structure ConseqConvTheory :> ConseqConvTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ConseqConvTheory ... "
    else ()
  
  open Type Term Thm
  local open boolTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ConseqConv"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/1/ConseqConvTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ASM_MARKER_DEF _ = ()
  val op ASM_MARKER_DEF = TDB.find "ASM_MARKER_DEF"
  fun op forall_eq_thm _ = ()
  val op forall_eq_thm = TDB.find "forall_eq_thm"
  fun op exists_eq_thm _ = ()
  val op exists_eq_thm = TDB.find "exists_eq_thm"
  fun op true_imp _ = () val op true_imp = TDB.find "true_imp"
  fun op false_imp _ = () val op false_imp = TDB.find "false_imp"
  fun op NOT_CLAUSES_X _ = ()
  val op NOT_CLAUSES_X = TDB.find "NOT_CLAUSES_X"
  fun op NOT_CLAUSES_T _ = ()
  val op NOT_CLAUSES_T = TDB.find "NOT_CLAUSES_T"
  fun op NOT_CLAUSES_F _ = ()
  val op NOT_CLAUSES_F = TDB.find "NOT_CLAUSES_F"
  fun op IMP_CONG_conj_strengthen _ = ()
  val op IMP_CONG_conj_strengthen = TDB.find "IMP_CONG_conj_strengthen"
  fun op IMP_CONG_conj_weaken _ = ()
  val op IMP_CONG_conj_weaken = TDB.find "IMP_CONG_conj_weaken"
  fun op AND_CLAUSES_TX _ = ()
  val op AND_CLAUSES_TX = TDB.find "AND_CLAUSES_TX"
  fun op AND_CLAUSES_XT _ = ()
  val op AND_CLAUSES_XT = TDB.find "AND_CLAUSES_XT"
  fun op AND_CLAUSES_FX _ = ()
  val op AND_CLAUSES_FX = TDB.find "AND_CLAUSES_FX"
  fun op AND_CLAUSES_XF _ = ()
  val op AND_CLAUSES_XF = TDB.find "AND_CLAUSES_XF"
  fun op AND_CLAUSES_XX _ = ()
  val op AND_CLAUSES_XX = TDB.find "AND_CLAUSES_XX"
  fun op IMP_CONG_disj_strengthen _ = ()
  val op IMP_CONG_disj_strengthen = TDB.find "IMP_CONG_disj_strengthen"
  fun op IMP_CONG_disj_weaken _ = ()
  val op IMP_CONG_disj_weaken = TDB.find "IMP_CONG_disj_weaken"
  fun op OR_CLAUSES_TX _ = ()
  val op OR_CLAUSES_TX = TDB.find "OR_CLAUSES_TX"
  fun op OR_CLAUSES_XT _ = ()
  val op OR_CLAUSES_XT = TDB.find "OR_CLAUSES_XT"
  fun op OR_CLAUSES_FX _ = ()
  val op OR_CLAUSES_FX = TDB.find "OR_CLAUSES_FX"
  fun op OR_CLAUSES_XF _ = ()
  val op OR_CLAUSES_XF = TDB.find "OR_CLAUSES_XF"
  fun op OR_CLAUSES_XX _ = ()
  val op OR_CLAUSES_XX = TDB.find "OR_CLAUSES_XX"
  fun op IMP_CONG_imp_strengthen _ = ()
  val op IMP_CONG_imp_strengthen = TDB.find "IMP_CONG_imp_strengthen"
  fun op IMP_CONG_imp_weaken _ = ()
  val op IMP_CONG_imp_weaken = TDB.find "IMP_CONG_imp_weaken"
  fun op IMP_CONG_simple_imp_strengthen _ = ()
  val op IMP_CONG_simple_imp_strengthen = TDB.find
    "IMP_CONG_simple_imp_strengthen"
  fun op IMP_CONG_simple_imp_weaken _ = ()
  val op IMP_CONG_simple_imp_weaken = TDB.find "IMP_CONG_simple_imp_weaken"
  fun op IMP_CLAUSES_TX _ = ()
  val op IMP_CLAUSES_TX = TDB.find "IMP_CLAUSES_TX"
  fun op IMP_CLAUSES_XT _ = ()
  val op IMP_CLAUSES_XT = TDB.find "IMP_CLAUSES_XT"
  fun op IMP_CLAUSES_FX _ = ()
  val op IMP_CLAUSES_FX = TDB.find "IMP_CLAUSES_FX"
  fun op IMP_CLAUSES_XX _ = ()
  val op IMP_CLAUSES_XX = TDB.find "IMP_CLAUSES_XX"
  fun op IMP_CLAUSES_XF _ = ()
  val op IMP_CLAUSES_XF = TDB.find "IMP_CLAUSES_XF"
  fun op IMP_CONG_cond_simple _ = ()
  val op IMP_CONG_cond_simple = TDB.find "IMP_CONG_cond_simple"
  fun op IMP_CONG_cond _ = ()
  val op IMP_CONG_cond = TDB.find "IMP_CONG_cond"
  fun op COND_CLAUSES_CT _ = ()
  val op COND_CLAUSES_CT = TDB.find "COND_CLAUSES_CT"
  fun op COND_CLAUSES_CF _ = ()
  val op COND_CLAUSES_CF = TDB.find "COND_CLAUSES_CF"
  fun op COND_CLAUSES_ID _ = ()
  val op COND_CLAUSES_ID = TDB.find "COND_CLAUSES_ID"
  fun op COND_CLAUSES_TT _ = ()
  val op COND_CLAUSES_TT = TDB.find "COND_CLAUSES_TT"
  fun op COND_CLAUSES_FT _ = ()
  val op COND_CLAUSES_FT = TDB.find "COND_CLAUSES_FT"
  fun op COND_CLAUSES_TF _ = ()
  val op COND_CLAUSES_TF = TDB.find "COND_CLAUSES_TF"
  fun op COND_CLAUSES_FF _ = ()
  val op COND_CLAUSES_FF = TDB.find "COND_CLAUSES_FF"
  fun op ASM_MARKER_THM _ = ()
  val op ASM_MARKER_THM = TDB.find "ASM_MARKER_THM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ConseqConv_grammars = merge_grammars ["bool"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ConseqConv"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ConseqConv_grammars = 
    Portable.## (addtyUDs,addtmUDs) ConseqConv_grammars
  val _ = Parse.grammarDB_insert("ConseqConv",ConseqConv_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ConseqConv"

end
