structure CoderTheory :> CoderTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading CoderTheory ... "
    else ()
  
  open Type Term Thm
  local open DecodeTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "Coder"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/Boolify/src/CoderTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op decode_def _ = () val op decode_def = TDB.find "decode_def"
  fun op wf_coder_def _ = () val op wf_coder_def = TDB.find "wf_coder_def"
  fun op domain_def _ = () val op domain_def = TDB.find "domain_def"
  fun op encoder_def _ = () val op encoder_def = TDB.find "encoder_def"
  fun op decoder_def _ = () val op decoder_def = TDB.find "decoder_def"
  fun op unit_coder_def _ = ()
  val op unit_coder_def = TDB.find "unit_coder_def"
  fun op bool_coder_def _ = ()
  val op bool_coder_def = TDB.find "bool_coder_def"
  fun op prod_coder_def _ = ()
  val op prod_coder_def = TDB.find "prod_coder_def"
  fun op sum_coder_def _ = ()
  val op sum_coder_def = TDB.find "sum_coder_def"
  fun op option_coder_def _ = ()
  val op option_coder_def = TDB.find "option_coder_def"
  fun op list_coder_def _ = ()
  val op list_coder_def = TDB.find "list_coder_def"
  fun op blist_coder_def _ = ()
  val op blist_coder_def = TDB.find "blist_coder_def"
  fun op num_coder_def _ = ()
  val op num_coder_def = TDB.find "num_coder_def"
  fun op bnum_coder_def _ = ()
  val op bnum_coder_def = TDB.find "bnum_coder_def"
  fun op tree_coder_def _ = ()
  val op tree_coder_def = TDB.find "tree_coder_def"
  fun op decode_encode _ = ()
  val op decode_encode = TDB.find "decode_encode"
  fun op wf_coder _ = () val op wf_coder = TDB.find "wf_coder"
  fun op wf_coder_closed _ = ()
  val op wf_coder_closed = TDB.find "wf_coder_closed"
  fun op wf_coder_op _ = () val op wf_coder_op = TDB.find "wf_coder_op"
  fun op wf_coder_unit _ = ()
  val op wf_coder_unit = TDB.find "wf_coder_unit"
  fun op wf_coder_bool _ = ()
  val op wf_coder_bool = TDB.find "wf_coder_bool"
  fun op wf_coder_prod _ = ()
  val op wf_coder_prod = TDB.find "wf_coder_prod"
  fun op wf_coder_sum _ = () val op wf_coder_sum = TDB.find "wf_coder_sum"
  fun op wf_coder_option _ = ()
  val op wf_coder_option = TDB.find "wf_coder_option"
  fun op wf_coder_list _ = ()
  val op wf_coder_list = TDB.find "wf_coder_list"
  fun op wf_coder_blist _ = ()
  val op wf_coder_blist = TDB.find "wf_coder_blist"
  fun op wf_coder_num _ = () val op wf_coder_num = TDB.find "wf_coder_num"
  fun op wf_coder_bnum _ = ()
  val op wf_coder_bnum = TDB.find "wf_coder_bnum"
  fun op wf_coder_tree _ = ()
  val op wf_coder_tree = TDB.find "wf_coder_tree"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val Coder_grammars = merge_grammars ["Decode"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="Coder"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val Coder_grammars = 
    Portable.## (addtyUDs,addtmUDs) Coder_grammars
  val _ = Parse.grammarDB_insert("Coder",Coder_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "Coder"

end
