structure DecodeTheory :> DecodeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading DecodeTheory ... "
    else ()
  
  open Type Term Thm
  local open EncodeTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "Decode"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/Boolify/src/DecodeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op wf_decoder_def _ = ()
  val op wf_decoder_def = TDB.find "wf_decoder_def"
  fun op enc2dec_def _ = () val op enc2dec_def = TDB.find "enc2dec_def"
  fun op dec2enc_def _ = () val op dec2enc_def = TDB.find "dec2enc_def"
  fun op decode_unit_def _ = ()
  val op decode_unit_def = TDB.find "decode_unit_def"
  fun op decode_bool_def _ = ()
  val op decode_bool_def = TDB.find "decode_bool_def"
  fun op decode_prod_def _ = ()
  val op decode_prod_def = TDB.find "decode_prod_def"
  fun op decode_sum_def _ = ()
  val op decode_sum_def = TDB.find "decode_sum_def"
  fun op decode_option_def _ = ()
  val op decode_option_def = TDB.find "decode_option_def"
  fun op decode_list_def _ = ()
  val op decode_list_def = TDB.find "decode_list_def"
  fun op decode_blist_def _ = ()
  val op decode_blist_def = TDB.find "decode_blist_def"
  fun op decode_num_def _ = ()
  val op decode_num_def = TDB.find "decode_num_def"
  fun op decode_bnum_def _ = ()
  val op decode_bnum_def = TDB.find "decode_bnum_def"
  fun op dec_bnum_def _ = () val op dec_bnum_def = TDB.find "dec_bnum_def"
  fun op decode_tree_def _ = ()
  val op decode_tree_def = TDB.find "decode_tree_def"
  fun op enc2dec_none _ = () val op enc2dec_none = TDB.find "enc2dec_none"
  fun op enc2dec_some _ = () val op enc2dec_some = TDB.find "enc2dec_some"
  fun op enc2dec_some_alt _ = ()
  val op enc2dec_some_alt = TDB.find "enc2dec_some_alt"
  fun op wf_enc2dec _ = () val op wf_enc2dec = TDB.find "wf_enc2dec"
  fun op dec2enc_some _ = () val op dec2enc_some = TDB.find "dec2enc_some"
  fun op decode_dec2enc _ = ()
  val op decode_dec2enc = TDB.find "decode_dec2enc"
  fun op decode_dec2enc_append _ = ()
  val op decode_dec2enc_append = TDB.find "decode_dec2enc_append"
  fun op wf_dec2enc _ = () val op wf_dec2enc = TDB.find "wf_dec2enc"
  fun op dec2enc_enc2dec _ = ()
  val op dec2enc_enc2dec = TDB.find "dec2enc_enc2dec"
  fun op enc2dec_dec2enc _ = ()
  val op enc2dec_dec2enc = TDB.find "enc2dec_dec2enc"
  fun op wf_decode_unit _ = ()
  val op wf_decode_unit = TDB.find "wf_decode_unit"
  fun op dec2enc_decode_unit _ = ()
  val op dec2enc_decode_unit = TDB.find "dec2enc_decode_unit"
  fun op decode_unit _ = () val op decode_unit = TDB.find "decode_unit"
  fun op wf_decode_bool _ = ()
  val op wf_decode_bool = TDB.find "wf_decode_bool"
  fun op dec2enc_decode_bool _ = ()
  val op dec2enc_decode_bool = TDB.find "dec2enc_decode_bool"
  fun op decode_bool _ = () val op decode_bool = TDB.find "decode_bool"
  fun op wf_decode_prod _ = ()
  val op wf_decode_prod = TDB.find "wf_decode_prod"
  fun op dec2enc_decode_prod _ = ()
  val op dec2enc_decode_prod = TDB.find "dec2enc_decode_prod"
  fun op encode_then_decode_prod _ = ()
  val op encode_then_decode_prod = TDB.find "encode_then_decode_prod"
  fun op decode_prod _ = () val op decode_prod = TDB.find "decode_prod"
  fun op wf_decode_sum _ = ()
  val op wf_decode_sum = TDB.find "wf_decode_sum"
  fun op dec2enc_decode_sum _ = ()
  val op dec2enc_decode_sum = TDB.find "dec2enc_decode_sum"
  fun op encode_then_decode_sum _ = ()
  val op encode_then_decode_sum = TDB.find "encode_then_decode_sum"
  fun op decode_sum _ = () val op decode_sum = TDB.find "decode_sum"
  fun op wf_decode_option _ = ()
  val op wf_decode_option = TDB.find "wf_decode_option"
  fun op dec2enc_decode_option _ = ()
  val op dec2enc_decode_option = TDB.find "dec2enc_decode_option"
  fun op encode_then_decode_option _ = ()
  val op encode_then_decode_option = TDB.find "encode_then_decode_option"
  fun op decode_option _ = ()
  val op decode_option = TDB.find "decode_option"
  fun op wf_decode_list _ = ()
  val op wf_decode_list = TDB.find "wf_decode_list"
  fun op dec2enc_decode_list _ = ()
  val op dec2enc_decode_list = TDB.find "dec2enc_decode_list"
  fun op encode_then_decode_list _ = ()
  val op encode_then_decode_list = TDB.find "encode_then_decode_list"
  fun op decode_list _ = () val op decode_list = TDB.find "decode_list"
  fun op wf_decode_blist _ = ()
  val op wf_decode_blist = TDB.find "wf_decode_blist"
  fun op dec2enc_decode_blist _ = ()
  val op dec2enc_decode_blist = TDB.find "dec2enc_decode_blist"
  fun op encode_then_decode_blist _ = ()
  val op encode_then_decode_blist = TDB.find "encode_then_decode_blist"
  fun op decode_blist _ = () val op decode_blist = TDB.find "decode_blist"
  fun op wf_decode_num _ = ()
  val op wf_decode_num = TDB.find "wf_decode_num"
  fun op dec2enc_decode_num _ = ()
  val op dec2enc_decode_num = TDB.find "dec2enc_decode_num"
  fun op decode_num_total _ = ()
  val op decode_num_total = TDB.find "decode_num_total"
  fun op decode_num _ = () val op decode_num = TDB.find "decode_num"
  fun op dec_bnum_compute _ = ()
  val op dec_bnum_compute = TDB.find "dec_bnum_compute"
  fun op dec_bnum_lt _ = () val op dec_bnum_lt = TDB.find "dec_bnum_lt"
  fun op dec_bnum_inj _ = () val op dec_bnum_inj = TDB.find "dec_bnum_inj"
  fun op wf_decode_bnum _ = ()
  val op wf_decode_bnum = TDB.find "wf_decode_bnum"
  fun op dec2enc_decode_bnum _ = ()
  val op dec2enc_decode_bnum = TDB.find "dec2enc_decode_bnum"
  fun op decode_bnum _ = () val op decode_bnum = TDB.find "decode_bnum"
  fun op wf_decode_tree _ = ()
  val op wf_decode_tree = TDB.find "wf_decode_tree"
  fun op decode_tree _ = () val op decode_tree = TDB.find "decode_tree"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val Decode_grammars = merge_grammars ["Encode"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="Decode"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val Decode_grammars = 
    Portable.## (addtyUDs,addtmUDs) Decode_grammars
  val _ = Parse.grammarDB_insert("Decode",Decode_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "Decode"

end
