structure EncodeTheory :> EncodeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading EncodeTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "Encode"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/Boolify/src/EncodeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op biprefix_def _ = () val op biprefix_def = TDB.find "biprefix_def"
  fun op wf_pred_def _ = () val op wf_pred_def = TDB.find "wf_pred_def"
  fun op wf_encoder_def _ = ()
  val op wf_encoder_def = TDB.find "wf_encoder_def"
  fun op encode_unit_def _ = ()
  val op encode_unit_def = TDB.find "encode_unit_def"
  fun op encode_bool_def _ = ()
  val op encode_bool_def = TDB.find "encode_bool_def"
  fun op encode_prod_def _ = ()
  val op encode_prod_def = TDB.find "encode_prod_def"
  fun op lift_prod_def _ = ()
  val op lift_prod_def = TDB.find "lift_prod_def"
  fun op encode_sum_def _ = ()
  val op encode_sum_def = TDB.find "encode_sum_def"
  fun op lift_sum_def _ = () val op lift_sum_def = TDB.find "lift_sum_def"
  fun op encode_option_def _ = ()
  val op encode_option_def = TDB.find "encode_option_def"
  fun op lift_option_def _ = ()
  val op lift_option_def = TDB.find "lift_option_def"
  fun op encode_list_def _ = ()
  val op encode_list_def = TDB.find "encode_list_def"
  fun op encode_blist_def _ = ()
  val op encode_blist_def = TDB.find "encode_blist_def"
  fun op lift_blist_def _ = ()
  val op lift_blist_def = TDB.find "lift_blist_def"
  fun op encode_num_primitive_def _ = ()
  val op encode_num_primitive_def = TDB.find "encode_num_primitive_def"
  fun op encode_bnum_def _ = ()
  val op encode_bnum_def = TDB.find "encode_bnum_def"
  fun op collision_free_def _ = ()
  val op collision_free_def = TDB.find "collision_free_def"
  fun op wf_pred_bnum_def _ = ()
  val op wf_pred_bnum_def = TDB.find "wf_pred_bnum_def"
  fun op tree_TY_DEF _ = () val op tree_TY_DEF = TDB.find "tree_TY_DEF"
  fun op tree_case_def _ = ()
  val op tree_case_def = TDB.find "tree_case_def"
  fun op tree_size_def _ = ()
  val op tree_size_def = TDB.find "tree_size_def"
  fun op biprefix_refl _ = ()
  val op biprefix_refl = TDB.find "biprefix_refl"
  fun op biprefix_sym _ = () val op biprefix_sym = TDB.find "biprefix_sym"
  fun op biprefix_append _ = ()
  val op biprefix_append = TDB.find "biprefix_append"
  fun op biprefix_cons _ = ()
  val op biprefix_cons = TDB.find "biprefix_cons"
  fun op biprefix_appends _ = ()
  val op biprefix_appends = TDB.find "biprefix_appends"
  fun op wf_encoder_alt _ = ()
  val op wf_encoder_alt = TDB.find "wf_encoder_alt"
  fun op wf_encoder_eq _ = ()
  val op wf_encoder_eq = TDB.find "wf_encoder_eq"
  fun op wf_encoder_total _ = ()
  val op wf_encoder_total = TDB.find "wf_encoder_total"
  fun op wf_encode_unit _ = ()
  val op wf_encode_unit = TDB.find "wf_encode_unit"
  fun op wf_encode_bool _ = ()
  val op wf_encode_bool = TDB.find "wf_encode_bool"
  fun op encode_prod_alt _ = ()
  val op encode_prod_alt = TDB.find "encode_prod_alt"
  fun op wf_encode_prod _ = ()
  val op wf_encode_prod = TDB.find "wf_encode_prod"
  fun op wf_encode_sum _ = ()
  val op wf_encode_sum = TDB.find "wf_encode_sum"
  fun op wf_encode_option _ = ()
  val op wf_encode_option = TDB.find "wf_encode_option"
  fun op wf_encode_list _ = ()
  val op wf_encode_list = TDB.find "wf_encode_list"
  fun op encode_list_cong _ = ()
  val op encode_list_cong = TDB.find "encode_list_cong"
  fun op encode_blist_compute _ = ()
  val op encode_blist_compute = TDB.find "encode_blist_compute"
  fun op lift_blist_suc _ = ()
  val op lift_blist_suc = TDB.find "lift_blist_suc"
  fun op wf_encode_blist _ = ()
  val op wf_encode_blist = TDB.find "wf_encode_blist"
  fun op encode_num_def _ = ()
  val op encode_num_def = TDB.find "encode_num_def"
  fun op encode_num_ind _ = ()
  val op encode_num_ind = TDB.find "encode_num_ind"
  fun op wf_encode_num _ = ()
  val op wf_encode_num = TDB.find "wf_encode_num"
  fun op encode_bnum_compute _ = ()
  val op encode_bnum_compute = TDB.find "encode_bnum_compute"
  fun op wf_pred_bnum_total _ = ()
  val op wf_pred_bnum_total = TDB.find "wf_pred_bnum_total"
  fun op wf_pred_bnum _ = () val op wf_pred_bnum = TDB.find "wf_pred_bnum"
  fun op encode_bnum_length _ = ()
  val op encode_bnum_length = TDB.find "encode_bnum_length"
  fun op encode_bnum_inj _ = ()
  val op encode_bnum_inj = TDB.find "encode_bnum_inj"
  fun op wf_encode_bnum_collision_free _ = ()
  val op wf_encode_bnum_collision_free = TDB.find
    "wf_encode_bnum_collision_free"
  fun op wf_encode_bnum _ = ()
  val op wf_encode_bnum = TDB.find "wf_encode_bnum"
  fun op datatype_tree _ = ()
  val op datatype_tree = TDB.find "datatype_tree"
  fun op tree_11 _ = () val op tree_11 = TDB.find "tree_11"
  fun op tree_nchotomy _ = ()
  val op tree_nchotomy = TDB.find "tree_nchotomy"
  fun op tree_Axiom _ = () val op tree_Axiom = TDB.find "tree_Axiom"
  fun op tree_induction _ = ()
  val op tree_induction = TDB.find "tree_induction"
  fun op tree_case_cong _ = ()
  val op tree_case_cong = TDB.find "tree_case_cong"
  fun op tree_case_eq _ = () val op tree_case_eq = TDB.find "tree_case_eq"
  fun op tree_ind _ = () val op tree_ind = TDB.find "tree_ind"
  fun op encode_tree_def _ = ()
  val op encode_tree_def = TDB.find "encode_tree_def"
  fun op lift_tree_def _ = ()
  val op lift_tree_def = TDB.find "lift_tree_def"
  fun op wf_encode_tree _ = ()
  val op wf_encode_tree = TDB.find "wf_encode_tree"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val Encode_grammars = merge_grammars ["indexedLists", "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="Encode"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val Encode_grammars = 
    Portable.## (addtyUDs,addtmUDs) Encode_grammars
  val _ = Parse.grammarDB_insert("Encode",Encode_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ = DefnBase.write_congs (encode_list_cong::DefnBase.read_congs());
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "Encode"

end
