structure EncodeVarTheory :> EncodeVarTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading EncodeVarTheory ... "
    else ()
  
  open Type Term Thm
  local open CoderTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "EncodeVar"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/Boolify/src/EncodeVarTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op fixed_width_def _ = ()
  val op fixed_width_def = TDB.find "fixed_width_def"
  fun op of_length_def _ = ()
  val op of_length_def = TDB.find "of_length_def"
  fun op fixed_width_univ _ = ()
  val op fixed_width_univ = TDB.find "fixed_width_univ"
  fun op of_length_univ_suc _ = ()
  val op of_length_univ_suc = TDB.find "of_length_univ_suc"
  fun op of_length_univ_zero _ = ()
  val op of_length_univ_zero = TDB.find "of_length_univ_zero"
  fun op fixed_width_exists _ = ()
  val op fixed_width_exists = TDB.find "fixed_width_exists"
  fun op of_length_exists_suc _ = ()
  val op of_length_exists_suc = TDB.find "of_length_exists_suc"
  fun op of_length_exists_zero _ = ()
  val op of_length_exists_zero = TDB.find "of_length_exists_zero"
  fun op fixed_width_unit _ = ()
  val op fixed_width_unit = TDB.find "fixed_width_unit"
  fun op fixed_width_bool _ = ()
  val op fixed_width_bool = TDB.find "fixed_width_bool"
  fun op fixed_width_prod _ = ()
  val op fixed_width_prod = TDB.find "fixed_width_prod"
  fun op fixed_width_sum _ = ()
  val op fixed_width_sum = TDB.find "fixed_width_sum"
  fun op fixed_width_bnum _ = ()
  val op fixed_width_bnum = TDB.find "fixed_width_bnum"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val EncodeVar_grammars = merge_grammars ["Coder"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="EncodeVar"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val EncodeVar_grammars = 
    Portable.## (addtyUDs,addtmUDs) EncodeVar_grammars
  val _ = Parse.grammarDB_insert("EncodeVar",EncodeVar_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "EncodeVar"

end
