structure satTheory :> satTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading satTheory ... "
    else ()
  
  open Type Term Thm
  local open boolTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "sat"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/HolSat/satTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op AND_IMP _ = () val op AND_IMP = TDB.find "AND_IMP"
  fun op NOT_NOT _ = () val op NOT_NOT = TDB.find "NOT_NOT"
  fun op AND_INV _ = () val op AND_INV = TDB.find "AND_INV"
  fun op AND_INV_IMP _ = () val op AND_INV_IMP = TDB.find "AND_INV_IMP"
  fun op OR_DUAL _ = () val op OR_DUAL = TDB.find "OR_DUAL"
  fun op OR_DUAL2 _ = () val op OR_DUAL2 = TDB.find "OR_DUAL2"
  fun op OR_DUAL3 _ = () val op OR_DUAL3 = TDB.find "OR_DUAL3"
  fun op AND_INV2 _ = () val op AND_INV2 = TDB.find "AND_INV2"
  fun op NOT_ELIM2 _ = () val op NOT_ELIM2 = TDB.find "NOT_ELIM2"
  fun op EQT_Imp1 _ = () val op EQT_Imp1 = TDB.find "EQT_Imp1"
  fun op EQF_Imp1 _ = () val op EQF_Imp1 = TDB.find "EQF_Imp1"
  fun op dc_eq _ = () val op dc_eq = TDB.find "dc_eq"
  fun op dc_conj _ = () val op dc_conj = TDB.find "dc_conj"
  fun op dc_disj _ = () val op dc_disj = TDB.find "dc_disj"
  fun op dc_imp _ = () val op dc_imp = TDB.find "dc_imp"
  fun op dc_neg _ = () val op dc_neg = TDB.find "dc_neg"
  fun op dc_cond _ = () val op dc_cond = TDB.find "dc_cond"
  fun op pth_ni1 _ = () val op pth_ni1 = TDB.find "pth_ni1"
  fun op pth_ni2 _ = () val op pth_ni2 = TDB.find "pth_ni2"
  fun op pth_no1 _ = () val op pth_no1 = TDB.find "pth_no1"
  fun op pth_no2 _ = () val op pth_no2 = TDB.find "pth_no2"
  fun op pth_an1 _ = () val op pth_an1 = TDB.find "pth_an1"
  fun op pth_an2 _ = () val op pth_an2 = TDB.find "pth_an2"
  fun op pth_nn _ = () val op pth_nn = TDB.find "pth_nn"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val sat_grammars = merge_grammars ["bool"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="sat"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val sat_grammars = 
    Portable.## (addtyUDs,addtmUDs) sat_grammars
  val _ = Parse.grammarDB_insert("sat",sat_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "sat"

end
