structure defCNFTheory :> defCNFTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading defCNFTheory ... "
    else ()
  
  open Type Term Thm
  local open rich_listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "defCNF"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/HolSat/vector_def_CNF/defCNFTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op DEF_def _ = () val op DEF_def = TDB.find "DEF_def"
  fun op OKDEF_def _ = () val op OKDEF_def = TDB.find "OKDEF_def"
  fun op UNIQUE_ind _ = () val op UNIQUE_ind = TDB.find "UNIQUE_ind"
  fun op UNIQUE_def _ = () val op UNIQUE_def = TDB.find "UNIQUE_def"
  fun op OK_ind _ = () val op OK_ind = TDB.find "OK_ind"
  fun op OK_def _ = () val op OK_def = TDB.find "OK_def"
  fun op DEF_SNOC _ = () val op DEF_SNOC = TDB.find "DEF_SNOC"
  fun op OKDEF_SNOC _ = () val op OKDEF_SNOC = TDB.find "OKDEF_SNOC"
  fun op CONSISTENCY _ = () val op CONSISTENCY = TDB.find "CONSISTENCY"
  fun op BIGSTEP _ = () val op BIGSTEP = TDB.find "BIGSTEP"
  fun op FINAL_DEF _ = () val op FINAL_DEF = TDB.find "FINAL_DEF"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val defCNF_grammars = merge_grammars ["rich_list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="defCNF"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val defCNF_grammars = 
    Portable.## (addtyUDs,addtmUDs) defCNF_grammars
  val _ = Parse.grammarDB_insert("defCNF",defCNF_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "defCNF"

end
