structure HolSmtTheory :> HolSmtTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading HolSmtTheory ... "
    else ()
  
  open Type Term Thm
  local open OmegaTheory bitstringTheory blastTheory int_arithTheory
  transcTheory
  in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "HolSmt"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/HolSmt/HolSmtTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op xor_def _ = () val op xor_def = TDB.find "xor_def"
  fun op array_ext_def _ = ()
  val op array_ext_def = TDB.find "array_ext_def"
  fun op ALL_DISTINCT_NIL _ = ()
  val op ALL_DISTINCT_NIL = TDB.find "ALL_DISTINCT_NIL"
  fun op ALL_DISTINCT_CONS _ = ()
  val op ALL_DISTINCT_CONS = TDB.find "ALL_DISTINCT_CONS"
  fun op NOT_MEM_NIL _ = () val op NOT_MEM_NIL = TDB.find "NOT_MEM_NIL"
  fun op NOT_MEM_CONS _ = () val op NOT_MEM_CONS = TDB.find "NOT_MEM_CONS"
  fun op AND_T _ = () val op AND_T = TDB.find "AND_T"
  fun op T_AND _ = () val op T_AND = TDB.find "T_AND"
  fun op F_OR _ = () val op F_OR = TDB.find "F_OR"
  fun op CONJ_CONG _ = () val op CONJ_CONG = TDB.find "CONJ_CONG"
  fun op NOT_NOT_ELIM _ = () val op NOT_NOT_ELIM = TDB.find "NOT_NOT_ELIM"
  fun op NOT_FALSE _ = () val op NOT_FALSE = TDB.find "NOT_FALSE"
  fun op NNF_CONJ _ = () val op NNF_CONJ = TDB.find "NNF_CONJ"
  fun op NNF_DISJ _ = () val op NNF_DISJ = TDB.find "NNF_DISJ"
  fun op NNF_NOT_NOT _ = () val op NNF_NOT_NOT = TDB.find "NNF_NOT_NOT"
  fun op NEG_IFF_1_1 _ = () val op NEG_IFF_1_1 = TDB.find "NEG_IFF_1_1"
  fun op NEG_IFF_1_2 _ = () val op NEG_IFF_1_2 = TDB.find "NEG_IFF_1_2"
  fun op NEG_IFF_2_1 _ = () val op NEG_IFF_2_1 = TDB.find "NEG_IFF_2_1"
  fun op NEG_IFF_2_2 _ = () val op NEG_IFF_2_2 = TDB.find "NEG_IFF_2_2"
  fun op DISJ_ELIM_1 _ = () val op DISJ_ELIM_1 = TDB.find "DISJ_ELIM_1"
  fun op DISJ_ELIM_2 _ = () val op DISJ_ELIM_2 = TDB.find "DISJ_ELIM_2"
  fun op IMP_DISJ_1 _ = () val op IMP_DISJ_1 = TDB.find "IMP_DISJ_1"
  fun op IMP_DISJ_2 _ = () val op IMP_DISJ_2 = TDB.find "IMP_DISJ_2"
  fun op IMP_FALSE _ = () val op IMP_FALSE = TDB.find "IMP_FALSE"
  fun op AND_IMP_INTRO_SYM _ = ()
  val op AND_IMP_INTRO_SYM = TDB.find "AND_IMP_INTRO_SYM"
  fun op VALID_IFF_TRUE _ = ()
  val op VALID_IFF_TRUE = TDB.find "VALID_IFF_TRUE"
  fun op d001 _ = () val op d001 = TDB.find "d001"
  fun op d002 _ = () val op d002 = TDB.find "d002"
  fun op d003 _ = () val op d003 = TDB.find "d003"
  fun op d004 _ = () val op d004 = TDB.find "d004"
  fun op d005 _ = () val op d005 = TDB.find "d005"
  fun op d006 _ = () val op d006 = TDB.find "d006"
  fun op d007 _ = () val op d007 = TDB.find "d007"
  fun op d008 _ = () val op d008 = TDB.find "d008"
  fun op d009 _ = () val op d009 = TDB.find "d009"
  fun op d010 _ = () val op d010 = TDB.find "d010"
  fun op d011 _ = () val op d011 = TDB.find "d011"
  fun op d012 _ = () val op d012 = TDB.find "d012"
  fun op d013 _ = () val op d013 = TDB.find "d013"
  fun op d014 _ = () val op d014 = TDB.find "d014"
  fun op d015 _ = () val op d015 = TDB.find "d015"
  fun op d016 _ = () val op d016 = TDB.find "d016"
  fun op d017 _ = () val op d017 = TDB.find "d017"
  fun op d018 _ = () val op d018 = TDB.find "d018"
  fun op d019 _ = () val op d019 = TDB.find "d019"
  fun op d020 _ = () val op d020 = TDB.find "d020"
  fun op d021 _ = () val op d021 = TDB.find "d021"
  fun op d022 _ = () val op d022 = TDB.find "d022"
  fun op d023 _ = () val op d023 = TDB.find "d023"
  fun op d024 _ = () val op d024 = TDB.find "d024"
  fun op d025 _ = () val op d025 = TDB.find "d025"
  fun op d026 _ = () val op d026 = TDB.find "d026"
  fun op d027 _ = () val op d027 = TDB.find "d027"
  fun op d028 _ = () val op d028 = TDB.find "d028"
  fun op r001 _ = () val op r001 = TDB.find "r001"
  fun op r002 _ = () val op r002 = TDB.find "r002"
  fun op r003 _ = () val op r003 = TDB.find "r003"
  fun op r004 _ = () val op r004 = TDB.find "r004"
  fun op r005 _ = () val op r005 = TDB.find "r005"
  fun op r006 _ = () val op r006 = TDB.find "r006"
  fun op r007 _ = () val op r007 = TDB.find "r007"
  fun op r008 _ = () val op r008 = TDB.find "r008"
  fun op r009 _ = () val op r009 = TDB.find "r009"
  fun op r010 _ = () val op r010 = TDB.find "r010"
  fun op r011 _ = () val op r011 = TDB.find "r011"
  fun op r012 _ = () val op r012 = TDB.find "r012"
  fun op r013 _ = () val op r013 = TDB.find "r013"
  fun op r014 _ = () val op r014 = TDB.find "r014"
  fun op r015 _ = () val op r015 = TDB.find "r015"
  fun op r016 _ = () val op r016 = TDB.find "r016"
  fun op r017 _ = () val op r017 = TDB.find "r017"
  fun op r018 _ = () val op r018 = TDB.find "r018"
  fun op r019 _ = () val op r019 = TDB.find "r019"
  fun op r020 _ = () val op r020 = TDB.find "r020"
  fun op r021 _ = () val op r021 = TDB.find "r021"
  fun op r022 _ = () val op r022 = TDB.find "r022"
  fun op r023 _ = () val op r023 = TDB.find "r023"
  fun op r024 _ = () val op r024 = TDB.find "r024"
  fun op r025 _ = () val op r025 = TDB.find "r025"
  fun op r026 _ = () val op r026 = TDB.find "r026"
  fun op r027 _ = () val op r027 = TDB.find "r027"
  fun op r028 _ = () val op r028 = TDB.find "r028"
  fun op r029 _ = () val op r029 = TDB.find "r029"
  fun op r030 _ = () val op r030 = TDB.find "r030"
  fun op r031 _ = () val op r031 = TDB.find "r031"
  fun op r032 _ = () val op r032 = TDB.find "r032"
  fun op r033 _ = () val op r033 = TDB.find "r033"
  fun op r034 _ = () val op r034 = TDB.find "r034"
  fun op r035 _ = () val op r035 = TDB.find "r035"
  fun op r036 _ = () val op r036 = TDB.find "r036"
  fun op r037 _ = () val op r037 = TDB.find "r037"
  fun op r038 _ = () val op r038 = TDB.find "r038"
  fun op r039 _ = () val op r039 = TDB.find "r039"
  fun op r040 _ = () val op r040 = TDB.find "r040"
  fun op r041 _ = () val op r041 = TDB.find "r041"
  fun op r042 _ = () val op r042 = TDB.find "r042"
  fun op r043 _ = () val op r043 = TDB.find "r043"
  fun op r044 _ = () val op r044 = TDB.find "r044"
  fun op r045 _ = () val op r045 = TDB.find "r045"
  fun op r046 _ = () val op r046 = TDB.find "r046"
  fun op r047 _ = () val op r047 = TDB.find "r047"
  fun op r048 _ = () val op r048 = TDB.find "r048"
  fun op r049 _ = () val op r049 = TDB.find "r049"
  fun op r050 _ = () val op r050 = TDB.find "r050"
  fun op r051 _ = () val op r051 = TDB.find "r051"
  fun op r052 _ = () val op r052 = TDB.find "r052"
  fun op r053 _ = () val op r053 = TDB.find "r053"
  fun op r054 _ = () val op r054 = TDB.find "r054"
  fun op r055 _ = () val op r055 = TDB.find "r055"
  fun op r056 _ = () val op r056 = TDB.find "r056"
  fun op r057 _ = () val op r057 = TDB.find "r057"
  fun op r058 _ = () val op r058 = TDB.find "r058"
  fun op r059 _ = () val op r059 = TDB.find "r059"
  fun op r060 _ = () val op r060 = TDB.find "r060"
  fun op r061 _ = () val op r061 = TDB.find "r061"
  fun op r062 _ = () val op r062 = TDB.find "r062"
  fun op r063 _ = () val op r063 = TDB.find "r063"
  fun op r064 _ = () val op r064 = TDB.find "r064"
  fun op r065 _ = () val op r065 = TDB.find "r065"
  fun op r066 _ = () val op r066 = TDB.find "r066"
  fun op r067 _ = () val op r067 = TDB.find "r067"
  fun op r068 _ = () val op r068 = TDB.find "r068"
  fun op r069 _ = () val op r069 = TDB.find "r069"
  fun op r070 _ = () val op r070 = TDB.find "r070"
  fun op r071 _ = () val op r071 = TDB.find "r071"
  fun op r072 _ = () val op r072 = TDB.find "r072"
  fun op r073 _ = () val op r073 = TDB.find "r073"
  fun op r074 _ = () val op r074 = TDB.find "r074"
  fun op r075 _ = () val op r075 = TDB.find "r075"
  fun op r076 _ = () val op r076 = TDB.find "r076"
  fun op r077 _ = () val op r077 = TDB.find "r077"
  fun op r078 _ = () val op r078 = TDB.find "r078"
  fun op r079 _ = () val op r079 = TDB.find "r079"
  fun op r080 _ = () val op r080 = TDB.find "r080"
  fun op r081 _ = () val op r081 = TDB.find "r081"
  fun op r082 _ = () val op r082 = TDB.find "r082"
  fun op r083 _ = () val op r083 = TDB.find "r083"
  fun op r084 _ = () val op r084 = TDB.find "r084"
  fun op r085 _ = () val op r085 = TDB.find "r085"
  fun op r086 _ = () val op r086 = TDB.find "r086"
  fun op r087 _ = () val op r087 = TDB.find "r087"
  fun op r088 _ = () val op r088 = TDB.find "r088"
  fun op r089 _ = () val op r089 = TDB.find "r089"
  fun op r090 _ = () val op r090 = TDB.find "r090"
  fun op r091 _ = () val op r091 = TDB.find "r091"
  fun op r092 _ = () val op r092 = TDB.find "r092"
  fun op r093 _ = () val op r093 = TDB.find "r093"
  fun op r094 _ = () val op r094 = TDB.find "r094"
  fun op r095 _ = () val op r095 = TDB.find "r095"
  fun op r096 _ = () val op r096 = TDB.find "r096"
  fun op r097 _ = () val op r097 = TDB.find "r097"
  fun op r098 _ = () val op r098 = TDB.find "r098"
  fun op r099 _ = () val op r099 = TDB.find "r099"
  fun op r100 _ = () val op r100 = TDB.find "r100"
  fun op r101 _ = () val op r101 = TDB.find "r101"
  fun op r102 _ = () val op r102 = TDB.find "r102"
  fun op r103 _ = () val op r103 = TDB.find "r103"
  fun op r104 _ = () val op r104 = TDB.find "r104"
  fun op r105 _ = () val op r105 = TDB.find "r105"
  fun op r106 _ = () val op r106 = TDB.find "r106"
  fun op r107 _ = () val op r107 = TDB.find "r107"
  fun op r108 _ = () val op r108 = TDB.find "r108"
  fun op r109 _ = () val op r109 = TDB.find "r109"
  fun op r110 _ = () val op r110 = TDB.find "r110"
  fun op r111 _ = () val op r111 = TDB.find "r111"
  fun op r112 _ = () val op r112 = TDB.find "r112"
  fun op r113 _ = () val op r113 = TDB.find "r113"
  fun op r114 _ = () val op r114 = TDB.find "r114"
  fun op r115 _ = () val op r115 = TDB.find "r115"
  fun op r116 _ = () val op r116 = TDB.find "r116"
  fun op r117 _ = () val op r117 = TDB.find "r117"
  fun op r118 _ = () val op r118 = TDB.find "r118"
  fun op r119 _ = () val op r119 = TDB.find "r119"
  fun op r120 _ = () val op r120 = TDB.find "r120"
  fun op r121 _ = () val op r121 = TDB.find "r121"
  fun op r122 _ = () val op r122 = TDB.find "r122"
  fun op r123 _ = () val op r123 = TDB.find "r123"
  fun op r124 _ = () val op r124 = TDB.find "r124"
  fun op r125 _ = () val op r125 = TDB.find "r125"
  fun op r126 _ = () val op r126 = TDB.find "r126"
  fun op r127 _ = () val op r127 = TDB.find "r127"
  fun op r128 _ = () val op r128 = TDB.find "r128"
  fun op r129 _ = () val op r129 = TDB.find "r129"
  fun op r130 _ = () val op r130 = TDB.find "r130"
  fun op r131 _ = () val op r131 = TDB.find "r131"
  fun op r132 _ = () val op r132 = TDB.find "r132"
  fun op r133 _ = () val op r133 = TDB.find "r133"
  fun op r134 _ = () val op r134 = TDB.find "r134"
  fun op r135 _ = () val op r135 = TDB.find "r135"
  fun op r136 _ = () val op r136 = TDB.find "r136"
  fun op r137 _ = () val op r137 = TDB.find "r137"
  fun op r138 _ = () val op r138 = TDB.find "r138"
  fun op r139 _ = () val op r139 = TDB.find "r139"
  fun op r140 _ = () val op r140 = TDB.find "r140"
  fun op r141 _ = () val op r141 = TDB.find "r141"
  fun op r142 _ = () val op r142 = TDB.find "r142"
  fun op r143 _ = () val op r143 = TDB.find "r143"
  fun op r144 _ = () val op r144 = TDB.find "r144"
  fun op r145 _ = () val op r145 = TDB.find "r145"
  fun op r146 _ = () val op r146 = TDB.find "r146"
  fun op r147 _ = () val op r147 = TDB.find "r147"
  fun op r148 _ = () val op r148 = TDB.find "r148"
  fun op r149 _ = () val op r149 = TDB.find "r149"
  fun op r150 _ = () val op r150 = TDB.find "r150"
  fun op r151 _ = () val op r151 = TDB.find "r151"
  fun op r152 _ = () val op r152 = TDB.find "r152"
  fun op r153 _ = () val op r153 = TDB.find "r153"
  fun op r154 _ = () val op r154 = TDB.find "r154"
  fun op r155 _ = () val op r155 = TDB.find "r155"
  fun op r156 _ = () val op r156 = TDB.find "r156"
  fun op r157 _ = () val op r157 = TDB.find "r157"
  fun op r158 _ = () val op r158 = TDB.find "r158"
  fun op r159 _ = () val op r159 = TDB.find "r159"
  fun op r160 _ = () val op r160 = TDB.find "r160"
  fun op r161 _ = () val op r161 = TDB.find "r161"
  fun op r162 _ = () val op r162 = TDB.find "r162"
  fun op r163 _ = () val op r163 = TDB.find "r163"
  fun op r164 _ = () val op r164 = TDB.find "r164"
  fun op r165 _ = () val op r165 = TDB.find "r165"
  fun op r166 _ = () val op r166 = TDB.find "r166"
  fun op r167 _ = () val op r167 = TDB.find "r167"
  fun op r168 _ = () val op r168 = TDB.find "r168"
  fun op r169 _ = () val op r169 = TDB.find "r169"
  fun op r170 _ = () val op r170 = TDB.find "r170"
  fun op r171 _ = () val op r171 = TDB.find "r171"
  fun op r172 _ = () val op r172 = TDB.find "r172"
  fun op r173 _ = () val op r173 = TDB.find "r173"
  fun op r174 _ = () val op r174 = TDB.find "r174"
  fun op r175 _ = () val op r175 = TDB.find "r175"
  fun op r176 _ = () val op r176 = TDB.find "r176"
  fun op r177 _ = () val op r177 = TDB.find "r177"
  fun op r178 _ = () val op r178 = TDB.find "r178"
  fun op r179 _ = () val op r179 = TDB.find "r179"
  fun op r180 _ = () val op r180 = TDB.find "r180"
  fun op r181 _ = () val op r181 = TDB.find "r181"
  fun op r182 _ = () val op r182 = TDB.find "r182"
  fun op r183 _ = () val op r183 = TDB.find "r183"
  fun op r184 _ = () val op r184 = TDB.find "r184"
  fun op r185 _ = () val op r185 = TDB.find "r185"
  fun op r186 _ = () val op r186 = TDB.find "r186"
  fun op r187 _ = () val op r187 = TDB.find "r187"
  fun op r188 _ = () val op r188 = TDB.find "r188"
  fun op r189 _ = () val op r189 = TDB.find "r189"
  fun op r190 _ = () val op r190 = TDB.find "r190"
  fun op r191 _ = () val op r191 = TDB.find "r191"
  fun op r192 _ = () val op r192 = TDB.find "r192"
  fun op r193 _ = () val op r193 = TDB.find "r193"
  fun op r194 _ = () val op r194 = TDB.find "r194"
  fun op r195 _ = () val op r195 = TDB.find "r195"
  fun op r196 _ = () val op r196 = TDB.find "r196"
  fun op r197 _ = () val op r197 = TDB.find "r197"
  fun op r198 _ = () val op r198 = TDB.find "r198"
  fun op r199 _ = () val op r199 = TDB.find "r199"
  fun op r200 _ = () val op r200 = TDB.find "r200"
  fun op r201 _ = () val op r201 = TDB.find "r201"
  fun op r202 _ = () val op r202 = TDB.find "r202"
  fun op r203 _ = () val op r203 = TDB.find "r203"
  fun op r204 _ = () val op r204 = TDB.find "r204"
  fun op r205 _ = () val op r205 = TDB.find "r205"
  fun op r206 _ = () val op r206 = TDB.find "r206"
  fun op r207 _ = () val op r207 = TDB.find "r207"
  fun op r208 _ = () val op r208 = TDB.find "r208"
  fun op r209 _ = () val op r209 = TDB.find "r209"
  fun op r210 _ = () val op r210 = TDB.find "r210"
  fun op r211 _ = () val op r211 = TDB.find "r211"
  fun op r212 _ = () val op r212 = TDB.find "r212"
  fun op r213 _ = () val op r213 = TDB.find "r213"
  fun op r214 _ = () val op r214 = TDB.find "r214"
  fun op r215 _ = () val op r215 = TDB.find "r215"
  fun op r216 _ = () val op r216 = TDB.find "r216"
  fun op r217 _ = () val op r217 = TDB.find "r217"
  fun op r218 _ = () val op r218 = TDB.find "r218"
  fun op r219 _ = () val op r219 = TDB.find "r219"
  fun op r220 _ = () val op r220 = TDB.find "r220"
  fun op r221 _ = () val op r221 = TDB.find "r221"
  fun op r222 _ = () val op r222 = TDB.find "r222"
  fun op r223 _ = () val op r223 = TDB.find "r223"
  fun op r224 _ = () val op r224 = TDB.find "r224"
  fun op r225 _ = () val op r225 = TDB.find "r225"
  fun op r226 _ = () val op r226 = TDB.find "r226"
  fun op r227 _ = () val op r227 = TDB.find "r227"
  fun op r228 _ = () val op r228 = TDB.find "r228"
  fun op r229 _ = () val op r229 = TDB.find "r229"
  fun op r230 _ = () val op r230 = TDB.find "r230"
  fun op r231 _ = () val op r231 = TDB.find "r231"
  fun op r232 _ = () val op r232 = TDB.find "r232"
  fun op r233 _ = () val op r233 = TDB.find "r233"
  fun op r234 _ = () val op r234 = TDB.find "r234"
  fun op r235 _ = () val op r235 = TDB.find "r235"
  fun op r236 _ = () val op r236 = TDB.find "r236"
  fun op r237 _ = () val op r237 = TDB.find "r237"
  fun op r238 _ = () val op r238 = TDB.find "r238"
  fun op r239 _ = () val op r239 = TDB.find "r239"
  fun op r240 _ = () val op r240 = TDB.find "r240"
  fun op r241 _ = () val op r241 = TDB.find "r241"
  fun op r242 _ = () val op r242 = TDB.find "r242"
  fun op r243 _ = () val op r243 = TDB.find "r243"
  fun op r244 _ = () val op r244 = TDB.find "r244"
  fun op r245 _ = () val op r245 = TDB.find "r245"
  fun op r246 _ = () val op r246 = TDB.find "r246"
  fun op r247 _ = () val op r247 = TDB.find "r247"
  fun op r248 _ = () val op r248 = TDB.find "r248"
  fun op r249 _ = () val op r249 = TDB.find "r249"
  fun op r250 _ = () val op r250 = TDB.find "r250"
  fun op r251 _ = () val op r251 = TDB.find "r251"
  fun op r252 _ = () val op r252 = TDB.find "r252"
  fun op r253 _ = () val op r253 = TDB.find "r253"
  fun op r254 _ = () val op r254 = TDB.find "r254"
  fun op r255 _ = () val op r255 = TDB.find "r255"
  fun op t001 _ = () val op t001 = TDB.find "t001"
  fun op t002 _ = () val op t002 = TDB.find "t002"
  fun op t003 _ = () val op t003 = TDB.find "t003"
  fun op t004 _ = () val op t004 = TDB.find "t004"
  fun op t005 _ = () val op t005 = TDB.find "t005"
  fun op t006 _ = () val op t006 = TDB.find "t006"
  fun op t007 _ = () val op t007 = TDB.find "t007"
  fun op t008 _ = () val op t008 = TDB.find "t008"
  fun op t009 _ = () val op t009 = TDB.find "t009"
  fun op t010 _ = () val op t010 = TDB.find "t010"
  fun op t011 _ = () val op t011 = TDB.find "t011"
  fun op t012 _ = () val op t012 = TDB.find "t012"
  fun op t013 _ = () val op t013 = TDB.find "t013"
  fun op t014 _ = () val op t014 = TDB.find "t014"
  fun op t015 _ = () val op t015 = TDB.find "t015"
  fun op t016 _ = () val op t016 = TDB.find "t016"
  fun op t017 _ = () val op t017 = TDB.find "t017"
  fun op t018 _ = () val op t018 = TDB.find "t018"
  fun op t019 _ = () val op t019 = TDB.find "t019"
  fun op t020 _ = () val op t020 = TDB.find "t020"
  fun op t021 _ = () val op t021 = TDB.find "t021"
  fun op t022 _ = () val op t022 = TDB.find "t022"
  fun op t023 _ = () val op t023 = TDB.find "t023"
  fun op t024 _ = () val op t024 = TDB.find "t024"
  fun op t025 _ = () val op t025 = TDB.find "t025"
  fun op t026 _ = () val op t026 = TDB.find "t026"
  fun op t027 _ = () val op t027 = TDB.find "t027"
  fun op t028 _ = () val op t028 = TDB.find "t028"
  fun op t029 _ = () val op t029 = TDB.find "t029"
  fun op t030 _ = () val op t030 = TDB.find "t030"
  fun op t031 _ = () val op t031 = TDB.find "t031"
  fun op t032 _ = () val op t032 = TDB.find "t032"
  fun op t033 _ = () val op t033 = TDB.find "t033"
  fun op t034 _ = () val op t034 = TDB.find "t034"
  fun op t035 _ = () val op t035 = TDB.find "t035"
  fun op p001 _ = () val op p001 = TDB.find "p001"
  fun op p002 _ = () val op p002 = TDB.find "p002"
  fun op p003 _ = () val op p003 = TDB.find "p003"
  fun op p004 _ = () val op p004 = TDB.find "p004"
  fun op p005 _ = () val op p005 = TDB.find "p005"
  fun op p006 _ = () val op p006 = TDB.find "p006"
  fun op p007 _ = () val op p007 = TDB.find "p007"
  fun op p008 _ = () val op p008 = TDB.find "p008"
  fun op p009 _ = () val op p009 = TDB.find "p009"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val HolSmt_grammars = merge_grammars ["transc", "Omega", "int_arith",
  "blast", "bitstring"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="HolSmt"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val HolSmt_grammars = 
    Portable.## (addtyUDs,addtmUDs) HolSmt_grammars
  val _ = Parse.grammarDB_insert("HolSmt",HolSmt_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "HolSmt"

end
