structure bagTheory :> bagTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading bagTheory ... "
    else ()
  
  open Type Term Thm
  local open dividesTheory indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "bag"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/bag/bagTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op EMPTY_BAG _ = () val op EMPTY_BAG = TDB.find "EMPTY_BAG"
  fun op BAG_INN _ = () val op BAG_INN = TDB.find "BAG_INN"
  fun op SUB_BAG _ = () val op SUB_BAG = TDB.find "SUB_BAG"
  fun op PSUB_BAG _ = () val op PSUB_BAG = TDB.find "PSUB_BAG"
  fun op BAG_IN _ = () val op BAG_IN = TDB.find "BAG_IN"
  fun op BAG_UNION _ = () val op BAG_UNION = TDB.find "BAG_UNION"
  fun op BAG_DIFF _ = () val op BAG_DIFF = TDB.find "BAG_DIFF"
  fun op BAG_INSERT _ = () val op BAG_INSERT = TDB.find "BAG_INSERT"
  fun op BAG_INTER _ = () val op BAG_INTER = TDB.find "BAG_INTER"
  fun op BAG_MERGE _ = () val op BAG_MERGE = TDB.find "BAG_MERGE"
  fun op BAG_DELETE _ = () val op BAG_DELETE = TDB.find "BAG_DELETE"
  fun op SING_BAG _ = () val op SING_BAG = TDB.find "SING_BAG"
  fun op EL_BAG _ = () val op EL_BAG = TDB.find "EL_BAG"
  fun op SET_OF_BAG _ = () val op SET_OF_BAG = TDB.find "SET_OF_BAG"
  fun op BAG_OF_SET _ = () val op BAG_OF_SET = TDB.find "BAG_OF_SET"
  fun op BAG_DISJOINT _ = () val op BAG_DISJOINT = TDB.find "BAG_DISJOINT"
  fun op FINITE_BAG _ = () val op FINITE_BAG = TDB.find "FINITE_BAG"
  fun op BAG_CARD_RELn _ = ()
  val op BAG_CARD_RELn = TDB.find "BAG_CARD_RELn"
  fun op BAG_CARD _ = () val op BAG_CARD = TDB.find "BAG_CARD"
  fun op BAG_FILTER_DEF _ = ()
  val op BAG_FILTER_DEF = TDB.find "BAG_FILTER_DEF"
  fun op BAG_IMAGE_DEF _ = ()
  val op BAG_IMAGE_DEF = TDB.find "BAG_IMAGE_DEF"
  fun op BAG_CHOICE_DEF _ = ()
  val op BAG_CHOICE_DEF = TDB.find "BAG_CHOICE_DEF"
  fun op BAG_REST_DEF _ = () val op BAG_REST_DEF = TDB.find "BAG_REST_DEF"
  fun op BAG_GEN_SUM_def _ = ()
  val op BAG_GEN_SUM_def = TDB.find "BAG_GEN_SUM_def"
  fun op BAG_GEN_PROD_def _ = ()
  val op BAG_GEN_PROD_def = TDB.find "BAG_GEN_PROD_def"
  fun op BAG_EVERY _ = () val op BAG_EVERY = TDB.find "BAG_EVERY"
  fun op BAG_ALL_DISTINCT _ = ()
  val op BAG_ALL_DISTINCT = TDB.find "BAG_ALL_DISTINCT"
  fun op BIG_BAG_UNION_def _ = ()
  val op BIG_BAG_UNION_def = TDB.find "BIG_BAG_UNION_def"
  fun op mlt1_def _ = () val op mlt1_def = TDB.find "mlt1_def"
  fun op dominates_def _ = ()
  val op dominates_def = TDB.find "dominates_def"
  fun op bag_size_def _ = () val op bag_size_def = TDB.find "bag_size_def"
  fun op EMPTY_BAG_alt _ = ()
  val op EMPTY_BAG_alt = TDB.find "EMPTY_BAG_alt"
  fun op BAG_cases _ = () val op BAG_cases = TDB.find "BAG_cases"
  fun op BAG_MERGE_IDEM _ = ()
  val op BAG_MERGE_IDEM = TDB.find "BAG_MERGE_IDEM"
  fun op BAG_MERGE_SUB_BAG_UNION _ = ()
  val op BAG_MERGE_SUB_BAG_UNION = TDB.find "BAG_MERGE_SUB_BAG_UNION"
  fun op BAG_MERGE_EMPTY _ = ()
  val op BAG_MERGE_EMPTY = TDB.find "BAG_MERGE_EMPTY"
  fun op BAG_MERGE_ELBAG_SUB_BAG_INSERT _ = ()
  val op BAG_MERGE_ELBAG_SUB_BAG_INSERT = TDB.find
    "BAG_MERGE_ELBAG_SUB_BAG_INSERT"
  fun op BAG_MERGE_EQ_EMPTY _ = ()
  val op BAG_MERGE_EQ_EMPTY = TDB.find "BAG_MERGE_EQ_EMPTY"
  fun op BAG_INSERT_EQ_MERGE_DIFF _ = ()
  val op BAG_INSERT_EQ_MERGE_DIFF = TDB.find "BAG_INSERT_EQ_MERGE_DIFF"
  fun op BAG_MERGE_BAG_INSERT _ = ()
  val op BAG_MERGE_BAG_INSERT = TDB.find "BAG_MERGE_BAG_INSERT"
  fun op BAG_INN_0 _ = () val op BAG_INN_0 = TDB.find "BAG_INN_0"
  fun op BAG_INN_LESS _ = () val op BAG_INN_LESS = TDB.find "BAG_INN_LESS"
  fun op BAG_IN_BAG_INSERT _ = ()
  val op BAG_IN_BAG_INSERT = TDB.find "BAG_IN_BAG_INSERT"
  fun op BAG_INN_BAG_INSERT _ = ()
  val op BAG_INN_BAG_INSERT = TDB.find "BAG_INN_BAG_INSERT"
  fun op BAG_INN_BAG_INSERT_STRONG _ = ()
  val op BAG_INN_BAG_INSERT_STRONG = TDB.find "BAG_INN_BAG_INSERT_STRONG"
  fun op BAG_UNION_EQ_LCANCEL1 _ = ()
  val op BAG_UNION_EQ_LCANCEL1 = TDB.find "BAG_UNION_EQ_LCANCEL1"
  fun op BAG_UNION_EQ_RCANCEL1 _ = ()
  val op BAG_UNION_EQ_RCANCEL1 = TDB.find "BAG_UNION_EQ_RCANCEL1"
  fun op BAG_IN_BAG_UNION _ = ()
  val op BAG_IN_BAG_UNION = TDB.find "BAG_IN_BAG_UNION"
  fun op BAG_INN_BAG_UNION _ = ()
  val op BAG_INN_BAG_UNION = TDB.find "BAG_INN_BAG_UNION"
  fun op BAG_INN_BAG_MERGE _ = ()
  val op BAG_INN_BAG_MERGE = TDB.find "BAG_INN_BAG_MERGE"
  fun op BAG_IN_BAG_MERGE _ = ()
  val op BAG_IN_BAG_MERGE = TDB.find "BAG_IN_BAG_MERGE"
  fun op BAG_EXTENSION _ = ()
  val op BAG_EXTENSION = TDB.find "BAG_EXTENSION"
  fun op BAG_UNION_INSERT _ = ()
  val op BAG_UNION_INSERT = TDB.find "BAG_UNION_INSERT"
  fun op BAG_INSERT_DIFF _ = ()
  val op BAG_INSERT_DIFF = TDB.find "BAG_INSERT_DIFF"
  fun op BAG_INSERT_NOT_EMPTY _ = ()
  val op BAG_INSERT_NOT_EMPTY = TDB.find "BAG_INSERT_NOT_EMPTY"
  fun op BAG_INSERT_ONE_ONE _ = ()
  val op BAG_INSERT_ONE_ONE = TDB.find "BAG_INSERT_ONE_ONE"
  fun op C_BAG_INSERT_ONE_ONE _ = ()
  val op C_BAG_INSERT_ONE_ONE = TDB.find "C_BAG_INSERT_ONE_ONE"
  fun op BAG_INSERT_commutes _ = ()
  val op BAG_INSERT_commutes = TDB.find "BAG_INSERT_commutes"
  fun op BAG_DECOMPOSE _ = ()
  val op BAG_DECOMPOSE = TDB.find "BAG_DECOMPOSE"
  fun op BAG_UNION_LEFT_CANCEL _ = ()
  val op BAG_UNION_LEFT_CANCEL = TDB.find "BAG_UNION_LEFT_CANCEL"
  fun op COMM_BAG_UNION _ = ()
  val op COMM_BAG_UNION = TDB.find "COMM_BAG_UNION"
  fun op BAG_UNION_RIGHT_CANCEL _ = ()
  val op BAG_UNION_RIGHT_CANCEL = TDB.find "BAG_UNION_RIGHT_CANCEL"
  fun op ASSOC_BAG_UNION _ = ()
  val op ASSOC_BAG_UNION = TDB.find "ASSOC_BAG_UNION"
  fun op BAG_UNION_EMPTY _ = ()
  val op BAG_UNION_EMPTY = TDB.find "BAG_UNION_EMPTY"
  fun op BAG_DELETE_EMPTY _ = ()
  val op BAG_DELETE_EMPTY = TDB.find "BAG_DELETE_EMPTY"
  fun op BAG_DELETE_commutes _ = ()
  val op BAG_DELETE_commutes = TDB.find "BAG_DELETE_commutes"
  fun op BAG_DELETE_11 _ = ()
  val op BAG_DELETE_11 = TDB.find "BAG_DELETE_11"
  fun op BAG_INN_BAG_DELETE _ = ()
  val op BAG_INN_BAG_DELETE = TDB.find "BAG_INN_BAG_DELETE"
  fun op BAG_IN_BAG_DELETE _ = ()
  val op BAG_IN_BAG_DELETE = TDB.find "BAG_IN_BAG_DELETE"
  fun op BAG_DELETE_INSERT _ = ()
  val op BAG_DELETE_INSERT = TDB.find "BAG_DELETE_INSERT"
  fun op BAG_DELETE_BAG_IN_up _ = ()
  val op BAG_DELETE_BAG_IN_up = TDB.find "BAG_DELETE_BAG_IN_up"
  fun op BAG_DELETE_BAG_IN_down _ = ()
  val op BAG_DELETE_BAG_IN_down = TDB.find "BAG_DELETE_BAG_IN_down"
  fun op BAG_DELETE_BAG_IN _ = ()
  val op BAG_DELETE_BAG_IN = TDB.find "BAG_DELETE_BAG_IN"
  fun op BAG_DELETE_concrete _ = ()
  val op BAG_DELETE_concrete = TDB.find "BAG_DELETE_concrete"
  fun op BAG_UNION_DIFF_eliminate _ = ()
  val op BAG_UNION_DIFF_eliminate = TDB.find "BAG_UNION_DIFF_eliminate"
  fun op BAG_INSERT_EQUAL _ = ()
  val op BAG_INSERT_EQUAL = TDB.find "BAG_INSERT_EQUAL"
  fun op BAG_DELETE_TWICE _ = ()
  val op BAG_DELETE_TWICE = TDB.find "BAG_DELETE_TWICE"
  fun op SING_BAG_THM _ = () val op SING_BAG_THM = TDB.find "SING_BAG_THM"
  fun op EL_BAG_11 _ = () val op EL_BAG_11 = TDB.find "EL_BAG_11"
  fun op EL_BAG_INSERT_squeeze _ = ()
  val op EL_BAG_INSERT_squeeze = TDB.find "EL_BAG_INSERT_squeeze"
  fun op SING_EL_BAG _ = () val op SING_EL_BAG = TDB.find "SING_EL_BAG"
  fun op BAG_INSERT_UNION _ = ()
  val op BAG_INSERT_UNION = TDB.find "BAG_INSERT_UNION"
  fun op BAG_INSERT_EQ_UNION _ = ()
  val op BAG_INSERT_EQ_UNION = TDB.find "BAG_INSERT_EQ_UNION"
  fun op BAG_DELETE_SING _ = ()
  val op BAG_DELETE_SING = TDB.find "BAG_DELETE_SING"
  fun op NOT_IN_EMPTY_BAG _ = ()
  val op NOT_IN_EMPTY_BAG = TDB.find "NOT_IN_EMPTY_BAG"
  fun op BAG_INN_EMPTY_BAG _ = ()
  val op BAG_INN_EMPTY_BAG = TDB.find "BAG_INN_EMPTY_BAG"
  fun op MEMBER_NOT_EMPTY _ = ()
  val op MEMBER_NOT_EMPTY = TDB.find "MEMBER_NOT_EMPTY"
  fun op SUB_BAG_LEQ _ = () val op SUB_BAG_LEQ = TDB.find "SUB_BAG_LEQ"
  fun op SUB_BAG_EMPTY _ = ()
  val op SUB_BAG_EMPTY = TDB.find "SUB_BAG_EMPTY"
  fun op SUB_BAG_REFL _ = () val op SUB_BAG_REFL = TDB.find "SUB_BAG_REFL"
  fun op PSUB_BAG_IRREFL _ = ()
  val op PSUB_BAG_IRREFL = TDB.find "PSUB_BAG_IRREFL"
  fun op SUB_BAG_ANTISYM _ = ()
  val op SUB_BAG_ANTISYM = TDB.find "SUB_BAG_ANTISYM"
  fun op PSUB_BAG_ANTISYM _ = ()
  val op PSUB_BAG_ANTISYM = TDB.find "PSUB_BAG_ANTISYM"
  fun op SUB_BAG_TRANS _ = ()
  val op SUB_BAG_TRANS = TDB.find "SUB_BAG_TRANS"
  fun op PSUB_BAG_TRANS _ = ()
  val op PSUB_BAG_TRANS = TDB.find "PSUB_BAG_TRANS"
  fun op PSUB_BAG_SUB_BAG _ = ()
  val op PSUB_BAG_SUB_BAG = TDB.find "PSUB_BAG_SUB_BAG"
  fun op PSUB_BAG_NOT_EQ _ = ()
  val op PSUB_BAG_NOT_EQ = TDB.find "PSUB_BAG_NOT_EQ"
  fun op BAG_DIFF_EMPTY _ = ()
  val op BAG_DIFF_EMPTY = TDB.find "BAG_DIFF_EMPTY"
  fun op BAG_DIFF_EMPTY_simple _ = ()
  val op BAG_DIFF_EMPTY_simple = TDB.find "BAG_DIFF_EMPTY_simple"
  fun op BAG_DIFF_EQ_EMPTY _ = ()
  val op BAG_DIFF_EQ_EMPTY = TDB.find "BAG_DIFF_EQ_EMPTY"
  fun op BAG_DIFF_INSERT_same _ = ()
  val op BAG_DIFF_INSERT_same = TDB.find "BAG_DIFF_INSERT_same"
  fun op BAG_DIFF_INSERT _ = ()
  val op BAG_DIFF_INSERT = TDB.find "BAG_DIFF_INSERT"
  fun op NOT_IN_BAG_DIFF _ = ()
  val op NOT_IN_BAG_DIFF = TDB.find "NOT_IN_BAG_DIFF"
  fun op BAG_IN_DIFF_I _ = ()
  val op BAG_IN_DIFF_I = TDB.find "BAG_IN_DIFF_I"
  fun op BAG_IN_DIFF_E _ = ()
  val op BAG_IN_DIFF_E = TDB.find "BAG_IN_DIFF_E"
  fun op BAG_UNION_DIFF _ = ()
  val op BAG_UNION_DIFF = TDB.find "BAG_UNION_DIFF"
  fun op BAG_DIFF_2L _ = () val op BAG_DIFF_2L = TDB.find "BAG_DIFF_2L"
  fun op BAG_DIFF_2R _ = () val op BAG_DIFF_2R = TDB.find "BAG_DIFF_2R"
  fun op SUB_BAG_BAG_DIFF _ = ()
  val op SUB_BAG_BAG_DIFF = TDB.find "SUB_BAG_BAG_DIFF"
  fun op BAG_DIFF_UNION_eliminate _ = ()
  val op BAG_DIFF_UNION_eliminate = TDB.find "BAG_DIFF_UNION_eliminate"
  fun op SUB_BAG_UNION_eliminate _ = ()
  val op SUB_BAG_UNION_eliminate = TDB.find "SUB_BAG_UNION_eliminate"
  fun op move_BAG_UNION_over_eq _ = ()
  val op move_BAG_UNION_over_eq = TDB.find "move_BAG_UNION_over_eq"
  fun op SUB_BAG_UNION _ = ()
  val op SUB_BAG_UNION = TDB.find "SUB_BAG_UNION"
  fun op SUB_BAG_EL_BAG _ = ()
  val op SUB_BAG_EL_BAG = TDB.find "SUB_BAG_EL_BAG"
  fun op SUB_BAG_INSERT _ = ()
  val op SUB_BAG_INSERT = TDB.find "SUB_BAG_INSERT"
  fun op SUB_BAG_INSERT_I _ = ()
  val op SUB_BAG_INSERT_I = TDB.find "SUB_BAG_INSERT_I"
  fun op NOT_IN_SUB_BAG_INSERT _ = ()
  val op NOT_IN_SUB_BAG_INSERT = TDB.find "NOT_IN_SUB_BAG_INSERT"
  fun op SUB_BAG_BAG_IN _ = ()
  val op SUB_BAG_BAG_IN = TDB.find "SUB_BAG_BAG_IN"
  fun op SUB_BAG_EXISTS _ = ()
  val op SUB_BAG_EXISTS = TDB.find "SUB_BAG_EXISTS"
  fun op SUB_BAG_UNION_DIFF _ = ()
  val op SUB_BAG_UNION_DIFF = TDB.find "SUB_BAG_UNION_DIFF"
  fun op SUB_BAG_UNION_down _ = ()
  val op SUB_BAG_UNION_down = TDB.find "SUB_BAG_UNION_down"
  fun op SUB_BAG_DIFF _ = () val op SUB_BAG_DIFF = TDB.find "SUB_BAG_DIFF"
  fun op SUB_BAG_PSUB_BAG _ = ()
  val op SUB_BAG_PSUB_BAG = TDB.find "SUB_BAG_PSUB_BAG"
  fun op BAG_DELETE_PSUB_BAG _ = ()
  val op BAG_DELETE_PSUB_BAG = TDB.find "BAG_DELETE_PSUB_BAG"
  fun op BAG_OF_SET_UNION _ = ()
  val op BAG_OF_SET_UNION = TDB.find "BAG_OF_SET_UNION"
  fun op BAG_OF_SET_INSERT _ = ()
  val op BAG_OF_SET_INSERT = TDB.find "BAG_OF_SET_INSERT"
  fun op BAG_OF_SET_BAG_DIFF_DIFF _ = ()
  val op BAG_OF_SET_BAG_DIFF_DIFF = TDB.find "BAG_OF_SET_BAG_DIFF_DIFF"
  fun op SET_OF_EMPTY _ = () val op SET_OF_EMPTY = TDB.find "SET_OF_EMPTY"
  fun op SET_OF_SINGLETON_BAG _ = ()
  val op SET_OF_SINGLETON_BAG = TDB.find "SET_OF_SINGLETON_BAG"
  fun op BAG_IN_BAG_OF_SET _ = ()
  val op BAG_IN_BAG_OF_SET = TDB.find "BAG_IN_BAG_OF_SET"
  fun op BAG_OF_EMPTY _ = () val op BAG_OF_EMPTY = TDB.find "BAG_OF_EMPTY"
  fun op SET_BAG_I _ = () val op SET_BAG_I = TDB.find "SET_BAG_I"
  fun op SUB_BAG_SET _ = () val op SUB_BAG_SET = TDB.find "SUB_BAG_SET"
  fun op SET_OF_BAG_UNION _ = ()
  val op SET_OF_BAG_UNION = TDB.find "SET_OF_BAG_UNION"
  fun op SET_OF_BAG_MERGE _ = ()
  val op SET_OF_BAG_MERGE = TDB.find "SET_OF_BAG_MERGE"
  fun op SET_OF_BAG_INSERT _ = ()
  val op SET_OF_BAG_INSERT = TDB.find "SET_OF_BAG_INSERT"
  fun op SET_OF_EL_BAG _ = ()
  val op SET_OF_EL_BAG = TDB.find "SET_OF_EL_BAG"
  fun op SET_OF_BAG_DIFF_SUBSET_down _ = ()
  val op SET_OF_BAG_DIFF_SUBSET_down = TDB.find
    "SET_OF_BAG_DIFF_SUBSET_down"
  fun op SET_OF_BAG_DIFF_SUBSET_up _ = ()
  val op SET_OF_BAG_DIFF_SUBSET_up = TDB.find "SET_OF_BAG_DIFF_SUBSET_up"
  fun op IN_SET_OF_BAG _ = ()
  val op IN_SET_OF_BAG = TDB.find "IN_SET_OF_BAG"
  fun op SET_OF_BAG_EQ_EMPTY _ = ()
  val op SET_OF_BAG_EQ_EMPTY = TDB.find "SET_OF_BAG_EQ_EMPTY"
  fun op BAG_OF_SET_EQ_INSERT _ = ()
  val op BAG_OF_SET_EQ_INSERT = TDB.find "BAG_OF_SET_EQ_INSERT"
  fun op BAG_DISJOINT_EMPTY _ = ()
  val op BAG_DISJOINT_EMPTY = TDB.find "BAG_DISJOINT_EMPTY"
  fun op BAG_DISJOINT_DIFF _ = ()
  val op BAG_DISJOINT_DIFF = TDB.find "BAG_DISJOINT_DIFF"
  fun op BAG_DISJOINT_BAG_IN _ = ()
  val op BAG_DISJOINT_BAG_IN = TDB.find "BAG_DISJOINT_BAG_IN"
  fun op BAG_DISJOINT_BAG_INSERT _ = ()
  val op BAG_DISJOINT_BAG_INSERT = TDB.find "BAG_DISJOINT_BAG_INSERT"
  fun op BAG_DISJOINT_BAG_UNION _ = ()
  val op BAG_DISJOINT_BAG_UNION = TDB.find "BAG_DISJOINT_BAG_UNION"
  fun op FINITE_EMPTY_BAG _ = ()
  val op FINITE_EMPTY_BAG = TDB.find "FINITE_EMPTY_BAG"
  fun op FINITE_BAG_INSERT _ = ()
  val op FINITE_BAG_INSERT = TDB.find "FINITE_BAG_INSERT"
  fun op FINITE_BAG_INDUCT _ = ()
  val op FINITE_BAG_INDUCT = TDB.find "FINITE_BAG_INDUCT"
  fun op STRONG_FINITE_BAG_INDUCT _ = ()
  val op STRONG_FINITE_BAG_INDUCT = TDB.find "STRONG_FINITE_BAG_INDUCT"
  fun op FINITE_BAG_THM _ = ()
  val op FINITE_BAG_THM = TDB.find "FINITE_BAG_THM"
  fun op FINITE_BAG_DIFF _ = ()
  val op FINITE_BAG_DIFF = TDB.find "FINITE_BAG_DIFF"
  fun op FINITE_BAG_DIFF_dual _ = ()
  val op FINITE_BAG_DIFF_dual = TDB.find "FINITE_BAG_DIFF_dual"
  fun op FINITE_BAG_UNION _ = ()
  val op FINITE_BAG_UNION = TDB.find "FINITE_BAG_UNION"
  fun op FINITE_SUB_BAG _ = ()
  val op FINITE_SUB_BAG = TDB.find "FINITE_SUB_BAG"
  fun op FINITE_BAG_MERGE _ = ()
  val op FINITE_BAG_MERGE = TDB.find "FINITE_BAG_MERGE"
  fun op BAG_CARD_EMPTY _ = ()
  val op BAG_CARD_EMPTY = TDB.find "BAG_CARD_EMPTY"
  fun op BCARD_0 _ = () val op BCARD_0 = TDB.find "BCARD_0"
  fun op BAG_CARD_THM _ = () val op BAG_CARD_THM = TDB.find "BAG_CARD_THM"
  fun op BAG_CARD_UNION _ = ()
  val op BAG_CARD_UNION = TDB.find "BAG_CARD_UNION"
  fun op BCARD_SUC _ = () val op BCARD_SUC = TDB.find "BCARD_SUC"
  fun op BAG_CARD_BAG_INN _ = ()
  val op BAG_CARD_BAG_INN = TDB.find "BAG_CARD_BAG_INN"
  fun op SUB_BAG_DIFF_EQ _ = ()
  val op SUB_BAG_DIFF_EQ = TDB.find "SUB_BAG_DIFF_EQ"
  fun op SUB_BAG_CARD _ = () val op SUB_BAG_CARD = TDB.find "SUB_BAG_CARD"
  fun op BAG_MERGE_CARD _ = ()
  val op BAG_MERGE_CARD = TDB.find "BAG_MERGE_CARD"
  fun op BAG_CARD_DIFF _ = ()
  val op BAG_CARD_DIFF = TDB.find "BAG_CARD_DIFF"
  fun op BAG_FILTER_EMPTY _ = ()
  val op BAG_FILTER_EMPTY = TDB.find "BAG_FILTER_EMPTY"
  fun op BAG_FILTER_BAG_INSERT _ = ()
  val op BAG_FILTER_BAG_INSERT = TDB.find "BAG_FILTER_BAG_INSERT"
  fun op FINITE_BAG_FILTER _ = ()
  val op FINITE_BAG_FILTER = TDB.find "FINITE_BAG_FILTER"
  fun op BAG_INN_BAG_FILTER _ = ()
  val op BAG_INN_BAG_FILTER = TDB.find "BAG_INN_BAG_FILTER"
  fun op BAG_IN_BAG_FILTER _ = ()
  val op BAG_IN_BAG_FILTER = TDB.find "BAG_IN_BAG_FILTER"
  fun op BAG_FILTER_FILTER _ = ()
  val op BAG_FILTER_FILTER = TDB.find "BAG_FILTER_FILTER"
  fun op BAG_FILTER_SUB_BAG _ = ()
  val op BAG_FILTER_SUB_BAG = TDB.find "BAG_FILTER_SUB_BAG"
  fun op BAG_OF_SET_DIFF _ = ()
  val op BAG_OF_SET_DIFF = TDB.find "BAG_OF_SET_DIFF"
  fun op SET_OF_BAG_EQ_INSERT _ = ()
  val op SET_OF_BAG_EQ_INSERT = TDB.find "SET_OF_BAG_EQ_INSERT"
  fun op FINITE_SET_OF_BAG _ = ()
  val op FINITE_SET_OF_BAG = TDB.find "FINITE_SET_OF_BAG"
  fun op FINITE_BAG_OF_SET _ = ()
  val op FINITE_BAG_OF_SET = TDB.find "FINITE_BAG_OF_SET"
  fun op BAG_IMAGE_EMPTY _ = ()
  val op BAG_IMAGE_EMPTY = TDB.find "BAG_IMAGE_EMPTY"
  fun op BAG_IMAGE_FINITE_INSERT _ = ()
  val op BAG_IMAGE_FINITE_INSERT = TDB.find "BAG_IMAGE_FINITE_INSERT"
  fun op BAG_IMAGE_FINITE_UNION _ = ()
  val op BAG_IMAGE_FINITE_UNION = TDB.find "BAG_IMAGE_FINITE_UNION"
  fun op BAG_IMAGE_FINITE _ = ()
  val op BAG_IMAGE_FINITE = TDB.find "BAG_IMAGE_FINITE"
  fun op BAG_IMAGE_COMPOSE _ = ()
  val op BAG_IMAGE_COMPOSE = TDB.find "BAG_IMAGE_COMPOSE"
  fun op BAG_IMAGE_FINITE_I _ = ()
  val op BAG_IMAGE_FINITE_I = TDB.find "BAG_IMAGE_FINITE_I"
  fun op BAG_IN_FINITE_BAG_IMAGE _ = ()
  val op BAG_IN_FINITE_BAG_IMAGE = TDB.find "BAG_IN_FINITE_BAG_IMAGE"
  fun op BAG_IMAGE_EQ_EMPTY _ = ()
  val op BAG_IMAGE_EQ_EMPTY = TDB.find "BAG_IMAGE_EQ_EMPTY"
  fun op BAG_INSERT_CHOICE_REST _ = ()
  val op BAG_INSERT_CHOICE_REST = TDB.find "BAG_INSERT_CHOICE_REST"
  fun op BAG_CHOICE_SING _ = ()
  val op BAG_CHOICE_SING = TDB.find "BAG_CHOICE_SING"
  fun op BAG_REST_SING _ = ()
  val op BAG_REST_SING = TDB.find "BAG_REST_SING"
  fun op SUB_BAG_REST _ = () val op SUB_BAG_REST = TDB.find "SUB_BAG_REST"
  fun op PSUB_BAG_REST _ = ()
  val op PSUB_BAG_REST = TDB.find "PSUB_BAG_REST"
  fun op SUB_BAG_UNION_MONO _ = ()
  val op SUB_BAG_UNION_MONO = TDB.find "SUB_BAG_UNION_MONO"
  fun op PSUB_BAG_CARD _ = ()
  val op PSUB_BAG_CARD = TDB.find "PSUB_BAG_CARD"
  fun op EL_BAG_BAG_INSERT _ = ()
  val op EL_BAG_BAG_INSERT = TDB.find "EL_BAG_BAG_INSERT"
  fun op EL_BAG_SUB_BAG _ = ()
  val op EL_BAG_SUB_BAG = TDB.find "EL_BAG_SUB_BAG"
  fun op ITBAG_IND _ = () val op ITBAG_IND = TDB.find "ITBAG_IND"
  fun op ITBAG_THM _ = () val op ITBAG_THM = TDB.find "ITBAG_THM"
  fun op ITBAG_EMPTY _ = () val op ITBAG_EMPTY = TDB.find "ITBAG_EMPTY"
  fun op ITBAG_INSERT _ = () val op ITBAG_INSERT = TDB.find "ITBAG_INSERT"
  fun op COMMUTING_ITBAG_INSERT _ = ()
  val op COMMUTING_ITBAG_INSERT = TDB.find "COMMUTING_ITBAG_INSERT"
  fun op COMMUTING_ITBAG_RECURSES _ = ()
  val op COMMUTING_ITBAG_RECURSES = TDB.find "COMMUTING_ITBAG_RECURSES"
  fun op BAG_GEN_SUM_EMPTY _ = ()
  val op BAG_GEN_SUM_EMPTY = TDB.find "BAG_GEN_SUM_EMPTY"
  fun op BAG_GEN_PROD_EMPTY _ = ()
  val op BAG_GEN_PROD_EMPTY = TDB.find "BAG_GEN_PROD_EMPTY"
  fun op BAG_GEN_SUM_TAILREC _ = ()
  val op BAG_GEN_SUM_TAILREC = TDB.find "BAG_GEN_SUM_TAILREC"
  fun op BAG_GEN_SUM_REC _ = ()
  val op BAG_GEN_SUM_REC = TDB.find "BAG_GEN_SUM_REC"
  fun op BAG_GEN_PROD_TAILREC _ = ()
  val op BAG_GEN_PROD_TAILREC = TDB.find "BAG_GEN_PROD_TAILREC"
  fun op BAG_GEN_PROD_REC _ = ()
  val op BAG_GEN_PROD_REC = TDB.find "BAG_GEN_PROD_REC"
  fun op BAG_GEN_PROD_EQ_1 _ = ()
  val op BAG_GEN_PROD_EQ_1 = TDB.find "BAG_GEN_PROD_EQ_1"
  fun op BAG_GEN_PROD_ALL_ONES _ = ()
  val op BAG_GEN_PROD_ALL_ONES = TDB.find "BAG_GEN_PROD_ALL_ONES"
  fun op BAG_GEN_PROD_POSITIVE _ = ()
  val op BAG_GEN_PROD_POSITIVE = TDB.find "BAG_GEN_PROD_POSITIVE"
  fun op BAG_EVERY_THM _ = ()
  val op BAG_EVERY_THM = TDB.find "BAG_EVERY_THM"
  fun op BAG_EVERY_UNION _ = ()
  val op BAG_EVERY_UNION = TDB.find "BAG_EVERY_UNION"
  fun op BAG_EVERY_MERGE _ = ()
  val op BAG_EVERY_MERGE = TDB.find "BAG_EVERY_MERGE"
  fun op BAG_EVERY_SET _ = ()
  val op BAG_EVERY_SET = TDB.find "BAG_EVERY_SET"
  fun op BAG_FILTER_EQ_EMPTY _ = ()
  val op BAG_FILTER_EQ_EMPTY = TDB.find "BAG_FILTER_EQ_EMPTY"
  fun op SET_OF_BAG_IMAGE _ = ()
  val op SET_OF_BAG_IMAGE = TDB.find "SET_OF_BAG_IMAGE"
  fun op BAG_IMAGE_FINITE_RESTRICTED_I _ = ()
  val op BAG_IMAGE_FINITE_RESTRICTED_I = TDB.find
    "BAG_IMAGE_FINITE_RESTRICTED_I"
  fun op BAG_ALL_DISTINCT_THM _ = ()
  val op BAG_ALL_DISTINCT_THM = TDB.find "BAG_ALL_DISTINCT_THM"
  fun op BAG_ALL_DISTINCT_BAG_MERGE _ = ()
  val op BAG_ALL_DISTINCT_BAG_MERGE = TDB.find "BAG_ALL_DISTINCT_BAG_MERGE"
  fun op BAG_ALL_DISTINCT_BAG_UNION _ = ()
  val op BAG_ALL_DISTINCT_BAG_UNION = TDB.find "BAG_ALL_DISTINCT_BAG_UNION"
  fun op BAG_ALL_DISTINCT_DIFF _ = ()
  val op BAG_ALL_DISTINCT_DIFF = TDB.find "BAG_ALL_DISTINCT_DIFF"
  fun op BAG_ALL_DISTINCT_DELETE _ = ()
  val op BAG_ALL_DISTINCT_DELETE = TDB.find "BAG_ALL_DISTINCT_DELETE"
  fun op BAG_ALL_DISTINCT_SET _ = ()
  val op BAG_ALL_DISTINCT_SET = TDB.find "BAG_ALL_DISTINCT_SET"
  fun op BAG_ALL_DISTINCT_BAG_OF_SET _ = ()
  val op BAG_ALL_DISTINCT_BAG_OF_SET = TDB.find
    "BAG_ALL_DISTINCT_BAG_OF_SET"
  fun op BAG_IN_BAG_DIFF_ALL_DISTINCT _ = ()
  val op BAG_IN_BAG_DIFF_ALL_DISTINCT = TDB.find
    "BAG_IN_BAG_DIFF_ALL_DISTINCT"
  fun op SUB_BAG_ALL_DISTINCT _ = ()
  val op SUB_BAG_ALL_DISTINCT = TDB.find "SUB_BAG_ALL_DISTINCT"
  fun op BAG_ALL_DISTINCT_BAG_INN _ = ()
  val op BAG_ALL_DISTINCT_BAG_INN = TDB.find "BAG_ALL_DISTINCT_BAG_INN"
  fun op BAG_ALL_DISTINCT_EXTENSION _ = ()
  val op BAG_ALL_DISTINCT_EXTENSION = TDB.find "BAG_ALL_DISTINCT_EXTENSION"
  fun op BAG_ALL_DISTINCT_SUB_BAG _ = ()
  val op BAG_ALL_DISTINCT_SUB_BAG = TDB.find "BAG_ALL_DISTINCT_SUB_BAG"
  fun op BAG_DISJOINT_SUB_BAG _ = ()
  val op BAG_DISJOINT_SUB_BAG = TDB.find "BAG_DISJOINT_SUB_BAG"
  fun op BAG_DISJOINT_SYM _ = ()
  val op BAG_DISJOINT_SYM = TDB.find "BAG_DISJOINT_SYM"
  fun op MONOID_BAG_UNION_EMPTY_BAG _ = ()
  val op MONOID_BAG_UNION_EMPTY_BAG = TDB.find "MONOID_BAG_UNION_EMPTY_BAG"
  fun op BAG_DISJOINT_FOLDR_BAG_UNION _ = ()
  val op BAG_DISJOINT_FOLDR_BAG_UNION = TDB.find
    "BAG_DISJOINT_FOLDR_BAG_UNION"
  fun op NOT_BAG_IN _ = () val op NOT_BAG_IN = TDB.find "NOT_BAG_IN"
  fun op BAG_UNION_EQ_LEFT _ = ()
  val op BAG_UNION_EQ_LEFT = TDB.find "BAG_UNION_EQ_LEFT"
  fun op BAG_IN_DIVIDES _ = ()
  val op BAG_IN_DIVIDES = TDB.find "BAG_IN_DIVIDES"
  fun op BAG_GEN_PROD_UNION_LEM _ = ()
  val op BAG_GEN_PROD_UNION_LEM = TDB.find "BAG_GEN_PROD_UNION_LEM"
  fun op BAG_GEN_PROD_UNION _ = ()
  val op BAG_GEN_PROD_UNION = TDB.find "BAG_GEN_PROD_UNION"
  fun op BIG_BAG_UNION_EMPTY _ = ()
  val op BIG_BAG_UNION_EMPTY = TDB.find "BIG_BAG_UNION_EMPTY"
  fun op BIG_BAG_UNION_INSERT _ = ()
  val op BIG_BAG_UNION_INSERT = TDB.find "BIG_BAG_UNION_INSERT"
  fun op BIG_BAG_UNION_DELETE _ = ()
  val op BIG_BAG_UNION_DELETE = TDB.find "BIG_BAG_UNION_DELETE"
  fun op BIG_BAG_UNION_ITSET_BAG_UNION _ = ()
  val op BIG_BAG_UNION_ITSET_BAG_UNION = TDB.find
    "BIG_BAG_UNION_ITSET_BAG_UNION"
  fun op FINITE_BIG_BAG_UNION _ = ()
  val op FINITE_BIG_BAG_UNION = TDB.find "FINITE_BIG_BAG_UNION"
  fun op BAG_IN_BIG_BAG_UNION _ = ()
  val op BAG_IN_BIG_BAG_UNION = TDB.find "BAG_IN_BIG_BAG_UNION"
  fun op BIG_BAG_UNION_EQ_EMPTY_BAG _ = ()
  val op BIG_BAG_UNION_EQ_EMPTY_BAG = TDB.find "BIG_BAG_UNION_EQ_EMPTY_BAG"
  fun op BIG_BAG_UNION_UNION _ = ()
  val op BIG_BAG_UNION_UNION = TDB.find "BIG_BAG_UNION_UNION"
  fun op BIG_BAG_UNION_EQ_ELEMENT _ = ()
  val op BIG_BAG_UNION_EQ_ELEMENT = TDB.find "BIG_BAG_UNION_EQ_ELEMENT"
  fun op BAG_NOT_LESS_EMPTY _ = ()
  val op BAG_NOT_LESS_EMPTY = TDB.find "BAG_NOT_LESS_EMPTY"
  fun op NOT_mlt_EMPTY _ = ()
  val op NOT_mlt_EMPTY = TDB.find "NOT_mlt_EMPTY"
  fun op BAG_LESS_ADD _ = () val op BAG_LESS_ADD = TDB.find "BAG_LESS_ADD"
  fun op mlt1_all_accessible _ = ()
  val op mlt1_all_accessible = TDB.find "mlt1_all_accessible"
  fun op WF_mlt1 _ = () val op WF_mlt1 = TDB.find "WF_mlt1"
  fun op TC_mlt1_FINITE_BAG _ = ()
  val op TC_mlt1_FINITE_BAG = TDB.find "TC_mlt1_FINITE_BAG"
  fun op TC_mlt1_UNION2_I _ = ()
  val op TC_mlt1_UNION2_I = TDB.find "TC_mlt1_UNION2_I"
  fun op TC_mlt1_UNION1_I _ = ()
  val op TC_mlt1_UNION1_I = TDB.find "TC_mlt1_UNION1_I"
  fun op mlt_NOT_REFL _ = () val op mlt_NOT_REFL = TDB.find "mlt_NOT_REFL"
  fun op mlt_INSERT_CANCEL_I _ = ()
  val op mlt_INSERT_CANCEL_I = TDB.find "mlt_INSERT_CANCEL_I"
  fun op mlt1_INSERT_CANCEL _ = ()
  val op mlt1_INSERT_CANCEL = TDB.find "mlt1_INSERT_CANCEL"
  fun op dominates_EMPTY _ = ()
  val op dominates_EMPTY = TDB.find "dominates_EMPTY"
  fun op dominates_SUBSET _ = ()
  val op dominates_SUBSET = TDB.find "dominates_SUBSET"
  fun op mlt_dominates_thm1 _ = ()
  val op mlt_dominates_thm1 = TDB.find "mlt_dominates_thm1"
  fun op dominates_DIFF _ = ()
  val op dominates_DIFF = TDB.find "dominates_DIFF"
  fun op BAG_INSERT_SUB_BAG_E _ = ()
  val op BAG_INSERT_SUB_BAG_E = TDB.find "BAG_INSERT_SUB_BAG_E"
  fun op bdominates_BAG_DIFF _ = ()
  val op bdominates_BAG_DIFF = TDB.find "bdominates_BAG_DIFF"
  fun op BAG_INTER_SUB_BAG _ = ()
  val op BAG_INTER_SUB_BAG = TDB.find "BAG_INTER_SUB_BAG"
  fun op BAG_INTER_FINITE _ = ()
  val op BAG_INTER_FINITE = TDB.find "BAG_INTER_FINITE"
  fun op mlt_dominates_thm2 _ = ()
  val op mlt_dominates_thm2 = TDB.find "mlt_dominates_thm2"
  fun op BAG_DIFF_INSERT_SUB_BAG _ = ()
  val op BAG_DIFF_INSERT_SUB_BAG = TDB.find "BAG_DIFF_INSERT_SUB_BAG"
  fun op mlt_INSERT_CANCEL _ = ()
  val op mlt_INSERT_CANCEL = TDB.find "mlt_INSERT_CANCEL"
  fun op mlt_UNION_RCANCEL_I _ = ()
  val op mlt_UNION_RCANCEL_I = TDB.find "mlt_UNION_RCANCEL_I"
  fun op mlt_UNION_RCANCEL _ = ()
  val op mlt_UNION_RCANCEL = TDB.find "mlt_UNION_RCANCEL"
  fun op mlt_UNION_LCANCEL_I _ = ()
  val op mlt_UNION_LCANCEL_I = TDB.find "mlt_UNION_LCANCEL_I"
  fun op mlt_UNION_LCANCEL _ = ()
  val op mlt_UNION_LCANCEL = TDB.find "mlt_UNION_LCANCEL"
  fun op mlt_UNION_CANCEL_EQN _ = ()
  val op mlt_UNION_CANCEL_EQN = TDB.find "mlt_UNION_CANCEL_EQN"
  fun op mlt_UNION_EMPTY_EQN _ = ()
  val op mlt_UNION_EMPTY_EQN = TDB.find "mlt_UNION_EMPTY_EQN"
  fun op SUB_BAG_SING _ = () val op SUB_BAG_SING = TDB.find "SUB_BAG_SING"
  fun op SUB_BAG_DIFF_simple _ = ()
  val op SUB_BAG_DIFF_simple = TDB.find "SUB_BAG_DIFF_simple"
  fun op mltLT_SING0 _ = () val op mltLT_SING0 = TDB.find "mltLT_SING0"
  fun op BAG_SIZE_EMPTY _ = ()
  val op BAG_SIZE_EMPTY = TDB.find "BAG_SIZE_EMPTY"
  fun op BAG_SIZE_INSERT _ = ()
  val op BAG_SIZE_INSERT = TDB.find "BAG_SIZE_INSERT"
  fun op unibag_thm _ = () val op unibag_thm = TDB.find "unibag_thm"
  fun op unibag_INSERT _ = ()
  val op unibag_INSERT = TDB.find "unibag_INSERT"
  fun op unibag_UNION _ = () val op unibag_UNION = TDB.find "unibag_UNION"
  fun op unibag_EQ_BAG_INSERT _ = ()
  val op unibag_EQ_BAG_INSERT = TDB.find "unibag_EQ_BAG_INSERT"
  fun op unibag_FINITE _ = ()
  val op unibag_FINITE = TDB.find "unibag_FINITE"
  fun op unibag_ALL_DISTINCT _ = ()
  val op unibag_ALL_DISTINCT = TDB.find "unibag_ALL_DISTINCT"
  fun op BAG_IN_unibag _ = ()
  val op BAG_IN_unibag = TDB.find "BAG_IN_unibag"
  fun op unibag_EL_MERGE_cases _ = ()
  val op unibag_EL_MERGE_cases = TDB.find "unibag_EL_MERGE_cases"
  fun op unibag_DECOMPOSE _ = ()
  val op unibag_DECOMPOSE = TDB.find "unibag_DECOMPOSE"
  fun op unibag_SUB_BAG _ = ()
  val op unibag_SUB_BAG = TDB.find "unibag_SUB_BAG"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val bag_grammars = merge_grammars ["list", "divides"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="bag"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val bag_grammars = 
    Portable.## (addtyUDs,addtmUDs) bag_grammars
  val _ = Parse.grammarDB_insert("bag",bag_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "bag"

end
