structure primeFactorTheory :> primeFactorTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading primeFactorTheory ... "
    else ()
  
  open Type Term Thm
  local open bagTheory gcdTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "primeFactor"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/bag/primeFactorTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op PRIME_FACTORS_def _ = ()
  val op PRIME_FACTORS_def = TDB.find "PRIME_FACTORS_def"
  fun op PRIME_FACTORS_EXIST _ = ()
  val op PRIME_FACTORS_EXIST = TDB.find "PRIME_FACTORS_EXIST"
  fun op UNIQUE_PRIME_FACTORS _ = ()
  val op UNIQUE_PRIME_FACTORS = TDB.find "UNIQUE_PRIME_FACTORS"
  fun op PRIME_FACTORIZATION _ = ()
  val op PRIME_FACTORIZATION = TDB.find "PRIME_FACTORIZATION"
  fun op PRIME_FACTORS_1 _ = ()
  val op PRIME_FACTORS_1 = TDB.find "PRIME_FACTORS_1"
  fun op PRIME_FACTOR_DIVIDES _ = ()
  val op PRIME_FACTOR_DIVIDES = TDB.find "PRIME_FACTOR_DIVIDES"
  fun op DIVISOR_IN_PRIME_FACTORS _ = ()
  val op DIVISOR_IN_PRIME_FACTORS = TDB.find "DIVISOR_IN_PRIME_FACTORS"
  fun op PRIME_FACTORS_MULT _ = ()
  val op PRIME_FACTORS_MULT = TDB.find "PRIME_FACTORS_MULT"
  fun op FACTORS_prime _ = ()
  val op FACTORS_prime = TDB.find "FACTORS_prime"
  fun op PRIME_FACTORS_EXP _ = ()
  val op PRIME_FACTORS_EXP = TDB.find "PRIME_FACTORS_EXP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val primeFactor_grammars = merge_grammars ["bag", "gcd"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="primeFactor"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val primeFactor_grammars = 
    Portable.## (addtyUDs,addtmUDs) primeFactor_grammars
  val _ = Parse.grammarDB_insert("primeFactor",primeFactor_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "primeFactor"

end
