structure boolTheory :> boolTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading boolTheory ... "
    else ()
  
  open Type Term Thm
  local open boolpp in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "bool"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/bool/boolTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op BOOL_CASES_AX _ = ()
  val op BOOL_CASES_AX = TDB.find "BOOL_CASES_AX"
  fun op ETA_AX _ = () val op ETA_AX = TDB.find "ETA_AX"
  fun op SELECT_AX _ = () val op SELECT_AX = TDB.find "SELECT_AX"
  fun op INFINITY_AX _ = () val op INFINITY_AX = TDB.find "INFINITY_AX"
  fun op T_DEF _ = () val op T_DEF = TDB.find "T_DEF"
  fun op FORALL_DEF _ = () val op FORALL_DEF = TDB.find "FORALL_DEF"
  fun op EXISTS_DEF _ = () val op EXISTS_DEF = TDB.find "EXISTS_DEF"
  fun op AND_DEF _ = () val op AND_DEF = TDB.find "AND_DEF"
  fun op OR_DEF _ = () val op OR_DEF = TDB.find "OR_DEF"
  fun op F_DEF _ = () val op F_DEF = TDB.find "F_DEF"
  fun op NOT_DEF _ = () val op NOT_DEF = TDB.find "NOT_DEF"
  fun op EXISTS_UNIQUE_DEF _ = ()
  val op EXISTS_UNIQUE_DEF = TDB.find "EXISTS_UNIQUE_DEF"
  fun op LET_DEF _ = () val op LET_DEF = TDB.find "LET_DEF"
  fun op COND_DEF _ = () val op COND_DEF = TDB.find "COND_DEF"
  fun op ONE_ONE_DEF _ = () val op ONE_ONE_DEF = TDB.find "ONE_ONE_DEF"
  fun op ONTO_DEF _ = () val op ONTO_DEF = TDB.find "ONTO_DEF"
  fun op TYPE_DEFINITION _ = ()
  val op TYPE_DEFINITION = TDB.find "TYPE_DEFINITION"
  fun op literal_case_DEF _ = ()
  val op literal_case_DEF = TDB.find "literal_case_DEF"
  fun op IN_DEF _ = () val op IN_DEF = TDB.find "IN_DEF"
  fun op RES_FORALL_DEF _ = ()
  val op RES_FORALL_DEF = TDB.find "RES_FORALL_DEF"
  fun op RES_EXISTS_DEF _ = ()
  val op RES_EXISTS_DEF = TDB.find "RES_EXISTS_DEF"
  fun op RES_EXISTS_UNIQUE_DEF _ = ()
  val op RES_EXISTS_UNIQUE_DEF = TDB.find "RES_EXISTS_UNIQUE_DEF"
  fun op RES_SELECT_DEF _ = ()
  val op RES_SELECT_DEF = TDB.find "RES_SELECT_DEF"
  fun op BOUNDED_DEF _ = () val op BOUNDED_DEF = TDB.find "BOUNDED_DEF"
  fun op DATATYPE_TAG_DEF _ = ()
  val op DATATYPE_TAG_DEF = TDB.find "DATATYPE_TAG_DEF"
  fun op RES_ABSTRACT_DEF _ = ()
  val op RES_ABSTRACT_DEF = TDB.find "RES_ABSTRACT_DEF"
  fun op itself_TY_DEF _ = ()
  val op itself_TY_DEF = TDB.find "itself_TY_DEF"
  fun op itself_case_thm _ = ()
  val op itself_case_thm = TDB.find "itself_case_thm"
  fun op TRUTH _ = () val op TRUTH = TDB.find "TRUTH"
  fun op IMP_ANTISYM_AX _ = ()
  val op IMP_ANTISYM_AX = TDB.find "IMP_ANTISYM_AX"
  fun op FALSITY _ = () val op FALSITY = TDB.find "FALSITY"
  fun op ETA_THM _ = () val op ETA_THM = TDB.find "ETA_THM"
  fun op EXCLUDED_MIDDLE _ = ()
  val op EXCLUDED_MIDDLE = TDB.find "EXCLUDED_MIDDLE"
  fun op BETA_THM _ = () val op BETA_THM = TDB.find "BETA_THM"
  fun op LET_THM _ = () val op LET_THM = TDB.find "LET_THM"
  fun op FORALL_THM _ = () val op FORALL_THM = TDB.find "FORALL_THM"
  fun op EXISTS_THM _ = () val op EXISTS_THM = TDB.find "EXISTS_THM"
  fun op ABS_SIMP _ = () val op ABS_SIMP = TDB.find "ABS_SIMP"
  fun op FORALL_SIMP _ = () val op FORALL_SIMP = TDB.find "FORALL_SIMP"
  fun op EXISTS_SIMP _ = () val op EXISTS_SIMP = TDB.find "EXISTS_SIMP"
  fun op AND_INTRO_THM _ = ()
  val op AND_INTRO_THM = TDB.find "AND_INTRO_THM"
  fun op AND1_THM _ = () val op AND1_THM = TDB.find "AND1_THM"
  fun op AND2_THM _ = () val op AND2_THM = TDB.find "AND2_THM"
  fun op CONJ_SYM _ = () val op CONJ_SYM = TDB.find "CONJ_SYM"
  fun op CONJ_COMM _ = () val op CONJ_COMM = TDB.find "CONJ_COMM"
  fun op CONJ_ASSOC _ = () val op CONJ_ASSOC = TDB.find "CONJ_ASSOC"
  fun op OR_INTRO_THM1 _ = ()
  val op OR_INTRO_THM1 = TDB.find "OR_INTRO_THM1"
  fun op OR_INTRO_THM2 _ = ()
  val op OR_INTRO_THM2 = TDB.find "OR_INTRO_THM2"
  fun op OR_ELIM_THM _ = () val op OR_ELIM_THM = TDB.find "OR_ELIM_THM"
  fun op IMP_F _ = () val op IMP_F = TDB.find "IMP_F"
  fun op F_IMP _ = () val op F_IMP = TDB.find "F_IMP"
  fun op NOT_F _ = () val op NOT_F = TDB.find "NOT_F"
  fun op NOT_AND _ = () val op NOT_AND = TDB.find "NOT_AND"
  fun op AND_CLAUSES _ = () val op AND_CLAUSES = TDB.find "AND_CLAUSES"
  fun op OR_CLAUSES _ = () val op OR_CLAUSES = TDB.find "OR_CLAUSES"
  fun op IMP_CLAUSES _ = () val op IMP_CLAUSES = TDB.find "IMP_CLAUSES"
  fun op NOT_CLAUSES _ = () val op NOT_CLAUSES = TDB.find "NOT_CLAUSES"
  fun op EQ_REFL _ = () val op EQ_REFL = TDB.find "EQ_REFL"
  fun op REFL_CLAUSE _ = () val op REFL_CLAUSE = TDB.find "REFL_CLAUSE"
  fun op EQ_SYM _ = () val op EQ_SYM = TDB.find "EQ_SYM"
  fun op EQ_SYM_EQ _ = () val op EQ_SYM_EQ = TDB.find "EQ_SYM_EQ"
  fun op EQ_EXT _ = () val op EQ_EXT = TDB.find "EQ_EXT"
  fun op FUN_EQ_THM _ = () val op FUN_EQ_THM = TDB.find "FUN_EQ_THM"
  fun op EQ_TRANS _ = () val op EQ_TRANS = TDB.find "EQ_TRANS"
  fun op BOOL_EQ_DISTINCT _ = ()
  val op BOOL_EQ_DISTINCT = TDB.find "BOOL_EQ_DISTINCT"
  fun op EQ_CLAUSES _ = () val op EQ_CLAUSES = TDB.find "EQ_CLAUSES"
  fun op COND_CLAUSES _ = () val op COND_CLAUSES = TDB.find "COND_CLAUSES"
  fun op COND_ID _ = () val op COND_ID = TDB.find "COND_ID"
  fun op SELECT_THM _ = () val op SELECT_THM = TDB.find "SELECT_THM"
  fun op SELECT_REFL _ = () val op SELECT_REFL = TDB.find "SELECT_REFL"
  fun op SELECT_REFL_2 _ = ()
  val op SELECT_REFL_2 = TDB.find "SELECT_REFL_2"
  fun op SELECT_UNIQUE _ = ()
  val op SELECT_UNIQUE = TDB.find "SELECT_UNIQUE"
  fun op SELECT_ELIM_THM _ = ()
  val op SELECT_ELIM_THM = TDB.find "SELECT_ELIM_THM"
  fun op NOT_FORALL_THM _ = ()
  val op NOT_FORALL_THM = TDB.find "NOT_FORALL_THM"
  fun op NOT_EXISTS_THM _ = ()
  val op NOT_EXISTS_THM = TDB.find "NOT_EXISTS_THM"
  fun op FORALL_AND_THM _ = ()
  val op FORALL_AND_THM = TDB.find "FORALL_AND_THM"
  fun op LEFT_AND_FORALL_THM _ = ()
  val op LEFT_AND_FORALL_THM = TDB.find "LEFT_AND_FORALL_THM"
  fun op RIGHT_AND_FORALL_THM _ = ()
  val op RIGHT_AND_FORALL_THM = TDB.find "RIGHT_AND_FORALL_THM"
  fun op EXISTS_OR_THM _ = ()
  val op EXISTS_OR_THM = TDB.find "EXISTS_OR_THM"
  fun op LEFT_OR_EXISTS_THM _ = ()
  val op LEFT_OR_EXISTS_THM = TDB.find "LEFT_OR_EXISTS_THM"
  fun op RIGHT_OR_EXISTS_THM _ = ()
  val op RIGHT_OR_EXISTS_THM = TDB.find "RIGHT_OR_EXISTS_THM"
  fun op BOTH_EXISTS_AND_THM _ = ()
  val op BOTH_EXISTS_AND_THM = TDB.find "BOTH_EXISTS_AND_THM"
  fun op LEFT_EXISTS_AND_THM _ = ()
  val op LEFT_EXISTS_AND_THM = TDB.find "LEFT_EXISTS_AND_THM"
  fun op RIGHT_EXISTS_AND_THM _ = ()
  val op RIGHT_EXISTS_AND_THM = TDB.find "RIGHT_EXISTS_AND_THM"
  fun op BOTH_FORALL_OR_THM _ = ()
  val op BOTH_FORALL_OR_THM = TDB.find "BOTH_FORALL_OR_THM"
  fun op LEFT_FORALL_OR_THM _ = ()
  val op LEFT_FORALL_OR_THM = TDB.find "LEFT_FORALL_OR_THM"
  fun op RIGHT_FORALL_OR_THM _ = ()
  val op RIGHT_FORALL_OR_THM = TDB.find "RIGHT_FORALL_OR_THM"
  fun op BOTH_FORALL_IMP_THM _ = ()
  val op BOTH_FORALL_IMP_THM = TDB.find "BOTH_FORALL_IMP_THM"
  fun op LEFT_FORALL_IMP_THM _ = ()
  val op LEFT_FORALL_IMP_THM = TDB.find "LEFT_FORALL_IMP_THM"
  fun op RIGHT_FORALL_IMP_THM _ = ()
  val op RIGHT_FORALL_IMP_THM = TDB.find "RIGHT_FORALL_IMP_THM"
  fun op BOTH_EXISTS_IMP_THM _ = ()
  val op BOTH_EXISTS_IMP_THM = TDB.find "BOTH_EXISTS_IMP_THM"
  fun op LEFT_EXISTS_IMP_THM _ = ()
  val op LEFT_EXISTS_IMP_THM = TDB.find "LEFT_EXISTS_IMP_THM"
  fun op RIGHT_EXISTS_IMP_THM _ = ()
  val op RIGHT_EXISTS_IMP_THM = TDB.find "RIGHT_EXISTS_IMP_THM"
  fun op OR_IMP_THM _ = () val op OR_IMP_THM = TDB.find "OR_IMP_THM"
  fun op NOT_IMP _ = () val op NOT_IMP = TDB.find "NOT_IMP"
  fun op DISJ_ASSOC _ = () val op DISJ_ASSOC = TDB.find "DISJ_ASSOC"
  fun op DISJ_SYM _ = () val op DISJ_SYM = TDB.find "DISJ_SYM"
  fun op DISJ_COMM _ = () val op DISJ_COMM = TDB.find "DISJ_COMM"
  fun op DE_MORGAN_THM _ = ()
  val op DE_MORGAN_THM = TDB.find "DE_MORGAN_THM"
  fun op LEFT_AND_OVER_OR _ = ()
  val op LEFT_AND_OVER_OR = TDB.find "LEFT_AND_OVER_OR"
  fun op RIGHT_AND_OVER_OR _ = ()
  val op RIGHT_AND_OVER_OR = TDB.find "RIGHT_AND_OVER_OR"
  fun op LEFT_OR_OVER_AND _ = ()
  val op LEFT_OR_OVER_AND = TDB.find "LEFT_OR_OVER_AND"
  fun op RIGHT_OR_OVER_AND _ = ()
  val op RIGHT_OR_OVER_AND = TDB.find "RIGHT_OR_OVER_AND"
  fun op IMP_DISJ_THM _ = () val op IMP_DISJ_THM = TDB.find "IMP_DISJ_THM"
  fun op DISJ_IMP_THM _ = () val op DISJ_IMP_THM = TDB.find "DISJ_IMP_THM"
  fun op IMP_CONJ_THM _ = () val op IMP_CONJ_THM = TDB.find "IMP_CONJ_THM"
  fun op IMP_F_EQ_F _ = () val op IMP_F_EQ_F = TDB.find "IMP_F_EQ_F"
  fun op AND_IMP_INTRO _ = ()
  val op AND_IMP_INTRO = TDB.find "AND_IMP_INTRO"
  fun op EQ_IMP_THM _ = () val op EQ_IMP_THM = TDB.find "EQ_IMP_THM"
  fun op EQ_EXPAND _ = () val op EQ_EXPAND = TDB.find "EQ_EXPAND"
  fun op COND_RATOR _ = () val op COND_RATOR = TDB.find "COND_RATOR"
  fun op COND_RAND _ = () val op COND_RAND = TDB.find "COND_RAND"
  fun op COND_ABS _ = () val op COND_ABS = TDB.find "COND_ABS"
  fun op COND_EXPAND _ = () val op COND_EXPAND = TDB.find "COND_EXPAND"
  fun op COND_EXPAND_IMP _ = ()
  val op COND_EXPAND_IMP = TDB.find "COND_EXPAND_IMP"
  fun op COND_EXPAND_OR _ = ()
  val op COND_EXPAND_OR = TDB.find "COND_EXPAND_OR"
  fun op TYPE_DEFINITION_THM _ = ()
  val op TYPE_DEFINITION_THM = TDB.find "TYPE_DEFINITION_THM"
  fun op ONTO_THM _ = () val op ONTO_THM = TDB.find "ONTO_THM"
  fun op ONE_ONE_THM _ = () val op ONE_ONE_THM = TDB.find "ONE_ONE_THM"
  fun op ABS_REP_THM _ = () val op ABS_REP_THM = TDB.find "ABS_REP_THM"
  fun op LET_RAND _ = () val op LET_RAND = TDB.find "LET_RAND"
  fun op LET_RATOR _ = () val op LET_RATOR = TDB.find "LET_RATOR"
  fun op SWAP_FORALL_THM _ = ()
  val op SWAP_FORALL_THM = TDB.find "SWAP_FORALL_THM"
  fun op SWAP_EXISTS_THM _ = ()
  val op SWAP_EXISTS_THM = TDB.find "SWAP_EXISTS_THM"
  fun op EXISTS_UNIQUE_THM _ = ()
  val op EXISTS_UNIQUE_THM = TDB.find "EXISTS_UNIQUE_THM"
  fun op EXISTS_UNIQUE_ALT' _ = ()
  val op EXISTS_UNIQUE_ALT' = TDB.find "EXISTS_UNIQUE_ALT'"
  fun op LET_CONG _ = () val op LET_CONG = TDB.find "LET_CONG"
  fun op IMP_CONG _ = () val op IMP_CONG = TDB.find "IMP_CONG"
  fun op AND_CONG _ = () val op AND_CONG = TDB.find "AND_CONG"
  fun op LEFT_AND_CONG _ = ()
  val op LEFT_AND_CONG = TDB.find "LEFT_AND_CONG"
  fun op OR_CONG _ = () val op OR_CONG = TDB.find "OR_CONG"
  fun op LEFT_OR_CONG _ = () val op LEFT_OR_CONG = TDB.find "LEFT_OR_CONG"
  fun op COND_CONG _ = () val op COND_CONG = TDB.find "COND_CONG"
  fun op RES_FORALL_CONG _ = ()
  val op RES_FORALL_CONG = TDB.find "RES_FORALL_CONG"
  fun op RES_EXISTS_CONG _ = ()
  val op RES_EXISTS_CONG = TDB.find "RES_EXISTS_CONG"
  fun op MONO_AND _ = () val op MONO_AND = TDB.find "MONO_AND"
  fun op MONO_OR _ = () val op MONO_OR = TDB.find "MONO_OR"
  fun op MONO_IMP _ = () val op MONO_IMP = TDB.find "MONO_IMP"
  fun op MONO_NOT _ = () val op MONO_NOT = TDB.find "MONO_NOT"
  fun op MONO_NOT_EQ _ = () val op MONO_NOT_EQ = TDB.find "MONO_NOT_EQ"
  fun op MONO_ALL _ = () val op MONO_ALL = TDB.find "MONO_ALL"
  fun op MONO_EXISTS _ = () val op MONO_EXISTS = TDB.find "MONO_EXISTS"
  fun op MONO_COND _ = () val op MONO_COND = TDB.find "MONO_COND"
  fun op EXISTS_REFL _ = () val op EXISTS_REFL = TDB.find "EXISTS_REFL"
  fun op EXISTS_UNIQUE_REFL _ = ()
  val op EXISTS_UNIQUE_REFL = TDB.find "EXISTS_UNIQUE_REFL"
  fun op UNWIND_THM1 _ = () val op UNWIND_THM1 = TDB.find "UNWIND_THM1"
  fun op UNWIND_THM2 _ = () val op UNWIND_THM2 = TDB.find "UNWIND_THM2"
  fun op UNWIND_FORALL_THM1 _ = ()
  val op UNWIND_FORALL_THM1 = TDB.find "UNWIND_FORALL_THM1"
  fun op UNWIND_FORALL_THM2 _ = ()
  val op UNWIND_FORALL_THM2 = TDB.find "UNWIND_FORALL_THM2"
  fun op SKOLEM_THM _ = () val op SKOLEM_THM = TDB.find "SKOLEM_THM"
  fun op bool_case_thm _ = ()
  val op bool_case_thm = TDB.find "bool_case_thm"
  fun op bool_case_ID _ = () val op bool_case_ID = TDB.find "bool_case_ID"
  fun op boolAxiom _ = () val op boolAxiom = TDB.find "boolAxiom"
  fun op bool_INDUCT _ = () val op bool_INDUCT = TDB.find "bool_INDUCT"
  fun op bool_case_CONG _ = ()
  val op bool_case_CONG = TDB.find "bool_case_CONG"
  fun op FORALL_BOOL _ = () val op FORALL_BOOL = TDB.find "FORALL_BOOL"
  fun op UEXISTS_OR_THM _ = ()
  val op UEXISTS_OR_THM = TDB.find "UEXISTS_OR_THM"
  fun op UEXISTS_SIMP _ = () val op UEXISTS_SIMP = TDB.find "UEXISTS_SIMP"
  fun op RES_FORALL_THM _ = ()
  val op RES_FORALL_THM = TDB.find "RES_FORALL_THM"
  fun op RES_EXISTS_THM _ = ()
  val op RES_EXISTS_THM = TDB.find "RES_EXISTS_THM"
  fun op RES_EXISTS_UNIQUE_THM _ = ()
  val op RES_EXISTS_UNIQUE_THM = TDB.find "RES_EXISTS_UNIQUE_THM"
  fun op RES_SELECT_THM _ = ()
  val op RES_SELECT_THM = TDB.find "RES_SELECT_THM"
  fun op RES_FORALL_TRUE _ = ()
  val op RES_FORALL_TRUE = TDB.find "RES_FORALL_TRUE"
  fun op RES_EXISTS_FALSE _ = ()
  val op RES_EXISTS_FALSE = TDB.find "RES_EXISTS_FALSE"
  fun op BOOL_FUN_CASES_THM _ = ()
  val op BOOL_FUN_CASES_THM = TDB.find "BOOL_FUN_CASES_THM"
  fun op BOOL_FUN_INDUCT _ = ()
  val op BOOL_FUN_INDUCT = TDB.find "BOOL_FUN_INDUCT"
  fun op literal_case_THM _ = ()
  val op literal_case_THM = TDB.find "literal_case_THM"
  fun op literal_case_RAND _ = ()
  val op literal_case_RAND = TDB.find "literal_case_RAND"
  fun op literal_case_RATOR _ = ()
  val op literal_case_RATOR = TDB.find "literal_case_RATOR"
  fun op literal_case_CONG _ = ()
  val op literal_case_CONG = TDB.find "literal_case_CONG"
  fun op literal_case_id _ = ()
  val op literal_case_id = TDB.find "literal_case_id"
  fun op BOUNDED_THM _ = () val op BOUNDED_THM = TDB.find "BOUNDED_THM"
  fun op LCOMM_THM _ = () val op LCOMM_THM = TDB.find "LCOMM_THM"
  fun op DATATYPE_TAG_THM _ = ()
  val op DATATYPE_TAG_THM = TDB.find "DATATYPE_TAG_THM"
  fun op DATATYPE_BOOL _ = ()
  val op DATATYPE_BOOL = TDB.find "DATATYPE_BOOL"
  fun op ITSELF_UNIQUE _ = ()
  val op ITSELF_UNIQUE = TDB.find "ITSELF_UNIQUE"
  fun op itself_Axiom _ = () val op itself_Axiom = TDB.find "itself_Axiom"
  fun op itself_induction _ = ()
  val op itself_induction = TDB.find "itself_induction"
  fun op FORALL_itself _ = ()
  val op FORALL_itself = TDB.find "FORALL_itself"
  fun op EXISTS_itself _ = ()
  val op EXISTS_itself = TDB.find "EXISTS_itself"
  fun op PULL_EXISTS _ = () val op PULL_EXISTS = TDB.find "PULL_EXISTS"
  fun op PULL_FORALL _ = () val op PULL_FORALL = TDB.find "PULL_FORALL"
  fun op PEIRCE _ = () val op PEIRCE = TDB.find "PEIRCE"
  fun op JRH_INDUCT_UTIL _ = ()
  val op JRH_INDUCT_UTIL = TDB.find "JRH_INDUCT_UTIL"
  fun op DISJ_EQ_IMP _ = () val op DISJ_EQ_IMP = TDB.find "DISJ_EQ_IMP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val bool_grammars = merge_grammars ["min"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="bool"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val bool_grammars = 
    Portable.## (addtyUDs,addtmUDs) bool_grammars
  val _ = Parse.grammarDB_insert("bool",bool_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "bool"

end
