structure lbtreeTheory :> lbtreeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading lbtreeTheory ... "
    else ()
  
  open Type Term Thm
  local open llistTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "lbtree"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coalgebras/lbtreeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op Lfrep_def _ = () val op Lfrep_def = TDB.find "Lfrep_def"
  fun op Ndrep_def _ = () val op Ndrep_def = TDB.find "Ndrep_def"
  fun op is_lbtree_def _ = ()
  val op is_lbtree_def = TDB.find "is_lbtree_def"
  fun op lbtree_TY_DEF _ = ()
  val op lbtree_TY_DEF = TDB.find "lbtree_TY_DEF"
  fun op lbtree_absrep _ = ()
  val op lbtree_absrep = TDB.find "lbtree_absrep"
  fun op path_follow_def _ = ()
  val op path_follow_def = TDB.find "path_follow_def"
  fun op Lf_def _ = () val op Lf_def = TDB.find "Lf_def"
  fun op Nd_def _ = () val op Nd_def = TDB.find "Nd_def"
  fun op lbtree_case_def _ = ()
  val op lbtree_case_def = TDB.find "lbtree_case_def"
  fun op mem_def _ = () val op mem_def = TDB.find "mem_def"
  fun op map_def _ = () val op map_def = TDB.find "map_def"
  fun op finite_def _ = () val op finite_def = TDB.find "finite_def"
  fun op bf_flatten_def _ = ()
  val op bf_flatten_def = TDB.find "bf_flatten_def"
  fun op depth_def _ = () val op depth_def = TDB.find "depth_def"
  fun op mindepth_def _ = () val op mindepth_def = TDB.find "mindepth_def"
  fun op is_mmindex_def _ = ()
  val op is_mmindex_def = TDB.find "is_mmindex_def"
  fun op lbtree_cases _ = () val op lbtree_cases = TDB.find "lbtree_cases"
  fun op Lf_NOT_Nd _ = () val op Lf_NOT_Nd = TDB.find "Lf_NOT_Nd"
  fun op Nd_11 _ = () val op Nd_11 = TDB.find "Nd_11"
  fun op lbtree_ue_Axiom _ = ()
  val op lbtree_ue_Axiom = TDB.find "lbtree_ue_Axiom"
  fun op lbtree_case_thm _ = ()
  val op lbtree_case_thm = TDB.find "lbtree_case_thm"
  fun op lbtree_bisimulation _ = ()
  val op lbtree_bisimulation = TDB.find "lbtree_bisimulation"
  fun op lbtree_strong_bisimulation _ = ()
  val op lbtree_strong_bisimulation = TDB.find "lbtree_strong_bisimulation"
  fun op mem_rules _ = () val op mem_rules = TDB.find "mem_rules"
  fun op mem_ind _ = () val op mem_ind = TDB.find "mem_ind"
  fun op mem_strongind _ = ()
  val op mem_strongind = TDB.find "mem_strongind"
  fun op mem_cases _ = () val op mem_cases = TDB.find "mem_cases"
  fun op mem_thm _ = () val op mem_thm = TDB.find "mem_thm"
  fun op map_eq_Lf _ = () val op map_eq_Lf = TDB.find "map_eq_Lf"
  fun op map_eq_Nd _ = () val op map_eq_Nd = TDB.find "map_eq_Nd"
  fun op finite_rules _ = () val op finite_rules = TDB.find "finite_rules"
  fun op finite_ind _ = () val op finite_ind = TDB.find "finite_ind"
  fun op finite_strongind _ = ()
  val op finite_strongind = TDB.find "finite_strongind"
  fun op finite_cases _ = () val op finite_cases = TDB.find "finite_cases"
  fun op finite_thm _ = () val op finite_thm = TDB.find "finite_thm"
  fun op finite_map _ = () val op finite_map = TDB.find "finite_map"
  fun op bf_flatten_eq_lnil _ = ()
  val op bf_flatten_eq_lnil = TDB.find "bf_flatten_eq_lnil"
  fun op bf_flatten_append _ = ()
  val op bf_flatten_append = TDB.find "bf_flatten_append"
  fun op EXISTS_FIRST _ = () val op EXISTS_FIRST = TDB.find "EXISTS_FIRST"
  fun op exists_bf_flatten _ = ()
  val op exists_bf_flatten = TDB.find "exists_bf_flatten"
  fun op depth_rules _ = () val op depth_rules = TDB.find "depth_rules"
  fun op depth_ind _ = () val op depth_ind = TDB.find "depth_ind"
  fun op depth_strongind _ = ()
  val op depth_strongind = TDB.find "depth_strongind"
  fun op depth_cases _ = () val op depth_cases = TDB.find "depth_cases"
  fun op mem_depth _ = () val op mem_depth = TDB.find "mem_depth"
  fun op depth_mem _ = () val op depth_mem = TDB.find "depth_mem"
  fun op optmin_ind _ = () val op optmin_ind = TDB.find "optmin_ind"
  fun op optmin_def _ = () val op optmin_def = TDB.find "optmin_def"
  fun op mindepth_thm _ = () val op mindepth_thm = TDB.find "mindepth_thm"
  fun op mem_mindepth _ = () val op mem_mindepth = TDB.find "mem_mindepth"
  fun op mindepth_depth _ = ()
  val op mindepth_depth = TDB.find "mindepth_depth"
  fun op mmindex_EXISTS _ = ()
  val op mmindex_EXISTS = TDB.find "mmindex_EXISTS"
  fun op mmindex_unique _ = ()
  val op mmindex_unique = TDB.find "mmindex_unique"
  fun op mem_bf_flatten _ = ()
  val op mem_bf_flatten = TDB.find "mem_bf_flatten"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val lbtree_grammars = merge_grammars ["llist"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="lbtree"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val lbtree_grammars = 
    Portable.## (addtyUDs,addtmUDs) lbtree_grammars
  val _ = Parse.grammarDB_insert("lbtree",lbtree_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "lbtree"

end
