structure llistTheory :> llistTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading llistTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory set_relationTheory
  in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "llist"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coalgebras/llistTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op lrep_ok_def _ = () val op lrep_ok_def = TDB.find "lrep_ok_def"
  fun op llist_TY_DEF _ = () val op llist_TY_DEF = TDB.find "llist_TY_DEF"
  fun op llist_absrep _ = () val op llist_absrep = TDB.find "llist_absrep"
  fun op LNIL _ = () val op LNIL = TDB.find "LNIL"
  fun op LCONS _ = () val op LCONS = TDB.find "LCONS"
  fun op LTL_HD_def _ = () val op LTL_HD_def = TDB.find "LTL_HD_def"
  fun op LHD _ = () val op LHD = TDB.find "LHD"
  fun op LTL _ = () val op LTL = TDB.find "LTL"
  fun op LNTH _ = () val op LNTH = TDB.find "LNTH"
  fun op LUNFOLD_def _ = () val op LUNFOLD_def = TDB.find "LUNFOLD_def"
  fun op LTAKE _ = () val op LTAKE = TDB.find "LTAKE"
  fun op LMAP _ = () val op LMAP = TDB.find "LMAP"
  fun op LAPPEND _ = () val op LAPPEND = TDB.find "LAPPEND"
  fun op LFINITE_def _ = () val op LFINITE_def = TDB.find "LFINITE_def"
  fun op llength_rel_def _ = ()
  val op llength_rel_def = TDB.find "llength_rel_def"
  fun op LLENGTH _ = () val op LLENGTH = TDB.find "LLENGTH"
  fun op toList _ = () val op toList = TDB.find "toList"
  fun op fromList_def _ = () val op fromList_def = TDB.find "fromList_def"
  fun op LDROP _ = () val op LDROP = TDB.find "LDROP"
  fun op exists_def _ = () val op exists_def = TDB.find "exists_def"
  fun op every_def _ = () val op every_def = TDB.find "every_def"
  fun op LFILTER _ = () val op LFILTER = TDB.find "LFILTER"
  fun op LFLATTEN _ = () val op LFLATTEN = TDB.find "LFLATTEN"
  fun op LZIP_THM _ = () val op LZIP_THM = TDB.find "LZIP_THM"
  fun op LUNZIP_THM _ = () val op LUNZIP_THM = TDB.find "LUNZIP_THM"
  fun op linear_order_to_list_f_def _ = ()
  val op linear_order_to_list_f_def = TDB.find "linear_order_to_list_f_def"
  fun op LPREFIX_def _ = () val op LPREFIX_def = TDB.find "LPREFIX_def"
  fun op LGENLIST_def _ = () val op LGENLIST_def = TDB.find "LGENLIST_def"
  fun op LREPEAT_def _ = () val op LREPEAT_def = TDB.find "LREPEAT_def"
  fun op eventually_def _ = ()
  val op eventually_def = TDB.find "eventually_def"
  fun op always_def _ = () val op always_def = TDB.find "always_def"
  fun op until_def _ = () val op until_def = TDB.find "until_def"
  fun op lrep_ok_rules _ = ()
  val op lrep_ok_rules = TDB.find "lrep_ok_rules"
  fun op lrep_ok_coind _ = ()
  val op lrep_ok_coind = TDB.find "lrep_ok_coind"
  fun op lrep_ok_cases _ = ()
  val op lrep_ok_cases = TDB.find "lrep_ok_cases"
  fun op lrep_ok_alt _ = () val op lrep_ok_alt = TDB.find "lrep_ok_alt"
  fun op lrep_ok_MAP _ = () val op lrep_ok_MAP = TDB.find "lrep_ok_MAP"
  fun op lrep_ok_FUNPOW_BIND _ = ()
  val op lrep_ok_FUNPOW_BIND = TDB.find "lrep_ok_FUNPOW_BIND"
  fun op llist_rep_LCONS _ = ()
  val op llist_rep_LCONS = TDB.find "llist_rep_LCONS"
  fun op llist_rep_LNIL _ = ()
  val op llist_rep_LNIL = TDB.find "llist_rep_LNIL"
  fun op LTL_HD_LNIL _ = () val op LTL_HD_LNIL = TDB.find "LTL_HD_LNIL"
  fun op LTL_HD_LCONS _ = () val op LTL_HD_LCONS = TDB.find "LTL_HD_LCONS"
  fun op LTL_HD_HD _ = () val op LTL_HD_HD = TDB.find "LTL_HD_HD"
  fun op LTL_HD_TL _ = () val op LTL_HD_TL = TDB.find "LTL_HD_TL"
  fun op LHD_LCONS _ = () val op LHD_LCONS = TDB.find "LHD_LCONS"
  fun op LTL_LCONS _ = () val op LTL_LCONS = TDB.find "LTL_LCONS"
  fun op LHDTL_CONS_THM _ = ()
  val op LHDTL_CONS_THM = TDB.find "LHDTL_CONS_THM"
  fun op llist_CASES _ = () val op llist_CASES = TDB.find "llist_CASES"
  fun op LTL_HD_11 _ = () val op LTL_HD_11 = TDB.find "LTL_HD_11"
  fun op LHD_THM _ = () val op LHD_THM = TDB.find "LHD_THM"
  fun op LTL_THM _ = () val op LTL_THM = TDB.find "LTL_THM"
  fun op LCONS_NOT_NIL _ = ()
  val op LCONS_NOT_NIL = TDB.find "LCONS_NOT_NIL"
  fun op LCONS_11 _ = () val op LCONS_11 = TDB.find "LCONS_11"
  fun op LTL_HD_iff _ = () val op LTL_HD_iff = TDB.find "LTL_HD_iff"
  fun op LHD_EQ_NONE _ = () val op LHD_EQ_NONE = TDB.find "LHD_EQ_NONE"
  fun op LTL_EQ_NONE _ = () val op LTL_EQ_NONE = TDB.find "LTL_EQ_NONE"
  fun op LHDTL_EQ_SOME _ = ()
  val op LHDTL_EQ_SOME = TDB.find "LHDTL_EQ_SOME"
  fun op LNTH_THM _ = () val op LNTH_THM = TDB.find "LNTH_THM"
  fun op LNTH_rep _ = () val op LNTH_rep = TDB.find "LNTH_rep"
  fun op LNTH_EQ _ = () val op LNTH_EQ = TDB.find "LNTH_EQ"
  fun op LUNFOLD _ = () val op LUNFOLD = TDB.find "LUNFOLD"
  fun op LUNFOLD_UNIQUE _ = ()
  val op LUNFOLD_UNIQUE = TDB.find "LUNFOLD_UNIQUE"
  fun op LUNFOLD_LTL_HD _ = ()
  val op LUNFOLD_LTL_HD = TDB.find "LUNFOLD_LTL_HD"
  fun op LTL_HD_LUNFOLD _ = ()
  val op LTL_HD_LUNFOLD = TDB.find "LTL_HD_LUNFOLD"
  fun op LNTH_LUNFOLD _ = () val op LNTH_LUNFOLD = TDB.find "LNTH_LUNFOLD"
  fun op LNTH_LUNFOLD_compute _ = ()
  val op LNTH_LUNFOLD_compute = TDB.find "LNTH_LUNFOLD_compute"
  fun op LHD_LUNFOLD _ = () val op LHD_LUNFOLD = TDB.find "LHD_LUNFOLD"
  fun op LTL_LUNFOLD _ = () val op LTL_LUNFOLD = TDB.find "LTL_LUNFOLD"
  fun op llist_Axiom_1 _ = ()
  val op llist_Axiom_1 = TDB.find "llist_Axiom_1"
  fun op llist_Axiom_1ue _ = ()
  val op llist_Axiom_1ue = TDB.find "llist_Axiom_1ue"
  fun op llist_ue_Axiom _ = ()
  val op llist_ue_Axiom = TDB.find "llist_ue_Axiom"
  fun op llist_Axiom _ = () val op llist_Axiom = TDB.find "llist_Axiom"
  fun op LUNFOLD_BISIMULATION _ = ()
  val op LUNFOLD_BISIMULATION = TDB.find "LUNFOLD_BISIMULATION"
  fun op LLIST_BISIMULATION0 _ = ()
  val op LLIST_BISIMULATION0 = TDB.find "LLIST_BISIMULATION0"
  fun op LLIST_BISIMULATION _ = ()
  val op LLIST_BISIMULATION = TDB.find "LLIST_BISIMULATION"
  fun op LLIST_STRONG_BISIMULATION _ = ()
  val op LLIST_STRONG_BISIMULATION = TDB.find "LLIST_STRONG_BISIMULATION"
  fun op LTAKE_LUNFOLD _ = ()
  val op LTAKE_LUNFOLD = TDB.find "LTAKE_LUNFOLD"
  fun op LTAKE_THM _ = () val op LTAKE_THM = TDB.find "LTAKE_THM"
  fun op LTAKE_SNOC_LNTH _ = ()
  val op LTAKE_SNOC_LNTH = TDB.find "LTAKE_SNOC_LNTH"
  fun op LTAKE_EQ_NONE_LNTH _ = ()
  val op LTAKE_EQ_NONE_LNTH = TDB.find "LTAKE_EQ_NONE_LNTH"
  fun op LTAKE_NIL_EQ_SOME _ = ()
  val op LTAKE_NIL_EQ_SOME = TDB.find "LTAKE_NIL_EQ_SOME"
  fun op LTAKE_NIL_EQ_NONE _ = ()
  val op LTAKE_NIL_EQ_NONE = TDB.find "LTAKE_NIL_EQ_NONE"
  fun op LTAKE_EQ _ = () val op LTAKE_EQ = TDB.find "LTAKE_EQ"
  fun op LTAKE_CONS_EQ_NONE _ = ()
  val op LTAKE_CONS_EQ_NONE = TDB.find "LTAKE_CONS_EQ_NONE"
  fun op LTAKE_CONS_EQ_SOME _ = ()
  val op LTAKE_CONS_EQ_SOME = TDB.find "LTAKE_CONS_EQ_SOME"
  fun op LTAKE_EQ_SOME_CONS _ = ()
  val op LTAKE_EQ_SOME_CONS = TDB.find "LTAKE_EQ_SOME_CONS"
  fun op LMAP_APPEND _ = () val op LMAP_APPEND = TDB.find "LMAP_APPEND"
  fun op LAPPEND_EQ_LNIL _ = ()
  val op LAPPEND_EQ_LNIL = TDB.find "LAPPEND_EQ_LNIL"
  fun op LAPPEND_ASSOC _ = ()
  val op LAPPEND_ASSOC = TDB.find "LAPPEND_ASSOC"
  fun op LMAP_MAP _ = () val op LMAP_MAP = TDB.find "LMAP_MAP"
  fun op LAPPEND_NIL_2ND _ = ()
  val op LAPPEND_NIL_2ND = TDB.find "LAPPEND_NIL_2ND"
  fun op LHD_LAPPEND _ = () val op LHD_LAPPEND = TDB.find "LHD_LAPPEND"
  fun op LTL_LAPPEND _ = () val op LTL_LAPPEND = TDB.find "LTL_LAPPEND"
  fun op LTAKE_LAPPEND1 _ = ()
  val op LTAKE_LAPPEND1 = TDB.find "LTAKE_LAPPEND1"
  fun op LFINITE_rules _ = ()
  val op LFINITE_rules = TDB.find "LFINITE_rules"
  fun op LFINITE_ind _ = () val op LFINITE_ind = TDB.find "LFINITE_ind"
  fun op LFINITE_strongind _ = ()
  val op LFINITE_strongind = TDB.find "LFINITE_strongind"
  fun op LFINITE_cases _ = ()
  val op LFINITE_cases = TDB.find "LFINITE_cases"
  fun op LFINITE_THM _ = () val op LFINITE_THM = TDB.find "LFINITE_THM"
  fun op LFINITE _ = () val op LFINITE = TDB.find "LFINITE"
  fun op llength_rel_rules _ = ()
  val op llength_rel_rules = TDB.find "llength_rel_rules"
  fun op llength_rel_ind _ = ()
  val op llength_rel_ind = TDB.find "llength_rel_ind"
  fun op llength_rel_strongind _ = ()
  val op llength_rel_strongind = TDB.find "llength_rel_strongind"
  fun op llength_rel_cases _ = ()
  val op llength_rel_cases = TDB.find "llength_rel_cases"
  fun op LLENGTH_THM _ = () val op LLENGTH_THM = TDB.find "LLENGTH_THM"
  fun op LLENGTH_0 _ = () val op LLENGTH_0 = TDB.find "LLENGTH_0"
  fun op LFINITE_HAS_LENGTH _ = ()
  val op LFINITE_HAS_LENGTH = TDB.find "LFINITE_HAS_LENGTH"
  fun op NOT_LFINITE_NO_LENGTH _ = ()
  val op NOT_LFINITE_NO_LENGTH = TDB.find "NOT_LFINITE_NO_LENGTH"
  fun op LFINITE_LLENGTH _ = ()
  val op LFINITE_LLENGTH = TDB.find "LFINITE_LLENGTH"
  fun op LFINITE_INDUCTION _ = ()
  val op LFINITE_INDUCTION = TDB.find "LFINITE_INDUCTION"
  fun op LFINITE_STRONG_INDUCTION _ = ()
  val op LFINITE_STRONG_INDUCTION = TDB.find "LFINITE_STRONG_INDUCTION"
  fun op LFINITE_MAP _ = () val op LFINITE_MAP = TDB.find "LFINITE_MAP"
  fun op LFINITE_APPEND _ = ()
  val op LFINITE_APPEND = TDB.find "LFINITE_APPEND"
  fun op LTAKE_LNTH_EL _ = ()
  val op LTAKE_LNTH_EL = TDB.find "LTAKE_LNTH_EL"
  fun op NOT_LFINITE_APPEND _ = ()
  val op NOT_LFINITE_APPEND = TDB.find "NOT_LFINITE_APPEND"
  fun op LFINITE_LAPPEND_IMP_NIL _ = ()
  val op LFINITE_LAPPEND_IMP_NIL = TDB.find "LFINITE_LAPPEND_IMP_NIL"
  fun op LLENGTH_MAP _ = () val op LLENGTH_MAP = TDB.find "LLENGTH_MAP"
  fun op LLENGTH_APPEND _ = ()
  val op LLENGTH_APPEND = TDB.find "LLENGTH_APPEND"
  fun op toList_THM _ = () val op toList_THM = TDB.find "toList_THM"
  fun op fromList_EQ_LNIL _ = ()
  val op fromList_EQ_LNIL = TDB.find "fromList_EQ_LNIL"
  fun op LHD_fromList _ = () val op LHD_fromList = TDB.find "LHD_fromList"
  fun op LTL_fromList _ = () val op LTL_fromList = TDB.find "LTL_fromList"
  fun op LFINITE_fromList _ = ()
  val op LFINITE_fromList = TDB.find "LFINITE_fromList"
  fun op LLENGTH_fromList _ = ()
  val op LLENGTH_fromList = TDB.find "LLENGTH_fromList"
  fun op LTAKE_fromList _ = ()
  val op LTAKE_fromList = TDB.find "LTAKE_fromList"
  fun op from_toList _ = () val op from_toList = TDB.find "from_toList"
  fun op LFINITE_toList _ = ()
  val op LFINITE_toList = TDB.find "LFINITE_toList"
  fun op LFINITE_toList_SOME _ = ()
  val op LFINITE_toList_SOME = TDB.find "LFINITE_toList_SOME"
  fun op to_fromList _ = () val op to_fromList = TDB.find "to_fromList"
  fun op LTAKE_LAPPEND2 _ = ()
  val op LTAKE_LAPPEND2 = TDB.find "LTAKE_LAPPEND2"
  fun op LNTH_fromList _ = ()
  val op LNTH_fromList = TDB.find "LNTH_fromList"
  fun op lnth_fromList_some _ = ()
  val op lnth_fromList_some = TDB.find "lnth_fromList_some"
  fun op LDROP_FUNPOW _ = () val op LDROP_FUNPOW = TDB.find "LDROP_FUNPOW"
  fun op LDROP_THM _ = () val op LDROP_THM = TDB.find "LDROP_THM"
  fun op LDROP1_THM _ = () val op LDROP1_THM = TDB.find "LDROP1_THM"
  fun op LNTH_HD_LDROP _ = ()
  val op LNTH_HD_LDROP = TDB.find "LNTH_HD_LDROP"
  fun op NOT_LFINITE_TAKE _ = ()
  val op NOT_LFINITE_TAKE = TDB.find "NOT_LFINITE_TAKE"
  fun op LFINITE_TAKE _ = () val op LFINITE_TAKE = TDB.find "LFINITE_TAKE"
  fun op NOT_LFINITE_DROP _ = ()
  val op NOT_LFINITE_DROP = TDB.find "NOT_LFINITE_DROP"
  fun op LFINITE_DROP _ = () val op LFINITE_DROP = TDB.find "LFINITE_DROP"
  fun op LTAKE_DROP _ = () val op LTAKE_DROP = TDB.find "LTAKE_DROP"
  fun op LDROP_ADD _ = () val op LDROP_ADD = TDB.find "LDROP_ADD"
  fun op LDROP_SOME_LLENGTH _ = ()
  val op LDROP_SOME_LLENGTH = TDB.find "LDROP_SOME_LLENGTH"
  fun op LFINITE_LNTH_NONE _ = ()
  val op LFINITE_LNTH_NONE = TDB.find "LFINITE_LNTH_NONE"
  fun op infinite_lnth_some _ = ()
  val op infinite_lnth_some = TDB.find "infinite_lnth_some"
  fun op LNTH_LAPPEND _ = () val op LNTH_LAPPEND = TDB.find "LNTH_LAPPEND"
  fun op LNTH_ADD _ = () val op LNTH_ADD = TDB.find "LNTH_ADD"
  fun op lnth_some_down_closed _ = ()
  val op lnth_some_down_closed = TDB.find "lnth_some_down_closed"
  fun op exists_rules _ = () val op exists_rules = TDB.find "exists_rules"
  fun op exists_ind _ = () val op exists_ind = TDB.find "exists_ind"
  fun op exists_strongind _ = ()
  val op exists_strongind = TDB.find "exists_strongind"
  fun op exists_cases _ = () val op exists_cases = TDB.find "exists_cases"
  fun op exists_thm _ = () val op exists_thm = TDB.find "exists_thm"
  fun op exists_LNTH _ = () val op exists_LNTH = TDB.find "exists_LNTH"
  fun op MONO_exists _ = () val op MONO_exists = TDB.find "MONO_exists"
  fun op exists_strong_ind _ = ()
  val op exists_strong_ind = TDB.find "exists_strong_ind"
  fun op exists_LDROP _ = () val op exists_LDROP = TDB.find "exists_LDROP"
  fun op every_coind _ = () val op every_coind = TDB.find "every_coind"
  fun op every_thm _ = () val op every_thm = TDB.find "every_thm"
  fun op LL_ALL_THM _ = () val op LL_ALL_THM = TDB.find "LL_ALL_THM"
  fun op MONO_every _ = () val op MONO_every = TDB.find "MONO_every"
  fun op every_strong_coind _ = ()
  val op every_strong_coind = TDB.find "every_strong_coind"
  fun op LFILTER_THM _ = () val op LFILTER_THM = TDB.find "LFILTER_THM"
  fun op LFILTER_NIL _ = () val op LFILTER_NIL = TDB.find "LFILTER_NIL"
  fun op LFILTER_EQ_NIL _ = ()
  val op LFILTER_EQ_NIL = TDB.find "LFILTER_EQ_NIL"
  fun op LFILTER_APPEND _ = ()
  val op LFILTER_APPEND = TDB.find "LFILTER_APPEND"
  fun op LFLATTEN_THM _ = () val op LFLATTEN_THM = TDB.find "LFLATTEN_THM"
  fun op LFLATTEN_APPEND _ = ()
  val op LFLATTEN_APPEND = TDB.find "LFLATTEN_APPEND"
  fun op LFLATTEN_EQ_NIL _ = ()
  val op LFLATTEN_EQ_NIL = TDB.find "LFLATTEN_EQ_NIL"
  fun op LFLATTEN_SINGLETON _ = ()
  val op LFLATTEN_SINGLETON = TDB.find "LFLATTEN_SINGLETON"
  fun op LZIP_LUNZIP _ = () val op LZIP_LUNZIP = TDB.find "LZIP_LUNZIP"
  fun op LUNFOLD_THM _ = () val op LUNFOLD_THM = TDB.find "LUNFOLD_THM"
  fun op LLIST_EQ _ = () val op LLIST_EQ = TDB.find "LLIST_EQ"
  fun op LUNFOLD_EQ _ = () val op LUNFOLD_EQ = TDB.find "LUNFOLD_EQ"
  fun op LMAP_LUNFOLD _ = () val op LMAP_LUNFOLD = TDB.find "LMAP_LUNFOLD"
  fun op LNTH_LDROP _ = () val op LNTH_LDROP = TDB.find "LNTH_LDROP"
  fun op LAPPEND_fromList _ = ()
  val op LAPPEND_fromList = TDB.find "LAPPEND_fromList"
  fun op LTAKE_LENGTH _ = () val op LTAKE_LENGTH = TDB.find "LTAKE_LENGTH"
  fun op LTAKE_TAKE_LESS _ = ()
  val op LTAKE_TAKE_LESS = TDB.find "LTAKE_TAKE_LESS"
  fun op LTAKE_LLENGTH_NONE _ = ()
  val op LTAKE_LLENGTH_NONE = TDB.find "LTAKE_LLENGTH_NONE"
  fun op LTAKE_LLENGTH_SOME _ = ()
  val op LTAKE_LLENGTH_SOME = TDB.find "LTAKE_LLENGTH_SOME"
  fun op toList_LAPPEND_APPEND _ = ()
  val op toList_LAPPEND_APPEND = TDB.find "toList_LAPPEND_APPEND"
  fun op LNTH_LLENGTH_NONE _ = ()
  val op LNTH_LLENGTH_NONE = TDB.find "LNTH_LLENGTH_NONE"
  fun op LNTH_NONE_MONO _ = ()
  val op LNTH_NONE_MONO = TDB.find "LNTH_NONE_MONO"
  fun op linear_order_to_llist_eq _ = ()
  val op linear_order_to_llist_eq = TDB.find "linear_order_to_llist_eq"
  fun op linear_order_to_llist _ = ()
  val op linear_order_to_llist = TDB.find "linear_order_to_llist"
  fun op LPREFIX_LNIL _ = () val op LPREFIX_LNIL = TDB.find "LPREFIX_LNIL"
  fun op LPREFIX_LCONS _ = ()
  val op LPREFIX_LCONS = TDB.find "LPREFIX_LCONS"
  fun op LPREFIX_LUNFOLD _ = ()
  val op LPREFIX_LUNFOLD = TDB.find "LPREFIX_LUNFOLD"
  fun op LPREFIX_REFL _ = () val op LPREFIX_REFL = TDB.find "LPREFIX_REFL"
  fun op LPREFIX_ANTISYM _ = ()
  val op LPREFIX_ANTISYM = TDB.find "LPREFIX_ANTISYM"
  fun op LPREFIX_TRANS _ = ()
  val op LPREFIX_TRANS = TDB.find "LPREFIX_TRANS"
  fun op LPREFIX_fromList _ = ()
  val op LPREFIX_fromList = TDB.find "LPREFIX_fromList"
  fun op prefixes_lprefix_total _ = ()
  val op prefixes_lprefix_total = TDB.find "prefixes_lprefix_total"
  fun op LTAKE_IMP_LDROP _ = ()
  val op LTAKE_IMP_LDROP = TDB.find "LTAKE_IMP_LDROP"
  fun op LDROP_EQ_LNIL _ = ()
  val op LDROP_EQ_LNIL = TDB.find "LDROP_EQ_LNIL"
  fun op LPREFIX_APPEND _ = ()
  val op LPREFIX_APPEND = TDB.find "LPREFIX_APPEND"
  fun op NOT_LFINITE_DROP_LFINITE _ = ()
  val op NOT_LFINITE_DROP_LFINITE = TDB.find "NOT_LFINITE_DROP_LFINITE"
  fun op LDROP_APPEND1 _ = ()
  val op LDROP_APPEND1 = TDB.find "LDROP_APPEND1"
  fun op LDROP_fromList _ = ()
  val op LDROP_fromList = TDB.find "LDROP_fromList"
  fun op LDROP_SUC _ = () val op LDROP_SUC = TDB.find "LDROP_SUC"
  fun op LDROP_1 _ = () val op LDROP_1 = TDB.find "LDROP_1"
  fun op LDROP_NONE_LFINITE _ = ()
  val op LDROP_NONE_LFINITE = TDB.find "LDROP_NONE_LFINITE"
  fun op LDROP_LDROP _ = () val op LDROP_LDROP = TDB.find "LDROP_LDROP"
  fun op LHD_LGENLIST _ = () val op LHD_LGENLIST = TDB.find "LHD_LGENLIST"
  fun op LTL_LGENLIST _ = () val op LTL_LGENLIST = TDB.find "LTL_LGENLIST"
  fun op numopt_BISIMULATION _ = ()
  val op numopt_BISIMULATION = TDB.find "numopt_BISIMULATION"
  fun op LGENLIST_EQ_LNIL _ = ()
  val op LGENLIST_EQ_LNIL = TDB.find "LGENLIST_EQ_LNIL"
  fun op LFINITE_LGENLIST _ = ()
  val op LFINITE_LGENLIST = TDB.find "LFINITE_LGENLIST"
  fun op LTL_HD_LTL_LHD _ = ()
  val op LTL_HD_LTL_LHD = TDB.find "LTL_HD_LTL_LHD"
  fun op LGENLIST_SOME _ = ()
  val op LGENLIST_SOME = TDB.find "LGENLIST_SOME"
  fun op LGENLIST_SOME_compute _ = ()
  val op LGENLIST_SOME_compute = TDB.find "LGENLIST_SOME_compute"
  fun op LNTH_LGENLIST _ = ()
  val op LNTH_LGENLIST = TDB.find "LNTH_LGENLIST"
  fun op LNTH_LMAP _ = () val op LNTH_LMAP = TDB.find "LNTH_LMAP"
  fun op LLENGTH_LGENLIST _ = ()
  val op LLENGTH_LGENLIST = TDB.find "LLENGTH_LGENLIST"
  fun op LMAP_LGENLIST _ = ()
  val op LMAP_LGENLIST = TDB.find "LMAP_LGENLIST"
  fun op LGENLIST_EQ_CONS _ = ()
  val op LGENLIST_EQ_CONS = TDB.find "LGENLIST_EQ_CONS"
  fun op LGENLIST_CHUNK_GENLIST _ = ()
  val op LGENLIST_CHUNK_GENLIST = TDB.find "LGENLIST_CHUNK_GENLIST"
  fun op LREPEAT_thm _ = () val op LREPEAT_thm = TDB.find "LREPEAT_thm"
  fun op LREPEAT_NIL _ = () val op LREPEAT_NIL = TDB.find "LREPEAT_NIL"
  fun op LREPEAT_EQ_LNIL _ = ()
  val op LREPEAT_EQ_LNIL = TDB.find "LREPEAT_EQ_LNIL"
  fun op LHD_LREPEAT _ = () val op LHD_LREPEAT = TDB.find "LHD_LREPEAT"
  fun op LTL_LREPEAT _ = () val op LTL_LREPEAT = TDB.find "LTL_LREPEAT"
  fun op LLENGTH_LREPEAT _ = ()
  val op LLENGTH_LREPEAT = TDB.find "LLENGTH_LREPEAT"
  fun op eventually_rules _ = ()
  val op eventually_rules = TDB.find "eventually_rules"
  fun op eventually_ind _ = ()
  val op eventually_ind = TDB.find "eventually_ind"
  fun op eventually_strongind _ = ()
  val op eventually_strongind = TDB.find "eventually_strongind"
  fun op eventually_cases _ = ()
  val op eventually_cases = TDB.find "eventually_cases"
  fun op eventually_thm _ = ()
  val op eventually_thm = TDB.find "eventually_thm"
  fun op always_rules _ = () val op always_rules = TDB.find "always_rules"
  fun op always_coind _ = () val op always_coind = TDB.find "always_coind"
  fun op always_cases _ = () val op always_cases = TDB.find "always_cases"
  fun op always_thm _ = () val op always_thm = TDB.find "always_thm"
  fun op always_conj_l _ = ()
  val op always_conj_l = TDB.find "always_conj_l"
  fun op always_eventually_ind _ = ()
  val op always_eventually_ind = TDB.find "always_eventually_ind"
  fun op always_DROP _ = () val op always_DROP = TDB.find "always_DROP"
  fun op until_rules _ = () val op until_rules = TDB.find "until_rules"
  fun op until_ind _ = () val op until_ind = TDB.find "until_ind"
  fun op until_strongind _ = ()
  val op until_strongind = TDB.find "until_strongind"
  fun op until_cases _ = () val op until_cases = TDB.find "until_cases"
  fun op eventually_until_EQN _ = ()
  val op eventually_until_EQN = TDB.find "eventually_until_EQN"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val llist_grammars = merge_grammars ["set_relation", "indexedLists",
  "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="llist"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val llist_grammars = 
    Portable.## (addtyUDs,addtmUDs) llist_grammars
  val _ = Parse.grammarDB_insert("llist",llist_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "llist"

end
