structure pathTheory :> pathTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading pathTheory ... "
    else ()
  
  open Type Term Thm
  local open fixedPointTheory llistTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "path"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coalgebras/pathTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op path_TY_DEF _ = () val op path_TY_DEF = TDB.find "path_TY_DEF"
  fun op path_absrep_bijections _ = ()
  val op path_absrep_bijections = TDB.find "path_absrep_bijections"
  fun op first_def _ = () val op first_def = TDB.find "first_def"
  fun op stopped_at_def _ = ()
  val op stopped_at_def = TDB.find "stopped_at_def"
  fun op pcons_def _ = () val op pcons_def = TDB.find "pcons_def"
  fun op finite_def _ = () val op finite_def = TDB.find "finite_def"
  fun op last_thm _ = () val op last_thm = TDB.find "last_thm"
  fun op pmap_def _ = () val op pmap_def = TDB.find "pmap_def"
  fun op tail_def _ = () val op tail_def = TDB.find "tail_def"
  fun op first_label_def _ = ()
  val op first_label_def = TDB.find "first_label_def"
  fun op length_def _ = () val op length_def = TDB.find "length_def"
  fun op el_def _ = () val op el_def = TDB.find "el_def"
  fun op nth_label_def _ = ()
  val op nth_label_def = TDB.find "nth_label_def"
  fun op pconcat_def _ = () val op pconcat_def = TDB.find "pconcat_def"
  fun op PL_def _ = () val op PL_def = TDB.find "PL_def"
  fun op firstP_at_def _ = ()
  val op firstP_at_def = TDB.find "firstP_at_def"
  fun op exists_def _ = () val op exists_def = TDB.find "exists_def"
  fun op every_def _ = () val op every_def = TDB.find "every_def"
  fun op mem_def _ = () val op mem_def = TDB.find "mem_def"
  fun op drop_def _ = () val op drop_def = TDB.find "drop_def"
  fun op take_def _ = () val op take_def = TDB.find "take_def"
  fun op seg_def _ = () val op seg_def = TDB.find "seg_def"
  fun op labels_def _ = () val op labels_def = TDB.find "labels_def"
  fun op is_stopped_def _ = ()
  val op is_stopped_def = TDB.find "is_stopped_def"
  fun op filter_def _ = () val op filter_def = TDB.find "filter_def"
  fun op pgenerate_def _ = ()
  val op pgenerate_def = TDB.find "pgenerate_def"
  fun op okpath_f_def _ = () val op okpath_f_def = TDB.find "okpath_f_def"
  fun op okpath_def _ = () val op okpath_def = TDB.find "okpath_def"
  fun op plink_def _ = () val op plink_def = TDB.find "plink_def"
  fun op SN_def _ = () val op SN_def = TDB.find "SN_def"
  fun op unfold_def _ = () val op unfold_def = TDB.find "unfold_def"
  fun op trace_machine_def _ = ()
  val op trace_machine_def = TDB.find "trace_machine_def"
  fun op parallel_comp_def _ = ()
  val op parallel_comp_def = TDB.find "parallel_comp_def"
  fun op path_rep_bijections_thm _ = ()
  val op path_rep_bijections_thm = TDB.find "path_rep_bijections_thm"
  fun op toPath_11 _ = () val op toPath_11 = TDB.find "toPath_11"
  fun op fromPath_11 _ = () val op fromPath_11 = TDB.find "fromPath_11"
  fun op fromPath_onto _ = ()
  val op fromPath_onto = TDB.find "fromPath_onto"
  fun op toPath_onto _ = () val op toPath_onto = TDB.find "toPath_onto"
  fun op stopped_at_11 _ = ()
  val op stopped_at_11 = TDB.find "stopped_at_11"
  fun op pcons_11 _ = () val op pcons_11 = TDB.find "pcons_11"
  fun op stopped_at_not_pcons _ = ()
  val op stopped_at_not_pcons = TDB.find "stopped_at_not_pcons"
  fun op path_cases _ = () val op path_cases = TDB.find "path_cases"
  fun op FORALL_path _ = () val op FORALL_path = TDB.find "FORALL_path"
  fun op EXISTS_path _ = () val op EXISTS_path = TDB.find "EXISTS_path"
  fun op first_thm _ = () val op first_thm = TDB.find "first_thm"
  fun op finite_thm _ = () val op finite_thm = TDB.find "finite_thm"
  fun op path_bisimulation _ = ()
  val op path_bisimulation = TDB.find "path_bisimulation"
  fun op finite_path_ind _ = ()
  val op finite_path_ind = TDB.find "finite_path_ind"
  fun op pmap_thm _ = () val op pmap_thm = TDB.find "pmap_thm"
  fun op first_pmap _ = () val op first_pmap = TDB.find "first_pmap"
  fun op last_pmap _ = () val op last_pmap = TDB.find "last_pmap"
  fun op finite_pmap _ = () val op finite_pmap = TDB.find "finite_pmap"
  fun op length_thm _ = () val op length_thm = TDB.find "length_thm"
  fun op alt_length_thm _ = ()
  val op alt_length_thm = TDB.find "alt_length_thm"
  fun op length_never_zero _ = ()
  val op length_never_zero = TDB.find "length_never_zero"
  fun op finite_length _ = ()
  val op finite_length = TDB.find "finite_length"
  fun op length_pmap _ = () val op length_pmap = TDB.find "length_pmap"
  fun op el_compute _ = () val op el_compute = TDB.find "el_compute"
  fun op nth_label_compute _ = ()
  val op nth_label_compute = TDB.find "nth_label_compute"
  fun op path_Axiom _ = () val op path_Axiom = TDB.find "path_Axiom"
  fun op pconcat_thm _ = () val op pconcat_thm = TDB.find "pconcat_thm"
  fun op pconcat_eq_stopped _ = ()
  val op pconcat_eq_stopped = TDB.find "pconcat_eq_stopped"
  fun op pconcat_eq_pcons _ = ()
  val op pconcat_eq_pcons = TDB.find "pconcat_eq_pcons"
  fun op finite_pconcat _ = ()
  val op finite_pconcat = TDB.find "finite_pconcat"
  fun op infinite_PL _ = () val op infinite_PL = TDB.find "infinite_PL"
  fun op PL_pcons _ = () val op PL_pcons = TDB.find "PL_pcons"
  fun op PL_stopped_at _ = ()
  val op PL_stopped_at = TDB.find "PL_stopped_at"
  fun op PL_thm _ = () val op PL_thm = TDB.find "PL_thm"
  fun op PL_0 _ = () val op PL_0 = TDB.find "PL_0"
  fun op PL_downward_closed _ = ()
  val op PL_downward_closed = TDB.find "PL_downward_closed"
  fun op PL_pmap _ = () val op PL_pmap = TDB.find "PL_pmap"
  fun op el_pmap _ = () val op el_pmap = TDB.find "el_pmap"
  fun op nth_label_pmap _ = ()
  val op nth_label_pmap = TDB.find "nth_label_pmap"
  fun op firstP_at_thm _ = ()
  val op firstP_at_thm = TDB.find "firstP_at_thm"
  fun op firstP_at_zero _ = ()
  val op firstP_at_zero = TDB.find "firstP_at_zero"
  fun op exists_thm _ = () val op exists_thm = TDB.find "exists_thm"
  fun op every_thm _ = () val op every_thm = TDB.find "every_thm"
  fun op not_every _ = () val op not_every = TDB.find "not_every"
  fun op not_exists _ = () val op not_exists = TDB.find "not_exists"
  fun op exists_el _ = () val op exists_el = TDB.find "exists_el"
  fun op every_el _ = () val op every_el = TDB.find "every_el"
  fun op every_coinduction _ = ()
  val op every_coinduction = TDB.find "every_coinduction"
  fun op exists_induction _ = ()
  val op exists_induction = TDB.find "exists_induction"
  fun op mem_thm _ = () val op mem_thm = TDB.find "mem_thm"
  fun op drop_compute _ = () val op drop_compute = TDB.find "drop_compute"
  fun op numeral_drop _ = () val op numeral_drop = TDB.find "numeral_drop"
  fun op finite_drop _ = () val op finite_drop = TDB.find "finite_drop"
  fun op length_drop _ = () val op length_drop = TDB.find "length_drop"
  fun op PL_drop _ = () val op PL_drop = TDB.find "PL_drop"
  fun op IN_PL_drop _ = () val op IN_PL_drop = TDB.find "IN_PL_drop"
  fun op first_drop _ = () val op first_drop = TDB.find "first_drop"
  fun op first_label_drop _ = ()
  val op first_label_drop = TDB.find "first_label_drop"
  fun op tail_drop _ = () val op tail_drop = TDB.find "tail_drop"
  fun op el_drop _ = () val op el_drop = TDB.find "el_drop"
  fun op nth_label_drop _ = ()
  val op nth_label_drop = TDB.find "nth_label_drop"
  fun op take_compute _ = () val op take_compute = TDB.find "take_compute"
  fun op first_take _ = () val op first_take = TDB.find "first_take"
  fun op finite_take _ = () val op finite_take = TDB.find "finite_take"
  fun op length_take _ = () val op length_take = TDB.find "length_take"
  fun op PL_take _ = () val op PL_take = TDB.find "PL_take"
  fun op last_take _ = () val op last_take = TDB.find "last_take"
  fun op nth_label_take _ = ()
  val op nth_label_take = TDB.find "nth_label_take"
  fun op singleton_seg _ = ()
  val op singleton_seg = TDB.find "singleton_seg"
  fun op recursive_seg _ = ()
  val op recursive_seg = TDB.find "recursive_seg"
  fun op PL_seg _ = () val op PL_seg = TDB.find "PL_seg"
  fun op finite_seg _ = () val op finite_seg = TDB.find "finite_seg"
  fun op first_seg _ = () val op first_seg = TDB.find "first_seg"
  fun op last_seg _ = () val op last_seg = TDB.find "last_seg"
  fun op firstP_at_unique _ = ()
  val op firstP_at_unique = TDB.find "firstP_at_unique"
  fun op is_stopped_thm _ = ()
  val op is_stopped_thm = TDB.find "is_stopped_thm"
  fun op filter_every _ = () val op filter_every = TDB.find "filter_every"
  fun op pgenerate_infinite _ = ()
  val op pgenerate_infinite = TDB.find "pgenerate_infinite"
  fun op pgenerate_not_stopped _ = ()
  val op pgenerate_not_stopped = TDB.find "pgenerate_not_stopped"
  fun op el_pgenerate _ = () val op el_pgenerate = TDB.find "el_pgenerate"
  fun op nth_label_pgenerate _ = ()
  val op nth_label_pgenerate = TDB.find "nth_label_pgenerate"
  fun op pgenerate_11 _ = () val op pgenerate_11 = TDB.find "pgenerate_11"
  fun op pgenerate_onto _ = ()
  val op pgenerate_onto = TDB.find "pgenerate_onto"
  fun op okpath_monotone _ = ()
  val op okpath_monotone = TDB.find "okpath_monotone"
  fun op okpath_co_ind _ = ()
  val op okpath_co_ind = TDB.find "okpath_co_ind"
  fun op okpath_cases _ = () val op okpath_cases = TDB.find "okpath_cases"
  fun op okpath_thm _ = () val op okpath_thm = TDB.find "okpath_thm"
  fun op finite_okpath_ind _ = ()
  val op finite_okpath_ind = TDB.find "finite_okpath_ind"
  fun op okpath_pmap _ = () val op okpath_pmap = TDB.find "okpath_pmap"
  fun op finite_plink _ = () val op finite_plink = TDB.find "finite_plink"
  fun op first_plink _ = () val op first_plink = TDB.find "first_plink"
  fun op last_plink _ = () val op last_plink = TDB.find "last_plink"
  fun op okpath_plink _ = () val op okpath_plink = TDB.find "okpath_plink"
  fun op okpath_take _ = () val op okpath_take = TDB.find "okpath_take"
  fun op okpath_drop _ = () val op okpath_drop = TDB.find "okpath_drop"
  fun op okpath_seg _ = () val op okpath_seg = TDB.find "okpath_seg"
  fun op SN_finite_paths _ = ()
  val op SN_finite_paths = TDB.find "SN_finite_paths"
  fun op finite_paths_SN _ = ()
  val op finite_paths_SN = TDB.find "finite_paths_SN"
  fun op SN_finite_paths_EQ _ = ()
  val op SN_finite_paths_EQ = TDB.find "SN_finite_paths_EQ"
  fun op labels_LMAP _ = () val op labels_LMAP = TDB.find "labels_LMAP"
  fun op labels_plink _ = () val op labels_plink = TDB.find "labels_plink"
  fun op finite_labels _ = ()
  val op finite_labels = TDB.find "finite_labels"
  fun op unfold_thm _ = () val op unfold_thm = TDB.find "unfold_thm"
  fun op unfold_thm2 _ = () val op unfold_thm2 = TDB.find "unfold_thm2"
  fun op labels_unfold _ = ()
  val op labels_unfold = TDB.find "labels_unfold"
  fun op okpath_unfold _ = ()
  val op okpath_unfold = TDB.find "okpath_unfold"
  fun op trace_machine_thm _ = ()
  val op trace_machine_thm = TDB.find "trace_machine_thm"
  fun op trace_machine_thm2 _ = ()
  val op trace_machine_thm2 = TDB.find "trace_machine_thm2"
  fun op LTAKE_labels _ = () val op LTAKE_labels = TDB.find "LTAKE_labels"
  fun op drop_eq_pcons _ = ()
  val op drop_eq_pcons = TDB.find "drop_eq_pcons"
  fun op okpath_parallel_comp _ = ()
  val op okpath_parallel_comp = TDB.find "okpath_parallel_comp"
  fun op build_pcomp_trace _ = ()
  val op build_pcomp_trace = TDB.find "build_pcomp_trace"
  fun op nth_label_LNTH _ = ()
  val op nth_label_LNTH = TDB.find "nth_label_LNTH"
  fun op nth_label_LTAKE _ = ()
  val op nth_label_LTAKE = TDB.find "nth_label_LTAKE"
  fun op finite_path_end_cases _ = ()
  val op finite_path_end_cases = TDB.find "finite_path_end_cases"
  fun op simulation_trace_inclusion _ = ()
  val op simulation_trace_inclusion = TDB.find "simulation_trace_inclusion"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val path_grammars = merge_grammars ["llist", "fixedPoint"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="path"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val path_grammars = 
    Portable.## (addtyUDs,addtmUDs) path_grammars
  val _ = Parse.grammarDB_insert("path",path_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "path"

end
