structure combinTheory :> combinTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading combinTheory ... "
    else ()
  
  open Type Term Thm
  local open markerTheory combinpp in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "combin"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/combin/combinTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op K_DEF _ = () val op K_DEF = TDB.find "K_DEF"
  fun op S_DEF _ = () val op S_DEF = TDB.find "S_DEF"
  fun op I_DEF _ = () val op I_DEF = TDB.find "I_DEF"
  fun op C_DEF _ = () val op C_DEF = TDB.find "C_DEF"
  fun op W_DEF _ = () val op W_DEF = TDB.find "W_DEF"
  fun op o_DEF _ = () val op o_DEF = TDB.find "o_DEF"
  fun op APP_DEF _ = () val op APP_DEF = TDB.find "APP_DEF"
  fun op UPDATE_def _ = () val op UPDATE_def = TDB.find "UPDATE_def"
  fun op ASSOC_DEF _ = () val op ASSOC_DEF = TDB.find "ASSOC_DEF"
  fun op COMM_DEF _ = () val op COMM_DEF = TDB.find "COMM_DEF"
  fun op FCOMM_DEF _ = () val op FCOMM_DEF = TDB.find "FCOMM_DEF"
  fun op RIGHT_ID_DEF _ = () val op RIGHT_ID_DEF = TDB.find "RIGHT_ID_DEF"
  fun op LEFT_ID_DEF _ = () val op LEFT_ID_DEF = TDB.find "LEFT_ID_DEF"
  fun op MONOID_DEF _ = () val op MONOID_DEF = TDB.find "MONOID_DEF"
  fun op FAIL_DEF _ = () val op FAIL_DEF = TDB.find "FAIL_DEF"
  fun op o_THM _ = () val op o_THM = TDB.find "o_THM"
  fun op o_ASSOC _ = () val op o_ASSOC = TDB.find "o_ASSOC"
  fun op o_ABS_L _ = () val op o_ABS_L = TDB.find "o_ABS_L"
  fun op o_ABS_R _ = () val op o_ABS_R = TDB.find "o_ABS_R"
  fun op K_THM _ = () val op K_THM = TDB.find "K_THM"
  fun op S_THM _ = () val op S_THM = TDB.find "S_THM"
  fun op S_ABS_L _ = () val op S_ABS_L = TDB.find "S_ABS_L"
  fun op S_ABS_R _ = () val op S_ABS_R = TDB.find "S_ABS_R"
  fun op C_THM _ = () val op C_THM = TDB.find "C_THM"
  fun op C_ABS_L _ = () val op C_ABS_L = TDB.find "C_ABS_L"
  fun op W_THM _ = () val op W_THM = TDB.find "W_THM"
  fun op I_THM _ = () val op I_THM = TDB.find "I_THM"
  fun op I_o_ID _ = () val op I_o_ID = TDB.find "I_o_ID"
  fun op K_o_THM _ = () val op K_o_THM = TDB.find "K_o_THM"
  fun op UPDATE_APPLY _ = () val op UPDATE_APPLY = TDB.find "UPDATE_APPLY"
  fun op APPLY_UPDATE_THM _ = ()
  val op APPLY_UPDATE_THM = TDB.find "APPLY_UPDATE_THM"
  fun op UPDATE_COMMUTES _ = ()
  val op UPDATE_COMMUTES = TDB.find "UPDATE_COMMUTES"
  fun op UPDATE_EQ _ = () val op UPDATE_EQ = TDB.find "UPDATE_EQ"
  fun op UPDATE_APPLY_ID _ = ()
  val op UPDATE_APPLY_ID = TDB.find "UPDATE_APPLY_ID"
  fun op UPDATE_APPLY_IMP_ID _ = ()
  val op UPDATE_APPLY_IMP_ID = TDB.find "UPDATE_APPLY_IMP_ID"
  fun op APPLY_UPDATE_ID _ = ()
  val op APPLY_UPDATE_ID = TDB.find "APPLY_UPDATE_ID"
  fun op UPD11_SAME_BASE _ = ()
  val op UPD11_SAME_BASE = TDB.find "UPD11_SAME_BASE"
  fun op SAME_KEY_UPDATE_DIFFER _ = ()
  val op SAME_KEY_UPDATE_DIFFER = TDB.find "SAME_KEY_UPDATE_DIFFER"
  fun op UPD11_SAME_KEY_AND_BASE _ = ()
  val op UPD11_SAME_KEY_AND_BASE = TDB.find "UPD11_SAME_KEY_AND_BASE"
  fun op UPD_SAME_KEY_UNWIND _ = ()
  val op UPD_SAME_KEY_UNWIND = TDB.find "UPD_SAME_KEY_UNWIND"
  fun op GEN_LET_RAND _ = () val op GEN_LET_RAND = TDB.find "GEN_LET_RAND"
  fun op GEN_LET_RATOR _ = ()
  val op GEN_LET_RATOR = TDB.find "GEN_LET_RATOR"
  fun op LET_FORALL_ELIM _ = ()
  val op LET_FORALL_ELIM = TDB.find "LET_FORALL_ELIM"
  fun op GEN_literal_case_RAND _ = ()
  val op GEN_literal_case_RAND = TDB.find "GEN_literal_case_RAND"
  fun op GEN_literal_case_RATOR _ = ()
  val op GEN_literal_case_RATOR = TDB.find "GEN_literal_case_RATOR"
  fun op literal_case_FORALL_ELIM _ = ()
  val op literal_case_FORALL_ELIM = TDB.find "literal_case_FORALL_ELIM"
  fun op ASSOC_CONJ _ = () val op ASSOC_CONJ = TDB.find "ASSOC_CONJ"
  fun op ASSOC_SYM _ = () val op ASSOC_SYM = TDB.find "ASSOC_SYM"
  fun op ASSOC_DISJ _ = () val op ASSOC_DISJ = TDB.find "ASSOC_DISJ"
  fun op FCOMM_ASSOC _ = () val op FCOMM_ASSOC = TDB.find "FCOMM_ASSOC"
  fun op MONOID_CONJ_T _ = ()
  val op MONOID_CONJ_T = TDB.find "MONOID_CONJ_T"
  fun op MONOID_DISJ_F _ = ()
  val op MONOID_DISJ_F = TDB.find "MONOID_DISJ_F"
  fun op FAIL_THM _ = () val op FAIL_THM = TDB.find "FAIL_THM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val combin_grammars = merge_grammars ["marker"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="combin"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val combin_grammars = 
    Portable.## (addtyUDs,addtmUDs) combin_grammars
  val _ = Parse.grammarDB_insert("combin",combin_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ =
    let open computeLib
        val K_tm = Term.prim_mk_const{Name="K",Thy="combin"}
    in
        add_funs
          [K_THM,S_DEF,I_THM,C_DEF,W_DEF,o_THM,K_o_THM,APP_DEF,
           APPLY_UPDATE_THM];
        set_skip the_compset K_tm (SOME 1)
    end;
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "combin"

end
