structure oneTheory :> oneTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading oneTheory ... "
    else ()
  
  open Type Term Thm
  local open combinTheory satTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "one"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coretypes/oneTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op one_TY_DEF _ = () val op one_TY_DEF = TDB.find "one_TY_DEF"
  fun op one_DEF _ = () val op one_DEF = TDB.find "one_DEF"
  fun op one_case_def _ = () val op one_case_def = TDB.find "one_case_def"
  fun op one_axiom _ = () val op one_axiom = TDB.find "one_axiom"
  fun op one _ = () val op one = TDB.find "one"
  fun op one_Axiom _ = () val op one_Axiom = TDB.find "one_Axiom"
  fun op one_prim_rec _ = () val op one_prim_rec = TDB.find "one_prim_rec"
  fun op one_induction _ = ()
  val op one_induction = TDB.find "one_induction"
  fun op FORALL_ONE _ = () val op FORALL_ONE = TDB.find "FORALL_ONE"
  fun op one_case_thm _ = () val op one_case_thm = TDB.find "one_case_thm"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val one_grammars = merge_grammars ["sat", "combin"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="one"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val one_grammars = 
    Portable.## (addtyUDs,addtmUDs) one_grammars
  val _ = Parse.grammarDB_insert("one",one_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "one"

end
