structure optionTheory :> optionTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading optionTheory ... "
    else ()
  
  open Type Term Thm
  local open oneTheory relationTheory sumTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "option"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coretypes/optionTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op option_TY_DEF _ = ()
  val op option_TY_DEF = TDB.find "option_TY_DEF"
  fun op option_REP_ABS_DEF _ = ()
  val op option_REP_ABS_DEF = TDB.find "option_REP_ABS_DEF"
  fun op SOME_DEF _ = () val op SOME_DEF = TDB.find "SOME_DEF"
  fun op NONE_DEF _ = () val op NONE_DEF = TDB.find "NONE_DEF"
  fun op option_case_def _ = ()
  val op option_case_def = TDB.find "option_case_def"
  fun op OPTION_MAP_DEF _ = ()
  val op OPTION_MAP_DEF = TDB.find "OPTION_MAP_DEF"
  fun op IS_SOME_DEF _ = () val op IS_SOME_DEF = TDB.find "IS_SOME_DEF"
  fun op IS_NONE_DEF _ = () val op IS_NONE_DEF = TDB.find "IS_NONE_DEF"
  fun op THE_DEF _ = () val op THE_DEF = TDB.find "THE_DEF"
  fun op OPTION_MAP2_DEF _ = ()
  val op OPTION_MAP2_DEF = TDB.find "OPTION_MAP2_DEF"
  fun op OPTION_JOIN_DEF _ = ()
  val op OPTION_JOIN_DEF = TDB.find "OPTION_JOIN_DEF"
  fun op OPTION_BIND_def _ = ()
  val op OPTION_BIND_def = TDB.find "OPTION_BIND_def"
  fun op OPTION_IGNORE_BIND_def _ = ()
  val op OPTION_IGNORE_BIND_def = TDB.find "OPTION_IGNORE_BIND_def"
  fun op OPTION_GUARD_def _ = ()
  val op OPTION_GUARD_def = TDB.find "OPTION_GUARD_def"
  fun op OPTION_CHOICE_def _ = ()
  val op OPTION_CHOICE_def = TDB.find "OPTION_CHOICE_def"
  fun op OPTION_MCOMP_def _ = ()
  val op OPTION_MCOMP_def = TDB.find "OPTION_MCOMP_def"
  fun op OPTION_APPLY_def _ = ()
  val op OPTION_APPLY_def = TDB.find "OPTION_APPLY_def"
  fun op OPTREL_def _ = () val op OPTREL_def = TDB.find "OPTREL_def"
  fun op some_def _ = () val op some_def = TDB.find "some_def"
  fun op OPTION_ALL_def _ = ()
  val op OPTION_ALL_def = TDB.find "OPTION_ALL_def"
  fun op option_Axiom _ = () val op option_Axiom = TDB.find "option_Axiom"
  fun op option_induction _ = ()
  val op option_induction = TDB.find "option_induction"
  fun op option_nchotomy _ = ()
  val op option_nchotomy = TDB.find "option_nchotomy"
  fun op FORALL_OPTION _ = ()
  val op FORALL_OPTION = TDB.find "FORALL_OPTION"
  fun op EXISTS_OPTION _ = ()
  val op EXISTS_OPTION = TDB.find "EXISTS_OPTION"
  fun op SOME_11 _ = () val op SOME_11 = TDB.find "SOME_11"
  fun op NOT_NONE_SOME _ = ()
  val op NOT_NONE_SOME = TDB.find "NOT_NONE_SOME"
  fun op NOT_SOME_NONE _ = ()
  val op NOT_SOME_NONE = TDB.find "NOT_SOME_NONE"
  fun op OPTION_MAP2_THM _ = ()
  val op OPTION_MAP2_THM = TDB.find "OPTION_MAP2_THM"
  fun op IS_SOME_EXISTS _ = ()
  val op IS_SOME_EXISTS = TDB.find "IS_SOME_EXISTS"
  fun op IS_NONE_EQ_NONE _ = ()
  val op IS_NONE_EQ_NONE = TDB.find "IS_NONE_EQ_NONE"
  fun op NOT_IS_SOME_EQ_NONE _ = ()
  val op NOT_IS_SOME_EQ_NONE = TDB.find "NOT_IS_SOME_EQ_NONE"
  fun op option_case_ID _ = ()
  val op option_case_ID = TDB.find "option_case_ID"
  fun op option_case_SOME_ID _ = ()
  val op option_case_SOME_ID = TDB.find "option_case_SOME_ID"
  fun op option_CLAUSES _ = ()
  val op option_CLAUSES = TDB.find "option_CLAUSES"
  fun op option_case_compute _ = ()
  val op option_case_compute = TDB.find "option_case_compute"
  fun op IF_EQUALS_OPTION _ = ()
  val op IF_EQUALS_OPTION = TDB.find "IF_EQUALS_OPTION"
  fun op IF_NONE_EQUALS_OPTION _ = ()
  val op IF_NONE_EQUALS_OPTION = TDB.find "IF_NONE_EQUALS_OPTION"
  fun op OPTION_MAP_EQ_SOME _ = ()
  val op OPTION_MAP_EQ_SOME = TDB.find "OPTION_MAP_EQ_SOME"
  fun op OPTION_MAP_EQ_NONE _ = ()
  val op OPTION_MAP_EQ_NONE = TDB.find "OPTION_MAP_EQ_NONE"
  fun op OPTION_MAP_EQ_NONE_both_ways _ = ()
  val op OPTION_MAP_EQ_NONE_both_ways = TDB.find
    "OPTION_MAP_EQ_NONE_both_ways"
  fun op OPTION_MAP_COMPOSE _ = ()
  val op OPTION_MAP_COMPOSE = TDB.find "OPTION_MAP_COMPOSE"
  fun op OPTION_MAP_CONG _ = ()
  val op OPTION_MAP_CONG = TDB.find "OPTION_MAP_CONG"
  fun op IS_SOME_MAP _ = () val op IS_SOME_MAP = TDB.find "IS_SOME_MAP"
  fun op OPTION_JOIN_EQ_SOME _ = ()
  val op OPTION_JOIN_EQ_SOME = TDB.find "OPTION_JOIN_EQ_SOME"
  fun op OPTION_MAP2_SOME _ = ()
  val op OPTION_MAP2_SOME = TDB.find "OPTION_MAP2_SOME"
  fun op OPTION_MAP2_NONE _ = ()
  val op OPTION_MAP2_NONE = TDB.find "OPTION_MAP2_NONE"
  fun op OPTION_MAP2_cong _ = ()
  val op OPTION_MAP2_cong = TDB.find "OPTION_MAP2_cong"
  fun op OPTION_MAP_CASE _ = ()
  val op OPTION_MAP_CASE = TDB.find "OPTION_MAP_CASE"
  fun op OPTION_BIND_cong _ = ()
  val op OPTION_BIND_cong = TDB.find "OPTION_BIND_cong"
  fun op OPTION_BIND_EQUALS_OPTION _ = ()
  val op OPTION_BIND_EQUALS_OPTION = TDB.find "OPTION_BIND_EQUALS_OPTION"
  fun op IS_SOME_BIND _ = () val op IS_SOME_BIND = TDB.find "IS_SOME_BIND"
  fun op OPTION_BIND_SOME _ = ()
  val op OPTION_BIND_SOME = TDB.find "OPTION_BIND_SOME"
  fun op OPTION_IGNORE_BIND_thm _ = ()
  val op OPTION_IGNORE_BIND_thm = TDB.find "OPTION_IGNORE_BIND_thm"
  fun op OPTION_IGNORE_BIND_EQUALS_OPTION _ = ()
  val op OPTION_IGNORE_BIND_EQUALS_OPTION = TDB.find
    "OPTION_IGNORE_BIND_EQUALS_OPTION"
  fun op OPTION_GUARD_COND _ = ()
  val op OPTION_GUARD_COND = TDB.find "OPTION_GUARD_COND"
  fun op OPTION_GUARD_EQ_THM _ = ()
  val op OPTION_GUARD_EQ_THM = TDB.find "OPTION_GUARD_EQ_THM"
  fun op OPTION_CHOICE_EQ_NONE _ = ()
  val op OPTION_CHOICE_EQ_NONE = TDB.find "OPTION_CHOICE_EQ_NONE"
  fun op OPTION_CHOICE_NONE _ = ()
  val op OPTION_CHOICE_NONE = TDB.find "OPTION_CHOICE_NONE"
  fun op OPTION_MCOMP_ASSOC _ = ()
  val op OPTION_MCOMP_ASSOC = TDB.find "OPTION_MCOMP_ASSOC"
  fun op OPTION_MCOMP_ID _ = ()
  val op OPTION_MCOMP_ID = TDB.find "OPTION_MCOMP_ID"
  fun op OPTION_APPLY_MAP2 _ = ()
  val op OPTION_APPLY_MAP2 = TDB.find "OPTION_APPLY_MAP2"
  fun op SOME_SOME_APPLY _ = ()
  val op SOME_SOME_APPLY = TDB.find "SOME_SOME_APPLY"
  fun op SOME_APPLY_PERMUTE _ = ()
  val op SOME_APPLY_PERMUTE = TDB.find "SOME_APPLY_PERMUTE"
  fun op OPTION_APPLY_o _ = ()
  val op OPTION_APPLY_o = TDB.find "OPTION_APPLY_o"
  fun op OPTREL_MONO _ = () val op OPTREL_MONO = TDB.find "OPTREL_MONO"
  fun op OPTREL_refl _ = () val op OPTREL_refl = TDB.find "OPTREL_refl"
  fun op OPTREL_eq _ = () val op OPTREL_eq = TDB.find "OPTREL_eq"
  fun op OPTREL_SOME _ = () val op OPTREL_SOME = TDB.find "OPTREL_SOME"
  fun op OPTREL_O _ = () val op OPTREL_O = TDB.find "OPTREL_O"
  fun op some_intro _ = () val op some_intro = TDB.find "some_intro"
  fun op some_elim _ = () val op some_elim = TDB.find "some_elim"
  fun op some_F _ = () val op some_F = TDB.find "some_F"
  fun op some_EQ _ = () val op some_EQ = TDB.find "some_EQ"
  fun op option_case_cong _ = ()
  val op option_case_cong = TDB.find "option_case_cong"
  fun op OPTION_ALL_MONO _ = ()
  val op OPTION_ALL_MONO = TDB.find "OPTION_ALL_MONO"
  fun op OPTION_ALL_CONG _ = ()
  val op OPTION_ALL_CONG = TDB.find "OPTION_ALL_CONG"
  fun op option_case_eq _ = ()
  val op option_case_eq = TDB.find "option_case_eq"
  fun op option_Induct _ = ()
  val op option_Induct = TDB.find "option_Induct"
  fun op option_CASES _ = () val op option_CASES = TDB.find "option_CASES"
  fun op datatype_option _ = ()
  val op datatype_option = TDB.find "datatype_option"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val option_grammars = merge_grammars ["sum", "one", "relation"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="option"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val option_grammars = 
    Portable.## (addtyUDs,addtmUDs) option_grammars
  val _ = Parse.grammarDB_insert("option",option_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ = let open computeLib
          in add_funs (map lazyfy_thm
                 [NOT_NONE_SOME,NOT_SOME_NONE,SOME_11,
                  option_case_def, 
                  IS_SOME_DEF,IS_NONE_DEF,THE_DEF,
                  OPTION_JOIN_DEF])
          end;
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "option"

end
