structure pairTheory :> pairTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading pairTheory ... "
    else ()
  
  open Type Term Thm
  local open relationTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "pair"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coretypes/pairTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op prod_TY_DEF _ = () val op prod_TY_DEF = TDB.find "prod_TY_DEF"
  fun op ABS_REP_prod _ = () val op ABS_REP_prod = TDB.find "ABS_REP_prod"
  fun op COMMA_DEF _ = () val op COMMA_DEF = TDB.find "COMMA_DEF"
  fun op PAIR _ = () val op PAIR = TDB.find "PAIR"
  fun op SWAP_def _ = () val op SWAP_def = TDB.find "SWAP_def"
  fun op CURRY_DEF _ = () val op CURRY_DEF = TDB.find "CURRY_DEF"
  fun op UNCURRY _ = () val op UNCURRY = TDB.find "UNCURRY"
  fun op PROD_ALL_def _ = () val op PROD_ALL_def = TDB.find "PROD_ALL_def"
  fun op PAIR_MAP _ = () val op PAIR_MAP = TDB.find "PAIR_MAP"
  fun op pair_CASE_def _ = ()
  val op pair_CASE_def = TDB.find "pair_CASE_def"
  fun op LEX_DEF _ = () val op LEX_DEF = TDB.find "LEX_DEF"
  fun op RPROD_DEF _ = () val op RPROD_DEF = TDB.find "RPROD_DEF"
  fun op PAIR_EQ _ = () val op PAIR_EQ = TDB.find "PAIR_EQ"
  fun op CLOSED_PAIR_EQ _ = ()
  val op CLOSED_PAIR_EQ = TDB.find "CLOSED_PAIR_EQ"
  fun op ABS_PAIR_THM _ = () val op ABS_PAIR_THM = TDB.find "ABS_PAIR_THM"
  fun op pair_CASES _ = () val op pair_CASES = TDB.find "pair_CASES"
  fun op FST _ = () val op FST = TDB.find "FST"
  fun op SND _ = () val op SND = TDB.find "SND"
  fun op PAIR_FST_SND_EQ _ = ()
  val op PAIR_FST_SND_EQ = TDB.find "PAIR_FST_SND_EQ"
  fun op UNCURRY_VAR _ = () val op UNCURRY_VAR = TDB.find "UNCURRY_VAR"
  fun op ELIM_UNCURRY _ = () val op ELIM_UNCURRY = TDB.find "ELIM_UNCURRY"
  fun op UNCURRY_DEF _ = () val op UNCURRY_DEF = TDB.find "UNCURRY_DEF"
  fun op CURRY_UNCURRY_THM _ = ()
  val op CURRY_UNCURRY_THM = TDB.find "CURRY_UNCURRY_THM"
  fun op UNCURRY_CURRY_THM _ = ()
  val op UNCURRY_CURRY_THM = TDB.find "UNCURRY_CURRY_THM"
  fun op CURRY_ONE_ONE_THM _ = ()
  val op CURRY_ONE_ONE_THM = TDB.find "CURRY_ONE_ONE_THM"
  fun op UNCURRY_ONE_ONE_THM _ = ()
  val op UNCURRY_ONE_ONE_THM = TDB.find "UNCURRY_ONE_ONE_THM"
  fun op pair_Axiom _ = () val op pair_Axiom = TDB.find "pair_Axiom"
  fun op UNCURRY_CONG _ = () val op UNCURRY_CONG = TDB.find "UNCURRY_CONG"
  fun op LAMBDA_PROD _ = () val op LAMBDA_PROD = TDB.find "LAMBDA_PROD"
  fun op EXISTS_PROD _ = () val op EXISTS_PROD = TDB.find "EXISTS_PROD"
  fun op FORALL_PROD _ = () val op FORALL_PROD = TDB.find "FORALL_PROD"
  fun op pair_induction _ = ()
  val op pair_induction = TDB.find "pair_induction"
  fun op PROD_ALL_THM _ = () val op PROD_ALL_THM = TDB.find "PROD_ALL_THM"
  fun op PROD_ALL_MONO _ = ()
  val op PROD_ALL_MONO = TDB.find "PROD_ALL_MONO"
  fun op PROD_ALL_CONG _ = ()
  val op PROD_ALL_CONG = TDB.find "PROD_ALL_CONG"
  fun op ELIM_PEXISTS _ = () val op ELIM_PEXISTS = TDB.find "ELIM_PEXISTS"
  fun op ELIM_PFORALL _ = () val op ELIM_PFORALL = TDB.find "ELIM_PFORALL"
  fun op PFORALL_THM _ = () val op PFORALL_THM = TDB.find "PFORALL_THM"
  fun op PEXISTS_THM _ = () val op PEXISTS_THM = TDB.find "PEXISTS_THM"
  fun op ELIM_PEXISTS_EVAL _ = ()
  val op ELIM_PEXISTS_EVAL = TDB.find "ELIM_PEXISTS_EVAL"
  fun op ELIM_PFORALL_EVAL _ = ()
  val op ELIM_PFORALL_EVAL = TDB.find "ELIM_PFORALL_EVAL"
  fun op PAIR_MAP_THM _ = () val op PAIR_MAP_THM = TDB.find "PAIR_MAP_THM"
  fun op FST_PAIR_MAP _ = () val op FST_PAIR_MAP = TDB.find "FST_PAIR_MAP"
  fun op SND_PAIR_MAP _ = () val op SND_PAIR_MAP = TDB.find "SND_PAIR_MAP"
  fun op LET2_RAND _ = () val op LET2_RAND = TDB.find "LET2_RAND"
  fun op LET2_RATOR _ = () val op LET2_RATOR = TDB.find "LET2_RATOR"
  fun op o_UNCURRY_R _ = () val op o_UNCURRY_R = TDB.find "o_UNCURRY_R"
  fun op C_UNCURRY_L _ = () val op C_UNCURRY_L = TDB.find "C_UNCURRY_L"
  fun op S_UNCURRY_R _ = () val op S_UNCURRY_R = TDB.find "S_UNCURRY_R"
  fun op FORALL_UNCURRY _ = ()
  val op FORALL_UNCURRY = TDB.find "FORALL_UNCURRY"
  fun op PAIR_FUN_THM _ = () val op PAIR_FUN_THM = TDB.find "PAIR_FUN_THM"
  fun op pair_case_thm _ = ()
  val op pair_case_thm = TDB.find "pair_case_thm"
  fun op pair_case_def _ = ()
  val op pair_case_def = TDB.find "pair_case_def"
  fun op pair_case_cong _ = ()
  val op pair_case_cong = TDB.find "pair_case_cong"
  fun op pair_case_eq _ = () val op pair_case_eq = TDB.find "pair_case_eq"
  fun op datatype_pair _ = ()
  val op datatype_pair = TDB.find "datatype_pair"
  fun op LEX_DEF_THM _ = () val op LEX_DEF_THM = TDB.find "LEX_DEF_THM"
  fun op LEX_MONO _ = () val op LEX_MONO = TDB.find "LEX_MONO"
  fun op WF_LEX _ = () val op WF_LEX = TDB.find "WF_LEX"
  fun op WF_RPROD _ = () val op WF_RPROD = TDB.find "WF_RPROD"
  fun op total_LEX _ = () val op total_LEX = TDB.find "total_LEX"
  fun op transitive_LEX _ = ()
  val op transitive_LEX = TDB.find "transitive_LEX"
  fun op reflexive_LEX _ = ()
  val op reflexive_LEX = TDB.find "reflexive_LEX"
  fun op symmetric_LEX _ = ()
  val op symmetric_LEX = TDB.find "symmetric_LEX"
  fun op LEX_CONG _ = () val op LEX_CONG = TDB.find "LEX_CONG"
  fun op FST_EQ_EQUIV _ = () val op FST_EQ_EQUIV = TDB.find "FST_EQ_EQUIV"
  fun op SND_EQ_EQUIV _ = () val op SND_EQ_EQUIV = TDB.find "SND_EQ_EQUIV"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val pair_grammars = merge_grammars ["relation"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="pair"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val pair_grammars = 
    Portable.## (addtyUDs,addtmUDs) pair_grammars
  val _ = Parse.grammarDB_insert("pair",pair_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val pair_rws = [PAIR, FST, SND];
  
  val _ = let open computeLib
          in add_funs (map lazyfy_thm
                [CLOSED_PAIR_EQ,FST,SND,pair_case_thm,SWAP_def,
                 CURRY_DEF,UNCURRY_DEF,PAIR_MAP_THM])
          end;
  
  
  (*---------------------------------------------------------------
         Support for definitions using varstructs
  ----------------------------------------------------------------*)
  
  open HolKernel boolLib;
  infix |-> ORELSEC THENC;
  
  val ERR1 = mk_HOL_ERR "pairSyntax"
  val ERR2 = mk_HOL_ERR "PairedLambda"
  val ERR3 = mk_HOL_ERR "pairTheory.dest"
  
  val comma_tm = prim_mk_const {Name=",", Thy="pair"};
  val uncurry_tm = prim_mk_const {Name="UNCURRY", Thy="pair"};
  
  val dest_pair = dest_binop comma_tm (ERR1 "dest_pair" "not a pair")
  val strip_pair = strip_binop (total dest_pair);
  val spine_pair = spine_binop (total dest_pair);
  
  local fun check [] = true
          | check (h::t) = is_var h andalso not(tmem h t) andalso check t
  in
  fun is_vstruct M = check (strip_pair M)end;
  
  fun mk_uncurry_tm(xt,yt,zt) = 
    inst [alpha |-> xt, beta |-> yt, gamma |-> zt] uncurry_tm;
  
  
  fun mk_pabs(vstruct,body) =
    if is_var vstruct then Term.mk_abs(vstruct, body)
    else let val (fst,snd) = dest_pair vstruct
         in mk_comb(mk_uncurry_tm(type_of fst, type_of snd, type_of body),
                    mk_pabs(fst,mk_pabs(snd,body)))
         end handle HOL_ERR _ => raise ERR1 "mk_pabs" "";
  
  
  local val vs = map genvar [alpha --> beta --> gamma, alpha, beta]
        val DEF = SPECL vs UNCURRY_DEF
        val RBCONV = RATOR_CONV BETA_CONV THENC BETA_CONV
        fun conv tm = 
         let val (Rator,Rand) = dest_comb tm
             val (fst,snd) = dest_pair Rand
             val (Rator,f) = dest_comb Rator
             val _ = assert (same_const uncurry_tm) Rator
             val (t1,ty') = dom_rng (type_of f)
             val (t2,t3) = dom_rng ty'
             val iDEF = INST_TYPE [alpha |-> t1, beta |-> t2, gamma |-> t3] DEF
             val (fv,xyv) = strip_comb(rand(concl iDEF))
             val xv = hd xyv and yv = hd (tl xyv)
             val def = INST [yv |-> snd, xv |-> fst, fv |-> f] iDEF
         in
           TRANS def 
            (if Term.is_abs f 
             then if Term.is_abs (body f) 
                  then RBCONV (rhs(concl def))
                  else CONV_RULE (RAND_CONV conv)
                        (AP_THM(BETA_CONV(mk_comb(f, fst))) snd)
             else let val recc = conv (rator(rand(concl def)))
                  in if Term.is_abs (rhs(concl recc))
                     then RIGHT_BETA (AP_THM recc snd)
                     else TRANS (AP_THM recc snd) 
                             (conv(mk_comb(rhs(concl recc), snd)))
                  end)
         end
  in
  fun PAIRED_BETA_CONV tm 
      = conv tm handle HOL_ERR _ => raise ERR2 "PAIRED_BETA_CONV" ""
  end;
  
  
  (*---------------------------------------------------------------------------
       Lifting primitive definition principle to understand varstruct
       arguments in definitions.
   ---------------------------------------------------------------------------*)
  
  fun inter s1 [] = []
    | inter s1 (h::t) = case op_intersect aconv s1 h of [] => inter s1 t | X => X
  
  fun joint_vars []  = []
    | joint_vars [_] = []
    | joint_vars (h::t) = case inter h t of [] => joint_vars t | X => X;
  
  fun dest t = 
    let val (lhs,rhs) = dest_eq (snd(strip_forall t))
        val (f,args) = strip_comb lhs
        val f = mk_var(dest_const f) handle HOL_ERR _ => f
    in 
    case filter (not o is_vstruct) args 
     of [] => (case joint_vars (map free_vars args)
                of [] => (args, mk_eq(f,itlist (curry mk_pabs) args rhs))
                 | V  => raise ERR3 "new_definition" (String.concat
                         ("shared variables between arguments: " ::
                          commafy (map Parse.term_to_string V))))
      | tml => raise ERR3 "new_definition" (String.concat
               ("The following arguments are not varstructs: "::
                commafy (map Parse.term_to_string tml)))
    end;
  
  fun RHS_CONV conv th = TRANS th (conv(rhs(concl th)));
  
  fun add_varstruct v th = 
    RHS_CONV(BETA_CONV ORELSEC PAIRED_BETA_CONV) (AP_THM th v)
  
  fun post (V,th) =
    let val vars = List.concat (map free_vars_lr V)
    in
      itlist GEN vars (rev_itlist add_varstruct V th)
    end;
    
  val _ = Definition.new_definition_hook := (dest, post)
  
  
  val _ = BasicProvers.new_let_thms[o_UNCURRY_R, C_UNCURRY_L, S_UNCURRY_R, FORALL_UNCURRY]
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "pair"

end
