structure posetTheory :> posetTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading posetTheory ... "
    else ()
  
  open Type Term Thm
  local open pairTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "poset"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coretypes/posetTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op function_def _ = () val op function_def = TDB.find "function_def"
  fun op poset_def _ = () val op poset_def = TDB.find "poset_def"
  fun op carrier_def _ = () val op carrier_def = TDB.find "carrier_def"
  fun op relation_def _ = () val op relation_def = TDB.find "relation_def"
  fun op top_def _ = () val op top_def = TDB.find "top_def"
  fun op bottom_def _ = () val op bottom_def = TDB.find "bottom_def"
  fun op chain_def _ = () val op chain_def = TDB.find "chain_def"
  fun op lub_def _ = () val op lub_def = TDB.find "lub_def"
  fun op glb_def _ = () val op glb_def = TDB.find "glb_def"
  fun op complete_def _ = () val op complete_def = TDB.find "complete_def"
  fun op pointwise_lift_def _ = ()
  val op pointwise_lift_def = TDB.find "pointwise_lift_def"
  fun op monotonic_def _ = ()
  val op monotonic_def = TDB.find "monotonic_def"
  fun op up_continuous_def _ = ()
  val op up_continuous_def = TDB.find "up_continuous_def"
  fun op down_continuous_def _ = ()
  val op down_continuous_def = TDB.find "down_continuous_def"
  fun op continuous_def _ = ()
  val op continuous_def = TDB.find "continuous_def"
  fun op lfp_def _ = () val op lfp_def = TDB.find "lfp_def"
  fun op gfp_def _ = () val op gfp_def = TDB.find "gfp_def"
  fun op poset_nonempty _ = ()
  val op poset_nonempty = TDB.find "poset_nonempty"
  fun op poset_refl _ = () val op poset_refl = TDB.find "poset_refl"
  fun op poset_antisym _ = ()
  val op poset_antisym = TDB.find "poset_antisym"
  fun op poset_trans _ = () val op poset_trans = TDB.find "poset_trans"
  fun op lub_pred _ = () val op lub_pred = TDB.find "lub_pred"
  fun op glb_pred _ = () val op glb_pred = TDB.find "glb_pred"
  fun op complete_up _ = () val op complete_up = TDB.find "complete_up"
  fun op complete_down _ = ()
  val op complete_down = TDB.find "complete_down"
  fun op complete_top _ = () val op complete_top = TDB.find "complete_top"
  fun op complete_bottom _ = ()
  val op complete_bottom = TDB.find "complete_bottom"
  fun op complete_pointwise _ = ()
  val op complete_pointwise = TDB.find "complete_pointwise"
  fun op lfp_unique _ = () val op lfp_unique = TDB.find "lfp_unique"
  fun op gfp_unique _ = () val op gfp_unique = TDB.find "gfp_unique"
  fun op knaster_tarski_lfp _ = ()
  val op knaster_tarski_lfp = TDB.find "knaster_tarski_lfp"
  fun op knaster_tarski_gfp _ = ()
  val op knaster_tarski_gfp = TDB.find "knaster_tarski_gfp"
  fun op knaster_tarski _ = ()
  val op knaster_tarski = TDB.find "knaster_tarski"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val poset_grammars = merge_grammars ["pair"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="poset"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val poset_grammars = 
    Portable.## (addtyUDs,addtmUDs) poset_grammars
  val _ = Parse.grammarDB_insert("poset",poset_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "poset"

end
