structure sumTheory :> sumTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading sumTheory ... "
    else ()
  
  open Type Term Thm
  local open combinTheory satTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "sum"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/coretypes/sumTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op IS_SUM_REP _ = () val op IS_SUM_REP = TDB.find "IS_SUM_REP"
  fun op sum_TY_DEF _ = () val op sum_TY_DEF = TDB.find "sum_TY_DEF"
  fun op sum_ISO_DEF _ = () val op sum_ISO_DEF = TDB.find "sum_ISO_DEF"
  fun op INL_DEF _ = () val op INL_DEF = TDB.find "INL_DEF"
  fun op INR_DEF _ = () val op INR_DEF = TDB.find "INR_DEF"
  fun op ISL _ = () val op ISL = TDB.find "ISL"
  fun op ISR _ = () val op ISR = TDB.find "ISR"
  fun op OUTL _ = () val op OUTL = TDB.find "OUTL"
  fun op OUTR _ = () val op OUTR = TDB.find "OUTR"
  fun op sum_case_def _ = () val op sum_case_def = TDB.find "sum_case_def"
  fun op SUM_MAP_def _ = () val op SUM_MAP_def = TDB.find "SUM_MAP_def"
  fun op SUM_ALL_def _ = () val op SUM_ALL_def = TDB.find "SUM_ALL_def"
  fun op INL_11 _ = () val op INL_11 = TDB.find "INL_11"
  fun op INR_11 _ = () val op INR_11 = TDB.find "INR_11"
  fun op INR_INL_11 _ = () val op INR_INL_11 = TDB.find "INR_INL_11"
  fun op INR_neq_INL _ = () val op INR_neq_INL = TDB.find "INR_neq_INL"
  fun op sum_axiom _ = () val op sum_axiom = TDB.find "sum_axiom"
  fun op sum_INDUCT _ = () val op sum_INDUCT = TDB.find "sum_INDUCT"
  fun op FORALL_SUM _ = () val op FORALL_SUM = TDB.find "FORALL_SUM"
  fun op EXISTS_SUM _ = () val op EXISTS_SUM = TDB.find "EXISTS_SUM"
  fun op sum_Axiom _ = () val op sum_Axiom = TDB.find "sum_Axiom"
  fun op sum_CASES _ = () val op sum_CASES = TDB.find "sum_CASES"
  fun op sum_distinct _ = () val op sum_distinct = TDB.find "sum_distinct"
  fun op sum_distinct1 _ = ()
  val op sum_distinct1 = TDB.find "sum_distinct1"
  fun op ISL_OR_ISR _ = () val op ISL_OR_ISR = TDB.find "ISL_OR_ISR"
  fun op INL _ = () val op INL = TDB.find "INL"
  fun op INR _ = () val op INR = TDB.find "INR"
  fun op sum_case_cong _ = ()
  val op sum_case_cong = TDB.find "sum_case_cong"
  fun op SUM_MAP _ = () val op SUM_MAP = TDB.find "SUM_MAP"
  fun op SUM_MAP_CASE _ = () val op SUM_MAP_CASE = TDB.find "SUM_MAP_CASE"
  fun op SUM_MAP_I _ = () val op SUM_MAP_I = TDB.find "SUM_MAP_I"
  fun op SUM_MAP_o _ = () val op SUM_MAP_o = TDB.find "SUM_MAP_o"
  fun op cond_sum_expand _ = ()
  val op cond_sum_expand = TDB.find "cond_sum_expand"
  fun op NOT_ISL_ISR _ = () val op NOT_ISL_ISR = TDB.find "NOT_ISL_ISR"
  fun op NOT_ISR_ISL _ = () val op NOT_ISR_ISL = TDB.find "NOT_ISR_ISL"
  fun op SUM_ALL_MONO _ = () val op SUM_ALL_MONO = TDB.find "SUM_ALL_MONO"
  fun op SUM_ALL_CONG _ = () val op SUM_ALL_CONG = TDB.find "SUM_ALL_CONG"
  fun op datatype_sum _ = () val op datatype_sum = TDB.find "datatype_sum"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val sum_grammars = merge_grammars ["sat", "combin"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="sum"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val sum_grammars = 
    Portable.## (addtyUDs,addtmUDs) sum_grammars
  val _ = Parse.grammarDB_insert("sum",sum_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "sum"

end
