structure ind_typeTheory :> ind_typeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ind_typeTheory ... "
    else ()
  
  open Type Term Thm
  local open numeralTheory whileTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ind_type"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/datatype/ind_typeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op NUMPAIR _ = () val op NUMPAIR = TDB.find "NUMPAIR"
  fun op NUMPAIR_DEST _ = () val op NUMPAIR_DEST = TDB.find "NUMPAIR_DEST"
  fun op NUMSUM _ = () val op NUMSUM = TDB.find "NUMSUM"
  fun op NUMSUM_DEST _ = () val op NUMSUM_DEST = TDB.find "NUMSUM_DEST"
  fun op INJN _ = () val op INJN = TDB.find "INJN"
  fun op INJA _ = () val op INJA = TDB.find "INJA"
  fun op INJF _ = () val op INJF = TDB.find "INJF"
  fun op INJP _ = () val op INJP = TDB.find "INJP"
  fun op ZCONSTR _ = () val op ZCONSTR = TDB.find "ZCONSTR"
  fun op ZBOT _ = () val op ZBOT = TDB.find "ZBOT"
  fun op ZRECSPACE_def _ = ()
  val op ZRECSPACE_def = TDB.find "ZRECSPACE_def"
  fun op recspace_TY_DEF _ = ()
  val op recspace_TY_DEF = TDB.find "recspace_TY_DEF"
  fun op recspace_repfns _ = ()
  val op recspace_repfns = TDB.find "recspace_repfns"
  fun op BOTTOM _ = () val op BOTTOM = TDB.find "BOTTOM"
  fun op CONSTR _ = () val op CONSTR = TDB.find "CONSTR"
  fun op FCONS _ = () val op FCONS = TDB.find "FCONS"
  fun op FNIL _ = () val op FNIL = TDB.find "FNIL"
  fun op ISO _ = () val op ISO = TDB.find "ISO"
  fun op INJ_INVERSE2 _ = () val op INJ_INVERSE2 = TDB.find "INJ_INVERSE2"
  fun op NUMPAIR_INJ_LEMMA _ = ()
  val op NUMPAIR_INJ_LEMMA = TDB.find "NUMPAIR_INJ_LEMMA"
  fun op NUMPAIR_INJ _ = () val op NUMPAIR_INJ = TDB.find "NUMPAIR_INJ"
  fun op NUMSUM_INJ _ = () val op NUMSUM_INJ = TDB.find "NUMSUM_INJ"
  fun op INJN_INJ _ = () val op INJN_INJ = TDB.find "INJN_INJ"
  fun op INJA_INJ _ = () val op INJA_INJ = TDB.find "INJA_INJ"
  fun op INJF_INJ _ = () val op INJF_INJ = TDB.find "INJF_INJ"
  fun op INJP_INJ _ = () val op INJP_INJ = TDB.find "INJP_INJ"
  fun op ZCONSTR_ZBOT _ = () val op ZCONSTR_ZBOT = TDB.find "ZCONSTR_ZBOT"
  fun op ZRECSPACE_rules _ = ()
  val op ZRECSPACE_rules = TDB.find "ZRECSPACE_rules"
  fun op ZRECSPACE_ind _ = ()
  val op ZRECSPACE_ind = TDB.find "ZRECSPACE_ind"
  fun op ZRECSPACE_strongind _ = ()
  val op ZRECSPACE_strongind = TDB.find "ZRECSPACE_strongind"
  fun op ZRECSPACE_cases _ = ()
  val op ZRECSPACE_cases = TDB.find "ZRECSPACE_cases"
  fun op MK_REC_INJ _ = () val op MK_REC_INJ = TDB.find "MK_REC_INJ"
  fun op DEST_REC_INJ _ = () val op DEST_REC_INJ = TDB.find "DEST_REC_INJ"
  fun op CONSTR_BOT _ = () val op CONSTR_BOT = TDB.find "CONSTR_BOT"
  fun op CONSTR_INJ _ = () val op CONSTR_INJ = TDB.find "CONSTR_INJ"
  fun op CONSTR_IND _ = () val op CONSTR_IND = TDB.find "CONSTR_IND"
  fun op CONSTR_REC _ = () val op CONSTR_REC = TDB.find "CONSTR_REC"
  fun op FCONS_DEST _ = () val op FCONS_DEST = TDB.find "FCONS_DEST"
  fun op ISO_REFL _ = () val op ISO_REFL = TDB.find "ISO_REFL"
  fun op ISO_FUN _ = () val op ISO_FUN = TDB.find "ISO_FUN"
  fun op ISO_USAGE _ = () val op ISO_USAGE = TDB.find "ISO_USAGE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ind_type_grammars = merge_grammars ["while", "numeral"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ind_type"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ind_type_grammars = 
    Portable.## (addtyUDs,addtmUDs) ind_type_grammars
  val _ = Parse.grammarDB_insert("ind_type",ind_type_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ind_type"

end
