structure inftreeTheory :> inftreeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading inftreeTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "inftree"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/datatype/inftree/inftreeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op is_tree_def _ = () val op is_tree_def = TDB.find "is_tree_def"
  fun op inftree_TY_DEF _ = ()
  val op inftree_TY_DEF = TDB.find "inftree_TY_DEF"
  fun op inftree_bijections _ = ()
  val op inftree_bijections = TDB.find "inftree_bijections"
  fun op iLf_def _ = () val op iLf_def = TDB.find "iLf_def"
  fun op iNd_def _ = () val op iNd_def = TDB.find "iNd_def"
  fun op relrec_def _ = () val op relrec_def = TDB.find "relrec_def"
  fun op inftree_rec_def _ = ()
  val op inftree_rec_def = TDB.find "inftree_rec_def"
  fun op inftree_case_def _ = ()
  val op inftree_case_def = TDB.find "inftree_case_def"
  fun op is_tree_rules _ = ()
  val op is_tree_rules = TDB.find "is_tree_rules"
  fun op is_tree_ind _ = () val op is_tree_ind = TDB.find "is_tree_ind"
  fun op is_tree_strongind _ = ()
  val op is_tree_strongind = TDB.find "is_tree_strongind"
  fun op is_tree_cases _ = ()
  val op is_tree_cases = TDB.find "is_tree_cases"
  fun op iNd_is_tree _ = () val op iNd_is_tree = TDB.find "iNd_is_tree"
  fun op inftree_11 _ = () val op inftree_11 = TDB.find "inftree_11"
  fun op inftree_distinct _ = ()
  val op inftree_distinct = TDB.find "inftree_distinct"
  fun op inftree_ind _ = () val op inftree_ind = TDB.find "inftree_ind"
  fun op relrec_rules _ = () val op relrec_rules = TDB.find "relrec_rules"
  fun op relrec_ind _ = () val op relrec_ind = TDB.find "relrec_ind"
  fun op relrec_strongind _ = ()
  val op relrec_strongind = TDB.find "relrec_strongind"
  fun op relrec_cases _ = () val op relrec_cases = TDB.find "relrec_cases"
  fun op inftree_Axiom _ = ()
  val op inftree_Axiom = TDB.find "inftree_Axiom"
  fun op inftree_nchotomy _ = ()
  val op inftree_nchotomy = TDB.find "inftree_nchotomy"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val inftree_grammars = merge_grammars ["indexedLists", "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="inftree"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val inftree_grammars = 
    Portable.## (addtyUDs,addtmUDs) inftree_grammars
  val _ = Parse.grammarDB_insert("inftree",inftree_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ = let
    open TypeBasePure
    val tyinfo = gen_datatype_info {
      ax = inftree_Axiom, ind = inftree_ind, case_defs = [inftree_case_def]
    }
  in
    TypeBase.write tyinfo
  end
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "inftree"

end
