structure alist_treeTheory :> alist_treeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading alist_treeTheory ... "
    else ()
  
  open Type Term Thm
  local open alistTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "alist_tree"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/alist_treeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op sorted_alist_repr_def _ = ()
  val op sorted_alist_repr_def = TDB.find "sorted_alist_repr_def"
  fun op count_append_def _ = ()
  val op count_append_def = TDB.find "count_append_def"
  fun op is_insert_def _ = ()
  val op is_insert_def = TDB.find "is_insert_def"
  fun op option_choice_f_def _ = ()
  val op option_choice_f_def = TDB.find "option_choice_f_def"
  fun op is_lookup_def _ = ()
  val op is_lookup_def = TDB.find "is_lookup_def"
  fun op HD_APPEND _ = () val op HD_APPEND = TDB.find "HD_APPEND"
  fun op LAST_APPEND _ = () val op LAST_APPEND = TDB.find "LAST_APPEND"
  fun op HD_MAP _ = () val op HD_MAP = TDB.find "HD_MAP"
  fun op HD_MEM _ = () val op HD_MEM = TDB.find "HD_MEM"
  fun op is_insert_l _ = () val op is_insert_l = TDB.find "is_insert_l"
  fun op SORTED_APPEND_trans_IFF _ = ()
  val op SORTED_APPEND_trans_IFF = TDB.find "SORTED_APPEND_trans_IFF"
  fun op insert_fl_R _ = () val op insert_fl_R = TDB.find "insert_fl_R"
  fun op insert_fl_R_append _ = ()
  val op insert_fl_R_append = TDB.find "insert_fl_R_append"
  fun op is_insert_r _ = () val op is_insert_r = TDB.find "is_insert_r"
  fun op is_insert_to_empty _ = ()
  val op is_insert_to_empty = TDB.find "is_insert_to_empty"
  fun op is_insert_overwrite _ = ()
  val op is_insert_overwrite = TDB.find "is_insert_overwrite"
  fun op sorted_fst_insert_centre _ = ()
  val op sorted_fst_insert_centre = TDB.find "sorted_fst_insert_centre"
  fun op is_insert_centre_rule _ = ()
  val op is_insert_centre_rule = TDB.find "is_insert_centre_rule"
  fun op is_insert_centre _ = ()
  val op is_insert_centre = TDB.find "is_insert_centre"
  fun op is_insert_far_left _ = ()
  val op is_insert_far_left = TDB.find "is_insert_far_left"
  fun op is_insert_far_right _ = ()
  val op is_insert_far_right = TDB.find "is_insert_far_right"
  fun op count_append_HD_LAST _ = ()
  val op count_append_HD_LAST = TDB.find "count_append_HD_LAST"
  fun op balance_r _ = () val op balance_r = TDB.find "balance_r"
  fun op balance_l _ = () val op balance_l = TDB.find "balance_l"
  fun op set_count _ = () val op set_count = TDB.find "set_count"
  fun op alookup_append_option_choice_f _ = ()
  val op alookup_append_option_choice_f = TDB.find
    "alookup_append_option_choice_f"
  fun op alookup_empty_option_choice_f _ = ()
  val op alookup_empty_option_choice_f = TDB.find
    "alookup_empty_option_choice_f"
  fun op option_choice_f_assoc _ = ()
  val op option_choice_f_assoc = TDB.find "option_choice_f_assoc"
  fun op empty_is_ALOOKUP _ = ()
  val op empty_is_ALOOKUP = TDB.find "empty_is_ALOOKUP"
  fun op repr_insert _ = () val op repr_insert = TDB.find "repr_insert"
  fun op alookup_to_option_choice _ = ()
  val op alookup_to_option_choice = TDB.find "alookup_to_option_choice"
  fun op alist_repr_choice_trans_left _ = ()
  val op alist_repr_choice_trans_left = TDB.find
    "alist_repr_choice_trans_left"
  fun op alist_repr_refl _ = ()
  val op alist_repr_refl = TDB.find "alist_repr_refl"
  fun op lookup_repr _ = () val op lookup_repr = TDB.find "lookup_repr"
  fun op is_lookup_l _ = () val op is_lookup_l = TDB.find "is_lookup_l"
  fun op is_lookup_r _ = () val op is_lookup_r = TDB.find "is_lookup_r"
  fun op is_lookup_far_left _ = ()
  val op is_lookup_far_left = TDB.find "is_lookup_far_left"
  fun op is_lookup_far_right _ = ()
  val op is_lookup_far_right = TDB.find "is_lookup_far_right"
  fun op is_lookup_hit _ = ()
  val op is_lookup_hit = TDB.find "is_lookup_hit"
  fun op DISJ_EQ_IMP _ = () val op DISJ_EQ_IMP = TDB.find "DISJ_EQ_IMP"
  fun op is_lookup_centre _ = ()
  val op is_lookup_centre = TDB.find "is_lookup_centre"
  fun op is_lookup_empty _ = ()
  val op is_lookup_empty = TDB.find "is_lookup_empty"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val alist_tree_grammars = merge_grammars ["alist"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="alist_tree"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val alist_tree_grammars = 
    Portable.## (addtyUDs,addtmUDs) alist_tree_grammars
  val _ = Parse.grammarDB_insert("alist_tree",alist_tree_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "alist_tree"

end
