structure containerTheory :> containerTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading containerTheory ... "
    else ()
  
  open Type Term Thm
  local open bagTheory finite_mapTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "container"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/containerTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op LIST_TO_BAG_def _ = ()
  val op LIST_TO_BAG_def = TDB.find "LIST_TO_BAG_def"
  fun op BAG_TO_LIST_primitive_def _ = ()
  val op BAG_TO_LIST_primitive_def = TDB.find "BAG_TO_LIST_primitive_def"
  fun op mlt_list_def _ = () val op mlt_list_def = TDB.find "mlt_list_def"
  fun op BAG_OF_FMAP_def _ = ()
  val op BAG_OF_FMAP_def = TDB.find "BAG_OF_FMAP_def"
  fun op SET_TO_LIST_THM _ = ()
  val op SET_TO_LIST_THM = TDB.find "SET_TO_LIST_THM"
  fun op SET_TO_LIST_IND _ = ()
  val op SET_TO_LIST_IND = TDB.find "SET_TO_LIST_IND"
  fun op LIST_TO_SET_THM _ = ()
  val op LIST_TO_SET_THM = TDB.find "LIST_TO_SET_THM"
  fun op SET_TO_LIST_INV _ = ()
  val op SET_TO_LIST_INV = TDB.find "SET_TO_LIST_INV"
  fun op SET_TO_LIST_CARD _ = ()
  val op SET_TO_LIST_CARD = TDB.find "SET_TO_LIST_CARD"
  fun op SET_TO_LIST_IN_MEM _ = ()
  val op SET_TO_LIST_IN_MEM = TDB.find "SET_TO_LIST_IN_MEM"
  fun op MEM_SET_TO_LIST _ = ()
  val op MEM_SET_TO_LIST = TDB.find "MEM_SET_TO_LIST"
  fun op SET_TO_LIST_SING _ = ()
  val op SET_TO_LIST_SING = TDB.find "SET_TO_LIST_SING"
  fun op UNION_APPEND _ = () val op UNION_APPEND = TDB.find "UNION_APPEND"
  fun op LIST_TO_SET_APPEND _ = ()
  val op LIST_TO_SET_APPEND = TDB.find "LIST_TO_SET_APPEND"
  fun op FINITE_LIST_TO_SET _ = ()
  val op FINITE_LIST_TO_SET = TDB.find "FINITE_LIST_TO_SET"
  fun op LIST_TO_BAG_alt _ = ()
  val op LIST_TO_BAG_alt = TDB.find "LIST_TO_BAG_alt"
  fun op BAG_TO_LIST_THM _ = ()
  val op BAG_TO_LIST_THM = TDB.find "BAG_TO_LIST_THM"
  fun op BAG_TO_LIST_IND _ = ()
  val op BAG_TO_LIST_IND = TDB.find "BAG_TO_LIST_IND"
  fun op BAG_TO_LIST_INV _ = ()
  val op BAG_TO_LIST_INV = TDB.find "BAG_TO_LIST_INV"
  fun op BAG_IN_MEM _ = () val op BAG_IN_MEM = TDB.find "BAG_IN_MEM"
  fun op MEM_BAG_TO_LIST _ = ()
  val op MEM_BAG_TO_LIST = TDB.find "MEM_BAG_TO_LIST"
  fun op FINITE_LIST_TO_BAG _ = ()
  val op FINITE_LIST_TO_BAG = TDB.find "FINITE_LIST_TO_BAG"
  fun op EVERY_LIST_TO_BAG _ = ()
  val op EVERY_LIST_TO_BAG = TDB.find "EVERY_LIST_TO_BAG"
  fun op LIST_TO_BAG_APPEND _ = ()
  val op LIST_TO_BAG_APPEND = TDB.find "LIST_TO_BAG_APPEND"
  fun op LIST_TO_BAG_MAP _ = ()
  val op LIST_TO_BAG_MAP = TDB.find "LIST_TO_BAG_MAP"
  fun op LIST_TO_BAG_FILTER _ = ()
  val op LIST_TO_BAG_FILTER = TDB.find "LIST_TO_BAG_FILTER"
  fun op INN_LIST_TO_BAG _ = ()
  val op INN_LIST_TO_BAG = TDB.find "INN_LIST_TO_BAG"
  fun op IN_LIST_TO_BAG _ = ()
  val op IN_LIST_TO_BAG = TDB.find "IN_LIST_TO_BAG"
  fun op LIST_TO_BAG_DISTINCT _ = ()
  val op LIST_TO_BAG_DISTINCT = TDB.find "LIST_TO_BAG_DISTINCT"
  fun op LIST_TO_BAG_EQ_EMPTY _ = ()
  val op LIST_TO_BAG_EQ_EMPTY = TDB.find "LIST_TO_BAG_EQ_EMPTY"
  fun op PERM_LIST_TO_BAG _ = ()
  val op PERM_LIST_TO_BAG = TDB.find "PERM_LIST_TO_BAG"
  fun op CARD_LIST_TO_BAG _ = ()
  val op CARD_LIST_TO_BAG = TDB.find "CARD_LIST_TO_BAG"
  fun op BAG_TO_LIST_CARD _ = ()
  val op BAG_TO_LIST_CARD = TDB.find "BAG_TO_LIST_CARD"
  fun op BAG_TO_LIST_EQ_NIL _ = ()
  val op BAG_TO_LIST_EQ_NIL = TDB.find "BAG_TO_LIST_EQ_NIL"
  fun op LIST_ELEM_COUNT_LIST_TO_BAG _ = ()
  val op LIST_ELEM_COUNT_LIST_TO_BAG = TDB.find
    "LIST_ELEM_COUNT_LIST_TO_BAG"
  fun op LIST_TO_BAG_SUB_BAG_FLAT_suff _ = ()
  val op LIST_TO_BAG_SUB_BAG_FLAT_suff = TDB.find
    "LIST_TO_BAG_SUB_BAG_FLAT_suff"
  fun op LIST_TO_BAG_SUBSET _ = ()
  val op LIST_TO_BAG_SUBSET = TDB.find "LIST_TO_BAG_SUBSET"
  fun op WF_mlt_list _ = () val op WF_mlt_list = TDB.find "WF_mlt_list"
  fun op BAG_OF_FMAP_THM _ = ()
  val op BAG_OF_FMAP_THM = TDB.find "BAG_OF_FMAP_THM"
  fun op BAG_IN_BAG_OF_FMAP _ = ()
  val op BAG_IN_BAG_OF_FMAP = TDB.find "BAG_IN_BAG_OF_FMAP"
  fun op FINITE_BAG_OF_FMAP _ = ()
  val op FINITE_BAG_OF_FMAP = TDB.find "FINITE_BAG_OF_FMAP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val container_grammars = merge_grammars ["finite_map", "bag"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="container"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val container_grammars = 
    Portable.## (addtyUDs,addtmUDs) container_grammars
  val _ = Parse.grammarDB_insert("container",container_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ = TotalDefn.WF_thms := (!TotalDefn.WF_thms @ [WF_mlt_list]);
  val _ = TotalDefn.termination_simps := (!TotalDefn.termination_simps @ [mlt_list_def]);
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "container"

end
