structure enumeralTheory :> enumeralTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading enumeralTheory ... "
    else ()
  
  open Type Term Thm
  local open res_quanTheory totoTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "enumeral"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/enumeralTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op bl_TY_DEF _ = () val op bl_TY_DEF = TDB.find "bl_TY_DEF"
  fun op bl_case_def _ = () val op bl_case_def = TDB.find "bl_case_def"
  fun op bl_size_def _ = () val op bl_size_def = TDB.find "bl_size_def"
  fun op bt_TY_DEF _ = () val op bt_TY_DEF = TDB.find "bt_TY_DEF"
  fun op bt_size_def _ = () val op bt_size_def = TDB.find "bt_size_def"
  fun op BL_ACCUM _ = () val op BL_ACCUM = TDB.find "BL_ACCUM"
  fun op BL_CONS _ = () val op BL_CONS = TDB.find "BL_CONS"
  fun op list_to_bl _ = () val op list_to_bl = TDB.find "list_to_bl"
  fun op bt_to_list _ = () val op bt_to_list = TDB.find "bt_to_list"
  fun op bt_to_list_ac _ = ()
  val op bt_to_list_ac = TDB.find "bt_to_list_ac"
  fun op bt_rev _ = () val op bt_rev = TDB.find "bt_rev"
  fun op K2 _ = () val op K2 = TDB.find "K2"
  fun op bl_rev _ = () val op bl_rev = TDB.find "bl_rev"
  fun op bl_to_bt _ = () val op bl_to_bt = TDB.find "bl_to_bt"
  fun op bt_to_bl _ = () val op bt_to_bl = TDB.find "bt_to_bl"
  fun op list_to_bt _ = () val op list_to_bt = TDB.find "list_to_bt"
  fun op OL _ = () val op OL = TDB.find "OL"
  fun op lol_set_primitive _ = ()
  val op lol_set_primitive = TDB.find "lol_set_primitive"
  fun op incr_sbuild _ = () val op incr_sbuild = TDB.find "incr_sbuild"
  fun op incr_ssort _ = () val op incr_ssort = TDB.find "incr_ssort"
  fun op bt_to_set _ = () val op bt_to_set = TDB.find "bt_to_set"
  fun op bt_to_set_lb _ = () val op bt_to_set_lb = TDB.find "bt_to_set_lb"
  fun op bt_to_set_ub _ = () val op bt_to_set_ub = TDB.find "bt_to_set_ub"
  fun op bt_to_set_lb_ub _ = ()
  val op bt_to_set_lb_ub = TDB.find "bt_to_set_lb_ub"
  fun op bt_to_ol_lb_ub _ = ()
  val op bt_to_ol_lb_ub = TDB.find "bt_to_ol_lb_ub"
  fun op bt_to_ol_lb _ = () val op bt_to_ol_lb = TDB.find "bt_to_ol_lb"
  fun op bt_to_ol_ub _ = () val op bt_to_ol_ub = TDB.find "bt_to_ol_ub"
  fun op bt_to_ol _ = () val op bt_to_ol = TDB.find "bt_to_ol"
  fun op bt_to_ol_lb_ub_ac _ = ()
  val op bt_to_ol_lb_ub_ac = TDB.find "bt_to_ol_lb_ub_ac"
  fun op bt_to_ol_lb_ac _ = ()
  val op bt_to_ol_lb_ac = TDB.find "bt_to_ol_lb_ac"
  fun op bt_to_ol_ub_ac _ = ()
  val op bt_to_ol_ub_ac = TDB.find "bt_to_ol_ub_ac"
  fun op bt_to_ol_ac _ = () val op bt_to_ol_ac = TDB.find "bt_to_ol_ac"
  fun op OWL _ = () val op OWL = TDB.find "OWL"
  fun op OU _ = () val op OU = TDB.find "OU"
  fun op UO _ = () val op UO = TDB.find "UO"
  fun op LESS_ALL _ = () val op LESS_ALL = TDB.find "LESS_ALL"
  fun op bl_to_set _ = () val op bl_to_set = TDB.find "bl_to_set"
  fun op OL_bt_lb_ub _ = () val op OL_bt_lb_ub = TDB.find "OL_bt_lb_ub"
  fun op OL_bt_lb _ = () val op OL_bt_lb = TDB.find "OL_bt_lb"
  fun op OL_bt_ub _ = () val op OL_bt_ub = TDB.find "OL_bt_ub"
  fun op OL_bt _ = () val op OL_bt = TDB.find "OL_bt"
  fun op bt_distinct _ = () val op bt_distinct = TDB.find "bt_distinct"
  fun op bt_nchotomy _ = () val op bt_nchotomy = TDB.find "bt_nchotomy"
  fun op bt_Axiom _ = () val op bt_Axiom = TDB.find "bt_Axiom"
  fun op bt_induction _ = () val op bt_induction = TDB.find "bt_induction"
  fun op bt_case_cong _ = () val op bt_case_cong = TDB.find "bt_case_cong"
  fun op bt_case_eq _ = () val op bt_case_eq = TDB.find "bt_case_eq"
  fun op datatype_bl _ = () val op datatype_bl = TDB.find "datatype_bl"
  fun op bl_11 _ = () val op bl_11 = TDB.find "bl_11"
  fun op bl_distinct _ = () val op bl_distinct = TDB.find "bl_distinct"
  fun op bl_nchotomy _ = () val op bl_nchotomy = TDB.find "bl_nchotomy"
  fun op bl_Axiom _ = () val op bl_Axiom = TDB.find "bl_Axiom"
  fun op bl_induction _ = () val op bl_induction = TDB.find "bl_induction"
  fun op bl_case_cong _ = () val op bl_case_cong = TDB.find "bl_case_cong"
  fun op bl_case_eq _ = () val op bl_case_eq = TDB.find "bl_case_eq"
  fun op bt_11 _ = () val op bt_11 = TDB.find "bt_11"
  fun op datatype_bt _ = () val op datatype_bt = TDB.find "datatype_bt"
  fun op bt_case_def _ = () val op bt_case_def = TDB.find "bt_case_def"
  fun op bt_to_list_thm _ = ()
  val op bt_to_list_thm = TDB.find "bt_to_list_thm"
  fun op smerge_ind _ = () val op smerge_ind = TDB.find "smerge_ind"
  fun op smerge _ = () val op smerge = TDB.find "smerge"
  fun op smerge_nil _ = () val op smerge_nil = TDB.find "smerge_nil"
  fun op smerge_OL _ = () val op smerge_OL = TDB.find "smerge_OL"
  fun op OL_sublists_ind _ = ()
  val op OL_sublists_ind = TDB.find "OL_sublists_ind"
  fun op OL_sublists _ = () val op OL_sublists = TDB.find "OL_sublists"
  fun op lol_set_ind _ = () val op lol_set_ind = TDB.find "lol_set_ind"
  fun op lol_set _ = () val op lol_set = TDB.find "lol_set"
  fun op incr_smerge_ind _ = ()
  val op incr_smerge_ind = TDB.find "incr_smerge_ind"
  fun op incr_smerge _ = () val op incr_smerge = TDB.find "incr_smerge"
  fun op incr_smerge_OL _ = ()
  val op incr_smerge_OL = TDB.find "incr_smerge_OL"
  fun op smerge_out_ind _ = ()
  val op smerge_out_ind = TDB.find "smerge_out_ind"
  fun op smerge_out _ = () val op smerge_out = TDB.find "smerge_out"
  fun op IN_bt_to_set _ = () val op IN_bt_to_set = TDB.find "IN_bt_to_set"
  fun op NOT_IN_nt _ = () val op NOT_IN_nt = TDB.find "NOT_IN_nt"
  fun op IN_node _ = () val op IN_node = TDB.find "IN_node"
  fun op ol_set _ = () val op ol_set = TDB.find "ol_set"
  fun op OL_bt_to_ol_lb_ub _ = ()
  val op OL_bt_to_ol_lb_ub = TDB.find "OL_bt_to_ol_lb_ub"
  fun op OL_bt_to_ol_lb _ = ()
  val op OL_bt_to_ol_lb = TDB.find "OL_bt_to_ol_lb"
  fun op OL_bt_to_ol_ub _ = ()
  val op OL_bt_to_ol_ub = TDB.find "OL_bt_to_ol_ub"
  fun op OL_bt_to_ol _ = () val op OL_bt_to_ol = TDB.find "OL_bt_to_ol"
  fun op OWL_bt_to_ol _ = () val op OWL_bt_to_ol = TDB.find "OWL_bt_to_ol"
  fun op EMPTY_OU _ = () val op EMPTY_OU = TDB.find "EMPTY_OU"
  fun op OU_EMPTY _ = () val op OU_EMPTY = TDB.find "OU_EMPTY"
  fun op LESS_UO_LEM _ = () val op LESS_UO_LEM = TDB.find "LESS_UO_LEM"
  fun op LESS_ALL_OU _ = () val op LESS_ALL_OU = TDB.find "LESS_ALL_OU"
  fun op OU_ASSOC _ = () val op OU_ASSOC = TDB.find "OU_ASSOC"
  fun op LESS_ALL_UO_LEM _ = ()
  val op LESS_ALL_UO_LEM = TDB.find "LESS_ALL_UO_LEM"
  fun op LESS_ALL_OU_UO_LEM _ = ()
  val op LESS_ALL_OU_UO_LEM = TDB.find "LESS_ALL_OU_UO_LEM"
  fun op bt_to_ol_ID_IMP _ = ()
  val op bt_to_ol_ID_IMP = TDB.find "bt_to_ol_ID_IMP"
  fun op OL_UNION_IMP _ = () val op OL_UNION_IMP = TDB.find "OL_UNION_IMP"
  fun op sinter_ind _ = () val op sinter_ind = TDB.find "sinter_ind"
  fun op sinter _ = () val op sinter = TDB.find "sinter"
  fun op OL_INTER_IMP _ = () val op OL_INTER_IMP = TDB.find "OL_INTER_IMP"
  fun op sdiff_ind _ = () val op sdiff_ind = TDB.find "sdiff_ind"
  fun op sdiff _ = () val op sdiff = TDB.find "sdiff"
  fun op OL_DIFF_IMP _ = () val op OL_DIFF_IMP = TDB.find "OL_DIFF_IMP"
  fun op ENUMERAL_set _ = () val op ENUMERAL_set = TDB.find "ENUMERAL_set"
  fun op OL_ENUMERAL _ = () val op OL_ENUMERAL = TDB.find "OL_ENUMERAL"
  fun op OWL_UNION_THM _ = ()
  val op OWL_UNION_THM = TDB.find "OWL_UNION_THM"
  fun op OWL_INTER_THM _ = ()
  val op OWL_INTER_THM = TDB.find "OWL_INTER_THM"
  fun op OWL_DIFF_THM _ = () val op OWL_DIFF_THM = TDB.find "OWL_DIFF_THM"
  fun op better_bt_to_ol _ = ()
  val op better_bt_to_ol = TDB.find "better_bt_to_ol"
  fun op set_OWL_thm _ = () val op set_OWL_thm = TDB.find "set_OWL_thm"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val enumeral_grammars = merge_grammars ["toto", "res_quan"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="enumeral"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val enumeral_grammars = 
    Portable.## (addtyUDs,addtmUDs) enumeral_grammars
  val _ = Parse.grammarDB_insert("enumeral",enumeral_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "enumeral"

end
