structure finite_mapTheory :> finite_mapTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading finite_mapTheory ... "
    else ()
  
  open Type Term Thm
  local open sortingTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "finite_map"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/finite_mapTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op fmap_inverse_def _ = ()
  val op fmap_inverse_def = TDB.find "fmap_inverse_def"
  fun op FMAP_MAP2_def _ = ()
  val op FMAP_MAP2_def = TDB.find "FMAP_MAP2_def"
  fun op FUPDATE_LIST _ = () val op FUPDATE_LIST = TDB.find "FUPDATE_LIST"
  fun op SUBMAP_DEF _ = () val op SUBMAP_DEF = TDB.find "SUBMAP_DEF"
  fun op FCARD_DEF _ = () val op FCARD_DEF = TDB.find "FCARD_DEF"
  fun op FDOM_DEF _ = () val op FDOM_DEF = TDB.find "FDOM_DEF"
  fun op FAPPLY_DEF _ = () val op FAPPLY_DEF = TDB.find "FAPPLY_DEF"
  fun op FEMPTY_DEF _ = () val op FEMPTY_DEF = TDB.find "FEMPTY_DEF"
  fun op FUPDATE_DEF _ = () val op FUPDATE_DEF = TDB.find "FUPDATE_DEF"
  fun op fmap_ISO_DEF _ = () val op fmap_ISO_DEF = TDB.find "fmap_ISO_DEF"
  fun op fmap_TY_DEF _ = () val op fmap_TY_DEF = TDB.find "fmap_TY_DEF"
  fun op is_fmap_def _ = () val op is_fmap_def = TDB.find "is_fmap_def"
  fun op DRESTRICT_DEF _ = ()
  val op DRESTRICT_DEF = TDB.find "DRESTRICT_DEF"
  fun op FUNION_DEF _ = () val op FUNION_DEF = TDB.find "FUNION_DEF"
  fun op fmap_domsub _ = () val op fmap_domsub = TDB.find "fmap_domsub"
  fun op f_o_DEF _ = () val op f_o_DEF = TDB.find "f_o_DEF"
  fun op FUN_FMAP_DEF _ = () val op FUN_FMAP_DEF = TDB.find "FUN_FMAP_DEF"
  fun op RRESTRICT_DEF _ = ()
  val op RRESTRICT_DEF = TDB.find "RRESTRICT_DEF"
  fun op FRANGE_DEF _ = () val op FRANGE_DEF = TDB.find "FRANGE_DEF"
  fun op o_f_DEF _ = () val op o_f_DEF = TDB.find "o_f_DEF"
  fun op f_o_f_DEF _ = () val op f_o_f_DEF = TDB.find "f_o_f_DEF"
  fun op FEVERY_DEF _ = () val op FEVERY_DEF = TDB.find "FEVERY_DEF"
  fun op FLOOKUP_DEF _ = () val op FLOOKUP_DEF = TDB.find "FLOOKUP_DEF"
  fun op FMERGE_DEF _ = () val op FMERGE_DEF = TDB.find "FMERGE_DEF"
  fun op MAP_KEYS_def _ = () val op MAP_KEYS_def = TDB.find "MAP_KEYS_def"
  fun op fmap_rel_def _ = () val op fmap_rel_def = TDB.find "fmap_rel_def"
  fun op fmap_EQ_UPTO_def _ = ()
  val op fmap_EQ_UPTO_def = TDB.find "fmap_EQ_UPTO_def"
  fun op fmap_size_def _ = ()
  val op fmap_size_def = TDB.find "fmap_size_def"
  fun op FDIFF_def _ = () val op FDIFF_def = TDB.find "FDIFF_def"
  fun op DISJOINT_FEVERY_FUNION _ = ()
  val op DISJOINT_FEVERY_FUNION = TDB.find "DISJOINT_FEVERY_FUNION"
  fun op fevery_funion _ = ()
  val op fevery_funion = TDB.find "fevery_funion"
  fun op drestrict_iter_list _ = ()
  val op drestrict_iter_list = TDB.find "drestrict_iter_list"
  fun op disjoint_drestrict _ = ()
  val op disjoint_drestrict = TDB.find "disjoint_drestrict"
  fun op fmap_to_list _ = () val op fmap_to_list = TDB.find "fmap_to_list"
  fun op fupdate_list_foldl _ = ()
  val op fupdate_list_foldl = TDB.find "fupdate_list_foldl"
  fun op fupdate_list_foldr _ = ()
  val op fupdate_list_foldr = TDB.find "fupdate_list_foldr"
  fun op FUPDATE_EQ_FUPDATE_LIST _ = ()
  val op FUPDATE_EQ_FUPDATE_LIST = TDB.find "FUPDATE_EQ_FUPDATE_LIST"
  fun op flookup_thm _ = () val op flookup_thm = TDB.find "flookup_thm"
  fun op fdom_fupdate_list2 _ = ()
  val op fdom_fupdate_list2 = TDB.find "fdom_fupdate_list2"
  fun op fupdate_list_map _ = ()
  val op fupdate_list_map = TDB.find "fupdate_list_map"
  fun op fmap_rel_sym _ = () val op fmap_rel_sym = TDB.find "fmap_rel_sym"
  fun op fmap_rel_trans _ = ()
  val op fmap_rel_trans = TDB.find "fmap_rel_trans"
  fun op f_o_f_FUPDATE_compose _ = ()
  val op f_o_f_FUPDATE_compose = TDB.find "f_o_f_FUPDATE_compose"
  fun op DRESTRICT_SUBSET _ = ()
  val op DRESTRICT_SUBSET = TDB.find "DRESTRICT_SUBSET"
  fun op DRESTRICT_FDOM _ = ()
  val op DRESTRICT_FDOM = TDB.find "DRESTRICT_FDOM"
  fun op FRANGE_DRESTRICT_SUBSET _ = ()
  val op FRANGE_DRESTRICT_SUBSET = TDB.find "FRANGE_DRESTRICT_SUBSET"
  fun op IN_FRANGE_DOMSUB_suff _ = ()
  val op IN_FRANGE_DOMSUB_suff = TDB.find "IN_FRANGE_DOMSUB_suff"
  fun op FRANGE_DOMSUB_SUBSET _ = ()
  val op FRANGE_DOMSUB_SUBSET = TDB.find "FRANGE_DOMSUB_SUBSET"
  fun op IN_FRANGE_FUNION_suff _ = ()
  val op IN_FRANGE_FUNION_suff = TDB.find "IN_FRANGE_FUNION_suff"
  fun op FRANGE_FUNION_SUBSET _ = ()
  val op FRANGE_FUNION_SUBSET = TDB.find "FRANGE_FUNION_SUBSET"
  fun op IN_FRANGE_FUPDATE_LIST_suff _ = ()
  val op IN_FRANGE_FUPDATE_LIST_suff = TDB.find
    "IN_FRANGE_FUPDATE_LIST_suff"
  fun op FRANGE_FUPDATE_LIST_SUBSET _ = ()
  val op FRANGE_FUPDATE_LIST_SUBSET = TDB.find "FRANGE_FUPDATE_LIST_SUBSET"
  fun op IN_FRANGE_FLOOKUP _ = ()
  val op IN_FRANGE_FLOOKUP = TDB.find "IN_FRANGE_FLOOKUP"
  fun op IN_FRANGE _ = () val op IN_FRANGE = TDB.find "IN_FRANGE"
  fun op FUPDATE_LIST_ALL_DISTINCT_REVERSE _ = ()
  val op FUPDATE_LIST_ALL_DISTINCT_REVERSE = TDB.find
    "FUPDATE_LIST_ALL_DISTINCT_REVERSE"
  fun op FUPDATE_LIST_ALL_DISTINCT_APPLY_MEM _ = ()
  val op FUPDATE_LIST_ALL_DISTINCT_APPLY_MEM = TDB.find
    "FUPDATE_LIST_ALL_DISTINCT_APPLY_MEM"
  fun op FUPDATE_SAME_LIST_APPLY _ = ()
  val op FUPDATE_SAME_LIST_APPLY = TDB.find "FUPDATE_SAME_LIST_APPLY"
  fun op FUPDATE_SAME_APPLY _ = ()
  val op FUPDATE_SAME_APPLY = TDB.find "FUPDATE_SAME_APPLY"
  fun op FUPDATE_LIST_APPLY_HO_THM _ = ()
  val op FUPDATE_LIST_APPLY_HO_THM = TDB.find "FUPDATE_LIST_APPLY_HO_THM"
  fun op FUPDATE_LIST_APPLY_NOT_MEM_matchable _ = ()
  val op FUPDATE_LIST_APPLY_NOT_MEM_matchable = TDB.find
    "FUPDATE_LIST_APPLY_NOT_MEM_matchable"
  fun op DRESTRICT_FUNION_SUBSET _ = ()
  val op DRESTRICT_FUNION_SUBSET = TDB.find "DRESTRICT_FUNION_SUBSET"
  fun op FOLDL2_FUPDATE_LIST_paired _ = ()
  val op FOLDL2_FUPDATE_LIST_paired = TDB.find "FOLDL2_FUPDATE_LIST_paired"
  fun op FOLDL2_FUPDATE_LIST _ = ()
  val op FOLDL2_FUPDATE_LIST = TDB.find "FOLDL2_FUPDATE_LIST"
  fun op DRESTRICT_EQ_DRESTRICT_SAME _ = ()
  val op DRESTRICT_EQ_DRESTRICT_SAME = TDB.find
    "DRESTRICT_EQ_DRESTRICT_SAME"
  fun op DRESTRICT_FUNION_SAME _ = ()
  val op DRESTRICT_FUNION_SAME = TDB.find "DRESTRICT_FUNION_SAME"
  fun op DRESTRICT_SUBSET_SUBMAP_gen _ = ()
  val op DRESTRICT_SUBSET_SUBMAP_gen = TDB.find
    "DRESTRICT_SUBSET_SUBMAP_gen"
  fun op DRESTRICT_DOMSUB _ = ()
  val op DRESTRICT_DOMSUB = TDB.find "DRESTRICT_DOMSUB"
  fun op DOMSUB_SUBMAP _ = ()
  val op DOMSUB_SUBMAP = TDB.find "DOMSUB_SUBMAP"
  fun op SUBMAP_DOMSUB_gen _ = ()
  val op SUBMAP_DOMSUB_gen = TDB.find "SUBMAP_DOMSUB_gen"
  fun op SUBMAP_mono_FUPDATE _ = ()
  val op SUBMAP_mono_FUPDATE = TDB.find "SUBMAP_mono_FUPDATE"
  fun op IMAGE_FRANGE _ = () val op IMAGE_FRANGE = TDB.find "IMAGE_FRANGE"
  fun op DRESTRICTED_FUNION _ = ()
  val op DRESTRICTED_FUNION = TDB.find "DRESTRICTED_FUNION"
  fun op DRESTRICT_SUBSET_SUBMAP _ = ()
  val op DRESTRICT_SUBSET_SUBMAP = TDB.find "DRESTRICT_SUBSET_SUBMAP"
  fun op DRESTRICT_SUBMAP_gen _ = ()
  val op DRESTRICT_SUBMAP_gen = TDB.find "DRESTRICT_SUBMAP_gen"
  fun op IN_FRANGE_o_f_suff _ = ()
  val op IN_FRANGE_o_f_suff = TDB.find "IN_FRANGE_o_f_suff"
  fun op IN_FRANGE_FUPDATE_suff _ = ()
  val op IN_FRANGE_FUPDATE_suff = TDB.find "IN_FRANGE_FUPDATE_suff"
  fun op FRANGE_FUPDATE_SUBSET _ = ()
  val op FRANGE_FUPDATE_SUBSET = TDB.find "FRANGE_FUPDATE_SUBSET"
  fun op IN_FRANGE_DRESTRICT_suff _ = ()
  val op IN_FRANGE_DRESTRICT_suff = TDB.find "IN_FRANGE_DRESTRICT_suff"
  fun op FUNION_ASSOC _ = () val op FUNION_ASSOC = TDB.find "FUNION_ASSOC"
  fun op FUNION_COMM _ = () val op FUNION_COMM = TDB.find "FUNION_COMM"
  fun op DOMSUB_FUNION _ = ()
  val op DOMSUB_FUNION = TDB.find "DOMSUB_FUNION"
  fun op FUNION_EQ_IMPL _ = ()
  val op FUNION_EQ_IMPL = TDB.find "FUNION_EQ_IMPL"
  fun op FUNION_EQ _ = () val op FUNION_EQ = TDB.find "FUNION_EQ"
  fun op FEMPTY_SUBMAP _ = ()
  val op FEMPTY_SUBMAP = TDB.find "FEMPTY_SUBMAP"
  fun op SUBMAP_FUNION_ID _ = ()
  val op SUBMAP_FUNION_ID = TDB.find "SUBMAP_FUNION_ID"
  fun op SUBMAP_FUNION _ = ()
  val op SUBMAP_FUNION = TDB.find "SUBMAP_FUNION"
  fun op SUBMAP_FUNION_EQ _ = ()
  val op SUBMAP_FUNION_EQ = TDB.find "SUBMAP_FUNION_EQ"
  fun op FUNION_EQ_FEMPTY _ = ()
  val op FUNION_EQ_FEMPTY = TDB.find "FUNION_EQ_FEMPTY"
  fun op FEVERY_DRESTRICT_COMPL _ = ()
  val op FEVERY_DRESTRICT_COMPL = TDB.find "FEVERY_DRESTRICT_COMPL"
  fun op FUPDATE_ELIM _ = () val op FUPDATE_ELIM = TDB.find "FUPDATE_ELIM"
  fun op FEVERY_STRENGTHEN_THM _ = ()
  val op FEVERY_STRENGTHEN_THM = TDB.find "FEVERY_STRENGTHEN_THM"
  fun op FMAP_MAP2_FUPDATE _ = ()
  val op FMAP_MAP2_FUPDATE = TDB.find "FMAP_MAP2_FUPDATE"
  fun op FMAP_MAP2_FEMPTY _ = ()
  val op FMAP_MAP2_FEMPTY = TDB.find "FMAP_MAP2_FEMPTY"
  fun op FMAP_MAP2_THM _ = ()
  val op FMAP_MAP2_THM = TDB.find "FMAP_MAP2_THM"
  fun op FUPDATE_PURGE _ = ()
  val op FUPDATE_PURGE = TDB.find "FUPDATE_PURGE"
  fun op FMEQ_SINGLE_SIMPLE_DISJ_ELIM _ = ()
  val op FMEQ_SINGLE_SIMPLE_DISJ_ELIM = TDB.find
    "FMEQ_SINGLE_SIMPLE_DISJ_ELIM"
  fun op FMEQ_SINGLE_SIMPLE_ELIM _ = ()
  val op FMEQ_SINGLE_SIMPLE_ELIM = TDB.find "FMEQ_SINGLE_SIMPLE_ELIM"
  fun op FMEQ_ENUMERATE_CASES _ = ()
  val op FMEQ_ENUMERATE_CASES = TDB.find "FMEQ_ENUMERATE_CASES"
  fun op FUPDATE_LIST_SAME_KEYS_UNWIND _ = ()
  val op FUPDATE_LIST_SAME_KEYS_UNWIND = TDB.find
    "FUPDATE_LIST_SAME_KEYS_UNWIND"
  fun op FUPDATE_LIST_SAME_UPDATE _ = ()
  val op FUPDATE_LIST_SAME_UPDATE = TDB.find "FUPDATE_LIST_SAME_UPDATE"
  fun op FUPDATE_LIST_EQ_FEMPTY _ = ()
  val op FUPDATE_LIST_EQ_FEMPTY = TDB.find "FUPDATE_LIST_EQ_FEMPTY"
  fun op FDOM_FUPDATE_LIST _ = ()
  val op FDOM_FUPDATE_LIST = TDB.find "FDOM_FUPDATE_LIST"
  fun op FUPD11_SAME_UPDATE _ = ()
  val op FUPD11_SAME_UPDATE = TDB.find "FUPD11_SAME_UPDATE"
  fun op FUPD_SAME_KEY_UNWIND _ = ()
  val op FUPD_SAME_KEY_UNWIND = TDB.find "FUPD_SAME_KEY_UNWIND"
  fun op FUPD11_SAME_BASE _ = ()
  val op FUPD11_SAME_BASE = TDB.find "FUPD11_SAME_BASE"
  fun op SAME_KEY_UPDATES_DIFFER _ = ()
  val op SAME_KEY_UPDATES_DIFFER = TDB.find "SAME_KEY_UPDATES_DIFFER"
  fun op FUPD11_SAME_NEW_KEY _ = ()
  val op FUPD11_SAME_NEW_KEY = TDB.find "FUPD11_SAME_NEW_KEY"
  fun op FUPD11_SAME_KEY_AND_BASE _ = ()
  val op FUPD11_SAME_KEY_AND_BASE = TDB.find "FUPD11_SAME_KEY_AND_BASE"
  fun op FEMPTY_FUPDATE_EQ _ = ()
  val op FEMPTY_FUPDATE_EQ = TDB.find "FEMPTY_FUPDATE_EQ"
  fun op FUPDATE_LIST_SNOC _ = ()
  val op FUPDATE_LIST_SNOC = TDB.find "FUPDATE_LIST_SNOC"
  fun op FOLDL_FUPDATE_LIST _ = ()
  val op FOLDL_FUPDATE_LIST = TDB.find "FOLDL_FUPDATE_LIST"
  fun op FUPDATE_LIST_APPLY_MEM _ = ()
  val op FUPDATE_LIST_APPLY_MEM = TDB.find "FUPDATE_LIST_APPLY_MEM"
  fun op FEVERY_FUPDATE_LIST _ = ()
  val op FEVERY_FUPDATE_LIST = TDB.find "FEVERY_FUPDATE_LIST"
  fun op FUPDATE_FUPDATE_LIST_MEM _ = ()
  val op FUPDATE_FUPDATE_LIST_MEM = TDB.find "FUPDATE_FUPDATE_LIST_MEM"
  fun op FUPDATE_FUPDATE_LIST_COMMUTES _ = ()
  val op FUPDATE_FUPDATE_LIST_COMMUTES = TDB.find
    "FUPDATE_FUPDATE_LIST_COMMUTES"
  fun op FUPDATE_LIST_APPEND _ = ()
  val op FUPDATE_LIST_APPEND = TDB.find "FUPDATE_LIST_APPEND"
  fun op FUPDATE_LIST_APPLY_NOT_MEM _ = ()
  val op FUPDATE_LIST_APPLY_NOT_MEM = TDB.find "FUPDATE_LIST_APPLY_NOT_MEM"
  fun op FUPDATE_LIST_THM _ = ()
  val op FUPDATE_LIST_THM = TDB.find "FUPDATE_LIST_THM"
  fun op SUBMAP_FUPDATE _ = ()
  val op SUBMAP_FUPDATE = TDB.find "SUBMAP_FUPDATE"
  fun op SUBMAP_TRANS _ = () val op SUBMAP_TRANS = TDB.find "SUBMAP_TRANS"
  fun op SUBMAP_ANTISYM _ = ()
  val op SUBMAP_ANTISYM = TDB.find "SUBMAP_ANTISYM"
  fun op SUBMAP_REFL _ = () val op SUBMAP_REFL = TDB.find "SUBMAP_REFL"
  fun op SUBMAP_FEMPTY _ = ()
  val op SUBMAP_FEMPTY = TDB.find "SUBMAP_FEMPTY"
  fun op fmap_EXT _ = () val op fmap_EXT = TDB.find "fmap_EXT"
  fun op fmap_EQ_THM _ = () val op fmap_EQ_THM = TDB.find "fmap_EQ_THM"
  fun op fmap_EQ _ = () val op fmap_EQ = TDB.find "fmap_EQ"
  fun op NOT_FDOM_FAPPLY_FEMPTY _ = ()
  val op NOT_FDOM_FAPPLY_FEMPTY = TDB.find "NOT_FDOM_FAPPLY_FEMPTY"
  fun op FM_PULL_APART _ = ()
  val op FM_PULL_APART = TDB.find "FM_PULL_APART"
  fun op fmap_INDUCT _ = () val op fmap_INDUCT = TDB.find "fmap_INDUCT"
  fun op FCARD_SUC _ = () val op FCARD_SUC = TDB.find "FCARD_SUC"
  fun op FCARD_0_FEMPTY _ = ()
  val op FCARD_0_FEMPTY = TDB.find "FCARD_0_FEMPTY"
  fun op FCARD_FUPDATE _ = ()
  val op FCARD_FUPDATE = TDB.find "FCARD_FUPDATE"
  fun op FCARD_FEMPTY _ = () val op FCARD_FEMPTY = TDB.find "FCARD_FEMPTY"
  fun op FDOM_FINITE _ = () val op FDOM_FINITE = TDB.find "FDOM_FINITE"
  fun op FDOM_F_FEMPTY1 _ = ()
  val op FDOM_F_FEMPTY1 = TDB.find "FDOM_F_FEMPTY1"
  fun op FDOM_EQ_EMPTY_SYM _ = ()
  val op FDOM_EQ_EMPTY_SYM = TDB.find "FDOM_EQ_EMPTY_SYM"
  fun op FDOM_EQ_EMPTY _ = ()
  val op FDOM_EQ_EMPTY = TDB.find "FDOM_EQ_EMPTY"
  fun op fmap_SIMPLE_INDUCT _ = ()
  val op fmap_SIMPLE_INDUCT = TDB.find "fmap_SIMPLE_INDUCT"
  fun op FDOM_EQ_FDOM_FUPDATE _ = ()
  val op FDOM_EQ_FDOM_FUPDATE = TDB.find "FDOM_EQ_FDOM_FUPDATE"
  fun op NOT_EQ_FEMPTY_FUPDATE _ = ()
  val op NOT_EQ_FEMPTY_FUPDATE = TDB.find "NOT_EQ_FEMPTY_FUPDATE"
  fun op FAPPLY_FUPDATE_THM _ = ()
  val op FAPPLY_FUPDATE_THM = TDB.find "FAPPLY_FUPDATE_THM"
  fun op FDOM_FUPDATE _ = () val op FDOM_FUPDATE = TDB.find "FDOM_FUPDATE"
  fun op FDOM_FEMPTY _ = () val op FDOM_FEMPTY = TDB.find "FDOM_FEMPTY"
  fun op FUPDATE_EQ _ = () val op FUPDATE_EQ = TDB.find "FUPDATE_EQ"
  fun op FUPDATE_COMMUTES _ = ()
  val op FUPDATE_COMMUTES = TDB.find "FUPDATE_COMMUTES"
  fun op NOT_EQ_FAPPLY _ = ()
  val op NOT_EQ_FAPPLY = TDB.find "NOT_EQ_FAPPLY"
  fun op FAPPLY_FUPDATE _ = ()
  val op FAPPLY_FUPDATE = TDB.find "FAPPLY_FUPDATE"
  fun op is_fmap_cases _ = ()
  val op is_fmap_cases = TDB.find "is_fmap_cases"
  fun op is_fmap_strongind _ = ()
  val op is_fmap_strongind = TDB.find "is_fmap_strongind"
  fun op is_fmap_ind _ = () val op is_fmap_ind = TDB.find "is_fmap_ind"
  fun op is_fmap_rules _ = ()
  val op is_fmap_rules = TDB.find "is_fmap_rules"
  fun op EQ_FDOM_SUBMAP _ = ()
  val op EQ_FDOM_SUBMAP = TDB.find "EQ_FDOM_SUBMAP"
  fun op SUBMAP_FUPDATE_EQN _ = ()
  val op SUBMAP_FUPDATE_EQN = TDB.find "SUBMAP_FUPDATE_EQN"
  fun op SUBMAP_FDOM_SUBSET _ = ()
  val op SUBMAP_FDOM_SUBSET = TDB.find "SUBMAP_FDOM_SUBSET"
  fun op DRESTRICT_FEMPTY _ = ()
  val op DRESTRICT_FEMPTY = TDB.find "DRESTRICT_FEMPTY"
  fun op DRESTRICT_FUPDATE _ = ()
  val op DRESTRICT_FUPDATE = TDB.find "DRESTRICT_FUPDATE"
  fun op STRONG_DRESTRICT_FUPDATE _ = ()
  val op STRONG_DRESTRICT_FUPDATE = TDB.find "STRONG_DRESTRICT_FUPDATE"
  fun op FDOM_DRESTRICT _ = ()
  val op FDOM_DRESTRICT = TDB.find "FDOM_DRESTRICT"
  fun op NOT_FDOM_DRESTRICT _ = ()
  val op NOT_FDOM_DRESTRICT = TDB.find "NOT_FDOM_DRESTRICT"
  fun op DRESTRICT_SUBMAP _ = ()
  val op DRESTRICT_SUBMAP = TDB.find "DRESTRICT_SUBMAP"
  fun op DRESTRICT_DRESTRICT _ = ()
  val op DRESTRICT_DRESTRICT = TDB.find "DRESTRICT_DRESTRICT"
  fun op DRESTRICT_IS_FEMPTY _ = ()
  val op DRESTRICT_IS_FEMPTY = TDB.find "DRESTRICT_IS_FEMPTY"
  fun op FUPDATE_DRESTRICT _ = ()
  val op FUPDATE_DRESTRICT = TDB.find "FUPDATE_DRESTRICT"
  fun op STRONG_DRESTRICT_FUPDATE_THM _ = ()
  val op STRONG_DRESTRICT_FUPDATE_THM = TDB.find
    "STRONG_DRESTRICT_FUPDATE_THM"
  fun op DRESTRICT_UNIV _ = ()
  val op DRESTRICT_UNIV = TDB.find "DRESTRICT_UNIV"
  fun op SUBMAP_DRESTRICT _ = ()
  val op SUBMAP_DRESTRICT = TDB.find "SUBMAP_DRESTRICT"
  fun op SUBMAP_DRESTRICT_MONOTONE _ = ()
  val op SUBMAP_DRESTRICT_MONOTONE = TDB.find "SUBMAP_DRESTRICT_MONOTONE"
  fun op DRESTRICT_EQ_DRESTRICT _ = ()
  val op DRESTRICT_EQ_DRESTRICT = TDB.find "DRESTRICT_EQ_DRESTRICT"
  fun op FDOM_FUNION _ = () val op FDOM_FUNION = TDB.find "FDOM_FUNION"
  fun op FUNION_FEMPTY_1 _ = ()
  val op FUNION_FEMPTY_1 = TDB.find "FUNION_FEMPTY_1"
  fun op FUNION_FEMPTY_2 _ = ()
  val op FUNION_FEMPTY_2 = TDB.find "FUNION_FEMPTY_2"
  fun op FUNION_FUPDATE_1 _ = ()
  val op FUNION_FUPDATE_1 = TDB.find "FUNION_FUPDATE_1"
  fun op FUNION_FUPDATE_2 _ = ()
  val op FUNION_FUPDATE_2 = TDB.find "FUNION_FUPDATE_2"
  fun op FMERGE_DOMSUB _ = ()
  val op FMERGE_DOMSUB = TDB.find "FMERGE_DOMSUB"
  fun op SUBMAP_DOMSUB _ = ()
  val op SUBMAP_DOMSUB = TDB.find "SUBMAP_DOMSUB"
  fun op fmap_CASES _ = () val op fmap_CASES = TDB.find "fmap_CASES"
  fun op DOMSUB_NOT_IN_DOM _ = ()
  val op DOMSUB_NOT_IN_DOM = TDB.find "DOMSUB_NOT_IN_DOM"
  fun op o_f_FUPDATE _ = () val op o_f_FUPDATE = TDB.find "o_f_FUPDATE"
  fun op DOMSUB_COMMUTES _ = ()
  val op DOMSUB_COMMUTES = TDB.find "DOMSUB_COMMUTES"
  fun op DOMSUB_IDEM _ = () val op DOMSUB_IDEM = TDB.find "DOMSUB_IDEM"
  fun op o_f_DOMSUB _ = () val op o_f_DOMSUB = TDB.find "o_f_DOMSUB"
  fun op FRANGE_FUPDATE_DOMSUB _ = ()
  val op FRANGE_FUPDATE_DOMSUB = TDB.find "FRANGE_FUPDATE_DOMSUB"
  fun op DOMSUB_FLOOKUP_THM _ = ()
  val op DOMSUB_FLOOKUP_THM = TDB.find "DOMSUB_FLOOKUP_THM"
  fun op DOMSUB_FLOOKUP_NEQ _ = ()
  val op DOMSUB_FLOOKUP_NEQ = TDB.find "DOMSUB_FLOOKUP_NEQ"
  fun op DOMSUB_FLOOKUP _ = ()
  val op DOMSUB_FLOOKUP = TDB.find "DOMSUB_FLOOKUP"
  fun op DOMSUB_FAPPLY_THM _ = ()
  val op DOMSUB_FAPPLY_THM = TDB.find "DOMSUB_FAPPLY_THM"
  fun op DOMSUB_FAPPLY_NEQ _ = ()
  val op DOMSUB_FAPPLY_NEQ = TDB.find "DOMSUB_FAPPLY_NEQ"
  fun op DOMSUB_FAPPLY _ = ()
  val op DOMSUB_FAPPLY = TDB.find "DOMSUB_FAPPLY"
  fun op FDOM_DOMSUB _ = () val op FDOM_DOMSUB = TDB.find "FDOM_DOMSUB"
  fun op DOMSUB_FUPDATE_THM _ = ()
  val op DOMSUB_FUPDATE_THM = TDB.find "DOMSUB_FUPDATE_THM"
  fun op DOMSUB_FUPDATE_NEQ _ = ()
  val op DOMSUB_FUPDATE_NEQ = TDB.find "DOMSUB_FUPDATE_NEQ"
  fun op DOMSUB_FUPDATE _ = ()
  val op DOMSUB_FUPDATE = TDB.find "DOMSUB_FUPDATE"
  fun op DOMSUB_FEMPTY _ = ()
  val op DOMSUB_FEMPTY = TDB.find "DOMSUB_FEMPTY"
  fun op f_o_ASSOC _ = () val op f_o_ASSOC = TDB.find "f_o_ASSOC"
  fun op FINITE_PRED_11 _ = ()
  val op FINITE_PRED_11 = TDB.find "FINITE_PRED_11"
  fun op FAPPLY_f_o _ = () val op FAPPLY_f_o = TDB.find "FAPPLY_f_o"
  fun op f_o_FUPDATE _ = () val op f_o_FUPDATE = TDB.find "f_o_FUPDATE"
  fun op f_o_FEMPTY _ = () val op f_o_FEMPTY = TDB.find "f_o_FEMPTY"
  fun op FDOM_f_o _ = () val op FDOM_f_o = TDB.find "FDOM_f_o"
  fun op FLOOKUP_FUN_FMAP _ = ()
  val op FLOOKUP_FUN_FMAP = TDB.find "FLOOKUP_FUN_FMAP"
  fun op FDOM_FMAP _ = () val op FDOM_FMAP = TDB.find "FDOM_FMAP"
  fun op FRANGE_FMAP _ = () val op FRANGE_FMAP = TDB.find "FRANGE_FMAP"
  fun op FUN_FMAP_EMPTY _ = ()
  val op FUN_FMAP_EMPTY = TDB.find "FUN_FMAP_EMPTY"
  fun op RRESTRICT_FUPDATE _ = ()
  val op RRESTRICT_FUPDATE = TDB.find "RRESTRICT_FUPDATE"
  fun op RRESTRICT_FEMPTY _ = ()
  val op RRESTRICT_FEMPTY = TDB.find "RRESTRICT_FEMPTY"
  fun op o_f_cong _ = () val op o_f_cong = TDB.find "o_f_cong"
  fun op FRANGE_FUNION _ = ()
  val op FRANGE_FUNION = TDB.find "FRANGE_FUNION"
  fun op FRANGE_FLOOKUP _ = ()
  val op FRANGE_FLOOKUP = TDB.find "FRANGE_FLOOKUP"
  fun op o_f_FRANGE _ = () val op o_f_FRANGE = TDB.find "o_f_FRANGE"
  fun op FINITE_FRANGE _ = ()
  val op FINITE_FRANGE = TDB.find "FINITE_FRANGE"
  fun op SUBMAP_FRANGE _ = ()
  val op SUBMAP_FRANGE = TDB.find "SUBMAP_FRANGE"
  fun op FRANGE_FUPDATE _ = ()
  val op FRANGE_FUPDATE = TDB.find "FRANGE_FUPDATE"
  fun op FRANGE_FEMPTY _ = ()
  val op FRANGE_FEMPTY = TDB.find "FRANGE_FEMPTY"
  fun op FLOOKUP_o_f _ = () val op FLOOKUP_o_f = TDB.find "FLOOKUP_o_f"
  fun op o_f_o_f _ = () val op o_f_o_f = TDB.find "o_f_o_f"
  fun op FEVERY_o_f _ = () val op FEVERY_o_f = TDB.find "FEVERY_o_f"
  fun op o_f_id _ = () val op o_f_id = TDB.find "o_f_id"
  fun op o_f_FEMPTY _ = () val op o_f_FEMPTY = TDB.find "o_f_FEMPTY"
  fun op o_f_FAPPLY _ = () val op o_f_FAPPLY = TDB.find "o_f_FAPPLY"
  fun op FDOM_o_f _ = () val op FDOM_o_f = TDB.find "FDOM_o_f"
  fun op o_f_FDOM _ = () val op o_f_FDOM = TDB.find "o_f_FDOM"
  fun op f_o_f_FEMPTY_2 _ = ()
  val op f_o_f_FEMPTY_2 = TDB.find "f_o_f_FEMPTY_2"
  fun op f_o_f_FEMPTY_1 _ = ()
  val op f_o_f_FEMPTY_1 = TDB.find "f_o_f_FEMPTY_1"
  fun op FEVERY_FLOOKUP _ = ()
  val op FEVERY_FLOOKUP = TDB.find "FEVERY_FLOOKUP"
  fun op FEVERY_FUPDATE _ = ()
  val op FEVERY_FUPDATE = TDB.find "FEVERY_FUPDATE"
  fun op FEVERY_FEMPTY _ = ()
  val op FEVERY_FEMPTY = TDB.find "FEVERY_FEMPTY"
  fun op FLOOKUP_DRESTRICT _ = ()
  val op FLOOKUP_DRESTRICT = TDB.find "FLOOKUP_DRESTRICT"
  fun op fmap_eq_flookup _ = ()
  val op fmap_eq_flookup = TDB.find "fmap_eq_flookup"
  fun op FLOOKUP_EXT _ = () val op FLOOKUP_EXT = TDB.find "FLOOKUP_EXT"
  fun op FLOOKUP_FUNION _ = ()
  val op FLOOKUP_FUNION = TDB.find "FLOOKUP_FUNION"
  fun op SUBMAP_FUPDATE_FLOOKUP _ = ()
  val op SUBMAP_FUPDATE_FLOOKUP = TDB.find "SUBMAP_FUPDATE_FLOOKUP"
  fun op SUBMAP_FLOOKUP_EQN _ = ()
  val op SUBMAP_FLOOKUP_EQN = TDB.find "SUBMAP_FLOOKUP_EQN"
  fun op FLOOKUP_SUBMAP _ = ()
  val op FLOOKUP_SUBMAP = TDB.find "FLOOKUP_SUBMAP"
  fun op FLOOKUP_UPDATE _ = ()
  val op FLOOKUP_UPDATE = TDB.find "FLOOKUP_UPDATE"
  fun op FLOOKUP_EMPTY _ = ()
  val op FLOOKUP_EMPTY = TDB.find "FLOOKUP_EMPTY"
  fun op FMERGE_EQ_FEMPTY _ = ()
  val op FMERGE_EQ_FEMPTY = TDB.find "FMERGE_EQ_FEMPTY"
  fun op FMERGE_DRESTRICT _ = ()
  val op FMERGE_DRESTRICT = TDB.find "FMERGE_DRESTRICT"
  fun op FMERGE_ASSOC _ = () val op FMERGE_ASSOC = TDB.find "FMERGE_ASSOC"
  fun op FMERGE_COMM _ = () val op FMERGE_COMM = TDB.find "FMERGE_COMM"
  fun op FMERGE_NO_CHANGE _ = ()
  val op FMERGE_NO_CHANGE = TDB.find "FMERGE_NO_CHANGE"
  fun op FUNION_FMERGE _ = ()
  val op FUNION_FMERGE = TDB.find "FUNION_FMERGE"
  fun op FMERGE_FUNION _ = ()
  val op FMERGE_FUNION = TDB.find "FMERGE_FUNION"
  fun op FDOM_FMERGE _ = () val op FDOM_FMERGE = TDB.find "FDOM_FMERGE"
  fun op FMERGE_FEMPTY _ = ()
  val op FMERGE_FEMPTY = TDB.find "FMERGE_FEMPTY"
  fun op FUNION_IDEMPOT _ = ()
  val op FUNION_IDEMPOT = TDB.find "FUNION_IDEMPOT"
  fun op DRESTRICT_FUNION _ = ()
  val op DRESTRICT_FUNION = TDB.find "DRESTRICT_FUNION"
  fun op DRESTRICT_EQ_FUNION _ = ()
  val op DRESTRICT_EQ_FUNION = TDB.find "DRESTRICT_EQ_FUNION"
  fun op IN_FDOM_FOLDR_UNION _ = ()
  val op IN_FDOM_FOLDR_UNION = TDB.find "IN_FDOM_FOLDR_UNION"
  fun op DRESTRICT_FUNION_DRESTRICT_COMPL _ = ()
  val op DRESTRICT_FUNION_DRESTRICT_COMPL = TDB.find
    "DRESTRICT_FUNION_DRESTRICT_COMPL"
  fun op DRESTRICT_IDEMPOT _ = ()
  val op DRESTRICT_IDEMPOT = TDB.find "DRESTRICT_IDEMPOT"
  fun op SUBMAP_FUNION_ABSORPTION _ = ()
  val op SUBMAP_FUNION_ABSORPTION = TDB.find "SUBMAP_FUNION_ABSORPTION"
  fun op MAP_KEYS_witness _ = ()
  val op MAP_KEYS_witness = TDB.find "MAP_KEYS_witness"
  fun op MAP_KEYS_FEMPTY _ = ()
  val op MAP_KEYS_FEMPTY = TDB.find "MAP_KEYS_FEMPTY"
  fun op MAP_KEYS_FUPDATE _ = ()
  val op MAP_KEYS_FUPDATE = TDB.find "MAP_KEYS_FUPDATE"
  fun op MAP_KEYS_using_LINV _ = ()
  val op MAP_KEYS_using_LINV = TDB.find "MAP_KEYS_using_LINV"
  fun op MAP_KEYS_BIJ_LINV _ = ()
  val op MAP_KEYS_BIJ_LINV = TDB.find "MAP_KEYS_BIJ_LINV"
  fun op FLOOKUP_MAP_KEYS _ = ()
  val op FLOOKUP_MAP_KEYS = TDB.find "FLOOKUP_MAP_KEYS"
  fun op FLOOKUP_MAP_KEYS_MAPPED _ = ()
  val op FLOOKUP_MAP_KEYS_MAPPED = TDB.find "FLOOKUP_MAP_KEYS_MAPPED"
  fun op DRESTRICT_MAP_KEYS_IMAGE _ = ()
  val op DRESTRICT_MAP_KEYS_IMAGE = TDB.find "DRESTRICT_MAP_KEYS_IMAGE"
  fun op DOMSUB_MAP_KEYS _ = ()
  val op DOMSUB_MAP_KEYS = TDB.find "DOMSUB_MAP_KEYS"
  fun op fmap_rel_FUPDATE_same _ = ()
  val op fmap_rel_FUPDATE_same = TDB.find "fmap_rel_FUPDATE_same"
  fun op fmap_rel_FUPDATE_LIST_same _ = ()
  val op fmap_rel_FUPDATE_LIST_same = TDB.find "fmap_rel_FUPDATE_LIST_same"
  fun op fmap_rel_FEMPTY _ = ()
  val op fmap_rel_FEMPTY = TDB.find "fmap_rel_FEMPTY"
  fun op fmap_rel_FEMPTY2 _ = ()
  val op fmap_rel_FEMPTY2 = TDB.find "fmap_rel_FEMPTY2"
  fun op fmap_rel_refl _ = ()
  val op fmap_rel_refl = TDB.find "fmap_rel_refl"
  fun op fmap_rel_FUNION_rels _ = ()
  val op fmap_rel_FUNION_rels = TDB.find "fmap_rel_FUNION_rels"
  fun op fmap_rel_FUPDATE_I _ = ()
  val op fmap_rel_FUPDATE_I = TDB.find "fmap_rel_FUPDATE_I"
  fun op fmap_rel_mono _ = ()
  val op fmap_rel_mono = TDB.find "fmap_rel_mono"
  fun op fmap_rel_OPTREL_FLOOKUP _ = ()
  val op fmap_rel_OPTREL_FLOOKUP = TDB.find "fmap_rel_OPTREL_FLOOKUP"
  fun op fmap_rel_FLOOKUP_imp _ = ()
  val op fmap_rel_FLOOKUP_imp = TDB.find "fmap_rel_FLOOKUP_imp"
  fun op fmap_EQ_UPTO___EMPTY _ = ()
  val op fmap_EQ_UPTO___EMPTY = TDB.find "fmap_EQ_UPTO___EMPTY"
  fun op fmap_EQ_UPTO___EQ _ = ()
  val op fmap_EQ_UPTO___EQ = TDB.find "fmap_EQ_UPTO___EQ"
  fun op fmap_EQ_UPTO___FUPDATE_BOTH _ = ()
  val op fmap_EQ_UPTO___FUPDATE_BOTH = TDB.find
    "fmap_EQ_UPTO___FUPDATE_BOTH"
  fun op fmap_EQ_UPTO___FUPDATE_BOTH___NO_DELETE _ = ()
  val op fmap_EQ_UPTO___FUPDATE_BOTH___NO_DELETE = TDB.find
    "fmap_EQ_UPTO___FUPDATE_BOTH___NO_DELETE"
  fun op fmap_EQ_UPTO___FUPDATE_SING _ = ()
  val op fmap_EQ_UPTO___FUPDATE_SING = TDB.find
    "fmap_EQ_UPTO___FUPDATE_SING"
  fun op o_f_FUNION _ = () val op o_f_FUNION = TDB.find "o_f_FUNION"
  fun op FDOM_FOLDR_DOMSUB _ = ()
  val op FDOM_FOLDR_DOMSUB = TDB.find "FDOM_FOLDR_DOMSUB"
  fun op FEVERY_SUBMAP _ = ()
  val op FEVERY_SUBMAP = TDB.find "FEVERY_SUBMAP"
  fun op FEVERY_ALL_FLOOKUP _ = ()
  val op FEVERY_ALL_FLOOKUP = TDB.find "FEVERY_ALL_FLOOKUP"
  fun op FUPDATE_LIST_CANCEL _ = ()
  val op FUPDATE_LIST_CANCEL = TDB.find "FUPDATE_LIST_CANCEL"
  fun op FUPDATE_EQ_FUNION _ = ()
  val op FUPDATE_EQ_FUNION = TDB.find "FUPDATE_EQ_FUNION"
  fun op FUPDATE_LIST_APPEND_COMMUTES _ = ()
  val op FUPDATE_LIST_APPEND_COMMUTES = TDB.find
    "FUPDATE_LIST_APPEND_COMMUTES"
  fun op FUPDATE_LIST_ALL_DISTINCT_PERM _ = ()
  val op FUPDATE_LIST_ALL_DISTINCT_PERM = TDB.find
    "FUPDATE_LIST_ALL_DISTINCT_PERM"
  fun op FDOM_FDIFF _ = () val op FDOM_FDIFF = TDB.find "FDOM_FDIFF"
  fun op NUM_NOT_IN_FDOM _ = ()
  val op NUM_NOT_IN_FDOM = TDB.find "NUM_NOT_IN_FDOM"
  fun op LEAST_NOTIN_FDOM _ = ()
  val op LEAST_NOTIN_FDOM = TDB.find "LEAST_NOTIN_FDOM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val finite_map_grammars = merge_grammars ["sorting"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="finite_map"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val finite_map_grammars = 
    Portable.## (addtyUDs,addtmUDs) finite_map_grammars
  val _ = Parse.grammarDB_insert("finite_map",finite_map_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ = 
   TypeBase.write
   [TypeBasePure.mk_nondatatype_info
    (mk_type("fmap",[alpha,beta]),
      {nchotomy = SOME fmap_CASES,
       induction = SOME fmap_INDUCT,
       size = SOME(Parse.Term`\(ksize:'a->num) (vsize:'b->num). fmap_size (\k:'a. 0) (\v. 1 + vsize v)`,
                   fmap_size_def),
       encode=NONE})];
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "finite_map"

end
