structure fmapalTheory :> fmapalTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading fmapalTheory ... "
    else ()
  
  open Type Term Thm
  local open enumeralTheory finite_mapTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "fmapal"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/fmapalTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op optry _ = () val op optry = TDB.find "optry"
  fun op vcossa _ = () val op vcossa = TDB.find "vcossa"
  fun op OPTION_UPDATE _ = ()
  val op OPTION_UPDATE = TDB.find "OPTION_UPDATE"
  fun op incr_build _ = () val op incr_build = TDB.find "incr_build"
  fun op incr_flat _ = () val op incr_flat = TDB.find "incr_flat"
  fun op incr_sort _ = () val op incr_sort = TDB.find "incr_sort"
  fun op OPTION_FLAT_primitive _ = ()
  val op OPTION_FLAT_primitive = TDB.find "OPTION_FLAT_primitive"
  fun op unlookup _ = () val op unlookup = TDB.find "unlookup"
  fun op bt_to_fmap_lb _ = ()
  val op bt_to_fmap_lb = TDB.find "bt_to_fmap_lb"
  fun op bt_to_fmap_ub _ = ()
  val op bt_to_fmap_ub = TDB.find "bt_to_fmap_ub"
  fun op bt_to_fmap_lb_ub _ = ()
  val op bt_to_fmap_lb_ub = TDB.find "bt_to_fmap_lb_ub"
  fun op bt_map _ = () val op bt_map = TDB.find "bt_map"
  fun op fmap _ = () val op fmap = TDB.find "fmap"
  fun op bt_to_orl_lb_ub_ac_tupled_AUX _ = ()
  val op bt_to_orl_lb_ub_ac_tupled_AUX = TDB.find
    "bt_to_orl_lb_ub_ac_tupled_AUX"
  fun op ORWL _ = () val op ORWL = TDB.find "ORWL"
  fun op OFU _ = () val op OFU = TDB.find "OFU"
  fun op UFO _ = () val op UFO = TDB.find "UFO"
  fun op AP_SND _ = () val op AP_SND = TDB.find "AP_SND"
  fun op ORL_ind _ = () val op ORL_ind = TDB.find "ORL_ind"
  fun op ORL _ = () val op ORL = TDB.find "ORL"
  fun op optry_list_ind _ = ()
  val op optry_list_ind = TDB.find "optry_list_ind"
  fun op optry_list _ = () val op optry_list = TDB.find "optry_list"
  fun op assocv_ind _ = () val op assocv_ind = TDB.find "assocv_ind"
  fun op assocv _ = () val op assocv = TDB.find "assocv"
  fun op merge_ind _ = () val op merge_ind = TDB.find "merge_ind"
  fun op merge _ = () val op merge = TDB.find "merge"
  fun op incr_merge_ind _ = ()
  val op incr_merge_ind = TDB.find "incr_merge_ind"
  fun op incr_merge _ = () val op incr_merge = TDB.find "incr_merge"
  fun op ORL_sublists_ind _ = ()
  val op ORL_sublists_ind = TDB.find "ORL_sublists_ind"
  fun op ORL_sublists _ = () val op ORL_sublists = TDB.find "ORL_sublists"
  fun op merge_out_ind _ = ()
  val op merge_out_ind = TDB.find "merge_out_ind"
  fun op merge_out _ = () val op merge_out = TDB.find "merge_out"
  fun op OPTION_FLAT_ind _ = ()
  val op OPTION_FLAT_ind = TDB.find "OPTION_FLAT_ind"
  fun op OPTION_FLAT _ = () val op OPTION_FLAT = TDB.find "OPTION_FLAT"
  fun op bt_to_fmap_ind _ = ()
  val op bt_to_fmap_ind = TDB.find "bt_to_fmap_ind"
  fun op bt_to_fmap _ = () val op bt_to_fmap = TDB.find "bt_to_fmap"
  fun op FAPPLY_nt _ = () val op FAPPLY_nt = TDB.find "FAPPLY_nt"
  fun op FAPPLY_node _ = () val op FAPPLY_node = TDB.find "FAPPLY_node"
  fun op bt_FST_FDOM _ = () val op bt_FST_FDOM = TDB.find "bt_FST_FDOM"
  fun op bt_to_orl_lb_ub_ind _ = ()
  val op bt_to_orl_lb_ub_ind = TDB.find "bt_to_orl_lb_ub_ind"
  fun op bt_to_orl_lb_ub _ = ()
  val op bt_to_orl_lb_ub = TDB.find "bt_to_orl_lb_ub"
  fun op bt_to_orl_lb_ind _ = ()
  val op bt_to_orl_lb_ind = TDB.find "bt_to_orl_lb_ind"
  fun op bt_to_orl_lb _ = () val op bt_to_orl_lb = TDB.find "bt_to_orl_lb"
  fun op bt_to_orl_ub_ind _ = ()
  val op bt_to_orl_ub_ind = TDB.find "bt_to_orl_ub_ind"
  fun op bt_to_orl_ub _ = () val op bt_to_orl_ub = TDB.find "bt_to_orl_ub"
  fun op bt_to_orl_ind _ = ()
  val op bt_to_orl_ind = TDB.find "bt_to_orl_ind"
  fun op bt_to_orl _ = () val op bt_to_orl = TDB.find "bt_to_orl"
  fun op bt_to_orl_lb_ub_ac_ind _ = ()
  val op bt_to_orl_lb_ub_ac_ind = TDB.find "bt_to_orl_lb_ub_ac_ind"
  fun op bt_to_orl_lb_ub_ac _ = ()
  val op bt_to_orl_lb_ub_ac = TDB.find "bt_to_orl_lb_ub_ac"
  fun op bt_to_orl_lb_ac_ind _ = ()
  val op bt_to_orl_lb_ac_ind = TDB.find "bt_to_orl_lb_ac_ind"
  fun op bt_to_orl_lb_ac _ = ()
  val op bt_to_orl_lb_ac = TDB.find "bt_to_orl_lb_ac"
  fun op bt_to_orl_ub_ac_ind _ = ()
  val op bt_to_orl_ub_ac_ind = TDB.find "bt_to_orl_ub_ac_ind"
  fun op bt_to_orl_ub_ac _ = ()
  val op bt_to_orl_ub_ac = TDB.find "bt_to_orl_ub_ac"
  fun op bt_to_orl_ac_ind _ = ()
  val op bt_to_orl_ac_ind = TDB.find "bt_to_orl_ac_ind"
  fun op bt_to_orl_ac _ = () val op bt_to_orl_ac = TDB.find "bt_to_orl_ac"
  fun op ORWL_bt_to_orl _ = ()
  val op ORWL_bt_to_orl = TDB.find "ORWL_bt_to_orl"
  fun op bl_to_fmap_ind _ = ()
  val op bl_to_fmap_ind = TDB.find "bl_to_fmap_ind"
  fun op bl_to_fmap _ = () val op bl_to_fmap = TDB.find "bl_to_fmap"
  fun op bt_to_orl_ID_IMP _ = ()
  val op bt_to_orl_ID_IMP = TDB.find "bt_to_orl_ID_IMP"
  fun op fmap_FDOM _ = () val op fmap_FDOM = TDB.find "fmap_FDOM"
  fun op ORL_FUNION_IMP _ = ()
  val op ORL_FUNION_IMP = TDB.find "ORL_FUNION_IMP"
  fun op FMAPAL_FDOM_THM _ = ()
  val op FMAPAL_FDOM_THM = TDB.find "FMAPAL_FDOM_THM"
  fun op inter_merge_ind _ = ()
  val op inter_merge_ind = TDB.find "inter_merge_ind"
  fun op inter_merge _ = () val op inter_merge = TDB.find "inter_merge"
  fun op ORL_DRESTRICT_IMP _ = ()
  val op ORL_DRESTRICT_IMP = TDB.find "ORL_DRESTRICT_IMP"
  fun op diff_merge_ind _ = ()
  val op diff_merge_ind = TDB.find "diff_merge_ind"
  fun op diff_merge _ = () val op diff_merge = TDB.find "diff_merge"
  fun op ORL_DRESTRICT_COMPL_IMP _ = ()
  val op ORL_DRESTRICT_COMPL_IMP = TDB.find "ORL_DRESTRICT_COMPL_IMP"
  fun op FMAPAL_fmap _ = () val op FMAPAL_fmap = TDB.find "FMAPAL_fmap"
  fun op ORL_FMAPAL _ = () val op ORL_FMAPAL = TDB.find "ORL_FMAPAL"
  fun op ORWL_FUNION_THM _ = ()
  val op ORWL_FUNION_THM = TDB.find "ORWL_FUNION_THM"
  fun op ORWL_DRESTRICT_THM _ = ()
  val op ORWL_DRESTRICT_THM = TDB.find "ORWL_DRESTRICT_THM"
  fun op ORWL_DRESTRICT_COMPL_THM _ = ()
  val op ORWL_DRESTRICT_COMPL_THM = TDB.find "ORWL_DRESTRICT_COMPL_THM"
  fun op o_f_bt_map _ = () val op o_f_bt_map = TDB.find "o_f_bt_map"
  fun op FAPPLY_fmap_NIL _ = ()
  val op FAPPLY_fmap_NIL = TDB.find "FAPPLY_fmap_NIL"
  fun op FAPPLY_fmap_CONS _ = ()
  val op FAPPLY_fmap_CONS = TDB.find "FAPPLY_fmap_CONS"
  fun op o_f_fmap _ = () val op o_f_fmap = TDB.find "o_f_fmap"
  fun op ORL_bt_lb_ub_ind _ = ()
  val op ORL_bt_lb_ub_ind = TDB.find "ORL_bt_lb_ub_ind"
  fun op ORL_bt_lb_ub _ = () val op ORL_bt_lb_ub = TDB.find "ORL_bt_lb_ub"
  fun op ORL_bt_lb_ind _ = ()
  val op ORL_bt_lb_ind = TDB.find "ORL_bt_lb_ind"
  fun op ORL_bt_lb _ = () val op ORL_bt_lb = TDB.find "ORL_bt_lb"
  fun op ORL_bt_ub_ind _ = ()
  val op ORL_bt_ub_ind = TDB.find "ORL_bt_ub_ind"
  fun op ORL_bt_ub _ = () val op ORL_bt_ub = TDB.find "ORL_bt_ub"
  fun op ORL_bt_ind _ = () val op ORL_bt_ind = TDB.find "ORL_bt_ind"
  fun op ORL_bt _ = () val op ORL_bt = TDB.find "ORL_bt"
  fun op better_bt_to_orl _ = ()
  val op better_bt_to_orl = TDB.find "better_bt_to_orl"
  fun op list_rplacv_cn_ind _ = ()
  val op list_rplacv_cn_ind = TDB.find "list_rplacv_cn_ind"
  fun op list_rplacv_cn _ = ()
  val op list_rplacv_cn = TDB.find "list_rplacv_cn"
  fun op fmap_FDOM_rec _ = ()
  val op fmap_FDOM_rec = TDB.find "fmap_FDOM_rec"
  fun op list_rplacv_thm _ = ()
  val op list_rplacv_thm = TDB.find "list_rplacv_thm"
  fun op bt_rplacv_cn_ind _ = ()
  val op bt_rplacv_cn_ind = TDB.find "bt_rplacv_cn_ind"
  fun op bt_rplacv_cn _ = () val op bt_rplacv_cn = TDB.find "bt_rplacv_cn"
  fun op bt_rplacv_thm _ = ()
  val op bt_rplacv_thm = TDB.find "bt_rplacv_thm"
  fun op FUN_fmap_thm _ = () val op FUN_fmap_thm = TDB.find "FUN_fmap_thm"
  fun op fmap_ORWL_thm _ = ()
  val op fmap_ORWL_thm = TDB.find "fmap_ORWL_thm"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val fmapal_grammars = merge_grammars ["finite_map", "enumeral"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="fmapal"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val fmapal_grammars = 
    Portable.## (addtyUDs,addtmUDs) fmapal_grammars
  val _ = Parse.grammarDB_insert("fmapal",fmapal_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "fmapal"

end
