structure fmaptreeTheory :> fmaptreeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading fmaptreeTheory ... "
    else ()
  
  open Type Term Thm
  local open finite_mapTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "fmaptree"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/fmaptreeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op construct_def _ = ()
  val op construct_def = TDB.find "construct_def"
  fun op wf_def _ = () val op wf_def = TDB.find "wf_def"
  fun op fmaptree_TY_DEF _ = ()
  val op fmaptree_TY_DEF = TDB.find "fmaptree_TY_DEF"
  fun op fmap_bij_thm _ = () val op fmap_bij_thm = TDB.find "fmap_bij_thm"
  fun op FTNode_def _ = () val op FTNode_def = TDB.find "FTNode_def"
  fun op item_map_def _ = () val op item_map_def = TDB.find "item_map_def"
  fun op apply_path_def _ = ()
  val op apply_path_def = TDB.find "apply_path_def"
  fun op update_at_path_def _ = ()
  val op update_at_path_def = TDB.find "update_at_path_def"
  fun op fupd_at_path_def _ = ()
  val op fupd_at_path_def = TDB.find "fupd_at_path_def"
  fun op relrec_def _ = () val op relrec_def = TDB.find "relrec_def"
  fun op fmtreerec_def _ = ()
  val op fmtreerec_def = TDB.find "fmtreerec_def"
  fun op wf_rules _ = () val op wf_rules = TDB.find "wf_rules"
  fun op wf_ind _ = () val op wf_ind = TDB.find "wf_ind"
  fun op wf_strongind _ = () val op wf_strongind = TDB.find "wf_strongind"
  fun op wf_cases _ = () val op wf_cases = TDB.find "wf_cases"
  fun op FTNode_11 _ = () val op FTNode_11 = TDB.find "FTNode_11"
  fun op fmaptree_nchotomy _ = ()
  val op fmaptree_nchotomy = TDB.find "fmaptree_nchotomy"
  fun op item_thm _ = () val op item_thm = TDB.find "item_thm"
  fun op map_thm _ = () val op map_thm = TDB.find "map_thm"
  fun op ft_ind _ = () val op ft_ind = TDB.find "ft_ind"
  fun op applicable_paths_FINITE _ = ()
  val op applicable_paths_FINITE = TDB.find "applicable_paths_FINITE"
  fun op apply_path_SNOC _ = ()
  val op apply_path_SNOC = TDB.find "apply_path_SNOC"
  fun op relrec_rules _ = () val op relrec_rules = TDB.find "relrec_rules"
  fun op relrec_ind _ = () val op relrec_ind = TDB.find "relrec_ind"
  fun op relrec_strongind _ = ()
  val op relrec_strongind = TDB.find "relrec_strongind"
  fun op relrec_cases _ = () val op relrec_cases = TDB.find "relrec_cases"
  fun op fmtreerec_thm _ = ()
  val op fmtreerec_thm = TDB.find "fmtreerec_thm"
  fun op fmtree_Axiom _ = () val op fmtree_Axiom = TDB.find "fmtree_Axiom"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val fmaptree_grammars = merge_grammars ["finite_map"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="fmaptree"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val fmaptree_grammars = 
    Portable.## (addtyUDs,addtmUDs) fmaptree_grammars
  val _ = Parse.grammarDB_insert("fmaptree",fmaptree_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "fmaptree"

end
