structure patriciaTheory :> patriciaTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading patriciaTheory ... "
    else ()
  
  open Type Term Thm
  local open sortingTheory wordsTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "patricia"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/patriciaTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ptree_TY_DEF _ = () val op ptree_TY_DEF = TDB.find "ptree_TY_DEF"
  fun op ptree_case_def _ = ()
  val op ptree_case_def = TDB.find "ptree_case_def"
  fun op ptree_size_def _ = ()
  val op ptree_size_def = TDB.find "ptree_size_def"
  fun op JOIN_def _ = () val op JOIN_def = TDB.find "JOIN_def"
  fun op BRANCH_primitive_def _ = ()
  val op BRANCH_primitive_def = TDB.find "BRANCH_primitive_def"
  fun op REMOVE_def _ = () val op REMOVE_def = TDB.find "REMOVE_def"
  fun op TRAVERSE_AUX_def _ = ()
  val op TRAVERSE_AUX_def = TDB.find "TRAVERSE_AUX_def"
  fun op TRAVERSE_def _ = () val op TRAVERSE_def = TDB.find "TRAVERSE_def"
  fun op KEYS_def _ = () val op KEYS_def = TDB.find "KEYS_def"
  fun op TRANSFORM_def _ = ()
  val op TRANSFORM_def = TDB.find "TRANSFORM_def"
  fun op EVERY_LEAF_def _ = ()
  val op EVERY_LEAF_def = TDB.find "EVERY_LEAF_def"
  fun op EXISTS_LEAF_def _ = ()
  val op EXISTS_LEAF_def = TDB.find "EXISTS_LEAF_def"
  fun op SIZE_def _ = () val op SIZE_def = TDB.find "SIZE_def"
  fun op DEPTH_def _ = () val op DEPTH_def = TDB.find "DEPTH_def"
  fun op IS_PTREE_def _ = () val op IS_PTREE_def = TDB.find "IS_PTREE_def"
  fun op IN_PTREE_def _ = () val op IN_PTREE_def = TDB.find "IN_PTREE_def"
  fun op INSERT_PTREE_def _ = ()
  val op INSERT_PTREE_def = TDB.find "INSERT_PTREE_def"
  fun op PTREE_OF_NUMSET_def _ = ()
  val op PTREE_OF_NUMSET_def = TDB.find "PTREE_OF_NUMSET_def"
  fun op NUMSET_OF_PTREE_def _ = ()
  val op NUMSET_OF_PTREE_def = TDB.find "NUMSET_OF_PTREE_def"
  fun op UNION_PTREE_def _ = ()
  val op UNION_PTREE_def = TDB.find "UNION_PTREE_def"
  fun op IS_EMPTY_primitive_def _ = ()
  val op IS_EMPTY_primitive_def = TDB.find "IS_EMPTY_primitive_def"
  fun op FIND_def _ = () val op FIND_def = TDB.find "FIND_def"
  fun op ADD_LIST_def _ = () val op ADD_LIST_def = TDB.find "ADD_LIST_def"
  fun op datatype_ptree _ = ()
  val op datatype_ptree = TDB.find "datatype_ptree"
  fun op ptree_11 _ = () val op ptree_11 = TDB.find "ptree_11"
  fun op ptree_distinct _ = ()
  val op ptree_distinct = TDB.find "ptree_distinct"
  fun op ptree_nchotomy _ = ()
  val op ptree_nchotomy = TDB.find "ptree_nchotomy"
  fun op ptree_Axiom _ = () val op ptree_Axiom = TDB.find "ptree_Axiom"
  fun op ptree_induction _ = ()
  val op ptree_induction = TDB.find "ptree_induction"
  fun op ptree_case_cong _ = ()
  val op ptree_case_cong = TDB.find "ptree_case_cong"
  fun op ptree_case_eq _ = ()
  val op ptree_case_eq = TDB.find "ptree_case_eq"
  fun op BRANCHING_BIT_ind _ = ()
  val op BRANCHING_BIT_ind = TDB.find "BRANCHING_BIT_ind"
  fun op BRANCHING_BIT_def _ = ()
  val op BRANCHING_BIT_def = TDB.find "BRANCHING_BIT_def"
  fun op PEEK_ind _ = () val op PEEK_ind = TDB.find "PEEK_ind"
  fun op PEEK_def _ = () val op PEEK_def = TDB.find "PEEK_def"
  fun op ADD_ind _ = () val op ADD_ind = TDB.find "ADD_ind"
  fun op ADD_def _ = () val op ADD_def = TDB.find "ADD_def"
  fun op BRANCH_ind _ = () val op BRANCH_ind = TDB.find "BRANCH_ind"
  fun op BRANCH_def _ = () val op BRANCH_def = TDB.find "BRANCH_def"
  fun op IS_EMPTY_ind _ = () val op IS_EMPTY_ind = TDB.find "IS_EMPTY_ind"
  fun op IS_EMPTY_def _ = () val op IS_EMPTY_def = TDB.find "IS_EMPTY_def"
  fun op BRANCHING_BIT _ = ()
  val op BRANCHING_BIT = TDB.find "BRANCHING_BIT"
  fun op BRANCHING_BIT_ZERO _ = ()
  val op BRANCHING_BIT_ZERO = TDB.find "BRANCHING_BIT_ZERO"
  fun op BRANCHING_BIT_SYM _ = ()
  val op BRANCHING_BIT_SYM = TDB.find "BRANCHING_BIT_SYM"
  fun op EVERY_LEAF_ADD _ = ()
  val op EVERY_LEAF_ADD = TDB.find "EVERY_LEAF_ADD"
  fun op MONO_EVERY_LEAF _ = ()
  val op MONO_EVERY_LEAF = TDB.find "MONO_EVERY_LEAF"
  fun op NOT_ADD_EMPTY _ = ()
  val op NOT_ADD_EMPTY = TDB.find "NOT_ADD_EMPTY"
  fun op EMPTY_IS_PTREE _ = ()
  val op EMPTY_IS_PTREE = TDB.find "EMPTY_IS_PTREE"
  fun op ADD_IS_PTREE _ = () val op ADD_IS_PTREE = TDB.find "ADD_IS_PTREE"
  fun op EVERY_LEAF_BRANCH _ = ()
  val op EVERY_LEAF_BRANCH = TDB.find "EVERY_LEAF_BRANCH"
  fun op EVERY_LEAF_REMOVE _ = ()
  val op EVERY_LEAF_REMOVE = TDB.find "EVERY_LEAF_REMOVE"
  fun op IS_PTREE_BRANCH _ = ()
  val op IS_PTREE_BRANCH = TDB.find "IS_PTREE_BRANCH"
  fun op REMOVE_IS_PTREE _ = ()
  val op REMOVE_IS_PTREE = TDB.find "REMOVE_IS_PTREE"
  fun op PEEK_NONE _ = () val op PEEK_NONE = TDB.find "PEEK_NONE"
  fun op PEEK_ADD _ = () val op PEEK_ADD = TDB.find "PEEK_ADD"
  fun op BRANCH _ = () val op BRANCH = TDB.find "BRANCH"
  fun op PEEK_REMOVE _ = () val op PEEK_REMOVE = TDB.find "PEEK_REMOVE"
  fun op EVERY_LEAF_TRANSFORM _ = ()
  val op EVERY_LEAF_TRANSFORM = TDB.find "EVERY_LEAF_TRANSFORM"
  fun op TRANSFORM_EMPTY _ = ()
  val op TRANSFORM_EMPTY = TDB.find "TRANSFORM_EMPTY"
  fun op TRANSFORM_IS_PTREE _ = ()
  val op TRANSFORM_IS_PTREE = TDB.find "TRANSFORM_IS_PTREE"
  fun op PEEK_TRANSFORM _ = ()
  val op PEEK_TRANSFORM = TDB.find "PEEK_TRANSFORM"
  fun op ADD_TRANSFORM _ = ()
  val op ADD_TRANSFORM = TDB.find "ADD_TRANSFORM"
  fun op TRANSFORM_BRANCH _ = ()
  val op TRANSFORM_BRANCH = TDB.find "TRANSFORM_BRANCH"
  fun op REMOVE_TRANSFORM _ = ()
  val op REMOVE_TRANSFORM = TDB.find "REMOVE_TRANSFORM"
  fun op REMOVE_ADD_EQ _ = ()
  val op REMOVE_ADD_EQ = TDB.find "REMOVE_ADD_EQ"
  fun op ADD_ADD _ = () val op ADD_ADD = TDB.find "ADD_ADD"
  fun op EVERY_LEAF_PEEK _ = ()
  val op EVERY_LEAF_PEEK = TDB.find "EVERY_LEAF_PEEK"
  fun op IS_PTREE_PEEK _ = ()
  val op IS_PTREE_PEEK = TDB.find "IS_PTREE_PEEK"
  fun op PTREE_EQ _ = () val op PTREE_EQ = TDB.find "PTREE_EQ"
  fun op REMOVE_REMOVE _ = ()
  val op REMOVE_REMOVE = TDB.find "REMOVE_REMOVE"
  fun op REMOVE_ADD _ = () val op REMOVE_ADD = TDB.find "REMOVE_ADD"
  fun op ADD_ADD_SYM _ = () val op ADD_ADD_SYM = TDB.find "ADD_ADD_SYM"
  fun op FILTER_ALL _ = () val op FILTER_ALL = TDB.find "FILTER_ALL"
  fun op TRAVERSE_TRANSFORM _ = ()
  val op TRAVERSE_TRANSFORM = TDB.find "TRAVERSE_TRANSFORM"
  fun op MEM_TRAVERSE_PEEK _ = ()
  val op MEM_TRAVERSE_PEEK = TDB.find "MEM_TRAVERSE_PEEK"
  fun op IN_NUMSET_OF_PTREE _ = ()
  val op IN_NUMSET_OF_PTREE = TDB.find "IN_NUMSET_OF_PTREE"
  fun op ADD_LIST_IS_PTREE _ = ()
  val op ADD_LIST_IS_PTREE = TDB.find "ADD_LIST_IS_PTREE"
  fun op ADD_LIST_TO_EMPTY_IS_PTREE _ = ()
  val op ADD_LIST_TO_EMPTY_IS_PTREE = TDB.find "ADD_LIST_TO_EMPTY_IS_PTREE"
  fun op PTREE_OF_NUMSET_IS_PTREE _ = ()
  val op PTREE_OF_NUMSET_IS_PTREE = TDB.find "PTREE_OF_NUMSET_IS_PTREE"
  fun op PTREE_OF_NUMSET_IS_PTREE_EMPTY _ = ()
  val op PTREE_OF_NUMSET_IS_PTREE_EMPTY = TDB.find
    "PTREE_OF_NUMSET_IS_PTREE_EMPTY"
  fun op NOT_KEY_LEFT_AND_RIGHT _ = ()
  val op NOT_KEY_LEFT_AND_RIGHT = TDB.find "NOT_KEY_LEFT_AND_RIGHT"
  fun op ALL_DISTINCT_TRAVERSE _ = ()
  val op ALL_DISTINCT_TRAVERSE = TDB.find "ALL_DISTINCT_TRAVERSE"
  fun op MEM_ALL_DISTINCT_IMP_PERM _ = ()
  val op MEM_ALL_DISTINCT_IMP_PERM = TDB.find "MEM_ALL_DISTINCT_IMP_PERM"
  fun op MEM_TRAVERSE _ = () val op MEM_TRAVERSE = TDB.find "MEM_TRAVERSE"
  fun op INSERT_PTREE_IS_PTREE _ = ()
  val op INSERT_PTREE_IS_PTREE = TDB.find "INSERT_PTREE_IS_PTREE"
  fun op FINITE_NUMSET_OF_PTREE _ = ()
  val op FINITE_NUMSET_OF_PTREE = TDB.find "FINITE_NUMSET_OF_PTREE"
  fun op ADD_INSERT _ = () val op ADD_INSERT = TDB.find "ADD_INSERT"
  fun op PEEK_INSERT_PTREE _ = ()
  val op PEEK_INSERT_PTREE = TDB.find "PEEK_INSERT_PTREE"
  fun op MEM_TRAVERSE_INSERT_PTREE _ = ()
  val op MEM_TRAVERSE_INSERT_PTREE = TDB.find "MEM_TRAVERSE_INSERT_PTREE"
  fun op PERM_INSERT_PTREE _ = ()
  val op PERM_INSERT_PTREE = TDB.find "PERM_INSERT_PTREE"
  fun op IN_PTREE_OF_NUMSET _ = ()
  val op IN_PTREE_OF_NUMSET = TDB.find "IN_PTREE_OF_NUMSET"
  fun op IN_PTREE_EMPTY _ = ()
  val op IN_PTREE_EMPTY = TDB.find "IN_PTREE_EMPTY"
  fun op IN_PTREE_OF_NUMSET_EMPTY _ = ()
  val op IN_PTREE_OF_NUMSET_EMPTY = TDB.find "IN_PTREE_OF_NUMSET_EMPTY"
  fun op PTREE_EXTENSION _ = ()
  val op PTREE_EXTENSION = TDB.find "PTREE_EXTENSION"
  fun op PTREE_OF_NUMSET_NUMSET_OF_PTREE _ = ()
  val op PTREE_OF_NUMSET_NUMSET_OF_PTREE = TDB.find
    "PTREE_OF_NUMSET_NUMSET_OF_PTREE"
  fun op NUMSET_OF_PTREE_PTREE_OF_NUMSET _ = ()
  val op NUMSET_OF_PTREE_PTREE_OF_NUMSET = TDB.find
    "NUMSET_OF_PTREE_PTREE_OF_NUMSET"
  fun op NUMSET_OF_PTREE_EMPTY _ = ()
  val op NUMSET_OF_PTREE_EMPTY = TDB.find "NUMSET_OF_PTREE_EMPTY"
  fun op PTREE_OF_NUMSET_EMPTY _ = ()
  val op PTREE_OF_NUMSET_EMPTY = TDB.find "PTREE_OF_NUMSET_EMPTY"
  fun op NUMSET_OF_PTREE_PTREE_OF_NUMSET_EMPTY _ = ()
  val op NUMSET_OF_PTREE_PTREE_OF_NUMSET_EMPTY = TDB.find
    "NUMSET_OF_PTREE_PTREE_OF_NUMSET_EMPTY"
  fun op IN_PTREE_INSERT_PTREE _ = ()
  val op IN_PTREE_INSERT_PTREE = TDB.find "IN_PTREE_INSERT_PTREE"
  fun op IN_PTREE_REMOVE _ = ()
  val op IN_PTREE_REMOVE = TDB.find "IN_PTREE_REMOVE"
  fun op IN_PTREE_UNION_PTREE _ = ()
  val op IN_PTREE_UNION_PTREE = TDB.find "IN_PTREE_UNION_PTREE"
  fun op UNION_PTREE_IS_PTREE _ = ()
  val op UNION_PTREE_IS_PTREE = TDB.find "UNION_PTREE_IS_PTREE"
  fun op UNION_PTREE_COMM _ = ()
  val op UNION_PTREE_COMM = TDB.find "UNION_PTREE_COMM"
  fun op UNION_PTREE_COMM_EMPTY _ = ()
  val op UNION_PTREE_COMM_EMPTY = TDB.find "UNION_PTREE_COMM_EMPTY"
  fun op UNION_PTREE_EMPTY _ = ()
  val op UNION_PTREE_EMPTY = TDB.find "UNION_PTREE_EMPTY"
  fun op UNION_PTREE_ASSOC _ = ()
  val op UNION_PTREE_ASSOC = TDB.find "UNION_PTREE_ASSOC"
  fun op PTREE_OF_NUMSET_UNION _ = ()
  val op PTREE_OF_NUMSET_UNION = TDB.find "PTREE_OF_NUMSET_UNION"
  fun op PTREE_OF_NUMSET_INSERT _ = ()
  val op PTREE_OF_NUMSET_INSERT = TDB.find "PTREE_OF_NUMSET_INSERT"
  fun op PTREE_OF_NUMSET_INSERT_EMPTY _ = ()
  val op PTREE_OF_NUMSET_INSERT_EMPTY = TDB.find
    "PTREE_OF_NUMSET_INSERT_EMPTY"
  fun op PTREE_OF_NUMSET_DELETE _ = ()
  val op PTREE_OF_NUMSET_DELETE = TDB.find "PTREE_OF_NUMSET_DELETE"
  fun op TRAVERSE_AUX _ = () val op TRAVERSE_AUX = TDB.find "TRAVERSE_AUX"
  fun op PTREE_TRAVERSE_EQ _ = ()
  val op PTREE_TRAVERSE_EQ = TDB.find "PTREE_TRAVERSE_EQ"
  fun op QSORT_MEM_EQ _ = () val op QSORT_MEM_EQ = TDB.find "QSORT_MEM_EQ"
  fun op KEYS_PEEK _ = () val op KEYS_PEEK = TDB.find "KEYS_PEEK"
  fun op PERM_ADD _ = () val op PERM_ADD = TDB.find "PERM_ADD"
  fun op PERM_NOT_ADD _ = () val op PERM_NOT_ADD = TDB.find "PERM_NOT_ADD"
  fun op PERM_NOT_REMOVE _ = ()
  val op PERM_NOT_REMOVE = TDB.find "PERM_NOT_REMOVE"
  fun op PERM_DELETE_PTREE _ = ()
  val op PERM_DELETE_PTREE = TDB.find "PERM_DELETE_PTREE"
  fun op FILTER_NONE _ = () val op FILTER_NONE = TDB.find "FILTER_NONE"
  fun op PERM_REMOVE _ = () val op PERM_REMOVE = TDB.find "PERM_REMOVE"
  fun op SIZE_ADD _ = () val op SIZE_ADD = TDB.find "SIZE_ADD"
  fun op SIZE_REMOVE _ = () val op SIZE_REMOVE = TDB.find "SIZE_REMOVE"
  fun op SIZE _ = () val op SIZE = TDB.find "SIZE"
  fun op SIZE_PTREE_OF_NUMSET _ = ()
  val op SIZE_PTREE_OF_NUMSET = TDB.find "SIZE_PTREE_OF_NUMSET"
  fun op SIZE_PTREE_OF_NUMSET_EMPTY _ = ()
  val op SIZE_PTREE_OF_NUMSET_EMPTY = TDB.find "SIZE_PTREE_OF_NUMSET_EMPTY"
  fun op CARD_LIST_TO_SET _ = ()
  val op CARD_LIST_TO_SET = TDB.find "CARD_LIST_TO_SET"
  fun op CARD_NUMSET_OF_PTREE _ = ()
  val op CARD_NUMSET_OF_PTREE = TDB.find "CARD_NUMSET_OF_PTREE"
  fun op DELETE_UNION _ = () val op DELETE_UNION = TDB.find "DELETE_UNION"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val patricia_grammars = merge_grammars ["words", "sorting"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="patricia"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val patricia_grammars = 
    Portable.## (addtyUDs,addtmUDs) patricia_grammars
  val _ = Parse.grammarDB_insert("patricia",patricia_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "patricia"

end
