structure sptreeTheory :> sptreeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading sptreeTheory ... "
    else ()
  
  open Type Term Thm
  local open alistTheory logrootTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "sptree"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/sptreeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op domain_def _ = () val op domain_def = TDB.find "domain_def"
  fun op lrnext_primitive_def _ = ()
  val op lrnext_primitive_def = TDB.find "lrnext_primitive_def"
  fun op difference_def _ = ()
  val op difference_def = TDB.find "difference_def"
  fun op inter_eq_def _ = () val op inter_eq_def = TDB.find "inter_eq_def"
  fun op inter_def _ = () val op inter_def = TDB.find "inter_def"
  fun op union_def _ = () val op union_def = TDB.find "union_def"
  fun op size_def _ = () val op size_def = TDB.find "size_def"
  fun op fromList_def _ = () val op fromList_def = TDB.find "fromList_def"
  fun op delete_def _ = () val op delete_def = TDB.find "delete_def"
  fun op wf_def _ = () val op wf_def = TDB.find "wf_def"
  fun op spt_size_def _ = () val op spt_size_def = TDB.find "spt_size_def"
  fun op spt_case_def _ = () val op spt_case_def = TDB.find "spt_case_def"
  fun op spt_TY_DEF _ = () val op spt_TY_DEF = TDB.find "spt_TY_DEF"
  fun op foldi_def _ = () val op foldi_def = TDB.find "foldi_def"
  fun op mapi0_def _ = () val op mapi0_def = TDB.find "mapi0_def"
  fun op mapi_def _ = () val op mapi_def = TDB.find "mapi_def"
  fun op toAList_def _ = () val op toAList_def = TDB.find "toAList_def"
  fun op toListA_def _ = () val op toListA_def = TDB.find "toListA_def"
  fun op toList_def _ = () val op toList_def = TDB.find "toList_def"
  fun op mk_wf_def _ = () val op mk_wf_def = TDB.find "mk_wf_def"
  fun op fromAList_primitive_def _ = ()
  val op fromAList_primitive_def = TDB.find "fromAList_primitive_def"
  fun op map_def _ = () val op map_def = TDB.find "map_def"
  fun op spt_left_def _ = () val op spt_left_def = TDB.find "spt_left_def"
  fun op spt_right_def _ = ()
  val op spt_right_def = TDB.find "spt_right_def"
  fun op spt_center_primitive_def _ = ()
  val op spt_center_primitive_def = TDB.find "spt_center_primitive_def"
  fun op filter_v_def _ = () val op filter_v_def = TDB.find "filter_v_def"
  fun op list_insert_def _ = ()
  val op list_insert_def = TDB.find "list_insert_def"
  fun op list_to_num_set_def _ = ()
  val op list_to_num_set_def = TDB.find "list_to_num_set_def"
  fun op spt_fold_def _ = () val op spt_fold_def = TDB.find "spt_fold_def"
  fun op spt_centers_def _ = ()
  val op spt_centers_def = TDB.find "spt_centers_def"
  fun op spt_size_alt_def _ = ()
  val op spt_size_alt_def = TDB.find "spt_size_alt_def"
  fun op toSortedAList_def _ = ()
  val op toSortedAList_def = TDB.find "toSortedAList_def"
  fun op map_map_K _ = () val op map_map_K = TDB.find "map_map_K"
  fun op IN_domain _ = () val op IN_domain = TDB.find "IN_domain"
  fun op FINITE_domain _ = ()
  val op FINITE_domain = TDB.find "FINITE_domain"
  fun op lrnext_thm _ = () val op lrnext_thm = TDB.find "lrnext_thm"
  fun op lrnext_def _ = () val op lrnext_def = TDB.find "lrnext_def"
  fun op lrnext_ind _ = () val op lrnext_ind = TDB.find "lrnext_ind"
  fun op lookup_difference _ = ()
  val op lookup_difference = TDB.find "lookup_difference"
  fun op lookup_inter_assoc _ = ()
  val op lookup_inter_assoc = TDB.find "lookup_inter_assoc"
  fun op lookup_inter_EQ _ = ()
  val op lookup_inter_EQ = TDB.find "lookup_inter_EQ"
  fun op lookup_inter_eq _ = ()
  val op lookup_inter_eq = TDB.find "lookup_inter_eq"
  fun op lookup_inter _ = () val op lookup_inter = TDB.find "lookup_inter"
  fun op wf_inter _ = () val op wf_inter = TDB.find "wf_inter"
  fun op lookup_union _ = () val op lookup_union = TDB.find "lookup_union"
  fun op wf_union _ = () val op wf_union = TDB.find "wf_union"
  fun op isEmpty_union _ = ()
  val op isEmpty_union = TDB.find "isEmpty_union"
  fun op lookup_insert _ = ()
  val op lookup_insert = TDB.find "lookup_insert"
  fun op lookup_insert1 _ = ()
  val op lookup_insert1 = TDB.find "lookup_insert1"
  fun op wf_delete _ = () val op wf_delete = TDB.find "wf_delete"
  fun op wf_insert _ = () val op wf_insert = TDB.find "wf_insert"
  fun op insert_notEmpty _ = ()
  val op insert_notEmpty = TDB.find "insert_notEmpty"
  fun op mk_BS_def _ = () val op mk_BS_def = TDB.find "mk_BS_def"
  fun op mk_BS_ind _ = () val op mk_BS_ind = TDB.find "mk_BS_ind"
  fun op mk_BN_def _ = () val op mk_BN_def = TDB.find "mk_BN_def"
  fun op mk_BN_ind _ = () val op mk_BN_ind = TDB.find "mk_BN_ind"
  fun op insert_def _ = () val op insert_def = TDB.find "insert_def"
  fun op insert_ind _ = () val op insert_ind = TDB.find "insert_ind"
  fun op lookup_def _ = () val op lookup_def = TDB.find "lookup_def"
  fun op lookup_ind _ = () val op lookup_ind = TDB.find "lookup_ind"
  fun op spt_case_eq _ = () val op spt_case_eq = TDB.find "spt_case_eq"
  fun op spt_case_cong _ = ()
  val op spt_case_cong = TDB.find "spt_case_cong"
  fun op spt_induction _ = ()
  val op spt_induction = TDB.find "spt_induction"
  fun op spt_Axiom _ = () val op spt_Axiom = TDB.find "spt_Axiom"
  fun op spt_nchotomy _ = () val op spt_nchotomy = TDB.find "spt_nchotomy"
  fun op spt_distinct _ = () val op spt_distinct = TDB.find "spt_distinct"
  fun op spt_11 _ = () val op spt_11 = TDB.find "spt_11"
  fun op datatype_spt _ = () val op datatype_spt = TDB.find "datatype_spt"
  fun op subspt_eq _ = () val op subspt_eq = TDB.find "subspt_eq"
  fun op subspt_lookup _ = ()
  val op subspt_lookup = TDB.find "subspt_lookup"
  fun op subspt_domain _ = ()
  val op subspt_domain = TDB.find "subspt_domain"
  fun op size_insert _ = () val op size_insert = TDB.find "size_insert"
  fun op lookup_fromList _ = ()
  val op lookup_fromList = TDB.find "lookup_fromList"
  fun op domain_lookup _ = ()
  val op domain_lookup = TDB.find "domain_lookup"
  fun op lookup_inter_alt _ = ()
  val op lookup_inter_alt = TDB.find "lookup_inter_alt"
  fun op lookup_NONE_domain _ = ()
  val op lookup_NONE_domain = TDB.find "lookup_NONE_domain"
  fun op domain_union _ = () val op domain_union = TDB.find "domain_union"
  fun op domain_inter _ = () val op domain_inter = TDB.find "domain_inter"
  fun op domain_insert _ = ()
  val op domain_insert = TDB.find "domain_insert"
  fun op domain_difference _ = ()
  val op domain_difference = TDB.find "domain_difference"
  fun op domain_sing _ = () val op domain_sing = TDB.find "domain_sing"
  fun op domain_fromList _ = ()
  val op domain_fromList = TDB.find "domain_fromList"
  fun op lookup_delete _ = ()
  val op lookup_delete = TDB.find "lookup_delete"
  fun op domain_delete _ = ()
  val op domain_delete = TDB.find "domain_delete"
  fun op spt_acc_ind _ = () val op spt_acc_ind = TDB.find "spt_acc_ind"
  fun op spt_acc_def _ = () val op spt_acc_def = TDB.find "spt_acc_def"
  fun op spt_acc_compute _ = ()
  val op spt_acc_compute = TDB.find "spt_acc_compute"
  fun op spt_acc_thm _ = () val op spt_acc_thm = TDB.find "spt_acc_thm"
  fun op spt_acc_eqn _ = () val op spt_acc_eqn = TDB.find "spt_acc_eqn"
  fun op spt_acc_0 _ = () val op spt_acc_0 = TDB.find "spt_acc_0"
  fun op set_foldi_keys _ = ()
  val op set_foldi_keys = TDB.find "set_foldi_keys"
  fun op domain_foldi _ = () val op domain_foldi = TDB.find "domain_foldi"
  fun op lookup_mapi0 _ = () val op lookup_mapi0 = TDB.find "lookup_mapi0"
  fun op lookup_mapi _ = () val op lookup_mapi = TDB.find "lookup_mapi"
  fun op MEM_toAList _ = () val op MEM_toAList = TDB.find "MEM_toAList"
  fun op ALOOKUP_toAList _ = ()
  val op ALOOKUP_toAList = TDB.find "ALOOKUP_toAList"
  fun op insert_union _ = () val op insert_union = TDB.find "insert_union"
  fun op domain_empty _ = () val op domain_empty = TDB.find "domain_empty"
  fun op ALL_DISTINCT_MAP_FST_toAList _ = ()
  val op ALL_DISTINCT_MAP_FST_toAList = TDB.find
    "ALL_DISTINCT_MAP_FST_toAList"
  fun op foldi_FOLDR_toAList _ = ()
  val op foldi_FOLDR_toAList = TDB.find "foldi_FOLDR_toAList"
  fun op toListA_append _ = ()
  val op toListA_append = TDB.find "toListA_append"
  fun op isEmpty_toListA _ = ()
  val op isEmpty_toListA = TDB.find "isEmpty_toListA"
  fun op isEmpty_toList _ = ()
  val op isEmpty_toList = TDB.find "isEmpty_toList"
  fun op MEM_toList _ = () val op MEM_toList = TDB.find "MEM_toList"
  fun op spt_eq_thm _ = () val op spt_eq_thm = TDB.find "spt_eq_thm"
  fun op wf_mk_wf _ = () val op wf_mk_wf = TDB.find "wf_mk_wf"
  fun op wf_mk_id _ = () val op wf_mk_id = TDB.find "wf_mk_id"
  fun op lookup_mk_wf _ = () val op lookup_mk_wf = TDB.find "lookup_mk_wf"
  fun op domain_mk_wf _ = () val op domain_mk_wf = TDB.find "domain_mk_wf"
  fun op mk_wf_eq _ = () val op mk_wf_eq = TDB.find "mk_wf_eq"
  fun op inter_eq _ = () val op inter_eq = TDB.find "inter_eq"
  fun op union_mk_wf _ = () val op union_mk_wf = TDB.find "union_mk_wf"
  fun op inter_mk_wf _ = () val op inter_mk_wf = TDB.find "inter_mk_wf"
  fun op insert_mk_wf _ = () val op insert_mk_wf = TDB.find "insert_mk_wf"
  fun op delete_mk_wf _ = () val op delete_mk_wf = TDB.find "delete_mk_wf"
  fun op union_LN _ = () val op union_LN = TDB.find "union_LN"
  fun op inter_LN _ = () val op inter_LN = TDB.find "inter_LN"
  fun op union_assoc _ = () val op union_assoc = TDB.find "union_assoc"
  fun op inter_assoc _ = () val op inter_assoc = TDB.find "inter_assoc"
  fun op lookup_compute _ = ()
  val op lookup_compute = TDB.find "lookup_compute"
  fun op insert_compute _ = ()
  val op insert_compute = TDB.find "insert_compute"
  fun op delete_compute _ = ()
  val op delete_compute = TDB.find "delete_compute"
  fun op fromAList_ind _ = ()
  val op fromAList_ind = TDB.find "fromAList_ind"
  fun op fromAList_def _ = ()
  val op fromAList_def = TDB.find "fromAList_def"
  fun op lookup_fromAList _ = ()
  val op lookup_fromAList = TDB.find "lookup_fromAList"
  fun op domain_fromAList _ = ()
  val op domain_fromAList = TDB.find "domain_fromAList"
  fun op lookup_fromAList_toAList _ = ()
  val op lookup_fromAList_toAList = TDB.find "lookup_fromAList_toAList"
  fun op wf_fromAList _ = () val op wf_fromAList = TDB.find "wf_fromAList"
  fun op fromAList_toAList _ = ()
  val op fromAList_toAList = TDB.find "fromAList_toAList"
  fun op union_insert_LN _ = ()
  val op union_insert_LN = TDB.find "union_insert_LN"
  fun op fromAList_append _ = ()
  val op fromAList_append = TDB.find "fromAList_append"
  fun op toList_map _ = () val op toList_map = TDB.find "toList_map"
  fun op domain_map _ = () val op domain_map = TDB.find "domain_map"
  fun op lookup_map _ = () val op lookup_map = TDB.find "lookup_map"
  fun op map_LN _ = () val op map_LN = TDB.find "map_LN"
  fun op wf_map _ = () val op wf_map = TDB.find "wf_map"
  fun op map_map_o _ = () val op map_map_o = TDB.find "map_map_o"
  fun op map_insert _ = () val op map_insert = TDB.find "map_insert"
  fun op map_fromAList _ = ()
  val op map_fromAList = TDB.find "map_fromAList"
  fun op insert_insert _ = ()
  val op insert_insert = TDB.find "insert_insert"
  fun op insert_shadow _ = ()
  val op insert_shadow = TDB.find "insert_shadow"
  fun op spt_center_ind _ = ()
  val op spt_center_ind = TDB.find "spt_center_ind"
  fun op spt_center_def _ = ()
  val op spt_center_def = TDB.find "spt_center_def"
  fun op subspt_def _ = () val op subspt_def = TDB.find "subspt_def"
  fun op subspt_refl _ = () val op subspt_refl = TDB.find "subspt_refl"
  fun op subspt_trans _ = () val op subspt_trans = TDB.find "subspt_trans"
  fun op subspt_LN _ = () val op subspt_LN = TDB.find "subspt_LN"
  fun op subspt_union _ = () val op subspt_union = TDB.find "subspt_union"
  fun op subspt_FOLDL_union _ = ()
  val op subspt_FOLDL_union = TDB.find "subspt_FOLDL_union"
  fun op domain_mapi _ = () val op domain_mapi = TDB.find "domain_mapi"
  fun op lookup_FOLDL_union _ = ()
  val op lookup_FOLDL_union = TDB.find "lookup_FOLDL_union"
  fun op map_union _ = () val op map_union = TDB.find "map_union"
  fun op domain_eq _ = () val op domain_eq = TDB.find "domain_eq"
  fun op lookup_filter_v _ = ()
  val op lookup_filter_v = TDB.find "lookup_filter_v"
  fun op wf_filter_v _ = () val op wf_filter_v = TDB.find "wf_filter_v"
  fun op wf_mk_BN _ = () val op wf_mk_BN = TDB.find "wf_mk_BN"
  fun op wf_mk_BS _ = () val op wf_mk_BS = TDB.find "wf_mk_BS"
  fun op wf_mapi _ = () val op wf_mapi = TDB.find "wf_mapi"
  fun op lookup_mk_BN _ = () val op lookup_mk_BN = TDB.find "lookup_mk_BN"
  fun op MAP_foldi _ = () val op MAP_foldi = TDB.find "MAP_foldi"
  fun op mapi_Alist _ = () val op mapi_Alist = TDB.find "mapi_Alist"
  fun op size_domain _ = () val op size_domain = TDB.find "size_domain"
  fun op num_set_domain_eq _ = ()
  val op num_set_domain_eq = TDB.find "num_set_domain_eq"
  fun op union_num_set_sym _ = ()
  val op union_num_set_sym = TDB.find "union_num_set_sym"
  fun op difference_sub _ = ()
  val op difference_sub = TDB.find "difference_sub"
  fun op wf_difference _ = ()
  val op wf_difference = TDB.find "wf_difference"
  fun op delete_fail _ = () val op delete_fail = TDB.find "delete_fail"
  fun op size_delete _ = () val op size_delete = TDB.find "size_delete"
  fun op lookup_fromList_outside _ = ()
  val op lookup_fromList_outside = TDB.find "lookup_fromList_outside"
  fun op list_to_num_set_append _ = ()
  val op list_to_num_set_append = TDB.find "list_to_num_set_append"
  fun op lookup_list_to_num_set _ = ()
  val op lookup_list_to_num_set = TDB.find "lookup_list_to_num_set"
  fun op domain_FOLDR_delete _ = ()
  val op domain_FOLDR_delete = TDB.find "domain_FOLDR_delete"
  fun op domain_list_insert _ = ()
  val op domain_list_insert = TDB.find "domain_list_insert"
  fun op domain_list_to_num_set _ = ()
  val op domain_list_to_num_set = TDB.find "domain_list_to_num_set"
  fun op inter_eq_LN _ = () val op inter_eq_LN = TDB.find "inter_eq_LN"
  fun op size_diff_less _ = ()
  val op size_diff_less = TDB.find "size_diff_less"
  fun op IMP_size_LESS_size _ = ()
  val op IMP_size_LESS_size = TDB.find "IMP_size_LESS_size"
  fun op lookup_map_K _ = () val op lookup_map_K = TDB.find "lookup_map_K"
  fun op alist_insert_ind _ = ()
  val op alist_insert_ind = TDB.find "alist_insert_ind"
  fun op alist_insert_def _ = ()
  val op alist_insert_def = TDB.find "alist_insert_def"
  fun op lookup_alist_insert _ = ()
  val op lookup_alist_insert = TDB.find "lookup_alist_insert"
  fun op domain_alist_insert _ = ()
  val op domain_alist_insert = TDB.find "domain_alist_insert"
  fun op alist_insert_append _ = ()
  val op alist_insert_append = TDB.find "alist_insert_append"
  fun op wf_LN _ = () val op wf_LN = TDB.find "wf_LN"
  fun op insert_swap _ = () val op insert_swap = TDB.find "insert_swap"
  fun op alist_insert_pull_insert _ = ()
  val op alist_insert_pull_insert = TDB.find "alist_insert_pull_insert"
  fun op alist_insert_REVERSE _ = ()
  val op alist_insert_REVERSE = TDB.find "alist_insert_REVERSE"
  fun op insert_unchanged _ = ()
  val op insert_unchanged = TDB.find "insert_unchanged"
  fun op spt_centers_eq_map _ = ()
  val op spt_centers_eq_map = TDB.find "spt_centers_eq_map"
  fun op list_size_APPEND _ = ()
  val op list_size_APPEND = TDB.find "list_size_APPEND"
  fun op sum_spt_size_alt_lemma _ = ()
  val op sum_spt_size_alt_lemma = TDB.find "sum_spt_size_alt_lemma"
  fun op sum_spt_size_less _ = ()
  val op sum_spt_size_less = TDB.find "sum_spt_size_less"
  fun op aux_alist_ind _ = ()
  val op aux_alist_ind = TDB.find "aux_alist_ind"
  fun op aux_alist_def _ = ()
  val op aux_alist_def = TDB.find "aux_alist_def"
  fun op spt_centers_add_lemma _ = ()
  val op spt_centers_add_lemma = TDB.find "spt_centers_add_lemma"
  fun op EL_CONS_IF _ = () val op EL_CONS_IF = TDB.find "EL_CONS_IF"
  fun op ADD_1_SUC _ = () val op ADD_1_SUC = TDB.find "ADD_1_SUC"
  fun op ALOOKUP_spt_centers _ = ()
  val op ALOOKUP_spt_centers = TDB.find "ALOOKUP_spt_centers"
  fun op lookup_0_spt_center _ = ()
  val op lookup_0_spt_center = TDB.find "lookup_0_spt_center"
  fun op lookup_spt_right _ = ()
  val op lookup_spt_right = TDB.find "lookup_spt_right"
  fun op lookup_spt_left _ = ()
  val op lookup_spt_left = TDB.find "lookup_spt_left"
  fun op DIV_MOD_TIMES_2 _ = ()
  val op DIV_MOD_TIMES_2 = TDB.find "DIV_MOD_TIMES_2"
  fun op ALOOKUP_aux_alist _ = ()
  val op ALOOKUP_aux_alist = TDB.find "ALOOKUP_aux_alist"
  fun op ALOOKUP_toSortedAList _ = ()
  val op ALOOKUP_toSortedAList = TDB.find "ALOOKUP_toSortedAList"
  fun op SORTED_spt_centers _ = ()
  val op SORTED_spt_centers = TDB.find "SORTED_spt_centers"
  fun op LESS_spt_centers _ = ()
  val op LESS_spt_centers = TDB.find "LESS_spt_centers"
  fun op MEM_FST_ALOOKUP_SOME _ = ()
  val op MEM_FST_ALOOKUP_SOME = TDB.find "MEM_FST_ALOOKUP_SOME"
  fun op GREATER_EQ_alist_aux _ = ()
  val op GREATER_EQ_alist_aux = TDB.find "GREATER_EQ_alist_aux"
  fun op SORTED_MAP_FST_alist_aux _ = ()
  val op SORTED_MAP_FST_alist_aux = TDB.find "SORTED_MAP_FST_alist_aux"
  fun op SORTED_MAP_FST_toSortedAList _ = ()
  val op SORTED_MAP_FST_toSortedAList = TDB.find
    "SORTED_MAP_FST_toSortedAList"
  fun op MEM_toSortedAList _ = ()
  val op MEM_toSortedAList = TDB.find "MEM_toSortedAList"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val sptree_grammars = merge_grammars ["alist", "logroot"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="sptree"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val sptree_grammars = 
    Portable.## (addtyUDs,addtmUDs) sptree_grammars
  val _ = Parse.grammarDB_insert("sptree",sptree_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "sptree"

end
