structure tcTheory :> tcTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading tcTheory ... "
    else ()
  
  open Type Term Thm
  local open finite_mapTheory totoTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "tc"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/tcTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op DRESTR _ = () val op DRESTR = TDB.find "DRESTR"
  fun op RRESTR _ = () val op RRESTR = TDB.find "RRESTR"
  fun op BRESTR _ = () val op BRESTR = TDB.find "BRESTR"
  fun op subTC _ = () val op subTC = TDB.find "subTC"
  fun op FMAP_TO_RELN _ = () val op FMAP_TO_RELN = TDB.find "FMAP_TO_RELN"
  fun op RELN_TO_FMAP _ = () val op RELN_TO_FMAP = TDB.find "RELN_TO_FMAP"
  fun op TC_MOD _ = () val op TC_MOD = TDB.find "TC_MOD"
  fun op TC_ITER _ = () val op TC_ITER = TDB.find "TC_ITER"
  fun op DRESTR_IN _ = () val op DRESTR_IN = TDB.find "DRESTR_IN"
  fun op DRESTR_EMPTY _ = () val op DRESTR_EMPTY = TDB.find "DRESTR_EMPTY"
  fun op DRESTR_RDOM _ = () val op DRESTR_RDOM = TDB.find "DRESTR_RDOM"
  fun op REMPTY_RRESTR _ = ()
  val op REMPTY_RRESTR = TDB.find "REMPTY_RRESTR"
  fun op O_REMPTY_O _ = () val op O_REMPTY_O = TDB.find "O_REMPTY_O"
  fun op subTC_thm _ = () val op subTC_thm = TDB.find "subTC_thm"
  fun op subTC_EMPTY _ = () val op subTC_EMPTY = TDB.find "subTC_EMPTY"
  fun op RTC_INSERT _ = () val op RTC_INSERT = TDB.find "RTC_INSERT"
  fun op subTC_INSERT _ = () val op subTC_INSERT = TDB.find "subTC_INSERT"
  fun op subTC_RDOM _ = () val op subTC_RDOM = TDB.find "subTC_RDOM"
  fun op subTC_INSERT_COR _ = ()
  val op subTC_INSERT_COR = TDB.find "subTC_INSERT_COR"
  fun op RDOM_SUBSET_FDOM _ = ()
  val op RDOM_SUBSET_FDOM = TDB.find "RDOM_SUBSET_FDOM"
  fun op FINITE_RDOM _ = () val op FINITE_RDOM = TDB.find "FINITE_RDOM"
  fun op FDOM_RDOM _ = () val op FDOM_RDOM = TDB.find "FDOM_RDOM"
  fun op RELN_TO_FMAP_TO_RELN_ID _ = ()
  val op RELN_TO_FMAP_TO_RELN_ID = TDB.find "RELN_TO_FMAP_TO_RELN_ID"
  fun op RDOM_subTC _ = () val op RDOM_subTC = TDB.find "RDOM_subTC"
  fun op NOT_IN_RDOM _ = () val op NOT_IN_RDOM = TDB.find "NOT_IN_RDOM"
  fun op TC_MOD_EMPTY_ID _ = ()
  val op TC_MOD_EMPTY_ID = TDB.find "TC_MOD_EMPTY_ID"
  fun op I_o_f _ = () val op I_o_f = TDB.find "I_o_f"
  fun op subTC_MAX_RDOM _ = ()
  val op subTC_MAX_RDOM = TDB.find "subTC_MAX_RDOM"
  fun op subTC_SUPERSET_RDOM _ = ()
  val op subTC_SUPERSET_RDOM = TDB.find "subTC_SUPERSET_RDOM"
  fun op subTC_FDOM _ = () val op subTC_FDOM = TDB.find "subTC_FDOM"
  fun op SUBSET_FDOM_LEM _ = ()
  val op SUBSET_FDOM_LEM = TDB.find "SUBSET_FDOM_LEM"
  fun op subTC_FDOM_RDOM _ = ()
  val op subTC_FDOM_RDOM = TDB.find "subTC_FDOM_RDOM"
  fun op TC_MOD_LEM _ = () val op TC_MOD_LEM = TDB.find "TC_MOD_LEM"
  fun op TC_ITER_THM _ = () val op TC_ITER_THM = TDB.find "TC_ITER_THM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val tc_grammars = merge_grammars ["toto", "finite_map"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="tc"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val tc_grammars = 
    Portable.## (addtyUDs,addtmUDs) tc_grammars
  val _ = Parse.grammarDB_insert("tc",tc_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "tc"

end
