structure totoTheory :> totoTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading totoTheory ... "
    else ()
  
  open Type Term Thm
  local open ternaryComparisonsTheory wotTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "toto"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/totoTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op TotOrd _ = () val op TotOrd = TDB.find "TotOrd"
  fun op TO_of_LinearOrder _ = ()
  val op TO_of_LinearOrder = TDB.find "TO_of_LinearOrder"
  fun op toto_TY_DEF _ = () val op toto_TY_DEF = TDB.find "toto_TY_DEF"
  fun op to_bij _ = () val op to_bij = TDB.find "to_bij"
  fun op WeakLinearOrder_of_TO _ = ()
  val op WeakLinearOrder_of_TO = TDB.find "WeakLinearOrder_of_TO"
  fun op StrongLinearOrder_of_TO _ = ()
  val op StrongLinearOrder_of_TO = TDB.find "StrongLinearOrder_of_TO"
  fun op toto_of_LinearOrder _ = ()
  val op toto_of_LinearOrder = TDB.find "toto_of_LinearOrder"
  fun op TO_inv _ = () val op TO_inv = TDB.find "TO_inv"
  fun op toto_inv _ = () val op toto_inv = TDB.find "toto_inv"
  fun op lexTO _ = () val op lexTO = TDB.find "lexTO"
  fun op lextoto _ = () val op lextoto = TDB.find "lextoto"
  fun op numOrd _ = () val op numOrd = TDB.find "numOrd"
  fun op numto _ = () val op numto = TDB.find "numto"
  fun op num_dt_TY_DEF _ = ()
  val op num_dt_TY_DEF = TDB.find "num_dt_TY_DEF"
  fun op num_dt_case_def _ = ()
  val op num_dt_case_def = TDB.find "num_dt_case_def"
  fun op num_dt_size_def _ = ()
  val op num_dt_size_def = TDB.find "num_dt_size_def"
  fun op num_to_dt_primitive _ = ()
  val op num_to_dt_primitive = TDB.find "num_to_dt_primitive"
  fun op qk_numOrd_def _ = ()
  val op qk_numOrd_def = TDB.find "qk_numOrd_def"
  fun op qk_numto _ = () val op qk_numto = TDB.find "qk_numto"
  fun op charOrd _ = () val op charOrd = TDB.find "charOrd"
  fun op charto _ = () val op charto = TDB.find "charto"
  fun op ListOrd _ = () val op ListOrd = TDB.find "ListOrd"
  fun op listoto _ = () val op listoto = TDB.find "listoto"
  fun op stringto _ = () val op stringto = TDB.find "stringto"
  fun op imageOrd _ = () val op imageOrd = TDB.find "imageOrd"
  fun op StrongLinearOrderExists _ = ()
  val op StrongLinearOrderExists = TDB.find "StrongLinearOrderExists"
  fun op trichotomous_ALT _ = ()
  val op trichotomous_ALT = TDB.find "trichotomous_ALT"
  fun op TotOrd_TO_of_LO _ = ()
  val op TotOrd_TO_of_LO = TDB.find "TotOrd_TO_of_LO"
  fun op SPLIT_PAIRS _ = () val op SPLIT_PAIRS = TDB.find "SPLIT_PAIRS"
  fun op all_cpn_distinct _ = ()
  val op all_cpn_distinct = TDB.find "all_cpn_distinct"
  fun op TO_exists _ = () val op TO_exists = TDB.find "TO_exists"
  fun op TO_apto_ID _ = () val op TO_apto_ID = TDB.find "TO_apto_ID"
  fun op TO_apto_TO_ID _ = ()
  val op TO_apto_TO_ID = TDB.find "TO_apto_TO_ID"
  fun op TO_11 _ = () val op TO_11 = TDB.find "TO_11"
  fun op onto_apto _ = () val op onto_apto = TDB.find "onto_apto"
  fun op TO_onto _ = () val op TO_onto = TDB.find "TO_onto"
  fun op TotOrd_apto _ = () val op TotOrd_apto = TDB.find "TotOrd_apto"
  fun op TO_apto_TO_IMP _ = ()
  val op TO_apto_TO_IMP = TDB.find "TO_apto_TO_IMP"
  fun op toto_thm _ = () val op toto_thm = TDB.find "toto_thm"
  fun op TO_equal_eq _ = () val op TO_equal_eq = TDB.find "TO_equal_eq"
  fun op toto_equal_eq _ = ()
  val op toto_equal_eq = TDB.find "toto_equal_eq"
  fun op toto_equal_imp_eq _ = ()
  val op toto_equal_imp_eq = TDB.find "toto_equal_imp_eq"
  fun op TO_refl _ = () val op TO_refl = TDB.find "TO_refl"
  fun op toto_refl _ = () val op toto_refl = TDB.find "toto_refl"
  fun op toto_equal_sym _ = ()
  val op toto_equal_sym = TDB.find "toto_equal_sym"
  fun op TO_antisym _ = () val op TO_antisym = TDB.find "TO_antisym"
  fun op toto_antisym _ = () val op toto_antisym = TDB.find "toto_antisym"
  fun op toto_not_less_refl _ = ()
  val op toto_not_less_refl = TDB.find "toto_not_less_refl"
  fun op toto_swap_cases _ = ()
  val op toto_swap_cases = TDB.find "toto_swap_cases"
  fun op toto_glneq _ = () val op toto_glneq = TDB.find "toto_glneq"
  fun op toto_cpn_eqn _ = () val op toto_cpn_eqn = TDB.find "toto_cpn_eqn"
  fun op TO_cpn_eqn _ = () val op TO_cpn_eqn = TDB.find "TO_cpn_eqn"
  fun op NOT_EQ_LESS_IMP _ = ()
  val op NOT_EQ_LESS_IMP = TDB.find "NOT_EQ_LESS_IMP"
  fun op totoEEtrans _ = () val op totoEEtrans = TDB.find "totoEEtrans"
  fun op totoLLtrans _ = () val op totoLLtrans = TDB.find "totoLLtrans"
  fun op totoLGtrans _ = () val op totoLGtrans = TDB.find "totoLGtrans"
  fun op totoGGtrans _ = () val op totoGGtrans = TDB.find "totoGGtrans"
  fun op totoGLtrans _ = () val op totoGLtrans = TDB.find "totoGLtrans"
  fun op totoLEtrans _ = () val op totoLEtrans = TDB.find "totoLEtrans"
  fun op totoELtrans _ = () val op totoELtrans = TDB.find "totoELtrans"
  fun op toto_trans_less _ = ()
  val op toto_trans_less = TDB.find "toto_trans_less"
  fun op Weak_Weak_of _ = () val op Weak_Weak_of = TDB.find "Weak_Weak_of"
  fun op STRORD_SLO _ = () val op STRORD_SLO = TDB.find "STRORD_SLO"
  fun op Strongof_toto_STRORD _ = ()
  val op Strongof_toto_STRORD = TDB.find "Strongof_toto_STRORD"
  fun op Strong_Strong_of _ = ()
  val op Strong_Strong_of = TDB.find "Strong_Strong_of"
  fun op Strong_Strong_of_TO _ = ()
  val op Strong_Strong_of_TO = TDB.find "Strong_Strong_of_TO"
  fun op TotOrd_TO_of_Weak _ = ()
  val op TotOrd_TO_of_Weak = TDB.find "TotOrd_TO_of_Weak"
  fun op TotOrd_TO_of_Strong _ = ()
  val op TotOrd_TO_of_Strong = TDB.find "TotOrd_TO_of_Strong"
  fun op toto_Weak_thm _ = ()
  val op toto_Weak_thm = TDB.find "toto_Weak_thm"
  fun op toto_Strong_thm _ = ()
  val op toto_Strong_thm = TDB.find "toto_Strong_thm"
  fun op Weak_toto_thm _ = ()
  val op Weak_toto_thm = TDB.find "Weak_toto_thm"
  fun op Strong_toto_thm _ = ()
  val op Strong_toto_thm = TDB.find "Strong_toto_thm"
  fun op TotOrd_inv _ = () val op TotOrd_inv = TDB.find "TotOrd_inv"
  fun op inv_TO _ = () val op inv_TO = TDB.find "inv_TO"
  fun op apto_inv _ = () val op apto_inv = TDB.find "apto_inv"
  fun op Weak_toto_inv _ = ()
  val op Weak_toto_inv = TDB.find "Weak_toto_inv"
  fun op Strong_toto_inv _ = ()
  val op Strong_toto_inv = TDB.find "Strong_toto_inv"
  fun op TO_inv_TO_inv _ = ()
  val op TO_inv_TO_inv = TDB.find "TO_inv_TO_inv"
  fun op toto_inv_toto_inv _ = ()
  val op toto_inv_toto_inv = TDB.find "toto_inv_toto_inv"
  fun op TO_inv_Ord _ = () val op TO_inv_Ord = TDB.find "TO_inv_Ord"
  fun op TO_of_less_rel _ = ()
  val op TO_of_less_rel = TDB.find "TO_of_less_rel"
  fun op TO_of_greater_ler _ = ()
  val op TO_of_greater_ler = TDB.find "TO_of_greater_ler"
  fun op toto_equal_imp _ = ()
  val op toto_equal_imp = TDB.find "toto_equal_imp"
  fun op toto_unequal_imp _ = ()
  val op toto_unequal_imp = TDB.find "toto_unequal_imp"
  fun op StrongOrder_ALT _ = ()
  val op StrongOrder_ALT = TDB.find "StrongOrder_ALT"
  fun op LEX_ALT _ = () val op LEX_ALT = TDB.find "LEX_ALT"
  fun op SLO_LEX _ = () val op SLO_LEX = TDB.find "SLO_LEX"
  fun op lexTO_thm _ = () val op lexTO_thm = TDB.find "lexTO_thm"
  fun op lexTO_ALT _ = () val op lexTO_ALT = TDB.find "lexTO_ALT"
  fun op TO_lexTO _ = () val op TO_lexTO = TDB.find "TO_lexTO"
  fun op pre_aplextoto _ = ()
  val op pre_aplextoto = TDB.find "pre_aplextoto"
  fun op aplextoto _ = () val op aplextoto = TDB.find "aplextoto"
  fun op StrongLinearOrder_LESS _ = ()
  val op StrongLinearOrder_LESS = TDB.find "StrongLinearOrder_LESS"
  fun op TO_numOrd _ = () val op TO_numOrd = TDB.find "TO_numOrd"
  fun op apnumto_thm _ = () val op apnumto_thm = TDB.find "apnumto_thm"
  fun op numeralOrd _ = () val op numeralOrd = TDB.find "numeralOrd"
  fun op datatype_num_dt _ = ()
  val op datatype_num_dt = TDB.find "datatype_num_dt"
  fun op num_dt_11 _ = () val op num_dt_11 = TDB.find "num_dt_11"
  fun op num_dt_distinct _ = ()
  val op num_dt_distinct = TDB.find "num_dt_distinct"
  fun op num_dt_nchotomy _ = ()
  val op num_dt_nchotomy = TDB.find "num_dt_nchotomy"
  fun op num_dt_Axiom _ = () val op num_dt_Axiom = TDB.find "num_dt_Axiom"
  fun op num_dt_induction _ = ()
  val op num_dt_induction = TDB.find "num_dt_induction"
  fun op num_dt_case_cong _ = ()
  val op num_dt_case_cong = TDB.find "num_dt_case_cong"
  fun op num_dt_case_eq _ = ()
  val op num_dt_case_eq = TDB.find "num_dt_case_eq"
  fun op num_dtOrd_ind _ = ()
  val op num_dtOrd_ind = TDB.find "num_dtOrd_ind"
  fun op num_dtOrd _ = () val op num_dtOrd = TDB.find "num_dtOrd"
  fun op TO_qk_numOrd _ = () val op TO_qk_numOrd = TDB.find "TO_qk_numOrd"
  fun op qk_numeralOrd _ = ()
  val op qk_numeralOrd = TDB.find "qk_numeralOrd"
  fun op ap_qk_numto_thm _ = ()
  val op ap_qk_numto_thm = TDB.find "ap_qk_numto_thm"
  fun op TO_charOrd _ = () val op TO_charOrd = TDB.find "TO_charOrd"
  fun op apcharto_thm _ = () val op apcharto_thm = TDB.find "apcharto_thm"
  fun op charOrd_lt_lem _ = ()
  val op charOrd_lt_lem = TDB.find "charOrd_lt_lem"
  fun op charOrd_gt_lem _ = ()
  val op charOrd_gt_lem = TDB.find "charOrd_gt_lem"
  fun op charOrd_eq_lem _ = ()
  val op charOrd_eq_lem = TDB.find "charOrd_eq_lem"
  fun op charOrd_thm _ = () val op charOrd_thm = TDB.find "charOrd_thm"
  fun op listorder_ind _ = ()
  val op listorder_ind = TDB.find "listorder_ind"
  fun op listorder _ = () val op listorder = TDB.find "listorder"
  fun op SLO_listorder _ = ()
  val op SLO_listorder = TDB.find "SLO_listorder"
  fun op TO_ListOrd _ = () val op TO_ListOrd = TDB.find "TO_ListOrd"
  fun op ListOrd_THM _ = () val op ListOrd_THM = TDB.find "ListOrd_THM"
  fun op aplistoto _ = () val op aplistoto = TDB.find "aplistoto"
  fun op TO_injection _ = () val op TO_injection = TDB.find "TO_injection"
  fun op StrongLinearOrder_of_TO_TO_of_LinearOrder _ = ()
  val op StrongLinearOrder_of_TO_TO_of_LinearOrder = TDB.find
    "StrongLinearOrder_of_TO_TO_of_LinearOrder"
  fun op TO_of_LinearOrder_LEX _ = ()
  val op TO_of_LinearOrder_LEX = TDB.find "TO_of_LinearOrder_LEX"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val toto_grammars = merge_grammars ["wot", "ternaryComparisons"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="toto"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val toto_grammars = 
    Portable.## (addtyUDs,addtmUDs) toto_grammars
  val _ = Parse.grammarDB_insert("toto",toto_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "toto"

end
