structure wotTheory :> wotTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading wotTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "wot"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/finite_maps/wotTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op cpl_def _ = () val op cpl_def = TDB.find "cpl_def"
  fun op chain_def _ = () val op chain_def = TDB.find "chain_def"
  fun op mex_def _ = () val op mex_def = TDB.find "mex_def"
  fun op setsuc_def _ = () val op setsuc_def = TDB.find "setsuc_def"
  fun op succl_def _ = () val op succl_def = TDB.find "succl_def"
  fun op uncl_def _ = () val op uncl_def = TDB.find "uncl_def"
  fun op tower_def _ = () val op tower_def = TDB.find "tower_def"
  fun op mex_less_eq_def _ = ()
  val op mex_less_eq_def = TDB.find "mex_less_eq_def"
  fun op mex_less_def _ = () val op mex_less_def = TDB.find "mex_less_def"
  fun op WeakWellOrder_def _ = ()
  val op WeakWellOrder_def = TDB.find "WeakWellOrder_def"
  fun op preds_image_def _ = ()
  val op preds_image_def = TDB.find "preds_image_def"
  fun op StrongWellOrder_def _ = ()
  val op StrongWellOrder_def = TDB.find "StrongWellOrder_def"
  fun op StrongWellOrderExists _ = ()
  val op StrongWellOrderExists = TDB.find "StrongWellOrderExists"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val wot_grammars = merge_grammars ["indexedLists", "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="wot"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val wot_grammars = 
    Portable.## (addtyUDs,addtmUDs) wot_grammars
  val _ = Parse.grammarDB_insert("wot",wot_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "wot"

end
