structure floatTheory :> floatTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading floatTheory ... "
    else ()
  
  open Type Term Thm
  local open ieeeTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "float"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/float/floatTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op error_def _ = () val op error_def = TDB.find "error_def"
  fun op normalizes_def _ = ()
  val op normalizes_def = TDB.find "normalizes_def"
  fun op SIGN _ = () val op SIGN = TDB.find "SIGN"
  fun op EXPONENT _ = () val op EXPONENT = TDB.find "EXPONENT"
  fun op FRACTION _ = () val op FRACTION = TDB.find "FRACTION"
  fun op IS_VALID _ = () val op IS_VALID = TDB.find "IS_VALID"
  fun op VALOF _ = () val op VALOF = TDB.find "VALOF"
  fun op IS_VALID_DEFLOAT _ = ()
  val op IS_VALID_DEFLOAT = TDB.find "IS_VALID_DEFLOAT"
  fun op IS_FINITE_EXPLICIT _ = ()
  val op IS_FINITE_EXPLICIT = TDB.find "IS_FINITE_EXPLICIT"
  fun op FLOAT_CASES _ = () val op FLOAT_CASES = TDB.find "FLOAT_CASES"
  fun op FLOAT_CASES_FINITE _ = ()
  val op FLOAT_CASES_FINITE = TDB.find "FLOAT_CASES_FINITE"
  fun op FLOAT_DISTINCT _ = ()
  val op FLOAT_DISTINCT = TDB.find "FLOAT_DISTINCT"
  fun op FLOAT_DISTINCT_FINITE _ = ()
  val op FLOAT_DISTINCT_FINITE = TDB.find "FLOAT_DISTINCT_FINITE"
  fun op FLOAT_INFINITIES_SIGNED _ = ()
  val op FLOAT_INFINITIES_SIGNED = TDB.find "FLOAT_INFINITIES_SIGNED"
  fun op INFINITY_IS_INFINITY _ = ()
  val op INFINITY_IS_INFINITY = TDB.find "INFINITY_IS_INFINITY"
  fun op ZERO_IS_ZERO _ = () val op ZERO_IS_ZERO = TDB.find "ZERO_IS_ZERO"
  fun op INFINITY_NOT_NAN _ = ()
  val op INFINITY_NOT_NAN = TDB.find "INFINITY_NOT_NAN"
  fun op ZERO_NOT_NAN _ = () val op ZERO_NOT_NAN = TDB.find "ZERO_NOT_NAN"
  fun op FLOAT_INFINITIES _ = ()
  val op FLOAT_INFINITIES = TDB.find "FLOAT_INFINITIES"
  fun op FLOAT_INFINITES_DISTINCT _ = ()
  val op FLOAT_INFINITES_DISTINCT = TDB.find "FLOAT_INFINITES_DISTINCT"
  fun op FLOAT_LT _ = () val op FLOAT_LT = TDB.find "FLOAT_LT"
  fun op FLOAT_GT _ = () val op FLOAT_GT = TDB.find "FLOAT_GT"
  fun op FLOAT_LE _ = () val op FLOAT_LE = TDB.find "FLOAT_LE"
  fun op FLOAT_GE _ = () val op FLOAT_GE = TDB.find "FLOAT_GE"
  fun op FLOAT_EQ _ = () val op FLOAT_EQ = TDB.find "FLOAT_EQ"
  fun op FLOAT_EQ_REFL _ = ()
  val op FLOAT_EQ_REFL = TDB.find "FLOAT_EQ_REFL"
  fun op IS_VALID_SPECIAL _ = ()
  val op IS_VALID_SPECIAL = TDB.find "IS_VALID_SPECIAL"
  fun op IS_CLOSEST_EXISTS _ = ()
  val op IS_CLOSEST_EXISTS = TDB.find "IS_CLOSEST_EXISTS"
  fun op CLOSEST_IS_EVERYTHING _ = ()
  val op CLOSEST_IS_EVERYTHING = TDB.find "CLOSEST_IS_EVERYTHING"
  fun op CLOSEST_IN_SET _ = ()
  val op CLOSEST_IN_SET = TDB.find "CLOSEST_IN_SET"
  fun op CLOSEST_IS_CLOSEST _ = ()
  val op CLOSEST_IS_CLOSEST = TDB.find "CLOSEST_IS_CLOSEST"
  fun op IS_VALID_FINITE _ = ()
  val op IS_VALID_FINITE = TDB.find "IS_VALID_FINITE"
  fun op IS_FINITE_FINITE _ = ()
  val op IS_FINITE_FINITE = TDB.find "IS_FINITE_FINITE"
  fun op IS_VALID_NONEMPTY _ = ()
  val op IS_VALID_NONEMPTY = TDB.find "IS_VALID_NONEMPTY"
  fun op IS_FINITE_NONEMPTY _ = ()
  val op IS_FINITE_NONEMPTY = TDB.find "IS_FINITE_NONEMPTY"
  fun op IS_FINITE_CLOSEST _ = ()
  val op IS_FINITE_CLOSEST = TDB.find "IS_FINITE_CLOSEST"
  fun op IS_VALID_CLOSEST _ = ()
  val op IS_VALID_CLOSEST = TDB.find "IS_VALID_CLOSEST"
  fun op IS_VALID_ROUND _ = ()
  val op IS_VALID_ROUND = TDB.find "IS_VALID_ROUND"
  fun op DEFLOAT_FLOAT_ROUND _ = ()
  val op DEFLOAT_FLOAT_ROUND = TDB.find "DEFLOAT_FLOAT_ROUND"
  fun op DEFLOAT_FLOAT_ZEROSIGN_ROUND _ = ()
  val op DEFLOAT_FLOAT_ZEROSIGN_ROUND = TDB.find
    "DEFLOAT_FLOAT_ZEROSIGN_ROUND"
  fun op VALOF_DEFLOAT_FLOAT_ZEROSIGN_ROUND _ = ()
  val op VALOF_DEFLOAT_FLOAT_ZEROSIGN_ROUND = TDB.find
    "VALOF_DEFLOAT_FLOAT_ZEROSIGN_ROUND"
  fun op ISFINITE _ = () val op ISFINITE = TDB.find "ISFINITE"
  fun op VAL_FINITE _ = () val op VAL_FINITE = TDB.find "VAL_FINITE"
  fun op FLOAT_THRESHOLD_EXPLICIT _ = ()
  val op FLOAT_THRESHOLD_EXPLICIT = TDB.find "FLOAT_THRESHOLD_EXPLICIT"
  fun op FLOAT_LARGEST_EXPLICIT _ = ()
  val op FLOAT_LARGEST_EXPLICIT = TDB.find "FLOAT_LARGEST_EXPLICIT"
  fun op VAL_THRESHOLD _ = ()
  val op VAL_THRESHOLD = TDB.find "VAL_THRESHOLD"
  fun op ERROR_IS_ZERO _ = ()
  val op ERROR_IS_ZERO = TDB.find "ERROR_IS_ZERO"
  fun op ERROR_BOUND_NORM_STRONG _ = ()
  val op ERROR_BOUND_NORM_STRONG = TDB.find "ERROR_BOUND_NORM_STRONG"
  fun op REAL_IN_BINADE _ = ()
  val op REAL_IN_BINADE = TDB.find "REAL_IN_BINADE"
  fun op ERROR_BOUND_NORM_STRONG_NORMALIZE _ = ()
  val op ERROR_BOUND_NORM_STRONG_NORMALIZE = TDB.find
    "ERROR_BOUND_NORM_STRONG_NORMALIZE"
  fun op RELATIVE_ERROR _ = ()
  val op RELATIVE_ERROR = TDB.find "RELATIVE_ERROR"
  fun op DEFLOAT_FLOAT_ZEROSIGN_ROUND_FINITE _ = ()
  val op DEFLOAT_FLOAT_ZEROSIGN_ROUND_FINITE = TDB.find
    "DEFLOAT_FLOAT_ZEROSIGN_ROUND_FINITE"
  fun op FLOAT_ADD _ = () val op FLOAT_ADD = TDB.find "FLOAT_ADD"
  fun op FLOAT_SUB _ = () val op FLOAT_SUB = TDB.find "FLOAT_SUB"
  fun op FLOAT_MUL _ = () val op FLOAT_MUL = TDB.find "FLOAT_MUL"
  fun op FLOAT_DIV _ = () val op FLOAT_DIV = TDB.find "FLOAT_DIV"
  fun op FLOAT_ADD_FINITE _ = ()
  val op FLOAT_ADD_FINITE = TDB.find "FLOAT_ADD_FINITE"
  fun op FLOAT_SUB_FINITE _ = ()
  val op FLOAT_SUB_FINITE = TDB.find "FLOAT_SUB_FINITE"
  fun op FLOAT_MUL_FINITE _ = ()
  val op FLOAT_MUL_FINITE = TDB.find "FLOAT_MUL_FINITE"
  fun op FLOAT_ADD_RELATIVE _ = ()
  val op FLOAT_ADD_RELATIVE = TDB.find "FLOAT_ADD_RELATIVE"
  fun op FLOAT_SUB_RELATIVE _ = ()
  val op FLOAT_SUB_RELATIVE = TDB.find "FLOAT_SUB_RELATIVE"
  fun op FLOAT_MUL_RELATIVE _ = ()
  val op FLOAT_MUL_RELATIVE = TDB.find "FLOAT_MUL_RELATIVE"
  fun op FLOAT_DIV_RELATIVE _ = ()
  val op FLOAT_DIV_RELATIVE = TDB.find "FLOAT_DIV_RELATIVE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val float_grammars = merge_grammars ["ieee"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="float"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val float_grammars = 
    Portable.## (addtyUDs,addtmUDs) float_grammars
  val _ = Parse.grammarDB_insert("float",float_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "float"

end
