structure ieeeTheory :> ieeeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ieeeTheory ... "
    else ()
  
  open Type Term Thm
  local open transcTheory EnumType in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ieee"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/float/ieeeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op expwidth _ = () val op expwidth = TDB.find "expwidth"
  fun op fracwidth _ = () val op fracwidth = TDB.find "fracwidth"
  fun op wordlength _ = () val op wordlength = TDB.find "wordlength"
  fun op emax _ = () val op emax = TDB.find "emax"
  fun op bias _ = () val op bias = TDB.find "bias"
  fun op is_single _ = () val op is_single = TDB.find "is_single"
  fun op is_double _ = () val op is_double = TDB.find "is_double"
  fun op is_single_extended _ = ()
  val op is_single_extended = TDB.find "is_single_extended"
  fun op is_double_extended _ = ()
  val op is_double_extended = TDB.find "is_double_extended"
  fun op sign _ = () val op sign = TDB.find "sign"
  fun op exponent _ = () val op exponent = TDB.find "exponent"
  fun op fraction _ = () val op fraction = TDB.find "fraction"
  fun op is_nan _ = () val op is_nan = TDB.find "is_nan"
  fun op is_infinity _ = () val op is_infinity = TDB.find "is_infinity"
  fun op is_normal _ = () val op is_normal = TDB.find "is_normal"
  fun op is_denormal _ = () val op is_denormal = TDB.find "is_denormal"
  fun op is_zero _ = () val op is_zero = TDB.find "is_zero"
  fun op is_valid _ = () val op is_valid = TDB.find "is_valid"
  fun op is_finite _ = () val op is_finite = TDB.find "is_finite"
  fun op plus_infinity _ = ()
  val op plus_infinity = TDB.find "plus_infinity"
  fun op minus_infinity _ = ()
  val op minus_infinity = TDB.find "minus_infinity"
  fun op plus_zero _ = () val op plus_zero = TDB.find "plus_zero"
  fun op minus_zero _ = () val op minus_zero = TDB.find "minus_zero"
  fun op topfloat _ = () val op topfloat = TDB.find "topfloat"
  fun op bottomfloat _ = () val op bottomfloat = TDB.find "bottomfloat"
  fun op minus _ = () val op minus = TDB.find "minus"
  fun op encoding _ = () val op encoding = TDB.find "encoding"
  fun op valof _ = () val op valof = TDB.find "valof"
  fun op largest _ = () val op largest = TDB.find "largest"
  fun op threshold _ = () val op threshold = TDB.find "threshold"
  fun op ulp _ = () val op ulp = TDB.find "ulp"
  fun op roundmode_TY_DEF _ = ()
  val op roundmode_TY_DEF = TDB.find "roundmode_TY_DEF"
  fun op roundmode_BIJ _ = ()
  val op roundmode_BIJ = TDB.find "roundmode_BIJ"
  
  
  
  
  fun op roundmode_size_def _ = ()
  val op roundmode_size_def = TDB.find "roundmode_size_def"
  fun op roundmode_CASE _ = ()
  val op roundmode_CASE = TDB.find "roundmode_CASE"
  fun op is_closest _ = () val op is_closest = TDB.find "is_closest"
  fun op closest _ = () val op closest = TDB.find "closest"
  fun op round_def _ = () val op round_def = TDB.find "round_def"
  fun op is_integral _ = () val op is_integral = TDB.find "is_integral"
  fun op intround_def _ = () val op intround_def = TDB.find "intround_def"
  fun op some_nan _ = () val op some_nan = TDB.find "some_nan"
  fun op zerosign _ = () val op zerosign = TDB.find "zerosign"
  fun op rem _ = () val op rem = TDB.find "rem"
  fun op fintrnd _ = () val op fintrnd = TDB.find "fintrnd"
  fun op fadd _ = () val op fadd = TDB.find "fadd"
  fun op fsub _ = () val op fsub = TDB.find "fsub"
  fun op fmul _ = () val op fmul = TDB.find "fmul"
  fun op fdiv _ = () val op fdiv = TDB.find "fdiv"
  fun op fsqrt _ = () val op fsqrt = TDB.find "fsqrt"
  fun op frem _ = () val op frem = TDB.find "frem"
  fun op fneg _ = () val op fneg = TDB.find "fneg"
  fun op ccode_TY_DEF _ = () val op ccode_TY_DEF = TDB.find "ccode_TY_DEF"
  fun op ccode_BIJ _ = () val op ccode_BIJ = TDB.find "ccode_BIJ"
  
  
  
  
  fun op ccode_size_def _ = ()
  val op ccode_size_def = TDB.find "ccode_size_def"
  fun op ccode_CASE _ = () val op ccode_CASE = TDB.find "ccode_CASE"
  fun op fcompare _ = () val op fcompare = TDB.find "fcompare"
  fun op flt _ = () val op flt = TDB.find "flt"
  fun op fle _ = () val op fle = TDB.find "fle"
  fun op fgt _ = () val op fgt = TDB.find "fgt"
  fun op fge _ = () val op fge = TDB.find "fge"
  fun op feq _ = () val op feq = TDB.find "feq"
  fun op float_format _ = () val op float_format = TDB.find "float_format"
  fun op float_TY_DEF _ = () val op float_TY_DEF = TDB.find "float_TY_DEF"
  fun op float_tybij _ = () val op float_tybij = TDB.find "float_tybij"
  fun op Val _ = () val op Val = TDB.find "Val"
  fun op Float _ = () val op Float = TDB.find "Float"
  fun op Sign _ = () val op Sign = TDB.find "Sign"
  fun op Exponent _ = () val op Exponent = TDB.find "Exponent"
  fun op Fraction _ = () val op Fraction = TDB.find "Fraction"
  fun op Ulp _ = () val op Ulp = TDB.find "Ulp"
  fun op Isnan _ = () val op Isnan = TDB.find "Isnan"
  fun op Infinity _ = () val op Infinity = TDB.find "Infinity"
  fun op Isnormal _ = () val op Isnormal = TDB.find "Isnormal"
  fun op Isdenormal _ = () val op Isdenormal = TDB.find "Isdenormal"
  fun op Iszero _ = () val op Iszero = TDB.find "Iszero"
  fun op Finite _ = () val op Finite = TDB.find "Finite"
  fun op Isintegral _ = () val op Isintegral = TDB.find "Isintegral"
  fun op Plus_zero _ = () val op Plus_zero = TDB.find "Plus_zero"
  fun op Minus_zero _ = () val op Minus_zero = TDB.find "Minus_zero"
  fun op Minus_infinity _ = ()
  val op Minus_infinity = TDB.find "Minus_infinity"
  fun op Plus_infinity _ = ()
  val op Plus_infinity = TDB.find "Plus_infinity"
  fun op float_add _ = () val op float_add = TDB.find "float_add"
  fun op float_sub _ = () val op float_sub = TDB.find "float_sub"
  fun op float_mul _ = () val op float_mul = TDB.find "float_mul"
  fun op float_div _ = () val op float_div = TDB.find "float_div"
  fun op float_rem _ = () val op float_rem = TDB.find "float_rem"
  fun op float_sqrt _ = () val op float_sqrt = TDB.find "float_sqrt"
  fun op ROUNDFLOAT _ = () val op ROUNDFLOAT = TDB.find "ROUNDFLOAT"
  fun op float_lt _ = () val op float_lt = TDB.find "float_lt"
  fun op float_le _ = () val op float_le = TDB.find "float_le"
  fun op float_gt _ = () val op float_gt = TDB.find "float_gt"
  fun op float_ge _ = () val op float_ge = TDB.find "float_ge"
  fun op float_eq _ = () val op float_eq = TDB.find "float_eq"
  fun op float_neg _ = () val op float_neg = TDB.find "float_neg"
  fun op float_abs _ = () val op float_abs = TDB.find "float_abs"
  fun op num2roundmode_roundmode2num _ = ()
  val op num2roundmode_roundmode2num = TDB.find
    "num2roundmode_roundmode2num"
  fun op roundmode2num_num2roundmode _ = ()
  val op roundmode2num_num2roundmode = TDB.find
    "roundmode2num_num2roundmode"
  fun op num2roundmode_11 _ = ()
  val op num2roundmode_11 = TDB.find "num2roundmode_11"
  fun op roundmode2num_11 _ = ()
  val op roundmode2num_11 = TDB.find "roundmode2num_11"
  fun op num2roundmode_ONTO _ = ()
  val op num2roundmode_ONTO = TDB.find "num2roundmode_ONTO"
  fun op roundmode2num_ONTO _ = ()
  val op roundmode2num_ONTO = TDB.find "roundmode2num_ONTO"
  fun op num2roundmode_thm _ = ()
  val op num2roundmode_thm = TDB.find "num2roundmode_thm"
  fun op roundmode2num_thm _ = ()
  val op roundmode2num_thm = TDB.find "roundmode2num_thm"
  fun op roundmode_EQ_roundmode _ = ()
  val op roundmode_EQ_roundmode = TDB.find "roundmode_EQ_roundmode"
  fun op roundmode_case_def _ = ()
  val op roundmode_case_def = TDB.find "roundmode_case_def"
  fun op datatype_roundmode _ = ()
  val op datatype_roundmode = TDB.find "datatype_roundmode"
  fun op roundmode_distinct _ = ()
  val op roundmode_distinct = TDB.find "roundmode_distinct"
  fun op roundmode_nchotomy _ = ()
  val op roundmode_nchotomy = TDB.find "roundmode_nchotomy"
  fun op roundmode_Axiom _ = ()
  val op roundmode_Axiom = TDB.find "roundmode_Axiom"
  fun op roundmode_induction _ = ()
  val op roundmode_induction = TDB.find "roundmode_induction"
  fun op roundmode_case_cong _ = ()
  val op roundmode_case_cong = TDB.find "roundmode_case_cong"
  fun op roundmode_case_eq _ = ()
  val op roundmode_case_eq = TDB.find "roundmode_case_eq"
  fun op num2ccode_ccode2num _ = ()
  val op num2ccode_ccode2num = TDB.find "num2ccode_ccode2num"
  fun op ccode2num_num2ccode _ = ()
  val op ccode2num_num2ccode = TDB.find "ccode2num_num2ccode"
  fun op num2ccode_11 _ = () val op num2ccode_11 = TDB.find "num2ccode_11"
  fun op ccode2num_11 _ = () val op ccode2num_11 = TDB.find "ccode2num_11"
  fun op num2ccode_ONTO _ = ()
  val op num2ccode_ONTO = TDB.find "num2ccode_ONTO"
  fun op ccode2num_ONTO _ = ()
  val op ccode2num_ONTO = TDB.find "ccode2num_ONTO"
  fun op num2ccode_thm _ = ()
  val op num2ccode_thm = TDB.find "num2ccode_thm"
  fun op ccode2num_thm _ = ()
  val op ccode2num_thm = TDB.find "ccode2num_thm"
  fun op ccode_EQ_ccode _ = ()
  val op ccode_EQ_ccode = TDB.find "ccode_EQ_ccode"
  fun op ccode_case_def _ = ()
  val op ccode_case_def = TDB.find "ccode_case_def"
  fun op datatype_ccode _ = ()
  val op datatype_ccode = TDB.find "datatype_ccode"
  fun op ccode_distinct _ = ()
  val op ccode_distinct = TDB.find "ccode_distinct"
  fun op ccode_nchotomy _ = ()
  val op ccode_nchotomy = TDB.find "ccode_nchotomy"
  fun op ccode_Axiom _ = () val op ccode_Axiom = TDB.find "ccode_Axiom"
  fun op ccode_induction _ = ()
  val op ccode_induction = TDB.find "ccode_induction"
  fun op ccode_case_cong _ = ()
  val op ccode_case_cong = TDB.find "ccode_case_cong"
  fun op ccode_case_eq _ = ()
  val op ccode_case_eq = TDB.find "ccode_case_eq"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ieee_grammars = merge_grammars ["transc"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ieee"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ieee_grammars = 
    Portable.## (addtyUDs,addtmUDs) ieee_grammars
  val _ = Parse.grammarDB_insert("ieee",ieee_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ieee"

end
