structure binary_ieeeTheory :> binary_ieeeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading binary_ieeeTheory ... "
    else ()
  
  open Type Term Thm
  local open intrealTheory transcTheory wordsTheory EnumType in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "binary_ieee"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/floating-point/binary_ieeeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op float_TY_DEF _ = () val op float_TY_DEF = TDB.find "float_TY_DEF"
  fun op float_case_def _ = ()
  val op float_case_def = TDB.find "float_case_def"
  fun op float_size_def _ = ()
  val op float_size_def = TDB.find "float_size_def"
  fun op float_Sign _ = () val op float_Sign = TDB.find "float_Sign"
  fun op float_Exponent _ = ()
  val op float_Exponent = TDB.find "float_Exponent"
  fun op float_Significand _ = ()
  val op float_Significand = TDB.find "float_Significand"
  fun op float_Sign_fupd _ = ()
  val op float_Sign_fupd = TDB.find "float_Sign_fupd"
  fun op float_Exponent_fupd _ = ()
  val op float_Exponent_fupd = TDB.find "float_Exponent_fupd"
  fun op float_Significand_fupd _ = ()
  val op float_Significand_fupd = TDB.find "float_Significand_fupd"
  fun op float_value_TY_DEF _ = ()
  val op float_value_TY_DEF = TDB.find "float_value_TY_DEF"
  fun op float_value_case_def _ = ()
  val op float_value_case_def = TDB.find "float_value_case_def"
  fun op float_value_size_def _ = ()
  val op float_value_size_def = TDB.find "float_value_size_def"
  fun op float_to_real_def _ = ()
  val op float_to_real_def = TDB.find "float_to_real_def"
  fun op float_value_def _ = ()
  val op float_value_def = TDB.find "float_value_def"
  fun op float_is_nan_def _ = ()
  val op float_is_nan_def = TDB.find "float_is_nan_def"
  fun op float_is_signalling_def _ = ()
  val op float_is_signalling_def = TDB.find "float_is_signalling_def"
  fun op float_is_infinite_def _ = ()
  val op float_is_infinite_def = TDB.find "float_is_infinite_def"
  fun op float_is_normal_def _ = ()
  val op float_is_normal_def = TDB.find "float_is_normal_def"
  fun op float_is_subnormal_def _ = ()
  val op float_is_subnormal_def = TDB.find "float_is_subnormal_def"
  fun op float_is_zero_def _ = ()
  val op float_is_zero_def = TDB.find "float_is_zero_def"
  fun op float_is_finite_def _ = ()
  val op float_is_finite_def = TDB.find "float_is_finite_def"
  fun op is_integral_def _ = ()
  val op is_integral_def = TDB.find "is_integral_def"
  fun op float_is_integral_def _ = ()
  val op float_is_integral_def = TDB.find "float_is_integral_def"
  fun op float_negate_def _ = ()
  val op float_negate_def = TDB.find "float_negate_def"
  fun op float_abs_def _ = ()
  val op float_abs_def = TDB.find "float_abs_def"
  fun op float_plus_infinity_def _ = ()
  val op float_plus_infinity_def = TDB.find "float_plus_infinity_def"
  fun op float_plus_zero_def _ = ()
  val op float_plus_zero_def = TDB.find "float_plus_zero_def"
  fun op float_top_def _ = ()
  val op float_top_def = TDB.find "float_top_def"
  fun op float_plus_min_def _ = ()
  val op float_plus_min_def = TDB.find "float_plus_min_def"
  fun op float_minus_infinity_def _ = ()
  val op float_minus_infinity_def = TDB.find "float_minus_infinity_def"
  fun op float_minus_zero_def _ = ()
  val op float_minus_zero_def = TDB.find "float_minus_zero_def"
  fun op float_bottom_def _ = ()
  val op float_bottom_def = TDB.find "float_bottom_def"
  fun op float_minus_min_def _ = ()
  val op float_minus_min_def = TDB.find "float_minus_min_def"
  fun op flags_TY_DEF _ = () val op flags_TY_DEF = TDB.find "flags_TY_DEF"
  fun op flags_case_def _ = ()
  val op flags_case_def = TDB.find "flags_case_def"
  fun op flags_size_def _ = ()
  val op flags_size_def = TDB.find "flags_size_def"
  fun op flags_DivideByZero _ = ()
  val op flags_DivideByZero = TDB.find "flags_DivideByZero"
  fun op flags_InvalidOp _ = ()
  val op flags_InvalidOp = TDB.find "flags_InvalidOp"
  fun op flags_Overflow _ = ()
  val op flags_Overflow = TDB.find "flags_Overflow"
  fun op flags_Precision _ = ()
  val op flags_Precision = TDB.find "flags_Precision"
  fun op flags_Underflow_BeforeRounding _ = ()
  val op flags_Underflow_BeforeRounding = TDB.find
    "flags_Underflow_BeforeRounding"
  fun op flags_Underflow_AfterRounding _ = ()
  val op flags_Underflow_AfterRounding = TDB.find
    "flags_Underflow_AfterRounding"
  fun op flags_DivideByZero_fupd _ = ()
  val op flags_DivideByZero_fupd = TDB.find "flags_DivideByZero_fupd"
  fun op flags_InvalidOp_fupd _ = ()
  val op flags_InvalidOp_fupd = TDB.find "flags_InvalidOp_fupd"
  fun op flags_Overflow_fupd _ = ()
  val op flags_Overflow_fupd = TDB.find "flags_Overflow_fupd"
  fun op flags_Precision_fupd _ = ()
  val op flags_Precision_fupd = TDB.find "flags_Precision_fupd"
  fun op flags_Underflow_BeforeRounding_fupd _ = ()
  val op flags_Underflow_BeforeRounding_fupd = TDB.find
    "flags_Underflow_BeforeRounding_fupd"
  fun op flags_Underflow_AfterRounding_fupd _ = ()
  val op flags_Underflow_AfterRounding_fupd = TDB.find
    "flags_Underflow_AfterRounding_fupd"
  fun op clear_flags_def _ = ()
  val op clear_flags_def = TDB.find "clear_flags_def"
  fun op invalidop_flags_def _ = ()
  val op invalidop_flags_def = TDB.find "invalidop_flags_def"
  fun op dividezero_flags_def _ = ()
  val op dividezero_flags_def = TDB.find "dividezero_flags_def"
  fun op rounding_TY_DEF _ = ()
  val op rounding_TY_DEF = TDB.find "rounding_TY_DEF"
  fun op rounding_BIJ _ = () val op rounding_BIJ = TDB.find "rounding_BIJ"
  
  
  
  
  fun op rounding_size_def _ = ()
  val op rounding_size_def = TDB.find "rounding_size_def"
  fun op rounding_CASE _ = ()
  val op rounding_CASE = TDB.find "rounding_CASE"
  fun op is_closest_def _ = ()
  val op is_closest_def = TDB.find "is_closest_def"
  fun op closest_such_def _ = ()
  val op closest_such_def = TDB.find "closest_such_def"
  fun op closest_def _ = () val op closest_def = TDB.find "closest_def"
  fun op largest_def _ = () val op largest_def = TDB.find "largest_def"
  fun op threshold_def _ = ()
  val op threshold_def = TDB.find "threshold_def"
  fun op ULP_primitive_def _ = ()
  val op ULP_primitive_def = TDB.find "ULP_primitive_def"
  fun op ulp_def _ = () val op ulp_def = TDB.find "ulp_def"
  fun op round_def _ = () val op round_def = TDB.find "round_def"
  fun op integral_round_def _ = ()
  val op integral_round_def = TDB.find "integral_round_def"
  fun op fp_op_TY_DEF _ = () val op fp_op_TY_DEF = TDB.find "fp_op_TY_DEF"
  fun op fp_op_case_def _ = ()
  val op fp_op_case_def = TDB.find "fp_op_case_def"
  fun op fp_op_size_def _ = ()
  val op fp_op_size_def = TDB.find "fp_op_size_def"
  fun op float_some_qnan_def _ = ()
  val op float_some_qnan_def = TDB.find "float_some_qnan_def"
  fun op float_round_def _ = ()
  val op float_round_def = TDB.find "float_round_def"
  fun op float_round_with_flags_def _ = ()
  val op float_round_with_flags_def = TDB.find "float_round_with_flags_def"
  fun op check_for_signalling_def _ = ()
  val op check_for_signalling_def = TDB.find "check_for_signalling_def"
  fun op real_to_float_def _ = ()
  val op real_to_float_def = TDB.find "real_to_float_def"
  fun op real_to_float_with_flags_def _ = ()
  val op real_to_float_with_flags_def = TDB.find
    "real_to_float_with_flags_def"
  fun op float_round_to_integral_def _ = ()
  val op float_round_to_integral_def = TDB.find
    "float_round_to_integral_def"
  fun op float_to_int_def _ = ()
  val op float_to_int_def = TDB.find "float_to_int_def"
  fun op float_sqrt_def _ = ()
  val op float_sqrt_def = TDB.find "float_sqrt_def"
  fun op float_add_def _ = ()
  val op float_add_def = TDB.find "float_add_def"
  fun op float_sub_def _ = ()
  val op float_sub_def = TDB.find "float_sub_def"
  fun op float_mul_def _ = ()
  val op float_mul_def = TDB.find "float_mul_def"
  fun op float_div_def _ = ()
  val op float_div_def = TDB.find "float_div_def"
  fun op float_mul_add_def _ = ()
  val op float_mul_add_def = TDB.find "float_mul_add_def"
  fun op float_mul_sub_def _ = ()
  val op float_mul_sub_def = TDB.find "float_mul_sub_def"
  fun op float_compare_TY_DEF _ = ()
  val op float_compare_TY_DEF = TDB.find "float_compare_TY_DEF"
  fun op float_compare_BIJ _ = ()
  val op float_compare_BIJ = TDB.find "float_compare_BIJ"
  
  
  
  
  fun op float_compare_size_def _ = ()
  val op float_compare_size_def = TDB.find "float_compare_size_def"
  fun op float_compare_CASE _ = ()
  val op float_compare_CASE = TDB.find "float_compare_CASE"
  fun op float_compare_def _ = ()
  val op float_compare_def = TDB.find "float_compare_def"
  fun op float_less_than_def _ = ()
  val op float_less_than_def = TDB.find "float_less_than_def"
  fun op float_less_equal_def _ = ()
  val op float_less_equal_def = TDB.find "float_less_equal_def"
  fun op float_greater_than_def _ = ()
  val op float_greater_than_def = TDB.find "float_greater_than_def"
  fun op float_greater_equal_def _ = ()
  val op float_greater_equal_def = TDB.find "float_greater_equal_def"
  fun op float_equal_def _ = ()
  val op float_equal_def = TDB.find "float_equal_def"
  fun op exponent_boundary_def _ = ()
  val op exponent_boundary_def = TDB.find "exponent_boundary_def"
  fun op float_accessors _ = ()
  val op float_accessors = TDB.find "float_accessors"
  fun op float_fn_updates _ = ()
  val op float_fn_updates = TDB.find "float_fn_updates"
  fun op float_accfupds _ = ()
  val op float_accfupds = TDB.find "float_accfupds"
  fun op float_fupdfupds _ = ()
  val op float_fupdfupds = TDB.find "float_fupdfupds"
  fun op float_fupdfupds_comp _ = ()
  val op float_fupdfupds_comp = TDB.find "float_fupdfupds_comp"
  fun op float_fupdcanon _ = ()
  val op float_fupdcanon = TDB.find "float_fupdcanon"
  fun op float_fupdcanon_comp _ = ()
  val op float_fupdcanon_comp = TDB.find "float_fupdcanon_comp"
  fun op float_component_equality _ = ()
  val op float_component_equality = TDB.find "float_component_equality"
  fun op float_updates_eq_literal _ = ()
  val op float_updates_eq_literal = TDB.find "float_updates_eq_literal"
  fun op float_literal_nchotomy _ = ()
  val op float_literal_nchotomy = TDB.find "float_literal_nchotomy"
  fun op FORALL_float _ = () val op FORALL_float = TDB.find "FORALL_float"
  fun op EXISTS_float _ = () val op EXISTS_float = TDB.find "EXISTS_float"
  fun op float_literal_11 _ = ()
  val op float_literal_11 = TDB.find "float_literal_11"
  fun op datatype_float _ = ()
  val op datatype_float = TDB.find "datatype_float"
  fun op float_11 _ = () val op float_11 = TDB.find "float_11"
  fun op float_nchotomy _ = ()
  val op float_nchotomy = TDB.find "float_nchotomy"
  fun op float_Axiom _ = () val op float_Axiom = TDB.find "float_Axiom"
  fun op float_induction _ = ()
  val op float_induction = TDB.find "float_induction"
  fun op float_case_cong _ = ()
  val op float_case_cong = TDB.find "float_case_cong"
  fun op float_case_eq _ = ()
  val op float_case_eq = TDB.find "float_case_eq"
  fun op datatype_float_value _ = ()
  val op datatype_float_value = TDB.find "datatype_float_value"
  fun op float_value_11 _ = ()
  val op float_value_11 = TDB.find "float_value_11"
  fun op float_value_distinct _ = ()
  val op float_value_distinct = TDB.find "float_value_distinct"
  fun op float_value_nchotomy _ = ()
  val op float_value_nchotomy = TDB.find "float_value_nchotomy"
  fun op float_value_Axiom _ = ()
  val op float_value_Axiom = TDB.find "float_value_Axiom"
  fun op float_value_induction _ = ()
  val op float_value_induction = TDB.find "float_value_induction"
  fun op float_value_case_cong _ = ()
  val op float_value_case_cong = TDB.find "float_value_case_cong"
  fun op float_value_case_eq _ = ()
  val op float_value_case_eq = TDB.find "float_value_case_eq"
  fun op flags_accessors _ = ()
  val op flags_accessors = TDB.find "flags_accessors"
  fun op flags_fn_updates _ = ()
  val op flags_fn_updates = TDB.find "flags_fn_updates"
  fun op flags_accfupds _ = ()
  val op flags_accfupds = TDB.find "flags_accfupds"
  fun op flags_fupdfupds _ = ()
  val op flags_fupdfupds = TDB.find "flags_fupdfupds"
  fun op flags_fupdfupds_comp _ = ()
  val op flags_fupdfupds_comp = TDB.find "flags_fupdfupds_comp"
  fun op flags_fupdcanon _ = ()
  val op flags_fupdcanon = TDB.find "flags_fupdcanon"
  fun op flags_fupdcanon_comp _ = ()
  val op flags_fupdcanon_comp = TDB.find "flags_fupdcanon_comp"
  fun op flags_component_equality _ = ()
  val op flags_component_equality = TDB.find "flags_component_equality"
  fun op flags_updates_eq_literal _ = ()
  val op flags_updates_eq_literal = TDB.find "flags_updates_eq_literal"
  fun op flags_literal_nchotomy _ = ()
  val op flags_literal_nchotomy = TDB.find "flags_literal_nchotomy"
  fun op FORALL_flags _ = () val op FORALL_flags = TDB.find "FORALL_flags"
  fun op EXISTS_flags _ = () val op EXISTS_flags = TDB.find "EXISTS_flags"
  fun op flags_literal_11 _ = ()
  val op flags_literal_11 = TDB.find "flags_literal_11"
  fun op datatype_flags _ = ()
  val op datatype_flags = TDB.find "datatype_flags"
  fun op flags_11 _ = () val op flags_11 = TDB.find "flags_11"
  fun op flags_nchotomy _ = ()
  val op flags_nchotomy = TDB.find "flags_nchotomy"
  fun op flags_Axiom _ = () val op flags_Axiom = TDB.find "flags_Axiom"
  fun op flags_induction _ = ()
  val op flags_induction = TDB.find "flags_induction"
  fun op flags_case_cong _ = ()
  val op flags_case_cong = TDB.find "flags_case_cong"
  fun op flags_case_eq _ = ()
  val op flags_case_eq = TDB.find "flags_case_eq"
  fun op num2rounding_rounding2num _ = ()
  val op num2rounding_rounding2num = TDB.find "num2rounding_rounding2num"
  fun op rounding2num_num2rounding _ = ()
  val op rounding2num_num2rounding = TDB.find "rounding2num_num2rounding"
  fun op num2rounding_11 _ = ()
  val op num2rounding_11 = TDB.find "num2rounding_11"
  fun op rounding2num_11 _ = ()
  val op rounding2num_11 = TDB.find "rounding2num_11"
  fun op num2rounding_ONTO _ = ()
  val op num2rounding_ONTO = TDB.find "num2rounding_ONTO"
  fun op rounding2num_ONTO _ = ()
  val op rounding2num_ONTO = TDB.find "rounding2num_ONTO"
  fun op num2rounding_thm _ = ()
  val op num2rounding_thm = TDB.find "num2rounding_thm"
  fun op rounding2num_thm _ = ()
  val op rounding2num_thm = TDB.find "rounding2num_thm"
  fun op rounding_EQ_rounding _ = ()
  val op rounding_EQ_rounding = TDB.find "rounding_EQ_rounding"
  fun op rounding_case_def _ = ()
  val op rounding_case_def = TDB.find "rounding_case_def"
  fun op datatype_rounding _ = ()
  val op datatype_rounding = TDB.find "datatype_rounding"
  fun op rounding_distinct _ = ()
  val op rounding_distinct = TDB.find "rounding_distinct"
  fun op rounding_nchotomy _ = ()
  val op rounding_nchotomy = TDB.find "rounding_nchotomy"
  fun op rounding_Axiom _ = ()
  val op rounding_Axiom = TDB.find "rounding_Axiom"
  fun op rounding_induction _ = ()
  val op rounding_induction = TDB.find "rounding_induction"
  fun op rounding_case_cong _ = ()
  val op rounding_case_cong = TDB.find "rounding_case_cong"
  fun op rounding_case_eq _ = ()
  val op rounding_case_eq = TDB.find "rounding_case_eq"
  fun op ULP_ind _ = () val op ULP_ind = TDB.find "ULP_ind"
  fun op ULP_def _ = () val op ULP_def = TDB.find "ULP_def"
  fun op datatype_fp_op _ = ()
  val op datatype_fp_op = TDB.find "datatype_fp_op"
  fun op fp_op_11 _ = () val op fp_op_11 = TDB.find "fp_op_11"
  fun op fp_op_distinct _ = ()
  val op fp_op_distinct = TDB.find "fp_op_distinct"
  fun op fp_op_nchotomy _ = ()
  val op fp_op_nchotomy = TDB.find "fp_op_nchotomy"
  fun op fp_op_Axiom _ = () val op fp_op_Axiom = TDB.find "fp_op_Axiom"
  fun op fp_op_induction _ = ()
  val op fp_op_induction = TDB.find "fp_op_induction"
  fun op fp_op_case_cong _ = ()
  val op fp_op_case_cong = TDB.find "fp_op_case_cong"
  fun op fp_op_case_eq _ = ()
  val op fp_op_case_eq = TDB.find "fp_op_case_eq"
  fun op num2float_compare_float_compare2num _ = ()
  val op num2float_compare_float_compare2num = TDB.find
    "num2float_compare_float_compare2num"
  fun op float_compare2num_num2float_compare _ = ()
  val op float_compare2num_num2float_compare = TDB.find
    "float_compare2num_num2float_compare"
  fun op num2float_compare_11 _ = ()
  val op num2float_compare_11 = TDB.find "num2float_compare_11"
  fun op float_compare2num_11 _ = ()
  val op float_compare2num_11 = TDB.find "float_compare2num_11"
  fun op num2float_compare_ONTO _ = ()
  val op num2float_compare_ONTO = TDB.find "num2float_compare_ONTO"
  fun op float_compare2num_ONTO _ = ()
  val op float_compare2num_ONTO = TDB.find "float_compare2num_ONTO"
  fun op num2float_compare_thm _ = ()
  val op num2float_compare_thm = TDB.find "num2float_compare_thm"
  fun op float_compare2num_thm _ = ()
  val op float_compare2num_thm = TDB.find "float_compare2num_thm"
  fun op float_compare_EQ_float_compare _ = ()
  val op float_compare_EQ_float_compare = TDB.find
    "float_compare_EQ_float_compare"
  fun op float_compare_case_def _ = ()
  val op float_compare_case_def = TDB.find "float_compare_case_def"
  fun op datatype_float_compare _ = ()
  val op datatype_float_compare = TDB.find "datatype_float_compare"
  fun op float_compare_distinct _ = ()
  val op float_compare_distinct = TDB.find "float_compare_distinct"
  fun op float_compare_nchotomy _ = ()
  val op float_compare_nchotomy = TDB.find "float_compare_nchotomy"
  fun op float_compare_Axiom _ = ()
  val op float_compare_Axiom = TDB.find "float_compare_Axiom"
  fun op float_compare_induction _ = ()
  val op float_compare_induction = TDB.find "float_compare_induction"
  fun op float_compare_case_cong _ = ()
  val op float_compare_case_cong = TDB.find "float_compare_case_cong"
  fun op float_compare_case_eq _ = ()
  val op float_compare_case_eq = TDB.find "float_compare_case_eq"
  fun op zero_lt_twopow _ = ()
  val op zero_lt_twopow = TDB.find "zero_lt_twopow"
  fun op zero_le_twopow _ = ()
  val op zero_le_twopow = TDB.find "zero_le_twopow"
  fun op zero_neq_twopow _ = ()
  val op zero_neq_twopow = TDB.find "zero_neq_twopow"
  fun op zero_le_pos_div_twopow _ = ()
  val op zero_le_pos_div_twopow = TDB.find "zero_le_pos_div_twopow"
  fun op div_eq0 _ = () val op div_eq0 = TDB.find "div_eq0"
  fun op exp_ge2 _ = () val op exp_ge2 = TDB.find "exp_ge2"
  fun op exp_gt2 _ = () val op exp_gt2 = TDB.find "exp_gt2"
  fun op le2 _ = () val op le2 = TDB.find "le2"
  fun op float_components _ = ()
  val op float_components = TDB.find "float_components"
  fun op float_distinct _ = ()
  val op float_distinct = TDB.find "float_distinct"
  fun op float_values _ = () val op float_values = TDB.find "float_values"
  fun op zero_to_real _ = () val op zero_to_real = TDB.find "zero_to_real"
  fun op sign_not_zero _ = ()
  val op sign_not_zero = TDB.find "sign_not_zero"
  fun op float_sets _ = () val op float_sets = TDB.find "float_sets"
  fun op infinity_properties _ = ()
  val op infinity_properties = TDB.find "infinity_properties"
  fun op zero_properties _ = ()
  val op zero_properties = TDB.find "zero_properties"
  fun op some_nan_properties _ = ()
  val op some_nan_properties = TDB.find "some_nan_properties"
  fun op min_properties _ = ()
  val op min_properties = TDB.find "min_properties"
  fun op top_properties _ = ()
  val op top_properties = TDB.find "top_properties"
  fun op bottom_properties _ = ()
  val op bottom_properties = TDB.find "bottom_properties"
  fun op float_is_zero _ = ()
  val op float_is_zero = TDB.find "float_is_zero"
  fun op float_is_finite _ = ()
  val op float_is_finite = TDB.find "float_is_finite"
  fun op float_cases_finite _ = ()
  val op float_cases_finite = TDB.find "float_cases_finite"
  fun op float_distinct_finite _ = ()
  val op float_distinct_finite = TDB.find "float_distinct_finite"
  fun op float_cases _ = () val op float_cases = TDB.find "float_cases"
  fun op float_is_distinct _ = ()
  val op float_is_distinct = TDB.find "float_is_distinct"
  fun op float_infinities _ = ()
  val op float_infinities = TDB.find "float_infinities"
  fun op float_infinities_distinct _ = ()
  val op float_infinities_distinct = TDB.find "float_infinities_distinct"
  fun op float_to_real_negate _ = ()
  val op float_to_real_negate = TDB.find "float_to_real_negate"
  fun op float_negate_negate _ = ()
  val op float_negate_negate = TDB.find "float_negate_negate"
  fun op ulp _ = () val op ulp = TDB.find "ulp"
  fun op neg_ulp _ = () val op neg_ulp = TDB.find "neg_ulp"
  fun op ULP_le_mono _ = () val op ULP_le_mono = TDB.find "ULP_le_mono"
  fun op ulp_lt_ULP _ = () val op ulp_lt_ULP = TDB.find "ulp_lt_ULP"
  fun op ulp_lt_largest _ = ()
  val op ulp_lt_largest = TDB.find "ulp_lt_largest"
  fun op ulp_lt_threshold _ = ()
  val op ulp_lt_threshold = TDB.find "ulp_lt_threshold"
  fun op abs_float_value _ = ()
  val op abs_float_value = TDB.find "abs_float_value"
  fun op less_than_ulp _ = ()
  val op less_than_ulp = TDB.find "less_than_ulp"
  fun op float_is_zero_to_real _ = ()
  val op float_is_zero_to_real = TDB.find "float_is_zero_to_real"
  fun op float_to_real_eq _ = ()
  val op float_to_real_eq = TDB.find "float_to_real_eq"
  fun op diff_float_ULP _ = ()
  val op diff_float_ULP = TDB.find "diff_float_ULP"
  fun op diff_lt_ulp_eq0 _ = ()
  val op diff_lt_ulp_eq0 = TDB.find "diff_lt_ulp_eq0"
  fun op diff_lt_ulp_even _ = ()
  val op diff_lt_ulp_even = TDB.find "diff_lt_ulp_even"
  fun op diff_lt_ulp_even4 _ = ()
  val op diff_lt_ulp_even4 = TDB.find "diff_lt_ulp_even4"
  fun op round_roundTowardZero _ = ()
  val op round_roundTowardZero = TDB.find "round_roundTowardZero"
  fun op round_roundTiesToEven _ = ()
  val op round_roundTiesToEven = TDB.find "round_roundTiesToEven"
  fun op round_roundTiesToEven0 _ = ()
  val op round_roundTiesToEven0 = TDB.find "round_roundTiesToEven0"
  fun op round_roundTowardZero_is_zero _ = ()
  val op round_roundTowardZero_is_zero = TDB.find
    "round_roundTowardZero_is_zero"
  fun op round_roundTiesToEven_is_zero _ = ()
  val op round_roundTiesToEven_is_zero = TDB.find
    "round_roundTiesToEven_is_zero"
  fun op round_roundTowardZero_is_minus_zero _ = ()
  val op round_roundTowardZero_is_minus_zero = TDB.find
    "round_roundTowardZero_is_minus_zero"
  fun op round_roundTowardZero_is_plus_zero _ = ()
  val op round_roundTowardZero_is_plus_zero = TDB.find
    "round_roundTowardZero_is_plus_zero"
  fun op round_roundTiesToEven_is_minus_zero _ = ()
  val op round_roundTiesToEven_is_minus_zero = TDB.find
    "round_roundTiesToEven_is_minus_zero"
  fun op round_roundTiesToEven_is_plus_zero _ = ()
  val op round_roundTiesToEven_is_plus_zero = TDB.find
    "round_roundTiesToEven_is_plus_zero"
  fun op largest_is_positive _ = ()
  val op largest_is_positive = TDB.find "largest_is_positive"
  fun op threshold_is_positive _ = ()
  val op threshold_is_positive = TDB.find "threshold_is_positive"
  fun op round_roundTiesToEven_plus_infinity _ = ()
  val op round_roundTiesToEven_plus_infinity = TDB.find
    "round_roundTiesToEven_plus_infinity"
  fun op round_roundTiesToEven_minus_infinity _ = ()
  val op round_roundTiesToEven_minus_infinity = TDB.find
    "round_roundTiesToEven_minus_infinity"
  fun op round_roundTowardZero_top _ = ()
  val op round_roundTowardZero_top = TDB.find "round_roundTowardZero_top"
  fun op round_roundTowardZero_bottom _ = ()
  val op round_roundTowardZero_bottom = TDB.find
    "round_roundTowardZero_bottom"
  fun op round_roundTowardPositive_plus_infinity _ = ()
  val op round_roundTowardPositive_plus_infinity = TDB.find
    "round_roundTowardPositive_plus_infinity"
  fun op round_roundTowardPositive_bottom _ = ()
  val op round_roundTowardPositive_bottom = TDB.find
    "round_roundTowardPositive_bottom"
  fun op round_roundTowardNegative_top _ = ()
  val op round_roundTowardNegative_top = TDB.find
    "round_roundTowardNegative_top"
  fun op round_roundTowardNegative_minus_infinity _ = ()
  val op round_roundTowardNegative_minus_infinity = TDB.find
    "round_roundTowardNegative_minus_infinity"
  fun op float_round_roundTowardZero_top _ = ()
  val op float_round_roundTowardZero_top = TDB.find
    "float_round_roundTowardZero_top"
  fun op float_round_roundTowardZero_bottom _ = ()
  val op float_round_roundTowardZero_bottom = TDB.find
    "float_round_roundTowardZero_bottom"
  fun op float_round_roundTowardPositive_plus_infinity _ = ()
  val op float_round_roundTowardPositive_plus_infinity = TDB.find
    "float_round_roundTowardPositive_plus_infinity"
  fun op float_round_roundTowardPositive_bottom _ = ()
  val op float_round_roundTowardPositive_bottom = TDB.find
    "float_round_roundTowardPositive_bottom"
  fun op float_round_roundTowardNegative_top _ = ()
  val op float_round_roundTowardNegative_top = TDB.find
    "float_round_roundTowardNegative_top"
  fun op float_round_roundTowardNegative_minus_infinity _ = ()
  val op float_round_roundTowardNegative_minus_infinity = TDB.find
    "float_round_roundTowardNegative_minus_infinity"
  fun op float_minus_zero _ = ()
  val op float_minus_zero = TDB.find "float_minus_zero"
  fun op float_minus_infinity _ = ()
  val op float_minus_infinity = TDB.find "float_minus_infinity"
  fun op float_round_non_zero _ = ()
  val op float_round_non_zero = TDB.find "float_round_non_zero"
  fun op float_round_plus_infinity _ = ()
  val op float_round_plus_infinity = TDB.find "float_round_plus_infinity"
  fun op float_round_minus_infinity _ = ()
  val op float_round_minus_infinity = TDB.find "float_round_minus_infinity"
  fun op float_round_top _ = ()
  val op float_round_top = TDB.find "float_round_top"
  fun op float_round_bottom _ = ()
  val op float_round_bottom = TDB.find "float_round_bottom"
  fun op float_to_real _ = ()
  val op float_to_real = TDB.find "float_to_real"
  fun op largest _ = () val op largest = TDB.find "largest"
  fun op threshold _ = () val op threshold = TDB.find "threshold"
  fun op largest_is_top _ = ()
  val op largest_is_top = TDB.find "largest_is_top"
  fun op largest_lt_threshold _ = ()
  val op largest_lt_threshold = TDB.find "largest_lt_threshold"
  fun op float_tests _ = () val op float_tests = TDB.find "float_tests"
  fun op float_infinity_negate_abs _ = ()
  val op float_infinity_negate_abs = TDB.find "float_infinity_negate_abs"
  fun op float_round_to_integral_compute _ = ()
  val op float_round_to_integral_compute = TDB.find
    "float_round_to_integral_compute"
  fun op float_add_compute _ = ()
  val op float_add_compute = TDB.find "float_add_compute"
  fun op float_add_nan _ = ()
  val op float_add_nan = TDB.find "float_add_nan"
  fun op float_add_finite _ = ()
  val op float_add_finite = TDB.find "float_add_finite"
  fun op float_add_finite_plus_infinity _ = ()
  val op float_add_finite_plus_infinity = TDB.find
    "float_add_finite_plus_infinity"
  fun op float_add_plus_infinity_finite _ = ()
  val op float_add_plus_infinity_finite = TDB.find
    "float_add_plus_infinity_finite"
  fun op float_add_finite_minus_infinity _ = ()
  val op float_add_finite_minus_infinity = TDB.find
    "float_add_finite_minus_infinity"
  fun op float_add_minus_infinity_finite _ = ()
  val op float_add_minus_infinity_finite = TDB.find
    "float_add_minus_infinity_finite"
  fun op float_sub_compute _ = ()
  val op float_sub_compute = TDB.find "float_sub_compute"
  fun op float_sub_nan _ = ()
  val op float_sub_nan = TDB.find "float_sub_nan"
  fun op float_sub_finite _ = ()
  val op float_sub_finite = TDB.find "float_sub_finite"
  fun op float_sub_finite_plus_infinity _ = ()
  val op float_sub_finite_plus_infinity = TDB.find
    "float_sub_finite_plus_infinity"
  fun op float_sub_plus_infinity_finite _ = ()
  val op float_sub_plus_infinity_finite = TDB.find
    "float_sub_plus_infinity_finite"
  fun op float_sub_finite_minus_infinity _ = ()
  val op float_sub_finite_minus_infinity = TDB.find
    "float_sub_finite_minus_infinity"
  fun op float_sub_minus_infinity_finite _ = ()
  val op float_sub_minus_infinity_finite = TDB.find
    "float_sub_minus_infinity_finite"
  fun op float_mul_compute _ = ()
  val op float_mul_compute = TDB.find "float_mul_compute"
  fun op float_mul_nan _ = ()
  val op float_mul_nan = TDB.find "float_mul_nan"
  fun op float_mul_finite _ = ()
  val op float_mul_finite = TDB.find "float_mul_finite"
  fun op float_mul_finite_plus_infinity _ = ()
  val op float_mul_finite_plus_infinity = TDB.find
    "float_mul_finite_plus_infinity"
  fun op float_mul_plus_infinity_finite _ = ()
  val op float_mul_plus_infinity_finite = TDB.find
    "float_mul_plus_infinity_finite"
  fun op float_mul_finite_minus_infinity _ = ()
  val op float_mul_finite_minus_infinity = TDB.find
    "float_mul_finite_minus_infinity"
  fun op float_mul_minus_infinity_finite _ = ()
  val op float_mul_minus_infinity_finite = TDB.find
    "float_mul_minus_infinity_finite"
  fun op float_div_compute _ = ()
  val op float_div_compute = TDB.find "float_div_compute"
  fun op float_div_nan _ = ()
  val op float_div_nan = TDB.find "float_div_nan"
  fun op float_div_finite _ = ()
  val op float_div_finite = TDB.find "float_div_finite"
  fun op float_div_finite_plus_infinity _ = ()
  val op float_div_finite_plus_infinity = TDB.find
    "float_div_finite_plus_infinity"
  fun op float_div_plus_infinity_finite _ = ()
  val op float_div_plus_infinity_finite = TDB.find
    "float_div_plus_infinity_finite"
  fun op float_div_finite_minus_infinity _ = ()
  val op float_div_finite_minus_infinity = TDB.find
    "float_div_finite_minus_infinity"
  fun op float_div_minus_infinity_finite _ = ()
  val op float_div_minus_infinity_finite = TDB.find
    "float_div_minus_infinity_finite"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val binary_ieee_grammars = merge_grammars ["words", "transc", "intreal"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="binary_ieee"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val binary_ieee_grammars = 
    Portable.## (addtyUDs,addtmUDs) binary_ieee_grammars
  val _ = Parse.grammarDB_insert("binary_ieee",binary_ieee_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "binary_ieee"

end
