structure lift_ieeeTheory :> lift_ieeeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading lift_ieeeTheory ... "
    else ()
  
  open Type Term Thm
  local open binary_ieeeTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "lift_ieee"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/floating-point/lift_ieeeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op error_def _ = () val op error_def = TDB.find "error_def"
  fun op normalizes_def _ = ()
  val op normalizes_def = TDB.find "normalizes_def"
  fun op float_lt _ = () val op float_lt = TDB.find "float_lt"
  fun op float_le _ = () val op float_le = TDB.find "float_le"
  fun op float_gt _ = () val op float_gt = TDB.find "float_gt"
  fun op float_ge _ = () val op float_ge = TDB.find "float_ge"
  fun op float_eq _ = () val op float_eq = TDB.find "float_eq"
  fun op float_eq_refl _ = ()
  val op float_eq_refl = TDB.find "float_eq_refl"
  fun op is_closest_exits _ = ()
  val op is_closest_exits = TDB.find "is_closest_exits"
  fun op closest_is_everything _ = ()
  val op closest_is_everything = TDB.find "closest_is_everything"
  fun op closest_in_set _ = ()
  val op closest_in_set = TDB.find "closest_in_set"
  fun op closest_is_closest _ = ()
  val op closest_is_closest = TDB.find "closest_is_closest"
  fun op float_finite _ = () val op float_finite = TDB.find "float_finite"
  fun op is_finite_finite _ = ()
  val op is_finite_finite = TDB.find "is_finite_finite"
  fun op is_finite_nonempty _ = ()
  val op is_finite_nonempty = TDB.find "is_finite_nonempty"
  fun op is_finite_closest _ = ()
  val op is_finite_closest = TDB.find "is_finite_closest"
  fun op float_to_real_finite _ = ()
  val op float_to_real_finite = TDB.find "float_to_real_finite"
  fun op float_to_real_threshold _ = ()
  val op float_to_real_threshold = TDB.find "float_to_real_threshold"
  fun op error_at_worst_lemma _ = ()
  val op error_at_worst_lemma = TDB.find "error_at_worst_lemma"
  fun op error_is_zero _ = ()
  val op error_is_zero = TDB.find "error_is_zero"
  fun op relative_error _ = ()
  val op relative_error = TDB.find "relative_error"
  fun op float_round_finite _ = ()
  val op float_round_finite = TDB.find "float_round_finite"
  fun op float_add _ = () val op float_add = TDB.find "float_add"
  fun op float_sub _ = () val op float_sub = TDB.find "float_sub"
  fun op float_mul _ = () val op float_mul = TDB.find "float_mul"
  fun op float_div _ = () val op float_div = TDB.find "float_div"
  fun op float_sqrt _ = () val op float_sqrt = TDB.find "float_sqrt"
  fun op float_mul_add _ = ()
  val op float_mul_add = TDB.find "float_mul_add"
  fun op float_mul_sub _ = ()
  val op float_mul_sub = TDB.find "float_mul_sub"
  fun op float_add_finite _ = ()
  val op float_add_finite = TDB.find "float_add_finite"
  fun op float_sub_finite _ = ()
  val op float_sub_finite = TDB.find "float_sub_finite"
  fun op float_mul_finite _ = ()
  val op float_mul_finite = TDB.find "float_mul_finite"
  fun op float_div_finite _ = ()
  val op float_div_finite = TDB.find "float_div_finite"
  fun op float_sqrt_finite _ = ()
  val op float_sqrt_finite = TDB.find "float_sqrt_finite"
  fun op float_mul_add_finite _ = ()
  val op float_mul_add_finite = TDB.find "float_mul_add_finite"
  fun op float_mul_sub_finite _ = ()
  val op float_mul_sub_finite = TDB.find "float_mul_sub_finite"
  fun op float_add_relative _ = ()
  val op float_add_relative = TDB.find "float_add_relative"
  fun op float_sub_relative _ = ()
  val op float_sub_relative = TDB.find "float_sub_relative"
  fun op float_mul_relative _ = ()
  val op float_mul_relative = TDB.find "float_mul_relative"
  fun op float_div_relative _ = ()
  val op float_div_relative = TDB.find "float_div_relative"
  fun op float_sqrt_relative _ = ()
  val op float_sqrt_relative = TDB.find "float_sqrt_relative"
  fun op float_mul_add_relative _ = ()
  val op float_mul_add_relative = TDB.find "float_mul_add_relative"
  fun op float_mul_sub_relative _ = ()
  val op float_mul_sub_relative = TDB.find "float_mul_sub_relative"
  fun op finite_float_within_threshold _ = ()
  val op finite_float_within_threshold = TDB.find
    "finite_float_within_threshold"
  fun op round_finite_normal_float_id _ = ()
  val op round_finite_normal_float_id = TDB.find
    "round_finite_normal_float_id"
  fun op real_to_float_finite_normal_id _ = ()
  val op real_to_float_finite_normal_id = TDB.find
    "real_to_float_finite_normal_id"
  fun op float_to_real_real_to_float_zero_id _ = ()
  val op float_to_real_real_to_float_zero_id = TDB.find
    "float_to_real_real_to_float_zero_id"
  fun op non_representable_float_is_zero _ = ()
  val op non_representable_float_is_zero = TDB.find
    "non_representable_float_is_zero"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val lift_ieee_grammars = merge_grammars ["binary_ieee"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="lift_ieee"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val lift_ieee_grammars = 
    Portable.## (addtyUDs,addtmUDs) lift_ieee_grammars
  val _ = Parse.grammarDB_insert("lift_ieee",lift_ieee_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "lift_ieee"

end
