structure lift_machine_ieeeTheory :> lift_machine_ieeeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading lift_machine_ieeeTheory ... "
    else ()
  
  open Type Term Thm
  local open lift_ieeeTheory machine_ieeeTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "lift_machine_ieee"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/floating-point/lift_machine_ieeeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op interval_def _ = () val op interval_def = TDB.find "interval_def"
  fun op fp16_float_add_relative _ = ()
  val op fp16_float_add_relative = TDB.find "fp16_float_add_relative"
  fun op fp16_float_sub_relative _ = ()
  val op fp16_float_sub_relative = TDB.find "fp16_float_sub_relative"
  fun op fp16_float_mul_relative _ = ()
  val op fp16_float_mul_relative = TDB.find "fp16_float_mul_relative"
  fun op fp16_float_mul_add_relative _ = ()
  val op fp16_float_mul_add_relative = TDB.find
    "fp16_float_mul_add_relative"
  fun op fp16_float_mul_sub_relative _ = ()
  val op fp16_float_mul_sub_relative = TDB.find
    "fp16_float_mul_sub_relative"
  fun op fp16_float_div_relative _ = ()
  val op fp16_float_div_relative = TDB.find "fp16_float_div_relative"
  fun op fp16_float_sqrt_relative _ = ()
  val op fp16_float_sqrt_relative = TDB.find "fp16_float_sqrt_relative"
  fun op fp32_float_add_relative _ = ()
  val op fp32_float_add_relative = TDB.find "fp32_float_add_relative"
  fun op fp32_float_sub_relative _ = ()
  val op fp32_float_sub_relative = TDB.find "fp32_float_sub_relative"
  fun op fp32_float_mul_relative _ = ()
  val op fp32_float_mul_relative = TDB.find "fp32_float_mul_relative"
  fun op fp32_float_mul_add_relative _ = ()
  val op fp32_float_mul_add_relative = TDB.find
    "fp32_float_mul_add_relative"
  fun op fp32_float_mul_sub_relative _ = ()
  val op fp32_float_mul_sub_relative = TDB.find
    "fp32_float_mul_sub_relative"
  fun op fp32_float_div_relative _ = ()
  val op fp32_float_div_relative = TDB.find "fp32_float_div_relative"
  fun op fp32_float_sqrt_relative _ = ()
  val op fp32_float_sqrt_relative = TDB.find "fp32_float_sqrt_relative"
  fun op fp64_float_add_relative _ = ()
  val op fp64_float_add_relative = TDB.find "fp64_float_add_relative"
  fun op fp64_float_sub_relative _ = ()
  val op fp64_float_sub_relative = TDB.find "fp64_float_sub_relative"
  fun op fp64_float_mul_relative _ = ()
  val op fp64_float_mul_relative = TDB.find "fp64_float_mul_relative"
  fun op fp64_float_mul_add_relative _ = ()
  val op fp64_float_mul_add_relative = TDB.find
    "fp64_float_mul_add_relative"
  fun op fp64_float_mul_sub_relative _ = ()
  val op fp64_float_mul_sub_relative = TDB.find
    "fp64_float_mul_sub_relative"
  fun op fp64_float_div_relative _ = ()
  val op fp64_float_div_relative = TDB.find "fp64_float_div_relative"
  fun op fp64_float_sqrt_relative _ = ()
  val op fp64_float_sqrt_relative = TDB.find "fp64_float_sqrt_relative"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val lift_machine_ieee_grammars = merge_grammars ["machine_ieee",
  "lift_ieee"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="lift_machine_ieee"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val lift_machine_ieee_grammars = 
    Portable.## (addtyUDs,addtmUDs) lift_machine_ieee_grammars
  val _ = Parse.grammarDB_insert("lift_machine_ieee",lift_machine_ieee_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "lift_machine_ieee"

end
