structure machine_ieeeTheory :> machine_ieeeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading machine_ieeeTheory ... "
    else ()
  
  open Type Term Thm
  local open binary_ieeeTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "machine_ieee"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/floating-point/machine_ieeeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op fp16_to_float_def _ = ()
  val op fp16_to_float_def = TDB.find "fp16_to_float_def"
  fun op float_to_fp16_def _ = ()
  val op float_to_fp16_def = TDB.find "float_to_fp16_def"
  fun op fp16_to_real_def _ = ()
  val op fp16_to_real_def = TDB.find "fp16_to_real_def"
  fun op fp16_to_value_def _ = ()
  val op fp16_to_value_def = TDB.find "fp16_to_value_def"
  fun op real_to_fp16_def _ = ()
  val op real_to_fp16_def = TDB.find "real_to_fp16_def"
  fun op real_to_fp16_with_flags_def _ = ()
  val op real_to_fp16_with_flags_def = TDB.find
    "real_to_fp16_with_flags_def"
  fun op int_to_fp16_def _ = ()
  val op int_to_fp16_def = TDB.find "int_to_fp16_def"
  fun op fp16_roundToIntegral_def _ = ()
  val op fp16_roundToIntegral_def = TDB.find "fp16_roundToIntegral_def"
  fun op fp16_to_int_def _ = ()
  val op fp16_to_int_def = TDB.find "fp16_to_int_def"
  fun op fp16_sqrt_def _ = ()
  val op fp16_sqrt_def = TDB.find "fp16_sqrt_def"
  fun op fp16_sqrt_with_flags_def _ = ()
  val op fp16_sqrt_with_flags_def = TDB.find "fp16_sqrt_with_flags_def"
  fun op fp16_negate_def _ = ()
  val op fp16_negate_def = TDB.find "fp16_negate_def"
  fun op fp16_abs_def _ = () val op fp16_abs_def = TDB.find "fp16_abs_def"
  fun op fp16_isNan_def _ = ()
  val op fp16_isNan_def = TDB.find "fp16_isNan_def"
  fun op fp16_isSignallingNan_def _ = ()
  val op fp16_isSignallingNan_def = TDB.find "fp16_isSignallingNan_def"
  fun op fp16_isIntegral_def _ = ()
  val op fp16_isIntegral_def = TDB.find "fp16_isIntegral_def"
  fun op fp16_isZero_def _ = ()
  val op fp16_isZero_def = TDB.find "fp16_isZero_def"
  fun op fp16_isNormal_def _ = ()
  val op fp16_isNormal_def = TDB.find "fp16_isNormal_def"
  fun op fp16_isSubnormal_def _ = ()
  val op fp16_isSubnormal_def = TDB.find "fp16_isSubnormal_def"
  fun op fp16_isFinite_def _ = ()
  val op fp16_isFinite_def = TDB.find "fp16_isFinite_def"
  fun op fp16_isInfinite_def _ = ()
  val op fp16_isInfinite_def = TDB.find "fp16_isInfinite_def"
  fun op fp16_posInf_def _ = ()
  val op fp16_posInf_def = TDB.find "fp16_posInf_def"
  fun op fp16_negInf_def _ = ()
  val op fp16_negInf_def = TDB.find "fp16_negInf_def"
  fun op fp16_posZero_def _ = ()
  val op fp16_posZero_def = TDB.find "fp16_posZero_def"
  fun op fp16_negZero_def _ = ()
  val op fp16_negZero_def = TDB.find "fp16_negZero_def"
  fun op fp16_posMin_def _ = ()
  val op fp16_posMin_def = TDB.find "fp16_posMin_def"
  fun op fp16_negMin_def _ = ()
  val op fp16_negMin_def = TDB.find "fp16_negMin_def"
  fun op fp16_top_def _ = () val op fp16_top_def = TDB.find "fp16_top_def"
  fun op fp16_bottom_def _ = ()
  val op fp16_bottom_def = TDB.find "fp16_bottom_def"
  fun op fp16_add_def _ = () val op fp16_add_def = TDB.find "fp16_add_def"
  fun op fp16_sub_def _ = () val op fp16_sub_def = TDB.find "fp16_sub_def"
  fun op fp16_mul_def _ = () val op fp16_mul_def = TDB.find "fp16_mul_def"
  fun op fp16_div_def _ = () val op fp16_div_def = TDB.find "fp16_div_def"
  fun op fp16_add_with_flags_def _ = ()
  val op fp16_add_with_flags_def = TDB.find "fp16_add_with_flags_def"
  fun op fp16_sub_with_flags_def _ = ()
  val op fp16_sub_with_flags_def = TDB.find "fp16_sub_with_flags_def"
  fun op fp16_mul_with_flags_def _ = ()
  val op fp16_mul_with_flags_def = TDB.find "fp16_mul_with_flags_def"
  fun op fp16_div_with_flags_def _ = ()
  val op fp16_div_with_flags_def = TDB.find "fp16_div_with_flags_def"
  fun op fp16_compare_def _ = ()
  val op fp16_compare_def = TDB.find "fp16_compare_def"
  fun op fp16_equal_def _ = ()
  val op fp16_equal_def = TDB.find "fp16_equal_def"
  fun op fp16_lessThan_def _ = ()
  val op fp16_lessThan_def = TDB.find "fp16_lessThan_def"
  fun op fp16_lessEqual_def _ = ()
  val op fp16_lessEqual_def = TDB.find "fp16_lessEqual_def"
  fun op fp16_greaterThan_def _ = ()
  val op fp16_greaterThan_def = TDB.find "fp16_greaterThan_def"
  fun op fp16_greaterEqual_def _ = ()
  val op fp16_greaterEqual_def = TDB.find "fp16_greaterEqual_def"
  fun op fp16_mul_add_def _ = ()
  val op fp16_mul_add_def = TDB.find "fp16_mul_add_def"
  fun op fp16_mul_sub_def _ = ()
  val op fp16_mul_sub_def = TDB.find "fp16_mul_sub_def"
  fun op fp16_mul_add_with_flags_def _ = ()
  val op fp16_mul_add_with_flags_def = TDB.find
    "fp16_mul_add_with_flags_def"
  fun op fp16_mul_sub_with_flags_def _ = ()
  val op fp16_mul_sub_with_flags_def = TDB.find
    "fp16_mul_sub_with_flags_def"
  fun op fp32_to_float_def _ = ()
  val op fp32_to_float_def = TDB.find "fp32_to_float_def"
  fun op float_to_fp32_def _ = ()
  val op float_to_fp32_def = TDB.find "float_to_fp32_def"
  fun op fp32_to_real_def _ = ()
  val op fp32_to_real_def = TDB.find "fp32_to_real_def"
  fun op fp32_to_value_def _ = ()
  val op fp32_to_value_def = TDB.find "fp32_to_value_def"
  fun op real_to_fp32_def _ = ()
  val op real_to_fp32_def = TDB.find "real_to_fp32_def"
  fun op real_to_fp32_with_flags_def _ = ()
  val op real_to_fp32_with_flags_def = TDB.find
    "real_to_fp32_with_flags_def"
  fun op int_to_fp32_def _ = ()
  val op int_to_fp32_def = TDB.find "int_to_fp32_def"
  fun op fp32_roundToIntegral_def _ = ()
  val op fp32_roundToIntegral_def = TDB.find "fp32_roundToIntegral_def"
  fun op fp32_to_int_def _ = ()
  val op fp32_to_int_def = TDB.find "fp32_to_int_def"
  fun op fp32_sqrt_def _ = ()
  val op fp32_sqrt_def = TDB.find "fp32_sqrt_def"
  fun op fp32_sqrt_with_flags_def _ = ()
  val op fp32_sqrt_with_flags_def = TDB.find "fp32_sqrt_with_flags_def"
  fun op fp32_negate_def _ = ()
  val op fp32_negate_def = TDB.find "fp32_negate_def"
  fun op fp32_abs_def _ = () val op fp32_abs_def = TDB.find "fp32_abs_def"
  fun op fp32_isNan_def _ = ()
  val op fp32_isNan_def = TDB.find "fp32_isNan_def"
  fun op fp32_isSignallingNan_def _ = ()
  val op fp32_isSignallingNan_def = TDB.find "fp32_isSignallingNan_def"
  fun op fp32_isIntegral_def _ = ()
  val op fp32_isIntegral_def = TDB.find "fp32_isIntegral_def"
  fun op fp32_isZero_def _ = ()
  val op fp32_isZero_def = TDB.find "fp32_isZero_def"
  fun op fp32_isNormal_def _ = ()
  val op fp32_isNormal_def = TDB.find "fp32_isNormal_def"
  fun op fp32_isSubnormal_def _ = ()
  val op fp32_isSubnormal_def = TDB.find "fp32_isSubnormal_def"
  fun op fp32_isFinite_def _ = ()
  val op fp32_isFinite_def = TDB.find "fp32_isFinite_def"
  fun op fp32_isInfinite_def _ = ()
  val op fp32_isInfinite_def = TDB.find "fp32_isInfinite_def"
  fun op fp32_posInf_def _ = ()
  val op fp32_posInf_def = TDB.find "fp32_posInf_def"
  fun op fp32_negInf_def _ = ()
  val op fp32_negInf_def = TDB.find "fp32_negInf_def"
  fun op fp32_posZero_def _ = ()
  val op fp32_posZero_def = TDB.find "fp32_posZero_def"
  fun op fp32_negZero_def _ = ()
  val op fp32_negZero_def = TDB.find "fp32_negZero_def"
  fun op fp32_posMin_def _ = ()
  val op fp32_posMin_def = TDB.find "fp32_posMin_def"
  fun op fp32_negMin_def _ = ()
  val op fp32_negMin_def = TDB.find "fp32_negMin_def"
  fun op fp32_top_def _ = () val op fp32_top_def = TDB.find "fp32_top_def"
  fun op fp32_bottom_def _ = ()
  val op fp32_bottom_def = TDB.find "fp32_bottom_def"
  fun op fp32_add_def _ = () val op fp32_add_def = TDB.find "fp32_add_def"
  fun op fp32_sub_def _ = () val op fp32_sub_def = TDB.find "fp32_sub_def"
  fun op fp32_mul_def _ = () val op fp32_mul_def = TDB.find "fp32_mul_def"
  fun op fp32_div_def _ = () val op fp32_div_def = TDB.find "fp32_div_def"
  fun op fp32_add_with_flags_def _ = ()
  val op fp32_add_with_flags_def = TDB.find "fp32_add_with_flags_def"
  fun op fp32_sub_with_flags_def _ = ()
  val op fp32_sub_with_flags_def = TDB.find "fp32_sub_with_flags_def"
  fun op fp32_mul_with_flags_def _ = ()
  val op fp32_mul_with_flags_def = TDB.find "fp32_mul_with_flags_def"
  fun op fp32_div_with_flags_def _ = ()
  val op fp32_div_with_flags_def = TDB.find "fp32_div_with_flags_def"
  fun op fp32_compare_def _ = ()
  val op fp32_compare_def = TDB.find "fp32_compare_def"
  fun op fp32_equal_def _ = ()
  val op fp32_equal_def = TDB.find "fp32_equal_def"
  fun op fp32_lessThan_def _ = ()
  val op fp32_lessThan_def = TDB.find "fp32_lessThan_def"
  fun op fp32_lessEqual_def _ = ()
  val op fp32_lessEqual_def = TDB.find "fp32_lessEqual_def"
  fun op fp32_greaterThan_def _ = ()
  val op fp32_greaterThan_def = TDB.find "fp32_greaterThan_def"
  fun op fp32_greaterEqual_def _ = ()
  val op fp32_greaterEqual_def = TDB.find "fp32_greaterEqual_def"
  fun op fp32_mul_add_def _ = ()
  val op fp32_mul_add_def = TDB.find "fp32_mul_add_def"
  fun op fp32_mul_sub_def _ = ()
  val op fp32_mul_sub_def = TDB.find "fp32_mul_sub_def"
  fun op fp32_mul_add_with_flags_def _ = ()
  val op fp32_mul_add_with_flags_def = TDB.find
    "fp32_mul_add_with_flags_def"
  fun op fp32_mul_sub_with_flags_def _ = ()
  val op fp32_mul_sub_with_flags_def = TDB.find
    "fp32_mul_sub_with_flags_def"
  fun op fp64_to_float_def _ = ()
  val op fp64_to_float_def = TDB.find "fp64_to_float_def"
  fun op float_to_fp64_def _ = ()
  val op float_to_fp64_def = TDB.find "float_to_fp64_def"
  fun op fp64_to_real_def _ = ()
  val op fp64_to_real_def = TDB.find "fp64_to_real_def"
  fun op fp64_to_value_def _ = ()
  val op fp64_to_value_def = TDB.find "fp64_to_value_def"
  fun op real_to_fp64_def _ = ()
  val op real_to_fp64_def = TDB.find "real_to_fp64_def"
  fun op real_to_fp64_with_flags_def _ = ()
  val op real_to_fp64_with_flags_def = TDB.find
    "real_to_fp64_with_flags_def"
  fun op int_to_fp64_def _ = ()
  val op int_to_fp64_def = TDB.find "int_to_fp64_def"
  fun op fp64_roundToIntegral_def _ = ()
  val op fp64_roundToIntegral_def = TDB.find "fp64_roundToIntegral_def"
  fun op fp64_to_int_def _ = ()
  val op fp64_to_int_def = TDB.find "fp64_to_int_def"
  fun op fp64_sqrt_def _ = ()
  val op fp64_sqrt_def = TDB.find "fp64_sqrt_def"
  fun op fp64_sqrt_with_flags_def _ = ()
  val op fp64_sqrt_with_flags_def = TDB.find "fp64_sqrt_with_flags_def"
  fun op fp64_negate_def _ = ()
  val op fp64_negate_def = TDB.find "fp64_negate_def"
  fun op fp64_abs_def _ = () val op fp64_abs_def = TDB.find "fp64_abs_def"
  fun op fp64_isNan_def _ = ()
  val op fp64_isNan_def = TDB.find "fp64_isNan_def"
  fun op fp64_isSignallingNan_def _ = ()
  val op fp64_isSignallingNan_def = TDB.find "fp64_isSignallingNan_def"
  fun op fp64_isIntegral_def _ = ()
  val op fp64_isIntegral_def = TDB.find "fp64_isIntegral_def"
  fun op fp64_isZero_def _ = ()
  val op fp64_isZero_def = TDB.find "fp64_isZero_def"
  fun op fp64_isNormal_def _ = ()
  val op fp64_isNormal_def = TDB.find "fp64_isNormal_def"
  fun op fp64_isSubnormal_def _ = ()
  val op fp64_isSubnormal_def = TDB.find "fp64_isSubnormal_def"
  fun op fp64_isFinite_def _ = ()
  val op fp64_isFinite_def = TDB.find "fp64_isFinite_def"
  fun op fp64_isInfinite_def _ = ()
  val op fp64_isInfinite_def = TDB.find "fp64_isInfinite_def"
  fun op fp64_posInf_def _ = ()
  val op fp64_posInf_def = TDB.find "fp64_posInf_def"
  fun op fp64_negInf_def _ = ()
  val op fp64_negInf_def = TDB.find "fp64_negInf_def"
  fun op fp64_posZero_def _ = ()
  val op fp64_posZero_def = TDB.find "fp64_posZero_def"
  fun op fp64_negZero_def _ = ()
  val op fp64_negZero_def = TDB.find "fp64_negZero_def"
  fun op fp64_posMin_def _ = ()
  val op fp64_posMin_def = TDB.find "fp64_posMin_def"
  fun op fp64_negMin_def _ = ()
  val op fp64_negMin_def = TDB.find "fp64_negMin_def"
  fun op fp64_top_def _ = () val op fp64_top_def = TDB.find "fp64_top_def"
  fun op fp64_bottom_def _ = ()
  val op fp64_bottom_def = TDB.find "fp64_bottom_def"
  fun op fp64_add_def _ = () val op fp64_add_def = TDB.find "fp64_add_def"
  fun op fp64_sub_def _ = () val op fp64_sub_def = TDB.find "fp64_sub_def"
  fun op fp64_mul_def _ = () val op fp64_mul_def = TDB.find "fp64_mul_def"
  fun op fp64_div_def _ = () val op fp64_div_def = TDB.find "fp64_div_def"
  fun op fp64_add_with_flags_def _ = ()
  val op fp64_add_with_flags_def = TDB.find "fp64_add_with_flags_def"
  fun op fp64_sub_with_flags_def _ = ()
  val op fp64_sub_with_flags_def = TDB.find "fp64_sub_with_flags_def"
  fun op fp64_mul_with_flags_def _ = ()
  val op fp64_mul_with_flags_def = TDB.find "fp64_mul_with_flags_def"
  fun op fp64_div_with_flags_def _ = ()
  val op fp64_div_with_flags_def = TDB.find "fp64_div_with_flags_def"
  fun op fp64_compare_def _ = ()
  val op fp64_compare_def = TDB.find "fp64_compare_def"
  fun op fp64_equal_def _ = ()
  val op fp64_equal_def = TDB.find "fp64_equal_def"
  fun op fp64_lessThan_def _ = ()
  val op fp64_lessThan_def = TDB.find "fp64_lessThan_def"
  fun op fp64_lessEqual_def _ = ()
  val op fp64_lessEqual_def = TDB.find "fp64_lessEqual_def"
  fun op fp64_greaterThan_def _ = ()
  val op fp64_greaterThan_def = TDB.find "fp64_greaterThan_def"
  fun op fp64_greaterEqual_def _ = ()
  val op fp64_greaterEqual_def = TDB.find "fp64_greaterEqual_def"
  fun op fp64_mul_add_def _ = ()
  val op fp64_mul_add_def = TDB.find "fp64_mul_add_def"
  fun op fp64_mul_sub_def _ = ()
  val op fp64_mul_sub_def = TDB.find "fp64_mul_sub_def"
  fun op fp64_mul_add_with_flags_def _ = ()
  val op fp64_mul_add_with_flags_def = TDB.find
    "fp64_mul_add_with_flags_def"
  fun op fp64_mul_sub_with_flags_def _ = ()
  val op fp64_mul_sub_with_flags_def = TDB.find
    "fp64_mul_sub_with_flags_def"
  fun op convert_def _ = () val op convert_def = TDB.find "convert_def"
  fun op fp16_to_fp32_with_flags_def _ = ()
  val op fp16_to_fp32_with_flags_def = TDB.find
    "fp16_to_fp32_with_flags_def"
  fun op fp16_to_fp64_with_flags_def _ = ()
  val op fp16_to_fp64_with_flags_def = TDB.find
    "fp16_to_fp64_with_flags_def"
  fun op fp32_to_fp64_with_flags_def _ = ()
  val op fp32_to_fp64_with_flags_def = TDB.find
    "fp32_to_fp64_with_flags_def"
  fun op fp64_to_fp32_with_flags_def _ = ()
  val op fp64_to_fp32_with_flags_def = TDB.find
    "fp64_to_fp32_with_flags_def"
  fun op fp64_to_fp16_with_flags_def _ = ()
  val op fp64_to_fp16_with_flags_def = TDB.find
    "fp64_to_fp16_with_flags_def"
  fun op fp32_to_fp16_with_flags_def _ = ()
  val op fp32_to_fp16_with_flags_def = TDB.find
    "fp32_to_fp16_with_flags_def"
  fun op fp16_to_fp32_def _ = ()
  val op fp16_to_fp32_def = TDB.find "fp16_to_fp32_def"
  fun op fp16_to_fp64_def _ = ()
  val op fp16_to_fp64_def = TDB.find "fp16_to_fp64_def"
  fun op fp32_to_fp64_def _ = ()
  val op fp32_to_fp64_def = TDB.find "fp32_to_fp64_def"
  fun op fp64_to_fp32_def _ = ()
  val op fp64_to_fp32_def = TDB.find "fp64_to_fp32_def"
  fun op fp64_to_fp16_def _ = ()
  val op fp64_to_fp16_def = TDB.find "fp64_to_fp16_def"
  fun op fp32_to_fp16_def _ = ()
  val op fp32_to_fp16_def = TDB.find "fp32_to_fp16_def"
  fun op fp16_to_float_11 _ = ()
  val op fp16_to_float_11 = TDB.find "fp16_to_float_11"
  fun op float_to_fp16_11 _ = ()
  val op float_to_fp16_11 = TDB.find "float_to_fp16_11"
  fun op float_to_fp16_fp16_to_float _ = ()
  val op float_to_fp16_fp16_to_float = TDB.find
    "float_to_fp16_fp16_to_float"
  fun op fp16_to_float_float_to_fp16 _ = ()
  val op fp16_to_float_float_to_fp16 = TDB.find
    "fp16_to_float_float_to_fp16"
  fun op fp16_nchotomy _ = ()
  val op fp16_nchotomy = TDB.find "fp16_nchotomy"
  fun op float_fp16_nchotomy _ = ()
  val op float_fp16_nchotomy = TDB.find "float_fp16_nchotomy"
  fun op fp16_to_float_n2w _ = ()
  val op fp16_to_float_n2w = TDB.find "fp16_to_float_n2w"
  fun op fp16_sqrt _ = () val op fp16_sqrt = TDB.find "fp16_sqrt"
  fun op fp16_add _ = () val op fp16_add = TDB.find "fp16_add"
  fun op fp16_sub _ = () val op fp16_sub = TDB.find "fp16_sub"
  fun op fp16_mul _ = () val op fp16_mul = TDB.find "fp16_mul"
  fun op fp16_div _ = () val op fp16_div = TDB.find "fp16_div"
  fun op fp16_compare _ = () val op fp16_compare = TDB.find "fp16_compare"
  fun op fp16_equal _ = () val op fp16_equal = TDB.find "fp16_equal"
  fun op fp16_lessThan _ = ()
  val op fp16_lessThan = TDB.find "fp16_lessThan"
  fun op fp16_lessEqual _ = ()
  val op fp16_lessEqual = TDB.find "fp16_lessEqual"
  fun op fp16_greaterThan _ = ()
  val op fp16_greaterThan = TDB.find "fp16_greaterThan"
  fun op fp16_greaterEqual _ = ()
  val op fp16_greaterEqual = TDB.find "fp16_greaterEqual"
  fun op fp16_to_real _ = () val op fp16_to_real = TDB.find "fp16_to_real"
  fun op fp16_to_value _ = ()
  val op fp16_to_value = TDB.find "fp16_to_value"
  fun op fp16_to_int _ = () val op fp16_to_int = TDB.find "fp16_to_int"
  fun op fp16_abs _ = () val op fp16_abs = TDB.find "fp16_abs"
  fun op fp16_negate _ = () val op fp16_negate = TDB.find "fp16_negate"
  fun op fp16_isNan _ = () val op fp16_isNan = TDB.find "fp16_isNan"
  fun op fp16_isSignallingNan _ = ()
  val op fp16_isSignallingNan = TDB.find "fp16_isSignallingNan"
  fun op fp16_isIntegral _ = ()
  val op fp16_isIntegral = TDB.find "fp16_isIntegral"
  fun op fp16_isZero _ = () val op fp16_isZero = TDB.find "fp16_isZero"
  fun op fp16_isNormal _ = ()
  val op fp16_isNormal = TDB.find "fp16_isNormal"
  fun op fp16_isSubnormal _ = ()
  val op fp16_isSubnormal = TDB.find "fp16_isSubnormal"
  fun op fp16_isFinite _ = ()
  val op fp16_isFinite = TDB.find "fp16_isFinite"
  fun op fp16_isInfinite _ = ()
  val op fp16_isInfinite = TDB.find "fp16_isInfinite"
  fun op fp16_roundToIntegral _ = ()
  val op fp16_roundToIntegral = TDB.find "fp16_roundToIntegral"
  fun op fp16_sqrt_with_flags _ = ()
  val op fp16_sqrt_with_flags = TDB.find "fp16_sqrt_with_flags"
  fun op fp16_add_with_flags _ = ()
  val op fp16_add_with_flags = TDB.find "fp16_add_with_flags"
  fun op fp16_sub_with_flags _ = ()
  val op fp16_sub_with_flags = TDB.find "fp16_sub_with_flags"
  fun op fp16_mul_with_flags _ = ()
  val op fp16_mul_with_flags = TDB.find "fp16_mul_with_flags"
  fun op fp16_div_with_flags _ = ()
  val op fp16_div_with_flags = TDB.find "fp16_div_with_flags"
  fun op fp16_mul_add _ = () val op fp16_mul_add = TDB.find "fp16_mul_add"
  fun op fp16_mul_sub _ = () val op fp16_mul_sub = TDB.find "fp16_mul_sub"
  fun op fp16_mul_add_with_flags _ = ()
  val op fp16_mul_add_with_flags = TDB.find "fp16_mul_add_with_flags"
  fun op fp16_mul_sub_with_flags _ = ()
  val op fp16_mul_sub_with_flags = TDB.find "fp16_mul_sub_with_flags"
  fun op fp32_to_float_11 _ = ()
  val op fp32_to_float_11 = TDB.find "fp32_to_float_11"
  fun op float_to_fp32_11 _ = ()
  val op float_to_fp32_11 = TDB.find "float_to_fp32_11"
  fun op float_to_fp32_fp32_to_float _ = ()
  val op float_to_fp32_fp32_to_float = TDB.find
    "float_to_fp32_fp32_to_float"
  fun op fp32_to_float_float_to_fp32 _ = ()
  val op fp32_to_float_float_to_fp32 = TDB.find
    "fp32_to_float_float_to_fp32"
  fun op fp32_nchotomy _ = ()
  val op fp32_nchotomy = TDB.find "fp32_nchotomy"
  fun op float_fp32_nchotomy _ = ()
  val op float_fp32_nchotomy = TDB.find "float_fp32_nchotomy"
  fun op fp32_to_float_n2w _ = ()
  val op fp32_to_float_n2w = TDB.find "fp32_to_float_n2w"
  fun op fp32_sqrt _ = () val op fp32_sqrt = TDB.find "fp32_sqrt"
  fun op fp32_add _ = () val op fp32_add = TDB.find "fp32_add"
  fun op fp32_sub _ = () val op fp32_sub = TDB.find "fp32_sub"
  fun op fp32_mul _ = () val op fp32_mul = TDB.find "fp32_mul"
  fun op fp32_div _ = () val op fp32_div = TDB.find "fp32_div"
  fun op fp32_compare _ = () val op fp32_compare = TDB.find "fp32_compare"
  fun op fp32_equal _ = () val op fp32_equal = TDB.find "fp32_equal"
  fun op fp32_lessThan _ = ()
  val op fp32_lessThan = TDB.find "fp32_lessThan"
  fun op fp32_lessEqual _ = ()
  val op fp32_lessEqual = TDB.find "fp32_lessEqual"
  fun op fp32_greaterThan _ = ()
  val op fp32_greaterThan = TDB.find "fp32_greaterThan"
  fun op fp32_greaterEqual _ = ()
  val op fp32_greaterEqual = TDB.find "fp32_greaterEqual"
  fun op fp32_to_real _ = () val op fp32_to_real = TDB.find "fp32_to_real"
  fun op fp32_to_value _ = ()
  val op fp32_to_value = TDB.find "fp32_to_value"
  fun op fp32_to_int _ = () val op fp32_to_int = TDB.find "fp32_to_int"
  fun op fp32_abs _ = () val op fp32_abs = TDB.find "fp32_abs"
  fun op fp32_negate _ = () val op fp32_negate = TDB.find "fp32_negate"
  fun op fp32_isNan _ = () val op fp32_isNan = TDB.find "fp32_isNan"
  fun op fp32_isSignallingNan _ = ()
  val op fp32_isSignallingNan = TDB.find "fp32_isSignallingNan"
  fun op fp32_isIntegral _ = ()
  val op fp32_isIntegral = TDB.find "fp32_isIntegral"
  fun op fp32_isZero _ = () val op fp32_isZero = TDB.find "fp32_isZero"
  fun op fp32_isNormal _ = ()
  val op fp32_isNormal = TDB.find "fp32_isNormal"
  fun op fp32_isSubnormal _ = ()
  val op fp32_isSubnormal = TDB.find "fp32_isSubnormal"
  fun op fp32_isFinite _ = ()
  val op fp32_isFinite = TDB.find "fp32_isFinite"
  fun op fp32_isInfinite _ = ()
  val op fp32_isInfinite = TDB.find "fp32_isInfinite"
  fun op fp32_roundToIntegral _ = ()
  val op fp32_roundToIntegral = TDB.find "fp32_roundToIntegral"
  fun op fp32_sqrt_with_flags _ = ()
  val op fp32_sqrt_with_flags = TDB.find "fp32_sqrt_with_flags"
  fun op fp32_add_with_flags _ = ()
  val op fp32_add_with_flags = TDB.find "fp32_add_with_flags"
  fun op fp32_sub_with_flags _ = ()
  val op fp32_sub_with_flags = TDB.find "fp32_sub_with_flags"
  fun op fp32_mul_with_flags _ = ()
  val op fp32_mul_with_flags = TDB.find "fp32_mul_with_flags"
  fun op fp32_div_with_flags _ = ()
  val op fp32_div_with_flags = TDB.find "fp32_div_with_flags"
  fun op fp32_mul_add _ = () val op fp32_mul_add = TDB.find "fp32_mul_add"
  fun op fp32_mul_sub _ = () val op fp32_mul_sub = TDB.find "fp32_mul_sub"
  fun op fp32_mul_add_with_flags _ = ()
  val op fp32_mul_add_with_flags = TDB.find "fp32_mul_add_with_flags"
  fun op fp32_mul_sub_with_flags _ = ()
  val op fp32_mul_sub_with_flags = TDB.find "fp32_mul_sub_with_flags"
  fun op fp64_to_float_11 _ = ()
  val op fp64_to_float_11 = TDB.find "fp64_to_float_11"
  fun op float_to_fp64_11 _ = ()
  val op float_to_fp64_11 = TDB.find "float_to_fp64_11"
  fun op float_to_fp64_fp64_to_float _ = ()
  val op float_to_fp64_fp64_to_float = TDB.find
    "float_to_fp64_fp64_to_float"
  fun op fp64_to_float_float_to_fp64 _ = ()
  val op fp64_to_float_float_to_fp64 = TDB.find
    "fp64_to_float_float_to_fp64"
  fun op fp64_nchotomy _ = ()
  val op fp64_nchotomy = TDB.find "fp64_nchotomy"
  fun op float_fp64_nchotomy _ = ()
  val op float_fp64_nchotomy = TDB.find "float_fp64_nchotomy"
  fun op fp64_to_float_n2w _ = ()
  val op fp64_to_float_n2w = TDB.find "fp64_to_float_n2w"
  fun op fp64_sqrt _ = () val op fp64_sqrt = TDB.find "fp64_sqrt"
  fun op fp64_add _ = () val op fp64_add = TDB.find "fp64_add"
  fun op fp64_sub _ = () val op fp64_sub = TDB.find "fp64_sub"
  fun op fp64_mul _ = () val op fp64_mul = TDB.find "fp64_mul"
  fun op fp64_div _ = () val op fp64_div = TDB.find "fp64_div"
  fun op fp64_compare _ = () val op fp64_compare = TDB.find "fp64_compare"
  fun op fp64_equal _ = () val op fp64_equal = TDB.find "fp64_equal"
  fun op fp64_lessThan _ = ()
  val op fp64_lessThan = TDB.find "fp64_lessThan"
  fun op fp64_lessEqual _ = ()
  val op fp64_lessEqual = TDB.find "fp64_lessEqual"
  fun op fp64_greaterThan _ = ()
  val op fp64_greaterThan = TDB.find "fp64_greaterThan"
  fun op fp64_greaterEqual _ = ()
  val op fp64_greaterEqual = TDB.find "fp64_greaterEqual"
  fun op fp64_to_real _ = () val op fp64_to_real = TDB.find "fp64_to_real"
  fun op fp64_to_value _ = ()
  val op fp64_to_value = TDB.find "fp64_to_value"
  fun op fp64_to_int _ = () val op fp64_to_int = TDB.find "fp64_to_int"
  fun op fp64_abs _ = () val op fp64_abs = TDB.find "fp64_abs"
  fun op fp64_negate _ = () val op fp64_negate = TDB.find "fp64_negate"
  fun op fp64_isNan _ = () val op fp64_isNan = TDB.find "fp64_isNan"
  fun op fp64_isSignallingNan _ = ()
  val op fp64_isSignallingNan = TDB.find "fp64_isSignallingNan"
  fun op fp64_isIntegral _ = ()
  val op fp64_isIntegral = TDB.find "fp64_isIntegral"
  fun op fp64_isZero _ = () val op fp64_isZero = TDB.find "fp64_isZero"
  fun op fp64_isNormal _ = ()
  val op fp64_isNormal = TDB.find "fp64_isNormal"
  fun op fp64_isSubnormal _ = ()
  val op fp64_isSubnormal = TDB.find "fp64_isSubnormal"
  fun op fp64_isFinite _ = ()
  val op fp64_isFinite = TDB.find "fp64_isFinite"
  fun op fp64_isInfinite _ = ()
  val op fp64_isInfinite = TDB.find "fp64_isInfinite"
  fun op fp64_roundToIntegral _ = ()
  val op fp64_roundToIntegral = TDB.find "fp64_roundToIntegral"
  fun op fp64_sqrt_with_flags _ = ()
  val op fp64_sqrt_with_flags = TDB.find "fp64_sqrt_with_flags"
  fun op fp64_add_with_flags _ = ()
  val op fp64_add_with_flags = TDB.find "fp64_add_with_flags"
  fun op fp64_sub_with_flags _ = ()
  val op fp64_sub_with_flags = TDB.find "fp64_sub_with_flags"
  fun op fp64_mul_with_flags _ = ()
  val op fp64_mul_with_flags = TDB.find "fp64_mul_with_flags"
  fun op fp64_div_with_flags _ = ()
  val op fp64_div_with_flags = TDB.find "fp64_div_with_flags"
  fun op fp64_mul_add _ = () val op fp64_mul_add = TDB.find "fp64_mul_add"
  fun op fp64_mul_sub _ = () val op fp64_mul_sub = TDB.find "fp64_mul_sub"
  fun op fp64_mul_add_with_flags _ = ()
  val op fp64_mul_add_with_flags = TDB.find "fp64_mul_add_with_flags"
  fun op fp64_mul_sub_with_flags _ = ()
  val op fp64_mul_sub_with_flags = TDB.find "fp64_mul_sub_with_flags"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val machine_ieee_grammars = merge_grammars ["binary_ieee"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="machine_ieee"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val machine_ieee_grammars = 
    Portable.## (addtyUDs,addtmUDs) machine_ieee_grammars
  val _ = Parse.grammarDB_insert("machine_ieee",machine_ieee_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val native_eval = ref false
  val () = Feedback.register_btrace ("native IEEE", native_eval)
  val sqrt_CONV = ref Conv.NO_CONV
  val add_CONV = ref Conv.NO_CONV
  val sub_CONV = ref Conv.NO_CONV
  val mul_CONV = ref Conv.NO_CONV
  val div_CONV = ref Conv.NO_CONV
  val compare_CONV = ref Conv.NO_CONV
  val eq_CONV = ref Conv.NO_CONV
  val lt_CONV = ref Conv.NO_CONV
  val le_CONV = ref Conv.NO_CONV
  val gt_CONV = ref Conv.NO_CONV
  val ge_CONV = ref Conv.NO_CONV
  fun native cnv1 s =
    let
      val cnv2 =
        Conv.QCHANGED_CONV
          (Rewrite.PURE_REWRITE_CONV [DB.fetch "machine_ieee" ("fp64_" ^  s)])
    in
      fn tm => (if !native_eval then !cnv1 else cnv2) tm
    end
  fun mk s = Term.prim_mk_const {Name = "fp64_" ^ s, Thy = "machine_ieee"}
  val () = computeLib.add_convs
    [(mk "sqrt", 2, native sqrt_CONV "sqrt"),
     (mk "add", 3, native add_CONV "add"),
     (mk "sub", 3, native sub_CONV "sub"),
     (mk "mul", 3, native mul_CONV "mul"),
     (mk "div", 3, native div_CONV "div"),
     (mk "compare", 2, native compare_CONV "compare"),
     (mk "equal", 2, native eq_CONV "equal"),
     (mk "lessThan", 2, native lt_CONV "lessThan"),
     (mk "lessEqual", 2, native le_CONV "lessEqual"),
     (mk "greaterThan", 2, native gt_CONV "greaterThan"),
     (mk "greaterEqual", 2, native ge_CONV "greaterEqual")
    ]
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "machine_ieee"

end
