structure DeepSyntaxTheory :> DeepSyntaxTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading DeepSyntaxTheory ... "
    else ()
  
  open Type Term Thm
  local open int_arithTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "DeepSyntax"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/DeepSyntaxTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op deep_form_TY_DEF _ = ()
  val op deep_form_TY_DEF = TDB.find "deep_form_TY_DEF"
  fun op deep_form_case_def _ = ()
  val op deep_form_case_def = TDB.find "deep_form_case_def"
  fun op deep_form_size_def _ = ()
  val op deep_form_size_def = TDB.find "deep_form_size_def"
  fun op eval_form_def _ = ()
  val op eval_form_def = TDB.find "eval_form_def"
  fun op neginf_def _ = () val op neginf_def = TDB.find "neginf_def"
  fun op posinf_def _ = () val op posinf_def = TDB.find "posinf_def"
  fun op alldivide_def _ = ()
  val op alldivide_def = TDB.find "alldivide_def"
  fun op Aset_def _ = () val op Aset_def = TDB.find "Aset_def"
  fun op Bset_def _ = () val op Bset_def = TDB.find "Bset_def"
  fun op datatype_deep_form _ = ()
  val op datatype_deep_form = TDB.find "datatype_deep_form"
  fun op deep_form_11 _ = () val op deep_form_11 = TDB.find "deep_form_11"
  fun op deep_form_distinct _ = ()
  val op deep_form_distinct = TDB.find "deep_form_distinct"
  fun op deep_form_nchotomy _ = ()
  val op deep_form_nchotomy = TDB.find "deep_form_nchotomy"
  fun op deep_form_Axiom _ = ()
  val op deep_form_Axiom = TDB.find "deep_form_Axiom"
  fun op deep_form_induction _ = ()
  val op deep_form_induction = TDB.find "deep_form_induction"
  fun op deep_form_case_cong _ = ()
  val op deep_form_case_cong = TDB.find "deep_form_case_cong"
  fun op deep_form_case_eq _ = ()
  val op deep_form_case_eq = TDB.find "deep_form_case_eq"
  fun op neginf_ok _ = () val op neginf_ok = TDB.find "neginf_ok"
  fun op posinf_ok _ = () val op posinf_ok = TDB.find "posinf_ok"
  fun op add_d_neginf _ = () val op add_d_neginf = TDB.find "add_d_neginf"
  fun op add_d_posinf _ = () val op add_d_posinf = TDB.find "add_d_posinf"
  fun op neginf_disj1_implies_exoriginal _ = ()
  val op neginf_disj1_implies_exoriginal = TDB.find
    "neginf_disj1_implies_exoriginal"
  fun op posinf_disj1_implies_exoriginal _ = ()
  val op posinf_disj1_implies_exoriginal = TDB.find
    "posinf_disj1_implies_exoriginal"
  fun op neginf_exoriginal_implies_rhs _ = ()
  val op neginf_exoriginal_implies_rhs = TDB.find
    "neginf_exoriginal_implies_rhs"
  fun op posinf_exoriginal_implies_rhs _ = ()
  val op posinf_exoriginal_implies_rhs = TDB.find
    "posinf_exoriginal_implies_rhs"
  fun op neginf_exoriginal_eq_rhs _ = ()
  val op neginf_exoriginal_eq_rhs = TDB.find "neginf_exoriginal_eq_rhs"
  fun op posinf_exoriginal_eq_rhs _ = ()
  val op posinf_exoriginal_eq_rhs = TDB.find "posinf_exoriginal_eq_rhs"
  fun op in_bset _ = () val op in_bset = TDB.find "in_bset"
  fun op in_aset _ = () val op in_aset = TDB.find "in_aset"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val DeepSyntax_grammars = merge_grammars ["int_arith"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="DeepSyntax"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val DeepSyntax_grammars = 
    Portable.## (addtyUDs,addtmUDs) DeepSyntax_grammars
  val _ = Parse.grammarDB_insert("DeepSyntax",DeepSyntax_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "DeepSyntax"

end
