structure OmegaTheory :> OmegaTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading OmegaTheory ... "
    else ()
  
  open Type Term Thm
  local open integerTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "Omega"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/OmegaTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op modhat_def _ = () val op modhat_def = TDB.find "modhat_def"
  fun op fst_nzero_def _ = ()
  val op fst_nzero_def = TDB.find "fst_nzero_def"
  fun op fst1_def _ = () val op fst1_def = TDB.find "fst1_def"
  fun op real_shadow_def _ = ()
  val op real_shadow_def = TDB.find "real_shadow_def"
  fun op MAP2_ind _ = () val op MAP2_ind = TDB.find "MAP2_ind"
  fun op MAP2_def _ = () val op MAP2_def = TDB.find "MAP2_def"
  fun op MAP2_zero_ADD _ = ()
  val op MAP2_zero_ADD = TDB.find "MAP2_zero_ADD"
  fun op sumc_ind _ = () val op sumc_ind = TDB.find "sumc_ind"
  fun op sumc_def _ = () val op sumc_def = TDB.find "sumc_def"
  fun op sumc_thm _ = () val op sumc_thm = TDB.find "sumc_thm"
  fun op sumc_ADD _ = () val op sumc_ADD = TDB.find "sumc_ADD"
  fun op sumc_MULT _ = () val op sumc_MULT = TDB.find "sumc_MULT"
  fun op sumc_singleton _ = ()
  val op sumc_singleton = TDB.find "sumc_singleton"
  fun op sumc_nonsingle _ = ()
  val op sumc_nonsingle = TDB.find "sumc_nonsingle"
  fun op equality_removal _ = ()
  val op equality_removal = TDB.find "equality_removal"
  fun op evalupper_ind _ = ()
  val op evalupper_ind = TDB.find "evalupper_ind"
  fun op evalupper_def _ = ()
  val op evalupper_def = TDB.find "evalupper_def"
  fun op evallower_ind _ = ()
  val op evallower_ind = TDB.find "evallower_ind"
  fun op evallower_def _ = ()
  val op evallower_def = TDB.find "evallower_def"
  fun op smaller_satisfies_uppers _ = ()
  val op smaller_satisfies_uppers = TDB.find "smaller_satisfies_uppers"
  fun op bigger_satisfies_lowers _ = ()
  val op bigger_satisfies_lowers = TDB.find "bigger_satisfies_lowers"
  fun op onlylowers_satisfiable _ = ()
  val op onlylowers_satisfiable = TDB.find "onlylowers_satisfiable"
  fun op onlyuppers_satisfiable _ = ()
  val op onlyuppers_satisfiable = TDB.find "onlyuppers_satisfiable"
  fun op rshadow_row_ind _ = ()
  val op rshadow_row_ind = TDB.find "rshadow_row_ind"
  fun op rshadow_row_def _ = ()
  val op rshadow_row_def = TDB.find "rshadow_row_def"
  fun op singleton_real_shadow _ = ()
  val op singleton_real_shadow = TDB.find "singleton_real_shadow"
  fun op real_shadow_revimp_uppers1 _ = ()
  val op real_shadow_revimp_uppers1 = TDB.find "real_shadow_revimp_uppers1"
  fun op real_shadow_revimp_lowers1 _ = ()
  val op real_shadow_revimp_lowers1 = TDB.find "real_shadow_revimp_lowers1"
  fun op real_shadow_always_implied _ = ()
  val op real_shadow_always_implied = TDB.find "real_shadow_always_implied"
  fun op exact_shadow_case _ = ()
  val op exact_shadow_case = TDB.find "exact_shadow_case"
  fun op dark_shadow_cond_row_ind _ = ()
  val op dark_shadow_cond_row_ind = TDB.find "dark_shadow_cond_row_ind"
  fun op dark_shadow_cond_row_def _ = ()
  val op dark_shadow_cond_row_def = TDB.find "dark_shadow_cond_row_def"
  fun op dark_shadow_condition_ind _ = ()
  val op dark_shadow_condition_ind = TDB.find "dark_shadow_condition_ind"
  fun op dark_shadow_condition_def _ = ()
  val op dark_shadow_condition_def = TDB.find "dark_shadow_condition_def"
  fun op basic_shadow_equivalence _ = ()
  val op basic_shadow_equivalence = TDB.find "basic_shadow_equivalence"
  fun op dark_shadow_row_ind _ = ()
  val op dark_shadow_row_ind = TDB.find "dark_shadow_row_ind"
  fun op dark_shadow_row_def _ = ()
  val op dark_shadow_row_def = TDB.find "dark_shadow_row_def"
  fun op dark_shadow_ind _ = ()
  val op dark_shadow_ind = TDB.find "dark_shadow_ind"
  fun op dark_shadow_def _ = ()
  val op dark_shadow_def = TDB.find "dark_shadow_def"
  fun op nightmare_ind _ = ()
  val op nightmare_ind = TDB.find "nightmare_ind"
  fun op nightmare_def _ = ()
  val op nightmare_def = TDB.find "nightmare_def"
  fun op nightmare_implies_LHS _ = ()
  val op nightmare_implies_LHS = TDB.find "nightmare_implies_LHS"
  fun op dark_shadow_FORALL _ = ()
  val op dark_shadow_FORALL = TDB.find "dark_shadow_FORALL"
  fun op real_shadow_FORALL _ = ()
  val op real_shadow_FORALL = TDB.find "real_shadow_FORALL"
  fun op evalupper_FORALL _ = ()
  val op evalupper_FORALL = TDB.find "evalupper_FORALL"
  fun op evallower_FORALL _ = ()
  val op evallower_FORALL = TDB.find "evallower_FORALL"
  fun op nightmare_EXISTS _ = ()
  val op nightmare_EXISTS = TDB.find "nightmare_EXISTS"
  fun op final_equivalence _ = ()
  val op final_equivalence = TDB.find "final_equivalence"
  fun op darkrow_implies_realrow _ = ()
  val op darkrow_implies_realrow = TDB.find "darkrow_implies_realrow"
  fun op dark_implies_real _ = ()
  val op dark_implies_real = TDB.find "dark_implies_real"
  fun op alternative_equivalence _ = ()
  val op alternative_equivalence = TDB.find "alternative_equivalence"
  fun op eval_base _ = () val op eval_base = TDB.find "eval_base"
  fun op eval_step_upper1 _ = ()
  val op eval_step_upper1 = TDB.find "eval_step_upper1"
  fun op eval_step_upper2 _ = ()
  val op eval_step_upper2 = TDB.find "eval_step_upper2"
  fun op eval_step_lower1 _ = ()
  val op eval_step_lower1 = TDB.find "eval_step_lower1"
  fun op eval_step_lower2 _ = ()
  val op eval_step_lower2 = TDB.find "eval_step_lower2"
  fun op eval_step_extra1 _ = ()
  val op eval_step_extra1 = TDB.find "eval_step_extra1"
  fun op eval_step_extra2 _ = ()
  val op eval_step_extra2 = TDB.find "eval_step_extra2"
  fun op eval_step_extra3 _ = ()
  val op eval_step_extra3 = TDB.find "eval_step_extra3"
  fun op eval_step_extra4 _ = ()
  val op eval_step_extra4 = TDB.find "eval_step_extra4"
  fun op calc_nightmare_ind _ = ()
  val op calc_nightmare_ind = TDB.find "calc_nightmare_ind"
  fun op calc_nightmare_def _ = ()
  val op calc_nightmare_def = TDB.find "calc_nightmare_def"
  fun op calculational_nightmare _ = ()
  val op calculational_nightmare = TDB.find "calculational_nightmare"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val Omega_grammars = merge_grammars ["integer"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="Omega"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val Omega_grammars = 
    Portable.## (addtyUDs,addtmUDs) Omega_grammars
  val _ = Parse.grammarDB_insert("Omega",Omega_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "Omega"

end
