structure int_arithTheory :> int_arithTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading int_arithTheory ... "
    else ()
  
  open Type Term Thm
  local open gcdTheory integerTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "int_arith"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/int_arithTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op bmarker_def _ = () val op bmarker_def = TDB.find "bmarker_def"
  fun op not_less _ = () val op not_less = TDB.find "not_less"
  fun op elim_eq _ = () val op elim_eq = TDB.find "elim_eq"
  fun op less_to_leq_samel _ = ()
  val op less_to_leq_samel = TDB.find "less_to_leq_samel"
  fun op less_to_leq_samer _ = ()
  val op less_to_leq_samer = TDB.find "less_to_leq_samer"
  fun op lt_move_all_right _ = ()
  val op lt_move_all_right = TDB.find "lt_move_all_right"
  fun op lt_move_all_left _ = ()
  val op lt_move_all_left = TDB.find "lt_move_all_left"
  fun op lt_move_left_left _ = ()
  val op lt_move_left_left = TDB.find "lt_move_left_left"
  fun op lt_move_left_right _ = ()
  val op lt_move_left_right = TDB.find "lt_move_left_right"
  fun op le_move_right_left _ = ()
  val op le_move_right_left = TDB.find "le_move_right_left"
  fun op le_move_all_right _ = ()
  val op le_move_all_right = TDB.find "le_move_all_right"
  fun op eq_move_all_right _ = ()
  val op eq_move_all_right = TDB.find "eq_move_all_right"
  fun op eq_move_all_left _ = ()
  val op eq_move_all_left = TDB.find "eq_move_all_left"
  fun op eq_move_left_left _ = ()
  val op eq_move_left_left = TDB.find "eq_move_left_left"
  fun op eq_move_left_right _ = ()
  val op eq_move_left_right = TDB.find "eq_move_left_right"
  fun op eq_move_right_left _ = ()
  val op eq_move_right_left = TDB.find "eq_move_right_left"
  fun op lcm_eliminate _ = ()
  val op lcm_eliminate = TDB.find "lcm_eliminate"
  fun op lt_justify_multiplication _ = ()
  val op lt_justify_multiplication = TDB.find "lt_justify_multiplication"
  fun op eq_justify_multiplication _ = ()
  val op eq_justify_multiplication = TDB.find "eq_justify_multiplication"
  fun op justify_divides _ = ()
  val op justify_divides = TDB.find "justify_divides"
  fun op justify_divides2 _ = ()
  val op justify_divides2 = TDB.find "justify_divides2"
  fun op justify_divides3 _ = ()
  val op justify_divides3 = TDB.find "justify_divides3"
  fun op INT_SUB_SUB3 _ = () val op INT_SUB_SUB3 = TDB.find "INT_SUB_SUB3"
  fun op move_sub _ = () val op move_sub = TDB.find "move_sub"
  fun op can_get_small _ = ()
  val op can_get_small = TDB.find "can_get_small"
  fun op can_get_big _ = () val op can_get_big = TDB.find "can_get_big"
  fun op positive_product_implication _ = ()
  val op positive_product_implication = TDB.find
    "positive_product_implication"
  fun op restricted_quantification_simp _ = ()
  val op restricted_quantification_simp = TDB.find
    "restricted_quantification_simp"
  fun op top_and_lessers _ = ()
  val op top_and_lessers = TDB.find "top_and_lessers"
  fun op bot_and_greaters _ = ()
  val op bot_and_greaters = TDB.find "bot_and_greaters"
  fun op in_additive_range _ = ()
  val op in_additive_range = TDB.find "in_additive_range"
  fun op in_subtractive_range _ = ()
  val op in_subtractive_range = TDB.find "in_subtractive_range"
  fun op subtract_to_small _ = ()
  val op subtract_to_small = TDB.find "subtract_to_small"
  fun op add_to_great _ = () val op add_to_great = TDB.find "add_to_great"
  fun op INT_LT_ADD_NUMERAL _ = ()
  val op INT_LT_ADD_NUMERAL = TDB.find "INT_LT_ADD_NUMERAL"
  fun op INT_NUM_FORALL _ = ()
  val op INT_NUM_FORALL = TDB.find "INT_NUM_FORALL"
  fun op INT_NUM_EXISTS _ = ()
  val op INT_NUM_EXISTS = TDB.find "INT_NUM_EXISTS"
  fun op INT_NUM_UEXISTS _ = ()
  val op INT_NUM_UEXISTS = TDB.find "INT_NUM_UEXISTS"
  fun op INT_NUM_SUB _ = () val op INT_NUM_SUB = TDB.find "INT_NUM_SUB"
  fun op INT_NUM_COND _ = () val op INT_NUM_COND = TDB.find "INT_NUM_COND"
  fun op INT_NUM_ODD _ = () val op INT_NUM_ODD = TDB.find "INT_NUM_ODD"
  fun op INT_NUM_EVEN _ = () val op INT_NUM_EVEN = TDB.find "INT_NUM_EVEN"
  fun op HO_SUB_ELIM _ = () val op HO_SUB_ELIM = TDB.find "HO_SUB_ELIM"
  fun op CONJ_EQ_ELIM _ = () val op CONJ_EQ_ELIM = TDB.find "CONJ_EQ_ELIM"
  fun op elim_neg_ones _ = ()
  val op elim_neg_ones = TDB.find "elim_neg_ones"
  fun op elim_minus_ones _ = ()
  val op elim_minus_ones = TDB.find "elim_minus_ones"
  fun op INT_NUM_DIVIDES _ = ()
  val op INT_NUM_DIVIDES = TDB.find "INT_NUM_DIVIDES"
  fun op INT_LINEAR_GCD _ = ()
  val op INT_LINEAR_GCD = TDB.find "INT_LINEAR_GCD"
  fun op INT_DIVIDES_LRMUL _ = ()
  val op INT_DIVIDES_LRMUL = TDB.find "INT_DIVIDES_LRMUL"
  fun op INT_DIVIDES_RELPRIME_MUL _ = ()
  val op INT_DIVIDES_RELPRIME_MUL = TDB.find "INT_DIVIDES_RELPRIME_MUL"
  fun op gcdthm2 _ = () val op gcdthm2 = TDB.find "gcdthm2"
  fun op gcd1thm _ = () val op gcd1thm = TDB.find "gcd1thm"
  fun op gcd21_thm _ = () val op gcd21_thm = TDB.find "gcd21_thm"
  fun op elim_lt_coeffs1 _ = ()
  val op elim_lt_coeffs1 = TDB.find "elim_lt_coeffs1"
  fun op elim_lt_coeffs2 _ = ()
  val op elim_lt_coeffs2 = TDB.find "elim_lt_coeffs2"
  fun op elim_le_coeffs _ = ()
  val op elim_le_coeffs = TDB.find "elim_le_coeffs"
  fun op elim_eq_coeffs _ = ()
  val op elim_eq_coeffs = TDB.find "elim_eq_coeffs"
  fun op cooper_lemma_1 _ = ()
  val op cooper_lemma_1 = TDB.find "cooper_lemma_1"
  fun op bmarker_rewrites _ = ()
  val op bmarker_rewrites = TDB.find "bmarker_rewrites"
  fun op NOT_INT_DIVIDES _ = ()
  val op NOT_INT_DIVIDES = TDB.find "NOT_INT_DIVIDES"
  fun op NOT_INT_DIVIDES_POS _ = ()
  val op NOT_INT_DIVIDES_POS = TDB.find "NOT_INT_DIVIDES_POS"
  fun op le_context_rwt1 _ = ()
  val op le_context_rwt1 = TDB.find "le_context_rwt1"
  fun op le_context_rwt2 _ = ()
  val op le_context_rwt2 = TDB.find "le_context_rwt2"
  fun op le_context_rwt3 _ = ()
  val op le_context_rwt3 = TDB.find "le_context_rwt3"
  fun op le_context_rwt4 _ = ()
  val op le_context_rwt4 = TDB.find "le_context_rwt4"
  fun op le_context_rwt5 _ = ()
  val op le_context_rwt5 = TDB.find "le_context_rwt5"
  fun op eq_context_rwt1 _ = ()
  val op eq_context_rwt1 = TDB.find "eq_context_rwt1"
  fun op eq_context_rwt2 _ = ()
  val op eq_context_rwt2 = TDB.find "eq_context_rwt2"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val int_arith_grammars = merge_grammars ["integer", "gcd"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="int_arith"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val int_arith_grammars = 
    Portable.## (addtyUDs,addtmUDs) int_arith_grammars
  val _ = Parse.grammarDB_insert("int_arith",int_arith_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "int_arith"

end
