structure int_bitwiseTheory :> int_bitwiseTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading int_bitwiseTheory ... "
    else ()
  
  open Type Term Thm
  local open OmegaTheory bitTheory int_arithTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "int_bitwise"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/int_bitwiseTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op int_not_def _ = () val op int_not_def = TDB.find "int_not_def"
  fun op int_bit_def _ = () val op int_bit_def = TDB.find "int_bit_def"
  fun op bits_of_num_primitive_def _ = ()
  val op bits_of_num_primitive_def = TDB.find "bits_of_num_primitive_def"
  fun op bits_of_int_def _ = ()
  val op bits_of_int_def = TDB.find "bits_of_int_def"
  fun op num_of_bits_primitive_def _ = ()
  val op num_of_bits_primitive_def = TDB.find "num_of_bits_primitive_def"
  fun op int_of_bits_def _ = ()
  val op int_of_bits_def = TDB.find "int_of_bits_def"
  fun op int_bitwise_def _ = ()
  val op int_bitwise_def = TDB.find "int_bitwise_def"
  fun op int_and_def _ = () val op int_and_def = TDB.find "int_and_def"
  fun op int_or_def _ = () val op int_or_def = TDB.find "int_or_def"
  fun op int_xor_def _ = () val op int_xor_def = TDB.find "int_xor_def"
  fun op int_shift_left_def _ = ()
  val op int_shift_left_def = TDB.find "int_shift_left_def"
  fun op int_shift_right_def _ = ()
  val op int_shift_right_def = TDB.find "int_shift_right_def"
  fun op int_not_not _ = () val op int_not_not = TDB.find "int_not_not"
  fun op int_bit_not _ = () val op int_bit_not = TDB.find "int_bit_not"
  fun op bits_of_num_ind _ = ()
  val op bits_of_num_ind = TDB.find "bits_of_num_ind"
  fun op bits_of_num_def _ = ()
  val op bits_of_num_def = TDB.find "bits_of_num_def"
  fun op num_of_bits_ind _ = ()
  val op num_of_bits_ind = TDB.find "num_of_bits_ind"
  fun op num_of_bits_def _ = ()
  val op num_of_bits_def = TDB.find "num_of_bits_def"
  fun op bits_bitwise_ind _ = ()
  val op bits_bitwise_ind = TDB.find "bits_bitwise_ind"
  fun op bits_bitwise_def _ = ()
  val op bits_bitwise_def = TDB.find "bits_bitwise_def"
  fun op int_not _ = () val op int_not = TDB.find "int_not"
  fun op int_bit_int_of_bits _ = ()
  val op int_bit_int_of_bits = TDB.find "int_bit_int_of_bits"
  fun op int_of_bits_bits_of_int _ = ()
  val op int_of_bits_bits_of_int = TDB.find "int_of_bits_bits_of_int"
  fun op int_bit_bitwise _ = ()
  val op int_bit_bitwise = TDB.find "int_bit_bitwise"
  fun op int_bit_and _ = () val op int_bit_and = TDB.find "int_bit_and"
  fun op int_bit_or _ = () val op int_bit_or = TDB.find "int_bit_or"
  fun op int_bit_xor _ = () val op int_bit_xor = TDB.find "int_bit_xor"
  fun op int_bit_equiv _ = ()
  val op int_bit_equiv = TDB.find "int_bit_equiv"
  fun op int_bit_shift_left _ = ()
  val op int_bit_shift_left = TDB.find "int_bit_shift_left"
  fun op int_bit_shift_right _ = ()
  val op int_bit_shift_right = TDB.find "int_bit_shift_right"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val int_bitwise_grammars = merge_grammars ["Omega", "int_arith", "bit"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="int_bitwise"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val int_bitwise_grammars = 
    Portable.## (addtyUDs,addtmUDs) int_bitwise_grammars
  val _ = Parse.grammarDB_insert("int_bitwise",int_bitwise_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "int_bitwise"

end
