structure integerRingTheory :> integerRingTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading integerRingTheory ... "
    else ()
  
  open Type Term Thm
  local open integerTheory ringNormTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "integerRing"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/integerRingTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op int_interp_p_def _ = ()
  val op int_interp_p_def = TDB.find "int_interp_p_def"
  fun op int_polynom_simplify_def _ = ()
  val op int_polynom_simplify_def = TDB.find "int_polynom_simplify_def"
  fun op int_polynom_normalize_def _ = ()
  val op int_polynom_normalize_def = TDB.find "int_polynom_normalize_def"
  fun op int_r_canonical_sum_merge_def _ = ()
  val op int_r_canonical_sum_merge_def = TDB.find
    "int_r_canonical_sum_merge_def"
  fun op int_r_monom_insert_def _ = ()
  val op int_r_monom_insert_def = TDB.find "int_r_monom_insert_def"
  fun op int_r_varlist_insert_def _ = ()
  val op int_r_varlist_insert_def = TDB.find "int_r_varlist_insert_def"
  fun op int_r_canonical_sum_scalar_def _ = ()
  val op int_r_canonical_sum_scalar_def = TDB.find
    "int_r_canonical_sum_scalar_def"
  fun op int_r_canonical_sum_scalar2_def _ = ()
  val op int_r_canonical_sum_scalar2_def = TDB.find
    "int_r_canonical_sum_scalar2_def"
  fun op int_r_canonical_sum_scalar3_def _ = ()
  val op int_r_canonical_sum_scalar3_def = TDB.find
    "int_r_canonical_sum_scalar3_def"
  fun op int_r_canonical_sum_prod_def _ = ()
  val op int_r_canonical_sum_prod_def = TDB.find
    "int_r_canonical_sum_prod_def"
  fun op int_r_canonical_sum_simplify_def _ = ()
  val op int_r_canonical_sum_simplify_def = TDB.find
    "int_r_canonical_sum_simplify_def"
  fun op int_r_ivl_aux_def _ = ()
  val op int_r_ivl_aux_def = TDB.find "int_r_ivl_aux_def"
  fun op int_r_interp_vl_def _ = ()
  val op int_r_interp_vl_def = TDB.find "int_r_interp_vl_def"
  fun op int_r_interp_m_def _ = ()
  val op int_r_interp_m_def = TDB.find "int_r_interp_m_def"
  fun op int_r_ics_aux_def _ = ()
  val op int_r_ics_aux_def = TDB.find "int_r_ics_aux_def"
  fun op int_r_interp_cs_def _ = ()
  val op int_r_interp_cs_def = TDB.find "int_r_interp_cs_def"
  fun op int_r_spolynom_normalize_def _ = ()
  val op int_r_spolynom_normalize_def = TDB.find
    "int_r_spolynom_normalize_def"
  fun op int_r_spolynom_simplify_def _ = ()
  val op int_r_spolynom_simplify_def = TDB.find
    "int_r_spolynom_simplify_def"
  fun op int_r_interp_sp_def _ = ()
  val op int_r_interp_sp_def = TDB.find "int_r_interp_sp_def"
  fun op int_is_ring _ = () val op int_is_ring = TDB.find "int_is_ring"
  fun op int_ring_thms _ = ()
  val op int_ring_thms = TDB.find "int_ring_thms"
  fun op int_calculate _ = ()
  val op int_calculate = TDB.find "int_calculate"
  fun op int_rewrites _ = () val op int_rewrites = TDB.find "int_rewrites"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val integerRing_grammars = merge_grammars ["integer", "ringNorm"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="integerRing"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val integerRing_grammars = 
    Portable.## (addtyUDs,addtmUDs) integerRing_grammars
  val _ = Parse.grammarDB_insert("integerRing",integerRing_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "integerRing"

end
