structure integerTheory :> integerTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading integerTheory ... "
    else ()
  
  open Type Term Thm
  local open dividesTheory quotient_listTheory quotient_optionTheory
  quotient_pairTheory quotient_sumTheory
  in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "integer"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/integerTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op int_ge _ = () val op int_ge = TDB.find "int_ge"
  fun op int_gt _ = () val op int_gt = TDB.find "int_gt"
  fun op int_le _ = () val op int_le = TDB.find "int_le"
  fun op int_sub _ = () val op int_sub = TDB.find "int_sub"
  fun op tint_0 _ = () val op tint_0 = TDB.find "tint_0"
  fun op tint_1 _ = () val op tint_1 = TDB.find "tint_1"
  fun op tint_neg _ = () val op tint_neg = TDB.find "tint_neg"
  fun op tint_add _ = () val op tint_add = TDB.find "tint_add"
  fun op tint_mul _ = () val op tint_mul = TDB.find "tint_mul"
  fun op tint_lt _ = () val op tint_lt = TDB.find "tint_lt"
  fun op tint_eq _ = () val op tint_eq = TDB.find "tint_eq"
  fun op tint_of_num _ = () val op tint_of_num = TDB.find "tint_of_num"
  fun op int_TY_DEF _ = () val op int_TY_DEF = TDB.find "int_TY_DEF"
  fun op int_bijections _ = ()
  val op int_bijections = TDB.find "int_bijections"
  fun op int_REP_def _ = () val op int_REP_def = TDB.find "int_REP_def"
  fun op int_ABS_def _ = () val op int_ABS_def = TDB.find "int_ABS_def"
  fun op int_0 _ = () val op int_0 = TDB.find "int_0"
  fun op int_1 _ = () val op int_1 = TDB.find "int_1"
  fun op int_neg _ = () val op int_neg = TDB.find "int_neg"
  fun op int_add _ = () val op int_add = TDB.find "int_add"
  fun op int_mul _ = () val op int_mul = TDB.find "int_mul"
  fun op int_lt _ = () val op int_lt = TDB.find "int_lt"
  fun op Num _ = () val op Num = TDB.find "Num"
  fun op int_div _ = () val op int_div = TDB.find "int_div"
  fun op int_mod _ = () val op int_mod = TDB.find "int_mod"
  fun op INT_ABS _ = () val op INT_ABS = TDB.find "INT_ABS"
  fun op int_quot _ = () val op int_quot = TDB.find "int_quot"
  fun op int_rem _ = () val op int_rem = TDB.find "int_rem"
  fun op INT_DIVIDES _ = () val op INT_DIVIDES = TDB.find "INT_DIVIDES"
  fun op int_exp _ = () val op int_exp = TDB.find "int_exp"
  fun op INT_MIN _ = () val op INT_MIN = TDB.find "INT_MIN"
  fun op INT_MAX _ = () val op INT_MAX = TDB.find "INT_MAX"
  fun op LEAST_INT_DEF _ = ()
  val op LEAST_INT_DEF = TDB.find "LEAST_INT_DEF"
  fun op INT_LT _ = () val op INT_LT = TDB.find "INT_LT"
  fun op INT_LE _ = () val op INT_LE = TDB.find "INT_LE"
  fun op INT_POS _ = () val op INT_POS = TDB.find "INT_POS"
  fun op INT _ = () val op INT = TDB.find "INT"
  fun op INT_EQ_RMUL _ = () val op INT_EQ_RMUL = TDB.find "INT_EQ_RMUL"
  fun op INT_EQ_LMUL _ = () val op INT_EQ_LMUL = TDB.find "INT_EQ_LMUL"
  fun op INT_ENTIRE _ = () val op INT_ENTIRE = TDB.find "INT_ENTIRE"
  fun op INT_LT_ADDL _ = () val op INT_LT_ADDL = TDB.find "INT_LT_ADDL"
  fun op INT_LT_ADDR _ = () val op INT_LT_ADDR = TDB.find "INT_LT_ADDR"
  fun op INT_LE_ADDL _ = () val op INT_LE_ADDL = TDB.find "INT_LE_ADDL"
  fun op INT_LE_ADDR _ = () val op INT_LE_ADDR = TDB.find "INT_LE_ADDR"
  fun op INT_LT_IMP_NE _ = ()
  val op INT_LT_IMP_NE = TDB.find "INT_LT_IMP_NE"
  fun op INT_NEG_MINUS1 _ = ()
  val op INT_NEG_MINUS1 = TDB.find "INT_NEG_MINUS1"
  fun op INT_NEG_EQ _ = () val op INT_NEG_EQ = TDB.find "INT_NEG_EQ"
  fun op INT_SUB_RDISTRIB _ = ()
  val op INT_SUB_RDISTRIB = TDB.find "INT_SUB_RDISTRIB"
  fun op INT_SUB_LDISTRIB _ = ()
  val op INT_SUB_LDISTRIB = TDB.find "INT_SUB_LDISTRIB"
  fun op INT_ADD_SUB _ = () val op INT_ADD_SUB = TDB.find "INT_ADD_SUB"
  fun op INT_SUB_LE _ = () val op INT_SUB_LE = TDB.find "INT_SUB_LE"
  fun op INT_SUB_LT _ = () val op INT_SUB_LT = TDB.find "INT_SUB_LT"
  fun op INT_NEG_SUB _ = () val op INT_NEG_SUB = TDB.find "INT_NEG_SUB"
  fun op INT_NEG_0 _ = () val op INT_NEG_0 = TDB.find "INT_NEG_0"
  fun op INT_NEG_EQ0 _ = () val op INT_NEG_EQ0 = TDB.find "INT_NEG_EQ0"
  fun op INT_LE_NEGR _ = () val op INT_LE_NEGR = TDB.find "INT_LE_NEGR"
  fun op INT_LE_NEGL _ = () val op INT_LE_NEGL = TDB.find "INT_LE_NEGL"
  fun op INT_LE_DOUBLE _ = ()
  val op INT_LE_DOUBLE = TDB.find "INT_LE_DOUBLE"
  fun op INT_SUB_0 _ = () val op INT_SUB_0 = TDB.find "INT_SUB_0"
  fun op INT_SUB_REFL _ = () val op INT_SUB_REFL = TDB.find "INT_SUB_REFL"
  fun op INT_SUB_ADD2 _ = () val op INT_SUB_ADD2 = TDB.find "INT_SUB_ADD2"
  fun op INT_SUB_ADD _ = () val op INT_SUB_ADD = TDB.find "INT_SUB_ADD"
  fun op INT_LT_ADD1 _ = () val op INT_LT_ADD1 = TDB.find "INT_LT_ADD1"
  fun op INT_LT_ADDNEG2 _ = ()
  val op INT_LT_ADDNEG2 = TDB.find "INT_LT_ADDNEG2"
  fun op INT_LT_ADDNEG _ = ()
  val op INT_LT_ADDNEG = TDB.find "INT_LT_ADDNEG"
  fun op INT_LT_ADD _ = () val op INT_LT_ADD = TDB.find "INT_LT_ADD"
  fun op INT_LE_ADD _ = () val op INT_LE_ADD = TDB.find "INT_LE_ADD"
  fun op INT_LE_ADD2 _ = () val op INT_LE_ADD2 = TDB.find "INT_LE_ADD2"
  fun op INT_LT_ADD2 _ = () val op INT_LT_ADD2 = TDB.find "INT_LT_ADD2"
  fun op INT_LE_RADD _ = () val op INT_LE_RADD = TDB.find "INT_LE_RADD"
  fun op INT_LE_LADD _ = () val op INT_LE_LADD = TDB.find "INT_LE_LADD"
  fun op INT_LT_01 _ = () val op INT_LT_01 = TDB.find "INT_LT_01"
  fun op INT_LE_01 _ = () val op INT_LE_01 = TDB.find "INT_LE_01"
  fun op INT_LE_SQUARE _ = ()
  val op INT_LE_SQUARE = TDB.find "INT_LE_SQUARE"
  fun op INT_LE_MUL _ = () val op INT_LE_MUL = TDB.find "INT_LE_MUL"
  fun op INT_LE_NEGTOTAL _ = ()
  val op INT_LE_NEGTOTAL = TDB.find "INT_LE_NEGTOTAL"
  fun op INT_LT_NEGTOTAL _ = ()
  val op INT_LT_NEGTOTAL = TDB.find "INT_LT_NEGTOTAL"
  fun op INT_NEG_GE0 _ = () val op INT_NEG_GE0 = TDB.find "INT_NEG_GE0"
  fun op INT_NEG_LE0 _ = () val op INT_NEG_LE0 = TDB.find "INT_NEG_LE0"
  fun op INT_NEG_GT0 _ = () val op INT_NEG_GT0 = TDB.find "INT_NEG_GT0"
  fun op INT_NEG_LT0 _ = () val op INT_NEG_LT0 = TDB.find "INT_NEG_LT0"
  fun op INT_LTE_ANTSYM _ = ()
  val op INT_LTE_ANTSYM = TDB.find "INT_LTE_ANTSYM"
  fun op INT_LET_ANTISYM _ = ()
  val op INT_LET_ANTISYM = TDB.find "INT_LET_ANTISYM"
  fun op INT_LE_ANTISYM _ = ()
  val op INT_LE_ANTISYM = TDB.find "INT_LE_ANTISYM"
  fun op INT_LE_TRANS _ = () val op INT_LE_TRANS = TDB.find "INT_LE_TRANS"
  fun op INT_LET_TRANS _ = ()
  val op INT_LET_TRANS = TDB.find "INT_LET_TRANS"
  fun op INT_LTE_TRANS _ = ()
  val op INT_LTE_TRANS = TDB.find "INT_LTE_TRANS"
  fun op INT_LT_IMP_LE _ = ()
  val op INT_LT_IMP_LE = TDB.find "INT_LT_IMP_LE"
  fun op INT_LT_LE _ = () val op INT_LT_LE = TDB.find "INT_LT_LE"
  fun op INT_LE_LT _ = () val op INT_LE_LT = TDB.find "INT_LE_LT"
  fun op INT_LE_REFL _ = () val op INT_LE_REFL = TDB.find "INT_LE_REFL"
  fun op INT_LTE_TOTAL _ = ()
  val op INT_LTE_TOTAL = TDB.find "INT_LTE_TOTAL"
  fun op INT_LET_TOTAL _ = ()
  val op INT_LET_TOTAL = TDB.find "INT_LET_TOTAL"
  fun op INT_LE_TOTAL _ = () val op INT_LE_TOTAL = TDB.find "INT_LE_TOTAL"
  fun op INT_NOT_LE _ = () val op INT_NOT_LE = TDB.find "INT_NOT_LE"
  fun op INT_LT_GT _ = () val op INT_LT_GT = TDB.find "INT_LT_GT"
  fun op INT_LT_ANTISYM _ = ()
  val op INT_LT_ANTISYM = TDB.find "INT_LT_ANTISYM"
  fun op INT_NOT_LT _ = () val op INT_NOT_LT = TDB.find "INT_NOT_LT"
  fun op INT_LT_RADD _ = () val op INT_LT_RADD = TDB.find "INT_LT_RADD"
  fun op INT_LT_LADD _ = () val op INT_LT_LADD = TDB.find "INT_LT_LADD"
  fun op INT_NEG_MUL2 _ = () val op INT_NEG_MUL2 = TDB.find "INT_NEG_MUL2"
  fun op INT_NEGNEG _ = () val op INT_NEGNEG = TDB.find "INT_NEGNEG"
  fun op INT_NEG_RMUL _ = () val op INT_NEG_RMUL = TDB.find "INT_NEG_RMUL"
  fun op INT_NEG_LMUL _ = () val op INT_NEG_LMUL = TDB.find "INT_NEG_LMUL"
  fun op INT_MUL_RZERO _ = ()
  val op INT_MUL_RZERO = TDB.find "INT_MUL_RZERO"
  fun op INT_MUL_LZERO _ = ()
  val op INT_MUL_LZERO = TDB.find "INT_MUL_LZERO"
  fun op INT_NEG_ADD _ = () val op INT_NEG_ADD = TDB.find "INT_NEG_ADD"
  fun op INT_RNEG_UNIQ _ = ()
  val op INT_RNEG_UNIQ = TDB.find "INT_RNEG_UNIQ"
  fun op INT_LNEG_UNIQ _ = ()
  val op INT_LNEG_UNIQ = TDB.find "INT_LNEG_UNIQ"
  fun op INT_ADD_RID_UNIQ _ = ()
  val op INT_ADD_RID_UNIQ = TDB.find "INT_ADD_RID_UNIQ"
  fun op INT_ADD_LID_UNIQ _ = ()
  val op INT_ADD_LID_UNIQ = TDB.find "INT_ADD_LID_UNIQ"
  fun op INT_EQ_RADD _ = () val op INT_EQ_RADD = TDB.find "INT_EQ_RADD"
  fun op INT_EQ_LADD _ = () val op INT_EQ_LADD = TDB.find "INT_EQ_LADD"
  fun op INT_RDISTRIB _ = () val op INT_RDISTRIB = TDB.find "INT_RDISTRIB"
  fun op INT_MUL_RID _ = () val op INT_MUL_RID = TDB.find "INT_MUL_RID"
  fun op INT_MUL_LID _ = () val op INT_MUL_LID = TDB.find "INT_MUL_LID"
  fun op INT_ADD_RINV _ = () val op INT_ADD_RINV = TDB.find "INT_ADD_RINV"
  fun op INT_ADD_LINV _ = () val op INT_ADD_LINV = TDB.find "INT_ADD_LINV"
  fun op INT_ADD_RID _ = () val op INT_ADD_RID = TDB.find "INT_ADD_RID"
  fun op INT_ADD_LID _ = () val op INT_ADD_LID = TDB.find "INT_ADD_LID"
  fun op INT_1 _ = () val op INT_1 = TDB.find "INT_1"
  fun op INT_0 _ = () val op INT_0 = TDB.find "INT_0"
  fun op NUM_POSINT_EX _ = ()
  val op NUM_POSINT_EX = TDB.find "NUM_POSINT_EX"
  fun op INT_LT_MUL _ = () val op INT_LT_MUL = TDB.find "INT_LT_MUL"
  fun op INT_LT_LADD_IMP _ = ()
  val op INT_LT_LADD_IMP = TDB.find "INT_LT_LADD_IMP"
  fun op INT_LT_TRANS _ = () val op INT_LT_TRANS = TDB.find "INT_LT_TRANS"
  fun op INT_LT_REFL _ = () val op INT_LT_REFL = TDB.find "INT_LT_REFL"
  fun op INT_LT_TOTAL _ = () val op INT_LT_TOTAL = TDB.find "INT_LT_TOTAL"
  fun op INT_LDISTRIB _ = () val op INT_LDISTRIB = TDB.find "INT_LDISTRIB"
  fun op INT_MUL_ASSOC _ = ()
  val op INT_MUL_ASSOC = TDB.find "INT_MUL_ASSOC"
  fun op INT_ADD_ASSOC _ = ()
  val op INT_ADD_ASSOC = TDB.find "INT_ADD_ASSOC"
  fun op INT_MUL_COMM _ = () val op INT_MUL_COMM = TDB.find "INT_MUL_COMM"
  fun op INT_MUL_SYM _ = () val op INT_MUL_SYM = TDB.find "INT_MUL_SYM"
  fun op INT_ADD_COMM _ = () val op INT_ADD_COMM = TDB.find "INT_ADD_COMM"
  fun op INT_ADD_SYM _ = () val op INT_ADD_SYM = TDB.find "INT_ADD_SYM"
  fun op INT_10 _ = () val op INT_10 = TDB.find "INT_10"
  fun op EQ_LADD _ = () val op EQ_LADD = TDB.find "EQ_LADD"
  fun op EQ_ADDL _ = () val op EQ_ADDL = TDB.find "EQ_ADDL"
  fun op LT_LADD _ = () val op LT_LADD = TDB.find "LT_LADD"
  fun op LT_ADDL _ = () val op LT_ADDL = TDB.find "LT_ADDL"
  fun op LT_ADDR _ = () val op LT_ADDR = TDB.find "LT_ADDR"
  fun op LT_ADD2 _ = () val op LT_ADD2 = TDB.find "LT_ADD2"
  fun op TINT_EQ_REFL _ = () val op TINT_EQ_REFL = TDB.find "TINT_EQ_REFL"
  fun op TINT_EQ_SYM _ = () val op TINT_EQ_SYM = TDB.find "TINT_EQ_SYM"
  fun op TINT_EQ_TRANS _ = ()
  val op TINT_EQ_TRANS = TDB.find "TINT_EQ_TRANS"
  fun op TINT_EQ_EQUIV _ = ()
  val op TINT_EQ_EQUIV = TDB.find "TINT_EQ_EQUIV"
  fun op TINT_EQ_AP _ = () val op TINT_EQ_AP = TDB.find "TINT_EQ_AP"
  fun op TINT_10 _ = () val op TINT_10 = TDB.find "TINT_10"
  fun op TINT_ADD_SYM _ = () val op TINT_ADD_SYM = TDB.find "TINT_ADD_SYM"
  fun op TINT_MUL_SYM _ = () val op TINT_MUL_SYM = TDB.find "TINT_MUL_SYM"
  fun op TINT_ADD_ASSOC _ = ()
  val op TINT_ADD_ASSOC = TDB.find "TINT_ADD_ASSOC"
  fun op TINT_MUL_ASSOC _ = ()
  val op TINT_MUL_ASSOC = TDB.find "TINT_MUL_ASSOC"
  fun op TINT_LDISTRIB _ = ()
  val op TINT_LDISTRIB = TDB.find "TINT_LDISTRIB"
  fun op TINT_ADD_LID _ = () val op TINT_ADD_LID = TDB.find "TINT_ADD_LID"
  fun op TINT_MUL_LID _ = () val op TINT_MUL_LID = TDB.find "TINT_MUL_LID"
  fun op TINT_ADD_LINV _ = ()
  val op TINT_ADD_LINV = TDB.find "TINT_ADD_LINV"
  fun op TINT_LT_TOTAL _ = ()
  val op TINT_LT_TOTAL = TDB.find "TINT_LT_TOTAL"
  fun op TINT_LT_REFL _ = () val op TINT_LT_REFL = TDB.find "TINT_LT_REFL"
  fun op TINT_LT_TRANS _ = ()
  val op TINT_LT_TRANS = TDB.find "TINT_LT_TRANS"
  fun op TINT_LT_ADD _ = () val op TINT_LT_ADD = TDB.find "TINT_LT_ADD"
  fun op TINT_LT_MUL _ = () val op TINT_LT_MUL = TDB.find "TINT_LT_MUL"
  fun op TINT_NEG_WELLDEF _ = ()
  val op TINT_NEG_WELLDEF = TDB.find "TINT_NEG_WELLDEF"
  fun op TINT_ADD_WELLDEFR _ = ()
  val op TINT_ADD_WELLDEFR = TDB.find "TINT_ADD_WELLDEFR"
  fun op TINT_ADD_WELLDEF _ = ()
  val op TINT_ADD_WELLDEF = TDB.find "TINT_ADD_WELLDEF"
  fun op TINT_MUL_WELLDEFR _ = ()
  val op TINT_MUL_WELLDEFR = TDB.find "TINT_MUL_WELLDEFR"
  fun op TINT_MUL_WELLDEF _ = ()
  val op TINT_MUL_WELLDEF = TDB.find "TINT_MUL_WELLDEF"
  fun op TINT_LT_WELLDEFR _ = ()
  val op TINT_LT_WELLDEFR = TDB.find "TINT_LT_WELLDEFR"
  fun op TINT_LT_WELLDEFL _ = ()
  val op TINT_LT_WELLDEFL = TDB.find "TINT_LT_WELLDEFL"
  fun op TINT_LT_WELLDEF _ = ()
  val op TINT_LT_WELLDEF = TDB.find "TINT_LT_WELLDEF"
  fun op tint_of_num_eq _ = ()
  val op tint_of_num_eq = TDB.find "tint_of_num_eq"
  fun op TINT_INJ _ = () val op TINT_INJ = TDB.find "TINT_INJ"
  fun op NUM_POSTINT_EX _ = ()
  val op NUM_POSTINT_EX = TDB.find "NUM_POSTINT_EX"
  fun op int_ABS_REP_CLASS _ = ()
  val op int_ABS_REP_CLASS = TDB.find "int_ABS_REP_CLASS"
  fun op int_QUOTIENT _ = () val op int_QUOTIENT = TDB.find "int_QUOTIENT"
  fun op int_of_num _ = () val op int_of_num = TDB.find "int_of_num"
  fun op INT_INJ _ = () val op INT_INJ = TDB.find "INT_INJ"
  fun op INT_ADD _ = () val op INT_ADD = TDB.find "INT_ADD"
  fun op INT_MUL _ = () val op INT_MUL = TDB.find "INT_MUL"
  fun op INT_LT_NZ _ = () val op INT_LT_NZ = TDB.find "INT_LT_NZ"
  fun op INT_NZ_IMP_LT _ = ()
  val op INT_NZ_IMP_LT = TDB.find "INT_NZ_IMP_LT"
  fun op INT_DOUBLE _ = () val op INT_DOUBLE = TDB.find "INT_DOUBLE"
  fun op INT_SUB_SUB _ = () val op INT_SUB_SUB = TDB.find "INT_SUB_SUB"
  fun op INT_LT_ADD_SUB _ = ()
  val op INT_LT_ADD_SUB = TDB.find "INT_LT_ADD_SUB"
  fun op INT_LT_SUB_RADD _ = ()
  val op INT_LT_SUB_RADD = TDB.find "INT_LT_SUB_RADD"
  fun op INT_LT_SUB_LADD _ = ()
  val op INT_LT_SUB_LADD = TDB.find "INT_LT_SUB_LADD"
  fun op INT_LE_SUB_LADD _ = ()
  val op INT_LE_SUB_LADD = TDB.find "INT_LE_SUB_LADD"
  fun op INT_LE_SUB_RADD _ = ()
  val op INT_LE_SUB_RADD = TDB.find "INT_LE_SUB_RADD"
  fun op INT_LT_NEG _ = () val op INT_LT_NEG = TDB.find "INT_LT_NEG"
  fun op INT_LE_NEG _ = () val op INT_LE_NEG = TDB.find "INT_LE_NEG"
  fun op INT_ADD2_SUB2 _ = ()
  val op INT_ADD2_SUB2 = TDB.find "INT_ADD2_SUB2"
  fun op INT_SUB_LZERO _ = ()
  val op INT_SUB_LZERO = TDB.find "INT_SUB_LZERO"
  fun op INT_SUB_RZERO _ = ()
  val op INT_SUB_RZERO = TDB.find "INT_SUB_RZERO"
  fun op INT_LET_ADD2 _ = () val op INT_LET_ADD2 = TDB.find "INT_LET_ADD2"
  fun op INT_LTE_ADD2 _ = () val op INT_LTE_ADD2 = TDB.find "INT_LTE_ADD2"
  fun op INT_LET_ADD _ = () val op INT_LET_ADD = TDB.find "INT_LET_ADD"
  fun op INT_LTE_ADD _ = () val op INT_LTE_ADD = TDB.find "INT_LTE_ADD"
  fun op INT_LT_MUL2 _ = () val op INT_LT_MUL2 = TDB.find "INT_LT_MUL2"
  fun op INT_SUB_LNEG _ = () val op INT_SUB_LNEG = TDB.find "INT_SUB_LNEG"
  fun op INT_SUB_RNEG _ = () val op INT_SUB_RNEG = TDB.find "INT_SUB_RNEG"
  fun op INT_SUB_NEG2 _ = () val op INT_SUB_NEG2 = TDB.find "INT_SUB_NEG2"
  fun op INT_SUB_TRIANGLE _ = ()
  val op INT_SUB_TRIANGLE = TDB.find "INT_SUB_TRIANGLE"
  fun op INT_EQ_SUB_LADD _ = ()
  val op INT_EQ_SUB_LADD = TDB.find "INT_EQ_SUB_LADD"
  fun op INT_EQ_SUB_RADD _ = ()
  val op INT_EQ_SUB_RADD = TDB.find "INT_EQ_SUB_RADD"
  fun op INT_SUB _ = () val op INT_SUB = TDB.find "INT_SUB"
  fun op INT_SUB_SUB2 _ = () val op INT_SUB_SUB2 = TDB.find "INT_SUB_SUB2"
  fun op INT_ADD_SUB2 _ = () val op INT_ADD_SUB2 = TDB.find "INT_ADD_SUB2"
  fun op INT_EQ_LMUL2 _ = () val op INT_EQ_LMUL2 = TDB.find "INT_EQ_LMUL2"
  fun op INT_EQ_IMP_LE _ = ()
  val op INT_EQ_IMP_LE = TDB.find "INT_EQ_IMP_LE"
  fun op INT_POS_NZ _ = () val op INT_POS_NZ = TDB.find "INT_POS_NZ"
  fun op INT_EQ_RMUL_IMP _ = ()
  val op INT_EQ_RMUL_IMP = TDB.find "INT_EQ_RMUL_IMP"
  fun op INT_EQ_LMUL_IMP _ = ()
  val op INT_EQ_LMUL_IMP = TDB.find "INT_EQ_LMUL_IMP"
  fun op INT_DIFFSQ _ = () val op INT_DIFFSQ = TDB.find "INT_DIFFSQ"
  fun op INT_POSSQ _ = () val op INT_POSSQ = TDB.find "INT_POSSQ"
  fun op INT_SUMSQ _ = () val op INT_SUMSQ = TDB.find "INT_SUMSQ"
  fun op INT_EQ_NEG _ = () val op INT_EQ_NEG = TDB.find "INT_EQ_NEG"
  fun op INT_LT_CALCULATE _ = ()
  val op INT_LT_CALCULATE = TDB.find "INT_LT_CALCULATE"
  fun op NUM_POSINT _ = () val op NUM_POSINT = TDB.find "NUM_POSINT"
  fun op NUM_POSINT_EXISTS _ = ()
  val op NUM_POSINT_EXISTS = TDB.find "NUM_POSINT_EXISTS"
  fun op NUM_NEGINT_EXISTS _ = ()
  val op NUM_NEGINT_EXISTS = TDB.find "NUM_NEGINT_EXISTS"
  fun op INT_NUM_CASES _ = ()
  val op INT_NUM_CASES = TDB.find "INT_NUM_CASES"
  fun op INT_DISCRETE _ = () val op INT_DISCRETE = TDB.find "INT_DISCRETE"
  fun op INT_LE_LT1 _ = () val op INT_LE_LT1 = TDB.find "INT_LE_LT1"
  fun op INT_LT_LE1 _ = () val op INT_LT_LE1 = TDB.find "INT_LT_LE1"
  fun op INT_MUL_EQ_1 _ = () val op INT_MUL_EQ_1 = TDB.find "INT_MUL_EQ_1"
  fun op NUM_OF_INT _ = () val op NUM_OF_INT = TDB.find "NUM_OF_INT"
  fun op INT_OF_NUM _ = () val op INT_OF_NUM = TDB.find "INT_OF_NUM"
  fun op LE_NUM_OF_INT _ = ()
  val op LE_NUM_OF_INT = TDB.find "LE_NUM_OF_INT"
  fun op NUM_LT _ = () val op NUM_LT = TDB.find "NUM_LT"
  fun op INT_DIV _ = () val op INT_DIV = TDB.find "INT_DIV"
  fun op INT_DIV_NEG _ = () val op INT_DIV_NEG = TDB.find "INT_DIV_NEG"
  fun op INT_DIV_1 _ = () val op INT_DIV_1 = TDB.find "INT_DIV_1"
  fun op INT_DIV_0 _ = () val op INT_DIV_0 = TDB.find "INT_DIV_0"
  fun op INT_DIV_ID _ = () val op INT_DIV_ID = TDB.find "INT_DIV_ID"
  fun op INT_MOD_BOUNDS _ = ()
  val op INT_MOD_BOUNDS = TDB.find "INT_MOD_BOUNDS"
  fun op INT_DIVISION _ = () val op INT_DIVISION = TDB.find "INT_DIVISION"
  fun op INT_MOD _ = () val op INT_MOD = TDB.find "INT_MOD"
  fun op INT_MOD_NEG _ = () val op INT_MOD_NEG = TDB.find "INT_MOD_NEG"
  fun op INT_MOD0 _ = () val op INT_MOD0 = TDB.find "INT_MOD0"
  fun op INT_DIV_MUL_ID _ = ()
  val op INT_DIV_MUL_ID = TDB.find "INT_DIV_MUL_ID"
  fun op INT_DIV_UNIQUE _ = ()
  val op INT_DIV_UNIQUE = TDB.find "INT_DIV_UNIQUE"
  fun op INT_MOD_UNIQUE _ = ()
  val op INT_MOD_UNIQUE = TDB.find "INT_MOD_UNIQUE"
  fun op INT_MOD_ID _ = () val op INT_MOD_ID = TDB.find "INT_MOD_ID"
  fun op INT_MOD_COMMON_FACTOR _ = ()
  val op INT_MOD_COMMON_FACTOR = TDB.find "INT_MOD_COMMON_FACTOR"
  fun op INT_DIV_LMUL _ = () val op INT_DIV_LMUL = TDB.find "INT_DIV_LMUL"
  fun op INT_DIV_RMUL _ = () val op INT_DIV_RMUL = TDB.find "INT_DIV_RMUL"
  fun op INT_MOD_EQ0 _ = () val op INT_MOD_EQ0 = TDB.find "INT_MOD_EQ0"
  fun op INT_MUL_DIV _ = () val op INT_MUL_DIV = TDB.find "INT_MUL_DIV"
  fun op INT_ADD_DIV _ = () val op INT_ADD_DIV = TDB.find "INT_ADD_DIV"
  fun op INT_MOD_ADD_MULTIPLES _ = ()
  val op INT_MOD_ADD_MULTIPLES = TDB.find "INT_MOD_ADD_MULTIPLES"
  fun op INT_MOD_NEG_NUMERATOR _ = ()
  val op INT_MOD_NEG_NUMERATOR = TDB.find "INT_MOD_NEG_NUMERATOR"
  fun op INT_MOD_PLUS _ = () val op INT_MOD_PLUS = TDB.find "INT_MOD_PLUS"
  fun op INT_MOD_SUB _ = () val op INT_MOD_SUB = TDB.find "INT_MOD_SUB"
  fun op INT_MOD_MOD _ = () val op INT_MOD_MOD = TDB.find "INT_MOD_MOD"
  fun op INT_DIV_P _ = () val op INT_DIV_P = TDB.find "INT_DIV_P"
  fun op INT_MOD_P _ = () val op INT_MOD_P = TDB.find "INT_MOD_P"
  fun op INT_DIV_FORALL_P _ = ()
  val op INT_DIV_FORALL_P = TDB.find "INT_DIV_FORALL_P"
  fun op INT_MOD_FORALL_P _ = ()
  val op INT_MOD_FORALL_P = TDB.find "INT_MOD_FORALL_P"
  fun op INT_MOD_1 _ = () val op INT_MOD_1 = TDB.find "INT_MOD_1"
  fun op INT_LESS_MOD _ = () val op INT_LESS_MOD = TDB.find "INT_LESS_MOD"
  fun op INT_MOD_MINUS1 _ = ()
  val op INT_MOD_MINUS1 = TDB.find "INT_MOD_MINUS1"
  fun op INT_ABS_POS _ = () val op INT_ABS_POS = TDB.find "INT_ABS_POS"
  fun op INT_ABS_NUM _ = () val op INT_ABS_NUM = TDB.find "INT_ABS_NUM"
  fun op INT_NEG_SAME_EQ _ = ()
  val op INT_NEG_SAME_EQ = TDB.find "INT_NEG_SAME_EQ"
  fun op INT_ABS_NEG _ = () val op INT_ABS_NEG = TDB.find "INT_ABS_NEG"
  fun op INT_ABS_ABS _ = () val op INT_ABS_ABS = TDB.find "INT_ABS_ABS"
  fun op INT_ABS_EQ_ID _ = ()
  val op INT_ABS_EQ_ID = TDB.find "INT_ABS_EQ_ID"
  fun op INT_ABS_MUL _ = () val op INT_ABS_MUL = TDB.find "INT_ABS_MUL"
  fun op INT_ABS_EQ0 _ = () val op INT_ABS_EQ0 = TDB.find "INT_ABS_EQ0"
  fun op INT_ABS_LT0 _ = () val op INT_ABS_LT0 = TDB.find "INT_ABS_LT0"
  fun op INT_ABS_0LT _ = () val op INT_ABS_0LT = TDB.find "INT_ABS_0LT"
  fun op INT_ABS_LE0 _ = () val op INT_ABS_LE0 = TDB.find "INT_ABS_LE0"
  fun op INT_ABS_LT _ = () val op INT_ABS_LT = TDB.find "INT_ABS_LT"
  fun op INT_ABS_LE _ = () val op INT_ABS_LE = TDB.find "INT_ABS_LE"
  fun op INT_ABS_EQ _ = () val op INT_ABS_EQ = TDB.find "INT_ABS_EQ"
  fun op INT_ABS_EQ_ABS _ = ()
  val op INT_ABS_EQ_ABS = TDB.find "INT_ABS_EQ_ABS"
  fun op INT_QUOT _ = () val op INT_QUOT = TDB.find "INT_QUOT"
  fun op INT_QUOT_0 _ = () val op INT_QUOT_0 = TDB.find "INT_QUOT_0"
  fun op INT_QUOT_1 _ = () val op INT_QUOT_1 = TDB.find "INT_QUOT_1"
  fun op INT_QUOT_NEG _ = () val op INT_QUOT_NEG = TDB.find "INT_QUOT_NEG"
  fun op INT_ABS_QUOT _ = () val op INT_ABS_QUOT = TDB.find "INT_ABS_QUOT"
  fun op INT_QUOT_UNIQUE _ = ()
  val op INT_QUOT_UNIQUE = TDB.find "INT_QUOT_UNIQUE"
  fun op INT_QUOT_ID _ = () val op INT_QUOT_ID = TDB.find "INT_QUOT_ID"
  fun op INT_REM _ = () val op INT_REM = TDB.find "INT_REM"
  fun op INT_REMQUOT _ = () val op INT_REMQUOT = TDB.find "INT_REMQUOT"
  fun op INT_REM_UNIQUE _ = ()
  val op INT_REM_UNIQUE = TDB.find "INT_REM_UNIQUE"
  fun op INT_REM_NEG _ = () val op INT_REM_NEG = TDB.find "INT_REM_NEG"
  fun op INT_REM_ID _ = () val op INT_REM_ID = TDB.find "INT_REM_ID"
  fun op INT_REM0 _ = () val op INT_REM0 = TDB.find "INT_REM0"
  fun op INT_REM_COMMON_FACTOR _ = ()
  val op INT_REM_COMMON_FACTOR = TDB.find "INT_REM_COMMON_FACTOR"
  fun op INT_REM_EQ0 _ = () val op INT_REM_EQ0 = TDB.find "INT_REM_EQ0"
  fun op INT_MUL_QUOT _ = () val op INT_MUL_QUOT = TDB.find "INT_MUL_QUOT"
  fun op INT_REM_EQ_MOD _ = ()
  val op INT_REM_EQ_MOD = TDB.find "INT_REM_EQ_MOD"
  fun op INT_DIVIDES_MOD0 _ = ()
  val op INT_DIVIDES_MOD0 = TDB.find "INT_DIVIDES_MOD0"
  fun op INT_DIVIDES_0 _ = ()
  val op INT_DIVIDES_0 = TDB.find "INT_DIVIDES_0"
  fun op INT_DIVIDES_1 _ = ()
  val op INT_DIVIDES_1 = TDB.find "INT_DIVIDES_1"
  fun op INT_DIVIDES_REFL _ = ()
  val op INT_DIVIDES_REFL = TDB.find "INT_DIVIDES_REFL"
  fun op INT_DIVIDES_TRANS _ = ()
  val op INT_DIVIDES_TRANS = TDB.find "INT_DIVIDES_TRANS"
  fun op INT_DIVIDES_MUL _ = ()
  val op INT_DIVIDES_MUL = TDB.find "INT_DIVIDES_MUL"
  fun op INT_DIVIDES_LMUL _ = ()
  val op INT_DIVIDES_LMUL = TDB.find "INT_DIVIDES_LMUL"
  fun op INT_DIVIDES_RMUL _ = ()
  val op INT_DIVIDES_RMUL = TDB.find "INT_DIVIDES_RMUL"
  fun op INT_DIVIDES_MUL_BOTH _ = ()
  val op INT_DIVIDES_MUL_BOTH = TDB.find "INT_DIVIDES_MUL_BOTH"
  fun op INT_DIVIDES_LADD _ = ()
  val op INT_DIVIDES_LADD = TDB.find "INT_DIVIDES_LADD"
  fun op INT_DIVIDES_RADD _ = ()
  val op INT_DIVIDES_RADD = TDB.find "INT_DIVIDES_RADD"
  fun op INT_DIVIDES_NEG _ = ()
  val op INT_DIVIDES_NEG = TDB.find "INT_DIVIDES_NEG"
  fun op INT_DIVIDES_LSUB _ = ()
  val op INT_DIVIDES_LSUB = TDB.find "INT_DIVIDES_LSUB"
  fun op INT_DIVIDES_RSUB _ = ()
  val op INT_DIVIDES_RSUB = TDB.find "INT_DIVIDES_RSUB"
  fun op INT_EXP _ = () val op INT_EXP = TDB.find "INT_EXP"
  fun op INT_EXP_EQ0 _ = () val op INT_EXP_EQ0 = TDB.find "INT_EXP_EQ0"
  fun op INT_MUL_SIGN_CASES _ = ()
  val op INT_MUL_SIGN_CASES = TDB.find "INT_MUL_SIGN_CASES"
  fun op INT_EXP_NEG _ = () val op INT_EXP_NEG = TDB.find "INT_EXP_NEG"
  fun op INT_EXP_ADD_EXPONENTS _ = ()
  val op INT_EXP_ADD_EXPONENTS = TDB.find "INT_EXP_ADD_EXPONENTS"
  fun op INT_EXP_MULTIPLY_EXPONENTS _ = ()
  val op INT_EXP_MULTIPLY_EXPONENTS = TDB.find "INT_EXP_MULTIPLY_EXPONENTS"
  fun op INT_EXP_MOD _ = () val op INT_EXP_MOD = TDB.find "INT_EXP_MOD"
  fun op INT_EXP_SUBTRACT_EXPONENTS _ = ()
  val op INT_EXP_SUBTRACT_EXPONENTS = TDB.find "INT_EXP_SUBTRACT_EXPONENTS"
  fun op INT_MIN_LT _ = () val op INT_MIN_LT = TDB.find "INT_MIN_LT"
  fun op INT_MAX_LT _ = () val op INT_MAX_LT = TDB.find "INT_MAX_LT"
  fun op INT_MIN_NUM _ = () val op INT_MIN_NUM = TDB.find "INT_MIN_NUM"
  fun op INT_MAX_NUM _ = () val op INT_MAX_NUM = TDB.find "INT_MAX_NUM"
  fun op INT_LT_MONO _ = () val op INT_LT_MONO = TDB.find "INT_LT_MONO"
  fun op INT_LE_MONO _ = () val op INT_LE_MONO = TDB.find "INT_LE_MONO"
  fun op INFINITE_INT_UNIV _ = ()
  val op INFINITE_INT_UNIV = TDB.find "INFINITE_INT_UNIV"
  fun op INT_ADD_CALCULATE _ = ()
  val op INT_ADD_CALCULATE = TDB.find "INT_ADD_CALCULATE"
  fun op INT_ADD_REDUCE _ = ()
  val op INT_ADD_REDUCE = TDB.find "INT_ADD_REDUCE"
  fun op INT_SUB_CALCULATE _ = ()
  val op INT_SUB_CALCULATE = TDB.find "INT_SUB_CALCULATE"
  fun op INT_SUB_REDUCE _ = ()
  val op INT_SUB_REDUCE = TDB.find "INT_SUB_REDUCE"
  fun op INT_MUL_CALCULATE _ = ()
  val op INT_MUL_CALCULATE = TDB.find "INT_MUL_CALCULATE"
  fun op INT_MUL_REDUCE _ = ()
  val op INT_MUL_REDUCE = TDB.find "INT_MUL_REDUCE"
  fun op INT_DIV_CALCULATE _ = ()
  val op INT_DIV_CALCULATE = TDB.find "INT_DIV_CALCULATE"
  fun op INT_DIV_REDUCE _ = ()
  val op INT_DIV_REDUCE = TDB.find "INT_DIV_REDUCE"
  fun op INT_QUOT_CALCULATE _ = ()
  val op INT_QUOT_CALCULATE = TDB.find "INT_QUOT_CALCULATE"
  fun op INT_QUOT_REDUCE _ = ()
  val op INT_QUOT_REDUCE = TDB.find "INT_QUOT_REDUCE"
  fun op INT_MOD_CALCULATE _ = ()
  val op INT_MOD_CALCULATE = TDB.find "INT_MOD_CALCULATE"
  fun op INT_MOD_REDUCE _ = ()
  val op INT_MOD_REDUCE = TDB.find "INT_MOD_REDUCE"
  fun op INT_REM_CALCULATE _ = ()
  val op INT_REM_CALCULATE = TDB.find "INT_REM_CALCULATE"
  fun op INT_REM_REDUCE _ = ()
  val op INT_REM_REDUCE = TDB.find "INT_REM_REDUCE"
  fun op INT_EXP_CALCULATE _ = ()
  val op INT_EXP_CALCULATE = TDB.find "INT_EXP_CALCULATE"
  fun op INT_EXP_REDUCE _ = ()
  val op INT_EXP_REDUCE = TDB.find "INT_EXP_REDUCE"
  fun op INT_LT_REDUCE _ = ()
  val op INT_LT_REDUCE = TDB.find "INT_LT_REDUCE"
  fun op INT_LE_CALCULATE _ = ()
  val op INT_LE_CALCULATE = TDB.find "INT_LE_CALCULATE"
  fun op INT_LE_REDUCE _ = ()
  val op INT_LE_REDUCE = TDB.find "INT_LE_REDUCE"
  fun op INT_GT_CALCULATE _ = ()
  val op INT_GT_CALCULATE = TDB.find "INT_GT_CALCULATE"
  fun op INT_GT_REDUCE _ = ()
  val op INT_GT_REDUCE = TDB.find "INT_GT_REDUCE"
  fun op INT_GE_CALCULATE _ = ()
  val op INT_GE_CALCULATE = TDB.find "INT_GE_CALCULATE"
  fun op INT_GE_REDUCE _ = ()
  val op INT_GE_REDUCE = TDB.find "INT_GE_REDUCE"
  fun op INT_EQ_CALCULATE _ = ()
  val op INT_EQ_CALCULATE = TDB.find "INT_EQ_CALCULATE"
  fun op INT_EQ_REDUCE _ = ()
  val op INT_EQ_REDUCE = TDB.find "INT_EQ_REDUCE"
  fun op INT_DIVIDES_REDUCE _ = ()
  val op INT_DIVIDES_REDUCE = TDB.find "INT_DIVIDES_REDUCE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val integer_grammars = merge_grammars ["arithmetic", "pred_set"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="integer"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val integer_grammars = 
    Portable.## (addtyUDs,addtmUDs) integer_grammars
  val _ = Parse.grammarDB_insert("integer",integer_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val () = Literal.add_literal
    (fn tm =>
       case Lib.total boolSyntax.dest_strip_comb tm of
          SOME ("integer$int_of_num", [n]) => numSyntax.is_numeral n
        | SOME ("integer$int_neg", [n]) =>
            (case Lib.total boolSyntax.dest_strip_comb n of
                SOME ("integer$int_of_num", [n]) => numSyntax.is_numeral n
              | _ => false)
        | _ => false)
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "integer"

end
