structure integer_wordTheory :> integer_wordTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading integer_wordTheory ... "
    else ()
  
  open Type Term Thm
  local open OmegaTheory int_arithTheory wordsTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "integer_word"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/integer_wordTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op toString_def _ = () val op toString_def = TDB.find "toString_def"
  fun op fromString_primitive_def _ = ()
  val op fromString_primitive_def = TDB.find "fromString_primitive_def"
  fun op i2w_def _ = () val op i2w_def = TDB.find "i2w_def"
  fun op w2i_def _ = () val op w2i_def = TDB.find "w2i_def"
  fun op UINT_MAX_def _ = () val op UINT_MAX_def = TDB.find "UINT_MAX_def"
  fun op INT_MAX_def _ = () val op INT_MAX_def = TDB.find "INT_MAX_def"
  fun op INT_MIN_def _ = () val op INT_MIN_def = TDB.find "INT_MIN_def"
  fun op saturate_i2w_def _ = ()
  val op saturate_i2w_def = TDB.find "saturate_i2w_def"
  fun op saturate_i2sw_def _ = ()
  val op saturate_i2sw_def = TDB.find "saturate_i2sw_def"
  fun op saturate_sw2sw_def _ = ()
  val op saturate_sw2sw_def = TDB.find "saturate_sw2sw_def"
  fun op saturate_w2sw_def _ = ()
  val op saturate_w2sw_def = TDB.find "saturate_w2sw_def"
  fun op saturate_sw2w_def _ = ()
  val op saturate_sw2w_def = TDB.find "saturate_sw2w_def"
  fun op signed_saturate_add_def _ = ()
  val op signed_saturate_add_def = TDB.find "signed_saturate_add_def"
  fun op signed_saturate_sub_def _ = ()
  val op signed_saturate_sub_def = TDB.find "signed_saturate_sub_def"
  fun op word_sdiv_def _ = ()
  val op word_sdiv_def = TDB.find "word_sdiv_def"
  fun op word_smod_def _ = ()
  val op word_smod_def = TDB.find "word_smod_def"
  fun op fromString_ind _ = ()
  val op fromString_ind = TDB.find "fromString_ind"
  fun op fromString_def _ = ()
  val op fromString_def = TDB.find "fromString_def"
  fun op ONE_LE_TWOEXP _ = ()
  val op ONE_LE_TWOEXP = TDB.find "ONE_LE_TWOEXP"
  fun op w2i_w2n_pos _ = () val op w2i_w2n_pos = TDB.find "w2i_w2n_pos"
  fun op w2i_n2w_pos _ = () val op w2i_n2w_pos = TDB.find "w2i_n2w_pos"
  fun op w2i_n2w_neg _ = () val op w2i_n2w_neg = TDB.find "w2i_n2w_neg"
  fun op i2w_w2i _ = () val op i2w_w2i = TDB.find "i2w_w2i"
  fun op w2i_i2w _ = () val op w2i_i2w = TDB.find "w2i_i2w"
  fun op word_msb_i2w _ = () val op word_msb_i2w = TDB.find "word_msb_i2w"
  fun op w2i_11 _ = () val op w2i_11 = TDB.find "w2i_11"
  fun op int_word_nchotomy _ = ()
  val op int_word_nchotomy = TDB.find "int_word_nchotomy"
  fun op w2i_le _ = () val op w2i_le = TDB.find "w2i_le"
  fun op w2i_ge _ = () val op w2i_ge = TDB.find "w2i_ge"
  fun op ranged_int_word_nchotomy _ = ()
  val op ranged_int_word_nchotomy = TDB.find "ranged_int_word_nchotomy"
  fun op sw2sw_i2w _ = () val op sw2sw_i2w = TDB.find "sw2sw_i2w"
  fun op w2w_i2w _ = () val op w2w_i2w = TDB.find "w2w_i2w"
  fun op WORD_LTi _ = () val op WORD_LTi = TDB.find "WORD_LTi"
  fun op WORD_GTi _ = () val op WORD_GTi = TDB.find "WORD_GTi"
  fun op WORD_LEi _ = () val op WORD_LEi = TDB.find "WORD_LEi"
  fun op WORD_GEi _ = () val op WORD_GEi = TDB.find "WORD_GEi"
  fun op word_add_i2w_w2n _ = ()
  val op word_add_i2w_w2n = TDB.find "word_add_i2w_w2n"
  fun op word_add_i2w _ = () val op word_add_i2w = TDB.find "word_add_i2w"
  fun op word_sub_i2w_w2n _ = ()
  val op word_sub_i2w_w2n = TDB.find "word_sub_i2w_w2n"
  fun op word_sub_i2w _ = () val op word_sub_i2w = TDB.find "word_sub_i2w"
  fun op word_mul_i2w_w2n _ = ()
  val op word_mul_i2w_w2n = TDB.find "word_mul_i2w_w2n"
  fun op word_mul_i2w _ = () val op word_mul_i2w = TDB.find "word_mul_i2w"
  fun op word_i2w_add _ = () val op word_i2w_add = TDB.find "word_i2w_add"
  fun op word_i2w_mul _ = () val op word_i2w_mul = TDB.find "word_i2w_mul"
  fun op MULT_MINUS_ONE _ = ()
  val op MULT_MINUS_ONE = TDB.find "MULT_MINUS_ONE"
  fun op word_0_w2i _ = () val op word_0_w2i = TDB.find "word_0_w2i"
  fun op w2i_eq_0 _ = () val op w2i_eq_0 = TDB.find "w2i_eq_0"
  fun op i2w_DIV _ = () val op i2w_DIV = TDB.find "i2w_DIV"
  fun op INT_MIN_MONOTONIC _ = ()
  val op INT_MIN_MONOTONIC = TDB.find "INT_MIN_MONOTONIC"
  fun op INT_MAX_MONOTONIC _ = ()
  val op INT_MAX_MONOTONIC = TDB.find "INT_MAX_MONOTONIC"
  fun op w2i_sw2sw_bounds _ = ()
  val op w2i_sw2sw_bounds = TDB.find "w2i_sw2sw_bounds"
  fun op w2i_i2w_id _ = () val op w2i_i2w_id = TDB.find "w2i_i2w_id"
  fun op w2i_11_lift _ = () val op w2i_11_lift = TDB.find "w2i_11_lift"
  fun op w2i_n2w_mod _ = () val op w2i_n2w_mod = TDB.find "w2i_n2w_mod"
  fun op word_abs_w2i _ = () val op word_abs_w2i = TDB.find "word_abs_w2i"
  fun op word_abs_i2w _ = () val op word_abs_i2w = TDB.find "word_abs_i2w"
  fun op INT_MIN _ = () val op INT_MIN = TDB.find "INT_MIN"
  fun op INT_MAX _ = () val op INT_MAX = TDB.find "INT_MAX"
  fun op UINT_MAX _ = () val op UINT_MAX = TDB.find "UINT_MAX"
  fun op INT_BOUND_ORDER _ = ()
  val op INT_BOUND_ORDER = TDB.find "INT_BOUND_ORDER"
  fun op INT_ZERO_LT_INT_MIN _ = ()
  val op INT_ZERO_LT_INT_MIN = TDB.find "INT_ZERO_LT_INT_MIN"
  fun op INT_ZERO_LT_INT_MAX _ = ()
  val op INT_ZERO_LT_INT_MAX = TDB.find "INT_ZERO_LT_INT_MAX"
  fun op INT_ZERO_LE_INT_MAX _ = ()
  val op INT_ZERO_LE_INT_MAX = TDB.find "INT_ZERO_LE_INT_MAX"
  fun op INT_ZERO_LT_UINT_MAX _ = ()
  val op INT_ZERO_LT_UINT_MAX = TDB.find "INT_ZERO_LT_UINT_MAX"
  fun op w2i_1 _ = () val op w2i_1 = TDB.find "w2i_1"
  fun op w2i_INT_MINw _ = () val op w2i_INT_MINw = TDB.find "w2i_INT_MINw"
  fun op w2i_UINT_MAXw _ = ()
  val op w2i_UINT_MAXw = TDB.find "w2i_UINT_MAXw"
  fun op w2i_INT_MAXw _ = () val op w2i_INT_MAXw = TDB.find "w2i_INT_MAXw"
  fun op w2i_minus_1 _ = () val op w2i_minus_1 = TDB.find "w2i_minus_1"
  fun op w2i_lt_0 _ = () val op w2i_lt_0 = TDB.find "w2i_lt_0"
  fun op w2i_neg _ = () val op w2i_neg = TDB.find "w2i_neg"
  fun op i2w_0 _ = () val op i2w_0 = TDB.find "i2w_0"
  fun op i2w_minus_1 _ = () val op i2w_minus_1 = TDB.find "i2w_minus_1"
  fun op i2w_INT_MIN _ = () val op i2w_INT_MIN = TDB.find "i2w_INT_MIN"
  fun op i2w_INT_MAX _ = () val op i2w_INT_MAX = TDB.find "i2w_INT_MAX"
  fun op i2w_UINT_MAX _ = () val op i2w_UINT_MAX = TDB.find "i2w_UINT_MAX"
  fun op word_msb_i2w_lt_0 _ = ()
  val op word_msb_i2w_lt_0 = TDB.find "word_msb_i2w_lt_0"
  fun op i2w_pos _ = () val op i2w_pos = TDB.find "i2w_pos"
  fun op word_quot _ = () val op word_quot = TDB.find "word_quot"
  fun op word_rem _ = () val op word_rem = TDB.find "word_rem"
  fun op saturate_i2w_0 _ = ()
  val op saturate_i2w_0 = TDB.find "saturate_i2w_0"
  fun op saturate_i2sw_0 _ = ()
  val op saturate_i2sw_0 = TDB.find "saturate_i2sw_0"
  fun op saturate_w2sw _ = ()
  val op saturate_w2sw = TDB.find "saturate_w2sw"
  fun op saturate_i2sw _ = ()
  val op saturate_i2sw = TDB.find "saturate_i2sw"
  fun op saturate_sw2w _ = ()
  val op saturate_sw2w = TDB.find "saturate_sw2w"
  fun op saturate_sw2sw _ = ()
  val op saturate_sw2sw = TDB.find "saturate_sw2sw"
  fun op signed_saturate_sub _ = ()
  val op signed_saturate_sub = TDB.find "signed_saturate_sub"
  fun op signed_saturate_add _ = ()
  val op signed_saturate_add = TDB.find "signed_saturate_add"
  fun op different_sign_then_no_overflow _ = ()
  val op different_sign_then_no_overflow = TDB.find
    "different_sign_then_no_overflow"
  fun op w2i_i2w_pos _ = () val op w2i_i2w_pos = TDB.find "w2i_i2w_pos"
  fun op w2i_i2w_neg _ = () val op w2i_i2w_neg = TDB.find "w2i_i2w_neg"
  fun op overflow _ = () val op overflow = TDB.find "overflow"
  fun op sub_overflow _ = () val op sub_overflow = TDB.find "sub_overflow"
  fun op overflow_add _ = () val op overflow_add = TDB.find "overflow_add"
  fun op overflow_sub _ = () val op overflow_sub = TDB.find "overflow_sub"
  fun op i2w_w2n_w2w _ = () val op i2w_w2n_w2w = TDB.find "i2w_w2n_w2w"
  fun op i2w_w2n _ = () val op i2w_w2n = TDB.find "i2w_w2n"
  fun op w2n_i2w _ = () val op w2n_i2w = TDB.find "w2n_i2w"
  fun op w2i_eq_w2n _ = () val op w2i_eq_w2n = TDB.find "w2i_eq_w2n"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val integer_word_grammars = merge_grammars ["Omega", "int_arith", "words"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="integer_word"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val integer_word_grammars = 
    Portable.## (addtyUDs,addtmUDs) integer_word_grammars
  val _ = Parse.grammarDB_insert("integer_word",integer_word_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "integer_word"

end
