structure inttoTheory :> inttoTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading inttoTheory ... "
    else ()
  
  open Type Term Thm
  local open OmegaTheory int_arithTheory totoTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "intto"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/integer/inttoTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op intOrd _ = () val op intOrd = TDB.find "intOrd"
  fun op intto _ = () val op intto = TDB.find "intto"
  fun op apintto_thm _ = () val op apintto_thm = TDB.find "apintto_thm"
  fun op pos_pos_thm _ = () val op pos_pos_thm = TDB.find "pos_pos_thm"
  fun op neg_neg_thm _ = () val op neg_neg_thm = TDB.find "neg_neg_thm"
  fun op BIT1_nz _ = () val op BIT1_nz = TDB.find "BIT1_nz"
  fun op BIT2_nz _ = () val op BIT2_nz = TDB.find "BIT2_nz"
  fun op neg_lt_BIT1_thm _ = ()
  val op neg_lt_BIT1_thm = TDB.find "neg_lt_BIT1_thm"
  fun op neg_lt_BIT2_thm _ = ()
  val op neg_lt_BIT2_thm = TDB.find "neg_lt_BIT2_thm"
  fun op neg_BIT1_lt_thm _ = ()
  val op neg_BIT1_lt_thm = TDB.find "neg_BIT1_lt_thm"
  fun op neg_BIT2_lt_thm _ = ()
  val op neg_BIT2_lt_thm = TDB.find "neg_BIT2_lt_thm"
  fun op neg_ZERO_eq_ZERO_thm _ = ()
  val op neg_ZERO_eq_ZERO_thm = TDB.find "neg_ZERO_eq_ZERO_thm"
  fun op BIT1_gt_neg_thm _ = ()
  val op BIT1_gt_neg_thm = TDB.find "BIT1_gt_neg_thm"
  fun op BIT2_gt_neg_thm _ = ()
  val op BIT2_gt_neg_thm = TDB.find "BIT2_gt_neg_thm"
  fun op gt_neg_BIT1_thm _ = ()
  val op gt_neg_BIT1_thm = TDB.find "gt_neg_BIT1_thm"
  fun op gt_neg_BIT2_thm _ = ()
  val op gt_neg_BIT2_thm = TDB.find "gt_neg_BIT2_thm"
  fun op ZERO_eq_neg_ZERO_thm _ = ()
  val op ZERO_eq_neg_ZERO_thm = TDB.find "ZERO_eq_neg_ZERO_thm"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val intto_grammars = merge_grammars ["Omega", "int_arith", "toto"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="intto"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val intto_grammars = 
    Portable.## (addtyUDs,addtmUDs) intto_grammars
  val _ = Parse.grammarDB_insert("intto",intto_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "intto"

end
