structure indexedListsTheory :> indexedListsTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading indexedListsTheory ... "
    else ()
  
  open Type Term Thm
  local open rich_listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "indexedLists"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/list/src/indexedListsTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op MAPi_def _ = () val op MAPi_def = TDB.find "MAPi_def"
  fun op MAPi_ACC_def _ = () val op MAPi_ACC_def = TDB.find "MAPi_ACC_def"
  fun op FOLDRi_def _ = () val op FOLDRi_def = TDB.find "FOLDRi_def"
  fun op findi_def _ = () val op findi_def = TDB.find "findi_def"
  fun op delN_def _ = () val op delN_def = TDB.find "delN_def"
  fun op LIST_RELi_def _ = ()
  val op LIST_RELi_def = TDB.find "LIST_RELi_def"
  fun op MAPi_ACC_MAPi _ = ()
  val op MAPi_ACC_MAPi = TDB.find "MAPi_ACC_MAPi"
  fun op MAPi_compute _ = () val op MAPi_compute = TDB.find "MAPi_compute"
  fun op LT_SUC _ = () val op LT_SUC = TDB.find "LT_SUC"
  fun op MEM_MAPi _ = () val op MEM_MAPi = TDB.find "MEM_MAPi"
  fun op MAPi_CONG _ = () val op MAPi_CONG = TDB.find "MAPi_CONG"
  fun op MAPi_CONG' _ = () val op MAPi_CONG' = TDB.find "MAPi_CONG'"
  fun op LENGTH_MAPi _ = () val op LENGTH_MAPi = TDB.find "LENGTH_MAPi"
  fun op MAP_MAPi _ = () val op MAP_MAPi = TDB.find "MAP_MAPi"
  fun op EL_MAPi _ = () val op EL_MAPi = TDB.find "EL_MAPi"
  fun op MAPi_APPEND _ = () val op MAPi_APPEND = TDB.find "MAPi_APPEND"
  fun op MAPi_GENLIST _ = () val op MAPi_GENLIST = TDB.find "MAPi_GENLIST"
  fun op GENLIST_CONG _ = () val op GENLIST_CONG = TDB.find "GENLIST_CONG"
  fun op FOLDR_MAPi _ = () val op FOLDR_MAPi = TDB.find "FOLDR_MAPi"
  fun op FOLDRi_APPEND _ = ()
  val op FOLDRi_APPEND = TDB.find "FOLDRi_APPEND"
  fun op FOLDRi_CONG _ = () val op FOLDRi_CONG = TDB.find "FOLDRi_CONG"
  fun op FOLDRi_CONG' _ = () val op FOLDRi_CONG' = TDB.find "FOLDRi_CONG'"
  fun op MEM_findi _ = () val op MEM_findi = TDB.find "MEM_findi"
  fun op findi_EL _ = () val op findi_EL = TDB.find "findi_EL"
  fun op EL_findi _ = () val op EL_findi = TDB.find "EL_findi"
  fun op delN_shortens _ = ()
  val op delN_shortens = TDB.find "delN_shortens"
  fun op EL_delN_BEFORE _ = ()
  val op EL_delN_BEFORE = TDB.find "EL_delN_BEFORE"
  fun op EL_delN_AFTER _ = ()
  val op EL_delN_AFTER = TDB.find "EL_delN_AFTER"
  fun op fupdLast_ind _ = () val op fupdLast_ind = TDB.find "fupdLast_ind"
  fun op fupdLast_def _ = () val op fupdLast_def = TDB.find "fupdLast_def"
  fun op fupdLast_EQ_NIL _ = ()
  val op fupdLast_EQ_NIL = TDB.find "fupdLast_EQ_NIL"
  fun op fupdLast_FRONT_LAST _ = ()
  val op fupdLast_FRONT_LAST = TDB.find "fupdLast_FRONT_LAST"
  fun op LIST_RELi_rules _ = ()
  val op LIST_RELi_rules = TDB.find "LIST_RELi_rules"
  fun op LIST_RELi_ind _ = ()
  val op LIST_RELi_ind = TDB.find "LIST_RELi_ind"
  fun op LIST_RELi_strongind _ = ()
  val op LIST_RELi_strongind = TDB.find "LIST_RELi_strongind"
  fun op LIST_RELi_cases _ = ()
  val op LIST_RELi_cases = TDB.find "LIST_RELi_cases"
  fun op LIST_RELi_LENGTH _ = ()
  val op LIST_RELi_LENGTH = TDB.find "LIST_RELi_LENGTH"
  fun op LIST_RELi_EL_EQN _ = ()
  val op LIST_RELi_EL_EQN = TDB.find "LIST_RELi_EL_EQN"
  fun op LIST_RELi_thm _ = ()
  val op LIST_RELi_thm = TDB.find "LIST_RELi_thm"
  fun op LIST_RELi_APPEND_I _ = ()
  val op LIST_RELi_APPEND_I = TDB.find "LIST_RELi_APPEND_I"
  fun op MAP2i_ind _ = () val op MAP2i_ind = TDB.find "MAP2i_ind"
  fun op MAP2i_def _ = () val op MAP2i_def = TDB.find "MAP2i_def"
  fun op MAP2i_NIL2 _ = () val op MAP2i_NIL2 = TDB.find "MAP2i_NIL2"
  fun op LENGTH_MAP2i _ = () val op LENGTH_MAP2i = TDB.find "LENGTH_MAP2i"
  fun op EL_MAP2i _ = () val op EL_MAP2i = TDB.find "EL_MAP2i"
  fun op MAP2ia_ind _ = () val op MAP2ia_ind = TDB.find "MAP2ia_ind"
  fun op MAP2ia_def _ = () val op MAP2ia_def = TDB.find "MAP2ia_def"
  fun op MAP2ia_NIL2 _ = () val op MAP2ia_NIL2 = TDB.find "MAP2ia_NIL2"
  fun op MAP2i_compute _ = ()
  val op MAP2i_compute = TDB.find "MAP2i_compute"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val indexedLists_grammars = merge_grammars ["rich_list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="indexedLists"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val indexedLists_grammars = 
    Portable.## (addtyUDs,addtmUDs) indexedLists_grammars
  val _ = Parse.grammarDB_insert("indexedLists",indexedLists_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "indexedLists"

end
