structure listRangeTheory :> listRangeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading listRangeTheory ... "
    else ()
  
  open Type Term Thm
  local open listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "listRange"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/list/src/listRangeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op listRangeINC_def _ = ()
  val op listRangeINC_def = TDB.find "listRangeINC_def"
  fun op listRangeLHI_def _ = ()
  val op listRangeLHI_def = TDB.find "listRangeLHI_def"
  fun op listRangeINC_SING _ = ()
  val op listRangeINC_SING = TDB.find "listRangeINC_SING"
  fun op MEM_listRangeINC _ = ()
  val op MEM_listRangeINC = TDB.find "MEM_listRangeINC"
  fun op listRangeINC_CONS _ = ()
  val op listRangeINC_CONS = TDB.find "listRangeINC_CONS"
  fun op listRangeINC_EMPTY _ = ()
  val op listRangeINC_EMPTY = TDB.find "listRangeINC_EMPTY"
  fun op listRangeLHI_EQ _ = ()
  val op listRangeLHI_EQ = TDB.find "listRangeLHI_EQ"
  fun op MEM_listRangeLHI _ = ()
  val op MEM_listRangeLHI = TDB.find "MEM_listRangeLHI"
  fun op listRangeLHI_EMPTY _ = ()
  val op listRangeLHI_EMPTY = TDB.find "listRangeLHI_EMPTY"
  fun op listRangeLHI_CONS _ = ()
  val op listRangeLHI_CONS = TDB.find "listRangeLHI_CONS"
  fun op listRangeLHI_ALL_DISTINCT _ = ()
  val op listRangeLHI_ALL_DISTINCT = TDB.find "listRangeLHI_ALL_DISTINCT"
  fun op LENGTH_listRangeLHI _ = ()
  val op LENGTH_listRangeLHI = TDB.find "LENGTH_listRangeLHI"
  fun op EL_listRangeLHI _ = ()
  val op EL_listRangeLHI = TDB.find "EL_listRangeLHI"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val listRange_grammars = merge_grammars ["list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="listRange"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val listRange_grammars = 
    Portable.## (addtyUDs,addtmUDs) listRange_grammars
  val _ = Parse.grammarDB_insert("listRange",listRange_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "listRange"

end
