structure listTheory :> listTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading listTheory ... "
    else ()
  
  open Type Term Thm
  local open ind_typeTheory pred_setTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "list"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/list/src/listTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op SUM_ACC_DEF _ = () val op SUM_ACC_DEF = TDB.find "SUM_ACC_DEF"
  fun op REV_DEF _ = () val op REV_DEF = TDB.find "REV_DEF"
  fun op LEN_DEF _ = () val op LEN_DEF = TDB.find "LEN_DEF"
  fun op PAD_RIGHT _ = () val op PAD_RIGHT = TDB.find "PAD_RIGHT"
  fun op PAD_LEFT _ = () val op PAD_LEFT = TDB.find "PAD_LEFT"
  fun op GENLIST_AUX _ = () val op GENLIST_AUX = TDB.find "GENLIST_AUX"
  fun op GENLIST _ = () val op GENLIST = TDB.find "GENLIST"
  fun op SNOC _ = () val op SNOC = TDB.find "SNOC"
  fun op isPREFIX _ = () val op isPREFIX = TDB.find "isPREFIX"
  fun op SET_TO_LIST_primitive_def _ = ()
  val op SET_TO_LIST_primitive_def = TDB.find "SET_TO_LIST_primitive_def"
  fun op LRC_def _ = () val op LRC_def = TDB.find "LRC_def"
  fun op ALL_DISTINCT _ = () val op ALL_DISTINCT = TDB.find "ALL_DISTINCT"
  fun op DROP_def _ = () val op DROP_def = TDB.find "DROP_def"
  fun op TAKE_def _ = () val op TAKE_def = TDB.find "TAKE_def"
  fun op FRONT_DEF _ = () val op FRONT_DEF = TDB.find "FRONT_DEF"
  fun op LAST_DEF _ = () val op LAST_DEF = TDB.find "LAST_DEF"
  fun op REVERSE_DEF _ = () val op REVERSE_DEF = TDB.find "REVERSE_DEF"
  fun op UNZIP _ = () val op UNZIP = TDB.find "UNZIP"
  fun op ZIP_def _ = () val op ZIP_def = TDB.find "ZIP_def"
  fun op list_size_def _ = ()
  val op list_size_def = TDB.find "list_size_def"
  fun op list_case_def _ = ()
  val op list_case_def = TDB.find "list_case_def"
  fun op list_TY_DEF _ = () val op list_TY_DEF = TDB.find "list_TY_DEF"
  fun op NULL_DEF _ = () val op NULL_DEF = TDB.find "NULL_DEF"
  fun op HD _ = () val op HD = TDB.find "HD"
  fun op TL_DEF _ = () val op TL_DEF = TDB.find "TL_DEF"
  fun op SUM _ = () val op SUM = TDB.find "SUM"
  fun op APPEND _ = () val op APPEND = TDB.find "APPEND"
  fun op FLAT _ = () val op FLAT = TDB.find "FLAT"
  fun op LENGTH _ = () val op LENGTH = TDB.find "LENGTH"
  fun op MAP _ = () val op MAP = TDB.find "MAP"
  fun op LIST_TO_SET_DEF _ = ()
  val op LIST_TO_SET_DEF = TDB.find "LIST_TO_SET_DEF"
  fun op FILTER _ = () val op FILTER = TDB.find "FILTER"
  fun op FOLDR _ = () val op FOLDR = TDB.find "FOLDR"
  fun op FOLDL _ = () val op FOLDL = TDB.find "FOLDL"
  fun op EVERY_DEF _ = () val op EVERY_DEF = TDB.find "EVERY_DEF"
  fun op EXISTS_DEF _ = () val op EXISTS_DEF = TDB.find "EXISTS_DEF"
  fun op EL _ = () val op EL = TDB.find "EL"
  fun op INDEX_FIND_def _ = ()
  val op INDEX_FIND_def = TDB.find "INDEX_FIND_def"
  fun op FIND_def _ = () val op FIND_def = TDB.find "FIND_def"
  fun op INDEX_OF_def _ = () val op INDEX_OF_def = TDB.find "INDEX_OF_def"
  fun op LUPDATE_def _ = () val op LUPDATE_def = TDB.find "LUPDATE_def"
  fun op EVERYi_def _ = () val op EVERYi_def = TDB.find "EVERYi_def"
  fun op splitAtPki_def _ = ()
  val op splitAtPki_def = TDB.find "splitAtPki_def"
  fun op LIST_BIND_def _ = ()
  val op LIST_BIND_def = TDB.find "LIST_BIND_def"
  fun op LIST_IGNORE_BIND_def _ = ()
  val op LIST_IGNORE_BIND_def = TDB.find "LIST_IGNORE_BIND_def"
  fun op LIST_GUARD_def _ = ()
  val op LIST_GUARD_def = TDB.find "LIST_GUARD_def"
  fun op LIST_APPLY_def _ = ()
  val op LIST_APPLY_def = TDB.find "LIST_APPLY_def"
  fun op LIST_LIFT2_def _ = ()
  val op LIST_LIFT2_def = TDB.find "LIST_LIFT2_def"
  fun op SHORTLEX_def _ = () val op SHORTLEX_def = TDB.find "SHORTLEX_def"
  fun op LLEX_def _ = () val op LLEX_def = TDB.find "LLEX_def"
  fun op nub_def _ = () val op nub_def = TDB.find "nub_def"
  fun op dropWhile_def _ = ()
  val op dropWhile_def = TDB.find "dropWhile_def"
  fun op UNIQUE_DEF _ = () val op UNIQUE_DEF = TDB.find "UNIQUE_DEF"
  fun op OPT_MMAP_def _ = () val op OPT_MMAP_def = TDB.find "OPT_MMAP_def"
  fun op oHD_def _ = () val op oHD_def = TDB.find "oHD_def"
  fun op oEL_def _ = () val op oEL_def = TDB.find "oEL_def"
  fun op EXISTS_LIST _ = () val op EXISTS_LIST = TDB.find "EXISTS_LIST"
  fun op SUM_SUM_ACC _ = () val op SUM_SUM_ACC = TDB.find "SUM_SUM_ACC"
  fun op SUM_ACC_SUM_LEM _ = ()
  val op SUM_ACC_SUM_LEM = TDB.find "SUM_ACC_SUM_LEM"
  fun op REVERSE_REV _ = () val op REVERSE_REV = TDB.find "REVERSE_REV"
  fun op LENGTH_LEN _ = () val op LENGTH_LEN = TDB.find "LENGTH_LEN"
  fun op REV_REVERSE_LEM _ = ()
  val op REV_REVERSE_LEM = TDB.find "REV_REVERSE_LEM"
  fun op LEN_LENGTH_LEM _ = ()
  val op LEN_LENGTH_LEM = TDB.find "LEN_LENGTH_LEM"
  fun op INFINITE_LIST_UNIV _ = ()
  val op INFINITE_LIST_UNIV = TDB.find "INFINITE_LIST_UNIV"
  fun op MAP_ZIP_SAME _ = () val op MAP_ZIP_SAME = TDB.find "MAP_ZIP_SAME"
  fun op FOLDL_ZIP_SAME _ = ()
  val op FOLDL_ZIP_SAME = TDB.find "FOLDL_ZIP_SAME"
  fun op FOLDL_UNION_BIGUNION_paired _ = ()
  val op FOLDL_UNION_BIGUNION_paired = TDB.find
    "FOLDL_UNION_BIGUNION_paired"
  fun op FOLDL_UNION_BIGUNION _ = ()
  val op FOLDL_UNION_BIGUNION = TDB.find "FOLDL_UNION_BIGUNION"
  fun op REVERSE_GENLIST _ = ()
  val op REVERSE_GENLIST = TDB.find "REVERSE_GENLIST"
  fun op EL_REVERSE _ = () val op EL_REVERSE = TDB.find "EL_REVERSE"
  fun op SUM_IMAGE_eq_SUM_MAP_SET_TO_LIST _ = ()
  val op SUM_IMAGE_eq_SUM_MAP_SET_TO_LIST = TDB.find
    "SUM_IMAGE_eq_SUM_MAP_SET_TO_LIST"
  fun op SUM_MAP_FOLDL _ = ()
  val op SUM_MAP_FOLDL = TDB.find "SUM_MAP_FOLDL"
  fun op SUM_APPEND _ = () val op SUM_APPEND = TDB.find "SUM_APPEND"
  fun op SUM_SNOC _ = () val op SUM_SNOC = TDB.find "SUM_SNOC"
  fun op FOLDL_SNOC _ = () val op FOLDL_SNOC = TDB.find "FOLDL_SNOC"
  fun op LIST_REL_O _ = () val op LIST_REL_O = TDB.find "LIST_REL_O"
  fun op DROP_GENLIST _ = () val op DROP_GENLIST = TDB.find "DROP_GENLIST"
  fun op TAKE_GENLIST _ = () val op TAKE_GENLIST = TDB.find "TAKE_GENLIST"
  fun op ALL_DISTINCT_GENLIST _ = ()
  val op ALL_DISTINCT_GENLIST = TDB.find "ALL_DISTINCT_GENLIST"
  fun op ALL_DISTINCT_SNOC _ = ()
  val op ALL_DISTINCT_SNOC = TDB.find "ALL_DISTINCT_SNOC"
  fun op MEM_GENLIST _ = () val op MEM_GENLIST = TDB.find "MEM_GENLIST"
  fun op GENLIST_NUMERALS _ = ()
  val op GENLIST_NUMERALS = TDB.find "GENLIST_NUMERALS"
  fun op GENLIST_GENLIST_AUX _ = ()
  val op GENLIST_GENLIST_AUX = TDB.find "GENLIST_GENLIST_AUX"
  fun op NULL_GENLIST _ = () val op NULL_GENLIST = TDB.find "NULL_GENLIST"
  fun op GENLIST_ID _ = () val op GENLIST_ID = TDB.find "GENLIST_ID"
  fun op GENLIST_CONS _ = () val op GENLIST_CONS = TDB.find "GENLIST_CONS"
  fun op ZIP_GENLIST _ = () val op ZIP_GENLIST = TDB.find "ZIP_GENLIST"
  fun op TL_GENLIST _ = () val op TL_GENLIST = TDB.find "TL_GENLIST"
  fun op EXISTS_GENLIST _ = ()
  val op EXISTS_GENLIST = TDB.find "EXISTS_GENLIST"
  fun op EVERY_GENLIST _ = ()
  val op EVERY_GENLIST = TDB.find "EVERY_GENLIST"
  fun op GENLIST_APPEND _ = ()
  val op GENLIST_APPEND = TDB.find "GENLIST_APPEND"
  fun op GENLIST_FUN_EQ _ = ()
  val op GENLIST_FUN_EQ = TDB.find "GENLIST_FUN_EQ"
  fun op HD_GENLIST_COR _ = ()
  val op HD_GENLIST_COR = TDB.find "HD_GENLIST_COR"
  fun op HD_GENLIST _ = () val op HD_GENLIST = TDB.find "HD_GENLIST"
  fun op EL_GENLIST _ = () val op EL_GENLIST = TDB.find "EL_GENLIST"
  fun op MAP_GENLIST _ = () val op MAP_GENLIST = TDB.find "MAP_GENLIST"
  fun op GENLIST_AUX_compute _ = ()
  val op GENLIST_AUX_compute = TDB.find "GENLIST_AUX_compute"
  fun op LENGTH_GENLIST _ = ()
  val op LENGTH_GENLIST = TDB.find "LENGTH_GENLIST"
  fun op SNOC_CASES _ = () val op SNOC_CASES = TDB.find "SNOC_CASES"
  fun op SNOC_INDUCT _ = () val op SNOC_INDUCT = TDB.find "SNOC_INDUCT"
  fun op SNOC_Axiom _ = () val op SNOC_Axiom = TDB.find "SNOC_Axiom"
  fun op REVERSE_SNOC _ = () val op REVERSE_SNOC = TDB.find "REVERSE_SNOC"
  fun op REVERSE_SNOC_DEF _ = ()
  val op REVERSE_SNOC_DEF = TDB.find "REVERSE_SNOC_DEF"
  fun op SNOC_11 _ = () val op SNOC_11 = TDB.find "SNOC_11"
  fun op MEM_SNOC _ = () val op MEM_SNOC = TDB.find "MEM_SNOC"
  fun op EXISTS_SNOC _ = () val op EXISTS_SNOC = TDB.find "EXISTS_SNOC"
  fun op EVERY_SNOC _ = () val op EVERY_SNOC = TDB.find "EVERY_SNOC"
  fun op APPEND_SNOC _ = () val op APPEND_SNOC = TDB.find "APPEND_SNOC"
  fun op EL_LENGTH_SNOC _ = ()
  val op EL_LENGTH_SNOC = TDB.find "EL_LENGTH_SNOC"
  fun op EL_SNOC _ = () val op EL_SNOC = TDB.find "EL_SNOC"
  fun op MAP_SNOC _ = () val op MAP_SNOC = TDB.find "MAP_SNOC"
  fun op LIST_TO_SET_SNOC _ = ()
  val op LIST_TO_SET_SNOC = TDB.find "LIST_TO_SET_SNOC"
  fun op SNOC_APPEND _ = () val op SNOC_APPEND = TDB.find "SNOC_APPEND"
  fun op FRONT_SNOC _ = () val op FRONT_SNOC = TDB.find "FRONT_SNOC"
  fun op LAST_SNOC _ = () val op LAST_SNOC = TDB.find "LAST_SNOC"
  fun op LENGTH_SNOC _ = () val op LENGTH_SNOC = TDB.find "LENGTH_SNOC"
  fun op isPREFIX_CONSR _ = ()
  val op isPREFIX_CONSR = TDB.find "isPREFIX_CONSR"
  fun op isPREFIX_NILR _ = ()
  val op isPREFIX_NILR = TDB.find "isPREFIX_NILR"
  fun op isPREFIX_THM _ = () val op isPREFIX_THM = TDB.find "isPREFIX_THM"
  fun op ITSET_eq_FOLDL_SET_TO_LIST _ = ()
  val op ITSET_eq_FOLDL_SET_TO_LIST = TDB.find "ITSET_eq_FOLDL_SET_TO_LIST"
  fun op ALL_DISTINCT_SET_TO_LIST _ = ()
  val op ALL_DISTINCT_SET_TO_LIST = TDB.find "ALL_DISTINCT_SET_TO_LIST"
  fun op SET_TO_LIST_SING _ = ()
  val op SET_TO_LIST_SING = TDB.find "SET_TO_LIST_SING"
  fun op MEM_SET_TO_LIST _ = ()
  val op MEM_SET_TO_LIST = TDB.find "MEM_SET_TO_LIST"
  fun op SET_TO_LIST_IN_MEM _ = ()
  val op SET_TO_LIST_IN_MEM = TDB.find "SET_TO_LIST_IN_MEM"
  fun op SET_TO_LIST_CARD _ = ()
  val op SET_TO_LIST_CARD = TDB.find "SET_TO_LIST_CARD"
  fun op SET_TO_LIST_INV _ = ()
  val op SET_TO_LIST_INV = TDB.find "SET_TO_LIST_INV"
  fun op SET_TO_LIST_EMPTY _ = ()
  val op SET_TO_LIST_EMPTY = TDB.find "SET_TO_LIST_EMPTY"
  fun op SET_TO_LIST_IND _ = ()
  val op SET_TO_LIST_IND = TDB.find "SET_TO_LIST_IND"
  fun op SET_TO_LIST_THM _ = ()
  val op SET_TO_LIST_THM = TDB.find "SET_TO_LIST_THM"
  fun op LIST_TO_SET_FILTER _ = ()
  val op LIST_TO_SET_FILTER = TDB.find "LIST_TO_SET_FILTER"
  fun op LIST_TO_SET_MAP _ = ()
  val op LIST_TO_SET_MAP = TDB.find "LIST_TO_SET_MAP"
  fun op LIST_TO_SET_THM _ = ()
  val op LIST_TO_SET_THM = TDB.find "LIST_TO_SET_THM"
  fun op LIST_TO_SET_REVERSE _ = ()
  val op LIST_TO_SET_REVERSE = TDB.find "LIST_TO_SET_REVERSE"
  fun op CARD_LIST_TO_SET_ALL_DISTINCT _ = ()
  val op CARD_LIST_TO_SET_ALL_DISTINCT = TDB.find
    "CARD_LIST_TO_SET_ALL_DISTINCT"
  fun op ALL_DISTINCT_CARD_LIST_TO_SET _ = ()
  val op ALL_DISTINCT_CARD_LIST_TO_SET = TDB.find
    "ALL_DISTINCT_CARD_LIST_TO_SET"
  fun op CARD_LIST_TO_SET _ = ()
  val op CARD_LIST_TO_SET = TDB.find "CARD_LIST_TO_SET"
  fun op INJ_MAP_EQ_IFF _ = ()
  val op INJ_MAP_EQ_IFF = TDB.find "INJ_MAP_EQ_IFF"
  fun op INJ_MAP_EQ _ = () val op INJ_MAP_EQ = TDB.find "INJ_MAP_EQ"
  fun op SUM_MAP_MEM_bound _ = ()
  val op SUM_MAP_MEM_bound = TDB.find "SUM_MAP_MEM_bound"
  fun op SUM_IMAGE_LIST_TO_SET_upper_bound _ = ()
  val op SUM_IMAGE_LIST_TO_SET_upper_bound = TDB.find
    "SUM_IMAGE_LIST_TO_SET_upper_bound"
  fun op FINITE_LIST_TO_SET _ = ()
  val op FINITE_LIST_TO_SET = TDB.find "FINITE_LIST_TO_SET"
  fun op LIST_TO_SET_EQ_EMPTY _ = ()
  val op LIST_TO_SET_EQ_EMPTY = TDB.find "LIST_TO_SET_EQ_EMPTY"
  fun op UNION_APPEND _ = () val op UNION_APPEND = TDB.find "UNION_APPEND"
  fun op LIST_TO_SET_APPEND _ = ()
  val op LIST_TO_SET_APPEND = TDB.find "LIST_TO_SET_APPEND"
  fun op LRC_MEM_right _ = ()
  val op LRC_MEM_right = TDB.find "LRC_MEM_right"
  fun op LRC_MEM _ = () val op LRC_MEM = TDB.find "LRC_MEM"
  fun op NRC_LRC _ = () val op NRC_LRC = TDB.find "NRC_LRC"
  fun op ALL_DISTINCT_FLAT_REVERSE _ = ()
  val op ALL_DISTINCT_FLAT_REVERSE = TDB.find "ALL_DISTINCT_FLAT_REVERSE"
  fun op ALL_DISTINCT_REVERSE _ = ()
  val op ALL_DISTINCT_REVERSE = TDB.find "ALL_DISTINCT_REVERSE"
  fun op ALL_DISTINCT_ZIP_SWAP _ = ()
  val op ALL_DISTINCT_ZIP_SWAP = TDB.find "ALL_DISTINCT_ZIP_SWAP"
  fun op ALL_DISTINCT_ZIP _ = ()
  val op ALL_DISTINCT_ZIP = TDB.find "ALL_DISTINCT_ZIP"
  fun op ALL_DISTINCT_SING _ = ()
  val op ALL_DISTINCT_SING = TDB.find "ALL_DISTINCT_SING"
  fun op ALL_DISTINCT_APPEND _ = ()
  val op ALL_DISTINCT_APPEND = TDB.find "ALL_DISTINCT_APPEND"
  fun op ALL_DISTINCT_EL_IMP _ = ()
  val op ALL_DISTINCT_EL_IMP = TDB.find "ALL_DISTINCT_EL_IMP"
  fun op EL_ALL_DISTINCT_EL_EQ _ = ()
  val op EL_ALL_DISTINCT_EL_EQ = TDB.find "EL_ALL_DISTINCT_EL_EQ"
  fun op ALL_DISTINCT_MAP _ = ()
  val op ALL_DISTINCT_MAP = TDB.find "ALL_DISTINCT_MAP"
  fun op FILTER_ALL_DISTINCT _ = ()
  val op FILTER_ALL_DISTINCT = TDB.find "FILTER_ALL_DISTINCT"
  fun op ALL_DISTINCT_FILTER _ = ()
  val op ALL_DISTINCT_FILTER = TDB.find "ALL_DISTINCT_FILTER"
  fun op EVERY2_mono _ = () val op EVERY2_mono = TDB.find "EVERY2_mono"
  fun op EVERY2_LENGTH _ = ()
  val op EVERY2_LENGTH = TDB.find "EVERY2_LENGTH"
  fun op EVERY2_EVERY _ = () val op EVERY2_EVERY = TDB.find "EVERY2_EVERY"
  fun op MAP_EQ_EVERY2 _ = ()
  val op MAP_EQ_EVERY2 = TDB.find "MAP_EQ_EVERY2"
  fun op EVERY2_cong _ = () val op EVERY2_cong = TDB.find "EVERY2_cong"
  fun op FOLDL2_FOLDL _ = () val op FOLDL2_FOLDL = TDB.find "FOLDL2_FOLDL"
  fun op FOLDL2_cong _ = () val op FOLDL2_cong = TDB.find "FOLDL2_cong"
  fun op FOLDL2_def _ = () val op FOLDL2_def = TDB.find "FOLDL2_def"
  fun op FOLDL2_ind _ = () val op FOLDL2_ind = TDB.find "FOLDL2_ind"
  fun op MAP_FRONT _ = () val op MAP_FRONT = TDB.find "MAP_FRONT"
  fun op MAP_DROP _ = () val op MAP_DROP = TDB.find "MAP_DROP"
  fun op EL_DROP _ = () val op EL_DROP = TDB.find "EL_DROP"
  fun op HD_DROP _ = () val op HD_DROP = TDB.find "HD_DROP"
  fun op DROP_NIL _ = () val op DROP_NIL = TDB.find "DROP_NIL"
  fun op MEM_DROP _ = () val op MEM_DROP = TDB.find "MEM_DROP"
  fun op DROP_LENGTH_TOO_LONG _ = ()
  val op DROP_LENGTH_TOO_LONG = TDB.find "DROP_LENGTH_TOO_LONG"
  fun op LENGTH_DROP _ = () val op LENGTH_DROP = TDB.find "LENGTH_DROP"
  fun op TAKE_TAKE_MIN _ = ()
  val op TAKE_TAKE_MIN = TDB.find "TAKE_TAKE_MIN"
  fun op TAKE_EQ_NIL _ = () val op TAKE_EQ_NIL = TDB.find "TAKE_EQ_NIL"
  fun op TAKE1_DROP _ = () val op TAKE1_DROP = TDB.find "TAKE1_DROP"
  fun op TAKE1 _ = () val op TAKE1 = TDB.find "TAKE1"
  fun op TAKE_DROP _ = () val op TAKE_DROP = TDB.find "TAKE_DROP"
  fun op DROP_0 _ = () val op DROP_0 = TDB.find "DROP_0"
  fun op TAKE_APPEND2 _ = () val op TAKE_APPEND2 = TDB.find "TAKE_APPEND2"
  fun op TAKE_APPEND1 _ = () val op TAKE_APPEND1 = TDB.find "TAKE_APPEND1"
  fun op MAP_TAKE _ = () val op MAP_TAKE = TDB.find "MAP_TAKE"
  fun op EL_TAKE _ = () val op EL_TAKE = TDB.find "EL_TAKE"
  fun op LENGTH_TAKE_EQ _ = ()
  val op LENGTH_TAKE_EQ = TDB.find "LENGTH_TAKE_EQ"
  fun op TAKE_LENGTH_TOO_LONG _ = ()
  val op TAKE_LENGTH_TOO_LONG = TDB.find "TAKE_LENGTH_TOO_LONG"
  fun op LENGTH_TAKE _ = () val op LENGTH_TAKE = TDB.find "LENGTH_TAKE"
  fun op TAKE_LENGTH_ID _ = ()
  val op TAKE_LENGTH_ID = TDB.find "TAKE_LENGTH_ID"
  fun op TAKE_0 _ = () val op TAKE_0 = TDB.find "TAKE_0"
  fun op DROP_cons _ = () val op DROP_cons = TDB.find "DROP_cons"
  fun op DROP_nil _ = () val op DROP_nil = TDB.find "DROP_nil"
  fun op TAKE_cons _ = () val op TAKE_cons = TDB.find "TAKE_cons"
  fun op TAKE_nil _ = () val op TAKE_nil = TDB.find "TAKE_nil"
  fun op LAST_APPEND_CONS _ = ()
  val op LAST_APPEND_CONS = TDB.find "LAST_APPEND_CONS"
  fun op LAST_CONS_cond _ = ()
  val op LAST_CONS_cond = TDB.find "LAST_CONS_cond"
  fun op APPEND_FRONT_LAST _ = ()
  val op APPEND_FRONT_LAST = TDB.find "APPEND_FRONT_LAST"
  fun op FRONT_CONS_EQ_NIL _ = ()
  val op FRONT_CONS_EQ_NIL = TDB.find "FRONT_CONS_EQ_NIL"
  fun op LENGTH_FRONT_CONS _ = ()
  val op LENGTH_FRONT_CONS = TDB.find "LENGTH_FRONT_CONS"
  fun op FRONT_CONS _ = () val op FRONT_CONS = TDB.find "FRONT_CONS"
  fun op LAST_MAP _ = () val op LAST_MAP = TDB.find "LAST_MAP"
  fun op LAST_EL _ = () val op LAST_EL = TDB.find "LAST_EL"
  fun op LAST_CONS _ = () val op LAST_CONS = TDB.find "LAST_CONS"
  fun op FILTER_REVERSE _ = ()
  val op FILTER_REVERSE = TDB.find "FILTER_REVERSE"
  fun op REVERSE_EQ_SING _ = ()
  val op REVERSE_EQ_SING = TDB.find "REVERSE_EQ_SING"
  fun op REVERSE_EQ_NIL _ = ()
  val op REVERSE_EQ_NIL = TDB.find "REVERSE_EQ_NIL"
  fun op LENGTH_REVERSE _ = ()
  val op LENGTH_REVERSE = TDB.find "LENGTH_REVERSE"
  fun op MEM_REVERSE _ = () val op MEM_REVERSE = TDB.find "MEM_REVERSE"
  fun op REVERSE_11 _ = () val op REVERSE_11 = TDB.find "REVERSE_11"
  fun op REVERSE_REVERSE _ = ()
  val op REVERSE_REVERSE = TDB.find "REVERSE_REVERSE"
  fun op REVERSE_APPEND _ = ()
  val op REVERSE_APPEND = TDB.find "REVERSE_APPEND"
  fun op LIST_REL_EVERY_ZIP _ = ()
  val op LIST_REL_EVERY_ZIP = TDB.find "LIST_REL_EVERY_ZIP"
  fun op SUM_MAP_PLUS_ZIP _ = ()
  val op SUM_MAP_PLUS_ZIP = TDB.find "SUM_MAP_PLUS_ZIP"
  fun op MEM_EL _ = () val op MEM_EL = TDB.find "MEM_EL"
  fun op MAP_ZIP _ = () val op MAP_ZIP = TDB.find "MAP_ZIP"
  fun op MAP2_MAP _ = () val op MAP2_MAP = TDB.find "MAP2_MAP"
  fun op MAP2_ZIP _ = () val op MAP2_ZIP = TDB.find "MAP2_ZIP"
  fun op EL_ZIP _ = () val op EL_ZIP = TDB.find "EL_ZIP"
  fun op MEM_ZIP _ = () val op MEM_ZIP = TDB.find "MEM_ZIP"
  fun op ZIP_MAP _ = () val op ZIP_MAP = TDB.find "ZIP_MAP"
  fun op UNZIP_ZIP _ = () val op UNZIP_ZIP = TDB.find "UNZIP_ZIP"
  fun op ZIP_UNZIP _ = () val op ZIP_UNZIP = TDB.find "ZIP_UNZIP"
  fun op LENGTH_UNZIP _ = () val op LENGTH_UNZIP = TDB.find "LENGTH_UNZIP"
  fun op LENGTH_ZIP_MIN _ = ()
  val op LENGTH_ZIP_MIN = TDB.find "LENGTH_ZIP_MIN"
  fun op LENGTH_ZIP _ = () val op LENGTH_ZIP = TDB.find "LENGTH_ZIP"
  fun op UNZIP_MAP _ = () val op UNZIP_MAP = TDB.find "UNZIP_MAP"
  fun op UNZIP_THM _ = () val op UNZIP_THM = TDB.find "UNZIP_THM"
  fun op ZIP _ = () val op ZIP = TDB.find "ZIP"
  fun op EVERY_MONOTONIC _ = ()
  val op EVERY_MONOTONIC = TDB.find "EVERY_MONOTONIC"
  fun op EVERY_CONG _ = () val op EVERY_CONG = TDB.find "EVERY_CONG"
  fun op EXISTS_CONG _ = () val op EXISTS_CONG = TDB.find "EXISTS_CONG"
  fun op MAP2_CONG _ = () val op MAP2_CONG = TDB.find "MAP2_CONG"
  fun op MAP_CONG _ = () val op MAP_CONG = TDB.find "MAP_CONG"
  fun op FOLDL_CONG _ = () val op FOLDL_CONG = TDB.find "FOLDL_CONG"
  fun op FOLDR_CONG _ = () val op FOLDR_CONG = TDB.find "FOLDR_CONG"
  fun op list_size_cong _ = ()
  val op list_size_cong = TDB.find "list_size_cong"
  fun op LIST_REL_SPLIT2 _ = ()
  val op LIST_REL_SPLIT2 = TDB.find "LIST_REL_SPLIT2"
  fun op LIST_REL_SPLIT1 _ = ()
  val op LIST_REL_SPLIT1 = TDB.find "LIST_REL_SPLIT1"
  fun op LIST_REL_LENGTH _ = ()
  val op LIST_REL_LENGTH = TDB.find "LIST_REL_LENGTH"
  fun op LIST_REL_MAP2 _ = ()
  val op LIST_REL_MAP2 = TDB.find "LIST_REL_MAP2"
  fun op LIST_REL_MAP1 _ = ()
  val op LIST_REL_MAP1 = TDB.find "LIST_REL_MAP1"
  fun op LIST_REL_CONJ _ = ()
  val op LIST_REL_CONJ = TDB.find "LIST_REL_CONJ"
  fun op LIST_REL_CONS2 _ = ()
  val op LIST_REL_CONS2 = TDB.find "LIST_REL_CONS2"
  fun op LIST_REL_CONS1 _ = ()
  val op LIST_REL_CONS1 = TDB.find "LIST_REL_CONS1"
  fun op LIST_REL_NIL _ = () val op LIST_REL_NIL = TDB.find "LIST_REL_NIL"
  fun op LIST_REL_mono _ = ()
  val op LIST_REL_mono = TDB.find "LIST_REL_mono"
  fun op LIST_REL_def _ = () val op LIST_REL_def = TDB.find "LIST_REL_def"
  fun op WF_LIST_PRED _ = () val op WF_LIST_PRED = TDB.find "WF_LIST_PRED"
  fun op NULL_FILTER _ = () val op NULL_FILTER = TDB.find "NULL_FILTER"
  fun op SUM_eq_0 _ = () val op SUM_eq_0 = TDB.find "SUM_eq_0"
  fun op EL_simp_restricted _ = ()
  val op EL_simp_restricted = TDB.find "EL_simp_restricted"
  fun op EL_restricted _ = ()
  val op EL_restricted = TDB.find "EL_restricted"
  fun op EL_simp _ = () val op EL_simp = TDB.find "EL_simp"
  fun op EL_compute _ = () val op EL_compute = TDB.find "EL_compute"
  fun op NOT_NULL_MEM _ = () val op NOT_NULL_MEM = TDB.find "NOT_NULL_MEM"
  fun op FILTER_COND_REWRITE _ = ()
  val op FILTER_COND_REWRITE = TDB.find "FILTER_COND_REWRITE"
  fun op EVERY_FILTER_IMP _ = ()
  val op EVERY_FILTER_IMP = TDB.find "EVERY_FILTER_IMP"
  fun op EVERY_FILTER _ = () val op EVERY_FILTER = TDB.find "EVERY_FILTER"
  fun op FILTER_EQ_APPEND _ = ()
  val op FILTER_EQ_APPEND = TDB.find "FILTER_EQ_APPEND"
  fun op MEM _ = () val op MEM = TDB.find "MEM"
  fun op FILTER_APPEND_DISTRIB _ = ()
  val op FILTER_APPEND_DISTRIB = TDB.find "FILTER_APPEND_DISTRIB"
  fun op FILTER_T _ = () val op FILTER_T = TDB.find "FILTER_T"
  fun op FILTER_F _ = () val op FILTER_F = TDB.find "FILTER_F"
  fun op FILTER_EQ_CONS _ = ()
  val op FILTER_EQ_CONS = TDB.find "FILTER_EQ_CONS"
  fun op FILTER_NEQ_ID _ = ()
  val op FILTER_NEQ_ID = TDB.find "FILTER_NEQ_ID"
  fun op FILTER_EQ_ID _ = () val op FILTER_EQ_ID = TDB.find "FILTER_EQ_ID"
  fun op FILTER_NEQ_NIL _ = ()
  val op FILTER_NEQ_NIL = TDB.find "FILTER_NEQ_NIL"
  fun op FILTER_EQ_NIL _ = ()
  val op FILTER_EQ_NIL = TDB.find "FILTER_EQ_NIL"
  fun op LENGTH_TL _ = () val op LENGTH_TL = TDB.find "LENGTH_TL"
  fun op FOLDR_CONS _ = () val op FOLDR_CONS = TDB.find "FOLDR_CONS"
  fun op FOLDL_EQ_FOLDR _ = ()
  val op FOLDL_EQ_FOLDR = TDB.find "FOLDL_EQ_FOLDR"
  fun op LIST_EQ _ = () val op LIST_EQ = TDB.find "LIST_EQ"
  fun op LIST_EQ_REWRITE _ = ()
  val op LIST_EQ_REWRITE = TDB.find "LIST_EQ_REWRITE"
  fun op MEM_SPLIT _ = () val op MEM_SPLIT = TDB.find "MEM_SPLIT"
  fun op APPEND_EQ_SELF _ = ()
  val op APPEND_EQ_SELF = TDB.find "APPEND_EQ_SELF"
  fun op APPEND_11_LENGTH _ = ()
  val op APPEND_11_LENGTH = TDB.find "APPEND_11_LENGTH"
  fun op APPEND_LENGTH_EQ _ = ()
  val op APPEND_LENGTH_EQ = TDB.find "APPEND_LENGTH_EQ"
  fun op APPEND_11 _ = () val op APPEND_11 = TDB.find "APPEND_11"
  fun op APPEND_EQ_SING _ = ()
  val op APPEND_EQ_SING = TDB.find "APPEND_EQ_SING"
  fun op MAP_EQ_APPEND _ = ()
  val op MAP_EQ_APPEND = TDB.find "MAP_EQ_APPEND"
  fun op NULL_APPEND _ = () val op NULL_APPEND = TDB.find "NULL_APPEND"
  fun op APPEND_eq_NIL _ = ()
  val op APPEND_eq_NIL = TDB.find "APPEND_eq_NIL"
  fun op CONS_ACYCLIC _ = () val op CONS_ACYCLIC = TDB.find "CONS_ACYCLIC"
  fun op LENGTH_EQ_NIL _ = ()
  val op LENGTH_EQ_NIL = TDB.find "LENGTH_EQ_NIL"
  fun op LENGTH_EQ_NUM_compute _ = ()
  val op LENGTH_EQ_NUM_compute = TDB.find "LENGTH_EQ_NUM_compute"
  fun op LENGTH_EQ_NUM _ = ()
  val op LENGTH_EQ_NUM = TDB.find "LENGTH_EQ_NUM"
  fun op LENGTH_EQ_SUM _ = ()
  val op LENGTH_EQ_SUM = TDB.find "LENGTH_EQ_SUM"
  fun op LENGTH_EQ_CONS _ = ()
  val op LENGTH_EQ_CONS = TDB.find "LENGTH_EQ_CONS"
  fun op LENGTH_CONS _ = () val op LENGTH_CONS = TDB.find "LENGTH_CONS"
  fun op NULL_LENGTH _ = () val op NULL_LENGTH = TDB.find "NULL_LENGTH"
  fun op NULL_EQ _ = () val op NULL_EQ = TDB.find "NULL_EQ"
  fun op SING_HD _ = () val op SING_HD = TDB.find "SING_HD"
  fun op LENGTH_NIL_SYM _ = ()
  val op LENGTH_NIL_SYM = TDB.find "LENGTH_NIL_SYM"
  fun op LENGTH_NIL _ = () val op LENGTH_NIL = TDB.find "LENGTH_NIL"
  fun op MEM_MAP _ = () val op MEM_MAP = TDB.find "MEM_MAP"
  fun op NOT_EXISTS _ = () val op NOT_EXISTS = TDB.find "NOT_EXISTS"
  fun op NOT_EVERY _ = () val op NOT_EVERY = TDB.find "NOT_EVERY"
  fun op EXISTS_APPEND _ = ()
  val op EXISTS_APPEND = TDB.find "EXISTS_APPEND"
  fun op EVERY_APPEND _ = () val op EVERY_APPEND = TDB.find "EVERY_APPEND"
  fun op EVERY_FLAT _ = () val op EVERY_FLAT = TDB.find "EVERY_FLAT"
  fun op FLAT_compute _ = () val op FLAT_compute = TDB.find "FLAT_compute"
  fun op FLAT_APPEND _ = () val op FLAT_APPEND = TDB.find "FLAT_APPEND"
  fun op MEM_FLAT _ = () val op MEM_FLAT = TDB.find "MEM_FLAT"
  fun op MEM_FILTER _ = () val op MEM_FILTER = TDB.find "MEM_FILTER"
  fun op MEM_APPEND _ = () val op MEM_APPEND = TDB.find "MEM_APPEND"
  fun op EXISTS_NOT_EVERY _ = ()
  val op EXISTS_NOT_EVERY = TDB.find "EXISTS_NOT_EVERY"
  fun op EVERY_NOT_EXISTS _ = ()
  val op EVERY_NOT_EXISTS = TDB.find "EVERY_NOT_EXISTS"
  fun op MONO_EXISTS _ = () val op MONO_EXISTS = TDB.find "MONO_EXISTS"
  fun op EXISTS_SIMP _ = () val op EXISTS_SIMP = TDB.find "EXISTS_SIMP"
  fun op EXISTS_MAP _ = () val op EXISTS_MAP = TDB.find "EXISTS_MAP"
  fun op EXISTS_MEM _ = () val op EXISTS_MEM = TDB.find "EXISTS_MEM"
  fun op MONO_EVERY _ = () val op MONO_EVERY = TDB.find "MONO_EVERY"
  fun op EVERY_SIMP _ = () val op EVERY_SIMP = TDB.find "EVERY_SIMP"
  fun op EVERY_MAP _ = () val op EVERY_MAP = TDB.find "EVERY_MAP"
  fun op EVERY_MEM _ = () val op EVERY_MEM = TDB.find "EVERY_MEM"
  fun op EVERY_CONJ _ = () val op EVERY_CONJ = TDB.find "EVERY_CONJ"
  fun op EVERY_EL _ = () val op EVERY_EL = TDB.find "EVERY_EL"
  fun op MAP_TL _ = () val op MAP_TL = TDB.find "MAP_TL"
  fun op EL_APPEND_EQN _ = ()
  val op EL_APPEND_EQN = TDB.find "EL_APPEND_EQN"
  fun op EL_MAP _ = () val op EL_MAP = TDB.find "EL_MAP"
  fun op MAP_MAP_o _ = () val op MAP_MAP_o = TDB.find "MAP_MAP_o"
  fun op MAP_o _ = () val op MAP_o = TDB.find "MAP_o"
  fun op MAP_EQ_f _ = () val op MAP_EQ_f = TDB.find "MAP_EQ_f"
  fun op MAP_EQ_SING _ = () val op MAP_EQ_SING = TDB.find "MAP_EQ_SING"
  fun op MAP_EQ_CONS _ = () val op MAP_EQ_CONS = TDB.find "MAP_EQ_CONS"
  fun op MAP_EQ_NIL _ = () val op MAP_EQ_NIL = TDB.find "MAP_EQ_NIL"
  fun op LENGTH_MAP _ = () val op LENGTH_MAP = TDB.find "LENGTH_MAP"
  fun op MAP_ID _ = () val op MAP_ID = TDB.find "MAP_ID"
  fun op MAP_APPEND _ = () val op MAP_APPEND = TDB.find "MAP_APPEND"
  fun op LENGTH_APPEND _ = ()
  val op LENGTH_APPEND = TDB.find "LENGTH_APPEND"
  fun op APPEND_ASSOC _ = () val op APPEND_ASSOC = TDB.find "APPEND_ASSOC"
  fun op APPEND_NIL _ = () val op APPEND_NIL = TDB.find "APPEND_NIL"
  fun op CONS _ = () val op CONS = TDB.find "CONS"
  fun op EQ_LIST _ = () val op EQ_LIST = TDB.find "EQ_LIST"
  fun op NOT_EQ_LIST _ = () val op NOT_EQ_LIST = TDB.find "NOT_EQ_LIST"
  fun op LIST_NOT_EQ _ = () val op LIST_NOT_EQ = TDB.find "LIST_NOT_EQ"
  fun op NOT_CONS_NIL _ = () val op NOT_CONS_NIL = TDB.find "NOT_CONS_NIL"
  fun op NOT_NIL_CONS _ = () val op NOT_NIL_CONS = TDB.find "NOT_NIL_CONS"
  fun op CONS_11 _ = () val op CONS_11 = TDB.find "CONS_11"
  fun op list_case_compute _ = ()
  val op list_case_compute = TDB.find "list_case_compute"
  fun op list_nchotomy _ = ()
  val op list_nchotomy = TDB.find "list_nchotomy"
  fun op list_distinct _ = ()
  val op list_distinct = TDB.find "list_distinct"
  fun op list_11 _ = () val op list_11 = TDB.find "list_11"
  fun op datatype_list _ = ()
  val op datatype_list = TDB.find "datatype_list"
  fun op list_case_cong _ = ()
  val op list_case_cong = TDB.find "list_case_cong"
  fun op list_case_eq _ = () val op list_case_eq = TDB.find "list_case_eq"
  fun op list_Axiom_old _ = ()
  val op list_Axiom_old = TDB.find "list_Axiom_old"
  fun op TL _ = () val op TL = TDB.find "TL"
  fun op LIST_TO_SET _ = () val op LIST_TO_SET = TDB.find "LIST_TO_SET"
  fun op MAP2_ind _ = () val op MAP2_ind = TDB.find "MAP2_ind"
  fun op MAP2_DEF _ = () val op MAP2_DEF = TDB.find "MAP2_DEF"
  fun op MAP2 _ = () val op MAP2 = TDB.find "MAP2"
  fun op MAP2_NIL _ = () val op MAP2_NIL = TDB.find "MAP2_NIL"
  fun op LENGTH_MAP2 _ = () val op LENGTH_MAP2 = TDB.find "LENGTH_MAP2"
  fun op EL_MAP2 _ = () val op EL_MAP2 = TDB.find "EL_MAP2"
  fun op MAP2_APPEND _ = () val op MAP2_APPEND = TDB.find "MAP2_APPEND"
  fun op NULL _ = () val op NULL = TDB.find "NULL"
  fun op list_INDUCT0 _ = () val op list_INDUCT0 = TDB.find "list_INDUCT0"
  fun op list_INDUCT _ = () val op list_INDUCT = TDB.find "list_INDUCT"
  fun op list_Axiom _ = () val op list_Axiom = TDB.find "list_Axiom"
  fun op list_induction _ = ()
  val op list_induction = TDB.find "list_induction"
  fun op LIST_REL_EL_EQN _ = ()
  val op LIST_REL_EL_EQN = TDB.find "LIST_REL_EL_EQN"
  fun op LIST_REL_cases _ = ()
  val op LIST_REL_cases = TDB.find "LIST_REL_cases"
  fun op LIST_REL_strongind _ = ()
  val op LIST_REL_strongind = TDB.find "LIST_REL_strongind"
  fun op LIST_REL_ind _ = () val op LIST_REL_ind = TDB.find "LIST_REL_ind"
  fun op LIST_REL_rules _ = ()
  val op LIST_REL_rules = TDB.find "LIST_REL_rules"
  fun op list_CASES _ = () val op list_CASES = TDB.find "list_CASES"
  fun op FORALL_LIST _ = () val op FORALL_LIST = TDB.find "FORALL_LIST"
  fun op MEM_SPLIT_APPEND_first _ = ()
  val op MEM_SPLIT_APPEND_first = TDB.find "MEM_SPLIT_APPEND_first"
  fun op MEM_SPLIT_APPEND_last _ = ()
  val op MEM_SPLIT_APPEND_last = TDB.find "MEM_SPLIT_APPEND_last"
  fun op APPEND_EQ_APPEND _ = ()
  val op APPEND_EQ_APPEND = TDB.find "APPEND_EQ_APPEND"
  fun op APPEND_EQ_CONS _ = ()
  val op APPEND_EQ_CONS = TDB.find "APPEND_EQ_CONS"
  fun op APPEND_EQ_APPEND_MID _ = ()
  val op APPEND_EQ_APPEND_MID = TDB.find "APPEND_EQ_APPEND_MID"
  fun op LUPDATE_NIL _ = () val op LUPDATE_NIL = TDB.find "LUPDATE_NIL"
  fun op LUPDATE_SEM _ = () val op LUPDATE_SEM = TDB.find "LUPDATE_SEM"
  fun op EL_LUPDATE _ = () val op EL_LUPDATE = TDB.find "EL_LUPDATE"
  fun op LENGTH_LUPDATE _ = ()
  val op LENGTH_LUPDATE = TDB.find "LENGTH_LUPDATE"
  fun op LUPDATE_LENGTH _ = ()
  val op LUPDATE_LENGTH = TDB.find "LUPDATE_LENGTH"
  fun op LUPDATE_SNOC _ = () val op LUPDATE_SNOC = TDB.find "LUPDATE_SNOC"
  fun op MEM_LUPDATE_E _ = ()
  val op MEM_LUPDATE_E = TDB.find "MEM_LUPDATE_E"
  fun op MEM_LUPDATE _ = () val op MEM_LUPDATE = TDB.find "MEM_LUPDATE"
  fun op LUPDATE_compute _ = ()
  val op LUPDATE_compute = TDB.find "LUPDATE_compute"
  fun op LUPDATE_MAP _ = () val op LUPDATE_MAP = TDB.find "LUPDATE_MAP"
  fun op splitAtPki_APPEND _ = ()
  val op splitAtPki_APPEND = TDB.find "splitAtPki_APPEND"
  fun op splitAtPki_EQN _ = ()
  val op splitAtPki_EQN = TDB.find "splitAtPki_EQN"
  fun op TAKE_splitAtPki _ = ()
  val op TAKE_splitAtPki = TDB.find "TAKE_splitAtPki"
  fun op DROP_splitAtPki _ = ()
  val op DROP_splitAtPki = TDB.find "DROP_splitAtPki"
  fun op splitAtPki_RAND _ = ()
  val op splitAtPki_RAND = TDB.find "splitAtPki_RAND"
  fun op splitAtPki_MAP _ = ()
  val op splitAtPki_MAP = TDB.find "splitAtPki_MAP"
  fun op splitAtPki_change_predicate _ = ()
  val op splitAtPki_change_predicate = TDB.find
    "splitAtPki_change_predicate"
  fun op LIST_BIND_THM _ = ()
  val op LIST_BIND_THM = TDB.find "LIST_BIND_THM"
  fun op LIST_BIND_ID _ = () val op LIST_BIND_ID = TDB.find "LIST_BIND_ID"
  fun op LIST_BIND_APPEND _ = ()
  val op LIST_BIND_APPEND = TDB.find "LIST_BIND_APPEND"
  fun op LIST_BIND_MAP _ = ()
  val op LIST_BIND_MAP = TDB.find "LIST_BIND_MAP"
  fun op MAP_LIST_BIND _ = ()
  val op MAP_LIST_BIND = TDB.find "MAP_LIST_BIND"
  fun op LIST_BIND_LIST_BIND _ = ()
  val op LIST_BIND_LIST_BIND = TDB.find "LIST_BIND_LIST_BIND"
  fun op SINGL_LIST_APPLY_L _ = ()
  val op SINGL_LIST_APPLY_L = TDB.find "SINGL_LIST_APPLY_L"
  fun op SINGL_LIST_APPLY_R _ = ()
  val op SINGL_LIST_APPLY_R = TDB.find "SINGL_LIST_APPLY_R"
  fun op SINGL_APPLY_MAP _ = ()
  val op SINGL_APPLY_MAP = TDB.find "SINGL_APPLY_MAP"
  fun op SINGL_SINGL_APPLY _ = ()
  val op SINGL_SINGL_APPLY = TDB.find "SINGL_SINGL_APPLY"
  fun op SINGL_APPLY_PERMUTE _ = ()
  val op SINGL_APPLY_PERMUTE = TDB.find "SINGL_APPLY_PERMUTE"
  fun op MAP_FLAT _ = () val op MAP_FLAT = TDB.find "MAP_FLAT"
  fun op LIST_APPLY_o _ = () val op LIST_APPLY_o = TDB.find "LIST_APPLY_o"
  fun op SHORTLEX_THM _ = () val op SHORTLEX_THM = TDB.find "SHORTLEX_THM"
  fun op SHORTLEX_MONO _ = ()
  val op SHORTLEX_MONO = TDB.find "SHORTLEX_MONO"
  fun op SHORTLEX_NIL2 _ = ()
  val op SHORTLEX_NIL2 = TDB.find "SHORTLEX_NIL2"
  fun op SHORTLEX_transitive _ = ()
  val op SHORTLEX_transitive = TDB.find "SHORTLEX_transitive"
  fun op LENGTH_LT_SHORTLEX _ = ()
  val op LENGTH_LT_SHORTLEX = TDB.find "LENGTH_LT_SHORTLEX"
  fun op SHORTLEX_LENGTH_LE _ = ()
  val op SHORTLEX_LENGTH_LE = TDB.find "SHORTLEX_LENGTH_LE"
  fun op SHORTLEX_total _ = ()
  val op SHORTLEX_total = TDB.find "SHORTLEX_total"
  fun op WF_SHORTLEX_same_lengths _ = ()
  val op WF_SHORTLEX_same_lengths = TDB.find "WF_SHORTLEX_same_lengths"
  fun op WF_SHORTLEX _ = () val op WF_SHORTLEX = TDB.find "WF_SHORTLEX"
  fun op LLEX_THM _ = () val op LLEX_THM = TDB.find "LLEX_THM"
  fun op LLEX_MONO _ = () val op LLEX_MONO = TDB.find "LLEX_MONO"
  fun op LLEX_CONG _ = () val op LLEX_CONG = TDB.find "LLEX_CONG"
  fun op LLEX_NIL2 _ = () val op LLEX_NIL2 = TDB.find "LLEX_NIL2"
  fun op LLEX_transitive _ = ()
  val op LLEX_transitive = TDB.find "LLEX_transitive"
  fun op LLEX_total _ = () val op LLEX_total = TDB.find "LLEX_total"
  fun op LLEX_not_WF _ = () val op LLEX_not_WF = TDB.find "LLEX_not_WF"
  fun op LLEX_EL_THM _ = () val op LLEX_EL_THM = TDB.find "LLEX_EL_THM"
  fun op nub_set _ = () val op nub_set = TDB.find "nub_set"
  fun op all_distinct_nub _ = ()
  val op all_distinct_nub = TDB.find "all_distinct_nub"
  fun op nub_append _ = () val op nub_append = TDB.find "nub_append"
  fun op list_to_set_diff _ = ()
  val op list_to_set_diff = TDB.find "list_to_set_diff"
  fun op length_nub_append _ = ()
  val op length_nub_append = TDB.find "length_nub_append"
  fun op ALL_DISTINCT_DROP _ = ()
  val op ALL_DISTINCT_DROP = TDB.find "ALL_DISTINCT_DROP"
  fun op EXISTS_LIST_EQ_MAP _ = ()
  val op EXISTS_LIST_EQ_MAP = TDB.find "EXISTS_LIST_EQ_MAP"
  fun op LIST_TO_SET_FLAT _ = ()
  val op LIST_TO_SET_FLAT = TDB.find "LIST_TO_SET_FLAT"
  fun op MEM_APPEND_lemma _ = ()
  val op MEM_APPEND_lemma = TDB.find "MEM_APPEND_lemma"
  fun op EVERY2_REVERSE _ = ()
  val op EVERY2_REVERSE = TDB.find "EVERY2_REVERSE"
  fun op SUM_MAP_PLUS _ = () val op SUM_MAP_PLUS = TDB.find "SUM_MAP_PLUS"
  fun op TAKE_LENGTH_ID_rwt _ = ()
  val op TAKE_LENGTH_ID_rwt = TDB.find "TAKE_LENGTH_ID_rwt"
  fun op ZIP_DROP _ = () val op ZIP_DROP = TDB.find "ZIP_DROP"
  fun op GENLIST_EL _ = () val op GENLIST_EL = TDB.find "GENLIST_EL"
  fun op EVERY2_trans _ = () val op EVERY2_trans = TDB.find "EVERY2_trans"
  fun op EVERY2_sym _ = () val op EVERY2_sym = TDB.find "EVERY2_sym"
  fun op EVERY2_LUPDATE_same _ = ()
  val op EVERY2_LUPDATE_same = TDB.find "EVERY2_LUPDATE_same"
  fun op EVERY2_refl _ = () val op EVERY2_refl = TDB.find "EVERY2_refl"
  fun op EVERY2_THM _ = () val op EVERY2_THM = TDB.find "EVERY2_THM"
  fun op LIST_REL_trans _ = ()
  val op LIST_REL_trans = TDB.find "LIST_REL_trans"
  fun op LIST_REL_eq _ = () val op LIST_REL_eq = TDB.find "LIST_REL_eq"
  fun op LIST_REL_MEM_IMP _ = ()
  val op LIST_REL_MEM_IMP = TDB.find "LIST_REL_MEM_IMP"
  fun op LIST_REL_SNOC _ = ()
  val op LIST_REL_SNOC = TDB.find "LIST_REL_SNOC"
  fun op LIST_REL_APPEND_IMP _ = ()
  val op LIST_REL_APPEND_IMP = TDB.find "LIST_REL_APPEND_IMP"
  fun op LIST_REL_APPEND _ = ()
  val op LIST_REL_APPEND = TDB.find "LIST_REL_APPEND"
  fun op LIST_REL_APPEND_suff _ = ()
  val op LIST_REL_APPEND_suff = TDB.find "LIST_REL_APPEND_suff"
  fun op LIST_REL_APPEND_EQ _ = ()
  val op LIST_REL_APPEND_EQ = TDB.find "LIST_REL_APPEND_EQ"
  fun op LIST_REL_MAP_inv_image _ = ()
  val op LIST_REL_MAP_inv_image = TDB.find "LIST_REL_MAP_inv_image"
  fun op SWAP_REVERSE _ = () val op SWAP_REVERSE = TDB.find "SWAP_REVERSE"
  fun op SWAP_REVERSE_SYM _ = ()
  val op SWAP_REVERSE_SYM = TDB.find "SWAP_REVERSE_SYM"
  fun op BIGUNION_IMAGE_set_SUBSET _ = ()
  val op BIGUNION_IMAGE_set_SUBSET = TDB.find "BIGUNION_IMAGE_set_SUBSET"
  fun op IMAGE_EL_count_LENGTH _ = ()
  val op IMAGE_EL_count_LENGTH = TDB.find "IMAGE_EL_count_LENGTH"
  fun op GENLIST_EL_MAP _ = ()
  val op GENLIST_EL_MAP = TDB.find "GENLIST_EL_MAP"
  fun op LENGTH_FILTER_LEQ_MONO _ = ()
  val op LENGTH_FILTER_LEQ_MONO = TDB.find "LENGTH_FILTER_LEQ_MONO"
  fun op LIST_EQ_MAP_PAIR _ = ()
  val op LIST_EQ_MAP_PAIR = TDB.find "LIST_EQ_MAP_PAIR"
  fun op TAKE_SUM _ = () val op TAKE_SUM = TDB.find "TAKE_SUM"
  fun op ALL_DISTINCT_FILTER_EL_IMP _ = ()
  val op ALL_DISTINCT_FILTER_EL_IMP = TDB.find "ALL_DISTINCT_FILTER_EL_IMP"
  fun op FLAT_EQ_NIL _ = () val op FLAT_EQ_NIL = TDB.find "FLAT_EQ_NIL"
  fun op ALL_DISTINCT_MAP_INJ _ = ()
  val op ALL_DISTINCT_MAP_INJ = TDB.find "ALL_DISTINCT_MAP_INJ"
  fun op LENGTH_o_REVERSE _ = ()
  val op LENGTH_o_REVERSE = TDB.find "LENGTH_o_REVERSE"
  fun op REVERSE_o_REVERSE _ = ()
  val op REVERSE_o_REVERSE = TDB.find "REVERSE_o_REVERSE"
  fun op GENLIST_PLUS_APPEND _ = ()
  val op GENLIST_PLUS_APPEND = TDB.find "GENLIST_PLUS_APPEND"
  fun op LIST_TO_SET_GENLIST _ = ()
  val op LIST_TO_SET_GENLIST = TDB.find "LIST_TO_SET_GENLIST"
  fun op MEM_ZIP_MEM_MAP _ = ()
  val op MEM_ZIP_MEM_MAP = TDB.find "MEM_ZIP_MEM_MAP"
  fun op DISJOINT_GENLIST_PLUS _ = ()
  val op DISJOINT_GENLIST_PLUS = TDB.find "DISJOINT_GENLIST_PLUS"
  fun op EVERY2_MAP _ = () val op EVERY2_MAP = TDB.find "EVERY2_MAP"
  fun op exists_list_GENLIST _ = ()
  val op exists_list_GENLIST = TDB.find "exists_list_GENLIST"
  fun op EVERY_MEM_MONO _ = ()
  val op EVERY_MEM_MONO = TDB.find "EVERY_MEM_MONO"
  fun op EVERY2_MEM_MONO _ = ()
  val op EVERY2_MEM_MONO = TDB.find "EVERY2_MEM_MONO"
  fun op mem_exists_set _ = ()
  val op mem_exists_set = TDB.find "mem_exists_set"
  fun op every_zip_snd _ = ()
  val op every_zip_snd = TDB.find "every_zip_snd"
  fun op every_zip_fst _ = ()
  val op every_zip_fst = TDB.find "every_zip_fst"
  fun op el_append3 _ = () val op el_append3 = TDB.find "el_append3"
  fun op lupdate_append _ = ()
  val op lupdate_append = TDB.find "lupdate_append"
  fun op lupdate_append2 _ = ()
  val op lupdate_append2 = TDB.find "lupdate_append2"
  fun op HD_REVERSE _ = () val op HD_REVERSE = TDB.find "HD_REVERSE"
  fun op LAST_REVERSE _ = () val op LAST_REVERSE = TDB.find "LAST_REVERSE"
  fun op NOT_NIL_EQ_LENGTH_NOT_0 _ = ()
  val op NOT_NIL_EQ_LENGTH_NOT_0 = TDB.find "NOT_NIL_EQ_LENGTH_NOT_0"
  fun op last_drop _ = () val op last_drop = TDB.find "last_drop"
  fun op dropWhile_splitAtPki _ = ()
  val op dropWhile_splitAtPki = TDB.find "dropWhile_splitAtPki"
  fun op dropWhile_eq_nil _ = ()
  val op dropWhile_eq_nil = TDB.find "dropWhile_eq_nil"
  fun op MEM_dropWhile_IMP _ = ()
  val op MEM_dropWhile_IMP = TDB.find "MEM_dropWhile_IMP"
  fun op HD_dropWhile _ = () val op HD_dropWhile = TDB.find "HD_dropWhile"
  fun op LENGTH_dropWhile_LESS_EQ _ = ()
  val op LENGTH_dropWhile_LESS_EQ = TDB.find "LENGTH_dropWhile_LESS_EQ"
  fun op dropWhile_APPEND_EVERY _ = ()
  val op dropWhile_APPEND_EVERY = TDB.find "dropWhile_APPEND_EVERY"
  fun op dropWhile_APPEND_EXISTS _ = ()
  val op dropWhile_APPEND_EXISTS = TDB.find "dropWhile_APPEND_EXISTS"
  fun op EL_LENGTH_dropWhile_REVERSE _ = ()
  val op EL_LENGTH_dropWhile_REVERSE = TDB.find
    "EL_LENGTH_dropWhile_REVERSE"
  fun op IMP_EVERY_LUPDATE _ = ()
  val op IMP_EVERY_LUPDATE = TDB.find "IMP_EVERY_LUPDATE"
  fun op MAP_APPEND_MAP_EQ _ = ()
  val op MAP_APPEND_MAP_EQ = TDB.find "MAP_APPEND_MAP_EQ"
  fun op LUPDATE_SOME_MAP _ = ()
  val op LUPDATE_SOME_MAP = TDB.find "LUPDATE_SOME_MAP"
  fun op ZIP_EQ_NIL _ = () val op ZIP_EQ_NIL = TDB.find "ZIP_EQ_NIL"
  fun op LUPDATE_SAME _ = () val op LUPDATE_SAME = TDB.find "LUPDATE_SAME"
  fun op UNIQUE_FILTER _ = ()
  val op UNIQUE_FILTER = TDB.find "UNIQUE_FILTER"
  fun op UNIQUE_LENGTH_FILTER _ = ()
  val op UNIQUE_LENGTH_FILTER = TDB.find "UNIQUE_LENGTH_FILTER"
  fun op OPT_MMAP_cong _ = ()
  val op OPT_MMAP_cong = TDB.find "OPT_MMAP_cong"
  fun op LAST_compute _ = () val op LAST_compute = TDB.find "LAST_compute"
  fun op TAKE_compute _ = () val op TAKE_compute = TDB.find "TAKE_compute"
  fun op DROP_compute _ = () val op DROP_compute = TDB.find "DROP_compute"
  fun op oHD_thm _ = () val op oHD_thm = TDB.find "oHD_thm"
  fun op oEL_THM _ = () val op oEL_THM = TDB.find "oEL_THM"
  fun op oEL_EQ_EL _ = () val op oEL_EQ_EL = TDB.find "oEL_EQ_EL"
  fun op oEL_DROP _ = () val op oEL_DROP = TDB.find "oEL_DROP"
  fun op oEL_TAKE_E _ = () val op oEL_TAKE_E = TDB.find "oEL_TAKE_E"
  fun op oEL_LUPDATE _ = () val op oEL_LUPDATE = TDB.find "oEL_LUPDATE"
  fun op lazy_list_case_compute _ = ()
  val op lazy_list_case_compute = TDB.find "lazy_list_case_compute"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val list_grammars = merge_grammars ["pred_set", "ind_type"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="list"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val list_grammars = 
    Portable.## (addtyUDs,addtmUDs) list_grammars
  val _ = Parse.grammarDB_insert("list",list_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "list"

end
