structure nlistTheory :> nlistTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading nlistTheory ... "
    else ()
  
  open Type Term Thm
  local open rich_listTheory set_relationTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "nlist"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/list/src/nlistTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ncons_def _ = () val op ncons_def = TDB.find "ncons_def"
  fun op nlist_of_def _ = () val op nlist_of_def = TDB.find "nlist_of_def"
  fun op listOfN_def _ = () val op listOfN_def = TDB.find "listOfN_def"
  fun op nhd_def _ = () val op nhd_def = TDB.find "nhd_def"
  fun op ntl_def _ = () val op ntl_def = TDB.find "ntl_def"
  fun op nel_def _ = () val op nel_def = TDB.find "nel_def"
  fun op nlast_def _ = () val op nlast_def = TDB.find "nlast_def"
  fun op nfront_def _ = () val op nfront_def = TDB.find "nfront_def"
  fun op ncons_11 _ = () val op ncons_11 = TDB.find "ncons_11"
  fun op ncons_not_nnil _ = ()
  val op ncons_not_nnil = TDB.find "ncons_not_nnil"
  fun op lt_ncons1 _ = () val op lt_ncons1 = TDB.find "lt_ncons1"
  fun op lt_ncons2 _ = () val op lt_ncons2 = TDB.find "lt_ncons2"
  fun op nlistrec_ind _ = () val op nlistrec_ind = TDB.find "nlistrec_ind"
  fun op nlistrec_def _ = () val op nlistrec_def = TDB.find "nlistrec_def"
  fun op nlistrec_thm _ = () val op nlistrec_thm = TDB.find "nlistrec_thm"
  fun op nlist_ind _ = () val op nlist_ind = TDB.find "nlist_ind"
  fun op nlist_cases _ = () val op nlist_cases = TDB.find "nlist_cases"
  fun op nlist_of_EQ0 _ = () val op nlist_of_EQ0 = TDB.find "nlist_of_EQ0"
  fun op listOfN_zero _ = () val op listOfN_zero = TDB.find "listOfN_zero"
  fun op listOfN_ncons _ = ()
  val op listOfN_ncons = TDB.find "listOfN_ncons"
  fun op listOfN_EQ_NIL _ = ()
  val op listOfN_EQ_NIL = TDB.find "listOfN_EQ_NIL"
  fun op listOfN_EQ_CONS _ = ()
  val op listOfN_EQ_CONS = TDB.find "listOfN_EQ_CONS"
  fun op nlist_listOfN _ = ()
  val op nlist_listOfN = TDB.find "nlist_listOfN"
  fun op listOfN_nlist _ = ()
  val op listOfN_nlist = TDB.find "listOfN_nlist"
  fun op listOfN_SURJ _ = () val op listOfN_SURJ = TDB.find "listOfN_SURJ"
  fun op listOfN_INJ _ = () val op listOfN_INJ = TDB.find "listOfN_INJ"
  fun op nlist_of_INJ _ = () val op nlist_of_INJ = TDB.find "nlist_of_INJ"
  fun op nlist_of_SURJ _ = ()
  val op nlist_of_SURJ = TDB.find "nlist_of_SURJ"
  fun op nhd0 _ = () val op nhd0 = TDB.find "nhd0"
  fun op nhd_thm _ = () val op nhd_thm = TDB.find "nhd_thm"
  fun op ntl_zero _ = () val op ntl_zero = TDB.find "ntl_zero"
  fun op ntl_thm _ = () val op ntl_thm = TDB.find "ntl_thm"
  fun op ntl_LT _ = () val op ntl_LT = TDB.find "ntl_LT"
  fun op ncons_nhd_ntl _ = ()
  val op ncons_nhd_ntl = TDB.find "ncons_nhd_ntl"
  fun op ntl_zero_empty_OR_ncons _ = ()
  val op ntl_zero_empty_OR_ncons = TDB.find "ntl_zero_empty_OR_ncons"
  fun op ndrop_SUC _ = () val op ndrop_SUC = TDB.find "ndrop_SUC"
  fun op ntl_ndrop _ = () val op ntl_ndrop = TDB.find "ntl_ndrop"
  fun op nel_nnil _ = () val op nel_nnil = TDB.find "nel_nnil"
  fun op nel0_ncons _ = () val op nel0_ncons = TDB.find "nel0_ncons"
  fun op nel_nhd _ = () val op nel_nhd = TDB.find "nel_nhd"
  fun op nel_SUC_CONS _ = () val op nel_SUC_CONS = TDB.find "nel_SUC_CONS"
  fun op nlast_nnil _ = () val op nlast_nnil = TDB.find "nlast_nnil"
  fun op nlast_ncons _ = () val op nlast_ncons = TDB.find "nlast_ncons"
  fun op nlast_nel _ = () val op nlast_nel = TDB.find "nlast_nel"
  fun op nfront_nnil _ = () val op nfront_nnil = TDB.find "nfront_nnil"
  fun op nfront_nsingl _ = ()
  val op nfront_nsingl = TDB.find "nfront_nsingl"
  fun op nfront_thm _ = () val op nfront_thm = TDB.find "nfront_thm"
  fun op nhd_nfront _ = () val op nhd_nfront = TDB.find "nhd_nfront"
  fun op LENGTH_nfront _ = ()
  val op LENGTH_nfront = TDB.find "LENGTH_nfront"
  fun op ncons_x_0_LENGTH_1 _ = ()
  val op ncons_x_0_LENGTH_1 = TDB.find "ncons_x_0_LENGTH_1"
  fun op ndrop_nsingl _ = () val op ndrop_nsingl = TDB.find "ndrop_nsingl"
  fun op ntl_DROP _ = () val op ntl_DROP = TDB.find "ntl_DROP"
  fun op nel_nfront _ = () val op nel_nfront = TDB.find "nel_nfront"
  fun op nsnoc_cases _ = () val op nsnoc_cases = TDB.find "nsnoc_cases"
  fun op nhd_napp _ = () val op nhd_napp = TDB.find "nhd_napp"
  fun op nel_napp _ = () val op nel_napp = TDB.find "nel_napp"
  fun op nfront_napp_sing _ = ()
  val op nfront_napp_sing = TDB.find "nfront_napp_sing"
  fun op nel_napp2 _ = () val op nel_napp2 = TDB.find "nel_napp2"
  fun op nel_ncons_nonzero _ = ()
  val op nel_ncons_nonzero = TDB.find "nel_ncons_nonzero"
  fun op napp_nsnoc_lt _ = ()
  val op napp_nsnoc_lt = TDB.find "napp_nsnoc_lt"
  fun op napp_sing_eq _ = () val op napp_sing_eq = TDB.find "napp_sing_eq"
  fun op nel_correct _ = () val op nel_correct = TDB.find "nel_correct"
  fun op nel_eq_nlist _ = () val op nel_eq_nlist = TDB.find "nel_eq_nlist"
  fun op nlast_napp _ = () val op nlast_napp = TDB.find "nlast_napp"
  fun op napp_ndrop_l1_empty _ = ()
  val op napp_ndrop_l1_empty = TDB.find "napp_ndrop_l1_empty"
  fun op ntl_LE _ = () val op ntl_LE = TDB.find "ntl_LE"
  fun op ntl_nonzero_LESS _ = ()
  val op ntl_nonzero_LESS = TDB.find "ntl_nonzero_LESS"
  fun op MEM_listOfN_LESS _ = ()
  val op MEM_listOfN_LESS = TDB.find "MEM_listOfN_LESS"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val nlist_grammars = merge_grammars ["rich_list", "set_relation"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="nlist"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val nlist_grammars = 
    Portable.## (addtyUDs,addtmUDs) nlist_grammars
  val _ = Parse.grammarDB_insert("nlist",nlist_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "nlist"

end
