structure numposrepTheory :> numposrepTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading numposrepTheory ... "
    else ()
  
  open Type Term Thm
  local open bitTheory rich_listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "numposrep"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/list/src/numposrepTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op l2n_def _ = () val op l2n_def = TDB.find "l2n_def"
  fun op num_from_bin_list_def _ = ()
  val op num_from_bin_list_def = TDB.find "num_from_bin_list_def"
  fun op num_from_oct_list_def _ = ()
  val op num_from_oct_list_def = TDB.find "num_from_oct_list_def"
  fun op num_from_dec_list_def _ = ()
  val op num_from_dec_list_def = TDB.find "num_from_dec_list_def"
  fun op num_from_hex_list_def _ = ()
  val op num_from_hex_list_def = TDB.find "num_from_hex_list_def"
  fun op num_to_bin_list_def _ = ()
  val op num_to_bin_list_def = TDB.find "num_to_bin_list_def"
  fun op num_to_oct_list_def _ = ()
  val op num_to_oct_list_def = TDB.find "num_to_oct_list_def"
  fun op num_to_dec_list_def _ = ()
  val op num_to_dec_list_def = TDB.find "num_to_dec_list_def"
  fun op num_to_hex_list_def _ = ()
  val op num_to_hex_list_def = TDB.find "num_to_hex_list_def"
  fun op BOOLIFY_def _ = () val op BOOLIFY_def = TDB.find "BOOLIFY_def"
  fun op l2n2 _ = () val op l2n2 = TDB.find "l2n2"
  fun op n2l_ind _ = () val op n2l_ind = TDB.find "n2l_ind"
  fun op n2l_def _ = () val op n2l_def = TDB.find "n2l_def"
  fun op LENGTH_n2l _ = () val op LENGTH_n2l = TDB.find "LENGTH_n2l"
  fun op l2n_n2l _ = () val op l2n_n2l = TDB.find "l2n_n2l"
  fun op l2n_lt _ = () val op l2n_lt = TDB.find "l2n_lt"
  fun op LENGTH_l2n _ = () val op LENGTH_l2n = TDB.find "LENGTH_l2n"
  fun op l2n_DIGIT _ = () val op l2n_DIGIT = TDB.find "l2n_DIGIT"
  fun op EL_n2l _ = () val op EL_n2l = TDB.find "EL_n2l"
  fun op n2l_l2n _ = () val op n2l_l2n = TDB.find "n2l_l2n"
  fun op l2n_eq_0 _ = () val op l2n_eq_0 = TDB.find "l2n_eq_0"
  fun op l2n_SNOC_0 _ = () val op l2n_SNOC_0 = TDB.find "l2n_SNOC_0"
  fun op LOG_l2n _ = () val op LOG_l2n = TDB.find "LOG_l2n"
  fun op l2n_dropWhile_0 _ = ()
  val op l2n_dropWhile_0 = TDB.find "l2n_dropWhile_0"
  fun op LOG_l2n_dropWhile _ = ()
  val op LOG_l2n_dropWhile = TDB.find "LOG_l2n_dropWhile"
  fun op n2l_BOUND _ = () val op n2l_BOUND = TDB.find "n2l_BOUND"
  fun op l2n_pow2_compute _ = ()
  val op l2n_pow2_compute = TDB.find "l2n_pow2_compute"
  fun op n2l_pow2_compute _ = ()
  val op n2l_pow2_compute = TDB.find "n2l_pow2_compute"
  fun op l2n_2_thms _ = () val op l2n_2_thms = TDB.find "l2n_2_thms"
  fun op BIT_num_from_bin_list _ = ()
  val op BIT_num_from_bin_list = TDB.find "BIT_num_from_bin_list"
  fun op EL_num_to_bin_list _ = ()
  val op EL_num_to_bin_list = TDB.find "EL_num_to_bin_list"
  fun op num_bin_list _ = () val op num_bin_list = TDB.find "num_bin_list"
  fun op num_oct_list _ = () val op num_oct_list = TDB.find "num_oct_list"
  fun op num_dec_list _ = () val op num_dec_list = TDB.find "num_dec_list"
  fun op num_hex_list _ = () val op num_hex_list = TDB.find "num_hex_list"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val numposrep_grammars = merge_grammars ["rich_list", "bit"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="numposrep"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val numposrep_grammars = 
    Portable.## (addtyUDs,addtmUDs) numposrep_grammars
  val _ = Parse.grammarDB_insert("numposrep",numposrep_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "numposrep"

end
