structure rich_listTheory :> rich_listTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading rich_listTheory ... "
    else ()
  
  open Type Term Thm
  local open listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "rich_list"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/list/src/rich_listTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op longest_prefix_def _ = ()
  val op longest_prefix_def = TDB.find "longest_prefix_def"
  fun op common_prefixes_def _ = ()
  val op common_prefixes_def = TDB.find "common_prefixes_def"
  fun op ELL _ = () val op ELL = TDB.find "ELL"
  fun op REPLICATE _ = () val op REPLICATE = TDB.find "REPLICATE"
  fun op SCANL _ = () val op SCANL = TDB.find "SCANL"
  fun op SCANR _ = () val op SCANR = TDB.find "SCANR"
  fun op SPLITP _ = () val op SPLITP = TDB.find "SPLITP"
  fun op SPLITP_AUX_def _ = ()
  val op SPLITP_AUX_def = TDB.find "SPLITP_AUX_def"
  fun op SPLITL_def _ = () val op SPLITL_def = TDB.find "SPLITL_def"
  fun op SPLITR_def _ = () val op SPLITR_def = TDB.find "SPLITR_def"
  fun op PREFIX_DEF _ = () val op PREFIX_DEF = TDB.find "PREFIX_DEF"
  fun op SUFFIX_DEF _ = () val op SUFFIX_DEF = TDB.find "SUFFIX_DEF"
  fun op AND_EL_DEF _ = () val op AND_EL_DEF = TDB.find "AND_EL_DEF"
  fun op OR_EL_DEF _ = () val op OR_EL_DEF = TDB.find "OR_EL_DEF"
  fun op UNZIP_FST_DEF _ = ()
  val op UNZIP_FST_DEF = TDB.find "UNZIP_FST_DEF"
  fun op UNZIP_SND_DEF _ = ()
  val op UNZIP_SND_DEF = TDB.find "UNZIP_SND_DEF"
  fun op LIST_ELEM_COUNT_DEF _ = ()
  val op LIST_ELEM_COUNT_DEF = TDB.find "LIST_ELEM_COUNT_DEF"
  fun op COUNT_LIST_def _ = ()
  val op COUNT_LIST_def = TDB.find "COUNT_LIST_def"
  fun op COUNT_LIST_AUX_def _ = ()
  val op COUNT_LIST_AUX_def = TDB.find "COUNT_LIST_AUX_def"
  fun op TL_T_def _ = () val op TL_T_def = TDB.find "TL_T_def"
  fun op LASTN_def _ = () val op LASTN_def = TDB.find "LASTN_def"
  fun op BUTLASTN_def _ = () val op BUTLASTN_def = TDB.find "BUTLASTN_def"
  fun op IS_SUBLIST _ = () val op IS_SUBLIST = TDB.find "IS_SUBLIST"
  fun op SEG _ = () val op SEG = TDB.find "SEG"
  fun op IS_SUFFIX _ = () val op IS_SUFFIX = TDB.find "IS_SUFFIX"
  fun op EL_REPLICATE _ = () val op EL_REPLICATE = TDB.find "EL_REPLICATE"
  fun op REPLICATE_GENLIST _ = ()
  val op REPLICATE_GENLIST = TDB.find "REPLICATE_GENLIST"
  fun op LIST_TO_SET_EQ_SING _ = ()
  val op LIST_TO_SET_EQ_SING = TDB.find "LIST_TO_SET_EQ_SING"
  fun op LIST_ELEM_COUNT_MEM _ = ()
  val op LIST_ELEM_COUNT_MEM = TDB.find "LIST_ELEM_COUNT_MEM"
  fun op LIST_ELEM_COUNT_THM _ = ()
  val op LIST_ELEM_COUNT_THM = TDB.find "LIST_ELEM_COUNT_THM"
  fun op MEM_LAST_FRONT _ = ()
  val op MEM_LAST_FRONT = TDB.find "MEM_LAST_FRONT"
  fun op DROP_CONS_EL _ = () val op DROP_CONS_EL = TDB.find "DROP_CONS_EL"
  fun op MEM_LAST _ = () val op MEM_LAST = TDB.find "MEM_LAST"
  fun op EL_FRONT _ = () val op EL_FRONT = TDB.find "EL_FRONT"
  fun op FRONT_APPEND _ = () val op FRONT_APPEND = TDB.find "FRONT_APPEND"
  fun op MEM_FRONT _ = () val op MEM_FRONT = TDB.find "MEM_FRONT"
  fun op SPLITP_EVERY _ = () val op SPLITP_EVERY = TDB.find "SPLITP_EVERY"
  fun op FOLDL_MAP2 _ = () val op FOLDL_MAP2 = TDB.find "FOLDL_MAP2"
  fun op APPEND_SNOC1 _ = () val op APPEND_SNOC1 = TDB.find "APPEND_SNOC1"
  fun op APPEND_ASSOC_CONS _ = ()
  val op APPEND_ASSOC_CONS = TDB.find "APPEND_ASSOC_CONS"
  fun op ZIP_APPEND _ = () val op ZIP_APPEND = TDB.find "ZIP_APPEND"
  fun op ZIP_TAKE _ = () val op ZIP_TAKE = TDB.find "ZIP_TAKE"
  fun op ZIP_TAKE_LEQ _ = () val op ZIP_TAKE_LEQ = TDB.find "ZIP_TAKE_LEQ"
  fun op SNOC_EL_TAKE _ = () val op SNOC_EL_TAKE = TDB.find "SNOC_EL_TAKE"
  fun op MAP_COUNT_LIST _ = ()
  val op MAP_COUNT_LIST = TDB.find "MAP_COUNT_LIST"
  fun op COUNT_LIST_ADD _ = ()
  val op COUNT_LIST_ADD = TDB.find "COUNT_LIST_ADD"
  fun op COUNT_LIST_COUNT _ = ()
  val op COUNT_LIST_COUNT = TDB.find "COUNT_LIST_COUNT"
  fun op COUNT_LIST_SNOC _ = ()
  val op COUNT_LIST_SNOC = TDB.find "COUNT_LIST_SNOC"
  fun op MEM_COUNT_LIST _ = ()
  val op MEM_COUNT_LIST = TDB.find "MEM_COUNT_LIST"
  fun op EL_COUNT_LIST _ = ()
  val op EL_COUNT_LIST = TDB.find "EL_COUNT_LIST"
  fun op LENGTH_COUNT_LIST _ = ()
  val op LENGTH_COUNT_LIST = TDB.find "LENGTH_COUNT_LIST"
  fun op COUNT_LIST_GENLIST _ = ()
  val op COUNT_LIST_GENLIST = TDB.find "COUNT_LIST_GENLIST"
  fun op longest_prefix_PAIR _ = ()
  val op longest_prefix_PAIR = TDB.find "longest_prefix_PAIR"
  fun op common_prefixes_PAIR _ = ()
  val op common_prefixes_PAIR = TDB.find "common_prefixes_PAIR"
  fun op longest_prefix_SING _ = ()
  val op longest_prefix_SING = TDB.find "longest_prefix_SING"
  fun op longest_prefix_EMPTY _ = ()
  val op longest_prefix_EMPTY = TDB.find "longest_prefix_EMPTY"
  fun op NIL_IN_common_prefixes _ = ()
  val op NIL_IN_common_prefixes = TDB.find "NIL_IN_common_prefixes"
  fun op longest_prefix_NIL _ = ()
  val op longest_prefix_NIL = TDB.find "longest_prefix_NIL"
  fun op common_prefixes_NIL _ = ()
  val op common_prefixes_NIL = TDB.find "common_prefixes_NIL"
  fun op longest_prefix_UNIQUE _ = ()
  val op longest_prefix_UNIQUE = TDB.find "longest_prefix_UNIQUE"
  fun op two_common_prefixes _ = ()
  val op two_common_prefixes = TDB.find "two_common_prefixes"
  fun op common_prefixes_NONEMPTY _ = ()
  val op common_prefixes_NONEMPTY = TDB.find "common_prefixes_NONEMPTY"
  fun op FINITE_common_prefixes _ = ()
  val op FINITE_common_prefixes = TDB.find "FINITE_common_prefixes"
  fun op FINITE_prefix _ = ()
  val op FINITE_prefix = TDB.find "FINITE_prefix"
  fun op common_prefixes_BIGINTER _ = ()
  val op common_prefixes_BIGINTER = TDB.find "common_prefixes_BIGINTER"
  fun op prefixes_is_prefix_total _ = ()
  val op prefixes_is_prefix_total = TDB.find "prefixes_is_prefix_total"
  fun op IS_PREFIX_APPEND3 _ = ()
  val op IS_PREFIX_APPEND3 = TDB.find "IS_PREFIX_APPEND3"
  fun op IS_PREFIX_APPENDS _ = ()
  val op IS_PREFIX_APPENDS = TDB.find "IS_PREFIX_APPENDS"
  fun op IS_PREFIX_APPEND2 _ = ()
  val op IS_PREFIX_APPEND2 = TDB.find "IS_PREFIX_APPEND2"
  fun op IS_PREFIX_APPEND1 _ = ()
  val op IS_PREFIX_APPEND1 = TDB.find "IS_PREFIX_APPEND1"
  fun op IS_PREFIX_SNOC _ = ()
  val op IS_PREFIX_SNOC = TDB.find "IS_PREFIX_SNOC"
  fun op IS_PREFIX_LENGTH_ANTI _ = ()
  val op IS_PREFIX_LENGTH_ANTI = TDB.find "IS_PREFIX_LENGTH_ANTI"
  fun op IS_PREFIX_LENGTH _ = ()
  val op IS_PREFIX_LENGTH = TDB.find "IS_PREFIX_LENGTH"
  fun op IS_PREFIX_BUTLAST _ = ()
  val op IS_PREFIX_BUTLAST = TDB.find "IS_PREFIX_BUTLAST"
  fun op IS_PREFIX_TRANS _ = ()
  val op IS_PREFIX_TRANS = TDB.find "IS_PREFIX_TRANS"
  fun op IS_PREFIX_ANTISYM _ = ()
  val op IS_PREFIX_ANTISYM = TDB.find "IS_PREFIX_ANTISYM"
  fun op IS_PREFIX_REFL _ = ()
  val op IS_PREFIX_REFL = TDB.find "IS_PREFIX_REFL"
  fun op IS_PREFIX_NIL _ = ()
  val op IS_PREFIX_NIL = TDB.find "IS_PREFIX_NIL"
  fun op OR_EL_FOLDR _ = () val op OR_EL_FOLDR = TDB.find "OR_EL_FOLDR"
  fun op OR_EL_FOLDL _ = () val op OR_EL_FOLDL = TDB.find "OR_EL_FOLDL"
  fun op AND_EL_FOLDR _ = () val op AND_EL_FOLDR = TDB.find "AND_EL_FOLDR"
  fun op AND_EL_FOLDL _ = () val op AND_EL_FOLDL = TDB.find "AND_EL_FOLDL"
  fun op DROP_LENGTH_NIL _ = ()
  val op DROP_LENGTH_NIL = TDB.find "DROP_LENGTH_NIL"
  fun op TAKE_TAKE _ = () val op TAKE_TAKE = TDB.find "TAKE_TAKE"
  fun op TAKE_TAKE_T _ = () val op TAKE_TAKE_T = TDB.find "TAKE_TAKE_T"
  fun op EVERY_BUTLASTN _ = ()
  val op EVERY_BUTLASTN = TDB.find "EVERY_BUTLASTN"
  fun op EVERY_LASTN _ = () val op EVERY_LASTN = TDB.find "EVERY_LASTN"
  fun op BUTLASTN_MAP _ = () val op BUTLASTN_MAP = TDB.find "BUTLASTN_MAP"
  fun op LASTN_MAP _ = () val op LASTN_MAP = TDB.find "LASTN_MAP"
  fun op LASTN_APPEND1 _ = ()
  val op LASTN_APPEND1 = TDB.find "LASTN_APPEND1"
  fun op LASTN_APPEND2 _ = ()
  val op LASTN_APPEND2 = TDB.find "LASTN_APPEND2"
  fun op BUTLASTN_APPEND1 _ = ()
  val op BUTLASTN_APPEND1 = TDB.find "BUTLASTN_APPEND1"
  fun op BUTLASTN_1 _ = () val op BUTLASTN_1 = TDB.find "BUTLASTN_1"
  fun op LASTN_1 _ = () val op LASTN_1 = TDB.find "LASTN_1"
  fun op BUTLASTN_LASTN _ = ()
  val op BUTLASTN_LASTN = TDB.find "BUTLASTN_LASTN"
  fun op LASTN_BUTLASTN _ = ()
  val op LASTN_BUTLASTN = TDB.find "LASTN_BUTLASTN"
  fun op BUTLASTN_LASTN_NIL _ = ()
  val op BUTLASTN_LASTN_NIL = TDB.find "BUTLASTN_LASTN_NIL"
  fun op LAST_LASTN_LAST _ = ()
  val op LAST_LASTN_LAST = TDB.find "LAST_LASTN_LAST"
  fun op BUTLASTN_LENGTH_CONS _ = ()
  val op BUTLASTN_LENGTH_CONS = TDB.find "BUTLASTN_LENGTH_CONS"
  fun op BUTLASTN_CONS _ = ()
  val op BUTLASTN_CONS = TDB.find "BUTLASTN_CONS"
  fun op LASTN_LENGTH_APPEND _ = ()
  val op LASTN_LENGTH_APPEND = TDB.find "LASTN_LENGTH_APPEND"
  fun op BUTLASTN_LENGTH_APPEND _ = ()
  val op BUTLASTN_LENGTH_APPEND = TDB.find "BUTLASTN_LENGTH_APPEND"
  fun op BUTLASTN_APPEND2 _ = ()
  val op BUTLASTN_APPEND2 = TDB.find "BUTLASTN_APPEND2"
  fun op APPEND_TAKE_LASTN _ = ()
  val op APPEND_TAKE_LASTN = TDB.find "APPEND_TAKE_LASTN"
  fun op APPEND_BUTLASTN_LASTN _ = ()
  val op APPEND_BUTLASTN_LASTN = TDB.find "APPEND_BUTLASTN_LASTN"
  fun op BUTLASTN_BUTLASTN _ = ()
  val op BUTLASTN_BUTLASTN = TDB.find "BUTLASTN_BUTLASTN"
  fun op LENGTH_BUTLASTN _ = ()
  val op LENGTH_BUTLASTN = TDB.find "LENGTH_BUTLASTN"
  fun op BUTLASTN_FRONT _ = ()
  val op BUTLASTN_FRONT = TDB.find "BUTLASTN_FRONT"
  fun op BUTLASTN_SUC_FRONT _ = ()
  val op BUTLASTN_SUC_FRONT = TDB.find "BUTLASTN_SUC_FRONT"
  fun op ELL_compute _ = () val op ELL_compute = TDB.find "ELL_compute"
  fun op REPLICATE_compute _ = ()
  val op REPLICATE_compute = TDB.find "REPLICATE_compute"
  fun op SPLITP_splitAtPki _ = ()
  val op SPLITP_splitAtPki = TDB.find "SPLITP_splitAtPki"
  fun op SPLITP_JOIN _ = () val op SPLITP_JOIN = TDB.find "SPLITP_JOIN"
  fun op SPLITP_IMP _ = () val op SPLITP_IMP = TDB.find "SPLITP_IMP"
  fun op SPLITP_LENGTH _ = ()
  val op SPLITP_LENGTH = TDB.find "SPLITP_LENGTH"
  fun op SPLITP_APPEND _ = ()
  val op SPLITP_APPEND = TDB.find "SPLITP_APPEND"
  fun op SPLITP_NIL_SND_EVERY _ = ()
  val op SPLITP_NIL_SND_EVERY = TDB.find "SPLITP_NIL_SND_EVERY"
  fun op SPLITP_NIL_FST_IMP _ = ()
  val op SPLITP_NIL_FST_IMP = TDB.find "SPLITP_NIL_FST_IMP"
  fun op COUNT_LIST_AUX_compute _ = ()
  val op COUNT_LIST_AUX_compute = TDB.find "COUNT_LIST_AUX_compute"
  fun op TAKE _ = () val op TAKE = TDB.find "TAKE"
  fun op DROP _ = () val op DROP = TDB.find "DROP"
  fun op DROP_FUNPOW_TL _ = ()
  val op DROP_FUNPOW_TL = TDB.find "DROP_FUNPOW_TL"
  fun op NOT_NULL_SNOC _ = ()
  val op NOT_NULL_SNOC = TDB.find "NOT_NULL_SNOC"
  fun op LASTN _ = () val op LASTN = TDB.find "LASTN"
  fun op BUTLASTN _ = () val op BUTLASTN = TDB.find "BUTLASTN"
  fun op LENGTH_NOT_NULL _ = ()
  val op LENGTH_NOT_NULL = TDB.find "LENGTH_NOT_NULL"
  fun op NOT_NIL_SNOC _ = () val op NOT_NIL_SNOC = TDB.find "NOT_NIL_SNOC"
  fun op NOT_SNOC_NIL _ = () val op NOT_SNOC_NIL = TDB.find "NOT_SNOC_NIL"
  fun op SNOC_EQ_LENGTH_EQ _ = ()
  val op SNOC_EQ_LENGTH_EQ = TDB.find "SNOC_EQ_LENGTH_EQ"
  fun op SNOC_REVERSE_CONS _ = ()
  val op SNOC_REVERSE_CONS = TDB.find "SNOC_REVERSE_CONS"
  fun op FOLDR_SNOC _ = () val op FOLDR_SNOC = TDB.find "FOLDR_SNOC"
  fun op FOLDR_FOLDL _ = () val op FOLDR_FOLDL = TDB.find "FOLDR_FOLDL"
  fun op LENGTH_FOLDR _ = () val op LENGTH_FOLDR = TDB.find "LENGTH_FOLDR"
  fun op LENGTH_FOLDL _ = () val op LENGTH_FOLDL = TDB.find "LENGTH_FOLDL"
  fun op MAP_FOLDR _ = () val op MAP_FOLDR = TDB.find "MAP_FOLDR"
  fun op MAP_FOLDL _ = () val op MAP_FOLDL = TDB.find "MAP_FOLDL"
  fun op FILTER_FOLDR _ = () val op FILTER_FOLDR = TDB.find "FILTER_FOLDR"
  fun op FILTER_SNOC _ = () val op FILTER_SNOC = TDB.find "FILTER_SNOC"
  fun op FILTER_FOLDL _ = () val op FILTER_FOLDL = TDB.find "FILTER_FOLDL"
  fun op FILTER_COMM _ = () val op FILTER_COMM = TDB.find "FILTER_COMM"
  fun op FILTER_IDEM _ = () val op FILTER_IDEM = TDB.find "FILTER_IDEM"
  fun op FILTER_MAP _ = () val op FILTER_MAP = TDB.find "FILTER_MAP"
  fun op LENGTH_FILTER_LEQ _ = ()
  val op LENGTH_FILTER_LEQ = TDB.find "LENGTH_FILTER_LEQ"
  fun op FILTER_EQ _ = () val op FILTER_EQ = TDB.find "FILTER_EQ"
  fun op LENGTH_SEG _ = () val op LENGTH_SEG = TDB.find "LENGTH_SEG"
  fun op APPEND_NIL _ = () val op APPEND_NIL = TDB.find "APPEND_NIL"
  fun op APPEND_FOLDR _ = () val op APPEND_FOLDR = TDB.find "APPEND_FOLDR"
  fun op APPEND_FOLDL _ = () val op APPEND_FOLDL = TDB.find "APPEND_FOLDL"
  fun op FOLDR_APPEND _ = () val op FOLDR_APPEND = TDB.find "FOLDR_APPEND"
  fun op FOLDL_APPEND _ = () val op FOLDL_APPEND = TDB.find "FOLDL_APPEND"
  fun op CONS_APPEND _ = () val op CONS_APPEND = TDB.find "CONS_APPEND"
  fun op ASSOC_APPEND _ = () val op ASSOC_APPEND = TDB.find "ASSOC_APPEND"
  fun op MONOID_APPEND_NIL _ = ()
  val op MONOID_APPEND_NIL = TDB.find "MONOID_APPEND_NIL"
  fun op FLAT_SNOC _ = () val op FLAT_SNOC = TDB.find "FLAT_SNOC"
  fun op FLAT_FOLDR _ = () val op FLAT_FOLDR = TDB.find "FLAT_FOLDR"
  fun op FLAT_FOLDL _ = () val op FLAT_FOLDL = TDB.find "FLAT_FOLDL"
  fun op LENGTH_FLAT _ = () val op LENGTH_FLAT = TDB.find "LENGTH_FLAT"
  fun op REVERSE_FOLDR _ = ()
  val op REVERSE_FOLDR = TDB.find "REVERSE_FOLDR"
  fun op REVERSE_FOLDL _ = ()
  val op REVERSE_FOLDL = TDB.find "REVERSE_FOLDL"
  fun op ALL_EL_MAP _ = () val op ALL_EL_MAP = TDB.find "ALL_EL_MAP"
  fun op MEM_EXISTS _ = () val op MEM_EXISTS = TDB.find "MEM_EXISTS"
  fun op SUM_FOLDR _ = () val op SUM_FOLDR = TDB.find "SUM_FOLDR"
  fun op SUM_FOLDL _ = () val op SUM_FOLDL = TDB.find "SUM_FOLDL"
  fun op IS_PREFIX _ = () val op IS_PREFIX = TDB.find "IS_PREFIX"
  fun op IS_PREFIX_APPEND _ = ()
  val op IS_PREFIX_APPEND = TDB.find "IS_PREFIX_APPEND"
  fun op IS_SUFFIX_APPEND _ = ()
  val op IS_SUFFIX_APPEND = TDB.find "IS_SUFFIX_APPEND"
  fun op IS_SUBLIST_APPEND _ = ()
  val op IS_SUBLIST_APPEND = TDB.find "IS_SUBLIST_APPEND"
  fun op IS_PREFIX_IS_SUBLIST _ = ()
  val op IS_PREFIX_IS_SUBLIST = TDB.find "IS_PREFIX_IS_SUBLIST"
  fun op IS_SUFFIX_IS_SUBLIST _ = ()
  val op IS_SUFFIX_IS_SUBLIST = TDB.find "IS_SUFFIX_IS_SUBLIST"
  fun op IS_SUFFIX_CONS _ = ()
  val op IS_SUFFIX_CONS = TDB.find "IS_SUFFIX_CONS"
  fun op IS_SUFFIX_TRANS _ = ()
  val op IS_SUFFIX_TRANS = TDB.find "IS_SUFFIX_TRANS"
  fun op IS_PREFIX_REVERSE _ = ()
  val op IS_PREFIX_REVERSE = TDB.find "IS_PREFIX_REVERSE"
  fun op IS_SUFFIX_REVERSE _ = ()
  val op IS_SUFFIX_REVERSE = TDB.find "IS_SUFFIX_REVERSE"
  fun op IS_SUFFIX_CONS2_E _ = ()
  val op IS_SUFFIX_CONS2_E = TDB.find "IS_SUFFIX_CONS2_E"
  fun op IS_SUFFIX_REFL _ = ()
  val op IS_SUFFIX_REFL = TDB.find "IS_SUFFIX_REFL"
  fun op IS_SUBLIST_REVERSE _ = ()
  val op IS_SUBLIST_REVERSE = TDB.find "IS_SUBLIST_REVERSE"
  fun op PREFIX_FOLDR _ = () val op PREFIX_FOLDR = TDB.find "PREFIX_FOLDR"
  fun op PREFIX _ = () val op PREFIX = TDB.find "PREFIX"
  fun op IS_PREFIX_PREFIX _ = ()
  val op IS_PREFIX_PREFIX = TDB.find "IS_PREFIX_PREFIX"
  fun op LENGTH_SCANL _ = () val op LENGTH_SCANL = TDB.find "LENGTH_SCANL"
  fun op LENGTH_SCANR _ = () val op LENGTH_SCANR = TDB.find "LENGTH_SCANR"
  fun op COMM_MONOID_FOLDL _ = ()
  val op COMM_MONOID_FOLDL = TDB.find "COMM_MONOID_FOLDL"
  fun op COMM_MONOID_FOLDR _ = ()
  val op COMM_MONOID_FOLDR = TDB.find "COMM_MONOID_FOLDR"
  fun op FCOMM_FOLDR_APPEND _ = ()
  val op FCOMM_FOLDR_APPEND = TDB.find "FCOMM_FOLDR_APPEND"
  fun op FCOMM_FOLDL_APPEND _ = ()
  val op FCOMM_FOLDL_APPEND = TDB.find "FCOMM_FOLDL_APPEND"
  fun op FOLDL_SINGLE _ = () val op FOLDL_SINGLE = TDB.find "FOLDL_SINGLE"
  fun op FOLDR_SINGLE _ = () val op FOLDR_SINGLE = TDB.find "FOLDR_SINGLE"
  fun op FOLDR_CONS_NIL _ = ()
  val op FOLDR_CONS_NIL = TDB.find "FOLDR_CONS_NIL"
  fun op FOLDL_SNOC_NIL _ = ()
  val op FOLDL_SNOC_NIL = TDB.find "FOLDL_SNOC_NIL"
  fun op FOLDR_FOLDL_REVERSE _ = ()
  val op FOLDR_FOLDL_REVERSE = TDB.find "FOLDR_FOLDL_REVERSE"
  fun op FOLDL_FOLDR_REVERSE _ = ()
  val op FOLDL_FOLDR_REVERSE = TDB.find "FOLDL_FOLDR_REVERSE"
  fun op FOLDR_REVERSE _ = ()
  val op FOLDR_REVERSE = TDB.find "FOLDR_REVERSE"
  fun op FOLDL_REVERSE _ = ()
  val op FOLDL_REVERSE = TDB.find "FOLDL_REVERSE"
  fun op FOLDR_MAP _ = () val op FOLDR_MAP = TDB.find "FOLDR_MAP"
  fun op FOLDL_MAP _ = () val op FOLDL_MAP = TDB.find "FOLDL_MAP"
  fun op EVERY_FOLDR _ = () val op EVERY_FOLDR = TDB.find "EVERY_FOLDR"
  fun op EVERY_FOLDL _ = () val op EVERY_FOLDL = TDB.find "EVERY_FOLDL"
  fun op EXISTS_FOLDR _ = () val op EXISTS_FOLDR = TDB.find "EXISTS_FOLDR"
  fun op EXISTS_FOLDL _ = () val op EXISTS_FOLDL = TDB.find "EXISTS_FOLDL"
  fun op EVERY_FOLDR_MAP _ = ()
  val op EVERY_FOLDR_MAP = TDB.find "EVERY_FOLDR_MAP"
  fun op EVERY_FOLDL_MAP _ = ()
  val op EVERY_FOLDL_MAP = TDB.find "EVERY_FOLDL_MAP"
  fun op EXISTS_FOLDR_MAP _ = ()
  val op EXISTS_FOLDR_MAP = TDB.find "EXISTS_FOLDR_MAP"
  fun op EXISTS_FOLDL_MAP _ = ()
  val op EXISTS_FOLDL_MAP = TDB.find "EXISTS_FOLDL_MAP"
  fun op FOLDR_FILTER _ = () val op FOLDR_FILTER = TDB.find "FOLDR_FILTER"
  fun op FOLDL_FILTER _ = () val op FOLDL_FILTER = TDB.find "FOLDL_FILTER"
  fun op ASSOC_FOLDR_FLAT _ = ()
  val op ASSOC_FOLDR_FLAT = TDB.find "ASSOC_FOLDR_FLAT"
  fun op ASSOC_FOLDL_FLAT _ = ()
  val op ASSOC_FOLDL_FLAT = TDB.find "ASSOC_FOLDL_FLAT"
  fun op MAP_FLAT _ = () val op MAP_FLAT = TDB.find "MAP_FLAT"
  fun op FILTER_FLAT _ = () val op FILTER_FLAT = TDB.find "FILTER_FLAT"
  fun op EXISTS_DISJ _ = () val op EXISTS_DISJ = TDB.find "EXISTS_DISJ"
  fun op MEM_FOLDR _ = () val op MEM_FOLDR = TDB.find "MEM_FOLDR"
  fun op MEM_FOLDL _ = () val op MEM_FOLDL = TDB.find "MEM_FOLDL"
  fun op NULL_FOLDR _ = () val op NULL_FOLDR = TDB.find "NULL_FOLDR"
  fun op NULL_FOLDL _ = () val op NULL_FOLDL = TDB.find "NULL_FOLDL"
  fun op MAP_REVERSE _ = () val op MAP_REVERSE = TDB.find "MAP_REVERSE"
  fun op SEG_LENGTH_ID _ = ()
  val op SEG_LENGTH_ID = TDB.find "SEG_LENGTH_ID"
  fun op SEG_SUC_CONS _ = () val op SEG_SUC_CONS = TDB.find "SEG_SUC_CONS"
  fun op SEG_0_SNOC _ = () val op SEG_0_SNOC = TDB.find "SEG_0_SNOC"
  fun op BUTLASTN_SEG _ = () val op BUTLASTN_SEG = TDB.find "BUTLASTN_SEG"
  fun op LASTN_CONS _ = () val op LASTN_CONS = TDB.find "LASTN_CONS"
  fun op LENGTH_LASTN _ = () val op LENGTH_LASTN = TDB.find "LENGTH_LASTN"
  fun op LASTN_LENGTH_ID _ = ()
  val op LASTN_LENGTH_ID = TDB.find "LASTN_LENGTH_ID"
  fun op LASTN_LASTN _ = () val op LASTN_LASTN = TDB.find "LASTN_LASTN"
  fun op TAKE_SNOC _ = () val op TAKE_SNOC = TDB.find "TAKE_SNOC"
  fun op BUTLASTN_LENGTH_NIL _ = ()
  val op BUTLASTN_LENGTH_NIL = TDB.find "BUTLASTN_LENGTH_NIL"
  fun op DROP_APPEND _ = () val op DROP_APPEND = TDB.find "DROP_APPEND"
  fun op DROP_APPEND1 _ = () val op DROP_APPEND1 = TDB.find "DROP_APPEND1"
  fun op DROP_APPEND2 _ = () val op DROP_APPEND2 = TDB.find "DROP_APPEND2"
  fun op DROP_DROP_T _ = () val op DROP_DROP_T = TDB.find "DROP_DROP_T"
  fun op DROP_DROP _ = () val op DROP_DROP = TDB.find "DROP_DROP"
  fun op LASTN_SEG _ = () val op LASTN_SEG = TDB.find "LASTN_SEG"
  fun op TAKE_SEG _ = () val op TAKE_SEG = TDB.find "TAKE_SEG"
  fun op DROP_SEG _ = () val op DROP_SEG = TDB.find "DROP_SEG"
  fun op DROP_SNOC _ = () val op DROP_SNOC = TDB.find "DROP_SNOC"
  fun op APPEND_BUTLASTN_DROP _ = ()
  val op APPEND_BUTLASTN_DROP = TDB.find "APPEND_BUTLASTN_DROP"
  fun op SEG_SEG _ = () val op SEG_SEG = TDB.find "SEG_SEG"
  fun op SEG_APPEND1 _ = () val op SEG_APPEND1 = TDB.find "SEG_APPEND1"
  fun op SEG_APPEND2 _ = () val op SEG_APPEND2 = TDB.find "SEG_APPEND2"
  fun op SEG_TAKE_DROP _ = ()
  val op SEG_TAKE_DROP = TDB.find "SEG_TAKE_DROP"
  fun op SEG_APPEND _ = () val op SEG_APPEND = TDB.find "SEG_APPEND"
  fun op SEG_LENGTH_SNOC _ = ()
  val op SEG_LENGTH_SNOC = TDB.find "SEG_LENGTH_SNOC"
  fun op SEG_SNOC _ = () val op SEG_SNOC = TDB.find "SEG_SNOC"
  fun op ELL_SEG _ = () val op ELL_SEG = TDB.find "ELL_SEG"
  fun op SNOC_FOLDR _ = () val op SNOC_FOLDR = TDB.find "SNOC_FOLDR"
  fun op MEM_FOLDR_MAP _ = ()
  val op MEM_FOLDR_MAP = TDB.find "MEM_FOLDR_MAP"
  fun op MEM_FOLDL_MAP _ = ()
  val op MEM_FOLDL_MAP = TDB.find "MEM_FOLDL_MAP"
  fun op FILTER_FILTER _ = ()
  val op FILTER_FILTER = TDB.find "FILTER_FILTER"
  fun op FCOMM_FOLDR_FLAT _ = ()
  val op FCOMM_FOLDR_FLAT = TDB.find "FCOMM_FOLDR_FLAT"
  fun op FCOMM_FOLDL_FLAT _ = ()
  val op FCOMM_FOLDL_FLAT = TDB.find "FCOMM_FOLDL_FLAT"
  fun op FOLDR_MAP_REVERSE _ = ()
  val op FOLDR_MAP_REVERSE = TDB.find "FOLDR_MAP_REVERSE"
  fun op FOLDR_FILTER_REVERSE _ = ()
  val op FOLDR_FILTER_REVERSE = TDB.find "FOLDR_FILTER_REVERSE"
  fun op COMM_ASSOC_FOLDR_REVERSE _ = ()
  val op COMM_ASSOC_FOLDR_REVERSE = TDB.find "COMM_ASSOC_FOLDR_REVERSE"
  fun op COMM_ASSOC_FOLDL_REVERSE _ = ()
  val op COMM_ASSOC_FOLDL_REVERSE = TDB.find "COMM_ASSOC_FOLDL_REVERSE"
  fun op ELL_LAST _ = () val op ELL_LAST = TDB.find "ELL_LAST"
  fun op ELL_0_SNOC _ = () val op ELL_0_SNOC = TDB.find "ELL_0_SNOC"
  fun op ELL_SNOC _ = () val op ELL_SNOC = TDB.find "ELL_SNOC"
  fun op ELL_SUC_SNOC _ = () val op ELL_SUC_SNOC = TDB.find "ELL_SUC_SNOC"
  fun op ELL_CONS _ = () val op ELL_CONS = TDB.find "ELL_CONS"
  fun op ELL_LENGTH_CONS _ = ()
  val op ELL_LENGTH_CONS = TDB.find "ELL_LENGTH_CONS"
  fun op ELL_LENGTH_SNOC _ = ()
  val op ELL_LENGTH_SNOC = TDB.find "ELL_LENGTH_SNOC"
  fun op ELL_APPEND2 _ = () val op ELL_APPEND2 = TDB.find "ELL_APPEND2"
  fun op ELL_APPEND1 _ = () val op ELL_APPEND1 = TDB.find "ELL_APPEND1"
  fun op ELL_PRE_LENGTH _ = ()
  val op ELL_PRE_LENGTH = TDB.find "ELL_PRE_LENGTH"
  fun op EL_PRE_LENGTH _ = ()
  val op EL_PRE_LENGTH = TDB.find "EL_PRE_LENGTH"
  fun op EL_ELL _ = () val op EL_ELL = TDB.find "EL_ELL"
  fun op EL_LENGTH_APPEND _ = ()
  val op EL_LENGTH_APPEND = TDB.find "EL_LENGTH_APPEND"
  fun op ELL_EL _ = () val op ELL_EL = TDB.find "ELL_EL"
  fun op ELL_MAP _ = () val op ELL_MAP = TDB.find "ELL_MAP"
  fun op LENGTH_FRONT _ = () val op LENGTH_FRONT = TDB.find "LENGTH_FRONT"
  fun op DROP_LENGTH_APPEND _ = ()
  val op DROP_LENGTH_APPEND = TDB.find "DROP_LENGTH_APPEND"
  fun op TAKE_APPEND _ = () val op TAKE_APPEND = TDB.find "TAKE_APPEND"
  fun op TAKE_APPEND1 _ = () val op TAKE_APPEND1 = TDB.find "TAKE_APPEND1"
  fun op TAKE_APPEND2 _ = () val op TAKE_APPEND2 = TDB.find "TAKE_APPEND2"
  fun op TAKE_LENGTH_APPEND _ = ()
  val op TAKE_LENGTH_APPEND = TDB.find "TAKE_LENGTH_APPEND"
  fun op REVERSE_FLAT _ = () val op REVERSE_FLAT = TDB.find "REVERSE_FLAT"
  fun op MAP_FILTER _ = () val op MAP_FILTER = TDB.find "MAP_FILTER"
  fun op FLAT_REVERSE _ = () val op FLAT_REVERSE = TDB.find "FLAT_REVERSE"
  fun op FLAT_FLAT _ = () val op FLAT_FLAT = TDB.find "FLAT_FLAT"
  fun op EVERY_REVERSE _ = ()
  val op EVERY_REVERSE = TDB.find "EVERY_REVERSE"
  fun op EXISTS_REVERSE _ = ()
  val op EXISTS_REVERSE = TDB.find "EXISTS_REVERSE"
  fun op EVERY_SEG _ = () val op EVERY_SEG = TDB.find "EVERY_SEG"
  fun op EVERY_TAKE _ = () val op EVERY_TAKE = TDB.find "EVERY_TAKE"
  fun op EVERY_DROP _ = () val op EVERY_DROP = TDB.find "EVERY_DROP"
  fun op EXISTS_SEG _ = () val op EXISTS_SEG = TDB.find "EXISTS_SEG"
  fun op EXISTS_TAKE_IMP _ = ()
  val op EXISTS_TAKE_IMP = TDB.find "EXISTS_TAKE_IMP"
  fun op EXISTS_DROP_IMP _ = ()
  val op EXISTS_DROP_IMP = TDB.find "EXISTS_DROP_IMP"
  fun op EXISTS_TAKE _ = () val op EXISTS_TAKE = TDB.find "EXISTS_TAKE"
  fun op EXISTS_DROP _ = () val op EXISTS_DROP = TDB.find "EXISTS_DROP"
  fun op EXISTS_LASTN _ = () val op EXISTS_LASTN = TDB.find "EXISTS_LASTN"
  fun op EXISTS_BUTLASTN _ = ()
  val op EXISTS_BUTLASTN = TDB.find "EXISTS_BUTLASTN"
  fun op MEM_SEG _ = () val op MEM_SEG = TDB.find "MEM_SEG"
  fun op MEM_TAKE_IMP _ = () val op MEM_TAKE_IMP = TDB.find "MEM_TAKE_IMP"
  fun op MEM_DROP_IMP _ = () val op MEM_DROP_IMP = TDB.find "MEM_DROP_IMP"
  fun op MEM_TAKE _ = () val op MEM_TAKE = TDB.find "MEM_TAKE"
  fun op MEM_BUTLASTN _ = () val op MEM_BUTLASTN = TDB.find "MEM_BUTLASTN"
  fun op MEM_LASTN _ = () val op MEM_LASTN = TDB.find "MEM_LASTN"
  fun op ZIP_SNOC _ = () val op ZIP_SNOC = TDB.find "ZIP_SNOC"
  fun op UNZIP_SNOC _ = () val op UNZIP_SNOC = TDB.find "UNZIP_SNOC"
  fun op LENGTH_UNZIP_FST _ = ()
  val op LENGTH_UNZIP_FST = TDB.find "LENGTH_UNZIP_FST"
  fun op LENGTH_UNZIP_SND _ = ()
  val op LENGTH_UNZIP_SND = TDB.find "LENGTH_UNZIP_SND"
  fun op SUM_REVERSE _ = () val op SUM_REVERSE = TDB.find "SUM_REVERSE"
  fun op SUM_FLAT _ = () val op SUM_FLAT = TDB.find "SUM_FLAT"
  fun op EL_APPEND1 _ = () val op EL_APPEND1 = TDB.find "EL_APPEND1"
  fun op EL_APPEND2 _ = () val op EL_APPEND2 = TDB.find "EL_APPEND2"
  fun op LUPDATE_APPEND2 _ = ()
  val op LUPDATE_APPEND2 = TDB.find "LUPDATE_APPEND2"
  fun op LUPDATE_APPEND1 _ = ()
  val op LUPDATE_APPEND1 = TDB.find "LUPDATE_APPEND1"
  fun op is_prefix_el _ = () val op is_prefix_el = TDB.find "is_prefix_el"
  fun op EL_CONS _ = () val op EL_CONS = TDB.find "EL_CONS"
  fun op SEG1 _ = () val op SEG1 = TDB.find "SEG1"
  fun op EL_SEG _ = () val op EL_SEG = TDB.find "EL_SEG"
  fun op SEG_CONS _ = () val op SEG_CONS = TDB.find "SEG_CONS"
  fun op SEG_SUC_EL _ = () val op SEG_SUC_EL = TDB.find "SEG_SUC_EL"
  fun op TAKE_SEG_DROP _ = ()
  val op TAKE_SEG_DROP = TDB.find "TAKE_SEG_DROP"
  fun op EL_MEM _ = () val op EL_MEM = TDB.find "EL_MEM"
  fun op TL_SNOC _ = () val op TL_SNOC = TDB.find "TL_SNOC"
  fun op EL_REVERSE_ELL _ = ()
  val op EL_REVERSE_ELL = TDB.find "EL_REVERSE_ELL"
  fun op ELL_LENGTH_APPEND _ = ()
  val op ELL_LENGTH_APPEND = TDB.find "ELL_LENGTH_APPEND"
  fun op ELL_MEM _ = () val op ELL_MEM = TDB.find "ELL_MEM"
  fun op ELL_REVERSE _ = () val op ELL_REVERSE = TDB.find "ELL_REVERSE"
  fun op ELL_REVERSE_EL _ = ()
  val op ELL_REVERSE_EL = TDB.find "ELL_REVERSE_EL"
  fun op TAKE_BUTLASTN _ = ()
  val op TAKE_BUTLASTN = TDB.find "TAKE_BUTLASTN"
  fun op BUTLASTN_TAKE _ = ()
  val op BUTLASTN_TAKE = TDB.find "BUTLASTN_TAKE"
  fun op LASTN_DROP _ = () val op LASTN_DROP = TDB.find "LASTN_DROP"
  fun op DROP_LASTN _ = () val op DROP_LASTN = TDB.find "DROP_LASTN"
  fun op SEG_LASTN_BUTLASTN _ = ()
  val op SEG_LASTN_BUTLASTN = TDB.find "SEG_LASTN_BUTLASTN"
  fun op DROP_REVERSE _ = () val op DROP_REVERSE = TDB.find "DROP_REVERSE"
  fun op BUTLASTN_REVERSE _ = ()
  val op BUTLASTN_REVERSE = TDB.find "BUTLASTN_REVERSE"
  fun op LASTN_REVERSE _ = ()
  val op LASTN_REVERSE = TDB.find "LASTN_REVERSE"
  fun op TAKE_REVERSE _ = () val op TAKE_REVERSE = TDB.find "TAKE_REVERSE"
  fun op SEG_REVERSE _ = () val op SEG_REVERSE = TDB.find "SEG_REVERSE"
  fun op LENGTH_REPLICATE _ = ()
  val op LENGTH_REPLICATE = TDB.find "LENGTH_REPLICATE"
  fun op MEM_REPLICATE _ = ()
  val op MEM_REPLICATE = TDB.find "MEM_REPLICATE"
  fun op EVERY_REPLICATE _ = ()
  val op EVERY_REPLICATE = TDB.find "EVERY_REPLICATE"
  fun op ALL_DISTINCT_DROP _ = ()
  val op ALL_DISTINCT_DROP = TDB.find "ALL_DISTINCT_DROP"
  fun op MAP_SND_FILTER_NEQ _ = ()
  val op MAP_SND_FILTER_NEQ = TDB.find "MAP_SND_FILTER_NEQ"
  fun op MEM_SING_APPEND _ = ()
  val op MEM_SING_APPEND = TDB.find "MEM_SING_APPEND"
  fun op EL_LENGTH_APPEND_rwt _ = ()
  val op EL_LENGTH_APPEND_rwt = TDB.find "EL_LENGTH_APPEND_rwt"
  fun op MAP_FST_funs _ = () val op MAP_FST_funs = TDB.find "MAP_FST_funs"
  fun op TAKE_PRE_LENGTH _ = ()
  val op TAKE_PRE_LENGTH = TDB.find "TAKE_PRE_LENGTH"
  fun op DROP_LENGTH_NIL_rwt _ = ()
  val op DROP_LENGTH_NIL_rwt = TDB.find "DROP_LENGTH_NIL_rwt"
  fun op DROP_EL_CONS _ = () val op DROP_EL_CONS = TDB.find "DROP_EL_CONS"
  fun op TAKE_EL_SNOC _ = () val op TAKE_EL_SNOC = TDB.find "TAKE_EL_SNOC"
  fun op REVERSE_DROP _ = () val op REVERSE_DROP = TDB.find "REVERSE_DROP"
  fun op LENGTH_FILTER_LESS _ = ()
  val op LENGTH_FILTER_LESS = TDB.find "LENGTH_FILTER_LESS"
  fun op EVERY2_APPEND _ = ()
  val op EVERY2_APPEND = TDB.find "EVERY2_APPEND"
  fun op EVERY2_APPEND_suff _ = ()
  val op EVERY2_APPEND_suff = TDB.find "EVERY2_APPEND_suff"
  fun op EVERY2_DROP _ = () val op EVERY2_DROP = TDB.find "EVERY2_DROP"
  fun op EVERY2_TAKE _ = () val op EVERY2_TAKE = TDB.find "EVERY2_TAKE"
  fun op LIST_REL_APPEND_SING _ = ()
  val op LIST_REL_APPEND_SING = TDB.find "LIST_REL_APPEND_SING"
  fun op LIST_REL_GENLIST _ = ()
  val op LIST_REL_GENLIST = TDB.find "LIST_REL_GENLIST"
  fun op ALL_DISTINCT_MEM_ZIP_MAP _ = ()
  val op ALL_DISTINCT_MEM_ZIP_MAP = TDB.find "ALL_DISTINCT_MEM_ZIP_MAP"
  fun op REVERSE_ZIP _ = () val op REVERSE_ZIP = TDB.find "REVERSE_ZIP"
  fun op EVERY2_REVERSE1 _ = ()
  val op EVERY2_REVERSE1 = TDB.find "EVERY2_REVERSE1"
  fun op LIST_REL_REVERSE_EQ _ = ()
  val op LIST_REL_REVERSE_EQ = TDB.find "LIST_REL_REVERSE_EQ"
  fun op every_count_list _ = ()
  val op every_count_list = TDB.find "every_count_list"
  fun op count_list_sub1 _ = ()
  val op count_list_sub1 = TDB.find "count_list_sub1"
  fun op el_map_count _ = () val op el_map_count = TDB.find "el_map_count"
  fun op ZIP_COUNT_LIST _ = ()
  val op ZIP_COUNT_LIST = TDB.find "ZIP_COUNT_LIST"
  fun op map_replicate _ = ()
  val op map_replicate = TDB.find "map_replicate"
  fun op REPLICATE_NIL _ = ()
  val op REPLICATE_NIL = TDB.find "REPLICATE_NIL"
  fun op REPLICATE_APPEND _ = ()
  val op REPLICATE_APPEND = TDB.find "REPLICATE_APPEND"
  fun op DROP_REPLICATE _ = ()
  val op DROP_REPLICATE = TDB.find "DROP_REPLICATE"
  fun op LIST_REL_REPLICATE_same _ = ()
  val op LIST_REL_REPLICATE_same = TDB.find "LIST_REL_REPLICATE_same"
  fun op SNOC_REPLICATE _ = ()
  val op SNOC_REPLICATE = TDB.find "SNOC_REPLICATE"
  fun op REVERSE_REPLICATE _ = ()
  val op REVERSE_REPLICATE = TDB.find "REVERSE_REPLICATE"
  fun op SUM_REPLICATE _ = ()
  val op SUM_REPLICATE = TDB.find "SUM_REPLICATE"
  fun op LENGTH_FLAT_REPLICATE _ = ()
  val op LENGTH_FLAT_REPLICATE = TDB.find "LENGTH_FLAT_REPLICATE"
  fun op take_drop_partition _ = ()
  val op take_drop_partition = TDB.find "take_drop_partition"
  fun op all_distinct_count_list _ = ()
  val op all_distinct_count_list = TDB.find "all_distinct_count_list"
  fun op list_rel_lastn _ = ()
  val op list_rel_lastn = TDB.find "list_rel_lastn"
  fun op list_rel_butlastn _ = ()
  val op list_rel_butlastn = TDB.find "list_rel_butlastn"
  fun op UNIQUE_LIST_ELEM_COUNT _ = ()
  val op UNIQUE_LIST_ELEM_COUNT = TDB.find "UNIQUE_LIST_ELEM_COUNT"
  fun op LIST_ELEM_COUNT_CARD_EL _ = ()
  val op LIST_ELEM_COUNT_CARD_EL = TDB.find "LIST_ELEM_COUNT_CARD_EL"
  fun op COUNT_LIST_compute _ = ()
  val op COUNT_LIST_compute = TDB.find "COUNT_LIST_compute"
  fun op SPLITP_compute _ = ()
  val op SPLITP_compute = TDB.find "SPLITP_compute"
  fun op IS_SUFFIX_compute _ = ()
  val op IS_SUFFIX_compute = TDB.find "IS_SUFFIX_compute"
  fun op SEG_compute _ = () val op SEG_compute = TDB.find "SEG_compute"
  fun op BUTLASTN_compute _ = ()
  val op BUTLASTN_compute = TDB.find "BUTLASTN_compute"
  fun op LASTN_compute _ = ()
  val op LASTN_compute = TDB.find "LASTN_compute"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val rich_list_grammars = merge_grammars ["list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="rich_list"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val rich_list_grammars = 
    Portable.## (addtyUDs,addtmUDs) rich_list_grammars
  val _ = Parse.grammarDB_insert("rich_list",rich_list_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val ALL_DISTINCT_SNOC = listTheory.ALL_DISTINCT_SNOC
  val ALL_EL = listTheory.EVERY_DEF
  val ALL_EL_APPEND = listTheory.EVERY_APPEND
  val ALL_EL_CONJ = listTheory.EVERY_CONJ
  val ALL_EL_SNOC = listTheory.EVERY_SNOC
  val APPEND = listTheory.APPEND
  val APPEND_11_LENGTH = listTheory.APPEND_11_LENGTH
  val APPEND_ASSOC = listTheory.APPEND_ASSOC
  val APPEND_BUTLAST_LAST = listTheory.APPEND_FRONT_LAST
  val APPEND_FIRSTN_BUTFIRSTN = listTheory.TAKE_DROP
  val APPEND_LENGTH_EQ = listTheory.APPEND_LENGTH_EQ
  val APPEND_SNOC = listTheory.APPEND_SNOC
  val BUTLAST = listTheory.FRONT_SNOC
  val BUTLAST_CONS = listTheory.FRONT_CONS
  val CONS = listTheory.CONS
  val CONS_11 = listTheory.CONS_11
  val EL = listTheory.EL
  val EL_DROP = listTheory.EL_DROP
  val EL_GENLIST = listTheory.EL_GENLIST
  val EL_LENGTH_SNOC = listTheory.EL_LENGTH_SNOC
  val EL_MAP = listTheory.EL_MAP
  val EL_REVERSE = listTheory.EL_REVERSE
  val EL_SNOC = listTheory.EL_SNOC
  val EL_TAKE = listTheory.EL_TAKE
  val EQ_LIST = listTheory.EQ_LIST
  val EVERY_GENLIST = listTheory.EVERY_GENLIST
  val EXISTS_GENLIST = listTheory.EXISTS_GENLIST
  val FILTER = listTheory.FILTER
  val FILTER_APPEND = listTheory.FILTER_APPEND_DISTRIB
  val FILTER_REVERSE = listTheory.FILTER_REVERSE
  val FIRSTN_LENGTH_ID = listTheory.TAKE_LENGTH_ID
  val FLAT = listTheory.FLAT
  val FLAT_APPEND = listTheory.FLAT_APPEND
  val FOLDL = listTheory.FOLDL
  val FOLDL_SNOC = listTheory.FOLDL_SNOC
  val FOLDR = listTheory.FOLDR
  val GENLIST = listTheory.GENLIST
  val GENLIST_APPEND = listTheory.GENLIST_APPEND
  val GENLIST_CONS = listTheory.GENLIST_CONS
  val GENLIST_FUN_EQ = listTheory.GENLIST_FUN_EQ
  val HD = listTheory.HD
  val HD_GENLIST = listTheory.HD_GENLIST
  val IS_EL = listTheory.MEM
  val IS_EL_APPEND = listTheory.MEM_APPEND
  val IS_EL_FILTER = listTheory.MEM_FILTER
  val IS_EL_REVERSE = listTheory.MEM_REVERSE
  val IS_EL_SNOC = listTheory.MEM_SNOC
  val LAST = listTheory.LAST_SNOC
  val LAST_APPEND = listTheory.LAST_APPEND_CONS
  val LAST_CONS = listTheory.LAST_CONS
  val LENGTH = listTheory.LENGTH
  val LENGTH_APPEND = listTheory.LENGTH_APPEND
  val LENGTH_BUTFIRSTN = listTheory.LENGTH_DROP
  val LENGTH_CONS = listTheory.LENGTH_CONS
  val LENGTH_EQ_NIL = listTheory.LENGTH_EQ_NIL
  val LENGTH_FIRSTN = listTheory.LENGTH_TAKE
  val LENGTH_GENLIST = listTheory.LENGTH_GENLIST
  val LENGTH_MAP = listTheory.LENGTH_MAP
  val LENGTH_NIL = listTheory.LENGTH_NIL
  val LENGTH_REVERSE = listTheory.LENGTH_REVERSE
  val LENGTH_SNOC = listTheory.LENGTH_SNOC
  val LENGTH_ZIP = listTheory.LENGTH_ZIP
  val LIST_NOT_EQ = listTheory.LIST_NOT_EQ
  val MAP = listTheory.MAP
  val MAP2 = listTheory.MAP2
  val MAP2_ZIP = listTheory.MAP2_ZIP
  val MAP_APPEND = listTheory.MAP_APPEND
  val MAP_EQ_f = listTheory.MAP_EQ_f
  val MAP_GENLIST = listTheory.MAP_GENLIST
  val MAP_MAP_o = listTheory.MAP_MAP_o
  val MAP_SNOC = listTheory.MAP_SNOC
  val MAP_o = listTheory.MAP_o
  val NOT_ALL_EL_SOME_EL = listTheory.NOT_EVERY
  val NOT_CONS_NIL = listTheory.NOT_CONS_NIL
  val NOT_EQ_LIST = listTheory.NOT_EQ_LIST
  val NOT_NIL_CONS = listTheory.NOT_NIL_CONS
  val NOT_SOME_EL_ALL_EL = listTheory.NOT_EXISTS
  val NULL = listTheory.NULL
  val NULL_DEF = listTheory.NULL_DEF
  val NULL_EQ_NIL = listTheory.NULL_EQ
  val REVERSE = listTheory.REVERSE_SNOC_DEF
  val REVERSE_APPEND = listTheory.REVERSE_APPEND
  val REVERSE_EQ_NIL = listTheory.REVERSE_EQ_NIL
  val REVERSE_REVERSE = listTheory.REVERSE_REVERSE
  val REVERSE_SNOC = listTheory.REVERSE_SNOC
  val SNOC = listTheory.SNOC
  val SNOC_11 = listTheory.SNOC_11
  val SNOC_APPEND = listTheory.SNOC_APPEND
  val SNOC_Axiom = listTheory.SNOC_Axiom
  val SNOC_CASES = listTheory.SNOC_CASES
  val SNOC_INDUCT = listTheory.SNOC_INDUCT
  val SOME_EL = listTheory.EXISTS_DEF
  val SOME_EL_APPEND = listTheory.EXISTS_APPEND
  val SOME_EL_MAP = listTheory.EXISTS_MAP
  val SOME_EL_SNOC = listTheory.EXISTS_SNOC
  val SUM = listTheory.SUM
  val SUM_APPEND = listTheory.SUM_APPEND
  val SUM_SNOC = listTheory.SUM_SNOC
  val TL = listTheory.TL
  val TL_GENLIST = listTheory.TL_GENLIST
  val UNZIP = listTheory.UNZIP
  val UNZIP_ZIP = listTheory.UNZIP_ZIP
  val ZIP = listTheory.ZIP
  val ZIP_GENLIST = listTheory.ZIP_GENLIST
  val ZIP_UNZIP = listTheory.ZIP_UNZIP
  val ALL_EL_BUTFIRSTN = EVERY_DROP
  val ALL_EL_BUTLASTN = EVERY_BUTLASTN
  val ALL_EL_FIRSTN = EVERY_TAKE
  val ALL_EL_FOLDL = EVERY_FOLDL
  val ALL_EL_FOLDL_MAP = EVERY_FOLDL_MAP
  val ALL_EL_FOLDR = EVERY_FOLDR
  val ALL_EL_FOLDR_MAP = EVERY_FOLDR_MAP
  val ALL_EL_LASTN = EVERY_LASTN
  val ALL_EL_REPLICATE = EVERY_REPLICATE
  val ALL_EL_REVERSE = EVERY_REVERSE
  val ALL_EL_SEG = EVERY_SEG
  val APPEND_BUTLASTN_BUTFIRSTN = APPEND_BUTLASTN_DROP
  val APPEND_FIRSTN_LASTN = APPEND_TAKE_LASTN
  val BUTFIRSTN = DROP
  val BUTFIRSTN_APPEND1 = DROP_APPEND1
  val BUTFIRSTN_APPEND2 = DROP_APPEND2
  val BUTFIRSTN_BUTFIRSTN = DROP_DROP
  val BUTFIRSTN_CONS_EL = DROP_CONS_EL
  val BUTFIRSTN_LASTN = DROP_LASTN
  val BUTFIRSTN_LENGTH_APPEND = DROP_LENGTH_APPEND
  val BUTFIRSTN_LENGTH_NIL = DROP_LENGTH_NIL
  val BUTFIRSTN_REVERSE = DROP_REVERSE
  val BUTFIRSTN_SEG = DROP_SEG
  val BUTFIRSTN_SNOC = DROP_SNOC
  val BUTLASTN_BUTLAST = BUTLASTN_FRONT
  val BUTLASTN_FIRSTN = BUTLASTN_TAKE
  val BUTLASTN_SUC_BUTLAST = BUTLASTN_SUC_FRONT
  val ELL_IS_EL = ELL_MEM
  val EL_BUTFIRSTN = EL_DROP
  val EL_FIRSTN = EL_TAKE
  val EL_IS_EL = EL_MEM
  val FIRSTN = TAKE
  val FIRSTN_APPEND1 = TAKE_APPEND1
  val FIRSTN_APPEND2 = TAKE_APPEND2
  val FIRSTN_BUTLASTN = TAKE_BUTLASTN
  val FIRSTN_FIRSTN = TAKE_TAKE
  val FIRSTN_LENGTH_APPEND = TAKE_LENGTH_APPEND
  val FIRSTN_REVERSE = TAKE_REVERSE
  val FIRSTN_SEG = TAKE_SEG
  val FIRSTN_SNOC = TAKE_SNOC
  val IS_EL_BUTFIRSTN = MEM_DROP_IMP
  val IS_EL_BUTLASTN = MEM_BUTLASTN
  val IS_EL_DEF = MEM_EXISTS
  val IS_EL_FIRSTN = MEM_TAKE
  val IS_EL_FOLDL = MEM_FOLDL
  val IS_EL_FOLDL_MAP = MEM_FOLDL_MAP
  val IS_EL_FOLDR = MEM_FOLDR
  val IS_EL_FOLDR_MAP = MEM_FOLDR_MAP
  val IS_EL_LASTN = MEM_LASTN
  val IS_EL_REPLICATE = MEM_REPLICATE
  val IS_EL_SEG = MEM_SEG
  val IS_EL_SOME_EL = MEM_EXISTS
  val LASTN_BUTFIRSTN = LASTN_DROP
  val LENGTH_BUTLAST = LENGTH_FRONT
  val SNOC_EL_FIRSTN = SNOC_EL_TAKE
  val SOME_EL_BUTFIRSTN = EXISTS_DROP
  val SOME_EL_BUTLASTN = EXISTS_BUTLASTN
  val SOME_EL_DISJ = EXISTS_DISJ
  val SOME_EL_FIRSTN = EXISTS_TAKE
  val SOME_EL_FOLDL = EXISTS_FOLDL
  val SOME_EL_FOLDL_MAP = EXISTS_FOLDL_MAP
  val SOME_EL_FOLDR = EXISTS_FOLDR
  val SOME_EL_FOLDR_MAP = EXISTS_FOLDR_MAP
  val SOME_EL_LASTN = EXISTS_LASTN
  val SOME_EL_REVERSE = EXISTS_REVERSE
  val SOME_EL_SEG = EXISTS_SEG
  val ZIP_FIRSTN = ZIP_TAKE
  val ZIP_FIRSTN_LEQ = ZIP_TAKE_LEQ
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "rich_list"

end
