structure markerTheory :> markerTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading markerTheory ... "
    else ()
  
  open Type Term Thm
  local open boolTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "marker"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/marker/markerTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op stmarker_def _ = () val op stmarker_def = TDB.find "stmarker_def"
  fun op unint_def _ = () val op unint_def = TDB.find "unint_def"
  fun op Abbrev_def _ = () val op Abbrev_def = TDB.find "Abbrev_def"
  fun op IfCases_def _ = () val op IfCases_def = TDB.find "IfCases_def"
  fun op AC_DEF _ = () val op AC_DEF = TDB.find "AC_DEF"
  fun op Req0_def _ = () val op Req0_def = TDB.find "Req0_def"
  fun op ReqD_def _ = () val op ReqD_def = TDB.find "ReqD_def"
  fun op Cong_def _ = () val op Cong_def = TDB.find "Cong_def"
  fun op Exclude_def _ = () val op Exclude_def = TDB.find "Exclude_def"
  fun op label_def _ = () val op label_def = TDB.find "label_def"
  fun op move_left_conj _ = ()
  val op move_left_conj = TDB.find "move_left_conj"
  fun op move_right_conj _ = ()
  val op move_right_conj = TDB.find "move_right_conj"
  fun op move_left_disj _ = ()
  val op move_left_disj = TDB.find "move_left_disj"
  fun op move_right_disj _ = ()
  val op move_right_disj = TDB.find "move_right_disj"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val marker_grammars = merge_grammars ["bool"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="marker"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val marker_grammars = 
    Portable.## (addtyUDs,addtmUDs) marker_grammars
  val _ = Parse.grammarDB_insert("marker",marker_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "marker"

end
