structure normalFormsTheory :> normalFormsTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading normalFormsTheory ... "
    else ()
  
  open Type Term Thm
  local open boolTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "normalForms"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/metis/normalFormsTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op EXT_POINT_DEF _ = ()
  val op EXT_POINT_DEF = TDB.find "EXT_POINT_DEF"
  fun op UNIV_POINT_DEF _ = ()
  val op UNIV_POINT_DEF = TDB.find "UNIV_POINT_DEF"
  fun op EXT_POINT _ = () val op EXT_POINT = TDB.find "EXT_POINT"
  fun op UNIV_POINT _ = () val op UNIV_POINT = TDB.find "UNIV_POINT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val normalForms_grammars = merge_grammars ["bool"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="normalForms"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val normalForms_grammars = 
    Portable.## (addtyUDs,addtmUDs) normalForms_grammars
  val _ = Parse.grammarDB_insert("normalForms",normalForms_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "normalForms"

end
