structure errorStateMonadTheory :> errorStateMonadTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading errorStateMonadTheory ... "
    else ()
  
  open Type Term Thm
  local open listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "errorStateMonad"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/monad/more_monads/errorStateMonadTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op UNIT_DEF _ = () val op UNIT_DEF = TDB.find "UNIT_DEF"
  fun op BIND_DEF _ = () val op BIND_DEF = TDB.find "BIND_DEF"
  fun op IGNORE_BIND_DEF _ = ()
  val op IGNORE_BIND_DEF = TDB.find "IGNORE_BIND_DEF"
  fun op MMAP_DEF _ = () val op MMAP_DEF = TDB.find "MMAP_DEF"
  fun op JOIN_DEF _ = () val op JOIN_DEF = TDB.find "JOIN_DEF"
  fun op EXT_DEF _ = () val op EXT_DEF = TDB.find "EXT_DEF"
  fun op MCOMP_DEF _ = () val op MCOMP_DEF = TDB.find "MCOMP_DEF"
  fun op FOR_primitive_def _ = ()
  val op FOR_primitive_def = TDB.find "FOR_primitive_def"
  fun op FOREACH_primitive_def _ = ()
  val op FOREACH_primitive_def = TDB.find "FOREACH_primitive_def"
  fun op READ_def _ = () val op READ_def = TDB.find "READ_def"
  fun op WRITE_def _ = () val op WRITE_def = TDB.find "WRITE_def"
  fun op NARROW_def _ = () val op NARROW_def = TDB.find "NARROW_def"
  fun op WIDEN_def _ = () val op WIDEN_def = TDB.find "WIDEN_def"
  fun op sequence_def _ = () val op sequence_def = TDB.find "sequence_def"
  fun op mapM_def _ = () val op mapM_def = TDB.find "mapM_def"
  fun op ES_FAIL_DEF _ = () val op ES_FAIL_DEF = TDB.find "ES_FAIL_DEF"
  fun op ES_CHOICE_DEF _ = ()
  val op ES_CHOICE_DEF = TDB.find "ES_CHOICE_DEF"
  fun op ES_GUARD_DEF _ = () val op ES_GUARD_DEF = TDB.find "ES_GUARD_DEF"
  fun op ES_APPLY_DEF _ = () val op ES_APPLY_DEF = TDB.find "ES_APPLY_DEF"
  fun op ES_LIFT2_DEF _ = () val op ES_LIFT2_DEF = TDB.find "ES_LIFT2_DEF"
  fun op FOR_ind _ = () val op FOR_ind = TDB.find "FOR_ind"
  fun op FOR_def _ = () val op FOR_def = TDB.find "FOR_def"
  fun op FOREACH_ind _ = () val op FOREACH_ind = TDB.find "FOREACH_ind"
  fun op FOREACH_def _ = () val op FOREACH_def = TDB.find "FOREACH_def"
  fun op BIND_LEFT_UNIT _ = ()
  val op BIND_LEFT_UNIT = TDB.find "BIND_LEFT_UNIT"
  fun op MCOMP_THM _ = () val op MCOMP_THM = TDB.find "MCOMP_THM"
  fun op MCOMP_ASSOC _ = () val op MCOMP_ASSOC = TDB.find "MCOMP_ASSOC"
  fun op UNIT_CURRY _ = () val op UNIT_CURRY = TDB.find "UNIT_CURRY"
  fun op MCOMP_ID _ = () val op MCOMP_ID = TDB.find "MCOMP_ID"
  fun op BIND_RIGHT_UNIT _ = ()
  val op BIND_RIGHT_UNIT = TDB.find "BIND_RIGHT_UNIT"
  fun op BIND_ASSOC _ = () val op BIND_ASSOC = TDB.find "BIND_ASSOC"
  fun op MMAP_ID _ = () val op MMAP_ID = TDB.find "MMAP_ID"
  fun op MMAP_COMP _ = () val op MMAP_COMP = TDB.find "MMAP_COMP"
  fun op MMAP_UNIT _ = () val op MMAP_UNIT = TDB.find "MMAP_UNIT"
  fun op MMAP_JOIN _ = () val op MMAP_JOIN = TDB.find "MMAP_JOIN"
  fun op JOIN_UNIT _ = () val op JOIN_UNIT = TDB.find "JOIN_UNIT"
  fun op JOIN_MMAP_UNIT _ = ()
  val op JOIN_MMAP_UNIT = TDB.find "JOIN_MMAP_UNIT"
  fun op JOIN_MAP_JOIN _ = ()
  val op JOIN_MAP_JOIN = TDB.find "JOIN_MAP_JOIN"
  fun op JOIN_MAP _ = () val op JOIN_MAP = TDB.find "JOIN_MAP"
  fun op sequence_nil _ = () val op sequence_nil = TDB.find "sequence_nil"
  fun op mapM_nil _ = () val op mapM_nil = TDB.find "mapM_nil"
  fun op mapM_cons _ = () val op mapM_cons = TDB.find "mapM_cons"
  fun op ES_CHOICE_ASSOC _ = ()
  val op ES_CHOICE_ASSOC = TDB.find "ES_CHOICE_ASSOC"
  fun op ES_CHOICE_FAIL_LID _ = ()
  val op ES_CHOICE_FAIL_LID = TDB.find "ES_CHOICE_FAIL_LID"
  fun op ES_CHOICE_FAIL_RID _ = ()
  val op ES_CHOICE_FAIL_RID = TDB.find "ES_CHOICE_FAIL_RID"
  fun op BIND_FAIL_L _ = () val op BIND_FAIL_L = TDB.find "BIND_FAIL_L"
  fun op BIND_ESGUARD _ = () val op BIND_ESGUARD = TDB.find "BIND_ESGUARD"
  fun op IGNORE_BIND_ESGUARD _ = ()
  val op IGNORE_BIND_ESGUARD = TDB.find "IGNORE_BIND_ESGUARD"
  fun op IGNORE_BIND_FAIL _ = ()
  val op IGNORE_BIND_FAIL = TDB.find "IGNORE_BIND_FAIL"
  fun op APPLY_UNIT _ = () val op APPLY_UNIT = TDB.find "APPLY_UNIT"
  fun op APPLY_UNIT_UNIT _ = ()
  val op APPLY_UNIT_UNIT = TDB.find "APPLY_UNIT_UNIT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val errorStateMonad_grammars = merge_grammars ["list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="errorStateMonad"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val errorStateMonad_grammars = 
    Portable.## (addtyUDs,addtmUDs) errorStateMonad_grammars
  val _ = Parse.grammarDB_insert("errorStateMonad",errorStateMonad_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "errorStateMonad"

end
