structure readerMonadTheory :> readerMonadTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading readerMonadTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "readerMonad"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/monad/more_monads/readerMonadTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op BIND_def _ = () val op BIND_def = TDB.find "BIND_def"
  fun op UNIT_def _ = () val op UNIT_def = TDB.find "UNIT_def"
  fun op MCOMPOSE_def _ = () val op MCOMPOSE_def = TDB.find "MCOMPOSE_def"
  fun op FMAP_def _ = () val op FMAP_def = TDB.find "FMAP_def"
  fun op JOIN_def _ = () val op JOIN_def = TDB.find "JOIN_def"
  fun op BIND_UNITR _ = () val op BIND_UNITR = TDB.find "BIND_UNITR"
  fun op BIND_UNITL _ = () val op BIND_UNITL = TDB.find "BIND_UNITL"
  fun op MCOMPOSE_LEFT_ID _ = ()
  val op MCOMPOSE_LEFT_ID = TDB.find "MCOMPOSE_LEFT_ID"
  fun op MCOMPOSE_RIGHT_ID _ = ()
  val op MCOMPOSE_RIGHT_ID = TDB.find "MCOMPOSE_RIGHT_ID"
  fun op MCOMPOSE_ASSOC _ = ()
  val op MCOMPOSE_ASSOC = TDB.find "MCOMPOSE_ASSOC"
  fun op FMAP_ID _ = () val op FMAP_ID = TDB.find "FMAP_ID"
  fun op FMAP_o _ = () val op FMAP_o = TDB.find "FMAP_o"
  fun op FMAP_BIND _ = () val op FMAP_BIND = TDB.find "FMAP_BIND"
  fun op BIND_JOIN _ = () val op BIND_JOIN = TDB.find "BIND_JOIN"
  fun op JOIN_BIND _ = () val op JOIN_BIND = TDB.find "JOIN_BIND"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val readerMonad_grammars = merge_grammars ["indexedLists",
  "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="readerMonad"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val readerMonad_grammars = 
    Portable.## (addtyUDs,addtmUDs) readerMonad_grammars
  val _ = Parse.grammarDB_insert("readerMonad",readerMonad_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "readerMonad"

end
