structure state_transformerTheory :> state_transformerTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading state_transformerTheory ... "
    else ()
  
  open Type Term Thm
  local open listTheory monadsyntax in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "state_transformer"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/monad/more_monads/state_transformerTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op UNIT_DEF _ = () val op UNIT_DEF = TDB.find "UNIT_DEF"
  fun op BIND_DEF _ = () val op BIND_DEF = TDB.find "BIND_DEF"
  fun op IGNORE_BIND_DEF _ = ()
  val op IGNORE_BIND_DEF = TDB.find "IGNORE_BIND_DEF"
  fun op MMAP_DEF _ = () val op MMAP_DEF = TDB.find "MMAP_DEF"
  fun op JOIN_DEF _ = () val op JOIN_DEF = TDB.find "JOIN_DEF"
  fun op EXT_DEF _ = () val op EXT_DEF = TDB.find "EXT_DEF"
  fun op MCOMP_DEF _ = () val op MCOMP_DEF = TDB.find "MCOMP_DEF"
  fun op FOR_primitive_def _ = ()
  val op FOR_primitive_def = TDB.find "FOR_primitive_def"
  fun op FOREACH_primitive_def _ = ()
  val op FOREACH_primitive_def = TDB.find "FOREACH_primitive_def"
  fun op READ_def _ = () val op READ_def = TDB.find "READ_def"
  fun op WRITE_def _ = () val op WRITE_def = TDB.find "WRITE_def"
  fun op NARROW_def _ = () val op NARROW_def = TDB.find "NARROW_def"
  fun op WIDEN_def _ = () val op WIDEN_def = TDB.find "WIDEN_def"
  fun op sequence_def _ = () val op sequence_def = TDB.find "sequence_def"
  fun op mapM_def _ = () val op mapM_def = TDB.find "mapM_def"
  fun op MWHILE_DEF _ = () val op MWHILE_DEF = TDB.find "MWHILE_DEF"
  fun op FOR_ind _ = () val op FOR_ind = TDB.find "FOR_ind"
  fun op FOR_def _ = () val op FOR_def = TDB.find "FOR_def"
  fun op FOREACH_ind _ = () val op FOREACH_ind = TDB.find "FOREACH_ind"
  fun op FOREACH_def _ = () val op FOREACH_def = TDB.find "FOREACH_def"
  fun op UNIT_CURRY _ = () val op UNIT_CURRY = TDB.find "UNIT_CURRY"
  fun op MCOMP_ALT _ = () val op MCOMP_ALT = TDB.find "MCOMP_ALT"
  fun op MCOMP_ID _ = () val op MCOMP_ID = TDB.find "MCOMP_ID"
  fun op MCOMP_ASSOC _ = () val op MCOMP_ASSOC = TDB.find "MCOMP_ASSOC"
  fun op EXT_UNIT _ = () val op EXT_UNIT = TDB.find "EXT_UNIT"
  fun op EXT_MCOMP _ = () val op EXT_MCOMP = TDB.find "EXT_MCOMP"
  fun op EXT_o_UNIT _ = () val op EXT_o_UNIT = TDB.find "EXT_o_UNIT"
  fun op UNIT_o_MCOMP _ = () val op UNIT_o_MCOMP = TDB.find "UNIT_o_MCOMP"
  fun op BIND_EXT _ = () val op BIND_EXT = TDB.find "BIND_EXT"
  fun op MMAP_EXT _ = () val op MMAP_EXT = TDB.find "MMAP_EXT"
  fun op JOIN_EXT _ = () val op JOIN_EXT = TDB.find "JOIN_EXT"
  fun op EXT_JM _ = () val op EXT_JM = TDB.find "EXT_JM"
  fun op BIND_LEFT_UNIT _ = ()
  val op BIND_LEFT_UNIT = TDB.find "BIND_LEFT_UNIT"
  fun op UNIT_UNCURRY _ = () val op UNIT_UNCURRY = TDB.find "UNIT_UNCURRY"
  fun op BIND_RIGHT_UNIT _ = ()
  val op BIND_RIGHT_UNIT = TDB.find "BIND_RIGHT_UNIT"
  fun op BIND_ASSOC _ = () val op BIND_ASSOC = TDB.find "BIND_ASSOC"
  fun op MMAP_ID _ = () val op MMAP_ID = TDB.find "MMAP_ID"
  fun op MMAP_COMP _ = () val op MMAP_COMP = TDB.find "MMAP_COMP"
  fun op MMAP_UNIT _ = () val op MMAP_UNIT = TDB.find "MMAP_UNIT"
  fun op EXT_o_JOIN _ = () val op EXT_o_JOIN = TDB.find "EXT_o_JOIN"
  fun op MMAP_JOIN _ = () val op MMAP_JOIN = TDB.find "MMAP_JOIN"
  fun op JOIN_UNIT _ = () val op JOIN_UNIT = TDB.find "JOIN_UNIT"
  fun op JOIN_MMAP_UNIT _ = ()
  val op JOIN_MMAP_UNIT = TDB.find "JOIN_MMAP_UNIT"
  fun op JOIN_MAP_JOIN _ = ()
  val op JOIN_MAP_JOIN = TDB.find "JOIN_MAP_JOIN"
  fun op JOIN_MAP _ = () val op JOIN_MAP = TDB.find "JOIN_MAP"
  fun op FST_o_UNIT _ = () val op FST_o_UNIT = TDB.find "FST_o_UNIT"
  fun op SND_o_UNIT _ = () val op SND_o_UNIT = TDB.find "SND_o_UNIT"
  fun op FST_o_MMAP _ = () val op FST_o_MMAP = TDB.find "FST_o_MMAP"
  fun op sequence_nil _ = () val op sequence_nil = TDB.find "sequence_nil"
  fun op mapM_nil _ = () val op mapM_nil = TDB.find "mapM_nil"
  fun op mapM_cons _ = () val op mapM_cons = TDB.find "mapM_cons"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val state_transformer_grammars = merge_grammars ["list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="state_transformer"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val state_transformer_grammars = 
    Portable.## (addtyUDs,addtmUDs) state_transformer_grammars
  val _ = Parse.grammarDB_insert("state_transformer",state_transformer_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "state_transformer"

end
