structure alignmentTheory :> alignmentTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading alignmentTheory ... "
    else ()
  
  open Type Term Thm
  local open wordsTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "alignment"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/n-bit/alignmentTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op align_def _ = () val op align_def = TDB.find "align_def"
  fun op aligned_def _ = () val op aligned_def = TDB.find "aligned_def"
  fun op byte_align_def _ = ()
  val op byte_align_def = TDB.find "byte_align_def"
  fun op byte_aligned_def _ = ()
  val op byte_aligned_def = TDB.find "byte_aligned_def"
  fun op align_0 _ = () val op align_0 = TDB.find "align_0"
  fun op align_align _ = () val op align_align = TDB.find "align_align"
  fun op aligned_align _ = ()
  val op aligned_align = TDB.find "aligned_align"
  fun op align_aligned _ = ()
  val op align_aligned = TDB.find "align_aligned"
  fun op align_bitwise_and _ = ()
  val op align_bitwise_and = TDB.find "align_bitwise_and"
  fun op align_shift _ = () val op align_shift = TDB.find "align_shift"
  fun op align_w2n _ = () val op align_w2n = TDB.find "align_w2n"
  fun op align_sub _ = () val op align_sub = TDB.find "align_sub"
  fun op aligned_extract _ = ()
  val op aligned_extract = TDB.find "aligned_extract"
  fun op aligned_0 _ = () val op aligned_0 = TDB.find "aligned_0"
  fun op aligned_1_lsb _ = ()
  val op aligned_1_lsb = TDB.find "aligned_1_lsb"
  fun op aligned_ge_dim _ = ()
  val op aligned_ge_dim = TDB.find "aligned_ge_dim"
  fun op aligned_bitwise_and _ = ()
  val op aligned_bitwise_and = TDB.find "aligned_bitwise_and"
  fun op aligned_bit_count_upto _ = ()
  val op aligned_bit_count_upto = TDB.find "aligned_bit_count_upto"
  fun op aligned_add_sub _ = ()
  val op aligned_add_sub = TDB.find "aligned_add_sub"
  fun op aligned_add_sub_cor _ = ()
  val op aligned_add_sub_cor = TDB.find "aligned_add_sub_cor"
  fun op aligned_mul_shift_1 _ = ()
  val op aligned_mul_shift_1 = TDB.find "aligned_mul_shift_1"
  fun op aligned_add_sub_prod _ = ()
  val op aligned_add_sub_prod = TDB.find "aligned_add_sub_prod"
  fun op aligned_imp _ = () val op aligned_imp = TDB.find "aligned_imp"
  fun op align_add_aligned _ = ()
  val op align_add_aligned = TDB.find "align_add_aligned"
  fun op lt_align_eq_0 _ = ()
  val op lt_align_eq_0 = TDB.find "lt_align_eq_0"
  fun op aligned_or _ = () val op aligned_or = TDB.find "aligned_or"
  fun op aligned_w2n _ = () val op aligned_w2n = TDB.find "aligned_w2n"
  fun op MOD_0_aligned _ = ()
  val op MOD_0_aligned = TDB.find "MOD_0_aligned"
  fun op aligned_lsl_leq _ = ()
  val op aligned_lsl_leq = TDB.find "aligned_lsl_leq"
  fun op aligned_lsl _ = () val op aligned_lsl = TDB.find "aligned_lsl"
  fun op align_align_MAX _ = ()
  val op align_align_MAX = TDB.find "align_align_MAX"
  fun op pow2_eq_0 _ = () val op pow2_eq_0 = TDB.find "pow2_eq_0"
  fun op aligned_pow2 _ = () val op aligned_pow2 = TDB.find "aligned_pow2"
  fun op word_msb_align _ = ()
  val op word_msb_align = TDB.find "word_msb_align"
  fun op align_ls _ = () val op align_ls = TDB.find "align_ls"
  fun op align_lo _ = () val op align_lo = TDB.find "align_lo"
  fun op aligned_between _ = ()
  val op aligned_between = TDB.find "aligned_between"
  fun op aligned_add_pow _ = ()
  val op aligned_add_pow = TDB.find "aligned_add_pow"
  fun op align_add_aligned_gen _ = ()
  val op align_add_aligned_gen = TDB.find "align_add_aligned_gen"
  fun op byte_align_aligned _ = ()
  val op byte_align_aligned = TDB.find "byte_align_aligned"
  fun op byte_aligned_add _ = ()
  val op byte_aligned_add = TDB.find "byte_aligned_add"
  fun op aligned_add_sub_123 _ = ()
  val op aligned_add_sub_123 = TDB.find "aligned_add_sub_123"
  fun op aligned_numeric _ = ()
  val op aligned_numeric = TDB.find "aligned_numeric"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val alignment_grammars = merge_grammars ["words"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="alignment"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val alignment_grammars = 
    Portable.## (addtyUDs,addtmUDs) alignment_grammars
  val _ = Parse.grammarDB_insert("alignment",alignment_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "alignment"

end
