structure bitstringTheory :> bitstringTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading bitstringTheory ... "
    else ()
  
  open Type Term Thm
  local open wordsTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "bitstring"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/n-bit/bitstringTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op extend_def _ = () val op extend_def = TDB.find "extend_def"
  fun op boolify_def _ = () val op boolify_def = TDB.find "boolify_def"
  fun op n2v_def _ = () val op n2v_def = TDB.find "n2v_def"
  fun op v2n_def _ = () val op v2n_def = TDB.find "v2n_def"
  fun op s2v_def _ = () val op s2v_def = TDB.find "s2v_def"
  fun op v2s_def _ = () val op v2s_def = TDB.find "v2s_def"
  fun op zero_extend_def _ = ()
  val op zero_extend_def = TDB.find "zero_extend_def"
  fun op sign_extend_def _ = ()
  val op sign_extend_def = TDB.find "sign_extend_def"
  fun op fixwidth_def _ = () val op fixwidth_def = TDB.find "fixwidth_def"
  fun op shiftl_def _ = () val op shiftl_def = TDB.find "shiftl_def"
  fun op shiftr_def _ = () val op shiftr_def = TDB.find "shiftr_def"
  fun op field_def _ = () val op field_def = TDB.find "field_def"
  fun op rotate_def _ = () val op rotate_def = TDB.find "rotate_def"
  fun op testbit_def _ = () val op testbit_def = TDB.find "testbit_def"
  fun op w2v_def _ = () val op w2v_def = TDB.find "w2v_def"
  fun op v2w_def _ = () val op v2w_def = TDB.find "v2w_def"
  fun op rev_count_list_def _ = ()
  val op rev_count_list_def = TDB.find "rev_count_list_def"
  fun op modify_def _ = () val op modify_def = TDB.find "modify_def"
  fun op field_insert_def _ = ()
  val op field_insert_def = TDB.find "field_insert_def"
  fun op add_def _ = () val op add_def = TDB.find "add_def"
  fun op bitwise_def _ = () val op bitwise_def = TDB.find "bitwise_def"
  fun op bnot_def _ = () val op bnot_def = TDB.find "bnot_def"
  fun op bor_def _ = () val op bor_def = TDB.find "bor_def"
  fun op band_def _ = () val op band_def = TDB.find "band_def"
  fun op bxor_def _ = () val op bxor_def = TDB.find "bxor_def"
  fun op bnor_def _ = () val op bnor_def = TDB.find "bnor_def"
  fun op bxnor_def _ = () val op bxnor_def = TDB.find "bxnor_def"
  fun op bnand_def _ = () val op bnand_def = TDB.find "bnand_def"
  fun op replicate_def _ = ()
  val op replicate_def = TDB.find "replicate_def"
  fun op extend_compute _ = ()
  val op extend_compute = TDB.find "extend_compute"
  fun op bitify_ind _ = () val op bitify_ind = TDB.find "bitify_ind"
  fun op bitify_def _ = () val op bitify_def = TDB.find "bitify_def"
  fun op extend_cons _ = () val op extend_cons = TDB.find "extend_cons"
  fun op pad_left_extend _ = ()
  val op pad_left_extend = TDB.find "pad_left_extend"
  fun op extend _ = () val op extend = TDB.find "extend"
  fun op fixwidth _ = () val op fixwidth = TDB.find "fixwidth"
  fun op fixwidth_id _ = () val op fixwidth_id = TDB.find "fixwidth_id"
  fun op fixwidth_id_imp _ = ()
  val op fixwidth_id_imp = TDB.find "fixwidth_id_imp"
  fun op boolify_reverse_map _ = ()
  val op boolify_reverse_map = TDB.find "boolify_reverse_map"
  fun op bitify_reverse_map _ = ()
  val op bitify_reverse_map = TDB.find "bitify_reverse_map"
  fun op every_bit_bitify _ = ()
  val op every_bit_bitify = TDB.find "every_bit_bitify"
  fun op length_pad_left _ = ()
  val op length_pad_left = TDB.find "length_pad_left"
  fun op length_pad_right _ = ()
  val op length_pad_right = TDB.find "length_pad_right"
  fun op length_zero_extend _ = ()
  val op length_zero_extend = TDB.find "length_zero_extend"
  fun op length_sign_extend _ = ()
  val op length_sign_extend = TDB.find "length_sign_extend"
  fun op length_fixwidth _ = ()
  val op length_fixwidth = TDB.find "length_fixwidth"
  fun op length_field _ = () val op length_field = TDB.find "length_field"
  fun op length_bitify _ = ()
  val op length_bitify = TDB.find "length_bitify"
  fun op length_bitify_null _ = ()
  val op length_bitify_null = TDB.find "length_bitify_null"
  fun op length_shiftr _ = ()
  val op length_shiftr = TDB.find "length_shiftr"
  fun op length_rev_count_list _ = ()
  val op length_rev_count_list = TDB.find "length_rev_count_list"
  fun op length_w2v _ = () val op length_w2v = TDB.find "length_w2v"
  fun op length_rotate _ = ()
  val op length_rotate = TDB.find "length_rotate"
  fun op el_rev_count_list _ = ()
  val op el_rev_count_list = TDB.find "el_rev_count_list"
  fun op el_zero_extend _ = ()
  val op el_zero_extend = TDB.find "el_zero_extend"
  fun op el_sign_extend _ = ()
  val op el_sign_extend = TDB.find "el_sign_extend"
  fun op el_fixwidth _ = () val op el_fixwidth = TDB.find "el_fixwidth"
  fun op el_field _ = () val op el_field = TDB.find "el_field"
  fun op el_w2v _ = () val op el_w2v = TDB.find "el_w2v"
  fun op el_shiftr _ = () val op el_shiftr = TDB.find "el_shiftr"
  fun op shiftr_0 _ = () val op shiftr_0 = TDB.find "shiftr_0"
  fun op field_fixwidth _ = ()
  val op field_fixwidth = TDB.find "field_fixwidth"
  fun op testbit _ = () val op testbit = TDB.find "testbit"
  fun op testbit_geq_len _ = ()
  val op testbit_geq_len = TDB.find "testbit_geq_len"
  fun op testbit_el _ = () val op testbit_el = TDB.find "testbit_el"
  fun op bit_v2w _ = () val op bit_v2w = TDB.find "bit_v2w"
  fun op word_index_v2w _ = ()
  val op word_index_v2w = TDB.find "word_index_v2w"
  fun op testbit_w2v _ = () val op testbit_w2v = TDB.find "testbit_w2v"
  fun op w2v_v2w _ = () val op w2v_v2w = TDB.find "w2v_v2w"
  fun op v2w_w2v _ = () val op v2w_w2v = TDB.find "v2w_w2v"
  fun op v2w_fixwidth _ = () val op v2w_fixwidth = TDB.find "v2w_fixwidth"
  fun op fixwidth_fixwidth _ = ()
  val op fixwidth_fixwidth = TDB.find "fixwidth_fixwidth"
  fun op bitstring_nchotomy _ = ()
  val op bitstring_nchotomy = TDB.find "bitstring_nchotomy"
  fun op ranged_bitstring_nchotomy _ = ()
  val op ranged_bitstring_nchotomy = TDB.find "ranged_bitstring_nchotomy"
  fun op fixwidth_eq _ = () val op fixwidth_eq = TDB.find "fixwidth_eq"
  fun op v2w_11 _ = () val op v2w_11 = TDB.find "v2w_11"
  fun op field_concat_right _ = ()
  val op field_concat_right = TDB.find "field_concat_right"
  fun op field_concat_left _ = ()
  val op field_concat_left = TDB.find "field_concat_left"
  fun op field_id_imp _ = () val op field_id_imp = TDB.find "field_id_imp"
  fun op shiftl_replicate_F _ = ()
  val op shiftl_replicate_F = TDB.find "shiftl_replicate_F"
  fun op word_lsb_v2w _ = () val op word_lsb_v2w = TDB.find "word_lsb_v2w"
  fun op word_msb_v2w _ = () val op word_msb_v2w = TDB.find "word_msb_v2w"
  fun op w2w_v2w _ = () val op w2w_v2w = TDB.find "w2w_v2w"
  fun op sw2sw_v2w _ = () val op sw2sw_v2w = TDB.find "sw2sw_v2w"
  fun op n2w_v2n _ = () val op n2w_v2n = TDB.find "n2w_v2n"
  fun op v2n_n2v _ = () val op v2n_n2v = TDB.find "v2n_n2v"
  fun op v2w_n2v _ = () val op v2w_n2v = TDB.find "v2w_n2v"
  fun op w2n_v2w _ = () val op w2n_v2w = TDB.find "w2n_v2w"
  fun op v2n_lt _ = () val op v2n_lt = TDB.find "v2n_lt"
  fun op word_and_v2w _ = () val op word_and_v2w = TDB.find "word_and_v2w"
  fun op word_or_v2w _ = () val op word_or_v2w = TDB.find "word_or_v2w"
  fun op word_xor_v2w _ = () val op word_xor_v2w = TDB.find "word_xor_v2w"
  fun op word_nand_v2w _ = ()
  val op word_nand_v2w = TDB.find "word_nand_v2w"
  fun op word_nor_v2w _ = () val op word_nor_v2w = TDB.find "word_nor_v2w"
  fun op word_xnor_v2w _ = ()
  val op word_xnor_v2w = TDB.find "word_xnor_v2w"
  fun op word_1comp_v2w _ = ()
  val op word_1comp_v2w = TDB.find "word_1comp_v2w"
  fun op word_lsl_v2w _ = () val op word_lsl_v2w = TDB.find "word_lsl_v2w"
  fun op word_lsr_v2w _ = () val op word_lsr_v2w = TDB.find "word_lsr_v2w"
  fun op word_modify_v2w _ = ()
  val op word_modify_v2w = TDB.find "word_modify_v2w"
  fun op word_bits_v2w _ = ()
  val op word_bits_v2w = TDB.find "word_bits_v2w"
  fun op word_extract_v2w _ = ()
  val op word_extract_v2w = TDB.find "word_extract_v2w"
  fun op word_slice_v2w _ = ()
  val op word_slice_v2w = TDB.find "word_slice_v2w"
  fun op word_asr_v2w _ = () val op word_asr_v2w = TDB.find "word_asr_v2w"
  fun op word_ror_v2w _ = () val op word_ror_v2w = TDB.find "word_ror_v2w"
  fun op word_reverse_v2w _ = ()
  val op word_reverse_v2w = TDB.find "word_reverse_v2w"
  fun op word_join_v2w _ = ()
  val op word_join_v2w = TDB.find "word_join_v2w"
  fun op word_concat_v2w _ = ()
  val op word_concat_v2w = TDB.find "word_concat_v2w"
  fun op word_join_v2w_rwt _ = ()
  val op word_join_v2w_rwt = TDB.find "word_join_v2w_rwt"
  fun op word_concat_v2w_rwt _ = ()
  val op word_concat_v2w_rwt = TDB.find "word_concat_v2w_rwt"
  fun op word_reduce_v2w _ = ()
  val op word_reduce_v2w = TDB.find "word_reduce_v2w"
  fun op reduce_and_v2w _ = ()
  val op reduce_and_v2w = TDB.find "reduce_and_v2w"
  fun op reduce_or_v2w _ = ()
  val op reduce_or_v2w = TDB.find "reduce_or_v2w"
  fun op extract_v2w _ = () val op extract_v2w = TDB.find "extract_v2w"
  fun op word_bit_last_shiftr _ = ()
  val op word_bit_last_shiftr = TDB.find "word_bit_last_shiftr"
  fun op ops_to_v2w _ = () val op ops_to_v2w = TDB.find "ops_to_v2w"
  fun op ops_to_n2w _ = () val op ops_to_n2w = TDB.find "ops_to_n2w"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val bitstring_grammars = merge_grammars ["words"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="bitstring"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val bitstring_grammars = 
    Portable.## (addtyUDs,addtmUDs) bitstring_grammars
  val _ = Parse.grammarDB_insert("bitstring",bitstring_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "bitstring"

end
