structure blastTheory :> blastTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading blastTheory ... "
    else ()
  
  open Type Term Thm
  local open wordsTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "blast"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/n-bit/blastTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op bcarry_def _ = () val op bcarry_def = TDB.find "bcarry_def"
  fun op BCARRY_def _ = () val op BCARRY_def = TDB.find "BCARRY_def"
  fun op bsum_def _ = () val op bsum_def = TDB.find "bsum_def"
  fun op BSUM_def _ = () val op BSUM_def = TDB.find "BSUM_def"
  fun op BCARRY_compute _ = ()
  val op BCARRY_compute = TDB.find "BCARRY_compute"
  fun op BCARRY_LEM _ = () val op BCARRY_LEM = TDB.find "BCARRY_LEM"
  fun op BCARRY_EQ _ = () val op BCARRY_EQ = TDB.find "BCARRY_EQ"
  fun op BSUM_EQ _ = () val op BSUM_EQ = TDB.find "BSUM_EQ"
  fun op BSUM_LEM _ = () val op BSUM_LEM = TDB.find "BSUM_LEM"
  fun op BITWISE_ADD _ = () val op BITWISE_ADD = TDB.find "BITWISE_ADD"
  fun op BITWISE_SUB _ = () val op BITWISE_SUB = TDB.find "BITWISE_SUB"
  fun op BITWISE_LO _ = () val op BITWISE_LO = TDB.find "BITWISE_LO"
  fun op BITWISE_MUL _ = () val op BITWISE_MUL = TDB.find "BITWISE_MUL"
  fun op word_lsl_bv_expand _ = ()
  val op word_lsl_bv_expand = TDB.find "word_lsl_bv_expand"
  fun op word_lsr_bv_expand _ = ()
  val op word_lsr_bv_expand = TDB.find "word_lsr_bv_expand"
  fun op word_asr_bv_expand _ = ()
  val op word_asr_bv_expand = TDB.find "word_asr_bv_expand"
  fun op word_ror_bv_expand _ = ()
  val op word_ror_bv_expand = TDB.find "word_ror_bv_expand"
  fun op word_rol_bv_expand _ = ()
  val op word_rol_bv_expand = TDB.find "word_rol_bv_expand"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val blast_grammars = merge_grammars ["words"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="blast"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val blast_grammars = 
    Portable.## (addtyUDs,addtmUDs) blast_grammars
  val _ = Parse.grammarDB_insert("blast",blast_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "blast"

end
