structure fcpTheory :> fcpTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading fcpTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "fcp"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/n-bit/fcpTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op HAS_SIZE_def _ = () val op HAS_SIZE_def = TDB.find "HAS_SIZE_def"
  fun op finite_image_TY_DEF _ = ()
  val op finite_image_TY_DEF = TDB.find "finite_image_TY_DEF"
  fun op finite_image_tybij _ = ()
  val op finite_image_tybij = TDB.find "finite_image_tybij"
  fun op dimindex_def _ = () val op dimindex_def = TDB.find "dimindex_def"
  fun op finite_index_def _ = ()
  val op finite_index_def = TDB.find "finite_index_def"
  fun op cart_TY_DEF _ = () val op cart_TY_DEF = TDB.find "cart_TY_DEF"
  fun op cart_tybij _ = () val op cart_tybij = TDB.find "cart_tybij"
  fun op fcp_index _ = () val op fcp_index = TDB.find "fcp_index"
  fun op fcp_case_def _ = () val op fcp_case_def = TDB.find "fcp_case_def"
  fun op FCP _ = () val op FCP = TDB.find "FCP"
  fun op bit0_TY_DEF _ = () val op bit0_TY_DEF = TDB.find "bit0_TY_DEF"
  fun op bit0_case_def _ = ()
  val op bit0_case_def = TDB.find "bit0_case_def"
  fun op bit0_size_def _ = ()
  val op bit0_size_def = TDB.find "bit0_size_def"
  fun op bit1_TY_DEF _ = () val op bit1_TY_DEF = TDB.find "bit1_TY_DEF"
  fun op bit1_case_def _ = ()
  val op bit1_case_def = TDB.find "bit1_case_def"
  fun op bit1_size_def _ = ()
  val op bit1_size_def = TDB.find "bit1_size_def"
  fun op FCP_UPDATE_def _ = ()
  val op FCP_UPDATE_def = TDB.find "FCP_UPDATE_def"
  fun op FCP_HD_def _ = () val op FCP_HD_def = TDB.find "FCP_HD_def"
  fun op FCP_TL_def _ = () val op FCP_TL_def = TDB.find "FCP_TL_def"
  fun op FCP_CONS_def _ = () val op FCP_CONS_def = TDB.find "FCP_CONS_def"
  fun op FCP_MAP_def _ = () val op FCP_MAP_def = TDB.find "FCP_MAP_def"
  fun op FCP_EXISTS_def _ = ()
  val op FCP_EXISTS_def = TDB.find "FCP_EXISTS_def"
  fun op FCP_EVERY_def _ = ()
  val op FCP_EVERY_def = TDB.find "FCP_EVERY_def"
  fun op FCP_CONCAT_def _ = ()
  val op FCP_CONCAT_def = TDB.find "FCP_CONCAT_def"
  fun op FCP_ZIP_def _ = () val op FCP_ZIP_def = TDB.find "FCP_ZIP_def"
  fun op V2L_def _ = () val op V2L_def = TDB.find "V2L_def"
  fun op L2V_def _ = () val op L2V_def = TDB.find "L2V_def"
  fun op FCP_FOLD_def _ = () val op FCP_FOLD_def = TDB.find "FCP_FOLD_def"
  fun op NOT_FINITE_IMP_dimindex_1 _ = ()
  val op NOT_FINITE_IMP_dimindex_1 = TDB.find "NOT_FINITE_IMP_dimindex_1"
  fun op DIMINDEX_GE_1 _ = ()
  val op DIMINDEX_GE_1 = TDB.find "DIMINDEX_GE_1"
  fun op fcp_Axiom _ = () val op fcp_Axiom = TDB.find "fcp_Axiom"
  fun op fcp_ind _ = () val op fcp_ind = TDB.find "fcp_ind"
  fun op CART_EQ _ = () val op CART_EQ = TDB.find "CART_EQ"
  fun op FCP_BETA _ = () val op FCP_BETA = TDB.find "FCP_BETA"
  fun op FCP_UNIQUE _ = () val op FCP_UNIQUE = TDB.find "FCP_UNIQUE"
  fun op FCP_ETA _ = () val op FCP_ETA = TDB.find "FCP_ETA"
  fun op card_dimindex _ = ()
  val op card_dimindex = TDB.find "card_dimindex"
  fun op index_sum _ = () val op index_sum = TDB.find "index_sum"
  fun op finite_sum _ = () val op finite_sum = TDB.find "finite_sum"
  fun op datatype_bit0 _ = ()
  val op datatype_bit0 = TDB.find "datatype_bit0"
  fun op bit0_11 _ = () val op bit0_11 = TDB.find "bit0_11"
  fun op bit0_distinct _ = ()
  val op bit0_distinct = TDB.find "bit0_distinct"
  fun op bit0_nchotomy _ = ()
  val op bit0_nchotomy = TDB.find "bit0_nchotomy"
  fun op bit0_Axiom _ = () val op bit0_Axiom = TDB.find "bit0_Axiom"
  fun op bit0_induction _ = ()
  val op bit0_induction = TDB.find "bit0_induction"
  fun op bit0_case_cong _ = ()
  val op bit0_case_cong = TDB.find "bit0_case_cong"
  fun op bit0_case_eq _ = () val op bit0_case_eq = TDB.find "bit0_case_eq"
  fun op index_bit0 _ = () val op index_bit0 = TDB.find "index_bit0"
  fun op finite_bit0 _ = () val op finite_bit0 = TDB.find "finite_bit0"
  fun op datatype_bit1 _ = ()
  val op datatype_bit1 = TDB.find "datatype_bit1"
  fun op bit1_11 _ = () val op bit1_11 = TDB.find "bit1_11"
  fun op bit1_distinct _ = ()
  val op bit1_distinct = TDB.find "bit1_distinct"
  fun op bit1_nchotomy _ = ()
  val op bit1_nchotomy = TDB.find "bit1_nchotomy"
  fun op bit1_Axiom _ = () val op bit1_Axiom = TDB.find "bit1_Axiom"
  fun op bit1_induction _ = ()
  val op bit1_induction = TDB.find "bit1_induction"
  fun op bit1_case_cong _ = ()
  val op bit1_case_cong = TDB.find "bit1_case_cong"
  fun op bit1_case_eq _ = () val op bit1_case_eq = TDB.find "bit1_case_eq"
  fun op index_bit1 _ = () val op index_bit1 = TDB.find "index_bit1"
  fun op finite_bit1 _ = () val op finite_bit1 = TDB.find "finite_bit1"
  fun op index_one _ = () val op index_one = TDB.find "index_one"
  fun op finite_one _ = () val op finite_one = TDB.find "finite_one"
  fun op FCP_UPDATE_COMMUTES _ = ()
  val op FCP_UPDATE_COMMUTES = TDB.find "FCP_UPDATE_COMMUTES"
  fun op FCP_UPDATE_EQ _ = ()
  val op FCP_UPDATE_EQ = TDB.find "FCP_UPDATE_EQ"
  fun op FCP_UPDATE_IMP_ID _ = ()
  val op FCP_UPDATE_IMP_ID = TDB.find "FCP_UPDATE_IMP_ID"
  fun op APPLY_FCP_UPDATE_ID _ = ()
  val op APPLY_FCP_UPDATE_ID = TDB.find "APPLY_FCP_UPDATE_ID"
  fun op FCP_APPLY_UPDATE_THM _ = ()
  val op FCP_APPLY_UPDATE_THM = TDB.find "FCP_APPLY_UPDATE_THM"
  fun op LENGTH_V2L _ = () val op LENGTH_V2L = TDB.find "LENGTH_V2L"
  fun op EL_V2L _ = () val op EL_V2L = TDB.find "EL_V2L"
  fun op FCP_MAP _ = () val op FCP_MAP = TDB.find "FCP_MAP"
  fun op FCP_TL _ = () val op FCP_TL = TDB.find "FCP_TL"
  fun op FCP_EXISTS _ = () val op FCP_EXISTS = TDB.find "FCP_EXISTS"
  fun op FCP_EVERY _ = () val op FCP_EVERY = TDB.find "FCP_EVERY"
  fun op FCP_HD _ = () val op FCP_HD = TDB.find "FCP_HD"
  fun op FCP_CONS _ = () val op FCP_CONS = TDB.find "FCP_CONS"
  fun op V2L_L2V _ = () val op V2L_L2V = TDB.find "V2L_L2V"
  fun op NULL_V2L _ = () val op NULL_V2L = TDB.find "NULL_V2L"
  fun op READ_TL _ = () val op READ_TL = TDB.find "READ_TL"
  fun op READ_L2V _ = () val op READ_L2V = TDB.find "READ_L2V"
  fun op index_comp _ = () val op index_comp = TDB.find "index_comp"
  fun op fcp_subst_comp _ = ()
  val op fcp_subst_comp = TDB.find "fcp_subst_comp"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val fcp_grammars = merge_grammars ["list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="fcp"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val fcp_grammars = 
    Portable.## (addtyUDs,addtmUDs) fcp_grammars
  val _ = Parse.grammarDB_insert("fcp",fcp_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ = let
    val tyi = 
      TypeBasePure.gen_datatype_info {
        ax = fcp_Axiom,
        ind = fcp_ind,
        case_defs = [fcp_case_def]
      }
  in
    TypeBase.write tyi
  end
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "fcp"

end
