structure sum_numTheory :> sum_numTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading sum_numTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "sum_num"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/n-bit/sum_numTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op SUM_def _ = () val op SUM_def = TDB.find "SUM_def"
  fun op GSUM_ind _ = () val op GSUM_ind = TDB.find "GSUM_ind"
  fun op GSUM_def _ = () val op GSUM_def = TDB.find "GSUM_def"
  fun op GSUM_compute _ = () val op GSUM_compute = TDB.find "GSUM_compute"
  fun op GSUM_1 _ = () val op GSUM_1 = TDB.find "GSUM_1"
  fun op GSUM_ADD _ = () val op GSUM_ADD = TDB.find "GSUM_ADD"
  fun op GSUM_ZERO _ = () val op GSUM_ZERO = TDB.find "GSUM_ZERO"
  fun op GSUM_MONO _ = () val op GSUM_MONO = TDB.find "GSUM_MONO"
  fun op GSUM_LESS _ = () val op GSUM_LESS = TDB.find "GSUM_LESS"
  fun op GSUM_EQUAL _ = () val op GSUM_EQUAL = TDB.find "GSUM_EQUAL"
  fun op GSUM_FUN_EQUAL _ = ()
  val op GSUM_FUN_EQUAL = TDB.find "GSUM_FUN_EQUAL"
  fun op SUM_compute _ = () val op SUM_compute = TDB.find "SUM_compute"
  fun op SUM _ = () val op SUM = TDB.find "SUM"
  fun op SUM_1 _ = () val op SUM_1 = TDB.find "SUM_1"
  fun op SUM_MONO _ = () val op SUM_MONO = TDB.find "SUM_MONO"
  fun op SUM_LESS _ = () val op SUM_LESS = TDB.find "SUM_LESS"
  fun op SUM_EQUAL _ = () val op SUM_EQUAL = TDB.find "SUM_EQUAL"
  fun op SUM_FUN_EQUAL _ = ()
  val op SUM_FUN_EQUAL = TDB.find "SUM_FUN_EQUAL"
  fun op SUM_ZERO _ = () val op SUM_ZERO = TDB.find "SUM_ZERO"
  fun op SUM_FOLDL _ = () val op SUM_FOLDL = TDB.find "SUM_FOLDL"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val sum_num_grammars = merge_grammars ["rich_list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="sum_num"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val sum_num_grammars = 
    Portable.## (addtyUDs,addtmUDs) sum_num_grammars
  val _ = Parse.grammarDB_insert("sum_num",sum_num_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "sum_num"

end
