structure wordsTheory :> wordsTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading wordsTheory ... "
    else ()
  
  open Type Term Thm
  local open ASCIInumbersTheory fcpTheory numeral_bitTheory sum_numTheory
  in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "words"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/n-bit/wordsTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op dimword_def _ = () val op dimword_def = TDB.find "dimword_def"
  fun op INT_MIN_def _ = () val op INT_MIN_def = TDB.find "INT_MIN_def"
  fun op UINT_MAX_def _ = () val op UINT_MAX_def = TDB.find "UINT_MAX_def"
  fun op INT_MAX_def _ = () val op INT_MAX_def = TDB.find "INT_MAX_def"
  fun op w2n_def _ = () val op w2n_def = TDB.find "w2n_def"
  fun op n2w_def _ = () val op n2w_def = TDB.find "n2w_def"
  fun op w2w_def _ = () val op w2w_def = TDB.find "w2w_def"
  fun op sw2sw_def _ = () val op sw2sw_def = TDB.find "sw2sw_def"
  fun op w2l_def _ = () val op w2l_def = TDB.find "w2l_def"
  fun op l2w_def _ = () val op l2w_def = TDB.find "l2w_def"
  fun op w2s_def _ = () val op w2s_def = TDB.find "w2s_def"
  fun op s2w_def _ = () val op s2w_def = TDB.find "s2w_def"
  fun op word_from_bin_list_def _ = ()
  val op word_from_bin_list_def = TDB.find "word_from_bin_list_def"
  fun op word_from_oct_list_def _ = ()
  val op word_from_oct_list_def = TDB.find "word_from_oct_list_def"
  fun op word_from_dec_list_def _ = ()
  val op word_from_dec_list_def = TDB.find "word_from_dec_list_def"
  fun op word_from_hex_list_def _ = ()
  val op word_from_hex_list_def = TDB.find "word_from_hex_list_def"
  fun op word_to_bin_list_def _ = ()
  val op word_to_bin_list_def = TDB.find "word_to_bin_list_def"
  fun op word_to_oct_list_def _ = ()
  val op word_to_oct_list_def = TDB.find "word_to_oct_list_def"
  fun op word_to_dec_list_def _ = ()
  val op word_to_dec_list_def = TDB.find "word_to_dec_list_def"
  fun op word_to_hex_list_def _ = ()
  val op word_to_hex_list_def = TDB.find "word_to_hex_list_def"
  fun op word_from_bin_string_def _ = ()
  val op word_from_bin_string_def = TDB.find "word_from_bin_string_def"
  fun op word_from_oct_string_def _ = ()
  val op word_from_oct_string_def = TDB.find "word_from_oct_string_def"
  fun op word_from_dec_string_def _ = ()
  val op word_from_dec_string_def = TDB.find "word_from_dec_string_def"
  fun op word_from_hex_string_def _ = ()
  val op word_from_hex_string_def = TDB.find "word_from_hex_string_def"
  fun op word_to_bin_string_def _ = ()
  val op word_to_bin_string_def = TDB.find "word_to_bin_string_def"
  fun op word_to_oct_string_def _ = ()
  val op word_to_oct_string_def = TDB.find "word_to_oct_string_def"
  fun op word_to_dec_string_def _ = ()
  val op word_to_dec_string_def = TDB.find "word_to_dec_string_def"
  fun op word_to_hex_string_def _ = ()
  val op word_to_hex_string_def = TDB.find "word_to_hex_string_def"
  fun op word_T_def _ = () val op word_T_def = TDB.find "word_T_def"
  fun op word_L_def _ = () val op word_L_def = TDB.find "word_L_def"
  fun op word_H_def _ = () val op word_H_def = TDB.find "word_H_def"
  fun op word_1comp_def _ = ()
  val op word_1comp_def = TDB.find "word_1comp_def"
  fun op word_and_def _ = () val op word_and_def = TDB.find "word_and_def"
  fun op word_or_def _ = () val op word_or_def = TDB.find "word_or_def"
  fun op word_xor_def _ = () val op word_xor_def = TDB.find "word_xor_def"
  fun op word_nand_def _ = ()
  val op word_nand_def = TDB.find "word_nand_def"
  fun op word_nor_def _ = () val op word_nor_def = TDB.find "word_nor_def"
  fun op word_xnor_def _ = ()
  val op word_xnor_def = TDB.find "word_xnor_def"
  fun op word_reduce_def _ = ()
  val op word_reduce_def = TDB.find "word_reduce_def"
  fun op word_compare_def _ = ()
  val op word_compare_def = TDB.find "word_compare_def"
  fun op reduce_and_def _ = ()
  val op reduce_and_def = TDB.find "reduce_and_def"
  fun op reduce_or_def _ = ()
  val op reduce_or_def = TDB.find "reduce_or_def"
  fun op reduce_xor_def _ = ()
  val op reduce_xor_def = TDB.find "reduce_xor_def"
  fun op reduce_nand_def _ = ()
  val op reduce_nand_def = TDB.find "reduce_nand_def"
  fun op reduce_nor_def _ = ()
  val op reduce_nor_def = TDB.find "reduce_nor_def"
  fun op reduce_xnor_def _ = ()
  val op reduce_xnor_def = TDB.find "reduce_xnor_def"
  fun op word_lsb_def _ = () val op word_lsb_def = TDB.find "word_lsb_def"
  fun op word_msb_def _ = () val op word_msb_def = TDB.find "word_msb_def"
  fun op word_slice_def _ = ()
  val op word_slice_def = TDB.find "word_slice_def"
  fun op word_bits_def _ = ()
  val op word_bits_def = TDB.find "word_bits_def"
  fun op word_signed_bits_def _ = ()
  val op word_signed_bits_def = TDB.find "word_signed_bits_def"
  fun op word_extract_def _ = ()
  val op word_extract_def = TDB.find "word_extract_def"
  fun op word_bit_def _ = () val op word_bit_def = TDB.find "word_bit_def"
  fun op word_reverse_def _ = ()
  val op word_reverse_def = TDB.find "word_reverse_def"
  fun op word_modify_def _ = ()
  val op word_modify_def = TDB.find "word_modify_def"
  fun op bit_field_insert_def _ = ()
  val op bit_field_insert_def = TDB.find "bit_field_insert_def"
  fun op word_sign_extend_def _ = ()
  val op word_sign_extend_def = TDB.find "word_sign_extend_def"
  fun op word_len_def _ = () val op word_len_def = TDB.find "word_len_def"
  fun op bit_count_upto_def _ = ()
  val op bit_count_upto_def = TDB.find "bit_count_upto_def"
  fun op bit_count_def _ = ()
  val op bit_count_def = TDB.find "bit_count_def"
  fun op word_2comp_def _ = ()
  val op word_2comp_def = TDB.find "word_2comp_def"
  fun op word_add_def _ = () val op word_add_def = TDB.find "word_add_def"
  fun op word_mul_def _ = () val op word_mul_def = TDB.find "word_mul_def"
  fun op word_log2_def _ = ()
  val op word_log2_def = TDB.find "word_log2_def"
  fun op add_with_carry_def _ = ()
  val op add_with_carry_def = TDB.find "add_with_carry_def"
  fun op word_sub_def _ = () val op word_sub_def = TDB.find "word_sub_def"
  fun op word_div_def _ = () val op word_div_def = TDB.find "word_div_def"
  fun op word_mod_def _ = () val op word_mod_def = TDB.find "word_mod_def"
  fun op word_quot_def _ = ()
  val op word_quot_def = TDB.find "word_quot_def"
  fun op word_rem_def _ = () val op word_rem_def = TDB.find "word_rem_def"
  fun op word_L2_def _ = () val op word_L2_def = TDB.find "word_L2_def"
  fun op nzcv_def _ = () val op nzcv_def = TDB.find "nzcv_def"
  fun op word_lt_def _ = () val op word_lt_def = TDB.find "word_lt_def"
  fun op word_gt_def _ = () val op word_gt_def = TDB.find "word_gt_def"
  fun op word_le_def _ = () val op word_le_def = TDB.find "word_le_def"
  fun op word_ge_def _ = () val op word_ge_def = TDB.find "word_ge_def"
  fun op word_ls_def _ = () val op word_ls_def = TDB.find "word_ls_def"
  fun op word_hi_def _ = () val op word_hi_def = TDB.find "word_hi_def"
  fun op word_lo_def _ = () val op word_lo_def = TDB.find "word_lo_def"
  fun op word_hs_def _ = () val op word_hs_def = TDB.find "word_hs_def"
  fun op word_min_def _ = () val op word_min_def = TDB.find "word_min_def"
  fun op word_max_def _ = () val op word_max_def = TDB.find "word_max_def"
  fun op word_smin_def _ = ()
  val op word_smin_def = TDB.find "word_smin_def"
  fun op word_smax_def _ = ()
  val op word_smax_def = TDB.find "word_smax_def"
  fun op word_abs_def _ = () val op word_abs_def = TDB.find "word_abs_def"
  fun op word_lsl_def _ = () val op word_lsl_def = TDB.find "word_lsl_def"
  fun op word_lsr_def _ = () val op word_lsr_def = TDB.find "word_lsr_def"
  fun op word_asr_def _ = () val op word_asr_def = TDB.find "word_asr_def"
  fun op word_ror_def _ = () val op word_ror_def = TDB.find "word_ror_def"
  fun op word_rol_def _ = () val op word_rol_def = TDB.find "word_rol_def"
  fun op word_rrx_def _ = () val op word_rrx_def = TDB.find "word_rrx_def"
  fun op word_lsl_bv_def _ = ()
  val op word_lsl_bv_def = TDB.find "word_lsl_bv_def"
  fun op word_lsr_bv_def _ = ()
  val op word_lsr_bv_def = TDB.find "word_lsr_bv_def"
  fun op word_asr_bv_def _ = ()
  val op word_asr_bv_def = TDB.find "word_asr_bv_def"
  fun op word_ror_bv_def _ = ()
  val op word_ror_bv_def = TDB.find "word_ror_bv_def"
  fun op word_rol_bv_def _ = ()
  val op word_rol_bv_def = TDB.find "word_rol_bv_def"
  fun op word_join_def _ = ()
  val op word_join_def = TDB.find "word_join_def"
  fun op word_concat_def _ = ()
  val op word_concat_def = TDB.find "word_concat_def"
  fun op word_replicate_def _ = ()
  val op word_replicate_def = TDB.find "word_replicate_def"
  fun op concat_word_list_def _ = ()
  val op concat_word_list_def = TDB.find "concat_word_list_def"
  fun op saturate_n2w_def _ = ()
  val op saturate_n2w_def = TDB.find "saturate_n2w_def"
  fun op saturate_w2w_def _ = ()
  val op saturate_w2w_def = TDB.find "saturate_w2w_def"
  fun op saturate_add_def _ = ()
  val op saturate_add_def = TDB.find "saturate_add_def"
  fun op saturate_sub_def _ = ()
  val op saturate_sub_def = TDB.find "saturate_sub_def"
  fun op saturate_mul_def _ = ()
  val op saturate_mul_def = TDB.find "saturate_mul_def"
  fun op n2w_itself_primitive_def _ = ()
  val op n2w_itself_primitive_def = TDB.find "n2w_itself_primitive_def"
  fun op BIT_SET_ind _ = () val op BIT_SET_ind = TDB.find "BIT_SET_ind"
  fun op BIT_SET_def _ = () val op BIT_SET_def = TDB.find "BIT_SET_def"
  fun op ZERO_LT_dimword _ = ()
  val op ZERO_LT_dimword = TDB.find "ZERO_LT_dimword"
  fun op DIMINDEX_GT_0 _ = ()
  val op DIMINDEX_GT_0 = TDB.find "DIMINDEX_GT_0"
  fun op dimword_IS_TWICE_INT_MIN _ = ()
  val op dimword_IS_TWICE_INT_MIN = TDB.find "dimword_IS_TWICE_INT_MIN"
  fun op dimword_sub_int_min _ = ()
  val op dimword_sub_int_min = TDB.find "dimword_sub_int_min"
  fun op ONE_LT_dimword _ = ()
  val op ONE_LT_dimword = TDB.find "ONE_LT_dimword"
  fun op EXISTS_HB _ = () val op EXISTS_HB = TDB.find "EXISTS_HB"
  fun op MOD_DIMINDEX _ = () val op MOD_DIMINDEX = TDB.find "MOD_DIMINDEX"
  fun op BITS_ZEROL_DIMINDEX _ = ()
  val op BITS_ZEROL_DIMINDEX = TDB.find "BITS_ZEROL_DIMINDEX"
  fun op MOD_2EXP_DIMINDEX _ = ()
  val op MOD_2EXP_DIMINDEX = TDB.find "MOD_2EXP_DIMINDEX"
  fun op INT_MIN_SUM _ = () val op INT_MIN_SUM = TDB.find "INT_MIN_SUM"
  fun op ZERO_LT_INT_MIN _ = ()
  val op ZERO_LT_INT_MIN = TDB.find "ZERO_LT_INT_MIN"
  fun op ZERO_LT_INT_MAX _ = ()
  val op ZERO_LT_INT_MAX = TDB.find "ZERO_LT_INT_MAX"
  fun op ZERO_LE_INT_MAX _ = ()
  val op ZERO_LE_INT_MAX = TDB.find "ZERO_LE_INT_MAX"
  fun op ZERO_LT_UINT_MAX _ = ()
  val op ZERO_LT_UINT_MAX = TDB.find "ZERO_LT_UINT_MAX"
  fun op INT_MIN_LT_DIMWORD _ = ()
  val op INT_MIN_LT_DIMWORD = TDB.find "INT_MIN_LT_DIMWORD"
  fun op INT_MAX_LT_DIMWORD _ = ()
  val op INT_MAX_LT_DIMWORD = TDB.find "INT_MAX_LT_DIMWORD"
  fun op dimindex_lt_dimword _ = ()
  val op dimindex_lt_dimword = TDB.find "dimindex_lt_dimword"
  fun op BOUND_ORDER _ = () val op BOUND_ORDER = TDB.find "BOUND_ORDER"
  fun op dimindex_dimword_iso _ = ()
  val op dimindex_dimword_iso = TDB.find "dimindex_dimword_iso"
  fun op dimindex_dimword_le_iso _ = ()
  val op dimindex_dimword_le_iso = TDB.find "dimindex_dimword_le_iso"
  fun op dimindex_dimword_lt_iso _ = ()
  val op dimindex_dimword_lt_iso = TDB.find "dimindex_dimword_lt_iso"
  fun op dimindex_int_min_iso _ = ()
  val op dimindex_int_min_iso = TDB.find "dimindex_int_min_iso"
  fun op dimindex_int_min_le_iso _ = ()
  val op dimindex_int_min_le_iso = TDB.find "dimindex_int_min_le_iso"
  fun op dimindex_int_min_lt_iso _ = ()
  val op dimindex_int_min_lt_iso = TDB.find "dimindex_int_min_lt_iso"
  fun op dimindex_int_max_iso _ = ()
  val op dimindex_int_max_iso = TDB.find "dimindex_int_max_iso"
  fun op dimindex_int_max_le_iso _ = ()
  val op dimindex_int_max_le_iso = TDB.find "dimindex_int_max_le_iso"
  fun op dimindex_int_max_lt_iso _ = ()
  val op dimindex_int_max_lt_iso = TDB.find "dimindex_int_max_lt_iso"
  fun op dimindex_uint_max_iso _ = ()
  val op dimindex_uint_max_iso = TDB.find "dimindex_uint_max_iso"
  fun op dimindex_uint_max_le_iso _ = ()
  val op dimindex_uint_max_le_iso = TDB.find "dimindex_uint_max_le_iso"
  fun op dimindex_uint_max_lt_iso _ = ()
  val op dimindex_uint_max_lt_iso = TDB.find "dimindex_uint_max_lt_iso"
  fun op w2n_n2w _ = () val op w2n_n2w = TDB.find "w2n_n2w"
  fun op n2w_w2n _ = () val op n2w_w2n = TDB.find "n2w_w2n"
  fun op word_nchotomy _ = ()
  val op word_nchotomy = TDB.find "word_nchotomy"
  fun op n2w_mod _ = () val op n2w_mod = TDB.find "n2w_mod"
  fun op n2w_11 _ = () val op n2w_11 = TDB.find "n2w_11"
  fun op ranged_word_nchotomy _ = ()
  val op ranged_word_nchotomy = TDB.find "ranged_word_nchotomy"
  fun op dimindex_1_cases _ = ()
  val op dimindex_1_cases = TDB.find "dimindex_1_cases"
  fun op mod_dimindex _ = () val op mod_dimindex = TDB.find "mod_dimindex"
  fun op WORD_INDUCT _ = () val op WORD_INDUCT = TDB.find "WORD_INDUCT"
  fun op w2n_11 _ = () val op w2n_11 = TDB.find "w2n_11"
  fun op w2n_lt _ = () val op w2n_lt = TDB.find "w2n_lt"
  fun op word_0_n2w _ = () val op word_0_n2w = TDB.find "word_0_n2w"
  fun op word_1_n2w _ = () val op word_1_n2w = TDB.find "word_1_n2w"
  fun op w2n_eq_0 _ = () val op w2n_eq_0 = TDB.find "w2n_eq_0"
  fun op n2w_dimword _ = () val op n2w_dimword = TDB.find "n2w_dimword"
  fun op word_2comp_dimindex_1 _ = ()
  val op word_2comp_dimindex_1 = TDB.find "word_2comp_dimindex_1"
  fun op word_add_n2w _ = () val op word_add_n2w = TDB.find "word_add_n2w"
  fun op word_mul_n2w _ = () val op word_mul_n2w = TDB.find "word_mul_n2w"
  fun op word_log2_n2w _ = ()
  val op word_log2_n2w = TDB.find "word_log2_n2w"
  fun op word_1comp_n2w _ = ()
  val op word_1comp_n2w = TDB.find "word_1comp_n2w"
  fun op word_2comp_n2w _ = ()
  val op word_2comp_n2w = TDB.find "word_2comp_n2w"
  fun op word_lsb _ = () val op word_lsb = TDB.find "word_lsb"
  fun op word_msb _ = () val op word_msb = TDB.find "word_msb"
  fun op word_lsb_n2w _ = () val op word_lsb_n2w = TDB.find "word_lsb_n2w"
  fun op word_msb_n2w _ = () val op word_msb_n2w = TDB.find "word_msb_n2w"
  fun op word_msb_n2w_numeric _ = ()
  val op word_msb_n2w_numeric = TDB.find "word_msb_n2w_numeric"
  fun op word_and_n2w _ = () val op word_and_n2w = TDB.find "word_and_n2w"
  fun op word_or_n2w _ = () val op word_or_n2w = TDB.find "word_or_n2w"
  fun op word_xor_n2w _ = () val op word_xor_n2w = TDB.find "word_xor_n2w"
  fun op word_nand_n2w _ = ()
  val op word_nand_n2w = TDB.find "word_nand_n2w"
  fun op word_nor_n2w _ = () val op word_nor_n2w = TDB.find "word_nor_n2w"
  fun op word_xnor_n2w _ = ()
  val op word_xnor_n2w = TDB.find "word_xnor_n2w"
  fun op l2w_w2l _ = () val op l2w_w2l = TDB.find "l2w_w2l"
  fun op w2l_l2w _ = () val op w2l_l2w = TDB.find "w2l_l2w"
  fun op s2w_w2s _ = () val op s2w_w2s = TDB.find "s2w_w2s"
  fun op w2s_s2w _ = () val op w2s_s2w = TDB.find "w2s_s2w"
  fun op NUMERAL_LESS_THM _ = ()
  val op NUMERAL_LESS_THM = TDB.find "NUMERAL_LESS_THM"
  fun op word_bin_list _ = ()
  val op word_bin_list = TDB.find "word_bin_list"
  fun op word_oct_list _ = ()
  val op word_oct_list = TDB.find "word_oct_list"
  fun op word_dec_list _ = ()
  val op word_dec_list = TDB.find "word_dec_list"
  fun op word_hex_list _ = ()
  val op word_hex_list = TDB.find "word_hex_list"
  fun op word_bin_string _ = ()
  val op word_bin_string = TDB.find "word_bin_string"
  fun op word_oct_string _ = ()
  val op word_oct_string = TDB.find "word_oct_string"
  fun op word_dec_string _ = ()
  val op word_dec_string = TDB.find "word_dec_string"
  fun op word_hex_string _ = ()
  val op word_hex_string = TDB.find "word_hex_string"
  fun op word_0 _ = () val op word_0 = TDB.find "word_0"
  fun op word_eq_0 _ = () val op word_eq_0 = TDB.find "word_eq_0"
  fun op word_T _ = () val op word_T = TDB.find "word_T"
  fun op FCP_T_F _ = () val op FCP_T_F = TDB.find "FCP_T_F"
  fun op word_L _ = () val op word_L = TDB.find "word_L"
  fun op word_H _ = () val op word_H = TDB.find "word_H"
  fun op word_L2 _ = () val op word_L2 = TDB.find "word_L2"
  fun op WORD_NEG_1 _ = () val op WORD_NEG_1 = TDB.find "WORD_NEG_1"
  fun op WORD_NEG_1_T _ = () val op WORD_NEG_1_T = TDB.find "WORD_NEG_1_T"
  fun op WORD_MSB_1COMP _ = ()
  val op WORD_MSB_1COMP = TDB.find "WORD_MSB_1COMP"
  fun op w2n_minus1 _ = () val op w2n_minus1 = TDB.find "w2n_minus1"
  fun op w2n_plus1 _ = () val op w2n_plus1 = TDB.find "w2n_plus1"
  fun op WORD_NOT_NOT _ = () val op WORD_NOT_NOT = TDB.find "WORD_NOT_NOT"
  fun op WORD_DE_MORGAN_THM _ = ()
  val op WORD_DE_MORGAN_THM = TDB.find "WORD_DE_MORGAN_THM"
  fun op WORD_NOT_XOR _ = () val op WORD_NOT_XOR = TDB.find "WORD_NOT_XOR"
  fun op WORD_AND_CLAUSES _ = ()
  val op WORD_AND_CLAUSES = TDB.find "WORD_AND_CLAUSES"
  fun op WORD_OR_CLAUSES _ = ()
  val op WORD_OR_CLAUSES = TDB.find "WORD_OR_CLAUSES"
  fun op WORD_XOR_CLAUSES _ = ()
  val op WORD_XOR_CLAUSES = TDB.find "WORD_XOR_CLAUSES"
  fun op WORD_AND_ASSOC _ = ()
  val op WORD_AND_ASSOC = TDB.find "WORD_AND_ASSOC"
  fun op WORD_OR_ASSOC _ = ()
  val op WORD_OR_ASSOC = TDB.find "WORD_OR_ASSOC"
  fun op WORD_XOR_ASSOC _ = ()
  val op WORD_XOR_ASSOC = TDB.find "WORD_XOR_ASSOC"
  fun op WORD_AND_COMM _ = ()
  val op WORD_AND_COMM = TDB.find "WORD_AND_COMM"
  fun op WORD_OR_COMM _ = () val op WORD_OR_COMM = TDB.find "WORD_OR_COMM"
  fun op WORD_XOR_COMM _ = ()
  val op WORD_XOR_COMM = TDB.find "WORD_XOR_COMM"
  fun op WORD_AND_IDEM _ = ()
  val op WORD_AND_IDEM = TDB.find "WORD_AND_IDEM"
  fun op WORD_OR_IDEM _ = () val op WORD_OR_IDEM = TDB.find "WORD_OR_IDEM"
  fun op WORD_AND_ABSORD _ = ()
  val op WORD_AND_ABSORD = TDB.find "WORD_AND_ABSORD"
  fun op WORD_OR_ABSORB _ = ()
  val op WORD_OR_ABSORB = TDB.find "WORD_OR_ABSORB"
  fun op WORD_AND_COMP _ = ()
  val op WORD_AND_COMP = TDB.find "WORD_AND_COMP"
  fun op WORD_OR_COMP _ = () val op WORD_OR_COMP = TDB.find "WORD_OR_COMP"
  fun op WORD_XOR_COMP _ = ()
  val op WORD_XOR_COMP = TDB.find "WORD_XOR_COMP"
  fun op WORD_RIGHT_AND_OVER_OR _ = ()
  val op WORD_RIGHT_AND_OVER_OR = TDB.find "WORD_RIGHT_AND_OVER_OR"
  fun op WORD_RIGHT_OR_OVER_AND _ = ()
  val op WORD_RIGHT_OR_OVER_AND = TDB.find "WORD_RIGHT_OR_OVER_AND"
  fun op WORD_RIGHT_AND_OVER_XOR _ = ()
  val op WORD_RIGHT_AND_OVER_XOR = TDB.find "WORD_RIGHT_AND_OVER_XOR"
  fun op WORD_LEFT_AND_OVER_OR _ = ()
  val op WORD_LEFT_AND_OVER_OR = TDB.find "WORD_LEFT_AND_OVER_OR"
  fun op WORD_LEFT_OR_OVER_AND _ = ()
  val op WORD_LEFT_OR_OVER_AND = TDB.find "WORD_LEFT_OR_OVER_AND"
  fun op WORD_LEFT_AND_OVER_XOR _ = ()
  val op WORD_LEFT_AND_OVER_XOR = TDB.find "WORD_LEFT_AND_OVER_XOR"
  fun op WORD_XOR _ = () val op WORD_XOR = TDB.find "WORD_XOR"
  fun op WORD_NAND_NOT_AND _ = ()
  val op WORD_NAND_NOT_AND = TDB.find "WORD_NAND_NOT_AND"
  fun op WORD_NOR_NOT_OR _ = ()
  val op WORD_NOR_NOT_OR = TDB.find "WORD_NOR_NOT_OR"
  fun op WORD_XNOR_NOT_XOR _ = ()
  val op WORD_XNOR_NOT_XOR = TDB.find "WORD_XNOR_NOT_XOR"
  fun op WORD_ADD_OR _ = () val op WORD_ADD_OR = TDB.find "WORD_ADD_OR"
  fun op WORD_ADD_XOR _ = () val op WORD_ADD_XOR = TDB.find "WORD_ADD_XOR"
  fun op WORD_AND_EXP_SUB1 _ = ()
  val op WORD_AND_EXP_SUB1 = TDB.find "WORD_AND_EXP_SUB1"
  fun op word_msb_add_word_L _ = ()
  val op word_msb_add_word_L = TDB.find "word_msb_add_word_L"
  fun op w2w _ = () val op w2w = TDB.find "w2w"
  fun op sw2sw _ = () val op sw2sw = TDB.find "sw2sw"
  fun op w2w_id _ = () val op w2w_id = TDB.find "w2w_id"
  fun op sw2sw_id _ = () val op sw2sw_id = TDB.find "sw2sw_id"
  fun op w2w_w2w _ = () val op w2w_w2w = TDB.find "w2w_w2w"
  fun op sw2sw_sw2sw _ = () val op sw2sw_sw2sw = TDB.find "sw2sw_sw2sw"
  fun op sw2sw_w2w _ = () val op sw2sw_w2w = TDB.find "sw2sw_w2w"
  fun op word_bit _ = () val op word_bit = TDB.find "word_bit"
  fun op word_slice_n2w _ = ()
  val op word_slice_n2w = TDB.find "word_slice_n2w"
  fun op word_bits_n2w _ = ()
  val op word_bits_n2w = TDB.find "word_bits_n2w"
  fun op word_bit_n2w _ = () val op word_bit_n2w = TDB.find "word_bit_n2w"
  fun op word_signed_bits_n2w _ = ()
  val op word_signed_bits_n2w = TDB.find "word_signed_bits_n2w"
  fun op word_sign_extend_bits _ = ()
  val op word_sign_extend_bits = TDB.find "word_sign_extend_bits"
  fun op word_index_n2w _ = ()
  val op word_index_n2w = TDB.find "word_index_n2w"
  fun op word_index _ = () val op word_index = TDB.find "word_index"
  fun op word_bits_w2w _ = ()
  val op word_bits_w2w = TDB.find "word_bits_w2w"
  fun op word_reverse_n2w _ = ()
  val op word_reverse_n2w = TDB.find "word_reverse_n2w"
  fun op word_modify_n2w _ = ()
  val op word_modify_n2w = TDB.find "word_modify_n2w"
  fun op fcp_n2w _ = () val op fcp_n2w = TDB.find "fcp_n2w"
  fun op w2n_w2w _ = () val op w2n_w2w = TDB.find "w2n_w2w"
  fun op w2n_w2w_le _ = () val op w2n_w2w_le = TDB.find "w2n_w2w_le"
  fun op w2w_lt _ = () val op w2w_lt = TDB.find "w2w_lt"
  fun op w2w_n2w _ = () val op w2w_n2w = TDB.find "w2w_n2w"
  fun op w2w_0 _ = () val op w2w_0 = TDB.find "w2w_0"
  fun op w2n_11_lift _ = () val op w2n_11_lift = TDB.find "w2n_11_lift"
  fun op word_extract_n2w _ = ()
  val op word_extract_n2w = TDB.find "word_extract_n2w"
  fun op n2w_BITS _ = () val op n2w_BITS = TDB.find "n2w_BITS"
  fun op word_extract_w2w _ = ()
  val op word_extract_w2w = TDB.find "word_extract_w2w"
  fun op WORD_w2w_EXTRACT _ = ()
  val op WORD_w2w_EXTRACT = TDB.find "WORD_w2w_EXTRACT"
  fun op WORD_EQ _ = () val op WORD_EQ = TDB.find "WORD_EQ"
  fun op BIT_UPDATE _ = () val op BIT_UPDATE = TDB.find "BIT_UPDATE"
  fun op WORD_MODIFY_BIT _ = ()
  val op WORD_MODIFY_BIT = TDB.find "WORD_MODIFY_BIT"
  fun op WORD_BIT_BITS _ = ()
  val op WORD_BIT_BITS = TDB.find "WORD_BIT_BITS"
  fun op WORD_BITS_COMP_THM _ = ()
  val op WORD_BITS_COMP_THM = TDB.find "WORD_BITS_COMP_THM"
  fun op WORD_BITS_EXTRACT _ = ()
  val op WORD_BITS_EXTRACT = TDB.find "WORD_BITS_EXTRACT"
  fun op WORD_BITS_LSR _ = ()
  val op WORD_BITS_LSR = TDB.find "WORD_BITS_LSR"
  fun op WORD_BITS_ZERO _ = ()
  val op WORD_BITS_ZERO = TDB.find "WORD_BITS_ZERO"
  fun op WORD_BITS_ZERO2 _ = ()
  val op WORD_BITS_ZERO2 = TDB.find "WORD_BITS_ZERO2"
  fun op WORD_BITS_ZERO3 _ = ()
  val op WORD_BITS_ZERO3 = TDB.find "WORD_BITS_ZERO3"
  fun op WORD_BITS_LT _ = () val op WORD_BITS_LT = TDB.find "WORD_BITS_LT"
  fun op WORD_EXTRACT_LT _ = ()
  val op WORD_EXTRACT_LT = TDB.find "WORD_EXTRACT_LT"
  fun op WORD_EXTRACT_ZERO _ = ()
  val op WORD_EXTRACT_ZERO = TDB.find "WORD_EXTRACT_ZERO"
  fun op WORD_EXTRACT_ZERO2 _ = ()
  val op WORD_EXTRACT_ZERO2 = TDB.find "WORD_EXTRACT_ZERO2"
  fun op WORD_EXTRACT_ZERO3 _ = ()
  val op WORD_EXTRACT_ZERO3 = TDB.find "WORD_EXTRACT_ZERO3"
  fun op WORD_SLICE_THM _ = ()
  val op WORD_SLICE_THM = TDB.find "WORD_SLICE_THM"
  fun op WORD_SLICE_ZERO _ = ()
  val op WORD_SLICE_ZERO = TDB.find "WORD_SLICE_ZERO"
  fun op WORD_SLICE_ZERO2 _ = ()
  val op WORD_SLICE_ZERO2 = TDB.find "WORD_SLICE_ZERO2"
  fun op WORD_SLICE_BITS_THM _ = ()
  val op WORD_SLICE_BITS_THM = TDB.find "WORD_SLICE_BITS_THM"
  fun op WORD_BITS_SLICE_THM _ = ()
  val op WORD_BITS_SLICE_THM = TDB.find "WORD_BITS_SLICE_THM"
  fun op WORD_SLICE_COMP_THM _ = ()
  val op WORD_SLICE_COMP_THM = TDB.find "WORD_SLICE_COMP_THM"
  fun op WORD_EXTRACT_COMP_THM _ = ()
  val op WORD_EXTRACT_COMP_THM = TDB.find "WORD_EXTRACT_COMP_THM"
  fun op WORD_EXTRACT_BITS_COMP _ = ()
  val op WORD_EXTRACT_BITS_COMP = TDB.find "WORD_EXTRACT_BITS_COMP"
  fun op WORD_ALL_BITS _ = ()
  val op WORD_ALL_BITS = TDB.find "WORD_ALL_BITS"
  fun op EXTRACT_ALL_BITS _ = ()
  val op EXTRACT_ALL_BITS = TDB.find "EXTRACT_ALL_BITS"
  fun op WORD_BITS_MIN_HIGH _ = ()
  val op WORD_BITS_MIN_HIGH = TDB.find "WORD_BITS_MIN_HIGH"
  fun op WORD_EXTRACT_MIN_HIGH _ = ()
  val op WORD_EXTRACT_MIN_HIGH = TDB.find "WORD_EXTRACT_MIN_HIGH"
  fun op CONCAT_EXTRACT _ = ()
  val op CONCAT_EXTRACT = TDB.find "CONCAT_EXTRACT"
  fun op EXTRACT_CONCAT _ = ()
  val op EXTRACT_CONCAT = TDB.find "EXTRACT_CONCAT"
  fun op EXTRACT_JOIN _ = () val op EXTRACT_JOIN = TDB.find "EXTRACT_JOIN"
  fun op EXTRACT_JOIN_ADD _ = ()
  val op EXTRACT_JOIN_ADD = TDB.find "EXTRACT_JOIN_ADD"
  fun op EXTEND_EXTRACT _ = ()
  val op EXTEND_EXTRACT = TDB.find "EXTEND_EXTRACT"
  fun op WORD_SLICE_OVER_BITWISE _ = ()
  val op WORD_SLICE_OVER_BITWISE = TDB.find "WORD_SLICE_OVER_BITWISE"
  fun op WORD_BITS_OVER_BITWISE _ = ()
  val op WORD_BITS_OVER_BITWISE = TDB.find "WORD_BITS_OVER_BITWISE"
  fun op WORD_w2w_OVER_BITWISE _ = ()
  val op WORD_w2w_OVER_BITWISE = TDB.find "WORD_w2w_OVER_BITWISE"
  fun op WORD_EXTRACT_OVER_BITWISE _ = ()
  val op WORD_EXTRACT_OVER_BITWISE = TDB.find "WORD_EXTRACT_OVER_BITWISE"
  fun op WORD_w2w_OVER_ADD _ = ()
  val op WORD_w2w_OVER_ADD = TDB.find "WORD_w2w_OVER_ADD"
  fun op WORD_w2w_OVER_MUL _ = ()
  val op WORD_w2w_OVER_MUL = TDB.find "WORD_w2w_OVER_MUL"
  fun op WORD_EXTRACT_OVER_ADD _ = ()
  val op WORD_EXTRACT_OVER_ADD = TDB.find "WORD_EXTRACT_OVER_ADD"
  fun op WORD_EXTRACT_OVER_MUL _ = ()
  val op WORD_EXTRACT_OVER_MUL = TDB.find "WORD_EXTRACT_OVER_MUL"
  fun op WORD_EXTRACT_OVER_ADD2 _ = ()
  val op WORD_EXTRACT_OVER_ADD2 = TDB.find "WORD_EXTRACT_OVER_ADD2"
  fun op WORD_EXTRACT_OVER_MUL2 _ = ()
  val op WORD_EXTRACT_OVER_MUL2 = TDB.find "WORD_EXTRACT_OVER_MUL2"
  fun op WORD_EXTRACT_ID _ = ()
  val op WORD_EXTRACT_ID = TDB.find "WORD_EXTRACT_ID"
  fun op BIT_SET _ = () val op BIT_SET = TDB.find "BIT_SET"
  fun op WORD_LITERAL_AND _ = ()
  val op WORD_LITERAL_AND = TDB.find "WORD_LITERAL_AND"
  fun op WORD_LITERAL_OR _ = ()
  val op WORD_LITERAL_OR = TDB.find "WORD_LITERAL_OR"
  fun op WORD_LITERAL_XOR _ = ()
  val op WORD_LITERAL_XOR = TDB.find "WORD_LITERAL_XOR"
  fun op word_replicate_concat_word_list _ = ()
  val op word_replicate_concat_word_list = TDB.find
    "word_replicate_concat_word_list"
  fun op bit_field_insert _ = ()
  val op bit_field_insert = TDB.find "bit_field_insert"
  fun op word_join_index _ = ()
  val op word_join_index = TDB.find "word_join_index"
  fun op foldl_reduce_and _ = ()
  val op foldl_reduce_and = TDB.find "foldl_reduce_and"
  fun op foldl_reduce_or _ = ()
  val op foldl_reduce_or = TDB.find "foldl_reduce_or"
  fun op foldl_reduce_xor _ = ()
  val op foldl_reduce_xor = TDB.find "foldl_reduce_xor"
  fun op foldl_reduce_nand _ = ()
  val op foldl_reduce_nand = TDB.find "foldl_reduce_nand"
  fun op foldl_reduce_nor _ = ()
  val op foldl_reduce_nor = TDB.find "foldl_reduce_nor"
  fun op foldl_reduce_xnor _ = ()
  val op foldl_reduce_xnor = TDB.find "foldl_reduce_xnor"
  fun op LOG2_w2n_lt _ = () val op LOG2_w2n_lt = TDB.find "LOG2_w2n_lt"
  fun op LOG2_w2n _ = () val op LOG2_w2n = TDB.find "LOG2_w2n"
  fun op LEAST_BIT_LT _ = () val op LEAST_BIT_LT = TDB.find "LEAST_BIT_LT"
  fun op word_reduce_n2w _ = ()
  val op word_reduce_n2w = TDB.find "word_reduce_n2w"
  fun op NOT_UINTMAXw _ = () val op NOT_UINTMAXw = TDB.find "NOT_UINTMAXw"
  fun op NOT_0w _ = () val op NOT_0w = TDB.find "NOT_0w"
  fun op reduce_and _ = () val op reduce_and = TDB.find "reduce_and"
  fun op reduce_or _ = () val op reduce_or = TDB.find "reduce_or"
  fun op WORD_ADD_0 _ = () val op WORD_ADD_0 = TDB.find "WORD_ADD_0"
  fun op WORD_ADD_ASSOC _ = ()
  val op WORD_ADD_ASSOC = TDB.find "WORD_ADD_ASSOC"
  fun op WORD_MULT_ASSOC _ = ()
  val op WORD_MULT_ASSOC = TDB.find "WORD_MULT_ASSOC"
  fun op WORD_ADD_COMM _ = ()
  val op WORD_ADD_COMM = TDB.find "WORD_ADD_COMM"
  fun op WORD_MULT_COMM _ = ()
  val op WORD_MULT_COMM = TDB.find "WORD_MULT_COMM"
  fun op WORD_MULT_CLAUSES _ = ()
  val op WORD_MULT_CLAUSES = TDB.find "WORD_MULT_CLAUSES"
  fun op WORD_LEFT_ADD_DISTRIB _ = ()
  val op WORD_LEFT_ADD_DISTRIB = TDB.find "WORD_LEFT_ADD_DISTRIB"
  fun op WORD_RIGHT_ADD_DISTRIB _ = ()
  val op WORD_RIGHT_ADD_DISTRIB = TDB.find "WORD_RIGHT_ADD_DISTRIB"
  fun op WORD_ADD_SUB_ASSOC _ = ()
  val op WORD_ADD_SUB_ASSOC = TDB.find "WORD_ADD_SUB_ASSOC"
  fun op WORD_ADD_SUB_SYM _ = ()
  val op WORD_ADD_SUB_SYM = TDB.find "WORD_ADD_SUB_SYM"
  fun op WORD_ADD_LINV _ = ()
  val op WORD_ADD_LINV = TDB.find "WORD_ADD_LINV"
  fun op WORD_ADD_RINV _ = ()
  val op WORD_ADD_RINV = TDB.find "WORD_ADD_RINV"
  fun op WORD_SUB_REFL _ = ()
  val op WORD_SUB_REFL = TDB.find "WORD_SUB_REFL"
  fun op WORD_SUB_ADD2 _ = ()
  val op WORD_SUB_ADD2 = TDB.find "WORD_SUB_ADD2"
  fun op WORD_ADD_SUB _ = () val op WORD_ADD_SUB = TDB.find "WORD_ADD_SUB"
  fun op WORD_SUB_ADD _ = () val op WORD_SUB_ADD = TDB.find "WORD_SUB_ADD"
  fun op WORD_ADD_EQ_SUB _ = ()
  val op WORD_ADD_EQ_SUB = TDB.find "WORD_ADD_EQ_SUB"
  fun op WORD_ADD_INV_0_EQ _ = ()
  val op WORD_ADD_INV_0_EQ = TDB.find "WORD_ADD_INV_0_EQ"
  fun op WORD_EQ_ADD_LCANCEL _ = ()
  val op WORD_EQ_ADD_LCANCEL = TDB.find "WORD_EQ_ADD_LCANCEL"
  fun op WORD_EQ_ADD_RCANCEL _ = ()
  val op WORD_EQ_ADD_RCANCEL = TDB.find "WORD_EQ_ADD_RCANCEL"
  fun op WORD_NEG _ = () val op WORD_NEG = TDB.find "WORD_NEG"
  fun op WORD_NOT _ = () val op WORD_NOT = TDB.find "WORD_NOT"
  fun op WORD_NEG_0 _ = () val op WORD_NEG_0 = TDB.find "WORD_NEG_0"
  fun op WORD_NEG_ADD _ = () val op WORD_NEG_ADD = TDB.find "WORD_NEG_ADD"
  fun op WORD_NEG_NEG _ = () val op WORD_NEG_NEG = TDB.find "WORD_NEG_NEG"
  fun op WORD_SUB_LNEG _ = ()
  val op WORD_SUB_LNEG = TDB.find "WORD_SUB_LNEG"
  fun op WORD_SUB_RNEG _ = ()
  val op WORD_SUB_RNEG = TDB.find "WORD_SUB_RNEG"
  fun op WORD_SUB_SUB _ = () val op WORD_SUB_SUB = TDB.find "WORD_SUB_SUB"
  fun op WORD_SUB_SUB2 _ = ()
  val op WORD_SUB_SUB2 = TDB.find "WORD_SUB_SUB2"
  fun op WORD_EQ_SUB_LADD _ = ()
  val op WORD_EQ_SUB_LADD = TDB.find "WORD_EQ_SUB_LADD"
  fun op WORD_EQ_SUB_RADD _ = ()
  val op WORD_EQ_SUB_RADD = TDB.find "WORD_EQ_SUB_RADD"
  fun op WORD_EQ_SUB_ZERO _ = ()
  val op WORD_EQ_SUB_ZERO = TDB.find "WORD_EQ_SUB_ZERO"
  fun op WORD_LCANCEL_SUB _ = ()
  val op WORD_LCANCEL_SUB = TDB.find "WORD_LCANCEL_SUB"
  fun op WORD_RCANCEL_SUB _ = ()
  val op WORD_RCANCEL_SUB = TDB.find "WORD_RCANCEL_SUB"
  fun op WORD_SUB_PLUS _ = ()
  val op WORD_SUB_PLUS = TDB.find "WORD_SUB_PLUS"
  fun op WORD_SUB_LZERO _ = ()
  val op WORD_SUB_LZERO = TDB.find "WORD_SUB_LZERO"
  fun op WORD_SUB_RZERO _ = ()
  val op WORD_SUB_RZERO = TDB.find "WORD_SUB_RZERO"
  fun op WORD_ADD_LID_UNIQ _ = ()
  val op WORD_ADD_LID_UNIQ = TDB.find "WORD_ADD_LID_UNIQ"
  fun op WORD_ADD_RID_UNIQ _ = ()
  val op WORD_ADD_RID_UNIQ = TDB.find "WORD_ADD_RID_UNIQ"
  fun op WORD_SUM_ZERO _ = ()
  val op WORD_SUM_ZERO = TDB.find "WORD_SUM_ZERO"
  fun op WORD_ADD_SUB2 _ = ()
  val op WORD_ADD_SUB2 = TDB.find "WORD_ADD_SUB2"
  fun op WORD_ADD_SUB3 _ = ()
  val op WORD_ADD_SUB3 = TDB.find "WORD_ADD_SUB3"
  fun op WORD_SUB_SUB3 _ = ()
  val op WORD_SUB_SUB3 = TDB.find "WORD_SUB_SUB3"
  fun op WORD_EQ_NEG _ = () val op WORD_EQ_NEG = TDB.find "WORD_EQ_NEG"
  fun op WORD_NEG_EQ _ = () val op WORD_NEG_EQ = TDB.find "WORD_NEG_EQ"
  fun op WORD_NEG_EQ_0 _ = ()
  val op WORD_NEG_EQ_0 = TDB.find "WORD_NEG_EQ_0"
  fun op WORD_SUB _ = () val op WORD_SUB = TDB.find "WORD_SUB"
  fun op WORD_SUB_NEG _ = () val op WORD_SUB_NEG = TDB.find "WORD_SUB_NEG"
  fun op WORD_NEG_SUB _ = () val op WORD_NEG_SUB = TDB.find "WORD_NEG_SUB"
  fun op WORD_SUB_TRIANGLE _ = ()
  val op WORD_SUB_TRIANGLE = TDB.find "WORD_SUB_TRIANGLE"
  fun op WORD_NOT_0 _ = () val op WORD_NOT_0 = TDB.find "WORD_NOT_0"
  fun op WORD_NOT_T _ = () val op WORD_NOT_T = TDB.find "WORD_NOT_T"
  fun op WORD_NEG_T _ = () val op WORD_NEG_T = TDB.find "WORD_NEG_T"
  fun op WORD_MULT_SUC _ = ()
  val op WORD_MULT_SUC = TDB.find "WORD_MULT_SUC"
  fun op WORD_NEG_LMUL _ = ()
  val op WORD_NEG_LMUL = TDB.find "WORD_NEG_LMUL"
  fun op WORD_NEG_RMUL _ = ()
  val op WORD_NEG_RMUL = TDB.find "WORD_NEG_RMUL"
  fun op WORD_NEG_MUL _ = () val op WORD_NEG_MUL = TDB.find "WORD_NEG_MUL"
  fun op sw2sw_w2w_add _ = ()
  val op sw2sw_w2w_add = TDB.find "sw2sw_w2w_add"
  fun op WORD_ADD_BIT0 _ = ()
  val op WORD_ADD_BIT0 = TDB.find "WORD_ADD_BIT0"
  fun op WORD_ADD_BIT _ = () val op WORD_ADD_BIT = TDB.find "WORD_ADD_BIT"
  fun op WORD_LEFT_SUB_DISTRIB _ = ()
  val op WORD_LEFT_SUB_DISTRIB = TDB.find "WORD_LEFT_SUB_DISTRIB"
  fun op WORD_RIGHT_SUB_DISTRIB _ = ()
  val op WORD_RIGHT_SUB_DISTRIB = TDB.find "WORD_RIGHT_SUB_DISTRIB"
  fun op WORD_LITERAL_MULT _ = ()
  val op WORD_LITERAL_MULT = TDB.find "WORD_LITERAL_MULT"
  fun op WORD_LITERAL_ADD _ = ()
  val op WORD_LITERAL_ADD = TDB.find "WORD_LITERAL_ADD"
  fun op WORD_SUB_INTRO _ = ()
  val op WORD_SUB_INTRO = TDB.find "WORD_SUB_INTRO"
  fun op n2w_SUC _ = () val op n2w_SUC = TDB.find "n2w_SUC"
  fun op n2w_sub _ = () val op n2w_sub = TDB.find "n2w_sub"
  fun op n2w_sub_eq_0 _ = () val op n2w_sub_eq_0 = TDB.find "n2w_sub_eq_0"
  fun op WORD_H_WORD_L _ = ()
  val op WORD_H_WORD_L = TDB.find "WORD_H_WORD_L"
  fun op word_L_MULT _ = () val op word_L_MULT = TDB.find "word_L_MULT"
  fun op ASR_ADD _ = () val op ASR_ADD = TDB.find "ASR_ADD"
  fun op LSR_ADD _ = () val op LSR_ADD = TDB.find "LSR_ADD"
  fun op ROR_ADD _ = () val op ROR_ADD = TDB.find "ROR_ADD"
  fun op LSL_ADD _ = () val op LSL_ADD = TDB.find "LSL_ADD"
  fun op ASR_LIMIT _ = () val op ASR_LIMIT = TDB.find "ASR_LIMIT"
  fun op ASR_UINT_MAX _ = () val op ASR_UINT_MAX = TDB.find "ASR_UINT_MAX"
  fun op LSR_LIMIT _ = () val op LSR_LIMIT = TDB.find "LSR_LIMIT"
  fun op LSL_LIMIT _ = () val op LSL_LIMIT = TDB.find "LSL_LIMIT"
  fun op ROR_CYCLE _ = () val op ROR_CYCLE = TDB.find "ROR_CYCLE"
  fun op ROR_MOD _ = () val op ROR_MOD = TDB.find "ROR_MOD"
  fun op ROL_MOD _ = () val op ROL_MOD = TDB.find "ROL_MOD"
  fun op LSL_ONE _ = () val op LSL_ONE = TDB.find "LSL_ONE"
  fun op ROR_UINT_MAX _ = () val op ROR_UINT_MAX = TDB.find "ROR_UINT_MAX"
  fun op ROR_ROL _ = () val op ROR_ROL = TDB.find "ROR_ROL"
  fun op MOD_COMPLEMENT _ = ()
  val op MOD_COMPLEMENT = TDB.find "MOD_COMPLEMENT"
  fun op ROL_ADD _ = () val op ROL_ADD = TDB.find "ROL_ADD"
  fun op ZERO_SHIFT _ = () val op ZERO_SHIFT = TDB.find "ZERO_SHIFT"
  fun op SHIFT_ZERO _ = () val op SHIFT_ZERO = TDB.find "SHIFT_ZERO"
  fun op word_lsl_n2w _ = () val op word_lsl_n2w = TDB.find "word_lsl_n2w"
  fun op word_1_lsl _ = () val op word_1_lsl = TDB.find "word_1_lsl"
  fun op word_lsr_n2w _ = () val op word_lsr_n2w = TDB.find "word_lsr_n2w"
  fun op LSL_UINT_MAX _ = () val op LSL_UINT_MAX = TDB.find "LSL_UINT_MAX"
  fun op word_asr_n2w _ = () val op word_asr_n2w = TDB.find "word_asr_n2w"
  fun op word_ror_n2w _ = () val op word_ror_n2w = TDB.find "word_ror_n2w"
  fun op word_rrx_n2w _ = () val op word_rrx_n2w = TDB.find "word_rrx_n2w"
  fun op word_ror _ = () val op word_ror = TDB.find "word_ror"
  fun op word_asr _ = () val op word_asr = TDB.find "word_asr"
  fun op w2n_lsr _ = () val op w2n_lsr = TDB.find "w2n_lsr"
  fun op WORD_MUL_LSL _ = () val op WORD_MUL_LSL = TDB.find "WORD_MUL_LSL"
  fun op WORD_ADD_LSL _ = () val op WORD_ADD_LSL = TDB.find "WORD_ADD_LSL"
  fun op WORD_DIV_LSR _ = () val op WORD_DIV_LSR = TDB.find "WORD_DIV_LSR"
  fun op WORD_MOD_1 _ = () val op WORD_MOD_1 = TDB.find "WORD_MOD_1"
  fun op WORD_MOD_POW2 _ = ()
  val op WORD_MOD_POW2 = TDB.find "WORD_MOD_POW2"
  fun op SHIFT_1_SUB_1 _ = ()
  val op SHIFT_1_SUB_1 = TDB.find "SHIFT_1_SUB_1"
  fun op LSR_BITWISE _ = () val op LSR_BITWISE = TDB.find "LSR_BITWISE"
  fun op LSL_BITWISE _ = () val op LSL_BITWISE = TDB.find "LSL_BITWISE"
  fun op ROR_BITWISE _ = () val op ROR_BITWISE = TDB.find "ROR_BITWISE"
  fun op ROL_BITWISE _ = () val op ROL_BITWISE = TDB.find "ROL_BITWISE"
  fun op WORD_2COMP_LSL _ = ()
  val op WORD_2COMP_LSL = TDB.find "WORD_2COMP_LSL"
  fun op w2w_LSL _ = () val op w2w_LSL = TDB.find "w2w_LSL"
  fun op n2w_DIV _ = () val op n2w_DIV = TDB.find "n2w_DIV"
  fun op WORD_BITS_LSL _ = ()
  val op WORD_BITS_LSL = TDB.find "WORD_BITS_LSL"
  fun op WORD_EXTRACT_LSL _ = ()
  val op WORD_EXTRACT_LSL = TDB.find "WORD_EXTRACT_LSL"
  fun op WORD_EXTRACT_LSL2 _ = ()
  val op WORD_EXTRACT_LSL2 = TDB.find "WORD_EXTRACT_LSL2"
  fun op EXTRACT_JOIN_LSL _ = ()
  val op EXTRACT_JOIN_LSL = TDB.find "EXTRACT_JOIN_LSL"
  fun op EXTRACT_JOIN_ADD_LSL _ = ()
  val op EXTRACT_JOIN_ADD_LSL = TDB.find "EXTRACT_JOIN_ADD_LSL"
  fun op word_extract_mask _ = ()
  val op word_extract_mask = TDB.find "word_extract_mask"
  fun op word_bits_mask _ = ()
  val op word_bits_mask = TDB.find "word_bits_mask"
  fun op word_extract_w2w_mask _ = ()
  val op word_extract_w2w_mask = TDB.find "word_extract_w2w_mask"
  fun op word_shift_bv _ = ()
  val op word_shift_bv = TDB.find "word_shift_bv"
  fun op lsl_lsr _ = () val op lsl_lsr = TDB.find "lsl_lsr"
  fun op WORD_NEG_L _ = () val op WORD_NEG_L = TDB.find "WORD_NEG_L"
  fun op word_L_MULT_NEG _ = ()
  val op word_L_MULT_NEG = TDB.find "word_L_MULT_NEG"
  fun op word_L2_MULT _ = () val op word_L2_MULT = TDB.find "word_L2_MULT"
  fun op TWO_COMP_NEG _ = () val op TWO_COMP_NEG = TDB.find "TWO_COMP_NEG"
  fun op TWO_COMP_POS_NEG _ = ()
  val op TWO_COMP_POS_NEG = TDB.find "TWO_COMP_POS_NEG"
  fun op WORD_0_POS _ = () val op WORD_0_POS = TDB.find "WORD_0_POS"
  fun op TWO_COMP_POS _ = () val op TWO_COMP_POS = TDB.find "TWO_COMP_POS"
  fun op WORD_H_POS _ = () val op WORD_H_POS = TDB.find "WORD_H_POS"
  fun op WORD_L_NEG _ = () val op WORD_L_NEG = TDB.find "WORD_L_NEG"
  fun op WORD_GREATER _ = () val op WORD_GREATER = TDB.find "WORD_GREATER"
  fun op WORD_GREATER_EQ _ = ()
  val op WORD_GREATER_EQ = TDB.find "WORD_GREATER_EQ"
  fun op WORD_NOT_LESS _ = ()
  val op WORD_NOT_LESS = TDB.find "WORD_NOT_LESS"
  fun op WORD_LT _ = () val op WORD_LT = TDB.find "WORD_LT"
  fun op WORD_GT _ = () val op WORD_GT = TDB.find "WORD_GT"
  fun op WORD_LE _ = () val op WORD_LE = TDB.find "WORD_LE"
  fun op WORD_GE _ = () val op WORD_GE = TDB.find "WORD_GE"
  fun op WORD_LO _ = () val op WORD_LO = TDB.find "WORD_LO"
  fun op WORD_LS _ = () val op WORD_LS = TDB.find "WORD_LS"
  fun op WORD_HI _ = () val op WORD_HI = TDB.find "WORD_HI"
  fun op WORD_HS _ = () val op WORD_HS = TDB.find "WORD_HS"
  fun op WORD_NOT_LESS_EQUAL _ = ()
  val op WORD_NOT_LESS_EQUAL = TDB.find "WORD_NOT_LESS_EQUAL"
  fun op WORD_LESS_OR_EQ _ = ()
  val op WORD_LESS_OR_EQ = TDB.find "WORD_LESS_OR_EQ"
  fun op WORD_GREATER_OR_EQ _ = ()
  val op WORD_GREATER_OR_EQ = TDB.find "WORD_GREATER_OR_EQ"
  fun op WORD_LESS_TRANS _ = ()
  val op WORD_LESS_TRANS = TDB.find "WORD_LESS_TRANS"
  fun op WORD_LESS_EQ_TRANS _ = ()
  val op WORD_LESS_EQ_TRANS = TDB.find "WORD_LESS_EQ_TRANS"
  fun op WORD_LESS_EQ_LESS_TRANS _ = ()
  val op WORD_LESS_EQ_LESS_TRANS = TDB.find "WORD_LESS_EQ_LESS_TRANS"
  fun op WORD_LESS_LESS_EQ_TRANS _ = ()
  val op WORD_LESS_LESS_EQ_TRANS = TDB.find "WORD_LESS_LESS_EQ_TRANS"
  fun op WORD_LESS_EQ_CASES _ = ()
  val op WORD_LESS_EQ_CASES = TDB.find "WORD_LESS_EQ_CASES"
  fun op WORD_LESS_CASES _ = ()
  val op WORD_LESS_CASES = TDB.find "WORD_LESS_CASES"
  fun op WORD_LESS_CASES_IMP _ = ()
  val op WORD_LESS_CASES_IMP = TDB.find "WORD_LESS_CASES_IMP"
  fun op WORD_LESS_ANTISYM _ = ()
  val op WORD_LESS_ANTISYM = TDB.find "WORD_LESS_ANTISYM"
  fun op WORD_LESS_EQ_ANTISYM _ = ()
  val op WORD_LESS_EQ_ANTISYM = TDB.find "WORD_LESS_EQ_ANTISYM"
  fun op WORD_LESS_EQ_REFL _ = ()
  val op WORD_LESS_EQ_REFL = TDB.find "WORD_LESS_EQ_REFL"
  fun op WORD_LESS_EQUAL_ANTISYM _ = ()
  val op WORD_LESS_EQUAL_ANTISYM = TDB.find "WORD_LESS_EQUAL_ANTISYM"
  fun op WORD_LESS_IMP_LESS_OR_EQ _ = ()
  val op WORD_LESS_IMP_LESS_OR_EQ = TDB.find "WORD_LESS_IMP_LESS_OR_EQ"
  fun op WORD_LESS_REFL _ = ()
  val op WORD_LESS_REFL = TDB.find "WORD_LESS_REFL"
  fun op WORD_LESS_LESS_CASES _ = ()
  val op WORD_LESS_LESS_CASES = TDB.find "WORD_LESS_LESS_CASES"
  fun op WORD_NOT_GREATER _ = ()
  val op WORD_NOT_GREATER = TDB.find "WORD_NOT_GREATER"
  fun op WORD_LESS_NOT_EQ _ = ()
  val op WORD_LESS_NOT_EQ = TDB.find "WORD_LESS_NOT_EQ"
  fun op WORD_NOT_LESS_EQ _ = ()
  val op WORD_NOT_LESS_EQ = TDB.find "WORD_NOT_LESS_EQ"
  fun op WORD_HIGHER _ = () val op WORD_HIGHER = TDB.find "WORD_HIGHER"
  fun op WORD_HIGHER_EQ _ = ()
  val op WORD_HIGHER_EQ = TDB.find "WORD_HIGHER_EQ"
  fun op WORD_NOT_LOWER _ = ()
  val op WORD_NOT_LOWER = TDB.find "WORD_NOT_LOWER"
  fun op WORD_NOT_LOWER_EQUAL _ = ()
  val op WORD_NOT_LOWER_EQUAL = TDB.find "WORD_NOT_LOWER_EQUAL"
  fun op WORD_LOWER_OR_EQ _ = ()
  val op WORD_LOWER_OR_EQ = TDB.find "WORD_LOWER_OR_EQ"
  fun op WORD_HIGHER_OR_EQ _ = ()
  val op WORD_HIGHER_OR_EQ = TDB.find "WORD_HIGHER_OR_EQ"
  fun op WORD_LOWER_TRANS _ = ()
  val op WORD_LOWER_TRANS = TDB.find "WORD_LOWER_TRANS"
  fun op WORD_LOWER_EQ_TRANS _ = ()
  val op WORD_LOWER_EQ_TRANS = TDB.find "WORD_LOWER_EQ_TRANS"
  fun op WORD_LOWER_EQ_LOWER_TRANS _ = ()
  val op WORD_LOWER_EQ_LOWER_TRANS = TDB.find "WORD_LOWER_EQ_LOWER_TRANS"
  fun op WORD_LOWER_LOWER_EQ_TRANS _ = ()
  val op WORD_LOWER_LOWER_EQ_TRANS = TDB.find "WORD_LOWER_LOWER_EQ_TRANS"
  fun op WORD_LOWER_EQ_CASES _ = ()
  val op WORD_LOWER_EQ_CASES = TDB.find "WORD_LOWER_EQ_CASES"
  fun op WORD_LOWER_CASES _ = ()
  val op WORD_LOWER_CASES = TDB.find "WORD_LOWER_CASES"
  fun op WORD_LOWER_CASES_IMP _ = ()
  val op WORD_LOWER_CASES_IMP = TDB.find "WORD_LOWER_CASES_IMP"
  fun op WORD_LOWER_ANTISYM _ = ()
  val op WORD_LOWER_ANTISYM = TDB.find "WORD_LOWER_ANTISYM"
  fun op WORD_LOWER_EQ_ANTISYM _ = ()
  val op WORD_LOWER_EQ_ANTISYM = TDB.find "WORD_LOWER_EQ_ANTISYM"
  fun op WORD_LOWER_EQ_REFL _ = ()
  val op WORD_LOWER_EQ_REFL = TDB.find "WORD_LOWER_EQ_REFL"
  fun op WORD_LOWER_EQUAL_ANTISYM _ = ()
  val op WORD_LOWER_EQUAL_ANTISYM = TDB.find "WORD_LOWER_EQUAL_ANTISYM"
  fun op WORD_LOWER_IMP_LOWER_OR_EQ _ = ()
  val op WORD_LOWER_IMP_LOWER_OR_EQ = TDB.find "WORD_LOWER_IMP_LOWER_OR_EQ"
  fun op WORD_LOWER_REFL _ = ()
  val op WORD_LOWER_REFL = TDB.find "WORD_LOWER_REFL"
  fun op WORD_LOWER_LOWER_CASES _ = ()
  val op WORD_LOWER_LOWER_CASES = TDB.find "WORD_LOWER_LOWER_CASES"
  fun op WORD_NOT_HIGHER _ = ()
  val op WORD_NOT_HIGHER = TDB.find "WORD_NOT_HIGHER"
  fun op WORD_LOWER_NOT_EQ _ = ()
  val op WORD_LOWER_NOT_EQ = TDB.find "WORD_LOWER_NOT_EQ"
  fun op WORD_NOT_LOWER_EQ _ = ()
  val op WORD_NOT_LOWER_EQ = TDB.find "WORD_NOT_LOWER_EQ"
  fun op WORD_L_PLUS_H _ = ()
  val op WORD_L_PLUS_H = TDB.find "WORD_L_PLUS_H"
  fun op WORD_L_LESS_EQ _ = ()
  val op WORD_L_LESS_EQ = TDB.find "WORD_L_LESS_EQ"
  fun op WORD_LESS_EQ_H _ = ()
  val op WORD_LESS_EQ_H = TDB.find "WORD_LESS_EQ_H"
  fun op WORD_L_LESS_H _ = ()
  val op WORD_L_LESS_H = TDB.find "WORD_L_LESS_H"
  fun op NOT_INT_MIN_ZERO _ = ()
  val op NOT_INT_MIN_ZERO = TDB.find "NOT_INT_MIN_ZERO"
  fun op ZERO_LO_INT_MIN _ = ()
  val op ZERO_LO_INT_MIN = TDB.find "ZERO_LO_INT_MIN"
  fun op WORD_0_LS _ = () val op WORD_0_LS = TDB.find "WORD_0_LS"
  fun op WORD_LS_T _ = () val op WORD_LS_T = TDB.find "WORD_LS_T"
  fun op WORD_ADD_LEFT_LO _ = ()
  val op WORD_ADD_LEFT_LO = TDB.find "WORD_ADD_LEFT_LO"
  fun op WORD_ADD_LEFT_LS _ = ()
  val op WORD_ADD_LEFT_LS = TDB.find "WORD_ADD_LEFT_LS"
  fun op WORD_ADD_RIGHT_LS _ = ()
  val op WORD_ADD_RIGHT_LS = TDB.find "WORD_ADD_RIGHT_LS"
  fun op WORD_ADD_RIGHT_LO _ = ()
  val op WORD_ADD_RIGHT_LO = TDB.find "WORD_ADD_RIGHT_LO"
  fun op WORD_MSB_INT_MIN_LS _ = ()
  val op WORD_MSB_INT_MIN_LS = TDB.find "WORD_MSB_INT_MIN_LS"
  fun op WORD_LT_LO _ = () val op WORD_LT_LO = TDB.find "WORD_LT_LO"
  fun op WORD_LE_LS _ = () val op WORD_LE_LS = TDB.find "WORD_LE_LS"
  fun op WORD_LESS_NEG_LEFT _ = ()
  val op WORD_LESS_NEG_LEFT = TDB.find "WORD_LESS_NEG_LEFT"
  fun op WORD_LESS_NEG_RIGHT _ = ()
  val op WORD_LESS_NEG_RIGHT = TDB.find "WORD_LESS_NEG_RIGHT"
  fun op WORD_LS_word_0 _ = ()
  val op WORD_LS_word_0 = TDB.find "WORD_LS_word_0"
  fun op WORD_LO_word_0 _ = ()
  val op WORD_LO_word_0 = TDB.find "WORD_LO_word_0"
  fun op WORD_ADD_LEFT_LO2 _ = ()
  val op WORD_ADD_LEFT_LO2 = TDB.find "WORD_ADD_LEFT_LO2"
  fun op WORD_ADD_LEFT_LS2 _ = ()
  val op WORD_ADD_LEFT_LS2 = TDB.find "WORD_ADD_LEFT_LS2"
  fun op WORD_ADD_RIGHT_LO2 _ = ()
  val op WORD_ADD_RIGHT_LO2 = TDB.find "WORD_ADD_RIGHT_LO2"
  fun op WORD_ADD_RIGHT_LS2 _ = ()
  val op WORD_ADD_RIGHT_LS2 = TDB.find "WORD_ADD_RIGHT_LS2"
  fun op word_msb_neg _ = () val op word_msb_neg = TDB.find "word_msb_neg"
  fun op word_abs _ = () val op word_abs = TDB.find "word_abs"
  fun op word_abs_word_abs _ = ()
  val op word_abs_word_abs = TDB.find "word_abs_word_abs"
  fun op word_abs_neg _ = () val op word_abs_neg = TDB.find "word_abs_neg"
  fun op word_abs_diff _ = ()
  val op word_abs_diff = TDB.find "word_abs_diff"
  fun op FST_ADD_WITH_CARRY _ = ()
  val op FST_ADD_WITH_CARRY = TDB.find "FST_ADD_WITH_CARRY"
  fun op ADD_WITH_CARRY_SUB _ = ()
  val op ADD_WITH_CARRY_SUB = TDB.find "ADD_WITH_CARRY_SUB"
  fun op word_eq_n2w _ = () val op word_eq_n2w = TDB.find "word_eq_n2w"
  fun op word_lt_n2w _ = () val op word_lt_n2w = TDB.find "word_lt_n2w"
  fun op word_gt_n2w _ = () val op word_gt_n2w = TDB.find "word_gt_n2w"
  fun op word_le_n2w _ = () val op word_le_n2w = TDB.find "word_le_n2w"
  fun op word_ge_n2w _ = () val op word_ge_n2w = TDB.find "word_ge_n2w"
  fun op word_ls_n2w _ = () val op word_ls_n2w = TDB.find "word_ls_n2w"
  fun op word_hi_n2w _ = () val op word_hi_n2w = TDB.find "word_hi_n2w"
  fun op word_lo_n2w _ = () val op word_lo_n2w = TDB.find "word_lo_n2w"
  fun op word_hs_n2w _ = () val op word_hs_n2w = TDB.find "word_hs_n2w"
  fun op w2n_add _ = () val op w2n_add = TDB.find "w2n_add"
  fun op saturate_w2w_n2w _ = ()
  val op saturate_w2w_n2w = TDB.find "saturate_w2w_n2w"
  fun op saturate_w2w _ = () val op saturate_w2w = TDB.find "saturate_w2w"
  fun op saturate_sub _ = () val op saturate_sub = TDB.find "saturate_sub"
  fun op saturate_add _ = () val op saturate_add = TDB.find "saturate_add"
  fun op NOT_FINITE_IMP_dimword_2 _ = ()
  val op NOT_FINITE_IMP_dimword_2 = TDB.find "NOT_FINITE_IMP_dimword_2"
  fun op saturate_mul _ = () val op saturate_mul = TDB.find "saturate_mul"
  fun op WORD_DIVISION _ = ()
  val op WORD_DIVISION = TDB.find "WORD_DIVISION"
  fun op word_reverse_0 _ = ()
  val op word_reverse_0 = TDB.find "word_reverse_0"
  fun op word_reverse_word_T _ = ()
  val op word_reverse_word_T = TDB.find "word_reverse_word_T"
  fun op sw2sw_0 _ = () val op sw2sw_0 = TDB.find "sw2sw_0"
  fun op sw2sw_word_T _ = () val op sw2sw_word_T = TDB.find "sw2sw_word_T"
  fun op word_div_1 _ = () val op word_div_1 = TDB.find "word_div_1"
  fun op word_bit_0 _ = () val op word_bit_0 = TDB.find "word_bit_0"
  fun op word_lsb_word_T _ = ()
  val op word_lsb_word_T = TDB.find "word_lsb_word_T"
  fun op word_msb_word_T _ = ()
  val op word_msb_word_T = TDB.find "word_msb_word_T"
  fun op word_bit_0_word_T _ = ()
  val op word_bit_0_word_T = TDB.find "word_bit_0_word_T"
  fun op word_log2_1 _ = () val op word_log2_1 = TDB.find "word_log2_1"
  fun op word_join_0 _ = () val op word_join_0 = TDB.find "word_join_0"
  fun op word_concat_0_0 _ = ()
  val op word_concat_0_0 = TDB.find "word_concat_0_0"
  fun op w2w_eq_n2w _ = () val op w2w_eq_n2w = TDB.find "w2w_eq_n2w"
  fun op word_extract_eq_n2w _ = ()
  val op word_extract_eq_n2w = TDB.find "word_extract_eq_n2w"
  fun op word_concat_0 _ = ()
  val op word_concat_0 = TDB.find "word_concat_0"
  fun op word_concat_0_eq _ = ()
  val op word_concat_0_eq = TDB.find "word_concat_0_eq"
  fun op word_concat_assoc _ = ()
  val op word_concat_assoc = TDB.find "word_concat_assoc"
  fun op word_join_word_T _ = ()
  val op word_join_word_T = TDB.find "word_join_word_T"
  fun op word_concat_word_T _ = ()
  val op word_concat_word_T = TDB.find "word_concat_word_T"
  fun op lsr_1_word_T _ = () val op lsr_1_word_T = TDB.find "lsr_1_word_T"
  fun op word_rrx_0 _ = () val op word_rrx_0 = TDB.find "word_rrx_0"
  fun op word_rrx_word_T _ = ()
  val op word_rrx_word_T = TDB.find "word_rrx_word_T"
  fun op word_T_not_zero _ = ()
  val op word_T_not_zero = TDB.find "word_T_not_zero"
  fun op WORD_LS_word_T _ = ()
  val op WORD_LS_word_T = TDB.find "WORD_LS_word_T"
  fun op WORD_LO_word_T _ = ()
  val op WORD_LO_word_T = TDB.find "WORD_LO_word_T"
  fun op WORD_LESS_0_word_T _ = ()
  val op WORD_LESS_0_word_T = TDB.find "WORD_LESS_0_word_T"
  fun op word_reverse_thm _ = ()
  val op word_reverse_thm = TDB.find "word_reverse_thm"
  fun op bit_count_upto_0 _ = ()
  val op bit_count_upto_0 = TDB.find "bit_count_upto_0"
  fun op bit_count_upto_SUC _ = ()
  val op bit_count_upto_SUC = TDB.find "bit_count_upto_SUC"
  fun op bit_count_upto_is_zero _ = ()
  val op bit_count_upto_is_zero = TDB.find "bit_count_upto_is_zero"
  fun op bit_count_is_zero _ = ()
  val op bit_count_is_zero = TDB.find "bit_count_is_zero"
  fun op WORD_FINITE _ = () val op WORD_FINITE = TDB.find "WORD_FINITE"
  fun op WORD_SET_INDUCT _ = ()
  val op WORD_SET_INDUCT = TDB.find "WORD_SET_INDUCT"
  fun op SUC_WORD_PRED _ = ()
  val op SUC_WORD_PRED = TDB.find "SUC_WORD_PRED"
  fun op WORD_PRED_THM _ = ()
  val op WORD_PRED_THM = TDB.find "WORD_PRED_THM"
  fun op LSR_LESS _ = () val op LSR_LESS = TDB.find "LSR_LESS"
  fun op word_sub_w2n _ = () val op word_sub_w2n = TDB.find "word_sub_w2n"
  fun op WORD_LE_EQ_LS _ = ()
  val op WORD_LE_EQ_LS = TDB.find "WORD_LE_EQ_LS"
  fun op WORD_LT_EQ_LO _ = ()
  val op WORD_LT_EQ_LO = TDB.find "WORD_LT_EQ_LO"
  fun op WORD_ZERO_LE _ = () val op WORD_ZERO_LE = TDB.find "WORD_ZERO_LE"
  fun op WORD_LT_SUB_UPPER _ = ()
  val op WORD_LT_SUB_UPPER = TDB.find "WORD_LT_SUB_UPPER"
  fun op WORD_SUB_LT _ = () val op WORD_SUB_LT = TDB.find "WORD_SUB_LT"
  fun op WORD_SUB_LE _ = () val op WORD_SUB_LE = TDB.find "WORD_SUB_LE"
  fun op word_bit_thm _ = () val op word_bit_thm = TDB.find "word_bit_thm"
  fun op word_bit_and _ = () val op word_bit_and = TDB.find "word_bit_and"
  fun op word_bit_or _ = () val op word_bit_or = TDB.find "word_bit_or"
  fun op word_bit_lsl _ = () val op word_bit_lsl = TDB.find "word_bit_lsl"
  fun op word_bit_test _ = ()
  val op word_bit_test = TDB.find "word_bit_test"
  fun op dimindex_1 _ = () val op dimindex_1 = TDB.find "dimindex_1"
  fun op finite_1 _ = () val op finite_1 = TDB.find "finite_1"
  fun op INT_MIN_1 _ = () val op INT_MIN_1 = TDB.find "INT_MIN_1"
  fun op dimword_1 _ = () val op dimword_1 = TDB.find "dimword_1"
  fun op dimindex_2 _ = () val op dimindex_2 = TDB.find "dimindex_2"
  fun op finite_2 _ = () val op finite_2 = TDB.find "finite_2"
  fun op INT_MIN_2 _ = () val op INT_MIN_2 = TDB.find "INT_MIN_2"
  fun op dimword_2 _ = () val op dimword_2 = TDB.find "dimword_2"
  fun op dimindex_3 _ = () val op dimindex_3 = TDB.find "dimindex_3"
  fun op finite_3 _ = () val op finite_3 = TDB.find "finite_3"
  fun op INT_MIN_3 _ = () val op INT_MIN_3 = TDB.find "INT_MIN_3"
  fun op dimword_3 _ = () val op dimword_3 = TDB.find "dimword_3"
  fun op dimindex_4 _ = () val op dimindex_4 = TDB.find "dimindex_4"
  fun op finite_4 _ = () val op finite_4 = TDB.find "finite_4"
  fun op INT_MIN_4 _ = () val op INT_MIN_4 = TDB.find "INT_MIN_4"
  fun op dimword_4 _ = () val op dimword_4 = TDB.find "dimword_4"
  fun op dimindex_5 _ = () val op dimindex_5 = TDB.find "dimindex_5"
  fun op finite_5 _ = () val op finite_5 = TDB.find "finite_5"
  fun op INT_MIN_5 _ = () val op INT_MIN_5 = TDB.find "INT_MIN_5"
  fun op dimword_5 _ = () val op dimword_5 = TDB.find "dimword_5"
  fun op dimindex_6 _ = () val op dimindex_6 = TDB.find "dimindex_6"
  fun op finite_6 _ = () val op finite_6 = TDB.find "finite_6"
  fun op INT_MIN_6 _ = () val op INT_MIN_6 = TDB.find "INT_MIN_6"
  fun op dimword_6 _ = () val op dimword_6 = TDB.find "dimword_6"
  fun op dimindex_7 _ = () val op dimindex_7 = TDB.find "dimindex_7"
  fun op finite_7 _ = () val op finite_7 = TDB.find "finite_7"
  fun op INT_MIN_7 _ = () val op INT_MIN_7 = TDB.find "INT_MIN_7"
  fun op dimword_7 _ = () val op dimword_7 = TDB.find "dimword_7"
  fun op dimindex_8 _ = () val op dimindex_8 = TDB.find "dimindex_8"
  fun op finite_8 _ = () val op finite_8 = TDB.find "finite_8"
  fun op INT_MIN_8 _ = () val op INT_MIN_8 = TDB.find "INT_MIN_8"
  fun op dimword_8 _ = () val op dimword_8 = TDB.find "dimword_8"
  fun op dimindex_9 _ = () val op dimindex_9 = TDB.find "dimindex_9"
  fun op finite_9 _ = () val op finite_9 = TDB.find "finite_9"
  fun op INT_MIN_9 _ = () val op INT_MIN_9 = TDB.find "INT_MIN_9"
  fun op dimword_9 _ = () val op dimword_9 = TDB.find "dimword_9"
  fun op dimindex_10 _ = () val op dimindex_10 = TDB.find "dimindex_10"
  fun op finite_10 _ = () val op finite_10 = TDB.find "finite_10"
  fun op INT_MIN_10 _ = () val op INT_MIN_10 = TDB.find "INT_MIN_10"
  fun op dimword_10 _ = () val op dimword_10 = TDB.find "dimword_10"
  fun op dimindex_11 _ = () val op dimindex_11 = TDB.find "dimindex_11"
  fun op finite_11 _ = () val op finite_11 = TDB.find "finite_11"
  fun op INT_MIN_11 _ = () val op INT_MIN_11 = TDB.find "INT_MIN_11"
  fun op dimword_11 _ = () val op dimword_11 = TDB.find "dimword_11"
  fun op dimindex_12 _ = () val op dimindex_12 = TDB.find "dimindex_12"
  fun op finite_12 _ = () val op finite_12 = TDB.find "finite_12"
  fun op INT_MIN_12 _ = () val op INT_MIN_12 = TDB.find "INT_MIN_12"
  fun op dimword_12 _ = () val op dimword_12 = TDB.find "dimword_12"
  fun op dimindex_16 _ = () val op dimindex_16 = TDB.find "dimindex_16"
  fun op finite_16 _ = () val op finite_16 = TDB.find "finite_16"
  fun op INT_MIN_16 _ = () val op INT_MIN_16 = TDB.find "INT_MIN_16"
  fun op dimword_16 _ = () val op dimword_16 = TDB.find "dimword_16"
  fun op dimindex_20 _ = () val op dimindex_20 = TDB.find "dimindex_20"
  fun op finite_20 _ = () val op finite_20 = TDB.find "finite_20"
  fun op INT_MIN_20 _ = () val op INT_MIN_20 = TDB.find "INT_MIN_20"
  fun op dimword_20 _ = () val op dimword_20 = TDB.find "dimword_20"
  fun op dimindex_24 _ = () val op dimindex_24 = TDB.find "dimindex_24"
  fun op finite_24 _ = () val op finite_24 = TDB.find "finite_24"
  fun op INT_MIN_24 _ = () val op INT_MIN_24 = TDB.find "INT_MIN_24"
  fun op dimword_24 _ = () val op dimword_24 = TDB.find "dimword_24"
  fun op dimindex_28 _ = () val op dimindex_28 = TDB.find "dimindex_28"
  fun op finite_28 _ = () val op finite_28 = TDB.find "finite_28"
  fun op INT_MIN_28 _ = () val op INT_MIN_28 = TDB.find "INT_MIN_28"
  fun op dimword_28 _ = () val op dimword_28 = TDB.find "dimword_28"
  fun op dimindex_30 _ = () val op dimindex_30 = TDB.find "dimindex_30"
  fun op finite_30 _ = () val op finite_30 = TDB.find "finite_30"
  fun op INT_MIN_30 _ = () val op INT_MIN_30 = TDB.find "INT_MIN_30"
  fun op dimword_30 _ = () val op dimword_30 = TDB.find "dimword_30"
  fun op dimindex_32 _ = () val op dimindex_32 = TDB.find "dimindex_32"
  fun op finite_32 _ = () val op finite_32 = TDB.find "finite_32"
  fun op INT_MIN_32 _ = () val op INT_MIN_32 = TDB.find "INT_MIN_32"
  fun op dimword_32 _ = () val op dimword_32 = TDB.find "dimword_32"
  fun op dimindex_48 _ = () val op dimindex_48 = TDB.find "dimindex_48"
  fun op finite_48 _ = () val op finite_48 = TDB.find "finite_48"
  fun op INT_MIN_48 _ = () val op INT_MIN_48 = TDB.find "INT_MIN_48"
  fun op dimword_48 _ = () val op dimword_48 = TDB.find "dimword_48"
  fun op dimindex_64 _ = () val op dimindex_64 = TDB.find "dimindex_64"
  fun op finite_64 _ = () val op finite_64 = TDB.find "finite_64"
  fun op INT_MIN_64 _ = () val op INT_MIN_64 = TDB.find "INT_MIN_64"
  fun op dimword_64 _ = () val op dimword_64 = TDB.find "dimword_64"
  fun op dimindex_96 _ = () val op dimindex_96 = TDB.find "dimindex_96"
  fun op finite_96 _ = () val op finite_96 = TDB.find "finite_96"
  fun op INT_MIN_96 _ = () val op INT_MIN_96 = TDB.find "INT_MIN_96"
  fun op dimword_96 _ = () val op dimword_96 = TDB.find "dimword_96"
  fun op dimindex_128 _ = () val op dimindex_128 = TDB.find "dimindex_128"
  fun op finite_128 _ = () val op finite_128 = TDB.find "finite_128"
  fun op INT_MIN_128 _ = () val op INT_MIN_128 = TDB.find "INT_MIN_128"
  fun op dimword_128 _ = () val op dimword_128 = TDB.find "dimword_128"
  fun op n2w_itself_ind _ = ()
  val op n2w_itself_ind = TDB.find "n2w_itself_ind"
  fun op n2w_itself_def _ = ()
  val op n2w_itself_def = TDB.find "n2w_itself_def"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val words_grammars = merge_grammars ["ASCIInumbers", "numeral_bit",
  "fcp", "sum_num"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="words"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val words_grammars = 
    Portable.## (addtyUDs,addtmUDs) words_grammars
  val _ = Parse.grammarDB_insert("words",words_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ = TotalDefn.termination_simps :=
    LSR_LESS :: WORD_PRED_THM :: !TotalDefn.termination_simps
  val _ =
    let
      open Lib boolSyntax numSyntax Drule
      val word_type = type_of (fst (dest_forall (concl word_nchotomy)))
      val w2n_tm = fst (strip_comb (lhs (snd (dest_forall (concl w2n_def)))))
      val w2n_abs =
        list_mk_abs ([mk_var ("v1", bool --> num),
                      mk_var ("v2", alpha --> num),
                      mk_var ("v3", word_type)],
                      mk_comb (w2n_tm, mk_var("v3" ,word_type)))
    in
      TypeBase.write
       [TypeBasePure.mk_nondatatype_info
        (word_type,
         {nchotomy = SOME ranged_word_nchotomy,
          induction = NONE,
          size = SOME (w2n_abs, CONJUNCT1 (SPEC_ALL boolTheory.AND_CLAUSES)),
          encode = NONE})]
    end;
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "words"

end
