structure bitTheory :> bitTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading bitTheory ... "
    else ()
  
  open Type Term Thm
  local open logrootTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "bit"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/extra_theories/bitTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op MOD_2EXP_def _ = () val op MOD_2EXP_def = TDB.find "MOD_2EXP_def"
  fun op DIV_2EXP_def _ = () val op DIV_2EXP_def = TDB.find "DIV_2EXP_def"
  fun op TIMES_2EXP_def _ = ()
  val op TIMES_2EXP_def = TDB.find "TIMES_2EXP_def"
  fun op DIVMOD_2EXP_def _ = ()
  val op DIVMOD_2EXP_def = TDB.find "DIVMOD_2EXP_def"
  fun op SBIT_def _ = () val op SBIT_def = TDB.find "SBIT_def"
  fun op BITS_def _ = () val op BITS_def = TDB.find "BITS_def"
  fun op BITV_def _ = () val op BITV_def = TDB.find "BITV_def"
  fun op BIT_def _ = () val op BIT_def = TDB.find "BIT_def"
  fun op SLICE_def _ = () val op SLICE_def = TDB.find "SLICE_def"
  fun op LOG2_def _ = () val op LOG2_def = TDB.find "LOG2_def"
  fun op LOWEST_SET_BIT_def _ = ()
  val op LOWEST_SET_BIT_def = TDB.find "LOWEST_SET_BIT_def"
  fun op BIT_REVERSE_def _ = ()
  val op BIT_REVERSE_def = TDB.find "BIT_REVERSE_def"
  fun op BITWISE_def _ = () val op BITWISE_def = TDB.find "BITWISE_def"
  fun op BIT_MODIFY_def _ = ()
  val op BIT_MODIFY_def = TDB.find "BIT_MODIFY_def"
  fun op SIGN_EXTEND_def _ = ()
  val op SIGN_EXTEND_def = TDB.find "SIGN_EXTEND_def"
  fun op MOD_2EXP_EQ_def _ = ()
  val op MOD_2EXP_EQ_def = TDB.find "MOD_2EXP_EQ_def"
  fun op MOD_2EXP_MAX_def _ = ()
  val op MOD_2EXP_MAX_def = TDB.find "MOD_2EXP_MAX_def"
  fun op LESS_MULT_MONO2 _ = ()
  val op LESS_MULT_MONO2 = TDB.find "LESS_MULT_MONO2"
  fun op LOG2_UNIQUE _ = () val op LOG2_UNIQUE = TDB.find "LOG2_UNIQUE"
  fun op LOG2_TWOEXP _ = () val op LOG2_TWOEXP = TDB.find "LOG2_TWOEXP"
  fun op DIVMOD_2EXP _ = () val op DIVMOD_2EXP = TDB.find "DIVMOD_2EXP"
  fun op SUC_SUB _ = () val op SUC_SUB = TDB.find "SUC_SUB"
  fun op DIV_MULT_1 _ = () val op DIV_MULT_1 = TDB.find "DIV_MULT_1"
  fun op NOT_ZERO_ADD1 _ = ()
  val op NOT_ZERO_ADD1 = TDB.find "NOT_ZERO_ADD1"
  fun op ZERO_LT_TWOEXP _ = ()
  val op ZERO_LT_TWOEXP = TDB.find "ZERO_LT_TWOEXP"
  fun op ONE_LE_TWOEXP _ = ()
  val op ONE_LE_TWOEXP = TDB.find "ONE_LE_TWOEXP"
  fun op TWOEXP_NOT_ZERO _ = ()
  val op TWOEXP_NOT_ZERO = TDB.find "TWOEXP_NOT_ZERO"
  fun op MOD_2EXP_LT _ = () val op MOD_2EXP_LT = TDB.find "MOD_2EXP_LT"
  fun op TWOEXP_DIVISION _ = ()
  val op TWOEXP_DIVISION = TDB.find "TWOEXP_DIVISION"
  fun op TWOEXP_MONO _ = () val op TWOEXP_MONO = TDB.find "TWOEXP_MONO"
  fun op TWOEXP_MONO2 _ = () val op TWOEXP_MONO2 = TDB.find "TWOEXP_MONO2"
  fun op EXP_SUB_LESS_EQ _ = ()
  val op EXP_SUB_LESS_EQ = TDB.find "EXP_SUB_LESS_EQ"
  fun op MOD_LEQ _ = () val op MOD_LEQ = TDB.find "MOD_LEQ"
  fun op BITS_THM _ = () val op BITS_THM = TDB.find "BITS_THM"
  fun op BITSLT_THM _ = () val op BITSLT_THM = TDB.find "BITSLT_THM"
  fun op BITSLT_THM2 _ = () val op BITSLT_THM2 = TDB.find "BITSLT_THM2"
  fun op BITS_THM2 _ = () val op BITS_THM2 = TDB.find "BITS_THM2"
  fun op BITS_LEQ _ = () val op BITS_LEQ = TDB.find "BITS_LEQ"
  fun op BITS_COMP_THM _ = ()
  val op BITS_COMP_THM = TDB.find "BITS_COMP_THM"
  fun op BITS_DIV_THM _ = () val op BITS_DIV_THM = TDB.find "BITS_DIV_THM"
  fun op BITS_LT_HIGH _ = () val op BITS_LT_HIGH = TDB.find "BITS_LT_HIGH"
  fun op BITS_ZERO _ = () val op BITS_ZERO = TDB.find "BITS_ZERO"
  fun op BITS_ZERO2 _ = () val op BITS_ZERO2 = TDB.find "BITS_ZERO2"
  fun op BITS_ZERO3 _ = () val op BITS_ZERO3 = TDB.find "BITS_ZERO3"
  fun op BITS_ZERO4 _ = () val op BITS_ZERO4 = TDB.find "BITS_ZERO4"
  fun op BITS_ZEROL _ = () val op BITS_ZEROL = TDB.find "BITS_ZEROL"
  fun op BITS_LOG2_ZERO_ID _ = ()
  val op BITS_LOG2_ZERO_ID = TDB.find "BITS_LOG2_ZERO_ID"
  fun op BITS_LT_LOW _ = () val op BITS_LT_LOW = TDB.find "BITS_LT_LOW"
  fun op BIT_ZERO _ = () val op BIT_ZERO = TDB.find "BIT_ZERO"
  fun op BIT_B _ = () val op BIT_B = TDB.find "BIT_B"
  fun op BIT_TWO_POW _ = () val op BIT_TWO_POW = TDB.find "BIT_TWO_POW"
  fun op BIT_B_NEQ _ = () val op BIT_B_NEQ = TDB.find "BIT_B_NEQ"
  fun op BITS_COMP_THM2 _ = ()
  val op BITS_COMP_THM2 = TDB.find "BITS_COMP_THM2"
  fun op NOT_MOD2_LEM _ = () val op NOT_MOD2_LEM = TDB.find "NOT_MOD2_LEM"
  fun op NOT_MOD2_LEM2 _ = ()
  val op NOT_MOD2_LEM2 = TDB.find "NOT_MOD2_LEM2"
  fun op ODD_MOD2_LEM _ = () val op ODD_MOD2_LEM = TDB.find "ODD_MOD2_LEM"
  fun op DIV_MULT_THM _ = () val op DIV_MULT_THM = TDB.find "DIV_MULT_THM"
  fun op DIV_MULT_THM2 _ = ()
  val op DIV_MULT_THM2 = TDB.find "DIV_MULT_THM2"
  fun op LESS_EQ_EXP_MULT _ = ()
  val op LESS_EQ_EXP_MULT = TDB.find "LESS_EQ_EXP_MULT"
  fun op SLICE_THM _ = () val op SLICE_THM = TDB.find "SLICE_THM"
  fun op SLICELT_THM _ = () val op SLICELT_THM = TDB.find "SLICELT_THM"
  fun op BITS_SLICE_THM _ = ()
  val op BITS_SLICE_THM = TDB.find "BITS_SLICE_THM"
  fun op BITS_SLICE_THM2 _ = ()
  val op BITS_SLICE_THM2 = TDB.find "BITS_SLICE_THM2"
  fun op SLICE_ZERO_THM _ = ()
  val op SLICE_ZERO_THM = TDB.find "SLICE_ZERO_THM"
  fun op MOD_2EXP_MONO _ = ()
  val op MOD_2EXP_MONO = TDB.find "MOD_2EXP_MONO"
  fun op SLICE_COMP_THM _ = ()
  val op SLICE_COMP_THM = TDB.find "SLICE_COMP_THM"
  fun op SLICE_COMP_RWT _ = ()
  val op SLICE_COMP_RWT = TDB.find "SLICE_COMP_RWT"
  fun op SLICE_ZERO _ = () val op SLICE_ZERO = TDB.find "SLICE_ZERO"
  fun op SLICE_ZERO2 _ = () val op SLICE_ZERO2 = TDB.find "SLICE_ZERO2"
  fun op BITS_SUM _ = () val op BITS_SUM = TDB.find "BITS_SUM"
  fun op BITS_SUM2 _ = () val op BITS_SUM2 = TDB.find "BITS_SUM2"
  fun op SLICE_COMP_THM2 _ = ()
  val op SLICE_COMP_THM2 = TDB.find "SLICE_COMP_THM2"
  fun op BITS_SUM3 _ = () val op BITS_SUM3 = TDB.find "BITS_SUM3"
  fun op BITS_MUL _ = () val op BITS_MUL = TDB.find "BITS_MUL"
  fun op BIT_COMP_THM3 _ = ()
  val op BIT_COMP_THM3 = TDB.find "BIT_COMP_THM3"
  fun op NOT_BIT _ = () val op NOT_BIT = TDB.find "NOT_BIT"
  fun op NOT_BITS _ = () val op NOT_BITS = TDB.find "NOT_BITS"
  fun op NOT_BITS2 _ = () val op NOT_BITS2 = TDB.find "NOT_BITS2"
  fun op BIT_SLICE _ = () val op BIT_SLICE = TDB.find "BIT_SLICE"
  fun op BIT_SLICE_LEM _ = ()
  val op BIT_SLICE_LEM = TDB.find "BIT_SLICE_LEM"
  fun op BIT_SLICE_THM _ = ()
  val op BIT_SLICE_THM = TDB.find "BIT_SLICE_THM"
  fun op BIT_SLICE_THM2 _ = ()
  val op BIT_SLICE_THM2 = TDB.find "BIT_SLICE_THM2"
  fun op BIT_SLICE_THM3 _ = ()
  val op BIT_SLICE_THM3 = TDB.find "BIT_SLICE_THM3"
  fun op BIT_SLICE_THM4 _ = ()
  val op BIT_SLICE_THM4 = TDB.find "BIT_SLICE_THM4"
  fun op SBIT_DIV _ = () val op SBIT_DIV = TDB.find "SBIT_DIV"
  fun op BITS_SUC _ = () val op BITS_SUC = TDB.find "BITS_SUC"
  fun op BITS_SUC_THM _ = () val op BITS_SUC_THM = TDB.find "BITS_SUC_THM"
  fun op BIT_BITS_THM _ = () val op BIT_BITS_THM = TDB.find "BIT_BITS_THM"
  fun op BITS_ZERO5 _ = () val op BITS_ZERO5 = TDB.find "BITS_ZERO5"
  fun op BIT0_ODD _ = () val op BIT0_ODD = TDB.find "BIT0_ODD"
  fun op BITV_THM _ = () val op BITV_THM = TDB.find "BITV_THM"
  fun op ADD_BIT0 _ = () val op ADD_BIT0 = TDB.find "ADD_BIT0"
  fun op ADD_BITS_SUC _ = () val op ADD_BITS_SUC = TDB.find "ADD_BITS_SUC"
  fun op ADD_BIT_SUC _ = () val op ADD_BIT_SUC = TDB.find "ADD_BIT_SUC"
  fun op BITWISE_LT_2EXP _ = ()
  val op BITWISE_LT_2EXP = TDB.find "BITWISE_LT_2EXP"
  fun op BITWISE_THM _ = () val op BITWISE_THM = TDB.find "BITWISE_THM"
  fun op BITWISE_COR _ = () val op BITWISE_COR = TDB.find "BITWISE_COR"
  fun op BITWISE_NOT_COR _ = ()
  val op BITWISE_NOT_COR = TDB.find "BITWISE_NOT_COR"
  fun op BITWISE_BITS _ = () val op BITWISE_BITS = TDB.find "BITWISE_BITS"
  fun op NOT_BIT_GT_TWOEXP _ = ()
  val op NOT_BIT_GT_TWOEXP = TDB.find "NOT_BIT_GT_TWOEXP"
  fun op BIT_IMP_GE_TWOEXP _ = ()
  val op BIT_IMP_GE_TWOEXP = TDB.find "BIT_IMP_GE_TWOEXP"
  fun op BITWISE_ONE_COMP_LEM _ = ()
  val op BITWISE_ONE_COMP_LEM = TDB.find "BITWISE_ONE_COMP_LEM"
  fun op BIT_COMPLEMENT _ = ()
  val op BIT_COMPLEMENT = TDB.find "BIT_COMPLEMENT"
  fun op BIT_OF_BITS_THM _ = ()
  val op BIT_OF_BITS_THM = TDB.find "BIT_OF_BITS_THM"
  fun op BIT_SHIFT_THM _ = ()
  val op BIT_SHIFT_THM = TDB.find "BIT_SHIFT_THM"
  fun op BIT_SHIFT_THM2 _ = ()
  val op BIT_SHIFT_THM2 = TDB.find "BIT_SHIFT_THM2"
  fun op BIT_SHIFT_THM3 _ = ()
  val op BIT_SHIFT_THM3 = TDB.find "BIT_SHIFT_THM3"
  fun op BIT_OF_BITS_THM2 _ = ()
  val op BIT_OF_BITS_THM2 = TDB.find "BIT_OF_BITS_THM2"
  fun op BIT_DIV2 _ = () val op BIT_DIV2 = TDB.find "BIT_DIV2"
  fun op BIT_SHIFT_THM4 _ = ()
  val op BIT_SHIFT_THM4 = TDB.find "BIT_SHIFT_THM4"
  fun op DIV_LT _ = () val op DIV_LT = TDB.find "DIV_LT"
  fun op MOD_ZERO_GT _ = () val op MOD_ZERO_GT = TDB.find "MOD_ZERO_GT"
  fun op DIV_GT0 _ = () val op DIV_GT0 = TDB.find "DIV_GT0"
  fun op DIV_SUB1 _ = () val op DIV_SUB1 = TDB.find "DIV_SUB1"
  fun op BIT_EXP_SUB1 _ = () val op BIT_EXP_SUB1 = TDB.find "BIT_EXP_SUB1"
  fun op BIT_SHIFT_THM5 _ = ()
  val op BIT_SHIFT_THM5 = TDB.find "BIT_SHIFT_THM5"
  fun op SBIT_MULT _ = () val op SBIT_MULT = TDB.find "SBIT_MULT"
  fun op BITWISE_EVAL _ = () val op BITWISE_EVAL = TDB.find "BITWISE_EVAL"
  fun op MOD_PLUS_RIGHT _ = ()
  val op MOD_PLUS_RIGHT = TDB.find "MOD_PLUS_RIGHT"
  fun op MOD_PLUS_LEFT _ = ()
  val op MOD_PLUS_LEFT = TDB.find "MOD_PLUS_LEFT"
  fun op MOD_PLUS_1 _ = () val op MOD_PLUS_1 = TDB.find "MOD_PLUS_1"
  fun op MOD_ADD_1 _ = () val op MOD_ADD_1 = TDB.find "MOD_ADD_1"
  fun op BIT_REVERSE_THM _ = ()
  val op BIT_REVERSE_THM = TDB.find "BIT_REVERSE_THM"
  fun op LOG2_LE_MONO _ = () val op LOG2_LE_MONO = TDB.find "LOG2_LE_MONO"
  fun op TWOEXP_LE_IMP_LE_LOG2 _ = ()
  val op TWOEXP_LE_IMP_LE_LOG2 = TDB.find "TWOEXP_LE_IMP_LE_LOG2"
  fun op NOT_BIT_GT_LOG2 _ = ()
  val op NOT_BIT_GT_LOG2 = TDB.find "NOT_BIT_GT_LOG2"
  fun op NOT_BIT_GT_BITWISE _ = ()
  val op NOT_BIT_GT_BITWISE = TDB.find "NOT_BIT_GT_BITWISE"
  fun op LT_TWOEXP _ = () val op LT_TWOEXP = TDB.find "LT_TWOEXP"
  fun op BIT_MODIFY_THM _ = ()
  val op BIT_MODIFY_THM = TDB.find "BIT_MODIFY_THM"
  fun op BIT_SIGN_EXTEND _ = ()
  val op BIT_SIGN_EXTEND = TDB.find "BIT_SIGN_EXTEND"
  fun op BIT_LOG2 _ = () val op BIT_LOG2 = TDB.find "BIT_LOG2"
  fun op EXISTS_BIT_IN_RANGE _ = ()
  val op EXISTS_BIT_IN_RANGE = TDB.find "EXISTS_BIT_IN_RANGE"
  fun op EXISTS_BIT_LT _ = ()
  val op EXISTS_BIT_LT = TDB.find "EXISTS_BIT_LT"
  fun op LEAST_THM _ = () val op LEAST_THM = TDB.find "LEAST_THM"
  fun op BIT_TIMES2 _ = () val op BIT_TIMES2 = TDB.find "BIT_TIMES2"
  fun op BIT_TIMES2_1 _ = () val op BIT_TIMES2_1 = TDB.find "BIT_TIMES2_1"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val bit_grammars = merge_grammars ["logroot"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="bit"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val bit_grammars = 
    Portable.## (addtyUDs,addtmUDs) bit_grammars
  val _ = Parse.grammarDB_insert("bit",bit_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "bit"

end
