structure dividesTheory :> dividesTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading dividesTheory ... "
    else ()
  
  open Type Term Thm
  local open numeralTheory whileTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "divides"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/extra_theories/dividesTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op divides_def _ = () val op divides_def = TDB.find "divides_def"
  fun op prime_def _ = () val op prime_def = TDB.find "prime_def"
  fun op PRIMES_def _ = () val op PRIMES_def = TDB.find "PRIMES_def"
  fun op ALL_DIVIDES_0 _ = ()
  val op ALL_DIVIDES_0 = TDB.find "ALL_DIVIDES_0"
  fun op ZERO_DIVIDES _ = () val op ZERO_DIVIDES = TDB.find "ZERO_DIVIDES"
  fun op DIVIDES_REFL _ = () val op DIVIDES_REFL = TDB.find "DIVIDES_REFL"
  fun op DIVIDES_TRANS _ = ()
  val op DIVIDES_TRANS = TDB.find "DIVIDES_TRANS"
  fun op ONE_DIVIDES_ALL _ = ()
  val op ONE_DIVIDES_ALL = TDB.find "ONE_DIVIDES_ALL"
  fun op DIVIDES_ONE _ = () val op DIVIDES_ONE = TDB.find "DIVIDES_ONE"
  fun op DIVIDES_ADD_1 _ = ()
  val op DIVIDES_ADD_1 = TDB.find "DIVIDES_ADD_1"
  fun op DIVIDES_ADD_2 _ = ()
  val op DIVIDES_ADD_2 = TDB.find "DIVIDES_ADD_2"
  fun op DIVIDES_SUB _ = () val op DIVIDES_SUB = TDB.find "DIVIDES_SUB"
  fun op DIVIDES_LE _ = () val op DIVIDES_LE = TDB.find "DIVIDES_LE"
  fun op DIVIDES_LEQ_OR_ZERO _ = ()
  val op DIVIDES_LEQ_OR_ZERO = TDB.find "DIVIDES_LEQ_OR_ZERO"
  fun op NOT_LT_DIVIDES _ = ()
  val op NOT_LT_DIVIDES = TDB.find "NOT_LT_DIVIDES"
  fun op DIVIDES_ANTISYM _ = ()
  val op DIVIDES_ANTISYM = TDB.find "DIVIDES_ANTISYM"
  fun op DIVIDES_MULT _ = () val op DIVIDES_MULT = TDB.find "DIVIDES_MULT"
  fun op DIVIDES_MULT_LEFT _ = ()
  val op DIVIDES_MULT_LEFT = TDB.find "DIVIDES_MULT_LEFT"
  fun op DIVIDES_FACT _ = () val op DIVIDES_FACT = TDB.find "DIVIDES_FACT"
  fun op LEQ_DIVIDES_FACT _ = ()
  val op LEQ_DIVIDES_FACT = TDB.find "LEQ_DIVIDES_FACT"
  fun op NOT_PRIME_0 _ = () val op NOT_PRIME_0 = TDB.find "NOT_PRIME_0"
  fun op NOT_PRIME_1 _ = () val op NOT_PRIME_1 = TDB.find "NOT_PRIME_1"
  fun op PRIME_2 _ = () val op PRIME_2 = TDB.find "PRIME_2"
  fun op PRIME_3 _ = () val op PRIME_3 = TDB.find "PRIME_3"
  fun op PRIME_POS _ = () val op PRIME_POS = TDB.find "PRIME_POS"
  fun op ONE_LT_PRIME _ = () val op ONE_LT_PRIME = TDB.find "ONE_LT_PRIME"
  fun op prime_divides_only_self _ = ()
  val op prime_divides_only_self = TDB.find "prime_divides_only_self"
  fun op PRIME_FACTOR _ = () val op PRIME_FACTOR = TDB.find "PRIME_FACTOR"
  fun op EUCLID _ = () val op EUCLID = TDB.find "EUCLID"
  fun op primePRIMES _ = () val op primePRIMES = TDB.find "primePRIMES"
  fun op INFINITE_PRIMES _ = ()
  val op INFINITE_PRIMES = TDB.find "INFINITE_PRIMES"
  fun op LT_PRIMES _ = () val op LT_PRIMES = TDB.find "LT_PRIMES"
  fun op PRIMES_11 _ = () val op PRIMES_11 = TDB.find "PRIMES_11"
  fun op INDEX_LESS_PRIMES _ = ()
  val op INDEX_LESS_PRIMES = TDB.find "INDEX_LESS_PRIMES"
  fun op EUCLID_PRIMES _ = ()
  val op EUCLID_PRIMES = TDB.find "EUCLID_PRIMES"
  fun op NEXT_LARGER_PRIME _ = ()
  val op NEXT_LARGER_PRIME = TDB.find "NEXT_LARGER_PRIME"
  fun op PRIMES_NO_GAP _ = ()
  val op PRIMES_NO_GAP = TDB.find "PRIMES_NO_GAP"
  fun op PRIMES_ONTO _ = () val op PRIMES_ONTO = TDB.find "PRIMES_ONTO"
  fun op PRIME_INDEX _ = () val op PRIME_INDEX = TDB.find "PRIME_INDEX"
  fun op ONE_LT_PRIMES _ = ()
  val op ONE_LT_PRIMES = TDB.find "ONE_LT_PRIMES"
  fun op ZERO_LT_PRIMES _ = ()
  val op ZERO_LT_PRIMES = TDB.find "ZERO_LT_PRIMES"
  fun op compute_divides _ = ()
  val op compute_divides = TDB.find "compute_divides"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val divides_grammars = merge_grammars ["while", "numeral"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="divides"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val divides_grammars = 
    Portable.## (addtyUDs,addtmUDs) divides_grammars
  val _ = Parse.grammarDB_insert("divides",divides_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "divides"

end
