structure gcdTheory :> gcdTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading gcdTheory ... "
    else ()
  
  open Type Term Thm
  local open basicSizeTheory dividesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "gcd"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/extra_theories/gcdTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op is_gcd_def _ = () val op is_gcd_def = TDB.find "is_gcd_def"
  fun op lcm_def _ = () val op lcm_def = TDB.find "lcm_def"
  fun op IS_GCD_UNIQUE _ = ()
  val op IS_GCD_UNIQUE = TDB.find "IS_GCD_UNIQUE"
  fun op IS_GCD_REF _ = () val op IS_GCD_REF = TDB.find "IS_GCD_REF"
  fun op IS_GCD_SYM _ = () val op IS_GCD_SYM = TDB.find "IS_GCD_SYM"
  fun op IS_GCD_0R _ = () val op IS_GCD_0R = TDB.find "IS_GCD_0R"
  fun op IS_GCD_0L _ = () val op IS_GCD_0L = TDB.find "IS_GCD_0L"
  fun op PRIME_IS_GCD _ = () val op PRIME_IS_GCD = TDB.find "PRIME_IS_GCD"
  fun op IS_GCD_MINUS_L _ = ()
  val op IS_GCD_MINUS_L = TDB.find "IS_GCD_MINUS_L"
  fun op IS_GCD_MINUS_R _ = ()
  val op IS_GCD_MINUS_R = TDB.find "IS_GCD_MINUS_R"
  fun op gcd_ind _ = () val op gcd_ind = TDB.find "gcd_ind"
  fun op gcd_def _ = () val op gcd_def = TDB.find "gcd_def"
  fun op gcd_compute _ = () val op gcd_compute = TDB.find "gcd_compute"
  fun op GCD_IS_GCD _ = () val op GCD_IS_GCD = TDB.find "GCD_IS_GCD"
  fun op GCD_IS_GREATEST_COMMON_DIVISOR _ = ()
  val op GCD_IS_GREATEST_COMMON_DIVISOR = TDB.find
    "GCD_IS_GREATEST_COMMON_DIVISOR"
  fun op GCD_REF _ = () val op GCD_REF = TDB.find "GCD_REF"
  fun op GCD_SYM _ = () val op GCD_SYM = TDB.find "GCD_SYM"
  fun op GCD_0R _ = () val op GCD_0R = TDB.find "GCD_0R"
  fun op GCD_0L _ = () val op GCD_0L = TDB.find "GCD_0L"
  fun op GCD_ADD_R _ = () val op GCD_ADD_R = TDB.find "GCD_ADD_R"
  fun op GCD_ADD_R_THM _ = ()
  val op GCD_ADD_R_THM = TDB.find "GCD_ADD_R_THM"
  fun op GCD_ADD_L _ = () val op GCD_ADD_L = TDB.find "GCD_ADD_L"
  fun op GCD_ADD_L_THM _ = ()
  val op GCD_ADD_L_THM = TDB.find "GCD_ADD_L_THM"
  fun op GCD_EQ_0 _ = () val op GCD_EQ_0 = TDB.find "GCD_EQ_0"
  fun op GCD_1 _ = () val op GCD_1 = TDB.find "GCD_1"
  fun op PRIME_GCD _ = () val op PRIME_GCD = TDB.find "PRIME_GCD"
  fun op L_EUCLIDES _ = () val op L_EUCLIDES = TDB.find "L_EUCLIDES"
  fun op P_EUCLIDES _ = () val op P_EUCLIDES = TDB.find "P_EUCLIDES"
  fun op FACTOR_OUT_GCD _ = ()
  val op FACTOR_OUT_GCD = TDB.find "FACTOR_OUT_GCD"
  fun op GCD_SUCfree_ind _ = ()
  val op GCD_SUCfree_ind = TDB.find "GCD_SUCfree_ind"
  fun op LINEAR_GCD _ = () val op LINEAR_GCD = TDB.find "LINEAR_GCD"
  fun op GCD_EFFICIENTLY _ = ()
  val op GCD_EFFICIENTLY = TDB.find "GCD_EFFICIENTLY"
  fun op LCM_IS_LEAST_COMMON_MULTIPLE _ = ()
  val op LCM_IS_LEAST_COMMON_MULTIPLE = TDB.find
    "LCM_IS_LEAST_COMMON_MULTIPLE"
  fun op LCM_0 _ = () val op LCM_0 = TDB.find "LCM_0"
  fun op LCM_1 _ = () val op LCM_1 = TDB.find "LCM_1"
  fun op LCM_COMM _ = () val op LCM_COMM = TDB.find "LCM_COMM"
  fun op LCM_LE _ = () val op LCM_LE = TDB.find "LCM_LE"
  fun op LCM_LEAST _ = () val op LCM_LEAST = TDB.find "LCM_LEAST"
  fun op GCD_COMMON_FACTOR _ = ()
  val op GCD_COMMON_FACTOR = TDB.find "GCD_COMMON_FACTOR"
  fun op GCD_CANCEL_MULT _ = ()
  val op GCD_CANCEL_MULT = TDB.find "GCD_CANCEL_MULT"
  fun op BINARY_GCD _ = () val op BINARY_GCD = TDB.find "BINARY_GCD"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val gcd_grammars = merge_grammars ["divides", "basicSize"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="gcd"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val gcd_grammars = 
    Portable.## (addtyUDs,addtmUDs) gcd_grammars
  val _ = Parse.grammarDB_insert("gcd",gcd_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "gcd"

end
