structure logrootTheory :> logrootTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading logrootTheory ... "
    else ()
  
  open Type Term Thm
  local open basicSizeTheory whileTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "logroot"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/extra_theories/logrootTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ROOT _ = () val op ROOT = TDB.find "ROOT"
  fun op LOG _ = () val op LOG = TDB.find "LOG"
  fun op SQRTd_def _ = () val op SQRTd_def = TDB.find "SQRTd_def"
  fun op iSQRT0_def _ = () val op iSQRT0_def = TDB.find "iSQRT0_def"
  fun op iSQRT1_def _ = () val op iSQRT1_def = TDB.find "iSQRT1_def"
  fun op iSQRT2_def _ = () val op iSQRT2_def = TDB.find "iSQRT2_def"
  fun op iSQRT3_def _ = () val op iSQRT3_def = TDB.find "iSQRT3_def"
  fun op LT_EXP_ISO _ = () val op LT_EXP_ISO = TDB.find "LT_EXP_ISO"
  fun op LE_EXP_ISO _ = () val op LE_EXP_ISO = TDB.find "LE_EXP_ISO"
  fun op EXP_LT_ISO _ = () val op EXP_LT_ISO = TDB.find "EXP_LT_ISO"
  fun op EXP_LE_ISO _ = () val op EXP_LE_ISO = TDB.find "EXP_LE_ISO"
  fun op ROOT_exists _ = () val op ROOT_exists = TDB.find "ROOT_exists"
  fun op ROOT_UNIQUE _ = () val op ROOT_UNIQUE = TDB.find "ROOT_UNIQUE"
  fun op LOG_exists _ = () val op LOG_exists = TDB.find "LOG_exists"
  fun op LOG_UNIQUE _ = () val op LOG_UNIQUE = TDB.find "LOG_UNIQUE"
  fun op LOG_ADD1 _ = () val op LOG_ADD1 = TDB.find "LOG_ADD1"
  fun op LOG_BASE _ = () val op LOG_BASE = TDB.find "LOG_BASE"
  fun op LOG_EXP _ = () val op LOG_EXP = TDB.find "LOG_EXP"
  fun op LOG_1 _ = () val op LOG_1 = TDB.find "LOG_1"
  fun op LOG_DIV _ = () val op LOG_DIV = TDB.find "LOG_DIV"
  fun op LOG_ADD _ = () val op LOG_ADD = TDB.find "LOG_ADD"
  fun op LOG_LE_MONO _ = () val op LOG_LE_MONO = TDB.find "LOG_LE_MONO"
  fun op LOG_RWT _ = () val op LOG_RWT = TDB.find "LOG_RWT"
  fun op LOG_EQ_0 _ = () val op LOG_EQ_0 = TDB.find "LOG_EQ_0"
  fun op LOG_MULT _ = () val op LOG_MULT = TDB.find "LOG_MULT"
  fun op LOG_add_digit _ = ()
  val op LOG_add_digit = TDB.find "LOG_add_digit"
  fun op ROOT_DIV _ = () val op ROOT_DIV = TDB.find "ROOT_DIV"
  fun op ROOT_LE_MONO _ = () val op ROOT_LE_MONO = TDB.find "ROOT_LE_MONO"
  fun op EXP_MUL _ = () val op EXP_MUL = TDB.find "EXP_MUL"
  fun op LOG_ROOT _ = () val op LOG_ROOT = TDB.find "LOG_ROOT"
  fun op LOG_MOD _ = () val op LOG_MOD = TDB.find "LOG_MOD"
  fun op ROOT_COMPUTE _ = () val op ROOT_COMPUTE = TDB.find "ROOT_COMPUTE"
  fun op numeral_sqrt _ = () val op numeral_sqrt = TDB.find "numeral_sqrt"
  fun op numeral_root2 _ = ()
  val op numeral_root2 = TDB.find "numeral_root2"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val logroot_grammars = merge_grammars ["basicSize", "while"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="logroot"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val logroot_grammars = 
    Portable.## (addtyUDs,addtmUDs) logroot_grammars
  val _ = Parse.grammarDB_insert("logroot",logroot_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "logroot"

end
