structure numeral_bitTheory :> numeral_bitTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading numeral_bitTheory ... "
    else ()
  
  open Type Term Thm
  local open bitTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "numeral_bit"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/extra_theories/numeral_bitTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op iMOD_2EXP _ = () val op iMOD_2EXP = TDB.find "iMOD_2EXP"
  fun op BIT_REV_def _ = () val op BIT_REV_def = TDB.find "BIT_REV_def"
  fun op BIT_MODF_def _ = () val op BIT_MODF_def = TDB.find "BIT_MODF_def"
  fun op iBITWISE_def _ = () val op iBITWISE_def = TDB.find "iBITWISE_def"
  fun op iSUC _ = () val op iSUC = TDB.find "iSUC"
  fun op iDIV2 _ = () val op iDIV2 = TDB.find "iDIV2"
  fun op SFUNPOW_def _ = () val op SFUNPOW_def = TDB.find "SFUNPOW_def"
  fun op FDUB_def _ = () val op FDUB_def = TDB.find "FDUB_def"
  fun op iLOG2_def _ = () val op iLOG2_def = TDB.find "iLOG2_def"
  fun op numeral_imod_2exp _ = ()
  val op numeral_imod_2exp = TDB.find "numeral_imod_2exp"
  fun op MOD_2EXP _ = () val op MOD_2EXP = TDB.find "MOD_2EXP"
  fun op DIV_2EXP _ = () val op DIV_2EXP = TDB.find "DIV_2EXP"
  fun op numeral_mod2 _ = () val op numeral_mod2 = TDB.find "numeral_mod2"
  fun op iDUB_NUMERAL _ = () val op iDUB_NUMERAL = TDB.find "iDUB_NUMERAL"
  fun op BIT_REVERSE_EVAL _ = ()
  val op BIT_REVERSE_EVAL = TDB.find "BIT_REVERSE_EVAL"
  fun op BIT_MODIFY_EVAL _ = ()
  val op BIT_MODIFY_EVAL = TDB.find "BIT_MODIFY_EVAL"
  fun op iBITWISE _ = () val op iBITWISE = TDB.find "iBITWISE"
  fun op NUMERAL_BITWISE _ = ()
  val op NUMERAL_BITWISE = TDB.find "NUMERAL_BITWISE"
  fun op NUMERAL_BIT_REV _ = ()
  val op NUMERAL_BIT_REV = TDB.find "NUMERAL_BIT_REV"
  fun op NUMERAL_BIT_REVERSE _ = ()
  val op NUMERAL_BIT_REVERSE = TDB.find "NUMERAL_BIT_REVERSE"
  fun op NUMERAL_BIT_MODF _ = ()
  val op NUMERAL_BIT_MODF = TDB.find "NUMERAL_BIT_MODF"
  fun op NUMERAL_BIT_MODIFY _ = ()
  val op NUMERAL_BIT_MODIFY = TDB.find "NUMERAL_BIT_MODIFY"
  fun op NUMERAL_TIMES_2EXP _ = ()
  val op NUMERAL_TIMES_2EXP = TDB.find "NUMERAL_TIMES_2EXP"
  fun op NUMERAL_iDIV2 _ = ()
  val op NUMERAL_iDIV2 = TDB.find "NUMERAL_iDIV2"
  fun op NUMERAL_DIV_2EXP _ = ()
  val op NUMERAL_DIV_2EXP = TDB.find "NUMERAL_DIV_2EXP"
  fun op NUMERAL_SFUNPOW_iDIV2 _ = ()
  val op NUMERAL_SFUNPOW_iDIV2 = TDB.find "NUMERAL_SFUNPOW_iDIV2"
  fun op NUMERAL_SFUNPOW_iDUB _ = ()
  val op NUMERAL_SFUNPOW_iDUB = TDB.find "NUMERAL_SFUNPOW_iDUB"
  fun op NUMERAL_SFUNPOW_FDUB _ = ()
  val op NUMERAL_SFUNPOW_FDUB = TDB.find "NUMERAL_SFUNPOW_FDUB"
  fun op FDUB_iDIV2 _ = () val op FDUB_iDIV2 = TDB.find "FDUB_iDIV2"
  fun op FDUB_iDUB _ = () val op FDUB_iDUB = TDB.find "FDUB_iDUB"
  fun op FDUB_FDUB _ = () val op FDUB_FDUB = TDB.find "FDUB_FDUB"
  fun op LOG_compute _ = () val op LOG_compute = TDB.find "LOG_compute"
  fun op numeral_ilog2 _ = ()
  val op numeral_ilog2 = TDB.find "numeral_ilog2"
  fun op numeral_log2 _ = () val op numeral_log2 = TDB.find "numeral_log2"
  fun op MOD_2EXP_EQ _ = () val op MOD_2EXP_EQ = TDB.find "MOD_2EXP_EQ"
  fun op MOD_2EXP_MAX _ = () val op MOD_2EXP_MAX = TDB.find "MOD_2EXP_MAX"
  fun op LOWEST_SET_BIT _ = ()
  val op LOWEST_SET_BIT = TDB.find "LOWEST_SET_BIT"
  fun op LOWEST_SET_BIT_compute _ = ()
  val op LOWEST_SET_BIT_compute = TDB.find "LOWEST_SET_BIT_compute"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val numeral_bit_grammars = merge_grammars ["bit"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="numeral_bit"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val numeral_bit_grammars = 
    Portable.## (addtyUDs,addtmUDs) numeral_bit_grammars
  val _ = Parse.grammarDB_insert("numeral_bit",numeral_bit_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "numeral_bit"

end
