structure numpairTheory :> numpairTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading numpairTheory ... "
    else ()
  
  open Type Term Thm
  local open basicSizeTheory whileTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "numpair"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/extra_theories/numpairTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op tri_def _ = () val op tri_def = TDB.find "tri_def"
  fun op invtri_def _ = () val op invtri_def = TDB.find "invtri_def"
  fun op npair_def _ = () val op npair_def = TDB.find "npair_def"
  fun op nfst_def _ = () val op nfst_def = TDB.find "nfst_def"
  fun op nsnd_def _ = () val op nsnd_def = TDB.find "nsnd_def"
  fun op twotri_formula _ = ()
  val op twotri_formula = TDB.find "twotri_formula"
  fun op tri_formula _ = () val op tri_formula = TDB.find "tri_formula"
  fun op tri_eq_0 _ = () val op tri_eq_0 = TDB.find "tri_eq_0"
  fun op tri_LT_I _ = () val op tri_LT_I = TDB.find "tri_LT_I"
  fun op tri_LT _ = () val op tri_LT = TDB.find "tri_LT"
  fun op tri_11 _ = () val op tri_11 = TDB.find "tri_11"
  fun op tri_LE _ = () val op tri_LE = TDB.find "tri_LE"
  fun op invtri0_ind _ = () val op invtri0_ind = TDB.find "invtri0_ind"
  fun op invtri0_def _ = () val op invtri0_def = TDB.find "invtri0_def"
  fun op invtri0_thm _ = () val op invtri0_thm = TDB.find "invtri0_thm"
  fun op SND_invtri0 _ = () val op SND_invtri0 = TDB.find "SND_invtri0"
  fun op invtri_lower _ = () val op invtri_lower = TDB.find "invtri_lower"
  fun op invtri_upper _ = () val op invtri_upper = TDB.find "invtri_upper"
  fun op invtri_linverse _ = ()
  val op invtri_linverse = TDB.find "invtri_linverse"
  fun op invtri_unique _ = ()
  val op invtri_unique = TDB.find "invtri_unique"
  fun op invtri_linverse_r _ = ()
  val op invtri_linverse_r = TDB.find "invtri_linverse_r"
  fun op tri_le _ = () val op tri_le = TDB.find "tri_le"
  fun op invtri_le _ = () val op invtri_le = TDB.find "invtri_le"
  fun op nfst_npair _ = () val op nfst_npair = TDB.find "nfst_npair"
  fun op nsnd_npair _ = () val op nsnd_npair = TDB.find "nsnd_npair"
  fun op npair_cases _ = () val op npair_cases = TDB.find "npair_cases"
  fun op npair _ = () val op npair = TDB.find "npair"
  fun op npair_11 _ = () val op npair_11 = TDB.find "npair_11"
  fun op nfst_le _ = () val op nfst_le = TDB.find "nfst_le"
  fun op nsnd_le _ = () val op nsnd_le = TDB.find "nsnd_le"
  fun op npair00 _ = () val op npair00 = TDB.find "npair00"
  fun op npair_EQ_0 _ = () val op npair_EQ_0 = TDB.find "npair_EQ_0"
  fun op nfst0 _ = () val op nfst0 = TDB.find "nfst0"
  fun op nsnd0 _ = () val op nsnd0 = TDB.find "nsnd0"
  fun op nfst_le_npair _ = ()
  val op nfst_le_npair = TDB.find "nfst_le_npair"
  fun op nsnd_le_npair _ = ()
  val op nsnd_le_npair = TDB.find "nsnd_le_npair"
  fun op npair2_lt_E _ = () val op npair2_lt_E = TDB.find "npair2_lt_E"
  fun op npair2_lt_I _ = () val op npair2_lt_I = TDB.find "npair2_lt_I"
  fun op npair2_lt _ = () val op npair2_lt = TDB.find "npair2_lt"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val numpair_grammars = merge_grammars ["basicSize", "while"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="numpair"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val numpair_grammars = 
    Portable.## (addtyUDs,addtmUDs) numpair_grammars
  val _ = Parse.grammarDB_insert("numpair",numpair_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "numpair"

end
