structure arithmeticTheory :> arithmeticTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading arithmeticTheory ... "
    else ()
  
  open Type Term Thm
  local open pairTheory prim_recTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "arithmetic"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/theories/arithmeticTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ADD _ = () val op ADD = TDB.find "ADD"
  fun op NUMERAL_DEF _ = () val op NUMERAL_DEF = TDB.find "NUMERAL_DEF"
  fun op ALT_ZERO _ = () val op ALT_ZERO = TDB.find "ALT_ZERO"
  fun op BIT1 _ = () val op BIT1 = TDB.find "BIT1"
  fun op BIT2 _ = () val op BIT2 = TDB.find "BIT2"
  fun op nat_elim__magic _ = ()
  val op nat_elim__magic = TDB.find "nat_elim__magic"
  fun op SUB _ = () val op SUB = TDB.find "SUB"
  fun op MULT _ = () val op MULT = TDB.find "MULT"
  fun op EXP _ = () val op EXP = TDB.find "EXP"
  fun op GREATER_DEF _ = () val op GREATER_DEF = TDB.find "GREATER_DEF"
  fun op LESS_OR_EQ _ = () val op LESS_OR_EQ = TDB.find "LESS_OR_EQ"
  fun op GREATER_OR_EQ _ = ()
  val op GREATER_OR_EQ = TDB.find "GREATER_OR_EQ"
  fun op EVEN _ = () val op EVEN = TDB.find "EVEN"
  fun op ODD _ = () val op ODD = TDB.find "ODD"
  fun op num_case_def _ = () val op num_case_def = TDB.find "num_case_def"
  fun op FUNPOW _ = () val op FUNPOW = TDB.find "FUNPOW"
  fun op NRC _ = () val op NRC = TDB.find "NRC"
  fun op FACT _ = () val op FACT = TDB.find "FACT"
  fun op DIVISION _ = () val op DIVISION = TDB.find "DIVISION"
  fun op DIV2_def _ = () val op DIV2_def = TDB.find "DIV2_def"
  fun op MAX_DEF _ = () val op MAX_DEF = TDB.find "MAX_DEF"
  fun op MIN_DEF _ = () val op MIN_DEF = TDB.find "MIN_DEF"
  fun op ABS_DIFF_def _ = () val op ABS_DIFF_def = TDB.find "ABS_DIFF_def"
  fun op findq_def _ = () val op findq_def = TDB.find "findq_def"
  fun op DIVMOD_DEF _ = () val op DIVMOD_DEF = TDB.find "DIVMOD_DEF"
  fun op MODEQ_DEF _ = () val op MODEQ_DEF = TDB.find "MODEQ_DEF"
  fun op ONE _ = () val op ONE = TDB.find "ONE"
  fun op TWO _ = () val op TWO = TDB.find "TWO"
  fun op NORM_0 _ = () val op NORM_0 = TDB.find "NORM_0"
  fun op num_case_compute _ = ()
  val op num_case_compute = TDB.find "num_case_compute"
  fun op SUC_NOT _ = () val op SUC_NOT = TDB.find "SUC_NOT"
  fun op ADD_0 _ = () val op ADD_0 = TDB.find "ADD_0"
  fun op ADD_SUC _ = () val op ADD_SUC = TDB.find "ADD_SUC"
  fun op ADD_CLAUSES _ = () val op ADD_CLAUSES = TDB.find "ADD_CLAUSES"
  fun op ADD_SYM _ = () val op ADD_SYM = TDB.find "ADD_SYM"
  fun op ADD_COMM _ = () val op ADD_COMM = TDB.find "ADD_COMM"
  fun op ADD_ASSOC _ = () val op ADD_ASSOC = TDB.find "ADD_ASSOC"
  fun op num_CASES _ = () val op num_CASES = TDB.find "num_CASES"
  fun op NOT_ZERO_LT_ZERO _ = ()
  val op NOT_ZERO_LT_ZERO = TDB.find "NOT_ZERO_LT_ZERO"
  fun op NOT_LT_ZERO_EQ_ZERO _ = ()
  val op NOT_LT_ZERO_EQ_ZERO = TDB.find "NOT_LT_ZERO_EQ_ZERO"
  fun op LESS_OR_EQ_ALT _ = ()
  val op LESS_OR_EQ_ALT = TDB.find "LESS_OR_EQ_ALT"
  fun op LESS_ADD _ = () val op LESS_ADD = TDB.find "LESS_ADD"
  fun op transitive_LESS _ = ()
  val op transitive_LESS = TDB.find "transitive_LESS"
  fun op LESS_TRANS _ = () val op LESS_TRANS = TDB.find "LESS_TRANS"
  fun op LESS_ANTISYM _ = () val op LESS_ANTISYM = TDB.find "LESS_ANTISYM"
  fun op LESS_MONO_REV _ = ()
  val op LESS_MONO_REV = TDB.find "LESS_MONO_REV"
  fun op LESS_MONO_EQ _ = () val op LESS_MONO_EQ = TDB.find "LESS_MONO_EQ"
  fun op LESS_EQ_MONO _ = () val op LESS_EQ_MONO = TDB.find "LESS_EQ_MONO"
  fun op LESS_LESS_SUC _ = ()
  val op LESS_LESS_SUC = TDB.find "LESS_LESS_SUC"
  fun op transitive_measure _ = ()
  val op transitive_measure = TDB.find "transitive_measure"
  fun op LESS_EQ _ = () val op LESS_EQ = TDB.find "LESS_EQ"
  fun op LESS_OR _ = () val op LESS_OR = TDB.find "LESS_OR"
  fun op OR_LESS _ = () val op OR_LESS = TDB.find "OR_LESS"
  fun op LESS_EQ_IFF_LESS_SUC _ = ()
  val op LESS_EQ_IFF_LESS_SUC = TDB.find "LESS_EQ_IFF_LESS_SUC"
  fun op LESS_EQ_IMP_LESS_SUC _ = ()
  val op LESS_EQ_IMP_LESS_SUC = TDB.find "LESS_EQ_IMP_LESS_SUC"
  fun op ZERO_LESS_EQ _ = () val op ZERO_LESS_EQ = TDB.find "ZERO_LESS_EQ"
  fun op LESS_SUC_EQ_COR _ = ()
  val op LESS_SUC_EQ_COR = TDB.find "LESS_SUC_EQ_COR"
  fun op LESS_NOT_SUC _ = () val op LESS_NOT_SUC = TDB.find "LESS_NOT_SUC"
  fun op LESS_0_CASES _ = () val op LESS_0_CASES = TDB.find "LESS_0_CASES"
  fun op LESS_CASES_IMP _ = ()
  val op LESS_CASES_IMP = TDB.find "LESS_CASES_IMP"
  fun op LESS_CASES _ = () val op LESS_CASES = TDB.find "LESS_CASES"
  fun op ADD_INV_0 _ = () val op ADD_INV_0 = TDB.find "ADD_INV_0"
  fun op LESS_EQ_ADD _ = () val op LESS_EQ_ADD = TDB.find "LESS_EQ_ADD"
  fun op LESS_EQ_ADD_EXISTS _ = ()
  val op LESS_EQ_ADD_EXISTS = TDB.find "LESS_EQ_ADD_EXISTS"
  fun op LESS_STRONG_ADD _ = ()
  val op LESS_STRONG_ADD = TDB.find "LESS_STRONG_ADD"
  fun op LESS_EQ_SUC_REFL _ = ()
  val op LESS_EQ_SUC_REFL = TDB.find "LESS_EQ_SUC_REFL"
  fun op LESS_ADD_NONZERO _ = ()
  val op LESS_ADD_NONZERO = TDB.find "LESS_ADD_NONZERO"
  fun op NOT_SUC_LESS_EQ_0 _ = ()
  val op NOT_SUC_LESS_EQ_0 = TDB.find "NOT_SUC_LESS_EQ_0"
  fun op NOT_LESS _ = () val op NOT_LESS = TDB.find "NOT_LESS"
  fun op NOT_LESS_EQUAL _ = ()
  val op NOT_LESS_EQUAL = TDB.find "NOT_LESS_EQUAL"
  fun op LESS_EQ_ANTISYM _ = ()
  val op LESS_EQ_ANTISYM = TDB.find "LESS_EQ_ANTISYM"
  fun op LESS_EQ_0 _ = () val op LESS_EQ_0 = TDB.find "LESS_EQ_0"
  fun op SUB_0 _ = () val op SUB_0 = TDB.find "SUB_0"
  fun op SUB_MONO_EQ _ = () val op SUB_MONO_EQ = TDB.find "SUB_MONO_EQ"
  fun op SUB_EQ_0 _ = () val op SUB_EQ_0 = TDB.find "SUB_EQ_0"
  fun op ADD1 _ = () val op ADD1 = TDB.find "ADD1"
  fun op SUC_SUB1 _ = () val op SUC_SUB1 = TDB.find "SUC_SUB1"
  fun op PRE_SUB1 _ = () val op PRE_SUB1 = TDB.find "PRE_SUB1"
  fun op MULT_0 _ = () val op MULT_0 = TDB.find "MULT_0"
  fun op MULT_SUC _ = () val op MULT_SUC = TDB.find "MULT_SUC"
  fun op MULT_LEFT_1 _ = () val op MULT_LEFT_1 = TDB.find "MULT_LEFT_1"
  fun op MULT_RIGHT_1 _ = () val op MULT_RIGHT_1 = TDB.find "MULT_RIGHT_1"
  fun op MULT_CLAUSES _ = () val op MULT_CLAUSES = TDB.find "MULT_CLAUSES"
  fun op MULT_SYM _ = () val op MULT_SYM = TDB.find "MULT_SYM"
  fun op MULT_COMM _ = () val op MULT_COMM = TDB.find "MULT_COMM"
  fun op RIGHT_ADD_DISTRIB _ = ()
  val op RIGHT_ADD_DISTRIB = TDB.find "RIGHT_ADD_DISTRIB"
  fun op LEFT_ADD_DISTRIB _ = ()
  val op LEFT_ADD_DISTRIB = TDB.find "LEFT_ADD_DISTRIB"
  fun op MULT_ASSOC _ = () val op MULT_ASSOC = TDB.find "MULT_ASSOC"
  fun op SUB_ADD _ = () val op SUB_ADD = TDB.find "SUB_ADD"
  fun op PRE_SUB _ = () val op PRE_SUB = TDB.find "PRE_SUB"
  fun op ADD_EQ_0 _ = () val op ADD_EQ_0 = TDB.find "ADD_EQ_0"
  fun op ADD_EQ_1 _ = () val op ADD_EQ_1 = TDB.find "ADD_EQ_1"
  fun op ADD_INV_0_EQ _ = () val op ADD_INV_0_EQ = TDB.find "ADD_INV_0_EQ"
  fun op PRE_SUC_EQ _ = () val op PRE_SUC_EQ = TDB.find "PRE_SUC_EQ"
  fun op INV_PRE_EQ _ = () val op INV_PRE_EQ = TDB.find "INV_PRE_EQ"
  fun op LESS_SUC_NOT _ = () val op LESS_SUC_NOT = TDB.find "LESS_SUC_NOT"
  fun op ADD_EQ_SUB _ = () val op ADD_EQ_SUB = TDB.find "ADD_EQ_SUB"
  fun op LESS_MONO_ADD _ = ()
  val op LESS_MONO_ADD = TDB.find "LESS_MONO_ADD"
  fun op LESS_MONO_ADD_INV _ = ()
  val op LESS_MONO_ADD_INV = TDB.find "LESS_MONO_ADD_INV"
  fun op LESS_MONO_ADD_EQ _ = ()
  val op LESS_MONO_ADD_EQ = TDB.find "LESS_MONO_ADD_EQ"
  fun op LT_ADD_RCANCEL _ = ()
  val op LT_ADD_RCANCEL = TDB.find "LT_ADD_RCANCEL"
  fun op LT_ADD_LCANCEL _ = ()
  val op LT_ADD_LCANCEL = TDB.find "LT_ADD_LCANCEL"
  fun op EQ_MONO_ADD_EQ _ = ()
  val op EQ_MONO_ADD_EQ = TDB.find "EQ_MONO_ADD_EQ"
  fun op LESS_EQ_MONO_ADD_EQ _ = ()
  val op LESS_EQ_MONO_ADD_EQ = TDB.find "LESS_EQ_MONO_ADD_EQ"
  fun op LESS_EQ_TRANS _ = ()
  val op LESS_EQ_TRANS = TDB.find "LESS_EQ_TRANS"
  fun op LESS_EQ_LESS_TRANS _ = ()
  val op LESS_EQ_LESS_TRANS = TDB.find "LESS_EQ_LESS_TRANS"
  fun op LESS_LESS_EQ_TRANS _ = ()
  val op LESS_LESS_EQ_TRANS = TDB.find "LESS_LESS_EQ_TRANS"
  fun op LESS_EQ_LESS_EQ_MONO _ = ()
  val op LESS_EQ_LESS_EQ_MONO = TDB.find "LESS_EQ_LESS_EQ_MONO"
  fun op LESS_EQ_REFL _ = () val op LESS_EQ_REFL = TDB.find "LESS_EQ_REFL"
  fun op LESS_IMP_LESS_OR_EQ _ = ()
  val op LESS_IMP_LESS_OR_EQ = TDB.find "LESS_IMP_LESS_OR_EQ"
  fun op LESS_MONO_MULT _ = ()
  val op LESS_MONO_MULT = TDB.find "LESS_MONO_MULT"
  fun op LESS_MONO_MULT2 _ = ()
  val op LESS_MONO_MULT2 = TDB.find "LESS_MONO_MULT2"
  fun op RIGHT_SUB_DISTRIB _ = ()
  val op RIGHT_SUB_DISTRIB = TDB.find "RIGHT_SUB_DISTRIB"
  fun op LEFT_SUB_DISTRIB _ = ()
  val op LEFT_SUB_DISTRIB = TDB.find "LEFT_SUB_DISTRIB"
  fun op LESS_ADD_1 _ = () val op LESS_ADD_1 = TDB.find "LESS_ADD_1"
  fun op EXP_ADD _ = () val op EXP_ADD = TDB.find "EXP_ADD"
  fun op NOT_ODD_EQ_EVEN _ = ()
  val op NOT_ODD_EQ_EVEN = TDB.find "NOT_ODD_EQ_EVEN"
  fun op LESS_EQUAL_ANTISYM _ = ()
  val op LESS_EQUAL_ANTISYM = TDB.find "LESS_EQUAL_ANTISYM"
  fun op LESS_ADD_SUC _ = () val op LESS_ADD_SUC = TDB.find "LESS_ADD_SUC"
  fun op LESS_OR_EQ_ADD _ = ()
  val op LESS_OR_EQ_ADD = TDB.find "LESS_OR_EQ_ADD"
  fun op WOP _ = () val op WOP = TDB.find "WOP"
  fun op COMPLETE_INDUCTION _ = ()
  val op COMPLETE_INDUCTION = TDB.find "COMPLETE_INDUCTION"
  fun op FORALL_NUM_THM _ = ()
  val op FORALL_NUM_THM = TDB.find "FORALL_NUM_THM"
  fun op SUC_SUB _ = () val op SUC_SUB = TDB.find "SUC_SUB"
  fun op SUB_PLUS _ = () val op SUB_PLUS = TDB.find "SUB_PLUS"
  fun op INV_PRE_LESS _ = () val op INV_PRE_LESS = TDB.find "INV_PRE_LESS"
  fun op INV_PRE_LESS_EQ _ = ()
  val op INV_PRE_LESS_EQ = TDB.find "INV_PRE_LESS_EQ"
  fun op PRE_LESS_EQ _ = () val op PRE_LESS_EQ = TDB.find "PRE_LESS_EQ"
  fun op SUB_LESS_EQ _ = () val op SUB_LESS_EQ = TDB.find "SUB_LESS_EQ"
  fun op SUB_EQ_EQ_0 _ = () val op SUB_EQ_EQ_0 = TDB.find "SUB_EQ_EQ_0"
  fun op SUB_LESS_0 _ = () val op SUB_LESS_0 = TDB.find "SUB_LESS_0"
  fun op SUB_LESS_OR _ = () val op SUB_LESS_OR = TDB.find "SUB_LESS_OR"
  fun op LESS_SUB_ADD_LESS _ = ()
  val op LESS_SUB_ADD_LESS = TDB.find "LESS_SUB_ADD_LESS"
  fun op TIMES2 _ = () val op TIMES2 = TDB.find "TIMES2"
  fun op LESS_MULT_MONO _ = ()
  val op LESS_MULT_MONO = TDB.find "LESS_MULT_MONO"
  fun op MULT_MONO_EQ _ = () val op MULT_MONO_EQ = TDB.find "MULT_MONO_EQ"
  fun op MULT_SUC_EQ _ = () val op MULT_SUC_EQ = TDB.find "MULT_SUC_EQ"
  fun op MULT_EXP_MONO _ = ()
  val op MULT_EXP_MONO = TDB.find "MULT_EXP_MONO"
  fun op EQ_ADD_LCANCEL _ = ()
  val op EQ_ADD_LCANCEL = TDB.find "EQ_ADD_LCANCEL"
  fun op EQ_ADD_RCANCEL _ = ()
  val op EQ_ADD_RCANCEL = TDB.find "EQ_ADD_RCANCEL"
  fun op EQ_MULT_LCANCEL _ = ()
  val op EQ_MULT_LCANCEL = TDB.find "EQ_MULT_LCANCEL"
  fun op EQ_MULT_RCANCEL _ = ()
  val op EQ_MULT_RCANCEL = TDB.find "EQ_MULT_RCANCEL"
  fun op ADD_SUB _ = () val op ADD_SUB = TDB.find "ADD_SUB"
  fun op LESS_EQ_ADD_SUB _ = ()
  val op LESS_EQ_ADD_SUB = TDB.find "LESS_EQ_ADD_SUB"
  fun op SUB_EQUAL_0 _ = () val op SUB_EQUAL_0 = TDB.find "SUB_EQUAL_0"
  fun op LESS_EQ_SUB_LESS _ = ()
  val op LESS_EQ_SUB_LESS = TDB.find "LESS_EQ_SUB_LESS"
  fun op NOT_SUC_LESS_EQ _ = ()
  val op NOT_SUC_LESS_EQ = TDB.find "NOT_SUC_LESS_EQ"
  fun op SUB_SUB _ = () val op SUB_SUB = TDB.find "SUB_SUB"
  fun op LESS_IMP_LESS_ADD _ = ()
  val op LESS_IMP_LESS_ADD = TDB.find "LESS_IMP_LESS_ADD"
  fun op SUB_LESS_EQ_ADD _ = ()
  val op SUB_LESS_EQ_ADD = TDB.find "SUB_LESS_EQ_ADD"
  fun op SUB_LESS_SUC _ = () val op SUB_LESS_SUC = TDB.find "SUB_LESS_SUC"
  fun op SUB_CANCEL _ = () val op SUB_CANCEL = TDB.find "SUB_CANCEL"
  fun op CANCEL_SUB _ = () val op CANCEL_SUB = TDB.find "CANCEL_SUB"
  fun op NOT_EXP_0 _ = () val op NOT_EXP_0 = TDB.find "NOT_EXP_0"
  fun op ZERO_LESS_EXP _ = ()
  val op ZERO_LESS_EXP = TDB.find "ZERO_LESS_EXP"
  fun op ODD_OR_EVEN _ = () val op ODD_OR_EVEN = TDB.find "ODD_OR_EVEN"
  fun op LESS_EXP_SUC_MONO _ = ()
  val op LESS_EXP_SUC_MONO = TDB.find "LESS_EXP_SUC_MONO"
  fun op LESS_LESS_CASES _ = ()
  val op LESS_LESS_CASES = TDB.find "LESS_LESS_CASES"
  fun op GREATER_EQ _ = () val op GREATER_EQ = TDB.find "GREATER_EQ"
  fun op LESS_EQ_CASES _ = ()
  val op LESS_EQ_CASES = TDB.find "LESS_EQ_CASES"
  fun op LESS_EQUAL_ADD _ = ()
  val op LESS_EQUAL_ADD = TDB.find "LESS_EQUAL_ADD"
  fun op LESS_EQ_EXISTS _ = ()
  val op LESS_EQ_EXISTS = TDB.find "LESS_EQ_EXISTS"
  fun op MULT_EQ_0 _ = () val op MULT_EQ_0 = TDB.find "MULT_EQ_0"
  fun op MULT_EQ_1 _ = () val op MULT_EQ_1 = TDB.find "MULT_EQ_1"
  fun op MULT_EQ_ID _ = () val op MULT_EQ_ID = TDB.find "MULT_EQ_ID"
  fun op LESS_MULT2 _ = () val op LESS_MULT2 = TDB.find "LESS_MULT2"
  fun op ZERO_LESS_MULT _ = ()
  val op ZERO_LESS_MULT = TDB.find "ZERO_LESS_MULT"
  fun op ZERO_LESS_ADD _ = ()
  val op ZERO_LESS_ADD = TDB.find "ZERO_LESS_ADD"
  fun op FACT_LESS _ = () val op FACT_LESS = TDB.find "FACT_LESS"
  fun op EVEN_ODD _ = () val op EVEN_ODD = TDB.find "EVEN_ODD"
  fun op ODD_EVEN _ = () val op ODD_EVEN = TDB.find "ODD_EVEN"
  fun op EVEN_OR_ODD _ = () val op EVEN_OR_ODD = TDB.find "EVEN_OR_ODD"
  fun op EVEN_AND_ODD _ = () val op EVEN_AND_ODD = TDB.find "EVEN_AND_ODD"
  fun op EVEN_ADD _ = () val op EVEN_ADD = TDB.find "EVEN_ADD"
  fun op EVEN_MULT _ = () val op EVEN_MULT = TDB.find "EVEN_MULT"
  fun op ODD_ADD _ = () val op ODD_ADD = TDB.find "ODD_ADD"
  fun op ODD_MULT _ = () val op ODD_MULT = TDB.find "ODD_MULT"
  fun op EVEN_DOUBLE _ = () val op EVEN_DOUBLE = TDB.find "EVEN_DOUBLE"
  fun op ODD_DOUBLE _ = () val op ODD_DOUBLE = TDB.find "ODD_DOUBLE"
  fun op EVEN_ODD_EXISTS _ = ()
  val op EVEN_ODD_EXISTS = TDB.find "EVEN_ODD_EXISTS"
  fun op EVEN_EXISTS _ = () val op EVEN_EXISTS = TDB.find "EVEN_EXISTS"
  fun op ODD_EXISTS _ = () val op ODD_EXISTS = TDB.find "ODD_EXISTS"
  fun op EVEN_EXP_IFF _ = () val op EVEN_EXP_IFF = TDB.find "EVEN_EXP_IFF"
  fun op EVEN_EXP _ = () val op EVEN_EXP = TDB.find "EVEN_EXP"
  fun op ODD_EXP_IFF _ = () val op ODD_EXP_IFF = TDB.find "ODD_EXP_IFF"
  fun op ODD_EXP _ = () val op ODD_EXP = TDB.find "ODD_EXP"
  fun op EQ_LESS_EQ _ = () val op EQ_LESS_EQ = TDB.find "EQ_LESS_EQ"
  fun op ADD_MONO_LESS_EQ _ = ()
  val op ADD_MONO_LESS_EQ = TDB.find "ADD_MONO_LESS_EQ"
  fun op LE_ADD_LCANCEL _ = ()
  val op LE_ADD_LCANCEL = TDB.find "LE_ADD_LCANCEL"
  fun op LE_ADD_RCANCEL _ = ()
  val op LE_ADD_RCANCEL = TDB.find "LE_ADD_RCANCEL"
  fun op NOT_LEQ _ = () val op NOT_LEQ = TDB.find "NOT_LEQ"
  fun op NOT_NUM_EQ _ = () val op NOT_NUM_EQ = TDB.find "NOT_NUM_EQ"
  fun op NOT_GREATER _ = () val op NOT_GREATER = TDB.find "NOT_GREATER"
  fun op NOT_GREATER_EQ _ = ()
  val op NOT_GREATER_EQ = TDB.find "NOT_GREATER_EQ"
  fun op SUC_ONE_ADD _ = () val op SUC_ONE_ADD = TDB.find "SUC_ONE_ADD"
  fun op SUC_ADD_SYM _ = () val op SUC_ADD_SYM = TDB.find "SUC_ADD_SYM"
  fun op NOT_SUC_ADD_LESS_EQ _ = ()
  val op NOT_SUC_ADD_LESS_EQ = TDB.find "NOT_SUC_ADD_LESS_EQ"
  fun op MULT_LESS_EQ_SUC _ = ()
  val op MULT_LESS_EQ_SUC = TDB.find "MULT_LESS_EQ_SUC"
  fun op LE_MULT_LCANCEL _ = ()
  val op LE_MULT_LCANCEL = TDB.find "LE_MULT_LCANCEL"
  fun op LE_MULT_RCANCEL _ = ()
  val op LE_MULT_RCANCEL = TDB.find "LE_MULT_RCANCEL"
  fun op LT_MULT_LCANCEL _ = ()
  val op LT_MULT_LCANCEL = TDB.find "LT_MULT_LCANCEL"
  fun op LT_MULT_RCANCEL _ = ()
  val op LT_MULT_RCANCEL = TDB.find "LT_MULT_RCANCEL"
  fun op LT_MULT_CANCEL_LBARE _ = ()
  val op LT_MULT_CANCEL_LBARE = TDB.find "LT_MULT_CANCEL_LBARE"
  fun op LT_MULT_CANCEL_RBARE _ = ()
  val op LT_MULT_CANCEL_RBARE = TDB.find "LT_MULT_CANCEL_RBARE"
  fun op LE_MULT_CANCEL_LBARE _ = ()
  val op LE_MULT_CANCEL_LBARE = TDB.find "LE_MULT_CANCEL_LBARE"
  fun op LE_MULT_CANCEL_RBARE _ = ()
  val op LE_MULT_CANCEL_RBARE = TDB.find "LE_MULT_CANCEL_RBARE"
  fun op SUB_LEFT_ADD _ = () val op SUB_LEFT_ADD = TDB.find "SUB_LEFT_ADD"
  fun op SUB_RIGHT_ADD _ = ()
  val op SUB_RIGHT_ADD = TDB.find "SUB_RIGHT_ADD"
  fun op SUB_LEFT_SUB _ = () val op SUB_LEFT_SUB = TDB.find "SUB_LEFT_SUB"
  fun op SUB_RIGHT_SUB _ = ()
  val op SUB_RIGHT_SUB = TDB.find "SUB_RIGHT_SUB"
  fun op SUB_LEFT_SUC _ = () val op SUB_LEFT_SUC = TDB.find "SUB_LEFT_SUC"
  fun op SUB_LEFT_LESS_EQ _ = ()
  val op SUB_LEFT_LESS_EQ = TDB.find "SUB_LEFT_LESS_EQ"
  fun op SUB_RIGHT_LESS_EQ _ = ()
  val op SUB_RIGHT_LESS_EQ = TDB.find "SUB_RIGHT_LESS_EQ"
  fun op SUB_LEFT_LESS _ = ()
  val op SUB_LEFT_LESS = TDB.find "SUB_LEFT_LESS"
  fun op SUB_RIGHT_LESS _ = ()
  val op SUB_RIGHT_LESS = TDB.find "SUB_RIGHT_LESS"
  fun op SUB_LEFT_GREATER_EQ _ = ()
  val op SUB_LEFT_GREATER_EQ = TDB.find "SUB_LEFT_GREATER_EQ"
  fun op SUB_RIGHT_GREATER_EQ _ = ()
  val op SUB_RIGHT_GREATER_EQ = TDB.find "SUB_RIGHT_GREATER_EQ"
  fun op SUB_LEFT_GREATER _ = ()
  val op SUB_LEFT_GREATER = TDB.find "SUB_LEFT_GREATER"
  fun op SUB_RIGHT_GREATER _ = ()
  val op SUB_RIGHT_GREATER = TDB.find "SUB_RIGHT_GREATER"
  fun op SUB_LEFT_EQ _ = () val op SUB_LEFT_EQ = TDB.find "SUB_LEFT_EQ"
  fun op SUB_RIGHT_EQ _ = () val op SUB_RIGHT_EQ = TDB.find "SUB_RIGHT_EQ"
  fun op LE _ = () val op LE = TDB.find "LE"
  fun op DA _ = () val op DA = TDB.find "DA"
  fun op MOD_ONE _ = () val op MOD_ONE = TDB.find "MOD_ONE"
  fun op MOD_1 _ = () val op MOD_1 = TDB.find "MOD_1"
  fun op DIV_LESS_EQ _ = () val op DIV_LESS_EQ = TDB.find "DIV_LESS_EQ"
  fun op DIV_UNIQUE _ = () val op DIV_UNIQUE = TDB.find "DIV_UNIQUE"
  fun op MOD_UNIQUE _ = () val op MOD_UNIQUE = TDB.find "MOD_UNIQUE"
  fun op DIV2_DOUBLE _ = () val op DIV2_DOUBLE = TDB.find "DIV2_DOUBLE"
  fun op DIV_MULT _ = () val op DIV_MULT = TDB.find "DIV_MULT"
  fun op LESS_MOD _ = () val op LESS_MOD = TDB.find "LESS_MOD"
  fun op MOD_EQ_0 _ = () val op MOD_EQ_0 = TDB.find "MOD_EQ_0"
  fun op ZERO_MOD _ = () val op ZERO_MOD = TDB.find "ZERO_MOD"
  fun op ZERO_DIV _ = () val op ZERO_DIV = TDB.find "ZERO_DIV"
  fun op MOD_MULT _ = () val op MOD_MULT = TDB.find "MOD_MULT"
  fun op MOD_TIMES _ = () val op MOD_TIMES = TDB.find "MOD_TIMES"
  fun op MOD_TIMES_SUB _ = ()
  val op MOD_TIMES_SUB = TDB.find "MOD_TIMES_SUB"
  fun op MOD_PLUS _ = () val op MOD_PLUS = TDB.find "MOD_PLUS"
  fun op MOD_MOD _ = () val op MOD_MOD = TDB.find "MOD_MOD"
  fun op LESS_DIV_EQ_ZERO _ = ()
  val op LESS_DIV_EQ_ZERO = TDB.find "LESS_DIV_EQ_ZERO"
  fun op MULT_DIV _ = () val op MULT_DIV = TDB.find "MULT_DIV"
  fun op ADD_DIV_ADD_DIV _ = ()
  val op ADD_DIV_ADD_DIV = TDB.find "ADD_DIV_ADD_DIV"
  fun op ADD_DIV_RWT _ = () val op ADD_DIV_RWT = TDB.find "ADD_DIV_RWT"
  fun op MOD_MULT_MOD _ = () val op MOD_MULT_MOD = TDB.find "MOD_MULT_MOD"
  fun op DIV_ONE _ = () val op DIV_ONE = TDB.find "DIV_ONE"
  fun op DIV_1 _ = () val op DIV_1 = TDB.find "DIV_1"
  fun op DIVMOD_ID _ = () val op DIVMOD_ID = TDB.find "DIVMOD_ID"
  fun op DIV_DIV_DIV_MULT _ = ()
  val op DIV_DIV_DIV_MULT = TDB.find "DIV_DIV_DIV_MULT"
  fun op SUC_PRE _ = () val op SUC_PRE = TDB.find "SUC_PRE"
  fun op DIV_LESS _ = () val op DIV_LESS = TDB.find "DIV_LESS"
  fun op MOD_LESS _ = () val op MOD_LESS = TDB.find "MOD_LESS"
  fun op ADD_MODULUS _ = () val op ADD_MODULUS = TDB.find "ADD_MODULUS"
  fun op ADD_MODULUS_LEFT _ = ()
  val op ADD_MODULUS_LEFT = TDB.find "ADD_MODULUS_LEFT"
  fun op ADD_MODULUS_RIGHT _ = ()
  val op ADD_MODULUS_RIGHT = TDB.find "ADD_MODULUS_RIGHT"
  fun op DIV_P _ = () val op DIV_P = TDB.find "DIV_P"
  fun op DIV_P_UNIV _ = () val op DIV_P_UNIV = TDB.find "DIV_P_UNIV"
  fun op MOD_P _ = () val op MOD_P = TDB.find "MOD_P"
  fun op MOD_P_UNIV _ = () val op MOD_P_UNIV = TDB.find "MOD_P_UNIV"
  fun op MOD_TIMES2 _ = () val op MOD_TIMES2 = TDB.find "MOD_TIMES2"
  fun op MOD_COMMON_FACTOR _ = ()
  val op MOD_COMMON_FACTOR = TDB.find "MOD_COMMON_FACTOR"
  fun op X_MOD_Y_EQ_X _ = () val op X_MOD_Y_EQ_X = TDB.find "X_MOD_Y_EQ_X"
  fun op DIV_LE_MONOTONE _ = ()
  val op DIV_LE_MONOTONE = TDB.find "DIV_LE_MONOTONE"
  fun op LE_LT1 _ = () val op LE_LT1 = TDB.find "LE_LT1"
  fun op X_LE_DIV _ = () val op X_LE_DIV = TDB.find "X_LE_DIV"
  fun op X_LT_DIV _ = () val op X_LT_DIV = TDB.find "X_LT_DIV"
  fun op DIV_LT_X _ = () val op DIV_LT_X = TDB.find "DIV_LT_X"
  fun op DIV_LE_X _ = () val op DIV_LE_X = TDB.find "DIV_LE_X"
  fun op DIV_EQ_X _ = () val op DIV_EQ_X = TDB.find "DIV_EQ_X"
  fun op DIV_MOD_MOD_DIV _ = ()
  val op DIV_MOD_MOD_DIV = TDB.find "DIV_MOD_MOD_DIV"
  fun op MULT_EQ_DIV _ = () val op MULT_EQ_DIV = TDB.find "MULT_EQ_DIV"
  fun op NUMERAL_MULT_EQ_DIV _ = ()
  val op NUMERAL_MULT_EQ_DIV = TDB.find "NUMERAL_MULT_EQ_DIV"
  fun op MOD_EQ_0_DIVISOR _ = ()
  val op MOD_EQ_0_DIVISOR = TDB.find "MOD_EQ_0_DIVISOR"
  fun op MOD_SUC _ = () val op MOD_SUC = TDB.find "MOD_SUC"
  fun op MOD_SUC_IFF _ = () val op MOD_SUC_IFF = TDB.find "MOD_SUC_IFF"
  fun op ONE_MOD _ = () val op ONE_MOD = TDB.find "ONE_MOD"
  fun op ONE_MOD_IFF _ = () val op ONE_MOD_IFF = TDB.find "ONE_MOD_IFF"
  fun op MOD_LESS_EQ _ = () val op MOD_LESS_EQ = TDB.find "MOD_LESS_EQ"
  fun op MOD_LIFT_PLUS _ = ()
  val op MOD_LIFT_PLUS = TDB.find "MOD_LIFT_PLUS"
  fun op MOD_LIFT_PLUS_IFF _ = ()
  val op MOD_LIFT_PLUS_IFF = TDB.find "MOD_LIFT_PLUS_IFF"
  fun op DIV_0_IMP_LT _ = () val op DIV_0_IMP_LT = TDB.find "DIV_0_IMP_LT"
  fun op DIV_EQ_0 _ = () val op DIV_EQ_0 = TDB.find "DIV_EQ_0"
  fun op num_case_cong _ = ()
  val op num_case_cong = TDB.find "num_case_cong"
  fun op SUC_ELIM_THM _ = () val op SUC_ELIM_THM = TDB.find "SUC_ELIM_THM"
  fun op SUC_ELIM_NUMERALS _ = ()
  val op SUC_ELIM_NUMERALS = TDB.find "SUC_ELIM_NUMERALS"
  fun op SUB_ELIM_THM _ = () val op SUB_ELIM_THM = TDB.find "SUB_ELIM_THM"
  fun op SUB_ELIM_THM_EXISTS _ = ()
  val op SUB_ELIM_THM_EXISTS = TDB.find "SUB_ELIM_THM_EXISTS"
  fun op PRE_ELIM_THM _ = () val op PRE_ELIM_THM = TDB.find "PRE_ELIM_THM"
  fun op MULT_INCREASES _ = ()
  val op MULT_INCREASES = TDB.find "MULT_INCREASES"
  fun op EXP_ALWAYS_BIG_ENOUGH _ = ()
  val op EXP_ALWAYS_BIG_ENOUGH = TDB.find "EXP_ALWAYS_BIG_ENOUGH"
  fun op EXP_EQ_0 _ = () val op EXP_EQ_0 = TDB.find "EXP_EQ_0"
  fun op ZERO_LT_EXP _ = () val op ZERO_LT_EXP = TDB.find "ZERO_LT_EXP"
  fun op EXP_1 _ = () val op EXP_1 = TDB.find "EXP_1"
  fun op EXP_EQ_1 _ = () val op EXP_EQ_1 = TDB.find "EXP_EQ_1"
  fun op EXP_BASE_LE_MONO _ = ()
  val op EXP_BASE_LE_MONO = TDB.find "EXP_BASE_LE_MONO"
  fun op EXP_BASE_LT_MONO _ = ()
  val op EXP_BASE_LT_MONO = TDB.find "EXP_BASE_LT_MONO"
  fun op EXP_BASE_INJECTIVE _ = ()
  val op EXP_BASE_INJECTIVE = TDB.find "EXP_BASE_INJECTIVE"
  fun op EXP_BASE_LEQ_MONO_IMP _ = ()
  val op EXP_BASE_LEQ_MONO_IMP = TDB.find "EXP_BASE_LEQ_MONO_IMP"
  fun op EXP_BASE_LEQ_MONO_SUC_IMP _ = ()
  val op EXP_BASE_LEQ_MONO_SUC_IMP = TDB.find "EXP_BASE_LEQ_MONO_SUC_IMP"
  fun op EXP_BASE_LE_IFF _ = ()
  val op EXP_BASE_LE_IFF = TDB.find "EXP_BASE_LE_IFF"
  fun op X_LE_X_EXP _ = () val op X_LE_X_EXP = TDB.find "X_LE_X_EXP"
  fun op X_LE_X_SQUARED _ = ()
  val op X_LE_X_SQUARED = TDB.find "X_LE_X_SQUARED"
  fun op X_LT_X_SQUARED _ = ()
  val op X_LT_X_SQUARED = TDB.find "X_LT_X_SQUARED"
  fun op X_LT_EXP_X _ = () val op X_LT_EXP_X = TDB.find "X_LT_EXP_X"
  fun op ZERO_EXP _ = () val op ZERO_EXP = TDB.find "ZERO_EXP"
  fun op X_LT_EXP_X_IFF _ = ()
  val op X_LT_EXP_X_IFF = TDB.find "X_LT_EXP_X_IFF"
  fun op EXP_EXP_LT_MONO _ = ()
  val op EXP_EXP_LT_MONO = TDB.find "EXP_EXP_LT_MONO"
  fun op EXP_EXP_LE_MONO _ = ()
  val op EXP_EXP_LE_MONO = TDB.find "EXP_EXP_LE_MONO"
  fun op EXP_EXP_INJECTIVE _ = ()
  val op EXP_EXP_INJECTIVE = TDB.find "EXP_EXP_INJECTIVE"
  fun op EXP_SUB _ = () val op EXP_SUB = TDB.find "EXP_SUB"
  fun op EXP_SUB_NUMERAL _ = ()
  val op EXP_SUB_NUMERAL = TDB.find "EXP_SUB_NUMERAL"
  fun op EXP_BASE_MULT _ = ()
  val op EXP_BASE_MULT = TDB.find "EXP_BASE_MULT"
  fun op EXP_EXP_MULT _ = () val op EXP_EXP_MULT = TDB.find "EXP_EXP_MULT"
  fun op SUM_SQUARED _ = () val op SUM_SQUARED = TDB.find "SUM_SQUARED"
  fun op MAX_COMM _ = () val op MAX_COMM = TDB.find "MAX_COMM"
  fun op MIN_COMM _ = () val op MIN_COMM = TDB.find "MIN_COMM"
  fun op MAX_ASSOC _ = () val op MAX_ASSOC = TDB.find "MAX_ASSOC"
  fun op MIN_ASSOC _ = () val op MIN_ASSOC = TDB.find "MIN_ASSOC"
  fun op MIN_MAX_EQ _ = () val op MIN_MAX_EQ = TDB.find "MIN_MAX_EQ"
  fun op MIN_MAX_LT _ = () val op MIN_MAX_LT = TDB.find "MIN_MAX_LT"
  fun op MIN_MAX_LE _ = () val op MIN_MAX_LE = TDB.find "MIN_MAX_LE"
  fun op MIN_MAX_PRED _ = () val op MIN_MAX_PRED = TDB.find "MIN_MAX_PRED"
  fun op MIN_LT _ = () val op MIN_LT = TDB.find "MIN_LT"
  fun op MAX_LT _ = () val op MAX_LT = TDB.find "MAX_LT"
  fun op MIN_LE _ = () val op MIN_LE = TDB.find "MIN_LE"
  fun op MAX_LE _ = () val op MAX_LE = TDB.find "MAX_LE"
  fun op MIN_0 _ = () val op MIN_0 = TDB.find "MIN_0"
  fun op MAX_0 _ = () val op MAX_0 = TDB.find "MAX_0"
  fun op MAX_EQ_0 _ = () val op MAX_EQ_0 = TDB.find "MAX_EQ_0"
  fun op MIN_EQ_0 _ = () val op MIN_EQ_0 = TDB.find "MIN_EQ_0"
  fun op MIN_IDEM _ = () val op MIN_IDEM = TDB.find "MIN_IDEM"
  fun op MAX_IDEM _ = () val op MAX_IDEM = TDB.find "MAX_IDEM"
  fun op EXISTS_GREATEST _ = ()
  val op EXISTS_GREATEST = TDB.find "EXISTS_GREATEST"
  fun op EXISTS_NUM _ = () val op EXISTS_NUM = TDB.find "EXISTS_NUM"
  fun op FORALL_NUM _ = () val op FORALL_NUM = TDB.find "FORALL_NUM"
  fun op BOUNDED_FORALL_THM _ = ()
  val op BOUNDED_FORALL_THM = TDB.find "BOUNDED_FORALL_THM"
  fun op BOUNDED_EXISTS_THM _ = ()
  val op BOUNDED_EXISTS_THM = TDB.find "BOUNDED_EXISTS_THM"
  fun op transitive_monotone _ = ()
  val op transitive_monotone = TDB.find "transitive_monotone"
  fun op STRICTLY_INCREASING_TC _ = ()
  val op STRICTLY_INCREASING_TC = TDB.find "STRICTLY_INCREASING_TC"
  fun op STRICTLY_INCREASING_ONE_ONE _ = ()
  val op STRICTLY_INCREASING_ONE_ONE = TDB.find
    "STRICTLY_INCREASING_ONE_ONE"
  fun op ONE_ONE_INV_IMAGE_BOUNDED _ = ()
  val op ONE_ONE_INV_IMAGE_BOUNDED = TDB.find "ONE_ONE_INV_IMAGE_BOUNDED"
  fun op ONE_ONE_UNBOUNDED _ = ()
  val op ONE_ONE_UNBOUNDED = TDB.find "ONE_ONE_UNBOUNDED"
  fun op STRICTLY_INCREASING_UNBOUNDED _ = ()
  val op STRICTLY_INCREASING_UNBOUNDED = TDB.find
    "STRICTLY_INCREASING_UNBOUNDED"
  fun op NOT_STRICTLY_DECREASING _ = ()
  val op NOT_STRICTLY_DECREASING = TDB.find "NOT_STRICTLY_DECREASING"
  fun op ABS_DIFF_SYM _ = () val op ABS_DIFF_SYM = TDB.find "ABS_DIFF_SYM"
  fun op ABS_DIFF_COMM _ = ()
  val op ABS_DIFF_COMM = TDB.find "ABS_DIFF_COMM"
  fun op ABS_DIFF_EQS _ = () val op ABS_DIFF_EQS = TDB.find "ABS_DIFF_EQS"
  fun op ABS_DIFF_EQ_0 _ = ()
  val op ABS_DIFF_EQ_0 = TDB.find "ABS_DIFF_EQ_0"
  fun op ABS_DIFF_ZERO _ = ()
  val op ABS_DIFF_ZERO = TDB.find "ABS_DIFF_ZERO"
  fun op ABS_DIFF_SUC _ = () val op ABS_DIFF_SUC = TDB.find "ABS_DIFF_SUC"
  fun op ABS_DIFF_SUC_LE _ = ()
  val op ABS_DIFF_SUC_LE = TDB.find "ABS_DIFF_SUC_LE"
  fun op ABS_DIFF_PLUS_LE _ = ()
  val op ABS_DIFF_PLUS_LE = TDB.find "ABS_DIFF_PLUS_LE"
  fun op ABS_DIFF_LE_SUM _ = ()
  val op ABS_DIFF_LE_SUM = TDB.find "ABS_DIFF_LE_SUM"
  fun op ABS_DIFF_TRIANGLE_lem _ = ()
  val op ABS_DIFF_TRIANGLE_lem = TDB.find "ABS_DIFF_TRIANGLE_lem"
  fun op ABS_DIFF_TRIANGLE _ = ()
  val op ABS_DIFF_TRIANGLE = TDB.find "ABS_DIFF_TRIANGLE"
  fun op ABS_DIFF_ADD_SAME _ = ()
  val op ABS_DIFF_ADD_SAME = TDB.find "ABS_DIFF_ADD_SAME"
  fun op LE_SUB_RCANCEL _ = ()
  val op LE_SUB_RCANCEL = TDB.find "LE_SUB_RCANCEL"
  fun op LT_SUB_RCANCEL _ = ()
  val op LT_SUB_RCANCEL = TDB.find "LT_SUB_RCANCEL"
  fun op LE_SUB_LCANCEL _ = ()
  val op LE_SUB_LCANCEL = TDB.find "LE_SUB_LCANCEL"
  fun op LT_SUB_LCANCEL _ = ()
  val op LT_SUB_LCANCEL = TDB.find "LT_SUB_LCANCEL"
  fun op ABS_DIFF_SUMS _ = ()
  val op ABS_DIFF_SUMS = TDB.find "ABS_DIFF_SUMS"
  fun op FUNPOW_SUC _ = () val op FUNPOW_SUC = TDB.find "FUNPOW_SUC"
  fun op FUNPOW_0 _ = () val op FUNPOW_0 = TDB.find "FUNPOW_0"
  fun op FUNPOW_ADD _ = () val op FUNPOW_ADD = TDB.find "FUNPOW_ADD"
  fun op FUNPOW_1 _ = () val op FUNPOW_1 = TDB.find "FUNPOW_1"
  fun op NRC_0 _ = () val op NRC_0 = TDB.find "NRC_0"
  fun op NRC_1 _ = () val op NRC_1 = TDB.find "NRC_1"
  fun op NRC_ADD_I _ = () val op NRC_ADD_I = TDB.find "NRC_ADD_I"
  fun op NRC_ADD_E _ = () val op NRC_ADD_E = TDB.find "NRC_ADD_E"
  fun op NRC_ADD_EQN _ = () val op NRC_ADD_EQN = TDB.find "NRC_ADD_EQN"
  fun op NRC_SUC_RECURSE_LEFT _ = ()
  val op NRC_SUC_RECURSE_LEFT = TDB.find "NRC_SUC_RECURSE_LEFT"
  fun op NRC_RTC _ = () val op NRC_RTC = TDB.find "NRC_RTC"
  fun op RTC_NRC _ = () val op RTC_NRC = TDB.find "RTC_NRC"
  fun op RTC_eq_NRC _ = () val op RTC_eq_NRC = TDB.find "RTC_eq_NRC"
  fun op TC_eq_NRC _ = () val op TC_eq_NRC = TDB.find "TC_eq_NRC"
  fun op LESS_EQUAL_DIFF _ = ()
  val op LESS_EQUAL_DIFF = TDB.find "LESS_EQUAL_DIFF"
  fun op MOD_2 _ = () val op MOD_2 = TDB.find "MOD_2"
  fun op EVEN_MOD2 _ = () val op EVEN_MOD2 = TDB.find "EVEN_MOD2"
  fun op SUC_MOD _ = () val op SUC_MOD = TDB.find "SUC_MOD"
  fun op ADD_MOD _ = () val op ADD_MOD = TDB.find "ADD_MOD"
  fun op MOD_ELIM _ = () val op MOD_ELIM = TDB.find "MOD_ELIM"
  fun op DOUBLE_LT _ = () val op DOUBLE_LT = TDB.find "DOUBLE_LT"
  fun op EXP2_LT _ = () val op EXP2_LT = TDB.find "EXP2_LT"
  fun op SUB_LESS _ = () val op SUB_LESS = TDB.find "SUB_LESS"
  fun op SUB_MOD _ = () val op SUB_MOD = TDB.find "SUB_MOD"
  fun op ONE_LT_MULT_IMP _ = ()
  val op ONE_LT_MULT_IMP = TDB.find "ONE_LT_MULT_IMP"
  fun op ONE_LT_MULT _ = () val op ONE_LT_MULT = TDB.find "ONE_LT_MULT"
  fun op ONE_LT_EXP _ = () val op ONE_LT_EXP = TDB.find "ONE_LT_EXP"
  fun op findq_thm _ = () val op findq_thm = TDB.find "findq_thm"
  fun op findq_eq_0 _ = () val op findq_eq_0 = TDB.find "findq_eq_0"
  fun op findq_divisor _ = ()
  val op findq_divisor = TDB.find "findq_divisor"
  fun op DIVMOD_THM _ = () val op DIVMOD_THM = TDB.find "DIVMOD_THM"
  fun op MOD_SUB _ = () val op MOD_SUB = TDB.find "MOD_SUB"
  fun op DIV_SUB _ = () val op DIV_SUB = TDB.find "DIV_SUB"
  fun op DIVMOD_CORRECT _ = ()
  val op DIVMOD_CORRECT = TDB.find "DIVMOD_CORRECT"
  fun op DIVMOD_CALC _ = () val op DIVMOD_CALC = TDB.find "DIVMOD_CALC"
  fun op MODEQ_0_CONG _ = () val op MODEQ_0_CONG = TDB.find "MODEQ_0_CONG"
  fun op MODEQ_NONZERO_MODEQUALITY _ = ()
  val op MODEQ_NONZERO_MODEQUALITY = TDB.find "MODEQ_NONZERO_MODEQUALITY"
  fun op MODEQ_THM _ = () val op MODEQ_THM = TDB.find "MODEQ_THM"
  fun op MODEQ_INTRO_CONG _ = ()
  val op MODEQ_INTRO_CONG = TDB.find "MODEQ_INTRO_CONG"
  fun op MODEQ_PLUS_CONG _ = ()
  val op MODEQ_PLUS_CONG = TDB.find "MODEQ_PLUS_CONG"
  fun op MODEQ_MULT_CONG _ = ()
  val op MODEQ_MULT_CONG = TDB.find "MODEQ_MULT_CONG"
  fun op MODEQ_REFL _ = () val op MODEQ_REFL = TDB.find "MODEQ_REFL"
  fun op MODEQ_SUC_CONG _ = ()
  val op MODEQ_SUC_CONG = TDB.find "MODEQ_SUC_CONG"
  fun op MODEQ_EXP_CONG _ = ()
  val op MODEQ_EXP_CONG = TDB.find "MODEQ_EXP_CONG"
  fun op EXP_MOD _ = () val op EXP_MOD = TDB.find "EXP_MOD"
  fun op MODEQ_SYM _ = () val op MODEQ_SYM = TDB.find "MODEQ_SYM"
  fun op MODEQ_TRANS _ = () val op MODEQ_TRANS = TDB.find "MODEQ_TRANS"
  fun op MODEQ_NUMERAL _ = ()
  val op MODEQ_NUMERAL = TDB.find "MODEQ_NUMERAL"
  fun op MODEQ_MOD _ = () val op MODEQ_MOD = TDB.find "MODEQ_MOD"
  fun op MODEQ_0 _ = () val op MODEQ_0 = TDB.find "MODEQ_0"
  fun op num_case_eq _ = () val op num_case_eq = TDB.find "num_case_eq"
  fun op datatype_num _ = () val op datatype_num = TDB.find "datatype_num"
  fun op binary_induct _ = ()
  val op binary_induct = TDB.find "binary_induct"
  fun op EVEN_SUB _ = () val op EVEN_SUB = TDB.find "EVEN_SUB"
  fun op ODD_SUB _ = () val op ODD_SUB = TDB.find "ODD_SUB"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val arithmetic_grammars = merge_grammars ["prim_rec", "pair"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="arithmetic"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val arithmetic_grammars = 
    Portable.## (addtyUDs,addtmUDs) arithmetic_grammars
  val _ = Parse.grammarDB_insert("arithmetic",arithmetic_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "arithmetic"

end
