structure basicSizeTheory :> basicSizeTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading basicSizeTheory ... "
    else ()
  
  open Type Term Thm
  local open numeralTheory optionTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "basicSize"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/theories/basicSizeTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op bool_size_def _ = ()
  val op bool_size_def = TDB.find "bool_size_def"
  fun op pair_size_def _ = ()
  val op pair_size_def = TDB.find "pair_size_def"
  fun op one_size_def _ = () val op one_size_def = TDB.find "one_size_def"
  fun op sum_size_def _ = () val op sum_size_def = TDB.find "sum_size_def"
  fun op option_size_def _ = ()
  val op option_size_def = TDB.find "option_size_def"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val basicSize_grammars = merge_grammars ["numeral", "option"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="basicSize"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val basicSize_grammars = 
    Portable.## (addtyUDs,addtmUDs) basicSize_grammars
  val _ = Parse.grammarDB_insert("basicSize",basicSize_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "basicSize"

end
