structure numTheory :> numTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading numTheory ... "
    else ()
  
  open Type Term Thm
  local open markerTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "num"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/theories/numTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op SUC_REP_DEF _ = () val op SUC_REP_DEF = TDB.find "SUC_REP_DEF"
  fun op ZERO_REP_DEF _ = () val op ZERO_REP_DEF = TDB.find "ZERO_REP_DEF"
  fun op IS_NUM_REP _ = () val op IS_NUM_REP = TDB.find "IS_NUM_REP"
  fun op num_TY_DEF _ = () val op num_TY_DEF = TDB.find "num_TY_DEF"
  fun op num_ISO_DEF _ = () val op num_ISO_DEF = TDB.find "num_ISO_DEF"
  fun op ZERO_DEF _ = () val op ZERO_DEF = TDB.find "ZERO_DEF"
  fun op SUC_DEF _ = () val op SUC_DEF = TDB.find "SUC_DEF"
  fun op NOT_SUC _ = () val op NOT_SUC = TDB.find "NOT_SUC"
  fun op INV_SUC _ = () val op INV_SUC = TDB.find "INV_SUC"
  fun op INDUCTION _ = () val op INDUCTION = TDB.find "INDUCTION"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val num_grammars = merge_grammars ["marker"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="num"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val num_grammars = 
    Portable.## (addtyUDs,addtmUDs) num_grammars
  val _ = Parse.grammarDB_insert("num",num_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "num"

end
