structure numeralTheory :> numeralTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading numeralTheory ... "
    else ()
  
  open Type Term Thm
  local open arithmeticTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "numeral"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/theories/numeralTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op iZ _ = () val op iZ = TDB.find "iZ"
  fun op iiSUC _ = () val op iiSUC = TDB.find "iiSUC"
  fun op iBIT_cases _ = () val op iBIT_cases = TDB.find "iBIT_cases"
  fun op iDUB _ = () val op iDUB = TDB.find "iDUB"
  fun op iSUB_DEF _ = () val op iSUB_DEF = TDB.find "iSUB_DEF"
  fun op iSQR _ = () val op iSQR = TDB.find "iSQR"
  fun op texp_help_def _ = ()
  val op texp_help_def = TDB.find "texp_help_def"
  fun op onecount_def _ = () val op onecount_def = TDB.find "onecount_def"
  fun op exactlog_def _ = () val op exactlog_def = TDB.find "exactlog_def"
  fun op internal_mult_def _ = ()
  val op internal_mult_def = TDB.find "internal_mult_def"
  fun op numeral_suc _ = () val op numeral_suc = TDB.find "numeral_suc"
  fun op numeral_distrib _ = ()
  val op numeral_distrib = TDB.find "numeral_distrib"
  fun op numeral_iisuc _ = ()
  val op numeral_iisuc = TDB.find "numeral_iisuc"
  fun op numeral_add _ = () val op numeral_add = TDB.find "numeral_add"
  fun op numeral_eq _ = () val op numeral_eq = TDB.find "numeral_eq"
  fun op numeral_lt _ = () val op numeral_lt = TDB.find "numeral_lt"
  fun op numeral_lte _ = () val op numeral_lte = TDB.find "numeral_lte"
  fun op numeral_pre _ = () val op numeral_pre = TDB.find "numeral_pre"
  fun op bit_initiality _ = ()
  val op bit_initiality = TDB.find "bit_initiality"
  fun op bit_induction _ = ()
  val op bit_induction = TDB.find "bit_induction"
  fun op iSUB_THM _ = () val op iSUB_THM = TDB.find "iSUB_THM"
  fun op numeral_sub _ = () val op numeral_sub = TDB.find "numeral_sub"
  fun op iDUB_removal _ = () val op iDUB_removal = TDB.find "iDUB_removal"
  fun op numeral_mult _ = () val op numeral_mult = TDB.find "numeral_mult"
  fun op numeral_exp _ = () val op numeral_exp = TDB.find "numeral_exp"
  fun op numeral_evenodd _ = ()
  val op numeral_evenodd = TDB.find "numeral_evenodd"
  fun op numeral_fact _ = () val op numeral_fact = TDB.find "numeral_fact"
  fun op numeral_funpow _ = ()
  val op numeral_funpow = TDB.find "numeral_funpow"
  fun op numeral_MIN _ = () val op numeral_MIN = TDB.find "numeral_MIN"
  fun op numeral_MAX _ = () val op numeral_MAX = TDB.find "numeral_MAX"
  fun op divmod_POS _ = () val op divmod_POS = TDB.find "divmod_POS"
  fun op DIVMOD_NUMERAL_CALC _ = ()
  val op DIVMOD_NUMERAL_CALC = TDB.find "DIVMOD_NUMERAL_CALC"
  fun op numeral_div2 _ = () val op numeral_div2 = TDB.find "numeral_div2"
  fun op texp_help_thm _ = ()
  val op texp_help_thm = TDB.find "texp_help_thm"
  fun op texp_help0 _ = () val op texp_help0 = TDB.find "texp_help0"
  fun op numeral_texp_help _ = ()
  val op numeral_texp_help = TDB.find "numeral_texp_help"
  fun op TWO_EXP_THM _ = () val op TWO_EXP_THM = TDB.find "TWO_EXP_THM"
  fun op onecount_characterisation _ = ()
  val op onecount_characterisation = TDB.find "onecount_characterisation"
  fun op exactlog_characterisation _ = ()
  val op exactlog_characterisation = TDB.find "exactlog_characterisation"
  fun op DIV2_BIT1 _ = () val op DIV2_BIT1 = TDB.find "DIV2_BIT1"
  fun op enumeral_mult _ = ()
  val op enumeral_mult = TDB.find "enumeral_mult"
  fun op internal_mult_characterisation _ = ()
  val op internal_mult_characterisation = TDB.find
    "internal_mult_characterisation"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val numeral_grammars = merge_grammars ["arithmetic"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="numeral"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val numeral_grammars = 
    Portable.## (addtyUDs,addtmUDs) numeral_grammars
  val _ = Parse.grammarDB_insert("numeral",numeral_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "numeral"

end
