structure prim_recTheory :> prim_recTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading prim_recTheory ... "
    else ()
  
  open Type Term Thm
  local open numTheory relationTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "prim_rec"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/theories/prim_recTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op LESS_DEF _ = () val op LESS_DEF = TDB.find "LESS_DEF"
  fun op PRE_DEF _ = () val op PRE_DEF = TDB.find "PRE_DEF"
  fun op SIMP_REC_REL _ = () val op SIMP_REC_REL = TDB.find "SIMP_REC_REL"
  fun op SIMP_REC _ = () val op SIMP_REC = TDB.find "SIMP_REC"
  fun op PRIM_REC_FUN _ = () val op PRIM_REC_FUN = TDB.find "PRIM_REC_FUN"
  fun op PRIM_REC _ = () val op PRIM_REC = TDB.find "PRIM_REC"
  fun op wellfounded_def _ = ()
  val op wellfounded_def = TDB.find "wellfounded_def"
  fun op measure_def _ = () val op measure_def = TDB.find "measure_def"
  fun op INV_SUC_EQ _ = () val op INV_SUC_EQ = TDB.find "INV_SUC_EQ"
  fun op PRE _ = () val op PRE = TDB.find "PRE"
  fun op LESS_REFL _ = () val op LESS_REFL = TDB.find "LESS_REFL"
  fun op SUC_LESS _ = () val op SUC_LESS = TDB.find "SUC_LESS"
  fun op NOT_LESS_0 _ = () val op NOT_LESS_0 = TDB.find "NOT_LESS_0"
  fun op LESS_0 _ = () val op LESS_0 = TDB.find "LESS_0"
  fun op LESS_0_0 _ = () val op LESS_0_0 = TDB.find "LESS_0_0"
  fun op LESS_MONO _ = () val op LESS_MONO = TDB.find "LESS_MONO"
  fun op LESS_MONO_REV _ = ()
  val op LESS_MONO_REV = TDB.find "LESS_MONO_REV"
  fun op LESS_MONO_EQ _ = () val op LESS_MONO_EQ = TDB.find "LESS_MONO_EQ"
  fun op TC_IM_RTC_SUC _ = ()
  val op TC_IM_RTC_SUC = TDB.find "TC_IM_RTC_SUC"
  fun op RTC_IM_TC _ = () val op RTC_IM_TC = TDB.find "RTC_IM_TC"
  fun op LESS_ALT _ = () val op LESS_ALT = TDB.find "LESS_ALT"
  fun op LESS_SUC_REFL _ = ()
  val op LESS_SUC_REFL = TDB.find "LESS_SUC_REFL"
  fun op LESS_SUC _ = () val op LESS_SUC = TDB.find "LESS_SUC"
  fun op LESS_LEMMA1 _ = () val op LESS_LEMMA1 = TDB.find "LESS_LEMMA1"
  fun op LESS_LEMMA2 _ = () val op LESS_LEMMA2 = TDB.find "LESS_LEMMA2"
  fun op LESS_THM _ = () val op LESS_THM = TDB.find "LESS_THM"
  fun op LESS_SUC_IMP _ = () val op LESS_SUC_IMP = TDB.find "LESS_SUC_IMP"
  fun op EQ_LESS _ = () val op EQ_LESS = TDB.find "EQ_LESS"
  fun op SUC_ID _ = () val op SUC_ID = TDB.find "SUC_ID"
  fun op NOT_LESS_EQ _ = () val op NOT_LESS_EQ = TDB.find "NOT_LESS_EQ"
  fun op LESS_NOT_EQ _ = () val op LESS_NOT_EQ = TDB.find "LESS_NOT_EQ"
  fun op SIMP_REC_EXISTS _ = ()
  val op SIMP_REC_EXISTS = TDB.find "SIMP_REC_EXISTS"
  fun op SIMP_REC_REL_UNIQUE _ = ()
  val op SIMP_REC_REL_UNIQUE = TDB.find "SIMP_REC_REL_UNIQUE"
  fun op SIMP_REC_REL_UNIQUE_RESULT _ = ()
  val op SIMP_REC_REL_UNIQUE_RESULT = TDB.find "SIMP_REC_REL_UNIQUE_RESULT"
  fun op LESS_SUC_SUC _ = () val op LESS_SUC_SUC = TDB.find "LESS_SUC_SUC"
  fun op SIMP_REC_THM _ = () val op SIMP_REC_THM = TDB.find "SIMP_REC_THM"
  fun op PRIM_REC_EQN _ = () val op PRIM_REC_EQN = TDB.find "PRIM_REC_EQN"
  fun op PRIM_REC_THM _ = () val op PRIM_REC_THM = TDB.find "PRIM_REC_THM"
  fun op DC _ = () val op DC = TDB.find "DC"
  fun op num_Axiom_old _ = ()
  val op num_Axiom_old = TDB.find "num_Axiom_old"
  fun op num_Axiom _ = () val op num_Axiom = TDB.find "num_Axiom"
  fun op WF_IFF_WELLFOUNDED _ = ()
  val op WF_IFF_WELLFOUNDED = TDB.find "WF_IFF_WELLFOUNDED"
  fun op WF_PRED _ = () val op WF_PRED = TDB.find "WF_PRED"
  fun op WF_LESS _ = () val op WF_LESS = TDB.find "WF_LESS"
  fun op WF_measure _ = () val op WF_measure = TDB.find "WF_measure"
  fun op measure_thm _ = () val op measure_thm = TDB.find "measure_thm"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val prim_rec_grammars = merge_grammars ["num", "relation"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="prim_rec"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val prim_rec_grammars = 
    Portable.## (addtyUDs,addtmUDs) prim_rec_grammars
  val _ = Parse.grammarDB_insert("prim_rec",prim_rec_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "prim_rec"

end
