structure whileTheory :> whileTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading whileTheory ... "
    else ()
  
  open Type Term Thm
  local open arithmeticTheory optionTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "while"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/num/theories/whileTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op WHILE _ = () val op WHILE = TDB.find "WHILE"
  fun op HOARE_SPEC_DEF _ = ()
  val op HOARE_SPEC_DEF = TDB.find "HOARE_SPEC_DEF"
  fun op LEAST_DEF _ = () val op LEAST_DEF = TDB.find "LEAST_DEF"
  fun op OLEAST_def _ = () val op OLEAST_def = TDB.find "OLEAST_def"
  fun op OWHILE_def _ = () val op OWHILE_def = TDB.find "OWHILE_def"
  fun op ITERATION _ = () val op ITERATION = TDB.find "ITERATION"
  fun op WHILE_INDUCTION _ = ()
  val op WHILE_INDUCTION = TDB.find "WHILE_INDUCTION"
  fun op WHILE_RULE _ = () val op WHILE_RULE = TDB.find "WHILE_RULE"
  fun op LEAST_INTRO _ = () val op LEAST_INTRO = TDB.find "LEAST_INTRO"
  fun op LESS_LEAST _ = () val op LESS_LEAST = TDB.find "LESS_LEAST"
  fun op FULL_LEAST_INTRO _ = ()
  val op FULL_LEAST_INTRO = TDB.find "FULL_LEAST_INTRO"
  fun op LEAST_ELIM _ = () val op LEAST_ELIM = TDB.find "LEAST_ELIM"
  fun op LEAST_EXISTS _ = () val op LEAST_EXISTS = TDB.find "LEAST_EXISTS"
  fun op LEAST_EXISTS_IMP _ = ()
  val op LEAST_EXISTS_IMP = TDB.find "LEAST_EXISTS_IMP"
  fun op LEAST_EQ _ = () val op LEAST_EQ = TDB.find "LEAST_EQ"
  fun op LEAST_T _ = () val op LEAST_T = TDB.find "LEAST_T"
  fun op LEAST_LESS_EQ _ = ()
  val op LEAST_LESS_EQ = TDB.find "LEAST_LESS_EQ"
  fun op OLEAST_INTRO _ = () val op OLEAST_INTRO = TDB.find "OLEAST_INTRO"
  fun op OLEAST_EQNS _ = () val op OLEAST_EQNS = TDB.find "OLEAST_EQNS"
  fun op OLEAST_EQ_NONE _ = ()
  val op OLEAST_EQ_NONE = TDB.find "OLEAST_EQ_NONE"
  fun op OLEAST_EQ_SOME _ = ()
  val op OLEAST_EQ_SOME = TDB.find "OLEAST_EQ_SOME"
  fun op OWHILE_THM _ = () val op OWHILE_THM = TDB.find "OWHILE_THM"
  fun op OWHILE_EQ_NONE _ = ()
  val op OWHILE_EQ_NONE = TDB.find "OWHILE_EQ_NONE"
  fun op OWHILE_ENDCOND _ = ()
  val op OWHILE_ENDCOND = TDB.find "OWHILE_ENDCOND"
  fun op OWHILE_WHILE _ = () val op OWHILE_WHILE = TDB.find "OWHILE_WHILE"
  fun op OWHILE_INV_IND _ = ()
  val op OWHILE_INV_IND = TDB.find "OWHILE_INV_IND"
  fun op OWHILE_IND _ = () val op OWHILE_IND = TDB.find "OWHILE_IND"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val while_grammars = merge_grammars ["arithmetic", "option"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="while"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val while_grammars = 
    Portable.## (addtyUDs,addtmUDs) while_grammars
  val _ = Parse.grammarDB_insert("while",while_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "while"

end
