structure patternMatchesTheory :> patternMatchesTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading patternMatchesTheory ... "
    else ()
  
  open Type Term Thm
  local open quantHeuristicsTheory rich_listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "patternMatches"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pattern_matches/patternMatchesTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op PMATCH_ROW_COND_def _ = ()
  val op PMATCH_ROW_COND_def = TDB.find "PMATCH_ROW_COND_def"
  fun op PMATCH_ROW_def _ = ()
  val op PMATCH_ROW_def = TDB.find "PMATCH_ROW_def"
  fun op PMATCH_INCOMPLETE_def _ = ()
  val op PMATCH_INCOMPLETE_def = TDB.find "PMATCH_INCOMPLETE_def"
  fun op PMATCH_def _ = () val op PMATCH_def = TDB.find "PMATCH_def"
  fun op PMATCH_EQUIV_ROWS_def _ = ()
  val op PMATCH_EQUIV_ROWS_def = TDB.find "PMATCH_EQUIV_ROWS_def"
  fun op PMATCH_ROW_REDUNDANT_def _ = ()
  val op PMATCH_ROW_REDUNDANT_def = TDB.find "PMATCH_ROW_REDUNDANT_def"
  fun op IS_REDUNDANT_ROWS_INFO_def _ = ()
  val op IS_REDUNDANT_ROWS_INFO_def = TDB.find "IS_REDUNDANT_ROWS_INFO_def"
  fun op PMATCH_ROW_COND_EX_def _ = ()
  val op PMATCH_ROW_COND_EX_def = TDB.find "PMATCH_ROW_COND_EX_def"
  fun op APPLY_REDUNDANT_ROWS_INFO_def _ = ()
  val op APPLY_REDUNDANT_ROWS_INFO_def = TDB.find
    "APPLY_REDUNDANT_ROWS_INFO_def"
  fun op PMATCH_IS_EXHAUSTIVE_def _ = ()
  val op PMATCH_IS_EXHAUSTIVE_def = TDB.find "PMATCH_IS_EXHAUSTIVE_def"
  fun op REDUNDANT_ROWS_INFOS_CONJ_def _ = ()
  val op REDUNDANT_ROWS_INFOS_CONJ_def = TDB.find
    "REDUNDANT_ROWS_INFOS_CONJ_def"
  fun op REDUNDANT_ROWS_INFOS_DISJ_def _ = ()
  val op REDUNDANT_ROWS_INFOS_DISJ_def = TDB.find
    "REDUNDANT_ROWS_INFOS_DISJ_def"
  fun op STRONGEST_REDUNDANT_ROWS_INFO_AUX_def _ = ()
  val op STRONGEST_REDUNDANT_ROWS_INFO_AUX_def = TDB.find
    "STRONGEST_REDUNDANT_ROWS_INFO_AUX_def"
  fun op STRONGEST_REDUNDANT_ROWS_INFO_def _ = ()
  val op STRONGEST_REDUNDANT_ROWS_INFO_def = TDB.find
    "STRONGEST_REDUNDANT_ROWS_INFO_def"
  fun op PMATCH_FLATTEN_FUN_def _ = ()
  val op PMATCH_FLATTEN_FUN_def = TDB.find "PMATCH_FLATTEN_FUN_def"
  fun op PMATCH_ROW_COND_NOT_EX_OR_EQ_def _ = ()
  val op PMATCH_ROW_COND_NOT_EX_OR_EQ_def = TDB.find
    "PMATCH_ROW_COND_NOT_EX_OR_EQ_def"
  fun op PMATCH_EXPAND_PRED_def _ = ()
  val op PMATCH_EXPAND_PRED_def = TDB.find "PMATCH_EXPAND_PRED_def"
  fun op PMATCH_ROW_LIFT_def _ = ()
  val op PMATCH_ROW_LIFT_def = TDB.find "PMATCH_ROW_LIFT_def"
  fun op LENGTH_STRONGEST_REDUNDANT_ROWS_INFO _ = ()
  val op LENGTH_STRONGEST_REDUNDANT_ROWS_INFO = TDB.find
    "LENGTH_STRONGEST_REDUNDANT_ROWS_INFO"
  fun op EL2_STRONGEST_REDUNDANT_ROWS_INFO_AUX _ = ()
  val op EL2_STRONGEST_REDUNDANT_ROWS_INFO_AUX = TDB.find
    "EL2_STRONGEST_REDUNDANT_ROWS_INFO_AUX"
  fun op EL1_STRONGEST_REDUNDANT_ROWS_INFO_AUX _ = ()
  val op EL1_STRONGEST_REDUNDANT_ROWS_INFO_AUX = TDB.find
    "EL1_STRONGEST_REDUNDANT_ROWS_INFO_AUX"
  fun op some_var_bool_T _ = ()
  val op some_var_bool_T = TDB.find "some_var_bool_T"
  fun op some_var_bool_F _ = ()
  val op some_var_bool_F = TDB.find "some_var_bool_F"
  fun op PMATCH_ROW_CONG _ = ()
  val op PMATCH_ROW_CONG = TDB.find "PMATCH_ROW_CONG"
  fun op PMATCH_CONG _ = () val op PMATCH_CONG = TDB.find "PMATCH_CONG"
  fun op PMATCH_ROW_EQ_AUX _ = ()
  val op PMATCH_ROW_EQ_AUX = TDB.find "PMATCH_ROW_EQ_AUX"
  fun op PMATCH_ROW_EQ_NONE _ = ()
  val op PMATCH_ROW_EQ_NONE = TDB.find "PMATCH_ROW_EQ_NONE"
  fun op PMATCH_ROW_EQ_SOME _ = ()
  val op PMATCH_ROW_EQ_SOME = TDB.find "PMATCH_ROW_EQ_SOME"
  fun op PMATCH_COND_SELECT_UNIQUE _ = ()
  val op PMATCH_COND_SELECT_UNIQUE = TDB.find "PMATCH_COND_SELECT_UNIQUE"
  fun op PMATCH_ROW_COND_DEF_GSYM _ = ()
  val op PMATCH_ROW_COND_DEF_GSYM = TDB.find "PMATCH_ROW_COND_DEF_GSYM"
  fun op PMATCH_EVAL _ = () val op PMATCH_EVAL = TDB.find "PMATCH_EVAL"
  fun op PMATCH_EVAL_MATCH _ = ()
  val op PMATCH_EVAL_MATCH = TDB.find "PMATCH_EVAL_MATCH"
  fun op PMATCH_EXTEND_BASE _ = ()
  val op PMATCH_EXTEND_BASE = TDB.find "PMATCH_EXTEND_BASE"
  fun op PMATCH_EXTEND_BOTH _ = ()
  val op PMATCH_EXTEND_BOTH = TDB.find "PMATCH_EXTEND_BOTH"
  fun op PMATCH_EXTEND_BOTH_ID _ = ()
  val op PMATCH_EXTEND_BOTH_ID = TDB.find "PMATCH_EXTEND_BOTH_ID"
  fun op PMATCH_EXTEND_OLD _ = ()
  val op PMATCH_EXTEND_OLD = TDB.find "PMATCH_EXTEND_OLD"
  fun op PMATCH_ROW_REMOVE_FUN _ = ()
  val op PMATCH_ROW_REMOVE_FUN = TDB.find "PMATCH_ROW_REMOVE_FUN"
  fun op PMATCH_ROW_EXTEND_INPUT _ = ()
  val op PMATCH_ROW_EXTEND_INPUT = TDB.find "PMATCH_ROW_EXTEND_INPUT"
  fun op PMATCH_ROW_REMOVE_FUN_VAR _ = ()
  val op PMATCH_ROW_REMOVE_FUN_VAR = TDB.find "PMATCH_ROW_REMOVE_FUN_VAR"
  fun op PMATCH_EQUIV_ROWS_EQUIV_EXPAND _ = ()
  val op PMATCH_EQUIV_ROWS_EQUIV_EXPAND = TDB.find
    "PMATCH_EQUIV_ROWS_EQUIV_EXPAND"
  fun op PMATCH_EQUIV_ROWS_is_equiv_1 _ = ()
  val op PMATCH_EQUIV_ROWS_is_equiv_1 = TDB.find
    "PMATCH_EQUIV_ROWS_is_equiv_1"
  fun op PMATCH_EQUIV_ROWS_is_equiv_2 _ = ()
  val op PMATCH_EQUIV_ROWS_is_equiv_2 = TDB.find
    "PMATCH_EQUIV_ROWS_is_equiv_2"
  fun op PMATCH_EQUIV_ROWS_is_equiv_3 _ = ()
  val op PMATCH_EQUIV_ROWS_is_equiv_3 = TDB.find
    "PMATCH_EQUIV_ROWS_is_equiv_3"
  fun op PMATCH_EQUIV_ROWS_MATCH _ = ()
  val op PMATCH_EQUIV_ROWS_MATCH = TDB.find "PMATCH_EQUIV_ROWS_MATCH"
  fun op PMATCH_APPEND_SEM _ = ()
  val op PMATCH_APPEND_SEM = TDB.find "PMATCH_APPEND_SEM"
  fun op PMATCH_EQUIV_APPEND _ = ()
  val op PMATCH_EQUIV_APPEND = TDB.find "PMATCH_EQUIV_APPEND"
  fun op PMATCH_EQUIV_ROWS_CONS_NONE _ = ()
  val op PMATCH_EQUIV_ROWS_CONS_NONE = TDB.find
    "PMATCH_EQUIV_ROWS_CONS_NONE"
  fun op PMATCH_ROWS_DROP_REDUNDANT_TRIVIAL_SOUNDNESS_EQUIV _ = ()
  val op PMATCH_ROWS_DROP_REDUNDANT_TRIVIAL_SOUNDNESS_EQUIV = TDB.find
    "PMATCH_ROWS_DROP_REDUNDANT_TRIVIAL_SOUNDNESS_EQUIV"
  fun op PMATCH_ROWS_DROP_REDUNDANT_TRIVIAL_SOUNDNESS _ = ()
  val op PMATCH_ROWS_DROP_REDUNDANT_TRIVIAL_SOUNDNESS = TDB.find
    "PMATCH_ROWS_DROP_REDUNDANT_TRIVIAL_SOUNDNESS"
  fun op PMATCH_ROWS_DROP_REDUNDANT _ = ()
  val op PMATCH_ROWS_DROP_REDUNDANT = TDB.find "PMATCH_ROWS_DROP_REDUNDANT"
  fun op PMATCH_ROWS_DROP_REDUNDANT_PMATCH_ROWS _ = ()
  val op PMATCH_ROWS_DROP_REDUNDANT_PMATCH_ROWS = TDB.find
    "PMATCH_ROWS_DROP_REDUNDANT_PMATCH_ROWS"
  fun op PMATCH_ROWS_DROP_SUBSUMED _ = ()
  val op PMATCH_ROWS_DROP_SUBSUMED = TDB.find "PMATCH_ROWS_DROP_SUBSUMED"
  fun op PMATCH_ROWS_DROP_SUBSUMED_PMATCH_ROWS _ = ()
  val op PMATCH_ROWS_DROP_SUBSUMED_PMATCH_ROWS = TDB.find
    "PMATCH_ROWS_DROP_SUBSUMED_PMATCH_ROWS"
  fun op PMATCH_REMOVE_ARB _ = ()
  val op PMATCH_REMOVE_ARB = TDB.find "PMATCH_REMOVE_ARB"
  fun op PMATCH_INTRO_CATCHALL _ = ()
  val op PMATCH_INTRO_CATCHALL = TDB.find "PMATCH_INTRO_CATCHALL"
  fun op PMATCH_REMOVE_ARB_NO_OVERLAP _ = ()
  val op PMATCH_REMOVE_ARB_NO_OVERLAP = TDB.find
    "PMATCH_REMOVE_ARB_NO_OVERLAP"
  fun op PMATCH_ROW_REDUNDANT_NIL _ = ()
  val op PMATCH_ROW_REDUNDANT_NIL = TDB.find "PMATCH_ROW_REDUNDANT_NIL"
  fun op PMATCH_ROW_REDUNDANT_0 _ = ()
  val op PMATCH_ROW_REDUNDANT_0 = TDB.find "PMATCH_ROW_REDUNDANT_0"
  fun op PMATCH_ROW_REDUNDANT_SUC _ = ()
  val op PMATCH_ROW_REDUNDANT_SUC = TDB.find "PMATCH_ROW_REDUNDANT_SUC"
  fun op PMATCH_ROW_REDUNDANT_APPEND_LT _ = ()
  val op PMATCH_ROW_REDUNDANT_APPEND_LT = TDB.find
    "PMATCH_ROW_REDUNDANT_APPEND_LT"
  fun op PMATCH_ROW_REDUNDANT_APPEND_GE _ = ()
  val op PMATCH_ROW_REDUNDANT_APPEND_GE = TDB.find
    "PMATCH_ROW_REDUNDANT_APPEND_GE"
  fun op IS_REDUNDANT_ROWS_INFO_NIL _ = ()
  val op IS_REDUNDANT_ROWS_INFO_NIL = TDB.find "IS_REDUNDANT_ROWS_INFO_NIL"
  fun op IS_REDUNDANT_ROWS_INFO_SNOC _ = ()
  val op IS_REDUNDANT_ROWS_INFO_SNOC = TDB.find
    "IS_REDUNDANT_ROWS_INFO_SNOC"
  fun op IS_REDUNDANT_ROWS_INFO_SNOC_PMATCH_ROW _ = ()
  val op IS_REDUNDANT_ROWS_INFO_SNOC_PMATCH_ROW = TDB.find
    "IS_REDUNDANT_ROWS_INFO_SNOC_PMATCH_ROW"
  fun op IS_REDUNDANT_ROWS_INFO_CONS _ = ()
  val op IS_REDUNDANT_ROWS_INFO_CONS = TDB.find
    "IS_REDUNDANT_ROWS_INFO_CONS"
  fun op APPLY_REDUNDANT_ROWS_INFO_THMS _ = ()
  val op APPLY_REDUNDANT_ROWS_INFO_THMS = TDB.find
    "APPLY_REDUNDANT_ROWS_INFO_THMS"
  fun op PMATCH_ROWS_DROP_REDUNDANT_ROWS_INFO_EQUIV _ = ()
  val op PMATCH_ROWS_DROP_REDUNDANT_ROWS_INFO_EQUIV = TDB.find
    "PMATCH_ROWS_DROP_REDUNDANT_ROWS_INFO_EQUIV"
  fun op REDUNDANT_ROWS_INFO_TO_PMATCH_EQ _ = ()
  val op REDUNDANT_ROWS_INFO_TO_PMATCH_EQ = TDB.find
    "REDUNDANT_ROWS_INFO_TO_PMATCH_EQ"
  fun op PMATCH_IS_EXHAUSTIVE_REWRITES _ = ()
  val op PMATCH_IS_EXHAUSTIVE_REWRITES = TDB.find
    "PMATCH_IS_EXHAUSTIVE_REWRITES"
  fun op IS_REDUNDANT_ROWS_INFO_EXTRACT_IS_EXHAUSTIVE _ = ()
  val op IS_REDUNDANT_ROWS_INFO_EXTRACT_IS_EXHAUSTIVE = TDB.find
    "IS_REDUNDANT_ROWS_INFO_EXTRACT_IS_EXHAUSTIVE"
  fun op REDUNDANT_ROWS_INFOS_CONJ_REWRITE _ = ()
  val op REDUNDANT_ROWS_INFOS_CONJ_REWRITE = TDB.find
    "REDUNDANT_ROWS_INFOS_CONJ_REWRITE"
  fun op REDUNDANT_ROWS_INFOS_CONJ_THM _ = ()
  val op REDUNDANT_ROWS_INFOS_CONJ_THM = TDB.find
    "REDUNDANT_ROWS_INFOS_CONJ_THM"
  fun op REDUNDANT_ROWS_INFOS_DISJ_THM _ = ()
  val op REDUNDANT_ROWS_INFOS_DISJ_THM = TDB.find
    "REDUNDANT_ROWS_INFOS_DISJ_THM"
  fun op LENGTH_STRONGEST_REDUNDANT_ROWS_INFO_AUX _ = ()
  val op LENGTH_STRONGEST_REDUNDANT_ROWS_INFO_AUX = TDB.find
    "LENGTH_STRONGEST_REDUNDANT_ROWS_INFO_AUX"
  fun op FST_STRONGEST_REDUNDANT_ROWS_INFO_AUX _ = ()
  val op FST_STRONGEST_REDUNDANT_ROWS_INFO_AUX = TDB.find
    "FST_STRONGEST_REDUNDANT_ROWS_INFO_AUX"
  fun op EL_STRONGEST_REDUNDANT_ROWS_INFO _ = ()
  val op EL_STRONGEST_REDUNDANT_ROWS_INFO = TDB.find
    "EL_STRONGEST_REDUNDANT_ROWS_INFO"
  fun op STRONGEST_REDUNDANT_ROWS_INFO_OK _ = ()
  val op STRONGEST_REDUNDANT_ROWS_INFO_OK = TDB.find
    "STRONGEST_REDUNDANT_ROWS_INFO_OK"
  fun op PMATCH_ROW_COND_EX_FULL_DEF _ = ()
  val op PMATCH_ROW_COND_EX_FULL_DEF = TDB.find
    "PMATCH_ROW_COND_EX_FULL_DEF"
  fun op PMATCH_ROW_COND_EX_WEAKEN _ = ()
  val op PMATCH_ROW_COND_EX_WEAKEN = TDB.find "PMATCH_ROW_COND_EX_WEAKEN"
  fun op PMATCH_ROW_COND_EX_FALSE _ = ()
  val op PMATCH_ROW_COND_EX_FALSE = TDB.find "PMATCH_ROW_COND_EX_FALSE"
  fun op PMATCH_ROW_COND_EX_IMP_REWRITE _ = ()
  val op PMATCH_ROW_COND_EX_IMP_REWRITE = TDB.find
    "PMATCH_ROW_COND_EX_IMP_REWRITE"
  fun op PMATCH_IS_EXHAUSTIVE_CONTRADICT _ = ()
  val op PMATCH_IS_EXHAUSTIVE_CONTRADICT = TDB.find
    "PMATCH_IS_EXHAUSTIVE_CONTRADICT"
  fun op PMATCH_ROW_EVAL_COND_EX _ = ()
  val op PMATCH_ROW_EVAL_COND_EX = TDB.find "PMATCH_ROW_EVAL_COND_EX"
  fun op PMATCH_ROW_NEQ_NONE _ = ()
  val op PMATCH_ROW_NEQ_NONE = TDB.find "PMATCH_ROW_NEQ_NONE"
  fun op PMATCH_ROW_REMOVE_DOUBLE_BINDS_THM _ = ()
  val op PMATCH_ROW_REMOVE_DOUBLE_BINDS_THM = TDB.find
    "PMATCH_ROW_REMOVE_DOUBLE_BINDS_THM"
  fun op GUARDS_ELIM_THM _ = ()
  val op GUARDS_ELIM_THM = TDB.find "GUARDS_ELIM_THM"
  fun op PMATCH_FLATTEN_THM_SINGLE _ = ()
  val op PMATCH_FLATTEN_THM_SINGLE = TDB.find "PMATCH_FLATTEN_THM_SINGLE"
  fun op PMATCH_FLATTEN_THM _ = ()
  val op PMATCH_FLATTEN_THM = TDB.find "PMATCH_FLATTEN_THM"
  fun op PMATCH_FLATTEN_FUN_PMATCH_ROW _ = ()
  val op PMATCH_FLATTEN_FUN_PMATCH_ROW = TDB.find
    "PMATCH_FLATTEN_FUN_PMATCH_ROW"
  fun op PMATCH_ROW_COND_NOT_EX_OR_EQ_FIRST_ROW _ = ()
  val op PMATCH_ROW_COND_NOT_EX_OR_EQ_FIRST_ROW = TDB.find
    "PMATCH_ROW_COND_NOT_EX_OR_EQ_FIRST_ROW"
  fun op PMATCH_ROW_COND_NOT_EX_OR_EQ_NIL _ = ()
  val op PMATCH_ROW_COND_NOT_EX_OR_EQ_NIL = TDB.find
    "PMATCH_ROW_COND_NOT_EX_OR_EQ_NIL"
  fun op PMATCH_ROW_COND_NOT_EX_OR_EQ_NOT_FIRST_ROW _ = ()
  val op PMATCH_ROW_COND_NOT_EX_OR_EQ_NOT_FIRST_ROW = TDB.find
    "PMATCH_ROW_COND_NOT_EX_OR_EQ_NOT_FIRST_ROW"
  fun op PMATCH_PRED_UNROLL_NIL _ = ()
  val op PMATCH_PRED_UNROLL_NIL = TDB.find "PMATCH_PRED_UNROLL_NIL"
  fun op PMATCH_PRED_UNROLL_CONS _ = ()
  val op PMATCH_PRED_UNROLL_CONS = TDB.find "PMATCH_PRED_UNROLL_CONS"
  fun op PMATCH_EXPAND_PRED_THM_GEN _ = ()
  val op PMATCH_EXPAND_PRED_THM_GEN = TDB.find "PMATCH_EXPAND_PRED_THM_GEN"
  fun op PMATCH_EXPAND_PRED_THM _ = ()
  val op PMATCH_EXPAND_PRED_THM = TDB.find "PMATCH_EXPAND_PRED_THM"
  fun op PMATCH_LIFT_THM _ = ()
  val op PMATCH_LIFT_THM = TDB.find "PMATCH_LIFT_THM"
  fun op PMATCH_ROW_LIFT_THM _ = ()
  val op PMATCH_ROW_LIFT_THM = TDB.find "PMATCH_ROW_LIFT_THM"
  fun op PMATCH_IS_EXHAUSTIVE_LIFT _ = ()
  val op PMATCH_IS_EXHAUSTIVE_LIFT = TDB.find "PMATCH_IS_EXHAUSTIVE_LIFT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val patternMatches_grammars = merge_grammars ["rich_list",
  "quantHeuristics"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="patternMatches"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val patternMatches_grammars = 
    Portable.## (addtyUDs,addtmUDs) patternMatches_grammars
  val _ = Parse.grammarDB_insert("patternMatches",patternMatches_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "patternMatches"

end
