structure fixedPointTheory :> fixedPointTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading fixedPointTheory ... "
    else ()
  
  open Type Term Thm
  local open pred_setTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "fixedPoint"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/fixedPointTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op monotone_def _ = () val op monotone_def = TDB.find "monotone_def"
  fun op lfp_def _ = () val op lfp_def = TDB.find "lfp_def"
  fun op gfp_def _ = () val op gfp_def = TDB.find "gfp_def"
  fun op closed_def _ = () val op closed_def = TDB.find "closed_def"
  fun op dense_def _ = () val op dense_def = TDB.find "dense_def"
  fun op fnsum_def _ = () val op fnsum_def = TDB.find "fnsum_def"
  fun op empty_def _ = () val op empty_def = TDB.find "empty_def"
  fun op lfp_least_closed _ = ()
  val op lfp_least_closed = TDB.find "lfp_least_closed"
  fun op gfp_greatest_dense _ = ()
  val op gfp_greatest_dense = TDB.find "gfp_greatest_dense"
  fun op lfp_fixedpoint _ = ()
  val op lfp_fixedpoint = TDB.find "lfp_fixedpoint"
  fun op gfp_greatest_fixedpoint _ = ()
  val op gfp_greatest_fixedpoint = TDB.find "gfp_greatest_fixedpoint"
  fun op lfp_induction _ = ()
  val op lfp_induction = TDB.find "lfp_induction"
  fun op gfp_coinduction _ = ()
  val op gfp_coinduction = TDB.find "gfp_coinduction"
  fun op lfp_strong_induction _ = ()
  val op lfp_strong_induction = TDB.find "lfp_strong_induction"
  fun op gfp_strong_coinduction _ = ()
  val op gfp_strong_coinduction = TDB.find "gfp_strong_coinduction"
  fun op fnsum_monotone _ = ()
  val op fnsum_monotone = TDB.find "fnsum_monotone"
  fun op empty_monotone _ = ()
  val op empty_monotone = TDB.find "empty_monotone"
  fun op fnsum_empty _ = () val op fnsum_empty = TDB.find "fnsum_empty"
  fun op fnsum_ASSOC _ = () val op fnsum_ASSOC = TDB.find "fnsum_ASSOC"
  fun op fnsum_COMM _ = () val op fnsum_COMM = TDB.find "fnsum_COMM"
  fun op fnsum_SUBSET _ = () val op fnsum_SUBSET = TDB.find "fnsum_SUBSET"
  fun op lfp_fnsum _ = () val op lfp_fnsum = TDB.find "lfp_fnsum"
  fun op lfp_rule_applied _ = ()
  val op lfp_rule_applied = TDB.find "lfp_rule_applied"
  fun op lfp_empty _ = () val op lfp_empty = TDB.find "lfp_empty"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val fixedPoint_grammars = merge_grammars ["pred_set"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="fixedPoint"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val fixedPoint_grammars = 
    Portable.## (addtyUDs,addtmUDs) fixedPoint_grammars
  val _ = Parse.grammarDB_insert("fixedPoint",fixedPoint_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "fixedPoint"

end
