structure gcdsetTheory :> gcdsetTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading gcdsetTheory ... "
    else ()
  
  open Type Term Thm
  local open gcdTheory pred_setTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "gcdset"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/gcdsetTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op gcdset_def _ = () val op gcdset_def = TDB.find "gcdset_def"
  fun op gcdset_divides _ = ()
  val op gcdset_divides = TDB.find "gcdset_divides"
  fun op gcdset_greatest _ = ()
  val op gcdset_greatest = TDB.find "gcdset_greatest"
  fun op gcdset_EMPTY _ = () val op gcdset_EMPTY = TDB.find "gcdset_EMPTY"
  fun op gcdset_INSERT _ = ()
  val op gcdset_INSERT = TDB.find "gcdset_INSERT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val gcdset_grammars = merge_grammars ["pred_set", "gcd"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="gcdset"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val gcdset_grammars = 
    Portable.## (addtyUDs,addtmUDs) gcdset_grammars
  val _ = Parse.grammarDB_insert("gcdset",gcdset_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "gcdset"

end
