structure cardinalTheory :> cardinalTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading cardinalTheory ... "
    else ()
  
  open Type Term Thm
  local open quotientTheory wellorderTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "cardinal"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/more_theories/cardinalTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op cardleq_def _ = () val op cardleq_def = TDB.find "cardleq_def"
  fun op cardeq_def _ = () val op cardeq_def = TDB.find "cardeq_def"
  fun op HAS_SIZE _ = () val op HAS_SIZE = TDB.find "HAS_SIZE"
  fun op list_def _ = () val op list_def = TDB.find "list_def"
  fun op bijns_def _ = () val op bijns_def = TDB.find "bijns_def"
  fun op cardgeq_def _ = () val op cardgeq_def = TDB.find "cardgeq_def"
  fun op cardgt_def _ = () val op cardgt_def = TDB.find "cardgt_def"
  fun op add_c _ = () val op add_c = TDB.find "add_c"
  fun op set_exp_def _ = () val op set_exp_def = TDB.find "set_exp_def"
  fun op CARD_MUL_LT_LEMMA _ = ()
  val op CARD_MUL_LT_LEMMA = TDB.find "CARD_MUL_LT_LEMMA"
  fun op CARD_LT_ADD _ = () val op CARD_LT_ADD = TDB.find "CARD_LT_ADD"
  fun op CARD_ADD2_ABSORB_LT _ = ()
  val op CARD_ADD2_ABSORB_LT = TDB.find "CARD_ADD2_ABSORB_LT"
  fun op CARD_ADD_ABSORB _ = ()
  val op CARD_ADD_ABSORB = TDB.find "CARD_ADD_ABSORB"
  fun op CARD_MUL_ABSORB _ = ()
  val op CARD_MUL_ABSORB = TDB.find "CARD_MUL_ABSORB"
  fun op CARD_ADD2_ABSORB_LE _ = ()
  val op CARD_ADD2_ABSORB_LE = TDB.find "CARD_ADD2_ABSORB_LE"
  fun op CARD_ADD_ABSORB_LE _ = ()
  val op CARD_ADD_ABSORB_LE = TDB.find "CARD_ADD_ABSORB_LE"
  fun op CARD_MUL2_ABSORB_LE _ = ()
  val op CARD_MUL2_ABSORB_LE = TDB.find "CARD_MUL2_ABSORB_LE"
  fun op CARD_MUL_ABSORB_LE _ = ()
  val op CARD_MUL_ABSORB_LE = TDB.find "CARD_MUL_ABSORB_LE"
  fun op CARD_BIGUNION _ = ()
  val op CARD_BIGUNION = TDB.find "CARD_BIGUNION"
  fun op SET_SUM_CARDEQ_SET _ = ()
  val op SET_SUM_CARDEQ_SET = TDB.find "SET_SUM_CARDEQ_SET"
  fun op SET_SQUARED_CARDEQ_SET _ = ()
  val op SET_SQUARED_CARDEQ_SET = TDB.find "SET_SQUARED_CARDEQ_SET"
  fun op set_binomial2 _ = ()
  val op set_binomial2 = TDB.find "set_binomial2"
  fun op cardleq_empty _ = ()
  val op cardleq_empty = TDB.find "cardleq_empty"
  fun op cardleq_lt_trans _ = ()
  val op cardleq_lt_trans = TDB.find "cardleq_lt_trans"
  fun op cardlt_leq_trans _ = ()
  val op cardlt_leq_trans = TDB.find "cardlt_leq_trans"
  fun op cardlt_TRANS _ = () val op cardlt_TRANS = TDB.find "cardlt_TRANS"
  fun op cardlt_lenoteq _ = ()
  val op cardlt_lenoteq = TDB.find "cardlt_lenoteq"
  fun op cardlt_REFL _ = () val op cardlt_REFL = TDB.find "cardlt_REFL"
  fun op cardleq_lteq _ = () val op cardleq_lteq = TDB.find "cardleq_lteq"
  fun op cardleq_dichotomy _ = ()
  val op cardleq_dichotomy = TDB.find "cardleq_dichotomy"
  fun op countable_cardeq _ = ()
  val op countable_cardeq = TDB.find "countable_cardeq"
  fun op countable_thm _ = ()
  val op countable_thm = TDB.find "countable_thm"
  fun op IMAGE_cardleq_rwt _ = ()
  val op IMAGE_cardleq_rwt = TDB.find "IMAGE_cardleq_rwt"
  fun op SUBSET_CARDLEQ _ = ()
  val op SUBSET_CARDLEQ = TDB.find "SUBSET_CARDLEQ"
  fun op CARDLEQ_CROSS_CONG _ = ()
  val op CARDLEQ_CROSS_CONG = TDB.find "CARDLEQ_CROSS_CONG"
  fun op IMAGE_cardleq _ = ()
  val op IMAGE_cardleq = TDB.find "IMAGE_cardleq"
  fun op INFINITE_UNIV_INF _ = ()
  val op INFINITE_UNIV_INF = TDB.find "INFINITE_UNIV_INF"
  fun op CARDLEQ_FINITE _ = ()
  val op CARDLEQ_FINITE = TDB.find "CARDLEQ_FINITE"
  fun op CARDEQ_CARDLEQ _ = ()
  val op CARDEQ_CARDLEQ = TDB.find "CARDEQ_CARDLEQ"
  fun op CARDEQ_SUBSET_CARDLEQ _ = ()
  val op CARDEQ_SUBSET_CARDLEQ = TDB.find "CARDEQ_SUBSET_CARDLEQ"
  fun op CARDEQ_CROSS_SYM _ = ()
  val op CARDEQ_CROSS_SYM = TDB.find "CARDEQ_CROSS_SYM"
  fun op CARDEQ_CROSS _ = () val op CARDEQ_CROSS = TDB.find "CARDEQ_CROSS"
  fun op FINITE_CLE_INFINITE _ = ()
  val op FINITE_CLE_INFINITE = TDB.find "FINITE_CLE_INFINITE"
  fun op EMPTY_CARDLEQ _ = ()
  val op EMPTY_CARDLEQ = TDB.find "EMPTY_CARDLEQ"
  fun op CARDEQ_INSERT_RWT _ = ()
  val op CARDEQ_INSERT_RWT = TDB.find "CARDEQ_INSERT_RWT"
  fun op cardeq_INSERT _ = ()
  val op cardeq_INSERT = TDB.find "cardeq_INSERT"
  fun op CARDEQ_0 _ = () val op CARDEQ_0 = TDB.find "CARDEQ_0"
  fun op CARDEQ_CARD _ = () val op CARDEQ_CARD = TDB.find "CARDEQ_CARD"
  fun op CARDEQ_FINITE _ = ()
  val op CARDEQ_FINITE = TDB.find "CARDEQ_FINITE"
  fun op cardleq_ANTISYM _ = ()
  val op cardleq_ANTISYM = TDB.find "cardleq_ANTISYM"
  fun op cardleq_TRANS _ = ()
  val op cardleq_TRANS = TDB.find "cardleq_TRANS"
  fun op cardleq_REFL _ = () val op cardleq_REFL = TDB.find "cardleq_REFL"
  fun op cardeq_TRANS _ = () val op cardeq_TRANS = TDB.find "cardeq_TRANS"
  fun op cardeq_SYM _ = () val op cardeq_SYM = TDB.find "cardeq_SYM"
  fun op cardeq_REFL _ = () val op cardeq_REFL = TDB.find "cardeq_REFL"
  fun op SURJECTIVE_ON_RIGHT_INVERSE _ = ()
  val op SURJECTIVE_ON_RIGHT_INVERSE = TDB.find
    "SURJECTIVE_ON_RIGHT_INVERSE"
  fun op SURJECTIVE_RIGHT_INVERSE _ = ()
  val op SURJECTIVE_RIGHT_INVERSE = TDB.find "SURJECTIVE_RIGHT_INVERSE"
  fun op FINITE_IMAGE_INJ_GENERAL _ = ()
  val op FINITE_IMAGE_INJ_GENERAL = TDB.find "FINITE_IMAGE_INJ_GENERAL"
  fun op FINITE_IMAGE_INJ _ = ()
  val op FINITE_IMAGE_INJ = TDB.find "FINITE_IMAGE_INJ"
  fun op FINITE_IMAGE_INJ_EQ _ = ()
  val op FINITE_IMAGE_INJ_EQ = TDB.find "FINITE_IMAGE_INJ_EQ"
  fun op INFINITE_IMAGE_INJ _ = ()
  val op INFINITE_IMAGE_INJ = TDB.find "INFINITE_IMAGE_INJ"
  fun op INFINITE_NONEMPTY _ = ()
  val op INFINITE_NONEMPTY = TDB.find "INFINITE_NONEMPTY"
  fun op FINITE_PRODUCT_DEPENDENT _ = ()
  val op FINITE_PRODUCT_DEPENDENT = TDB.find "FINITE_PRODUCT_DEPENDENT"
  fun op FINITE_PRODUCT _ = ()
  val op FINITE_PRODUCT = TDB.find "FINITE_PRODUCT"
  fun op SURJECTIVE_IMAGE_THM _ = ()
  val op SURJECTIVE_IMAGE_THM = TDB.find "SURJECTIVE_IMAGE_THM"
  fun op SURJECTIVE_ON_IMAGE _ = ()
  val op SURJECTIVE_ON_IMAGE = TDB.find "SURJECTIVE_ON_IMAGE"
  fun op SURJECTIVE_IMAGE _ = ()
  val op SURJECTIVE_IMAGE = TDB.find "SURJECTIVE_IMAGE"
  fun op CARD_LE_INJ _ = () val op CARD_LE_INJ = TDB.find "CARD_LE_INJ"
  fun op CARD_IMAGE_INJ _ = ()
  val op CARD_IMAGE_INJ = TDB.find "CARD_IMAGE_INJ"
  fun op CARD_IMAGE_LE _ = ()
  val op CARD_IMAGE_LE = TDB.find "CARD_IMAGE_LE"
  fun op SURJECTIVE_IFF_INJECTIVE_GEN _ = ()
  val op SURJECTIVE_IFF_INJECTIVE_GEN = TDB.find
    "SURJECTIVE_IFF_INJECTIVE_GEN"
  fun op SURJECTIVE_IFF_INJECTIVE _ = ()
  val op SURJECTIVE_IFF_INJECTIVE = TDB.find "SURJECTIVE_IFF_INJECTIVE"
  fun op CARD_EQ_BIJECTION _ = ()
  val op CARD_EQ_BIJECTION = TDB.find "CARD_EQ_BIJECTION"
  fun op CARD_EQ_BIJECTIONS _ = ()
  val op CARD_EQ_BIJECTIONS = TDB.find "CARD_EQ_BIJECTIONS"
  fun op SING_SUBSET _ = () val op SING_SUBSET = TDB.find "SING_SUBSET"
  fun op INJECTIVE_ON_IMAGE _ = ()
  val op INJECTIVE_ON_IMAGE = TDB.find "INJECTIVE_ON_IMAGE"
  fun op INJECTIVE_IMAGE _ = ()
  val op INJECTIVE_IMAGE = TDB.find "INJECTIVE_IMAGE"
  fun op FINITE_FINITE_BIGUNION _ = ()
  val op FINITE_FINITE_BIGUNION = TDB.find "FINITE_FINITE_BIGUNION"
  fun op num_FINITE _ = () val op num_FINITE = TDB.find "num_FINITE"
  fun op num_FINITE_AVOID _ = ()
  val op num_FINITE_AVOID = TDB.find "num_FINITE_AVOID"
  fun op num_INFINITE _ = () val op num_INFINITE = TDB.find "num_INFINITE"
  fun op HAS_SIZE_CARD _ = ()
  val op HAS_SIZE_CARD = TDB.find "HAS_SIZE_CARD"
  fun op HAS_SIZE_0 _ = () val op HAS_SIZE_0 = TDB.find "HAS_SIZE_0"
  fun op HAS_SIZE_SUC _ = () val op HAS_SIZE_SUC = TDB.find "HAS_SIZE_SUC"
  fun op FINITE_HAS_SIZE _ = ()
  val op FINITE_HAS_SIZE = TDB.find "FINITE_HAS_SIZE"
  fun op HAS_SIZE_CLAUSES _ = ()
  val op HAS_SIZE_CLAUSES = TDB.find "HAS_SIZE_CLAUSES"
  fun op CARD_SUBSET_EQ _ = ()
  val op CARD_SUBSET_EQ = TDB.find "CARD_SUBSET_EQ"
  fun op HAS_SIZE_INDEX _ = ()
  val op HAS_SIZE_INDEX = TDB.find "HAS_SIZE_INDEX"
  fun op CARD_BIGUNION_LE _ = ()
  val op CARD_BIGUNION_LE = TDB.find "CARD_BIGUNION_LE"
  fun op HAS_SIZE_BOOL _ = ()
  val op HAS_SIZE_BOOL = TDB.find "HAS_SIZE_BOOL"
  fun op CARD_BOOL _ = () val op CARD_BOOL = TDB.find "CARD_BOOL"
  fun op FINITE_BOOL _ = () val op FINITE_BOOL = TDB.find "FINITE_BOOL"
  fun op HAS_SIZE_CART_UNIV _ = ()
  val op HAS_SIZE_CART_UNIV = TDB.find "HAS_SIZE_CART_UNIV"
  fun op CARD_CART_UNIV _ = ()
  val op CARD_CART_UNIV = TDB.find "CARD_CART_UNIV"
  fun op FINITE_CART_UNIV _ = ()
  val op FINITE_CART_UNIV = TDB.find "FINITE_CART_UNIV"
  fun op HAS_SIZE_NUMSEG_LT _ = ()
  val op HAS_SIZE_NUMSEG_LT = TDB.find "HAS_SIZE_NUMSEG_LT"
  fun op FINITE_NUMSEG_LT _ = ()
  val op FINITE_NUMSEG_LT = TDB.find "FINITE_NUMSEG_LT"
  fun op HAS_SIZE_NUMSEG_LE _ = ()
  val op HAS_SIZE_NUMSEG_LE = TDB.find "HAS_SIZE_NUMSEG_LE"
  fun op FINITE_NUMSEG_LE _ = ()
  val op FINITE_NUMSEG_LE = TDB.find "FINITE_NUMSEG_LE"
  fun op INFINITE_DIFF_FINITE _ = ()
  val op INFINITE_DIFF_FINITE = TDB.find "INFINITE_DIFF_FINITE"
  fun op LE_CASES _ = () val op LE_CASES = TDB.find "LE_CASES"
  fun op LT_CASES _ = () val op LT_CASES = TDB.find "LT_CASES"
  fun op LT _ = () val op LT = TDB.find "LT"
  fun op LT_LE _ = () val op LT_LE = TDB.find "LT_LE"
  fun op GE _ = () val op GE = TDB.find "GE"
  fun op LE_SUC_LT _ = () val op LE_SUC_LT = TDB.find "LE_SUC_LT"
  fun op EMPTY_set_exp _ = ()
  val op EMPTY_set_exp = TDB.find "EMPTY_set_exp"
  fun op EMPTY_set_exp_CARD _ = ()
  val op EMPTY_set_exp_CARD = TDB.find "EMPTY_set_exp_CARD"
  fun op SING_set_exp _ = () val op SING_set_exp = TDB.find "SING_set_exp"
  fun op SING_set_exp_CARD _ = ()
  val op SING_set_exp_CARD = TDB.find "SING_set_exp_CARD"
  fun op POW_TWO_set_exp _ = ()
  val op POW_TWO_set_exp = TDB.find "POW_TWO_set_exp"
  fun op set_exp_count _ = ()
  val op set_exp_count = TDB.find "set_exp_count"
  fun op set_exp_card_cong _ = ()
  val op set_exp_card_cong = TDB.find "set_exp_card_cong"
  fun op set_exp_cardle_cong _ = ()
  val op set_exp_cardle_cong = TDB.find "set_exp_cardle_cong"
  fun op exp_INSERT_cardeq _ = ()
  val op exp_INSERT_cardeq = TDB.find "exp_INSERT_cardeq"
  fun op exp_count_cardeq _ = ()
  val op exp_count_cardeq = TDB.find "exp_count_cardeq"
  fun op INFINITE_Unum _ = ()
  val op INFINITE_Unum = TDB.find "INFINITE_Unum"
  fun op cardleq_SURJ _ = () val op cardleq_SURJ = TDB.find "cardleq_SURJ"
  fun op INFINITE_cardleq_INSERT _ = ()
  val op INFINITE_cardleq_INSERT = TDB.find "INFINITE_cardleq_INSERT"
  fun op list_EMPTY _ = () val op list_EMPTY = TDB.find "list_EMPTY"
  fun op list_SING _ = () val op list_SING = TDB.find "list_SING"
  fun op UNIV_list _ = () val op UNIV_list = TDB.find "UNIV_list"
  fun op list_BIGUNION_EXP _ = ()
  val op list_BIGUNION_EXP = TDB.find "list_BIGUNION_EXP"
  fun op INFINITE_A_list_BIJ_A _ = ()
  val op INFINITE_A_list_BIJ_A = TDB.find "INFINITE_A_list_BIJ_A"
  fun op finite_subsets_bijection _ = ()
  val op finite_subsets_bijection = TDB.find "finite_subsets_bijection"
  fun op FINITE_IMAGE_INJ' _ = ()
  val op FINITE_IMAGE_INJ' = TDB.find "FINITE_IMAGE_INJ'"
  fun op countable_decomposition _ = ()
  val op countable_decomposition = TDB.find "countable_decomposition"
  fun op disjoint_countable_decomposition _ = ()
  val op disjoint_countable_decomposition = TDB.find
    "disjoint_countable_decomposition"
  fun op count_cardle _ = () val op count_cardle = TDB.find "count_cardle"
  fun op CANTOR _ = () val op CANTOR = TDB.find "CANTOR"
  fun op cardlt_cardle _ = ()
  val op cardlt_cardle = TDB.find "cardlt_cardle"
  fun op set_exp_product _ = ()
  val op set_exp_product = TDB.find "set_exp_product"
  fun op COUNT_EQ_EMPTY _ = ()
  val op COUNT_EQ_EMPTY = TDB.find "COUNT_EQ_EMPTY"
  fun op POW_EQ_X_EXP_X _ = ()
  val op POW_EQ_X_EXP_X = TDB.find "POW_EQ_X_EXP_X"
  fun op cardeq_bijns_cong _ = ()
  val op cardeq_bijns_cong = TDB.find "cardeq_bijns_cong"
  fun op bijections_cardeq _ = ()
  val op bijections_cardeq = TDB.find "bijections_cardeq"
  fun op LEFT_IMP_EXISTS_THM _ = ()
  val op LEFT_IMP_EXISTS_THM = TDB.find "LEFT_IMP_EXISTS_THM"
  fun op LEFT_IMP_FORALL_THM _ = ()
  val op LEFT_IMP_FORALL_THM = TDB.find "LEFT_IMP_FORALL_THM"
  fun op RIGHT_IMP_EXISTS_THM _ = ()
  val op RIGHT_IMP_EXISTS_THM = TDB.find "RIGHT_IMP_EXISTS_THM"
  fun op RIGHT_IMP_FORALL_THM _ = ()
  val op RIGHT_IMP_FORALL_THM = TDB.find "RIGHT_IMP_FORALL_THM"
  fun op FINITE_FINITE_BIGUNIONS _ = ()
  val op FINITE_FINITE_BIGUNIONS = TDB.find "FINITE_FINITE_BIGUNIONS"
  fun op CONJ_EQ_IMP _ = () val op CONJ_EQ_IMP = TDB.find "CONJ_EQ_IMP"
  fun op IMP_CONJ_ALT _ = () val op IMP_CONJ_ALT = TDB.find "IMP_CONJ_ALT"
  fun op LT_SUC_LE _ = () val op LT_SUC_LE = TDB.find "LT_SUC_LE"
  fun op INJECTIVE_ON_LEFT_INVERSE _ = ()
  val op INJECTIVE_ON_LEFT_INVERSE = TDB.find "INJECTIVE_ON_LEFT_INVERSE"
  fun op INJECTIVE_LEFT_INVERSE _ = ()
  val op INJECTIVE_LEFT_INVERSE = TDB.find "INJECTIVE_LEFT_INVERSE"
  fun op INTER_ACI _ = () val op INTER_ACI = TDB.find "INTER_ACI"
  fun op CONJ_ACI _ = () val op CONJ_ACI = TDB.find "CONJ_ACI"
  fun op UNION_ACI _ = () val op UNION_ACI = TDB.find "UNION_ACI"
  fun op LT_NZ _ = () val op LT_NZ = TDB.find "LT_NZ"
  fun op LE_1 _ = () val op LE_1 = TDB.find "LE_1"
  fun op OR_EXISTS_THM _ = ()
  val op OR_EXISTS_THM = TDB.find "OR_EXISTS_THM"
  fun op BIJECTIVE_INJECTIVE_SURJECTIVE _ = ()
  val op BIJECTIVE_INJECTIVE_SURJECTIVE = TDB.find
    "BIJECTIVE_INJECTIVE_SURJECTIVE"
  fun op BIJECTIVE_INVERSES _ = ()
  val op BIJECTIVE_INVERSES = TDB.find "BIJECTIVE_INVERSES"
  fun op le_c _ = () val op le_c = TDB.find "le_c"
  fun op lt_c _ = () val op lt_c = TDB.find "lt_c"
  fun op eq_c _ = () val op eq_c = TDB.find "eq_c"
  fun op ge_c _ = () val op ge_c = TDB.find "ge_c"
  fun op gt_c _ = () val op gt_c = TDB.find "gt_c"
  fun op LE_C _ = () val op LE_C = TDB.find "LE_C"
  fun op GE_C _ = () val op GE_C = TDB.find "GE_C"
  fun op COUNTABLE _ = () val op COUNTABLE = TDB.find "COUNTABLE"
  fun op EQ_C _ = () val op EQ_C = TDB.find "EQ_C"
  fun op CARD_LE_REFL _ = () val op CARD_LE_REFL = TDB.find "CARD_LE_REFL"
  fun op CARD_LE_TRANS _ = ()
  val op CARD_LE_TRANS = TDB.find "CARD_LE_TRANS"
  fun op CARD_LT_REFL _ = () val op CARD_LT_REFL = TDB.find "CARD_LT_REFL"
  fun op CARD_LET_TRANS _ = ()
  val op CARD_LET_TRANS = TDB.find "CARD_LET_TRANS"
  fun op CARD_LTE_TRANS _ = ()
  val op CARD_LTE_TRANS = TDB.find "CARD_LTE_TRANS"
  fun op CARD_LT_TRANS _ = ()
  val op CARD_LT_TRANS = TDB.find "CARD_LT_TRANS"
  fun op CARD_EQ_REFL _ = () val op CARD_EQ_REFL = TDB.find "CARD_EQ_REFL"
  fun op CARD_EQ_SYM _ = () val op CARD_EQ_SYM = TDB.find "CARD_EQ_SYM"
  fun op CARD_EQ_IMP_LE _ = ()
  val op CARD_EQ_IMP_LE = TDB.find "CARD_EQ_IMP_LE"
  fun op CARD_LT_IMP_LE _ = ()
  val op CARD_LT_IMP_LE = TDB.find "CARD_LT_IMP_LE"
  fun op CARD_LE_RELATIONAL _ = ()
  val op CARD_LE_RELATIONAL = TDB.find "CARD_LE_RELATIONAL"
  fun op CARD_LE_EMPTY _ = ()
  val op CARD_LE_EMPTY = TDB.find "CARD_LE_EMPTY"
  fun op CARD_EQ_EMPTY _ = ()
  val op CARD_EQ_EMPTY = TDB.find "CARD_EQ_EMPTY"
  fun op CARD_LE_ANTISYM _ = ()
  val op CARD_LE_ANTISYM = TDB.find "CARD_LE_ANTISYM"
  fun op CARD_LE_TOTAL _ = ()
  val op CARD_LE_TOTAL = TDB.find "CARD_LE_TOTAL"
  fun op CARD_LET_TOTAL _ = ()
  val op CARD_LET_TOTAL = TDB.find "CARD_LET_TOTAL"
  fun op CARD_LTE_TOTAL _ = ()
  val op CARD_LTE_TOTAL = TDB.find "CARD_LTE_TOTAL"
  fun op CARD_LT_TOTAL _ = ()
  val op CARD_LT_TOTAL = TDB.find "CARD_LT_TOTAL"
  fun op CARD_NOT_LE _ = () val op CARD_NOT_LE = TDB.find "CARD_NOT_LE"
  fun op CARD_NOT_LT _ = () val op CARD_NOT_LT = TDB.find "CARD_NOT_LT"
  fun op CARD_LT_LE _ = () val op CARD_LT_LE = TDB.find "CARD_LT_LE"
  fun op CARD_LE_LT _ = () val op CARD_LE_LT = TDB.find "CARD_LE_LT"
  fun op CARD_LE_CONG _ = () val op CARD_LE_CONG = TDB.find "CARD_LE_CONG"
  fun op CARD_LT_CONG _ = () val op CARD_LT_CONG = TDB.find "CARD_LT_CONG"
  fun op CARD_EQ_TRANS _ = ()
  val op CARD_EQ_TRANS = TDB.find "CARD_EQ_TRANS"
  fun op CARD_EQ_CONG _ = () val op CARD_EQ_CONG = TDB.find "CARD_EQ_CONG"
  fun op INFINITE_CARD_LE _ = ()
  val op INFINITE_CARD_LE = TDB.find "INFINITE_CARD_LE"
  fun op FINITE_CARD_LT _ = ()
  val op FINITE_CARD_LT = TDB.find "FINITE_CARD_LT"
  fun op CARD_LE_SUBSET _ = ()
  val op CARD_LE_SUBSET = TDB.find "CARD_LE_SUBSET"
  fun op CARD_LE_UNIV _ = () val op CARD_LE_UNIV = TDB.find "CARD_LE_UNIV"
  fun op CARD_LE_EQ_SUBSET _ = ()
  val op CARD_LE_EQ_SUBSET = TDB.find "CARD_LE_EQ_SUBSET"
  fun op CARD_INFINITE_CONG _ = ()
  val op CARD_INFINITE_CONG = TDB.find "CARD_INFINITE_CONG"
  fun op CARD_FINITE_CONG _ = ()
  val op CARD_FINITE_CONG = TDB.find "CARD_FINITE_CONG"
  fun op CARD_LE_FINITE _ = ()
  val op CARD_LE_FINITE = TDB.find "CARD_LE_FINITE"
  fun op CARD_EQ_FINITE _ = ()
  val op CARD_EQ_FINITE = TDB.find "CARD_EQ_FINITE"
  fun op CARD_LE_INFINITE _ = ()
  val op CARD_LE_INFINITE = TDB.find "CARD_LE_INFINITE"
  fun op CARD_LT_FINITE_INFINITE _ = ()
  val op CARD_LT_FINITE_INFINITE = TDB.find "CARD_LT_FINITE_INFINITE"
  fun op CARD_LE_CARD_IMP _ = ()
  val op CARD_LE_CARD_IMP = TDB.find "CARD_LE_CARD_IMP"
  fun op CARD_EQ_CARD_IMP _ = ()
  val op CARD_EQ_CARD_IMP = TDB.find "CARD_EQ_CARD_IMP"
  fun op CARD_LE_CARD _ = () val op CARD_LE_CARD = TDB.find "CARD_LE_CARD"
  fun op CARD_EQ_CARD _ = () val op CARD_EQ_CARD = TDB.find "CARD_EQ_CARD"
  fun op CARD_ADD_C _ = () val op CARD_ADD_C = TDB.find "CARD_ADD_C"
  fun op CARD_ADD_SYM _ = () val op CARD_ADD_SYM = TDB.find "CARD_ADD_SYM"
  fun op CARD_ADD_ASSOC _ = ()
  val op CARD_ADD_ASSOC = TDB.find "CARD_ADD_ASSOC"
  fun op CARD_MUL_SYM _ = () val op CARD_MUL_SYM = TDB.find "CARD_MUL_SYM"
  fun op CARD_MUL_ASSOC _ = ()
  val op CARD_MUL_ASSOC = TDB.find "CARD_MUL_ASSOC"
  fun op CARD_LDISTRIB _ = ()
  val op CARD_LDISTRIB = TDB.find "CARD_LDISTRIB"
  fun op CARD_RDISTRIB _ = ()
  val op CARD_RDISTRIB = TDB.find "CARD_RDISTRIB"
  fun op CARD_LE_ADDR _ = () val op CARD_LE_ADDR = TDB.find "CARD_LE_ADDR"
  fun op CARD_LE_ADDL _ = () val op CARD_LE_ADDL = TDB.find "CARD_LE_ADDL"
  fun op CARD_ADD_LE_MUL_INFINITE _ = ()
  val op CARD_ADD_LE_MUL_INFINITE = TDB.find "CARD_ADD_LE_MUL_INFINITE"
  fun op CARD_MUL_FINITE _ = ()
  val op CARD_MUL_FINITE = TDB.find "CARD_MUL_FINITE"
  fun op CARD_ADD_FINITE_EQ _ = ()
  val op CARD_ADD_FINITE_EQ = TDB.find "CARD_ADD_FINITE_EQ"
  fun op CARD_ADD_FINITE _ = ()
  val op CARD_ADD_FINITE = TDB.find "CARD_ADD_FINITE"
  fun op CARD_SQUARE_INFINITE _ = ()
  val op CARD_SQUARE_INFINITE = TDB.find "CARD_SQUARE_INFINITE"
  fun op CARD_DISJOINT_UNION _ = ()
  val op CARD_DISJOINT_UNION = TDB.find "CARD_DISJOINT_UNION"
  fun op UNION_LE_ADD_C _ = ()
  val op UNION_LE_ADD_C = TDB.find "UNION_LE_ADD_C"
  fun op CARD_SQUARE_NUM _ = ()
  val op CARD_SQUARE_NUM = TDB.find "CARD_SQUARE_NUM"
  fun op CARD_LE_SQUARE _ = ()
  val op CARD_LE_SQUARE = TDB.find "CARD_LE_SQUARE"
  fun op IN_CARD_MUL _ = () val op IN_CARD_MUL = TDB.find "IN_CARD_MUL"
  fun op IN_CARD_ADD _ = () val op IN_CARD_ADD = TDB.find "IN_CARD_ADD"
  fun op CARD_MUL_CONG _ = ()
  val op CARD_MUL_CONG = TDB.find "CARD_MUL_CONG"
  fun op CARD_ADD_CONG _ = ()
  val op CARD_ADD_CONG = TDB.find "CARD_ADD_CONG"
  fun op CARD_LE_MUL _ = () val op CARD_LE_MUL = TDB.find "CARD_LE_MUL"
  fun op CARD_LE_ADD _ = () val op CARD_LE_ADD = TDB.find "CARD_LE_ADD"
  fun op mul_c _ = () val op mul_c = TDB.find "mul_c"
  fun op CARD_EQ_IMAGE _ = ()
  val op CARD_EQ_IMAGE = TDB.find "CARD_EQ_IMAGE"
  fun op CARD_LE_IMAGE_GEN _ = ()
  val op CARD_LE_IMAGE_GEN = TDB.find "CARD_LE_IMAGE_GEN"
  fun op CARD_LE_IMAGE _ = ()
  val op CARD_LE_IMAGE = TDB.find "CARD_LE_IMAGE"
  fun op CARD_HAS_SIZE_CONG _ = ()
  val op CARD_HAS_SIZE_CONG = TDB.find "CARD_HAS_SIZE_CONG"
  fun op CARD_LT_CARD _ = () val op CARD_LT_CARD = TDB.find "CARD_LT_CARD"
  fun op CARDLEQ_CARD _ = () val op CARDLEQ_CARD = TDB.find "CARDLEQ_CARD"
  fun op CARDEQ_CARD_EQN _ = ()
  val op CARDEQ_CARD_EQN = TDB.find "CARDEQ_CARD_EQN"
  fun op CARD_CARDEQ_I _ = ()
  val op CARD_CARDEQ_I = TDB.find "CARD_CARDEQ_I"
  fun op BIJ_functions_agree _ = ()
  val op BIJ_functions_agree = TDB.find "BIJ_functions_agree"
  fun op CARD_MUL_LT_INFINITE _ = ()
  val op CARD_MUL_LT_INFINITE = TDB.find "CARD_MUL_LT_INFINITE"
  fun op CANTOR_THM _ = () val op CANTOR_THM = TDB.find "CANTOR_THM"
  fun op CANTOR_THM_UNIV _ = ()
  val op CANTOR_THM_UNIV = TDB.find "CANTOR_THM_UNIV"
  fun op NUM_COUNTABLE _ = ()
  val op NUM_COUNTABLE = TDB.find "NUM_COUNTABLE"
  fun op COUNTABLE_ALT_cardleq _ = ()
  val op COUNTABLE_ALT_cardleq = TDB.find "COUNTABLE_ALT_cardleq"
  fun op COUNTABLE_CASES _ = ()
  val op COUNTABLE_CASES = TDB.find "COUNTABLE_CASES"
  fun op CARD_LE_COUNTABLE _ = ()
  val op CARD_LE_COUNTABLE = TDB.find "CARD_LE_COUNTABLE"
  fun op CARD_EQ_COUNTABLE _ = ()
  val op CARD_EQ_COUNTABLE = TDB.find "CARD_EQ_COUNTABLE"
  fun op CARD_COUNTABLE_CONG _ = ()
  val op CARD_COUNTABLE_CONG = TDB.find "CARD_COUNTABLE_CONG"
  fun op COUNTABLE_RESTRICT _ = ()
  val op COUNTABLE_RESTRICT = TDB.find "COUNTABLE_RESTRICT"
  fun op FINITE_IMP_COUNTABLE _ = ()
  val op FINITE_IMP_COUNTABLE = TDB.find "FINITE_IMP_COUNTABLE"
  fun op COUNTABLE_IMAGE _ = ()
  val op COUNTABLE_IMAGE = TDB.find "COUNTABLE_IMAGE"
  fun op COUNTABLE_IMAGE_INJ_GENERAL _ = ()
  val op COUNTABLE_IMAGE_INJ_GENERAL = TDB.find
    "COUNTABLE_IMAGE_INJ_GENERAL"
  fun op COUNTABLE_IMAGE_INJ_EQ _ = ()
  val op COUNTABLE_IMAGE_INJ_EQ = TDB.find "COUNTABLE_IMAGE_INJ_EQ"
  fun op COUNTABLE_IMAGE_INJ _ = ()
  val op COUNTABLE_IMAGE_INJ = TDB.find "COUNTABLE_IMAGE_INJ"
  fun op COUNTABLE_EMPTY _ = ()
  val op COUNTABLE_EMPTY = TDB.find "COUNTABLE_EMPTY"
  fun op COUNTABLE_INTER _ = ()
  val op COUNTABLE_INTER = TDB.find "COUNTABLE_INTER"
  fun op COUNTABLE_UNION_IMP _ = ()
  val op COUNTABLE_UNION_IMP = TDB.find "COUNTABLE_UNION_IMP"
  fun op COUNTABLE_UNION _ = ()
  val op COUNTABLE_UNION = TDB.find "COUNTABLE_UNION"
  fun op COUNTABLE_SING _ = ()
  val op COUNTABLE_SING = TDB.find "COUNTABLE_SING"
  fun op COUNTABLE_INSERT _ = ()
  val op COUNTABLE_INSERT = TDB.find "COUNTABLE_INSERT"
  fun op COUNTABLE_DELETE _ = ()
  val op COUNTABLE_DELETE = TDB.find "COUNTABLE_DELETE"
  fun op COUNTABLE_DIFF_FINITE _ = ()
  val op COUNTABLE_DIFF_FINITE = TDB.find "COUNTABLE_DIFF_FINITE"
  fun op COUNTABLE_CROSS _ = ()
  val op COUNTABLE_CROSS = TDB.find "COUNTABLE_CROSS"
  fun op COUNTABLE_AS_IMAGE_SUBSET _ = ()
  val op COUNTABLE_AS_IMAGE_SUBSET = TDB.find "COUNTABLE_AS_IMAGE_SUBSET"
  fun op COUNTABLE_AS_IMAGE_SUBSET_EQ _ = ()
  val op COUNTABLE_AS_IMAGE_SUBSET_EQ = TDB.find
    "COUNTABLE_AS_IMAGE_SUBSET_EQ"
  fun op COUNTABLE_AS_IMAGE _ = ()
  val op COUNTABLE_AS_IMAGE = TDB.find "COUNTABLE_AS_IMAGE"
  fun op FORALL_COUNTABLE_AS_IMAGE _ = ()
  val op FORALL_COUNTABLE_AS_IMAGE = TDB.find "FORALL_COUNTABLE_AS_IMAGE"
  fun op COUNTABLE_AS_INJECTIVE_IMAGE _ = ()
  val op COUNTABLE_AS_INJECTIVE_IMAGE = TDB.find
    "COUNTABLE_AS_INJECTIVE_IMAGE"
  fun op COUNTABLE_BIGUNION _ = ()
  val op COUNTABLE_BIGUNION = TDB.find "COUNTABLE_BIGUNION"
  fun op IN_ELIM_PAIR_THM _ = ()
  val op IN_ELIM_PAIR_THM = TDB.find "IN_ELIM_PAIR_THM"
  fun op COUNTABLE_PRODUCT_DEPENDENT _ = ()
  val op COUNTABLE_PRODUCT_DEPENDENT = TDB.find
    "COUNTABLE_PRODUCT_DEPENDENT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val cardinal_grammars = merge_grammars ["wellorder", "quotient"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="cardinal"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val cardinal_grammars = 
    Portable.## (addtyUDs,addtmUDs) cardinal_grammars
  val _ = Parse.grammarDB_insert("cardinal",cardinal_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "cardinal"

end
