structure ordNotationSemanticsTheory :> ordNotationSemanticsTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ordNotationSemanticsTheory ... "
    else ()
  
  open Type Term Thm
  local open ordinalNotationTheory ordinalTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ordNotationSemantics"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/more_theories/ordNotationSemanticsTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ordModel_def _ = () val op ordModel_def = TDB.find "ordModel_def"
  fun op osyntax_EQ_0 _ = () val op osyntax_EQ_0 = TDB.find "osyntax_EQ_0"
  fun op oless_0 _ = () val op oless_0 = TDB.find "oless_0"
  fun op oless_0a _ = () val op oless_0a = TDB.find "oless_0a"
  fun op oless_x_End _ = () val op oless_x_End = TDB.find "oless_x_End"
  fun op is_ord_expt _ = () val op is_ord_expt = TDB.find "is_ord_expt"
  fun op ordModel_lt_epsilon0 _ = ()
  val op ordModel_lt_epsilon0 = TDB.find "ordModel_lt_epsilon0"
  fun op ord_less_models_ordlt _ = ()
  val op ord_less_models_ordlt = TDB.find "ord_less_models_ordlt"
  fun op oless_total _ = () val op oless_total = TDB.find "oless_total"
  fun op ord_less_modelled _ = ()
  val op ord_less_modelled = TDB.find "ord_less_modelled"
  fun op oless_modelled _ = ()
  val op oless_modelled = TDB.find "oless_modelled"
  fun op WF_ord_less _ = () val op WF_ord_less = TDB.find "WF_ord_less"
  fun op tail_dominated _ = ()
  val op tail_dominated = TDB.find "tail_dominated"
  fun op addL_disappears _ = ()
  val op addL_disappears = TDB.find "addL_disappears"
  fun op add_nat1_disappears _ = ()
  val op add_nat1_disappears = TDB.find "add_nat1_disappears"
  fun op add_nat1_disappears_kexp _ = ()
  val op add_nat1_disappears_kexp = TDB.find "add_nat1_disappears_kexp"
  fun op add_disappears_kexp _ = ()
  val op add_disappears_kexp = TDB.find "add_disappears_kexp"
  fun op kexp_lt _ = () val op kexp_lt = TDB.find "kexp_lt"
  fun op ord_add_correct _ = ()
  val op ord_add_correct = TDB.find "ord_add_correct"
  fun op notation_exists _ = ()
  val op notation_exists = TDB.find "notation_exists"
  fun op ordModel_11 _ = () val op ordModel_11 = TDB.find "ordModel_11"
  fun op ordModel_BIJ _ = () val op ordModel_BIJ = TDB.find "ordModel_BIJ"
  fun op nat_times_omega _ = ()
  val op nat_times_omega = TDB.find "nat_times_omega"
  fun op kexp_sum_times_nat _ = ()
  val op kexp_sum_times_nat = TDB.find "kexp_sum_times_nat"
  fun op kexp_mult _ = () val op kexp_mult = TDB.find "kexp_mult"
  fun op ord_mult_correct _ = ()
  val op ord_mult_correct = TDB.find "ord_mult_correct"
  fun op model_expt _ = () val op model_expt = TDB.find "model_expt"
  fun op ord_less_expt_monotone _ = ()
  val op ord_less_expt_monotone = TDB.find "ord_less_expt_monotone"
  fun op mvjar_lemma3 _ = () val op mvjar_lemma3 = TDB.find "mvjar_lemma3"
  fun op mvjar_lemma4 _ = () val op mvjar_lemma4 = TDB.find "mvjar_lemma4"
  fun op mvjar_lemma5 _ = () val op mvjar_lemma5 = TDB.find "mvjar_lemma5"
  fun op better_pmult_def _ = ()
  val op better_pmult_def = TDB.find "better_pmult_def"
  fun op better_ord_mult_def _ = ()
  val op better_ord_mult_def = TDB.find "better_ord_mult_def"
  fun op mvjar_theorem10 _ = ()
  val op mvjar_theorem10 = TDB.find "mvjar_theorem10"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ordNotationSemantics_grammars = merge_grammars ["ordinal",
  "ordinalNotation"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ordNotationSemantics"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ordNotationSemantics_grammars = 
    Portable.## (addtyUDs,addtmUDs) ordNotationSemantics_grammars
  val _ = Parse.grammarDB_insert("ordNotationSemantics",ordNotationSemantics_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ordNotationSemantics"

end
