structure ordinalNotationTheory :> ordinalNotationTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ordinalNotationTheory ... "
    else ()
  
  open Type Term Thm
  local open basis_emitTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ordinalNotation"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/more_theories/ordinalNotationTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op osyntax_TY_DEF _ = ()
  val op osyntax_TY_DEF = TDB.find "osyntax_TY_DEF"
  fun op osyntax_case_def _ = ()
  val op osyntax_case_def = TDB.find "osyntax_case_def"
  fun op osyntax_size_def _ = ()
  val op osyntax_size_def = TDB.find "osyntax_size_def"
  fun op expt_def _ = () val op expt_def = TDB.find "expt_def"
  fun op coeff_def _ = () val op coeff_def = TDB.find "coeff_def"
  fun op finp_def _ = () val op finp_def = TDB.find "finp_def"
  fun op tail_def _ = () val op tail_def = TDB.find "tail_def"
  fun op rank_def _ = () val op rank_def = TDB.find "rank_def"
  fun op oless_def _ = () val op oless_def = TDB.find "oless_def"
  fun op is_ord_def _ = () val op is_ord_def = TDB.find "is_ord_def"
  fun op ord_less_def _ = () val op ord_less_def = TDB.find "ord_less_def"
  fun op restn_def _ = () val op restn_def = TDB.find "restn_def"
  fun op cf1_def _ = () val op cf1_def = TDB.find "cf1_def"
  fun op cf2_def _ = () val op cf2_def = TDB.find "cf2_def"
  fun op padd_def _ = () val op padd_def = TDB.find "padd_def"
  fun op datatype_osyntax _ = ()
  val op datatype_osyntax = TDB.find "datatype_osyntax"
  fun op osyntax_11 _ = () val op osyntax_11 = TDB.find "osyntax_11"
  fun op osyntax_distinct _ = ()
  val op osyntax_distinct = TDB.find "osyntax_distinct"
  fun op osyntax_nchotomy _ = ()
  val op osyntax_nchotomy = TDB.find "osyntax_nchotomy"
  fun op osyntax_Axiom _ = ()
  val op osyntax_Axiom = TDB.find "osyntax_Axiom"
  fun op osyntax_induction _ = ()
  val op osyntax_induction = TDB.find "osyntax_induction"
  fun op osyntax_case_cong _ = ()
  val op osyntax_case_cong = TDB.find "osyntax_case_cong"
  fun op osyntax_case_eq _ = ()
  val op osyntax_case_eq = TDB.find "osyntax_case_eq"
  fun op oless_rules _ = () val op oless_rules = TDB.find "oless_rules"
  fun op oless_ind _ = () val op oless_ind = TDB.find "oless_ind"
  fun op oless_strongind _ = ()
  val op oless_strongind = TDB.find "oless_strongind"
  fun op oless_cases _ = () val op oless_cases = TDB.find "oless_cases"
  fun op oless_strong_ind _ = ()
  val op oless_strong_ind = TDB.find "oless_strong_ind"
  fun op oless_End_End _ = ()
  val op oless_End_End = TDB.find "oless_End_End"
  fun op oless_equations _ = ()
  val op oless_equations = TDB.find "oless_equations"
  fun op is_ord_rules _ = () val op is_ord_rules = TDB.find "is_ord_rules"
  fun op is_ord_ind _ = () val op is_ord_ind = TDB.find "is_ord_ind"
  fun op is_ord_strongind _ = ()
  val op is_ord_strongind = TDB.find "is_ord_strongind"
  fun op is_ord_cases _ = () val op is_ord_cases = TDB.find "is_ord_cases"
  fun op is_ord_strong_ind _ = ()
  val op is_ord_strong_ind = TDB.find "is_ord_strong_ind"
  fun op decompose_plus _ = ()
  val op decompose_plus = TDB.find "decompose_plus"
  fun op is_ord_equations _ = ()
  val op is_ord_equations = TDB.find "is_ord_equations"
  fun op is_ord_expt_closed _ = ()
  val op is_ord_expt_closed = TDB.find "is_ord_expt_closed"
  fun op is_ord_tail_closed _ = ()
  val op is_ord_tail_closed = TDB.find "is_ord_tail_closed"
  fun op is_ord_downclosed _ = ()
  val op is_ord_downclosed = TDB.find "is_ord_downclosed"
  fun op is_ord_coeff_pos _ = ()
  val op is_ord_coeff_pos = TDB.find "is_ord_coeff_pos"
  fun op rank_expt _ = () val op rank_expt = TDB.find "rank_expt"
  fun op oless_antirefl _ = ()
  val op oless_antirefl = TDB.find "oless_antirefl"
  fun op oless_antisym _ = ()
  val op oless_antisym = TDB.find "oless_antisym"
  fun op rank_less_imp_oless _ = ()
  val op rank_less_imp_oless = TDB.find "rank_less_imp_oless"
  fun op oless_imp_rank_leq _ = ()
  val op oless_imp_rank_leq = TDB.find "oless_imp_rank_leq"
  fun op rank_0_End _ = () val op rank_0_End = TDB.find "rank_0_End"
  fun op rank_finp _ = () val op rank_finp = TDB.find "rank_finp"
  fun op rank_positive_exists _ = ()
  val op rank_positive_exists = TDB.find "rank_positive_exists"
  fun op rank_positive _ = ()
  val op rank_positive = TDB.find "rank_positive"
  fun op rank_positive_expt _ = ()
  val op rank_positive_expt = TDB.find "rank_positive_expt"
  fun op oless_expt _ = () val op oless_expt = TDB.find "oless_expt"
  fun op oless_tail _ = () val op oless_tail = TDB.find "oless_tail"
  fun op lemma _ = () val op lemma = TDB.find "lemma"
  fun op main_lemma _ = () val op main_lemma = TDB.find "main_lemma"
  fun op WF_ord_less _ = () val op WF_ord_less = TDB.find "WF_ord_less"
  fun op e0_INDUCTION _ = () val op e0_INDUCTION = TDB.find "e0_INDUCTION"
  fun op e0_RECURSION _ = () val op e0_RECURSION = TDB.find "e0_RECURSION"
  fun op ord_add_ind _ = () val op ord_add_ind = TDB.find "ord_add_ind"
  fun op ord_add_def _ = () val op ord_add_def = TDB.find "ord_add_def"
  fun op ord_sub_ind _ = () val op ord_sub_ind = TDB.find "ord_sub_ind"
  fun op ord_sub_def _ = () val op ord_sub_def = TDB.find "ord_sub_def"
  fun op ord_mult_ind _ = () val op ord_mult_ind = TDB.find "ord_mult_ind"
  fun op ord_mult_def _ = () val op ord_mult_def = TDB.find "ord_mult_def"
  fun op restn_compute _ = ()
  val op restn_compute = TDB.find "restn_compute"
  fun op padd_compute _ = () val op padd_compute = TDB.find "padd_compute"
  fun op pmult_ind _ = () val op pmult_ind = TDB.find "pmult_ind"
  fun op pmult_def _ = () val op pmult_def = TDB.find "pmult_def"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ordinalNotation_grammars = merge_grammars ["basis_emit"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ordinalNotation"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ordinalNotation_grammars = 
    Portable.## (addtyUDs,addtmUDs) ordinalNotation_grammars
  val _ = Parse.grammarDB_insert("ordinalNotation",ordinalNotation_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ordinalNotation"

end
