structure ordinalTheory :> ordinalTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ordinalTheory ... "
    else ()
  
  open Type Term Thm
  local open cardinalTheory quotient_listTheory quotient_optionTheory
  quotient_pairTheory quotient_sumTheory
  in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ordinal"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/more_theories/ordinalTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ordinal_TY_DEF _ = ()
  val op ordinal_TY_DEF = TDB.find "ordinal_TY_DEF"
  fun op ordinal_bijections _ = ()
  val op ordinal_bijections = TDB.find "ordinal_bijections"
  fun op ordinal_REP_def _ = ()
  val op ordinal_REP_def = TDB.find "ordinal_REP_def"
  fun op ordinal_ABS_def _ = ()
  val op ordinal_ABS_def = TDB.find "ordinal_ABS_def"
  fun op ordlt_def _ = () val op ordlt_def = TDB.find "ordlt_def"
  fun op allOrds_def _ = () val op allOrds_def = TDB.find "allOrds_def"
  fun op preds_def _ = () val op preds_def = TDB.find "preds_def"
  fun op downward_closed_def _ = ()
  val op downward_closed_def = TDB.find "downward_closed_def"
  fun op oleast_def _ = () val op oleast_def = TDB.find "oleast_def"
  fun op ordSUC_def _ = () val op ordSUC_def = TDB.find "ordSUC_def"
  fun op fromNat_def _ = () val op fromNat_def = TDB.find "fromNat_def"
  fun op sup_def _ = () val op sup_def = TDB.find "sup_def"
  fun op omax_def _ = () val op omax_def = TDB.find "omax_def"
  fun op dclose_def _ = () val op dclose_def = TDB.find "dclose_def"
  fun op omega_def _ = () val op omega_def = TDB.find "omega_def"
  fun op ordADD_def _ = () val op ordADD_def = TDB.find "ordADD_def"
  fun op ordMULT_def _ = () val op ordMULT_def = TDB.find "ordMULT_def"
  fun op ordDIVISION _ = () val op ordDIVISION = TDB.find "ordDIVISION"
  fun op ordEXP_def _ = () val op ordEXP_def = TDB.find "ordEXP_def"
  fun op epsilon0_def _ = () val op epsilon0_def = TDB.find "epsilon0_def"
  fun op polyform_def _ = () val op polyform_def = TDB.find "polyform_def"
  fun op ordinal_ABS_REP_CLASS _ = ()
  val op ordinal_ABS_REP_CLASS = TDB.find "ordinal_ABS_REP_CLASS"
  fun op ordinal_QUOTIENT _ = ()
  val op ordinal_QUOTIENT = TDB.find "ordinal_QUOTIENT"
  fun op ordlt_REFL _ = () val op ordlt_REFL = TDB.find "ordlt_REFL"
  fun op ordlt_TRANS _ = () val op ordlt_TRANS = TDB.find "ordlt_TRANS"
  fun op ordlt_WF _ = () val op ordlt_WF = TDB.find "ordlt_WF"
  fun op ordlt_trichotomy _ = ()
  val op ordlt_trichotomy = TDB.find "ordlt_trichotomy"
  fun op wellorder_allOrds _ = ()
  val op wellorder_allOrds = TDB.find "wellorder_allOrds"
  fun op WIN_allOrds _ = () val op WIN_allOrds = TDB.find "WIN_allOrds"
  fun op elsOf_allOrds _ = ()
  val op elsOf_allOrds = TDB.find "elsOf_allOrds"
  fun op ordlt_mkOrdinal _ = ()
  val op ordlt_mkOrdinal = TDB.find "ordlt_mkOrdinal"
  fun op orderlt_iso_REFL _ = ()
  val op orderlt_iso_REFL = TDB.find "orderlt_iso_REFL"
  fun op orderiso_wobound2 _ = ()
  val op orderiso_wobound2 = TDB.find "orderiso_wobound2"
  fun op wellorder_ordinal_isomorphism _ = ()
  val op wellorder_ordinal_isomorphism = TDB.find
    "wellorder_ordinal_isomorphism"
  fun op IN_preds _ = () val op IN_preds = TDB.find "IN_preds"
  fun op preds_11 _ = () val op preds_11 = TDB.find "preds_11"
  fun op preds_downward_closed _ = ()
  val op preds_downward_closed = TDB.find "preds_downward_closed"
  fun op preds_bij _ = () val op preds_bij = TDB.find "preds_bij"
  fun op preds_lt_PSUBSET _ = ()
  val op preds_lt_PSUBSET = TDB.find "preds_lt_PSUBSET"
  fun op preds_wobound _ = ()
  val op preds_wobound = TDB.find "preds_wobound"
  fun op preds_inj_univ _ = ()
  val op preds_inj_univ = TDB.find "preds_inj_univ"
  fun op unitinf_univnum _ = ()
  val op unitinf_univnum = TDB.find "unitinf_univnum"
  fun op cord_countable_preds _ = ()
  val op cord_countable_preds = TDB.find "cord_countable_preds"
  fun op univ_ord_greater_cardinal _ = ()
  val op univ_ord_greater_cardinal = TDB.find "univ_ord_greater_cardinal"
  fun op univ_cord_uncountable _ = ()
  val op univ_cord_uncountable = TDB.find "univ_cord_uncountable"
  fun op ordle_lteq _ = () val op ordle_lteq = TDB.find "ordle_lteq"
  fun op ordle_ANTISYM _ = ()
  val op ordle_ANTISYM = TDB.find "ordle_ANTISYM"
  fun op ordle_TRANS _ = () val op ordle_TRANS = TDB.find "ordle_TRANS"
  fun op ordlet_TRANS _ = () val op ordlet_TRANS = TDB.find "ordlet_TRANS"
  fun op ordlte_TRANS _ = () val op ordlte_TRANS = TDB.find "ordlte_TRANS"
  fun op oleast_intro _ = () val op oleast_intro = TDB.find "oleast_intro"
  fun op fromNat_compute _ = ()
  val op fromNat_compute = TDB.find "fromNat_compute"
  fun op fromNat_SUC _ = () val op fromNat_SUC = TDB.find "fromNat_SUC"
  fun op ordlt_ZERO _ = () val op ordlt_ZERO = TDB.find "ordlt_ZERO"
  fun op preds_surj _ = () val op preds_surj = TDB.find "preds_surj"
  fun op no_maximal_ordinal _ = ()
  val op no_maximal_ordinal = TDB.find "no_maximal_ordinal"
  fun op ordlt_SUC _ = () val op ordlt_SUC = TDB.find "ordlt_SUC"
  fun op ordSUC_ZERO _ = () val op ordSUC_ZERO = TDB.find "ordSUC_ZERO"
  fun op ordlt_DISCRETE1 _ = ()
  val op ordlt_DISCRETE1 = TDB.find "ordlt_DISCRETE1"
  fun op ordlt_SUC_DISCRETE _ = ()
  val op ordlt_SUC_DISCRETE = TDB.find "ordlt_SUC_DISCRETE"
  fun op ordSUC_MONO _ = () val op ordSUC_MONO = TDB.find "ordSUC_MONO"
  fun op ordSUC_11 _ = () val op ordSUC_11 = TDB.find "ordSUC_11"
  fun op ord_induction _ = ()
  val op ord_induction = TDB.find "ord_induction"
  fun op sup_thm _ = () val op sup_thm = TDB.find "sup_thm"
  fun op suple_thm _ = () val op suple_thm = TDB.find "suple_thm"
  fun op sup_eq_sup _ = () val op sup_eq_sup = TDB.find "sup_eq_sup"
  fun op Unum_cle_Uinf _ = ()
  val op Unum_cle_Uinf = TDB.find "Unum_cle_Uinf"
  fun op csup_thm _ = () val op csup_thm = TDB.find "csup_thm"
  fun op predimage_sup_thm _ = ()
  val op predimage_sup_thm = TDB.find "predimage_sup_thm"
  fun op predimage_suplt_ELIM _ = ()
  val op predimage_suplt_ELIM = TDB.find "predimage_suplt_ELIM"
  fun op suppred_suplt_ELIM _ = ()
  val op suppred_suplt_ELIM = TDB.find "suppred_suplt_ELIM"
  fun op sup_EMPTY _ = () val op sup_EMPTY = TDB.find "sup_EMPTY"
  fun op sup_SING _ = () val op sup_SING = TDB.find "sup_SING"
  fun op sup_preds_SUC _ = ()
  val op sup_preds_SUC = TDB.find "sup_preds_SUC"
  fun op preds_ordSUC _ = () val op preds_ordSUC = TDB.find "preds_ordSUC"
  fun op countableOrds_dclosed _ = ()
  val op countableOrds_dclosed = TDB.find "countableOrds_dclosed"
  fun op omax_SOME _ = () val op omax_SOME = TDB.find "omax_SOME"
  fun op omax_NONE _ = () val op omax_NONE = TDB.find "omax_NONE"
  fun op omax_EMPTY _ = () val op omax_EMPTY = TDB.find "omax_EMPTY"
  fun op preds_0 _ = () val op preds_0 = TDB.find "preds_0"
  fun op ordleq0 _ = () val op ordleq0 = TDB.find "ordleq0"
  fun op preds_EQ_EMPTY _ = ()
  val op preds_EQ_EMPTY = TDB.find "preds_EQ_EMPTY"
  fun op omax_sup _ = () val op omax_sup = TDB.find "omax_sup"
  fun op preds_omax_SOME_SUC _ = ()
  val op preds_omax_SOME_SUC = TDB.find "preds_omax_SOME_SUC"
  fun op omax_preds_SUC _ = ()
  val op omax_preds_SUC = TDB.find "omax_preds_SUC"
  fun op simple_ord_induction _ = ()
  val op simple_ord_induction = TDB.find "simple_ord_induction"
  fun op sup_preds_omax_NONE _ = ()
  val op sup_preds_omax_NONE = TDB.find "sup_preds_omax_NONE"
  fun op preds_sup _ = () val op preds_sup = TDB.find "preds_sup"
  fun op csup_lesup _ = () val op csup_lesup = TDB.find "csup_lesup"
  fun op csup_suple _ = () val op csup_suple = TDB.find "csup_suple"
  fun op preds_sup_thm _ = ()
  val op preds_sup_thm = TDB.find "preds_sup_thm"
  fun op preds_lesup _ = () val op preds_lesup = TDB.find "preds_lesup"
  fun op preds_suple _ = () val op preds_suple = TDB.find "preds_suple"
  fun op fromNat_11 _ = () val op fromNat_11 = TDB.find "fromNat_11"
  fun op ordlt_fromNat _ = ()
  val op ordlt_fromNat = TDB.find "ordlt_fromNat"
  fun op fromNat_ordlt _ = ()
  val op fromNat_ordlt = TDB.find "fromNat_ordlt"
  fun op lt_omega _ = () val op lt_omega = TDB.find "lt_omega"
  fun op fromNat_lt_omega _ = ()
  val op fromNat_lt_omega = TDB.find "fromNat_lt_omega"
  fun op fromNat_eq_omega _ = ()
  val op fromNat_eq_omega = TDB.find "fromNat_eq_omega"
  fun op ord_RECURSION _ = ()
  val op ord_RECURSION = TDB.find "ord_RECURSION"
  fun op ordADD_0L _ = () val op ordADD_0L = TDB.find "ordADD_0L"
  fun op ubsup_thm _ = () val op ubsup_thm = TDB.find "ubsup_thm"
  fun op ordADD_fromNat _ = ()
  val op ordADD_fromNat = TDB.find "ordADD_fromNat"
  fun op omax_preds_omega _ = ()
  val op omax_preds_omega = TDB.find "omax_preds_omega"
  fun op omega_islimit _ = ()
  val op omega_islimit = TDB.find "omega_islimit"
  fun op ordADD_fromNat_omega _ = ()
  val op ordADD_fromNat_omega = TDB.find "ordADD_fromNat_omega"
  fun op lt_suppreds _ = () val op lt_suppreds = TDB.find "lt_suppreds"
  fun op ORD_ONE _ = () val op ORD_ONE = TDB.find "ORD_ONE"
  fun op ordSUC_NUMERAL _ = ()
  val op ordSUC_NUMERAL = TDB.find "ordSUC_NUMERAL"
  fun op ordZERO_ltSUC _ = ()
  val op ordZERO_ltSUC = TDB.find "ordZERO_ltSUC"
  fun op ordlt_CANCEL_ADDR _ = ()
  val op ordlt_CANCEL_ADDR = TDB.find "ordlt_CANCEL_ADDR"
  fun op ordlt_CANCEL_ADDL _ = ()
  val op ordlt_CANCEL_ADDL = TDB.find "ordlt_CANCEL_ADDL"
  fun op ordADD_CANCEL1 _ = ()
  val op ordADD_CANCEL1 = TDB.find "ordADD_CANCEL1"
  fun op ordADD_MONO _ = () val op ordADD_MONO = TDB.find "ordADD_MONO"
  fun op ordlt_CANCEL _ = () val op ordlt_CANCEL = TDB.find "ordlt_CANCEL"
  fun op ordADD_RIGHT_CANCEL _ = ()
  val op ordADD_RIGHT_CANCEL = TDB.find "ordADD_RIGHT_CANCEL"
  fun op leqLEFT_CANCEL _ = ()
  val op leqLEFT_CANCEL = TDB.find "leqLEFT_CANCEL"
  fun op ordlt_EXISTS_ADD _ = ()
  val op ordlt_EXISTS_ADD = TDB.find "ordlt_EXISTS_ADD"
  fun op ordle_EXISTS_ADD _ = ()
  val op ordle_EXISTS_ADD = TDB.find "ordle_EXISTS_ADD"
  fun op ordle_CANCEL_ADDR _ = ()
  val op ordle_CANCEL_ADDR = TDB.find "ordle_CANCEL_ADDR"
  fun op dclose_BIGUNION _ = ()
  val op dclose_BIGUNION = TDB.find "dclose_BIGUNION"
  fun op countableOrds_uncountable _ = ()
  val op countableOrds_uncountable = TDB.find "countableOrds_uncountable"
  fun op dclose_cardleq_univinf _ = ()
  val op dclose_cardleq_univinf = TDB.find "dclose_cardleq_univinf"
  fun op sup_lt_implies _ = ()
  val op sup_lt_implies = TDB.find "sup_lt_implies"
  fun op sup_eq_max _ = () val op sup_eq_max = TDB.find "sup_eq_max"
  fun op sup_eq_SUC _ = () val op sup_eq_SUC = TDB.find "sup_eq_SUC"
  fun op generic_continuity _ = ()
  val op generic_continuity = TDB.find "generic_continuity"
  fun op ord_CASES _ = () val op ord_CASES = TDB.find "ord_CASES"
  fun op islimit_0 _ = () val op islimit_0 = TDB.find "islimit_0"
  fun op ordinal_IVT _ = () val op ordinal_IVT = TDB.find "ordinal_IVT"
  fun op ordADD_continuous _ = ()
  val op ordADD_continuous = TDB.find "ordADD_continuous"
  fun op ordADD_ASSOC _ = () val op ordADD_ASSOC = TDB.find "ordADD_ASSOC"
  fun op ADD1R _ = () val op ADD1R = TDB.find "ADD1R"
  fun op ordADD_weak_MONO _ = ()
  val op ordADD_weak_MONO = TDB.find "ordADD_weak_MONO"
  fun op ordMULT_0L _ = () val op ordMULT_0L = TDB.find "ordMULT_0L"
  fun op ordMULT_0R _ = () val op ordMULT_0R = TDB.find "ordMULT_0R"
  fun op ordMULT_1L _ = () val op ordMULT_1L = TDB.find "ordMULT_1L"
  fun op ordMULT_1R _ = () val op ordMULT_1R = TDB.find "ordMULT_1R"
  fun op ordMULT_2R _ = () val op ordMULT_2R = TDB.find "ordMULT_2R"
  fun op islimit_SUC_lt _ = ()
  val op islimit_SUC_lt = TDB.find "islimit_SUC_lt"
  fun op ordMULT_lt_MONO_R _ = ()
  val op ordMULT_lt_MONO_R = TDB.find "ordMULT_lt_MONO_R"
  fun op ordMULT_le_MONO_R _ = ()
  val op ordMULT_le_MONO_R = TDB.find "ordMULT_le_MONO_R"
  fun op ordMULT_lt_MONO_R_EQN _ = ()
  val op ordMULT_lt_MONO_R_EQN = TDB.find "ordMULT_lt_MONO_R_EQN"
  fun op ordADD_le_MONO_L _ = ()
  val op ordADD_le_MONO_L = TDB.find "ordADD_le_MONO_L"
  fun op ordMULT_le_MONO_L _ = ()
  val op ordMULT_le_MONO_L = TDB.find "ordMULT_le_MONO_L"
  fun op ordMULT_CANCEL_R _ = ()
  val op ordMULT_CANCEL_R = TDB.find "ordMULT_CANCEL_R"
  fun op ordMULT_continuous _ = ()
  val op ordMULT_continuous = TDB.find "ordMULT_continuous"
  fun op ordMULT_fromNat _ = ()
  val op ordMULT_fromNat = TDB.find "ordMULT_fromNat"
  fun op omega_MUL_fromNat _ = ()
  val op omega_MUL_fromNat = TDB.find "omega_MUL_fromNat"
  fun op ordMULT_LDISTRIB _ = ()
  val op ordMULT_LDISTRIB = TDB.find "ordMULT_LDISTRIB"
  fun op ordMULT_ASSOC _ = ()
  val op ordMULT_ASSOC = TDB.find "ordMULT_ASSOC"
  fun op ordDIV_UNIQUE _ = ()
  val op ordDIV_UNIQUE = TDB.find "ordDIV_UNIQUE"
  fun op ordMOD_UNIQUE _ = ()
  val op ordMOD_UNIQUE = TDB.find "ordMOD_UNIQUE"
  fun op ordEXP_1R _ = () val op ordEXP_1R = TDB.find "ordEXP_1R"
  fun op ordEXP_1L _ = () val op ordEXP_1L = TDB.find "ordEXP_1L"
  fun op ordEXP_2R _ = () val op ordEXP_2R = TDB.find "ordEXP_2R"
  fun op ordEXP_fromNat _ = ()
  val op ordEXP_fromNat = TDB.find "ordEXP_fromNat"
  fun op ordEXP_le_MONO_L _ = ()
  val op ordEXP_le_MONO_L = TDB.find "ordEXP_le_MONO_L"
  fun op IFF_ZERO_lt _ = () val op IFF_ZERO_lt = TDB.find "IFF_ZERO_lt"
  fun op islimit_SUC _ = () val op islimit_SUC = TDB.find "islimit_SUC"
  fun op islimit_fromNat _ = ()
  val op islimit_fromNat = TDB.find "islimit_fromNat"
  fun op ordEXP_ZERO_limit _ = ()
  val op ordEXP_ZERO_limit = TDB.find "ordEXP_ZERO_limit"
  fun op ordEXP_ZERO_nonlimit _ = ()
  val op ordEXP_ZERO_nonlimit = TDB.find "ordEXP_ZERO_nonlimit"
  fun op sup_EQ_0 _ = () val op sup_EQ_0 = TDB.find "sup_EQ_0"
  fun op ordADD_EQ_0 _ = () val op ordADD_EQ_0 = TDB.find "ordADD_EQ_0"
  fun op IMAGE_EQ_SING _ = ()
  val op IMAGE_EQ_SING = TDB.find "IMAGE_EQ_SING"
  fun op ordMULT_EQ_0 _ = () val op ordMULT_EQ_0 = TDB.find "ordMULT_EQ_0"
  fun op ordEXP_EQ_0 _ = () val op ordEXP_EQ_0 = TDB.find "ordEXP_EQ_0"
  fun op ZERO_lt_ordEXP_I _ = ()
  val op ZERO_lt_ordEXP_I = TDB.find "ZERO_lt_ordEXP_I"
  fun op ZERO_lt_ordEXP _ = ()
  val op ZERO_lt_ordEXP = TDB.find "ZERO_lt_ordEXP"
  fun op ordEXP_lt_MONO_R _ = ()
  val op ordEXP_lt_MONO_R = TDB.find "ordEXP_lt_MONO_R"
  fun op ordEXP_lt_IFF _ = ()
  val op ordEXP_lt_IFF = TDB.find "ordEXP_lt_IFF"
  fun op ordEXP_le_MONO_R _ = ()
  val op ordEXP_le_MONO_R = TDB.find "ordEXP_le_MONO_R"
  fun op ordEXP_continuous _ = ()
  val op ordEXP_continuous = TDB.find "ordEXP_continuous"
  fun op ordEXP_ADD _ = () val op ordEXP_ADD = TDB.find "ordEXP_ADD"
  fun op ordEXP_MUL _ = () val op ordEXP_MUL = TDB.find "ordEXP_MUL"
  fun op fixpoints_exist _ = ()
  val op fixpoints_exist = TDB.find "fixpoints_exist"
  fun op x_le_ordEXP_x _ = ()
  val op x_le_ordEXP_x = TDB.find "x_le_ordEXP_x"
  fun op epsilon0_fixpoint _ = ()
  val op epsilon0_fixpoint = TDB.find "epsilon0_fixpoint"
  fun op epsilon0_least_fixpoint _ = ()
  val op epsilon0_least_fixpoint = TDB.find "epsilon0_least_fixpoint"
  fun op omega_lt_epsilon0 _ = ()
  val op omega_lt_epsilon0 = TDB.find "omega_lt_epsilon0"
  fun op fromNat_lt_epsilon0 _ = ()
  val op fromNat_lt_epsilon0 = TDB.find "fromNat_lt_epsilon0"
  fun op add_nat_islimit _ = ()
  val op add_nat_islimit = TDB.find "add_nat_islimit"
  fun op strict_continuity_preserves_islimit _ = ()
  val op strict_continuity_preserves_islimit = TDB.find
    "strict_continuity_preserves_islimit"
  fun op add_omega_islimit _ = ()
  val op add_omega_islimit = TDB.find "add_omega_islimit"
  fun op islimit_mul_R _ = ()
  val op islimit_mul_R = TDB.find "islimit_mul_R"
  fun op mul_omega_islimit _ = ()
  val op mul_omega_islimit = TDB.find "mul_omega_islimit"
  fun op omega_exp_islimit _ = ()
  val op omega_exp_islimit = TDB.find "omega_exp_islimit"
  fun op expbound_add _ = () val op expbound_add = TDB.find "expbound_add"
  fun op addL_fixpoint_iff _ = ()
  val op addL_fixpoint_iff = TDB.find "addL_fixpoint_iff"
  fun op ordADD_under_epsilon0 _ = ()
  val op ordADD_under_epsilon0 = TDB.find "ordADD_under_epsilon0"
  fun op ordMUL_under_epsilon0 _ = ()
  val op ordMUL_under_epsilon0 = TDB.find "ordMUL_under_epsilon0"
  fun op ordEXP_under_epsilon0 _ = ()
  val op ordEXP_under_epsilon0 = TDB.find "ordEXP_under_epsilon0"
  fun op eval_poly_ind _ = ()
  val op eval_poly_ind = TDB.find "eval_poly_ind"
  fun op eval_poly_def _ = ()
  val op eval_poly_def = TDB.find "eval_poly_def"
  fun op is_polyform_ind _ = ()
  val op is_polyform_ind = TDB.find "is_polyform_ind"
  fun op is_polyform_def _ = ()
  val op is_polyform_def = TDB.find "is_polyform_def"
  fun op is_polyform_ELthm _ = ()
  val op is_polyform_ELthm = TDB.find "is_polyform_ELthm"
  fun op polyform_exists _ = ()
  val op polyform_exists = TDB.find "polyform_exists"
  fun op CNF_thm _ = () val op CNF_thm = TDB.find "CNF_thm"
  fun op polyform_0 _ = () val op polyform_0 = TDB.find "polyform_0"
  fun op polyform_EQ_NIL _ = ()
  val op polyform_EQ_NIL = TDB.find "polyform_EQ_NIL"
  fun op is_polyform_CONS_E _ = ()
  val op is_polyform_CONS_E = TDB.find "is_polyform_CONS_E"
  fun op is_polyform_head_dominates_tail _ = ()
  val op is_polyform_head_dominates_tail = TDB.find
    "is_polyform_head_dominates_tail"
  fun op cx_lt_x _ = () val op cx_lt_x = TDB.find "cx_lt_x"
  fun op polyform_UNIQUE _ = ()
  val op polyform_UNIQUE = TDB.find "polyform_UNIQUE"
  fun op polyform_eval_poly _ = ()
  val op polyform_eval_poly = TDB.find "polyform_eval_poly"
  fun op CNF_nat _ = () val op CNF_nat = TDB.find "CNF_nat"
  fun op ordLOG_correct _ = ()
  val op ordLOG_correct = TDB.find "ordLOG_correct"
  fun op olog_correct _ = () val op olog_correct = TDB.find "olog_correct"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ordinal_grammars = merge_grammars ["cardinal", "quotient_sum",
  "quotient_pair", "quotient_option", "quotient_list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ordinal"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ordinal_grammars = 
    Portable.## (addtyUDs,addtmUDs) ordinal_grammars
  val _ = Parse.grammarDB_insert("ordinal",ordinal_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ordinal"

end
