structure ucordTheory :> ucordTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ucordTheory ... "
    else ()
  
  open Type Term Thm
  local open ordinalTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ucord"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/more_theories/ucordTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op omega1_def _ = () val op omega1_def = TDB.find "omega1_def"
  fun op ucinf_uncountable _ = ()
  val op ucinf_uncountable = TDB.find "ucinf_uncountable"
  fun op Unum_cardlt_ucinf _ = ()
  val op Unum_cardlt_ucinf = TDB.find "Unum_cardlt_ucinf"
  fun op Unum_cardle_ucinf _ = ()
  val op Unum_cardle_ucinf = TDB.find "Unum_cardle_ucinf"
  fun op ucord_sup_exists_lemma _ = ()
  val op ucord_sup_exists_lemma = TDB.find "ucord_sup_exists_lemma"
  fun op x_lt_omega1_countable _ = ()
  val op x_lt_omega1_countable = TDB.find "x_lt_omega1_countable"
  fun op omega1_not_countable _ = ()
  val op omega1_not_countable = TDB.find "omega1_not_countable"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ucord_grammars = merge_grammars ["ordinal"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ucord"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ucord_grammars = 
    Portable.## (addtyUDs,addtmUDs) ucord_grammars
  val _ = Parse.grammarDB_insert("ucord",ucord_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ucord"

end
