structure veblenTheory :> veblenTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading veblenTheory ... "
    else ()
  
  open Type Term Thm
  local open ordinalTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "veblen"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/more_theories/veblenTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op closed_def _ = () val op closed_def = TDB.find "closed_def"
  fun op unbounded_def _ = ()
  val op unbounded_def = TDB.find "unbounded_def"
  fun op club_def _ = () val op club_def = TDB.find "club_def"
  fun op continuous_def _ = ()
  val op continuous_def = TDB.find "continuous_def"
  fun op strict_mono_def _ = ()
  val op strict_mono_def = TDB.find "strict_mono_def"
  fun op better_induction _ = ()
  val op better_induction = TDB.find "better_induction"
  fun op nrange_IN_Uinf _ = ()
  val op nrange_IN_Uinf = TDB.find "nrange_IN_Uinf"
  fun op increasing _ = () val op increasing = TDB.find "increasing"
  fun op clubs_exist _ = () val op clubs_exist = TDB.find "clubs_exist"
  fun op mono_natI _ = () val op mono_natI = TDB.find "mono_natI"
  fun op sup_mem_INTER _ = ()
  val op sup_mem_INTER = TDB.find "sup_mem_INTER"
  fun op oleast_leq _ = () val op oleast_leq = TDB.find "oleast_leq"
  fun op club_INTER _ = () val op club_INTER = TDB.find "club_INTER"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val veblen_grammars = merge_grammars ["ordinal"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="veblen"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val veblen_grammars = 
    Portable.## (addtyUDs,addtmUDs) veblen_grammars
  val _ = Parse.grammarDB_insert("veblen",veblen_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "veblen"

end
