structure set_relationTheory :> set_relationTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading set_relationTheory ... "
    else ()
  
  open Type Term Thm
  local open pred_setTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "set_relation"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/pred_set/src/set_relationTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op domain_def _ = () val op domain_def = TDB.find "domain_def"
  fun op range_def _ = () val op range_def = TDB.find "range_def"
  fun op rrestrict_def _ = ()
  val op rrestrict_def = TDB.find "rrestrict_def"
  fun op rcomp_def _ = () val op rcomp_def = TDB.find "rcomp_def"
  fun op strict_def _ = () val op strict_def = TDB.find "strict_def"
  fun op univ_reln_def _ = ()
  val op univ_reln_def = TDB.find "univ_reln_def"
  fun op finite_prefixes_def _ = ()
  val op finite_prefixes_def = TDB.find "finite_prefixes_def"
  fun op tc_def _ = () val op tc_def = TDB.find "tc_def"
  fun op acyclic_def _ = () val op acyclic_def = TDB.find "acyclic_def"
  fun op reflexive_def _ = ()
  val op reflexive_def = TDB.find "reflexive_def"
  fun op irreflexive_def _ = ()
  val op irreflexive_def = TDB.find "irreflexive_def"
  fun op transitive_def _ = ()
  val op transitive_def = TDB.find "transitive_def"
  fun op antisym_def _ = () val op antisym_def = TDB.find "antisym_def"
  fun op partial_order_def _ = ()
  val op partial_order_def = TDB.find "partial_order_def"
  fun op linear_order_def _ = ()
  val op linear_order_def = TDB.find "linear_order_def"
  fun op strict_linear_order_def _ = ()
  val op strict_linear_order_def = TDB.find "strict_linear_order_def"
  fun op reln_to_rel_def _ = ()
  val op reln_to_rel_def = TDB.find "reln_to_rel_def"
  fun op rel_to_reln_def _ = ()
  val op rel_to_reln_def = TDB.find "rel_to_reln_def"
  fun op RRUNIV_def _ = () val op RRUNIV_def = TDB.find "RRUNIV_def"
  fun op RREFL_EXP_def _ = ()
  val op RREFL_EXP_def = TDB.find "RREFL_EXP_def"
  fun op maximal_elements_def _ = ()
  val op maximal_elements_def = TDB.find "maximal_elements_def"
  fun op minimal_elements_def _ = ()
  val op minimal_elements_def = TDB.find "minimal_elements_def"
  fun op chain_def _ = () val op chain_def = TDB.find "chain_def"
  fun op upper_bounds_def _ = ()
  val op upper_bounds_def = TDB.find "upper_bounds_def"
  fun op fchains_def _ = () val op fchains_def = TDB.find "fchains_def"
  fun op per_def _ = () val op per_def = TDB.find "per_def"
  fun op per_restrict_def _ = ()
  val op per_restrict_def = TDB.find "per_restrict_def"
  fun op all_choices_def _ = ()
  val op all_choices_def = TDB.find "all_choices_def"
  fun op num_order_def _ = ()
  val op num_order_def = TDB.find "num_order_def"
  fun op get_min_def _ = () val op get_min_def = TDB.find "get_min_def"
  fun op acyclic_bigunion _ = ()
  val op acyclic_bigunion = TDB.find "acyclic_bigunion"
  fun op acyclic_SWAP _ = () val op acyclic_SWAP = TDB.find "acyclic_SWAP"
  fun op acyclic_irreflexive _ = ()
  val op acyclic_irreflexive = TDB.find "acyclic_irreflexive"
  fun op acyclic_rrestrict _ = ()
  val op acyclic_rrestrict = TDB.find "acyclic_rrestrict"
  fun op tc_mono _ = () val op tc_mono = TDB.find "tc_mono"
  fun op tc_idemp _ = () val op tc_idemp = TDB.find "tc_idemp"
  fun op subset_tc _ = () val op subset_tc = TDB.find "subset_tc"
  fun op tc_closure _ = () val op tc_closure = TDB.find "tc_closure"
  fun op tc_ind _ = () val op tc_ind = TDB.find "tc_ind"
  fun op rextension _ = () val op rextension = TDB.find "rextension"
  fun op in_domain _ = () val op in_domain = TDB.find "in_domain"
  fun op in_range _ = () val op in_range = TDB.find "in_range"
  fun op in_dom_rg _ = () val op in_dom_rg = TDB.find "in_dom_rg"
  fun op domain_mono _ = () val op domain_mono = TDB.find "domain_mono"
  fun op range_mono _ = () val op range_mono = TDB.find "range_mono"
  fun op in_rrestrict _ = () val op in_rrestrict = TDB.find "in_rrestrict"
  fun op in_rrestrict_alt _ = ()
  val op in_rrestrict_alt = TDB.find "in_rrestrict_alt"
  fun op rrestrict_SUBSET _ = ()
  val op rrestrict_SUBSET = TDB.find "rrestrict_SUBSET"
  fun op rrestrict_union _ = ()
  val op rrestrict_union = TDB.find "rrestrict_union"
  fun op rrestrict_rrestrict _ = ()
  val op rrestrict_rrestrict = TDB.find "rrestrict_rrestrict"
  fun op domain_rrestrict_SUBSET _ = ()
  val op domain_rrestrict_SUBSET = TDB.find "domain_rrestrict_SUBSET"
  fun op range_rrestrict_SUBSET _ = ()
  val op range_rrestrict_SUBSET = TDB.find "range_rrestrict_SUBSET"
  fun op strict_rrestrict _ = ()
  val op strict_rrestrict = TDB.find "strict_rrestrict"
  fun op finite_prefixes_subset_s _ = ()
  val op finite_prefixes_subset_s = TDB.find "finite_prefixes_subset_s"
  fun op finite_prefixes_subset_r _ = ()
  val op finite_prefixes_subset_r = TDB.find "finite_prefixes_subset_r"
  fun op finite_prefixes_subset_rs _ = ()
  val op finite_prefixes_subset_rs = TDB.find "finite_prefixes_subset_rs"
  fun op finite_prefixes_subset _ = ()
  val op finite_prefixes_subset = TDB.find "finite_prefixes_subset"
  fun op finite_prefixes_union _ = ()
  val op finite_prefixes_union = TDB.find "finite_prefixes_union"
  fun op finite_prefixes_comp _ = ()
  val op finite_prefixes_comp = TDB.find "finite_prefixes_comp"
  fun op finite_prefixes_inj_image _ = ()
  val op finite_prefixes_inj_image = TDB.find "finite_prefixes_inj_image"
  fun op finite_prefixes_range _ = ()
  val op finite_prefixes_range = TDB.find "finite_prefixes_range"
  fun op tc_rules _ = () val op tc_rules = TDB.find "tc_rules"
  fun op tc_cases _ = () val op tc_cases = TDB.find "tc_cases"
  fun op tc_strongind _ = () val op tc_strongind = TDB.find "tc_strongind"
  fun op tc_cases_right _ = ()
  val op tc_cases_right = TDB.find "tc_cases_right"
  fun op tc_cases_left _ = ()
  val op tc_cases_left = TDB.find "tc_cases_left"
  fun op tc_ind_left _ = () val op tc_ind_left = TDB.find "tc_ind_left"
  fun op tc_strongind_left _ = ()
  val op tc_strongind_left = TDB.find "tc_strongind_left"
  fun op tc_ind_right _ = () val op tc_ind_right = TDB.find "tc_ind_right"
  fun op rtc_ind_right _ = ()
  val op rtc_ind_right = TDB.find "rtc_ind_right"
  fun op tc_strongind_right _ = ()
  val op tc_strongind_right = TDB.find "tc_strongind_right"
  fun op tc_union _ = () val op tc_union = TDB.find "tc_union"
  fun op tc_implication _ = ()
  val op tc_implication = TDB.find "tc_implication"
  fun op tc_empty _ = () val op tc_empty = TDB.find "tc_empty"
  fun op tc_empty_eqn _ = () val op tc_empty_eqn = TDB.find "tc_empty_eqn"
  fun op tc_domain_range _ = ()
  val op tc_domain_range = TDB.find "tc_domain_range"
  fun op rrestrict_tc _ = () val op rrestrict_tc = TDB.find "rrestrict_tc"
  fun op tc_SWAP _ = () val op tc_SWAP = TDB.find "tc_SWAP"
  fun op acyclic_subset _ = ()
  val op acyclic_subset = TDB.find "acyclic_subset"
  fun op acyclic_union _ = ()
  val op acyclic_union = TDB.find "acyclic_union"
  fun op transitive_tc _ = ()
  val op transitive_tc = TDB.find "transitive_tc"
  fun op tc_transitive _ = ()
  val op tc_transitive = TDB.find "tc_transitive"
  fun op antisym_subset _ = ()
  val op antisym_subset = TDB.find "antisym_subset"
  fun op partial_order_dom_rng _ = ()
  val op partial_order_dom_rng = TDB.find "partial_order_dom_rng"
  fun op partial_order_subset _ = ()
  val op partial_order_subset = TDB.find "partial_order_subset"
  fun op strict_partial_order _ = ()
  val op strict_partial_order = TDB.find "strict_partial_order"
  fun op strict_partial_order_acyclic _ = ()
  val op strict_partial_order_acyclic = TDB.find
    "strict_partial_order_acyclic"
  fun op linear_order_subset _ = ()
  val op linear_order_subset = TDB.find "linear_order_subset"
  fun op partial_order_linear_order _ = ()
  val op partial_order_linear_order = TDB.find "partial_order_linear_order"
  fun op strict_linear_order_dom_rng _ = ()
  val op strict_linear_order_dom_rng = TDB.find
    "strict_linear_order_dom_rng"
  fun op linear_order_dom_rng _ = ()
  val op linear_order_dom_rng = TDB.find "linear_order_dom_rng"
  fun op RREFL_EXP_RSUBSET _ = ()
  val op RREFL_EXP_RSUBSET = TDB.find "RREFL_EXP_RSUBSET"
  fun op RREFL_EXP_UNIV _ = ()
  val op RREFL_EXP_UNIV = TDB.find "RREFL_EXP_UNIV"
  fun op REL_RESTRICT_UNIV _ = ()
  val op REL_RESTRICT_UNIV = TDB.find "REL_RESTRICT_UNIV"
  fun op in_rel_to_reln _ = ()
  val op in_rel_to_reln = TDB.find "in_rel_to_reln"
  fun op reln_to_rel_app _ = ()
  val op reln_to_rel_app = TDB.find "reln_to_rel_app"
  fun op rel_to_reln_IS_UNCURRY _ = ()
  val op rel_to_reln_IS_UNCURRY = TDB.find "rel_to_reln_IS_UNCURRY"
  fun op reln_to_rel_IS_CURRY _ = ()
  val op reln_to_rel_IS_CURRY = TDB.find "reln_to_rel_IS_CURRY"
  fun op rel_to_reln_inv _ = ()
  val op rel_to_reln_inv = TDB.find "rel_to_reln_inv"
  fun op reln_to_rel_inv _ = ()
  val op reln_to_rel_inv = TDB.find "reln_to_rel_inv"
  fun op reln_to_rel_11 _ = ()
  val op reln_to_rel_11 = TDB.find "reln_to_rel_11"
  fun op rel_to_reln_11 _ = ()
  val op rel_to_reln_11 = TDB.find "rel_to_reln_11"
  fun op rel_to_reln_swap _ = ()
  val op rel_to_reln_swap = TDB.find "rel_to_reln_swap"
  fun op domain_to_rel_conv _ = ()
  val op domain_to_rel_conv = TDB.find "domain_to_rel_conv"
  fun op range_to_rel_conv _ = ()
  val op range_to_rel_conv = TDB.find "range_to_rel_conv"
  fun op strict_to_rel_conv _ = ()
  val op strict_to_rel_conv = TDB.find "strict_to_rel_conv"
  fun op rrestrict_to_rel_conv _ = ()
  val op rrestrict_to_rel_conv = TDB.find "rrestrict_to_rel_conv"
  fun op rcomp_to_rel_conv _ = ()
  val op rcomp_to_rel_conv = TDB.find "rcomp_to_rel_conv"
  fun op univ_reln_to_rel_conv _ = ()
  val op univ_reln_to_rel_conv = TDB.find "univ_reln_to_rel_conv"
  fun op tc_to_rel_conv _ = ()
  val op tc_to_rel_conv = TDB.find "tc_to_rel_conv"
  fun op acyclic_reln_to_rel_conv _ = ()
  val op acyclic_reln_to_rel_conv = TDB.find "acyclic_reln_to_rel_conv"
  fun op irreflexive_reln_to_rel_conv _ = ()
  val op irreflexive_reln_to_rel_conv = TDB.find
    "irreflexive_reln_to_rel_conv"
  fun op irreflexive_reln_to_rel_conv_UNIV _ = ()
  val op irreflexive_reln_to_rel_conv_UNIV = TDB.find
    "irreflexive_reln_to_rel_conv_UNIV"
  fun op reflexive_reln_to_rel_conv _ = ()
  val op reflexive_reln_to_rel_conv = TDB.find "reflexive_reln_to_rel_conv"
  fun op reflexive_reln_to_rel_conv_UNIV _ = ()
  val op reflexive_reln_to_rel_conv_UNIV = TDB.find
    "reflexive_reln_to_rel_conv_UNIV"
  fun op transitive_reln_to_rel_conv _ = ()
  val op transitive_reln_to_rel_conv = TDB.find
    "transitive_reln_to_rel_conv"
  fun op antisym_reln_to_rel_conv _ = ()
  val op antisym_reln_to_rel_conv = TDB.find "antisym_reln_to_rel_conv"
  fun op partial_order_reln_to_rel_conv _ = ()
  val op partial_order_reln_to_rel_conv = TDB.find
    "partial_order_reln_to_rel_conv"
  fun op partial_order_reln_to_rel_conv_UNIV _ = ()
  val op partial_order_reln_to_rel_conv_UNIV = TDB.find
    "partial_order_reln_to_rel_conv_UNIV"
  fun op linear_order_reln_to_rel_conv_UNIV _ = ()
  val op linear_order_reln_to_rel_conv_UNIV = TDB.find
    "linear_order_reln_to_rel_conv_UNIV"
  fun op strict_linear_order_reln_to_rel_conv_UNIV _ = ()
  val op strict_linear_order_reln_to_rel_conv_UNIV = TDB.find
    "strict_linear_order_reln_to_rel_conv_UNIV"
  fun op reln_rel_conv_thms _ = ()
  val op reln_rel_conv_thms = TDB.find "reln_rel_conv_thms"
  fun op acyclic_WF _ = () val op acyclic_WF = TDB.find "acyclic_WF"
  fun op minimal_elements_subset _ = ()
  val op minimal_elements_subset = TDB.find "minimal_elements_subset"
  fun op minimal_elements_SWAP _ = ()
  val op minimal_elements_SWAP = TDB.find "minimal_elements_SWAP"
  fun op maximal_union _ = ()
  val op maximal_union = TDB.find "maximal_union"
  fun op minimal_union _ = ()
  val op minimal_union = TDB.find "minimal_union"
  fun op minimal_elements_mono _ = ()
  val op minimal_elements_mono = TDB.find "minimal_elements_mono"
  fun op minimal_elements_rrestrict _ = ()
  val op minimal_elements_rrestrict = TDB.find "minimal_elements_rrestrict"
  fun op WF_has_minimal_path _ = ()
  val op WF_has_minimal_path = TDB.find "WF_has_minimal_path"
  fun op finite_acyclic_has_maximal _ = ()
  val op finite_acyclic_has_maximal = TDB.find "finite_acyclic_has_maximal"
  fun op finite_acyclic_has_minimal _ = ()
  val op finite_acyclic_has_minimal = TDB.find "finite_acyclic_has_minimal"
  fun op maximal_TC _ = () val op maximal_TC = TDB.find "maximal_TC"
  fun op minimal_TC _ = () val op minimal_TC = TDB.find "minimal_TC"
  fun op finite_acyclic_has_minimal_path _ = ()
  val op finite_acyclic_has_minimal_path = TDB.find
    "finite_acyclic_has_minimal_path"
  fun op finite_acyclic_has_maximal_path _ = ()
  val op finite_acyclic_has_maximal_path = TDB.find
    "finite_acyclic_has_maximal_path"
  fun op finite_prefix_po_has_minimal_path _ = ()
  val op finite_prefix_po_has_minimal_path = TDB.find
    "finite_prefix_po_has_minimal_path"
  fun op empty_strict_linear_order _ = ()
  val op empty_strict_linear_order = TDB.find "empty_strict_linear_order"
  fun op empty_linear_order _ = ()
  val op empty_linear_order = TDB.find "empty_linear_order"
  fun op linear_order_restrict _ = ()
  val op linear_order_restrict = TDB.find "linear_order_restrict"
  fun op strict_linear_order_restrict _ = ()
  val op strict_linear_order_restrict = TDB.find
    "strict_linear_order_restrict"
  fun op linear_order_dom_rg _ = ()
  val op linear_order_dom_rg = TDB.find "linear_order_dom_rg"
  fun op linear_order_refl _ = ()
  val op linear_order_refl = TDB.find "linear_order_refl"
  fun op linear_order_in_set _ = ()
  val op linear_order_in_set = TDB.find "linear_order_in_set"
  fun op IN_MIN_LO _ = () val op IN_MIN_LO = TDB.find "IN_MIN_LO"
  fun op extend_linear_order _ = ()
  val op extend_linear_order = TDB.find "extend_linear_order"
  fun op strict_linear_order_acyclic _ = ()
  val op strict_linear_order_acyclic = TDB.find
    "strict_linear_order_acyclic"
  fun op strict_linear_order_union_acyclic _ = ()
  val op strict_linear_order_union_acyclic = TDB.find
    "strict_linear_order_union_acyclic"
  fun op strict_linear_order _ = ()
  val op strict_linear_order = TDB.find "strict_linear_order"
  fun op linear_order _ = () val op linear_order = TDB.find "linear_order"
  fun op finite_strict_linear_order_has_maximal _ = ()
  val op finite_strict_linear_order_has_maximal = TDB.find
    "finite_strict_linear_order_has_maximal"
  fun op finite_strict_linear_order_has_minimal _ = ()
  val op finite_strict_linear_order_has_minimal = TDB.find
    "finite_strict_linear_order_has_minimal"
  fun op finite_linear_order_has_maximal _ = ()
  val op finite_linear_order_has_maximal = TDB.find
    "finite_linear_order_has_maximal"
  fun op finite_linear_order_has_minimal _ = ()
  val op finite_linear_order_has_minimal = TDB.find
    "finite_linear_order_has_minimal"
  fun op maximal_linear_order _ = ()
  val op maximal_linear_order = TDB.find "maximal_linear_order"
  fun op minimal_linear_order _ = ()
  val op minimal_linear_order = TDB.find "minimal_linear_order"
  fun op minimal_linear_order_unique _ = ()
  val op minimal_linear_order_unique = TDB.find
    "minimal_linear_order_unique"
  fun op finite_prefix_linear_order_has_unique_minimal _ = ()
  val op finite_prefix_linear_order_has_unique_minimal = TDB.find
    "finite_prefix_linear_order_has_unique_minimal"
  fun op nat_order_iso_thm _ = ()
  val op nat_order_iso_thm = TDB.find "nat_order_iso_thm"
  fun op upper_bounds_lem _ = ()
  val op upper_bounds_lem = TDB.find "upper_bounds_lem"
  fun op zorns_lemma _ = () val op zorns_lemma = TDB.find "zorns_lemma"
  fun op per_delete _ = () val op per_delete = TDB.find "per_delete"
  fun op per_restrict_per _ = ()
  val op per_restrict_per = TDB.find "per_restrict_per"
  fun op countable_per _ = ()
  val op countable_per = TDB.find "countable_per"
  fun op all_choices_thm _ = ()
  val op all_choices_thm = TDB.find "all_choices_thm"
  fun op linear_order_num_order _ = ()
  val op linear_order_num_order = TDB.find "linear_order_num_order"
  fun op num_order_finite_prefix _ = ()
  val op num_order_finite_prefix = TDB.find "num_order_finite_prefix"
  fun op nth_min_ind _ = () val op nth_min_ind = TDB.find "nth_min_ind"
  fun op nth_min_def _ = () val op nth_min_def = TDB.find "nth_min_def"
  fun op nth_min_compute _ = ()
  val op nth_min_compute = TDB.find "nth_min_compute"
  fun op linear_order_of_countable_po _ = ()
  val op linear_order_of_countable_po = TDB.find
    "linear_order_of_countable_po"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val set_relation_grammars = merge_grammars ["pred_set"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="set_relation"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val set_relation_grammars = 
    Portable.## (addtyUDs,addtmUDs) set_relation_grammars
  val _ = Parse.grammarDB_insert("set_relation",set_relation_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "set_relation"

end
