structure extrealTheory :> extrealTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading extrealTheory ... "
    else ()
  
  open Type Term Thm
  local open util_probTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "extreal"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/extrealTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op mono_decreasing_def _ = ()
  val op mono_decreasing_def = TDB.find "mono_decreasing_def"
  fun op mono_increasing_def _ = ()
  val op mono_increasing_def = TDB.find "mono_increasing_def"
  fun op extreal_sqrt_def _ = ()
  val op extreal_sqrt_def = TDB.find "extreal_sqrt_def"
  fun op extreal_pow_def _ = ()
  val op extreal_pow_def = TDB.find "extreal_pow_def"
  fun op extreal_exp_def _ = ()
  val op extreal_exp_def = TDB.find "extreal_exp_def"
  fun op extreal_lg_def _ = ()
  val op extreal_lg_def = TDB.find "extreal_lg_def"
  fun op extreal_logr_def _ = ()
  val op extreal_logr_def = TDB.find "extreal_logr_def"
  fun op extreal_abs_primitive_def _ = ()
  val op extreal_abs_primitive_def = TDB.find "extreal_abs_primitive_def"
  fun op extreal_div_def _ = ()
  val op extreal_div_def = TDB.find "extreal_div_def"
  fun op extreal_ainv_def _ = ()
  val op extreal_ainv_def = TDB.find "extreal_ainv_def"
  fun op extreal_inv_def _ = ()
  val op extreal_inv_def = TDB.find "extreal_inv_def"
  fun op extreal_lt_def _ = ()
  val op extreal_lt_def = TDB.find "extreal_lt_def"
  fun op real_def _ = () val op real_def = TDB.find "real_def"
  fun op extreal_of_num_def _ = ()
  val op extreal_of_num_def = TDB.find "extreal_of_num_def"
  fun op extreal_TY_DEF _ = ()
  val op extreal_TY_DEF = TDB.find "extreal_TY_DEF"
  fun op extreal_case_def _ = ()
  val op extreal_case_def = TDB.find "extreal_case_def"
  fun op extreal_size_def _ = ()
  val op extreal_size_def = TDB.find "extreal_size_def"
  fun op ext_mono_increasing_def _ = ()
  val op ext_mono_increasing_def = TDB.find "ext_mono_increasing_def"
  fun op ext_mono_decreasing_def _ = ()
  val op ext_mono_decreasing_def = TDB.find "ext_mono_decreasing_def"
  fun op EXTREAL_SUM_IMAGE_DEF _ = ()
  val op EXTREAL_SUM_IMAGE_DEF = TDB.find "EXTREAL_SUM_IMAGE_DEF"
  fun op extreal_sup_def _ = ()
  val op extreal_sup_def = TDB.find "extreal_sup_def"
  fun op extreal_inf_def _ = ()
  val op extreal_inf_def = TDB.find "extreal_inf_def"
  fun op ext_suminf_def _ = ()
  val op ext_suminf_def = TDB.find "ext_suminf_def"
  fun op extreal_min_def _ = ()
  val op extreal_min_def = TDB.find "extreal_min_def"
  fun op extreal_max_def _ = ()
  val op extreal_max_def = TDB.find "extreal_max_def"
  fun op Q_set_def _ = () val op Q_set_def = TDB.find "Q_set_def"
  fun op ceiling_def _ = () val op ceiling_def = TDB.find "ceiling_def"
  fun op open_interval_def _ = ()
  val op open_interval_def = TDB.find "open_interval_def"
  fun op open_intervals_set_def _ = ()
  val op open_intervals_set_def = TDB.find "open_intervals_set_def"
  fun op rational_intervals_def _ = ()
  val op rational_intervals_def = TDB.find "rational_intervals_def"
  fun op num_not_infty _ = ()
  val op num_not_infty = TDB.find "num_not_infty"
  fun op extreal_not_infty _ = ()
  val op extreal_not_infty = TDB.find "extreal_not_infty"
  fun op extreal_eq_zero _ = ()
  val op extreal_eq_zero = TDB.find "extreal_eq_zero"
  fun op extreal_cases _ = ()
  val op extreal_cases = TDB.find "extreal_cases"
  fun op mono_increasing_converges_to_sup _ = ()
  val op mono_increasing_converges_to_sup = TDB.find
    "mono_increasing_converges_to_sup"
  fun op mono_decreasing_suc _ = ()
  val op mono_decreasing_suc = TDB.find "mono_decreasing_suc"
  fun op mono_increasing_suc _ = ()
  val op mono_increasing_suc = TDB.find "mono_increasing_suc"
  fun op LOGR_MONO_LE_IMP _ = ()
  val op LOGR_MONO_LE_IMP = TDB.find "LOGR_MONO_LE_IMP"
  fun op LOGR_MONO_LE _ = () val op LOGR_MONO_LE = TDB.find "LOGR_MONO_LE"
  fun op POW_NEG_ODD _ = () val op POW_NEG_ODD = TDB.find "POW_NEG_ODD"
  fun op POW_POS_EVEN _ = () val op POW_POS_EVEN = TDB.find "POW_POS_EVEN"
  fun op REAL_LE_RDIV_EQ_NEG _ = ()
  val op REAL_LE_RDIV_EQ_NEG = TDB.find "REAL_LE_RDIV_EQ_NEG"
  fun op REAL_LT_RDIV_EQ_NEG _ = ()
  val op REAL_LT_RDIV_EQ_NEG = TDB.find "REAL_LT_RDIV_EQ_NEG"
  fun op REAL_LT_RMUL_NEG_0_NEG _ = ()
  val op REAL_LT_RMUL_NEG_0_NEG = TDB.find "REAL_LT_RMUL_NEG_0_NEG"
  fun op REAL_LT_LMUL_NEG_0_NEG _ = ()
  val op REAL_LT_LMUL_NEG_0_NEG = TDB.find "REAL_LT_LMUL_NEG_0_NEG"
  fun op REAL_LT_RMUL_NEG_0 _ = ()
  val op REAL_LT_RMUL_NEG_0 = TDB.find "REAL_LT_RMUL_NEG_0"
  fun op REAL_LT_LMUL_NEG_0 _ = ()
  val op REAL_LT_LMUL_NEG_0 = TDB.find "REAL_LT_LMUL_NEG_0"
  fun op REAL_LT_RMUL_0_NEG _ = ()
  val op REAL_LT_RMUL_0_NEG = TDB.find "REAL_LT_RMUL_0_NEG"
  fun op REAL_LT_LMUL_0_NEG _ = ()
  val op REAL_LT_LMUL_0_NEG = TDB.find "REAL_LT_LMUL_0_NEG"
  fun op extreal_abs_def _ = ()
  val op extreal_abs_def = TDB.find "extreal_abs_def"
  fun op extreal_abs_ind _ = ()
  val op extreal_abs_ind = TDB.find "extreal_abs_ind"
  fun op extreal_mul_def _ = ()
  val op extreal_mul_def = TDB.find "extreal_mul_def"
  fun op extreal_mul_ind _ = ()
  val op extreal_mul_ind = TDB.find "extreal_mul_ind"
  fun op extreal_le_def _ = ()
  val op extreal_le_def = TDB.find "extreal_le_def"
  fun op extreal_le_ind _ = ()
  val op extreal_le_ind = TDB.find "extreal_le_ind"
  fun op extreal_sub_def _ = ()
  val op extreal_sub_def = TDB.find "extreal_sub_def"
  fun op extreal_sub_ind _ = ()
  val op extreal_sub_ind = TDB.find "extreal_sub_ind"
  fun op extreal_add_def _ = ()
  val op extreal_add_def = TDB.find "extreal_add_def"
  fun op extreal_add_ind _ = ()
  val op extreal_add_ind = TDB.find "extreal_add_ind"
  fun op normal_real _ = () val op normal_real = TDB.find "normal_real"
  fun op real_normal _ = () val op real_normal = TDB.find "real_normal"
  fun op extreal_case_eq _ = ()
  val op extreal_case_eq = TDB.find "extreal_case_eq"
  fun op extreal_case_cong _ = ()
  val op extreal_case_cong = TDB.find "extreal_case_cong"
  fun op extreal_induction _ = ()
  val op extreal_induction = TDB.find "extreal_induction"
  fun op extreal_Axiom _ = ()
  val op extreal_Axiom = TDB.find "extreal_Axiom"
  fun op extreal_nchotomy _ = ()
  val op extreal_nchotomy = TDB.find "extreal_nchotomy"
  fun op extreal_distinct _ = ()
  val op extreal_distinct = TDB.find "extreal_distinct"
  fun op datatype_extreal _ = ()
  val op datatype_extreal = TDB.find "datatype_extreal"
  fun op extreal_11 _ = () val op extreal_11 = TDB.find "extreal_11"
  fun op mul_rzero _ = () val op mul_rzero = TDB.find "mul_rzero"
  fun op mul_lzero _ = () val op mul_lzero = TDB.find "mul_lzero"
  fun op mul_rone _ = () val op mul_rone = TDB.find "mul_rone"
  fun op mul_lone _ = () val op mul_lone = TDB.find "mul_lone"
  fun op entire _ = () val op entire = TDB.find "entire"
  fun op extreal_lt_eq _ = ()
  val op extreal_lt_eq = TDB.find "extreal_lt_eq"
  fun op le_refl _ = () val op le_refl = TDB.find "le_refl"
  fun op lt_refl _ = () val op lt_refl = TDB.find "lt_refl"
  fun op le_infty _ = () val op le_infty = TDB.find "le_infty"
  fun op lt_infty _ = () val op lt_infty = TDB.find "lt_infty"
  fun op lt_imp_le _ = () val op lt_imp_le = TDB.find "lt_imp_le"
  fun op lt_imp_ne _ = () val op lt_imp_ne = TDB.find "lt_imp_ne"
  fun op le_trans _ = () val op le_trans = TDB.find "le_trans"
  fun op lt_trans _ = () val op lt_trans = TDB.find "lt_trans"
  fun op let_trans _ = () val op let_trans = TDB.find "let_trans"
  fun op le_antisym _ = () val op le_antisym = TDB.find "le_antisym"
  fun op lt_antisym _ = () val op lt_antisym = TDB.find "lt_antisym"
  fun op lte_trans _ = () val op lte_trans = TDB.find "lte_trans"
  fun op le_total _ = () val op le_total = TDB.find "le_total"
  fun op lt_total _ = () val op lt_total = TDB.find "lt_total"
  fun op le_01 _ = () val op le_01 = TDB.find "le_01"
  fun op lt_01 _ = () val op lt_01 = TDB.find "lt_01"
  fun op ne_01 _ = () val op ne_01 = TDB.find "ne_01"
  fun op le_02 _ = () val op le_02 = TDB.find "le_02"
  fun op lt_02 _ = () val op lt_02 = TDB.find "lt_02"
  fun op ne_02 _ = () val op ne_02 = TDB.find "ne_02"
  fun op le_num _ = () val op le_num = TDB.find "le_num"
  fun op lt_le _ = () val op lt_le = TDB.find "lt_le"
  fun op le_lt _ = () val op le_lt = TDB.find "le_lt"
  fun op le_neg _ = () val op le_neg = TDB.find "le_neg"
  fun op lt_neg _ = () val op lt_neg = TDB.find "lt_neg"
  fun op le_add _ = () val op le_add = TDB.find "le_add"
  fun op lt_add _ = () val op lt_add = TDB.find "lt_add"
  fun op let_add _ = () val op let_add = TDB.find "let_add"
  fun op lte_add _ = () val op lte_add = TDB.find "lte_add"
  fun op le_add2 _ = () val op le_add2 = TDB.find "le_add2"
  fun op lt_add2 _ = () val op lt_add2 = TDB.find "lt_add2"
  fun op let_add2 _ = () val op let_add2 = TDB.find "let_add2"
  fun op let_add2_alt _ = () val op let_add2_alt = TDB.find "let_add2_alt"
  fun op le_addr _ = () val op le_addr = TDB.find "le_addr"
  fun op le_addr_imp _ = () val op le_addr_imp = TDB.find "le_addr_imp"
  fun op le_ladd _ = () val op le_ladd = TDB.find "le_ladd"
  fun op le_radd _ = () val op le_radd = TDB.find "le_radd"
  fun op le_radd_imp _ = () val op le_radd_imp = TDB.find "le_radd_imp"
  fun op le_ladd_imp _ = () val op le_ladd_imp = TDB.find "le_ladd_imp"
  fun op lt_ladd _ = () val op lt_ladd = TDB.find "lt_ladd"
  fun op lt_radd _ = () val op lt_radd = TDB.find "lt_radd"
  fun op lt_addl _ = () val op lt_addl = TDB.find "lt_addl"
  fun op le_lneg _ = () val op le_lneg = TDB.find "le_lneg"
  fun op le_mul _ = () val op le_mul = TDB.find "le_mul"
  fun op let_mul _ = () val op let_mul = TDB.find "let_mul"
  fun op lte_mul _ = () val op lte_mul = TDB.find "lte_mul"
  fun op le_mul_neg _ = () val op le_mul_neg = TDB.find "le_mul_neg"
  fun op mul_le _ = () val op mul_le = TDB.find "mul_le"
  fun op lt_mul _ = () val op lt_mul = TDB.find "lt_mul"
  fun op lt_mul_neg _ = () val op lt_mul_neg = TDB.find "lt_mul_neg"
  fun op mul_lt _ = () val op mul_lt = TDB.find "mul_lt"
  fun op mul_let _ = () val op mul_let = TDB.find "mul_let"
  fun op mul_lte _ = () val op mul_lte = TDB.find "mul_lte"
  fun op le_rmul_imp _ = () val op le_rmul_imp = TDB.find "le_rmul_imp"
  fun op le_lmul_imp _ = () val op le_lmul_imp = TDB.find "le_lmul_imp"
  fun op lt_rmul _ = () val op lt_rmul = TDB.find "lt_rmul"
  fun op lt_lmul _ = () val op lt_lmul = TDB.find "lt_lmul"
  fun op lt_mul2 _ = () val op lt_mul2 = TDB.find "lt_mul2"
  fun op abs_pos _ = () val op abs_pos = TDB.find "abs_pos"
  fun op abs_refl _ = () val op abs_refl = TDB.find "abs_refl"
  fun op abs_bounds _ = () val op abs_bounds = TDB.find "abs_bounds"
  fun op abs_bounds_lt _ = ()
  val op abs_bounds_lt = TDB.find "abs_bounds_lt"
  fun op add_comm _ = () val op add_comm = TDB.find "add_comm"
  fun op add_assoc _ = () val op add_assoc = TDB.find "add_assoc"
  fun op add_not_infty _ = ()
  val op add_not_infty = TDB.find "add_not_infty"
  fun op add_rzero _ = () val op add_rzero = TDB.find "add_rzero"
  fun op add_lzero _ = () val op add_lzero = TDB.find "add_lzero"
  fun op add_infty _ = () val op add_infty = TDB.find "add_infty"
  fun op EXTREAL_EQ_LADD _ = ()
  val op EXTREAL_EQ_LADD = TDB.find "EXTREAL_EQ_LADD"
  fun op sub_rzero _ = () val op sub_rzero = TDB.find "sub_rzero"
  fun op sub_lzero _ = () val op sub_lzero = TDB.find "sub_lzero"
  fun op sub_le_imp _ = () val op sub_le_imp = TDB.find "sub_le_imp"
  fun op sub_le_imp2 _ = () val op sub_le_imp2 = TDB.find "sub_le_imp2"
  fun op le_sub_imp _ = () val op le_sub_imp = TDB.find "le_sub_imp"
  fun op lt_sub_imp _ = () val op lt_sub_imp = TDB.find "lt_sub_imp"
  fun op sub_lt_imp _ = () val op sub_lt_imp = TDB.find "sub_lt_imp"
  fun op sub_lt_imp2 _ = () val op sub_lt_imp2 = TDB.find "sub_lt_imp2"
  fun op sub_zero_lt _ = () val op sub_zero_lt = TDB.find "sub_zero_lt"
  fun op sub_zero_lt2 _ = () val op sub_zero_lt2 = TDB.find "sub_zero_lt2"
  fun op sub_lt_zero _ = () val op sub_lt_zero = TDB.find "sub_lt_zero"
  fun op sub_lt_zero2 _ = () val op sub_lt_zero2 = TDB.find "sub_lt_zero2"
  fun op sub_zero_le _ = () val op sub_zero_le = TDB.find "sub_zero_le"
  fun op sub_le_zero _ = () val op sub_le_zero = TDB.find "sub_le_zero"
  fun op le_sub_eq _ = () val op le_sub_eq = TDB.find "le_sub_eq"
  fun op le_sub_eq2 _ = () val op le_sub_eq2 = TDB.find "le_sub_eq2"
  fun op sub_le_eq _ = () val op sub_le_eq = TDB.find "sub_le_eq"
  fun op sub_le_eq2 _ = () val op sub_le_eq2 = TDB.find "sub_le_eq2"
  fun op sub_le_switch _ = ()
  val op sub_le_switch = TDB.find "sub_le_switch"
  fun op sub_le_switch2 _ = ()
  val op sub_le_switch2 = TDB.find "sub_le_switch2"
  fun op lt_sub _ = () val op lt_sub = TDB.find "lt_sub"
  fun op sub_add2 _ = () val op sub_add2 = TDB.find "sub_add2"
  fun op add_sub _ = () val op add_sub = TDB.find "add_sub"
  fun op add_sub2 _ = () val op add_sub2 = TDB.find "add_sub2"
  fun op sub_add _ = () val op sub_add = TDB.find "sub_add"
  fun op extreal_sub_add _ = ()
  val op extreal_sub_add = TDB.find "extreal_sub_add"
  fun op sub_0 _ = () val op sub_0 = TDB.find "sub_0"
  fun op neg_neg _ = () val op neg_neg = TDB.find "neg_neg"
  fun op neg_0 _ = () val op neg_0 = TDB.find "neg_0"
  fun op neg_eq0 _ = () val op neg_eq0 = TDB.find "neg_eq0"
  fun op eq_neg _ = () val op eq_neg = TDB.find "eq_neg"
  fun op neg_minus1 _ = () val op neg_minus1 = TDB.find "neg_minus1"
  fun op sub_rneg _ = () val op sub_rneg = TDB.find "sub_rneg"
  fun op sub_lneg _ = () val op sub_lneg = TDB.find "sub_lneg"
  fun op neg_sub _ = () val op neg_sub = TDB.find "neg_sub"
  fun op sub_not_infty _ = ()
  val op sub_not_infty = TDB.find "sub_not_infty"
  fun op le_lsub_imp _ = () val op le_lsub_imp = TDB.find "le_lsub_imp"
  fun op eq_sub_ladd_normal _ = ()
  val op eq_sub_ladd_normal = TDB.find "eq_sub_ladd_normal"
  fun op eq_sub_radd _ = () val op eq_sub_radd = TDB.find "eq_sub_radd"
  fun op eq_sub_ladd _ = () val op eq_sub_ladd = TDB.find "eq_sub_ladd"
  fun op eq_sub_switch _ = ()
  val op eq_sub_switch = TDB.find "eq_sub_switch"
  fun op eq_add_sub_switch _ = ()
  val op eq_add_sub_switch = TDB.find "eq_add_sub_switch"
  fun op sub_refl _ = () val op sub_refl = TDB.find "sub_refl"
  fun op mul_comm _ = () val op mul_comm = TDB.find "mul_comm"
  fun op mul_assoc _ = () val op mul_assoc = TDB.find "mul_assoc"
  fun op mul_not_infty _ = ()
  val op mul_not_infty = TDB.find "mul_not_infty"
  fun op mul_not_infty2 _ = ()
  val op mul_not_infty2 = TDB.find "mul_not_infty2"
  fun op add_ldistrib_pos _ = ()
  val op add_ldistrib_pos = TDB.find "add_ldistrib_pos"
  fun op add_ldistrib_neg _ = ()
  val op add_ldistrib_neg = TDB.find "add_ldistrib_neg"
  fun op add_ldistrib_normal _ = ()
  val op add_ldistrib_normal = TDB.find "add_ldistrib_normal"
  fun op add_ldistrib_normal2 _ = ()
  val op add_ldistrib_normal2 = TDB.find "add_ldistrib_normal2"
  fun op add_rdistrib_normal _ = ()
  val op add_rdistrib_normal = TDB.find "add_rdistrib_normal"
  fun op add_rdistrib_normal2 _ = ()
  val op add_rdistrib_normal2 = TDB.find "add_rdistrib_normal2"
  fun op add_ldistrib _ = () val op add_ldistrib = TDB.find "add_ldistrib"
  fun op add_rdistrib _ = () val op add_rdistrib = TDB.find "add_rdistrib"
  fun op mul_lneg _ = () val op mul_lneg = TDB.find "mul_lneg"
  fun op mul_rneg _ = () val op mul_rneg = TDB.find "mul_rneg"
  fun op neg_mul2 _ = () val op neg_mul2 = TDB.find "neg_mul2"
  fun op add2_sub2 _ = () val op add2_sub2 = TDB.find "add2_sub2"
  fun op sub_ldistrib _ = () val op sub_ldistrib = TDB.find "sub_ldistrib"
  fun op sub_rdistrib _ = () val op sub_rdistrib = TDB.find "sub_rdistrib"
  fun op extreal_div_eq _ = ()
  val op extreal_div_eq = TDB.find "extreal_div_eq"
  fun op inv_one _ = () val op inv_one = TDB.find "inv_one"
  fun op inv_1over _ = () val op inv_1over = TDB.find "inv_1over"
  fun op div_one _ = () val op div_one = TDB.find "div_one"
  fun op inv_pos _ = () val op inv_pos = TDB.find "inv_pos"
  fun op rinv_uniq _ = () val op rinv_uniq = TDB.find "rinv_uniq"
  fun op linv_uniq _ = () val op linv_uniq = TDB.find "linv_uniq"
  fun op le_rdiv _ = () val op le_rdiv = TDB.find "le_rdiv"
  fun op le_ldiv _ = () val op le_ldiv = TDB.find "le_ldiv"
  fun op lt_rdiv _ = () val op lt_rdiv = TDB.find "lt_rdiv"
  fun op lt_ldiv _ = () val op lt_ldiv = TDB.find "lt_ldiv"
  fun op lt_rdiv_neg _ = () val op lt_rdiv_neg = TDB.find "lt_rdiv_neg"
  fun op div_add _ = () val op div_add = TDB.find "div_add"
  fun op le_inv _ = () val op le_inv = TDB.find "le_inv"
  fun op pow_0 _ = () val op pow_0 = TDB.find "pow_0"
  fun op pow_1 _ = () val op pow_1 = TDB.find "pow_1"
  fun op pow_2 _ = () val op pow_2 = TDB.find "pow_2"
  fun op pow_zero _ = () val op pow_zero = TDB.find "pow_zero"
  fun op pow_zero_imp _ = () val op pow_zero_imp = TDB.find "pow_zero_imp"
  fun op le_pow2 _ = () val op le_pow2 = TDB.find "le_pow2"
  fun op pow_pos_le _ = () val op pow_pos_le = TDB.find "pow_pos_le"
  fun op pow_pos_lt _ = () val op pow_pos_lt = TDB.find "pow_pos_lt"
  fun op pow_le _ = () val op pow_le = TDB.find "pow_le"
  fun op pow_lt _ = () val op pow_lt = TDB.find "pow_lt"
  fun op pow_lt2 _ = () val op pow_lt2 = TDB.find "pow_lt2"
  fun op pow_le_mono _ = () val op pow_le_mono = TDB.find "pow_le_mono"
  fun op pow_pos_even _ = () val op pow_pos_even = TDB.find "pow_pos_even"
  fun op pow_neg_odd _ = () val op pow_neg_odd = TDB.find "pow_neg_odd"
  fun op add_pow2 _ = () val op add_pow2 = TDB.find "add_pow2"
  fun op pow_add _ = () val op pow_add = TDB.find "pow_add"
  fun op pow_mul _ = () val op pow_mul = TDB.find "pow_mul"
  fun op pow_minus1 _ = () val op pow_minus1 = TDB.find "pow_minus1"
  fun op pow_not_infty _ = ()
  val op pow_not_infty = TDB.find "pow_not_infty"
  fun op sqrt_pos_le _ = () val op sqrt_pos_le = TDB.find "sqrt_pos_le"
  fun op sqrt_pos_lt _ = () val op sqrt_pos_lt = TDB.find "sqrt_pos_lt"
  fun op pow2_sqrt _ = () val op pow2_sqrt = TDB.find "pow2_sqrt"
  fun op sqrt_pow2 _ = () val op sqrt_pow2 = TDB.find "sqrt_pow2"
  fun op sqrt_mono_le _ = () val op sqrt_mono_le = TDB.find "sqrt_mono_le"
  fun op logr_not_infty _ = ()
  val op logr_not_infty = TDB.find "logr_not_infty"
  fun op half_between _ = () val op half_between = TDB.find "half_between"
  fun op thirds_between _ = ()
  val op thirds_between = TDB.find "thirds_between"
  fun op half_cancel _ = () val op half_cancel = TDB.find "half_cancel"
  fun op third_cancel _ = () val op third_cancel = TDB.find "third_cancel"
  fun op fourth_cancel _ = ()
  val op fourth_cancel = TDB.find "fourth_cancel"
  fun op quotient_normal _ = ()
  val op quotient_normal = TDB.find "quotient_normal"
  fun op ext_mono_increasing_suc _ = ()
  val op ext_mono_increasing_suc = TDB.find "ext_mono_increasing_suc"
  fun op ext_mono_decreasing_suc _ = ()
  val op ext_mono_decreasing_suc = TDB.find "ext_mono_decreasing_suc"
  fun op EXTREAL_ARCH _ = () val op EXTREAL_ARCH = TDB.find "EXTREAL_ARCH"
  fun op SIMP_REAL_ARCH _ = ()
  val op SIMP_REAL_ARCH = TDB.find "SIMP_REAL_ARCH"
  fun op SIMP_REAL_ARCH_NEG _ = ()
  val op SIMP_REAL_ARCH_NEG = TDB.find "SIMP_REAL_ARCH_NEG"
  fun op SIMP_EXTREAL_ARCH _ = ()
  val op SIMP_EXTREAL_ARCH = TDB.find "SIMP_EXTREAL_ARCH"
  fun op REAL_ARCH_POW _ = ()
  val op REAL_ARCH_POW = TDB.find "REAL_ARCH_POW"
  fun op EXTREAL_ARCH_POW _ = ()
  val op EXTREAL_ARCH_POW = TDB.find "EXTREAL_ARCH_POW"
  fun op EXTREAL_ARCH_POW_INV _ = ()
  val op EXTREAL_ARCH_POW_INV = TDB.find "EXTREAL_ARCH_POW_INV"
  fun op REAL_LE_MUL_EPSILON _ = ()
  val op REAL_LE_MUL_EPSILON = TDB.find "REAL_LE_MUL_EPSILON"
  fun op le_epsilon _ = () val op le_epsilon = TDB.find "le_epsilon"
  fun op le_mul_epsilon _ = ()
  val op le_mul_epsilon = TDB.find "le_mul_epsilon"
  fun op EXTREAL_SUM_IMAGE_THM _ = ()
  val op EXTREAL_SUM_IMAGE_THM = TDB.find "EXTREAL_SUM_IMAGE_THM"
  fun op EXTREAL_SUM_IMAGE_NOT_NEG_INF _ = ()
  val op EXTREAL_SUM_IMAGE_NOT_NEG_INF = TDB.find
    "EXTREAL_SUM_IMAGE_NOT_NEG_INF"
  fun op EXTREAL_SUM_IMAGE_NOT_POS_INF _ = ()
  val op EXTREAL_SUM_IMAGE_NOT_POS_INF = TDB.find
    "EXTREAL_SUM_IMAGE_NOT_POS_INF"
  fun op EXTREAL_SUM_IMAGE_NOT_INFTY _ = ()
  val op EXTREAL_SUM_IMAGE_NOT_INFTY = TDB.find
    "EXTREAL_SUM_IMAGE_NOT_INFTY"
  fun op EXTREAL_SUM_IMAGE_SING _ = ()
  val op EXTREAL_SUM_IMAGE_SING = TDB.find "EXTREAL_SUM_IMAGE_SING"
  fun op EXTREAL_SUM_IMAGE_POS _ = ()
  val op EXTREAL_SUM_IMAGE_POS = TDB.find "EXTREAL_SUM_IMAGE_POS"
  fun op EXTREAL_SUM_IMAGE_SPOS _ = ()
  val op EXTREAL_SUM_IMAGE_SPOS = TDB.find "EXTREAL_SUM_IMAGE_SPOS"
  fun op EXTREAL_SUM_IMAGE_IF_ELIM _ = ()
  val op EXTREAL_SUM_IMAGE_IF_ELIM = TDB.find "EXTREAL_SUM_IMAGE_IF_ELIM"
  fun op EXTREAL_SUM_IMAGE_FINITE_SAME _ = ()
  val op EXTREAL_SUM_IMAGE_FINITE_SAME = TDB.find
    "EXTREAL_SUM_IMAGE_FINITE_SAME"
  fun op EXTREAL_SUM_IMAGE_FINITE_CONST _ = ()
  val op EXTREAL_SUM_IMAGE_FINITE_CONST = TDB.find
    "EXTREAL_SUM_IMAGE_FINITE_CONST"
  fun op EXTREAL_SUM_IMAGE_ZERO _ = ()
  val op EXTREAL_SUM_IMAGE_ZERO = TDB.find "EXTREAL_SUM_IMAGE_ZERO"
  fun op EXTREAL_SUM_IMAGE_0 _ = ()
  val op EXTREAL_SUM_IMAGE_0 = TDB.find "EXTREAL_SUM_IMAGE_0"
  fun op EXTREAL_SUM_IMAGE_IN_IF _ = ()
  val op EXTREAL_SUM_IMAGE_IN_IF = TDB.find "EXTREAL_SUM_IMAGE_IN_IF"
  fun op EXTREAL_SUM_IMAGE_CMUL _ = ()
  val op EXTREAL_SUM_IMAGE_CMUL = TDB.find "EXTREAL_SUM_IMAGE_CMUL"
  fun op EXTREAL_SUM_IMAGE_CMUL2 _ = ()
  val op EXTREAL_SUM_IMAGE_CMUL2 = TDB.find "EXTREAL_SUM_IMAGE_CMUL2"
  fun op EXTREAL_SUM_IMAGE_IMAGE _ = ()
  val op EXTREAL_SUM_IMAGE_IMAGE = TDB.find "EXTREAL_SUM_IMAGE_IMAGE"
  fun op EXTREAL_SUM_IMAGE_DISJOINT_UNION _ = ()
  val op EXTREAL_SUM_IMAGE_DISJOINT_UNION = TDB.find
    "EXTREAL_SUM_IMAGE_DISJOINT_UNION"
  fun op EXTREAL_SUM_IMAGE_EQ_CARD _ = ()
  val op EXTREAL_SUM_IMAGE_EQ_CARD = TDB.find "EXTREAL_SUM_IMAGE_EQ_CARD"
  fun op EXTREAL_SUM_IMAGE_INV_CARD_EQ_1 _ = ()
  val op EXTREAL_SUM_IMAGE_INV_CARD_EQ_1 = TDB.find
    "EXTREAL_SUM_IMAGE_INV_CARD_EQ_1"
  fun op EXTREAL_SUM_IMAGE_INTER_NONZERO _ = ()
  val op EXTREAL_SUM_IMAGE_INTER_NONZERO = TDB.find
    "EXTREAL_SUM_IMAGE_INTER_NONZERO"
  fun op EXTREAL_SUM_IMAGE_INTER_ELIM _ = ()
  val op EXTREAL_SUM_IMAGE_INTER_ELIM = TDB.find
    "EXTREAL_SUM_IMAGE_INTER_ELIM"
  fun op EXTREAL_SUM_IMAGE_ZERO_DIFF _ = ()
  val op EXTREAL_SUM_IMAGE_ZERO_DIFF = TDB.find
    "EXTREAL_SUM_IMAGE_ZERO_DIFF"
  fun op EXTREAL_SUM_IMAGE_MONO _ = ()
  val op EXTREAL_SUM_IMAGE_MONO = TDB.find "EXTREAL_SUM_IMAGE_MONO"
  fun op EXTREAL_SUM_IMAGE_MONO_SET _ = ()
  val op EXTREAL_SUM_IMAGE_MONO_SET = TDB.find "EXTREAL_SUM_IMAGE_MONO_SET"
  fun op EXTREAL_SUM_IMAGE_EQ _ = ()
  val op EXTREAL_SUM_IMAGE_EQ = TDB.find "EXTREAL_SUM_IMAGE_EQ"
  fun op EXTREAL_SUM_IMAGE_POS_MEM_LE _ = ()
  val op EXTREAL_SUM_IMAGE_POS_MEM_LE = TDB.find
    "EXTREAL_SUM_IMAGE_POS_MEM_LE"
  fun op EXTREAL_SUM_IMAGE_ADD _ = ()
  val op EXTREAL_SUM_IMAGE_ADD = TDB.find "EXTREAL_SUM_IMAGE_ADD"
  fun op EXTREAL_SUM_IMAGE_SUB _ = ()
  val op EXTREAL_SUM_IMAGE_SUB = TDB.find "EXTREAL_SUM_IMAGE_SUB"
  fun op EXTREAL_SUM_IMAGE_EXTREAL_SUM_IMAGE _ = ()
  val op EXTREAL_SUM_IMAGE_EXTREAL_SUM_IMAGE = TDB.find
    "EXTREAL_SUM_IMAGE_EXTREAL_SUM_IMAGE"
  fun op EXTREAL_SUM_IMAGE_NORMAL _ = ()
  val op EXTREAL_SUM_IMAGE_NORMAL = TDB.find "EXTREAL_SUM_IMAGE_NORMAL"
  fun op EXTREAL_SUM_IMAGE_IN_IF_ALT _ = ()
  val op EXTREAL_SUM_IMAGE_IN_IF_ALT = TDB.find
    "EXTREAL_SUM_IMAGE_IN_IF_ALT"
  fun op EXTREAL_SUM_IMAGE_CROSS_SYM _ = ()
  val op EXTREAL_SUM_IMAGE_CROSS_SYM = TDB.find
    "EXTREAL_SUM_IMAGE_CROSS_SYM"
  fun op EXTREAL_SUM_IMAGE_COUNT _ = ()
  val op EXTREAL_SUM_IMAGE_COUNT = TDB.find "EXTREAL_SUM_IMAGE_COUNT"
  fun op le_sup_imp _ = () val op le_sup_imp = TDB.find "le_sup_imp"
  fun op sup_le _ = () val op sup_le = TDB.find "sup_le"
  fun op le_sup _ = () val op le_sup = TDB.find "le_sup"
  fun op sup_eq _ = () val op sup_eq = TDB.find "sup_eq"
  fun op sup_const _ = () val op sup_const = TDB.find "sup_const"
  fun op sup_const_alt _ = ()
  val op sup_const_alt = TDB.find "sup_const_alt"
  fun op sup_const_over_set _ = ()
  val op sup_const_over_set = TDB.find "sup_const_over_set"
  fun op sup_num _ = () val op sup_num = TDB.find "sup_num"
  fun op sup_le_sup_imp _ = ()
  val op sup_le_sup_imp = TDB.find "sup_le_sup_imp"
  fun op sup_mono _ = () val op sup_mono = TDB.find "sup_mono"
  fun op sup_suc _ = () val op sup_suc = TDB.find "sup_suc"
  fun op sup_seq _ = () val op sup_seq = TDB.find "sup_seq"
  fun op sup_lt_infty _ = () val op sup_lt_infty = TDB.find "sup_lt_infty"
  fun op sup_max _ = () val op sup_max = TDB.find "sup_max"
  fun op sup_add_mono _ = () val op sup_add_mono = TDB.find "sup_add_mono"
  fun op sup_sum_mono _ = () val op sup_sum_mono = TDB.find "sup_sum_mono"
  fun op sup_le_mono _ = () val op sup_le_mono = TDB.find "sup_le_mono"
  fun op sup_cmul _ = () val op sup_cmul = TDB.find "sup_cmul"
  fun op sup_lt _ = () val op sup_lt = TDB.find "sup_lt"
  fun op sup_lt_epsilon _ = ()
  val op sup_lt_epsilon = TDB.find "sup_lt_epsilon"
  fun op inf_le_imp _ = () val op inf_le_imp = TDB.find "inf_le_imp"
  fun op le_inf _ = () val op le_inf = TDB.find "le_inf"
  fun op inf_le _ = () val op inf_le = TDB.find "inf_le"
  fun op inf_eq _ = () val op inf_eq = TDB.find "inf_eq"
  fun op inf_const _ = () val op inf_const = TDB.find "inf_const"
  fun op inf_const_alt _ = ()
  val op inf_const_alt = TDB.find "inf_const_alt"
  fun op inf_const_over_set _ = ()
  val op inf_const_over_set = TDB.find "inf_const_over_set"
  fun op inf_suc _ = () val op inf_suc = TDB.find "inf_suc"
  fun op inf_seq _ = () val op inf_seq = TDB.find "inf_seq"
  fun op inf_lt_infty _ = () val op inf_lt_infty = TDB.find "inf_lt_infty"
  fun op inf_min _ = () val op inf_min = TDB.find "inf_min"
  fun op inf_cminus _ = () val op inf_cminus = TDB.find "inf_cminus"
  fun op ext_suminf_add _ = ()
  val op ext_suminf_add = TDB.find "ext_suminf_add"
  fun op ext_suminf_cmul _ = ()
  val op ext_suminf_cmul = TDB.find "ext_suminf_cmul"
  fun op ext_suminf_cmul_alt _ = ()
  val op ext_suminf_cmul_alt = TDB.find "ext_suminf_cmul_alt"
  fun op ext_suminf_lt_infty _ = ()
  val op ext_suminf_lt_infty = TDB.find "ext_suminf_lt_infty"
  fun op ext_suminf_suminf _ = ()
  val op ext_suminf_suminf = TDB.find "ext_suminf_suminf"
  fun op ext_suminf_mono _ = ()
  val op ext_suminf_mono = TDB.find "ext_suminf_mono"
  fun op ext_suminf_sub _ = ()
  val op ext_suminf_sub = TDB.find "ext_suminf_sub"
  fun op ext_suminf_sum _ = ()
  val op ext_suminf_sum = TDB.find "ext_suminf_sum"
  fun op min_le _ = () val op min_le = TDB.find "min_le"
  fun op min_le1 _ = () val op min_le1 = TDB.find "min_le1"
  fun op min_le2 _ = () val op min_le2 = TDB.find "min_le2"
  fun op le_min _ = () val op le_min = TDB.find "le_min"
  fun op min_le2_imp _ = () val op min_le2_imp = TDB.find "min_le2_imp"
  fun op min_refl _ = () val op min_refl = TDB.find "min_refl"
  fun op min_comm _ = () val op min_comm = TDB.find "min_comm"
  fun op min_infty _ = () val op min_infty = TDB.find "min_infty"
  fun op le_max _ = () val op le_max = TDB.find "le_max"
  fun op le_max1 _ = () val op le_max1 = TDB.find "le_max1"
  fun op le_max2 _ = () val op le_max2 = TDB.find "le_max2"
  fun op max_le _ = () val op max_le = TDB.find "max_le"
  fun op max_le2_imp _ = () val op max_le2_imp = TDB.find "max_le2_imp"
  fun op max_refl _ = () val op max_refl = TDB.find "max_refl"
  fun op max_comm _ = () val op max_comm = TDB.find "max_comm"
  fun op max_infty _ = () val op max_infty = TDB.find "max_infty"
  fun op Q_not_infty _ = () val op Q_not_infty = TDB.find "Q_not_infty"
  fun op Q_COUNTABLE _ = () val op Q_COUNTABLE = TDB.find "Q_COUNTABLE"
  fun op NUM_IN_Q _ = () val op NUM_IN_Q = TDB.find "NUM_IN_Q"
  fun op Q_INFINITE _ = () val op Q_INFINITE = TDB.find "Q_INFINITE"
  fun op OPP_IN_Q _ = () val op OPP_IN_Q = TDB.find "OPP_IN_Q"
  fun op INV_IN_Q _ = () val op INV_IN_Q = TDB.find "INV_IN_Q"
  fun op CMUL_IN_Q _ = () val op CMUL_IN_Q = TDB.find "CMUL_IN_Q"
  fun op ADD_IN_Q _ = () val op ADD_IN_Q = TDB.find "ADD_IN_Q"
  fun op SUB_IN_Q _ = () val op SUB_IN_Q = TDB.find "SUB_IN_Q"
  fun op MUL_IN_Q _ = () val op MUL_IN_Q = TDB.find "MUL_IN_Q"
  fun op DIV_IN_Q _ = () val op DIV_IN_Q = TDB.find "DIV_IN_Q"
  fun op rat_not_infty _ = ()
  val op rat_not_infty = TDB.find "rat_not_infty"
  fun op CEILING_LBOUND _ = ()
  val op CEILING_LBOUND = TDB.find "CEILING_LBOUND"
  fun op CEILING_UBOUND _ = ()
  val op CEILING_UBOUND = TDB.find "CEILING_UBOUND"
  fun op Q_DENSE_IN_R_LEMMA _ = ()
  val op Q_DENSE_IN_R_LEMMA = TDB.find "Q_DENSE_IN_R_LEMMA"
  fun op Q_DENSE_IN_R _ = () val op Q_DENSE_IN_R = TDB.find "Q_DENSE_IN_R"
  fun op COUNTABLE_ENUM_Q _ = ()
  val op COUNTABLE_ENUM_Q = TDB.find "COUNTABLE_ENUM_Q"
  fun op CROSS_COUNTABLE_UNIV _ = ()
  val op CROSS_COUNTABLE_UNIV = TDB.find "CROSS_COUNTABLE_UNIV"
  fun op CROSS_COUNTABLE_LEMMA1 _ = ()
  val op CROSS_COUNTABLE_LEMMA1 = TDB.find "CROSS_COUNTABLE_LEMMA1"
  fun op CROSS_COUNTABLE_LEMMA2 _ = ()
  val op CROSS_COUNTABLE_LEMMA2 = TDB.find "CROSS_COUNTABLE_LEMMA2"
  fun op CROSS_COUNTABLE _ = ()
  val op CROSS_COUNTABLE = TDB.find "CROSS_COUNTABLE"
  fun op COUNTABLE_RATIONAL_INTERVALS _ = ()
  val op COUNTABLE_RATIONAL_INTERVALS = TDB.find
    "COUNTABLE_RATIONAL_INTERVALS"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val extreal_grammars = merge_grammars ["util_prob"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="extreal"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val extreal_grammars = 
    Portable.## (addtyUDs,addtmUDs) extreal_grammars
  val _ = Parse.grammarDB_insert("extreal",extreal_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "extreal"

end
