structure iterateTheory :> iterateTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading iterateTheory ... "
    else ()
  
  open Type Term Thm
  local open cardinalTheory util_probTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "iterate"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/iterateTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op sum_def _ = () val op sum_def = TDB.find "sum_def"
  fun op ITSET_def _ = () val op ITSET_def = TDB.find "ITSET_def"
  fun op FINREC_def _ = () val op FINREC_def = TDB.find "FINREC_def"
  fun op inf _ = () val op inf = TDB.find "inf"
  fun op numseg _ = () val op numseg = TDB.find "numseg"
  fun op neutral _ = () val op neutral = TDB.find "neutral"
  fun op monoidal _ = () val op monoidal = TDB.find "monoidal"
  fun op support _ = () val op support = TDB.find "support"
  fun op iterate _ = () val op iterate = TDB.find "iterate"
  fun op nsum_def _ = () val op nsum_def = TDB.find "nsum_def"
  fun op polynomial_function _ = ()
  val op polynomial_function = TDB.find "polynomial_function"
  fun op SUM_COMBINE_L _ = ()
  val op SUM_COMBINE_L = TDB.find "SUM_COMBINE_L"
  fun op SUM_COMBINE_R _ = ()
  val op SUM_COMBINE_R = TDB.find "SUM_COMBINE_R"
  fun op SUM_DIFFS_ALT _ = ()
  val op SUM_DIFFS_ALT = TDB.find "SUM_DIFFS_ALT"
  fun op SUM_DIFFS _ = () val op SUM_DIFFS = TDB.find "SUM_DIFFS"
  fun op SUM_PARTIAL_PRE _ = ()
  val op SUM_PARTIAL_PRE = TDB.find "SUM_PARTIAL_PRE"
  fun op SUM_PARTIAL_SUC _ = ()
  val op SUM_PARTIAL_SUC = TDB.find "SUM_PARTIAL_SUC"
  fun op REAL_OF_NUM_SUM_NUMSEG _ = ()
  val op REAL_OF_NUM_SUM_NUMSEG = TDB.find "REAL_OF_NUM_SUM_NUMSEG"
  fun op SUM_PAIR _ = () val op SUM_PAIR = TDB.find "SUM_PAIR"
  fun op SUM_CLAUSES_RIGHT _ = ()
  val op SUM_CLAUSES_RIGHT = TDB.find "SUM_CLAUSES_RIGHT"
  fun op SUM_CLAUSES_LEFT _ = ()
  val op SUM_CLAUSES_LEFT = TDB.find "SUM_CLAUSES_LEFT"
  fun op SUM_OFFSET_0 _ = () val op SUM_OFFSET_0 = TDB.find "SUM_OFFSET_0"
  fun op SUM_OFFSET _ = () val op SUM_OFFSET = TDB.find "SUM_OFFSET"
  fun op SUM_ADD_SPLIT _ = ()
  val op SUM_ADD_SPLIT = TDB.find "SUM_ADD_SPLIT"
  fun op SUM_SWAP_NUMSEG _ = ()
  val op SUM_SWAP_NUMSEG = TDB.find "SUM_SWAP_NUMSEG"
  fun op SUM_CLAUSES_NUMSEG _ = ()
  val op SUM_CLAUSES_NUMSEG = TDB.find "SUM_CLAUSES_NUMSEG"
  fun op SUM_SING_NUMSEG _ = ()
  val op SUM_SING_NUMSEG = TDB.find "SUM_SING_NUMSEG"
  fun op SUM_POS_EQ_0_NUMSEG _ = ()
  val op SUM_POS_EQ_0_NUMSEG = TDB.find "SUM_POS_EQ_0_NUMSEG"
  fun op SUM_POS_LE_NUMSEG _ = ()
  val op SUM_POS_LE_NUMSEG = TDB.find "SUM_POS_LE_NUMSEG"
  fun op SUM_TRIV_NUMSEG _ = ()
  val op SUM_TRIV_NUMSEG = TDB.find "SUM_TRIV_NUMSEG"
  fun op SUM_EQ_0_NUMSEG _ = ()
  val op SUM_EQ_0_NUMSEG = TDB.find "SUM_EQ_0_NUMSEG"
  fun op SUM_CONST_NUMSEG _ = ()
  val op SUM_CONST_NUMSEG = TDB.find "SUM_CONST_NUMSEG"
  fun op SUM_ABS_NUMSEG _ = ()
  val op SUM_ABS_NUMSEG = TDB.find "SUM_ABS_NUMSEG"
  fun op SUM_EQ_NUMSEG _ = ()
  val op SUM_EQ_NUMSEG = TDB.find "SUM_EQ_NUMSEG"
  fun op SUM_LE_NUMSEG _ = ()
  val op SUM_LE_NUMSEG = TDB.find "SUM_LE_NUMSEG"
  fun op SUM_SUB_NUMSEG _ = ()
  val op SUM_SUB_NUMSEG = TDB.find "SUM_SUB_NUMSEG"
  fun op SUM_ADD_NUMSEG _ = ()
  val op SUM_ADD_NUMSEG = TDB.find "SUM_ADD_NUMSEG"
  fun op SUM_CLOSED _ = () val op SUM_CLOSED = TDB.find "SUM_CLOSED"
  fun op SUM_IMAGE_LE _ = () val op SUM_IMAGE_LE = TDB.find "SUM_IMAGE_LE"
  fun op SUM_LE_INCLUDED _ = ()
  val op SUM_LE_INCLUDED = TDB.find "SUM_LE_INCLUDED"
  fun op SUM_CASES_1 _ = () val op SUM_CASES_1 = TDB.find "SUM_CASES_1"
  fun op SUM_CASES _ = () val op SUM_CASES = TDB.find "SUM_CASES"
  fun op SUM_BIGUNION_NONZERO _ = ()
  val op SUM_BIGUNION_NONZERO = TDB.find "SUM_BIGUNION_NONZERO"
  fun op SUM_UNION_NONZERO _ = ()
  val op SUM_UNION_NONZERO = TDB.find "SUM_UNION_NONZERO"
  fun op SUM_INJECTION _ = ()
  val op SUM_INJECTION = TDB.find "SUM_INJECTION"
  fun op SUM_EQ_GENERAL_INVERSES _ = ()
  val op SUM_EQ_GENERAL_INVERSES = TDB.find "SUM_EQ_GENERAL_INVERSES"
  fun op SUM_EQ_GENERAL _ = ()
  val op SUM_EQ_GENERAL = TDB.find "SUM_EQ_GENERAL"
  fun op SUM_SUM_PRODUCT _ = ()
  val op SUM_SUM_PRODUCT = TDB.find "SUM_SUM_PRODUCT"
  fun op SUM_BIJECTION _ = ()
  val op SUM_BIJECTION = TDB.find "SUM_BIJECTION"
  fun op SUM_IMAGE_NONZERO _ = ()
  val op SUM_IMAGE_NONZERO = TDB.find "SUM_IMAGE_NONZERO"
  fun op SUM_SUBSET_SIMPLE _ = ()
  val op SUM_SUBSET_SIMPLE = TDB.find "SUM_SUBSET_SIMPLE"
  fun op SUM_SUBSET _ = () val op SUM_SUBSET = TDB.find "SUM_SUBSET"
  fun op REAL_OF_NUM_SUM _ = ()
  val op REAL_OF_NUM_SUM = TDB.find "REAL_OF_NUM_SUM"
  fun op SUM_GROUP _ = () val op SUM_GROUP = TDB.find "SUM_GROUP"
  fun op SUM_IMAGE_GEN _ = ()
  val op SUM_IMAGE_GEN = TDB.find "SUM_IMAGE_GEN"
  fun op SUM_MULTICOUNT _ = ()
  val op SUM_MULTICOUNT = TDB.find "SUM_MULTICOUNT"
  fun op SUM_MULTICOUNT_GEN _ = ()
  val op SUM_MULTICOUNT_GEN = TDB.find "SUM_MULTICOUNT_GEN"
  fun op CARD_EQ_SUM _ = () val op CARD_EQ_SUM = TDB.find "CARD_EQ_SUM"
  fun op SUM_SUM_RESTRICT _ = ()
  val op SUM_SUM_RESTRICT = TDB.find "SUM_SUM_RESTRICT"
  fun op SUM_RESTRICT_SET _ = ()
  val op SUM_RESTRICT_SET = TDB.find "SUM_RESTRICT_SET"
  fun op SUM_EQ_SUPERSET _ = ()
  val op SUM_EQ_SUPERSET = TDB.find "SUM_EQ_SUPERSET"
  fun op SUM_UNION_EQ _ = () val op SUM_UNION_EQ = TDB.find "SUM_UNION_EQ"
  fun op SUM_BOUND_LT_GEN _ = ()
  val op SUM_BOUND_LT_GEN = TDB.find "SUM_BOUND_LT_GEN"
  fun op SUM_BOUND_LT_ALL _ = ()
  val op SUM_BOUND_LT_ALL = TDB.find "SUM_BOUND_LT_ALL"
  fun op SUM_BOUND_LT _ = () val op SUM_BOUND_LT = TDB.find "SUM_BOUND_LT"
  fun op SUM_ABS_BOUND _ = ()
  val op SUM_ABS_BOUND = TDB.find "SUM_ABS_BOUND"
  fun op SUM_BOUND_GEN _ = ()
  val op SUM_BOUND_GEN = TDB.find "SUM_BOUND_GEN"
  fun op SUM_BOUND _ = () val op SUM_BOUND = TDB.find "SUM_BOUND"
  fun op SUM_RESTRICT _ = () val op SUM_RESTRICT = TDB.find "SUM_RESTRICT"
  fun op SUM_UNION_LZERO _ = ()
  val op SUM_UNION_LZERO = TDB.find "SUM_UNION_LZERO"
  fun op SUM_UNION_RZERO _ = ()
  val op SUM_UNION_RZERO = TDB.find "SUM_UNION_RZERO"
  fun op SUM_SUPERSET _ = () val op SUM_SUPERSET = TDB.find "SUM_SUPERSET"
  fun op SUM_IMAGE _ = () val op SUM_IMAGE = TDB.find "SUM_IMAGE"
  fun op SUM_SWAP _ = () val op SUM_SWAP = TDB.find "SUM_SWAP"
  fun op SUM_DELTA _ = () val op SUM_DELTA = TDB.find "SUM_DELTA"
  fun op SUM_SING _ = () val op SUM_SING = TDB.find "SUM_SING"
  fun op SUM_DELETE_CASES _ = ()
  val op SUM_DELETE_CASES = TDB.find "SUM_DELETE_CASES"
  fun op SUM_DELETE _ = () val op SUM_DELETE = TDB.find "SUM_DELETE"
  fun op SUM_ZERO_EXISTS _ = ()
  val op SUM_ZERO_EXISTS = TDB.find "SUM_ZERO_EXISTS"
  fun op SUM_POS_EQ_0 _ = () val op SUM_POS_EQ_0 = TDB.find "SUM_POS_EQ_0"
  fun op SUM_POS_BOUND _ = ()
  val op SUM_POS_BOUND = TDB.find "SUM_POS_BOUND"
  fun op SUM_POS_LE _ = () val op SUM_POS_LE = TDB.find "SUM_POS_LE"
  fun op SUM_CONST _ = () val op SUM_CONST = TDB.find "SUM_CONST"
  fun op SUM_ABS_LE _ = () val op SUM_ABS_LE = TDB.find "SUM_ABS_LE"
  fun op SUM_ABS _ = () val op SUM_ABS = TDB.find "SUM_ABS"
  fun op SUM_EQ _ = () val op SUM_EQ = TDB.find "SUM_EQ"
  fun op SUM_POS_LT_ALL _ = ()
  val op SUM_POS_LT_ALL = TDB.find "SUM_POS_LT_ALL"
  fun op SUM_POS_LT _ = () val op SUM_POS_LT = TDB.find "SUM_POS_LT"
  fun op SUM_LT_ALL _ = () val op SUM_LT_ALL = TDB.find "SUM_LT_ALL"
  fun op SUM_LT _ = () val op SUM_LT = TDB.find "SUM_LT"
  fun op SUM_LE _ = () val op SUM_LE = TDB.find "SUM_LE"
  fun op SUM_SUB _ = () val op SUM_SUB = TDB.find "SUM_SUB"
  fun op SUM_NEG _ = () val op SUM_NEG = TDB.find "SUM_NEG"
  fun op SUM_RMUL _ = () val op SUM_RMUL = TDB.find "SUM_RMUL"
  fun op SUM_LMUL _ = () val op SUM_LMUL = TDB.find "SUM_LMUL"
  fun op SUM_0 _ = () val op SUM_0 = TDB.find "SUM_0"
  fun op SUM_EQ_0 _ = () val op SUM_EQ_0 = TDB.find "SUM_EQ_0"
  fun op SUM_ADD_GEN _ = () val op SUM_ADD_GEN = TDB.find "SUM_ADD_GEN"
  fun op SUM_ADD _ = () val op SUM_ADD = TDB.find "SUM_ADD"
  fun op SUM_SUPPORT _ = () val op SUM_SUPPORT = TDB.find "SUM_SUPPORT"
  fun op SUM_INCL_EXCL _ = ()
  val op SUM_INCL_EXCL = TDB.find "SUM_INCL_EXCL"
  fun op SUM_DIFF _ = () val op SUM_DIFF = TDB.find "SUM_DIFF"
  fun op SUM_UNION _ = () val op SUM_UNION = TDB.find "SUM_UNION"
  fun op SUM_CLAUSES _ = () val op SUM_CLAUSES = TDB.find "SUM_CLAUSES"
  fun op SUM_DEGENERATE _ = ()
  val op SUM_DEGENERATE = TDB.find "SUM_DEGENERATE"
  fun op MONOIDAL_REAL_MUL _ = ()
  val op MONOIDAL_REAL_MUL = TDB.find "MONOIDAL_REAL_MUL"
  fun op MONOIDAL_REAL_ADD _ = ()
  val op MONOIDAL_REAL_ADD = TDB.find "MONOIDAL_REAL_ADD"
  fun op NEUTRAL_REAL_MUL _ = ()
  val op NEUTRAL_REAL_MUL = TDB.find "NEUTRAL_REAL_MUL"
  fun op NEUTRAL_REAL_ADD _ = ()
  val op NEUTRAL_REAL_ADD = TDB.find "NEUTRAL_REAL_ADD"
  fun op CARD_BIGUNION _ = ()
  val op CARD_BIGUNION = TDB.find "CARD_BIGUNION"
  fun op INF_UNIQUE_FINITE _ = ()
  val op INF_UNIQUE_FINITE = TDB.find "INF_UNIQUE_FINITE"
  fun op SUP_UNIQUE_FINITE _ = ()
  val op SUP_UNIQUE_FINITE = TDB.find "SUP_UNIQUE_FINITE"
  fun op REAL_SUP_LT_FINITE _ = ()
  val op REAL_SUP_LT_FINITE = TDB.find "REAL_SUP_LT_FINITE"
  fun op REAL_LT_SUP_FINITE _ = ()
  val op REAL_LT_SUP_FINITE = TDB.find "REAL_LT_SUP_FINITE"
  fun op REAL_SUP_LE_FINITE _ = ()
  val op REAL_SUP_LE_FINITE = TDB.find "REAL_SUP_LE_FINITE"
  fun op REAL_LE_SUP_FINITE _ = ()
  val op REAL_LE_SUP_FINITE = TDB.find "REAL_LE_SUP_FINITE"
  fun op SUP_FINITE _ = () val op SUP_FINITE = TDB.find "SUP_FINITE"
  fun op SUP_FINITE_LEMMA _ = ()
  val op SUP_FINITE_LEMMA = TDB.find "SUP_FINITE_LEMMA"
  fun op SUP _ = () val op SUP = TDB.find "SUP"
  fun op SUP_EQ _ = () val op SUP_EQ = TDB.find "SUP_EQ"
  fun op sup_alt _ = () val op sup_alt = TDB.find "sup_alt"
  fun op REAL_COMPLETE _ = ()
  val op REAL_COMPLETE = TDB.find "REAL_COMPLETE"
  fun op CHOOSE_SUBSET _ = ()
  val op CHOOSE_SUBSET = TDB.find "CHOOSE_SUBSET"
  fun op CHOOSE_SUBSET_STRONG _ = ()
  val op CHOOSE_SUBSET_STRONG = TDB.find "CHOOSE_SUBSET_STRONG"
  fun op SET_PROVE_CASES _ = ()
  val op SET_PROVE_CASES = TDB.find "SET_PROVE_CASES"
  fun op real_INFINITE _ = ()
  val op real_INFINITE = TDB.find "real_INFINITE"
  fun op FINITE_REAL_INTERVAL _ = ()
  val op FINITE_REAL_INTERVAL = TDB.find "FINITE_REAL_INTERVAL"
  fun op FINITE_RESTRICT _ = ()
  val op FINITE_RESTRICT = TDB.find "FINITE_RESTRICT"
  fun op SUBSET_RESTRICT _ = ()
  val op SUBSET_RESTRICT = TDB.find "SUBSET_RESTRICT"
  fun op CARD_UNION_EQ _ = ()
  val op CARD_UNION_EQ = TDB.find "CARD_UNION_EQ"
  fun op FINITE_RECURSION _ = ()
  val op FINITE_RECURSION = TDB.find "FINITE_RECURSION"
  fun op SET_RECURSION_LEMMA _ = ()
  val op SET_RECURSION_LEMMA = TDB.find "SET_RECURSION_LEMMA"
  fun op FINREC_FUN _ = () val op FINREC_FUN = TDB.find "FINREC_FUN"
  fun op FINREC_FUN_LEMMA _ = ()
  val op FINREC_FUN_LEMMA = TDB.find "FINREC_FUN_LEMMA"
  fun op FINREC_EXISTS_LEMMA _ = ()
  val op FINREC_EXISTS_LEMMA = TDB.find "FINREC_EXISTS_LEMMA"
  fun op FINREC_UNIQUE_LEMMA _ = ()
  val op FINREC_UNIQUE_LEMMA = TDB.find "FINREC_UNIQUE_LEMMA"
  fun op FINREC_SUC_LEMMA _ = ()
  val op FINREC_SUC_LEMMA = TDB.find "FINREC_SUC_LEMMA"
  fun op FINREC_1_LEMMA _ = ()
  val op FINREC_1_LEMMA = TDB.find "FINREC_1_LEMMA"
  fun op FINREC_compute _ = ()
  val op FINREC_compute = TDB.find "FINREC_compute"
  fun op REAL_WLOG_LT _ = () val op REAL_WLOG_LT = TDB.find "REAL_WLOG_LT"
  fun op UPPER_BOUND_FINITE_SET_REAL _ = ()
  val op UPPER_BOUND_FINITE_SET_REAL = TDB.find
    "UPPER_BOUND_FINITE_SET_REAL"
  fun op LOWER_BOUND_FINITE_SET_REAL _ = ()
  val op LOWER_BOUND_FINITE_SET_REAL = TDB.find
    "LOWER_BOUND_FINITE_SET_REAL"
  fun op SIMP_REAL_ARCH _ = ()
  val op SIMP_REAL_ARCH = TDB.find "SIMP_REAL_ARCH"
  fun op REAL_LT_BETWEEN _ = ()
  val op REAL_LT_BETWEEN = TDB.find "REAL_LT_BETWEEN"
  fun op REAL_SUP_LE_EQ _ = ()
  val op REAL_SUP_LE_EQ = TDB.find "REAL_SUP_LE_EQ"
  fun op REAL_SUP_UNIQUE _ = ()
  val op REAL_SUP_UNIQUE = TDB.find "REAL_SUP_UNIQUE"
  fun op REAL_SUP_LE_S _ = ()
  val op REAL_SUP_LE_S = TDB.find "REAL_SUP_LE_S"
  fun op REAL_SUP_LE_SUBSET _ = ()
  val op REAL_SUP_LE_SUBSET = TDB.find "REAL_SUP_LE_SUBSET"
  fun op REAL_LE_SUP _ = () val op REAL_LE_SUP = TDB.find "REAL_LE_SUP"
  fun op REAL_SUP_BOUNDS _ = ()
  val op REAL_SUP_BOUNDS = TDB.find "REAL_SUP_BOUNDS"
  fun op REAL_ABS_SUP_LE _ = ()
  val op REAL_ABS_SUP_LE = TDB.find "REAL_ABS_SUP_LE"
  fun op REAL_SUP_ASCLOSE _ = ()
  val op REAL_SUP_ASCLOSE = TDB.find "REAL_SUP_ASCLOSE"
  fun op REAL_INF_ASCLOSE _ = ()
  val op REAL_INF_ASCLOSE = TDB.find "REAL_INF_ASCLOSE"
  fun op REAL_ABS_INF_LE _ = ()
  val op REAL_ABS_INF_LE = TDB.find "REAL_ABS_INF_LE"
  fun op REAL_INF_BOUNDS _ = ()
  val op REAL_INF_BOUNDS = TDB.find "REAL_INF_BOUNDS"
  fun op REAL_LE_INF_SUBSET _ = ()
  val op REAL_LE_INF_SUBSET = TDB.find "REAL_LE_INF_SUBSET"
  fun op REAL_LE_INF _ = () val op REAL_LE_INF = TDB.find "REAL_LE_INF"
  fun op REAL_INF_UNIQUE _ = ()
  val op REAL_INF_UNIQUE = TDB.find "REAL_INF_UNIQUE"
  fun op REAL_INF_LT_FINITE _ = ()
  val op REAL_INF_LT_FINITE = TDB.find "REAL_INF_LT_FINITE"
  fun op REAL_LT_INF_FINITE _ = ()
  val op REAL_LT_INF_FINITE = TDB.find "REAL_LT_INF_FINITE"
  fun op REAL_INF_LE_FINITE _ = ()
  val op REAL_INF_LE_FINITE = TDB.find "REAL_INF_LE_FINITE"
  fun op REAL_LE_INF_FINITE _ = ()
  val op REAL_LE_INF_FINITE = TDB.find "REAL_LE_INF_FINITE"
  fun op INF_FINITE _ = () val op INF_FINITE = TDB.find "INF_FINITE"
  fun op INF_FINITE_LEMMA _ = ()
  val op INF_FINITE_LEMMA = TDB.find "INF_FINITE_LEMMA"
  fun op INF _ = () val op INF = TDB.find "INF"
  fun op INF_EQ _ = () val op INF_EQ = TDB.find "INF_EQ"
  fun op SUP_UNION _ = () val op SUP_UNION = TDB.find "SUP_UNION"
  fun op SUP_UNIQUE _ = () val op SUP_UNIQUE = TDB.find "SUP_UNIQUE"
  fun op SUP_SING _ = () val op SUP_SING = TDB.find "SUP_SING"
  fun op SUP_INSERT_FINITE _ = ()
  val op SUP_INSERT_FINITE = TDB.find "SUP_INSERT_FINITE"
  fun op INF_INSERT_FINITE _ = ()
  val op INF_INSERT_FINITE = TDB.find "INF_INSERT_FINITE"
  fun op REAL_SUP_EQ_INF _ = ()
  val op REAL_SUP_EQ_INF = TDB.find "REAL_SUP_EQ_INF"
  fun op INF_SING _ = () val op INF_SING = TDB.find "INF_SING"
  fun op FINITE_NUMSEG _ = ()
  val op FINITE_NUMSEG = TDB.find "FINITE_NUMSEG"
  fun op NUMSEG_COMBINE_R _ = ()
  val op NUMSEG_COMBINE_R = TDB.find "NUMSEG_COMBINE_R"
  fun op NUMSEG_COMBINE_L _ = ()
  val op NUMSEG_COMBINE_L = TDB.find "NUMSEG_COMBINE_L"
  fun op NUMSEG_LREC _ = () val op NUMSEG_LREC = TDB.find "NUMSEG_LREC"
  fun op NUMSEG_RREC _ = () val op NUMSEG_RREC = TDB.find "NUMSEG_RREC"
  fun op NUMSEG_REC _ = () val op NUMSEG_REC = TDB.find "NUMSEG_REC"
  fun op IN_NUMSEG _ = () val op IN_NUMSEG = TDB.find "IN_NUMSEG"
  fun op IN_NUMSEG_0 _ = () val op IN_NUMSEG_0 = TDB.find "IN_NUMSEG_0"
  fun op NUMSEG_SING _ = () val op NUMSEG_SING = TDB.find "NUMSEG_SING"
  fun op NUMSEG_EMPTY _ = () val op NUMSEG_EMPTY = TDB.find "NUMSEG_EMPTY"
  fun op CARD_NUMSEG_LEMMA _ = ()
  val op CARD_NUMSEG_LEMMA = TDB.find "CARD_NUMSEG_LEMMA"
  fun op CARD_NUMSEG _ = () val op CARD_NUMSEG = TDB.find "CARD_NUMSEG"
  fun op HAS_SIZE_NUMSEG _ = ()
  val op HAS_SIZE_NUMSEG = TDB.find "HAS_SIZE_NUMSEG"
  fun op CARD_NUMSEG_1 _ = ()
  val op CARD_NUMSEG_1 = TDB.find "CARD_NUMSEG_1"
  fun op HAS_SIZE_NUMSEG_1 _ = ()
  val op HAS_SIZE_NUMSEG_1 = TDB.find "HAS_SIZE_NUMSEG_1"
  fun op NUMSEG_CLAUSES _ = ()
  val op NUMSEG_CLAUSES = TDB.find "NUMSEG_CLAUSES"
  fun op FINITE_INDEX_NUMSEG _ = ()
  val op FINITE_INDEX_NUMSEG = TDB.find "FINITE_INDEX_NUMSEG"
  fun op FINITE_INDEX_NUMBERS _ = ()
  val op FINITE_INDEX_NUMBERS = TDB.find "FINITE_INDEX_NUMBERS"
  fun op DISJOINT_NUMSEG _ = ()
  val op DISJOINT_NUMSEG = TDB.find "DISJOINT_NUMSEG"
  fun op NUMSEG_ADD_SPLIT _ = ()
  val op NUMSEG_ADD_SPLIT = TDB.find "NUMSEG_ADD_SPLIT"
  fun op NUMSEG_OFFSET_IMAGE _ = ()
  val op NUMSEG_OFFSET_IMAGE = TDB.find "NUMSEG_OFFSET_IMAGE"
  fun op SUBSET_NUMSEG _ = ()
  val op SUBSET_NUMSEG = TDB.find "SUBSET_NUMSEG"
  fun op NUMSEG_LE _ = () val op NUMSEG_LE = TDB.find "NUMSEG_LE"
  fun op NUMSEG_LT _ = () val op NUMSEG_LT = TDB.find "NUMSEG_LT"
  fun op TOPOLOGICAL_SORT _ = ()
  val op TOPOLOGICAL_SORT = TDB.find "TOPOLOGICAL_SORT"
  fun op MONOIDAL_AC _ = () val op MONOIDAL_AC = TDB.find "MONOIDAL_AC"
  fun op IN_SUPPORT _ = () val op IN_SUPPORT = TDB.find "IN_SUPPORT"
  fun op SUPPORT_SUPPORT _ = ()
  val op SUPPORT_SUPPORT = TDB.find "SUPPORT_SUPPORT"
  fun op SUPPORT_EMPTY _ = ()
  val op SUPPORT_EMPTY = TDB.find "SUPPORT_EMPTY"
  fun op SUPPORT_SUBSET _ = ()
  val op SUPPORT_SUBSET = TDB.find "SUPPORT_SUBSET"
  fun op FINITE_SUPPORT _ = ()
  val op FINITE_SUPPORT = TDB.find "FINITE_SUPPORT"
  fun op SUPPORT_CLAUSES _ = ()
  val op SUPPORT_CLAUSES = TDB.find "SUPPORT_CLAUSES"
  fun op SUPPORT_DELTA _ = ()
  val op SUPPORT_DELTA = TDB.find "SUPPORT_DELTA"
  fun op FINITE_SUPPORT_DELTA _ = ()
  val op FINITE_SUPPORT_DELTA = TDB.find "FINITE_SUPPORT_DELTA"
  fun op ITERATE_SUPPORT _ = ()
  val op ITERATE_SUPPORT = TDB.find "ITERATE_SUPPORT"
  fun op ITERATE_EXPAND_CASES _ = ()
  val op ITERATE_EXPAND_CASES = TDB.find "ITERATE_EXPAND_CASES"
  fun op ITERATE_CLAUSES_GEN _ = ()
  val op ITERATE_CLAUSES_GEN = TDB.find "ITERATE_CLAUSES_GEN"
  fun op ITERATE_CLAUSES _ = ()
  val op ITERATE_CLAUSES = TDB.find "ITERATE_CLAUSES"
  fun op ITERATE_UNION _ = ()
  val op ITERATE_UNION = TDB.find "ITERATE_UNION"
  fun op ITERATE_UNION_GEN _ = ()
  val op ITERATE_UNION_GEN = TDB.find "ITERATE_UNION_GEN"
  fun op ITERATE_DIFF _ = () val op ITERATE_DIFF = TDB.find "ITERATE_DIFF"
  fun op ITERATE_DIFF_GEN _ = ()
  val op ITERATE_DIFF_GEN = TDB.find "ITERATE_DIFF_GEN"
  fun op ITERATE_INCL_EXCL _ = ()
  val op ITERATE_INCL_EXCL = TDB.find "ITERATE_INCL_EXCL"
  fun op ITERATE_CLOSED _ = ()
  val op ITERATE_CLOSED = TDB.find "ITERATE_CLOSED"
  fun op ITERATE_RELATED _ = ()
  val op ITERATE_RELATED = TDB.find "ITERATE_RELATED"
  fun op ITERATE_EQ_NEUTRAL _ = ()
  val op ITERATE_EQ_NEUTRAL = TDB.find "ITERATE_EQ_NEUTRAL"
  fun op ITERATE_SING _ = () val op ITERATE_SING = TDB.find "ITERATE_SING"
  fun op ITERATE_DELETE _ = ()
  val op ITERATE_DELETE = TDB.find "ITERATE_DELETE"
  fun op ITERATE_DELTA _ = ()
  val op ITERATE_DELTA = TDB.find "ITERATE_DELTA"
  fun op ITERATE_IMAGE _ = ()
  val op ITERATE_IMAGE = TDB.find "ITERATE_IMAGE"
  fun op ITERATE_BIJECTION _ = ()
  val op ITERATE_BIJECTION = TDB.find "ITERATE_BIJECTION"
  fun op ITERATE_ITERATE_PRODUCT _ = ()
  val op ITERATE_ITERATE_PRODUCT = TDB.find "ITERATE_ITERATE_PRODUCT"
  fun op ITERATE_EQ _ = () val op ITERATE_EQ = TDB.find "ITERATE_EQ"
  fun op ITERATE_EQ_GENERAL _ = ()
  val op ITERATE_EQ_GENERAL = TDB.find "ITERATE_EQ_GENERAL"
  fun op ITERATE_EQ_GENERAL_INVERSES _ = ()
  val op ITERATE_EQ_GENERAL_INVERSES = TDB.find
    "ITERATE_EQ_GENERAL_INVERSES"
  fun op ITERATE_INJECTION _ = ()
  val op ITERATE_INJECTION = TDB.find "ITERATE_INJECTION"
  fun op ITERATE_UNION_NONZERO _ = ()
  val op ITERATE_UNION_NONZERO = TDB.find "ITERATE_UNION_NONZERO"
  fun op ITERATE_OP _ = () val op ITERATE_OP = TDB.find "ITERATE_OP"
  fun op ITERATE_SUPERSET _ = ()
  val op ITERATE_SUPERSET = TDB.find "ITERATE_SUPERSET"
  fun op ITERATE_IMAGE_NONZERO _ = ()
  val op ITERATE_IMAGE_NONZERO = TDB.find "ITERATE_IMAGE_NONZERO"
  fun op ITERATE_CASES _ = ()
  val op ITERATE_CASES = TDB.find "ITERATE_CASES"
  fun op ITERATE_OP_GEN _ = ()
  val op ITERATE_OP_GEN = TDB.find "ITERATE_OP_GEN"
  fun op ITERATE_CLAUSES_NUMSEG _ = ()
  val op ITERATE_CLAUSES_NUMSEG = TDB.find "ITERATE_CLAUSES_NUMSEG"
  fun op ITERATE_PAIR _ = () val op ITERATE_PAIR = TDB.find "ITERATE_PAIR"
  fun op NEUTRAL_ADD _ = () val op NEUTRAL_ADD = TDB.find "NEUTRAL_ADD"
  fun op NEUTRAL_MUL _ = () val op NEUTRAL_MUL = TDB.find "NEUTRAL_MUL"
  fun op MONOIDAL_ADD _ = () val op MONOIDAL_ADD = TDB.find "MONOIDAL_ADD"
  fun op MONOIDAL_MUL _ = () val op MONOIDAL_MUL = TDB.find "MONOIDAL_MUL"
  fun op NSUM_DEGENERATE _ = ()
  val op NSUM_DEGENERATE = TDB.find "NSUM_DEGENERATE"
  fun op NSUM_CLAUSES _ = () val op NSUM_CLAUSES = TDB.find "NSUM_CLAUSES"
  fun op NSUM_UNION _ = () val op NSUM_UNION = TDB.find "NSUM_UNION"
  fun op NSUM_DIFF _ = () val op NSUM_DIFF = TDB.find "NSUM_DIFF"
  fun op NSUM_INCL_EXCL _ = ()
  val op NSUM_INCL_EXCL = TDB.find "NSUM_INCL_EXCL"
  fun op NSUM_SUPPORT _ = () val op NSUM_SUPPORT = TDB.find "NSUM_SUPPORT"
  fun op NSUM_ADD _ = () val op NSUM_ADD = TDB.find "NSUM_ADD"
  fun op NSUM_ADD_GEN _ = () val op NSUM_ADD_GEN = TDB.find "NSUM_ADD_GEN"
  fun op NSUM_EQ_0 _ = () val op NSUM_EQ_0 = TDB.find "NSUM_EQ_0"
  fun op NSUM_0 _ = () val op NSUM_0 = TDB.find "NSUM_0"
  fun op NSUM_LMUL _ = () val op NSUM_LMUL = TDB.find "NSUM_LMUL"
  fun op NSUM_RMUL _ = () val op NSUM_RMUL = TDB.find "NSUM_RMUL"
  fun op NSUM_LE _ = () val op NSUM_LE = TDB.find "NSUM_LE"
  fun op NSUM_LT _ = () val op NSUM_LT = TDB.find "NSUM_LT"
  fun op NSUM_LT_ALL _ = () val op NSUM_LT_ALL = TDB.find "NSUM_LT_ALL"
  fun op NSUM_EQ _ = () val op NSUM_EQ = TDB.find "NSUM_EQ"
  fun op NSUM_CONST _ = () val op NSUM_CONST = TDB.find "NSUM_CONST"
  fun op NSUM_POS_BOUND _ = ()
  val op NSUM_POS_BOUND = TDB.find "NSUM_POS_BOUND"
  fun op NSUM_EQ_0_IFF _ = ()
  val op NSUM_EQ_0_IFF = TDB.find "NSUM_EQ_0_IFF"
  fun op NSUM_POS_LT _ = () val op NSUM_POS_LT = TDB.find "NSUM_POS_LT"
  fun op NSUM_POS_LT_ALL _ = ()
  val op NSUM_POS_LT_ALL = TDB.find "NSUM_POS_LT_ALL"
  fun op NSUM_DELETE _ = () val op NSUM_DELETE = TDB.find "NSUM_DELETE"
  fun op NSUM_SING _ = () val op NSUM_SING = TDB.find "NSUM_SING"
  fun op NSUM_DELTA _ = () val op NSUM_DELTA = TDB.find "NSUM_DELTA"
  fun op NSUM_SWAP _ = () val op NSUM_SWAP = TDB.find "NSUM_SWAP"
  fun op NSUM_IMAGE _ = () val op NSUM_IMAGE = TDB.find "NSUM_IMAGE"
  fun op NSUM_SUPERSET _ = ()
  val op NSUM_SUPERSET = TDB.find "NSUM_SUPERSET"
  fun op NSUM_UNION_RZERO _ = ()
  val op NSUM_UNION_RZERO = TDB.find "NSUM_UNION_RZERO"
  fun op NSUM_UNION_LZERO _ = ()
  val op NSUM_UNION_LZERO = TDB.find "NSUM_UNION_LZERO"
  fun op NSUM_RESTRICT _ = ()
  val op NSUM_RESTRICT = TDB.find "NSUM_RESTRICT"
  fun op NSUM_BOUND _ = () val op NSUM_BOUND = TDB.find "NSUM_BOUND"
  fun op NSUM_BOUND_GEN _ = ()
  val op NSUM_BOUND_GEN = TDB.find "NSUM_BOUND_GEN"
  fun op NSUM_BOUND_LT _ = ()
  val op NSUM_BOUND_LT = TDB.find "NSUM_BOUND_LT"
  fun op NSUM_BOUND_LT_ALL _ = ()
  val op NSUM_BOUND_LT_ALL = TDB.find "NSUM_BOUND_LT_ALL"
  fun op NSUM_BOUND_LT_GEN _ = ()
  val op NSUM_BOUND_LT_GEN = TDB.find "NSUM_BOUND_LT_GEN"
  fun op NSUM_UNION_EQ _ = ()
  val op NSUM_UNION_EQ = TDB.find "NSUM_UNION_EQ"
  fun op NSUM_EQ_SUPERSET _ = ()
  val op NSUM_EQ_SUPERSET = TDB.find "NSUM_EQ_SUPERSET"
  fun op NSUM_RESTRICT_SET _ = ()
  val op NSUM_RESTRICT_SET = TDB.find "NSUM_RESTRICT_SET"
  fun op NSUM_NSUM_RESTRICT _ = ()
  val op NSUM_NSUM_RESTRICT = TDB.find "NSUM_NSUM_RESTRICT"
  fun op CARD_EQ_NSUM _ = () val op CARD_EQ_NSUM = TDB.find "CARD_EQ_NSUM"
  fun op NSUM_MULTICOUNT_GEN _ = ()
  val op NSUM_MULTICOUNT_GEN = TDB.find "NSUM_MULTICOUNT_GEN"
  fun op NSUM_MULTICOUNT _ = ()
  val op NSUM_MULTICOUNT = TDB.find "NSUM_MULTICOUNT"
  fun op NSUM_IMAGE_GEN _ = ()
  val op NSUM_IMAGE_GEN = TDB.find "NSUM_IMAGE_GEN"
  fun op NSUM_GROUP _ = () val op NSUM_GROUP = TDB.find "NSUM_GROUP"
  fun op NSUM_SUBSET _ = () val op NSUM_SUBSET = TDB.find "NSUM_SUBSET"
  fun op NSUM_SUBSET_SIMPLE _ = ()
  val op NSUM_SUBSET_SIMPLE = TDB.find "NSUM_SUBSET_SIMPLE"
  fun op NSUM_LE_GEN _ = () val op NSUM_LE_GEN = TDB.find "NSUM_LE_GEN"
  fun op NSUM_IMAGE_NONZERO _ = ()
  val op NSUM_IMAGE_NONZERO = TDB.find "NSUM_IMAGE_NONZERO"
  fun op NSUM_BIJECTION _ = ()
  val op NSUM_BIJECTION = TDB.find "NSUM_BIJECTION"
  fun op NSUM_NSUM_PRODUCT _ = ()
  val op NSUM_NSUM_PRODUCT = TDB.find "NSUM_NSUM_PRODUCT"
  fun op NSUM_EQ_GENERAL _ = ()
  val op NSUM_EQ_GENERAL = TDB.find "NSUM_EQ_GENERAL"
  fun op NSUM_EQ_GENERAL_INVERSES _ = ()
  val op NSUM_EQ_GENERAL_INVERSES = TDB.find "NSUM_EQ_GENERAL_INVERSES"
  fun op NSUM_INJECTION _ = ()
  val op NSUM_INJECTION = TDB.find "NSUM_INJECTION"
  fun op NSUM_UNION_NONZERO _ = ()
  val op NSUM_UNION_NONZERO = TDB.find "NSUM_UNION_NONZERO"
  fun op NSUM_BIGUNION_NONZERO _ = ()
  val op NSUM_BIGUNION_NONZERO = TDB.find "NSUM_BIGUNION_NONZERO"
  fun op NSUM_CASES _ = () val op NSUM_CASES = TDB.find "NSUM_CASES"
  fun op NSUM_CLOSED _ = () val op NSUM_CLOSED = TDB.find "NSUM_CLOSED"
  fun op NSUM_ADD_NUMSEG _ = ()
  val op NSUM_ADD_NUMSEG = TDB.find "NSUM_ADD_NUMSEG"
  fun op NSUM_LE_NUMSEG _ = ()
  val op NSUM_LE_NUMSEG = TDB.find "NSUM_LE_NUMSEG"
  fun op NSUM_EQ_NUMSEG _ = ()
  val op NSUM_EQ_NUMSEG = TDB.find "NSUM_EQ_NUMSEG"
  fun op NSUM_CONST_NUMSEG _ = ()
  val op NSUM_CONST_NUMSEG = TDB.find "NSUM_CONST_NUMSEG"
  fun op NSUM_EQ_0_NUMSEG _ = ()
  val op NSUM_EQ_0_NUMSEG = TDB.find "NSUM_EQ_0_NUMSEG"
  fun op NSUM_EQ_0_IFF_NUMSEG _ = ()
  val op NSUM_EQ_0_IFF_NUMSEG = TDB.find "NSUM_EQ_0_IFF_NUMSEG"
  fun op NSUM_TRIV_NUMSEG _ = ()
  val op NSUM_TRIV_NUMSEG = TDB.find "NSUM_TRIV_NUMSEG"
  fun op NSUM_SING_NUMSEG _ = ()
  val op NSUM_SING_NUMSEG = TDB.find "NSUM_SING_NUMSEG"
  fun op NSUM_CLAUSES_NUMSEG _ = ()
  val op NSUM_CLAUSES_NUMSEG = TDB.find "NSUM_CLAUSES_NUMSEG"
  fun op NSUM_SWAP_NUMSEG _ = ()
  val op NSUM_SWAP_NUMSEG = TDB.find "NSUM_SWAP_NUMSEG"
  fun op NSUM_ADD_SPLIT _ = ()
  val op NSUM_ADD_SPLIT = TDB.find "NSUM_ADD_SPLIT"
  fun op NSUM_OFFSET _ = () val op NSUM_OFFSET = TDB.find "NSUM_OFFSET"
  fun op NSUM_OFFSET_0 _ = ()
  val op NSUM_OFFSET_0 = TDB.find "NSUM_OFFSET_0"
  fun op NSUM_CLAUSES_LEFT _ = ()
  val op NSUM_CLAUSES_LEFT = TDB.find "NSUM_CLAUSES_LEFT"
  fun op NSUM_CLAUSES_RIGHT _ = ()
  val op NSUM_CLAUSES_RIGHT = TDB.find "NSUM_CLAUSES_RIGHT"
  fun op NSUM_PAIR _ = () val op NSUM_PAIR = TDB.find "NSUM_PAIR"
  fun op MOD_NSUM_MOD _ = () val op MOD_NSUM_MOD = TDB.find "MOD_NSUM_MOD"
  fun op MOD_NSUM_MOD_NUMSEG _ = ()
  val op MOD_NSUM_MOD_NUMSEG = TDB.find "MOD_NSUM_MOD_NUMSEG"
  fun op TH _ = () val op TH = TDB.find "TH"
  fun op REAL_SUB_POW _ = () val op REAL_SUB_POW = TDB.find "REAL_SUB_POW"
  fun op REAL_SUB_POW_R1 _ = ()
  val op REAL_SUB_POW_R1 = TDB.find "REAL_SUB_POW_R1"
  fun op REAL_SUB_POW_L1 _ = ()
  val op REAL_SUB_POW_L1 = TDB.find "REAL_SUB_POW_L1"
  fun op FORALL_IN_GSPEC _ = ()
  val op FORALL_IN_GSPEC = TDB.find "FORALL_IN_GSPEC"
  fun op REAL_SUB_POLYFUN _ = ()
  val op REAL_SUB_POLYFUN = TDB.find "REAL_SUB_POLYFUN"
  fun op REAL_SUB_POLYFUN_ALT _ = ()
  val op REAL_SUB_POLYFUN_ALT = TDB.find "REAL_SUB_POLYFUN_ALT"
  fun op REAL_POLYFUN_ROOTBOUND _ = ()
  val op REAL_POLYFUN_ROOTBOUND = TDB.find "REAL_POLYFUN_ROOTBOUND"
  fun op REAL_POLYFUN_FINITE_ROOTS _ = ()
  val op REAL_POLYFUN_FINITE_ROOTS = TDB.find "REAL_POLYFUN_FINITE_ROOTS"
  fun op REAL_POLYFUN_EQ_0 _ = ()
  val op REAL_POLYFUN_EQ_0 = TDB.find "REAL_POLYFUN_EQ_0"
  fun op REAL_POLYFUN_EQ_CONST _ = ()
  val op REAL_POLYFUN_EQ_CONST = TDB.find "REAL_POLYFUN_EQ_CONST"
  fun op POLYNOMIAL_FUNCTION_CONST _ = ()
  val op POLYNOMIAL_FUNCTION_CONST = TDB.find "POLYNOMIAL_FUNCTION_CONST"
  fun op POLYNOMIAL_FUNCTION_ID _ = ()
  val op POLYNOMIAL_FUNCTION_ID = TDB.find "POLYNOMIAL_FUNCTION_ID"
  fun op POLYNOMIAL_FUNCTION_ADD _ = ()
  val op POLYNOMIAL_FUNCTION_ADD = TDB.find "POLYNOMIAL_FUNCTION_ADD"
  fun op POLYNOMIAL_FUNCTION_LMUL _ = ()
  val op POLYNOMIAL_FUNCTION_LMUL = TDB.find "POLYNOMIAL_FUNCTION_LMUL"
  fun op POLYNOMIAL_FUNCTION_RMUL _ = ()
  val op POLYNOMIAL_FUNCTION_RMUL = TDB.find "POLYNOMIAL_FUNCTION_RMUL"
  fun op POLYNOMIAL_FUNCTION_NEG _ = ()
  val op POLYNOMIAL_FUNCTION_NEG = TDB.find "POLYNOMIAL_FUNCTION_NEG"
  fun op POLYNOMIAL_FUNCTION_SUB _ = ()
  val op POLYNOMIAL_FUNCTION_SUB = TDB.find "POLYNOMIAL_FUNCTION_SUB"
  fun op POLYNOMIAL_FUNCTION_MUL _ = ()
  val op POLYNOMIAL_FUNCTION_MUL = TDB.find "POLYNOMIAL_FUNCTION_MUL"
  fun op POLYNOMIAL_FUNCTION_SUM _ = ()
  val op POLYNOMIAL_FUNCTION_SUM = TDB.find "POLYNOMIAL_FUNCTION_SUM"
  fun op POLYNOMIAL_FUNCTION_POW _ = ()
  val op POLYNOMIAL_FUNCTION_POW = TDB.find "POLYNOMIAL_FUNCTION_POW"
  fun op POLYNOMIAL_FUNCTION_INDUCT _ = ()
  val op POLYNOMIAL_FUNCTION_INDUCT = TDB.find "POLYNOMIAL_FUNCTION_INDUCT"
  fun op POLYNOMIAL_FUNCTION_o _ = ()
  val op POLYNOMIAL_FUNCTION_o = TDB.find "POLYNOMIAL_FUNCTION_o"
  fun op POLYNOMIAL_FUNCTION_FINITE_ROOTS _ = ()
  val op POLYNOMIAL_FUNCTION_FINITE_ROOTS = TDB.find
    "POLYNOMIAL_FUNCTION_FINITE_ROOTS"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val iterate_grammars = merge_grammars ["util_prob", "cardinal"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="iterate"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val iterate_grammars = 
    Portable.## (addtyUDs,addtmUDs) iterate_grammars
  val _ = Parse.grammarDB_insert("iterate",iterate_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "iterate"

end
