structure lebesgueTheory :> lebesgueTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading lebesgueTheory ... "
    else ()
  
  open Type Term Thm
  local open measureTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "lebesgue"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/lebesgueTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op pos_simple_fn_integral_def _ = ()
  val op pos_simple_fn_integral_def = TDB.find "pos_simple_fn_integral_def"
  fun op psfs_def _ = () val op psfs_def = TDB.find "psfs_def"
  fun op psfis_def _ = () val op psfis_def = TDB.find "psfis_def"
  fun op pos_fn_integral_def _ = ()
  val op pos_fn_integral_def = TDB.find "pos_fn_integral_def"
  fun op integral_def _ = () val op integral_def = TDB.find "integral_def"
  fun op integrable_def _ = ()
  val op integrable_def = TDB.find "integrable_def"
  fun op finite_space_integral_def _ = ()
  val op finite_space_integral_def = TDB.find "finite_space_integral_def"
  fun op prod_measure_def _ = ()
  val op prod_measure_def = TDB.find "prod_measure_def"
  fun op prod_measure_space_def _ = ()
  val op prod_measure_space_def = TDB.find "prod_measure_space_def"
  fun op prod_sets3_def _ = ()
  val op prod_sets3_def = TDB.find "prod_sets3_def"
  fun op prod_measure3_def _ = ()
  val op prod_measure3_def = TDB.find "prod_measure3_def"
  fun op prod_measure_space3_def _ = ()
  val op prod_measure_space3_def = TDB.find "prod_measure_space3_def"
  fun op fn_seq_def _ = () val op fn_seq_def = TDB.find "fn_seq_def"
  fun op fn_seq_integral_def _ = ()
  val op fn_seq_integral_def = TDB.find "fn_seq_integral_def"
  fun op seq_sup_def _ = () val op seq_sup_def = TDB.find "seq_sup_def"
  fun op max_fn_seq_def _ = ()
  val op max_fn_seq_def = TDB.find "max_fn_seq_def"
  fun op signed_measure_space_def _ = ()
  val op signed_measure_space_def = TDB.find "signed_measure_space_def"
  fun op negative_set_def _ = ()
  val op negative_set_def = TDB.find "negative_set_def"
  fun op RADON_F_def _ = () val op RADON_F_def = TDB.find "RADON_F_def"
  fun op RADON_F_integrals_def _ = ()
  val op RADON_F_integrals_def = TDB.find "RADON_F_integrals_def"
  fun op measure_absolutely_continuous_def _ = ()
  val op measure_absolutely_continuous_def = TDB.find
    "measure_absolutely_continuous_def"
  fun op pos_simple_fn_integral_present _ = ()
  val op pos_simple_fn_integral_present = TDB.find
    "pos_simple_fn_integral_present"
  fun op psfis_present _ = ()
  val op psfis_present = TDB.find "psfis_present"
  fun op pos_simple_fn_thm1 _ = ()
  val op pos_simple_fn_thm1 = TDB.find "pos_simple_fn_thm1"
  fun op pos_simple_fn_le _ = ()
  val op pos_simple_fn_le = TDB.find "pos_simple_fn_le"
  fun op pos_simple_fn_cmul _ = ()
  val op pos_simple_fn_cmul = TDB.find "pos_simple_fn_cmul"
  fun op pos_simple_fn_cmul_alt _ = ()
  val op pos_simple_fn_cmul_alt = TDB.find "pos_simple_fn_cmul_alt"
  fun op pos_simple_fn_add _ = ()
  val op pos_simple_fn_add = TDB.find "pos_simple_fn_add"
  fun op pos_simple_fn_add_alt _ = ()
  val op pos_simple_fn_add_alt = TDB.find "pos_simple_fn_add_alt"
  fun op pos_simple_fn_indicator _ = ()
  val op pos_simple_fn_indicator = TDB.find "pos_simple_fn_indicator"
  fun op pos_simple_fn_indicator_alt _ = ()
  val op pos_simple_fn_indicator_alt = TDB.find
    "pos_simple_fn_indicator_alt"
  fun op pos_simple_fn_max _ = ()
  val op pos_simple_fn_max = TDB.find "pos_simple_fn_max"
  fun op pos_simple_fn_not_infty _ = ()
  val op pos_simple_fn_not_infty = TDB.find "pos_simple_fn_not_infty"
  fun op pos_simple_fn_integral_add _ = ()
  val op pos_simple_fn_integral_add = TDB.find "pos_simple_fn_integral_add"
  fun op pos_simple_fn_integral_add_alt _ = ()
  val op pos_simple_fn_integral_add_alt = TDB.find
    "pos_simple_fn_integral_add_alt"
  fun op psfis_add _ = () val op psfis_add = TDB.find "psfis_add"
  fun op pos_simple_fn_integral_mono _ = ()
  val op pos_simple_fn_integral_mono = TDB.find
    "pos_simple_fn_integral_mono"
  fun op psfis_mono _ = () val op psfis_mono = TDB.find "psfis_mono"
  fun op pos_simple_fn_integral_unique _ = ()
  val op pos_simple_fn_integral_unique = TDB.find
    "pos_simple_fn_integral_unique"
  fun op psfis_unique _ = () val op psfis_unique = TDB.find "psfis_unique"
  fun op pos_simple_fn_integral_indicator _ = ()
  val op pos_simple_fn_integral_indicator = TDB.find
    "pos_simple_fn_integral_indicator"
  fun op psfis_indicator _ = ()
  val op psfis_indicator = TDB.find "psfis_indicator"
  fun op pos_simple_fn_integral_cmul _ = ()
  val op pos_simple_fn_integral_cmul = TDB.find
    "pos_simple_fn_integral_cmul"
  fun op psfis_cmul _ = () val op psfis_cmul = TDB.find "psfis_cmul"
  fun op pos_simple_fn_integral_cmul_alt _ = ()
  val op pos_simple_fn_integral_cmul_alt = TDB.find
    "pos_simple_fn_integral_cmul_alt"
  fun op IN_psfis _ = () val op IN_psfis = TDB.find "IN_psfis"
  fun op IN_psfis_eq _ = () val op IN_psfis_eq = TDB.find "IN_psfis_eq"
  fun op psfis_pos _ = () val op psfis_pos = TDB.find "psfis_pos"
  fun op pos_simple_fn_integral_zero _ = ()
  val op pos_simple_fn_integral_zero = TDB.find
    "pos_simple_fn_integral_zero"
  fun op pos_simple_fn_integral_zero_alt _ = ()
  val op pos_simple_fn_integral_zero_alt = TDB.find
    "pos_simple_fn_integral_zero_alt"
  fun op psfis_zero _ = () val op psfis_zero = TDB.find "psfis_zero"
  fun op pos_simple_fn_integral_not_infty _ = ()
  val op pos_simple_fn_integral_not_infty = TDB.find
    "pos_simple_fn_integral_not_infty"
  fun op psfis_not_infty _ = ()
  val op psfis_not_infty = TDB.find "psfis_not_infty"
  fun op pos_simple_fn_integral_sum _ = ()
  val op pos_simple_fn_integral_sum = TDB.find "pos_simple_fn_integral_sum"
  fun op pos_simple_fn_integral_sum_alt _ = ()
  val op pos_simple_fn_integral_sum_alt = TDB.find
    "pos_simple_fn_integral_sum_alt"
  fun op psfis_sum _ = () val op psfis_sum = TDB.find "psfis_sum"
  fun op psfis_intro _ = () val op psfis_intro = TDB.find "psfis_intro"
  fun op pos_simple_fn_integral_sub _ = ()
  val op pos_simple_fn_integral_sub = TDB.find "pos_simple_fn_integral_sub"
  fun op psfis_sub _ = () val op psfis_sub = TDB.find "psfis_sub"
  fun op pos_fn_integral_pos_simple_fn _ = ()
  val op pos_fn_integral_pos_simple_fn = TDB.find
    "pos_fn_integral_pos_simple_fn"
  fun op pos_fn_integral_mspace _ = ()
  val op pos_fn_integral_mspace = TDB.find "pos_fn_integral_mspace"
  fun op pos_fn_integral_zero _ = ()
  val op pos_fn_integral_zero = TDB.find "pos_fn_integral_zero"
  fun op pos_fn_integral_mono _ = ()
  val op pos_fn_integral_mono = TDB.find "pos_fn_integral_mono"
  fun op pos_fn_integral_mono_mspace _ = ()
  val op pos_fn_integral_mono_mspace = TDB.find
    "pos_fn_integral_mono_mspace"
  fun op pos_fn_integral_pos _ = ()
  val op pos_fn_integral_pos = TDB.find "pos_fn_integral_pos"
  fun op pos_fn_integral_cmul _ = ()
  val op pos_fn_integral_cmul = TDB.find "pos_fn_integral_cmul"
  fun op pos_fn_integral_indicator _ = ()
  val op pos_fn_integral_indicator = TDB.find "pos_fn_integral_indicator"
  fun op pos_fn_integral_cmul_indicator _ = ()
  val op pos_fn_integral_cmul_indicator = TDB.find
    "pos_fn_integral_cmul_indicator"
  fun op pos_fn_integral_sum_cmul_indicator _ = ()
  val op pos_fn_integral_sum_cmul_indicator = TDB.find
    "pos_fn_integral_sum_cmul_indicator"
  fun op lebesgue_monotone_convergence_lemma _ = ()
  val op lebesgue_monotone_convergence_lemma = TDB.find
    "lebesgue_monotone_convergence_lemma"
  fun op lebesgue_monotone_convergence _ = ()
  val op lebesgue_monotone_convergence = TDB.find
    "lebesgue_monotone_convergence"
  fun op lebesgue_monotone_convergence_subset _ = ()
  val op lebesgue_monotone_convergence_subset = TDB.find
    "lebesgue_monotone_convergence_subset"
  fun op lemma_fn_1 _ = () val op lemma_fn_1 = TDB.find "lemma_fn_1"
  fun op lemma_fn_2 _ = () val op lemma_fn_2 = TDB.find "lemma_fn_2"
  fun op lemma_fn_3 _ = () val op lemma_fn_3 = TDB.find "lemma_fn_3"
  fun op lemma_fn_4 _ = () val op lemma_fn_4 = TDB.find "lemma_fn_4"
  fun op lemma_fn_5 _ = () val op lemma_fn_5 = TDB.find "lemma_fn_5"
  fun op lemma_fn_mono_increasing _ = ()
  val op lemma_fn_mono_increasing = TDB.find "lemma_fn_mono_increasing"
  fun op lemma_fn_upper_bounded _ = ()
  val op lemma_fn_upper_bounded = TDB.find "lemma_fn_upper_bounded"
  fun op lemma_fn_sup _ = () val op lemma_fn_sup = TDB.find "lemma_fn_sup"
  fun op lemma_fn_in_psfis _ = ()
  val op lemma_fn_in_psfis = TDB.find "lemma_fn_in_psfis"
  fun op integral_sequence _ = ()
  val op integral_sequence = TDB.find "integral_sequence"
  fun op measurable_sequence _ = ()
  val op measurable_sequence = TDB.find "measurable_sequence"
  fun op pos_fn_integral_add _ = ()
  val op pos_fn_integral_add = TDB.find "pos_fn_integral_add"
  fun op pos_fn_integral_sum _ = ()
  val op pos_fn_integral_sum = TDB.find "pos_fn_integral_sum"
  fun op pos_fn_integral_disjoint_sets _ = ()
  val op pos_fn_integral_disjoint_sets = TDB.find
    "pos_fn_integral_disjoint_sets"
  fun op pos_fn_integral_disjoint_sets_sum _ = ()
  val op pos_fn_integral_disjoint_sets_sum = TDB.find
    "pos_fn_integral_disjoint_sets_sum"
  fun op pos_fn_integral_split _ = ()
  val op pos_fn_integral_split = TDB.find "pos_fn_integral_split"
  fun op pos_fn_integral_cmul_infty _ = ()
  val op pos_fn_integral_cmul_infty = TDB.find "pos_fn_integral_cmul_infty"
  fun op pos_fn_integral_suminf _ = ()
  val op pos_fn_integral_suminf = TDB.find "pos_fn_integral_suminf"
  fun op integral_pos_fn _ = ()
  val op integral_pos_fn = TDB.find "integral_pos_fn"
  fun op integrable_pos _ = ()
  val op integrable_pos = TDB.find "integrable_pos"
  fun op integrable_infty _ = ()
  val op integrable_infty = TDB.find "integrable_infty"
  fun op integrable_infty_null _ = ()
  val op integrable_infty_null = TDB.find "integrable_infty_null"
  fun op integrable_bounded _ = ()
  val op integrable_bounded = TDB.find "integrable_bounded"
  fun op integrable_fn_plus _ = ()
  val op integrable_fn_plus = TDB.find "integrable_fn_plus"
  fun op integrable_fn_minus _ = ()
  val op integrable_fn_minus = TDB.find "integrable_fn_minus"
  fun op integrable_const _ = ()
  val op integrable_const = TDB.find "integrable_const"
  fun op integrable_zero _ = ()
  val op integrable_zero = TDB.find "integrable_zero"
  fun op integrable_plus_minus _ = ()
  val op integrable_plus_minus = TDB.find "integrable_plus_minus"
  fun op integrable_add_pos _ = ()
  val op integrable_add_pos = TDB.find "integrable_add_pos"
  fun op integrable_add_lemma _ = ()
  val op integrable_add_lemma = TDB.find "integrable_add_lemma"
  fun op integrable_add _ = ()
  val op integrable_add = TDB.find "integrable_add"
  fun op integrable_cmul _ = ()
  val op integrable_cmul = TDB.find "integrable_cmul"
  fun op integrable_sub _ = ()
  val op integrable_sub = TDB.find "integrable_sub"
  fun op integrable_indicator _ = ()
  val op integrable_indicator = TDB.find "integrable_indicator"
  fun op integrable_not_infty _ = ()
  val op integrable_not_infty = TDB.find "integrable_not_infty"
  fun op integrable_not_infty_alt _ = ()
  val op integrable_not_infty_alt = TDB.find "integrable_not_infty_alt"
  fun op integrable_not_infty_alt2 _ = ()
  val op integrable_not_infty_alt2 = TDB.find "integrable_not_infty_alt2"
  fun op integrable_not_infty_alt3 _ = ()
  val op integrable_not_infty_alt3 = TDB.find "integrable_not_infty_alt3"
  fun op integral_indicator _ = ()
  val op integral_indicator = TDB.find "integral_indicator"
  fun op integral_add_lemma _ = ()
  val op integral_add_lemma = TDB.find "integral_add_lemma"
  fun op integral_add _ = () val op integral_add = TDB.find "integral_add"
  fun op integral_cmul _ = ()
  val op integral_cmul = TDB.find "integral_cmul"
  fun op integral_cmul_indicator _ = ()
  val op integral_cmul_indicator = TDB.find "integral_cmul_indicator"
  fun op integral_zero _ = ()
  val op integral_zero = TDB.find "integral_zero"
  fun op integral_mspace _ = ()
  val op integral_mspace = TDB.find "integral_mspace"
  fun op integral_mono _ = ()
  val op integral_mono = TDB.find "integral_mono"
  fun op finite_space_integral_reduce _ = ()
  val op finite_space_integral_reduce = TDB.find
    "finite_space_integral_reduce"
  fun op finite_support_integral_reduce _ = ()
  val op finite_support_integral_reduce = TDB.find
    "finite_support_integral_reduce"
  fun op finite_space_POW_integral_reduce _ = ()
  val op finite_space_POW_integral_reduce = TDB.find
    "finite_space_POW_integral_reduce"
  fun op finite_POW_prod_measure_reduce _ = ()
  val op finite_POW_prod_measure_reduce = TDB.find
    "finite_POW_prod_measure_reduce"
  fun op measure_space_finite_prod_measure_POW1 _ = ()
  val op measure_space_finite_prod_measure_POW1 = TDB.find
    "measure_space_finite_prod_measure_POW1"
  fun op measure_space_finite_prod_measure_POW2 _ = ()
  val op measure_space_finite_prod_measure_POW2 = TDB.find
    "measure_space_finite_prod_measure_POW2"
  fun op finite_prod_measure_space_POW _ = ()
  val op finite_prod_measure_space_POW = TDB.find
    "finite_prod_measure_space_POW"
  fun op finite_POW_prod_measure_reduce3 _ = ()
  val op finite_POW_prod_measure_reduce3 = TDB.find
    "finite_POW_prod_measure_reduce3"
  fun op measure_space_finite_prod_measure_POW3 _ = ()
  val op measure_space_finite_prod_measure_POW3 = TDB.find
    "measure_space_finite_prod_measure_POW3"
  fun op finite_prod_measure_space_POW3 _ = ()
  val op finite_prod_measure_space_POW3 = TDB.find
    "finite_prod_measure_space_POW3"
  fun op seq_sup_compute _ = ()
  val op seq_sup_compute = TDB.find "seq_sup_compute"
  fun op EXTREAL_SUP_SEQ _ = ()
  val op EXTREAL_SUP_SEQ = TDB.find "EXTREAL_SUP_SEQ"
  fun op EXTREAL_SUP_FUN_SEQ_IMAGE _ = ()
  val op EXTREAL_SUP_FUN_SEQ_IMAGE = TDB.find "EXTREAL_SUP_FUN_SEQ_IMAGE"
  fun op max_fn_seq_compute _ = ()
  val op max_fn_seq_compute = TDB.find "max_fn_seq_compute"
  fun op max_fn_seq_mono _ = ()
  val op max_fn_seq_mono = TDB.find "max_fn_seq_mono"
  fun op EXTREAL_SUP_FUN_SEQ_MONO_IMAGE _ = ()
  val op EXTREAL_SUP_FUN_SEQ_MONO_IMAGE = TDB.find
    "EXTREAL_SUP_FUN_SEQ_MONO_IMAGE"
  fun op lemma_radon_max_in_F _ = ()
  val op lemma_radon_max_in_F = TDB.find "lemma_radon_max_in_F"
  fun op lemma_radon_seq_conv_sup _ = ()
  val op lemma_radon_seq_conv_sup = TDB.find "lemma_radon_seq_conv_sup"
  fun op RN_lemma1 _ = () val op RN_lemma1 = TDB.find "RN_lemma1"
  fun op RN_lemma2 _ = () val op RN_lemma2 = TDB.find "RN_lemma2"
  fun op Radon_Nikodym _ = ()
  val op Radon_Nikodym = TDB.find "Radon_Nikodym"
  fun op Radon_Nikodym2 _ = ()
  val op Radon_Nikodym2 = TDB.find "Radon_Nikodym2"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val lebesgue_grammars = merge_grammars ["measure"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="lebesgue"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val lebesgue_grammars = 
    Portable.## (addtyUDs,addtmUDs) lebesgue_grammars
  val _ = Parse.grammarDB_insert("lebesgue",lebesgue_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "lebesgue"

end
