structure measureTheory :> measureTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading measureTheory ... "
    else ()
  
  open Type Term Thm
  local open extrealTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "measure"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/measureTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op space_def _ = () val op space_def = TDB.find "space_def"
  fun op subsets_def _ = () val op subsets_def = TDB.find "subsets_def"
  fun op subset_class_def _ = ()
  val op subset_class_def = TDB.find "subset_class_def"
  fun op algebra_def _ = () val op algebra_def = TDB.find "algebra_def"
  fun op sigma_algebra_def _ = ()
  val op sigma_algebra_def = TDB.find "sigma_algebra_def"
  fun op sigma_def _ = () val op sigma_def = TDB.find "sigma_def"
  fun op m_space_def _ = () val op m_space_def = TDB.find "m_space_def"
  fun op measurable_sets_def _ = ()
  val op measurable_sets_def = TDB.find "measurable_sets_def"
  fun op measure_def _ = () val op measure_def = TDB.find "measure_def"
  fun op positive_def _ = () val op positive_def = TDB.find "positive_def"
  fun op additive_def _ = () val op additive_def = TDB.find "additive_def"
  fun op countably_additive_def _ = ()
  val op countably_additive_def = TDB.find "countably_additive_def"
  fun op subadditive_def _ = ()
  val op subadditive_def = TDB.find "subadditive_def"
  fun op countably_subadditive_def _ = ()
  val op countably_subadditive_def = TDB.find "countably_subadditive_def"
  fun op increasing_def _ = ()
  val op increasing_def = TDB.find "increasing_def"
  fun op measure_space_def _ = ()
  val op measure_space_def = TDB.find "measure_space_def"
  fun op lambda_system_def _ = ()
  val op lambda_system_def = TDB.find "lambda_system_def"
  fun op outer_measure_space_def _ = ()
  val op outer_measure_space_def = TDB.find "outer_measure_space_def"
  fun op inf_measure_def _ = ()
  val op inf_measure_def = TDB.find "inf_measure_def"
  fun op closed_cdi_def _ = ()
  val op closed_cdi_def = TDB.find "closed_cdi_def"
  fun op smallest_closed_cdi_def _ = ()
  val op smallest_closed_cdi_def = TDB.find "smallest_closed_cdi_def"
  fun op measurable_def _ = ()
  val op measurable_def = TDB.find "measurable_def"
  fun op measure_preserving_def _ = ()
  val op measure_preserving_def = TDB.find "measure_preserving_def"
  fun op indicator_fn_def _ = ()
  val op indicator_fn_def = TDB.find "indicator_fn_def"
  fun op pos_simple_fn_def _ = ()
  val op pos_simple_fn_def = TDB.find "pos_simple_fn_def"
  fun op null_set_def _ = () val op null_set_def = TDB.find "null_set_def"
  fun op Borel_def _ = () val op Borel_def = TDB.find "Borel_def"
  fun op fn_plus_def _ = () val op fn_plus_def = TDB.find "fn_plus_def"
  fun op fn_minus_def _ = () val op fn_minus_def = TDB.find "fn_minus_def"
  fun op fn_abs_def _ = () val op fn_abs_def = TDB.find "fn_abs_def"
  fun op SIGMA_PROPERTY_DISJOINT_LEMMA _ = ()
  val op SIGMA_PROPERTY_DISJOINT_LEMMA = TDB.find
    "SIGMA_PROPERTY_DISJOINT_LEMMA"
  fun op SIGMA_PROPERTY_DISJOINT_LEMMA2 _ = ()
  val op SIGMA_PROPERTY_DISJOINT_LEMMA2 = TDB.find
    "SIGMA_PROPERTY_DISJOINT_LEMMA2"
  fun op SIGMA_PROPERTY_DISJOINT_LEMMA1 _ = ()
  val op SIGMA_PROPERTY_DISJOINT_LEMMA1 = TDB.find
    "SIGMA_PROPERTY_DISJOINT_LEMMA1"
  fun op CLOSED_CDI_INCREASING _ = ()
  val op CLOSED_CDI_INCREASING = TDB.find "CLOSED_CDI_INCREASING"
  fun op CLOSED_CDI_DISJOINT _ = ()
  val op CLOSED_CDI_DISJOINT = TDB.find "CLOSED_CDI_DISJOINT"
  fun op CLOSED_CDI_COMPL _ = ()
  val op CLOSED_CDI_COMPL = TDB.find "CLOSED_CDI_COMPL"
  fun op CLOSED_CDI_DUNION _ = ()
  val op CLOSED_CDI_DUNION = TDB.find "CLOSED_CDI_DUNION"
  fun op SMALLEST_CLOSED_CDI _ = ()
  val op SMALLEST_CLOSED_CDI = TDB.find "SMALLEST_CLOSED_CDI"
  fun op SPACE_SMALLEST_CLOSED_CDI _ = ()
  val op SPACE_SMALLEST_CLOSED_CDI = TDB.find "SPACE_SMALLEST_CLOSED_CDI"
  fun op SPACE _ = () val op SPACE = TDB.find "SPACE"
  fun op ALGEBRA_ALT_INTER _ = ()
  val op ALGEBRA_ALT_INTER = TDB.find "ALGEBRA_ALT_INTER"
  fun op ALGEBRA_EMPTY _ = ()
  val op ALGEBRA_EMPTY = TDB.find "ALGEBRA_EMPTY"
  fun op ALGEBRA_SPACE _ = ()
  val op ALGEBRA_SPACE = TDB.find "ALGEBRA_SPACE"
  fun op ALGEBRA_COMPL _ = ()
  val op ALGEBRA_COMPL = TDB.find "ALGEBRA_COMPL"
  fun op ALGEBRA_UNION _ = ()
  val op ALGEBRA_UNION = TDB.find "ALGEBRA_UNION"
  fun op ALGEBRA_INTER _ = ()
  val op ALGEBRA_INTER = TDB.find "ALGEBRA_INTER"
  fun op ALGEBRA_DIFF _ = () val op ALGEBRA_DIFF = TDB.find "ALGEBRA_DIFF"
  fun op ALGEBRA_FINITE_UNION _ = ()
  val op ALGEBRA_FINITE_UNION = TDB.find "ALGEBRA_FINITE_UNION"
  fun op ALGEBRA_INTER_SPACE _ = ()
  val op ALGEBRA_INTER_SPACE = TDB.find "ALGEBRA_INTER_SPACE"
  fun op LAMBDA_SYSTEM_EMPTY _ = ()
  val op LAMBDA_SYSTEM_EMPTY = TDB.find "LAMBDA_SYSTEM_EMPTY"
  fun op LAMBDA_SYSTEM_COMPL _ = ()
  val op LAMBDA_SYSTEM_COMPL = TDB.find "LAMBDA_SYSTEM_COMPL"
  fun op LAMBDA_SYSTEM_INTER _ = ()
  val op LAMBDA_SYSTEM_INTER = TDB.find "LAMBDA_SYSTEM_INTER"
  fun op LAMBDA_SYSTEM_ALGEBRA _ = ()
  val op LAMBDA_SYSTEM_ALGEBRA = TDB.find "LAMBDA_SYSTEM_ALGEBRA"
  fun op LAMBDA_SYSTEM_STRONG_ADDITIVE _ = ()
  val op LAMBDA_SYSTEM_STRONG_ADDITIVE = TDB.find
    "LAMBDA_SYSTEM_STRONG_ADDITIVE"
  fun op LAMBDA_SYSTEM_ADDITIVE _ = ()
  val op LAMBDA_SYSTEM_ADDITIVE = TDB.find "LAMBDA_SYSTEM_ADDITIVE"
  fun op COUNTABLY_SUBADDITIVE_SUBADDITIVE _ = ()
  val op COUNTABLY_SUBADDITIVE_SUBADDITIVE = TDB.find
    "COUNTABLY_SUBADDITIVE_SUBADDITIVE"
  fun op SIGMA_ALGEBRA_ALT _ = ()
  val op SIGMA_ALGEBRA_ALT = TDB.find "SIGMA_ALGEBRA_ALT"
  fun op SIGMA_ALGEBRA_ALT_MONO _ = ()
  val op SIGMA_ALGEBRA_ALT_MONO = TDB.find "SIGMA_ALGEBRA_ALT_MONO"
  fun op SIGMA_ALGEBRA_ALT_DISJOINT _ = ()
  val op SIGMA_ALGEBRA_ALT_DISJOINT = TDB.find "SIGMA_ALGEBRA_ALT_DISJOINT"
  fun op SUBADDITIVE _ = () val op SUBADDITIVE = TDB.find "SUBADDITIVE"
  fun op ADDITIVE _ = () val op ADDITIVE = TDB.find "ADDITIVE"
  fun op COUNTABLY_SUBADDITIVE _ = ()
  val op COUNTABLY_SUBADDITIVE = TDB.find "COUNTABLY_SUBADDITIVE"
  fun op ADDITIVE_SUM _ = () val op ADDITIVE_SUM = TDB.find "ADDITIVE_SUM"
  fun op INCREASING_ADDITIVE_SUMMABLE _ = ()
  val op INCREASING_ADDITIVE_SUMMABLE = TDB.find
    "INCREASING_ADDITIVE_SUMMABLE"
  fun op LAMBDA_SYSTEM_POSITIVE _ = ()
  val op LAMBDA_SYSTEM_POSITIVE = TDB.find "LAMBDA_SYSTEM_POSITIVE"
  fun op LAMBDA_SYSTEM_INCREASING _ = ()
  val op LAMBDA_SYSTEM_INCREASING = TDB.find "LAMBDA_SYSTEM_INCREASING"
  fun op LAMBDA_SYSTEM_STRONG_SUM _ = ()
  val op LAMBDA_SYSTEM_STRONG_SUM = TDB.find "LAMBDA_SYSTEM_STRONG_SUM"
  fun op SIGMA_ALGEBRA_ALGEBRA _ = ()
  val op SIGMA_ALGEBRA_ALGEBRA = TDB.find "SIGMA_ALGEBRA_ALGEBRA"
  fun op OUTER_MEASURE_SPACE_POSITIVE _ = ()
  val op OUTER_MEASURE_SPACE_POSITIVE = TDB.find
    "OUTER_MEASURE_SPACE_POSITIVE"
  fun op LAMBDA_SYSTEM_CARATHEODORY _ = ()
  val op LAMBDA_SYSTEM_CARATHEODORY = TDB.find "LAMBDA_SYSTEM_CARATHEODORY"
  fun op CARATHEODORY_LEMMA _ = ()
  val op CARATHEODORY_LEMMA = TDB.find "CARATHEODORY_LEMMA"
  fun op INF_MEASURE_NONEMPTY _ = ()
  val op INF_MEASURE_NONEMPTY = TDB.find "INF_MEASURE_NONEMPTY"
  fun op INF_MEASURE_POS0 _ = ()
  val op INF_MEASURE_POS0 = TDB.find "INF_MEASURE_POS0"
  fun op INF_MEASURE_POS _ = ()
  val op INF_MEASURE_POS = TDB.find "INF_MEASURE_POS"
  fun op INCREASING _ = () val op INCREASING = TDB.find "INCREASING"
  fun op ADDITIVE_INCREASING _ = ()
  val op ADDITIVE_INCREASING = TDB.find "ADDITIVE_INCREASING"
  fun op COUNTABLY_ADDITIVE_ADDITIVE _ = ()
  val op COUNTABLY_ADDITIVE_ADDITIVE = TDB.find
    "COUNTABLY_ADDITIVE_ADDITIVE"
  fun op COUNTABLY_ADDITIVE _ = ()
  val op COUNTABLY_ADDITIVE = TDB.find "COUNTABLY_ADDITIVE"
  fun op INF_MEASURE_AGREES _ = ()
  val op INF_MEASURE_AGREES = TDB.find "INF_MEASURE_AGREES"
  fun op MEASURE_DOWN _ = () val op MEASURE_DOWN = TDB.find "MEASURE_DOWN"
  fun op SIGMA_ALGEBRA_SIGMA _ = ()
  val op SIGMA_ALGEBRA_SIGMA = TDB.find "SIGMA_ALGEBRA_SIGMA"
  fun op POW_ALGEBRA _ = () val op POW_ALGEBRA = TDB.find "POW_ALGEBRA"
  fun op POW_SIGMA_ALGEBRA _ = ()
  val op POW_SIGMA_ALGEBRA = TDB.find "POW_SIGMA_ALGEBRA"
  fun op UNIV_SIGMA_ALGEBRA _ = ()
  val op UNIV_SIGMA_ALGEBRA = TDB.find "UNIV_SIGMA_ALGEBRA"
  fun op INF_MEASURE_EMPTY _ = ()
  val op INF_MEASURE_EMPTY = TDB.find "INF_MEASURE_EMPTY"
  fun op INF_MEASURE_POSITIVE _ = ()
  val op INF_MEASURE_POSITIVE = TDB.find "INF_MEASURE_POSITIVE"
  fun op INF_MEASURE_INCREASING _ = ()
  val op INF_MEASURE_INCREASING = TDB.find "INF_MEASURE_INCREASING"
  fun op INF_MEASURE_LE _ = ()
  val op INF_MEASURE_LE = TDB.find "INF_MEASURE_LE"
  fun op INF_MEASURE_CLOSE _ = ()
  val op INF_MEASURE_CLOSE = TDB.find "INF_MEASURE_CLOSE"
  fun op INF_MEASURE_COUNTABLY_SUBADDITIVE _ = ()
  val op INF_MEASURE_COUNTABLY_SUBADDITIVE = TDB.find
    "INF_MEASURE_COUNTABLY_SUBADDITIVE"
  fun op INF_MEASURE_OUTER _ = ()
  val op INF_MEASURE_OUTER = TDB.find "INF_MEASURE_OUTER"
  fun op SIGMA_SUBSET _ = () val op SIGMA_SUBSET = TDB.find "SIGMA_SUBSET"
  fun op ALGEBRA_SUBSET_LAMBDA_SYSTEM _ = ()
  val op ALGEBRA_SUBSET_LAMBDA_SYSTEM = TDB.find
    "ALGEBRA_SUBSET_LAMBDA_SYSTEM"
  fun op CARATHEODORY _ = () val op CARATHEODORY = TDB.find "CARATHEODORY"
  fun op SIGMA_SUBSET_SUBSETS _ = ()
  val op SIGMA_SUBSET_SUBSETS = TDB.find "SIGMA_SUBSET_SUBSETS"
  fun op IN_SIGMA _ = () val op IN_SIGMA = TDB.find "IN_SIGMA"
  fun op SIGMA_ALGEBRA _ = ()
  val op SIGMA_ALGEBRA = TDB.find "SIGMA_ALGEBRA"
  fun op SIGMA_ALGEBRA_COUNTABLE_UNION _ = ()
  val op SIGMA_ALGEBRA_COUNTABLE_UNION = TDB.find
    "SIGMA_ALGEBRA_COUNTABLE_UNION"
  fun op SIGMA_ALGEBRA_ENUM _ = ()
  val op SIGMA_ALGEBRA_ENUM = TDB.find "SIGMA_ALGEBRA_ENUM"
  fun op MEASURE_COMPL _ = ()
  val op MEASURE_COMPL = TDB.find "MEASURE_COMPL"
  fun op SIGMA_PROPERTY _ = ()
  val op SIGMA_PROPERTY = TDB.find "SIGMA_PROPERTY"
  fun op MEASURE_EMPTY _ = ()
  val op MEASURE_EMPTY = TDB.find "MEASURE_EMPTY"
  fun op SIGMA_SUBSET_MEASURABLE_SETS _ = ()
  val op SIGMA_SUBSET_MEASURABLE_SETS = TDB.find
    "SIGMA_SUBSET_MEASURABLE_SETS"
  fun op SIGMA_ALGEBRA_FN _ = ()
  val op SIGMA_ALGEBRA_FN = TDB.find "SIGMA_ALGEBRA_FN"
  fun op SIGMA_ALGEBRA_FN_DISJOINT _ = ()
  val op SIGMA_ALGEBRA_FN_DISJOINT = TDB.find "SIGMA_ALGEBRA_FN_DISJOINT"
  fun op SIGMA_PROPERTY_ALT _ = ()
  val op SIGMA_PROPERTY_ALT = TDB.find "SIGMA_PROPERTY_ALT"
  fun op SIGMA_PROPERTY_DISJOINT_WEAK _ = ()
  val op SIGMA_PROPERTY_DISJOINT_WEAK = TDB.find
    "SIGMA_PROPERTY_DISJOINT_WEAK"
  fun op SIGMA_PROPERTY_DISJOINT _ = ()
  val op SIGMA_PROPERTY_DISJOINT = TDB.find "SIGMA_PROPERTY_DISJOINT"
  fun op MEASURE_COUNTABLY_ADDITIVE _ = ()
  val op MEASURE_COUNTABLY_ADDITIVE = TDB.find "MEASURE_COUNTABLY_ADDITIVE"
  fun op MEASURE_SPACE_ADDITIVE _ = ()
  val op MEASURE_SPACE_ADDITIVE = TDB.find "MEASURE_SPACE_ADDITIVE"
  fun op MEASURE_ADDITIVE _ = ()
  val op MEASURE_ADDITIVE = TDB.find "MEASURE_ADDITIVE"
  fun op MEASURE_COUNTABLE_INCREASING _ = ()
  val op MEASURE_COUNTABLE_INCREASING = TDB.find
    "MEASURE_COUNTABLE_INCREASING"
  fun op MEASURE_SPACE_REDUCE _ = ()
  val op MEASURE_SPACE_REDUCE = TDB.find "MEASURE_SPACE_REDUCE"
  fun op SPACE_SIGMA _ = () val op SPACE_SIGMA = TDB.find "SPACE_SIGMA"
  fun op MONOTONE_CONVERGENCE _ = ()
  val op MONOTONE_CONVERGENCE = TDB.find "MONOTONE_CONVERGENCE"
  fun op SIGMA_REDUCE _ = () val op SIGMA_REDUCE = TDB.find "SIGMA_REDUCE"
  fun op MEASURABLE_SETS_SUBSET_SPACE _ = ()
  val op MEASURABLE_SETS_SUBSET_SPACE = TDB.find
    "MEASURABLE_SETS_SUBSET_SPACE"
  fun op MEASURABLE_DIFF_PROPERTY _ = ()
  val op MEASURABLE_DIFF_PROPERTY = TDB.find "MEASURABLE_DIFF_PROPERTY"
  fun op MEASURABLE_BIGUNION_PROPERTY _ = ()
  val op MEASURABLE_BIGUNION_PROPERTY = TDB.find
    "MEASURABLE_BIGUNION_PROPERTY"
  fun op MEASUBABLE_BIGUNION_LEMMA _ = ()
  val op MEASUBABLE_BIGUNION_LEMMA = TDB.find "MEASUBABLE_BIGUNION_LEMMA"
  fun op MEASURABLE_SIGMA_PREIMAGES _ = ()
  val op MEASURABLE_SIGMA_PREIMAGES = TDB.find "MEASURABLE_SIGMA_PREIMAGES"
  fun op IN_MEASURABLE _ = ()
  val op IN_MEASURABLE = TDB.find "IN_MEASURABLE"
  fun op MEASURABLE_SIGMA _ = ()
  val op MEASURABLE_SIGMA = TDB.find "MEASURABLE_SIGMA"
  fun op MEASURABLE_SUBSET _ = ()
  val op MEASURABLE_SUBSET = TDB.find "MEASURABLE_SUBSET"
  fun op MEASURABLE_LIFT _ = ()
  val op MEASURABLE_LIFT = TDB.find "MEASURABLE_LIFT"
  fun op IN_MEASURE_PRESERVING _ = ()
  val op IN_MEASURE_PRESERVING = TDB.find "IN_MEASURE_PRESERVING"
  fun op MEASURE_PRESERVING_LIFT _ = ()
  val op MEASURE_PRESERVING_LIFT = TDB.find "MEASURE_PRESERVING_LIFT"
  fun op MEASURE_PRESERVING_SUBSET _ = ()
  val op MEASURE_PRESERVING_SUBSET = TDB.find "MEASURE_PRESERVING_SUBSET"
  fun op MEASURABLE_I _ = () val op MEASURABLE_I = TDB.find "MEASURABLE_I"
  fun op MEASURABLE_COMP _ = ()
  val op MEASURABLE_COMP = TDB.find "MEASURABLE_COMP"
  fun op MEASURABLE_COMP_STRONG _ = ()
  val op MEASURABLE_COMP_STRONG = TDB.find "MEASURABLE_COMP_STRONG"
  fun op MEASURABLE_COMP_STRONGER _ = ()
  val op MEASURABLE_COMP_STRONGER = TDB.find "MEASURABLE_COMP_STRONGER"
  fun op MEASURABLE_UP_LIFT _ = ()
  val op MEASURABLE_UP_LIFT = TDB.find "MEASURABLE_UP_LIFT"
  fun op MEASURABLE_UP_SUBSET _ = ()
  val op MEASURABLE_UP_SUBSET = TDB.find "MEASURABLE_UP_SUBSET"
  fun op MEASURABLE_UP_SIGMA _ = ()
  val op MEASURABLE_UP_SIGMA = TDB.find "MEASURABLE_UP_SIGMA"
  fun op MEASURE_PRESERVING_UP_LIFT _ = ()
  val op MEASURE_PRESERVING_UP_LIFT = TDB.find "MEASURE_PRESERVING_UP_LIFT"
  fun op MEASURE_PRESERVING_UP_SUBSET _ = ()
  val op MEASURE_PRESERVING_UP_SUBSET = TDB.find
    "MEASURE_PRESERVING_UP_SUBSET"
  fun op MEASURE_PRESERVING_UP_SIGMA _ = ()
  val op MEASURE_PRESERVING_UP_SIGMA = TDB.find
    "MEASURE_PRESERVING_UP_SIGMA"
  fun op MEASURABLE_PROD_SIGMA _ = ()
  val op MEASURABLE_PROD_SIGMA = TDB.find "MEASURABLE_PROD_SIGMA"
  fun op MEASURABLE_RANGE_REDUCE _ = ()
  val op MEASURABLE_RANGE_REDUCE = TDB.find "MEASURABLE_RANGE_REDUCE"
  fun op MEASURABLE_POW_TO_POW _ = ()
  val op MEASURABLE_POW_TO_POW = TDB.find "MEASURABLE_POW_TO_POW"
  fun op MEASURABLE_POW_TO_POW_IMAGE _ = ()
  val op MEASURABLE_POW_TO_POW_IMAGE = TDB.find
    "MEASURABLE_POW_TO_POW_IMAGE"
  fun op MEASURE_SPACE_SUBSET _ = ()
  val op MEASURE_SPACE_SUBSET = TDB.find "MEASURE_SPACE_SUBSET"
  fun op STRONG_MEASURE_SPACE_SUBSET _ = ()
  val op STRONG_MEASURE_SPACE_SUBSET = TDB.find
    "STRONG_MEASURE_SPACE_SUBSET"
  fun op MEASURE_REAL_SUM_IMAGE _ = ()
  val op MEASURE_REAL_SUM_IMAGE = TDB.find "MEASURE_REAL_SUM_IMAGE"
  fun op SIGMA_POW _ = () val op SIGMA_POW = TDB.find "SIGMA_POW"
  fun op finite_additivity_sufficient_for_finite_spaces _ = ()
  val op finite_additivity_sufficient_for_finite_spaces = TDB.find
    "finite_additivity_sufficient_for_finite_spaces"
  fun op finite_additivity_sufficient_for_finite_spaces2 _ = ()
  val op finite_additivity_sufficient_for_finite_spaces2 = TDB.find
    "finite_additivity_sufficient_for_finite_spaces2"
  fun op IMAGE_SING _ = () val op IMAGE_SING = TDB.find "IMAGE_SING"
  fun op SUBSET_BIGINTER _ = ()
  val op SUBSET_BIGINTER = TDB.find "SUBSET_BIGINTER"
  fun op MEASURE_SPACE_INCREASING _ = ()
  val op MEASURE_SPACE_INCREASING = TDB.find "MEASURE_SPACE_INCREASING"
  fun op MEASURE_SPACE_POSITIVE _ = ()
  val op MEASURE_SPACE_POSITIVE = TDB.find "MEASURE_SPACE_POSITIVE"
  fun op MEASURE_SPACE_INTER _ = ()
  val op MEASURE_SPACE_INTER = TDB.find "MEASURE_SPACE_INTER"
  fun op MEASURE_SPACE_UNION _ = ()
  val op MEASURE_SPACE_UNION = TDB.find "MEASURE_SPACE_UNION"
  fun op MEASURE_SPACE_DIFF _ = ()
  val op MEASURE_SPACE_DIFF = TDB.find "MEASURE_SPACE_DIFF"
  fun op MEASURE_COMPL_SUBSET _ = ()
  val op MEASURE_COMPL_SUBSET = TDB.find "MEASURE_COMPL_SUBSET"
  fun op MEASURE_SPACE_BIGUNION _ = ()
  val op MEASURE_SPACE_BIGUNION = TDB.find "MEASURE_SPACE_BIGUNION"
  fun op MEASURE_SPACE_IN_MSPACE _ = ()
  val op MEASURE_SPACE_IN_MSPACE = TDB.find "MEASURE_SPACE_IN_MSPACE"
  fun op MEASURE_SPACE_SUBSET_MSPACE _ = ()
  val op MEASURE_SPACE_SUBSET_MSPACE = TDB.find
    "MEASURE_SPACE_SUBSET_MSPACE"
  fun op MEASURE_SPACE_EMPTY_MEASURABLE _ = ()
  val op MEASURE_SPACE_EMPTY_MEASURABLE = TDB.find
    "MEASURE_SPACE_EMPTY_MEASURABLE"
  fun op MEASURE_SPACE_MSPACE_MEASURABLE _ = ()
  val op MEASURE_SPACE_MSPACE_MEASURABLE = TDB.find
    "MEASURE_SPACE_MSPACE_MEASURABLE"
  fun op SIGMA_ALGEBRA_FN_BIGINTER _ = ()
  val op SIGMA_ALGEBRA_FN_BIGINTER = TDB.find "SIGMA_ALGEBRA_FN_BIGINTER"
  fun op MEASURE_SPACE_BIGINTER _ = ()
  val op MEASURE_SPACE_BIGINTER = TDB.find "MEASURE_SPACE_BIGINTER"
  fun op MONOTONE_CONVERGENCE2 _ = ()
  val op MONOTONE_CONVERGENCE2 = TDB.find "MONOTONE_CONVERGENCE2"
  fun op MONOTONE_CONVERGENCE_BIGINTER _ = ()
  val op MONOTONE_CONVERGENCE_BIGINTER = TDB.find
    "MONOTONE_CONVERGENCE_BIGINTER"
  fun op MONOTONE_CONVERGENCE_BIGINTER2 _ = ()
  val op MONOTONE_CONVERGENCE_BIGINTER2 = TDB.find
    "MONOTONE_CONVERGENCE_BIGINTER2"
  fun op MEASURE_SPACE_RESTRICTED _ = ()
  val op MEASURE_SPACE_RESTRICTED = TDB.find "MEASURE_SPACE_RESTRICTED"
  fun op MEASURE_SPACE_CMUL _ = ()
  val op MEASURE_SPACE_CMUL = TDB.find "MEASURE_SPACE_CMUL"
  fun op BIGUNION_IMAGE_Q _ = ()
  val op BIGUNION_IMAGE_Q = TDB.find "BIGUNION_IMAGE_Q"
  fun op SIGMA_ALGEBRA_BOREL _ = ()
  val op SIGMA_ALGEBRA_BOREL = TDB.find "SIGMA_ALGEBRA_BOREL"
  fun op MEASURABLE_BOREL _ = ()
  val op MEASURABLE_BOREL = TDB.find "MEASURABLE_BOREL"
  fun op IN_MEASURABLE_BOREL _ = ()
  val op IN_MEASURABLE_BOREL = TDB.find "IN_MEASURABLE_BOREL"
  fun op IN_MEASURABLE_BOREL_NEGINF _ = ()
  val op IN_MEASURABLE_BOREL_NEGINF = TDB.find "IN_MEASURABLE_BOREL_NEGINF"
  fun op IN_MEASURABLE_BOREL_ALT1 _ = ()
  val op IN_MEASURABLE_BOREL_ALT1 = TDB.find "IN_MEASURABLE_BOREL_ALT1"
  fun op IN_MEASURABLE_BOREL_ALT2 _ = ()
  val op IN_MEASURABLE_BOREL_ALT2 = TDB.find "IN_MEASURABLE_BOREL_ALT2"
  fun op IN_MEASURABLE_BOREL_ALT3 _ = ()
  val op IN_MEASURABLE_BOREL_ALT3 = TDB.find "IN_MEASURABLE_BOREL_ALT3"
  fun op IN_MEASURABLE_BOREL_ALT4 _ = ()
  val op IN_MEASURABLE_BOREL_ALT4 = TDB.find "IN_MEASURABLE_BOREL_ALT4"
  fun op IN_MEASURABLE_BOREL_ALT5 _ = ()
  val op IN_MEASURABLE_BOREL_ALT5 = TDB.find "IN_MEASURABLE_BOREL_ALT5"
  fun op IN_MEASURABLE_BOREL_ALT6 _ = ()
  val op IN_MEASURABLE_BOREL_ALT6 = TDB.find "IN_MEASURABLE_BOREL_ALT6"
  fun op IN_MEASURABLE_BOREL_ALT7 _ = ()
  val op IN_MEASURABLE_BOREL_ALT7 = TDB.find "IN_MEASURABLE_BOREL_ALT7"
  fun op IN_MEASURABLE_BOREL_ALT8 _ = ()
  val op IN_MEASURABLE_BOREL_ALT8 = TDB.find "IN_MEASURABLE_BOREL_ALT8"
  fun op IN_MEASURABLE_BOREL_ALT9 _ = ()
  val op IN_MEASURABLE_BOREL_ALT9 = TDB.find "IN_MEASURABLE_BOREL_ALT9"
  fun op IN_MEASURABLE_BOREL_ALL _ = ()
  val op IN_MEASURABLE_BOREL_ALL = TDB.find "IN_MEASURABLE_BOREL_ALL"
  fun op IN_MEASURABLE_BOREL_ALL_MEASURE _ = ()
  val op IN_MEASURABLE_BOREL_ALL_MEASURE = TDB.find
    "IN_MEASURABLE_BOREL_ALL_MEASURE"
  fun op IN_MEASURABLE_BOREL_LT _ = ()
  val op IN_MEASURABLE_BOREL_LT = TDB.find "IN_MEASURABLE_BOREL_LT"
  fun op IN_MEASURABLE_BOREL_LE _ = ()
  val op IN_MEASURABLE_BOREL_LE = TDB.find "IN_MEASURABLE_BOREL_LE"
  fun op SPACE_BOREL _ = () val op SPACE_BOREL = TDB.find "SPACE_BOREL"
  fun op BOREL_MEASURABLE_SETS1 _ = ()
  val op BOREL_MEASURABLE_SETS1 = TDB.find "BOREL_MEASURABLE_SETS1"
  fun op BOREL_MEASURABLE_SETS2 _ = ()
  val op BOREL_MEASURABLE_SETS2 = TDB.find "BOREL_MEASURABLE_SETS2"
  fun op BOREL_MEASURABLE_SETS3 _ = ()
  val op BOREL_MEASURABLE_SETS3 = TDB.find "BOREL_MEASURABLE_SETS3"
  fun op BOREL_MEASURABLE_SETS4 _ = ()
  val op BOREL_MEASURABLE_SETS4 = TDB.find "BOREL_MEASURABLE_SETS4"
  fun op BOREL_MEASURABLE_SETS5 _ = ()
  val op BOREL_MEASURABLE_SETS5 = TDB.find "BOREL_MEASURABLE_SETS5"
  fun op BOREL_MEASURABLE_SETS6 _ = ()
  val op BOREL_MEASURABLE_SETS6 = TDB.find "BOREL_MEASURABLE_SETS6"
  fun op BOREL_MEASURABLE_SETS7 _ = ()
  val op BOREL_MEASURABLE_SETS7 = TDB.find "BOREL_MEASURABLE_SETS7"
  fun op BOREL_MEASURABLE_SETS8 _ = ()
  val op BOREL_MEASURABLE_SETS8 = TDB.find "BOREL_MEASURABLE_SETS8"
  fun op BOREL_MEASURABLE_SETS9 _ = ()
  val op BOREL_MEASURABLE_SETS9 = TDB.find "BOREL_MEASURABLE_SETS9"
  fun op BOREL_MEASURABLE_SETS10 _ = ()
  val op BOREL_MEASURABLE_SETS10 = TDB.find "BOREL_MEASURABLE_SETS10"
  fun op BOREL_MEASURABLE_SETS _ = ()
  val op BOREL_MEASURABLE_SETS = TDB.find "BOREL_MEASURABLE_SETS"
  fun op IN_MEASURABLE_BOREL_CONST _ = ()
  val op IN_MEASURABLE_BOREL_CONST = TDB.find "IN_MEASURABLE_BOREL_CONST"
  fun op IN_MEASURABLE_BOREL_INDICATOR _ = ()
  val op IN_MEASURABLE_BOREL_INDICATOR = TDB.find
    "IN_MEASURABLE_BOREL_INDICATOR"
  fun op IN_MEASURABLE_BOREL_CMUL _ = ()
  val op IN_MEASURABLE_BOREL_CMUL = TDB.find "IN_MEASURABLE_BOREL_CMUL"
  fun op IN_MEASURABLE_BOREL_ABS _ = ()
  val op IN_MEASURABLE_BOREL_ABS = TDB.find "IN_MEASURABLE_BOREL_ABS"
  fun op IN_MEASURABLE_BOREL_SQR _ = ()
  val op IN_MEASURABLE_BOREL_SQR = TDB.find "IN_MEASURABLE_BOREL_SQR"
  fun op IN_MEASURABLE_BOREL_ADD _ = ()
  val op IN_MEASURABLE_BOREL_ADD = TDB.find "IN_MEASURABLE_BOREL_ADD"
  fun op IN_MEASURABLE_BOREL_SUB _ = ()
  val op IN_MEASURABLE_BOREL_SUB = TDB.find "IN_MEASURABLE_BOREL_SUB"
  fun op IN_MEASURABLE_BOREL_MUL _ = ()
  val op IN_MEASURABLE_BOREL_MUL = TDB.find "IN_MEASURABLE_BOREL_MUL"
  fun op IN_MEASURABLE_BOREL_SUM _ = ()
  val op IN_MEASURABLE_BOREL_SUM = TDB.find "IN_MEASURABLE_BOREL_SUM"
  fun op IN_MEASURABLE_BOREL_CMUL_INDICATOR _ = ()
  val op IN_MEASURABLE_BOREL_CMUL_INDICATOR = TDB.find
    "IN_MEASURABLE_BOREL_CMUL_INDICATOR"
  fun op IN_MEASURABLE_BOREL_MUL_INDICATOR _ = ()
  val op IN_MEASURABLE_BOREL_MUL_INDICATOR = TDB.find
    "IN_MEASURABLE_BOREL_MUL_INDICATOR"
  fun op IN_MEASURABLE_BOREL_MUL_INDICATOR_EQ _ = ()
  val op IN_MEASURABLE_BOREL_MUL_INDICATOR_EQ = TDB.find
    "IN_MEASURABLE_BOREL_MUL_INDICATOR_EQ"
  fun op IN_MEASURABLE_BOREL_POS_SIMPLE_FN _ = ()
  val op IN_MEASURABLE_BOREL_POS_SIMPLE_FN = TDB.find
    "IN_MEASURABLE_BOREL_POS_SIMPLE_FN"
  fun op IN_MEASURABLE_BOREL_POW _ = ()
  val op IN_MEASURABLE_BOREL_POW = TDB.find "IN_MEASURABLE_BOREL_POW"
  fun op IN_MEASURABLE_BOREL_MAX _ = ()
  val op IN_MEASURABLE_BOREL_MAX = TDB.find "IN_MEASURABLE_BOREL_MAX"
  fun op IN_MEASURABLE_BOREL_MONO_SUP _ = ()
  val op IN_MEASURABLE_BOREL_MONO_SUP = TDB.find
    "IN_MEASURABLE_BOREL_MONO_SUP"
  fun op FN_PLUS_POS _ = () val op FN_PLUS_POS = TDB.find "FN_PLUS_POS"
  fun op FN_MINUS_POS _ = () val op FN_MINUS_POS = TDB.find "FN_MINUS_POS"
  fun op FN_PLUS_POS_ID _ = ()
  val op FN_PLUS_POS_ID = TDB.find "FN_PLUS_POS_ID"
  fun op FN_MINUS_POS_ZERO _ = ()
  val op FN_MINUS_POS_ZERO = TDB.find "FN_MINUS_POS_ZERO"
  fun op FN_PLUS_CMUL _ = () val op FN_PLUS_CMUL = TDB.find "FN_PLUS_CMUL"
  fun op FN_MINUS_CMUL _ = ()
  val op FN_MINUS_CMUL = TDB.find "FN_MINUS_CMUL"
  fun op FN_PLUS_ADD_LE _ = ()
  val op FN_PLUS_ADD_LE = TDB.find "FN_PLUS_ADD_LE"
  fun op FN_MINUS_ADD_LE _ = ()
  val op FN_MINUS_ADD_LE = TDB.find "FN_MINUS_ADD_LE"
  fun op IN_MEASURABLE_BOREL_FN_PLUS _ = ()
  val op IN_MEASURABLE_BOREL_FN_PLUS = TDB.find
    "IN_MEASURABLE_BOREL_FN_PLUS"
  fun op IN_MEASURABLE_BOREL_FN_MINUS _ = ()
  val op IN_MEASURABLE_BOREL_FN_MINUS = TDB.find
    "IN_MEASURABLE_BOREL_FN_MINUS"
  fun op IN_MEASURABLE_BOREL_PLUS_MINUS _ = ()
  val op IN_MEASURABLE_BOREL_PLUS_MINUS = TDB.find
    "IN_MEASURABLE_BOREL_PLUS_MINUS"
  fun op INDICATOR_FN_MUL_INTER _ = ()
  val op INDICATOR_FN_MUL_INTER = TDB.find "INDICATOR_FN_MUL_INTER"
  fun op indicator_fn_split _ = ()
  val op indicator_fn_split = TDB.find "indicator_fn_split"
  fun op indicator_fn_suminf _ = ()
  val op indicator_fn_suminf = TDB.find "indicator_fn_suminf"
  fun op measure_split _ = ()
  val op measure_split = TDB.find "measure_split"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val measure_grammars = merge_grammars ["extreal"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="measure"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val measure_grammars = 
    Portable.## (addtyUDs,addtmUDs) measure_grammars
  val _ = Parse.grammarDB_insert("measure",measure_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "measure"

end
