structure probabilityTheory :> probabilityTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading probabilityTheory ... "
    else ()
  
  open Type Term Thm
  local open lebesgueTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "probability"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/probabilityTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op p_space_def _ = () val op p_space_def = TDB.find "p_space_def"
  fun op events_def _ = () val op events_def = TDB.find "events_def"
  fun op prob_def _ = () val op prob_def = TDB.find "prob_def"
  fun op prob_space_def _ = ()
  val op prob_space_def = TDB.find "prob_space_def"
  fun op indep_def _ = () val op indep_def = TDB.find "indep_def"
  fun op indep_families_def _ = ()
  val op indep_families_def = TDB.find "indep_families_def"
  fun op indep_function_def _ = ()
  val op indep_function_def = TDB.find "indep_function_def"
  fun op probably_def _ = () val op probably_def = TDB.find "probably_def"
  fun op possibly_def _ = () val op possibly_def = TDB.find "possibly_def"
  fun op random_variable_def _ = ()
  val op random_variable_def = TDB.find "random_variable_def"
  fun op real_random_variable_def _ = ()
  val op real_random_variable_def = TDB.find "real_random_variable_def"
  fun op distribution_def _ = ()
  val op distribution_def = TDB.find "distribution_def"
  fun op joint_distribution_def _ = ()
  val op joint_distribution_def = TDB.find "joint_distribution_def"
  fun op joint_distribution3_def _ = ()
  val op joint_distribution3_def = TDB.find "joint_distribution3_def"
  fun op conditional_distribution_def _ = ()
  val op conditional_distribution_def = TDB.find
    "conditional_distribution_def"
  fun op expectation_def _ = ()
  val op expectation_def = TDB.find "expectation_def"
  fun op conditional_expectation_def _ = ()
  val op conditional_expectation_def = TDB.find
    "conditional_expectation_def"
  fun op conditional_prob_def _ = ()
  val op conditional_prob_def = TDB.find "conditional_prob_def"
  fun op rv_conditional_expectation_def _ = ()
  val op rv_conditional_expectation_def = TDB.find
    "rv_conditional_expectation_def"
  fun op indep_rv_def _ = () val op indep_rv_def = TDB.find "indep_rv_def"
  fun op uniform_distribution_def _ = ()
  val op uniform_distribution_def = TDB.find "uniform_distribution_def"
  fun op POSITIVE_PROB _ = ()
  val op POSITIVE_PROB = TDB.find "POSITIVE_PROB"
  fun op INCREASING_PROB _ = ()
  val op INCREASING_PROB = TDB.find "INCREASING_PROB"
  fun op ADDITIVE_PROB _ = ()
  val op ADDITIVE_PROB = TDB.find "ADDITIVE_PROB"
  fun op COUNTABLY_ADDITIVE_PROB _ = ()
  val op COUNTABLY_ADDITIVE_PROB = TDB.find "COUNTABLY_ADDITIVE_PROB"
  fun op PROB_SPACE _ = () val op PROB_SPACE = TDB.find "PROB_SPACE"
  fun op EVENTS_SIGMA_ALGEBRA _ = ()
  val op EVENTS_SIGMA_ALGEBRA = TDB.find "EVENTS_SIGMA_ALGEBRA"
  fun op EVENTS_ALGEBRA _ = ()
  val op EVENTS_ALGEBRA = TDB.find "EVENTS_ALGEBRA"
  fun op PROB_EMPTY _ = () val op PROB_EMPTY = TDB.find "PROB_EMPTY"
  fun op PROB_UNIV _ = () val op PROB_UNIV = TDB.find "PROB_UNIV"
  fun op PROB_SPACE_POSITIVE _ = ()
  val op PROB_SPACE_POSITIVE = TDB.find "PROB_SPACE_POSITIVE"
  fun op PROB_SPACE_COUNTABLY_ADDITIVE _ = ()
  val op PROB_SPACE_COUNTABLY_ADDITIVE = TDB.find
    "PROB_SPACE_COUNTABLY_ADDITIVE"
  fun op PROB_SPACE_ADDITIVE _ = ()
  val op PROB_SPACE_ADDITIVE = TDB.find "PROB_SPACE_ADDITIVE"
  fun op PROB_SPACE_INCREASING _ = ()
  val op PROB_SPACE_INCREASING = TDB.find "PROB_SPACE_INCREASING"
  fun op PROB_POSITIVE _ = ()
  val op PROB_POSITIVE = TDB.find "PROB_POSITIVE"
  fun op PROB_INCREASING _ = ()
  val op PROB_INCREASING = TDB.find "PROB_INCREASING"
  fun op PROB_ADDITIVE _ = ()
  val op PROB_ADDITIVE = TDB.find "PROB_ADDITIVE"
  fun op PROB_COUNTABLY_ADDITIVE _ = ()
  val op PROB_COUNTABLY_ADDITIVE = TDB.find "PROB_COUNTABLY_ADDITIVE"
  fun op PROB_COMPL _ = () val op PROB_COMPL = TDB.find "PROB_COMPL"
  fun op PROB_INDEP _ = () val op PROB_INDEP = TDB.find "PROB_INDEP"
  fun op PSPACE _ = () val op PSPACE = TDB.find "PSPACE"
  fun op EVENTS _ = () val op EVENTS = TDB.find "EVENTS"
  fun op PROB _ = () val op PROB = TDB.find "PROB"
  fun op EVENTS_INTER _ = () val op EVENTS_INTER = TDB.find "EVENTS_INTER"
  fun op EVENTS_EMPTY _ = () val op EVENTS_EMPTY = TDB.find "EVENTS_EMPTY"
  fun op EVENTS_SPACE _ = () val op EVENTS_SPACE = TDB.find "EVENTS_SPACE"
  fun op EVENTS_UNION _ = () val op EVENTS_UNION = TDB.find "EVENTS_UNION"
  fun op INDEP_EMPTY _ = () val op INDEP_EMPTY = TDB.find "INDEP_EMPTY"
  fun op INTER_PSPACE _ = () val op INTER_PSPACE = TDB.find "INTER_PSPACE"
  fun op INDEP_SPACE _ = () val op INDEP_SPACE = TDB.find "INDEP_SPACE"
  fun op EVENTS_DIFF _ = () val op EVENTS_DIFF = TDB.find "EVENTS_DIFF"
  fun op EVENTS_COMPL _ = () val op EVENTS_COMPL = TDB.find "EVENTS_COMPL"
  fun op EVENTS_COUNTABLE_UNION _ = ()
  val op EVENTS_COUNTABLE_UNION = TDB.find "EVENTS_COUNTABLE_UNION"
  fun op PROB_ZERO_UNION _ = ()
  val op PROB_ZERO_UNION = TDB.find "PROB_ZERO_UNION"
  fun op PROB_EQ_COMPL _ = ()
  val op PROB_EQ_COMPL = TDB.find "PROB_EQ_COMPL"
  fun op PROB_ONE_INTER _ = ()
  val op PROB_ONE_INTER = TDB.find "PROB_ONE_INTER"
  fun op EVENTS_COUNTABLE_INTER _ = ()
  val op EVENTS_COUNTABLE_INTER = TDB.find "EVENTS_COUNTABLE_INTER"
  fun op ABS_PROB _ = () val op ABS_PROB = TDB.find "ABS_PROB"
  fun op PROB_COMPL_LE1 _ = ()
  val op PROB_COMPL_LE1 = TDB.find "PROB_COMPL_LE1"
  fun op PROB_LE_1 _ = () val op PROB_LE_1 = TDB.find "PROB_LE_1"
  fun op PROB_EQ_BIGUNION_IMAGE _ = ()
  val op PROB_EQ_BIGUNION_IMAGE = TDB.find "PROB_EQ_BIGUNION_IMAGE"
  fun op PROB_FINITELY_ADDITIVE _ = ()
  val op PROB_FINITELY_ADDITIVE = TDB.find "PROB_FINITELY_ADDITIVE"
  fun op ABS_1_MINUS_PROB _ = ()
  val op ABS_1_MINUS_PROB = TDB.find "ABS_1_MINUS_PROB"
  fun op PROB_INCREASING_UNION _ = ()
  val op PROB_INCREASING_UNION = TDB.find "PROB_INCREASING_UNION"
  fun op PROB_SUBADDITIVE _ = ()
  val op PROB_SUBADDITIVE = TDB.find "PROB_SUBADDITIVE"
  fun op PROB_COUNTABLY_SUBADDITIVE _ = ()
  val op PROB_COUNTABLY_SUBADDITIVE = TDB.find "PROB_COUNTABLY_SUBADDITIVE"
  fun op PROB_COUNTABLY_ZERO _ = ()
  val op PROB_COUNTABLY_ZERO = TDB.find "PROB_COUNTABLY_ZERO"
  fun op INDEP_SYM _ = () val op INDEP_SYM = TDB.find "INDEP_SYM"
  fun op INDEP_REFL _ = () val op INDEP_REFL = TDB.find "INDEP_REFL"
  fun op PROB_REAL_SUM_IMAGE _ = ()
  val op PROB_REAL_SUM_IMAGE = TDB.find "PROB_REAL_SUM_IMAGE"
  fun op PROB_EQUIPROBABLE_FINITE_UNIONS _ = ()
  val op PROB_EQUIPROBABLE_FINITE_UNIONS = TDB.find
    "PROB_EQUIPROBABLE_FINITE_UNIONS"
  fun op PROB_REAL_SUM_IMAGE_FN _ = ()
  val op PROB_REAL_SUM_IMAGE_FN = TDB.find "PROB_REAL_SUM_IMAGE_FN"
  fun op PROB_REAL_SUM_IMAGE_SPACE _ = ()
  val op PROB_REAL_SUM_IMAGE_SPACE = TDB.find "PROB_REAL_SUM_IMAGE_SPACE"
  fun op PROB_DISCRETE_EVENTS _ = ()
  val op PROB_DISCRETE_EVENTS = TDB.find "PROB_DISCRETE_EVENTS"
  fun op PROB_DISCRETE_EVENTS_COUNTABLE _ = ()
  val op PROB_DISCRETE_EVENTS_COUNTABLE = TDB.find
    "PROB_DISCRETE_EVENTS_COUNTABLE"
  fun op marginal_joint_zero _ = ()
  val op marginal_joint_zero = TDB.find "marginal_joint_zero"
  fun op marginal_joint_zero3 _ = ()
  val op marginal_joint_zero3 = TDB.find "marginal_joint_zero3"
  fun op distribution_prob_space _ = ()
  val op distribution_prob_space = TDB.find "distribution_prob_space"
  fun op uniform_distribution_prob_space _ = ()
  val op uniform_distribution_prob_space = TDB.find
    "uniform_distribution_prob_space"
  fun op distribution_partition _ = ()
  val op distribution_partition = TDB.find "distribution_partition"
  fun op distribution_lebesgue_thm1 _ = ()
  val op distribution_lebesgue_thm1 = TDB.find "distribution_lebesgue_thm1"
  fun op distribution_lebesgue_thm2 _ = ()
  val op distribution_lebesgue_thm2 = TDB.find "distribution_lebesgue_thm2"
  fun op finite_expectation1 _ = ()
  val op finite_expectation1 = TDB.find "finite_expectation1"
  fun op finite_expectation2 _ = ()
  val op finite_expectation2 = TDB.find "finite_expectation2"
  fun op finite_expectation _ = ()
  val op finite_expectation = TDB.find "finite_expectation"
  fun op finite_support_expectation _ = ()
  val op finite_support_expectation = TDB.find "finite_support_expectation"
  fun op finite_marginal_product_space_POW _ = ()
  val op finite_marginal_product_space_POW = TDB.find
    "finite_marginal_product_space_POW"
  fun op finite_marginal_product_space_POW2 _ = ()
  val op finite_marginal_product_space_POW2 = TDB.find
    "finite_marginal_product_space_POW2"
  fun op finite_marginal_product_space_POW3 _ = ()
  val op finite_marginal_product_space_POW3 = TDB.find
    "finite_marginal_product_space_POW3"
  fun op prob_x_eq_1_imp_prob_y_eq_0 _ = ()
  val op prob_x_eq_1_imp_prob_y_eq_0 = TDB.find
    "prob_x_eq_1_imp_prob_y_eq_0"
  fun op distribution_x_eq_1_imp_distribution_y_eq_0 _ = ()
  val op distribution_x_eq_1_imp_distribution_y_eq_0 = TDB.find
    "distribution_x_eq_1_imp_distribution_y_eq_0"
  fun op joint_distribution_sym _ = ()
  val op joint_distribution_sym = TDB.find "joint_distribution_sym"
  fun op joint_distribution_pos _ = ()
  val op joint_distribution_pos = TDB.find "joint_distribution_pos"
  fun op joint_distribution_le_1 _ = ()
  val op joint_distribution_le_1 = TDB.find "joint_distribution_le_1"
  fun op joint_distribution_le _ = ()
  val op joint_distribution_le = TDB.find "joint_distribution_le"
  fun op joint_distribution_le2 _ = ()
  val op joint_distribution_le2 = TDB.find "joint_distribution_le2"
  fun op joint_conditional _ = ()
  val op joint_conditional = TDB.find "joint_conditional"
  fun op distribution_pos _ = ()
  val op distribution_pos = TDB.find "distribution_pos"
  fun op conditional_distribution_pos _ = ()
  val op conditional_distribution_pos = TDB.find
    "conditional_distribution_pos"
  fun op conditional_distribution_le_1 _ = ()
  val op conditional_distribution_le_1 = TDB.find
    "conditional_distribution_le_1"
  fun op marginal_distribution1 _ = ()
  val op marginal_distribution1 = TDB.find "marginal_distribution1"
  fun op marginal_distribution2 _ = ()
  val op marginal_distribution2 = TDB.find "marginal_distribution2"
  fun op joint_distribution_sums_1 _ = ()
  val op joint_distribution_sums_1 = TDB.find "joint_distribution_sums_1"
  fun op joint_distribution_sum_mul1 _ = ()
  val op joint_distribution_sum_mul1 = TDB.find
    "joint_distribution_sum_mul1"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val probability_grammars = merge_grammars ["lebesgue"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="probability"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val probability_grammars = 
    Portable.## (addtyUDs,addtmUDs) probability_grammars
  val _ = Parse.grammarDB_insert("probability",probability_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "probability"

end
