structure productTheory :> productTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading productTheory ... "
    else ()
  
  open Type Term Thm
  local open iterateTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "product"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/productTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op nproduct _ = () val op nproduct = TDB.find "nproduct"
  fun op product _ = () val op product = TDB.find "product"
  fun op REAL_ADD_AC _ = () val op REAL_ADD_AC = TDB.find "REAL_ADD_AC"
  fun op MULT_AC _ = () val op MULT_AC = TDB.find "MULT_AC"
  fun op NPRODUCT_CLAUSES _ = ()
  val op NPRODUCT_CLAUSES = TDB.find "NPRODUCT_CLAUSES"
  fun op NPRODUCT_SUPPORT _ = ()
  val op NPRODUCT_SUPPORT = TDB.find "NPRODUCT_SUPPORT"
  fun op NPRODUCT_UNION _ = ()
  val op NPRODUCT_UNION = TDB.find "NPRODUCT_UNION"
  fun op NPRODUCT_IMAGE _ = ()
  val op NPRODUCT_IMAGE = TDB.find "NPRODUCT_IMAGE"
  fun op NPRODUCT_ADD_SPLIT _ = ()
  val op NPRODUCT_ADD_SPLIT = TDB.find "NPRODUCT_ADD_SPLIT"
  fun op NPRODUCT_POS_LT _ = ()
  val op NPRODUCT_POS_LT = TDB.find "NPRODUCT_POS_LT"
  fun op NPRODUCT_POS_LT_NUMSEG _ = ()
  val op NPRODUCT_POS_LT_NUMSEG = TDB.find "NPRODUCT_POS_LT_NUMSEG"
  fun op NPRODUCT_OFFSET _ = ()
  val op NPRODUCT_OFFSET = TDB.find "NPRODUCT_OFFSET"
  fun op NPRODUCT_SING _ = ()
  val op NPRODUCT_SING = TDB.find "NPRODUCT_SING"
  fun op NPRODUCT_SING_NUMSEG _ = ()
  val op NPRODUCT_SING_NUMSEG = TDB.find "NPRODUCT_SING_NUMSEG"
  fun op NPRODUCT_CLAUSES_NUMSEG _ = ()
  val op NPRODUCT_CLAUSES_NUMSEG = TDB.find "NPRODUCT_CLAUSES_NUMSEG"
  fun op NPRODUCT_EQ _ = () val op NPRODUCT_EQ = TDB.find "NPRODUCT_EQ"
  fun op NPRODUCT_EQ_NUMSEG _ = ()
  val op NPRODUCT_EQ_NUMSEG = TDB.find "NPRODUCT_EQ_NUMSEG"
  fun op NPRODUCT_EQ_0 _ = ()
  val op NPRODUCT_EQ_0 = TDB.find "NPRODUCT_EQ_0"
  fun op NPRODUCT_EQ_0_NUMSEG _ = ()
  val op NPRODUCT_EQ_0_NUMSEG = TDB.find "NPRODUCT_EQ_0_NUMSEG"
  fun op NPRODUCT_LE _ = () val op NPRODUCT_LE = TDB.find "NPRODUCT_LE"
  fun op NPRODUCT_LE_NUMSEG _ = ()
  val op NPRODUCT_LE_NUMSEG = TDB.find "NPRODUCT_LE_NUMSEG"
  fun op NPRODUCT_EQ_1 _ = ()
  val op NPRODUCT_EQ_1 = TDB.find "NPRODUCT_EQ_1"
  fun op NPRODUCT_EQ_1_NUMSEG _ = ()
  val op NPRODUCT_EQ_1_NUMSEG = TDB.find "NPRODUCT_EQ_1_NUMSEG"
  fun op NPRODUCT_MUL_GEN _ = ()
  val op NPRODUCT_MUL_GEN = TDB.find "NPRODUCT_MUL_GEN"
  fun op NPRODUCT_MUL _ = () val op NPRODUCT_MUL = TDB.find "NPRODUCT_MUL"
  fun op NPRODUCT_MUL_NUMSEG _ = ()
  val op NPRODUCT_MUL_NUMSEG = TDB.find "NPRODUCT_MUL_NUMSEG"
  fun op NPRODUCT_CONST _ = ()
  val op NPRODUCT_CONST = TDB.find "NPRODUCT_CONST"
  fun op NPRODUCT_CONST_NUMSEG _ = ()
  val op NPRODUCT_CONST_NUMSEG = TDB.find "NPRODUCT_CONST_NUMSEG"
  fun op NPRODUCT_CONST_NUMSEG_1 _ = ()
  val op NPRODUCT_CONST_NUMSEG_1 = TDB.find "NPRODUCT_CONST_NUMSEG_1"
  fun op NPRODUCT_ONE _ = () val op NPRODUCT_ONE = TDB.find "NPRODUCT_ONE"
  fun op NPRODUCT_CLOSED _ = ()
  val op NPRODUCT_CLOSED = TDB.find "NPRODUCT_CLOSED"
  fun op NPRODUCT_CLAUSES_LEFT _ = ()
  val op NPRODUCT_CLAUSES_LEFT = TDB.find "NPRODUCT_CLAUSES_LEFT"
  fun op NPRODUCT_CLAUSES_RIGHT _ = ()
  val op NPRODUCT_CLAUSES_RIGHT = TDB.find "NPRODUCT_CLAUSES_RIGHT"
  fun op NPRODUCT_SUPERSET _ = ()
  val op NPRODUCT_SUPERSET = TDB.find "NPRODUCT_SUPERSET"
  fun op NPRODUCT_PAIR _ = ()
  val op NPRODUCT_PAIR = TDB.find "NPRODUCT_PAIR"
  fun op NPRODUCT_DELETE _ = ()
  val op NPRODUCT_DELETE = TDB.find "NPRODUCT_DELETE"
  fun op NPRODUCT_FACT _ = ()
  val op NPRODUCT_FACT = TDB.find "NPRODUCT_FACT"
  fun op NPRODUCT_DELTA _ = ()
  val op NPRODUCT_DELTA = TDB.find "NPRODUCT_DELTA"
  fun op th _ = () val op th = TDB.find "th"
  fun op PRODUCT_CLAUSES _ = ()
  val op PRODUCT_CLAUSES = TDB.find "PRODUCT_CLAUSES"
  fun op PRODUCT_SUPPORT _ = ()
  val op PRODUCT_SUPPORT = TDB.find "PRODUCT_SUPPORT"
  fun op PRODUCT_UNION _ = ()
  val op PRODUCT_UNION = TDB.find "PRODUCT_UNION"
  fun op PRODUCT_IMAGE _ = ()
  val op PRODUCT_IMAGE = TDB.find "PRODUCT_IMAGE"
  fun op PRODUCT_ADD_SPLIT _ = ()
  val op PRODUCT_ADD_SPLIT = TDB.find "PRODUCT_ADD_SPLIT"
  fun op PRODUCT_POS_LE _ = ()
  val op PRODUCT_POS_LE = TDB.find "PRODUCT_POS_LE"
  fun op PRODUCT_POS_LE_NUMSEG _ = ()
  val op PRODUCT_POS_LE_NUMSEG = TDB.find "PRODUCT_POS_LE_NUMSEG"
  fun op PRODUCT_POS_LT _ = ()
  val op PRODUCT_POS_LT = TDB.find "PRODUCT_POS_LT"
  fun op PRODUCT_POS_LT_NUMSEG _ = ()
  val op PRODUCT_POS_LT_NUMSEG = TDB.find "PRODUCT_POS_LT_NUMSEG"
  fun op PRODUCT_OFFSET _ = ()
  val op PRODUCT_OFFSET = TDB.find "PRODUCT_OFFSET"
  fun op PRODUCT_SING _ = () val op PRODUCT_SING = TDB.find "PRODUCT_SING"
  fun op PRODUCT_SING_NUMSEG _ = ()
  val op PRODUCT_SING_NUMSEG = TDB.find "PRODUCT_SING_NUMSEG"
  fun op PRODUCT_CLAUSES_NUMSEG _ = ()
  val op PRODUCT_CLAUSES_NUMSEG = TDB.find "PRODUCT_CLAUSES_NUMSEG"
  fun op PRODUCT_EQ _ = () val op PRODUCT_EQ = TDB.find "PRODUCT_EQ"
  fun op PRODUCT_EQ_NUMSEG _ = ()
  val op PRODUCT_EQ_NUMSEG = TDB.find "PRODUCT_EQ_NUMSEG"
  fun op PRODUCT_EQ_0 _ = () val op PRODUCT_EQ_0 = TDB.find "PRODUCT_EQ_0"
  fun op PRODUCT_EQ_0_NUMSEG _ = ()
  val op PRODUCT_EQ_0_NUMSEG = TDB.find "PRODUCT_EQ_0_NUMSEG"
  fun op PRODUCT_LE _ = () val op PRODUCT_LE = TDB.find "PRODUCT_LE"
  fun op PRODUCT_LE_NUMSEG _ = ()
  val op PRODUCT_LE_NUMSEG = TDB.find "PRODUCT_LE_NUMSEG"
  fun op PRODUCT_EQ_1 _ = () val op PRODUCT_EQ_1 = TDB.find "PRODUCT_EQ_1"
  fun op PRODUCT_EQ_1_NUMSEG _ = ()
  val op PRODUCT_EQ_1_NUMSEG = TDB.find "PRODUCT_EQ_1_NUMSEG"
  fun op PRODUCT_MUL_GEN _ = ()
  val op PRODUCT_MUL_GEN = TDB.find "PRODUCT_MUL_GEN"
  fun op PRODUCT_MUL _ = () val op PRODUCT_MUL = TDB.find "PRODUCT_MUL"
  fun op PRODUCT_MUL_NUMSEG _ = ()
  val op PRODUCT_MUL_NUMSEG = TDB.find "PRODUCT_MUL_NUMSEG"
  fun op PRODUCT_CONST _ = ()
  val op PRODUCT_CONST = TDB.find "PRODUCT_CONST"
  fun op PRODUCT_CONST_NUMSEG _ = ()
  val op PRODUCT_CONST_NUMSEG = TDB.find "PRODUCT_CONST_NUMSEG"
  fun op PRODUCT_CONST_NUMSEG_1 _ = ()
  val op PRODUCT_CONST_NUMSEG_1 = TDB.find "PRODUCT_CONST_NUMSEG_1"
  fun op PRODUCT_NEG _ = () val op PRODUCT_NEG = TDB.find "PRODUCT_NEG"
  fun op PRODUCT_NEG_NUMSEG _ = ()
  val op PRODUCT_NEG_NUMSEG = TDB.find "PRODUCT_NEG_NUMSEG"
  fun op PRODUCT_NEG_NUMSEG_1 _ = ()
  val op PRODUCT_NEG_NUMSEG_1 = TDB.find "PRODUCT_NEG_NUMSEG_1"
  fun op PRODUCT_INV _ = () val op PRODUCT_INV = TDB.find "PRODUCT_INV"
  fun op PRODUCT_DIV _ = () val op PRODUCT_DIV = TDB.find "PRODUCT_DIV"
  fun op PRODUCT_DIV_NUMSEG _ = ()
  val op PRODUCT_DIV_NUMSEG = TDB.find "PRODUCT_DIV_NUMSEG"
  fun op PRODUCT_ONE _ = () val op PRODUCT_ONE = TDB.find "PRODUCT_ONE"
  fun op PRODUCT_LE_1 _ = () val op PRODUCT_LE_1 = TDB.find "PRODUCT_LE_1"
  fun op PRODUCT_ABS _ = () val op PRODUCT_ABS = TDB.find "PRODUCT_ABS"
  fun op PRODUCT_CLOSED _ = ()
  val op PRODUCT_CLOSED = TDB.find "PRODUCT_CLOSED"
  fun op PRODUCT_CLAUSES_LEFT _ = ()
  val op PRODUCT_CLAUSES_LEFT = TDB.find "PRODUCT_CLAUSES_LEFT"
  fun op PRODUCT_CLAUSES_RIGHT _ = ()
  val op PRODUCT_CLAUSES_RIGHT = TDB.find "PRODUCT_CLAUSES_RIGHT"
  fun op REAL_OF_NUM_NPRODUCT _ = ()
  val op REAL_OF_NUM_NPRODUCT = TDB.find "REAL_OF_NUM_NPRODUCT"
  fun op PRODUCT_SUPERSET _ = ()
  val op PRODUCT_SUPERSET = TDB.find "PRODUCT_SUPERSET"
  fun op PRODUCT_PAIR _ = () val op PRODUCT_PAIR = TDB.find "PRODUCT_PAIR"
  fun op PRODUCT_DELETE _ = ()
  val op PRODUCT_DELETE = TDB.find "PRODUCT_DELETE"
  fun op PRODUCT_DELTA _ = ()
  val op PRODUCT_DELTA = TDB.find "PRODUCT_DELTA"
  fun op PRODUCT_CONG _ = () val op PRODUCT_CONG = TDB.find "PRODUCT_CONG"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val product_grammars = merge_grammars ["iterate"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="product"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val product_grammars = 
    Portable.## (addtyUDs,addtmUDs) product_grammars
  val _ = Parse.grammarDB_insert("product",product_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "product"

end
