structure util_probTheory :> util_probTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading util_probTheory ... "
    else ()
  
  open Type Term Thm
  local open real_sigmaTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "util_prob"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/util_probTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op pair_def _ = () val op pair_def = TDB.find "pair_def"
  fun op powr_def _ = () val op powr_def = TDB.find "powr_def"
  fun op logr_def _ = () val op logr_def = TDB.find "logr_def"
  fun op lg_def _ = () val op lg_def = TDB.find "lg_def"
  fun op prod_sets_def _ = ()
  val op prod_sets_def = TDB.find "prod_sets_def"
  fun op minimal_def _ = () val op minimal_def = TDB.find "minimal_def"
  fun op disjoint_def _ = () val op disjoint_def = TDB.find "disjoint_def"
  fun op from_def _ = () val op from_def = TDB.find "from_def"
  fun op EQ_T_IMP _ = () val op EQ_T_IMP = TDB.find "EQ_T_IMP"
  fun op IN_PAIR _ = () val op IN_PAIR = TDB.find "IN_PAIR"
  fun op PAIR_UNIV _ = () val op PAIR_UNIV = TDB.find "PAIR_UNIV"
  fun op PAIRED_BETA_THM _ = ()
  val op PAIRED_BETA_THM = TDB.find "PAIRED_BETA_THM"
  fun op lg_1 _ = () val op lg_1 = TDB.find "lg_1"
  fun op logr_1 _ = () val op logr_1 = TDB.find "logr_1"
  fun op lg_nonzero _ = () val op lg_nonzero = TDB.find "lg_nonzero"
  fun op lg_mul _ = () val op lg_mul = TDB.find "lg_mul"
  fun op logr_mul _ = () val op logr_mul = TDB.find "logr_mul"
  fun op lg_2 _ = () val op lg_2 = TDB.find "lg_2"
  fun op lg_inv _ = () val op lg_inv = TDB.find "lg_inv"
  fun op logr_inv _ = () val op logr_inv = TDB.find "logr_inv"
  fun op logr_div _ = () val op logr_div = TDB.find "logr_div"
  fun op neg_lg _ = () val op neg_lg = TDB.find "neg_lg"
  fun op neg_logr _ = () val op neg_logr = TDB.find "neg_logr"
  fun op lg_pow _ = () val op lg_pow = TDB.find "lg_pow"
  fun op NUM_2D_BIJ _ = () val op NUM_2D_BIJ = TDB.find "NUM_2D_BIJ"
  fun op NUM_2D_BIJ_INV _ = ()
  val op NUM_2D_BIJ_INV = TDB.find "NUM_2D_BIJ_INV"
  fun op NUM_2D_BIJ_NZ _ = ()
  val op NUM_2D_BIJ_NZ = TDB.find "NUM_2D_BIJ_NZ"
  fun op NUM_2D_BIJ_NZ_INV _ = ()
  val op NUM_2D_BIJ_NZ_INV = TDB.find "NUM_2D_BIJ_NZ_INV"
  fun op NUM_2D_BIJ_NZ_ALT _ = ()
  val op NUM_2D_BIJ_NZ_ALT = TDB.find "NUM_2D_BIJ_NZ_ALT"
  fun op NUM_2D_BIJ_NZ_ALT_INV _ = ()
  val op NUM_2D_BIJ_NZ_ALT_INV = TDB.find "NUM_2D_BIJ_NZ_ALT_INV"
  fun op NUM_2D_BIJ_NZ_ALT2 _ = ()
  val op NUM_2D_BIJ_NZ_ALT2 = TDB.find "NUM_2D_BIJ_NZ_ALT2"
  fun op NUM_2D_BIJ_NZ_ALT2_INV _ = ()
  val op NUM_2D_BIJ_NZ_ALT2_INV = TDB.find "NUM_2D_BIJ_NZ_ALT2_INV"
  fun op IN_o _ = () val op IN_o = TDB.find "IN_o"
  fun op IN_PROD_SETS _ = () val op IN_PROD_SETS = TDB.find "IN_PROD_SETS"
  fun op finite_enumeration_of_sets_has_max_non_empty _ = ()
  val op finite_enumeration_of_sets_has_max_non_empty = TDB.find
    "finite_enumeration_of_sets_has_max_non_empty"
  fun op PREIMAGE_REAL_COMPL1 _ = ()
  val op PREIMAGE_REAL_COMPL1 = TDB.find "PREIMAGE_REAL_COMPL1"
  fun op PREIMAGE_REAL_COMPL2 _ = ()
  val op PREIMAGE_REAL_COMPL2 = TDB.find "PREIMAGE_REAL_COMPL2"
  fun op PREIMAGE_REAL_COMPL3 _ = ()
  val op PREIMAGE_REAL_COMPL3 = TDB.find "PREIMAGE_REAL_COMPL3"
  fun op PREIMAGE_REAL_COMPL4 _ = ()
  val op PREIMAGE_REAL_COMPL4 = TDB.find "PREIMAGE_REAL_COMPL4"
  fun op GBIGUNION_IMAGE _ = ()
  val op GBIGUNION_IMAGE = TDB.find "GBIGUNION_IMAGE"
  fun op POW_HALF_POS _ = () val op POW_HALF_POS = TDB.find "POW_HALF_POS"
  fun op POW_HALF_SMALL _ = ()
  val op POW_HALF_SMALL = TDB.find "POW_HALF_SMALL"
  fun op POW_HALF_MONO _ = ()
  val op POW_HALF_MONO = TDB.find "POW_HALF_MONO"
  fun op REAL_LE_LT_MUL _ = ()
  val op REAL_LE_LT_MUL = TDB.find "REAL_LE_LT_MUL"
  fun op REAL_LT_LE_MUL _ = ()
  val op REAL_LT_LE_MUL = TDB.find "REAL_LT_LE_MUL"
  fun op REAL_MUL_IDEMPOT _ = ()
  val op REAL_MUL_IDEMPOT = TDB.find "REAL_MUL_IDEMPOT"
  fun op REAL_SUP_LE_X _ = ()
  val op REAL_SUP_LE_X = TDB.find "REAL_SUP_LE_X"
  fun op REAL_X_LE_SUP _ = ()
  val op REAL_X_LE_SUP = TDB.find "REAL_X_LE_SUP"
  fun op INF_DEF_ALT _ = () val op INF_DEF_ALT = TDB.find "INF_DEF_ALT"
  fun op LE_INF _ = () val op LE_INF = TDB.find "LE_INF"
  fun op INF_LE _ = () val op INF_LE = TDB.find "INF_LE"
  fun op INF_GREATER _ = () val op INF_GREATER = TDB.find "INF_GREATER"
  fun op INF_CLOSE _ = () val op INF_CLOSE = TDB.find "INF_CLOSE"
  fun op REAL_NEG_NZ _ = () val op REAL_NEG_NZ = TDB.find "REAL_NEG_NZ"
  fun op REAL_LT_LMUL_0_NEG _ = ()
  val op REAL_LT_LMUL_0_NEG = TDB.find "REAL_LT_LMUL_0_NEG"
  fun op REAL_LT_RMUL_0_NEG _ = ()
  val op REAL_LT_RMUL_0_NEG = TDB.find "REAL_LT_RMUL_0_NEG"
  fun op REAL_LT_LMUL_NEG_0 _ = ()
  val op REAL_LT_LMUL_NEG_0 = TDB.find "REAL_LT_LMUL_NEG_0"
  fun op REAL_LT_RMUL_NEG_0 _ = ()
  val op REAL_LT_RMUL_NEG_0 = TDB.find "REAL_LT_RMUL_NEG_0"
  fun op REAL_LT_LMUL_NEG_0_NEG _ = ()
  val op REAL_LT_LMUL_NEG_0_NEG = TDB.find "REAL_LT_LMUL_NEG_0_NEG"
  fun op REAL_LT_RMUL_NEG_0_NEG _ = ()
  val op REAL_LT_RMUL_NEG_0_NEG = TDB.find "REAL_LT_RMUL_NEG_0_NEG"
  fun op REAL_LT_RDIV_EQ_NEG _ = ()
  val op REAL_LT_RDIV_EQ_NEG = TDB.find "REAL_LT_RDIV_EQ_NEG"
  fun op REAL_LE_RDIV_EQ_NEG _ = ()
  val op REAL_LE_RDIV_EQ_NEG = TDB.find "REAL_LE_RDIV_EQ_NEG"
  fun op POW_POS_EVEN _ = () val op POW_POS_EVEN = TDB.find "POW_POS_EVEN"
  fun op POW_NEG_ODD _ = () val op POW_NEG_ODD = TDB.find "POW_NEG_ODD"
  fun op LOGR_MONO_LE _ = () val op LOGR_MONO_LE = TDB.find "LOGR_MONO_LE"
  fun op LOGR_MONO_LE_IMP _ = ()
  val op LOGR_MONO_LE_IMP = TDB.find "LOGR_MONO_LE_IMP"
  fun op MINIMAL_EXISTS0 _ = ()
  val op MINIMAL_EXISTS0 = TDB.find "MINIMAL_EXISTS0"
  fun op MINIMAL_EXISTS _ = ()
  val op MINIMAL_EXISTS = TDB.find "MINIMAL_EXISTS"
  fun op MINIMAL_EXISTS_IMP _ = ()
  val op MINIMAL_EXISTS_IMP = TDB.find "MINIMAL_EXISTS_IMP"
  fun op MINIMAL_EQ_IMP _ = ()
  val op MINIMAL_EQ_IMP = TDB.find "MINIMAL_EQ_IMP"
  fun op MINIMAL_SUC _ = () val op MINIMAL_SUC = TDB.find "MINIMAL_SUC"
  fun op MINIMAL_EQ _ = () val op MINIMAL_EQ = TDB.find "MINIMAL_EQ"
  fun op MINIMAL_SUC_IMP _ = ()
  val op MINIMAL_SUC_IMP = TDB.find "MINIMAL_SUC_IMP"
  fun op disjointI _ = () val op disjointI = TDB.find "disjointI"
  fun op disjointD _ = () val op disjointD = TDB.find "disjointD"
  fun op disjoint_empty _ = ()
  val op disjoint_empty = TDB.find "disjoint_empty"
  fun op disjoint_union _ = ()
  val op disjoint_union = TDB.find "disjoint_union"
  fun op disjoint_sing _ = ()
  val op disjoint_sing = TDB.find "disjoint_sing"
  fun op FROM_0 _ = () val op FROM_0 = TDB.find "FROM_0"
  fun op IN_FROM _ = () val op IN_FROM = TDB.find "IN_FROM"
  fun op DISJOINT_COUNT_FROM _ = ()
  val op DISJOINT_COUNT_FROM = TDB.find "DISJOINT_COUNT_FROM"
  fun op DISJOINT_FROM_COUNT _ = ()
  val op DISJOINT_FROM_COUNT = TDB.find "DISJOINT_FROM_COUNT"
  fun op UNION_COUNT_FROM _ = ()
  val op UNION_COUNT_FROM = TDB.find "UNION_COUNT_FROM"
  fun op UNION_FROM_COUNT _ = ()
  val op UNION_FROM_COUNT = TDB.find "UNION_FROM_COUNT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val util_prob_grammars = merge_grammars ["real_sigma"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="util_prob"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val util_prob_grammars = 
    Portable.## (addtyUDs,addtmUDs) util_prob_grammars
  val _ = Parse.grammarDB_insert("util_prob",util_prob_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "util_prob"

end
