structure quantHeuristicsTheory :> quantHeuristicsTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quantHeuristicsTheory ... "
    else ()
  
  open Type Term Thm
  local open ConseqConvTheory listTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quantHeuristics"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/quantHeuristics/quantHeuristicsTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op GUESS_EXISTS_def _ = ()
  val op GUESS_EXISTS_def = TDB.find "GUESS_EXISTS_def"
  fun op GUESS_FORALL_def _ = ()
  val op GUESS_FORALL_def = TDB.find "GUESS_FORALL_def"
  fun op GUESS_EXISTS_POINT_def _ = ()
  val op GUESS_EXISTS_POINT_def = TDB.find "GUESS_EXISTS_POINT_def"
  fun op GUESS_FORALL_POINT_def _ = ()
  val op GUESS_FORALL_POINT_def = TDB.find "GUESS_FORALL_POINT_def"
  fun op GUESS_EXISTS_GAP_def _ = ()
  val op GUESS_EXISTS_GAP_def = TDB.find "GUESS_EXISTS_GAP_def"
  fun op GUESS_FORALL_GAP_def _ = ()
  val op GUESS_FORALL_GAP_def = TDB.find "GUESS_FORALL_GAP_def"
  fun op SIMPLE_GUESS_EXISTS_def _ = ()
  val op SIMPLE_GUESS_EXISTS_def = TDB.find "SIMPLE_GUESS_EXISTS_def"
  fun op SIMPLE_GUESS_FORALL_def _ = ()
  val op SIMPLE_GUESS_FORALL_def = TDB.find "SIMPLE_GUESS_FORALL_def"
  fun op IS_REMOVABLE_QUANT_FUN_def _ = ()
  val op IS_REMOVABLE_QUANT_FUN_def = TDB.find "IS_REMOVABLE_QUANT_FUN_def"
  fun op GUESS_EXISTS_FORALL_REWRITES _ = ()
  val op GUESS_EXISTS_FORALL_REWRITES = TDB.find
    "GUESS_EXISTS_FORALL_REWRITES"
  fun op GUESS_POINT_THM _ = ()
  val op GUESS_POINT_THM = TDB.find "GUESS_POINT_THM"
  fun op GUESS_REWRITES _ = ()
  val op GUESS_REWRITES = TDB.find "GUESS_REWRITES"
  fun op GUESS_EXISTS_POINT_THM _ = ()
  val op GUESS_EXISTS_POINT_THM = TDB.find "GUESS_EXISTS_POINT_THM"
  fun op GUESS_FORALL_POINT_THM _ = ()
  val op GUESS_FORALL_POINT_THM = TDB.find "GUESS_FORALL_POINT_THM"
  fun op GUESS_EXISTS_THM _ = ()
  val op GUESS_EXISTS_THM = TDB.find "GUESS_EXISTS_THM"
  fun op GUESS_FORALL_THM _ = ()
  val op GUESS_FORALL_THM = TDB.find "GUESS_FORALL_THM"
  fun op GUESSES_UEXISTS_THM1 _ = ()
  val op GUESSES_UEXISTS_THM1 = TDB.find "GUESSES_UEXISTS_THM1"
  fun op GUESSES_UEXISTS_THM2 _ = ()
  val op GUESSES_UEXISTS_THM2 = TDB.find "GUESSES_UEXISTS_THM2"
  fun op GUESSES_UEXISTS_THM3 _ = ()
  val op GUESSES_UEXISTS_THM3 = TDB.find "GUESSES_UEXISTS_THM3"
  fun op GUESSES_UEXISTS_THM4 _ = ()
  val op GUESSES_UEXISTS_THM4 = TDB.find "GUESSES_UEXISTS_THM4"
  fun op GUESSES_NEG_DUALITY _ = ()
  val op GUESSES_NEG_DUALITY = TDB.find "GUESSES_NEG_DUALITY"
  fun op GUESSES_NEG_REWRITE _ = ()
  val op GUESSES_NEG_REWRITE = TDB.find "GUESSES_NEG_REWRITE"
  fun op GUESSES_WEAKEN_THM _ = ()
  val op GUESSES_WEAKEN_THM = TDB.find "GUESSES_WEAKEN_THM"
  fun op GUESS_RULES_EQUATION_EXISTS_POINT _ = ()
  val op GUESS_RULES_EQUATION_EXISTS_POINT = TDB.find
    "GUESS_RULES_EQUATION_EXISTS_POINT"
  fun op GUESS_RULES_EQUATION_FORALL_POINT _ = ()
  val op GUESS_RULES_EQUATION_FORALL_POINT = TDB.find
    "GUESS_RULES_EQUATION_FORALL_POINT"
  fun op GUESS_RULES_EQUATION_EXISTS_GAP _ = ()
  val op GUESS_RULES_EQUATION_EXISTS_GAP = TDB.find
    "GUESS_RULES_EQUATION_EXISTS_GAP"
  fun op GUESS_RULES_TRIVIAL_EXISTS_POINT _ = ()
  val op GUESS_RULES_TRIVIAL_EXISTS_POINT = TDB.find
    "GUESS_RULES_TRIVIAL_EXISTS_POINT"
  fun op GUESS_RULES_TRIVIAL_FORALL_POINT _ = ()
  val op GUESS_RULES_TRIVIAL_FORALL_POINT = TDB.find
    "GUESS_RULES_TRIVIAL_FORALL_POINT"
  fun op GUESS_RULES_BOOL _ = ()
  val op GUESS_RULES_BOOL = TDB.find "GUESS_RULES_BOOL"
  fun op GUESS_RULES_TWO_CASES _ = ()
  val op GUESS_RULES_TWO_CASES = TDB.find "GUESS_RULES_TWO_CASES"
  fun op GUESS_RULES_ONE_CASE___FORALL_GAP _ = ()
  val op GUESS_RULES_ONE_CASE___FORALL_GAP = TDB.find
    "GUESS_RULES_ONE_CASE___FORALL_GAP"
  fun op GUESS_RULES_ONE_CASE___EXISTS_GAP _ = ()
  val op GUESS_RULES_ONE_CASE___EXISTS_GAP = TDB.find
    "GUESS_RULES_ONE_CASE___EXISTS_GAP"
  fun op GUESS_RULES_NEG _ = ()
  val op GUESS_RULES_NEG = TDB.find "GUESS_RULES_NEG"
  fun op GUESS_RULES_CONSTANT_EXISTS _ = ()
  val op GUESS_RULES_CONSTANT_EXISTS = TDB.find
    "GUESS_RULES_CONSTANT_EXISTS"
  fun op GUESS_RULES_CONSTANT_FORALL _ = ()
  val op GUESS_RULES_CONSTANT_FORALL = TDB.find
    "GUESS_RULES_CONSTANT_FORALL"
  fun op GUESS_RULES_DISJ _ = ()
  val op GUESS_RULES_DISJ = TDB.find "GUESS_RULES_DISJ"
  fun op GUESS_RULES_CONJ _ = ()
  val op GUESS_RULES_CONJ = TDB.find "GUESS_RULES_CONJ"
  fun op GUESS_RULES_IMP _ = ()
  val op GUESS_RULES_IMP = TDB.find "GUESS_RULES_IMP"
  fun op GUESS_RULES_EQUIV _ = ()
  val op GUESS_RULES_EQUIV = TDB.find "GUESS_RULES_EQUIV"
  fun op GUESS_RULES_COND _ = ()
  val op GUESS_RULES_COND = TDB.find "GUESS_RULES_COND"
  fun op GUESS_RULES_FORALL___NEW_FV _ = ()
  val op GUESS_RULES_FORALL___NEW_FV = TDB.find
    "GUESS_RULES_FORALL___NEW_FV"
  fun op GUESS_RULES_FORALL___NEW_FV_1 _ = ()
  val op GUESS_RULES_FORALL___NEW_FV_1 = TDB.find
    "GUESS_RULES_FORALL___NEW_FV_1"
  fun op GUESS_RULES_FORALL _ = ()
  val op GUESS_RULES_FORALL = TDB.find "GUESS_RULES_FORALL"
  fun op GUESS_RULES_EXISTS___NEW_FV _ = ()
  val op GUESS_RULES_EXISTS___NEW_FV = TDB.find
    "GUESS_RULES_EXISTS___NEW_FV"
  fun op GUESS_RULES_EXISTS___NEW_FV_1 _ = ()
  val op GUESS_RULES_EXISTS___NEW_FV_1 = TDB.find
    "GUESS_RULES_EXISTS___NEW_FV_1"
  fun op GUESS_RULES_EXISTS _ = ()
  val op GUESS_RULES_EXISTS = TDB.find "GUESS_RULES_EXISTS"
  fun op GUESS_RULES_EXISTS_UNIQUE _ = ()
  val op GUESS_RULES_EXISTS_UNIQUE = TDB.find "GUESS_RULES_EXISTS_UNIQUE"
  fun op GUESS_RULES_ELIM_UNIT _ = ()
  val op GUESS_RULES_ELIM_UNIT = TDB.find "GUESS_RULES_ELIM_UNIT"
  fun op GUESS_RULES_STRENGTHEN_EXISTS_POINT _ = ()
  val op GUESS_RULES_STRENGTHEN_EXISTS_POINT = TDB.find
    "GUESS_RULES_STRENGTHEN_EXISTS_POINT"
  fun op GUESS_RULES_STRENGTHEN_FORALL_GAP _ = ()
  val op GUESS_RULES_STRENGTHEN_FORALL_GAP = TDB.find
    "GUESS_RULES_STRENGTHEN_FORALL_GAP"
  fun op GUESS_RULES_WEAKEN_FORALL_POINT _ = ()
  val op GUESS_RULES_WEAKEN_FORALL_POINT = TDB.find
    "GUESS_RULES_WEAKEN_FORALL_POINT"
  fun op GUESS_RULES_WEAKEN_EXISTS_GAP _ = ()
  val op GUESS_RULES_WEAKEN_EXISTS_GAP = TDB.find
    "GUESS_RULES_WEAKEN_EXISTS_GAP"
  fun op CONJ_NOT_OR_THM _ = ()
  val op CONJ_NOT_OR_THM = TDB.find "CONJ_NOT_OR_THM"
  fun op EXISTS_NOT_FORALL_THM _ = ()
  val op EXISTS_NOT_FORALL_THM = TDB.find "EXISTS_NOT_FORALL_THM"
  fun op MOVE_EXISTS_IMP_THM _ = ()
  val op MOVE_EXISTS_IMP_THM = TDB.find "MOVE_EXISTS_IMP_THM"
  fun op UNWIND_EXISTS_THM _ = ()
  val op UNWIND_EXISTS_THM = TDB.find "UNWIND_EXISTS_THM"
  fun op LEFT_IMP_AND_INTRO _ = ()
  val op LEFT_IMP_AND_INTRO = TDB.find "LEFT_IMP_AND_INTRO"
  fun op RIGHT_IMP_AND_INTRO _ = ()
  val op RIGHT_IMP_AND_INTRO = TDB.find "RIGHT_IMP_AND_INTRO"
  fun op LEFT_IMP_OR_INTRO _ = ()
  val op LEFT_IMP_OR_INTRO = TDB.find "LEFT_IMP_OR_INTRO"
  fun op RIGHT_IMP_OR_INTRO _ = ()
  val op RIGHT_IMP_OR_INTRO = TDB.find "RIGHT_IMP_OR_INTRO"
  fun op IMP_NEG_CONTRA _ = ()
  val op IMP_NEG_CONTRA = TDB.find "IMP_NEG_CONTRA"
  fun op DISJ_IMP_INTRO _ = ()
  val op DISJ_IMP_INTRO = TDB.find "DISJ_IMP_INTRO"
  fun op SIMPLE_GUESS_EXISTS_ALT_DEF _ = ()
  val op SIMPLE_GUESS_EXISTS_ALT_DEF = TDB.find
    "SIMPLE_GUESS_EXISTS_ALT_DEF"
  fun op SIMPLE_GUESS_FORALL_ALT_DEF _ = ()
  val op SIMPLE_GUESS_FORALL_ALT_DEF = TDB.find
    "SIMPLE_GUESS_FORALL_ALT_DEF"
  fun op SIMPLE_GUESS_FORALL_THM _ = ()
  val op SIMPLE_GUESS_FORALL_THM = TDB.find "SIMPLE_GUESS_FORALL_THM"
  fun op SIMPLE_GUESS_EXISTS_THM _ = ()
  val op SIMPLE_GUESS_EXISTS_THM = TDB.find "SIMPLE_GUESS_EXISTS_THM"
  fun op SIMPLE_GUESS_UEXISTS_THM _ = ()
  val op SIMPLE_GUESS_UEXISTS_THM = TDB.find "SIMPLE_GUESS_UEXISTS_THM"
  fun op SIMPLE_GUESS_SELECT_THM _ = ()
  val op SIMPLE_GUESS_SELECT_THM = TDB.find "SIMPLE_GUESS_SELECT_THM"
  fun op SIMPLE_GUESS_SOME_THM _ = ()
  val op SIMPLE_GUESS_SOME_THM = TDB.find "SIMPLE_GUESS_SOME_THM"
  fun op SIMPLE_GUESS_EXISTS_EQ_1 _ = ()
  val op SIMPLE_GUESS_EXISTS_EQ_1 = TDB.find "SIMPLE_GUESS_EXISTS_EQ_1"
  fun op SIMPLE_GUESS_EXISTS_EQ_2 _ = ()
  val op SIMPLE_GUESS_EXISTS_EQ_2 = TDB.find "SIMPLE_GUESS_EXISTS_EQ_2"
  fun op SIMPLE_GUESS_EXISTS_EQ_T _ = ()
  val op SIMPLE_GUESS_EXISTS_EQ_T = TDB.find "SIMPLE_GUESS_EXISTS_EQ_T"
  fun op SIMPLE_GUESS_FORALL_NEG _ = ()
  val op SIMPLE_GUESS_FORALL_NEG = TDB.find "SIMPLE_GUESS_FORALL_NEG"
  fun op SIMPLE_GUESS_EXISTS_NEG _ = ()
  val op SIMPLE_GUESS_EXISTS_NEG = TDB.find "SIMPLE_GUESS_EXISTS_NEG"
  fun op SIMPLE_GUESS_FORALL_OR_1 _ = ()
  val op SIMPLE_GUESS_FORALL_OR_1 = TDB.find "SIMPLE_GUESS_FORALL_OR_1"
  fun op SIMPLE_GUESS_FORALL_OR_2 _ = ()
  val op SIMPLE_GUESS_FORALL_OR_2 = TDB.find "SIMPLE_GUESS_FORALL_OR_2"
  fun op SIMPLE_GUESS_EXISTS_AND_1 _ = ()
  val op SIMPLE_GUESS_EXISTS_AND_1 = TDB.find "SIMPLE_GUESS_EXISTS_AND_1"
  fun op SIMPLE_GUESS_EXISTS_AND_2 _ = ()
  val op SIMPLE_GUESS_EXISTS_AND_2 = TDB.find "SIMPLE_GUESS_EXISTS_AND_2"
  fun op SIMPLE_GUESS_EXISTS_EXISTS _ = ()
  val op SIMPLE_GUESS_EXISTS_EXISTS = TDB.find "SIMPLE_GUESS_EXISTS_EXISTS"
  fun op SIMPLE_GUESS_EXISTS_FORALL _ = ()
  val op SIMPLE_GUESS_EXISTS_FORALL = TDB.find "SIMPLE_GUESS_EXISTS_FORALL"
  fun op SIMPLE_GUESS_FORALL_EXISTS _ = ()
  val op SIMPLE_GUESS_FORALL_EXISTS = TDB.find "SIMPLE_GUESS_FORALL_EXISTS"
  fun op SIMPLE_GUESS_FORALL_FORALL _ = ()
  val op SIMPLE_GUESS_FORALL_FORALL = TDB.find "SIMPLE_GUESS_FORALL_FORALL"
  fun op SIMPLE_GUESS_FORALL_IMP_1 _ = ()
  val op SIMPLE_GUESS_FORALL_IMP_1 = TDB.find "SIMPLE_GUESS_FORALL_IMP_1"
  fun op SIMPLE_GUESS_FORALL_IMP_2 _ = ()
  val op SIMPLE_GUESS_FORALL_IMP_2 = TDB.find "SIMPLE_GUESS_FORALL_IMP_2"
  fun op SIMPLE_GUESS_EXISTS_EQ_FUN _ = ()
  val op SIMPLE_GUESS_EXISTS_EQ_FUN = TDB.find "SIMPLE_GUESS_EXISTS_EQ_FUN"
  fun op IS_REMOVABLE_QUANT_FUN___EXISTS_THM _ = ()
  val op IS_REMOVABLE_QUANT_FUN___EXISTS_THM = TDB.find
    "IS_REMOVABLE_QUANT_FUN___EXISTS_THM"
  fun op IS_REMOVABLE_QUANT_FUN___FORALL_THM _ = ()
  val op IS_REMOVABLE_QUANT_FUN___FORALL_THM = TDB.find
    "IS_REMOVABLE_QUANT_FUN___FORALL_THM"
  fun op PAIR_EQ_EXPAND _ = ()
  val op PAIR_EQ_EXPAND = TDB.find "PAIR_EQ_EXPAND"
  fun op PAIR_EQ_SIMPLE_EXPAND _ = ()
  val op PAIR_EQ_SIMPLE_EXPAND = TDB.find "PAIR_EQ_SIMPLE_EXPAND"
  fun op IS_SOME_EQ_NOT_NONE _ = ()
  val op IS_SOME_EQ_NOT_NONE = TDB.find "IS_SOME_EQ_NOT_NONE"
  fun op ISL_exists _ = () val op ISL_exists = TDB.find "ISL_exists"
  fun op ISR_exists _ = () val op ISR_exists = TDB.find "ISR_exists"
  fun op INL_NEQ_ELIM _ = () val op INL_NEQ_ELIM = TDB.find "INL_NEQ_ELIM"
  fun op INR_NEQ_ELIM _ = () val op INR_NEQ_ELIM = TDB.find "INR_NEQ_ELIM"
  fun op LENGTH_LE_PLUS _ = ()
  val op LENGTH_LE_PLUS = TDB.find "LENGTH_LE_PLUS"
  fun op LENGTH_LE_NUM _ = ()
  val op LENGTH_LE_NUM = TDB.find "LENGTH_LE_NUM"
  fun op LENGTH_NIL_SYM _ = ()
  val op LENGTH_NIL_SYM = TDB.find "LENGTH_NIL_SYM"
  fun op LIST_LENGTH_COMPARE_1 _ = ()
  val op LIST_LENGTH_COMPARE_1 = TDB.find "LIST_LENGTH_COMPARE_1"
  fun op LIST_LENGTH_0 _ = ()
  val op LIST_LENGTH_0 = TDB.find "LIST_LENGTH_0"
  fun op LIST_LENGTH_1 _ = ()
  val op LIST_LENGTH_1 = TDB.find "LIST_LENGTH_1"
  fun op LIST_LENGTH_2 _ = ()
  val op LIST_LENGTH_2 = TDB.find "LIST_LENGTH_2"
  fun op LIST_LENGTH_3 _ = ()
  val op LIST_LENGTH_3 = TDB.find "LIST_LENGTH_3"
  fun op LIST_LENGTH_4 _ = ()
  val op LIST_LENGTH_4 = TDB.find "LIST_LENGTH_4"
  fun op LIST_LENGTH_5 _ = ()
  val op LIST_LENGTH_5 = TDB.find "LIST_LENGTH_5"
  fun op LIST_LENGTH_7 _ = ()
  val op LIST_LENGTH_7 = TDB.find "LIST_LENGTH_7"
  fun op LIST_LENGTH_10 _ = ()
  val op LIST_LENGTH_10 = TDB.find "LIST_LENGTH_10"
  fun op LIST_LENGTH_15 _ = ()
  val op LIST_LENGTH_15 = TDB.find "LIST_LENGTH_15"
  fun op LIST_LENGTH_20 _ = ()
  val op LIST_LENGTH_20 = TDB.find "LIST_LENGTH_20"
  fun op LIST_LENGTH_25 _ = ()
  val op LIST_LENGTH_25 = TDB.find "LIST_LENGTH_25"
  fun op LIST_LENGTH_COMPARE_SUC _ = ()
  val op LIST_LENGTH_COMPARE_SUC = TDB.find "LIST_LENGTH_COMPARE_SUC"
  fun op HD_TL_EQ_THMS _ = ()
  val op HD_TL_EQ_THMS = TDB.find "HD_TL_EQ_THMS"
  fun op SOME_THE_EQ _ = () val op SOME_THE_EQ = TDB.find "SOME_THE_EQ"
  fun op SOME_THE_EQ_SYM _ = ()
  val op SOME_THE_EQ_SYM = TDB.find "SOME_THE_EQ_SYM"
  fun op FST_PAIR_EQ _ = () val op FST_PAIR_EQ = TDB.find "FST_PAIR_EQ"
  fun op SND_PAIR_EQ _ = () val op SND_PAIR_EQ = TDB.find "SND_PAIR_EQ"
  fun op FST_PAIR_EQ_SYM _ = ()
  val op FST_PAIR_EQ_SYM = TDB.find "FST_PAIR_EQ_SYM"
  fun op SND_PAIR_EQ_SYM _ = ()
  val op SND_PAIR_EQ_SYM = TDB.find "SND_PAIR_EQ_SYM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quantHeuristics_grammars = merge_grammars ["list", "ConseqConv"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quantHeuristics"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quantHeuristics_grammars = 
    Portable.## (addtyUDs,addtmUDs) quantHeuristics_grammars
  val _ = Parse.grammarDB_insert("quantHeuristics",quantHeuristics_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quantHeuristics"

end
