structure quotientTheory :> quotientTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quotientTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory res_quanTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quotient"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/quotient/src/quotientTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op EQUIV_def _ = () val op EQUIV_def = TDB.find "EQUIV_def"
  fun op PARTIAL_EQUIV_def _ = ()
  val op PARTIAL_EQUIV_def = TDB.find "PARTIAL_EQUIV_def"
  fun op QUOTIENT_def _ = () val op QUOTIENT_def = TDB.find "QUOTIENT_def"
  fun op FUN_MAP _ = () val op FUN_MAP = TDB.find "FUN_MAP"
  fun op FUN_REL _ = () val op FUN_REL = TDB.find "FUN_REL"
  fun op respects_def _ = () val op respects_def = TDB.find "respects_def"
  fun op ?!! _ = () val op ?!! = TDB.find "?!!"
  fun op RES_EXISTS_EQUIV_DEF _ = ()
  val op RES_EXISTS_EQUIV_DEF = TDB.find "RES_EXISTS_EQUIV_DEF"
  fun op FUN_REL_EQUALS _ = ()
  val op FUN_REL_EQUALS = TDB.find "FUN_REL_EQUALS"
  fun op EQUIV_IMP_PARTIAL_EQUIV _ = ()
  val op EQUIV_IMP_PARTIAL_EQUIV = TDB.find "EQUIV_IMP_PARTIAL_EQUIV"
  fun op QUOTIENT_ABS_REP _ = ()
  val op QUOTIENT_ABS_REP = TDB.find "QUOTIENT_ABS_REP"
  fun op QUOTIENT_REP_REFL _ = ()
  val op QUOTIENT_REP_REFL = TDB.find "QUOTIENT_REP_REFL"
  fun op QUOTIENT_REL _ = () val op QUOTIENT_REL = TDB.find "QUOTIENT_REL"
  fun op QUOTIENT_REL_ABS _ = ()
  val op QUOTIENT_REL_ABS = TDB.find "QUOTIENT_REL_ABS"
  fun op QUOTIENT_REL_ABS_EQ _ = ()
  val op QUOTIENT_REL_ABS_EQ = TDB.find "QUOTIENT_REL_ABS_EQ"
  fun op QUOTIENT_REL_REP _ = ()
  val op QUOTIENT_REL_REP = TDB.find "QUOTIENT_REL_REP"
  fun op QUOTIENT_REP_ABS _ = ()
  val op QUOTIENT_REP_ABS = TDB.find "QUOTIENT_REP_ABS"
  fun op IDENTITY_EQUIV _ = ()
  val op IDENTITY_EQUIV = TDB.find "IDENTITY_EQUIV"
  fun op IDENTITY_QUOTIENT _ = ()
  val op IDENTITY_QUOTIENT = TDB.find "IDENTITY_QUOTIENT"
  fun op EQUIV_REFL_SYM_TRANS _ = ()
  val op EQUIV_REFL_SYM_TRANS = TDB.find "EQUIV_REFL_SYM_TRANS"
  fun op QUOTIENT_SYM _ = () val op QUOTIENT_SYM = TDB.find "QUOTIENT_SYM"
  fun op QUOTIENT_TRANS _ = ()
  val op QUOTIENT_TRANS = TDB.find "QUOTIENT_TRANS"
  fun op FUN_MAP_THM _ = () val op FUN_MAP_THM = TDB.find "FUN_MAP_THM"
  fun op FUN_MAP_I _ = () val op FUN_MAP_I = TDB.find "FUN_MAP_I"
  fun op IN_FUN _ = () val op IN_FUN = TDB.find "IN_FUN"
  fun op FUN_REL_EQ _ = () val op FUN_REL_EQ = TDB.find "FUN_REL_EQ"
  fun op FUN_QUOTIENT _ = () val op FUN_QUOTIENT = TDB.find "FUN_QUOTIENT"
  fun op RESPECTS _ = () val op RESPECTS = TDB.find "RESPECTS"
  fun op IN_RESPECTS _ = () val op IN_RESPECTS = TDB.find "IN_RESPECTS"
  fun op RESPECTS_THM _ = () val op RESPECTS_THM = TDB.find "RESPECTS_THM"
  fun op RESPECTS_MP _ = () val op RESPECTS_MP = TDB.find "RESPECTS_MP"
  fun op RESPECTS_REP_ABS _ = ()
  val op RESPECTS_REP_ABS = TDB.find "RESPECTS_REP_ABS"
  fun op RESPECTS_o _ = () val op RESPECTS_o = TDB.find "RESPECTS_o"
  fun op RES_EXISTS_EQUIV _ = ()
  val op RES_EXISTS_EQUIV = TDB.find "RES_EXISTS_EQUIV"
  fun op FUN_REL_EQ_REL _ = ()
  val op FUN_REL_EQ_REL = TDB.find "FUN_REL_EQ_REL"
  fun op FUN_REL_MP _ = () val op FUN_REL_MP = TDB.find "FUN_REL_MP"
  fun op FUN_REL_IMP _ = () val op FUN_REL_IMP = TDB.find "FUN_REL_IMP"
  fun op EQUALS_PRS _ = () val op EQUALS_PRS = TDB.find "EQUALS_PRS"
  fun op EQUALS_RSP _ = () val op EQUALS_RSP = TDB.find "EQUALS_RSP"
  fun op LAMBDA_PRS _ = () val op LAMBDA_PRS = TDB.find "LAMBDA_PRS"
  fun op LAMBDA_PRS1 _ = () val op LAMBDA_PRS1 = TDB.find "LAMBDA_PRS1"
  fun op LAMBDA_RSP _ = () val op LAMBDA_RSP = TDB.find "LAMBDA_RSP"
  fun op ABSTRACT_PRS _ = () val op ABSTRACT_PRS = TDB.find "ABSTRACT_PRS"
  fun op RES_ABSTRACT_RSP _ = ()
  val op RES_ABSTRACT_RSP = TDB.find "RES_ABSTRACT_RSP"
  fun op LET_RES_ABSTRACT _ = ()
  val op LET_RES_ABSTRACT = TDB.find "LET_RES_ABSTRACT"
  fun op LAMBDA_REP_ABS_RSP _ = ()
  val op LAMBDA_REP_ABS_RSP = TDB.find "LAMBDA_REP_ABS_RSP"
  fun op REP_ABS_RSP _ = () val op REP_ABS_RSP = TDB.find "REP_ABS_RSP"
  fun op FORALL_PRS _ = () val op FORALL_PRS = TDB.find "FORALL_PRS"
  fun op RES_FORALL_RSP _ = ()
  val op RES_FORALL_RSP = TDB.find "RES_FORALL_RSP"
  fun op RES_FORALL_PRS _ = ()
  val op RES_FORALL_PRS = TDB.find "RES_FORALL_PRS"
  fun op EXISTS_PRS _ = () val op EXISTS_PRS = TDB.find "EXISTS_PRS"
  fun op RES_EXISTS_RSP _ = ()
  val op RES_EXISTS_RSP = TDB.find "RES_EXISTS_RSP"
  fun op RES_EXISTS_PRS _ = ()
  val op RES_EXISTS_PRS = TDB.find "RES_EXISTS_PRS"
  fun op EXISTS_UNIQUE_PRS _ = ()
  val op EXISTS_UNIQUE_PRS = TDB.find "EXISTS_UNIQUE_PRS"
  fun op RES_EXISTS_EQUIV_RSP _ = ()
  val op RES_EXISTS_EQUIV_RSP = TDB.find "RES_EXISTS_EQUIV_RSP"
  fun op COND_PRS _ = () val op COND_PRS = TDB.find "COND_PRS"
  fun op COND_RSP _ = () val op COND_RSP = TDB.find "COND_RSP"
  fun op LET_PRS _ = () val op LET_PRS = TDB.find "LET_PRS"
  fun op LET_RSP _ = () val op LET_RSP = TDB.find "LET_RSP"
  fun op literal_case_PRS _ = ()
  val op literal_case_PRS = TDB.find "literal_case_PRS"
  fun op literal_case_RSP _ = ()
  val op literal_case_RSP = TDB.find "literal_case_RSP"
  fun op APPLY_PRS _ = () val op APPLY_PRS = TDB.find "APPLY_PRS"
  fun op APPLY_RSP _ = () val op APPLY_RSP = TDB.find "APPLY_RSP"
  fun op I_PRS _ = () val op I_PRS = TDB.find "I_PRS"
  fun op I_RSP _ = () val op I_RSP = TDB.find "I_RSP"
  fun op K_PRS _ = () val op K_PRS = TDB.find "K_PRS"
  fun op K_RSP _ = () val op K_RSP = TDB.find "K_RSP"
  fun op o_PRS _ = () val op o_PRS = TDB.find "o_PRS"
  fun op o_RSP _ = () val op o_RSP = TDB.find "o_RSP"
  fun op C_PRS _ = () val op C_PRS = TDB.find "C_PRS"
  fun op C_RSP _ = () val op C_RSP = TDB.find "C_RSP"
  fun op W_PRS _ = () val op W_PRS = TDB.find "W_PRS"
  fun op W_RSP _ = () val op W_RSP = TDB.find "W_RSP"
  fun op EQ_IMPLIES _ = () val op EQ_IMPLIES = TDB.find "EQ_IMPLIES"
  fun op EQUALS_IMPLIES _ = ()
  val op EQUALS_IMPLIES = TDB.find "EQUALS_IMPLIES"
  fun op CONJ_IMPLIES _ = () val op CONJ_IMPLIES = TDB.find "CONJ_IMPLIES"
  fun op DISJ_IMPLIES _ = () val op DISJ_IMPLIES = TDB.find "DISJ_IMPLIES"
  fun op IMP_IMPLIES _ = () val op IMP_IMPLIES = TDB.find "IMP_IMPLIES"
  fun op NOT_IMPLIES _ = () val op NOT_IMPLIES = TDB.find "NOT_IMPLIES"
  fun op EQUALS_EQUIV_IMPLIES _ = ()
  val op EQUALS_EQUIV_IMPLIES = TDB.find "EQUALS_EQUIV_IMPLIES"
  fun op ABSTRACT_RES_ABSTRACT _ = ()
  val op ABSTRACT_RES_ABSTRACT = TDB.find "ABSTRACT_RES_ABSTRACT"
  fun op RES_ABSTRACT_ABSTRACT _ = ()
  val op RES_ABSTRACT_ABSTRACT = TDB.find "RES_ABSTRACT_ABSTRACT"
  fun op EQUIV_RES_ABSTRACT_LEFT _ = ()
  val op EQUIV_RES_ABSTRACT_LEFT = TDB.find "EQUIV_RES_ABSTRACT_LEFT"
  fun op EQUIV_RES_ABSTRACT_RIGHT _ = ()
  val op EQUIV_RES_ABSTRACT_RIGHT = TDB.find "EQUIV_RES_ABSTRACT_RIGHT"
  fun op EQUIV_RES_FORALL _ = ()
  val op EQUIV_RES_FORALL = TDB.find "EQUIV_RES_FORALL"
  fun op EQUIV_RES_EXISTS _ = ()
  val op EQUIV_RES_EXISTS = TDB.find "EQUIV_RES_EXISTS"
  fun op EQUIV_RES_EXISTS_UNIQUE _ = ()
  val op EQUIV_RES_EXISTS_UNIQUE = TDB.find "EQUIV_RES_EXISTS_UNIQUE"
  fun op FORALL_REGULAR _ = ()
  val op FORALL_REGULAR = TDB.find "FORALL_REGULAR"
  fun op EXISTS_REGULAR _ = ()
  val op EXISTS_REGULAR = TDB.find "EXISTS_REGULAR"
  fun op RES_FORALL_REGULAR _ = ()
  val op RES_FORALL_REGULAR = TDB.find "RES_FORALL_REGULAR"
  fun op RES_EXISTS_REGULAR _ = ()
  val op RES_EXISTS_REGULAR = TDB.find "RES_EXISTS_REGULAR"
  fun op LEFT_RES_FORALL_REGULAR _ = ()
  val op LEFT_RES_FORALL_REGULAR = TDB.find "LEFT_RES_FORALL_REGULAR"
  fun op RIGHT_RES_FORALL_REGULAR _ = ()
  val op RIGHT_RES_FORALL_REGULAR = TDB.find "RIGHT_RES_FORALL_REGULAR"
  fun op LEFT_RES_EXISTS_REGULAR _ = ()
  val op LEFT_RES_EXISTS_REGULAR = TDB.find "LEFT_RES_EXISTS_REGULAR"
  fun op RIGHT_RES_EXISTS_REGULAR _ = ()
  val op RIGHT_RES_EXISTS_REGULAR = TDB.find "RIGHT_RES_EXISTS_REGULAR"
  fun op EXISTS_UNIQUE_REGULAR _ = ()
  val op EXISTS_UNIQUE_REGULAR = TDB.find "EXISTS_UNIQUE_REGULAR"
  fun op RES_EXISTS_UNIQUE_RESPECTS_REGULAR _ = ()
  val op RES_EXISTS_UNIQUE_RESPECTS_REGULAR = TDB.find
    "RES_EXISTS_UNIQUE_RESPECTS_REGULAR"
  fun op RES_EXISTS_UNIQUE_REGULAR _ = ()
  val op RES_EXISTS_UNIQUE_REGULAR = TDB.find "RES_EXISTS_UNIQUE_REGULAR"
  fun op RES_EXISTS_UNIQUE_REGULAR_SAME _ = ()
  val op RES_EXISTS_UNIQUE_REGULAR_SAME = TDB.find
    "RES_EXISTS_UNIQUE_REGULAR_SAME"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quotient_grammars = merge_grammars ["res_quan", "indexedLists",
  "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quotient"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quotient_grammars = 
    Portable.## (addtyUDs,addtmUDs) quotient_grammars
  val _ = Parse.grammarDB_insert("quotient",quotient_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quotient"

end
