structure quotient_listTheory :> quotient_listTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quotient_listTheory ... "
    else ()
  
  open Type Term Thm
  local open quotientTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quotient_list"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/quotient/src/quotient_listTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op LIST_MAP_I _ = () val op LIST_MAP_I = TDB.find "LIST_MAP_I"
  fun op LIST_REL_EQ _ = () val op LIST_REL_EQ = TDB.find "LIST_REL_EQ"
  fun op LIST_REL_REFL _ = ()
  val op LIST_REL_REFL = TDB.find "LIST_REL_REFL"
  fun op LIST_EQUIV _ = () val op LIST_EQUIV = TDB.find "LIST_EQUIV"
  fun op LIST_REL_REL _ = () val op LIST_REL_REL = TDB.find "LIST_REL_REL"
  fun op LIST_QUOTIENT _ = ()
  val op LIST_QUOTIENT = TDB.find "LIST_QUOTIENT"
  fun op CONS_PRS _ = () val op CONS_PRS = TDB.find "CONS_PRS"
  fun op CONS_RSP _ = () val op CONS_RSP = TDB.find "CONS_RSP"
  fun op NIL_PRS _ = () val op NIL_PRS = TDB.find "NIL_PRS"
  fun op NIL_RSP _ = () val op NIL_RSP = TDB.find "NIL_RSP"
  fun op MAP_PRS _ = () val op MAP_PRS = TDB.find "MAP_PRS"
  fun op MAP_RSP _ = () val op MAP_RSP = TDB.find "MAP_RSP"
  fun op LENGTH_PRS _ = () val op LENGTH_PRS = TDB.find "LENGTH_PRS"
  fun op LENGTH_RSP _ = () val op LENGTH_RSP = TDB.find "LENGTH_RSP"
  fun op APPEND_PRS _ = () val op APPEND_PRS = TDB.find "APPEND_PRS"
  fun op APPEND_RSP _ = () val op APPEND_RSP = TDB.find "APPEND_RSP"
  fun op FLAT_PRS _ = () val op FLAT_PRS = TDB.find "FLAT_PRS"
  fun op FLAT_RSP _ = () val op FLAT_RSP = TDB.find "FLAT_RSP"
  fun op REVERSE_PRS _ = () val op REVERSE_PRS = TDB.find "REVERSE_PRS"
  fun op REVERSE_RSP _ = () val op REVERSE_RSP = TDB.find "REVERSE_RSP"
  fun op FILTER_PRS _ = () val op FILTER_PRS = TDB.find "FILTER_PRS"
  fun op FILTER_RSP _ = () val op FILTER_RSP = TDB.find "FILTER_RSP"
  fun op NULL_PRS _ = () val op NULL_PRS = TDB.find "NULL_PRS"
  fun op NULL_RSP _ = () val op NULL_RSP = TDB.find "NULL_RSP"
  fun op ALL_EL_PRS _ = () val op ALL_EL_PRS = TDB.find "ALL_EL_PRS"
  fun op ALL_EL_RSP _ = () val op ALL_EL_RSP = TDB.find "ALL_EL_RSP"
  fun op SOME_EL_PRS _ = () val op SOME_EL_PRS = TDB.find "SOME_EL_PRS"
  fun op SOME_EL_RSP _ = () val op SOME_EL_RSP = TDB.find "SOME_EL_RSP"
  fun op FOLDL_PRS _ = () val op FOLDL_PRS = TDB.find "FOLDL_PRS"
  fun op FOLDL_RSP _ = () val op FOLDL_RSP = TDB.find "FOLDL_RSP"
  fun op FOLDR_PRS _ = () val op FOLDR_PRS = TDB.find "FOLDR_PRS"
  fun op FOLDR_RSP _ = () val op FOLDR_RSP = TDB.find "FOLDR_RSP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quotient_list_grammars = merge_grammars ["quotient"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quotient_list"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quotient_list_grammars = 
    Portable.## (addtyUDs,addtmUDs) quotient_list_grammars
  val _ = Parse.grammarDB_insert("quotient_list",quotient_list_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quotient_list"

end
