structure quotient_optionTheory :> quotient_optionTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quotient_optionTheory ... "
    else ()
  
  open Type Term Thm
  local open quotientTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quotient_option"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/quotient/src/quotient_optionTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op OPTION_MAP_I _ = () val op OPTION_MAP_I = TDB.find "OPTION_MAP_I"
  fun op OPTION_REL_def _ = ()
  val op OPTION_REL_def = TDB.find "OPTION_REL_def"
  fun op OPTION_REL_EQ _ = ()
  val op OPTION_REL_EQ = TDB.find "OPTION_REL_EQ"
  fun op OPTION_EQUIV _ = () val op OPTION_EQUIV = TDB.find "OPTION_EQUIV"
  fun op OPTION_QUOTIENT _ = ()
  val op OPTION_QUOTIENT = TDB.find "OPTION_QUOTIENT"
  fun op NONE_PRS _ = () val op NONE_PRS = TDB.find "NONE_PRS"
  fun op NONE_RSP _ = () val op NONE_RSP = TDB.find "NONE_RSP"
  fun op SOME_PRS _ = () val op SOME_PRS = TDB.find "SOME_PRS"
  fun op SOME_RSP _ = () val op SOME_RSP = TDB.find "SOME_RSP"
  fun op IS_SOME_PRS _ = () val op IS_SOME_PRS = TDB.find "IS_SOME_PRS"
  fun op IS_SOME_RSP _ = () val op IS_SOME_RSP = TDB.find "IS_SOME_RSP"
  fun op IS_NONE_PRS _ = () val op IS_NONE_PRS = TDB.find "IS_NONE_PRS"
  fun op IS_NONE_RSP _ = () val op IS_NONE_RSP = TDB.find "IS_NONE_RSP"
  fun op OPTION_MAP_PRS _ = ()
  val op OPTION_MAP_PRS = TDB.find "OPTION_MAP_PRS"
  fun op OPTION_MAP_RSP _ = ()
  val op OPTION_MAP_RSP = TDB.find "OPTION_MAP_RSP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quotient_option_grammars = merge_grammars ["quotient"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quotient_option"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quotient_option_grammars = 
    Portable.## (addtyUDs,addtmUDs) quotient_option_grammars
  val _ = Parse.grammarDB_insert("quotient_option",quotient_option_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quotient_option"

end
