structure quotient_pairTheory :> quotient_pairTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quotient_pairTheory ... "
    else ()
  
  open Type Term Thm
  local open quotientTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quotient_pair"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/quotient/src/quotient_pairTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op PAIR_REL _ = () val op PAIR_REL = TDB.find "PAIR_REL"
  fun op PAIR_MAP_I _ = () val op PAIR_MAP_I = TDB.find "PAIR_MAP_I"
  fun op PAIR_REL_THM _ = () val op PAIR_REL_THM = TDB.find "PAIR_REL_THM"
  fun op PAIR_REL_EQ _ = () val op PAIR_REL_EQ = TDB.find "PAIR_REL_EQ"
  fun op PAIR_REL_REFL _ = ()
  val op PAIR_REL_REFL = TDB.find "PAIR_REL_REFL"
  fun op PAIR_EQUIV _ = () val op PAIR_EQUIV = TDB.find "PAIR_EQUIV"
  fun op PAIR_QUOTIENT _ = ()
  val op PAIR_QUOTIENT = TDB.find "PAIR_QUOTIENT"
  fun op FST_PRS _ = () val op FST_PRS = TDB.find "FST_PRS"
  fun op FST_RSP _ = () val op FST_RSP = TDB.find "FST_RSP"
  fun op SND_PRS _ = () val op SND_PRS = TDB.find "SND_PRS"
  fun op SND_RSP _ = () val op SND_RSP = TDB.find "SND_RSP"
  fun op COMMA_PRS _ = () val op COMMA_PRS = TDB.find "COMMA_PRS"
  fun op COMMA_RSP _ = () val op COMMA_RSP = TDB.find "COMMA_RSP"
  fun op CURRY_PRS _ = () val op CURRY_PRS = TDB.find "CURRY_PRS"
  fun op CURRY_RSP _ = () val op CURRY_RSP = TDB.find "CURRY_RSP"
  fun op UNCURRY_PRS _ = () val op UNCURRY_PRS = TDB.find "UNCURRY_PRS"
  fun op UNCURRY_RSP _ = () val op UNCURRY_RSP = TDB.find "UNCURRY_RSP"
  fun op PAIR_MAP_PRS _ = () val op PAIR_MAP_PRS = TDB.find "PAIR_MAP_PRS"
  fun op PAIR_MAP_RSP _ = () val op PAIR_MAP_RSP = TDB.find "PAIR_MAP_RSP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quotient_pair_grammars = merge_grammars ["quotient"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quotient_pair"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quotient_pair_grammars = 
    Portable.## (addtyUDs,addtmUDs) quotient_pair_grammars
  val _ = Parse.grammarDB_insert("quotient_pair",quotient_pair_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quotient_pair"

end
