structure quotient_pred_setTheory :> quotient_pred_setTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quotient_pred_setTheory ... "
    else ()
  
  open Type Term Thm
  local open quotient_pairTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quotient_pred_set"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/quotient/src/quotient_pred_setTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op GSPECR_def _ = () val op GSPECR_def = TDB.find "GSPECR_def"
  fun op SUBSETR_def _ = () val op SUBSETR_def = TDB.find "SUBSETR_def"
  fun op PSUBSETR_def _ = () val op PSUBSETR_def = TDB.find "PSUBSETR_def"
  fun op INSERTR_def _ = () val op INSERTR_def = TDB.find "INSERTR_def"
  fun op DELETER_def _ = () val op DELETER_def = TDB.find "DELETER_def"
  fun op DISJOINTR_def _ = ()
  val op DISJOINTR_def = TDB.find "DISJOINTR_def"
  fun op FINITER_def _ = () val op FINITER_def = TDB.find "FINITER_def"
  fun op IMAGER_def _ = () val op IMAGER_def = TDB.find "IMAGER_def"
  fun op IN_SET_MAP _ = () val op IN_SET_MAP = TDB.find "IN_SET_MAP"
  fun op SET_REL _ = () val op SET_REL = TDB.find "SET_REL"
  fun op SET_REL_MP _ = () val op SET_REL_MP = TDB.find "SET_REL_MP"
  fun op IN_PRS _ = () val op IN_PRS = TDB.find "IN_PRS"
  fun op IN_RSP _ = () val op IN_RSP = TDB.find "IN_RSP"
  fun op IN_GSPECR _ = () val op IN_GSPECR = TDB.find "IN_GSPECR"
  fun op GSPEC_PRS _ = () val op GSPEC_PRS = TDB.find "GSPEC_PRS"
  fun op GSPECR_RSP _ = () val op GSPECR_RSP = TDB.find "GSPECR_RSP"
  fun op EMPTY_PRS _ = () val op EMPTY_PRS = TDB.find "EMPTY_PRS"
  fun op EMPTY_RSP _ = () val op EMPTY_RSP = TDB.find "EMPTY_RSP"
  fun op UNIV_PRS _ = () val op UNIV_PRS = TDB.find "UNIV_PRS"
  fun op UNIV_RSP _ = () val op UNIV_RSP = TDB.find "UNIV_RSP"
  fun op UNION_PRS _ = () val op UNION_PRS = TDB.find "UNION_PRS"
  fun op UNION_RSP _ = () val op UNION_RSP = TDB.find "UNION_RSP"
  fun op INTER_PRS _ = () val op INTER_PRS = TDB.find "INTER_PRS"
  fun op INTER_RSP _ = () val op INTER_RSP = TDB.find "INTER_RSP"
  fun op SUBSET_PRS _ = () val op SUBSET_PRS = TDB.find "SUBSET_PRS"
  fun op SUBSETR_RSP _ = () val op SUBSETR_RSP = TDB.find "SUBSETR_RSP"
  fun op PSUBSET_PRS _ = () val op PSUBSET_PRS = TDB.find "PSUBSET_PRS"
  fun op PSUBSETR_RSP _ = () val op PSUBSETR_RSP = TDB.find "PSUBSETR_RSP"
  fun op IN_INSERTR _ = () val op IN_INSERTR = TDB.find "IN_INSERTR"
  fun op INSERT_PRS _ = () val op INSERT_PRS = TDB.find "INSERT_PRS"
  fun op INSERTR_RSP _ = () val op INSERTR_RSP = TDB.find "INSERTR_RSP"
  fun op IN_DELETER _ = () val op IN_DELETER = TDB.find "IN_DELETER"
  fun op DELETE_PRS _ = () val op DELETE_PRS = TDB.find "DELETE_PRS"
  fun op DELETER_RSP _ = () val op DELETER_RSP = TDB.find "DELETER_RSP"
  fun op DIFF_PRS _ = () val op DIFF_PRS = TDB.find "DIFF_PRS"
  fun op DIFF_RSP _ = () val op DIFF_RSP = TDB.find "DIFF_RSP"
  fun op DISJOINT_PRS _ = () val op DISJOINT_PRS = TDB.find "DISJOINT_PRS"
  fun op DISJOINTR_RSP _ = ()
  val op DISJOINTR_RSP = TDB.find "DISJOINTR_RSP"
  fun op FINITE_PRS _ = () val op FINITE_PRS = TDB.find "FINITE_PRS"
  fun op FINITER_EQ _ = () val op FINITER_EQ = TDB.find "FINITER_EQ"
  fun op FINITER_RSP _ = () val op FINITER_RSP = TDB.find "FINITER_RSP"
  fun op FINITER_EMPTY _ = ()
  val op FINITER_EMPTY = TDB.find "FINITER_EMPTY"
  fun op FINITER_INSERTR _ = ()
  val op FINITER_INSERTR = TDB.find "FINITER_INSERTR"
  fun op ABSORPTIONR _ = () val op ABSORPTIONR = TDB.find "ABSORPTIONR"
  fun op FINITER_INDUCT _ = ()
  val op FINITER_INDUCT = TDB.find "FINITER_INDUCT"
  fun op IN_IMAGER _ = () val op IN_IMAGER = TDB.find "IN_IMAGER"
  fun op IMAGE_PRS _ = () val op IMAGE_PRS = TDB.find "IMAGE_PRS"
  fun op IMAGER_RSP _ = () val op IMAGER_RSP = TDB.find "IMAGER_RSP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quotient_pred_set_grammars = merge_grammars ["quotient_pair"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quotient_pred_set"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quotient_pred_set_grammars = 
    Portable.## (addtyUDs,addtmUDs) quotient_pred_set_grammars
  val _ = Parse.grammarDB_insert("quotient_pred_set",quotient_pred_set_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quotient_pred_set"

end
