structure quotient_sumTheory :> quotient_sumTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quotient_sumTheory ... "
    else ()
  
  open Type Term Thm
  local open quotientTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quotient_sum"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/quotient/src/quotient_sumTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op SUM_REL_ind _ = () val op SUM_REL_ind = TDB.find "SUM_REL_ind"
  fun op SUM_REL_def _ = () val op SUM_REL_def = TDB.find "SUM_REL_def"
  fun op SUM_REL_EQ _ = () val op SUM_REL_EQ = TDB.find "SUM_REL_EQ"
  fun op SUM_EQUIV _ = () val op SUM_EQUIV = TDB.find "SUM_EQUIV"
  fun op SUM_QUOTIENT _ = () val op SUM_QUOTIENT = TDB.find "SUM_QUOTIENT"
  fun op INL_PRS _ = () val op INL_PRS = TDB.find "INL_PRS"
  fun op INL_RSP _ = () val op INL_RSP = TDB.find "INL_RSP"
  fun op INR_PRS _ = () val op INR_PRS = TDB.find "INR_PRS"
  fun op INR_RSP _ = () val op INR_RSP = TDB.find "INR_RSP"
  fun op ISL_PRS _ = () val op ISL_PRS = TDB.find "ISL_PRS"
  fun op ISL_RSP _ = () val op ISL_RSP = TDB.find "ISL_RSP"
  fun op ISR_PRS _ = () val op ISR_PRS = TDB.find "ISR_PRS"
  fun op ISR_RSP _ = () val op ISR_RSP = TDB.find "ISR_RSP"
  fun op SUM_MAP_PRS _ = () val op SUM_MAP_PRS = TDB.find "SUM_MAP_PRS"
  fun op SUM_MAP_RSP _ = () val op SUM_MAP_RSP = TDB.find "SUM_MAP_RSP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quotient_sum_grammars = merge_grammars ["quotient"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quotient_sum"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quotient_sum_grammars = 
    Portable.## (addtyUDs,addtmUDs) quotient_sum_grammars
  val _ = Parse.grammarDB_insert("quotient_sum",quotient_sum_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quotient_sum"

end
