structure fracTheory :> fracTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading fracTheory ... "
    else ()
  
  open Type Term Thm
  local open intExtensionTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "frac"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/rational/fracTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op frac_TY_DEF _ = () val op frac_TY_DEF = TDB.find "frac_TY_DEF"
  fun op frac_tybij _ = () val op frac_tybij = TDB.find "frac_tybij"
  fun op frac_nmr_def _ = () val op frac_nmr_def = TDB.find "frac_nmr_def"
  fun op frac_dnm_def _ = () val op frac_dnm_def = TDB.find "frac_dnm_def"
  fun op frac_sgn_def _ = () val op frac_sgn_def = TDB.find "frac_sgn_def"
  fun op frac_ainv_def _ = ()
  val op frac_ainv_def = TDB.find "frac_ainv_def"
  fun op frac_minv_def _ = ()
  val op frac_minv_def = TDB.find "frac_minv_def"
  fun op frac_0_def _ = () val op frac_0_def = TDB.find "frac_0_def"
  fun op frac_1_def _ = () val op frac_1_def = TDB.find "frac_1_def"
  fun op les_abs_def _ = () val op les_abs_def = TDB.find "les_abs_def"
  fun op frac_add_def _ = () val op frac_add_def = TDB.find "frac_add_def"
  fun op frac_sub_def _ = () val op frac_sub_def = TDB.find "frac_sub_def"
  fun op frac_mul_def _ = () val op frac_mul_def = TDB.find "frac_mul_def"
  fun op frac_div_def _ = () val op frac_div_def = TDB.find "frac_div_def"
  fun op frac_save_def _ = ()
  val op frac_save_def = TDB.find "frac_save_def"
  fun op frac_bij _ = () val op frac_bij = TDB.find "frac_bij"
  fun op FRAC _ = () val op FRAC = TDB.find "FRAC"
  fun op FRAC_EQ _ = () val op FRAC_EQ = TDB.find "FRAC_EQ"
  fun op FRAC_EQ_ALT _ = () val op FRAC_EQ_ALT = TDB.find "FRAC_EQ_ALT"
  fun op FRAC_NOT_EQ _ = () val op FRAC_NOT_EQ = TDB.find "FRAC_NOT_EQ"
  fun op FRAC_NOT_EQ_IMP _ = ()
  val op FRAC_NOT_EQ_IMP = TDB.find "FRAC_NOT_EQ_IMP"
  fun op FRAC_DNMPOS _ = () val op FRAC_DNMPOS = TDB.find "FRAC_DNMPOS"
  fun op NMR _ = () val op NMR = TDB.find "NMR"
  fun op DNM _ = () val op DNM = TDB.find "DNM"
  fun op FRAC_AINV_CALCULATE _ = ()
  val op FRAC_AINV_CALCULATE = TDB.find "FRAC_AINV_CALCULATE"
  fun op FRAC_MINV_CALCULATE _ = ()
  val op FRAC_MINV_CALCULATE = TDB.find "FRAC_MINV_CALCULATE"
  fun op FRAC_SGN_CALCULATE _ = ()
  val op FRAC_SGN_CALCULATE = TDB.find "FRAC_SGN_CALCULATE"
  fun op FRAC_ADD_CALCULATE _ = ()
  val op FRAC_ADD_CALCULATE = TDB.find "FRAC_ADD_CALCULATE"
  fun op FRAC_SUB_CALCULATE _ = ()
  val op FRAC_SUB_CALCULATE = TDB.find "FRAC_SUB_CALCULATE"
  fun op FRAC_MULT_CALCULATE _ = ()
  val op FRAC_MULT_CALCULATE = TDB.find "FRAC_MULT_CALCULATE"
  fun op FRAC_DIV_CALCULATE _ = ()
  val op FRAC_DIV_CALCULATE = TDB.find "FRAC_DIV_CALCULATE"
  fun op FRAC_ADD_ASSOC _ = ()
  val op FRAC_ADD_ASSOC = TDB.find "FRAC_ADD_ASSOC"
  fun op FRAC_MUL_ASSOC _ = ()
  val op FRAC_MUL_ASSOC = TDB.find "FRAC_MUL_ASSOC"
  fun op FRAC_ADD_COMM _ = ()
  val op FRAC_ADD_COMM = TDB.find "FRAC_ADD_COMM"
  fun op FRAC_MUL_COMM _ = ()
  val op FRAC_MUL_COMM = TDB.find "FRAC_MUL_COMM"
  fun op FRAC_ADD_RID _ = () val op FRAC_ADD_RID = TDB.find "FRAC_ADD_RID"
  fun op FRAC_MUL_RID _ = () val op FRAC_MUL_RID = TDB.find "FRAC_MUL_RID"
  fun op FRAC_1_0 _ = () val op FRAC_1_0 = TDB.find "FRAC_1_0"
  fun op FRAC_AINV_0 _ = () val op FRAC_AINV_0 = TDB.find "FRAC_AINV_0"
  fun op FRAC_AINV_AINV _ = ()
  val op FRAC_AINV_AINV = TDB.find "FRAC_AINV_AINV"
  fun op FRAC_AINV_ADD _ = ()
  val op FRAC_AINV_ADD = TDB.find "FRAC_AINV_ADD"
  fun op FRAC_AINV_SUB _ = ()
  val op FRAC_AINV_SUB = TDB.find "FRAC_AINV_SUB"
  fun op FRAC_AINV_RMUL _ = ()
  val op FRAC_AINV_RMUL = TDB.find "FRAC_AINV_RMUL"
  fun op FRAC_AINV_LMUL _ = ()
  val op FRAC_AINV_LMUL = TDB.find "FRAC_AINV_LMUL"
  fun op FRAC_MINV_1 _ = () val op FRAC_MINV_1 = TDB.find "FRAC_MINV_1"
  fun op FRAC_SUB_ADD _ = () val op FRAC_SUB_ADD = TDB.find "FRAC_SUB_ADD"
  fun op FRAC_SUB_SUB _ = () val op FRAC_SUB_SUB = TDB.find "FRAC_SUB_SUB"
  fun op FRAC_SGN_TOTAL _ = ()
  val op FRAC_SGN_TOTAL = TDB.find "FRAC_SGN_TOTAL"
  fun op FRAC_SGN_POS _ = () val op FRAC_SGN_POS = TDB.find "FRAC_SGN_POS"
  fun op FRAC_SGN_NOT_NEG _ = ()
  val op FRAC_SGN_NOT_NEG = TDB.find "FRAC_SGN_NOT_NEG"
  fun op FRAC_SGN_NEG _ = () val op FRAC_SGN_NEG = TDB.find "FRAC_SGN_NEG"
  fun op FRAC_SGN_IMP_EQGT _ = ()
  val op FRAC_SGN_IMP_EQGT = TDB.find "FRAC_SGN_IMP_EQGT"
  fun op FRAC_SGN_MUL _ = () val op FRAC_SGN_MUL = TDB.find "FRAC_SGN_MUL"
  fun op FRAC_ABS_SGN _ = () val op FRAC_ABS_SGN = TDB.find "FRAC_ABS_SGN"
  fun op FRAC_SGN_MUL2 _ = ()
  val op FRAC_SGN_MUL2 = TDB.find "FRAC_SGN_MUL2"
  fun op FRAC_SGN_CASES _ = ()
  val op FRAC_SGN_CASES = TDB.find "FRAC_SGN_CASES"
  fun op FRAC_SGN_AINV _ = ()
  val op FRAC_SGN_AINV = TDB.find "FRAC_SGN_AINV"
  fun op FRAC_AINV_ONEONE _ = ()
  val op FRAC_AINV_ONEONE = TDB.find "FRAC_AINV_ONEONE"
  fun op FRAC_AINV_ONTO _ = ()
  val op FRAC_AINV_ONTO = TDB.find "FRAC_AINV_ONTO"
  fun op FRAC_NMR_SAVE _ = ()
  val op FRAC_NMR_SAVE = TDB.find "FRAC_NMR_SAVE"
  fun op FRAC_DNM_SAVE _ = ()
  val op FRAC_DNM_SAVE = TDB.find "FRAC_DNM_SAVE"
  fun op FRAC_0_SAVE _ = () val op FRAC_0_SAVE = TDB.find "FRAC_0_SAVE"
  fun op FRAC_1_SAVE _ = () val op FRAC_1_SAVE = TDB.find "FRAC_1_SAVE"
  fun op FRAC_AINV_SAVE _ = ()
  val op FRAC_AINV_SAVE = TDB.find "FRAC_AINV_SAVE"
  fun op FRAC_MINV_SAVE _ = ()
  val op FRAC_MINV_SAVE = TDB.find "FRAC_MINV_SAVE"
  fun op FRAC_ADD_SAVE _ = ()
  val op FRAC_ADD_SAVE = TDB.find "FRAC_ADD_SAVE"
  fun op FRAC_MUL_SAVE _ = ()
  val op FRAC_MUL_SAVE = TDB.find "FRAC_MUL_SAVE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val frac_grammars = merge_grammars ["intExtension"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="frac"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val frac_grammars = 
    Portable.## (addtyUDs,addtmUDs) frac_grammars
  val _ = Parse.grammarDB_insert("frac",frac_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "frac"

end
