structure intExtensionTheory :> intExtensionTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading intExtensionTheory ... "
    else ()
  
  open Type Term Thm
  local open OmegaTheory int_arithTheory integerRingTheory numRingTheory
  in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "intExtension"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/rational/intExtensionTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op SGN_def _ = () val op SGN_def = TDB.find "SGN_def"
  fun op INT_SGN_TOTAL _ = ()
  val op INT_SGN_TOTAL = TDB.find "INT_SGN_TOTAL"
  fun op INT_SGN_MUL2 _ = () val op INT_SGN_MUL2 = TDB.find "INT_SGN_MUL2"
  fun op INT_SGN_MUL _ = () val op INT_SGN_MUL = TDB.find "INT_SGN_MUL"
  fun op INT_SGN_CLAUSES _ = ()
  val op INT_SGN_CLAUSES = TDB.find "INT_SGN_CLAUSES"
  fun op INT_NOT0_SGNNOT0 _ = ()
  val op INT_NOT0_SGNNOT0 = TDB.find "INT_NOT0_SGNNOT0"
  fun op INT_ABS_CALCULATE_POS _ = ()
  val op INT_ABS_CALCULATE_POS = TDB.find "INT_ABS_CALCULATE_POS"
  fun op INT_ABS_CALCULATE_0 _ = ()
  val op INT_ABS_CALCULATE_0 = TDB.find "INT_ABS_CALCULATE_0"
  fun op INT_ABS_CALCULATE_NEG _ = ()
  val op INT_ABS_CALCULATE_NEG = TDB.find "INT_ABS_CALCULATE_NEG"
  fun op INT_GT_RMUL_EXP _ = ()
  val op INT_GT_RMUL_EXP = TDB.find "INT_GT_RMUL_EXP"
  fun op INT_LT_RMUL_EXP _ = ()
  val op INT_LT_RMUL_EXP = TDB.find "INT_LT_RMUL_EXP"
  fun op INT_EQ_RMUL_EXP _ = ()
  val op INT_EQ_RMUL_EXP = TDB.find "INT_EQ_RMUL_EXP"
  fun op LESS_IMP_NOT_0 _ = ()
  val op LESS_IMP_NOT_0 = TDB.find "LESS_IMP_NOT_0"
  fun op ABS_EQ_MUL_SGN _ = ()
  val op ABS_EQ_MUL_SGN = TDB.find "ABS_EQ_MUL_SGN"
  fun op MUL_ABS_SGN _ = () val op MUL_ABS_SGN = TDB.find "MUL_ABS_SGN"
  fun op INT_MUL_POS_SIGN _ = ()
  val op INT_MUL_POS_SIGN = TDB.find "INT_MUL_POS_SIGN"
  fun op INT_NE_IMP_LTGT _ = ()
  val op INT_NE_IMP_LTGT = TDB.find "INT_NE_IMP_LTGT"
  fun op INT_NOTGT_IMP_EQLT _ = ()
  val op INT_NOTGT_IMP_EQLT = TDB.find "INT_NOTGT_IMP_EQLT"
  fun op INT_NO_ZERODIV _ = ()
  val op INT_NO_ZERODIV = TDB.find "INT_NO_ZERODIV"
  fun op INT_NOTPOS0_NEG _ = ()
  val op INT_NOTPOS0_NEG = TDB.find "INT_NOTPOS0_NEG"
  fun op INT_NOT0_MUL _ = () val op INT_NOT0_MUL = TDB.find "INT_NOT0_MUL"
  fun op INT_GT0_IMP_NOT0 _ = ()
  val op INT_GT0_IMP_NOT0 = TDB.find "INT_GT0_IMP_NOT0"
  fun op INT_NOTLTEQ_GT _ = ()
  val op INT_NOTLTEQ_GT = TDB.find "INT_NOTLTEQ_GT"
  fun op INT_ABS_NOT0POS _ = ()
  val op INT_ABS_NOT0POS = TDB.find "INT_ABS_NOT0POS"
  fun op INT_SGN_NOTPOSNEG _ = ()
  val op INT_SGN_NOTPOSNEG = TDB.find "INT_SGN_NOTPOSNEG"
  fun op INT_SGN_CASES _ = ()
  val op INT_SGN_CASES = TDB.find "INT_SGN_CASES"
  fun op INT_LT_ADD_NEG _ = ()
  val op INT_LT_ADD_NEG = TDB.find "INT_LT_ADD_NEG"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val intExtension_grammars = merge_grammars ["integerRing", "numRing",
  "Omega", "int_arith"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="intExtension"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val intExtension_grammars = 
    Portable.## (addtyUDs,addtmUDs) intExtension_grammars
  val _ = Parse.grammarDB_insert("intExtension",intExtension_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "intExtension"

end
