structure ratRingTheory :> ratRingTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ratRingTheory ... "
    else ()
  
  open Type Term Thm
  local open ratTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ratRing"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/rational/ratRingTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op rat_interp_p_def _ = ()
  val op rat_interp_p_def = TDB.find "rat_interp_p_def"
  fun op rat_polynom_simplify_def _ = ()
  val op rat_polynom_simplify_def = TDB.find "rat_polynom_simplify_def"
  fun op rat_polynom_normalize_def _ = ()
  val op rat_polynom_normalize_def = TDB.find "rat_polynom_normalize_def"
  fun op rat_r_canonical_sum_merge_def _ = ()
  val op rat_r_canonical_sum_merge_def = TDB.find
    "rat_r_canonical_sum_merge_def"
  fun op rat_r_monom_insert_def _ = ()
  val op rat_r_monom_insert_def = TDB.find "rat_r_monom_insert_def"
  fun op rat_r_varlist_insert_def _ = ()
  val op rat_r_varlist_insert_def = TDB.find "rat_r_varlist_insert_def"
  fun op rat_r_canonical_sum_scalar_def _ = ()
  val op rat_r_canonical_sum_scalar_def = TDB.find
    "rat_r_canonical_sum_scalar_def"
  fun op rat_r_canonical_sum_scalar2_def _ = ()
  val op rat_r_canonical_sum_scalar2_def = TDB.find
    "rat_r_canonical_sum_scalar2_def"
  fun op rat_r_canonical_sum_scalar3_def _ = ()
  val op rat_r_canonical_sum_scalar3_def = TDB.find
    "rat_r_canonical_sum_scalar3_def"
  fun op rat_r_canonical_sum_prod_def _ = ()
  val op rat_r_canonical_sum_prod_def = TDB.find
    "rat_r_canonical_sum_prod_def"
  fun op rat_r_canonical_sum_simplify_def _ = ()
  val op rat_r_canonical_sum_simplify_def = TDB.find
    "rat_r_canonical_sum_simplify_def"
  fun op rat_r_ivl_aux_def _ = ()
  val op rat_r_ivl_aux_def = TDB.find "rat_r_ivl_aux_def"
  fun op rat_r_interp_vl_def _ = ()
  val op rat_r_interp_vl_def = TDB.find "rat_r_interp_vl_def"
  fun op rat_r_interp_m_def _ = ()
  val op rat_r_interp_m_def = TDB.find "rat_r_interp_m_def"
  fun op rat_r_ics_aux_def _ = ()
  val op rat_r_ics_aux_def = TDB.find "rat_r_ics_aux_def"
  fun op rat_r_interp_cs_def _ = ()
  val op rat_r_interp_cs_def = TDB.find "rat_r_interp_cs_def"
  fun op rat_r_spolynom_normalize_def _ = ()
  val op rat_r_spolynom_normalize_def = TDB.find
    "rat_r_spolynom_normalize_def"
  fun op rat_r_spolynom_simplify_def _ = ()
  val op rat_r_spolynom_simplify_def = TDB.find
    "rat_r_spolynom_simplify_def"
  fun op rat_r_interp_sp_def _ = ()
  val op rat_r_interp_sp_def = TDB.find "rat_r_interp_sp_def"
  fun op RAT_IS_RING _ = () val op RAT_IS_RING = TDB.find "RAT_IS_RING"
  fun op rat_ring_thms _ = ()
  val op rat_ring_thms = TDB.find "rat_ring_thms"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ratRing_grammars = merge_grammars ["rat"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ratRing"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ratRing_grammars = 
    Portable.## (addtyUDs,addtmUDs) ratRing_grammars
  val _ = Parse.grammarDB_insert("ratRing",ratRing_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ratRing"

end
