structure ratTheory :> ratTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ratTheory ... "
    else ()
  
  open Type Term Thm
  local open fracTheory ratPP in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "rat"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/rational/ratTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op rat_equiv_def _ = ()
  val op rat_equiv_def = TDB.find "rat_equiv_def"
  fun op rat_TY_DEF _ = () val op rat_TY_DEF = TDB.find "rat_TY_DEF"
  fun op rat_bijections _ = ()
  val op rat_bijections = TDB.find "rat_bijections"
  fun op rep_rat_def _ = () val op rep_rat_def = TDB.find "rep_rat_def"
  fun op abs_rat_def _ = () val op abs_rat_def = TDB.find "abs_rat_def"
  fun op rat_nmr_def _ = () val op rat_nmr_def = TDB.find "rat_nmr_def"
  fun op rat_dnm_def _ = () val op rat_dnm_def = TDB.find "rat_dnm_def"
  fun op rat_sgn_def _ = () val op rat_sgn_def = TDB.find "rat_sgn_def"
  fun op rat_0_def _ = () val op rat_0_def = TDB.find "rat_0_def"
  fun op rat_1_def _ = () val op rat_1_def = TDB.find "rat_1_def"
  fun op rat_ainv_def _ = () val op rat_ainv_def = TDB.find "rat_ainv_def"
  fun op rat_minv_def _ = () val op rat_minv_def = TDB.find "rat_minv_def"
  fun op rat_add_def _ = () val op rat_add_def = TDB.find "rat_add_def"
  fun op rat_sub_def _ = () val op rat_sub_def = TDB.find "rat_sub_def"
  fun op rat_mul_def _ = () val op rat_mul_def = TDB.find "rat_mul_def"
  fun op rat_div_def _ = () val op rat_div_def = TDB.find "rat_div_def"
  fun op rat_les_def _ = () val op rat_les_def = TDB.find "rat_les_def"
  fun op rat_gre_def _ = () val op rat_gre_def = TDB.find "rat_gre_def"
  fun op rat_leq_def _ = () val op rat_leq_def = TDB.find "rat_leq_def"
  fun op rat_geq_def _ = () val op rat_geq_def = TDB.find "rat_geq_def"
  fun op rat_cons_def _ = () val op rat_cons_def = TDB.find "rat_cons_def"
  fun op rat_of_num_primitive_def _ = ()
  val op rat_of_num_primitive_def = TDB.find "rat_of_num_primitive_def"
  fun op rat_of_int_def _ = ()
  val op rat_of_int_def = TDB.find "rat_of_int_def"
  fun op RATND_THM _ = () val op RATND_THM = TDB.find "RATND_THM"
  fun op rat_min_def _ = () val op rat_min_def = TDB.find "rat_min_def"
  fun op rat_max_def _ = () val op rat_max_def = TDB.find "rat_max_def"
  fun op RAT_EQUIV_REF _ = ()
  val op RAT_EQUIV_REF = TDB.find "RAT_EQUIV_REF"
  fun op RAT_EQUIV_SYM _ = ()
  val op RAT_EQUIV_SYM = TDB.find "RAT_EQUIV_SYM"
  fun op RAT_EQUIV_NMR_Z_IFF _ = ()
  val op RAT_EQUIV_NMR_Z_IFF = TDB.find "RAT_EQUIV_NMR_Z_IFF"
  fun op RAT_EQUIV_NMR_GTZ_IFF _ = ()
  val op RAT_EQUIV_NMR_GTZ_IFF = TDB.find "RAT_EQUIV_NMR_GTZ_IFF"
  fun op RAT_EQUIV_NMR_LTZ_IFF _ = ()
  val op RAT_EQUIV_NMR_LTZ_IFF = TDB.find "RAT_EQUIV_NMR_LTZ_IFF"
  fun op RAT_NMR_Z_IFF_EQUIV _ = ()
  val op RAT_NMR_Z_IFF_EQUIV = TDB.find "RAT_NMR_Z_IFF_EQUIV"
  fun op RAT_EQUIV_TRANS _ = ()
  val op RAT_EQUIV_TRANS = TDB.find "RAT_EQUIV_TRANS"
  fun op RAT_EQUIV _ = () val op RAT_EQUIV = TDB.find "RAT_EQUIV"
  fun op RAT_EQUIV_ALT _ = ()
  val op RAT_EQUIV_ALT = TDB.find "RAT_EQUIV_ALT"
  fun op rat_ABS_REP_CLASS _ = ()
  val op rat_ABS_REP_CLASS = TDB.find "rat_ABS_REP_CLASS"
  fun op rat_QUOTIENT _ = () val op rat_QUOTIENT = TDB.find "rat_QUOTIENT"
  fun op rat_def _ = () val op rat_def = TDB.find "rat_def"
  fun op rat_type_thm _ = () val op rat_type_thm = TDB.find "rat_type_thm"
  fun op rat_equiv_reps _ = ()
  val op rat_equiv_reps = TDB.find "rat_equiv_reps"
  fun op rat_equiv_rep_abs _ = ()
  val op rat_equiv_rep_abs = TDB.find "rat_equiv_rep_abs"
  fun op rat_of_num_ind _ = ()
  val op rat_of_num_ind = TDB.find "rat_of_num_ind"
  fun op rat_of_num_def _ = ()
  val op rat_of_num_def = TDB.find "rat_of_num_def"
  fun op rat_of_num_compute _ = ()
  val op rat_of_num_compute = TDB.find "rat_of_num_compute"
  fun op rat_0 _ = () val op rat_0 = TDB.find "rat_0"
  fun op rat_1 _ = () val op rat_1 = TDB.find "rat_1"
  fun op RAT _ = () val op RAT = TDB.find "RAT"
  fun op RAT_ABS_EQUIV _ = ()
  val op RAT_ABS_EQUIV = TDB.find "RAT_ABS_EQUIV"
  fun op RAT_EQ _ = () val op RAT_EQ = TDB.find "RAT_EQ"
  fun op RAT_EQ_ALT _ = () val op RAT_EQ_ALT = TDB.find "RAT_EQ_ALT"
  fun op RAT_NMREQ0_CONG _ = ()
  val op RAT_NMREQ0_CONG = TDB.find "RAT_NMREQ0_CONG"
  fun op RAT_NMRLT0_CONG _ = ()
  val op RAT_NMRLT0_CONG = TDB.find "RAT_NMRLT0_CONG"
  fun op RAT_NMRGT0_CONG _ = ()
  val op RAT_NMRGT0_CONG = TDB.find "RAT_NMRGT0_CONG"
  fun op RAT_SGN_CONG _ = () val op RAT_SGN_CONG = TDB.find "RAT_SGN_CONG"
  fun op RAT_AINV_CONG _ = ()
  val op RAT_AINV_CONG = TDB.find "RAT_AINV_CONG"
  fun op FRAC_MINV_EQUIV _ = ()
  val op FRAC_MINV_EQUIV = TDB.find "FRAC_MINV_EQUIV"
  fun op RAT_MINV_CONG _ = ()
  val op RAT_MINV_CONG = TDB.find "RAT_MINV_CONG"
  fun op FRAC_ADD_EQUIV1 _ = ()
  val op FRAC_ADD_EQUIV1 = TDB.find "FRAC_ADD_EQUIV1"
  fun op RAT_ADD_CONG1 _ = ()
  val op RAT_ADD_CONG1 = TDB.find "RAT_ADD_CONG1"
  fun op RAT_ADD_CONG2 _ = ()
  val op RAT_ADD_CONG2 = TDB.find "RAT_ADD_CONG2"
  fun op RAT_ADD_CONG _ = () val op RAT_ADD_CONG = TDB.find "RAT_ADD_CONG"
  fun op FRAC_MUL_EQUIV1 _ = ()
  val op FRAC_MUL_EQUIV1 = TDB.find "FRAC_MUL_EQUIV1"
  fun op FRAC_MUL_EQUIV2 _ = ()
  val op FRAC_MUL_EQUIV2 = TDB.find "FRAC_MUL_EQUIV2"
  fun op RAT_MUL_CONG1 _ = ()
  val op RAT_MUL_CONG1 = TDB.find "RAT_MUL_CONG1"
  fun op RAT_MUL_CONG2 _ = ()
  val op RAT_MUL_CONG2 = TDB.find "RAT_MUL_CONG2"
  fun op RAT_MUL_CONG _ = () val op RAT_MUL_CONG = TDB.find "RAT_MUL_CONG"
  fun op RAT_SUB_CONG1 _ = ()
  val op RAT_SUB_CONG1 = TDB.find "RAT_SUB_CONG1"
  fun op RAT_SUB_CONG2 _ = ()
  val op RAT_SUB_CONG2 = TDB.find "RAT_SUB_CONG2"
  fun op RAT_SUB_CONG _ = () val op RAT_SUB_CONG = TDB.find "RAT_SUB_CONG"
  fun op RAT_DIV_CONG1 _ = ()
  val op RAT_DIV_CONG1 = TDB.find "RAT_DIV_CONG1"
  fun op RAT_DIV_CONG2 _ = ()
  val op RAT_DIV_CONG2 = TDB.find "RAT_DIV_CONG2"
  fun op RAT_DIV_CONG _ = () val op RAT_DIV_CONG = TDB.find "RAT_DIV_CONG"
  fun op RAT_NMRDNM_EQ _ = ()
  val op RAT_NMRDNM_EQ = TDB.find "RAT_NMRDNM_EQ"
  fun op RAT_AINV_CALCULATE _ = ()
  val op RAT_AINV_CALCULATE = TDB.find "RAT_AINV_CALCULATE"
  fun op RAT_MINV_CALCULATE _ = ()
  val op RAT_MINV_CALCULATE = TDB.find "RAT_MINV_CALCULATE"
  fun op RAT_ADD_CALCULATE _ = ()
  val op RAT_ADD_CALCULATE = TDB.find "RAT_ADD_CALCULATE"
  fun op RAT_SUB_CALCULATE _ = ()
  val op RAT_SUB_CALCULATE = TDB.find "RAT_SUB_CALCULATE"
  fun op RAT_MUL_CALCULATE _ = ()
  val op RAT_MUL_CALCULATE = TDB.find "RAT_MUL_CALCULATE"
  fun op RAT_DIV_CALCULATE _ = ()
  val op RAT_DIV_CALCULATE = TDB.find "RAT_DIV_CALCULATE"
  fun op RAT_EQ_CALCULATE _ = ()
  val op RAT_EQ_CALCULATE = TDB.find "RAT_EQ_CALCULATE"
  fun op RAT_LES_CALCULATE _ = ()
  val op RAT_LES_CALCULATE = TDB.find "RAT_LES_CALCULATE"
  fun op RAT_LEQ_CALCULATE _ = ()
  val op RAT_LEQ_CALCULATE = TDB.find "RAT_LEQ_CALCULATE"
  fun op RAT_OF_NUM_CALCULATE _ = ()
  val op RAT_OF_NUM_CALCULATE = TDB.find "RAT_OF_NUM_CALCULATE"
  fun op RAT_OF_NUM_LEQ _ = ()
  val op RAT_OF_NUM_LEQ = TDB.find "RAT_OF_NUM_LEQ"
  fun op RAT_OF_NUM_LES _ = ()
  val op RAT_OF_NUM_LES = TDB.find "RAT_OF_NUM_LES"
  fun op RAT_EQ0_NMR _ = () val op RAT_EQ0_NMR = TDB.find "RAT_EQ0_NMR"
  fun op RAT_0LES_NMR _ = () val op RAT_0LES_NMR = TDB.find "RAT_0LES_NMR"
  fun op RAT_LES0_NMR _ = () val op RAT_LES0_NMR = TDB.find "RAT_LES0_NMR"
  fun op RAT_0LEQ_NMR _ = () val op RAT_0LEQ_NMR = TDB.find "RAT_0LEQ_NMR"
  fun op RAT_LEQ0_NMR _ = () val op RAT_LEQ0_NMR = TDB.find "RAT_LEQ0_NMR"
  fun op RAT_ADD_ASSOC _ = ()
  val op RAT_ADD_ASSOC = TDB.find "RAT_ADD_ASSOC"
  fun op RAT_MUL_ASSOC _ = ()
  val op RAT_MUL_ASSOC = TDB.find "RAT_MUL_ASSOC"
  fun op RAT_ADD_COMM _ = () val op RAT_ADD_COMM = TDB.find "RAT_ADD_COMM"
  fun op RAT_MUL_COMM _ = () val op RAT_MUL_COMM = TDB.find "RAT_MUL_COMM"
  fun op RAT_ADD_RID _ = () val op RAT_ADD_RID = TDB.find "RAT_ADD_RID"
  fun op RAT_ADD_LID _ = () val op RAT_ADD_LID = TDB.find "RAT_ADD_LID"
  fun op RAT_MUL_RID _ = () val op RAT_MUL_RID = TDB.find "RAT_MUL_RID"
  fun op RAT_MUL_LID _ = () val op RAT_MUL_LID = TDB.find "RAT_MUL_LID"
  fun op RAT_ADD_RINV _ = () val op RAT_ADD_RINV = TDB.find "RAT_ADD_RINV"
  fun op RAT_ADD_LINV _ = () val op RAT_ADD_LINV = TDB.find "RAT_ADD_LINV"
  fun op RAT_MUL_RINV _ = () val op RAT_MUL_RINV = TDB.find "RAT_MUL_RINV"
  fun op RAT_MUL_LINV _ = () val op RAT_MUL_LINV = TDB.find "RAT_MUL_LINV"
  fun op RAT_RDISTRIB _ = () val op RAT_RDISTRIB = TDB.find "RAT_RDISTRIB"
  fun op RAT_LDISTRIB _ = () val op RAT_LDISTRIB = TDB.find "RAT_LDISTRIB"
  fun op RAT_1_NOT_0 _ = () val op RAT_1_NOT_0 = TDB.find "RAT_1_NOT_0"
  fun op RAT_MUL_LZERO _ = ()
  val op RAT_MUL_LZERO = TDB.find "RAT_MUL_LZERO"
  fun op RAT_MUL_RZERO _ = ()
  val op RAT_MUL_RZERO = TDB.find "RAT_MUL_RZERO"
  fun op RAT_SUB_ADDAINV _ = ()
  val op RAT_SUB_ADDAINV = TDB.find "RAT_SUB_ADDAINV"
  fun op RAT_DIV_MULMINV _ = ()
  val op RAT_DIV_MULMINV = TDB.find "RAT_DIV_MULMINV"
  fun op RAT_DIV_0 _ = () val op RAT_DIV_0 = TDB.find "RAT_DIV_0"
  fun op RAT_AINV_0 _ = () val op RAT_AINV_0 = TDB.find "RAT_AINV_0"
  fun op RAT_AINV_AINV _ = ()
  val op RAT_AINV_AINV = TDB.find "RAT_AINV_AINV"
  fun op RAT_AINV_ADD _ = () val op RAT_AINV_ADD = TDB.find "RAT_AINV_ADD"
  fun op RAT_AINV_SUB _ = () val op RAT_AINV_SUB = TDB.find "RAT_AINV_SUB"
  fun op RAT_AINV_RMUL _ = ()
  val op RAT_AINV_RMUL = TDB.find "RAT_AINV_RMUL"
  fun op RAT_AINV_LMUL _ = ()
  val op RAT_AINV_LMUL = TDB.find "RAT_AINV_LMUL"
  fun op RAT_AINV_EQ _ = () val op RAT_AINV_EQ = TDB.find "RAT_AINV_EQ"
  fun op RAT_EQ_AINV _ = () val op RAT_EQ_AINV = TDB.find "RAT_EQ_AINV"
  fun op RAT_AINV_MINV _ = ()
  val op RAT_AINV_MINV = TDB.find "RAT_AINV_MINV"
  fun op RAT_SUB_RDISTRIB _ = ()
  val op RAT_SUB_RDISTRIB = TDB.find "RAT_SUB_RDISTRIB"
  fun op RAT_SUB_LDISTRIB _ = ()
  val op RAT_SUB_LDISTRIB = TDB.find "RAT_SUB_LDISTRIB"
  fun op RAT_SUB_LID _ = () val op RAT_SUB_LID = TDB.find "RAT_SUB_LID"
  fun op RAT_SUB_RID _ = () val op RAT_SUB_RID = TDB.find "RAT_SUB_RID"
  fun op RAT_SUB_ID _ = () val op RAT_SUB_ID = TDB.find "RAT_SUB_ID"
  fun op RAT_EQ_SUB0 _ = () val op RAT_EQ_SUB0 = TDB.find "RAT_EQ_SUB0"
  fun op RAT_EQ_0SUB _ = () val op RAT_EQ_0SUB = TDB.find "RAT_EQ_0SUB"
  fun op RAT_SGN_CALCULATE _ = ()
  val op RAT_SGN_CALCULATE = TDB.find "RAT_SGN_CALCULATE"
  fun op RAT_SGN_CLAUSES _ = ()
  val op RAT_SGN_CLAUSES = TDB.find "RAT_SGN_CLAUSES"
  fun op RAT_SGN_0 _ = () val op RAT_SGN_0 = TDB.find "RAT_SGN_0"
  fun op RAT_SGN_AINV _ = () val op RAT_SGN_AINV = TDB.find "RAT_SGN_AINV"
  fun op RAT_SGN_MUL _ = () val op RAT_SGN_MUL = TDB.find "RAT_SGN_MUL"
  fun op RAT_SGN_MINV _ = () val op RAT_SGN_MINV = TDB.find "RAT_SGN_MINV"
  fun op RAT_SGN_TOTAL _ = ()
  val op RAT_SGN_TOTAL = TDB.find "RAT_SGN_TOTAL"
  fun op RAT_SGN_COMPLEMENT _ = ()
  val op RAT_SGN_COMPLEMENT = TDB.find "RAT_SGN_COMPLEMENT"
  fun op RAT_LES_REF _ = () val op RAT_LES_REF = TDB.find "RAT_LES_REF"
  fun op RAT_LES_ANTISYM _ = ()
  val op RAT_LES_ANTISYM = TDB.find "RAT_LES_ANTISYM"
  fun op RAT_LES_TRANS _ = ()
  val op RAT_LES_TRANS = TDB.find "RAT_LES_TRANS"
  fun op RAT_LES_TOTAL _ = ()
  val op RAT_LES_TOTAL = TDB.find "RAT_LES_TOTAL"
  fun op RAT_LEQ_REF _ = () val op RAT_LEQ_REF = TDB.find "RAT_LEQ_REF"
  fun op RAT_LEQ_ANTISYM _ = ()
  val op RAT_LEQ_ANTISYM = TDB.find "RAT_LEQ_ANTISYM"
  fun op RAT_LEQ_TRANS _ = ()
  val op RAT_LEQ_TRANS = TDB.find "RAT_LEQ_TRANS"
  fun op RAT_LES_01 _ = () val op RAT_LES_01 = TDB.find "RAT_LES_01"
  fun op RAT_LES_IMP_LEQ _ = ()
  val op RAT_LES_IMP_LEQ = TDB.find "RAT_LES_IMP_LEQ"
  fun op RAT_LES_IMP_NEQ _ = ()
  val op RAT_LES_IMP_NEQ = TDB.find "RAT_LES_IMP_NEQ"
  fun op RAT_LEQ_LES _ = () val op RAT_LEQ_LES = TDB.find "RAT_LEQ_LES"
  fun op RAT_LES_LEQ _ = () val op RAT_LES_LEQ = TDB.find "RAT_LES_LEQ"
  fun op RAT_LES_LEQ2 _ = () val op RAT_LES_LEQ2 = TDB.find "RAT_LES_LEQ2"
  fun op RAT_LES_LEQ_TRANS _ = ()
  val op RAT_LES_LEQ_TRANS = TDB.find "RAT_LES_LEQ_TRANS"
  fun op RAT_LEQ_LES_TRANS _ = ()
  val op RAT_LEQ_LES_TRANS = TDB.find "RAT_LEQ_LES_TRANS"
  fun op RAT_0LES_0LES_ADD _ = ()
  val op RAT_0LES_0LES_ADD = TDB.find "RAT_0LES_0LES_ADD"
  fun op RAT_LES0_LES0_ADD _ = ()
  val op RAT_LES0_LES0_ADD = TDB.find "RAT_LES0_LES0_ADD"
  fun op RAT_0LES_0LEQ_ADD _ = ()
  val op RAT_0LES_0LEQ_ADD = TDB.find "RAT_0LES_0LEQ_ADD"
  fun op RAT_LES0_LEQ0_ADD _ = ()
  val op RAT_LES0_LEQ0_ADD = TDB.find "RAT_LES0_LEQ0_ADD"
  fun op RAT_LSUB_EQ _ = () val op RAT_LSUB_EQ = TDB.find "RAT_LSUB_EQ"
  fun op RAT_RSUB_EQ _ = () val op RAT_RSUB_EQ = TDB.find "RAT_RSUB_EQ"
  fun op RAT_LDIV_EQ _ = () val op RAT_LDIV_EQ = TDB.find "RAT_LDIV_EQ"
  fun op RAT_RDIV_EQ _ = () val op RAT_RDIV_EQ = TDB.find "RAT_RDIV_EQ"
  fun op RAT_AINV_ONE_ONE _ = ()
  val op RAT_AINV_ONE_ONE = TDB.find "RAT_AINV_ONE_ONE"
  fun op RAT_ADD_ONE_ONE _ = ()
  val op RAT_ADD_ONE_ONE = TDB.find "RAT_ADD_ONE_ONE"
  fun op RAT_MUL_ONE_ONE _ = ()
  val op RAT_MUL_ONE_ONE = TDB.find "RAT_MUL_ONE_ONE"
  fun op RAT_EQ_LADD _ = () val op RAT_EQ_LADD = TDB.find "RAT_EQ_LADD"
  fun op RAT_EQ_RADD _ = () val op RAT_EQ_RADD = TDB.find "RAT_EQ_RADD"
  fun op RAT_EQ_RMUL _ = () val op RAT_EQ_RMUL = TDB.find "RAT_EQ_RMUL"
  fun op RAT_EQ_LMUL _ = () val op RAT_EQ_LMUL = TDB.find "RAT_EQ_LMUL"
  fun op RAT_LES_RADD _ = () val op RAT_LES_RADD = TDB.find "RAT_LES_RADD"
  fun op RAT_LES_LADD _ = () val op RAT_LES_LADD = TDB.find "RAT_LES_LADD"
  fun op RAT_LEQ_RADD _ = () val op RAT_LEQ_RADD = TDB.find "RAT_LEQ_RADD"
  fun op RAT_LEQ_LADD _ = () val op RAT_LEQ_LADD = TDB.find "RAT_LEQ_LADD"
  fun op RAT_ADD_MONO _ = () val op RAT_ADD_MONO = TDB.find "RAT_ADD_MONO"
  fun op RAT_LES_AINV _ = () val op RAT_LES_AINV = TDB.find "RAT_LES_AINV"
  fun op RAT_LSUB_LES _ = () val op RAT_LSUB_LES = TDB.find "RAT_LSUB_LES"
  fun op RAT_RSUB_LES _ = () val op RAT_RSUB_LES = TDB.find "RAT_RSUB_LES"
  fun op RAT_LSUB_LEQ _ = () val op RAT_LSUB_LEQ = TDB.find "RAT_LSUB_LEQ"
  fun op RAT_RSUB_LEQ _ = () val op RAT_RSUB_LEQ = TDB.find "RAT_RSUB_LEQ"
  fun op RAT_LES_RMUL_POS _ = ()
  val op RAT_LES_RMUL_POS = TDB.find "RAT_LES_RMUL_POS"
  fun op RAT_LES_LMUL_POS _ = ()
  val op RAT_LES_LMUL_POS = TDB.find "RAT_LES_LMUL_POS"
  fun op RAT_LES_RMUL_NEG _ = ()
  val op RAT_LES_RMUL_NEG = TDB.find "RAT_LES_RMUL_NEG"
  fun op RAT_LES_LMUL_NEG _ = ()
  val op RAT_LES_LMUL_NEG = TDB.find "RAT_LES_LMUL_NEG"
  fun op RAT_AINV_LES _ = () val op RAT_AINV_LES = TDB.find "RAT_AINV_LES"
  fun op RAT_LDIV_LES_POS _ = ()
  val op RAT_LDIV_LES_POS = TDB.find "RAT_LDIV_LES_POS"
  fun op RAT_LDIV_LES_NEG _ = ()
  val op RAT_LDIV_LES_NEG = TDB.find "RAT_LDIV_LES_NEG"
  fun op RAT_RDIV_LES_POS _ = ()
  val op RAT_RDIV_LES_POS = TDB.find "RAT_RDIV_LES_POS"
  fun op RAT_RDIV_LES_NEG _ = ()
  val op RAT_RDIV_LES_NEG = TDB.find "RAT_RDIV_LES_NEG"
  fun op RAT_LDIV_LEQ_POS _ = ()
  val op RAT_LDIV_LEQ_POS = TDB.find "RAT_LDIV_LEQ_POS"
  fun op RAT_LDIV_LEQ_NEG _ = ()
  val op RAT_LDIV_LEQ_NEG = TDB.find "RAT_LDIV_LEQ_NEG"
  fun op RAT_RDIV_LEQ_POS _ = ()
  val op RAT_RDIV_LEQ_POS = TDB.find "RAT_RDIV_LEQ_POS"
  fun op RAT_RDIV_LEQ_NEG _ = ()
  val op RAT_RDIV_LEQ_NEG = TDB.find "RAT_RDIV_LEQ_NEG"
  fun op RAT_LES_SUB0 _ = () val op RAT_LES_SUB0 = TDB.find "RAT_LES_SUB0"
  fun op RAT_LES_0SUB _ = () val op RAT_LES_0SUB = TDB.find "RAT_LES_0SUB"
  fun op RAT_MINV_LES _ = () val op RAT_MINV_LES = TDB.find "RAT_MINV_LES"
  fun op RAT_MUL_SIGN_CASES _ = ()
  val op RAT_MUL_SIGN_CASES = TDB.find "RAT_MUL_SIGN_CASES"
  fun op RAT_NO_ZERODIV _ = ()
  val op RAT_NO_ZERODIV = TDB.find "RAT_NO_ZERODIV"
  fun op RAT_NO_ZERODIV_THM _ = ()
  val op RAT_NO_ZERODIV_THM = TDB.find "RAT_NO_ZERODIV_THM"
  fun op RAT_NO_ZERODIV_NEG _ = ()
  val op RAT_NO_ZERODIV_NEG = TDB.find "RAT_NO_ZERODIV_NEG"
  fun op RAT_NO_IDDIV _ = () val op RAT_NO_IDDIV = TDB.find "RAT_NO_IDDIV"
  fun op RDIV_MUL_OUT _ = () val op RDIV_MUL_OUT = TDB.find "RDIV_MUL_OUT"
  fun op LDIV_MUL_OUT _ = () val op LDIV_MUL_OUT = TDB.find "LDIV_MUL_OUT"
  fun op RAT_DENSE_THM _ = ()
  val op RAT_DENSE_THM = TDB.find "RAT_DENSE_THM"
  fun op RAT_SAVE _ = () val op RAT_SAVE = TDB.find "RAT_SAVE"
  fun op RAT_SAVE_MINV _ = ()
  val op RAT_SAVE_MINV = TDB.find "RAT_SAVE_MINV"
  fun op RAT_SAVE_TO_CONS _ = ()
  val op RAT_SAVE_TO_CONS = TDB.find "RAT_SAVE_TO_CONS"
  fun op RAT_OF_NUM _ = () val op RAT_OF_NUM = TDB.find "RAT_OF_NUM"
  fun op RAT_SAVE_NUM _ = () val op RAT_SAVE_NUM = TDB.find "RAT_SAVE_NUM"
  fun op RAT_CONS_TO_NUM _ = ()
  val op RAT_CONS_TO_NUM = TDB.find "RAT_CONS_TO_NUM"
  fun op RAT_0 _ = () val op RAT_0 = TDB.find "RAT_0"
  fun op RAT_1 _ = () val op RAT_1 = TDB.find "RAT_1"
  fun op RAT_MINV_1 _ = () val op RAT_MINV_1 = TDB.find "RAT_MINV_1"
  fun op RAT_DIV_1 _ = () val op RAT_DIV_1 = TDB.find "RAT_DIV_1"
  fun op RAT_DIV_NEG1 _ = () val op RAT_DIV_NEG1 = TDB.find "RAT_DIV_NEG1"
  fun op RAT_DIV_INV _ = () val op RAT_DIV_INV = TDB.find "RAT_DIV_INV"
  fun op RAT_MINV_MUL _ = () val op RAT_MINV_MUL = TDB.find "RAT_MINV_MUL"
  fun op RAT_DIVDIV_MUL _ = ()
  val op RAT_DIVDIV_MUL = TDB.find "RAT_DIVDIV_MUL"
  fun op RAT_DIVDIV_ADD _ = ()
  val op RAT_DIVDIV_ADD = TDB.find "RAT_DIVDIV_ADD"
  fun op RAT_DIV_AINV _ = () val op RAT_DIV_AINV = TDB.find "RAT_DIV_AINV"
  fun op RAT_MINV_EQ_0 _ = ()
  val op RAT_MINV_EQ_0 = TDB.find "RAT_MINV_EQ_0"
  fun op RAT_DIV_MINV _ = () val op RAT_DIV_MINV = TDB.find "RAT_DIV_MINV"
  fun op RAT_DIV_EQ0 _ = () val op RAT_DIV_EQ0 = TDB.find "RAT_DIV_EQ0"
  fun op RAT_ADD_NUM_CALCULATE _ = ()
  val op RAT_ADD_NUM_CALCULATE = TDB.find "RAT_ADD_NUM_CALCULATE"
  fun op RAT_MUL_NUM_CALCULATE _ = ()
  val op RAT_MUL_NUM_CALCULATE = TDB.find "RAT_MUL_NUM_CALCULATE"
  fun op RAT_EQ_NUM_CALCULATE _ = ()
  val op RAT_EQ_NUM_CALCULATE = TDB.find "RAT_EQ_NUM_CALCULATE"
  fun op RAT_LT_NUM_CALCULATE _ = ()
  val op RAT_LT_NUM_CALCULATE = TDB.find "RAT_LT_NUM_CALCULATE"
  fun op RAT_LE_NUM_CALCULATE _ = ()
  val op RAT_LE_NUM_CALCULATE = TDB.find "RAT_LE_NUM_CALCULATE"
  fun op rat_of_int_11 _ = ()
  val op rat_of_int_11 = TDB.find "rat_of_int_11"
  fun op rat_of_int_of_num _ = ()
  val op rat_of_int_of_num = TDB.find "rat_of_int_of_num"
  fun op rat_of_int_MUL _ = ()
  val op rat_of_int_MUL = TDB.find "rat_of_int_MUL"
  fun op rat_of_int_ADD _ = ()
  val op rat_of_int_ADD = TDB.find "rat_of_int_ADD"
  fun op rat_of_int_LE _ = ()
  val op rat_of_int_LE = TDB.find "rat_of_int_LE"
  fun op rat_of_int_LT _ = ()
  val op rat_of_int_LT = TDB.find "rat_of_int_LT"
  fun op rat_of_int_ainv _ = ()
  val op rat_of_int_ainv = TDB.find "rat_of_int_ainv"
  fun op RAT_OF_INT_CALCULATE _ = ()
  val op RAT_OF_INT_CALCULATE = TDB.find "RAT_OF_INT_CALCULATE"
  fun op RATD_NZERO _ = () val op RATD_NZERO = TDB.find "RATD_NZERO"
  fun op RATN_LEAST _ = () val op RATN_LEAST = TDB.find "RATN_LEAST"
  fun op RATN_RATD_EQ_THM _ = ()
  val op RATN_RATD_EQ_THM = TDB.find "RATN_RATD_EQ_THM"
  fun op RATN_RATD_MULT _ = ()
  val op RATN_RATD_MULT = TDB.find "RATN_RATD_MULT"
  fun op RATND_RAT_OF_NUM _ = ()
  val op RATND_RAT_OF_NUM = TDB.find "RATND_RAT_OF_NUM"
  fun op RATN_EQ0 _ = () val op RATN_EQ0 = TDB.find "RATN_EQ0"
  fun op RATN_SIGN _ = () val op RATN_SIGN = TDB.find "RATN_SIGN"
  fun op RAT_AINV_SGN _ = () val op RAT_AINV_SGN = TDB.find "RAT_AINV_SGN"
  fun op RATN_NEG _ = () val op RATN_NEG = TDB.find "RATN_NEG"
  fun op RATD_NEG _ = () val op RATD_NEG = TDB.find "RATD_NEG"
  fun op RATN_RATD_RAT_OF_INT _ = ()
  val op RATN_RATD_RAT_OF_INT = TDB.find "RATN_RATD_RAT_OF_INT"
  fun op RATN_DIV_RATD _ = ()
  val op RATN_DIV_RATD = TDB.find "RATN_DIV_RATD"
  fun op RAT_AINV_EQ_NUM _ = ()
  val op RAT_AINV_EQ_NUM = TDB.find "RAT_AINV_EQ_NUM"
  fun op RAT_SGN_NUM_COND _ = ()
  val op RAT_SGN_NUM_COND = TDB.find "RAT_SGN_NUM_COND"
  fun op RAT_SGN_AINV_RWT _ = ()
  val op RAT_SGN_AINV_RWT = TDB.find "RAT_SGN_AINV_RWT"
  fun op RAT_SGN_ALT _ = () val op RAT_SGN_ALT = TDB.find "RAT_SGN_ALT"
  fun op RAT_SGN_NUM_BITs _ = ()
  val op RAT_SGN_NUM_BITs = TDB.find "RAT_SGN_NUM_BITs"
  fun op RAT_SGN_EQ0 _ = () val op RAT_SGN_EQ0 = TDB.find "RAT_SGN_EQ0"
  fun op RAT_SGN_POS _ = () val op RAT_SGN_POS = TDB.find "RAT_SGN_POS"
  fun op RAT_SGN_NEG _ = () val op RAT_SGN_NEG = TDB.find "RAT_SGN_NEG"
  fun op RAT_SGN_DIV _ = () val op RAT_SGN_DIV = TDB.find "RAT_SGN_DIV"
  fun op RAT_MINV_RATND _ = ()
  val op RAT_MINV_RATND = TDB.find "RAT_MINV_RATND"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val rat_grammars = merge_grammars ["frac"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="rat"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val rat_grammars = 
    Portable.## (addtyUDs,addtmUDs) rat_grammars
  val _ = Parse.grammarDB_insert("rat",rat_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "rat"

end
