structure complexTheory :> complexTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading complexTheory ... "
    else ()
  
  open Type Term Thm
  local open transcTheory complexPP in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "complex"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/complexTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op RE _ = () val op RE = TDB.find "RE"
  fun op IM _ = () val op IM = TDB.find "IM"
  fun op complex_of_real _ = ()
  val op complex_of_real = TDB.find "complex_of_real"
  fun op complex_of_num _ = ()
  val op complex_of_num = TDB.find "complex_of_num"
  fun op i _ = () val op i = TDB.find "i"
  fun op complex_add _ = () val op complex_add = TDB.find "complex_add"
  fun op complex_neg _ = () val op complex_neg = TDB.find "complex_neg"
  fun op complex_mul _ = () val op complex_mul = TDB.find "complex_mul"
  fun op complex_inv _ = () val op complex_inv = TDB.find "complex_inv"
  fun op complex_sub _ = () val op complex_sub = TDB.find "complex_sub"
  fun op complex_div _ = () val op complex_div = TDB.find "complex_div"
  fun op complex_scalar_lmul _ = ()
  val op complex_scalar_lmul = TDB.find "complex_scalar_lmul"
  fun op complex_scalar_rmul _ = ()
  val op complex_scalar_rmul = TDB.find "complex_scalar_rmul"
  fun op conj _ = () val op conj = TDB.find "conj"
  fun op modu _ = () val op modu = TDB.find "modu"
  fun op arg _ = () val op arg = TDB.find "arg"
  fun op complex_pow_def _ = ()
  val op complex_pow_def = TDB.find "complex_pow_def"
  fun op complex_exp _ = () val op complex_exp = TDB.find "complex_exp"
  fun op COMPLEX_LEMMA1 _ = ()
  val op COMPLEX_LEMMA1 = TDB.find "COMPLEX_LEMMA1"
  fun op COMPLEX_LEMMA2 _ = ()
  val op COMPLEX_LEMMA2 = TDB.find "COMPLEX_LEMMA2"
  fun op COMPLEX _ = () val op COMPLEX = TDB.find "COMPLEX"
  fun op COMPLEX_RE_IM_EQ _ = ()
  val op COMPLEX_RE_IM_EQ = TDB.find "COMPLEX_RE_IM_EQ"
  fun op RE_COMPLEX_OF_REAL _ = ()
  val op RE_COMPLEX_OF_REAL = TDB.find "RE_COMPLEX_OF_REAL"
  fun op IM_COMPLEX_OF_REAL _ = ()
  val op IM_COMPLEX_OF_REAL = TDB.find "IM_COMPLEX_OF_REAL"
  fun op COMPLEX_0 _ = () val op COMPLEX_0 = TDB.find "COMPLEX_0"
  fun op COMPLEX_1 _ = () val op COMPLEX_1 = TDB.find "COMPLEX_1"
  fun op COMPLEX_10 _ = () val op COMPLEX_10 = TDB.find "COMPLEX_10"
  fun op COMPLEX_0_THM _ = ()
  val op COMPLEX_0_THM = TDB.find "COMPLEX_0_THM"
  fun op COMPLEX_ADD_COMM _ = ()
  val op COMPLEX_ADD_COMM = TDB.find "COMPLEX_ADD_COMM"
  fun op COMPLEX_ADD_ASSOC _ = ()
  val op COMPLEX_ADD_ASSOC = TDB.find "COMPLEX_ADD_ASSOC"
  fun op COMPLEX_ADD_RID _ = ()
  val op COMPLEX_ADD_RID = TDB.find "COMPLEX_ADD_RID"
  fun op COMPLEX_ADD_LID _ = ()
  val op COMPLEX_ADD_LID = TDB.find "COMPLEX_ADD_LID"
  fun op COMPLEX_ADD_RINV _ = ()
  val op COMPLEX_ADD_RINV = TDB.find "COMPLEX_ADD_RINV"
  fun op COMPLEX_ADD_LINV _ = ()
  val op COMPLEX_ADD_LINV = TDB.find "COMPLEX_ADD_LINV"
  fun op COMPLEX_MUL_COMM _ = ()
  val op COMPLEX_MUL_COMM = TDB.find "COMPLEX_MUL_COMM"
  fun op COMPLEX_MUL_ASSOC _ = ()
  val op COMPLEX_MUL_ASSOC = TDB.find "COMPLEX_MUL_ASSOC"
  fun op COMPLEX_MUL_RID _ = ()
  val op COMPLEX_MUL_RID = TDB.find "COMPLEX_MUL_RID"
  fun op COMPLEX_MUL_LID _ = ()
  val op COMPLEX_MUL_LID = TDB.find "COMPLEX_MUL_LID"
  fun op COMPLEX_MUL_RINV _ = ()
  val op COMPLEX_MUL_RINV = TDB.find "COMPLEX_MUL_RINV"
  fun op COMPLEX_MUL_LINV _ = ()
  val op COMPLEX_MUL_LINV = TDB.find "COMPLEX_MUL_LINV"
  fun op COMPLEX_ADD_LDISTRIB _ = ()
  val op COMPLEX_ADD_LDISTRIB = TDB.find "COMPLEX_ADD_LDISTRIB"
  fun op COMPLEX_ADD_RDISTRIB _ = ()
  val op COMPLEX_ADD_RDISTRIB = TDB.find "COMPLEX_ADD_RDISTRIB"
  fun op COMPLEX_EQ_LADD _ = ()
  val op COMPLEX_EQ_LADD = TDB.find "COMPLEX_EQ_LADD"
  fun op COMPLEX_EQ_RADD _ = ()
  val op COMPLEX_EQ_RADD = TDB.find "COMPLEX_EQ_RADD"
  fun op COMPLEX_ADD_RID_UNIQ _ = ()
  val op COMPLEX_ADD_RID_UNIQ = TDB.find "COMPLEX_ADD_RID_UNIQ"
  fun op COMPLEX_ADD_LID_UNIQ _ = ()
  val op COMPLEX_ADD_LID_UNIQ = TDB.find "COMPLEX_ADD_LID_UNIQ"
  fun op COMPLEX_NEGNEG _ = ()
  val op COMPLEX_NEGNEG = TDB.find "COMPLEX_NEGNEG"
  fun op COMPLEX_NEG_EQ _ = ()
  val op COMPLEX_NEG_EQ = TDB.find "COMPLEX_NEG_EQ"
  fun op COMPLEX_EQ_NEG _ = ()
  val op COMPLEX_EQ_NEG = TDB.find "COMPLEX_EQ_NEG"
  fun op COMPLEX_RNEG_UNIQ _ = ()
  val op COMPLEX_RNEG_UNIQ = TDB.find "COMPLEX_RNEG_UNIQ"
  fun op COMPLEX_LNEG_UNIQ _ = ()
  val op COMPLEX_LNEG_UNIQ = TDB.find "COMPLEX_LNEG_UNIQ"
  fun op COMPLEX_NEG_ADD _ = ()
  val op COMPLEX_NEG_ADD = TDB.find "COMPLEX_NEG_ADD"
  fun op COMPLEX_MUL_RZERO _ = ()
  val op COMPLEX_MUL_RZERO = TDB.find "COMPLEX_MUL_RZERO"
  fun op COMPLEX_MUL_LZERO _ = ()
  val op COMPLEX_MUL_LZERO = TDB.find "COMPLEX_MUL_LZERO"
  fun op COMPLEX_NEG_LMUL _ = ()
  val op COMPLEX_NEG_LMUL = TDB.find "COMPLEX_NEG_LMUL"
  fun op COMPLEX_NEG_RMUL _ = ()
  val op COMPLEX_NEG_RMUL = TDB.find "COMPLEX_NEG_RMUL"
  fun op COMPLEX_NEG_MUL2 _ = ()
  val op COMPLEX_NEG_MUL2 = TDB.find "COMPLEX_NEG_MUL2"
  fun op COMPLEX_ENTIRE _ = ()
  val op COMPLEX_ENTIRE = TDB.find "COMPLEX_ENTIRE"
  fun op COMPLEX_NEG_0 _ = ()
  val op COMPLEX_NEG_0 = TDB.find "COMPLEX_NEG_0"
  fun op COMPLEX_NEG_EQ0 _ = ()
  val op COMPLEX_NEG_EQ0 = TDB.find "COMPLEX_NEG_EQ0"
  fun op COMPLEX_SUB_REFL _ = ()
  val op COMPLEX_SUB_REFL = TDB.find "COMPLEX_SUB_REFL"
  fun op COMPLEX_SUB_RZERO _ = ()
  val op COMPLEX_SUB_RZERO = TDB.find "COMPLEX_SUB_RZERO"
  fun op COMPLEX_SUB_LZERO _ = ()
  val op COMPLEX_SUB_LZERO = TDB.find "COMPLEX_SUB_LZERO"
  fun op COMPLEX_SUB_LNEG _ = ()
  val op COMPLEX_SUB_LNEG = TDB.find "COMPLEX_SUB_LNEG"
  fun op COMPLEX_SUB_NEG2 _ = ()
  val op COMPLEX_SUB_NEG2 = TDB.find "COMPLEX_SUB_NEG2"
  fun op COMPLEX_NEG_SUB _ = ()
  val op COMPLEX_NEG_SUB = TDB.find "COMPLEX_NEG_SUB"
  fun op COMPLEX_SUB_RNEG _ = ()
  val op COMPLEX_SUB_RNEG = TDB.find "COMPLEX_SUB_RNEG"
  fun op COMPLEX_SUB_ADD _ = ()
  val op COMPLEX_SUB_ADD = TDB.find "COMPLEX_SUB_ADD"
  fun op COMPLEX_SUB_ADD2 _ = ()
  val op COMPLEX_SUB_ADD2 = TDB.find "COMPLEX_SUB_ADD2"
  fun op COMPLEX_ADD_SUB _ = ()
  val op COMPLEX_ADD_SUB = TDB.find "COMPLEX_ADD_SUB"
  fun op COMPLEX_SUB_SUB _ = ()
  val op COMPLEX_SUB_SUB = TDB.find "COMPLEX_SUB_SUB"
  fun op COMPLEX_SUB_SUB2 _ = ()
  val op COMPLEX_SUB_SUB2 = TDB.find "COMPLEX_SUB_SUB2"
  fun op COMPLEX_ADD_SUB2 _ = ()
  val op COMPLEX_ADD_SUB2 = TDB.find "COMPLEX_ADD_SUB2"
  fun op COMPLEX_ADD2_SUB2 _ = ()
  val op COMPLEX_ADD2_SUB2 = TDB.find "COMPLEX_ADD2_SUB2"
  fun op COMPLEX_SUB_TRIANGLE _ = ()
  val op COMPLEX_SUB_TRIANGLE = TDB.find "COMPLEX_SUB_TRIANGLE"
  fun op COMPLEX_SUB_0 _ = ()
  val op COMPLEX_SUB_0 = TDB.find "COMPLEX_SUB_0"
  fun op COMPLEX_EQ_SUB_LADD _ = ()
  val op COMPLEX_EQ_SUB_LADD = TDB.find "COMPLEX_EQ_SUB_LADD"
  fun op COMPLEX_EQ_SUB_RADD _ = ()
  val op COMPLEX_EQ_SUB_RADD = TDB.find "COMPLEX_EQ_SUB_RADD"
  fun op COMPLEX_MUL_RNEG _ = ()
  val op COMPLEX_MUL_RNEG = TDB.find "COMPLEX_MUL_RNEG"
  fun op COMPLEX_MUL_LNEG _ = ()
  val op COMPLEX_MUL_LNEG = TDB.find "COMPLEX_MUL_LNEG"
  fun op COMPLEX_SUB_LDISTRIB _ = ()
  val op COMPLEX_SUB_LDISTRIB = TDB.find "COMPLEX_SUB_LDISTRIB"
  fun op COMPLEX_SUB_RDISTRIB _ = ()
  val op COMPLEX_SUB_RDISTRIB = TDB.find "COMPLEX_SUB_RDISTRIB"
  fun op COMPLEX_DIFFSQ _ = ()
  val op COMPLEX_DIFFSQ = TDB.find "COMPLEX_DIFFSQ"
  fun op COMPLEX_EQ_LMUL _ = ()
  val op COMPLEX_EQ_LMUL = TDB.find "COMPLEX_EQ_LMUL"
  fun op COMPLEX_EQ_RMUL _ = ()
  val op COMPLEX_EQ_RMUL = TDB.find "COMPLEX_EQ_RMUL"
  fun op COMPLEX_EQ_LMUL2 _ = ()
  val op COMPLEX_EQ_LMUL2 = TDB.find "COMPLEX_EQ_LMUL2"
  fun op COMPLEX_EQ_RMUL_IMP _ = ()
  val op COMPLEX_EQ_RMUL_IMP = TDB.find "COMPLEX_EQ_RMUL_IMP"
  fun op COMPLEX_EQ_LMUL_IMP _ = ()
  val op COMPLEX_EQ_LMUL_IMP = TDB.find "COMPLEX_EQ_LMUL_IMP"
  fun op COMPLEX_NEG_INV _ = ()
  val op COMPLEX_NEG_INV = TDB.find "COMPLEX_NEG_INV"
  fun op COMPLEX_INV_MUL _ = ()
  val op COMPLEX_INV_MUL = TDB.find "COMPLEX_INV_MUL"
  fun op COMPLEX_INVINV _ = ()
  val op COMPLEX_INVINV = TDB.find "COMPLEX_INVINV"
  fun op COMPLEX_LINV_UNIQ _ = ()
  val op COMPLEX_LINV_UNIQ = TDB.find "COMPLEX_LINV_UNIQ"
  fun op COMPLEX_RINV_UNIQ _ = ()
  val op COMPLEX_RINV_UNIQ = TDB.find "COMPLEX_RINV_UNIQ"
  fun op COMPLEX_INV_0 _ = ()
  val op COMPLEX_INV_0 = TDB.find "COMPLEX_INV_0"
  fun op COMPLEX_INV1 _ = () val op COMPLEX_INV1 = TDB.find "COMPLEX_INV1"
  fun op COMPLEX_INV_INV _ = ()
  val op COMPLEX_INV_INV = TDB.find "COMPLEX_INV_INV"
  fun op COMPLEX_INV_NEG _ = ()
  val op COMPLEX_INV_NEG = TDB.find "COMPLEX_INV_NEG"
  fun op COMPLEX_INV_EQ_0 _ = ()
  val op COMPLEX_INV_EQ_0 = TDB.find "COMPLEX_INV_EQ_0"
  fun op COMPLEX_INV_NZ _ = ()
  val op COMPLEX_INV_NZ = TDB.find "COMPLEX_INV_NZ"
  fun op COMPLEX_INV_INJ _ = ()
  val op COMPLEX_INV_INJ = TDB.find "COMPLEX_INV_INJ"
  fun op COMPLEX_NEG_LDIV _ = ()
  val op COMPLEX_NEG_LDIV = TDB.find "COMPLEX_NEG_LDIV"
  fun op COMPLEX_NEG_RDIV _ = ()
  val op COMPLEX_NEG_RDIV = TDB.find "COMPLEX_NEG_RDIV"
  fun op COMPLEX_NEG_DIV2 _ = ()
  val op COMPLEX_NEG_DIV2 = TDB.find "COMPLEX_NEG_DIV2"
  fun op COMPLEX_INV_1OVER _ = ()
  val op COMPLEX_INV_1OVER = TDB.find "COMPLEX_INV_1OVER"
  fun op COMPLEX_DIV1 _ = () val op COMPLEX_DIV1 = TDB.find "COMPLEX_DIV1"
  fun op COMPLEX_DIV_ADD _ = ()
  val op COMPLEX_DIV_ADD = TDB.find "COMPLEX_DIV_ADD"
  fun op COMPLEX_DIV_SUB _ = ()
  val op COMPLEX_DIV_SUB = TDB.find "COMPLEX_DIV_SUB"
  fun op COMPLEX_DIV_RMUL_CANCEL _ = ()
  val op COMPLEX_DIV_RMUL_CANCEL = TDB.find "COMPLEX_DIV_RMUL_CANCEL"
  fun op COMPLEX_DIV_LMUL_CANCEL _ = ()
  val op COMPLEX_DIV_LMUL_CANCEL = TDB.find "COMPLEX_DIV_LMUL_CANCEL"
  fun op COMPLEX_DIV_DENOM_CANCEL _ = ()
  val op COMPLEX_DIV_DENOM_CANCEL = TDB.find "COMPLEX_DIV_DENOM_CANCEL"
  fun op COMPLEX_DIV_INNER_CANCEL _ = ()
  val op COMPLEX_DIV_INNER_CANCEL = TDB.find "COMPLEX_DIV_INNER_CANCEL"
  fun op COMPLEX_DIV_OUTER_CANCEL _ = ()
  val op COMPLEX_DIV_OUTER_CANCEL = TDB.find "COMPLEX_DIV_OUTER_CANCEL"
  fun op COMPLEX_DIV_MUL2 _ = ()
  val op COMPLEX_DIV_MUL2 = TDB.find "COMPLEX_DIV_MUL2"
  fun op COMPLEX_ADD_RAT _ = ()
  val op COMPLEX_ADD_RAT = TDB.find "COMPLEX_ADD_RAT"
  fun op COMPLEX_SUB_RAT _ = ()
  val op COMPLEX_SUB_RAT = TDB.find "COMPLEX_SUB_RAT"
  fun op COMPLEX_DIV_LZERO _ = ()
  val op COMPLEX_DIV_LZERO = TDB.find "COMPLEX_DIV_LZERO"
  fun op COMPLEX_DIV_REFL _ = ()
  val op COMPLEX_DIV_REFL = TDB.find "COMPLEX_DIV_REFL"
  fun op COMPLEX_SUB_INV2 _ = ()
  val op COMPLEX_SUB_INV2 = TDB.find "COMPLEX_SUB_INV2"
  fun op COMPLEX_EQ_RDIV_EQ _ = ()
  val op COMPLEX_EQ_RDIV_EQ = TDB.find "COMPLEX_EQ_RDIV_EQ"
  fun op COMPLEX_EQ_LDIV_EQ _ = ()
  val op COMPLEX_EQ_LDIV_EQ = TDB.find "COMPLEX_EQ_LDIV_EQ"
  fun op COMPLEX_OF_REAL_EQ _ = ()
  val op COMPLEX_OF_REAL_EQ = TDB.find "COMPLEX_OF_REAL_EQ"
  fun op COMPLEX_OF_REAL_ADD _ = ()
  val op COMPLEX_OF_REAL_ADD = TDB.find "COMPLEX_OF_REAL_ADD"
  fun op COMPLEX_OF_REAL_NEG _ = ()
  val op COMPLEX_OF_REAL_NEG = TDB.find "COMPLEX_OF_REAL_NEG"
  fun op COMPLEX_OF_REAL_MUL _ = ()
  val op COMPLEX_OF_REAL_MUL = TDB.find "COMPLEX_OF_REAL_MUL"
  fun op COMPLEX_OF_REAL_INV _ = ()
  val op COMPLEX_OF_REAL_INV = TDB.find "COMPLEX_OF_REAL_INV"
  fun op COMPLEX_OF_REAL_SUB _ = ()
  val op COMPLEX_OF_REAL_SUB = TDB.find "COMPLEX_OF_REAL_SUB"
  fun op COMPLEX_OF_REAL_DIV _ = ()
  val op COMPLEX_OF_REAL_DIV = TDB.find "COMPLEX_OF_REAL_DIV"
  fun op COMPLEX_OF_NUM_EQ _ = ()
  val op COMPLEX_OF_NUM_EQ = TDB.find "COMPLEX_OF_NUM_EQ"
  fun op COMPLEX_OF_NUM_ADD _ = ()
  val op COMPLEX_OF_NUM_ADD = TDB.find "COMPLEX_OF_NUM_ADD"
  fun op COMPLEX_OF_NUM_MUL _ = ()
  val op COMPLEX_OF_NUM_MUL = TDB.find "COMPLEX_OF_NUM_MUL"
  fun op COMPLEX_SCALAR_LMUL _ = ()
  val op COMPLEX_SCALAR_LMUL = TDB.find "COMPLEX_SCALAR_LMUL"
  fun op COMPLEX_SCALAR_LMUL_NEG _ = ()
  val op COMPLEX_SCALAR_LMUL_NEG = TDB.find "COMPLEX_SCALAR_LMUL_NEG"
  fun op COMPLEX_NEG_SCALAR_LMUL _ = ()
  val op COMPLEX_NEG_SCALAR_LMUL = TDB.find "COMPLEX_NEG_SCALAR_LMUL"
  fun op COMPLEX_SCALAR_LMUL_ADD _ = ()
  val op COMPLEX_SCALAR_LMUL_ADD = TDB.find "COMPLEX_SCALAR_LMUL_ADD"
  fun op COMPLEX_SCALAR_LMUL_SUB _ = ()
  val op COMPLEX_SCALAR_LMUL_SUB = TDB.find "COMPLEX_SCALAR_LMUL_SUB"
  fun op COMPLEX_ADD_SCALAR_LMUL _ = ()
  val op COMPLEX_ADD_SCALAR_LMUL = TDB.find "COMPLEX_ADD_SCALAR_LMUL"
  fun op COMPLEX_SUB_SCALAR_LMUL _ = ()
  val op COMPLEX_SUB_SCALAR_LMUL = TDB.find "COMPLEX_SUB_SCALAR_LMUL"
  fun op COMPLEX_MUL_SCALAR_LMUL2 _ = ()
  val op COMPLEX_MUL_SCALAR_LMUL2 = TDB.find "COMPLEX_MUL_SCALAR_LMUL2"
  fun op COMPLEX_LMUL_SCALAR_LMUL _ = ()
  val op COMPLEX_LMUL_SCALAR_LMUL = TDB.find "COMPLEX_LMUL_SCALAR_LMUL"
  fun op COMPLEX_RMUL_SCALAR_LMUL _ = ()
  val op COMPLEX_RMUL_SCALAR_LMUL = TDB.find "COMPLEX_RMUL_SCALAR_LMUL"
  fun op COMPLEX_SCALAR_LMUL_ZERO _ = ()
  val op COMPLEX_SCALAR_LMUL_ZERO = TDB.find "COMPLEX_SCALAR_LMUL_ZERO"
  fun op COMPLEX_ZERO_SCALAR_LMUL _ = ()
  val op COMPLEX_ZERO_SCALAR_LMUL = TDB.find "COMPLEX_ZERO_SCALAR_LMUL"
  fun op COMPLEX_SCALAR_LMUL_ONE _ = ()
  val op COMPLEX_SCALAR_LMUL_ONE = TDB.find "COMPLEX_SCALAR_LMUL_ONE"
  fun op COMPLEX_SCALAR_LMUL_NEG1 _ = ()
  val op COMPLEX_SCALAR_LMUL_NEG1 = TDB.find "COMPLEX_SCALAR_LMUL_NEG1"
  fun op COMPLEX_DOUBLE _ = ()
  val op COMPLEX_DOUBLE = TDB.find "COMPLEX_DOUBLE"
  fun op COMPLEX_SCALAR_LMUL_ENTIRE _ = ()
  val op COMPLEX_SCALAR_LMUL_ENTIRE = TDB.find "COMPLEX_SCALAR_LMUL_ENTIRE"
  fun op COMPLEX_EQ_SCALAR_LMUL _ = ()
  val op COMPLEX_EQ_SCALAR_LMUL = TDB.find "COMPLEX_EQ_SCALAR_LMUL"
  fun op COMPLEX_SCALAR_LMUL_EQ _ = ()
  val op COMPLEX_SCALAR_LMUL_EQ = TDB.find "COMPLEX_SCALAR_LMUL_EQ"
  fun op COMPLEX_SCALAR_LMUL_EQ1 _ = ()
  val op COMPLEX_SCALAR_LMUL_EQ1 = TDB.find "COMPLEX_SCALAR_LMUL_EQ1"
  fun op COMPLEX_INV_SCALAR_LMUL _ = ()
  val op COMPLEX_INV_SCALAR_LMUL = TDB.find "COMPLEX_INV_SCALAR_LMUL"
  fun op COMPLEX_SCALAR_LMUL_DIV2 _ = ()
  val op COMPLEX_SCALAR_LMUL_DIV2 = TDB.find "COMPLEX_SCALAR_LMUL_DIV2"
  fun op COMPLEX_SCALAR_MUL_COMM _ = ()
  val op COMPLEX_SCALAR_MUL_COMM = TDB.find "COMPLEX_SCALAR_MUL_COMM"
  fun op COMPLEX_SCALAR_RMUL _ = ()
  val op COMPLEX_SCALAR_RMUL = TDB.find "COMPLEX_SCALAR_RMUL"
  fun op COMPLEX_SCALAR_RMUL_NEG _ = ()
  val op COMPLEX_SCALAR_RMUL_NEG = TDB.find "COMPLEX_SCALAR_RMUL_NEG"
  fun op COMPLEX_NEG_SCALAR_RMUL _ = ()
  val op COMPLEX_NEG_SCALAR_RMUL = TDB.find "COMPLEX_NEG_SCALAR_RMUL"
  fun op COMPLEX_SCALAR_RMUL_ADD _ = ()
  val op COMPLEX_SCALAR_RMUL_ADD = TDB.find "COMPLEX_SCALAR_RMUL_ADD"
  fun op COMPLEX_RSCALAR_RMUL_SUB _ = ()
  val op COMPLEX_RSCALAR_RMUL_SUB = TDB.find "COMPLEX_RSCALAR_RMUL_SUB"
  fun op COMPLEX_ADD_RSCALAR_RMUL _ = ()
  val op COMPLEX_ADD_RSCALAR_RMUL = TDB.find "COMPLEX_ADD_RSCALAR_RMUL"
  fun op COMPLEX_SUB_SCALAR_RMUL _ = ()
  val op COMPLEX_SUB_SCALAR_RMUL = TDB.find "COMPLEX_SUB_SCALAR_RMUL"
  fun op COMPLEX_SCALAR_RMUL_ZERO _ = ()
  val op COMPLEX_SCALAR_RMUL_ZERO = TDB.find "COMPLEX_SCALAR_RMUL_ZERO"
  fun op COMPLEX_ZERO_SCALAR_RMUL _ = ()
  val op COMPLEX_ZERO_SCALAR_RMUL = TDB.find "COMPLEX_ZERO_SCALAR_RMUL"
  fun op COMPLEX_SCALAR_RMUL_ONE _ = ()
  val op COMPLEX_SCALAR_RMUL_ONE = TDB.find "COMPLEX_SCALAR_RMUL_ONE"
  fun op COMPLEX_SCALAR_RMUL_NEG1 _ = ()
  val op COMPLEX_SCALAR_RMUL_NEG1 = TDB.find "COMPLEX_SCALAR_RMUL_NEG1"
  fun op CONJ_REAL_REFL _ = ()
  val op CONJ_REAL_REFL = TDB.find "CONJ_REAL_REFL"
  fun op CONJ_NUM_REFL _ = ()
  val op CONJ_NUM_REFL = TDB.find "CONJ_NUM_REFL"
  fun op CONJ_ADD _ = () val op CONJ_ADD = TDB.find "CONJ_ADD"
  fun op CONJ_NEG _ = () val op CONJ_NEG = TDB.find "CONJ_NEG"
  fun op CONJ_SUB _ = () val op CONJ_SUB = TDB.find "CONJ_SUB"
  fun op CONJ_MUL _ = () val op CONJ_MUL = TDB.find "CONJ_MUL"
  fun op CONJ_INV _ = () val op CONJ_INV = TDB.find "CONJ_INV"
  fun op CONJ_DIV _ = () val op CONJ_DIV = TDB.find "CONJ_DIV"
  fun op CONJ_SCALAR_LMUL _ = ()
  val op CONJ_SCALAR_LMUL = TDB.find "CONJ_SCALAR_LMUL"
  fun op CONJ_CONJ _ = () val op CONJ_CONJ = TDB.find "CONJ_CONJ"
  fun op CONJ_EQ _ = () val op CONJ_EQ = TDB.find "CONJ_EQ"
  fun op CONJ_EQ2 _ = () val op CONJ_EQ2 = TDB.find "CONJ_EQ2"
  fun op COMPLEX_MUL_RCONJ _ = ()
  val op COMPLEX_MUL_RCONJ = TDB.find "COMPLEX_MUL_RCONJ"
  fun op COMPLEX_MUL_LCONJ _ = ()
  val op COMPLEX_MUL_LCONJ = TDB.find "COMPLEX_MUL_LCONJ"
  fun op CONJ_ZERO _ = () val op CONJ_ZERO = TDB.find "CONJ_ZERO"
  fun op MODU_POW2 _ = () val op MODU_POW2 = TDB.find "MODU_POW2"
  fun op RE_IM_LE_MODU _ = ()
  val op RE_IM_LE_MODU = TDB.find "RE_IM_LE_MODU"
  fun op MODU_POS _ = () val op MODU_POS = TDB.find "MODU_POS"
  fun op COMPLEX_MUL_RCONJ1 _ = ()
  val op COMPLEX_MUL_RCONJ1 = TDB.find "COMPLEX_MUL_RCONJ1"
  fun op COMPLEX_MUL_LCONJ1 _ = ()
  val op COMPLEX_MUL_LCONJ1 = TDB.find "COMPLEX_MUL_LCONJ1"
  fun op MODU_NEG _ = () val op MODU_NEG = TDB.find "MODU_NEG"
  fun op MODU_SUB _ = () val op MODU_SUB = TDB.find "MODU_SUB"
  fun op MODU_CONJ _ = () val op MODU_CONJ = TDB.find "MODU_CONJ"
  fun op MODU_MUL _ = () val op MODU_MUL = TDB.find "MODU_MUL"
  fun op MODU_0 _ = () val op MODU_0 = TDB.find "MODU_0"
  fun op MODU_1 _ = () val op MODU_1 = TDB.find "MODU_1"
  fun op MODU_COMPLEX_INV _ = ()
  val op MODU_COMPLEX_INV = TDB.find "MODU_COMPLEX_INV"
  fun op MODU_DIV _ = () val op MODU_DIV = TDB.find "MODU_DIV"
  fun op MODU_SCALAR_LMUL _ = ()
  val op MODU_SCALAR_LMUL = TDB.find "MODU_SCALAR_LMUL"
  fun op MODU_REAL _ = () val op MODU_REAL = TDB.find "MODU_REAL"
  fun op MODU_NUM _ = () val op MODU_NUM = TDB.find "MODU_NUM"
  fun op MODU_ZERO _ = () val op MODU_ZERO = TDB.find "MODU_ZERO"
  fun op MODU_NZ _ = () val op MODU_NZ = TDB.find "MODU_NZ"
  fun op MODU_CASES _ = () val op MODU_CASES = TDB.find "MODU_CASES"
  fun op RE_DIV_MODU_BOUNDS _ = ()
  val op RE_DIV_MODU_BOUNDS = TDB.find "RE_DIV_MODU_BOUNDS"
  fun op IM_DIV_MODU_BOUNDS _ = ()
  val op IM_DIV_MODU_BOUNDS = TDB.find "IM_DIV_MODU_BOUNDS"
  fun op RE_DIV_MODU_ACS_BOUNDS _ = ()
  val op RE_DIV_MODU_ACS_BOUNDS = TDB.find "RE_DIV_MODU_ACS_BOUNDS"
  fun op IM_DIV_MODU_ASN_BOUNDS _ = ()
  val op IM_DIV_MODU_ASN_BOUNDS = TDB.find "IM_DIV_MODU_ASN_BOUNDS"
  fun op RE_DIV_MODU_ACS_COS _ = ()
  val op RE_DIV_MODU_ACS_COS = TDB.find "RE_DIV_MODU_ACS_COS"
  fun op IM_DIV_MODU_ASN_SIN _ = ()
  val op IM_DIV_MODU_ASN_SIN = TDB.find "IM_DIV_MODU_ASN_SIN"
  fun op ARG_COS _ = () val op ARG_COS = TDB.find "ARG_COS"
  fun op ARG_SIN _ = () val op ARG_SIN = TDB.find "ARG_SIN"
  fun op RE_MODU_ARG _ = () val op RE_MODU_ARG = TDB.find "RE_MODU_ARG"
  fun op IM_MODU_ARG _ = () val op IM_MODU_ARG = TDB.find "IM_MODU_ARG"
  fun op COMPLEX_TRIANGLE _ = ()
  val op COMPLEX_TRIANGLE = TDB.find "COMPLEX_TRIANGLE"
  fun op COMPLEX_MODU_ARG_EQ _ = ()
  val op COMPLEX_MODU_ARG_EQ = TDB.find "COMPLEX_MODU_ARG_EQ"
  fun op MODU_UNIT _ = () val op MODU_UNIT = TDB.find "MODU_UNIT"
  fun op COMPLEX_MUL_ARG _ = ()
  val op COMPLEX_MUL_ARG = TDB.find "COMPLEX_MUL_ARG"
  fun op COMPLEX_INV_ARG _ = ()
  val op COMPLEX_INV_ARG = TDB.find "COMPLEX_INV_ARG"
  fun op COMPLEX_DIV_ARG _ = ()
  val op COMPLEX_DIV_ARG = TDB.find "COMPLEX_DIV_ARG"
  fun op complex_pow_compute _ = ()
  val op complex_pow_compute = TDB.find "complex_pow_compute"
  fun op COMPLEX_POW_0 _ = ()
  val op COMPLEX_POW_0 = TDB.find "COMPLEX_POW_0"
  fun op COMPLEX_POW_NZ _ = ()
  val op COMPLEX_POW_NZ = TDB.find "COMPLEX_POW_NZ"
  fun op COMPLEX_POWINV _ = ()
  val op COMPLEX_POWINV = TDB.find "COMPLEX_POWINV"
  fun op MODU_COMPLEX_POW _ = ()
  val op MODU_COMPLEX_POW = TDB.find "MODU_COMPLEX_POW"
  fun op COMPLEX_POW_ADD _ = ()
  val op COMPLEX_POW_ADD = TDB.find "COMPLEX_POW_ADD"
  fun op COMPLEX_POW_1 _ = ()
  val op COMPLEX_POW_1 = TDB.find "COMPLEX_POW_1"
  fun op COMPLEX_POW_2 _ = ()
  val op COMPLEX_POW_2 = TDB.find "COMPLEX_POW_2"
  fun op COMPLEX_POW_ONE _ = ()
  val op COMPLEX_POW_ONE = TDB.find "COMPLEX_POW_ONE"
  fun op COMPLEX_POW_MUL _ = ()
  val op COMPLEX_POW_MUL = TDB.find "COMPLEX_POW_MUL"
  fun op COMPLEX_POW_INV _ = ()
  val op COMPLEX_POW_INV = TDB.find "COMPLEX_POW_INV"
  fun op COMPLEX_POW_DIV _ = ()
  val op COMPLEX_POW_DIV = TDB.find "COMPLEX_POW_DIV"
  fun op COMPLEX_POW_L _ = ()
  val op COMPLEX_POW_L = TDB.find "COMPLEX_POW_L"
  fun op COMPLEX_POW_ZERO _ = ()
  val op COMPLEX_POW_ZERO = TDB.find "COMPLEX_POW_ZERO"
  fun op COMPLEX_POW_ZERO_EQ _ = ()
  val op COMPLEX_POW_ZERO_EQ = TDB.find "COMPLEX_POW_ZERO_EQ"
  fun op COMPLEX_POW_POW _ = ()
  val op COMPLEX_POW_POW = TDB.find "COMPLEX_POW_POW"
  fun op DE_MOIVRE_LEMMA _ = ()
  val op DE_MOIVRE_LEMMA = TDB.find "DE_MOIVRE_LEMMA"
  fun op DE_MOIVRE_THM _ = ()
  val op DE_MOIVRE_THM = TDB.find "DE_MOIVRE_THM"
  fun op EXP_IMAGINARY _ = ()
  val op EXP_IMAGINARY = TDB.find "EXP_IMAGINARY"
  fun op EULER_FORMULE _ = ()
  val op EULER_FORMULE = TDB.find "EULER_FORMULE"
  fun op COMPLEX_EXP_ADD _ = ()
  val op COMPLEX_EXP_ADD = TDB.find "COMPLEX_EXP_ADD"
  fun op COMPLEX_EXP_NEG _ = ()
  val op COMPLEX_EXP_NEG = TDB.find "COMPLEX_EXP_NEG"
  fun op COMPLEX_EXP_SUB _ = ()
  val op COMPLEX_EXP_SUB = TDB.find "COMPLEX_EXP_SUB"
  fun op COMPLEX_EXP_N _ = ()
  val op COMPLEX_EXP_N = TDB.find "COMPLEX_EXP_N"
  fun op COMPLEX_EXP_N2 _ = ()
  val op COMPLEX_EXP_N2 = TDB.find "COMPLEX_EXP_N2"
  fun op COMPLEX_EXP_0 _ = ()
  val op COMPLEX_EXP_0 = TDB.find "COMPLEX_EXP_0"
  fun op COMPLEX_EXP_NZ _ = ()
  val op COMPLEX_EXP_NZ = TDB.find "COMPLEX_EXP_NZ"
  fun op COMPLEX_EXP_ADD_MUL _ = ()
  val op COMPLEX_EXP_ADD_MUL = TDB.find "COMPLEX_EXP_ADD_MUL"
  fun op COMPLEX_EXP_NEG_MUL _ = ()
  val op COMPLEX_EXP_NEG_MUL = TDB.find "COMPLEX_EXP_NEG_MUL"
  fun op COMPLEX_EXP_NEG_MUL2 _ = ()
  val op COMPLEX_EXP_NEG_MUL2 = TDB.find "COMPLEX_EXP_NEG_MUL2"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val complex_grammars = merge_grammars ["transc"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="complex"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val complex_grammars = 
    Portable.## (addtyUDs,addtmUDs) complex_grammars
  val _ = Parse.grammarDB_insert("complex",complex_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "complex"

end
