structure hratTheory :> hratTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading hratTheory ... "
    else ()
  
  open Type Term Thm
  local open quotient_listTheory quotient_optionTheory quotient_pairTheory
  quotient_sumTheory
  in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "hrat"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/hratTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op trat_1 _ = () val op trat_1 = TDB.find "trat_1"
  fun op trat_inv _ = () val op trat_inv = TDB.find "trat_inv"
  fun op trat_add _ = () val op trat_add = TDB.find "trat_add"
  fun op trat_mul _ = () val op trat_mul = TDB.find "trat_mul"
  fun op trat_sucint _ = () val op trat_sucint = TDB.find "trat_sucint"
  fun op trat_eq _ = () val op trat_eq = TDB.find "trat_eq"
  fun op hrat_TY_DEF _ = () val op hrat_TY_DEF = TDB.find "hrat_TY_DEF"
  fun op hrat_bijections _ = ()
  val op hrat_bijections = TDB.find "hrat_bijections"
  fun op hrat_REP_def _ = () val op hrat_REP_def = TDB.find "hrat_REP_def"
  fun op hrat_ABS_def _ = () val op hrat_ABS_def = TDB.find "hrat_ABS_def"
  fun op hrat_1 _ = () val op hrat_1 = TDB.find "hrat_1"
  fun op hrat_inv _ = () val op hrat_inv = TDB.find "hrat_inv"
  fun op hrat_add _ = () val op hrat_add = TDB.find "hrat_add"
  fun op hrat_mul _ = () val op hrat_mul = TDB.find "hrat_mul"
  fun op hrat_sucint _ = () val op hrat_sucint = TDB.find "hrat_sucint"
  fun op TRAT_EQ_REFL _ = () val op TRAT_EQ_REFL = TDB.find "TRAT_EQ_REFL"
  fun op TRAT_EQ_SYM _ = () val op TRAT_EQ_SYM = TDB.find "TRAT_EQ_SYM"
  fun op TRAT_EQ_TRANS _ = ()
  val op TRAT_EQ_TRANS = TDB.find "TRAT_EQ_TRANS"
  fun op TRAT_EQ_AP _ = () val op TRAT_EQ_AP = TDB.find "TRAT_EQ_AP"
  fun op TRAT_ADD_SYM_EQ _ = ()
  val op TRAT_ADD_SYM_EQ = TDB.find "TRAT_ADD_SYM_EQ"
  fun op TRAT_MUL_SYM_EQ _ = ()
  val op TRAT_MUL_SYM_EQ = TDB.find "TRAT_MUL_SYM_EQ"
  fun op TRAT_INV_WELLDEFINED _ = ()
  val op TRAT_INV_WELLDEFINED = TDB.find "TRAT_INV_WELLDEFINED"
  fun op TRAT_ADD_WELLDEFINED _ = ()
  val op TRAT_ADD_WELLDEFINED = TDB.find "TRAT_ADD_WELLDEFINED"
  fun op TRAT_ADD_WELLDEFINED2 _ = ()
  val op TRAT_ADD_WELLDEFINED2 = TDB.find "TRAT_ADD_WELLDEFINED2"
  fun op TRAT_MUL_WELLDEFINED _ = ()
  val op TRAT_MUL_WELLDEFINED = TDB.find "TRAT_MUL_WELLDEFINED"
  fun op TRAT_MUL_WELLDEFINED2 _ = ()
  val op TRAT_MUL_WELLDEFINED2 = TDB.find "TRAT_MUL_WELLDEFINED2"
  fun op TRAT_ADD_SYM _ = () val op TRAT_ADD_SYM = TDB.find "TRAT_ADD_SYM"
  fun op TRAT_ADD_ASSOC _ = ()
  val op TRAT_ADD_ASSOC = TDB.find "TRAT_ADD_ASSOC"
  fun op TRAT_MUL_SYM _ = () val op TRAT_MUL_SYM = TDB.find "TRAT_MUL_SYM"
  fun op TRAT_MUL_ASSOC _ = ()
  val op TRAT_MUL_ASSOC = TDB.find "TRAT_MUL_ASSOC"
  fun op TRAT_LDISTRIB _ = ()
  val op TRAT_LDISTRIB = TDB.find "TRAT_LDISTRIB"
  fun op TRAT_MUL_LID _ = () val op TRAT_MUL_LID = TDB.find "TRAT_MUL_LID"
  fun op TRAT_MUL_LINV _ = ()
  val op TRAT_MUL_LINV = TDB.find "TRAT_MUL_LINV"
  fun op TRAT_NOZERO _ = () val op TRAT_NOZERO = TDB.find "TRAT_NOZERO"
  fun op TRAT_ADD_TOTAL _ = ()
  val op TRAT_ADD_TOTAL = TDB.find "TRAT_ADD_TOTAL"
  fun op TRAT_SUCINT_0 _ = ()
  val op TRAT_SUCINT_0 = TDB.find "TRAT_SUCINT_0"
  fun op TRAT_ARCH _ = () val op TRAT_ARCH = TDB.find "TRAT_ARCH"
  fun op TRAT_SUCINT _ = () val op TRAT_SUCINT = TDB.find "TRAT_SUCINT"
  fun op TRAT_EQ_EQUIV _ = ()
  val op TRAT_EQ_EQUIV = TDB.find "TRAT_EQ_EQUIV"
  fun op hrat_ABS_REP_CLASS _ = ()
  val op hrat_ABS_REP_CLASS = TDB.find "hrat_ABS_REP_CLASS"
  fun op hrat_QUOTIENT _ = ()
  val op hrat_QUOTIENT = TDB.find "hrat_QUOTIENT"
  fun op HRAT_ADD_SYM _ = () val op HRAT_ADD_SYM = TDB.find "HRAT_ADD_SYM"
  fun op HRAT_ADD_ASSOC _ = ()
  val op HRAT_ADD_ASSOC = TDB.find "HRAT_ADD_ASSOC"
  fun op HRAT_MUL_SYM _ = () val op HRAT_MUL_SYM = TDB.find "HRAT_MUL_SYM"
  fun op HRAT_MUL_ASSOC _ = ()
  val op HRAT_MUL_ASSOC = TDB.find "HRAT_MUL_ASSOC"
  fun op HRAT_LDISTRIB _ = ()
  val op HRAT_LDISTRIB = TDB.find "HRAT_LDISTRIB"
  fun op HRAT_MUL_LID _ = () val op HRAT_MUL_LID = TDB.find "HRAT_MUL_LID"
  fun op HRAT_MUL_LINV _ = ()
  val op HRAT_MUL_LINV = TDB.find "HRAT_MUL_LINV"
  fun op HRAT_NOZERO _ = () val op HRAT_NOZERO = TDB.find "HRAT_NOZERO"
  fun op HRAT_ADD_TOTAL _ = ()
  val op HRAT_ADD_TOTAL = TDB.find "HRAT_ADD_TOTAL"
  fun op HRAT_ARCH _ = () val op HRAT_ARCH = TDB.find "HRAT_ARCH"
  fun op HRAT_SUCINT _ = () val op HRAT_SUCINT = TDB.find "HRAT_SUCINT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val hrat_grammars = merge_grammars ["quotient_sum", "quotient_pair",
  "quotient_option", "quotient_list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="hrat"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val hrat_grammars = 
    Portable.## (addtyUDs,addtmUDs) hrat_grammars
  val _ = Parse.grammarDB_insert("hrat",hrat_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "hrat"

end
