structure hrealTheory :> hrealTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading hrealTheory ... "
    else ()
  
  open Type Term Thm
  local open hratTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "hreal"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/hrealTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op hrat_lt _ = () val op hrat_lt = TDB.find "hrat_lt"
  fun op isacut _ = () val op isacut = TDB.find "isacut"
  fun op cut_of_hrat _ = () val op cut_of_hrat = TDB.find "cut_of_hrat"
  fun op hreal_TY_DEF _ = () val op hreal_TY_DEF = TDB.find "hreal_TY_DEF"
  fun op hreal_tybij _ = () val op hreal_tybij = TDB.find "hreal_tybij"
  fun op hreal_1 _ = () val op hreal_1 = TDB.find "hreal_1"
  fun op hreal_add _ = () val op hreal_add = TDB.find "hreal_add"
  fun op hreal_mul _ = () val op hreal_mul = TDB.find "hreal_mul"
  fun op hreal_inv _ = () val op hreal_inv = TDB.find "hreal_inv"
  fun op hreal_sup _ = () val op hreal_sup = TDB.find "hreal_sup"
  fun op hreal_lt _ = () val op hreal_lt = TDB.find "hreal_lt"
  fun op hreal_sub _ = () val op hreal_sub = TDB.find "hreal_sub"
  fun op HRAT_LT_REFL _ = () val op HRAT_LT_REFL = TDB.find "HRAT_LT_REFL"
  fun op HRAT_LT_TRANS _ = ()
  val op HRAT_LT_TRANS = TDB.find "HRAT_LT_TRANS"
  fun op HRAT_LT_ANTISYM _ = ()
  val op HRAT_LT_ANTISYM = TDB.find "HRAT_LT_ANTISYM"
  fun op HRAT_LT_TOTAL _ = ()
  val op HRAT_LT_TOTAL = TDB.find "HRAT_LT_TOTAL"
  fun op HRAT_MUL_RID _ = () val op HRAT_MUL_RID = TDB.find "HRAT_MUL_RID"
  fun op HRAT_MUL_RINV _ = ()
  val op HRAT_MUL_RINV = TDB.find "HRAT_MUL_RINV"
  fun op HRAT_RDISTRIB _ = ()
  val op HRAT_RDISTRIB = TDB.find "HRAT_RDISTRIB"
  fun op HRAT_LT_ADDL _ = () val op HRAT_LT_ADDL = TDB.find "HRAT_LT_ADDL"
  fun op HRAT_LT_ADDR _ = () val op HRAT_LT_ADDR = TDB.find "HRAT_LT_ADDR"
  fun op HRAT_LT_GT _ = () val op HRAT_LT_GT = TDB.find "HRAT_LT_GT"
  fun op HRAT_LT_NE _ = () val op HRAT_LT_NE = TDB.find "HRAT_LT_NE"
  fun op HRAT_EQ_LADD _ = () val op HRAT_EQ_LADD = TDB.find "HRAT_EQ_LADD"
  fun op HRAT_EQ_LMUL _ = () val op HRAT_EQ_LMUL = TDB.find "HRAT_EQ_LMUL"
  fun op HRAT_LT_ADD2 _ = () val op HRAT_LT_ADD2 = TDB.find "HRAT_LT_ADD2"
  fun op HRAT_LT_LADD _ = () val op HRAT_LT_LADD = TDB.find "HRAT_LT_LADD"
  fun op HRAT_LT_RADD _ = () val op HRAT_LT_RADD = TDB.find "HRAT_LT_RADD"
  fun op HRAT_LT_MUL2 _ = () val op HRAT_LT_MUL2 = TDB.find "HRAT_LT_MUL2"
  fun op HRAT_LT_LMUL _ = () val op HRAT_LT_LMUL = TDB.find "HRAT_LT_LMUL"
  fun op HRAT_LT_RMUL _ = () val op HRAT_LT_RMUL = TDB.find "HRAT_LT_RMUL"
  fun op HRAT_LT_LMUL1 _ = ()
  val op HRAT_LT_LMUL1 = TDB.find "HRAT_LT_LMUL1"
  fun op HRAT_LT_RMUL1 _ = ()
  val op HRAT_LT_RMUL1 = TDB.find "HRAT_LT_RMUL1"
  fun op HRAT_GT_LMUL1 _ = ()
  val op HRAT_GT_LMUL1 = TDB.find "HRAT_GT_LMUL1"
  fun op HRAT_LT_L1 _ = () val op HRAT_LT_L1 = TDB.find "HRAT_LT_L1"
  fun op HRAT_LT_R1 _ = () val op HRAT_LT_R1 = TDB.find "HRAT_LT_R1"
  fun op HRAT_GT_L1 _ = () val op HRAT_GT_L1 = TDB.find "HRAT_GT_L1"
  fun op HRAT_INV_MUL _ = () val op HRAT_INV_MUL = TDB.find "HRAT_INV_MUL"
  fun op HRAT_UP _ = () val op HRAT_UP = TDB.find "HRAT_UP"
  fun op HRAT_DOWN _ = () val op HRAT_DOWN = TDB.find "HRAT_DOWN"
  fun op HRAT_DOWN2 _ = () val op HRAT_DOWN2 = TDB.find "HRAT_DOWN2"
  fun op HRAT_MEAN _ = () val op HRAT_MEAN = TDB.find "HRAT_MEAN"
  fun op ISACUT_HRAT _ = () val op ISACUT_HRAT = TDB.find "ISACUT_HRAT"
  fun op EQUAL_CUTS _ = () val op EQUAL_CUTS = TDB.find "EQUAL_CUTS"
  fun op CUT_ISACUT _ = () val op CUT_ISACUT = TDB.find "CUT_ISACUT"
  fun op CUT_NONEMPTY _ = () val op CUT_NONEMPTY = TDB.find "CUT_NONEMPTY"
  fun op CUT_BOUNDED _ = () val op CUT_BOUNDED = TDB.find "CUT_BOUNDED"
  fun op CUT_DOWN _ = () val op CUT_DOWN = TDB.find "CUT_DOWN"
  fun op CUT_UP _ = () val op CUT_UP = TDB.find "CUT_UP"
  fun op CUT_UBOUND _ = () val op CUT_UBOUND = TDB.find "CUT_UBOUND"
  fun op CUT_STRADDLE _ = () val op CUT_STRADDLE = TDB.find "CUT_STRADDLE"
  fun op CUT_NEARTOP_ADD _ = ()
  val op CUT_NEARTOP_ADD = TDB.find "CUT_NEARTOP_ADD"
  fun op CUT_NEARTOP_MUL _ = ()
  val op CUT_NEARTOP_MUL = TDB.find "CUT_NEARTOP_MUL"
  fun op HREAL_INV_ISACUT _ = ()
  val op HREAL_INV_ISACUT = TDB.find "HREAL_INV_ISACUT"
  fun op HREAL_ADD_ISACUT _ = ()
  val op HREAL_ADD_ISACUT = TDB.find "HREAL_ADD_ISACUT"
  fun op HREAL_MUL_ISACUT _ = ()
  val op HREAL_MUL_ISACUT = TDB.find "HREAL_MUL_ISACUT"
  fun op HREAL_ADD_SYM _ = ()
  val op HREAL_ADD_SYM = TDB.find "HREAL_ADD_SYM"
  fun op HREAL_MUL_SYM _ = ()
  val op HREAL_MUL_SYM = TDB.find "HREAL_MUL_SYM"
  fun op HREAL_ADD_ASSOC _ = ()
  val op HREAL_ADD_ASSOC = TDB.find "HREAL_ADD_ASSOC"
  fun op HREAL_MUL_ASSOC _ = ()
  val op HREAL_MUL_ASSOC = TDB.find "HREAL_MUL_ASSOC"
  fun op HREAL_LDISTRIB _ = ()
  val op HREAL_LDISTRIB = TDB.find "HREAL_LDISTRIB"
  fun op HREAL_MUL_LID _ = ()
  val op HREAL_MUL_LID = TDB.find "HREAL_MUL_LID"
  fun op HREAL_MUL_LINV _ = ()
  val op HREAL_MUL_LINV = TDB.find "HREAL_MUL_LINV"
  fun op HREAL_NOZERO _ = () val op HREAL_NOZERO = TDB.find "HREAL_NOZERO"
  fun op HREAL_LT_LEMMA _ = ()
  val op HREAL_LT_LEMMA = TDB.find "HREAL_LT_LEMMA"
  fun op HREAL_SUB_ISACUT _ = ()
  val op HREAL_SUB_ISACUT = TDB.find "HREAL_SUB_ISACUT"
  fun op HREAL_SUB_ADD _ = ()
  val op HREAL_SUB_ADD = TDB.find "HREAL_SUB_ADD"
  fun op HREAL_LT_TOTAL _ = ()
  val op HREAL_LT_TOTAL = TDB.find "HREAL_LT_TOTAL"
  fun op HREAL_LT _ = () val op HREAL_LT = TDB.find "HREAL_LT"
  fun op HREAL_ADD_TOTAL _ = ()
  val op HREAL_ADD_TOTAL = TDB.find "HREAL_ADD_TOTAL"
  fun op HREAL_SUP_ISACUT _ = ()
  val op HREAL_SUP_ISACUT = TDB.find "HREAL_SUP_ISACUT"
  fun op HREAL_SUP _ = () val op HREAL_SUP = TDB.find "HREAL_SUP"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val hreal_grammars = merge_grammars ["hrat"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="hreal"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val hreal_grammars = 
    Portable.## (addtyUDs,addtmUDs) hreal_grammars
  val _ = Parse.grammarDB_insert("hreal",hreal_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "hreal"

end
