structure integralTheory :> integralTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading integralTheory ... "
    else ()
  
  open Type Term Thm
  local open transcTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "integral"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/integralTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op integrable_def _ = ()
  val op integrable_def = TDB.find "integrable_def"
  fun op integral_def _ = () val op integral_def = TDB.find "integral_def"
  fun op SUM_SPLIT _ = () val op SUM_SPLIT = TDB.find "SUM_SPLIT"
  fun op DIVISION_APPEND_EXPLICIT _ = ()
  val op DIVISION_APPEND_EXPLICIT = TDB.find "DIVISION_APPEND_EXPLICIT"
  fun op DIVISION_APPEND_STRONG _ = ()
  val op DIVISION_APPEND_STRONG = TDB.find "DIVISION_APPEND_STRONG"
  fun op DIVISION_APPEND _ = ()
  val op DIVISION_APPEND = TDB.find "DIVISION_APPEND"
  fun op INTEGRABLE_DINT _ = ()
  val op INTEGRABLE_DINT = TDB.find "INTEGRABLE_DINT"
  fun op DIVISION_BOUNDS _ = ()
  val op DIVISION_BOUNDS = TDB.find "DIVISION_BOUNDS"
  fun op TDIV_BOUNDS _ = () val op TDIV_BOUNDS = TDB.find "TDIV_BOUNDS"
  fun op TDIV_LE _ = () val op TDIV_LE = TDB.find "TDIV_LE"
  fun op DINT_WRONG _ = () val op DINT_WRONG = TDB.find "DINT_WRONG"
  fun op DINT_INTEGRAL _ = ()
  val op DINT_INTEGRAL = TDB.find "DINT_INTEGRAL"
  fun op DINT_NEG _ = () val op DINT_NEG = TDB.find "DINT_NEG"
  fun op DINT_0 _ = () val op DINT_0 = TDB.find "DINT_0"
  fun op DINT_ADD _ = () val op DINT_ADD = TDB.find "DINT_ADD"
  fun op DINT_SUB _ = () val op DINT_SUB = TDB.find "DINT_SUB"
  fun op DSIZE_EQ _ = () val op DSIZE_EQ = TDB.find "DSIZE_EQ"
  fun op DINT_CONST _ = () val op DINT_CONST = TDB.find "DINT_CONST"
  fun op DINT_CMUL _ = () val op DINT_CMUL = TDB.find "DINT_CMUL"
  fun op DINT_LINEAR _ = () val op DINT_LINEAR = TDB.find "DINT_LINEAR"
  fun op LT _ = () val op LT = TDB.find "LT"
  fun op LE_0 _ = () val op LE_0 = TDB.find "LE_0"
  fun op LT_0 _ = () val op LT_0 = TDB.find "LT_0"
  fun op EQ_SUC _ = () val op EQ_SUC = TDB.find "EQ_SUC"
  fun op LE_LT _ = () val op LE_LT = TDB.find "LE_LT"
  fun op LT_LE _ = () val op LT_LE = TDB.find "LT_LE"
  fun op REAL_LT_MIN _ = () val op REAL_LT_MIN = TDB.find "REAL_LT_MIN"
  fun op REAL_LE_RMUL1 _ = ()
  val op REAL_LE_RMUL1 = TDB.find "REAL_LE_RMUL1"
  fun op REAL_LE_LMUL1 _ = ()
  val op REAL_LE_LMUL1 = TDB.find "REAL_LE_LMUL1"
  fun op INTEGRAL_LE _ = () val op INTEGRAL_LE = TDB.find "INTEGRAL_LE"
  fun op DINT_LE _ = () val op DINT_LE = TDB.find "DINT_LE"
  fun op DINT_TRIANGLE _ = ()
  val op DINT_TRIANGLE = TDB.find "DINT_TRIANGLE"
  fun op DINT_EQ _ = () val op DINT_EQ = TDB.find "DINT_EQ"
  fun op INTEGRAL_EQ _ = () val op INTEGRAL_EQ = TDB.find "INTEGRAL_EQ"
  fun op INTEGRATION_BY_PARTS _ = ()
  val op INTEGRATION_BY_PARTS = TDB.find "INTEGRATION_BY_PARTS"
  fun op DIVISION_LE_SUC _ = ()
  val op DIVISION_LE_SUC = TDB.find "DIVISION_LE_SUC"
  fun op DIVISION_MONO_LE _ = ()
  val op DIVISION_MONO_LE = TDB.find "DIVISION_MONO_LE"
  fun op DIVISION_MONO_LE_SUC _ = ()
  val op DIVISION_MONO_LE_SUC = TDB.find "DIVISION_MONO_LE_SUC"
  fun op DIVISION_DSIZE_LE _ = ()
  val op DIVISION_DSIZE_LE = TDB.find "DIVISION_DSIZE_LE"
  fun op DIVISION_DSIZE_GE _ = ()
  val op DIVISION_DSIZE_GE = TDB.find "DIVISION_DSIZE_GE"
  fun op DIVISION_DSIZE_EQ _ = ()
  val op DIVISION_DSIZE_EQ = TDB.find "DIVISION_DSIZE_EQ"
  fun op DIVISION_DSIZE_EQ_ALT _ = ()
  val op DIVISION_DSIZE_EQ_ALT = TDB.find "DIVISION_DSIZE_EQ_ALT"
  fun op num_MAX _ = () val op num_MAX = TDB.find "num_MAX"
  fun op DIVISION_INTERMEDIATE _ = ()
  val op DIVISION_INTERMEDIATE = TDB.find "DIVISION_INTERMEDIATE"
  fun op DINT_COMBINE _ = () val op DINT_COMBINE = TDB.find "DINT_COMBINE"
  fun op SUM_EQ_0 _ = () val op SUM_EQ_0 = TDB.find "SUM_EQ_0"
  fun op DINT_DELTA_LEFT _ = ()
  val op DINT_DELTA_LEFT = TDB.find "DINT_DELTA_LEFT"
  fun op DINT_DELTA_RIGHT _ = ()
  val op DINT_DELTA_RIGHT = TDB.find "DINT_DELTA_RIGHT"
  fun op DINT_DELTA _ = () val op DINT_DELTA = TDB.find "DINT_DELTA"
  fun op DINT_POINT_SPIKE _ = ()
  val op DINT_POINT_SPIKE = TDB.find "DINT_POINT_SPIKE"
  fun op DINT_FINITE_SPIKE _ = ()
  val op DINT_FINITE_SPIKE = TDB.find "DINT_FINITE_SPIKE"
  fun op REAL_POW_LBOUND _ = ()
  val op REAL_POW_LBOUND = TDB.find "REAL_POW_LBOUND"
  fun op REAL_ARCH_POW _ = ()
  val op REAL_ARCH_POW = TDB.find "REAL_ARCH_POW"
  fun op REAL_ARCH_POW2 _ = ()
  val op REAL_ARCH_POW2 = TDB.find "REAL_ARCH_POW2"
  fun op REAL_POW_LE_1 _ = ()
  val op REAL_POW_LE_1 = TDB.find "REAL_POW_LE_1"
  fun op REAL_POW_MONO _ = ()
  val op REAL_POW_MONO = TDB.find "REAL_POW_MONO"
  fun op REAL_LE_INV2 _ = () val op REAL_LE_INV2 = TDB.find "REAL_LE_INV2"
  fun op GAUGE_MIN_FINITE _ = ()
  val op GAUGE_MIN_FINITE = TDB.find "GAUGE_MIN_FINITE"
  fun op INTEGRABLE_CAUCHY _ = ()
  val op INTEGRABLE_CAUCHY = TDB.find "INTEGRABLE_CAUCHY"
  fun op SUM_DIFFS _ = () val op SUM_DIFFS = TDB.find "SUM_DIFFS"
  fun op RSUM_BOUND _ = () val op RSUM_BOUND = TDB.find "RSUM_BOUND"
  fun op RSUM_DIFF_BOUND _ = ()
  val op RSUM_DIFF_BOUND = TDB.find "RSUM_DIFF_BOUND"
  fun op INTEGRABLE_LIMIT _ = ()
  val op INTEGRABLE_LIMIT = TDB.find "INTEGRABLE_LIMIT"
  fun op INTEGRABLE_CONST _ = ()
  val op INTEGRABLE_CONST = TDB.find "INTEGRABLE_CONST"
  fun op INTEGRABLE_ADD _ = ()
  val op INTEGRABLE_ADD = TDB.find "INTEGRABLE_ADD"
  fun op INTEGRABLE_CMUL _ = ()
  val op INTEGRABLE_CMUL = TDB.find "INTEGRABLE_CMUL"
  fun op INTEGRABLE_COMBINE _ = ()
  val op INTEGRABLE_COMBINE = TDB.find "INTEGRABLE_COMBINE"
  fun op INTEGRABLE_POINT_SPIKE _ = ()
  val op INTEGRABLE_POINT_SPIKE = TDB.find "INTEGRABLE_POINT_SPIKE"
  fun op SUP_INTERVAL _ = () val op SUP_INTERVAL = TDB.find "SUP_INTERVAL"
  fun op BOLZANO_LEMMA_ALT _ = ()
  val op BOLZANO_LEMMA_ALT = TDB.find "BOLZANO_LEMMA_ALT"
  fun op CONT_UNIFORM _ = () val op CONT_UNIFORM = TDB.find "CONT_UNIFORM"
  fun op INTEGRABLE_CONTINUOUS _ = ()
  val op INTEGRABLE_CONTINUOUS = TDB.find "INTEGRABLE_CONTINUOUS"
  fun op INTEGRABLE_SPLIT_SIDES _ = ()
  val op INTEGRABLE_SPLIT_SIDES = TDB.find "INTEGRABLE_SPLIT_SIDES"
  fun op INTEGRABLE_SUBINTERVAL_LEFT _ = ()
  val op INTEGRABLE_SUBINTERVAL_LEFT = TDB.find
    "INTEGRABLE_SUBINTERVAL_LEFT"
  fun op INTEGRABLE_SUBINTERVAL_RIGHT _ = ()
  val op INTEGRABLE_SUBINTERVAL_RIGHT = TDB.find
    "INTEGRABLE_SUBINTERVAL_RIGHT"
  fun op INTEGRABLE_SUBINTERVAL _ = ()
  val op INTEGRABLE_SUBINTERVAL = TDB.find "INTEGRABLE_SUBINTERVAL"
  fun op INTEGRAL_0 _ = () val op INTEGRAL_0 = TDB.find "INTEGRAL_0"
  fun op INTEGRAL_CONST _ = ()
  val op INTEGRAL_CONST = TDB.find "INTEGRAL_CONST"
  fun op INTEGRAL_CMUL _ = ()
  val op INTEGRAL_CMUL = TDB.find "INTEGRAL_CMUL"
  fun op INTEGRAL_ADD _ = () val op INTEGRAL_ADD = TDB.find "INTEGRAL_ADD"
  fun op INTEGRAL_SUB _ = () val op INTEGRAL_SUB = TDB.find "INTEGRAL_SUB"
  fun op INTEGRAL_BY_PARTS _ = ()
  val op INTEGRAL_BY_PARTS = TDB.find "INTEGRAL_BY_PARTS"
  fun op INTEGRAL_COMBINE _ = ()
  val op INTEGRAL_COMBINE = TDB.find "INTEGRAL_COMBINE"
  fun op INTEGRAL_MVT1 _ = ()
  val op INTEGRAL_MVT1 = TDB.find "INTEGRAL_MVT1"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val integral_grammars = merge_grammars ["transc"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="integral"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val integral_grammars = 
    Portable.## (addtyUDs,addtmUDs) integral_grammars
  val _ = Parse.grammarDB_insert("integral",integral_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "integral"

end
