structure intrealTheory :> intrealTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading intrealTheory ... "
    else ()
  
  open Type Term Thm
  local open OmegaTheory int_arithTheory realTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "intreal"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/intrealTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op real_of_int _ = () val op real_of_int = TDB.find "real_of_int"
  fun op INT_FLOOR_def _ = ()
  val op INT_FLOOR_def = TDB.find "INT_FLOOR_def"
  fun op INT_CEILING_def _ = ()
  val op INT_CEILING_def = TDB.find "INT_CEILING_def"
  fun op is_int_def _ = () val op is_int_def = TDB.find "is_int_def"
  fun op real_of_int_def _ = ()
  val op real_of_int_def = TDB.find "real_of_int_def"
  fun op real_of_int_monotonic _ = ()
  val op real_of_int_monotonic = TDB.find "real_of_int_monotonic"
  fun op INT_FLOOR_BOUNDS _ = ()
  val op INT_FLOOR_BOUNDS = TDB.find "INT_FLOOR_BOUNDS"
  fun op INT_FLOOR _ = () val op INT_FLOOR = TDB.find "INT_FLOOR"
  fun op INT_CEILING_INT_FLOOR _ = ()
  val op INT_CEILING_INT_FLOOR = TDB.find "INT_CEILING_INT_FLOOR"
  fun op INT_CEILING_BOUNDS _ = ()
  val op INT_CEILING_BOUNDS = TDB.find "INT_CEILING_BOUNDS"
  fun op INT_CEILING _ = () val op INT_CEILING = TDB.find "INT_CEILING"
  fun op INT_FLOOR_EQNS _ = ()
  val op INT_FLOOR_EQNS = TDB.find "INT_FLOOR_EQNS"
  fun op INT_FLOOR_compute _ = ()
  val op INT_FLOOR_compute = TDB.find "INT_FLOOR_compute"
  fun op real_of_int_num _ = ()
  val op real_of_int_num = TDB.find "real_of_int_num"
  fun op real_of_int_add _ = ()
  val op real_of_int_add = TDB.find "real_of_int_add"
  fun op real_of_int_neg _ = ()
  val op real_of_int_neg = TDB.find "real_of_int_neg"
  fun op real_of_int_sub _ = ()
  val op real_of_int_sub = TDB.find "real_of_int_sub"
  fun op real_of_int_mul _ = ()
  val op real_of_int_mul = TDB.find "real_of_int_mul"
  fun op real_of_int_lt _ = ()
  val op real_of_int_lt = TDB.find "real_of_int_lt"
  fun op real_of_int_11 _ = ()
  val op real_of_int_11 = TDB.find "real_of_int_11"
  fun op real_of_int_le _ = ()
  val op real_of_int_le = TDB.find "real_of_int_le"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val intreal_grammars = merge_grammars ["real", "Omega", "int_arith"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="intreal"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val intreal_grammars = 
    Portable.## (addtyUDs,addtmUDs) intreal_grammars
  val _ = Parse.grammarDB_insert("intreal",intreal_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "intreal"

end
