structure limTheory :> limTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading limTheory ... "
    else ()
  
  open Type Term Thm
  local open seqTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "lim"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/limTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op tends_real_real _ = ()
  val op tends_real_real = TDB.find "tends_real_real"
  fun op diffl _ = () val op diffl = TDB.find "diffl"
  fun op contl _ = () val op contl = TDB.find "contl"
  fun op differentiable _ = ()
  val op differentiable = TDB.find "differentiable"
  fun op LIM _ = () val op LIM = TDB.find "LIM"
  fun op LIM_CONST _ = () val op LIM_CONST = TDB.find "LIM_CONST"
  fun op LIM_ADD _ = () val op LIM_ADD = TDB.find "LIM_ADD"
  fun op LIM_MUL _ = () val op LIM_MUL = TDB.find "LIM_MUL"
  fun op LIM_NEG _ = () val op LIM_NEG = TDB.find "LIM_NEG"
  fun op LIM_INV _ = () val op LIM_INV = TDB.find "LIM_INV"
  fun op LIM_SUB _ = () val op LIM_SUB = TDB.find "LIM_SUB"
  fun op LIM_DIV _ = () val op LIM_DIV = TDB.find "LIM_DIV"
  fun op LIM_NULL _ = () val op LIM_NULL = TDB.find "LIM_NULL"
  fun op LIM_X _ = () val op LIM_X = TDB.find "LIM_X"
  fun op LIM_UNIQ _ = () val op LIM_UNIQ = TDB.find "LIM_UNIQ"
  fun op LIM_EQUAL _ = () val op LIM_EQUAL = TDB.find "LIM_EQUAL"
  fun op LIM_TRANSFORM _ = ()
  val op LIM_TRANSFORM = TDB.find "LIM_TRANSFORM"
  fun op DIFF_UNIQ _ = () val op DIFF_UNIQ = TDB.find "DIFF_UNIQ"
  fun op DIFF_CONT _ = () val op DIFF_CONT = TDB.find "DIFF_CONT"
  fun op CONTL_LIM _ = () val op CONTL_LIM = TDB.find "CONTL_LIM"
  fun op DIFF_CARAT _ = () val op DIFF_CARAT = TDB.find "DIFF_CARAT"
  fun op CONT_CONST _ = () val op CONT_CONST = TDB.find "CONT_CONST"
  fun op CONT_ADD _ = () val op CONT_ADD = TDB.find "CONT_ADD"
  fun op CONT_MUL _ = () val op CONT_MUL = TDB.find "CONT_MUL"
  fun op CONT_NEG _ = () val op CONT_NEG = TDB.find "CONT_NEG"
  fun op CONT_INV _ = () val op CONT_INV = TDB.find "CONT_INV"
  fun op CONT_SUB _ = () val op CONT_SUB = TDB.find "CONT_SUB"
  fun op CONT_DIV _ = () val op CONT_DIV = TDB.find "CONT_DIV"
  fun op CONT_COMPOSE _ = () val op CONT_COMPOSE = TDB.find "CONT_COMPOSE"
  fun op IVT _ = () val op IVT = TDB.find "IVT"
  fun op IVT2 _ = () val op IVT2 = TDB.find "IVT2"
  fun op DIFF_CONST _ = () val op DIFF_CONST = TDB.find "DIFF_CONST"
  fun op DIFF_ADD _ = () val op DIFF_ADD = TDB.find "DIFF_ADD"
  fun op DIFF_MUL _ = () val op DIFF_MUL = TDB.find "DIFF_MUL"
  fun op DIFF_CMUL _ = () val op DIFF_CMUL = TDB.find "DIFF_CMUL"
  fun op DIFF_NEG _ = () val op DIFF_NEG = TDB.find "DIFF_NEG"
  fun op DIFF_SUB _ = () val op DIFF_SUB = TDB.find "DIFF_SUB"
  fun op DIFF_CHAIN _ = () val op DIFF_CHAIN = TDB.find "DIFF_CHAIN"
  fun op DIFF_X _ = () val op DIFF_X = TDB.find "DIFF_X"
  fun op DIFF_POW _ = () val op DIFF_POW = TDB.find "DIFF_POW"
  fun op DIFF_XM1 _ = () val op DIFF_XM1 = TDB.find "DIFF_XM1"
  fun op DIFF_INV _ = () val op DIFF_INV = TDB.find "DIFF_INV"
  fun op DIFF_DIV _ = () val op DIFF_DIV = TDB.find "DIFF_DIV"
  fun op DIFF_SUM _ = () val op DIFF_SUM = TDB.find "DIFF_SUM"
  fun op CONT_BOUNDED _ = () val op CONT_BOUNDED = TDB.find "CONT_BOUNDED"
  fun op CONT_HASSUP _ = () val op CONT_HASSUP = TDB.find "CONT_HASSUP"
  fun op CONT_ATTAINS _ = () val op CONT_ATTAINS = TDB.find "CONT_ATTAINS"
  fun op CONT_ATTAINS2 _ = ()
  val op CONT_ATTAINS2 = TDB.find "CONT_ATTAINS2"
  fun op CONT_ATTAINS_ALL _ = ()
  val op CONT_ATTAINS_ALL = TDB.find "CONT_ATTAINS_ALL"
  fun op DIFF_LINC _ = () val op DIFF_LINC = TDB.find "DIFF_LINC"
  fun op DIFF_LDEC _ = () val op DIFF_LDEC = TDB.find "DIFF_LDEC"
  fun op DIFF_LMAX _ = () val op DIFF_LMAX = TDB.find "DIFF_LMAX"
  fun op DIFF_LMIN _ = () val op DIFF_LMIN = TDB.find "DIFF_LMIN"
  fun op DIFF_LCONST _ = () val op DIFF_LCONST = TDB.find "DIFF_LCONST"
  fun op INTERVAL_LEMMA _ = ()
  val op INTERVAL_LEMMA = TDB.find "INTERVAL_LEMMA"
  fun op ROLLE _ = () val op ROLLE = TDB.find "ROLLE"
  fun op MVT_LEMMA _ = () val op MVT_LEMMA = TDB.find "MVT_LEMMA"
  fun op MVT _ = () val op MVT = TDB.find "MVT"
  fun op DIFF_ISCONST_END _ = ()
  val op DIFF_ISCONST_END = TDB.find "DIFF_ISCONST_END"
  fun op DIFF_ISCONST _ = () val op DIFF_ISCONST = TDB.find "DIFF_ISCONST"
  fun op DIFF_ISCONST_ALL _ = ()
  val op DIFF_ISCONST_ALL = TDB.find "DIFF_ISCONST_ALL"
  fun op INTERVAL_ABS _ = () val op INTERVAL_ABS = TDB.find "INTERVAL_ABS"
  fun op CONT_INJ_LEMMA _ = ()
  val op CONT_INJ_LEMMA = TDB.find "CONT_INJ_LEMMA"
  fun op CONT_INJ_LEMMA2 _ = ()
  val op CONT_INJ_LEMMA2 = TDB.find "CONT_INJ_LEMMA2"
  fun op CONT_INJ_RANGE _ = ()
  val op CONT_INJ_RANGE = TDB.find "CONT_INJ_RANGE"
  fun op CONT_INVERSE _ = () val op CONT_INVERSE = TDB.find "CONT_INVERSE"
  fun op DIFF_INVERSE _ = () val op DIFF_INVERSE = TDB.find "DIFF_INVERSE"
  fun op DIFF_INVERSE_LT _ = ()
  val op DIFF_INVERSE_LT = TDB.find "DIFF_INVERSE_LT"
  fun op INTERVAL_CLEMMA _ = ()
  val op INTERVAL_CLEMMA = TDB.find "INTERVAL_CLEMMA"
  fun op DIFF_INVERSE_OPEN _ = ()
  val op DIFF_INVERSE_OPEN = TDB.find "DIFF_INVERSE_OPEN"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val lim_grammars = merge_grammars ["seq"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="lim"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val lim_grammars = 
    Portable.## (addtyUDs,addtmUDs) lim_grammars
  val _ = Parse.grammarDB_insert("lim",lim_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "lim"

end
