structure metricTheory :> metricTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading metricTheory ... "
    else ()
  
  open Type Term Thm
  local open realTheory topologyTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "metric"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/metricTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ismet _ = () val op ismet = TDB.find "ismet"
  fun op metric_TY_DEF _ = ()
  val op metric_TY_DEF = TDB.find "metric_TY_DEF"
  fun op metric_tybij _ = () val op metric_tybij = TDB.find "metric_tybij"
  fun op mtop _ = () val op mtop = TDB.find "mtop"
  fun op ball _ = () val op ball = TDB.find "ball"
  fun op mr1 _ = () val op mr1 = TDB.find "mr1"
  fun op METRIC_ISMET _ = () val op METRIC_ISMET = TDB.find "METRIC_ISMET"
  fun op METRIC_ZERO _ = () val op METRIC_ZERO = TDB.find "METRIC_ZERO"
  fun op METRIC_SAME _ = () val op METRIC_SAME = TDB.find "METRIC_SAME"
  fun op METRIC_POS _ = () val op METRIC_POS = TDB.find "METRIC_POS"
  fun op METRIC_SYM _ = () val op METRIC_SYM = TDB.find "METRIC_SYM"
  fun op METRIC_TRIANGLE _ = ()
  val op METRIC_TRIANGLE = TDB.find "METRIC_TRIANGLE"
  fun op METRIC_NZ _ = () val op METRIC_NZ = TDB.find "METRIC_NZ"
  fun op mtop_istopology _ = ()
  val op mtop_istopology = TDB.find "mtop_istopology"
  fun op MTOP_OPEN _ = () val op MTOP_OPEN = TDB.find "MTOP_OPEN"
  fun op BALL_OPEN _ = () val op BALL_OPEN = TDB.find "BALL_OPEN"
  fun op BALL_NEIGH _ = () val op BALL_NEIGH = TDB.find "BALL_NEIGH"
  fun op MTOP_LIMPT _ = () val op MTOP_LIMPT = TDB.find "MTOP_LIMPT"
  fun op ISMET_R1 _ = () val op ISMET_R1 = TDB.find "ISMET_R1"
  fun op MR1_DEF _ = () val op MR1_DEF = TDB.find "MR1_DEF"
  fun op MR1_ADD _ = () val op MR1_ADD = TDB.find "MR1_ADD"
  fun op MR1_SUB _ = () val op MR1_SUB = TDB.find "MR1_SUB"
  fun op MR1_ADD_POS _ = () val op MR1_ADD_POS = TDB.find "MR1_ADD_POS"
  fun op MR1_SUB_LE _ = () val op MR1_SUB_LE = TDB.find "MR1_SUB_LE"
  fun op MR1_ADD_LT _ = () val op MR1_ADD_LT = TDB.find "MR1_ADD_LT"
  fun op MR1_SUB_LT _ = () val op MR1_SUB_LT = TDB.find "MR1_SUB_LT"
  fun op MR1_BETWEEN1 _ = () val op MR1_BETWEEN1 = TDB.find "MR1_BETWEEN1"
  fun op MR1_LIMPT _ = () val op MR1_LIMPT = TDB.find "MR1_LIMPT"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val metric_grammars = merge_grammars ["real", "topology"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="metric"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val metric_grammars = 
    Portable.## (addtyUDs,addtmUDs) metric_grammars
  val _ = Parse.grammarDB_insert("metric",metric_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "metric"

end
