structure netsTheory :> netsTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading netsTheory ... "
    else ()
  
  open Type Term Thm
  local open metricTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "nets"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/netsTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op dorder _ = () val op dorder = TDB.find "dorder"
  fun op tends _ = () val op tends = TDB.find "tends"
  fun op bounded _ = () val op bounded = TDB.find "bounded"
  fun op tendsto _ = () val op tendsto = TDB.find "tendsto"
  fun op DORDER_LEMMA _ = () val op DORDER_LEMMA = TDB.find "DORDER_LEMMA"
  fun op DORDER_NGE _ = () val op DORDER_NGE = TDB.find "DORDER_NGE"
  fun op DORDER_TENDSTO _ = ()
  val op DORDER_TENDSTO = TDB.find "DORDER_TENDSTO"
  fun op MTOP_TENDS _ = () val op MTOP_TENDS = TDB.find "MTOP_TENDS"
  fun op MTOP_TENDS_UNIQ _ = ()
  val op MTOP_TENDS_UNIQ = TDB.find "MTOP_TENDS_UNIQ"
  fun op SEQ_TENDS _ = () val op SEQ_TENDS = TDB.find "SEQ_TENDS"
  fun op LIM_TENDS _ = () val op LIM_TENDS = TDB.find "LIM_TENDS"
  fun op LIM_TENDS2 _ = () val op LIM_TENDS2 = TDB.find "LIM_TENDS2"
  fun op MR1_BOUNDED _ = () val op MR1_BOUNDED = TDB.find "MR1_BOUNDED"
  fun op NET_NULL _ = () val op NET_NULL = TDB.find "NET_NULL"
  fun op NET_CONV_BOUNDED _ = ()
  val op NET_CONV_BOUNDED = TDB.find "NET_CONV_BOUNDED"
  fun op NET_CONV_NZ _ = () val op NET_CONV_NZ = TDB.find "NET_CONV_NZ"
  fun op NET_CONV_IBOUNDED _ = ()
  val op NET_CONV_IBOUNDED = TDB.find "NET_CONV_IBOUNDED"
  fun op NET_NULL_ADD _ = () val op NET_NULL_ADD = TDB.find "NET_NULL_ADD"
  fun op NET_NULL_MUL _ = () val op NET_NULL_MUL = TDB.find "NET_NULL_MUL"
  fun op NET_NULL_CMUL _ = ()
  val op NET_NULL_CMUL = TDB.find "NET_NULL_CMUL"
  fun op NET_ADD _ = () val op NET_ADD = TDB.find "NET_ADD"
  fun op NET_NEG _ = () val op NET_NEG = TDB.find "NET_NEG"
  fun op NET_SUB _ = () val op NET_SUB = TDB.find "NET_SUB"
  fun op NET_MUL _ = () val op NET_MUL = TDB.find "NET_MUL"
  fun op NET_INV _ = () val op NET_INV = TDB.find "NET_INV"
  fun op NET_DIV _ = () val op NET_DIV = TDB.find "NET_DIV"
  fun op NET_ABS _ = () val op NET_ABS = TDB.find "NET_ABS"
  fun op NET_LE _ = () val op NET_LE = TDB.find "NET_LE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val nets_grammars = merge_grammars ["metric"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="nets"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val nets_grammars = 
    Portable.## (addtyUDs,addtmUDs) nets_grammars
  val _ = Parse.grammarDB_insert("nets",nets_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "nets"

end
