structure polyTheory :> polyTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading polyTheory ... "
    else ()
  
  open Type Term Thm
  local open limTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "poly"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/polyTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op poly_def _ = () val op poly_def = TDB.find "poly_def"
  fun op poly_add_def _ = () val op poly_add_def = TDB.find "poly_add_def"
  fun op poly_cmul_def _ = ()
  val op poly_cmul_def = TDB.find "poly_cmul_def"
  fun op poly_neg_def _ = () val op poly_neg_def = TDB.find "poly_neg_def"
  fun op poly_mul_def _ = () val op poly_mul_def = TDB.find "poly_mul_def"
  fun op poly_exp_def _ = () val op poly_exp_def = TDB.find "poly_exp_def"
  fun op poly_diff_aux_def _ = ()
  val op poly_diff_aux_def = TDB.find "poly_diff_aux_def"
  fun op poly_diff_def _ = ()
  val op poly_diff_def = TDB.find "poly_diff_def"
  fun op poly_divides _ = () val op poly_divides = TDB.find "poly_divides"
  fun op poly_order _ = () val op poly_order = TDB.find "poly_order"
  fun op rsquarefree _ = () val op rsquarefree = TDB.find "rsquarefree"
  fun op normalize _ = () val op normalize = TDB.find "normalize"
  fun op degree _ = () val op degree = TDB.find "degree"
  fun op POLY_ADD_CLAUSES _ = ()
  val op POLY_ADD_CLAUSES = TDB.find "POLY_ADD_CLAUSES"
  fun op POLY_CMUL_CLAUSES _ = ()
  val op POLY_CMUL_CLAUSES = TDB.find "POLY_CMUL_CLAUSES"
  fun op POLY_NEG_CLAUSES _ = ()
  val op POLY_NEG_CLAUSES = TDB.find "POLY_NEG_CLAUSES"
  fun op POLY_MUL_CLAUSES _ = ()
  val op POLY_MUL_CLAUSES = TDB.find "POLY_MUL_CLAUSES"
  fun op POLY_DIFF_CLAUSES _ = ()
  val op POLY_DIFF_CLAUSES = TDB.find "POLY_DIFF_CLAUSES"
  fun op POLY_ADD _ = () val op POLY_ADD = TDB.find "POLY_ADD"
  fun op POLY_CMUL _ = () val op POLY_CMUL = TDB.find "POLY_CMUL"
  fun op POLY_NEG _ = () val op POLY_NEG = TDB.find "POLY_NEG"
  fun op POLY_MUL _ = () val op POLY_MUL = TDB.find "POLY_MUL"
  fun op POLY_EXP _ = () val op POLY_EXP = TDB.find "POLY_EXP"
  fun op POLY_DIFF_LEMMA _ = ()
  val op POLY_DIFF_LEMMA = TDB.find "POLY_DIFF_LEMMA"
  fun op POLY_DIFF _ = () val op POLY_DIFF = TDB.find "POLY_DIFF"
  fun op POLY_DIFFERENTIABLE _ = ()
  val op POLY_DIFFERENTIABLE = TDB.find "POLY_DIFFERENTIABLE"
  fun op POLY_CONT _ = () val op POLY_CONT = TDB.find "POLY_CONT"
  fun op POLY_IVT_POS _ = () val op POLY_IVT_POS = TDB.find "POLY_IVT_POS"
  fun op POLY_IVT_NEG _ = () val op POLY_IVT_NEG = TDB.find "POLY_IVT_NEG"
  fun op POLY_MVT _ = () val op POLY_MVT = TDB.find "POLY_MVT"
  fun op POLY_ADD_RZERO _ = ()
  val op POLY_ADD_RZERO = TDB.find "POLY_ADD_RZERO"
  fun op POLY_MUL_ASSOC _ = ()
  val op POLY_MUL_ASSOC = TDB.find "POLY_MUL_ASSOC"
  fun op POLY_EXP_ADD _ = () val op POLY_EXP_ADD = TDB.find "POLY_EXP_ADD"
  fun op POLY_DIFF_AUX_ADD _ = ()
  val op POLY_DIFF_AUX_ADD = TDB.find "POLY_DIFF_AUX_ADD"
  fun op POLY_DIFF_AUX_CMUL _ = ()
  val op POLY_DIFF_AUX_CMUL = TDB.find "POLY_DIFF_AUX_CMUL"
  fun op POLY_DIFF_AUX_NEG _ = ()
  val op POLY_DIFF_AUX_NEG = TDB.find "POLY_DIFF_AUX_NEG"
  fun op POLY_DIFF_AUX_MUL_LEMMA _ = ()
  val op POLY_DIFF_AUX_MUL_LEMMA = TDB.find "POLY_DIFF_AUX_MUL_LEMMA"
  fun op POLY_DIFF_ADD _ = ()
  val op POLY_DIFF_ADD = TDB.find "POLY_DIFF_ADD"
  fun op POLY_DIFF_CMUL _ = ()
  val op POLY_DIFF_CMUL = TDB.find "POLY_DIFF_CMUL"
  fun op POLY_DIFF_NEG _ = ()
  val op POLY_DIFF_NEG = TDB.find "POLY_DIFF_NEG"
  fun op POLY_DIFF_MUL_LEMMA _ = ()
  val op POLY_DIFF_MUL_LEMMA = TDB.find "POLY_DIFF_MUL_LEMMA"
  fun op POLY_DIFF_MUL _ = ()
  val op POLY_DIFF_MUL = TDB.find "POLY_DIFF_MUL"
  fun op POLY_DIFF_EXP _ = ()
  val op POLY_DIFF_EXP = TDB.find "POLY_DIFF_EXP"
  fun op POLY_DIFF_EXP_PRIME _ = ()
  val op POLY_DIFF_EXP_PRIME = TDB.find "POLY_DIFF_EXP_PRIME"
  fun op POLY_LINEAR_REM _ = ()
  val op POLY_LINEAR_REM = TDB.find "POLY_LINEAR_REM"
  fun op POLY_LINEAR_DIVIDES _ = ()
  val op POLY_LINEAR_DIVIDES = TDB.find "POLY_LINEAR_DIVIDES"
  fun op POLY_LENGTH_MUL _ = ()
  val op POLY_LENGTH_MUL = TDB.find "POLY_LENGTH_MUL"
  fun op POLY_ROOTS_INDEX_LEMMA _ = ()
  val op POLY_ROOTS_INDEX_LEMMA = TDB.find "POLY_ROOTS_INDEX_LEMMA"
  fun op POLY_ROOTS_INDEX_LENGTH _ = ()
  val op POLY_ROOTS_INDEX_LENGTH = TDB.find "POLY_ROOTS_INDEX_LENGTH"
  fun op POLY_ROOTS_FINITE_LEMMA _ = ()
  val op POLY_ROOTS_FINITE_LEMMA = TDB.find "POLY_ROOTS_FINITE_LEMMA"
  fun op FINITE_LEMMA _ = () val op FINITE_LEMMA = TDB.find "FINITE_LEMMA"
  fun op POLY_ROOTS_FINITE _ = ()
  val op POLY_ROOTS_FINITE = TDB.find "POLY_ROOTS_FINITE"
  fun op POLY_ENTIRE_LEMMA _ = ()
  val op POLY_ENTIRE_LEMMA = TDB.find "POLY_ENTIRE_LEMMA"
  fun op POLY_ENTIRE _ = () val op POLY_ENTIRE = TDB.find "POLY_ENTIRE"
  fun op POLY_MUL_LCANCEL _ = ()
  val op POLY_MUL_LCANCEL = TDB.find "POLY_MUL_LCANCEL"
  fun op POLY_EXP_EQ_0 _ = ()
  val op POLY_EXP_EQ_0 = TDB.find "POLY_EXP_EQ_0"
  fun op POLY_PRIME_EQ_0 _ = ()
  val op POLY_PRIME_EQ_0 = TDB.find "POLY_PRIME_EQ_0"
  fun op POLY_EXP_PRIME_EQ_0 _ = ()
  val op POLY_EXP_PRIME_EQ_0 = TDB.find "POLY_EXP_PRIME_EQ_0"
  fun op POLY_ZERO_LEMMA _ = ()
  val op POLY_ZERO_LEMMA = TDB.find "POLY_ZERO_LEMMA"
  fun op POLY_ZERO _ = () val op POLY_ZERO = TDB.find "POLY_ZERO"
  fun op POLY_DIFF_AUX_ISZERO _ = ()
  val op POLY_DIFF_AUX_ISZERO = TDB.find "POLY_DIFF_AUX_ISZERO"
  fun op POLY_DIFF_ISZERO _ = ()
  val op POLY_DIFF_ISZERO = TDB.find "POLY_DIFF_ISZERO"
  fun op POLY_DIFF_ZERO _ = ()
  val op POLY_DIFF_ZERO = TDB.find "POLY_DIFF_ZERO"
  fun op POLY_DIFF_WELLDEF _ = ()
  val op POLY_DIFF_WELLDEF = TDB.find "POLY_DIFF_WELLDEF"
  fun op POLY_PRIMES _ = () val op POLY_PRIMES = TDB.find "POLY_PRIMES"
  fun op POLY_DIVIDES_REFL _ = ()
  val op POLY_DIVIDES_REFL = TDB.find "POLY_DIVIDES_REFL"
  fun op POLY_DIVIDES_TRANS _ = ()
  val op POLY_DIVIDES_TRANS = TDB.find "POLY_DIVIDES_TRANS"
  fun op POLY_DIVIDES_EXP _ = ()
  val op POLY_DIVIDES_EXP = TDB.find "POLY_DIVIDES_EXP"
  fun op POLY_EXP_DIVIDES _ = ()
  val op POLY_EXP_DIVIDES = TDB.find "POLY_EXP_DIVIDES"
  fun op POLY_DIVIDES_ADD _ = ()
  val op POLY_DIVIDES_ADD = TDB.find "POLY_DIVIDES_ADD"
  fun op POLY_DIVIDES_SUB _ = ()
  val op POLY_DIVIDES_SUB = TDB.find "POLY_DIVIDES_SUB"
  fun op POLY_DIVIDES_SUB2 _ = ()
  val op POLY_DIVIDES_SUB2 = TDB.find "POLY_DIVIDES_SUB2"
  fun op POLY_DIVIDES_ZERO _ = ()
  val op POLY_DIVIDES_ZERO = TDB.find "POLY_DIVIDES_ZERO"
  fun op POLY_ORDER_EXISTS _ = ()
  val op POLY_ORDER_EXISTS = TDB.find "POLY_ORDER_EXISTS"
  fun op POLY_ORDER _ = () val op POLY_ORDER = TDB.find "POLY_ORDER"
  fun op ORDER _ = () val op ORDER = TDB.find "ORDER"
  fun op ORDER_THM _ = () val op ORDER_THM = TDB.find "ORDER_THM"
  fun op ORDER_UNIQUE _ = () val op ORDER_UNIQUE = TDB.find "ORDER_UNIQUE"
  fun op ORDER_POLY _ = () val op ORDER_POLY = TDB.find "ORDER_POLY"
  fun op ORDER_ROOT _ = () val op ORDER_ROOT = TDB.find "ORDER_ROOT"
  fun op ORDER_DIVIDES _ = ()
  val op ORDER_DIVIDES = TDB.find "ORDER_DIVIDES"
  fun op ORDER_DECOMP _ = () val op ORDER_DECOMP = TDB.find "ORDER_DECOMP"
  fun op ORDER_MUL _ = () val op ORDER_MUL = TDB.find "ORDER_MUL"
  fun op ORDER_DIFF _ = () val op ORDER_DIFF = TDB.find "ORDER_DIFF"
  fun op POLY_SQUAREFREE_DECOMP_ORDER _ = ()
  val op POLY_SQUAREFREE_DECOMP_ORDER = TDB.find
    "POLY_SQUAREFREE_DECOMP_ORDER"
  fun op RSQUAREFREE_ROOTS _ = ()
  val op RSQUAREFREE_ROOTS = TDB.find "RSQUAREFREE_ROOTS"
  fun op RSQUAREFREE_DECOMP _ = ()
  val op RSQUAREFREE_DECOMP = TDB.find "RSQUAREFREE_DECOMP"
  fun op POLY_SQUAREFREE_DECOMP _ = ()
  val op POLY_SQUAREFREE_DECOMP = TDB.find "POLY_SQUAREFREE_DECOMP"
  fun op POLY_NORMALIZE _ = ()
  val op POLY_NORMALIZE = TDB.find "POLY_NORMALIZE"
  fun op DEGREE_ZERO _ = () val op DEGREE_ZERO = TDB.find "DEGREE_ZERO"
  fun op POLY_ROOTS_FINITE_SET _ = ()
  val op POLY_ROOTS_FINITE_SET = TDB.find "POLY_ROOTS_FINITE_SET"
  fun op POLY_MONO _ = () val op POLY_MONO = TDB.find "POLY_MONO"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val poly_grammars = merge_grammars ["lim"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="poly"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val poly_grammars = 
    Portable.## (addtyUDs,addtmUDs) poly_grammars
  val _ = Parse.grammarDB_insert("poly",poly_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "poly"

end
