structure powserTheory :> powserTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading powserTheory ... "
    else ()
  
  open Type Term Thm
  local open limTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "powser"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/powserTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op diffs _ = () val op diffs = TDB.find "diffs"
  fun op POWDIFF_LEMMA _ = ()
  val op POWDIFF_LEMMA = TDB.find "POWDIFF_LEMMA"
  fun op POWDIFF _ = () val op POWDIFF = TDB.find "POWDIFF"
  fun op POWREV _ = () val op POWREV = TDB.find "POWREV"
  fun op POWSER_INSIDEA _ = ()
  val op POWSER_INSIDEA = TDB.find "POWSER_INSIDEA"
  fun op POWSER_INSIDE _ = ()
  val op POWSER_INSIDE = TDB.find "POWSER_INSIDE"
  fun op DIFFS_NEG _ = () val op DIFFS_NEG = TDB.find "DIFFS_NEG"
  fun op DIFFS_LEMMA _ = () val op DIFFS_LEMMA = TDB.find "DIFFS_LEMMA"
  fun op DIFFS_LEMMA2 _ = () val op DIFFS_LEMMA2 = TDB.find "DIFFS_LEMMA2"
  fun op DIFFS_EQUIV _ = () val op DIFFS_EQUIV = TDB.find "DIFFS_EQUIV"
  fun op TERMDIFF_LEMMA1 _ = ()
  val op TERMDIFF_LEMMA1 = TDB.find "TERMDIFF_LEMMA1"
  fun op TERMDIFF_LEMMA2 _ = ()
  val op TERMDIFF_LEMMA2 = TDB.find "TERMDIFF_LEMMA2"
  fun op TERMDIFF_LEMMA3 _ = ()
  val op TERMDIFF_LEMMA3 = TDB.find "TERMDIFF_LEMMA3"
  fun op TERMDIFF_LEMMA4 _ = ()
  val op TERMDIFF_LEMMA4 = TDB.find "TERMDIFF_LEMMA4"
  fun op TERMDIFF_LEMMA5 _ = ()
  val op TERMDIFF_LEMMA5 = TDB.find "TERMDIFF_LEMMA5"
  fun op TERMDIFF _ = () val op TERMDIFF = TDB.find "TERMDIFF"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val powser_grammars = merge_grammars ["lim"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="powser"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val powser_grammars = 
    Portable.## (addtyUDs,addtmUDs) powser_grammars
  val _ = Parse.grammarDB_insert("powser",powser_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "powser"

end
