structure realTheory :> realTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading realTheory ... "
    else ()
  
  open Type Term Thm
  local open realaxTheory realPP in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "real"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/realTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op real_of_num _ = () val op real_of_num = TDB.find "real_of_num"
  fun op real_sub _ = () val op real_sub = TDB.find "real_sub"
  fun op real_lte _ = () val op real_lte = TDB.find "real_lte"
  fun op real_gt _ = () val op real_gt = TDB.find "real_gt"
  fun op real_ge _ = () val op real_ge = TDB.find "real_ge"
  fun op real_div _ = () val op real_div = TDB.find "real_div"
  fun op abs _ = () val op abs = TDB.find "abs"
  fun op pow _ = () val op pow = TDB.find "pow"
  fun op sup _ = () val op sup = TDB.find "sup"
  fun op pos_def _ = () val op pos_def = TDB.find "pos_def"
  fun op min_def _ = () val op min_def = TDB.find "min_def"
  fun op max_def _ = () val op max_def = TDB.find "max_def"
  fun op inf_def _ = () val op inf_def = TDB.find "inf_def"
  fun op NUM_FLOOR_def _ = ()
  val op NUM_FLOOR_def = TDB.find "NUM_FLOOR_def"
  fun op NUM_CEILING_def _ = ()
  val op NUM_CEILING_def = TDB.find "NUM_CEILING_def"
  fun op REAL_0 _ = () val op REAL_0 = TDB.find "REAL_0"
  fun op REAL_1 _ = () val op REAL_1 = TDB.find "REAL_1"
  fun op REAL_10 _ = () val op REAL_10 = TDB.find "REAL_10"
  fun op REAL_ADD_SYM _ = () val op REAL_ADD_SYM = TDB.find "REAL_ADD_SYM"
  fun op REAL_ADD_COMM _ = ()
  val op REAL_ADD_COMM = TDB.find "REAL_ADD_COMM"
  fun op REAL_ADD_ASSOC _ = ()
  val op REAL_ADD_ASSOC = TDB.find "REAL_ADD_ASSOC"
  fun op REAL_ADD_LID _ = () val op REAL_ADD_LID = TDB.find "REAL_ADD_LID"
  fun op REAL_ADD_LINV _ = ()
  val op REAL_ADD_LINV = TDB.find "REAL_ADD_LINV"
  fun op REAL_LDISTRIB _ = ()
  val op REAL_LDISTRIB = TDB.find "REAL_LDISTRIB"
  fun op REAL_LT_TOTAL _ = ()
  val op REAL_LT_TOTAL = TDB.find "REAL_LT_TOTAL"
  fun op REAL_LT_REFL _ = () val op REAL_LT_REFL = TDB.find "REAL_LT_REFL"
  fun op REAL_LT_TRANS _ = ()
  val op REAL_LT_TRANS = TDB.find "REAL_LT_TRANS"
  fun op REAL_LT_IADD _ = () val op REAL_LT_IADD = TDB.find "REAL_LT_IADD"
  fun op REAL_SUP_ALLPOS _ = ()
  val op REAL_SUP_ALLPOS = TDB.find "REAL_SUP_ALLPOS"
  fun op REAL_MUL_SYM _ = () val op REAL_MUL_SYM = TDB.find "REAL_MUL_SYM"
  fun op REAL_MUL_COMM _ = ()
  val op REAL_MUL_COMM = TDB.find "REAL_MUL_COMM"
  fun op REAL_MUL_ASSOC _ = ()
  val op REAL_MUL_ASSOC = TDB.find "REAL_MUL_ASSOC"
  fun op REAL_MUL_LID _ = () val op REAL_MUL_LID = TDB.find "REAL_MUL_LID"
  fun op REAL_MUL_LINV _ = ()
  val op REAL_MUL_LINV = TDB.find "REAL_MUL_LINV"
  fun op REAL_LT_MUL _ = () val op REAL_LT_MUL = TDB.find "REAL_LT_MUL"
  fun op REAL_INV_0 _ = () val op REAL_INV_0 = TDB.find "REAL_INV_0"
  fun op REAL_ADD_RID _ = () val op REAL_ADD_RID = TDB.find "REAL_ADD_RID"
  fun op REAL_ADD_RINV _ = ()
  val op REAL_ADD_RINV = TDB.find "REAL_ADD_RINV"
  fun op REAL_MUL_RID _ = () val op REAL_MUL_RID = TDB.find "REAL_MUL_RID"
  fun op REAL_MUL_RINV _ = ()
  val op REAL_MUL_RINV = TDB.find "REAL_MUL_RINV"
  fun op REAL_RDISTRIB _ = ()
  val op REAL_RDISTRIB = TDB.find "REAL_RDISTRIB"
  fun op REAL_EQ_LADD _ = () val op REAL_EQ_LADD = TDB.find "REAL_EQ_LADD"
  fun op REAL_EQ_RADD _ = () val op REAL_EQ_RADD = TDB.find "REAL_EQ_RADD"
  fun op REAL_ADD_LID_UNIQ _ = ()
  val op REAL_ADD_LID_UNIQ = TDB.find "REAL_ADD_LID_UNIQ"
  fun op REAL_ADD_RID_UNIQ _ = ()
  val op REAL_ADD_RID_UNIQ = TDB.find "REAL_ADD_RID_UNIQ"
  fun op REAL_LNEG_UNIQ _ = ()
  val op REAL_LNEG_UNIQ = TDB.find "REAL_LNEG_UNIQ"
  fun op REAL_RNEG_UNIQ _ = ()
  val op REAL_RNEG_UNIQ = TDB.find "REAL_RNEG_UNIQ"
  fun op REAL_NEG_ADD _ = () val op REAL_NEG_ADD = TDB.find "REAL_NEG_ADD"
  fun op REAL_MUL_LZERO _ = ()
  val op REAL_MUL_LZERO = TDB.find "REAL_MUL_LZERO"
  fun op REAL_MUL_RZERO _ = ()
  val op REAL_MUL_RZERO = TDB.find "REAL_MUL_RZERO"
  fun op REAL_NEG_LMUL _ = ()
  val op REAL_NEG_LMUL = TDB.find "REAL_NEG_LMUL"
  fun op REAL_NEG_RMUL _ = ()
  val op REAL_NEG_RMUL = TDB.find "REAL_NEG_RMUL"
  fun op REAL_NEGNEG _ = () val op REAL_NEGNEG = TDB.find "REAL_NEGNEG"
  fun op REAL_NEG_MUL2 _ = ()
  val op REAL_NEG_MUL2 = TDB.find "REAL_NEG_MUL2"
  fun op REAL_ENTIRE _ = () val op REAL_ENTIRE = TDB.find "REAL_ENTIRE"
  fun op REAL_LT_LADD _ = () val op REAL_LT_LADD = TDB.find "REAL_LT_LADD"
  fun op REAL_LT_RADD _ = () val op REAL_LT_RADD = TDB.find "REAL_LT_RADD"
  fun op REAL_NOT_LT _ = () val op REAL_NOT_LT = TDB.find "REAL_NOT_LT"
  fun op REAL_LT_ANTISYM _ = ()
  val op REAL_LT_ANTISYM = TDB.find "REAL_LT_ANTISYM"
  fun op REAL_LT_GT _ = () val op REAL_LT_GT = TDB.find "REAL_LT_GT"
  fun op REAL_NOT_LE _ = () val op REAL_NOT_LE = TDB.find "REAL_NOT_LE"
  fun op REAL_LE_TOTAL _ = ()
  val op REAL_LE_TOTAL = TDB.find "REAL_LE_TOTAL"
  fun op REAL_LET_TOTAL _ = ()
  val op REAL_LET_TOTAL = TDB.find "REAL_LET_TOTAL"
  fun op REAL_LTE_TOTAL _ = ()
  val op REAL_LTE_TOTAL = TDB.find "REAL_LTE_TOTAL"
  fun op REAL_LE_REFL _ = () val op REAL_LE_REFL = TDB.find "REAL_LE_REFL"
  fun op REAL_LE_LT _ = () val op REAL_LE_LT = TDB.find "REAL_LE_LT"
  fun op REAL_LT_LE _ = () val op REAL_LT_LE = TDB.find "REAL_LT_LE"
  fun op REAL_LT_IMP_LE _ = ()
  val op REAL_LT_IMP_LE = TDB.find "REAL_LT_IMP_LE"
  fun op REAL_LTE_TRANS _ = ()
  val op REAL_LTE_TRANS = TDB.find "REAL_LTE_TRANS"
  fun op REAL_LET_TRANS _ = ()
  val op REAL_LET_TRANS = TDB.find "REAL_LET_TRANS"
  fun op REAL_LE_TRANS _ = ()
  val op REAL_LE_TRANS = TDB.find "REAL_LE_TRANS"
  fun op REAL_LE_ANTISYM _ = ()
  val op REAL_LE_ANTISYM = TDB.find "REAL_LE_ANTISYM"
  fun op REAL_LET_ANTISYM _ = ()
  val op REAL_LET_ANTISYM = TDB.find "REAL_LET_ANTISYM"
  fun op REAL_LTE_ANTISYM _ = ()
  val op REAL_LTE_ANTISYM = TDB.find "REAL_LTE_ANTISYM"
  fun op REAL_LTE_ANTSYM _ = ()
  val op REAL_LTE_ANTSYM = TDB.find "REAL_LTE_ANTSYM"
  fun op REAL_NEG_LT0 _ = () val op REAL_NEG_LT0 = TDB.find "REAL_NEG_LT0"
  fun op REAL_NEG_GT0 _ = () val op REAL_NEG_GT0 = TDB.find "REAL_NEG_GT0"
  fun op REAL_NEG_LE0 _ = () val op REAL_NEG_LE0 = TDB.find "REAL_NEG_LE0"
  fun op REAL_NEG_GE0 _ = () val op REAL_NEG_GE0 = TDB.find "REAL_NEG_GE0"
  fun op REAL_LT_NEGTOTAL _ = ()
  val op REAL_LT_NEGTOTAL = TDB.find "REAL_LT_NEGTOTAL"
  fun op REAL_LE_NEGTOTAL _ = ()
  val op REAL_LE_NEGTOTAL = TDB.find "REAL_LE_NEGTOTAL"
  fun op REAL_LE_MUL _ = () val op REAL_LE_MUL = TDB.find "REAL_LE_MUL"
  fun op REAL_LE_SQUARE _ = ()
  val op REAL_LE_SQUARE = TDB.find "REAL_LE_SQUARE"
  fun op REAL_LE_01 _ = () val op REAL_LE_01 = TDB.find "REAL_LE_01"
  fun op REAL_LT_01 _ = () val op REAL_LT_01 = TDB.find "REAL_LT_01"
  fun op REAL_LE_LADD _ = () val op REAL_LE_LADD = TDB.find "REAL_LE_LADD"
  fun op REAL_LE_RADD _ = () val op REAL_LE_RADD = TDB.find "REAL_LE_RADD"
  fun op REAL_LT_ADD2 _ = () val op REAL_LT_ADD2 = TDB.find "REAL_LT_ADD2"
  fun op REAL_LE_ADD2 _ = () val op REAL_LE_ADD2 = TDB.find "REAL_LE_ADD2"
  fun op REAL_LE_ADD _ = () val op REAL_LE_ADD = TDB.find "REAL_LE_ADD"
  fun op REAL_LT_ADD _ = () val op REAL_LT_ADD = TDB.find "REAL_LT_ADD"
  fun op REAL_LT_ADDNEG _ = ()
  val op REAL_LT_ADDNEG = TDB.find "REAL_LT_ADDNEG"
  fun op REAL_LT_ADDNEG2 _ = ()
  val op REAL_LT_ADDNEG2 = TDB.find "REAL_LT_ADDNEG2"
  fun op REAL_LT_ADD1 _ = () val op REAL_LT_ADD1 = TDB.find "REAL_LT_ADD1"
  fun op REAL_SUB_ADD _ = () val op REAL_SUB_ADD = TDB.find "REAL_SUB_ADD"
  fun op REAL_SUB_ADD2 _ = ()
  val op REAL_SUB_ADD2 = TDB.find "REAL_SUB_ADD2"
  fun op REAL_SUB_REFL _ = ()
  val op REAL_SUB_REFL = TDB.find "REAL_SUB_REFL"
  fun op REAL_SUB_0 _ = () val op REAL_SUB_0 = TDB.find "REAL_SUB_0"
  fun op REAL_LE_DOUBLE _ = ()
  val op REAL_LE_DOUBLE = TDB.find "REAL_LE_DOUBLE"
  fun op REAL_LE_NEGL _ = () val op REAL_LE_NEGL = TDB.find "REAL_LE_NEGL"
  fun op REAL_LE_NEGR _ = () val op REAL_LE_NEGR = TDB.find "REAL_LE_NEGR"
  fun op REAL_NEG_EQ0 _ = () val op REAL_NEG_EQ0 = TDB.find "REAL_NEG_EQ0"
  fun op REAL_NEG_0 _ = () val op REAL_NEG_0 = TDB.find "REAL_NEG_0"
  fun op REAL_NEG_SUB _ = () val op REAL_NEG_SUB = TDB.find "REAL_NEG_SUB"
  fun op REAL_SUB_LT _ = () val op REAL_SUB_LT = TDB.find "REAL_SUB_LT"
  fun op REAL_SUB_LE _ = () val op REAL_SUB_LE = TDB.find "REAL_SUB_LE"
  fun op REAL_ADD_SUB _ = () val op REAL_ADD_SUB = TDB.find "REAL_ADD_SUB"
  fun op REAL_EQ_LMUL _ = () val op REAL_EQ_LMUL = TDB.find "REAL_EQ_LMUL"
  fun op REAL_EQ_RMUL _ = () val op REAL_EQ_RMUL = TDB.find "REAL_EQ_RMUL"
  fun op REAL_SUB_LDISTRIB _ = ()
  val op REAL_SUB_LDISTRIB = TDB.find "REAL_SUB_LDISTRIB"
  fun op REAL_SUB_RDISTRIB _ = ()
  val op REAL_SUB_RDISTRIB = TDB.find "REAL_SUB_RDISTRIB"
  fun op REAL_NEG_EQ _ = () val op REAL_NEG_EQ = TDB.find "REAL_NEG_EQ"
  fun op REAL_NEG_MINUS1 _ = ()
  val op REAL_NEG_MINUS1 = TDB.find "REAL_NEG_MINUS1"
  fun op REAL_INV_NZ _ = () val op REAL_INV_NZ = TDB.find "REAL_INV_NZ"
  fun op REAL_INVINV _ = () val op REAL_INVINV = TDB.find "REAL_INVINV"
  fun op REAL_LT_IMP_NE _ = ()
  val op REAL_LT_IMP_NE = TDB.find "REAL_LT_IMP_NE"
  fun op REAL_INV_POS _ = () val op REAL_INV_POS = TDB.find "REAL_INV_POS"
  fun op REAL_LT_LMUL_0 _ = ()
  val op REAL_LT_LMUL_0 = TDB.find "REAL_LT_LMUL_0"
  fun op REAL_LT_RMUL_0 _ = ()
  val op REAL_LT_RMUL_0 = TDB.find "REAL_LT_RMUL_0"
  fun op REAL_LT_LMUL _ = () val op REAL_LT_LMUL = TDB.find "REAL_LT_LMUL"
  fun op REAL_LT_RMUL _ = () val op REAL_LT_RMUL = TDB.find "REAL_LT_RMUL"
  fun op REAL_LT_RMUL_IMP _ = ()
  val op REAL_LT_RMUL_IMP = TDB.find "REAL_LT_RMUL_IMP"
  fun op REAL_LT_LMUL_IMP _ = ()
  val op REAL_LT_LMUL_IMP = TDB.find "REAL_LT_LMUL_IMP"
  fun op REAL_LINV_UNIQ _ = ()
  val op REAL_LINV_UNIQ = TDB.find "REAL_LINV_UNIQ"
  fun op REAL_RINV_UNIQ _ = ()
  val op REAL_RINV_UNIQ = TDB.find "REAL_RINV_UNIQ"
  fun op REAL_INV_INV _ = () val op REAL_INV_INV = TDB.find "REAL_INV_INV"
  fun op REAL_INV_EQ_0 _ = ()
  val op REAL_INV_EQ_0 = TDB.find "REAL_INV_EQ_0"
  fun op REAL_NEG_INV _ = () val op REAL_NEG_INV = TDB.find "REAL_NEG_INV"
  fun op REAL_INV_1OVER _ = ()
  val op REAL_INV_1OVER = TDB.find "REAL_INV_1OVER"
  fun op REAL_LT_INV_EQ _ = ()
  val op REAL_LT_INV_EQ = TDB.find "REAL_LT_INV_EQ"
  fun op REAL_LE_INV_EQ _ = ()
  val op REAL_LE_INV_EQ = TDB.find "REAL_LE_INV_EQ"
  fun op REAL_LE_INV _ = () val op REAL_LE_INV = TDB.find "REAL_LE_INV"
  fun op REAL_LE_ADDR _ = () val op REAL_LE_ADDR = TDB.find "REAL_LE_ADDR"
  fun op REAL_LE_ADDL _ = () val op REAL_LE_ADDL = TDB.find "REAL_LE_ADDL"
  fun op REAL_LT_ADDR _ = () val op REAL_LT_ADDR = TDB.find "REAL_LT_ADDR"
  fun op REAL_LT_ADDL _ = () val op REAL_LT_ADDL = TDB.find "REAL_LT_ADDL"
  fun op REAL _ = () val op REAL = TDB.find "REAL"
  fun op REAL_POS _ = () val op REAL_POS = TDB.find "REAL_POS"
  fun op REAL_LE _ = () val op REAL_LE = TDB.find "REAL_LE"
  fun op REAL_LT _ = () val op REAL_LT = TDB.find "REAL_LT"
  fun op REAL_INJ _ = () val op REAL_INJ = TDB.find "REAL_INJ"
  fun op REAL_ADD _ = () val op REAL_ADD = TDB.find "REAL_ADD"
  fun op REAL_MUL _ = () val op REAL_MUL = TDB.find "REAL_MUL"
  fun op REAL_INV1 _ = () val op REAL_INV1 = TDB.find "REAL_INV1"
  fun op REAL_OVER1 _ = () val op REAL_OVER1 = TDB.find "REAL_OVER1"
  fun op REAL_DIV_REFL _ = ()
  val op REAL_DIV_REFL = TDB.find "REAL_DIV_REFL"
  fun op REAL_DIV_LZERO _ = ()
  val op REAL_DIV_LZERO = TDB.find "REAL_DIV_LZERO"
  fun op REAL_LT_NZ _ = () val op REAL_LT_NZ = TDB.find "REAL_LT_NZ"
  fun op REAL_NZ_IMP_LT _ = ()
  val op REAL_NZ_IMP_LT = TDB.find "REAL_NZ_IMP_LT"
  fun op REAL_LT_RDIV_0 _ = ()
  val op REAL_LT_RDIV_0 = TDB.find "REAL_LT_RDIV_0"
  fun op REAL_LT_RDIV _ = () val op REAL_LT_RDIV = TDB.find "REAL_LT_RDIV"
  fun op REAL_LT_FRACTION_0 _ = ()
  val op REAL_LT_FRACTION_0 = TDB.find "REAL_LT_FRACTION_0"
  fun op REAL_LT_MULTIPLE _ = ()
  val op REAL_LT_MULTIPLE = TDB.find "REAL_LT_MULTIPLE"
  fun op REAL_LT_FRACTION _ = ()
  val op REAL_LT_FRACTION = TDB.find "REAL_LT_FRACTION"
  fun op REAL_LT_HALF1 _ = ()
  val op REAL_LT_HALF1 = TDB.find "REAL_LT_HALF1"
  fun op REAL_LT_HALF2 _ = ()
  val op REAL_LT_HALF2 = TDB.find "REAL_LT_HALF2"
  fun op REAL_DOUBLE _ = () val op REAL_DOUBLE = TDB.find "REAL_DOUBLE"
  fun op REAL_DIV_LMUL _ = ()
  val op REAL_DIV_LMUL = TDB.find "REAL_DIV_LMUL"
  fun op REAL_DIV_RMUL _ = ()
  val op REAL_DIV_RMUL = TDB.find "REAL_DIV_RMUL"
  fun op REAL_HALF_DOUBLE _ = ()
  val op REAL_HALF_DOUBLE = TDB.find "REAL_HALF_DOUBLE"
  fun op REAL_DOWN _ = () val op REAL_DOWN = TDB.find "REAL_DOWN"
  fun op REAL_DOWN2 _ = () val op REAL_DOWN2 = TDB.find "REAL_DOWN2"
  fun op REAL_SUB_SUB _ = () val op REAL_SUB_SUB = TDB.find "REAL_SUB_SUB"
  fun op REAL_LT_ADD_SUB _ = ()
  val op REAL_LT_ADD_SUB = TDB.find "REAL_LT_ADD_SUB"
  fun op REAL_LT_SUB_RADD _ = ()
  val op REAL_LT_SUB_RADD = TDB.find "REAL_LT_SUB_RADD"
  fun op REAL_LT_SUB_LADD _ = ()
  val op REAL_LT_SUB_LADD = TDB.find "REAL_LT_SUB_LADD"
  fun op REAL_LE_SUB_LADD _ = ()
  val op REAL_LE_SUB_LADD = TDB.find "REAL_LE_SUB_LADD"
  fun op REAL_LE_SUB_RADD _ = ()
  val op REAL_LE_SUB_RADD = TDB.find "REAL_LE_SUB_RADD"
  fun op REAL_LT_NEG _ = () val op REAL_LT_NEG = TDB.find "REAL_LT_NEG"
  fun op REAL_LE_NEG _ = () val op REAL_LE_NEG = TDB.find "REAL_LE_NEG"
  fun op REAL_ADD2_SUB2 _ = ()
  val op REAL_ADD2_SUB2 = TDB.find "REAL_ADD2_SUB2"
  fun op REAL_SUB_LZERO _ = ()
  val op REAL_SUB_LZERO = TDB.find "REAL_SUB_LZERO"
  fun op REAL_SUB_RZERO _ = ()
  val op REAL_SUB_RZERO = TDB.find "REAL_SUB_RZERO"
  fun op REAL_LET_ADD2 _ = ()
  val op REAL_LET_ADD2 = TDB.find "REAL_LET_ADD2"
  fun op REAL_LTE_ADD2 _ = ()
  val op REAL_LTE_ADD2 = TDB.find "REAL_LTE_ADD2"
  fun op REAL_LET_ADD _ = () val op REAL_LET_ADD = TDB.find "REAL_LET_ADD"
  fun op REAL_LTE_ADD _ = () val op REAL_LTE_ADD = TDB.find "REAL_LTE_ADD"
  fun op REAL_LT_MUL2 _ = () val op REAL_LT_MUL2 = TDB.find "REAL_LT_MUL2"
  fun op REAL_LT_INV _ = () val op REAL_LT_INV = TDB.find "REAL_LT_INV"
  fun op REAL_SUB_LNEG _ = ()
  val op REAL_SUB_LNEG = TDB.find "REAL_SUB_LNEG"
  fun op REAL_SUB_RNEG _ = ()
  val op REAL_SUB_RNEG = TDB.find "REAL_SUB_RNEG"
  fun op REAL_SUB_NEG2 _ = ()
  val op REAL_SUB_NEG2 = TDB.find "REAL_SUB_NEG2"
  fun op REAL_SUB_TRIANGLE _ = ()
  val op REAL_SUB_TRIANGLE = TDB.find "REAL_SUB_TRIANGLE"
  fun op REAL_EQ_SUB_LADD _ = ()
  val op REAL_EQ_SUB_LADD = TDB.find "REAL_EQ_SUB_LADD"
  fun op REAL_EQ_SUB_RADD _ = ()
  val op REAL_EQ_SUB_RADD = TDB.find "REAL_EQ_SUB_RADD"
  fun op REAL_INV_MUL _ = () val op REAL_INV_MUL = TDB.find "REAL_INV_MUL"
  fun op REAL_LE_LMUL _ = () val op REAL_LE_LMUL = TDB.find "REAL_LE_LMUL"
  fun op REAL_LE_RMUL _ = () val op REAL_LE_RMUL = TDB.find "REAL_LE_RMUL"
  fun op REAL_SUB_INV2 _ = ()
  val op REAL_SUB_INV2 = TDB.find "REAL_SUB_INV2"
  fun op REAL_SUB_SUB2 _ = ()
  val op REAL_SUB_SUB2 = TDB.find "REAL_SUB_SUB2"
  fun op REAL_ADD_SUB2 _ = ()
  val op REAL_ADD_SUB2 = TDB.find "REAL_ADD_SUB2"
  fun op REAL_MEAN _ = () val op REAL_MEAN = TDB.find "REAL_MEAN"
  fun op REAL_EQ_LMUL2 _ = ()
  val op REAL_EQ_LMUL2 = TDB.find "REAL_EQ_LMUL2"
  fun op REAL_LE_MUL2 _ = () val op REAL_LE_MUL2 = TDB.find "REAL_LE_MUL2"
  fun op REAL_LE_LDIV _ = () val op REAL_LE_LDIV = TDB.find "REAL_LE_LDIV"
  fun op REAL_LE_RDIV _ = () val op REAL_LE_RDIV = TDB.find "REAL_LE_RDIV"
  fun op REAL_LT_DIV _ = () val op REAL_LT_DIV = TDB.find "REAL_LT_DIV"
  fun op REAL_LE_DIV _ = () val op REAL_LE_DIV = TDB.find "REAL_LE_DIV"
  fun op REAL_LT_1 _ = () val op REAL_LT_1 = TDB.find "REAL_LT_1"
  fun op REAL_LE_LMUL_IMP _ = ()
  val op REAL_LE_LMUL_IMP = TDB.find "REAL_LE_LMUL_IMP"
  fun op REAL_LE_RMUL_IMP _ = ()
  val op REAL_LE_RMUL_IMP = TDB.find "REAL_LE_RMUL_IMP"
  fun op REAL_EQ_IMP_LE _ = ()
  val op REAL_EQ_IMP_LE = TDB.find "REAL_EQ_IMP_LE"
  fun op REAL_INV_LT1 _ = () val op REAL_INV_LT1 = TDB.find "REAL_INV_LT1"
  fun op REAL_POS_NZ _ = () val op REAL_POS_NZ = TDB.find "REAL_POS_NZ"
  fun op REAL_EQ_RMUL_IMP _ = ()
  val op REAL_EQ_RMUL_IMP = TDB.find "REAL_EQ_RMUL_IMP"
  fun op REAL_EQ_LMUL_IMP _ = ()
  val op REAL_EQ_LMUL_IMP = TDB.find "REAL_EQ_LMUL_IMP"
  fun op REAL_FACT_NZ _ = () val op REAL_FACT_NZ = TDB.find "REAL_FACT_NZ"
  fun op REAL_DIFFSQ _ = () val op REAL_DIFFSQ = TDB.find "REAL_DIFFSQ"
  fun op REAL_POASQ _ = () val op REAL_POASQ = TDB.find "REAL_POASQ"
  fun op REAL_SUMSQ _ = () val op REAL_SUMSQ = TDB.find "REAL_SUMSQ"
  fun op REAL_EQ_NEG _ = () val op REAL_EQ_NEG = TDB.find "REAL_EQ_NEG"
  fun op REAL_DIV_MUL2 _ = ()
  val op REAL_DIV_MUL2 = TDB.find "REAL_DIV_MUL2"
  fun op REAL_MIDDLE1 _ = () val op REAL_MIDDLE1 = TDB.find "REAL_MIDDLE1"
  fun op REAL_MIDDLE2 _ = () val op REAL_MIDDLE2 = TDB.find "REAL_MIDDLE2"
  fun op ABS_ZERO _ = () val op ABS_ZERO = TDB.find "ABS_ZERO"
  fun op ABS_0 _ = () val op ABS_0 = TDB.find "ABS_0"
  fun op ABS_1 _ = () val op ABS_1 = TDB.find "ABS_1"
  fun op ABS_NEG _ = () val op ABS_NEG = TDB.find "ABS_NEG"
  fun op ABS_TRIANGLE _ = () val op ABS_TRIANGLE = TDB.find "ABS_TRIANGLE"
  fun op ABS_TRIANGLE_NEG _ = ()
  val op ABS_TRIANGLE_NEG = TDB.find "ABS_TRIANGLE_NEG"
  fun op ABS_TRIANGLE_SUB _ = ()
  val op ABS_TRIANGLE_SUB = TDB.find "ABS_TRIANGLE_SUB"
  fun op ABS_TRIANGLE_LT _ = ()
  val op ABS_TRIANGLE_LT = TDB.find "ABS_TRIANGLE_LT"
  fun op ABS_POS _ = () val op ABS_POS = TDB.find "ABS_POS"
  fun op ABS_MUL _ = () val op ABS_MUL = TDB.find "ABS_MUL"
  fun op ABS_LT_MUL2 _ = () val op ABS_LT_MUL2 = TDB.find "ABS_LT_MUL2"
  fun op ABS_SUB _ = () val op ABS_SUB = TDB.find "ABS_SUB"
  fun op ABS_NZ _ = () val op ABS_NZ = TDB.find "ABS_NZ"
  fun op ABS_INV _ = () val op ABS_INV = TDB.find "ABS_INV"
  fun op ABS_ABS _ = () val op ABS_ABS = TDB.find "ABS_ABS"
  fun op ABS_LE _ = () val op ABS_LE = TDB.find "ABS_LE"
  fun op ABS_REFL _ = () val op ABS_REFL = TDB.find "ABS_REFL"
  fun op ABS_N _ = () val op ABS_N = TDB.find "ABS_N"
  fun op ABS_BETWEEN _ = () val op ABS_BETWEEN = TDB.find "ABS_BETWEEN"
  fun op ABS_BOUND _ = () val op ABS_BOUND = TDB.find "ABS_BOUND"
  fun op ABS_STILLNZ _ = () val op ABS_STILLNZ = TDB.find "ABS_STILLNZ"
  fun op ABS_CASES _ = () val op ABS_CASES = TDB.find "ABS_CASES"
  fun op ABS_BETWEEN1 _ = () val op ABS_BETWEEN1 = TDB.find "ABS_BETWEEN1"
  fun op ABS_SIGN _ = () val op ABS_SIGN = TDB.find "ABS_SIGN"
  fun op ABS_SIGN2 _ = () val op ABS_SIGN2 = TDB.find "ABS_SIGN2"
  fun op ABS_DIV _ = () val op ABS_DIV = TDB.find "ABS_DIV"
  fun op ABS_CIRCLE _ = () val op ABS_CIRCLE = TDB.find "ABS_CIRCLE"
  fun op REAL_SUB_ABS _ = () val op REAL_SUB_ABS = TDB.find "REAL_SUB_ABS"
  fun op ABS_SUB_ABS _ = () val op ABS_SUB_ABS = TDB.find "ABS_SUB_ABS"
  fun op ABS_BETWEEN2 _ = () val op ABS_BETWEEN2 = TDB.find "ABS_BETWEEN2"
  fun op ABS_BOUNDS _ = () val op ABS_BOUNDS = TDB.find "ABS_BOUNDS"
  fun op POW_0 _ = () val op POW_0 = TDB.find "POW_0"
  fun op POW_NZ _ = () val op POW_NZ = TDB.find "POW_NZ"
  fun op POW_INV _ = () val op POW_INV = TDB.find "POW_INV"
  fun op POW_ABS _ = () val op POW_ABS = TDB.find "POW_ABS"
  fun op POW_PLUS1 _ = () val op POW_PLUS1 = TDB.find "POW_PLUS1"
  fun op POW_ADD _ = () val op POW_ADD = TDB.find "POW_ADD"
  fun op POW_1 _ = () val op POW_1 = TDB.find "POW_1"
  fun op POW_2 _ = () val op POW_2 = TDB.find "POW_2"
  fun op POW_ONE _ = () val op POW_ONE = TDB.find "POW_ONE"
  fun op POW_POS _ = () val op POW_POS = TDB.find "POW_POS"
  fun op POW_LE _ = () val op POW_LE = TDB.find "POW_LE"
  fun op POW_M1 _ = () val op POW_M1 = TDB.find "POW_M1"
  fun op POW_MUL _ = () val op POW_MUL = TDB.find "POW_MUL"
  fun op REAL_LE_POW2 _ = () val op REAL_LE_POW2 = TDB.find "REAL_LE_POW2"
  fun op ABS_POW2 _ = () val op ABS_POW2 = TDB.find "ABS_POW2"
  fun op REAL_POW2_ABS _ = ()
  val op REAL_POW2_ABS = TDB.find "REAL_POW2_ABS"
  fun op REAL_LE1_POW2 _ = ()
  val op REAL_LE1_POW2 = TDB.find "REAL_LE1_POW2"
  fun op REAL_LT1_POW2 _ = ()
  val op REAL_LT1_POW2 = TDB.find "REAL_LT1_POW2"
  fun op POW_POS_LT _ = () val op POW_POS_LT = TDB.find "POW_POS_LT"
  fun op POW_2_LE1 _ = () val op POW_2_LE1 = TDB.find "POW_2_LE1"
  fun op POW_2_LT _ = () val op POW_2_LT = TDB.find "POW_2_LT"
  fun op POW_MINUS1 _ = () val op POW_MINUS1 = TDB.find "POW_MINUS1"
  fun op POW_LT _ = () val op POW_LT = TDB.find "POW_LT"
  fun op REAL_POW_LT _ = () val op REAL_POW_LT = TDB.find "REAL_POW_LT"
  fun op POW_EQ _ = () val op POW_EQ = TDB.find "POW_EQ"
  fun op POW_ZERO _ = () val op POW_ZERO = TDB.find "POW_ZERO"
  fun op POW_ZERO_EQ _ = () val op POW_ZERO_EQ = TDB.find "POW_ZERO_EQ"
  fun op REAL_POW_LT2 _ = () val op REAL_POW_LT2 = TDB.find "REAL_POW_LT2"
  fun op REAL_POW_MONO_LT _ = ()
  val op REAL_POW_MONO_LT = TDB.find "REAL_POW_MONO_LT"
  fun op REAL_POW_POW _ = () val op REAL_POW_POW = TDB.find "REAL_POW_POW"
  fun op REAL_SUP_SOMEPOS _ = ()
  val op REAL_SUP_SOMEPOS = TDB.find "REAL_SUP_SOMEPOS"
  fun op SUP_LEMMA1 _ = () val op SUP_LEMMA1 = TDB.find "SUP_LEMMA1"
  fun op SUP_LEMMA2 _ = () val op SUP_LEMMA2 = TDB.find "SUP_LEMMA2"
  fun op SUP_LEMMA3 _ = () val op SUP_LEMMA3 = TDB.find "SUP_LEMMA3"
  fun op REAL_SUP_EXISTS _ = ()
  val op REAL_SUP_EXISTS = TDB.find "REAL_SUP_EXISTS"
  fun op REAL_SUP _ = () val op REAL_SUP = TDB.find "REAL_SUP"
  fun op REAL_SUP_UBOUND _ = ()
  val op REAL_SUP_UBOUND = TDB.find "REAL_SUP_UBOUND"
  fun op SETOK_LE_LT _ = () val op SETOK_LE_LT = TDB.find "SETOK_LE_LT"
  fun op REAL_SUP_LE _ = () val op REAL_SUP_LE = TDB.find "REAL_SUP_LE"
  fun op REAL_SUP_UBOUND_LE _ = ()
  val op REAL_SUP_UBOUND_LE = TDB.find "REAL_SUP_UBOUND_LE"
  fun op REAL_ARCH _ = () val op REAL_ARCH = TDB.find "REAL_ARCH"
  fun op REAL_ARCH_LEAST _ = ()
  val op REAL_ARCH_LEAST = TDB.find "REAL_ARCH_LEAST"
  fun op SIMP_REAL_ARCH _ = ()
  val op SIMP_REAL_ARCH = TDB.find "SIMP_REAL_ARCH"
  fun op REAL_ARCH_POW _ = ()
  val op REAL_ARCH_POW = TDB.find "REAL_ARCH_POW"
  fun op sum_ind _ = () val op sum_ind = TDB.find "sum_ind"
  fun op sum _ = () val op sum = TDB.find "sum"
  fun op sum_compute _ = () val op sum_compute = TDB.find "sum_compute"
  fun op SUM_TWO _ = () val op SUM_TWO = TDB.find "SUM_TWO"
  fun op SUM_DIFF _ = () val op SUM_DIFF = TDB.find "SUM_DIFF"
  fun op ABS_SUM _ = () val op ABS_SUM = TDB.find "ABS_SUM"
  fun op SUM_LE _ = () val op SUM_LE = TDB.find "SUM_LE"
  fun op SUM_EQ _ = () val op SUM_EQ = TDB.find "SUM_EQ"
  fun op SUM_POS _ = () val op SUM_POS = TDB.find "SUM_POS"
  fun op SUM_POS_GEN _ = () val op SUM_POS_GEN = TDB.find "SUM_POS_GEN"
  fun op SUM_ABS _ = () val op SUM_ABS = TDB.find "SUM_ABS"
  fun op SUM_ABS_LE _ = () val op SUM_ABS_LE = TDB.find "SUM_ABS_LE"
  fun op SUM_ZERO _ = () val op SUM_ZERO = TDB.find "SUM_ZERO"
  fun op SUM_ADD _ = () val op SUM_ADD = TDB.find "SUM_ADD"
  fun op SUM_CMUL _ = () val op SUM_CMUL = TDB.find "SUM_CMUL"
  fun op SUM_NEG _ = () val op SUM_NEG = TDB.find "SUM_NEG"
  fun op SUM_SUB _ = () val op SUM_SUB = TDB.find "SUM_SUB"
  fun op SUM_SUBST _ = () val op SUM_SUBST = TDB.find "SUM_SUBST"
  fun op SUM_NSUB _ = () val op SUM_NSUB = TDB.find "SUM_NSUB"
  fun op SUM_BOUND _ = () val op SUM_BOUND = TDB.find "SUM_BOUND"
  fun op SUM_GROUP _ = () val op SUM_GROUP = TDB.find "SUM_GROUP"
  fun op SUM_1 _ = () val op SUM_1 = TDB.find "SUM_1"
  fun op SUM_2 _ = () val op SUM_2 = TDB.find "SUM_2"
  fun op SUM_OFFSET _ = () val op SUM_OFFSET = TDB.find "SUM_OFFSET"
  fun op SUM_REINDEX _ = () val op SUM_REINDEX = TDB.find "SUM_REINDEX"
  fun op SUM_0 _ = () val op SUM_0 = TDB.find "SUM_0"
  fun op SUM_PERMUTE_0 _ = ()
  val op SUM_PERMUTE_0 = TDB.find "SUM_PERMUTE_0"
  fun op SUM_CANCEL _ = () val op SUM_CANCEL = TDB.find "SUM_CANCEL"
  fun op REAL_MUL_RNEG _ = ()
  val op REAL_MUL_RNEG = TDB.find "REAL_MUL_RNEG"
  fun op REAL_MUL_LNEG _ = ()
  val op REAL_MUL_LNEG = TDB.find "REAL_MUL_LNEG"
  fun op real_lt _ = () val op real_lt = TDB.find "real_lt"
  fun op REAL_LE_LADD_IMP _ = ()
  val op REAL_LE_LADD_IMP = TDB.find "REAL_LE_LADD_IMP"
  fun op REAL_LE_LNEG _ = () val op REAL_LE_LNEG = TDB.find "REAL_LE_LNEG"
  fun op REAL_LE_NEG2 _ = () val op REAL_LE_NEG2 = TDB.find "REAL_LE_NEG2"
  fun op REAL_NEG_NEG _ = () val op REAL_NEG_NEG = TDB.find "REAL_NEG_NEG"
  fun op SIMP_REAL_ARCH_NEG _ = ()
  val op SIMP_REAL_ARCH_NEG = TDB.find "SIMP_REAL_ARCH_NEG"
  fun op REAL_LE_RNEG _ = () val op REAL_LE_RNEG = TDB.find "REAL_LE_RNEG"
  fun op REAL_LT_RNEG _ = () val op REAL_LT_RNEG = TDB.find "REAL_LT_RNEG"
  fun op REAL_POW_INV _ = () val op REAL_POW_INV = TDB.find "REAL_POW_INV"
  fun op REAL_POW_DIV _ = () val op REAL_POW_DIV = TDB.find "REAL_POW_DIV"
  fun op REAL_POW_ADD _ = () val op REAL_POW_ADD = TDB.find "REAL_POW_ADD"
  fun op REAL_LE_RDIV_EQ _ = ()
  val op REAL_LE_RDIV_EQ = TDB.find "REAL_LE_RDIV_EQ"
  fun op REAL_LE_LDIV_EQ _ = ()
  val op REAL_LE_LDIV_EQ = TDB.find "REAL_LE_LDIV_EQ"
  fun op REAL_LT_RDIV_EQ _ = ()
  val op REAL_LT_RDIV_EQ = TDB.find "REAL_LT_RDIV_EQ"
  fun op REAL_LT_LDIV_EQ _ = ()
  val op REAL_LT_LDIV_EQ = TDB.find "REAL_LT_LDIV_EQ"
  fun op REAL_EQ_RDIV_EQ _ = ()
  val op REAL_EQ_RDIV_EQ = TDB.find "REAL_EQ_RDIV_EQ"
  fun op REAL_EQ_LDIV_EQ _ = ()
  val op REAL_EQ_LDIV_EQ = TDB.find "REAL_EQ_LDIV_EQ"
  fun op REAL_OF_NUM_POW _ = ()
  val op REAL_OF_NUM_POW = TDB.find "REAL_OF_NUM_POW"
  fun op REAL_ADD_LDISTRIB _ = ()
  val op REAL_ADD_LDISTRIB = TDB.find "REAL_ADD_LDISTRIB"
  fun op REAL_ADD_RDISTRIB _ = ()
  val op REAL_ADD_RDISTRIB = TDB.find "REAL_ADD_RDISTRIB"
  fun op REAL_OF_NUM_ADD _ = ()
  val op REAL_OF_NUM_ADD = TDB.find "REAL_OF_NUM_ADD"
  fun op REAL_OF_NUM_LE _ = ()
  val op REAL_OF_NUM_LE = TDB.find "REAL_OF_NUM_LE"
  fun op REAL_OF_NUM_MUL _ = ()
  val op REAL_OF_NUM_MUL = TDB.find "REAL_OF_NUM_MUL"
  fun op REAL_OF_NUM_SUC _ = ()
  val op REAL_OF_NUM_SUC = TDB.find "REAL_OF_NUM_SUC"
  fun op REAL_OF_NUM_EQ _ = ()
  val op REAL_OF_NUM_EQ = TDB.find "REAL_OF_NUM_EQ"
  fun op REAL_EQ_MUL_LCANCEL _ = ()
  val op REAL_EQ_MUL_LCANCEL = TDB.find "REAL_EQ_MUL_LCANCEL"
  fun op REAL_ABS_0 _ = () val op REAL_ABS_0 = TDB.find "REAL_ABS_0"
  fun op REAL_ABS_TRIANGLE _ = ()
  val op REAL_ABS_TRIANGLE = TDB.find "REAL_ABS_TRIANGLE"
  fun op REAL_ABS_MUL _ = () val op REAL_ABS_MUL = TDB.find "REAL_ABS_MUL"
  fun op REAL_ABS_POS _ = () val op REAL_ABS_POS = TDB.find "REAL_ABS_POS"
  fun op REAL_LE_EPSILON _ = ()
  val op REAL_LE_EPSILON = TDB.find "REAL_LE_EPSILON"
  fun op REAL_BIGNUM _ = () val op REAL_BIGNUM = TDB.find "REAL_BIGNUM"
  fun op REAL_INV_LT_ANTIMONO _ = ()
  val op REAL_INV_LT_ANTIMONO = TDB.find "REAL_INV_LT_ANTIMONO"
  fun op REAL_INV_INJ _ = () val op REAL_INV_INJ = TDB.find "REAL_INV_INJ"
  fun op REAL_DIV_RMUL_CANCEL _ = ()
  val op REAL_DIV_RMUL_CANCEL = TDB.find "REAL_DIV_RMUL_CANCEL"
  fun op REAL_DIV_LMUL_CANCEL _ = ()
  val op REAL_DIV_LMUL_CANCEL = TDB.find "REAL_DIV_LMUL_CANCEL"
  fun op REAL_DIV_ADD _ = () val op REAL_DIV_ADD = TDB.find "REAL_DIV_ADD"
  fun op REAL_ADD_RAT _ = () val op REAL_ADD_RAT = TDB.find "REAL_ADD_RAT"
  fun op REAL_SUB_RAT _ = () val op REAL_SUB_RAT = TDB.find "REAL_SUB_RAT"
  fun op REAL_SUB _ = () val op REAL_SUB = TDB.find "REAL_SUB"
  fun op REAL_POS_POS _ = () val op REAL_POS_POS = TDB.find "REAL_POS_POS"
  fun op REAL_POS_ID _ = () val op REAL_POS_ID = TDB.find "REAL_POS_ID"
  fun op REAL_POS_INFLATE _ = ()
  val op REAL_POS_INFLATE = TDB.find "REAL_POS_INFLATE"
  fun op REAL_POS_MONO _ = ()
  val op REAL_POS_MONO = TDB.find "REAL_POS_MONO"
  fun op REAL_POS_EQ_ZERO _ = ()
  val op REAL_POS_EQ_ZERO = TDB.find "REAL_POS_EQ_ZERO"
  fun op REAL_POS_LE_ZERO _ = ()
  val op REAL_POS_LE_ZERO = TDB.find "REAL_POS_LE_ZERO"
  fun op REAL_MIN_REFL _ = ()
  val op REAL_MIN_REFL = TDB.find "REAL_MIN_REFL"
  fun op REAL_LE_MIN _ = () val op REAL_LE_MIN = TDB.find "REAL_LE_MIN"
  fun op REAL_MIN_LE _ = () val op REAL_MIN_LE = TDB.find "REAL_MIN_LE"
  fun op REAL_MIN_LE1 _ = () val op REAL_MIN_LE1 = TDB.find "REAL_MIN_LE1"
  fun op REAL_MIN_LE2 _ = () val op REAL_MIN_LE2 = TDB.find "REAL_MIN_LE2"
  fun op REAL_LT_MIN _ = () val op REAL_LT_MIN = TDB.find "REAL_LT_MIN"
  fun op REAL_MIN_LT _ = () val op REAL_MIN_LT = TDB.find "REAL_MIN_LT"
  fun op REAL_MIN_ALT _ = () val op REAL_MIN_ALT = TDB.find "REAL_MIN_ALT"
  fun op REAL_MIN_LE_LIN _ = ()
  val op REAL_MIN_LE_LIN = TDB.find "REAL_MIN_LE_LIN"
  fun op REAL_MIN_ADD _ = () val op REAL_MIN_ADD = TDB.find "REAL_MIN_ADD"
  fun op REAL_MIN_SUB _ = () val op REAL_MIN_SUB = TDB.find "REAL_MIN_SUB"
  fun op REAL_IMP_MIN_LE2 _ = ()
  val op REAL_IMP_MIN_LE2 = TDB.find "REAL_IMP_MIN_LE2"
  fun op REAL_MIN_ACI _ = () val op REAL_MIN_ACI = TDB.find "REAL_MIN_ACI"
  fun op REAL_MAX_REFL _ = ()
  val op REAL_MAX_REFL = TDB.find "REAL_MAX_REFL"
  fun op REAL_LE_MAX _ = () val op REAL_LE_MAX = TDB.find "REAL_LE_MAX"
  fun op REAL_LE_MAX1 _ = () val op REAL_LE_MAX1 = TDB.find "REAL_LE_MAX1"
  fun op REAL_LE_MAX2 _ = () val op REAL_LE_MAX2 = TDB.find "REAL_LE_MAX2"
  fun op REAL_MAX_LE _ = () val op REAL_MAX_LE = TDB.find "REAL_MAX_LE"
  fun op REAL_LT_MAX _ = () val op REAL_LT_MAX = TDB.find "REAL_LT_MAX"
  fun op REAL_MAX_LT _ = () val op REAL_MAX_LT = TDB.find "REAL_MAX_LT"
  fun op REAL_MAX_ALT _ = () val op REAL_MAX_ALT = TDB.find "REAL_MAX_ALT"
  fun op REAL_MAX_MIN _ = () val op REAL_MAX_MIN = TDB.find "REAL_MAX_MIN"
  fun op REAL_MIN_MAX _ = () val op REAL_MIN_MAX = TDB.find "REAL_MIN_MAX"
  fun op REAL_LIN_LE_MAX _ = ()
  val op REAL_LIN_LE_MAX = TDB.find "REAL_LIN_LE_MAX"
  fun op REAL_MAX_ADD _ = () val op REAL_MAX_ADD = TDB.find "REAL_MAX_ADD"
  fun op REAL_MAX_SUB _ = () val op REAL_MAX_SUB = TDB.find "REAL_MAX_SUB"
  fun op REAL_IMP_MAX_LE2 _ = ()
  val op REAL_IMP_MAX_LE2 = TDB.find "REAL_IMP_MAX_LE2"
  fun op REAL_MAX_ACI _ = () val op REAL_MAX_ACI = TDB.find "REAL_MAX_ACI"
  fun op REAL_SUP_EXISTS_UNIQUE _ = ()
  val op REAL_SUP_EXISTS_UNIQUE = TDB.find "REAL_SUP_EXISTS_UNIQUE"
  fun op REAL_SUP_MAX _ = () val op REAL_SUP_MAX = TDB.find "REAL_SUP_MAX"
  fun op REAL_IMP_SUP_LE _ = ()
  val op REAL_IMP_SUP_LE = TDB.find "REAL_IMP_SUP_LE"
  fun op REAL_IMP_LE_SUP _ = ()
  val op REAL_IMP_LE_SUP = TDB.find "REAL_IMP_LE_SUP"
  fun op REAL_INF_MIN _ = () val op REAL_INF_MIN = TDB.find "REAL_INF_MIN"
  fun op REAL_IMP_LE_INF _ = ()
  val op REAL_IMP_LE_INF = TDB.find "REAL_IMP_LE_INF"
  fun op REAL_IMP_INF_LE _ = ()
  val op REAL_IMP_INF_LE = TDB.find "REAL_IMP_INF_LE"
  fun op REAL_INF_LT _ = () val op REAL_INF_LT = TDB.find "REAL_INF_LT"
  fun op REAL_INF_CLOSE _ = ()
  val op REAL_INF_CLOSE = TDB.find "REAL_INF_CLOSE"
  fun op SUP_EPSILON _ = () val op SUP_EPSILON = TDB.find "SUP_EPSILON"
  fun op REAL_LE_SUP _ = () val op REAL_LE_SUP = TDB.find "REAL_LE_SUP"
  fun op REAL_INF_LE _ = () val op REAL_INF_LE = TDB.find "REAL_INF_LE"
  fun op REAL_SUP_CONST _ = ()
  val op REAL_SUP_CONST = TDB.find "REAL_SUP_CONST"
  fun op REAL_MUL_SUB2_CANCEL _ = ()
  val op REAL_MUL_SUB2_CANCEL = TDB.find "REAL_MUL_SUB2_CANCEL"
  fun op REAL_MUL_SUB1_CANCEL _ = ()
  val op REAL_MUL_SUB1_CANCEL = TDB.find "REAL_MUL_SUB1_CANCEL"
  fun op REAL_NEG_HALF _ = ()
  val op REAL_NEG_HALF = TDB.find "REAL_NEG_HALF"
  fun op REAL_NEG_THIRD _ = ()
  val op REAL_NEG_THIRD = TDB.find "REAL_NEG_THIRD"
  fun op REAL_DIV_DENOM_CANCEL _ = ()
  val op REAL_DIV_DENOM_CANCEL = TDB.find "REAL_DIV_DENOM_CANCEL"
  fun op REAL_DIV_DENOM_CANCEL2 _ = ()
  val op REAL_DIV_DENOM_CANCEL2 = TDB.find "REAL_DIV_DENOM_CANCEL2"
  fun op REAL_DIV_DENOM_CANCEL3 _ = ()
  val op REAL_DIV_DENOM_CANCEL3 = TDB.find "REAL_DIV_DENOM_CANCEL3"
  fun op REAL_DIV_INNER_CANCEL _ = ()
  val op REAL_DIV_INNER_CANCEL = TDB.find "REAL_DIV_INNER_CANCEL"
  fun op REAL_DIV_INNER_CANCEL2 _ = ()
  val op REAL_DIV_INNER_CANCEL2 = TDB.find "REAL_DIV_INNER_CANCEL2"
  fun op REAL_DIV_INNER_CANCEL3 _ = ()
  val op REAL_DIV_INNER_CANCEL3 = TDB.find "REAL_DIV_INNER_CANCEL3"
  fun op REAL_DIV_OUTER_CANCEL _ = ()
  val op REAL_DIV_OUTER_CANCEL = TDB.find "REAL_DIV_OUTER_CANCEL"
  fun op REAL_DIV_OUTER_CANCEL2 _ = ()
  val op REAL_DIV_OUTER_CANCEL2 = TDB.find "REAL_DIV_OUTER_CANCEL2"
  fun op REAL_DIV_OUTER_CANCEL3 _ = ()
  val op REAL_DIV_OUTER_CANCEL3 = TDB.find "REAL_DIV_OUTER_CANCEL3"
  fun op REAL_DIV_REFL2 _ = ()
  val op REAL_DIV_REFL2 = TDB.find "REAL_DIV_REFL2"
  fun op REAL_DIV_REFL3 _ = ()
  val op REAL_DIV_REFL3 = TDB.find "REAL_DIV_REFL3"
  fun op REAL_HALF_BETWEEN _ = ()
  val op REAL_HALF_BETWEEN = TDB.find "REAL_HALF_BETWEEN"
  fun op REAL_THIRDS_BETWEEN _ = ()
  val op REAL_THIRDS_BETWEEN = TDB.find "REAL_THIRDS_BETWEEN"
  fun op REAL_LE_SUB_CANCEL2 _ = ()
  val op REAL_LE_SUB_CANCEL2 = TDB.find "REAL_LE_SUB_CANCEL2"
  fun op REAL_ADD_SUB_ALT _ = ()
  val op REAL_ADD_SUB_ALT = TDB.find "REAL_ADD_SUB_ALT"
  fun op INFINITE_REAL_UNIV _ = ()
  val op INFINITE_REAL_UNIV = TDB.find "INFINITE_REAL_UNIV"
  fun op add_rat _ = () val op add_rat = TDB.find "add_rat"
  fun op add_ratl _ = () val op add_ratl = TDB.find "add_ratl"
  fun op add_ratr _ = () val op add_ratr = TDB.find "add_ratr"
  fun op add_ints _ = () val op add_ints = TDB.find "add_ints"
  fun op mult_rat _ = () val op mult_rat = TDB.find "mult_rat"
  fun op mult_ratl _ = () val op mult_ratl = TDB.find "mult_ratl"
  fun op mult_ratr _ = () val op mult_ratr = TDB.find "mult_ratr"
  fun op mult_ints _ = () val op mult_ints = TDB.find "mult_ints"
  fun op pow_rat _ = () val op pow_rat = TDB.find "pow_rat"
  fun op neg_rat _ = () val op neg_rat = TDB.find "neg_rat"
  fun op eq_rat _ = () val op eq_rat = TDB.find "eq_rat"
  fun op eq_ratl _ = () val op eq_ratl = TDB.find "eq_ratl"
  fun op eq_ratr _ = () val op eq_ratr = TDB.find "eq_ratr"
  fun op eq_ints _ = () val op eq_ints = TDB.find "eq_ints"
  fun op div_ratr _ = () val op div_ratr = TDB.find "div_ratr"
  fun op div_ratl _ = () val op div_ratl = TDB.find "div_ratl"
  fun op div_rat _ = () val op div_rat = TDB.find "div_rat"
  fun op le_rat _ = () val op le_rat = TDB.find "le_rat"
  fun op le_ratl _ = () val op le_ratl = TDB.find "le_ratl"
  fun op le_ratr _ = () val op le_ratr = TDB.find "le_ratr"
  fun op le_int _ = () val op le_int = TDB.find "le_int"
  fun op lt_rat _ = () val op lt_rat = TDB.find "lt_rat"
  fun op lt_ratl _ = () val op lt_ratl = TDB.find "lt_ratl"
  fun op lt_ratr _ = () val op lt_ratr = TDB.find "lt_ratr"
  fun op lt_int _ = () val op lt_int = TDB.find "lt_int"
  fun op NUM_FLOOR_LE _ = () val op NUM_FLOOR_LE = TDB.find "NUM_FLOOR_LE"
  fun op NUM_FLOOR_LE2 _ = ()
  val op NUM_FLOOR_LE2 = TDB.find "NUM_FLOOR_LE2"
  fun op NUM_FLOOR_LET _ = ()
  val op NUM_FLOOR_LET = TDB.find "NUM_FLOOR_LET"
  fun op NUM_FLOOR_DIV _ = ()
  val op NUM_FLOOR_DIV = TDB.find "NUM_FLOOR_DIV"
  fun op NUM_FLOOR_DIV_LOWERBOUND _ = ()
  val op NUM_FLOOR_DIV_LOWERBOUND = TDB.find "NUM_FLOOR_DIV_LOWERBOUND"
  fun op NUM_FLOOR_BASE _ = ()
  val op NUM_FLOOR_BASE = TDB.find "NUM_FLOOR_BASE"
  fun op NUM_FLOOR_EQNS _ = ()
  val op NUM_FLOOR_EQNS = TDB.find "NUM_FLOOR_EQNS"
  fun op NUM_FLOOR_LOWER_BOUND _ = ()
  val op NUM_FLOOR_LOWER_BOUND = TDB.find "NUM_FLOOR_LOWER_BOUND"
  fun op NUM_FLOOR_upper_bound _ = ()
  val op NUM_FLOOR_upper_bound = TDB.find "NUM_FLOOR_upper_bound"
  fun op NUM_CEILING_NUM_FLOOR _ = ()
  val op NUM_CEILING_NUM_FLOOR = TDB.find "NUM_CEILING_NUM_FLOOR"
  fun op LE_NUM_CEILING _ = ()
  val op LE_NUM_CEILING = TDB.find "LE_NUM_CEILING"
  fun op NUM_CEILING_LE _ = ()
  val op NUM_CEILING_LE = TDB.find "NUM_CEILING_LE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val real_grammars = merge_grammars ["realax"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="real"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val real_grammars = 
    Portable.## (addtyUDs,addtmUDs) real_grammars
  val _ = Parse.grammarDB_insert("real",real_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "real"

end
