structure real_sigmaTheory :> real_sigmaTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading real_sigmaTheory ... "
    else ()
  
  open Type Term Thm
  local open transcTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "real_sigma"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/real_sigmaTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op REAL_SUM_IMAGE_DEF _ = ()
  val op REAL_SUM_IMAGE_DEF = TDB.find "REAL_SUM_IMAGE_DEF"
  fun op REAL_SUM_IMAGE_THM _ = ()
  val op REAL_SUM_IMAGE_THM = TDB.find "REAL_SUM_IMAGE_THM"
  fun op REAL_SUM_IMAGE_SING _ = ()
  val op REAL_SUM_IMAGE_SING = TDB.find "REAL_SUM_IMAGE_SING"
  fun op REAL_SUM_IMAGE_POS _ = ()
  val op REAL_SUM_IMAGE_POS = TDB.find "REAL_SUM_IMAGE_POS"
  fun op REAL_SUM_IMAGE_SPOS _ = ()
  val op REAL_SUM_IMAGE_SPOS = TDB.find "REAL_SUM_IMAGE_SPOS"
  fun op REAL_SUM_IMAGE_NONZERO _ = ()
  val op REAL_SUM_IMAGE_NONZERO = TDB.find "REAL_SUM_IMAGE_NONZERO"
  fun op REAL_SUM_IMAGE_IF_ELIM _ = ()
  val op REAL_SUM_IMAGE_IF_ELIM = TDB.find "REAL_SUM_IMAGE_IF_ELIM"
  fun op REAL_SUM_IMAGE_FINITE_SAME _ = ()
  val op REAL_SUM_IMAGE_FINITE_SAME = TDB.find "REAL_SUM_IMAGE_FINITE_SAME"
  fun op REAL_SUM_IMAGE_FINITE_CONST _ = ()
  val op REAL_SUM_IMAGE_FINITE_CONST = TDB.find
    "REAL_SUM_IMAGE_FINITE_CONST"
  fun op REAL_SUM_IMAGE_FINITE_CONST2 _ = ()
  val op REAL_SUM_IMAGE_FINITE_CONST2 = TDB.find
    "REAL_SUM_IMAGE_FINITE_CONST2"
  fun op REAL_SUM_IMAGE_FINITE_CONST3 _ = ()
  val op REAL_SUM_IMAGE_FINITE_CONST3 = TDB.find
    "REAL_SUM_IMAGE_FINITE_CONST3"
  fun op REAL_SUM_IMAGE_IN_IF _ = ()
  val op REAL_SUM_IMAGE_IN_IF = TDB.find "REAL_SUM_IMAGE_IN_IF"
  fun op REAL_SUM_IMAGE_CMUL _ = ()
  val op REAL_SUM_IMAGE_CMUL = TDB.find "REAL_SUM_IMAGE_CMUL"
  fun op REAL_SUM_IMAGE_NEG _ = ()
  val op REAL_SUM_IMAGE_NEG = TDB.find "REAL_SUM_IMAGE_NEG"
  fun op REAL_SUM_IMAGE_IMAGE _ = ()
  val op REAL_SUM_IMAGE_IMAGE = TDB.find "REAL_SUM_IMAGE_IMAGE"
  fun op REAL_SUM_IMAGE_DISJOINT_UNION _ = ()
  val op REAL_SUM_IMAGE_DISJOINT_UNION = TDB.find
    "REAL_SUM_IMAGE_DISJOINT_UNION"
  fun op REAL_SUM_IMAGE_EQ_CARD _ = ()
  val op REAL_SUM_IMAGE_EQ_CARD = TDB.find "REAL_SUM_IMAGE_EQ_CARD"
  fun op REAL_SUM_IMAGE_INV_CARD_EQ_1 _ = ()
  val op REAL_SUM_IMAGE_INV_CARD_EQ_1 = TDB.find
    "REAL_SUM_IMAGE_INV_CARD_EQ_1"
  fun op REAL_SUM_IMAGE_INTER_NONZERO _ = ()
  val op REAL_SUM_IMAGE_INTER_NONZERO = TDB.find
    "REAL_SUM_IMAGE_INTER_NONZERO"
  fun op REAL_SUM_IMAGE_INTER_ELIM _ = ()
  val op REAL_SUM_IMAGE_INTER_ELIM = TDB.find "REAL_SUM_IMAGE_INTER_ELIM"
  fun op REAL_SUM_IMAGE_COUNT _ = ()
  val op REAL_SUM_IMAGE_COUNT = TDB.find "REAL_SUM_IMAGE_COUNT"
  fun op REAL_SUM_IMAGE_MONO _ = ()
  val op REAL_SUM_IMAGE_MONO = TDB.find "REAL_SUM_IMAGE_MONO"
  fun op REAL_SUM_IMAGE_POS_MEM_LE _ = ()
  val op REAL_SUM_IMAGE_POS_MEM_LE = TDB.find "REAL_SUM_IMAGE_POS_MEM_LE"
  fun op REAL_SUM_IMAGE_CONST_EQ_1_EQ_INV_CARD _ = ()
  val op REAL_SUM_IMAGE_CONST_EQ_1_EQ_INV_CARD = TDB.find
    "REAL_SUM_IMAGE_CONST_EQ_1_EQ_INV_CARD"
  fun op REAL_SUM_IMAGE_ADD _ = ()
  val op REAL_SUM_IMAGE_ADD = TDB.find "REAL_SUM_IMAGE_ADD"
  fun op REAL_SUM_IMAGE_REAL_SUM_IMAGE _ = ()
  val op REAL_SUM_IMAGE_REAL_SUM_IMAGE = TDB.find
    "REAL_SUM_IMAGE_REAL_SUM_IMAGE"
  fun op REAL_SUM_IMAGE_0 _ = ()
  val op REAL_SUM_IMAGE_0 = TDB.find "REAL_SUM_IMAGE_0"
  fun op SEQ_REAL_SUM_IMAGE _ = ()
  val op SEQ_REAL_SUM_IMAGE = TDB.find "SEQ_REAL_SUM_IMAGE"
  fun op NESTED_REAL_SUM_IMAGE_REVERSE _ = ()
  val op NESTED_REAL_SUM_IMAGE_REVERSE = TDB.find
    "NESTED_REAL_SUM_IMAGE_REVERSE"
  fun op REAL_SUM_IMAGE_EQ_sum _ = ()
  val op REAL_SUM_IMAGE_EQ_sum = TDB.find "REAL_SUM_IMAGE_EQ_sum"
  fun op REAL_SUM_IMAGE_POW _ = ()
  val op REAL_SUM_IMAGE_POW = TDB.find "REAL_SUM_IMAGE_POW"
  fun op REAL_SUM_IMAGE_EQ _ = ()
  val op REAL_SUM_IMAGE_EQ = TDB.find "REAL_SUM_IMAGE_EQ"
  fun op REAL_SUM_IMAGE_IN_IF_ALT _ = ()
  val op REAL_SUM_IMAGE_IN_IF_ALT = TDB.find "REAL_SUM_IMAGE_IN_IF_ALT"
  fun op REAL_SUM_IMAGE_SUB _ = ()
  val op REAL_SUM_IMAGE_SUB = TDB.find "REAL_SUM_IMAGE_SUB"
  fun op REAL_SUM_IMAGE_MONO_SET _ = ()
  val op REAL_SUM_IMAGE_MONO_SET = TDB.find "REAL_SUM_IMAGE_MONO_SET"
  fun op REAL_SUM_IMAGE_CROSS_SYM _ = ()
  val op REAL_SUM_IMAGE_CROSS_SYM = TDB.find "REAL_SUM_IMAGE_CROSS_SYM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val real_sigma_grammars = merge_grammars ["transc"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="real_sigma"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val real_sigma_grammars = 
    Portable.## (addtyUDs,addtmUDs) real_sigma_grammars
  val _ = Parse.grammarDB_insert("real_sigma",real_sigma_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "real_sigma"

end
