structure realaxTheory :> realaxTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading realaxTheory ... "
    else ()
  
  open Type Term Thm
  local open hrealTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "realax"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/realaxTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op treal_0 _ = () val op treal_0 = TDB.find "treal_0"
  fun op treal_1 _ = () val op treal_1 = TDB.find "treal_1"
  fun op treal_neg _ = () val op treal_neg = TDB.find "treal_neg"
  fun op treal_add _ = () val op treal_add = TDB.find "treal_add"
  fun op treal_mul _ = () val op treal_mul = TDB.find "treal_mul"
  fun op treal_lt _ = () val op treal_lt = TDB.find "treal_lt"
  fun op treal_inv _ = () val op treal_inv = TDB.find "treal_inv"
  fun op treal_eq _ = () val op treal_eq = TDB.find "treal_eq"
  fun op treal_of_hreal _ = ()
  val op treal_of_hreal = TDB.find "treal_of_hreal"
  fun op hreal_of_treal _ = ()
  val op hreal_of_treal = TDB.find "hreal_of_treal"
  fun op real_TY_DEF _ = () val op real_TY_DEF = TDB.find "real_TY_DEF"
  fun op real_bijections _ = ()
  val op real_bijections = TDB.find "real_bijections"
  fun op real_REP_def _ = () val op real_REP_def = TDB.find "real_REP_def"
  fun op real_ABS_def _ = () val op real_ABS_def = TDB.find "real_ABS_def"
  fun op real_0 _ = () val op real_0 = TDB.find "real_0"
  fun op real_1 _ = () val op real_1 = TDB.find "real_1"
  fun op real_neg _ = () val op real_neg = TDB.find "real_neg"
  fun op real_inv _ = () val op real_inv = TDB.find "real_inv"
  fun op real_add _ = () val op real_add = TDB.find "real_add"
  fun op real_mul _ = () val op real_mul = TDB.find "real_mul"
  fun op real_lt _ = () val op real_lt = TDB.find "real_lt"
  fun op real_of_hreal _ = ()
  val op real_of_hreal = TDB.find "real_of_hreal"
  fun op hreal_of_real _ = ()
  val op hreal_of_real = TDB.find "hreal_of_real"
  fun op HREAL_RDISTRIB _ = ()
  val op HREAL_RDISTRIB = TDB.find "HREAL_RDISTRIB"
  fun op HREAL_EQ_ADDR _ = ()
  val op HREAL_EQ_ADDR = TDB.find "HREAL_EQ_ADDR"
  fun op HREAL_EQ_ADDL _ = ()
  val op HREAL_EQ_ADDL = TDB.find "HREAL_EQ_ADDL"
  fun op HREAL_EQ_LADD _ = ()
  val op HREAL_EQ_LADD = TDB.find "HREAL_EQ_LADD"
  fun op HREAL_LT_REFL _ = ()
  val op HREAL_LT_REFL = TDB.find "HREAL_LT_REFL"
  fun op HREAL_LT_ADDL _ = ()
  val op HREAL_LT_ADDL = TDB.find "HREAL_LT_ADDL"
  fun op HREAL_LT_NE _ = () val op HREAL_LT_NE = TDB.find "HREAL_LT_NE"
  fun op HREAL_LT_ADDR _ = ()
  val op HREAL_LT_ADDR = TDB.find "HREAL_LT_ADDR"
  fun op HREAL_LT_GT _ = () val op HREAL_LT_GT = TDB.find "HREAL_LT_GT"
  fun op HREAL_LT_ADD2 _ = ()
  val op HREAL_LT_ADD2 = TDB.find "HREAL_LT_ADD2"
  fun op HREAL_LT_LADD _ = ()
  val op HREAL_LT_LADD = TDB.find "HREAL_LT_LADD"
  fun op TREAL_EQ_REFL _ = ()
  val op TREAL_EQ_REFL = TDB.find "TREAL_EQ_REFL"
  fun op TREAL_EQ_SYM _ = () val op TREAL_EQ_SYM = TDB.find "TREAL_EQ_SYM"
  fun op TREAL_EQ_TRANS _ = ()
  val op TREAL_EQ_TRANS = TDB.find "TREAL_EQ_TRANS"
  fun op TREAL_EQ_EQUIV _ = ()
  val op TREAL_EQ_EQUIV = TDB.find "TREAL_EQ_EQUIV"
  fun op TREAL_EQ_AP _ = () val op TREAL_EQ_AP = TDB.find "TREAL_EQ_AP"
  fun op TREAL_10 _ = () val op TREAL_10 = TDB.find "TREAL_10"
  fun op TREAL_ADD_SYM _ = ()
  val op TREAL_ADD_SYM = TDB.find "TREAL_ADD_SYM"
  fun op TREAL_MUL_SYM _ = ()
  val op TREAL_MUL_SYM = TDB.find "TREAL_MUL_SYM"
  fun op TREAL_ADD_ASSOC _ = ()
  val op TREAL_ADD_ASSOC = TDB.find "TREAL_ADD_ASSOC"
  fun op TREAL_MUL_ASSOC _ = ()
  val op TREAL_MUL_ASSOC = TDB.find "TREAL_MUL_ASSOC"
  fun op TREAL_LDISTRIB _ = ()
  val op TREAL_LDISTRIB = TDB.find "TREAL_LDISTRIB"
  fun op TREAL_ADD_LID _ = ()
  val op TREAL_ADD_LID = TDB.find "TREAL_ADD_LID"
  fun op TREAL_MUL_LID _ = ()
  val op TREAL_MUL_LID = TDB.find "TREAL_MUL_LID"
  fun op TREAL_ADD_LINV _ = ()
  val op TREAL_ADD_LINV = TDB.find "TREAL_ADD_LINV"
  fun op TREAL_INV_0 _ = () val op TREAL_INV_0 = TDB.find "TREAL_INV_0"
  fun op TREAL_MUL_LINV _ = ()
  val op TREAL_MUL_LINV = TDB.find "TREAL_MUL_LINV"
  fun op TREAL_LT_TOTAL _ = ()
  val op TREAL_LT_TOTAL = TDB.find "TREAL_LT_TOTAL"
  fun op TREAL_LT_REFL _ = ()
  val op TREAL_LT_REFL = TDB.find "TREAL_LT_REFL"
  fun op TREAL_LT_TRANS _ = ()
  val op TREAL_LT_TRANS = TDB.find "TREAL_LT_TRANS"
  fun op TREAL_LT_ADD _ = () val op TREAL_LT_ADD = TDB.find "TREAL_LT_ADD"
  fun op TREAL_LT_MUL _ = () val op TREAL_LT_MUL = TDB.find "TREAL_LT_MUL"
  fun op TREAL_BIJ _ = () val op TREAL_BIJ = TDB.find "TREAL_BIJ"
  fun op TREAL_ISO _ = () val op TREAL_ISO = TDB.find "TREAL_ISO"
  fun op TREAL_BIJ_WELLDEF _ = ()
  val op TREAL_BIJ_WELLDEF = TDB.find "TREAL_BIJ_WELLDEF"
  fun op TREAL_NEG_WELLDEF _ = ()
  val op TREAL_NEG_WELLDEF = TDB.find "TREAL_NEG_WELLDEF"
  fun op TREAL_ADD_WELLDEFR _ = ()
  val op TREAL_ADD_WELLDEFR = TDB.find "TREAL_ADD_WELLDEFR"
  fun op TREAL_ADD_WELLDEF _ = ()
  val op TREAL_ADD_WELLDEF = TDB.find "TREAL_ADD_WELLDEF"
  fun op TREAL_MUL_WELLDEFR _ = ()
  val op TREAL_MUL_WELLDEFR = TDB.find "TREAL_MUL_WELLDEFR"
  fun op TREAL_MUL_WELLDEF _ = ()
  val op TREAL_MUL_WELLDEF = TDB.find "TREAL_MUL_WELLDEF"
  fun op TREAL_LT_WELLDEFR _ = ()
  val op TREAL_LT_WELLDEFR = TDB.find "TREAL_LT_WELLDEFR"
  fun op TREAL_LT_WELLDEFL _ = ()
  val op TREAL_LT_WELLDEFL = TDB.find "TREAL_LT_WELLDEFL"
  fun op TREAL_LT_WELLDEF _ = ()
  val op TREAL_LT_WELLDEF = TDB.find "TREAL_LT_WELLDEF"
  fun op TREAL_INV_WELLDEF _ = ()
  val op TREAL_INV_WELLDEF = TDB.find "TREAL_INV_WELLDEF"
  fun op real_ABS_REP_CLASS _ = ()
  val op real_ABS_REP_CLASS = TDB.find "real_ABS_REP_CLASS"
  fun op real_QUOTIENT _ = ()
  val op real_QUOTIENT = TDB.find "real_QUOTIENT"
  fun op REAL_ISO_EQ _ = () val op REAL_ISO_EQ = TDB.find "REAL_ISO_EQ"
  fun op REAL_POS _ = () val op REAL_POS = TDB.find "REAL_POS"
  fun op SUP_ALLPOS_LEMMA1 _ = ()
  val op SUP_ALLPOS_LEMMA1 = TDB.find "SUP_ALLPOS_LEMMA1"
  fun op SUP_ALLPOS_LEMMA2 _ = ()
  val op SUP_ALLPOS_LEMMA2 = TDB.find "SUP_ALLPOS_LEMMA2"
  fun op SUP_ALLPOS_LEMMA3 _ = ()
  val op SUP_ALLPOS_LEMMA3 = TDB.find "SUP_ALLPOS_LEMMA3"
  fun op SUP_ALLPOS_LEMMA4 _ = ()
  val op SUP_ALLPOS_LEMMA4 = TDB.find "SUP_ALLPOS_LEMMA4"
  fun op REAL_SUP_ALLPOS _ = ()
  val op REAL_SUP_ALLPOS = TDB.find "REAL_SUP_ALLPOS"
  fun op REAL_10 _ = () val op REAL_10 = TDB.find "REAL_10"
  fun op REAL_ADD_SYM _ = () val op REAL_ADD_SYM = TDB.find "REAL_ADD_SYM"
  fun op REAL_MUL_SYM _ = () val op REAL_MUL_SYM = TDB.find "REAL_MUL_SYM"
  fun op REAL_ADD_ASSOC _ = ()
  val op REAL_ADD_ASSOC = TDB.find "REAL_ADD_ASSOC"
  fun op REAL_MUL_ASSOC _ = ()
  val op REAL_MUL_ASSOC = TDB.find "REAL_MUL_ASSOC"
  fun op REAL_LDISTRIB _ = ()
  val op REAL_LDISTRIB = TDB.find "REAL_LDISTRIB"
  fun op REAL_ADD_LID _ = () val op REAL_ADD_LID = TDB.find "REAL_ADD_LID"
  fun op REAL_MUL_LID _ = () val op REAL_MUL_LID = TDB.find "REAL_MUL_LID"
  fun op REAL_ADD_LINV _ = ()
  val op REAL_ADD_LINV = TDB.find "REAL_ADD_LINV"
  fun op REAL_MUL_LINV _ = ()
  val op REAL_MUL_LINV = TDB.find "REAL_MUL_LINV"
  fun op REAL_LT_TOTAL _ = ()
  val op REAL_LT_TOTAL = TDB.find "REAL_LT_TOTAL"
  fun op REAL_LT_REFL _ = () val op REAL_LT_REFL = TDB.find "REAL_LT_REFL"
  fun op REAL_LT_TRANS _ = ()
  val op REAL_LT_TRANS = TDB.find "REAL_LT_TRANS"
  fun op REAL_LT_IADD _ = () val op REAL_LT_IADD = TDB.find "REAL_LT_IADD"
  fun op REAL_LT_MUL _ = () val op REAL_LT_MUL = TDB.find "REAL_LT_MUL"
  fun op REAL_INV_0 _ = () val op REAL_INV_0 = TDB.find "REAL_INV_0"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val realax_grammars = merge_grammars ["hreal"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="realax"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val realax_grammars = 
    Portable.## (addtyUDs,addtmUDs) realax_grammars
  val _ = Parse.grammarDB_insert("realax",realax_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "realax"

end
