structure seqTheory :> seqTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading seqTheory ... "
    else ()
  
  open Type Term Thm
  local open netsTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "seq"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/seqTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op tends_num_real _ = ()
  val op tends_num_real = TDB.find "tends_num_real"
  fun op convergent _ = () val op convergent = TDB.find "convergent"
  fun op cauchy _ = () val op cauchy = TDB.find "cauchy"
  fun op lim _ = () val op lim = TDB.find "lim"
  fun op subseq _ = () val op subseq = TDB.find "subseq"
  fun op mono _ = () val op mono = TDB.find "mono"
  fun op sums _ = () val op sums = TDB.find "sums"
  fun op summable _ = () val op summable = TDB.find "summable"
  fun op suminf _ = () val op suminf = TDB.find "suminf"
  fun op mono_increasing_def _ = ()
  val op mono_increasing_def = TDB.find "mono_increasing_def"
  fun op mono_decreasing_def _ = ()
  val op mono_decreasing_def = TDB.find "mono_decreasing_def"
  fun op SEQ _ = () val op SEQ = TDB.find "SEQ"
  fun op SEQ_CONST _ = () val op SEQ_CONST = TDB.find "SEQ_CONST"
  fun op SEQ_ADD _ = () val op SEQ_ADD = TDB.find "SEQ_ADD"
  fun op SEQ_MUL _ = () val op SEQ_MUL = TDB.find "SEQ_MUL"
  fun op SEQ_NEG _ = () val op SEQ_NEG = TDB.find "SEQ_NEG"
  fun op SEQ_INV _ = () val op SEQ_INV = TDB.find "SEQ_INV"
  fun op SEQ_SUB _ = () val op SEQ_SUB = TDB.find "SEQ_SUB"
  fun op SEQ_DIV _ = () val op SEQ_DIV = TDB.find "SEQ_DIV"
  fun op SEQ_UNIQ _ = () val op SEQ_UNIQ = TDB.find "SEQ_UNIQ"
  fun op SEQ_LIM _ = () val op SEQ_LIM = TDB.find "SEQ_LIM"
  fun op SUBSEQ_SUC _ = () val op SUBSEQ_SUC = TDB.find "SUBSEQ_SUC"
  fun op MONO_SUC _ = () val op MONO_SUC = TDB.find "MONO_SUC"
  fun op MAX_LEMMA _ = () val op MAX_LEMMA = TDB.find "MAX_LEMMA"
  fun op SEQ_BOUNDED _ = () val op SEQ_BOUNDED = TDB.find "SEQ_BOUNDED"
  fun op SEQ_BOUNDED_2 _ = ()
  val op SEQ_BOUNDED_2 = TDB.find "SEQ_BOUNDED_2"
  fun op SEQ_CBOUNDED _ = () val op SEQ_CBOUNDED = TDB.find "SEQ_CBOUNDED"
  fun op SEQ_ICONV _ = () val op SEQ_ICONV = TDB.find "SEQ_ICONV"
  fun op SEQ_NEG_CONV _ = () val op SEQ_NEG_CONV = TDB.find "SEQ_NEG_CONV"
  fun op SEQ_NEG_BOUNDED _ = ()
  val op SEQ_NEG_BOUNDED = TDB.find "SEQ_NEG_BOUNDED"
  fun op SEQ_BCONV _ = () val op SEQ_BCONV = TDB.find "SEQ_BCONV"
  fun op SEQ_MONOSUB _ = () val op SEQ_MONOSUB = TDB.find "SEQ_MONOSUB"
  fun op SEQ_SBOUNDED _ = () val op SEQ_SBOUNDED = TDB.find "SEQ_SBOUNDED"
  fun op SEQ_SUBLE _ = () val op SEQ_SUBLE = TDB.find "SEQ_SUBLE"
  fun op SEQ_DIRECT _ = () val op SEQ_DIRECT = TDB.find "SEQ_DIRECT"
  fun op SEQ_CAUCHY _ = () val op SEQ_CAUCHY = TDB.find "SEQ_CAUCHY"
  fun op SEQ_LE _ = () val op SEQ_LE = TDB.find "SEQ_LE"
  fun op SEQ_SUC _ = () val op SEQ_SUC = TDB.find "SEQ_SUC"
  fun op SEQ_ABS _ = () val op SEQ_ABS = TDB.find "SEQ_ABS"
  fun op SEQ_ABS_IMP _ = () val op SEQ_ABS_IMP = TDB.find "SEQ_ABS_IMP"
  fun op SEQ_INV0 _ = () val op SEQ_INV0 = TDB.find "SEQ_INV0"
  fun op SEQ_POWER_ABS _ = ()
  val op SEQ_POWER_ABS = TDB.find "SEQ_POWER_ABS"
  fun op SEQ_POWER _ = () val op SEQ_POWER = TDB.find "SEQ_POWER"
  fun op NEST_LEMMA _ = () val op NEST_LEMMA = TDB.find "NEST_LEMMA"
  fun op NEST_LEMMA_UNIQ _ = ()
  val op NEST_LEMMA_UNIQ = TDB.find "NEST_LEMMA_UNIQ"
  fun op BOLZANO_LEMMA _ = ()
  val op BOLZANO_LEMMA = TDB.find "BOLZANO_LEMMA"
  fun op SUM_SUMMABLE _ = () val op SUM_SUMMABLE = TDB.find "SUM_SUMMABLE"
  fun op SUMMABLE_SUM _ = () val op SUMMABLE_SUM = TDB.find "SUMMABLE_SUM"
  fun op SUM_UNIQ _ = () val op SUM_UNIQ = TDB.find "SUM_UNIQ"
  fun op SER_0 _ = () val op SER_0 = TDB.find "SER_0"
  fun op SER_POS_LE _ = () val op SER_POS_LE = TDB.find "SER_POS_LE"
  fun op SER_POS_LT _ = () val op SER_POS_LT = TDB.find "SER_POS_LT"
  fun op SER_GROUP _ = () val op SER_GROUP = TDB.find "SER_GROUP"
  fun op SER_PAIR _ = () val op SER_PAIR = TDB.find "SER_PAIR"
  fun op SER_OFFSET _ = () val op SER_OFFSET = TDB.find "SER_OFFSET"
  fun op SER_POS_LT_PAIR _ = ()
  val op SER_POS_LT_PAIR = TDB.find "SER_POS_LT_PAIR"
  fun op SER_ADD _ = () val op SER_ADD = TDB.find "SER_ADD"
  fun op SER_CMUL _ = () val op SER_CMUL = TDB.find "SER_CMUL"
  fun op SER_NEG _ = () val op SER_NEG = TDB.find "SER_NEG"
  fun op SER_SUB _ = () val op SER_SUB = TDB.find "SER_SUB"
  fun op SER_CDIV _ = () val op SER_CDIV = TDB.find "SER_CDIV"
  fun op SER_CAUCHY _ = () val op SER_CAUCHY = TDB.find "SER_CAUCHY"
  fun op SER_ZERO _ = () val op SER_ZERO = TDB.find "SER_ZERO"
  fun op SER_COMPAR _ = () val op SER_COMPAR = TDB.find "SER_COMPAR"
  fun op SER_COMPARA _ = () val op SER_COMPARA = TDB.find "SER_COMPARA"
  fun op SER_LE _ = () val op SER_LE = TDB.find "SER_LE"
  fun op SER_LE2 _ = () val op SER_LE2 = TDB.find "SER_LE2"
  fun op SER_ACONV _ = () val op SER_ACONV = TDB.find "SER_ACONV"
  fun op SER_ABS _ = () val op SER_ABS = TDB.find "SER_ABS"
  fun op GP_FINITE _ = () val op GP_FINITE = TDB.find "GP_FINITE"
  fun op GP _ = () val op GP = TDB.find "GP"
  fun op ABS_NEG_LEMMA _ = ()
  val op ABS_NEG_LEMMA = TDB.find "ABS_NEG_LEMMA"
  fun op SER_RATIO _ = () val op SER_RATIO = TDB.find "SER_RATIO"
  fun op LE_SEQ_IMP_LE_LIM _ = ()
  val op LE_SEQ_IMP_LE_LIM = TDB.find "LE_SEQ_IMP_LE_LIM"
  fun op SEQ_LE_IMP_LIM_LE _ = ()
  val op SEQ_LE_IMP_LIM_LE = TDB.find "SEQ_LE_IMP_LIM_LE"
  fun op SEQ_MONO_LE _ = () val op SEQ_MONO_LE = TDB.find "SEQ_MONO_LE"
  fun op SEQ_LE_MONO _ = () val op SEQ_LE_MONO = TDB.find "SEQ_LE_MONO"
  fun op mono_increasing_suc _ = ()
  val op mono_increasing_suc = TDB.find "mono_increasing_suc"
  fun op mono_decreasing_suc _ = ()
  val op mono_decreasing_suc = TDB.find "mono_decreasing_suc"
  fun op mono_increasing_converges_to_sup _ = ()
  val op mono_increasing_converges_to_sup = TDB.find
    "mono_increasing_converges_to_sup"
  fun op INCREASING_SEQ _ = ()
  val op INCREASING_SEQ = TDB.find "INCREASING_SEQ"
  fun op MAX_LE_X _ = () val op MAX_LE_X = TDB.find "MAX_LE_X"
  fun op X_LE_MAX _ = () val op X_LE_MAX = TDB.find "X_LE_MAX"
  fun op TRANSFORM_2D_NUM _ = ()
  val op TRANSFORM_2D_NUM = TDB.find "TRANSFORM_2D_NUM"
  fun op TRIANGLE_2D_NUM _ = ()
  val op TRIANGLE_2D_NUM = TDB.find "TRIANGLE_2D_NUM"
  fun op SEQ_SANDWICH _ = () val op SEQ_SANDWICH = TDB.find "SEQ_SANDWICH"
  fun op SER_POS _ = () val op SER_POS = TDB.find "SER_POS"
  fun op SER_POS_MONO _ = () val op SER_POS_MONO = TDB.find "SER_POS_MONO"
  fun op POS_SUMMABLE _ = () val op POS_SUMMABLE = TDB.find "POS_SUMMABLE"
  fun op SUMMABLE_LE _ = () val op SUMMABLE_LE = TDB.find "SUMMABLE_LE"
  fun op SUMS_EQ _ = () val op SUMS_EQ = TDB.find "SUMS_EQ"
  fun op SUMINF_POS _ = () val op SUMINF_POS = TDB.find "SUMINF_POS"
  fun op SUM_PICK _ = () val op SUM_PICK = TDB.find "SUM_PICK"
  fun op SUM_LT _ = () val op SUM_LT = TDB.find "SUM_LT"
  fun op SUM_CONST_R _ = () val op SUM_CONST_R = TDB.find "SUM_CONST_R"
  fun op SUMS_ZERO _ = () val op SUMS_ZERO = TDB.find "SUMS_ZERO"
  fun op LT_SUC _ = () val op LT_SUC = TDB.find "LT_SUC"
  fun op LE_SUC _ = () val op LE_SUC = TDB.find "LE_SUC"
  fun op K_PARTIAL _ = () val op K_PARTIAL = TDB.find "K_PARTIAL"
  fun op HALF_POS _ = () val op HALF_POS = TDB.find "HALF_POS"
  fun op HALF_LT_1 _ = () val op HALF_LT_1 = TDB.find "HALF_LT_1"
  fun op HALF_CANCEL _ = () val op HALF_CANCEL = TDB.find "HALF_CANCEL"
  fun op X_HALF_HALF _ = () val op X_HALF_HALF = TDB.find "X_HALF_HALF"
  fun op ONE_MINUS_HALF _ = ()
  val op ONE_MINUS_HALF = TDB.find "ONE_MINUS_HALF"
  fun op NUM_2D_BIJ_BIG_SQUARE _ = ()
  val op NUM_2D_BIJ_BIG_SQUARE = TDB.find "NUM_2D_BIJ_BIG_SQUARE"
  fun op NUM_2D_BIJ_SMALL_SQUARE _ = ()
  val op NUM_2D_BIJ_SMALL_SQUARE = TDB.find "NUM_2D_BIJ_SMALL_SQUARE"
  fun op SUMINF_ADD _ = () val op SUMINF_ADD = TDB.find "SUMINF_ADD"
  fun op SUMINF_2D _ = () val op SUMINF_2D = TDB.find "SUMINF_2D"
  fun op POW_HALF_SER _ = () val op POW_HALF_SER = TDB.find "POW_HALF_SER"
  fun op SER_POS_COMPARE _ = ()
  val op SER_POS_COMPARE = TDB.find "SER_POS_COMPARE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val seq_grammars = merge_grammars ["nets"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="seq"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val seq_grammars = 
    Portable.## (addtyUDs,addtmUDs) seq_grammars
  val _ = Parse.grammarDB_insert("seq",seq_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "seq"

end
