structure transcTheory :> transcTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading transcTheory ... "
    else ()
  
  open Type Term Thm
  local open powserTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "transc"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/real/transcTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op atn _ = () val op atn = TDB.find "atn"
  fun op acs _ = () val op acs = TDB.find "acs"
  fun op asn _ = () val op asn = TDB.find "asn"
  fun op tan _ = () val op tan = TDB.find "tan"
  fun op pi _ = () val op pi = TDB.find "pi"
  fun op sqrt _ = () val op sqrt = TDB.find "sqrt"
  fun op root _ = () val op root = TDB.find "root"
  fun op exp _ = () val op exp = TDB.find "exp"
  fun op cos _ = () val op cos = TDB.find "cos"
  fun op sin _ = () val op sin = TDB.find "sin"
  fun op ln _ = () val op ln = TDB.find "ln"
  fun op division _ = () val op division = TDB.find "division"
  fun op dsize _ = () val op dsize = TDB.find "dsize"
  fun op tdiv _ = () val op tdiv = TDB.find "tdiv"
  fun op gauge _ = () val op gauge = TDB.find "gauge"
  fun op fine _ = () val op fine = TDB.find "fine"
  fun op rsum _ = () val op rsum = TDB.find "rsum"
  fun op Dint _ = () val op Dint = TDB.find "Dint"
  fun op rpow_def _ = () val op rpow_def = TDB.find "rpow_def"
  fun op SIN_COS_SQRT _ = () val op SIN_COS_SQRT = TDB.find "SIN_COS_SQRT"
  fun op COS_SIN_SQRT _ = () val op COS_SIN_SQRT = TDB.find "COS_SIN_SQRT"
  fun op SIN_ACS_NZ _ = () val op SIN_ACS_NZ = TDB.find "SIN_ACS_NZ"
  fun op COS_ASN_NZ _ = () val op COS_ASN_NZ = TDB.find "COS_ASN_NZ"
  fun op COS_ATN_NZ _ = () val op COS_ATN_NZ = TDB.find "COS_ATN_NZ"
  fun op COS_SIN_SQ _ = () val op COS_SIN_SQ = TDB.find "COS_SIN_SQ"
  fun op SIN_COS_SQ _ = () val op SIN_COS_SQ = TDB.find "SIN_COS_SQ"
  fun op TAN_SEC _ = () val op TAN_SEC = TDB.find "TAN_SEC"
  fun op TAN_ATN _ = () val op TAN_ATN = TDB.find "TAN_ATN"
  fun op ATN_BOUNDS _ = () val op ATN_BOUNDS = TDB.find "ATN_BOUNDS"
  fun op ATN_TAN _ = () val op ATN_TAN = TDB.find "ATN_TAN"
  fun op ATN _ = () val op ATN = TDB.find "ATN"
  fun op COS_ACS _ = () val op COS_ACS = TDB.find "COS_ACS"
  fun op ACS_BOUNDS_LT _ = ()
  val op ACS_BOUNDS_LT = TDB.find "ACS_BOUNDS_LT"
  fun op ACS_BOUNDS _ = () val op ACS_BOUNDS = TDB.find "ACS_BOUNDS"
  fun op ACS_COS _ = () val op ACS_COS = TDB.find "ACS_COS"
  fun op ACS _ = () val op ACS = TDB.find "ACS"
  fun op SIN_ASN _ = () val op SIN_ASN = TDB.find "SIN_ASN"
  fun op ASN_BOUNDS_LT _ = ()
  val op ASN_BOUNDS_LT = TDB.find "ASN_BOUNDS_LT"
  fun op ASN_BOUNDS _ = () val op ASN_BOUNDS = TDB.find "ASN_BOUNDS"
  fun op ASN_SIN _ = () val op ASN_SIN = TDB.find "ASN_SIN"
  fun op ASN _ = () val op ASN = TDB.find "ASN"
  fun op TAN_TOTAL _ = () val op TAN_TOTAL = TDB.find "TAN_TOTAL"
  fun op TAN_TOTAL_POS _ = ()
  val op TAN_TOTAL_POS = TDB.find "TAN_TOTAL_POS"
  fun op TAN_TOTAL_LEMMA _ = ()
  val op TAN_TOTAL_LEMMA = TDB.find "TAN_TOTAL_LEMMA"
  fun op DIFF_TAN _ = () val op DIFF_TAN = TDB.find "DIFF_TAN"
  fun op TAN_POS_PI2 _ = () val op TAN_POS_PI2 = TDB.find "TAN_POS_PI2"
  fun op TAN_DOUBLE _ = () val op TAN_DOUBLE = TDB.find "TAN_DOUBLE"
  fun op TAN_ADD _ = () val op TAN_ADD = TDB.find "TAN_ADD"
  fun op TAN_PERIODIC _ = () val op TAN_PERIODIC = TDB.find "TAN_PERIODIC"
  fun op TAN_NEG _ = () val op TAN_NEG = TDB.find "TAN_NEG"
  fun op TAN_NPI _ = () val op TAN_NPI = TDB.find "TAN_NPI"
  fun op TAN_PI _ = () val op TAN_PI = TDB.find "TAN_PI"
  fun op TAN_0 _ = () val op TAN_0 = TDB.find "TAN_0"
  fun op SIN_ZERO _ = () val op SIN_ZERO = TDB.find "SIN_ZERO"
  fun op COS_ZERO _ = () val op COS_ZERO = TDB.find "COS_ZERO"
  fun op SIN_ZERO_LEMMA _ = ()
  val op SIN_ZERO_LEMMA = TDB.find "SIN_ZERO_LEMMA"
  fun op COS_ZERO_LEMMA _ = ()
  val op COS_ZERO_LEMMA = TDB.find "COS_ZERO_LEMMA"
  fun op SIN_TOTAL _ = () val op SIN_TOTAL = TDB.find "SIN_TOTAL"
  fun op COS_TOTAL _ = () val op COS_TOTAL = TDB.find "COS_TOTAL"
  fun op SIN_POS_PI_LE _ = ()
  val op SIN_POS_PI_LE = TDB.find "SIN_POS_PI_LE"
  fun op SIN_POS_PI2_LE _ = ()
  val op SIN_POS_PI2_LE = TDB.find "SIN_POS_PI2_LE"
  fun op COS_POS_PI_LE _ = ()
  val op COS_POS_PI_LE = TDB.find "COS_POS_PI_LE"
  fun op COS_POS_PI2_LE _ = ()
  val op COS_POS_PI2_LE = TDB.find "COS_POS_PI2_LE"
  fun op SIN_POS_PI _ = () val op SIN_POS_PI = TDB.find "SIN_POS_PI"
  fun op COS_POS_PI _ = () val op COS_POS_PI = TDB.find "COS_POS_PI"
  fun op COS_POS_PI2 _ = () val op COS_POS_PI2 = TDB.find "COS_POS_PI2"
  fun op SIN_POS_PI2 _ = () val op SIN_POS_PI2 = TDB.find "SIN_POS_PI2"
  fun op SIN_NPI _ = () val op SIN_NPI = TDB.find "SIN_NPI"
  fun op COS_NPI _ = () val op COS_NPI = TDB.find "COS_NPI"
  fun op COS_PERIODIC _ = () val op COS_PERIODIC = TDB.find "COS_PERIODIC"
  fun op SIN_PERIODIC _ = () val op SIN_PERIODIC = TDB.find "SIN_PERIODIC"
  fun op COS_PERIODIC_PI _ = ()
  val op COS_PERIODIC_PI = TDB.find "COS_PERIODIC_PI"
  fun op SIN_PERIODIC_PI _ = ()
  val op SIN_PERIODIC_PI = TDB.find "SIN_PERIODIC_PI"
  fun op COS_SIN _ = () val op COS_SIN = TDB.find "COS_SIN"
  fun op SIN_COS _ = () val op SIN_COS = TDB.find "SIN_COS"
  fun op SIN_PI _ = () val op SIN_PI = TDB.find "SIN_PI"
  fun op COS_PI _ = () val op COS_PI = TDB.find "COS_PI"
  fun op SIN_PI2 _ = () val op SIN_PI2 = TDB.find "SIN_PI2"
  fun op PI_POS _ = () val op PI_POS = TDB.find "PI_POS"
  fun op PI2_BOUNDS _ = () val op PI2_BOUNDS = TDB.find "PI2_BOUNDS"
  fun op COS_PI2 _ = () val op COS_PI2 = TDB.find "COS_PI2"
  fun op PI2 _ = () val op PI2 = TDB.find "PI2"
  fun op COS_ISZERO _ = () val op COS_ISZERO = TDB.find "COS_ISZERO"
  fun op COS_2 _ = () val op COS_2 = TDB.find "COS_2"
  fun op COS_PAIRED _ = () val op COS_PAIRED = TDB.find "COS_PAIRED"
  fun op SIN_POS _ = () val op SIN_POS = TDB.find "SIN_POS"
  fun op SIN_PAIRED _ = () val op SIN_PAIRED = TDB.find "SIN_PAIRED"
  fun op COS_DOUBLE _ = () val op COS_DOUBLE = TDB.find "COS_DOUBLE"
  fun op SIN_DOUBLE _ = () val op SIN_DOUBLE = TDB.find "SIN_DOUBLE"
  fun op COS_NEG _ = () val op COS_NEG = TDB.find "COS_NEG"
  fun op SIN_NEG _ = () val op SIN_NEG = TDB.find "SIN_NEG"
  fun op COS_ADD _ = () val op COS_ADD = TDB.find "COS_ADD"
  fun op SIN_ADD _ = () val op SIN_ADD = TDB.find "SIN_ADD"
  fun op SIN_COS_NEG _ = () val op SIN_COS_NEG = TDB.find "SIN_COS_NEG"
  fun op SIN_COS_ADD _ = () val op SIN_COS_ADD = TDB.find "SIN_COS_ADD"
  fun op COS_BOUNDS _ = () val op COS_BOUNDS = TDB.find "COS_BOUNDS"
  fun op COS_BOUND _ = () val op COS_BOUND = TDB.find "COS_BOUND"
  fun op SIN_BOUNDS _ = () val op SIN_BOUNDS = TDB.find "SIN_BOUNDS"
  fun op SIN_BOUND _ = () val op SIN_BOUND = TDB.find "SIN_BOUND"
  fun op SIN_CIRCLE _ = () val op SIN_CIRCLE = TDB.find "SIN_CIRCLE"
  fun op COS_0 _ = () val op COS_0 = TDB.find "COS_0"
  fun op SIN_0 _ = () val op SIN_0 = TDB.find "SIN_0"
  fun op SQRT_EQ _ = () val op SQRT_EQ = TDB.find "SQRT_EQ"
  fun op REAL_DIV_SQRT _ = ()
  val op REAL_DIV_SQRT = TDB.find "REAL_DIV_SQRT"
  fun op SQRT_EVEN_POW2 _ = ()
  val op SQRT_EVEN_POW2 = TDB.find "SQRT_EVEN_POW2"
  fun op SQRT_MONO_LE _ = () val op SQRT_MONO_LE = TDB.find "SQRT_MONO_LE"
  fun op SQRT_DIV _ = () val op SQRT_DIV = TDB.find "SQRT_DIV"
  fun op SQRT_INV _ = () val op SQRT_INV = TDB.find "SQRT_INV"
  fun op SQRT_MUL _ = () val op SQRT_MUL = TDB.find "SQRT_MUL"
  fun op SQRT_POS_UNIQ _ = ()
  val op SQRT_POS_UNIQ = TDB.find "SQRT_POS_UNIQ"
  fun op POW_2_SQRT _ = () val op POW_2_SQRT = TDB.find "POW_2_SQRT"
  fun op SQRT_POW_2 _ = () val op SQRT_POW_2 = TDB.find "SQRT_POW_2"
  fun op SQRT_POW2 _ = () val op SQRT_POW2 = TDB.find "SQRT_POW2"
  fun op SQRT_POS_LE _ = () val op SQRT_POS_LE = TDB.find "SQRT_POS_LE"
  fun op SQRT_POS_LT _ = () val op SQRT_POS_LT = TDB.find "SQRT_POS_LT"
  fun op SQRT_1 _ = () val op SQRT_1 = TDB.find "SQRT_1"
  fun op SQRT_0 _ = () val op SQRT_0 = TDB.find "SQRT_0"
  fun op ROOT_MONO_LE _ = () val op ROOT_MONO_LE = TDB.find "ROOT_MONO_LE"
  fun op ROOT_DIV _ = () val op ROOT_DIV = TDB.find "ROOT_DIV"
  fun op ROOT_INV _ = () val op ROOT_INV = TDB.find "ROOT_INV"
  fun op ROOT_MUL _ = () val op ROOT_MUL = TDB.find "ROOT_MUL"
  fun op ROOT_POS_UNIQ _ = ()
  val op ROOT_POS_UNIQ = TDB.find "ROOT_POS_UNIQ"
  fun op ROOT_POS _ = () val op ROOT_POS = TDB.find "ROOT_POS"
  fun op POW_ROOT_POS _ = () val op POW_ROOT_POS = TDB.find "POW_ROOT_POS"
  fun op ROOT_POW_POS _ = () val op ROOT_POW_POS = TDB.find "ROOT_POW_POS"
  fun op ROOT_POS_LT _ = () val op ROOT_POS_LT = TDB.find "ROOT_POS_LT"
  fun op ROOT_1 _ = () val op ROOT_1 = TDB.find "ROOT_1"
  fun op ROOT_0 _ = () val op ROOT_0 = TDB.find "ROOT_0"
  fun op ROOT_LN _ = () val op ROOT_LN = TDB.find "ROOT_LN"
  fun op ROOT_LT_LEMMA _ = ()
  val op ROOT_LT_LEMMA = TDB.find "ROOT_LT_LEMMA"
  fun op EXP_CONVERGES _ = ()
  val op EXP_CONVERGES = TDB.find "EXP_CONVERGES"
  fun op SIN_CONVERGES _ = ()
  val op SIN_CONVERGES = TDB.find "SIN_CONVERGES"
  fun op COS_CONVERGES _ = ()
  val op COS_CONVERGES = TDB.find "COS_CONVERGES"
  fun op EXP_FDIFF _ = () val op EXP_FDIFF = TDB.find "EXP_FDIFF"
  fun op SIN_FDIFF _ = () val op SIN_FDIFF = TDB.find "SIN_FDIFF"
  fun op COS_FDIFF _ = () val op COS_FDIFF = TDB.find "COS_FDIFF"
  fun op SIN_NEGLEMMA _ = () val op SIN_NEGLEMMA = TDB.find "SIN_NEGLEMMA"
  fun op DIFF_EXP _ = () val op DIFF_EXP = TDB.find "DIFF_EXP"
  fun op DIFF_SIN _ = () val op DIFF_SIN = TDB.find "DIFF_SIN"
  fun op DIFF_COS _ = () val op DIFF_COS = TDB.find "DIFF_COS"
  fun op DIFF_COMPOSITE _ = ()
  val op DIFF_COMPOSITE = TDB.find "DIFF_COMPOSITE"
  fun op EXP_0 _ = () val op EXP_0 = TDB.find "EXP_0"
  fun op EXP_LE_X _ = () val op EXP_LE_X = TDB.find "EXP_LE_X"
  fun op EXP_LT_1 _ = () val op EXP_LT_1 = TDB.find "EXP_LT_1"
  fun op EXP_ADD_MUL _ = () val op EXP_ADD_MUL = TDB.find "EXP_ADD_MUL"
  fun op EXP_NEG_MUL _ = () val op EXP_NEG_MUL = TDB.find "EXP_NEG_MUL"
  fun op EXP_NEG_MUL2 _ = () val op EXP_NEG_MUL2 = TDB.find "EXP_NEG_MUL2"
  fun op EXP_NEG _ = () val op EXP_NEG = TDB.find "EXP_NEG"
  fun op EXP_ADD _ = () val op EXP_ADD = TDB.find "EXP_ADD"
  fun op EXP_POS_LE _ = () val op EXP_POS_LE = TDB.find "EXP_POS_LE"
  fun op EXP_NZ _ = () val op EXP_NZ = TDB.find "EXP_NZ"
  fun op EXP_POS_LT _ = () val op EXP_POS_LT = TDB.find "EXP_POS_LT"
  fun op EXP_N _ = () val op EXP_N = TDB.find "EXP_N"
  fun op EXP_SUB _ = () val op EXP_SUB = TDB.find "EXP_SUB"
  fun op EXP_MONO_IMP _ = () val op EXP_MONO_IMP = TDB.find "EXP_MONO_IMP"
  fun op EXP_MONO_LT _ = () val op EXP_MONO_LT = TDB.find "EXP_MONO_LT"
  fun op EXP_MONO_LE _ = () val op EXP_MONO_LE = TDB.find "EXP_MONO_LE"
  fun op EXP_INJ _ = () val op EXP_INJ = TDB.find "EXP_INJ"
  fun op EXP_TOTAL_LEMMA _ = ()
  val op EXP_TOTAL_LEMMA = TDB.find "EXP_TOTAL_LEMMA"
  fun op EXP_TOTAL _ = () val op EXP_TOTAL = TDB.find "EXP_TOTAL"
  fun op LN_EXP _ = () val op LN_EXP = TDB.find "LN_EXP"
  fun op EXP_LN _ = () val op EXP_LN = TDB.find "EXP_LN"
  fun op LN_MUL _ = () val op LN_MUL = TDB.find "LN_MUL"
  fun op LN_INJ _ = () val op LN_INJ = TDB.find "LN_INJ"
  fun op LN_1 _ = () val op LN_1 = TDB.find "LN_1"
  fun op LN_INV _ = () val op LN_INV = TDB.find "LN_INV"
  fun op LN_DIV _ = () val op LN_DIV = TDB.find "LN_DIV"
  fun op LN_MONO_LT _ = () val op LN_MONO_LT = TDB.find "LN_MONO_LT"
  fun op LN_MONO_LE _ = () val op LN_MONO_LE = TDB.find "LN_MONO_LE"
  fun op LN_POW _ = () val op LN_POW = TDB.find "LN_POW"
  fun op LN_LE _ = () val op LN_LE = TDB.find "LN_LE"
  fun op LN_LT_X _ = () val op LN_LT_X = TDB.find "LN_LT_X"
  fun op LN_POS _ = () val op LN_POS = TDB.find "LN_POS"
  fun op DIFF_LN _ = () val op DIFF_LN = TDB.find "DIFF_LN"
  fun op DIFF_ASN_LEMMA _ = ()
  val op DIFF_ASN_LEMMA = TDB.find "DIFF_ASN_LEMMA"
  fun op DIFF_ASN _ = () val op DIFF_ASN = TDB.find "DIFF_ASN"
  fun op DIFF_ACS_LEMMA _ = ()
  val op DIFF_ACS_LEMMA = TDB.find "DIFF_ACS_LEMMA"
  fun op DIFF_ACS _ = () val op DIFF_ACS = TDB.find "DIFF_ACS"
  fun op DIFF_ATN _ = () val op DIFF_ATN = TDB.find "DIFF_ATN"
  fun op DIVISION_0 _ = () val op DIVISION_0 = TDB.find "DIVISION_0"
  fun op DIVISION_1 _ = () val op DIVISION_1 = TDB.find "DIVISION_1"
  fun op DIVISION_SINGLE _ = ()
  val op DIVISION_SINGLE = TDB.find "DIVISION_SINGLE"
  fun op DIVISION_LHS _ = () val op DIVISION_LHS = TDB.find "DIVISION_LHS"
  fun op DIVISION_THM _ = () val op DIVISION_THM = TDB.find "DIVISION_THM"
  fun op DIVISION_RHS _ = () val op DIVISION_RHS = TDB.find "DIVISION_RHS"
  fun op DIVISION_LT_GEN _ = ()
  val op DIVISION_LT_GEN = TDB.find "DIVISION_LT_GEN"
  fun op DIVISION_LT _ = () val op DIVISION_LT = TDB.find "DIVISION_LT"
  fun op DIVISION_LE _ = () val op DIVISION_LE = TDB.find "DIVISION_LE"
  fun op DIVISION_GT _ = () val op DIVISION_GT = TDB.find "DIVISION_GT"
  fun op DIVISION_EQ _ = () val op DIVISION_EQ = TDB.find "DIVISION_EQ"
  fun op DIVISION_LBOUND _ = ()
  val op DIVISION_LBOUND = TDB.find "DIVISION_LBOUND"
  fun op DIVISION_LBOUND_LT _ = ()
  val op DIVISION_LBOUND_LT = TDB.find "DIVISION_LBOUND_LT"
  fun op DIVISION_UBOUND _ = ()
  val op DIVISION_UBOUND = TDB.find "DIVISION_UBOUND"
  fun op DIVISION_UBOUND_LT _ = ()
  val op DIVISION_UBOUND_LT = TDB.find "DIVISION_UBOUND_LT"
  fun op DIVISION_APPEND _ = ()
  val op DIVISION_APPEND = TDB.find "DIVISION_APPEND"
  fun op DIVISION_EXISTS _ = ()
  val op DIVISION_EXISTS = TDB.find "DIVISION_EXISTS"
  fun op GAUGE_MIN _ = () val op GAUGE_MIN = TDB.find "GAUGE_MIN"
  fun op FINE_MIN _ = () val op FINE_MIN = TDB.find "FINE_MIN"
  fun op DINT_UNIQ _ = () val op DINT_UNIQ = TDB.find "DINT_UNIQ"
  fun op INTEGRAL_NULL _ = ()
  val op INTEGRAL_NULL = TDB.find "INTEGRAL_NULL"
  fun op FTC1 _ = () val op FTC1 = TDB.find "FTC1"
  fun op MCLAURIN _ = () val op MCLAURIN = TDB.find "MCLAURIN"
  fun op MCLAURIN_NEG _ = () val op MCLAURIN_NEG = TDB.find "MCLAURIN_NEG"
  fun op MCLAURIN_ALL_LT _ = ()
  val op MCLAURIN_ALL_LT = TDB.find "MCLAURIN_ALL_LT"
  fun op MCLAURIN_ZERO _ = ()
  val op MCLAURIN_ZERO = TDB.find "MCLAURIN_ZERO"
  fun op MCLAURIN_ALL_LE _ = ()
  val op MCLAURIN_ALL_LE = TDB.find "MCLAURIN_ALL_LE"
  fun op MCLAURIN_EXP_LT _ = ()
  val op MCLAURIN_EXP_LT = TDB.find "MCLAURIN_EXP_LT"
  fun op MCLAURIN_EXP_LE _ = ()
  val op MCLAURIN_EXP_LE = TDB.find "MCLAURIN_EXP_LE"
  fun op DIFF_LN_COMPOSITE _ = ()
  val op DIFF_LN_COMPOSITE = TDB.find "DIFF_LN_COMPOSITE"
  fun op GEN_RPOW _ = () val op GEN_RPOW = TDB.find "GEN_RPOW"
  fun op RPOW_SUC_N _ = () val op RPOW_SUC_N = TDB.find "RPOW_SUC_N"
  fun op RPOW_0 _ = () val op RPOW_0 = TDB.find "RPOW_0"
  fun op RPOW_1 _ = () val op RPOW_1 = TDB.find "RPOW_1"
  fun op ONE_RPOW _ = () val op ONE_RPOW = TDB.find "ONE_RPOW"
  fun op RPOW_POS_LT _ = () val op RPOW_POS_LT = TDB.find "RPOW_POS_LT"
  fun op RPOW_NZ _ = () val op RPOW_NZ = TDB.find "RPOW_NZ"
  fun op LN_RPOW _ = () val op LN_RPOW = TDB.find "LN_RPOW"
  fun op RPOW_ADD _ = () val op RPOW_ADD = TDB.find "RPOW_ADD"
  fun op RPOW_ADD_MUL _ = () val op RPOW_ADD_MUL = TDB.find "RPOW_ADD_MUL"
  fun op RPOW_SUB _ = () val op RPOW_SUB = TDB.find "RPOW_SUB"
  fun op RPOW_DIV _ = () val op RPOW_DIV = TDB.find "RPOW_DIV"
  fun op RPOW_INV _ = () val op RPOW_INV = TDB.find "RPOW_INV"
  fun op RPOW_MUL _ = () val op RPOW_MUL = TDB.find "RPOW_MUL"
  fun op RPOW_RPOW _ = () val op RPOW_RPOW = TDB.find "RPOW_RPOW"
  fun op RPOW_LT _ = () val op RPOW_LT = TDB.find "RPOW_LT"
  fun op RPOW_LE _ = () val op RPOW_LE = TDB.find "RPOW_LE"
  fun op BASE_RPOW_LE _ = () val op BASE_RPOW_LE = TDB.find "BASE_RPOW_LE"
  fun op BASE_RPOW_LT _ = () val op BASE_RPOW_LT = TDB.find "BASE_RPOW_LT"
  fun op RPOW_UNIQ_BASE _ = ()
  val op RPOW_UNIQ_BASE = TDB.find "RPOW_UNIQ_BASE"
  fun op RPOW_UNIQ_EXP _ = ()
  val op RPOW_UNIQ_EXP = TDB.find "RPOW_UNIQ_EXP"
  fun op RPOW_DIV_BASE _ = ()
  val op RPOW_DIV_BASE = TDB.find "RPOW_DIV_BASE"
  fun op DIFF_COMPOSITE_EXP _ = ()
  val op DIFF_COMPOSITE_EXP = TDB.find "DIFF_COMPOSITE_EXP"
  fun op DIFF_RPOW _ = () val op DIFF_RPOW = TDB.find "DIFF_RPOW"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val transc_grammars = merge_grammars ["powser"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="transc"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val transc_grammars = 
    Portable.## (addtyUDs,addtmUDs) transc_grammars
  val _ = Parse.grammarDB_insert("transc",transc_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "transc"

end
