structure bisimulationTheory :> bisimulationTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading bisimulationTheory ... "
    else ()
  
  open Type Term Thm
  local open relationTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "bisimulation"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/relation/bisimulationTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op BISIM_def _ = () val op BISIM_def = TDB.find "BISIM_def"
  fun op ETS_def _ = () val op ETS_def = TDB.find "ETS_def"
  fun op WTS_def _ = () val op WTS_def = TDB.find "WTS_def"
  fun op WBISIM_def _ = () val op WBISIM_def = TDB.find "WBISIM_def"
  fun op WBISIM_REL_IS_WBISIM _ = ()
  val op WBISIM_REL_IS_WBISIM = TDB.find "WBISIM_REL_IS_WBISIM"
  fun op WBISIM_RUNION _ = ()
  val op WBISIM_RUNION = TDB.find "WBISIM_RUNION"
  fun op WBISIM_O _ = () val op WBISIM_O = TDB.find "WBISIM_O"
  fun op WBISIM_INV _ = () val op WBISIM_INV = TDB.find "WBISIM_INV"
  fun op ETS_WTS_ETS _ = () val op ETS_WTS_ETS = TDB.find "ETS_WTS_ETS"
  fun op ETS_TRANS _ = () val op ETS_TRANS = TDB.find "ETS_TRANS"
  fun op TS_IMP_WTS _ = () val op TS_IMP_WTS = TDB.find "TS_IMP_WTS"
  fun op ETS_REFL _ = () val op ETS_REFL = TDB.find "ETS_REFL"
  fun op TS_IMP_ETS _ = () val op TS_IMP_ETS = TDB.find "TS_IMP_ETS"
  fun op WBISIM_REL_cases _ = ()
  val op WBISIM_REL_cases = TDB.find "WBISIM_REL_cases"
  fun op WBISIM_REL_coind _ = ()
  val op WBISIM_REL_coind = TDB.find "WBISIM_REL_coind"
  fun op WBISIM_REL_rules _ = ()
  val op WBISIM_REL_rules = TDB.find "WBISIM_REL_rules"
  fun op WBISIM_ID _ = () val op WBISIM_ID = TDB.find "WBISIM_ID"
  fun op BISIM_REL_IS_BISIM _ = ()
  val op BISIM_REL_IS_BISIM = TDB.find "BISIM_REL_IS_BISIM"
  fun op BISIM_RUNION _ = () val op BISIM_RUNION = TDB.find "BISIM_RUNION"
  fun op BISIM_O _ = () val op BISIM_O = TDB.find "BISIM_O"
  fun op BISIM_INV _ = () val op BISIM_INV = TDB.find "BISIM_INV"
  fun op BISIM_ID _ = () val op BISIM_ID = TDB.find "BISIM_ID"
  fun op BISIM_REL_cases _ = ()
  val op BISIM_REL_cases = TDB.find "BISIM_REL_cases"
  fun op BISIM_REL_coind _ = ()
  val op BISIM_REL_coind = TDB.find "BISIM_REL_coind"
  fun op BISIM_REL_rules _ = ()
  val op BISIM_REL_rules = TDB.find "BISIM_REL_rules"
  fun op BISIM_REL_def _ = ()
  val op BISIM_REL_def = TDB.find "BISIM_REL_def"
  fun op BISIM_REL_IS_EQUIV_REL _ = ()
  val op BISIM_REL_IS_EQUIV_REL = TDB.find "BISIM_REL_IS_EQUIV_REL"
  fun op WBISIM_REL_def _ = ()
  val op WBISIM_REL_def = TDB.find "WBISIM_REL_def"
  fun op WBISIM_REL_IS_EQUIV_REL _ = ()
  val op WBISIM_REL_IS_EQUIV_REL = TDB.find "WBISIM_REL_IS_EQUIV_REL"
  fun op BISIM_IMP_WBISIM _ = ()
  val op BISIM_IMP_WBISIM = TDB.find "BISIM_IMP_WBISIM"
  fun op BISIM_REL_RSUBSET_WBISIM_REL _ = ()
  val op BISIM_REL_RSUBSET_WBISIM_REL = TDB.find
    "BISIM_REL_RSUBSET_WBISIM_REL"
  fun op BISIM_REL_IMP_WBISIM_REL _ = ()
  val op BISIM_REL_IMP_WBISIM_REL = TDB.find "BISIM_REL_IMP_WBISIM_REL"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val bisimulation_grammars = merge_grammars ["relation"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="bisimulation"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val bisimulation_grammars = 
    Portable.## (addtyUDs,addtmUDs) bisimulation_grammars
  val _ = Parse.grammarDB_insert("bisimulation",bisimulation_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "bisimulation"

end
