structure relationTheory :> relationTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading relationTheory ... "
    else ()
  
  open Type Term Thm
  local open combinTheory normalFormsTheory satTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "relation"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/relation/relationTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op transitive_def _ = ()
  val op transitive_def = TDB.find "transitive_def"
  fun op reflexive_def _ = ()
  val op reflexive_def = TDB.find "reflexive_def"
  fun op irreflexive_def _ = ()
  val op irreflexive_def = TDB.find "irreflexive_def"
  fun op symmetric_def _ = ()
  val op symmetric_def = TDB.find "symmetric_def"
  fun op antisymmetric_def _ = ()
  val op antisymmetric_def = TDB.find "antisymmetric_def"
  fun op equivalence_def _ = ()
  val op equivalence_def = TDB.find "equivalence_def"
  fun op total_def _ = () val op total_def = TDB.find "total_def"
  fun op trichotomous _ = () val op trichotomous = TDB.find "trichotomous"
  fun op TC_DEF _ = () val op TC_DEF = TDB.find "TC_DEF"
  fun op RTC_def _ = () val op RTC_def = TDB.find "RTC_def"
  fun op RC_DEF _ = () val op RC_DEF = TDB.find "RC_DEF"
  fun op SC_DEF _ = () val op SC_DEF = TDB.find "SC_DEF"
  fun op EQC_DEF _ = () val op EQC_DEF = TDB.find "EQC_DEF"
  fun op WF_DEF _ = () val op WF_DEF = TDB.find "WF_DEF"
  fun op EMPTY_REL_DEF _ = ()
  val op EMPTY_REL_DEF = TDB.find "EMPTY_REL_DEF"
  fun op inv_image_def _ = ()
  val op inv_image_def = TDB.find "inv_image_def"
  fun op RESTRICT_DEF _ = () val op RESTRICT_DEF = TDB.find "RESTRICT_DEF"
  fun op approx_def _ = () val op approx_def = TDB.find "approx_def"
  fun op the_fun_def _ = () val op the_fun_def = TDB.find "the_fun_def"
  fun op WFREC_DEF _ = () val op WFREC_DEF = TDB.find "WFREC_DEF"
  fun op WFP_DEF _ = () val op WFP_DEF = TDB.find "WFP_DEF"
  fun op INDUCTIVE_INVARIANT_DEF _ = ()
  val op INDUCTIVE_INVARIANT_DEF = TDB.find "INDUCTIVE_INVARIANT_DEF"
  fun op INDUCTIVE_INVARIANT_ON_DEF _ = ()
  val op INDUCTIVE_INVARIANT_ON_DEF = TDB.find "INDUCTIVE_INVARIANT_ON_DEF"
  fun op inv_DEF _ = () val op inv_DEF = TDB.find "inv_DEF"
  fun op INVOL_DEF _ = () val op INVOL_DEF = TDB.find "INVOL_DEF"
  fun op IDEM_DEF _ = () val op IDEM_DEF = TDB.find "IDEM_DEF"
  fun op O_DEF _ = () val op O_DEF = TDB.find "O_DEF"
  fun op RSUBSET _ = () val op RSUBSET = TDB.find "RSUBSET"
  fun op RUNION _ = () val op RUNION = TDB.find "RUNION"
  fun op RINTER _ = () val op RINTER = TDB.find "RINTER"
  fun op RCOMPL _ = () val op RCOMPL = TDB.find "RCOMPL"
  fun op PreOrder _ = () val op PreOrder = TDB.find "PreOrder"
  fun op Order _ = () val op Order = TDB.find "Order"
  fun op WeakOrder _ = () val op WeakOrder = TDB.find "WeakOrder"
  fun op StrongOrder _ = () val op StrongOrder = TDB.find "StrongOrder"
  fun op STRORD _ = () val op STRORD = TDB.find "STRORD"
  fun op LinearOrder _ = () val op LinearOrder = TDB.find "LinearOrder"
  fun op StrongLinearOrder _ = ()
  val op StrongLinearOrder = TDB.find "StrongLinearOrder"
  fun op WeakLinearOrder _ = ()
  val op WeakLinearOrder = TDB.find "WeakLinearOrder"
  fun op diag_def _ = () val op diag_def = TDB.find "diag_def"
  fun op RDOM_DEF _ = () val op RDOM_DEF = TDB.find "RDOM_DEF"
  fun op RRANGE _ = () val op RRANGE = TDB.find "RRANGE"
  fun op RUNIV _ = () val op RUNIV = TDB.find "RUNIV"
  fun op RRESTRICT_DEF _ = ()
  val op RRESTRICT_DEF = TDB.find "RRESTRICT_DEF"
  fun op RDOM_DELETE_DEF _ = ()
  val op RDOM_DELETE_DEF = TDB.find "RDOM_DELETE_DEF"
  fun op diamond_def _ = () val op diamond_def = TDB.find "diamond_def"
  fun op rcdiamond_def _ = ()
  val op rcdiamond_def = TDB.find "rcdiamond_def"
  fun op CR_def _ = () val op CR_def = TDB.find "CR_def"
  fun op WCR_def _ = () val op WCR_def = TDB.find "WCR_def"
  fun op SN_def _ = () val op SN_def = TDB.find "SN_def"
  fun op nf_def _ = () val op nf_def = TDB.find "nf_def"
  fun op RTC_rules _ = () val op RTC_rules = TDB.find "RTC_rules"
  fun op RTC_ind _ = () val op RTC_ind = TDB.find "RTC_ind"
  fun op RTC_strongind _ = ()
  val op RTC_strongind = TDB.find "RTC_strongind"
  fun op RTC_cases _ = () val op RTC_cases = TDB.find "RTC_cases"
  fun op SC_SYMMETRIC _ = () val op SC_SYMMETRIC = TDB.find "SC_SYMMETRIC"
  fun op TC_TRANSITIVE _ = ()
  val op TC_TRANSITIVE = TDB.find "TC_TRANSITIVE"
  fun op RTC_INDUCT _ = () val op RTC_INDUCT = TDB.find "RTC_INDUCT"
  fun op TC_RULES _ = () val op TC_RULES = TDB.find "TC_RULES"
  fun op RTC_RULES _ = () val op RTC_RULES = TDB.find "RTC_RULES"
  fun op RTC_REFL _ = () val op RTC_REFL = TDB.find "RTC_REFL"
  fun op RTC_SINGLE _ = () val op RTC_SINGLE = TDB.find "RTC_SINGLE"
  fun op RTC_STRONG_INDUCT _ = ()
  val op RTC_STRONG_INDUCT = TDB.find "RTC_STRONG_INDUCT"
  fun op RTC_RTC _ = () val op RTC_RTC = TDB.find "RTC_RTC"
  fun op RTC_TRANSITIVE _ = ()
  val op RTC_TRANSITIVE = TDB.find "RTC_TRANSITIVE"
  fun op transitive_RTC _ = ()
  val op transitive_RTC = TDB.find "transitive_RTC"
  fun op RTC_REFLEXIVE _ = ()
  val op RTC_REFLEXIVE = TDB.find "RTC_REFLEXIVE"
  fun op reflexive_RTC _ = ()
  val op reflexive_RTC = TDB.find "reflexive_RTC"
  fun op RC_REFLEXIVE _ = () val op RC_REFLEXIVE = TDB.find "RC_REFLEXIVE"
  fun op reflexive_RC _ = () val op reflexive_RC = TDB.find "reflexive_RC"
  fun op RC_lifts_monotonicities _ = ()
  val op RC_lifts_monotonicities = TDB.find "RC_lifts_monotonicities"
  fun op RC_MONOTONE _ = () val op RC_MONOTONE = TDB.find "RC_MONOTONE"
  fun op RC_lifts_invariants _ = ()
  val op RC_lifts_invariants = TDB.find "RC_lifts_invariants"
  fun op RC_lifts_equalities _ = ()
  val op RC_lifts_equalities = TDB.find "RC_lifts_equalities"
  fun op SC_lifts_monotonicities _ = ()
  val op SC_lifts_monotonicities = TDB.find "SC_lifts_monotonicities"
  fun op SC_lifts_equalities _ = ()
  val op SC_lifts_equalities = TDB.find "SC_lifts_equalities"
  fun op SC_MONOTONE _ = () val op SC_MONOTONE = TDB.find "SC_MONOTONE"
  fun op symmetric_RC _ = () val op symmetric_RC = TDB.find "symmetric_RC"
  fun op antisymmetric_RC _ = ()
  val op antisymmetric_RC = TDB.find "antisymmetric_RC"
  fun op transitive_RC _ = ()
  val op transitive_RC = TDB.find "transitive_RC"
  fun op TC_SUBSET _ = () val op TC_SUBSET = TDB.find "TC_SUBSET"
  fun op RTC_SUBSET _ = () val op RTC_SUBSET = TDB.find "RTC_SUBSET"
  fun op RC_SUBSET _ = () val op RC_SUBSET = TDB.find "RC_SUBSET"
  fun op RC_RTC _ = () val op RC_RTC = TDB.find "RC_RTC"
  fun op TC_INDUCT _ = () val op TC_INDUCT = TDB.find "TC_INDUCT"
  fun op TC_INDUCT_LEFT1 _ = ()
  val op TC_INDUCT_LEFT1 = TDB.find "TC_INDUCT_LEFT1"
  fun op TC_INDUCT_RIGHT1 _ = ()
  val op TC_INDUCT_RIGHT1 = TDB.find "TC_INDUCT_RIGHT1"
  fun op TC_STRONG_INDUCT _ = ()
  val op TC_STRONG_INDUCT = TDB.find "TC_STRONG_INDUCT"
  fun op TC_STRONG_INDUCT_LEFT1 _ = ()
  val op TC_STRONG_INDUCT_LEFT1 = TDB.find "TC_STRONG_INDUCT_LEFT1"
  fun op TC_STRONG_INDUCT_RIGHT1 _ = ()
  val op TC_STRONG_INDUCT_RIGHT1 = TDB.find "TC_STRONG_INDUCT_RIGHT1"
  fun op TC_INDUCT_ALT_LEFT _ = ()
  val op TC_INDUCT_ALT_LEFT = TDB.find "TC_INDUCT_ALT_LEFT"
  fun op TC_INDUCT_ALT_RIGHT _ = ()
  val op TC_INDUCT_ALT_RIGHT = TDB.find "TC_INDUCT_ALT_RIGHT"
  fun op TC_lifts_monotonicities _ = ()
  val op TC_lifts_monotonicities = TDB.find "TC_lifts_monotonicities"
  fun op TC_lifts_invariants _ = ()
  val op TC_lifts_invariants = TDB.find "TC_lifts_invariants"
  fun op TC_lifts_equalities _ = ()
  val op TC_lifts_equalities = TDB.find "TC_lifts_equalities"
  fun op TC_lifts_transitive_relations _ = ()
  val op TC_lifts_transitive_relations = TDB.find
    "TC_lifts_transitive_relations"
  fun op TC_implies_one_step _ = ()
  val op TC_implies_one_step = TDB.find "TC_implies_one_step"
  fun op TC_RTC _ = () val op TC_RTC = TDB.find "TC_RTC"
  fun op RTC_TC_RC _ = () val op RTC_TC_RC = TDB.find "RTC_TC_RC"
  fun op TC_RC_EQNS _ = () val op TC_RC_EQNS = TDB.find "TC_RC_EQNS"
  fun op RTC_ALT_DEF _ = () val op RTC_ALT_DEF = TDB.find "RTC_ALT_DEF"
  fun op RTC_ALT_INDUCT _ = ()
  val op RTC_ALT_INDUCT = TDB.find "RTC_ALT_INDUCT"
  fun op RTC_ALT_RIGHT_DEF _ = ()
  val op RTC_ALT_RIGHT_DEF = TDB.find "RTC_ALT_RIGHT_DEF"
  fun op RTC_ALT_RIGHT_INDUCT _ = ()
  val op RTC_ALT_RIGHT_INDUCT = TDB.find "RTC_ALT_RIGHT_INDUCT"
  fun op RTC_INDUCT_RIGHT1 _ = ()
  val op RTC_INDUCT_RIGHT1 = TDB.find "RTC_INDUCT_RIGHT1"
  fun op RTC_RULES_RIGHT1 _ = ()
  val op RTC_RULES_RIGHT1 = TDB.find "RTC_RULES_RIGHT1"
  fun op RTC_STRONG_INDUCT_RIGHT1 _ = ()
  val op RTC_STRONG_INDUCT_RIGHT1 = TDB.find "RTC_STRONG_INDUCT_RIGHT1"
  fun op EXTEND_RTC_TC _ = ()
  val op EXTEND_RTC_TC = TDB.find "EXTEND_RTC_TC"
  fun op EXTEND_RTC_TC_EQN _ = ()
  val op EXTEND_RTC_TC_EQN = TDB.find "EXTEND_RTC_TC_EQN"
  fun op reflexive_RC_identity _ = ()
  val op reflexive_RC_identity = TDB.find "reflexive_RC_identity"
  fun op symmetric_SC_identity _ = ()
  val op symmetric_SC_identity = TDB.find "symmetric_SC_identity"
  fun op transitive_TC_identity _ = ()
  val op transitive_TC_identity = TDB.find "transitive_TC_identity"
  fun op RC_IDEM _ = () val op RC_IDEM = TDB.find "RC_IDEM"
  fun op SC_IDEM _ = () val op SC_IDEM = TDB.find "SC_IDEM"
  fun op TC_IDEM _ = () val op TC_IDEM = TDB.find "TC_IDEM"
  fun op RC_MOVES_OUT _ = () val op RC_MOVES_OUT = TDB.find "RC_MOVES_OUT"
  fun op symmetric_TC _ = () val op symmetric_TC = TDB.find "symmetric_TC"
  fun op reflexive_TC _ = () val op reflexive_TC = TDB.find "reflexive_TC"
  fun op EQC_EQUIVALENCE _ = ()
  val op EQC_EQUIVALENCE = TDB.find "EQC_EQUIVALENCE"
  fun op EQC_IDEM _ = () val op EQC_IDEM = TDB.find "EQC_IDEM"
  fun op RTC_IDEM _ = () val op RTC_IDEM = TDB.find "RTC_IDEM"
  fun op RTC_CASES1 _ = () val op RTC_CASES1 = TDB.find "RTC_CASES1"
  fun op RTC_CASES_TC _ = () val op RTC_CASES_TC = TDB.find "RTC_CASES_TC"
  fun op RTC_CASES2 _ = () val op RTC_CASES2 = TDB.find "RTC_CASES2"
  fun op RTC_CASES_RTC_TWICE _ = ()
  val op RTC_CASES_RTC_TWICE = TDB.find "RTC_CASES_RTC_TWICE"
  fun op TC_CASES1_E _ = () val op TC_CASES1_E = TDB.find "TC_CASES1_E"
  fun op TC_CASES1 _ = () val op TC_CASES1 = TDB.find "TC_CASES1"
  fun op TC_CASES2_E _ = () val op TC_CASES2_E = TDB.find "TC_CASES2_E"
  fun op TC_CASES2 _ = () val op TC_CASES2 = TDB.find "TC_CASES2"
  fun op TC_MONOTONE _ = () val op TC_MONOTONE = TDB.find "TC_MONOTONE"
  fun op RTC_MONOTONE _ = () val op RTC_MONOTONE = TDB.find "RTC_MONOTONE"
  fun op EQC_INDUCTION _ = ()
  val op EQC_INDUCTION = TDB.find "EQC_INDUCTION"
  fun op EQC_REFL _ = () val op EQC_REFL = TDB.find "EQC_REFL"
  fun op EQC_R _ = () val op EQC_R = TDB.find "EQC_R"
  fun op EQC_SYM _ = () val op EQC_SYM = TDB.find "EQC_SYM"
  fun op EQC_TRANS _ = () val op EQC_TRANS = TDB.find "EQC_TRANS"
  fun op transitive_EQC _ = ()
  val op transitive_EQC = TDB.find "transitive_EQC"
  fun op symmetric_EQC _ = ()
  val op symmetric_EQC = TDB.find "symmetric_EQC"
  fun op reflexive_EQC _ = ()
  val op reflexive_EQC = TDB.find "reflexive_EQC"
  fun op EQC_MOVES_IN _ = () val op EQC_MOVES_IN = TDB.find "EQC_MOVES_IN"
  fun op STRONG_EQC_INDUCTION _ = ()
  val op STRONG_EQC_INDUCTION = TDB.find "STRONG_EQC_INDUCTION"
  fun op ALT_equivalence _ = ()
  val op ALT_equivalence = TDB.find "ALT_equivalence"
  fun op EQC_MONOTONE _ = () val op EQC_MONOTONE = TDB.find "EQC_MONOTONE"
  fun op RTC_EQC _ = () val op RTC_EQC = TDB.find "RTC_EQC"
  fun op RTC_lifts_monotonicities _ = ()
  val op RTC_lifts_monotonicities = TDB.find "RTC_lifts_monotonicities"
  fun op RTC_lifts_reflexive_transitive_relations _ = ()
  val op RTC_lifts_reflexive_transitive_relations = TDB.find
    "RTC_lifts_reflexive_transitive_relations"
  fun op RTC_lifts_equalities _ = ()
  val op RTC_lifts_equalities = TDB.find "RTC_lifts_equalities"
  fun op RTC_lifts_invariants _ = ()
  val op RTC_lifts_invariants = TDB.find "RTC_lifts_invariants"
  fun op WF_INDUCTION_THM _ = ()
  val op WF_INDUCTION_THM = TDB.find "WF_INDUCTION_THM"
  fun op INDUCTION_WF_THM _ = ()
  val op INDUCTION_WF_THM = TDB.find "INDUCTION_WF_THM"
  fun op WF_EQ_INDUCTION_THM _ = ()
  val op WF_EQ_INDUCTION_THM = TDB.find "WF_EQ_INDUCTION_THM"
  fun op WF_NOT_REFL _ = () val op WF_NOT_REFL = TDB.find "WF_NOT_REFL"
  fun op WF_irreflexive _ = ()
  val op WF_irreflexive = TDB.find "WF_irreflexive"
  fun op WF_EMPTY_REL _ = () val op WF_EMPTY_REL = TDB.find "WF_EMPTY_REL"
  fun op WF_SUBSET _ = () val op WF_SUBSET = TDB.find "WF_SUBSET"
  fun op WF_TC _ = () val op WF_TC = TDB.find "WF_TC"
  fun op WF_TC_EQN _ = () val op WF_TC_EQN = TDB.find "WF_TC_EQN"
  fun op WF_noloops _ = () val op WF_noloops = TDB.find "WF_noloops"
  fun op WF_antisymmetric _ = ()
  val op WF_antisymmetric = TDB.find "WF_antisymmetric"
  fun op inv_image_thm _ = ()
  val op inv_image_thm = TDB.find "inv_image_thm"
  fun op WF_inv_image _ = () val op WF_inv_image = TDB.find "WF_inv_image"
  fun op total_inv_image _ = ()
  val op total_inv_image = TDB.find "total_inv_image"
  fun op reflexive_inv_image _ = ()
  val op reflexive_inv_image = TDB.find "reflexive_inv_image"
  fun op symmetric_inv_image _ = ()
  val op symmetric_inv_image = TDB.find "symmetric_inv_image"
  fun op transitive_inv_image _ = ()
  val op transitive_inv_image = TDB.find "transitive_inv_image"
  fun op RESTRICT_LEMMA _ = ()
  val op RESTRICT_LEMMA = TDB.find "RESTRICT_LEMMA"
  fun op WFREC_THM _ = () val op WFREC_THM = TDB.find "WFREC_THM"
  fun op WFREC_COROLLARY _ = ()
  val op WFREC_COROLLARY = TDB.find "WFREC_COROLLARY"
  fun op WF_RECURSION_THM _ = ()
  val op WF_RECURSION_THM = TDB.find "WF_RECURSION_THM"
  fun op WFP_RULES _ = () val op WFP_RULES = TDB.find "WFP_RULES"
  fun op WFP_INDUCT _ = () val op WFP_INDUCT = TDB.find "WFP_INDUCT"
  fun op WFP_CASES _ = () val op WFP_CASES = TDB.find "WFP_CASES"
  fun op WFP_STRONG_INDUCT _ = ()
  val op WFP_STRONG_INDUCT = TDB.find "WFP_STRONG_INDUCT"
  fun op WF_EQ_WFP _ = () val op WF_EQ_WFP = TDB.find "WF_EQ_WFP"
  fun op INDUCTIVE_INVARIANT_WFREC _ = ()
  val op INDUCTIVE_INVARIANT_WFREC = TDB.find "INDUCTIVE_INVARIANT_WFREC"
  fun op TFL_INDUCTIVE_INVARIANT_WFREC _ = ()
  val op TFL_INDUCTIVE_INVARIANT_WFREC = TDB.find
    "TFL_INDUCTIVE_INVARIANT_WFREC"
  fun op INDUCTIVE_INVARIANT_ON_WFREC _ = ()
  val op INDUCTIVE_INVARIANT_ON_WFREC = TDB.find
    "INDUCTIVE_INVARIANT_ON_WFREC"
  fun op TFL_INDUCTIVE_INVARIANT_ON_WFREC _ = ()
  val op TFL_INDUCTIVE_INVARIANT_ON_WFREC = TDB.find
    "TFL_INDUCTIVE_INVARIANT_ON_WFREC"
  fun op inv_inv _ = () val op inv_inv = TDB.find "inv_inv"
  fun op inv_RC _ = () val op inv_RC = TDB.find "inv_RC"
  fun op inv_SC _ = () val op inv_SC = TDB.find "inv_SC"
  fun op inv_TC _ = () val op inv_TC = TDB.find "inv_TC"
  fun op inv_EQC _ = () val op inv_EQC = TDB.find "inv_EQC"
  fun op inv_MOVES_OUT _ = ()
  val op inv_MOVES_OUT = TDB.find "inv_MOVES_OUT"
  fun op reflexive_inv _ = ()
  val op reflexive_inv = TDB.find "reflexive_inv"
  fun op irreflexive_inv _ = ()
  val op irreflexive_inv = TDB.find "irreflexive_inv"
  fun op symmetric_inv _ = ()
  val op symmetric_inv = TDB.find "symmetric_inv"
  fun op antisymmetric_inv _ = ()
  val op antisymmetric_inv = TDB.find "antisymmetric_inv"
  fun op transitive_inv _ = ()
  val op transitive_inv = TDB.find "transitive_inv"
  fun op symmetric_inv_identity _ = ()
  val op symmetric_inv_identity = TDB.find "symmetric_inv_identity"
  fun op equivalence_inv_identity _ = ()
  val op equivalence_inv_identity = TDB.find "equivalence_inv_identity"
  fun op INVOL _ = () val op INVOL = TDB.find "INVOL"
  fun op INVOL_ONE_ONE _ = ()
  val op INVOL_ONE_ONE = TDB.find "INVOL_ONE_ONE"
  fun op INVOL_ONE_ENO _ = ()
  val op INVOL_ONE_ENO = TDB.find "INVOL_ONE_ENO"
  fun op NOT_INVOL _ = () val op NOT_INVOL = TDB.find "NOT_INVOL"
  fun op IDEM _ = () val op IDEM = TDB.find "IDEM"
  fun op inv_INVOL _ = () val op inv_INVOL = TDB.find "inv_INVOL"
  fun op inv_O _ = () val op inv_O = TDB.find "inv_O"
  fun op irreflexive_RSUBSET _ = ()
  val op irreflexive_RSUBSET = TDB.find "irreflexive_RSUBSET"
  fun op RUNION_COMM _ = () val op RUNION_COMM = TDB.find "RUNION_COMM"
  fun op RUNION_ASSOC _ = () val op RUNION_ASSOC = TDB.find "RUNION_ASSOC"
  fun op RINTER_COMM _ = () val op RINTER_COMM = TDB.find "RINTER_COMM"
  fun op RINTER_ASSOC _ = () val op RINTER_ASSOC = TDB.find "RINTER_ASSOC"
  fun op antisymmetric_RINTER _ = ()
  val op antisymmetric_RINTER = TDB.find "antisymmetric_RINTER"
  fun op transitive_RINTER _ = ()
  val op transitive_RINTER = TDB.find "transitive_RINTER"
  fun op RTC_RINTER _ = () val op RTC_RINTER = TDB.find "RTC_RINTER"
  fun op reflexive_Id_RSUBSET _ = ()
  val op reflexive_Id_RSUBSET = TDB.find "reflexive_Id_RSUBSET"
  fun op symmetric_inv_RSUBSET _ = ()
  val op symmetric_inv_RSUBSET = TDB.find "symmetric_inv_RSUBSET"
  fun op transitive_O_RSUBSET _ = ()
  val op transitive_O_RSUBSET = TDB.find "transitive_O_RSUBSET"
  fun op irrefl_trans_implies_antisym _ = ()
  val op irrefl_trans_implies_antisym = TDB.find
    "irrefl_trans_implies_antisym"
  fun op StrongOrd_Ord _ = ()
  val op StrongOrd_Ord = TDB.find "StrongOrd_Ord"
  fun op WeakOrd_Ord _ = () val op WeakOrd_Ord = TDB.find "WeakOrd_Ord"
  fun op WeakOrder_EQ _ = () val op WeakOrder_EQ = TDB.find "WeakOrder_EQ"
  fun op RSUBSET_ANTISYM _ = ()
  val op RSUBSET_ANTISYM = TDB.find "RSUBSET_ANTISYM"
  fun op RSUBSET_antisymmetric _ = ()
  val op RSUBSET_antisymmetric = TDB.find "RSUBSET_antisymmetric"
  fun op RSUBSET_WeakOrder _ = ()
  val op RSUBSET_WeakOrder = TDB.find "RSUBSET_WeakOrder"
  fun op EqIsBothRSUBSET _ = ()
  val op EqIsBothRSUBSET = TDB.find "EqIsBothRSUBSET"
  fun op STRORD_AND_NOT_Id _ = ()
  val op STRORD_AND_NOT_Id = TDB.find "STRORD_AND_NOT_Id"
  fun op RC_OR_Id _ = () val op RC_OR_Id = TDB.find "RC_OR_Id"
  fun op RC_Weak _ = () val op RC_Weak = TDB.find "RC_Weak"
  fun op STRORD_Strong _ = ()
  val op STRORD_Strong = TDB.find "STRORD_Strong"
  fun op STRORD_RC _ = () val op STRORD_RC = TDB.find "STRORD_RC"
  fun op RC_STRORD _ = () val op RC_STRORD = TDB.find "RC_STRORD"
  fun op IDEM_STRORD _ = () val op IDEM_STRORD = TDB.find "IDEM_STRORD"
  fun op IDEM_RC _ = () val op IDEM_RC = TDB.find "IDEM_RC"
  fun op IDEM_SC _ = () val op IDEM_SC = TDB.find "IDEM_SC"
  fun op IDEM_TC _ = () val op IDEM_TC = TDB.find "IDEM_TC"
  fun op IDEM_RTC _ = () val op IDEM_RTC = TDB.find "IDEM_RTC"
  fun op trichotomous_STRORD _ = ()
  val op trichotomous_STRORD = TDB.find "trichotomous_STRORD"
  fun op trichotomous_RC _ = ()
  val op trichotomous_RC = TDB.find "trichotomous_RC"
  fun op WeakLinearOrder_dichotomy _ = ()
  val op WeakLinearOrder_dichotomy = TDB.find "WeakLinearOrder_dichotomy"
  fun op O_ASSOC _ = () val op O_ASSOC = TDB.find "O_ASSOC"
  fun op Id_O _ = () val op Id_O = TDB.find "Id_O"
  fun op O_Id _ = () val op O_Id = TDB.find "O_Id"
  fun op O_MONO _ = () val op O_MONO = TDB.find "O_MONO"
  fun op inv_Id _ = () val op inv_Id = TDB.find "inv_Id"
  fun op inv_diag _ = () val op inv_diag = TDB.find "inv_diag"
  fun op IN_RDOM _ = () val op IN_RDOM = TDB.find "IN_RDOM"
  fun op IN_RRANGE _ = () val op IN_RRANGE = TDB.find "IN_RRANGE"
  fun op IN_RDOM_RUNION _ = ()
  val op IN_RDOM_RUNION = TDB.find "IN_RDOM_RUNION"
  fun op RUNIV_SUBSET _ = () val op RUNIV_SUBSET = TDB.find "RUNIV_SUBSET"
  fun op REMPTY_SUBSET _ = ()
  val op REMPTY_SUBSET = TDB.find "REMPTY_SUBSET"
  fun op IN_RDOM_RRESTRICT _ = ()
  val op IN_RDOM_RRESTRICT = TDB.find "IN_RDOM_RRESTRICT"
  fun op IN_RDOM_DELETE _ = ()
  val op IN_RDOM_DELETE = TDB.find "IN_RDOM_DELETE"
  fun op rcdiamond_diamond _ = ()
  val op rcdiamond_diamond = TDB.find "rcdiamond_diamond"
  fun op diamond_RC_diamond _ = ()
  val op diamond_RC_diamond = TDB.find "diamond_RC_diamond"
  fun op diamond_TC_diamond _ = ()
  val op diamond_TC_diamond = TDB.find "diamond_TC_diamond"
  fun op establish_CR _ = () val op establish_CR = TDB.find "establish_CR"
  fun op Newmans_lemma _ = ()
  val op Newmans_lemma = TDB.find "Newmans_lemma"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val relation_grammars = merge_grammars ["normalForms", "sat", "combin"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="relation"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val relation_grammars = 
    Portable.## (addtyUDs,addtmUDs) relation_grammars
  val _ = Parse.grammarDB_insert("relation",relation_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "relation"

end
