structure canonicalTheory :> canonicalTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading canonicalTheory ... "
    else ()
  
  open Type Term Thm
  local open quoteTheory semi_ringTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "canonical"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/ring/src/canonicalTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op canonical_sum_TY_DEF _ = ()
  val op canonical_sum_TY_DEF = TDB.find "canonical_sum_TY_DEF"
  fun op canonical_sum_case_def _ = ()
  val op canonical_sum_case_def = TDB.find "canonical_sum_case_def"
  fun op canonical_sum_size_def _ = ()
  val op canonical_sum_size_def = TDB.find "canonical_sum_size_def"
  fun op canonical_sum_scalar_def _ = ()
  val op canonical_sum_scalar_def = TDB.find "canonical_sum_scalar_def"
  fun op canonical_sum_scalar2_def _ = ()
  val op canonical_sum_scalar2_def = TDB.find "canonical_sum_scalar2_def"
  fun op canonical_sum_scalar3_def _ = ()
  val op canonical_sum_scalar3_def = TDB.find "canonical_sum_scalar3_def"
  fun op canonical_sum_prod_def _ = ()
  val op canonical_sum_prod_def = TDB.find "canonical_sum_prod_def"
  fun op canonical_sum_simplify_def _ = ()
  val op canonical_sum_simplify_def = TDB.find "canonical_sum_simplify_def"
  fun op ivl_aux_def _ = () val op ivl_aux_def = TDB.find "ivl_aux_def"
  fun op interp_vl_def _ = ()
  val op interp_vl_def = TDB.find "interp_vl_def"
  fun op interp_m_def _ = () val op interp_m_def = TDB.find "interp_m_def"
  fun op ics_aux_def _ = () val op ics_aux_def = TDB.find "ics_aux_def"
  fun op interp_cs_def _ = ()
  val op interp_cs_def = TDB.find "interp_cs_def"
  fun op spolynom_TY_DEF _ = ()
  val op spolynom_TY_DEF = TDB.find "spolynom_TY_DEF"
  fun op spolynom_case_def _ = ()
  val op spolynom_case_def = TDB.find "spolynom_case_def"
  fun op spolynom_size_def _ = ()
  val op spolynom_size_def = TDB.find "spolynom_size_def"
  fun op spolynom_normalize_def _ = ()
  val op spolynom_normalize_def = TDB.find "spolynom_normalize_def"
  fun op spolynom_simplify_def _ = ()
  val op spolynom_simplify_def = TDB.find "spolynom_simplify_def"
  fun op interp_sp_def _ = ()
  val op interp_sp_def = TDB.find "interp_sp_def"
  fun op datatype_canonical_sum _ = ()
  val op datatype_canonical_sum = TDB.find "datatype_canonical_sum"
  fun op canonical_sum_11 _ = ()
  val op canonical_sum_11 = TDB.find "canonical_sum_11"
  fun op canonical_sum_distinct _ = ()
  val op canonical_sum_distinct = TDB.find "canonical_sum_distinct"
  fun op canonical_sum_nchotomy _ = ()
  val op canonical_sum_nchotomy = TDB.find "canonical_sum_nchotomy"
  fun op canonical_sum_Axiom _ = ()
  val op canonical_sum_Axiom = TDB.find "canonical_sum_Axiom"
  fun op canonical_sum_induction _ = ()
  val op canonical_sum_induction = TDB.find "canonical_sum_induction"
  fun op canonical_sum_case_cong _ = ()
  val op canonical_sum_case_cong = TDB.find "canonical_sum_case_cong"
  fun op canonical_sum_case_eq _ = ()
  val op canonical_sum_case_eq = TDB.find "canonical_sum_case_eq"
  fun op canonical_sum_merge_ind _ = ()
  val op canonical_sum_merge_ind = TDB.find "canonical_sum_merge_ind"
  fun op canonical_sum_merge_def _ = ()
  val op canonical_sum_merge_def = TDB.find "canonical_sum_merge_def"
  fun op monom_insert_ind _ = ()
  val op monom_insert_ind = TDB.find "monom_insert_ind"
  fun op monom_insert_def _ = ()
  val op monom_insert_def = TDB.find "monom_insert_def"
  fun op varlist_insert_ind _ = ()
  val op varlist_insert_ind = TDB.find "varlist_insert_ind"
  fun op varlist_insert_def _ = ()
  val op varlist_insert_def = TDB.find "varlist_insert_def"
  fun op ivl_aux_ok _ = () val op ivl_aux_ok = TDB.find "ivl_aux_ok"
  fun op varlist_merge_ok _ = ()
  val op varlist_merge_ok = TDB.find "varlist_merge_ok"
  fun op ics_aux_ok _ = () val op ics_aux_ok = TDB.find "ics_aux_ok"
  fun op interp_m_ok _ = () val op interp_m_ok = TDB.find "interp_m_ok"
  fun op canonical_sum_merge_ok _ = ()
  val op canonical_sum_merge_ok = TDB.find "canonical_sum_merge_ok"
  fun op monom_insert_ok _ = ()
  val op monom_insert_ok = TDB.find "monom_insert_ok"
  fun op varlist_insert_ok _ = ()
  val op varlist_insert_ok = TDB.find "varlist_insert_ok"
  fun op canonical_sum_scalar_ok _ = ()
  val op canonical_sum_scalar_ok = TDB.find "canonical_sum_scalar_ok"
  fun op canonical_sum_scalar2_ok _ = ()
  val op canonical_sum_scalar2_ok = TDB.find "canonical_sum_scalar2_ok"
  fun op canonical_sum_scalar3_ok _ = ()
  val op canonical_sum_scalar3_ok = TDB.find "canonical_sum_scalar3_ok"
  fun op canonical_sum_prod_ok _ = ()
  val op canonical_sum_prod_ok = TDB.find "canonical_sum_prod_ok"
  fun op canonical_sum_simplify_ok _ = ()
  val op canonical_sum_simplify_ok = TDB.find "canonical_sum_simplify_ok"
  fun op datatype_spolynom _ = ()
  val op datatype_spolynom = TDB.find "datatype_spolynom"
  fun op spolynom_11 _ = () val op spolynom_11 = TDB.find "spolynom_11"
  fun op spolynom_distinct _ = ()
  val op spolynom_distinct = TDB.find "spolynom_distinct"
  fun op spolynom_nchotomy _ = ()
  val op spolynom_nchotomy = TDB.find "spolynom_nchotomy"
  fun op spolynom_Axiom _ = ()
  val op spolynom_Axiom = TDB.find "spolynom_Axiom"
  fun op spolynom_induction _ = ()
  val op spolynom_induction = TDB.find "spolynom_induction"
  fun op spolynom_case_cong _ = ()
  val op spolynom_case_cong = TDB.find "spolynom_case_cong"
  fun op spolynom_case_eq _ = ()
  val op spolynom_case_eq = TDB.find "spolynom_case_eq"
  fun op spolynomial_normalize_ok _ = ()
  val op spolynomial_normalize_ok = TDB.find "spolynomial_normalize_ok"
  fun op spolynomial_simplify_ok _ = ()
  val op spolynomial_simplify_ok = TDB.find "spolynomial_simplify_ok"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val canonical_grammars = merge_grammars ["semi_ring", "quote"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="canonical"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val canonical_grammars = 
    Portable.## (addtyUDs,addtmUDs) canonical_grammars
  val _ = Parse.grammarDB_insert("canonical",canonical_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  fun IMPORT P =
    let open Parse abstraction
        fun sing [x] = x | sing _ = raise Match
        val sr = sing (#Vals P)
        val ctab =
          [ Term`interp_sp ^sr`,
            Term`spolynom_simplify ^sr`,
            Term`spolynom_normalize ^sr`,
            Term`interp_cs ^sr`,
            Term`ics_aux ^sr`,
            Term`interp_m ^sr`,
            Term`interp_vl ^sr`,
            Term`ivl_aux ^sr`,
            Term`canonical_sum_simplify ^sr`,
            Term`canonical_sum_prod ^sr`,
            Term`canonical_sum_scalar3 ^sr`,
            Term`canonical_sum_scalar2 ^sr`,
            Term`canonical_sum_scalar ^sr`,
            Term`varlist_insert ^sr`,
            Term`monom_insert ^sr`,
            Term`canonical_sum_merge ^sr` ]
        val inst_fun = inst_thm_fun (compute_inst_infos ctab P) in
    { canonical_sum_case_def = inst_fun canonical_sum_case_def,
      canonical_sum_prod_def = inst_fun canonical_sum_prod_def,
      canonical_sum_scalar2_def = inst_fun canonical_sum_scalar2_def,
      canonical_sum_scalar3_def = inst_fun canonical_sum_scalar3_def,
      canonical_sum_scalar_def = inst_fun canonical_sum_scalar_def,
      canonical_sum_simplify_def = inst_fun canonical_sum_simplify_def,
      canonical_sum_size_def = inst_fun canonical_sum_size_def,
      canonical_sum_TY_DEF = inst_fun canonical_sum_TY_DEF,
      ics_aux_def = inst_fun ics_aux_def,
      interp_cs_def = inst_fun interp_cs_def,
      interp_m_def = inst_fun interp_m_def,
      interp_sp_def = inst_fun interp_sp_def,
      interp_vl_def = inst_fun interp_vl_def,
      ivl_aux_def = inst_fun ivl_aux_def,
      spolynom_case_def = inst_fun spolynom_case_def,
      spolynom_normalize_def = inst_fun spolynom_normalize_def,
      spolynom_simplify_def = inst_fun spolynom_simplify_def,
      spolynom_size_def = inst_fun spolynom_size_def,
      spolynom_TY_DEF = inst_fun spolynom_TY_DEF,
      canonical_sum_11 = inst_fun canonical_sum_11,
      canonical_sum_Axiom = inst_fun canonical_sum_Axiom,
      canonical_sum_case_cong = inst_fun canonical_sum_case_cong,
      canonical_sum_case_eq = inst_fun canonical_sum_case_eq,
      canonical_sum_distinct = inst_fun canonical_sum_distinct,
      canonical_sum_induction = inst_fun canonical_sum_induction,
      canonical_sum_merge_def = inst_fun canonical_sum_merge_def,
      canonical_sum_merge_ind = inst_fun canonical_sum_merge_ind,
      canonical_sum_merge_ok = inst_fun canonical_sum_merge_ok,
      canonical_sum_nchotomy = inst_fun canonical_sum_nchotomy,
      canonical_sum_prod_ok = inst_fun canonical_sum_prod_ok,
      canonical_sum_scalar2_ok = inst_fun canonical_sum_scalar2_ok,
      canonical_sum_scalar3_ok = inst_fun canonical_sum_scalar3_ok,
      canonical_sum_scalar_ok = inst_fun canonical_sum_scalar_ok,
      canonical_sum_simplify_ok = inst_fun canonical_sum_simplify_ok,
      datatype_canonical_sum = inst_fun datatype_canonical_sum,
      datatype_spolynom = inst_fun datatype_spolynom,
      ics_aux_ok = inst_fun ics_aux_ok,
      interp_m_ok = inst_fun interp_m_ok,
      ivl_aux_ok = inst_fun ivl_aux_ok,
      monom_insert_def = inst_fun monom_insert_def,
      monom_insert_ind = inst_fun monom_insert_ind,
      monom_insert_ok = inst_fun monom_insert_ok,
      spolynom_11 = inst_fun spolynom_11,
      spolynom_Axiom = inst_fun spolynom_Axiom,
      spolynom_case_cong = inst_fun spolynom_case_cong,
      spolynom_case_eq = inst_fun spolynom_case_eq,
      spolynom_distinct = inst_fun spolynom_distinct,
      spolynom_induction = inst_fun spolynom_induction,
      spolynom_nchotomy = inst_fun spolynom_nchotomy,
      spolynomial_normalize_ok = inst_fun spolynomial_normalize_ok,
      spolynomial_simplify_ok = inst_fun spolynomial_simplify_ok,
      varlist_insert_def = inst_fun varlist_insert_def,
      varlist_insert_ind = inst_fun varlist_insert_ind,
      varlist_insert_ok = inst_fun varlist_insert_ok,
      varlist_merge_ok = inst_fun varlist_merge_ok }
    end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "canonical"

end
