structure numRingTheory :> numRingTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading numRingTheory ... "
    else ()
  
  open Type Term Thm
  local open ringNormTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "numRing"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/ring/src/numRingTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op num_interp_sp_def _ = ()
  val op num_interp_sp_def = TDB.find "num_interp_sp_def"
  fun op num_spolynom_simplify_def _ = ()
  val op num_spolynom_simplify_def = TDB.find "num_spolynom_simplify_def"
  fun op num_spolynom_normalize_def _ = ()
  val op num_spolynom_normalize_def = TDB.find "num_spolynom_normalize_def"
  fun op num_interp_cs_def _ = ()
  val op num_interp_cs_def = TDB.find "num_interp_cs_def"
  fun op num_ics_aux_def _ = ()
  val op num_ics_aux_def = TDB.find "num_ics_aux_def"
  fun op num_interp_m_def _ = ()
  val op num_interp_m_def = TDB.find "num_interp_m_def"
  fun op num_interp_vl_def _ = ()
  val op num_interp_vl_def = TDB.find "num_interp_vl_def"
  fun op num_ivl_aux_def _ = ()
  val op num_ivl_aux_def = TDB.find "num_ivl_aux_def"
  fun op num_canonical_sum_simplify_def _ = ()
  val op num_canonical_sum_simplify_def = TDB.find
    "num_canonical_sum_simplify_def"
  fun op num_canonical_sum_prod_def _ = ()
  val op num_canonical_sum_prod_def = TDB.find "num_canonical_sum_prod_def"
  fun op num_canonical_sum_scalar3_def _ = ()
  val op num_canonical_sum_scalar3_def = TDB.find
    "num_canonical_sum_scalar3_def"
  fun op num_canonical_sum_scalar2_def _ = ()
  val op num_canonical_sum_scalar2_def = TDB.find
    "num_canonical_sum_scalar2_def"
  fun op num_canonical_sum_scalar_def _ = ()
  val op num_canonical_sum_scalar_def = TDB.find
    "num_canonical_sum_scalar_def"
  fun op num_varlist_insert_def _ = ()
  val op num_varlist_insert_def = TDB.find "num_varlist_insert_def"
  fun op num_monom_insert_def _ = ()
  val op num_monom_insert_def = TDB.find "num_monom_insert_def"
  fun op num_canonical_sum_merge_def _ = ()
  val op num_canonical_sum_merge_def = TDB.find
    "num_canonical_sum_merge_def"
  fun op num_semi_ring _ = ()
  val op num_semi_ring = TDB.find "num_semi_ring"
  fun op num_ring_thms _ = ()
  val op num_ring_thms = TDB.find "num_ring_thms"
  fun op num_rewrites _ = () val op num_rewrites = TDB.find "num_rewrites"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val numRing_grammars = merge_grammars ["ringNorm"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="numRing"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val numRing_grammars = 
    Portable.## (addtyUDs,addtmUDs) numRing_grammars
  val _ = Parse.grammarDB_insert("numRing",numRing_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "numRing"

end
