structure quoteTheory :> quoteTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading quoteTheory ... "
    else ()
  
  open Type Term Thm
  local open ternaryComparisonsTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "quote"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/ring/src/quoteTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op index_TY_DEF _ = () val op index_TY_DEF = TDB.find "index_TY_DEF"
  fun op index_case_def _ = ()
  val op index_case_def = TDB.find "index_case_def"
  fun op index_size_def _ = ()
  val op index_size_def = TDB.find "index_size_def"
  fun op index_lt_def _ = () val op index_lt_def = TDB.find "index_lt_def"
  fun op varmap_TY_DEF _ = ()
  val op varmap_TY_DEF = TDB.find "varmap_TY_DEF"
  fun op varmap_case_def _ = ()
  val op varmap_case_def = TDB.find "varmap_case_def"
  fun op varmap_size_def _ = ()
  val op varmap_size_def = TDB.find "varmap_size_def"
  fun op datatype_index _ = ()
  val op datatype_index = TDB.find "datatype_index"
  fun op index_11 _ = () val op index_11 = TDB.find "index_11"
  fun op index_distinct _ = ()
  val op index_distinct = TDB.find "index_distinct"
  fun op index_nchotomy _ = ()
  val op index_nchotomy = TDB.find "index_nchotomy"
  fun op index_Axiom _ = () val op index_Axiom = TDB.find "index_Axiom"
  fun op index_induction _ = ()
  val op index_induction = TDB.find "index_induction"
  fun op index_case_cong _ = ()
  val op index_case_cong = TDB.find "index_case_cong"
  fun op index_case_eq _ = ()
  val op index_case_eq = TDB.find "index_case_eq"
  fun op index_compare_ind _ = ()
  val op index_compare_ind = TDB.find "index_compare_ind"
  fun op index_compare_def _ = ()
  val op index_compare_def = TDB.find "index_compare_def"
  fun op compare_index_equal _ = ()
  val op compare_index_equal = TDB.find "compare_index_equal"
  fun op compare_list_index _ = ()
  val op compare_list_index = TDB.find "compare_list_index"
  fun op datatype_varmap _ = ()
  val op datatype_varmap = TDB.find "datatype_varmap"
  fun op varmap_11 _ = () val op varmap_11 = TDB.find "varmap_11"
  fun op varmap_distinct _ = ()
  val op varmap_distinct = TDB.find "varmap_distinct"
  fun op varmap_nchotomy _ = ()
  val op varmap_nchotomy = TDB.find "varmap_nchotomy"
  fun op varmap_Axiom _ = () val op varmap_Axiom = TDB.find "varmap_Axiom"
  fun op varmap_induction _ = ()
  val op varmap_induction = TDB.find "varmap_induction"
  fun op varmap_case_cong _ = ()
  val op varmap_case_cong = TDB.find "varmap_case_cong"
  fun op varmap_case_eq _ = ()
  val op varmap_case_eq = TDB.find "varmap_case_eq"
  fun op varmap_find_ind _ = ()
  val op varmap_find_ind = TDB.find "varmap_find_ind"
  fun op varmap_find_def _ = ()
  val op varmap_find_def = TDB.find "varmap_find_def"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val quote_grammars = merge_grammars ["ternaryComparisons"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="quote"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val quote_grammars = 
    Portable.## (addtyUDs,addtmUDs) quote_grammars
  val _ = Parse.grammarDB_insert("quote",quote_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "quote"

end
