structure ringNormTheory :> ringNormTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ringNormTheory ... "
    else ()
  
  open Type Term Thm
  local open canonicalTheory ringTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ringNorm"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/ring/src/ringNormTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op r_interp_sp_def _ = ()
  val op r_interp_sp_def = TDB.find "r_interp_sp_def"
  fun op r_spolynom_simplify_def _ = ()
  val op r_spolynom_simplify_def = TDB.find "r_spolynom_simplify_def"
  fun op r_spolynom_normalize_def _ = ()
  val op r_spolynom_normalize_def = TDB.find "r_spolynom_normalize_def"
  fun op r_interp_cs_def _ = ()
  val op r_interp_cs_def = TDB.find "r_interp_cs_def"
  fun op r_ics_aux_def _ = ()
  val op r_ics_aux_def = TDB.find "r_ics_aux_def"
  fun op r_interp_m_def _ = ()
  val op r_interp_m_def = TDB.find "r_interp_m_def"
  fun op r_interp_vl_def _ = ()
  val op r_interp_vl_def = TDB.find "r_interp_vl_def"
  fun op r_ivl_aux_def _ = ()
  val op r_ivl_aux_def = TDB.find "r_ivl_aux_def"
  fun op r_canonical_sum_simplify_def _ = ()
  val op r_canonical_sum_simplify_def = TDB.find
    "r_canonical_sum_simplify_def"
  fun op r_canonical_sum_prod_def _ = ()
  val op r_canonical_sum_prod_def = TDB.find "r_canonical_sum_prod_def"
  fun op r_canonical_sum_scalar3_def _ = ()
  val op r_canonical_sum_scalar3_def = TDB.find
    "r_canonical_sum_scalar3_def"
  fun op r_canonical_sum_scalar2_def _ = ()
  val op r_canonical_sum_scalar2_def = TDB.find
    "r_canonical_sum_scalar2_def"
  fun op r_canonical_sum_scalar_def _ = ()
  val op r_canonical_sum_scalar_def = TDB.find "r_canonical_sum_scalar_def"
  fun op r_varlist_insert_def _ = ()
  val op r_varlist_insert_def = TDB.find "r_varlist_insert_def"
  fun op r_monom_insert_def _ = ()
  val op r_monom_insert_def = TDB.find "r_monom_insert_def"
  fun op r_canonical_sum_merge_def _ = ()
  val op r_canonical_sum_merge_def = TDB.find "r_canonical_sum_merge_def"
  fun op polynom_TY_DEF _ = ()
  val op polynom_TY_DEF = TDB.find "polynom_TY_DEF"
  fun op polynom_case_def _ = ()
  val op polynom_case_def = TDB.find "polynom_case_def"
  fun op polynom_size_def _ = ()
  val op polynom_size_def = TDB.find "polynom_size_def"
  fun op polynom_normalize_def _ = ()
  val op polynom_normalize_def = TDB.find "polynom_normalize_def"
  fun op polynom_simplify_def _ = ()
  val op polynom_simplify_def = TDB.find "polynom_simplify_def"
  fun op interp_p_def _ = () val op interp_p_def = TDB.find "interp_p_def"
  fun op interp_sp_def _ = ()
  val op interp_sp_def = TDB.find "interp_sp_def"
  fun op canonical_sum_merge_def _ = ()
  val op canonical_sum_merge_def = TDB.find "canonical_sum_merge_def"
  fun op monom_insert_def _ = ()
  val op monom_insert_def = TDB.find "monom_insert_def"
  fun op varlist_insert_def _ = ()
  val op varlist_insert_def = TDB.find "varlist_insert_def"
  fun op canonical_sum_scalar_def _ = ()
  val op canonical_sum_scalar_def = TDB.find "canonical_sum_scalar_def"
  fun op canonical_sum_scalar2_def _ = ()
  val op canonical_sum_scalar2_def = TDB.find "canonical_sum_scalar2_def"
  fun op canonical_sum_scalar3_def _ = ()
  val op canonical_sum_scalar3_def = TDB.find "canonical_sum_scalar3_def"
  fun op canonical_sum_prod_def _ = ()
  val op canonical_sum_prod_def = TDB.find "canonical_sum_prod_def"
  fun op canonical_sum_simplify_def _ = ()
  val op canonical_sum_simplify_def = TDB.find "canonical_sum_simplify_def"
  fun op ivl_aux_def _ = () val op ivl_aux_def = TDB.find "ivl_aux_def"
  fun op interp_vl_def _ = ()
  val op interp_vl_def = TDB.find "interp_vl_def"
  fun op interp_m_def _ = () val op interp_m_def = TDB.find "interp_m_def"
  fun op ics_aux_def _ = () val op ics_aux_def = TDB.find "ics_aux_def"
  fun op interp_cs_def _ = ()
  val op interp_cs_def = TDB.find "interp_cs_def"
  fun op spolynom_normalize_def _ = ()
  val op spolynom_normalize_def = TDB.find "spolynom_normalize_def"
  fun op spolynom_simplify_def _ = ()
  val op spolynom_simplify_def = TDB.find "spolynom_simplify_def"
  fun op datatype_polynom _ = ()
  val op datatype_polynom = TDB.find "datatype_polynom"
  fun op polynom_11 _ = () val op polynom_11 = TDB.find "polynom_11"
  fun op polynom_distinct _ = ()
  val op polynom_distinct = TDB.find "polynom_distinct"
  fun op polynom_nchotomy _ = ()
  val op polynom_nchotomy = TDB.find "polynom_nchotomy"
  fun op polynom_Axiom _ = ()
  val op polynom_Axiom = TDB.find "polynom_Axiom"
  fun op polynom_induction _ = ()
  val op polynom_induction = TDB.find "polynom_induction"
  fun op polynom_case_cong _ = ()
  val op polynom_case_cong = TDB.find "polynom_case_cong"
  fun op polynom_case_eq _ = ()
  val op polynom_case_eq = TDB.find "polynom_case_eq"
  fun op polynom_normalize_ok _ = ()
  val op polynom_normalize_ok = TDB.find "polynom_normalize_ok"
  fun op polynom_simplify_ok _ = ()
  val op polynom_simplify_ok = TDB.find "polynom_simplify_ok"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ringNorm_grammars = merge_grammars ["ring", "canonical"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ringNorm"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ringNorm_grammars = 
    Portable.## (addtyUDs,addtmUDs) ringNorm_grammars
  val _ = Parse.grammarDB_insert("ringNorm",ringNorm_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  fun IMPORT P =
    let open Parse abstraction
        fun sing [x] = x | sing _ = raise Match
        val r = sing (#Vals P)
        val ctab =
          [ Term`interp_p ^r`,
            Term`polynom_simplify ^r`,
            Term`polynom_normalize ^r`,
            Term`r_canonical_sum_merge ^r`,
            Term`r_monom_insert ^r`,
            Term`r_varlist_insert ^r`,
            Term`r_canonical_sum_scalar ^r`,
            Term`r_canonical_sum_scalar2 ^r`,
            Term`r_canonical_sum_scalar3 ^r`,
            Term`r_canonical_sum_prod ^r`,
            Term`r_canonical_sum_simplify ^r`,
            Term`r_ivl_aux ^r`,
            Term`r_interp_vl ^r`,
            Term`r_interp_m ^r`,
            Term`r_ics_aux ^r`,
            Term`r_interp_cs ^r`,
            Term`r_spolynom_normalize ^r`,
            Term`r_spolynom_simplify ^r`,
            Term`r_interp_sp ^r` ]
        val inst_fun = inst_thm_fun (compute_inst_infos ctab P) in
    { interp_p_def = inst_fun interp_p_def,
      polynom_case_def = inst_fun polynom_case_def,
      polynom_normalize_def = inst_fun polynom_normalize_def,
      polynom_simplify_def = inst_fun polynom_simplify_def,
      polynom_size_def = inst_fun polynom_size_def,
      polynom_TY_DEF = inst_fun polynom_TY_DEF,
      r_canonical_sum_merge_def = inst_fun r_canonical_sum_merge_def,
      r_canonical_sum_prod_def = inst_fun r_canonical_sum_prod_def,
      r_canonical_sum_scalar2_def = inst_fun r_canonical_sum_scalar2_def,
      r_canonical_sum_scalar3_def = inst_fun r_canonical_sum_scalar3_def,
      r_canonical_sum_scalar_def = inst_fun r_canonical_sum_scalar_def,
      r_canonical_sum_simplify_def = inst_fun r_canonical_sum_simplify_def,
      r_ics_aux_def = inst_fun r_ics_aux_def,
      r_interp_cs_def = inst_fun r_interp_cs_def,
      r_interp_m_def = inst_fun r_interp_m_def,
      r_interp_sp_def = inst_fun r_interp_sp_def,
      r_interp_vl_def = inst_fun r_interp_vl_def,
      r_ivl_aux_def = inst_fun r_ivl_aux_def,
      r_monom_insert_def = inst_fun r_monom_insert_def,
      r_spolynom_normalize_def = inst_fun r_spolynom_normalize_def,
      r_spolynom_simplify_def = inst_fun r_spolynom_simplify_def,
      r_varlist_insert_def = inst_fun r_varlist_insert_def,
      canonical_sum_merge_def = inst_fun canonical_sum_merge_def,
      canonical_sum_prod_def = inst_fun canonical_sum_prod_def,
      canonical_sum_scalar2_def = inst_fun canonical_sum_scalar2_def,
      canonical_sum_scalar3_def = inst_fun canonical_sum_scalar3_def,
      canonical_sum_scalar_def = inst_fun canonical_sum_scalar_def,
      canonical_sum_simplify_def = inst_fun canonical_sum_simplify_def,
      datatype_polynom = inst_fun datatype_polynom,
      ics_aux_def = inst_fun ics_aux_def,
      interp_cs_def = inst_fun interp_cs_def,
      interp_m_def = inst_fun interp_m_def,
      interp_sp_def = inst_fun interp_sp_def,
      interp_vl_def = inst_fun interp_vl_def,
      ivl_aux_def = inst_fun ivl_aux_def,
      monom_insert_def = inst_fun monom_insert_def,
      polynom_11 = inst_fun polynom_11,
      polynom_Axiom = inst_fun polynom_Axiom,
      polynom_case_cong = inst_fun polynom_case_cong,
      polynom_case_eq = inst_fun polynom_case_eq,
      polynom_distinct = inst_fun polynom_distinct,
      polynom_induction = inst_fun polynom_induction,
      polynom_nchotomy = inst_fun polynom_nchotomy,
      polynom_normalize_ok = inst_fun polynom_normalize_ok,
      polynom_simplify_ok = inst_fun polynom_simplify_ok,
      spolynom_normalize_def = inst_fun spolynom_normalize_def,
      spolynom_simplify_def = inst_fun spolynom_simplify_def,
      varlist_insert_def = inst_fun varlist_insert_def }
    end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ringNorm"

end
