structure ringTheory :> ringTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ringTheory ... "
    else ()
  
  open Type Term Thm
  local open semi_ringTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ring"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/ring/src/ringTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ring_TY_DEF _ = () val op ring_TY_DEF = TDB.find "ring_TY_DEF"
  fun op ring_case_def _ = ()
  val op ring_case_def = TDB.find "ring_case_def"
  fun op ring_size_def _ = ()
  val op ring_size_def = TDB.find "ring_size_def"
  fun op ring_R0 _ = () val op ring_R0 = TDB.find "ring_R0"
  fun op ring_R1 _ = () val op ring_R1 = TDB.find "ring_R1"
  fun op ring_RP _ = () val op ring_RP = TDB.find "ring_RP"
  fun op ring_RM _ = () val op ring_RM = TDB.find "ring_RM"
  fun op ring_RN _ = () val op ring_RN = TDB.find "ring_RN"
  fun op ring_R0_fupd _ = () val op ring_R0_fupd = TDB.find "ring_R0_fupd"
  fun op ring_R1_fupd _ = () val op ring_R1_fupd = TDB.find "ring_R1_fupd"
  fun op ring_RP_fupd _ = () val op ring_RP_fupd = TDB.find "ring_RP_fupd"
  fun op ring_RM_fupd _ = () val op ring_RM_fupd = TDB.find "ring_RM_fupd"
  fun op ring_RN_fupd _ = () val op ring_RN_fupd = TDB.find "ring_RN_fupd"
  fun op is_ring_def _ = () val op is_ring_def = TDB.find "is_ring_def"
  fun op semi_ring_of_def _ = ()
  val op semi_ring_of_def = TDB.find "semi_ring_of_def"
  fun op ring_accessors _ = ()
  val op ring_accessors = TDB.find "ring_accessors"
  fun op ring_fn_updates _ = ()
  val op ring_fn_updates = TDB.find "ring_fn_updates"
  fun op ring_accfupds _ = ()
  val op ring_accfupds = TDB.find "ring_accfupds"
  fun op ring_fupdfupds _ = ()
  val op ring_fupdfupds = TDB.find "ring_fupdfupds"
  fun op ring_fupdfupds_comp _ = ()
  val op ring_fupdfupds_comp = TDB.find "ring_fupdfupds_comp"
  fun op ring_fupdcanon _ = ()
  val op ring_fupdcanon = TDB.find "ring_fupdcanon"
  fun op ring_fupdcanon_comp _ = ()
  val op ring_fupdcanon_comp = TDB.find "ring_fupdcanon_comp"
  fun op ring_component_equality _ = ()
  val op ring_component_equality = TDB.find "ring_component_equality"
  fun op ring_updates_eq_literal _ = ()
  val op ring_updates_eq_literal = TDB.find "ring_updates_eq_literal"
  fun op ring_literal_nchotomy _ = ()
  val op ring_literal_nchotomy = TDB.find "ring_literal_nchotomy"
  fun op FORALL_ring _ = () val op FORALL_ring = TDB.find "FORALL_ring"
  fun op EXISTS_ring _ = () val op EXISTS_ring = TDB.find "EXISTS_ring"
  fun op ring_literal_11 _ = ()
  val op ring_literal_11 = TDB.find "ring_literal_11"
  fun op datatype_ring _ = ()
  val op datatype_ring = TDB.find "datatype_ring"
  fun op ring_11 _ = () val op ring_11 = TDB.find "ring_11"
  fun op ring_nchotomy _ = ()
  val op ring_nchotomy = TDB.find "ring_nchotomy"
  fun op ring_Axiom _ = () val op ring_Axiom = TDB.find "ring_Axiom"
  fun op ring_induction _ = ()
  val op ring_induction = TDB.find "ring_induction"
  fun op ring_case_cong _ = ()
  val op ring_case_cong = TDB.find "ring_case_cong"
  fun op ring_case_eq _ = () val op ring_case_eq = TDB.find "ring_case_eq"
  fun op plus_sym _ = () val op plus_sym = TDB.find "plus_sym"
  fun op plus_assoc _ = () val op plus_assoc = TDB.find "plus_assoc"
  fun op mult_sym _ = () val op mult_sym = TDB.find "mult_sym"
  fun op mult_assoc _ = () val op mult_assoc = TDB.find "mult_assoc"
  fun op plus_zero_left _ = ()
  val op plus_zero_left = TDB.find "plus_zero_left"
  fun op mult_one_left _ = ()
  val op mult_one_left = TDB.find "mult_one_left"
  fun op opp_def _ = () val op opp_def = TDB.find "opp_def"
  fun op distr_left _ = () val op distr_left = TDB.find "distr_left"
  fun op plus_zero_right _ = ()
  val op plus_zero_right = TDB.find "plus_zero_right"
  fun op mult_zero_left _ = ()
  val op mult_zero_left = TDB.find "mult_zero_left"
  fun op mult_zero_right _ = ()
  val op mult_zero_right = TDB.find "mult_zero_right"
  fun op ring_is_semi_ring _ = ()
  val op ring_is_semi_ring = TDB.find "ring_is_semi_ring"
  fun op mult_one_right _ = ()
  val op mult_one_right = TDB.find "mult_one_right"
  fun op neg_mult _ = () val op neg_mult = TDB.find "neg_mult"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ring_grammars = merge_grammars ["semi_ring"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ring"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ring_grammars = 
    Portable.## (addtyUDs,addtmUDs) ring_grammars
  val _ = Parse.grammarDB_insert("ring",ring_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  fun IMPORT P =
    let open Parse abstraction
        fun sing [x] = x | sing _ = raise Match
        val r = sing (#Vals P)
        val ctab =
          [ Term`semi_ring_of ^r` ]
        val inst_fun = inst_thm_fun (compute_inst_infos ctab P) in
    { is_ring_def = inst_fun is_ring_def,
      ring_case_def = inst_fun ring_case_def,
      ring_R0 = inst_fun ring_R0,
      ring_R0_fupd = inst_fun ring_R0_fupd,
      ring_R1 = inst_fun ring_R1,
      ring_R1_fupd = inst_fun ring_R1_fupd,
      ring_RM = inst_fun ring_RM,
      ring_RM_fupd = inst_fun ring_RM_fupd,
      ring_RN = inst_fun ring_RN,
      ring_RN_fupd = inst_fun ring_RN_fupd,
      ring_RP = inst_fun ring_RP,
      ring_RP_fupd = inst_fun ring_RP_fupd,
      ring_size_def = inst_fun ring_size_def,
      ring_TY_DEF = inst_fun ring_TY_DEF,
      semi_ring_of_def = inst_fun semi_ring_of_def,
      datatype_ring = inst_fun datatype_ring,
      distr_left = inst_fun distr_left,
      EXISTS_ring = inst_fun EXISTS_ring,
      FORALL_ring = inst_fun FORALL_ring,
      mult_assoc = inst_fun mult_assoc,
      mult_one_left = inst_fun mult_one_left,
      mult_one_right = inst_fun mult_one_right,
      mult_sym = inst_fun mult_sym,
      mult_zero_left = inst_fun mult_zero_left,
      mult_zero_right = inst_fun mult_zero_right,
      neg_mult = inst_fun neg_mult,
      opp_def = inst_fun opp_def,
      plus_assoc = inst_fun plus_assoc,
      plus_sym = inst_fun plus_sym,
      plus_zero_left = inst_fun plus_zero_left,
      plus_zero_right = inst_fun plus_zero_right,
      ring_11 = inst_fun ring_11,
      ring_accessors = inst_fun ring_accessors,
      ring_accfupds = inst_fun ring_accfupds,
      ring_Axiom = inst_fun ring_Axiom,
      ring_case_cong = inst_fun ring_case_cong,
      ring_case_eq = inst_fun ring_case_eq,
      ring_component_equality = inst_fun ring_component_equality,
      ring_fn_updates = inst_fun ring_fn_updates,
      ring_fupdcanon = inst_fun ring_fupdcanon,
      ring_fupdcanon_comp = inst_fun ring_fupdcanon_comp,
      ring_fupdfupds = inst_fun ring_fupdfupds,
      ring_fupdfupds_comp = inst_fun ring_fupdfupds_comp,
      ring_induction = inst_fun ring_induction,
      ring_is_semi_ring = inst_fun ring_is_semi_ring,
      ring_literal_11 = inst_fun ring_literal_11,
      ring_literal_nchotomy = inst_fun ring_literal_nchotomy,
      ring_nchotomy = inst_fun ring_nchotomy,
      ring_updates_eq_literal = inst_fun ring_updates_eq_literal }
    end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ring"

end
