structure semi_ringTheory :> semi_ringTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading semi_ringTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "semi_ring"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/ring/src/semi_ringTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op semi_ring_TY_DEF _ = ()
  val op semi_ring_TY_DEF = TDB.find "semi_ring_TY_DEF"
  fun op semi_ring_case_def _ = ()
  val op semi_ring_case_def = TDB.find "semi_ring_case_def"
  fun op semi_ring_size_def _ = ()
  val op semi_ring_size_def = TDB.find "semi_ring_size_def"
  fun op semi_ring_SR0 _ = ()
  val op semi_ring_SR0 = TDB.find "semi_ring_SR0"
  fun op semi_ring_SR1 _ = ()
  val op semi_ring_SR1 = TDB.find "semi_ring_SR1"
  fun op semi_ring_SRP _ = ()
  val op semi_ring_SRP = TDB.find "semi_ring_SRP"
  fun op semi_ring_SRM _ = ()
  val op semi_ring_SRM = TDB.find "semi_ring_SRM"
  fun op semi_ring_SR0_fupd _ = ()
  val op semi_ring_SR0_fupd = TDB.find "semi_ring_SR0_fupd"
  fun op semi_ring_SR1_fupd _ = ()
  val op semi_ring_SR1_fupd = TDB.find "semi_ring_SR1_fupd"
  fun op semi_ring_SRP_fupd _ = ()
  val op semi_ring_SRP_fupd = TDB.find "semi_ring_SRP_fupd"
  fun op semi_ring_SRM_fupd _ = ()
  val op semi_ring_SRM_fupd = TDB.find "semi_ring_SRM_fupd"
  fun op is_semi_ring_def _ = ()
  val op is_semi_ring_def = TDB.find "is_semi_ring_def"
  fun op semi_ring_accessors _ = ()
  val op semi_ring_accessors = TDB.find "semi_ring_accessors"
  fun op semi_ring_fn_updates _ = ()
  val op semi_ring_fn_updates = TDB.find "semi_ring_fn_updates"
  fun op semi_ring_accfupds _ = ()
  val op semi_ring_accfupds = TDB.find "semi_ring_accfupds"
  fun op semi_ring_fupdfupds _ = ()
  val op semi_ring_fupdfupds = TDB.find "semi_ring_fupdfupds"
  fun op semi_ring_fupdfupds_comp _ = ()
  val op semi_ring_fupdfupds_comp = TDB.find "semi_ring_fupdfupds_comp"
  fun op semi_ring_fupdcanon _ = ()
  val op semi_ring_fupdcanon = TDB.find "semi_ring_fupdcanon"
  fun op semi_ring_fupdcanon_comp _ = ()
  val op semi_ring_fupdcanon_comp = TDB.find "semi_ring_fupdcanon_comp"
  fun op semi_ring_component_equality _ = ()
  val op semi_ring_component_equality = TDB.find
    "semi_ring_component_equality"
  fun op semi_ring_updates_eq_literal _ = ()
  val op semi_ring_updates_eq_literal = TDB.find
    "semi_ring_updates_eq_literal"
  fun op semi_ring_literal_nchotomy _ = ()
  val op semi_ring_literal_nchotomy = TDB.find "semi_ring_literal_nchotomy"
  fun op FORALL_semi_ring _ = ()
  val op FORALL_semi_ring = TDB.find "FORALL_semi_ring"
  fun op EXISTS_semi_ring _ = ()
  val op EXISTS_semi_ring = TDB.find "EXISTS_semi_ring"
  fun op semi_ring_literal_11 _ = ()
  val op semi_ring_literal_11 = TDB.find "semi_ring_literal_11"
  fun op datatype_semi_ring _ = ()
  val op datatype_semi_ring = TDB.find "datatype_semi_ring"
  fun op semi_ring_11 _ = () val op semi_ring_11 = TDB.find "semi_ring_11"
  fun op semi_ring_nchotomy _ = ()
  val op semi_ring_nchotomy = TDB.find "semi_ring_nchotomy"
  fun op semi_ring_Axiom _ = ()
  val op semi_ring_Axiom = TDB.find "semi_ring_Axiom"
  fun op semi_ring_induction _ = ()
  val op semi_ring_induction = TDB.find "semi_ring_induction"
  fun op semi_ring_case_cong _ = ()
  val op semi_ring_case_cong = TDB.find "semi_ring_case_cong"
  fun op semi_ring_case_eq _ = ()
  val op semi_ring_case_eq = TDB.find "semi_ring_case_eq"
  fun op plus_sym _ = () val op plus_sym = TDB.find "plus_sym"
  fun op plus_assoc _ = () val op plus_assoc = TDB.find "plus_assoc"
  fun op mult_sym _ = () val op mult_sym = TDB.find "mult_sym"
  fun op mult_assoc _ = () val op mult_assoc = TDB.find "mult_assoc"
  fun op plus_zero_left _ = ()
  val op plus_zero_left = TDB.find "plus_zero_left"
  fun op mult_one_left _ = ()
  val op mult_one_left = TDB.find "mult_one_left"
  fun op mult_zero_left _ = ()
  val op mult_zero_left = TDB.find "mult_zero_left"
  fun op distr_left _ = () val op distr_left = TDB.find "distr_left"
  fun op plus_zero_right _ = ()
  val op plus_zero_right = TDB.find "plus_zero_right"
  fun op mult_one_right _ = ()
  val op mult_one_right = TDB.find "mult_one_right"
  fun op mult_zero_right _ = ()
  val op mult_zero_right = TDB.find "mult_zero_right"
  fun op distr_right _ = () val op distr_right = TDB.find "distr_right"
  fun op plus_rotate _ = () val op plus_rotate = TDB.find "plus_rotate"
  fun op plus_permute _ = () val op plus_permute = TDB.find "plus_permute"
  fun op mult_rotate _ = () val op mult_rotate = TDB.find "mult_rotate"
  fun op mult_permute _ = () val op mult_permute = TDB.find "mult_permute"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val semi_ring_grammars = merge_grammars ["indexedLists", "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="semi_ring"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val semi_ring_grammars = 
    Portable.## (addtyUDs,addtmUDs) semi_ring_grammars
  val _ = Parse.grammarDB_insert("semi_ring",semi_ring_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  fun IMPORT P =
    let open Parse abstraction
        fun sing [x] = x | sing _ = raise Match
        val r = sing (#Vals P)
        val ctab =
          [ Term`is_semi_ring ^r` ]
        val inst_fun = inst_thm_fun (compute_inst_infos ctab P) in
    { is_semi_ring_def = inst_fun is_semi_ring_def,
      semi_ring_case_def = inst_fun semi_ring_case_def,
      semi_ring_size_def = inst_fun semi_ring_size_def,
      semi_ring_SR0 = inst_fun semi_ring_SR0,
      semi_ring_SR0_fupd = inst_fun semi_ring_SR0_fupd,
      semi_ring_SR1 = inst_fun semi_ring_SR1,
      semi_ring_SR1_fupd = inst_fun semi_ring_SR1_fupd,
      semi_ring_SRM = inst_fun semi_ring_SRM,
      semi_ring_SRM_fupd = inst_fun semi_ring_SRM_fupd,
      semi_ring_SRP = inst_fun semi_ring_SRP,
      semi_ring_SRP_fupd = inst_fun semi_ring_SRP_fupd,
      semi_ring_TY_DEF = inst_fun semi_ring_TY_DEF,
      datatype_semi_ring = inst_fun datatype_semi_ring,
      distr_left = inst_fun distr_left,
      distr_right = inst_fun distr_right,
      EXISTS_semi_ring = inst_fun EXISTS_semi_ring,
      FORALL_semi_ring = inst_fun FORALL_semi_ring,
      mult_assoc = inst_fun mult_assoc,
      mult_one_left = inst_fun mult_one_left,
      mult_one_right = inst_fun mult_one_right,
      mult_permute = inst_fun mult_permute,
      mult_rotate = inst_fun mult_rotate,
      mult_sym = inst_fun mult_sym,
      mult_zero_left = inst_fun mult_zero_left,
      mult_zero_right = inst_fun mult_zero_right,
      plus_assoc = inst_fun plus_assoc,
      plus_permute = inst_fun plus_permute,
      plus_rotate = inst_fun plus_rotate,
      plus_sym = inst_fun plus_sym,
      plus_zero_left = inst_fun plus_zero_left,
      plus_zero_right = inst_fun plus_zero_right,
      semi_ring_11 = inst_fun semi_ring_11,
      semi_ring_accessors = inst_fun semi_ring_accessors,
      semi_ring_accfupds = inst_fun semi_ring_accfupds,
      semi_ring_Axiom = inst_fun semi_ring_Axiom,
      semi_ring_case_cong = inst_fun semi_ring_case_cong,
      semi_ring_case_eq = inst_fun semi_ring_case_eq,
      semi_ring_component_equality = inst_fun semi_ring_component_equality,
      semi_ring_fn_updates = inst_fun semi_ring_fn_updates,
      semi_ring_fupdcanon = inst_fun semi_ring_fupdcanon,
      semi_ring_fupdcanon_comp = inst_fun semi_ring_fupdcanon_comp,
      semi_ring_fupdfupds = inst_fun semi_ring_fupdfupds,
      semi_ring_fupdfupds_comp = inst_fun semi_ring_fupdfupds_comp,
      semi_ring_induction = inst_fun semi_ring_induction,
      semi_ring_literal_11 = inst_fun semi_ring_literal_11,
      semi_ring_literal_nchotomy = inst_fun semi_ring_literal_nchotomy,
      semi_ring_nchotomy = inst_fun semi_ring_nchotomy,
      semi_ring_updates_eq_literal = inst_fun semi_ring_updates_eq_literal }
    end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "semi_ring"

end
