structure bftTheory :> bftTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading bftTheory ... "
    else ()
  
  open Type Term Thm
  local open dirGraphTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "bft"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/search/bftTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op Rel_def _ = () val op Rel_def = TDB.find "Rel_def"
  fun op BFT_def _ = () val op BFT_def = TDB.find "BFT_def"
  fun op BFT_ind _ = () val op BFT_ind = TDB.find "BFT_ind"
  fun op BFT_CONS _ = () val op BFT_CONS = TDB.find "BFT_CONS"
  fun op BFT_FOLD _ = () val op BFT_FOLD = TDB.find "BFT_FOLD"
  fun op BFT_ALL_DISTINCT _ = ()
  val op BFT_ALL_DISTINCT = TDB.find "BFT_ALL_DISTINCT"
  fun op BFT_REACH_1 _ = () val op BFT_REACH_1 = TDB.find "BFT_REACH_1"
  fun op BFT_REACH_2 _ = () val op BFT_REACH_2 = TDB.find "BFT_REACH_2"
  fun op BFT_REACH_THM _ = ()
  val op BFT_REACH_THM = TDB.find "BFT_REACH_THM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val bft_grammars = merge_grammars ["dirGraph"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="bft"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val bft_grammars = 
    Portable.## (addtyUDs,addtmUDs) bft_grammars
  val _ = Parse.grammarDB_insert("bft",bft_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "bft"

end
