structure dftTheory :> dftTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading dftTheory ... "
    else ()
  
  open Type Term Thm
  local open dirGraphTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "dft"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/search/dftTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op Rel_def _ = () val op Rel_def = TDB.find "Rel_def"
  fun op DFT_def _ = () val op DFT_def = TDB.find "DFT_def"
  fun op DFT_ind _ = () val op DFT_ind = TDB.find "DFT_ind"
  fun op DFT_CONS _ = () val op DFT_CONS = TDB.find "DFT_CONS"
  fun op DFT_FOLD _ = () val op DFT_FOLD = TDB.find "DFT_FOLD"
  fun op DFT_ALL_DISTINCT _ = ()
  val op DFT_ALL_DISTINCT = TDB.find "DFT_ALL_DISTINCT"
  fun op DFT_REACH_1 _ = () val op DFT_REACH_1 = TDB.find "DFT_REACH_1"
  fun op DFT_REACH_2 _ = () val op DFT_REACH_2 = TDB.find "DFT_REACH_2"
  fun op DFT_REACH_THM _ = ()
  val op DFT_REACH_THM = TDB.find "DFT_REACH_THM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val dft_grammars = merge_grammars ["dirGraph"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="dft"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val dft_grammars = 
    Portable.## (addtyUDs,addtmUDs) dft_grammars
  val _ = Parse.grammarDB_insert("dft",dft_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "dft"

end
