structure dirGraphTheory :> dirGraphTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading dirGraphTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "dirGraph"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/search/dirGraphTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op Parents_def _ = () val op Parents_def = TDB.find "Parents_def"
  fun op REACH_def _ = () val op REACH_def = TDB.find "REACH_def"
  fun op REACH_LIST_def _ = ()
  val op REACH_LIST_def = TDB.find "REACH_LIST_def"
  fun op EXCLUDE_def _ = () val op EXCLUDE_def = TDB.find "EXCLUDE_def"
  fun op EXCLUDE_LEM _ = () val op EXCLUDE_LEM = TDB.find "EXCLUDE_LEM"
  fun op REACH_EXCLUDE _ = ()
  val op REACH_EXCLUDE = TDB.find "REACH_EXCLUDE"
  fun op REACH_LEM1 _ = () val op REACH_LEM1 = TDB.find "REACH_LEM1"
  fun op REACH_LEM2 _ = () val op REACH_LEM2 = TDB.find "REACH_LEM2"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val dirGraph_grammars = merge_grammars ["indexedLists", "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="dirGraph"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val dirGraph_grammars = 
    Portable.## (addtyUDs,addtmUDs) dirGraph_grammars
  val _ = Parse.grammarDB_insert("dirGraph",dirGraph_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "dirGraph"

end
