structure mergesortTheory :> mergesortTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading mergesortTheory ... "
    else ()
  
  open Type Term Thm
  local open sortingTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "mergesort"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/sort/mergesortTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op stable_def _ = () val op stable_def = TDB.find "stable_def"
  fun op sort2_def _ = () val op sort2_def = TDB.find "sort2_def"
  fun op sort3_def _ = () val op sort3_def = TDB.find "sort3_def"
  fun op mergesort_def _ = ()
  val op mergesort_def = TDB.find "mergesort_def"
  fun op sort2_tail_def _ = ()
  val op sort2_tail_def = TDB.find "sort2_tail_def"
  fun op sort3_tail_def _ = ()
  val op sort3_tail_def = TDB.find "sort3_tail_def"
  fun op mergesort_tail_def _ = ()
  val op mergesort_tail_def = TDB.find "mergesort_tail_def"
  fun op merge_ind _ = () val op merge_ind = TDB.find "merge_ind"
  fun op merge_def _ = () val op merge_def = TDB.find "merge_def"
  fun op mergesortN_ind _ = ()
  val op mergesortN_ind = TDB.find "mergesortN_ind"
  fun op mergesortN_def _ = ()
  val op mergesortN_def = TDB.find "mergesortN_def"
  fun op merge_tail_ind _ = ()
  val op merge_tail_ind = TDB.find "merge_tail_ind"
  fun op merge_tail_def _ = ()
  val op merge_tail_def = TDB.find "merge_tail_def"
  fun op mergesortN_tail_ind _ = ()
  val op mergesortN_tail_ind = TDB.find "mergesortN_tail_ind"
  fun op mergesortN_tail_def _ = ()
  val op mergesortN_tail_def = TDB.find "mergesortN_tail_def"
  fun op sort2_perm _ = () val op sort2_perm = TDB.find "sort2_perm"
  fun op sort3_perm _ = () val op sort3_perm = TDB.find "sort3_perm"
  fun op merge_perm _ = () val op merge_perm = TDB.find "merge_perm"
  fun op mergesortN_perm _ = ()
  val op mergesortN_perm = TDB.find "mergesortN_perm"
  fun op mergesort_perm _ = ()
  val op mergesort_perm = TDB.find "mergesort_perm"
  fun op sort2_sorted _ = () val op sort2_sorted = TDB.find "sort2_sorted"
  fun op sort3_sorted _ = () val op sort3_sorted = TDB.find "sort3_sorted"
  fun op merge_sorted _ = () val op merge_sorted = TDB.find "merge_sorted"
  fun op mergesortN_sorted _ = ()
  val op mergesortN_sorted = TDB.find "mergesortN_sorted"
  fun op mergesort_sorted _ = ()
  val op mergesort_sorted = TDB.find "mergesort_sorted"
  fun op stable_cong _ = () val op stable_cong = TDB.find "stable_cong"
  fun op stable_trans _ = () val op stable_trans = TDB.find "stable_trans"
  fun op sort2_stable _ = () val op sort2_stable = TDB.find "sort2_stable"
  fun op sort3_stable _ = () val op sort3_stable = TDB.find "sort3_stable"
  fun op filter_merge _ = () val op filter_merge = TDB.find "filter_merge"
  fun op merge_stable _ = () val op merge_stable = TDB.find "merge_stable"
  fun op mergesortN_stable _ = ()
  val op mergesortN_stable = TDB.find "mergesortN_stable"
  fun op mergesort_stable _ = ()
  val op mergesort_stable = TDB.find "mergesort_stable"
  fun op mergesort_STABLE_SORT _ = ()
  val op mergesort_STABLE_SORT = TDB.find "mergesort_STABLE_SORT"
  fun op mergesort_mem _ = ()
  val op mergesort_mem = TDB.find "mergesort_mem"
  fun op sort2_tail_correct _ = ()
  val op sort2_tail_correct = TDB.find "sort2_tail_correct"
  fun op sort3_tail_correct _ = ()
  val op sort3_tail_correct = TDB.find "sort3_tail_correct"
  fun op merge_tail_correct1 _ = ()
  val op merge_tail_correct1 = TDB.find "merge_tail_correct1"
  fun op merge_empty _ = () val op merge_empty = TDB.find "merge_empty"
  fun op merge_tail_correct2 _ = ()
  val op merge_tail_correct2 = TDB.find "merge_tail_correct2"
  fun op mergesortN_correct _ = ()
  val op mergesortN_correct = TDB.find "mergesortN_correct"
  fun op mergesort_tail_correct _ = ()
  val op mergesort_tail_correct = TDB.find "mergesort_tail_correct"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val mergesort_grammars = merge_grammars ["sorting"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="mergesort"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val mergesort_grammars = 
    Portable.## (addtyUDs,addtmUDs) mergesort_grammars
  val _ = Parse.grammarDB_insert("mergesort",mergesort_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "mergesort"

end
