structure sortingTheory :> sortingTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading sortingTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "sorting"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/sort/sortingTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op PERM_DEF _ = () val op PERM_DEF = TDB.find "PERM_DEF"
  fun op SORTS_DEF _ = () val op SORTS_DEF = TDB.find "SORTS_DEF"
  fun op PART_DEF _ = () val op PART_DEF = TDB.find "PART_DEF"
  fun op PARTITION_DEF _ = ()
  val op PARTITION_DEF = TDB.find "PARTITION_DEF"
  fun op PERM_SINGLE_SWAP_DEF _ = ()
  val op PERM_SINGLE_SWAP_DEF = TDB.find "PERM_SINGLE_SWAP_DEF"
  fun op STABLE_DEF _ = () val op STABLE_DEF = TDB.find "STABLE_DEF"
  fun op PART3_DEF _ = () val op PART3_DEF = TDB.find "PART3_DEF"
  fun op PERM_REFL _ = () val op PERM_REFL = TDB.find "PERM_REFL"
  fun op PERM_INTRO _ = () val op PERM_INTRO = TDB.find "PERM_INTRO"
  fun op PERM_transitive _ = ()
  val op PERM_transitive = TDB.find "PERM_transitive"
  fun op PERM_TRANS _ = () val op PERM_TRANS = TDB.find "PERM_TRANS"
  fun op PERM_SYM _ = () val op PERM_SYM = TDB.find "PERM_SYM"
  fun op PERM_CONG _ = () val op PERM_CONG = TDB.find "PERM_CONG"
  fun op PERM_MONO _ = () val op PERM_MONO = TDB.find "PERM_MONO"
  fun op PERM_CONS_IFF _ = ()
  val op PERM_CONS_IFF = TDB.find "PERM_CONS_IFF"
  fun op PERM_NIL _ = () val op PERM_NIL = TDB.find "PERM_NIL"
  fun op PERM_SING _ = () val op PERM_SING = TDB.find "PERM_SING"
  fun op PERM_CONS_EQ_APPEND _ = ()
  val op PERM_CONS_EQ_APPEND = TDB.find "PERM_CONS_EQ_APPEND"
  fun op PERM_APPEND _ = () val op PERM_APPEND = TDB.find "PERM_APPEND"
  fun op CONS_PERM _ = () val op CONS_PERM = TDB.find "CONS_PERM"
  fun op APPEND_PERM_SYM _ = ()
  val op APPEND_PERM_SYM = TDB.find "APPEND_PERM_SYM"
  fun op PERM_SPLIT_IF _ = ()
  val op PERM_SPLIT_IF = TDB.find "PERM_SPLIT_IF"
  fun op PERM_SPLIT _ = () val op PERM_SPLIT = TDB.find "PERM_SPLIT"
  fun op FILTER_EQ_REP _ = ()
  val op FILTER_EQ_REP = TDB.find "FILTER_EQ_REP"
  fun op FILTER_EQ_LENGTHS_EQ _ = ()
  val op FILTER_EQ_LENGTHS_EQ = TDB.find "FILTER_EQ_LENGTHS_EQ"
  fun op PERM_alt _ = () val op PERM_alt = TDB.find "PERM_alt"
  fun op PERM_IND _ = () val op PERM_IND = TDB.find "PERM_IND"
  fun op PERM_SWAP_AT_FRONT _ = ()
  val op PERM_SWAP_AT_FRONT = TDB.find "PERM_SWAP_AT_FRONT"
  fun op PERM_SWAP_L_AT_FRONT _ = ()
  val op PERM_SWAP_L_AT_FRONT = TDB.find "PERM_SWAP_L_AT_FRONT"
  fun op PERM_STRONG_IND _ = ()
  val op PERM_STRONG_IND = TDB.find "PERM_STRONG_IND"
  fun op PERM_LENGTH _ = () val op PERM_LENGTH = TDB.find "PERM_LENGTH"
  fun op PERM_MEM_EQ _ = () val op PERM_MEM_EQ = TDB.find "PERM_MEM_EQ"
  fun op PERM_LIST_TO_SET _ = ()
  val op PERM_LIST_TO_SET = TDB.find "PERM_LIST_TO_SET"
  fun op PERM_BIJ _ = () val op PERM_BIJ = TDB.find "PERM_BIJ"
  fun op PERM_EVERY _ = () val op PERM_EVERY = TDB.find "PERM_EVERY"
  fun op SORTED_IND _ = () val op SORTED_IND = TDB.find "SORTED_IND"
  fun op SORTED_DEF _ = () val op SORTED_DEF = TDB.find "SORTED_DEF"
  fun op SORTED_EQ _ = () val op SORTED_EQ = TDB.find "SORTED_EQ"
  fun op SORTED_APPEND _ = ()
  val op SORTED_APPEND = TDB.find "SORTED_APPEND"
  fun op PART_LENGTH _ = () val op PART_LENGTH = TDB.find "PART_LENGTH"
  fun op PART_LENGTH_LEM _ = ()
  val op PART_LENGTH_LEM = TDB.find "PART_LENGTH_LEM"
  fun op PARTs_HAVE_PROP _ = ()
  val op PARTs_HAVE_PROP = TDB.find "PARTs_HAVE_PROP"
  fun op PART_MEM _ = () val op PART_MEM = TDB.find "PART_MEM"
  fun op QSORT_IND _ = () val op QSORT_IND = TDB.find "QSORT_IND"
  fun op QSORT_DEF _ = () val op QSORT_DEF = TDB.find "QSORT_DEF"
  fun op QSORT_MEM _ = () val op QSORT_MEM = TDB.find "QSORT_MEM"
  fun op QSORT_PERM _ = () val op QSORT_PERM = TDB.find "QSORT_PERM"
  fun op QSORT_SORTED _ = () val op QSORT_SORTED = TDB.find "QSORT_SORTED"
  fun op QSORT_SORTS _ = () val op QSORT_SORTS = TDB.find "QSORT_SORTS"
  fun op PERM_APPEND_IFF _ = ()
  val op PERM_APPEND_IFF = TDB.find "PERM_APPEND_IFF"
  fun op PERM_SINGLE_SWAP_SYM _ = ()
  val op PERM_SINGLE_SWAP_SYM = TDB.find "PERM_SINGLE_SWAP_SYM"
  fun op PERM_SINGLE_SWAP_I _ = ()
  val op PERM_SINGLE_SWAP_I = TDB.find "PERM_SINGLE_SWAP_I"
  fun op PERM_SINGLE_SWAP_APPEND _ = ()
  val op PERM_SINGLE_SWAP_APPEND = TDB.find "PERM_SINGLE_SWAP_APPEND"
  fun op PERM_SINGLE_SWAP_REFL _ = ()
  val op PERM_SINGLE_SWAP_REFL = TDB.find "PERM_SINGLE_SWAP_REFL"
  fun op PERM_SINGLE_SWAP_CONS _ = ()
  val op PERM_SINGLE_SWAP_CONS = TDB.find "PERM_SINGLE_SWAP_CONS"
  fun op PERM_SINGLE_SWAP_TC_CONS _ = ()
  val op PERM_SINGLE_SWAP_TC_CONS = TDB.find "PERM_SINGLE_SWAP_TC_CONS"
  fun op PERM_TC _ = () val op PERM_TC = TDB.find "PERM_TC"
  fun op PERM_RTC _ = () val op PERM_RTC = TDB.find "PERM_RTC"
  fun op PERM_EQC _ = () val op PERM_EQC = TDB.find "PERM_EQC"
  fun op PERM_lifts_transitive_relations _ = ()
  val op PERM_lifts_transitive_relations = TDB.find
    "PERM_lifts_transitive_relations"
  fun op PERM_lifts_equalities _ = ()
  val op PERM_lifts_equalities = TDB.find "PERM_lifts_equalities"
  fun op PERM_lifts_invariants _ = ()
  val op PERM_lifts_invariants = TDB.find "PERM_lifts_invariants"
  fun op PERM_lifts_monotonicities _ = ()
  val op PERM_lifts_monotonicities = TDB.find "PERM_lifts_monotonicities"
  fun op PERM_EQUIVALENCE _ = ()
  val op PERM_EQUIVALENCE = TDB.find "PERM_EQUIVALENCE"
  fun op PERM_EQUIVALENCE_ALT_DEF _ = ()
  val op PERM_EQUIVALENCE_ALT_DEF = TDB.find "PERM_EQUIVALENCE_ALT_DEF"
  fun op ALL_DISTINCT_PERM _ = ()
  val op ALL_DISTINCT_PERM = TDB.find "ALL_DISTINCT_PERM"
  fun op PERM_ALL_DISTINCT _ = ()
  val op PERM_ALL_DISTINCT = TDB.find "PERM_ALL_DISTINCT"
  fun op ALL_DISTINCT_PERM_LIST_TO_SET_TO_LIST _ = ()
  val op ALL_DISTINCT_PERM_LIST_TO_SET_TO_LIST = TDB.find
    "ALL_DISTINCT_PERM_LIST_TO_SET_TO_LIST"
  fun op PERM_MAP _ = () val op PERM_MAP = TDB.find "PERM_MAP"
  fun op PERM_SUM _ = () val op PERM_SUM = TDB.find "PERM_SUM"
  fun op PERM_FILTER _ = () val op PERM_FILTER = TDB.find "PERM_FILTER"
  fun op PERM_REVERSE _ = () val op PERM_REVERSE = TDB.find "PERM_REVERSE"
  fun op PERM_REVERSE_EQ _ = ()
  val op PERM_REVERSE_EQ = TDB.find "PERM_REVERSE_EQ"
  fun op FOLDR_PERM _ = () val op FOLDR_PERM = TDB.find "FOLDR_PERM"
  fun op PERM_SET_TO_LIST_count_COUNT_LIST _ = ()
  val op PERM_SET_TO_LIST_count_COUNT_LIST = TDB.find
    "PERM_SET_TO_LIST_count_COUNT_LIST"
  fun op SUM_IMAGE_count_SUM_GENLIST _ = ()
  val op SUM_IMAGE_count_SUM_GENLIST = TDB.find
    "SUM_IMAGE_count_SUM_GENLIST"
  fun op SUM_IMAGE_count_MULT _ = ()
  val op SUM_IMAGE_count_MULT = TDB.find "SUM_IMAGE_count_MULT"
  fun op sum_of_sums _ = () val op sum_of_sums = TDB.find "sum_of_sums"
  fun op SORTED_NIL _ = () val op SORTED_NIL = TDB.find "SORTED_NIL"
  fun op SORTED_SING _ = () val op SORTED_SING = TDB.find "SORTED_SING"
  fun op SORTED_TL _ = () val op SORTED_TL = TDB.find "SORTED_TL"
  fun op SORTED_EL_SUC _ = ()
  val op SORTED_EL_SUC = TDB.find "SORTED_EL_SUC"
  fun op SORTED_EL_LESS _ = ()
  val op SORTED_EL_LESS = TDB.find "SORTED_EL_LESS"
  fun op SORTED_APPEND_IFF _ = ()
  val op SORTED_APPEND_IFF = TDB.find "SORTED_APPEND_IFF"
  fun op MEM_PERM _ = () val op MEM_PERM = TDB.find "MEM_PERM"
  fun op SORTED_PERM_EQ _ = ()
  val op SORTED_PERM_EQ = TDB.find "SORTED_PERM_EQ"
  fun op QSORT_eq_if_PERM _ = ()
  val op QSORT_eq_if_PERM = TDB.find "QSORT_eq_if_PERM"
  fun op SORTED_FILTER _ = ()
  val op SORTED_FILTER = TDB.find "SORTED_FILTER"
  fun op ALL_DISTINCT_SORTED_WEAKEN _ = ()
  val op ALL_DISTINCT_SORTED_WEAKEN = TDB.find "ALL_DISTINCT_SORTED_WEAKEN"
  fun op PERM_FUN_APPEND_C _ = ()
  val op PERM_FUN_APPEND_C = TDB.find "PERM_FUN_APPEND_C"
  fun op PERM_FUN_CONS _ = ()
  val op PERM_FUN_CONS = TDB.find "PERM_FUN_CONS"
  fun op PERM_FUN_APPEND_CONS _ = ()
  val op PERM_FUN_APPEND_CONS = TDB.find "PERM_FUN_APPEND_CONS"
  fun op PERM_FUN_SWAP_AT_FRONT _ = ()
  val op PERM_FUN_SWAP_AT_FRONT = TDB.find "PERM_FUN_SWAP_AT_FRONT"
  fun op PERM_FUN_CONS_11_SWAP_AT_FRONT _ = ()
  val op PERM_FUN_CONS_11_SWAP_AT_FRONT = TDB.find
    "PERM_FUN_CONS_11_SWAP_AT_FRONT"
  fun op PERM_FUN_CONS_11_APPEND _ = ()
  val op PERM_FUN_CONS_11_APPEND = TDB.find "PERM_FUN_CONS_11_APPEND"
  fun op PERM_FUN_CONS_APPEND_1 _ = ()
  val op PERM_FUN_CONS_APPEND_1 = TDB.find "PERM_FUN_CONS_APPEND_1"
  fun op PERM_FUN_CONS_APPEND_2 _ = ()
  val op PERM_FUN_CONS_APPEND_2 = TDB.find "PERM_FUN_CONS_APPEND_2"
  fun op PERM_FUN_APPEND_APPEND_1 _ = ()
  val op PERM_FUN_APPEND_APPEND_1 = TDB.find "PERM_FUN_APPEND_APPEND_1"
  fun op PERM_FUN_APPEND_APPEND_2 _ = ()
  val op PERM_FUN_APPEND_APPEND_2 = TDB.find "PERM_FUN_APPEND_APPEND_2"
  fun op PERM_FUN_APPEND _ = ()
  val op PERM_FUN_APPEND = TDB.find "PERM_FUN_APPEND"
  fun op PERM_FUN_CONS_IFF _ = ()
  val op PERM_FUN_CONS_IFF = TDB.find "PERM_FUN_CONS_IFF"
  fun op PERM_FUN_APPEND_IFF _ = ()
  val op PERM_FUN_APPEND_IFF = TDB.find "PERM_FUN_APPEND_IFF"
  fun op PERM_FUN_CONG _ = ()
  val op PERM_FUN_CONG = TDB.find "PERM_FUN_CONG"
  fun op PERM_CONG_2 _ = () val op PERM_CONG_2 = TDB.find "PERM_CONG_2"
  fun op PERM_CONG_APPEND_IFF _ = ()
  val op PERM_CONG_APPEND_IFF = TDB.find "PERM_CONG_APPEND_IFF"
  fun op PERM_CONG_APPEND_IFF2 _ = ()
  val op PERM_CONG_APPEND_IFF2 = TDB.find "PERM_CONG_APPEND_IFF2"
  fun op PERM_FUN_SPLIT _ = ()
  val op PERM_FUN_SPLIT = TDB.find "PERM_FUN_SPLIT"
  fun op PERM_REWR _ = () val op PERM_REWR = TDB.find "PERM_REWR"
  fun op PERM_TO_APPEND_SIMPS _ = ()
  val op PERM_TO_APPEND_SIMPS = TDB.find "PERM_TO_APPEND_SIMPS"
  fun op PART3_FILTER _ = () val op PART3_FILTER = TDB.find "PART3_FILTER"
  fun op QSORT3_IND _ = () val op QSORT3_IND = TDB.find "QSORT3_IND"
  fun op QSORT3_DEF _ = () val op QSORT3_DEF = TDB.find "QSORT3_DEF"
  fun op PERM3 _ = () val op PERM3 = TDB.find "PERM3"
  fun op PERM3_FILTER _ = () val op PERM3_FILTER = TDB.find "PERM3_FILTER"
  fun op PERM_QSORT3 _ = () val op PERM_QSORT3 = TDB.find "PERM_QSORT3"
  fun op SORTED_EQ_PART _ = ()
  val op SORTED_EQ_PART = TDB.find "SORTED_EQ_PART"
  fun op QSORT3_SORTS _ = () val op QSORT3_SORTS = TDB.find "QSORT3_SORTS"
  fun op QSORT3_SPLIT _ = () val op QSORT3_SPLIT = TDB.find "QSORT3_SPLIT"
  fun op QSORT3_STABLE _ = ()
  val op QSORT3_STABLE = TDB.find "QSORT3_STABLE"
  fun op QSORT3_MEM _ = () val op QSORT3_MEM = TDB.find "QSORT3_MEM"
  fun op QSORT3_SORTED _ = ()
  val op QSORT3_SORTED = TDB.find "QSORT3_SORTED"
  fun op sorted_count_list _ = ()
  val op sorted_count_list = TDB.find "sorted_count_list"
  fun op sorted_map _ = () val op sorted_map = TDB.find "sorted_map"
  fun op sorted_perm_count_list _ = ()
  val op sorted_perm_count_list = TDB.find "sorted_perm_count_list"
  fun op SORTED_weaken _ = ()
  val op SORTED_weaken = TDB.find "SORTED_weaken"
  fun op less_sorted_eq _ = ()
  val op less_sorted_eq = TDB.find "less_sorted_eq"
  fun op SORTED_GENLIST_PLUS _ = ()
  val op SORTED_GENLIST_PLUS = TDB.find "SORTED_GENLIST_PLUS"
  fun op SORTED_ALL_DISTINCT _ = ()
  val op SORTED_ALL_DISTINCT = TDB.find "SORTED_ALL_DISTINCT"
  fun op sorted_filter _ = ()
  val op sorted_filter = TDB.find "sorted_filter"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val sorting_grammars = merge_grammars ["rich_list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="sorting"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val sorting_grammars = 
    Portable.## (addtyUDs,addtmUDs) sorting_grammars
  val _ = Parse.grammarDB_insert("sorting",sorting_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "sorting"

end
