structure ternaryComparisonsTheory :> ternaryComparisonsTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ternaryComparisonsTheory ... "
    else ()
  
  open Type Term Thm
  local open stringTheory EnumType in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ternaryComparisons"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/sort/ternaryComparisonsTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op ordering_TY_DEF _ = ()
  val op ordering_TY_DEF = TDB.find "ordering_TY_DEF"
  fun op ordering_BIJ _ = () val op ordering_BIJ = TDB.find "ordering_BIJ"
  
  
  
  fun op ordering_size_def _ = ()
  val op ordering_size_def = TDB.find "ordering_size_def"
  fun op ordering_CASE _ = ()
  val op ordering_CASE = TDB.find "ordering_CASE"
  fun op pair_compare_def _ = ()
  val op pair_compare_def = TDB.find "pair_compare_def"
  fun op num_compare_def _ = ()
  val op num_compare_def = TDB.find "num_compare_def"
  fun op char_compare_def _ = ()
  val op char_compare_def = TDB.find "char_compare_def"
  fun op string_compare_def _ = ()
  val op string_compare_def = TDB.find "string_compare_def"
  fun op invert_comparison_def _ = ()
  val op invert_comparison_def = TDB.find "invert_comparison_def"
  fun op num2ordering_ordering2num _ = ()
  val op num2ordering_ordering2num = TDB.find "num2ordering_ordering2num"
  fun op ordering2num_num2ordering _ = ()
  val op ordering2num_num2ordering = TDB.find "ordering2num_num2ordering"
  fun op num2ordering_11 _ = ()
  val op num2ordering_11 = TDB.find "num2ordering_11"
  fun op ordering2num_11 _ = ()
  val op ordering2num_11 = TDB.find "ordering2num_11"
  fun op num2ordering_ONTO _ = ()
  val op num2ordering_ONTO = TDB.find "num2ordering_ONTO"
  fun op ordering2num_ONTO _ = ()
  val op ordering2num_ONTO = TDB.find "ordering2num_ONTO"
  fun op num2ordering_thm _ = ()
  val op num2ordering_thm = TDB.find "num2ordering_thm"
  fun op ordering2num_thm _ = ()
  val op ordering2num_thm = TDB.find "ordering2num_thm"
  fun op ordering_EQ_ordering _ = ()
  val op ordering_EQ_ordering = TDB.find "ordering_EQ_ordering"
  fun op ordering_case_def _ = ()
  val op ordering_case_def = TDB.find "ordering_case_def"
  fun op datatype_ordering _ = ()
  val op datatype_ordering = TDB.find "datatype_ordering"
  fun op ordering_distinct _ = ()
  val op ordering_distinct = TDB.find "ordering_distinct"
  fun op ordering_nchotomy _ = ()
  val op ordering_nchotomy = TDB.find "ordering_nchotomy"
  fun op ordering_Axiom _ = ()
  val op ordering_Axiom = TDB.find "ordering_Axiom"
  fun op ordering_induction _ = ()
  val op ordering_induction = TDB.find "ordering_induction"
  fun op ordering_case_cong _ = ()
  val op ordering_case_cong = TDB.find "ordering_case_cong"
  fun op ordering_case_eq _ = ()
  val op ordering_case_eq = TDB.find "ordering_case_eq"
  fun op ordering_eq_dec _ = ()
  val op ordering_eq_dec = TDB.find "ordering_eq_dec"
  fun op bool_compare_ind _ = ()
  val op bool_compare_ind = TDB.find "bool_compare_ind"
  fun op bool_compare_def _ = ()
  val op bool_compare_def = TDB.find "bool_compare_def"
  fun op option_compare_ind _ = ()
  val op option_compare_ind = TDB.find "option_compare_ind"
  fun op option_compare_def _ = ()
  val op option_compare_def = TDB.find "option_compare_def"
  fun op list_compare_ind _ = ()
  val op list_compare_ind = TDB.find "list_compare_ind"
  fun op list_compare_def _ = ()
  val op list_compare_def = TDB.find "list_compare_def"
  fun op compare_equal _ = ()
  val op compare_equal = TDB.find "compare_equal"
  fun op list_merge_ind _ = ()
  val op list_merge_ind = TDB.find "list_merge_ind"
  fun op list_merge_def _ = ()
  val op list_merge_def = TDB.find "list_merge_def"
  fun op invert_eq_EQUAL _ = ()
  val op invert_eq_EQUAL = TDB.find "invert_eq_EQUAL"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ternaryComparisons_grammars = merge_grammars ["string"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ternaryComparisons"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ternaryComparisons_grammars = 
    Portable.## (addtyUDs,addtmUDs) ternaryComparisons_grammars
  val _ = Parse.grammarDB_insert("ternaryComparisons",ternaryComparisons_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ternaryComparisons"

end
