structure ASCIInumbersTheory :> ASCIInumbersTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading ASCIInumbersTheory ... "
    else ()
  
  open Type Term Thm
  local open numposrepTheory stringTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "ASCIInumbers"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/string/ASCIInumbersTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op s2n_def _ = () val op s2n_def = TDB.find "s2n_def"
  fun op n2s_def _ = () val op n2s_def = TDB.find "n2s_def"
  fun op HEX_primitive_def _ = ()
  val op HEX_primitive_def = TDB.find "HEX_primitive_def"
  fun op UNHEX_primitive_def _ = ()
  val op UNHEX_primitive_def = TDB.find "UNHEX_primitive_def"
  fun op num_from_bin_string_def _ = ()
  val op num_from_bin_string_def = TDB.find "num_from_bin_string_def"
  fun op num_from_oct_string_def _ = ()
  val op num_from_oct_string_def = TDB.find "num_from_oct_string_def"
  fun op num_from_dec_string_def _ = ()
  val op num_from_dec_string_def = TDB.find "num_from_dec_string_def"
  fun op num_from_hex_string_def _ = ()
  val op num_from_hex_string_def = TDB.find "num_from_hex_string_def"
  fun op num_to_bin_string_def _ = ()
  val op num_to_bin_string_def = TDB.find "num_to_bin_string_def"
  fun op num_to_oct_string_def _ = ()
  val op num_to_oct_string_def = TDB.find "num_to_oct_string_def"
  fun op num_to_dec_string_def _ = ()
  val op num_to_dec_string_def = TDB.find "num_to_dec_string_def"
  fun op num_to_hex_string_def _ = ()
  val op num_to_hex_string_def = TDB.find "num_to_hex_string_def"
  fun op fromBinString_def _ = ()
  val op fromBinString_def = TDB.find "fromBinString_def"
  fun op fromDecString_def _ = ()
  val op fromDecString_def = TDB.find "fromDecString_def"
  fun op fromHexString_def _ = ()
  val op fromHexString_def = TDB.find "fromHexString_def"
  fun op HEX_ind _ = () val op HEX_ind = TDB.find "HEX_ind"
  fun op HEX_def _ = () val op HEX_def = TDB.find "HEX_def"
  fun op UNHEX_ind _ = () val op UNHEX_ind = TDB.find "UNHEX_ind"
  fun op UNHEX_def _ = () val op UNHEX_def = TDB.find "UNHEX_def"
  fun op s2n_compute _ = () val op s2n_compute = TDB.find "s2n_compute"
  fun op n2s_compute _ = () val op n2s_compute = TDB.find "n2s_compute"
  fun op UNHEX_HEX _ = () val op UNHEX_HEX = TDB.find "UNHEX_HEX"
  fun op HEX_UNHEX _ = () val op HEX_UNHEX = TDB.find "HEX_UNHEX"
  fun op DEC_UNDEC _ = () val op DEC_UNDEC = TDB.find "DEC_UNDEC"
  fun op s2n_n2s _ = () val op s2n_n2s = TDB.find "s2n_n2s"
  fun op n2s_s2n _ = () val op n2s_s2n = TDB.find "n2s_s2n"
  fun op toNum_toString _ = ()
  val op toNum_toString = TDB.find "toNum_toString"
  fun op toString_toNum_cancel _ = ()
  val op toString_toNum_cancel = TDB.find "toString_toNum_cancel"
  fun op toString_inj _ = () val op toString_inj = TDB.find "toString_inj"
  fun op toString_11 _ = () val op toString_11 = TDB.find "toString_11"
  fun op STRCAT_toString_inj _ = ()
  val op STRCAT_toString_inj = TDB.find "STRCAT_toString_inj"
  fun op BIT_num_from_bin_string _ = ()
  val op BIT_num_from_bin_string = TDB.find "BIT_num_from_bin_string"
  fun op SUB_num_to_bin_string _ = ()
  val op SUB_num_to_bin_string = TDB.find "SUB_num_to_bin_string"
  fun op num_bin_string _ = ()
  val op num_bin_string = TDB.find "num_bin_string"
  fun op num_oct_string _ = ()
  val op num_oct_string = TDB.find "num_oct_string"
  fun op num_dec_string _ = ()
  val op num_dec_string = TDB.find "num_dec_string"
  fun op num_hex_string _ = ()
  val op num_hex_string = TDB.find "num_hex_string"
  fun op num_to_bin_string_nil _ = ()
  val op num_to_bin_string_nil = TDB.find "num_to_bin_string_nil"
  fun op num_to_oct_string_nil _ = ()
  val op num_to_oct_string_nil = TDB.find "num_to_oct_string_nil"
  fun op num_to_dec_string_nil _ = ()
  val op num_to_dec_string_nil = TDB.find "num_to_dec_string_nil"
  fun op num_to_hex_string_nil _ = ()
  val op num_to_hex_string_nil = TDB.find "num_to_hex_string_nil"
  fun op isDigit_HEX _ = () val op isDigit_HEX = TDB.find "isDigit_HEX"
  fun op isHexDigit_HEX _ = ()
  val op isHexDigit_HEX = TDB.find "isHexDigit_HEX"
  fun op EVERY_isDigit_num_to_dec_string _ = ()
  val op EVERY_isDigit_num_to_dec_string = TDB.find
    "EVERY_isDigit_num_to_dec_string"
  fun op EVERY_isHexDigit_num_to_hex_string _ = ()
  val op EVERY_isHexDigit_num_to_hex_string = TDB.find
    "EVERY_isHexDigit_num_to_hex_string"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val ASCIInumbers_grammars = merge_grammars ["string", "numposrep"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="ASCIInumbers"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val ASCIInumbers_grammars = 
    Portable.## (addtyUDs,addtmUDs) ASCIInumbers_grammars
  val _ = Parse.grammarDB_insert("ASCIInumbers",ASCIInumbers_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "ASCIInumbers"

end
