structure stringTheory :> stringTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading stringTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "string"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/string/stringTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op DEST_STRING_def _ = ()
  val op DEST_STRING_def = TDB.find "DEST_STRING_def"
  fun op char_TY_DEF _ = () val op char_TY_DEF = TDB.find "char_TY_DEF"
  fun op char_BIJ _ = () val op char_BIJ = TDB.find "char_BIJ"
  fun op isLower_def _ = () val op isLower_def = TDB.find "isLower_def"
  fun op isUpper_def _ = () val op isUpper_def = TDB.find "isUpper_def"
  fun op isDigit_def _ = () val op isDigit_def = TDB.find "isDigit_def"
  fun op isAlpha_def _ = () val op isAlpha_def = TDB.find "isAlpha_def"
  fun op isHexDigit_def _ = ()
  val op isHexDigit_def = TDB.find "isHexDigit_def"
  fun op isAlphaNum_def _ = ()
  val op isAlphaNum_def = TDB.find "isAlphaNum_def"
  fun op isPrint_def _ = () val op isPrint_def = TDB.find "isPrint_def"
  fun op isSpace_def _ = () val op isSpace_def = TDB.find "isSpace_def"
  fun op isGraph_def _ = () val op isGraph_def = TDB.find "isGraph_def"
  fun op isPunct_def _ = () val op isPunct_def = TDB.find "isPunct_def"
  fun op isAscii_def _ = () val op isAscii_def = TDB.find "isAscii_def"
  fun op isCntrl_def _ = () val op isCntrl_def = TDB.find "isCntrl_def"
  fun op toLower_def _ = () val op toLower_def = TDB.find "toLower_def"
  fun op toUpper_def _ = () val op toUpper_def = TDB.find "toUpper_def"
  fun op char_lt_def _ = () val op char_lt_def = TDB.find "char_lt_def"
  fun op char_le_def _ = () val op char_le_def = TDB.find "char_le_def"
  fun op char_gt_def _ = () val op char_gt_def = TDB.find "char_gt_def"
  fun op char_ge_def _ = () val op char_ge_def = TDB.find "char_ge_def"
  fun op char_size_def _ = ()
  val op char_size_def = TDB.find "char_size_def"
  fun op string_elim__magic _ = ()
  val op string_elim__magic = TDB.find "string_elim__magic"
  fun op SUB_def _ = () val op SUB_def = TDB.find "SUB_def"
  fun op STR_def _ = () val op STR_def = TDB.find "STR_def"
  fun op TOCHAR_primitive_def _ = ()
  val op TOCHAR_primitive_def = TDB.find "TOCHAR_primitive_def"
  fun op SUBSTRING_def _ = ()
  val op SUBSTRING_def = TDB.find "SUBSTRING_def"
  fun op TRANSLATE_def _ = ()
  val op TRANSLATE_def = TDB.find "TRANSLATE_def"
  fun op IMPLODE_def _ = () val op IMPLODE_def = TDB.find "IMPLODE_def"
  fun op EXPLODE_def _ = () val op EXPLODE_def = TDB.find "EXPLODE_def"
  fun op EXTRACT_primitive_def _ = ()
  val op EXTRACT_primitive_def = TDB.find "EXTRACT_primitive_def"
  fun op string_le_def _ = ()
  val op string_le_def = TDB.find "string_le_def"
  fun op string_gt_def _ = ()
  val op string_gt_def = TDB.find "string_gt_def"
  fun op string_ge_def _ = ()
  val op string_ge_def = TDB.find "string_ge_def"
  fun op IMPLODE_STRING _ = ()
  val op IMPLODE_STRING = TDB.find "IMPLODE_STRING"
  fun op EXPLODE_DEST_STRING _ = ()
  val op EXPLODE_DEST_STRING = TDB.find "EXPLODE_DEST_STRING"
  fun op IMPLODE_EQ_THM _ = ()
  val op IMPLODE_EQ_THM = TDB.find "IMPLODE_EQ_THM"
  fun op EXPLODE_EQ_THM _ = ()
  val op EXPLODE_EQ_THM = TDB.find "EXPLODE_EQ_THM"
  fun op EXPLODE_EQ_NIL _ = ()
  val op EXPLODE_EQ_NIL = TDB.find "EXPLODE_EQ_NIL"
  fun op IMPLODE_EQ_EMPTYSTRING _ = ()
  val op IMPLODE_EQ_EMPTYSTRING = TDB.find "IMPLODE_EQ_EMPTYSTRING"
  fun op IMPLODE_EQNS _ = () val op IMPLODE_EQNS = TDB.find "IMPLODE_EQNS"
  fun op EXPLODE_EQNS _ = () val op EXPLODE_EQNS = TDB.find "EXPLODE_EQNS"
  fun op DEST_STRING_LEMS _ = ()
  val op DEST_STRING_LEMS = TDB.find "DEST_STRING_LEMS"
  fun op STRLEN_EXPLODE_THM _ = ()
  val op STRLEN_EXPLODE_THM = TDB.find "STRLEN_EXPLODE_THM"
  fun op ORD_11 _ = () val op ORD_11 = TDB.find "ORD_11"
  fun op CHR_11 _ = () val op CHR_11 = TDB.find "CHR_11"
  fun op ORD_ONTO _ = () val op ORD_ONTO = TDB.find "ORD_ONTO"
  fun op CHR_ONTO _ = () val op CHR_ONTO = TDB.find "CHR_ONTO"
  fun op CHR_ORD _ = () val op CHR_ORD = TDB.find "CHR_ORD"
  fun op ORD_CHR _ = () val op ORD_CHR = TDB.find "ORD_CHR"
  fun op ORD_CHR_RWT _ = () val op ORD_CHR_RWT = TDB.find "ORD_CHR_RWT"
  fun op ORD_CHR_COMPUTE _ = ()
  val op ORD_CHR_COMPUTE = TDB.find "ORD_CHR_COMPUTE"
  fun op ORD_BOUND _ = () val op ORD_BOUND = TDB.find "ORD_BOUND"
  fun op char_nchotomy _ = ()
  val op char_nchotomy = TDB.find "char_nchotomy"
  fun op ranged_char_nchotomy _ = ()
  val op ranged_char_nchotomy = TDB.find "ranged_char_nchotomy"
  fun op isAlphaNum_isPrint _ = ()
  val op isAlphaNum_isPrint = TDB.find "isAlphaNum_isPrint"
  fun op isHexDigit_isAlphaNum _ = ()
  val op isHexDigit_isAlphaNum = TDB.find "isHexDigit_isAlphaNum"
  fun op isHexDigit_isPrint _ = ()
  val op isHexDigit_isPrint = TDB.find "isHexDigit_isPrint"
  fun op CHAR_EQ_THM _ = () val op CHAR_EQ_THM = TDB.find "CHAR_EQ_THM"
  fun op CHAR_INDUCT_THM _ = ()
  val op CHAR_INDUCT_THM = TDB.find "CHAR_INDUCT_THM"
  fun op TOCHAR_ind _ = () val op TOCHAR_ind = TDB.find "TOCHAR_ind"
  fun op TOCHAR_def _ = () val op TOCHAR_def = TDB.find "TOCHAR_def"
  fun op TOKENS_ind _ = () val op TOKENS_ind = TDB.find "TOKENS_ind"
  fun op TOKENS_def _ = () val op TOKENS_def = TDB.find "TOKENS_def"
  fun op FIELDS_ind _ = () val op FIELDS_ind = TDB.find "FIELDS_ind"
  fun op FIELDS_def _ = () val op FIELDS_def = TDB.find "FIELDS_def"
  fun op IMPLODE_EXPLODE_I _ = ()
  val op IMPLODE_EXPLODE_I = TDB.find "IMPLODE_EXPLODE_I"
  fun op IMPLODE_EXPLODE _ = ()
  val op IMPLODE_EXPLODE = TDB.find "IMPLODE_EXPLODE"
  fun op EXPLODE_IMPLODE _ = ()
  val op EXPLODE_IMPLODE = TDB.find "EXPLODE_IMPLODE"
  fun op EXPLODE_ONTO _ = () val op EXPLODE_ONTO = TDB.find "EXPLODE_ONTO"
  fun op IMPLODE_ONTO _ = () val op IMPLODE_ONTO = TDB.find "IMPLODE_ONTO"
  fun op EXPLODE_11 _ = () val op EXPLODE_11 = TDB.find "EXPLODE_11"
  fun op IMPLODE_11 _ = () val op IMPLODE_11 = TDB.find "IMPLODE_11"
  fun op TOKENS_APPEND _ = ()
  val op TOKENS_APPEND = TDB.find "TOKENS_APPEND"
  fun op TOKENS_NIL _ = () val op TOKENS_NIL = TDB.find "TOKENS_NIL"
  fun op TOKENS_FRONT _ = () val op TOKENS_FRONT = TDB.find "TOKENS_FRONT"
  fun op STRING_ACYCLIC _ = ()
  val op STRING_ACYCLIC = TDB.find "STRING_ACYCLIC"
  fun op EXTRACT_ind _ = () val op EXTRACT_ind = TDB.find "EXTRACT_ind"
  fun op EXTRACT_def _ = () val op EXTRACT_def = TDB.find "EXTRACT_def"
  fun op STRLEN_EQ_0 _ = () val op STRLEN_EQ_0 = TDB.find "STRLEN_EQ_0"
  fun op STRLEN_THM _ = () val op STRLEN_THM = TDB.find "STRLEN_THM"
  fun op STRLEN_DEF _ = () val op STRLEN_DEF = TDB.find "STRLEN_DEF"
  fun op STRCAT_def _ = () val op STRCAT_def = TDB.find "STRCAT_def"
  fun op STRCAT _ = () val op STRCAT = TDB.find "STRCAT"
  fun op STRCAT_EQNS _ = () val op STRCAT_EQNS = TDB.find "STRCAT_EQNS"
  fun op STRCAT_ASSOC _ = () val op STRCAT_ASSOC = TDB.find "STRCAT_ASSOC"
  fun op STRCAT_11 _ = () val op STRCAT_11 = TDB.find "STRCAT_11"
  fun op STRCAT_ACYCLIC _ = ()
  val op STRCAT_ACYCLIC = TDB.find "STRCAT_ACYCLIC"
  fun op STRCAT_EXPLODE _ = ()
  val op STRCAT_EXPLODE = TDB.find "STRCAT_EXPLODE"
  fun op STRCAT_EQ_EMPTY _ = ()
  val op STRCAT_EQ_EMPTY = TDB.find "STRCAT_EQ_EMPTY"
  fun op STRLEN_CAT _ = () val op STRLEN_CAT = TDB.find "STRLEN_CAT"
  fun op isPREFIX_DEF _ = () val op isPREFIX_DEF = TDB.find "isPREFIX_DEF"
  fun op isPREFIX_IND _ = () val op isPREFIX_IND = TDB.find "isPREFIX_IND"
  fun op isPREFIX_STRCAT _ = ()
  val op isPREFIX_STRCAT = TDB.find "isPREFIX_STRCAT"
  fun op string_lt_ind _ = ()
  val op string_lt_ind = TDB.find "string_lt_ind"
  fun op string_lt_def _ = ()
  val op string_lt_def = TDB.find "string_lt_def"
  fun op string_lt_nonrefl _ = ()
  val op string_lt_nonrefl = TDB.find "string_lt_nonrefl"
  fun op string_lt_antisym _ = ()
  val op string_lt_antisym = TDB.find "string_lt_antisym"
  fun op string_lt_cases _ = ()
  val op string_lt_cases = TDB.find "string_lt_cases"
  fun op string_lt_trans _ = ()
  val op string_lt_trans = TDB.find "string_lt_trans"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val string_grammars = merge_grammars ["rich_list"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="string"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val string_grammars = 
    Portable.## (addtyUDs,addtmUDs) string_grammars
  val _ = Parse.grammarDB_insert("string",string_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
  
  val _ =
  let open Lib boolSyntax
      val (v,M) = dest_forall(concl char_size_def)
      val char_size_tm = fst(strip_comb(lhs M))
  in
   TypeBase.write
   [TypeBasePure.mk_nondatatype_info
    (type_of v, 
      {nchotomy = SOME ranged_char_nchotomy,
       induction = NONE,
       size = SOME(char_size_tm,char_size_def),
       encode = NONE})]
  end;
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "string"

end
