structure string_numTheory :> string_numTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading string_numTheory ... "
    else ()
  
  open Type Term Thm
  local open stringTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "string_num"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/string/string_numTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op n2s_primitive_def _ = ()
  val op n2s_primitive_def = TDB.find "n2s_primitive_def"
  fun op s2n_def _ = () val op s2n_def = TDB.find "s2n_def"
  fun op n2nsum_def _ = () val op n2nsum_def = TDB.find "n2nsum_def"
  fun op nsum2n_def _ = () val op nsum2n_def = TDB.find "nsum2n_def"
  fun op s2ssum_def _ = () val op s2ssum_def = TDB.find "s2ssum_def"
  fun op ssum2s_def _ = () val op ssum2s_def = TDB.find "ssum2s_def"
  fun op n2s_ind _ = () val op n2s_ind = TDB.find "n2s_ind"
  fun op n2s_def _ = () val op n2s_def = TDB.find "n2s_def"
  fun op s2n_n2s _ = () val op s2n_n2s = TDB.find "s2n_n2s"
  fun op n2s_s2n _ = () val op n2s_s2n = TDB.find "n2s_s2n"
  fun op n2s_11 _ = () val op n2s_11 = TDB.find "n2s_11"
  fun op s2n_11 _ = () val op s2n_11 = TDB.find "s2n_11"
  fun op n2s_onto _ = () val op n2s_onto = TDB.find "n2s_onto"
  fun op s2n_onto _ = () val op s2n_onto = TDB.find "s2n_onto"
  fun op n2nsum_nsum2n _ = ()
  val op n2nsum_nsum2n = TDB.find "n2nsum_nsum2n"
  fun op nsum2n_n2nsum _ = ()
  val op nsum2n_n2nsum = TDB.find "nsum2n_n2nsum"
  fun op s2ssum_ssum2s _ = ()
  val op s2ssum_ssum2s = TDB.find "s2ssum_ssum2s"
  fun op ssum2s_s2ssum _ = ()
  val op ssum2s_s2ssum = TDB.find "ssum2s_s2ssum"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val string_num_grammars = merge_grammars ["string"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="string_num"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val string_num_grammars = 
    Portable.## (addtyUDs,addtmUDs) string_num_grammars
  val _ = Parse.grammarDB_insert("string_num",string_num_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "string_num"

end
