structure Omega_AutomataTheory :> Omega_AutomataTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading Omega_AutomataTheory ... "
    else ()
  
  open Type Term Thm
  local open Past_Temporal_LogicTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "Omega_Automata"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/temporal/src/Omega_AutomataTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op DET_OMEGA_EXISTS_FORALL_THEOREM _ = ()
  val op DET_OMEGA_EXISTS_FORALL_THEOREM = TDB.find
    "DET_OMEGA_EXISTS_FORALL_THEOREM"
  fun op NEG_DET_AUTOMATA _ = ()
  val op NEG_DET_AUTOMATA = TDB.find "NEG_DET_AUTOMATA"
  fun op OMEGA_CONJ_CLOSURE _ = ()
  val op OMEGA_CONJ_CLOSURE = TDB.find "OMEGA_CONJ_CLOSURE"
  fun op OMEGA_DISJ_CLOSURE _ = ()
  val op OMEGA_DISJ_CLOSURE = TDB.find "OMEGA_DISJ_CLOSURE"
  fun op BOOLEAN_CLOSURE_G _ = ()
  val op BOOLEAN_CLOSURE_G = TDB.find "BOOLEAN_CLOSURE_G"
  fun op BOOLEAN_CLOSURE_F _ = ()
  val op BOOLEAN_CLOSURE_F = TDB.find "BOOLEAN_CLOSURE_F"
  fun op BOOLEAN_CLOSURE_FG _ = ()
  val op BOOLEAN_CLOSURE_FG = TDB.find "BOOLEAN_CLOSURE_FG"
  fun op BOOLEAN_CLOSURE_GF _ = ()
  val op BOOLEAN_CLOSURE_GF = TDB.find "BOOLEAN_CLOSURE_GF"
  fun op BOREL_HIERARCHY_G _ = ()
  val op BOREL_HIERARCHY_G = TDB.find "BOREL_HIERARCHY_G"
  fun op BOREL_HIERARCHY_F _ = ()
  val op BOREL_HIERARCHY_F = TDB.find "BOREL_HIERARCHY_F"
  fun op BOREL_HIERARCHY_FG _ = ()
  val op BOREL_HIERARCHY_FG = TDB.find "BOREL_HIERARCHY_FG"
  fun op TEMP_OPS_DEFS_TO_OMEGA _ = ()
  val op TEMP_OPS_DEFS_TO_OMEGA = TDB.find "TEMP_OPS_DEFS_TO_OMEGA"
  fun op AUTOMATON_TEMP_CLOSURE _ = ()
  val op AUTOMATON_TEMP_CLOSURE = TDB.find "AUTOMATON_TEMP_CLOSURE"
  fun op BUECHI_TRANSLATION _ = ()
  val op BUECHI_TRANSLATION = TDB.find "BUECHI_TRANSLATION"
  fun op CO_BUECHI_CONJ_CLOSURE _ = ()
  val op CO_BUECHI_CONJ_CLOSURE = TDB.find "CO_BUECHI_CONJ_CLOSURE"
  fun op CO_BUECHI_DISJ_CLOSURE _ = ()
  val op CO_BUECHI_DISJ_CLOSURE = TDB.find "CO_BUECHI_DISJ_CLOSURE"
  fun op CO_BUECHI_NEXT_CLOSURE _ = ()
  val op CO_BUECHI_NEXT_CLOSURE = TDB.find "CO_BUECHI_NEXT_CLOSURE"
  fun op CO_BUECHI_SUNTIL_CLOSURE _ = ()
  val op CO_BUECHI_SUNTIL_CLOSURE = TDB.find "CO_BUECHI_SUNTIL_CLOSURE"
  fun op CO_BUECHI_UNTIL_CLOSURE _ = ()
  val op CO_BUECHI_UNTIL_CLOSURE = TDB.find "CO_BUECHI_UNTIL_CLOSURE"
  fun op CO_BUECHI_SBEFORE_CLOSURE _ = ()
  val op CO_BUECHI_SBEFORE_CLOSURE = TDB.find "CO_BUECHI_SBEFORE_CLOSURE"
  fun op CO_BUECHI_BEFORE_CLOSURE _ = ()
  val op CO_BUECHI_BEFORE_CLOSURE = TDB.find "CO_BUECHI_BEFORE_CLOSURE"
  fun op CO_BUECHI_SWHEN_CLOSURE _ = ()
  val op CO_BUECHI_SWHEN_CLOSURE = TDB.find "CO_BUECHI_SWHEN_CLOSURE"
  fun op CO_BUECHI_WHEN_CLOSURE _ = ()
  val op CO_BUECHI_WHEN_CLOSURE = TDB.find "CO_BUECHI_WHEN_CLOSURE"
  fun op NEXT_AS_CO_BUECHI _ = ()
  val op NEXT_AS_CO_BUECHI = TDB.find "NEXT_AS_CO_BUECHI"
  fun op SUNTIL_AS_CO_BUECHI _ = ()
  val op SUNTIL_AS_CO_BUECHI = TDB.find "SUNTIL_AS_CO_BUECHI"
  fun op UNTIL_AS_CO_BUECHI _ = ()
  val op UNTIL_AS_CO_BUECHI = TDB.find "UNTIL_AS_CO_BUECHI"
  fun op SBEFORE_AS_CO_BUECHI _ = ()
  val op SBEFORE_AS_CO_BUECHI = TDB.find "SBEFORE_AS_CO_BUECHI"
  fun op BEFORE_AS_CO_BUECHI _ = ()
  val op BEFORE_AS_CO_BUECHI = TDB.find "BEFORE_AS_CO_BUECHI"
  fun op SWHEN_AS_CO_BUECHI _ = ()
  val op SWHEN_AS_CO_BUECHI = TDB.find "SWHEN_AS_CO_BUECHI"
  fun op WHEN_AS_CO_BUECHI _ = ()
  val op WHEN_AS_CO_BUECHI = TDB.find "WHEN_AS_CO_BUECHI"
  fun op BUECHI_PERIODIC_MODEL _ = ()
  val op BUECHI_PERIODIC_MODEL = TDB.find "BUECHI_PERIODIC_MODEL"
  fun op BUECHI_PERIODIC_REDUCTION_THM _ = ()
  val op BUECHI_PERIODIC_REDUCTION_THM = TDB.find
    "BUECHI_PERIODIC_REDUCTION_THM"
  fun op BUECHI_PROP_REDUCTION _ = ()
  val op BUECHI_PROP_REDUCTION = TDB.find "BUECHI_PROP_REDUCTION"
  fun op EQUALITY_THM _ = () val op EQUALITY_THM = TDB.find "EQUALITY_THM"
  fun op LESS_THM _ = () val op LESS_THM = TDB.find "LESS_THM"
  fun op FORALL_EXISTS_THM _ = ()
  val op FORALL_EXISTS_THM = TDB.find "FORALL_EXISTS_THM"
  fun op EXISTS_FORALL_THM _ = ()
  val op EXISTS_FORALL_THM = TDB.find "EXISTS_FORALL_THM"
  fun op ELGOT_LEMMA _ = () val op ELGOT_LEMMA = TDB.find "ELGOT_LEMMA"
  fun op ELGOT1_THM _ = () val op ELGOT1_THM = TDB.find "ELGOT1_THM"
  fun op ELGOT2_THM _ = () val op ELGOT2_THM = TDB.find "ELGOT2_THM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val Omega_Automata_grammars = merge_grammars ["Past_Temporal_Logic"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="Omega_Automata"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val Omega_Automata_grammars = 
    Portable.## (addtyUDs,addtmUDs) Omega_Automata_grammars
  val _ = Parse.grammarDB_insert("Omega_Automata",Omega_Automata_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "Omega_Automata"

end
