structure Past_Temporal_LogicTheory :> Past_Temporal_LogicTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading Past_Temporal_LogicTheory ... "
    else ()
  
  open Type Term Thm
  local open Temporal_LogicTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "Past_Temporal_Logic"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/temporal/src/Past_Temporal_LogicTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op InitPoint _ = () val op InitPoint = TDB.find "InitPoint"
  fun op PSNEXT _ = () val op PSNEXT = TDB.find "PSNEXT"
  fun op PNEXT _ = () val op PNEXT = TDB.find "PNEXT"
  fun op PALWAYS _ = () val op PALWAYS = TDB.find "PALWAYS"
  fun op PEVENTUAL _ = () val op PEVENTUAL = TDB.find "PEVENTUAL"
  fun op PSWHEN _ = () val op PSWHEN = TDB.find "PSWHEN"
  fun op PSUNTIL _ = () val op PSUNTIL = TDB.find "PSUNTIL"
  fun op PSBEFORE _ = () val op PSBEFORE = TDB.find "PSBEFORE"
  fun op PWHEN _ = () val op PWHEN = TDB.find "PWHEN"
  fun op PUNTIL _ = () val op PUNTIL = TDB.find "PUNTIL"
  fun op PBEFORE _ = () val op PBEFORE = TDB.find "PBEFORE"
  fun op INITIALISATION _ = ()
  val op INITIALISATION = TDB.find "INITIALISATION"
  fun op RECURSION _ = () val op RECURSION = TDB.find "RECURSION"
  fun op FIXPOINTS _ = () val op FIXPOINTS = TDB.find "FIXPOINTS"
  fun op SUNTIL_EXPRESSIVE _ = ()
  val op SUNTIL_EXPRESSIVE = TDB.find "SUNTIL_EXPRESSIVE"
  fun op UNTIL_EXPRESSIVE _ = ()
  val op UNTIL_EXPRESSIVE = TDB.find "UNTIL_EXPRESSIVE"
  fun op WHEN_EXPRESSIVE _ = ()
  val op WHEN_EXPRESSIVE = TDB.find "WHEN_EXPRESSIVE"
  fun op SWHEN_EXPRESSIVE _ = ()
  val op SWHEN_EXPRESSIVE = TDB.find "SWHEN_EXPRESSIVE"
  fun op BEFORE_EXPRESSIVE _ = ()
  val op BEFORE_EXPRESSIVE = TDB.find "BEFORE_EXPRESSIVE"
  fun op SBEFORE_EXPRESSIVE _ = ()
  val op SBEFORE_EXPRESSIVE = TDB.find "SBEFORE_EXPRESSIVE"
  fun op PSUNTIL_EXPRESSIVE _ = ()
  val op PSUNTIL_EXPRESSIVE = TDB.find "PSUNTIL_EXPRESSIVE"
  fun op PUNTIL_EXPRESSIVE _ = ()
  val op PUNTIL_EXPRESSIVE = TDB.find "PUNTIL_EXPRESSIVE"
  fun op PWHEN_EXPRESSIVE _ = ()
  val op PWHEN_EXPRESSIVE = TDB.find "PWHEN_EXPRESSIVE"
  fun op PSWHEN_EXPRESSIVE _ = ()
  val op PSWHEN_EXPRESSIVE = TDB.find "PSWHEN_EXPRESSIVE"
  fun op PBEFORE_EXPRESSIVE _ = ()
  val op PBEFORE_EXPRESSIVE = TDB.find "PBEFORE_EXPRESSIVE"
  fun op PSBEFORE_EXPRESSIVE _ = ()
  val op PSBEFORE_EXPRESSIVE = TDB.find "PSBEFORE_EXPRESSIVE"
  fun op NEGATION_NORMAL_FORM _ = ()
  val op NEGATION_NORMAL_FORM = TDB.find "NEGATION_NORMAL_FORM"
  fun op CONJUNCTIVE_NORMAL_FORM _ = ()
  val op CONJUNCTIVE_NORMAL_FORM = TDB.find "CONJUNCTIVE_NORMAL_FORM"
  fun op DISJUNCTIVE_NORMAL_FORM _ = ()
  val op DISJUNCTIVE_NORMAL_FORM = TDB.find "DISJUNCTIVE_NORMAL_FORM"
  fun op PRENEX_NEXT_NORMAL_FORM _ = ()
  val op PRENEX_NEXT_NORMAL_FORM = TDB.find "PRENEX_NEXT_NORMAL_FORM"
  fun op NEXT_INWARDS_NORMAL_FORM _ = ()
  val op NEXT_INWARDS_NORMAL_FORM = TDB.find "NEXT_INWARDS_NORMAL_FORM"
  fun op PNEXT_INWARDS_NORMAL_FORM _ = ()
  val op PNEXT_INWARDS_NORMAL_FORM = TDB.find "PNEXT_INWARDS_NORMAL_FORM"
  fun op SIMPLIFY _ = () val op SIMPLIFY = TDB.find "SIMPLIFY"
  fun op MORE_EVENT _ = () val op MORE_EVENT = TDB.find "MORE_EVENT"
  fun op IMMEDIATE_EVENT _ = ()
  val op IMMEDIATE_EVENT = TDB.find "IMMEDIATE_EVENT"
  fun op NO_FUTURE_EVENT _ = ()
  val op NO_FUTURE_EVENT = TDB.find "NO_FUTURE_EVENT"
  fun op NO_PAST_EVENT _ = ()
  val op NO_PAST_EVENT = TDB.find "NO_PAST_EVENT"
  fun op SOME_FUTURE_EVENT _ = ()
  val op SOME_FUTURE_EVENT = TDB.find "SOME_FUTURE_EVENT"
  fun op SOME_PAST_EVENT _ = ()
  val op SOME_PAST_EVENT = TDB.find "SOME_PAST_EVENT"
  fun op SEPARATE_NEXT_THM _ = ()
  val op SEPARATE_NEXT_THM = TDB.find "SEPARATE_NEXT_THM"
  fun op SEPARATE_SUNTIL_THM _ = ()
  val op SEPARATE_SUNTIL_THM = TDB.find "SEPARATE_SUNTIL_THM"
  fun op SEPARATE_BEFORE_THM _ = ()
  val op SEPARATE_BEFORE_THM = TDB.find "SEPARATE_BEFORE_THM"
  fun op SEPARATE_PNEXT_THM _ = ()
  val op SEPARATE_PNEXT_THM = TDB.find "SEPARATE_PNEXT_THM"
  fun op SEPARATE_PSUNTIL_THM _ = ()
  val op SEPARATE_PSUNTIL_THM = TDB.find "SEPARATE_PSUNTIL_THM"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val Past_Temporal_Logic_grammars = merge_grammars ["Temporal_Logic"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="Past_Temporal_Logic"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val Past_Temporal_Logic_grammars = 
    Portable.## (addtyUDs,addtmUDs) Past_Temporal_Logic_grammars
  val _ = Parse.grammarDB_insert("Past_Temporal_Logic",Past_Temporal_Logic_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "Past_Temporal_Logic"

end
