structure Temporal_LogicTheory :> Temporal_LogicTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading Temporal_LogicTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "Temporal_Logic"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/temporal/src/Temporal_LogicTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op NEXT _ = () val op NEXT = TDB.find "NEXT"
  fun op ALWAYS _ = () val op ALWAYS = TDB.find "ALWAYS"
  fun op EVENTUAL _ = () val op EVENTUAL = TDB.find "EVENTUAL"
  fun op WATCH _ = () val op WATCH = TDB.find "WATCH"
  fun op UPTO _ = () val op UPTO = TDB.find "UPTO"
  fun op WHEN _ = () val op WHEN = TDB.find "WHEN"
  fun op UNTIL _ = () val op UNTIL = TDB.find "UNTIL"
  fun op BEFORE _ = () val op BEFORE = TDB.find "BEFORE"
  fun op SWHEN _ = () val op SWHEN = TDB.find "SWHEN"
  fun op SUNTIL _ = () val op SUNTIL = TDB.find "SUNTIL"
  fun op SBEFORE _ = () val op SBEFORE = TDB.find "SBEFORE"
  fun op DELTA_CASES _ = () val op DELTA_CASES = TDB.find "DELTA_CASES"
  fun op WATCH_SIGNAL _ = () val op WATCH_SIGNAL = TDB.find "WATCH_SIGNAL"
  fun op SUNTIL_SIGNAL _ = ()
  val op SUNTIL_SIGNAL = TDB.find "SUNTIL_SIGNAL"
  fun op BEFORE_AS_WHEN _ = ()
  val op BEFORE_AS_WHEN = TDB.find "BEFORE_AS_WHEN"
  fun op WATCH_EXISTS _ = () val op WATCH_EXISTS = TDB.find "WATCH_EXISTS"
  fun op WELL_ORDER _ = () val op WELL_ORDER = TDB.find "WELL_ORDER"
  fun op WELL_ORDER_UNIQUE _ = ()
  val op WELL_ORDER_UNIQUE = TDB.find "WELL_ORDER_UNIQUE"
  fun op WHEN_IMP _ = () val op WHEN_IMP = TDB.find "WHEN_IMP"
  fun op UNTIL_IMP _ = () val op UNTIL_IMP = TDB.find "UNTIL_IMP"
  fun op BEFORE_IMP _ = () val op BEFORE_IMP = TDB.find "BEFORE_IMP"
  fun op SWHEN_IMP _ = () val op SWHEN_IMP = TDB.find "SWHEN_IMP"
  fun op SUNTIL_IMP _ = () val op SUNTIL_IMP = TDB.find "SUNTIL_IMP"
  fun op SBEFORE_IMP _ = () val op SBEFORE_IMP = TDB.find "SBEFORE_IMP"
  fun op ALWAYS_SIGNAL _ = ()
  val op ALWAYS_SIGNAL = TDB.find "ALWAYS_SIGNAL"
  fun op EVENTUAL_SIGNAL _ = ()
  val op EVENTUAL_SIGNAL = TDB.find "EVENTUAL_SIGNAL"
  fun op WHEN_SIGNAL _ = () val op WHEN_SIGNAL = TDB.find "WHEN_SIGNAL"
  fun op UNTIL_SIGNAL _ = () val op UNTIL_SIGNAL = TDB.find "UNTIL_SIGNAL"
  fun op BEFORE_SIGNAL _ = ()
  val op BEFORE_SIGNAL = TDB.find "BEFORE_SIGNAL"
  fun op SWHEN_SIGNAL _ = () val op SWHEN_SIGNAL = TDB.find "SWHEN_SIGNAL"
  fun op SBEFORE_SIGNAL _ = ()
  val op SBEFORE_SIGNAL = TDB.find "SBEFORE_SIGNAL"
  fun op NEXT_LINORD _ = () val op NEXT_LINORD = TDB.find "NEXT_LINORD"
  fun op ALWAYS_LINORD _ = ()
  val op ALWAYS_LINORD = TDB.find "ALWAYS_LINORD"
  fun op EVENTUAL_LINORD _ = ()
  val op EVENTUAL_LINORD = TDB.find "EVENTUAL_LINORD"
  fun op SUNTIL_LINORD _ = ()
  val op SUNTIL_LINORD = TDB.find "SUNTIL_LINORD"
  fun op UNTIL_LINORD _ = () val op UNTIL_LINORD = TDB.find "UNTIL_LINORD"
  fun op SBEFORE_LINORD _ = ()
  val op SBEFORE_LINORD = TDB.find "SBEFORE_LINORD"
  fun op BEFORE_LINORD _ = ()
  val op BEFORE_LINORD = TDB.find "BEFORE_LINORD"
  fun op SWHEN_LINORD _ = () val op SWHEN_LINORD = TDB.find "SWHEN_LINORD"
  fun op WHEN_LINORD _ = () val op WHEN_LINORD = TDB.find "WHEN_LINORD"
  fun op ALWAYS_AS_WHEN _ = ()
  val op ALWAYS_AS_WHEN = TDB.find "ALWAYS_AS_WHEN"
  fun op EVENTUAL_AS_WHEN _ = ()
  val op EVENTUAL_AS_WHEN = TDB.find "EVENTUAL_AS_WHEN"
  fun op UNTIL_AS_WHEN _ = ()
  val op UNTIL_AS_WHEN = TDB.find "UNTIL_AS_WHEN"
  fun op SWHEN_AS_WHEN _ = ()
  val op SWHEN_AS_WHEN = TDB.find "SWHEN_AS_WHEN"
  fun op SWHEN_AS_NOT_WHEN _ = ()
  val op SWHEN_AS_NOT_WHEN = TDB.find "SWHEN_AS_NOT_WHEN"
  fun op SUNTIL_AS_WHEN _ = ()
  val op SUNTIL_AS_WHEN = TDB.find "SUNTIL_AS_WHEN"
  fun op SBEFORE_AS_WHEN _ = ()
  val op SBEFORE_AS_WHEN = TDB.find "SBEFORE_AS_WHEN"
  fun op BEFORE_AS_WHEN_UNTIL _ = ()
  val op BEFORE_AS_WHEN_UNTIL = TDB.find "BEFORE_AS_WHEN_UNTIL"
  fun op BEFORE_HW _ = () val op BEFORE_HW = TDB.find "BEFORE_HW"
  fun op ALWAYS_AS_UNTIL _ = ()
  val op ALWAYS_AS_UNTIL = TDB.find "ALWAYS_AS_UNTIL"
  fun op EVENTUAL_AS_UNTIL _ = ()
  val op EVENTUAL_AS_UNTIL = TDB.find "EVENTUAL_AS_UNTIL"
  fun op WHEN_AS_UNTIL _ = ()
  val op WHEN_AS_UNTIL = TDB.find "WHEN_AS_UNTIL"
  fun op BEFORE_AS_UNTIL _ = ()
  val op BEFORE_AS_UNTIL = TDB.find "BEFORE_AS_UNTIL"
  fun op SWHEN_AS_UNTIL _ = ()
  val op SWHEN_AS_UNTIL = TDB.find "SWHEN_AS_UNTIL"
  fun op SUNTIL_AS_UNTIL _ = ()
  val op SUNTIL_AS_UNTIL = TDB.find "SUNTIL_AS_UNTIL"
  fun op SBEFORE_AS_UNTIL _ = ()
  val op SBEFORE_AS_UNTIL = TDB.find "SBEFORE_AS_UNTIL"
  fun op ALWAYS_AS_BEFORE _ = ()
  val op ALWAYS_AS_BEFORE = TDB.find "ALWAYS_AS_BEFORE"
  fun op EVENTUAL_AS_BEFORE _ = ()
  val op EVENTUAL_AS_BEFORE = TDB.find "EVENTUAL_AS_BEFORE"
  fun op WHEN_AS_BEFORE _ = ()
  val op WHEN_AS_BEFORE = TDB.find "WHEN_AS_BEFORE"
  fun op UNTIL_AS_BEFORE _ = ()
  val op UNTIL_AS_BEFORE = TDB.find "UNTIL_AS_BEFORE"
  fun op SWHEN_AS_BEFORE _ = ()
  val op SWHEN_AS_BEFORE = TDB.find "SWHEN_AS_BEFORE"
  fun op SUNTIL_AS_BEFORE _ = ()
  val op SUNTIL_AS_BEFORE = TDB.find "SUNTIL_AS_BEFORE"
  fun op SBEFORE_AS_BEFORE _ = ()
  val op SBEFORE_AS_BEFORE = TDB.find "SBEFORE_AS_BEFORE"
  fun op WHEN_SWHEN_LEMMA _ = ()
  val op WHEN_SWHEN_LEMMA = TDB.find "WHEN_SWHEN_LEMMA"
  fun op ALWAYS_AS_SWHEN _ = ()
  val op ALWAYS_AS_SWHEN = TDB.find "ALWAYS_AS_SWHEN"
  fun op EVENTUAL_AS_SWHEN _ = ()
  val op EVENTUAL_AS_SWHEN = TDB.find "EVENTUAL_AS_SWHEN"
  fun op WHEN_AS_SWHEN _ = ()
  val op WHEN_AS_SWHEN = TDB.find "WHEN_AS_SWHEN"
  fun op WHEN_AS_NOT_SWHEN _ = ()
  val op WHEN_AS_NOT_SWHEN = TDB.find "WHEN_AS_NOT_SWHEN"
  fun op UNTIL_AS_SWHEN _ = ()
  val op UNTIL_AS_SWHEN = TDB.find "UNTIL_AS_SWHEN"
  fun op BEFORE_AS_SWHEN _ = ()
  val op BEFORE_AS_SWHEN = TDB.find "BEFORE_AS_SWHEN"
  fun op BEFORE_AS_NOT_SWHEN _ = ()
  val op BEFORE_AS_NOT_SWHEN = TDB.find "BEFORE_AS_NOT_SWHEN"
  fun op SUNTIL_AS_SWHEN _ = ()
  val op SUNTIL_AS_SWHEN = TDB.find "SUNTIL_AS_SWHEN"
  fun op SBEFORE_AS_SWHEN _ = ()
  val op SBEFORE_AS_SWHEN = TDB.find "SBEFORE_AS_SWHEN"
  fun op ALWAYS_AS_SUNTIL _ = ()
  val op ALWAYS_AS_SUNTIL = TDB.find "ALWAYS_AS_SUNTIL"
  fun op EVENTUAL_AS_SUNTIL _ = ()
  val op EVENTUAL_AS_SUNTIL = TDB.find "EVENTUAL_AS_SUNTIL"
  fun op WHEN_AS_SUNTIL _ = ()
  val op WHEN_AS_SUNTIL = TDB.find "WHEN_AS_SUNTIL"
  fun op UNTIL_AS_SUNTIL _ = ()
  val op UNTIL_AS_SUNTIL = TDB.find "UNTIL_AS_SUNTIL"
  fun op BEFORE_AS_SUNTIL _ = ()
  val op BEFORE_AS_SUNTIL = TDB.find "BEFORE_AS_SUNTIL"
  fun op SWHEN_AS_SUNTIL _ = ()
  val op SWHEN_AS_SUNTIL = TDB.find "SWHEN_AS_SUNTIL"
  fun op SBEFORE_AS_SUNTIL _ = ()
  val op SBEFORE_AS_SUNTIL = TDB.find "SBEFORE_AS_SUNTIL"
  fun op ALWAYS_AS_SBEFORE _ = ()
  val op ALWAYS_AS_SBEFORE = TDB.find "ALWAYS_AS_SBEFORE"
  fun op EVENTUAL_AS_SBEFORE _ = ()
  val op EVENTUAL_AS_SBEFORE = TDB.find "EVENTUAL_AS_SBEFORE"
  fun op WHEN_AS_SBEFORE _ = ()
  val op WHEN_AS_SBEFORE = TDB.find "WHEN_AS_SBEFORE"
  fun op UNTIL_AS_SBEFORE _ = ()
  val op UNTIL_AS_SBEFORE = TDB.find "UNTIL_AS_SBEFORE"
  fun op SWHEN_AS_SBEFORE _ = ()
  val op SWHEN_AS_SBEFORE = TDB.find "SWHEN_AS_SBEFORE"
  fun op SUNTIL_AS_SBEFORE _ = ()
  val op SUNTIL_AS_SBEFORE = TDB.find "SUNTIL_AS_SBEFORE"
  fun op BEFORE_AS_SBEFORE _ = ()
  val op BEFORE_AS_SBEFORE = TDB.find "BEFORE_AS_SBEFORE"
  fun op WHEN_SIMP _ = () val op WHEN_SIMP = TDB.find "WHEN_SIMP"
  fun op UNTIL_SIMP _ = () val op UNTIL_SIMP = TDB.find "UNTIL_SIMP"
  fun op BEFORE_SIMP _ = () val op BEFORE_SIMP = TDB.find "BEFORE_SIMP"
  fun op SWHEN_SIMP _ = () val op SWHEN_SIMP = TDB.find "SWHEN_SIMP"
  fun op SUNTIL_SIMP _ = () val op SUNTIL_SIMP = TDB.find "SUNTIL_SIMP"
  fun op SBEFORE_SIMP _ = () val op SBEFORE_SIMP = TDB.find "SBEFORE_SIMP"
  fun op WHEN_EVENT _ = () val op WHEN_EVENT = TDB.find "WHEN_EVENT"
  fun op UNTIL_EVENT _ = () val op UNTIL_EVENT = TDB.find "UNTIL_EVENT"
  fun op BEFORE_EVENT _ = () val op BEFORE_EVENT = TDB.find "BEFORE_EVENT"
  fun op SWHEN_EVENT _ = () val op SWHEN_EVENT = TDB.find "SWHEN_EVENT"
  fun op SUNTIL_EVENT _ = () val op SUNTIL_EVENT = TDB.find "SUNTIL_EVENT"
  fun op SBEFORE_EVENT _ = ()
  val op SBEFORE_EVENT = TDB.find "SBEFORE_EVENT"
  fun op IMMEDIATE_EVENT _ = ()
  val op IMMEDIATE_EVENT = TDB.find "IMMEDIATE_EVENT"
  fun op NO_EVENT _ = () val op NO_EVENT = TDB.find "NO_EVENT"
  fun op SOME_EVENT _ = () val op SOME_EVENT = TDB.find "SOME_EVENT"
  fun op MORE_EVENT _ = () val op MORE_EVENT = TDB.find "MORE_EVENT"
  fun op NOT_NEXT _ = () val op NOT_NEXT = TDB.find "NOT_NEXT"
  fun op AND_NEXT _ = () val op AND_NEXT = TDB.find "AND_NEXT"
  fun op OR_NEXT _ = () val op OR_NEXT = TDB.find "OR_NEXT"
  fun op IMP_NEXT _ = () val op IMP_NEXT = TDB.find "IMP_NEXT"
  fun op EQUIV_NEXT _ = () val op EQUIV_NEXT = TDB.find "EQUIV_NEXT"
  fun op ALWAYS_NEXT _ = () val op ALWAYS_NEXT = TDB.find "ALWAYS_NEXT"
  fun op EVENTUAL_NEXT _ = ()
  val op EVENTUAL_NEXT = TDB.find "EVENTUAL_NEXT"
  fun op WHEN_NEXT _ = () val op WHEN_NEXT = TDB.find "WHEN_NEXT"
  fun op UNTIL_NEXT _ = () val op UNTIL_NEXT = TDB.find "UNTIL_NEXT"
  fun op BEFORE_NEXT _ = () val op BEFORE_NEXT = TDB.find "BEFORE_NEXT"
  fun op SWHEN_NEXT _ = () val op SWHEN_NEXT = TDB.find "SWHEN_NEXT"
  fun op SUNTIL_NEXT _ = () val op SUNTIL_NEXT = TDB.find "SUNTIL_NEXT"
  fun op SBEFORE_NEXT _ = () val op SBEFORE_NEXT = TDB.find "SBEFORE_NEXT"
  fun op ALWAYS_REC _ = () val op ALWAYS_REC = TDB.find "ALWAYS_REC"
  fun op EVENTUAL_REC _ = () val op EVENTUAL_REC = TDB.find "EVENTUAL_REC"
  fun op WATCH_REC _ = () val op WATCH_REC = TDB.find "WATCH_REC"
  fun op WHEN_REC _ = () val op WHEN_REC = TDB.find "WHEN_REC"
  fun op UNTIL_REC _ = () val op UNTIL_REC = TDB.find "UNTIL_REC"
  fun op BEFORE_REC _ = () val op BEFORE_REC = TDB.find "BEFORE_REC"
  fun op SWHEN_REC _ = () val op SWHEN_REC = TDB.find "SWHEN_REC"
  fun op SUNTIL_REC _ = () val op SUNTIL_REC = TDB.find "SUNTIL_REC"
  fun op SBEFORE_REC _ = () val op SBEFORE_REC = TDB.find "SBEFORE_REC"
  fun op ALWAYS_FIX _ = () val op ALWAYS_FIX = TDB.find "ALWAYS_FIX"
  fun op EVENTUAL_FIX _ = () val op EVENTUAL_FIX = TDB.find "EVENTUAL_FIX"
  fun op WHEN_FIX _ = () val op WHEN_FIX = TDB.find "WHEN_FIX"
  fun op UNTIL_FIX _ = () val op UNTIL_FIX = TDB.find "UNTIL_FIX"
  fun op BEFORE_FIX _ = () val op BEFORE_FIX = TDB.find "BEFORE_FIX"
  fun op WHEN_INVARIANT _ = ()
  val op WHEN_INVARIANT = TDB.find "WHEN_INVARIANT"
  fun op UNTIL_INVARIANT _ = ()
  val op UNTIL_INVARIANT = TDB.find "UNTIL_INVARIANT"
  fun op BEFORE_INVARIANT _ = ()
  val op BEFORE_INVARIANT = TDB.find "BEFORE_INVARIANT"
  fun op ALWAYS_INVARIANT _ = ()
  val op ALWAYS_INVARIANT = TDB.find "ALWAYS_INVARIANT"
  fun op EVENTUAL_INVARIANT _ = ()
  val op EVENTUAL_INVARIANT = TDB.find "EVENTUAL_INVARIANT"
  fun op SWHEN_INVARIANT _ = ()
  val op SWHEN_INVARIANT = TDB.find "SWHEN_INVARIANT"
  fun op SUNTIL_INVARIANT _ = ()
  val op SUNTIL_INVARIANT = TDB.find "SUNTIL_INVARIANT"
  fun op SBEFORE_INVARIANT _ = ()
  val op SBEFORE_INVARIANT = TDB.find "SBEFORE_INVARIANT"
  fun op ALWAYS_IDEM _ = () val op ALWAYS_IDEM = TDB.find "ALWAYS_IDEM"
  fun op EVENTUAL_IDEM _ = ()
  val op EVENTUAL_IDEM = TDB.find "EVENTUAL_IDEM"
  fun op WHEN_IDEM _ = () val op WHEN_IDEM = TDB.find "WHEN_IDEM"
  fun op UNTIL_IDEM _ = () val op UNTIL_IDEM = TDB.find "UNTIL_IDEM"
  fun op BEFORE_IDEM _ = () val op BEFORE_IDEM = TDB.find "BEFORE_IDEM"
  fun op SWHEN_IDEM _ = () val op SWHEN_IDEM = TDB.find "SWHEN_IDEM"
  fun op SUNTIL_IDEM _ = () val op SUNTIL_IDEM = TDB.find "SUNTIL_IDEM"
  fun op SBEFORE_IDEM _ = () val op SBEFORE_IDEM = TDB.find "SBEFORE_IDEM"
  fun op NOT_ALWAYS _ = () val op NOT_ALWAYS = TDB.find "NOT_ALWAYS"
  fun op NOT_EVENTUAL _ = () val op NOT_EVENTUAL = TDB.find "NOT_EVENTUAL"
  fun op NOT_WHEN _ = () val op NOT_WHEN = TDB.find "NOT_WHEN"
  fun op NOT_UNTIL _ = () val op NOT_UNTIL = TDB.find "NOT_UNTIL"
  fun op NOT_BEFORE _ = () val op NOT_BEFORE = TDB.find "NOT_BEFORE"
  fun op NOT_SWHEN _ = () val op NOT_SWHEN = TDB.find "NOT_SWHEN"
  fun op NOT_SUNTIL _ = () val op NOT_SUNTIL = TDB.find "NOT_SUNTIL"
  fun op NOT_SBEFORE _ = () val op NOT_SBEFORE = TDB.find "NOT_SBEFORE"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val Temporal_Logic_grammars = merge_grammars ["indexedLists",
  "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="Temporal_Logic"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val Temporal_Logic_grammars = 
    Portable.## (addtyUDs,addtmUDs) Temporal_Logic_grammars
  val _ = Parse.grammarDB_insert("Temporal_Logic",Temporal_Logic_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "Temporal_Logic"

end
