structure topologyTheory :> topologyTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading topologyTheory ... "
    else ()
  
  open Type Term Thm
  local open quotientTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "topology"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/topology/topologyTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op istopology _ = () val op istopology = TDB.find "istopology"
  fun op topology_TY_DEF _ = ()
  val op topology_TY_DEF = TDB.find "topology_TY_DEF"
  fun op topology_tybij _ = ()
  val op topology_tybij = TDB.find "topology_tybij"
  fun op open_DEF _ = () val op open_DEF = TDB.find "open_DEF"
  fun op topspace _ = () val op topspace = TDB.find "topspace"
  fun op neigh _ = () val op neigh = TDB.find "neigh"
  fun op closed_in _ = () val op closed_in = TDB.find "closed_in"
  fun op closed_DEF _ = () val op closed_DEF = TDB.find "closed_DEF"
  fun op limpt _ = () val op limpt = TDB.find "limpt"
  fun op hull _ = () val op hull = TDB.find "hull"
  fun op ISTOPOLOGY_OPEN_IN _ = ()
  val op ISTOPOLOGY_OPEN_IN = TDB.find "ISTOPOLOGY_OPEN_IN"
  fun op TOPOLOGY_EQ _ = () val op TOPOLOGY_EQ = TDB.find "TOPOLOGY_EQ"
  fun op open_topspace _ = ()
  val op open_topspace = TDB.find "open_topspace"
  fun op OPEN_IN_CLAUSES _ = ()
  val op OPEN_IN_CLAUSES = TDB.find "OPEN_IN_CLAUSES"
  fun op OPEN_IN_SUBSET _ = ()
  val op OPEN_IN_SUBSET = TDB.find "OPEN_IN_SUBSET"
  fun op OPEN_IN_EMPTY _ = ()
  val op OPEN_IN_EMPTY = TDB.find "OPEN_IN_EMPTY"
  fun op OPEN_IN_INTER _ = ()
  val op OPEN_IN_INTER = TDB.find "OPEN_IN_INTER"
  fun op OPEN_IN_BIGUNION _ = ()
  val op OPEN_IN_BIGUNION = TDB.find "OPEN_IN_BIGUNION"
  fun op BIGUNION_2 _ = () val op BIGUNION_2 = TDB.find "BIGUNION_2"
  fun op OPEN_IN_UNION _ = ()
  val op OPEN_IN_UNION = TDB.find "OPEN_IN_UNION"
  fun op OPEN_IN_TOPSPACE _ = ()
  val op OPEN_IN_TOPSPACE = TDB.find "OPEN_IN_TOPSPACE"
  fun op OPEN_IN_BIGINTER _ = ()
  val op OPEN_IN_BIGINTER = TDB.find "OPEN_IN_BIGINTER"
  fun op OPEN_IN_SUBOPEN _ = ()
  val op OPEN_IN_SUBOPEN = TDB.find "OPEN_IN_SUBOPEN"
  fun op OPEN_OWN_NEIGH _ = ()
  val op OPEN_OWN_NEIGH = TDB.find "OPEN_OWN_NEIGH"
  fun op OPEN_UNOPEN _ = () val op OPEN_UNOPEN = TDB.find "OPEN_UNOPEN"
  fun op OPEN_SUBOPEN _ = () val op OPEN_SUBOPEN = TDB.find "OPEN_SUBOPEN"
  fun op OPEN_NEIGH _ = () val op OPEN_NEIGH = TDB.find "OPEN_NEIGH"
  fun op closed_topspace _ = ()
  val op closed_topspace = TDB.find "closed_topspace"
  fun op CLOSED_IN_OPEN_IN_COMPL _ = ()
  val op CLOSED_IN_OPEN_IN_COMPL = TDB.find "CLOSED_IN_OPEN_IN_COMPL"
  fun op CLOSED_IN_SUBSET _ = ()
  val op CLOSED_IN_SUBSET = TDB.find "CLOSED_IN_SUBSET"
  fun op CLOSED_IN_EMPTY _ = ()
  val op CLOSED_IN_EMPTY = TDB.find "CLOSED_IN_EMPTY"
  fun op CLOSED_IN_TOPSPACE _ = ()
  val op CLOSED_IN_TOPSPACE = TDB.find "CLOSED_IN_TOPSPACE"
  fun op CLOSED_IN_UNION _ = ()
  val op CLOSED_IN_UNION = TDB.find "CLOSED_IN_UNION"
  fun op CLOSED_IN_BIGINTER _ = ()
  val op CLOSED_IN_BIGINTER = TDB.find "CLOSED_IN_BIGINTER"
  fun op BIGINTER_2 _ = () val op BIGINTER_2 = TDB.find "BIGINTER_2"
  fun op CLOSED_IN_INTER _ = ()
  val op CLOSED_IN_INTER = TDB.find "CLOSED_IN_INTER"
  fun op OPEN_IN_CLOSED_IN_EQ _ = ()
  val op OPEN_IN_CLOSED_IN_EQ = TDB.find "OPEN_IN_CLOSED_IN_EQ"
  fun op OPEN_IN_CLOSED_IN _ = ()
  val op OPEN_IN_CLOSED_IN = TDB.find "OPEN_IN_CLOSED_IN"
  fun op OPEN_IN_DIFF _ = () val op OPEN_IN_DIFF = TDB.find "OPEN_IN_DIFF"
  fun op CLOSED_IN_DIFF _ = ()
  val op CLOSED_IN_DIFF = TDB.find "CLOSED_IN_DIFF"
  fun op CLOSED_IN_BIGUNION _ = ()
  val op CLOSED_IN_BIGUNION = TDB.find "CLOSED_IN_BIGUNION"
  fun op CLOSED_LIMPT _ = () val op CLOSED_LIMPT = TDB.find "CLOSED_LIMPT"
  fun op HULL_P _ = () val op HULL_P = TDB.find "HULL_P"
  fun op P_HULL _ = () val op P_HULL = TDB.find "P_HULL"
  fun op HULL_EQ _ = () val op HULL_EQ = TDB.find "HULL_EQ"
  fun op HULL_HULL _ = () val op HULL_HULL = TDB.find "HULL_HULL"
  fun op HULL_SUBSET _ = () val op HULL_SUBSET = TDB.find "HULL_SUBSET"
  fun op HULL_MONO _ = () val op HULL_MONO = TDB.find "HULL_MONO"
  fun op HULL_ANTIMONO _ = ()
  val op HULL_ANTIMONO = TDB.find "HULL_ANTIMONO"
  fun op HULL_MINIMAL _ = () val op HULL_MINIMAL = TDB.find "HULL_MINIMAL"
  fun op SUBSET_HULL _ = () val op SUBSET_HULL = TDB.find "SUBSET_HULL"
  fun op HULL_UNIQUE _ = () val op HULL_UNIQUE = TDB.find "HULL_UNIQUE"
  fun op HULL_UNION_SUBSET _ = ()
  val op HULL_UNION_SUBSET = TDB.find "HULL_UNION_SUBSET"
  fun op HULL_UNION _ = () val op HULL_UNION = TDB.find "HULL_UNION"
  fun op HULL_UNION_LEFT _ = ()
  val op HULL_UNION_LEFT = TDB.find "HULL_UNION_LEFT"
  fun op HULL_UNION_RIGHT _ = ()
  val op HULL_UNION_RIGHT = TDB.find "HULL_UNION_RIGHT"
  fun op HULL_REDUNDANT_EQ _ = ()
  val op HULL_REDUNDANT_EQ = TDB.find "HULL_REDUNDANT_EQ"
  fun op HULL_REDUNDANT _ = ()
  val op HULL_REDUNDANT = TDB.find "HULL_REDUNDANT"
  fun op HULL_INDUCT _ = () val op HULL_INDUCT = TDB.find "HULL_INDUCT"
  fun op HULL_INC _ = () val op HULL_INC = TDB.find "HULL_INC"
  fun op HULL_IMAGE_SUBSET _ = ()
  val op HULL_IMAGE_SUBSET = TDB.find "HULL_IMAGE_SUBSET"
  fun op HULL_IMAGE_GALOIS _ = ()
  val op HULL_IMAGE_GALOIS = TDB.find "HULL_IMAGE_GALOIS"
  fun op HULL_IMAGE _ = () val op HULL_IMAGE = TDB.find "HULL_IMAGE"
  fun op IS_HULL _ = () val op IS_HULL = TDB.find "IS_HULL"
  fun op HULLS_EQ _ = () val op HULLS_EQ = TDB.find "HULLS_EQ"
  fun op HULL_P_AND_Q _ = () val op HULL_P_AND_Q = TDB.find "HULL_P_AND_Q"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val topology_grammars = merge_grammars ["quotient"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="topology"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val topology_grammars = 
    Portable.## (addtyUDs,addtmUDs) topology_grammars
  val _ = Parse.grammarDB_insert("topology",topology_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "topology"

end
