structure fmspTheory :> fmspTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading fmspTheory ... "
    else ()
  
  open Type Term Thm
  local open sptreeTheory transferTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "fmsp"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/transfer/fmspTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op FMSP_def _ = () val op FMSP_def = TDB.find "FMSP_def"
  fun op FMSP_FDOM _ = () val op FMSP_FDOM = TDB.find "FMSP_FDOM"
  fun op FMSP_FEMPTY _ = () val op FMSP_FEMPTY = TDB.find "FMSP_FEMPTY"
  fun op FMSP_FUPDATE _ = () val op FMSP_FUPDATE = TDB.find "FMSP_FUPDATE"
  fun op FMSP_bitotal _ = () val op FMSP_bitotal = TDB.find "FMSP_bitotal"
  fun op FMSP_FORALL _ = () val op FMSP_FORALL = TDB.find "FMSP_FORALL"
  fun op FMSP_FUNION _ = () val op FMSP_FUNION = TDB.find "FMSP_FUNION"
  fun op FMSP_FDOMSUB _ = () val op FMSP_FDOMSUB = TDB.find "FMSP_FDOMSUB"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val fmsp_grammars = merge_grammars ["transfer", "sptree"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="fmsp"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val fmsp_grammars = 
    Portable.## (addtyUDs,addtmUDs) fmsp_grammars
  val _ = Parse.grammarDB_insert("fmsp",fmsp_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "fmsp"

end
