structure transferTheory :> transferTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading transferTheory ... "
    else ()
  
  open Type Term Thm
  local open indexedListsTheory patternMatchesTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "transfer"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/transfer/transferTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op right_unique_def _ = ()
  val op right_unique_def = TDB.find "right_unique_def"
  fun op left_unique_def _ = ()
  val op left_unique_def = TDB.find "left_unique_def"
  fun op bi_unique_def _ = ()
  val op bi_unique_def = TDB.find "bi_unique_def"
  fun op total_def _ = () val op total_def = TDB.find "total_def"
  fun op surj_def _ = () val op surj_def = TDB.find "surj_def"
  fun op bitotal_def _ = () val op bitotal_def = TDB.find "bitotal_def"
  fun op FUN_REL_def _ = () val op FUN_REL_def = TDB.find "FUN_REL_def"
  fun op PAIR_REL_def _ = () val op PAIR_REL_def = TDB.find "PAIR_REL_def"
  fun op FUN_REL_COMB _ = () val op FUN_REL_COMB = TDB.find "FUN_REL_COMB"
  fun op FUN_REL_ABS _ = () val op FUN_REL_ABS = TDB.find "FUN_REL_ABS"
  fun op FUN_REL_EQ2 _ = () val op FUN_REL_EQ2 = TDB.find "FUN_REL_EQ2"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val transfer_grammars = merge_grammars ["indexedLists", "patternMatches"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="transfer"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val transfer_grammars = 
    Portable.## (addtyUDs,addtmUDs) transfer_grammars
  val _ = Parse.grammarDB_insert("transfer",transfer_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "transfer"

end
