structure updateTheory :> updateTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading updateTheory ... "
    else ()
  
  open Type Term Thm
  local open sortingTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "update"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/update/updateTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op FIND_def _ = () val op FIND_def = TDB.find "FIND_def"
  fun op OVERRIDE_primitive_def _ = ()
  val op OVERRIDE_primitive_def = TDB.find "OVERRIDE_primitive_def"
  fun op LIST_UPDATE_def _ = ()
  val op LIST_UPDATE_def = TDB.find "LIST_UPDATE_def"
  fun op OVERRIDE_ind _ = () val op OVERRIDE_ind = TDB.find "OVERRIDE_ind"
  fun op OVERRIDE_def _ = () val op OVERRIDE_def = TDB.find "OVERRIDE_def"
  fun op LIST_UPDATE_LOOKUP _ = ()
  val op LIST_UPDATE_LOOKUP = TDB.find "LIST_UPDATE_LOOKUP"
  fun op LIST_UPDATE_OVERRIDE _ = ()
  val op LIST_UPDATE_OVERRIDE = TDB.find "LIST_UPDATE_OVERRIDE"
  fun op LIST_UPDATE_ALL_DISTINCT _ = ()
  val op LIST_UPDATE_ALL_DISTINCT = TDB.find "LIST_UPDATE_ALL_DISTINCT"
  fun op LIST_UPDATE_SORT_OVERRIDE _ = ()
  val op LIST_UPDATE_SORT_OVERRIDE = TDB.find "LIST_UPDATE_SORT_OVERRIDE"
  fun op LIST_UPDATE_THMS _ = ()
  val op LIST_UPDATE_THMS = TDB.find "LIST_UPDATE_THMS"
  fun op APPLY_UPDATE_ID _ = ()
  val op APPLY_UPDATE_ID = TDB.find "APPLY_UPDATE_ID"
  fun op APPLY_UPDATE_THM _ = ()
  val op APPLY_UPDATE_THM = TDB.find "APPLY_UPDATE_THM"
  fun op SAME_KEY_UPDATE_DIFFER _ = ()
  val op SAME_KEY_UPDATE_DIFFER = TDB.find "SAME_KEY_UPDATE_DIFFER"
  fun op UPDATE_APPLY_ID _ = ()
  val op UPDATE_APPLY_ID = TDB.find "UPDATE_APPLY_ID"
  fun op UPDATE_APPLY_IMP_ID _ = ()
  val op UPDATE_APPLY_IMP_ID = TDB.find "UPDATE_APPLY_IMP_ID"
  fun op UPDATE_COMMUTES _ = ()
  val op UPDATE_COMMUTES = TDB.find "UPDATE_COMMUTES"
  fun op UPDATE_EQ _ = () val op UPDATE_EQ = TDB.find "UPDATE_EQ"
  fun op UPDATE_def _ = () val op UPDATE_def = TDB.find "UPDATE_def"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val update_grammars = merge_grammars ["sorting"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="update"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val update_grammars = 
    Portable.## (addtyUDs,addtmUDs) update_grammars
  val _ = Parse.grammarDB_insert("update",update_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "update"

end
