
(*****************************************************************************)
(* Ignore everything up to "END BOILERPLATE"                                 *)
(*****************************************************************************)

(*****************************************************************************)
(* START BOILERPLATE NEEDED FOR COMPILATION                                  *)
(*****************************************************************************)

(******************************************************************************
* Load theories
******************************************************************************)
(* The commented out stuff below should be loaded in interactive sessions
quietdec := true;
map
 load
 ["sexp"];
open sexp;
printDepth := 1000;
printLength := 1000;
Globals.checking_const_names := false;
quietdec := false;
*)

structure PKGS =
struct

(******************************************************************************
* Boilerplate needed for compilation: open HOL4 systems modules
******************************************************************************)
open HolKernel Parse boolLib bossLib;

(******************************************************************************
* Open theories
******************************************************************************)
open intSyntax pairSyntax listSyntax stringLib numLib sexp;

(*****************************************************************************)
(* END BOILERPLATE                                                           *)
(*****************************************************************************)

val ACL2_PACKAGE_ALIST =
   [
    ("&ALLOW-OTHER-KEYS" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-MISER-WIDTH*" , "ACL2" , "COMMON-LISP"),
    ("&AUX" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-PPRINT-DISPATCH*" , "ACL2" , "COMMON-LISP"),
    ("&BODY" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-PRETTY*" , "ACL2" , "COMMON-LISP"),
    ("&ENVIRONMENT" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-RADIX*" , "ACL2" , "COMMON-LISP"),
    ("&KEY" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-READABLY*" , "ACL2" , "COMMON-LISP"),
    ("&OPTIONAL" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-RIGHT-MARGIN*" , "ACL2" , "COMMON-LISP"),
    ("&REST" , "ACL2" , "COMMON-LISP"),
    ("*QUERY-IO*" , "ACL2" , "COMMON-LISP"),
    ("&WHOLE" , "ACL2" , "COMMON-LISP"),
    ("*RANDOM-STATE*" , "ACL2" , "COMMON-LISP"),
    ("*" , "ACL2" , "COMMON-LISP"),
    ("*READ-BASE*" , "ACL2" , "COMMON-LISP"),
    ("**" , "ACL2" , "COMMON-LISP"),
    ("*READ-DEFAULT-FLOAT-FORMAT*" , "ACL2" , "COMMON-LISP"),
    ("***" , "ACL2" , "COMMON-LISP"),
    ("*READ-EVAL*" , "ACL2" , "COMMON-LISP"),
    ("*BREAK-ON-SIGNALS*" , "ACL2" , "COMMON-LISP"),
    ("*READ-SUPPRESS*" , "ACL2" , "COMMON-LISP"),
    ("*COMPILE-FILE-PATHNAME*" , "ACL2" , "COMMON-LISP"),
    ("*READTABLE*" , "ACL2" , "COMMON-LISP"),
    ("*COMPILE-FILE-TRUENAME*" , "ACL2" , "COMMON-LISP"),
    ("*STANDARD-INPUT*" , "ACL2" , "COMMON-LISP"),
    ("*COMPILE-PRINT*" , "ACL2" , "COMMON-LISP"),
    ("*STANDARD-OUTPUT*" , "ACL2" , "COMMON-LISP"),
    ("*COMPILE-VERBOSE*" , "ACL2" , "COMMON-LISP"),
    ("*TERMINAL-IO*" , "ACL2" , "COMMON-LISP"),
    ("*DEBUG-IO*" , "ACL2" , "COMMON-LISP"),
    ("*TRACE-OUTPUT*" , "ACL2" , "COMMON-LISP"),
    ("*DEBUGGER-HOOK*" , "ACL2" , "COMMON-LISP"),
    ("+" , "ACL2" , "COMMON-LISP"),
    ("*DEFAULT-PATHNAME-DEFAULTS*" , "ACL2" , "COMMON-LISP"),
    ("++" , "ACL2" , "COMMON-LISP"),
    ("*ERROR-OUTPUT*" , "ACL2" , "COMMON-LISP"),
    ("+++" , "ACL2" , "COMMON-LISP"),
    ("*FEATURES*" , "ACL2" , "COMMON-LISP"),
    ("-" , "ACL2" , "COMMON-LISP"),
    ("*GENSYM-COUNTER*" , "ACL2" , "COMMON-LISP"),
    ("/" , "ACL2" , "COMMON-LISP"),
    ("*LOAD-PATHNAME*" , "ACL2" , "COMMON-LISP"),
    ("//" , "ACL2" , "COMMON-LISP"),
    ("*LOAD-PRINT*" , "ACL2" , "COMMON-LISP"),
    ("///" , "ACL2" , "COMMON-LISP"),
    ("*LOAD-TRUENAME*" , "ACL2" , "COMMON-LISP"),
    ("/=" , "ACL2" , "COMMON-LISP"),
    ("*LOAD-VERBOSE*" , "ACL2" , "COMMON-LISP"),
    ("1+" , "ACL2" , "COMMON-LISP"),
    ("*MACROEXPAND-HOOK*" , "ACL2" , "COMMON-LISP"),
    ("1-" , "ACL2" , "COMMON-LISP"),
    ("*MODULES*" , "ACL2" , "COMMON-LISP"),
    ("<" , "ACL2" , "COMMON-LISP"),
    ("*PACKAGE*" , "ACL2" , "COMMON-LISP"),
    ("<=" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-ARRAY*" , "ACL2" , "COMMON-LISP"),
    ("=" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-BASE*" , "ACL2" , "COMMON-LISP"),
    (">" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-CASE*" , "ACL2" , "COMMON-LISP"),
    (">=" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-CIRCLE*" , "ACL2" , "COMMON-LISP"),
    ("ABORT" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-ESCAPE*" , "ACL2" , "COMMON-LISP"),
    ("ABS" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-GENSYM*" , "ACL2" , "COMMON-LISP"),
    ("ACONS" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-LENGTH*" , "ACL2" , "COMMON-LISP"),
    ("ACOS" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-LEVEL*" , "ACL2" , "COMMON-LISP"),
    ("ACOSH" , "ACL2" , "COMMON-LISP"),
    ("*PRINT-LINES*" , "ACL2" , "COMMON-LISP"),
    ("ADD-METHOD" , "ACL2" , "COMMON-LISP"),
    ("ADJOIN" , "ACL2" , "COMMON-LISP"),
    ("ATOM" , "ACL2" , "COMMON-LISP"),
    ("BOUNDP" , "ACL2" , "COMMON-LISP"),
    ("ADJUST-ARRAY" , "ACL2" , "COMMON-LISP"),
    ("BASE-CHAR" , "ACL2" , "COMMON-LISP"),
    ("BREAK" , "ACL2" , "COMMON-LISP"),
    ("ADJUSTABLE-ARRAY-P" , "ACL2" , "COMMON-LISP"),
    ("BASE-STRING" , "ACL2" , "COMMON-LISP"),
    ("BROADCAST-STREAM" , "ACL2" , "COMMON-LISP"),
    ("ALLOCATE-INSTANCE" , "ACL2" , "COMMON-LISP"),
    ("BIGNUM" , "ACL2" , "COMMON-LISP"),
    ("BROADCAST-STREAM-STREAMS" , "ACL2" , "COMMON-LISP"),
    ("ALPHA-CHAR-P" , "ACL2" , "COMMON-LISP"),
    ("BIT" , "ACL2" , "COMMON-LISP"),
    ("BUILT-IN-CLASS" , "ACL2" , "COMMON-LISP"),
    ("ALPHANUMERICP" , "ACL2" , "COMMON-LISP"),
    ("BIT-AND" , "ACL2" , "COMMON-LISP"),
    ("BUTLAST" , "ACL2" , "COMMON-LISP"),
    ("AND" , "ACL2" , "COMMON-LISP"),
    ("BIT-ANDC1" , "ACL2" , "COMMON-LISP"),
    ("BYTE" , "ACL2" , "COMMON-LISP"),
    ("APPEND" , "ACL2" , "COMMON-LISP"),
    ("BIT-ANDC2" , "ACL2" , "COMMON-LISP"),
    ("BYTE-POSITION" , "ACL2" , "COMMON-LISP"),
    ("APPLY" , "ACL2" , "COMMON-LISP"),
    ("BIT-EQV" , "ACL2" , "COMMON-LISP"),
    ("BYTE-SIZE" , "ACL2" , "COMMON-LISP"),
    ("APROPOS" , "ACL2" , "COMMON-LISP"),
    ("BIT-IOR" , "ACL2" , "COMMON-LISP"),
    ("CAAAAR" , "ACL2" , "COMMON-LISP"),
    ("APROPOS-LIST" , "ACL2" , "COMMON-LISP"),
    ("BIT-NAND" , "ACL2" , "COMMON-LISP"),
    ("CAAADR" , "ACL2" , "COMMON-LISP"),
    ("AREF" , "ACL2" , "COMMON-LISP"),
    ("BIT-NOR" , "ACL2" , "COMMON-LISP"),
    ("CAAAR" , "ACL2" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR" , "ACL2" , "COMMON-LISP"),
    ("BIT-NOT" , "ACL2" , "COMMON-LISP"),
    ("CAADAR" , "ACL2" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERANDS" , "ACL2" , "COMMON-LISP"),
    ("BIT-ORC1" , "ACL2" , "COMMON-LISP"),
    ("CAADDR" , "ACL2" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERATION" , "ACL2" , "COMMON-LISP"),
    ("BIT-ORC2" , "ACL2" , "COMMON-LISP"),
    ("CAADR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY" , "ACL2" , "COMMON-LISP"),
    ("BIT-VECTOR" , "ACL2" , "COMMON-LISP"),
    ("CAAR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-DIMENSION" , "ACL2" , "COMMON-LISP"),
    ("BIT-VECTOR-P" , "ACL2" , "COMMON-LISP"),
    ("CADAAR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-DIMENSION-LIMIT" , "ACL2" , "COMMON-LISP"),
    ("BIT-XOR" , "ACL2" , "COMMON-LISP"),
    ("CADADR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-DIMENSIONS" , "ACL2" , "COMMON-LISP"),
    ("BLOCK" , "ACL2" , "COMMON-LISP"),
    ("CADAR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-DISPLACEMENT" , "ACL2" , "COMMON-LISP"),
    ("BOOLE" , "ACL2" , "COMMON-LISP"),
    ("CADDAR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-ELEMENT-TYPE" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-1" , "ACL2" , "COMMON-LISP"),
    ("CADDDR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-HAS-FILL-POINTER-P" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-2" , "ACL2" , "COMMON-LISP"),
    ("CADDR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-IN-BOUNDS-P" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-AND" , "ACL2" , "COMMON-LISP"),
    ("CADR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-RANK" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-ANDC1" , "ACL2" , "COMMON-LISP"),
    ("CALL-ARGUMENTS-LIMIT" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-RANK-LIMIT" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-ANDC2" , "ACL2" , "COMMON-LISP"),
    ("CALL-METHOD" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-ROW-MAJOR-INDEX" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-C1" , "ACL2" , "COMMON-LISP"),
    ("CALL-NEXT-METHOD" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-C2" , "ACL2" , "COMMON-LISP"),
    ("CAR" , "ACL2" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE-LIMIT" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-CLR" , "ACL2" , "COMMON-LISP"),
    ("CASE" , "ACL2" , "COMMON-LISP"),
    ("ARRAYP" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-EQV" , "ACL2" , "COMMON-LISP"),
    ("CATCH" , "ACL2" , "COMMON-LISP"),
    ("ASH" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-IOR" , "ACL2" , "COMMON-LISP"),
    ("CCASE" , "ACL2" , "COMMON-LISP"),
    ("ASIN" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-NAND" , "ACL2" , "COMMON-LISP"),
    ("CDAAAR" , "ACL2" , "COMMON-LISP"),
    ("ASINH" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-NOR" , "ACL2" , "COMMON-LISP"),
    ("CDAADR" , "ACL2" , "COMMON-LISP"),
    ("ASSERT" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-ORC1" , "ACL2" , "COMMON-LISP"),
    ("CDAAR" , "ACL2" , "COMMON-LISP"),
    ("ASSOC" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-ORC2" , "ACL2" , "COMMON-LISP"),
    ("CDADAR" , "ACL2" , "COMMON-LISP"),
    ("ASSOC-IF" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-SET" , "ACL2" , "COMMON-LISP"),
    ("CDADDR" , "ACL2" , "COMMON-LISP"),
    ("ASSOC-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("BOOLE-XOR" , "ACL2" , "COMMON-LISP"),
    ("CDADR" , "ACL2" , "COMMON-LISP"),
    ("ATAN" , "ACL2" , "COMMON-LISP"),
    ("BOOLEAN" , "ACL2" , "COMMON-LISP"),
    ("CDAR" , "ACL2" , "COMMON-LISP"),
    ("ATANH" , "ACL2" , "COMMON-LISP"),
    ("BOTH-CASE-P" , "ACL2" , "COMMON-LISP"),
    ("CDDAAR" , "ACL2" , "COMMON-LISP"),
    ("CDDADR" , "ACL2" , "COMMON-LISP"),
    ("CLEAR-INPUT" , "ACL2" , "COMMON-LISP"),
    ("COPY-TREE" , "ACL2" , "COMMON-LISP"),
    ("CDDAR" , "ACL2" , "COMMON-LISP"),
    ("CLEAR-OUTPUT" , "ACL2" , "COMMON-LISP"),
    ("COS" , "ACL2" , "COMMON-LISP"),
    ("CDDDAR" , "ACL2" , "COMMON-LISP"),
    ("CLOSE" , "ACL2" , "COMMON-LISP"),
    ("COSH" , "ACL2" , "COMMON-LISP"),
    ("CDDDDR" , "ACL2" , "COMMON-LISP"),
    ("CLRHASH" , "ACL2" , "COMMON-LISP"),
    ("COUNT" , "ACL2" , "COMMON-LISP"),
    ("CDDDR" , "ACL2" , "COMMON-LISP"),
    ("CODE-CHAR" , "ACL2" , "COMMON-LISP"),
    ("COUNT-IF" , "ACL2" , "COMMON-LISP"),
    ("CDDR" , "ACL2" , "COMMON-LISP"),
    ("COERCE" , "ACL2" , "COMMON-LISP"),
    ("COUNT-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("CDR" , "ACL2" , "COMMON-LISP"),
    ("COMPILATION-SPEED" , "ACL2" , "COMMON-LISP"),
    ("CTYPECASE" , "ACL2" , "COMMON-LISP"),
    ("CEILING" , "ACL2" , "COMMON-LISP"),
    ("COMPILE" , "ACL2" , "COMMON-LISP"),
    ("DEBUG" , "ACL2" , "COMMON-LISP"),
    ("CELL-ERROR" , "ACL2" , "COMMON-LISP"),
    ("COMPILE-FILE" , "ACL2" , "COMMON-LISP"),
    ("DECF" , "ACL2" , "COMMON-LISP"),
    ("CELL-ERROR-NAME" , "ACL2" , "COMMON-LISP"),
    ("COMPILE-FILE-PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("DECLAIM" , "ACL2" , "COMMON-LISP"),
    ("CERROR" , "ACL2" , "COMMON-LISP"),
    ("COMPILED-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("DECLARATION" , "ACL2" , "COMMON-LISP"),
    ("CHANGE-CLASS" , "ACL2" , "COMMON-LISP"),
    ("COMPILED-FUNCTION-P" , "ACL2" , "COMMON-LISP"),
    ("DECLARE" , "ACL2" , "COMMON-LISP"),
    ("CHAR" , "ACL2" , "COMMON-LISP"),
    ("COMPILER-MACRO" , "ACL2" , "COMMON-LISP"),
    ("DECODE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("CHAR-CODE" , "ACL2" , "COMMON-LISP"),
    ("COMPILER-MACRO-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("DECODE-UNIVERSAL-TIME" , "ACL2" , "COMMON-LISP"),
    ("CHAR-CODE-LIMIT" , "ACL2" , "COMMON-LISP"),
    ("COMPLEMENT" , "ACL2" , "COMMON-LISP"),
    ("DEFCLASS" , "ACL2" , "COMMON-LISP"),
    ("CHAR-DOWNCASE" , "ACL2" , "COMMON-LISP"),
    ("COMPLEX" , "ACL2" , "COMMON-LISP"),
    ("DEFCONSTANT" , "ACL2" , "COMMON-LISP"),
    ("CHAR-EQUAL" , "ACL2" , "COMMON-LISP"),
    ("COMPLEXP" , "ACL2" , "COMMON-LISP"),
    ("DEFGENERIC" , "ACL2" , "COMMON-LISP"),
    ("CHAR-GREATERP" , "ACL2" , "COMMON-LISP"),
    ("COMPUTE-APPLICABLE-METHODS" , "ACL2" , "COMMON-LISP"),
    ("DEFINE-COMPILER-MACRO" , "ACL2" , "COMMON-LISP"),
    ("CHAR-INT" , "ACL2" , "COMMON-LISP"),
    ("COMPUTE-RESTARTS" , "ACL2" , "COMMON-LISP"),
    ("DEFINE-CONDITION" , "ACL2" , "COMMON-LISP"),
    ("CHAR-LESSP" , "ACL2" , "COMMON-LISP"),
    ("CONCATENATE" , "ACL2" , "COMMON-LISP"),
    ("DEFINE-METHOD-COMBINATION" , "ACL2" , "COMMON-LISP"),
    ("CHAR-NAME" , "ACL2" , "COMMON-LISP"),
    ("CONCATENATED-STREAM" , "ACL2" , "COMMON-LISP"),
    ("DEFINE-MODIFY-MACRO" , "ACL2" , "COMMON-LISP"),
    ("CHAR-NOT-EQUAL" , "ACL2" , "COMMON-LISP"),
    ("CONCATENATED-STREAM-STREAMS" , "ACL2" , "COMMON-LISP"),
    ("DEFINE-SETF-EXPANDER" , "ACL2" , "COMMON-LISP"),
    ("CHAR-NOT-GREATERP" , "ACL2" , "COMMON-LISP"),
    ("COND" , "ACL2" , "COMMON-LISP"),
    ("DEFINE-SYMBOL-MACRO" , "ACL2" , "COMMON-LISP"),
    ("CHAR-NOT-LESSP" , "ACL2" , "COMMON-LISP"),
    ("CONDITION" , "ACL2" , "COMMON-LISP"),
    ("DEFMACRO" , "ACL2" , "COMMON-LISP"),
    ("CHAR-UPCASE" , "ACL2" , "COMMON-LISP"),
    ("CONJUGATE" , "ACL2" , "COMMON-LISP"),
    ("DEFMETHOD" , "ACL2" , "COMMON-LISP"),
    ("CHAR/=" , "ACL2" , "COMMON-LISP"),
    ("CONS" , "ACL2" , "COMMON-LISP"),
    ("DEFPACKAGE" , "ACL2" , "COMMON-LISP"),
    ("CHAR<" , "ACL2" , "COMMON-LISP"),
    ("CONSP" , "ACL2" , "COMMON-LISP"),
    ("DEFPARAMETER" , "ACL2" , "COMMON-LISP"),
    ("CHAR<=" , "ACL2" , "COMMON-LISP"),
    ("CONSTANTLY" , "ACL2" , "COMMON-LISP"),
    ("DEFSETF" , "ACL2" , "COMMON-LISP"),
    ("CHAR=" , "ACL2" , "COMMON-LISP"),
    ("CONSTANTP" , "ACL2" , "COMMON-LISP"),
    ("DEFSTRUCT" , "ACL2" , "COMMON-LISP"),
    ("CHAR>" , "ACL2" , "COMMON-LISP"),
    ("CONTINUE" , "ACL2" , "COMMON-LISP"),
    ("DEFTYPE" , "ACL2" , "COMMON-LISP"),
    ("CHAR>=" , "ACL2" , "COMMON-LISP"),
    ("CONTROL-ERROR" , "ACL2" , "COMMON-LISP"),
    ("DEFUN" , "ACL2" , "COMMON-LISP"),
    ("CHARACTER" , "ACL2" , "COMMON-LISP"),
    ("COPY-ALIST" , "ACL2" , "COMMON-LISP"),
    ("DEFVAR" , "ACL2" , "COMMON-LISP"),
    ("CHARACTERP" , "ACL2" , "COMMON-LISP"),
    ("COPY-LIST" , "ACL2" , "COMMON-LISP"),
    ("DELETE" , "ACL2" , "COMMON-LISP"),
    ("CHECK-TYPE" , "ACL2" , "COMMON-LISP"),
    ("COPY-PPRINT-DISPATCH" , "ACL2" , "COMMON-LISP"),
    ("DELETE-DUPLICATES" , "ACL2" , "COMMON-LISP"),
    ("CIS" , "ACL2" , "COMMON-LISP"),
    ("COPY-READTABLE" , "ACL2" , "COMMON-LISP"),
    ("DELETE-FILE" , "ACL2" , "COMMON-LISP"),
    ("CLASS" , "ACL2" , "COMMON-LISP"),
    ("COPY-SEQ" , "ACL2" , "COMMON-LISP"),
    ("DELETE-IF" , "ACL2" , "COMMON-LISP"),
    ("CLASS-NAME" , "ACL2" , "COMMON-LISP"),
    ("COPY-STRUCTURE" , "ACL2" , "COMMON-LISP"),
    ("DELETE-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("CLASS-OF" , "ACL2" , "COMMON-LISP"),
    ("COPY-SYMBOL" , "ACL2" , "COMMON-LISP"),
    ("DELETE-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("DENOMINATOR" , "ACL2" , "COMMON-LISP"),
    ("EQ" , "ACL2" , "COMMON-LISP"),
    ("DEPOSIT-FIELD" , "ACL2" , "COMMON-LISP"),
    ("EQL" , "ACL2" , "COMMON-LISP"),
    ("DESCRIBE" , "ACL2" , "COMMON-LISP"),
    ("EQUAL" , "ACL2" , "COMMON-LISP"),
    ("DESCRIBE-OBJECT" , "ACL2" , "COMMON-LISP"),
    ("EQUALP" , "ACL2" , "COMMON-LISP"),
    ("DESTRUCTURING-BIND" , "ACL2" , "COMMON-LISP"),
    ("ERROR" , "ACL2" , "COMMON-LISP"),
    ("DIGIT-CHAR" , "ACL2" , "COMMON-LISP"),
    ("ETYPECASE" , "ACL2" , "COMMON-LISP"),
    ("DIGIT-CHAR-P" , "ACL2" , "COMMON-LISP"),
    ("EVAL" , "ACL2" , "COMMON-LISP"),
    ("DIRECTORY" , "ACL2" , "COMMON-LISP"),
    ("EVAL-WHEN" , "ACL2" , "COMMON-LISP"),
    ("DIRECTORY-NAMESTRING" , "ACL2" , "COMMON-LISP"),
    ("EVENP" , "ACL2" , "COMMON-LISP"),
    ("DISASSEMBLE" , "ACL2" , "COMMON-LISP"),
    ("EVERY" , "ACL2" , "COMMON-LISP"),
    ("DIVISION-BY-ZERO" , "ACL2" , "COMMON-LISP"),
    ("EXP" , "ACL2" , "COMMON-LISP"),
    ("DO" , "ACL2" , "COMMON-LISP"),
    ("EXPORT" , "ACL2" , "COMMON-LISP"),
    ("DO*" , "ACL2" , "COMMON-LISP"),
    ("EXPT" , "ACL2" , "COMMON-LISP"),
    ("DO-ALL-SYMBOLS" , "ACL2" , "COMMON-LISP"),
    ("EXTENDED-CHAR" , "ACL2" , "COMMON-LISP"),
    ("DO-EXTERNAL-SYMBOLS" , "ACL2" , "COMMON-LISP"),
    ("FBOUNDP" , "ACL2" , "COMMON-LISP"),
    ("DO-SYMBOLS" , "ACL2" , "COMMON-LISP"),
    ("FCEILING" , "ACL2" , "COMMON-LISP"),
    ("DOCUMENTATION" , "ACL2" , "COMMON-LISP"),
    ("FDEFINITION" , "ACL2" , "COMMON-LISP"),
    ("DOLIST" , "ACL2" , "COMMON-LISP"),
    ("FFLOOR" , "ACL2" , "COMMON-LISP"),
    ("DOTIMES" , "ACL2" , "COMMON-LISP"),
    ("FIFTH" , "ACL2" , "COMMON-LISP"),
    ("DOUBLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("FILE-AUTHOR" , "ACL2" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("FILE-ERROR" , "ACL2" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-NEGATIVE-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("FILE-ERROR-PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("DPB" , "ACL2" , "COMMON-LISP"),
    ("FILE-LENGTH" , "ACL2" , "COMMON-LISP"),
    ("DRIBBLE" , "ACL2" , "COMMON-LISP"),
    ("FILE-NAMESTRING" , "ACL2" , "COMMON-LISP"),
    ("DYNAMIC-EXTENT" , "ACL2" , "COMMON-LISP"),
    ("FILE-POSITION" , "ACL2" , "COMMON-LISP"),
    ("ECASE" , "ACL2" , "COMMON-LISP"),
    ("FILE-STREAM" , "ACL2" , "COMMON-LISP"),
    ("ECHO-STREAM" , "ACL2" , "COMMON-LISP"),
    ("FILE-STRING-LENGTH" , "ACL2" , "COMMON-LISP"),
    ("ECHO-STREAM-INPUT-STREAM" , "ACL2" , "COMMON-LISP"),
    ("FILE-WRITE-DATE" , "ACL2" , "COMMON-LISP"),
    ("ECHO-STREAM-OUTPUT-STREAM" , "ACL2" , "COMMON-LISP"),
    ("FILL" , "ACL2" , "COMMON-LISP"),
    ("ED" , "ACL2" , "COMMON-LISP"),
    ("FILL-POINTER" , "ACL2" , "COMMON-LISP"),
    ("EIGHTH" , "ACL2" , "COMMON-LISP"),
    ("FIND" , "ACL2" , "COMMON-LISP"),
    ("ELT" , "ACL2" , "COMMON-LISP"),
    ("FIND-ALL-SYMBOLS" , "ACL2" , "COMMON-LISP"),
    ("ENCODE-UNIVERSAL-TIME" , "ACL2" , "COMMON-LISP"),
    ("FIND-CLASS" , "ACL2" , "COMMON-LISP"),
    ("END-OF-FILE" , "ACL2" , "COMMON-LISP"),
    ("FIND-IF" , "ACL2" , "COMMON-LISP"),
    ("ENDP" , "ACL2" , "COMMON-LISP"),
    ("FIND-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("ENOUGH-NAMESTRING" , "ACL2" , "COMMON-LISP"),
    ("FIND-METHOD" , "ACL2" , "COMMON-LISP"),
    ("ENSURE-DIRECTORIES-EXIST" , "ACL2" , "COMMON-LISP"),
    ("FIND-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("ENSURE-GENERIC-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("FIND-RESTART" , "ACL2" , "COMMON-LISP"),
    ("FIND-SYMBOL" , "ACL2" , "COMMON-LISP"),
    ("GET-INTERNAL-RUN-TIME" , "ACL2" , "COMMON-LISP"),
    ("FINISH-OUTPUT" , "ACL2" , "COMMON-LISP"),
    ("GET-MACRO-CHARACTER" , "ACL2" , "COMMON-LISP"),
    ("FIRST" , "ACL2" , "COMMON-LISP"),
    ("GET-OUTPUT-STREAM-STRING" , "ACL2" , "COMMON-LISP"),
    ("FIXNUM" , "ACL2" , "COMMON-LISP"),
    ("GET-PROPERTIES" , "ACL2" , "COMMON-LISP"),
    ("FLET" , "ACL2" , "COMMON-LISP"),
    ("GET-SETF-EXPANSION" , "ACL2" , "COMMON-LISP"),
    ("FLOAT" , "ACL2" , "COMMON-LISP"),
    ("GET-UNIVERSAL-TIME" , "ACL2" , "COMMON-LISP"),
    ("FLOAT-DIGITS" , "ACL2" , "COMMON-LISP"),
    ("GETF" , "ACL2" , "COMMON-LISP"),
    ("FLOAT-PRECISION" , "ACL2" , "COMMON-LISP"),
    ("GETHASH" , "ACL2" , "COMMON-LISP"),
    ("FLOAT-RADIX" , "ACL2" , "COMMON-LISP"),
    ("GO" , "ACL2" , "COMMON-LISP"),
    ("FLOAT-SIGN" , "ACL2" , "COMMON-LISP"),
    ("GRAPHIC-CHAR-P" , "ACL2" , "COMMON-LISP"),
    ("FLOATING-POINT-INEXACT" , "ACL2" , "COMMON-LISP"),
    ("HANDLER-BIND" , "ACL2" , "COMMON-LISP"),
    ("FLOATING-POINT-INVALID-OPERATION" , "ACL2" , "COMMON-LISP"),
    ("HANDLER-CASE" , "ACL2" , "COMMON-LISP"),
    ("FLOATING-POINT-OVERFLOW" , "ACL2" , "COMMON-LISP"),
    ("HASH-TABLE" , "ACL2" , "COMMON-LISP"),
    ("FLOATING-POINT-UNDERFLOW" , "ACL2" , "COMMON-LISP"),
    ("HASH-TABLE-COUNT" , "ACL2" , "COMMON-LISP"),
    ("FLOATP" , "ACL2" , "COMMON-LISP"),
    ("HASH-TABLE-P" , "ACL2" , "COMMON-LISP"),
    ("FLOOR" , "ACL2" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-SIZE" , "ACL2" , "COMMON-LISP"),
    ("FMAKUNBOUND" , "ACL2" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-THRESHOLD" , "ACL2" , "COMMON-LISP"),
    ("FORCE-OUTPUT" , "ACL2" , "COMMON-LISP"),
    ("HASH-TABLE-SIZE" , "ACL2" , "COMMON-LISP"),
    ("FORMAT" , "ACL2" , "COMMON-LISP"),
    ("HASH-TABLE-TEST" , "ACL2" , "COMMON-LISP"),
    ("FORMATTER" , "ACL2" , "COMMON-LISP"),
    ("HOST-NAMESTRING" , "ACL2" , "COMMON-LISP"),
    ("FOURTH" , "ACL2" , "COMMON-LISP"),
    ("IDENTITY" , "ACL2" , "COMMON-LISP"),
    ("FRESH-LINE" , "ACL2" , "COMMON-LISP"),
    ("IF" , "ACL2" , "COMMON-LISP"),
    ("FROUND" , "ACL2" , "COMMON-LISP"),
    ("IGNORABLE" , "ACL2" , "COMMON-LISP"),
    ("FTRUNCATE" , "ACL2" , "COMMON-LISP"),
    ("IGNORE" , "ACL2" , "COMMON-LISP"),
    ("FTYPE" , "ACL2" , "COMMON-LISP"),
    ("IGNORE-ERRORS" , "ACL2" , "COMMON-LISP"),
    ("FUNCALL" , "ACL2" , "COMMON-LISP"),
    ("IMAGPART" , "ACL2" , "COMMON-LISP"),
    ("FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("IMPORT" , "ACL2" , "COMMON-LISP"),
    ("FUNCTION-KEYWORDS" , "ACL2" , "COMMON-LISP"),
    ("IN-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("FUNCTION-LAMBDA-EXPRESSION" , "ACL2" , "COMMON-LISP"),
    ("INCF" , "ACL2" , "COMMON-LISP"),
    ("FUNCTIONP" , "ACL2" , "COMMON-LISP"),
    ("INITIALIZE-INSTANCE" , "ACL2" , "COMMON-LISP"),
    ("GCD" , "ACL2" , "COMMON-LISP"),
    ("INLINE" , "ACL2" , "COMMON-LISP"),
    ("GENERIC-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("INPUT-STREAM-P" , "ACL2" , "COMMON-LISP"),
    ("GENSYM" , "ACL2" , "COMMON-LISP"),
    ("INSPECT" , "ACL2" , "COMMON-LISP"),
    ("GENTEMP" , "ACL2" , "COMMON-LISP"),
    ("INTEGER" , "ACL2" , "COMMON-LISP"),
    ("GET" , "ACL2" , "COMMON-LISP"),
    ("INTEGER-DECODE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("GET-DECODED-TIME" , "ACL2" , "COMMON-LISP"),
    ("INTEGER-LENGTH" , "ACL2" , "COMMON-LISP"),
    ("GET-DISPATCH-MACRO-CHARACTER" , "ACL2" , "COMMON-LISP"),
    ("INTEGERP" , "ACL2" , "COMMON-LISP"),
    ("GET-INTERNAL-REAL-TIME" , "ACL2" , "COMMON-LISP"),
    ("INTERACTIVE-STREAM-P" , "ACL2" , "COMMON-LISP"),
    ("INTERN" , "ACL2" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-TYPE" , "ACL2" , "COMMON-LISP"),
    ("INTERNAL-TIME-UNITS-PER-SECOND" , "ACL2" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-VERSION" , "ACL2" , "COMMON-LISP"),
    ("INTERSECTION" , "ACL2" , "COMMON-LISP"),
    ("LIST" , "ACL2" , "COMMON-LISP"),
    ("INVALID-METHOD-ERROR" , "ACL2" , "COMMON-LISP"),
    ("LIST*" , "ACL2" , "COMMON-LISP"),
    ("INVOKE-DEBUGGER" , "ACL2" , "COMMON-LISP"),
    ("LIST-ALL-PACKAGES" , "ACL2" , "COMMON-LISP"),
    ("INVOKE-RESTART" , "ACL2" , "COMMON-LISP"),
    ("LIST-LENGTH" , "ACL2" , "COMMON-LISP"),
    ("INVOKE-RESTART-INTERACTIVELY" , "ACL2" , "COMMON-LISP"),
    ("LISTEN" , "ACL2" , "COMMON-LISP"),
    ("ISQRT" , "ACL2" , "COMMON-LISP"),
    ("LISTP" , "ACL2" , "COMMON-LISP"),
    ("KEYWORD" , "ACL2" , "COMMON-LISP"),
    ("LOAD" , "ACL2" , "COMMON-LISP"),
    ("KEYWORDP" , "ACL2" , "COMMON-LISP"),
    ("LOAD-LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2" , "COMMON-LISP"),
    ("LABELS" , "ACL2" , "COMMON-LISP"),
    ("LOAD-TIME-VALUE" , "ACL2" , "COMMON-LISP"),
    ("LAMBDA" , "ACL2" , "COMMON-LISP"),
    ("LOCALLY" , "ACL2" , "COMMON-LISP"),
    ("LAMBDA-LIST-KEYWORDS" , "ACL2" , "COMMON-LISP"),
    ("LOG" , "ACL2" , "COMMON-LISP"),
    ("LAMBDA-PARAMETERS-LIMIT" , "ACL2" , "COMMON-LISP"),
    ("LOGAND" , "ACL2" , "COMMON-LISP"),
    ("LAST" , "ACL2" , "COMMON-LISP"),
    ("LOGANDC1" , "ACL2" , "COMMON-LISP"),
    ("LCM" , "ACL2" , "COMMON-LISP"),
    ("LOGANDC2" , "ACL2" , "COMMON-LISP"),
    ("LDB" , "ACL2" , "COMMON-LISP"),
    ("LOGBITP" , "ACL2" , "COMMON-LISP"),
    ("LDB-TEST" , "ACL2" , "COMMON-LISP"),
    ("LOGCOUNT" , "ACL2" , "COMMON-LISP"),
    ("LDIFF" , "ACL2" , "COMMON-LISP"),
    ("LOGEQV" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-DOUBLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGICAL-PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-LONG-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGIOR" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-LONG-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGNAND" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SHORT-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGNOR" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGNOT" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SHORT-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGORC1" , "ACL2" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SINGLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGORC2" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-DOUBLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGTEST" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-LONG-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOGXOR" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LONG-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-LONG-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LONG-FLOAT-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SHORT-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LONG-FLOAT-NEGATIVE-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LONG-SITE-NAME" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SHORT-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOOP" , "ACL2" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SINGLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("LOOP-FINISH" , "ACL2" , "COMMON-LISP"),
    ("LENGTH" , "ACL2" , "COMMON-LISP"),
    ("LOWER-CASE-P" , "ACL2" , "COMMON-LISP"),
    ("LET" , "ACL2" , "COMMON-LISP"),
    ("MACHINE-INSTANCE" , "ACL2" , "COMMON-LISP"),
    ("LET*" , "ACL2" , "COMMON-LISP"),
    ("MACHINE-TYPE" , "ACL2" , "COMMON-LISP"),
    ("MACHINE-VERSION" , "ACL2" , "COMMON-LISP"),
    ("MASK-FIELD" , "ACL2" , "COMMON-LISP"),
    ("MACRO-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("MAX" , "ACL2" , "COMMON-LISP"),
    ("MACROEXPAND" , "ACL2" , "COMMON-LISP"),
    ("MEMBER" , "ACL2" , "COMMON-LISP"),
    ("MACROEXPAND-1" , "ACL2" , "COMMON-LISP"),
    ("MEMBER-IF" , "ACL2" , "COMMON-LISP"),
    ("MACROLET" , "ACL2" , "COMMON-LISP"),
    ("MEMBER-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-ARRAY" , "ACL2" , "COMMON-LISP"),
    ("MERGE" , "ACL2" , "COMMON-LISP"),
    ("MAKE-BROADCAST-STREAM" , "ACL2" , "COMMON-LISP"),
    ("MERGE-PATHNAMES" , "ACL2" , "COMMON-LISP"),
    ("MAKE-CONCATENATED-STREAM" , "ACL2" , "COMMON-LISP"),
    ("METHOD" , "ACL2" , "COMMON-LISP"),
    ("MAKE-CONDITION" , "ACL2" , "COMMON-LISP"),
    ("METHOD-COMBINATION" , "ACL2" , "COMMON-LISP"),
    ("MAKE-DISPATCH-MACRO-CHARACTER" , "ACL2" , "COMMON-LISP"),
    ("METHOD-COMBINATION-ERROR" , "ACL2" , "COMMON-LISP"),
    ("MAKE-ECHO-STREAM" , "ACL2" , "COMMON-LISP"),
    ("METHOD-QUALIFIERS" , "ACL2" , "COMMON-LISP"),
    ("MAKE-HASH-TABLE" , "ACL2" , "COMMON-LISP"),
    ("MIN" , "ACL2" , "COMMON-LISP"),
    ("MAKE-INSTANCE" , "ACL2" , "COMMON-LISP"),
    ("MINUSP" , "ACL2" , "COMMON-LISP"),
    ("MAKE-INSTANCES-OBSOLETE" , "ACL2" , "COMMON-LISP"),
    ("MISMATCH" , "ACL2" , "COMMON-LISP"),
    ("MAKE-LIST" , "ACL2" , "COMMON-LISP"),
    ("MOD" , "ACL2" , "COMMON-LISP"),
    ("MAKE-LOAD-FORM" , "ACL2" , "COMMON-LISP"),
    ("MOST-NEGATIVE-DOUBLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-LOAD-FORM-SAVING-SLOTS" , "ACL2" , "COMMON-LISP"),
    ("MOST-NEGATIVE-FIXNUM" , "ACL2" , "COMMON-LISP"),
    ("MAKE-METHOD" , "ACL2" , "COMMON-LISP"),
    ("MOST-NEGATIVE-LONG-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SHORT-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SINGLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-RANDOM-STATE" , "ACL2" , "COMMON-LISP"),
    ("MOST-POSITIVE-DOUBLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-SEQUENCE" , "ACL2" , "COMMON-LISP"),
    ("MOST-POSITIVE-FIXNUM" , "ACL2" , "COMMON-LISP"),
    ("MAKE-STRING" , "ACL2" , "COMMON-LISP"),
    ("MOST-POSITIVE-LONG-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-STRING-INPUT-STREAM" , "ACL2" , "COMMON-LISP"),
    ("MOST-POSITIVE-SHORT-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-STRING-OUTPUT-STREAM" , "ACL2" , "COMMON-LISP"),
    ("MOST-POSITIVE-SINGLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("MAKE-SYMBOL" , "ACL2" , "COMMON-LISP"),
    ("MUFFLE-WARNING" , "ACL2" , "COMMON-LISP"),
    ("MAKE-SYNONYM-STREAM" , "ACL2" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-BIND" , "ACL2" , "COMMON-LISP"),
    ("MAKE-TWO-WAY-STREAM" , "ACL2" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-CALL" , "ACL2" , "COMMON-LISP"),
    ("MAKUNBOUND" , "ACL2" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-LIST" , "ACL2" , "COMMON-LISP"),
    ("MAP" , "ACL2" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-PROG1" , "ACL2" , "COMMON-LISP"),
    ("MAP-INTO" , "ACL2" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-SETQ" , "ACL2" , "COMMON-LISP"),
    ("MAPC" , "ACL2" , "COMMON-LISP"),
    ("MULTIPLE-VALUES-LIMIT" , "ACL2" , "COMMON-LISP"),
    ("MAPCAN" , "ACL2" , "COMMON-LISP"),
    ("NAME-CHAR" , "ACL2" , "COMMON-LISP"),
    ("MAPCAR" , "ACL2" , "COMMON-LISP"),
    ("NAMESTRING" , "ACL2" , "COMMON-LISP"),
    ("MAPCON" , "ACL2" , "COMMON-LISP"),
    ("NBUTLAST" , "ACL2" , "COMMON-LISP"),
    ("MAPHASH" , "ACL2" , "COMMON-LISP"),
    ("NCONC" , "ACL2" , "COMMON-LISP"),
    ("MAPL" , "ACL2" , "COMMON-LISP"),
    ("NEXT-METHOD-P" , "ACL2" , "COMMON-LISP"),
    ("MAPLIST" , "ACL2" , "COMMON-LISP"),
    ("NIL" , "ACL2" , "COMMON-LISP"),
    ("NINTERSECTION" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE-ERROR" , "ACL2" , "COMMON-LISP"),
    ("NINTH" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE-ERROR-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("NO-APPLICABLE-METHOD" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE-NAME" , "ACL2" , "COMMON-LISP"),
    ("NO-NEXT-METHOD" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE-NICKNAMES" , "ACL2" , "COMMON-LISP"),
    ("NOT" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE-SHADOWING-SYMBOLS" , "ACL2" , "COMMON-LISP"),
    ("NOTANY" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE-USE-LIST" , "ACL2" , "COMMON-LISP"),
    ("NOTEVERY" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE-USED-BY-LIST" , "ACL2" , "COMMON-LISP"),
    ("NOTINLINE" , "ACL2" , "COMMON-LISP"),
    ("PACKAGEP" , "ACL2" , "COMMON-LISP"),
    ("NRECONC" , "ACL2" , "COMMON-LISP"),
    ("PAIRLIS" , "ACL2" , "COMMON-LISP"),
    ("NREVERSE" , "ACL2" , "COMMON-LISP"),
    ("PARSE-ERROR" , "ACL2" , "COMMON-LISP"),
    ("NSET-DIFFERENCE" , "ACL2" , "COMMON-LISP"),
    ("PARSE-INTEGER" , "ACL2" , "COMMON-LISP"),
    ("NSET-EXCLUSIVE-OR" , "ACL2" , "COMMON-LISP"),
    ("PARSE-NAMESTRING" , "ACL2" , "COMMON-LISP"),
    ("NSTRING-CAPITALIZE" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("NSTRING-DOWNCASE" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME-DEVICE" , "ACL2" , "COMMON-LISP"),
    ("NSTRING-UPCASE" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME-DIRECTORY" , "ACL2" , "COMMON-LISP"),
    ("NSUBLIS" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME-HOST" , "ACL2" , "COMMON-LISP"),
    ("NSUBST" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME-MATCH-P" , "ACL2" , "COMMON-LISP"),
    ("NSUBST-IF" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME-NAME" , "ACL2" , "COMMON-LISP"),
    ("NSUBST-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME-TYPE" , "ACL2" , "COMMON-LISP"),
    ("NSUBSTITUTE" , "ACL2" , "COMMON-LISP"),
    ("PATHNAME-VERSION" , "ACL2" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF" , "ACL2" , "COMMON-LISP"),
    ("PATHNAMEP" , "ACL2" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("PEEK-CHAR" , "ACL2" , "COMMON-LISP"),
    ("NTH" , "ACL2" , "COMMON-LISP"),
    ("PHASE" , "ACL2" , "COMMON-LISP"),
    ("NTH-VALUE" , "ACL2" , "COMMON-LISP"),
    ("PI" , "ACL2" , "COMMON-LISP"),
    ("NTHCDR" , "ACL2" , "COMMON-LISP"),
    ("PLUSP" , "ACL2" , "COMMON-LISP"),
    ("NULL" , "ACL2" , "COMMON-LISP"),
    ("POP" , "ACL2" , "COMMON-LISP"),
    ("NUMBER" , "ACL2" , "COMMON-LISP"),
    ("POSITION" , "ACL2" , "COMMON-LISP"),
    ("NUMBERP" , "ACL2" , "COMMON-LISP"),
    ("POSITION-IF" , "ACL2" , "COMMON-LISP"),
    ("NUMERATOR" , "ACL2" , "COMMON-LISP"),
    ("POSITION-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("NUNION" , "ACL2" , "COMMON-LISP"),
    ("PPRINT" , "ACL2" , "COMMON-LISP"),
    ("ODDP" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-DISPATCH" , "ACL2" , "COMMON-LISP"),
    ("OPEN" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-EXIT-IF-LIST-EXHAUSTED" , "ACL2" , "COMMON-LISP"),
    ("OPEN-STREAM-P" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-FILL" , "ACL2" , "COMMON-LISP"),
    ("OPTIMIZE" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-INDENT" , "ACL2" , "COMMON-LISP"),
    ("OR" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-LINEAR" , "ACL2" , "COMMON-LISP"),
    ("OTHERWISE" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-LOGICAL-BLOCK" , "ACL2" , "COMMON-LISP"),
    ("OUTPUT-STREAM-P" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-NEWLINE" , "ACL2" , "COMMON-LISP"),
    ("PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-POP" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-TAB" , "ACL2" , "COMMON-LISP"),
    ("READ-CHAR" , "ACL2" , "COMMON-LISP"),
    ("PPRINT-TABULAR" , "ACL2" , "COMMON-LISP"),
    ("READ-CHAR-NO-HANG" , "ACL2" , "COMMON-LISP"),
    ("PRIN1" , "ACL2" , "COMMON-LISP"),
    ("READ-DELIMITED-LIST" , "ACL2" , "COMMON-LISP"),
    ("PRIN1-TO-STRING" , "ACL2" , "COMMON-LISP"),
    ("READ-FROM-STRING" , "ACL2" , "COMMON-LISP"),
    ("PRINC" , "ACL2" , "COMMON-LISP"),
    ("READ-LINE" , "ACL2" , "COMMON-LISP"),
    ("PRINC-TO-STRING" , "ACL2" , "COMMON-LISP"),
    ("READ-PRESERVING-WHITESPACE" , "ACL2" , "COMMON-LISP"),
    ("PRINT" , "ACL2" , "COMMON-LISP"),
    ("READ-SEQUENCE" , "ACL2" , "COMMON-LISP"),
    ("PRINT-NOT-READABLE" , "ACL2" , "COMMON-LISP"),
    ("READER-ERROR" , "ACL2" , "COMMON-LISP"),
    ("PRINT-NOT-READABLE-OBJECT" , "ACL2" , "COMMON-LISP"),
    ("READTABLE" , "ACL2" , "COMMON-LISP"),
    ("PRINT-OBJECT" , "ACL2" , "COMMON-LISP"),
    ("READTABLE-CASE" , "ACL2" , "COMMON-LISP"),
    ("PRINT-UNREADABLE-OBJECT" , "ACL2" , "COMMON-LISP"),
    ("READTABLEP" , "ACL2" , "COMMON-LISP"),
    ("PROBE-FILE" , "ACL2" , "COMMON-LISP"),
    ("REAL" , "ACL2" , "COMMON-LISP"),
    ("PROCLAIM" , "ACL2" , "COMMON-LISP"),
    ("REALP" , "ACL2" , "COMMON-LISP"),
    ("PROG" , "ACL2" , "COMMON-LISP"),
    ("REALPART" , "ACL2" , "COMMON-LISP"),
    ("PROG*" , "ACL2" , "COMMON-LISP"),
    ("REDUCE" , "ACL2" , "COMMON-LISP"),
    ("PROG1" , "ACL2" , "COMMON-LISP"),
    ("REINITIALIZE-INSTANCE" , "ACL2" , "COMMON-LISP"),
    ("PROG2" , "ACL2" , "COMMON-LISP"),
    ("REM" , "ACL2" , "COMMON-LISP"),
    ("PROGN" , "ACL2" , "COMMON-LISP"),
    ("REMF" , "ACL2" , "COMMON-LISP"),
    ("PROGRAM-ERROR" , "ACL2" , "COMMON-LISP"),
    ("REMHASH" , "ACL2" , "COMMON-LISP"),
    ("PROGV" , "ACL2" , "COMMON-LISP"),
    ("REMOVE" , "ACL2" , "COMMON-LISP"),
    ("PROVIDE" , "ACL2" , "COMMON-LISP"),
    ("REMOVE-DUPLICATES" , "ACL2" , "COMMON-LISP"),
    ("PSETF" , "ACL2" , "COMMON-LISP"),
    ("REMOVE-IF" , "ACL2" , "COMMON-LISP"),
    ("PSETQ" , "ACL2" , "COMMON-LISP"),
    ("REMOVE-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("PUSH" , "ACL2" , "COMMON-LISP"),
    ("REMOVE-METHOD" , "ACL2" , "COMMON-LISP"),
    ("PUSHNEW" , "ACL2" , "COMMON-LISP"),
    ("REMPROP" , "ACL2" , "COMMON-LISP"),
    ("QUOTE" , "ACL2" , "COMMON-LISP"),
    ("RENAME-FILE" , "ACL2" , "COMMON-LISP"),
    ("RANDOM" , "ACL2" , "COMMON-LISP"),
    ("RENAME-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("RANDOM-STATE" , "ACL2" , "COMMON-LISP"),
    ("REPLACE" , "ACL2" , "COMMON-LISP"),
    ("RANDOM-STATE-P" , "ACL2" , "COMMON-LISP"),
    ("REQUIRE" , "ACL2" , "COMMON-LISP"),
    ("RASSOC" , "ACL2" , "COMMON-LISP"),
    ("REST" , "ACL2" , "COMMON-LISP"),
    ("RASSOC-IF" , "ACL2" , "COMMON-LISP"),
    ("RESTART" , "ACL2" , "COMMON-LISP"),
    ("RASSOC-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("RESTART-BIND" , "ACL2" , "COMMON-LISP"),
    ("RATIO" , "ACL2" , "COMMON-LISP"),
    ("RESTART-CASE" , "ACL2" , "COMMON-LISP"),
    ("RATIONAL" , "ACL2" , "COMMON-LISP"),
    ("RESTART-NAME" , "ACL2" , "COMMON-LISP"),
    ("RATIONALIZE" , "ACL2" , "COMMON-LISP"),
    ("RETURN" , "ACL2" , "COMMON-LISP"),
    ("RATIONALP" , "ACL2" , "COMMON-LISP"),
    ("RETURN-FROM" , "ACL2" , "COMMON-LISP"),
    ("READ" , "ACL2" , "COMMON-LISP"),
    ("REVAPPEND" , "ACL2" , "COMMON-LISP"),
    ("READ-BYTE" , "ACL2" , "COMMON-LISP"),
    ("REVERSE" , "ACL2" , "COMMON-LISP"),
    ("ROOM" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR" , "ACL2" , "COMMON-LISP"),
    ("ROTATEF" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR-P" , "ACL2" , "COMMON-LISP"),
    ("ROUND" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-CONDITION" , "ACL2" , "COMMON-LISP"),
    ("ROW-MAJOR-AREF" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-ARGUMENTS" , "ACL2" , "COMMON-LISP"),
    ("RPLACA" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-CONTROL" , "ACL2" , "COMMON-LISP"),
    ("RPLACD" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-ERROR" , "ACL2" , "COMMON-LISP"),
    ("SAFETY" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-STRING" , "ACL2" , "COMMON-LISP"),
    ("SATISFIES" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-STRING-P" , "ACL2" , "COMMON-LISP"),
    ("SBIT" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-TYPE-ERROR" , "ACL2" , "COMMON-LISP"),
    ("SCALE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-VECTOR" , "ACL2" , "COMMON-LISP"),
    ("SCHAR" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-VECTOR-P" , "ACL2" , "COMMON-LISP"),
    ("SEARCH" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-WARNING" , "ACL2" , "COMMON-LISP"),
    ("SECOND" , "ACL2" , "COMMON-LISP"),
    ("SIN" , "ACL2" , "COMMON-LISP"),
    ("SEQUENCE" , "ACL2" , "COMMON-LISP"),
    ("SINGLE-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("SERIOUS-CONDITION" , "ACL2" , "COMMON-LISP"),
    ("SINGLE-FLOAT-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("SET" , "ACL2" , "COMMON-LISP"),
    ("SINGLE-FLOAT-NEGATIVE-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("SET-DIFFERENCE" , "ACL2" , "COMMON-LISP"),
    ("SINH" , "ACL2" , "COMMON-LISP"),
    ("SET-DISPATCH-MACRO-CHARACTER" , "ACL2" , "COMMON-LISP"),
    ("SIXTH" , "ACL2" , "COMMON-LISP"),
    ("SET-EXCLUSIVE-OR" , "ACL2" , "COMMON-LISP"),
    ("SLEEP" , "ACL2" , "COMMON-LISP"),
    ("SET-MACRO-CHARACTER" , "ACL2" , "COMMON-LISP"),
    ("SLOT-BOUNDP" , "ACL2" , "COMMON-LISP"),
    ("SET-PPRINT-DISPATCH" , "ACL2" , "COMMON-LISP"),
    ("SLOT-EXISTS-P" , "ACL2" , "COMMON-LISP"),
    ("SET-SYNTAX-FROM-CHAR" , "ACL2" , "COMMON-LISP"),
    ("SLOT-MAKUNBOUND" , "ACL2" , "COMMON-LISP"),
    ("SETF" , "ACL2" , "COMMON-LISP"),
    ("SLOT-MISSING" , "ACL2" , "COMMON-LISP"),
    ("SETQ" , "ACL2" , "COMMON-LISP"),
    ("SLOT-UNBOUND" , "ACL2" , "COMMON-LISP"),
    ("SEVENTH" , "ACL2" , "COMMON-LISP"),
    ("SLOT-VALUE" , "ACL2" , "COMMON-LISP"),
    ("SHADOW" , "ACL2" , "COMMON-LISP"),
    ("SOFTWARE-TYPE" , "ACL2" , "COMMON-LISP"),
    ("SHADOWING-IMPORT" , "ACL2" , "COMMON-LISP"),
    ("SOFTWARE-VERSION" , "ACL2" , "COMMON-LISP"),
    ("SHARED-INITIALIZE" , "ACL2" , "COMMON-LISP"),
    ("SOME" , "ACL2" , "COMMON-LISP"),
    ("SHIFTF" , "ACL2" , "COMMON-LISP"),
    ("SORT" , "ACL2" , "COMMON-LISP"),
    ("SHORT-FLOAT" , "ACL2" , "COMMON-LISP"),
    ("SPACE" , "ACL2" , "COMMON-LISP"),
    ("SHORT-FLOAT-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("SPECIAL" , "ACL2" , "COMMON-LISP"),
    ("SHORT-FLOAT-NEGATIVE-EPSILON" , "ACL2" , "COMMON-LISP"),
    ("SPECIAL-OPERATOR-P" , "ACL2" , "COMMON-LISP"),
    ("SHORT-SITE-NAME" , "ACL2" , "COMMON-LISP"),
    ("SPEED" , "ACL2" , "COMMON-LISP"),
    ("SIGNAL" , "ACL2" , "COMMON-LISP"),
    ("SQRT" , "ACL2" , "COMMON-LISP"),
    ("SIGNED-BYTE" , "ACL2" , "COMMON-LISP"),
    ("STABLE-SORT" , "ACL2" , "COMMON-LISP"),
    ("SIGNUM" , "ACL2" , "COMMON-LISP"),
    ("STANDARD" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-ARRAY" , "ACL2" , "COMMON-LISP"),
    ("STANDARD-CHAR" , "ACL2" , "COMMON-LISP"),
    ("SIMPLE-BASE-STRING" , "ACL2" , "COMMON-LISP"),
    ("STANDARD-CHAR-P" , "ACL2" , "COMMON-LISP"),
    ("STANDARD-CLASS" , "ACL2" , "COMMON-LISP"),
    ("SUBLIS" , "ACL2" , "COMMON-LISP"),
    ("STANDARD-GENERIC-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("SUBSEQ" , "ACL2" , "COMMON-LISP"),
    ("STANDARD-METHOD" , "ACL2" , "COMMON-LISP"),
    ("SUBSETP" , "ACL2" , "COMMON-LISP"),
    ("STANDARD-OBJECT" , "ACL2" , "COMMON-LISP"),
    ("SUBST" , "ACL2" , "COMMON-LISP"),
    ("STEP" , "ACL2" , "COMMON-LISP"),
    ("SUBST-IF" , "ACL2" , "COMMON-LISP"),
    ("STORAGE-CONDITION" , "ACL2" , "COMMON-LISP"),
    ("SUBST-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("STORE-VALUE" , "ACL2" , "COMMON-LISP"),
    ("SUBSTITUTE" , "ACL2" , "COMMON-LISP"),
    ("STREAM" , "ACL2" , "COMMON-LISP"),
    ("SUBSTITUTE-IF" , "ACL2" , "COMMON-LISP"),
    ("STREAM-ELEMENT-TYPE" , "ACL2" , "COMMON-LISP"),
    ("SUBSTITUTE-IF-NOT" , "ACL2" , "COMMON-LISP"),
    ("STREAM-ERROR" , "ACL2" , "COMMON-LISP"),
    ("SUBTYPEP" , "ACL2" , "COMMON-LISP"),
    ("STREAM-ERROR-STREAM" , "ACL2" , "COMMON-LISP"),
    ("SVREF" , "ACL2" , "COMMON-LISP"),
    ("STREAM-EXTERNAL-FORMAT" , "ACL2" , "COMMON-LISP"),
    ("SXHASH" , "ACL2" , "COMMON-LISP"),
    ("STREAMP" , "ACL2" , "COMMON-LISP"),
    ("SYMBOL" , "ACL2" , "COMMON-LISP"),
    ("STRING" , "ACL2" , "COMMON-LISP"),
    ("SYMBOL-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("STRING-CAPITALIZE" , "ACL2" , "COMMON-LISP"),
    ("SYMBOL-MACROLET" , "ACL2" , "COMMON-LISP"),
    ("STRING-DOWNCASE" , "ACL2" , "COMMON-LISP"),
    ("SYMBOL-NAME" , "ACL2" , "COMMON-LISP"),
    ("STRING-EQUAL" , "ACL2" , "COMMON-LISP"),
    ("SYMBOL-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("STRING-GREATERP" , "ACL2" , "COMMON-LISP"),
    ("SYMBOL-PLIST" , "ACL2" , "COMMON-LISP"),
    ("STRING-LEFT-TRIM" , "ACL2" , "COMMON-LISP"),
    ("SYMBOL-VALUE" , "ACL2" , "COMMON-LISP"),
    ("STRING-LESSP" , "ACL2" , "COMMON-LISP"),
    ("SYMBOLP" , "ACL2" , "COMMON-LISP"),
    ("STRING-NOT-EQUAL" , "ACL2" , "COMMON-LISP"),
    ("SYNONYM-STREAM" , "ACL2" , "COMMON-LISP"),
    ("STRING-NOT-GREATERP" , "ACL2" , "COMMON-LISP"),
    ("SYNONYM-STREAM-SYMBOL" , "ACL2" , "COMMON-LISP"),
    ("STRING-NOT-LESSP" , "ACL2" , "COMMON-LISP"),
    ("T" , "ACL2" , "COMMON-LISP"),
    ("STRING-RIGHT-TRIM" , "ACL2" , "COMMON-LISP"),
    ("TAGBODY" , "ACL2" , "COMMON-LISP"),
    ("STRING-STREAM" , "ACL2" , "COMMON-LISP"),
    ("TAILP" , "ACL2" , "COMMON-LISP"),
    ("STRING-TRIM" , "ACL2" , "COMMON-LISP"),
    ("TAN" , "ACL2" , "COMMON-LISP"),
    ("STRING-UPCASE" , "ACL2" , "COMMON-LISP"),
    ("TANH" , "ACL2" , "COMMON-LISP"),
    ("STRING/=" , "ACL2" , "COMMON-LISP"),
    ("TENTH" , "ACL2" , "COMMON-LISP"),
    ("STRING<" , "ACL2" , "COMMON-LISP"),
    ("TERPRI" , "ACL2" , "COMMON-LISP"),
    ("STRING<=" , "ACL2" , "COMMON-LISP"),
    ("THE" , "ACL2" , "COMMON-LISP"),
    ("STRING=" , "ACL2" , "COMMON-LISP"),
    ("THIRD" , "ACL2" , "COMMON-LISP"),
    ("STRING>" , "ACL2" , "COMMON-LISP"),
    ("THROW" , "ACL2" , "COMMON-LISP"),
    ("STRING>=" , "ACL2" , "COMMON-LISP"),
    ("TIME" , "ACL2" , "COMMON-LISP"),
    ("STRINGP" , "ACL2" , "COMMON-LISP"),
    ("TRACE" , "ACL2" , "COMMON-LISP"),
    ("STRUCTURE" , "ACL2" , "COMMON-LISP"),
    ("TRANSLATE-LOGICAL-PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("STRUCTURE-CLASS" , "ACL2" , "COMMON-LISP"),
    ("TRANSLATE-PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("STRUCTURE-OBJECT" , "ACL2" , "COMMON-LISP"),
    ("TREE-EQUAL" , "ACL2" , "COMMON-LISP"),
    ("STYLE-WARNING" , "ACL2" , "COMMON-LISP"),
    ("TRUENAME" , "ACL2" , "COMMON-LISP"),
    ("TRUNCATE" , "ACL2" , "COMMON-LISP"),
    ("VALUES-LIST" , "ACL2" , "COMMON-LISP"),
    ("TWO-WAY-STREAM" , "ACL2" , "COMMON-LISP"),
    ("VARIABLE" , "ACL2" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-INPUT-STREAM" , "ACL2" , "COMMON-LISP"),
    ("VECTOR" , "ACL2" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-OUTPUT-STREAM" , "ACL2" , "COMMON-LISP"),
    ("VECTOR-POP" , "ACL2" , "COMMON-LISP"),
    ("TYPE" , "ACL2" , "COMMON-LISP"),
    ("VECTOR-PUSH" , "ACL2" , "COMMON-LISP"),
    ("TYPE-ERROR" , "ACL2" , "COMMON-LISP"),
    ("VECTOR-PUSH-EXTEND" , "ACL2" , "COMMON-LISP"),
    ("TYPE-ERROR-DATUM" , "ACL2" , "COMMON-LISP"),
    ("VECTORP" , "ACL2" , "COMMON-LISP"),
    ("TYPE-ERROR-EXPECTED-TYPE" , "ACL2" , "COMMON-LISP"),
    ("WARN" , "ACL2" , "COMMON-LISP"),
    ("TYPE-OF" , "ACL2" , "COMMON-LISP"),
    ("WARNING" , "ACL2" , "COMMON-LISP"),
    ("TYPECASE" , "ACL2" , "COMMON-LISP"),
    ("WHEN" , "ACL2" , "COMMON-LISP"),
    ("TYPEP" , "ACL2" , "COMMON-LISP"),
    ("WILD-PATHNAME-P" , "ACL2" , "COMMON-LISP"),
    ("UNBOUND-SLOT" , "ACL2" , "COMMON-LISP"),
    ("WITH-ACCESSORS" , "ACL2" , "COMMON-LISP"),
    ("UNBOUND-SLOT-INSTANCE" , "ACL2" , "COMMON-LISP"),
    ("WITH-COMPILATION-UNIT" , "ACL2" , "COMMON-LISP"),
    ("UNBOUND-VARIABLE" , "ACL2" , "COMMON-LISP"),
    ("WITH-CONDITION-RESTARTS" , "ACL2" , "COMMON-LISP"),
    ("UNDEFINED-FUNCTION" , "ACL2" , "COMMON-LISP"),
    ("WITH-HASH-TABLE-ITERATOR" , "ACL2" , "COMMON-LISP"),
    ("UNEXPORT" , "ACL2" , "COMMON-LISP"),
    ("WITH-INPUT-FROM-STRING" , "ACL2" , "COMMON-LISP"),
    ("UNINTERN" , "ACL2" , "COMMON-LISP"),
    ("WITH-OPEN-FILE" , "ACL2" , "COMMON-LISP"),
    ("UNION" , "ACL2" , "COMMON-LISP"),
    ("WITH-OPEN-STREAM" , "ACL2" , "COMMON-LISP"),
    ("UNLESS" , "ACL2" , "COMMON-LISP"),
    ("WITH-OUTPUT-TO-STRING" , "ACL2" , "COMMON-LISP"),
    ("UNREAD-CHAR" , "ACL2" , "COMMON-LISP"),
    ("WITH-PACKAGE-ITERATOR" , "ACL2" , "COMMON-LISP"),
    ("UNSIGNED-BYTE" , "ACL2" , "COMMON-LISP"),
    ("WITH-SIMPLE-RESTART" , "ACL2" , "COMMON-LISP"),
    ("UNTRACE" , "ACL2" , "COMMON-LISP"),
    ("WITH-SLOTS" , "ACL2" , "COMMON-LISP"),
    ("UNUSE-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("WITH-STANDARD-IO-SYNTAX" , "ACL2" , "COMMON-LISP"),
    ("UNWIND-PROTECT" , "ACL2" , "COMMON-LISP"),
    ("WRITE" , "ACL2" , "COMMON-LISP"),
    ("UPDATE-INSTANCE-FOR-DIFFERENT-CLASS" , "ACL2" , "COMMON-LISP"),
    ("WRITE-BYTE" , "ACL2" , "COMMON-LISP"),
    ("UPDATE-INSTANCE-FOR-REDEFINED-CLASS" , "ACL2" , "COMMON-LISP"),
    ("WRITE-CHAR" , "ACL2" , "COMMON-LISP"),
    ("UPGRADED-ARRAY-ELEMENT-TYPE" , "ACL2" , "COMMON-LISP"),
    ("WRITE-LINE" , "ACL2" , "COMMON-LISP"),
    ("UPGRADED-COMPLEX-PART-TYPE" , "ACL2" , "COMMON-LISP"),
    ("WRITE-SEQUENCE" , "ACL2" , "COMMON-LISP"),
    ("UPPER-CASE-P" , "ACL2" , "COMMON-LISP"),
    ("WRITE-STRING" , "ACL2" , "COMMON-LISP"),
    ("USE-PACKAGE" , "ACL2" , "COMMON-LISP"),
    ("WRITE-TO-STRING" , "ACL2" , "COMMON-LISP"),
    ("USE-VALUE" , "ACL2" , "COMMON-LISP"),
    ("Y-OR-N-P" , "ACL2" , "COMMON-LISP"),
    ("USER-HOMEDIR-PATHNAME" , "ACL2" , "COMMON-LISP"),
    ("YES-OR-NO-P" , "ACL2" , "COMMON-LISP"),
    ("VALUES" , "ACL2" , "COMMON-LISP"),
    ("ZEROP" , "ACL2" , "COMMON-LISP"),
    ("&" , "ACL2-USER" , "ACL2"),
    ("&ALLOW-OTHER-KEYS" , "ACL2-USER" , "COMMON-LISP"),
    ("&AUX" , "ACL2-USER" , "COMMON-LISP"),
    ("&BODY" , "ACL2-USER" , "COMMON-LISP"),
    ("&ENVIRONMENT" , "ACL2-USER" , "COMMON-LISP"),
    ("&KEY" , "ACL2-USER" , "COMMON-LISP"),
    ("&OPTIONAL" , "ACL2-USER" , "COMMON-LISP"),
    ("&REST" , "ACL2-USER" , "COMMON-LISP"),
    ("&WHOLE" , "ACL2-USER" , "COMMON-LISP"),
    ("*" , "ACL2-USER" , "COMMON-LISP"),
    ("**" , "ACL2-USER" , "COMMON-LISP"),
    ("***" , "ACL2-USER" , "COMMON-LISP"),
    ("*ACL2-EXPORTS*" , "ACL2-USER" , "ACL2"),
    ("*BREAK-ON-SIGNALS*" , "ACL2-USER" , "COMMON-LISP"),
    ("*COMMON-LISP-SPECIALS-AND-CONSTANTS*" , "ACL2-USER" , "ACL2"),
    ("*COMMON-LISP-SYMBOLS-FROM-MAIN-LISP-PACKAGE*" , "ACL2-USER" ,
"ACL2"),
    ("*COMPILE-FILE-PATHNAME*" , "ACL2-USER" , "COMMON-LISP"),
    ("*COMPILE-FILE-TRUENAME*" , "ACL2-USER" , "COMMON-LISP"),
    ("*COMPILE-PRINT*" , "ACL2-USER" , "COMMON-LISP"),
    ("*COMPILE-VERBOSE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*DEBUG-IO*" , "ACL2-USER" , "COMMON-LISP"),
    ("*DEBUGGER-HOOK*" , "ACL2-USER" , "COMMON-LISP"),
    ("*DEFAULT-PATHNAME-DEFAULTS*" , "ACL2-USER" , "COMMON-LISP"),
    ("*ERROR-OUTPUT*" , "ACL2-USER" , "COMMON-LISP"),
    ("*FEATURES*" , "ACL2-USER" , "COMMON-LISP"),
    ("*GENSYM-COUNTER*" , "ACL2-USER" , "COMMON-LISP"),
    ("*LOAD-PATHNAME*" , "ACL2-USER" , "COMMON-LISP"),
    ("*LOAD-PRINT*" , "ACL2-USER" , "COMMON-LISP"),
    ("*LOAD-TRUENAME*" , "ACL2-USER" , "COMMON-LISP"),
    ("*LOAD-VERBOSE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*MACROEXPAND-HOOK*" , "ACL2-USER" , "COMMON-LISP"),
    ("*MAIN-LISP-PACKAGE-NAME*" , "ACL2-USER" , "ACL2"),
    ("*MODULES*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PACKAGE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-ARRAY*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-BASE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-CASE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-CIRCLE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-ESCAPE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-GENSYM*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-LENGTH*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-LEVEL*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-LINES*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-MISER-WIDTH*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-PPRINT-DISPATCH*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-PRETTY*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-RADIX*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-READABLY*" , "ACL2-USER" , "COMMON-LISP"),
    ("*PRINT-RIGHT-MARGIN*" , "ACL2-USER" , "COMMON-LISP"),
    ("*QUERY-IO*" , "ACL2-USER" , "COMMON-LISP"),
    ("*RANDOM-STATE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*READ-BASE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*READ-DEFAULT-FLOAT-FORMAT*" , "ACL2-USER" , "COMMON-LISP"),
    ("*READ-EVAL*" , "ACL2-USER" , "COMMON-LISP"),
    ("*READ-SUPPRESS*" , "ACL2-USER" , "COMMON-LISP"),
    ("*READTABLE*" , "ACL2-USER" , "COMMON-LISP"),
    ("*STANDARD-CHARS*" , "ACL2-USER" , "ACL2"),
    ("*STANDARD-CI*" , "ACL2-USER" , "ACL2"),
    ("*STANDARD-CO*" , "ACL2-USER" , "ACL2"),
    ("*STANDARD-INPUT*" , "ACL2-USER" , "COMMON-LISP"),
    ("*STANDARD-OI*" , "ACL2-USER" , "ACL2"),
    ("*STANDARD-OUTPUT*" , "ACL2-USER" , "COMMON-LISP"),
    ("*TERMINAL-IO*" , "ACL2-USER" , "COMMON-LISP"),
    ("*TRACE-OUTPUT*" , "ACL2-USER" , "COMMON-LISP"),
    ("+" , "ACL2-USER" , "COMMON-LISP"),
    ("++" , "ACL2-USER" , "COMMON-LISP"),
    ("+++" , "ACL2-USER" , "COMMON-LISP"),
    ("-" , "ACL2-USER" , "COMMON-LISP"),
    ("/" , "ACL2-USER" , "COMMON-LISP"),
    ("//" , "ACL2-USER" , "COMMON-LISP"),
    ("///" , "ACL2-USER" , "COMMON-LISP"),
    ("/=" , "ACL2-USER" , "COMMON-LISP"),
    ("1+" , "ACL2-USER" , "COMMON-LISP"),
    ("1-" , "ACL2-USER" , "COMMON-LISP"),
    ("32-BIT-INTEGER-LISTP" , "ACL2-USER" , "ACL2"),
    ("32-BIT-INTEGER-LISTP-FORWARD-TO-INTEGER-LISTP" , "ACL2-USER"
, "ACL2"),
    ("32-BIT-INTEGER-STACK" , "ACL2-USER" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH" , "ACL2-USER" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH1" , "ACL2-USER" , "ACL2"),
    ("32-BIT-INTEGERP" , "ACL2-USER" , "ACL2"),
    ("32-BIT-INTEGERP-FORWARD-TO-INTEGERP" , "ACL2-USER" , "ACL2"),
    ("<" , "ACL2-USER" , "COMMON-LISP"),
    ("<-ON-OTHERS" , "ACL2-USER" , "ACL2"),
    ("<=" , "ACL2-USER" , "COMMON-LISP"),
    ("=" , "ACL2-USER" , "COMMON-LISP"),
    (">" , "ACL2-USER" , "COMMON-LISP"),
    (">=" , "ACL2-USER" , "COMMON-LISP"),
    ("?-FN" , "ACL2-USER" , "ACL2"),
    ("@" , "ACL2-USER" , "ACL2"),
    ("ABORT" , "ACL2-USER" , "COMMON-LISP"),
    ("ABORT!" , "ACL2-USER" , "ACL2"),
    ("ABS" , "ACL2-USER" , "COMMON-LISP"),
    ("ACCUMULATED-PERSISTENCE" , "ACL2-USER" , "ACL2"),
    ("ACL2-COUNT" , "ACL2-USER" , "ACL2"),
    ("ACL2-INPUT-CHANNEL-PACKAGE" , "ACL2-USER" , "ACL2"),
    ("ACL2-NUMBERP" , "ACL2-USER" , "ACL2"),
    ("ACL2-ORACLE" , "ACL2-USER" , "ACL2"),
    ("ACL2-OUTPUT-CHANNEL-PACKAGE" , "ACL2-USER" , "ACL2"),
    ("ACL2-PACKAGE" , "ACL2-USER" , "ACL2"),
    ("ACONS" , "ACL2-USER" , "COMMON-LISP"),
    ("ACOS" , "ACL2-USER" , "COMMON-LISP"),
    ("ACOSH" , "ACL2-USER" , "COMMON-LISP"),
    ("ACTIVE-RUNEP" , "ACL2-USER" , "ACL2"),
    ("ADD-BINOP" , "ACL2-USER" , "ACL2"),
    ("ADD-DEFAULT-HINTS" , "ACL2-USER" , "ACL2"),
    ("ADD-DEFAULT-HINTS!" , "ACL2-USER" , "ACL2"),
    ("ADD-INVISIBLE-FNS" , "ACL2-USER" , "ACL2"),
    ("ADD-MACRO-ALIAS" , "ACL2-USER" , "ACL2"),
    ("ADD-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("ADD-NTH-ALIAS" , "ACL2-USER" , "ACL2"),
    ("ADD-PAIR" , "ACL2-USER" , "ACL2"),
    ("ADD-PAIR-PRESERVES-ALL-BOUNDP" , "ACL2-USER" , "ACL2"),
    ("ADD-TIMERS" , "ACL2-USER" , "ACL2"),
    ("ADD-TO-SET-EQ" , "ACL2-USER" , "ACL2"),
    ("ADD-TO-SET-EQL" , "ACL2-USER" , "ACL2"),
    ("ADD-TO-SET-EQUAL" , "ACL2-USER" , "ACL2"),
    ("ADJOIN" , "ACL2-USER" , "COMMON-LISP"),
    ("ADJUST-ARRAY" , "ACL2-USER" , "COMMON-LISP"),
    ("ADJUSTABLE-ARRAY-P" , "ACL2-USER" , "COMMON-LISP"),
    ("ALISTP" , "ACL2-USER" , "ACL2"),
    ("ALISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("ALL-BOUNDP" , "ACL2-USER" , "ACL2"),
    ("ALL-BOUNDP-PRESERVES-ASSOC" , "ACL2-USER" , "ACL2"),
    ("ALL-VARS" , "ACL2-USER" , "ACL2"),
    ("ALL-VARS1" , "ACL2-USER" , "ACL2"),
    ("ALL-VARS1-LST" , "ACL2-USER" , "ACL2"),
    ("ALLOCATE-INSTANCE" , "ACL2-USER" , "COMMON-LISP"),
    ("ALPHA-CHAR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("ALPHA-CHAR-P-FORWARD-TO-CHARACTERP" , "ACL2-USER" , "ACL2"),
    ("ALPHANUMERICP" , "ACL2-USER" , "COMMON-LISP"),
    ("AND" , "ACL2-USER" , "COMMON-LISP"),
    ("AND-MACRO" , "ACL2-USER" , "ACL2"),
    ("APPEND" , "ACL2-USER" , "COMMON-LISP"),
    ("APPLY" , "ACL2-USER" , "COMMON-LISP"),
    ("APROPOS" , "ACL2-USER" , "COMMON-LISP"),
    ("APROPOS-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("AREF" , "ACL2-USER" , "COMMON-LISP"),
    ("AREF-32-BIT-INTEGER-STACK" , "ACL2-USER" , "ACL2"),
    ("AREF-T-STACK" , "ACL2-USER" , "ACL2"),
    ("AREF1" , "ACL2-USER" , "ACL2"),
    ("AREF2" , "ACL2-USER" , "ACL2"),
    ("ARGS" , "ACL2-USER" , "ACL2"),
    ("ARITHMETIC-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERANDS" , "ACL2-USER" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERATION" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-DIMENSION" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-DIMENSION-LIMIT" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-DIMENSIONS" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-DISPLACEMENT" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-ELEMENT-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-HAS-FILL-POINTER-P" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-IN-BOUNDS-P" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-RANK" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-RANK-LIMIT" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-ROW-MAJOR-INDEX" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE-LIMIT" , "ACL2-USER" , "COMMON-LISP"),
    ("ARRAY1P" , "ACL2-USER" , "ACL2"),
    ("ARRAY1P-CONS" , "ACL2-USER" , "ACL2"),
    ("ARRAY1P-FORWARD" , "ACL2-USER" , "ACL2"),
    ("ARRAY1P-LINEAR" , "ACL2-USER" , "ACL2"),
    ("ARRAY2P" , "ACL2-USER" , "ACL2"),
    ("ARRAY2P-CONS" , "ACL2-USER" , "ACL2"),
    ("ARRAY2P-FORWARD" , "ACL2-USER" , "ACL2"),
    ("ARRAY2P-LINEAR" , "ACL2-USER" , "ACL2"),
    ("ARRAYP" , "ACL2-USER" , "COMMON-LISP"),
    ("ASET-32-BIT-INTEGER-STACK" , "ACL2-USER" , "ACL2"),
    ("ASET-T-STACK" , "ACL2-USER" , "ACL2"),
    ("ASET1" , "ACL2-USER" , "ACL2"),
    ("ASET2" , "ACL2-USER" , "ACL2"),
    ("ASH" , "ACL2-USER" , "COMMON-LISP"),
    ("ASIN" , "ACL2-USER" , "COMMON-LISP"),
    ("ASINH" , "ACL2-USER" , "COMMON-LISP"),
    ("ASSERT" , "ACL2-USER" , "COMMON-LISP"),
    ("ASSERT$" , "ACL2-USER" , "ACL2"),
    ("ASSIGN" , "ACL2-USER" , "ACL2"),
    ("ASSOC" , "ACL2-USER" , "COMMON-LISP"),
    ("ASSOC-ADD-PAIR" , "ACL2-USER" , "ACL2"),
    ("ASSOC-EQ" , "ACL2-USER" , "ACL2"),
    ("ASSOC-EQ-EQUAL" , "ACL2-USER" , "ACL2"),
    ("ASSOC-EQ-EQUAL-ALISTP" , "ACL2-USER" , "ACL2"),
    ("ASSOC-EQUAL" , "ACL2-USER" , "ACL2"),
    ("ASSOC-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("ASSOC-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("ASSOC-KEYWORD" , "ACL2-USER" , "ACL2"),
    ("ASSOC-STRING-EQUAL" , "ACL2-USER" , "ACL2"),
    ("ASSOC2" , "ACL2-USER" , "ACL2"),
    ("ASSOCIATIVITY-OF-*" , "ACL2-USER" , "ACL2"),
    ("ASSOCIATIVITY-OF-+" , "ACL2-USER" , "ACL2"),
    ("ASSUME" , "ACL2-USER" , "ACL2"),
    ("ATAN" , "ACL2-USER" , "COMMON-LISP"),
    ("ATANH" , "ACL2-USER" , "COMMON-LISP"),
    ("ATOM" , "ACL2-USER" , "COMMON-LISP"),
    ("ATOM-LISTP" , "ACL2-USER" , "ACL2"),
    ("ATOM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("BASE-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("BASE-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("BIG-CLOCK-ENTRY" , "ACL2-USER" , "ACL2"),
    ("BIG-CLOCK-NEGATIVE-P" , "ACL2-USER" , "ACL2"),
    ("BIGNUM" , "ACL2-USER" , "COMMON-LISP"),
    ("BINARY-*" , "ACL2-USER" , "ACL2"),
    ("BINARY-+" , "ACL2-USER" , "ACL2"),
    ("BINARY-APPEND" , "ACL2-USER" , "ACL2"),
    ("BIND-FREE" , "ACL2-USER" , "ACL2"),
    ("BINOP-TABLE" , "ACL2-USER" , "ACL2"),
    ("BIT" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-AND" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-ANDC1" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-ANDC2" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-EQV" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-IOR" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-NAND" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-NOR" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-ORC1" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-ORC2" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-VECTOR" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-VECTOR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("BIT-XOR" , "ACL2-USER" , "COMMON-LISP"),
    ("BLOCK" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-1" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-2" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-AND" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-ANDC1" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-ANDC2" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-C1" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-C2" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-CLR" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-EQV" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-IOR" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-NAND" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-NOR" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-ORC1" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-ORC2" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-SET" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLE-XOR" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLEAN" , "ACL2-USER" , "COMMON-LISP"),
    ("BOOLEAN-LISTP" , "ACL2-USER" , "ACL2"),
    ("BOOLEAN-LISTP-CONS" , "ACL2-USER" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD" , "ACL2-USER" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD-TO-SYMBOL-LISTP" , "ACL2-USER" , "ACL2"),
    ("BOOLEANP" , "ACL2-USER" , "ACL2"),
    ("BOOLEANP-CHARACTERP" , "ACL2-USER" , "ACL2"),
    ("BOOLEANP-COMPOUND-RECOGNIZER" , "ACL2-USER" , "ACL2"),
    ("BOTH-CASE-P" , "ACL2-USER" , "COMMON-LISP"),
    ("BOUNDED-INTEGER-ALISTP" , "ACL2-USER" , "ACL2"),
    ("BOUNDED-INTEGER-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-USER"
, "ACL2"),
    ("BOUNDED-INTEGER-ALISTP2" , "ACL2-USER" , "ACL2"),
    ("BOUNDP" , "ACL2-USER" , "COMMON-LISP"),
    ("BOUNDP-GLOBAL" , "ACL2-USER" , "ACL2"),
    ("BOUNDP-GLOBAL1" , "ACL2-USER" , "ACL2"),
    ("BREAK" , "ACL2-USER" , "COMMON-LISP"),
    ("BROADCAST-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("BROADCAST-STREAM-STREAMS" , "ACL2-USER" , "COMMON-LISP"),
    ("BRR" , "ACL2-USER" , "ACL2"),
    ("BRR@" , "ACL2-USER" , "ACL2"),
    ("BUILD-STATE1" , "ACL2-USER" , "ACL2"),
    ("BUILT-IN-CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("BUTLAST" , "ACL2-USER" , "COMMON-LISP"),
    ("BYTE" , "ACL2-USER" , "COMMON-LISP"),
    ("BYTE-POSITION" , "ACL2-USER" , "COMMON-LISP"),
    ("BYTE-SIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("CAAAAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CAAADR" , "ACL2-USER" , "COMMON-LISP"),
    ("CAAAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CAADAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CAADDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CAADR" , "ACL2-USER" , "COMMON-LISP"),
    ("CAAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CADAAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CADADR" , "ACL2-USER" , "COMMON-LISP"),
    ("CADAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CADDAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CADDDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CADDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CADR" , "ACL2-USER" , "COMMON-LISP"),
    ("CALL-ARGUMENTS-LIMIT" , "ACL2-USER" , "COMMON-LISP"),
    ("CALL-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("CALL-NEXT-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("CAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CAR-CDR-ELIM" , "ACL2-USER" , "ACL2"),
    ("CAR-CONS" , "ACL2-USER" , "ACL2"),
    ("CASE" , "ACL2-USER" , "COMMON-LISP"),
    ("CASE-LIST" , "ACL2-USER" , "ACL2"),
    ("CASE-LIST-CHECK" , "ACL2-USER" , "ACL2"),
    ("CASE-MATCH" , "ACL2-USER" , "ACL2"),
    ("CASE-SPLIT" , "ACL2-USER" , "ACL2"),
    ("CASE-TEST" , "ACL2-USER" , "ACL2"),
    ("CATCH" , "ACL2-USER" , "COMMON-LISP"),
    ("CBD" , "ACL2-USER" , "ACL2"),
    ("CCASE" , "ACL2-USER" , "COMMON-LISP"),
    ("CDAAAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDAADR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDAAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDADAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDADDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDADR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDDAAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDDADR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDDAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDDDAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDDDDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDDDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDR" , "ACL2-USER" , "COMMON-LISP"),
    ("CDR-CONS" , "ACL2-USER" , "ACL2"),
    ("CDRN" , "ACL2-USER" , "ACL2"),
    ("CEILING" , "ACL2-USER" , "COMMON-LISP"),
    ("CELL-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("CELL-ERROR-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("CERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("CERTIFY-BOOK" , "ACL2-USER" , "ACL2"),
    ("CERTIFY-BOOK!" , "ACL2-USER" , "ACL2"),
    ("CHANGE-CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-CODE" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-CODE-CODE-CHAR-IS-IDENTITY" , "ACL2-USER" , "ACL2"),
    ("CHAR-CODE-LIMIT" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-CODE-LINEAR" , "ACL2-USER" , "ACL2"),
    ("CHAR-DOWNCASE" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-EQUAL" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-GREATERP" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-INT" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-LESSP" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-NOT-EQUAL" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-NOT-GREATERP" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-NOT-LESSP" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR-UPCASE" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR/=" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR<" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR<=" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR=" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR>" , "ACL2-USER" , "COMMON-LISP"),
    ("CHAR>=" , "ACL2-USER" , "COMMON-LISP"),
    ("CHARACTER" , "ACL2-USER" , "COMMON-LISP"),
    ("CHARACTER-LISTP" , "ACL2-USER" , "ACL2"),
    ("CHARACTER-LISTP-APPEND" , "ACL2-USER" , "ACL2"),
    ("CHARACTER-LISTP-COERCE" , "ACL2-USER" , "ACL2"),
    ("CHARACTER-LISTP-FORWARD-TO-EQLABLE-LISTP" , "ACL2-USER" , "ACL2"),
    ("CHARACTER-LISTP-REMOVE-DUPLICATES-EQL" , "ACL2-USER" , "ACL2"),
    ("CHARACTER-LISTP-REVAPPEND" , "ACL2-USER" , "ACL2"),
    ("CHARACTER-LISTP-STRING-DOWNCASE-1" , "ACL2-USER" , "ACL2"),
    ("CHARACTER-LISTP-STRING-UPCASE1-1" , "ACL2-USER" , "ACL2"),
    ("CHARACTERP" , "ACL2-USER" , "COMMON-LISP"),
    ("CHARACTERP-CHAR-DOWNCASE" , "ACL2-USER" , "ACL2"),
    ("CHARACTERP-CHAR-UPCASE" , "ACL2-USER" , "ACL2"),
    ("CHARACTERP-NTH" , "ACL2-USER" , "ACL2"),
    ("CHARACTERP-PAGE" , "ACL2-USER" , "ACL2"),
    ("CHARACTERP-RUBOUT" , "ACL2-USER" , "ACL2"),
    ("CHARACTERP-TAB" , "ACL2-USER" , "ACL2"),
    ("CHECK-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("CHECK-VARS-NOT-FREE" , "ACL2-USER" , "ACL2"),
    ("CHECKPOINT-FORCED-GOALS" , "ACL2-USER" , "ACL2"),
    ("CIS" , "ACL2-USER" , "COMMON-LISP"),
    ("CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("CLASS-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("CLASS-OF" , "ACL2-USER" , "COMMON-LISP"),
    ("CLAUSE" , "ACL2-USER" , "ACL2"),
    ("CLEAR-HASH-TABLES" , "ACL2-USER" , "ACL2"),
    ("CLEAR-INPUT" , "ACL2-USER" , "COMMON-LISP"),
    ("CLEAR-MEMOIZE-TABLE" , "ACL2-USER" , "ACL2"),
    ("CLEAR-MEMOIZE-TABLES" , "ACL2-USER" , "ACL2"),
    ("CLEAR-OUTPUT" , "ACL2-USER" , "COMMON-LISP"),
    ("CLOSE" , "ACL2-USER" , "COMMON-LISP"),
    ("CLOSE-INPUT-CHANNEL" , "ACL2-USER" , "ACL2"),
    ("CLOSE-OUTPUT-CHANNEL" , "ACL2-USER" , "ACL2"),
    ("CLOSE-TRACE-FILE" , "ACL2-USER" , "ACL2"),
    ("CLOSURE" , "ACL2-USER" , "ACL2"),
    ("CLRHASH" , "ACL2-USER" , "COMMON-LISP"),
    ("CODE-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("CODE-CHAR-CHAR-CODE-IS-IDENTITY" , "ACL2-USER" , "ACL2"),
    ("CODE-CHAR-TYPE" , "ACL2-USER" , "ACL2"),
    ("COERCE" , "ACL2-USER" , "COMMON-LISP"),
    ("COERCE-INVERSE-1" , "ACL2-USER" , "ACL2"),
    ("COERCE-INVERSE-2" , "ACL2-USER" , "ACL2"),
    ("COERCE-OBJECT-TO-STATE" , "ACL2-USER" , "ACL2"),
    ("COERCE-STATE-TO-OBJECT" , "ACL2-USER" , "ACL2"),
    ("COMMUTATIVITY-OF-*" , "ACL2-USER" , "ACL2"),
    ("COMMUTATIVITY-OF-+" , "ACL2-USER" , "ACL2"),
    ("COMP" , "ACL2-USER" , "ACL2"),
    ("COMPILATION-SPEED" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPILE" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPILE-FILE" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPILE-FILE-PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPILED-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPILED-FUNCTION-P" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPILER-MACRO" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPILER-MACRO-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPLEMENT" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPLETION-OF-*" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-+" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-<" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-CAR" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-CDR" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-CHAR-CODE" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-CODE-CHAR" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-COERCE" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-COMPLEX" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-DENOMINATOR" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-IMAGPART" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-NUMERATOR" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-REALPART" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-NAME" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-PACKAGE-NAME" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-UNARY-/" , "ACL2-USER" , "ACL2"),
    ("COMPLETION-OF-UNARY-MINUS" , "ACL2-USER" , "ACL2"),
    ("COMPLEX" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPLEX-0" , "ACL2-USER" , "ACL2"),
    ("COMPLEX-DEFINITION" , "ACL2-USER" , "ACL2"),
    ("COMPLEX-EQUAL" , "ACL2-USER" , "ACL2"),
    ("COMPLEX-IMPLIES1" , "ACL2-USER" , "ACL2"),
    ("COMPLEX-RATIONALP" , "ACL2-USER" , "ACL2"),
    ("COMPLEXP" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPRESS1" , "ACL2-USER" , "ACL2"),
    ("COMPRESS11" , "ACL2-USER" , "ACL2"),
    ("COMPRESS2" , "ACL2-USER" , "ACL2"),
    ("COMPRESS21" , "ACL2-USER" , "ACL2"),
    ("COMPRESS211" , "ACL2-USER" , "ACL2"),
    ("COMPUTE-APPLICABLE-METHODS" , "ACL2-USER" , "COMMON-LISP"),
    ("COMPUTE-RESTARTS" , "ACL2-USER" , "COMMON-LISP"),
    ("CONCATENATE" , "ACL2-USER" , "COMMON-LISP"),
    ("CONCATENATED-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("CONCATENATED-STREAM-STREAMS" , "ACL2-USER" , "COMMON-LISP"),
    ("COND" , "ACL2-USER" , "COMMON-LISP"),
    ("COND-CLAUSESP" , "ACL2-USER" , "ACL2"),
    ("COND-MACRO" , "ACL2-USER" , "ACL2"),
    ("CONDITION" , "ACL2-USER" , "COMMON-LISP"),
    ("CONJUGATE" , "ACL2-USER" , "COMMON-LISP"),
    ("CONS" , "ACL2-USER" , "COMMON-LISP"),
    ("CONS-EQUAL" , "ACL2-USER" , "ACL2"),
    ("CONS-SUBTREES" , "ACL2-USER" , "ACL2"),
    ("CONSP" , "ACL2-USER" , "COMMON-LISP"),
    ("CONSP-ASSOC" , "ACL2-USER" , "ACL2"),
    ("CONSP-ASSOC-EQ" , "ACL2-USER" , "ACL2"),
    ("CONSTANTLY" , "ACL2-USER" , "COMMON-LISP"),
    ("CONSTANTP" , "ACL2-USER" , "COMMON-LISP"),
    ("CONTINUE" , "ACL2-USER" , "COMMON-LISP"),
    ("CONTROL-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-ALIST" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-PPRINT-DISPATCH" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-READTABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-SEQ" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-STRUCTURE" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-SYMBOL" , "ACL2-USER" , "COMMON-LISP"),
    ("COPY-TREE" , "ACL2-USER" , "COMMON-LISP"),
    ("COS" , "ACL2-USER" , "COMMON-LISP"),
    ("COSH" , "ACL2-USER" , "COMMON-LISP"),
    ("COUNT" , "ACL2-USER" , "COMMON-LISP"),
    ("COUNT-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("COUNT-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("CTYPECASE" , "ACL2-USER" , "COMMON-LISP"),
    ("CURRENT-PACKAGE" , "ACL2-USER" , "ACL2"),
    ("CURRENT-THEORY" , "ACL2-USER" , "ACL2"),
    ("CW" , "ACL2-USER" , "ACL2"),
    ("CW-GSTACK" , "ACL2-USER" , "ACL2"),
    ("DEBUG" , "ACL2-USER" , "COMMON-LISP"),
    ("DECF" , "ACL2-USER" , "COMMON-LISP"),
    ("DECLAIM" , "ACL2-USER" , "COMMON-LISP"),
    ("DECLARATION" , "ACL2-USER" , "COMMON-LISP"),
    ("DECLARE" , "ACL2-USER" , "COMMON-LISP"),
    ("DECODE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("DECODE-UNIVERSAL-TIME" , "ACL2-USER" , "COMMON-LISP"),
    ("DECREMENT-BIG-CLOCK" , "ACL2-USER" , "ACL2"),
    ("DEFABBREV" , "ACL2-USER" , "ACL2"),
    ("DEFAULT" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-*-1" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-*-2" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-+-1" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-+-2" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-<-1" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-<-2" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-CAR" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-CDR" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-CHAR-CODE" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-COERCE-1" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-COERCE-2" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-COERCE-3" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-COMPILE-FNS" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-COMPLEX-1" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-COMPLEX-2" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-DEFUN-MODE" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-DEFUN-MODE-FROM-STATE" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-DENOMINATOR" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-IMAGPART" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-MEASURE-FUNCTION" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-NUMERATOR" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-REALPART" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-SYMBOL-NAME" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-SYMBOL-PACKAGE-NAME" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-UNARY-/" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-UNARY-MINUS" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-VERIFY-GUARDS-EAGERNESS" , "ACL2-USER" , "ACL2"),
    ("DEFAULT-WELL-FOUNDED-RELATION" , "ACL2-USER" , "ACL2"),
    ("DEFAXIOM" , "ACL2-USER" , "ACL2"),
    ("DEFCHOOSE" , "ACL2-USER" , "ACL2"),
    ("DEFCLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFCONG" , "ACL2-USER" , "ACL2"),
    ("DEFCONST" , "ACL2-USER" , "ACL2"),
    ("DEFCONSTANT" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFDOC" , "ACL2-USER" , "ACL2"),
    ("DEFEQUIV" , "ACL2-USER" , "ACL2"),
    ("DEFEVALUATOR" , "ACL2-USER" , "ACL2"),
    ("DEFEXEC" , "ACL2-USER" , "ACL2"),
    ("DEFGENERIC" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFINE-COMPILER-MACRO" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFINE-CONDITION" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFINE-METHOD-COMBINATION" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFINE-MODIFY-MACRO" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFINE-PC-ATOMIC-MACRO" , "ACL2-USER" , "ACL2"),
    ("DEFINE-PC-HELP" , "ACL2-USER" , "ACL2"),
    ("DEFINE-PC-MACRO" , "ACL2-USER" , "ACL2"),
    ("DEFINE-SETF-EXPANDER" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFINE-SYMBOL-MACRO" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFLABEL" , "ACL2-USER" , "ACL2"),
    ("DEFMACRO" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFMETHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFPACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFPARAMETER" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFPKG" , "ACL2-USER" , "ACL2"),
    ("DEFREFINEMENT" , "ACL2-USER" , "ACL2"),
    ("DEFSETF" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFSTOBJ" , "ACL2-USER" , "ACL2"),
    ("DEFSTRUCT" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFSTUB" , "ACL2-USER" , "ACL2"),
    ("DEFTHEORY" , "ACL2-USER" , "ACL2"),
    ("DEFTHM" , "ACL2-USER" , "ACL2"),
    ("DEFTHMD" , "ACL2-USER" , "ACL2"),
    ("DEFTTAG" , "ACL2-USER" , "ACL2"),
    ("DEFTYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFUN" , "ACL2-USER" , "COMMON-LISP"),
    ("DEFUN-NX" , "ACL2-USER" , "ACL2"),
    ("DEFUN-SK" , "ACL2-USER" , "ACL2"),
    ("DEFUND" , "ACL2-USER" , "ACL2"),
    ("DEFUND-NX" , "ACL2-USER" , "ACL2"),
    ("DEFUNS" , "ACL2-USER" , "ACL2"),
    ("DEFVAR" , "ACL2-USER" , "COMMON-LISP"),
    ("DELETE" , "ACL2-USER" , "COMMON-LISP"),
    ("DELETE-DUPLICATES" , "ACL2-USER" , "COMMON-LISP"),
    ("DELETE-FILE" , "ACL2-USER" , "COMMON-LISP"),
    ("DELETE-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("DELETE-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("DELETE-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("DELETE-PAIR" , "ACL2-USER" , "ACL2"),
    ("DENOMINATOR" , "ACL2-USER" , "COMMON-LISP"),
    ("DEPOSIT-FIELD" , "ACL2-USER" , "COMMON-LISP"),
    ("DESCRIBE" , "ACL2-USER" , "COMMON-LISP"),
    ("DESCRIBE-OBJECT" , "ACL2-USER" , "COMMON-LISP"),
    ("DESTRUCTURING-BIND" , "ACL2-USER" , "COMMON-LISP"),
    ("DIGIT-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("DIGIT-CHAR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("DIGIT-TO-CHAR" , "ACL2-USER" , "ACL2"),
    ("DIMENSIONS" , "ACL2-USER" , "ACL2"),
    ("DIRECTORY" , "ACL2-USER" , "COMMON-LISP"),
    ("DIRECTORY-NAMESTRING" , "ACL2-USER" , "COMMON-LISP"),
    ("DISABLE" , "ACL2-USER" , "ACL2"),
    ("DISABLE-FORCING" , "ACL2-USER" , "ACL2"),
    ("DISABLEDP" , "ACL2-USER" , "ACL2"),
    ("DISASSEMBLE" , "ACL2-USER" , "COMMON-LISP"),
    ("DISTRIBUTIVITY" , "ACL2-USER" , "ACL2"),
    ("DIVISION-BY-ZERO" , "ACL2-USER" , "COMMON-LISP"),
    ("DO" , "ACL2-USER" , "COMMON-LISP"),
    ("DO*" , "ACL2-USER" , "COMMON-LISP"),
    ("DO-ALL-SYMBOLS" , "ACL2-USER" , "COMMON-LISP"),
    ("DO-EXTERNAL-SYMBOLS" , "ACL2-USER" , "COMMON-LISP"),
    ("DO-SYMBOLS" , "ACL2-USER" , "COMMON-LISP"),
    ("DOC" , "ACL2-USER" , "ACL2"),
    ("DOC!" , "ACL2-USER" , "ACL2"),
    ("DOCS" , "ACL2-USER" , "ACL2"),
    ("DOCUMENTATION" , "ACL2-USER" , "COMMON-LISP"),
    ("DOLIST" , "ACL2-USER" , "COMMON-LISP"),
    ("DOTIMES" , "ACL2-USER" , "COMMON-LISP"),
    ("DOUBLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("DOUBLE-REWRITE" , "ACL2-USER" , "ACL2"),
    ("DPB" , "ACL2-USER" , "COMMON-LISP"),
    ("DRIBBLE" , "ACL2-USER" , "COMMON-LISP"),
    ("DUPLICATES" , "ACL2-USER" , "ACL2"),
    ("DYNAMIC-EXTENT" , "ACL2-USER" , "COMMON-LISP"),
    ("E/D" , "ACL2-USER" , "ACL2"),
    ("E0-ORD-<" , "ACL2-USER" , "ACL2"),
    ("E0-ORDINALP" , "ACL2-USER" , "ACL2"),
    ("EC-CALL" , "ACL2-USER" , "ACL2"),
    ("ECASE" , "ACL2-USER" , "COMMON-LISP"),
    ("ECHO-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("ECHO-STREAM-INPUT-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("ECHO-STREAM-OUTPUT-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("ED" , "ACL2-USER" , "COMMON-LISP"),
    ("EIGHTH" , "ACL2-USER" , "COMMON-LISP"),
    ("ELIMINATE-DESTRUCTORS" , "ACL2-USER" , "ACL2"),
    ("ELIMINATE-IRRELEVANCE" , "ACL2-USER" , "ACL2"),
    ("ELT" , "ACL2-USER" , "COMMON-LISP"),
    ("ENABLE" , "ACL2-USER" , "ACL2"),
    ("ENABLE-FORCING" , "ACL2-USER" , "ACL2"),
    ("ENCAPSULATE" , "ACL2-USER" , "ACL2"),
    ("ENCODE-UNIVERSAL-TIME" , "ACL2-USER" , "COMMON-LISP"),
    ("END-OF-FILE" , "ACL2-USER" , "COMMON-LISP"),
    ("ENDP" , "ACL2-USER" , "COMMON-LISP"),
    ("ENOUGH-NAMESTRING" , "ACL2-USER" , "COMMON-LISP"),
    ("ENSURE-DIRECTORIES-EXIST" , "ACL2-USER" , "COMMON-LISP"),
    ("ENSURE-GENERIC-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("EQ" , "ACL2-USER" , "COMMON-LISP"),
    ("EQL" , "ACL2-USER" , "COMMON-LISP"),
    ("EQLABLE-ALISTP" , "ACL2-USER" , "ACL2"),
    ("EQLABLE-ALISTP-FORWARD-TO-ALISTP" , "ACL2-USER" , "ACL2"),
    ("EQLABLE-LISTP" , "ACL2-USER" , "ACL2"),
    ("EQLABLE-LISTP-FORWARD-TO-ATOM-LISTP" , "ACL2-USER" , "ACL2"),
    ("EQLABLEP" , "ACL2-USER" , "ACL2"),
    ("EQLABLEP-RECOG" , "ACL2-USER" , "ACL2"),
    ("EQUAL" , "ACL2-USER" , "COMMON-LISP"),
    ("EQUAL-CHAR-CODE" , "ACL2-USER" , "ACL2"),
    ("EQUALP" , "ACL2-USER" , "COMMON-LISP"),
    ("ER" , "ACL2-USER" , "ACL2"),
    ("ER-PROGN" , "ACL2-USER" , "ACL2"),
    ("ER-PROGN-FN" , "ACL2-USER" , "ACL2"),
    ("ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("ETYPECASE" , "ACL2-USER" , "COMMON-LISP"),
    ("EVAL" , "ACL2-USER" , "COMMON-LISP"),
    ("EVAL-WHEN" , "ACL2-USER" , "COMMON-LISP"),
    ("EVENP" , "ACL2-USER" , "COMMON-LISP"),
    ("EVENS" , "ACL2-USER" , "ACL2"),
    ("EVENT" , "ACL2-USER" , "ACL2"),
    ("EVERY" , "ACL2-USER" , "COMMON-LISP"),
    ("EXECUTABLE-COUNTERPART-THEORY" , "ACL2-USER" , "ACL2"),
    ("EXP" , "ACL2-USER" , "COMMON-LISP"),
    ("EXPLODE-ATOM" , "ACL2-USER" , "ACL2"),
    ("EXPLODE-NONNEGATIVE-INTEGER" , "ACL2-USER" , "ACL2"),
    ("EXPORT" , "ACL2-USER" , "COMMON-LISP"),
    ("EXPT" , "ACL2-USER" , "COMMON-LISP"),
    ("EXPT-TYPE-PRESCRIPTION-NON-ZERO-BASE" , "ACL2-USER" , "ACL2"),
    ("EXTEND-32-BIT-INTEGER-STACK" , "ACL2-USER" , "ACL2"),
    ("EXTEND-T-STACK" , "ACL2-USER" , "ACL2"),
    ("EXTEND-WORLD" , "ACL2-USER" , "ACL2"),
    ("EXTENDED-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("EXTRA-INFO" , "ACL2-USER" , "ACL2"),
    ("FAST-ALIST-FREE" , "ACL2-USER" , "ACL2"),
    ("FAST-ALIST-LEN" , "ACL2-USER" , "ACL2"),
    ("FAST-ALIST-SUMMARY" , "ACL2-USER" , "ACL2"),
    ("FBOUNDP" , "ACL2-USER" , "COMMON-LISP"),
    ("FCEILING" , "ACL2-USER" , "COMMON-LISP"),
    ("FDEFINITION" , "ACL2-USER" , "COMMON-LISP"),
    ("FERTILIZE" , "ACL2-USER" , "ACL2"),
    ("FFLOOR" , "ACL2-USER" , "COMMON-LISP"),
    ("FGETPROP" , "ACL2-USER" , "ACL2"),
    ("FIFTH" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-AUTHOR" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-CLOCK" , "ACL2-USER" , "ACL2"),
    ("FILE-CLOCK-P" , "ACL2-USER" , "ACL2"),
    ("FILE-CLOCK-P-FORWARD-TO-INTEGERP" , "ACL2-USER" , "ACL2"),
    ("FILE-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-ERROR-PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-LENGTH" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-NAMESTRING" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-POSITION" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-STRING-LENGTH" , "ACL2-USER" , "COMMON-LISP"),
    ("FILE-WRITE-DATE" , "ACL2-USER" , "COMMON-LISP"),
    ("FILL" , "ACL2-USER" , "COMMON-LISP"),
    ("FILL-POINTER" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-ALL-SYMBOLS" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-RESTART" , "ACL2-USER" , "COMMON-LISP"),
    ("FIND-SYMBOL" , "ACL2-USER" , "COMMON-LISP"),
    ("FINISH-OUTPUT" , "ACL2-USER" , "COMMON-LISP"),
    ("FIRST" , "ACL2-USER" , "COMMON-LISP"),
    ("FIRST-N-AC" , "ACL2-USER" , "ACL2"),
    ("FIX" , "ACL2-USER" , "ACL2"),
    ("FIX-TRUE-LIST" , "ACL2-USER" , "ACL2"),
    ("FIXNUM" , "ACL2-USER" , "COMMON-LISP"),
    ("FLET" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOAT-DIGITS" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOAT-PRECISION" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOAT-RADIX" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOAT-SIGN" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOATING-POINT-INEXACT" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOATING-POINT-INVALID-OPERATION" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOATING-POINT-OVERFLOW" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOATING-POINT-UNDERFLOW" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOATP" , "ACL2-USER" , "COMMON-LISP"),
    ("FLOOR" , "ACL2-USER" , "COMMON-LISP"),
    ("FLUSH-HONS-GET-HASH-TABLE-LINK" , "ACL2-USER" , "ACL2"),
    ("FMAKUNBOUND" , "ACL2-USER" , "COMMON-LISP"),
    ("FMS" , "ACL2-USER" , "ACL2"),
    ("FMT" , "ACL2-USER" , "ACL2"),
    ("FMT-TO-COMMENT-WINDOW" , "ACL2-USER" , "ACL2"),
    ("FMT1" , "ACL2-USER" , "ACL2"),
    ("FORCE" , "ACL2-USER" , "ACL2"),
    ("FORCE-OUTPUT" , "ACL2-USER" , "COMMON-LISP"),
    ("FORMAT" , "ACL2-USER" , "COMMON-LISP"),
    ("FORMATTER" , "ACL2-USER" , "COMMON-LISP"),
    ("FOURTH" , "ACL2-USER" , "COMMON-LISP"),
    ("FRESH-LINE" , "ACL2-USER" , "COMMON-LISP"),
    ("FROUND" , "ACL2-USER" , "COMMON-LISP"),
    ("FTRUNCATE" , "ACL2-USER" , "COMMON-LISP"),
    ("FTYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("FUNCALL" , "ACL2-USER" , "COMMON-LISP"),
    ("FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("FUNCTION-KEYWORDS" , "ACL2-USER" , "COMMON-LISP"),
    ("FUNCTION-LAMBDA-EXPRESSION" , "ACL2-USER" , "COMMON-LISP"),
    ("FUNCTION-SYMBOLP" , "ACL2-USER" , "ACL2"),
    ("FUNCTION-THEORY" , "ACL2-USER" , "ACL2"),
    ("FUNCTIONP" , "ACL2-USER" , "COMMON-LISP"),
    ("GCD" , "ACL2-USER" , "COMMON-LISP"),
    ("GENERALIZE" , "ACL2-USER" , "ACL2"),
    ("GENERIC-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("GENSYM" , "ACL2-USER" , "COMMON-LISP"),
    ("GENTEMP" , "ACL2-USER" , "COMMON-LISP"),
    ("GET" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-DECODED-TIME" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-DISPATCH-MACRO-CHARACTER" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-GLOBAL" , "ACL2-USER" , "ACL2"),
    ("GET-INTERNAL-REAL-TIME" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-INTERNAL-RUN-TIME" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-MACRO-CHARACTER" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-OUTPUT-STREAM-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-PROPERTIES" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-SETF-EXPANSION" , "ACL2-USER" , "COMMON-LISP"),
    ("GET-SLOW-ALIST-ACTION" , "ACL2-USER" , "ACL2"),
    ("GET-TIMER" , "ACL2-USER" , "ACL2"),
    ("GET-UNIVERSAL-TIME" , "ACL2-USER" , "COMMON-LISP"),
    ("GETF" , "ACL2-USER" , "COMMON-LISP"),
    ("GETHASH" , "ACL2-USER" , "COMMON-LISP"),
    ("GETPROP-DEFAULT" , "ACL2-USER" , "ACL2"),
    ("GETPROPS" , "ACL2-USER" , "ACL2"),
    ("GETPROPS1" , "ACL2-USER" , "ACL2"),
    ("GLOBAL-TABLE" , "ACL2-USER" , "ACL2"),
    ("GLOBAL-TABLE-CARS" , "ACL2-USER" , "ACL2"),
    ("GLOBAL-TABLE-CARS1" , "ACL2-USER" , "ACL2"),
    ("GLOBAL-VAL" , "ACL2-USER" , "ACL2"),
    ("GO" , "ACL2-USER" , "COMMON-LISP"),
    ("GOOD-BYE" , "ACL2-USER" , "ACL2"),
    ("GRANULARITY" , "ACL2-USER" , "ACL2"),
    ("GRAPHIC-CHAR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("GROUND-ZERO" , "ACL2-USER" , "ACL2"),
    ("HANDLER-BIND" , "ACL2-USER" , "COMMON-LISP"),
    ("HANDLER-CASE" , "ACL2-USER" , "COMMON-LISP"),
    ("HARD-ERROR" , "ACL2-USER" , "ACL2"),
    ("HAS-PROPSP" , "ACL2-USER" , "ACL2"),
    ("HAS-PROPSP1" , "ACL2-USER" , "ACL2"),
    ("HASH-TABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("HASH-TABLE-COUNT" , "ACL2-USER" , "COMMON-LISP"),
    ("HASH-TABLE-P" , "ACL2-USER" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-SIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-THRESHOLD" , "ACL2-USER" , "COMMON-LISP"),
    ("HASH-TABLE-SIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("HASH-TABLE-TEST" , "ACL2-USER" , "COMMON-LISP"),
    ("HEADER" , "ACL2-USER" , "ACL2"),
    ("HELP" , "ACL2-USER" , "ACL2"),
    ("HIDE" , "ACL2-USER" , "ACL2"),
    ("HONS" , "ACL2-USER" , "ACL2"),
    ("HONS-ACONS" , "ACL2-USER" , "ACL2"),
    ("HONS-ACONS!" , "ACL2-USER" , "ACL2"),
    ("HONS-CLEAR" , "ACL2-USER" , "ACL2"),
    ("HONS-COPY" , "ACL2-USER" , "ACL2"),
    ("HONS-EQUAL" , "ACL2-USER" , "ACL2"),
    ("HONS-EQUAL-LITE" , "ACL2-USER" , "ACL2"),
    ("HONS-GET" , "ACL2-USER" , "ACL2"),
    ("HONS-RESIZE" , "ACL2-USER" , "ACL2"),
    ("HONS-RESIZE-FN" , "ACL2-USER" , "ACL2"),
    ("HONS-SHRINK-ALIST" , "ACL2-USER" , "ACL2"),
    ("HONS-SHRINK-ALIST!" , "ACL2-USER" , "ACL2"),
    ("HONS-SUMMARY" , "ACL2-USER" , "ACL2"),
    ("HONS-WASH" , "ACL2-USER" , "ACL2"),
    ("HOST-NAMESTRING" , "ACL2-USER" , "COMMON-LISP"),
    ("I-AM-HERE" , "ACL2-USER" , "ACL2"),
    ("ID" , "ACL2-USER" , "ACL2"),
    ("IDATES" , "ACL2-USER" , "ACL2"),
    ("IDENTITY" , "ACL2-USER" , "COMMON-LISP"),
    ("IF" , "ACL2-USER" , "COMMON-LISP"),
    ("IF*" , "ACL2-USER" , "ACL2"),
    ("IFF" , "ACL2-USER" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-1" , "ACL2-USER" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-2" , "ACL2-USER" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-NOT" , "ACL2-USER" , "ACL2"),
    ("IFF-IS-AN-EQUIVALENCE" , "ACL2-USER" , "ACL2"),
    ("IFIX" , "ACL2-USER" , "ACL2"),
    ("IGNORABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("IGNORE" , "ACL2-USER" , "COMMON-LISP"),
    ("IGNORE-ERRORS" , "ACL2-USER" , "COMMON-LISP"),
    ("ILLEGAL" , "ACL2-USER" , "ACL2"),
    ("IMAGPART" , "ACL2-USER" , "COMMON-LISP"),
    ("IMAGPART-COMPLEX" , "ACL2-USER" , "ACL2"),
    ("IMMEDIATE-FORCE-MODEP" , "ACL2-USER" , "ACL2"),
    ("IMPLIES" , "ACL2-USER" , "ACL2"),
    ("IMPORT" , "ACL2-USER" , "COMMON-LISP"),
    ("IMPROPER-CONSP" , "ACL2-USER" , "ACL2"),
    ("IN-ARITHMETIC-THEORY" , "ACL2-USER" , "ACL2"),
    ("IN-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("IN-THEORY" , "ACL2-USER" , "ACL2"),
    ("INCF" , "ACL2-USER" , "COMMON-LISP"),
    ("INCLUDE-BOOK" , "ACL2-USER" , "ACL2"),
    ("INCOMPATIBLE" , "ACL2-USER" , "ACL2"),
    ("INCREMENT-TIMER" , "ACL2-USER" , "ACL2"),
    ("INDUCT" , "ACL2-USER" , "ACL2"),
    ("INITIALIZE-INSTANCE" , "ACL2-USER" , "COMMON-LISP"),
    ("INLINE" , "ACL2-USER" , "COMMON-LISP"),
    ("INPUT-STREAM-P" , "ACL2-USER" , "COMMON-LISP"),
    ("INSPECT" , "ACL2-USER" , "COMMON-LISP"),
    ("INT=" , "ACL2-USER" , "ACL2"),
    ("INTEGER" , "ACL2-USER" , "COMMON-LISP"),
    ("INTEGER-0" , "ACL2-USER" , "ACL2"),
    ("INTEGER-1" , "ACL2-USER" , "ACL2"),
    ("INTEGER-ABS" , "ACL2-USER" , "ACL2"),
    ("INTEGER-DECODE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("INTEGER-IMPLIES-RATIONAL" , "ACL2-USER" , "ACL2"),
    ("INTEGER-LENGTH" , "ACL2-USER" , "COMMON-LISP"),
    ("INTEGER-LISTP" , "ACL2-USER" , "ACL2"),
    ("INTEGER-LISTP-FORWARD-TO-RATIONAL-LISTP" , "ACL2-USER" , "ACL2"),
    ("INTEGER-STEP" , "ACL2-USER" , "ACL2"),
    ("INTEGERP" , "ACL2-USER" , "COMMON-LISP"),
    ("INTERACTIVE-STREAM-P" , "ACL2-USER" , "COMMON-LISP"),
    ("INTERN" , "ACL2-USER" , "COMMON-LISP"),
    ("INTERN$" , "ACL2-USER" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-USER" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL-SYMBOL-NAME" , "ACL2-USER" , "ACL2"),
    ("INTERNAL-TIME-UNITS-PER-SECOND" , "ACL2-USER" , "COMMON-LISP"),
    ("INTERSECTION" , "ACL2-USER" , "COMMON-LISP"),
    ("INTERSECTION-EQ" , "ACL2-USER" , "ACL2"),
    ("INTERSECTION-THEORIES" , "ACL2-USER" , "ACL2"),
    ("INTERSECTP-EQ" , "ACL2-USER" , "ACL2"),
    ("INTERSECTP-EQUAL" , "ACL2-USER" , "ACL2"),
    ("INVALID-METHOD-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("INVERSE-OF-*" , "ACL2-USER" , "ACL2"),
    ("INVERSE-OF-+" , "ACL2-USER" , "ACL2"),
    ("INVISIBLE-FNS-TABLE" , "ACL2-USER" , "ACL2"),
    ("INVOKE-DEBUGGER" , "ACL2-USER" , "COMMON-LISP"),
    ("INVOKE-RESTART" , "ACL2-USER" , "COMMON-LISP"),
    ("INVOKE-RESTART-INTERACTIVELY" , "ACL2-USER" , "COMMON-LISP"),
    ("ISQRT" , "ACL2-USER" , "COMMON-LISP"),
    ("KEYWORD" , "ACL2-USER" , "COMMON-LISP"),
    ("KEYWORD-PACKAGE" , "ACL2-USER" , "ACL2"),
    ("KEYWORD-VALUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-ASSOC-KEYWORD" , "ACL2-USER" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("KEYWORDP" , "ACL2-USER" , "COMMON-LISP"),
    ("KEYWORDP-FORWARD-TO-SYMBOLP" , "ACL2-USER" , "ACL2"),
    ("KNOWN-PACKAGE-ALIST" , "ACL2-USER" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP" , "ACL2-USER" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-USER" , "ACL2"),
    ("LABELS" , "ACL2-USER" , "COMMON-LISP"),
    ("LAMBDA" , "ACL2-USER" , "COMMON-LISP"),
    ("LAMBDA-LIST-KEYWORDS" , "ACL2-USER" , "COMMON-LISP"),
    ("LAMBDA-PARAMETERS-LIMIT" , "ACL2-USER" , "COMMON-LISP"),
    ("LAST" , "ACL2-USER" , "COMMON-LISP"),
    ("LCM" , "ACL2-USER" , "COMMON-LISP"),
    ("LD" , "ACL2-USER" , "ACL2"),
    ("LD-ERROR-ACTION" , "ACL2-USER" , "ACL2"),
    ("LD-ERROR-TRIPLES" , "ACL2-USER" , "ACL2"),
    ("LD-KEYWORD-ALIASES" , "ACL2-USER" , "ACL2"),
    ("LD-POST-EVAL-PRINT" , "ACL2-USER" , "ACL2"),
    ("LD-PRE-EVAL-FILTER" , "ACL2-USER" , "ACL2"),
    ("LD-PRE-EVAL-PRINT" , "ACL2-USER" , "ACL2"),
    ("LD-PROMPT" , "ACL2-USER" , "ACL2"),
    ("LD-QUERY-CONTROL-ALIST" , "ACL2-USER" , "ACL2"),
    ("LD-REDEFINITION-ACTION" , "ACL2-USER" , "ACL2"),
    ("LD-SKIP-PROOFSP" , "ACL2-USER" , "ACL2"),
    ("LD-VERBOSE" , "ACL2-USER" , "ACL2"),
    ("LDB" , "ACL2-USER" , "COMMON-LISP"),
    ("LDB-TEST" , "ACL2-USER" , "COMMON-LISP"),
    ("LDIFF" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-LONG-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-LONG-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SHORT-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SINGLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-DOUBLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-LONG-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-LONG-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SHORT-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SINGLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LEGAL-CASE-CLAUSESP" , "ACL2-USER" , "ACL2"),
    ("LEN" , "ACL2-USER" , "ACL2"),
    ("LEN-UPDATE-NTH" , "ACL2-USER" , "ACL2"),
    ("LENGTH" , "ACL2-USER" , "COMMON-LISP"),
    ("LET" , "ACL2-USER" , "COMMON-LISP"),
    ("LET*" , "ACL2-USER" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-VERSION" , "ACL2-USER" , "COMMON-LISP"),
    ("LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("LIST*" , "ACL2-USER" , "COMMON-LISP"),
    ("LIST*-MACRO" , "ACL2-USER" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES" , "ACL2-USER" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-USER" , "ACL2"),
    ("LIST-ALL-PACKAGES" , "ACL2-USER" , "COMMON-LISP"),
    ("LIST-LENGTH" , "ACL2-USER" , "COMMON-LISP"),
    ("LIST-MACRO" , "ACL2-USER" , "ACL2"),
    ("LISTEN" , "ACL2-USER" , "COMMON-LISP"),
    ("LISTP" , "ACL2-USER" , "COMMON-LISP"),
    ("LOAD" , "ACL2-USER" , "COMMON-LISP"),
    ("LOAD-LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-USER" , "COMMON-LISP"),
    ("LOAD-TIME-VALUE" , "ACL2-USER" , "COMMON-LISP"),
    ("LOCAL" , "ACL2-USER" , "ACL2"),
    ("LOCALLY" , "ACL2-USER" , "COMMON-LISP"),
    ("LOG" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGAND" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGANDC1" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGANDC2" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGBITP" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGCOUNT" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGEQV" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGIC" , "ACL2-USER" , "ACL2"),
    ("LOGICAL-PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGIOR" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGNAND" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGNOR" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGNOT" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGORC1" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGORC2" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGTEST" , "ACL2-USER" , "COMMON-LISP"),
    ("LOGXOR" , "ACL2-USER" , "COMMON-LISP"),
    ("LONG-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("LONG-FLOAT-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("LONG-FLOAT-NEGATIVE-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("LONG-SITE-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("LOOP" , "ACL2-USER" , "COMMON-LISP"),
    ("LOOP-FINISH" , "ACL2-USER" , "COMMON-LISP"),
    ("LOWER-CASE-P" , "ACL2-USER" , "COMMON-LISP"),
    ("LOWER-CASE-P-CHAR-DOWNCASE" , "ACL2-USER" , "ACL2"),
    ("LOWER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-USER" , "ACL2"),
    ("LOWEST-TERMS" , "ACL2-USER" , "ACL2"),
    ("LP" , "ACL2-USER" , "ACL2"),
    ("MACHINE-INSTANCE" , "ACL2-USER" , "COMMON-LISP"),
    ("MACHINE-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("MACHINE-VERSION" , "ACL2-USER" , "COMMON-LISP"),
    ("MACRO-ALIASES" , "ACL2-USER" , "ACL2"),
    ("MACRO-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("MACROEXPAND" , "ACL2-USER" , "COMMON-LISP"),
    ("MACROEXPAND-1" , "ACL2-USER" , "COMMON-LISP"),
    ("MACROLET" , "ACL2-USER" , "COMMON-LISP"),
    ("MAIN-TIMER" , "ACL2-USER" , "ACL2"),
    ("MAIN-TIMER-TYPE-PRESCRIPTION" , "ACL2-USER" , "ACL2"),
    ("MAKE-ARRAY" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-BROADCAST-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-CHARACTER-LIST" , "ACL2-USER" , "ACL2"),
    ("MAKE-CHARACTER-LIST-MAKE-CHARACTER-LIST" , "ACL2-USER" , "ACL2"),
    ("MAKE-CONCATENATED-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-CONDITION" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-DISPATCH-MACRO-CHARACTER" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-ECHO-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-EVENT" , "ACL2-USER" , "ACL2"),
    ("MAKE-FMT-BINDINGS" , "ACL2-USER" , "ACL2"),
    ("MAKE-HASH-TABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-INPUT-CHANNEL" , "ACL2-USER" , "ACL2"),
    ("MAKE-INSTANCE" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-INSTANCES-OBSOLETE" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-LIST-AC" , "ACL2-USER" , "ACL2"),
    ("MAKE-LOAD-FORM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-LOAD-FORM-SAVING-SLOTS" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-MV-NTHS" , "ACL2-USER" , "ACL2"),
    ("MAKE-ORD" , "ACL2-USER" , "ACL2"),
    ("MAKE-OUTPUT-CHANNEL" , "ACL2-USER" , "ACL2"),
    ("MAKE-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-RANDOM-STATE" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-SEQUENCE" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-STRING-INPUT-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-STRING-OUTPUT-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-SYMBOL" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-SYNONYM-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-TWO-WAY-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKE-VAR-LST" , "ACL2-USER" , "ACL2"),
    ("MAKE-VAR-LST1" , "ACL2-USER" , "ACL2"),
    ("MAKUNBOUND" , "ACL2-USER" , "COMMON-LISP"),
    ("MAKUNBOUND-GLOBAL" , "ACL2-USER" , "ACL2"),
    ("MAP" , "ACL2-USER" , "COMMON-LISP"),
    ("MAP-INTO" , "ACL2-USER" , "COMMON-LISP"),
    ("MAPC" , "ACL2-USER" , "COMMON-LISP"),
    ("MAPCAN" , "ACL2-USER" , "COMMON-LISP"),
    ("MAPCAR" , "ACL2-USER" , "COMMON-LISP"),
    ("MAPCON" , "ACL2-USER" , "COMMON-LISP"),
    ("MAPHASH" , "ACL2-USER" , "COMMON-LISP"),
    ("MAPL" , "ACL2-USER" , "COMMON-LISP"),
    ("MAPLIST" , "ACL2-USER" , "COMMON-LISP"),
    ("MASK-FIELD" , "ACL2-USER" , "COMMON-LISP"),
    ("MAX" , "ACL2-USER" , "COMMON-LISP"),
    ("MAXIMUM-LENGTH" , "ACL2-USER" , "ACL2"),
    ("MAY-NEED-SLASHES" , "ACL2-USER" , "ACL2"),
    ("MBE" , "ACL2-USER" , "ACL2"),
    ("MBT" , "ACL2-USER" , "ACL2"),
    ("MEMBER" , "ACL2-USER" , "COMMON-LISP"),
    ("MEMBER-EQ" , "ACL2-USER" , "ACL2"),
    ("MEMBER-EQUAL" , "ACL2-USER" , "ACL2"),
    ("MEMBER-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("MEMBER-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("MEMBER-SYMBOL-NAME" , "ACL2-USER" , "ACL2"),
    ("MEMOIZE" , "ACL2-USER" , "ACL2"),
    ("MEMOIZE-LET" , "ACL2-USER" , "ACL2"),
    ("MEMOIZE-OFF" , "ACL2-USER" , "ACL2"),
    ("MEMOIZE-ON" , "ACL2-USER" , "ACL2"),
    ("MERGE" , "ACL2-USER" , "COMMON-LISP"),
    ("MERGE-PATHNAMES" , "ACL2-USER" , "COMMON-LISP"),
    ("METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("METHOD-COMBINATION" , "ACL2-USER" , "COMMON-LISP"),
    ("METHOD-COMBINATION-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("METHOD-QUALIFIERS" , "ACL2-USER" , "COMMON-LISP"),
    ("MFC" , "ACL2-USER" , "ACL2"),
    ("MIN" , "ACL2-USER" , "COMMON-LISP"),
    ("MINIMAL-THEORY" , "ACL2-USER" , "ACL2"),
    ("MINUSP" , "ACL2-USER" , "COMMON-LISP"),
    ("MISMATCH" , "ACL2-USER" , "COMMON-LISP"),
    ("MOD" , "ACL2-USER" , "COMMON-LISP"),
    ("MONITOR" , "ACL2-USER" , "ACL2"),
    ("MONITORED-RUNES" , "ACL2-USER" , "ACL2"),
    ("MORE" , "ACL2-USER" , "ACL2"),
    ("MORE!" , "ACL2-USER" , "ACL2"),
    ("MORE-DOC" , "ACL2-USER" , "ACL2"),
    ("MOST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-NEGATIVE-FIXNUM" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-NEGATIVE-LONG-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SHORT-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SINGLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-POSITIVE-DOUBLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-POSITIVE-FIXNUM" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-POSITIVE-LONG-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-POSITIVE-SHORT-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MOST-POSITIVE-SINGLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("MUFFLE-WARNING" , "ACL2-USER" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-BIND" , "ACL2-USER" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-CALL" , "ACL2-USER" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-PROG1" , "ACL2-USER" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-SETQ" , "ACL2-USER" , "COMMON-LISP"),
    ("MULTIPLE-VALUES-LIMIT" , "ACL2-USER" , "COMMON-LISP"),
    ("MUTUAL-RECURSION" , "ACL2-USER" , "ACL2"),
    ("MUTUAL-RECURSION-GUARDP" , "ACL2-USER" , "ACL2"),
    ("MV" , "ACL2-USER" , "ACL2"),
    ("MV-LET" , "ACL2-USER" , "ACL2"),
    ("MV-LIST" , "ACL2-USER" , "ACL2"),
    ("MV-NTH" , "ACL2-USER" , "ACL2"),
    ("NAME-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("NAMESTRING" , "ACL2-USER" , "COMMON-LISP"),
    ("NATP" , "ACL2-USER" , "ACL2"),
    ("NBUTLAST" , "ACL2-USER" , "COMMON-LISP"),
    ("NCONC" , "ACL2-USER" , "COMMON-LISP"),
    ("NEEDS-SLASHES" , "ACL2-USER" , "ACL2"),
    ("NEWLINE" , "ACL2-USER" , "ACL2"),
    ("NEXT-METHOD-P" , "ACL2-USER" , "COMMON-LISP"),
    ("NFIX" , "ACL2-USER" , "ACL2"),
    ("NIL" , "ACL2-USER" , "COMMON-LISP"),
    ("NIL-IS-NOT-CIRCULAR" , "ACL2-USER" , "ACL2"),
    ("NINTERSECTION" , "ACL2-USER" , "COMMON-LISP"),
    ("NINTH" , "ACL2-USER" , "COMMON-LISP"),
    ("NO-APPLICABLE-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("NO-DUPLICATESP" , "ACL2-USER" , "ACL2"),
    ("NO-DUPLICATESP-EQUAL" , "ACL2-USER" , "ACL2"),
    ("NO-NEXT-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("NONNEGATIVE-INTEGER-QUOTIENT" , "ACL2-USER" , "ACL2"),
    ("NONNEGATIVE-PRODUCT" , "ACL2-USER" , "ACL2"),
    ("NONZERO-IMAGPART" , "ACL2-USER" , "ACL2"),
    ("NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("NOTANY" , "ACL2-USER" , "COMMON-LISP"),
    ("NOTEVERY" , "ACL2-USER" , "COMMON-LISP"),
    ("NOTINLINE" , "ACL2-USER" , "COMMON-LISP"),
    ("NQTHM-TO-ACL2" , "ACL2-USER" , "ACL2"),
    ("NRECONC" , "ACL2-USER" , "COMMON-LISP"),
    ("NREVERSE" , "ACL2-USER" , "COMMON-LISP"),
    ("NSET-DIFFERENCE" , "ACL2-USER" , "COMMON-LISP"),
    ("NSET-EXCLUSIVE-OR" , "ACL2-USER" , "COMMON-LISP"),
    ("NSTRING-CAPITALIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("NSTRING-DOWNCASE" , "ACL2-USER" , "COMMON-LISP"),
    ("NSTRING-UPCASE" , "ACL2-USER" , "COMMON-LISP"),
    ("NSUBLIS" , "ACL2-USER" , "COMMON-LISP"),
    ("NSUBST" , "ACL2-USER" , "COMMON-LISP"),
    ("NSUBST-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("NSUBST-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("NSUBSTITUTE" , "ACL2-USER" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("NTH" , "ACL2-USER" , "COMMON-LISP"),
    ("NTH-0-CONS" , "ACL2-USER" , "ACL2"),
    ("NTH-0-READ-RUN-TIME-TYPE-PRESCRIPTION" , "ACL2-USER" , "ACL2"),
    ("NTH-ADD1" , "ACL2-USER" , "ACL2"),
    ("NTH-ALIASES" , "ACL2-USER" , "ACL2"),
    ("NTH-UPDATE-NTH" , "ACL2-USER" , "ACL2"),
    ("NTH-VALUE" , "ACL2-USER" , "COMMON-LISP"),
    ("NTHCDR" , "ACL2-USER" , "COMMON-LISP"),
    ("NULL" , "ACL2-USER" , "COMMON-LISP"),
    ("NUMBER" , "ACL2-USER" , "COMMON-LISP"),
    ("NUMBER-SUBTREES" , "ACL2-USER" , "ACL2"),
    ("NUMBERP" , "ACL2-USER" , "COMMON-LISP"),
    ("NUMERATOR" , "ACL2-USER" , "COMMON-LISP"),
    ("NUNION" , "ACL2-USER" , "COMMON-LISP"),
    ("O-FINP" , "ACL2-USER" , "ACL2"),
    ("O-FIRST-COEFF" , "ACL2-USER" , "ACL2"),
    ("O-FIRST-EXPT" , "ACL2-USER" , "ACL2"),
    ("O-INFP" , "ACL2-USER" , "ACL2"),
    ("O-P" , "ACL2-USER" , "ACL2"),
    ("O-RST" , "ACL2-USER" , "ACL2"),
    ("O<" , "ACL2-USER" , "ACL2"),
    ("O<=" , "ACL2-USER" , "ACL2"),
    ("O>" , "ACL2-USER" , "ACL2"),
    ("O>=" , "ACL2-USER" , "ACL2"),
    ("OBSERVATION" , "ACL2-USER" , "ACL2"),
    ("ODDP" , "ACL2-USER" , "COMMON-LISP"),
    ("ODDS" , "ACL2-USER" , "ACL2"),
    ("OK-IF" , "ACL2-USER" , "ACL2"),
    ("OOPS" , "ACL2-USER" , "ACL2"),
    ("OPEN" , "ACL2-USER" , "COMMON-LISP"),
    ("OPEN-CHANNEL-LISTP" , "ACL2-USER" , "ACL2"),
    ("OPEN-CHANNEL1" , "ACL2-USER" , "ACL2"),
    ("OPEN-CHANNEL1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-USER"
, "ACL2"),
    ("OPEN-CHANNELS-P" , "ACL2-USER" , "ACL2"),
    ("OPEN-CHANNELS-P-FORWARD" , "ACL2-USER" , "ACL2"),
    ("OPEN-INPUT-CHANNEL" , "ACL2-USER" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P" , "ACL2-USER" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P1" , "ACL2-USER" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P" , "ACL2-USER" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P1" , "ACL2-USER" , "ACL2"),
    ("OPEN-INPUT-CHANNELS" , "ACL2-USER" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL" , "ACL2-USER" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL!" , "ACL2-USER" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P" , "ACL2-USER" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P1" , "ACL2-USER" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P" , "ACL2-USER" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P1" , "ACL2-USER" , "ACL2"),
    ("OPEN-OUTPUT-CHANNELS" , "ACL2-USER" , "ACL2"),
    ("OPEN-STREAM-P" , "ACL2-USER" , "COMMON-LISP"),
    ("OPEN-TRACE-FILE" , "ACL2-USER" , "ACL2"),
    ("OPTIMIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("OR" , "ACL2-USER" , "COMMON-LISP"),
    ("OR-MACRO" , "ACL2-USER" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP" , "ACL2-USER" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR" , "ACL2-USER" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR-FORWARD" , "ACL2-USER" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-FORWARD-TO-SYMBOL-ALISTP" , "ACL2-USER"
, "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-GETPROPS" , "ACL2-USER" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-REMOVE-FIRST-PAIR" , "ACL2-USER" , "ACL2"),
    ("OTHERWISE" , "ACL2-USER" , "COMMON-LISP"),
    ("OUR-DIGIT-CHAR-P" , "ACL2-USER" , "ACL2"),
    ("OUTPUT-STREAM-P" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE-ERROR-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE-NICKNAMES" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE-SHADOWING-SYMBOLS" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE-USE-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGE-USED-BY-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("PACKAGEP" , "ACL2-USER" , "COMMON-LISP"),
    ("PAIRLIS" , "ACL2-USER" , "COMMON-LISP"),
    ("PAIRLIS$" , "ACL2-USER" , "ACL2"),
    ("PAIRLIS2" , "ACL2-USER" , "ACL2"),
    ("PAND" , "ACL2-USER" , "ACL2"),
    ("PARGS" , "ACL2-USER" , "ACL2"),
    ("PARSE-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("PARSE-INTEGER" , "ACL2-USER" , "COMMON-LISP"),
    ("PARSE-NAMESTRING" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME-DEVICE" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME-DIRECTORY" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME-HOST" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME-MATCH-P" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAME-VERSION" , "ACL2-USER" , "COMMON-LISP"),
    ("PATHNAMEP" , "ACL2-USER" , "COMMON-LISP"),
    ("PBT" , "ACL2-USER" , "ACL2"),
    ("PC" , "ACL2-USER" , "ACL2"),
    ("PCB" , "ACL2-USER" , "ACL2"),
    ("PCB!" , "ACL2-USER" , "ACL2"),
    ("PCS" , "ACL2-USER" , "ACL2"),
    ("PE" , "ACL2-USER" , "ACL2"),
    ("PEEK-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("PEEK-CHAR$" , "ACL2-USER" , "ACL2"),
    ("PF" , "ACL2-USER" , "ACL2"),
    ("PHASE" , "ACL2-USER" , "COMMON-LISP"),
    ("PI" , "ACL2-USER" , "COMMON-LISP"),
    ("PL" , "ACL2-USER" , "ACL2"),
    ("PLET" , "ACL2-USER" , "ACL2"),
    ("PLIST-WORLDP" , "ACL2-USER" , "ACL2"),
    ("PLIST-WORLDP-FORWARD-TO-ASSOC-EQ-EQUAL-ALISTP" , "ACL2-USER"
, "ACL2"),
    ("PLUSP" , "ACL2-USER" , "COMMON-LISP"),
    ("POP" , "ACL2-USER" , "COMMON-LISP"),
    ("POP-TIMER" , "ACL2-USER" , "ACL2"),
    ("POR" , "ACL2-USER" , "ACL2"),
    ("POSITION" , "ACL2-USER" , "COMMON-LISP"),
    ("POSITION-AC" , "ACL2-USER" , "ACL2"),
    ("POSITION-EQ" , "ACL2-USER" , "ACL2"),
    ("POSITION-EQ-AC" , "ACL2-USER" , "ACL2"),
    ("POSITION-EQUAL" , "ACL2-USER" , "ACL2"),
    ("POSITION-EQUAL-AC" , "ACL2-USER" , "ACL2"),
    ("POSITION-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("POSITION-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("POSITIVE" , "ACL2-USER" , "ACL2"),
    ("POSP" , "ACL2-USER" , "ACL2"),
    ("POWER-EVAL" , "ACL2-USER" , "ACL2"),
    ("PPRINT" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-DISPATCH" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-EXIT-IF-LIST-EXHAUSTED" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-FILL" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-INDENT" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-LINEAR" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-LOGICAL-BLOCK" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-NEWLINE" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-POP" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-TAB" , "ACL2-USER" , "COMMON-LISP"),
    ("PPRINT-TABULAR" , "ACL2-USER" , "COMMON-LISP"),
    ("PPROGN" , "ACL2-USER" , "ACL2"),
    ("PR" , "ACL2-USER" , "ACL2"),
    ("PR!" , "ACL2-USER" , "ACL2"),
    ("PREPROCESS" , "ACL2-USER" , "ACL2"),
    ("PRIN1" , "ACL2-USER" , "COMMON-LISP"),
    ("PRIN1$" , "ACL2-USER" , "ACL2"),
    ("PRIN1-TO-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("PRIN1-WITH-SLASHES" , "ACL2-USER" , "ACL2"),
    ("PRIN1-WITH-SLASHES1" , "ACL2-USER" , "ACL2"),
    ("PRINC" , "ACL2-USER" , "COMMON-LISP"),
    ("PRINC$" , "ACL2-USER" , "ACL2"),
    ("PRINC-TO-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("PRINT" , "ACL2-USER" , "COMMON-LISP"),
    ("PRINT-GV" , "ACL2-USER" , "ACL2"),
    ("PRINT-NOT-READABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("PRINT-NOT-READABLE-OBJECT" , "ACL2-USER" , "COMMON-LISP"),
    ("PRINT-OBJECT" , "ACL2-USER" , "COMMON-LISP"),
    ("PRINT-OBJECT$" , "ACL2-USER" , "ACL2"),
    ("PRINT-RATIONAL-AS-DECIMAL" , "ACL2-USER" , "ACL2"),
    ("PRINT-TIMER" , "ACL2-USER" , "ACL2"),
    ("PRINT-UNREADABLE-OBJECT" , "ACL2-USER" , "COMMON-LISP"),
    ("PROBE-FILE" , "ACL2-USER" , "COMMON-LISP"),
    ("PROCLAIM" , "ACL2-USER" , "COMMON-LISP"),
    ("PROG" , "ACL2-USER" , "COMMON-LISP"),
    ("PROG*" , "ACL2-USER" , "COMMON-LISP"),
    ("PROG1" , "ACL2-USER" , "COMMON-LISP"),
    ("PROG2" , "ACL2-USER" , "COMMON-LISP"),
    ("PROG2$" , "ACL2-USER" , "ACL2"),
    ("PROGN" , "ACL2-USER" , "COMMON-LISP"),
    ("PROGRAM" , "ACL2-USER" , "ACL2"),
    ("PROGRAM-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("PROGV" , "ACL2-USER" , "COMMON-LISP"),
    ("PROOF-TREE" , "ACL2-USER" , "ACL2"),
    ("PROOFS-CO" , "ACL2-USER" , "ACL2"),
    ("PROPER-CONSP" , "ACL2-USER" , "ACL2"),
    ("PROPS" , "ACL2-USER" , "ACL2"),
    ("PROVE" , "ACL2-USER" , "ACL2"),
    ("PROVIDE" , "ACL2-USER" , "COMMON-LISP"),
    ("PSETF" , "ACL2-USER" , "COMMON-LISP"),
    ("PSETQ" , "ACL2-USER" , "COMMON-LISP"),
    ("PSEUDO-TERM-LISTP" , "ACL2-USER" , "ACL2"),
    ("PSEUDO-TERM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("PSEUDO-TERMP" , "ACL2-USER" , "ACL2"),
    ("PSTACK" , "ACL2-USER" , "ACL2"),
    ("PUFF" , "ACL2-USER" , "ACL2"),
    ("PUFF*" , "ACL2-USER" , "ACL2"),
    ("PUSH" , "ACL2-USER" , "COMMON-LISP"),
    ("PUSH-TIMER" , "ACL2-USER" , "ACL2"),
    ("PUSH-UNTOUCHABLE" , "ACL2-USER" , "ACL2"),
    ("PUSHNEW" , "ACL2-USER" , "COMMON-LISP"),
    ("PUT-ASSOC-EQ" , "ACL2-USER" , "ACL2"),
    ("PUT-ASSOC-EQUAL" , "ACL2-USER" , "ACL2"),
    ("PUT-GLOBAL" , "ACL2-USER" , "ACL2"),
    ("PUTPROP" , "ACL2-USER" , "ACL2"),
    ("QUOTE" , "ACL2-USER" , "COMMON-LISP"),
    ("QUOTEP" , "ACL2-USER" , "ACL2"),
    ("R-EQLABLE-ALISTP" , "ACL2-USER" , "ACL2"),
    ("RANDOM" , "ACL2-USER" , "COMMON-LISP"),
    ("RANDOM-STATE" , "ACL2-USER" , "COMMON-LISP"),
    ("RANDOM-STATE-P" , "ACL2-USER" , "COMMON-LISP"),
    ("RASSOC" , "ACL2-USER" , "COMMON-LISP"),
    ("RASSOC-EQ" , "ACL2-USER" , "ACL2"),
    ("RASSOC-EQUAL" , "ACL2-USER" , "ACL2"),
    ("RASSOC-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("RASSOC-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("RATIO" , "ACL2-USER" , "COMMON-LISP"),
    ("RATIONAL" , "ACL2-USER" , "COMMON-LISP"),
    ("RATIONAL-IMPLIES1" , "ACL2-USER" , "ACL2"),
    ("RATIONAL-IMPLIES2" , "ACL2-USER" , "ACL2"),
    ("RATIONAL-LISTP" , "ACL2-USER" , "ACL2"),
    ("RATIONAL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("RATIONALIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("RATIONALP" , "ACL2-USER" , "COMMON-LISP"),
    ("RATIONALP-*" , "ACL2-USER" , "ACL2"),
    ("RATIONALP-+" , "ACL2-USER" , "ACL2"),
    ("RATIONALP-EXPT-TYPE-PRESCRIPTION" , "ACL2-USER" , "ACL2"),
    ("RATIONALP-IMPLIES-ACL2-NUMBERP" , "ACL2-USER" , "ACL2"),
    ("RATIONALP-UNARY--" , "ACL2-USER" , "ACL2"),
    ("RATIONALP-UNARY-/" , "ACL2-USER" , "ACL2"),
    ("READ" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-ACL2-ORACLE" , "ACL2-USER" , "ACL2"),
    ("READ-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-USER" , "ACL2"),
    ("READ-BYTE" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-BYTE$" , "ACL2-USER" , "ACL2"),
    ("READ-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-CHAR$" , "ACL2-USER" , "ACL2"),
    ("READ-CHAR-NO-HANG" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-DELIMITED-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-FILE-LISTP" , "ACL2-USER" , "ACL2"),
    ("READ-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-USER" , "ACL2"),
    ("READ-FILE-LISTP1" , "ACL2-USER" , "ACL2"),
    ("READ-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-USER"
, "ACL2"),
    ("READ-FILES" , "ACL2-USER" , "ACL2"),
    ("READ-FILES-P" , "ACL2-USER" , "ACL2"),
    ("READ-FILES-P-FORWARD-TO-READ-FILE-LISTP" , "ACL2-USER" , "ACL2"),
    ("READ-FROM-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-IDATE" , "ACL2-USER" , "ACL2"),
    ("READ-LINE" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-OBJECT" , "ACL2-USER" , "ACL2"),
    ("READ-PRESERVING-WHITESPACE" , "ACL2-USER" , "COMMON-LISP"),
    ("READ-RUN-TIME" , "ACL2-USER" , "ACL2"),
    ("READ-RUN-TIME-PRESERVES-STATE-P1" , "ACL2-USER" , "ACL2"),
    ("READ-SEQUENCE" , "ACL2-USER" , "COMMON-LISP"),
    ("READABLE-FILE" , "ACL2-USER" , "ACL2"),
    ("READABLE-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-USER"
, "ACL2"),
    ("READABLE-FILES" , "ACL2-USER" , "ACL2"),
    ("READABLE-FILES-LISTP" , "ACL2-USER" , "ACL2"),
    ("READABLE-FILES-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-USER" , "ACL2"),
    ("READABLE-FILES-P" , "ACL2-USER" , "ACL2"),
    ("READABLE-FILES-P-FORWARD-TO-READABLE-FILES-LISTP" , "ACL2-USER"
, "ACL2"),
    ("READER-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("READTABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("READTABLE-CASE" , "ACL2-USER" , "COMMON-LISP"),
    ("READTABLEP" , "ACL2-USER" , "COMMON-LISP"),
    ("REAL" , "ACL2-USER" , "COMMON-LISP"),
    ("REAL/RATIONALP" , "ACL2-USER" , "ACL2"),
    ("REALFIX" , "ACL2-USER" , "ACL2"),
    ("REALP" , "ACL2-USER" , "COMMON-LISP"),
    ("REALPART" , "ACL2-USER" , "COMMON-LISP"),
    ("REALPART-COMPLEX" , "ACL2-USER" , "ACL2"),
    ("REALPART-IMAGPART-ELIM" , "ACL2-USER" , "ACL2"),
    ("REBUILD" , "ACL2-USER" , "ACL2"),
    ("REDEF" , "ACL2-USER" , "ACL2"),
    ("REDEF!" , "ACL2-USER" , "ACL2"),
    ("REDEF+" , "ACL2-USER" , "ACL2"),
    ("REDUCE" , "ACL2-USER" , "COMMON-LISP"),
    ("REINITIALIZE-INSTANCE" , "ACL2-USER" , "COMMON-LISP"),
    ("REM" , "ACL2-USER" , "COMMON-LISP"),
    ("REMF" , "ACL2-USER" , "COMMON-LISP"),
    ("REMHASH" , "ACL2-USER" , "COMMON-LISP"),
    ("REMOVE" , "ACL2-USER" , "COMMON-LISP"),
    ("REMOVE-BINOP" , "ACL2-USER" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS" , "ACL2-USER" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS!" , "ACL2-USER" , "ACL2"),
    ("REMOVE-DUPLICATES" , "ACL2-USER" , "COMMON-LISP"),
    ("REMOVE-DUPLICATES-EQL" , "ACL2-USER" , "ACL2"),
    ("REMOVE-DUPLICATES-EQUAL" , "ACL2-USER" , "ACL2"),
    ("REMOVE-EQ" , "ACL2-USER" , "ACL2"),
    ("REMOVE-EQUAL" , "ACL2-USER" , "ACL2"),
    ("REMOVE-FIRST-PAIR" , "ACL2-USER" , "ACL2"),
    ("REMOVE-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("REMOVE-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("REMOVE-INVISIBLE-FNS" , "ACL2-USER" , "ACL2"),
    ("REMOVE-MACRO-ALIAS" , "ACL2-USER" , "ACL2"),
    ("REMOVE-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("REMOVE-NTH-ALIAS" , "ACL2-USER" , "ACL2"),
    ("REMOVE-UNTOUCHABLE" , "ACL2-USER" , "ACL2"),
    ("REMOVE1" , "ACL2-USER" , "ACL2"),
    ("REMOVE1-EQ" , "ACL2-USER" , "ACL2"),
    ("REMOVE1-EQUAL" , "ACL2-USER" , "ACL2"),
    ("REMPROP" , "ACL2-USER" , "COMMON-LISP"),
    ("RENAME-FILE" , "ACL2-USER" , "COMMON-LISP"),
    ("RENAME-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("REPLACE" , "ACL2-USER" , "COMMON-LISP"),
    ("REQUIRE" , "ACL2-USER" , "COMMON-LISP"),
    ("RESET-LD-SPECIALS" , "ACL2-USER" , "ACL2"),
    ("RESET-PREHISTORY" , "ACL2-USER" , "ACL2"),
    ("REST" , "ACL2-USER" , "COMMON-LISP"),
    ("RESTART" , "ACL2-USER" , "COMMON-LISP"),
    ("RESTART-BIND" , "ACL2-USER" , "COMMON-LISP"),
    ("RESTART-CASE" , "ACL2-USER" , "COMMON-LISP"),
    ("RESTART-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("RETRACT-WORLD" , "ACL2-USER" , "ACL2"),
    ("RETRIEVE" , "ACL2-USER" , "ACL2"),
    ("RETURN" , "ACL2-USER" , "COMMON-LISP"),
    ("RETURN-FROM" , "ACL2-USER" , "COMMON-LISP"),
    ("REVAPPEND" , "ACL2-USER" , "COMMON-LISP"),
    ("REVERSE" , "ACL2-USER" , "COMMON-LISP"),
    ("RFIX" , "ACL2-USER" , "ACL2"),
    ("ROOM" , "ACL2-USER" , "COMMON-LISP"),
    ("ROTATEF" , "ACL2-USER" , "COMMON-LISP"),
    ("ROUND" , "ACL2-USER" , "COMMON-LISP"),
    ("ROW-MAJOR-AREF" , "ACL2-USER" , "COMMON-LISP"),
    ("RPLACA" , "ACL2-USER" , "COMMON-LISP"),
    ("RPLACD" , "ACL2-USER" , "COMMON-LISP"),
    ("SAFETY" , "ACL2-USER" , "COMMON-LISP"),
    ("SATISFIES" , "ACL2-USER" , "COMMON-LISP"),
    ("SBIT" , "ACL2-USER" , "COMMON-LISP"),
    ("SCALE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("SCHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("SEARCH" , "ACL2-USER" , "COMMON-LISP"),
    ("SECOND" , "ACL2-USER" , "COMMON-LISP"),
    ("SEQUENCE" , "ACL2-USER" , "COMMON-LISP"),
    ("SERIOUS-CONDITION" , "ACL2-USER" , "COMMON-LISP"),
    ("SET" , "ACL2-USER" , "COMMON-LISP"),
    ("SET-BACKCHAIN-LIMIT" , "ACL2-USER" , "ACL2"),
    ("SET-BODY" , "ACL2-USER" , "ACL2"),
    ("SET-BOGUS-DEFUN-HINTS-OK" , "ACL2-USER" , "ACL2"),
    ("SET-BOGUS-MUTUAL-RECURSION-OK" , "ACL2-USER" , "ACL2"),
    ("SET-CASE-SPLIT-LIMITATIONS" , "ACL2-USER" , "ACL2"),
    ("SET-CBD" , "ACL2-USER" , "ACL2"),
    ("SET-CHECKPOINT-SUMMARY-LIMIT" , "ACL2-USER" , "ACL2"),
    ("SET-COMPILE-FNS" , "ACL2-USER" , "ACL2"),
    ("SET-DEBUGGER-ENABLE" , "ACL2-USER" , "ACL2"),
    ("SET-DEFAULT-BACKCHAIN-LIMIT" , "ACL2-USER" , "ACL2"),
    ("SET-DEFAULT-HINTS" , "ACL2-USER" , "ACL2"),
    ("SET-DEFAULT-HINTS!" , "ACL2-USER" , "ACL2"),
    ("SET-DIFFERENCE" , "ACL2-USER" , "COMMON-LISP"),
    ("SET-DIFFERENCE-EQ" , "ACL2-USER" , "ACL2"),
    ("SET-DIFFERENCE-EQUAL" , "ACL2-USER" , "ACL2"),
    ("SET-DIFFERENCE-THEORIES" , "ACL2-USER" , "ACL2"),
    ("SET-DISPATCH-MACRO-CHARACTER" , "ACL2-USER" , "COMMON-LISP"),
    ("SET-ENFORCE-REDUNDANCY" , "ACL2-USER" , "ACL2"),
    ("SET-EQUALP-EQUAL" , "ACL2-USER" , "ACL2"),
    ("SET-EXCLUSIVE-OR" , "ACL2-USER" , "COMMON-LISP"),
    ("SET-GAG-MODE" , "ACL2-USER" , "ACL2"),
    ("SET-GUARD-CHECKING" , "ACL2-USER" , "ACL2"),
    ("SET-IGNORE-DOC-STRING-ERROR" , "ACL2-USER" , "ACL2"),
    ("SET-IGNORE-OK" , "ACL2-USER" , "ACL2"),
    ("SET-INHIBIT-OUTPUT-LST" , "ACL2-USER" , "ACL2"),
    ("SET-INHIBIT-WARNINGS" , "ACL2-USER" , "ACL2"),
    ("SET-INHIBITED-SUMMARY-TYPES" , "ACL2-USER" , "ACL2"),
    ("SET-INVISIBLE-FNS-TABLE" , "ACL2-USER" , "ACL2"),
    ("SET-IRRELEVANT-FORMALS-OK" , "ACL2-USER" , "ACL2"),
    ("SET-LD-KEYWORD-ALIASES" , "ACL2-USER" , "ACL2"),
    ("SET-LD-REDEFINITION-ACTION" , "ACL2-USER" , "ACL2"),
    ("SET-LD-SKIP-PROOFS" , "ACL2-USER" , "ACL2"),
    ("SET-LD-SKIP-PROOFSP" , "ACL2-USER" , "ACL2"),
    ("SET-LET*-ABSTRACTION" , "ACL2-USER" , "ACL2"),
    ("SET-LET*-ABSTRACTIONP" , "ACL2-USER" , "ACL2"),
    ("SET-MACRO-CHARACTER" , "ACL2-USER" , "COMMON-LISP"),
    ("SET-MATCH-FREE-DEFAULT" , "ACL2-USER" , "ACL2"),
    ("SET-MATCH-FREE-ERROR" , "ACL2-USER" , "ACL2"),
    ("SET-MEASURE-FUNCTION" , "ACL2-USER" , "ACL2"),
    ("SET-NON-LINEAR" , "ACL2-USER" , "ACL2"),
    ("SET-NON-LINEARP" , "ACL2-USER" , "ACL2"),
    ("SET-NU-REWRITER-MODE" , "ACL2-USER" , "ACL2"),
    ("SET-PARALLEL-EVALUATION" , "ACL2-USER" , "ACL2"),
    ("SET-PPRINT-DISPATCH" , "ACL2-USER" , "COMMON-LISP"),
    ("SET-PRINT-BASE" , "ACL2-USER" , "ACL2"),
    ("SET-PRINT-CASE" , "ACL2-USER" , "ACL2"),
    ("SET-PRINT-CLAUSE-IDS" , "ACL2-USER" , "ACL2"),
    ("SET-RAW-MODE" , "ACL2-USER" , "ACL2"),
    ("SET-RAW-MODE-ON!" , "ACL2-USER" , "ACL2"),
    ("SET-RAW-PROOF-FORMAT" , "ACL2-USER" , "ACL2"),
    ("SET-REWRITE-STACK-LIMIT" , "ACL2-USER" , "ACL2"),
    ("SET-RULER-EXTENDERS" , "ACL2-USER" , "ACL2"),
    ("SET-SAVED-OUTPUT" , "ACL2-USER" , "ACL2"),
    ("SET-SLOW-ALIST-ACTION" , "ACL2-USER" , "ACL2"),
    ("SET-STATE-OK" , "ACL2-USER" , "ACL2"),
    ("SET-SYNTAX-FROM-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("SET-TAINTED-OK" , "ACL2-USER" , "ACL2"),
    ("SET-TAINTED-OKP" , "ACL2-USER" , "ACL2"),
    ("SET-TIMER" , "ACL2-USER" , "ACL2"),
    ("SET-TRACE-EVISC-TUPLE" , "ACL2-USER" , "ACL2"),
    ("SET-VERIFY-GUARDS-EAGERNESS" , "ACL2-USER" , "ACL2"),
    ("SET-W" , "ACL2-USER" , "ACL2"),
    ("SET-WELL-FOUNDED-RELATION" , "ACL2-USER" , "ACL2"),
    ("SETF" , "ACL2-USER" , "COMMON-LISP"),
    ("SETQ" , "ACL2-USER" , "COMMON-LISP"),
    ("SEVENTH" , "ACL2-USER" , "COMMON-LISP"),
    ("SGETPROP" , "ACL2-USER" , "ACL2"),
    ("SHADOW" , "ACL2-USER" , "COMMON-LISP"),
    ("SHADOWING-IMPORT" , "ACL2-USER" , "COMMON-LISP"),
    ("SHARED-INITIALIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("SHIFTF" , "ACL2-USER" , "COMMON-LISP"),
    ("SHORT-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("SHORT-FLOAT-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("SHORT-FLOAT-NEGATIVE-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("SHORT-SITE-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("SHOW-ACCUMULATED-PERSISTENCE" , "ACL2-USER" , "ACL2"),
    ("SHOW-BDD" , "ACL2-USER" , "ACL2"),
    ("SHOW-BODIES" , "ACL2-USER" , "ACL2"),
    ("SHRINK-32-BIT-INTEGER-STACK" , "ACL2-USER" , "ACL2"),
    ("SHRINK-T-STACK" , "ACL2-USER" , "ACL2"),
    ("SIGNAL" , "ACL2-USER" , "COMMON-LISP"),
    ("SIGNED-BYTE" , "ACL2-USER" , "COMMON-LISP"),
    ("SIGNUM" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-ARRAY" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-BASE-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-CONDITION" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-ARGUMENTS" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-CONTROL" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-STRING-P" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-TYPE-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-VECTOR" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-VECTOR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLE-WARNING" , "ACL2-USER" , "COMMON-LISP"),
    ("SIMPLIFY" , "ACL2-USER" , "ACL2"),
    ("SIN" , "ACL2-USER" , "COMMON-LISP"),
    ("SINGLE-FLOAT" , "ACL2-USER" , "COMMON-LISP"),
    ("SINGLE-FLOAT-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("SINGLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-USER" , "COMMON-LISP"),
    ("SINH" , "ACL2-USER" , "COMMON-LISP"),
    ("SIXTH" , "ACL2-USER" , "COMMON-LISP"),
    ("SKIP-PROOFS" , "ACL2-USER" , "ACL2"),
    ("SLEEP" , "ACL2-USER" , "COMMON-LISP"),
    ("SLOT-BOUNDP" , "ACL2-USER" , "COMMON-LISP"),
    ("SLOT-EXISTS-P" , "ACL2-USER" , "COMMON-LISP"),
    ("SLOT-MAKUNBOUND" , "ACL2-USER" , "COMMON-LISP"),
    ("SLOT-MISSING" , "ACL2-USER" , "COMMON-LISP"),
    ("SLOT-UNBOUND" , "ACL2-USER" , "COMMON-LISP"),
    ("SLOT-VALUE" , "ACL2-USER" , "COMMON-LISP"),
    ("SOFTWARE-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("SOFTWARE-VERSION" , "ACL2-USER" , "COMMON-LISP"),
    ("SOME" , "ACL2-USER" , "COMMON-LISP"),
    ("SOME-SLASHABLE" , "ACL2-USER" , "ACL2"),
    ("SORT" , "ACL2-USER" , "COMMON-LISP"),
    ("SPACE" , "ACL2-USER" , "COMMON-LISP"),
    ("SPECIAL" , "ACL2-USER" , "COMMON-LISP"),
    ("SPECIAL-OPERATOR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("SPEED" , "ACL2-USER" , "COMMON-LISP"),
    ("SQRT" , "ACL2-USER" , "COMMON-LISP"),
    ("STABLE-SORT" , "ACL2-USER" , "COMMON-LISP"),
    ("STABLE-UNDER-SIMPLIFICATIONP" , "ACL2-USER" , "ACL2"),
    ("STANDARD" , "ACL2-USER" , "COMMON-LISP"),
    ("STANDARD-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("STANDARD-CHAR-LISTP" , "ACL2-USER" , "ACL2"),
    ("STANDARD-CHAR-LISTP-APPEND" , "ACL2-USER" , "ACL2"),
    ("STANDARD-CHAR-LISTP-FORWARD-TO-CHARACTER-LISTP" , "ACL2-USER"
, "ACL2"),
    ("STANDARD-CHAR-P" , "ACL2-USER" , "COMMON-LISP"),
    ("STANDARD-CHAR-P-NTH" , "ACL2-USER" , "ACL2"),
    ("STANDARD-CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("STANDARD-CO" , "ACL2-USER" , "ACL2"),
    ("STANDARD-GENERIC-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("STANDARD-METHOD" , "ACL2-USER" , "COMMON-LISP"),
    ("STANDARD-OBJECT" , "ACL2-USER" , "COMMON-LISP"),
    ("STANDARD-OI" , "ACL2-USER" , "ACL2"),
    ("STANDARD-STRING-ALISTP" , "ACL2-USER" , "ACL2"),
    ("STANDARD-STRING-ALISTP-FORWARD-TO-ALISTP" , "ACL2-USER" , "ACL2"),
    ("START-PROOF-TREE" , "ACL2-USER" , "ACL2"),
    ("STATE" , "ACL2-USER" , "ACL2"),
    ("STATE-GLOBAL-LET*-CLEANUP" , "ACL2-USER" , "ACL2"),
    ("STATE-GLOBAL-LET*-GET-GLOBALS" , "ACL2-USER" , "ACL2"),
    ("STATE-GLOBAL-LET*-PUT-GLOBALS" , "ACL2-USER" , "ACL2"),
    ("STATE-P" , "ACL2-USER" , "ACL2"),
    ("STATE-P-IMPLIES-AND-FORWARD-TO-STATE-P1" , "ACL2-USER" , "ACL2"),
    ("STATE-P1" , "ACL2-USER" , "ACL2"),
    ("STATE-P1-FORWARD" , "ACL2-USER" , "ACL2"),
    ("STATE-P1-UPDATE-MAIN-TIMER" , "ACL2-USER" , "ACL2"),
    ("STATE-P1-UPDATE-NTH-2-WORLD" , "ACL2-USER" , "ACL2"),
    ("STEP" , "ACL2-USER" , "COMMON-LISP"),
    ("STOP-PROOF-TREE" , "ACL2-USER" , "ACL2"),
    ("STORAGE-CONDITION" , "ACL2-USER" , "COMMON-LISP"),
    ("STORE-VALUE" , "ACL2-USER" , "COMMON-LISP"),
    ("STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("STREAM-ELEMENT-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("STREAM-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("STREAM-ERROR-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("STREAM-EXTERNAL-FORMAT" , "ACL2-USER" , "COMMON-LISP"),
    ("STREAMP" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-APPEND" , "ACL2-USER" , "ACL2"),
    ("STRING-APPEND-LST" , "ACL2-USER" , "ACL2"),
    ("STRING-CAPITALIZE" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-DOWNCASE" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-DOWNCASE1" , "ACL2-USER" , "ACL2"),
    ("STRING-EQUAL" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-EQUAL1" , "ACL2-USER" , "ACL2"),
    ("STRING-GREATERP" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-IS-NOT-CIRCULAR" , "ACL2-USER" , "ACL2"),
    ("STRING-LEFT-TRIM" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-LESSP" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-LISTP" , "ACL2-USER" , "ACL2"),
    ("STRING-NOT-EQUAL" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-NOT-GREATERP" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-NOT-LESSP" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-RIGHT-TRIM" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-TRIM" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-UPCASE" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING-UPCASE1" , "ACL2-USER" , "ACL2"),
    ("STRING/=" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING<" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING<-IRREFLEXIVE" , "ACL2-USER" , "ACL2"),
    ("STRING<-L" , "ACL2-USER" , "ACL2"),
    ("STRING<-L-ASYMMETRIC" , "ACL2-USER" , "ACL2"),
    ("STRING<-L-IRREFLEXIVE" , "ACL2-USER" , "ACL2"),
    ("STRING<-L-TRANSITIVE" , "ACL2-USER" , "ACL2"),
    ("STRING<-L-TRICHOTOMY" , "ACL2-USER" , "ACL2"),
    ("STRING<=" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING=" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING>" , "ACL2-USER" , "COMMON-LISP"),
    ("STRING>=" , "ACL2-USER" , "COMMON-LISP"),
    ("STRINGP" , "ACL2-USER" , "COMMON-LISP"),
    ("STRINGP-SYMBOL-PACKAGE-NAME" , "ACL2-USER" , "ACL2"),
    ("STRIP-CARS" , "ACL2-USER" , "ACL2"),
    ("STRIP-CDRS" , "ACL2-USER" , "ACL2"),
    ("STRUCTURE" , "ACL2-USER" , "COMMON-LISP"),
    ("STRUCTURE-CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("STRUCTURE-OBJECT" , "ACL2-USER" , "COMMON-LISP"),
    ("STYLE-WARNING" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBLIS" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBSEQ" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBSEQ-LIST" , "ACL2-USER" , "ACL2"),
    ("SUBSETP" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBSETP-EQUAL" , "ACL2-USER" , "ACL2"),
    ("SUBST" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBST-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBST-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBSTITUTE" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBSTITUTE-AC" , "ACL2-USER" , "ACL2"),
    ("SUBSTITUTE-IF" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBSTITUTE-IF-NOT" , "ACL2-USER" , "COMMON-LISP"),
    ("SUBTYPEP" , "ACL2-USER" , "COMMON-LISP"),
    ("SUMMARY" , "ACL2-USER" , "ACL2"),
    ("SVREF" , "ACL2-USER" , "COMMON-LISP"),
    ("SXHASH" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOL" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOL-<" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-<-ASYMMETRIC" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-<-IRREFLEXIVE" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-<-TRANSITIVE" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-<-TRICHOTOMY" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-ALISTP" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-DOUBLET-LISTP" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-EQUALITY" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOL-LISTP" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-MACROLET" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOL-NAME" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOL-NAME-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOL-PACKAGE-NAME" , "ACL2-USER" , "ACL2"),
    ("SYMBOL-PLIST" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOL-VALUE" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOLP" , "ACL2-USER" , "COMMON-LISP"),
    ("SYMBOLP-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-USER" , "ACL2"),
    ("SYNONYM-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("SYNONYM-STREAM-SYMBOL" , "ACL2-USER" , "COMMON-LISP"),
    ("SYNP" , "ACL2-USER" , "ACL2"),
    ("SYNTAXP" , "ACL2-USER" , "ACL2"),
    ("SYS-CALL" , "ACL2-USER" , "ACL2"),
    ("SYS-CALL-STATUS" , "ACL2-USER" , "ACL2"),
    ("T" , "ACL2-USER" , "COMMON-LISP"),
    ("T-STACK" , "ACL2-USER" , "ACL2"),
    ("T-STACK-LENGTH" , "ACL2-USER" , "ACL2"),
    ("T-STACK-LENGTH1" , "ACL2-USER" , "ACL2"),
    ("TABLE" , "ACL2-USER" , "ACL2"),
    ("TABLE-ALIST" , "ACL2-USER" , "ACL2"),
    ("TAGBODY" , "ACL2-USER" , "COMMON-LISP"),
    ("TAILP" , "ACL2-USER" , "COMMON-LISP"),
    ("TAKE" , "ACL2-USER" , "ACL2"),
    ("TAN" , "ACL2-USER" , "COMMON-LISP"),
    ("TANH" , "ACL2-USER" , "COMMON-LISP"),
    ("TENTH" , "ACL2-USER" , "COMMON-LISP"),
    ("TERPRI" , "ACL2-USER" , "COMMON-LISP"),
    ("THE" , "ACL2-USER" , "COMMON-LISP"),
    ("THE-ERROR" , "ACL2-USER" , "ACL2"),
    ("THE-FIXNUM" , "ACL2-USER" , "ACL2"),
    ("THE-FIXNUM!" , "ACL2-USER" , "ACL2"),
    ("THEORY" , "ACL2-USER" , "ACL2"),
    ("THEORY-INVARIANT" , "ACL2-USER" , "ACL2"),
    ("THIRD" , "ACL2-USER" , "COMMON-LISP"),
    ("THM" , "ACL2-USER" , "ACL2"),
    ("THROW" , "ACL2-USER" , "COMMON-LISP"),
    ("TIME" , "ACL2-USER" , "COMMON-LISP"),
    ("TIME$" , "ACL2-USER" , "ACL2"),
    ("TIMER-ALISTP" , "ACL2-USER" , "ACL2"),
    ("TIMER-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-SYMBOL-ALISTP" ,
"ACL2-USER" , "ACL2"),
    ("TOGGLE-PC-MACRO" , "ACL2-USER" , "ACL2"),
    ("TRACE" , "ACL2-USER" , "COMMON-LISP"),
    ("TRACE!" , "ACL2-USER" , "ACL2"),
    ("TRACE$" , "ACL2-USER" , "ACL2"),
    ("TRACE*" , "ACL2-USER" , "ACL2"),
    ("TRANS" , "ACL2-USER" , "ACL2"),
    ("TRANS1" , "ACL2-USER" , "ACL2"),
    ("TRANSLATE-LOGICAL-PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("TRANSLATE-PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("TREE-EQUAL" , "ACL2-USER" , "COMMON-LISP"),
    ("TRICHOTOMY" , "ACL2-USER" , "ACL2"),
    ("TRUE-LIST-LISTP" , "ACL2-USER" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP-ASSOC-EQ" , "ACL2-USER"
, "ACL2"),
    ("TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("TRUE-LISTP-CADR-ASSOC-EQ-FOR-OPEN-CHANNELS-P" , "ACL2-USER" ,
"ACL2"),
    ("TRUE-LISTP-UPDATE-NTH" , "ACL2-USER" , "ACL2"),
    ("TRUENAME" , "ACL2-USER" , "COMMON-LISP"),
    ("TRUNCATE" , "ACL2-USER" , "COMMON-LISP"),
    ("TWO-WAY-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-INPUT-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-OUTPUT-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("TYPE-ERROR" , "ACL2-USER" , "COMMON-LISP"),
    ("TYPE-ERROR-DATUM" , "ACL2-USER" , "COMMON-LISP"),
    ("TYPE-ERROR-EXPECTED-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("TYPE-OF" , "ACL2-USER" , "COMMON-LISP"),
    ("TYPECASE" , "ACL2-USER" , "COMMON-LISP"),
    ("TYPED-IO-LISTP" , "ACL2-USER" , "ACL2"),
    ("TYPED-IO-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-USER" , "ACL2"),
    ("TYPEP" , "ACL2-USER" , "COMMON-LISP"),
    ("U" , "ACL2-USER" , "ACL2"),
    ("UBT" , "ACL2-USER" , "ACL2"),
    ("UBT!" , "ACL2-USER" , "ACL2"),
    ("UNARY--" , "ACL2-USER" , "ACL2"),
    ("UNARY-/" , "ACL2-USER" , "ACL2"),
    ("UNARY-FUNCTION-SYMBOL-LISTP" , "ACL2-USER" , "ACL2"),
    ("UNBOUND-SLOT" , "ACL2-USER" , "COMMON-LISP"),
    ("UNBOUND-SLOT-INSTANCE" , "ACL2-USER" , "COMMON-LISP"),
    ("UNBOUND-VARIABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("UNDEFINED-FUNCTION" , "ACL2-USER" , "COMMON-LISP"),
    ("UNEXPORT" , "ACL2-USER" , "COMMON-LISP"),
    ("UNICITY-OF-0" , "ACL2-USER" , "ACL2"),
    ("UNICITY-OF-1" , "ACL2-USER" , "ACL2"),
    ("UNINTERN" , "ACL2-USER" , "COMMON-LISP"),
    ("UNION" , "ACL2-USER" , "COMMON-LISP"),
    ("UNION-EQ" , "ACL2-USER" , "ACL2"),
    ("UNION-EQUAL" , "ACL2-USER" , "ACL2"),
    ("UNION-THEORIES" , "ACL2-USER" , "ACL2"),
    ("UNIVERSAL-THEORY" , "ACL2-USER" , "ACL2"),
    ("UNLESS" , "ACL2-USER" , "COMMON-LISP"),
    ("UNMEMOIZE" , "ACL2-USER" , "ACL2"),
    ("UNMONITOR" , "ACL2-USER" , "ACL2"),
    ("UNREAD-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("UNSAVE" , "ACL2-USER" , "ACL2"),
    ("UNSIGNED-BYTE" , "ACL2-USER" , "COMMON-LISP"),
    ("UNTRACE" , "ACL2-USER" , "COMMON-LISP"),
    ("UNTRACE$" , "ACL2-USER" , "ACL2"),
    ("UNUSE-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("UNWIND-PROTECT" , "ACL2-USER" , "COMMON-LISP"),
    ("UPDATE-32-BIT-INTEGER-STACK" , "ACL2-USER" , "ACL2"),
    ("UPDATE-ACL2-ORACLE" , "ACL2-USER" , "ACL2"),
    ("UPDATE-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-USER" , "ACL2"),
    ("UPDATE-BIG-CLOCK-ENTRY" , "ACL2-USER" , "ACL2"),
    ("UPDATE-FILE-CLOCK" , "ACL2-USER" , "ACL2"),
    ("UPDATE-GLOBAL-TABLE" , "ACL2-USER" , "ACL2"),
    ("UPDATE-IDATES" , "ACL2-USER" , "ACL2"),
    ("UPDATE-INSTANCE-FOR-DIFFERENT-CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("UPDATE-INSTANCE-FOR-REDEFINED-CLASS" , "ACL2-USER" , "COMMON-LISP"),
    ("UPDATE-LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-USER" , "ACL2"),
    ("UPDATE-NTH" , "ACL2-USER" , "ACL2"),
    ("UPDATE-OPEN-INPUT-CHANNELS" , "ACL2-USER" , "ACL2"),
    ("UPDATE-OPEN-OUTPUT-CHANNELS" , "ACL2-USER" , "ACL2"),
    ("UPDATE-READ-FILES" , "ACL2-USER" , "ACL2"),
    ("UPDATE-T-STACK" , "ACL2-USER" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST" , "ACL2-USER" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST1" , "ACL2-USER" , "ACL2"),
    ("UPDATE-WRITTEN-FILES" , "ACL2-USER" , "ACL2"),
    ("UPGRADED-ARRAY-ELEMENT-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("UPGRADED-COMPLEX-PART-TYPE" , "ACL2-USER" , "COMMON-LISP"),
    ("UPPER-CASE-P" , "ACL2-USER" , "COMMON-LISP"),
    ("UPPER-CASE-P-CHAR-UPCASE" , "ACL2-USER" , "ACL2"),
    ("UPPER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-USER" , "ACL2"),
    ("USE-PACKAGE" , "ACL2-USER" , "COMMON-LISP"),
    ("USE-VALUE" , "ACL2-USER" , "COMMON-LISP"),
    ("USER-HOMEDIR-PATHNAME" , "ACL2-USER" , "COMMON-LISP"),
    ("USER-STOBJ-ALIST" , "ACL2-USER" , "ACL2"),
    ("USER-STOBJ-ALIST1" , "ACL2-USER" , "ACL2"),
    ("VALUE-TRIPLE" , "ACL2-USER" , "ACL2"),
    ("VALUES" , "ACL2-USER" , "COMMON-LISP"),
    ("VALUES-LIST" , "ACL2-USER" , "COMMON-LISP"),
    ("VARIABLE" , "ACL2-USER" , "COMMON-LISP"),
    ("VECTOR" , "ACL2-USER" , "COMMON-LISP"),
    ("VECTOR-POP" , "ACL2-USER" , "COMMON-LISP"),
    ("VECTOR-PUSH" , "ACL2-USER" , "COMMON-LISP"),
    ("VECTOR-PUSH-EXTEND" , "ACL2-USER" , "COMMON-LISP"),
    ("VECTORP" , "ACL2-USER" , "COMMON-LISP"),
    ("VERBOSE-PSTACK" , "ACL2-USER" , "ACL2"),
    ("VERIFY" , "ACL2-USER" , "ACL2"),
    ("VERIFY-GUARDS" , "ACL2-USER" , "ACL2"),
    ("VERIFY-TERMINATION" , "ACL2-USER" , "ACL2"),
    ("W" , "ACL2-USER" , "ACL2"),
    ("WARN" , "ACL2-USER" , "COMMON-LISP"),
    ("WARNING" , "ACL2-USER" , "COMMON-LISP"),
    ("WARNING!" , "ACL2-USER" , "ACL2"),
    ("WHEN" , "ACL2-USER" , "COMMON-LISP"),
    ("WILD-PATHNAME-P" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-ACCESSORS" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-COMPILATION-UNIT" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-CONDITION-RESTARTS" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-HASH-TABLE-ITERATOR" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-INPUT-FROM-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-OPEN-FILE" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-OPEN-STREAM" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-OUTPUT" , "ACL2-USER" , "ACL2"),
    ("WITH-OUTPUT-TO-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-PACKAGE-ITERATOR" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-SIMPLE-RESTART" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-SLOTS" , "ACL2-USER" , "COMMON-LISP"),
    ("WITH-STANDARD-IO-SYNTAX" , "ACL2-USER" , "COMMON-LISP"),
    ("WORLD" , "ACL2-USER" , "ACL2"),
    ("WORMHOLE" , "ACL2-USER" , "ACL2"),
    ("WORMHOLE-EVAL" , "ACL2-USER" , "ACL2"),
    ("WORMHOLE1" , "ACL2-USER" , "ACL2"),
    ("WRITABLE-FILE-LISTP" , "ACL2-USER" , "ACL2"),
    ("WRITABLE-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-USER"
, "ACL2"),
    ("WRITABLE-FILE-LISTP1" , "ACL2-USER" , "ACL2"),
    ("WRITABLE-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-USER"
, "ACL2"),
    ("WRITE" , "ACL2-USER" , "COMMON-LISP"),
    ("WRITE-BYTE" , "ACL2-USER" , "COMMON-LISP"),
    ("WRITE-BYTE$" , "ACL2-USER" , "ACL2"),
    ("WRITE-CHAR" , "ACL2-USER" , "COMMON-LISP"),
    ("WRITE-LINE" , "ACL2-USER" , "COMMON-LISP"),
    ("WRITE-SEQUENCE" , "ACL2-USER" , "COMMON-LISP"),
    ("WRITE-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("WRITE-TO-STRING" , "ACL2-USER" , "COMMON-LISP"),
    ("WRITEABLE-FILES" , "ACL2-USER" , "ACL2"),
    ("WRITEABLE-FILES-P" , "ACL2-USER" , "ACL2"),
    ("WRITEABLE-FILES-P-FORWARD-TO-WRITABLE-FILE-LISTP" , "ACL2-USER"
, "ACL2"),
    ("WRITTEN-FILE" , "ACL2-USER" , "ACL2"),
    ("WRITTEN-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-USER" ,
"ACL2"),
    ("WRITTEN-FILE-LISTP" , "ACL2-USER" , "ACL2"),
    ("WRITTEN-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-USER" , "ACL2"),
    ("WRITTEN-FILES" , "ACL2-USER" , "ACL2"),
    ("WRITTEN-FILES-P" , "ACL2-USER" , "ACL2"),
    ("WRITTEN-FILES-P-FORWARD-TO-WRITTEN-FILE-LISTP" , "ACL2-USER"
, "ACL2"),
    ("XARGS" , "ACL2-USER" , "ACL2"),
    ("XXXJOIN" , "ACL2-USER" , "ACL2"),
    ("Y-OR-N-P" , "ACL2-USER" , "COMMON-LISP"),
    ("YES-OR-NO-P" , "ACL2-USER" , "COMMON-LISP"),
    ("ZERO" , "ACL2-USER" , "ACL2"),
    ("ZEROP" , "ACL2-USER" , "COMMON-LISP"),
    ("ZIP" , "ACL2-USER" , "ACL2"),
    ("ZP" , "ACL2-USER" , "ACL2"),
    ("CONS" , "MY-PKG" , "COMMON-LISP"),
    ("DEFUN" , "MY-PKG" , "COMMON-LISP"),
    ("&REST" , "M1" , "COMMON-LISP"),
    ("*" , "M1" , "COMMON-LISP"),
    ("+" , "M1" , "COMMON-LISP"),
    ("-" , "M1" , "COMMON-LISP"),
    ("/" , "M1" , "COMMON-LISP"),
    ("<" , "M1" , "COMMON-LISP"),
    ("<=" , "M1" , "COMMON-LISP"),
    (">" , "M1" , "COMMON-LISP"),
    (">=" , "M1" , "COMMON-LISP"),
    ("ACL2-COUNT" , "M1" , "ACL2"),
    ("AND" , "M1" , "COMMON-LISP"),
    ("ASSOC" , "M1" , "COMMON-LISP"),
    ("ATOM" , "M1" , "COMMON-LISP"),
    ("CAR" , "M1" , "COMMON-LISP"),
    ("CASE" , "M1" , "COMMON-LISP"),
    ("CDR" , "M1" , "COMMON-LISP"),
    ("COERCE" , "M1" , "COMMON-LISP"),
    ("CONCATENATE" , "M1" , "COMMON-LISP"),
    ("COND" , "M1" , "COMMON-LISP"),
    ("CONS" , "M1" , "COMMON-LISP"),
    ("CONSP" , "M1" , "COMMON-LISP"),
    ("DECLARE" , "M1" , "COMMON-LISP"),
    ("DEFCONST" , "M1" , "ACL2"),
    ("DEFMACRO" , "M1" , "COMMON-LISP"),
    ("DEFTHM" , "M1" , "ACL2"),
    ("DEFUN" , "M1" , "COMMON-LISP"),
    ("DISABLE" , "M1" , "ACL2"),
    ("E/D" , "M1" , "ACL2"),
    ("ENDP" , "M1" , "COMMON-LISP"),
    ("EQUAL" , "M1" , "COMMON-LISP"),
    ("EXPT" , "M1" , "COMMON-LISP"),
    ("IF" , "M1" , "COMMON-LISP"),
    ("IGNORE" , "M1" , "COMMON-LISP"),
    ("IMPLIES" , "M1" , "ACL2"),
    ("IN-THEORY" , "M1" , "ACL2"),
    ("INCLUDE-BOOK" , "M1" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL" , "M1" , "ACL2"),
    ("LET" , "M1" , "COMMON-LISP"),
    ("LET*" , "M1" , "COMMON-LISP"),
    ("LIST" , "M1" , "COMMON-LISP"),
    ("LIST*" , "M1" , "COMMON-LISP"),
    ("MOD" , "M1" , "COMMON-LISP"),
    ("MUTUAL-RECURSION" , "M1" , "ACL2"),
    ("NATP" , "M1" , "ACL2"),
    ("NIL" , "M1" , "COMMON-LISP"),
    ("NOT" , "M1" , "COMMON-LISP"),
    ("O-P" , "M1" , "ACL2"),
    ("O<" , "M1" , "ACL2"),
    ("OR" , "M1" , "COMMON-LISP"),
    ("OTHERWISE" , "M1" , "COMMON-LISP"),
    ("PAIRLIS$" , "M1" , "ACL2"),
    ("PAIRLIS-X2" , "M1" , "ACL2"),
    ("PROGN" , "M1" , "COMMON-LISP"),
    ("QUOTE" , "M1" , "COMMON-LISP"),
    ("QUOTEP" , "M1" , "ACL2"),
    ("STRING" , "M1" , "COMMON-LISP"),
    ("STRIP-CARS" , "M1" , "ACL2"),
    ("SYMBOL-NAME" , "M1" , "COMMON-LISP"),
    ("SYMBOLP" , "M1" , "COMMON-LISP"),
    ("SYNTAXP" , "M1" , "ACL2"),
    ("T" , "M1" , "COMMON-LISP"),
    ("XARGS" , "M1" , "ACL2"),
    ("ZP" , "M1" , "ACL2"),
    ("&" , "U" , "ACL2"),
    ("&ALLOW-OTHER-KEYS" , "U" , "COMMON-LISP"),
    ("&AUX" , "U" , "COMMON-LISP"),
    ("&BODY" , "U" , "COMMON-LISP"),
    ("&ENVIRONMENT" , "U" , "COMMON-LISP"),
    ("&KEY" , "U" , "COMMON-LISP"),
    ("&OPTIONAL" , "U" , "COMMON-LISP"),
    ("&REST" , "U" , "COMMON-LISP"),
    ("&WHOLE" , "U" , "COMMON-LISP"),
    ("*" , "U" , "COMMON-LISP"),
    ("**" , "U" , "COMMON-LISP"),
    ("***" , "U" , "COMMON-LISP"),
    ("*ACL2-EXPORTS*" , "U" , "ACL2"),
    ("*BREAK-ON-SIGNALS*" , "U" , "COMMON-LISP"),
    ("*COMMON-LISP-SPECIALS-AND-CONSTANTS*" , "U" , "ACL2"),
    ("*COMMON-LISP-SYMBOLS-FROM-MAIN-LISP-PACKAGE*" , "U" , "ACL2"),
    ("*COMPILE-FILE-PATHNAME*" , "U" , "COMMON-LISP"),
    ("*COMPILE-FILE-TRUENAME*" , "U" , "COMMON-LISP"),
    ("*COMPILE-PRINT*" , "U" , "COMMON-LISP"),
    ("*COMPILE-VERBOSE*" , "U" , "COMMON-LISP"),
    ("*DEBUG-IO*" , "U" , "COMMON-LISP"),
    ("*DEBUGGER-HOOK*" , "U" , "COMMON-LISP"),
    ("*DEFAULT-PATHNAME-DEFAULTS*" , "U" , "COMMON-LISP"),
    ("*ERROR-OUTPUT*" , "U" , "COMMON-LISP"),
    ("*FEATURES*" , "U" , "COMMON-LISP"),
    ("*GENSYM-COUNTER*" , "U" , "COMMON-LISP"),
    ("*LOAD-PATHNAME*" , "U" , "COMMON-LISP"),
    ("*LOAD-PRINT*" , "U" , "COMMON-LISP"),
    ("*LOAD-TRUENAME*" , "U" , "COMMON-LISP"),
    ("*LOAD-VERBOSE*" , "U" , "COMMON-LISP"),
    ("*MACROEXPAND-HOOK*" , "U" , "COMMON-LISP"),
    ("*MAIN-LISP-PACKAGE-NAME*" , "U" , "ACL2"),
    ("*MODULES*" , "U" , "COMMON-LISP"),
    ("*PACKAGE*" , "U" , "COMMON-LISP"),
    ("*PRINT-ARRAY*" , "U" , "COMMON-LISP"),
    ("*PRINT-BASE*" , "U" , "COMMON-LISP"),
    ("*PRINT-CASE*" , "U" , "COMMON-LISP"),
    ("*PRINT-CIRCLE*" , "U" , "COMMON-LISP"),
    ("*PRINT-ESCAPE*" , "U" , "COMMON-LISP"),
    ("*PRINT-GENSYM*" , "U" , "COMMON-LISP"),
    ("*PRINT-LENGTH*" , "U" , "COMMON-LISP"),
    ("*PRINT-LEVEL*" , "U" , "COMMON-LISP"),
    ("*PRINT-LINES*" , "U" , "COMMON-LISP"),
    ("*PRINT-MISER-WIDTH*" , "U" , "COMMON-LISP"),
    ("*PRINT-PPRINT-DISPATCH*" , "U" , "COMMON-LISP"),
    ("*PRINT-PRETTY*" , "U" , "COMMON-LISP"),
    ("*PRINT-RADIX*" , "U" , "COMMON-LISP"),
    ("*PRINT-READABLY*" , "U" , "COMMON-LISP"),
    ("*PRINT-RIGHT-MARGIN*" , "U" , "COMMON-LISP"),
    ("*QUERY-IO*" , "U" , "COMMON-LISP"),
    ("*RANDOM-STATE*" , "U" , "COMMON-LISP"),
    ("*READ-BASE*" , "U" , "COMMON-LISP"),
    ("*READ-DEFAULT-FLOAT-FORMAT*" , "U" , "COMMON-LISP"),
    ("*READ-EVAL*" , "U" , "COMMON-LISP"),
    ("*READ-SUPPRESS*" , "U" , "COMMON-LISP"),
    ("*READTABLE*" , "U" , "COMMON-LISP"),
    ("*STANDARD-CHARS*" , "U" , "ACL2"),
    ("*STANDARD-CI*" , "U" , "ACL2"),
    ("*STANDARD-CO*" , "U" , "ACL2"),
    ("*STANDARD-INPUT*" , "U" , "COMMON-LISP"),
    ("*STANDARD-OI*" , "U" , "ACL2"),
    ("*STANDARD-OUTPUT*" , "U" , "COMMON-LISP"),
    ("*TERMINAL-IO*" , "U" , "COMMON-LISP"),
    ("*TRACE-OUTPUT*" , "U" , "COMMON-LISP"),
    ("+" , "U" , "COMMON-LISP"),
    ("++" , "U" , "COMMON-LISP"),
    ("+++" , "U" , "COMMON-LISP"),
    ("-" , "U" , "COMMON-LISP"),
    ("/" , "U" , "COMMON-LISP"),
    ("//" , "U" , "COMMON-LISP"),
    ("///" , "U" , "COMMON-LISP"),
    ("/=" , "U" , "COMMON-LISP"),
    ("1+" , "U" , "COMMON-LISP"),
    ("1-" , "U" , "COMMON-LISP"),
    ("32-BIT-INTEGER-LISTP" , "U" , "ACL2"),
    ("32-BIT-INTEGER-LISTP-FORWARD-TO-INTEGER-LISTP" , "U" , "ACL2"),
    ("32-BIT-INTEGER-STACK" , "U" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH" , "U" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH1" , "U" , "ACL2"),
    ("32-BIT-INTEGERP" , "U" , "ACL2"),
    ("32-BIT-INTEGERP-FORWARD-TO-INTEGERP" , "U" , "ACL2"),
    ("<" , "U" , "COMMON-LISP"),
    ("<-ON-OTHERS" , "U" , "ACL2"),
    ("<=" , "U" , "COMMON-LISP"),
    ("=" , "U" , "COMMON-LISP"),
    (">" , "U" , "COMMON-LISP"),
    (">=" , "U" , "COMMON-LISP"),
    ("?-FN" , "U" , "ACL2"),
    ("@" , "U" , "ACL2"),
    ("ABORT" , "U" , "COMMON-LISP"),
    ("ABORT!" , "U" , "ACL2"),
    ("ABS" , "U" , "COMMON-LISP"),
    ("ACCUMULATED-PERSISTENCE" , "U" , "ACL2"),
    ("ACL2-COUNT" , "U" , "ACL2"),
    ("ACL2-INPUT-CHANNEL-PACKAGE" , "U" , "ACL2"),
    ("ACL2-NUMBERP" , "U" , "ACL2"),
    ("ACL2-ORACLE" , "U" , "ACL2"),
    ("ACL2-OUTPUT-CHANNEL-PACKAGE" , "U" , "ACL2"),
    ("ACL2-PACKAGE" , "U" , "ACL2"),
    ("ACONS" , "U" , "COMMON-LISP"),
    ("ACOS" , "U" , "COMMON-LISP"),
    ("ACOSH" , "U" , "COMMON-LISP"),
    ("ACTIVE-RUNEP" , "U" , "ACL2"),
    ("ADD-BINOP" , "U" , "ACL2"),
    ("ADD-DEFAULT-HINTS" , "U" , "ACL2"),
    ("ADD-DEFAULT-HINTS!" , "U" , "ACL2"),
    ("ADD-INVISIBLE-FNS" , "U" , "ACL2"),
    ("ADD-MACRO-ALIAS" , "U" , "ACL2"),
    ("ADD-METHOD" , "U" , "COMMON-LISP"),
    ("ADD-NTH-ALIAS" , "U" , "ACL2"),
    ("ADD-PAIR" , "U" , "ACL2"),
    ("ADD-PAIR-PRESERVES-ALL-BOUNDP" , "U" , "ACL2"),
    ("ADD-TIMERS" , "U" , "ACL2"),
    ("ADD-TO-SET-EQ" , "U" , "ACL2"),
    ("ADD-TO-SET-EQL" , "U" , "ACL2"),
    ("ADD-TO-SET-EQUAL" , "U" , "ACL2"),
    ("ADJOIN" , "U" , "COMMON-LISP"),
    ("ADJUST-ARRAY" , "U" , "COMMON-LISP"),
    ("ADJUSTABLE-ARRAY-P" , "U" , "COMMON-LISP"),
    ("ALISTP" , "U" , "ACL2"),
    ("ALISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("ALL-BOUNDP" , "U" , "ACL2"),
    ("ALL-BOUNDP-PRESERVES-ASSOC" , "U" , "ACL2"),
    ("ALL-VARS" , "U" , "ACL2"),
    ("ALL-VARS1" , "U" , "ACL2"),
    ("ALL-VARS1-LST" , "U" , "ACL2"),
    ("ALLOCATE-INSTANCE" , "U" , "COMMON-LISP"),
    ("ALPHA-CHAR-P" , "U" , "COMMON-LISP"),
    ("ALPHA-CHAR-P-FORWARD-TO-CHARACTERP" , "U" , "ACL2"),
    ("ALPHANUMERICP" , "U" , "COMMON-LISP"),
    ("AND" , "U" , "COMMON-LISP"),
    ("AND-MACRO" , "U" , "ACL2"),
    ("APPEND" , "U" , "COMMON-LISP"),
    ("APPLY" , "U" , "COMMON-LISP"),
    ("APROPOS" , "U" , "COMMON-LISP"),
    ("APROPOS-LIST" , "U" , "COMMON-LISP"),
    ("AREF" , "U" , "COMMON-LISP"),
    ("AREF-32-BIT-INTEGER-STACK" , "U" , "ACL2"),
    ("AREF-T-STACK" , "U" , "ACL2"),
    ("AREF1" , "U" , "ACL2"),
    ("AREF2" , "U" , "ACL2"),
    ("ARGS" , "U" , "ACL2"),
    ("ARITHMETIC-ERROR" , "U" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERANDS" , "U" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERATION" , "U" , "COMMON-LISP"),
    ("ARRAY" , "U" , "COMMON-LISP"),
    ("ARRAY-DIMENSION" , "U" , "COMMON-LISP"),
    ("ARRAY-DIMENSION-LIMIT" , "U" , "COMMON-LISP"),
    ("ARRAY-DIMENSIONS" , "U" , "COMMON-LISP"),
    ("ARRAY-DISPLACEMENT" , "U" , "COMMON-LISP"),
    ("ARRAY-ELEMENT-TYPE" , "U" , "COMMON-LISP"),
    ("ARRAY-HAS-FILL-POINTER-P" , "U" , "COMMON-LISP"),
    ("ARRAY-IN-BOUNDS-P" , "U" , "COMMON-LISP"),
    ("ARRAY-RANK" , "U" , "COMMON-LISP"),
    ("ARRAY-RANK-LIMIT" , "U" , "COMMON-LISP"),
    ("ARRAY-ROW-MAJOR-INDEX" , "U" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE" , "U" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE-LIMIT" , "U" , "COMMON-LISP"),
    ("ARRAY1P" , "U" , "ACL2"),
    ("ARRAY1P-CONS" , "U" , "ACL2"),
    ("ARRAY1P-FORWARD" , "U" , "ACL2"),
    ("ARRAY1P-LINEAR" , "U" , "ACL2"),
    ("ARRAY2P" , "U" , "ACL2"),
    ("ARRAY2P-CONS" , "U" , "ACL2"),
    ("ARRAY2P-FORWARD" , "U" , "ACL2"),
    ("ARRAY2P-LINEAR" , "U" , "ACL2"),
    ("ARRAYP" , "U" , "COMMON-LISP"),
    ("ASET-32-BIT-INTEGER-STACK" , "U" , "ACL2"),
    ("ASET-T-STACK" , "U" , "ACL2"),
    ("ASET1" , "U" , "ACL2"),
    ("ASET2" , "U" , "ACL2"),
    ("ASH" , "U" , "COMMON-LISP"),
    ("ASIN" , "U" , "COMMON-LISP"),
    ("ASINH" , "U" , "COMMON-LISP"),
    ("ASSERT" , "U" , "COMMON-LISP"),
    ("ASSERT$" , "U" , "ACL2"),
    ("ASSIGN" , "U" , "ACL2"),
    ("ASSOC" , "U" , "COMMON-LISP"),
    ("ASSOC-ADD-PAIR" , "U" , "ACL2"),
    ("ASSOC-EQ" , "U" , "ACL2"),
    ("ASSOC-EQ-EQUAL" , "U" , "ACL2"),
    ("ASSOC-EQ-EQUAL-ALISTP" , "U" , "ACL2"),
    ("ASSOC-EQUAL" , "U" , "ACL2"),
    ("ASSOC-IF" , "U" , "COMMON-LISP"),
    ("ASSOC-IF-NOT" , "U" , "COMMON-LISP"),
    ("ASSOC-KEYWORD" , "U" , "ACL2"),
    ("ASSOC-STRING-EQUAL" , "U" , "ACL2"),
    ("ASSOC2" , "U" , "ACL2"),
    ("ASSOCIATIVITY-OF-*" , "U" , "ACL2"),
    ("ASSOCIATIVITY-OF-+" , "U" , "ACL2"),
    ("ASSUME" , "U" , "ACL2"),
    ("ATAN" , "U" , "COMMON-LISP"),
    ("ATANH" , "U" , "COMMON-LISP"),
    ("ATOM" , "U" , "COMMON-LISP"),
    ("ATOM-LISTP" , "U" , "ACL2"),
    ("ATOM-LISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("BASE-CHAR" , "U" , "COMMON-LISP"),
    ("BASE-STRING" , "U" , "COMMON-LISP"),
    ("BIG-CLOCK-ENTRY" , "U" , "ACL2"),
    ("BIG-CLOCK-NEGATIVE-P" , "U" , "ACL2"),
    ("BIGNUM" , "U" , "COMMON-LISP"),
    ("BINARY-*" , "U" , "ACL2"),
    ("BINARY-+" , "U" , "ACL2"),
    ("BINARY-APPEND" , "U" , "ACL2"),
    ("BIND-FREE" , "U" , "ACL2"),
    ("BINOP-TABLE" , "U" , "ACL2"),
    ("BIT" , "U" , "COMMON-LISP"),
    ("BIT-AND" , "U" , "COMMON-LISP"),
    ("BIT-ANDC1" , "U" , "COMMON-LISP"),
    ("BIT-ANDC2" , "U" , "COMMON-LISP"),
    ("BIT-EQV" , "U" , "COMMON-LISP"),
    ("BIT-IOR" , "U" , "COMMON-LISP"),
    ("BIT-NAND" , "U" , "COMMON-LISP"),
    ("BIT-NOR" , "U" , "COMMON-LISP"),
    ("BIT-NOT" , "U" , "COMMON-LISP"),
    ("BIT-ORC1" , "U" , "COMMON-LISP"),
    ("BIT-ORC2" , "U" , "COMMON-LISP"),
    ("BIT-VECTOR" , "U" , "COMMON-LISP"),
    ("BIT-VECTOR-P" , "U" , "COMMON-LISP"),
    ("BIT-XOR" , "U" , "COMMON-LISP"),
    ("BLOCK" , "U" , "COMMON-LISP"),
    ("BOOLE" , "U" , "COMMON-LISP"),
    ("BOOLE-1" , "U" , "COMMON-LISP"),
    ("BOOLE-2" , "U" , "COMMON-LISP"),
    ("BOOLE-AND" , "U" , "COMMON-LISP"),
    ("BOOLE-ANDC1" , "U" , "COMMON-LISP"),
    ("BOOLE-ANDC2" , "U" , "COMMON-LISP"),
    ("BOOLE-C1" , "U" , "COMMON-LISP"),
    ("BOOLE-C2" , "U" , "COMMON-LISP"),
    ("BOOLE-CLR" , "U" , "COMMON-LISP"),
    ("BOOLE-EQV" , "U" , "COMMON-LISP"),
    ("BOOLE-IOR" , "U" , "COMMON-LISP"),
    ("BOOLE-NAND" , "U" , "COMMON-LISP"),
    ("BOOLE-NOR" , "U" , "COMMON-LISP"),
    ("BOOLE-ORC1" , "U" , "COMMON-LISP"),
    ("BOOLE-ORC2" , "U" , "COMMON-LISP"),
    ("BOOLE-SET" , "U" , "COMMON-LISP"),
    ("BOOLE-XOR" , "U" , "COMMON-LISP"),
    ("BOOLEAN" , "U" , "COMMON-LISP"),
    ("BOOLEAN-LISTP" , "U" , "ACL2"),
    ("BOOLEAN-LISTP-CONS" , "U" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD" , "U" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD-TO-SYMBOL-LISTP" , "U" , "ACL2"),
    ("BOOLEANP" , "U" , "ACL2"),
    ("BOOLEANP-CHARACTERP" , "U" , "ACL2"),
    ("BOOLEANP-COMPOUND-RECOGNIZER" , "U" , "ACL2"),
    ("BOTH-CASE-P" , "U" , "COMMON-LISP"),
    ("BOUNDED-INTEGER-ALISTP" , "U" , "ACL2"),
    ("BOUNDED-INTEGER-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "U" , "ACL2"),
    ("BOUNDED-INTEGER-ALISTP2" , "U" , "ACL2"),
    ("BOUNDP" , "U" , "COMMON-LISP"),
    ("BOUNDP-GLOBAL" , "U" , "ACL2"),
    ("BOUNDP-GLOBAL1" , "U" , "ACL2"),
    ("BREAK" , "U" , "COMMON-LISP"),
    ("BROADCAST-STREAM" , "U" , "COMMON-LISP"),
    ("BROADCAST-STREAM-STREAMS" , "U" , "COMMON-LISP"),
    ("BRR" , "U" , "ACL2"),
    ("BRR@" , "U" , "ACL2"),
    ("BUILD-STATE1" , "U" , "ACL2"),
    ("BUILT-IN-CLASS" , "U" , "COMMON-LISP"),
    ("BUTLAST" , "U" , "COMMON-LISP"),
    ("BYTE" , "U" , "COMMON-LISP"),
    ("BYTE-POSITION" , "U" , "COMMON-LISP"),
    ("BYTE-SIZE" , "U" , "COMMON-LISP"),
    ("CAAAAR" , "U" , "COMMON-LISP"),
    ("CAAADR" , "U" , "COMMON-LISP"),
    ("CAAAR" , "U" , "COMMON-LISP"),
    ("CAADAR" , "U" , "COMMON-LISP"),
    ("CAADDR" , "U" , "COMMON-LISP"),
    ("CAADR" , "U" , "COMMON-LISP"),
    ("CAAR" , "U" , "COMMON-LISP"),
    ("CADAAR" , "U" , "COMMON-LISP"),
    ("CADADR" , "U" , "COMMON-LISP"),
    ("CADAR" , "U" , "COMMON-LISP"),
    ("CADDAR" , "U" , "COMMON-LISP"),
    ("CADDDR" , "U" , "COMMON-LISP"),
    ("CADDR" , "U" , "COMMON-LISP"),
    ("CADR" , "U" , "COMMON-LISP"),
    ("CALL-ARGUMENTS-LIMIT" , "U" , "COMMON-LISP"),
    ("CALL-METHOD" , "U" , "COMMON-LISP"),
    ("CALL-NEXT-METHOD" , "U" , "COMMON-LISP"),
    ("CAR" , "U" , "COMMON-LISP"),
    ("CAR-CDR-ELIM" , "U" , "ACL2"),
    ("CAR-CONS" , "U" , "ACL2"),
    ("CASE" , "U" , "COMMON-LISP"),
    ("CASE-LIST" , "U" , "ACL2"),
    ("CASE-LIST-CHECK" , "U" , "ACL2"),
    ("CASE-MATCH" , "U" , "ACL2"),
    ("CASE-SPLIT" , "U" , "ACL2"),
    ("CASE-TEST" , "U" , "ACL2"),
    ("CATCH" , "U" , "COMMON-LISP"),
    ("CBD" , "U" , "ACL2"),
    ("CCASE" , "U" , "COMMON-LISP"),
    ("CDAAAR" , "U" , "COMMON-LISP"),
    ("CDAADR" , "U" , "COMMON-LISP"),
    ("CDAAR" , "U" , "COMMON-LISP"),
    ("CDADAR" , "U" , "COMMON-LISP"),
    ("CDADDR" , "U" , "COMMON-LISP"),
    ("CDADR" , "U" , "COMMON-LISP"),
    ("CDAR" , "U" , "COMMON-LISP"),
    ("CDDAAR" , "U" , "COMMON-LISP"),
    ("CDDADR" , "U" , "COMMON-LISP"),
    ("CDDAR" , "U" , "COMMON-LISP"),
    ("CDDDAR" , "U" , "COMMON-LISP"),
    ("CDDDDR" , "U" , "COMMON-LISP"),
    ("CDDDR" , "U" , "COMMON-LISP"),
    ("CDDR" , "U" , "COMMON-LISP"),
    ("CDR" , "U" , "COMMON-LISP"),
    ("CDR-CONS" , "U" , "ACL2"),
    ("CDRN" , "U" , "ACL2"),
    ("CEILING" , "U" , "COMMON-LISP"),
    ("CELL-ERROR" , "U" , "COMMON-LISP"),
    ("CELL-ERROR-NAME" , "U" , "COMMON-LISP"),
    ("CERROR" , "U" , "COMMON-LISP"),
    ("CERTIFY-BOOK" , "U" , "ACL2"),
    ("CERTIFY-BOOK!" , "U" , "ACL2"),
    ("CHANGE-CLASS" , "U" , "COMMON-LISP"),
    ("CHAR" , "U" , "COMMON-LISP"),
    ("CHAR-CODE" , "U" , "COMMON-LISP"),
    ("CHAR-CODE-CODE-CHAR-IS-IDENTITY" , "U" , "ACL2"),
    ("CHAR-CODE-LIMIT" , "U" , "COMMON-LISP"),
    ("CHAR-CODE-LINEAR" , "U" , "ACL2"),
    ("CHAR-DOWNCASE" , "U" , "COMMON-LISP"),
    ("CHAR-EQUAL" , "U" , "COMMON-LISP"),
    ("CHAR-GREATERP" , "U" , "COMMON-LISP"),
    ("CHAR-INT" , "U" , "COMMON-LISP"),
    ("CHAR-LESSP" , "U" , "COMMON-LISP"),
    ("CHAR-NAME" , "U" , "COMMON-LISP"),
    ("CHAR-NOT-EQUAL" , "U" , "COMMON-LISP"),
    ("CHAR-NOT-GREATERP" , "U" , "COMMON-LISP"),
    ("CHAR-NOT-LESSP" , "U" , "COMMON-LISP"),
    ("CHAR-UPCASE" , "U" , "COMMON-LISP"),
    ("CHAR/=" , "U" , "COMMON-LISP"),
    ("CHAR<" , "U" , "COMMON-LISP"),
    ("CHAR<=" , "U" , "COMMON-LISP"),
    ("CHAR=" , "U" , "COMMON-LISP"),
    ("CHAR>" , "U" , "COMMON-LISP"),
    ("CHAR>=" , "U" , "COMMON-LISP"),
    ("CHARACTER" , "U" , "COMMON-LISP"),
    ("CHARACTER-LISTP" , "U" , "ACL2"),
    ("CHARACTER-LISTP-APPEND" , "U" , "ACL2"),
    ("CHARACTER-LISTP-COERCE" , "U" , "ACL2"),
    ("CHARACTER-LISTP-FORWARD-TO-EQLABLE-LISTP" , "U" , "ACL2"),
    ("CHARACTER-LISTP-REMOVE-DUPLICATES-EQL" , "U" , "ACL2"),
    ("CHARACTER-LISTP-REVAPPEND" , "U" , "ACL2"),
    ("CHARACTER-LISTP-STRING-DOWNCASE-1" , "U" , "ACL2"),
    ("CHARACTER-LISTP-STRING-UPCASE1-1" , "U" , "ACL2"),
    ("CHARACTERP" , "U" , "COMMON-LISP"),
    ("CHARACTERP-CHAR-DOWNCASE" , "U" , "ACL2"),
    ("CHARACTERP-CHAR-UPCASE" , "U" , "ACL2"),
    ("CHARACTERP-NTH" , "U" , "ACL2"),
    ("CHARACTERP-PAGE" , "U" , "ACL2"),
    ("CHARACTERP-RUBOUT" , "U" , "ACL2"),
    ("CHARACTERP-TAB" , "U" , "ACL2"),
    ("CHECK-TYPE" , "U" , "COMMON-LISP"),
    ("CHECK-VARS-NOT-FREE" , "U" , "ACL2"),
    ("CHECKPOINT-FORCED-GOALS" , "U" , "ACL2"),
    ("CIS" , "U" , "COMMON-LISP"),
    ("CLASS" , "U" , "COMMON-LISP"),
    ("CLASS-NAME" , "U" , "COMMON-LISP"),
    ("CLASS-OF" , "U" , "COMMON-LISP"),
    ("CLAUSE" , "U" , "ACL2"),
    ("CLEAR-HASH-TABLES" , "U" , "ACL2"),
    ("CLEAR-INPUT" , "U" , "COMMON-LISP"),
    ("CLEAR-MEMOIZE-TABLE" , "U" , "ACL2"),
    ("CLEAR-MEMOIZE-TABLES" , "U" , "ACL2"),
    ("CLEAR-OUTPUT" , "U" , "COMMON-LISP"),
    ("CLOSE" , "U" , "COMMON-LISP"),
    ("CLOSE-INPUT-CHANNEL" , "U" , "ACL2"),
    ("CLOSE-OUTPUT-CHANNEL" , "U" , "ACL2"),
    ("CLOSE-TRACE-FILE" , "U" , "ACL2"),
    ("CLOSURE" , "U" , "ACL2"),
    ("CLRHASH" , "U" , "COMMON-LISP"),
    ("CODE-CHAR" , "U" , "COMMON-LISP"),
    ("CODE-CHAR-CHAR-CODE-IS-IDENTITY" , "U" , "ACL2"),
    ("CODE-CHAR-TYPE" , "U" , "ACL2"),
    ("COERCE" , "U" , "COMMON-LISP"),
    ("COERCE-INVERSE-1" , "U" , "ACL2"),
    ("COERCE-INVERSE-2" , "U" , "ACL2"),
    ("COERCE-OBJECT-TO-STATE" , "U" , "ACL2"),
    ("COERCE-STATE-TO-OBJECT" , "U" , "ACL2"),
    ("COMMUTATIVITY-OF-*" , "U" , "ACL2"),
    ("COMMUTATIVITY-OF-+" , "U" , "ACL2"),
    ("COMP" , "U" , "ACL2"),
    ("COMPILATION-SPEED" , "U" , "COMMON-LISP"),
    ("COMPILE" , "U" , "COMMON-LISP"),
    ("COMPILE-FILE" , "U" , "COMMON-LISP"),
    ("COMPILE-FILE-PATHNAME" , "U" , "COMMON-LISP"),
    ("COMPILED-FUNCTION" , "U" , "COMMON-LISP"),
    ("COMPILED-FUNCTION-P" , "U" , "COMMON-LISP"),
    ("COMPILER-MACRO" , "U" , "COMMON-LISP"),
    ("COMPILER-MACRO-FUNCTION" , "U" , "COMMON-LISP"),
    ("COMPLEMENT" , "U" , "COMMON-LISP"),
    ("COMPLETION-OF-*" , "U" , "ACL2"),
    ("COMPLETION-OF-+" , "U" , "ACL2"),
    ("COMPLETION-OF-<" , "U" , "ACL2"),
    ("COMPLETION-OF-CAR" , "U" , "ACL2"),
    ("COMPLETION-OF-CDR" , "U" , "ACL2"),
    ("COMPLETION-OF-CHAR-CODE" , "U" , "ACL2"),
    ("COMPLETION-OF-CODE-CHAR" , "U" , "ACL2"),
    ("COMPLETION-OF-COERCE" , "U" , "ACL2"),
    ("COMPLETION-OF-COMPLEX" , "U" , "ACL2"),
    ("COMPLETION-OF-DENOMINATOR" , "U" , "ACL2"),
    ("COMPLETION-OF-IMAGPART" , "U" , "ACL2"),
    ("COMPLETION-OF-INTERN-IN-PACKAGE-OF-SYMBOL" , "U" , "ACL2"),
    ("COMPLETION-OF-NUMERATOR" , "U" , "ACL2"),
    ("COMPLETION-OF-REALPART" , "U" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-NAME" , "U" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-PACKAGE-NAME" , "U" , "ACL2"),
    ("COMPLETION-OF-UNARY-/" , "U" , "ACL2"),
    ("COMPLETION-OF-UNARY-MINUS" , "U" , "ACL2"),
    ("COMPLEX" , "U" , "COMMON-LISP"),
    ("COMPLEX-0" , "U" , "ACL2"),
    ("COMPLEX-DEFINITION" , "U" , "ACL2"),
    ("COMPLEX-EQUAL" , "U" , "ACL2"),
    ("COMPLEX-IMPLIES1" , "U" , "ACL2"),
    ("COMPLEX-RATIONALP" , "U" , "ACL2"),
    ("COMPLEXP" , "U" , "COMMON-LISP"),
    ("COMPRESS1" , "U" , "ACL2"),
    ("COMPRESS11" , "U" , "ACL2"),
    ("COMPRESS2" , "U" , "ACL2"),
    ("COMPRESS21" , "U" , "ACL2"),
    ("COMPRESS211" , "U" , "ACL2"),
    ("COMPUTE-APPLICABLE-METHODS" , "U" , "COMMON-LISP"),
    ("COMPUTE-RESTARTS" , "U" , "COMMON-LISP"),
    ("CONCATENATE" , "U" , "COMMON-LISP"),
    ("CONCATENATED-STREAM" , "U" , "COMMON-LISP"),
    ("CONCATENATED-STREAM-STREAMS" , "U" , "COMMON-LISP"),
    ("COND" , "U" , "COMMON-LISP"),
    ("COND-CLAUSESP" , "U" , "ACL2"),
    ("COND-MACRO" , "U" , "ACL2"),
    ("CONDITION" , "U" , "COMMON-LISP"),
    ("CONJUGATE" , "U" , "COMMON-LISP"),
    ("CONS" , "U" , "COMMON-LISP"),
    ("CONS-EQUAL" , "U" , "ACL2"),
    ("CONS-SUBTREES" , "U" , "ACL2"),
    ("CONSP" , "U" , "COMMON-LISP"),
    ("CONSP-ASSOC" , "U" , "ACL2"),
    ("CONSP-ASSOC-EQ" , "U" , "ACL2"),
    ("CONSTANTLY" , "U" , "COMMON-LISP"),
    ("CONSTANTP" , "U" , "COMMON-LISP"),
    ("CONTINUE" , "U" , "COMMON-LISP"),
    ("CONTROL-ERROR" , "U" , "COMMON-LISP"),
    ("COPY-ALIST" , "U" , "COMMON-LISP"),
    ("COPY-LIST" , "U" , "COMMON-LISP"),
    ("COPY-PPRINT-DISPATCH" , "U" , "COMMON-LISP"),
    ("COPY-READTABLE" , "U" , "COMMON-LISP"),
    ("COPY-SEQ" , "U" , "COMMON-LISP"),
    ("COPY-STRUCTURE" , "U" , "COMMON-LISP"),
    ("COPY-SYMBOL" , "U" , "COMMON-LISP"),
    ("COPY-TREE" , "U" , "COMMON-LISP"),
    ("COS" , "U" , "COMMON-LISP"),
    ("COSH" , "U" , "COMMON-LISP"),
    ("COUNT" , "U" , "COMMON-LISP"),
    ("COUNT-IF" , "U" , "COMMON-LISP"),
    ("COUNT-IF-NOT" , "U" , "COMMON-LISP"),
    ("CTYPECASE" , "U" , "COMMON-LISP"),
    ("CURRENT-PACKAGE" , "U" , "ACL2"),
    ("CURRENT-THEORY" , "U" , "ACL2"),
    ("CW" , "U" , "ACL2"),
    ("CW-GSTACK" , "U" , "ACL2"),
    ("DEBUG" , "U" , "COMMON-LISP"),
    ("DECF" , "U" , "COMMON-LISP"),
    ("DECLAIM" , "U" , "COMMON-LISP"),
    ("DECLARATION" , "U" , "COMMON-LISP"),
    ("DECLARE" , "U" , "COMMON-LISP"),
    ("DECODE-FLOAT" , "U" , "COMMON-LISP"),
    ("DECODE-UNIVERSAL-TIME" , "U" , "COMMON-LISP"),
    ("DECREMENT-BIG-CLOCK" , "U" , "ACL2"),
    ("DEFABBREV" , "U" , "ACL2"),
    ("DEFAULT" , "U" , "ACL2"),
    ("DEFAULT-*-1" , "U" , "ACL2"),
    ("DEFAULT-*-2" , "U" , "ACL2"),
    ("DEFAULT-+-1" , "U" , "ACL2"),
    ("DEFAULT-+-2" , "U" , "ACL2"),
    ("DEFAULT-<-1" , "U" , "ACL2"),
    ("DEFAULT-<-2" , "U" , "ACL2"),
    ("DEFAULT-CAR" , "U" , "ACL2"),
    ("DEFAULT-CDR" , "U" , "ACL2"),
    ("DEFAULT-CHAR-CODE" , "U" , "ACL2"),
    ("DEFAULT-COERCE-1" , "U" , "ACL2"),
    ("DEFAULT-COERCE-2" , "U" , "ACL2"),
    ("DEFAULT-COERCE-3" , "U" , "ACL2"),
    ("DEFAULT-COMPILE-FNS" , "U" , "ACL2"),
    ("DEFAULT-COMPLEX-1" , "U" , "ACL2"),
    ("DEFAULT-COMPLEX-2" , "U" , "ACL2"),
    ("DEFAULT-DEFUN-MODE" , "U" , "ACL2"),
    ("DEFAULT-DEFUN-MODE-FROM-STATE" , "U" , "ACL2"),
    ("DEFAULT-DENOMINATOR" , "U" , "ACL2"),
    ("DEFAULT-IMAGPART" , "U" , "ACL2"),
    ("DEFAULT-MEASURE-FUNCTION" , "U" , "ACL2"),
    ("DEFAULT-NUMERATOR" , "U" , "ACL2"),
    ("DEFAULT-REALPART" , "U" , "ACL2"),
    ("DEFAULT-SYMBOL-NAME" , "U" , "ACL2"),
    ("DEFAULT-SYMBOL-PACKAGE-NAME" , "U" , "ACL2"),
    ("DEFAULT-UNARY-/" , "U" , "ACL2"),
    ("DEFAULT-UNARY-MINUS" , "U" , "ACL2"),
    ("DEFAULT-VERIFY-GUARDS-EAGERNESS" , "U" , "ACL2"),
    ("DEFAULT-WELL-FOUNDED-RELATION" , "U" , "ACL2"),
    ("DEFAXIOM" , "U" , "ACL2"),
    ("DEFCHOOSE" , "U" , "ACL2"),
    ("DEFCLASS" , "U" , "COMMON-LISP"),
    ("DEFCONG" , "U" , "ACL2"),
    ("DEFCONST" , "U" , "ACL2"),
    ("DEFCONSTANT" , "U" , "COMMON-LISP"),
    ("DEFDOC" , "U" , "ACL2"),
    ("DEFEQUIV" , "U" , "ACL2"),
    ("DEFEVALUATOR" , "U" , "ACL2"),
    ("DEFEXEC" , "U" , "ACL2"),
    ("DEFGENERIC" , "U" , "COMMON-LISP"),
    ("DEFINE-COMPILER-MACRO" , "U" , "COMMON-LISP"),
    ("DEFINE-CONDITION" , "U" , "COMMON-LISP"),
    ("DEFINE-METHOD-COMBINATION" , "U" , "COMMON-LISP"),
    ("DEFINE-MODIFY-MACRO" , "U" , "COMMON-LISP"),
    ("DEFINE-PC-ATOMIC-MACRO" , "U" , "ACL2"),
    ("DEFINE-PC-HELP" , "U" , "ACL2"),
    ("DEFINE-PC-MACRO" , "U" , "ACL2"),
    ("DEFINE-SETF-EXPANDER" , "U" , "COMMON-LISP"),
    ("DEFINE-SYMBOL-MACRO" , "U" , "COMMON-LISP"),
    ("DEFLABEL" , "U" , "ACL2"),
    ("DEFMACRO" , "U" , "COMMON-LISP"),
    ("DEFMETHOD" , "U" , "COMMON-LISP"),
    ("DEFPACKAGE" , "U" , "COMMON-LISP"),
    ("DEFPARAMETER" , "U" , "COMMON-LISP"),
    ("DEFPKG" , "U" , "ACL2"),
    ("DEFREFINEMENT" , "U" , "ACL2"),
    ("DEFSETF" , "U" , "COMMON-LISP"),
    ("DEFSTOBJ" , "U" , "ACL2"),
    ("DEFSTRUCT" , "U" , "COMMON-LISP"),
    ("DEFSTUB" , "U" , "ACL2"),
    ("DEFTHEORY" , "U" , "ACL2"),
    ("DEFTHM" , "U" , "ACL2"),
    ("DEFTHMD" , "U" , "ACL2"),
    ("DEFTTAG" , "U" , "ACL2"),
    ("DEFTYPE" , "U" , "COMMON-LISP"),
    ("DEFUN" , "U" , "COMMON-LISP"),
    ("DEFUN-NX" , "U" , "ACL2"),
    ("DEFUN-SK" , "U" , "ACL2"),
    ("DEFUND" , "U" , "ACL2"),
    ("DEFUND-NX" , "U" , "ACL2"),
    ("DEFUNS" , "U" , "ACL2"),
    ("DEFVAR" , "U" , "COMMON-LISP"),
    ("DELETE" , "U" , "COMMON-LISP"),
    ("DELETE-DUPLICATES" , "U" , "COMMON-LISP"),
    ("DELETE-FILE" , "U" , "COMMON-LISP"),
    ("DELETE-IF" , "U" , "COMMON-LISP"),
    ("DELETE-IF-NOT" , "U" , "COMMON-LISP"),
    ("DELETE-PACKAGE" , "U" , "COMMON-LISP"),
    ("DELETE-PAIR" , "U" , "ACL2"),
    ("DENOMINATOR" , "U" , "COMMON-LISP"),
    ("DEPOSIT-FIELD" , "U" , "COMMON-LISP"),
    ("DESCRIBE" , "U" , "COMMON-LISP"),
    ("DESCRIBE-OBJECT" , "U" , "COMMON-LISP"),
    ("DESTRUCTURING-BIND" , "U" , "COMMON-LISP"),
    ("DIGIT-CHAR" , "U" , "COMMON-LISP"),
    ("DIGIT-CHAR-P" , "U" , "COMMON-LISP"),
    ("DIGIT-TO-CHAR" , "U" , "ACL2"),
    ("DIMENSIONS" , "U" , "ACL2"),
    ("DIRECTORY" , "U" , "COMMON-LISP"),
    ("DIRECTORY-NAMESTRING" , "U" , "COMMON-LISP"),
    ("DISABLE" , "U" , "ACL2"),
    ("DISABLE-FORCING" , "U" , "ACL2"),
    ("DISABLEDP" , "U" , "ACL2"),
    ("DISASSEMBLE" , "U" , "COMMON-LISP"),
    ("DISTRIBUTIVITY" , "U" , "ACL2"),
    ("DIVISION-BY-ZERO" , "U" , "COMMON-LISP"),
    ("DO" , "U" , "COMMON-LISP"),
    ("DO*" , "U" , "COMMON-LISP"),
    ("DO-ALL-SYMBOLS" , "U" , "COMMON-LISP"),
    ("DO-EXTERNAL-SYMBOLS" , "U" , "COMMON-LISP"),
    ("DO-SYMBOLS" , "U" , "COMMON-LISP"),
    ("DOC" , "U" , "ACL2"),
    ("DOC!" , "U" , "ACL2"),
    ("DOCS" , "U" , "ACL2"),
    ("DOCUMENTATION" , "U" , "COMMON-LISP"),
    ("DOLIST" , "U" , "COMMON-LISP"),
    ("DOTIMES" , "U" , "COMMON-LISP"),
    ("DOUBLE-FLOAT" , "U" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-EPSILON" , "U" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-NEGATIVE-EPSILON" , "U" , "COMMON-LISP"),
    ("DOUBLE-REWRITE" , "U" , "ACL2"),
    ("DPB" , "U" , "COMMON-LISP"),
    ("DRIBBLE" , "U" , "COMMON-LISP"),
    ("DUPLICATES" , "U" , "ACL2"),
    ("DYNAMIC-EXTENT" , "U" , "COMMON-LISP"),
    ("E/D" , "U" , "ACL2"),
    ("E0-ORD-<" , "U" , "ACL2"),
    ("E0-ORDINALP" , "U" , "ACL2"),
    ("EC-CALL" , "U" , "ACL2"),
    ("ECASE" , "U" , "COMMON-LISP"),
    ("ECHO-STREAM" , "U" , "COMMON-LISP"),
    ("ECHO-STREAM-INPUT-STREAM" , "U" , "COMMON-LISP"),
    ("ECHO-STREAM-OUTPUT-STREAM" , "U" , "COMMON-LISP"),
    ("ED" , "U" , "COMMON-LISP"),
    ("EIGHTH" , "U" , "COMMON-LISP"),
    ("ELIMINATE-DESTRUCTORS" , "U" , "ACL2"),
    ("ELIMINATE-IRRELEVANCE" , "U" , "ACL2"),
    ("ELT" , "U" , "COMMON-LISP"),
    ("ENABLE" , "U" , "ACL2"),
    ("ENABLE-FORCING" , "U" , "ACL2"),
    ("ENCAPSULATE" , "U" , "ACL2"),
    ("ENCODE-UNIVERSAL-TIME" , "U" , "COMMON-LISP"),
    ("END-OF-FILE" , "U" , "COMMON-LISP"),
    ("ENDP" , "U" , "COMMON-LISP"),
    ("ENOUGH-NAMESTRING" , "U" , "COMMON-LISP"),
    ("ENSURE-DIRECTORIES-EXIST" , "U" , "COMMON-LISP"),
    ("ENSURE-GENERIC-FUNCTION" , "U" , "COMMON-LISP"),
    ("EQ" , "U" , "COMMON-LISP"),
    ("EQL" , "U" , "COMMON-LISP"),
    ("EQLABLE-ALISTP" , "U" , "ACL2"),
    ("EQLABLE-ALISTP-FORWARD-TO-ALISTP" , "U" , "ACL2"),
    ("EQLABLE-LISTP" , "U" , "ACL2"),
    ("EQLABLE-LISTP-FORWARD-TO-ATOM-LISTP" , "U" , "ACL2"),
    ("EQLABLEP" , "U" , "ACL2"),
    ("EQLABLEP-RECOG" , "U" , "ACL2"),
    ("EQUAL" , "U" , "COMMON-LISP"),
    ("EQUAL-CHAR-CODE" , "U" , "ACL2"),
    ("EQUALP" , "U" , "COMMON-LISP"),
    ("ER" , "U" , "ACL2"),
    ("ER-PROGN" , "U" , "ACL2"),
    ("ER-PROGN-FN" , "U" , "ACL2"),
    ("ERROR" , "U" , "COMMON-LISP"),
    ("ETYPECASE" , "U" , "COMMON-LISP"),
    ("EVAL" , "U" , "COMMON-LISP"),
    ("EVAL-WHEN" , "U" , "COMMON-LISP"),
    ("EVENP" , "U" , "COMMON-LISP"),
    ("EVENS" , "U" , "ACL2"),
    ("EVENT" , "U" , "ACL2"),
    ("EVERY" , "U" , "COMMON-LISP"),
    ("EXECUTABLE-COUNTERPART-THEORY" , "U" , "ACL2"),
    ("EXP" , "U" , "COMMON-LISP"),
    ("EXPLODE-ATOM" , "U" , "ACL2"),
    ("EXPLODE-NONNEGATIVE-INTEGER" , "U" , "ACL2"),
    ("EXPORT" , "U" , "COMMON-LISP"),
    ("EXPT" , "U" , "COMMON-LISP"),
    ("EXPT-TYPE-PRESCRIPTION-NON-ZERO-BASE" , "U" , "ACL2"),
    ("EXTEND-32-BIT-INTEGER-STACK" , "U" , "ACL2"),
    ("EXTEND-T-STACK" , "U" , "ACL2"),
    ("EXTEND-WORLD" , "U" , "ACL2"),
    ("EXTENDED-CHAR" , "U" , "COMMON-LISP"),
    ("EXTRA-INFO" , "U" , "ACL2"),
    ("FAST-ALIST-FREE" , "U" , "ACL2"),
    ("FAST-ALIST-LEN" , "U" , "ACL2"),
    ("FAST-ALIST-SUMMARY" , "U" , "ACL2"),
    ("FBOUNDP" , "U" , "COMMON-LISP"),
    ("FCEILING" , "U" , "COMMON-LISP"),
    ("FDEFINITION" , "U" , "COMMON-LISP"),
    ("FERTILIZE" , "U" , "ACL2"),
    ("FFLOOR" , "U" , "COMMON-LISP"),
    ("FGETPROP" , "U" , "ACL2"),
    ("FIFTH" , "U" , "COMMON-LISP"),
    ("FILE-AUTHOR" , "U" , "COMMON-LISP"),
    ("FILE-CLOCK" , "U" , "ACL2"),
    ("FILE-CLOCK-P" , "U" , "ACL2"),
    ("FILE-CLOCK-P-FORWARD-TO-INTEGERP" , "U" , "ACL2"),
    ("FILE-ERROR" , "U" , "COMMON-LISP"),
    ("FILE-ERROR-PATHNAME" , "U" , "COMMON-LISP"),
    ("FILE-LENGTH" , "U" , "COMMON-LISP"),
    ("FILE-NAMESTRING" , "U" , "COMMON-LISP"),
    ("FILE-POSITION" , "U" , "COMMON-LISP"),
    ("FILE-STREAM" , "U" , "COMMON-LISP"),
    ("FILE-STRING-LENGTH" , "U" , "COMMON-LISP"),
    ("FILE-WRITE-DATE" , "U" , "COMMON-LISP"),
    ("FILL" , "U" , "COMMON-LISP"),
    ("FILL-POINTER" , "U" , "COMMON-LISP"),
    ("FIND" , "U" , "COMMON-LISP"),
    ("FIND-ALL-SYMBOLS" , "U" , "COMMON-LISP"),
    ("FIND-CLASS" , "U" , "COMMON-LISP"),
    ("FIND-IF" , "U" , "COMMON-LISP"),
    ("FIND-IF-NOT" , "U" , "COMMON-LISP"),
    ("FIND-METHOD" , "U" , "COMMON-LISP"),
    ("FIND-PACKAGE" , "U" , "COMMON-LISP"),
    ("FIND-RESTART" , "U" , "COMMON-LISP"),
    ("FIND-SYMBOL" , "U" , "COMMON-LISP"),
    ("FINISH-OUTPUT" , "U" , "COMMON-LISP"),
    ("FIRST" , "U" , "COMMON-LISP"),
    ("FIRST-N-AC" , "U" , "ACL2"),
    ("FIX" , "U" , "ACL2"),
    ("FIX-TRUE-LIST" , "U" , "ACL2"),
    ("FIXNUM" , "U" , "COMMON-LISP"),
    ("FLET" , "U" , "COMMON-LISP"),
    ("FLOAT" , "U" , "COMMON-LISP"),
    ("FLOAT-DIGITS" , "U" , "COMMON-LISP"),
    ("FLOAT-PRECISION" , "U" , "COMMON-LISP"),
    ("FLOAT-RADIX" , "U" , "COMMON-LISP"),
    ("FLOAT-SIGN" , "U" , "COMMON-LISP"),
    ("FLOATING-POINT-INEXACT" , "U" , "COMMON-LISP"),
    ("FLOATING-POINT-INVALID-OPERATION" , "U" , "COMMON-LISP"),
    ("FLOATING-POINT-OVERFLOW" , "U" , "COMMON-LISP"),
    ("FLOATING-POINT-UNDERFLOW" , "U" , "COMMON-LISP"),
    ("FLOATP" , "U" , "COMMON-LISP"),
    ("FLOOR" , "U" , "COMMON-LISP"),
    ("FLUSH-HONS-GET-HASH-TABLE-LINK" , "U" , "ACL2"),
    ("FMAKUNBOUND" , "U" , "COMMON-LISP"),
    ("FMS" , "U" , "ACL2"),
    ("FMT" , "U" , "ACL2"),
    ("FMT-TO-COMMENT-WINDOW" , "U" , "ACL2"),
    ("FMT1" , "U" , "ACL2"),
    ("FORCE" , "U" , "ACL2"),
    ("FORCE-OUTPUT" , "U" , "COMMON-LISP"),
    ("FORMAT" , "U" , "COMMON-LISP"),
    ("FORMATTER" , "U" , "COMMON-LISP"),
    ("FOURTH" , "U" , "COMMON-LISP"),
    ("FRESH-LINE" , "U" , "COMMON-LISP"),
    ("FROUND" , "U" , "COMMON-LISP"),
    ("FTRUNCATE" , "U" , "COMMON-LISP"),
    ("FTYPE" , "U" , "COMMON-LISP"),
    ("FUNCALL" , "U" , "COMMON-LISP"),
    ("FUNCTION" , "U" , "COMMON-LISP"),
    ("FUNCTION-KEYWORDS" , "U" , "COMMON-LISP"),
    ("FUNCTION-LAMBDA-EXPRESSION" , "U" , "COMMON-LISP"),
    ("FUNCTION-SYMBOLP" , "U" , "ACL2"),
    ("FUNCTION-THEORY" , "U" , "ACL2"),
    ("FUNCTIONP" , "U" , "COMMON-LISP"),
    ("GCD" , "U" , "COMMON-LISP"),
    ("GENERALIZE" , "U" , "ACL2"),
    ("GENERIC-FUNCTION" , "U" , "COMMON-LISP"),
    ("GENSYM" , "U" , "COMMON-LISP"),
    ("GENTEMP" , "U" , "COMMON-LISP"),
    ("GET" , "U" , "COMMON-LISP"),
    ("GET-DECODED-TIME" , "U" , "COMMON-LISP"),
    ("GET-DISPATCH-MACRO-CHARACTER" , "U" , "COMMON-LISP"),
    ("GET-GLOBAL" , "U" , "ACL2"),
    ("GET-INTERNAL-REAL-TIME" , "U" , "COMMON-LISP"),
    ("GET-INTERNAL-RUN-TIME" , "U" , "COMMON-LISP"),
    ("GET-MACRO-CHARACTER" , "U" , "COMMON-LISP"),
    ("GET-OUTPUT-STREAM-STRING" , "U" , "COMMON-LISP"),
    ("GET-PROPERTIES" , "U" , "COMMON-LISP"),
    ("GET-SETF-EXPANSION" , "U" , "COMMON-LISP"),
    ("GET-SLOW-ALIST-ACTION" , "U" , "ACL2"),
    ("GET-TIMER" , "U" , "ACL2"),
    ("GET-UNIVERSAL-TIME" , "U" , "COMMON-LISP"),
    ("GETF" , "U" , "COMMON-LISP"),
    ("GETHASH" , "U" , "COMMON-LISP"),
    ("GETPROP-DEFAULT" , "U" , "ACL2"),
    ("GETPROPS" , "U" , "ACL2"),
    ("GETPROPS1" , "U" , "ACL2"),
    ("GLOBAL-TABLE" , "U" , "ACL2"),
    ("GLOBAL-TABLE-CARS" , "U" , "ACL2"),
    ("GLOBAL-TABLE-CARS1" , "U" , "ACL2"),
    ("GLOBAL-VAL" , "U" , "ACL2"),
    ("GO" , "U" , "COMMON-LISP"),
    ("GOOD-BYE" , "U" , "ACL2"),
    ("GRANULARITY" , "U" , "ACL2"),
    ("GRAPHIC-CHAR-P" , "U" , "COMMON-LISP"),
    ("GROUND-ZERO" , "U" , "ACL2"),
    ("HANDLER-BIND" , "U" , "COMMON-LISP"),
    ("HANDLER-CASE" , "U" , "COMMON-LISP"),
    ("HARD-ERROR" , "U" , "ACL2"),
    ("HAS-PROPSP" , "U" , "ACL2"),
    ("HAS-PROPSP1" , "U" , "ACL2"),
    ("HASH-TABLE" , "U" , "COMMON-LISP"),
    ("HASH-TABLE-COUNT" , "U" , "COMMON-LISP"),
    ("HASH-TABLE-P" , "U" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-SIZE" , "U" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-THRESHOLD" , "U" , "COMMON-LISP"),
    ("HASH-TABLE-SIZE" , "U" , "COMMON-LISP"),
    ("HASH-TABLE-TEST" , "U" , "COMMON-LISP"),
    ("HEADER" , "U" , "ACL2"),
    ("HELP" , "U" , "ACL2"),
    ("HIDE" , "U" , "ACL2"),
    ("HONS" , "U" , "ACL2"),
    ("HONS-ACONS" , "U" , "ACL2"),
    ("HONS-ACONS!" , "U" , "ACL2"),
    ("HONS-CLEAR" , "U" , "ACL2"),
    ("HONS-COPY" , "U" , "ACL2"),
    ("HONS-EQUAL" , "U" , "ACL2"),
    ("HONS-EQUAL-LITE" , "U" , "ACL2"),
    ("HONS-GET" , "U" , "ACL2"),
    ("HONS-RESIZE" , "U" , "ACL2"),
    ("HONS-RESIZE-FN" , "U" , "ACL2"),
    ("HONS-SHRINK-ALIST" , "U" , "ACL2"),
    ("HONS-SHRINK-ALIST!" , "U" , "ACL2"),
    ("HONS-SUMMARY" , "U" , "ACL2"),
    ("HONS-WASH" , "U" , "ACL2"),
    ("HOST-NAMESTRING" , "U" , "COMMON-LISP"),
    ("I-AM-HERE" , "U" , "ACL2"),
    ("ID" , "U" , "ACL2"),
    ("IDATES" , "U" , "ACL2"),
    ("IDENTITY" , "U" , "COMMON-LISP"),
    ("IF" , "U" , "COMMON-LISP"),
    ("IF*" , "U" , "ACL2"),
    ("IFF" , "U" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-1" , "U" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-2" , "U" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-NOT" , "U" , "ACL2"),
    ("IFF-IS-AN-EQUIVALENCE" , "U" , "ACL2"),
    ("IFIX" , "U" , "ACL2"),
    ("IGNORABLE" , "U" , "COMMON-LISP"),
    ("IGNORE" , "U" , "COMMON-LISP"),
    ("IGNORE-ERRORS" , "U" , "COMMON-LISP"),
    ("ILLEGAL" , "U" , "ACL2"),
    ("IMAGPART" , "U" , "COMMON-LISP"),
    ("IMAGPART-COMPLEX" , "U" , "ACL2"),
    ("IMMEDIATE-FORCE-MODEP" , "U" , "ACL2"),
    ("IMPLIES" , "U" , "ACL2"),
    ("IMPORT" , "U" , "COMMON-LISP"),
    ("IMPROPER-CONSP" , "U" , "ACL2"),
    ("IN-ARITHMETIC-THEORY" , "U" , "ACL2"),
    ("IN-PACKAGE" , "U" , "COMMON-LISP"),
    ("IN-THEORY" , "U" , "ACL2"),
    ("INCF" , "U" , "COMMON-LISP"),
    ("INCLUDE-BOOK" , "U" , "ACL2"),
    ("INCOMPATIBLE" , "U" , "ACL2"),
    ("INCREMENT-TIMER" , "U" , "ACL2"),
    ("INDUCT" , "U" , "ACL2"),
    ("INITIALIZE-INSTANCE" , "U" , "COMMON-LISP"),
    ("INLINE" , "U" , "COMMON-LISP"),
    ("INPUT-STREAM-P" , "U" , "COMMON-LISP"),
    ("INSPECT" , "U" , "COMMON-LISP"),
    ("INT=" , "U" , "ACL2"),
    ("INTEGER" , "U" , "COMMON-LISP"),
    ("INTEGER-0" , "U" , "ACL2"),
    ("INTEGER-1" , "U" , "ACL2"),
    ("INTEGER-ABS" , "U" , "ACL2"),
    ("INTEGER-DECODE-FLOAT" , "U" , "COMMON-LISP"),
    ("INTEGER-IMPLIES-RATIONAL" , "U" , "ACL2"),
    ("INTEGER-LENGTH" , "U" , "COMMON-LISP"),
    ("INTEGER-LISTP" , "U" , "ACL2"),
    ("INTEGER-LISTP-FORWARD-TO-RATIONAL-LISTP" , "U" , "ACL2"),
    ("INTEGER-STEP" , "U" , "ACL2"),
    ("INTEGERP" , "U" , "COMMON-LISP"),
    ("INTERACTIVE-STREAM-P" , "U" , "COMMON-LISP"),
    ("INTERN" , "U" , "COMMON-LISP"),
    ("INTERN$" , "U" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL" , "U" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL-SYMBOL-NAME" , "U" , "ACL2"),
    ("INTERNAL-TIME-UNITS-PER-SECOND" , "U" , "COMMON-LISP"),
    ("INTERSECTION" , "U" , "COMMON-LISP"),
    ("INTERSECTION-EQ" , "U" , "ACL2"),
    ("INTERSECTION-THEORIES" , "U" , "ACL2"),
    ("INTERSECTP-EQ" , "U" , "ACL2"),
    ("INTERSECTP-EQUAL" , "U" , "ACL2"),
    ("INVALID-METHOD-ERROR" , "U" , "COMMON-LISP"),
    ("INVERSE-OF-*" , "U" , "ACL2"),
    ("INVERSE-OF-+" , "U" , "ACL2"),
    ("INVISIBLE-FNS-TABLE" , "U" , "ACL2"),
    ("INVOKE-DEBUGGER" , "U" , "COMMON-LISP"),
    ("INVOKE-RESTART" , "U" , "COMMON-LISP"),
    ("INVOKE-RESTART-INTERACTIVELY" , "U" , "COMMON-LISP"),
    ("ISQRT" , "U" , "COMMON-LISP"),
    ("KEYWORD" , "U" , "COMMON-LISP"),
    ("KEYWORD-PACKAGE" , "U" , "ACL2"),
    ("KEYWORD-VALUE-LISTP" , "U" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-ASSOC-KEYWORD" , "U" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("KEYWORDP" , "U" , "COMMON-LISP"),
    ("KEYWORDP-FORWARD-TO-SYMBOLP" , "U" , "ACL2"),
    ("KNOWN-PACKAGE-ALIST" , "U" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP" , "U" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"U" , "ACL2"),
    ("LABELS" , "U" , "COMMON-LISP"),
    ("LAMBDA" , "U" , "COMMON-LISP"),
    ("LAMBDA-LIST-KEYWORDS" , "U" , "COMMON-LISP"),
    ("LAMBDA-PARAMETERS-LIMIT" , "U" , "COMMON-LISP"),
    ("LAST" , "U" , "COMMON-LISP"),
    ("LCM" , "U" , "COMMON-LISP"),
    ("LD" , "U" , "ACL2"),
    ("LD-ERROR-ACTION" , "U" , "ACL2"),
    ("LD-ERROR-TRIPLES" , "U" , "ACL2"),
    ("LD-KEYWORD-ALIASES" , "U" , "ACL2"),
    ("LD-POST-EVAL-PRINT" , "U" , "ACL2"),
    ("LD-PRE-EVAL-FILTER" , "U" , "ACL2"),
    ("LD-PRE-EVAL-PRINT" , "U" , "ACL2"),
    ("LD-PROMPT" , "U" , "ACL2"),
    ("LD-QUERY-CONTROL-ALIST" , "U" , "ACL2"),
    ("LD-REDEFINITION-ACTION" , "U" , "ACL2"),
    ("LD-SKIP-PROOFSP" , "U" , "ACL2"),
    ("LD-VERBOSE" , "U" , "ACL2"),
    ("LDB" , "U" , "COMMON-LISP"),
    ("LDB-TEST" , "U" , "COMMON-LISP"),
    ("LDIFF" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-DOUBLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-LONG-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-DOUBLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-LONG-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SHORT-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SINGLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SHORT-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SINGLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-DOUBLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-LONG-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-DOUBLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-LONG-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SHORT-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SINGLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SHORT-FLOAT" , "U" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SINGLE-FLOAT" , "U" , "COMMON-LISP"),
    ("LEGAL-CASE-CLAUSESP" , "U" , "ACL2"),
    ("LEN" , "U" , "ACL2"),
    ("LEN-UPDATE-NTH" , "U" , "ACL2"),
    ("LENGTH" , "U" , "COMMON-LISP"),
    ("LET" , "U" , "COMMON-LISP"),
    ("LET*" , "U" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-TYPE" , "U" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-VERSION" , "U" , "COMMON-LISP"),
    ("LIST" , "U" , "COMMON-LISP"),
    ("LIST*" , "U" , "COMMON-LISP"),
    ("LIST*-MACRO" , "U" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES" , "U" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES-LST" , "U" , "ACL2"),
    ("LIST-ALL-PACKAGES" , "U" , "COMMON-LISP"),
    ("LIST-LENGTH" , "U" , "COMMON-LISP"),
    ("LIST-MACRO" , "U" , "ACL2"),
    ("LISTEN" , "U" , "COMMON-LISP"),
    ("LISTP" , "U" , "COMMON-LISP"),
    ("LOAD" , "U" , "COMMON-LISP"),
    ("LOAD-LOGICAL-PATHNAME-TRANSLATIONS" , "U" , "COMMON-LISP"),
    ("LOAD-TIME-VALUE" , "U" , "COMMON-LISP"),
    ("LOCAL" , "U" , "ACL2"),
    ("LOCALLY" , "U" , "COMMON-LISP"),
    ("LOG" , "U" , "COMMON-LISP"),
    ("LOGAND" , "U" , "COMMON-LISP"),
    ("LOGANDC1" , "U" , "COMMON-LISP"),
    ("LOGANDC2" , "U" , "COMMON-LISP"),
    ("LOGBITP" , "U" , "COMMON-LISP"),
    ("LOGCOUNT" , "U" , "COMMON-LISP"),
    ("LOGEQV" , "U" , "COMMON-LISP"),
    ("LOGIC" , "U" , "ACL2"),
    ("LOGICAL-PATHNAME" , "U" , "COMMON-LISP"),
    ("LOGICAL-PATHNAME-TRANSLATIONS" , "U" , "COMMON-LISP"),
    ("LOGIOR" , "U" , "COMMON-LISP"),
    ("LOGNAND" , "U" , "COMMON-LISP"),
    ("LOGNOR" , "U" , "COMMON-LISP"),
    ("LOGNOT" , "U" , "COMMON-LISP"),
    ("LOGORC1" , "U" , "COMMON-LISP"),
    ("LOGORC2" , "U" , "COMMON-LISP"),
    ("LOGTEST" , "U" , "COMMON-LISP"),
    ("LOGXOR" , "U" , "COMMON-LISP"),
    ("LONG-FLOAT" , "U" , "COMMON-LISP"),
    ("LONG-FLOAT-EPSILON" , "U" , "COMMON-LISP"),
    ("LONG-FLOAT-NEGATIVE-EPSILON" , "U" , "COMMON-LISP"),
    ("LONG-SITE-NAME" , "U" , "COMMON-LISP"),
    ("LOOP" , "U" , "COMMON-LISP"),
    ("LOOP-FINISH" , "U" , "COMMON-LISP"),
    ("LOWER-CASE-P" , "U" , "COMMON-LISP"),
    ("LOWER-CASE-P-CHAR-DOWNCASE" , "U" , "ACL2"),
    ("LOWER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "U" , "ACL2"),
    ("LOWEST-TERMS" , "U" , "ACL2"),
    ("LP" , "U" , "ACL2"),
    ("MACHINE-INSTANCE" , "U" , "COMMON-LISP"),
    ("MACHINE-TYPE" , "U" , "COMMON-LISP"),
    ("MACHINE-VERSION" , "U" , "COMMON-LISP"),
    ("MACRO-ALIASES" , "U" , "ACL2"),
    ("MACRO-FUNCTION" , "U" , "COMMON-LISP"),
    ("MACROEXPAND" , "U" , "COMMON-LISP"),
    ("MACROEXPAND-1" , "U" , "COMMON-LISP"),
    ("MACROLET" , "U" , "COMMON-LISP"),
    ("MAIN-TIMER" , "U" , "ACL2"),
    ("MAIN-TIMER-TYPE-PRESCRIPTION" , "U" , "ACL2"),
    ("MAKE-ARRAY" , "U" , "COMMON-LISP"),
    ("MAKE-BROADCAST-STREAM" , "U" , "COMMON-LISP"),
    ("MAKE-CHARACTER-LIST" , "U" , "ACL2"),
    ("MAKE-CHARACTER-LIST-MAKE-CHARACTER-LIST" , "U" , "ACL2"),
    ("MAKE-CONCATENATED-STREAM" , "U" , "COMMON-LISP"),
    ("MAKE-CONDITION" , "U" , "COMMON-LISP"),
    ("MAKE-DISPATCH-MACRO-CHARACTER" , "U" , "COMMON-LISP"),
    ("MAKE-ECHO-STREAM" , "U" , "COMMON-LISP"),
    ("MAKE-EVENT" , "U" , "ACL2"),
    ("MAKE-FMT-BINDINGS" , "U" , "ACL2"),
    ("MAKE-HASH-TABLE" , "U" , "COMMON-LISP"),
    ("MAKE-INPUT-CHANNEL" , "U" , "ACL2"),
    ("MAKE-INSTANCE" , "U" , "COMMON-LISP"),
    ("MAKE-INSTANCES-OBSOLETE" , "U" , "COMMON-LISP"),
    ("MAKE-LIST" , "U" , "COMMON-LISP"),
    ("MAKE-LIST-AC" , "U" , "ACL2"),
    ("MAKE-LOAD-FORM" , "U" , "COMMON-LISP"),
    ("MAKE-LOAD-FORM-SAVING-SLOTS" , "U" , "COMMON-LISP"),
    ("MAKE-METHOD" , "U" , "COMMON-LISP"),
    ("MAKE-MV-NTHS" , "U" , "ACL2"),
    ("MAKE-ORD" , "U" , "ACL2"),
    ("MAKE-OUTPUT-CHANNEL" , "U" , "ACL2"),
    ("MAKE-PACKAGE" , "U" , "COMMON-LISP"),
    ("MAKE-PATHNAME" , "U" , "COMMON-LISP"),
    ("MAKE-RANDOM-STATE" , "U" , "COMMON-LISP"),
    ("MAKE-SEQUENCE" , "U" , "COMMON-LISP"),
    ("MAKE-STRING" , "U" , "COMMON-LISP"),
    ("MAKE-STRING-INPUT-STREAM" , "U" , "COMMON-LISP"),
    ("MAKE-STRING-OUTPUT-STREAM" , "U" , "COMMON-LISP"),
    ("MAKE-SYMBOL" , "U" , "COMMON-LISP"),
    ("MAKE-SYNONYM-STREAM" , "U" , "COMMON-LISP"),
    ("MAKE-TWO-WAY-STREAM" , "U" , "COMMON-LISP"),
    ("MAKE-VAR-LST" , "U" , "ACL2"),
    ("MAKE-VAR-LST1" , "U" , "ACL2"),
    ("MAKUNBOUND" , "U" , "COMMON-LISP"),
    ("MAKUNBOUND-GLOBAL" , "U" , "ACL2"),
    ("MAP" , "U" , "COMMON-LISP"),
    ("MAP-INTO" , "U" , "COMMON-LISP"),
    ("MAPC" , "U" , "COMMON-LISP"),
    ("MAPCAN" , "U" , "COMMON-LISP"),
    ("MAPCAR" , "U" , "COMMON-LISP"),
    ("MAPCON" , "U" , "COMMON-LISP"),
    ("MAPHASH" , "U" , "COMMON-LISP"),
    ("MAPL" , "U" , "COMMON-LISP"),
    ("MAPLIST" , "U" , "COMMON-LISP"),
    ("MASK-FIELD" , "U" , "COMMON-LISP"),
    ("MAX" , "U" , "COMMON-LISP"),
    ("MAXIMUM-LENGTH" , "U" , "ACL2"),
    ("MAY-NEED-SLASHES" , "U" , "ACL2"),
    ("MBE" , "U" , "ACL2"),
    ("MBT" , "U" , "ACL2"),
    ("MEMBER" , "U" , "COMMON-LISP"),
    ("MEMBER-EQ" , "U" , "ACL2"),
    ("MEMBER-EQUAL" , "U" , "ACL2"),
    ("MEMBER-IF" , "U" , "COMMON-LISP"),
    ("MEMBER-IF-NOT" , "U" , "COMMON-LISP"),
    ("MEMBER-SYMBOL-NAME" , "U" , "ACL2"),
    ("MEMOIZE" , "U" , "ACL2"),
    ("MEMOIZE-LET" , "U" , "ACL2"),
    ("MEMOIZE-OFF" , "U" , "ACL2"),
    ("MEMOIZE-ON" , "U" , "ACL2"),
    ("MERGE" , "U" , "COMMON-LISP"),
    ("MERGE-PATHNAMES" , "U" , "COMMON-LISP"),
    ("METHOD" , "U" , "COMMON-LISP"),
    ("METHOD-COMBINATION" , "U" , "COMMON-LISP"),
    ("METHOD-COMBINATION-ERROR" , "U" , "COMMON-LISP"),
    ("METHOD-QUALIFIERS" , "U" , "COMMON-LISP"),
    ("MFC" , "U" , "ACL2"),
    ("MIN" , "U" , "COMMON-LISP"),
    ("MINIMAL-THEORY" , "U" , "ACL2"),
    ("MINUSP" , "U" , "COMMON-LISP"),
    ("MISMATCH" , "U" , "COMMON-LISP"),
    ("MOD" , "U" , "COMMON-LISP"),
    ("MONITOR" , "U" , "ACL2"),
    ("MONITORED-RUNES" , "U" , "ACL2"),
    ("MORE" , "U" , "ACL2"),
    ("MORE!" , "U" , "ACL2"),
    ("MORE-DOC" , "U" , "ACL2"),
    ("MOST-NEGATIVE-DOUBLE-FLOAT" , "U" , "COMMON-LISP"),
    ("MOST-NEGATIVE-FIXNUM" , "U" , "COMMON-LISP"),
    ("MOST-NEGATIVE-LONG-FLOAT" , "U" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SHORT-FLOAT" , "U" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SINGLE-FLOAT" , "U" , "COMMON-LISP"),
    ("MOST-POSITIVE-DOUBLE-FLOAT" , "U" , "COMMON-LISP"),
    ("MOST-POSITIVE-FIXNUM" , "U" , "COMMON-LISP"),
    ("MOST-POSITIVE-LONG-FLOAT" , "U" , "COMMON-LISP"),
    ("MOST-POSITIVE-SHORT-FLOAT" , "U" , "COMMON-LISP"),
    ("MOST-POSITIVE-SINGLE-FLOAT" , "U" , "COMMON-LISP"),
    ("MUFFLE-WARNING" , "U" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-BIND" , "U" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-CALL" , "U" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-LIST" , "U" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-PROG1" , "U" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-SETQ" , "U" , "COMMON-LISP"),
    ("MULTIPLE-VALUES-LIMIT" , "U" , "COMMON-LISP"),
    ("MUTUAL-RECURSION" , "U" , "ACL2"),
    ("MUTUAL-RECURSION-GUARDP" , "U" , "ACL2"),
    ("MV" , "U" , "ACL2"),
    ("MV-LET" , "U" , "ACL2"),
    ("MV-LIST" , "U" , "ACL2"),
    ("MV-NTH" , "U" , "ACL2"),
    ("NAME-CHAR" , "U" , "COMMON-LISP"),
    ("NAMESTRING" , "U" , "COMMON-LISP"),
    ("NATP" , "U" , "ACL2"),
    ("NBUTLAST" , "U" , "COMMON-LISP"),
    ("NCONC" , "U" , "COMMON-LISP"),
    ("NEEDS-SLASHES" , "U" , "ACL2"),
    ("NEWLINE" , "U" , "ACL2"),
    ("NEXT-METHOD-P" , "U" , "COMMON-LISP"),
    ("NFIX" , "U" , "ACL2"),
    ("NIL" , "U" , "COMMON-LISP"),
    ("NIL-IS-NOT-CIRCULAR" , "U" , "ACL2"),
    ("NINTERSECTION" , "U" , "COMMON-LISP"),
    ("NINTH" , "U" , "COMMON-LISP"),
    ("NO-APPLICABLE-METHOD" , "U" , "COMMON-LISP"),
    ("NO-DUPLICATESP" , "U" , "ACL2"),
    ("NO-DUPLICATESP-EQUAL" , "U" , "ACL2"),
    ("NO-NEXT-METHOD" , "U" , "COMMON-LISP"),
    ("NONNEGATIVE-INTEGER-QUOTIENT" , "U" , "ACL2"),
    ("NONNEGATIVE-PRODUCT" , "U" , "ACL2"),
    ("NONZERO-IMAGPART" , "U" , "ACL2"),
    ("NOT" , "U" , "COMMON-LISP"),
    ("NOTANY" , "U" , "COMMON-LISP"),
    ("NOTEVERY" , "U" , "COMMON-LISP"),
    ("NOTINLINE" , "U" , "COMMON-LISP"),
    ("NQTHM-TO-ACL2" , "U" , "ACL2"),
    ("NRECONC" , "U" , "COMMON-LISP"),
    ("NREVERSE" , "U" , "COMMON-LISP"),
    ("NSET-DIFFERENCE" , "U" , "COMMON-LISP"),
    ("NSET-EXCLUSIVE-OR" , "U" , "COMMON-LISP"),
    ("NSTRING-CAPITALIZE" , "U" , "COMMON-LISP"),
    ("NSTRING-DOWNCASE" , "U" , "COMMON-LISP"),
    ("NSTRING-UPCASE" , "U" , "COMMON-LISP"),
    ("NSUBLIS" , "U" , "COMMON-LISP"),
    ("NSUBST" , "U" , "COMMON-LISP"),
    ("NSUBST-IF" , "U" , "COMMON-LISP"),
    ("NSUBST-IF-NOT" , "U" , "COMMON-LISP"),
    ("NSUBSTITUTE" , "U" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF" , "U" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF-NOT" , "U" , "COMMON-LISP"),
    ("NTH" , "U" , "COMMON-LISP"),
    ("NTH-0-CONS" , "U" , "ACL2"),
    ("NTH-0-READ-RUN-TIME-TYPE-PRESCRIPTION" , "U" , "ACL2"),
    ("NTH-ADD1" , "U" , "ACL2"),
    ("NTH-ALIASES" , "U" , "ACL2"),
    ("NTH-UPDATE-NTH" , "U" , "ACL2"),
    ("NTH-VALUE" , "U" , "COMMON-LISP"),
    ("NTHCDR" , "U" , "COMMON-LISP"),
    ("NULL" , "U" , "COMMON-LISP"),
    ("NUMBER" , "U" , "COMMON-LISP"),
    ("NUMBER-SUBTREES" , "U" , "ACL2"),
    ("NUMBERP" , "U" , "COMMON-LISP"),
    ("NUMERATOR" , "U" , "COMMON-LISP"),
    ("NUNION" , "U" , "COMMON-LISP"),
    ("O-FINP" , "U" , "ACL2"),
    ("O-FIRST-COEFF" , "U" , "ACL2"),
    ("O-FIRST-EXPT" , "U" , "ACL2"),
    ("O-INFP" , "U" , "ACL2"),
    ("O-P" , "U" , "ACL2"),
    ("O-RST" , "U" , "ACL2"),
    ("O<" , "U" , "ACL2"),
    ("O<=" , "U" , "ACL2"),
    ("O>" , "U" , "ACL2"),
    ("O>=" , "U" , "ACL2"),
    ("OBSERVATION" , "U" , "ACL2"),
    ("ODDP" , "U" , "COMMON-LISP"),
    ("ODDS" , "U" , "ACL2"),
    ("OK-IF" , "U" , "ACL2"),
    ("OOPS" , "U" , "ACL2"),
    ("OPEN" , "U" , "COMMON-LISP"),
    ("OPEN-CHANNEL-LISTP" , "U" , "ACL2"),
    ("OPEN-CHANNEL1" , "U" , "ACL2"),
    ("OPEN-CHANNEL1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "U" , "ACL2"),
    ("OPEN-CHANNELS-P" , "U" , "ACL2"),
    ("OPEN-CHANNELS-P-FORWARD" , "U" , "ACL2"),
    ("OPEN-INPUT-CHANNEL" , "U" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P" , "U" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P1" , "U" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P" , "U" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P1" , "U" , "ACL2"),
    ("OPEN-INPUT-CHANNELS" , "U" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL" , "U" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL!" , "U" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P" , "U" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P1" , "U" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P" , "U" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P1" , "U" , "ACL2"),
    ("OPEN-OUTPUT-CHANNELS" , "U" , "ACL2"),
    ("OPEN-STREAM-P" , "U" , "COMMON-LISP"),
    ("OPEN-TRACE-FILE" , "U" , "ACL2"),
    ("OPTIMIZE" , "U" , "COMMON-LISP"),
    ("OR" , "U" , "COMMON-LISP"),
    ("OR-MACRO" , "U" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP" , "U" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR" , "U" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR-FORWARD" , "U" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-FORWARD-TO-SYMBOL-ALISTP" , "U" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-GETPROPS" , "U" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-REMOVE-FIRST-PAIR" , "U" , "ACL2"),
    ("OTHERWISE" , "U" , "COMMON-LISP"),
    ("OUR-DIGIT-CHAR-P" , "U" , "ACL2"),
    ("OUTPUT-STREAM-P" , "U" , "COMMON-LISP"),
    ("PACKAGE" , "U" , "COMMON-LISP"),
    ("PACKAGE-ERROR" , "U" , "COMMON-LISP"),
    ("PACKAGE-ERROR-PACKAGE" , "U" , "COMMON-LISP"),
    ("PACKAGE-NAME" , "U" , "COMMON-LISP"),
    ("PACKAGE-NICKNAMES" , "U" , "COMMON-LISP"),
    ("PACKAGE-SHADOWING-SYMBOLS" , "U" , "COMMON-LISP"),
    ("PACKAGE-USE-LIST" , "U" , "COMMON-LISP"),
    ("PACKAGE-USED-BY-LIST" , "U" , "COMMON-LISP"),
    ("PACKAGEP" , "U" , "COMMON-LISP"),
    ("PAIRLIS" , "U" , "COMMON-LISP"),
    ("PAIRLIS$" , "U" , "ACL2"),
    ("PAIRLIS2" , "U" , "ACL2"),
    ("PAND" , "U" , "ACL2"),
    ("PARGS" , "U" , "ACL2"),
    ("PARSE-ERROR" , "U" , "COMMON-LISP"),
    ("PARSE-INTEGER" , "U" , "COMMON-LISP"),
    ("PARSE-NAMESTRING" , "U" , "COMMON-LISP"),
    ("PATHNAME" , "U" , "COMMON-LISP"),
    ("PATHNAME-DEVICE" , "U" , "COMMON-LISP"),
    ("PATHNAME-DIRECTORY" , "U" , "COMMON-LISP"),
    ("PATHNAME-HOST" , "U" , "COMMON-LISP"),
    ("PATHNAME-MATCH-P" , "U" , "COMMON-LISP"),
    ("PATHNAME-NAME" , "U" , "COMMON-LISP"),
    ("PATHNAME-TYPE" , "U" , "COMMON-LISP"),
    ("PATHNAME-VERSION" , "U" , "COMMON-LISP"),
    ("PATHNAMEP" , "U" , "COMMON-LISP"),
    ("PBT" , "U" , "ACL2"),
    ("PC" , "U" , "ACL2"),
    ("PCB" , "U" , "ACL2"),
    ("PCB!" , "U" , "ACL2"),
    ("PCS" , "U" , "ACL2"),
    ("PE" , "U" , "ACL2"),
    ("PEEK-CHAR" , "U" , "COMMON-LISP"),
    ("PEEK-CHAR$" , "U" , "ACL2"),
    ("PF" , "U" , "ACL2"),
    ("PHASE" , "U" , "COMMON-LISP"),
    ("PI" , "U" , "COMMON-LISP"),
    ("PL" , "U" , "ACL2"),
    ("PLET" , "U" , "ACL2"),
    ("PLIST-WORLDP" , "U" , "ACL2"),
    ("PLIST-WORLDP-FORWARD-TO-ASSOC-EQ-EQUAL-ALISTP" , "U" , "ACL2"),
    ("PLUSP" , "U" , "COMMON-LISP"),
    ("POP" , "U" , "COMMON-LISP"),
    ("POP-TIMER" , "U" , "ACL2"),
    ("POR" , "U" , "ACL2"),
    ("POSITION" , "U" , "COMMON-LISP"),
    ("POSITION-AC" , "U" , "ACL2"),
    ("POSITION-EQ" , "U" , "ACL2"),
    ("POSITION-EQ-AC" , "U" , "ACL2"),
    ("POSITION-EQUAL" , "U" , "ACL2"),
    ("POSITION-EQUAL-AC" , "U" , "ACL2"),
    ("POSITION-IF" , "U" , "COMMON-LISP"),
    ("POSITION-IF-NOT" , "U" , "COMMON-LISP"),
    ("POSITIVE" , "U" , "ACL2"),
    ("POSP" , "U" , "ACL2"),
    ("POWER-EVAL" , "U" , "ACL2"),
    ("PPRINT" , "U" , "COMMON-LISP"),
    ("PPRINT-DISPATCH" , "U" , "COMMON-LISP"),
    ("PPRINT-EXIT-IF-LIST-EXHAUSTED" , "U" , "COMMON-LISP"),
    ("PPRINT-FILL" , "U" , "COMMON-LISP"),
    ("PPRINT-INDENT" , "U" , "COMMON-LISP"),
    ("PPRINT-LINEAR" , "U" , "COMMON-LISP"),
    ("PPRINT-LOGICAL-BLOCK" , "U" , "COMMON-LISP"),
    ("PPRINT-NEWLINE" , "U" , "COMMON-LISP"),
    ("PPRINT-POP" , "U" , "COMMON-LISP"),
    ("PPRINT-TAB" , "U" , "COMMON-LISP"),
    ("PPRINT-TABULAR" , "U" , "COMMON-LISP"),
    ("PPROGN" , "U" , "ACL2"),
    ("PR" , "U" , "ACL2"),
    ("PR!" , "U" , "ACL2"),
    ("PREPROCESS" , "U" , "ACL2"),
    ("PRIN1" , "U" , "COMMON-LISP"),
    ("PRIN1$" , "U" , "ACL2"),
    ("PRIN1-TO-STRING" , "U" , "COMMON-LISP"),
    ("PRIN1-WITH-SLASHES" , "U" , "ACL2"),
    ("PRIN1-WITH-SLASHES1" , "U" , "ACL2"),
    ("PRINC" , "U" , "COMMON-LISP"),
    ("PRINC$" , "U" , "ACL2"),
    ("PRINC-TO-STRING" , "U" , "COMMON-LISP"),
    ("PRINT" , "U" , "COMMON-LISP"),
    ("PRINT-GV" , "U" , "ACL2"),
    ("PRINT-NOT-READABLE" , "U" , "COMMON-LISP"),
    ("PRINT-NOT-READABLE-OBJECT" , "U" , "COMMON-LISP"),
    ("PRINT-OBJECT" , "U" , "COMMON-LISP"),
    ("PRINT-OBJECT$" , "U" , "ACL2"),
    ("PRINT-RATIONAL-AS-DECIMAL" , "U" , "ACL2"),
    ("PRINT-TIMER" , "U" , "ACL2"),
    ("PRINT-UNREADABLE-OBJECT" , "U" , "COMMON-LISP"),
    ("PROBE-FILE" , "U" , "COMMON-LISP"),
    ("PROCLAIM" , "U" , "COMMON-LISP"),
    ("PROG" , "U" , "COMMON-LISP"),
    ("PROG*" , "U" , "COMMON-LISP"),
    ("PROG1" , "U" , "COMMON-LISP"),
    ("PROG2" , "U" , "COMMON-LISP"),
    ("PROG2$" , "U" , "ACL2"),
    ("PROGN" , "U" , "COMMON-LISP"),
    ("PROGRAM" , "U" , "ACL2"),
    ("PROGRAM-ERROR" , "U" , "COMMON-LISP"),
    ("PROGV" , "U" , "COMMON-LISP"),
    ("PROOF-TREE" , "U" , "ACL2"),
    ("PROOFS-CO" , "U" , "ACL2"),
    ("PROPER-CONSP" , "U" , "ACL2"),
    ("PROPS" , "U" , "ACL2"),
    ("PROVE" , "U" , "ACL2"),
    ("PROVIDE" , "U" , "COMMON-LISP"),
    ("PSETF" , "U" , "COMMON-LISP"),
    ("PSETQ" , "U" , "COMMON-LISP"),
    ("PSEUDO-TERM-LISTP" , "U" , "ACL2"),
    ("PSEUDO-TERM-LISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("PSEUDO-TERMP" , "U" , "ACL2"),
    ("PSTACK" , "U" , "ACL2"),
    ("PUFF" , "U" , "ACL2"),
    ("PUFF*" , "U" , "ACL2"),
    ("PUSH" , "U" , "COMMON-LISP"),
    ("PUSH-TIMER" , "U" , "ACL2"),
    ("PUSH-UNTOUCHABLE" , "U" , "ACL2"),
    ("PUSHNEW" , "U" , "COMMON-LISP"),
    ("PUT-ASSOC-EQ" , "U" , "ACL2"),
    ("PUT-ASSOC-EQUAL" , "U" , "ACL2"),
    ("PUT-GLOBAL" , "U" , "ACL2"),
    ("PUTPROP" , "U" , "ACL2"),
    ("QUOTE" , "U" , "COMMON-LISP"),
    ("QUOTEP" , "U" , "ACL2"),
    ("R-EQLABLE-ALISTP" , "U" , "ACL2"),
    ("RANDOM" , "U" , "COMMON-LISP"),
    ("RANDOM-STATE" , "U" , "COMMON-LISP"),
    ("RANDOM-STATE-P" , "U" , "COMMON-LISP"),
    ("RASSOC" , "U" , "COMMON-LISP"),
    ("RASSOC-EQ" , "U" , "ACL2"),
    ("RASSOC-EQUAL" , "U" , "ACL2"),
    ("RASSOC-IF" , "U" , "COMMON-LISP"),
    ("RASSOC-IF-NOT" , "U" , "COMMON-LISP"),
    ("RATIO" , "U" , "COMMON-LISP"),
    ("RATIONAL" , "U" , "COMMON-LISP"),
    ("RATIONAL-IMPLIES1" , "U" , "ACL2"),
    ("RATIONAL-IMPLIES2" , "U" , "ACL2"),
    ("RATIONAL-LISTP" , "U" , "ACL2"),
    ("RATIONAL-LISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("RATIONALIZE" , "U" , "COMMON-LISP"),
    ("RATIONALP" , "U" , "COMMON-LISP"),
    ("RATIONALP-*" , "U" , "ACL2"),
    ("RATIONALP-+" , "U" , "ACL2"),
    ("RATIONALP-EXPT-TYPE-PRESCRIPTION" , "U" , "ACL2"),
    ("RATIONALP-IMPLIES-ACL2-NUMBERP" , "U" , "ACL2"),
    ("RATIONALP-UNARY--" , "U" , "ACL2"),
    ("RATIONALP-UNARY-/" , "U" , "ACL2"),
    ("READ" , "U" , "COMMON-LISP"),
    ("READ-ACL2-ORACLE" , "U" , "ACL2"),
    ("READ-ACL2-ORACLE-PRESERVES-STATE-P1" , "U" , "ACL2"),
    ("READ-BYTE" , "U" , "COMMON-LISP"),
    ("READ-BYTE$" , "U" , "ACL2"),
    ("READ-CHAR" , "U" , "COMMON-LISP"),
    ("READ-CHAR$" , "U" , "ACL2"),
    ("READ-CHAR-NO-HANG" , "U" , "COMMON-LISP"),
    ("READ-DELIMITED-LIST" , "U" , "COMMON-LISP"),
    ("READ-FILE-LISTP" , "U" , "ACL2"),
    ("READ-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "U" , "ACL2"),
    ("READ-FILE-LISTP1" , "U" , "ACL2"),
    ("READ-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "U" , "ACL2"),
    ("READ-FILES" , "U" , "ACL2"),
    ("READ-FILES-P" , "U" , "ACL2"),
    ("READ-FILES-P-FORWARD-TO-READ-FILE-LISTP" , "U" , "ACL2"),
    ("READ-FROM-STRING" , "U" , "COMMON-LISP"),
    ("READ-IDATE" , "U" , "ACL2"),
    ("READ-LINE" , "U" , "COMMON-LISP"),
    ("READ-OBJECT" , "U" , "ACL2"),
    ("READ-PRESERVING-WHITESPACE" , "U" , "COMMON-LISP"),
    ("READ-RUN-TIME" , "U" , "ACL2"),
    ("READ-RUN-TIME-PRESERVES-STATE-P1" , "U" , "ACL2"),
    ("READ-SEQUENCE" , "U" , "COMMON-LISP"),
    ("READABLE-FILE" , "U" , "ACL2"),
    ("READABLE-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "U" , "ACL2"),
    ("READABLE-FILES" , "U" , "ACL2"),
    ("READABLE-FILES-LISTP" , "U" , "ACL2"),
    ("READABLE-FILES-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"U" , "ACL2"),
    ("READABLE-FILES-P" , "U" , "ACL2"),
    ("READABLE-FILES-P-FORWARD-TO-READABLE-FILES-LISTP" , "U" , "ACL2"),
    ("READER-ERROR" , "U" , "COMMON-LISP"),
    ("READTABLE" , "U" , "COMMON-LISP"),
    ("READTABLE-CASE" , "U" , "COMMON-LISP"),
    ("READTABLEP" , "U" , "COMMON-LISP"),
    ("REAL" , "U" , "COMMON-LISP"),
    ("REAL/RATIONALP" , "U" , "ACL2"),
    ("REALFIX" , "U" , "ACL2"),
    ("REALP" , "U" , "COMMON-LISP"),
    ("REALPART" , "U" , "COMMON-LISP"),
    ("REALPART-COMPLEX" , "U" , "ACL2"),
    ("REALPART-IMAGPART-ELIM" , "U" , "ACL2"),
    ("REBUILD" , "U" , "ACL2"),
    ("REDEF" , "U" , "ACL2"),
    ("REDEF!" , "U" , "ACL2"),
    ("REDEF+" , "U" , "ACL2"),
    ("REDUCE" , "U" , "COMMON-LISP"),
    ("REINITIALIZE-INSTANCE" , "U" , "COMMON-LISP"),
    ("REM" , "U" , "COMMON-LISP"),
    ("REMF" , "U" , "COMMON-LISP"),
    ("REMHASH" , "U" , "COMMON-LISP"),
    ("REMOVE" , "U" , "COMMON-LISP"),
    ("REMOVE-BINOP" , "U" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS" , "U" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS!" , "U" , "ACL2"),
    ("REMOVE-DUPLICATES" , "U" , "COMMON-LISP"),
    ("REMOVE-DUPLICATES-EQL" , "U" , "ACL2"),
    ("REMOVE-DUPLICATES-EQUAL" , "U" , "ACL2"),
    ("REMOVE-EQ" , "U" , "ACL2"),
    ("REMOVE-EQUAL" , "U" , "ACL2"),
    ("REMOVE-FIRST-PAIR" , "U" , "ACL2"),
    ("REMOVE-IF" , "U" , "COMMON-LISP"),
    ("REMOVE-IF-NOT" , "U" , "COMMON-LISP"),
    ("REMOVE-INVISIBLE-FNS" , "U" , "ACL2"),
    ("REMOVE-MACRO-ALIAS" , "U" , "ACL2"),
    ("REMOVE-METHOD" , "U" , "COMMON-LISP"),
    ("REMOVE-NTH-ALIAS" , "U" , "ACL2"),
    ("REMOVE-UNTOUCHABLE" , "U" , "ACL2"),
    ("REMOVE1" , "U" , "ACL2"),
    ("REMOVE1-EQ" , "U" , "ACL2"),
    ("REMOVE1-EQUAL" , "U" , "ACL2"),
    ("REMPROP" , "U" , "COMMON-LISP"),
    ("RENAME-FILE" , "U" , "COMMON-LISP"),
    ("RENAME-PACKAGE" , "U" , "COMMON-LISP"),
    ("REPLACE" , "U" , "COMMON-LISP"),
    ("REQUIRE" , "U" , "COMMON-LISP"),
    ("RESET-LD-SPECIALS" , "U" , "ACL2"),
    ("RESET-PREHISTORY" , "U" , "ACL2"),
    ("REST" , "U" , "COMMON-LISP"),
    ("RESTART" , "U" , "COMMON-LISP"),
    ("RESTART-BIND" , "U" , "COMMON-LISP"),
    ("RESTART-CASE" , "U" , "COMMON-LISP"),
    ("RESTART-NAME" , "U" , "COMMON-LISP"),
    ("RETRACT-WORLD" , "U" , "ACL2"),
    ("RETRIEVE" , "U" , "ACL2"),
    ("RETURN" , "U" , "COMMON-LISP"),
    ("RETURN-FROM" , "U" , "COMMON-LISP"),
    ("REVAPPEND" , "U" , "COMMON-LISP"),
    ("REVERSE" , "U" , "COMMON-LISP"),
    ("RFIX" , "U" , "ACL2"),
    ("ROOM" , "U" , "COMMON-LISP"),
    ("ROTATEF" , "U" , "COMMON-LISP"),
    ("ROUND" , "U" , "COMMON-LISP"),
    ("ROW-MAJOR-AREF" , "U" , "COMMON-LISP"),
    ("RPLACA" , "U" , "COMMON-LISP"),
    ("RPLACD" , "U" , "COMMON-LISP"),
    ("SAFETY" , "U" , "COMMON-LISP"),
    ("SATISFIES" , "U" , "COMMON-LISP"),
    ("SBIT" , "U" , "COMMON-LISP"),
    ("SCALE-FLOAT" , "U" , "COMMON-LISP"),
    ("SCHAR" , "U" , "COMMON-LISP"),
    ("SEARCH" , "U" , "COMMON-LISP"),
    ("SECOND" , "U" , "COMMON-LISP"),
    ("SEQUENCE" , "U" , "COMMON-LISP"),
    ("SERIOUS-CONDITION" , "U" , "COMMON-LISP"),
    ("SET" , "U" , "COMMON-LISP"),
    ("SET-BACKCHAIN-LIMIT" , "U" , "ACL2"),
    ("SET-BODY" , "U" , "ACL2"),
    ("SET-BOGUS-DEFUN-HINTS-OK" , "U" , "ACL2"),
    ("SET-BOGUS-MUTUAL-RECURSION-OK" , "U" , "ACL2"),
    ("SET-CASE-SPLIT-LIMITATIONS" , "U" , "ACL2"),
    ("SET-CBD" , "U" , "ACL2"),
    ("SET-CHECKPOINT-SUMMARY-LIMIT" , "U" , "ACL2"),
    ("SET-COMPILE-FNS" , "U" , "ACL2"),
    ("SET-DEBUGGER-ENABLE" , "U" , "ACL2"),
    ("SET-DEFAULT-BACKCHAIN-LIMIT" , "U" , "ACL2"),
    ("SET-DEFAULT-HINTS" , "U" , "ACL2"),
    ("SET-DEFAULT-HINTS!" , "U" , "ACL2"),
    ("SET-DIFFERENCE" , "U" , "COMMON-LISP"),
    ("SET-DIFFERENCE-EQ" , "U" , "ACL2"),
    ("SET-DIFFERENCE-EQUAL" , "U" , "ACL2"),
    ("SET-DIFFERENCE-THEORIES" , "U" , "ACL2"),
    ("SET-DISPATCH-MACRO-CHARACTER" , "U" , "COMMON-LISP"),
    ("SET-ENFORCE-REDUNDANCY" , "U" , "ACL2"),
    ("SET-EQUALP-EQUAL" , "U" , "ACL2"),
    ("SET-EXCLUSIVE-OR" , "U" , "COMMON-LISP"),
    ("SET-GAG-MODE" , "U" , "ACL2"),
    ("SET-GUARD-CHECKING" , "U" , "ACL2"),
    ("SET-IGNORE-DOC-STRING-ERROR" , "U" , "ACL2"),
    ("SET-IGNORE-OK" , "U" , "ACL2"),
    ("SET-INHIBIT-OUTPUT-LST" , "U" , "ACL2"),
    ("SET-INHIBIT-WARNINGS" , "U" , "ACL2"),
    ("SET-INHIBITED-SUMMARY-TYPES" , "U" , "ACL2"),
    ("SET-INVISIBLE-FNS-TABLE" , "U" , "ACL2"),
    ("SET-IRRELEVANT-FORMALS-OK" , "U" , "ACL2"),
    ("SET-LD-KEYWORD-ALIASES" , "U" , "ACL2"),
    ("SET-LD-REDEFINITION-ACTION" , "U" , "ACL2"),
    ("SET-LD-SKIP-PROOFS" , "U" , "ACL2"),
    ("SET-LD-SKIP-PROOFSP" , "U" , "ACL2"),
    ("SET-LET*-ABSTRACTION" , "U" , "ACL2"),
    ("SET-LET*-ABSTRACTIONP" , "U" , "ACL2"),
    ("SET-MACRO-CHARACTER" , "U" , "COMMON-LISP"),
    ("SET-MATCH-FREE-DEFAULT" , "U" , "ACL2"),
    ("SET-MATCH-FREE-ERROR" , "U" , "ACL2"),
    ("SET-MEASURE-FUNCTION" , "U" , "ACL2"),
    ("SET-NON-LINEAR" , "U" , "ACL2"),
    ("SET-NON-LINEARP" , "U" , "ACL2"),
    ("SET-NU-REWRITER-MODE" , "U" , "ACL2"),
    ("SET-PARALLEL-EVALUATION" , "U" , "ACL2"),
    ("SET-PPRINT-DISPATCH" , "U" , "COMMON-LISP"),
    ("SET-PRINT-BASE" , "U" , "ACL2"),
    ("SET-PRINT-CASE" , "U" , "ACL2"),
    ("SET-PRINT-CLAUSE-IDS" , "U" , "ACL2"),
    ("SET-RAW-MODE" , "U" , "ACL2"),
    ("SET-RAW-MODE-ON!" , "U" , "ACL2"),
    ("SET-RAW-PROOF-FORMAT" , "U" , "ACL2"),
    ("SET-REWRITE-STACK-LIMIT" , "U" , "ACL2"),
    ("SET-RULER-EXTENDERS" , "U" , "ACL2"),
    ("SET-SAVED-OUTPUT" , "U" , "ACL2"),
    ("SET-SLOW-ALIST-ACTION" , "U" , "ACL2"),
    ("SET-STATE-OK" , "U" , "ACL2"),
    ("SET-SYNTAX-FROM-CHAR" , "U" , "COMMON-LISP"),
    ("SET-TAINTED-OK" , "U" , "ACL2"),
    ("SET-TAINTED-OKP" , "U" , "ACL2"),
    ("SET-TIMER" , "U" , "ACL2"),
    ("SET-TRACE-EVISC-TUPLE" , "U" , "ACL2"),
    ("SET-VERIFY-GUARDS-EAGERNESS" , "U" , "ACL2"),
    ("SET-W" , "U" , "ACL2"),
    ("SET-WELL-FOUNDED-RELATION" , "U" , "ACL2"),
    ("SETF" , "U" , "COMMON-LISP"),
    ("SETQ" , "U" , "COMMON-LISP"),
    ("SEVENTH" , "U" , "COMMON-LISP"),
    ("SGETPROP" , "U" , "ACL2"),
    ("SHADOW" , "U" , "COMMON-LISP"),
    ("SHADOWING-IMPORT" , "U" , "COMMON-LISP"),
    ("SHARED-INITIALIZE" , "U" , "COMMON-LISP"),
    ("SHIFTF" , "U" , "COMMON-LISP"),
    ("SHORT-FLOAT" , "U" , "COMMON-LISP"),
    ("SHORT-FLOAT-EPSILON" , "U" , "COMMON-LISP"),
    ("SHORT-FLOAT-NEGATIVE-EPSILON" , "U" , "COMMON-LISP"),
    ("SHORT-SITE-NAME" , "U" , "COMMON-LISP"),
    ("SHOW-ACCUMULATED-PERSISTENCE" , "U" , "ACL2"),
    ("SHOW-BDD" , "U" , "ACL2"),
    ("SHOW-BODIES" , "U" , "ACL2"),
    ("SHRINK-32-BIT-INTEGER-STACK" , "U" , "ACL2"),
    ("SHRINK-T-STACK" , "U" , "ACL2"),
    ("SIGNAL" , "U" , "COMMON-LISP"),
    ("SIGNED-BYTE" , "U" , "COMMON-LISP"),
    ("SIGNUM" , "U" , "COMMON-LISP"),
    ("SIMPLE-ARRAY" , "U" , "COMMON-LISP"),
    ("SIMPLE-BASE-STRING" , "U" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR" , "U" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR-P" , "U" , "COMMON-LISP"),
    ("SIMPLE-CONDITION" , "U" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-ARGUMENTS" , "U" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-CONTROL" , "U" , "COMMON-LISP"),
    ("SIMPLE-ERROR" , "U" , "COMMON-LISP"),
    ("SIMPLE-STRING" , "U" , "COMMON-LISP"),
    ("SIMPLE-STRING-P" , "U" , "COMMON-LISP"),
    ("SIMPLE-TYPE-ERROR" , "U" , "COMMON-LISP"),
    ("SIMPLE-VECTOR" , "U" , "COMMON-LISP"),
    ("SIMPLE-VECTOR-P" , "U" , "COMMON-LISP"),
    ("SIMPLE-WARNING" , "U" , "COMMON-LISP"),
    ("SIMPLIFY" , "U" , "ACL2"),
    ("SIN" , "U" , "COMMON-LISP"),
    ("SINGLE-FLOAT" , "U" , "COMMON-LISP"),
    ("SINGLE-FLOAT-EPSILON" , "U" , "COMMON-LISP"),
    ("SINGLE-FLOAT-NEGATIVE-EPSILON" , "U" , "COMMON-LISP"),
    ("SINH" , "U" , "COMMON-LISP"),
    ("SIXTH" , "U" , "COMMON-LISP"),
    ("SKIP-PROOFS" , "U" , "ACL2"),
    ("SLEEP" , "U" , "COMMON-LISP"),
    ("SLOT-BOUNDP" , "U" , "COMMON-LISP"),
    ("SLOT-EXISTS-P" , "U" , "COMMON-LISP"),
    ("SLOT-MAKUNBOUND" , "U" , "COMMON-LISP"),
    ("SLOT-MISSING" , "U" , "COMMON-LISP"),
    ("SLOT-UNBOUND" , "U" , "COMMON-LISP"),
    ("SLOT-VALUE" , "U" , "COMMON-LISP"),
    ("SOFTWARE-TYPE" , "U" , "COMMON-LISP"),
    ("SOFTWARE-VERSION" , "U" , "COMMON-LISP"),
    ("SOME" , "U" , "COMMON-LISP"),
    ("SOME-SLASHABLE" , "U" , "ACL2"),
    ("SORT" , "U" , "COMMON-LISP"),
    ("SPACE" , "U" , "COMMON-LISP"),
    ("SPECIAL" , "U" , "COMMON-LISP"),
    ("SPECIAL-OPERATOR-P" , "U" , "COMMON-LISP"),
    ("SPEED" , "U" , "COMMON-LISP"),
    ("SQRT" , "U" , "COMMON-LISP"),
    ("STABLE-SORT" , "U" , "COMMON-LISP"),
    ("STABLE-UNDER-SIMPLIFICATIONP" , "U" , "ACL2"),
    ("STANDARD" , "U" , "COMMON-LISP"),
    ("STANDARD-CHAR" , "U" , "COMMON-LISP"),
    ("STANDARD-CHAR-LISTP" , "U" , "ACL2"),
    ("STANDARD-CHAR-LISTP-APPEND" , "U" , "ACL2"),
    ("STANDARD-CHAR-LISTP-FORWARD-TO-CHARACTER-LISTP" , "U" , "ACL2"),
    ("STANDARD-CHAR-P" , "U" , "COMMON-LISP"),
    ("STANDARD-CHAR-P-NTH" , "U" , "ACL2"),
    ("STANDARD-CLASS" , "U" , "COMMON-LISP"),
    ("STANDARD-CO" , "U" , "ACL2"),
    ("STANDARD-GENERIC-FUNCTION" , "U" , "COMMON-LISP"),
    ("STANDARD-METHOD" , "U" , "COMMON-LISP"),
    ("STANDARD-OBJECT" , "U" , "COMMON-LISP"),
    ("STANDARD-OI" , "U" , "ACL2"),
    ("STANDARD-STRING-ALISTP" , "U" , "ACL2"),
    ("STANDARD-STRING-ALISTP-FORWARD-TO-ALISTP" , "U" , "ACL2"),
    ("START-PROOF-TREE" , "U" , "ACL2"),
    ("STATE" , "U" , "ACL2"),
    ("STATE-GLOBAL-LET*-CLEANUP" , "U" , "ACL2"),
    ("STATE-GLOBAL-LET*-GET-GLOBALS" , "U" , "ACL2"),
    ("STATE-GLOBAL-LET*-PUT-GLOBALS" , "U" , "ACL2"),
    ("STATE-P" , "U" , "ACL2"),
    ("STATE-P-IMPLIES-AND-FORWARD-TO-STATE-P1" , "U" , "ACL2"),
    ("STATE-P1" , "U" , "ACL2"),
    ("STATE-P1-FORWARD" , "U" , "ACL2"),
    ("STATE-P1-UPDATE-MAIN-TIMER" , "U" , "ACL2"),
    ("STATE-P1-UPDATE-NTH-2-WORLD" , "U" , "ACL2"),
    ("STEP" , "U" , "COMMON-LISP"),
    ("STOP-PROOF-TREE" , "U" , "ACL2"),
    ("STORAGE-CONDITION" , "U" , "COMMON-LISP"),
    ("STORE-VALUE" , "U" , "COMMON-LISP"),
    ("STREAM" , "U" , "COMMON-LISP"),
    ("STREAM-ELEMENT-TYPE" , "U" , "COMMON-LISP"),
    ("STREAM-ERROR" , "U" , "COMMON-LISP"),
    ("STREAM-ERROR-STREAM" , "U" , "COMMON-LISP"),
    ("STREAM-EXTERNAL-FORMAT" , "U" , "COMMON-LISP"),
    ("STREAMP" , "U" , "COMMON-LISP"),
    ("STRING" , "U" , "COMMON-LISP"),
    ("STRING-APPEND" , "U" , "ACL2"),
    ("STRING-APPEND-LST" , "U" , "ACL2"),
    ("STRING-CAPITALIZE" , "U" , "COMMON-LISP"),
    ("STRING-DOWNCASE" , "U" , "COMMON-LISP"),
    ("STRING-DOWNCASE1" , "U" , "ACL2"),
    ("STRING-EQUAL" , "U" , "COMMON-LISP"),
    ("STRING-EQUAL1" , "U" , "ACL2"),
    ("STRING-GREATERP" , "U" , "COMMON-LISP"),
    ("STRING-IS-NOT-CIRCULAR" , "U" , "ACL2"),
    ("STRING-LEFT-TRIM" , "U" , "COMMON-LISP"),
    ("STRING-LESSP" , "U" , "COMMON-LISP"),
    ("STRING-LISTP" , "U" , "ACL2"),
    ("STRING-NOT-EQUAL" , "U" , "COMMON-LISP"),
    ("STRING-NOT-GREATERP" , "U" , "COMMON-LISP"),
    ("STRING-NOT-LESSP" , "U" , "COMMON-LISP"),
    ("STRING-RIGHT-TRIM" , "U" , "COMMON-LISP"),
    ("STRING-STREAM" , "U" , "COMMON-LISP"),
    ("STRING-TRIM" , "U" , "COMMON-LISP"),
    ("STRING-UPCASE" , "U" , "COMMON-LISP"),
    ("STRING-UPCASE1" , "U" , "ACL2"),
    ("STRING/=" , "U" , "COMMON-LISP"),
    ("STRING<" , "U" , "COMMON-LISP"),
    ("STRING<-IRREFLEXIVE" , "U" , "ACL2"),
    ("STRING<-L" , "U" , "ACL2"),
    ("STRING<-L-ASYMMETRIC" , "U" , "ACL2"),
    ("STRING<-L-IRREFLEXIVE" , "U" , "ACL2"),
    ("STRING<-L-TRANSITIVE" , "U" , "ACL2"),
    ("STRING<-L-TRICHOTOMY" , "U" , "ACL2"),
    ("STRING<=" , "U" , "COMMON-LISP"),
    ("STRING=" , "U" , "COMMON-LISP"),
    ("STRING>" , "U" , "COMMON-LISP"),
    ("STRING>=" , "U" , "COMMON-LISP"),
    ("STRINGP" , "U" , "COMMON-LISP"),
    ("STRINGP-SYMBOL-PACKAGE-NAME" , "U" , "ACL2"),
    ("STRIP-CARS" , "U" , "ACL2"),
    ("STRIP-CDRS" , "U" , "ACL2"),
    ("STRUCTURE" , "U" , "COMMON-LISP"),
    ("STRUCTURE-CLASS" , "U" , "COMMON-LISP"),
    ("STRUCTURE-OBJECT" , "U" , "COMMON-LISP"),
    ("STYLE-WARNING" , "U" , "COMMON-LISP"),
    ("SUBLIS" , "U" , "COMMON-LISP"),
    ("SUBSEQ" , "U" , "COMMON-LISP"),
    ("SUBSEQ-LIST" , "U" , "ACL2"),
    ("SUBSETP" , "U" , "COMMON-LISP"),
    ("SUBSETP-EQUAL" , "U" , "ACL2"),
    ("SUBST" , "U" , "COMMON-LISP"),
    ("SUBST-IF" , "U" , "COMMON-LISP"),
    ("SUBST-IF-NOT" , "U" , "COMMON-LISP"),
    ("SUBSTITUTE" , "U" , "COMMON-LISP"),
    ("SUBSTITUTE-AC" , "U" , "ACL2"),
    ("SUBSTITUTE-IF" , "U" , "COMMON-LISP"),
    ("SUBSTITUTE-IF-NOT" , "U" , "COMMON-LISP"),
    ("SUBTYPEP" , "U" , "COMMON-LISP"),
    ("SUMMARY" , "U" , "ACL2"),
    ("SVREF" , "U" , "COMMON-LISP"),
    ("SXHASH" , "U" , "COMMON-LISP"),
    ("SYMBOL" , "U" , "COMMON-LISP"),
    ("SYMBOL-<" , "U" , "ACL2"),
    ("SYMBOL-<-ASYMMETRIC" , "U" , "ACL2"),
    ("SYMBOL-<-IRREFLEXIVE" , "U" , "ACL2"),
    ("SYMBOL-<-TRANSITIVE" , "U" , "ACL2"),
    ("SYMBOL-<-TRICHOTOMY" , "U" , "ACL2"),
    ("SYMBOL-ALISTP" , "U" , "ACL2"),
    ("SYMBOL-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "U" , "ACL2"),
    ("SYMBOL-DOUBLET-LISTP" , "U" , "ACL2"),
    ("SYMBOL-EQUALITY" , "U" , "ACL2"),
    ("SYMBOL-FUNCTION" , "U" , "COMMON-LISP"),
    ("SYMBOL-LISTP" , "U" , "ACL2"),
    ("SYMBOL-LISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("SYMBOL-MACROLET" , "U" , "COMMON-LISP"),
    ("SYMBOL-NAME" , "U" , "COMMON-LISP"),
    ("SYMBOL-NAME-INTERN-IN-PACKAGE-OF-SYMBOL" , "U" , "ACL2"),
    ("SYMBOL-PACKAGE" , "U" , "COMMON-LISP"),
    ("SYMBOL-PACKAGE-NAME" , "U" , "ACL2"),
    ("SYMBOL-PLIST" , "U" , "COMMON-LISP"),
    ("SYMBOL-VALUE" , "U" , "COMMON-LISP"),
    ("SYMBOLP" , "U" , "COMMON-LISP"),
    ("SYMBOLP-INTERN-IN-PACKAGE-OF-SYMBOL" , "U" , "ACL2"),
    ("SYNONYM-STREAM" , "U" , "COMMON-LISP"),
    ("SYNONYM-STREAM-SYMBOL" , "U" , "COMMON-LISP"),
    ("SYNP" , "U" , "ACL2"),
    ("SYNTAXP" , "U" , "ACL2"),
    ("SYS-CALL" , "U" , "ACL2"),
    ("SYS-CALL-STATUS" , "U" , "ACL2"),
    ("T" , "U" , "COMMON-LISP"),
    ("T-STACK" , "U" , "ACL2"),
    ("T-STACK-LENGTH" , "U" , "ACL2"),
    ("T-STACK-LENGTH1" , "U" , "ACL2"),
    ("TABLE" , "U" , "ACL2"),
    ("TABLE-ALIST" , "U" , "ACL2"),
    ("TAGBODY" , "U" , "COMMON-LISP"),
    ("TAILP" , "U" , "COMMON-LISP"),
    ("TAKE" , "U" , "ACL2"),
    ("TAN" , "U" , "COMMON-LISP"),
    ("TANH" , "U" , "COMMON-LISP"),
    ("TENTH" , "U" , "COMMON-LISP"),
    ("TERPRI" , "U" , "COMMON-LISP"),
    ("THE" , "U" , "COMMON-LISP"),
    ("THE-ERROR" , "U" , "ACL2"),
    ("THE-FIXNUM" , "U" , "ACL2"),
    ("THE-FIXNUM!" , "U" , "ACL2"),
    ("THEORY" , "U" , "ACL2"),
    ("THEORY-INVARIANT" , "U" , "ACL2"),
    ("THIRD" , "U" , "COMMON-LISP"),
    ("THM" , "U" , "ACL2"),
    ("THROW" , "U" , "COMMON-LISP"),
    ("TIME" , "U" , "COMMON-LISP"),
    ("TIME$" , "U" , "ACL2"),
    ("TIMER-ALISTP" , "U" , "ACL2"),
    ("TIMER-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-SYMBOL-ALISTP" ,
"U" , "ACL2"),
    ("TOGGLE-PC-MACRO" , "U" , "ACL2"),
    ("TRACE" , "U" , "COMMON-LISP"),
    ("TRACE!" , "U" , "ACL2"),
    ("TRACE$" , "U" , "ACL2"),
    ("TRACE*" , "U" , "ACL2"),
    ("TRANS" , "U" , "ACL2"),
    ("TRANS1" , "U" , "ACL2"),
    ("TRANSLATE-LOGICAL-PATHNAME" , "U" , "COMMON-LISP"),
    ("TRANSLATE-PATHNAME" , "U" , "COMMON-LISP"),
    ("TREE-EQUAL" , "U" , "COMMON-LISP"),
    ("TRICHOTOMY" , "U" , "ACL2"),
    ("TRUE-LIST-LISTP" , "U" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP-ASSOC-EQ" , "U" , "ACL2"),
    ("TRUE-LISTP" , "U" , "ACL2"),
    ("TRUE-LISTP-CADR-ASSOC-EQ-FOR-OPEN-CHANNELS-P" , "U" , "ACL2"),
    ("TRUE-LISTP-UPDATE-NTH" , "U" , "ACL2"),
    ("TRUENAME" , "U" , "COMMON-LISP"),
    ("TRUNCATE" , "U" , "COMMON-LISP"),
    ("TWO-WAY-STREAM" , "U" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-INPUT-STREAM" , "U" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-OUTPUT-STREAM" , "U" , "COMMON-LISP"),
    ("TYPE" , "U" , "COMMON-LISP"),
    ("TYPE-ERROR" , "U" , "COMMON-LISP"),
    ("TYPE-ERROR-DATUM" , "U" , "COMMON-LISP"),
    ("TYPE-ERROR-EXPECTED-TYPE" , "U" , "COMMON-LISP"),
    ("TYPE-OF" , "U" , "COMMON-LISP"),
    ("TYPECASE" , "U" , "COMMON-LISP"),
    ("TYPED-IO-LISTP" , "U" , "ACL2"),
    ("TYPED-IO-LISTP-FORWARD-TO-TRUE-LISTP" , "U" , "ACL2"),
    ("TYPEP" , "U" , "COMMON-LISP"),
    ("U" , "U" , "ACL2"),
    ("UBT" , "U" , "ACL2"),
    ("UBT!" , "U" , "ACL2"),
    ("UNARY--" , "U" , "ACL2"),
    ("UNARY-/" , "U" , "ACL2"),
    ("UNARY-FUNCTION-SYMBOL-LISTP" , "U" , "ACL2"),
    ("UNBOUND-SLOT" , "U" , "COMMON-LISP"),
    ("UNBOUND-SLOT-INSTANCE" , "U" , "COMMON-LISP"),
    ("UNBOUND-VARIABLE" , "U" , "COMMON-LISP"),
    ("UNDEFINED-FUNCTION" , "U" , "COMMON-LISP"),
    ("UNEXPORT" , "U" , "COMMON-LISP"),
    ("UNICITY-OF-0" , "U" , "ACL2"),
    ("UNICITY-OF-1" , "U" , "ACL2"),
    ("UNINTERN" , "U" , "COMMON-LISP"),
    ("UNION" , "U" , "COMMON-LISP"),
    ("UNION-EQ" , "U" , "ACL2"),
    ("UNION-EQUAL" , "U" , "ACL2"),
    ("UNION-THEORIES" , "U" , "ACL2"),
    ("UNIVERSAL-THEORY" , "U" , "ACL2"),
    ("UNLESS" , "U" , "COMMON-LISP"),
    ("UNMEMOIZE" , "U" , "ACL2"),
    ("UNMONITOR" , "U" , "ACL2"),
    ("UNREAD-CHAR" , "U" , "COMMON-LISP"),
    ("UNSAVE" , "U" , "ACL2"),
    ("UNSIGNED-BYTE" , "U" , "COMMON-LISP"),
    ("UNTRACE" , "U" , "COMMON-LISP"),
    ("UNTRACE$" , "U" , "ACL2"),
    ("UNUSE-PACKAGE" , "U" , "COMMON-LISP"),
    ("UNWIND-PROTECT" , "U" , "COMMON-LISP"),
    ("UPDATE-32-BIT-INTEGER-STACK" , "U" , "ACL2"),
    ("UPDATE-ACL2-ORACLE" , "U" , "ACL2"),
    ("UPDATE-ACL2-ORACLE-PRESERVES-STATE-P1" , "U" , "ACL2"),
    ("UPDATE-BIG-CLOCK-ENTRY" , "U" , "ACL2"),
    ("UPDATE-FILE-CLOCK" , "U" , "ACL2"),
    ("UPDATE-GLOBAL-TABLE" , "U" , "ACL2"),
    ("UPDATE-IDATES" , "U" , "ACL2"),
    ("UPDATE-INSTANCE-FOR-DIFFERENT-CLASS" , "U" , "COMMON-LISP"),
    ("UPDATE-INSTANCE-FOR-REDEFINED-CLASS" , "U" , "COMMON-LISP"),
    ("UPDATE-LIST-ALL-PACKAGE-NAMES-LST" , "U" , "ACL2"),
    ("UPDATE-NTH" , "U" , "ACL2"),
    ("UPDATE-OPEN-INPUT-CHANNELS" , "U" , "ACL2"),
    ("UPDATE-OPEN-OUTPUT-CHANNELS" , "U" , "ACL2"),
    ("UPDATE-READ-FILES" , "U" , "ACL2"),
    ("UPDATE-T-STACK" , "U" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST" , "U" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST1" , "U" , "ACL2"),
    ("UPDATE-WRITTEN-FILES" , "U" , "ACL2"),
    ("UPGRADED-ARRAY-ELEMENT-TYPE" , "U" , "COMMON-LISP"),
    ("UPGRADED-COMPLEX-PART-TYPE" , "U" , "COMMON-LISP"),
    ("UPPER-CASE-P" , "U" , "COMMON-LISP"),
    ("UPPER-CASE-P-CHAR-UPCASE" , "U" , "ACL2"),
    ("UPPER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "U" , "ACL2"),
    ("USE-PACKAGE" , "U" , "COMMON-LISP"),
    ("USE-VALUE" , "U" , "COMMON-LISP"),
    ("USER-HOMEDIR-PATHNAME" , "U" , "COMMON-LISP"),
    ("USER-STOBJ-ALIST" , "U" , "ACL2"),
    ("USER-STOBJ-ALIST1" , "U" , "ACL2"),
    ("VALUE-TRIPLE" , "U" , "ACL2"),
    ("VALUES" , "U" , "COMMON-LISP"),
    ("VALUES-LIST" , "U" , "COMMON-LISP"),
    ("VARIABLE" , "U" , "COMMON-LISP"),
    ("VECTOR" , "U" , "COMMON-LISP"),
    ("VECTOR-POP" , "U" , "COMMON-LISP"),
    ("VECTOR-PUSH" , "U" , "COMMON-LISP"),
    ("VECTOR-PUSH-EXTEND" , "U" , "COMMON-LISP"),
    ("VECTORP" , "U" , "COMMON-LISP"),
    ("VERBOSE-PSTACK" , "U" , "ACL2"),
    ("VERIFY" , "U" , "ACL2"),
    ("VERIFY-GUARDS" , "U" , "ACL2"),
    ("VERIFY-TERMINATION" , "U" , "ACL2"),
    ("W" , "U" , "ACL2"),
    ("WARN" , "U" , "COMMON-LISP"),
    ("WARNING" , "U" , "COMMON-LISP"),
    ("WARNING!" , "U" , "ACL2"),
    ("WHEN" , "U" , "COMMON-LISP"),
    ("WILD-PATHNAME-P" , "U" , "COMMON-LISP"),
    ("WITH-ACCESSORS" , "U" , "COMMON-LISP"),
    ("WITH-COMPILATION-UNIT" , "U" , "COMMON-LISP"),
    ("WITH-CONDITION-RESTARTS" , "U" , "COMMON-LISP"),
    ("WITH-HASH-TABLE-ITERATOR" , "U" , "COMMON-LISP"),
    ("WITH-INPUT-FROM-STRING" , "U" , "COMMON-LISP"),
    ("WITH-OPEN-FILE" , "U" , "COMMON-LISP"),
    ("WITH-OPEN-STREAM" , "U" , "COMMON-LISP"),
    ("WITH-OUTPUT" , "U" , "ACL2"),
    ("WITH-OUTPUT-TO-STRING" , "U" , "COMMON-LISP"),
    ("WITH-PACKAGE-ITERATOR" , "U" , "COMMON-LISP"),
    ("WITH-SIMPLE-RESTART" , "U" , "COMMON-LISP"),
    ("WITH-SLOTS" , "U" , "COMMON-LISP"),
    ("WITH-STANDARD-IO-SYNTAX" , "U" , "COMMON-LISP"),
    ("WORLD" , "U" , "ACL2"),
    ("WORMHOLE" , "U" , "ACL2"),
    ("WORMHOLE-EVAL" , "U" , "ACL2"),
    ("WORMHOLE1" , "U" , "ACL2"),
    ("WRITABLE-FILE-LISTP" , "U" , "ACL2"),
    ("WRITABLE-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "U" , "ACL2"),
    ("WRITABLE-FILE-LISTP1" , "U" , "ACL2"),
    ("WRITABLE-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "U" ,
"ACL2"),
    ("WRITE" , "U" , "COMMON-LISP"),
    ("WRITE-BYTE" , "U" , "COMMON-LISP"),
    ("WRITE-BYTE$" , "U" , "ACL2"),
    ("WRITE-CHAR" , "U" , "COMMON-LISP"),
    ("WRITE-LINE" , "U" , "COMMON-LISP"),
    ("WRITE-SEQUENCE" , "U" , "COMMON-LISP"),
    ("WRITE-STRING" , "U" , "COMMON-LISP"),
    ("WRITE-TO-STRING" , "U" , "COMMON-LISP"),
    ("WRITEABLE-FILES" , "U" , "ACL2"),
    ("WRITEABLE-FILES-P" , "U" , "ACL2"),
    ("WRITEABLE-FILES-P-FORWARD-TO-WRITABLE-FILE-LISTP" , "U" , "ACL2"),
    ("WRITTEN-FILE" , "U" , "ACL2"),
    ("WRITTEN-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "U" , "ACL2"),
    ("WRITTEN-FILE-LISTP" , "U" , "ACL2"),
    ("WRITTEN-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" , "U"
, "ACL2"),
    ("WRITTEN-FILES" , "U" , "ACL2"),
    ("WRITTEN-FILES-P" , "U" , "ACL2"),
    ("WRITTEN-FILES-P-FORWARD-TO-WRITTEN-FILE-LISTP" , "U" , "ACL2"),
    ("XARGS" , "U" , "ACL2"),
    ("XXXJOIN" , "U" , "ACL2"),
    ("Y-OR-N-P" , "U" , "COMMON-LISP"),
    ("YES-OR-NO-P" , "U" , "COMMON-LISP"),
    ("ZERO" , "U" , "ACL2"),
    ("ZEROP" , "U" , "COMMON-LISP"),
    ("ZIP" , "U" , "ACL2"),
    ("ZP" , "U" , "ACL2"),
    ("&" , "ACL2-ASG" , "ACL2"),
    ("&ALLOW-OTHER-KEYS" , "ACL2-ASG" , "COMMON-LISP"),
    ("&AUX" , "ACL2-ASG" , "COMMON-LISP"),
    ("&BODY" , "ACL2-ASG" , "COMMON-LISP"),
    ("&ENVIRONMENT" , "ACL2-ASG" , "COMMON-LISP"),
    ("&KEY" , "ACL2-ASG" , "COMMON-LISP"),
    ("&OPTIONAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("&REST" , "ACL2-ASG" , "COMMON-LISP"),
    ("&WHOLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("*" , "ACL2-ASG" , "COMMON-LISP"),
    ("**" , "ACL2-ASG" , "COMMON-LISP"),
    ("***" , "ACL2-ASG" , "COMMON-LISP"),
    ("*ACL2-EXPORTS*" , "ACL2-ASG" , "ACL2"),
    ("*BREAK-ON-SIGNALS*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*COMMON-LISP-SPECIALS-AND-CONSTANTS*" , "ACL2-ASG" , "ACL2"),
    ("*COMMON-LISP-SYMBOLS-FROM-MAIN-LISP-PACKAGE*" , "ACL2-ASG" ,
"ACL2"),
    ("*COMPILE-FILE-PATHNAME*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*COMPILE-FILE-TRUENAME*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*COMPILE-PRINT*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*COMPILE-VERBOSE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*DEBUG-IO*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*DEBUGGER-HOOK*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*DEFAULT-PATHNAME-DEFAULTS*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*ERROR-OUTPUT*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*FEATURES*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*GENSYM-COUNTER*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*LOAD-PATHNAME*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*LOAD-PRINT*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*LOAD-TRUENAME*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*LOAD-VERBOSE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*MACROEXPAND-HOOK*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*MAIN-LISP-PACKAGE-NAME*" , "ACL2-ASG" , "ACL2"),
    ("*MODULES*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PACKAGE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-ARRAY*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-BASE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-CASE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-CIRCLE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-ESCAPE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-GENSYM*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-LENGTH*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-LEVEL*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-LINES*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-MISER-WIDTH*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-PPRINT-DISPATCH*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-PRETTY*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-RADIX*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-READABLY*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*PRINT-RIGHT-MARGIN*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*QUERY-IO*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*RANDOM-STATE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*READ-BASE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*READ-DEFAULT-FLOAT-FORMAT*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*READ-EVAL*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*READ-SUPPRESS*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*READTABLE*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*STANDARD-CHARS*" , "ACL2-ASG" , "ACL2"),
    ("*STANDARD-CI*" , "ACL2-ASG" , "ACL2"),
    ("*STANDARD-CO*" , "ACL2-ASG" , "ACL2"),
    ("*STANDARD-INPUT*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*STANDARD-OI*" , "ACL2-ASG" , "ACL2"),
    ("*STANDARD-OUTPUT*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*TERMINAL-IO*" , "ACL2-ASG" , "COMMON-LISP"),
    ("*TRACE-OUTPUT*" , "ACL2-ASG" , "COMMON-LISP"),
    ("+" , "ACL2-ASG" , "COMMON-LISP"),
    ("++" , "ACL2-ASG" , "COMMON-LISP"),
    ("+++" , "ACL2-ASG" , "COMMON-LISP"),
    ("-" , "ACL2-ASG" , "COMMON-LISP"),
    ("/" , "ACL2-ASG" , "COMMON-LISP"),
    ("//" , "ACL2-ASG" , "COMMON-LISP"),
    ("///" , "ACL2-ASG" , "COMMON-LISP"),
    ("/=" , "ACL2-ASG" , "COMMON-LISP"),
    ("1+" , "ACL2-ASG" , "COMMON-LISP"),
    ("1-" , "ACL2-ASG" , "COMMON-LISP"),
    ("32-BIT-INTEGER-LISTP" , "ACL2-ASG" , "ACL2"),
    ("32-BIT-INTEGER-LISTP-FORWARD-TO-INTEGER-LISTP" , "ACL2-ASG" ,
"ACL2"),
    ("32-BIT-INTEGER-STACK" , "ACL2-ASG" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH" , "ACL2-ASG" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH1" , "ACL2-ASG" , "ACL2"),
    ("32-BIT-INTEGERP" , "ACL2-ASG" , "ACL2"),
    ("32-BIT-INTEGERP-FORWARD-TO-INTEGERP" , "ACL2-ASG" , "ACL2"),
    ("<" , "ACL2-ASG" , "COMMON-LISP"),
    ("<-ON-OTHERS" , "ACL2-ASG" , "ACL2"),
    ("<=" , "ACL2-ASG" , "COMMON-LISP"),
    ("=" , "ACL2-ASG" , "COMMON-LISP"),
    (">" , "ACL2-ASG" , "COMMON-LISP"),
    (">=" , "ACL2-ASG" , "COMMON-LISP"),
    ("?-FN" , "ACL2-ASG" , "ACL2"),
    ("@" , "ACL2-ASG" , "ACL2"),
    ("ABORT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ABORT!" , "ACL2-ASG" , "ACL2"),
    ("ABS" , "ACL2-ASG" , "COMMON-LISP"),
    ("ACCUMULATED-PERSISTENCE" , "ACL2-ASG" , "ACL2"),
    ("ACL2-COUNT" , "ACL2-ASG" , "ACL2"),
    ("ACL2-INPUT-CHANNEL-PACKAGE" , "ACL2-ASG" , "ACL2"),
    ("ACL2-NUMBERP" , "ACL2-ASG" , "ACL2"),
    ("ACL2-ORACLE" , "ACL2-ASG" , "ACL2"),
    ("ACL2-OUTPUT-CHANNEL-PACKAGE" , "ACL2-ASG" , "ACL2"),
    ("ACL2-PACKAGE" , "ACL2-ASG" , "ACL2"),
    ("ACONS" , "ACL2-ASG" , "COMMON-LISP"),
    ("ACOS" , "ACL2-ASG" , "COMMON-LISP"),
    ("ACOSH" , "ACL2-ASG" , "COMMON-LISP"),
    ("ACTIVE-RUNEP" , "ACL2-ASG" , "ACL2"),
    ("ADD-BINOP" , "ACL2-ASG" , "ACL2"),
    ("ADD-DEFAULT-HINTS" , "ACL2-ASG" , "ACL2"),
    ("ADD-DEFAULT-HINTS!" , "ACL2-ASG" , "ACL2"),
    ("ADD-INVISIBLE-FNS" , "ACL2-ASG" , "ACL2"),
    ("ADD-MACRO-ALIAS" , "ACL2-ASG" , "ACL2"),
    ("ADD-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("ADD-NTH-ALIAS" , "ACL2-ASG" , "ACL2"),
    ("ADD-PAIR" , "ACL2-ASG" , "ACL2"),
    ("ADD-PAIR-PRESERVES-ALL-BOUNDP" , "ACL2-ASG" , "ACL2"),
    ("ADD-TIMERS" , "ACL2-ASG" , "ACL2"),
    ("ADD-TO-SET-EQ" , "ACL2-ASG" , "ACL2"),
    ("ADD-TO-SET-EQL" , "ACL2-ASG" , "ACL2"),
    ("ADD-TO-SET-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("ADJOIN" , "ACL2-ASG" , "COMMON-LISP"),
    ("ADJUST-ARRAY" , "ACL2-ASG" , "COMMON-LISP"),
    ("ADJUSTABLE-ARRAY-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("ALISTP" , "ACL2-ASG" , "ACL2"),
    ("ALISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("ALL-BOUNDP" , "ACL2-ASG" , "ACL2"),
    ("ALL-BOUNDP-PRESERVES-ASSOC" , "ACL2-ASG" , "ACL2"),
    ("ALL-VARS" , "ACL2-ASG" , "ACL2"),
    ("ALL-VARS1" , "ACL2-ASG" , "ACL2"),
    ("ALL-VARS1-LST" , "ACL2-ASG" , "ACL2"),
    ("ALLOCATE-INSTANCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("ALPHA-CHAR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("ALPHA-CHAR-P-FORWARD-TO-CHARACTERP" , "ACL2-ASG" , "ACL2"),
    ("ALPHANUMERICP" , "ACL2-ASG" , "COMMON-LISP"),
    ("AND" , "ACL2-ASG" , "COMMON-LISP"),
    ("AND-MACRO" , "ACL2-ASG" , "ACL2"),
    ("APPEND" , "ACL2-ASG" , "COMMON-LISP"),
    ("APPLY" , "ACL2-ASG" , "COMMON-LISP"),
    ("APROPOS" , "ACL2-ASG" , "COMMON-LISP"),
    ("APROPOS-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("AREF" , "ACL2-ASG" , "COMMON-LISP"),
    ("AREF-32-BIT-INTEGER-STACK" , "ACL2-ASG" , "ACL2"),
    ("AREF-T-STACK" , "ACL2-ASG" , "ACL2"),
    ("AREF1" , "ACL2-ASG" , "ACL2"),
    ("AREF2" , "ACL2-ASG" , "ACL2"),
    ("ARGS" , "ACL2-ASG" , "ACL2"),
    ("ARITHMETIC-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERANDS" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERATION" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-DIMENSION" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-DIMENSION-LIMIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-DIMENSIONS" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-DISPLACEMENT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-ELEMENT-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-HAS-FILL-POINTER-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-IN-BOUNDS-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-RANK" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-RANK-LIMIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-ROW-MAJOR-INDEX" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE-LIMIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ARRAY1P" , "ACL2-ASG" , "ACL2"),
    ("ARRAY1P-CONS" , "ACL2-ASG" , "ACL2"),
    ("ARRAY1P-FORWARD" , "ACL2-ASG" , "ACL2"),
    ("ARRAY1P-LINEAR" , "ACL2-ASG" , "ACL2"),
    ("ARRAY2P" , "ACL2-ASG" , "ACL2"),
    ("ARRAY2P-CONS" , "ACL2-ASG" , "ACL2"),
    ("ARRAY2P-FORWARD" , "ACL2-ASG" , "ACL2"),
    ("ARRAY2P-LINEAR" , "ACL2-ASG" , "ACL2"),
    ("ARRAYP" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASET-32-BIT-INTEGER-STACK" , "ACL2-ASG" , "ACL2"),
    ("ASET-T-STACK" , "ACL2-ASG" , "ACL2"),
    ("ASET1" , "ACL2-ASG" , "ACL2"),
    ("ASET2" , "ACL2-ASG" , "ACL2"),
    ("ASH" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASIN" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASINH" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASSERT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASSERT$" , "ACL2-ASG" , "ACL2"),
    ("ASSIGN" , "ACL2-ASG" , "ACL2"),
    ("ASSOC" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASSOC-ADD-PAIR" , "ACL2-ASG" , "ACL2"),
    ("ASSOC-EQ" , "ACL2-ASG" , "ACL2"),
    ("ASSOC-EQ-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("ASSOC-EQ-EQUAL-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("ASSOC-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("ASSOC-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASSOC-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ASSOC-KEYWORD" , "ACL2-ASG" , "ACL2"),
    ("ASSOC-STRING-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("ASSOC2" , "ACL2-ASG" , "ACL2"),
    ("ASSOCIATIVITY-OF-*" , "ACL2-ASG" , "ACL2"),
    ("ASSOCIATIVITY-OF-+" , "ACL2-ASG" , "ACL2"),
    ("ASSUME" , "ACL2-ASG" , "ACL2"),
    ("ATAN" , "ACL2-ASG" , "COMMON-LISP"),
    ("ATANH" , "ACL2-ASG" , "COMMON-LISP"),
    ("ATOM" , "ACL2-ASG" , "COMMON-LISP"),
    ("ATOM-LISTP" , "ACL2-ASG" , "ACL2"),
    ("ATOM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("BASE-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BASE-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIG-CLOCK-ENTRY" , "ACL2-ASG" , "ACL2"),
    ("BIG-CLOCK-NEGATIVE-P" , "ACL2-ASG" , "ACL2"),
    ("BIGNUM" , "ACL2-ASG" , "COMMON-LISP"),
    ("BINARY-*" , "ACL2-ASG" , "ACL2"),
    ("BINARY-+" , "ACL2-ASG" , "ACL2"),
    ("BINARY-APPEND" , "ACL2-ASG" , "ACL2"),
    ("BIND-FREE" , "ACL2-ASG" , "ACL2"),
    ("BINOP-TABLE" , "ACL2-ASG" , "ACL2"),
    ("BIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-AND" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-ANDC1" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-ANDC2" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-EQV" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-IOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-NAND" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-NOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-ORC1" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-ORC2" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-VECTOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-VECTOR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("BIT-XOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BLOCK" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-1" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-2" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-AND" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-ANDC1" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-ANDC2" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-C1" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-C2" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-CLR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-EQV" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-IOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-NAND" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-NOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-ORC1" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-ORC2" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-SET" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLE-XOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLEAN" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOOLEAN-LISTP" , "ACL2-ASG" , "ACL2"),
    ("BOOLEAN-LISTP-CONS" , "ACL2-ASG" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD" , "ACL2-ASG" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD-TO-SYMBOL-LISTP" , "ACL2-ASG" , "ACL2"),
    ("BOOLEANP" , "ACL2-ASG" , "ACL2"),
    ("BOOLEANP-CHARACTERP" , "ACL2-ASG" , "ACL2"),
    ("BOOLEANP-COMPOUND-RECOGNIZER" , "ACL2-ASG" , "ACL2"),
    ("BOTH-CASE-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOUNDED-INTEGER-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("BOUNDED-INTEGER-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-ASG"
, "ACL2"),
    ("BOUNDED-INTEGER-ALISTP2" , "ACL2-ASG" , "ACL2"),
    ("BOUNDP" , "ACL2-ASG" , "COMMON-LISP"),
    ("BOUNDP-GLOBAL" , "ACL2-ASG" , "ACL2"),
    ("BOUNDP-GLOBAL1" , "ACL2-ASG" , "ACL2"),
    ("BREAK" , "ACL2-ASG" , "COMMON-LISP"),
    ("BROADCAST-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("BROADCAST-STREAM-STREAMS" , "ACL2-ASG" , "COMMON-LISP"),
    ("BRR" , "ACL2-ASG" , "ACL2"),
    ("BRR@" , "ACL2-ASG" , "ACL2"),
    ("BUILD-STATE1" , "ACL2-ASG" , "ACL2"),
    ("BUILT-IN-CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("BUTLAST" , "ACL2-ASG" , "COMMON-LISP"),
    ("BYTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("BYTE-POSITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("BYTE-SIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAAAAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAAADR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAAAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAADAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAADDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAADR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CADAAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CADADR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CADAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CADDAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CADDDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CADDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CADR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CALL-ARGUMENTS-LIMIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("CALL-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("CALL-NEXT-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CAR-CDR-ELIM" , "ACL2-ASG" , "ACL2"),
    ("CAR-CONS" , "ACL2-ASG" , "ACL2"),
    ("CASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CASE-LIST" , "ACL2-ASG" , "ACL2"),
    ("CASE-LIST-CHECK" , "ACL2-ASG" , "ACL2"),
    ("CASE-MATCH" , "ACL2-ASG" , "ACL2"),
    ("CASE-SPLIT" , "ACL2-ASG" , "ACL2"),
    ("CASE-TEST" , "ACL2-ASG" , "ACL2"),
    ("CATCH" , "ACL2-ASG" , "COMMON-LISP"),
    ("CBD" , "ACL2-ASG" , "ACL2"),
    ("CCASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDAAAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDAADR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDAAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDADAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDADDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDADR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDDAAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDDADR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDDAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDDDAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDDDDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDDDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CDR-CONS" , "ACL2-ASG" , "ACL2"),
    ("CDRN" , "ACL2-ASG" , "ACL2"),
    ("CEILING" , "ACL2-ASG" , "COMMON-LISP"),
    ("CELL-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CELL-ERROR-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("CERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CERTIFY-BOOK" , "ACL2-ASG" , "ACL2"),
    ("CERTIFY-BOOK!" , "ACL2-ASG" , "ACL2"),
    ("CHANGE-CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-CODE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-CODE-CODE-CHAR-IS-IDENTITY" , "ACL2-ASG" , "ACL2"),
    ("CHAR-CODE-LIMIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-CODE-LINEAR" , "ACL2-ASG" , "ACL2"),
    ("CHAR-DOWNCASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-EQUAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-GREATERP" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-INT" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-LESSP" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-NOT-EQUAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-NOT-GREATERP" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-NOT-LESSP" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR-UPCASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR/=" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR<" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR<=" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR=" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR>" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHAR>=" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHARACTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHARACTER-LISTP" , "ACL2-ASG" , "ACL2"),
    ("CHARACTER-LISTP-APPEND" , "ACL2-ASG" , "ACL2"),
    ("CHARACTER-LISTP-COERCE" , "ACL2-ASG" , "ACL2"),
    ("CHARACTER-LISTP-FORWARD-TO-EQLABLE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("CHARACTER-LISTP-REMOVE-DUPLICATES-EQL" , "ACL2-ASG" , "ACL2"),
    ("CHARACTER-LISTP-REVAPPEND" , "ACL2-ASG" , "ACL2"),
    ("CHARACTER-LISTP-STRING-DOWNCASE-1" , "ACL2-ASG" , "ACL2"),
    ("CHARACTER-LISTP-STRING-UPCASE1-1" , "ACL2-ASG" , "ACL2"),
    ("CHARACTERP" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHARACTERP-CHAR-DOWNCASE" , "ACL2-ASG" , "ACL2"),
    ("CHARACTERP-CHAR-UPCASE" , "ACL2-ASG" , "ACL2"),
    ("CHARACTERP-NTH" , "ACL2-ASG" , "ACL2"),
    ("CHARACTERP-PAGE" , "ACL2-ASG" , "ACL2"),
    ("CHARACTERP-RUBOUT" , "ACL2-ASG" , "ACL2"),
    ("CHARACTERP-TAB" , "ACL2-ASG" , "ACL2"),
    ("CHECK-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CHECK-VARS-NOT-FREE" , "ACL2-ASG" , "ACL2"),
    ("CHECKPOINT-FORCED-GOALS" , "ACL2-ASG" , "ACL2"),
    ("CIS" , "ACL2-ASG" , "COMMON-LISP"),
    ("CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("CLASS-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("CLASS-OF" , "ACL2-ASG" , "COMMON-LISP"),
    ("CLAUSE" , "ACL2-ASG" , "ACL2"),
    ("CLEAR-HASH-TABLES" , "ACL2-ASG" , "ACL2"),
    ("CLEAR-INPUT" , "ACL2-ASG" , "COMMON-LISP"),
    ("CLEAR-MEMOIZE-TABLE" , "ACL2-ASG" , "ACL2"),
    ("CLEAR-MEMOIZE-TABLES" , "ACL2-ASG" , "ACL2"),
    ("CLEAR-OUTPUT" , "ACL2-ASG" , "COMMON-LISP"),
    ("CLOSE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CLOSE-INPUT-CHANNEL" , "ACL2-ASG" , "ACL2"),
    ("CLOSE-OUTPUT-CHANNEL" , "ACL2-ASG" , "ACL2"),
    ("CLOSE-TRACE-FILE" , "ACL2-ASG" , "ACL2"),
    ("CLOSURE" , "ACL2-ASG" , "ACL2"),
    ("CLRHASH" , "ACL2-ASG" , "COMMON-LISP"),
    ("CODE-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("CODE-CHAR-CHAR-CODE-IS-IDENTITY" , "ACL2-ASG" , "ACL2"),
    ("CODE-CHAR-TYPE" , "ACL2-ASG" , "ACL2"),
    ("COERCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("COERCE-INVERSE-1" , "ACL2-ASG" , "ACL2"),
    ("COERCE-INVERSE-2" , "ACL2-ASG" , "ACL2"),
    ("COERCE-OBJECT-TO-STATE" , "ACL2-ASG" , "ACL2"),
    ("COERCE-STATE-TO-OBJECT" , "ACL2-ASG" , "ACL2"),
    ("COMMUTATIVITY-OF-*" , "ACL2-ASG" , "ACL2"),
    ("COMMUTATIVITY-OF-+" , "ACL2-ASG" , "ACL2"),
    ("COMP" , "ACL2-ASG" , "ACL2"),
    ("COMPILATION-SPEED" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPILE" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPILE-FILE" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPILE-FILE-PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPILED-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPILED-FUNCTION-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPILER-MACRO" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPILER-MACRO-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPLEMENT" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPLETION-OF-*" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-+" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-<" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-CAR" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-CDR" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-CHAR-CODE" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-CODE-CHAR" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-COERCE" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-COMPLEX" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-DENOMINATOR" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-IMAGPART" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-NUMERATOR" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-REALPART" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-NAME" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-PACKAGE-NAME" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-UNARY-/" , "ACL2-ASG" , "ACL2"),
    ("COMPLETION-OF-UNARY-MINUS" , "ACL2-ASG" , "ACL2"),
    ("COMPLEX" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPLEX-0" , "ACL2-ASG" , "ACL2"),
    ("COMPLEX-DEFINITION" , "ACL2-ASG" , "ACL2"),
    ("COMPLEX-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("COMPLEX-IMPLIES1" , "ACL2-ASG" , "ACL2"),
    ("COMPLEX-RATIONALP" , "ACL2-ASG" , "ACL2"),
    ("COMPLEXP" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPRESS1" , "ACL2-ASG" , "ACL2"),
    ("COMPRESS11" , "ACL2-ASG" , "ACL2"),
    ("COMPRESS2" , "ACL2-ASG" , "ACL2"),
    ("COMPRESS21" , "ACL2-ASG" , "ACL2"),
    ("COMPRESS211" , "ACL2-ASG" , "ACL2"),
    ("COMPUTE-APPLICABLE-METHODS" , "ACL2-ASG" , "COMMON-LISP"),
    ("COMPUTE-RESTARTS" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONCATENATE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONCATENATED-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONCATENATED-STREAM-STREAMS" , "ACL2-ASG" , "COMMON-LISP"),
    ("COND" , "ACL2-ASG" , "COMMON-LISP"),
    ("COND-CLAUSESP" , "ACL2-ASG" , "ACL2"),
    ("COND-MACRO" , "ACL2-ASG" , "ACL2"),
    ("CONDITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONJUGATE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONS" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONS-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("CONS-SUBTREES" , "ACL2-ASG" , "ACL2"),
    ("CONSP" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONSP-ASSOC" , "ACL2-ASG" , "ACL2"),
    ("CONSP-ASSOC-EQ" , "ACL2-ASG" , "ACL2"),
    ("CONSTANTLY" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONSTANTP" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONTINUE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CONTROL-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-ALIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-PPRINT-DISPATCH" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-READTABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-SEQ" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-STRUCTURE" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-SYMBOL" , "ACL2-ASG" , "COMMON-LISP"),
    ("COPY-TREE" , "ACL2-ASG" , "COMMON-LISP"),
    ("COS" , "ACL2-ASG" , "COMMON-LISP"),
    ("COSH" , "ACL2-ASG" , "COMMON-LISP"),
    ("COUNT" , "ACL2-ASG" , "COMMON-LISP"),
    ("COUNT-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("COUNT-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("CTYPECASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("CURRENT-PACKAGE" , "ACL2-ASG" , "ACL2"),
    ("CURRENT-THEORY" , "ACL2-ASG" , "ACL2"),
    ("CW" , "ACL2-ASG" , "ACL2"),
    ("CW-GSTACK" , "ACL2-ASG" , "ACL2"),
    ("DEBUG" , "ACL2-ASG" , "COMMON-LISP"),
    ("DECF" , "ACL2-ASG" , "COMMON-LISP"),
    ("DECLAIM" , "ACL2-ASG" , "COMMON-LISP"),
    ("DECLARATION" , "ACL2-ASG" , "COMMON-LISP"),
    ("DECLARE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DECODE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("DECODE-UNIVERSAL-TIME" , "ACL2-ASG" , "COMMON-LISP"),
    ("DECREMENT-BIG-CLOCK" , "ACL2-ASG" , "ACL2"),
    ("DEFABBREV" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-*-1" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-*-2" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-+-1" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-+-2" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-<-1" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-<-2" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-CAR" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-CDR" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-CHAR-CODE" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-COERCE-1" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-COERCE-2" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-COERCE-3" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-COMPILE-FNS" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-COMPLEX-1" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-COMPLEX-2" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-DEFUN-MODE" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-DEFUN-MODE-FROM-STATE" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-DENOMINATOR" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-IMAGPART" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-MEASURE-FUNCTION" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-NUMERATOR" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-REALPART" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-SYMBOL-NAME" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-SYMBOL-PACKAGE-NAME" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-UNARY-/" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-UNARY-MINUS" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-VERIFY-GUARDS-EAGERNESS" , "ACL2-ASG" , "ACL2"),
    ("DEFAULT-WELL-FOUNDED-RELATION" , "ACL2-ASG" , "ACL2"),
    ("DEFAXIOM" , "ACL2-ASG" , "ACL2"),
    ("DEFCHOOSE" , "ACL2-ASG" , "ACL2"),
    ("DEFCLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFCONG" , "ACL2-ASG" , "ACL2"),
    ("DEFCONST" , "ACL2-ASG" , "ACL2"),
    ("DEFCONSTANT" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFDOC" , "ACL2-ASG" , "ACL2"),
    ("DEFEQUIV" , "ACL2-ASG" , "ACL2"),
    ("DEFEVALUATOR" , "ACL2-ASG" , "ACL2"),
    ("DEFEXEC" , "ACL2-ASG" , "ACL2"),
    ("DEFGENERIC" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFINE-COMPILER-MACRO" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFINE-CONDITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFINE-METHOD-COMBINATION" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFINE-MODIFY-MACRO" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFINE-PC-ATOMIC-MACRO" , "ACL2-ASG" , "ACL2"),
    ("DEFINE-PC-HELP" , "ACL2-ASG" , "ACL2"),
    ("DEFINE-PC-MACRO" , "ACL2-ASG" , "ACL2"),
    ("DEFINE-SETF-EXPANDER" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFINE-SYMBOL-MACRO" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFLABEL" , "ACL2-ASG" , "ACL2"),
    ("DEFMACRO" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFMETHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFPACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFPARAMETER" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFPKG" , "ACL2-ASG" , "ACL2"),
    ("DEFREFINEMENT" , "ACL2-ASG" , "ACL2"),
    ("DEFSETF" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFSTOBJ" , "ACL2-ASG" , "ACL2"),
    ("DEFSTRUCT" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFSTUB" , "ACL2-ASG" , "ACL2"),
    ("DEFTHEORY" , "ACL2-ASG" , "ACL2"),
    ("DEFTHM" , "ACL2-ASG" , "ACL2"),
    ("DEFTHMD" , "ACL2-ASG" , "ACL2"),
    ("DEFTTAG" , "ACL2-ASG" , "ACL2"),
    ("DEFTYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFUN" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEFUN-NX" , "ACL2-ASG" , "ACL2"),
    ("DEFUN-SK" , "ACL2-ASG" , "ACL2"),
    ("DEFUND" , "ACL2-ASG" , "ACL2"),
    ("DEFUND-NX" , "ACL2-ASG" , "ACL2"),
    ("DEFUNS" , "ACL2-ASG" , "ACL2"),
    ("DEFVAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("DELETE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DELETE-DUPLICATES" , "ACL2-ASG" , "COMMON-LISP"),
    ("DELETE-FILE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DELETE-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("DELETE-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("DELETE-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DELETE-PAIR" , "ACL2-ASG" , "ACL2"),
    ("DENOMINATOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("DEPOSIT-FIELD" , "ACL2-ASG" , "COMMON-LISP"),
    ("DESCRIBE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DESCRIBE-OBJECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("DESTRUCTURING-BIND" , "ACL2-ASG" , "COMMON-LISP"),
    ("DIGIT-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("DIGIT-CHAR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("DIGIT-TO-CHAR" , "ACL2-ASG" , "ACL2"),
    ("DIMENSIONS" , "ACL2-ASG" , "ACL2"),
    ("DIRECTORY" , "ACL2-ASG" , "COMMON-LISP"),
    ("DIRECTORY-NAMESTRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("DISABLE" , "ACL2-ASG" , "ACL2"),
    ("DISABLE-FORCING" , "ACL2-ASG" , "ACL2"),
    ("DISABLEDP" , "ACL2-ASG" , "ACL2"),
    ("DISASSEMBLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DISTRIBUTIVITY" , "ACL2-ASG" , "ACL2"),
    ("DIVISION-BY-ZERO" , "ACL2-ASG" , "COMMON-LISP"),
    ("DO" , "ACL2-ASG" , "COMMON-LISP"),
    ("DO*" , "ACL2-ASG" , "COMMON-LISP"),
    ("DO-ALL-SYMBOLS" , "ACL2-ASG" , "COMMON-LISP"),
    ("DO-EXTERNAL-SYMBOLS" , "ACL2-ASG" , "COMMON-LISP"),
    ("DO-SYMBOLS" , "ACL2-ASG" , "COMMON-LISP"),
    ("DOC" , "ACL2-ASG" , "ACL2"),
    ("DOC!" , "ACL2-ASG" , "ACL2"),
    ("DOCS" , "ACL2-ASG" , "ACL2"),
    ("DOCUMENTATION" , "ACL2-ASG" , "COMMON-LISP"),
    ("DOLIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("DOTIMES" , "ACL2-ASG" , "COMMON-LISP"),
    ("DOUBLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("DOUBLE-REWRITE" , "ACL2-ASG" , "ACL2"),
    ("DPB" , "ACL2-ASG" , "COMMON-LISP"),
    ("DRIBBLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("DUPLICATES" , "ACL2-ASG" , "ACL2"),
    ("DYNAMIC-EXTENT" , "ACL2-ASG" , "COMMON-LISP"),
    ("E/D" , "ACL2-ASG" , "ACL2"),
    ("E0-ORD-<" , "ACL2-ASG" , "ACL2"),
    ("E0-ORDINALP" , "ACL2-ASG" , "ACL2"),
    ("EC-CALL" , "ACL2-ASG" , "ACL2"),
    ("ECASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("ECHO-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("ECHO-STREAM-INPUT-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("ECHO-STREAM-OUTPUT-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("ED" , "ACL2-ASG" , "COMMON-LISP"),
    ("EIGHTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("ELIMINATE-DESTRUCTORS" , "ACL2-ASG" , "ACL2"),
    ("ELIMINATE-IRRELEVANCE" , "ACL2-ASG" , "ACL2"),
    ("ELT" , "ACL2-ASG" , "COMMON-LISP"),
    ("ENABLE" , "ACL2-ASG" , "ACL2"),
    ("ENABLE-FORCING" , "ACL2-ASG" , "ACL2"),
    ("ENCAPSULATE" , "ACL2-ASG" , "ACL2"),
    ("ENCODE-UNIVERSAL-TIME" , "ACL2-ASG" , "COMMON-LISP"),
    ("END-OF-FILE" , "ACL2-ASG" , "COMMON-LISP"),
    ("ENDP" , "ACL2-ASG" , "COMMON-LISP"),
    ("ENOUGH-NAMESTRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("ENSURE-DIRECTORIES-EXIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("ENSURE-GENERIC-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("EQ" , "ACL2-ASG" , "COMMON-LISP"),
    ("EQL" , "ACL2-ASG" , "COMMON-LISP"),
    ("EQLABLE-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("EQLABLE-ALISTP-FORWARD-TO-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("EQLABLE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("EQLABLE-LISTP-FORWARD-TO-ATOM-LISTP" , "ACL2-ASG" , "ACL2"),
    ("EQLABLEP" , "ACL2-ASG" , "ACL2"),
    ("EQLABLEP-RECOG" , "ACL2-ASG" , "ACL2"),
    ("EQUAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("EQUAL-CHAR-CODE" , "ACL2-ASG" , "ACL2"),
    ("EQUALP" , "ACL2-ASG" , "COMMON-LISP"),
    ("ER" , "ACL2-ASG" , "ACL2"),
    ("ER-PROGN" , "ACL2-ASG" , "ACL2"),
    ("ER-PROGN-FN" , "ACL2-ASG" , "ACL2"),
    ("ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("ETYPECASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("EVAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("EVAL-WHEN" , "ACL2-ASG" , "COMMON-LISP"),
    ("EVENP" , "ACL2-ASG" , "COMMON-LISP"),
    ("EVENS" , "ACL2-ASG" , "ACL2"),
    ("EVENT" , "ACL2-ASG" , "ACL2"),
    ("EVERY" , "ACL2-ASG" , "COMMON-LISP"),
    ("EXECUTABLE-COUNTERPART-THEORY" , "ACL2-ASG" , "ACL2"),
    ("EXP" , "ACL2-ASG" , "COMMON-LISP"),
    ("EXPLODE-ATOM" , "ACL2-ASG" , "ACL2"),
    ("EXPLODE-NONNEGATIVE-INTEGER" , "ACL2-ASG" , "ACL2"),
    ("EXPORT" , "ACL2-ASG" , "COMMON-LISP"),
    ("EXPT" , "ACL2-ASG" , "COMMON-LISP"),
    ("EXPT-TYPE-PRESCRIPTION-NON-ZERO-BASE" , "ACL2-ASG" , "ACL2"),
    ("EXTEND-32-BIT-INTEGER-STACK" , "ACL2-ASG" , "ACL2"),
    ("EXTEND-T-STACK" , "ACL2-ASG" , "ACL2"),
    ("EXTEND-WORLD" , "ACL2-ASG" , "ACL2"),
    ("EXTENDED-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("EXTRA-INFO" , "ACL2-ASG" , "ACL2"),
    ("FAST-ALIST-FREE" , "ACL2-ASG" , "ACL2"),
    ("FAST-ALIST-LEN" , "ACL2-ASG" , "ACL2"),
    ("FAST-ALIST-SUMMARY" , "ACL2-ASG" , "ACL2"),
    ("FBOUNDP" , "ACL2-ASG" , "COMMON-LISP"),
    ("FCEILING" , "ACL2-ASG" , "COMMON-LISP"),
    ("FDEFINITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("FERTILIZE" , "ACL2-ASG" , "ACL2"),
    ("FFLOOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("FGETPROP" , "ACL2-ASG" , "ACL2"),
    ("FIFTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-AUTHOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-CLOCK" , "ACL2-ASG" , "ACL2"),
    ("FILE-CLOCK-P" , "ACL2-ASG" , "ACL2"),
    ("FILE-CLOCK-P-FORWARD-TO-INTEGERP" , "ACL2-ASG" , "ACL2"),
    ("FILE-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-ERROR-PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-LENGTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-NAMESTRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-POSITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-STRING-LENGTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILE-WRITE-DATE" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILL" , "ACL2-ASG" , "COMMON-LISP"),
    ("FILL-POINTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-ALL-SYMBOLS" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-RESTART" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIND-SYMBOL" , "ACL2-ASG" , "COMMON-LISP"),
    ("FINISH-OUTPUT" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIRST" , "ACL2-ASG" , "COMMON-LISP"),
    ("FIRST-N-AC" , "ACL2-ASG" , "ACL2"),
    ("FIX" , "ACL2-ASG" , "ACL2"),
    ("FIX-TRUE-LIST" , "ACL2-ASG" , "ACL2"),
    ("FIXNUM" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLET" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOAT-DIGITS" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOAT-PRECISION" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOAT-RADIX" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOAT-SIGN" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOATING-POINT-INEXACT" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOATING-POINT-INVALID-OPERATION" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOATING-POINT-OVERFLOW" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOATING-POINT-UNDERFLOW" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOATP" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLOOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("FLUSH-HONS-GET-HASH-TABLE-LINK" , "ACL2-ASG" , "ACL2"),
    ("FMAKUNBOUND" , "ACL2-ASG" , "COMMON-LISP"),
    ("FMS" , "ACL2-ASG" , "ACL2"),
    ("FMT" , "ACL2-ASG" , "ACL2"),
    ("FMT-TO-COMMENT-WINDOW" , "ACL2-ASG" , "ACL2"),
    ("FMT1" , "ACL2-ASG" , "ACL2"),
    ("FORCE" , "ACL2-ASG" , "ACL2"),
    ("FORCE-OUTPUT" , "ACL2-ASG" , "COMMON-LISP"),
    ("FORMAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("FORMATTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("FOURTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("FRESH-LINE" , "ACL2-ASG" , "COMMON-LISP"),
    ("FROUND" , "ACL2-ASG" , "COMMON-LISP"),
    ("FTRUNCATE" , "ACL2-ASG" , "COMMON-LISP"),
    ("FTYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("FUNCALL" , "ACL2-ASG" , "COMMON-LISP"),
    ("FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("FUNCTION-KEYWORDS" , "ACL2-ASG" , "COMMON-LISP"),
    ("FUNCTION-LAMBDA-EXPRESSION" , "ACL2-ASG" , "COMMON-LISP"),
    ("FUNCTION-SYMBOLP" , "ACL2-ASG" , "ACL2"),
    ("FUNCTION-THEORY" , "ACL2-ASG" , "ACL2"),
    ("FUNCTIONP" , "ACL2-ASG" , "COMMON-LISP"),
    ("GCD" , "ACL2-ASG" , "COMMON-LISP"),
    ("GENERALIZE" , "ACL2-ASG" , "ACL2"),
    ("GENERIC-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("GENSYM" , "ACL2-ASG" , "COMMON-LISP"),
    ("GENTEMP" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-DECODED-TIME" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-DISPATCH-MACRO-CHARACTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-GLOBAL" , "ACL2-ASG" , "ACL2"),
    ("GET-INTERNAL-REAL-TIME" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-INTERNAL-RUN-TIME" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-MACRO-CHARACTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-OUTPUT-STREAM-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-PROPERTIES" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-SETF-EXPANSION" , "ACL2-ASG" , "COMMON-LISP"),
    ("GET-SLOW-ALIST-ACTION" , "ACL2-ASG" , "ACL2"),
    ("GET-TIMER" , "ACL2-ASG" , "ACL2"),
    ("GET-UNIVERSAL-TIME" , "ACL2-ASG" , "COMMON-LISP"),
    ("GETF" , "ACL2-ASG" , "COMMON-LISP"),
    ("GETHASH" , "ACL2-ASG" , "COMMON-LISP"),
    ("GETPROP-DEFAULT" , "ACL2-ASG" , "ACL2"),
    ("GETPROPS" , "ACL2-ASG" , "ACL2"),
    ("GETPROPS1" , "ACL2-ASG" , "ACL2"),
    ("GLOBAL-TABLE" , "ACL2-ASG" , "ACL2"),
    ("GLOBAL-TABLE-CARS" , "ACL2-ASG" , "ACL2"),
    ("GLOBAL-TABLE-CARS1" , "ACL2-ASG" , "ACL2"),
    ("GLOBAL-VAL" , "ACL2-ASG" , "ACL2"),
    ("GO" , "ACL2-ASG" , "COMMON-LISP"),
    ("GOOD-BYE" , "ACL2-ASG" , "ACL2"),
    ("GRANULARITY" , "ACL2-ASG" , "ACL2"),
    ("GRAPHIC-CHAR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("GROUND-ZERO" , "ACL2-ASG" , "ACL2"),
    ("HANDLER-BIND" , "ACL2-ASG" , "COMMON-LISP"),
    ("HANDLER-CASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("HARD-ERROR" , "ACL2-ASG" , "ACL2"),
    ("HAS-PROPSP" , "ACL2-ASG" , "ACL2"),
    ("HAS-PROPSP1" , "ACL2-ASG" , "ACL2"),
    ("HASH-TABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("HASH-TABLE-COUNT" , "ACL2-ASG" , "COMMON-LISP"),
    ("HASH-TABLE-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-SIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-THRESHOLD" , "ACL2-ASG" , "COMMON-LISP"),
    ("HASH-TABLE-SIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("HASH-TABLE-TEST" , "ACL2-ASG" , "COMMON-LISP"),
    ("HEADER" , "ACL2-ASG" , "ACL2"),
    ("HELP" , "ACL2-ASG" , "ACL2"),
    ("HIDE" , "ACL2-ASG" , "ACL2"),
    ("HONS" , "ACL2-ASG" , "ACL2"),
    ("HONS-ACONS" , "ACL2-ASG" , "ACL2"),
    ("HONS-ACONS!" , "ACL2-ASG" , "ACL2"),
    ("HONS-CLEAR" , "ACL2-ASG" , "ACL2"),
    ("HONS-COPY" , "ACL2-ASG" , "ACL2"),
    ("HONS-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("HONS-EQUAL-LITE" , "ACL2-ASG" , "ACL2"),
    ("HONS-GET" , "ACL2-ASG" , "ACL2"),
    ("HONS-RESIZE" , "ACL2-ASG" , "ACL2"),
    ("HONS-RESIZE-FN" , "ACL2-ASG" , "ACL2"),
    ("HONS-SHRINK-ALIST" , "ACL2-ASG" , "ACL2"),
    ("HONS-SHRINK-ALIST!" , "ACL2-ASG" , "ACL2"),
    ("HONS-SUMMARY" , "ACL2-ASG" , "ACL2"),
    ("HONS-WASH" , "ACL2-ASG" , "ACL2"),
    ("HOST-NAMESTRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("I-AM-HERE" , "ACL2-ASG" , "ACL2"),
    ("ID" , "ACL2-ASG" , "ACL2"),
    ("IDATES" , "ACL2-ASG" , "ACL2"),
    ("IDENTITY" , "ACL2-ASG" , "COMMON-LISP"),
    ("IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("IF*" , "ACL2-ASG" , "ACL2"),
    ("IFF" , "ACL2-ASG" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-1" , "ACL2-ASG" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-2" , "ACL2-ASG" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-NOT" , "ACL2-ASG" , "ACL2"),
    ("IFF-IS-AN-EQUIVALENCE" , "ACL2-ASG" , "ACL2"),
    ("IFIX" , "ACL2-ASG" , "ACL2"),
    ("IGNORABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("IGNORE" , "ACL2-ASG" , "COMMON-LISP"),
    ("IGNORE-ERRORS" , "ACL2-ASG" , "COMMON-LISP"),
    ("ILLEGAL" , "ACL2-ASG" , "ACL2"),
    ("IMAGPART" , "ACL2-ASG" , "COMMON-LISP"),
    ("IMAGPART-COMPLEX" , "ACL2-ASG" , "ACL2"),
    ("IMMEDIATE-FORCE-MODEP" , "ACL2-ASG" , "ACL2"),
    ("IMPLIES" , "ACL2-ASG" , "ACL2"),
    ("IMPORT" , "ACL2-ASG" , "COMMON-LISP"),
    ("IMPROPER-CONSP" , "ACL2-ASG" , "ACL2"),
    ("IN-ARITHMETIC-THEORY" , "ACL2-ASG" , "ACL2"),
    ("IN-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("IN-THEORY" , "ACL2-ASG" , "ACL2"),
    ("INCF" , "ACL2-ASG" , "COMMON-LISP"),
    ("INCLUDE-BOOK" , "ACL2-ASG" , "ACL2"),
    ("INCOMPATIBLE" , "ACL2-ASG" , "ACL2"),
    ("INCREMENT-TIMER" , "ACL2-ASG" , "ACL2"),
    ("INDUCT" , "ACL2-ASG" , "ACL2"),
    ("INITIALIZE-INSTANCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("INLINE" , "ACL2-ASG" , "COMMON-LISP"),
    ("INPUT-STREAM-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("INSPECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("INT=" , "ACL2-ASG" , "ACL2"),
    ("INTEGER" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTEGER-0" , "ACL2-ASG" , "ACL2"),
    ("INTEGER-1" , "ACL2-ASG" , "ACL2"),
    ("INTEGER-ABS" , "ACL2-ASG" , "ACL2"),
    ("INTEGER-DECODE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTEGER-IMPLIES-RATIONAL" , "ACL2-ASG" , "ACL2"),
    ("INTEGER-LENGTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTEGER-LISTP" , "ACL2-ASG" , "ACL2"),
    ("INTEGER-LISTP-FORWARD-TO-RATIONAL-LISTP" , "ACL2-ASG" , "ACL2"),
    ("INTEGER-STEP" , "ACL2-ASG" , "ACL2"),
    ("INTEGERP" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTERACTIVE-STREAM-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTERN" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTERN$" , "ACL2-ASG" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-ASG" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL-SYMBOL-NAME" , "ACL2-ASG" , "ACL2"),
    ("INTERNAL-TIME-UNITS-PER-SECOND" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTERSECTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("INTERSECTION-EQ" , "ACL2-ASG" , "ACL2"),
    ("INTERSECTION-THEORIES" , "ACL2-ASG" , "ACL2"),
    ("INTERSECTP-EQ" , "ACL2-ASG" , "ACL2"),
    ("INTERSECTP-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("INVALID-METHOD-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("INVERSE-OF-*" , "ACL2-ASG" , "ACL2"),
    ("INVERSE-OF-+" , "ACL2-ASG" , "ACL2"),
    ("INVISIBLE-FNS-TABLE" , "ACL2-ASG" , "ACL2"),
    ("INVOKE-DEBUGGER" , "ACL2-ASG" , "COMMON-LISP"),
    ("INVOKE-RESTART" , "ACL2-ASG" , "COMMON-LISP"),
    ("INVOKE-RESTART-INTERACTIVELY" , "ACL2-ASG" , "COMMON-LISP"),
    ("ISQRT" , "ACL2-ASG" , "COMMON-LISP"),
    ("KEYWORD" , "ACL2-ASG" , "COMMON-LISP"),
    ("KEYWORD-PACKAGE" , "ACL2-ASG" , "ACL2"),
    ("KEYWORD-VALUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-ASSOC-KEYWORD" , "ACL2-ASG" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("KEYWORDP" , "ACL2-ASG" , "COMMON-LISP"),
    ("KEYWORDP-FORWARD-TO-SYMBOLP" , "ACL2-ASG" , "ACL2"),
    ("KNOWN-PACKAGE-ALIST" , "ACL2-ASG" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-ASG" , "ACL2"),
    ("LABELS" , "ACL2-ASG" , "COMMON-LISP"),
    ("LAMBDA" , "ACL2-ASG" , "COMMON-LISP"),
    ("LAMBDA-LIST-KEYWORDS" , "ACL2-ASG" , "COMMON-LISP"),
    ("LAMBDA-PARAMETERS-LIMIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LAST" , "ACL2-ASG" , "COMMON-LISP"),
    ("LCM" , "ACL2-ASG" , "COMMON-LISP"),
    ("LD" , "ACL2-ASG" , "ACL2"),
    ("LD-ERROR-ACTION" , "ACL2-ASG" , "ACL2"),
    ("LD-ERROR-TRIPLES" , "ACL2-ASG" , "ACL2"),
    ("LD-KEYWORD-ALIASES" , "ACL2-ASG" , "ACL2"),
    ("LD-POST-EVAL-PRINT" , "ACL2-ASG" , "ACL2"),
    ("LD-PRE-EVAL-FILTER" , "ACL2-ASG" , "ACL2"),
    ("LD-PRE-EVAL-PRINT" , "ACL2-ASG" , "ACL2"),
    ("LD-PROMPT" , "ACL2-ASG" , "ACL2"),
    ("LD-QUERY-CONTROL-ALIST" , "ACL2-ASG" , "ACL2"),
    ("LD-REDEFINITION-ACTION" , "ACL2-ASG" , "ACL2"),
    ("LD-SKIP-PROOFSP" , "ACL2-ASG" , "ACL2"),
    ("LD-VERBOSE" , "ACL2-ASG" , "ACL2"),
    ("LDB" , "ACL2-ASG" , "COMMON-LISP"),
    ("LDB-TEST" , "ACL2-ASG" , "COMMON-LISP"),
    ("LDIFF" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-LONG-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-LONG-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SHORT-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SINGLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-DOUBLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-LONG-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-LONG-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SHORT-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SINGLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LEGAL-CASE-CLAUSESP" , "ACL2-ASG" , "ACL2"),
    ("LEN" , "ACL2-ASG" , "ACL2"),
    ("LEN-UPDATE-NTH" , "ACL2-ASG" , "ACL2"),
    ("LENGTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("LET" , "ACL2-ASG" , "COMMON-LISP"),
    ("LET*" , "ACL2-ASG" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-VERSION" , "ACL2-ASG" , "COMMON-LISP"),
    ("LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("LIST*" , "ACL2-ASG" , "COMMON-LISP"),
    ("LIST*-MACRO" , "ACL2-ASG" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES" , "ACL2-ASG" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-ASG" , "ACL2"),
    ("LIST-ALL-PACKAGES" , "ACL2-ASG" , "COMMON-LISP"),
    ("LIST-LENGTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("LIST-MACRO" , "ACL2-ASG" , "ACL2"),
    ("LISTEN" , "ACL2-ASG" , "COMMON-LISP"),
    ("LISTP" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOAD" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOAD-LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOAD-TIME-VALUE" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOCAL" , "ACL2-ASG" , "ACL2"),
    ("LOCALLY" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOG" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGAND" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGANDC1" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGANDC2" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGBITP" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGCOUNT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGEQV" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGIC" , "ACL2-ASG" , "ACL2"),
    ("LOGICAL-PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGIOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGNAND" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGNOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGNOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGORC1" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGORC2" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGTEST" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOGXOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("LONG-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("LONG-FLOAT-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("LONG-FLOAT-NEGATIVE-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("LONG-SITE-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOOP" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOOP-FINISH" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOWER-CASE-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("LOWER-CASE-P-CHAR-DOWNCASE" , "ACL2-ASG" , "ACL2"),
    ("LOWER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-ASG" , "ACL2"),
    ("LOWEST-TERMS" , "ACL2-ASG" , "ACL2"),
    ("LP" , "ACL2-ASG" , "ACL2"),
    ("MACHINE-INSTANCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MACHINE-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MACHINE-VERSION" , "ACL2-ASG" , "COMMON-LISP"),
    ("MACRO-ALIASES" , "ACL2-ASG" , "ACL2"),
    ("MACRO-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("MACROEXPAND" , "ACL2-ASG" , "COMMON-LISP"),
    ("MACROEXPAND-1" , "ACL2-ASG" , "COMMON-LISP"),
    ("MACROLET" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAIN-TIMER" , "ACL2-ASG" , "ACL2"),
    ("MAIN-TIMER-TYPE-PRESCRIPTION" , "ACL2-ASG" , "ACL2"),
    ("MAKE-ARRAY" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-BROADCAST-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-CHARACTER-LIST" , "ACL2-ASG" , "ACL2"),
    ("MAKE-CHARACTER-LIST-MAKE-CHARACTER-LIST" , "ACL2-ASG" , "ACL2"),
    ("MAKE-CONCATENATED-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-CONDITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-DISPATCH-MACRO-CHARACTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-ECHO-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-EVENT" , "ACL2-ASG" , "ACL2"),
    ("MAKE-FMT-BINDINGS" , "ACL2-ASG" , "ACL2"),
    ("MAKE-HASH-TABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-INPUT-CHANNEL" , "ACL2-ASG" , "ACL2"),
    ("MAKE-INSTANCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-INSTANCES-OBSOLETE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-LIST-AC" , "ACL2-ASG" , "ACL2"),
    ("MAKE-LOAD-FORM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-LOAD-FORM-SAVING-SLOTS" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-MV-NTHS" , "ACL2-ASG" , "ACL2"),
    ("MAKE-ORD" , "ACL2-ASG" , "ACL2"),
    ("MAKE-OUTPUT-CHANNEL" , "ACL2-ASG" , "ACL2"),
    ("MAKE-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-RANDOM-STATE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-SEQUENCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-STRING-INPUT-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-STRING-OUTPUT-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-SYMBOL" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-SYNONYM-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-TWO-WAY-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKE-VAR-LST" , "ACL2-ASG" , "ACL2"),
    ("MAKE-VAR-LST1" , "ACL2-ASG" , "ACL2"),
    ("MAKUNBOUND" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAKUNBOUND-GLOBAL" , "ACL2-ASG" , "ACL2"),
    ("MAP" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAP-INTO" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAPC" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAPCAN" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAPCAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAPCON" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAPHASH" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAPL" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAPLIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("MASK-FIELD" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAX" , "ACL2-ASG" , "COMMON-LISP"),
    ("MAXIMUM-LENGTH" , "ACL2-ASG" , "ACL2"),
    ("MAY-NEED-SLASHES" , "ACL2-ASG" , "ACL2"),
    ("MBE" , "ACL2-ASG" , "ACL2"),
    ("MBT" , "ACL2-ASG" , "ACL2"),
    ("MEMBER" , "ACL2-ASG" , "COMMON-LISP"),
    ("MEMBER-EQ" , "ACL2-ASG" , "ACL2"),
    ("MEMBER-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("MEMBER-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("MEMBER-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MEMBER-SYMBOL-NAME" , "ACL2-ASG" , "ACL2"),
    ("MEMOIZE" , "ACL2-ASG" , "ACL2"),
    ("MEMOIZE-LET" , "ACL2-ASG" , "ACL2"),
    ("MEMOIZE-OFF" , "ACL2-ASG" , "ACL2"),
    ("MEMOIZE-ON" , "ACL2-ASG" , "ACL2"),
    ("MERGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("MERGE-PATHNAMES" , "ACL2-ASG" , "COMMON-LISP"),
    ("METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("METHOD-COMBINATION" , "ACL2-ASG" , "COMMON-LISP"),
    ("METHOD-COMBINATION-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("METHOD-QUALIFIERS" , "ACL2-ASG" , "COMMON-LISP"),
    ("MFC" , "ACL2-ASG" , "ACL2"),
    ("MIN" , "ACL2-ASG" , "COMMON-LISP"),
    ("MINIMAL-THEORY" , "ACL2-ASG" , "ACL2"),
    ("MINUSP" , "ACL2-ASG" , "COMMON-LISP"),
    ("MISMATCH" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("MONITOR" , "ACL2-ASG" , "ACL2"),
    ("MONITORED-RUNES" , "ACL2-ASG" , "ACL2"),
    ("MORE" , "ACL2-ASG" , "ACL2"),
    ("MORE!" , "ACL2-ASG" , "ACL2"),
    ("MORE-DOC" , "ACL2-ASG" , "ACL2"),
    ("MOST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-FIXNUM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-LONG-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SHORT-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SINGLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-POSITIVE-DOUBLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-POSITIVE-FIXNUM" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-POSITIVE-LONG-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-POSITIVE-SHORT-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MOST-POSITIVE-SINGLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MUFFLE-WARNING" , "ACL2-ASG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-BIND" , "ACL2-ASG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-CALL" , "ACL2-ASG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-PROG1" , "ACL2-ASG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-SETQ" , "ACL2-ASG" , "COMMON-LISP"),
    ("MULTIPLE-VALUES-LIMIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("MUTUAL-RECURSION" , "ACL2-ASG" , "ACL2"),
    ("MUTUAL-RECURSION-GUARDP" , "ACL2-ASG" , "ACL2"),
    ("MV" , "ACL2-ASG" , "ACL2"),
    ("MV-LET" , "ACL2-ASG" , "ACL2"),
    ("MV-LIST" , "ACL2-ASG" , "ACL2"),
    ("MV-NTH" , "ACL2-ASG" , "ACL2"),
    ("NAME-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("NAMESTRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("NATP" , "ACL2-ASG" , "ACL2"),
    ("NBUTLAST" , "ACL2-ASG" , "COMMON-LISP"),
    ("NCONC" , "ACL2-ASG" , "COMMON-LISP"),
    ("NEEDS-SLASHES" , "ACL2-ASG" , "ACL2"),
    ("NEWLINE" , "ACL2-ASG" , "ACL2"),
    ("NEXT-METHOD-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("NFIX" , "ACL2-ASG" , "ACL2"),
    ("NIL" , "ACL2-ASG" , "COMMON-LISP"),
    ("NIL-IS-NOT-CIRCULAR" , "ACL2-ASG" , "ACL2"),
    ("NINTERSECTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("NINTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("NO-APPLICABLE-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("NO-DUPLICATESP" , "ACL2-ASG" , "ACL2"),
    ("NO-DUPLICATESP-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("NO-NEXT-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("NONNEGATIVE-INTEGER-QUOTIENT" , "ACL2-ASG" , "ACL2"),
    ("NONNEGATIVE-PRODUCT" , "ACL2-ASG" , "ACL2"),
    ("NONZERO-IMAGPART" , "ACL2-ASG" , "ACL2"),
    ("NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("NOTANY" , "ACL2-ASG" , "COMMON-LISP"),
    ("NOTEVERY" , "ACL2-ASG" , "COMMON-LISP"),
    ("NOTINLINE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NQTHM-TO-ACL2" , "ACL2-ASG" , "ACL2"),
    ("NRECONC" , "ACL2-ASG" , "COMMON-LISP"),
    ("NREVERSE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSET-DIFFERENCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSET-EXCLUSIVE-OR" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSTRING-CAPITALIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSTRING-DOWNCASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSTRING-UPCASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSUBLIS" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSUBST" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSUBST-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSUBST-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSUBSTITUTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("NTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("NTH-0-CONS" , "ACL2-ASG" , "ACL2"),
    ("NTH-0-READ-RUN-TIME-TYPE-PRESCRIPTION" , "ACL2-ASG" , "ACL2"),
    ("NTH-ADD1" , "ACL2-ASG" , "ACL2"),
    ("NTH-ALIASES" , "ACL2-ASG" , "ACL2"),
    ("NTH-UPDATE-NTH" , "ACL2-ASG" , "ACL2"),
    ("NTH-VALUE" , "ACL2-ASG" , "COMMON-LISP"),
    ("NTHCDR" , "ACL2-ASG" , "COMMON-LISP"),
    ("NULL" , "ACL2-ASG" , "COMMON-LISP"),
    ("NUMBER" , "ACL2-ASG" , "COMMON-LISP"),
    ("NUMBER-SUBTREES" , "ACL2-ASG" , "ACL2"),
    ("NUMBERP" , "ACL2-ASG" , "COMMON-LISP"),
    ("NUMERATOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("NUNION" , "ACL2-ASG" , "COMMON-LISP"),
    ("O-FINP" , "ACL2-ASG" , "ACL2"),
    ("O-FIRST-COEFF" , "ACL2-ASG" , "ACL2"),
    ("O-FIRST-EXPT" , "ACL2-ASG" , "ACL2"),
    ("O-INFP" , "ACL2-ASG" , "ACL2"),
    ("O-P" , "ACL2-ASG" , "ACL2"),
    ("O-RST" , "ACL2-ASG" , "ACL2"),
    ("O<" , "ACL2-ASG" , "ACL2"),
    ("O<=" , "ACL2-ASG" , "ACL2"),
    ("O>" , "ACL2-ASG" , "ACL2"),
    ("O>=" , "ACL2-ASG" , "ACL2"),
    ("OBSERVATION" , "ACL2-ASG" , "ACL2"),
    ("ODDP" , "ACL2-ASG" , "COMMON-LISP"),
    ("ODDS" , "ACL2-ASG" , "ACL2"),
    ("OK-IF" , "ACL2-ASG" , "ACL2"),
    ("OOPS" , "ACL2-ASG" , "ACL2"),
    ("OPEN" , "ACL2-ASG" , "COMMON-LISP"),
    ("OPEN-CHANNEL-LISTP" , "ACL2-ASG" , "ACL2"),
    ("OPEN-CHANNEL1" , "ACL2-ASG" , "ACL2"),
    ("OPEN-CHANNEL1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-ASG" ,
"ACL2"),
    ("OPEN-CHANNELS-P" , "ACL2-ASG" , "ACL2"),
    ("OPEN-CHANNELS-P-FORWARD" , "ACL2-ASG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL" , "ACL2-ASG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P" , "ACL2-ASG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P1" , "ACL2-ASG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P" , "ACL2-ASG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P1" , "ACL2-ASG" , "ACL2"),
    ("OPEN-INPUT-CHANNELS" , "ACL2-ASG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL" , "ACL2-ASG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL!" , "ACL2-ASG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P" , "ACL2-ASG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P1" , "ACL2-ASG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P" , "ACL2-ASG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P1" , "ACL2-ASG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNELS" , "ACL2-ASG" , "ACL2"),
    ("OPEN-STREAM-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("OPEN-TRACE-FILE" , "ACL2-ASG" , "ACL2"),
    ("OPTIMIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("OR" , "ACL2-ASG" , "COMMON-LISP"),
    ("OR-MACRO" , "ACL2-ASG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR" , "ACL2-ASG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR-FORWARD" , "ACL2-ASG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-FORWARD-TO-SYMBOL-ALISTP" , "ACL2-ASG"
, "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-GETPROPS" , "ACL2-ASG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-REMOVE-FIRST-PAIR" , "ACL2-ASG" , "ACL2"),
    ("OTHERWISE" , "ACL2-ASG" , "COMMON-LISP"),
    ("OUR-DIGIT-CHAR-P" , "ACL2-ASG" , "ACL2"),
    ("OUTPUT-STREAM-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE-ERROR-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE-NICKNAMES" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE-SHADOWING-SYMBOLS" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE-USE-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGE-USED-BY-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("PACKAGEP" , "ACL2-ASG" , "COMMON-LISP"),
    ("PAIRLIS" , "ACL2-ASG" , "COMMON-LISP"),
    ("PAIRLIS$" , "ACL2-ASG" , "ACL2"),
    ("PAIRLIS2" , "ACL2-ASG" , "ACL2"),
    ("PAND" , "ACL2-ASG" , "ACL2"),
    ("PARGS" , "ACL2-ASG" , "ACL2"),
    ("PARSE-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("PARSE-INTEGER" , "ACL2-ASG" , "COMMON-LISP"),
    ("PARSE-NAMESTRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME-DEVICE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME-DIRECTORY" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME-HOST" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME-MATCH-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAME-VERSION" , "ACL2-ASG" , "COMMON-LISP"),
    ("PATHNAMEP" , "ACL2-ASG" , "COMMON-LISP"),
    ("PBT" , "ACL2-ASG" , "ACL2"),
    ("PC" , "ACL2-ASG" , "ACL2"),
    ("PCB" , "ACL2-ASG" , "ACL2"),
    ("PCB!" , "ACL2-ASG" , "ACL2"),
    ("PCS" , "ACL2-ASG" , "ACL2"),
    ("PE" , "ACL2-ASG" , "ACL2"),
    ("PEEK-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("PEEK-CHAR$" , "ACL2-ASG" , "ACL2"),
    ("PF" , "ACL2-ASG" , "ACL2"),
    ("PHASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PI" , "ACL2-ASG" , "COMMON-LISP"),
    ("PL" , "ACL2-ASG" , "ACL2"),
    ("PLET" , "ACL2-ASG" , "ACL2"),
    ("PLIST-WORLDP" , "ACL2-ASG" , "ACL2"),
    ("PLIST-WORLDP-FORWARD-TO-ASSOC-EQ-EQUAL-ALISTP" , "ACL2-ASG" ,
"ACL2"),
    ("PLUSP" , "ACL2-ASG" , "COMMON-LISP"),
    ("POP" , "ACL2-ASG" , "COMMON-LISP"),
    ("POP-TIMER" , "ACL2-ASG" , "ACL2"),
    ("POR" , "ACL2-ASG" , "ACL2"),
    ("POSITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("POSITION-AC" , "ACL2-ASG" , "ACL2"),
    ("POSITION-EQ" , "ACL2-ASG" , "ACL2"),
    ("POSITION-EQ-AC" , "ACL2-ASG" , "ACL2"),
    ("POSITION-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("POSITION-EQUAL-AC" , "ACL2-ASG" , "ACL2"),
    ("POSITION-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("POSITION-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("POSITIVE" , "ACL2-ASG" , "ACL2"),
    ("POSP" , "ACL2-ASG" , "ACL2"),
    ("POWER-EVAL" , "ACL2-ASG" , "ACL2"),
    ("PPRINT" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-DISPATCH" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-EXIT-IF-LIST-EXHAUSTED" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-FILL" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-INDENT" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-LINEAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-LOGICAL-BLOCK" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-NEWLINE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-POP" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-TAB" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPRINT-TABULAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("PPROGN" , "ACL2-ASG" , "ACL2"),
    ("PR" , "ACL2-ASG" , "ACL2"),
    ("PR!" , "ACL2-ASG" , "ACL2"),
    ("PREPROCESS" , "ACL2-ASG" , "ACL2"),
    ("PRIN1" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRIN1$" , "ACL2-ASG" , "ACL2"),
    ("PRIN1-TO-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRIN1-WITH-SLASHES" , "ACL2-ASG" , "ACL2"),
    ("PRIN1-WITH-SLASHES1" , "ACL2-ASG" , "ACL2"),
    ("PRINC" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRINC$" , "ACL2-ASG" , "ACL2"),
    ("PRINC-TO-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRINT" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRINT-GV" , "ACL2-ASG" , "ACL2"),
    ("PRINT-NOT-READABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRINT-NOT-READABLE-OBJECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRINT-OBJECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("PRINT-OBJECT$" , "ACL2-ASG" , "ACL2"),
    ("PRINT-RATIONAL-AS-DECIMAL" , "ACL2-ASG" , "ACL2"),
    ("PRINT-TIMER" , "ACL2-ASG" , "ACL2"),
    ("PRINT-UNREADABLE-OBJECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROBE-FILE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROCLAIM" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROG" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROG*" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROG1" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROG2" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROG2$" , "ACL2-ASG" , "ACL2"),
    ("PROGN" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROGRAM" , "ACL2-ASG" , "ACL2"),
    ("PROGRAM-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROGV" , "ACL2-ASG" , "COMMON-LISP"),
    ("PROOF-TREE" , "ACL2-ASG" , "ACL2"),
    ("PROOFS-CO" , "ACL2-ASG" , "ACL2"),
    ("PROPER-CONSP" , "ACL2-ASG" , "ACL2"),
    ("PROPS" , "ACL2-ASG" , "ACL2"),
    ("PROVE" , "ACL2-ASG" , "ACL2"),
    ("PROVIDE" , "ACL2-ASG" , "COMMON-LISP"),
    ("PSETF" , "ACL2-ASG" , "COMMON-LISP"),
    ("PSETQ" , "ACL2-ASG" , "COMMON-LISP"),
    ("PSEUDO-TERM-LISTP" , "ACL2-ASG" , "ACL2"),
    ("PSEUDO-TERM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("PSEUDO-TERMP" , "ACL2-ASG" , "ACL2"),
    ("PSTACK" , "ACL2-ASG" , "ACL2"),
    ("PUFF" , "ACL2-ASG" , "ACL2"),
    ("PUFF*" , "ACL2-ASG" , "ACL2"),
    ("PUSH" , "ACL2-ASG" , "COMMON-LISP"),
    ("PUSH-TIMER" , "ACL2-ASG" , "ACL2"),
    ("PUSH-UNTOUCHABLE" , "ACL2-ASG" , "ACL2"),
    ("PUSHNEW" , "ACL2-ASG" , "COMMON-LISP"),
    ("PUT-ASSOC-EQ" , "ACL2-ASG" , "ACL2"),
    ("PUT-ASSOC-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("PUT-GLOBAL" , "ACL2-ASG" , "ACL2"),
    ("PUTPROP" , "ACL2-ASG" , "ACL2"),
    ("QUOTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("QUOTEP" , "ACL2-ASG" , "ACL2"),
    ("R-EQLABLE-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("RANDOM" , "ACL2-ASG" , "COMMON-LISP"),
    ("RANDOM-STATE" , "ACL2-ASG" , "COMMON-LISP"),
    ("RANDOM-STATE-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("RASSOC" , "ACL2-ASG" , "COMMON-LISP"),
    ("RASSOC-EQ" , "ACL2-ASG" , "ACL2"),
    ("RASSOC-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("RASSOC-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("RASSOC-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("RATIO" , "ACL2-ASG" , "COMMON-LISP"),
    ("RATIONAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("RATIONAL-IMPLIES1" , "ACL2-ASG" , "ACL2"),
    ("RATIONAL-IMPLIES2" , "ACL2-ASG" , "ACL2"),
    ("RATIONAL-LISTP" , "ACL2-ASG" , "ACL2"),
    ("RATIONAL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("RATIONALIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("RATIONALP" , "ACL2-ASG" , "COMMON-LISP"),
    ("RATIONALP-*" , "ACL2-ASG" , "ACL2"),
    ("RATIONALP-+" , "ACL2-ASG" , "ACL2"),
    ("RATIONALP-EXPT-TYPE-PRESCRIPTION" , "ACL2-ASG" , "ACL2"),
    ("RATIONALP-IMPLIES-ACL2-NUMBERP" , "ACL2-ASG" , "ACL2"),
    ("RATIONALP-UNARY--" , "ACL2-ASG" , "ACL2"),
    ("RATIONALP-UNARY-/" , "ACL2-ASG" , "ACL2"),
    ("READ" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-ACL2-ORACLE" , "ACL2-ASG" , "ACL2"),
    ("READ-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-ASG" , "ACL2"),
    ("READ-BYTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-BYTE$" , "ACL2-ASG" , "ACL2"),
    ("READ-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-CHAR$" , "ACL2-ASG" , "ACL2"),
    ("READ-CHAR-NO-HANG" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-DELIMITED-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-FILE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("READ-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-ASG" , "ACL2"),
    ("READ-FILE-LISTP1" , "ACL2-ASG" , "ACL2"),
    ("READ-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-ASG"
, "ACL2"),
    ("READ-FILES" , "ACL2-ASG" , "ACL2"),
    ("READ-FILES-P" , "ACL2-ASG" , "ACL2"),
    ("READ-FILES-P-FORWARD-TO-READ-FILE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("READ-FROM-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-IDATE" , "ACL2-ASG" , "ACL2"),
    ("READ-LINE" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-OBJECT" , "ACL2-ASG" , "ACL2"),
    ("READ-PRESERVING-WHITESPACE" , "ACL2-ASG" , "COMMON-LISP"),
    ("READ-RUN-TIME" , "ACL2-ASG" , "ACL2"),
    ("READ-RUN-TIME-PRESERVES-STATE-P1" , "ACL2-ASG" , "ACL2"),
    ("READ-SEQUENCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("READABLE-FILE" , "ACL2-ASG" , "ACL2"),
    ("READABLE-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-ASG" ,
"ACL2"),
    ("READABLE-FILES" , "ACL2-ASG" , "ACL2"),
    ("READABLE-FILES-LISTP" , "ACL2-ASG" , "ACL2"),
    ("READABLE-FILES-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-ASG" , "ACL2"),
    ("READABLE-FILES-P" , "ACL2-ASG" , "ACL2"),
    ("READABLE-FILES-P-FORWARD-TO-READABLE-FILES-LISTP" , "ACL2-ASG"
, "ACL2"),
    ("READER-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("READTABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("READTABLE-CASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("READTABLEP" , "ACL2-ASG" , "COMMON-LISP"),
    ("REAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("REAL/RATIONALP" , "ACL2-ASG" , "ACL2"),
    ("REALFIX" , "ACL2-ASG" , "ACL2"),
    ("REALP" , "ACL2-ASG" , "COMMON-LISP"),
    ("REALPART" , "ACL2-ASG" , "COMMON-LISP"),
    ("REALPART-COMPLEX" , "ACL2-ASG" , "ACL2"),
    ("REALPART-IMAGPART-ELIM" , "ACL2-ASG" , "ACL2"),
    ("REBUILD" , "ACL2-ASG" , "ACL2"),
    ("REDEF" , "ACL2-ASG" , "ACL2"),
    ("REDEF!" , "ACL2-ASG" , "ACL2"),
    ("REDEF+" , "ACL2-ASG" , "ACL2"),
    ("REDUCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("REINITIALIZE-INSTANCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("REM" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMF" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMHASH" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMOVE" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMOVE-BINOP" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS!" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-DUPLICATES" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMOVE-DUPLICATES-EQL" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-DUPLICATES-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-EQ" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-FIRST-PAIR" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMOVE-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMOVE-INVISIBLE-FNS" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-MACRO-ALIAS" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("REMOVE-NTH-ALIAS" , "ACL2-ASG" , "ACL2"),
    ("REMOVE-UNTOUCHABLE" , "ACL2-ASG" , "ACL2"),
    ("REMOVE1" , "ACL2-ASG" , "ACL2"),
    ("REMOVE1-EQ" , "ACL2-ASG" , "ACL2"),
    ("REMOVE1-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("REMPROP" , "ACL2-ASG" , "COMMON-LISP"),
    ("RENAME-FILE" , "ACL2-ASG" , "COMMON-LISP"),
    ("RENAME-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("REPLACE" , "ACL2-ASG" , "COMMON-LISP"),
    ("REQUIRE" , "ACL2-ASG" , "COMMON-LISP"),
    ("RESET-LD-SPECIALS" , "ACL2-ASG" , "ACL2"),
    ("RESET-PREHISTORY" , "ACL2-ASG" , "ACL2"),
    ("REST" , "ACL2-ASG" , "COMMON-LISP"),
    ("RESTART" , "ACL2-ASG" , "COMMON-LISP"),
    ("RESTART-BIND" , "ACL2-ASG" , "COMMON-LISP"),
    ("RESTART-CASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("RESTART-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("RETRACT-WORLD" , "ACL2-ASG" , "ACL2"),
    ("RETRIEVE" , "ACL2-ASG" , "ACL2"),
    ("RETURN" , "ACL2-ASG" , "COMMON-LISP"),
    ("RETURN-FROM" , "ACL2-ASG" , "COMMON-LISP"),
    ("REVAPPEND" , "ACL2-ASG" , "COMMON-LISP"),
    ("REVERSE" , "ACL2-ASG" , "COMMON-LISP"),
    ("RFIX" , "ACL2-ASG" , "ACL2"),
    ("ROOM" , "ACL2-ASG" , "COMMON-LISP"),
    ("ROTATEF" , "ACL2-ASG" , "COMMON-LISP"),
    ("ROUND" , "ACL2-ASG" , "COMMON-LISP"),
    ("ROW-MAJOR-AREF" , "ACL2-ASG" , "COMMON-LISP"),
    ("RPLACA" , "ACL2-ASG" , "COMMON-LISP"),
    ("RPLACD" , "ACL2-ASG" , "COMMON-LISP"),
    ("SAFETY" , "ACL2-ASG" , "COMMON-LISP"),
    ("SATISFIES" , "ACL2-ASG" , "COMMON-LISP"),
    ("SBIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SCALE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SCHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("SEARCH" , "ACL2-ASG" , "COMMON-LISP"),
    ("SECOND" , "ACL2-ASG" , "COMMON-LISP"),
    ("SEQUENCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SERIOUS-CONDITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET-BACKCHAIN-LIMIT" , "ACL2-ASG" , "ACL2"),
    ("SET-BODY" , "ACL2-ASG" , "ACL2"),
    ("SET-BOGUS-DEFUN-HINTS-OK" , "ACL2-ASG" , "ACL2"),
    ("SET-BOGUS-MUTUAL-RECURSION-OK" , "ACL2-ASG" , "ACL2"),
    ("SET-CASE-SPLIT-LIMITATIONS" , "ACL2-ASG" , "ACL2"),
    ("SET-CBD" , "ACL2-ASG" , "ACL2"),
    ("SET-CHECKPOINT-SUMMARY-LIMIT" , "ACL2-ASG" , "ACL2"),
    ("SET-COMPILE-FNS" , "ACL2-ASG" , "ACL2"),
    ("SET-DEBUGGER-ENABLE" , "ACL2-ASG" , "ACL2"),
    ("SET-DEFAULT-BACKCHAIN-LIMIT" , "ACL2-ASG" , "ACL2"),
    ("SET-DEFAULT-HINTS" , "ACL2-ASG" , "ACL2"),
    ("SET-DEFAULT-HINTS!" , "ACL2-ASG" , "ACL2"),
    ("SET-DIFFERENCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET-DIFFERENCE-EQ" , "ACL2-ASG" , "ACL2"),
    ("SET-DIFFERENCE-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("SET-DIFFERENCE-THEORIES" , "ACL2-ASG" , "ACL2"),
    ("SET-DISPATCH-MACRO-CHARACTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET-ENFORCE-REDUNDANCY" , "ACL2-ASG" , "ACL2"),
    ("SET-EQUALP-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("SET-EXCLUSIVE-OR" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET-GAG-MODE" , "ACL2-ASG" , "ACL2"),
    ("SET-GUARD-CHECKING" , "ACL2-ASG" , "ACL2"),
    ("SET-IGNORE-DOC-STRING-ERROR" , "ACL2-ASG" , "ACL2"),
    ("SET-IGNORE-OK" , "ACL2-ASG" , "ACL2"),
    ("SET-INHIBIT-OUTPUT-LST" , "ACL2-ASG" , "ACL2"),
    ("SET-INHIBIT-WARNINGS" , "ACL2-ASG" , "ACL2"),
    ("SET-INHIBITED-SUMMARY-TYPES" , "ACL2-ASG" , "ACL2"),
    ("SET-INVISIBLE-FNS-TABLE" , "ACL2-ASG" , "ACL2"),
    ("SET-IRRELEVANT-FORMALS-OK" , "ACL2-ASG" , "ACL2"),
    ("SET-LD-KEYWORD-ALIASES" , "ACL2-ASG" , "ACL2"),
    ("SET-LD-REDEFINITION-ACTION" , "ACL2-ASG" , "ACL2"),
    ("SET-LD-SKIP-PROOFS" , "ACL2-ASG" , "ACL2"),
    ("SET-LD-SKIP-PROOFSP" , "ACL2-ASG" , "ACL2"),
    ("SET-LET*-ABSTRACTION" , "ACL2-ASG" , "ACL2"),
    ("SET-LET*-ABSTRACTIONP" , "ACL2-ASG" , "ACL2"),
    ("SET-MACRO-CHARACTER" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET-MATCH-FREE-DEFAULT" , "ACL2-ASG" , "ACL2"),
    ("SET-MATCH-FREE-ERROR" , "ACL2-ASG" , "ACL2"),
    ("SET-MEASURE-FUNCTION" , "ACL2-ASG" , "ACL2"),
    ("SET-NON-LINEAR" , "ACL2-ASG" , "ACL2"),
    ("SET-NON-LINEARP" , "ACL2-ASG" , "ACL2"),
    ("SET-NU-REWRITER-MODE" , "ACL2-ASG" , "ACL2"),
    ("SET-PARALLEL-EVALUATION" , "ACL2-ASG" , "ACL2"),
    ("SET-PPRINT-DISPATCH" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET-PRINT-BASE" , "ACL2-ASG" , "ACL2"),
    ("SET-PRINT-CASE" , "ACL2-ASG" , "ACL2"),
    ("SET-PRINT-CLAUSE-IDS" , "ACL2-ASG" , "ACL2"),
    ("SET-RAW-MODE" , "ACL2-ASG" , "ACL2"),
    ("SET-RAW-MODE-ON!" , "ACL2-ASG" , "ACL2"),
    ("SET-RAW-PROOF-FORMAT" , "ACL2-ASG" , "ACL2"),
    ("SET-REWRITE-STACK-LIMIT" , "ACL2-ASG" , "ACL2"),
    ("SET-RULER-EXTENDERS" , "ACL2-ASG" , "ACL2"),
    ("SET-SAVED-OUTPUT" , "ACL2-ASG" , "ACL2"),
    ("SET-SLOW-ALIST-ACTION" , "ACL2-ASG" , "ACL2"),
    ("SET-STATE-OK" , "ACL2-ASG" , "ACL2"),
    ("SET-SYNTAX-FROM-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("SET-TAINTED-OK" , "ACL2-ASG" , "ACL2"),
    ("SET-TAINTED-OKP" , "ACL2-ASG" , "ACL2"),
    ("SET-TIMER" , "ACL2-ASG" , "ACL2"),
    ("SET-TRACE-EVISC-TUPLE" , "ACL2-ASG" , "ACL2"),
    ("SET-VERIFY-GUARDS-EAGERNESS" , "ACL2-ASG" , "ACL2"),
    ("SET-W" , "ACL2-ASG" , "ACL2"),
    ("SET-WELL-FOUNDED-RELATION" , "ACL2-ASG" , "ACL2"),
    ("SETF" , "ACL2-ASG" , "COMMON-LISP"),
    ("SETQ" , "ACL2-ASG" , "COMMON-LISP"),
    ("SEVENTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("SGETPROP" , "ACL2-ASG" , "ACL2"),
    ("SHADOW" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHADOWING-IMPORT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHARED-INITIALIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHIFTF" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHORT-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHORT-FLOAT-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHORT-FLOAT-NEGATIVE-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHORT-SITE-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("SHOW-ACCUMULATED-PERSISTENCE" , "ACL2-ASG" , "ACL2"),
    ("SHOW-BDD" , "ACL2-ASG" , "ACL2"),
    ("SHOW-BODIES" , "ACL2-ASG" , "ACL2"),
    ("SHRINK-32-BIT-INTEGER-STACK" , "ACL2-ASG" , "ACL2"),
    ("SHRINK-T-STACK" , "ACL2-ASG" , "ACL2"),
    ("SIGNAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIGNED-BYTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIGNUM" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-ARRAY" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-BASE-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-CONDITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-ARGUMENTS" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-CONTROL" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-STRING-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-TYPE-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-VECTOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-VECTOR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLE-WARNING" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIMPLIFY" , "ACL2-ASG" , "ACL2"),
    ("SIN" , "ACL2-ASG" , "COMMON-LISP"),
    ("SINGLE-FLOAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SINGLE-FLOAT-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("SINGLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-ASG" , "COMMON-LISP"),
    ("SINH" , "ACL2-ASG" , "COMMON-LISP"),
    ("SIXTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("SKIP-PROOFS" , "ACL2-ASG" , "ACL2"),
    ("SLEEP" , "ACL2-ASG" , "COMMON-LISP"),
    ("SLOT-BOUNDP" , "ACL2-ASG" , "COMMON-LISP"),
    ("SLOT-EXISTS-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("SLOT-MAKUNBOUND" , "ACL2-ASG" , "COMMON-LISP"),
    ("SLOT-MISSING" , "ACL2-ASG" , "COMMON-LISP"),
    ("SLOT-UNBOUND" , "ACL2-ASG" , "COMMON-LISP"),
    ("SLOT-VALUE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SOFTWARE-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SOFTWARE-VERSION" , "ACL2-ASG" , "COMMON-LISP"),
    ("SOME" , "ACL2-ASG" , "COMMON-LISP"),
    ("SOME-SLASHABLE" , "ACL2-ASG" , "ACL2"),
    ("SORT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SPACE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SPECIAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("SPECIAL-OPERATOR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("SPEED" , "ACL2-ASG" , "COMMON-LISP"),
    ("SQRT" , "ACL2-ASG" , "COMMON-LISP"),
    ("STABLE-SORT" , "ACL2-ASG" , "COMMON-LISP"),
    ("STABLE-UNDER-SIMPLIFICATIONP" , "ACL2-ASG" , "ACL2"),
    ("STANDARD" , "ACL2-ASG" , "COMMON-LISP"),
    ("STANDARD-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("STANDARD-CHAR-LISTP" , "ACL2-ASG" , "ACL2"),
    ("STANDARD-CHAR-LISTP-APPEND" , "ACL2-ASG" , "ACL2"),
    ("STANDARD-CHAR-LISTP-FORWARD-TO-CHARACTER-LISTP" , "ACL2-ASG"
, "ACL2"),
    ("STANDARD-CHAR-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("STANDARD-CHAR-P-NTH" , "ACL2-ASG" , "ACL2"),
    ("STANDARD-CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("STANDARD-CO" , "ACL2-ASG" , "ACL2"),
    ("STANDARD-GENERIC-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("STANDARD-METHOD" , "ACL2-ASG" , "COMMON-LISP"),
    ("STANDARD-OBJECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("STANDARD-OI" , "ACL2-ASG" , "ACL2"),
    ("STANDARD-STRING-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("STANDARD-STRING-ALISTP-FORWARD-TO-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("START-PROOF-TREE" , "ACL2-ASG" , "ACL2"),
    ("STATE" , "ACL2-ASG" , "ACL2"),
    ("STATE-GLOBAL-LET*-CLEANUP" , "ACL2-ASG" , "ACL2"),
    ("STATE-GLOBAL-LET*-GET-GLOBALS" , "ACL2-ASG" , "ACL2"),
    ("STATE-GLOBAL-LET*-PUT-GLOBALS" , "ACL2-ASG" , "ACL2"),
    ("STATE-P" , "ACL2-ASG" , "ACL2"),
    ("STATE-P-IMPLIES-AND-FORWARD-TO-STATE-P1" , "ACL2-ASG" , "ACL2"),
    ("STATE-P1" , "ACL2-ASG" , "ACL2"),
    ("STATE-P1-FORWARD" , "ACL2-ASG" , "ACL2"),
    ("STATE-P1-UPDATE-MAIN-TIMER" , "ACL2-ASG" , "ACL2"),
    ("STATE-P1-UPDATE-NTH-2-WORLD" , "ACL2-ASG" , "ACL2"),
    ("STEP" , "ACL2-ASG" , "COMMON-LISP"),
    ("STOP-PROOF-TREE" , "ACL2-ASG" , "ACL2"),
    ("STORAGE-CONDITION" , "ACL2-ASG" , "COMMON-LISP"),
    ("STORE-VALUE" , "ACL2-ASG" , "COMMON-LISP"),
    ("STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("STREAM-ELEMENT-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("STREAM-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("STREAM-ERROR-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("STREAM-EXTERNAL-FORMAT" , "ACL2-ASG" , "COMMON-LISP"),
    ("STREAMP" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-APPEND" , "ACL2-ASG" , "ACL2"),
    ("STRING-APPEND-LST" , "ACL2-ASG" , "ACL2"),
    ("STRING-CAPITALIZE" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-DOWNCASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-DOWNCASE1" , "ACL2-ASG" , "ACL2"),
    ("STRING-EQUAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-EQUAL1" , "ACL2-ASG" , "ACL2"),
    ("STRING-GREATERP" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-IS-NOT-CIRCULAR" , "ACL2-ASG" , "ACL2"),
    ("STRING-LEFT-TRIM" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-LESSP" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-LISTP" , "ACL2-ASG" , "ACL2"),
    ("STRING-NOT-EQUAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-NOT-GREATERP" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-NOT-LESSP" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-RIGHT-TRIM" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-TRIM" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-UPCASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING-UPCASE1" , "ACL2-ASG" , "ACL2"),
    ("STRING/=" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING<" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING<-IRREFLEXIVE" , "ACL2-ASG" , "ACL2"),
    ("STRING<-L" , "ACL2-ASG" , "ACL2"),
    ("STRING<-L-ASYMMETRIC" , "ACL2-ASG" , "ACL2"),
    ("STRING<-L-IRREFLEXIVE" , "ACL2-ASG" , "ACL2"),
    ("STRING<-L-TRANSITIVE" , "ACL2-ASG" , "ACL2"),
    ("STRING<-L-TRICHOTOMY" , "ACL2-ASG" , "ACL2"),
    ("STRING<=" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING=" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING>" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRING>=" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRINGP" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRINGP-SYMBOL-PACKAGE-NAME" , "ACL2-ASG" , "ACL2"),
    ("STRIP-CARS" , "ACL2-ASG" , "ACL2"),
    ("STRIP-CDRS" , "ACL2-ASG" , "ACL2"),
    ("STRUCTURE" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRUCTURE-CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("STRUCTURE-OBJECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("STYLE-WARNING" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBLIS" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBSEQ" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBSEQ-LIST" , "ACL2-ASG" , "ACL2"),
    ("SUBSETP" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBSETP-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("SUBST" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBST-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBST-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBSTITUTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBSTITUTE-AC" , "ACL2-ASG" , "ACL2"),
    ("SUBSTITUTE-IF" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBSTITUTE-IF-NOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUBTYPEP" , "ACL2-ASG" , "COMMON-LISP"),
    ("SUMMARY" , "ACL2-ASG" , "ACL2"),
    ("SVREF" , "ACL2-ASG" , "COMMON-LISP"),
    ("SXHASH" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOL" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOL-<" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-<-ASYMMETRIC" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-<-IRREFLEXIVE" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-<-TRANSITIVE" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-<-TRICHOTOMY" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-DOUBLET-LISTP" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-EQUALITY" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOL-LISTP" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-MACROLET" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOL-NAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOL-NAME-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOL-PACKAGE-NAME" , "ACL2-ASG" , "ACL2"),
    ("SYMBOL-PLIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOL-VALUE" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOLP" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYMBOLP-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-ASG" , "ACL2"),
    ("SYNONYM-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYNONYM-STREAM-SYMBOL" , "ACL2-ASG" , "COMMON-LISP"),
    ("SYNP" , "ACL2-ASG" , "ACL2"),
    ("SYNTAXP" , "ACL2-ASG" , "ACL2"),
    ("SYS-CALL" , "ACL2-ASG" , "ACL2"),
    ("SYS-CALL-STATUS" , "ACL2-ASG" , "ACL2"),
    ("T" , "ACL2-ASG" , "COMMON-LISP"),
    ("T-STACK" , "ACL2-ASG" , "ACL2"),
    ("T-STACK-LENGTH" , "ACL2-ASG" , "ACL2"),
    ("T-STACK-LENGTH1" , "ACL2-ASG" , "ACL2"),
    ("TABLE" , "ACL2-ASG" , "ACL2"),
    ("TABLE-ALIST" , "ACL2-ASG" , "ACL2"),
    ("TAGBODY" , "ACL2-ASG" , "COMMON-LISP"),
    ("TAILP" , "ACL2-ASG" , "COMMON-LISP"),
    ("TAKE" , "ACL2-ASG" , "ACL2"),
    ("TAN" , "ACL2-ASG" , "COMMON-LISP"),
    ("TANH" , "ACL2-ASG" , "COMMON-LISP"),
    ("TENTH" , "ACL2-ASG" , "COMMON-LISP"),
    ("TERPRI" , "ACL2-ASG" , "COMMON-LISP"),
    ("THE" , "ACL2-ASG" , "COMMON-LISP"),
    ("THE-ERROR" , "ACL2-ASG" , "ACL2"),
    ("THE-FIXNUM" , "ACL2-ASG" , "ACL2"),
    ("THE-FIXNUM!" , "ACL2-ASG" , "ACL2"),
    ("THEORY" , "ACL2-ASG" , "ACL2"),
    ("THEORY-INVARIANT" , "ACL2-ASG" , "ACL2"),
    ("THIRD" , "ACL2-ASG" , "COMMON-LISP"),
    ("THM" , "ACL2-ASG" , "ACL2"),
    ("THROW" , "ACL2-ASG" , "COMMON-LISP"),
    ("TIME" , "ACL2-ASG" , "COMMON-LISP"),
    ("TIME$" , "ACL2-ASG" , "ACL2"),
    ("TIMER-ALISTP" , "ACL2-ASG" , "ACL2"),
    ("TIMER-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-SYMBOL-ALISTP" ,
"ACL2-ASG" , "ACL2"),
    ("TOGGLE-PC-MACRO" , "ACL2-ASG" , "ACL2"),
    ("TRACE" , "ACL2-ASG" , "COMMON-LISP"),
    ("TRACE!" , "ACL2-ASG" , "ACL2"),
    ("TRACE$" , "ACL2-ASG" , "ACL2"),
    ("TRACE*" , "ACL2-ASG" , "ACL2"),
    ("TRANS" , "ACL2-ASG" , "ACL2"),
    ("TRANS1" , "ACL2-ASG" , "ACL2"),
    ("TRANSLATE-LOGICAL-PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("TRANSLATE-PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("TREE-EQUAL" , "ACL2-ASG" , "COMMON-LISP"),
    ("TRICHOTOMY" , "ACL2-ASG" , "ACL2"),
    ("TRUE-LIST-LISTP" , "ACL2-ASG" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP-ASSOC-EQ" , "ACL2-ASG"
, "ACL2"),
    ("TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("TRUE-LISTP-CADR-ASSOC-EQ-FOR-OPEN-CHANNELS-P" , "ACL2-ASG" ,
"ACL2"),
    ("TRUE-LISTP-UPDATE-NTH" , "ACL2-ASG" , "ACL2"),
    ("TRUENAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("TRUNCATE" , "ACL2-ASG" , "COMMON-LISP"),
    ("TWO-WAY-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-INPUT-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-OUTPUT-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("TYPE-ERROR" , "ACL2-ASG" , "COMMON-LISP"),
    ("TYPE-ERROR-DATUM" , "ACL2-ASG" , "COMMON-LISP"),
    ("TYPE-ERROR-EXPECTED-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("TYPE-OF" , "ACL2-ASG" , "COMMON-LISP"),
    ("TYPECASE" , "ACL2-ASG" , "COMMON-LISP"),
    ("TYPED-IO-LISTP" , "ACL2-ASG" , "ACL2"),
    ("TYPED-IO-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("TYPEP" , "ACL2-ASG" , "COMMON-LISP"),
    ("U" , "ACL2-ASG" , "ACL2"),
    ("UBT" , "ACL2-ASG" , "ACL2"),
    ("UBT!" , "ACL2-ASG" , "ACL2"),
    ("UNARY--" , "ACL2-ASG" , "ACL2"),
    ("UNARY-/" , "ACL2-ASG" , "ACL2"),
    ("UNARY-FUNCTION-SYMBOL-LISTP" , "ACL2-ASG" , "ACL2"),
    ("UNBOUND-SLOT" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNBOUND-SLOT-INSTANCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNBOUND-VARIABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNDEFINED-FUNCTION" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNEXPORT" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNICITY-OF-0" , "ACL2-ASG" , "ACL2"),
    ("UNICITY-OF-1" , "ACL2-ASG" , "ACL2"),
    ("UNINTERN" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNION" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNION-EQ" , "ACL2-ASG" , "ACL2"),
    ("UNION-EQUAL" , "ACL2-ASG" , "ACL2"),
    ("UNION-THEORIES" , "ACL2-ASG" , "ACL2"),
    ("UNIVERSAL-THEORY" , "ACL2-ASG" , "ACL2"),
    ("UNLESS" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNMEMOIZE" , "ACL2-ASG" , "ACL2"),
    ("UNMONITOR" , "ACL2-ASG" , "ACL2"),
    ("UNREAD-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNSAVE" , "ACL2-ASG" , "ACL2"),
    ("UNSIGNED-BYTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNTRACE" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNTRACE$" , "ACL2-ASG" , "ACL2"),
    ("UNUSE-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("UNWIND-PROTECT" , "ACL2-ASG" , "COMMON-LISP"),
    ("UPDATE-32-BIT-INTEGER-STACK" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-ACL2-ORACLE" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-BIG-CLOCK-ENTRY" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-FILE-CLOCK" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-GLOBAL-TABLE" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-IDATES" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-INSTANCE-FOR-DIFFERENT-CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("UPDATE-INSTANCE-FOR-REDEFINED-CLASS" , "ACL2-ASG" , "COMMON-LISP"),
    ("UPDATE-LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-NTH" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-OPEN-INPUT-CHANNELS" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-OPEN-OUTPUT-CHANNELS" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-READ-FILES" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-T-STACK" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST1" , "ACL2-ASG" , "ACL2"),
    ("UPDATE-WRITTEN-FILES" , "ACL2-ASG" , "ACL2"),
    ("UPGRADED-ARRAY-ELEMENT-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("UPGRADED-COMPLEX-PART-TYPE" , "ACL2-ASG" , "COMMON-LISP"),
    ("UPPER-CASE-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("UPPER-CASE-P-CHAR-UPCASE" , "ACL2-ASG" , "ACL2"),
    ("UPPER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-ASG" , "ACL2"),
    ("USE-PACKAGE" , "ACL2-ASG" , "COMMON-LISP"),
    ("USE-VALUE" , "ACL2-ASG" , "COMMON-LISP"),
    ("USER-HOMEDIR-PATHNAME" , "ACL2-ASG" , "COMMON-LISP"),
    ("USER-STOBJ-ALIST" , "ACL2-ASG" , "ACL2"),
    ("USER-STOBJ-ALIST1" , "ACL2-ASG" , "ACL2"),
    ("VALUE-TRIPLE" , "ACL2-ASG" , "ACL2"),
    ("VALUES" , "ACL2-ASG" , "COMMON-LISP"),
    ("VALUES-LIST" , "ACL2-ASG" , "COMMON-LISP"),
    ("VARIABLE" , "ACL2-ASG" , "COMMON-LISP"),
    ("VECTOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("VECTOR-POP" , "ACL2-ASG" , "COMMON-LISP"),
    ("VECTOR-PUSH" , "ACL2-ASG" , "COMMON-LISP"),
    ("VECTOR-PUSH-EXTEND" , "ACL2-ASG" , "COMMON-LISP"),
    ("VECTORP" , "ACL2-ASG" , "COMMON-LISP"),
    ("VERBOSE-PSTACK" , "ACL2-ASG" , "ACL2"),
    ("VERIFY" , "ACL2-ASG" , "ACL2"),
    ("VERIFY-GUARDS" , "ACL2-ASG" , "ACL2"),
    ("VERIFY-TERMINATION" , "ACL2-ASG" , "ACL2"),
    ("W" , "ACL2-ASG" , "ACL2"),
    ("WARN" , "ACL2-ASG" , "COMMON-LISP"),
    ("WARNING" , "ACL2-ASG" , "COMMON-LISP"),
    ("WARNING!" , "ACL2-ASG" , "ACL2"),
    ("WHEN" , "ACL2-ASG" , "COMMON-LISP"),
    ("WILD-PATHNAME-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-ACCESSORS" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-COMPILATION-UNIT" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-CONDITION-RESTARTS" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-HASH-TABLE-ITERATOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-INPUT-FROM-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-OPEN-FILE" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-OPEN-STREAM" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-OUTPUT" , "ACL2-ASG" , "ACL2"),
    ("WITH-OUTPUT-TO-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-PACKAGE-ITERATOR" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-SIMPLE-RESTART" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-SLOTS" , "ACL2-ASG" , "COMMON-LISP"),
    ("WITH-STANDARD-IO-SYNTAX" , "ACL2-ASG" , "COMMON-LISP"),
    ("WORLD" , "ACL2-ASG" , "ACL2"),
    ("WORMHOLE" , "ACL2-ASG" , "ACL2"),
    ("WORMHOLE-EVAL" , "ACL2-ASG" , "ACL2"),
    ("WORMHOLE1" , "ACL2-ASG" , "ACL2"),
    ("WRITABLE-FILE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("WRITABLE-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-ASG"
, "ACL2"),
    ("WRITABLE-FILE-LISTP1" , "ACL2-ASG" , "ACL2"),
    ("WRITABLE-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-ASG"
, "ACL2"),
    ("WRITE" , "ACL2-ASG" , "COMMON-LISP"),
    ("WRITE-BYTE" , "ACL2-ASG" , "COMMON-LISP"),
    ("WRITE-BYTE$" , "ACL2-ASG" , "ACL2"),
    ("WRITE-CHAR" , "ACL2-ASG" , "COMMON-LISP"),
    ("WRITE-LINE" , "ACL2-ASG" , "COMMON-LISP"),
    ("WRITE-SEQUENCE" , "ACL2-ASG" , "COMMON-LISP"),
    ("WRITE-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("WRITE-TO-STRING" , "ACL2-ASG" , "COMMON-LISP"),
    ("WRITEABLE-FILES" , "ACL2-ASG" , "ACL2"),
    ("WRITEABLE-FILES-P" , "ACL2-ASG" , "ACL2"),
    ("WRITEABLE-FILES-P-FORWARD-TO-WRITABLE-FILE-LISTP" , "ACL2-ASG"
, "ACL2"),
    ("WRITTEN-FILE" , "ACL2-ASG" , "ACL2"),
    ("WRITTEN-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-ASG" ,
"ACL2"),
    ("WRITTEN-FILE-LISTP" , "ACL2-ASG" , "ACL2"),
    ("WRITTEN-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" , "ACL2-ASG"
, "ACL2"),
    ("WRITTEN-FILES" , "ACL2-ASG" , "ACL2"),
    ("WRITTEN-FILES-P" , "ACL2-ASG" , "ACL2"),
    ("WRITTEN-FILES-P-FORWARD-TO-WRITTEN-FILE-LISTP" , "ACL2-ASG" ,
"ACL2"),
    ("XARGS" , "ACL2-ASG" , "ACL2"),
    ("XXXJOIN" , "ACL2-ASG" , "ACL2"),
    ("Y-OR-N-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("YES-OR-NO-P" , "ACL2-ASG" , "COMMON-LISP"),
    ("ZEROP" , "ACL2-ASG" , "COMMON-LISP"),
    ("ZIP" , "ACL2-ASG" , "ACL2"),
    ("ZP" , "ACL2-ASG" , "ACL2"),
    ("&" , "ACL2-AGP" , "ACL2"),
    ("&ALLOW-OTHER-KEYS" , "ACL2-AGP" , "COMMON-LISP"),
    ("&AUX" , "ACL2-AGP" , "COMMON-LISP"),
    ("&BODY" , "ACL2-AGP" , "COMMON-LISP"),
    ("&ENVIRONMENT" , "ACL2-AGP" , "COMMON-LISP"),
    ("&KEY" , "ACL2-AGP" , "COMMON-LISP"),
    ("&OPTIONAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("&REST" , "ACL2-AGP" , "COMMON-LISP"),
    ("&WHOLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("*" , "ACL2-AGP" , "COMMON-LISP"),
    ("**" , "ACL2-AGP" , "COMMON-LISP"),
    ("***" , "ACL2-AGP" , "COMMON-LISP"),
    ("*ACL2-EXPORTS*" , "ACL2-AGP" , "ACL2"),
    ("*BREAK-ON-SIGNALS*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*COMMON-LISP-SPECIALS-AND-CONSTANTS*" , "ACL2-AGP" , "ACL2"),
    ("*COMMON-LISP-SYMBOLS-FROM-MAIN-LISP-PACKAGE*" , "ACL2-AGP" ,
"ACL2"),
    ("*COMPILE-FILE-PATHNAME*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*COMPILE-FILE-TRUENAME*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*COMPILE-PRINT*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*COMPILE-VERBOSE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*DEBUG-IO*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*DEBUGGER-HOOK*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*DEFAULT-PATHNAME-DEFAULTS*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*ERROR-OUTPUT*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*FEATURES*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*GENSYM-COUNTER*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*LOAD-PATHNAME*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*LOAD-PRINT*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*LOAD-TRUENAME*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*LOAD-VERBOSE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*MACROEXPAND-HOOK*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*MAIN-LISP-PACKAGE-NAME*" , "ACL2-AGP" , "ACL2"),
    ("*MODULES*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PACKAGE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-ARRAY*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-BASE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-CASE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-CIRCLE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-ESCAPE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-GENSYM*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-LENGTH*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-LEVEL*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-LINES*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-MISER-WIDTH*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-PPRINT-DISPATCH*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-PRETTY*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-RADIX*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-READABLY*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*PRINT-RIGHT-MARGIN*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*QUERY-IO*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*RANDOM-STATE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*READ-BASE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*READ-DEFAULT-FLOAT-FORMAT*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*READ-EVAL*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*READ-SUPPRESS*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*READTABLE*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*STANDARD-CHARS*" , "ACL2-AGP" , "ACL2"),
    ("*STANDARD-CI*" , "ACL2-AGP" , "ACL2"),
    ("*STANDARD-CO*" , "ACL2-AGP" , "ACL2"),
    ("*STANDARD-INPUT*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*STANDARD-OI*" , "ACL2-AGP" , "ACL2"),
    ("*STANDARD-OUTPUT*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*TERMINAL-IO*" , "ACL2-AGP" , "COMMON-LISP"),
    ("*TRACE-OUTPUT*" , "ACL2-AGP" , "COMMON-LISP"),
    ("+" , "ACL2-AGP" , "COMMON-LISP"),
    ("++" , "ACL2-AGP" , "COMMON-LISP"),
    ("+++" , "ACL2-AGP" , "COMMON-LISP"),
    ("-" , "ACL2-AGP" , "COMMON-LISP"),
    ("/" , "ACL2-AGP" , "COMMON-LISP"),
    ("//" , "ACL2-AGP" , "COMMON-LISP"),
    ("///" , "ACL2-AGP" , "COMMON-LISP"),
    ("/=" , "ACL2-AGP" , "COMMON-LISP"),
    ("1+" , "ACL2-AGP" , "COMMON-LISP"),
    ("1-" , "ACL2-AGP" , "COMMON-LISP"),
    ("32-BIT-INTEGER-LISTP" , "ACL2-AGP" , "ACL2"),
    ("32-BIT-INTEGER-LISTP-FORWARD-TO-INTEGER-LISTP" , "ACL2-AGP" ,
"ACL2"),
    ("32-BIT-INTEGER-STACK" , "ACL2-AGP" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH" , "ACL2-AGP" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH1" , "ACL2-AGP" , "ACL2"),
    ("32-BIT-INTEGERP" , "ACL2-AGP" , "ACL2"),
    ("32-BIT-INTEGERP-FORWARD-TO-INTEGERP" , "ACL2-AGP" , "ACL2"),
    ("<" , "ACL2-AGP" , "COMMON-LISP"),
    ("<-ON-OTHERS" , "ACL2-AGP" , "ACL2"),
    ("<=" , "ACL2-AGP" , "COMMON-LISP"),
    ("=" , "ACL2-AGP" , "COMMON-LISP"),
    (">" , "ACL2-AGP" , "COMMON-LISP"),
    (">=" , "ACL2-AGP" , "COMMON-LISP"),
    ("?-FN" , "ACL2-AGP" , "ACL2"),
    ("@" , "ACL2-AGP" , "ACL2"),
    ("ABORT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ABORT!" , "ACL2-AGP" , "ACL2"),
    ("ABS" , "ACL2-AGP" , "COMMON-LISP"),
    ("ACCUMULATED-PERSISTENCE" , "ACL2-AGP" , "ACL2"),
    ("ACL2-COUNT" , "ACL2-AGP" , "ACL2"),
    ("ACL2-INPUT-CHANNEL-PACKAGE" , "ACL2-AGP" , "ACL2"),
    ("ACL2-NUMBERP" , "ACL2-AGP" , "ACL2"),
    ("ACL2-ORACLE" , "ACL2-AGP" , "ACL2"),
    ("ACL2-OUTPUT-CHANNEL-PACKAGE" , "ACL2-AGP" , "ACL2"),
    ("ACL2-PACKAGE" , "ACL2-AGP" , "ACL2"),
    ("ACONS" , "ACL2-AGP" , "COMMON-LISP"),
    ("ACOS" , "ACL2-AGP" , "COMMON-LISP"),
    ("ACOSH" , "ACL2-AGP" , "COMMON-LISP"),
    ("ACTIVE-RUNEP" , "ACL2-AGP" , "ACL2"),
    ("ADD-BINOP" , "ACL2-AGP" , "ACL2"),
    ("ADD-DEFAULT-HINTS" , "ACL2-AGP" , "ACL2"),
    ("ADD-DEFAULT-HINTS!" , "ACL2-AGP" , "ACL2"),
    ("ADD-INVISIBLE-FNS" , "ACL2-AGP" , "ACL2"),
    ("ADD-MACRO-ALIAS" , "ACL2-AGP" , "ACL2"),
    ("ADD-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("ADD-NTH-ALIAS" , "ACL2-AGP" , "ACL2"),
    ("ADD-PAIR" , "ACL2-AGP" , "ACL2"),
    ("ADD-PAIR-PRESERVES-ALL-BOUNDP" , "ACL2-AGP" , "ACL2"),
    ("ADD-TIMERS" , "ACL2-AGP" , "ACL2"),
    ("ADD-TO-SET-EQ" , "ACL2-AGP" , "ACL2"),
    ("ADD-TO-SET-EQL" , "ACL2-AGP" , "ACL2"),
    ("ADD-TO-SET-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("ADJOIN" , "ACL2-AGP" , "COMMON-LISP"),
    ("ADJUST-ARRAY" , "ACL2-AGP" , "COMMON-LISP"),
    ("ADJUSTABLE-ARRAY-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("ALISTP" , "ACL2-AGP" , "ACL2"),
    ("ALISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("ALL-BOUNDP" , "ACL2-AGP" , "ACL2"),
    ("ALL-BOUNDP-PRESERVES-ASSOC" , "ACL2-AGP" , "ACL2"),
    ("ALL-VARS" , "ACL2-AGP" , "ACL2"),
    ("ALL-VARS1" , "ACL2-AGP" , "ACL2"),
    ("ALL-VARS1-LST" , "ACL2-AGP" , "ACL2"),
    ("ALLOCATE-INSTANCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("ALPHA-CHAR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("ALPHA-CHAR-P-FORWARD-TO-CHARACTERP" , "ACL2-AGP" , "ACL2"),
    ("ALPHANUMERICP" , "ACL2-AGP" , "COMMON-LISP"),
    ("AND" , "ACL2-AGP" , "COMMON-LISP"),
    ("AND-MACRO" , "ACL2-AGP" , "ACL2"),
    ("APPEND" , "ACL2-AGP" , "COMMON-LISP"),
    ("APPLY" , "ACL2-AGP" , "COMMON-LISP"),
    ("APROPOS" , "ACL2-AGP" , "COMMON-LISP"),
    ("APROPOS-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("AREF" , "ACL2-AGP" , "COMMON-LISP"),
    ("AREF-32-BIT-INTEGER-STACK" , "ACL2-AGP" , "ACL2"),
    ("AREF-T-STACK" , "ACL2-AGP" , "ACL2"),
    ("AREF1" , "ACL2-AGP" , "ACL2"),
    ("AREF2" , "ACL2-AGP" , "ACL2"),
    ("ARGS" , "ACL2-AGP" , "ACL2"),
    ("ARITHMETIC-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERANDS" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERATION" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-DIMENSION" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-DIMENSION-LIMIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-DIMENSIONS" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-DISPLACEMENT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-ELEMENT-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-HAS-FILL-POINTER-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-IN-BOUNDS-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-RANK" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-RANK-LIMIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-ROW-MAJOR-INDEX" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE-LIMIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ARRAY1P" , "ACL2-AGP" , "ACL2"),
    ("ARRAY1P-CONS" , "ACL2-AGP" , "ACL2"),
    ("ARRAY1P-FORWARD" , "ACL2-AGP" , "ACL2"),
    ("ARRAY1P-LINEAR" , "ACL2-AGP" , "ACL2"),
    ("ARRAY2P" , "ACL2-AGP" , "ACL2"),
    ("ARRAY2P-CONS" , "ACL2-AGP" , "ACL2"),
    ("ARRAY2P-FORWARD" , "ACL2-AGP" , "ACL2"),
    ("ARRAY2P-LINEAR" , "ACL2-AGP" , "ACL2"),
    ("ARRAYP" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASET-32-BIT-INTEGER-STACK" , "ACL2-AGP" , "ACL2"),
    ("ASET-T-STACK" , "ACL2-AGP" , "ACL2"),
    ("ASET1" , "ACL2-AGP" , "ACL2"),
    ("ASET2" , "ACL2-AGP" , "ACL2"),
    ("ASH" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASIN" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASINH" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASSERT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASSERT$" , "ACL2-AGP" , "ACL2"),
    ("ASSIGN" , "ACL2-AGP" , "ACL2"),
    ("ASSOC" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASSOC-ADD-PAIR" , "ACL2-AGP" , "ACL2"),
    ("ASSOC-EQ" , "ACL2-AGP" , "ACL2"),
    ("ASSOC-EQ-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("ASSOC-EQ-EQUAL-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("ASSOC-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("ASSOC-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASSOC-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ASSOC-KEYWORD" , "ACL2-AGP" , "ACL2"),
    ("ASSOC-STRING-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("ASSOC2" , "ACL2-AGP" , "ACL2"),
    ("ASSOCIATIVITY-OF-*" , "ACL2-AGP" , "ACL2"),
    ("ASSOCIATIVITY-OF-+" , "ACL2-AGP" , "ACL2"),
    ("ASSUME" , "ACL2-AGP" , "ACL2"),
    ("ATAN" , "ACL2-AGP" , "COMMON-LISP"),
    ("ATANH" , "ACL2-AGP" , "COMMON-LISP"),
    ("ATOM" , "ACL2-AGP" , "COMMON-LISP"),
    ("ATOM-LISTP" , "ACL2-AGP" , "ACL2"),
    ("ATOM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("BASE-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BASE-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIG-CLOCK-ENTRY" , "ACL2-AGP" , "ACL2"),
    ("BIG-CLOCK-NEGATIVE-P" , "ACL2-AGP" , "ACL2"),
    ("BIGNUM" , "ACL2-AGP" , "COMMON-LISP"),
    ("BINARY-*" , "ACL2-AGP" , "ACL2"),
    ("BINARY-+" , "ACL2-AGP" , "ACL2"),
    ("BINARY-APPEND" , "ACL2-AGP" , "ACL2"),
    ("BIND-FREE" , "ACL2-AGP" , "ACL2"),
    ("BINOP-TABLE" , "ACL2-AGP" , "ACL2"),
    ("BIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-AND" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-ANDC1" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-ANDC2" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-EQV" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-IOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-NAND" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-NOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-ORC1" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-ORC2" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-VECTOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-VECTOR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("BIT-XOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BLOCK" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-1" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-2" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-AND" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-ANDC1" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-ANDC2" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-C1" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-C2" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-CLR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-EQV" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-IOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-NAND" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-NOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-ORC1" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-ORC2" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-SET" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLE-XOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLEAN" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOOLEAN-LISTP" , "ACL2-AGP" , "ACL2"),
    ("BOOLEAN-LISTP-CONS" , "ACL2-AGP" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD" , "ACL2-AGP" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD-TO-SYMBOL-LISTP" , "ACL2-AGP" , "ACL2"),
    ("BOOLEANP" , "ACL2-AGP" , "ACL2"),
    ("BOOLEANP-CHARACTERP" , "ACL2-AGP" , "ACL2"),
    ("BOOLEANP-COMPOUND-RECOGNIZER" , "ACL2-AGP" , "ACL2"),
    ("BOTH-CASE-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOUNDED-INTEGER-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("BOUNDED-INTEGER-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-AGP"
, "ACL2"),
    ("BOUNDED-INTEGER-ALISTP2" , "ACL2-AGP" , "ACL2"),
    ("BOUNDP" , "ACL2-AGP" , "COMMON-LISP"),
    ("BOUNDP-GLOBAL" , "ACL2-AGP" , "ACL2"),
    ("BOUNDP-GLOBAL1" , "ACL2-AGP" , "ACL2"),
    ("BREAK" , "ACL2-AGP" , "COMMON-LISP"),
    ("BROADCAST-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("BROADCAST-STREAM-STREAMS" , "ACL2-AGP" , "COMMON-LISP"),
    ("BRR" , "ACL2-AGP" , "ACL2"),
    ("BRR@" , "ACL2-AGP" , "ACL2"),
    ("BUILD-STATE1" , "ACL2-AGP" , "ACL2"),
    ("BUILT-IN-CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("BUTLAST" , "ACL2-AGP" , "COMMON-LISP"),
    ("BYTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("BYTE-POSITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("BYTE-SIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAAAAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAAADR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAAAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAADAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAADDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAADR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CADAAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CADADR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CADAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CADDAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CADDDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CADDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CADR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CALL-ARGUMENTS-LIMIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("CALL-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("CALL-NEXT-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CAR-CDR-ELIM" , "ACL2-AGP" , "ACL2"),
    ("CAR-CONS" , "ACL2-AGP" , "ACL2"),
    ("CASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CASE-LIST" , "ACL2-AGP" , "ACL2"),
    ("CASE-LIST-CHECK" , "ACL2-AGP" , "ACL2"),
    ("CASE-MATCH" , "ACL2-AGP" , "ACL2"),
    ("CASE-SPLIT" , "ACL2-AGP" , "ACL2"),
    ("CASE-TEST" , "ACL2-AGP" , "ACL2"),
    ("CATCH" , "ACL2-AGP" , "COMMON-LISP"),
    ("CBD" , "ACL2-AGP" , "ACL2"),
    ("CCASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDAAAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDAADR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDAAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDADAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDADDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDADR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDDAAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDDADR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDDAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDDDAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDDDDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDDDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CDR-CONS" , "ACL2-AGP" , "ACL2"),
    ("CDRN" , "ACL2-AGP" , "ACL2"),
    ("CEILING" , "ACL2-AGP" , "COMMON-LISP"),
    ("CELL-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CELL-ERROR-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("CERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CERTIFY-BOOK" , "ACL2-AGP" , "ACL2"),
    ("CERTIFY-BOOK!" , "ACL2-AGP" , "ACL2"),
    ("CHANGE-CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-CODE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-CODE-CODE-CHAR-IS-IDENTITY" , "ACL2-AGP" , "ACL2"),
    ("CHAR-CODE-LIMIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-CODE-LINEAR" , "ACL2-AGP" , "ACL2"),
    ("CHAR-DOWNCASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-EQUAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-GREATERP" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-INT" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-LESSP" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-NOT-EQUAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-NOT-GREATERP" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-NOT-LESSP" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR-UPCASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR/=" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR<" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR<=" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR=" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR>" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHAR>=" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHARACTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHARACTER-LISTP" , "ACL2-AGP" , "ACL2"),
    ("CHARACTER-LISTP-APPEND" , "ACL2-AGP" , "ACL2"),
    ("CHARACTER-LISTP-COERCE" , "ACL2-AGP" , "ACL2"),
    ("CHARACTER-LISTP-FORWARD-TO-EQLABLE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("CHARACTER-LISTP-REMOVE-DUPLICATES-EQL" , "ACL2-AGP" , "ACL2"),
    ("CHARACTER-LISTP-REVAPPEND" , "ACL2-AGP" , "ACL2"),
    ("CHARACTER-LISTP-STRING-DOWNCASE-1" , "ACL2-AGP" , "ACL2"),
    ("CHARACTER-LISTP-STRING-UPCASE1-1" , "ACL2-AGP" , "ACL2"),
    ("CHARACTERP" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHARACTERP-CHAR-DOWNCASE" , "ACL2-AGP" , "ACL2"),
    ("CHARACTERP-CHAR-UPCASE" , "ACL2-AGP" , "ACL2"),
    ("CHARACTERP-NTH" , "ACL2-AGP" , "ACL2"),
    ("CHARACTERP-PAGE" , "ACL2-AGP" , "ACL2"),
    ("CHARACTERP-RUBOUT" , "ACL2-AGP" , "ACL2"),
    ("CHARACTERP-TAB" , "ACL2-AGP" , "ACL2"),
    ("CHECK-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CHECK-VARS-NOT-FREE" , "ACL2-AGP" , "ACL2"),
    ("CHECKPOINT-FORCED-GOALS" , "ACL2-AGP" , "ACL2"),
    ("CIS" , "ACL2-AGP" , "COMMON-LISP"),
    ("CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("CLASS-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("CLASS-OF" , "ACL2-AGP" , "COMMON-LISP"),
    ("CLAUSE" , "ACL2-AGP" , "ACL2"),
    ("CLEAR-HASH-TABLES" , "ACL2-AGP" , "ACL2"),
    ("CLEAR-INPUT" , "ACL2-AGP" , "COMMON-LISP"),
    ("CLEAR-MEMOIZE-TABLE" , "ACL2-AGP" , "ACL2"),
    ("CLEAR-MEMOIZE-TABLES" , "ACL2-AGP" , "ACL2"),
    ("CLEAR-OUTPUT" , "ACL2-AGP" , "COMMON-LISP"),
    ("CLOSE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CLOSE-INPUT-CHANNEL" , "ACL2-AGP" , "ACL2"),
    ("CLOSE-OUTPUT-CHANNEL" , "ACL2-AGP" , "ACL2"),
    ("CLOSE-TRACE-FILE" , "ACL2-AGP" , "ACL2"),
    ("CLOSURE" , "ACL2-AGP" , "ACL2"),
    ("CLRHASH" , "ACL2-AGP" , "COMMON-LISP"),
    ("CODE-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("CODE-CHAR-CHAR-CODE-IS-IDENTITY" , "ACL2-AGP" , "ACL2"),
    ("CODE-CHAR-TYPE" , "ACL2-AGP" , "ACL2"),
    ("COERCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("COERCE-INVERSE-1" , "ACL2-AGP" , "ACL2"),
    ("COERCE-INVERSE-2" , "ACL2-AGP" , "ACL2"),
    ("COERCE-OBJECT-TO-STATE" , "ACL2-AGP" , "ACL2"),
    ("COERCE-STATE-TO-OBJECT" , "ACL2-AGP" , "ACL2"),
    ("COMMUTATIVITY-OF-*" , "ACL2-AGP" , "ACL2"),
    ("COMMUTATIVITY-OF-+" , "ACL2-AGP" , "ACL2"),
    ("COMP" , "ACL2-AGP" , "ACL2"),
    ("COMPILATION-SPEED" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPILE" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPILE-FILE" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPILE-FILE-PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPILED-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPILED-FUNCTION-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPILER-MACRO" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPILER-MACRO-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPLEMENT" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPLETION-OF-*" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-+" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-<" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-CAR" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-CDR" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-CHAR-CODE" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-CODE-CHAR" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-COERCE" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-COMPLEX" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-DENOMINATOR" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-IMAGPART" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-NUMERATOR" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-REALPART" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-NAME" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-PACKAGE-NAME" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-UNARY-/" , "ACL2-AGP" , "ACL2"),
    ("COMPLETION-OF-UNARY-MINUS" , "ACL2-AGP" , "ACL2"),
    ("COMPLEX" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPLEX-0" , "ACL2-AGP" , "ACL2"),
    ("COMPLEX-DEFINITION" , "ACL2-AGP" , "ACL2"),
    ("COMPLEX-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("COMPLEX-IMPLIES1" , "ACL2-AGP" , "ACL2"),
    ("COMPLEX-RATIONALP" , "ACL2-AGP" , "ACL2"),
    ("COMPLEXP" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPRESS1" , "ACL2-AGP" , "ACL2"),
    ("COMPRESS11" , "ACL2-AGP" , "ACL2"),
    ("COMPRESS2" , "ACL2-AGP" , "ACL2"),
    ("COMPRESS21" , "ACL2-AGP" , "ACL2"),
    ("COMPRESS211" , "ACL2-AGP" , "ACL2"),
    ("COMPUTE-APPLICABLE-METHODS" , "ACL2-AGP" , "COMMON-LISP"),
    ("COMPUTE-RESTARTS" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONCATENATE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONCATENATED-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONCATENATED-STREAM-STREAMS" , "ACL2-AGP" , "COMMON-LISP"),
    ("COND" , "ACL2-AGP" , "COMMON-LISP"),
    ("COND-CLAUSESP" , "ACL2-AGP" , "ACL2"),
    ("COND-MACRO" , "ACL2-AGP" , "ACL2"),
    ("CONDITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONJUGATE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONS" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONS-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("CONS-SUBTREES" , "ACL2-AGP" , "ACL2"),
    ("CONSP" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONSP-ASSOC" , "ACL2-AGP" , "ACL2"),
    ("CONSP-ASSOC-EQ" , "ACL2-AGP" , "ACL2"),
    ("CONSTANTLY" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONSTANTP" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONTINUE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CONTROL-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-ALIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-PPRINT-DISPATCH" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-READTABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-SEQ" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-STRUCTURE" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-SYMBOL" , "ACL2-AGP" , "COMMON-LISP"),
    ("COPY-TREE" , "ACL2-AGP" , "COMMON-LISP"),
    ("COS" , "ACL2-AGP" , "COMMON-LISP"),
    ("COSH" , "ACL2-AGP" , "COMMON-LISP"),
    ("COUNT" , "ACL2-AGP" , "COMMON-LISP"),
    ("COUNT-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("COUNT-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("CTYPECASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("CURRENT-PACKAGE" , "ACL2-AGP" , "ACL2"),
    ("CURRENT-THEORY" , "ACL2-AGP" , "ACL2"),
    ("CW" , "ACL2-AGP" , "ACL2"),
    ("CW-GSTACK" , "ACL2-AGP" , "ACL2"),
    ("DEBUG" , "ACL2-AGP" , "COMMON-LISP"),
    ("DECF" , "ACL2-AGP" , "COMMON-LISP"),
    ("DECLAIM" , "ACL2-AGP" , "COMMON-LISP"),
    ("DECLARATION" , "ACL2-AGP" , "COMMON-LISP"),
    ("DECLARE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DECODE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("DECODE-UNIVERSAL-TIME" , "ACL2-AGP" , "COMMON-LISP"),
    ("DECREMENT-BIG-CLOCK" , "ACL2-AGP" , "ACL2"),
    ("DEFABBREV" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-*-1" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-*-2" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-+-1" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-+-2" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-<-1" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-<-2" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-CAR" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-CDR" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-CHAR-CODE" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-COERCE-1" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-COERCE-2" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-COERCE-3" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-COMPILE-FNS" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-COMPLEX-1" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-COMPLEX-2" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-DEFUN-MODE" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-DEFUN-MODE-FROM-STATE" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-DENOMINATOR" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-IMAGPART" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-MEASURE-FUNCTION" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-NUMERATOR" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-REALPART" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-SYMBOL-NAME" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-SYMBOL-PACKAGE-NAME" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-UNARY-/" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-UNARY-MINUS" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-VERIFY-GUARDS-EAGERNESS" , "ACL2-AGP" , "ACL2"),
    ("DEFAULT-WELL-FOUNDED-RELATION" , "ACL2-AGP" , "ACL2"),
    ("DEFAXIOM" , "ACL2-AGP" , "ACL2"),
    ("DEFCHOOSE" , "ACL2-AGP" , "ACL2"),
    ("DEFCLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFCONG" , "ACL2-AGP" , "ACL2"),
    ("DEFCONST" , "ACL2-AGP" , "ACL2"),
    ("DEFCONSTANT" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFDOC" , "ACL2-AGP" , "ACL2"),
    ("DEFEQUIV" , "ACL2-AGP" , "ACL2"),
    ("DEFEVALUATOR" , "ACL2-AGP" , "ACL2"),
    ("DEFEXEC" , "ACL2-AGP" , "ACL2"),
    ("DEFGENERIC" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFINE-COMPILER-MACRO" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFINE-CONDITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFINE-METHOD-COMBINATION" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFINE-MODIFY-MACRO" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFINE-PC-ATOMIC-MACRO" , "ACL2-AGP" , "ACL2"),
    ("DEFINE-PC-HELP" , "ACL2-AGP" , "ACL2"),
    ("DEFINE-PC-MACRO" , "ACL2-AGP" , "ACL2"),
    ("DEFINE-SETF-EXPANDER" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFINE-SYMBOL-MACRO" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFLABEL" , "ACL2-AGP" , "ACL2"),
    ("DEFMACRO" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFMETHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFPACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFPARAMETER" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFPKG" , "ACL2-AGP" , "ACL2"),
    ("DEFREFINEMENT" , "ACL2-AGP" , "ACL2"),
    ("DEFSETF" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFSTOBJ" , "ACL2-AGP" , "ACL2"),
    ("DEFSTRUCT" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFSTUB" , "ACL2-AGP" , "ACL2"),
    ("DEFTHEORY" , "ACL2-AGP" , "ACL2"),
    ("DEFTHM" , "ACL2-AGP" , "ACL2"),
    ("DEFTHMD" , "ACL2-AGP" , "ACL2"),
    ("DEFTTAG" , "ACL2-AGP" , "ACL2"),
    ("DEFTYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFUN" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEFUN-NX" , "ACL2-AGP" , "ACL2"),
    ("DEFUN-SK" , "ACL2-AGP" , "ACL2"),
    ("DEFUND" , "ACL2-AGP" , "ACL2"),
    ("DEFUND-NX" , "ACL2-AGP" , "ACL2"),
    ("DEFUNS" , "ACL2-AGP" , "ACL2"),
    ("DEFVAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("DELETE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DELETE-DUPLICATES" , "ACL2-AGP" , "COMMON-LISP"),
    ("DELETE-FILE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DELETE-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("DELETE-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("DELETE-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DELETE-PAIR" , "ACL2-AGP" , "ACL2"),
    ("DENOMINATOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("DEPOSIT-FIELD" , "ACL2-AGP" , "COMMON-LISP"),
    ("DESCRIBE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DESCRIBE-OBJECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("DESTRUCTURING-BIND" , "ACL2-AGP" , "COMMON-LISP"),
    ("DIGIT-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("DIGIT-CHAR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("DIGIT-TO-CHAR" , "ACL2-AGP" , "ACL2"),
    ("DIMENSIONS" , "ACL2-AGP" , "ACL2"),
    ("DIRECTORY" , "ACL2-AGP" , "COMMON-LISP"),
    ("DIRECTORY-NAMESTRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("DISABLE" , "ACL2-AGP" , "ACL2"),
    ("DISABLE-FORCING" , "ACL2-AGP" , "ACL2"),
    ("DISABLEDP" , "ACL2-AGP" , "ACL2"),
    ("DISASSEMBLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DISTRIBUTIVITY" , "ACL2-AGP" , "ACL2"),
    ("DIVISION-BY-ZERO" , "ACL2-AGP" , "COMMON-LISP"),
    ("DO" , "ACL2-AGP" , "COMMON-LISP"),
    ("DO*" , "ACL2-AGP" , "COMMON-LISP"),
    ("DO-ALL-SYMBOLS" , "ACL2-AGP" , "COMMON-LISP"),
    ("DO-EXTERNAL-SYMBOLS" , "ACL2-AGP" , "COMMON-LISP"),
    ("DO-SYMBOLS" , "ACL2-AGP" , "COMMON-LISP"),
    ("DOC" , "ACL2-AGP" , "ACL2"),
    ("DOC!" , "ACL2-AGP" , "ACL2"),
    ("DOCS" , "ACL2-AGP" , "ACL2"),
    ("DOCUMENTATION" , "ACL2-AGP" , "COMMON-LISP"),
    ("DOLIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("DOTIMES" , "ACL2-AGP" , "COMMON-LISP"),
    ("DOUBLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("DOUBLE-REWRITE" , "ACL2-AGP" , "ACL2"),
    ("DPB" , "ACL2-AGP" , "COMMON-LISP"),
    ("DRIBBLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("DUPLICATES" , "ACL2-AGP" , "ACL2"),
    ("DYNAMIC-EXTENT" , "ACL2-AGP" , "COMMON-LISP"),
    ("E/D" , "ACL2-AGP" , "ACL2"),
    ("E0-ORD-<" , "ACL2-AGP" , "ACL2"),
    ("E0-ORDINALP" , "ACL2-AGP" , "ACL2"),
    ("EC-CALL" , "ACL2-AGP" , "ACL2"),
    ("ECASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("ECHO-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("ECHO-STREAM-INPUT-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("ECHO-STREAM-OUTPUT-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("ED" , "ACL2-AGP" , "COMMON-LISP"),
    ("EIGHTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("ELIMINATE-DESTRUCTORS" , "ACL2-AGP" , "ACL2"),
    ("ELIMINATE-IRRELEVANCE" , "ACL2-AGP" , "ACL2"),
    ("ELT" , "ACL2-AGP" , "COMMON-LISP"),
    ("ENABLE" , "ACL2-AGP" , "ACL2"),
    ("ENABLE-FORCING" , "ACL2-AGP" , "ACL2"),
    ("ENCAPSULATE" , "ACL2-AGP" , "ACL2"),
    ("ENCODE-UNIVERSAL-TIME" , "ACL2-AGP" , "COMMON-LISP"),
    ("END-OF-FILE" , "ACL2-AGP" , "COMMON-LISP"),
    ("ENDP" , "ACL2-AGP" , "COMMON-LISP"),
    ("ENOUGH-NAMESTRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("ENSURE-DIRECTORIES-EXIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("ENSURE-GENERIC-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("EQ" , "ACL2-AGP" , "COMMON-LISP"),
    ("EQL" , "ACL2-AGP" , "COMMON-LISP"),
    ("EQLABLE-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("EQLABLE-ALISTP-FORWARD-TO-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("EQLABLE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("EQLABLE-LISTP-FORWARD-TO-ATOM-LISTP" , "ACL2-AGP" , "ACL2"),
    ("EQLABLEP" , "ACL2-AGP" , "ACL2"),
    ("EQLABLEP-RECOG" , "ACL2-AGP" , "ACL2"),
    ("EQUAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("EQUAL-CHAR-CODE" , "ACL2-AGP" , "ACL2"),
    ("EQUALP" , "ACL2-AGP" , "COMMON-LISP"),
    ("ER" , "ACL2-AGP" , "ACL2"),
    ("ER-PROGN" , "ACL2-AGP" , "ACL2"),
    ("ER-PROGN-FN" , "ACL2-AGP" , "ACL2"),
    ("ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("ETYPECASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("EVAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("EVAL-WHEN" , "ACL2-AGP" , "COMMON-LISP"),
    ("EVENP" , "ACL2-AGP" , "COMMON-LISP"),
    ("EVENS" , "ACL2-AGP" , "ACL2"),
    ("EVENT" , "ACL2-AGP" , "ACL2"),
    ("EVERY" , "ACL2-AGP" , "COMMON-LISP"),
    ("EXECUTABLE-COUNTERPART-THEORY" , "ACL2-AGP" , "ACL2"),
    ("EXP" , "ACL2-AGP" , "COMMON-LISP"),
    ("EXPLODE-ATOM" , "ACL2-AGP" , "ACL2"),
    ("EXPLODE-NONNEGATIVE-INTEGER" , "ACL2-AGP" , "ACL2"),
    ("EXPORT" , "ACL2-AGP" , "COMMON-LISP"),
    ("EXPT" , "ACL2-AGP" , "COMMON-LISP"),
    ("EXPT-TYPE-PRESCRIPTION-NON-ZERO-BASE" , "ACL2-AGP" , "ACL2"),
    ("EXTEND-32-BIT-INTEGER-STACK" , "ACL2-AGP" , "ACL2"),
    ("EXTEND-T-STACK" , "ACL2-AGP" , "ACL2"),
    ("EXTEND-WORLD" , "ACL2-AGP" , "ACL2"),
    ("EXTENDED-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("EXTRA-INFO" , "ACL2-AGP" , "ACL2"),
    ("FAST-ALIST-FREE" , "ACL2-AGP" , "ACL2"),
    ("FAST-ALIST-LEN" , "ACL2-AGP" , "ACL2"),
    ("FAST-ALIST-SUMMARY" , "ACL2-AGP" , "ACL2"),
    ("FBOUNDP" , "ACL2-AGP" , "COMMON-LISP"),
    ("FCEILING" , "ACL2-AGP" , "COMMON-LISP"),
    ("FDEFINITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("FERTILIZE" , "ACL2-AGP" , "ACL2"),
    ("FFLOOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("FGETPROP" , "ACL2-AGP" , "ACL2"),
    ("FIFTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-AUTHOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-CLOCK" , "ACL2-AGP" , "ACL2"),
    ("FILE-CLOCK-P" , "ACL2-AGP" , "ACL2"),
    ("FILE-CLOCK-P-FORWARD-TO-INTEGERP" , "ACL2-AGP" , "ACL2"),
    ("FILE-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-ERROR-PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-LENGTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-NAMESTRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-POSITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-STRING-LENGTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILE-WRITE-DATE" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILL" , "ACL2-AGP" , "COMMON-LISP"),
    ("FILL-POINTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-ALL-SYMBOLS" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-RESTART" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIND-SYMBOL" , "ACL2-AGP" , "COMMON-LISP"),
    ("FINISH-OUTPUT" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIRST" , "ACL2-AGP" , "COMMON-LISP"),
    ("FIRST-N-AC" , "ACL2-AGP" , "ACL2"),
    ("FIX" , "ACL2-AGP" , "ACL2"),
    ("FIX-TRUE-LIST" , "ACL2-AGP" , "ACL2"),
    ("FIXNUM" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLET" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOAT-DIGITS" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOAT-PRECISION" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOAT-RADIX" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOAT-SIGN" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOATING-POINT-INEXACT" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOATING-POINT-INVALID-OPERATION" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOATING-POINT-OVERFLOW" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOATING-POINT-UNDERFLOW" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOATP" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLOOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("FLUSH-HONS-GET-HASH-TABLE-LINK" , "ACL2-AGP" , "ACL2"),
    ("FMAKUNBOUND" , "ACL2-AGP" , "COMMON-LISP"),
    ("FMS" , "ACL2-AGP" , "ACL2"),
    ("FMT" , "ACL2-AGP" , "ACL2"),
    ("FMT-TO-COMMENT-WINDOW" , "ACL2-AGP" , "ACL2"),
    ("FMT1" , "ACL2-AGP" , "ACL2"),
    ("FORCE" , "ACL2-AGP" , "ACL2"),
    ("FORCE-OUTPUT" , "ACL2-AGP" , "COMMON-LISP"),
    ("FORMAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("FORMATTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("FOURTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("FRESH-LINE" , "ACL2-AGP" , "COMMON-LISP"),
    ("FROUND" , "ACL2-AGP" , "COMMON-LISP"),
    ("FTRUNCATE" , "ACL2-AGP" , "COMMON-LISP"),
    ("FTYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("FUNCALL" , "ACL2-AGP" , "COMMON-LISP"),
    ("FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("FUNCTION-KEYWORDS" , "ACL2-AGP" , "COMMON-LISP"),
    ("FUNCTION-LAMBDA-EXPRESSION" , "ACL2-AGP" , "COMMON-LISP"),
    ("FUNCTION-SYMBOLP" , "ACL2-AGP" , "ACL2"),
    ("FUNCTION-THEORY" , "ACL2-AGP" , "ACL2"),
    ("FUNCTIONP" , "ACL2-AGP" , "COMMON-LISP"),
    ("GCD" , "ACL2-AGP" , "COMMON-LISP"),
    ("GENERALIZE" , "ACL2-AGP" , "ACL2"),
    ("GENERIC-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("GENSYM" , "ACL2-AGP" , "COMMON-LISP"),
    ("GENTEMP" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-DECODED-TIME" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-DISPATCH-MACRO-CHARACTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-GLOBAL" , "ACL2-AGP" , "ACL2"),
    ("GET-INTERNAL-REAL-TIME" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-INTERNAL-RUN-TIME" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-MACRO-CHARACTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-OUTPUT-STREAM-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-PROPERTIES" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-SETF-EXPANSION" , "ACL2-AGP" , "COMMON-LISP"),
    ("GET-SLOW-ALIST-ACTION" , "ACL2-AGP" , "ACL2"),
    ("GET-TIMER" , "ACL2-AGP" , "ACL2"),
    ("GET-UNIVERSAL-TIME" , "ACL2-AGP" , "COMMON-LISP"),
    ("GETF" , "ACL2-AGP" , "COMMON-LISP"),
    ("GETHASH" , "ACL2-AGP" , "COMMON-LISP"),
    ("GETPROP-DEFAULT" , "ACL2-AGP" , "ACL2"),
    ("GETPROPS" , "ACL2-AGP" , "ACL2"),
    ("GETPROPS1" , "ACL2-AGP" , "ACL2"),
    ("GLOBAL-TABLE" , "ACL2-AGP" , "ACL2"),
    ("GLOBAL-TABLE-CARS" , "ACL2-AGP" , "ACL2"),
    ("GLOBAL-TABLE-CARS1" , "ACL2-AGP" , "ACL2"),
    ("GLOBAL-VAL" , "ACL2-AGP" , "ACL2"),
    ("GO" , "ACL2-AGP" , "COMMON-LISP"),
    ("GOOD-BYE" , "ACL2-AGP" , "ACL2"),
    ("GRANULARITY" , "ACL2-AGP" , "ACL2"),
    ("GRAPHIC-CHAR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("GROUND-ZERO" , "ACL2-AGP" , "ACL2"),
    ("HANDLER-BIND" , "ACL2-AGP" , "COMMON-LISP"),
    ("HANDLER-CASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("HARD-ERROR" , "ACL2-AGP" , "ACL2"),
    ("HAS-PROPSP" , "ACL2-AGP" , "ACL2"),
    ("HAS-PROPSP1" , "ACL2-AGP" , "ACL2"),
    ("HASH-TABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("HASH-TABLE-COUNT" , "ACL2-AGP" , "COMMON-LISP"),
    ("HASH-TABLE-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-SIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-THRESHOLD" , "ACL2-AGP" , "COMMON-LISP"),
    ("HASH-TABLE-SIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("HASH-TABLE-TEST" , "ACL2-AGP" , "COMMON-LISP"),
    ("HEADER" , "ACL2-AGP" , "ACL2"),
    ("HELP" , "ACL2-AGP" , "ACL2"),
    ("HIDE" , "ACL2-AGP" , "ACL2"),
    ("HONS" , "ACL2-AGP" , "ACL2"),
    ("HONS-ACONS" , "ACL2-AGP" , "ACL2"),
    ("HONS-ACONS!" , "ACL2-AGP" , "ACL2"),
    ("HONS-CLEAR" , "ACL2-AGP" , "ACL2"),
    ("HONS-COPY" , "ACL2-AGP" , "ACL2"),
    ("HONS-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("HONS-EQUAL-LITE" , "ACL2-AGP" , "ACL2"),
    ("HONS-GET" , "ACL2-AGP" , "ACL2"),
    ("HONS-RESIZE" , "ACL2-AGP" , "ACL2"),
    ("HONS-RESIZE-FN" , "ACL2-AGP" , "ACL2"),
    ("HONS-SHRINK-ALIST" , "ACL2-AGP" , "ACL2"),
    ("HONS-SHRINK-ALIST!" , "ACL2-AGP" , "ACL2"),
    ("HONS-SUMMARY" , "ACL2-AGP" , "ACL2"),
    ("HONS-WASH" , "ACL2-AGP" , "ACL2"),
    ("HOST-NAMESTRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("I-AM-HERE" , "ACL2-AGP" , "ACL2"),
    ("ID" , "ACL2-AGP" , "ACL2"),
    ("IDATES" , "ACL2-AGP" , "ACL2"),
    ("IDENTITY" , "ACL2-AGP" , "COMMON-LISP"),
    ("IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("IF*" , "ACL2-AGP" , "ACL2"),
    ("IFF" , "ACL2-AGP" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-1" , "ACL2-AGP" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-2" , "ACL2-AGP" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-NOT" , "ACL2-AGP" , "ACL2"),
    ("IFF-IS-AN-EQUIVALENCE" , "ACL2-AGP" , "ACL2"),
    ("IFIX" , "ACL2-AGP" , "ACL2"),
    ("IGNORABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("IGNORE" , "ACL2-AGP" , "COMMON-LISP"),
    ("IGNORE-ERRORS" , "ACL2-AGP" , "COMMON-LISP"),
    ("ILLEGAL" , "ACL2-AGP" , "ACL2"),
    ("IMAGPART" , "ACL2-AGP" , "COMMON-LISP"),
    ("IMAGPART-COMPLEX" , "ACL2-AGP" , "ACL2"),
    ("IMMEDIATE-FORCE-MODEP" , "ACL2-AGP" , "ACL2"),
    ("IMPLIES" , "ACL2-AGP" , "ACL2"),
    ("IMPORT" , "ACL2-AGP" , "COMMON-LISP"),
    ("IMPROPER-CONSP" , "ACL2-AGP" , "ACL2"),
    ("IN-ARITHMETIC-THEORY" , "ACL2-AGP" , "ACL2"),
    ("IN-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("IN-THEORY" , "ACL2-AGP" , "ACL2"),
    ("INCF" , "ACL2-AGP" , "COMMON-LISP"),
    ("INCLUDE-BOOK" , "ACL2-AGP" , "ACL2"),
    ("INCOMPATIBLE" , "ACL2-AGP" , "ACL2"),
    ("INCREMENT-TIMER" , "ACL2-AGP" , "ACL2"),
    ("INDUCT" , "ACL2-AGP" , "ACL2"),
    ("INITIALIZE-INSTANCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("INLINE" , "ACL2-AGP" , "COMMON-LISP"),
    ("INPUT-STREAM-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("INSPECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("INT=" , "ACL2-AGP" , "ACL2"),
    ("INTEGER" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTEGER-0" , "ACL2-AGP" , "ACL2"),
    ("INTEGER-1" , "ACL2-AGP" , "ACL2"),
    ("INTEGER-ABS" , "ACL2-AGP" , "ACL2"),
    ("INTEGER-DECODE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTEGER-IMPLIES-RATIONAL" , "ACL2-AGP" , "ACL2"),
    ("INTEGER-LENGTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTEGER-LISTP" , "ACL2-AGP" , "ACL2"),
    ("INTEGER-LISTP-FORWARD-TO-RATIONAL-LISTP" , "ACL2-AGP" , "ACL2"),
    ("INTEGER-STEP" , "ACL2-AGP" , "ACL2"),
    ("INTEGERP" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTERACTIVE-STREAM-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTERN" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTERN$" , "ACL2-AGP" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-AGP" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL-SYMBOL-NAME" , "ACL2-AGP" , "ACL2"),
    ("INTERNAL-TIME-UNITS-PER-SECOND" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTERSECTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("INTERSECTION-EQ" , "ACL2-AGP" , "ACL2"),
    ("INTERSECTION-THEORIES" , "ACL2-AGP" , "ACL2"),
    ("INTERSECTP-EQ" , "ACL2-AGP" , "ACL2"),
    ("INTERSECTP-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("INVALID-METHOD-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("INVERSE-OF-*" , "ACL2-AGP" , "ACL2"),
    ("INVERSE-OF-+" , "ACL2-AGP" , "ACL2"),
    ("INVISIBLE-FNS-TABLE" , "ACL2-AGP" , "ACL2"),
    ("INVOKE-DEBUGGER" , "ACL2-AGP" , "COMMON-LISP"),
    ("INVOKE-RESTART" , "ACL2-AGP" , "COMMON-LISP"),
    ("INVOKE-RESTART-INTERACTIVELY" , "ACL2-AGP" , "COMMON-LISP"),
    ("ISQRT" , "ACL2-AGP" , "COMMON-LISP"),
    ("KEYWORD" , "ACL2-AGP" , "COMMON-LISP"),
    ("KEYWORD-PACKAGE" , "ACL2-AGP" , "ACL2"),
    ("KEYWORD-VALUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-ASSOC-KEYWORD" , "ACL2-AGP" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("KEYWORDP" , "ACL2-AGP" , "COMMON-LISP"),
    ("KEYWORDP-FORWARD-TO-SYMBOLP" , "ACL2-AGP" , "ACL2"),
    ("KNOWN-PACKAGE-ALIST" , "ACL2-AGP" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-AGP" , "ACL2"),
    ("LABELS" , "ACL2-AGP" , "COMMON-LISP"),
    ("LAMBDA" , "ACL2-AGP" , "COMMON-LISP"),
    ("LAMBDA-LIST-KEYWORDS" , "ACL2-AGP" , "COMMON-LISP"),
    ("LAMBDA-PARAMETERS-LIMIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LAST" , "ACL2-AGP" , "COMMON-LISP"),
    ("LCM" , "ACL2-AGP" , "COMMON-LISP"),
    ("LD" , "ACL2-AGP" , "ACL2"),
    ("LD-ERROR-ACTION" , "ACL2-AGP" , "ACL2"),
    ("LD-ERROR-TRIPLES" , "ACL2-AGP" , "ACL2"),
    ("LD-KEYWORD-ALIASES" , "ACL2-AGP" , "ACL2"),
    ("LD-POST-EVAL-PRINT" , "ACL2-AGP" , "ACL2"),
    ("LD-PRE-EVAL-FILTER" , "ACL2-AGP" , "ACL2"),
    ("LD-PRE-EVAL-PRINT" , "ACL2-AGP" , "ACL2"),
    ("LD-PROMPT" , "ACL2-AGP" , "ACL2"),
    ("LD-QUERY-CONTROL-ALIST" , "ACL2-AGP" , "ACL2"),
    ("LD-REDEFINITION-ACTION" , "ACL2-AGP" , "ACL2"),
    ("LD-SKIP-PROOFSP" , "ACL2-AGP" , "ACL2"),
    ("LD-VERBOSE" , "ACL2-AGP" , "ACL2"),
    ("LDB" , "ACL2-AGP" , "COMMON-LISP"),
    ("LDB-TEST" , "ACL2-AGP" , "COMMON-LISP"),
    ("LDIFF" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-LONG-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-LONG-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SHORT-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SINGLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-DOUBLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-LONG-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-LONG-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SHORT-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SINGLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LEGAL-CASE-CLAUSESP" , "ACL2-AGP" , "ACL2"),
    ("LEN" , "ACL2-AGP" , "ACL2"),
    ("LEN-UPDATE-NTH" , "ACL2-AGP" , "ACL2"),
    ("LENGTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("LET" , "ACL2-AGP" , "COMMON-LISP"),
    ("LET*" , "ACL2-AGP" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-VERSION" , "ACL2-AGP" , "COMMON-LISP"),
    ("LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("LIST*" , "ACL2-AGP" , "COMMON-LISP"),
    ("LIST*-MACRO" , "ACL2-AGP" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES" , "ACL2-AGP" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-AGP" , "ACL2"),
    ("LIST-ALL-PACKAGES" , "ACL2-AGP" , "COMMON-LISP"),
    ("LIST-LENGTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("LIST-MACRO" , "ACL2-AGP" , "ACL2"),
    ("LISTEN" , "ACL2-AGP" , "COMMON-LISP"),
    ("LISTP" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOAD" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOAD-LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOAD-TIME-VALUE" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOCAL" , "ACL2-AGP" , "ACL2"),
    ("LOCALLY" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOG" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGAND" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGANDC1" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGANDC2" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGBITP" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGCOUNT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGEQV" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGIC" , "ACL2-AGP" , "ACL2"),
    ("LOGICAL-PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGIOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGNAND" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGNOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGNOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGORC1" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGORC2" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGTEST" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOGXOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("LONG-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("LONG-FLOAT-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("LONG-FLOAT-NEGATIVE-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("LONG-SITE-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOOP" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOOP-FINISH" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOWER-CASE-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("LOWER-CASE-P-CHAR-DOWNCASE" , "ACL2-AGP" , "ACL2"),
    ("LOWER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-AGP" , "ACL2"),
    ("LOWEST-TERMS" , "ACL2-AGP" , "ACL2"),
    ("LP" , "ACL2-AGP" , "ACL2"),
    ("MACHINE-INSTANCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MACHINE-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MACHINE-VERSION" , "ACL2-AGP" , "COMMON-LISP"),
    ("MACRO-ALIASES" , "ACL2-AGP" , "ACL2"),
    ("MACRO-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("MACROEXPAND" , "ACL2-AGP" , "COMMON-LISP"),
    ("MACROEXPAND-1" , "ACL2-AGP" , "COMMON-LISP"),
    ("MACROLET" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAIN-TIMER" , "ACL2-AGP" , "ACL2"),
    ("MAIN-TIMER-TYPE-PRESCRIPTION" , "ACL2-AGP" , "ACL2"),
    ("MAKE-ARRAY" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-BROADCAST-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-CHARACTER-LIST" , "ACL2-AGP" , "ACL2"),
    ("MAKE-CHARACTER-LIST-MAKE-CHARACTER-LIST" , "ACL2-AGP" , "ACL2"),
    ("MAKE-CONCATENATED-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-CONDITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-DISPATCH-MACRO-CHARACTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-ECHO-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-EVENT" , "ACL2-AGP" , "ACL2"),
    ("MAKE-FMT-BINDINGS" , "ACL2-AGP" , "ACL2"),
    ("MAKE-HASH-TABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-INPUT-CHANNEL" , "ACL2-AGP" , "ACL2"),
    ("MAKE-INSTANCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-INSTANCES-OBSOLETE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-LIST-AC" , "ACL2-AGP" , "ACL2"),
    ("MAKE-LOAD-FORM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-LOAD-FORM-SAVING-SLOTS" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-MV-NTHS" , "ACL2-AGP" , "ACL2"),
    ("MAKE-ORD" , "ACL2-AGP" , "ACL2"),
    ("MAKE-OUTPUT-CHANNEL" , "ACL2-AGP" , "ACL2"),
    ("MAKE-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-RANDOM-STATE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-SEQUENCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-STRING-INPUT-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-STRING-OUTPUT-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-SYMBOL" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-SYNONYM-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-TWO-WAY-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKE-VAR-LST" , "ACL2-AGP" , "ACL2"),
    ("MAKE-VAR-LST1" , "ACL2-AGP" , "ACL2"),
    ("MAKUNBOUND" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAKUNBOUND-GLOBAL" , "ACL2-AGP" , "ACL2"),
    ("MAP" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAP-INTO" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAPC" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAPCAN" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAPCAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAPCON" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAPHASH" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAPL" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAPLIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("MASK-FIELD" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAX" , "ACL2-AGP" , "COMMON-LISP"),
    ("MAXIMUM-LENGTH" , "ACL2-AGP" , "ACL2"),
    ("MAY-NEED-SLASHES" , "ACL2-AGP" , "ACL2"),
    ("MBE" , "ACL2-AGP" , "ACL2"),
    ("MBT" , "ACL2-AGP" , "ACL2"),
    ("MEMBER" , "ACL2-AGP" , "COMMON-LISP"),
    ("MEMBER-EQ" , "ACL2-AGP" , "ACL2"),
    ("MEMBER-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("MEMBER-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("MEMBER-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MEMBER-SYMBOL-NAME" , "ACL2-AGP" , "ACL2"),
    ("MEMOIZE" , "ACL2-AGP" , "ACL2"),
    ("MEMOIZE-LET" , "ACL2-AGP" , "ACL2"),
    ("MEMOIZE-OFF" , "ACL2-AGP" , "ACL2"),
    ("MEMOIZE-ON" , "ACL2-AGP" , "ACL2"),
    ("MERGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("MERGE-PATHNAMES" , "ACL2-AGP" , "COMMON-LISP"),
    ("METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("METHOD-COMBINATION" , "ACL2-AGP" , "COMMON-LISP"),
    ("METHOD-COMBINATION-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("METHOD-QUALIFIERS" , "ACL2-AGP" , "COMMON-LISP"),
    ("MFC" , "ACL2-AGP" , "ACL2"),
    ("MIN" , "ACL2-AGP" , "COMMON-LISP"),
    ("MINIMAL-THEORY" , "ACL2-AGP" , "ACL2"),
    ("MINUSP" , "ACL2-AGP" , "COMMON-LISP"),
    ("MISMATCH" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("MONITOR" , "ACL2-AGP" , "ACL2"),
    ("MONITORED-RUNES" , "ACL2-AGP" , "ACL2"),
    ("MORE" , "ACL2-AGP" , "ACL2"),
    ("MORE!" , "ACL2-AGP" , "ACL2"),
    ("MORE-DOC" , "ACL2-AGP" , "ACL2"),
    ("MOST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-NEGATIVE-FIXNUM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-NEGATIVE-LONG-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SHORT-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SINGLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-POSITIVE-DOUBLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-POSITIVE-FIXNUM" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-POSITIVE-LONG-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-POSITIVE-SHORT-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MOST-POSITIVE-SINGLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MUFFLE-WARNING" , "ACL2-AGP" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-BIND" , "ACL2-AGP" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-CALL" , "ACL2-AGP" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-PROG1" , "ACL2-AGP" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-SETQ" , "ACL2-AGP" , "COMMON-LISP"),
    ("MULTIPLE-VALUES-LIMIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("MUTUAL-RECURSION" , "ACL2-AGP" , "ACL2"),
    ("MUTUAL-RECURSION-GUARDP" , "ACL2-AGP" , "ACL2"),
    ("MV" , "ACL2-AGP" , "ACL2"),
    ("MV-LET" , "ACL2-AGP" , "ACL2"),
    ("MV-LIST" , "ACL2-AGP" , "ACL2"),
    ("MV-NTH" , "ACL2-AGP" , "ACL2"),
    ("NAME-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("NAMESTRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("NATP" , "ACL2-AGP" , "ACL2"),
    ("NBUTLAST" , "ACL2-AGP" , "COMMON-LISP"),
    ("NCONC" , "ACL2-AGP" , "COMMON-LISP"),
    ("NEEDS-SLASHES" , "ACL2-AGP" , "ACL2"),
    ("NEWLINE" , "ACL2-AGP" , "ACL2"),
    ("NEXT-METHOD-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("NFIX" , "ACL2-AGP" , "ACL2"),
    ("NIL" , "ACL2-AGP" , "COMMON-LISP"),
    ("NIL-IS-NOT-CIRCULAR" , "ACL2-AGP" , "ACL2"),
    ("NINTERSECTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("NINTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("NO-APPLICABLE-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("NO-DUPLICATESP" , "ACL2-AGP" , "ACL2"),
    ("NO-DUPLICATESP-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("NO-NEXT-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("NONNEGATIVE-INTEGER-QUOTIENT" , "ACL2-AGP" , "ACL2"),
    ("NONNEGATIVE-PRODUCT" , "ACL2-AGP" , "ACL2"),
    ("NONZERO-IMAGPART" , "ACL2-AGP" , "ACL2"),
    ("NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("NOTANY" , "ACL2-AGP" , "COMMON-LISP"),
    ("NOTEVERY" , "ACL2-AGP" , "COMMON-LISP"),
    ("NOTINLINE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NQTHM-TO-ACL2" , "ACL2-AGP" , "ACL2"),
    ("NRECONC" , "ACL2-AGP" , "COMMON-LISP"),
    ("NREVERSE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSET-DIFFERENCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSET-EXCLUSIVE-OR" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSTRING-CAPITALIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSTRING-DOWNCASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSTRING-UPCASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSUBLIS" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSUBST" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSUBST-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSUBST-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSUBSTITUTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("NTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("NTH-0-CONS" , "ACL2-AGP" , "ACL2"),
    ("NTH-0-READ-RUN-TIME-TYPE-PRESCRIPTION" , "ACL2-AGP" , "ACL2"),
    ("NTH-ADD1" , "ACL2-AGP" , "ACL2"),
    ("NTH-ALIASES" , "ACL2-AGP" , "ACL2"),
    ("NTH-UPDATE-NTH" , "ACL2-AGP" , "ACL2"),
    ("NTH-VALUE" , "ACL2-AGP" , "COMMON-LISP"),
    ("NTHCDR" , "ACL2-AGP" , "COMMON-LISP"),
    ("NULL" , "ACL2-AGP" , "COMMON-LISP"),
    ("NUMBER" , "ACL2-AGP" , "COMMON-LISP"),
    ("NUMBER-SUBTREES" , "ACL2-AGP" , "ACL2"),
    ("NUMBERP" , "ACL2-AGP" , "COMMON-LISP"),
    ("NUMERATOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("NUNION" , "ACL2-AGP" , "COMMON-LISP"),
    ("O-FINP" , "ACL2-AGP" , "ACL2"),
    ("O-FIRST-COEFF" , "ACL2-AGP" , "ACL2"),
    ("O-FIRST-EXPT" , "ACL2-AGP" , "ACL2"),
    ("O-INFP" , "ACL2-AGP" , "ACL2"),
    ("O-P" , "ACL2-AGP" , "ACL2"),
    ("O-RST" , "ACL2-AGP" , "ACL2"),
    ("O<" , "ACL2-AGP" , "ACL2"),
    ("O<=" , "ACL2-AGP" , "ACL2"),
    ("O>" , "ACL2-AGP" , "ACL2"),
    ("O>=" , "ACL2-AGP" , "ACL2"),
    ("OBSERVATION" , "ACL2-AGP" , "ACL2"),
    ("ODDP" , "ACL2-AGP" , "COMMON-LISP"),
    ("ODDS" , "ACL2-AGP" , "ACL2"),
    ("OK-IF" , "ACL2-AGP" , "ACL2"),
    ("OOPS" , "ACL2-AGP" , "ACL2"),
    ("OPEN" , "ACL2-AGP" , "COMMON-LISP"),
    ("OPEN-CHANNEL-LISTP" , "ACL2-AGP" , "ACL2"),
    ("OPEN-CHANNEL1" , "ACL2-AGP" , "ACL2"),
    ("OPEN-CHANNEL1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-AGP" ,
"ACL2"),
    ("OPEN-CHANNELS-P" , "ACL2-AGP" , "ACL2"),
    ("OPEN-CHANNELS-P-FORWARD" , "ACL2-AGP" , "ACL2"),
    ("OPEN-INPUT-CHANNEL" , "ACL2-AGP" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P" , "ACL2-AGP" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P1" , "ACL2-AGP" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P" , "ACL2-AGP" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P1" , "ACL2-AGP" , "ACL2"),
    ("OPEN-INPUT-CHANNELS" , "ACL2-AGP" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL" , "ACL2-AGP" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL!" , "ACL2-AGP" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P" , "ACL2-AGP" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P1" , "ACL2-AGP" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P" , "ACL2-AGP" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P1" , "ACL2-AGP" , "ACL2"),
    ("OPEN-OUTPUT-CHANNELS" , "ACL2-AGP" , "ACL2"),
    ("OPEN-STREAM-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("OPEN-TRACE-FILE" , "ACL2-AGP" , "ACL2"),
    ("OPTIMIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("OR" , "ACL2-AGP" , "COMMON-LISP"),
    ("OR-MACRO" , "ACL2-AGP" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR" , "ACL2-AGP" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR-FORWARD" , "ACL2-AGP" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-FORWARD-TO-SYMBOL-ALISTP" , "ACL2-AGP"
, "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-GETPROPS" , "ACL2-AGP" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-REMOVE-FIRST-PAIR" , "ACL2-AGP" , "ACL2"),
    ("OTHERWISE" , "ACL2-AGP" , "COMMON-LISP"),
    ("OUR-DIGIT-CHAR-P" , "ACL2-AGP" , "ACL2"),
    ("OUTPUT-STREAM-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE-ERROR-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE-NICKNAMES" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE-SHADOWING-SYMBOLS" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE-USE-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGE-USED-BY-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("PACKAGEP" , "ACL2-AGP" , "COMMON-LISP"),
    ("PAIRLIS" , "ACL2-AGP" , "COMMON-LISP"),
    ("PAIRLIS$" , "ACL2-AGP" , "ACL2"),
    ("PAIRLIS2" , "ACL2-AGP" , "ACL2"),
    ("PAND" , "ACL2-AGP" , "ACL2"),
    ("PARGS" , "ACL2-AGP" , "ACL2"),
    ("PARSE-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("PARSE-INTEGER" , "ACL2-AGP" , "COMMON-LISP"),
    ("PARSE-NAMESTRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME-DEVICE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME-DIRECTORY" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME-HOST" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME-MATCH-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAME-VERSION" , "ACL2-AGP" , "COMMON-LISP"),
    ("PATHNAMEP" , "ACL2-AGP" , "COMMON-LISP"),
    ("PBT" , "ACL2-AGP" , "ACL2"),
    ("PC" , "ACL2-AGP" , "ACL2"),
    ("PCB" , "ACL2-AGP" , "ACL2"),
    ("PCB!" , "ACL2-AGP" , "ACL2"),
    ("PCS" , "ACL2-AGP" , "ACL2"),
    ("PE" , "ACL2-AGP" , "ACL2"),
    ("PEEK-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("PEEK-CHAR$" , "ACL2-AGP" , "ACL2"),
    ("PF" , "ACL2-AGP" , "ACL2"),
    ("PHASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PI" , "ACL2-AGP" , "COMMON-LISP"),
    ("PL" , "ACL2-AGP" , "ACL2"),
    ("PLET" , "ACL2-AGP" , "ACL2"),
    ("PLIST-WORLDP" , "ACL2-AGP" , "ACL2"),
    ("PLIST-WORLDP-FORWARD-TO-ASSOC-EQ-EQUAL-ALISTP" , "ACL2-AGP" ,
"ACL2"),
    ("PLUSP" , "ACL2-AGP" , "COMMON-LISP"),
    ("POP" , "ACL2-AGP" , "COMMON-LISP"),
    ("POP-TIMER" , "ACL2-AGP" , "ACL2"),
    ("POR" , "ACL2-AGP" , "ACL2"),
    ("POSITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("POSITION-AC" , "ACL2-AGP" , "ACL2"),
    ("POSITION-EQ" , "ACL2-AGP" , "ACL2"),
    ("POSITION-EQ-AC" , "ACL2-AGP" , "ACL2"),
    ("POSITION-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("POSITION-EQUAL-AC" , "ACL2-AGP" , "ACL2"),
    ("POSITION-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("POSITION-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("POSITIVE" , "ACL2-AGP" , "ACL2"),
    ("POSP" , "ACL2-AGP" , "ACL2"),
    ("POWER-EVAL" , "ACL2-AGP" , "ACL2"),
    ("PPRINT" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-DISPATCH" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-EXIT-IF-LIST-EXHAUSTED" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-FILL" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-INDENT" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-LINEAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-LOGICAL-BLOCK" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-NEWLINE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-POP" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-TAB" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPRINT-TABULAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("PPROGN" , "ACL2-AGP" , "ACL2"),
    ("PR" , "ACL2-AGP" , "ACL2"),
    ("PR!" , "ACL2-AGP" , "ACL2"),
    ("PREPROCESS" , "ACL2-AGP" , "ACL2"),
    ("PRIN1" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRIN1$" , "ACL2-AGP" , "ACL2"),
    ("PRIN1-TO-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRIN1-WITH-SLASHES" , "ACL2-AGP" , "ACL2"),
    ("PRIN1-WITH-SLASHES1" , "ACL2-AGP" , "ACL2"),
    ("PRINC" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRINC$" , "ACL2-AGP" , "ACL2"),
    ("PRINC-TO-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRINT" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRINT-GV" , "ACL2-AGP" , "ACL2"),
    ("PRINT-NOT-READABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRINT-NOT-READABLE-OBJECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRINT-OBJECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("PRINT-OBJECT$" , "ACL2-AGP" , "ACL2"),
    ("PRINT-RATIONAL-AS-DECIMAL" , "ACL2-AGP" , "ACL2"),
    ("PRINT-TIMER" , "ACL2-AGP" , "ACL2"),
    ("PRINT-UNREADABLE-OBJECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROBE-FILE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROCLAIM" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROG" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROG*" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROG1" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROG2" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROG2$" , "ACL2-AGP" , "ACL2"),
    ("PROGN" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROGRAM" , "ACL2-AGP" , "ACL2"),
    ("PROGRAM-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROGV" , "ACL2-AGP" , "COMMON-LISP"),
    ("PROOF-TREE" , "ACL2-AGP" , "ACL2"),
    ("PROOFS-CO" , "ACL2-AGP" , "ACL2"),
    ("PROPER-CONSP" , "ACL2-AGP" , "ACL2"),
    ("PROPS" , "ACL2-AGP" , "ACL2"),
    ("PROVE" , "ACL2-AGP" , "ACL2"),
    ("PROVIDE" , "ACL2-AGP" , "COMMON-LISP"),
    ("PSETF" , "ACL2-AGP" , "COMMON-LISP"),
    ("PSETQ" , "ACL2-AGP" , "COMMON-LISP"),
    ("PSEUDO-TERM-LISTP" , "ACL2-AGP" , "ACL2"),
    ("PSEUDO-TERM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("PSEUDO-TERMP" , "ACL2-AGP" , "ACL2"),
    ("PSTACK" , "ACL2-AGP" , "ACL2"),
    ("PUFF" , "ACL2-AGP" , "ACL2"),
    ("PUFF*" , "ACL2-AGP" , "ACL2"),
    ("PUSH" , "ACL2-AGP" , "COMMON-LISP"),
    ("PUSH-TIMER" , "ACL2-AGP" , "ACL2"),
    ("PUSH-UNTOUCHABLE" , "ACL2-AGP" , "ACL2"),
    ("PUSHNEW" , "ACL2-AGP" , "COMMON-LISP"),
    ("PUT-ASSOC-EQ" , "ACL2-AGP" , "ACL2"),
    ("PUT-ASSOC-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("PUT-GLOBAL" , "ACL2-AGP" , "ACL2"),
    ("PUTPROP" , "ACL2-AGP" , "ACL2"),
    ("QUOTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("QUOTEP" , "ACL2-AGP" , "ACL2"),
    ("R-EQLABLE-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("RANDOM" , "ACL2-AGP" , "COMMON-LISP"),
    ("RANDOM-STATE" , "ACL2-AGP" , "COMMON-LISP"),
    ("RANDOM-STATE-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("RASSOC" , "ACL2-AGP" , "COMMON-LISP"),
    ("RASSOC-EQ" , "ACL2-AGP" , "ACL2"),
    ("RASSOC-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("RASSOC-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("RASSOC-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("RATIO" , "ACL2-AGP" , "COMMON-LISP"),
    ("RATIONAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("RATIONAL-IMPLIES1" , "ACL2-AGP" , "ACL2"),
    ("RATIONAL-IMPLIES2" , "ACL2-AGP" , "ACL2"),
    ("RATIONAL-LISTP" , "ACL2-AGP" , "ACL2"),
    ("RATIONAL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("RATIONALIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("RATIONALP" , "ACL2-AGP" , "COMMON-LISP"),
    ("RATIONALP-*" , "ACL2-AGP" , "ACL2"),
    ("RATIONALP-+" , "ACL2-AGP" , "ACL2"),
    ("RATIONALP-EXPT-TYPE-PRESCRIPTION" , "ACL2-AGP" , "ACL2"),
    ("RATIONALP-IMPLIES-ACL2-NUMBERP" , "ACL2-AGP" , "ACL2"),
    ("RATIONALP-UNARY--" , "ACL2-AGP" , "ACL2"),
    ("RATIONALP-UNARY-/" , "ACL2-AGP" , "ACL2"),
    ("READ" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-ACL2-ORACLE" , "ACL2-AGP" , "ACL2"),
    ("READ-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-AGP" , "ACL2"),
    ("READ-BYTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-BYTE$" , "ACL2-AGP" , "ACL2"),
    ("READ-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-CHAR$" , "ACL2-AGP" , "ACL2"),
    ("READ-CHAR-NO-HANG" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-DELIMITED-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-FILE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("READ-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-AGP" , "ACL2"),
    ("READ-FILE-LISTP1" , "ACL2-AGP" , "ACL2"),
    ("READ-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-AGP"
, "ACL2"),
    ("READ-FILES" , "ACL2-AGP" , "ACL2"),
    ("READ-FILES-P" , "ACL2-AGP" , "ACL2"),
    ("READ-FILES-P-FORWARD-TO-READ-FILE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("READ-FROM-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-IDATE" , "ACL2-AGP" , "ACL2"),
    ("READ-LINE" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-OBJECT" , "ACL2-AGP" , "ACL2"),
    ("READ-PRESERVING-WHITESPACE" , "ACL2-AGP" , "COMMON-LISP"),
    ("READ-RUN-TIME" , "ACL2-AGP" , "ACL2"),
    ("READ-RUN-TIME-PRESERVES-STATE-P1" , "ACL2-AGP" , "ACL2"),
    ("READ-SEQUENCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("READABLE-FILE" , "ACL2-AGP" , "ACL2"),
    ("READABLE-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-AGP" ,
"ACL2"),
    ("READABLE-FILES" , "ACL2-AGP" , "ACL2"),
    ("READABLE-FILES-LISTP" , "ACL2-AGP" , "ACL2"),
    ("READABLE-FILES-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-AGP" , "ACL2"),
    ("READABLE-FILES-P" , "ACL2-AGP" , "ACL2"),
    ("READABLE-FILES-P-FORWARD-TO-READABLE-FILES-LISTP" , "ACL2-AGP"
, "ACL2"),
    ("READER-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("READTABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("READTABLE-CASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("READTABLEP" , "ACL2-AGP" , "COMMON-LISP"),
    ("REAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("REAL/RATIONALP" , "ACL2-AGP" , "ACL2"),
    ("REALFIX" , "ACL2-AGP" , "ACL2"),
    ("REALP" , "ACL2-AGP" , "COMMON-LISP"),
    ("REALPART" , "ACL2-AGP" , "COMMON-LISP"),
    ("REALPART-COMPLEX" , "ACL2-AGP" , "ACL2"),
    ("REALPART-IMAGPART-ELIM" , "ACL2-AGP" , "ACL2"),
    ("REBUILD" , "ACL2-AGP" , "ACL2"),
    ("REDEF" , "ACL2-AGP" , "ACL2"),
    ("REDEF!" , "ACL2-AGP" , "ACL2"),
    ("REDEF+" , "ACL2-AGP" , "ACL2"),
    ("REDUCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("REINITIALIZE-INSTANCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("REM" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMF" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMHASH" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMOVE" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMOVE-BINOP" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS!" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-DUPLICATES" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMOVE-DUPLICATES-EQL" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-DUPLICATES-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-EQ" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-FIRST-PAIR" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMOVE-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMOVE-INVISIBLE-FNS" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-MACRO-ALIAS" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("REMOVE-NTH-ALIAS" , "ACL2-AGP" , "ACL2"),
    ("REMOVE-UNTOUCHABLE" , "ACL2-AGP" , "ACL2"),
    ("REMOVE1" , "ACL2-AGP" , "ACL2"),
    ("REMOVE1-EQ" , "ACL2-AGP" , "ACL2"),
    ("REMOVE1-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("REMPROP" , "ACL2-AGP" , "COMMON-LISP"),
    ("RENAME-FILE" , "ACL2-AGP" , "COMMON-LISP"),
    ("RENAME-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("REPLACE" , "ACL2-AGP" , "COMMON-LISP"),
    ("REQUIRE" , "ACL2-AGP" , "COMMON-LISP"),
    ("RESET-LD-SPECIALS" , "ACL2-AGP" , "ACL2"),
    ("RESET-PREHISTORY" , "ACL2-AGP" , "ACL2"),
    ("REST" , "ACL2-AGP" , "COMMON-LISP"),
    ("RESTART" , "ACL2-AGP" , "COMMON-LISP"),
    ("RESTART-BIND" , "ACL2-AGP" , "COMMON-LISP"),
    ("RESTART-CASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("RESTART-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("RETRACT-WORLD" , "ACL2-AGP" , "ACL2"),
    ("RETRIEVE" , "ACL2-AGP" , "ACL2"),
    ("RETURN" , "ACL2-AGP" , "COMMON-LISP"),
    ("RETURN-FROM" , "ACL2-AGP" , "COMMON-LISP"),
    ("REVAPPEND" , "ACL2-AGP" , "COMMON-LISP"),
    ("REVERSE" , "ACL2-AGP" , "COMMON-LISP"),
    ("RFIX" , "ACL2-AGP" , "ACL2"),
    ("ROOM" , "ACL2-AGP" , "COMMON-LISP"),
    ("ROTATEF" , "ACL2-AGP" , "COMMON-LISP"),
    ("ROUND" , "ACL2-AGP" , "COMMON-LISP"),
    ("ROW-MAJOR-AREF" , "ACL2-AGP" , "COMMON-LISP"),
    ("RPLACA" , "ACL2-AGP" , "COMMON-LISP"),
    ("RPLACD" , "ACL2-AGP" , "COMMON-LISP"),
    ("SAFETY" , "ACL2-AGP" , "COMMON-LISP"),
    ("SATISFIES" , "ACL2-AGP" , "COMMON-LISP"),
    ("SBIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SCALE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SCHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("SEARCH" , "ACL2-AGP" , "COMMON-LISP"),
    ("SECOND" , "ACL2-AGP" , "COMMON-LISP"),
    ("SEQUENCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SERIOUS-CONDITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET-BACKCHAIN-LIMIT" , "ACL2-AGP" , "ACL2"),
    ("SET-BODY" , "ACL2-AGP" , "ACL2"),
    ("SET-BOGUS-DEFUN-HINTS-OK" , "ACL2-AGP" , "ACL2"),
    ("SET-BOGUS-MUTUAL-RECURSION-OK" , "ACL2-AGP" , "ACL2"),
    ("SET-CASE-SPLIT-LIMITATIONS" , "ACL2-AGP" , "ACL2"),
    ("SET-CBD" , "ACL2-AGP" , "ACL2"),
    ("SET-CHECKPOINT-SUMMARY-LIMIT" , "ACL2-AGP" , "ACL2"),
    ("SET-COMPILE-FNS" , "ACL2-AGP" , "ACL2"),
    ("SET-DEBUGGER-ENABLE" , "ACL2-AGP" , "ACL2"),
    ("SET-DEFAULT-BACKCHAIN-LIMIT" , "ACL2-AGP" , "ACL2"),
    ("SET-DEFAULT-HINTS" , "ACL2-AGP" , "ACL2"),
    ("SET-DEFAULT-HINTS!" , "ACL2-AGP" , "ACL2"),
    ("SET-DIFFERENCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET-DIFFERENCE-EQ" , "ACL2-AGP" , "ACL2"),
    ("SET-DIFFERENCE-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("SET-DIFFERENCE-THEORIES" , "ACL2-AGP" , "ACL2"),
    ("SET-DISPATCH-MACRO-CHARACTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET-ENFORCE-REDUNDANCY" , "ACL2-AGP" , "ACL2"),
    ("SET-EQUALP-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("SET-EXCLUSIVE-OR" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET-GAG-MODE" , "ACL2-AGP" , "ACL2"),
    ("SET-GUARD-CHECKING" , "ACL2-AGP" , "ACL2"),
    ("SET-IGNORE-DOC-STRING-ERROR" , "ACL2-AGP" , "ACL2"),
    ("SET-IGNORE-OK" , "ACL2-AGP" , "ACL2"),
    ("SET-INHIBIT-OUTPUT-LST" , "ACL2-AGP" , "ACL2"),
    ("SET-INHIBIT-WARNINGS" , "ACL2-AGP" , "ACL2"),
    ("SET-INHIBITED-SUMMARY-TYPES" , "ACL2-AGP" , "ACL2"),
    ("SET-INVISIBLE-FNS-TABLE" , "ACL2-AGP" , "ACL2"),
    ("SET-IRRELEVANT-FORMALS-OK" , "ACL2-AGP" , "ACL2"),
    ("SET-LD-KEYWORD-ALIASES" , "ACL2-AGP" , "ACL2"),
    ("SET-LD-REDEFINITION-ACTION" , "ACL2-AGP" , "ACL2"),
    ("SET-LD-SKIP-PROOFS" , "ACL2-AGP" , "ACL2"),
    ("SET-LD-SKIP-PROOFSP" , "ACL2-AGP" , "ACL2"),
    ("SET-LET*-ABSTRACTION" , "ACL2-AGP" , "ACL2"),
    ("SET-LET*-ABSTRACTIONP" , "ACL2-AGP" , "ACL2"),
    ("SET-MACRO-CHARACTER" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET-MATCH-FREE-DEFAULT" , "ACL2-AGP" , "ACL2"),
    ("SET-MATCH-FREE-ERROR" , "ACL2-AGP" , "ACL2"),
    ("SET-MEASURE-FUNCTION" , "ACL2-AGP" , "ACL2"),
    ("SET-NON-LINEAR" , "ACL2-AGP" , "ACL2"),
    ("SET-NON-LINEARP" , "ACL2-AGP" , "ACL2"),
    ("SET-NU-REWRITER-MODE" , "ACL2-AGP" , "ACL2"),
    ("SET-PARALLEL-EVALUATION" , "ACL2-AGP" , "ACL2"),
    ("SET-PPRINT-DISPATCH" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET-PRINT-BASE" , "ACL2-AGP" , "ACL2"),
    ("SET-PRINT-CASE" , "ACL2-AGP" , "ACL2"),
    ("SET-PRINT-CLAUSE-IDS" , "ACL2-AGP" , "ACL2"),
    ("SET-RAW-MODE" , "ACL2-AGP" , "ACL2"),
    ("SET-RAW-MODE-ON!" , "ACL2-AGP" , "ACL2"),
    ("SET-RAW-PROOF-FORMAT" , "ACL2-AGP" , "ACL2"),
    ("SET-REWRITE-STACK-LIMIT" , "ACL2-AGP" , "ACL2"),
    ("SET-RULER-EXTENDERS" , "ACL2-AGP" , "ACL2"),
    ("SET-SAVED-OUTPUT" , "ACL2-AGP" , "ACL2"),
    ("SET-SLOW-ALIST-ACTION" , "ACL2-AGP" , "ACL2"),
    ("SET-STATE-OK" , "ACL2-AGP" , "ACL2"),
    ("SET-SYNTAX-FROM-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("SET-TAINTED-OK" , "ACL2-AGP" , "ACL2"),
    ("SET-TAINTED-OKP" , "ACL2-AGP" , "ACL2"),
    ("SET-TIMER" , "ACL2-AGP" , "ACL2"),
    ("SET-TRACE-EVISC-TUPLE" , "ACL2-AGP" , "ACL2"),
    ("SET-VERIFY-GUARDS-EAGERNESS" , "ACL2-AGP" , "ACL2"),
    ("SET-W" , "ACL2-AGP" , "ACL2"),
    ("SET-WELL-FOUNDED-RELATION" , "ACL2-AGP" , "ACL2"),
    ("SETF" , "ACL2-AGP" , "COMMON-LISP"),
    ("SETQ" , "ACL2-AGP" , "COMMON-LISP"),
    ("SEVENTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("SGETPROP" , "ACL2-AGP" , "ACL2"),
    ("SHADOW" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHADOWING-IMPORT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHARED-INITIALIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHIFTF" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHORT-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHORT-FLOAT-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHORT-FLOAT-NEGATIVE-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHORT-SITE-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("SHOW-ACCUMULATED-PERSISTENCE" , "ACL2-AGP" , "ACL2"),
    ("SHOW-BDD" , "ACL2-AGP" , "ACL2"),
    ("SHOW-BODIES" , "ACL2-AGP" , "ACL2"),
    ("SHRINK-32-BIT-INTEGER-STACK" , "ACL2-AGP" , "ACL2"),
    ("SHRINK-T-STACK" , "ACL2-AGP" , "ACL2"),
    ("SIGNAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIGNED-BYTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIGNUM" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-ARRAY" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-BASE-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-CONDITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-ARGUMENTS" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-CONTROL" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-STRING-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-TYPE-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-VECTOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-VECTOR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLE-WARNING" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIMPLIFY" , "ACL2-AGP" , "ACL2"),
    ("SIN" , "ACL2-AGP" , "COMMON-LISP"),
    ("SINGLE-FLOAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SINGLE-FLOAT-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("SINGLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-AGP" , "COMMON-LISP"),
    ("SINH" , "ACL2-AGP" , "COMMON-LISP"),
    ("SIXTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("SKIP-PROOFS" , "ACL2-AGP" , "ACL2"),
    ("SLEEP" , "ACL2-AGP" , "COMMON-LISP"),
    ("SLOT-BOUNDP" , "ACL2-AGP" , "COMMON-LISP"),
    ("SLOT-EXISTS-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("SLOT-MAKUNBOUND" , "ACL2-AGP" , "COMMON-LISP"),
    ("SLOT-MISSING" , "ACL2-AGP" , "COMMON-LISP"),
    ("SLOT-UNBOUND" , "ACL2-AGP" , "COMMON-LISP"),
    ("SLOT-VALUE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SOFTWARE-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SOFTWARE-VERSION" , "ACL2-AGP" , "COMMON-LISP"),
    ("SOME" , "ACL2-AGP" , "COMMON-LISP"),
    ("SOME-SLASHABLE" , "ACL2-AGP" , "ACL2"),
    ("SORT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SPACE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SPECIAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("SPECIAL-OPERATOR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("SPEED" , "ACL2-AGP" , "COMMON-LISP"),
    ("SQRT" , "ACL2-AGP" , "COMMON-LISP"),
    ("STABLE-SORT" , "ACL2-AGP" , "COMMON-LISP"),
    ("STABLE-UNDER-SIMPLIFICATIONP" , "ACL2-AGP" , "ACL2"),
    ("STANDARD" , "ACL2-AGP" , "COMMON-LISP"),
    ("STANDARD-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("STANDARD-CHAR-LISTP" , "ACL2-AGP" , "ACL2"),
    ("STANDARD-CHAR-LISTP-APPEND" , "ACL2-AGP" , "ACL2"),
    ("STANDARD-CHAR-LISTP-FORWARD-TO-CHARACTER-LISTP" , "ACL2-AGP"
, "ACL2"),
    ("STANDARD-CHAR-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("STANDARD-CHAR-P-NTH" , "ACL2-AGP" , "ACL2"),
    ("STANDARD-CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("STANDARD-CO" , "ACL2-AGP" , "ACL2"),
    ("STANDARD-GENERIC-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("STANDARD-METHOD" , "ACL2-AGP" , "COMMON-LISP"),
    ("STANDARD-OBJECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("STANDARD-OI" , "ACL2-AGP" , "ACL2"),
    ("STANDARD-STRING-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("STANDARD-STRING-ALISTP-FORWARD-TO-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("START-PROOF-TREE" , "ACL2-AGP" , "ACL2"),
    ("STATE" , "ACL2-AGP" , "ACL2"),
    ("STATE-GLOBAL-LET*-CLEANUP" , "ACL2-AGP" , "ACL2"),
    ("STATE-GLOBAL-LET*-GET-GLOBALS" , "ACL2-AGP" , "ACL2"),
    ("STATE-GLOBAL-LET*-PUT-GLOBALS" , "ACL2-AGP" , "ACL2"),
    ("STATE-P" , "ACL2-AGP" , "ACL2"),
    ("STATE-P-IMPLIES-AND-FORWARD-TO-STATE-P1" , "ACL2-AGP" , "ACL2"),
    ("STATE-P1" , "ACL2-AGP" , "ACL2"),
    ("STATE-P1-FORWARD" , "ACL2-AGP" , "ACL2"),
    ("STATE-P1-UPDATE-MAIN-TIMER" , "ACL2-AGP" , "ACL2"),
    ("STATE-P1-UPDATE-NTH-2-WORLD" , "ACL2-AGP" , "ACL2"),
    ("STEP" , "ACL2-AGP" , "COMMON-LISP"),
    ("STOP-PROOF-TREE" , "ACL2-AGP" , "ACL2"),
    ("STORAGE-CONDITION" , "ACL2-AGP" , "COMMON-LISP"),
    ("STORE-VALUE" , "ACL2-AGP" , "COMMON-LISP"),
    ("STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("STREAM-ELEMENT-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("STREAM-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("STREAM-ERROR-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("STREAM-EXTERNAL-FORMAT" , "ACL2-AGP" , "COMMON-LISP"),
    ("STREAMP" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-APPEND" , "ACL2-AGP" , "ACL2"),
    ("STRING-APPEND-LST" , "ACL2-AGP" , "ACL2"),
    ("STRING-CAPITALIZE" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-DOWNCASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-DOWNCASE1" , "ACL2-AGP" , "ACL2"),
    ("STRING-EQUAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-EQUAL1" , "ACL2-AGP" , "ACL2"),
    ("STRING-GREATERP" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-IS-NOT-CIRCULAR" , "ACL2-AGP" , "ACL2"),
    ("STRING-LEFT-TRIM" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-LESSP" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-LISTP" , "ACL2-AGP" , "ACL2"),
    ("STRING-NOT-EQUAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-NOT-GREATERP" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-NOT-LESSP" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-RIGHT-TRIM" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-TRIM" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-UPCASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING-UPCASE1" , "ACL2-AGP" , "ACL2"),
    ("STRING/=" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING<" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING<-IRREFLEXIVE" , "ACL2-AGP" , "ACL2"),
    ("STRING<-L" , "ACL2-AGP" , "ACL2"),
    ("STRING<-L-ASYMMETRIC" , "ACL2-AGP" , "ACL2"),
    ("STRING<-L-IRREFLEXIVE" , "ACL2-AGP" , "ACL2"),
    ("STRING<-L-TRANSITIVE" , "ACL2-AGP" , "ACL2"),
    ("STRING<-L-TRICHOTOMY" , "ACL2-AGP" , "ACL2"),
    ("STRING<=" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING=" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING>" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRING>=" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRINGP" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRINGP-SYMBOL-PACKAGE-NAME" , "ACL2-AGP" , "ACL2"),
    ("STRIP-CARS" , "ACL2-AGP" , "ACL2"),
    ("STRIP-CDRS" , "ACL2-AGP" , "ACL2"),
    ("STRUCTURE" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRUCTURE-CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("STRUCTURE-OBJECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("STYLE-WARNING" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBLIS" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBSEQ" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBSEQ-LIST" , "ACL2-AGP" , "ACL2"),
    ("SUBSETP" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBSETP-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("SUBST" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBST-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBST-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBSTITUTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBSTITUTE-AC" , "ACL2-AGP" , "ACL2"),
    ("SUBSTITUTE-IF" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBSTITUTE-IF-NOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUBTYPEP" , "ACL2-AGP" , "COMMON-LISP"),
    ("SUMMARY" , "ACL2-AGP" , "ACL2"),
    ("SVREF" , "ACL2-AGP" , "COMMON-LISP"),
    ("SXHASH" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOL" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOL-<" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-<-ASYMMETRIC" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-<-IRREFLEXIVE" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-<-TRANSITIVE" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-<-TRICHOTOMY" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-DOUBLET-LISTP" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-EQUALITY" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOL-LISTP" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-MACROLET" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOL-NAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOL-NAME-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOL-PACKAGE-NAME" , "ACL2-AGP" , "ACL2"),
    ("SYMBOL-PLIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOL-VALUE" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOLP" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYMBOLP-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-AGP" , "ACL2"),
    ("SYNONYM-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYNONYM-STREAM-SYMBOL" , "ACL2-AGP" , "COMMON-LISP"),
    ("SYNP" , "ACL2-AGP" , "ACL2"),
    ("SYNTAXP" , "ACL2-AGP" , "ACL2"),
    ("SYS-CALL" , "ACL2-AGP" , "ACL2"),
    ("SYS-CALL-STATUS" , "ACL2-AGP" , "ACL2"),
    ("T" , "ACL2-AGP" , "COMMON-LISP"),
    ("T-STACK" , "ACL2-AGP" , "ACL2"),
    ("T-STACK-LENGTH" , "ACL2-AGP" , "ACL2"),
    ("T-STACK-LENGTH1" , "ACL2-AGP" , "ACL2"),
    ("TABLE" , "ACL2-AGP" , "ACL2"),
    ("TABLE-ALIST" , "ACL2-AGP" , "ACL2"),
    ("TAGBODY" , "ACL2-AGP" , "COMMON-LISP"),
    ("TAILP" , "ACL2-AGP" , "COMMON-LISP"),
    ("TAKE" , "ACL2-AGP" , "ACL2"),
    ("TAN" , "ACL2-AGP" , "COMMON-LISP"),
    ("TANH" , "ACL2-AGP" , "COMMON-LISP"),
    ("TENTH" , "ACL2-AGP" , "COMMON-LISP"),
    ("TERPRI" , "ACL2-AGP" , "COMMON-LISP"),
    ("THE" , "ACL2-AGP" , "COMMON-LISP"),
    ("THE-ERROR" , "ACL2-AGP" , "ACL2"),
    ("THE-FIXNUM" , "ACL2-AGP" , "ACL2"),
    ("THE-FIXNUM!" , "ACL2-AGP" , "ACL2"),
    ("THEORY" , "ACL2-AGP" , "ACL2"),
    ("THEORY-INVARIANT" , "ACL2-AGP" , "ACL2"),
    ("THIRD" , "ACL2-AGP" , "COMMON-LISP"),
    ("THM" , "ACL2-AGP" , "ACL2"),
    ("THROW" , "ACL2-AGP" , "COMMON-LISP"),
    ("TIME" , "ACL2-AGP" , "COMMON-LISP"),
    ("TIME$" , "ACL2-AGP" , "ACL2"),
    ("TIMER-ALISTP" , "ACL2-AGP" , "ACL2"),
    ("TIMER-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-SYMBOL-ALISTP" ,
"ACL2-AGP" , "ACL2"),
    ("TOGGLE-PC-MACRO" , "ACL2-AGP" , "ACL2"),
    ("TRACE" , "ACL2-AGP" , "COMMON-LISP"),
    ("TRACE!" , "ACL2-AGP" , "ACL2"),
    ("TRACE$" , "ACL2-AGP" , "ACL2"),
    ("TRACE*" , "ACL2-AGP" , "ACL2"),
    ("TRANS" , "ACL2-AGP" , "ACL2"),
    ("TRANS1" , "ACL2-AGP" , "ACL2"),
    ("TRANSLATE-LOGICAL-PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("TRANSLATE-PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("TREE-EQUAL" , "ACL2-AGP" , "COMMON-LISP"),
    ("TRICHOTOMY" , "ACL2-AGP" , "ACL2"),
    ("TRUE-LIST-LISTP" , "ACL2-AGP" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP-ASSOC-EQ" , "ACL2-AGP"
, "ACL2"),
    ("TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("TRUE-LISTP-CADR-ASSOC-EQ-FOR-OPEN-CHANNELS-P" , "ACL2-AGP" ,
"ACL2"),
    ("TRUE-LISTP-UPDATE-NTH" , "ACL2-AGP" , "ACL2"),
    ("TRUENAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("TRUNCATE" , "ACL2-AGP" , "COMMON-LISP"),
    ("TWO-WAY-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-INPUT-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-OUTPUT-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("TYPE-ERROR" , "ACL2-AGP" , "COMMON-LISP"),
    ("TYPE-ERROR-DATUM" , "ACL2-AGP" , "COMMON-LISP"),
    ("TYPE-ERROR-EXPECTED-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("TYPE-OF" , "ACL2-AGP" , "COMMON-LISP"),
    ("TYPECASE" , "ACL2-AGP" , "COMMON-LISP"),
    ("TYPED-IO-LISTP" , "ACL2-AGP" , "ACL2"),
    ("TYPED-IO-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("TYPEP" , "ACL2-AGP" , "COMMON-LISP"),
    ("U" , "ACL2-AGP" , "ACL2"),
    ("UBT" , "ACL2-AGP" , "ACL2"),
    ("UBT!" , "ACL2-AGP" , "ACL2"),
    ("UNARY--" , "ACL2-AGP" , "ACL2"),
    ("UNARY-/" , "ACL2-AGP" , "ACL2"),
    ("UNARY-FUNCTION-SYMBOL-LISTP" , "ACL2-AGP" , "ACL2"),
    ("UNBOUND-SLOT" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNBOUND-SLOT-INSTANCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNBOUND-VARIABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNDEFINED-FUNCTION" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNEXPORT" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNICITY-OF-0" , "ACL2-AGP" , "ACL2"),
    ("UNICITY-OF-1" , "ACL2-AGP" , "ACL2"),
    ("UNINTERN" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNION" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNION-EQ" , "ACL2-AGP" , "ACL2"),
    ("UNION-EQUAL" , "ACL2-AGP" , "ACL2"),
    ("UNION-THEORIES" , "ACL2-AGP" , "ACL2"),
    ("UNIVERSAL-THEORY" , "ACL2-AGP" , "ACL2"),
    ("UNLESS" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNMEMOIZE" , "ACL2-AGP" , "ACL2"),
    ("UNMONITOR" , "ACL2-AGP" , "ACL2"),
    ("UNREAD-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNSAVE" , "ACL2-AGP" , "ACL2"),
    ("UNSIGNED-BYTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNTRACE" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNTRACE$" , "ACL2-AGP" , "ACL2"),
    ("UNUSE-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("UNWIND-PROTECT" , "ACL2-AGP" , "COMMON-LISP"),
    ("UPDATE-32-BIT-INTEGER-STACK" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-ACL2-ORACLE" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-BIG-CLOCK-ENTRY" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-FILE-CLOCK" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-GLOBAL-TABLE" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-IDATES" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-INSTANCE-FOR-DIFFERENT-CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("UPDATE-INSTANCE-FOR-REDEFINED-CLASS" , "ACL2-AGP" , "COMMON-LISP"),
    ("UPDATE-LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-NTH" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-OPEN-INPUT-CHANNELS" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-OPEN-OUTPUT-CHANNELS" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-READ-FILES" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-T-STACK" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST1" , "ACL2-AGP" , "ACL2"),
    ("UPDATE-WRITTEN-FILES" , "ACL2-AGP" , "ACL2"),
    ("UPGRADED-ARRAY-ELEMENT-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("UPGRADED-COMPLEX-PART-TYPE" , "ACL2-AGP" , "COMMON-LISP"),
    ("UPPER-CASE-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("UPPER-CASE-P-CHAR-UPCASE" , "ACL2-AGP" , "ACL2"),
    ("UPPER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-AGP" , "ACL2"),
    ("USE-PACKAGE" , "ACL2-AGP" , "COMMON-LISP"),
    ("USE-VALUE" , "ACL2-AGP" , "COMMON-LISP"),
    ("USER-HOMEDIR-PATHNAME" , "ACL2-AGP" , "COMMON-LISP"),
    ("USER-STOBJ-ALIST" , "ACL2-AGP" , "ACL2"),
    ("USER-STOBJ-ALIST1" , "ACL2-AGP" , "ACL2"),
    ("VALUE-TRIPLE" , "ACL2-AGP" , "ACL2"),
    ("VALUES" , "ACL2-AGP" , "COMMON-LISP"),
    ("VALUES-LIST" , "ACL2-AGP" , "COMMON-LISP"),
    ("VARIABLE" , "ACL2-AGP" , "COMMON-LISP"),
    ("VECTOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("VECTOR-POP" , "ACL2-AGP" , "COMMON-LISP"),
    ("VECTOR-PUSH" , "ACL2-AGP" , "COMMON-LISP"),
    ("VECTOR-PUSH-EXTEND" , "ACL2-AGP" , "COMMON-LISP"),
    ("VECTORP" , "ACL2-AGP" , "COMMON-LISP"),
    ("VERBOSE-PSTACK" , "ACL2-AGP" , "ACL2"),
    ("VERIFY" , "ACL2-AGP" , "ACL2"),
    ("VERIFY-GUARDS" , "ACL2-AGP" , "ACL2"),
    ("VERIFY-TERMINATION" , "ACL2-AGP" , "ACL2"),
    ("W" , "ACL2-AGP" , "ACL2"),
    ("WARN" , "ACL2-AGP" , "COMMON-LISP"),
    ("WARNING" , "ACL2-AGP" , "COMMON-LISP"),
    ("WARNING!" , "ACL2-AGP" , "ACL2"),
    ("WHEN" , "ACL2-AGP" , "COMMON-LISP"),
    ("WILD-PATHNAME-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-ACCESSORS" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-COMPILATION-UNIT" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-CONDITION-RESTARTS" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-HASH-TABLE-ITERATOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-INPUT-FROM-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-OPEN-FILE" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-OPEN-STREAM" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-OUTPUT" , "ACL2-AGP" , "ACL2"),
    ("WITH-OUTPUT-TO-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-PACKAGE-ITERATOR" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-SIMPLE-RESTART" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-SLOTS" , "ACL2-AGP" , "COMMON-LISP"),
    ("WITH-STANDARD-IO-SYNTAX" , "ACL2-AGP" , "COMMON-LISP"),
    ("WORLD" , "ACL2-AGP" , "ACL2"),
    ("WORMHOLE" , "ACL2-AGP" , "ACL2"),
    ("WORMHOLE-EVAL" , "ACL2-AGP" , "ACL2"),
    ("WORMHOLE1" , "ACL2-AGP" , "ACL2"),
    ("WRITABLE-FILE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("WRITABLE-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-AGP"
, "ACL2"),
    ("WRITABLE-FILE-LISTP1" , "ACL2-AGP" , "ACL2"),
    ("WRITABLE-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-AGP"
, "ACL2"),
    ("WRITE" , "ACL2-AGP" , "COMMON-LISP"),
    ("WRITE-BYTE" , "ACL2-AGP" , "COMMON-LISP"),
    ("WRITE-BYTE$" , "ACL2-AGP" , "ACL2"),
    ("WRITE-CHAR" , "ACL2-AGP" , "COMMON-LISP"),
    ("WRITE-LINE" , "ACL2-AGP" , "COMMON-LISP"),
    ("WRITE-SEQUENCE" , "ACL2-AGP" , "COMMON-LISP"),
    ("WRITE-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("WRITE-TO-STRING" , "ACL2-AGP" , "COMMON-LISP"),
    ("WRITEABLE-FILES" , "ACL2-AGP" , "ACL2"),
    ("WRITEABLE-FILES-P" , "ACL2-AGP" , "ACL2"),
    ("WRITEABLE-FILES-P-FORWARD-TO-WRITABLE-FILE-LISTP" , "ACL2-AGP"
, "ACL2"),
    ("WRITTEN-FILE" , "ACL2-AGP" , "ACL2"),
    ("WRITTEN-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-AGP" ,
"ACL2"),
    ("WRITTEN-FILE-LISTP" , "ACL2-AGP" , "ACL2"),
    ("WRITTEN-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" , "ACL2-AGP"
, "ACL2"),
    ("WRITTEN-FILES" , "ACL2-AGP" , "ACL2"),
    ("WRITTEN-FILES-P" , "ACL2-AGP" , "ACL2"),
    ("WRITTEN-FILES-P-FORWARD-TO-WRITTEN-FILE-LISTP" , "ACL2-AGP" ,
"ACL2"),
    ("XARGS" , "ACL2-AGP" , "ACL2"),
    ("XXXJOIN" , "ACL2-AGP" , "ACL2"),
    ("Y-OR-N-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("YES-OR-NO-P" , "ACL2-AGP" , "COMMON-LISP"),
    ("ZEROP" , "ACL2-AGP" , "COMMON-LISP"),
    ("ZIP" , "ACL2-AGP" , "ACL2"),
    ("ZP" , "ACL2-AGP" , "ACL2"),
    ("&" , "ACL2-CRG" , "ACL2"),
    ("&ALLOW-OTHER-KEYS" , "ACL2-CRG" , "COMMON-LISP"),
    ("&AUX" , "ACL2-CRG" , "COMMON-LISP"),
    ("&BODY" , "ACL2-CRG" , "COMMON-LISP"),
    ("&ENVIRONMENT" , "ACL2-CRG" , "COMMON-LISP"),
    ("&KEY" , "ACL2-CRG" , "COMMON-LISP"),
    ("&OPTIONAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("&REST" , "ACL2-CRG" , "COMMON-LISP"),
    ("&WHOLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("*" , "ACL2-CRG" , "COMMON-LISP"),
    ("**" , "ACL2-CRG" , "COMMON-LISP"),
    ("***" , "ACL2-CRG" , "COMMON-LISP"),
    ("*ACL2-EXPORTS*" , "ACL2-CRG" , "ACL2"),
    ("*BREAK-ON-SIGNALS*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*COMMON-LISP-SPECIALS-AND-CONSTANTS*" , "ACL2-CRG" , "ACL2"),
    ("*COMMON-LISP-SYMBOLS-FROM-MAIN-LISP-PACKAGE*" , "ACL2-CRG" ,
"ACL2"),
    ("*COMPILE-FILE-PATHNAME*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*COMPILE-FILE-TRUENAME*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*COMPILE-PRINT*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*COMPILE-VERBOSE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*DEBUG-IO*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*DEBUGGER-HOOK*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*DEFAULT-PATHNAME-DEFAULTS*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*ERROR-OUTPUT*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*FEATURES*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*GENSYM-COUNTER*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*LOAD-PATHNAME*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*LOAD-PRINT*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*LOAD-TRUENAME*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*LOAD-VERBOSE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*MACROEXPAND-HOOK*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*MAIN-LISP-PACKAGE-NAME*" , "ACL2-CRG" , "ACL2"),
    ("*MODULES*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PACKAGE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-ARRAY*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-BASE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-CASE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-CIRCLE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-ESCAPE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-GENSYM*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-LENGTH*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-LEVEL*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-LINES*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-MISER-WIDTH*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-PPRINT-DISPATCH*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-PRETTY*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-RADIX*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-READABLY*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*PRINT-RIGHT-MARGIN*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*QUERY-IO*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*RANDOM-STATE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*READ-BASE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*READ-DEFAULT-FLOAT-FORMAT*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*READ-EVAL*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*READ-SUPPRESS*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*READTABLE*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*STANDARD-CHARS*" , "ACL2-CRG" , "ACL2"),
    ("*STANDARD-CI*" , "ACL2-CRG" , "ACL2"),
    ("*STANDARD-CO*" , "ACL2-CRG" , "ACL2"),
    ("*STANDARD-INPUT*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*STANDARD-OI*" , "ACL2-CRG" , "ACL2"),
    ("*STANDARD-OUTPUT*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*TERMINAL-IO*" , "ACL2-CRG" , "COMMON-LISP"),
    ("*TRACE-OUTPUT*" , "ACL2-CRG" , "COMMON-LISP"),
    ("+" , "ACL2-CRG" , "COMMON-LISP"),
    ("++" , "ACL2-CRG" , "COMMON-LISP"),
    ("+++" , "ACL2-CRG" , "COMMON-LISP"),
    ("-" , "ACL2-CRG" , "COMMON-LISP"),
    ("/" , "ACL2-CRG" , "COMMON-LISP"),
    ("//" , "ACL2-CRG" , "COMMON-LISP"),
    ("///" , "ACL2-CRG" , "COMMON-LISP"),
    ("/=" , "ACL2-CRG" , "COMMON-LISP"),
    ("1+" , "ACL2-CRG" , "COMMON-LISP"),
    ("1-" , "ACL2-CRG" , "COMMON-LISP"),
    ("32-BIT-INTEGER-LISTP" , "ACL2-CRG" , "ACL2"),
    ("32-BIT-INTEGER-LISTP-FORWARD-TO-INTEGER-LISTP" , "ACL2-CRG" ,
"ACL2"),
    ("32-BIT-INTEGER-STACK" , "ACL2-CRG" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH" , "ACL2-CRG" , "ACL2"),
    ("32-BIT-INTEGER-STACK-LENGTH1" , "ACL2-CRG" , "ACL2"),
    ("32-BIT-INTEGERP" , "ACL2-CRG" , "ACL2"),
    ("32-BIT-INTEGERP-FORWARD-TO-INTEGERP" , "ACL2-CRG" , "ACL2"),
    ("<" , "ACL2-CRG" , "COMMON-LISP"),
    ("<-ON-OTHERS" , "ACL2-CRG" , "ACL2"),
    ("<=" , "ACL2-CRG" , "COMMON-LISP"),
    ("=" , "ACL2-CRG" , "COMMON-LISP"),
    (">" , "ACL2-CRG" , "COMMON-LISP"),
    (">=" , "ACL2-CRG" , "COMMON-LISP"),
    ("?-FN" , "ACL2-CRG" , "ACL2"),
    ("@" , "ACL2-CRG" , "ACL2"),
    ("ABORT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ABORT!" , "ACL2-CRG" , "ACL2"),
    ("ABS" , "ACL2-CRG" , "COMMON-LISP"),
    ("ACCUMULATED-PERSISTENCE" , "ACL2-CRG" , "ACL2"),
    ("ACL2-COUNT" , "ACL2-CRG" , "ACL2"),
    ("ACL2-INPUT-CHANNEL-PACKAGE" , "ACL2-CRG" , "ACL2"),
    ("ACL2-NUMBERP" , "ACL2-CRG" , "ACL2"),
    ("ACL2-ORACLE" , "ACL2-CRG" , "ACL2"),
    ("ACL2-OUTPUT-CHANNEL-PACKAGE" , "ACL2-CRG" , "ACL2"),
    ("ACL2-PACKAGE" , "ACL2-CRG" , "ACL2"),
    ("ACONS" , "ACL2-CRG" , "COMMON-LISP"),
    ("ACOS" , "ACL2-CRG" , "COMMON-LISP"),
    ("ACOSH" , "ACL2-CRG" , "COMMON-LISP"),
    ("ACTIVE-RUNEP" , "ACL2-CRG" , "ACL2"),
    ("ADD-BINOP" , "ACL2-CRG" , "ACL2"),
    ("ADD-DEFAULT-HINTS" , "ACL2-CRG" , "ACL2"),
    ("ADD-DEFAULT-HINTS!" , "ACL2-CRG" , "ACL2"),
    ("ADD-INVISIBLE-FNS" , "ACL2-CRG" , "ACL2"),
    ("ADD-MACRO-ALIAS" , "ACL2-CRG" , "ACL2"),
    ("ADD-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("ADD-NTH-ALIAS" , "ACL2-CRG" , "ACL2"),
    ("ADD-PAIR" , "ACL2-CRG" , "ACL2"),
    ("ADD-PAIR-PRESERVES-ALL-BOUNDP" , "ACL2-CRG" , "ACL2"),
    ("ADD-TIMERS" , "ACL2-CRG" , "ACL2"),
    ("ADD-TO-SET-EQ" , "ACL2-CRG" , "ACL2"),
    ("ADD-TO-SET-EQL" , "ACL2-CRG" , "ACL2"),
    ("ADD-TO-SET-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("ADJOIN" , "ACL2-CRG" , "COMMON-LISP"),
    ("ADJUST-ARRAY" , "ACL2-CRG" , "COMMON-LISP"),
    ("ADJUSTABLE-ARRAY-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("ALISTP" , "ACL2-CRG" , "ACL2"),
    ("ALISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("ALL-BOUNDP" , "ACL2-CRG" , "ACL2"),
    ("ALL-BOUNDP-PRESERVES-ASSOC" , "ACL2-CRG" , "ACL2"),
    ("ALL-VARS" , "ACL2-CRG" , "ACL2"),
    ("ALL-VARS1" , "ACL2-CRG" , "ACL2"),
    ("ALL-VARS1-LST" , "ACL2-CRG" , "ACL2"),
    ("ALLOCATE-INSTANCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("ALPHA-CHAR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("ALPHA-CHAR-P-FORWARD-TO-CHARACTERP" , "ACL2-CRG" , "ACL2"),
    ("ALPHANUMERICP" , "ACL2-CRG" , "COMMON-LISP"),
    ("AND" , "ACL2-CRG" , "COMMON-LISP"),
    ("AND-MACRO" , "ACL2-CRG" , "ACL2"),
    ("APPEND" , "ACL2-CRG" , "COMMON-LISP"),
    ("APPLY" , "ACL2-CRG" , "COMMON-LISP"),
    ("APROPOS" , "ACL2-CRG" , "COMMON-LISP"),
    ("APROPOS-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("AREF" , "ACL2-CRG" , "COMMON-LISP"),
    ("AREF-32-BIT-INTEGER-STACK" , "ACL2-CRG" , "ACL2"),
    ("AREF-T-STACK" , "ACL2-CRG" , "ACL2"),
    ("AREF1" , "ACL2-CRG" , "ACL2"),
    ("AREF2" , "ACL2-CRG" , "ACL2"),
    ("ARGS" , "ACL2-CRG" , "ACL2"),
    ("ARITHMETIC-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERANDS" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARITHMETIC-ERROR-OPERATION" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-DIMENSION" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-DIMENSION-LIMIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-DIMENSIONS" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-DISPLACEMENT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-ELEMENT-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-HAS-FILL-POINTER-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-IN-BOUNDS-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-RANK" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-RANK-LIMIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-ROW-MAJOR-INDEX" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY-TOTAL-SIZE-LIMIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ARRAY1P" , "ACL2-CRG" , "ACL2"),
    ("ARRAY1P-CONS" , "ACL2-CRG" , "ACL2"),
    ("ARRAY1P-FORWARD" , "ACL2-CRG" , "ACL2"),
    ("ARRAY1P-LINEAR" , "ACL2-CRG" , "ACL2"),
    ("ARRAY2P" , "ACL2-CRG" , "ACL2"),
    ("ARRAY2P-CONS" , "ACL2-CRG" , "ACL2"),
    ("ARRAY2P-FORWARD" , "ACL2-CRG" , "ACL2"),
    ("ARRAY2P-LINEAR" , "ACL2-CRG" , "ACL2"),
    ("ARRAYP" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASET-32-BIT-INTEGER-STACK" , "ACL2-CRG" , "ACL2"),
    ("ASET-T-STACK" , "ACL2-CRG" , "ACL2"),
    ("ASET1" , "ACL2-CRG" , "ACL2"),
    ("ASET2" , "ACL2-CRG" , "ACL2"),
    ("ASH" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASIN" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASINH" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASSERT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASSERT$" , "ACL2-CRG" , "ACL2"),
    ("ASSIGN" , "ACL2-CRG" , "ACL2"),
    ("ASSOC" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASSOC-ADD-PAIR" , "ACL2-CRG" , "ACL2"),
    ("ASSOC-EQ" , "ACL2-CRG" , "ACL2"),
    ("ASSOC-EQ-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("ASSOC-EQ-EQUAL-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("ASSOC-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("ASSOC-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASSOC-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ASSOC-KEYWORD" , "ACL2-CRG" , "ACL2"),
    ("ASSOC-STRING-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("ASSOC2" , "ACL2-CRG" , "ACL2"),
    ("ASSOCIATIVITY-OF-*" , "ACL2-CRG" , "ACL2"),
    ("ASSOCIATIVITY-OF-+" , "ACL2-CRG" , "ACL2"),
    ("ASSUME" , "ACL2-CRG" , "ACL2"),
    ("ATAN" , "ACL2-CRG" , "COMMON-LISP"),
    ("ATANH" , "ACL2-CRG" , "COMMON-LISP"),
    ("ATOM" , "ACL2-CRG" , "COMMON-LISP"),
    ("ATOM-LISTP" , "ACL2-CRG" , "ACL2"),
    ("ATOM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("BASE-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BASE-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIG-CLOCK-ENTRY" , "ACL2-CRG" , "ACL2"),
    ("BIG-CLOCK-NEGATIVE-P" , "ACL2-CRG" , "ACL2"),
    ("BIGNUM" , "ACL2-CRG" , "COMMON-LISP"),
    ("BINARY-*" , "ACL2-CRG" , "ACL2"),
    ("BINARY-+" , "ACL2-CRG" , "ACL2"),
    ("BINARY-APPEND" , "ACL2-CRG" , "ACL2"),
    ("BIND-FREE" , "ACL2-CRG" , "ACL2"),
    ("BINOP-TABLE" , "ACL2-CRG" , "ACL2"),
    ("BIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-AND" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-ANDC1" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-ANDC2" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-EQV" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-IOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-NAND" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-NOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-ORC1" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-ORC2" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-VECTOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-VECTOR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("BIT-XOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BLOCK" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-1" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-2" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-AND" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-ANDC1" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-ANDC2" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-C1" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-C2" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-CLR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-EQV" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-IOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-NAND" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-NOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-ORC1" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-ORC2" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-SET" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLE-XOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLEAN" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOOLEAN-LISTP" , "ACL2-CRG" , "ACL2"),
    ("BOOLEAN-LISTP-CONS" , "ACL2-CRG" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD" , "ACL2-CRG" , "ACL2"),
    ("BOOLEAN-LISTP-FORWARD-TO-SYMBOL-LISTP" , "ACL2-CRG" , "ACL2"),
    ("BOOLEANP" , "ACL2-CRG" , "ACL2"),
    ("BOOLEANP-CHARACTERP" , "ACL2-CRG" , "ACL2"),
    ("BOOLEANP-COMPOUND-RECOGNIZER" , "ACL2-CRG" , "ACL2"),
    ("BOTH-CASE-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOUNDED-INTEGER-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("BOUNDED-INTEGER-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-CRG"
, "ACL2"),
    ("BOUNDED-INTEGER-ALISTP2" , "ACL2-CRG" , "ACL2"),
    ("BOUNDP" , "ACL2-CRG" , "COMMON-LISP"),
    ("BOUNDP-GLOBAL" , "ACL2-CRG" , "ACL2"),
    ("BOUNDP-GLOBAL1" , "ACL2-CRG" , "ACL2"),
    ("BREAK" , "ACL2-CRG" , "COMMON-LISP"),
    ("BROADCAST-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("BROADCAST-STREAM-STREAMS" , "ACL2-CRG" , "COMMON-LISP"),
    ("BRR" , "ACL2-CRG" , "ACL2"),
    ("BRR@" , "ACL2-CRG" , "ACL2"),
    ("BUILD-STATE1" , "ACL2-CRG" , "ACL2"),
    ("BUILT-IN-CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("BUTLAST" , "ACL2-CRG" , "COMMON-LISP"),
    ("BYTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("BYTE-POSITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("BYTE-SIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAAAAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAAADR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAAAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAADAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAADDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAADR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CADAAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CADADR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CADAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CADDAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CADDDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CADDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CADR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CALL-ARGUMENTS-LIMIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("CALL-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("CALL-NEXT-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CAR-CDR-ELIM" , "ACL2-CRG" , "ACL2"),
    ("CAR-CONS" , "ACL2-CRG" , "ACL2"),
    ("CASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CASE-LIST" , "ACL2-CRG" , "ACL2"),
    ("CASE-LIST-CHECK" , "ACL2-CRG" , "ACL2"),
    ("CASE-MATCH" , "ACL2-CRG" , "ACL2"),
    ("CASE-SPLIT" , "ACL2-CRG" , "ACL2"),
    ("CASE-TEST" , "ACL2-CRG" , "ACL2"),
    ("CATCH" , "ACL2-CRG" , "COMMON-LISP"),
    ("CBD" , "ACL2-CRG" , "ACL2"),
    ("CCASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDAAAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDAADR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDAAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDADAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDADDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDADR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDDAAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDDADR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDDAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDDDAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDDDDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDDDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CDR-CONS" , "ACL2-CRG" , "ACL2"),
    ("CDRN" , "ACL2-CRG" , "ACL2"),
    ("CEILING" , "ACL2-CRG" , "COMMON-LISP"),
    ("CELL-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CELL-ERROR-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("CERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CERTIFY-BOOK" , "ACL2-CRG" , "ACL2"),
    ("CERTIFY-BOOK!" , "ACL2-CRG" , "ACL2"),
    ("CHANGE-CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-CODE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-CODE-CODE-CHAR-IS-IDENTITY" , "ACL2-CRG" , "ACL2"),
    ("CHAR-CODE-LIMIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-CODE-LINEAR" , "ACL2-CRG" , "ACL2"),
    ("CHAR-DOWNCASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-EQUAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-GREATERP" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-INT" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-LESSP" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-NOT-EQUAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-NOT-GREATERP" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-NOT-LESSP" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR-UPCASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR/=" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR<" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR<=" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR=" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR>" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHAR>=" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHARACTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHARACTER-LISTP" , "ACL2-CRG" , "ACL2"),
    ("CHARACTER-LISTP-APPEND" , "ACL2-CRG" , "ACL2"),
    ("CHARACTER-LISTP-COERCE" , "ACL2-CRG" , "ACL2"),
    ("CHARACTER-LISTP-FORWARD-TO-EQLABLE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("CHARACTER-LISTP-REMOVE-DUPLICATES-EQL" , "ACL2-CRG" , "ACL2"),
    ("CHARACTER-LISTP-REVAPPEND" , "ACL2-CRG" , "ACL2"),
    ("CHARACTER-LISTP-STRING-DOWNCASE-1" , "ACL2-CRG" , "ACL2"),
    ("CHARACTER-LISTP-STRING-UPCASE1-1" , "ACL2-CRG" , "ACL2"),
    ("CHARACTERP" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHARACTERP-CHAR-DOWNCASE" , "ACL2-CRG" , "ACL2"),
    ("CHARACTERP-CHAR-UPCASE" , "ACL2-CRG" , "ACL2"),
    ("CHARACTERP-NTH" , "ACL2-CRG" , "ACL2"),
    ("CHARACTERP-PAGE" , "ACL2-CRG" , "ACL2"),
    ("CHARACTERP-RUBOUT" , "ACL2-CRG" , "ACL2"),
    ("CHARACTERP-TAB" , "ACL2-CRG" , "ACL2"),
    ("CHECK-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CHECK-VARS-NOT-FREE" , "ACL2-CRG" , "ACL2"),
    ("CHECKPOINT-FORCED-GOALS" , "ACL2-CRG" , "ACL2"),
    ("CIS" , "ACL2-CRG" , "COMMON-LISP"),
    ("CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("CLASS-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("CLASS-OF" , "ACL2-CRG" , "COMMON-LISP"),
    ("CLAUSE" , "ACL2-CRG" , "ACL2"),
    ("CLEAR-HASH-TABLES" , "ACL2-CRG" , "ACL2"),
    ("CLEAR-INPUT" , "ACL2-CRG" , "COMMON-LISP"),
    ("CLEAR-MEMOIZE-TABLE" , "ACL2-CRG" , "ACL2"),
    ("CLEAR-MEMOIZE-TABLES" , "ACL2-CRG" , "ACL2"),
    ("CLEAR-OUTPUT" , "ACL2-CRG" , "COMMON-LISP"),
    ("CLOSE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CLOSE-INPUT-CHANNEL" , "ACL2-CRG" , "ACL2"),
    ("CLOSE-OUTPUT-CHANNEL" , "ACL2-CRG" , "ACL2"),
    ("CLOSE-TRACE-FILE" , "ACL2-CRG" , "ACL2"),
    ("CLOSURE" , "ACL2-CRG" , "ACL2"),
    ("CLRHASH" , "ACL2-CRG" , "COMMON-LISP"),
    ("CODE-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("CODE-CHAR-CHAR-CODE-IS-IDENTITY" , "ACL2-CRG" , "ACL2"),
    ("CODE-CHAR-TYPE" , "ACL2-CRG" , "ACL2"),
    ("COERCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("COERCE-INVERSE-1" , "ACL2-CRG" , "ACL2"),
    ("COERCE-INVERSE-2" , "ACL2-CRG" , "ACL2"),
    ("COERCE-OBJECT-TO-STATE" , "ACL2-CRG" , "ACL2"),
    ("COERCE-STATE-TO-OBJECT" , "ACL2-CRG" , "ACL2"),
    ("COMMUTATIVITY-OF-*" , "ACL2-CRG" , "ACL2"),
    ("COMMUTATIVITY-OF-+" , "ACL2-CRG" , "ACL2"),
    ("COMP" , "ACL2-CRG" , "ACL2"),
    ("COMPILATION-SPEED" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPILE" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPILE-FILE" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPILE-FILE-PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPILED-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPILED-FUNCTION-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPILER-MACRO" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPILER-MACRO-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPLEMENT" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPLETION-OF-*" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-+" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-<" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-CAR" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-CDR" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-CHAR-CODE" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-CODE-CHAR" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-COERCE" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-COMPLEX" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-DENOMINATOR" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-IMAGPART" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-NUMERATOR" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-REALPART" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-NAME" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-SYMBOL-PACKAGE-NAME" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-UNARY-/" , "ACL2-CRG" , "ACL2"),
    ("COMPLETION-OF-UNARY-MINUS" , "ACL2-CRG" , "ACL2"),
    ("COMPLEX" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPLEX-0" , "ACL2-CRG" , "ACL2"),
    ("COMPLEX-DEFINITION" , "ACL2-CRG" , "ACL2"),
    ("COMPLEX-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("COMPLEX-IMPLIES1" , "ACL2-CRG" , "ACL2"),
    ("COMPLEX-RATIONALP" , "ACL2-CRG" , "ACL2"),
    ("COMPLEXP" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPRESS1" , "ACL2-CRG" , "ACL2"),
    ("COMPRESS11" , "ACL2-CRG" , "ACL2"),
    ("COMPRESS2" , "ACL2-CRG" , "ACL2"),
    ("COMPRESS21" , "ACL2-CRG" , "ACL2"),
    ("COMPRESS211" , "ACL2-CRG" , "ACL2"),
    ("COMPUTE-APPLICABLE-METHODS" , "ACL2-CRG" , "COMMON-LISP"),
    ("COMPUTE-RESTARTS" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONCATENATE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONCATENATED-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONCATENATED-STREAM-STREAMS" , "ACL2-CRG" , "COMMON-LISP"),
    ("COND" , "ACL2-CRG" , "COMMON-LISP"),
    ("COND-CLAUSESP" , "ACL2-CRG" , "ACL2"),
    ("COND-MACRO" , "ACL2-CRG" , "ACL2"),
    ("CONDITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONJUGATE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONS" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONS-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("CONS-SUBTREES" , "ACL2-CRG" , "ACL2"),
    ("CONSP" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONSP-ASSOC" , "ACL2-CRG" , "ACL2"),
    ("CONSP-ASSOC-EQ" , "ACL2-CRG" , "ACL2"),
    ("CONSTANTLY" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONSTANTP" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONTINUE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CONTROL-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-ALIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-PPRINT-DISPATCH" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-READTABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-SEQ" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-STRUCTURE" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-SYMBOL" , "ACL2-CRG" , "COMMON-LISP"),
    ("COPY-TREE" , "ACL2-CRG" , "COMMON-LISP"),
    ("COS" , "ACL2-CRG" , "COMMON-LISP"),
    ("COSH" , "ACL2-CRG" , "COMMON-LISP"),
    ("COUNT" , "ACL2-CRG" , "COMMON-LISP"),
    ("COUNT-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("COUNT-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("CTYPECASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("CURRENT-PACKAGE" , "ACL2-CRG" , "ACL2"),
    ("CURRENT-THEORY" , "ACL2-CRG" , "ACL2"),
    ("CW" , "ACL2-CRG" , "ACL2"),
    ("CW-GSTACK" , "ACL2-CRG" , "ACL2"),
    ("DEBUG" , "ACL2-CRG" , "COMMON-LISP"),
    ("DECF" , "ACL2-CRG" , "COMMON-LISP"),
    ("DECLAIM" , "ACL2-CRG" , "COMMON-LISP"),
    ("DECLARATION" , "ACL2-CRG" , "COMMON-LISP"),
    ("DECLARE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DECODE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("DECODE-UNIVERSAL-TIME" , "ACL2-CRG" , "COMMON-LISP"),
    ("DECREMENT-BIG-CLOCK" , "ACL2-CRG" , "ACL2"),
    ("DEFABBREV" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-*-1" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-*-2" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-+-1" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-+-2" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-<-1" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-<-2" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-CAR" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-CDR" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-CHAR-CODE" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-COERCE-1" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-COERCE-2" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-COERCE-3" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-COMPILE-FNS" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-COMPLEX-1" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-COMPLEX-2" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-DEFUN-MODE" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-DEFUN-MODE-FROM-STATE" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-DENOMINATOR" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-IMAGPART" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-MEASURE-FUNCTION" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-NUMERATOR" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-REALPART" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-SYMBOL-NAME" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-SYMBOL-PACKAGE-NAME" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-UNARY-/" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-UNARY-MINUS" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-VERIFY-GUARDS-EAGERNESS" , "ACL2-CRG" , "ACL2"),
    ("DEFAULT-WELL-FOUNDED-RELATION" , "ACL2-CRG" , "ACL2"),
    ("DEFAXIOM" , "ACL2-CRG" , "ACL2"),
    ("DEFCHOOSE" , "ACL2-CRG" , "ACL2"),
    ("DEFCLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFCONG" , "ACL2-CRG" , "ACL2"),
    ("DEFCONST" , "ACL2-CRG" , "ACL2"),
    ("DEFCONSTANT" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFDOC" , "ACL2-CRG" , "ACL2"),
    ("DEFEQUIV" , "ACL2-CRG" , "ACL2"),
    ("DEFEVALUATOR" , "ACL2-CRG" , "ACL2"),
    ("DEFEXEC" , "ACL2-CRG" , "ACL2"),
    ("DEFGENERIC" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFINE-COMPILER-MACRO" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFINE-CONDITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFINE-METHOD-COMBINATION" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFINE-MODIFY-MACRO" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFINE-PC-ATOMIC-MACRO" , "ACL2-CRG" , "ACL2"),
    ("DEFINE-PC-HELP" , "ACL2-CRG" , "ACL2"),
    ("DEFINE-PC-MACRO" , "ACL2-CRG" , "ACL2"),
    ("DEFINE-SETF-EXPANDER" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFINE-SYMBOL-MACRO" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFLABEL" , "ACL2-CRG" , "ACL2"),
    ("DEFMACRO" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFMETHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFPACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFPARAMETER" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFPKG" , "ACL2-CRG" , "ACL2"),
    ("DEFREFINEMENT" , "ACL2-CRG" , "ACL2"),
    ("DEFSETF" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFSTOBJ" , "ACL2-CRG" , "ACL2"),
    ("DEFSTRUCT" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFSTUB" , "ACL2-CRG" , "ACL2"),
    ("DEFTHEORY" , "ACL2-CRG" , "ACL2"),
    ("DEFTHM" , "ACL2-CRG" , "ACL2"),
    ("DEFTHMD" , "ACL2-CRG" , "ACL2"),
    ("DEFTTAG" , "ACL2-CRG" , "ACL2"),
    ("DEFTYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFUN" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEFUN-NX" , "ACL2-CRG" , "ACL2"),
    ("DEFUN-SK" , "ACL2-CRG" , "ACL2"),
    ("DEFUND" , "ACL2-CRG" , "ACL2"),
    ("DEFUND-NX" , "ACL2-CRG" , "ACL2"),
    ("DEFUNS" , "ACL2-CRG" , "ACL2"),
    ("DEFVAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("DELETE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DELETE-DUPLICATES" , "ACL2-CRG" , "COMMON-LISP"),
    ("DELETE-FILE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DELETE-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("DELETE-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("DELETE-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DELETE-PAIR" , "ACL2-CRG" , "ACL2"),
    ("DENOMINATOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("DEPOSIT-FIELD" , "ACL2-CRG" , "COMMON-LISP"),
    ("DESCRIBE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DESCRIBE-OBJECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("DESTRUCTURING-BIND" , "ACL2-CRG" , "COMMON-LISP"),
    ("DIGIT-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("DIGIT-CHAR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("DIGIT-TO-CHAR" , "ACL2-CRG" , "ACL2"),
    ("DIMENSIONS" , "ACL2-CRG" , "ACL2"),
    ("DIRECTORY" , "ACL2-CRG" , "COMMON-LISP"),
    ("DIRECTORY-NAMESTRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("DISABLE" , "ACL2-CRG" , "ACL2"),
    ("DISABLE-FORCING" , "ACL2-CRG" , "ACL2"),
    ("DISABLEDP" , "ACL2-CRG" , "ACL2"),
    ("DISASSEMBLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DISTRIBUTIVITY" , "ACL2-CRG" , "ACL2"),
    ("DIVISION-BY-ZERO" , "ACL2-CRG" , "COMMON-LISP"),
    ("DO" , "ACL2-CRG" , "COMMON-LISP"),
    ("DO*" , "ACL2-CRG" , "COMMON-LISP"),
    ("DO-ALL-SYMBOLS" , "ACL2-CRG" , "COMMON-LISP"),
    ("DO-EXTERNAL-SYMBOLS" , "ACL2-CRG" , "COMMON-LISP"),
    ("DO-SYMBOLS" , "ACL2-CRG" , "COMMON-LISP"),
    ("DOC" , "ACL2-CRG" , "ACL2"),
    ("DOC!" , "ACL2-CRG" , "ACL2"),
    ("DOCS" , "ACL2-CRG" , "ACL2"),
    ("DOCUMENTATION" , "ACL2-CRG" , "COMMON-LISP"),
    ("DOLIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("DOTIMES" , "ACL2-CRG" , "COMMON-LISP"),
    ("DOUBLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("DOUBLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("DOUBLE-REWRITE" , "ACL2-CRG" , "ACL2"),
    ("DPB" , "ACL2-CRG" , "COMMON-LISP"),
    ("DRIBBLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("DUPLICATES" , "ACL2-CRG" , "ACL2"),
    ("DYNAMIC-EXTENT" , "ACL2-CRG" , "COMMON-LISP"),
    ("E/D" , "ACL2-CRG" , "ACL2"),
    ("E0-ORD-<" , "ACL2-CRG" , "ACL2"),
    ("E0-ORDINALP" , "ACL2-CRG" , "ACL2"),
    ("EC-CALL" , "ACL2-CRG" , "ACL2"),
    ("ECASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("ECHO-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("ECHO-STREAM-INPUT-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("ECHO-STREAM-OUTPUT-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("ED" , "ACL2-CRG" , "COMMON-LISP"),
    ("EIGHTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("ELIMINATE-DESTRUCTORS" , "ACL2-CRG" , "ACL2"),
    ("ELIMINATE-IRRELEVANCE" , "ACL2-CRG" , "ACL2"),
    ("ELT" , "ACL2-CRG" , "COMMON-LISP"),
    ("ENABLE" , "ACL2-CRG" , "ACL2"),
    ("ENABLE-FORCING" , "ACL2-CRG" , "ACL2"),
    ("ENCAPSULATE" , "ACL2-CRG" , "ACL2"),
    ("ENCODE-UNIVERSAL-TIME" , "ACL2-CRG" , "COMMON-LISP"),
    ("END-OF-FILE" , "ACL2-CRG" , "COMMON-LISP"),
    ("ENDP" , "ACL2-CRG" , "COMMON-LISP"),
    ("ENOUGH-NAMESTRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("ENSURE-DIRECTORIES-EXIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("ENSURE-GENERIC-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("EQ" , "ACL2-CRG" , "COMMON-LISP"),
    ("EQL" , "ACL2-CRG" , "COMMON-LISP"),
    ("EQLABLE-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("EQLABLE-ALISTP-FORWARD-TO-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("EQLABLE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("EQLABLE-LISTP-FORWARD-TO-ATOM-LISTP" , "ACL2-CRG" , "ACL2"),
    ("EQLABLEP" , "ACL2-CRG" , "ACL2"),
    ("EQLABLEP-RECOG" , "ACL2-CRG" , "ACL2"),
    ("EQUAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("EQUAL-CHAR-CODE" , "ACL2-CRG" , "ACL2"),
    ("EQUALP" , "ACL2-CRG" , "COMMON-LISP"),
    ("ER" , "ACL2-CRG" , "ACL2"),
    ("ER-PROGN" , "ACL2-CRG" , "ACL2"),
    ("ER-PROGN-FN" , "ACL2-CRG" , "ACL2"),
    ("ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("ETYPECASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("EVAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("EVAL-WHEN" , "ACL2-CRG" , "COMMON-LISP"),
    ("EVENP" , "ACL2-CRG" , "COMMON-LISP"),
    ("EVENS" , "ACL2-CRG" , "ACL2"),
    ("EVENT" , "ACL2-CRG" , "ACL2"),
    ("EVERY" , "ACL2-CRG" , "COMMON-LISP"),
    ("EXECUTABLE-COUNTERPART-THEORY" , "ACL2-CRG" , "ACL2"),
    ("EXP" , "ACL2-CRG" , "COMMON-LISP"),
    ("EXPLODE-ATOM" , "ACL2-CRG" , "ACL2"),
    ("EXPLODE-NONNEGATIVE-INTEGER" , "ACL2-CRG" , "ACL2"),
    ("EXPORT" , "ACL2-CRG" , "COMMON-LISP"),
    ("EXPT" , "ACL2-CRG" , "COMMON-LISP"),
    ("EXPT-TYPE-PRESCRIPTION-NON-ZERO-BASE" , "ACL2-CRG" , "ACL2"),
    ("EXTEND-32-BIT-INTEGER-STACK" , "ACL2-CRG" , "ACL2"),
    ("EXTEND-T-STACK" , "ACL2-CRG" , "ACL2"),
    ("EXTEND-WORLD" , "ACL2-CRG" , "ACL2"),
    ("EXTENDED-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("EXTRA-INFO" , "ACL2-CRG" , "ACL2"),
    ("FAST-ALIST-FREE" , "ACL2-CRG" , "ACL2"),
    ("FAST-ALIST-LEN" , "ACL2-CRG" , "ACL2"),
    ("FAST-ALIST-SUMMARY" , "ACL2-CRG" , "ACL2"),
    ("FBOUNDP" , "ACL2-CRG" , "COMMON-LISP"),
    ("FCEILING" , "ACL2-CRG" , "COMMON-LISP"),
    ("FDEFINITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("FERTILIZE" , "ACL2-CRG" , "ACL2"),
    ("FFLOOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("FGETPROP" , "ACL2-CRG" , "ACL2"),
    ("FIFTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-AUTHOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-CLOCK" , "ACL2-CRG" , "ACL2"),
    ("FILE-CLOCK-P" , "ACL2-CRG" , "ACL2"),
    ("FILE-CLOCK-P-FORWARD-TO-INTEGERP" , "ACL2-CRG" , "ACL2"),
    ("FILE-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-ERROR-PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-LENGTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-NAMESTRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-POSITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-STRING-LENGTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILE-WRITE-DATE" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILL" , "ACL2-CRG" , "COMMON-LISP"),
    ("FILL-POINTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-ALL-SYMBOLS" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-RESTART" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIND-SYMBOL" , "ACL2-CRG" , "COMMON-LISP"),
    ("FINISH-OUTPUT" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIRST" , "ACL2-CRG" , "COMMON-LISP"),
    ("FIRST-N-AC" , "ACL2-CRG" , "ACL2"),
    ("FIX" , "ACL2-CRG" , "ACL2"),
    ("FIX-TRUE-LIST" , "ACL2-CRG" , "ACL2"),
    ("FIXNUM" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLET" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOAT-DIGITS" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOAT-PRECISION" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOAT-RADIX" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOAT-SIGN" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOATING-POINT-INEXACT" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOATING-POINT-INVALID-OPERATION" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOATING-POINT-OVERFLOW" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOATING-POINT-UNDERFLOW" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOATP" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLOOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("FLUSH-HONS-GET-HASH-TABLE-LINK" , "ACL2-CRG" , "ACL2"),
    ("FMAKUNBOUND" , "ACL2-CRG" , "COMMON-LISP"),
    ("FMS" , "ACL2-CRG" , "ACL2"),
    ("FMT" , "ACL2-CRG" , "ACL2"),
    ("FMT-TO-COMMENT-WINDOW" , "ACL2-CRG" , "ACL2"),
    ("FMT1" , "ACL2-CRG" , "ACL2"),
    ("FORCE" , "ACL2-CRG" , "ACL2"),
    ("FORCE-OUTPUT" , "ACL2-CRG" , "COMMON-LISP"),
    ("FORMAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("FORMATTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("FOURTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("FRESH-LINE" , "ACL2-CRG" , "COMMON-LISP"),
    ("FROUND" , "ACL2-CRG" , "COMMON-LISP"),
    ("FTRUNCATE" , "ACL2-CRG" , "COMMON-LISP"),
    ("FTYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("FUNCALL" , "ACL2-CRG" , "COMMON-LISP"),
    ("FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("FUNCTION-KEYWORDS" , "ACL2-CRG" , "COMMON-LISP"),
    ("FUNCTION-LAMBDA-EXPRESSION" , "ACL2-CRG" , "COMMON-LISP"),
    ("FUNCTION-SYMBOLP" , "ACL2-CRG" , "ACL2"),
    ("FUNCTION-THEORY" , "ACL2-CRG" , "ACL2"),
    ("FUNCTIONP" , "ACL2-CRG" , "COMMON-LISP"),
    ("GCD" , "ACL2-CRG" , "COMMON-LISP"),
    ("GENERALIZE" , "ACL2-CRG" , "ACL2"),
    ("GENERIC-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("GENSYM" , "ACL2-CRG" , "COMMON-LISP"),
    ("GENTEMP" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-DECODED-TIME" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-DISPATCH-MACRO-CHARACTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-GLOBAL" , "ACL2-CRG" , "ACL2"),
    ("GET-INTERNAL-REAL-TIME" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-INTERNAL-RUN-TIME" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-MACRO-CHARACTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-OUTPUT-STREAM-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-PROPERTIES" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-SETF-EXPANSION" , "ACL2-CRG" , "COMMON-LISP"),
    ("GET-SLOW-ALIST-ACTION" , "ACL2-CRG" , "ACL2"),
    ("GET-TIMER" , "ACL2-CRG" , "ACL2"),
    ("GET-UNIVERSAL-TIME" , "ACL2-CRG" , "COMMON-LISP"),
    ("GETF" , "ACL2-CRG" , "COMMON-LISP"),
    ("GETHASH" , "ACL2-CRG" , "COMMON-LISP"),
    ("GETPROP-DEFAULT" , "ACL2-CRG" , "ACL2"),
    ("GETPROPS" , "ACL2-CRG" , "ACL2"),
    ("GETPROPS1" , "ACL2-CRG" , "ACL2"),
    ("GLOBAL-TABLE" , "ACL2-CRG" , "ACL2"),
    ("GLOBAL-TABLE-CARS" , "ACL2-CRG" , "ACL2"),
    ("GLOBAL-TABLE-CARS1" , "ACL2-CRG" , "ACL2"),
    ("GLOBAL-VAL" , "ACL2-CRG" , "ACL2"),
    ("GO" , "ACL2-CRG" , "COMMON-LISP"),
    ("GOOD-BYE" , "ACL2-CRG" , "ACL2"),
    ("GRANULARITY" , "ACL2-CRG" , "ACL2"),
    ("GRAPHIC-CHAR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("GROUND-ZERO" , "ACL2-CRG" , "ACL2"),
    ("HANDLER-BIND" , "ACL2-CRG" , "COMMON-LISP"),
    ("HANDLER-CASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("HARD-ERROR" , "ACL2-CRG" , "ACL2"),
    ("HAS-PROPSP" , "ACL2-CRG" , "ACL2"),
    ("HAS-PROPSP1" , "ACL2-CRG" , "ACL2"),
    ("HASH-TABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("HASH-TABLE-COUNT" , "ACL2-CRG" , "COMMON-LISP"),
    ("HASH-TABLE-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-SIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("HASH-TABLE-REHASH-THRESHOLD" , "ACL2-CRG" , "COMMON-LISP"),
    ("HASH-TABLE-SIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("HASH-TABLE-TEST" , "ACL2-CRG" , "COMMON-LISP"),
    ("HEADER" , "ACL2-CRG" , "ACL2"),
    ("HELP" , "ACL2-CRG" , "ACL2"),
    ("HIDE" , "ACL2-CRG" , "ACL2"),
    ("HONS" , "ACL2-CRG" , "ACL2"),
    ("HONS-ACONS" , "ACL2-CRG" , "ACL2"),
    ("HONS-ACONS!" , "ACL2-CRG" , "ACL2"),
    ("HONS-CLEAR" , "ACL2-CRG" , "ACL2"),
    ("HONS-COPY" , "ACL2-CRG" , "ACL2"),
    ("HONS-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("HONS-EQUAL-LITE" , "ACL2-CRG" , "ACL2"),
    ("HONS-GET" , "ACL2-CRG" , "ACL2"),
    ("HONS-RESIZE" , "ACL2-CRG" , "ACL2"),
    ("HONS-RESIZE-FN" , "ACL2-CRG" , "ACL2"),
    ("HONS-SHRINK-ALIST" , "ACL2-CRG" , "ACL2"),
    ("HONS-SHRINK-ALIST!" , "ACL2-CRG" , "ACL2"),
    ("HONS-SUMMARY" , "ACL2-CRG" , "ACL2"),
    ("HONS-WASH" , "ACL2-CRG" , "ACL2"),
    ("HOST-NAMESTRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("I-AM-HERE" , "ACL2-CRG" , "ACL2"),
    ("ID" , "ACL2-CRG" , "ACL2"),
    ("IDATES" , "ACL2-CRG" , "ACL2"),
    ("IDENTITY" , "ACL2-CRG" , "COMMON-LISP"),
    ("IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("IF*" , "ACL2-CRG" , "ACL2"),
    ("IFF" , "ACL2-CRG" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-1" , "ACL2-CRG" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-IMPLIES-2" , "ACL2-CRG" , "ACL2"),
    ("IFF-IMPLIES-EQUAL-NOT" , "ACL2-CRG" , "ACL2"),
    ("IFF-IS-AN-EQUIVALENCE" , "ACL2-CRG" , "ACL2"),
    ("IFIX" , "ACL2-CRG" , "ACL2"),
    ("IGNORABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("IGNORE" , "ACL2-CRG" , "COMMON-LISP"),
    ("IGNORE-ERRORS" , "ACL2-CRG" , "COMMON-LISP"),
    ("ILLEGAL" , "ACL2-CRG" , "ACL2"),
    ("IMAGPART" , "ACL2-CRG" , "COMMON-LISP"),
    ("IMAGPART-COMPLEX" , "ACL2-CRG" , "ACL2"),
    ("IMMEDIATE-FORCE-MODEP" , "ACL2-CRG" , "ACL2"),
    ("IMPLIES" , "ACL2-CRG" , "ACL2"),
    ("IMPORT" , "ACL2-CRG" , "COMMON-LISP"),
    ("IMPROPER-CONSP" , "ACL2-CRG" , "ACL2"),
    ("IN-ARITHMETIC-THEORY" , "ACL2-CRG" , "ACL2"),
    ("IN-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("IN-THEORY" , "ACL2-CRG" , "ACL2"),
    ("INCF" , "ACL2-CRG" , "COMMON-LISP"),
    ("INCLUDE-BOOK" , "ACL2-CRG" , "ACL2"),
    ("INCOMPATIBLE" , "ACL2-CRG" , "ACL2"),
    ("INCREMENT-TIMER" , "ACL2-CRG" , "ACL2"),
    ("INDUCT" , "ACL2-CRG" , "ACL2"),
    ("INITIALIZE-INSTANCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("INLINE" , "ACL2-CRG" , "COMMON-LISP"),
    ("INPUT-STREAM-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("INSPECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("INT=" , "ACL2-CRG" , "ACL2"),
    ("INTEGER" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTEGER-0" , "ACL2-CRG" , "ACL2"),
    ("INTEGER-1" , "ACL2-CRG" , "ACL2"),
    ("INTEGER-ABS" , "ACL2-CRG" , "ACL2"),
    ("INTEGER-DECODE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTEGER-IMPLIES-RATIONAL" , "ACL2-CRG" , "ACL2"),
    ("INTEGER-LENGTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTEGER-LISTP" , "ACL2-CRG" , "ACL2"),
    ("INTEGER-LISTP-FORWARD-TO-RATIONAL-LISTP" , "ACL2-CRG" , "ACL2"),
    ("INTEGER-STEP" , "ACL2-CRG" , "ACL2"),
    ("INTEGERP" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTERACTIVE-STREAM-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTERN" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTERN$" , "ACL2-CRG" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-CRG" , "ACL2"),
    ("INTERN-IN-PACKAGE-OF-SYMBOL-SYMBOL-NAME" , "ACL2-CRG" , "ACL2"),
    ("INTERNAL-TIME-UNITS-PER-SECOND" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTERSECTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("INTERSECTION-EQ" , "ACL2-CRG" , "ACL2"),
    ("INTERSECTION-THEORIES" , "ACL2-CRG" , "ACL2"),
    ("INTERSECTP-EQ" , "ACL2-CRG" , "ACL2"),
    ("INTERSECTP-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("INVALID-METHOD-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("INVERSE-OF-*" , "ACL2-CRG" , "ACL2"),
    ("INVERSE-OF-+" , "ACL2-CRG" , "ACL2"),
    ("INVISIBLE-FNS-TABLE" , "ACL2-CRG" , "ACL2"),
    ("INVOKE-DEBUGGER" , "ACL2-CRG" , "COMMON-LISP"),
    ("INVOKE-RESTART" , "ACL2-CRG" , "COMMON-LISP"),
    ("INVOKE-RESTART-INTERACTIVELY" , "ACL2-CRG" , "COMMON-LISP"),
    ("ISQRT" , "ACL2-CRG" , "COMMON-LISP"),
    ("KEYWORD" , "ACL2-CRG" , "COMMON-LISP"),
    ("KEYWORD-PACKAGE" , "ACL2-CRG" , "ACL2"),
    ("KEYWORD-VALUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-ASSOC-KEYWORD" , "ACL2-CRG" , "ACL2"),
    ("KEYWORD-VALUE-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("KEYWORDP" , "ACL2-CRG" , "COMMON-LISP"),
    ("KEYWORDP-FORWARD-TO-SYMBOLP" , "ACL2-CRG" , "ACL2"),
    ("KNOWN-PACKAGE-ALIST" , "ACL2-CRG" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("KNOWN-PACKAGE-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-CRG" , "ACL2"),
    ("LABELS" , "ACL2-CRG" , "COMMON-LISP"),
    ("LAMBDA" , "ACL2-CRG" , "COMMON-LISP"),
    ("LAMBDA-LIST-KEYWORDS" , "ACL2-CRG" , "COMMON-LISP"),
    ("LAMBDA-PARAMETERS-LIMIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LAST" , "ACL2-CRG" , "COMMON-LISP"),
    ("LCM" , "ACL2-CRG" , "COMMON-LISP"),
    ("LD" , "ACL2-CRG" , "ACL2"),
    ("LD-ERROR-ACTION" , "ACL2-CRG" , "ACL2"),
    ("LD-ERROR-TRIPLES" , "ACL2-CRG" , "ACL2"),
    ("LD-KEYWORD-ALIASES" , "ACL2-CRG" , "ACL2"),
    ("LD-POST-EVAL-PRINT" , "ACL2-CRG" , "ACL2"),
    ("LD-PRE-EVAL-FILTER" , "ACL2-CRG" , "ACL2"),
    ("LD-PRE-EVAL-PRINT" , "ACL2-CRG" , "ACL2"),
    ("LD-PROMPT" , "ACL2-CRG" , "ACL2"),
    ("LD-QUERY-CONTROL-ALIST" , "ACL2-CRG" , "ACL2"),
    ("LD-REDEFINITION-ACTION" , "ACL2-CRG" , "ACL2"),
    ("LD-SKIP-PROOFSP" , "ACL2-CRG" , "ACL2"),
    ("LD-VERBOSE" , "ACL2-CRG" , "ACL2"),
    ("LDB" , "ACL2-CRG" , "COMMON-LISP"),
    ("LDB-TEST" , "ACL2-CRG" , "COMMON-LISP"),
    ("LDIFF" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-LONG-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-LONG-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SHORT-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-NEGATIVE-SINGLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-DOUBLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-LONG-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-DOUBLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-LONG-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SHORT-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-NORMALIZED-SINGLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SHORT-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEAST-POSITIVE-SINGLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LEGAL-CASE-CLAUSESP" , "ACL2-CRG" , "ACL2"),
    ("LEN" , "ACL2-CRG" , "ACL2"),
    ("LEN-UPDATE-NTH" , "ACL2-CRG" , "ACL2"),
    ("LENGTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("LET" , "ACL2-CRG" , "COMMON-LISP"),
    ("LET*" , "ACL2-CRG" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("LISP-IMPLEMENTATION-VERSION" , "ACL2-CRG" , "COMMON-LISP"),
    ("LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("LIST*" , "ACL2-CRG" , "COMMON-LISP"),
    ("LIST*-MACRO" , "ACL2-CRG" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES" , "ACL2-CRG" , "ACL2"),
    ("LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-CRG" , "ACL2"),
    ("LIST-ALL-PACKAGES" , "ACL2-CRG" , "COMMON-LISP"),
    ("LIST-LENGTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("LIST-MACRO" , "ACL2-CRG" , "ACL2"),
    ("LISTEN" , "ACL2-CRG" , "COMMON-LISP"),
    ("LISTP" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOAD" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOAD-LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOAD-TIME-VALUE" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOCAL" , "ACL2-CRG" , "ACL2"),
    ("LOCALLY" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOG" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGAND" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGANDC1" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGANDC2" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGBITP" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGCOUNT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGEQV" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGIC" , "ACL2-CRG" , "ACL2"),
    ("LOGICAL-PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGICAL-PATHNAME-TRANSLATIONS" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGIOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGNAND" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGNOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGNOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGORC1" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGORC2" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGTEST" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOGXOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("LONG-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("LONG-FLOAT-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("LONG-FLOAT-NEGATIVE-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("LONG-SITE-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOOP" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOOP-FINISH" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOWER-CASE-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("LOWER-CASE-P-CHAR-DOWNCASE" , "ACL2-CRG" , "ACL2"),
    ("LOWER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-CRG" , "ACL2"),
    ("LOWEST-TERMS" , "ACL2-CRG" , "ACL2"),
    ("LP" , "ACL2-CRG" , "ACL2"),
    ("MACHINE-INSTANCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MACHINE-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MACHINE-VERSION" , "ACL2-CRG" , "COMMON-LISP"),
    ("MACRO-ALIASES" , "ACL2-CRG" , "ACL2"),
    ("MACRO-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("MACROEXPAND" , "ACL2-CRG" , "COMMON-LISP"),
    ("MACROEXPAND-1" , "ACL2-CRG" , "COMMON-LISP"),
    ("MACROLET" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAIN-TIMER" , "ACL2-CRG" , "ACL2"),
    ("MAIN-TIMER-TYPE-PRESCRIPTION" , "ACL2-CRG" , "ACL2"),
    ("MAKE-ARRAY" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-BROADCAST-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-CHARACTER-LIST" , "ACL2-CRG" , "ACL2"),
    ("MAKE-CHARACTER-LIST-MAKE-CHARACTER-LIST" , "ACL2-CRG" , "ACL2"),
    ("MAKE-CONCATENATED-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-CONDITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-DISPATCH-MACRO-CHARACTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-ECHO-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-EVENT" , "ACL2-CRG" , "ACL2"),
    ("MAKE-FMT-BINDINGS" , "ACL2-CRG" , "ACL2"),
    ("MAKE-HASH-TABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-INPUT-CHANNEL" , "ACL2-CRG" , "ACL2"),
    ("MAKE-INSTANCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-INSTANCES-OBSOLETE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-LIST-AC" , "ACL2-CRG" , "ACL2"),
    ("MAKE-LOAD-FORM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-LOAD-FORM-SAVING-SLOTS" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-MV-NTHS" , "ACL2-CRG" , "ACL2"),
    ("MAKE-ORD" , "ACL2-CRG" , "ACL2"),
    ("MAKE-OUTPUT-CHANNEL" , "ACL2-CRG" , "ACL2"),
    ("MAKE-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-RANDOM-STATE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-SEQUENCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-STRING-INPUT-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-STRING-OUTPUT-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-SYMBOL" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-SYNONYM-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-TWO-WAY-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKE-VAR-LST" , "ACL2-CRG" , "ACL2"),
    ("MAKE-VAR-LST1" , "ACL2-CRG" , "ACL2"),
    ("MAKUNBOUND" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAKUNBOUND-GLOBAL" , "ACL2-CRG" , "ACL2"),
    ("MAP" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAP-INTO" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAPC" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAPCAN" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAPCAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAPCON" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAPHASH" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAPL" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAPLIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("MASK-FIELD" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAX" , "ACL2-CRG" , "COMMON-LISP"),
    ("MAXIMUM-LENGTH" , "ACL2-CRG" , "ACL2"),
    ("MAY-NEED-SLASHES" , "ACL2-CRG" , "ACL2"),
    ("MBE" , "ACL2-CRG" , "ACL2"),
    ("MBT" , "ACL2-CRG" , "ACL2"),
    ("MEMBER" , "ACL2-CRG" , "COMMON-LISP"),
    ("MEMBER-EQ" , "ACL2-CRG" , "ACL2"),
    ("MEMBER-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("MEMBER-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("MEMBER-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MEMBER-SYMBOL-NAME" , "ACL2-CRG" , "ACL2"),
    ("MEMOIZE" , "ACL2-CRG" , "ACL2"),
    ("MEMOIZE-LET" , "ACL2-CRG" , "ACL2"),
    ("MEMOIZE-OFF" , "ACL2-CRG" , "ACL2"),
    ("MEMOIZE-ON" , "ACL2-CRG" , "ACL2"),
    ("MERGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("MERGE-PATHNAMES" , "ACL2-CRG" , "COMMON-LISP"),
    ("METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("METHOD-COMBINATION" , "ACL2-CRG" , "COMMON-LISP"),
    ("METHOD-COMBINATION-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("METHOD-QUALIFIERS" , "ACL2-CRG" , "COMMON-LISP"),
    ("MFC" , "ACL2-CRG" , "ACL2"),
    ("MIN" , "ACL2-CRG" , "COMMON-LISP"),
    ("MINIMAL-THEORY" , "ACL2-CRG" , "ACL2"),
    ("MINUSP" , "ACL2-CRG" , "COMMON-LISP"),
    ("MISMATCH" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("MONITOR" , "ACL2-CRG" , "ACL2"),
    ("MONITORED-RUNES" , "ACL2-CRG" , "ACL2"),
    ("MORE" , "ACL2-CRG" , "ACL2"),
    ("MORE!" , "ACL2-CRG" , "ACL2"),
    ("MORE-DOC" , "ACL2-CRG" , "ACL2"),
    ("MOST-NEGATIVE-DOUBLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-FIXNUM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-LONG-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SHORT-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-NEGATIVE-SINGLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-POSITIVE-DOUBLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-POSITIVE-FIXNUM" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-POSITIVE-LONG-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-POSITIVE-SHORT-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MOST-POSITIVE-SINGLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MUFFLE-WARNING" , "ACL2-CRG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-BIND" , "ACL2-CRG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-CALL" , "ACL2-CRG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-PROG1" , "ACL2-CRG" , "COMMON-LISP"),
    ("MULTIPLE-VALUE-SETQ" , "ACL2-CRG" , "COMMON-LISP"),
    ("MULTIPLE-VALUES-LIMIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("MUTUAL-RECURSION" , "ACL2-CRG" , "ACL2"),
    ("MUTUAL-RECURSION-GUARDP" , "ACL2-CRG" , "ACL2"),
    ("MV" , "ACL2-CRG" , "ACL2"),
    ("MV-LET" , "ACL2-CRG" , "ACL2"),
    ("MV-LIST" , "ACL2-CRG" , "ACL2"),
    ("MV-NTH" , "ACL2-CRG" , "ACL2"),
    ("NAME-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("NAMESTRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("NATP" , "ACL2-CRG" , "ACL2"),
    ("NBUTLAST" , "ACL2-CRG" , "COMMON-LISP"),
    ("NCONC" , "ACL2-CRG" , "COMMON-LISP"),
    ("NEEDS-SLASHES" , "ACL2-CRG" , "ACL2"),
    ("NEWLINE" , "ACL2-CRG" , "ACL2"),
    ("NEXT-METHOD-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("NFIX" , "ACL2-CRG" , "ACL2"),
    ("NIL" , "ACL2-CRG" , "COMMON-LISP"),
    ("NIL-IS-NOT-CIRCULAR" , "ACL2-CRG" , "ACL2"),
    ("NINTERSECTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("NINTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("NO-APPLICABLE-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("NO-DUPLICATESP" , "ACL2-CRG" , "ACL2"),
    ("NO-DUPLICATESP-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("NO-NEXT-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("NONNEGATIVE-INTEGER-QUOTIENT" , "ACL2-CRG" , "ACL2"),
    ("NONNEGATIVE-PRODUCT" , "ACL2-CRG" , "ACL2"),
    ("NONZERO-IMAGPART" , "ACL2-CRG" , "ACL2"),
    ("NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("NOTANY" , "ACL2-CRG" , "COMMON-LISP"),
    ("NOTEVERY" , "ACL2-CRG" , "COMMON-LISP"),
    ("NOTINLINE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NQTHM-TO-ACL2" , "ACL2-CRG" , "ACL2"),
    ("NRECONC" , "ACL2-CRG" , "COMMON-LISP"),
    ("NREVERSE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSET-DIFFERENCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSET-EXCLUSIVE-OR" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSTRING-CAPITALIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSTRING-DOWNCASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSTRING-UPCASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSUBLIS" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSUBST" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSUBST-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSUBST-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSUBSTITUTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("NSUBSTITUTE-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("NTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("NTH-0-CONS" , "ACL2-CRG" , "ACL2"),
    ("NTH-0-READ-RUN-TIME-TYPE-PRESCRIPTION" , "ACL2-CRG" , "ACL2"),
    ("NTH-ADD1" , "ACL2-CRG" , "ACL2"),
    ("NTH-ALIASES" , "ACL2-CRG" , "ACL2"),
    ("NTH-UPDATE-NTH" , "ACL2-CRG" , "ACL2"),
    ("NTH-VALUE" , "ACL2-CRG" , "COMMON-LISP"),
    ("NTHCDR" , "ACL2-CRG" , "COMMON-LISP"),
    ("NULL" , "ACL2-CRG" , "COMMON-LISP"),
    ("NUMBER" , "ACL2-CRG" , "COMMON-LISP"),
    ("NUMBER-SUBTREES" , "ACL2-CRG" , "ACL2"),
    ("NUMBERP" , "ACL2-CRG" , "COMMON-LISP"),
    ("NUMERATOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("NUNION" , "ACL2-CRG" , "COMMON-LISP"),
    ("O-FINP" , "ACL2-CRG" , "ACL2"),
    ("O-FIRST-COEFF" , "ACL2-CRG" , "ACL2"),
    ("O-FIRST-EXPT" , "ACL2-CRG" , "ACL2"),
    ("O-INFP" , "ACL2-CRG" , "ACL2"),
    ("O-P" , "ACL2-CRG" , "ACL2"),
    ("O-RST" , "ACL2-CRG" , "ACL2"),
    ("O<" , "ACL2-CRG" , "ACL2"),
    ("O<=" , "ACL2-CRG" , "ACL2"),
    ("O>" , "ACL2-CRG" , "ACL2"),
    ("O>=" , "ACL2-CRG" , "ACL2"),
    ("OBSERVATION" , "ACL2-CRG" , "ACL2"),
    ("ODDP" , "ACL2-CRG" , "COMMON-LISP"),
    ("ODDS" , "ACL2-CRG" , "ACL2"),
    ("OK-IF" , "ACL2-CRG" , "ACL2"),
    ("OOPS" , "ACL2-CRG" , "ACL2"),
    ("OPEN" , "ACL2-CRG" , "COMMON-LISP"),
    ("OPEN-CHANNEL-LISTP" , "ACL2-CRG" , "ACL2"),
    ("OPEN-CHANNEL1" , "ACL2-CRG" , "ACL2"),
    ("OPEN-CHANNEL1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-CRG" ,
"ACL2"),
    ("OPEN-CHANNELS-P" , "ACL2-CRG" , "ACL2"),
    ("OPEN-CHANNELS-P-FORWARD" , "ACL2-CRG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL" , "ACL2-CRG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P" , "ACL2-CRG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-ANY-P1" , "ACL2-CRG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P" , "ACL2-CRG" , "ACL2"),
    ("OPEN-INPUT-CHANNEL-P1" , "ACL2-CRG" , "ACL2"),
    ("OPEN-INPUT-CHANNELS" , "ACL2-CRG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL" , "ACL2-CRG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL!" , "ACL2-CRG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P" , "ACL2-CRG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-ANY-P1" , "ACL2-CRG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P" , "ACL2-CRG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNEL-P1" , "ACL2-CRG" , "ACL2"),
    ("OPEN-OUTPUT-CHANNELS" , "ACL2-CRG" , "ACL2"),
    ("OPEN-STREAM-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("OPEN-TRACE-FILE" , "ACL2-CRG" , "ACL2"),
    ("OPTIMIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("OR" , "ACL2-CRG" , "COMMON-LISP"),
    ("OR-MACRO" , "ACL2-CRG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR" , "ACL2-CRG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-ADD-PAIR-FORWARD" , "ACL2-CRG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-FORWARD-TO-SYMBOL-ALISTP" , "ACL2-CRG"
, "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-GETPROPS" , "ACL2-CRG" , "ACL2"),
    ("ORDERED-SYMBOL-ALISTP-REMOVE-FIRST-PAIR" , "ACL2-CRG" , "ACL2"),
    ("OTHERWISE" , "ACL2-CRG" , "COMMON-LISP"),
    ("OUR-DIGIT-CHAR-P" , "ACL2-CRG" , "ACL2"),
    ("OUTPUT-STREAM-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE-ERROR-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE-NICKNAMES" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE-SHADOWING-SYMBOLS" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE-USE-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGE-USED-BY-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("PACKAGEP" , "ACL2-CRG" , "COMMON-LISP"),
    ("PAIRLIS" , "ACL2-CRG" , "COMMON-LISP"),
    ("PAIRLIS$" , "ACL2-CRG" , "ACL2"),
    ("PAIRLIS2" , "ACL2-CRG" , "ACL2"),
    ("PAND" , "ACL2-CRG" , "ACL2"),
    ("PARGS" , "ACL2-CRG" , "ACL2"),
    ("PARSE-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("PARSE-INTEGER" , "ACL2-CRG" , "COMMON-LISP"),
    ("PARSE-NAMESTRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME-DEVICE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME-DIRECTORY" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME-HOST" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME-MATCH-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAME-VERSION" , "ACL2-CRG" , "COMMON-LISP"),
    ("PATHNAMEP" , "ACL2-CRG" , "COMMON-LISP"),
    ("PBT" , "ACL2-CRG" , "ACL2"),
    ("PC" , "ACL2-CRG" , "ACL2"),
    ("PCB" , "ACL2-CRG" , "ACL2"),
    ("PCB!" , "ACL2-CRG" , "ACL2"),
    ("PCS" , "ACL2-CRG" , "ACL2"),
    ("PE" , "ACL2-CRG" , "ACL2"),
    ("PEEK-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("PEEK-CHAR$" , "ACL2-CRG" , "ACL2"),
    ("PF" , "ACL2-CRG" , "ACL2"),
    ("PHASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PI" , "ACL2-CRG" , "COMMON-LISP"),
    ("PL" , "ACL2-CRG" , "ACL2"),
    ("PLET" , "ACL2-CRG" , "ACL2"),
    ("PLIST-WORLDP" , "ACL2-CRG" , "ACL2"),
    ("PLIST-WORLDP-FORWARD-TO-ASSOC-EQ-EQUAL-ALISTP" , "ACL2-CRG" ,
"ACL2"),
    ("PLUSP" , "ACL2-CRG" , "COMMON-LISP"),
    ("POP" , "ACL2-CRG" , "COMMON-LISP"),
    ("POP-TIMER" , "ACL2-CRG" , "ACL2"),
    ("POR" , "ACL2-CRG" , "ACL2"),
    ("POSITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("POSITION-AC" , "ACL2-CRG" , "ACL2"),
    ("POSITION-EQ" , "ACL2-CRG" , "ACL2"),
    ("POSITION-EQ-AC" , "ACL2-CRG" , "ACL2"),
    ("POSITION-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("POSITION-EQUAL-AC" , "ACL2-CRG" , "ACL2"),
    ("POSITION-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("POSITION-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("POSITIVE" , "ACL2-CRG" , "ACL2"),
    ("POSP" , "ACL2-CRG" , "ACL2"),
    ("POWER-EVAL" , "ACL2-CRG" , "ACL2"),
    ("PPRINT" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-DISPATCH" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-EXIT-IF-LIST-EXHAUSTED" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-FILL" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-INDENT" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-LINEAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-LOGICAL-BLOCK" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-NEWLINE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-POP" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-TAB" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPRINT-TABULAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("PPROGN" , "ACL2-CRG" , "ACL2"),
    ("PR" , "ACL2-CRG" , "ACL2"),
    ("PR!" , "ACL2-CRG" , "ACL2"),
    ("PREPROCESS" , "ACL2-CRG" , "ACL2"),
    ("PRIN1" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRIN1$" , "ACL2-CRG" , "ACL2"),
    ("PRIN1-TO-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRIN1-WITH-SLASHES" , "ACL2-CRG" , "ACL2"),
    ("PRIN1-WITH-SLASHES1" , "ACL2-CRG" , "ACL2"),
    ("PRINC" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRINC$" , "ACL2-CRG" , "ACL2"),
    ("PRINC-TO-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRINT" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRINT-GV" , "ACL2-CRG" , "ACL2"),
    ("PRINT-NOT-READABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRINT-NOT-READABLE-OBJECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRINT-OBJECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("PRINT-OBJECT$" , "ACL2-CRG" , "ACL2"),
    ("PRINT-RATIONAL-AS-DECIMAL" , "ACL2-CRG" , "ACL2"),
    ("PRINT-TIMER" , "ACL2-CRG" , "ACL2"),
    ("PRINT-UNREADABLE-OBJECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROBE-FILE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROCLAIM" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROG" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROG*" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROG1" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROG2" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROG2$" , "ACL2-CRG" , "ACL2"),
    ("PROGN" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROGRAM" , "ACL2-CRG" , "ACL2"),
    ("PROGRAM-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROGV" , "ACL2-CRG" , "COMMON-LISP"),
    ("PROOF-TREE" , "ACL2-CRG" , "ACL2"),
    ("PROOFS-CO" , "ACL2-CRG" , "ACL2"),
    ("PROPER-CONSP" , "ACL2-CRG" , "ACL2"),
    ("PROPS" , "ACL2-CRG" , "ACL2"),
    ("PROVE" , "ACL2-CRG" , "ACL2"),
    ("PROVIDE" , "ACL2-CRG" , "COMMON-LISP"),
    ("PSETF" , "ACL2-CRG" , "COMMON-LISP"),
    ("PSETQ" , "ACL2-CRG" , "COMMON-LISP"),
    ("PSEUDO-TERM-LISTP" , "ACL2-CRG" , "ACL2"),
    ("PSEUDO-TERM-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("PSEUDO-TERMP" , "ACL2-CRG" , "ACL2"),
    ("PSTACK" , "ACL2-CRG" , "ACL2"),
    ("PUFF" , "ACL2-CRG" , "ACL2"),
    ("PUFF*" , "ACL2-CRG" , "ACL2"),
    ("PUSH" , "ACL2-CRG" , "COMMON-LISP"),
    ("PUSH-TIMER" , "ACL2-CRG" , "ACL2"),
    ("PUSH-UNTOUCHABLE" , "ACL2-CRG" , "ACL2"),
    ("PUSHNEW" , "ACL2-CRG" , "COMMON-LISP"),
    ("PUT-ASSOC-EQ" , "ACL2-CRG" , "ACL2"),
    ("PUT-ASSOC-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("PUT-GLOBAL" , "ACL2-CRG" , "ACL2"),
    ("PUTPROP" , "ACL2-CRG" , "ACL2"),
    ("QUOTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("QUOTEP" , "ACL2-CRG" , "ACL2"),
    ("R-EQLABLE-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("RANDOM" , "ACL2-CRG" , "COMMON-LISP"),
    ("RANDOM-STATE" , "ACL2-CRG" , "COMMON-LISP"),
    ("RANDOM-STATE-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("RASSOC" , "ACL2-CRG" , "COMMON-LISP"),
    ("RASSOC-EQ" , "ACL2-CRG" , "ACL2"),
    ("RASSOC-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("RASSOC-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("RASSOC-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("RATIO" , "ACL2-CRG" , "COMMON-LISP"),
    ("RATIONAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("RATIONAL-IMPLIES1" , "ACL2-CRG" , "ACL2"),
    ("RATIONAL-IMPLIES2" , "ACL2-CRG" , "ACL2"),
    ("RATIONAL-LISTP" , "ACL2-CRG" , "ACL2"),
    ("RATIONAL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("RATIONALIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("RATIONALP" , "ACL2-CRG" , "COMMON-LISP"),
    ("RATIONALP-*" , "ACL2-CRG" , "ACL2"),
    ("RATIONALP-+" , "ACL2-CRG" , "ACL2"),
    ("RATIONALP-EXPT-TYPE-PRESCRIPTION" , "ACL2-CRG" , "ACL2"),
    ("RATIONALP-IMPLIES-ACL2-NUMBERP" , "ACL2-CRG" , "ACL2"),
    ("RATIONALP-UNARY--" , "ACL2-CRG" , "ACL2"),
    ("RATIONALP-UNARY-/" , "ACL2-CRG" , "ACL2"),
    ("READ" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-ACL2-ORACLE" , "ACL2-CRG" , "ACL2"),
    ("READ-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-CRG" , "ACL2"),
    ("READ-BYTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-BYTE$" , "ACL2-CRG" , "ACL2"),
    ("READ-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-CHAR$" , "ACL2-CRG" , "ACL2"),
    ("READ-CHAR-NO-HANG" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-DELIMITED-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-FILE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("READ-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-CRG" , "ACL2"),
    ("READ-FILE-LISTP1" , "ACL2-CRG" , "ACL2"),
    ("READ-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-CRG"
, "ACL2"),
    ("READ-FILES" , "ACL2-CRG" , "ACL2"),
    ("READ-FILES-P" , "ACL2-CRG" , "ACL2"),
    ("READ-FILES-P-FORWARD-TO-READ-FILE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("READ-FROM-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-IDATE" , "ACL2-CRG" , "ACL2"),
    ("READ-LINE" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-OBJECT" , "ACL2-CRG" , "ACL2"),
    ("READ-PRESERVING-WHITESPACE" , "ACL2-CRG" , "COMMON-LISP"),
    ("READ-RUN-TIME" , "ACL2-CRG" , "ACL2"),
    ("READ-RUN-TIME-PRESERVES-STATE-P1" , "ACL2-CRG" , "ACL2"),
    ("READ-SEQUENCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("READABLE-FILE" , "ACL2-CRG" , "ACL2"),
    ("READABLE-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-CRG" ,
"ACL2"),
    ("READABLE-FILES" , "ACL2-CRG" , "ACL2"),
    ("READABLE-FILES-LISTP" , "ACL2-CRG" , "ACL2"),
    ("READABLE-FILES-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" ,
"ACL2-CRG" , "ACL2"),
    ("READABLE-FILES-P" , "ACL2-CRG" , "ACL2"),
    ("READABLE-FILES-P-FORWARD-TO-READABLE-FILES-LISTP" , "ACL2-CRG"
, "ACL2"),
    ("READER-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("READTABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("READTABLE-CASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("READTABLEP" , "ACL2-CRG" , "COMMON-LISP"),
    ("REAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("REAL/RATIONALP" , "ACL2-CRG" , "ACL2"),
    ("REALFIX" , "ACL2-CRG" , "ACL2"),
    ("REALP" , "ACL2-CRG" , "COMMON-LISP"),
    ("REALPART" , "ACL2-CRG" , "COMMON-LISP"),
    ("REALPART-COMPLEX" , "ACL2-CRG" , "ACL2"),
    ("REALPART-IMAGPART-ELIM" , "ACL2-CRG" , "ACL2"),
    ("REBUILD" , "ACL2-CRG" , "ACL2"),
    ("REDEF" , "ACL2-CRG" , "ACL2"),
    ("REDEF!" , "ACL2-CRG" , "ACL2"),
    ("REDEF+" , "ACL2-CRG" , "ACL2"),
    ("REDUCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("REINITIALIZE-INSTANCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("REM" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMF" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMHASH" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMOVE" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMOVE-BINOP" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-DEFAULT-HINTS!" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-DUPLICATES" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMOVE-DUPLICATES-EQL" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-DUPLICATES-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-EQ" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-FIRST-PAIR" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMOVE-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMOVE-INVISIBLE-FNS" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-MACRO-ALIAS" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("REMOVE-NTH-ALIAS" , "ACL2-CRG" , "ACL2"),
    ("REMOVE-UNTOUCHABLE" , "ACL2-CRG" , "ACL2"),
    ("REMOVE1" , "ACL2-CRG" , "ACL2"),
    ("REMOVE1-EQ" , "ACL2-CRG" , "ACL2"),
    ("REMOVE1-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("REMPROP" , "ACL2-CRG" , "COMMON-LISP"),
    ("RENAME-FILE" , "ACL2-CRG" , "COMMON-LISP"),
    ("RENAME-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("REPLACE" , "ACL2-CRG" , "COMMON-LISP"),
    ("REQUIRE" , "ACL2-CRG" , "COMMON-LISP"),
    ("RESET-LD-SPECIALS" , "ACL2-CRG" , "ACL2"),
    ("RESET-PREHISTORY" , "ACL2-CRG" , "ACL2"),
    ("REST" , "ACL2-CRG" , "COMMON-LISP"),
    ("RESTART" , "ACL2-CRG" , "COMMON-LISP"),
    ("RESTART-BIND" , "ACL2-CRG" , "COMMON-LISP"),
    ("RESTART-CASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("RESTART-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("RETRACT-WORLD" , "ACL2-CRG" , "ACL2"),
    ("RETRIEVE" , "ACL2-CRG" , "ACL2"),
    ("RETURN" , "ACL2-CRG" , "COMMON-LISP"),
    ("RETURN-FROM" , "ACL2-CRG" , "COMMON-LISP"),
    ("REVAPPEND" , "ACL2-CRG" , "COMMON-LISP"),
    ("REVERSE" , "ACL2-CRG" , "COMMON-LISP"),
    ("RFIX" , "ACL2-CRG" , "ACL2"),
    ("ROOM" , "ACL2-CRG" , "COMMON-LISP"),
    ("ROTATEF" , "ACL2-CRG" , "COMMON-LISP"),
    ("ROUND" , "ACL2-CRG" , "COMMON-LISP"),
    ("ROW-MAJOR-AREF" , "ACL2-CRG" , "COMMON-LISP"),
    ("RPLACA" , "ACL2-CRG" , "COMMON-LISP"),
    ("RPLACD" , "ACL2-CRG" , "COMMON-LISP"),
    ("SAFETY" , "ACL2-CRG" , "COMMON-LISP"),
    ("SATISFIES" , "ACL2-CRG" , "COMMON-LISP"),
    ("SBIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SCALE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SCHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("SEARCH" , "ACL2-CRG" , "COMMON-LISP"),
    ("SECOND" , "ACL2-CRG" , "COMMON-LISP"),
    ("SEQUENCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SERIOUS-CONDITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET-BACKCHAIN-LIMIT" , "ACL2-CRG" , "ACL2"),
    ("SET-BODY" , "ACL2-CRG" , "ACL2"),
    ("SET-BOGUS-DEFUN-HINTS-OK" , "ACL2-CRG" , "ACL2"),
    ("SET-BOGUS-MUTUAL-RECURSION-OK" , "ACL2-CRG" , "ACL2"),
    ("SET-CASE-SPLIT-LIMITATIONS" , "ACL2-CRG" , "ACL2"),
    ("SET-CBD" , "ACL2-CRG" , "ACL2"),
    ("SET-CHECKPOINT-SUMMARY-LIMIT" , "ACL2-CRG" , "ACL2"),
    ("SET-COMPILE-FNS" , "ACL2-CRG" , "ACL2"),
    ("SET-DEBUGGER-ENABLE" , "ACL2-CRG" , "ACL2"),
    ("SET-DEFAULT-BACKCHAIN-LIMIT" , "ACL2-CRG" , "ACL2"),
    ("SET-DEFAULT-HINTS" , "ACL2-CRG" , "ACL2"),
    ("SET-DEFAULT-HINTS!" , "ACL2-CRG" , "ACL2"),
    ("SET-DIFFERENCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET-DIFFERENCE-EQ" , "ACL2-CRG" , "ACL2"),
    ("SET-DIFFERENCE-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("SET-DIFFERENCE-THEORIES" , "ACL2-CRG" , "ACL2"),
    ("SET-DISPATCH-MACRO-CHARACTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET-ENFORCE-REDUNDANCY" , "ACL2-CRG" , "ACL2"),
    ("SET-EQUALP-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("SET-EXCLUSIVE-OR" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET-GAG-MODE" , "ACL2-CRG" , "ACL2"),
    ("SET-GUARD-CHECKING" , "ACL2-CRG" , "ACL2"),
    ("SET-IGNORE-DOC-STRING-ERROR" , "ACL2-CRG" , "ACL2"),
    ("SET-IGNORE-OK" , "ACL2-CRG" , "ACL2"),
    ("SET-INHIBIT-OUTPUT-LST" , "ACL2-CRG" , "ACL2"),
    ("SET-INHIBIT-WARNINGS" , "ACL2-CRG" , "ACL2"),
    ("SET-INHIBITED-SUMMARY-TYPES" , "ACL2-CRG" , "ACL2"),
    ("SET-INVISIBLE-FNS-TABLE" , "ACL2-CRG" , "ACL2"),
    ("SET-IRRELEVANT-FORMALS-OK" , "ACL2-CRG" , "ACL2"),
    ("SET-LD-KEYWORD-ALIASES" , "ACL2-CRG" , "ACL2"),
    ("SET-LD-REDEFINITION-ACTION" , "ACL2-CRG" , "ACL2"),
    ("SET-LD-SKIP-PROOFS" , "ACL2-CRG" , "ACL2"),
    ("SET-LD-SKIP-PROOFSP" , "ACL2-CRG" , "ACL2"),
    ("SET-LET*-ABSTRACTION" , "ACL2-CRG" , "ACL2"),
    ("SET-LET*-ABSTRACTIONP" , "ACL2-CRG" , "ACL2"),
    ("SET-MACRO-CHARACTER" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET-MATCH-FREE-DEFAULT" , "ACL2-CRG" , "ACL2"),
    ("SET-MATCH-FREE-ERROR" , "ACL2-CRG" , "ACL2"),
    ("SET-MEASURE-FUNCTION" , "ACL2-CRG" , "ACL2"),
    ("SET-NON-LINEAR" , "ACL2-CRG" , "ACL2"),
    ("SET-NON-LINEARP" , "ACL2-CRG" , "ACL2"),
    ("SET-NU-REWRITER-MODE" , "ACL2-CRG" , "ACL2"),
    ("SET-PARALLEL-EVALUATION" , "ACL2-CRG" , "ACL2"),
    ("SET-PPRINT-DISPATCH" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET-PRINT-BASE" , "ACL2-CRG" , "ACL2"),
    ("SET-PRINT-CASE" , "ACL2-CRG" , "ACL2"),
    ("SET-PRINT-CLAUSE-IDS" , "ACL2-CRG" , "ACL2"),
    ("SET-RAW-MODE" , "ACL2-CRG" , "ACL2"),
    ("SET-RAW-MODE-ON!" , "ACL2-CRG" , "ACL2"),
    ("SET-RAW-PROOF-FORMAT" , "ACL2-CRG" , "ACL2"),
    ("SET-REWRITE-STACK-LIMIT" , "ACL2-CRG" , "ACL2"),
    ("SET-RULER-EXTENDERS" , "ACL2-CRG" , "ACL2"),
    ("SET-SAVED-OUTPUT" , "ACL2-CRG" , "ACL2"),
    ("SET-SLOW-ALIST-ACTION" , "ACL2-CRG" , "ACL2"),
    ("SET-STATE-OK" , "ACL2-CRG" , "ACL2"),
    ("SET-SYNTAX-FROM-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("SET-TAINTED-OK" , "ACL2-CRG" , "ACL2"),
    ("SET-TAINTED-OKP" , "ACL2-CRG" , "ACL2"),
    ("SET-TIMER" , "ACL2-CRG" , "ACL2"),
    ("SET-TRACE-EVISC-TUPLE" , "ACL2-CRG" , "ACL2"),
    ("SET-VERIFY-GUARDS-EAGERNESS" , "ACL2-CRG" , "ACL2"),
    ("SET-W" , "ACL2-CRG" , "ACL2"),
    ("SET-WELL-FOUNDED-RELATION" , "ACL2-CRG" , "ACL2"),
    ("SETF" , "ACL2-CRG" , "COMMON-LISP"),
    ("SETQ" , "ACL2-CRG" , "COMMON-LISP"),
    ("SEVENTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("SGETPROP" , "ACL2-CRG" , "ACL2"),
    ("SHADOW" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHADOWING-IMPORT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHARED-INITIALIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHIFTF" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHORT-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHORT-FLOAT-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHORT-FLOAT-NEGATIVE-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHORT-SITE-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("SHOW-ACCUMULATED-PERSISTENCE" , "ACL2-CRG" , "ACL2"),
    ("SHOW-BDD" , "ACL2-CRG" , "ACL2"),
    ("SHOW-BODIES" , "ACL2-CRG" , "ACL2"),
    ("SHRINK-32-BIT-INTEGER-STACK" , "ACL2-CRG" , "ACL2"),
    ("SHRINK-T-STACK" , "ACL2-CRG" , "ACL2"),
    ("SIGNAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIGNED-BYTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIGNUM" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-ARRAY" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-BASE-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-BIT-VECTOR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-CONDITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-ARGUMENTS" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-CONDITION-FORMAT-CONTROL" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-STRING-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-TYPE-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-VECTOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-VECTOR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLE-WARNING" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIMPLIFY" , "ACL2-CRG" , "ACL2"),
    ("SIN" , "ACL2-CRG" , "COMMON-LISP"),
    ("SINGLE-FLOAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SINGLE-FLOAT-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("SINGLE-FLOAT-NEGATIVE-EPSILON" , "ACL2-CRG" , "COMMON-LISP"),
    ("SINH" , "ACL2-CRG" , "COMMON-LISP"),
    ("SIXTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("SKIP-PROOFS" , "ACL2-CRG" , "ACL2"),
    ("SLEEP" , "ACL2-CRG" , "COMMON-LISP"),
    ("SLOT-BOUNDP" , "ACL2-CRG" , "COMMON-LISP"),
    ("SLOT-EXISTS-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("SLOT-MAKUNBOUND" , "ACL2-CRG" , "COMMON-LISP"),
    ("SLOT-MISSING" , "ACL2-CRG" , "COMMON-LISP"),
    ("SLOT-UNBOUND" , "ACL2-CRG" , "COMMON-LISP"),
    ("SLOT-VALUE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SOFTWARE-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SOFTWARE-VERSION" , "ACL2-CRG" , "COMMON-LISP"),
    ("SOME" , "ACL2-CRG" , "COMMON-LISP"),
    ("SOME-SLASHABLE" , "ACL2-CRG" , "ACL2"),
    ("SORT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SPACE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SPECIAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("SPECIAL-OPERATOR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("SPEED" , "ACL2-CRG" , "COMMON-LISP"),
    ("SQRT" , "ACL2-CRG" , "COMMON-LISP"),
    ("STABLE-SORT" , "ACL2-CRG" , "COMMON-LISP"),
    ("STABLE-UNDER-SIMPLIFICATIONP" , "ACL2-CRG" , "ACL2"),
    ("STANDARD" , "ACL2-CRG" , "COMMON-LISP"),
    ("STANDARD-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("STANDARD-CHAR-LISTP" , "ACL2-CRG" , "ACL2"),
    ("STANDARD-CHAR-LISTP-APPEND" , "ACL2-CRG" , "ACL2"),
    ("STANDARD-CHAR-LISTP-FORWARD-TO-CHARACTER-LISTP" , "ACL2-CRG"
, "ACL2"),
    ("STANDARD-CHAR-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("STANDARD-CHAR-P-NTH" , "ACL2-CRG" , "ACL2"),
    ("STANDARD-CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("STANDARD-CO" , "ACL2-CRG" , "ACL2"),
    ("STANDARD-GENERIC-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("STANDARD-METHOD" , "ACL2-CRG" , "COMMON-LISP"),
    ("STANDARD-OBJECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("STANDARD-OI" , "ACL2-CRG" , "ACL2"),
    ("STANDARD-STRING-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("STANDARD-STRING-ALISTP-FORWARD-TO-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("START-PROOF-TREE" , "ACL2-CRG" , "ACL2"),
    ("STATE" , "ACL2-CRG" , "ACL2"),
    ("STATE-GLOBAL-LET*-CLEANUP" , "ACL2-CRG" , "ACL2"),
    ("STATE-GLOBAL-LET*-GET-GLOBALS" , "ACL2-CRG" , "ACL2"),
    ("STATE-GLOBAL-LET*-PUT-GLOBALS" , "ACL2-CRG" , "ACL2"),
    ("STATE-P" , "ACL2-CRG" , "ACL2"),
    ("STATE-P-IMPLIES-AND-FORWARD-TO-STATE-P1" , "ACL2-CRG" , "ACL2"),
    ("STATE-P1" , "ACL2-CRG" , "ACL2"),
    ("STATE-P1-FORWARD" , "ACL2-CRG" , "ACL2"),
    ("STATE-P1-UPDATE-MAIN-TIMER" , "ACL2-CRG" , "ACL2"),
    ("STATE-P1-UPDATE-NTH-2-WORLD" , "ACL2-CRG" , "ACL2"),
    ("STEP" , "ACL2-CRG" , "COMMON-LISP"),
    ("STOP-PROOF-TREE" , "ACL2-CRG" , "ACL2"),
    ("STORAGE-CONDITION" , "ACL2-CRG" , "COMMON-LISP"),
    ("STORE-VALUE" , "ACL2-CRG" , "COMMON-LISP"),
    ("STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("STREAM-ELEMENT-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("STREAM-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("STREAM-ERROR-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("STREAM-EXTERNAL-FORMAT" , "ACL2-CRG" , "COMMON-LISP"),
    ("STREAMP" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-APPEND" , "ACL2-CRG" , "ACL2"),
    ("STRING-APPEND-LST" , "ACL2-CRG" , "ACL2"),
    ("STRING-CAPITALIZE" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-DOWNCASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-DOWNCASE1" , "ACL2-CRG" , "ACL2"),
    ("STRING-EQUAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-EQUAL1" , "ACL2-CRG" , "ACL2"),
    ("STRING-GREATERP" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-IS-NOT-CIRCULAR" , "ACL2-CRG" , "ACL2"),
    ("STRING-LEFT-TRIM" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-LESSP" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-LISTP" , "ACL2-CRG" , "ACL2"),
    ("STRING-NOT-EQUAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-NOT-GREATERP" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-NOT-LESSP" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-RIGHT-TRIM" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-TRIM" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-UPCASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING-UPCASE1" , "ACL2-CRG" , "ACL2"),
    ("STRING/=" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING<" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING<-IRREFLEXIVE" , "ACL2-CRG" , "ACL2"),
    ("STRING<-L" , "ACL2-CRG" , "ACL2"),
    ("STRING<-L-ASYMMETRIC" , "ACL2-CRG" , "ACL2"),
    ("STRING<-L-IRREFLEXIVE" , "ACL2-CRG" , "ACL2"),
    ("STRING<-L-TRANSITIVE" , "ACL2-CRG" , "ACL2"),
    ("STRING<-L-TRICHOTOMY" , "ACL2-CRG" , "ACL2"),
    ("STRING<=" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING=" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING>" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRING>=" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRINGP" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRINGP-SYMBOL-PACKAGE-NAME" , "ACL2-CRG" , "ACL2"),
    ("STRIP-CARS" , "ACL2-CRG" , "ACL2"),
    ("STRIP-CDRS" , "ACL2-CRG" , "ACL2"),
    ("STRUCTURE" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRUCTURE-CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("STRUCTURE-OBJECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("STYLE-WARNING" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBLIS" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBSEQ" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBSEQ-LIST" , "ACL2-CRG" , "ACL2"),
    ("SUBSETP" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBSETP-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("SUBST" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBST-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBST-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBSTITUTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBSTITUTE-AC" , "ACL2-CRG" , "ACL2"),
    ("SUBSTITUTE-IF" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBSTITUTE-IF-NOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUBTYPEP" , "ACL2-CRG" , "COMMON-LISP"),
    ("SUMMARY" , "ACL2-CRG" , "ACL2"),
    ("SVREF" , "ACL2-CRG" , "COMMON-LISP"),
    ("SXHASH" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOL" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOL-<" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-<-ASYMMETRIC" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-<-IRREFLEXIVE" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-<-TRANSITIVE" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-<-TRICHOTOMY" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-ALISTP-FORWARD-TO-EQLABLE-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-DOUBLET-LISTP" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-EQUALITY" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOL-LISTP" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-MACROLET" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOL-NAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOL-NAME-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOL-PACKAGE-NAME" , "ACL2-CRG" , "ACL2"),
    ("SYMBOL-PLIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOL-VALUE" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOLP" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYMBOLP-INTERN-IN-PACKAGE-OF-SYMBOL" , "ACL2-CRG" , "ACL2"),
    ("SYNONYM-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYNONYM-STREAM-SYMBOL" , "ACL2-CRG" , "COMMON-LISP"),
    ("SYNP" , "ACL2-CRG" , "ACL2"),
    ("SYNTAXP" , "ACL2-CRG" , "ACL2"),
    ("SYS-CALL" , "ACL2-CRG" , "ACL2"),
    ("SYS-CALL-STATUS" , "ACL2-CRG" , "ACL2"),
    ("T" , "ACL2-CRG" , "COMMON-LISP"),
    ("T-STACK" , "ACL2-CRG" , "ACL2"),
    ("T-STACK-LENGTH" , "ACL2-CRG" , "ACL2"),
    ("T-STACK-LENGTH1" , "ACL2-CRG" , "ACL2"),
    ("TABLE" , "ACL2-CRG" , "ACL2"),
    ("TABLE-ALIST" , "ACL2-CRG" , "ACL2"),
    ("TAGBODY" , "ACL2-CRG" , "COMMON-LISP"),
    ("TAILP" , "ACL2-CRG" , "COMMON-LISP"),
    ("TAKE" , "ACL2-CRG" , "ACL2"),
    ("TAN" , "ACL2-CRG" , "COMMON-LISP"),
    ("TANH" , "ACL2-CRG" , "COMMON-LISP"),
    ("TENTH" , "ACL2-CRG" , "COMMON-LISP"),
    ("TERPRI" , "ACL2-CRG" , "COMMON-LISP"),
    ("THE" , "ACL2-CRG" , "COMMON-LISP"),
    ("THE-ERROR" , "ACL2-CRG" , "ACL2"),
    ("THE-FIXNUM" , "ACL2-CRG" , "ACL2"),
    ("THE-FIXNUM!" , "ACL2-CRG" , "ACL2"),
    ("THEORY" , "ACL2-CRG" , "ACL2"),
    ("THEORY-INVARIANT" , "ACL2-CRG" , "ACL2"),
    ("THIRD" , "ACL2-CRG" , "COMMON-LISP"),
    ("THM" , "ACL2-CRG" , "ACL2"),
    ("THROW" , "ACL2-CRG" , "COMMON-LISP"),
    ("TIME" , "ACL2-CRG" , "COMMON-LISP"),
    ("TIME$" , "ACL2-CRG" , "ACL2"),
    ("TIMER-ALISTP" , "ACL2-CRG" , "ACL2"),
    ("TIMER-ALISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-SYMBOL-ALISTP" ,
"ACL2-CRG" , "ACL2"),
    ("TOGGLE-PC-MACRO" , "ACL2-CRG" , "ACL2"),
    ("TRACE" , "ACL2-CRG" , "COMMON-LISP"),
    ("TRACE!" , "ACL2-CRG" , "ACL2"),
    ("TRACE$" , "ACL2-CRG" , "ACL2"),
    ("TRACE*" , "ACL2-CRG" , "ACL2"),
    ("TRANS" , "ACL2-CRG" , "ACL2"),
    ("TRANS1" , "ACL2-CRG" , "ACL2"),
    ("TRANSLATE-LOGICAL-PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("TRANSLATE-PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("TREE-EQUAL" , "ACL2-CRG" , "COMMON-LISP"),
    ("TRICHOTOMY" , "ACL2-CRG" , "ACL2"),
    ("TRUE-LIST-LISTP" , "ACL2-CRG" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("TRUE-LIST-LISTP-FORWARD-TO-TRUE-LISTP-ASSOC-EQ" , "ACL2-CRG"
, "ACL2"),
    ("TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("TRUE-LISTP-CADR-ASSOC-EQ-FOR-OPEN-CHANNELS-P" , "ACL2-CRG" ,
"ACL2"),
    ("TRUE-LISTP-UPDATE-NTH" , "ACL2-CRG" , "ACL2"),
    ("TRUENAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("TRUNCATE" , "ACL2-CRG" , "COMMON-LISP"),
    ("TWO-WAY-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-INPUT-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("TWO-WAY-STREAM-OUTPUT-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("TYPE-ERROR" , "ACL2-CRG" , "COMMON-LISP"),
    ("TYPE-ERROR-DATUM" , "ACL2-CRG" , "COMMON-LISP"),
    ("TYPE-ERROR-EXPECTED-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("TYPE-OF" , "ACL2-CRG" , "COMMON-LISP"),
    ("TYPECASE" , "ACL2-CRG" , "COMMON-LISP"),
    ("TYPED-IO-LISTP" , "ACL2-CRG" , "ACL2"),
    ("TYPED-IO-LISTP-FORWARD-TO-TRUE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("TYPEP" , "ACL2-CRG" , "COMMON-LISP"),
    ("U" , "ACL2-CRG" , "ACL2"),
    ("UBT" , "ACL2-CRG" , "ACL2"),
    ("UBT!" , "ACL2-CRG" , "ACL2"),
    ("UNARY--" , "ACL2-CRG" , "ACL2"),
    ("UNARY-/" , "ACL2-CRG" , "ACL2"),
    ("UNARY-FUNCTION-SYMBOL-LISTP" , "ACL2-CRG" , "ACL2"),
    ("UNBOUND-SLOT" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNBOUND-SLOT-INSTANCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNBOUND-VARIABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNDEFINED-FUNCTION" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNEXPORT" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNICITY-OF-0" , "ACL2-CRG" , "ACL2"),
    ("UNICITY-OF-1" , "ACL2-CRG" , "ACL2"),
    ("UNINTERN" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNION" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNION-EQ" , "ACL2-CRG" , "ACL2"),
    ("UNION-EQUAL" , "ACL2-CRG" , "ACL2"),
    ("UNION-THEORIES" , "ACL2-CRG" , "ACL2"),
    ("UNIVERSAL-THEORY" , "ACL2-CRG" , "ACL2"),
    ("UNLESS" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNMEMOIZE" , "ACL2-CRG" , "ACL2"),
    ("UNMONITOR" , "ACL2-CRG" , "ACL2"),
    ("UNREAD-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNSAVE" , "ACL2-CRG" , "ACL2"),
    ("UNSIGNED-BYTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNTRACE" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNTRACE$" , "ACL2-CRG" , "ACL2"),
    ("UNUSE-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("UNWIND-PROTECT" , "ACL2-CRG" , "COMMON-LISP"),
    ("UPDATE-32-BIT-INTEGER-STACK" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-ACL2-ORACLE" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-ACL2-ORACLE-PRESERVES-STATE-P1" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-BIG-CLOCK-ENTRY" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-FILE-CLOCK" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-GLOBAL-TABLE" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-IDATES" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-INSTANCE-FOR-DIFFERENT-CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("UPDATE-INSTANCE-FOR-REDEFINED-CLASS" , "ACL2-CRG" , "COMMON-LISP"),
    ("UPDATE-LIST-ALL-PACKAGE-NAMES-LST" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-NTH" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-OPEN-INPUT-CHANNELS" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-OPEN-OUTPUT-CHANNELS" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-READ-FILES" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-T-STACK" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-USER-STOBJ-ALIST1" , "ACL2-CRG" , "ACL2"),
    ("UPDATE-WRITTEN-FILES" , "ACL2-CRG" , "ACL2"),
    ("UPGRADED-ARRAY-ELEMENT-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("UPGRADED-COMPLEX-PART-TYPE" , "ACL2-CRG" , "COMMON-LISP"),
    ("UPPER-CASE-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("UPPER-CASE-P-CHAR-UPCASE" , "ACL2-CRG" , "ACL2"),
    ("UPPER-CASE-P-FORWARD-TO-ALPHA-CHAR-P" , "ACL2-CRG" , "ACL2"),
    ("USE-PACKAGE" , "ACL2-CRG" , "COMMON-LISP"),
    ("USE-VALUE" , "ACL2-CRG" , "COMMON-LISP"),
    ("USER-HOMEDIR-PATHNAME" , "ACL2-CRG" , "COMMON-LISP"),
    ("USER-STOBJ-ALIST" , "ACL2-CRG" , "ACL2"),
    ("USER-STOBJ-ALIST1" , "ACL2-CRG" , "ACL2"),
    ("VALUE-TRIPLE" , "ACL2-CRG" , "ACL2"),
    ("VALUES" , "ACL2-CRG" , "COMMON-LISP"),
    ("VALUES-LIST" , "ACL2-CRG" , "COMMON-LISP"),
    ("VARIABLE" , "ACL2-CRG" , "COMMON-LISP"),
    ("VECTOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("VECTOR-POP" , "ACL2-CRG" , "COMMON-LISP"),
    ("VECTOR-PUSH" , "ACL2-CRG" , "COMMON-LISP"),
    ("VECTOR-PUSH-EXTEND" , "ACL2-CRG" , "COMMON-LISP"),
    ("VECTORP" , "ACL2-CRG" , "COMMON-LISP"),
    ("VERBOSE-PSTACK" , "ACL2-CRG" , "ACL2"),
    ("VERIFY" , "ACL2-CRG" , "ACL2"),
    ("VERIFY-GUARDS" , "ACL2-CRG" , "ACL2"),
    ("VERIFY-TERMINATION" , "ACL2-CRG" , "ACL2"),
    ("W" , "ACL2-CRG" , "ACL2"),
    ("WARN" , "ACL2-CRG" , "COMMON-LISP"),
    ("WARNING" , "ACL2-CRG" , "COMMON-LISP"),
    ("WARNING!" , "ACL2-CRG" , "ACL2"),
    ("WHEN" , "ACL2-CRG" , "COMMON-LISP"),
    ("WILD-PATHNAME-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-ACCESSORS" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-COMPILATION-UNIT" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-CONDITION-RESTARTS" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-HASH-TABLE-ITERATOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-INPUT-FROM-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-OPEN-FILE" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-OPEN-STREAM" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-OUTPUT" , "ACL2-CRG" , "ACL2"),
    ("WITH-OUTPUT-TO-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-PACKAGE-ITERATOR" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-SIMPLE-RESTART" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-SLOTS" , "ACL2-CRG" , "COMMON-LISP"),
    ("WITH-STANDARD-IO-SYNTAX" , "ACL2-CRG" , "COMMON-LISP"),
    ("WORLD" , "ACL2-CRG" , "ACL2"),
    ("WORMHOLE" , "ACL2-CRG" , "ACL2"),
    ("WORMHOLE-EVAL" , "ACL2-CRG" , "ACL2"),
    ("WORMHOLE1" , "ACL2-CRG" , "ACL2"),
    ("WRITABLE-FILE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("WRITABLE-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP" , "ACL2-CRG"
, "ACL2"),
    ("WRITABLE-FILE-LISTP1" , "ACL2-CRG" , "ACL2"),
    ("WRITABLE-FILE-LISTP1-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-CRG"
, "ACL2"),
    ("WRITE" , "ACL2-CRG" , "COMMON-LISP"),
    ("WRITE-BYTE" , "ACL2-CRG" , "COMMON-LISP"),
    ("WRITE-BYTE$" , "ACL2-CRG" , "ACL2"),
    ("WRITE-CHAR" , "ACL2-CRG" , "COMMON-LISP"),
    ("WRITE-LINE" , "ACL2-CRG" , "COMMON-LISP"),
    ("WRITE-SEQUENCE" , "ACL2-CRG" , "COMMON-LISP"),
    ("WRITE-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("WRITE-TO-STRING" , "ACL2-CRG" , "COMMON-LISP"),
    ("WRITEABLE-FILES" , "ACL2-CRG" , "ACL2"),
    ("WRITEABLE-FILES-P" , "ACL2-CRG" , "ACL2"),
    ("WRITEABLE-FILES-P-FORWARD-TO-WRITABLE-FILE-LISTP" , "ACL2-CRG"
, "ACL2"),
    ("WRITTEN-FILE" , "ACL2-CRG" , "ACL2"),
    ("WRITTEN-FILE-FORWARD-TO-TRUE-LISTP-AND-CONSP" , "ACL2-CRG" ,
"ACL2"),
    ("WRITTEN-FILE-LISTP" , "ACL2-CRG" , "ACL2"),
    ("WRITTEN-FILE-LISTP-FORWARD-TO-TRUE-LIST-LISTP-AND-ALISTP" , "ACL2-CRG"
, "ACL2"),
    ("WRITTEN-FILES" , "ACL2-CRG" , "ACL2"),
    ("WRITTEN-FILES-P" , "ACL2-CRG" , "ACL2"),
    ("WRITTEN-FILES-P-FORWARD-TO-WRITTEN-FILE-LISTP" , "ACL2-CRG" ,
"ACL2"),
    ("XARGS" , "ACL2-CRG" , "ACL2"),
    ("XXXJOIN" , "ACL2-CRG" , "ACL2"),
    ("Y-OR-N-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("YES-OR-NO-P" , "ACL2-CRG" , "COMMON-LISP"),
    ("ZEROP" , "ACL2-CRG" , "COMMON-LISP"),
    ("ZIP" , "ACL2-CRG" , "ACL2"),
    ("ZP" , "ACL2-CRG" , "ACL2")];

val ACL2_KNOWN_PACKAGES =
   [
    "ACL2-CRG",
    "ACL2-AGP",
    "ACL2-ASG",
    "U",
    "M1",
    "MY-PKG",
    "ACL2-USER",
    "ACL2-PC",
    "ACL2-INPUT-CHANNEL",
    "ACL2-OUTPUT-CHANNEL",
    "ACL2",
    "COMMON-LISP",
    "KEYWORD"];

end
