(* armScript.sml - generated by L<3> - Fri Mar 14 11:12:38 2014 *)
open HolKernel boolLib bossLib Import

val () = Import.start "arm"

open monadsyntax
val _ = Construct
  [("Architecture",
    [("ARMv4",[]),("ARMv4T",[]),("ARMv5T",[]),("ARMv5TE",[]),("ARMv6",[]),
     ("ARMv6K",[]),("ARMv6T2",[]),("ARMv7_A",[]),("ARMv7_R",[])])]
;
val _ = Construct
  [("Extensions",
    [("Extension_ThumbEE",[]),("Extension_Security",[]),
     ("Extension_Multiprocessing",[]),("Extension_Virtualization",[]),
     ("Extension_VFP",[]),("Extension_AdvanvedSIMD",[])])]
;
val _ = Record
  ("PSR",
   [("A",bTy),("C",bTy),("E",bTy),("F",bTy),("GE",F4),("I",bTy),("IT",F8),
    ("J",bTy),("M",FTy 5),("N",bTy),("Q",bTy),("T",bTy),("V",bTy),
    ("Z",bTy),("psr'rst",F4)])
;
val _ = Record ("CP14",[("TEEHBR",F32)])
;
val _ = Record
  ("SCTLR",
   [("A",bTy),("B",bTy),("BR",bTy),("C",bTy),("DZ",bTy),("EE",bTy),
    ("FI",bTy),("I",bTy),("IE",bTy),("M",bTy),("NMFI",bTy),("RR",bTy),
    ("SW",bTy),("TE",bTy),("U",bTy),("V",bTy),("VE",bTy),("Z",bTy),
    ("sctlr'rst",FTy 14)])
;
val _ = Record
  ("HSCTLR",
   [("A",bTy),("C",bTy),("CP15BEN",bTy),("EE",bTy),("FI",bTy),("I",bTy),
    ("M",bTy),("TE",bTy),("WXN",bTy),("hsctlr'rst",FTy 23)])
;
val _ = Record ("HSR",[("EC",FTy 6),("IL",bTy),("ISS",FTy 25)])
;
val _ = Record
  ("SCR",
   [("AW",bTy),("EA",bTy),("FIQ",bTy),("FW",bTy),("HCE",bTy),("IRQ",bTy),
    ("NS",bTy),("SCD",bTy),("SIF",bTy),("nET",bTy),("scr'rst",FTy 22)])
;
val _ = Record
  ("NSACR",
   [("NSASEDIS",bTy),("NSD32DIS",bTy),("NSTRCDIS",bTy),("RFR",bTy),
    ("cp",FTy 14),("nsacr'rst",FTy 14)])
;
val _ = Record
  ("HCR",
   [("AMO",bTy),("BSU",FTy 2),("DC",bTy),("FB",bTy),("FMO",bTy),
    ("IMO",bTy),("PTW",bTy),("SWIO",bTy),("TAC",bTy),("TGE",bTy),
    ("TID",F4),("TIDCP",bTy),("TPC",bTy),("TPU",bTy),("TSC",bTy),
    ("TSW",bTy),("TTLB",bTy),("TVM",bTy),("TWE",bTy),("TWI",bTy),
    ("VA",bTy),("VF",bTy),("VI",bTy),("VM",bTy),("hcr'rst",F4)])
;
val _ = Record
  ("CP15",
   [("HCR",CTy"HCR"),("HSCTLR",CTy"HSCTLR"),("HSR",CTy"HSR"),
    ("MVBAR",F32),("NSACR",CTy"NSACR"),("SCR",CTy"SCR"),
    ("SCTLR",CTy"SCTLR"),("VBAR",F32)])
;
val _ = Construct
  [("InstrSet",
    [("InstrSet_ARM",[]),("InstrSet_Thumb",[]),("InstrSet_Jazelle",[]),
     ("InstrSet_ThumbEE",[])])]
;
val _ = Construct
  [("Encoding",
    [("Encoding_Thumb",[]),("Encoding_Thumb2",[]),("Encoding_ARM",[])])]
;
val _ = Construct
  [("RName",
    [("RName_0usr",[]),("RName_1usr",[]),("RName_2usr",[]),
     ("RName_3usr",[]),("RName_4usr",[]),("RName_5usr",[]),
     ("RName_6usr",[]),("RName_7usr",[]),("RName_8usr",[]),
     ("RName_8fiq",[]),("RName_9usr",[]),("RName_9fiq",[]),
     ("RName_10usr",[]),("RName_10fiq",[]),("RName_11usr",[]),
     ("RName_11fiq",[]),("RName_12usr",[]),("RName_12fiq",[]),
     ("RName_SPusr",[]),("RName_SPfiq",[]),("RName_SPirq",[]),
     ("RName_SPsvc",[]),("RName_SPabt",[]),("RName_SPund",[]),
     ("RName_SPmon",[]),("RName_SPhyp",[]),("RName_LRusr",[]),
     ("RName_LRfiq",[]),("RName_LRirq",[]),("RName_LRsvc",[]),
     ("RName_LRabt",[]),("RName_LRund",[]),("RName_LRmon",[]),
     ("RName_PC",[])])]
;
val _ = Construct
  [("rights",
    [("Restricted",[]),("ReadPermit",[]),("ReadWritePermit",[]),
     ("XNeverRead",[]),("XNeverReadWrite",[])])]
;
val _ = Construct
  [("SRType",
    [("SRType_LSL",[]),("SRType_LSR",[]),("SRType_ASR",[]),
     ("SRType_ROR",[]),("SRType_RRX",[])])]
;
val _ = Construct
  [("offset1",
    [("immediate_form1",[F32]),
     ("register_form1",[PTy(F4,PTy(CTy"SRType",nTy))])])]
;
val _ = Construct
  [("offset2",[("immediate_form2",[F32]),("register_form2",[F4])])]
;
val _ = Construct
  [("Hint",
    [("Breakpoint",[F32]),("DataMemoryBarrier",[F4]),
     ("DataSynchronizationBarrier",[F4]),("Debug",[F4]),
     ("InstructionSynchronizationBarrier",[F4]),
     ("PreloadData",[PTy(bTy,PTy(bTy,PTy(F4,CTy"offset1")))]),
     ("PreloadDataLiteral",[PTy(bTy,F32)]),
     ("PreloadInstruction",[PTy(bTy,PTy(F4,CTy"offset1"))]),
     ("SendEvent",[]),("WaitForEvent",[]),("WaitForInterrupt",[]),
     ("Yield",[])])]
;
val _ = Construct
  [("System",
    [("ChangeProcessorState",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,FTy 5))))))]),
     ("ChangeProcessorStateT1",[PTy(bTy,PTy(bTy,PTy(bTy,bTy)))]),
     ("EnterxLeavex",[bTy]),("ExceptionReturn",[]),
     ("HypervisorCall",[F16]),
     ("MoveToBankedOrSpecialRegister",[PTy(bTy,PTy(FTy 5,F4))]),
     ("MoveToRegisterFromBankedOrSpecial",[PTy(bTy,PTy(FTy 5,F4))]),
     ("MoveToRegisterFromSpecial",[PTy(bTy,F4)]),
     ("MoveToSpecialFromImmediate",[PTy(bTy,PTy(F32,F4))]),
     ("MoveToSpecialFromRegister",[PTy(bTy,PTy(F4,F4))]),
     ("ReturnFromException",[PTy(bTy,PTy(bTy,PTy(bTy,F4)))]),
     ("SecureMonitorCall",[F4]),("Setend",[bTy]),
     ("StoreReturnState",[PTy(bTy,PTy(bTy,PTy(bTy,FTy 5)))]),
     ("SupervisorCall",[F32])])]
;
val _ = Construct
  [("Store",
    [("StoreByte",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))]),
     ("StoreByteUnprivileged",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))]),
     ("StoreDual",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,CTy"offset2"))))))]),
     ("StoreExclusive",[PTy(F4,PTy(F4,PTy(F4,F32)))]),
     ("StoreExclusiveByte",[PTy(F4,PTy(F4,F4))]),
     ("StoreExclusiveDoubleword",[PTy(F4,PTy(F4,PTy(F4,F4)))]),
     ("StoreExclusiveHalf",[PTy(F4,PTy(F4,F4))]),
     ("StoreHalf",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))]),
     ("StoreHalfUnprivileged",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2"))))]),
     ("StoreMultiple",[PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,F16))))]),
     ("StoreMultipleUserRegisters",[PTy(bTy,PTy(bTy,PTy(F4,F16)))]),
     ("StoreUnprivileged",[PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))]),
     ("StoreWord",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))])])]
;
val _ = Construct
  [("Load",
    [("LoadByte",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))]),
     ("LoadByteLiteral",[PTy(bTy,PTy(bTy,PTy(F4,F32)))]),
     ("LoadByteUnprivileged",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))]),
     ("LoadDual",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,CTy"offset2"))))))]),
     ("LoadDualLiteral",[PTy(bTy,PTy(F4,PTy(F4,F32)))]),
     ("LoadExclusive",[PTy(F4,PTy(F4,F32))]),
     ("LoadExclusiveByte",[PTy(F4,F4)]),
     ("LoadExclusiveDoubleword",[PTy(F4,PTy(F4,F4))]),
     ("LoadExclusiveHalf",[PTy(F4,F4)]),
     ("LoadHalf",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))]),
     ("LoadHalfLiteral",[PTy(bTy,PTy(bTy,PTy(F4,F32)))]),
     ("LoadHalfUnprivileged",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2")))))]),
     ("LoadLiteral",[PTy(bTy,PTy(F4,F32))]),
     ("LoadMultiple",[PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,F16))))]),
     ("LoadMultipleExceptionReturn",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,FTy 15))))]),
     ("LoadMultipleUserRegisters",[PTy(bTy,PTy(bTy,PTy(F4,FTy 15)))]),
     ("LoadSignedByteUnprivileged",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2"))))]),
     ("LoadUnprivileged",[PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))]),
     ("LoadWord",[PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))])])]
;
val _ = Construct
  [("Media",
    [("BitFieldClearOrInsert",[PTy(F4,PTy(F4,PTy(nTy,nTy)))]),
     ("BitFieldExtract",[PTy(bTy,PTy(F4,PTy(F4,PTy(nTy,nTy))))]),
     ("ByteReverse",[PTy(F4,F4)]),
     ("ByteReversePackedHalfword",[PTy(F4,F4)]),
     ("ByteReverseSignedHalfword",[PTy(F4,F4)]),
     ("ExtendByte",[PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy))))]),
     ("ExtendByte16",[PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy))))]),
     ("ExtendHalfword",[PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy))))]),
     ("PackHalfword",
      [PTy(CTy"SRType",PTy(nTy,PTy(bTy,PTy(F4,PTy(F4,F4)))))]),
     ("ReverseBits",[PTy(F4,F4)]),
     ("Saturate",[PTy(CTy"SRType",PTy(nTy,PTy(nTy,PTy(bTy,PTy(F4,F4)))))]),
     ("Saturate16",[PTy(nTy,PTy(bTy,PTy(F4,F4)))]),
     ("SaturatingAddSubtract",[PTy(FTy 2,PTy(F4,PTy(F4,F4)))]),
     ("SelectBytes",[PTy(F4,PTy(F4,F4))])])]
;
val _ = Construct
  [("SIMD",
    [("SignedAddSub16",[PTy(FTy 2,PTy(F4,PTy(F4,F4)))]),
     ("SignedAddSub8",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("SignedHalvingAddSub16",[PTy(FTy 2,PTy(F4,PTy(F4,F4)))]),
     ("SignedHalvingAddSub8",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("SignedSaturatingAddSub16",[PTy(FTy 2,PTy(F4,PTy(F4,F4)))]),
     ("SignedSaturatingAddSub8",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("UnsignedAddSub16",[PTy(FTy 2,PTy(F4,PTy(F4,F4)))]),
     ("UnsignedAddSub8",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("UnsignedHalvingAddSub16",[PTy(FTy 2,PTy(F4,PTy(F4,F4)))]),
     ("UnsignedHalvingAddSub8",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("UnsignedSaturatingAddSub16",[PTy(FTy 2,PTy(F4,PTy(F4,F4)))]),
     ("UnsignedSaturatingAddSub8",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("UnsignedSumAbsoluteDifferences",[PTy(F4,PTy(F4,PTy(F4,F4)))])])]
;
val _ = Construct
  [("Multiply",
    [("Multiply32",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("MultiplyAccumulate",[PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))]),
     ("MultiplyAccumulateAccumulate",[PTy(F4,PTy(F4,PTy(F4,F4)))]),
     ("MultiplyLong",
      [PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))]),
     ("MultiplySubtract",[PTy(F4,PTy(F4,PTy(F4,F4)))]),
     ("Signed16Multiply32Accumulate",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))]),
     ("Signed16Multiply32Result",[PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,F4))))]),
     ("Signed16Multiply64Accumulate",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))]),
     ("Signed16x32Multiply32Accumulate",
      [PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))]),
     ("Signed16x32Multiply32Result",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("SignedMostSignificantMultiply",
      [PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))]),
     ("SignedMostSignificantMultiplySubtract",
      [PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))]),
     ("SignedMultiplyDual",[PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))]),
     ("SignedMultiplyLongDual",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))])])]
;
val _ = Construct
  [("Data",
    [("AddSub",[PTy(bTy,PTy(F4,PTy(F4,FTy 12)))]),
     ("ArithLogicImmediate",[PTy(F4,PTy(bTy,PTy(F4,PTy(F4,FTy 12))))]),
     ("CountLeadingZeroes",[PTy(F4,F4)]),
     ("Move",[PTy(bTy,PTy(bTy,PTy(F4,FTy 12)))]),
     ("MoveHalfword",[PTy(bTy,PTy(F4,F16))]),
     ("Register",
      [PTy(F4,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy))))))]),
     ("RegisterShiftedRegister",
      [PTy(F4,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,PTy(CTy"SRType",F4))))))]),
     ("ShiftImmediate",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy)))))]),
     ("ShiftRegister",
      [PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(CTy"SRType",F4)))))]),
     ("TestCompareImmediate",[PTy(FTy 2,PTy(F4,FTy 12))]),
     ("TestCompareRegister",
      [PTy(FTy 2,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy))))])])]
;
val _ = Construct
  [("Branch",
    [("BranchExchange",[F4]),
     ("BranchLinkExchangeImmediate",[PTy(CTy"InstrSet",F32)]),
     ("BranchLinkExchangeRegister",[F4]),("BranchTarget",[F32]),
     ("CheckArray",[PTy(F4,F4)]),("CompareBranch",[PTy(bTy,PTy(F4,F32))]),
     ("HandlerBranchLink",[PTy(bTy,F32)]),
     ("HandlerBranchLinkParameter",[PTy(F32,F32)]),
     ("HandlerBranchParameter",[PTy(F32,F32)]),
     ("TableBranchByte",[PTy(bTy,PTy(F4,F4))])])]
;
val _ = Construct
  [("instruction",
    [("Branch",[CTy"Branch"]),("ClearExclusive",[]),("Data",[CTy"Data"]),
     ("Divide",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),("Hint",[CTy"Hint"]),
     ("IfThen",[PTy(F4,F4)]),("Load",[CTy"Load"]),("Media",[CTy"Media"]),
     ("Multiply",[CTy"Multiply"]),("NoOperation",[]),("SIMD",[CTy"SIMD"]),
     ("Store",[CTy"Store"]),("Swap",[PTy(bTy,PTy(F4,PTy(F4,F4)))]),
     ("System",[CTy"System"]),("Undefined",[F32])])]
;
val _ = Construct
  [("MachineCode",
    [("ARM",[F32]),("Thumb",[F16]),("Thumb2",[PTy(F16,F16)]),
     ("ThumbEE",[F16])])]
;
val _ = Construct
  [("exception",
    [("ASSERT",[sTy]),("IMPLEMENTATION_DEFINED",[sTy]),("NoException",[]),
     ("UNPREDICTABLE",[sTy])])]
;
val _ = Record
  ("arm_state",
   [("Architecture",CTy"Architecture"),("CP14",CTy"CP14"),
    ("CP15",CTy"CP15"),("CPSR",CTy"PSR"),
    ("ClearExclusiveLocal",
     ATy(PTy(iTy,PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
         PTy(LTy(STy F32),STy(PTy(F32,nTy))))),("CurrentCondition",F4),
    ("ELR_hyp",F32),("Encoding",CTy"Encoding"),
    ("ExclusiveMonitorsPass",
     ATy(PTy(F32,PTy(nTy,PTy(LTy(STy F32),STy(PTy(F32,nTy))))),bTy)),
    ("Extensions",STy(CTy"Extensions")),("MEM",ATy(F32,F8)),
    ("REG",ATy(CTy"RName",F32)),("SPSR_abt",CTy"PSR"),
    ("SPSR_fiq",CTy"PSR"),("SPSR_hyp",CTy"PSR"),("SPSR_irq",CTy"PSR"),
    ("SPSR_mon",CTy"PSR"),("SPSR_svc",CTy"PSR"),("SPSR_und",CTy"PSR"),
    ("SetExclusiveMonitors",
     ATy(PTy(F32,PTy(nTy,PTy(LTy(STy F32),STy(PTy(F32,nTy))))),
         PTy(LTy(STy F32),STy(PTy(F32,nTy))))),("data_abort",bTy),
    ("exception",CTy"exception"),
    ("exclusive_state",PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
    ("external_abort_oracle",ATy(nTy,bTy)),
    ("external_abort_oracle_count",nTy),("isfetch",bTy),
    ("rights_map",ATy(F32,CTy"rights")),("transfer_unknown",bTy),
    ("translate_address",ATy(F32,OTy F32)),("undefined",bTy)])
;
val qTy = CTy "arm_state";
fun qVar v = Term.mk_var (v, ParseDatatype.pretypeToType qTy);
val raise'exception_def = Def
  ("raise'exception",Var("e",CTy"exception"),
   MB(MR(Close(qVar"s",Dest("exception",CTy"exception",qVar"s"))),
      Close
        (Var("v",CTy"exception"),
         MB(MB(MU(EQ(Var("v",CTy"exception"),
                     Const("NoException",CTy"exception")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MW(Close
                           (qVar"s",
                            Rupd
                              ("exception",
                               TP[qVar"s",Var("e",CTy"exception")]))),
                      MU(LU,qTy)))),Close(AVar uTy,MU(LX(VTy"a"),qTy))))))
;
val ArchVersion_def = Def
  ("ArchVersion",AVar uTy,
   MB(MR(Close(qVar"s",Dest("Architecture",CTy"Architecture",qVar"s"))),
      Close
        (Var("x",CTy"Architecture"),
         MU(CS(Var("x",CTy"Architecture"),
               [(LC("ARMv4",CTy"Architecture"),LN 4),
                (LC("ARMv4T",CTy"Architecture"),LN 4),
                (LC("ARMv5T",CTy"Architecture"),LN 5),
                (LC("ARMv5TE",CTy"Architecture"),LN 5),
                (LC("ARMv6",CTy"Architecture"),LN 6),
                (LC("ARMv6K",CTy"Architecture"),LN 6),
                (LC("ARMv6T2",CTy"Architecture"),LN 6),
                (LC("ARMv7_A",CTy"Architecture"),LN 7),
                (LC("ARMv7_R",CTy"Architecture"),LN 7)]),qTy))))
;
val HaveDSPSupport_def = Def
  ("HaveDSPSupport",AVar uTy,
   MB(MR(Close(qVar"s",Dest("Architecture",CTy"Architecture",qVar"s"))),
      Close
        (Var("v",CTy"Architecture"),
         MB(MU(Bop(In,Var("v",CTy"Architecture"),
                   SL[LC("ARMv4",CTy"Architecture"),
                      LC("ARMv4T",CTy"Architecture"),
                      LC("ARMv5T",CTy"Architecture")]),qTy),
            Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))))))
;
val HaveThumb2_def = Def
  ("HaveThumb2",AVar uTy,
   MB(MR(Close(qVar"s",Dest("Architecture",CTy"Architecture",qVar"s"))),
      Close
        (Var("v",CTy"Architecture"),
         MU(Bop(In,Var("v",CTy"Architecture"),
                SL[LC("ARMv6T2",CTy"Architecture"),
                   LC("ARMv7_A",CTy"Architecture"),
                   LC("ARMv7_R",CTy"Architecture")]),qTy))))
;
val HaveThumbEE_def = Def
  ("HaveThumbEE",AVar uTy,
   MB(MR(Close(qVar"s",Dest("Architecture",CTy"Architecture",qVar"s"))),
      Close
        (Var("v",CTy"Architecture"),
         MB(MU(EQ(Var("v",CTy"Architecture"),
                  LC("ARMv7_A",CTy"Architecture")),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",MU(LT,qTy),
                   MB(MR(Close
                           (qVar"s",
                            Dest("Architecture",CTy"Architecture",qVar"s"))),
                      Close
                        (Var("v",CTy"Architecture"),
                         MB(MU(EQ(Var("v",CTy"Architecture"),
                                  LC("ARMv7_R",CTy"Architecture")),qTy),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest
                                              ("Extensions",
                                               STy(CTy"Extensions"),
                                               qVar"s"))),
                                      Close
                                        (Var("v",STy(CTy"Extensions")),
                                         MU(Bop(In,
                                                LC("Extension_ThumbEE",
                                                   CTy"Extensions"),
                                                Var("v",
                                                    STy(CTy"Extensions"))),
                                            qTy))),MU(LF,qTy))))))))))))
;
val HaveMPExt_def = Def
  ("HaveMPExt",AVar uTy,
   MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
      Close
        (nVar"v",
         MB(MU(Bop(Ge,nVar"v",LN 7),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("Extensions",STy(CTy"Extensions"),qVar"s"))),
                      Close
                        (Var("v",STy(CTy"Extensions")),
                         MU(Bop(In,
                                LC("Extension_Multiprocessing",
                                   CTy"Extensions"),
                                Var("v",STy(CTy"Extensions"))),qTy))),
                   MU(LF,qTy)))))))
;
val HaveSecurityExt_def = Def
  ("HaveSecurityExt",AVar uTy,
   MB(MR(Close(qVar"s",Dest("Architecture",CTy"Architecture",qVar"s"))),
      Close
        (Var("v",CTy"Architecture"),
         MB(MU(Bop(In,Var("v",CTy"Architecture"),
                   SL[LC("ARMv6K",CTy"Architecture"),
                      LC("ARMv7_A",CTy"Architecture")]),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("Extensions",STy(CTy"Extensions"),qVar"s"))),
                      Close
                        (Var("v",STy(CTy"Extensions")),
                         MU(Bop(In,
                                LC("Extension_Security",CTy"Extensions"),
                                Var("v",STy(CTy"Extensions"))),qTy))),
                   MU(LF,qTy)))))))
;
val HaveVirtExt_def = Def
  ("HaveVirtExt",AVar uTy,
   MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
      Close
        (nVar"v",
         MB(MU(Bop(Ge,nVar"v",LN 7),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("Extensions",STy(CTy"Extensions"),qVar"s"))),
                      Close
                        (Var("v",STy(CTy"Extensions")),
                         MU(Bop(In,
                                LC("Extension_Virtualization",
                                   CTy"Extensions"),
                                Var("v",STy(CTy"Extensions"))),qTy))),
                   MU(LF,qTy)))))))
;
val rec'PSR_def = Def
  ("rec'PSR",Var("x",F32),
   Rec(CTy"PSR",
       [Bop(Bit,Var("x",F32),LN 8),Bop(Bit,Var("x",F32),LN 29),
        Bop(Bit,Var("x",F32),LN 9),Bop(Bit,Var("x",F32),LN 6),
        EX(Var("x",F32),LN 19,LN 16,F4),Bop(Bit,Var("x",F32),LN 7),
        CC[EX(Var("x",F32),LN 15,LN 10,FTy 6),
           EX(Var("x",F32),LN 26,LN 25,FTy 2)],
        Bop(Bit,Var("x",F32),LN 24),EX(Var("x",F32),LN 4,LN 0,FTy 5),
        Bop(Bit,Var("x",F32),LN 31),Bop(Bit,Var("x",F32),LN 27),
        Bop(Bit,Var("x",F32),LN 5),Bop(Bit,Var("x",F32),LN 28),
        Bop(Bit,Var("x",F32),LN 30),EX(Var("x",F32),LN 23,LN 20,F4)]))
;
val reg'PSR_def = Def
  ("reg'PSR",Var("x",CTy"PSR"),
   CS(Var("x",CTy"PSR"),
      [(Rec(CTy"PSR",
            [bVar"A",bVar"C",bVar"E",bVar"F",Var("GE",F4),bVar"I",
             Var("IT",F8),bVar"J",Var("M",FTy 5),bVar"N",bVar"Q",bVar"T",
             bVar"V",bVar"Z",Var("psr'rst",F4)]),
        Bop(Mdfy,
            Close
              (TP[nVar"i",AVar bTy],
               ITB([(EQ(nVar"i",LN 31),bVar"N"),
                    (EQ(nVar"i",LN 30),bVar"Z"),
                    (EQ(nVar"i",LN 29),bVar"C"),
                    (EQ(nVar"i",LN 28),bVar"V"),
                    (EQ(nVar"i",LN 27),bVar"Q"),
                    (EQ(nVar"i",LN 26),Bop(Bit,Var("IT",F8),LN 1)),
                    (EQ(nVar"i",LN 25),Bop(Bit,Var("IT",F8),LN 0)),
                    (EQ(nVar"i",LN 24),bVar"J"),
                    (EQ(nVar"i",LN 23),Bop(Bit,Var("psr'rst",F4),LN 3)),
                    (EQ(nVar"i",LN 22),Bop(Bit,Var("psr'rst",F4),LN 2)),
                    (EQ(nVar"i",LN 21),Bop(Bit,Var("psr'rst",F4),LN 1)),
                    (EQ(nVar"i",LN 20),Bop(Bit,Var("psr'rst",F4),LN 0)),
                    (EQ(nVar"i",LN 19),Bop(Bit,Var("GE",F4),LN 3)),
                    (EQ(nVar"i",LN 18),Bop(Bit,Var("GE",F4),LN 2)),
                    (EQ(nVar"i",LN 17),Bop(Bit,Var("GE",F4),LN 1)),
                    (EQ(nVar"i",LN 16),Bop(Bit,Var("GE",F4),LN 0)),
                    (EQ(nVar"i",LN 15),Bop(Bit,Var("IT",F8),LN 7)),
                    (EQ(nVar"i",LN 14),Bop(Bit,Var("IT",F8),LN 6)),
                    (EQ(nVar"i",LN 13),Bop(Bit,Var("IT",F8),LN 5)),
                    (EQ(nVar"i",LN 12),Bop(Bit,Var("IT",F8),LN 4)),
                    (EQ(nVar"i",LN 11),Bop(Bit,Var("IT",F8),LN 3)),
                    (EQ(nVar"i",LN 10),Bop(Bit,Var("IT",F8),LN 2)),
                    (EQ(nVar"i",LN 9),bVar"E"),(EQ(nVar"i",LN 8),bVar"A"),
                    (EQ(nVar"i",LN 7),bVar"I"),(EQ(nVar"i",LN 6),bVar"F"),
                    (EQ(nVar"i",LN 5),bVar"T"),
                    (EQ(nVar"i",LN 4),Bop(Bit,Var("M",FTy 5),LN 4)),
                    (EQ(nVar"i",LN 3),Bop(Bit,Var("M",FTy 5),LN 3)),
                    (EQ(nVar"i",LN 2),Bop(Bit,Var("M",FTy 5),LN 2)),
                    (EQ(nVar"i",LN 1),Bop(Bit,Var("M",FTy 5),LN 1))],
                   Bop(Bit,Var("M",FTy 5),LN 0))),LW(0,32)))]))
;
val write'rec'PSR_def = Def
  ("write'rec'PSR",TP[AVar F32,Var("x",CTy"PSR")],
   Call("reg'PSR",F32,Var("x",CTy"PSR")))
;
val write'reg'PSR_def = Def
  ("write'reg'PSR",TP[AVar(CTy"PSR"),Var("x",F32)],
   Call("rec'PSR",CTy"PSR",Var("x",F32)))
;
val rec'SCTLR_def = Def
  ("rec'SCTLR",Var("x",F32),
   Rec(CTy"SCTLR",
       [Bop(Bit,Var("x",F32),LN 1),Bop(Bit,Var("x",F32),LN 7),
        Bop(Bit,Var("x",F32),LN 17),Bop(Bit,Var("x",F32),LN 2),
        Bop(Bit,Var("x",F32),LN 19),Bop(Bit,Var("x",F32),LN 25),
        Bop(Bit,Var("x",F32),LN 21),Bop(Bit,Var("x",F32),LN 12),
        Bop(Bit,Var("x",F32),LN 31),Bop(Bit,Var("x",F32),LN 0),
        Bop(Bit,Var("x",F32),LN 27),Bop(Bit,Var("x",F32),LN 14),
        Bop(Bit,Var("x",F32),LN 10),Bop(Bit,Var("x",F32),LN 30),
        Bop(Bit,Var("x",F32),LN 22),Bop(Bit,Var("x",F32),LN 13),
        Bop(Bit,Var("x",F32),LN 24),Bop(Bit,Var("x",F32),LN 11),
        CC[EX(Var("x",F32),LN 6,LN 3,F4),EX(Var("x",F32),LN 9,LN 8,FTy 2),
           EX(Var("x",F32),LN 16,LN 15,FTy 2),
           EX(Var("x",F32),LN 18,LN 18,F1),
           EX(Var("x",F32),LN 20,LN 20,F1),
           EX(Var("x",F32),LN 23,LN 23,F1),
           EX(Var("x",F32),LN 26,LN 26,F1),
           EX(Var("x",F32),LN 29,LN 28,FTy 2)]]))
;
val reg'SCTLR_def = Def
  ("reg'SCTLR",Var("x",CTy"SCTLR"),
   CS(Var("x",CTy"SCTLR"),
      [(Rec(CTy"SCTLR",
            [bVar"A",bVar"B",bVar"BR",bVar"C",bVar"DZ",bVar"EE",bVar"FI",
             bVar"I",bVar"IE",bVar"M",bVar"NMFI",bVar"RR",bVar"SW",
             bVar"TE",bVar"U",bVar"V",bVar"VE",bVar"Z",
             Var("sctlr'rst",FTy 14)]),
        Bop(Mdfy,
            Close
              (TP[nVar"i",AVar bTy],
               ITB([(EQ(nVar"i",LN 31),bVar"IE"),
                    (EQ(nVar"i",LN 30),bVar"TE"),
                    (EQ(nVar"i",LN 29),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 1)),
                    (EQ(nVar"i",LN 28),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 0)),
                    (EQ(nVar"i",LN 27),bVar"NMFI"),
                    (EQ(nVar"i",LN 26),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 2)),
                    (EQ(nVar"i",LN 25),bVar"EE"),
                    (EQ(nVar"i",LN 24),bVar"VE"),
                    (EQ(nVar"i",LN 23),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 3)),
                    (EQ(nVar"i",LN 22),bVar"U"),
                    (EQ(nVar"i",LN 21),bVar"FI"),
                    (EQ(nVar"i",LN 20),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 4)),
                    (EQ(nVar"i",LN 19),bVar"DZ"),
                    (EQ(nVar"i",LN 18),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 5)),
                    (EQ(nVar"i",LN 17),bVar"BR"),
                    (EQ(nVar"i",LN 16),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 7)),
                    (EQ(nVar"i",LN 15),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 6)),
                    (EQ(nVar"i",LN 14),bVar"RR"),
                    (EQ(nVar"i",LN 13),bVar"V"),
                    (EQ(nVar"i",LN 12),bVar"I"),
                    (EQ(nVar"i",LN 11),bVar"Z"),
                    (EQ(nVar"i",LN 10),bVar"SW"),
                    (EQ(nVar"i",LN 9),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 9)),
                    (EQ(nVar"i",LN 8),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 8)),
                    (EQ(nVar"i",LN 7),bVar"B"),
                    (EQ(nVar"i",LN 6),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 13)),
                    (EQ(nVar"i",LN 5),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 12)),
                    (EQ(nVar"i",LN 4),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 11)),
                    (EQ(nVar"i",LN 3),
                     Bop(Bit,Var("sctlr'rst",FTy 14),LN 10)),
                    (EQ(nVar"i",LN 2),bVar"C"),(EQ(nVar"i",LN 1),bVar"A")],
                   bVar"M")),LW(0,32)))]))
;
val write'rec'SCTLR_def = Def
  ("write'rec'SCTLR",TP[AVar F32,Var("x",CTy"SCTLR")],
   Call("reg'SCTLR",F32,Var("x",CTy"SCTLR")))
;
val write'reg'SCTLR_def = Def
  ("write'reg'SCTLR",TP[AVar(CTy"SCTLR"),Var("x",F32)],
   Call("rec'SCTLR",CTy"SCTLR",Var("x",F32)))
;
val rec'HSCTLR_def = Def
  ("rec'HSCTLR",Var("x",F32),
   Rec(CTy"HSCTLR",
       [Bop(Bit,Var("x",F32),LN 1),Bop(Bit,Var("x",F32),LN 2),
        Bop(Bit,Var("x",F32),LN 5),Bop(Bit,Var("x",F32),LN 25),
        Bop(Bit,Var("x",F32),LN 21),Bop(Bit,Var("x",F32),LN 12),
        Bop(Bit,Var("x",F32),LN 0),Bop(Bit,Var("x",F32),LN 30),
        Bop(Bit,Var("x",F32),LN 19),
        CC[EX(Var("x",F32),LN 4,LN 3,FTy 2),
           EX(Var("x",F32),LN 11,LN 6,FTy 6),
           EX(Var("x",F32),LN 18,LN 13,FTy 6),
           EX(Var("x",F32),LN 20,LN 20,F1),
           EX(Var("x",F32),LN 24,LN 22,FTy 3),
           EX(Var("x",F32),LN 29,LN 26,F4),EX(Var("x",F32),LN 31,LN 31,F1)]]))
;
val reg'HSCTLR_def = Def
  ("reg'HSCTLR",Var("x",CTy"HSCTLR"),
   CS(Var("x",CTy"HSCTLR"),
      [(Rec(CTy"HSCTLR",
            [bVar"A",bVar"C",bVar"CP15BEN",bVar"EE",bVar"FI",bVar"I",
             bVar"M",bVar"TE",bVar"WXN",Var("hsctlr'rst",FTy 23)]),
        Bop(Mdfy,
            Close
              (TP[nVar"i",AVar bTy],
               ITB([(EQ(nVar"i",LN 31),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 0)),
                    (EQ(nVar"i",LN 30),bVar"TE"),
                    (EQ(nVar"i",LN 29),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 4)),
                    (EQ(nVar"i",LN 28),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 3)),
                    (EQ(nVar"i",LN 27),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 2)),
                    (EQ(nVar"i",LN 26),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 1)),
                    (EQ(nVar"i",LN 25),bVar"EE"),
                    (EQ(nVar"i",LN 24),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 7)),
                    (EQ(nVar"i",LN 23),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 6)),
                    (EQ(nVar"i",LN 22),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 5)),
                    (EQ(nVar"i",LN 21),bVar"FI"),
                    (EQ(nVar"i",LN 20),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 8)),
                    (EQ(nVar"i",LN 19),bVar"WXN"),
                    (EQ(nVar"i",LN 18),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 14)),
                    (EQ(nVar"i",LN 17),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 13)),
                    (EQ(nVar"i",LN 16),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 12)),
                    (EQ(nVar"i",LN 15),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 11)),
                    (EQ(nVar"i",LN 14),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 10)),
                    (EQ(nVar"i",LN 13),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 9)),
                    (EQ(nVar"i",LN 12),bVar"I"),
                    (EQ(nVar"i",LN 11),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 20)),
                    (EQ(nVar"i",LN 10),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 19)),
                    (EQ(nVar"i",LN 9),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 18)),
                    (EQ(nVar"i",LN 8),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 17)),
                    (EQ(nVar"i",LN 7),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 16)),
                    (EQ(nVar"i",LN 6),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 15)),
                    (EQ(nVar"i",LN 5),bVar"CP15BEN"),
                    (EQ(nVar"i",LN 4),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 22)),
                    (EQ(nVar"i",LN 3),
                     Bop(Bit,Var("hsctlr'rst",FTy 23),LN 21)),
                    (EQ(nVar"i",LN 2),bVar"C"),(EQ(nVar"i",LN 1),bVar"A")],
                   bVar"M")),LW(0,32)))]))
;
val write'rec'HSCTLR_def = Def
  ("write'rec'HSCTLR",TP[AVar F32,Var("x",CTy"HSCTLR")],
   Call("reg'HSCTLR",F32,Var("x",CTy"HSCTLR")))
;
val write'reg'HSCTLR_def = Def
  ("write'reg'HSCTLR",TP[AVar(CTy"HSCTLR"),Var("x",F32)],
   Call("rec'HSCTLR",CTy"HSCTLR",Var("x",F32)))
;
val rec'HSR_def = Def
  ("rec'HSR",Var("x",F32),
   Rec(CTy"HSR",
       [EX(Var("x",F32),LN 31,LN 26,FTy 6),Bop(Bit,Var("x",F32),LN 25),
        EX(Var("x",F32),LN 24,LN 0,FTy 25)]))
;
val reg'HSR_def = Def
  ("reg'HSR",Var("x",CTy"HSR"),
   CS(Var("x",CTy"HSR"),
      [(Rec(CTy"HSR",[Var("EC",FTy 6),bVar"IL",Var("ISS",FTy 25)]),
        Bop(Mdfy,
            Close
              (TP[nVar"i",AVar bTy],
               ITB([(EQ(nVar"i",LN 31),Bop(Bit,Var("EC",FTy 6),LN 5)),
                    (EQ(nVar"i",LN 30),Bop(Bit,Var("EC",FTy 6),LN 4)),
                    (EQ(nVar"i",LN 29),Bop(Bit,Var("EC",FTy 6),LN 3)),
                    (EQ(nVar"i",LN 28),Bop(Bit,Var("EC",FTy 6),LN 2)),
                    (EQ(nVar"i",LN 27),Bop(Bit,Var("EC",FTy 6),LN 1)),
                    (EQ(nVar"i",LN 26),Bop(Bit,Var("EC",FTy 6),LN 0)),
                    (EQ(nVar"i",LN 25),bVar"IL"),
                    (EQ(nVar"i",LN 24),Bop(Bit,Var("ISS",FTy 25),LN 24)),
                    (EQ(nVar"i",LN 23),Bop(Bit,Var("ISS",FTy 25),LN 23)),
                    (EQ(nVar"i",LN 22),Bop(Bit,Var("ISS",FTy 25),LN 22)),
                    (EQ(nVar"i",LN 21),Bop(Bit,Var("ISS",FTy 25),LN 21)),
                    (EQ(nVar"i",LN 20),Bop(Bit,Var("ISS",FTy 25),LN 20)),
                    (EQ(nVar"i",LN 19),Bop(Bit,Var("ISS",FTy 25),LN 19)),
                    (EQ(nVar"i",LN 18),Bop(Bit,Var("ISS",FTy 25),LN 18)),
                    (EQ(nVar"i",LN 17),Bop(Bit,Var("ISS",FTy 25),LN 17)),
                    (EQ(nVar"i",LN 16),Bop(Bit,Var("ISS",FTy 25),LN 16)),
                    (EQ(nVar"i",LN 15),Bop(Bit,Var("ISS",FTy 25),LN 15)),
                    (EQ(nVar"i",LN 14),Bop(Bit,Var("ISS",FTy 25),LN 14)),
                    (EQ(nVar"i",LN 13),Bop(Bit,Var("ISS",FTy 25),LN 13)),
                    (EQ(nVar"i",LN 12),Bop(Bit,Var("ISS",FTy 25),LN 12)),
                    (EQ(nVar"i",LN 11),Bop(Bit,Var("ISS",FTy 25),LN 11)),
                    (EQ(nVar"i",LN 10),Bop(Bit,Var("ISS",FTy 25),LN 10)),
                    (EQ(nVar"i",LN 9),Bop(Bit,Var("ISS",FTy 25),LN 9)),
                    (EQ(nVar"i",LN 8),Bop(Bit,Var("ISS",FTy 25),LN 8)),
                    (EQ(nVar"i",LN 7),Bop(Bit,Var("ISS",FTy 25),LN 7)),
                    (EQ(nVar"i",LN 6),Bop(Bit,Var("ISS",FTy 25),LN 6)),
                    (EQ(nVar"i",LN 5),Bop(Bit,Var("ISS",FTy 25),LN 5)),
                    (EQ(nVar"i",LN 4),Bop(Bit,Var("ISS",FTy 25),LN 4)),
                    (EQ(nVar"i",LN 3),Bop(Bit,Var("ISS",FTy 25),LN 3)),
                    (EQ(nVar"i",LN 2),Bop(Bit,Var("ISS",FTy 25),LN 2)),
                    (EQ(nVar"i",LN 1),Bop(Bit,Var("ISS",FTy 25),LN 1))],
                   Bop(Bit,Var("ISS",FTy 25),LN 0))),LW(0,32)))]))
;
val write'rec'HSR_def = Def
  ("write'rec'HSR",TP[AVar F32,Var("x",CTy"HSR")],
   Call("reg'HSR",F32,Var("x",CTy"HSR")))
;
val write'reg'HSR_def = Def
  ("write'reg'HSR",TP[AVar(CTy"HSR"),Var("x",F32)],
   Call("rec'HSR",CTy"HSR",Var("x",F32)))
;
val rec'SCR_def = Def
  ("rec'SCR",Var("x",F32),
   Rec(CTy"SCR",
       [Bop(Bit,Var("x",F32),LN 5),Bop(Bit,Var("x",F32),LN 3),
        Bop(Bit,Var("x",F32),LN 2),Bop(Bit,Var("x",F32),LN 4),
        Bop(Bit,Var("x",F32),LN 8),Bop(Bit,Var("x",F32),LN 1),
        Bop(Bit,Var("x",F32),LN 0),Bop(Bit,Var("x",F32),LN 7),
        Bop(Bit,Var("x",F32),LN 9),Bop(Bit,Var("x",F32),LN 6),
        EX(Var("x",F32),LN 31,LN 10,FTy 22)]))
;
val reg'SCR_def = Def
  ("reg'SCR",Var("x",CTy"SCR"),
   CS(Var("x",CTy"SCR"),
      [(Rec(CTy"SCR",
            [bVar"AW",bVar"EA",bVar"FIQ",bVar"FW",bVar"HCE",bVar"IRQ",
             bVar"NS",bVar"SCD",bVar"SIF",bVar"nET",Var("scr'rst",FTy 22)]),
        Bop(Mdfy,
            Close
              (TP[nVar"i",AVar bTy],
               ITB([(EQ(nVar"i",LN 31),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 21)),
                    (EQ(nVar"i",LN 30),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 20)),
                    (EQ(nVar"i",LN 29),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 19)),
                    (EQ(nVar"i",LN 28),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 18)),
                    (EQ(nVar"i",LN 27),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 17)),
                    (EQ(nVar"i",LN 26),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 16)),
                    (EQ(nVar"i",LN 25),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 15)),
                    (EQ(nVar"i",LN 24),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 14)),
                    (EQ(nVar"i",LN 23),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 13)),
                    (EQ(nVar"i",LN 22),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 12)),
                    (EQ(nVar"i",LN 21),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 11)),
                    (EQ(nVar"i",LN 20),
                     Bop(Bit,Var("scr'rst",FTy 22),LN 10)),
                    (EQ(nVar"i",LN 19),Bop(Bit,Var("scr'rst",FTy 22),LN 9)),
                    (EQ(nVar"i",LN 18),Bop(Bit,Var("scr'rst",FTy 22),LN 8)),
                    (EQ(nVar"i",LN 17),Bop(Bit,Var("scr'rst",FTy 22),LN 7)),
                    (EQ(nVar"i",LN 16),Bop(Bit,Var("scr'rst",FTy 22),LN 6)),
                    (EQ(nVar"i",LN 15),Bop(Bit,Var("scr'rst",FTy 22),LN 5)),
                    (EQ(nVar"i",LN 14),Bop(Bit,Var("scr'rst",FTy 22),LN 4)),
                    (EQ(nVar"i",LN 13),Bop(Bit,Var("scr'rst",FTy 22),LN 3)),
                    (EQ(nVar"i",LN 12),Bop(Bit,Var("scr'rst",FTy 22),LN 2)),
                    (EQ(nVar"i",LN 11),Bop(Bit,Var("scr'rst",FTy 22),LN 1)),
                    (EQ(nVar"i",LN 10),Bop(Bit,Var("scr'rst",FTy 22),LN 0)),
                    (EQ(nVar"i",LN 9),bVar"SIF"),
                    (EQ(nVar"i",LN 8),bVar"HCE"),
                    (EQ(nVar"i",LN 7),bVar"SCD"),
                    (EQ(nVar"i",LN 6),bVar"nET"),
                    (EQ(nVar"i",LN 5),bVar"AW"),
                    (EQ(nVar"i",LN 4),bVar"FW"),
                    (EQ(nVar"i",LN 3),bVar"EA"),
                    (EQ(nVar"i",LN 2),bVar"FIQ"),
                    (EQ(nVar"i",LN 1),bVar"IRQ")],bVar"NS")),LW(0,32)))]))
;
val write'rec'SCR_def = Def
  ("write'rec'SCR",TP[AVar F32,Var("x",CTy"SCR")],
   Call("reg'SCR",F32,Var("x",CTy"SCR")))
;
val write'reg'SCR_def = Def
  ("write'reg'SCR",TP[AVar(CTy"SCR"),Var("x",F32)],
   Call("rec'SCR",CTy"SCR",Var("x",F32)))
;
val rec'NSACR_def = Def
  ("rec'NSACR",Var("x",F32),
   Rec(CTy"NSACR",
       [Bop(Bit,Var("x",F32),LN 15),Bop(Bit,Var("x",F32),LN 14),
        Bop(Bit,Var("x",F32),LN 20),Bop(Bit,Var("x",F32),LN 19),
        EX(Var("x",F32),LN 13,LN 0,FTy 14),
        CC[EX(Var("x",F32),LN 18,LN 16,FTy 3),
           EX(Var("x",F32),LN 31,LN 21,FTy 11)]]))
;
val reg'NSACR_def = Def
  ("reg'NSACR",Var("x",CTy"NSACR"),
   CS(Var("x",CTy"NSACR"),
      [(Rec(CTy"NSACR",
            [bVar"NSASEDIS",bVar"NSD32DIS",bVar"NSTRCDIS",bVar"RFR",
             Var("cp",FTy 14),Var("nsacr'rst",FTy 14)]),
        Bop(Mdfy,
            Close
              (TP[nVar"i",AVar bTy],
               ITB([(EQ(nVar"i",LN 31),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 10)),
                    (EQ(nVar"i",LN 30),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 9)),
                    (EQ(nVar"i",LN 29),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 8)),
                    (EQ(nVar"i",LN 28),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 7)),
                    (EQ(nVar"i",LN 27),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 6)),
                    (EQ(nVar"i",LN 26),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 5)),
                    (EQ(nVar"i",LN 25),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 4)),
                    (EQ(nVar"i",LN 24),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 3)),
                    (EQ(nVar"i",LN 23),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 2)),
                    (EQ(nVar"i",LN 22),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 1)),
                    (EQ(nVar"i",LN 21),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 0)),
                    (EQ(nVar"i",LN 20),bVar"NSTRCDIS"),
                    (EQ(nVar"i",LN 19),bVar"RFR"),
                    (EQ(nVar"i",LN 18),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 13)),
                    (EQ(nVar"i",LN 17),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 12)),
                    (EQ(nVar"i",LN 16),
                     Bop(Bit,Var("nsacr'rst",FTy 14),LN 11)),
                    (EQ(nVar"i",LN 15),bVar"NSASEDIS"),
                    (EQ(nVar"i",LN 14),bVar"NSD32DIS"),
                    (EQ(nVar"i",LN 13),Bop(Bit,Var("cp",FTy 14),LN 13)),
                    (EQ(nVar"i",LN 12),Bop(Bit,Var("cp",FTy 14),LN 12)),
                    (EQ(nVar"i",LN 11),Bop(Bit,Var("cp",FTy 14),LN 11)),
                    (EQ(nVar"i",LN 10),Bop(Bit,Var("cp",FTy 14),LN 10)),
                    (EQ(nVar"i",LN 9),Bop(Bit,Var("cp",FTy 14),LN 9)),
                    (EQ(nVar"i",LN 8),Bop(Bit,Var("cp",FTy 14),LN 8)),
                    (EQ(nVar"i",LN 7),Bop(Bit,Var("cp",FTy 14),LN 7)),
                    (EQ(nVar"i",LN 6),Bop(Bit,Var("cp",FTy 14),LN 6)),
                    (EQ(nVar"i",LN 5),Bop(Bit,Var("cp",FTy 14),LN 5)),
                    (EQ(nVar"i",LN 4),Bop(Bit,Var("cp",FTy 14),LN 4)),
                    (EQ(nVar"i",LN 3),Bop(Bit,Var("cp",FTy 14),LN 3)),
                    (EQ(nVar"i",LN 2),Bop(Bit,Var("cp",FTy 14),LN 2)),
                    (EQ(nVar"i",LN 1),Bop(Bit,Var("cp",FTy 14),LN 1))],
                   Bop(Bit,Var("cp",FTy 14),LN 0))),LW(0,32)))]))
;
val write'rec'NSACR_def = Def
  ("write'rec'NSACR",TP[AVar F32,Var("x",CTy"NSACR")],
   Call("reg'NSACR",F32,Var("x",CTy"NSACR")))
;
val write'reg'NSACR_def = Def
  ("write'reg'NSACR",TP[AVar(CTy"NSACR"),Var("x",F32)],
   Call("rec'NSACR",CTy"NSACR",Var("x",F32)))
;
val rec'HCR_def = Def
  ("rec'HCR",Var("x",F32),
   Rec(CTy"HCR",
       [Bop(Bit,Var("x",F32),LN 5),EX(Var("x",F32),LN 11,LN 10,FTy 2),
        Bop(Bit,Var("x",F32),LN 12),Bop(Bit,Var("x",F32),LN 9),
        Bop(Bit,Var("x",F32),LN 3),Bop(Bit,Var("x",F32),LN 4),
        Bop(Bit,Var("x",F32),LN 2),Bop(Bit,Var("x",F32),LN 1),
        Bop(Bit,Var("x",F32),LN 21),Bop(Bit,Var("x",F32),LN 27),
        EX(Var("x",F32),LN 18,LN 15,F4),Bop(Bit,Var("x",F32),LN 20),
        Bop(Bit,Var("x",F32),LN 23),Bop(Bit,Var("x",F32),LN 24),
        Bop(Bit,Var("x",F32),LN 19),Bop(Bit,Var("x",F32),LN 22),
        Bop(Bit,Var("x",F32),LN 25),Bop(Bit,Var("x",F32),LN 26),
        Bop(Bit,Var("x",F32),LN 14),Bop(Bit,Var("x",F32),LN 13),
        Bop(Bit,Var("x",F32),LN 8),Bop(Bit,Var("x",F32),LN 6),
        Bop(Bit,Var("x",F32),LN 7),Bop(Bit,Var("x",F32),LN 0),
        EX(Var("x",F32),LN 31,LN 28,F4)]))
;
val reg'HCR_def = Def
  ("reg'HCR",Var("x",CTy"HCR"),
   CS(Var("x",CTy"HCR"),
      [(Rec(CTy"HCR",
            [bVar"AMO",Var("BSU",FTy 2),bVar"DC",bVar"FB",bVar"FMO",
             bVar"IMO",bVar"PTW",bVar"SWIO",bVar"TAC",bVar"TGE",
             Var("TID",F4),bVar"TIDCP",bVar"TPC",bVar"TPU",bVar"TSC",
             bVar"TSW",bVar"TTLB",bVar"TVM",bVar"TWE",bVar"TWI",bVar"VA",
             bVar"VF",bVar"VI",bVar"VM",Var("hcr'rst",F4)]),
        Bop(Mdfy,
            Close
              (TP[nVar"i",AVar bTy],
               ITB([(EQ(nVar"i",LN 31),Bop(Bit,Var("hcr'rst",F4),LN 3)),
                    (EQ(nVar"i",LN 30),Bop(Bit,Var("hcr'rst",F4),LN 2)),
                    (EQ(nVar"i",LN 29),Bop(Bit,Var("hcr'rst",F4),LN 1)),
                    (EQ(nVar"i",LN 28),Bop(Bit,Var("hcr'rst",F4),LN 0)),
                    (EQ(nVar"i",LN 27),bVar"TGE"),
                    (EQ(nVar"i",LN 26),bVar"TVM"),
                    (EQ(nVar"i",LN 25),bVar"TTLB"),
                    (EQ(nVar"i",LN 24),bVar"TPU"),
                    (EQ(nVar"i",LN 23),bVar"TPC"),
                    (EQ(nVar"i",LN 22),bVar"TSW"),
                    (EQ(nVar"i",LN 21),bVar"TAC"),
                    (EQ(nVar"i",LN 20),bVar"TIDCP"),
                    (EQ(nVar"i",LN 19),bVar"TSC"),
                    (EQ(nVar"i",LN 18),Bop(Bit,Var("TID",F4),LN 3)),
                    (EQ(nVar"i",LN 17),Bop(Bit,Var("TID",F4),LN 2)),
                    (EQ(nVar"i",LN 16),Bop(Bit,Var("TID",F4),LN 1)),
                    (EQ(nVar"i",LN 15),Bop(Bit,Var("TID",F4),LN 0)),
                    (EQ(nVar"i",LN 14),bVar"TWE"),
                    (EQ(nVar"i",LN 13),bVar"TWI"),
                    (EQ(nVar"i",LN 12),bVar"DC"),
                    (EQ(nVar"i",LN 11),Bop(Bit,Var("BSU",FTy 2),LN 1)),
                    (EQ(nVar"i",LN 10),Bop(Bit,Var("BSU",FTy 2),LN 0)),
                    (EQ(nVar"i",LN 9),bVar"FB"),
                    (EQ(nVar"i",LN 8),bVar"VA"),
                    (EQ(nVar"i",LN 7),bVar"VI"),
                    (EQ(nVar"i",LN 6),bVar"VF"),
                    (EQ(nVar"i",LN 5),bVar"AMO"),
                    (EQ(nVar"i",LN 4),bVar"IMO"),
                    (EQ(nVar"i",LN 3),bVar"FMO"),
                    (EQ(nVar"i",LN 2),bVar"PTW"),
                    (EQ(nVar"i",LN 1),bVar"SWIO")],bVar"VM")),LW(0,32)))]))
;
val write'rec'HCR_def = Def
  ("write'rec'HCR",TP[AVar F32,Var("x",CTy"HCR")],
   Call("reg'HCR",F32,Var("x",CTy"HCR")))
;
val write'reg'HCR_def = Def
  ("write'reg'HCR",TP[AVar(CTy"HCR"),Var("x",F32)],
   Call("rec'HCR",CTy"HCR",Var("x",F32)))
;
val ProcessorID_def = Def ("ProcessorID",AVar uTy,LI 0)
;
val IsExternalAbort_def = Def
  ("IsExternalAbort",AVar uTy,
   MB(MR(Close(qVar"s",Dest("external_abort_oracle",ATy(nTy,bTy),qVar"s"))),
      Close
        (Var("v",ATy(nTy,bTy)),
         MB(MB(MR(Close
                    (qVar"s",
                     Dest("external_abort_oracle_count",nTy,qVar"s"))),
               Close
                 (nVar"v0",MU(Apply(Var("v",ATy(nTy,bTy)),nVar"v0"),qTy))),
            Close
              (bVar"ext",
               MB(MR(Close
                       (qVar"s",
                        Dest("external_abort_oracle_count",nTy,qVar"s"))),
                  Close
                    (nVar"v",
                     MB(MB(MU(Bop(Add,nVar"v",LN 1),qTy),
                           Close
                             (nVar"v",
                              MW(Close
                                   (qVar"s",
                                    Rupd
                                      ("external_abort_oracle_count",
                                       TP[qVar"s",nVar"v"]))))),
                        Close(AVar uTy,MU(bVar"ext",qTy))))))))))
;
val IsSecure_def = Def
  ("IsSecure",AVar uTy,
   MB(Call("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(MU(Mop(Not,bVar"v"),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",MU(LT,qTy),
                      MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
                         Close
                           (Var("v",CTy"CP15"),
                            MB(MB(MU(Dest
                                       ("SCR",CTy"SCR",Var("v",CTy"CP15")),
                                     qTy),
                                  Close
                                    (Var("v",CTy"SCR"),
                                     MU(Dest("NS",bTy,Var("v",CTy"SCR")),
                                        qTy))),
                               Close(bVar"v",MU(Mop(Not,bVar"v"),qTy)))))))),
            Close
              (bVar"b",
               ITE(bVar"b",MU(LT,qTy),
                   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                      Close
                        (Var("v",CTy"PSR"),
                         MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                            Close
                              (Var("v",FTy 5),
                               MU(EQ(Var("v",FTy 5),LW(22,5)),qTy)))))))))))
;
val UnalignedSupport_def = Def
  ("UnalignedSupport",AVar uTy,
   MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
      Close
        (nVar"v",
         MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
            Close
              (Var("v0",CTy"CP15"),
               MB(MB(MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v0",CTy"CP15")),
                           qTy),
                        Close
                          (Var("v",CTy"SCTLR"),
                           MU(Dest("U",bTy,Var("v",CTy"SCTLR")),qTy))),
                     Close
                       (bVar"v0",
                        MU(Bop(And,EQ(nVar"v",LN 6),bVar"v0"),qTy))),
                  Close
                    (bVar"v0",
                     MU(Bop(Or,Bop(Ge,nVar"v",LN 7),bVar"v0"),qTy))))))))
;
val BadMode_def = Def
  ("BadMode",Var("mode",FTy 5),
   CS(Var("mode",FTy 5),
      [(LW(16,5),MU(LF,qTy)),(LW(17,5),MU(LF,qTy)),(LW(18,5),MU(LF,qTy)),
       (LW(19,5),MU(LF,qTy)),
       (LW(22,5),
        MB(Call("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
           Close(bVar"v",MU(Mop(Not,bVar"v"),qTy)))),
       (LW(23,5),MU(LF,qTy)),
       (LW(26,5),
        MB(Call("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
           Close(bVar"v",MU(Mop(Not,bVar"v"),qTy)))),
       (LW(27,5),MU(LF,qTy)),(LW(31,5),MU(LF,qTy)),
       (AVar(FTy 5),MU(LT,qTy))]))
;
val CurrentModeIsNotUser_def = Def
  ("CurrentModeIsNotUser",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                  Close
                    (Var("v",FTy 5),
                     Call("BadMode",ATy(qTy,PTy(bTy,qTy)),Var("v",FTy 5)))),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                         Close
                           (Var("v",CTy"PSR"),
                            MB(MB(MB(MB(MU(Dest
                                             ("M",FTy 5,Var("v",CTy"PSR")),
                                           qTy),
                                        Close
                                          (Var("v",FTy 5),
                                           MU(Mop(Cast sTy,Var("v",FTy 5)),
                                              qTy))),
                                     Close
                                       (sVar"v",
                                        MU(CC[LS"BadMode: ",sVar"v"],qTy))),
                                  Close
                                    (sVar"v",
                                     MU(Call
                                          ("UNPREDICTABLE",CTy"exception",
                                           sVar"v"),qTy))),
                               Close
                                 (Var("v",CTy"exception"),
                                  Call
                                    ("raise'exception",
                                     ATy(qTy,PTy(uTy,qTy)),
                                     Var("v",CTy"exception")))))),
                      MU(LU,qTy)))),
            Close
              (AVar uTy,
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v",CTy"PSR"),
                     MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                           Close
                             (Var("v",FTy 5),
                              MU(EQ(Var("v",FTy 5),LW(16,5)),qTy))),
                        Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))))))))))
;
val CurrentModeIsUserOrSystem_def = Def
  ("CurrentModeIsUserOrSystem",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                  Close
                    (Var("v",FTy 5),
                     Call("BadMode",ATy(qTy,PTy(bTy,qTy)),Var("v",FTy 5)))),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                         Close
                           (Var("v",CTy"PSR"),
                            MB(MB(MB(MB(MU(Dest
                                             ("M",FTy 5,Var("v",CTy"PSR")),
                                           qTy),
                                        Close
                                          (Var("v",FTy 5),
                                           MU(Mop(Cast sTy,Var("v",FTy 5)),
                                              qTy))),
                                     Close
                                       (sVar"v",
                                        MU(CC[LS"BadMode: ",sVar"v"],qTy))),
                                  Close
                                    (sVar"v",
                                     MU(Call
                                          ("UNPREDICTABLE",CTy"exception",
                                           sVar"v"),qTy))),
                               Close
                                 (Var("v",CTy"exception"),
                                  Call
                                    ("raise'exception",
                                     ATy(qTy,PTy(uTy,qTy)),
                                     Var("v",CTy"exception")))))),
                      MU(LU,qTy)))),
            Close
              (AVar uTy,
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v",CTy"PSR"),
                     MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                        Close
                          (Var("v",FTy 5),
                           MU(Bop(In,Var("v",FTy 5),SL[LW(16,5),LW(31,5)]),
                              qTy))))))))))
;
val CurrentModeIsHyp_def = Def
  ("CurrentModeIsHyp",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                  Close
                    (Var("v",FTy 5),
                     Call("BadMode",ATy(qTy,PTy(bTy,qTy)),Var("v",FTy 5)))),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                         Close
                           (Var("v",CTy"PSR"),
                            MB(MB(MB(MB(MU(Dest
                                             ("M",FTy 5,Var("v",CTy"PSR")),
                                           qTy),
                                        Close
                                          (Var("v",FTy 5),
                                           MU(Mop(Cast sTy,Var("v",FTy 5)),
                                              qTy))),
                                     Close
                                       (sVar"v",
                                        MU(CC[LS"BadMode: ",sVar"v"],qTy))),
                                  Close
                                    (sVar"v",
                                     MU(Call
                                          ("UNPREDICTABLE",CTy"exception",
                                           sVar"v"),qTy))),
                               Close
                                 (Var("v",CTy"exception"),
                                  Call
                                    ("raise'exception",
                                     ATy(qTy,PTy(uTy,qTy)),
                                     Var("v",CTy"exception")))))),
                      MU(LU,qTy)))),
            Close
              (AVar uTy,
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v",CTy"PSR"),
                     MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                        Close
                          (Var("v",FTy 5),
                           MU(EQ(Var("v",FTy 5),LW(26,5)),qTy))))))))))
;
val IntegerZeroDivideTrappingEnabled_def = Def
  ("IntegerZeroDivideTrappingEnabled",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
      Close
        (Var("v",CTy"CP15"),
         MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),qTy),
            Close
              (Var("v",CTy"SCTLR"),
               MU(Dest("DZ",bTy,Var("v",CTy"SCTLR")),qTy))))))
;
val ISETSTATE_def = Def0
  ("ISETSTATE",
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("J",bTy,Var("v",CTy"PSR")),qTy),
               Close(bVar"v",MU(Mop(Cast F1,bVar"v"),qTy))),
            Close
              (Var("v",F1),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v0",CTy"PSR"),
                     MB(MB(MU(Dest("T",bTy,Var("v0",CTy"PSR")),qTy),
                           Close(bVar"v",MU(Mop(Cast F1,bVar"v"),qTy))),
                        Close
                          (Var("v0",F1),
                           MU(CC[Var("v",F1),Var("v0",F1)],qTy))))))))))
;
val write'ISETSTATE_def = Def
  ("write'ISETSTATE",Var("value",FTy 2),
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(TP[Var("v",CTy"PSR"),Bop(Bit,Var("value",FTy 2),LN 1)],
                     qTy),
                  Close
                    (Var("v",PTy(CTy"PSR",bTy)),
                     MU(Rupd("J",Var("v",PTy(CTy"PSR",bTy))),qTy))),
               Close
                 (Var("v",CTy"PSR"),
                  MW(Close
                       (qVar"s",Rupd("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))),
            Close
              (AVar uTy,
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v",CTy"PSR"),
                     MB(MB(MU(TP[Var("v",CTy"PSR"),
                                 Bop(Bit,Var("value",FTy 2),LN 0)],qTy),
                           Close
                             (Var("v",PTy(CTy"PSR",bTy)),
                              MU(Rupd("T",Var("v",PTy(CTy"PSR",bTy))),qTy))),
                        Close
                          (Var("v",CTy"PSR"),
                           MW(Close
                                (qVar"s",
                                 Rupd
                                   ("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))))))))))
;
val CurrentInstrSet_def = Def
  ("CurrentInstrSet",AVar uTy,
   MB(Const("ISETSTATE",ATy(qTy,PTy(FTy 2,qTy))),
      Close
        (Var("x",FTy 2),
         MU(CS(Var("x",FTy 2),
               [(LW(0,2),LC("InstrSet_ARM",CTy"InstrSet")),
                (LW(1,2),LC("InstrSet_Thumb",CTy"InstrSet")),
                (LW(2,2),LC("InstrSet_Jazelle",CTy"InstrSet")),
                (LW(3,2),LC("InstrSet_ThumbEE",CTy"InstrSet"))]),qTy))))
;
val SelectInstrSet_def = Def
  ("SelectInstrSet",Var("iset",CTy"InstrSet"),
   CS(Var("iset",CTy"InstrSet"),
      [(LC("InstrSet_ARM",CTy"InstrSet"),
        MB(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
           Close
             (Var("v",CTy"InstrSet"),
              MB(MU(EQ(Var("v",CTy"InstrSet"),
                       LC("InstrSet_ThumbEE",CTy"InstrSet")),qTy),
                 Close
                   (bVar"b",
                    ITE(bVar"b",
                        Call
                          ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                           Call
                             ("UNPREDICTABLE",CTy"exception",
                              LS"SelectInstrSet")),
                        Call
                          ("write'ISETSTATE",ATy(qTy,PTy(uTy,qTy)),LW(0,2)))))))),
       (LC("InstrSet_Thumb",CTy"InstrSet"),
        Call("write'ISETSTATE",ATy(qTy,PTy(uTy,qTy)),LW(1,2))),
       (LC("InstrSet_Jazelle",CTy"InstrSet"),
        Call("write'ISETSTATE",ATy(qTy,PTy(uTy,qTy)),LW(2,2))),
       (LC("InstrSet_ThumbEE",CTy"InstrSet"),
        Call("write'ISETSTATE",ATy(qTy,PTy(uTy,qTy)),LW(3,2)))]))
;
val ITSTATE_def = Def0
  ("ITSTATE",
   MB(Call("HaveThumb2",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                Close
                  (Var("v",CTy"PSR"),
                   MU(Dest("IT",F8,Var("v",CTy"PSR")),qTy))),
             MU(LW(0,8),qTy)))))
;
val write'ITSTATE_def = Def
  ("write'ITSTATE",Var("value",F8),
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(TP[Var("v",CTy"PSR"),Var("value",F8)],qTy),
               Close
                 (Var("v",PTy(CTy"PSR",F8)),
                  MU(Rupd("IT",Var("v",PTy(CTy"PSR",F8))),qTy))),
            Close
              (Var("v",CTy"PSR"),
               MW(Close
                    (qVar"s",Rupd("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))))))
;
val ITAdvance_def = Def
  ("ITAdvance",AVar uTy,
   MB(Call("HaveThumb2",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",
                MB(MR(Close
                        (qVar"s",Dest("Encoding",CTy"Encoding",qVar"s"))),
                   Close
                     (Var("v",CTy"Encoding"),
                      MB(MU(EQ(Var("v",CTy"Encoding"),
                               LC("Encoding_ARM",CTy"Encoding")),qTy),
                         Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))))),
                MU(LF,qTy)),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(Const("ITSTATE",ATy(qTy,PTy(F8,qTy))),
                      Close
                        (Var("v",F8),
                         MB(MB(MU(EX(Var("v",F8),LN 2,LN 0,FTy 3),qTy),
                               Close
                                 (Var("v",FTy 3),
                                  MU(EQ(Var("v",FTy 3),LW(0,3)),qTy))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   Call
                                     ("write'ITSTATE",
                                      ATy(qTy,PTy(uTy,qTy)),LW(0,8)),
                                   MB(Const
                                        ("ITSTATE",ATy(qTy,PTy(F8,qTy))),
                                      Close
                                        (Var("w",F8),
                                         MB(Const
                                              ("ITSTATE",
                                               ATy(qTy,PTy(F8,qTy))),
                                            Close
                                              (Var("v",F8),
                                               MB(MB(MB(MU(EX(Var("v",F8),
                                                              LN 4,LN 0,
                                                              FTy 5),qTy),
                                                        Close
                                                          (Var("v",FTy 5),
                                                           MU(Bop(Lsl,
                                                                  Var("v",
                                                                      FTy 5),
                                                                  LN 1),
                                                              qTy))),
                                                     Close
                                                       (Var("v",FTy 5),
                                                        MU(BFI(LN 4,LN 0,
                                                               Var("v",
                                                                   FTy 5),
                                                               Var("w",F8)),
                                                           qTy))),
                                                  Close
                                                    (Var("v",F8),
                                                     Call
                                                       ("write'ITSTATE",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        Var("v",F8))))))))))))),
                   MU(LU,qTy)))))))
;
val InITBlock_def = Def
  ("InITBlock",AVar uTy,
   MB(Const("ITSTATE",ATy(qTy,PTy(F8,qTy))),
      Close
        (Var("v",F8),
         MB(MB(MU(EX(Var("v",F8),LN 3,LN 0,F4),qTy),
               Close(Var("v",F4),MU(EQ(Var("v",F4),LW(0,4)),qTy))),
            Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))))))
;
val LastInITBlock_def = Def
  ("LastInITBlock",AVar uTy,
   MB(Const("ITSTATE",ATy(qTy,PTy(F8,qTy))),
      Close
        (Var("v",F8),
         MB(MU(EX(Var("v",F8),LN 3,LN 0,F4),qTy),
            Close(Var("v",F4),MU(EQ(Var("v",F4),LW(8,4)),qTy))))))
;
val ThumbCondition_def = Def
  ("ThumbCondition",AVar uTy,
   MB(Const("ITSTATE",ATy(qTy,PTy(F8,qTy))),
      Close
        (Var("v",F8),
         MB(MU(EQ(Var("v",F8),LW(0,8)),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",MU(LW(14,4),qTy),
                   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                      Close
                        (Var("v",CTy"PSR"),
                         MB(MB(MB(MB(MU(Dest("IT",F8,Var("v",CTy"PSR")),
                                        qTy),
                                     Close
                                       (Var("v",F8),
                                        MU(EX(Var("v",F8),LN 3,LN 0,F4),
                                           qTy))),
                                  Close
                                    (Var("v",F4),
                                     MU(EQ(Var("v",F4),LW(0,4)),qTy))),
                               Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("CPSR",CTy"PSR",qVar"s"))),
                                      Close
                                        (Var("v",CTy"PSR"),
                                         MB(MU(Dest
                                                 ("IT",F8,
                                                  Var("v",CTy"PSR")),qTy),
                                            Close
                                              (Var("v",F8),
                                               MU(EX(Var("v",F8),LN 7,
                                                     LN 4,F4),qTy))))),
                                   Call
                                     ("raise'exception",
                                      ATy(qTy,PTy(F4,qTy)),
                                      Call
                                        ("UNPREDICTABLE",CTy"exception",
                                         LS"ThumbCondition")))))))))))))
;
val BigEndian_def = Def
  ("BigEndian",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close(Var("v",CTy"PSR"),MU(Dest("E",bTy,Var("v",CTy"PSR")),qTy))))
;
val CurrentCond_def = Def
  ("CurrentCond",AVar uTy,
   MR(Close(qVar"s",Dest("CurrentCondition",F4,qVar"s"))))
;
val ConditionPassed_def = Def
  ("ConditionPassed",AVar uTy,
   MB(Call("CurrentCond",ATy(qTy,PTy(F4,qTy)),LU),
      Close
        (Var("cond",F4),
         MB(CS(EX(Var("cond",F4),LN 3,LN 1,FTy 3),
               [(LW(0,3),
                 MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                    Close
                      (Var("v",CTy"PSR"),
                       MU(Dest("Z",bTy,Var("v",CTy"PSR")),qTy)))),
                (LW(1,3),
                 MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                    Close
                      (Var("v",CTy"PSR"),
                       MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy)))),
                (LW(2,3),
                 MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                    Close
                      (Var("v",CTy"PSR"),
                       MU(Dest("N",bTy,Var("v",CTy"PSR")),qTy)))),
                (LW(3,3),
                 MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                    Close
                      (Var("v",CTy"PSR"),
                       MU(Dest("V",bTy,Var("v",CTy"PSR")),qTy)))),
                (LW(4,3),
                 MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                    Close
                      (Var("v",CTy"PSR"),
                       MB(MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest("CPSR",CTy"PSR",qVar"s"))),
                                    Close
                                      (Var("v",CTy"PSR"),
                                       MB(MU(Dest
                                               ("Z",bTy,Var("v",CTy"PSR")),
                                             qTy),
                                          Close
                                            (bVar"v",
                                             MU(Mop(Not,bVar"v"),qTy))))),
                                 MU(LF,qTy))))))),
                (LW(5,3),
                 MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                    Close
                      (Var("v",CTy"PSR"),
                       MB(MU(Dest("N",bTy,Var("v",CTy"PSR")),qTy),
                          Close
                            (bVar"v",
                             MB(MR(Close
                                     (qVar"s",
                                      Dest("CPSR",CTy"PSR",qVar"s"))),
                                Close
                                  (Var("v0",CTy"PSR"),
                                   MB(MU(Dest("V",bTy,Var("v0",CTy"PSR")),
                                         qTy),
                                      Close
                                        (bVar"v0",
                                         MU(EQ(bVar"v",bVar"v0"),qTy)))))))))),
                (LW(6,3),
                 MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                    Close
                      (Var("v",CTy"PSR"),
                       MB(MB(MU(Dest("N",bTy,Var("v",CTy"PSR")),qTy),
                             Close
                               (bVar"v",
                                MB(MR(Close
                                        (qVar"s",
                                         Dest("CPSR",CTy"PSR",qVar"s"))),
                                   Close
                                     (Var("v0",CTy"PSR"),
                                      MB(MU(Dest
                                              ("V",bTy,Var("v0",CTy"PSR")),
                                            qTy),
                                         Close
                                           (bVar"v0",
                                            MU(EQ(bVar"v",bVar"v0"),qTy))))))),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest("CPSR",CTy"PSR",qVar"s"))),
                                    Close
                                      (Var("v",CTy"PSR"),
                                       MB(MU(Dest
                                               ("Z",bTy,Var("v",CTy"PSR")),
                                             qTy),
                                          Close
                                            (bVar"v",
                                             MU(Mop(Not,bVar"v"),qTy))))),
                                 MU(LF,qTy))))))),(LW(7,3),MU(LT,qTy))]),
            Close
              (bVar"result",
               MU(ITE(Bop(And,Bop(Bit,Var("cond",F4),LN 0),
                          Mop(Not,EQ(Var("cond",F4),LW(15,4)))),
                      Mop(Not,bVar"result"),bVar"result"),qTy))))))
;
val SPSR_def = Def0
  ("SPSR",
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
               Close
                 (Var("v",FTy 5),
                  Call("BadMode",ATy(qTy,PTy(bTy,qTy)),Var("v",FTy 5)))),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                      Close
                        (Var("v",CTy"PSR"),
                         MB(MB(MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),
                                        qTy),
                                     Close
                                       (Var("v",FTy 5),
                                        MU(Mop(Cast sTy,Var("v",FTy 5)),
                                           qTy))),
                                  Close
                                    (sVar"v",
                                     MU(CC[LS"SPSR: BadMode: ",sVar"v"],
                                        qTy))),
                               Close
                                 (sVar"v",
                                  MU(Call
                                       ("UNPREDICTABLE",CTy"exception",
                                        sVar"v"),qTy))),
                            Close
                              (Var("v",CTy"exception"),
                               Call
                                 ("raise'exception",
                                  ATy(qTy,PTy(CTy"PSR",qTy)),
                                  Var("v",CTy"exception")))))),
                   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                      Close
                        (Var("v",CTy"PSR"),
                         MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                            Close
                              (Var("x",FTy 5),
                               CS(Var("x",FTy 5),
                                  [(LW(17,5),
                                    MR(Close
                                         (qVar"s",
                                          Dest
                                            ("SPSR_fiq",CTy"PSR",qVar"s")))),
                                   (LW(18,5),
                                    MR(Close
                                         (qVar"s",
                                          Dest
                                            ("SPSR_irq",CTy"PSR",qVar"s")))),
                                   (LW(19,5),
                                    MR(Close
                                         (qVar"s",
                                          Dest
                                            ("SPSR_svc",CTy"PSR",qVar"s")))),
                                   (LW(22,5),
                                    MR(Close
                                         (qVar"s",
                                          Dest
                                            ("SPSR_mon",CTy"PSR",qVar"s")))),
                                   (LW(23,5),
                                    MR(Close
                                         (qVar"s",
                                          Dest
                                            ("SPSR_abt",CTy"PSR",qVar"s")))),
                                   (LW(26,5),
                                    MR(Close
                                         (qVar"s",
                                          Dest
                                            ("SPSR_hyp",CTy"PSR",qVar"s")))),
                                   (LW(27,5),
                                    MR(Close
                                         (qVar"s",
                                          Dest
                                            ("SPSR_und",CTy"PSR",qVar"s")))),
                                   (AVar(FTy 5),
                                    Call
                                      ("raise'exception",
                                       ATy(qTy,PTy(CTy"PSR",qTy)),
                                       Call
                                         ("UNPREDICTABLE",CTy"exception",
                                          LS"SPSR")))])))))))))))
;
val write'SPSR_def = Def
  ("write'SPSR",Var("value",CTy"PSR"),
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
               Close
                 (Var("v",FTy 5),
                  Call("BadMode",ATy(qTy,PTy(bTy,qTy)),Var("v",FTy 5)))),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                      Close
                        (Var("v",CTy"PSR"),
                         MB(MB(MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),
                                        qTy),
                                     Close
                                       (Var("v",FTy 5),
                                        MU(Mop(Cast sTy,Var("v",FTy 5)),
                                           qTy))),
                                  Close
                                    (sVar"v",
                                     MU(CC[LS"SPSR: BadMode: ",sVar"v"],
                                        qTy))),
                               Close
                                 (sVar"v",
                                  MU(Call
                                       ("UNPREDICTABLE",CTy"exception",
                                        sVar"v"),qTy))),
                            Close
                              (Var("v",CTy"exception"),
                               Call
                                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                                  Var("v",CTy"exception")))))),
                   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                      Close
                        (Var("v",CTy"PSR"),
                         MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                            Close
                              (Var("x",FTy 5),
                               CS(Var("x",FTy 5),
                                  [(LW(17,5),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("SPSR_fiq",
                                             TP[qVar"s",
                                                Var("value",CTy"PSR")])))),
                                   (LW(18,5),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("SPSR_irq",
                                             TP[qVar"s",
                                                Var("value",CTy"PSR")])))),
                                   (LW(19,5),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("SPSR_svc",
                                             TP[qVar"s",
                                                Var("value",CTy"PSR")])))),
                                   (LW(22,5),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("SPSR_mon",
                                             TP[qVar"s",
                                                Var("value",CTy"PSR")])))),
                                   (LW(23,5),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("SPSR_abt",
                                             TP[qVar"s",
                                                Var("value",CTy"PSR")])))),
                                   (LW(26,5),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("SPSR_hyp",
                                             TP[qVar"s",
                                                Var("value",CTy"PSR")])))),
                                   (LW(27,5),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("SPSR_und",
                                             TP[qVar"s",
                                                Var("value",CTy"PSR")])))),
                                   (AVar(FTy 5),
                                    Call
                                      ("raise'exception",
                                       ATy(qTy,PTy(uTy,qTy)),
                                       Call
                                         ("UNPREDICTABLE",CTy"exception",
                                          LS"SPSR")))])))))))))))
;
val CPSRWriteByInstr_def = Def
  ("CPSRWriteByInstr",
   TP[Var("value",F32),Var("bytemask",F4),bVar"is_excpt_return"],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"privileged",
         MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
            Close
              (Var("v",CTy"CP15"),
               MB(MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),qTy),
                     Close
                       (Var("v",CTy"SCTLR"),
                        MU(Dest("NMFI",bTy,Var("v",CTy"SCTLR")),qTy))),
                  Close
                    (bVar"nmfi",
                     MB(ITE(Bop(Bit,Var("bytemask",F4),LN 3),
                            MB(MR(Close
                                    (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                               Close
                                 (Var("v",CTy"PSR"),
                                  MB(MB(MU(Call
                                             ("reg'PSR",F32,
                                              Var("v",CTy"PSR")),qTy),
                                        Close
                                          (Var("w",F32),
                                           MB(MR(Close
                                                   (qVar"s",
                                                    Dest
                                                      ("CPSR",CTy"PSR",
                                                       qVar"s"))),
                                              Close
                                                (Var("v",CTy"PSR"),
                                                 MB(MB(MU(TP[Var("v",
                                                                 CTy"PSR"),
                                                             BFI(LN 31,
                                                                 LN 27,
                                                                 EX(Var("value",
                                                                        F32),
                                                                    LN 31,
                                                                    LN 27,
                                                                    FTy 5),
                                                                 Var("w",
                                                                     F32))],
                                                          qTy),
                                                       Close
                                                         (Var("v",
                                                              PTy(CTy"PSR",
                                                                  F32)),
                                                          MU(Call
                                                               ("write'reg'PSR",
                                                                CTy"PSR",
                                                                Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32))),
                                                             qTy))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MW(Close
                                                            (qVar"s",
                                                             Rupd
                                                               ("CPSR",
                                                                TP[qVar"s",
                                                                   Var("v",
                                                                       CTy"PSR")]))))))))),
                                     Close
                                       (AVar uTy,
                                        ITE(bVar"is_excpt_return",
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("CPSR",CTy"PSR",
                                                        qVar"s"))),
                                               Close
                                                 (Var("v",CTy"PSR"),
                                                  MB(MU(Call
                                                          ("reg'PSR",F32,
                                                           Var("v",
                                                               CTy"PSR")),
                                                        qTy),
                                                     Close
                                                       (Var("w",F32),
                                                        MB(MR(Close
                                                                (qVar"s",
                                                                 Dest
                                                                   ("CPSR",
                                                                    CTy"PSR",
                                                                    qVar"s"))),
                                                           Close
                                                             (Var("v",
                                                                  CTy"PSR"),
                                                              MB(MB(MU(TP[Var("v",
                                                                              CTy"PSR"),
                                                                          BFI(LN
                                                                               26,
                                                                              LN
                                                                               24,
                                                                              EX(Var("value",
                                                                                     F32),
                                                                                 LN
                                                                                  26,
                                                                                 LN
                                                                                  24,
                                                                                 FTy 3),
                                                                              Var("w",
                                                                                  F32))],
                                                                       qTy),
                                                                    Close
                                                                      (Var("v",
                                                                           PTy(CTy"PSR",
                                                                               F32)),
                                                                       MU(Call
                                                                            ("write'reg'PSR",
                                                                             CTy"PSR",
                                                                             Var("v",
                                                                                 PTy(CTy"PSR",
                                                                                     F32))),
                                                                          qTy))),
                                                                 Close
                                                                   (Var("v",
                                                                        CTy"PSR"),
                                                                    MW(Close
                                                                         (qVar"s",
                                                                          Rupd
                                                                            ("CPSR",
                                                                             TP[qVar"s",
                                                                                Var("v",
                                                                                    CTy"PSR")]))))))))))),
                                            MU(LU,qTy)))))),MU(LU,qTy)),
                        Close
                          (AVar uTy,
                           MB(ITE(Bop(Bit,Var("bytemask",F4),LN 2),
                                  MB(MR(Close
                                          (qVar"s",
                                           Dest("CPSR",CTy"PSR",qVar"s"))),
                                     Close
                                       (Var("v",CTy"PSR"),
                                        MB(MU(Call
                                                ("reg'PSR",F32,
                                                 Var("v",CTy"PSR")),qTy),
                                           Close
                                             (Var("w",F32),
                                              MB(MR(Close
                                                      (qVar"s",
                                                       Dest
                                                         ("CPSR",CTy"PSR",
                                                          qVar"s"))),
                                                 Close
                                                   (Var("v",CTy"PSR"),
                                                    MB(MB(MU(TP[Var("v",
                                                                    CTy"PSR"),
                                                                BFI(LN 19,
                                                                    LN 16,
                                                                    EX(Var("value",
                                                                           F32),
                                                                       LN
                                                                        19,
                                                                       LN
                                                                        16,
                                                                       F4),
                                                                    Var("w",
                                                                        F32))],
                                                             qTy),
                                                          Close
                                                            (Var("v",
                                                                 PTy(CTy"PSR",
                                                                     F32)),
                                                             MU(Call
                                                                  ("write'reg'PSR",
                                                                   CTy"PSR",
                                                                   Var("v",
                                                                       PTy(CTy"PSR",
                                                                           F32))),
                                                                qTy))),
                                                       Close
                                                         (Var("v",CTy"PSR"),
                                                          MW(Close
                                                               (qVar"s",
                                                                Rupd
                                                                  ("CPSR",
                                                                   TP[qVar"s",
                                                                      Var("v",
                                                                          CTy"PSR")]))))))))))),
                                  MU(LU,qTy)),
                              Close
                                (AVar uTy,
                                 MB(ITE(Bop(Bit,Var("bytemask",F4),LN 1),
                                        MB(ITE(bVar"is_excpt_return",
                                               MB(MR(Close
                                                       (qVar"s",
                                                        Dest
                                                          ("CPSR",
                                                           CTy"PSR",
                                                           qVar"s"))),
                                                  Close
                                                    (Var("v",CTy"PSR"),
                                                     MB(MU(Call
                                                             ("reg'PSR",
                                                              F32,
                                                              Var("v",
                                                                  CTy"PSR")),
                                                           qTy),
                                                        Close
                                                          (Var("w",F32),
                                                           MB(MR(Close
                                                                   (qVar"s",
                                                                    Dest
                                                                      ("CPSR",
                                                                       CTy"PSR",
                                                                       qVar"s"))),
                                                              Close
                                                                (Var("v",
                                                                     CTy"PSR"),
                                                                 MB(MB(MU(TP[Var("v",
                                                                                 CTy"PSR"),
                                                                             BFI(LN
                                                                                  15,
                                                                                 LN
                                                                                  10,
                                                                                 EX(Var("value",
                                                                                        F32),
                                                                                    LN
                                                                                     15,
                                                                                    LN
                                                                                     10,
                                                                                    FTy 6),
                                                                                 Var("w",
                                                                                     F32))],
                                                                          qTy),
                                                                       Close
                                                                         (Var("v",
                                                                              PTy(CTy"PSR",
                                                                                  F32)),
                                                                          MU(Call
                                                                               ("write'reg'PSR",
                                                                                CTy"PSR",
                                                                                Var("v",
                                                                                    PTy(CTy"PSR",
                                                                                        F32))),
                                                                             qTy))),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"PSR"),
                                                                       MW(Close
                                                                            (qVar"s",
                                                                             Rupd
                                                                               ("CPSR",
                                                                                TP[qVar"s",
                                                                                   Var("v",
                                                                                       CTy"PSR")]))))))))))),
                                               MU(LU,qTy)),
                                           Close
                                             (AVar uTy,
                                              MB(MR(Close
                                                      (qVar"s",
                                                       Dest
                                                         ("CPSR",CTy"PSR",
                                                          qVar"s"))),
                                                 Close
                                                   (Var("v",CTy"PSR"),
                                                    MB(MB(MU(Call
                                                               ("reg'PSR",
                                                                F32,
                                                                Var("v",
                                                                    CTy"PSR")),
                                                             qTy),
                                                          Close
                                                            (Var("w",F32),
                                                             MB(MR(Close
                                                                     (qVar"s",
                                                                      Dest
                                                                        ("CPSR",
                                                                         CTy"PSR",
                                                                         qVar"s"))),
                                                                Close
                                                                  (Var("v",
                                                                       CTy"PSR"),
                                                                   MB(MB(MU(TP[Var("v",
                                                                                   CTy"PSR"),
                                                                               BFI(LN
                                                                                    9,
                                                                                   LN
                                                                                    9,
                                                                                   Mop(Cast
                                                                                         F1,
                                                                                       Bop(Bit,
                                                                                           Var("value",
                                                                                               F32),
                                                                                           LN
                                                                                            9)),
                                                                                   Var("w",
                                                                                       F32))],
                                                                            qTy),
                                                                         Close
                                                                           (Var("v",
                                                                                PTy(CTy"PSR",
                                                                                    F32)),
                                                                            MU(Call
                                                                                 ("write'reg'PSR",
                                                                                  CTy"PSR",
                                                                                  Var("v",
                                                                                      PTy(CTy"PSR",
                                                                                          F32))),
                                                                               qTy))),
                                                                      Close
                                                                        (Var("v",
                                                                             CTy"PSR"),
                                                                         MW(Close
                                                                              (qVar"s",
                                                                               Rupd
                                                                                 ("CPSR",
                                                                                  TP[qVar"s",
                                                                                     Var("v",
                                                                                         CTy"PSR")]))))))))),
                                                       Close
                                                         (AVar uTy,
                                                          MB(Call
                                                               ("IsSecure",
                                                                ATy(qTy,
                                                                    PTy(bTy,
                                                                        qTy)),
                                                                LU),
                                                             Close
                                                               (bVar"v",
                                                                MB(MB(ITE(bVar"v",
                                                                          MU(LT,
                                                                             qTy),
                                                                          MB(MR(Close
                                                                                  (qVar"s",
                                                                                   Dest
                                                                                     ("CP15",
                                                                                      CTy"CP15",
                                                                                      qVar"s"))),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"CP15"),
                                                                                MB(MU(Dest
                                                                                        ("SCR",
                                                                                         CTy"SCR",
                                                                                         Var("v",
                                                                                             CTy"CP15")),
                                                                                      qTy),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          CTy"SCR"),
                                                                                      MU(Dest
                                                                                           ("AW",
                                                                                            bTy,
                                                                                            Var("v",
                                                                                                CTy"SCR")),
                                                                                         qTy)))))),
                                                                      Close
                                                                        (bVar"v",
                                                                         MU(Bop(And,
                                                                                bVar"privileged",
                                                                                bVar"v"),
                                                                            qTy))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MB(MR(Close
                                                                                  (qVar"s",
                                                                                   Dest
                                                                                     ("CPSR",
                                                                                      CTy"PSR",
                                                                                      qVar"s"))),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"PSR"),
                                                                                MB(MU(Call
                                                                                        ("reg'PSR",
                                                                                         F32,
                                                                                         Var("v",
                                                                                             CTy"PSR")),
                                                                                      qTy),
                                                                                   Close
                                                                                     (Var("w",
                                                                                          F32),
                                                                                      MB(MR(Close
                                                                                              (qVar"s",
                                                                                               Dest
                                                                                                 ("CPSR",
                                                                                                  CTy"PSR",
                                                                                                  qVar"s"))),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                CTy"PSR"),
                                                                                            MB(MB(MU(TP[Var("v",
                                                                                                            CTy"PSR"),
                                                                                                        BFI(LN
                                                                                                             8,
                                                                                                            LN
                                                                                                             8,
                                                                                                            Mop(Cast
                                                                                                                  F1,
                                                                                                                Bop(Bit,
                                                                                                                    Var("value",
                                                                                                                        F32),
                                                                                                                    LN
                                                                                                                     8)),
                                                                                                            Var("w",
                                                                                                                F32))],
                                                                                                     qTy),
                                                                                                  Close
                                                                                                    (Var("v",
                                                                                                         PTy(CTy"PSR",
                                                                                                             F32)),
                                                                                                     MU(Call
                                                                                                          ("write'reg'PSR",
                                                                                                           CTy"PSR",
                                                                                                           Var("v",
                                                                                                               PTy(CTy"PSR",
                                                                                                                   F32))),
                                                                                                        qTy))),
                                                                                               Close
                                                                                                 (Var("v",
                                                                                                      CTy"PSR"),
                                                                                                  MW(Close
                                                                                                       (qVar"s",
                                                                                                        Rupd
                                                                                                          ("CPSR",
                                                                                                           TP[qVar"s",
                                                                                                              Var("v",
                                                                                                                  CTy"PSR")]))))))))))),
                                                                          MU(LU,
                                                                             qTy)))))))))))),
                                        MU(LU,qTy)),
                                    Close
                                      (AVar uTy,
                                       ITE(Bop(Bit,Var("bytemask",F4),LN 0),
                                           MB(ITE(bVar"privileged",
                                                  MB(MR(Close
                                                          (qVar"s",
                                                           Dest
                                                             ("CPSR",
                                                              CTy"PSR",
                                                              qVar"s"))),
                                                     Close
                                                       (Var("v",CTy"PSR"),
                                                        MB(MU(Call
                                                                ("reg'PSR",
                                                                 F32,
                                                                 Var("v",
                                                                     CTy"PSR")),
                                                              qTy),
                                                           Close
                                                             (Var("w",F32),
                                                              MB(MR(Close
                                                                      (qVar"s",
                                                                       Dest
                                                                         ("CPSR",
                                                                          CTy"PSR",
                                                                          qVar"s"))),
                                                                 Close
                                                                   (Var("v",
                                                                        CTy"PSR"),
                                                                    MB(MB(MU(TP[Var("v",
                                                                                    CTy"PSR"),
                                                                                BFI(LN
                                                                                     7,
                                                                                    LN
                                                                                     7,
                                                                                    Mop(Cast
                                                                                          F1,
                                                                                        Bop(Bit,
                                                                                            Var("value",
                                                                                                F32),
                                                                                            LN
                                                                                             7)),
                                                                                    Var("w",
                                                                                        F32))],
                                                                             qTy),
                                                                          Close
                                                                            (Var("v",
                                                                                 PTy(CTy"PSR",
                                                                                     F32)),
                                                                             MU(Call
                                                                                  ("write'reg'PSR",
                                                                                   CTy"PSR",
                                                                                   Var("v",
                                                                                       PTy(CTy"PSR",
                                                                                           F32))),
                                                                                qTy))),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"PSR"),
                                                                          MW(Close
                                                                               (qVar"s",
                                                                                Rupd
                                                                                  ("CPSR",
                                                                                   TP[qVar"s",
                                                                                      Var("v",
                                                                                          CTy"PSR")]))))))))))),
                                                  MU(LU,qTy)),
                                              Close
                                                (AVar uTy,
                                                 MB(Call
                                                      ("IsSecure",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       LU),
                                                    Close
                                                      (bVar"v",
                                                       MB(MB(MB(MB(ITE(bVar"v",
                                                                       MU(LT,
                                                                          qTy),
                                                                       MB(MR(Close
                                                                               (qVar"s",
                                                                                Dest
                                                                                  ("CP15",
                                                                                   CTy"CP15",
                                                                                   qVar"s"))),
                                                                          Close
                                                                            (Var("v",
                                                                                 CTy"CP15"),
                                                                             MB(MU(Dest
                                                                                     ("SCR",
                                                                                      CTy"SCR",
                                                                                      Var("v",
                                                                                          CTy"CP15")),
                                                                                   qTy),
                                                                                Close
                                                                                  (Var("v",
                                                                                       CTy"SCR"),
                                                                                   MU(Dest
                                                                                        ("FW",
                                                                                         bTy,
                                                                                         Var("v",
                                                                                             CTy"SCR")),
                                                                                      qTy)))))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MU(LT,
                                                                             qTy),
                                                                          Call
                                                                            ("HaveVirtExt",
                                                                             ATy(qTy,
                                                                                 PTy(bTy,
                                                                                     qTy)),
                                                                             LU)))),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(Bop(And,
                                                                          Bop(And,
                                                                              bVar"privileged",
                                                                              Bop(Or,
                                                                                  Mop(Not,
                                                                                      bVar"nmfi"),
                                                                                  Mop(Not,
                                                                                      Bop(Bit,
                                                                                          Var("value",
                                                                                              F32),
                                                                                          LN
                                                                                           6)))),
                                                                          bVar"v"),
                                                                      qTy))),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    MB(MR(Close
                                                                            (qVar"s",
                                                                             Dest
                                                                               ("CPSR",
                                                                                CTy"PSR",
                                                                                qVar"s"))),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"PSR"),
                                                                          MB(MU(Call
                                                                                  ("reg'PSR",
                                                                                   F32,
                                                                                   Var("v",
                                                                                       CTy"PSR")),
                                                                                qTy),
                                                                             Close
                                                                               (Var("w",
                                                                                    F32),
                                                                                MB(MR(Close
                                                                                        (qVar"s",
                                                                                         Dest
                                                                                           ("CPSR",
                                                                                            CTy"PSR",
                                                                                            qVar"s"))),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          CTy"PSR"),
                                                                                      MB(MB(MU(TP[Var("v",
                                                                                                      CTy"PSR"),
                                                                                                  BFI(LN
                                                                                                       6,
                                                                                                      LN
                                                                                                       6,
                                                                                                      Mop(Cast
                                                                                                            F1,
                                                                                                          Bop(Bit,
                                                                                                              Var("value",
                                                                                                                  F32),
                                                                                                              LN
                                                                                                               6)),
                                                                                                      Var("w",
                                                                                                          F32))],
                                                                                               qTy),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   PTy(CTy"PSR",
                                                                                                       F32)),
                                                                                               MU(Call
                                                                                                    ("write'reg'PSR",
                                                                                                     CTy"PSR",
                                                                                                     Var("v",
                                                                                                         PTy(CTy"PSR",
                                                                                                             F32))),
                                                                                                  qTy))),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                CTy"PSR"),
                                                                                            MW(Close
                                                                                                 (qVar"s",
                                                                                                  Rupd
                                                                                                    ("CPSR",
                                                                                                     TP[qVar"s",
                                                                                                        Var("v",
                                                                                                            CTy"PSR")]))))))))))),
                                                                    MU(LU,
                                                                       qTy)))),
                                                          Close
                                                            (AVar uTy,
                                                             MB(ITE(bVar"is_excpt_return",
                                                                    MB(MR(Close
                                                                            (qVar"s",
                                                                             Dest
                                                                               ("CPSR",
                                                                                CTy"PSR",
                                                                                qVar"s"))),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"PSR"),
                                                                          MB(MU(Call
                                                                                  ("reg'PSR",
                                                                                   F32,
                                                                                   Var("v",
                                                                                       CTy"PSR")),
                                                                                qTy),
                                                                             Close
                                                                               (Var("w",
                                                                                    F32),
                                                                                MB(MR(Close
                                                                                        (qVar"s",
                                                                                         Dest
                                                                                           ("CPSR",
                                                                                            CTy"PSR",
                                                                                            qVar"s"))),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          CTy"PSR"),
                                                                                      MB(MB(MU(TP[Var("v",
                                                                                                      CTy"PSR"),
                                                                                                  BFI(LN
                                                                                                       5,
                                                                                                      LN
                                                                                                       5,
                                                                                                      Mop(Cast
                                                                                                            F1,
                                                                                                          Bop(Bit,
                                                                                                              Var("value",
                                                                                                                  F32),
                                                                                                              LN
                                                                                                               5)),
                                                                                                      Var("w",
                                                                                                          F32))],
                                                                                               qTy),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   PTy(CTy"PSR",
                                                                                                       F32)),
                                                                                               MU(Call
                                                                                                    ("write'reg'PSR",
                                                                                                     CTy"PSR",
                                                                                                     Var("v",
                                                                                                         PTy(CTy"PSR",
                                                                                                             F32))),
                                                                                                  qTy))),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                CTy"PSR"),
                                                                                            MW(Close
                                                                                                 (qVar"s",
                                                                                                  Rupd
                                                                                                    ("CPSR",
                                                                                                     TP[qVar"s",
                                                                                                        Var("v",
                                                                                                            CTy"PSR")]))))))))))),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   ITE(bVar"privileged",
                                                                       MB(Call
                                                                            ("BadMode",
                                                                             ATy(qTy,
                                                                                 PTy(bTy,
                                                                                     qTy)),
                                                                             EX(Var("value",
                                                                                    F32),
                                                                                LN
                                                                                 4,
                                                                                LN
                                                                                 0,
                                                                                FTy 5)),
                                                                          Close
                                                                            (bVar"b",
                                                                             ITE(bVar"b",
                                                                                 Call
                                                                                   ("raise'exception",
                                                                                    ATy(qTy,
                                                                                        PTy(uTy,
                                                                                            qTy)),
                                                                                    Call
                                                                                      ("UNPREDICTABLE",
                                                                                       CTy"exception",
                                                                                       CC[LS
                                                                                           "CPSRWriteByInstr: BadMode: ",
                                                                                          Mop(Cast
                                                                                                sTy,
                                                                                              EX(Var("value",
                                                                                                     F32),
                                                                                                 LN
                                                                                                  4,
                                                                                                 LN
                                                                                                  0,
                                                                                                 FTy 5))])),
                                                                                 MB(Call
                                                                                      ("IsSecure",
                                                                                       ATy(qTy,
                                                                                           PTy(bTy,
                                                                                               qTy)),
                                                                                       LU),
                                                                                    Close
                                                                                      (bVar"v",
                                                                                       MB(MB(MB(MU(Mop(Not,
                                                                                                       bVar"v"),
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (bVar"b",
                                                                                                   MU(Bop(And,
                                                                                                          bVar"b",
                                                                                                          EQ(EX(Var("value",
                                                                                                                    F32),
                                                                                                                LN
                                                                                                                 4,
                                                                                                                LN
                                                                                                                 0,
                                                                                                                FTy 5),
                                                                                                             LW(22,
                                                                                                                5))),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (bVar"b",
                                                                                                ITE(bVar"b",
                                                                                                    Call
                                                                                                      ("raise'exception",
                                                                                                       ATy(qTy,
                                                                                                           PTy(uTy,
                                                                                                               qTy)),
                                                                                                       Call
                                                                                                         ("UNPREDICTABLE",
                                                                                                          CTy"exception",
                                                                                                          LS
                                                                                                           "CPSRWriteByInstr")),
                                                                                                    MU(LU,
                                                                                                       qTy)))),
                                                                                          Close
                                                                                            (AVar
                                                                                               uTy,
                                                                                             MB(Call
                                                                                                  ("IsSecure",
                                                                                                   ATy(qTy,
                                                                                                       PTy(bTy,
                                                                                                           qTy)),
                                                                                                   LU),
                                                                                                Close
                                                                                                  (bVar"v",
                                                                                                   MB(MB(MB(MB(MU(Mop(Not,
                                                                                                                      bVar"v"),
                                                                                                                  qTy),
                                                                                                               Close
                                                                                                                 (bVar"b",
                                                                                                                  MU(Bop(And,
                                                                                                                         bVar"b",
                                                                                                                         EQ(EX(Var("value",
                                                                                                                                   F32),
                                                                                                                               LN
                                                                                                                                4,
                                                                                                                               LN
                                                                                                                                0,
                                                                                                                               FTy 5),
                                                                                                                            LW(17,
                                                                                                                               5))),
                                                                                                                     qTy))),
                                                                                                            Close
                                                                                                              (bVar"b",
                                                                                                               ITE(bVar"b",
                                                                                                                   MB(MR(Close
                                                                                                                           (qVar"s",
                                                                                                                            Dest
                                                                                                                              ("CP15",
                                                                                                                               CTy"CP15",
                                                                                                                               qVar"s"))),
                                                                                                                      Close
                                                                                                                        (Var("v",
                                                                                                                             CTy"CP15"),
                                                                                                                         MB(MU(Dest
                                                                                                                                 ("NSACR",
                                                                                                                                  CTy"NSACR",
                                                                                                                                  Var("v",
                                                                                                                                      CTy"CP15")),
                                                                                                                               qTy),
                                                                                                                            Close
                                                                                                                              (Var("v",
                                                                                                                                   CTy"NSACR"),
                                                                                                                               MU(Dest
                                                                                                                                    ("RFR",
                                                                                                                                     bTy,
                                                                                                                                     Var("v",
                                                                                                                                         CTy"NSACR")),
                                                                                                                                  qTy))))),
                                                                                                                   MU(LF,
                                                                                                                      qTy)))),
                                                                                                         Close
                                                                                                           (bVar"b",
                                                                                                            ITE(bVar"b",
                                                                                                                Call
                                                                                                                  ("raise'exception",
                                                                                                                   ATy(qTy,
                                                                                                                       PTy(uTy,
                                                                                                                           qTy)),
                                                                                                                   Call
                                                                                                                     ("UNPREDICTABLE",
                                                                                                                      CTy"exception",
                                                                                                                      LS
                                                                                                                       "CPSRWriteByInstr")),
                                                                                                                MU(LU,
                                                                                                                   qTy)))),
                                                                                                      Close
                                                                                                        (AVar
                                                                                                           uTy,
                                                                                                         MB(MR(Close
                                                                                                                 (qVar"s",
                                                                                                                  Dest
                                                                                                                    ("CP15",
                                                                                                                     CTy"CP15",
                                                                                                                     qVar"s"))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   CTy"CP15"),
                                                                                                               MB(MB(MB(MB(MB(MU(Dest
                                                                                                                                   ("SCR",
                                                                                                                                    CTy"SCR",
                                                                                                                                    Var("v",
                                                                                                                                        CTy"CP15")),
                                                                                                                                 qTy),
                                                                                                                              Close
                                                                                                                                (Var("v",
                                                                                                                                     CTy"SCR"),
                                                                                                                                 MU(Dest
                                                                                                                                      ("NS",
                                                                                                                                       bTy,
                                                                                                                                       Var("v",
                                                                                                                                           CTy"SCR")),
                                                                                                                                    qTy))),
                                                                                                                           Close
                                                                                                                             (bVar"v",
                                                                                                                              MU(Mop(Not,
                                                                                                                                     bVar"v"),
                                                                                                                                 qTy))),
                                                                                                                        Close
                                                                                                                          (bVar"b",
                                                                                                                           MU(Bop(And,
                                                                                                                                  bVar"b",
                                                                                                                                  EQ(EX(Var("value",
                                                                                                                                            F32),
                                                                                                                                        LN
                                                                                                                                         4,
                                                                                                                                        LN
                                                                                                                                         0,
                                                                                                                                        FTy 5),
                                                                                                                                     LW(26,
                                                                                                                                        5))),
                                                                                                                              qTy))),
                                                                                                                     Close
                                                                                                                       (bVar"b",
                                                                                                                        ITE(bVar"b",
                                                                                                                            Call
                                                                                                                              ("raise'exception",
                                                                                                                               ATy(qTy,
                                                                                                                                   PTy(uTy,
                                                                                                                                       qTy)),
                                                                                                                               Call
                                                                                                                                 ("UNPREDICTABLE",
                                                                                                                                  CTy"exception",
                                                                                                                                  LS
                                                                                                                                   "CPSRWriteByInstr")),
                                                                                                                            MU(LU,
                                                                                                                               qTy)))),
                                                                                                                  Close
                                                                                                                    (AVar
                                                                                                                       uTy,
                                                                                                                     MB(Call
                                                                                                                          ("IsSecure",
                                                                                                                           ATy(qTy,
                                                                                                                               PTy(bTy,
                                                                                                                                   qTy)),
                                                                                                                           LU),
                                                                                                                        Close
                                                                                                                          (bVar"v",
                                                                                                                           MB(MB(MB(MB(MU(Mop(Not,
                                                                                                                                              bVar"v"),
                                                                                                                                          qTy),
                                                                                                                                       Close
                                                                                                                                         (bVar"b",
                                                                                                                                          ITE(bVar"b",
                                                                                                                                              MB(MR(Close
                                                                                                                                                      (qVar"s",
                                                                                                                                                       Dest
                                                                                                                                                         ("CPSR",
                                                                                                                                                          CTy"PSR",
                                                                                                                                                          qVar"s"))),
                                                                                                                                                 Close
                                                                                                                                                   (Var("v",
                                                                                                                                                        CTy"PSR"),
                                                                                                                                                    MB(MB(MU(Dest
                                                                                                                                                               ("M",
                                                                                                                                                                FTy 5,
                                                                                                                                                                Var("v",
                                                                                                                                                                    CTy"PSR")),
                                                                                                                                                             qTy),
                                                                                                                                                          Close
                                                                                                                                                            (Var("v",
                                                                                                                                                                 FTy 5),
                                                                                                                                                             MU(EQ(Var("v",
                                                                                                                                                                       FTy 5),
                                                                                                                                                                   LW(26,
                                                                                                                                                                      5)),
                                                                                                                                                                qTy))),
                                                                                                                                                       Close
                                                                                                                                                         (bVar"v",
                                                                                                                                                          MU(Mop(Not,
                                                                                                                                                                 bVar"v"),
                                                                                                                                                             qTy))))),
                                                                                                                                              MU(LF,
                                                                                                                                                 qTy)))),
                                                                                                                                    Close
                                                                                                                                      (bVar"b",
                                                                                                                                       MU(Bop(And,
                                                                                                                                              bVar"b",
                                                                                                                                              EQ(EX(Var("value",
                                                                                                                                                        F32),
                                                                                                                                                    LN
                                                                                                                                                     4,
                                                                                                                                                    LN
                                                                                                                                                     0,
                                                                                                                                                    FTy 5),
                                                                                                                                                 LW(26,
                                                                                                                                                    5))),
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (bVar"b",
                                                                                                                                    ITE(bVar"b",
                                                                                                                                        Call
                                                                                                                                          ("raise'exception",
                                                                                                                                           ATy(qTy,
                                                                                                                                               PTy(uTy,
                                                                                                                                                   qTy)),
                                                                                                                                           Call
                                                                                                                                             ("UNPREDICTABLE",
                                                                                                                                              CTy"exception",
                                                                                                                                              LS
                                                                                                                                               "CPSRWriteByInstr")),
                                                                                                                                        MU(LU,
                                                                                                                                           qTy)))),
                                                                                                                              Close
                                                                                                                                (AVar
                                                                                                                                   uTy,
                                                                                                                                 MB(MR(Close
                                                                                                                                         (qVar"s",
                                                                                                                                          Dest
                                                                                                                                            ("CPSR",
                                                                                                                                             CTy"PSR",
                                                                                                                                             qVar"s"))),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           CTy"PSR"),
                                                                                                                                       MB(MB(MB(MB(MB(MU(Dest
                                                                                                                                                           ("M",
                                                                                                                                                            FTy 5,
                                                                                                                                                            Var("v",
                                                                                                                                                                CTy"PSR")),
                                                                                                                                                         qTy),
                                                                                                                                                      Close
                                                                                                                                                        (Var("v",
                                                                                                                                                             FTy 5),
                                                                                                                                                         MU(EQ(Var("v",
                                                                                                                                                                   FTy 5),
                                                                                                                                                               LW(26,
                                                                                                                                                                  5)),
                                                                                                                                                            qTy))),
                                                                                                                                                   Close
                                                                                                                                                     (bVar"b",
                                                                                                                                                      MU(Bop(And,
                                                                                                                                                             bVar"b",
                                                                                                                                                             Mop(Not,
                                                                                                                                                                 EQ(EX(Var("value",
                                                                                                                                                                           F32),
                                                                                                                                                                       LN
                                                                                                                                                                        4,
                                                                                                                                                                       LN
                                                                                                                                                                        0,
                                                                                                                                                                       FTy 5),
                                                                                                                                                                    LW(26,
                                                                                                                                                                       5)))),
                                                                                                                                                         qTy))),
                                                                                                                                                Close
                                                                                                                                                  (bVar"b",
                                                                                                                                                   MU(Bop(And,
                                                                                                                                                          bVar"b",
                                                                                                                                                          Mop(Not,
                                                                                                                                                              bVar"is_excpt_return")),
                                                                                                                                                      qTy))),
                                                                                                                                             Close
                                                                                                                                               (bVar"b",
                                                                                                                                                ITE(bVar"b",
                                                                                                                                                    Call
                                                                                                                                                      ("raise'exception",
                                                                                                                                                       ATy(qTy,
                                                                                                                                                           PTy(uTy,
                                                                                                                                                               qTy)),
                                                                                                                                                       Call
                                                                                                                                                         ("UNPREDICTABLE",
                                                                                                                                                          CTy"exception",
                                                                                                                                                          LS
                                                                                                                                                           "CPSRWriteByInstr")),
                                                                                                                                                    MU(LU,
                                                                                                                                                       qTy)))),
                                                                                                                                          Close
                                                                                                                                            (AVar
                                                                                                                                               uTy,
                                                                                                                                             MB(MR(Close
                                                                                                                                                     (qVar"s",
                                                                                                                                                      Dest
                                                                                                                                                        ("CPSR",
                                                                                                                                                         CTy"PSR",
                                                                                                                                                         qVar"s"))),
                                                                                                                                                Close
                                                                                                                                                  (Var("v",
                                                                                                                                                       CTy"PSR"),
                                                                                                                                                   MB(MU(Call
                                                                                                                                                           ("reg'PSR",
                                                                                                                                                            F32,
                                                                                                                                                            Var("v",
                                                                                                                                                                CTy"PSR")),
                                                                                                                                                         qTy),
                                                                                                                                                      Close
                                                                                                                                                        (Var("w",
                                                                                                                                                             F32),
                                                                                                                                                         MB(MR(Close
                                                                                                                                                                 (qVar"s",
                                                                                                                                                                  Dest
                                                                                                                                                                    ("CPSR",
                                                                                                                                                                     CTy"PSR",
                                                                                                                                                                     qVar"s"))),
                                                                                                                                                            Close
                                                                                                                                                              (Var("v",
                                                                                                                                                                   CTy"PSR"),
                                                                                                                                                               MB(MB(MU(TP[Var("v",
                                                                                                                                                                               CTy"PSR"),
                                                                                                                                                                           BFI(LN
                                                                                                                                                                                4,
                                                                                                                                                                               LN
                                                                                                                                                                                0,
                                                                                                                                                                               EX(Var("value",
                                                                                                                                                                                      F32),
                                                                                                                                                                                  LN
                                                                                                                                                                                   4,
                                                                                                                                                                                  LN
                                                                                                                                                                                   0,
                                                                                                                                                                                  FTy 5),
                                                                                                                                                                               Var("w",
                                                                                                                                                                                   F32))],
                                                                                                                                                                        qTy),
                                                                                                                                                                     Close
                                                                                                                                                                       (Var("v",
                                                                                                                                                                            PTy(CTy"PSR",
                                                                                                                                                                                F32)),
                                                                                                                                                                        MU(Call
                                                                                                                                                                             ("write'reg'PSR",
                                                                                                                                                                              CTy"PSR",
                                                                                                                                                                              Var("v",
                                                                                                                                                                                  PTy(CTy"PSR",
                                                                                                                                                                                      F32))),
                                                                                                                                                                           qTy))),
                                                                                                                                                                  Close
                                                                                                                                                                    (Var("v",
                                                                                                                                                                         CTy"PSR"),
                                                                                                                                                                     MW(Close
                                                                                                                                                                          (qVar"s",
                                                                                                                                                                           Rupd
                                                                                                                                                                             ("CPSR",
                                                                                                                                                                              TP[qVar"s",
                                                                                                                                                                                 Var("v",
                                                                                                                                                                                     CTy"PSR")])))))))))))))))))))))))))))))))))),
                                                                       MU(LU,
                                                                          qTy)))))))))),
                                           MU(LU,qTy)))))))))))))))
;
val SPSRWriteByInstr_def = Def
  ("SPSRWriteByInstr",TP[Var("value",F32),Var("bytemask",F4)],
   MB(Call("CurrentModeIsUserOrSystem",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",
                Call
                  ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                   Call
                     ("UNPREDICTABLE",CTy"exception",LS"SPSRWriteByInstr")),
                MU(LU,qTy)),
            Close
              (AVar uTy,
               MB(ITE(Bop(Bit,Var("bytemask",F4),LN 3),
                      MB(Const("SPSR",ATy(qTy,PTy(CTy"PSR",qTy))),
                         Close
                           (Var("x",CTy"PSR"),
                            Call
                              ("write'SPSR",ATy(qTy,PTy(uTy,qTy)),
                               Call
                                 ("write'reg'PSR",CTy"PSR",
                                  TP[Var("x",CTy"PSR"),
                                     BFI(LN 31,LN 24,
                                         EX(Var("value",F32),LN 31,LN 24,
                                            F8),
                                         Call
                                           ("reg'PSR",F32,
                                            Var("x",CTy"PSR")))])))),
                      MU(LU,qTy)),
                  Close
                    (AVar uTy,
                     MB(ITE(Bop(Bit,Var("bytemask",F4),LN 2),
                            MB(Const("SPSR",ATy(qTy,PTy(CTy"PSR",qTy))),
                               Close
                                 (Var("x",CTy"PSR"),
                                  Call
                                    ("write'SPSR",ATy(qTy,PTy(uTy,qTy)),
                                     Call
                                       ("write'reg'PSR",CTy"PSR",
                                        TP[Var("x",CTy"PSR"),
                                           BFI(LN 19,LN 16,
                                               EX(Var("value",F32),LN 19,
                                                  LN 16,F4),
                                               Call
                                                 ("reg'PSR",F32,
                                                  Var("x",CTy"PSR")))])))),
                            MU(LU,qTy)),
                        Close
                          (AVar uTy,
                           MB(ITE(Bop(Bit,Var("bytemask",F4),LN 1),
                                  MB(Const
                                       ("SPSR",ATy(qTy,PTy(CTy"PSR",qTy))),
                                     Close
                                       (Var("x",CTy"PSR"),
                                        Call
                                          ("write'SPSR",
                                           ATy(qTy,PTy(uTy,qTy)),
                                           Call
                                             ("write'reg'PSR",CTy"PSR",
                                              TP[Var("x",CTy"PSR"),
                                                 BFI(LN 15,LN 8,
                                                     EX(Var("value",F32),
                                                        LN 15,LN 8,F8),
                                                     Call
                                                       ("reg'PSR",F32,
                                                        Var("x",CTy"PSR")))])))),
                                  MU(LU,qTy)),
                              Close
                                (AVar uTy,
                                 ITE(Bop(Bit,Var("bytemask",F4),LN 0),
                                     MB(Const
                                          ("SPSR",
                                           ATy(qTy,PTy(CTy"PSR",qTy))),
                                        Close
                                          (Var("v",CTy"PSR"),
                                           MB(Call
                                                ("write'SPSR",
                                                 ATy(qTy,PTy(uTy,qTy)),
                                                 Call
                                                   ("write'reg'PSR",
                                                    CTy"PSR",
                                                    TP[Var("v",CTy"PSR"),
                                                       BFI(LN 7,LN 5,
                                                           EX(Var("value",
                                                                  F32),
                                                              LN 7,LN 5,
                                                              FTy 3),
                                                           Call
                                                             ("reg'PSR",
                                                              F32,
                                                              Var("v",
                                                                  CTy"PSR")))])),
                                              Close
                                                (AVar uTy,
                                                 MB(Call
                                                      ("BadMode",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       EX(Var("value",F32),
                                                          LN 4,LN 0,FTy 5)),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           Call
                                                             ("raise'exception",
                                                              ATy(qTy,
                                                                  PTy(uTy,
                                                                      qTy)),
                                                              Call
                                                                ("UNPREDICTABLE",
                                                                 CTy"exception",
                                                                 CC[LS
                                                                     "SPSRWriteByInstr: BadMode: ",
                                                                    Mop(Cast
                                                                          sTy,
                                                                        EX(Var("value",
                                                                               F32),
                                                                           LN
                                                                            4,
                                                                           LN
                                                                            0,
                                                                           FTy 5))])),
                                                           MB(Const
                                                                ("SPSR",
                                                                 ATy(qTy,
                                                                     PTy(CTy"PSR",
                                                                         qTy))),
                                                              Close
                                                                (Var("x",
                                                                     CTy"PSR"),
                                                                 Call
                                                                   ("write'SPSR",
                                                                    ATy(qTy,
                                                                        PTy(uTy,
                                                                            qTy)),
                                                                    Call
                                                                      ("write'reg'PSR",
                                                                       CTy"PSR",
                                                                       TP[Var("x",
                                                                              CTy"PSR"),
                                                                          BFI(LN
                                                                               4,
                                                                              LN
                                                                               0,
                                                                              EX(Var("value",
                                                                                     F32),
                                                                                 LN
                                                                                  4,
                                                                                 LN
                                                                                  0,
                                                                                 FTy 5),
                                                                              Call
                                                                                ("reg'PSR",
                                                                                 F32,
                                                                                 Var("x",
                                                                                     CTy"PSR")))]))))))))))),
                                     MU(LU,qTy)))))))))))))
;
val RBankSelect_def = Def
  ("RBankSelect",
   TP[Var("mode",FTy 5),Var("usr",CTy"RName"),Var("fiq",CTy"RName"),
      Var("irq",CTy"RName"),Var("svc",CTy"RName"),Var("abt",CTy"RName"),
      Var("und",CTy"RName"),Var("mon",CTy"RName"),Var("hyp",CTy"RName")],
   MB(Call("BadMode",ATy(qTy,PTy(bTy,qTy)),Var("mode",FTy 5)),
      Close
        (bVar"b",
         ITE(bVar"b",
             Call
               ("raise'exception",ATy(qTy,PTy(CTy"RName",qTy)),
                Call
                  ("UNPREDICTABLE",CTy"exception",
                   CC[LS"RBankSelect: BadMode",
                      Mop(Cast sTy,Var("mode",FTy 5))])),
             MU(CS(Var("mode",FTy 5),
                   [(LW(16,5),Var("usr",CTy"RName")),
                    (LW(17,5),Var("fiq",CTy"RName")),
                    (LW(18,5),Var("irq",CTy"RName")),
                    (LW(19,5),Var("svc",CTy"RName")),
                    (LW(22,5),Var("mon",CTy"RName")),
                    (LW(23,5),Var("abt",CTy"RName")),
                    (LW(26,5),Var("hyp",CTy"RName")),
                    (LW(27,5),Var("und",CTy"RName")),
                    (LW(31,5),Var("usr",CTy"RName"))]),qTy)))))
;
val RfiqBankSelect_def = Def
  ("RfiqBankSelect",
   TP[Var("mode",FTy 5),Var("usr",CTy"RName"),Var("fiq",CTy"RName")],
   Call
     ("RBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
      TP[Var("mode",FTy 5),Var("usr",CTy"RName"),Var("fiq",CTy"RName"),
         Var("usr",CTy"RName"),Var("usr",CTy"RName"),
         Var("usr",CTy"RName"),Var("usr",CTy"RName"),
         Var("usr",CTy"RName"),Var("usr",CTy"RName")]))
;
val LookUpRName_def = Def
  ("LookUpRName",TP[Var("n",F4),Var("mode",FTy 5)],
   CS(Var("n",F4),
      [(LW(0,4),MU(LC("RName_0usr",CTy"RName"),qTy)),
       (LW(1,4),MU(LC("RName_1usr",CTy"RName"),qTy)),
       (LW(2,4),MU(LC("RName_2usr",CTy"RName"),qTy)),
       (LW(3,4),MU(LC("RName_3usr",CTy"RName"),qTy)),
       (LW(4,4),MU(LC("RName_4usr",CTy"RName"),qTy)),
       (LW(5,4),MU(LC("RName_5usr",CTy"RName"),qTy)),
       (LW(6,4),MU(LC("RName_6usr",CTy"RName"),qTy)),
       (LW(7,4),MU(LC("RName_7usr",CTy"RName"),qTy)),
       (LW(8,4),
        Call
          ("RfiqBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
           TP[Var("mode",FTy 5),LC("RName_8usr",CTy"RName"),
              LC("RName_8fiq",CTy"RName")])),
       (LW(9,4),
        Call
          ("RfiqBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
           TP[Var("mode",FTy 5),LC("RName_9usr",CTy"RName"),
              LC("RName_9fiq",CTy"RName")])),
       (LW(10,4),
        Call
          ("RfiqBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
           TP[Var("mode",FTy 5),LC("RName_10usr",CTy"RName"),
              LC("RName_10fiq",CTy"RName")])),
       (LW(11,4),
        Call
          ("RfiqBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
           TP[Var("mode",FTy 5),LC("RName_11usr",CTy"RName"),
              LC("RName_11fiq",CTy"RName")])),
       (LW(12,4),
        Call
          ("RfiqBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
           TP[Var("mode",FTy 5),LC("RName_12usr",CTy"RName"),
              LC("RName_12fiq",CTy"RName")])),
       (LW(13,4),
        Call
          ("RBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
           TP[Var("mode",FTy 5),LC("RName_SPusr",CTy"RName"),
              LC("RName_SPfiq",CTy"RName"),LC("RName_SPirq",CTy"RName"),
              LC("RName_SPsvc",CTy"RName"),LC("RName_SPabt",CTy"RName"),
              LC("RName_SPund",CTy"RName"),LC("RName_SPmon",CTy"RName"),
              LC("RName_SPhyp",CTy"RName")])),
       (LW(14,4),
        Call
          ("RBankSelect",ATy(qTy,PTy(CTy"RName",qTy)),
           TP[Var("mode",FTy 5),LC("RName_LRusr",CTy"RName"),
              LC("RName_LRfiq",CTy"RName"),LC("RName_LRirq",CTy"RName"),
              LC("RName_LRsvc",CTy"RName"),LC("RName_LRabt",CTy"RName"),
              LC("RName_LRund",CTy"RName"),LC("RName_LRmon",CTy"RName"),
              LC("RName_LRusr",CTy"RName")])),
       (LW(15,4),
        Call
          ("raise'exception",ATy(qTy,PTy(CTy"RName",qTy)),
           Call
             ("ASSERT",CTy"exception",LS"LookUpRName: n >= 0 and n <= 14")))]))
;
val Rmode_def = Def
  ("Rmode",TP[Var("n",F4),Var("mode",FTy 5)],
   MB(Call("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MU(Mop(Not,bVar"v"),qTy),
            Close
              (bVar"notSecure",
               MB(ITE(Bop(And,bVar"notSecure",
                          EQ(Var("mode",FTy 5),LW(22,5))),
                      Call
                        ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                         Call("UNPREDICTABLE",CTy"exception",LS"Rmode")),
                      MU(LU,qTy)),
                  Close
                    (AVar uTy,
                     MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
                        Close
                          (Var("v",CTy"CP15"),
                           MB(MB(MB(MB(MU(Dest
                                            ("NSACR",CTy"NSACR",
                                             Var("v",CTy"CP15")),qTy),
                                       Close
                                         (Var("v",CTy"NSACR"),
                                          MU(Dest
                                               ("RFR",bTy,
                                                Var("v",CTy"NSACR")),qTy))),
                                    Close
                                      (bVar"v",
                                       MU(Bop(And,
                                              Bop(And,bVar"notSecure",
                                                  EQ(Var("mode",FTy 5),
                                                     LW(17,5))),bVar"v"),
                                          qTy))),
                                 Close
                                   (bVar"b",
                                    ITE(bVar"b",
                                        Call
                                          ("raise'exception",
                                           ATy(qTy,PTy(uTy,qTy)),
                                           Call
                                             ("UNPREDICTABLE",
                                              CTy"exception",LS"Rmode")),
                                        MU(LU,qTy)))),
                              Close
                                (AVar uTy,
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest
                                            ("REG",ATy(CTy"RName",F32),
                                             qVar"s"))),
                                    Close
                                      (Var("v",ATy(CTy"RName",F32)),
                                       MB(Call
                                            ("LookUpRName",
                                             ATy(qTy,PTy(CTy"RName",qTy)),
                                             TP[Var("n",F4),
                                                Var("mode",FTy 5)]),
                                          Close
                                            (Var("v0",CTy"RName"),
                                             MU(Apply
                                                  (Var("v",
                                                       ATy(CTy"RName",F32)),
                                                   Var("v0",CTy"RName")),
                                                qTy))))))))))))))))
;
val write'Rmode_def = Def
  ("write'Rmode",TP[Var("value",F32),Var("n",F4),Var("mode",FTy 5)],
   MB(MR(Close(qVar"s",Dest("data_abort",bTy,qVar"s"))),
      Close
        (bVar"v",
         MB(MU(Mop(Not,bVar"v"),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(Call("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU),
                      Close
                        (bVar"v",
                         MB(MU(Mop(Not,bVar"v"),qTy),
                            Close
                              (bVar"notSecure",
                               MB(ITE(Bop(And,bVar"notSecure",
                                          EQ(Var("mode",FTy 5),LW(22,5))),
                                      Call
                                        ("raise'exception",
                                         ATy(qTy,PTy(uTy,qTy)),
                                         Call
                                           ("UNPREDICTABLE",
                                            CTy"exception",LS"Rmode")),
                                      MU(LU,qTy)),
                                  Close
                                    (AVar uTy,
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("CP15",CTy"CP15",qVar"s"))),
                                        Close
                                          (Var("v",CTy"CP15"),
                                           MB(MB(MB(MB(MU(Dest
                                                            ("NSACR",
                                                             CTy"NSACR",
                                                             Var("v",
                                                                 CTy"CP15")),
                                                          qTy),
                                                       Close
                                                         (Var("v",
                                                              CTy"NSACR"),
                                                          MU(Dest
                                                               ("RFR",bTy,
                                                                Var("v",
                                                                    CTy"NSACR")),
                                                             qTy))),
                                                    Close
                                                      (bVar"v",
                                                       MU(Bop(And,
                                                              Bop(And,
                                                                  bVar"notSecure",
                                                                  EQ(Var("mode",
                                                                         FTy 5),
                                                                     LW(17,
                                                                        5))),
                                                              bVar"v"),qTy))),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        Call
                                                          ("raise'exception",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           Call
                                                             ("UNPREDICTABLE",
                                                              CTy"exception",
                                                              LS"Rmode")),
                                                        MU(LU,qTy)))),
                                              Close
                                                (AVar uTy,
                                                 MB(Call
                                                      ("CurrentInstrSet",
                                                       ATy(qTy,
                                                           PTy(CTy"InstrSet",
                                                               qTy)),LU),
                                                    Close
                                                      (Var("v",
                                                           CTy"InstrSet"),
                                                       MB(MB(MB(MB(MU(EQ(Var("v",
                                                                             CTy"InstrSet"),
                                                                         LC("InstrSet_ARM",
                                                                            CTy"InstrSet")),
                                                                      qTy),
                                                                   Close
                                                                     (bVar"v",
                                                                      MU(Mop(Not,
                                                                             bVar"v"),
                                                                         qTy))),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(Bop(And,
                                                                          Bop(And,
                                                                              EQ(Var("n",
                                                                                     F4),
                                                                                 LW(13,
                                                                                    4)),
                                                                              Mop(Not,
                                                                                  EQ(EX(Var("value",
                                                                                            F32),
                                                                                        LN
                                                                                         1,
                                                                                        LN
                                                                                         0,
                                                                                        FTy 2),
                                                                                     LW(0,
                                                                                        2)))),
                                                                          bVar"v"),
                                                                      qTy))),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    Call
                                                                      ("raise'exception",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       Call
                                                                         ("UNPREDICTABLE",
                                                                          CTy"exception",
                                                                          LS
                                                                           "Rmode")),
                                                                    MU(LU,
                                                                       qTy)))),
                                                          Close
                                                            (AVar uTy,
                                                             MB(Call
                                                                  ("LookUpRName",
                                                                   ATy(qTy,
                                                                       PTy(CTy"RName",
                                                                           qTy)),
                                                                   TP[Var("n",
                                                                          F4),
                                                                      Var("mode",
                                                                          FTy 5)]),
                                                                Close
                                                                  (Var("x",
                                                                       CTy"RName"),
                                                                   MB(MR(Close
                                                                           (qVar"s",
                                                                            Dest
                                                                              ("REG",
                                                                               ATy(CTy"RName",
                                                                                   F32),
                                                                               qVar"s"))),
                                                                      Close
                                                                        (Var("v",
                                                                             ATy(CTy"RName",
                                                                                 F32)),
                                                                         MB(MU(Fupd
                                                                                 (Var("v",
                                                                                      ATy(CTy"RName",
                                                                                          F32)),
                                                                                  Var("x",
                                                                                      CTy"RName"),
                                                                                  Var("value",
                                                                                      F32)),
                                                                               qTy),
                                                                            Close
                                                                              (Var("v",
                                                                                   ATy(CTy"RName",
                                                                                       F32)),
                                                                               MW(Close
                                                                                    (qVar"s",
                                                                                     Rupd
                                                                                       ("REG",
                                                                                        TP[qVar"s",
                                                                                           Var("v",
                                                                                               ATy(CTy"RName",
                                                                                                   F32))]))))))))))))))))))))))),
                   MU(LU,qTy)))))))
;
val R_def = Def
  ("R",Var("n",F4),
   ITE(EQ(Var("n",F4),LW(15,4)),
       MB(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
          Close
            (Var("v",CTy"InstrSet"),
             MB(MB(MU(EQ(Var("v",CTy"InstrSet"),
                         LC("InstrSet_ARM",CTy"InstrSet")),qTy),
                   Close(bVar"b",MU(ITE(bVar"b",LW(8,32),LW(4,32)),qTy))),
                Close
                  (Var("offset",F32),
                   MB(MR(Close
                           (qVar"s",
                            Dest("REG",ATy(CTy"RName",F32),qVar"s"))),
                      Close
                        (Var("v",ATy(CTy"RName",F32)),
                         MB(MU(Apply
                                 (Var("v",ATy(CTy"RName",F32)),
                                  LC("RName_PC",CTy"RName")),qTy),
                            Close
                              (Var("v",F32),
                               MU(Bop(Add,Var("v",F32),Var("offset",F32)),
                                  qTy))))))))),
       MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
          Close
            (Var("v",CTy"PSR"),
             MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                   Close
                     (Var("v",FTy 5),
                      MU(TP[Var("n",F4),Var("v",FTy 5)],qTy))),
                Close
                  (Var("v",PTy(F4,FTy 5)),
                   Call
                     ("Rmode",ATy(qTy,PTy(F32,qTy)),Var("v",PTy(F4,FTy 5)))))))))
;
val write'R_def = Def
  ("write'R",TP[Var("value",F32),Var("n",F4)],
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
               Close
                 (Var("v",FTy 5),MU(TP[Var("n",F4),Var("v",FTy 5)],qTy))),
            Close
              (Var("x",PTy(F4,FTy 5)),
               Call
                 ("write'Rmode",ATy(qTy,PTy(uTy,qTy)),
                  TP[Var("value",F32),Var("x",PTy(F4,FTy 5))]))))))
;
val SP_def = Def0 ("SP",Call("R",ATy(qTy,PTy(F32,qTy)),LW(13,4)))
;
val write'SP_def = Def
  ("write'SP",Var("value",F32),
   Call("write'R",ATy(qTy,PTy(uTy,qTy)),TP[Var("value",F32),LW(13,4)]))
;
val LR_def = Def0 ("LR",Call("R",ATy(qTy,PTy(F32,qTy)),LW(14,4)))
;
val write'LR_def = Def
  ("write'LR",Var("value",F32),
   Call("write'R",ATy(qTy,PTy(uTy,qTy)),TP[Var("value",F32),LW(14,4)]))
;
val PC_def = Def0 ("PC",Call("R",ATy(qTy,PTy(F32,qTy)),LW(15,4)))
;
val BranchTo_def = Def
  ("BranchTo",Var("address",F32),
   MB(MR(Close(qVar"s",Dest("REG",ATy(CTy"RName",F32),qVar"s"))),
      Close
        (Var("v",ATy(CTy"RName",F32)),
         MB(MU(Fupd
                 (Var("v",ATy(CTy"RName",F32)),LC("RName_PC",CTy"RName"),
                  Var("address",F32)),qTy),
            Close
              (Var("v",ATy(CTy"RName",F32)),
               MW(Close
                    (qVar"s",
                     Rupd("REG",TP[qVar"s",Var("v",ATy(CTy"RName",F32))]))))))))
;
val PCStoreValue_def = Def
  ("PCStoreValue",AVar uTy,Const("PC",ATy(qTy,PTy(F32,qTy))))
;
val BranchWritePC_def = Def
  ("BranchWritePC",Var("address",F32),
   MB(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
      Close
        (Var("v",CTy"InstrSet"),
         MB(MU(EQ(Var("v",CTy"InstrSet"),LC("InstrSet_ARM",CTy"InstrSet")),
               qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                      Close
                        (nVar"v",
                         MB(MB(MB(MU(Bop(Lt,nVar"v",LN 6),qTy),
                                  Close
                                    (bVar"b",
                                     MU(Bop(And,bVar"b",
                                            Mop(Not,
                                                EQ(EX(Var("address",F32),
                                                      LN 1,LN 0,FTy 2),
                                                   LW(0,2)))),qTy))),
                               Close
                                 (bVar"b",
                                  ITE(bVar"b",
                                      Call
                                        ("raise'exception",
                                         ATy(qTy,PTy(uTy,qTy)),
                                         Call
                                           ("UNPREDICTABLE",
                                            CTy"exception",
                                            LS"BranchWritePC")),MU(LU,qTy)))),
                            Close
                              (AVar uTy,
                               Call
                                 ("BranchTo",ATy(qTy,PTy(uTy,qTy)),
                                  CC[EX(Var("address",F32),LN 31,LN 2,
                                        FTy 30),LW(0,2)]))))),
                   Call
                     ("BranchTo",ATy(qTy,PTy(uTy,qTy)),
                      CC[EX(Var("address",F32),LN 31,LN 1,FTy 31),LW(0,1)])))))))
;
val BXWritePC_def = Def
  ("BXWritePC",Var("address",F32),
   MB(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
      Close
        (Var("v",CTy"InstrSet"),
         MB(MU(EQ(Var("v",CTy"InstrSet"),
                  LC("InstrSet_ThumbEE",CTy"InstrSet")),qTy),
            Close
              (bVar"b",
               ITB([(bVar"b",
                     ITE(Bop(Bit,Var("address",F32),LN 0),
                         Call
                           ("BranchTo",ATy(qTy,PTy(uTy,qTy)),
                            CC[EX(Var("address",F32),LN 31,LN 1,FTy 31),
                               LW(0,1)]),
                         Call
                           ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                            Call
                              ("UNPREDICTABLE",CTy"exception",
                               LS"BXWritePC")))),
                    (Bop(Bit,Var("address",F32),LN 0),
                     MB(Call
                          ("SelectInstrSet",ATy(qTy,PTy(uTy,qTy)),
                           LC("InstrSet_Thumb",CTy"InstrSet")),
                        Close
                          (AVar uTy,
                           Call
                             ("BranchTo",ATy(qTy,PTy(uTy,qTy)),
                              CC[EX(Var("address",F32),LN 31,LN 1,FTy 31),
                                 LW(0,1)])))),
                    (Mop(Not,Bop(Bit,Var("address",F32),LN 1)),
                     MB(Call
                          ("SelectInstrSet",ATy(qTy,PTy(uTy,qTy)),
                           LC("InstrSet_ARM",CTy"InstrSet")),
                        Close
                          (AVar uTy,
                           Call
                             ("BranchTo",ATy(qTy,PTy(uTy,qTy)),
                              Var("address",F32)))))],
                   Call
                     ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                      Call("UNPREDICTABLE",CTy"exception",LS"BXWritePC"))))))))
;
val LoadWritePC_def = Def
  ("LoadWritePC",Var("address",F32),
   MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
      Close
        (nVar"v",
         MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   Call
                     ("BXWritePC",ATy(qTy,PTy(uTy,qTy)),Var("address",F32)),
                   Call
                     ("BranchWritePC",ATy(qTy,PTy(uTy,qTy)),
                      Var("address",F32))))))))
;
val ALUWritePC_def = Def
  ("ALUWritePC",Var("address",F32),
   MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
      Close
        (nVar"v",
         MB(MB(MU(Bop(Ge,nVar"v",LN 7),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MB(Call
                           ("CurrentInstrSet",
                            ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
                         Close
                           (Var("v",CTy"InstrSet"),
                            MU(EQ(Var("v",CTy"InstrSet"),
                                  LC("InstrSet_ARM",CTy"InstrSet")),qTy))),
                      MU(LF,qTy)))),
            Close
              (bVar"b",
               ITE(bVar"b",
                   Call
                     ("BXWritePC",ATy(qTy,PTy(uTy,qTy)),Var("address",F32)),
                   Call
                     ("BranchWritePC",ATy(qTy,PTy(uTy,qTy)),
                      Var("address",F32))))))))
;
val ThisInstrLength_def = Def
  ("ThisInstrLength",AVar uTy,
   MB(MR(Close(qVar"s",Dest("Encoding",CTy"Encoding",qVar"s"))),
      Close
        (Var("v",CTy"Encoding"),
         MB(MU(EQ(Var("v",CTy"Encoding"),
                  LC("Encoding_Thumb",CTy"Encoding")),qTy),
            Close(bVar"b",MU(ITE(bVar"b",LN 16,LN 32),qTy))))))
;
val IncPC_def = Def
  ("IncPC",AVar uTy,
   MB(MR(Close(qVar"s",Dest("REG",ATy(CTy"RName",F32),qVar"s"))),
      Close
        (Var("v",ATy(CTy"RName",F32)),
         MB(MB(MU(Apply
                    (Var("v",ATy(CTy"RName",F32)),
                     LC("RName_PC",CTy"RName")),qTy),
               Close
                 (Var("v",F32),
                  MB(Call("ThisInstrLength",ATy(qTy,PTy(nTy,qTy)),LU),
                     Close
                       (nVar"v0",
                        MB(MB(MU(EQ(nVar"v0",LN 16),qTy),
                              Close
                                (bVar"b",
                                 MU(ITE(bVar"b",LW(2,32),LW(4,32)),qTy))),
                           Close
                             (Var("v0",F32),
                              MU(Bop(Add,Var("v",F32),Var("v0",F32)),qTy))))))),
            Close
              (Var("v",F32),
               Call("BranchTo",ATy(qTy,PTy(uTy,qTy)),Var("v",F32)))))))
;
val TranslateAddress_def = Def
  ("TranslateAddress",
   TP[Var("VA",F32),bVar"privileged",bVar"iswrite",nVar"size"],
   MB(ITE(bVar"iswrite",
          MU(SL[LC("ReadWritePermit",CTy"rights"),
                LC("XNeverReadWrite",CTy"rights")],qTy),
          MB(MR(Close(qVar"s",Dest("isfetch",bTy,qVar"s"))),
             Close
               (bVar"b",
                MU(ITE(bVar"b",
                       SL[LC("ReadPermit",CTy"rights"),
                          LC("ReadWritePermit",CTy"rights")],
                       SL[LC("ReadPermit",CTy"rights"),
                          LC("ReadWritePermit",CTy"rights"),
                          LC("XNeverRead",CTy"rights"),
                          LC("XNeverReadWrite",CTy"rights")]),qTy)))),
      Close
        (Var("rights",STy(CTy"rights")),
         MB(For(TP[LN 0,Bop(Sub,nVar"size",LN 1),
                   Close
                     (nVar"i",
                      MB(MR(Close(qVar"s",Dest("data_abort",bTy,qVar"s"))),
                         Close
                           (bVar"v",
                            MB(MB(MR(Close
                                       (qVar"s",
                                        Dest
                                          ("rights_map",
                                           ATy(F32,CTy"rights"),qVar"s"))),
                                  Close
                                    (Var("v0",ATy(F32,CTy"rights")),
                                     MB(MB(MB(MU(Apply
                                                   (Var("v0",
                                                        ATy(F32,
                                                            CTy"rights")),
                                                    Bop(Add,Var("VA",F32),
                                                        Mop(Cast F32,
                                                            nVar"i"))),qTy),
                                              Close
                                                (Var("v",CTy"rights"),
                                                 MU(Bop(In,
                                                        Var("v",
                                                            CTy"rights"),
                                                        Var("rights",
                                                            STy(CTy"rights"))),
                                                    qTy))),
                                           Close
                                             (bVar"v",
                                              MU(Mop(Not,bVar"v"),qTy))),
                                        Close
                                          (bVar"v0",
                                           MU(Bop(Or,bVar"v",bVar"v0"),qTy))))),
                               Close
                                 (bVar"v",
                                  MW(Close
                                       (qVar"s",
                                        Rupd
                                          ("data_abort",
                                           TP[qVar"s",bVar"v"]))))))))]),
            Close
              (AVar uTy,
               MB(MR(Close
                       (qVar"s",
                        Dest("translate_address",ATy(F32,OTy F32),qVar"s"))),
                  Close
                    (Var("v",ATy(F32,OTy F32)),
                     MB(MU(Apply(Var("v",ATy(F32,OTy F32)),Var("VA",F32)),
                           qTy),
                        Close
                          (Var("x",OTy F32),
                           CS(Var("x",OTy F32),
                              [(Mop(Some,Var("PA",F32)),
                                MU(Var("PA",F32),qTy)),
                               (LO F32,
                                MB(MW(Close
                                        (qVar"s",
                                         Rupd("data_abort",TP[qVar"s",LT]))),
                                   Close(AVar uTy,MU(LX F32,qTy))))]))))))))))
;
val mem1_def = Def
  ("mem1",Var("address",F32),
   MB(MR(Close(qVar"s",Dest("MEM",ATy(F32,F8),qVar"s"))),
      Close
        (Var("v",ATy(F32,F8)),
         MB(MU(Apply(Var("v",ATy(F32,F8)),Var("address",F32)),qTy),
            Close(Var("v",F8),MU(Mop(Cast vTy,Var("v",F8)),qTy))))))
;
val mem_def = Def
  ("mem",TP[Var("address",F32),nVar"size"],
   MB(MR(Close(qVar"s",Dest("data_abort",bTy,qVar"s"))),
      Close
        (bVar"b",
         ITE(bVar"b",MU(LX vTy,qTy),
             CS(nVar"size",
                [(LN 1,
                  MB(Call
                       ("mem1",ATy(qTy,PTy(vTy,qTy)),
                        Bop(Add,Var("address",F32),LW(0,32))),
                     Close(vVar"v",MU(EX(vVar"v",LN 7,LN 0,vTy),qTy)))),
                 (LN 2,
                  MB(Call
                       ("mem1",ATy(qTy,PTy(vTy,qTy)),
                        Bop(Add,Var("address",F32),LW(1,32))),
                     Close
                       (vVar"v",
                        MB(MB(Call
                                ("mem1",ATy(qTy,PTy(vTy,qTy)),
                                 Bop(Add,Var("address",F32),LW(0,32))),
                              Close(vVar"v0",MU(CC[vVar"v",vVar"v0"],qTy))),
                           Close
                             (vVar"v",MU(EX(vVar"v",LN 15,LN 0,vTy),qTy)))))),
                 (LN 4,
                  MB(Call
                       ("mem1",ATy(qTy,PTy(vTy,qTy)),
                        Bop(Add,Var("address",F32),LW(3,32))),
                     Close
                       (vVar"v",
                        MB(MB(Call
                                ("mem1",ATy(qTy,PTy(vTy,qTy)),
                                 Bop(Add,Var("address",F32),LW(2,32))),
                              Close
                                (vVar"v0",
                                 MB(MB(Call
                                         ("mem1",ATy(qTy,PTy(vTy,qTy)),
                                          Bop(Add,Var("address",F32),
                                              LW(1,32))),
                                       Close
                                         (vVar"v1",
                                          MB(MB(Call
                                                  ("mem1",
                                                   ATy(qTy,PTy(vTy,qTy)),
                                                   Bop(Add,
                                                       Var("address",F32),
                                                       LW(0,32))),
                                                Close
                                                  (vVar"v2",
                                                   MU(CC[vVar"v1",vVar"v2"],
                                                      qTy))),
                                             Close
                                               (vVar"v1",
                                                MU(CC[vVar"v0",vVar"v1"],
                                                   qTy))))),
                                    Close
                                      (vVar"v0",
                                       MU(CC[vVar"v",vVar"v0"],qTy))))),
                           Close
                             (vVar"v",MU(EX(vVar"v",LN 31,LN 0,vTy),qTy)))))),
                 (LN 8,
                  MB(Call
                       ("mem1",ATy(qTy,PTy(vTy,qTy)),
                        Bop(Add,Var("address",F32),LW(7,32))),
                     Close
                       (vVar"v",
                        MB(MB(Call
                                ("mem1",ATy(qTy,PTy(vTy,qTy)),
                                 Bop(Add,Var("address",F32),LW(6,32))),
                              Close
                                (vVar"v0",
                                 MB(MB(Call
                                         ("mem1",ATy(qTy,PTy(vTy,qTy)),
                                          Bop(Add,Var("address",F32),
                                              LW(5,32))),
                                       Close
                                         (vVar"v1",
                                          MB(MB(Call
                                                  ("mem1",
                                                   ATy(qTy,PTy(vTy,qTy)),
                                                   Bop(Add,
                                                       Var("address",F32),
                                                       LW(4,32))),
                                                Close
                                                  (vVar"v2",
                                                   MB(MB(Call
                                                           ("mem1",
                                                            ATy(qTy,
                                                                PTy(vTy,
                                                                    qTy)),
                                                            Bop(Add,
                                                                Var("address",
                                                                    F32),
                                                                LW(3,32))),
                                                         Close
                                                           (vVar"v3",
                                                            MB(MB(Call
                                                                    ("mem1",
                                                                     ATy(qTy,
                                                                         PTy(vTy,
                                                                             qTy)),
                                                                     Bop(Add,
                                                                         Var("address",
                                                                             F32),
                                                                         LW(2,
                                                                            32))),
                                                                  Close
                                                                    (vVar"v4",
                                                                     MB(MB(Call
                                                                             ("mem1",
                                                                              ATy(qTy,
                                                                                  PTy(vTy,
                                                                                      qTy)),
                                                                              Bop(Add,
                                                                                  Var("address",
                                                                                      F32),
                                                                                  LW(1,
                                                                                     32))),
                                                                           Close
                                                                             (vVar"v5",
                                                                              MB(MB(Call
                                                                                      ("mem1",
                                                                                       ATy(qTy,
                                                                                           PTy(vTy,
                                                                                               qTy)),
                                                                                       Bop(Add,
                                                                                           Var("address",
                                                                                               F32),
                                                                                           LW(0,
                                                                                              32))),
                                                                                    Close
                                                                                      (vVar"v6",
                                                                                       MU(CC[vVar"v5",
                                                                                             vVar"v6"],
                                                                                          qTy))),
                                                                                 Close
                                                                                   (vVar"v5",
                                                                                    MU(CC[vVar"v4",
                                                                                          vVar"v5"],
                                                                                       qTy))))),
                                                                        Close
                                                                          (vVar"v4",
                                                                           MU(CC[vVar"v3",
                                                                                 vVar"v4"],
                                                                              qTy))))),
                                                               Close
                                                                 (vVar"v3",
                                                                  MU(CC[vVar"v2",
                                                                        vVar"v3"],
                                                                     qTy))))),
                                                      Close
                                                        (vVar"v2",
                                                         MU(CC[vVar"v1",
                                                               vVar"v2"],
                                                            qTy))))),
                                             Close
                                               (vVar"v1",
                                                MU(CC[vVar"v0",vVar"v1"],
                                                   qTy))))),
                                    Close
                                      (vVar"v0",
                                       MU(CC[vVar"v",vVar"v0"],qTy))))),
                           Close
                             (vVar"v",MU(EX(vVar"v",LN 63,LN 0,vTy),qTy)))))),
                 (AVar nTy,
                  Call
                    ("raise'exception",ATy(qTy,PTy(vTy,qTy)),
                     Call
                       ("ASSERT",CTy"exception",
                        LS"mem: size in {1, 2, 4, 8}")))])))))
;
val write'mem_def = Def
  ("write'mem",TP[vVar"value",Var("address",F32),nVar"size"],
   MB(MR(Close(qVar"s",Dest("data_abort",bTy,qVar"s"))),
      Close
        (bVar"v",
         MB(MU(Mop(Not,bVar"v"),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   CS(nVar"size",
                      [(LN 1,
                        MB(MR(Close
                                (qVar"s",Dest("MEM",ATy(F32,F8),qVar"s"))),
                           Close
                             (Var("v",ATy(F32,F8)),
                              MB(MU(Fupd
                                      (Var("v",ATy(F32,F8)),
                                       Bop(Add,Var("address",F32),LW(0,32)),
                                       Mop(Cast F8,
                                           EX(vVar"value",LN 7,LN 0,vTy))),
                                    qTy),
                                 Close
                                   (Var("v",ATy(F32,F8)),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("MEM",
                                             TP[qVar"s",
                                                Var("v",ATy(F32,F8))])))))))),
                       (LN 2,
                        MB(MB(MR(Close
                                   (qVar"s",
                                    Dest("MEM",ATy(F32,F8),qVar"s"))),
                              Close
                                (Var("v",ATy(F32,F8)),
                                 MB(MU(Fupd
                                         (Var("v",ATy(F32,F8)),
                                          Bop(Add,Var("address",F32),
                                              LW(0,32)),
                                          Mop(Cast F8,
                                              EX(vVar"value",LN 7,LN 0,vTy))),
                                       qTy),
                                    Close
                                      (Var("v",ATy(F32,F8)),
                                       MW(Close
                                            (qVar"s",
                                             Rupd
                                               ("MEM",
                                                TP[qVar"s",
                                                   Var("v",ATy(F32,F8))]))))))),
                           Close
                             (AVar uTy,
                              MB(MR(Close
                                      (qVar"s",
                                       Dest("MEM",ATy(F32,F8),qVar"s"))),
                                 Close
                                   (Var("v",ATy(F32,F8)),
                                    MB(MU(Fupd
                                            (Var("v",ATy(F32,F8)),
                                             Bop(Add,Var("address",F32),
                                                 LW(1,32)),
                                             Mop(Cast F8,
                                                 EX(vVar"value",LN 15,
                                                    LN 8,vTy))),qTy),
                                       Close
                                         (Var("v",ATy(F32,F8)),
                                          MW(Close
                                               (qVar"s",
                                                Rupd
                                                  ("MEM",
                                                   TP[qVar"s",
                                                      Var("v",ATy(F32,F8))])))))))))),
                       (LN 4,
                        MB(MB(MR(Close
                                   (qVar"s",
                                    Dest("MEM",ATy(F32,F8),qVar"s"))),
                              Close
                                (Var("v",ATy(F32,F8)),
                                 MB(MU(Fupd
                                         (Var("v",ATy(F32,F8)),
                                          Bop(Add,Var("address",F32),
                                              LW(0,32)),
                                          Mop(Cast F8,
                                              EX(vVar"value",LN 7,LN 0,vTy))),
                                       qTy),
                                    Close
                                      (Var("v",ATy(F32,F8)),
                                       MW(Close
                                            (qVar"s",
                                             Rupd
                                               ("MEM",
                                                TP[qVar"s",
                                                   Var("v",ATy(F32,F8))]))))))),
                           Close
                             (AVar uTy,
                              MB(MB(MR(Close
                                         (qVar"s",
                                          Dest("MEM",ATy(F32,F8),qVar"s"))),
                                    Close
                                      (Var("v",ATy(F32,F8)),
                                       MB(MU(Fupd
                                               (Var("v",ATy(F32,F8)),
                                                Bop(Add,
                                                    Var("address",F32),
                                                    LW(1,32)),
                                                Mop(Cast F8,
                                                    EX(vVar"value",LN 15,
                                                       LN 8,vTy))),qTy),
                                          Close
                                            (Var("v",ATy(F32,F8)),
                                             MW(Close
                                                  (qVar"s",
                                                   Rupd
                                                     ("MEM",
                                                      TP[qVar"s",
                                                         Var("v",
                                                             ATy(F32,F8))]))))))),
                                 Close
                                   (AVar uTy,
                                    MB(MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("MEM",ATy(F32,F8),
                                                   qVar"s"))),
                                          Close
                                            (Var("v",ATy(F32,F8)),
                                             MB(MU(Fupd
                                                     (Var("v",ATy(F32,F8)),
                                                      Bop(Add,
                                                          Var("address",
                                                              F32),
                                                          LW(2,32)),
                                                      Mop(Cast F8,
                                                          EX(vVar"value",
                                                             LN 23,LN 16,
                                                             vTy))),qTy),
                                                Close
                                                  (Var("v",ATy(F32,F8)),
                                                   MW(Close
                                                        (qVar"s",
                                                         Rupd
                                                           ("MEM",
                                                            TP[qVar"s",
                                                               Var("v",
                                                                   ATy(F32,
                                                                       F8))]))))))),
                                       Close
                                         (AVar uTy,
                                          MB(MR(Close
                                                  (qVar"s",
                                                   Dest
                                                     ("MEM",ATy(F32,F8),
                                                      qVar"s"))),
                                             Close
                                               (Var("v",ATy(F32,F8)),
                                                MB(MU(Fupd
                                                        (Var("v",
                                                             ATy(F32,F8)),
                                                         Bop(Add,
                                                             Var("address",
                                                                 F32),
                                                             LW(3,32)),
                                                         Mop(Cast F8,
                                                             EX(vVar"value",
                                                                LN 31,
                                                                LN 24,vTy))),
                                                      qTy),
                                                   Close
                                                     (Var("v",ATy(F32,F8)),
                                                      MW(Close
                                                           (qVar"s",
                                                            Rupd
                                                              ("MEM",
                                                               TP[qVar"s",
                                                                  Var("v",
                                                                      ATy(F32,
                                                                          F8))])))))))))))))),
                       (LN 8,
                        MB(MB(MR(Close
                                   (qVar"s",
                                    Dest("MEM",ATy(F32,F8),qVar"s"))),
                              Close
                                (Var("v",ATy(F32,F8)),
                                 MB(MU(Fupd
                                         (Var("v",ATy(F32,F8)),
                                          Bop(Add,Var("address",F32),
                                              LW(0,32)),
                                          Mop(Cast F8,
                                              EX(vVar"value",LN 7,LN 0,vTy))),
                                       qTy),
                                    Close
                                      (Var("v",ATy(F32,F8)),
                                       MW(Close
                                            (qVar"s",
                                             Rupd
                                               ("MEM",
                                                TP[qVar"s",
                                                   Var("v",ATy(F32,F8))]))))))),
                           Close
                             (AVar uTy,
                              MB(MB(MR(Close
                                         (qVar"s",
                                          Dest("MEM",ATy(F32,F8),qVar"s"))),
                                    Close
                                      (Var("v",ATy(F32,F8)),
                                       MB(MU(Fupd
                                               (Var("v",ATy(F32,F8)),
                                                Bop(Add,
                                                    Var("address",F32),
                                                    LW(1,32)),
                                                Mop(Cast F8,
                                                    EX(vVar"value",LN 15,
                                                       LN 8,vTy))),qTy),
                                          Close
                                            (Var("v",ATy(F32,F8)),
                                             MW(Close
                                                  (qVar"s",
                                                   Rupd
                                                     ("MEM",
                                                      TP[qVar"s",
                                                         Var("v",
                                                             ATy(F32,F8))]))))))),
                                 Close
                                   (AVar uTy,
                                    MB(MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("MEM",ATy(F32,F8),
                                                   qVar"s"))),
                                          Close
                                            (Var("v",ATy(F32,F8)),
                                             MB(MU(Fupd
                                                     (Var("v",ATy(F32,F8)),
                                                      Bop(Add,
                                                          Var("address",
                                                              F32),
                                                          LW(2,32)),
                                                      Mop(Cast F8,
                                                          EX(vVar"value",
                                                             LN 23,LN 16,
                                                             vTy))),qTy),
                                                Close
                                                  (Var("v",ATy(F32,F8)),
                                                   MW(Close
                                                        (qVar"s",
                                                         Rupd
                                                           ("MEM",
                                                            TP[qVar"s",
                                                               Var("v",
                                                                   ATy(F32,
                                                                       F8))]))))))),
                                       Close
                                         (AVar uTy,
                                          MB(MB(MR(Close
                                                     (qVar"s",
                                                      Dest
                                                        ("MEM",
                                                         ATy(F32,F8),
                                                         qVar"s"))),
                                                Close
                                                  (Var("v",ATy(F32,F8)),
                                                   MB(MU(Fupd
                                                           (Var("v",
                                                                ATy(F32,F8)),
                                                            Bop(Add,
                                                                Var("address",
                                                                    F32),
                                                                LW(3,32)),
                                                            Mop(Cast F8,
                                                                EX(vVar"value",
                                                                   LN 31,
                                                                   LN 24,
                                                                   vTy))),
                                                         qTy),
                                                      Close
                                                        (Var("v",
                                                             ATy(F32,F8)),
                                                         MW(Close
                                                              (qVar"s",
                                                               Rupd
                                                                 ("MEM",
                                                                  TP[qVar"s",
                                                                     Var("v",
                                                                         ATy(F32,
                                                                             F8))]))))))),
                                             Close
                                               (AVar uTy,
                                                MB(MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("MEM",
                                                               ATy(F32,F8),
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",
                                                             ATy(F32,F8)),
                                                         MB(MU(Fupd
                                                                 (Var("v",
                                                                      ATy(F32,
                                                                          F8)),
                                                                  Bop(Add,
                                                                      Var("address",
                                                                          F32),
                                                                      LW(4,
                                                                         32)),
                                                                  Mop(Cast
                                                                        F8,
                                                                      EX(vVar"value",
                                                                         LN
                                                                          39,
                                                                         LN
                                                                          32,
                                                                         vTy))),
                                                               qTy),
                                                            Close
                                                              (Var("v",
                                                                   ATy(F32,
                                                                       F8)),
                                                               MW(Close
                                                                    (qVar"s",
                                                                     Rupd
                                                                       ("MEM",
                                                                        TP[qVar"s",
                                                                           Var("v",
                                                                               ATy(F32,
                                                                                   F8))]))))))),
                                                   Close
                                                     (AVar uTy,
                                                      MB(MB(MR(Close
                                                                 (qVar"s",
                                                                  Dest
                                                                    ("MEM",
                                                                     ATy(F32,
                                                                         F8),
                                                                     qVar"s"))),
                                                            Close
                                                              (Var("v",
                                                                   ATy(F32,
                                                                       F8)),
                                                               MB(MU(Fupd
                                                                       (Var("v",
                                                                            ATy(F32,
                                                                                F8)),
                                                                        Bop(Add,
                                                                            Var("address",
                                                                                F32),
                                                                            LW(5,
                                                                               32)),
                                                                        Mop(Cast
                                                                              F8,
                                                                            EX(vVar"value",
                                                                               LN
                                                                                47,
                                                                               LN
                                                                                40,
                                                                               vTy))),
                                                                     qTy),
                                                                  Close
                                                                    (Var("v",
                                                                         ATy(F32,
                                                                             F8)),
                                                                     MW(Close
                                                                          (qVar"s",
                                                                           Rupd
                                                                             ("MEM",
                                                                              TP[qVar"s",
                                                                                 Var("v",
                                                                                     ATy(F32,
                                                                                         F8))]))))))),
                                                         Close
                                                           (AVar uTy,
                                                            MB(MB(MR(Close
                                                                       (qVar"s",
                                                                        Dest
                                                                          ("MEM",
                                                                           ATy(F32,
                                                                               F8),
                                                                           qVar"s"))),
                                                                  Close
                                                                    (Var("v",
                                                                         ATy(F32,
                                                                             F8)),
                                                                     MB(MU(Fupd
                                                                             (Var("v",
                                                                                  ATy(F32,
                                                                                      F8)),
                                                                              Bop(Add,
                                                                                  Var("address",
                                                                                      F32),
                                                                                  LW(6,
                                                                                     32)),
                                                                              Mop(Cast
                                                                                    F8,
                                                                                  EX(vVar"value",
                                                                                     LN
                                                                                      55,
                                                                                     LN
                                                                                      48,
                                                                                     vTy))),
                                                                           qTy),
                                                                        Close
                                                                          (Var("v",
                                                                               ATy(F32,
                                                                                   F8)),
                                                                           MW(Close
                                                                                (qVar"s",
                                                                                 Rupd
                                                                                   ("MEM",
                                                                                    TP[qVar"s",
                                                                                       Var("v",
                                                                                           ATy(F32,
                                                                                               F8))]))))))),
                                                               Close
                                                                 (AVar uTy,
                                                                  MB(MR(Close
                                                                          (qVar"s",
                                                                           Dest
                                                                             ("MEM",
                                                                              ATy(F32,
                                                                                  F8),
                                                                              qVar"s"))),
                                                                     Close
                                                                       (Var("v",
                                                                            ATy(F32,
                                                                                F8)),
                                                                        MB(MU(Fupd
                                                                                (Var("v",
                                                                                     ATy(F32,
                                                                                         F8)),
                                                                                 Bop(Add,
                                                                                     Var("address",
                                                                                         F32),
                                                                                     LW(7,
                                                                                        32)),
                                                                                 Mop(Cast
                                                                                       F8,
                                                                                     EX(vVar"value",
                                                                                        LN
                                                                                         63,
                                                                                        LN
                                                                                         56,
                                                                                        vTy))),
                                                                              qTy),
                                                                           Close
                                                                             (Var("v",
                                                                                  ATy(F32,
                                                                                      F8)),
                                                                              MW(Close
                                                                                   (qVar"s",
                                                                                    Rupd
                                                                                      ("MEM",
                                                                                       TP[qVar"s",
                                                                                          Var("v",
                                                                                              ATy(F32,
                                                                                                  F8))])))))))))))))))))))))),
                       (AVar nTy,
                        Call
                          ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                           Call
                             ("ASSERT",CTy"exception",
                              LS"mem: size in {1, 2, 4, 8}")))]),
                   MU(LU,qTy)))))))
;
val BigEndianReverse_def = Def
  ("BigEndianReverse",TP[vVar"value",nVar"n"],
   CS(nVar"n",
      [(LN 1,MU(EX(vVar"value",LN 7,LN 0,vTy),qTy)),
       (LN 2,
        MU(CC[EX(vVar"value",LN 7,LN 0,vTy),EX(vVar"value",LN 15,LN 8,vTy)],
           qTy)),
       (LN 4,
        MU(CC[EX(vVar"value",LN 7,LN 0,vTy),
              EX(vVar"value",LN 15,LN 8,vTy),
              EX(vVar"value",LN 23,LN 16,vTy),
              EX(vVar"value",LN 31,LN 24,vTy)],qTy)),
       (LN 8,
        MU(CC[EX(vVar"value",LN 7,LN 0,vTy),
              EX(vVar"value",LN 15,LN 8,vTy),
              EX(vVar"value",LN 23,LN 16,vTy),
              EX(vVar"value",LN 31,LN 24,vTy),
              EX(vVar"value",LN 39,LN 32,vTy),
              EX(vVar"value",LN 47,LN 40,vTy),
              EX(vVar"value",LN 55,LN 48,vTy),
              EX(vVar"value",LN 63,LN 56,vTy)],qTy)),
       (AVar nTy,
        Call
          ("raise'exception",ATy(qTy,PTy(vTy,qTy)),
           Call
             ("ASSERT",CTy"exception",
              LS"BigEndianReverse: n in {1, 2, 4, 8}")))]))
;
val Align_def = Def
  ("Align",TP[Var("w",BTy"N"),nVar"n"],
   Mop(Cast(BTy"N"),
       Bop(Mul,nVar"n",Bop(Div,Mop(Cast nTy,Var("w",BTy"N")),nVar"n"))))
;
val Aligned_def = Def
  ("Aligned",TP[Var("w",BTy"N"),nVar"n"],
   EQ(Var("w",BTy"N"),Call("Align",BTy"N",TP[Var("w",BTy"N"),nVar"n"])))
;
val AlignmentFault_def = Def
  ("AlignmentFault",Var("address",F32),
   MW(Close(qVar"s",Rupd("data_abort",TP[qVar"s",LT]))))
;
val MemA_with_priv_def = Def
  ("MemA_with_priv",TP[Var("address",F32),nVar"size",bVar"privileged"],
   MN(LX F32,
      MB(ITE(Call("Aligned",bTy,TP[Var("address",F32),nVar"size"]),
             MW(Close
                  (Var("s",PTy(F32,qTy)),
                   TP[Var("address",F32),Mop(Snd,Var("s",PTy(F32,qTy)))])),
             MB(MR(Close
                     (Var("s",PTy(F32,qTy)),
                      Dest
                        ("CP15",CTy"CP15",Mop(Snd,Var("s",PTy(F32,qTy)))))),
                Close
                  (Var("v",CTy"CP15"),
                   MB(MB(MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),
                               PTy(F32,qTy)),
                            Close
                              (Var("v",CTy"SCTLR"),
                               MU(Dest("A",bTy,Var("v",CTy"SCTLR")),
                                  PTy(F32,qTy)))),
                         Close
                           (bVar"b",
                            ITE(bVar"b",MU(LT,PTy(F32,qTy)),
                                MB(MR(Close
                                        (Var("s",PTy(F32,qTy)),
                                         Dest
                                           ("CP15",CTy"CP15",
                                            Mop(Snd,Var("s",PTy(F32,qTy)))))),
                                   Close
                                     (Var("v",CTy"CP15"),
                                      MB(MU(Dest
                                              ("SCTLR",CTy"SCTLR",
                                               Var("v",CTy"CP15")),
                                            PTy(F32,qTy)),
                                         Close
                                           (Var("v",CTy"SCTLR"),
                                            MU(Dest
                                                 ("U",bTy,
                                                  Var("v",CTy"SCTLR")),
                                               PTy(F32,qTy))))))))),
                      Close
                        (bVar"b",
                         ITE(bVar"b",
                             MD(Call
                                  ("AlignmentFault",ATy(qTy,PTy(uTy,qTy)),
                                   Var("address",F32)),F32),
                             MW(Close
                                  (Var("s",PTy(F32,qTy)),
                                   TP[Call
                                        ("Align",F32,
                                         TP[Var("address",F32),nVar"size"]),
                                      Mop(Snd,Var("s",PTy(F32,qTy)))])))))))),
         Close
           (AVar uTy,
            MB(MR(Close
                    (Var("s",PTy(F32,qTy)),Mop(Fst,Var("s",PTy(F32,qTy))))),
               Close
                 (Var("v",F32),
                  MB(MB(MU(TP[Var("v",F32),bVar"privileged",LF,nVar"size"],
                           PTy(F32,qTy)),
                        Close
                          (Var("v",PTy(F32,PTy(bTy,PTy(bTy,nTy)))),
                           MD(Call
                                ("TranslateAddress",ATy(qTy,PTy(F32,qTy)),
                                 Var("v",PTy(F32,PTy(bTy,PTy(bTy,nTy))))),
                              F32))),
                     Close
                       (Var("memaddrdesc",F32),
                        MB(MD(Call
                                ("mem",ATy(qTy,PTy(vTy,qTy)),
                                 TP[Var("memaddrdesc",F32),nVar"size"]),
                              F32),
                           Close
                             (vVar"v",
                              MN(vVar"v",
                                 MB(MR(Close
                                         (Var("s",PTy(vTy,PTy(F32,qTy))),
                                          Dest
                                            ("isfetch",bTy,
                                             Mop(Snd,
                                                 Mop(Snd,
                                                     Var("s",
                                                         PTy(vTy,
                                                             PTy(F32,qTy)))))))),
                                    Close
                                      (bVar"v",
                                       MB(ITE(bVar"v",
                                              MB(MR(Close
                                                      (Var("s",
                                                           PTy(vTy,
                                                               PTy(F32,qTy))),
                                                       Dest
                                                         ("CP15",
                                                          CTy"CP15",
                                                          Mop(Snd,
                                                              Mop(Snd,
                                                                  Var("s",
                                                                      PTy(vTy,
                                                                          PTy(F32,
                                                                              qTy)))))))),
                                                 Close
                                                   (Var("v",CTy"CP15"),
                                                    MB(MU(Dest
                                                            ("SCTLR",
                                                             CTy"SCTLR",
                                                             Var("v",
                                                                 CTy"CP15")),
                                                          PTy(vTy,
                                                              PTy(F32,qTy))),
                                                       Close
                                                         (Var("v",
                                                              CTy"SCTLR"),
                                                          MU(Dest
                                                               ("IE",bTy,
                                                                Var("v",
                                                                    CTy"SCTLR")),
                                                             PTy(vTy,
                                                                 PTy(F32,
                                                                     qTy))))))),
                                              MB(MR(Close
                                                      (Var("s",
                                                           PTy(vTy,
                                                               PTy(F32,qTy))),
                                                       Dest
                                                         ("CPSR",CTy"PSR",
                                                          Mop(Snd,
                                                              Mop(Snd,
                                                                  Var("s",
                                                                      PTy(vTy,
                                                                          PTy(F32,
                                                                              qTy)))))))),
                                                 Close
                                                   (Var("v",CTy"PSR"),
                                                    MU(Dest
                                                         ("E",bTy,
                                                          Var("v",CTy"PSR")),
                                                       PTy(vTy,
                                                           PTy(F32,qTy)))))),
                                          Close
                                            (bVar"bigend",
                                             MB(ITE(bVar"bigend",
                                                    MB(MR(Close
                                                            (Var("s",
                                                                 PTy(vTy,
                                                                     PTy(F32,
                                                                         qTy))),
                                                             Mop(Fst,
                                                                 Var("s",
                                                                     PTy(vTy,
                                                                         PTy(F32,
                                                                             qTy)))))),
                                                       Close
                                                         (vVar"v",
                                                          MB(MB(MU(TP[vVar"v",
                                                                      nVar"size"],
                                                                   PTy(vTy,
                                                                       PTy(F32,
                                                                           qTy))),
                                                                Close
                                                                  (Var("v",
                                                                       PTy(vTy,
                                                                           nTy)),
                                                                   MD(MD(Call
                                                                           ("BigEndianReverse",
                                                                            ATy(qTy,
                                                                                PTy(vTy,
                                                                                    qTy)),
                                                                            Var("v",
                                                                                PTy(vTy,
                                                                                    nTy))),
                                                                         F32),
                                                                      vTy))),
                                                             Close
                                                               (vVar"v",
                                                                MW(Close
                                                                     (Var("s",
                                                                          PTy(vTy,
                                                                              PTy(F32,
                                                                                  qTy))),
                                                                      TP[vVar"v",
                                                                         Mop(Snd,
                                                                             Var("s",
                                                                                 PTy(vTy,
                                                                                     PTy(F32,
                                                                                         qTy))))])))))),
                                                    MU(LU,
                                                       PTy(vTy,
                                                           PTy(F32,qTy)))),
                                                Close
                                                  (AVar uTy,
                                                   MB(MR(Close
                                                           (Var("s",
                                                                PTy(vTy,
                                                                    PTy(F32,
                                                                        qTy))),
                                                            Mop(Fst,
                                                                Var("s",
                                                                    PTy(vTy,
                                                                        PTy(F32,
                                                                            qTy)))))),
                                                      Close
                                                        (vVar"v",
                                                         MU(Mop(Cast
                                                                  (BTy"N"),
                                                                vVar"v"),
                                                            PTy(vTy,
                                                                PTy(F32,
                                                                    qTy))))))))))))))))))))))
;
val write'MemA_with_priv_def = Def
  ("write'MemA_with_priv",
   TP[Var("value",BTy"N"),Var("address",F32),nVar"size",bVar"privileged"],
   MN(LX F32,
      MB(ITE(Call("Aligned",bTy,TP[Var("address",F32),nVar"size"]),
             MW(Close
                  (Var("s",PTy(F32,qTy)),
                   TP[Var("address",F32),Mop(Snd,Var("s",PTy(F32,qTy)))])),
             MB(MR(Close
                     (Var("s",PTy(F32,qTy)),
                      Dest
                        ("CP15",CTy"CP15",Mop(Snd,Var("s",PTy(F32,qTy)))))),
                Close
                  (Var("v",CTy"CP15"),
                   MB(MB(MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),
                               PTy(F32,qTy)),
                            Close
                              (Var("v",CTy"SCTLR"),
                               MU(Dest("A",bTy,Var("v",CTy"SCTLR")),
                                  PTy(F32,qTy)))),
                         Close
                           (bVar"b",
                            ITE(bVar"b",MU(LT,PTy(F32,qTy)),
                                MB(MR(Close
                                        (Var("s",PTy(F32,qTy)),
                                         Dest
                                           ("CP15",CTy"CP15",
                                            Mop(Snd,Var("s",PTy(F32,qTy)))))),
                                   Close
                                     (Var("v",CTy"CP15"),
                                      MB(MU(Dest
                                              ("SCTLR",CTy"SCTLR",
                                               Var("v",CTy"CP15")),
                                            PTy(F32,qTy)),
                                         Close
                                           (Var("v",CTy"SCTLR"),
                                            MU(Dest
                                                 ("U",bTy,
                                                  Var("v",CTy"SCTLR")),
                                               PTy(F32,qTy))))))))),
                      Close
                        (bVar"b",
                         ITE(bVar"b",
                             MD(Call
                                  ("AlignmentFault",ATy(qTy,PTy(uTy,qTy)),
                                   Var("address",F32)),F32),
                             MW(Close
                                  (Var("s",PTy(F32,qTy)),
                                   TP[Call
                                        ("Align",F32,
                                         TP[Var("address",F32),nVar"size"]),
                                      Mop(Snd,Var("s",PTy(F32,qTy)))])))))))),
         Close
           (AVar uTy,
            MB(MR(Close
                    (Var("s",PTy(F32,qTy)),Mop(Fst,Var("s",PTy(F32,qTy))))),
               Close
                 (Var("v",F32),
                  MB(MB(MU(TP[Var("v",F32),bVar"privileged",LT,nVar"size"],
                           PTy(F32,qTy)),
                        Close
                          (Var("v",PTy(F32,PTy(bTy,PTy(bTy,nTy)))),
                           MD(Call
                                ("TranslateAddress",ATy(qTy,PTy(F32,qTy)),
                                 Var("v",PTy(F32,PTy(bTy,PTy(bTy,nTy))))),
                              F32))),
                     Close
                       (Var("memaddrdesc",F32),
                        MB(MR(Close
                                (Var("s",PTy(F32,qTy)),
                                 Dest
                                   ("isfetch",bTy,
                                    Mop(Snd,Var("s",PTy(F32,qTy)))))),
                           Close
                             (bVar"v",
                              MB(ITE(bVar"v",
                                     MB(MR(Close
                                             (Var("s",PTy(F32,qTy)),
                                              Dest
                                                ("CP15",CTy"CP15",
                                                 Mop(Snd,
                                                     Var("s",PTy(F32,qTy)))))),
                                        Close
                                          (Var("v",CTy"CP15"),
                                           MB(MU(Dest
                                                   ("SCTLR",CTy"SCTLR",
                                                    Var("v",CTy"CP15")),
                                                 PTy(F32,qTy)),
                                              Close
                                                (Var("v",CTy"SCTLR"),
                                                 MU(Dest
                                                      ("IE",bTy,
                                                       Var("v",CTy"SCTLR")),
                                                    PTy(F32,qTy)))))),
                                     MB(MR(Close
                                             (Var("s",PTy(F32,qTy)),
                                              Dest
                                                ("CPSR",CTy"PSR",
                                                 Mop(Snd,
                                                     Var("s",PTy(F32,qTy)))))),
                                        Close
                                          (Var("v",CTy"PSR"),
                                           MU(Dest
                                                ("E",bTy,Var("v",CTy"PSR")),
                                              PTy(F32,qTy))))),
                                 Close
                                   (bVar"bigend",
                                    MB(ITE(bVar"bigend",
                                           MD(Call
                                                ("BigEndianReverse",
                                                 ATy(qTy,PTy(vTy,qTy)),
                                                 TP[Mop(Cast vTy,
                                                        Var("value",BTy"N")),
                                                    nVar"size"]),F32),
                                           MU(Mop(Cast vTy,
                                                  Var("value",BTy"N")),
                                              PTy(F32,qTy))),
                                       Close
                                         (vVar"value",
                                          MD(Call
                                               ("write'mem",
                                                ATy(qTy,PTy(uTy,qTy)),
                                                TP[vVar"value",
                                                   Var("memaddrdesc",F32),
                                                   nVar"size"]),F32)))))))))))))))
;
val MemA_unpriv_def = Def
  ("MemA_unpriv",TP[Var("address",F32),nVar"size"],
   Call
     ("MemA_with_priv",ATy(qTy,PTy(BTy"N",qTy)),
      TP[Var("address",F32),nVar"size",LF]))
;
val write'MemA_unpriv_def = Def
  ("write'MemA_unpriv",
   TP[Var("value",BTy"N"),Var("address",F32),nVar"size"],
   Call
     ("write'MemA_with_priv",ATy(qTy,PTy(uTy,qTy)),
      TP[Var("value",BTy"N"),Var("address",F32),nVar"size",LF]))
;
val MemA_def = Def
  ("MemA",TP[Var("address",F32),nVar"size"],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(MU(TP[nVar"size",bVar"v"],qTy),
               Close
                 (Var("v",PTy(nTy,bTy)),
                  MU(TP[Var("address",F32),Var("v",PTy(nTy,bTy))],qTy))),
            Close
              (Var("v",PTy(F32,PTy(nTy,bTy))),
               Call
                 ("MemA_with_priv",ATy(qTy,PTy(BTy"N",qTy)),
                  Var("v",PTy(F32,PTy(nTy,bTy)))))))))
;
val write'MemA_def = Def
  ("write'MemA",TP[Var("value",BTy"N"),Var("address",F32),nVar"size"],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(MU(TP[nVar"size",bVar"v"],qTy),
               Close
                 (Var("v",PTy(nTy,bTy)),
                  MU(TP[Var("address",F32),Var("v",PTy(nTy,bTy))],qTy))),
            Close
              (Var("x",PTy(F32,PTy(nTy,bTy))),
               Call
                 ("write'MemA_with_priv",ATy(qTy,PTy(uTy,qTy)),
                  TP[Var("value",BTy"N"),Var("x",PTy(F32,PTy(nTy,bTy)))]))))))
;
val MemU_with_priv_def = Def
  ("MemU_with_priv",TP[Var("address",F32),nVar"size",bVar"privileged"],
   MN(Bop(Rep,LV"0",LN 64),
      MB(MR(Close
              (Var("s",PTy(vTy,qTy)),
               Dest("CP15",CTy"CP15",Mop(Snd,Var("s",PTy(vTy,qTy)))))),
         Close
           (Var("v",CTy"CP15"),
            MB(MB(MB(MB(MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),
                              PTy(vTy,qTy)),
                           Close
                             (Var("v",CTy"SCTLR"),
                              MU(Dest("A",bTy,Var("v",CTy"SCTLR")),
                                 PTy(vTy,qTy)))),
                        Close(bVar"v",MU(Mop(Not,bVar"v"),PTy(vTy,qTy)))),
                     Close
                       (bVar"b",
                        ITE(bVar"b",
                            MB(MR(Close
                                    (Var("s",PTy(vTy,qTy)),
                                     Dest
                                       ("CP15",CTy"CP15",
                                        Mop(Snd,Var("s",PTy(vTy,qTy)))))),
                               Close
                                 (Var("v",CTy"CP15"),
                                  MB(MB(MU(Dest
                                             ("SCTLR",CTy"SCTLR",
                                              Var("v",CTy"CP15")),
                                           PTy(vTy,qTy)),
                                        Close
                                          (Var("v",CTy"SCTLR"),
                                           MU(Dest
                                                ("U",bTy,
                                                 Var("v",CTy"SCTLR")),
                                              PTy(vTy,qTy)))),
                                     Close
                                       (bVar"v",
                                        MU(Mop(Not,bVar"v"),PTy(vTy,qTy)))))),
                            MU(LF,PTy(vTy,qTy))))),
                  Close
                    (bVar"b",
                     MU(ITE(bVar"b",
                            Call
                              ("Align",F32,
                               TP[Var("address",F32),nVar"size"]),
                            Var("address",F32)),PTy(vTy,qTy)))),
               Close
                 (Var("VA",F32),
                  MB(ITE(Call("Aligned",bTy,TP[Var("VA",F32),nVar"size"]),
                         MB(MD(Call
                                 ("MemA_with_priv",
                                  ATy(qTy,PTy(BTy"N",qTy)),
                                  TP[Var("VA",F32),nVar"size",
                                     bVar"privileged"]),vTy),
                            Close
                              (Var("v",BTy"N"),
                               MB(MU(Mop(Cast vTy,Var("v",BTy"N")),
                                     PTy(vTy,qTy)),
                                  Close
                                    (vVar"v",
                                     MW(Close
                                          (Var("s",PTy(vTy,qTy)),
                                           TP[vVar"v",
                                              Mop(Snd,
                                                  Var("s",PTy(vTy,qTy)))])))))),
                         MB(MR(Close
                                 (Var("s",PTy(vTy,qTy)),
                                  Dest
                                    ("CP15",CTy"CP15",
                                     Mop(Snd,Var("s",PTy(vTy,qTy)))))),
                            Close
                              (Var("v",CTy"CP15"),
                               MB(MB(MU(Dest
                                          ("SCTLR",CTy"SCTLR",
                                           Var("v",CTy"CP15")),
                                        PTy(vTy,qTy)),
                                     Close
                                       (Var("v",CTy"SCTLR"),
                                        MU(Dest
                                             ("A",bTy,Var("v",CTy"SCTLR")),
                                           PTy(vTy,qTy)))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MB(MW(Close
                                                 (Var("s",PTy(vTy,qTy)),
                                                  TP[LX vTy,
                                                     Mop(Snd,
                                                         Var("s",
                                                             PTy(vTy,qTy)))])),
                                            Close
                                              (AVar uTy,
                                               MD(Call
                                                    ("AlignmentFault",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     Var("address",F32)),
                                                  vTy))),
                                         MB(For(TP[LN 0,
                                                   Bop(Sub,nVar"size",LN 1),
                                                   Close
                                                     (nVar"i",
                                                      MB(MR(Close
                                                              (Var("s",
                                                                   PTy(vTy,
                                                                       qTy)),
                                                               Mop(Fst,
                                                                   Var("s",
                                                                       PTy(vTy,
                                                                           qTy))))),
                                                         Close
                                                           (vVar"v",
                                                            MB(MB(MD(Call
                                                                       ("MemA_with_priv",
                                                                        ATy(qTy,
                                                                            PTy(F8,
                                                                                qTy)),
                                                                        TP[Bop(Add,
                                                                               Var("VA",
                                                                                   F32),
                                                                               Mop(Cast
                                                                                     F32,
                                                                                   nVar"i")),
                                                                           LN
                                                                            1,
                                                                           bVar"privileged"]),
                                                                     vTy),
                                                                  Close
                                                                    (Var("v0",
                                                                         F8),
                                                                     MB(MU(Mop(Cast
                                                                                 vTy,
                                                                               Var("v0",
                                                                                   F8)),
                                                                           PTy(vTy,
                                                                               qTy)),
                                                                        Close
                                                                          (vVar"v0",
                                                                           MU(BFI(Bop(Add,
                                                                                      Bop(Mul,
                                                                                          LN
                                                                                           8,
                                                                                          nVar"i"),
                                                                                      LN
                                                                                       7),
                                                                                  Bop(Mul,
                                                                                      LN
                                                                                       8,
                                                                                      nVar"i"),
                                                                                  vVar"v0",
                                                                                  vVar"v"),
                                                                              PTy(vTy,
                                                                                  qTy)))))),
                                                               Close
                                                                 (vVar"v",
                                                                  MW(Close
                                                                       (Var("s",
                                                                            PTy(vTy,
                                                                                qTy)),
                                                                        TP[vVar"v",
                                                                           Mop(Snd,
                                                                               Var("s",
                                                                                   PTy(vTy,
                                                                                       qTy)))])))))))]),
                                            Close
                                              (AVar uTy,
                                               MB(MR(Close
                                                       (Var("s",
                                                            PTy(vTy,qTy)),
                                                        Dest
                                                          ("CPSR",
                                                           CTy"PSR",
                                                           Mop(Snd,
                                                               Var("s",
                                                                   PTy(vTy,
                                                                       qTy)))))),
                                                  Close
                                                    (Var("v",CTy"PSR"),
                                                     MB(MU(Dest
                                                             ("E",bTy,
                                                              Var("v",
                                                                  CTy"PSR")),
                                                           PTy(vTy,qTy)),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(MR(Close
                                                                       (Var("s",
                                                                            PTy(vTy,
                                                                                qTy)),
                                                                        Mop(Fst,
                                                                            Var("s",
                                                                                PTy(vTy,
                                                                                    qTy))))),
                                                                  Close
                                                                    (vVar"v",
                                                                     MB(MB(MU(TP[vVar"v",
                                                                                 nVar"size"],
                                                                              PTy(vTy,
                                                                                  qTy)),
                                                                           Close
                                                                             (Var("v",
                                                                                  PTy(vTy,
                                                                                      nTy)),
                                                                              MD(Call
                                                                                   ("BigEndianReverse",
                                                                                    ATy(qTy,
                                                                                        PTy(vTy,
                                                                                            qTy)),
                                                                                    Var("v",
                                                                                        PTy(vTy,
                                                                                            nTy))),
                                                                                 vTy))),
                                                                        Close
                                                                          (vVar"v",
                                                                           MW(Close
                                                                                (Var("s",
                                                                                     PTy(vTy,
                                                                                         qTy)),
                                                                                 TP[vVar"v",
                                                                                    Mop(Snd,
                                                                                        Var("s",
                                                                                            PTy(vTy,
                                                                                                qTy)))])))))),
                                                               MU(LU,
                                                                  PTy(vTy,
                                                                      qTy))))))))))))))),
                     Close
                       (AVar uTy,
                        MB(MR(Close
                                (Var("s",PTy(vTy,qTy)),
                                 Mop(Fst,Var("s",PTy(vTy,qTy))))),
                           Close
                             (vVar"v",
                              MU(Mop(Cast(BTy"N"),vVar"v"),PTy(vTy,qTy))))))))))))
;
val write'MemU_with_priv_def = Def
  ("write'MemU_with_priv",
   TP[Var("value",BTy"N"),Var("address",F32),nVar"size",bVar"privileged"],
   MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
      Close
        (Var("v",CTy"CP15"),
         MB(MB(MB(MB(MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),qTy),
                        Close
                          (Var("v",CTy"SCTLR"),
                           MU(Dest("A",bTy,Var("v",CTy"SCTLR")),qTy))),
                     Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))),
                  Close
                    (bVar"b",
                     ITE(bVar"b",
                         MB(MR(Close
                                 (qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
                            Close
                              (Var("v",CTy"CP15"),
                               MB(MB(MU(Dest
                                          ("SCTLR",CTy"SCTLR",
                                           Var("v",CTy"CP15")),qTy),
                                     Close
                                       (Var("v",CTy"SCTLR"),
                                        MU(Dest
                                             ("U",bTy,Var("v",CTy"SCTLR")),
                                           qTy))),
                                  Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))))),
                         MU(LF,qTy)))),
               Close
                 (bVar"b",
                  MU(ITE(bVar"b",
                         Call
                           ("Align",F32,TP[Var("address",F32),nVar"size"]),
                         Var("address",F32)),qTy))),
            Close
              (Var("VA",F32),
               ITE(Call("Aligned",bTy,TP[Var("VA",F32),nVar"size"]),
                   Call
                     ("write'MemA_with_priv",ATy(qTy,PTy(uTy,qTy)),
                      TP[Var("value",BTy"N"),Var("VA",F32),nVar"size",
                         bVar"privileged"]),
                   MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
                      Close
                        (Var("v",CTy"CP15"),
                         MB(MB(MU(Dest
                                    ("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),
                                  qTy),
                               Close
                                 (Var("v",CTy"SCTLR"),
                                  MU(Dest("A",bTy,Var("v",CTy"SCTLR")),qTy))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   Call
                                     ("AlignmentFault",
                                      ATy(qTy,PTy(uTy,qTy)),
                                      Var("address",F32)),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("CPSR",CTy"PSR",qVar"s"))),
                                      Close
                                        (Var("v",CTy"PSR"),
                                         MB(MB(MU(Dest
                                                    ("E",bTy,
                                                     Var("v",CTy"PSR")),
                                                  qTy),
                                               Close
                                                 (bVar"b",
                                                  ITE(bVar"b",
                                                      Call
                                                        ("BigEndianReverse",
                                                         ATy(qTy,
                                                             PTy(vTy,qTy)),
                                                         TP[Mop(Cast vTy,
                                                                Var("value",
                                                                    BTy"N")),
                                                            nVar"size"]),
                                                      MU(Mop(Cast vTy,
                                                             Var("value",
                                                                 BTy"N")),
                                                         qTy)))),
                                            Close
                                              (vVar"v",
                                               For(TP[LN 0,
                                                      Bop(Sub,nVar"size",
                                                          LN 1),
                                                      Close
                                                        (nVar"i",
                                                         Call
                                                           ("write'MemA_with_priv",
                                                            ATy(qTy,
                                                                PTy(uTy,
                                                                    qTy)),
                                                            TP[Mop(Cast F8,
                                                                   EX(vVar"v",
                                                                      Bop(Add,
                                                                          Bop(Mul,
                                                                              LN
                                                                               8,
                                                                              nVar"i"),
                                                                          LN
                                                                           7),
                                                                      Bop(Mul,
                                                                          LN
                                                                           8,
                                                                          nVar"i"),
                                                                      vTy)),
                                                               Bop(Add,
                                                                   Var("VA",
                                                                       F32),
                                                                   Mop(Cast
                                                                         F32,
                                                                       nVar"i")),
                                                               LN 1,
                                                               bVar"privileged"]))]))))))))))))))))
;
val MemU_unpriv_def = Def
  ("MemU_unpriv",TP[Var("address",F32),nVar"size"],
   Call
     ("MemU_with_priv",ATy(qTy,PTy(BTy"N",qTy)),
      TP[Var("address",F32),nVar"size",LF]))
;
val write'MemU_unpriv_def = Def
  ("write'MemU_unpriv",
   TP[Var("value",BTy"N"),Var("address",F32),nVar"size"],
   Call
     ("write'MemU_with_priv",ATy(qTy,PTy(uTy,qTy)),
      TP[Var("value",BTy"N"),Var("address",F32),nVar"size",LF]))
;
val MemU_def = Def
  ("MemU",TP[Var("address",F32),nVar"size"],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(MU(TP[nVar"size",bVar"v"],qTy),
               Close
                 (Var("v",PTy(nTy,bTy)),
                  MU(TP[Var("address",F32),Var("v",PTy(nTy,bTy))],qTy))),
            Close
              (Var("v",PTy(F32,PTy(nTy,bTy))),
               Call
                 ("MemU_with_priv",ATy(qTy,PTy(BTy"N",qTy)),
                  Var("v",PTy(F32,PTy(nTy,bTy)))))))))
;
val write'MemU_def = Def
  ("write'MemU",TP[Var("value",BTy"N"),Var("address",F32),nVar"size"],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(MU(TP[nVar"size",bVar"v"],qTy),
               Close
                 (Var("v",PTy(nTy,bTy)),
                  MU(TP[Var("address",F32),Var("v",PTy(nTy,bTy))],qTy))),
            Close
              (Var("x",PTy(F32,PTy(nTy,bTy))),
               Call
                 ("write'MemU_with_priv",ATy(qTy,PTy(uTy,qTy)),
                  TP[Var("value",BTy"N"),Var("x",PTy(F32,PTy(nTy,bTy)))]))))))
;
val NullCheckIfThumbEE_def = Def
  ("NullCheckIfThumbEE",Var("n",F4),
   MN(LF,
      MB(MD(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),bTy),
         Close
           (Var("v",CTy"InstrSet"),
            MB(MB(MU(EQ(Var("v",CTy"InstrSet"),
                        LC("InstrSet_ThumbEE",CTy"InstrSet")),PTy(bTy,qTy)),
                  Close
                    (bVar"b",
                     ITE(bVar"b",
                         ITB([(EQ(Var("n",F4),LW(15,4)),
                               MB(MD(Const("PC",ATy(qTy,PTy(F32,qTy))),bTy),
                                  Close
                                    (Var("v",F32),
                                     MB(MB(MB(MU(TP[Var("v",F32),LN 4],
                                                 PTy(bTy,qTy)),
                                              Close
                                                (Var("v",PTy(F32,nTy)),
                                                 MU(Call
                                                      ("Align",F32,
                                                       Var("v",
                                                           PTy(F32,nTy))),
                                                    PTy(bTy,qTy)))),
                                           Close
                                             (Var("v",F32),
                                              MU(EQ(Var("v",F32),LW(0,32)),
                                                 PTy(bTy,qTy)))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MD(Call
                                                    ("raise'exception",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     Call
                                                       ("UNPREDICTABLE",
                                                        CTy"exception",
                                                        LS
                                                         "NullCheckIfThumbEE")),
                                                  bTy),MU(LU,PTy(bTy,qTy)))))))),
                              (EQ(Var("n",F4),LW(13,4)),
                               MB(MD(Const("SP",ATy(qTy,PTy(F32,qTy))),bTy),
                                  Close
                                    (Var("v",F32),
                                     MB(MU(EQ(Var("v",F32),LW(0,32)),
                                           PTy(bTy,qTy)),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MD(Call
                                                    ("raise'exception",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     Call
                                                       ("UNPREDICTABLE",
                                                        CTy"exception",
                                                        LS
                                                         "NullCheckIfThumbEE")),
                                                  bTy),MU(LU,PTy(bTy,qTy))))))))],
                             MB(MD(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("n",F4)),bTy),
                                Close
                                  (Var("v",F32),
                                   MB(MU(EQ(Var("v",F32),LW(0,32)),
                                         PTy(bTy,qTy)),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(MD(Const
                                                     ("PC",
                                                      ATy(qTy,PTy(F32,qTy))),
                                                   bTy),
                                                Close
                                                  (Var("v",F32),
                                                   MB(MB(MB(MU(EX(Var("v",
                                                                      F32),
                                                                  LN 31,
                                                                  LN 1,
                                                                  FTy 31),
                                                               PTy(bTy,qTy)),
                                                            Close
                                                              (Var("v",
                                                                   FTy 31),
                                                               MU(CC[Var("v",
                                                                         FTy 31),
                                                                     LW(1,
                                                                        1)],
                                                                  PTy(bTy,
                                                                      qTy)))),
                                                         Close
                                                           (Var("v",F32),
                                                            MD(Call
                                                                 ("write'LR",
                                                                  ATy(qTy,
                                                                      PTy(uTy,
                                                                          qTy)),
                                                                  Var("v",
                                                                      F32)),
                                                               bTy))),
                                                      Close
                                                        (AVar uTy,
                                                         MB(MD(Call
                                                                 ("write'ITSTATE",
                                                                  ATy(qTy,
                                                                      PTy(uTy,
                                                                          qTy)),
                                                                  LW(0,8)),
                                                               bTy),
                                                            Close
                                                              (AVar uTy,
                                                               MB(MR(Close
                                                                       (Var("s",
                                                                            PTy(bTy,
                                                                                qTy)),
                                                                        Dest
                                                                          ("CP14",
                                                                           CTy"CP14",
                                                                           Mop(Snd,
                                                                               Var("s",
                                                                                   PTy(bTy,
                                                                                       qTy)))))),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"CP14"),
                                                                     MB(MB(MB(MU(Dest
                                                                                   ("TEEHBR",
                                                                                    F32,
                                                                                    Var("v",
                                                                                        CTy"CP14")),
                                                                                 PTy(bTy,
                                                                                     qTy)),
                                                                              Close
                                                                                (Var("v",
                                                                                     F32),
                                                                                 MU(Bop(Sub,
                                                                                        Var("v",
                                                                                            F32),
                                                                                        LW(4,
                                                                                           32)),
                                                                                    PTy(bTy,
                                                                                        qTy)))),
                                                                           Close
                                                                             (Var("v",
                                                                                  F32),
                                                                              MD(Call
                                                                                   ("BranchWritePC",
                                                                                    ATy(qTy,
                                                                                        PTy(uTy,
                                                                                            qTy)),
                                                                                    Var("v",
                                                                                        F32)),
                                                                                 bTy))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MW(Close
                                                                                (Var("s",
                                                                                     PTy(bTy,
                                                                                         qTy)),
                                                                                 TP[LT,
                                                                                    Mop(Snd,
                                                                                        Var("s",
                                                                                            PTy(bTy,
                                                                                                qTy)))])))))))))))),
                                             MU(LU,PTy(bTy,qTy)))))))),
                         MU(LU,PTy(bTy,qTy))))),
               Close
                 (AVar uTy,
                  MB(MR(Close
                          (Var("s",PTy(bTy,qTy)),
                           Mop(Fst,Var("s",PTy(bTy,qTy))))),
                     Close(bVar"v",MU(Mop(Not,bVar"v"),PTy(bTy,qTy))))))))))
;
val HighestSetBit_def = Def
  ("HighestSetBit",Var("w",BTy"N"),
   ITE(EQ(Var("w",BTy"N"),LY(0,"N")),Mop(Neg,LI 1),
       Mop(Cast iTy,Mop(Log,Var("w",BTy"N")))))
;
val CountLeadingZeroBits_def = Def
  ("CountLeadingZeroBits",Var("w",BTy"N"),
   Mop(Cast nTy,
       Bop(Sub,Bop(Sub,Mop(Cast iTy,Mop(Size,LY(0,"N"))),LI 1),
           Call("HighestSetBit",iTy,Var("w",BTy"N")))))
;
val LowestSetBit_def = Def
  ("LowestSetBit",Var("w",BTy"N"),
   Call("CountLeadingZeroBits",nTy,Mop(Rev,Var("w",BTy"N"))))
;
val BitCount_def = Def
  ("BitCount",Var("w",BTy"N"),
   MN(LN 0,
      MB(For(TP[LN 0,Bop(Sub,Mop(Size,LY(0,"N")),LN 1),
                Close
                  (nVar"i",
                   ITE(Bop(Bit,Var("w",BTy"N"),nVar"i"),
                       MB(MR(Close
                               (Var("s",PTy(nTy,qTy)),
                                Mop(Fst,Var("s",PTy(nTy,qTy))))),
                          Close
                            (nVar"v",
                             MB(MU(Bop(Add,nVar"v",LN 1),PTy(nTy,qTy)),
                                Close
                                  (nVar"v",
                                   MW(Close
                                        (Var("s",PTy(nTy,qTy)),
                                         TP[nVar"v",
                                            Mop(Snd,Var("s",PTy(nTy,qTy)))])))))),
                       MU(LU,PTy(nTy,qTy))))]),
         Close
           (AVar uTy,
            MR(Close(Var("s",PTy(nTy,qTy)),Mop(Fst,Var("s",PTy(nTy,qTy)))))))))
;
val SignExtendFrom_def = Def
  ("SignExtendFrom",TP[Var("w",BTy"N"),nVar"p"],
   Let(nVar"s",Bop(Sub,Mop(Size,LY(0,"N")),nVar"p"),
       Bop(Asr,Bop(Lsl,Var("w",BTy"N"),nVar"s"),nVar"s")))
;
val Extend_def = Def
  ("Extend",TP[bVar"unsigned",Var("w",BTy"M")],
   ITE(bVar"unsigned",Mop(Cast(BTy"N"),Var("w",BTy"M")),
       Mop(SE(BTy"N"),Var("w",BTy"M"))))
;
val UInt_def = Def
  ("UInt",Var("w",BTy"N"),Mop(Cast iTy,Mop(Cast nTy,Var("w",BTy"N"))))
;
val SignedSatQ_def = Def
  ("SignedSatQ",TP[iVar"i",nVar"N"],
   MB(ITE(Bop(Lt,Mop(Size,LY(0,"M")),nVar"N"),
          Call
            ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
             Call("ASSERT",CTy"exception",LS"SignedSatQ: M < N")),
          MU(LU,qTy)),
      Close
        (AVar uTy,
         MU(Let(iVar"max",
                Mop(Cast iTy,
                    Bop(Sub,Bop(Exp,LN 2,Bop(Sub,nVar"N",LN 1)),LN 1)),
                ITB([(Bop(Gt,iVar"i",iVar"max"),
                      TP[Mop(Cast(BTy"M"),iVar"max"),LT]),
                     (Bop(Lt,iVar"i",Mop(Neg,iVar"max")),
                      TP[Mop(Neg,Mop(Cast(BTy"M"),iVar"max")),LT])],
                    TP[Mop(Cast(BTy"M"),iVar"i"),LF])),qTy))))
;
val UnsignedSatQ_def = Def
  ("UnsignedSatQ",TP[iVar"i",nVar"N"],
   MB(ITE(Bop(Lt,Mop(Size,LY(0,"M")),nVar"N"),
          Call
            ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
             Call("ASSERT",CTy"exception",LS"UnsignedSatQ: M < N")),
          MU(LU,qTy)),
      Close
        (AVar uTy,
         MU(Let(iVar"max",
                Mop(Cast iTy,Bop(Sub,Bop(Exp,LN 2,nVar"N"),LN 1)),
                ITB([(Bop(Gt,iVar"i",iVar"max"),
                      TP[Mop(Cast(BTy"M"),iVar"max"),LT]),
                     (Bop(Lt,iVar"i",LI 0),TP[LY(0,"M"),LT])],
                    TP[Mop(Cast(BTy"M"),iVar"i"),LF])),qTy))))
;
val SignedSat_def = Def
  ("SignedSat",TP[iVar"i",nVar"N"],
   MB(Call
        ("SignedSatQ",ATy(qTy,PTy(PTy(BTy"M",bTy),qTy)),
         TP[iVar"i",nVar"N"]),
      Close
        (Var("v",PTy(BTy"M",bTy)),
         MU(Mop(Fst,Var("v",PTy(BTy"M",bTy))),qTy))))
;
val UnsignedSat_def = Def
  ("UnsignedSat",TP[iVar"i",nVar"N"],
   MB(Call
        ("UnsignedSatQ",ATy(qTy,PTy(PTy(BTy"M",bTy),qTy)),
         TP[iVar"i",nVar"N"]),
      Close
        (Var("v",PTy(BTy"M",bTy)),
         MU(Mop(Fst,Var("v",PTy(BTy"M",bTy))),qTy))))
;
val LSL_C_def = Def
  ("LSL_C",TP[Var("x",BTy"N"),nVar"shift"],
   MB(ITE(EQ(nVar"shift",LN 0),
          Call
            ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
             Call("ASSERT",CTy"exception",LS"LSL_C")),MU(LU,qTy)),
      Close
        (AVar uTy,
         MU(TP[Bop(Lsl,Var("x",BTy"N"),nVar"shift"),
               Bop(Bit,
                   CC[Mop(Cast vTy,Var("x",BTy"N")),
                      Bop(Rep,LV"0",nVar"shift")],Mop(Size,LY(0,"N")))],
            qTy))))
;
val LSL_def = Def
  ("LSL",TP[Var("x",BTy"N"),nVar"shift"],
   ITE(EQ(nVar"shift",LN 0),MU(Var("x",BTy"N"),qTy),
       MB(Call
            ("LSL_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
             TP[Var("x",BTy"N"),nVar"shift"]),
          Close
            (Var("v",PTy(BTy"N",bTy)),
             MU(Mop(Fst,Var("v",PTy(BTy"N",bTy))),qTy)))))
;
val LSR_C_def = Def
  ("LSR_C",TP[Var("x",BTy"N"),nVar"shift"],
   MB(ITE(EQ(nVar"shift",LN 0),
          Call
            ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
             Call("ASSERT",CTy"exception",LS"LSR_C")),MU(LU,qTy)),
      Close
        (AVar uTy,
         MU(TP[Bop(Lsr,Var("x",BTy"N"),nVar"shift"),
               Bop(And,Bop(Le,nVar"shift",Mop(Size,LY(0,"N"))),
                   Bop(Bit,Var("x",BTy"N"),Bop(Sub,nVar"shift",LN 1)))],
            qTy))))
;
val LSR_def = Def
  ("LSR",TP[Var("x",BTy"N"),nVar"shift"],
   ITE(EQ(nVar"shift",LN 0),MU(Var("x",BTy"N"),qTy),
       MB(Call
            ("LSR_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
             TP[Var("x",BTy"N"),nVar"shift"]),
          Close
            (Var("v",PTy(BTy"N",bTy)),
             MU(Mop(Fst,Var("v",PTy(BTy"N",bTy))),qTy)))))
;
val ASR_C_def = Def
  ("ASR_C",TP[Var("x",BTy"N"),nVar"shift"],
   MB(ITE(EQ(nVar"shift",LN 0),
          Call
            ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
             Call("ASSERT",CTy"exception",LS"ASR_C")),MU(LU,qTy)),
      Close
        (AVar uTy,
         MU(TP[Bop(Asr,Var("x",BTy"N"),nVar"shift"),
               Bop(Bit,Var("x",BTy"N"),
                   Bop(Sub,Mop(Min,TP[Mop(Size,LY(0,"N")),nVar"shift"]),
                       LN 1))],qTy))))
;
val ASR_def = Def
  ("ASR",TP[Var("x",BTy"N"),nVar"shift"],
   ITE(EQ(nVar"shift",LN 0),MU(Var("x",BTy"N"),qTy),
       MB(Call
            ("ASR_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
             TP[Var("x",BTy"N"),nVar"shift"]),
          Close
            (Var("v",PTy(BTy"N",bTy)),
             MU(Mop(Fst,Var("v",PTy(BTy"N",bTy))),qTy)))))
;
val ROR_C_def = Def
  ("ROR_C",TP[Var("x",BTy"N"),nVar"shift"],
   MB(ITE(EQ(nVar"shift",LN 0),
          Call
            ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
             Call("ASSERT",CTy"exception",LS"ROR_C")),MU(LU,qTy)),
      Close
        (AVar uTy,
         MU(Let(Var("result",BTy"N"),Bop(Ror,Var("x",BTy"N"),nVar"shift"),
                TP[Var("result",BTy"N"),Mop(Msb,Var("result",BTy"N"))]),
            qTy))))
;
val ROR_def = Def
  ("ROR",TP[Var("x",BTy"N"),nVar"shift"],
   ITE(EQ(nVar"shift",LN 0),MU(Var("x",BTy"N"),qTy),
       MB(Call
            ("ROR_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
             TP[Var("x",BTy"N"),nVar"shift"]),
          Close
            (Var("v",PTy(BTy"N",bTy)),
             MU(Mop(Fst,Var("v",PTy(BTy"N",bTy))),qTy)))))
;
val RRX_C_def = Def
  ("RRX_C",TP[Var("x",BTy"N"),bVar"carry_in"],
   TP[Mop(Cast(BTy"N"),
          CC[Mop(Cast vTy,bVar"carry_in"),
             EX(Mop(Cast vTy,Var("x",BTy"N")),
                Bop(Sub,Mop(Size,LY(0,"N")),LN 1),LN 1,vTy)]),
      Bop(Bit,Var("x",BTy"N"),LN 0)])
;
val RRX_def = Def
  ("RRX",TP[Var("x",BTy"N"),bVar"carry_in"],
   Mop(Fst,
       Call("RRX_C",PTy(BTy"N",bTy),TP[Var("x",BTy"N"),bVar"carry_in"])))
;
val DecodeImmShift_def = Def
  ("DecodeImmShift",TP[Var("typ",FTy 2),Var("imm5",FTy 5)],
   CS(Var("typ",FTy 2),
      [(LW(0,2),
        TP[LC("SRType_LSL",CTy"SRType"),Mop(Cast nTy,Var("imm5",FTy 5))]),
       (LW(1,2),
        TP[LC("SRType_LSR",CTy"SRType"),
           ITE(EQ(Var("imm5",FTy 5),LW(0,5)),LN 32,
               Mop(Cast nTy,Var("imm5",FTy 5)))]),
       (LW(2,2),
        TP[LC("SRType_ASR",CTy"SRType"),
           ITE(EQ(Var("imm5",FTy 5),LW(0,5)),LN 32,
               Mop(Cast nTy,Var("imm5",FTy 5)))]),
       (LW(3,2),
        ITE(EQ(Var("imm5",FTy 5),LW(0,5)),
            TP[LC("SRType_RRX",CTy"SRType"),LN 1],
            TP[LC("SRType_ROR",CTy"SRType"),
               Mop(Cast nTy,Var("imm5",FTy 5))]))]))
;
val DecodeRegShift_def = Def
  ("DecodeRegShift",Var("typ",FTy 2),
   CS(Var("typ",FTy 2),
      [(LW(0,2),LC("SRType_LSL",CTy"SRType")),
       (LW(1,2),LC("SRType_LSR",CTy"SRType")),
       (LW(2,2),LC("SRType_ASR",CTy"SRType")),
       (LW(3,2),LC("SRType_ROR",CTy"SRType"))]))
;
val Shift_C_def = Def
  ("Shift_C",
   TP[Var("value",BTy"N"),Var("typ",CTy"SRType"),nVar"amount",
      bVar"carry_in"],
   ITE(EQ(nVar"amount",LN 0),
       MU(TP[Var("value",BTy"N"),bVar"carry_in"],qTy),
       CS(Var("typ",CTy"SRType"),
          [(LC("SRType_LSL",CTy"SRType"),
            Call
              ("LSL_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
               TP[Var("value",BTy"N"),nVar"amount"])),
           (LC("SRType_LSR",CTy"SRType"),
            Call
              ("LSR_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
               TP[Var("value",BTy"N"),nVar"amount"])),
           (LC("SRType_ASR",CTy"SRType"),
            Call
              ("ASR_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
               TP[Var("value",BTy"N"),nVar"amount"])),
           (LC("SRType_ROR",CTy"SRType"),
            Call
              ("ROR_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
               TP[Var("value",BTy"N"),nVar"amount"])),
           (LC("SRType_RRX",CTy"SRType"),
            MU(Call
                 ("RRX_C",PTy(BTy"N",bTy),
                  TP[Var("value",BTy"N"),bVar"carry_in"]),qTy))])))
;
val Shift_def = Def
  ("Shift",
   TP[Var("value",BTy"N"),Var("typ",CTy"SRType"),nVar"amount",
      bVar"carry_in"],
   MB(Call
        ("Shift_C",ATy(qTy,PTy(PTy(BTy"N",bTy),qTy)),
         TP[Var("value",BTy"N"),Var("typ",CTy"SRType"),nVar"amount",
            bVar"carry_in"]),
      Close
        (Var("v",PTy(BTy"N",bTy)),
         MU(Mop(Fst,Var("v",PTy(BTy"N",bTy))),qTy))))
;
val ARMExpandImm_C_def = Def
  ("ARMExpandImm_C",TP[Var("imm12",FTy 12),bVar"carry_in"],
   Call
     ("Shift_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
      TP[Mop(Cast F32,EX(Var("imm12",FTy 12),LN 7,LN 0,F8)),
         LC("SRType_ROR",CTy"SRType"),
         Bop(Mul,LN 2,Mop(Cast nTy,EX(Var("imm12",FTy 12),LN 11,LN 8,F4))),
         bVar"carry_in"]))
;
val ARMExpandImm_def = Def
  ("ARMExpandImm",Var("imm12",FTy 12),
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy),
                  Close(bVar"v",MU(TP[Var("imm12",FTy 12),bVar"v"],qTy))),
               Close
                 (Var("v",PTy(FTy 12,bTy)),
                  Call
                    ("ARMExpandImm_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                     Var("v",PTy(FTy 12,bTy))))),
            Close
              (Var("v",PTy(F32,bTy)),
               MU(Mop(Fst,Var("v",PTy(F32,bTy))),qTy))))))
;
val ThumbExpandImm_C_def = Def
  ("ThumbExpandImm_C",TP[Var("imm12",FTy 12),bVar"carry_in"],
   ITE(EQ(EX(Var("imm12",FTy 12),LN 11,LN 10,FTy 2),LW(0,2)),
       MB(CS(EX(Var("imm12",FTy 12),LN 9,LN 8,FTy 2),
             [(LW(0,2),
               MU(Mop(Cast F32,EX(Var("imm12",FTy 12),LN 7,LN 0,F8)),qTy)),
              (LW(1,2),
               ITE(EQ(EX(Var("imm12",FTy 12),LN 7,LN 0,F8),LW(0,8)),
                   Call
                     ("raise'exception",ATy(qTy,PTy(F32,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",
                         LS"ThumbExpandImm_C")),
                   MU(CC[LW(0,8),EX(Var("imm12",FTy 12),LN 7,LN 0,F8),
                         LW(0,8),EX(Var("imm12",FTy 12),LN 7,LN 0,F8)],qTy))),
              (LW(2,2),
               ITE(EQ(EX(Var("imm12",FTy 12),LN 7,LN 0,F8),LW(0,8)),
                   Call
                     ("raise'exception",ATy(qTy,PTy(F32,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",
                         LS"ThumbExpandImm_C")),
                   MU(CC[EX(Var("imm12",FTy 12),LN 7,LN 0,F8),LW(0,8),
                         EX(Var("imm12",FTy 12),LN 7,LN 0,F8),LW(0,8)],qTy))),
              (LW(3,2),
               ITE(EQ(EX(Var("imm12",FTy 12),LN 7,LN 0,F8),LW(0,8)),
                   Call
                     ("raise'exception",ATy(qTy,PTy(F32,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",
                         LS"ThumbExpandImm_C")),
                   MU(CC[EX(Var("imm12",FTy 12),LN 7,LN 0,F8),
                         EX(Var("imm12",FTy 12),LN 7,LN 0,F8),
                         EX(Var("imm12",FTy 12),LN 7,LN 0,F8),
                         EX(Var("imm12",FTy 12),LN 7,LN 0,F8)],qTy)))]),
          Close
            (Var("imm32",F32),MU(TP[Var("imm32",F32),bVar"carry_in"],qTy))),
       Call
         ("ROR_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
          TP[Mop(Cast F32,
                 CC[LW(1,1),EX(Var("imm12",FTy 12),LN 6,LN 0,FTy 7)]),
             Mop(Cast nTy,EX(Var("imm12",FTy 12),LN 11,LN 7,FTy 5))])))
;
val ExpandImm_C_def = Def
  ("ExpandImm_C",TP[Var("imm12",FTy 12),bVar"carry_in"],
   MB(MR(Close(qVar"s",Dest("Encoding",CTy"Encoding",qVar"s"))),
      Close
        (Var("v",CTy"Encoding"),
         MB(MU(EQ(Var("v",CTy"Encoding"),
                  LC("Encoding_Thumb2",CTy"Encoding")),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   Call
                     ("ThumbExpandImm_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                      TP[Var("imm12",FTy 12),bVar"carry_in"]),
                   Call
                     ("ARMExpandImm_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                      TP[Var("imm12",FTy 12),bVar"carry_in"])))))))
;
val AddWithCarry_def = Def
  ("AddWithCarry",TP[Var("x",BTy"N"),Var("y",BTy"N"),bVar"carry_in"],
   Let(nVar"unsigned_sum",
       Bop(Add,
           Bop(Add,Mop(Cast nTy,Var("x",BTy"N")),
               Mop(Cast nTy,Var("y",BTy"N"))),Mop(Cast nTy,bVar"carry_in")),
       Let(Var("result",BTy"N"),Mop(Cast(BTy"N"),nVar"unsigned_sum"),
           TP[Var("result",BTy"N"),
              Mop(Not,
                  EQ(Mop(Cast nTy,Var("result",BTy"N")),nVar"unsigned_sum")),
              Mop(Not,
                  EQ(Mop(Cast iTy,Var("result",BTy"N")),
                     Bop(Add,
                         Bop(Add,Mop(Cast iTy,Var("x",BTy"N")),
                             Mop(Cast iTy,Var("y",BTy"N"))),
                         Mop(Cast iTy,bVar"carry_in"))))])))
;
val DataProcessingALU_def = Def
  ("DataProcessingALU",
   TP[Var("opc",F4),Var("a",F32),Var("b",F32),bVar"c"],
   CS(Var("opc",F4),
      [(LW(0,4),TP[Bop(BAnd,Var("a",F32),Var("b",F32)),bVar"c",LX bTy]),
       (LW(8,4),TP[Bop(BAnd,Var("a",F32),Var("b",F32)),bVar"c",LX bTy]),
       (LW(1,4),TP[Bop(BXor,Var("a",F32),Var("b",F32)),bVar"c",LX bTy]),
       (LW(9,4),TP[Bop(BXor,Var("a",F32),Var("b",F32)),bVar"c",LX bTy]),
       (LW(2,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Var("a",F32),Mop(BNot,Var("b",F32)),LT])),
       (LW(10,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Var("a",F32),Mop(BNot,Var("b",F32)),LT])),
       (LW(3,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Mop(BNot,Var("a",F32)),Var("b",F32),LT])),
       (LW(4,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Var("a",F32),Var("b",F32),LF])),
       (LW(11,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Var("a",F32),Var("b",F32),LF])),
       (LW(5,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Var("a",F32),Var("b",F32),bVar"c"])),
       (LW(6,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Var("a",F32),Mop(BNot,Var("b",F32)),bVar"c"])),
       (LW(7,4),
        Call
          ("AddWithCarry",PTy(F32,PTy(bTy,bTy)),
           TP[Mop(BNot,Var("a",F32)),Var("b",F32),bVar"c"])),
       (LW(12,4),TP[Bop(BOr,Var("a",F32),Var("b",F32)),bVar"c",LX bTy]),
       (LW(13,4),TP[Var("b",F32),bVar"c",LX bTy]),
       (LW(14,4),
        TP[Bop(BAnd,Var("a",F32),Mop(BNot,Var("b",F32))),bVar"c",LX bTy]),
       (LW(15,4),
        TP[Bop(BOr,Var("a",F32),Mop(BNot,Var("b",F32))),bVar"c",LX bTy])]))
;
val ArithmeticOpcode_def = Def
  ("ArithmeticOpcode",Var("opc",F4),
   Bop(And,
       Bop(Or,Bop(Bit,Var("opc",F4),LN 2),Bop(Bit,Var("opc",F4),LN 1)),
       Mop(Not,
           Bop(And,Bop(Bit,Var("opc",F4),LN 3),Bop(Bit,Var("opc",F4),LN 2)))))
;
val ExcVectorBase_def = Def
  ("ExcVectorBase",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
      Close
        (Var("v",CTy"CP15"),
         MB(MB(MU(Dest("SCTLR",CTy"SCTLR",Var("v",CTy"CP15")),qTy),
               Close
                 (Var("v",CTy"SCTLR"),
                  MU(Dest("V",bTy,Var("v",CTy"SCTLR")),qTy))),
            Close
              (bVar"b",
               ITE(bVar"b",MU(LW(268431360,32),qTy),
                   MB(Call("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
                      Close
                        (bVar"b",
                         ITE(bVar"b",
                             MB(MR(Close
                                     (qVar"s",
                                      Dest("CP15",CTy"CP15",qVar"s"))),
                                Close
                                  (Var("v",CTy"CP15"),
                                   MU(Dest("VBAR",F32,Var("v",CTy"CP15")),
                                      qTy))),MU(LW(0,32),qTy))))))))))
;
val EnterMonitorMode_def = Def
  ("EnterMonitorMode",
   TP[Var("new_spsr_value",CTy"PSR"),Var("new_lr_value",F32),
      Var("vect_offset",F32)],
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LW(22,5)],qTy),
                  Close
                    (Var("v",PTy(CTy"PSR",FTy 5)),
                     MU(Rupd("M",Var("v",PTy(CTy"PSR",FTy 5))),qTy))),
               Close
                 (Var("v",CTy"PSR"),
                  MW(Close
                       (qVar"s",Rupd("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))),
            Close
              (AVar uTy,
               MB(Call
                    ("write'SPSR",ATy(qTy,PTy(uTy,qTy)),
                     Var("new_spsr_value",CTy"PSR")),
                  Close
                    (AVar uTy,
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[Var("new_lr_value",F32),LW(14,4)]),
                        Close
                          (AVar uTy,
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LF],qTy),
                                          Close
                                            (Var("v",PTy(CTy"PSR",bTy)),
                                             MU(Rupd
                                                  ("J",
                                                   Var("v",
                                                       PTy(CTy"PSR",bTy))),
                                                qTy))),
                                       Close
                                         (Var("v",CTy"PSR"),
                                          MW(Close
                                               (qVar"s",
                                                Rupd
                                                  ("CPSR",
                                                   TP[qVar"s",
                                                      Var("v",CTy"PSR")]))))),
                                    Close
                                      (AVar uTy,
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("CPSR",CTy"PSR",qVar"s"))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MB(MB(MR(Close
                                                              (qVar"s",
                                                               Dest
                                                                 ("CP15",
                                                                  CTy"CP15",
                                                                  qVar"s"))),
                                                         Close
                                                           (Var("v0",
                                                                CTy"CP15"),
                                                            MB(MB(MU(Dest
                                                                       ("SCTLR",
                                                                        CTy"SCTLR",
                                                                        Var("v0",
                                                                            CTy"CP15")),
                                                                     qTy),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"SCTLR"),
                                                                     MU(Dest
                                                                          ("TE",
                                                                           bTy,
                                                                           Var("v",
                                                                               CTy"SCTLR")),
                                                                        qTy))),
                                                               Close
                                                                 (bVar"v0",
                                                                  MU(TP[Var("v",
                                                                            CTy"PSR"),
                                                                        bVar"v0"],
                                                                     qTy))))),
                                                      Close
                                                        (Var("v",
                                                             PTy(CTy"PSR",
                                                                 bTy)),
                                                         MU(Rupd
                                                              ("T",
                                                               Var("v",
                                                                   PTy(CTy"PSR",
                                                                       bTy))),
                                                            qTy))),
                                                   Close
                                                     (Var("v",CTy"PSR"),
                                                      MW(Close
                                                           (qVar"s",
                                                            Rupd
                                                              ("CPSR",
                                                               TP[qVar"s",
                                                                  Var("v",
                                                                      CTy"PSR")]))))),
                                                Close
                                                  (AVar uTy,
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("CPSR",
                                                               CTy"PSR",
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MB(MB(MB(MB(MR(Close
                                                                          (qVar"s",
                                                                           Dest
                                                                             ("CP15",
                                                                              CTy"CP15",
                                                                              qVar"s"))),
                                                                     Close
                                                                       (Var("v0",
                                                                            CTy"CP15"),
                                                                        MB(MB(MU(Dest
                                                                                   ("SCTLR",
                                                                                    CTy"SCTLR",
                                                                                    Var("v0",
                                                                                        CTy"CP15")),
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"SCTLR"),
                                                                                 MU(Dest
                                                                                      ("EE",
                                                                                       bTy,
                                                                                       Var("v",
                                                                                           CTy"SCTLR")),
                                                                                    qTy))),
                                                                           Close
                                                                             (bVar"v0",
                                                                              MU(TP[Var("v",
                                                                                        CTy"PSR"),
                                                                                    bVar"v0"],
                                                                                 qTy))))),
                                                                  Close
                                                                    (Var("v",
                                                                         PTy(CTy"PSR",
                                                                             bTy)),
                                                                     MU(Rupd
                                                                          ("E",
                                                                           Var("v",
                                                                               PTy(CTy"PSR",
                                                                                   bTy))),
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      CTy"PSR"),
                                                                  MW(Close
                                                                       (qVar"s",
                                                                        Rupd
                                                                          ("CPSR",
                                                                           TP[qVar"s",
                                                                              Var("v",
                                                                                  CTy"PSR")]))))),
                                                            Close
                                                              (AVar uTy,
                                                               MB(MR(Close
                                                                       (qVar"s",
                                                                        Dest
                                                                          ("CPSR",
                                                                           CTy"PSR",
                                                                           qVar"s"))),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"PSR"),
                                                                     MB(MB(MB(MU(TP[Var("v",
                                                                                        CTy"PSR"),
                                                                                    LT],
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     PTy(CTy"PSR",
                                                                                         bTy)),
                                                                                 MU(Rupd
                                                                                      ("A",
                                                                                       Var("v",
                                                                                           PTy(CTy"PSR",
                                                                                               bTy))),
                                                                                    qTy))),
                                                                           Close
                                                                             (Var("v",
                                                                                  CTy"PSR"),
                                                                              MW(Close
                                                                                   (qVar"s",
                                                                                    Rupd
                                                                                      ("CPSR",
                                                                                       TP[qVar"s",
                                                                                          Var("v",
                                                                                              CTy"PSR")]))))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MB(MR(Close
                                                                                   (qVar"s",
                                                                                    Dest
                                                                                      ("CPSR",
                                                                                       CTy"PSR",
                                                                                       qVar"s"))),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"PSR"),
                                                                                 MB(MB(MB(MU(TP[Var("v",
                                                                                                    CTy"PSR"),
                                                                                                LT],
                                                                                             qTy),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 PTy(CTy"PSR",
                                                                                                     bTy)),
                                                                                             MU(Rupd
                                                                                                  ("F",
                                                                                                   Var("v",
                                                                                                       PTy(CTy"PSR",
                                                                                                           bTy))),
                                                                                                qTy))),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              CTy"PSR"),
                                                                                          MW(Close
                                                                                               (qVar"s",
                                                                                                Rupd
                                                                                                  ("CPSR",
                                                                                                   TP[qVar"s",
                                                                                                      Var("v",
                                                                                                          CTy"PSR")]))))),
                                                                                    Close
                                                                                      (AVar
                                                                                         uTy,
                                                                                       MB(MR(Close
                                                                                               (qVar"s",
                                                                                                Dest
                                                                                                  ("CPSR",
                                                                                                   CTy"PSR",
                                                                                                   qVar"s"))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 CTy"PSR"),
                                                                                             MB(MB(MB(MU(TP[Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            LT],
                                                                                                         qTy),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             PTy(CTy"PSR",
                                                                                                                 bTy)),
                                                                                                         MU(Rupd
                                                                                                              ("I",
                                                                                                               Var("v",
                                                                                                                   PTy(CTy"PSR",
                                                                                                                       bTy))),
                                                                                                            qTy))),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          CTy"PSR"),
                                                                                                      MW(Close
                                                                                                           (qVar"s",
                                                                                                            Rupd
                                                                                                              ("CPSR",
                                                                                                               TP[qVar"s",
                                                                                                                  Var("v",
                                                                                                                      CTy"PSR")]))))),
                                                                                                Close
                                                                                                  (AVar
                                                                                                     uTy,
                                                                                                   MB(MR(Close
                                                                                                           (qVar"s",
                                                                                                            Dest
                                                                                                              ("CPSR",
                                                                                                               CTy"PSR",
                                                                                                               qVar"s"))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             CTy"PSR"),
                                                                                                         MB(MB(MB(MU(TP[Var("v",
                                                                                                                            CTy"PSR"),
                                                                                                                        LW(0,
                                                                                                                           8)],
                                                                                                                     qTy),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         PTy(CTy"PSR",
                                                                                                                             F8)),
                                                                                                                     MU(Rupd
                                                                                                                          ("IT",
                                                                                                                           Var("v",
                                                                                                                               PTy(CTy"PSR",
                                                                                                                                   F8))),
                                                                                                                        qTy))),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      CTy"PSR"),
                                                                                                                  MW(Close
                                                                                                                       (qVar"s",
                                                                                                                        Rupd
                                                                                                                          ("CPSR",
                                                                                                                           TP[qVar"s",
                                                                                                                              Var("v",
                                                                                                                                  CTy"PSR")]))))),
                                                                                                            Close
                                                                                                              (AVar
                                                                                                                 uTy,
                                                                                                               MB(MR(Close
                                                                                                                       (qVar"s",
                                                                                                                        Dest
                                                                                                                          ("CP15",
                                                                                                                           CTy"CP15",
                                                                                                                           qVar"s"))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         CTy"CP15"),
                                                                                                                     MB(MB(MU(Dest
                                                                                                                                ("MVBAR",
                                                                                                                                 F32,
                                                                                                                                 Var("v",
                                                                                                                                     CTy"CP15")),
                                                                                                                              qTy),
                                                                                                                           Close
                                                                                                                             (Var("v",
                                                                                                                                  F32),
                                                                                                                              MU(Bop(Add,
                                                                                                                                     Var("v",
                                                                                                                                         F32),
                                                                                                                                     Var("vect_offset",
                                                                                                                                         F32)),
                                                                                                                                 qTy))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               F32),
                                                                                                                           Call
                                                                                                                             ("BranchTo",
                                                                                                                              ATy(qTy,
                                                                                                                                  PTy(uTy,
                                                                                                                                      qTy)),
                                                                                                                              Var("v",
                                                                                                                                  F32)))))))))))))))))))))))))))))))))))))))))))
;
val EnterHypMode_def = Def
  ("EnterHypMode",
   TP[Var("new_spsr_value",CTy"PSR"),Var("new_lr_value",F32),
      Var("vect_offset",F32)],
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LW(26,5)],qTy),
                  Close
                    (Var("v",PTy(CTy"PSR",FTy 5)),
                     MU(Rupd("M",Var("v",PTy(CTy"PSR",FTy 5))),qTy))),
               Close
                 (Var("v",CTy"PSR"),
                  MW(Close
                       (qVar"s",Rupd("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))),
            Close
              (AVar uTy,
               MB(Call
                    ("write'SPSR",ATy(qTy,PTy(uTy,qTy)),
                     Var("new_spsr_value",CTy"PSR")),
                  Close
                    (AVar uTy,
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[Var("new_lr_value",F32),LW(14,4)]),
                        Close
                          (AVar uTy,
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LF],qTy),
                                          Close
                                            (Var("v",PTy(CTy"PSR",bTy)),
                                             MU(Rupd
                                                  ("J",
                                                   Var("v",
                                                       PTy(CTy"PSR",bTy))),
                                                qTy))),
                                       Close
                                         (Var("v",CTy"PSR"),
                                          MW(Close
                                               (qVar"s",
                                                Rupd
                                                  ("CPSR",
                                                   TP[qVar"s",
                                                      Var("v",CTy"PSR")]))))),
                                    Close
                                      (AVar uTy,
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("CPSR",CTy"PSR",qVar"s"))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MB(MB(MR(Close
                                                              (qVar"s",
                                                               Dest
                                                                 ("CP15",
                                                                  CTy"CP15",
                                                                  qVar"s"))),
                                                         Close
                                                           (Var("v0",
                                                                CTy"CP15"),
                                                            MB(MB(MU(Dest
                                                                       ("SCTLR",
                                                                        CTy"SCTLR",
                                                                        Var("v0",
                                                                            CTy"CP15")),
                                                                     qTy),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"SCTLR"),
                                                                     MU(Dest
                                                                          ("TE",
                                                                           bTy,
                                                                           Var("v",
                                                                               CTy"SCTLR")),
                                                                        qTy))),
                                                               Close
                                                                 (bVar"v0",
                                                                  MU(TP[Var("v",
                                                                            CTy"PSR"),
                                                                        bVar"v0"],
                                                                     qTy))))),
                                                      Close
                                                        (Var("v",
                                                             PTy(CTy"PSR",
                                                                 bTy)),
                                                         MU(Rupd
                                                              ("T",
                                                               Var("v",
                                                                   PTy(CTy"PSR",
                                                                       bTy))),
                                                            qTy))),
                                                   Close
                                                     (Var("v",CTy"PSR"),
                                                      MW(Close
                                                           (qVar"s",
                                                            Rupd
                                                              ("CPSR",
                                                               TP[qVar"s",
                                                                  Var("v",
                                                                      CTy"PSR")]))))),
                                                Close
                                                  (AVar uTy,
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("CPSR",
                                                               CTy"PSR",
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MB(MB(MB(MB(MR(Close
                                                                          (qVar"s",
                                                                           Dest
                                                                             ("CP15",
                                                                              CTy"CP15",
                                                                              qVar"s"))),
                                                                     Close
                                                                       (Var("v0",
                                                                            CTy"CP15"),
                                                                        MB(MB(MU(Dest
                                                                                   ("SCTLR",
                                                                                    CTy"SCTLR",
                                                                                    Var("v0",
                                                                                        CTy"CP15")),
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"SCTLR"),
                                                                                 MU(Dest
                                                                                      ("EE",
                                                                                       bTy,
                                                                                       Var("v",
                                                                                           CTy"SCTLR")),
                                                                                    qTy))),
                                                                           Close
                                                                             (bVar"v0",
                                                                              MU(TP[Var("v",
                                                                                        CTy"PSR"),
                                                                                    bVar"v0"],
                                                                                 qTy))))),
                                                                  Close
                                                                    (Var("v",
                                                                         PTy(CTy"PSR",
                                                                             bTy)),
                                                                     MU(Rupd
                                                                          ("E",
                                                                           Var("v",
                                                                               PTy(CTy"PSR",
                                                                                   bTy))),
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      CTy"PSR"),
                                                                  MW(Close
                                                                       (qVar"s",
                                                                        Rupd
                                                                          ("CPSR",
                                                                           TP[qVar"s",
                                                                              Var("v",
                                                                                  CTy"PSR")]))))),
                                                            Close
                                                              (AVar uTy,
                                                               MB(MR(Close
                                                                       (qVar"s",
                                                                        Dest
                                                                          ("CPSR",
                                                                           CTy"PSR",
                                                                           qVar"s"))),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"PSR"),
                                                                     MB(MB(MB(MU(TP[Var("v",
                                                                                        CTy"PSR"),
                                                                                    LT],
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     PTy(CTy"PSR",
                                                                                         bTy)),
                                                                                 MU(Rupd
                                                                                      ("A",
                                                                                       Var("v",
                                                                                           PTy(CTy"PSR",
                                                                                               bTy))),
                                                                                    qTy))),
                                                                           Close
                                                                             (Var("v",
                                                                                  CTy"PSR"),
                                                                              MW(Close
                                                                                   (qVar"s",
                                                                                    Rupd
                                                                                      ("CPSR",
                                                                                       TP[qVar"s",
                                                                                          Var("v",
                                                                                              CTy"PSR")]))))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MB(MR(Close
                                                                                   (qVar"s",
                                                                                    Dest
                                                                                      ("CPSR",
                                                                                       CTy"PSR",
                                                                                       qVar"s"))),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"PSR"),
                                                                                 MB(MB(MB(MU(TP[Var("v",
                                                                                                    CTy"PSR"),
                                                                                                LT],
                                                                                             qTy),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 PTy(CTy"PSR",
                                                                                                     bTy)),
                                                                                             MU(Rupd
                                                                                                  ("F",
                                                                                                   Var("v",
                                                                                                       PTy(CTy"PSR",
                                                                                                           bTy))),
                                                                                                qTy))),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              CTy"PSR"),
                                                                                          MW(Close
                                                                                               (qVar"s",
                                                                                                Rupd
                                                                                                  ("CPSR",
                                                                                                   TP[qVar"s",
                                                                                                      Var("v",
                                                                                                          CTy"PSR")]))))),
                                                                                    Close
                                                                                      (AVar
                                                                                         uTy,
                                                                                       MB(MR(Close
                                                                                               (qVar"s",
                                                                                                Dest
                                                                                                  ("CPSR",
                                                                                                   CTy"PSR",
                                                                                                   qVar"s"))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 CTy"PSR"),
                                                                                             MB(MB(MB(MU(TP[Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            LT],
                                                                                                         qTy),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             PTy(CTy"PSR",
                                                                                                                 bTy)),
                                                                                                         MU(Rupd
                                                                                                              ("I",
                                                                                                               Var("v",
                                                                                                                   PTy(CTy"PSR",
                                                                                                                       bTy))),
                                                                                                            qTy))),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          CTy"PSR"),
                                                                                                      MW(Close
                                                                                                           (qVar"s",
                                                                                                            Rupd
                                                                                                              ("CPSR",
                                                                                                               TP[qVar"s",
                                                                                                                  Var("v",
                                                                                                                      CTy"PSR")]))))),
                                                                                                Close
                                                                                                  (AVar
                                                                                                     uTy,
                                                                                                   MB(MR(Close
                                                                                                           (qVar"s",
                                                                                                            Dest
                                                                                                              ("CPSR",
                                                                                                               CTy"PSR",
                                                                                                               qVar"s"))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             CTy"PSR"),
                                                                                                         MB(MB(MB(MU(TP[Var("v",
                                                                                                                            CTy"PSR"),
                                                                                                                        LW(0,
                                                                                                                           8)],
                                                                                                                     qTy),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         PTy(CTy"PSR",
                                                                                                                             F8)),
                                                                                                                     MU(Rupd
                                                                                                                          ("IT",
                                                                                                                           Var("v",
                                                                                                                               PTy(CTy"PSR",
                                                                                                                                   F8))),
                                                                                                                        qTy))),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      CTy"PSR"),
                                                                                                                  MW(Close
                                                                                                                       (qVar"s",
                                                                                                                        Rupd
                                                                                                                          ("CPSR",
                                                                                                                           TP[qVar"s",
                                                                                                                              Var("v",
                                                                                                                                  CTy"PSR")]))))),
                                                                                                            Close
                                                                                                              (AVar
                                                                                                                 uTy,
                                                                                                               MB(MR(Close
                                                                                                                       (qVar"s",
                                                                                                                        Dest
                                                                                                                          ("CP15",
                                                                                                                           CTy"CP15",
                                                                                                                           qVar"s"))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         CTy"CP15"),
                                                                                                                     MB(MB(MU(Dest
                                                                                                                                ("MVBAR",
                                                                                                                                 F32,
                                                                                                                                 Var("v",
                                                                                                                                     CTy"CP15")),
                                                                                                                              qTy),
                                                                                                                           Close
                                                                                                                             (Var("v",
                                                                                                                                  F32),
                                                                                                                              MU(Bop(Add,
                                                                                                                                     Var("v",
                                                                                                                                         F32),
                                                                                                                                     Var("vect_offset",
                                                                                                                                         F32)),
                                                                                                                                 qTy))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               F32),
                                                                                                                           Call
                                                                                                                             ("BranchTo",
                                                                                                                              ATy(qTy,
                                                                                                                                  PTy(uTy,
                                                                                                                                      qTy)),
                                                                                                                              Var("v",
                                                                                                                                  F32)))))))))))))))))))))))))))))))))))))))))))
;
val TakeReset_def = Def
  ("TakeReset",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LW(19,5)],qTy),
                  Close
                    (Var("v",PTy(CTy"PSR",FTy 5)),
                     MU(Rupd("M",Var("v",PTy(CTy"PSR",FTy 5))),qTy))),
               Close
                 (Var("v",CTy"PSR"),
                  MW(Close
                       (qVar"s",Rupd("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))),
            Close
              (AVar uTy,
               MB(Call("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
                  Close
                    (bVar"v",
                     MB(ITE(bVar"v",
                            MB(MR(Close
                                    (qVar"s",
                                     Dest("CP15",CTy"CP15",qVar"s"))),
                               Close
                                 (Var("v",CTy"CP15"),
                                  MB(MU(Dest
                                          ("SCR",CTy"SCR",
                                           Var("v",CTy"CP15")),qTy),
                                     Close
                                       (Var("x0",CTy"SCR"),
                                        MB(MR(Close
                                                (qVar"s",
                                                 Dest
                                                   ("CP15",CTy"CP15",
                                                    qVar"s"))),
                                           Close
                                             (Var("v",CTy"CP15"),
                                              MB(MB(MU(TP[Var("v",
                                                              CTy"CP15"),
                                                          Rupd
                                                            ("NS",
                                                             TP[Var("x0",
                                                                    CTy"SCR"),
                                                                LF])],qTy),
                                                    Close
                                                      (Var("v",
                                                           PTy(CTy"CP15",
                                                               CTy"SCR")),
                                                       MU(Rupd
                                                            ("SCR",
                                                             Var("v",
                                                                 PTy(CTy"CP15",
                                                                     CTy"SCR"))),
                                                          qTy))),
                                                 Close
                                                   (Var("v",CTy"CP15"),
                                                    MW(Close
                                                         (qVar"s",
                                                          Rupd
                                                            ("CP15",
                                                             TP[qVar"s",
                                                                Var("v",
                                                                    CTy"CP15")]))))))))))),
                            MU(LU,qTy)),
                        Close
                          (AVar uTy,
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LT],qTy),
                                          Close
                                            (Var("v",PTy(CTy"PSR",bTy)),
                                             MU(Rupd
                                                  ("I",
                                                   Var("v",
                                                       PTy(CTy"PSR",bTy))),
                                                qTy))),
                                       Close
                                         (Var("v",CTy"PSR"),
                                          MW(Close
                                               (qVar"s",
                                                Rupd
                                                  ("CPSR",
                                                   TP[qVar"s",
                                                      Var("v",CTy"PSR")]))))),
                                    Close
                                      (AVar uTy,
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("CPSR",CTy"PSR",qVar"s"))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MB(MU(TP[Var("v",
                                                                CTy"PSR"),
                                                            LT],qTy),
                                                      Close
                                                        (Var("v",
                                                             PTy(CTy"PSR",
                                                                 bTy)),
                                                         MU(Rupd
                                                              ("F",
                                                               Var("v",
                                                                   PTy(CTy"PSR",
                                                                       bTy))),
                                                            qTy))),
                                                   Close
                                                     (Var("v",CTy"PSR"),
                                                      MW(Close
                                                           (qVar"s",
                                                            Rupd
                                                              ("CPSR",
                                                               TP[qVar"s",
                                                                  Var("v",
                                                                      CTy"PSR")]))))),
                                                Close
                                                  (AVar uTy,
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("CPSR",
                                                               CTy"PSR",
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MB(MB(MB(MU(TP[Var("v",
                                                                            CTy"PSR"),
                                                                        LT],
                                                                     qTy),
                                                                  Close
                                                                    (Var("v",
                                                                         PTy(CTy"PSR",
                                                                             bTy)),
                                                                     MU(Rupd
                                                                          ("A",
                                                                           Var("v",
                                                                               PTy(CTy"PSR",
                                                                                   bTy))),
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      CTy"PSR"),
                                                                  MW(Close
                                                                       (qVar"s",
                                                                        Rupd
                                                                          ("CPSR",
                                                                           TP[qVar"s",
                                                                              Var("v",
                                                                                  CTy"PSR")]))))),
                                                            Close
                                                              (AVar uTy,
                                                               MB(MR(Close
                                                                       (qVar"s",
                                                                        Dest
                                                                          ("CPSR",
                                                                           CTy"PSR",
                                                                           qVar"s"))),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"PSR"),
                                                                     MB(MB(MB(MU(TP[Var("v",
                                                                                        CTy"PSR"),
                                                                                    LW(0,
                                                                                       8)],
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     PTy(CTy"PSR",
                                                                                         F8)),
                                                                                 MU(Rupd
                                                                                      ("IT",
                                                                                       Var("v",
                                                                                           PTy(CTy"PSR",
                                                                                               F8))),
                                                                                    qTy))),
                                                                           Close
                                                                             (Var("v",
                                                                                  CTy"PSR"),
                                                                              MW(Close
                                                                                   (qVar"s",
                                                                                    Rupd
                                                                                      ("CPSR",
                                                                                       TP[qVar"s",
                                                                                          Var("v",
                                                                                              CTy"PSR")]))))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MB(MR(Close
                                                                                   (qVar"s",
                                                                                    Dest
                                                                                      ("CPSR",
                                                                                       CTy"PSR",
                                                                                       qVar"s"))),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"PSR"),
                                                                                 MB(MB(MB(MU(TP[Var("v",
                                                                                                    CTy"PSR"),
                                                                                                LF],
                                                                                             qTy),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 PTy(CTy"PSR",
                                                                                                     bTy)),
                                                                                             MU(Rupd
                                                                                                  ("J",
                                                                                                   Var("v",
                                                                                                       PTy(CTy"PSR",
                                                                                                           bTy))),
                                                                                                qTy))),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              CTy"PSR"),
                                                                                          MW(Close
                                                                                               (qVar"s",
                                                                                                Rupd
                                                                                                  ("CPSR",
                                                                                                   TP[qVar"s",
                                                                                                      Var("v",
                                                                                                          CTy"PSR")]))))),
                                                                                    Close
                                                                                      (AVar
                                                                                         uTy,
                                                                                       MB(MR(Close
                                                                                               (qVar"s",
                                                                                                Dest
                                                                                                  ("CPSR",
                                                                                                   CTy"PSR",
                                                                                                   qVar"s"))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 CTy"PSR"),
                                                                                             MB(MB(MB(MB(MR(Close
                                                                                                              (qVar"s",
                                                                                                               Dest
                                                                                                                 ("CP15",
                                                                                                                  CTy"CP15",
                                                                                                                  qVar"s"))),
                                                                                                         Close
                                                                                                           (Var("v0",
                                                                                                                CTy"CP15"),
                                                                                                            MB(MB(MU(Dest
                                                                                                                       ("SCTLR",
                                                                                                                        CTy"SCTLR",
                                                                                                                        Var("v0",
                                                                                                                            CTy"CP15")),
                                                                                                                     qTy),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         CTy"SCTLR"),
                                                                                                                     MU(Dest
                                                                                                                          ("TE",
                                                                                                                           bTy,
                                                                                                                           Var("v",
                                                                                                                               CTy"SCTLR")),
                                                                                                                        qTy))),
                                                                                                               Close
                                                                                                                 (bVar"v0",
                                                                                                                  MU(TP[Var("v",
                                                                                                                            CTy"PSR"),
                                                                                                                        bVar"v0"],
                                                                                                                     qTy))))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             PTy(CTy"PSR",
                                                                                                                 bTy)),
                                                                                                         MU(Rupd
                                                                                                              ("T",
                                                                                                               Var("v",
                                                                                                                   PTy(CTy"PSR",
                                                                                                                       bTy))),
                                                                                                            qTy))),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          CTy"PSR"),
                                                                                                      MW(Close
                                                                                                           (qVar"s",
                                                                                                            Rupd
                                                                                                              ("CPSR",
                                                                                                               TP[qVar"s",
                                                                                                                  Var("v",
                                                                                                                      CTy"PSR")]))))),
                                                                                                Close
                                                                                                  (AVar
                                                                                                     uTy,
                                                                                                   MB(MR(Close
                                                                                                           (qVar"s",
                                                                                                            Dest
                                                                                                              ("CPSR",
                                                                                                               CTy"PSR",
                                                                                                               qVar"s"))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             CTy"PSR"),
                                                                                                         MB(MB(MB(MB(MR(Close
                                                                                                                          (qVar"s",
                                                                                                                           Dest
                                                                                                                             ("CP15",
                                                                                                                              CTy"CP15",
                                                                                                                              qVar"s"))),
                                                                                                                     Close
                                                                                                                       (Var("v0",
                                                                                                                            CTy"CP15"),
                                                                                                                        MB(MB(MU(Dest
                                                                                                                                   ("SCTLR",
                                                                                                                                    CTy"SCTLR",
                                                                                                                                    Var("v0",
                                                                                                                                        CTy"CP15")),
                                                                                                                                 qTy),
                                                                                                                              Close
                                                                                                                                (Var("v",
                                                                                                                                     CTy"SCTLR"),
                                                                                                                                 MU(Dest
                                                                                                                                      ("EE",
                                                                                                                                       bTy,
                                                                                                                                       Var("v",
                                                                                                                                           CTy"SCTLR")),
                                                                                                                                    qTy))),
                                                                                                                           Close
                                                                                                                             (bVar"v0",
                                                                                                                              MU(TP[Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    bVar"v0"],
                                                                                                                                 qTy))))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         PTy(CTy"PSR",
                                                                                                                             bTy)),
                                                                                                                     MU(Rupd
                                                                                                                          ("E",
                                                                                                                           Var("v",
                                                                                                                               PTy(CTy"PSR",
                                                                                                                                   bTy))),
                                                                                                                        qTy))),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      CTy"PSR"),
                                                                                                                  MW(Close
                                                                                                                       (qVar"s",
                                                                                                                        Rupd
                                                                                                                          ("CPSR",
                                                                                                                           TP[qVar"s",
                                                                                                                              Var("v",
                                                                                                                                  CTy"PSR")]))))),
                                                                                                            Close
                                                                                                              (AVar
                                                                                                                 uTy,
                                                                                                               MB(Call
                                                                                                                    ("ExcVectorBase",
                                                                                                                     ATy(qTy,
                                                                                                                         PTy(F32,
                                                                                                                             qTy)),
                                                                                                                     LU),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         F32),
                                                                                                                     MB(MU(Bop(Add,
                                                                                                                               Var("v",
                                                                                                                                   F32),
                                                                                                                               LW(0,
                                                                                                                                  32)),
                                                                                                                           qTy),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               F32),
                                                                                                                           Call
                                                                                                                             ("BranchTo",
                                                                                                                              ATy(qTy,
                                                                                                                                  PTy(uTy,
                                                                                                                                      qTy)),
                                                                                                                              Var("v",
                                                                                                                                  F32)))))))))))))))))))))))))))))))))))))))))))
;
val TakeUndefInstrException_def = Def
  ("TakeUndefInstrException",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(2,32)),qTy))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
            Close
              (Var("new_lr_value",F32),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("new_spsr_value",CTy"PSR"),
                     Let(Var("vect_offset",F32),LW(4,32),
                         MB(Call("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
                            Close
                              (bVar"v",
                               MB(MB(MB(ITE(bVar"v",
                                            Call
                                              ("HaveSecurityExt",
                                               ATy(qTy,PTy(bTy,qTy)),LU),
                                            MU(LF,qTy)),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(MR(Close
                                                       (qVar"s",
                                                        Dest
                                                          ("CP15",
                                                           CTy"CP15",
                                                           qVar"s"))),
                                                  Close
                                                    (Var("v",CTy"CP15"),
                                                     MB(MU(Dest
                                                             ("SCR",
                                                              CTy"SCR",
                                                              Var("v",
                                                                  CTy"CP15")),
                                                           qTy),
                                                        Close
                                                          (Var("v",
                                                               CTy"SCR"),
                                                           MU(Dest
                                                                ("NS",bTy,
                                                                 Var("v",
                                                                     CTy"SCR")),
                                                              qTy))))),
                                               MU(LF,qTy)))),
                                     Close
                                       (bVar"b",
                                        ITE(bVar"b",
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("CPSR",CTy"PSR",
                                                        qVar"s"))),
                                               Close
                                                 (Var("v",CTy"PSR"),
                                                  MB(MU(Dest
                                                          ("M",FTy 5,
                                                           Var("v",
                                                               CTy"PSR")),
                                                        qTy),
                                                     Close
                                                       (Var("v",FTy 5),
                                                        MU(EQ(Var("v",
                                                                  FTy 5),
                                                              LW(26,5)),
                                                           qTy))))),
                                            MU(LF,qTy)))),
                                  Close
                                    (bVar"take_to_hyp",
                                     MB(Call
                                          ("HaveVirtExt",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MB(MB(ITE(bVar"v",
                                                           Call
                                                             ("HaveSecurityExt",
                                                              ATy(qTy,
                                                                  PTy(bTy,
                                                                      qTy)),
                                                              LU),
                                                           MU(LF,qTy)),
                                                       Close
                                                         (bVar"b",
                                                          ITE(bVar"b",
                                                              MB(Call
                                                                   ("IsSecure",
                                                                    ATy(qTy,
                                                                        PTy(bTy,
                                                                            qTy)),
                                                                    LU),
                                                                 Close
                                                                   (bVar"v",
                                                                    MU(Mop(Not,
                                                                           bVar"v"),
                                                                       qTy))),
                                                              MU(LF,qTy)))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(MR(Close
                                                                   (qVar"s",
                                                                    Dest
                                                                      ("CP15",
                                                                       CTy"CP15",
                                                                       qVar"s"))),
                                                              Close
                                                                (Var("v",
                                                                     CTy"CP15"),
                                                                 MB(MU(Dest
                                                                         ("HCR",
                                                                          CTy"HCR",
                                                                          Var("v",
                                                                              CTy"CP15")),
                                                                       qTy),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"HCR"),
                                                                       MU(Dest
                                                                            ("TGE",
                                                                             bTy,
                                                                             Var("v",
                                                                                 CTy"HCR")),
                                                                          qTy))))),
                                                           MU(LF,qTy)))),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        MB(MR(Close
                                                                (qVar"s",
                                                                 Dest
                                                                   ("CPSR",
                                                                    CTy"PSR",
                                                                    qVar"s"))),
                                                           Close
                                                             (Var("v",
                                                                  CTy"PSR"),
                                                              MB(MU(Dest
                                                                      ("M",
                                                                       FTy 5,
                                                                       Var("v",
                                                                           CTy"PSR")),
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        FTy 5),
                                                                    MU(EQ(Var("v",
                                                                              FTy 5),
                                                                          LW(16,
                                                                             5)),
                                                                       qTy))))),
                                                        MU(LF,qTy)))),
                                              Close
                                                (bVar"route_to_hyp",
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("CPSR",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Dest
                                                                  ("T",
                                                                   bTy,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (bVar"b",
                                                                MU(ITE(bVar"b",
                                                                       LW(2,
                                                                          32),
                                                                       LW(4,
                                                                          32)),
                                                                   qTy))),
                                                          Close
                                                            (Var("return_offset",
                                                                 F32),
                                                             Let(Var("preferred_exceptn_return",
                                                                     F32),
                                                                 Bop(Sub,
                                                                     Var("new_lr_value",
                                                                         F32),
                                                                     Var("return_offset",
                                                                         F32)),
                                                                 ITB([(bVar"take_to_hyp",
                                                                       Call
                                                                         ("EnterHypMode",
                                                                          ATy(qTy,
                                                                              PTy(uTy,
                                                                                  qTy)),
                                                                          TP[Var("new_spsr_value",
                                                                                 CTy"PSR"),
                                                                             Var("preferred_exceptn_return",
                                                                                 F32),
                                                                             Var("vect_offset",
                                                                                 F32)])),
                                                                      (bVar"route_to_hyp",
                                                                       Call
                                                                         ("EnterHypMode",
                                                                          ATy(qTy,
                                                                              PTy(uTy,
                                                                                  qTy)),
                                                                          TP[Var("new_spsr_value",
                                                                                 CTy"PSR"),
                                                                             Var("preferred_exceptn_return",
                                                                                 F32),
                                                                             LW(20,
                                                                                32)]))],
                                                                     MB(MR(Close
                                                                             (qVar"s",
                                                                              Dest
                                                                                ("CPSR",
                                                                                 CTy"PSR",
                                                                                 qVar"s"))),
                                                                        Close
                                                                          (Var("v",
                                                                               CTy"PSR"),
                                                                           MB(MB(MB(MU(Dest
                                                                                         ("M",
                                                                                          FTy 5,
                                                                                          Var("v",
                                                                                              CTy"PSR")),
                                                                                       qTy),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           FTy 5),
                                                                                       MU(EQ(Var("v",
                                                                                                 FTy 5),
                                                                                             LW(22,
                                                                                                5)),
                                                                                          qTy))),
                                                                                 Close
                                                                                   (bVar"b",
                                                                                    ITE(bVar"b",
                                                                                        MB(MR(Close
                                                                                                (qVar"s",
                                                                                                 Dest
                                                                                                   ("CP15",
                                                                                                    CTy"CP15",
                                                                                                    qVar"s"))),
                                                                                           Close
                                                                                             (Var("v",
                                                                                                  CTy"CP15"),
                                                                                              MB(MU(Dest
                                                                                                      ("SCR",
                                                                                                       CTy"SCR",
                                                                                                       Var("v",
                                                                                                           CTy"CP15")),
                                                                                                    qTy),
                                                                                                 Close
                                                                                                   (Var("x0",
                                                                                                        CTy"SCR"),
                                                                                                    MB(MR(Close
                                                                                                            (qVar"s",
                                                                                                             Dest
                                                                                                               ("CP15",
                                                                                                                CTy"CP15",
                                                                                                                qVar"s"))),
                                                                                                       Close
                                                                                                         (Var("v",
                                                                                                              CTy"CP15"),
                                                                                                          MB(MB(MU(TP[Var("v",
                                                                                                                          CTy"CP15"),
                                                                                                                      Rupd
                                                                                                                        ("NS",
                                                                                                                         TP[Var("x0",
                                                                                                                                CTy"SCR"),
                                                                                                                            LF])],
                                                                                                                   qTy),
                                                                                                                Close
                                                                                                                  (Var("v",
                                                                                                                       PTy(CTy"CP15",
                                                                                                                           CTy"SCR")),
                                                                                                                   MU(Rupd
                                                                                                                        ("SCR",
                                                                                                                         Var("v",
                                                                                                                             PTy(CTy"CP15",
                                                                                                                                 CTy"SCR"))),
                                                                                                                      qTy))),
                                                                                                             Close
                                                                                                               (Var("v",
                                                                                                                    CTy"CP15"),
                                                                                                                MW(Close
                                                                                                                     (qVar"s",
                                                                                                                      Rupd
                                                                                                                        ("CP15",
                                                                                                                         TP[qVar"s",
                                                                                                                            Var("v",
                                                                                                                                CTy"CP15")]))))))))))),
                                                                                        MU(LU,
                                                                                           qTy)))),
                                                                              Close
                                                                                (AVar
                                                                                   uTy,
                                                                                 MB(MR(Close
                                                                                         (qVar"s",
                                                                                          Dest
                                                                                            ("CPSR",
                                                                                             CTy"PSR",
                                                                                             qVar"s"))),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           CTy"PSR"),
                                                                                       MB(MB(MB(MU(TP[Var("v",
                                                                                                          CTy"PSR"),
                                                                                                      LW(27,
                                                                                                         5)],
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       PTy(CTy"PSR",
                                                                                                           FTy 5)),
                                                                                                   MU(Rupd
                                                                                                        ("M",
                                                                                                         Var("v",
                                                                                                             PTy(CTy"PSR",
                                                                                                                 FTy 5))),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"PSR"),
                                                                                                MW(Close
                                                                                                     (qVar"s",
                                                                                                      Rupd
                                                                                                        ("CPSR",
                                                                                                         TP[qVar"s",
                                                                                                            Var("v",
                                                                                                                CTy"PSR")]))))),
                                                                                          Close
                                                                                            (AVar
                                                                                               uTy,
                                                                                             MB(Call
                                                                                                  ("write'SPSR",
                                                                                                   ATy(qTy,
                                                                                                       PTy(uTy,
                                                                                                           qTy)),
                                                                                                   Var("new_spsr_value",
                                                                                                       CTy"PSR")),
                                                                                                Close
                                                                                                  (AVar
                                                                                                     uTy,
                                                                                                   MB(Call
                                                                                                        ("write'R",
                                                                                                         ATy(qTy,
                                                                                                             PTy(uTy,
                                                                                                                 qTy)),
                                                                                                         TP[Var("new_lr_value",
                                                                                                                F32),
                                                                                                            LW(14,
                                                                                                               4)]),
                                                                                                      Close
                                                                                                        (AVar
                                                                                                           uTy,
                                                                                                         MB(MR(Close
                                                                                                                 (qVar"s",
                                                                                                                  Dest
                                                                                                                    ("CPSR",
                                                                                                                     CTy"PSR",
                                                                                                                     qVar"s"))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   CTy"PSR"),
                                                                                                               MB(MB(MB(MU(TP[Var("v",
                                                                                                                                  CTy"PSR"),
                                                                                                                              LT],
                                                                                                                           qTy),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               PTy(CTy"PSR",
                                                                                                                                   bTy)),
                                                                                                                           MU(Rupd
                                                                                                                                ("I",
                                                                                                                                 Var("v",
                                                                                                                                     PTy(CTy"PSR",
                                                                                                                                         bTy))),
                                                                                                                              qTy))),
                                                                                                                     Close
                                                                                                                       (Var("v",
                                                                                                                            CTy"PSR"),
                                                                                                                        MW(Close
                                                                                                                             (qVar"s",
                                                                                                                              Rupd
                                                                                                                                ("CPSR",
                                                                                                                                 TP[qVar"s",
                                                                                                                                    Var("v",
                                                                                                                                        CTy"PSR")]))))),
                                                                                                                  Close
                                                                                                                    (AVar
                                                                                                                       uTy,
                                                                                                                     MB(MR(Close
                                                                                                                             (qVar"s",
                                                                                                                              Dest
                                                                                                                                ("CPSR",
                                                                                                                                 CTy"PSR",
                                                                                                                                 qVar"s"))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               CTy"PSR"),
                                                                                                                           MB(MB(MB(MU(TP[Var("v",
                                                                                                                                              CTy"PSR"),
                                                                                                                                          LW(0,
                                                                                                                                             8)],
                                                                                                                                       qTy),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           PTy(CTy"PSR",
                                                                                                                                               F8)),
                                                                                                                                       MU(Rupd
                                                                                                                                            ("IT",
                                                                                                                                             Var("v",
                                                                                                                                                 PTy(CTy"PSR",
                                                                                                                                                     F8))),
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    MW(Close
                                                                                                                                         (qVar"s",
                                                                                                                                          Rupd
                                                                                                                                            ("CPSR",
                                                                                                                                             TP[qVar"s",
                                                                                                                                                Var("v",
                                                                                                                                                    CTy"PSR")]))))),
                                                                                                                              Close
                                                                                                                                (AVar
                                                                                                                                   uTy,
                                                                                                                                 MB(MR(Close
                                                                                                                                         (qVar"s",
                                                                                                                                          Dest
                                                                                                                                            ("CPSR",
                                                                                                                                             CTy"PSR",
                                                                                                                                             qVar"s"))),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           CTy"PSR"),
                                                                                                                                       MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                          CTy"PSR"),
                                                                                                                                                      LF],
                                                                                                                                                   qTy),
                                                                                                                                                Close
                                                                                                                                                  (Var("v",
                                                                                                                                                       PTy(CTy"PSR",
                                                                                                                                                           bTy)),
                                                                                                                                                   MU(Rupd
                                                                                                                                                        ("J",
                                                                                                                                                         Var("v",
                                                                                                                                                             PTy(CTy"PSR",
                                                                                                                                                                 bTy))),
                                                                                                                                                      qTy))),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    CTy"PSR"),
                                                                                                                                                MW(Close
                                                                                                                                                     (qVar"s",
                                                                                                                                                      Rupd
                                                                                                                                                        ("CPSR",
                                                                                                                                                         TP[qVar"s",
                                                                                                                                                            Var("v",
                                                                                                                                                                CTy"PSR")]))))),
                                                                                                                                          Close
                                                                                                                                            (AVar
                                                                                                                                               uTy,
                                                                                                                                             MB(MR(Close
                                                                                                                                                     (qVar"s",
                                                                                                                                                      Dest
                                                                                                                                                        ("CPSR",
                                                                                                                                                         CTy"PSR",
                                                                                                                                                         qVar"s"))),
                                                                                                                                                Close
                                                                                                                                                  (Var("v",
                                                                                                                                                       CTy"PSR"),
                                                                                                                                                   MB(MB(MB(MB(MR(Close
                                                                                                                                                                    (qVar"s",
                                                                                                                                                                     Dest
                                                                                                                                                                       ("CP15",
                                                                                                                                                                        CTy"CP15",
                                                                                                                                                                        qVar"s"))),
                                                                                                                                                               Close
                                                                                                                                                                 (Var("v0",
                                                                                                                                                                      CTy"CP15"),
                                                                                                                                                                  MB(MB(MU(Dest
                                                                                                                                                                             ("SCTLR",
                                                                                                                                                                              CTy"SCTLR",
                                                                                                                                                                              Var("v0",
                                                                                                                                                                                  CTy"CP15")),
                                                                                                                                                                           qTy),
                                                                                                                                                                        Close
                                                                                                                                                                          (Var("v",
                                                                                                                                                                               CTy"SCTLR"),
                                                                                                                                                                           MU(Dest
                                                                                                                                                                                ("TE",
                                                                                                                                                                                 bTy,
                                                                                                                                                                                 Var("v",
                                                                                                                                                                                     CTy"SCTLR")),
                                                                                                                                                                              qTy))),
                                                                                                                                                                     Close
                                                                                                                                                                       (bVar"v0",
                                                                                                                                                                        MU(TP[Var("v",
                                                                                                                                                                                  CTy"PSR"),
                                                                                                                                                                              bVar"v0"],
                                                                                                                                                                           qTy))))),
                                                                                                                                                            Close
                                                                                                                                                              (Var("v",
                                                                                                                                                                   PTy(CTy"PSR",
                                                                                                                                                                       bTy)),
                                                                                                                                                               MU(Rupd
                                                                                                                                                                    ("T",
                                                                                                                                                                     Var("v",
                                                                                                                                                                         PTy(CTy"PSR",
                                                                                                                                                                             bTy))),
                                                                                                                                                                  qTy))),
                                                                                                                                                         Close
                                                                                                                                                           (Var("v",
                                                                                                                                                                CTy"PSR"),
                                                                                                                                                            MW(Close
                                                                                                                                                                 (qVar"s",
                                                                                                                                                                  Rupd
                                                                                                                                                                    ("CPSR",
                                                                                                                                                                     TP[qVar"s",
                                                                                                                                                                        Var("v",
                                                                                                                                                                            CTy"PSR")]))))),
                                                                                                                                                      Close
                                                                                                                                                        (AVar
                                                                                                                                                           uTy,
                                                                                                                                                         MB(MR(Close
                                                                                                                                                                 (qVar"s",
                                                                                                                                                                  Dest
                                                                                                                                                                    ("CPSR",
                                                                                                                                                                     CTy"PSR",
                                                                                                                                                                     qVar"s"))),
                                                                                                                                                            Close
                                                                                                                                                              (Var("v",
                                                                                                                                                                   CTy"PSR"),
                                                                                                                                                               MB(MB(MB(MB(MR(Close
                                                                                                                                                                                (qVar"s",
                                                                                                                                                                                 Dest
                                                                                                                                                                                   ("CP15",
                                                                                                                                                                                    CTy"CP15",
                                                                                                                                                                                    qVar"s"))),
                                                                                                                                                                           Close
                                                                                                                                                                             (Var("v0",
                                                                                                                                                                                  CTy"CP15"),
                                                                                                                                                                              MB(MB(MU(Dest
                                                                                                                                                                                         ("SCTLR",
                                                                                                                                                                                          CTy"SCTLR",
                                                                                                                                                                                          Var("v0",
                                                                                                                                                                                              CTy"CP15")),
                                                                                                                                                                                       qTy),
                                                                                                                                                                                    Close
                                                                                                                                                                                      (Var("v",
                                                                                                                                                                                           CTy"SCTLR"),
                                                                                                                                                                                       MU(Dest
                                                                                                                                                                                            ("EE",
                                                                                                                                                                                             bTy,
                                                                                                                                                                                             Var("v",
                                                                                                                                                                                                 CTy"SCTLR")),
                                                                                                                                                                                          qTy))),
                                                                                                                                                                                 Close
                                                                                                                                                                                   (bVar"v0",
                                                                                                                                                                                    MU(TP[Var("v",
                                                                                                                                                                                              CTy"PSR"),
                                                                                                                                                                                          bVar"v0"],
                                                                                                                                                                                       qTy))))),
                                                                                                                                                                        Close
                                                                                                                                                                          (Var("v",
                                                                                                                                                                               PTy(CTy"PSR",
                                                                                                                                                                                   bTy)),
                                                                                                                                                                           MU(Rupd
                                                                                                                                                                                ("E",
                                                                                                                                                                                 Var("v",
                                                                                                                                                                                     PTy(CTy"PSR",
                                                                                                                                                                                         bTy))),
                                                                                                                                                                              qTy))),
                                                                                                                                                                     Close
                                                                                                                                                                       (Var("v",
                                                                                                                                                                            CTy"PSR"),
                                                                                                                                                                        MW(Close
                                                                                                                                                                             (qVar"s",
                                                                                                                                                                              Rupd
                                                                                                                                                                                ("CPSR",
                                                                                                                                                                                 TP[qVar"s",
                                                                                                                                                                                    Var("v",
                                                                                                                                                                                        CTy"PSR")]))))),
                                                                                                                                                                  Close
                                                                                                                                                                    (AVar
                                                                                                                                                                       uTy,
                                                                                                                                                                     MB(Call
                                                                                                                                                                          ("ExcVectorBase",
                                                                                                                                                                           ATy(qTy,
                                                                                                                                                                               PTy(F32,
                                                                                                                                                                                   qTy)),
                                                                                                                                                                           LU),
                                                                                                                                                                        Close
                                                                                                                                                                          (Var("v",
                                                                                                                                                                               F32),
                                                                                                                                                                           MB(MU(Bop(Add,
                                                                                                                                                                                     Var("v",
                                                                                                                                                                                         F32),
                                                                                                                                                                                     Var("vect_offset",
                                                                                                                                                                                         F32)),
                                                                                                                                                                                 qTy),
                                                                                                                                                                              Close
                                                                                                                                                                                (Var("v",
                                                                                                                                                                                     F32),
                                                                                                                                                                                 Call
                                                                                                                                                                                   ("BranchTo",
                                                                                                                                                                                    ATy(qTy,
                                                                                                                                                                                        PTy(uTy,
                                                                                                                                                                                            qTy)),
                                                                                                                                                                                    Var("v",
                                                                                                                                                                                        F32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
;
val TakeSVCException_def = Def
  ("TakeSVCException",AVar uTy,
   MB(Call("ITAdvance",ATy(qTy,PTy(uTy,qTy)),LU),
      Close
        (AVar uTy,
         MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
            Close
              (Var("v",CTy"PSR"),
               MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
                     Close
                       (bVar"b",
                        ITE(bVar"b",
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Sub,Var("v",F32),LW(2,32)),qTy))),
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
                  Close
                    (Var("new_lr_value",F32),
                     MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                        Close
                          (Var("new_spsr_value",CTy"PSR"),
                           Let(Var("vect_offset",F32),LW(8,32),
                               MB(Call
                                    ("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),
                                     LU),
                                  Close
                                    (bVar"v",
                                     MB(MB(MB(ITE(bVar"v",
                                                  Call
                                                    ("HaveSecurityExt",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),MU(LF,qTy)),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(MR(Close
                                                             (qVar"s",
                                                              Dest
                                                                ("CP15",
                                                                 CTy"CP15",
                                                                 qVar"s"))),
                                                        Close
                                                          (Var("v",
                                                               CTy"CP15"),
                                                           MB(MU(Dest
                                                                   ("SCR",
                                                                    CTy"SCR",
                                                                    Var("v",
                                                                        CTy"CP15")),
                                                                 qTy),
                                                              Close
                                                                (Var("v",
                                                                     CTy"SCR"),
                                                                 MU(Dest
                                                                      ("NS",
                                                                       bTy,
                                                                       Var("v",
                                                                           CTy"SCR")),
                                                                    qTy))))),
                                                     MU(LF,qTy)))),
                                           Close
                                             (bVar"b",
                                              ITE(bVar"b",
                                                  MB(MR(Close
                                                          (qVar"s",
                                                           Dest
                                                             ("CPSR",
                                                              CTy"PSR",
                                                              qVar"s"))),
                                                     Close
                                                       (Var("v",CTy"PSR"),
                                                        MB(MU(Dest
                                                                ("M",
                                                                 FTy 5,
                                                                 Var("v",
                                                                     CTy"PSR")),
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  FTy 5),
                                                              MU(EQ(Var("v",
                                                                        FTy 5),
                                                                    LW(26,
                                                                       5)),
                                                                 qTy))))),
                                                  MU(LF,qTy)))),
                                        Close
                                          (bVar"take_to_hyp",
                                           MB(Call
                                                ("HaveVirtExt",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v",
                                                 MB(MB(MB(MB(ITE(bVar"v",
                                                                 Call
                                                                   ("HaveSecurityExt",
                                                                    ATy(qTy,
                                                                        PTy(bTy,
                                                                            qTy)),
                                                                    LU),
                                                                 MU(LF,qTy)),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    MB(Call
                                                                         ("IsSecure",
                                                                          ATy(qTy,
                                                                              PTy(bTy,
                                                                                  qTy)),
                                                                          LU),
                                                                       Close
                                                                         (bVar"v",
                                                                          MU(Mop(Not,
                                                                                 bVar"v"),
                                                                             qTy))),
                                                                    MU(LF,
                                                                       qTy)))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(MR(Close
                                                                         (qVar"s",
                                                                          Dest
                                                                            ("CP15",
                                                                             CTy"CP15",
                                                                             qVar"s"))),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"CP15"),
                                                                       MB(MU(Dest
                                                                               ("HCR",
                                                                                CTy"HCR",
                                                                                Var("v",
                                                                                    CTy"CP15")),
                                                                             qTy),
                                                                          Close
                                                                            (Var("v",
                                                                                 CTy"HCR"),
                                                                             MU(Dest
                                                                                  ("TGE",
                                                                                   bTy,
                                                                                   Var("v",
                                                                                       CTy"HCR")),
                                                                                qTy))))),
                                                                 MU(LF,qTy)))),
                                                       Close
                                                         (bVar"b",
                                                          ITE(bVar"b",
                                                              MB(MR(Close
                                                                      (qVar"s",
                                                                       Dest
                                                                         ("CPSR",
                                                                          CTy"PSR",
                                                                          qVar"s"))),
                                                                 Close
                                                                   (Var("v",
                                                                        CTy"PSR"),
                                                                    MB(MU(Dest
                                                                            ("M",
                                                                             FTy 5,
                                                                             Var("v",
                                                                                 CTy"PSR")),
                                                                          qTy),
                                                                       Close
                                                                         (Var("v",
                                                                              FTy 5),
                                                                          MU(EQ(Var("v",
                                                                                    FTy 5),
                                                                                LW(16,
                                                                                   5)),
                                                                             qTy))))),
                                                              MU(LF,qTy)))),
                                                    Close
                                                      (bVar"route_to_hyp",
                                                       ITB([(bVar"take_to_hyp",
                                                             Call
                                                               ("EnterHypMode",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                TP[Var("new_spsr_value",
                                                                       CTy"PSR"),
                                                                   Var("new_lr_value",
                                                                       F32),
                                                                   Var("vect_offset",
                                                                       F32)])),
                                                            (bVar"route_to_hyp",
                                                             Call
                                                               ("EnterHypMode",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                TP[Var("new_spsr_value",
                                                                       CTy"PSR"),
                                                                   Var("new_lr_value",
                                                                       F32),
                                                                   LW(20,
                                                                      32)]))],
                                                           MB(MR(Close
                                                                   (qVar"s",
                                                                    Dest
                                                                      ("CPSR",
                                                                       CTy"PSR",
                                                                       qVar"s"))),
                                                              Close
                                                                (Var("v",
                                                                     CTy"PSR"),
                                                                 MB(MB(MB(MU(Dest
                                                                               ("M",
                                                                                FTy 5,
                                                                                Var("v",
                                                                                    CTy"PSR")),
                                                                             qTy),
                                                                          Close
                                                                            (Var("v",
                                                                                 FTy 5),
                                                                             MU(EQ(Var("v",
                                                                                       FTy 5),
                                                                                   LW(22,
                                                                                      5)),
                                                                                qTy))),
                                                                       Close
                                                                         (bVar"b",
                                                                          ITE(bVar"b",
                                                                              MB(MR(Close
                                                                                      (qVar"s",
                                                                                       Dest
                                                                                         ("CP15",
                                                                                          CTy"CP15",
                                                                                          qVar"s"))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"CP15"),
                                                                                    MB(MU(Dest
                                                                                            ("SCR",
                                                                                             CTy"SCR",
                                                                                             Var("v",
                                                                                                 CTy"CP15")),
                                                                                          qTy),
                                                                                       Close
                                                                                         (Var("x0",
                                                                                              CTy"SCR"),
                                                                                          MB(MR(Close
                                                                                                  (qVar"s",
                                                                                                   Dest
                                                                                                     ("CP15",
                                                                                                      CTy"CP15",
                                                                                                      qVar"s"))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"CP15"),
                                                                                                MB(MB(MU(TP[Var("v",
                                                                                                                CTy"CP15"),
                                                                                                            Rupd
                                                                                                              ("NS",
                                                                                                               TP[Var("x0",
                                                                                                                      CTy"SCR"),
                                                                                                                  LF])],
                                                                                                         qTy),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             PTy(CTy"CP15",
                                                                                                                 CTy"SCR")),
                                                                                                         MU(Rupd
                                                                                                              ("SCR",
                                                                                                               Var("v",
                                                                                                                   PTy(CTy"CP15",
                                                                                                                       CTy"SCR"))),
                                                                                                            qTy))),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          CTy"CP15"),
                                                                                                      MW(Close
                                                                                                           (qVar"s",
                                                                                                            Rupd
                                                                                                              ("CP15",
                                                                                                               TP[qVar"s",
                                                                                                                  Var("v",
                                                                                                                      CTy"CP15")]))))))))))),
                                                                              MU(LU,
                                                                                 qTy)))),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MB(MR(Close
                                                                               (qVar"s",
                                                                                Dest
                                                                                  ("CPSR",
                                                                                   CTy"PSR",
                                                                                   qVar"s"))),
                                                                          Close
                                                                            (Var("v",
                                                                                 CTy"PSR"),
                                                                             MB(MB(MB(MU(TP[Var("v",
                                                                                                CTy"PSR"),
                                                                                            LW(19,
                                                                                               5)],
                                                                                         qTy),
                                                                                      Close
                                                                                        (Var("v",
                                                                                             PTy(CTy"PSR",
                                                                                                 FTy 5)),
                                                                                         MU(Rupd
                                                                                              ("M",
                                                                                               Var("v",
                                                                                                   PTy(CTy"PSR",
                                                                                                       FTy 5))),
                                                                                            qTy))),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          CTy"PSR"),
                                                                                      MW(Close
                                                                                           (qVar"s",
                                                                                            Rupd
                                                                                              ("CPSR",
                                                                                               TP[qVar"s",
                                                                                                  Var("v",
                                                                                                      CTy"PSR")]))))),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MB(Call
                                                                                        ("write'SPSR",
                                                                                         ATy(qTy,
                                                                                             PTy(uTy,
                                                                                                 qTy)),
                                                                                         Var("new_spsr_value",
                                                                                             CTy"PSR")),
                                                                                      Close
                                                                                        (AVar
                                                                                           uTy,
                                                                                         MB(Call
                                                                                              ("write'R",
                                                                                               ATy(qTy,
                                                                                                   PTy(uTy,
                                                                                                       qTy)),
                                                                                               TP[Var("new_lr_value",
                                                                                                      F32),
                                                                                                  LW(14,
                                                                                                     4)]),
                                                                                            Close
                                                                                              (AVar
                                                                                                 uTy,
                                                                                               MB(MR(Close
                                                                                                       (qVar"s",
                                                                                                        Dest
                                                                                                          ("CPSR",
                                                                                                           CTy"PSR",
                                                                                                           qVar"s"))),
                                                                                                  Close
                                                                                                    (Var("v",
                                                                                                         CTy"PSR"),
                                                                                                     MB(MB(MB(MU(TP[Var("v",
                                                                                                                        CTy"PSR"),
                                                                                                                    LT],
                                                                                                                 qTy),
                                                                                                              Close
                                                                                                                (Var("v",
                                                                                                                     PTy(CTy"PSR",
                                                                                                                         bTy)),
                                                                                                                 MU(Rupd
                                                                                                                      ("I",
                                                                                                                       Var("v",
                                                                                                                           PTy(CTy"PSR",
                                                                                                                               bTy))),
                                                                                                                    qTy))),
                                                                                                           Close
                                                                                                             (Var("v",
                                                                                                                  CTy"PSR"),
                                                                                                              MW(Close
                                                                                                                   (qVar"s",
                                                                                                                    Rupd
                                                                                                                      ("CPSR",
                                                                                                                       TP[qVar"s",
                                                                                                                          Var("v",
                                                                                                                              CTy"PSR")]))))),
                                                                                                        Close
                                                                                                          (AVar
                                                                                                             uTy,
                                                                                                           MB(MR(Close
                                                                                                                   (qVar"s",
                                                                                                                    Dest
                                                                                                                      ("CPSR",
                                                                                                                       CTy"PSR",
                                                                                                                       qVar"s"))),
                                                                                                              Close
                                                                                                                (Var("v",
                                                                                                                     CTy"PSR"),
                                                                                                                 MB(MB(MB(MU(TP[Var("v",
                                                                                                                                    CTy"PSR"),
                                                                                                                                LW(0,
                                                                                                                                   8)],
                                                                                                                             qTy),
                                                                                                                          Close
                                                                                                                            (Var("v",
                                                                                                                                 PTy(CTy"PSR",
                                                                                                                                     F8)),
                                                                                                                             MU(Rupd
                                                                                                                                  ("IT",
                                                                                                                                   Var("v",
                                                                                                                                       PTy(CTy"PSR",
                                                                                                                                           F8))),
                                                                                                                                qTy))),
                                                                                                                       Close
                                                                                                                         (Var("v",
                                                                                                                              CTy"PSR"),
                                                                                                                          MW(Close
                                                                                                                               (qVar"s",
                                                                                                                                Rupd
                                                                                                                                  ("CPSR",
                                                                                                                                   TP[qVar"s",
                                                                                                                                      Var("v",
                                                                                                                                          CTy"PSR")]))))),
                                                                                                                    Close
                                                                                                                      (AVar
                                                                                                                         uTy,
                                                                                                                       MB(MR(Close
                                                                                                                               (qVar"s",
                                                                                                                                Dest
                                                                                                                                  ("CPSR",
                                                                                                                                   CTy"PSR",
                                                                                                                                   qVar"s"))),
                                                                                                                          Close
                                                                                                                            (Var("v",
                                                                                                                                 CTy"PSR"),
                                                                                                                             MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                CTy"PSR"),
                                                                                                                                            LF],
                                                                                                                                         qTy),
                                                                                                                                      Close
                                                                                                                                        (Var("v",
                                                                                                                                             PTy(CTy"PSR",
                                                                                                                                                 bTy)),
                                                                                                                                         MU(Rupd
                                                                                                                                              ("J",
                                                                                                                                               Var("v",
                                                                                                                                                   PTy(CTy"PSR",
                                                                                                                                                       bTy))),
                                                                                                                                            qTy))),
                                                                                                                                   Close
                                                                                                                                     (Var("v",
                                                                                                                                          CTy"PSR"),
                                                                                                                                      MW(Close
                                                                                                                                           (qVar"s",
                                                                                                                                            Rupd
                                                                                                                                              ("CPSR",
                                                                                                                                               TP[qVar"s",
                                                                                                                                                  Var("v",
                                                                                                                                                      CTy"PSR")]))))),
                                                                                                                                Close
                                                                                                                                  (AVar
                                                                                                                                     uTy,
                                                                                                                                   MB(MR(Close
                                                                                                                                           (qVar"s",
                                                                                                                                            Dest
                                                                                                                                              ("CPSR",
                                                                                                                                               CTy"PSR",
                                                                                                                                               qVar"s"))),
                                                                                                                                      Close
                                                                                                                                        (Var("v",
                                                                                                                                             CTy"PSR"),
                                                                                                                                         MB(MB(MB(MB(MR(Close
                                                                                                                                                          (qVar"s",
                                                                                                                                                           Dest
                                                                                                                                                             ("CP15",
                                                                                                                                                              CTy"CP15",
                                                                                                                                                              qVar"s"))),
                                                                                                                                                     Close
                                                                                                                                                       (Var("v0",
                                                                                                                                                            CTy"CP15"),
                                                                                                                                                        MB(MB(MU(Dest
                                                                                                                                                                   ("SCTLR",
                                                                                                                                                                    CTy"SCTLR",
                                                                                                                                                                    Var("v0",
                                                                                                                                                                        CTy"CP15")),
                                                                                                                                                                 qTy),
                                                                                                                                                              Close
                                                                                                                                                                (Var("v",
                                                                                                                                                                     CTy"SCTLR"),
                                                                                                                                                                 MU(Dest
                                                                                                                                                                      ("TE",
                                                                                                                                                                       bTy,
                                                                                                                                                                       Var("v",
                                                                                                                                                                           CTy"SCTLR")),
                                                                                                                                                                    qTy))),
                                                                                                                                                           Close
                                                                                                                                                             (bVar"v0",
                                                                                                                                                              MU(TP[Var("v",
                                                                                                                                                                        CTy"PSR"),
                                                                                                                                                                    bVar"v0"],
                                                                                                                                                                 qTy))))),
                                                                                                                                                  Close
                                                                                                                                                    (Var("v",
                                                                                                                                                         PTy(CTy"PSR",
                                                                                                                                                             bTy)),
                                                                                                                                                     MU(Rupd
                                                                                                                                                          ("T",
                                                                                                                                                           Var("v",
                                                                                                                                                               PTy(CTy"PSR",
                                                                                                                                                                   bTy))),
                                                                                                                                                        qTy))),
                                                                                                                                               Close
                                                                                                                                                 (Var("v",
                                                                                                                                                      CTy"PSR"),
                                                                                                                                                  MW(Close
                                                                                                                                                       (qVar"s",
                                                                                                                                                        Rupd
                                                                                                                                                          ("CPSR",
                                                                                                                                                           TP[qVar"s",
                                                                                                                                                              Var("v",
                                                                                                                                                                  CTy"PSR")]))))),
                                                                                                                                            Close
                                                                                                                                              (AVar
                                                                                                                                                 uTy,
                                                                                                                                               MB(MR(Close
                                                                                                                                                       (qVar"s",
                                                                                                                                                        Dest
                                                                                                                                                          ("CPSR",
                                                                                                                                                           CTy"PSR",
                                                                                                                                                           qVar"s"))),
                                                                                                                                                  Close
                                                                                                                                                    (Var("v",
                                                                                                                                                         CTy"PSR"),
                                                                                                                                                     MB(MB(MB(MB(MR(Close
                                                                                                                                                                      (qVar"s",
                                                                                                                                                                       Dest
                                                                                                                                                                         ("CP15",
                                                                                                                                                                          CTy"CP15",
                                                                                                                                                                          qVar"s"))),
                                                                                                                                                                 Close
                                                                                                                                                                   (Var("v0",
                                                                                                                                                                        CTy"CP15"),
                                                                                                                                                                    MB(MB(MU(Dest
                                                                                                                                                                               ("SCTLR",
                                                                                                                                                                                CTy"SCTLR",
                                                                                                                                                                                Var("v0",
                                                                                                                                                                                    CTy"CP15")),
                                                                                                                                                                             qTy),
                                                                                                                                                                          Close
                                                                                                                                                                            (Var("v",
                                                                                                                                                                                 CTy"SCTLR"),
                                                                                                                                                                             MU(Dest
                                                                                                                                                                                  ("EE",
                                                                                                                                                                                   bTy,
                                                                                                                                                                                   Var("v",
                                                                                                                                                                                       CTy"SCTLR")),
                                                                                                                                                                                qTy))),
                                                                                                                                                                       Close
                                                                                                                                                                         (bVar"v0",
                                                                                                                                                                          MU(TP[Var("v",
                                                                                                                                                                                    CTy"PSR"),
                                                                                                                                                                                bVar"v0"],
                                                                                                                                                                             qTy))))),
                                                                                                                                                              Close
                                                                                                                                                                (Var("v",
                                                                                                                                                                     PTy(CTy"PSR",
                                                                                                                                                                         bTy)),
                                                                                                                                                                 MU(Rupd
                                                                                                                                                                      ("E",
                                                                                                                                                                       Var("v",
                                                                                                                                                                           PTy(CTy"PSR",
                                                                                                                                                                               bTy))),
                                                                                                                                                                    qTy))),
                                                                                                                                                           Close
                                                                                                                                                             (Var("v",
                                                                                                                                                                  CTy"PSR"),
                                                                                                                                                              MW(Close
                                                                                                                                                                   (qVar"s",
                                                                                                                                                                    Rupd
                                                                                                                                                                      ("CPSR",
                                                                                                                                                                       TP[qVar"s",
                                                                                                                                                                          Var("v",
                                                                                                                                                                              CTy"PSR")]))))),
                                                                                                                                                        Close
                                                                                                                                                          (AVar
                                                                                                                                                             uTy,
                                                                                                                                                           MB(Call
                                                                                                                                                                ("ExcVectorBase",
                                                                                                                                                                 ATy(qTy,
                                                                                                                                                                     PTy(F32,
                                                                                                                                                                         qTy)),
                                                                                                                                                                 LU),
                                                                                                                                                              Close
                                                                                                                                                                (Var("v",
                                                                                                                                                                     F32),
                                                                                                                                                                 MB(MU(Bop(Add,
                                                                                                                                                                           Var("v",
                                                                                                                                                                               F32),
                                                                                                                                                                           Var("vect_offset",
                                                                                                                                                                               F32)),
                                                                                                                                                                       qTy),
                                                                                                                                                                    Close
                                                                                                                                                                      (Var("v",
                                                                                                                                                                           F32),
                                                                                                                                                                       Call
                                                                                                                                                                         ("BranchTo",
                                                                                                                                                                          ATy(qTy,
                                                                                                                                                                              PTy(uTy,
                                                                                                                                                                                  qTy)),
                                                                                                                                                                          Var("v",
                                                                                                                                                                              F32)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
;
val TakeSMCException_def = Def
  ("TakeSMCException",AVar uTy,
   MB(Call("ITAdvance",ATy(qTy,PTy(uTy,qTy)),LU),
      Close
        (AVar uTy,
         MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
            Close
              (Var("v",CTy"PSR"),
               MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
                     Close
                       (bVar"b",
                        ITE(bVar"b",Const("PC",ATy(qTy,PTy(F32,qTy))),
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
                  Close
                    (Var("new_lr_value",F32),
                     MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                        Close
                          (Var("new_spsr_value",CTy"PSR"),
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MB(MB(MB(MU(Dest
                                               ("M",FTy 5,
                                                Var("v",CTy"PSR")),qTy),
                                          Close
                                            (Var("v",FTy 5),
                                             MU(EQ(Var("v",FTy 5),LW(22,5)),
                                                qTy))),
                                       Close
                                         (bVar"b",
                                          ITE(bVar"b",
                                              MB(MR(Close
                                                      (qVar"s",
                                                       Dest
                                                         ("CP15",
                                                          CTy"CP15",
                                                          qVar"s"))),
                                                 Close
                                                   (Var("v",CTy"CP15"),
                                                    MB(MU(Dest
                                                            ("SCR",
                                                             CTy"SCR",
                                                             Var("v",
                                                                 CTy"CP15")),
                                                          qTy),
                                                       Close
                                                         (Var("x0",
                                                              CTy"SCR"),
                                                          MB(MR(Close
                                                                  (qVar"s",
                                                                   Dest
                                                                     ("CP15",
                                                                      CTy"CP15",
                                                                      qVar"s"))),
                                                             Close
                                                               (Var("v",
                                                                    CTy"CP15"),
                                                                MB(MB(MU(TP[Var("v",
                                                                                CTy"CP15"),
                                                                            Rupd
                                                                              ("NS",
                                                                               TP[Var("x0",
                                                                                      CTy"SCR"),
                                                                                  LF])],
                                                                         qTy),
                                                                      Close
                                                                        (Var("v",
                                                                             PTy(CTy"CP15",
                                                                                 CTy"SCR")),
                                                                         MU(Rupd
                                                                              ("SCR",
                                                                               Var("v",
                                                                                   PTy(CTy"CP15",
                                                                                       CTy"SCR"))),
                                                                            qTy))),
                                                                   Close
                                                                     (Var("v",
                                                                          CTy"CP15"),
                                                                      MW(Close
                                                                           (qVar"s",
                                                                            Rupd
                                                                              ("CP15",
                                                                               TP[qVar"s",
                                                                                  Var("v",
                                                                                      CTy"CP15")]))))))))))),
                                              MU(LU,qTy)))),
                                    Close
                                      (AVar uTy,
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("CPSR",CTy"PSR",qVar"s"))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MB(MU(TP[Var("v",
                                                                CTy"PSR"),
                                                            LW(22,5)],qTy),
                                                      Close
                                                        (Var("v",
                                                             PTy(CTy"PSR",
                                                                 FTy 5)),
                                                         MU(Rupd
                                                              ("M",
                                                               Var("v",
                                                                   PTy(CTy"PSR",
                                                                       FTy 5))),
                                                            qTy))),
                                                   Close
                                                     (Var("v",CTy"PSR"),
                                                      MW(Close
                                                           (qVar"s",
                                                            Rupd
                                                              ("CPSR",
                                                               TP[qVar"s",
                                                                  Var("v",
                                                                      CTy"PSR")]))))),
                                                Close
                                                  (AVar uTy,
                                                   Call
                                                     ("EnterMonitorMode",
                                                      ATy(qTy,PTy(uTy,qTy)),
                                                      TP[Var("new_spsr_value",
                                                             CTy"PSR"),
                                                         Var("new_lr_value",
                                                             F32),LW(8,32)]))))))))))))))))))
;
val TakeHVCException_def = Def
  ("TakeHVCException",AVar uTy,
   MB(Call("ITAdvance",ATy(qTy,PTy(uTy,qTy)),LU),
      Close
        (AVar uTy,
         MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
            Close
              (Var("v",CTy"PSR"),
               MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
                     Close
                       (bVar"b",
                        ITE(bVar"b",Const("PC",ATy(qTy,PTy(F32,qTy))),
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
                  Close
                    (Var("preferred_exceptn_return",F32),
                     MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                        Close
                          (Var("new_spsr_value",CTy"PSR"),
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MB(MB(MU(Dest
                                            ("M",FTy 5,Var("v",CTy"PSR")),
                                          qTy),
                                       Close
                                         (Var("v",FTy 5),
                                          MU(EQ(Var("v",FTy 5),LW(26,5)),
                                             qTy))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           Call
                                             ("EnterHypMode",
                                              ATy(qTy,PTy(uTy,qTy)),
                                              TP[Var("new_spsr_value",
                                                     CTy"PSR"),
                                                 Var("preferred_exceptn_return",
                                                     F32),LW(8,32)]),
                                           Call
                                             ("EnterHypMode",
                                              ATy(qTy,PTy(uTy,qTy)),
                                              TP[Var("new_spsr_value",
                                                     CTy"PSR"),
                                                 Var("preferred_exceptn_return",
                                                     F32),LW(20,32)])))))))))))))))
;
val TakeDataAbortException_def = Def
  ("TakeDataAbortException",AVar uTy,
   MB(MW(Close(qVar"s",Rupd("data_abort",TP[qVar"s",LF]))),
      Close
        (AVar uTy,
         MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
            Close
              (Var("v",CTy"PSR"),
               MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
                     Close
                       (bVar"b",
                        ITE(bVar"b",
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Add,Var("v",F32),LW(4,32)),qTy))),
                            Const("PC",ATy(qTy,PTy(F32,qTy)))))),
                  Close
                    (Var("new_lr_value",F32),
                     MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                        Close
                          (Var("new_spsr_value",CTy"PSR"),
                           Let(Var("vect_offset",F32),LW(16,32),
                               Let(Var("preferred_exceptn_return",F32),
                                   Bop(Sub,Var("new_lr_value",F32),
                                       LW(8,32)),
                                   MB(Call
                                        ("HaveSecurityExt",
                                         ATy(qTy,PTy(bTy,qTy)),LU),
                                      Close
                                        (bVar"v",
                                         MB(MB(ITE(bVar"v",
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("CP15",
                                                               CTy"CP15",
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",CTy"CP15"),
                                                         MB(MU(Dest
                                                                 ("SCR",
                                                                  CTy"SCR",
                                                                  Var("v",
                                                                      CTy"CP15")),
                                                               qTy),
                                                            Close
                                                              (Var("v",
                                                                   CTy"SCR"),
                                                               MU(Dest
                                                                    ("EA",
                                                                     bTy,
                                                                     Var("v",
                                                                         CTy"SCR")),
                                                                  qTy))))),
                                                   MU(LF,qTy)),
                                               Close
                                                 (bVar"b",
                                                  ITE(bVar"b",
                                                      Call
                                                        ("IsExternalAbort",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         LU),MU(LF,qTy)))),
                                            Close
                                              (bVar"route_to_monitor",
                                               MB(Call
                                                    ("HaveVirtExt",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v",
                                                     MB(MB(MB(ITE(bVar"v",
                                                                  Call
                                                                    ("HaveSecurityExt",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  MU(LF,
                                                                     qTy)),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(MR(Close
                                                                             (qVar"s",
                                                                              Dest
                                                                                ("CP15",
                                                                                 CTy"CP15",
                                                                                 qVar"s"))),
                                                                        Close
                                                                          (Var("v",
                                                                               CTy"CP15"),
                                                                           MB(MU(Dest
                                                                                   ("SCR",
                                                                                    CTy"SCR",
                                                                                    Var("v",
                                                                                        CTy"CP15")),
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"SCR"),
                                                                                 MU(Dest
                                                                                      ("NS",
                                                                                       bTy,
                                                                                       Var("v",
                                                                                           CTy"SCR")),
                                                                                    qTy))))),
                                                                     MU(LF,
                                                                        qTy)))),
                                                           Close
                                                             (bVar"b",
                                                              ITE(bVar"b",
                                                                  MB(MR(Close
                                                                          (qVar"s",
                                                                           Dest
                                                                             ("CPSR",
                                                                              CTy"PSR",
                                                                              qVar"s"))),
                                                                     Close
                                                                       (Var("v",
                                                                            CTy"PSR"),
                                                                        MB(MU(Dest
                                                                                ("M",
                                                                                 FTy 5,
                                                                                 Var("v",
                                                                                     CTy"PSR")),
                                                                              qTy),
                                                                           Close
                                                                             (Var("v",
                                                                                  FTy 5),
                                                                              MU(EQ(Var("v",
                                                                                        FTy 5),
                                                                                    LW(26,
                                                                                       5)),
                                                                                 qTy))))),
                                                                  MU(LF,
                                                                     qTy)))),
                                                        Close
                                                          (bVar"take_to_hyp",
                                                           MB(ITB([(bVar"route_to_monitor",
                                                                    MB(MR(Close
                                                                            (qVar"s",
                                                                             Dest
                                                                               ("CPSR",
                                                                                CTy"PSR",
                                                                                qVar"s"))),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"PSR"),
                                                                          MB(MB(MB(MU(Dest
                                                                                        ("M",
                                                                                         FTy 5,
                                                                                         Var("v",
                                                                                             CTy"PSR")),
                                                                                      qTy),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          FTy 5),
                                                                                      MU(EQ(Var("v",
                                                                                                FTy 5),
                                                                                            LW(22,
                                                                                               5)),
                                                                                         qTy))),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   ITE(bVar"b",
                                                                                       MB(MR(Close
                                                                                               (qVar"s",
                                                                                                Dest
                                                                                                  ("CP15",
                                                                                                   CTy"CP15",
                                                                                                   qVar"s"))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 CTy"CP15"),
                                                                                             MB(MU(Dest
                                                                                                     ("SCR",
                                                                                                      CTy"SCR",
                                                                                                      Var("v",
                                                                                                          CTy"CP15")),
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (Var("x0",
                                                                                                       CTy"SCR"),
                                                                                                   MB(MR(Close
                                                                                                           (qVar"s",
                                                                                                            Dest
                                                                                                              ("CP15",
                                                                                                               CTy"CP15",
                                                                                                               qVar"s"))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             CTy"CP15"),
                                                                                                         MB(MB(MU(TP[Var("v",
                                                                                                                         CTy"CP15"),
                                                                                                                     Rupd
                                                                                                                       ("NS",
                                                                                                                        TP[Var("x0",
                                                                                                                               CTy"SCR"),
                                                                                                                           LF])],
                                                                                                                  qTy),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      PTy(CTy"CP15",
                                                                                                                          CTy"SCR")),
                                                                                                                  MU(Rupd
                                                                                                                       ("SCR",
                                                                                                                        Var("v",
                                                                                                                            PTy(CTy"CP15",
                                                                                                                                CTy"SCR"))),
                                                                                                                     qTy))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   CTy"CP15"),
                                                                                                               MW(Close
                                                                                                                    (qVar"s",
                                                                                                                     Rupd
                                                                                                                       ("CP15",
                                                                                                                        TP[qVar"s",
                                                                                                                           Var("v",
                                                                                                                               CTy"CP15")]))))))))))),
                                                                                       MU(LU,
                                                                                          qTy)))),
                                                                             Close
                                                                               (AVar
                                                                                  uTy,
                                                                                Call
                                                                                  ("EnterMonitorMode",
                                                                                   ATy(qTy,
                                                                                       PTy(uTy,
                                                                                           qTy)),
                                                                                   TP[Var("new_spsr_value",
                                                                                          CTy"PSR"),
                                                                                      Var("new_lr_value",
                                                                                          F32),
                                                                                      Var("vect_offset",
                                                                                          F32)])))))),
                                                                   (bVar"take_to_hyp",
                                                                    Call
                                                                      ("EnterHypMode",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("new_spsr_value",
                                                                              CTy"PSR"),
                                                                          Var("preferred_exceptn_return",
                                                                              F32),
                                                                          Var("vect_offset",
                                                                              F32)])),
                                                                   (LF,
                                                                    Call
                                                                      ("EnterHypMode",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("new_spsr_value",
                                                                              CTy"PSR"),
                                                                          Var("preferred_exceptn_return",
                                                                              F32),
                                                                          LW(20,
                                                                             32)]))],
                                                                  MB(Call
                                                                       ("HaveSecurityExt",
                                                                        ATy(qTy,
                                                                            PTy(bTy,
                                                                                qTy)),
                                                                        LU),
                                                                     Close
                                                                       (bVar"v",
                                                                        MB(MB(ITE(bVar"v",
                                                                                  MB(MR(Close
                                                                                          (qVar"s",
                                                                                           Dest
                                                                                             ("CPSR",
                                                                                              CTy"PSR",
                                                                                              qVar"s"))),
                                                                                     Close
                                                                                       (Var("v",
                                                                                            CTy"PSR"),
                                                                                        MB(MU(Dest
                                                                                                ("M",
                                                                                                 FTy 5,
                                                                                                 Var("v",
                                                                                                     CTy"PSR")),
                                                                                              qTy),
                                                                                           Close
                                                                                             (Var("v",
                                                                                                  FTy 5),
                                                                                              MU(EQ(Var("v",
                                                                                                        FTy 5),
                                                                                                    LW(22,
                                                                                                       5)),
                                                                                                 qTy))))),
                                                                                  MU(LF,
                                                                                     qTy)),
                                                                              Close
                                                                                (bVar"b",
                                                                                 ITE(bVar"b",
                                                                                     MB(MR(Close
                                                                                             (qVar"s",
                                                                                              Dest
                                                                                                ("CP15",
                                                                                                 CTy"CP15",
                                                                                                 qVar"s"))),
                                                                                        Close
                                                                                          (Var("v",
                                                                                               CTy"CP15"),
                                                                                           MB(MU(Dest
                                                                                                   ("SCR",
                                                                                                    CTy"SCR",
                                                                                                    Var("v",
                                                                                                        CTy"CP15")),
                                                                                                 qTy),
                                                                                              Close
                                                                                                (Var("x0",
                                                                                                     CTy"SCR"),
                                                                                                 MB(MR(Close
                                                                                                         (qVar"s",
                                                                                                          Dest
                                                                                                            ("CP15",
                                                                                                             CTy"CP15",
                                                                                                             qVar"s"))),
                                                                                                    Close
                                                                                                      (Var("v",
                                                                                                           CTy"CP15"),
                                                                                                       MB(MB(MU(TP[Var("v",
                                                                                                                       CTy"CP15"),
                                                                                                                   Rupd
                                                                                                                     ("NS",
                                                                                                                      TP[Var("x0",
                                                                                                                             CTy"SCR"),
                                                                                                                         LF])],
                                                                                                                qTy),
                                                                                                             Close
                                                                                                               (Var("v",
                                                                                                                    PTy(CTy"CP15",
                                                                                                                        CTy"SCR")),
                                                                                                                MU(Rupd
                                                                                                                     ("SCR",
                                                                                                                      Var("v",
                                                                                                                          PTy(CTy"CP15",
                                                                                                                              CTy"SCR"))),
                                                                                                                   qTy))),
                                                                                                          Close
                                                                                                            (Var("v",
                                                                                                                 CTy"CP15"),
                                                                                                             MW(Close
                                                                                                                  (qVar"s",
                                                                                                                   Rupd
                                                                                                                     ("CP15",
                                                                                                                      TP[qVar"s",
                                                                                                                         Var("v",
                                                                                                                             CTy"CP15")]))))))))))),
                                                                                     MU(LU,
                                                                                        qTy)))),
                                                                           Close
                                                                             (AVar
                                                                                uTy,
                                                                              MB(MR(Close
                                                                                      (qVar"s",
                                                                                       Dest
                                                                                         ("CPSR",
                                                                                          CTy"PSR",
                                                                                          qVar"s"))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"PSR"),
                                                                                    MB(MB(MB(MU(TP[Var("v",
                                                                                                       CTy"PSR"),
                                                                                                   LW(23,
                                                                                                      5)],
                                                                                                qTy),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    PTy(CTy"PSR",
                                                                                                        FTy 5)),
                                                                                                MU(Rupd
                                                                                                     ("M",
                                                                                                      Var("v",
                                                                                                          PTy(CTy"PSR",
                                                                                                              FTy 5))),
                                                                                                   qTy))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 CTy"PSR"),
                                                                                             MW(Close
                                                                                                  (qVar"s",
                                                                                                   Rupd
                                                                                                     ("CPSR",
                                                                                                      TP[qVar"s",
                                                                                                         Var("v",
                                                                                                             CTy"PSR")]))))),
                                                                                       Close
                                                                                         (AVar
                                                                                            uTy,
                                                                                          MB(Call
                                                                                               ("write'SPSR",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                Var("new_spsr_value",
                                                                                                    CTy"PSR")),
                                                                                             Close
                                                                                               (AVar
                                                                                                  uTy,
                                                                                                MB(Call
                                                                                                     ("write'R",
                                                                                                      ATy(qTy,
                                                                                                          PTy(uTy,
                                                                                                              qTy)),
                                                                                                      TP[Var("new_lr_value",
                                                                                                             F32),
                                                                                                         LW(14,
                                                                                                            4)]),
                                                                                                   Close
                                                                                                     (AVar
                                                                                                        uTy,
                                                                                                      MB(MR(Close
                                                                                                              (qVar"s",
                                                                                                               Dest
                                                                                                                 ("CPSR",
                                                                                                                  CTy"PSR",
                                                                                                                  qVar"s"))),
                                                                                                         Close
                                                                                                           (Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            MB(MB(MB(MU(TP[Var("v",
                                                                                                                               CTy"PSR"),
                                                                                                                           LT],
                                                                                                                        qTy),
                                                                                                                     Close
                                                                                                                       (Var("v",
                                                                                                                            PTy(CTy"PSR",
                                                                                                                                bTy)),
                                                                                                                        MU(Rupd
                                                                                                                             ("I",
                                                                                                                              Var("v",
                                                                                                                                  PTy(CTy"PSR",
                                                                                                                                      bTy))),
                                                                                                                           qTy))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         CTy"PSR"),
                                                                                                                     MW(Close
                                                                                                                          (qVar"s",
                                                                                                                           Rupd
                                                                                                                             ("CPSR",
                                                                                                                              TP[qVar"s",
                                                                                                                                 Var("v",
                                                                                                                                     CTy"PSR")]))))),
                                                                                                               Close
                                                                                                                 (AVar
                                                                                                                    uTy,
                                                                                                                  MB(Call
                                                                                                                       ("HaveSecurityExt",
                                                                                                                        ATy(qTy,
                                                                                                                            PTy(bTy,
                                                                                                                                qTy)),
                                                                                                                        LU),
                                                                                                                     Close
                                                                                                                       (bVar"v",
                                                                                                                        MB(MB(MB(MB(MB(MU(Mop(Not,
                                                                                                                                              bVar"v"),
                                                                                                                                          qTy),
                                                                                                                                       Close
                                                                                                                                         (bVar"b",
                                                                                                                                          ITE(bVar"b",
                                                                                                                                              MU(LT,
                                                                                                                                                 qTy),
                                                                                                                                              Call
                                                                                                                                                ("HaveVirtExt",
                                                                                                                                                 ATy(qTy,
                                                                                                                                                     PTy(bTy,
                                                                                                                                                         qTy)),
                                                                                                                                                 LU)))),
                                                                                                                                    Close
                                                                                                                                      (bVar"b",
                                                                                                                                       ITE(bVar"b",
                                                                                                                                           MU(LT,
                                                                                                                                              qTy),
                                                                                                                                           MB(MR(Close
                                                                                                                                                   (qVar"s",
                                                                                                                                                    Dest
                                                                                                                                                      ("CP15",
                                                                                                                                                       CTy"CP15",
                                                                                                                                                       qVar"s"))),
                                                                                                                                              Close
                                                                                                                                                (Var("v",
                                                                                                                                                     CTy"CP15"),
                                                                                                                                                 MB(MB(MU(Dest
                                                                                                                                                            ("SCR",
                                                                                                                                                             CTy"SCR",
                                                                                                                                                             Var("v",
                                                                                                                                                                 CTy"CP15")),
                                                                                                                                                          qTy),
                                                                                                                                                       Close
                                                                                                                                                         (Var("v",
                                                                                                                                                              CTy"SCR"),
                                                                                                                                                          MU(Dest
                                                                                                                                                               ("NS",
                                                                                                                                                                bTy,
                                                                                                                                                                Var("v",
                                                                                                                                                                    CTy"SCR")),
                                                                                                                                                             qTy))),
                                                                                                                                                    Close
                                                                                                                                                      (bVar"v",
                                                                                                                                                       MU(Mop(Not,
                                                                                                                                                              bVar"v"),
                                                                                                                                                          qTy)))))))),
                                                                                                                                 Close
                                                                                                                                   (bVar"b",
                                                                                                                                    ITE(bVar"b",
                                                                                                                                        MU(LT,
                                                                                                                                           qTy),
                                                                                                                                        MB(MR(Close
                                                                                                                                                (qVar"s",
                                                                                                                                                 Dest
                                                                                                                                                   ("CP15",
                                                                                                                                                    CTy"CP15",
                                                                                                                                                    qVar"s"))),
                                                                                                                                           Close
                                                                                                                                             (Var("v",
                                                                                                                                                  CTy"CP15"),
                                                                                                                                              MB(MU(Dest
                                                                                                                                                      ("SCR",
                                                                                                                                                       CTy"SCR",
                                                                                                                                                       Var("v",
                                                                                                                                                           CTy"CP15")),
                                                                                                                                                    qTy),
                                                                                                                                                 Close
                                                                                                                                                   (Var("v",
                                                                                                                                                        CTy"SCR"),
                                                                                                                                                    MU(Dest
                                                                                                                                                         ("AW",
                                                                                                                                                          bTy,
                                                                                                                                                          Var("v",
                                                                                                                                                              CTy"SCR")),
                                                                                                                                                       qTy)))))))),
                                                                                                                              Close
                                                                                                                                (bVar"b",
                                                                                                                                 ITE(bVar"b",
                                                                                                                                     MB(MR(Close
                                                                                                                                             (qVar"s",
                                                                                                                                              Dest
                                                                                                                                                ("CPSR",
                                                                                                                                                 CTy"PSR",
                                                                                                                                                 qVar"s"))),
                                                                                                                                        Close
                                                                                                                                          (Var("v",
                                                                                                                                               CTy"PSR"),
                                                                                                                                           MB(MB(MU(TP[Var("v",
                                                                                                                                                           CTy"PSR"),
                                                                                                                                                       LT],
                                                                                                                                                    qTy),
                                                                                                                                                 Close
                                                                                                                                                   (Var("v",
                                                                                                                                                        PTy(CTy"PSR",
                                                                                                                                                            bTy)),
                                                                                                                                                    MU(Rupd
                                                                                                                                                         ("A",
                                                                                                                                                          Var("v",
                                                                                                                                                              PTy(CTy"PSR",
                                                                                                                                                                  bTy))),
                                                                                                                                                       qTy))),
                                                                                                                                              Close
                                                                                                                                                (Var("v",
                                                                                                                                                     CTy"PSR"),
                                                                                                                                                 MW(Close
                                                                                                                                                      (qVar"s",
                                                                                                                                                       Rupd
                                                                                                                                                         ("CPSR",
                                                                                                                                                          TP[qVar"s",
                                                                                                                                                             Var("v",
                                                                                                                                                                 CTy"PSR")]))))))),
                                                                                                                                     MU(LU,
                                                                                                                                        qTy)))),
                                                                                                                           Close
                                                                                                                             (AVar
                                                                                                                                uTy,
                                                                                                                              MB(MR(Close
                                                                                                                                      (qVar"s",
                                                                                                                                       Dest
                                                                                                                                         ("CPSR",
                                                                                                                                          CTy"PSR",
                                                                                                                                          qVar"s"))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                       CTy"PSR"),
                                                                                                                                                   LW(0,
                                                                                                                                                      8)],
                                                                                                                                                qTy),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    PTy(CTy"PSR",
                                                                                                                                                        F8)),
                                                                                                                                                MU(Rupd
                                                                                                                                                     ("IT",
                                                                                                                                                      Var("v",
                                                                                                                                                          PTy(CTy"PSR",
                                                                                                                                                              F8))),
                                                                                                                                                   qTy))),
                                                                                                                                          Close
                                                                                                                                            (Var("v",
                                                                                                                                                 CTy"PSR"),
                                                                                                                                             MW(Close
                                                                                                                                                  (qVar"s",
                                                                                                                                                   Rupd
                                                                                                                                                     ("CPSR",
                                                                                                                                                      TP[qVar"s",
                                                                                                                                                         Var("v",
                                                                                                                                                             CTy"PSR")]))))),
                                                                                                                                       Close
                                                                                                                                         (AVar
                                                                                                                                            uTy,
                                                                                                                                          MB(MR(Close
                                                                                                                                                  (qVar"s",
                                                                                                                                                   Dest
                                                                                                                                                     ("CPSR",
                                                                                                                                                      CTy"PSR",
                                                                                                                                                      qVar"s"))),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    CTy"PSR"),
                                                                                                                                                MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                                   CTy"PSR"),
                                                                                                                                                               LF],
                                                                                                                                                            qTy),
                                                                                                                                                         Close
                                                                                                                                                           (Var("v",
                                                                                                                                                                PTy(CTy"PSR",
                                                                                                                                                                    bTy)),
                                                                                                                                                            MU(Rupd
                                                                                                                                                                 ("J",
                                                                                                                                                                  Var("v",
                                                                                                                                                                      PTy(CTy"PSR",
                                                                                                                                                                          bTy))),
                                                                                                                                                               qTy))),
                                                                                                                                                      Close
                                                                                                                                                        (Var("v",
                                                                                                                                                             CTy"PSR"),
                                                                                                                                                         MW(Close
                                                                                                                                                              (qVar"s",
                                                                                                                                                               Rupd
                                                                                                                                                                 ("CPSR",
                                                                                                                                                                  TP[qVar"s",
                                                                                                                                                                     Var("v",
                                                                                                                                                                         CTy"PSR")]))))),
                                                                                                                                                   Close
                                                                                                                                                     (AVar
                                                                                                                                                        uTy,
                                                                                                                                                      MB(MR(Close
                                                                                                                                                              (qVar"s",
                                                                                                                                                               Dest
                                                                                                                                                                 ("CPSR",
                                                                                                                                                                  CTy"PSR",
                                                                                                                                                                  qVar"s"))),
                                                                                                                                                         Close
                                                                                                                                                           (Var("v",
                                                                                                                                                                CTy"PSR"),
                                                                                                                                                            MB(MB(MB(MB(MR(Close
                                                                                                                                                                             (qVar"s",
                                                                                                                                                                              Dest
                                                                                                                                                                                ("CP15",
                                                                                                                                                                                 CTy"CP15",
                                                                                                                                                                                 qVar"s"))),
                                                                                                                                                                        Close
                                                                                                                                                                          (Var("v0",
                                                                                                                                                                               CTy"CP15"),
                                                                                                                                                                           MB(MB(MU(Dest
                                                                                                                                                                                      ("SCTLR",
                                                                                                                                                                                       CTy"SCTLR",
                                                                                                                                                                                       Var("v0",
                                                                                                                                                                                           CTy"CP15")),
                                                                                                                                                                                    qTy),
                                                                                                                                                                                 Close
                                                                                                                                                                                   (Var("v",
                                                                                                                                                                                        CTy"SCTLR"),
                                                                                                                                                                                    MU(Dest
                                                                                                                                                                                         ("TE",
                                                                                                                                                                                          bTy,
                                                                                                                                                                                          Var("v",
                                                                                                                                                                                              CTy"SCTLR")),
                                                                                                                                                                                       qTy))),
                                                                                                                                                                              Close
                                                                                                                                                                                (bVar"v0",
                                                                                                                                                                                 MU(TP[Var("v",
                                                                                                                                                                                           CTy"PSR"),
                                                                                                                                                                                       bVar"v0"],
                                                                                                                                                                                    qTy))))),
                                                                                                                                                                     Close
                                                                                                                                                                       (Var("v",
                                                                                                                                                                            PTy(CTy"PSR",
                                                                                                                                                                                bTy)),
                                                                                                                                                                        MU(Rupd
                                                                                                                                                                             ("T",
                                                                                                                                                                              Var("v",
                                                                                                                                                                                  PTy(CTy"PSR",
                                                                                                                                                                                      bTy))),
                                                                                                                                                                           qTy))),
                                                                                                                                                                  Close
                                                                                                                                                                    (Var("v",
                                                                                                                                                                         CTy"PSR"),
                                                                                                                                                                     MW(Close
                                                                                                                                                                          (qVar"s",
                                                                                                                                                                           Rupd
                                                                                                                                                                             ("CPSR",
                                                                                                                                                                              TP[qVar"s",
                                                                                                                                                                                 Var("v",
                                                                                                                                                                                     CTy"PSR")]))))),
                                                                                                                                                               Close
                                                                                                                                                                 (AVar
                                                                                                                                                                    uTy,
                                                                                                                                                                  MB(MR(Close
                                                                                                                                                                          (qVar"s",
                                                                                                                                                                           Dest
                                                                                                                                                                             ("CPSR",
                                                                                                                                                                              CTy"PSR",
                                                                                                                                                                              qVar"s"))),
                                                                                                                                                                     Close
                                                                                                                                                                       (Var("v",
                                                                                                                                                                            CTy"PSR"),
                                                                                                                                                                        MB(MB(MB(MB(MR(Close
                                                                                                                                                                                         (qVar"s",
                                                                                                                                                                                          Dest
                                                                                                                                                                                            ("CP15",
                                                                                                                                                                                             CTy"CP15",
                                                                                                                                                                                             qVar"s"))),
                                                                                                                                                                                    Close
                                                                                                                                                                                      (Var("v0",
                                                                                                                                                                                           CTy"CP15"),
                                                                                                                                                                                       MB(MB(MU(Dest
                                                                                                                                                                                                  ("SCTLR",
                                                                                                                                                                                                   CTy"SCTLR",
                                                                                                                                                                                                   Var("v0",
                                                                                                                                                                                                       CTy"CP15")),
                                                                                                                                                                                                qTy),
                                                                                                                                                                                             Close
                                                                                                                                                                                               (Var("v",
                                                                                                                                                                                                    CTy"SCTLR"),
                                                                                                                                                                                                MU(Dest
                                                                                                                                                                                                     ("EE",
                                                                                                                                                                                                      bTy,
                                                                                                                                                                                                      Var("v",
                                                                                                                                                                                                          CTy"SCTLR")),
                                                                                                                                                                                                   qTy))),
                                                                                                                                                                                          Close
                                                                                                                                                                                            (bVar"v0",
                                                                                                                                                                                             MU(TP[Var("v",
                                                                                                                                                                                                       CTy"PSR"),
                                                                                                                                                                                                   bVar"v0"],
                                                                                                                                                                                                qTy))))),
                                                                                                                                                                                 Close
                                                                                                                                                                                   (Var("v",
                                                                                                                                                                                        PTy(CTy"PSR",
                                                                                                                                                                                            bTy)),
                                                                                                                                                                                    MU(Rupd
                                                                                                                                                                                         ("E",
                                                                                                                                                                                          Var("v",
                                                                                                                                                                                              PTy(CTy"PSR",
                                                                                                                                                                                                  bTy))),
                                                                                                                                                                                       qTy))),
                                                                                                                                                                              Close
                                                                                                                                                                                (Var("v",
                                                                                                                                                                                     CTy"PSR"),
                                                                                                                                                                                 MW(Close
                                                                                                                                                                                      (qVar"s",
                                                                                                                                                                                       Rupd
                                                                                                                                                                                         ("CPSR",
                                                                                                                                                                                          TP[qVar"s",
                                                                                                                                                                                             Var("v",
                                                                                                                                                                                                 CTy"PSR")]))))),
                                                                                                                                                                           Close
                                                                                                                                                                             (AVar
                                                                                                                                                                                uTy,
                                                                                                                                                                              MB(Call
                                                                                                                                                                                   ("ExcVectorBase",
                                                                                                                                                                                    ATy(qTy,
                                                                                                                                                                                        PTy(F32,
                                                                                                                                                                                            qTy)),
                                                                                                                                                                                    LU),
                                                                                                                                                                                 Close
                                                                                                                                                                                   (Var("v",
                                                                                                                                                                                        F32),
                                                                                                                                                                                    MB(MU(Bop(Add,
                                                                                                                                                                                              Var("v",
                                                                                                                                                                                                  F32),
                                                                                                                                                                                              Var("vect_offset",
                                                                                                                                                                                                  F32)),
                                                                                                                                                                                          qTy),
                                                                                                                                                                                       Close
                                                                                                                                                                                         (Var("v",
                                                                                                                                                                                              F32),
                                                                                                                                                                                          Call
                                                                                                                                                                                            ("BranchTo",
                                                                                                                                                                                             ATy(qTy,
                                                                                                                                                                                                 PTy(uTy,
                                                                                                                                                                                                     qTy)),
                                                                                                                                                                                             Var("v",
                                                                                                                                                                                                 F32))))))))))))))))))))))))))))))))))))))))))),
                                                              Close
                                                                (AVar uTy,
                                                                 MW(Close
                                                                      (qVar"s",
                                                                       Rupd
                                                                         ("data_abort",
                                                                          TP[qVar"s",
                                                                             LT]))))))))))))))))))))))))
;
val TakePrefetchAbortException_def = Def
  ("TakePrefetchAbortException",AVar uTy,
   MB(MW(Close(qVar"s",Rupd("data_abort",TP[qVar"s",LF]))),
      Close
        (AVar uTy,
         MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
            Close
              (Var("v",CTy"PSR"),
               MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
                     Close
                       (bVar"b",
                        ITE(bVar"b",Const("PC",ATy(qTy,PTy(F32,qTy))),
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
                  Close
                    (Var("new_lr_value",F32),
                     MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                        Close
                          (Var("new_spsr_value",CTy"PSR"),
                           Let(Var("vect_offset",F32),LW(12,32),
                               Let(Var("preferred_exceptn_return",F32),
                                   Bop(Sub,Var("new_lr_value",F32),
                                       LW(4,32)),
                                   MB(Call
                                        ("HaveSecurityExt",
                                         ATy(qTy,PTy(bTy,qTy)),LU),
                                      Close
                                        (bVar"v",
                                         MB(MB(ITE(bVar"v",
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("CP15",
                                                               CTy"CP15",
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",CTy"CP15"),
                                                         MB(MU(Dest
                                                                 ("SCR",
                                                                  CTy"SCR",
                                                                  Var("v",
                                                                      CTy"CP15")),
                                                               qTy),
                                                            Close
                                                              (Var("v",
                                                                   CTy"SCR"),
                                                               MU(Dest
                                                                    ("EA",
                                                                     bTy,
                                                                     Var("v",
                                                                         CTy"SCR")),
                                                                  qTy))))),
                                                   MU(LF,qTy)),
                                               Close
                                                 (bVar"b",
                                                  ITE(bVar"b",
                                                      Call
                                                        ("IsExternalAbort",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         LU),MU(LF,qTy)))),
                                            Close
                                              (bVar"route_to_monitor",
                                               MB(Call
                                                    ("HaveVirtExt",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v",
                                                     MB(MB(MB(ITE(bVar"v",
                                                                  Call
                                                                    ("HaveSecurityExt",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  MU(LF,
                                                                     qTy)),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(MR(Close
                                                                             (qVar"s",
                                                                              Dest
                                                                                ("CP15",
                                                                                 CTy"CP15",
                                                                                 qVar"s"))),
                                                                        Close
                                                                          (Var("v",
                                                                               CTy"CP15"),
                                                                           MB(MU(Dest
                                                                                   ("SCR",
                                                                                    CTy"SCR",
                                                                                    Var("v",
                                                                                        CTy"CP15")),
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"SCR"),
                                                                                 MU(Dest
                                                                                      ("NS",
                                                                                       bTy,
                                                                                       Var("v",
                                                                                           CTy"SCR")),
                                                                                    qTy))))),
                                                                     MU(LF,
                                                                        qTy)))),
                                                           Close
                                                             (bVar"b",
                                                              ITE(bVar"b",
                                                                  MB(MR(Close
                                                                          (qVar"s",
                                                                           Dest
                                                                             ("CPSR",
                                                                              CTy"PSR",
                                                                              qVar"s"))),
                                                                     Close
                                                                       (Var("v",
                                                                            CTy"PSR"),
                                                                        MB(MU(Dest
                                                                                ("M",
                                                                                 FTy 5,
                                                                                 Var("v",
                                                                                     CTy"PSR")),
                                                                              qTy),
                                                                           Close
                                                                             (Var("v",
                                                                                  FTy 5),
                                                                              MU(EQ(Var("v",
                                                                                        FTy 5),
                                                                                    LW(26,
                                                                                       5)),
                                                                                 qTy))))),
                                                                  MU(LF,
                                                                     qTy)))),
                                                        Close
                                                          (bVar"take_to_hyp",
                                                           MB(ITB([(bVar"route_to_monitor",
                                                                    MB(MR(Close
                                                                            (qVar"s",
                                                                             Dest
                                                                               ("CPSR",
                                                                                CTy"PSR",
                                                                                qVar"s"))),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"PSR"),
                                                                          MB(MB(MB(MU(Dest
                                                                                        ("M",
                                                                                         FTy 5,
                                                                                         Var("v",
                                                                                             CTy"PSR")),
                                                                                      qTy),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          FTy 5),
                                                                                      MU(EQ(Var("v",
                                                                                                FTy 5),
                                                                                            LW(22,
                                                                                               5)),
                                                                                         qTy))),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   ITE(bVar"b",
                                                                                       MB(MR(Close
                                                                                               (qVar"s",
                                                                                                Dest
                                                                                                  ("CP15",
                                                                                                   CTy"CP15",
                                                                                                   qVar"s"))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 CTy"CP15"),
                                                                                             MB(MU(Dest
                                                                                                     ("SCR",
                                                                                                      CTy"SCR",
                                                                                                      Var("v",
                                                                                                          CTy"CP15")),
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (Var("x0",
                                                                                                       CTy"SCR"),
                                                                                                   MB(MR(Close
                                                                                                           (qVar"s",
                                                                                                            Dest
                                                                                                              ("CP15",
                                                                                                               CTy"CP15",
                                                                                                               qVar"s"))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             CTy"CP15"),
                                                                                                         MB(MB(MU(TP[Var("v",
                                                                                                                         CTy"CP15"),
                                                                                                                     Rupd
                                                                                                                       ("NS",
                                                                                                                        TP[Var("x0",
                                                                                                                               CTy"SCR"),
                                                                                                                           LF])],
                                                                                                                  qTy),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      PTy(CTy"CP15",
                                                                                                                          CTy"SCR")),
                                                                                                                  MU(Rupd
                                                                                                                       ("SCR",
                                                                                                                        Var("v",
                                                                                                                            PTy(CTy"CP15",
                                                                                                                                CTy"SCR"))),
                                                                                                                     qTy))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   CTy"CP15"),
                                                                                                               MW(Close
                                                                                                                    (qVar"s",
                                                                                                                     Rupd
                                                                                                                       ("CP15",
                                                                                                                        TP[qVar"s",
                                                                                                                           Var("v",
                                                                                                                               CTy"CP15")]))))))))))),
                                                                                       MU(LU,
                                                                                          qTy)))),
                                                                             Close
                                                                               (AVar
                                                                                  uTy,
                                                                                Call
                                                                                  ("EnterMonitorMode",
                                                                                   ATy(qTy,
                                                                                       PTy(uTy,
                                                                                           qTy)),
                                                                                   TP[Var("new_spsr_value",
                                                                                          CTy"PSR"),
                                                                                      Var("new_lr_value",
                                                                                          F32),
                                                                                      Var("vect_offset",
                                                                                          F32)])))))),
                                                                   (bVar"take_to_hyp",
                                                                    Call
                                                                      ("EnterHypMode",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("new_spsr_value",
                                                                              CTy"PSR"),
                                                                          Var("preferred_exceptn_return",
                                                                              F32),
                                                                          Var("vect_offset",
                                                                              F32)])),
                                                                   (LF,
                                                                    Call
                                                                      ("EnterHypMode",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("new_spsr_value",
                                                                              CTy"PSR"),
                                                                          Var("preferred_exceptn_return",
                                                                              F32),
                                                                          LW(20,
                                                                             32)]))],
                                                                  MB(Call
                                                                       ("HaveSecurityExt",
                                                                        ATy(qTy,
                                                                            PTy(bTy,
                                                                                qTy)),
                                                                        LU),
                                                                     Close
                                                                       (bVar"v",
                                                                        MB(MB(ITE(bVar"v",
                                                                                  MB(MR(Close
                                                                                          (qVar"s",
                                                                                           Dest
                                                                                             ("CPSR",
                                                                                              CTy"PSR",
                                                                                              qVar"s"))),
                                                                                     Close
                                                                                       (Var("v",
                                                                                            CTy"PSR"),
                                                                                        MB(MU(Dest
                                                                                                ("M",
                                                                                                 FTy 5,
                                                                                                 Var("v",
                                                                                                     CTy"PSR")),
                                                                                              qTy),
                                                                                           Close
                                                                                             (Var("v",
                                                                                                  FTy 5),
                                                                                              MU(EQ(Var("v",
                                                                                                        FTy 5),
                                                                                                    LW(22,
                                                                                                       5)),
                                                                                                 qTy))))),
                                                                                  MU(LF,
                                                                                     qTy)),
                                                                              Close
                                                                                (bVar"b",
                                                                                 ITE(bVar"b",
                                                                                     MB(MR(Close
                                                                                             (qVar"s",
                                                                                              Dest
                                                                                                ("CP15",
                                                                                                 CTy"CP15",
                                                                                                 qVar"s"))),
                                                                                        Close
                                                                                          (Var("v",
                                                                                               CTy"CP15"),
                                                                                           MB(MU(Dest
                                                                                                   ("SCR",
                                                                                                    CTy"SCR",
                                                                                                    Var("v",
                                                                                                        CTy"CP15")),
                                                                                                 qTy),
                                                                                              Close
                                                                                                (Var("x0",
                                                                                                     CTy"SCR"),
                                                                                                 MB(MR(Close
                                                                                                         (qVar"s",
                                                                                                          Dest
                                                                                                            ("CP15",
                                                                                                             CTy"CP15",
                                                                                                             qVar"s"))),
                                                                                                    Close
                                                                                                      (Var("v",
                                                                                                           CTy"CP15"),
                                                                                                       MB(MB(MU(TP[Var("v",
                                                                                                                       CTy"CP15"),
                                                                                                                   Rupd
                                                                                                                     ("NS",
                                                                                                                      TP[Var("x0",
                                                                                                                             CTy"SCR"),
                                                                                                                         LF])],
                                                                                                                qTy),
                                                                                                             Close
                                                                                                               (Var("v",
                                                                                                                    PTy(CTy"CP15",
                                                                                                                        CTy"SCR")),
                                                                                                                MU(Rupd
                                                                                                                     ("SCR",
                                                                                                                      Var("v",
                                                                                                                          PTy(CTy"CP15",
                                                                                                                              CTy"SCR"))),
                                                                                                                   qTy))),
                                                                                                          Close
                                                                                                            (Var("v",
                                                                                                                 CTy"CP15"),
                                                                                                             MW(Close
                                                                                                                  (qVar"s",
                                                                                                                   Rupd
                                                                                                                     ("CP15",
                                                                                                                      TP[qVar"s",
                                                                                                                         Var("v",
                                                                                                                             CTy"CP15")]))))))))))),
                                                                                     MU(LU,
                                                                                        qTy)))),
                                                                           Close
                                                                             (AVar
                                                                                uTy,
                                                                              MB(MR(Close
                                                                                      (qVar"s",
                                                                                       Dest
                                                                                         ("CPSR",
                                                                                          CTy"PSR",
                                                                                          qVar"s"))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"PSR"),
                                                                                    MB(MB(MB(MU(TP[Var("v",
                                                                                                       CTy"PSR"),
                                                                                                   LW(23,
                                                                                                      5)],
                                                                                                qTy),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    PTy(CTy"PSR",
                                                                                                        FTy 5)),
                                                                                                MU(Rupd
                                                                                                     ("M",
                                                                                                      Var("v",
                                                                                                          PTy(CTy"PSR",
                                                                                                              FTy 5))),
                                                                                                   qTy))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 CTy"PSR"),
                                                                                             MW(Close
                                                                                                  (qVar"s",
                                                                                                   Rupd
                                                                                                     ("CPSR",
                                                                                                      TP[qVar"s",
                                                                                                         Var("v",
                                                                                                             CTy"PSR")]))))),
                                                                                       Close
                                                                                         (AVar
                                                                                            uTy,
                                                                                          MB(Call
                                                                                               ("write'SPSR",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                Var("new_spsr_value",
                                                                                                    CTy"PSR")),
                                                                                             Close
                                                                                               (AVar
                                                                                                  uTy,
                                                                                                MB(Call
                                                                                                     ("write'R",
                                                                                                      ATy(qTy,
                                                                                                          PTy(uTy,
                                                                                                              qTy)),
                                                                                                      TP[Var("new_lr_value",
                                                                                                             F32),
                                                                                                         LW(14,
                                                                                                            4)]),
                                                                                                   Close
                                                                                                     (AVar
                                                                                                        uTy,
                                                                                                      MB(MR(Close
                                                                                                              (qVar"s",
                                                                                                               Dest
                                                                                                                 ("CPSR",
                                                                                                                  CTy"PSR",
                                                                                                                  qVar"s"))),
                                                                                                         Close
                                                                                                           (Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            MB(MB(MB(MU(TP[Var("v",
                                                                                                                               CTy"PSR"),
                                                                                                                           LT],
                                                                                                                        qTy),
                                                                                                                     Close
                                                                                                                       (Var("v",
                                                                                                                            PTy(CTy"PSR",
                                                                                                                                bTy)),
                                                                                                                        MU(Rupd
                                                                                                                             ("I",
                                                                                                                              Var("v",
                                                                                                                                  PTy(CTy"PSR",
                                                                                                                                      bTy))),
                                                                                                                           qTy))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         CTy"PSR"),
                                                                                                                     MW(Close
                                                                                                                          (qVar"s",
                                                                                                                           Rupd
                                                                                                                             ("CPSR",
                                                                                                                              TP[qVar"s",
                                                                                                                                 Var("v",
                                                                                                                                     CTy"PSR")]))))),
                                                                                                               Close
                                                                                                                 (AVar
                                                                                                                    uTy,
                                                                                                                  MB(Call
                                                                                                                       ("HaveSecurityExt",
                                                                                                                        ATy(qTy,
                                                                                                                            PTy(bTy,
                                                                                                                                qTy)),
                                                                                                                        LU),
                                                                                                                     Close
                                                                                                                       (bVar"v",
                                                                                                                        MB(MB(MB(MB(MB(MU(Mop(Not,
                                                                                                                                              bVar"v"),
                                                                                                                                          qTy),
                                                                                                                                       Close
                                                                                                                                         (bVar"b",
                                                                                                                                          ITE(bVar"b",
                                                                                                                                              MU(LT,
                                                                                                                                                 qTy),
                                                                                                                                              Call
                                                                                                                                                ("HaveVirtExt",
                                                                                                                                                 ATy(qTy,
                                                                                                                                                     PTy(bTy,
                                                                                                                                                         qTy)),
                                                                                                                                                 LU)))),
                                                                                                                                    Close
                                                                                                                                      (bVar"b",
                                                                                                                                       ITE(bVar"b",
                                                                                                                                           MU(LT,
                                                                                                                                              qTy),
                                                                                                                                           MB(MR(Close
                                                                                                                                                   (qVar"s",
                                                                                                                                                    Dest
                                                                                                                                                      ("CP15",
                                                                                                                                                       CTy"CP15",
                                                                                                                                                       qVar"s"))),
                                                                                                                                              Close
                                                                                                                                                (Var("v",
                                                                                                                                                     CTy"CP15"),
                                                                                                                                                 MB(MB(MU(Dest
                                                                                                                                                            ("SCR",
                                                                                                                                                             CTy"SCR",
                                                                                                                                                             Var("v",
                                                                                                                                                                 CTy"CP15")),
                                                                                                                                                          qTy),
                                                                                                                                                       Close
                                                                                                                                                         (Var("v",
                                                                                                                                                              CTy"SCR"),
                                                                                                                                                          MU(Dest
                                                                                                                                                               ("NS",
                                                                                                                                                                bTy,
                                                                                                                                                                Var("v",
                                                                                                                                                                    CTy"SCR")),
                                                                                                                                                             qTy))),
                                                                                                                                                    Close
                                                                                                                                                      (bVar"v",
                                                                                                                                                       MU(Mop(Not,
                                                                                                                                                              bVar"v"),
                                                                                                                                                          qTy)))))))),
                                                                                                                                 Close
                                                                                                                                   (bVar"b",
                                                                                                                                    ITE(bVar"b",
                                                                                                                                        MU(LT,
                                                                                                                                           qTy),
                                                                                                                                        MB(MR(Close
                                                                                                                                                (qVar"s",
                                                                                                                                                 Dest
                                                                                                                                                   ("CP15",
                                                                                                                                                    CTy"CP15",
                                                                                                                                                    qVar"s"))),
                                                                                                                                           Close
                                                                                                                                             (Var("v",
                                                                                                                                                  CTy"CP15"),
                                                                                                                                              MB(MU(Dest
                                                                                                                                                      ("SCR",
                                                                                                                                                       CTy"SCR",
                                                                                                                                                       Var("v",
                                                                                                                                                           CTy"CP15")),
                                                                                                                                                    qTy),
                                                                                                                                                 Close
                                                                                                                                                   (Var("v",
                                                                                                                                                        CTy"SCR"),
                                                                                                                                                    MU(Dest
                                                                                                                                                         ("AW",
                                                                                                                                                          bTy,
                                                                                                                                                          Var("v",
                                                                                                                                                              CTy"SCR")),
                                                                                                                                                       qTy)))))))),
                                                                                                                              Close
                                                                                                                                (bVar"b",
                                                                                                                                 ITE(bVar"b",
                                                                                                                                     MB(MR(Close
                                                                                                                                             (qVar"s",
                                                                                                                                              Dest
                                                                                                                                                ("CPSR",
                                                                                                                                                 CTy"PSR",
                                                                                                                                                 qVar"s"))),
                                                                                                                                        Close
                                                                                                                                          (Var("v",
                                                                                                                                               CTy"PSR"),
                                                                                                                                           MB(MB(MU(TP[Var("v",
                                                                                                                                                           CTy"PSR"),
                                                                                                                                                       LT],
                                                                                                                                                    qTy),
                                                                                                                                                 Close
                                                                                                                                                   (Var("v",
                                                                                                                                                        PTy(CTy"PSR",
                                                                                                                                                            bTy)),
                                                                                                                                                    MU(Rupd
                                                                                                                                                         ("A",
                                                                                                                                                          Var("v",
                                                                                                                                                              PTy(CTy"PSR",
                                                                                                                                                                  bTy))),
                                                                                                                                                       qTy))),
                                                                                                                                              Close
                                                                                                                                                (Var("v",
                                                                                                                                                     CTy"PSR"),
                                                                                                                                                 MW(Close
                                                                                                                                                      (qVar"s",
                                                                                                                                                       Rupd
                                                                                                                                                         ("CPSR",
                                                                                                                                                          TP[qVar"s",
                                                                                                                                                             Var("v",
                                                                                                                                                                 CTy"PSR")]))))))),
                                                                                                                                     MU(LU,
                                                                                                                                        qTy)))),
                                                                                                                           Close
                                                                                                                             (AVar
                                                                                                                                uTy,
                                                                                                                              MB(MR(Close
                                                                                                                                      (qVar"s",
                                                                                                                                       Dest
                                                                                                                                         ("CPSR",
                                                                                                                                          CTy"PSR",
                                                                                                                                          qVar"s"))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                       CTy"PSR"),
                                                                                                                                                   LW(0,
                                                                                                                                                      8)],
                                                                                                                                                qTy),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    PTy(CTy"PSR",
                                                                                                                                                        F8)),
                                                                                                                                                MU(Rupd
                                                                                                                                                     ("IT",
                                                                                                                                                      Var("v",
                                                                                                                                                          PTy(CTy"PSR",
                                                                                                                                                              F8))),
                                                                                                                                                   qTy))),
                                                                                                                                          Close
                                                                                                                                            (Var("v",
                                                                                                                                                 CTy"PSR"),
                                                                                                                                             MW(Close
                                                                                                                                                  (qVar"s",
                                                                                                                                                   Rupd
                                                                                                                                                     ("CPSR",
                                                                                                                                                      TP[qVar"s",
                                                                                                                                                         Var("v",
                                                                                                                                                             CTy"PSR")]))))),
                                                                                                                                       Close
                                                                                                                                         (AVar
                                                                                                                                            uTy,
                                                                                                                                          MB(MR(Close
                                                                                                                                                  (qVar"s",
                                                                                                                                                   Dest
                                                                                                                                                     ("CPSR",
                                                                                                                                                      CTy"PSR",
                                                                                                                                                      qVar"s"))),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    CTy"PSR"),
                                                                                                                                                MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                                   CTy"PSR"),
                                                                                                                                                               LF],
                                                                                                                                                            qTy),
                                                                                                                                                         Close
                                                                                                                                                           (Var("v",
                                                                                                                                                                PTy(CTy"PSR",
                                                                                                                                                                    bTy)),
                                                                                                                                                            MU(Rupd
                                                                                                                                                                 ("J",
                                                                                                                                                                  Var("v",
                                                                                                                                                                      PTy(CTy"PSR",
                                                                                                                                                                          bTy))),
                                                                                                                                                               qTy))),
                                                                                                                                                      Close
                                                                                                                                                        (Var("v",
                                                                                                                                                             CTy"PSR"),
                                                                                                                                                         MW(Close
                                                                                                                                                              (qVar"s",
                                                                                                                                                               Rupd
                                                                                                                                                                 ("CPSR",
                                                                                                                                                                  TP[qVar"s",
                                                                                                                                                                     Var("v",
                                                                                                                                                                         CTy"PSR")]))))),
                                                                                                                                                   Close
                                                                                                                                                     (AVar
                                                                                                                                                        uTy,
                                                                                                                                                      MB(MR(Close
                                                                                                                                                              (qVar"s",
                                                                                                                                                               Dest
                                                                                                                                                                 ("CPSR",
                                                                                                                                                                  CTy"PSR",
                                                                                                                                                                  qVar"s"))),
                                                                                                                                                         Close
                                                                                                                                                           (Var("v",
                                                                                                                                                                CTy"PSR"),
                                                                                                                                                            MB(MB(MB(MB(MR(Close
                                                                                                                                                                             (qVar"s",
                                                                                                                                                                              Dest
                                                                                                                                                                                ("CP15",
                                                                                                                                                                                 CTy"CP15",
                                                                                                                                                                                 qVar"s"))),
                                                                                                                                                                        Close
                                                                                                                                                                          (Var("v0",
                                                                                                                                                                               CTy"CP15"),
                                                                                                                                                                           MB(MB(MU(Dest
                                                                                                                                                                                      ("SCTLR",
                                                                                                                                                                                       CTy"SCTLR",
                                                                                                                                                                                       Var("v0",
                                                                                                                                                                                           CTy"CP15")),
                                                                                                                                                                                    qTy),
                                                                                                                                                                                 Close
                                                                                                                                                                                   (Var("v",
                                                                                                                                                                                        CTy"SCTLR"),
                                                                                                                                                                                    MU(Dest
                                                                                                                                                                                         ("TE",
                                                                                                                                                                                          bTy,
                                                                                                                                                                                          Var("v",
                                                                                                                                                                                              CTy"SCTLR")),
                                                                                                                                                                                       qTy))),
                                                                                                                                                                              Close
                                                                                                                                                                                (bVar"v0",
                                                                                                                                                                                 MU(TP[Var("v",
                                                                                                                                                                                           CTy"PSR"),
                                                                                                                                                                                       bVar"v0"],
                                                                                                                                                                                    qTy))))),
                                                                                                                                                                     Close
                                                                                                                                                                       (Var("v",
                                                                                                                                                                            PTy(CTy"PSR",
                                                                                                                                                                                bTy)),
                                                                                                                                                                        MU(Rupd
                                                                                                                                                                             ("T",
                                                                                                                                                                              Var("v",
                                                                                                                                                                                  PTy(CTy"PSR",
                                                                                                                                                                                      bTy))),
                                                                                                                                                                           qTy))),
                                                                                                                                                                  Close
                                                                                                                                                                    (Var("v",
                                                                                                                                                                         CTy"PSR"),
                                                                                                                                                                     MW(Close
                                                                                                                                                                          (qVar"s",
                                                                                                                                                                           Rupd
                                                                                                                                                                             ("CPSR",
                                                                                                                                                                              TP[qVar"s",
                                                                                                                                                                                 Var("v",
                                                                                                                                                                                     CTy"PSR")]))))),
                                                                                                                                                               Close
                                                                                                                                                                 (AVar
                                                                                                                                                                    uTy,
                                                                                                                                                                  MB(MR(Close
                                                                                                                                                                          (qVar"s",
                                                                                                                                                                           Dest
                                                                                                                                                                             ("CPSR",
                                                                                                                                                                              CTy"PSR",
                                                                                                                                                                              qVar"s"))),
                                                                                                                                                                     Close
                                                                                                                                                                       (Var("v",
                                                                                                                                                                            CTy"PSR"),
                                                                                                                                                                        MB(MB(MB(MB(MR(Close
                                                                                                                                                                                         (qVar"s",
                                                                                                                                                                                          Dest
                                                                                                                                                                                            ("CP15",
                                                                                                                                                                                             CTy"CP15",
                                                                                                                                                                                             qVar"s"))),
                                                                                                                                                                                    Close
                                                                                                                                                                                      (Var("v0",
                                                                                                                                                                                           CTy"CP15"),
                                                                                                                                                                                       MB(MB(MU(Dest
                                                                                                                                                                                                  ("SCTLR",
                                                                                                                                                                                                   CTy"SCTLR",
                                                                                                                                                                                                   Var("v0",
                                                                                                                                                                                                       CTy"CP15")),
                                                                                                                                                                                                qTy),
                                                                                                                                                                                             Close
                                                                                                                                                                                               (Var("v",
                                                                                                                                                                                                    CTy"SCTLR"),
                                                                                                                                                                                                MU(Dest
                                                                                                                                                                                                     ("EE",
                                                                                                                                                                                                      bTy,
                                                                                                                                                                                                      Var("v",
                                                                                                                                                                                                          CTy"SCTLR")),
                                                                                                                                                                                                   qTy))),
                                                                                                                                                                                          Close
                                                                                                                                                                                            (bVar"v0",
                                                                                                                                                                                             MU(TP[Var("v",
                                                                                                                                                                                                       CTy"PSR"),
                                                                                                                                                                                                   bVar"v0"],
                                                                                                                                                                                                qTy))))),
                                                                                                                                                                                 Close
                                                                                                                                                                                   (Var("v",
                                                                                                                                                                                        PTy(CTy"PSR",
                                                                                                                                                                                            bTy)),
                                                                                                                                                                                    MU(Rupd
                                                                                                                                                                                         ("E",
                                                                                                                                                                                          Var("v",
                                                                                                                                                                                              PTy(CTy"PSR",
                                                                                                                                                                                                  bTy))),
                                                                                                                                                                                       qTy))),
                                                                                                                                                                              Close
                                                                                                                                                                                (Var("v",
                                                                                                                                                                                     CTy"PSR"),
                                                                                                                                                                                 MW(Close
                                                                                                                                                                                      (qVar"s",
                                                                                                                                                                                       Rupd
                                                                                                                                                                                         ("CPSR",
                                                                                                                                                                                          TP[qVar"s",
                                                                                                                                                                                             Var("v",
                                                                                                                                                                                                 CTy"PSR")]))))),
                                                                                                                                                                           Close
                                                                                                                                                                             (AVar
                                                                                                                                                                                uTy,
                                                                                                                                                                              MB(Call
                                                                                                                                                                                   ("ExcVectorBase",
                                                                                                                                                                                    ATy(qTy,
                                                                                                                                                                                        PTy(F32,
                                                                                                                                                                                            qTy)),
                                                                                                                                                                                    LU),
                                                                                                                                                                                 Close
                                                                                                                                                                                   (Var("v",
                                                                                                                                                                                        F32),
                                                                                                                                                                                    MB(MU(Bop(Add,
                                                                                                                                                                                              Var("v",
                                                                                                                                                                                                  F32),
                                                                                                                                                                                              Var("vect_offset",
                                                                                                                                                                                                  F32)),
                                                                                                                                                                                          qTy),
                                                                                                                                                                                       Close
                                                                                                                                                                                         (Var("v",
                                                                                                                                                                                              F32),
                                                                                                                                                                                          Call
                                                                                                                                                                                            ("BranchTo",
                                                                                                                                                                                             ATy(qTy,
                                                                                                                                                                                                 PTy(uTy,
                                                                                                                                                                                                     qTy)),
                                                                                                                                                                                             Var("v",
                                                                                                                                                                                                 F32))))))))))))))))))))))))))))))))))))))))))),
                                                              Close
                                                                (AVar uTy,
                                                                 MW(Close
                                                                      (qVar"s",
                                                                       Rupd
                                                                         ("data_abort",
                                                                          TP[qVar"s",
                                                                             LT]))))))))))))))))))))))))
;
val TakePhysicalIRQException_def = Def
  ("TakePhysicalIRQException",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",Const("PC",ATy(qTy,PTy(F32,qTy))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
            Close
              (Var("new_lr_value",F32),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("new_spsr_value",CTy"PSR"),
                     Let(Var("vect_offset",F32),LW(24,32),
                         MB(Call
                              ("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
                            Close
                              (bVar"v",
                               MB(ITE(bVar"v",
                                      MB(MR(Close
                                              (qVar"s",
                                               Dest
                                                 ("CP15",CTy"CP15",qVar"s"))),
                                         Close
                                           (Var("v",CTy"CP15"),
                                            MB(MU(Dest
                                                    ("SCR",CTy"SCR",
                                                     Var("v",CTy"CP15")),
                                                  qTy),
                                               Close
                                                 (Var("v",CTy"SCR"),
                                                  MU(Dest
                                                       ("IRQ",bTy,
                                                        Var("v",CTy"SCR")),
                                                     qTy))))),MU(LF,qTy)),
                                  Close
                                    (bVar"route_to_monitor",
                                     MB(Call
                                          ("HaveVirtExt",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MB(MB(MB(ITE(bVar"v",
                                                              Call
                                                                ("HaveSecurityExt",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              MU(LF,qTy)),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(MR(Close
                                                                         (qVar"s",
                                                                          Dest
                                                                            ("CP15",
                                                                             CTy"CP15",
                                                                             qVar"s"))),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"CP15"),
                                                                       MB(MB(MU(Dest
                                                                                  ("SCR",
                                                                                   CTy"SCR",
                                                                                   Var("v",
                                                                                       CTy"CP15")),
                                                                                qTy),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"SCR"),
                                                                                MU(Dest
                                                                                     ("IRQ",
                                                                                      bTy,
                                                                                      Var("v",
                                                                                          CTy"SCR")),
                                                                                   qTy))),
                                                                          Close
                                                                            (bVar"v",
                                                                             MU(Mop(Not,
                                                                                    bVar"v"),
                                                                                qTy))))),
                                                                 MU(LF,qTy)))),
                                                       Close
                                                         (bVar"b",
                                                          ITE(bVar"b",
                                                              MB(MR(Close
                                                                      (qVar"s",
                                                                       Dest
                                                                         ("CP15",
                                                                          CTy"CP15",
                                                                          qVar"s"))),
                                                                 Close
                                                                   (Var("v",
                                                                        CTy"CP15"),
                                                                    MB(MU(Dest
                                                                            ("HCR",
                                                                             CTy"HCR",
                                                                             Var("v",
                                                                                 CTy"CP15")),
                                                                          qTy),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"HCR"),
                                                                          MU(Dest
                                                                               ("IMO",
                                                                                bTy,
                                                                                Var("v",
                                                                                    CTy"HCR")),
                                                                             qTy))))),
                                                              MU(LF,qTy)))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(Call
                                                                ("IsSecure",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v",
                                                                 MU(Mop(Not,
                                                                        bVar"v"),
                                                                    qTy))),
                                                           MU(LF,qTy)))),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        MU(LT,qTy),
                                                        MB(MR(Close
                                                                (qVar"s",
                                                                 Dest
                                                                   ("CPSR",
                                                                    CTy"PSR",
                                                                    qVar"s"))),
                                                           Close
                                                             (Var("v",
                                                                  CTy"PSR"),
                                                              MB(MU(Dest
                                                                      ("M",
                                                                       FTy 5,
                                                                       Var("v",
                                                                           CTy"PSR")),
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        FTy 5),
                                                                    MU(EQ(Var("v",
                                                                              FTy 5),
                                                                          LW(26,
                                                                             5)),
                                                                       qTy)))))))),
                                              Close
                                                (bVar"route_to_hyp",
                                                 ITB([(bVar"route_to_monitor",
                                                       MB(MR(Close
                                                               (qVar"s",
                                                                Dest
                                                                  ("CPSR",
                                                                   CTy"PSR",
                                                                   qVar"s"))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MB(MB(MB(MU(Dest
                                                                           ("M",
                                                                            FTy 5,
                                                                            Var("v",
                                                                                CTy"PSR")),
                                                                         qTy),
                                                                      Close
                                                                        (Var("v",
                                                                             FTy 5),
                                                                         MU(EQ(Var("v",
                                                                                   FTy 5),
                                                                               LW(22,
                                                                                  5)),
                                                                            qTy))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MB(MR(Close
                                                                                  (qVar"s",
                                                                                   Dest
                                                                                     ("CP15",
                                                                                      CTy"CP15",
                                                                                      qVar"s"))),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"CP15"),
                                                                                MB(MU(Dest
                                                                                        ("SCR",
                                                                                         CTy"SCR",
                                                                                         Var("v",
                                                                                             CTy"CP15")),
                                                                                      qTy),
                                                                                   Close
                                                                                     (Var("x0",
                                                                                          CTy"SCR"),
                                                                                      MB(MR(Close
                                                                                              (qVar"s",
                                                                                               Dest
                                                                                                 ("CP15",
                                                                                                  CTy"CP15",
                                                                                                  qVar"s"))),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                CTy"CP15"),
                                                                                            MB(MB(MU(TP[Var("v",
                                                                                                            CTy"CP15"),
                                                                                                        Rupd
                                                                                                          ("NS",
                                                                                                           TP[Var("x0",
                                                                                                                  CTy"SCR"),
                                                                                                              LF])],
                                                                                                     qTy),
                                                                                                  Close
                                                                                                    (Var("v",
                                                                                                         PTy(CTy"CP15",
                                                                                                             CTy"SCR")),
                                                                                                     MU(Rupd
                                                                                                          ("SCR",
                                                                                                           Var("v",
                                                                                                               PTy(CTy"CP15",
                                                                                                                   CTy"SCR"))),
                                                                                                        qTy))),
                                                                                               Close
                                                                                                 (Var("v",
                                                                                                      CTy"CP15"),
                                                                                                  MW(Close
                                                                                                       (qVar"s",
                                                                                                        Rupd
                                                                                                          ("CP15",
                                                                                                           TP[qVar"s",
                                                                                                              Var("v",
                                                                                                                  CTy"CP15")]))))))))))),
                                                                          MU(LU,
                                                                             qTy)))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("EnterMonitorMode",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      TP[Var("new_spsr_value",
                                                                             CTy"PSR"),
                                                                         Var("new_lr_value",
                                                                             F32),
                                                                         Var("vect_offset",
                                                                             F32)])))))),
                                                      (bVar"route_to_hyp",
                                                       MB(MR(Close
                                                               (qVar"s",
                                                                Dest
                                                                  ("CP15",
                                                                   CTy"CP15",
                                                                   qVar"s"))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"CP15"),
                                                             MB(MB(MB(MU(TP[Var("v",
                                                                                CTy"CP15"),
                                                                            LX(CTy"HSR")],
                                                                         qTy),
                                                                      Close
                                                                        (Var("v",
                                                                             PTy(CTy"CP15",
                                                                                 CTy"HSR")),
                                                                         MU(Rupd
                                                                              ("HSR",
                                                                               Var("v",
                                                                                   PTy(CTy"CP15",
                                                                                       CTy"HSR"))),
                                                                            qTy))),
                                                                   Close
                                                                     (Var("v",
                                                                          CTy"CP15"),
                                                                      MW(Close
                                                                           (qVar"s",
                                                                            Rupd
                                                                              ("CP15",
                                                                               TP[qVar"s",
                                                                                  Var("v",
                                                                                      CTy"CP15")]))))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("EnterHypMode",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      TP[Var("new_spsr_value",
                                                                             CTy"PSR"),
                                                                         Bop(Sub,
                                                                             Var("new_lr_value",
                                                                                 F32),
                                                                             LW(4,
                                                                                32)),
                                                                         Var("vect_offset",
                                                                             F32)]))))))],
                                                     MB(MR(Close
                                                             (qVar"s",
                                                              Dest
                                                                ("CPSR",
                                                                 CTy"PSR",
                                                                 qVar"s"))),
                                                        Close
                                                          (Var("v",
                                                               CTy"PSR"),
                                                           MB(MB(MB(MU(Dest
                                                                         ("M",
                                                                          FTy 5,
                                                                          Var("v",
                                                                              CTy"PSR")),
                                                                       qTy),
                                                                    Close
                                                                      (Var("v",
                                                                           FTy 5),
                                                                       MU(EQ(Var("v",
                                                                                 FTy 5),
                                                                             LW(22,
                                                                                5)),
                                                                          qTy))),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        MB(MR(Close
                                                                                (qVar"s",
                                                                                 Dest
                                                                                   ("CP15",
                                                                                    CTy"CP15",
                                                                                    qVar"s"))),
                                                                           Close
                                                                             (Var("v",
                                                                                  CTy"CP15"),
                                                                              MB(MU(Dest
                                                                                      ("SCR",
                                                                                       CTy"SCR",
                                                                                       Var("v",
                                                                                           CTy"CP15")),
                                                                                    qTy),
                                                                                 Close
                                                                                   (Var("x0",
                                                                                        CTy"SCR"),
                                                                                    MB(MR(Close
                                                                                            (qVar"s",
                                                                                             Dest
                                                                                               ("CP15",
                                                                                                CTy"CP15",
                                                                                                qVar"s"))),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              CTy"CP15"),
                                                                                          MB(MB(MU(TP[Var("v",
                                                                                                          CTy"CP15"),
                                                                                                      Rupd
                                                                                                        ("NS",
                                                                                                         TP[Var("x0",
                                                                                                                CTy"SCR"),
                                                                                                            LF])],
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       PTy(CTy"CP15",
                                                                                                           CTy"SCR")),
                                                                                                   MU(Rupd
                                                                                                        ("SCR",
                                                                                                         Var("v",
                                                                                                             PTy(CTy"CP15",
                                                                                                                 CTy"SCR"))),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"CP15"),
                                                                                                MW(Close
                                                                                                     (qVar"s",
                                                                                                      Rupd
                                                                                                        ("CP15",
                                                                                                         TP[qVar"s",
                                                                                                            Var("v",
                                                                                                                CTy"CP15")]))))))))))),
                                                                        MU(LU,
                                                                           qTy)))),
                                                              Close
                                                                (AVar uTy,
                                                                 MB(MR(Close
                                                                         (qVar"s",
                                                                          Dest
                                                                            ("CPSR",
                                                                             CTy"PSR",
                                                                             qVar"s"))),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"PSR"),
                                                                       MB(MB(MB(MU(TP[Var("v",
                                                                                          CTy"PSR"),
                                                                                      LW(18,
                                                                                         5)],
                                                                                   qTy),
                                                                                Close
                                                                                  (Var("v",
                                                                                       PTy(CTy"PSR",
                                                                                           FTy 5)),
                                                                                   MU(Rupd
                                                                                        ("M",
                                                                                         Var("v",
                                                                                             PTy(CTy"PSR",
                                                                                                 FTy 5))),
                                                                                      qTy))),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"PSR"),
                                                                                MW(Close
                                                                                     (qVar"s",
                                                                                      Rupd
                                                                                        ("CPSR",
                                                                                         TP[qVar"s",
                                                                                            Var("v",
                                                                                                CTy"PSR")]))))),
                                                                          Close
                                                                            (AVar
                                                                               uTy,
                                                                             MB(Call
                                                                                  ("write'SPSR",
                                                                                   ATy(qTy,
                                                                                       PTy(uTy,
                                                                                           qTy)),
                                                                                   Var("new_spsr_value",
                                                                                       CTy"PSR")),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MB(Call
                                                                                        ("write'R",
                                                                                         ATy(qTy,
                                                                                             PTy(uTy,
                                                                                                 qTy)),
                                                                                         TP[Var("new_lr_value",
                                                                                                F32),
                                                                                            LW(14,
                                                                                               4)]),
                                                                                      Close
                                                                                        (AVar
                                                                                           uTy,
                                                                                         MB(MR(Close
                                                                                                 (qVar"s",
                                                                                                  Dest
                                                                                                    ("CPSR",
                                                                                                     CTy"PSR",
                                                                                                     qVar"s"))),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   CTy"PSR"),
                                                                                               MB(MB(MB(MU(TP[Var("v",
                                                                                                                  CTy"PSR"),
                                                                                                              LT],
                                                                                                           qTy),
                                                                                                        Close
                                                                                                          (Var("v",
                                                                                                               PTy(CTy"PSR",
                                                                                                                   bTy)),
                                                                                                           MU(Rupd
                                                                                                                ("I",
                                                                                                                 Var("v",
                                                                                                                     PTy(CTy"PSR",
                                                                                                                         bTy))),
                                                                                                              qTy))),
                                                                                                     Close
                                                                                                       (Var("v",
                                                                                                            CTy"PSR"),
                                                                                                        MW(Close
                                                                                                             (qVar"s",
                                                                                                              Rupd
                                                                                                                ("CPSR",
                                                                                                                 TP[qVar"s",
                                                                                                                    Var("v",
                                                                                                                        CTy"PSR")]))))),
                                                                                                  Close
                                                                                                    (AVar
                                                                                                       uTy,
                                                                                                     MB(Call
                                                                                                          ("HaveSecurityExt",
                                                                                                           ATy(qTy,
                                                                                                               PTy(bTy,
                                                                                                                   qTy)),
                                                                                                           LU),
                                                                                                        Close
                                                                                                          (bVar"v",
                                                                                                           MB(MB(MB(MB(MB(MU(Mop(Not,
                                                                                                                                 bVar"v"),
                                                                                                                             qTy),
                                                                                                                          Close
                                                                                                                            (bVar"b",
                                                                                                                             ITE(bVar"b",
                                                                                                                                 MU(LT,
                                                                                                                                    qTy),
                                                                                                                                 Call
                                                                                                                                   ("HaveVirtExt",
                                                                                                                                    ATy(qTy,
                                                                                                                                        PTy(bTy,
                                                                                                                                            qTy)),
                                                                                                                                    LU)))),
                                                                                                                       Close
                                                                                                                         (bVar"b",
                                                                                                                          ITE(bVar"b",
                                                                                                                              MU(LT,
                                                                                                                                 qTy),
                                                                                                                              MB(MR(Close
                                                                                                                                      (qVar"s",
                                                                                                                                       Dest
                                                                                                                                         ("CP15",
                                                                                                                                          CTy"CP15",
                                                                                                                                          qVar"s"))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"CP15"),
                                                                                                                                    MB(MB(MU(Dest
                                                                                                                                               ("SCR",
                                                                                                                                                CTy"SCR",
                                                                                                                                                Var("v",
                                                                                                                                                    CTy"CP15")),
                                                                                                                                             qTy),
                                                                                                                                          Close
                                                                                                                                            (Var("v",
                                                                                                                                                 CTy"SCR"),
                                                                                                                                             MU(Dest
                                                                                                                                                  ("NS",
                                                                                                                                                   bTy,
                                                                                                                                                   Var("v",
                                                                                                                                                       CTy"SCR")),
                                                                                                                                                qTy))),
                                                                                                                                       Close
                                                                                                                                         (bVar"v",
                                                                                                                                          MU(Mop(Not,
                                                                                                                                                 bVar"v"),
                                                                                                                                             qTy)))))))),
                                                                                                                    Close
                                                                                                                      (bVar"b",
                                                                                                                       ITE(bVar"b",
                                                                                                                           MU(LT,
                                                                                                                              qTy),
                                                                                                                           MB(MR(Close
                                                                                                                                   (qVar"s",
                                                                                                                                    Dest
                                                                                                                                      ("CP15",
                                                                                                                                       CTy"CP15",
                                                                                                                                       qVar"s"))),
                                                                                                                              Close
                                                                                                                                (Var("v",
                                                                                                                                     CTy"CP15"),
                                                                                                                                 MB(MU(Dest
                                                                                                                                         ("SCR",
                                                                                                                                          CTy"SCR",
                                                                                                                                          Var("v",
                                                                                                                                              CTy"CP15")),
                                                                                                                                       qTy),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           CTy"SCR"),
                                                                                                                                       MU(Dest
                                                                                                                                            ("AW",
                                                                                                                                             bTy,
                                                                                                                                             Var("v",
                                                                                                                                                 CTy"SCR")),
                                                                                                                                          qTy)))))))),
                                                                                                                 Close
                                                                                                                   (bVar"b",
                                                                                                                    ITE(bVar"b",
                                                                                                                        MB(MR(Close
                                                                                                                                (qVar"s",
                                                                                                                                 Dest
                                                                                                                                   ("CPSR",
                                                                                                                                    CTy"PSR",
                                                                                                                                    qVar"s"))),
                                                                                                                           Close
                                                                                                                             (Var("v",
                                                                                                                                  CTy"PSR"),
                                                                                                                              MB(MB(MU(TP[Var("v",
                                                                                                                                              CTy"PSR"),
                                                                                                                                          LT],
                                                                                                                                       qTy),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           PTy(CTy"PSR",
                                                                                                                                               bTy)),
                                                                                                                                       MU(Rupd
                                                                                                                                            ("A",
                                                                                                                                             Var("v",
                                                                                                                                                 PTy(CTy"PSR",
                                                                                                                                                     bTy))),
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    MW(Close
                                                                                                                                         (qVar"s",
                                                                                                                                          Rupd
                                                                                                                                            ("CPSR",
                                                                                                                                             TP[qVar"s",
                                                                                                                                                Var("v",
                                                                                                                                                    CTy"PSR")]))))))),
                                                                                                                        MU(LU,
                                                                                                                           qTy)))),
                                                                                                              Close
                                                                                                                (AVar
                                                                                                                   uTy,
                                                                                                                 MB(MR(Close
                                                                                                                         (qVar"s",
                                                                                                                          Dest
                                                                                                                            ("CPSR",
                                                                                                                             CTy"PSR",
                                                                                                                             qVar"s"))),
                                                                                                                    Close
                                                                                                                      (Var("v",
                                                                                                                           CTy"PSR"),
                                                                                                                       MB(MB(MB(MU(TP[Var("v",
                                                                                                                                          CTy"PSR"),
                                                                                                                                      LW(0,
                                                                                                                                         8)],
                                                                                                                                   qTy),
                                                                                                                                Close
                                                                                                                                  (Var("v",
                                                                                                                                       PTy(CTy"PSR",
                                                                                                                                           F8)),
                                                                                                                                   MU(Rupd
                                                                                                                                        ("IT",
                                                                                                                                         Var("v",
                                                                                                                                             PTy(CTy"PSR",
                                                                                                                                                 F8))),
                                                                                                                                      qTy))),
                                                                                                                             Close
                                                                                                                               (Var("v",
                                                                                                                                    CTy"PSR"),
                                                                                                                                MW(Close
                                                                                                                                     (qVar"s",
                                                                                                                                      Rupd
                                                                                                                                        ("CPSR",
                                                                                                                                         TP[qVar"s",
                                                                                                                                            Var("v",
                                                                                                                                                CTy"PSR")]))))),
                                                                                                                          Close
                                                                                                                            (AVar
                                                                                                                               uTy,
                                                                                                                             MB(MR(Close
                                                                                                                                     (qVar"s",
                                                                                                                                      Dest
                                                                                                                                        ("CPSR",
                                                                                                                                         CTy"PSR",
                                                                                                                                         qVar"s"))),
                                                                                                                                Close
                                                                                                                                  (Var("v",
                                                                                                                                       CTy"PSR"),
                                                                                                                                   MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                      CTy"PSR"),
                                                                                                                                                  LF],
                                                                                                                                               qTy),
                                                                                                                                            Close
                                                                                                                                              (Var("v",
                                                                                                                                                   PTy(CTy"PSR",
                                                                                                                                                       bTy)),
                                                                                                                                               MU(Rupd
                                                                                                                                                    ("J",
                                                                                                                                                     Var("v",
                                                                                                                                                         PTy(CTy"PSR",
                                                                                                                                                             bTy))),
                                                                                                                                                  qTy))),
                                                                                                                                         Close
                                                                                                                                           (Var("v",
                                                                                                                                                CTy"PSR"),
                                                                                                                                            MW(Close
                                                                                                                                                 (qVar"s",
                                                                                                                                                  Rupd
                                                                                                                                                    ("CPSR",
                                                                                                                                                     TP[qVar"s",
                                                                                                                                                        Var("v",
                                                                                                                                                            CTy"PSR")]))))),
                                                                                                                                      Close
                                                                                                                                        (AVar
                                                                                                                                           uTy,
                                                                                                                                         MB(MR(Close
                                                                                                                                                 (qVar"s",
                                                                                                                                                  Dest
                                                                                                                                                    ("CPSR",
                                                                                                                                                     CTy"PSR",
                                                                                                                                                     qVar"s"))),
                                                                                                                                            Close
                                                                                                                                              (Var("v",
                                                                                                                                                   CTy"PSR"),
                                                                                                                                               MB(MB(MB(MB(MR(Close
                                                                                                                                                                (qVar"s",
                                                                                                                                                                 Dest
                                                                                                                                                                   ("CP15",
                                                                                                                                                                    CTy"CP15",
                                                                                                                                                                    qVar"s"))),
                                                                                                                                                           Close
                                                                                                                                                             (Var("v0",
                                                                                                                                                                  CTy"CP15"),
                                                                                                                                                              MB(MB(MU(Dest
                                                                                                                                                                         ("SCTLR",
                                                                                                                                                                          CTy"SCTLR",
                                                                                                                                                                          Var("v0",
                                                                                                                                                                              CTy"CP15")),
                                                                                                                                                                       qTy),
                                                                                                                                                                    Close
                                                                                                                                                                      (Var("v",
                                                                                                                                                                           CTy"SCTLR"),
                                                                                                                                                                       MU(Dest
                                                                                                                                                                            ("TE",
                                                                                                                                                                             bTy,
                                                                                                                                                                             Var("v",
                                                                                                                                                                                 CTy"SCTLR")),
                                                                                                                                                                          qTy))),
                                                                                                                                                                 Close
                                                                                                                                                                   (bVar"v0",
                                                                                                                                                                    MU(TP[Var("v",
                                                                                                                                                                              CTy"PSR"),
                                                                                                                                                                          bVar"v0"],
                                                                                                                                                                       qTy))))),
                                                                                                                                                        Close
                                                                                                                                                          (Var("v",
                                                                                                                                                               PTy(CTy"PSR",
                                                                                                                                                                   bTy)),
                                                                                                                                                           MU(Rupd
                                                                                                                                                                ("T",
                                                                                                                                                                 Var("v",
                                                                                                                                                                     PTy(CTy"PSR",
                                                                                                                                                                         bTy))),
                                                                                                                                                              qTy))),
                                                                                                                                                     Close
                                                                                                                                                       (Var("v",
                                                                                                                                                            CTy"PSR"),
                                                                                                                                                        MW(Close
                                                                                                                                                             (qVar"s",
                                                                                                                                                              Rupd
                                                                                                                                                                ("CPSR",
                                                                                                                                                                 TP[qVar"s",
                                                                                                                                                                    Var("v",
                                                                                                                                                                        CTy"PSR")]))))),
                                                                                                                                                  Close
                                                                                                                                                    (AVar
                                                                                                                                                       uTy,
                                                                                                                                                     MB(MR(Close
                                                                                                                                                             (qVar"s",
                                                                                                                                                              Dest
                                                                                                                                                                ("CPSR",
                                                                                                                                                                 CTy"PSR",
                                                                                                                                                                 qVar"s"))),
                                                                                                                                                        Close
                                                                                                                                                          (Var("v",
                                                                                                                                                               CTy"PSR"),
                                                                                                                                                           MB(MB(MB(MB(MR(Close
                                                                                                                                                                            (qVar"s",
                                                                                                                                                                             Dest
                                                                                                                                                                               ("CP15",
                                                                                                                                                                                CTy"CP15",
                                                                                                                                                                                qVar"s"))),
                                                                                                                                                                       Close
                                                                                                                                                                         (Var("v0",
                                                                                                                                                                              CTy"CP15"),
                                                                                                                                                                          MB(MB(MU(Dest
                                                                                                                                                                                     ("SCTLR",
                                                                                                                                                                                      CTy"SCTLR",
                                                                                                                                                                                      Var("v0",
                                                                                                                                                                                          CTy"CP15")),
                                                                                                                                                                                   qTy),
                                                                                                                                                                                Close
                                                                                                                                                                                  (Var("v",
                                                                                                                                                                                       CTy"SCTLR"),
                                                                                                                                                                                   MU(Dest
                                                                                                                                                                                        ("EE",
                                                                                                                                                                                         bTy,
                                                                                                                                                                                         Var("v",
                                                                                                                                                                                             CTy"SCTLR")),
                                                                                                                                                                                      qTy))),
                                                                                                                                                                             Close
                                                                                                                                                                               (bVar"v0",
                                                                                                                                                                                MU(TP[Var("v",
                                                                                                                                                                                          CTy"PSR"),
                                                                                                                                                                                      bVar"v0"],
                                                                                                                                                                                   qTy))))),
                                                                                                                                                                    Close
                                                                                                                                                                      (Var("v",
                                                                                                                                                                           PTy(CTy"PSR",
                                                                                                                                                                               bTy)),
                                                                                                                                                                       MU(Rupd
                                                                                                                                                                            ("E",
                                                                                                                                                                             Var("v",
                                                                                                                                                                                 PTy(CTy"PSR",
                                                                                                                                                                                     bTy))),
                                                                                                                                                                          qTy))),
                                                                                                                                                                 Close
                                                                                                                                                                   (Var("v",
                                                                                                                                                                        CTy"PSR"),
                                                                                                                                                                    MW(Close
                                                                                                                                                                         (qVar"s",
                                                                                                                                                                          Rupd
                                                                                                                                                                            ("CPSR",
                                                                                                                                                                             TP[qVar"s",
                                                                                                                                                                                Var("v",
                                                                                                                                                                                    CTy"PSR")]))))),
                                                                                                                                                              Close
                                                                                                                                                                (AVar
                                                                                                                                                                   uTy,
                                                                                                                                                                 MB(MR(Close
                                                                                                                                                                         (qVar"s",
                                                                                                                                                                          Dest
                                                                                                                                                                            ("CP15",
                                                                                                                                                                             CTy"CP15",
                                                                                                                                                                             qVar"s"))),
                                                                                                                                                                    Close
                                                                                                                                                                      (Var("v",
                                                                                                                                                                           CTy"CP15"),
                                                                                                                                                                       MB(MB(MU(Dest
                                                                                                                                                                                  ("SCTLR",
                                                                                                                                                                                   CTy"SCTLR",
                                                                                                                                                                                   Var("v",
                                                                                                                                                                                       CTy"CP15")),
                                                                                                                                                                                qTy),
                                                                                                                                                                             Close
                                                                                                                                                                               (Var("v",
                                                                                                                                                                                    CTy"SCTLR"),
                                                                                                                                                                                MU(Dest
                                                                                                                                                                                     ("VE",
                                                                                                                                                                                      bTy,
                                                                                                                                                                                      Var("v",
                                                                                                                                                                                          CTy"SCTLR")),
                                                                                                                                                                                   qTy))),
                                                                                                                                                                          Close
                                                                                                                                                                            (bVar"b",
                                                                                                                                                                             ITE(bVar"b",
                                                                                                                                                                                 Call
                                                                                                                                                                                   ("raise'exception",
                                                                                                                                                                                    ATy(qTy,
                                                                                                                                                                                        PTy(uTy,
                                                                                                                                                                                            qTy)),
                                                                                                                                                                                    Call
                                                                                                                                                                                      ("IMPLEMENTATION_DEFINED",
                                                                                                                                                                                       CTy"exception",
                                                                                                                                                                                       LS
                                                                                                                                                                                        "branch to an IRQ vector")),
                                                                                                                                                                                 MB(Call
                                                                                                                                                                                      ("ExcVectorBase",
                                                                                                                                                                                       ATy(qTy,
                                                                                                                                                                                           PTy(F32,
                                                                                                                                                                                               qTy)),
                                                                                                                                                                                       LU),
                                                                                                                                                                                    Close
                                                                                                                                                                                      (Var("v",
                                                                                                                                                                                           F32),
                                                                                                                                                                                       MB(MU(Bop(Add,
                                                                                                                                                                                                 Var("v",
                                                                                                                                                                                                     F32),
                                                                                                                                                                                                 Var("vect_offset",
                                                                                                                                                                                                     F32)),
                                                                                                                                                                                             qTy),
                                                                                                                                                                                          Close
                                                                                                                                                                                            (Var("v",
                                                                                                                                                                                                 F32),
                                                                                                                                                                                             Call
                                                                                                                                                                                               ("BranchTo",
                                                                                                                                                                                                ATy(qTy,
                                                                                                                                                                                                    PTy(uTy,
                                                                                                                                                                                                        qTy)),
                                                                                                                                                                                                Var("v",
                                                                                                                                                                                                    F32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
;
val TakeVirtualIRQException_def = Def
  ("TakeVirtualIRQException",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",Const("PC",ATy(qTy,PTy(F32,qTy))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
            Close
              (Var("new_lr_value",F32),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("new_spsr_value",CTy"PSR"),
                     MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                        Close
                          (Var("v",CTy"PSR"),
                           MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LW(18,5)],qTy),
                                    Close
                                      (Var("v",PTy(CTy"PSR",FTy 5)),
                                       MU(Rupd
                                            ("M",
                                             Var("v",PTy(CTy"PSR",FTy 5))),
                                          qTy))),
                                 Close
                                   (Var("v",CTy"PSR"),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("CPSR",
                                             TP[qVar"s",Var("v",CTy"PSR")]))))),
                              Close
                                (AVar uTy,
                                 MB(Call
                                      ("write'SPSR",ATy(qTy,PTy(uTy,qTy)),
                                       Var("new_spsr_value",CTy"PSR")),
                                    Close
                                      (AVar uTy,
                                       MB(Call
                                            ("write'R",
                                             ATy(qTy,PTy(uTy,qTy)),
                                             TP[Var("new_lr_value",F32),
                                                LW(14,4)]),
                                          Close
                                            (AVar uTy,
                                             MB(MR(Close
                                                     (qVar"s",
                                                      Dest
                                                        ("CPSR",CTy"PSR",
                                                         qVar"s"))),
                                                Close
                                                  (Var("v",CTy"PSR"),
                                                   MB(MB(MB(MU(TP[Var("v",
                                                                      CTy"PSR"),
                                                                  LT],qTy),
                                                            Close
                                                              (Var("v",
                                                                   PTy(CTy"PSR",
                                                                       bTy)),
                                                               MU(Rupd
                                                                    ("I",
                                                                     Var("v",
                                                                         PTy(CTy"PSR",
                                                                             bTy))),
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                CTy"PSR"),
                                                            MW(Close
                                                                 (qVar"s",
                                                                  Rupd
                                                                    ("CPSR",
                                                                     TP[qVar"s",
                                                                        Var("v",
                                                                            CTy"PSR")]))))),
                                                      Close
                                                        (AVar uTy,
                                                         MB(MR(Close
                                                                 (qVar"s",
                                                                  Dest
                                                                    ("CPSR",
                                                                     CTy"PSR",
                                                                     qVar"s"))),
                                                            Close
                                                              (Var("v",
                                                                   CTy"PSR"),
                                                               MB(MB(MB(MU(TP[Var("v",
                                                                                  CTy"PSR"),
                                                                              LT],
                                                                           qTy),
                                                                        Close
                                                                          (Var("v",
                                                                               PTy(CTy"PSR",
                                                                                   bTy)),
                                                                           MU(Rupd
                                                                                ("A",
                                                                                 Var("v",
                                                                                     PTy(CTy"PSR",
                                                                                         bTy))),
                                                                              qTy))),
                                                                     Close
                                                                       (Var("v",
                                                                            CTy"PSR"),
                                                                        MW(Close
                                                                             (qVar"s",
                                                                              Rupd
                                                                                ("CPSR",
                                                                                 TP[qVar"s",
                                                                                    Var("v",
                                                                                        CTy"PSR")]))))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MB(MR(Close
                                                                             (qVar"s",
                                                                              Dest
                                                                                ("CPSR",
                                                                                 CTy"PSR",
                                                                                 qVar"s"))),
                                                                        Close
                                                                          (Var("v",
                                                                               CTy"PSR"),
                                                                           MB(MB(MB(MU(TP[Var("v",
                                                                                              CTy"PSR"),
                                                                                          LW(0,
                                                                                             8)],
                                                                                       qTy),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           PTy(CTy"PSR",
                                                                                               F8)),
                                                                                       MU(Rupd
                                                                                            ("IT",
                                                                                             Var("v",
                                                                                                 PTy(CTy"PSR",
                                                                                                     F8))),
                                                                                          qTy))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"PSR"),
                                                                                    MW(Close
                                                                                         (qVar"s",
                                                                                          Rupd
                                                                                            ("CPSR",
                                                                                             TP[qVar"s",
                                                                                                Var("v",
                                                                                                    CTy"PSR")]))))),
                                                                              Close
                                                                                (AVar
                                                                                   uTy,
                                                                                 MB(MR(Close
                                                                                         (qVar"s",
                                                                                          Dest
                                                                                            ("CPSR",
                                                                                             CTy"PSR",
                                                                                             qVar"s"))),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           CTy"PSR"),
                                                                                       MB(MB(MB(MU(TP[Var("v",
                                                                                                          CTy"PSR"),
                                                                                                      LF],
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       PTy(CTy"PSR",
                                                                                                           bTy)),
                                                                                                   MU(Rupd
                                                                                                        ("J",
                                                                                                         Var("v",
                                                                                                             PTy(CTy"PSR",
                                                                                                                 bTy))),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"PSR"),
                                                                                                MW(Close
                                                                                                     (qVar"s",
                                                                                                      Rupd
                                                                                                        ("CPSR",
                                                                                                         TP[qVar"s",
                                                                                                            Var("v",
                                                                                                                CTy"PSR")]))))),
                                                                                          Close
                                                                                            (AVar
                                                                                               uTy,
                                                                                             MB(MR(Close
                                                                                                     (qVar"s",
                                                                                                      Dest
                                                                                                        ("CPSR",
                                                                                                         CTy"PSR",
                                                                                                         qVar"s"))),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       CTy"PSR"),
                                                                                                   MB(MB(MB(MB(MR(Close
                                                                                                                    (qVar"s",
                                                                                                                     Dest
                                                                                                                       ("CP15",
                                                                                                                        CTy"CP15",
                                                                                                                        qVar"s"))),
                                                                                                               Close
                                                                                                                 (Var("v0",
                                                                                                                      CTy"CP15"),
                                                                                                                  MB(MB(MU(Dest
                                                                                                                             ("SCTLR",
                                                                                                                              CTy"SCTLR",
                                                                                                                              Var("v0",
                                                                                                                                  CTy"CP15")),
                                                                                                                           qTy),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               CTy"SCTLR"),
                                                                                                                           MU(Dest
                                                                                                                                ("TE",
                                                                                                                                 bTy,
                                                                                                                                 Var("v",
                                                                                                                                     CTy"SCTLR")),
                                                                                                                              qTy))),
                                                                                                                     Close
                                                                                                                       (bVar"v0",
                                                                                                                        MU(TP[Var("v",
                                                                                                                                  CTy"PSR"),
                                                                                                                              bVar"v0"],
                                                                                                                           qTy))))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   PTy(CTy"PSR",
                                                                                                                       bTy)),
                                                                                                               MU(Rupd
                                                                                                                    ("T",
                                                                                                                     Var("v",
                                                                                                                         PTy(CTy"PSR",
                                                                                                                             bTy))),
                                                                                                                  qTy))),
                                                                                                         Close
                                                                                                           (Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            MW(Close
                                                                                                                 (qVar"s",
                                                                                                                  Rupd
                                                                                                                    ("CPSR",
                                                                                                                     TP[qVar"s",
                                                                                                                        Var("v",
                                                                                                                            CTy"PSR")]))))),
                                                                                                      Close
                                                                                                        (AVar
                                                                                                           uTy,
                                                                                                         MB(MR(Close
                                                                                                                 (qVar"s",
                                                                                                                  Dest
                                                                                                                    ("CPSR",
                                                                                                                     CTy"PSR",
                                                                                                                     qVar"s"))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   CTy"PSR"),
                                                                                                               MB(MB(MB(MB(MR(Close
                                                                                                                                (qVar"s",
                                                                                                                                 Dest
                                                                                                                                   ("CP15",
                                                                                                                                    CTy"CP15",
                                                                                                                                    qVar"s"))),
                                                                                                                           Close
                                                                                                                             (Var("v0",
                                                                                                                                  CTy"CP15"),
                                                                                                                              MB(MB(MU(Dest
                                                                                                                                         ("SCTLR",
                                                                                                                                          CTy"SCTLR",
                                                                                                                                          Var("v0",
                                                                                                                                              CTy"CP15")),
                                                                                                                                       qTy),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           CTy"SCTLR"),
                                                                                                                                       MU(Dest
                                                                                                                                            ("EE",
                                                                                                                                             bTy,
                                                                                                                                             Var("v",
                                                                                                                                                 CTy"SCTLR")),
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (bVar"v0",
                                                                                                                                    MU(TP[Var("v",
                                                                                                                                              CTy"PSR"),
                                                                                                                                          bVar"v0"],
                                                                                                                                       qTy))))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               PTy(CTy"PSR",
                                                                                                                                   bTy)),
                                                                                                                           MU(Rupd
                                                                                                                                ("E",
                                                                                                                                 Var("v",
                                                                                                                                     PTy(CTy"PSR",
                                                                                                                                         bTy))),
                                                                                                                              qTy))),
                                                                                                                     Close
                                                                                                                       (Var("v",
                                                                                                                            CTy"PSR"),
                                                                                                                        MW(Close
                                                                                                                             (qVar"s",
                                                                                                                              Rupd
                                                                                                                                ("CPSR",
                                                                                                                                 TP[qVar"s",
                                                                                                                                    Var("v",
                                                                                                                                        CTy"PSR")]))))),
                                                                                                                  Close
                                                                                                                    (AVar
                                                                                                                       uTy,
                                                                                                                     MB(MR(Close
                                                                                                                             (qVar"s",
                                                                                                                              Dest
                                                                                                                                ("CP15",
                                                                                                                                 CTy"CP15",
                                                                                                                                 qVar"s"))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               CTy"CP15"),
                                                                                                                           MB(MB(MU(Dest
                                                                                                                                      ("SCTLR",
                                                                                                                                       CTy"SCTLR",
                                                                                                                                       Var("v",
                                                                                                                                           CTy"CP15")),
                                                                                                                                    qTy),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"SCTLR"),
                                                                                                                                    MU(Dest
                                                                                                                                         ("VE",
                                                                                                                                          bTy,
                                                                                                                                          Var("v",
                                                                                                                                              CTy"SCTLR")),
                                                                                                                                       qTy))),
                                                                                                                              Close
                                                                                                                                (bVar"b",
                                                                                                                                 ITE(bVar"b",
                                                                                                                                     Call
                                                                                                                                       ("raise'exception",
                                                                                                                                        ATy(qTy,
                                                                                                                                            PTy(uTy,
                                                                                                                                                qTy)),
                                                                                                                                        Call
                                                                                                                                          ("IMPLEMENTATION_DEFINED",
                                                                                                                                           CTy"exception",
                                                                                                                                           LS
                                                                                                                                            "branch to an IRQ vector")),
                                                                                                                                     MB(Call
                                                                                                                                          ("ExcVectorBase",
                                                                                                                                           ATy(qTy,
                                                                                                                                               PTy(F32,
                                                                                                                                                   qTy)),
                                                                                                                                           LU),
                                                                                                                                        Close
                                                                                                                                          (Var("v",
                                                                                                                                               F32),
                                                                                                                                           MB(MU(Bop(Add,
                                                                                                                                                     Var("v",
                                                                                                                                                         F32),
                                                                                                                                                     LW(24,
                                                                                                                                                        32)),
                                                                                                                                                 qTy),
                                                                                                                                              Close
                                                                                                                                                (Var("v",
                                                                                                                                                     F32),
                                                                                                                                                 Call
                                                                                                                                                   ("BranchTo",
                                                                                                                                                    ATy(qTy,
                                                                                                                                                        PTy(uTy,
                                                                                                                                                            qTy)),
                                                                                                                                                    Var("v",
                                                                                                                                                        F32))))))))))))))))))))))))))))))))))))))))))))))))))
;
val TakePhysicalFIQException_def = Def
  ("TakePhysicalFIQException",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",Const("PC",ATy(qTy,PTy(F32,qTy))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
            Close
              (Var("new_lr_value",F32),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("new_spsr_value",CTy"PSR"),
                     Let(Var("vect_offset",F32),LW(28,32),
                         MB(Call
                              ("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
                            Close
                              (bVar"v",
                               MB(ITE(bVar"v",
                                      MB(MR(Close
                                              (qVar"s",
                                               Dest
                                                 ("CP15",CTy"CP15",qVar"s"))),
                                         Close
                                           (Var("v",CTy"CP15"),
                                            MB(MU(Dest
                                                    ("SCR",CTy"SCR",
                                                     Var("v",CTy"CP15")),
                                                  qTy),
                                               Close
                                                 (Var("v",CTy"SCR"),
                                                  MU(Dest
                                                       ("FIQ",bTy,
                                                        Var("v",CTy"SCR")),
                                                     qTy))))),MU(LF,qTy)),
                                  Close
                                    (bVar"route_to_monitor",
                                     MB(Call
                                          ("HaveVirtExt",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MB(MB(MB(ITE(bVar"v",
                                                              Call
                                                                ("HaveSecurityExt",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              MU(LF,qTy)),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(MR(Close
                                                                         (qVar"s",
                                                                          Dest
                                                                            ("CP15",
                                                                             CTy"CP15",
                                                                             qVar"s"))),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"CP15"),
                                                                       MB(MB(MU(Dest
                                                                                  ("SCR",
                                                                                   CTy"SCR",
                                                                                   Var("v",
                                                                                       CTy"CP15")),
                                                                                qTy),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"SCR"),
                                                                                MU(Dest
                                                                                     ("FIQ",
                                                                                      bTy,
                                                                                      Var("v",
                                                                                          CTy"SCR")),
                                                                                   qTy))),
                                                                          Close
                                                                            (bVar"v",
                                                                             MU(Mop(Not,
                                                                                    bVar"v"),
                                                                                qTy))))),
                                                                 MU(LF,qTy)))),
                                                       Close
                                                         (bVar"b",
                                                          ITE(bVar"b",
                                                              MB(MR(Close
                                                                      (qVar"s",
                                                                       Dest
                                                                         ("CP15",
                                                                          CTy"CP15",
                                                                          qVar"s"))),
                                                                 Close
                                                                   (Var("v",
                                                                        CTy"CP15"),
                                                                    MB(MU(Dest
                                                                            ("HCR",
                                                                             CTy"HCR",
                                                                             Var("v",
                                                                                 CTy"CP15")),
                                                                          qTy),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"HCR"),
                                                                          MU(Dest
                                                                               ("FMO",
                                                                                bTy,
                                                                                Var("v",
                                                                                    CTy"HCR")),
                                                                             qTy))))),
                                                              MU(LF,qTy)))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(Call
                                                                ("IsSecure",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v",
                                                                 MU(Mop(Not,
                                                                        bVar"v"),
                                                                    qTy))),
                                                           MU(LF,qTy)))),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        MU(LT,qTy),
                                                        MB(MR(Close
                                                                (qVar"s",
                                                                 Dest
                                                                   ("CPSR",
                                                                    CTy"PSR",
                                                                    qVar"s"))),
                                                           Close
                                                             (Var("v",
                                                                  CTy"PSR"),
                                                              MB(MU(Dest
                                                                      ("M",
                                                                       FTy 5,
                                                                       Var("v",
                                                                           CTy"PSR")),
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        FTy 5),
                                                                    MU(EQ(Var("v",
                                                                              FTy 5),
                                                                          LW(26,
                                                                             5)),
                                                                       qTy)))))))),
                                              Close
                                                (bVar"route_to_hyp",
                                                 ITB([(bVar"route_to_monitor",
                                                       MB(MR(Close
                                                               (qVar"s",
                                                                Dest
                                                                  ("CPSR",
                                                                   CTy"PSR",
                                                                   qVar"s"))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MB(MB(MB(MU(Dest
                                                                           ("M",
                                                                            FTy 5,
                                                                            Var("v",
                                                                                CTy"PSR")),
                                                                         qTy),
                                                                      Close
                                                                        (Var("v",
                                                                             FTy 5),
                                                                         MU(EQ(Var("v",
                                                                                   FTy 5),
                                                                               LW(22,
                                                                                  5)),
                                                                            qTy))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MB(MR(Close
                                                                                  (qVar"s",
                                                                                   Dest
                                                                                     ("CP15",
                                                                                      CTy"CP15",
                                                                                      qVar"s"))),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"CP15"),
                                                                                MB(MU(Dest
                                                                                        ("SCR",
                                                                                         CTy"SCR",
                                                                                         Var("v",
                                                                                             CTy"CP15")),
                                                                                      qTy),
                                                                                   Close
                                                                                     (Var("x0",
                                                                                          CTy"SCR"),
                                                                                      MB(MR(Close
                                                                                              (qVar"s",
                                                                                               Dest
                                                                                                 ("CP15",
                                                                                                  CTy"CP15",
                                                                                                  qVar"s"))),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                CTy"CP15"),
                                                                                            MB(MB(MU(TP[Var("v",
                                                                                                            CTy"CP15"),
                                                                                                        Rupd
                                                                                                          ("NS",
                                                                                                           TP[Var("x0",
                                                                                                                  CTy"SCR"),
                                                                                                              LF])],
                                                                                                     qTy),
                                                                                                  Close
                                                                                                    (Var("v",
                                                                                                         PTy(CTy"CP15",
                                                                                                             CTy"SCR")),
                                                                                                     MU(Rupd
                                                                                                          ("SCR",
                                                                                                           Var("v",
                                                                                                               PTy(CTy"CP15",
                                                                                                                   CTy"SCR"))),
                                                                                                        qTy))),
                                                                                               Close
                                                                                                 (Var("v",
                                                                                                      CTy"CP15"),
                                                                                                  MW(Close
                                                                                                       (qVar"s",
                                                                                                        Rupd
                                                                                                          ("CP15",
                                                                                                           TP[qVar"s",
                                                                                                              Var("v",
                                                                                                                  CTy"CP15")]))))))))))),
                                                                          MU(LU,
                                                                             qTy)))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("EnterMonitorMode",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      TP[Var("new_spsr_value",
                                                                             CTy"PSR"),
                                                                         Var("new_lr_value",
                                                                             F32),
                                                                         Var("vect_offset",
                                                                             F32)])))))),
                                                      (bVar"route_to_hyp",
                                                       MB(MR(Close
                                                               (qVar"s",
                                                                Dest
                                                                  ("CP15",
                                                                   CTy"CP15",
                                                                   qVar"s"))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"CP15"),
                                                             MB(MB(MB(MU(TP[Var("v",
                                                                                CTy"CP15"),
                                                                            LX(CTy"HSR")],
                                                                         qTy),
                                                                      Close
                                                                        (Var("v",
                                                                             PTy(CTy"CP15",
                                                                                 CTy"HSR")),
                                                                         MU(Rupd
                                                                              ("HSR",
                                                                               Var("v",
                                                                                   PTy(CTy"CP15",
                                                                                       CTy"HSR"))),
                                                                            qTy))),
                                                                   Close
                                                                     (Var("v",
                                                                          CTy"CP15"),
                                                                      MW(Close
                                                                           (qVar"s",
                                                                            Rupd
                                                                              ("CP15",
                                                                               TP[qVar"s",
                                                                                  Var("v",
                                                                                      CTy"CP15")]))))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("EnterHypMode",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      TP[Var("new_spsr_value",
                                                                             CTy"PSR"),
                                                                         Bop(Sub,
                                                                             Var("new_lr_value",
                                                                                 F32),
                                                                             LW(4,
                                                                                32)),
                                                                         Var("vect_offset",
                                                                             F32)]))))))],
                                                     MB(MR(Close
                                                             (qVar"s",
                                                              Dest
                                                                ("CPSR",
                                                                 CTy"PSR",
                                                                 qVar"s"))),
                                                        Close
                                                          (Var("v",
                                                               CTy"PSR"),
                                                           MB(MB(MB(MU(Dest
                                                                         ("M",
                                                                          FTy 5,
                                                                          Var("v",
                                                                              CTy"PSR")),
                                                                       qTy),
                                                                    Close
                                                                      (Var("v",
                                                                           FTy 5),
                                                                       MU(EQ(Var("v",
                                                                                 FTy 5),
                                                                             LW(22,
                                                                                5)),
                                                                          qTy))),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        MB(MR(Close
                                                                                (qVar"s",
                                                                                 Dest
                                                                                   ("CP15",
                                                                                    CTy"CP15",
                                                                                    qVar"s"))),
                                                                           Close
                                                                             (Var("v",
                                                                                  CTy"CP15"),
                                                                              MB(MU(Dest
                                                                                      ("SCR",
                                                                                       CTy"SCR",
                                                                                       Var("v",
                                                                                           CTy"CP15")),
                                                                                    qTy),
                                                                                 Close
                                                                                   (Var("x0",
                                                                                        CTy"SCR"),
                                                                                    MB(MR(Close
                                                                                            (qVar"s",
                                                                                             Dest
                                                                                               ("CP15",
                                                                                                CTy"CP15",
                                                                                                qVar"s"))),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              CTy"CP15"),
                                                                                          MB(MB(MU(TP[Var("v",
                                                                                                          CTy"CP15"),
                                                                                                      Rupd
                                                                                                        ("NS",
                                                                                                         TP[Var("x0",
                                                                                                                CTy"SCR"),
                                                                                                            LF])],
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       PTy(CTy"CP15",
                                                                                                           CTy"SCR")),
                                                                                                   MU(Rupd
                                                                                                        ("SCR",
                                                                                                         Var("v",
                                                                                                             PTy(CTy"CP15",
                                                                                                                 CTy"SCR"))),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"CP15"),
                                                                                                MW(Close
                                                                                                     (qVar"s",
                                                                                                      Rupd
                                                                                                        ("CP15",
                                                                                                         TP[qVar"s",
                                                                                                            Var("v",
                                                                                                                CTy"CP15")]))))))))))),
                                                                        MU(LU,
                                                                           qTy)))),
                                                              Close
                                                                (AVar uTy,
                                                                 MB(MR(Close
                                                                         (qVar"s",
                                                                          Dest
                                                                            ("CPSR",
                                                                             CTy"PSR",
                                                                             qVar"s"))),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"PSR"),
                                                                       MB(MB(MB(MU(TP[Var("v",
                                                                                          CTy"PSR"),
                                                                                      LW(17,
                                                                                         5)],
                                                                                   qTy),
                                                                                Close
                                                                                  (Var("v",
                                                                                       PTy(CTy"PSR",
                                                                                           FTy 5)),
                                                                                   MU(Rupd
                                                                                        ("M",
                                                                                         Var("v",
                                                                                             PTy(CTy"PSR",
                                                                                                 FTy 5))),
                                                                                      qTy))),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"PSR"),
                                                                                MW(Close
                                                                                     (qVar"s",
                                                                                      Rupd
                                                                                        ("CPSR",
                                                                                         TP[qVar"s",
                                                                                            Var("v",
                                                                                                CTy"PSR")]))))),
                                                                          Close
                                                                            (AVar
                                                                               uTy,
                                                                             MB(Call
                                                                                  ("write'SPSR",
                                                                                   ATy(qTy,
                                                                                       PTy(uTy,
                                                                                           qTy)),
                                                                                   Var("new_spsr_value",
                                                                                       CTy"PSR")),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MB(Call
                                                                                        ("write'R",
                                                                                         ATy(qTy,
                                                                                             PTy(uTy,
                                                                                                 qTy)),
                                                                                         TP[Var("new_lr_value",
                                                                                                F32),
                                                                                            LW(14,
                                                                                               4)]),
                                                                                      Close
                                                                                        (AVar
                                                                                           uTy,
                                                                                         MB(MR(Close
                                                                                                 (qVar"s",
                                                                                                  Dest
                                                                                                    ("CPSR",
                                                                                                     CTy"PSR",
                                                                                                     qVar"s"))),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   CTy"PSR"),
                                                                                               MB(MB(MB(MU(TP[Var("v",
                                                                                                                  CTy"PSR"),
                                                                                                              LT],
                                                                                                           qTy),
                                                                                                        Close
                                                                                                          (Var("v",
                                                                                                               PTy(CTy"PSR",
                                                                                                                   bTy)),
                                                                                                           MU(Rupd
                                                                                                                ("I",
                                                                                                                 Var("v",
                                                                                                                     PTy(CTy"PSR",
                                                                                                                         bTy))),
                                                                                                              qTy))),
                                                                                                     Close
                                                                                                       (Var("v",
                                                                                                            CTy"PSR"),
                                                                                                        MW(Close
                                                                                                             (qVar"s",
                                                                                                              Rupd
                                                                                                                ("CPSR",
                                                                                                                 TP[qVar"s",
                                                                                                                    Var("v",
                                                                                                                        CTy"PSR")]))))),
                                                                                                  Close
                                                                                                    (AVar
                                                                                                       uTy,
                                                                                                     MB(Call
                                                                                                          ("HaveSecurityExt",
                                                                                                           ATy(qTy,
                                                                                                               PTy(bTy,
                                                                                                                   qTy)),
                                                                                                           LU),
                                                                                                        Close
                                                                                                          (bVar"v",
                                                                                                           MB(MB(MB(MB(MB(MU(Mop(Not,
                                                                                                                                 bVar"v"),
                                                                                                                             qTy),
                                                                                                                          Close
                                                                                                                            (bVar"b",
                                                                                                                             ITE(bVar"b",
                                                                                                                                 MU(LT,
                                                                                                                                    qTy),
                                                                                                                                 Call
                                                                                                                                   ("HaveVirtExt",
                                                                                                                                    ATy(qTy,
                                                                                                                                        PTy(bTy,
                                                                                                                                            qTy)),
                                                                                                                                    LU)))),
                                                                                                                       Close
                                                                                                                         (bVar"b",
                                                                                                                          ITE(bVar"b",
                                                                                                                              MU(LT,
                                                                                                                                 qTy),
                                                                                                                              MB(MR(Close
                                                                                                                                      (qVar"s",
                                                                                                                                       Dest
                                                                                                                                         ("CP15",
                                                                                                                                          CTy"CP15",
                                                                                                                                          qVar"s"))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"CP15"),
                                                                                                                                    MB(MB(MU(Dest
                                                                                                                                               ("SCR",
                                                                                                                                                CTy"SCR",
                                                                                                                                                Var("v",
                                                                                                                                                    CTy"CP15")),
                                                                                                                                             qTy),
                                                                                                                                          Close
                                                                                                                                            (Var("v",
                                                                                                                                                 CTy"SCR"),
                                                                                                                                             MU(Dest
                                                                                                                                                  ("NS",
                                                                                                                                                   bTy,
                                                                                                                                                   Var("v",
                                                                                                                                                       CTy"SCR")),
                                                                                                                                                qTy))),
                                                                                                                                       Close
                                                                                                                                         (bVar"v",
                                                                                                                                          MU(Mop(Not,
                                                                                                                                                 bVar"v"),
                                                                                                                                             qTy)))))))),
                                                                                                                    Close
                                                                                                                      (bVar"b",
                                                                                                                       ITE(bVar"b",
                                                                                                                           MU(LT,
                                                                                                                              qTy),
                                                                                                                           MB(MR(Close
                                                                                                                                   (qVar"s",
                                                                                                                                    Dest
                                                                                                                                      ("CP15",
                                                                                                                                       CTy"CP15",
                                                                                                                                       qVar"s"))),
                                                                                                                              Close
                                                                                                                                (Var("v",
                                                                                                                                     CTy"CP15"),
                                                                                                                                 MB(MU(Dest
                                                                                                                                         ("SCR",
                                                                                                                                          CTy"SCR",
                                                                                                                                          Var("v",
                                                                                                                                              CTy"CP15")),
                                                                                                                                       qTy),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           CTy"SCR"),
                                                                                                                                       MU(Dest
                                                                                                                                            ("FW",
                                                                                                                                             bTy,
                                                                                                                                             Var("v",
                                                                                                                                                 CTy"SCR")),
                                                                                                                                          qTy)))))))),
                                                                                                                 Close
                                                                                                                   (bVar"b",
                                                                                                                    ITE(bVar"b",
                                                                                                                        MB(MR(Close
                                                                                                                                (qVar"s",
                                                                                                                                 Dest
                                                                                                                                   ("CPSR",
                                                                                                                                    CTy"PSR",
                                                                                                                                    qVar"s"))),
                                                                                                                           Close
                                                                                                                             (Var("v",
                                                                                                                                  CTy"PSR"),
                                                                                                                              MB(MB(MU(TP[Var("v",
                                                                                                                                              CTy"PSR"),
                                                                                                                                          LT],
                                                                                                                                       qTy),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           PTy(CTy"PSR",
                                                                                                                                               bTy)),
                                                                                                                                       MU(Rupd
                                                                                                                                            ("F",
                                                                                                                                             Var("v",
                                                                                                                                                 PTy(CTy"PSR",
                                                                                                                                                     bTy))),
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    MW(Close
                                                                                                                                         (qVar"s",
                                                                                                                                          Rupd
                                                                                                                                            ("CPSR",
                                                                                                                                             TP[qVar"s",
                                                                                                                                                Var("v",
                                                                                                                                                    CTy"PSR")]))))))),
                                                                                                                        MU(LU,
                                                                                                                           qTy)))),
                                                                                                              Close
                                                                                                                (AVar
                                                                                                                   uTy,
                                                                                                                 MB(Call
                                                                                                                      ("HaveSecurityExt",
                                                                                                                       ATy(qTy,
                                                                                                                           PTy(bTy,
                                                                                                                               qTy)),
                                                                                                                       LU),
                                                                                                                    Close
                                                                                                                      (bVar"v",
                                                                                                                       MB(MB(MB(MB(MB(MU(Mop(Not,
                                                                                                                                             bVar"v"),
                                                                                                                                         qTy),
                                                                                                                                      Close
                                                                                                                                        (bVar"b",
                                                                                                                                         ITE(bVar"b",
                                                                                                                                             MU(LT,
                                                                                                                                                qTy),
                                                                                                                                             Call
                                                                                                                                               ("HaveVirtExt",
                                                                                                                                                ATy(qTy,
                                                                                                                                                    PTy(bTy,
                                                                                                                                                        qTy)),
                                                                                                                                                LU)))),
                                                                                                                                   Close
                                                                                                                                     (bVar"b",
                                                                                                                                      ITE(bVar"b",
                                                                                                                                          MU(LT,
                                                                                                                                             qTy),
                                                                                                                                          MB(MR(Close
                                                                                                                                                  (qVar"s",
                                                                                                                                                   Dest
                                                                                                                                                     ("CP15",
                                                                                                                                                      CTy"CP15",
                                                                                                                                                      qVar"s"))),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    CTy"CP15"),
                                                                                                                                                MB(MB(MU(Dest
                                                                                                                                                           ("SCR",
                                                                                                                                                            CTy"SCR",
                                                                                                                                                            Var("v",
                                                                                                                                                                CTy"CP15")),
                                                                                                                                                         qTy),
                                                                                                                                                      Close
                                                                                                                                                        (Var("v",
                                                                                                                                                             CTy"SCR"),
                                                                                                                                                         MU(Dest
                                                                                                                                                              ("NS",
                                                                                                                                                               bTy,
                                                                                                                                                               Var("v",
                                                                                                                                                                   CTy"SCR")),
                                                                                                                                                            qTy))),
                                                                                                                                                   Close
                                                                                                                                                     (bVar"v",
                                                                                                                                                      MU(Mop(Not,
                                                                                                                                                             bVar"v"),
                                                                                                                                                         qTy)))))))),
                                                                                                                                Close
                                                                                                                                  (bVar"b",
                                                                                                                                   ITE(bVar"b",
                                                                                                                                       MU(LT,
                                                                                                                                          qTy),
                                                                                                                                       MB(MR(Close
                                                                                                                                               (qVar"s",
                                                                                                                                                Dest
                                                                                                                                                  ("CP15",
                                                                                                                                                   CTy"CP15",
                                                                                                                                                   qVar"s"))),
                                                                                                                                          Close
                                                                                                                                            (Var("v",
                                                                                                                                                 CTy"CP15"),
                                                                                                                                             MB(MU(Dest
                                                                                                                                                     ("SCR",
                                                                                                                                                      CTy"SCR",
                                                                                                                                                      Var("v",
                                                                                                                                                          CTy"CP15")),
                                                                                                                                                   qTy),
                                                                                                                                                Close
                                                                                                                                                  (Var("v",
                                                                                                                                                       CTy"SCR"),
                                                                                                                                                   MU(Dest
                                                                                                                                                        ("AW",
                                                                                                                                                         bTy,
                                                                                                                                                         Var("v",
                                                                                                                                                             CTy"SCR")),
                                                                                                                                                      qTy)))))))),
                                                                                                                             Close
                                                                                                                               (bVar"b",
                                                                                                                                ITE(bVar"b",
                                                                                                                                    MB(MR(Close
                                                                                                                                            (qVar"s",
                                                                                                                                             Dest
                                                                                                                                               ("CPSR",
                                                                                                                                                CTy"PSR",
                                                                                                                                                qVar"s"))),
                                                                                                                                       Close
                                                                                                                                         (Var("v",
                                                                                                                                              CTy"PSR"),
                                                                                                                                          MB(MB(MU(TP[Var("v",
                                                                                                                                                          CTy"PSR"),
                                                                                                                                                      LT],
                                                                                                                                                   qTy),
                                                                                                                                                Close
                                                                                                                                                  (Var("v",
                                                                                                                                                       PTy(CTy"PSR",
                                                                                                                                                           bTy)),
                                                                                                                                                   MU(Rupd
                                                                                                                                                        ("A",
                                                                                                                                                         Var("v",
                                                                                                                                                             PTy(CTy"PSR",
                                                                                                                                                                 bTy))),
                                                                                                                                                      qTy))),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    CTy"PSR"),
                                                                                                                                                MW(Close
                                                                                                                                                     (qVar"s",
                                                                                                                                                      Rupd
                                                                                                                                                        ("CPSR",
                                                                                                                                                         TP[qVar"s",
                                                                                                                                                            Var("v",
                                                                                                                                                                CTy"PSR")]))))))),
                                                                                                                                    MU(LU,
                                                                                                                                       qTy)))),
                                                                                                                          Close
                                                                                                                            (AVar
                                                                                                                               uTy,
                                                                                                                             MB(MR(Close
                                                                                                                                     (qVar"s",
                                                                                                                                      Dest
                                                                                                                                        ("CPSR",
                                                                                                                                         CTy"PSR",
                                                                                                                                         qVar"s"))),
                                                                                                                                Close
                                                                                                                                  (Var("v",
                                                                                                                                       CTy"PSR"),
                                                                                                                                   MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                      CTy"PSR"),
                                                                                                                                                  LW(0,
                                                                                                                                                     8)],
                                                                                                                                               qTy),
                                                                                                                                            Close
                                                                                                                                              (Var("v",
                                                                                                                                                   PTy(CTy"PSR",
                                                                                                                                                       F8)),
                                                                                                                                               MU(Rupd
                                                                                                                                                    ("IT",
                                                                                                                                                     Var("v",
                                                                                                                                                         PTy(CTy"PSR",
                                                                                                                                                             F8))),
                                                                                                                                                  qTy))),
                                                                                                                                         Close
                                                                                                                                           (Var("v",
                                                                                                                                                CTy"PSR"),
                                                                                                                                            MW(Close
                                                                                                                                                 (qVar"s",
                                                                                                                                                  Rupd
                                                                                                                                                    ("CPSR",
                                                                                                                                                     TP[qVar"s",
                                                                                                                                                        Var("v",
                                                                                                                                                            CTy"PSR")]))))),
                                                                                                                                      Close
                                                                                                                                        (AVar
                                                                                                                                           uTy,
                                                                                                                                         MB(MR(Close
                                                                                                                                                 (qVar"s",
                                                                                                                                                  Dest
                                                                                                                                                    ("CPSR",
                                                                                                                                                     CTy"PSR",
                                                                                                                                                     qVar"s"))),
                                                                                                                                            Close
                                                                                                                                              (Var("v",
                                                                                                                                                   CTy"PSR"),
                                                                                                                                               MB(MB(MB(MU(TP[Var("v",
                                                                                                                                                                  CTy"PSR"),
                                                                                                                                                              LF],
                                                                                                                                                           qTy),
                                                                                                                                                        Close
                                                                                                                                                          (Var("v",
                                                                                                                                                               PTy(CTy"PSR",
                                                                                                                                                                   bTy)),
                                                                                                                                                           MU(Rupd
                                                                                                                                                                ("J",
                                                                                                                                                                 Var("v",
                                                                                                                                                                     PTy(CTy"PSR",
                                                                                                                                                                         bTy))),
                                                                                                                                                              qTy))),
                                                                                                                                                     Close
                                                                                                                                                       (Var("v",
                                                                                                                                                            CTy"PSR"),
                                                                                                                                                        MW(Close
                                                                                                                                                             (qVar"s",
                                                                                                                                                              Rupd
                                                                                                                                                                ("CPSR",
                                                                                                                                                                 TP[qVar"s",
                                                                                                                                                                    Var("v",
                                                                                                                                                                        CTy"PSR")]))))),
                                                                                                                                                  Close
                                                                                                                                                    (AVar
                                                                                                                                                       uTy,
                                                                                                                                                     MB(MR(Close
                                                                                                                                                             (qVar"s",
                                                                                                                                                              Dest
                                                                                                                                                                ("CPSR",
                                                                                                                                                                 CTy"PSR",
                                                                                                                                                                 qVar"s"))),
                                                                                                                                                        Close
                                                                                                                                                          (Var("v",
                                                                                                                                                               CTy"PSR"),
                                                                                                                                                           MB(MB(MB(MB(MR(Close
                                                                                                                                                                            (qVar"s",
                                                                                                                                                                             Dest
                                                                                                                                                                               ("CP15",
                                                                                                                                                                                CTy"CP15",
                                                                                                                                                                                qVar"s"))),
                                                                                                                                                                       Close
                                                                                                                                                                         (Var("v0",
                                                                                                                                                                              CTy"CP15"),
                                                                                                                                                                          MB(MB(MU(Dest
                                                                                                                                                                                     ("SCTLR",
                                                                                                                                                                                      CTy"SCTLR",
                                                                                                                                                                                      Var("v0",
                                                                                                                                                                                          CTy"CP15")),
                                                                                                                                                                                   qTy),
                                                                                                                                                                                Close
                                                                                                                                                                                  (Var("v",
                                                                                                                                                                                       CTy"SCTLR"),
                                                                                                                                                                                   MU(Dest
                                                                                                                                                                                        ("TE",
                                                                                                                                                                                         bTy,
                                                                                                                                                                                         Var("v",
                                                                                                                                                                                             CTy"SCTLR")),
                                                                                                                                                                                      qTy))),
                                                                                                                                                                             Close
                                                                                                                                                                               (bVar"v0",
                                                                                                                                                                                MU(TP[Var("v",
                                                                                                                                                                                          CTy"PSR"),
                                                                                                                                                                                      bVar"v0"],
                                                                                                                                                                                   qTy))))),
                                                                                                                                                                    Close
                                                                                                                                                                      (Var("v",
                                                                                                                                                                           PTy(CTy"PSR",
                                                                                                                                                                               bTy)),
                                                                                                                                                                       MU(Rupd
                                                                                                                                                                            ("T",
                                                                                                                                                                             Var("v",
                                                                                                                                                                                 PTy(CTy"PSR",
                                                                                                                                                                                     bTy))),
                                                                                                                                                                          qTy))),
                                                                                                                                                                 Close
                                                                                                                                                                   (Var("v",
                                                                                                                                                                        CTy"PSR"),
                                                                                                                                                                    MW(Close
                                                                                                                                                                         (qVar"s",
                                                                                                                                                                          Rupd
                                                                                                                                                                            ("CPSR",
                                                                                                                                                                             TP[qVar"s",
                                                                                                                                                                                Var("v",
                                                                                                                                                                                    CTy"PSR")]))))),
                                                                                                                                                              Close
                                                                                                                                                                (AVar
                                                                                                                                                                   uTy,
                                                                                                                                                                 MB(MR(Close
                                                                                                                                                                         (qVar"s",
                                                                                                                                                                          Dest
                                                                                                                                                                            ("CPSR",
                                                                                                                                                                             CTy"PSR",
                                                                                                                                                                             qVar"s"))),
                                                                                                                                                                    Close
                                                                                                                                                                      (Var("v",
                                                                                                                                                                           CTy"PSR"),
                                                                                                                                                                       MB(MB(MB(MB(MR(Close
                                                                                                                                                                                        (qVar"s",
                                                                                                                                                                                         Dest
                                                                                                                                                                                           ("CP15",
                                                                                                                                                                                            CTy"CP15",
                                                                                                                                                                                            qVar"s"))),
                                                                                                                                                                                   Close
                                                                                                                                                                                     (Var("v0",
                                                                                                                                                                                          CTy"CP15"),
                                                                                                                                                                                      MB(MB(MU(Dest
                                                                                                                                                                                                 ("SCTLR",
                                                                                                                                                                                                  CTy"SCTLR",
                                                                                                                                                                                                  Var("v0",
                                                                                                                                                                                                      CTy"CP15")),
                                                                                                                                                                                               qTy),
                                                                                                                                                                                            Close
                                                                                                                                                                                              (Var("v",
                                                                                                                                                                                                   CTy"SCTLR"),
                                                                                                                                                                                               MU(Dest
                                                                                                                                                                                                    ("EE",
                                                                                                                                                                                                     bTy,
                                                                                                                                                                                                     Var("v",
                                                                                                                                                                                                         CTy"SCTLR")),
                                                                                                                                                                                                  qTy))),
                                                                                                                                                                                         Close
                                                                                                                                                                                           (bVar"v0",
                                                                                                                                                                                            MU(TP[Var("v",
                                                                                                                                                                                                      CTy"PSR"),
                                                                                                                                                                                                  bVar"v0"],
                                                                                                                                                                                               qTy))))),
                                                                                                                                                                                Close
                                                                                                                                                                                  (Var("v",
                                                                                                                                                                                       PTy(CTy"PSR",
                                                                                                                                                                                           bTy)),
                                                                                                                                                                                   MU(Rupd
                                                                                                                                                                                        ("E",
                                                                                                                                                                                         Var("v",
                                                                                                                                                                                             PTy(CTy"PSR",
                                                                                                                                                                                                 bTy))),
                                                                                                                                                                                      qTy))),
                                                                                                                                                                             Close
                                                                                                                                                                               (Var("v",
                                                                                                                                                                                    CTy"PSR"),
                                                                                                                                                                                MW(Close
                                                                                                                                                                                     (qVar"s",
                                                                                                                                                                                      Rupd
                                                                                                                                                                                        ("CPSR",
                                                                                                                                                                                         TP[qVar"s",
                                                                                                                                                                                            Var("v",
                                                                                                                                                                                                CTy"PSR")]))))),
                                                                                                                                                                          Close
                                                                                                                                                                            (AVar
                                                                                                                                                                               uTy,
                                                                                                                                                                             MB(MR(Close
                                                                                                                                                                                     (qVar"s",
                                                                                                                                                                                      Dest
                                                                                                                                                                                        ("CP15",
                                                                                                                                                                                         CTy"CP15",
                                                                                                                                                                                         qVar"s"))),
                                                                                                                                                                                Close
                                                                                                                                                                                  (Var("v",
                                                                                                                                                                                       CTy"CP15"),
                                                                                                                                                                                   MB(MB(MU(Dest
                                                                                                                                                                                              ("SCTLR",
                                                                                                                                                                                               CTy"SCTLR",
                                                                                                                                                                                               Var("v",
                                                                                                                                                                                                   CTy"CP15")),
                                                                                                                                                                                            qTy),
                                                                                                                                                                                         Close
                                                                                                                                                                                           (Var("v",
                                                                                                                                                                                                CTy"SCTLR"),
                                                                                                                                                                                            MU(Dest
                                                                                                                                                                                                 ("VE",
                                                                                                                                                                                                  bTy,
                                                                                                                                                                                                  Var("v",
                                                                                                                                                                                                      CTy"SCTLR")),
                                                                                                                                                                                               qTy))),
                                                                                                                                                                                      Close
                                                                                                                                                                                        (bVar"b",
                                                                                                                                                                                         ITE(bVar"b",
                                                                                                                                                                                             Call
                                                                                                                                                                                               ("raise'exception",
                                                                                                                                                                                                ATy(qTy,
                                                                                                                                                                                                    PTy(uTy,
                                                                                                                                                                                                        qTy)),
                                                                                                                                                                                                Call
                                                                                                                                                                                                  ("IMPLEMENTATION_DEFINED",
                                                                                                                                                                                                   CTy"exception",
                                                                                                                                                                                                   LS
                                                                                                                                                                                                    "branch to an FIQ vector")),
                                                                                                                                                                                             MB(Call
                                                                                                                                                                                                  ("ExcVectorBase",
                                                                                                                                                                                                   ATy(qTy,
                                                                                                                                                                                                       PTy(F32,
                                                                                                                                                                                                           qTy)),
                                                                                                                                                                                                   LU),
                                                                                                                                                                                                Close
                                                                                                                                                                                                  (Var("v",
                                                                                                                                                                                                       F32),
                                                                                                                                                                                                   MB(MU(Bop(Add,
                                                                                                                                                                                                             Var("v",
                                                                                                                                                                                                                 F32),
                                                                                                                                                                                                             Var("vect_offset",
                                                                                                                                                                                                                 F32)),
                                                                                                                                                                                                         qTy),
                                                                                                                                                                                                      Close
                                                                                                                                                                                                        (Var("v",
                                                                                                                                                                                                             F32),
                                                                                                                                                                                                         Call
                                                                                                                                                                                                           ("BranchTo",
                                                                                                                                                                                                            ATy(qTy,
                                                                                                                                                                                                                PTy(uTy,
                                                                                                                                                                                                                    qTy)),
                                                                                                                                                                                                            Var("v",
                                                                                                                                                                                                                F32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
;
val TakeVirtualFIQException_def = Def
  ("TakeVirtualFIQException",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",Const("PC",ATy(qTy,PTy(F32,qTy))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy)))))),
            Close
              (Var("new_lr_value",F32),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("new_spsr_value",CTy"PSR"),
                     MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                        Close
                          (Var("v",CTy"PSR"),
                           MB(MB(MB(MU(TP[Var("v",CTy"PSR"),LW(17,5)],qTy),
                                    Close
                                      (Var("v",PTy(CTy"PSR",FTy 5)),
                                       MU(Rupd
                                            ("M",
                                             Var("v",PTy(CTy"PSR",FTy 5))),
                                          qTy))),
                                 Close
                                   (Var("v",CTy"PSR"),
                                    MW(Close
                                         (qVar"s",
                                          Rupd
                                            ("CPSR",
                                             TP[qVar"s",Var("v",CTy"PSR")]))))),
                              Close
                                (AVar uTy,
                                 MB(Call
                                      ("write'SPSR",ATy(qTy,PTy(uTy,qTy)),
                                       Var("new_spsr_value",CTy"PSR")),
                                    Close
                                      (AVar uTy,
                                       MB(Call
                                            ("write'R",
                                             ATy(qTy,PTy(uTy,qTy)),
                                             TP[Var("new_lr_value",F32),
                                                LW(14,4)]),
                                          Close
                                            (AVar uTy,
                                             MB(MR(Close
                                                     (qVar"s",
                                                      Dest
                                                        ("CPSR",CTy"PSR",
                                                         qVar"s"))),
                                                Close
                                                  (Var("v",CTy"PSR"),
                                                   MB(MB(MB(MU(TP[Var("v",
                                                                      CTy"PSR"),
                                                                  LT],qTy),
                                                            Close
                                                              (Var("v",
                                                                   PTy(CTy"PSR",
                                                                       bTy)),
                                                               MU(Rupd
                                                                    ("I",
                                                                     Var("v",
                                                                         PTy(CTy"PSR",
                                                                             bTy))),
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                CTy"PSR"),
                                                            MW(Close
                                                                 (qVar"s",
                                                                  Rupd
                                                                    ("CPSR",
                                                                     TP[qVar"s",
                                                                        Var("v",
                                                                            CTy"PSR")]))))),
                                                      Close
                                                        (AVar uTy,
                                                         MB(MR(Close
                                                                 (qVar"s",
                                                                  Dest
                                                                    ("CPSR",
                                                                     CTy"PSR",
                                                                     qVar"s"))),
                                                            Close
                                                              (Var("v",
                                                                   CTy"PSR"),
                                                               MB(MB(MB(MU(TP[Var("v",
                                                                                  CTy"PSR"),
                                                                              LT],
                                                                           qTy),
                                                                        Close
                                                                          (Var("v",
                                                                               PTy(CTy"PSR",
                                                                                   bTy)),
                                                                           MU(Rupd
                                                                                ("F",
                                                                                 Var("v",
                                                                                     PTy(CTy"PSR",
                                                                                         bTy))),
                                                                              qTy))),
                                                                     Close
                                                                       (Var("v",
                                                                            CTy"PSR"),
                                                                        MW(Close
                                                                             (qVar"s",
                                                                              Rupd
                                                                                ("CPSR",
                                                                                 TP[qVar"s",
                                                                                    Var("v",
                                                                                        CTy"PSR")]))))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MB(MR(Close
                                                                             (qVar"s",
                                                                              Dest
                                                                                ("CPSR",
                                                                                 CTy"PSR",
                                                                                 qVar"s"))),
                                                                        Close
                                                                          (Var("v",
                                                                               CTy"PSR"),
                                                                           MB(MB(MB(MU(TP[Var("v",
                                                                                              CTy"PSR"),
                                                                                          LT],
                                                                                       qTy),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           PTy(CTy"PSR",
                                                                                               bTy)),
                                                                                       MU(Rupd
                                                                                            ("A",
                                                                                             Var("v",
                                                                                                 PTy(CTy"PSR",
                                                                                                     bTy))),
                                                                                          qTy))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"PSR"),
                                                                                    MW(Close
                                                                                         (qVar"s",
                                                                                          Rupd
                                                                                            ("CPSR",
                                                                                             TP[qVar"s",
                                                                                                Var("v",
                                                                                                    CTy"PSR")]))))),
                                                                              Close
                                                                                (AVar
                                                                                   uTy,
                                                                                 MB(MR(Close
                                                                                         (qVar"s",
                                                                                          Dest
                                                                                            ("CPSR",
                                                                                             CTy"PSR",
                                                                                             qVar"s"))),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           CTy"PSR"),
                                                                                       MB(MB(MB(MU(TP[Var("v",
                                                                                                          CTy"PSR"),
                                                                                                      LW(0,
                                                                                                         8)],
                                                                                                   qTy),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       PTy(CTy"PSR",
                                                                                                           F8)),
                                                                                                   MU(Rupd
                                                                                                        ("IT",
                                                                                                         Var("v",
                                                                                                             PTy(CTy"PSR",
                                                                                                                 F8))),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"PSR"),
                                                                                                MW(Close
                                                                                                     (qVar"s",
                                                                                                      Rupd
                                                                                                        ("CPSR",
                                                                                                         TP[qVar"s",
                                                                                                            Var("v",
                                                                                                                CTy"PSR")]))))),
                                                                                          Close
                                                                                            (AVar
                                                                                               uTy,
                                                                                             MB(MR(Close
                                                                                                     (qVar"s",
                                                                                                      Dest
                                                                                                        ("CPSR",
                                                                                                         CTy"PSR",
                                                                                                         qVar"s"))),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       CTy"PSR"),
                                                                                                   MB(MB(MB(MU(TP[Var("v",
                                                                                                                      CTy"PSR"),
                                                                                                                  LF],
                                                                                                               qTy),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   PTy(CTy"PSR",
                                                                                                                       bTy)),
                                                                                                               MU(Rupd
                                                                                                                    ("J",
                                                                                                                     Var("v",
                                                                                                                         PTy(CTy"PSR",
                                                                                                                             bTy))),
                                                                                                                  qTy))),
                                                                                                         Close
                                                                                                           (Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            MW(Close
                                                                                                                 (qVar"s",
                                                                                                                  Rupd
                                                                                                                    ("CPSR",
                                                                                                                     TP[qVar"s",
                                                                                                                        Var("v",
                                                                                                                            CTy"PSR")]))))),
                                                                                                      Close
                                                                                                        (AVar
                                                                                                           uTy,
                                                                                                         MB(MR(Close
                                                                                                                 (qVar"s",
                                                                                                                  Dest
                                                                                                                    ("CPSR",
                                                                                                                     CTy"PSR",
                                                                                                                     qVar"s"))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   CTy"PSR"),
                                                                                                               MB(MB(MB(MB(MR(Close
                                                                                                                                (qVar"s",
                                                                                                                                 Dest
                                                                                                                                   ("CP15",
                                                                                                                                    CTy"CP15",
                                                                                                                                    qVar"s"))),
                                                                                                                           Close
                                                                                                                             (Var("v0",
                                                                                                                                  CTy"CP15"),
                                                                                                                              MB(MB(MU(Dest
                                                                                                                                         ("SCTLR",
                                                                                                                                          CTy"SCTLR",
                                                                                                                                          Var("v0",
                                                                                                                                              CTy"CP15")),
                                                                                                                                       qTy),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           CTy"SCTLR"),
                                                                                                                                       MU(Dest
                                                                                                                                            ("TE",
                                                                                                                                             bTy,
                                                                                                                                             Var("v",
                                                                                                                                                 CTy"SCTLR")),
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (bVar"v0",
                                                                                                                                    MU(TP[Var("v",
                                                                                                                                              CTy"PSR"),
                                                                                                                                          bVar"v0"],
                                                                                                                                       qTy))))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               PTy(CTy"PSR",
                                                                                                                                   bTy)),
                                                                                                                           MU(Rupd
                                                                                                                                ("T",
                                                                                                                                 Var("v",
                                                                                                                                     PTy(CTy"PSR",
                                                                                                                                         bTy))),
                                                                                                                              qTy))),
                                                                                                                     Close
                                                                                                                       (Var("v",
                                                                                                                            CTy"PSR"),
                                                                                                                        MW(Close
                                                                                                                             (qVar"s",
                                                                                                                              Rupd
                                                                                                                                ("CPSR",
                                                                                                                                 TP[qVar"s",
                                                                                                                                    Var("v",
                                                                                                                                        CTy"PSR")]))))),
                                                                                                                  Close
                                                                                                                    (AVar
                                                                                                                       uTy,
                                                                                                                     MB(MR(Close
                                                                                                                             (qVar"s",
                                                                                                                              Dest
                                                                                                                                ("CPSR",
                                                                                                                                 CTy"PSR",
                                                                                                                                 qVar"s"))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               CTy"PSR"),
                                                                                                                           MB(MB(MB(MB(MR(Close
                                                                                                                                            (qVar"s",
                                                                                                                                             Dest
                                                                                                                                               ("CP15",
                                                                                                                                                CTy"CP15",
                                                                                                                                                qVar"s"))),
                                                                                                                                       Close
                                                                                                                                         (Var("v0",
                                                                                                                                              CTy"CP15"),
                                                                                                                                          MB(MB(MU(Dest
                                                                                                                                                     ("SCTLR",
                                                                                                                                                      CTy"SCTLR",
                                                                                                                                                      Var("v0",
                                                                                                                                                          CTy"CP15")),
                                                                                                                                                   qTy),
                                                                                                                                                Close
                                                                                                                                                  (Var("v",
                                                                                                                                                       CTy"SCTLR"),
                                                                                                                                                   MU(Dest
                                                                                                                                                        ("EE",
                                                                                                                                                         bTy,
                                                                                                                                                         Var("v",
                                                                                                                                                             CTy"SCTLR")),
                                                                                                                                                      qTy))),
                                                                                                                                             Close
                                                                                                                                               (bVar"v0",
                                                                                                                                                MU(TP[Var("v",
                                                                                                                                                          CTy"PSR"),
                                                                                                                                                      bVar"v0"],
                                                                                                                                                   qTy))))),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           PTy(CTy"PSR",
                                                                                                                                               bTy)),
                                                                                                                                       MU(Rupd
                                                                                                                                            ("E",
                                                                                                                                             Var("v",
                                                                                                                                                 PTy(CTy"PSR",
                                                                                                                                                     bTy))),
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    MW(Close
                                                                                                                                         (qVar"s",
                                                                                                                                          Rupd
                                                                                                                                            ("CPSR",
                                                                                                                                             TP[qVar"s",
                                                                                                                                                Var("v",
                                                                                                                                                    CTy"PSR")]))))),
                                                                                                                              Close
                                                                                                                                (AVar
                                                                                                                                   uTy,
                                                                                                                                 MB(MR(Close
                                                                                                                                         (qVar"s",
                                                                                                                                          Dest
                                                                                                                                            ("CP15",
                                                                                                                                             CTy"CP15",
                                                                                                                                             qVar"s"))),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           CTy"CP15"),
                                                                                                                                       MB(MB(MU(Dest
                                                                                                                                                  ("SCTLR",
                                                                                                                                                   CTy"SCTLR",
                                                                                                                                                   Var("v",
                                                                                                                                                       CTy"CP15")),
                                                                                                                                                qTy),
                                                                                                                                             Close
                                                                                                                                               (Var("v",
                                                                                                                                                    CTy"SCTLR"),
                                                                                                                                                MU(Dest
                                                                                                                                                     ("VE",
                                                                                                                                                      bTy,
                                                                                                                                                      Var("v",
                                                                                                                                                          CTy"SCTLR")),
                                                                                                                                                   qTy))),
                                                                                                                                          Close
                                                                                                                                            (bVar"b",
                                                                                                                                             ITE(bVar"b",
                                                                                                                                                 Call
                                                                                                                                                   ("raise'exception",
                                                                                                                                                    ATy(qTy,
                                                                                                                                                        PTy(uTy,
                                                                                                                                                            qTy)),
                                                                                                                                                    Call
                                                                                                                                                      ("IMPLEMENTATION_DEFINED",
                                                                                                                                                       CTy"exception",
                                                                                                                                                       LS
                                                                                                                                                        "branch to an FIQ vector")),
                                                                                                                                                 MB(Call
                                                                                                                                                      ("ExcVectorBase",
                                                                                                                                                       ATy(qTy,
                                                                                                                                                           PTy(F32,
                                                                                                                                                               qTy)),
                                                                                                                                                       LU),
                                                                                                                                                    Close
                                                                                                                                                      (Var("v",
                                                                                                                                                           F32),
                                                                                                                                                       MB(MU(Bop(Add,
                                                                                                                                                                 Var("v",
                                                                                                                                                                     F32),
                                                                                                                                                                 LW(28,
                                                                                                                                                                    32)),
                                                                                                                                                             qTy),
                                                                                                                                                          Close
                                                                                                                                                            (Var("v",
                                                                                                                                                                 F32),
                                                                                                                                                             Call
                                                                                                                                                               ("BranchTo",
                                                                                                                                                                ATy(qTy,
                                                                                                                                                                    PTy(uTy,
                                                                                                                                                                        qTy)),
                                                                                                                                                                Var("v",
                                                                                                                                                                    F32))))))))))))))))))))))))))))))))))))))))))))))))))))))
;
val TakeHypTrapException_def = Def
  ("TakeHypTrapException",AVar uTy,
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MU(Dest("T",bTy,Var("v",CTy"PSR")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Sub,Var("v",F32),LW(8,32)),qTy)))))),
            Close
              (Var("preferred_exceptn_return",F32),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("new_spsr_value",CTy"PSR"),
                     Call
                       ("EnterHypMode",ATy(qTy,PTy(uTy,qTy)),
                        TP[Var("new_spsr_value",CTy"PSR"),
                           Var("preferred_exceptn_return",F32),LW(20,32)]))))))))
;
val WriteHSR_def = Def
  ("WriteHSR",TP[Var("ec",FTy 6),Var("HSRString",FTy 25)],
   MN(LW(0,32),
      MB(MR(Close(Var("s",PTy(F32,qTy)),Mop(Fst,Var("s",PTy(F32,qTy))))),
         Close
           (Var("v",F32),
            MB(MB(MU(BFI(LN 31,LN 26,Var("ec",FTy 6),Var("v",F32)),
                     PTy(F32,qTy)),
                  Close
                    (Var("v",F32),
                     MW(Close
                          (Var("s",PTy(F32,qTy)),
                           TP[Var("v",F32),Mop(Snd,Var("s",PTy(F32,qTy)))])))),
               Close
                 (AVar uTy,
                  MB(ITE(Bop(Or,
                             Mop(Not,
                                 EQ(EX(Var("ec",FTy 6),LN 5,LN 3,FTy 3),
                                    LW(4,3))),
                             Bop(And,Bop(Bit,Var("ec",FTy 6),LN 2),
                                 Bop(Bit,Var("HSRString",FTy 25),LN 24))),
                         MB(MR(Close
                                 (Var("s",PTy(F32,qTy)),
                                  Mop(Fst,Var("s",PTy(F32,qTy))))),
                            Close
                              (Var("v",F32),
                               MB(MB(MD(Call
                                          ("ThisInstrLength",
                                           ATy(qTy,PTy(nTy,qTy)),LU),F32),
                                     Close
                                       (nVar"v0",
                                        MB(MB(MU(EQ(nVar"v0",LN 32),
                                                 PTy(F32,qTy)),
                                              Close
                                                (bVar"v",
                                                 MU(Mop(Cast F1,bVar"v"),
                                                    PTy(F32,qTy)))),
                                           Close
                                             (Var("v0",F1),
                                              MU(BFI(LN 25,LN 25,
                                                     Var("v0",F1),
                                                     Var("v",F32)),
                                                 PTy(F32,qTy)))))),
                                  Close
                                    (Var("v",F32),
                                     MW(Close
                                          (Var("s",PTy(F32,qTy)),
                                           TP[Var("v",F32),
                                              Mop(Snd,
                                                  Var("s",PTy(F32,qTy)))])))))),
                         MU(LU,PTy(F32,qTy))),
                     Close
                       (AVar uTy,
                        MB(ITE(Bop(And,
                                   EQ(EX(Var("ec",FTy 6),LN 5,LN 4,FTy 2),
                                      LW(0,2)),
                                   Mop(Not,
                                       EQ(EX(Var("ec",FTy 6),LN 3,LN 0,F4),
                                          LW(0,4)))),
                               MB(MD(Call
                                       ("CurrentInstrSet",
                                        ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
                                     F32),
                                  Close
                                    (Var("v",CTy"InstrSet"),
                                     MB(MU(EQ(Var("v",CTy"InstrSet"),
                                              LC("InstrSet_ARM",
                                                 CTy"InstrSet")),
                                           PTy(F32,qTy)),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(MR(Close
                                                       (Var("s",
                                                            PTy(F32,qTy)),
                                                        Mop(Fst,
                                                            Var("s",
                                                                PTy(F32,
                                                                    qTy))))),
                                                  Close
                                                    (Var("v",F32),
                                                     MB(MB(MU(BFI(LN 24,
                                                                  LN 24,
                                                                  Mop(Cast
                                                                        F1,
                                                                      LT),
                                                                  Var("v",
                                                                      F32)),
                                                              PTy(F32,qTy)),
                                                           Close
                                                             (Var("v",F32),
                                                              MW(Close
                                                                   (Var("s",
                                                                        PTy(F32,
                                                                            qTy)),
                                                                    TP[Var("v",
                                                                           F32),
                                                                       Mop(Snd,
                                                                           Var("s",
                                                                               PTy(F32,
                                                                                   qTy)))])))),
                                                        Close
                                                          (AVar uTy,
                                                           MB(MR(Close
                                                                   (Var("s",
                                                                        PTy(F32,
                                                                            qTy)),
                                                                    Mop(Fst,
                                                                        Var("s",
                                                                            PTy(F32,
                                                                                qTy))))),
                                                              Close
                                                                (Var("v",
                                                                     F32),
                                                                 MB(MB(MD(Call
                                                                            ("CurrentCond",
                                                                             ATy(qTy,
                                                                                 PTy(F4,
                                                                                     qTy)),
                                                                             LU),
                                                                          F32),
                                                                       Close
                                                                         (Var("v0",
                                                                              F4),
                                                                          MU(BFI(LN
                                                                                  23,
                                                                                 LN
                                                                                  20,
                                                                                 Var("v0",
                                                                                     F4),
                                                                                 Var("v",
                                                                                     F32)),
                                                                             PTy(F32,
                                                                                 qTy)))),
                                                                    Close
                                                                      (Var("v",
                                                                           F32),
                                                                       MW(Close
                                                                            (Var("s",
                                                                                 PTy(F32,
                                                                                     qTy)),
                                                                             TP[Var("v",
                                                                                    F32),
                                                                                Mop(Snd,
                                                                                    Var("s",
                                                                                        PTy(F32,
                                                                                            qTy)))])))))))))),
                                               MB(MR(Close
                                                       (Var("s",
                                                            PTy(F32,qTy)),
                                                        Mop(Fst,
                                                            Var("s",
                                                                PTy(F32,
                                                                    qTy))))),
                                                  Close
                                                    (Var("v",F32),
                                                     MB(MB(MU(BFI(LN 24,
                                                                  LN 24,
                                                                  Mop(Cast
                                                                        F1,
                                                                      LX bTy),
                                                                  Var("v",
                                                                      F32)),
                                                              PTy(F32,qTy)),
                                                           Close
                                                             (Var("v",F32),
                                                              MW(Close
                                                                   (Var("s",
                                                                        PTy(F32,
                                                                            qTy)),
                                                                    TP[Var("v",
                                                                           F32),
                                                                       Mop(Snd,
                                                                           Var("s",
                                                                               PTy(F32,
                                                                                   qTy)))])))),
                                                        Close
                                                          (AVar uTy,
                                                           MB(MR(Close
                                                                   (Var("s",
                                                                        PTy(F32,
                                                                            qTy)),
                                                                    Mop(Fst,
                                                                        Var("s",
                                                                            PTy(F32,
                                                                                qTy))))),
                                                              Close
                                                                (Var("v",
                                                                     F32),
                                                                 MB(MB(MU(Bop(Bit,
                                                                              Var("v",
                                                                                  F32),
                                                                              LN
                                                                               24),
                                                                          PTy(F32,
                                                                              qTy)),
                                                                       Close
                                                                         (bVar"b",
                                                                          ITE(bVar"b",
                                                                              MB(MD(Call
                                                                                      ("ConditionPassed",
                                                                                       ATy(qTy,
                                                                                           PTy(bTy,
                                                                                               qTy)),
                                                                                       LU),
                                                                                    F32),
                                                                                 Close
                                                                                   (bVar"b",
                                                                                    ITE(bVar"b",
                                                                                        MB(MR(Close
                                                                                                (Var("s",
                                                                                                     PTy(F32,
                                                                                                         qTy)),
                                                                                                 Mop(Fst,
                                                                                                     Var("s",
                                                                                                         PTy(F32,
                                                                                                             qTy))))),
                                                                                           Close
                                                                                             (Var("v",
                                                                                                  F32),
                                                                                              MB(MB(ITE(LX bTy,
                                                                                                        MD(Call
                                                                                                             ("CurrentCond",
                                                                                                              ATy(qTy,
                                                                                                                  PTy(F4,
                                                                                                                      qTy)),
                                                                                                              LU),
                                                                                                           F32),
                                                                                                        MU(LW(14,
                                                                                                              4),
                                                                                                           PTy(F32,
                                                                                                               qTy))),
                                                                                                    Close
                                                                                                      (Var("v0",
                                                                                                           F4),
                                                                                                       MU(BFI(LN
                                                                                                               23,
                                                                                                              LN
                                                                                                               20,
                                                                                                              Var("v0",
                                                                                                                  F4),
                                                                                                              Var("v",
                                                                                                                  F32)),
                                                                                                          PTy(F32,
                                                                                                              qTy)))),
                                                                                                 Close
                                                                                                   (Var("v",
                                                                                                        F32),
                                                                                                    MW(Close
                                                                                                         (Var("s",
                                                                                                              PTy(F32,
                                                                                                                  qTy)),
                                                                                                          TP[Var("v",
                                                                                                                 F32),
                                                                                                             Mop(Snd,
                                                                                                                 Var("s",
                                                                                                                     PTy(F32,
                                                                                                                         qTy)))])))))),
                                                                                        MB(MR(Close
                                                                                                (Var("s",
                                                                                                     PTy(F32,
                                                                                                         qTy)),
                                                                                                 Mop(Fst,
                                                                                                     Var("s",
                                                                                                         PTy(F32,
                                                                                                             qTy))))),
                                                                                           Close
                                                                                             (Var("v",
                                                                                                  F32),
                                                                                              MB(MB(MD(Call
                                                                                                         ("CurrentCond",
                                                                                                          ATy(qTy,
                                                                                                              PTy(F4,
                                                                                                                  qTy)),
                                                                                                          LU),
                                                                                                       F32),
                                                                                                    Close
                                                                                                      (Var("v0",
                                                                                                           F4),
                                                                                                       MU(BFI(LN
                                                                                                               23,
                                                                                                              LN
                                                                                                               20,
                                                                                                              Var("v0",
                                                                                                                  F4),
                                                                                                              Var("v",
                                                                                                                  F32)),
                                                                                                          PTy(F32,
                                                                                                              qTy)))),
                                                                                                 Close
                                                                                                   (Var("v",
                                                                                                        F32),
                                                                                                    MW(Close
                                                                                                         (Var("s",
                                                                                                              PTy(F32,
                                                                                                                  qTy)),
                                                                                                          TP[Var("v",
                                                                                                                 F32),
                                                                                                             Mop(Snd,
                                                                                                                 Var("s",
                                                                                                                     PTy(F32,
                                                                                                                         qTy)))]))))))))),
                                                                              MU(LU,
                                                                                 PTy(F32,
                                                                                     qTy))))),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MB(MR(Close
                                                                               (Var("s",
                                                                                    PTy(F32,
                                                                                        qTy)),
                                                                                Mop(Fst,
                                                                                    Var("s",
                                                                                        PTy(F32,
                                                                                            qTy))))),
                                                                          Close
                                                                            (Var("v",
                                                                                 F32),
                                                                             MB(MU(BFI(LN
                                                                                        19,
                                                                                       LN
                                                                                        0,
                                                                                       EX(Var("HSRString",
                                                                                              FTy 25),
                                                                                          LN
                                                                                           19,
                                                                                          LN
                                                                                           0,
                                                                                          FTy 20),
                                                                                       Var("v",
                                                                                           F32)),
                                                                                   PTy(F32,
                                                                                       qTy)),
                                                                                Close
                                                                                  (Var("v",
                                                                                       F32),
                                                                                   MW(Close
                                                                                        (Var("s",
                                                                                             PTy(F32,
                                                                                                 qTy)),
                                                                                         TP[Var("v",
                                                                                                F32),
                                                                                            Mop(Snd,
                                                                                                Var("s",
                                                                                                    PTy(F32,
                                                                                                        qTy)))]))))))))))))))))))),
                               MB(MR(Close
                                       (Var("s",PTy(F32,qTy)),
                                        Mop(Fst,Var("s",PTy(F32,qTy))))),
                                  Close
                                    (Var("v",F32),
                                     MB(MU(BFI(LN 24,LN 0,
                                               Var("HSRString",FTy 25),
                                               Var("v",F32)),PTy(F32,qTy)),
                                        Close
                                          (Var("v",F32),
                                           MW(Close
                                                (Var("s",PTy(F32,qTy)),
                                                 TP[Var("v",F32),
                                                    Mop(Snd,
                                                        Var("s",
                                                            PTy(F32,qTy)))]))))))),
                           Close
                             (AVar uTy,
                              MB(MR(Close
                                      (Var("s",PTy(F32,qTy)),
                                       Dest
                                         ("CP15",CTy"CP15",
                                          Mop(Snd,Var("s",PTy(F32,qTy)))))),
                                 Close
                                   (Var("v",CTy"CP15"),
                                    MB(MU(Dest
                                            ("HSR",CTy"HSR",
                                             Var("v",CTy"CP15")),
                                          PTy(F32,qTy)),
                                       Close
                                         (Var("x0",CTy"HSR"),
                                          MB(MR(Close
                                                  (Var("s",PTy(F32,qTy)),
                                                   Dest
                                                     ("CP15",CTy"CP15",
                                                      Mop(Snd,
                                                          Var("s",
                                                              PTy(F32,qTy)))))),
                                             Close
                                               (Var("v",CTy"CP15"),
                                                MB(MB(MB(MR(Close
                                                              (Var("s",
                                                                   PTy(F32,
                                                                       qTy)),
                                                               Mop(Fst,
                                                                   Var("s",
                                                                       PTy(F32,
                                                                           qTy))))),
                                                         Close
                                                           (Var("v0",F32),
                                                            MB(MB(MU(TP[Var("x0",
                                                                            CTy"HSR"),
                                                                        Var("v0",
                                                                            F32)],
                                                                     PTy(F32,
                                                                         qTy)),
                                                                  Close
                                                                    (Var("v",
                                                                         PTy(CTy"HSR",
                                                                             F32)),
                                                                     MU(Call
                                                                          ("write'reg'HSR",
                                                                           CTy"HSR",
                                                                           Var("v",
                                                                               PTy(CTy"HSR",
                                                                                   F32))),
                                                                        PTy(F32,
                                                                            qTy)))),
                                                               Close
                                                                 (Var("v0",
                                                                      CTy"HSR"),
                                                                  MU(TP[Var("v",
                                                                            CTy"CP15"),
                                                                        Var("v0",
                                                                            CTy"HSR")],
                                                                     PTy(F32,
                                                                         qTy)))))),
                                                      Close
                                                        (Var("v",
                                                             PTy(CTy"CP15",
                                                                 CTy"HSR")),
                                                         MU(Rupd
                                                              ("HSR",
                                                               Var("v",
                                                                   PTy(CTy"CP15",
                                                                       CTy"HSR"))),
                                                            PTy(F32,qTy)))),
                                                   Close
                                                     (Var("v",CTy"CP15"),
                                                      MW(Close
                                                           (Var("s",
                                                                PTy(F32,
                                                                    qTy)),
                                                            TP[Mop(Fst,
                                                                   Var("s",
                                                                       PTy(F32,
                                                                           qTy))),
                                                               Rupd
                                                                 ("CP15",
                                                                  TP[Mop(Snd,
                                                                         Var("s",
                                                                             PTy(F32,
                                                                                 qTy))),
                                                                     Var("v",
                                                                         CTy"CP15")])]))))))))))))))))))))
;
val CallSupervisor_def = Def
  ("CallSupervisor",Var("immediate",F16),
   MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(ITE(bVar"v",MU(LT,qTy),
                   MB(Call("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
                      Close
                        (bVar"v",
                         MB(MB(ITE(bVar"v",
                                   MB(Call
                                        ("IsSecure",ATy(qTy,PTy(bTy,qTy)),
                                         LU),
                                      Close
                                        (bVar"v",MU(Mop(Not,bVar"v"),qTy))),
                                   MU(LF,qTy)),
                               Close
                                 (bVar"b",
                                  ITE(bVar"b",
                                      MB(Call
                                           ("CurrentModeIsNotUser",
                                            ATy(qTy,PTy(bTy,qTy)),LU),
                                         Close
                                           (bVar"v",
                                            MU(Mop(Not,bVar"v"),qTy))),
                                      MU(LF,qTy)))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("CP15",CTy"CP15",qVar"s"))),
                                      Close
                                        (Var("v",CTy"CP15"),
                                         MB(MU(Dest
                                                 ("HCR",CTy"HCR",
                                                  Var("v",CTy"CP15")),qTy),
                                            Close
                                              (Var("v",CTy"HCR"),
                                               MU(Dest
                                                    ("TGE",bTy,
                                                     Var("v",CTy"HCR")),
                                                  qTy))))),MU(LF,qTy))))))),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MN(LW(0,25),
                         MB(MR(Close
                                 (Var("s",PTy(FTy 25,qTy)),
                                  Mop(Fst,Var("s",PTy(FTy 25,qTy))))),
                            Close
                              (Var("v",FTy 25),
                               MB(MB(MB(MD(Call
                                             ("CurrentCond",
                                              ATy(qTy,PTy(F4,qTy)),LU),
                                           FTy 25),
                                        Close
                                          (Var("v0",F4),
                                           MB(MB(MU(EQ(Var("v0",F4),
                                                       LW(14,4)),
                                                    PTy(FTy 25,qTy)),
                                                 Close
                                                   (bVar"b",
                                                    MU(ITE(bVar"b",
                                                           Var("immediate",
                                                               F16),LX F16),
                                                       PTy(FTy 25,qTy)))),
                                              Close
                                                (Var("v0",F16),
                                                 MU(BFI(LN 15,LN 0,
                                                        Var("v0",F16),
                                                        Var("v",FTy 25)),
                                                    PTy(FTy 25,qTy)))))),
                                     Close
                                       (Var("v",FTy 25),
                                        MW(Close
                                             (Var("s",PTy(FTy 25,qTy)),
                                              TP[Var("v",FTy 25),
                                                 Mop(Snd,
                                                     Var("s",
                                                         PTy(FTy 25,qTy)))])))),
                                  Close
                                    (AVar uTy,
                                     MB(MR(Close
                                             (Var("s",PTy(FTy 25,qTy)),
                                              Mop(Fst,
                                                  Var("s",PTy(FTy 25,qTy))))),
                                        Close
                                          (Var("v",FTy 25),
                                           MB(MU(TP[LW(18,6),
                                                    Var("v",FTy 25)],
                                                 PTy(FTy 25,qTy)),
                                              Close
                                                (Var("v",PTy(FTy 6,FTy 25)),
                                                 MD(Call
                                                      ("WriteHSR",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       Var("v",
                                                           PTy(FTy 6,
                                                               FTy 25))),
                                                    FTy 25)))))))))),
                      MU(LU,qTy)))),
            Close
              (AVar uTy,Call("TakeSVCException",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val CallHypervisor_def = Def
  ("CallHypervisor",Var("immediate",F16),
   MB(Call
        ("WriteHSR",ATy(qTy,PTy(uTy,qTy)),
         TP[LW(18,6),CC[Var("immediate",F16),LW(0,9)]]),
      Close(AVar uTy,Call("TakeHVCException",ATy(qTy,PTy(uTy,qTy)),LU))))
;
val BankedRegisterAccessValid_def = Def
  ("BankedRegisterAccessValid",TP[Var("SYSm",FTy 5),Var("mode",FTy 5)],
   ITB([(EQ(EX(Var("SYSm",FTy 5),LN 4,LN 3,FTy 2),LW(0,2)),
         ITB([(EQ(EX(Var("SYSm",FTy 5),LN 2,LN 0,FTy 3),LW(7,3)),
               Call
                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                  Call
                    ("UNPREDICTABLE",CTy"exception",
                     LS"BankedRegisterAccessValid"))),
              (EQ(EX(Var("SYSm",FTy 5),LN 2,LN 0,FTy 3),LW(6,3)),
               ITE(Bop(In,Var("mode",FTy 5),SL[LW(26,5),LW(31,5)]),
                   Call
                     ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",
                         LS"BankedRegisterAccessValid")),MU(LU,qTy))),
              (EQ(EX(Var("SYSm",FTy 5),LN 2,LN 0,FTy 3),LW(5,3)),
               ITE(EQ(Var("mode",FTy 5),LW(31,5)),
                   Call
                     ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",
                         LS"BankedRegisterAccessValid")),MU(LU,qTy))),
              (Mop(Not,EQ(Var("mode",FTy 5),LW(17,5))),
               Call
                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                  Call
                    ("UNPREDICTABLE",CTy"exception",
                     LS"BankedRegisterAccessValid")))],MU(LU,qTy))),
        (EQ(EX(Var("SYSm",FTy 5),LN 4,LN 3,FTy 2),LW(1,2)),
         MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
            Close
              (Var("v",CTy"CP15"),
               MB(MB(MB(MB(MU(Dest("NSACR",CTy"NSACR",Var("v",CTy"CP15")),
                              qTy),
                           Close
                             (Var("v",CTy"NSACR"),
                              MU(Dest("RFR",bTy,Var("v",CTy"NSACR")),qTy))),
                        Close
                          (bVar"b",
                           ITE(bVar"b",
                               MB(Call
                                    ("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU),
                                  Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))),
                               MU(LF,qTy)))),
                     Close
                       (bVar"v",
                        MU(Bop(Or,
                               Bop(Or,
                                   EQ(EX(Var("SYSm",FTy 5),LN 2,LN 0,FTy 3),
                                      LW(7,3)),
                                   EQ(Var("mode",FTy 5),LW(17,5))),bVar"v"),
                           qTy))),
                  Close
                    (bVar"b",
                     ITE(bVar"b",
                         Call
                           ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                            Call
                              ("UNPREDICTABLE",CTy"exception",
                               LS"BankedRegisterAccessValid")),MU(LU,qTy))))))),
        (EQ(EX(Var("SYSm",FTy 5),LN 4,LN 3,FTy 2),LW(3,2)),
         ITB([(Mop(Not,Bop(Bit,Var("SYSm",FTy 5),LN 2)),
               Call
                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                  Call
                    ("UNPREDICTABLE",CTy"exception",
                     LS"BankedRegisterAccessValid"))),
              (Mop(Not,Bop(Bit,Var("SYSm",FTy 5),LN 1)),
               MB(Call("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU),
                  Close
                    (bVar"v",
                     MB(MB(MU(Mop(Not,bVar"v"),qTy),
                           Close
                             (bVar"b",
                              MU(Bop(Or,bVar"b",
                                     EQ(Var("mode",FTy 5),LW(22,5))),qTy))),
                        Close
                          (bVar"b",
                           ITE(bVar"b",
                               Call
                                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                                  Call
                                    ("UNPREDICTABLE",CTy"exception",
                                     LS"BankedRegisterAccessValid")),
                               MU(LU,qTy))))))),
              (Mop(Not,EQ(Var("mode",FTy 5),LW(22,5))),
               Call
                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                  Call
                    ("UNPREDICTABLE",CTy"exception",
                     LS"BankedRegisterAccessValid")))],MU(LU,qTy)))],
       MU(LU,qTy)))
;
val SPSRAccessValid_def = Def
  ("SPSRAccessValid",TP[Var("SYSm",FTy 5),Var("mode",FTy 5)],
   CS(Var("SYSm",FTy 5),
      [(LW(14,5),
        MB(Call("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU),
           Close
             (bVar"v",
              MB(MB(MB(MU(Mop(Not,bVar"v"),qTy),
                       Close
                         (bVar"b",
                          ITE(bVar"b",
                              MB(MR(Close
                                      (qVar"s",
                                       Dest("CP15",CTy"CP15",qVar"s"))),
                                 Close
                                   (Var("v",CTy"CP15"),
                                    MB(MU(Dest
                                            ("NSACR",CTy"NSACR",
                                             Var("v",CTy"CP15")),qTy),
                                       Close
                                         (Var("v",CTy"NSACR"),
                                          MU(Dest
                                               ("RFR",bTy,
                                                Var("v",CTy"NSACR")),qTy))))),
                              MU(LF,qTy)))),
                    Close
                      (bVar"b",
                       MU(Bop(Or,bVar"b",EQ(Var("mode",FTy 5),LW(17,5))),
                          qTy))),
                 Close
                   (bVar"b",
                    ITE(bVar"b",
                        Call
                          ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                           Call
                             ("UNPREDICTABLE",CTy"exception",
                              LS"SPSRAccessValid")),MU(LU,qTy))))))),
       (LW(16,5),
        ITE(EQ(Var("mode",FTy 5),LW(18,5)),
            Call
              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
               Call("UNPREDICTABLE",CTy"exception",LS"SPSRAccessValid")),
            MU(LU,qTy))),
       (LW(18,5),
        ITE(EQ(Var("mode",FTy 5),LW(19,5)),
            Call
              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
               Call("UNPREDICTABLE",CTy"exception",LS"SPSRAccessValid")),
            MU(LU,qTy))),
       (LW(20,5),
        ITE(EQ(Var("mode",FTy 5),LW(23,5)),
            Call
              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
               Call("UNPREDICTABLE",CTy"exception",LS"SPSRAccessValid")),
            MU(LU,qTy))),
       (LW(22,5),
        ITE(EQ(Var("mode",FTy 5),LW(27,5)),
            Call
              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
               Call("UNPREDICTABLE",CTy"exception",LS"SPSRAccessValid")),
            MU(LU,qTy))),
       (LW(28,5),
        MB(Call("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU),
           Close
             (bVar"v",
              MB(MB(MU(Mop(Not,bVar"v"),qTy),
                    Close
                      (bVar"v",
                       MU(Bop(Or,EQ(Var("mode",FTy 5),LW(22,5)),bVar"v"),
                          qTy))),
                 Close
                   (bVar"b",
                    ITE(bVar"b",
                        Call
                          ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                           Call
                             ("UNPREDICTABLE",CTy"exception",
                              LS"SPSRAccessValid")),MU(LU,qTy))))))),
       (LW(30,5),
        ITE(Mop(Not,EQ(Var("mode",FTy 5),LW(22,5))),
            Call
              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
               Call("UNPREDICTABLE",CTy"exception",LS"SPSRAccessValid")),
            MU(LU,qTy))),
       (AVar(FTy 5),
        Call
          ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
           Call("UNPREDICTABLE",CTy"exception",LS"SPSRAccessValid")))]))
;
val dfn'BranchTarget_def = Def
  ("dfn'BranchTarget",Var("imm32",F32),
   MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
      Close
        (Var("v",F32),
         MB(MU(Bop(Add,Var("v",F32),Var("imm32",F32)),qTy),
            Close
              (Var("v",F32),
               Call("BranchWritePC",ATy(qTy,PTy(uTy,qTy)),Var("v",F32)))))))
;
val dfn'BranchExchange_def = Def
  ("dfn'BranchExchange",Var("m",F4),
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("v",F32),Call("BXWritePC",ATy(qTy,PTy(uTy,qTy)),Var("v",F32)))))
;
val dfn'BranchLinkExchangeImmediate_def = Def
  ("dfn'BranchLinkExchangeImmediate",
   TP[Var("targetInstrSet",CTy"InstrSet"),Var("imm32",F32)],
   MB(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
      Close
        (Var("v",CTy"InstrSet"),
         MB(MB(MU(EQ(Var("v",CTy"InstrSet"),
                     LC("InstrSet_ARM",CTy"InstrSet")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MB(MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy),
                               Close
                                 (Var("v",F32),
                                  Call
                                    ("write'LR",ATy(qTy,PTy(uTy,qTy)),
                                     Var("v",F32)))))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MB(MB(MU(EX(Var("v",F32),LN 31,LN 1,FTy 31),
                                     qTy),
                                  Close
                                    (Var("v",FTy 31),
                                     MU(CC[Var("v",FTy 31),LW(1,1)],qTy))),
                               Close
                                 (Var("v",F32),
                                  Call
                                    ("write'LR",ATy(qTy,PTy(uTy,qTy)),
                                     Var("v",F32))))))))),
            Close
              (AVar uTy,
               MB(ITE(EQ(Var("targetInstrSet",CTy"InstrSet"),
                         LC("InstrSet_ARM",CTy"InstrSet")),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MB(MB(MU(TP[Var("v",F32),LN 4],qTy),
                                  Close
                                    (Var("v",PTy(F32,nTy)),
                                     MU(Call
                                          ("Align",F32,
                                           Var("v",PTy(F32,nTy))),qTy))),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Add,Var("v",F32),Var("imm32",F32)),
                                     qTy))))),
                      MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                         Close
                           (Var("v",F32),
                            MU(Bop(Add,Var("v",F32),Var("imm32",F32)),qTy)))),
                  Close
                    (Var("targetAddress",F32),
                     MB(Call
                          ("SelectInstrSet",ATy(qTy,PTy(uTy,qTy)),
                           Var("targetInstrSet",CTy"InstrSet")),
                        Close
                          (AVar uTy,
                           Call
                             ("BranchWritePC",ATy(qTy,PTy(uTy,qTy)),
                              Var("targetAddress",F32)))))))))))
;
val dfn'BranchLinkExchangeRegister_def = Def
  ("dfn'BranchLinkExchangeRegister",Var("m",F4),
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("target",F32),
         MB(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
            Close
              (Var("v",CTy"InstrSet"),
               MB(MB(MU(EQ(Var("v",CTy"InstrSet"),
                           LC("InstrSet_ARM",CTy"InstrSet")),qTy),
                     Close
                       (bVar"b",
                        ITE(bVar"b",
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MB(MU(Bop(Sub,Var("v",F32),LW(4,32)),qTy),
                                     Close
                                       (Var("next_instr_addr",F32),
                                        Call
                                          ("write'LR",
                                           ATy(qTy,PTy(uTy,qTy)),
                                           Var("next_instr_addr",F32)))))),
                            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                               Close
                                 (Var("v",F32),
                                  MB(MU(Bop(Sub,Var("v",F32),LW(2,32)),qTy),
                                     Close
                                       (Var("next_instr_addr",F32),
                                        Call
                                          ("write'LR",
                                           ATy(qTy,PTy(uTy,qTy)),
                                           CC[EX(Var("next_instr_addr",F32),
                                                 LN 31,LN 1,FTy 31),
                                              LW(1,1)])))))))),
                  Close
                    (AVar uTy,
                     Call
                       ("BXWritePC",ATy(qTy,PTy(uTy,qTy)),
                        Var("target",F32)))))))))
;
val dfn'CompareBranch_def = Def
  ("dfn'CompareBranch",TP[bVar"nonzero",Var("n",F4),Var("imm32",F32)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MU(EQ(Var("v",F32),LW(0,32)),qTy),
                  Close(bVar"v",MU(EQ(bVar"nonzero",bVar"v"),qTy))),
               Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                      Close
                        (Var("v",F32),
                         MB(MU(Bop(Add,Var("v",F32),Var("imm32",F32)),qTy),
                            Close
                              (Var("v",F32),
                               Call
                                 ("BranchWritePC",ATy(qTy,PTy(uTy,qTy)),
                                  Var("v",F32)))))),
                   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))
;
val dfn'TableBranchByte_def = Def
  ("dfn'TableBranchByte",TP[bVar"is_tbh",Var("m",F4),Var("n",F4)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(ITE(bVar"is_tbh",
                    MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                       Close
                         (Var("v",F32),
                          MB(MB(MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("m",F4)),
                                   Close
                                     (Var("v0",F32),
                                      MB(MB(MU(TP[Var("v0",F32),LN 1],qTy),
                                            Close
                                              (Var("v",PTy(F32,nTy)),
                                               Call
                                                 ("LSL",
                                                  ATy(qTy,PTy(F32,qTy)),
                                                  Var("v",PTy(F32,nTy))))),
                                         Close
                                           (Var("v0",F32),
                                            MU(Bop(Add,Var("v",F32),
                                                   Var("v0",F32)),qTy))))),
                                Close
                                  (Var("v",F32),
                                   MU(TP[Var("v",F32),LN 2],qTy))),
                             Close
                               (Var("v",PTy(F32,nTy)),
                                Call
                                  ("MemU",ATy(qTy,PTy(F16,qTy)),
                                   Var("v",PTy(F32,nTy))))))),
                    MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                       Close
                         (Var("v",F32),
                          MB(MB(MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("m",F4)),
                                   Close
                                     (Var("v0",F32),
                                      MU(Bop(Add,Var("v",F32),
                                             Var("v0",F32)),qTy))),
                                Close
                                  (Var("v",F32),
                                   MU(TP[Var("v",F32),LN 1],qTy))),
                             Close
                               (Var("v",PTy(F32,nTy)),
                                Call
                                  ("MemU",ATy(qTy,PTy(F16,qTy)),
                                   Var("v",PTy(F32,nTy)))))))),
                Close
                  (Var("halfwords",F16),
                   MB(MR(Close(qVar"s",Dest("data_abort",bTy,qVar"s"))),
                      Close
                        (bVar"b",
                         ITE(bVar"b",
                             Call
                               ("TakeDataAbortException",
                                ATy(qTy,PTy(uTy,qTy)),LU),
                             MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                                Close
                                  (Var("v",F32),
                                   MB(MU(Bop(Add,Var("v",F32),
                                             Bop(Mul,LW(2,32),
                                                 Mop(Cast F32,
                                                     Var("halfwords",F16)))),
                                         qTy),
                                      Close
                                        (Var("v",F32),
                                         Call
                                           ("BranchWritePC",
                                            ATy(qTy,PTy(uTy,qTy)),
                                            Var("v",F32))))))))))),
             MU(LU,qTy)))))
;
val dfn'CheckArray_def = Def
  ("dfn'CheckArray",TP[Var("m",F4),Var("n",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("v",F32),
         MB(MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
               Close
                 (Var("v0",F32),
                  MU(Bop(Ule,Var("v",F32),Var("v0",F32)),qTy))),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                      Close
                        (Var("v",F32),
                         MB(MB(MB(MU(EX(Var("v",F32),LN 31,LN 1,FTy 31),
                                     qTy),
                                  Close
                                    (Var("v",FTy 31),
                                     MU(CC[Var("v",FTy 31),LW(1,1)],qTy))),
                               Close
                                 (Var("v",F32),
                                  Call
                                    ("write'LR",ATy(qTy,PTy(uTy,qTy)),
                                     Var("v",F32)))),
                            Close
                              (AVar uTy,
                               MB(Call
                                    ("write'ITSTATE",
                                     ATy(qTy,PTy(uTy,qTy)),LW(0,8)),
                                  Close
                                    (AVar uTy,
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("CP14",CTy"CP14",qVar"s"))),
                                        Close
                                          (Var("v",CTy"CP14"),
                                           MB(MB(MU(Dest
                                                      ("TEEHBR",F32,
                                                       Var("v",CTy"CP14")),
                                                    qTy),
                                                 Close
                                                   (Var("v",F32),
                                                    MU(Bop(Sub,
                                                           Var("v",F32),
                                                           LW(8,32)),qTy))),
                                              Close
                                                (Var("v",F32),
                                                 Call
                                                   ("BranchWritePC",
                                                    ATy(qTy,PTy(uTy,qTy)),
                                                    Var("v",F32)))))))))))),
                   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))
;
val dfn'HandlerBranchLink_def = Def
  ("dfn'HandlerBranchLink",
   TP[bVar"generate_link",Var("handler_offset",F32)],
   MB(ITE(bVar"generate_link",
          MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
             Close
               (Var("v",F32),
                MB(MU(Bop(Sub,Var("v",F32),LW(2,32)),qTy),
                   Close
                     (Var("next_instr_addr",F32),
                      Call
                        ("write'LR",ATy(qTy,PTy(uTy,qTy)),
                         CC[EX(Var("next_instr_addr",F32),LN 31,LN 1,
                               FTy 31),LW(1,1)]))))),MU(LU,qTy)),
      Close
        (AVar uTy,
         MB(MR(Close(qVar"s",Dest("CP14",CTy"CP14",qVar"s"))),
            Close
              (Var("v",CTy"CP14"),
               MB(MB(MU(Dest("TEEHBR",F32,Var("v",CTy"CP14")),qTy),
                     Close
                       (Var("v",F32),
                        MU(Bop(Add,Var("v",F32),Var("handler_offset",F32)),
                           qTy))),
                  Close
                    (Var("v",F32),
                     Call
                       ("BranchWritePC",ATy(qTy,PTy(uTy,qTy)),Var("v",F32)))))))))
;
val dfn'HandlerBranchLinkParameter_def = Def
  ("dfn'HandlerBranchLinkParameter",
   TP[Var("imm32",F32),Var("handler_offset",F32)],
   MB(Call("write'R",ATy(qTy,PTy(uTy,qTy)),TP[Var("imm32",F32),LW(8,4)]),
      Close
        (AVar uTy,
         MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
            Close
              (Var("v",F32),
               MB(MU(Bop(Sub,Var("v",F32),LW(2,32)),qTy),
                  Close
                    (Var("next_instr_addr",F32),
                     MB(Call
                          ("write'LR",ATy(qTy,PTy(uTy,qTy)),
                           CC[EX(Var("next_instr_addr",F32),LN 31,LN 1,
                                 FTy 31),LW(1,1)]),
                        Close
                          (AVar uTy,
                           MB(MR(Close
                                   (qVar"s",Dest("CP14",CTy"CP14",qVar"s"))),
                              Close
                                (Var("v",CTy"CP14"),
                                 MB(MB(MU(Dest
                                            ("TEEHBR",F32,
                                             Var("v",CTy"CP14")),qTy),
                                       Close
                                         (Var("v",F32),
                                          MU(Bop(Add,Var("v",F32),
                                                 Var("handler_offset",F32)),
                                             qTy))),
                                    Close
                                      (Var("v",F32),
                                       Call
                                         ("BranchWritePC",
                                          ATy(qTy,PTy(uTy,qTy)),
                                          Var("v",F32)))))))))))))))
;
val dfn'HandlerBranchParameter_def = Def
  ("dfn'HandlerBranchParameter",
   TP[Var("imm32",F32),Var("handler_offset",F32)],
   MB(Call("write'R",ATy(qTy,PTy(uTy,qTy)),TP[Var("imm32",F32),LW(8,4)]),
      Close
        (AVar uTy,
         MB(MR(Close(qVar"s",Dest("CP14",CTy"CP14",qVar"s"))),
            Close
              (Var("v",CTy"CP14"),
               MB(MB(MU(Dest("TEEHBR",F32,Var("v",CTy"CP14")),qTy),
                     Close
                       (Var("v",F32),
                        MU(Bop(Add,Var("v",F32),Var("handler_offset",F32)),
                           qTy))),
                  Close
                    (Var("v",F32),
                     Call
                       ("BranchWritePC",ATy(qTy,PTy(uTy,qTy)),Var("v",F32)))))))))
;
val dfn'EnterxLeavex_def = Def
  ("dfn'EnterxLeavex",bVar"is_enterx",
   ITE(bVar"is_enterx",
       MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
          Close
            (bVar"b",
             ITE(bVar"b",
                 Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU),
                 MB(Call
                      ("SelectInstrSet",ATy(qTy,PTy(uTy,qTy)),
                       LC("InstrSet_ThumbEE",CTy"InstrSet")),
                    Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))),
       MB(Call
            ("SelectInstrSet",ATy(qTy,PTy(uTy,qTy)),
             LC("InstrSet_Thumb",CTy"InstrSet")),
          Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))
;
val dfn'IfThen_def = Def
  ("dfn'IfThen",TP[Var("firstcond",F4),Var("mask",F4)],
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(TP[Var("v",CTy"PSR"),
                        CC[Var("firstcond",F4),Var("mask",F4)]],qTy),
                  Close
                    (Var("v",PTy(CTy"PSR",F8)),
                     MU(Rupd("IT",Var("v",PTy(CTy"PSR",F8))),qTy))),
               Close
                 (Var("v",CTy"PSR"),
                  MW(Close
                       (qVar"s",Rupd("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))),
            Close
              (AVar uTy,
               MB(Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU),
                  Close
                    (AVar uTy,
                     MW(Close
                          (qVar"s",
                           Rupd
                             ("Encoding",
                              TP[qVar"s",LC("Encoding_ARM",CTy"Encoding")]))))))))))
;
val dfn'CountLeadingZeroes_def = Def
  ("dfn'CountLeadingZeroes",TP[Var("d",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MB(MU(Call("CountLeadingZeroBits",nTy,Var("v",F32)),qTy),
                     Close(nVar"v",MU(Mop(Cast F32,nVar"v"),qTy))),
                  Close(Var("v",F32),MU(TP[Var("v",F32),Var("d",F4)],qTy))),
               Close
                 (Var("v",PTy(F32,F4)),
                  Call
                    ("write'R",ATy(qTy,PTy(uTy,qTy)),Var("v",PTy(F32,F4))))),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'MoveHalfword_def = Def
  ("dfn'MoveHalfword",TP[bVar"high",Var("d",F4),Var("imm16",F16)],
   MB(ITE(bVar"high",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("d",F4)),
             Close
               (Var("w",F32),
                Call
                  ("write'R",ATy(qTy,PTy(uTy,qTy)),
                   TP[BFI(LN 31,LN 16,Var("imm16",F16),Var("w",F32)),
                      Var("d",F4)]))),
          Call
            ("write'R",ATy(qTy,PTy(uTy,qTy)),
             TP[Mop(Cast F32,Var("imm16",F16)),Var("d",F4)])),
      Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))
;
val DataProcessing_def = Def
  ("DataProcessing",
   TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),
      Var("imm32",F32),bVar"C"],
   MB(ITB([(Bop(Or,EQ(Var("opc",F4),LW(13,4)),
                Bop(And,EQ(Var("opc",F4),LW(15,4)),
                    EQ(Var("n",F4),LW(15,4)))),MU(LW(0,32),qTy)),
           (Bop(And,
                Bop(And,Bop(In,Var("opc",F4),SL[LW(4,4),LW(2,4)]),
                    EQ(Var("n",F4),LW(15,4))),Mop(Not,bVar"setflags")),
            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
               Close
                 (Var("v",F32),
                  MB(MU(TP[Var("v",F32),LN 4],qTy),
                     Close
                       (Var("v",PTy(F32,nTy)),
                        MU(Call("Align",F32,Var("v",PTy(F32,nTy))),qTy))))))],
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4))),
      Close
        (Var("rn",F32),
         Let(TP[Var("result",F32),bVar"carry",bVar"overflow"],
             Call
               ("DataProcessingALU",PTy(F32,PTy(bTy,bTy)),
                TP[Var("opc",F4),Var("rn",F32),Var("imm32",F32),bVar"C"]),
             MB(ITE(Mop(Not,EQ(EX(Var("opc",F4),LN 3,LN 2,FTy 2),LW(2,2))),
                    Call
                      ("write'R",ATy(qTy,PTy(uTy,qTy)),
                       TP[Var("result",F32),Var("d",F4)]),MU(LU,qTy)),
                Close
                  (AVar uTy,
                   MB(ITE(bVar"setflags",
                          MB(MR(Close
                                  (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                             Close
                               (Var("v",CTy"PSR"),
                                MB(MB(MB(MU(TP[Var("v",CTy"PSR"),
                                               Bop(Bit,Var("result",F32),
                                                   LN 31)],qTy),
                                         Close
                                           (Var("v",PTy(CTy"PSR",bTy)),
                                            MU(Rupd
                                                 ("N",
                                                  Var("v",
                                                      PTy(CTy"PSR",bTy))),
                                               qTy))),
                                      Close
                                        (Var("v",CTy"PSR"),
                                         MW(Close
                                              (qVar"s",
                                               Rupd
                                                 ("CPSR",
                                                  TP[qVar"s",
                                                     Var("v",CTy"PSR")]))))),
                                   Close
                                     (AVar uTy,
                                      MB(MR(Close
                                              (qVar"s",
                                               Dest
                                                 ("CPSR",CTy"PSR",qVar"s"))),
                                         Close
                                           (Var("v",CTy"PSR"),
                                            MB(MB(MB(MU(TP[Var("v",
                                                               CTy"PSR"),
                                                           EQ(Var("result",
                                                                  F32),
                                                              LW(0,32))],
                                                        qTy),
                                                     Close
                                                       (Var("v",
                                                            PTy(CTy"PSR",
                                                                bTy)),
                                                        MU(Rupd
                                                             ("Z",
                                                              Var("v",
                                                                  PTy(CTy"PSR",
                                                                      bTy))),
                                                           qTy))),
                                                  Close
                                                    (Var("v",CTy"PSR"),
                                                     MW(Close
                                                          (qVar"s",
                                                           Rupd
                                                             ("CPSR",
                                                              TP[qVar"s",
                                                                 Var("v",
                                                                     CTy"PSR")]))))),
                                               Close
                                                 (AVar uTy,
                                                  MB(MR(Close
                                                          (qVar"s",
                                                           Dest
                                                             ("CPSR",
                                                              CTy"PSR",
                                                              qVar"s"))),
                                                     Close
                                                       (Var("v",CTy"PSR"),
                                                        MB(MB(MB(MU(TP[Var("v",
                                                                           CTy"PSR"),
                                                                       bVar"carry"],
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(CTy"PSR",
                                                                            bTy)),
                                                                    MU(Rupd
                                                                         ("C",
                                                                          Var("v",
                                                                              PTy(CTy"PSR",
                                                                                  bTy))),
                                                                       qTy))),
                                                              Close
                                                                (Var("v",
                                                                     CTy"PSR"),
                                                                 MW(Close
                                                                      (qVar"s",
                                                                       Rupd
                                                                         ("CPSR",
                                                                          TP[qVar"s",
                                                                             Var("v",
                                                                                 CTy"PSR")]))))),
                                                           Close
                                                             (AVar uTy,
                                                              ITE(Call
                                                                    ("ArithmeticOpcode",
                                                                     bTy,
                                                                     Var("opc",
                                                                         F4)),
                                                                  MB(MR(Close
                                                                          (qVar"s",
                                                                           Dest
                                                                             ("CPSR",
                                                                              CTy"PSR",
                                                                              qVar"s"))),
                                                                     Close
                                                                       (Var("v",
                                                                            CTy"PSR"),
                                                                        MB(MB(MU(TP[Var("v",
                                                                                        CTy"PSR"),
                                                                                    bVar"overflow"],
                                                                                 qTy),
                                                                              Close
                                                                                (Var("v",
                                                                                     PTy(CTy"PSR",
                                                                                         bTy)),
                                                                                 MU(Rupd
                                                                                      ("V",
                                                                                       Var("v",
                                                                                           PTy(CTy"PSR",
                                                                                               bTy))),
                                                                                    qTy))),
                                                                           Close
                                                                             (Var("v",
                                                                                  CTy"PSR"),
                                                                              MW(Close
                                                                                   (qVar"s",
                                                                                    Rupd
                                                                                      ("CPSR",
                                                                                       TP[qVar"s",
                                                                                          Var("v",
                                                                                              CTy"PSR")]))))))),
                                                                  MU(LU,
                                                                     qTy)))))))))))))),
                          MU(LU,qTy)),
                      Close
                        (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))))
;
val DataProcessingPC_def = Def
  ("DataProcessingPC",
   TP[Var("opc",F4),bVar"setflags",Var("n",F4),Var("imm32",F32),bVar"C"],
   MB(ITB([(Bop(Or,EQ(Var("opc",F4),LW(13,4)),
                Bop(And,EQ(Var("opc",F4),LW(15,4)),
                    EQ(Var("n",F4),LW(15,4)))),MU(LW(0,32),qTy)),
           (Bop(And,
                Bop(And,Bop(In,Var("opc",F4),SL[LW(4,4),LW(2,4)]),
                    EQ(Var("n",F4),LW(15,4))),Mop(Not,bVar"setflags")),
            MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
               Close
                 (Var("v",F32),
                  MB(MU(TP[Var("v",F32),LN 4],qTy),
                     Close
                       (Var("v",PTy(F32,nTy)),
                        MU(Call("Align",F32,Var("v",PTy(F32,nTy))),qTy))))))],
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4))),
      Close
        (Var("rn",F32),
         Let(TP[Var("result",F32),bVar"carry",bVar"overflow"],
             Call
               ("DataProcessingALU",PTy(F32,PTy(bTy,bTy)),
                TP[Var("opc",F4),Var("rn",F32),Var("imm32",F32),bVar"C"]),
             ITE(bVar"setflags",
                 MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
                    Close
                      (bVar"b",
                       ITE(bVar"b",
                           Call
                             ("TakeUndefInstrException",
                              ATy(qTy,PTy(uTy,qTy)),LU),
                           MB(Call
                                ("CurrentModeIsUserOrSystem",
                                 ATy(qTy,PTy(bTy,qTy)),LU),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     Call
                                       ("raise'exception",
                                        ATy(qTy,PTy(uTy,qTy)),
                                        Call
                                          ("UNPREDICTABLE",CTy"exception",
                                           LS"DataProcessingPC")),
                                     MB(Const
                                          ("SPSR",
                                           ATy(qTy,PTy(CTy"PSR",qTy))),
                                        Close
                                          (Var("v",CTy"PSR"),
                                           MB(MB(MB(MU(Call
                                                         ("reg'PSR",F32,
                                                          Var("v",CTy"PSR")),
                                                       qTy),
                                                    Close
                                                      (Var("v",F32),
                                                       MU(TP[Var("v",F32),
                                                             LW(15,4),LT],
                                                          qTy))),
                                                 Close
                                                   (Var("v",
                                                        PTy(F32,
                                                            PTy(F4,bTy))),
                                                    Call
                                                      ("CPSRWriteByInstr",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       Var("v",
                                                           PTy(F32,
                                                               PTy(F4,bTy)))))),
                                              Close
                                                (AVar uTy,
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("CPSR",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(MU(Dest
                                                                     ("M",
                                                                      FTy 5,
                                                                      Var("v",
                                                                          CTy"PSR")),
                                                                   qTy),
                                                                Close
                                                                  (Var("v",
                                                                       FTy 5),
                                                                   MU(EQ(Var("v",
                                                                             FTy 5),
                                                                         LW(26,
                                                                            5)),
                                                                      qTy))),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    MB(Call
                                                                         ("CurrentInstrSet",
                                                                          ATy(qTy,
                                                                              PTy(CTy"InstrSet",
                                                                                  qTy)),
                                                                          LU),
                                                                       Close
                                                                         (Var("v",
                                                                              CTy"InstrSet"),
                                                                          MU(EQ(Var("v",
                                                                                    CTy"InstrSet"),
                                                                                LC("InstrSet_ThumbEE",
                                                                                   CTy"InstrSet")),
                                                                             qTy))),
                                                                    MU(LF,
                                                                       qTy)))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 Call
                                                                   ("raise'exception",
                                                                    ATy(qTy,
                                                                        PTy(uTy,
                                                                            qTy)),
                                                                    Call
                                                                      ("UNPREDICTABLE",
                                                                       CTy"exception",
                                                                       LS
                                                                        "DataProcessingPC")),
                                                                 Call
                                                                   ("BranchWritePC",
                                                                    ATy(qTy,
                                                                        PTy(uTy,
                                                                            qTy)),
                                                                    Var("result",
                                                                        F32))))))))))))))))),
                 Call
                   ("ALUWritePC",ATy(qTy,PTy(uTy,qTy)),Var("result",F32)))))))
;
val dfn'Move_def = Def
  ("dfn'Move",
   TP[bVar"setflags",bVar"negate",Var("d",F4),Var("imm12",FTy 12)],
   Let(Var("opc",F4),CC[LW(3,2),Mop(Cast F1,bVar"negate"),LW(1,1)],
       MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
          Close
            (Var("v",CTy"PSR"),
             MB(MB(MB(MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy),
                      Close
                        (bVar"v",MU(TP[Var("imm12",FTy 12),bVar"v"],qTy))),
                   Close
                     (Var("v",PTy(FTy 12,bTy)),
                      Call
                        ("ExpandImm_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                         Var("v",PTy(FTy 12,bTy))))),
                Close
                  (Var("x",PTy(F32,bTy)),
                   CS(Var("x",PTy(F32,bTy)),
                      [(TP[Var("imm32",F32),bVar"carry"],
                        ITE(EQ(Var("d",F4),LW(15,4)),
                            Call
                              ("DataProcessingPC",ATy(qTy,PTy(uTy,qTy)),
                               TP[Var("opc",F4),bVar"setflags",LW(15,4),
                                  Var("imm32",F32),bVar"carry"]),
                            Call
                              ("DataProcessing",ATy(qTy,PTy(uTy,qTy)),
                               TP[Var("opc",F4),bVar"setflags",
                                  Var("d",F4),LW(15,4),Var("imm32",F32),
                                  bVar"carry"])))])))))))
;
val dfn'AddSub_def = Def
  ("dfn'AddSub",TP[bVar"sub",Var("d",F4),Var("n",F4),Var("imm12",FTy 12)],
   Call
     ("DataProcessing",ATy(qTy,PTy(uTy,qTy)),
      TP[ITE(bVar"sub",LW(2,4),LW(4,4)),LF,Var("d",F4),Var("n",F4),
         Mop(Cast F32,Var("imm12",FTy 12)),LX bTy]))
;
val dfn'TestCompareImmediate_def = Def
  ("dfn'TestCompareImmediate",
   TP[Var("op",FTy 2),Var("n",F4),Var("imm12",FTy 12)],
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy),
                  Close(bVar"v",MU(TP[Var("imm12",FTy 12),bVar"v"],qTy))),
               Close
                 (Var("v",PTy(FTy 12,bTy)),
                  Call
                    ("ExpandImm_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                     Var("v",PTy(FTy 12,bTy))))),
            Close
              (Var("x",PTy(F32,bTy)),
               CS(Var("x",PTy(F32,bTy)),
                  [(TP[Var("imm32",F32),bVar"carry"],
                    Call
                      ("DataProcessing",ATy(qTy,PTy(uTy,qTy)),
                       TP[CC[LW(2,2),Var("op",FTy 2)],LT,LX F4,
                          Var("n",F4),Var("imm32",F32),bVar"carry"]))]))))))
;
val dfn'ArithLogicImmediate_def = Def
  ("dfn'ArithLogicImmediate",
   TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),
      Var("imm12",FTy 12)],
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy),
                  Close(bVar"v",MU(TP[Var("imm12",FTy 12),bVar"v"],qTy))),
               Close
                 (Var("v",PTy(FTy 12,bTy)),
                  Call
                    ("ExpandImm_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                     Var("v",PTy(FTy 12,bTy))))),
            Close
              (Var("x",PTy(F32,bTy)),
               CS(Var("x",PTy(F32,bTy)),
                  [(TP[Var("imm32",F32),bVar"carry"],
                    ITE(EQ(Var("d",F4),LW(15,4)),
                        Call
                          ("DataProcessingPC",ATy(qTy,PTy(uTy,qTy)),
                           TP[Var("opc",F4),bVar"setflags",Var("n",F4),
                              Var("imm32",F32),bVar"carry"]),
                        Call
                          ("DataProcessing",ATy(qTy,PTy(uTy,qTy)),
                           TP[Var("opc",F4),bVar"setflags",Var("d",F4),
                              Var("n",F4),Var("imm32",F32),bVar"carry"])))]))))))
;
val doRegister_def = Def
  ("doRegister",
   TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4),
      Var("shift_t",CTy"SRType"),nVar"shift_n"],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v0",CTy"PSR"),
                     MB(MB(MB(MU(Dest("C",bTy,Var("v0",CTy"PSR")),qTy),
                              Close
                                (bVar"v",MU(TP[nVar"shift_n",bVar"v"],qTy))),
                           Close
                             (Var("v",PTy(nTy,bTy)),
                              MU(TP[Var("shift_t",CTy"SRType"),
                                    Var("v",PTy(nTy,bTy))],qTy))),
                        Close
                          (Var("v0",PTy(CTy"SRType",PTy(nTy,bTy))),
                           MU(TP[Var("v",F32),
                                 Var("v0",PTy(CTy"SRType",PTy(nTy,bTy)))],
                              qTy))))),
               Close
                 (Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy)))),
                  Call
                    ("Shift_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                     Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy))))))),
            Close
              (Var("x",PTy(F32,bTy)),
               CS(Var("x",PTy(F32,bTy)),
                  [(TP[Var("shifted",F32),bVar"carry"],
                    MB(ITE(Call("ArithmeticOpcode",bTy,Var("opc",F4)),
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy))),
                           MU(bVar"carry",qTy)),
                       Close
                         (bVar"carry",
                          ITE(EQ(Var("d",F4),LW(15,4)),
                              Call
                                ("DataProcessingPC",ATy(qTy,PTy(uTy,qTy)),
                                 TP[Var("opc",F4),bVar"setflags",
                                    Var("n",F4),Var("shifted",F32),
                                    bVar"carry"]),
                              Call
                                ("DataProcessing",ATy(qTy,PTy(uTy,qTy)),
                                 TP[Var("opc",F4),bVar"setflags",
                                    Var("d",F4),Var("n",F4),
                                    Var("shifted",F32),bVar"carry"])))))]))))))
;
val dfn'Register_def = Def
  ("dfn'Register",
   TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4),
      Var("shift_t",CTy"SRType"),nVar"shift_n"],
   Call
     ("doRegister",ATy(qTy,PTy(uTy,qTy)),
      TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4),
         Var("shift_t",CTy"SRType"),nVar"shift_n"]))
;
val dfn'TestCompareRegister_def = Def
  ("dfn'TestCompareRegister",
   TP[Var("opc",FTy 2),Var("n",F4),Var("m",F4),Var("shift_t",CTy"SRType"),
      nVar"shift_n"],
   Call
     ("doRegister",ATy(qTy,PTy(uTy,qTy)),
      TP[CC[LW(2,2),Var("opc",FTy 2)],LT,LW(0,4),Var("n",F4),Var("m",F4),
         Var("shift_t",CTy"SRType"),nVar"shift_n"]))
;
val dfn'ShiftImmediate_def = Def
  ("dfn'ShiftImmediate",
   TP[bVar"negate",bVar"setflags",Var("d",F4),Var("m",F4),
      Var("shift_t",CTy"SRType"),nVar"shift_n"],
   ITE(bVar"negate",
       Call
         ("doRegister",ATy(qTy,PTy(uTy,qTy)),
          TP[LW(15,4),bVar"setflags",Var("d",F4),LW(15,4),Var("m",F4),
             Var("shift_t",CTy"SRType"),nVar"shift_n"]),
       Call
         ("doRegister",ATy(qTy,PTy(uTy,qTy)),
          TP[LW(13,4),bVar"setflags",Var("d",F4),LX F4,Var("m",F4),
             Var("shift_t",CTy"SRType"),nVar"shift_n"])))
;
val doRegisterShiftedRegister_def = Def
  ("doRegisterShiftedRegister",
   TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4),
      Var("shift_t",CTy"SRType"),Var("s",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("s",F4)),
                  Close
                    (Var("v0",F32),
                     MB(MB(MB(MB(MU(EX(Var("v0",F32),LN 7,LN 0,F8),qTy),
                                 Close
                                   (Var("v",F8),
                                    MU(Mop(Cast nTy,Var("v",F8)),qTy))),
                              Close
                                (nVar"v",
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest("CPSR",CTy"PSR",qVar"s"))),
                                    Close
                                      (Var("v0",CTy"PSR"),
                                       MB(MU(Dest
                                               ("C",bTy,Var("v0",CTy"PSR")),
                                             qTy),
                                          Close
                                            (bVar"v0",
                                             MU(TP[nVar"v",bVar"v0"],qTy))))))),
                           Close
                             (Var("v",PTy(nTy,bTy)),
                              MU(TP[Var("shift_t",CTy"SRType"),
                                    Var("v",PTy(nTy,bTy))],qTy))),
                        Close
                          (Var("v0",PTy(CTy"SRType",PTy(nTy,bTy))),
                           MU(TP[Var("v",F32),
                                 Var("v0",PTy(CTy"SRType",PTy(nTy,bTy)))],
                              qTy))))),
               Close
                 (Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy)))),
                  Call
                    ("Shift_C",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                     Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy))))))),
            Close
              (Var("x",PTy(F32,bTy)),
               CS(Var("x",PTy(F32,bTy)),
                  [(TP[Var("shifted",F32),bVar"carry"],
                    MB(ITE(Call("ArithmeticOpcode",bTy,Var("opc",F4)),
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MU(Dest("C",bTy,Var("v",CTy"PSR")),qTy))),
                           MU(bVar"carry",qTy)),
                       Close
                         (bVar"carry",
                          Call
                            ("DataProcessing",ATy(qTy,PTy(uTy,qTy)),
                             TP[Var("opc",F4),bVar"setflags",Var("d",F4),
                                Var("n",F4),Var("shifted",F32),bVar"carry"]))))]))))))
;
val dfn'RegisterShiftedRegister_def = Def
  ("dfn'RegisterShiftedRegister",
   TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4),
      Var("shift_t",CTy"SRType"),Var("s",F4)],
   Call
     ("doRegisterShiftedRegister",ATy(qTy,PTy(uTy,qTy)),
      TP[Var("opc",F4),bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4),
         Var("shift_t",CTy"SRType"),Var("s",F4)]))
;
val dfn'ShiftRegister_def = Def
  ("dfn'ShiftRegister",
   TP[bVar"negate",bVar"setflags",Var("d",F4),Var("n",F4),
      Var("shift_t",CTy"SRType"),Var("m",F4)],
   ITE(bVar"negate",
       Call
         ("doRegisterShiftedRegister",ATy(qTy,PTy(uTy,qTy)),
          TP[LW(15,4),bVar"setflags",Var("d",F4),LW(15,4),Var("n",F4),
             Var("shift_t",CTy"SRType"),Var("m",F4)]),
       Call
         ("doRegisterShiftedRegister",ATy(qTy,PTy(uTy,qTy)),
          TP[LW(13,4),bVar"setflags",Var("d",F4),LX F4,Var("n",F4),
             Var("shift_t",CTy"SRType"),Var("m",F4)])))
;
val dfn'SaturatingAddSubtract_def = Def
  ("dfn'SaturatingAddSubtract",
   TP[Var("opc",FTy 2),Var("d",F4),Var("m",F4),Var("n",F4)],
   MN(LX F32,
      MN(LX bTy,
         MB(CS(Var("opc",FTy 2),
               [(LW(0,2),
                 MB(MD(MD(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),F32),
                       bTy),
                    Close
                      (Var("v",F32),
                       MB(MB(MB(MB(MU(Mop(Cast iTy,Var("v",F32)),
                                      PTy(bTy,PTy(F32,qTy))),
                                   Close
                                     (iVar"v",
                                      MB(MD(MD(Call
                                                 ("R",
                                                  ATy(qTy,PTy(F32,qTy)),
                                                  Var("n",F4)),F32),bTy),
                                         Close
                                           (Var("v0",F32),
                                            MB(MU(Mop(Cast iTy,
                                                      Var("v0",F32)),
                                                  PTy(bTy,PTy(F32,qTy))),
                                               Close
                                                 (iVar"v0",
                                                  MU(Bop(Add,iVar"v",
                                                         iVar"v0"),
                                                     PTy(bTy,PTy(F32,qTy))))))))),
                                Close
                                  (iVar"v",
                                   MU(TP[iVar"v",LN 32],
                                      PTy(bTy,PTy(F32,qTy))))),
                             Close
                               (Var("v",PTy(iTy,nTy)),
                                MD(MD(Call
                                        ("SignedSatQ",
                                         ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                                         Var("v",PTy(iTy,nTy))),F32),bTy))),
                          Close
                            (Var("x",PTy(F32,bTy)),
                             CS(Var("x",PTy(F32,bTy)),
                                [(TP[Var("r",F32),bVar"s"],
                                  MB(MW(Close
                                          (Var("s",PTy(bTy,PTy(F32,qTy))),
                                           TP[Mop(Fst,
                                                  Var("s",
                                                      PTy(bTy,PTy(F32,qTy)))),
                                              Var("r",F32),
                                              Mop(Snd,
                                                  Mop(Snd,
                                                      Var("s",
                                                          PTy(bTy,
                                                              PTy(F32,qTy)))))])),
                                     Close
                                       (AVar uTy,
                                        MW(Close
                                             (Var("s0",
                                                  PTy(bTy,PTy(F32,qTy))),
                                              TP[bVar"s",
                                                 Mop(Snd,
                                                     Var("s0",
                                                         PTy(bTy,
                                                             PTy(F32,qTy))))])))))])))))),
                (LW(1,2),
                 MB(MD(MD(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),F32),
                       bTy),
                    Close
                      (Var("v",F32),
                       MB(MB(MB(MB(MU(Mop(Cast iTy,Var("v",F32)),
                                      PTy(bTy,PTy(F32,qTy))),
                                   Close
                                     (iVar"v",
                                      MB(MD(MD(Call
                                                 ("R",
                                                  ATy(qTy,PTy(F32,qTy)),
                                                  Var("n",F4)),F32),bTy),
                                         Close
                                           (Var("v0",F32),
                                            MB(MU(Mop(Cast iTy,
                                                      Var("v0",F32)),
                                                  PTy(bTy,PTy(F32,qTy))),
                                               Close
                                                 (iVar"v0",
                                                  MU(Bop(Sub,iVar"v",
                                                         iVar"v0"),
                                                     PTy(bTy,PTy(F32,qTy))))))))),
                                Close
                                  (iVar"v",
                                   MU(TP[iVar"v",LN 32],
                                      PTy(bTy,PTy(F32,qTy))))),
                             Close
                               (Var("v",PTy(iTy,nTy)),
                                MD(MD(Call
                                        ("SignedSatQ",
                                         ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                                         Var("v",PTy(iTy,nTy))),F32),bTy))),
                          Close
                            (Var("x",PTy(F32,bTy)),
                             CS(Var("x",PTy(F32,bTy)),
                                [(TP[Var("r",F32),bVar"s"],
                                  MB(MW(Close
                                          (Var("s",PTy(bTy,PTy(F32,qTy))),
                                           TP[Mop(Fst,
                                                  Var("s",
                                                      PTy(bTy,PTy(F32,qTy)))),
                                              Var("r",F32),
                                              Mop(Snd,
                                                  Mop(Snd,
                                                      Var("s",
                                                          PTy(bTy,
                                                              PTy(F32,qTy)))))])),
                                     Close
                                       (AVar uTy,
                                        MW(Close
                                             (Var("s0",
                                                  PTy(bTy,PTy(F32,qTy))),
                                              TP[bVar"s",
                                                 Mop(Snd,
                                                     Var("s0",
                                                         PTy(bTy,
                                                             PTy(F32,qTy))))])))))])))))),
                (LW(2,2),
                 MB(MD(MD(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),F32),
                       bTy),
                    Close
                      (Var("v",F32),
                       MB(MB(MB(MB(MU(Mop(Cast iTy,Var("v",F32)),
                                      PTy(bTy,PTy(F32,qTy))),
                                   Close
                                     (iVar"v",
                                      MU(Bop(Mul,LI 2,iVar"v"),
                                         PTy(bTy,PTy(F32,qTy))))),
                                Close
                                  (iVar"v",
                                   MU(TP[iVar"v",LN 32],
                                      PTy(bTy,PTy(F32,qTy))))),
                             Close
                               (Var("v",PTy(iTy,nTy)),
                                MD(MD(Call
                                        ("SignedSatQ",
                                         ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                                         Var("v",PTy(iTy,nTy))),F32),bTy))),
                          Close
                            (Var("x",PTy(F32,bTy)),
                             CS(Var("x",PTy(F32,bTy)),
                                [(TP[Var("doubled",F32),bVar"sat1"],
                                  MB(MD(MD(Call
                                             ("R",ATy(qTy,PTy(F32,qTy)),
                                              Var("m",F4)),F32),bTy),
                                     Close
                                       (Var("v",F32),
                                        MB(MB(MB(MB(MU(Mop(Cast iTy,
                                                           Var("v",F32)),
                                                       PTy(bTy,
                                                           PTy(F32,qTy))),
                                                    Close
                                                      (iVar"v",
                                                       MU(Bop(Add,iVar"v",
                                                              Mop(Cast iTy,
                                                                  Var("doubled",
                                                                      F32))),
                                                          PTy(bTy,
                                                              PTy(F32,qTy))))),
                                                 Close
                                                   (iVar"v",
                                                    MU(TP[iVar"v",LN 32],
                                                       PTy(bTy,
                                                           PTy(F32,qTy))))),
                                              Close
                                                (Var("v",PTy(iTy,nTy)),
                                                 MD(MD(Call
                                                         ("SignedSatQ",
                                                          ATy(qTy,
                                                              PTy(PTy(F32,
                                                                      bTy),
                                                                  qTy)),
                                                          Var("v",
                                                              PTy(iTy,nTy))),
                                                       F32),bTy))),
                                           Close
                                             (Var("x",PTy(F32,bTy)),
                                              CS(Var("x",PTy(F32,bTy)),
                                                 [(TP[Var("r",F32),
                                                      bVar"sat2"],
                                                   MB(MW(Close
                                                           (Var("s",
                                                                PTy(bTy,
                                                                    PTy(F32,
                                                                        qTy))),
                                                            TP[Mop(Fst,
                                                                   Var("s",
                                                                       PTy(bTy,
                                                                           PTy(F32,
                                                                               qTy)))),
                                                               Var("r",F32),
                                                               Mop(Snd,
                                                                   Mop(Snd,
                                                                       Var("s",
                                                                           PTy(bTy,
                                                                               PTy(F32,
                                                                                   qTy)))))])),
                                                      Close
                                                        (AVar uTy,
                                                         MW(Close
                                                              (Var("s",
                                                                   PTy(bTy,
                                                                       PTy(F32,
                                                                           qTy))),
                                                               TP[bVar"sat1",
                                                                  Mop(Snd,
                                                                      Var("s",
                                                                          PTy(bTy,
                                                                              PTy(F32,
                                                                                  qTy))))])))))]))))))])))))),
                (LW(3,2),
                 MB(MD(MD(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),F32),
                       bTy),
                    Close
                      (Var("v",F32),
                       MB(MB(MB(MB(MU(Mop(Cast iTy,Var("v",F32)),
                                      PTy(bTy,PTy(F32,qTy))),
                                   Close
                                     (iVar"v",
                                      MU(Bop(Mul,LI 2,iVar"v"),
                                         PTy(bTy,PTy(F32,qTy))))),
                                Close
                                  (iVar"v",
                                   MU(TP[iVar"v",LN 32],
                                      PTy(bTy,PTy(F32,qTy))))),
                             Close
                               (Var("v",PTy(iTy,nTy)),
                                MD(MD(Call
                                        ("SignedSatQ",
                                         ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                                         Var("v",PTy(iTy,nTy))),F32),bTy))),
                          Close
                            (Var("x",PTy(F32,bTy)),
                             CS(Var("x",PTy(F32,bTy)),
                                [(TP[Var("doubled",F32),bVar"sat1"],
                                  MB(MD(MD(Call
                                             ("R",ATy(qTy,PTy(F32,qTy)),
                                              Var("m",F4)),F32),bTy),
                                     Close
                                       (Var("v",F32),
                                        MB(MB(MB(MB(MU(Mop(Cast iTy,
                                                           Var("v",F32)),
                                                       PTy(bTy,
                                                           PTy(F32,qTy))),
                                                    Close
                                                      (iVar"v",
                                                       MU(Bop(Sub,iVar"v",
                                                              Mop(Cast iTy,
                                                                  Var("doubled",
                                                                      F32))),
                                                          PTy(bTy,
                                                              PTy(F32,qTy))))),
                                                 Close
                                                   (iVar"v",
                                                    MU(TP[iVar"v",LN 32],
                                                       PTy(bTy,
                                                           PTy(F32,qTy))))),
                                              Close
                                                (Var("v",PTy(iTy,nTy)),
                                                 MD(MD(Call
                                                         ("SignedSatQ",
                                                          ATy(qTy,
                                                              PTy(PTy(F32,
                                                                      bTy),
                                                                  qTy)),
                                                          Var("v",
                                                              PTy(iTy,nTy))),
                                                       F32),bTy))),
                                           Close
                                             (Var("x",PTy(F32,bTy)),
                                              CS(Var("x",PTy(F32,bTy)),
                                                 [(TP[Var("r",F32),
                                                      bVar"sat2"],
                                                   MB(MW(Close
                                                           (Var("s",
                                                                PTy(bTy,
                                                                    PTy(F32,
                                                                        qTy))),
                                                            TP[Mop(Fst,
                                                                   Var("s",
                                                                       PTy(bTy,
                                                                           PTy(F32,
                                                                               qTy)))),
                                                               Var("r",F32),
                                                               Mop(Snd,
                                                                   Mop(Snd,
                                                                       Var("s",
                                                                           PTy(bTy,
                                                                               PTy(F32,
                                                                                   qTy)))))])),
                                                      Close
                                                        (AVar uTy,
                                                         MW(Close
                                                              (Var("s",
                                                                   PTy(bTy,
                                                                       PTy(F32,
                                                                           qTy))),
                                                               TP[Bop(Or,
                                                                      bVar"sat1",
                                                                      bVar"sat2"),
                                                                  Mop(Snd,
                                                                      Var("s",
                                                                          PTy(bTy,
                                                                              PTy(F32,
                                                                                  qTy))))])))))]))))))]))))))]),
            Close
              (AVar uTy,
               MB(MR(Close
                       (Var("s",PTy(bTy,PTy(F32,qTy))),
                        Mop(Fst,Mop(Snd,Var("s",PTy(bTy,PTy(F32,qTy))))))),
                  Close
                    (Var("v",F32),
                     MB(MB(MU(TP[Var("v",F32),Var("d",F4)],
                              PTy(bTy,PTy(F32,qTy))),
                           Close
                             (Var("v",PTy(F32,F4)),
                              MD(MD(Call
                                      ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                       Var("v",PTy(F32,F4))),F32),bTy))),
                        Close
                          (AVar uTy,
                           MB(MR(Close
                                   (Var("s",PTy(bTy,PTy(F32,qTy))),
                                    Mop(Fst,Var("s",PTy(bTy,PTy(F32,qTy)))))),
                              Close
                                (bVar"v",
                                 MB(ITE(bVar"v",
                                        MB(MR(Close
                                                (Var("s",
                                                     PTy(bTy,PTy(F32,qTy))),
                                                 Dest
                                                   ("CPSR",CTy"PSR",
                                                    Mop(Snd,
                                                        Mop(Snd,
                                                            Var("s",
                                                                PTy(bTy,
                                                                    PTy(F32,
                                                                        qTy)))))))),
                                           Close
                                             (Var("v",CTy"PSR"),
                                              MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                          LT],
                                                       PTy(bTy,
                                                           PTy(F32,qTy))),
                                                    Close
                                                      (Var("v",
                                                           PTy(CTy"PSR",
                                                               bTy)),
                                                       MU(Rupd
                                                            ("Q",
                                                             Var("v",
                                                                 PTy(CTy"PSR",
                                                                     bTy))),
                                                          PTy(bTy,
                                                              PTy(F32,qTy))))),
                                                 Close
                                                   (Var("v",CTy"PSR"),
                                                    MW(Close
                                                         (Var("s",
                                                              PTy(bTy,
                                                                  PTy(F32,
                                                                      qTy))),
                                                          TP[Mop(Fst,
                                                                 Var("s",
                                                                     PTy(bTy,
                                                                         PTy(F32,
                                                                             qTy)))),
                                                             Let(Var("s",
                                                                     PTy(F32,
                                                                         qTy)),
                                                                 Mop(Snd,
                                                                     Var("s",
                                                                         PTy(bTy,
                                                                             PTy(F32,
                                                                                 qTy)))),
                                                                 TP[Mop(Fst,
                                                                        Var("s",
                                                                            PTy(F32,
                                                                                qTy))),
                                                                    Rupd
                                                                      ("CPSR",
                                                                       TP[Mop(Snd,
                                                                              Var("s",
                                                                                  PTy(F32,
                                                                                      qTy))),
                                                                          Var("v",
                                                                              CTy"PSR")])])])))))),
                                        MU(LU,PTy(bTy,PTy(F32,qTy)))),
                                    Close
                                      (AVar uTy,
                                       MD(MD(Call
                                               ("IncPC",
                                                ATy(qTy,PTy(uTy,qTy)),LU),
                                             F32),bTy))))))))))))))
;
val dfn'Multiply32_def = Def
  ("dfn'Multiply32",
   TP[bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("rm",F32),
               Let(Var("result",F32),Bop(Mul,Var("rn",F32),Var("rm",F32)),
                   MB(Call
                        ("write'R",ATy(qTy,PTy(uTy,qTy)),
                         TP[Var("result",F32),Var("d",F4)]),
                      Close
                        (AVar uTy,
                         MB(ITE(bVar"setflags",
                                MB(MR(Close
                                        (qVar"s",
                                         Dest("CPSR",CTy"PSR",qVar"s"))),
                                   Close
                                     (Var("v",CTy"PSR"),
                                      MB(MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                     Bop(Bit,
                                                         Var("result",F32),
                                                         LN 31)],qTy),
                                               Close
                                                 (Var("v",
                                                      PTy(CTy"PSR",bTy)),
                                                  MU(Rupd
                                                       ("N",
                                                        Var("v",
                                                            PTy(CTy"PSR",
                                                                bTy))),qTy))),
                                            Close
                                              (Var("v",CTy"PSR"),
                                               MW(Close
                                                    (qVar"s",
                                                     Rupd
                                                       ("CPSR",
                                                        TP[qVar"s",
                                                           Var("v",
                                                               CTy"PSR")]))))),
                                         Close
                                           (AVar uTy,
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("CPSR",CTy"PSR",
                                                        qVar"s"))),
                                               Close
                                                 (Var("v",CTy"PSR"),
                                                  MB(MB(MB(MU(TP[Var("v",
                                                                     CTy"PSR"),
                                                                 EQ(Var("result",
                                                                        F32),
                                                                    LW(0,
                                                                       32))],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(CTy"PSR",
                                                                      bTy)),
                                                              MU(Rupd
                                                                   ("Z",
                                                                    Var("v",
                                                                        PTy(CTy"PSR",
                                                                            bTy))),
                                                                 qTy))),
                                                        Close
                                                          (Var("v",
                                                               CTy"PSR"),
                                                           MW(Close
                                                                (qVar"s",
                                                                 Rupd
                                                                   ("CPSR",
                                                                    TP[qVar"s",
                                                                       Var("v",
                                                                           CTy"PSR")]))))),
                                                     Close
                                                       (AVar uTy,
                                                        MB(Call
                                                             ("ArchVersion",
                                                              ATy(qTy,
                                                                  PTy(nTy,
                                                                      qTy)),
                                                              LU),
                                                           Close
                                                             (nVar"v",
                                                              MB(MU(EQ(nVar"v",
                                                                       LN
                                                                        4),
                                                                    qTy),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        MB(MR(Close
                                                                                (qVar"s",
                                                                                 Dest
                                                                                   ("CPSR",
                                                                                    CTy"PSR",
                                                                                    qVar"s"))),
                                                                           Close
                                                                             (Var("v",
                                                                                  CTy"PSR"),
                                                                              MB(MB(MB(MR(Close
                                                                                            (qVar"s",
                                                                                             Dest
                                                                                               ("CPSR",
                                                                                                CTy"PSR",
                                                                                                qVar"s"))),
                                                                                       Close
                                                                                         (Var("v0",
                                                                                              CTy"PSR"),
                                                                                          MB(MB(MB(MB(MU(Dest
                                                                                                           ("C",
                                                                                                            bTy,
                                                                                                            Var("v0",
                                                                                                                CTy"PSR")),
                                                                                                         qTy),
                                                                                                      Close
                                                                                                        (bVar"v",
                                                                                                         MU(TP[Var("rm",
                                                                                                                   F32),
                                                                                                               bVar"v"],
                                                                                                            qTy))),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          PTy(F32,
                                                                                                              bTy)),
                                                                                                      MU(TP[Var("rn",
                                                                                                                F32),
                                                                                                            Var("v",
                                                                                                                PTy(F32,
                                                                                                                    bTy))],
                                                                                                         qTy))),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       PTy(F32,
                                                                                                           PTy(F32,
                                                                                                               bTy))),
                                                                                                   MU(Apply
                                                                                                        (LX(ATy(PTy(F32,
                                                                                                                    PTy(F32,
                                                                                                                        bTy)),
                                                                                                                bTy)),
                                                                                                         Var("v",
                                                                                                             PTy(F32,
                                                                                                                 PTy(F32,
                                                                                                                     bTy)))),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (bVar"v0",
                                                                                                MU(TP[Var("v",
                                                                                                          CTy"PSR"),
                                                                                                      bVar"v0"],
                                                                                                   qTy))))),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           PTy(CTy"PSR",
                                                                                               bTy)),
                                                                                       MU(Rupd
                                                                                            ("C",
                                                                                             Var("v",
                                                                                                 PTy(CTy"PSR",
                                                                                                     bTy))),
                                                                                          qTy))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"PSR"),
                                                                                    MW(Close
                                                                                         (qVar"s",
                                                                                          Rupd
                                                                                            ("CPSR",
                                                                                             TP[qVar"s",
                                                                                                Var("v",
                                                                                                    CTy"PSR")]))))))),
                                                                        MU(LU,
                                                                           qTy)))))))))))))),
                                MU(LU,qTy)),
                            Close
                              (AVar uTy,
                               Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))))))
;
val dfn'MultiplyAccumulate_def = Def
  ("dfn'MultiplyAccumulate",
   TP[bVar"setflags",Var("d",F4),Var("n",F4),Var("m",F4),Var("a",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("rm",F32),
               MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("a",F4)),
                  Close
                    (Var("ra",F32),
                     Let(Var("result",F32),
                         Bop(Add,Bop(Mul,Var("rn",F32),Var("rm",F32)),
                             Var("ra",F32)),
                         MB(Call
                              ("write'R",ATy(qTy,PTy(uTy,qTy)),
                               TP[Var("result",F32),Var("d",F4)]),
                            Close
                              (AVar uTy,
                               MB(ITE(bVar"setflags",
                                      MB(MR(Close
                                              (qVar"s",
                                               Dest
                                                 ("CPSR",CTy"PSR",qVar"s"))),
                                         Close
                                           (Var("v",CTy"PSR"),
                                            MB(MB(MB(MU(TP[Var("v",
                                                               CTy"PSR"),
                                                           Bop(Bit,
                                                               Var("result",
                                                                   F32),
                                                               LN 31)],qTy),
                                                     Close
                                                       (Var("v",
                                                            PTy(CTy"PSR",
                                                                bTy)),
                                                        MU(Rupd
                                                             ("N",
                                                              Var("v",
                                                                  PTy(CTy"PSR",
                                                                      bTy))),
                                                           qTy))),
                                                  Close
                                                    (Var("v",CTy"PSR"),
                                                     MW(Close
                                                          (qVar"s",
                                                           Rupd
                                                             ("CPSR",
                                                              TP[qVar"s",
                                                                 Var("v",
                                                                     CTy"PSR")]))))),
                                               Close
                                                 (AVar uTy,
                                                  MB(MR(Close
                                                          (qVar"s",
                                                           Dest
                                                             ("CPSR",
                                                              CTy"PSR",
                                                              qVar"s"))),
                                                     Close
                                                       (Var("v",CTy"PSR"),
                                                        MB(MB(MB(MU(TP[Var("v",
                                                                           CTy"PSR"),
                                                                       EQ(Var("result",
                                                                              F32),
                                                                          LW(0,
                                                                             32))],
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(CTy"PSR",
                                                                            bTy)),
                                                                    MU(Rupd
                                                                         ("Z",
                                                                          Var("v",
                                                                              PTy(CTy"PSR",
                                                                                  bTy))),
                                                                       qTy))),
                                                              Close
                                                                (Var("v",
                                                                     CTy"PSR"),
                                                                 MW(Close
                                                                      (qVar"s",
                                                                       Rupd
                                                                         ("CPSR",
                                                                          TP[qVar"s",
                                                                             Var("v",
                                                                                 CTy"PSR")]))))),
                                                           Close
                                                             (AVar uTy,
                                                              MB(Call
                                                                   ("ArchVersion",
                                                                    ATy(qTy,
                                                                        PTy(nTy,
                                                                            qTy)),
                                                                    LU),
                                                                 Close
                                                                   (nVar"v",
                                                                    MB(MU(EQ(nVar"v",
                                                                             LN
                                                                              4),
                                                                          qTy),
                                                                       Close
                                                                         (bVar"b",
                                                                          ITE(bVar"b",
                                                                              MB(MR(Close
                                                                                      (qVar"s",
                                                                                       Dest
                                                                                         ("CPSR",
                                                                                          CTy"PSR",
                                                                                          qVar"s"))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"PSR"),
                                                                                    MB(MB(MB(MR(Close
                                                                                                  (qVar"s",
                                                                                                   Dest
                                                                                                     ("CPSR",
                                                                                                      CTy"PSR",
                                                                                                      qVar"s"))),
                                                                                             Close
                                                                                               (Var("v0",
                                                                                                    CTy"PSR"),
                                                                                                MB(MB(MB(MB(MB(MU(Dest
                                                                                                                    ("C",
                                                                                                                     bTy,
                                                                                                                     Var("v0",
                                                                                                                         CTy"PSR")),
                                                                                                                  qTy),
                                                                                                               Close
                                                                                                                 (bVar"v",
                                                                                                                  MU(TP[Var("ra",
                                                                                                                            F32),
                                                                                                                        bVar"v"],
                                                                                                                     qTy))),
                                                                                                            Close
                                                                                                              (Var("v",
                                                                                                                   PTy(F32,
                                                                                                                       bTy)),
                                                                                                               MU(TP[Var("rm",
                                                                                                                         F32),
                                                                                                                     Var("v",
                                                                                                                         PTy(F32,
                                                                                                                             bTy))],
                                                                                                                  qTy))),
                                                                                                         Close
                                                                                                           (Var("v",
                                                                                                                PTy(F32,
                                                                                                                    PTy(F32,
                                                                                                                        bTy))),
                                                                                                            MU(TP[Var("rn",
                                                                                                                      F32),
                                                                                                                  Var("v",
                                                                                                                      PTy(F32,
                                                                                                                          PTy(F32,
                                                                                                                              bTy)))],
                                                                                                               qTy))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             PTy(F32,
                                                                                                                 PTy(F32,
                                                                                                                     PTy(F32,
                                                                                                                         bTy)))),
                                                                                                         MU(Apply
                                                                                                              (LX(ATy(PTy(F32,
                                                                                                                          PTy(F32,
                                                                                                                              PTy(F32,
                                                                                                                                  bTy))),
                                                                                                                      bTy)),
                                                                                                               Var("v",
                                                                                                                   PTy(F32,
                                                                                                                       PTy(F32,
                                                                                                                           PTy(F32,
                                                                                                                               bTy))))),
                                                                                                            qTy))),
                                                                                                   Close
                                                                                                     (bVar"v0",
                                                                                                      MU(TP[Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            bVar"v0"],
                                                                                                         qTy))))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 PTy(CTy"PSR",
                                                                                                     bTy)),
                                                                                             MU(Rupd
                                                                                                  ("C",
                                                                                                   Var("v",
                                                                                                       PTy(CTy"PSR",
                                                                                                           bTy))),
                                                                                                qTy))),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              CTy"PSR"),
                                                                                          MW(Close
                                                                                               (qVar"s",
                                                                                                Rupd
                                                                                                  ("CPSR",
                                                                                                   TP[qVar"s",
                                                                                                      Var("v",
                                                                                                          CTy"PSR")]))))))),
                                                                              MU(LU,
                                                                                 qTy)))))))))))))),
                                      MU(LU,qTy)),
                                  Close
                                    (AVar uTy,
                                     Call
                                       ("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))))))))
;
val dfn'MultiplyLong_def = Def
  ("dfn'MultiplyLong",
   TP[bVar"accumulate",bVar"signed",bVar"setflags",Var("dhi",F4),
      Var("dlo",F4),Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("rm",F32),
               MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("dhi",F4)),
                  Close
                    (Var("rdhi",F32),
                     MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("dlo",F4)),
                        Close
                          (Var("rdlo",F32),
                           Let(Var("result",F64),
                               Bop(Add,
                                   ITE(bVar"signed",
                                       Bop(Mul,Mop(SE F64,Var("rn",F32)),
                                           Mop(SE F64,Var("rm",F32))),
                                       Bop(Mul,
                                           Mop(Cast F64,Var("rn",F32)),
                                           Mop(Cast F64,Var("rm",F32)))),
                                   ITE(bVar"accumulate",
                                       CC[Var("rdhi",F32),Var("rdlo",F32)],
                                       LW(0,64))),
                               MB(Call
                                    ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                     TP[EX(Var("result",F64),LN 63,LN 32,
                                           F32),Var("dhi",F4)]),
                                  Close
                                    (AVar uTy,
                                     MB(Call
                                          ("write'R",
                                           ATy(qTy,PTy(uTy,qTy)),
                                           TP[EX(Var("result",F64),LN 31,
                                                 LN 0,F32),Var("dlo",F4)]),
                                        Close
                                          (AVar uTy,
                                           MB(ITE(bVar"setflags",
                                                  MB(MR(Close
                                                          (qVar"s",
                                                           Dest
                                                             ("CPSR",
                                                              CTy"PSR",
                                                              qVar"s"))),
                                                     Close
                                                       (Var("v",CTy"PSR"),
                                                        MB(MB(MB(MU(TP[Var("v",
                                                                           CTy"PSR"),
                                                                       Bop(Bit,
                                                                           Var("result",
                                                                               F64),
                                                                           LN
                                                                            63)],
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(CTy"PSR",
                                                                            bTy)),
                                                                    MU(Rupd
                                                                         ("N",
                                                                          Var("v",
                                                                              PTy(CTy"PSR",
                                                                                  bTy))),
                                                                       qTy))),
                                                              Close
                                                                (Var("v",
                                                                     CTy"PSR"),
                                                                 MW(Close
                                                                      (qVar"s",
                                                                       Rupd
                                                                         ("CPSR",
                                                                          TP[qVar"s",
                                                                             Var("v",
                                                                                 CTy"PSR")]))))),
                                                           Close
                                                             (AVar uTy,
                                                              MB(MR(Close
                                                                      (qVar"s",
                                                                       Dest
                                                                         ("CPSR",
                                                                          CTy"PSR",
                                                                          qVar"s"))),
                                                                 Close
                                                                   (Var("v",
                                                                        CTy"PSR"),
                                                                    MB(MB(MB(MU(TP[Var("v",
                                                                                       CTy"PSR"),
                                                                                   EQ(Var("result",
                                                                                          F64),
                                                                                      LW(0,
                                                                                         64))],
                                                                                qTy),
                                                                             Close
                                                                               (Var("v",
                                                                                    PTy(CTy"PSR",
                                                                                        bTy)),
                                                                                MU(Rupd
                                                                                     ("Z",
                                                                                      Var("v",
                                                                                          PTy(CTy"PSR",
                                                                                              bTy))),
                                                                                   qTy))),
                                                                          Close
                                                                            (Var("v",
                                                                                 CTy"PSR"),
                                                                             MW(Close
                                                                                  (qVar"s",
                                                                                   Rupd
                                                                                     ("CPSR",
                                                                                      TP[qVar"s",
                                                                                         Var("v",
                                                                                             CTy"PSR")]))))),
                                                                       Close
                                                                         (AVar
                                                                            uTy,
                                                                          MB(Call
                                                                               ("ArchVersion",
                                                                                ATy(qTy,
                                                                                    PTy(nTy,
                                                                                        qTy)),
                                                                                LU),
                                                                             Close
                                                                               (nVar"v",
                                                                                MB(MU(EQ(nVar"v",
                                                                                         LN
                                                                                          4),
                                                                                      qTy),
                                                                                   Close
                                                                                     (bVar"b",
                                                                                      ITE(bVar"b",
                                                                                          MB(MR(Close
                                                                                                  (qVar"s",
                                                                                                   Dest
                                                                                                     ("CPSR",
                                                                                                      CTy"PSR",
                                                                                                      qVar"s"))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"PSR"),
                                                                                                MB(MB(MB(MB(MR(Close
                                                                                                                 (qVar"s",
                                                                                                                  Dest
                                                                                                                    ("CPSR",
                                                                                                                     CTy"PSR",
                                                                                                                     qVar"s"))),
                                                                                                            Close
                                                                                                              (Var("v0",
                                                                                                                   CTy"PSR"),
                                                                                                               MB(MB(MB(MB(MB(MB(MU(Dest
                                                                                                                                      ("C",
                                                                                                                                       bTy,
                                                                                                                                       Var("v0",
                                                                                                                                           CTy"PSR")),
                                                                                                                                    qTy),
                                                                                                                                 Close
                                                                                                                                   (bVar"v",
                                                                                                                                    MU(TP[Var("rdlo",
                                                                                                                                              F32),
                                                                                                                                          bVar"v"],
                                                                                                                                       qTy))),
                                                                                                                              Close
                                                                                                                                (Var("v",
                                                                                                                                     PTy(F32,
                                                                                                                                         bTy)),
                                                                                                                                 MU(TP[Var("rdhi",
                                                                                                                                           F32),
                                                                                                                                       Var("v",
                                                                                                                                           PTy(F32,
                                                                                                                                               bTy))],
                                                                                                                                    qTy))),
                                                                                                                           Close
                                                                                                                             (Var("v",
                                                                                                                                  PTy(F32,
                                                                                                                                      PTy(F32,
                                                                                                                                          bTy))),
                                                                                                                              MU(TP[Var("rm",
                                                                                                                                        F32),
                                                                                                                                    Var("v",
                                                                                                                                        PTy(F32,
                                                                                                                                            PTy(F32,
                                                                                                                                                bTy)))],
                                                                                                                                 qTy))),
                                                                                                                        Close
                                                                                                                          (Var("v",
                                                                                                                               PTy(F32,
                                                                                                                                   PTy(F32,
                                                                                                                                       PTy(F32,
                                                                                                                                           bTy)))),
                                                                                                                           MU(TP[Var("rn",
                                                                                                                                     F32),
                                                                                                                                 Var("v",
                                                                                                                                     PTy(F32,
                                                                                                                                         PTy(F32,
                                                                                                                                             PTy(F32,
                                                                                                                                                 bTy))))],
                                                                                                                              qTy))),
                                                                                                                     Close
                                                                                                                       (Var("v",
                                                                                                                            PTy(F32,
                                                                                                                                PTy(F32,
                                                                                                                                    PTy(F32,
                                                                                                                                        PTy(F32,
                                                                                                                                            bTy))))),
                                                                                                                        MU(Apply
                                                                                                                             (LX(ATy(PTy(F32,
                                                                                                                                         PTy(F32,
                                                                                                                                             PTy(F32,
                                                                                                                                                 PTy(F32,
                                                                                                                                                     bTy)))),
                                                                                                                                     bTy)),
                                                                                                                              Var("v",
                                                                                                                                  PTy(F32,
                                                                                                                                      PTy(F32,
                                                                                                                                          PTy(F32,
                                                                                                                                              PTy(F32,
                                                                                                                                                  bTy)))))),
                                                                                                                           qTy))),
                                                                                                                  Close
                                                                                                                    (bVar"v0",
                                                                                                                     MU(TP[Var("v",
                                                                                                                               CTy"PSR"),
                                                                                                                           bVar"v0"],
                                                                                                                        qTy))))),
                                                                                                         Close
                                                                                                           (Var("v",
                                                                                                                PTy(CTy"PSR",
                                                                                                                    bTy)),
                                                                                                            MU(Rupd
                                                                                                                 ("C",
                                                                                                                  Var("v",
                                                                                                                      PTy(CTy"PSR",
                                                                                                                          bTy))),
                                                                                                               qTy))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             CTy"PSR"),
                                                                                                         MW(Close
                                                                                                              (qVar"s",
                                                                                                               Rupd
                                                                                                                 ("CPSR",
                                                                                                                  TP[qVar"s",
                                                                                                                     Var("v",
                                                                                                                         CTy"PSR")]))))),
                                                                                                   Close
                                                                                                     (AVar
                                                                                                        uTy,
                                                                                                      MB(MR(Close
                                                                                                              (qVar"s",
                                                                                                               Dest
                                                                                                                 ("CPSR",
                                                                                                                  CTy"PSR",
                                                                                                                  qVar"s"))),
                                                                                                         Close
                                                                                                           (Var("v",
                                                                                                                CTy"PSR"),
                                                                                                            MB(MB(MB(MR(Close
                                                                                                                          (qVar"s",
                                                                                                                           Dest
                                                                                                                             ("CPSR",
                                                                                                                              CTy"PSR",
                                                                                                                              qVar"s"))),
                                                                                                                     Close
                                                                                                                       (Var("v0",
                                                                                                                            CTy"PSR"),
                                                                                                                        MB(MB(MB(MB(MB(MB(MU(Dest
                                                                                                                                               ("V",
                                                                                                                                                bTy,
                                                                                                                                                Var("v0",
                                                                                                                                                    CTy"PSR")),
                                                                                                                                             qTy),
                                                                                                                                          Close
                                                                                                                                            (bVar"v",
                                                                                                                                             MU(TP[Var("rdlo",
                                                                                                                                                       F32),
                                                                                                                                                   bVar"v"],
                                                                                                                                                qTy))),
                                                                                                                                       Close
                                                                                                                                         (Var("v",
                                                                                                                                              PTy(F32,
                                                                                                                                                  bTy)),
                                                                                                                                          MU(TP[Var("rdhi",
                                                                                                                                                    F32),
                                                                                                                                                Var("v",
                                                                                                                                                    PTy(F32,
                                                                                                                                                        bTy))],
                                                                                                                                             qTy))),
                                                                                                                                    Close
                                                                                                                                      (Var("v",
                                                                                                                                           PTy(F32,
                                                                                                                                               PTy(F32,
                                                                                                                                                   bTy))),
                                                                                                                                       MU(TP[Var("rm",
                                                                                                                                                 F32),
                                                                                                                                             Var("v",
                                                                                                                                                 PTy(F32,
                                                                                                                                                     PTy(F32,
                                                                                                                                                         bTy)))],
                                                                                                                                          qTy))),
                                                                                                                                 Close
                                                                                                                                   (Var("v",
                                                                                                                                        PTy(F32,
                                                                                                                                            PTy(F32,
                                                                                                                                                PTy(F32,
                                                                                                                                                    bTy)))),
                                                                                                                                    MU(TP[Var("rn",
                                                                                                                                              F32),
                                                                                                                                          Var("v",
                                                                                                                                              PTy(F32,
                                                                                                                                                  PTy(F32,
                                                                                                                                                      PTy(F32,
                                                                                                                                                          bTy))))],
                                                                                                                                       qTy))),
                                                                                                                              Close
                                                                                                                                (Var("v",
                                                                                                                                     PTy(F32,
                                                                                                                                         PTy(F32,
                                                                                                                                             PTy(F32,
                                                                                                                                                 PTy(F32,
                                                                                                                                                     bTy))))),
                                                                                                                                 MU(Apply
                                                                                                                                      (LX(ATy(PTy(F32,
                                                                                                                                                  PTy(F32,
                                                                                                                                                      PTy(F32,
                                                                                                                                                          PTy(F32,
                                                                                                                                                              bTy)))),
                                                                                                                                              bTy)),
                                                                                                                                       Var("v",
                                                                                                                                           PTy(F32,
                                                                                                                                               PTy(F32,
                                                                                                                                                   PTy(F32,
                                                                                                                                                       PTy(F32,
                                                                                                                                                           bTy)))))),
                                                                                                                                    qTy))),
                                                                                                                           Close
                                                                                                                             (bVar"v0",
                                                                                                                              MU(TP[Var("v",
                                                                                                                                        CTy"PSR"),
                                                                                                                                    bVar"v0"],
                                                                                                                                 qTy))))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         PTy(CTy"PSR",
                                                                                                                             bTy)),
                                                                                                                     MU(Rupd
                                                                                                                          ("V",
                                                                                                                           Var("v",
                                                                                                                               PTy(CTy"PSR",
                                                                                                                                   bTy))),
                                                                                                                        qTy))),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      CTy"PSR"),
                                                                                                                  MW(Close
                                                                                                                       (qVar"s",
                                                                                                                        Rupd
                                                                                                                          ("CPSR",
                                                                                                                           TP[qVar"s",
                                                                                                                              Var("v",
                                                                                                                                  CTy"PSR")]))))))))))),
                                                                                          MU(LU,
                                                                                             qTy)))))))))))))),
                                                  MU(LU,qTy)),
                                              Close
                                                (AVar uTy,
                                                 Call
                                                   ("IncPC",
                                                    ATy(qTy,PTy(uTy,qTy)),
                                                    LU)))))))))))))))))
;
val dfn'MultiplyAccumulateAccumulate_def = Def
  ("dfn'MultiplyAccumulateAccumulate",
   TP[Var("dhi",F4),Var("dlo",F4),Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MB(MU(Mop(Cast F64,Var("v",F32)),qTy),
                     Close
                       (Var("v",F64),
                        MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                           Close
                             (Var("v0",F32),
                              MB(MU(Mop(Cast F64,Var("v0",F32)),qTy),
                                 Close
                                   (Var("v0",F64),
                                    MU(Bop(Mul,Var("v",F64),Var("v0",F64)),
                                       qTy))))))),
                  Close
                    (Var("v",F64),
                     MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("dhi",F4)),
                        Close
                          (Var("v0",F32),
                           MB(MU(Mop(Cast F64,Var("v0",F32)),qTy),
                              Close
                                (Var("v0",F64),
                                 MU(Bop(Add,Var("v",F64),Var("v0",F64)),
                                    qTy))))))),
               Close
                 (Var("v",F64),
                  MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("dlo",F4)),
                     Close
                       (Var("v0",F32),
                        MB(MU(Mop(Cast F64,Var("v0",F32)),qTy),
                           Close
                             (Var("v0",F64),
                              MU(Bop(Add,Var("v",F64),Var("v0",F64)),qTy))))))),
            Close
              (Var("result",F64),
               MB(Call
                    ("write'R",ATy(qTy,PTy(uTy,qTy)),
                     TP[EX(Var("result",F64),LN 63,LN 32,F32),
                        Var("dhi",F4)]),
                  Close
                    (AVar uTy,
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[EX(Var("result",F64),LN 31,LN 0,F32),
                              Var("dlo",F4)]),
                        Close
                          (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))))
;
val dfn'MultiplySubtract_def = Def
  ("dfn'MultiplySubtract",
   TP[Var("d",F4),Var("n",F4),Var("m",F4),Var("a",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("a",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                     Close
                       (Var("v0",F32),
                        MB(MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                              Close
                                (Var("v1",F32),
                                 MU(Bop(Mul,Var("v0",F32),Var("v1",F32)),
                                    qTy))),
                           Close
                             (Var("v0",F32),
                              MU(Bop(Sub,Var("v",F32),Var("v0",F32)),qTy))))),
                  Close(Var("v",F32),MU(TP[Var("v",F32),Var("d",F4)],qTy))),
               Close
                 (Var("v",PTy(F32,F4)),
                  Call
                    ("write'R",ATy(qTy,PTy(uTy,qTy)),Var("v",PTy(F32,F4))))),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'Signed16Multiply32Accumulate_def = Def
  ("dfn'Signed16Multiply32Accumulate",
   TP[bVar"m_high",bVar"n_high",Var("d",F4),Var("n",F4),Var("m",F4),
      Var("a",F4)],
   MB(ITE(bVar"n_high",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
      Close
        (Var("operand1",F16),
         MB(ITE(bVar"m_high",
                MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                   Close
                     (Var("v",F32),
                      MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
                MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                   Close
                     (Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
            Close
              (Var("operand2",F16),
               MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("a",F4)),
                  Close
                    (Var("v",F32),
                     MB(MB(MU(Mop(Cast iTy,Var("v",F32)),qTy),
                           Close
                             (iVar"v",
                              MU(Bop(Add,
                                     Bop(Mul,
                                         Mop(Cast iTy,Var("operand1",F16)),
                                         Mop(Cast iTy,Var("operand2",F16))),
                                     iVar"v"),qTy))),
                        Close
                          (iVar"result",
                           Let(Var("result32",F32),
                               Mop(Cast F32,iVar"result"),
                               MB(Call
                                    ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                     TP[Var("result32",F32),Var("d",F4)]),
                                  Close
                                    (AVar uTy,
                                     MB(ITE(Mop(Not,
                                                EQ(iVar"result",
                                                   Mop(Cast iTy,
                                                       Var("result32",F32)))),
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("CPSR",CTy"PSR",
                                                        qVar"s"))),
                                               Close
                                                 (Var("v",CTy"PSR"),
                                                  MB(MB(MU(TP[Var("v",
                                                                  CTy"PSR"),
                                                              LT],qTy),
                                                        Close
                                                          (Var("v",
                                                               PTy(CTy"PSR",
                                                                   bTy)),
                                                           MU(Rupd
                                                                ("Q",
                                                                 Var("v",
                                                                     PTy(CTy"PSR",
                                                                         bTy))),
                                                              qTy))),
                                                     Close
                                                       (Var("v",CTy"PSR"),
                                                        MW(Close
                                                             (qVar"s",
                                                              Rupd
                                                                ("CPSR",
                                                                 TP[qVar"s",
                                                                    Var("v",
                                                                        CTy"PSR")]))))))),
                                            MU(LU,qTy)),
                                        Close
                                          (AVar uTy,
                                           Call
                                             ("IncPC",
                                              ATy(qTy,PTy(uTy,qTy)),LU)))))))))))))))
;
val dfn'Signed16Multiply32Result_def = Def
  ("dfn'Signed16Multiply32Result",
   TP[bVar"m_high",bVar"n_high",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(ITE(bVar"n_high",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
      Close
        (Var("operand1",F16),
         MB(ITE(bVar"m_high",
                MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                   Close
                     (Var("v",F32),
                      MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
                MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                   Close
                     (Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
            Close
              (Var("operand2",F16),
               MB(Call
                    ("write'R",ATy(qTy,PTy(uTy,qTy)),
                     TP[Mop(Cast F32,
                            Bop(Mul,Mop(Cast iTy,Var("operand1",F16)),
                                Mop(Cast iTy,Var("operand2",F16)))),
                        Var("d",F4)]),
                  Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))
;
val dfn'Signed16x32Multiply32Accumulate_def = Def
  ("dfn'Signed16x32Multiply32Accumulate",
   TP[bVar"m_high",Var("d",F4),Var("n",F4),Var("m",F4),Var("a",F4)],
   MB(ITE(bVar"m_high",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
      Close
        (Var("operand2",F16),
         Let(iVar"sh16",Bop(Exp,LI 2,LN 16),
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("v",F32),
                   MB(MB(MB(MB(MU(Mop(Cast iTy,Var("v",F32)),qTy),
                               Close
                                 (iVar"v",
                                  MU(Bop(Mul,iVar"v",
                                         Mop(Cast iTy,Var("operand2",F16))),
                                     qTy))),
                            Close
                              (iVar"v",
                               MB(Call
                                    ("R",ATy(qTy,PTy(F32,qTy)),Var("a",F4)),
                                  Close
                                    (Var("v0",F32),
                                     MB(MB(MU(Mop(Cast iTy,Var("v0",F32)),
                                              qTy),
                                           Close
                                             (iVar"v",
                                              MU(Bop(Mul,iVar"v",
                                                     iVar"sh16"),qTy))),
                                        Close
                                          (iVar"v0",
                                           MU(Bop(Add,iVar"v",iVar"v0"),
                                              qTy))))))),
                         Close
                           (iVar"v",MU(Bop(Div,iVar"v",iVar"sh16"),qTy))),
                      Close
                        (iVar"result",
                         Let(Var("result32",F32),
                             Mop(Cast F32,iVar"result"),
                             MB(Call
                                  ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                   TP[Var("result32",F32),Var("d",F4)]),
                                Close
                                  (AVar uTy,
                                   MB(ITE(Mop(Not,
                                              EQ(iVar"result",
                                                 Mop(Cast iTy,
                                                     Var("result32",F32)))),
                                          MB(MR(Close
                                                  (qVar"s",
                                                   Dest
                                                     ("CPSR",CTy"PSR",
                                                      qVar"s"))),
                                             Close
                                               (Var("v",CTy"PSR"),
                                                MB(MB(MU(TP[Var("v",
                                                                CTy"PSR"),
                                                            LT],qTy),
                                                      Close
                                                        (Var("v",
                                                             PTy(CTy"PSR",
                                                                 bTy)),
                                                         MU(Rupd
                                                              ("Q",
                                                               Var("v",
                                                                   PTy(CTy"PSR",
                                                                       bTy))),
                                                            qTy))),
                                                   Close
                                                     (Var("v",CTy"PSR"),
                                                      MW(Close
                                                           (qVar"s",
                                                            Rupd
                                                              ("CPSR",
                                                               TP[qVar"s",
                                                                  Var("v",
                                                                      CTy"PSR")]))))))),
                                          MU(LU,qTy)),
                                      Close
                                        (AVar uTy,
                                         Call
                                           ("IncPC",ATy(qTy,PTy(uTy,qTy)),
                                            LU))))))))))))))
;
val dfn'Signed16x32Multiply32Result_def = Def
  ("dfn'Signed16x32Multiply32Result",
   TP[bVar"m_high",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(ITE(bVar"m_high",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
      Close
        (Var("operand2",F16),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
            Close
              (Var("v",F32),
               MB(MB(MB(MU(Mop(Cast iTy,Var("v",F32)),qTy),
                        Close
                          (iVar"v",
                           MU(Bop(Mul,iVar"v",
                                  Mop(Cast iTy,Var("operand2",F16))),qTy))),
                     Close
                       (iVar"v",
                        MU(Bop(Div,iVar"v",Bop(Exp,LI 2,LN 16)),qTy))),
                  Close
                    (iVar"result",
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[Mop(Cast F32,iVar"result"),Var("d",F4)]),
                        Close
                          (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))))
;
val dfn'Signed16Multiply64Accumulate_def = Def
  ("dfn'Signed16Multiply64Accumulate",
   TP[bVar"m_high",bVar"n_high",Var("dhi",F4),Var("dlo",F4),Var("n",F4),
      Var("m",F4)],
   MB(ITE(bVar"n_high",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close(Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
      Close
        (Var("operand1",F16),
         MB(ITE(bVar"m_high",
                MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                   Close
                     (Var("v",F32),
                      MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
                MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                   Close
                     (Var("v",F32),MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
            Close
              (Var("operand2",F16),
               MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("dhi",F4)),
                  Close
                    (Var("v",F32),
                     MB(MB(MB(MB(Call
                                   ("R",ATy(qTy,PTy(F32,qTy)),
                                    Var("dlo",F4)),
                                 Close
                                   (Var("v0",F32),
                                    MU(CC[Var("v",F32),Var("v0",F32)],qTy))),
                              Close
                                (Var("v",F64),
                                 MU(Mop(Cast iTy,Var("v",F64)),qTy))),
                           Close
                             (iVar"v",
                              MU(Bop(Add,
                                     Bop(Mul,
                                         Mop(Cast iTy,Var("operand1",F16)),
                                         Mop(Cast iTy,Var("operand2",F16))),
                                     iVar"v"),qTy))),
                        Close
                          (iVar"result",
                           Let(Var("result64",F64),
                               Mop(Cast F64,iVar"result"),
                               MB(Call
                                    ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                     TP[EX(Var("result64",F64),LN 63,
                                           LN 32,F32),Var("dhi",F4)]),
                                  Close
                                    (AVar uTy,
                                     MB(Call
                                          ("write'R",
                                           ATy(qTy,PTy(uTy,qTy)),
                                           TP[EX(Var("result64",F64),
                                                 LN 31,LN 0,F32),
                                              Var("dlo",F4)]),
                                        Close
                                          (AVar uTy,
                                           Call
                                             ("IncPC",
                                              ATy(qTy,PTy(uTy,qTy)),LU)))))))))))))))
;
val dfn'SignedMultiplyDual_def = Def
  ("dfn'SignedMultiplyDual",
   TP[bVar"sub",bVar"m_swap",Var("d",F4),Var("n",F4),Var("m",F4),
      Var("a",F4)],
   MB(ITE(bVar"m_swap",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
             Close
               (Var("v",F32),
                MB(MU(TP[Var("v",F32),LN 16],qTy),
                   Close
                     (Var("v",PTy(F32,nTy)),
                      Call
                        ("ROR",ATy(qTy,PTy(F32,qTy)),Var("v",PTy(F32,nTy))))))),
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4))),
      Close
        (Var("operand2",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
            Close
              (Var("v",F32),
               MB(MB(MB(MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy),
                        Close
                          (Var("v",F16),MU(Mop(Cast iTy,Var("v",F16)),qTy))),
                     Close
                       (iVar"v",
                        MU(Bop(Mul,iVar"v",
                               Mop(Cast iTy,
                                   EX(Var("operand2",F32),LN 15,LN 0,F16))),
                           qTy))),
                  Close
                    (iVar"product1",
                     MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                        Close
                          (Var("v",F32),
                           MB(MB(MB(MU(EX(Var("v",F32),LN 31,LN 16,F16),
                                       qTy),
                                    Close
                                      (Var("v",F16),
                                       MU(Mop(Cast iTy,Var("v",F16)),qTy))),
                                 Close
                                   (iVar"v",
                                    MU(Bop(Mul,iVar"v",
                                           Mop(Cast iTy,
                                               EX(Var("operand2",F32),
                                                  LN 31,LN 16,F16))),qTy))),
                              Close
                                (iVar"product2",
                                 MB(ITE(EQ(Var("a",F4),LW(15,4)),
                                        MU(LW(0,32),qTy),
                                        Call
                                          ("R",ATy(qTy,PTy(F32,qTy)),
                                           Var("a",F4))),
                                    Close
                                      (Var("acc",F32),
                                       Let(iVar"result",
                                           ITE(bVar"sub",
                                               Bop(Add,
                                                   Bop(Sub,iVar"product1",
                                                       iVar"product2"),
                                                   Mop(Cast iTy,
                                                       Var("acc",F32))),
                                               Bop(Add,
                                                   Bop(Add,iVar"product1",
                                                       iVar"product2"),
                                                   Mop(Cast iTy,
                                                       Var("acc",F32)))),
                                           Let(Var("result32",F32),
                                               Mop(Cast F32,iVar"result"),
                                               MB(Call
                                                    ("write'R",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Var("result32",F32),
                                                        Var("d",F4)]),
                                                  Close
                                                    (AVar uTy,
                                                     MB(ITE(Mop(Not,
                                                                EQ(iVar"result",
                                                                   Mop(Cast
                                                                         iTy,
                                                                       Var("result32",
                                                                           F32)))),
                                                            MB(MR(Close
                                                                    (qVar"s",
                                                                     Dest
                                                                       ("CPSR",
                                                                        CTy"PSR",
                                                                        qVar"s"))),
                                                               Close
                                                                 (Var("v",
                                                                      CTy"PSR"),
                                                                  MB(MB(MU(TP[Var("v",
                                                                                  CTy"PSR"),
                                                                              LT],
                                                                           qTy),
                                                                        Close
                                                                          (Var("v",
                                                                               PTy(CTy"PSR",
                                                                                   bTy)),
                                                                           MU(Rupd
                                                                                ("Q",
                                                                                 Var("v",
                                                                                     PTy(CTy"PSR",
                                                                                         bTy))),
                                                                              qTy))),
                                                                     Close
                                                                       (Var("v",
                                                                            CTy"PSR"),
                                                                        MW(Close
                                                                             (qVar"s",
                                                                              Rupd
                                                                                ("CPSR",
                                                                                 TP[qVar"s",
                                                                                    Var("v",
                                                                                        CTy"PSR")]))))))),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           Call
                                                             ("IncPC",
                                                              ATy(qTy,
                                                                  PTy(uTy,
                                                                      qTy)),
                                                              LU))))))))))))))))))))
;
val dfn'SignedMultiplyLongDual_def = Def
  ("dfn'SignedMultiplyLongDual",
   TP[bVar"sub",bVar"m_swap",Var("dhi",F4),Var("dlo",F4),Var("n",F4),
      Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(ITE(bVar"m_swap",
                MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                   Close
                     (Var("v",F32),
                      MB(MU(TP[Var("v",F32),LN 16],qTy),
                         Close
                           (Var("v",PTy(F32,nTy)),
                            Call
                              ("ROR",ATy(qTy,PTy(F32,qTy)),
                               Var("v",PTy(F32,nTy))))))),
                Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4))),
            Close
              (Var("operand2",F32),
               Let(iVar"product1",
                   Bop(Mul,Mop(Cast iTy,EX(Var("Rn",F32),LN 15,LN 0,F16)),
                       Mop(Cast iTy,EX(Var("operand2",F32),LN 15,LN 0,F16))),
                   Let(iVar"product2",
                       Bop(Mul,
                           Mop(Cast iTy,EX(Var("Rn",F32),LN 31,LN 16,F16)),
                           Mop(Cast iTy,
                               EX(Var("operand2",F32),LN 31,LN 16,F16))),
                       MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("dhi",F4)),
                          Close
                            (Var("v",F32),
                             MB(MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("dlo",F4)),
                                   Close
                                     (Var("v0",F32),
                                      MU(CC[Var("v",F32),Var("v0",F32)],
                                         qTy))),
                                Close
                                  (Var("acc",F64),
                                   Let(Var("result64",F64),
                                       Mop(Cast F64,
                                           ITE(bVar"sub",
                                               Bop(Add,
                                                   Bop(Sub,iVar"product1",
                                                       iVar"product2"),
                                                   Mop(Cast iTy,
                                                       Var("acc",F64))),
                                               Bop(Add,
                                                   Bop(Add,iVar"product1",
                                                       iVar"product2"),
                                                   Mop(Cast iTy,
                                                       Var("acc",F64))))),
                                       MB(Call
                                            ("write'R",
                                             ATy(qTy,PTy(uTy,qTy)),
                                             TP[EX(Var("result64",F64),
                                                   LN 63,LN 32,F32),
                                                Var("dhi",F4)]),
                                          Close
                                            (AVar uTy,
                                             MB(Call
                                                  ("write'R",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[EX(Var("result64",
                                                             F64),LN 31,
                                                         LN 0,F32),
                                                      Var("dlo",F4)]),
                                                Close
                                                  (AVar uTy,
                                                   Call
                                                     ("IncPC",
                                                      ATy(qTy,PTy(uTy,qTy)),
                                                      LU)))))))))))))))))
;
val dfn'SignedMostSignificantMultiply_def = Def
  ("dfn'SignedMostSignificantMultiply",
   TP[bVar"round",Var("d",F4),Var("n",F4),Var("m",F4),Var("a",F4)],
   MB(ITE(EQ(Var("a",F4),LW(15,4)),MU(LW(0,32),qTy),
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("a",F4))),
      Close
        (Var("acc",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
            Close
              (Var("v",F32),
               MB(MB(MB(MU(Mop(Cast iTy,Var("v",F32)),qTy),
                        Close
                          (iVar"v",
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v0",F32),
                                 MB(MU(Mop(Cast iTy,Var("v0",F32)),qTy),
                                    Close
                                      (iVar"v0",
                                       MU(Bop(Mul,iVar"v",iVar"v0"),qTy))))))),
                     Close
                       (iVar"v",
                        MU(Bop(Add,
                               Mop(Cast iTy,
                                   Bop(Lsl,Mop(Cast F64,Var("acc",F32)),
                                       LN 32)),iVar"v"),qTy))),
                  Close
                    (iVar"result",
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[EX(Mop(Cast F64,
                                     ITE(bVar"round",
                                         Bop(Add,iVar"result",
                                             LI 2147483648),iVar"result")),
                                 LN 63,LN 32,F32),Var("d",F4)]),
                        Close
                          (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))))
;
val dfn'SignedMostSignificantMultiplySubtract_def = Def
  ("dfn'SignedMostSignificantMultiplySubtract",
   TP[bVar"round",Var("d",F4),Var("n",F4),Var("m",F4),Var("a",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("a",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MB(MU(Mop(Cast F64,Var("v",F32)),qTy),
                     Close
                       (Var("v",F64),MU(Bop(Lsl,Var("v",F64),LN 32),qTy))),
                  Close(Var("v",F64),MU(Mop(Cast iTy,Var("v",F64)),qTy))),
               Close
                 (iVar"v",
                  MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                     Close
                       (Var("v0",F32),
                        MB(MB(MU(Mop(Cast iTy,Var("v0",F32)),qTy),
                              Close
                                (iVar"v",
                                 MB(Call
                                      ("R",ATy(qTy,PTy(F32,qTy)),
                                       Var("m",F4)),
                                    Close
                                      (Var("v0",F32),
                                       MB(MU(Mop(Cast iTy,Var("v0",F32)),
                                             qTy),
                                          Close
                                            (iVar"v0",
                                             MU(Bop(Mul,iVar"v",iVar"v0"),
                                                qTy))))))),
                           Close
                             (iVar"v0",MU(Bop(Sub,iVar"v",iVar"v0"),qTy))))))),
            Close
              (iVar"result",
               MB(Call
                    ("write'R",ATy(qTy,PTy(uTy,qTy)),
                     TP[EX(Mop(Cast F64,
                               ITE(bVar"round",
                                   Bop(Add,iVar"result",LI 2147483648),
                                   iVar"result")),LN 63,LN 32,F32),
                        Var("d",F4)]),
                  Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))
;
val SignedParallelAddSub16_def = Def
  ("SignedParallelAddSub16",TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("Rm",F32),
               MU(CS(Var("op",FTy 2),
                     [(LW(0,2),
                       TP[Bop(Add,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 15,LN 0,F16))),
                          Bop(Add,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 31,LN 16,F16)))]),
                      (LW(1,2),
                       TP[Bop(Sub,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 31,LN 16,F16))),
                          Bop(Add,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 15,LN 0,F16)))]),
                      (LW(2,2),
                       TP[Bop(Add,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 31,LN 16,F16))),
                          Bop(Sub,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 15,LN 0,F16)))]),
                      (LW(3,2),
                       TP[Bop(Sub,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 15,LN 0,F16))),
                          Bop(Sub,
                              Mop(Cast iTy,
                                  EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Mop(Cast iTy,
                                  EX(Var("Rm",F32),LN 31,LN 16,F16)))])]),
                  qTy))))))
;
val dfn'SignedAddSub16_def = Def
  ("dfn'SignedAddSub16",
   TP[Var("op",FTy 2),Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("SignedParallelAddSub16",ATy(qTy,PTy(PTy(iTy,iTy),qTy)),
         TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,iTy)),
         CS(Var("x",PTy(iTy,iTy)),
            [(TP[iVar"res1",iVar"res2"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F16,iVar"res2"),
                          Mop(Cast F16,iVar"res1")],Var("d",F4)]),
                 Close
                   (AVar uTy,
                    MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                       Close
                         (Var("v",CTy"PSR"),
                          MB(MB(MU(Dest("GE",F4,Var("v",CTy"PSR")),qTy),
                                Close
                                  (Var("w",F4),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("CPSR",CTy"PSR",qVar"s"))),
                                      Close
                                        (Var("v",CTy"PSR"),
                                         MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                     BFI(LN 1,LN 0,
                                                         ITE(Bop(Ge,
                                                                 iVar"res1",
                                                                 LI 0),
                                                             LW(3,2),
                                                             LW(0,2)),
                                                         Var("w",F4))],qTy),
                                               Close
                                                 (Var("v",PTy(CTy"PSR",F4)),
                                                  MU(Rupd
                                                       ("GE",
                                                        Var("v",
                                                            PTy(CTy"PSR",
                                                                F4))),qTy))),
                                            Close
                                              (Var("v",CTy"PSR"),
                                               MW(Close
                                                    (qVar"s",
                                                     Rupd
                                                       ("CPSR",
                                                        TP[qVar"s",
                                                           Var("v",
                                                               CTy"PSR")]))))))))),
                             Close
                               (AVar uTy,
                                MB(MR(Close
                                        (qVar"s",
                                         Dest("CPSR",CTy"PSR",qVar"s"))),
                                   Close
                                     (Var("v",CTy"PSR"),
                                      MB(MB(MU(Dest
                                                 ("GE",F4,
                                                  Var("v",CTy"PSR")),qTy),
                                            Close
                                              (Var("w",F4),
                                               MB(MR(Close
                                                       (qVar"s",
                                                        Dest
                                                          ("CPSR",
                                                           CTy"PSR",
                                                           qVar"s"))),
                                                  Close
                                                    (Var("v",CTy"PSR"),
                                                     MB(MB(MU(TP[Var("v",
                                                                     CTy"PSR"),
                                                                 BFI(LN 3,
                                                                     LN 2,
                                                                     ITE(Bop(Ge,
                                                                             iVar"res2",
                                                                             LI
                                                                              0),
                                                                         LW(3,
                                                                            2),
                                                                         LW(0,
                                                                            2)),
                                                                     Var("w",
                                                                         F4))],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(CTy"PSR",
                                                                      F4)),
                                                              MU(Rupd
                                                                   ("GE",
                                                                    Var("v",
                                                                        PTy(CTy"PSR",
                                                                            F4))),
                                                                 qTy))),
                                                        Close
                                                          (Var("v",
                                                               CTy"PSR"),
                                                           MW(Close
                                                                (qVar"s",
                                                                 Rupd
                                                                   ("CPSR",
                                                                    TP[qVar"s",
                                                                       Var("v",
                                                                           CTy"PSR")]))))))))),
                                         Close
                                           (AVar uTy,
                                            Call
                                              ("IncPC",
                                               ATy(qTy,PTy(uTy,qTy)),LU))))))))))))]))))
;
val dfn'SignedSaturatingAddSub16_def = Def
  ("dfn'SignedSaturatingAddSub16",
   TP[Var("op",FTy 2),Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("SignedParallelAddSub16",ATy(qTy,PTy(PTy(iTy,iTy),qTy)),
         TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,iTy)),
         CS(Var("x",PTy(iTy,iTy)),
            [(TP[iVar"res1",iVar"res2"],
              MB(Call
                   ("SignedSat",ATy(qTy,PTy(F16,qTy)),TP[iVar"res2",LN 16]),
                 Close
                   (Var("v",F16),
                    MB(MB(MB(MB(Call
                                  ("SignedSat",ATy(qTy,PTy(F16,qTy)),
                                   TP[iVar"res1",LN 16]),
                                Close
                                  (Var("v0",F16),
                                   MU(CC[Var("v",F16),Var("v0",F16)],qTy))),
                             Close
                               (Var("v",F32),
                                MU(TP[Var("v",F32),Var("d",F4)],qTy))),
                          Close
                            (Var("v",PTy(F32,F4)),
                             Call
                               ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                Var("v",PTy(F32,F4))))),
                       Close
                         (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))]))))
;
val dfn'SignedHalvingAddSub16_def = Def
  ("dfn'SignedHalvingAddSub16",
   TP[Var("op",FTy 2),Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("SignedParallelAddSub16",ATy(qTy,PTy(PTy(iTy,iTy),qTy)),
         TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,iTy)),
         CS(Var("x",PTy(iTy,iTy)),
            [(TP[iVar"res1",iVar"res2"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F16,Bop(Div,iVar"res2",LI 2)),
                          Mop(Cast F16,Bop(Div,iVar"res1",LI 2))],
                       Var("d",F4)]),
                 Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))]))))
;
val SignedParallelAddSub8_def = Def
  ("SignedParallelAddSub8",TP[bVar"sub",Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("Rm",F32),
               MU(ITE(bVar"sub",
                      TP[Bop(Sub,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 7,LN 0,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 7,LN 0,F8))),
                         Bop(Sub,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 15,LN 8,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 15,LN 8,F8))),
                         Bop(Sub,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 23,LN 16,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 23,LN 16,F8))),
                         Bop(Sub,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 31,LN 24,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 31,LN 24,F8)))],
                      TP[Bop(Add,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 7,LN 0,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 7,LN 0,F8))),
                         Bop(Add,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 15,LN 8,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 15,LN 8,F8))),
                         Bop(Add,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 23,LN 16,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 23,LN 16,F8))),
                         Bop(Add,
                             Mop(Cast iTy,EX(Var("Rn",F32),LN 31,LN 24,F8)),
                             Mop(Cast iTy,EX(Var("Rm",F32),LN 31,LN 24,F8)))]),
                  qTy))))))
;
val dfn'SignedAddSub8_def = Def
  ("dfn'SignedAddSub8",TP[bVar"sub",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("SignedParallelAddSub8",
         ATy(qTy,PTy(PTy(iTy,PTy(iTy,PTy(iTy,iTy))),qTy)),
         TP[bVar"sub",Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
         CS(Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
            [(TP[iVar"res1",iVar"res2",iVar"res3",iVar"res4"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F8,iVar"res4"),Mop(Cast F8,iVar"res3"),
                          Mop(Cast F8,iVar"res2"),Mop(Cast F8,iVar"res1")],
                       Var("d",F4)]),
                 Close
                   (AVar uTy,
                    MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                       Close
                         (Var("v",CTy"PSR"),
                          MB(MB(MU(Dest("GE",F4,Var("v",CTy"PSR")),qTy),
                                Close
                                  (Var("w",F4),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("CPSR",CTy"PSR",qVar"s"))),
                                      Close
                                        (Var("v",CTy"PSR"),
                                         MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                     BFI(LN 0,LN 0,
                                                         Mop(Cast F1,
                                                             Bop(Ge,
                                                                 iVar"res1",
                                                                 LI 0)),
                                                         Var("w",F4))],qTy),
                                               Close
                                                 (Var("v",PTy(CTy"PSR",F4)),
                                                  MU(Rupd
                                                       ("GE",
                                                        Var("v",
                                                            PTy(CTy"PSR",
                                                                F4))),qTy))),
                                            Close
                                              (Var("v",CTy"PSR"),
                                               MW(Close
                                                    (qVar"s",
                                                     Rupd
                                                       ("CPSR",
                                                        TP[qVar"s",
                                                           Var("v",
                                                               CTy"PSR")]))))))))),
                             Close
                               (AVar uTy,
                                MB(MR(Close
                                        (qVar"s",
                                         Dest("CPSR",CTy"PSR",qVar"s"))),
                                   Close
                                     (Var("v",CTy"PSR"),
                                      MB(MB(MU(Dest
                                                 ("GE",F4,
                                                  Var("v",CTy"PSR")),qTy),
                                            Close
                                              (Var("w",F4),
                                               MB(MR(Close
                                                       (qVar"s",
                                                        Dest
                                                          ("CPSR",
                                                           CTy"PSR",
                                                           qVar"s"))),
                                                  Close
                                                    (Var("v",CTy"PSR"),
                                                     MB(MB(MU(TP[Var("v",
                                                                     CTy"PSR"),
                                                                 BFI(LN 1,
                                                                     LN 1,
                                                                     Mop(Cast
                                                                           F1,
                                                                         Bop(Ge,
                                                                             iVar"res2",
                                                                             LI
                                                                              0)),
                                                                     Var("w",
                                                                         F4))],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(CTy"PSR",
                                                                      F4)),
                                                              MU(Rupd
                                                                   ("GE",
                                                                    Var("v",
                                                                        PTy(CTy"PSR",
                                                                            F4))),
                                                                 qTy))),
                                                        Close
                                                          (Var("v",
                                                               CTy"PSR"),
                                                           MW(Close
                                                                (qVar"s",
                                                                 Rupd
                                                                   ("CPSR",
                                                                    TP[qVar"s",
                                                                       Var("v",
                                                                           CTy"PSR")]))))))))),
                                         Close
                                           (AVar uTy,
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("CPSR",CTy"PSR",
                                                        qVar"s"))),
                                               Close
                                                 (Var("v",CTy"PSR"),
                                                  MB(MB(MU(Dest
                                                             ("GE",F4,
                                                              Var("v",
                                                                  CTy"PSR")),
                                                           qTy),
                                                        Close
                                                          (Var("w",F4),
                                                           MB(MR(Close
                                                                   (qVar"s",
                                                                    Dest
                                                                      ("CPSR",
                                                                       CTy"PSR",
                                                                       qVar"s"))),
                                                              Close
                                                                (Var("v",
                                                                     CTy"PSR"),
                                                                 MB(MB(MU(TP[Var("v",
                                                                                 CTy"PSR"),
                                                                             BFI(LN
                                                                                  2,
                                                                                 LN
                                                                                  2,
                                                                                 Mop(Cast
                                                                                       F1,
                                                                                     Bop(Ge,
                                                                                         iVar"res3",
                                                                                         LI
                                                                                          0)),
                                                                                 Var("w",
                                                                                     F4))],
                                                                          qTy),
                                                                       Close
                                                                         (Var("v",
                                                                              PTy(CTy"PSR",
                                                                                  F4)),
                                                                          MU(Rupd
                                                                               ("GE",
                                                                                Var("v",
                                                                                    PTy(CTy"PSR",
                                                                                        F4))),
                                                                             qTy))),
                                                                    Close
                                                                      (Var("v",
                                                                           CTy"PSR"),
                                                                       MW(Close
                                                                            (qVar"s",
                                                                             Rupd
                                                                               ("CPSR",
                                                                                TP[qVar"s",
                                                                                   Var("v",
                                                                                       CTy"PSR")]))))))))),
                                                     Close
                                                       (AVar uTy,
                                                        MB(MR(Close
                                                                (qVar"s",
                                                                 Dest
                                                                   ("CPSR",
                                                                    CTy"PSR",
                                                                    qVar"s"))),
                                                           Close
                                                             (Var("v",
                                                                  CTy"PSR"),
                                                              MB(MB(MU(Dest
                                                                         ("GE",
                                                                          F4,
                                                                          Var("v",
                                                                              CTy"PSR")),
                                                                       qTy),
                                                                    Close
                                                                      (Var("w",
                                                                           F4),
                                                                       MB(MR(Close
                                                                               (qVar"s",
                                                                                Dest
                                                                                  ("CPSR",
                                                                                   CTy"PSR",
                                                                                   qVar"s"))),
                                                                          Close
                                                                            (Var("v",
                                                                                 CTy"PSR"),
                                                                             MB(MB(MU(TP[Var("v",
                                                                                             CTy"PSR"),
                                                                                         BFI(LN
                                                                                              3,
                                                                                             LN
                                                                                              3,
                                                                                             Mop(Cast
                                                                                                   F1,
                                                                                                 Bop(Ge,
                                                                                                     iVar"res4",
                                                                                                     LI
                                                                                                      0)),
                                                                                             Var("w",
                                                                                                 F4))],
                                                                                      qTy),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          PTy(CTy"PSR",
                                                                                              F4)),
                                                                                      MU(Rupd
                                                                                           ("GE",
                                                                                            Var("v",
                                                                                                PTy(CTy"PSR",
                                                                                                    F4))),
                                                                                         qTy))),
                                                                                Close
                                                                                  (Var("v",
                                                                                       CTy"PSR"),
                                                                                   MW(Close
                                                                                        (qVar"s",
                                                                                         Rupd
                                                                                           ("CPSR",
                                                                                            TP[qVar"s",
                                                                                               Var("v",
                                                                                                   CTy"PSR")]))))))))),
                                                                 Close
                                                                   (AVar
                                                                      uTy,
                                                                    Call
                                                                      ("IncPC",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       LU))))))))))))))))))))]))))
;
val dfn'SignedSaturatingAddSub8_def = Def
  ("dfn'SignedSaturatingAddSub8",
   TP[bVar"sub",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("SignedParallelAddSub8",
         ATy(qTy,PTy(PTy(iTy,PTy(iTy,PTy(iTy,iTy))),qTy)),
         TP[bVar"sub",Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
         CS(Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
            [(TP[iVar"res1",iVar"res2",iVar"res3",iVar"res4"],
              MB(Call
                   ("SignedSat",ATy(qTy,PTy(F8,qTy)),TP[iVar"res4",LN 8]),
                 Close
                   (Var("v",F8),
                    MB(MB(MB(MB(Call
                                  ("SignedSat",ATy(qTy,PTy(F8,qTy)),
                                   TP[iVar"res3",LN 8]),
                                Close
                                  (Var("v0",F8),
                                   MB(MB(Call
                                           ("SignedSat",
                                            ATy(qTy,PTy(F8,qTy)),
                                            TP[iVar"res2",LN 8]),
                                         Close
                                           (Var("v1",F8),
                                            MB(MB(Call
                                                    ("SignedSat",
                                                     ATy(qTy,PTy(F8,qTy)),
                                                     TP[iVar"res1",LN 8]),
                                                  Close
                                                    (Var("v2",F8),
                                                     MU(CC[Var("v1",F8),
                                                           Var("v2",F8)],
                                                        qTy))),
                                               Close
                                                 (Var("v1",F16),
                                                  MU(CC[Var("v0",F8),
                                                        Var("v1",F16)],qTy))))),
                                      Close
                                        (Var("v0",FTy 24),
                                         MU(CC[Var("v",F8),
                                               Var("v0",FTy 24)],qTy))))),
                             Close
                               (Var("v",F32),
                                MU(TP[Var("v",F32),Var("d",F4)],qTy))),
                          Close
                            (Var("v",PTy(F32,F4)),
                             Call
                               ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                Var("v",PTy(F32,F4))))),
                       Close
                         (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))]))))
;
val dfn'SignedHalvingAddSub8_def = Def
  ("dfn'SignedHalvingAddSub8",
   TP[bVar"sub",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("SignedParallelAddSub8",
         ATy(qTy,PTy(PTy(iTy,PTy(iTy,PTy(iTy,iTy))),qTy)),
         TP[bVar"sub",Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
         CS(Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
            [(TP[iVar"res1",iVar"res2",iVar"res3",iVar"res4"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F8,Bop(Div,iVar"res4",LI 2)),
                          Mop(Cast F8,Bop(Div,iVar"res3",LI 2)),
                          Mop(Cast F8,Bop(Div,iVar"res2",LI 2)),
                          Mop(Cast F8,Bop(Div,iVar"res1",LI 2))],
                       Var("d",F4)]),
                 Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))]))))
;
val UnsignedParallelAddSub16_def = Def
  ("UnsignedParallelAddSub16",TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("Rm",F32),
               MU(CS(Var("op",FTy 2),
                     [(LW(0,2),
                       TP[Bop(Add,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 15,LN 0,F16))),
                          Bop(Add,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 31,LN 16,F16)))]),
                      (LW(1,2),
                       TP[Bop(Sub,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 31,LN 16,F16))),
                          Bop(Add,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 15,LN 0,F16)))]),
                      (LW(2,2),
                       TP[Bop(Add,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 31,LN 16,F16))),
                          Bop(Sub,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 15,LN 0,F16)))]),
                      (LW(3,2),
                       TP[Bop(Sub,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 15,LN 0,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 15,LN 0,F16))),
                          Bop(Sub,
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rn",F32),LN 31,LN 16,F16)),
                              Call
                                ("UInt",iTy,
                                 EX(Var("Rm",F32),LN 31,LN 16,F16)))])]),
                  qTy))))))
;
val dfn'UnsignedAddSub16_def = Def
  ("dfn'UnsignedAddSub16",
   TP[Var("op",FTy 2),Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("UnsignedParallelAddSub16",ATy(qTy,PTy(PTy(iTy,iTy),qTy)),
         TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,iTy)),
         CS(Var("x",PTy(iTy,iTy)),
            [(TP[iVar"res1",iVar"res2"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F16,iVar"res2"),
                          Mop(Cast F16,iVar"res1")],Var("d",F4)]),
                 Close
                   (AVar uTy,
                    MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                       Close
                         (Var("v",CTy"PSR"),
                          MB(MB(MU(Dest("GE",F4,Var("v",CTy"PSR")),qTy),
                                Close
                                  (Var("w",F4),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("CPSR",CTy"PSR",qVar"s"))),
                                      Close
                                        (Var("v",CTy"PSR"),
                                         MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                     BFI(LN 1,LN 0,
                                                         ITE(Bop(Ge,
                                                                 iVar"res1",
                                                                 ITE(Bop(In,
                                                                         Var("op",
                                                                             FTy 2),
                                                                         SL[LW(1,
                                                                               2),
                                                                            LW(2,
                                                                               2)]),
                                                                     LI 0,
                                                                     LI
                                                                      65536)),
                                                             LW(3,2),
                                                             LW(0,2)),
                                                         Var("w",F4))],qTy),
                                               Close
                                                 (Var("v",PTy(CTy"PSR",F4)),
                                                  MU(Rupd
                                                       ("GE",
                                                        Var("v",
                                                            PTy(CTy"PSR",
                                                                F4))),qTy))),
                                            Close
                                              (Var("v",CTy"PSR"),
                                               MW(Close
                                                    (qVar"s",
                                                     Rupd
                                                       ("CPSR",
                                                        TP[qVar"s",
                                                           Var("v",
                                                               CTy"PSR")]))))))))),
                             Close
                               (AVar uTy,
                                MB(MR(Close
                                        (qVar"s",
                                         Dest("CPSR",CTy"PSR",qVar"s"))),
                                   Close
                                     (Var("v",CTy"PSR"),
                                      MB(MB(MU(Dest
                                                 ("GE",F4,
                                                  Var("v",CTy"PSR")),qTy),
                                            Close
                                              (Var("w",F4),
                                               MB(MR(Close
                                                       (qVar"s",
                                                        Dest
                                                          ("CPSR",
                                                           CTy"PSR",
                                                           qVar"s"))),
                                                  Close
                                                    (Var("v",CTy"PSR"),
                                                     MB(MB(MU(TP[Var("v",
                                                                     CTy"PSR"),
                                                                 BFI(LN 3,
                                                                     LN 2,
                                                                     ITE(Bop(Ge,
                                                                             iVar"res2",
                                                                             ITE(Bop(In,
                                                                                     Var("op",
                                                                                         FTy 2),
                                                                                     SL[LW(2,
                                                                                           2),
                                                                                        LW(3,
                                                                                           2)]),
                                                                                 LI
                                                                                  0,
                                                                                 LI
                                                                                  65536)),
                                                                         LW(3,
                                                                            2),
                                                                         LW(0,
                                                                            2)),
                                                                     Var("w",
                                                                         F4))],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(CTy"PSR",
                                                                      F4)),
                                                              MU(Rupd
                                                                   ("GE",
                                                                    Var("v",
                                                                        PTy(CTy"PSR",
                                                                            F4))),
                                                                 qTy))),
                                                        Close
                                                          (Var("v",
                                                               CTy"PSR"),
                                                           MW(Close
                                                                (qVar"s",
                                                                 Rupd
                                                                   ("CPSR",
                                                                    TP[qVar"s",
                                                                       Var("v",
                                                                           CTy"PSR")]))))))))),
                                         Close
                                           (AVar uTy,
                                            Call
                                              ("IncPC",
                                               ATy(qTy,PTy(uTy,qTy)),LU))))))))))))]))))
;
val dfn'UnsignedSaturatingAddSub16_def = Def
  ("dfn'UnsignedSaturatingAddSub16",
   TP[Var("op",FTy 2),Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("UnsignedParallelAddSub16",ATy(qTy,PTy(PTy(iTy,iTy),qTy)),
         TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,iTy)),
         CS(Var("x",PTy(iTy,iTy)),
            [(TP[iVar"res1",iVar"res2"],
              MB(Call
                   ("UnsignedSat",ATy(qTy,PTy(F16,qTy)),
                    TP[iVar"res2",LN 16]),
                 Close
                   (Var("v",F16),
                    MB(MB(MB(MB(Call
                                  ("UnsignedSat",ATy(qTy,PTy(F16,qTy)),
                                   TP[iVar"res1",LN 16]),
                                Close
                                  (Var("v0",F16),
                                   MU(CC[Var("v",F16),Var("v0",F16)],qTy))),
                             Close
                               (Var("v",F32),
                                MU(TP[Var("v",F32),Var("d",F4)],qTy))),
                          Close
                            (Var("v",PTy(F32,F4)),
                             Call
                               ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                Var("v",PTy(F32,F4))))),
                       Close
                         (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))]))))
;
val dfn'UnsignedHalvingAddSub16_def = Def
  ("dfn'UnsignedHalvingAddSub16",
   TP[Var("op",FTy 2),Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("UnsignedParallelAddSub16",ATy(qTy,PTy(PTy(iTy,iTy),qTy)),
         TP[Var("op",FTy 2),Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,iTy)),
         CS(Var("x",PTy(iTy,iTy)),
            [(TP[iVar"res1",iVar"res2"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F16,Bop(Div,iVar"res2",LI 2)),
                          Mop(Cast F16,Bop(Div,iVar"res1",LI 2))],
                       Var("d",F4)]),
                 Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))]))))
;
val UnsignedParallelAddSub8_def = Def
  ("UnsignedParallelAddSub8",TP[bVar"sub",Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("Rm",F32),
               MU(ITE(bVar"sub",
                      TP[Bop(Sub,
                             Call
                               ("UInt",iTy,EX(Var("Rn",F32),LN 7,LN 0,F8)),
                             Call
                               ("UInt",iTy,EX(Var("Rm",F32),LN 7,LN 0,F8))),
                         Bop(Sub,
                             Call
                               ("UInt",iTy,EX(Var("Rn",F32),LN 15,LN 8,F8)),
                             Call
                               ("UInt",iTy,EX(Var("Rm",F32),LN 15,LN 8,F8))),
                         Bop(Sub,
                             Call
                               ("UInt",iTy,
                                EX(Var("Rn",F32),LN 23,LN 16,F8)),
                             Call
                               ("UInt",iTy,
                                EX(Var("Rm",F32),LN 23,LN 16,F8))),
                         Bop(Sub,
                             Call
                               ("UInt",iTy,
                                EX(Var("Rn",F32),LN 31,LN 24,F8)),
                             Call
                               ("UInt",iTy,
                                EX(Var("Rm",F32),LN 31,LN 24,F8)))],
                      TP[Bop(Add,
                             Call
                               ("UInt",iTy,EX(Var("Rn",F32),LN 7,LN 0,F8)),
                             Call
                               ("UInt",iTy,EX(Var("Rm",F32),LN 7,LN 0,F8))),
                         Bop(Add,
                             Call
                               ("UInt",iTy,EX(Var("Rn",F32),LN 15,LN 8,F8)),
                             Call
                               ("UInt",iTy,EX(Var("Rm",F32),LN 15,LN 8,F8))),
                         Bop(Add,
                             Call
                               ("UInt",iTy,
                                EX(Var("Rn",F32),LN 23,LN 16,F8)),
                             Call
                               ("UInt",iTy,
                                EX(Var("Rm",F32),LN 23,LN 16,F8))),
                         Bop(Add,
                             Call
                               ("UInt",iTy,
                                EX(Var("Rn",F32),LN 31,LN 24,F8)),
                             Call
                               ("UInt",iTy,
                                EX(Var("Rm",F32),LN 31,LN 24,F8)))]),qTy))))))
;
val dfn'UnsignedAddSub8_def = Def
  ("dfn'UnsignedAddSub8",
   TP[bVar"sub",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("UnsignedParallelAddSub8",
         ATy(qTy,PTy(PTy(iTy,PTy(iTy,PTy(iTy,iTy))),qTy)),
         TP[bVar"sub",Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
         CS(Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
            [(TP[iVar"res1",iVar"res2",iVar"res3",iVar"res4"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F8,iVar"res4"),Mop(Cast F8,iVar"res3"),
                          Mop(Cast F8,iVar"res2"),Mop(Cast F8,iVar"res1")],
                       Var("d",F4)]),
                 Close
                   (AVar uTy,
                    Let(iVar"ge_lim",ITE(bVar"sub",LI 0,LI 256),
                        MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                           Close
                             (Var("v",CTy"PSR"),
                              MB(MB(MU(Dest("GE",F4,Var("v",CTy"PSR")),qTy),
                                    Close
                                      (Var("w",F4),
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("CPSR",CTy"PSR",qVar"s"))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                         BFI(LN 0,LN 0,
                                                             Mop(Cast F1,
                                                                 Bop(Ge,
                                                                     iVar"res1",
                                                                     iVar"ge_lim")),
                                                             Var("w",F4))],
                                                      qTy),
                                                   Close
                                                     (Var("v",
                                                          PTy(CTy"PSR",F4)),
                                                      MU(Rupd
                                                           ("GE",
                                                            Var("v",
                                                                PTy(CTy"PSR",
                                                                    F4))),
                                                         qTy))),
                                                Close
                                                  (Var("v",CTy"PSR"),
                                                   MW(Close
                                                        (qVar"s",
                                                         Rupd
                                                           ("CPSR",
                                                            TP[qVar"s",
                                                               Var("v",
                                                                   CTy"PSR")]))))))))),
                                 Close
                                   (AVar uTy,
                                    MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v",CTy"PSR"),
                                          MB(MB(MU(Dest
                                                     ("GE",F4,
                                                      Var("v",CTy"PSR")),
                                                   qTy),
                                                Close
                                                  (Var("w",F4),
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("CPSR",
                                                               CTy"PSR",
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MB(MB(MU(TP[Var("v",
                                                                         CTy"PSR"),
                                                                     BFI(LN
                                                                          1,
                                                                         LN
                                                                          1,
                                                                         Mop(Cast
                                                                               F1,
                                                                             Bop(Ge,
                                                                                 iVar"res2",
                                                                                 iVar"ge_lim")),
                                                                         Var("w",
                                                                             F4))],
                                                                  qTy),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(CTy"PSR",
                                                                          F4)),
                                                                  MU(Rupd
                                                                       ("GE",
                                                                        Var("v",
                                                                            PTy(CTy"PSR",
                                                                                F4))),
                                                                     qTy))),
                                                            Close
                                                              (Var("v",
                                                                   CTy"PSR"),
                                                               MW(Close
                                                                    (qVar"s",
                                                                     Rupd
                                                                       ("CPSR",
                                                                        TP[qVar"s",
                                                                           Var("v",
                                                                               CTy"PSR")]))))))))),
                                             Close
                                               (AVar uTy,
                                                MB(MR(Close
                                                        (qVar"s",
                                                         Dest
                                                           ("CPSR",
                                                            CTy"PSR",
                                                            qVar"s"))),
                                                   Close
                                                     (Var("v",CTy"PSR"),
                                                      MB(MB(MU(Dest
                                                                 ("GE",F4,
                                                                  Var("v",
                                                                      CTy"PSR")),
                                                               qTy),
                                                            Close
                                                              (Var("w",F4),
                                                               MB(MR(Close
                                                                       (qVar"s",
                                                                        Dest
                                                                          ("CPSR",
                                                                           CTy"PSR",
                                                                           qVar"s"))),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"PSR"),
                                                                     MB(MB(MU(TP[Var("v",
                                                                                     CTy"PSR"),
                                                                                 BFI(LN
                                                                                      2,
                                                                                     LN
                                                                                      2,
                                                                                     Mop(Cast
                                                                                           F1,
                                                                                         Bop(Ge,
                                                                                             iVar"res3",
                                                                                             iVar"ge_lim")),
                                                                                     Var("w",
                                                                                         F4))],
                                                                              qTy),
                                                                           Close
                                                                             (Var("v",
                                                                                  PTy(CTy"PSR",
                                                                                      F4)),
                                                                              MU(Rupd
                                                                                   ("GE",
                                                                                    Var("v",
                                                                                        PTy(CTy"PSR",
                                                                                            F4))),
                                                                                 qTy))),
                                                                        Close
                                                                          (Var("v",
                                                                               CTy"PSR"),
                                                                           MW(Close
                                                                                (qVar"s",
                                                                                 Rupd
                                                                                   ("CPSR",
                                                                                    TP[qVar"s",
                                                                                       Var("v",
                                                                                           CTy"PSR")]))))))))),
                                                         Close
                                                           (AVar uTy,
                                                            MB(MR(Close
                                                                    (qVar"s",
                                                                     Dest
                                                                       ("CPSR",
                                                                        CTy"PSR",
                                                                        qVar"s"))),
                                                               Close
                                                                 (Var("v",
                                                                      CTy"PSR"),
                                                                  MB(MB(MU(Dest
                                                                             ("GE",
                                                                              F4,
                                                                              Var("v",
                                                                                  CTy"PSR")),
                                                                           qTy),
                                                                        Close
                                                                          (Var("w",
                                                                               F4),
                                                                           MB(MR(Close
                                                                                   (qVar"s",
                                                                                    Dest
                                                                                      ("CPSR",
                                                                                       CTy"PSR",
                                                                                       qVar"s"))),
                                                                              Close
                                                                                (Var("v",
                                                                                     CTy"PSR"),
                                                                                 MB(MB(MU(TP[Var("v",
                                                                                                 CTy"PSR"),
                                                                                             BFI(LN
                                                                                                  3,
                                                                                                 LN
                                                                                                  3,
                                                                                                 Mop(Cast
                                                                                                       F1,
                                                                                                     Bop(Ge,
                                                                                                         iVar"res4",
                                                                                                         iVar"ge_lim")),
                                                                                                 Var("w",
                                                                                                     F4))],
                                                                                          qTy),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              PTy(CTy"PSR",
                                                                                                  F4)),
                                                                                          MU(Rupd
                                                                                               ("GE",
                                                                                                Var("v",
                                                                                                    PTy(CTy"PSR",
                                                                                                        F4))),
                                                                                             qTy))),
                                                                                    Close
                                                                                      (Var("v",
                                                                                           CTy"PSR"),
                                                                                       MW(Close
                                                                                            (qVar"s",
                                                                                             Rupd
                                                                                               ("CPSR",
                                                                                                TP[qVar"s",
                                                                                                   Var("v",
                                                                                                       CTy"PSR")]))))))))),
                                                                     Close
                                                                       (AVar
                                                                          uTy,
                                                                        Call
                                                                          ("IncPC",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           LU)))))))))))))))))))))]))))
;
val dfn'UnsignedSaturatingAddSub8_def = Def
  ("dfn'UnsignedSaturatingAddSub8",
   TP[bVar"sub",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("UnsignedParallelAddSub8",
         ATy(qTy,PTy(PTy(iTy,PTy(iTy,PTy(iTy,iTy))),qTy)),
         TP[bVar"sub",Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
         CS(Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
            [(TP[iVar"res1",iVar"res2",iVar"res3",iVar"res4"],
              MB(Call
                   ("UnsignedSat",ATy(qTy,PTy(F8,qTy)),TP[iVar"res4",LN 8]),
                 Close
                   (Var("v",F8),
                    MB(MB(MB(MB(Call
                                  ("UnsignedSat",ATy(qTy,PTy(F8,qTy)),
                                   TP[iVar"res3",LN 8]),
                                Close
                                  (Var("v0",F8),
                                   MB(MB(Call
                                           ("UnsignedSat",
                                            ATy(qTy,PTy(F8,qTy)),
                                            TP[iVar"res2",LN 8]),
                                         Close
                                           (Var("v1",F8),
                                            MB(MB(Call
                                                    ("UnsignedSat",
                                                     ATy(qTy,PTy(F8,qTy)),
                                                     TP[iVar"res1",LN 8]),
                                                  Close
                                                    (Var("v2",F8),
                                                     MU(CC[Var("v1",F8),
                                                           Var("v2",F8)],
                                                        qTy))),
                                               Close
                                                 (Var("v1",F16),
                                                  MU(CC[Var("v0",F8),
                                                        Var("v1",F16)],qTy))))),
                                      Close
                                        (Var("v0",FTy 24),
                                         MU(CC[Var("v",F8),
                                               Var("v0",FTy 24)],qTy))))),
                             Close
                               (Var("v",F32),
                                MU(TP[Var("v",F32),Var("d",F4)],qTy))),
                          Close
                            (Var("v",PTy(F32,F4)),
                             Call
                               ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                Var("v",PTy(F32,F4))))),
                       Close
                         (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))]))))
;
val dfn'UnsignedHalvingAddSub8_def = Def
  ("dfn'UnsignedHalvingAddSub8",
   TP[bVar"sub",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call
        ("UnsignedParallelAddSub8",
         ATy(qTy,PTy(PTy(iTy,PTy(iTy,PTy(iTy,iTy))),qTy)),
         TP[bVar"sub",Var("n",F4),Var("m",F4)]),
      Close
        (Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
         CS(Var("x",PTy(iTy,PTy(iTy,PTy(iTy,iTy)))),
            [(TP[iVar"res1",iVar"res2",iVar"res3",iVar"res4"],
              MB(Call
                   ("write'R",ATy(qTy,PTy(uTy,qTy)),
                    TP[CC[Mop(Cast F8,Bop(Div,iVar"res4",LI 2)),
                          Mop(Cast F8,Bop(Div,iVar"res3",LI 2)),
                          Mop(Cast F8,Bop(Div,iVar"res2",LI 2)),
                          Mop(Cast F8,Bop(Div,iVar"res1",LI 2))],
                       Var("d",F4)]),
                 Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))]))))
;
val dfn'UnsignedSumAbsoluteDifferences_def = Def
  ("dfn'UnsignedSumAbsoluteDifferences",
   TP[Var("d",F4),Var("n",F4),Var("m",F4),Var("a",F4)],
   MB(ITE(EQ(Var("a",F4),LW(15,4)),MU(LW(0,32),qTy),
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("a",F4))),
      Close
        (Var("acc",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
            Close
              (Var("Rn",F32),
               MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                  Close
                    (Var("Rm",F32),
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[Mop(Cast F32,
                                  Bop(Add,
                                      Bop(Add,
                                          Bop(Add,
                                              Bop(Add,
                                                  Call
                                                    ("UInt",iTy,
                                                     Var("acc",F32)),
                                                  Mop(Abs,
                                                      Bop(Sub,
                                                          Call
                                                            ("UInt",iTy,
                                                             EX(Var("Rn",
                                                                    F32),
                                                                LN 7,LN 0,
                                                                F8)),
                                                          Call
                                                            ("UInt",iTy,
                                                             EX(Var("Rm",
                                                                    F32),
                                                                LN 7,LN 0,
                                                                F8))))),
                                              Mop(Abs,
                                                  Bop(Sub,
                                                      Call
                                                        ("UInt",iTy,
                                                         EX(Var("Rn",F32),
                                                            LN 15,LN 8,F8)),
                                                      Call
                                                        ("UInt",iTy,
                                                         EX(Var("Rm",F32),
                                                            LN 15,LN 8,F8))))),
                                          Mop(Abs,
                                              Bop(Sub,
                                                  Call
                                                    ("UInt",iTy,
                                                     EX(Var("Rn",F32),
                                                        LN 23,LN 16,F8)),
                                                  Call
                                                    ("UInt",iTy,
                                                     EX(Var("Rm",F32),
                                                        LN 23,LN 16,F8))))),
                                      Mop(Abs,
                                          Bop(Sub,
                                              Call
                                                ("UInt",iTy,
                                                 EX(Var("Rn",F32),LN 31,
                                                    LN 24,F8)),
                                              Call
                                                ("UInt",iTy,
                                                 EX(Var("Rm",F32),LN 31,
                                                    LN 24,F8)))))),
                              Var("d",F4)]),
                        Close
                          (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))))
;
val GenerateIntegerZeroDivide_def = Def
  ("GenerateIntegerZeroDivide",AVar uTy,
   Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'Divide_def = Def
  ("dfn'Divide",TP[bVar"unsigned",Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("v",F32),
         MB(MU(EQ(Var("v",F32),LW(0,32)),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(Call
                        ("IntegerZeroDivideTrappingEnabled",
                         ATy(qTy,PTy(bTy,qTy)),LU),
                      Close
                        (bVar"b",
                         ITE(bVar"b",
                             Call
                               ("GenerateIntegerZeroDivide",
                                ATy(qTy,PTy(uTy,qTy)),LU),
                             MB(Call
                                  ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                   TP[LW(0,32),Var("d",F4)]),
                                Close
                                  (AVar uTy,
                                   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))),
                   MB(ITE(bVar"unsigned",
                          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                             Close
                               (Var("v",F32),
                                MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("m",F4)),
                                   Close
                                     (Var("v0",F32),
                                      MU(Bop(Div,Var("v",F32),
                                             Var("v0",F32)),qTy))))),
                          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                             Close
                               (Var("v",F32),
                                MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("m",F4)),
                                   Close
                                     (Var("v0",F32),
                                      MU(Bop(Quot,Var("v",F32),
                                             Var("v0",F32)),qTy)))))),
                      Close
                        (Var("v",F32),
                         MB(MB(MU(TP[Var("v",F32),Var("d",F4)],qTy),
                               Close
                                 (Var("v",PTy(F32,F4)),
                                  Call
                                    ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                     Var("v",PTy(F32,F4))))),
                            Close
                              (AVar uTy,
                               Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))))))
;
val dfn'PackHalfword_def = Def
  ("dfn'PackHalfword",
   TP[Var("shift_t",CTy"SRType"),nVar"shift_n",bVar"tbform",Var("d",F4),
      Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v0",CTy"PSR"),
                     MB(MB(MB(MU(Dest("C",bTy,Var("v0",CTy"PSR")),qTy),
                              Close
                                (bVar"v",MU(TP[nVar"shift_n",bVar"v"],qTy))),
                           Close
                             (Var("v",PTy(nTy,bTy)),
                              MU(TP[Var("shift_t",CTy"SRType"),
                                    Var("v",PTy(nTy,bTy))],qTy))),
                        Close
                          (Var("v0",PTy(CTy"SRType",PTy(nTy,bTy))),
                           MU(TP[Var("v",F32),
                                 Var("v0",PTy(CTy"SRType",PTy(nTy,bTy)))],
                              qTy))))),
               Close
                 (Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy)))),
                  Call
                    ("Shift",ATy(qTy,PTy(F32,qTy)),
                     Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy))))))),
            Close
              (Var("operand2",F32),
               MB(ITE(bVar"tbform",
                      MU(EX(Var("operand2",F32),LN 15,LN 0,F16),qTy),
                      MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                         Close
                           (Var("v",F32),
                            MU(EX(Var("v",F32),LN 15,LN 0,F16),qTy)))),
                  Close
                    (Var("bot",F16),
                     MB(ITE(bVar"tbform",
                            MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                               Close
                                 (Var("v",F32),
                                  MU(EX(Var("v",F32),LN 31,LN 16,F16),qTy))),
                            MU(EX(Var("operand2",F32),LN 31,LN 16,F16),qTy)),
                        Close
                          (Var("top",F16),
                           MB(Call
                                ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                 TP[CC[Var("top",F16),Var("bot",F16)],
                                    Var("d",F4)]),
                              Close
                                (AVar uTy,
                                 Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))))))
;
val dfn'Saturate_def = Def
  ("dfn'Saturate",
   TP[Var("shift_t",CTy"SRType"),nVar"shift_n",nVar"saturate_to",
      bVar"unsigned",Var("d",F4),Var("n",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v0",CTy"PSR"),
                     MB(MB(MB(MU(Dest("C",bTy,Var("v0",CTy"PSR")),qTy),
                              Close
                                (bVar"v",MU(TP[nVar"shift_n",bVar"v"],qTy))),
                           Close
                             (Var("v",PTy(nTy,bTy)),
                              MU(TP[Var("shift_t",CTy"SRType"),
                                    Var("v",PTy(nTy,bTy))],qTy))),
                        Close
                          (Var("v0",PTy(CTy"SRType",PTy(nTy,bTy))),
                           MU(TP[Var("v",F32),
                                 Var("v0",PTy(CTy"SRType",PTy(nTy,bTy)))],
                              qTy))))),
               Close
                 (Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy)))),
                  Call
                    ("Shift",ATy(qTy,PTy(F32,qTy)),
                     Var("v",PTy(F32,PTy(CTy"SRType",PTy(nTy,bTy))))))),
            Close
              (Var("operand",F32),
               MB(ITE(bVar"unsigned",
                      Call
                        ("UnsignedSatQ",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                         TP[Mop(Cast iTy,Var("operand",F32)),
                            nVar"saturate_to"]),
                      Call
                        ("SignedSatQ",ATy(qTy,PTy(PTy(F32,bTy),qTy)),
                         TP[Mop(Cast iTy,Var("operand",F32)),
                            nVar"saturate_to"])),
                  Close
                    (Var("x",PTy(F32,bTy)),
                     CS(Var("x",PTy(F32,bTy)),
                        [(TP[Var("result",F32),bVar"sat"],
                          MB(Call
                               ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                TP[ITE(bVar"unsigned",Var("result",F32),
                                       Call
                                         ("SignExtendFrom",F32,
                                          TP[Var("result",F32),
                                             nVar"saturate_to"])),
                                   Var("d",F4)]),
                             Close
                               (AVar uTy,
                                MB(ITE(bVar"sat",
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("CPSR",CTy"PSR",qVar"s"))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                         LT],qTy),
                                                   Close
                                                     (Var("v",
                                                          PTy(CTy"PSR",bTy)),
                                                      MU(Rupd
                                                           ("Q",
                                                            Var("v",
                                                                PTy(CTy"PSR",
                                                                    bTy))),
                                                         qTy))),
                                                Close
                                                  (Var("v",CTy"PSR"),
                                                   MW(Close
                                                        (qVar"s",
                                                         Rupd
                                                           ("CPSR",
                                                            TP[qVar"s",
                                                               Var("v",
                                                                   CTy"PSR")]))))))),
                                       MU(LU,qTy)),
                                   Close
                                     (AVar uTy,
                                      Call
                                        ("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))]))))))))
;
val dfn'Saturate16_def = Def
  ("dfn'Saturate16",
   TP[nVar"saturate_to",bVar"unsigned",Var("d",F4),Var("n",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(ITE(bVar"unsigned",
                MB(Call
                     ("UnsignedSatQ",ATy(qTy,PTy(PTy(F16,bTy),qTy)),
                      TP[Mop(Cast iTy,EX(Var("Rn",F32),LN 15,LN 0,F16)),
                         nVar"saturate_to"]),
                   Close
                     (Var("v",PTy(F16,bTy)),
                      MB(Call
                           ("UnsignedSatQ",ATy(qTy,PTy(PTy(F16,bTy),qTy)),
                            TP[Mop(Cast iTy,
                                   EX(Var("Rn",F32),LN 31,LN 16,F16)),
                               nVar"saturate_to"]),
                         Close
                           (Var("v0",PTy(F16,bTy)),
                            MU(TP[Var("v",PTy(F16,bTy)),
                                  Var("v0",PTy(F16,bTy))],qTy))))),
                MB(Call
                     ("SignedSatQ",ATy(qTy,PTy(PTy(F16,bTy),qTy)),
                      TP[Mop(Cast iTy,EX(Var("Rn",F32),LN 15,LN 0,F16)),
                         nVar"saturate_to"]),
                   Close
                     (Var("v",PTy(F16,bTy)),
                      MB(Call
                           ("SignedSatQ",ATy(qTy,PTy(PTy(F16,bTy),qTy)),
                            TP[Mop(Cast iTy,
                                   EX(Var("Rn",F32),LN 31,LN 16,F16)),
                               nVar"saturate_to"]),
                         Close
                           (Var("v0",PTy(F16,bTy)),
                            MU(TP[Var("v",PTy(F16,bTy)),
                                  Var("v0",PTy(F16,bTy))],qTy)))))),
            Close
              (Var("x",PTy(PTy(F16,bTy),PTy(F16,bTy))),
               CS(Var("x",PTy(PTy(F16,bTy),PTy(F16,bTy))),
                  [(TP[TP[Var("result1",F16),bVar"sat1"],
                       Var("result2",F16),bVar"sat2"],
                    MB(Call
                         ("write'R",ATy(qTy,PTy(uTy,qTy)),
                          TP[ITE(bVar"unsigned",
                                 CC[Var("result2",F16),Var("result1",F16)],
                                 CC[Call
                                      ("SignExtendFrom",F16,
                                       TP[Var("result2",F16),
                                          nVar"saturate_to"]),
                                    Call
                                      ("SignExtendFrom",F16,
                                       TP[Var("result1",F16),
                                          nVar"saturate_to"])]),
                             Var("d",F4)]),
                       Close
                         (AVar uTy,
                          MB(ITE(Bop(Or,bVar"sat1",bVar"sat2"),
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest("CPSR",CTy"PSR",qVar"s"))),
                                    Close
                                      (Var("v",CTy"PSR"),
                                       MB(MB(MU(TP[Var("v",CTy"PSR"),LT],
                                                qTy),
                                             Close
                                               (Var("v",PTy(CTy"PSR",bTy)),
                                                MU(Rupd
                                                     ("Q",
                                                      Var("v",
                                                          PTy(CTy"PSR",bTy))),
                                                   qTy))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MW(Close
                                                  (qVar"s",
                                                   Rupd
                                                     ("CPSR",
                                                      TP[qVar"s",
                                                         Var("v",CTy"PSR")]))))))),
                                 MU(LU,qTy)),
                             Close
                               (AVar uTy,
                                Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))]))))))
;
val dfn'ExtendByte_def = Def
  ("dfn'ExtendByte",
   TP[bVar"unsigned",Var("d",F4),Var("n",F4),Var("m",F4),nVar"rotation"],
   MB(ITE(EQ(Var("n",F4),LW(15,4)),MU(LW(0,32),qTy),
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4))),
      Close
        (Var("acc",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("v",F32),
               MB(MB(MU(TP[Var("v",F32),nVar"rotation"],qTy),
                     Close
                       (Var("v",PTy(F32,nTy)),
                        Call
                          ("ROR",ATy(qTy,PTy(F32,qTy)),
                           Var("v",PTy(F32,nTy))))),
                  Close
                    (Var("rotated",F32),
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[Bop(Add,Var("acc",F32),
                                  Call
                                    ("Extend",F32,
                                     TP[bVar"unsigned",
                                        EX(Var("rotated",F32),LN 7,LN 0,F8)])),
                              Var("d",F4)]),
                        Close
                          (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))))
;
val dfn'ExtendByte16_def = Def
  ("dfn'ExtendByte16",
   TP[bVar"unsigned",Var("d",F4),Var("n",F4),Var("m",F4),nVar"rotation"],
   MB(ITE(EQ(Var("n",F4),LW(15,4)),MU(LW(0,32),qTy),
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4))),
      Close
        (Var("acc",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("v",F32),
               MB(MB(MU(TP[Var("v",F32),nVar"rotation"],qTy),
                     Close
                       (Var("v",PTy(F32,nTy)),
                        Call
                          ("ROR",ATy(qTy,PTy(F32,qTy)),
                           Var("v",PTy(F32,nTy))))),
                  Close
                    (Var("rotated",F32),
                     Let(Var("r1",F16),
                         Bop(Add,EX(Var("acc",F32),LN 15,LN 0,F16),
                             Call
                               ("Extend",F16,
                                TP[bVar"unsigned",
                                   EX(Var("rotated",F32),LN 7,LN 0,F8)])),
                         MB(Call
                              ("write'R",ATy(qTy,PTy(uTy,qTy)),
                               TP[CC[Var("r1",F16),Var("r1",F16)],
                                  Var("d",F4)]),
                            Close
                              (AVar uTy,
                               Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))))))
;
val dfn'ExtendHalfword_def = Def
  ("dfn'ExtendHalfword",
   TP[bVar"unsigned",Var("d",F4),Var("n",F4),Var("m",F4),nVar"rotation"],
   MB(ITE(EQ(Var("n",F4),LW(15,4)),MU(LW(0,32),qTy),
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4))),
      Close
        (Var("acc",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("v",F32),
               MB(MB(MU(TP[Var("v",F32),nVar"rotation"],qTy),
                     Close
                       (Var("v",PTy(F32,nTy)),
                        Call
                          ("ROR",ATy(qTy,PTy(F32,qTy)),
                           Var("v",PTy(F32,nTy))))),
                  Close
                    (Var("rotated",F32),
                     MB(Call
                          ("write'R",ATy(qTy,PTy(uTy,qTy)),
                           TP[Bop(Add,Var("acc",F32),
                                  Call
                                    ("Extend",F32,
                                     TP[bVar"unsigned",
                                        EX(Var("rotated",F32),LN 15,LN 0,
                                           F16)])),Var("d",F4)]),
                        Close
                          (AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))))))
;
val dfn'SelectBytes_def = Def
  ("dfn'SelectBytes",TP[Var("d",F4),Var("n",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
            Close
              (Var("Rm",F32),
               MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                  Close
                    (Var("v",CTy"PSR"),
                     MB(MB(MB(MU(Dest("GE",F4,Var("v",CTy"PSR")),qTy),
                              Close
                                (Var("v",F4),
                                 MU(Bop(Bit,Var("v",F4),LN 0),qTy))),
                           Close
                             (bVar"b",
                              MU(ITE(bVar"b",
                                     EX(Var("Rn",F32),LN 7,LN 0,F8),
                                     EX(Var("Rm",F32),LN 7,LN 0,F8)),qTy))),
                        Close
                          (Var("r1",F8),
                           MB(MR(Close
                                   (qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                              Close
                                (Var("v",CTy"PSR"),
                                 MB(MB(MB(MU(Dest
                                               ("GE",F4,Var("v",CTy"PSR")),
                                             qTy),
                                          Close
                                            (Var("v",F4),
                                             MU(Bop(Bit,Var("v",F4),LN 1),
                                                qTy))),
                                       Close
                                         (bVar"b",
                                          MU(ITE(bVar"b",
                                                 EX(Var("Rn",F32),LN 15,
                                                    LN 8,F8),
                                                 EX(Var("Rm",F32),LN 15,
                                                    LN 8,F8)),qTy))),
                                    Close
                                      (Var("r2",F8),
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("CPSR",CTy"PSR",qVar"s"))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MB(MU(Dest
                                                           ("GE",F4,
                                                            Var("v",
                                                                CTy"PSR")),
                                                         qTy),
                                                      Close
                                                        (Var("v",F4),
                                                         MU(Bop(Bit,
                                                                Var("v",F4),
                                                                LN 2),qTy))),
                                                   Close
                                                     (bVar"b",
                                                      MU(ITE(bVar"b",
                                                             EX(Var("Rn",
                                                                    F32),
                                                                LN 23,
                                                                LN 16,F8),
                                                             EX(Var("Rm",
                                                                    F32),
                                                                LN 23,
                                                                LN 16,F8)),
                                                         qTy))),
                                                Close
                                                  (Var("r3",F8),
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("CPSR",
                                                               CTy"PSR",
                                                               qVar"s"))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MB(MB(MB(MU(Dest
                                                                       ("GE",
                                                                        F4,
                                                                        Var("v",
                                                                            CTy"PSR")),
                                                                     qTy),
                                                                  Close
                                                                    (Var("v",
                                                                         F4),
                                                                     MU(Bop(Bit,
                                                                            Var("v",
                                                                                F4),
                                                                            LN
                                                                             3),
                                                                        qTy))),
                                                               Close
                                                                 (bVar"b",
                                                                  MU(ITE(bVar"b",
                                                                         EX(Var("Rn",
                                                                                F32),
                                                                            LN
                                                                             31,
                                                                            LN
                                                                             24,
                                                                            F8),
                                                                         EX(Var("Rm",
                                                                                F32),
                                                                            LN
                                                                             31,
                                                                            LN
                                                                             24,
                                                                            F8)),
                                                                     qTy))),
                                                            Close
                                                              (Var("r4",F8),
                                                               MB(Call
                                                                    ("write'R",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[CC[Var("r4",
                                                                               F8),
                                                                           Var("r3",
                                                                               F8),
                                                                           Var("r2",
                                                                               F8),
                                                                           Var("r1",
                                                                               F8)],
                                                                        Var("d",
                                                                            F4)]),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     Call
                                                                       ("IncPC",
                                                                        ATy(qTy,
                                                                            PTy(uTy,
                                                                                qTy)),
                                                                        LU))))))))))))))))))))))))
;
val dfn'ByteReverse_def = Def
  ("dfn'ByteReverse",TP[Var("d",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("Rm",F32),
         MB(Call
              ("write'R",ATy(qTy,PTy(uTy,qTy)),
               TP[CC[EX(Var("Rm",F32),LN 7,LN 0,F8),
                     EX(Var("Rm",F32),LN 15,LN 8,F8),
                     EX(Var("Rm",F32),LN 23,LN 16,F8),
                     EX(Var("Rm",F32),LN 31,LN 24,F8)],Var("d",F4)]),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'ByteReversePackedHalfword_def = Def
  ("dfn'ByteReversePackedHalfword",TP[Var("d",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("Rm",F32),
         MB(Call
              ("write'R",ATy(qTy,PTy(uTy,qTy)),
               TP[CC[EX(Var("Rm",F32),LN 23,LN 16,F8),
                     EX(Var("Rm",F32),LN 31,LN 24,F8),
                     EX(Var("Rm",F32),LN 7,LN 0,F8),
                     EX(Var("Rm",F32),LN 15,LN 8,F8)],Var("d",F4)]),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'ByteReverseSignedHalfword_def = Def
  ("dfn'ByteReverseSignedHalfword",TP[Var("d",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("Rm",F32),
         MB(Call
              ("write'R",ATy(qTy,PTy(uTy,qTy)),
               TP[CC[Mop(SE(FTy 24),EX(Var("Rm",F32),LN 7,LN 0,F8)),
                     EX(Var("Rm",F32),LN 15,LN 8,F8)],Var("d",F4)]),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'ReverseBits_def = Def
  ("dfn'ReverseBits",TP[Var("d",F4),Var("m",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
      Close
        (Var("v",F32),
         MB(MB(MB(MU(Mop(Rev,Var("v",F32)),qTy),
                  Close(Var("v",F32),MU(TP[Var("v",F32),Var("d",F4)],qTy))),
               Close
                 (Var("v",PTy(F32,F4)),
                  Call
                    ("write'R",ATy(qTy,PTy(uTy,qTy)),Var("v",PTy(F32,F4))))),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'BitFieldExtract_def = Def
  ("dfn'BitFieldExtract",
   TP[bVar"unsigned",Var("d",F4),Var("n",F4),nVar"lsbit",nVar"widthminus1"],
   Let(nVar"msbit",Bop(Add,nVar"lsbit",nVar"widthminus1"),
       MB(ITE(bVar"unsigned",
              MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                 Close
                   (Var("v",F32),
                    MU(EX(Var("v",F32),nVar"msbit",nVar"lsbit",F32),qTy))),
              MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                 Close
                   (Var("v",F32),
                    MB(MB(MU(EX(Var("v",F32),nVar"msbit",nVar"lsbit",F32),
                             qTy),
                          Close
                            (Var("v",F32),
                             MU(TP[Var("v",F32),nVar"widthminus1"],qTy))),
                       Close
                         (Var("v",PTy(F32,nTy)),
                          MU(Call
                               ("SignExtendFrom",F32,Var("v",PTy(F32,nTy))),
                             qTy)))))),
          Close
            (Var("v",F32),
             MB(MB(MU(TP[Var("v",F32),Var("d",F4)],qTy),
                   Close
                     (Var("v",PTy(F32,F4)),
                      Call
                        ("write'R",ATy(qTy,PTy(uTy,qTy)),
                         Var("v",PTy(F32,F4))))),
                Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))
;
val dfn'BitFieldClearOrInsert_def = Def
  ("dfn'BitFieldClearOrInsert",
   TP[Var("d",F4),Var("n",F4),nVar"lsbit",nVar"msbit"],
   MB(ITE(EQ(Var("n",F4),LW(15,4)),MU(LW(0,32),qTy),
          Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4))),
      Close
        (Var("v",F32),
         MB(MU(Mop(Cast vTy,Var("v",F32)),qTy),
            Close
              (vVar"field",
               MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("d",F4)),
                  Close
                    (Var("v",F32),
                     MB(MU(Mop(Cast vTy,Var("v",F32)),qTy),
                        Close
                          (vVar"v",
                           MN(vVar"v",
                              MB(MR(Close
                                      (Var("s",PTy(vTy,qTy)),
                                       Mop(Fst,Var("s",PTy(vTy,qTy))))),
                                 Close
                                   (vVar"v",
                                    MB(MB(MU(BFI(nVar"msbit",nVar"lsbit",
                                                 EX(vVar"field",
                                                    Bop(Sub,nVar"msbit",
                                                        nVar"lsbit"),LN 0,
                                                    vTy),vVar"v"),
                                             PTy(vTy,qTy)),
                                          Close
                                            (vVar"v",
                                             MW(Close
                                                  (Var("s",PTy(vTy,qTy)),
                                                   TP[vVar"v",
                                                      Mop(Snd,
                                                          Var("s",
                                                              PTy(vTy,qTy)))])))),
                                       Close
                                         (AVar uTy,
                                          MB(MR(Close
                                                  (Var("s",PTy(vTy,qTy)),
                                                   Mop(Fst,
                                                       Var("s",
                                                           PTy(vTy,qTy))))),
                                             Close
                                               (vVar"v",
                                                MB(MB(MB(MU(Mop(Cast F32,
                                                                vVar"v"),
                                                            PTy(vTy,qTy)),
                                                         Close
                                                           (Var("v",F32),
                                                            MU(TP[Var("v",
                                                                      F32),
                                                                  Var("d",
                                                                      F4)],
                                                               PTy(vTy,qTy)))),
                                                      Close
                                                        (Var("v",
                                                             PTy(F32,F4)),
                                                         MD(Call
                                                              ("write'R",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F32,
                                                                       F4))),
                                                            vTy))),
                                                   Close
                                                     (AVar uTy,
                                                      MD(Call
                                                           ("IncPC",
                                                            ATy(qTy,
                                                                PTy(uTy,
                                                                    qTy)),
                                                            LU),vTy)))))))))))))))))))
;
val dfn'LoadWord_def = Def
  ("dfn'LoadWord",
   TP[bVar"add",bVar"index",bVar"wback",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"index",Var("offset_addr",F32),
                                     Var("Rn",F32)),
                                 MB(Call
                                      ("MemU",ATy(qTy,PTy(F32,qTy)),
                                       TP[Var("address",F32),LN 4]),
                                    Close
                                      (Var("data",F32),
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("data_abort",bTy,
                                                   qVar"s"))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 Call
                                                   ("TakeDataAbortException",
                                                    ATy(qTy,PTy(uTy,qTy)),
                                                    LU),
                                                 MB(ITE(bVar"wback",
                                                        Call
                                                          ("write'R",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("offset_addr",
                                                                  F32),
                                                              Var("n",F4)]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       ITE(EQ(Var("t",F4),
                                                              LW(15,4)),
                                                           ITE(Call
                                                                 ("Aligned",
                                                                  bTy,
                                                                  TP[Var("address",
                                                                         F32),
                                                                     LN 4]),
                                                               Call
                                                                 ("LoadWritePC",
                                                                  ATy(qTy,
                                                                      PTy(uTy,
                                                                          qTy)),
                                                                  Var("data",
                                                                      F32)),
                                                               Call
                                                                 ("raise'exception",
                                                                  ATy(qTy,
                                                                      PTy(uTy,
                                                                          qTy)),
                                                                  Call
                                                                    ("UNPREDICTABLE",
                                                                     CTy"exception",
                                                                     LS
                                                                      "Load"))),
                                                           MB(Call
                                                                ("UnalignedSupport",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v",
                                                                 MB(MB(MU(Bop(Or,
                                                                              bVar"v",
                                                                              Call
                                                                                ("Aligned",
                                                                                 bTy,
                                                                                 TP[Var("address",
                                                                                        F32),
                                                                                    LN
                                                                                     4])),
                                                                          qTy),
                                                                       Close
                                                                         (bVar"b",
                                                                          ITE(bVar"b",
                                                                              Call
                                                                                ("write'R",
                                                                                 ATy(qTy,
                                                                                     PTy(uTy,
                                                                                         qTy)),
                                                                                 TP[Var("data",
                                                                                        F32),
                                                                                    Var("t",
                                                                                        F4)]),
                                                                              MB(MR(Close
                                                                                      (qVar"s",
                                                                                       Dest
                                                                                         ("Encoding",
                                                                                          CTy"Encoding",
                                                                                          qVar"s"))),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        CTy"Encoding"),
                                                                                    MB(MU(EQ(Var("v",
                                                                                                 CTy"Encoding"),
                                                                                             LC("Encoding_ARM",
                                                                                                CTy"Encoding")),
                                                                                          qTy),
                                                                                       Close
                                                                                         (bVar"b",
                                                                                          ITE(bVar"b",
                                                                                              MB(Call
                                                                                                   ("ROR",
                                                                                                    ATy(qTy,
                                                                                                        PTy(F32,
                                                                                                            qTy)),
                                                                                                    TP[Var("data",
                                                                                                           F32),
                                                                                                       Bop(Mul,
                                                                                                           LN
                                                                                                            8,
                                                                                                           Mop(Cast
                                                                                                                 nTy,
                                                                                                               EX(Var("address",
                                                                                                                      F32),
                                                                                                                  LN
                                                                                                                   1,
                                                                                                                  LN
                                                                                                                   0,
                                                                                                                  FTy 2)))]),
                                                                                                 Close
                                                                                                   (Var("v",
                                                                                                        F32),
                                                                                                    MB(MU(TP[Var("v",
                                                                                                                 F32),
                                                                                                             Var("t",
                                                                                                                 F4)],
                                                                                                          qTy),
                                                                                                       Close
                                                                                                         (Var("v",
                                                                                                              PTy(F32,
                                                                                                                  F4)),
                                                                                                          Call
                                                                                                            ("write'R",
                                                                                                             ATy(qTy,
                                                                                                                 PTy(uTy,
                                                                                                                     qTy)),
                                                                                                             Var("v",
                                                                                                                 PTy(F32,
                                                                                                                     F4))))))),
                                                                                              MB(MW(Close
                                                                                                      (qVar"s",
                                                                                                       Rupd
                                                                                                         ("transfer_unknown",
                                                                                                          TP[qVar"s",
                                                                                                             LT]))),
                                                                                                 Close
                                                                                                   (AVar
                                                                                                      uTy,
                                                                                                    Call
                                                                                                      ("write'R",
                                                                                                       ATy(qTy,
                                                                                                           PTy(uTy,
                                                                                                               qTy)),
                                                                                                       TP[LX F32,
                                                                                                          Var("t",
                                                                                                              F4)]))))))))))),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       Call
                                                                         ("IncPC",
                                                                          ATy(qTy,
                                                                              PTy(uTy,
                                                                                  qTy)),
                                                                          LU))))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadLiteral_def = Def
  ("dfn'LoadLiteral",TP[bVar"add",Var("t",F4),Var("imm32",F32)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),LW(15,4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                Close
                  (Var("v",F32),
                   MB(MB(MU(TP[Var("v",F32),LN 4],qTy),
                         Close
                           (Var("v",PTy(F32,nTy)),
                            MU(Call("Align",F32,Var("v",PTy(F32,nTy))),qTy))),
                      Close
                        (Var("base",F32),
                         Let(Var("address",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("base",F32),Var("imm32",F32)),
                                 Bop(Sub,Var("base",F32),Var("imm32",F32))),
                             MB(Call
                                  ("MemU",ATy(qTy,PTy(F32,qTy)),
                                   TP[Var("address",F32),LN 4]),
                                Close
                                  (Var("data",F32),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("data_abort",bTy,qVar"s"))),
                                      Close
                                        (bVar"b",
                                         ITB([(bVar"b",
                                               Call
                                                 ("TakeDataAbortException",
                                                  ATy(qTy,PTy(uTy,qTy)),LU)),
                                              (EQ(Var("t",F4),LW(15,4)),
                                               ITE(Call
                                                     ("Aligned",bTy,
                                                      TP[Var("address",F32),
                                                         LN 4]),
                                                   Call
                                                     ("LoadWritePC",
                                                      ATy(qTy,PTy(uTy,qTy)),
                                                      Var("data",F32)),
                                                   Call
                                                     ("raise'exception",
                                                      ATy(qTy,PTy(uTy,qTy)),
                                                      Call
                                                        ("UNPREDICTABLE",
                                                         CTy"exception",
                                                         LS"LoadLiteral"))))],
                                             MB(Call
                                                  ("UnalignedSupport",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(MU(Bop(Or,
                                                                bVar"v",
                                                                Call
                                                                  ("Aligned",
                                                                   bTy,
                                                                   TP[Var("address",
                                                                          F32),
                                                                      LN 4])),
                                                            qTy),
                                                         Close
                                                           (bVar"b",
                                                            ITE(bVar"b",
                                                                Call
                                                                  ("write'R",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("data",
                                                                          F32),
                                                                      Var("t",
                                                                          F4)]),
                                                                MB(MR(Close
                                                                        (qVar"s",
                                                                         Dest
                                                                           ("Encoding",
                                                                            CTy"Encoding",
                                                                            qVar"s"))),
                                                                   Close
                                                                     (Var("v",
                                                                          CTy"Encoding"),
                                                                      MB(MU(EQ(Var("v",
                                                                                   CTy"Encoding"),
                                                                               LC("Encoding_ARM",
                                                                                  CTy"Encoding")),
                                                                            qTy),
                                                                         Close
                                                                           (bVar"b",
                                                                            ITE(bVar"b",
                                                                                MB(Call
                                                                                     ("ROR",
                                                                                      ATy(qTy,
                                                                                          PTy(F32,
                                                                                              qTy)),
                                                                                      TP[Var("data",
                                                                                             F32),
                                                                                         Bop(Mul,
                                                                                             LN
                                                                                              8,
                                                                                             Mop(Cast
                                                                                                   nTy,
                                                                                                 EX(Var("address",
                                                                                                        F32),
                                                                                                    LN
                                                                                                     1,
                                                                                                    LN
                                                                                                     0,
                                                                                                    FTy 2)))]),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          F32),
                                                                                      MB(MU(TP[Var("v",
                                                                                                   F32),
                                                                                               Var("t",
                                                                                                   F4)],
                                                                                            qTy),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                PTy(F32,
                                                                                                    F4)),
                                                                                            Call
                                                                                              ("write'R",
                                                                                               ATy(qTy,
                                                                                                   PTy(uTy,
                                                                                                       qTy)),
                                                                                               Var("v",
                                                                                                   PTy(F32,
                                                                                                       F4))))))),
                                                                                MB(MW(Close
                                                                                        (qVar"s",
                                                                                         Rupd
                                                                                           ("transfer_unknown",
                                                                                            TP[qVar"s",
                                                                                               LT]))),
                                                                                   Close
                                                                                     (AVar
                                                                                        uTy,
                                                                                      Call
                                                                                        ("write'R",
                                                                                         ATy(qTy,
                                                                                             PTy(uTy,
                                                                                                 qTy)),
                                                                                         TP[LX F32,
                                                                                            Var("t",
                                                                                                F4)]))))))))))),
                                                      Close
                                                        (AVar uTy,
                                                         Call
                                                           ("IncPC",
                                                            ATy(qTy,
                                                                PTy(uTy,
                                                                    qTy)),
                                                            LU))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadUnprivileged_def = Def
  ("dfn'LoadUnprivileged",
   TP[bVar"add",bVar"postindex",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"postindex",Var("Rn",F32),
                                     Var("offset_addr",F32)),
                                 MB(Call
                                      ("MemU_unpriv",
                                       ATy(qTy,PTy(F32,qTy)),
                                       TP[Var("address",F32),LN 4]),
                                    Close
                                      (Var("data",F32),
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("data_abort",bTy,
                                                   qVar"s"))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 Call
                                                   ("TakeDataAbortException",
                                                    ATy(qTy,PTy(uTy,qTy)),
                                                    LU),
                                                 MB(ITE(bVar"postindex",
                                                        Call
                                                          ("write'R",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("offset_addr",
                                                                  F32),
                                                              Var("n",F4)]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MB(Call
                                                            ("UnalignedSupport",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v",
                                                             MB(MB(MU(Bop(Or,
                                                                          bVar"v",
                                                                          Call
                                                                            ("Aligned",
                                                                             bTy,
                                                                             TP[Var("address",
                                                                                    F32),
                                                                                LN
                                                                                 4])),
                                                                      qTy),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          Call
                                                                            ("write'R",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("data",
                                                                                    F32),
                                                                                Var("t",
                                                                                    F4)]),
                                                                          MB(MR(Close
                                                                                  (qVar"s",
                                                                                   Dest
                                                                                     ("Encoding",
                                                                                      CTy"Encoding",
                                                                                      qVar"s"))),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"Encoding"),
                                                                                MB(MU(EQ(Var("v",
                                                                                             CTy"Encoding"),
                                                                                         LC("Encoding_ARM",
                                                                                            CTy"Encoding")),
                                                                                      qTy),
                                                                                   Close
                                                                                     (bVar"b",
                                                                                      ITE(bVar"b",
                                                                                          MB(Call
                                                                                               ("ROR",
                                                                                                ATy(qTy,
                                                                                                    PTy(F32,
                                                                                                        qTy)),
                                                                                                TP[Var("data",
                                                                                                       F32),
                                                                                                   Bop(Mul,
                                                                                                       LN
                                                                                                        8,
                                                                                                       Mop(Cast
                                                                                                             nTy,
                                                                                                           EX(Var("address",
                                                                                                                  F32),
                                                                                                              LN
                                                                                                               1,
                                                                                                              LN
                                                                                                               0,
                                                                                                              FTy 2)))]),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    F32),
                                                                                                MB(MU(TP[Var("v",
                                                                                                             F32),
                                                                                                         Var("t",
                                                                                                             F4)],
                                                                                                      qTy),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          PTy(F32,
                                                                                                              F4)),
                                                                                                      Call
                                                                                                        ("write'R",
                                                                                                         ATy(qTy,
                                                                                                             PTy(uTy,
                                                                                                                 qTy)),
                                                                                                         Var("v",
                                                                                                             PTy(F32,
                                                                                                                 F4))))))),
                                                                                          MB(MW(Close
                                                                                                  (qVar"s",
                                                                                                   Rupd
                                                                                                     ("transfer_unknown",
                                                                                                      TP[qVar"s",
                                                                                                         LT]))),
                                                                                             Close
                                                                                               (AVar
                                                                                                  uTy,
                                                                                                Call
                                                                                                  ("write'R",
                                                                                                   ATy(qTy,
                                                                                                       PTy(uTy,
                                                                                                           qTy)),
                                                                                                   TP[LX F32,
                                                                                                      Var("t",
                                                                                                          F4)]))))))))))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("IncPC",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      LU)))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadByte_def = Def
  ("dfn'LoadByte",
   TP[bVar"unsigned",bVar"add",bVar"index",bVar"wback",Var("t",F4),
      Var("n",F4),Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             MB(Call
                                  ("MemU",ATy(qTy,PTy(F8,qTy)),
                                   TP[ITE(bVar"index",
                                          Var("offset_addr",F32),
                                          Var("Rn",F32)),LN 1]),
                                Close
                                  (Var("data",F8),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("data_abort",bTy,qVar"s"))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Call
                                               ("TakeDataAbortException",
                                                ATy(qTy,PTy(uTy,qTy)),LU),
                                             MB(Call
                                                  ("write'R",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[Call
                                                        ("Extend",F32,
                                                         TP[bVar"unsigned",
                                                            Var("data",F8)]),
                                                      Var("t",F4)]),
                                                Close
                                                  (AVar uTy,
                                                   MB(ITE(bVar"wback",
                                                          Call
                                                            ("write'R",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("offset_addr",
                                                                    F32),
                                                                Var("n",F4)]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         Call
                                                           ("IncPC",
                                                            ATy(qTy,
                                                                PTy(uTy,
                                                                    qTy)),
                                                            LU))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadByteLiteral_def = Def
  ("dfn'LoadByteLiteral",
   TP[bVar"unsigned",bVar"add",Var("t",F4),Var("imm32",F32)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),LW(15,4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                Close
                  (Var("v",F32),
                   MB(MB(MU(TP[Var("v",F32),LN 4],qTy),
                         Close
                           (Var("v",PTy(F32,nTy)),
                            MU(Call("Align",F32,Var("v",PTy(F32,nTy))),qTy))),
                      Close
                        (Var("base",F32),
                         MB(Call
                              ("MemU",ATy(qTy,PTy(F8,qTy)),
                               TP[ITE(bVar"add",
                                      Bop(Add,Var("base",F32),
                                          Var("imm32",F32)),
                                      Bop(Sub,Var("base",F32),
                                          Var("imm32",F32))),LN 1]),
                            Close
                              (Var("data",F8),
                               MB(MR(Close
                                       (qVar"s",
                                        Dest("data_abort",bTy,qVar"s"))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         Call
                                           ("TakeDataAbortException",
                                            ATy(qTy,PTy(uTy,qTy)),LU),
                                         MB(Call
                                              ("write'R",
                                               ATy(qTy,PTy(uTy,qTy)),
                                               TP[Call
                                                    ("Extend",F32,
                                                     TP[bVar"unsigned",
                                                        Var("data",F8)]),
                                                  Var("t",F4)]),
                                            Close
                                              (AVar uTy,
                                               Call
                                                 ("IncPC",
                                                  ATy(qTy,PTy(uTy,qTy)),LU)))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadByteUnprivileged_def = Def
  ("dfn'LoadByteUnprivileged",
   TP[bVar"add",bVar"postindex",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             MB(Call
                                  ("MemU_unpriv",ATy(qTy,PTy(F8,qTy)),
                                   TP[ITE(bVar"postindex",Var("Rn",F32),
                                          Var("offset_addr",F32)),LN 1]),
                                Close
                                  (Var("data",F8),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("data_abort",bTy,qVar"s"))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Call
                                               ("TakeDataAbortException",
                                                ATy(qTy,PTy(uTy,qTy)),LU),
                                             MB(Call
                                                  ("write'R",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[Mop(Cast F32,
                                                          Var("data",F8)),
                                                      Var("t",F4)]),
                                                Close
                                                  (AVar uTy,
                                                   MB(ITE(bVar"postindex",
                                                          Call
                                                            ("write'R",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("offset_addr",
                                                                    F32),
                                                                Var("n",F4)]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         Call
                                                           ("IncPC",
                                                            ATy(qTy,
                                                                PTy(uTy,
                                                                    qTy)),
                                                            LU))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadSignedByteUnprivileged_def = Def
  ("dfn'LoadSignedByteUnprivileged",
   TP[bVar"add",bVar"postindex",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset2")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset2"),
                         [(Call("register_form2",CTy"offset2",Var("m",F4)),
                           Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4))),
                          (Call
                             ("immediate_form2",CTy"offset2",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             MB(Call
                                  ("MemU_unpriv",ATy(qTy,PTy(F8,qTy)),
                                   TP[ITE(bVar"postindex",Var("Rn",F32),
                                          Var("offset_addr",F32)),LN 1]),
                                Close
                                  (Var("data",F8),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("data_abort",bTy,qVar"s"))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Call
                                               ("TakeDataAbortException",
                                                ATy(qTy,PTy(uTy,qTy)),LU),
                                             MB(Call
                                                  ("write'R",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[Mop(SE F32,
                                                          Var("data",F8)),
                                                      Var("t",F4)]),
                                                Close
                                                  (AVar uTy,
                                                   MB(ITE(bVar"postindex",
                                                          Call
                                                            ("write'R",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("offset_addr",
                                                                    F32),
                                                                Var("n",F4)]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         Call
                                                           ("IncPC",
                                                            ATy(qTy,
                                                                PTy(uTy,
                                                                    qTy)),
                                                            LU))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadHalf_def = Def
  ("dfn'LoadHalf",
   TP[bVar"unsigned",bVar"add",bVar"index",bVar"wback",Var("t",F4),
      Var("n",F4),Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"index",Var("offset_addr",F32),
                                     Var("Rn",F32)),
                                 MB(Call
                                      ("MemU",ATy(qTy,PTy(F16,qTy)),
                                       TP[Var("address",F32),LN 2]),
                                    Close
                                      (Var("data",F16),
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("data_abort",bTy,
                                                   qVar"s"))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 Call
                                                   ("TakeDataAbortException",
                                                    ATy(qTy,PTy(uTy,qTy)),
                                                    LU),
                                                 MB(ITE(bVar"wback",
                                                        Call
                                                          ("write'R",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("offset_addr",
                                                                  F32),
                                                              Var("n",F4)]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MB(Call
                                                            ("UnalignedSupport",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v",
                                                             MB(MB(MU(Bop(Or,
                                                                          bVar"v",
                                                                          Call
                                                                            ("Aligned",
                                                                             bTy,
                                                                             TP[Var("address",
                                                                                    F32),
                                                                                LN
                                                                                 2])),
                                                                      qTy),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          Call
                                                                            ("write'R",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Call
                                                                                  ("Extend",
                                                                                   F32,
                                                                                   TP[bVar"unsigned",
                                                                                      Var("data",
                                                                                          F16)]),
                                                                                Var("t",
                                                                                    F4)]),
                                                                          MB(MW(Close
                                                                                  (qVar"s",
                                                                                   Rupd
                                                                                     ("transfer_unknown",
                                                                                      TP[qVar"s",
                                                                                         LT]))),
                                                                             Close
                                                                               (AVar
                                                                                  uTy,
                                                                                Call
                                                                                  ("write'R",
                                                                                   ATy(qTy,
                                                                                       PTy(uTy,
                                                                                           qTy)),
                                                                                   TP[LX F32,
                                                                                      Var("t",
                                                                                          F4)])))))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("IncPC",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      LU)))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadHalfLiteral_def = Def
  ("dfn'LoadHalfLiteral",
   TP[bVar"unsigned",bVar"add",Var("t",F4),Var("imm32",F32)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),LW(15,4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                Close
                  (Var("v",F32),
                   MB(MB(MU(TP[Var("v",F32),LN 4],qTy),
                         Close
                           (Var("v",PTy(F32,nTy)),
                            MU(Call("Align",F32,Var("v",PTy(F32,nTy))),qTy))),
                      Close
                        (Var("base",F32),
                         Let(Var("address",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("base",F32),Var("imm32",F32)),
                                 Bop(Sub,Var("base",F32),Var("imm32",F32))),
                             MB(Call
                                  ("MemU",ATy(qTy,PTy(F16,qTy)),
                                   TP[Var("address",F32),LN 2]),
                                Close
                                  (Var("data",F16),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("data_abort",bTy,qVar"s"))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Call
                                               ("TakeDataAbortException",
                                                ATy(qTy,PTy(uTy,qTy)),LU),
                                             MB(Call
                                                  ("UnalignedSupport",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(MU(Bop(Or,
                                                                bVar"v",
                                                                Call
                                                                  ("Aligned",
                                                                   bTy,
                                                                   TP[Var("address",
                                                                          F32),
                                                                      LN 2])),
                                                            qTy),
                                                         Close
                                                           (bVar"b",
                                                            ITE(bVar"b",
                                                                Call
                                                                  ("write'R",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Call
                                                                        ("Extend",
                                                                         F32,
                                                                         TP[bVar"unsigned",
                                                                            Var("data",
                                                                                F16)]),
                                                                      Var("t",
                                                                          F4)]),
                                                                MB(MW(Close
                                                                        (qVar"s",
                                                                         Rupd
                                                                           ("transfer_unknown",
                                                                            TP[qVar"s",
                                                                               LT]))),
                                                                   Close
                                                                     (AVar
                                                                        uTy,
                                                                      Call
                                                                        ("write'R",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[LX F32,
                                                                            Var("t",
                                                                                F4)])))))),
                                                      Close
                                                        (AVar uTy,
                                                         Call
                                                           ("IncPC",
                                                            ATy(qTy,
                                                                PTy(uTy,
                                                                    qTy)),
                                                            LU))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadHalfUnprivileged_def = Def
  ("dfn'LoadHalfUnprivileged",
   TP[bVar"unsigned",bVar"add",bVar"postindex",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset2")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset2"),
                         [(Call("register_form2",CTy"offset2",Var("m",F4)),
                           Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4))),
                          (Call
                             ("immediate_form2",CTy"offset2",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"postindex",Var("Rn",F32),
                                     Var("offset_addr",F32)),
                                 MB(Call
                                      ("MemU_unpriv",
                                       ATy(qTy,PTy(F16,qTy)),
                                       TP[Var("address",F32),LN 2]),
                                    Close
                                      (Var("data",F16),
                                       MB(MR(Close
                                               (qVar"s",
                                                Dest
                                                  ("data_abort",bTy,
                                                   qVar"s"))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 Call
                                                   ("TakeDataAbortException",
                                                    ATy(qTy,PTy(uTy,qTy)),
                                                    LU),
                                                 MB(ITE(bVar"postindex",
                                                        Call
                                                          ("write'R",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("offset_addr",
                                                                  F32),
                                                              Var("n",F4)]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MB(Call
                                                            ("UnalignedSupport",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v",
                                                             MB(MB(MU(Bop(Or,
                                                                          bVar"v",
                                                                          Call
                                                                            ("Aligned",
                                                                             bTy,
                                                                             TP[Var("address",
                                                                                    F32),
                                                                                LN
                                                                                 2])),
                                                                      qTy),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          Call
                                                                            ("write'R",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Call
                                                                                  ("Extend",
                                                                                   F32,
                                                                                   TP[bVar"unsigned",
                                                                                      Var("data",
                                                                                          F16)]),
                                                                                Var("t",
                                                                                    F4)]),
                                                                          MB(MW(Close
                                                                                  (qVar"s",
                                                                                   Rupd
                                                                                     ("transfer_unknown",
                                                                                      TP[qVar"s",
                                                                                         LT]))),
                                                                             Close
                                                                               (AVar
                                                                                  uTy,
                                                                                Call
                                                                                  ("write'R",
                                                                                   ATy(qTy,
                                                                                       PTy(uTy,
                                                                                           qTy)),
                                                                                   TP[LX F32,
                                                                                      Var("t",
                                                                                          F4)])))))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("IncPC",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      LU)))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadMultiple_def = Def
  ("dfn'LoadMultiple",
   TP[bVar"increment",bVar"index",bVar"wback",Var("n",F4),
      Var("registers",F16)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(Call
                        ("BitCount",ATy(qTy,PTy(nTy,qTy)),
                         Var("registers",F16)),
                      Close
                        (nVar"v",
                         MB(MB(MU(Mop(Cast F32,nVar"v"),qTy),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Mul,LW(4,32),Var("v",F32)),qTy))),
                            Close
                              (Var("length",F32),
                               MN(ITE(bVar"increment",Var("Rn",F32),
                                      Bop(Sub,Var("Rn",F32),
                                          Var("length",F32))),
                                  MB(ITE(EQ(bVar"index",bVar"increment"),
                                         MB(MR(Close
                                                 (Var("s",PTy(F32,qTy)),
                                                  Mop(Fst,
                                                      Var("s",PTy(F32,qTy))))),
                                            Close
                                              (Var("v",F32),
                                               MB(MU(Bop(Add,Var("v",F32),
                                                         LW(4,32)),
                                                     PTy(F32,qTy)),
                                                  Close
                                                    (Var("v",F32),
                                                     MW(Close
                                                          (Var("s",
                                                               PTy(F32,qTy)),
                                                           TP[Var("v",F32),
                                                              Mop(Snd,
                                                                  Var("s",
                                                                      PTy(F32,
                                                                          qTy)))])))))),
                                         MU(LU,PTy(F32,qTy))),
                                     Close
                                       (AVar uTy,
                                        MB(MR(Close
                                                (Var("s",PTy(F32,qTy)),
                                                 Dest
                                                   ("REG",
                                                    ATy(CTy"RName",F32),
                                                    Mop(Snd,
                                                        Var("s",
                                                            PTy(F32,qTy)))))),
                                           Close
                                             (Var("oreg",
                                                  ATy(CTy"RName",F32)),
                                              MB(For(TP[LN 0,LN 14,
                                                        Close
                                                          (nVar"i",
                                                           ITE(Bop(Bit,
                                                                   Var("registers",
                                                                       F16),
                                                                   nVar"i"),
                                                               MB(MB(MR(Close
                                                                          (Var("s",
                                                                               PTy(F32,
                                                                                   qTy)),
                                                                           Mop(Fst,
                                                                               Var("s",
                                                                                   PTy(F32,
                                                                                       qTy))))),
                                                                     Close
                                                                       (Var("v",
                                                                            F32),
                                                                        MB(MB(MB(MU(TP[Var("v",
                                                                                           F32),
                                                                                       LN
                                                                                        4],
                                                                                    PTy(F32,
                                                                                        qTy)),
                                                                                 Close
                                                                                   (Var("v",
                                                                                        PTy(F32,
                                                                                            nTy)),
                                                                                    MD(Call
                                                                                         ("MemA",
                                                                                          ATy(qTy,
                                                                                              PTy(F32,
                                                                                                  qTy)),
                                                                                          Var("v",
                                                                                              PTy(F32,
                                                                                                  nTy))),
                                                                                       F32))),
                                                                              Close
                                                                                (Var("v",
                                                                                     F32),
                                                                                 MU(TP[Var("v",
                                                                                           F32),
                                                                                       Mop(Cast
                                                                                             F4,
                                                                                           nVar"i")],
                                                                                    PTy(F32,
                                                                                        qTy)))),
                                                                           Close
                                                                             (Var("v",
                                                                                  PTy(F32,
                                                                                      F4)),
                                                                              MD(Call
                                                                                   ("write'R",
                                                                                    ATy(qTy,
                                                                                        PTy(uTy,
                                                                                            qTy)),
                                                                                    Var("v",
                                                                                        PTy(F32,
                                                                                            F4))),
                                                                                 F32))))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MB(MR(Close
                                                                             (Var("s",
                                                                                  PTy(F32,
                                                                                      qTy)),
                                                                              Mop(Fst,
                                                                                  Var("s",
                                                                                      PTy(F32,
                                                                                          qTy))))),
                                                                        Close
                                                                          (Var("v",
                                                                               F32),
                                                                           MB(MU(Bop(Add,
                                                                                     Var("v",
                                                                                         F32),
                                                                                     LW(4,
                                                                                        32)),
                                                                                 PTy(F32,
                                                                                     qTy)),
                                                                              Close
                                                                                (Var("v",
                                                                                     F32),
                                                                                 MW(Close
                                                                                      (Var("s",
                                                                                           PTy(F32,
                                                                                               qTy)),
                                                                                       TP[Var("v",
                                                                                              F32),
                                                                                          Mop(Snd,
                                                                                              Var("s",
                                                                                                  PTy(F32,
                                                                                                      qTy)))])))))))),
                                                               MU(LU,
                                                                  PTy(F32,
                                                                      qTy))))]),
                                                 Close
                                                   (AVar uTy,
                                                    MB(MR(Close
                                                            (Var("s",
                                                                 PTy(F32,
                                                                     qTy)),
                                                             Dest
                                                               ("data_abort",
                                                                bTy,
                                                                Mop(Snd,
                                                                    Var("s",
                                                                        PTy(F32,
                                                                            qTy)))))),
                                                       Close
                                                         (bVar"v",
                                                          MB(ITB([(bVar"v",
                                                                   MB(MW(Close
                                                                           (Var("s",
                                                                                PTy(F32,
                                                                                    qTy)),
                                                                            TP[Mop(Fst,
                                                                                   Var("s",
                                                                                       PTy(F32,
                                                                                           qTy))),
                                                                               Rupd
                                                                                 ("REG",
                                                                                  TP[Mop(Snd,
                                                                                         Var("s",
                                                                                             PTy(F32,
                                                                                                 qTy))),
                                                                                     Var("oreg",
                                                                                         ATy(CTy"RName",
                                                                                             F32))])])),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MD(Call
                                                                              ("TakeDataAbortException",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               LU),
                                                                            F32)))),
                                                                  (Bop(Bit,
                                                                       Var("registers",
                                                                           F16),
                                                                       LN
                                                                        15),
                                                                   MB(MR(Close
                                                                           (Var("s",
                                                                                PTy(F32,
                                                                                    qTy)),
                                                                            Mop(Fst,
                                                                                Var("s",
                                                                                    PTy(F32,
                                                                                        qTy))))),
                                                                      Close
                                                                        (Var("v",
                                                                             F32),
                                                                         MB(MB(MU(TP[Var("v",
                                                                                         F32),
                                                                                     LN
                                                                                      4],
                                                                                  PTy(F32,
                                                                                      qTy)),
                                                                               Close
                                                                                 (Var("v",
                                                                                      PTy(F32,
                                                                                          nTy)),
                                                                                  MD(Call
                                                                                       ("MemA",
                                                                                        ATy(qTy,
                                                                                            PTy(F32,
                                                                                                qTy)),
                                                                                        Var("v",
                                                                                            PTy(F32,
                                                                                                nTy))),
                                                                                     F32))),
                                                                            Close
                                                                              (Var("new_pc_value",
                                                                                   F32),
                                                                               MB(MR(Close
                                                                                       (Var("s",
                                                                                            PTy(F32,
                                                                                                qTy)),
                                                                                        Dest
                                                                                          ("data_abort",
                                                                                           bTy,
                                                                                           Mop(Snd,
                                                                                               Var("s",
                                                                                                   PTy(F32,
                                                                                                       qTy)))))),
                                                                                  Close
                                                                                    (bVar"b",
                                                                                     ITE(bVar"b",
                                                                                         MB(MW(Close
                                                                                                 (Var("s",
                                                                                                      PTy(F32,
                                                                                                          qTy)),
                                                                                                  TP[Mop(Fst,
                                                                                                         Var("s",
                                                                                                             PTy(F32,
                                                                                                                 qTy))),
                                                                                                     Rupd
                                                                                                       ("REG",
                                                                                                        TP[Mop(Snd,
                                                                                                               Var("s",
                                                                                                                   PTy(F32,
                                                                                                                       qTy))),
                                                                                                           Var("oreg",
                                                                                                               ATy(CTy"RName",
                                                                                                                   F32))])])),
                                                                                            Close
                                                                                              (AVar
                                                                                                 uTy,
                                                                                               MD(Call
                                                                                                    ("TakeDataAbortException",
                                                                                                     ATy(qTy,
                                                                                                         PTy(uTy,
                                                                                                             qTy)),
                                                                                                     LU),
                                                                                                  F32))),
                                                                                         MD(Call
                                                                                              ("LoadWritePC",
                                                                                               ATy(qTy,
                                                                                                   PTy(uTy,
                                                                                                       qTy)),
                                                                                               Var("new_pc_value",
                                                                                                   F32)),
                                                                                            F32)))))))))],
                                                                 MD(Call
                                                                      ("IncPC",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       LU),
                                                                    F32)),
                                                             Close
                                                               (AVar uTy,
                                                                ITE(bVar"wback",
                                                                    ITE(Bop(Bit,
                                                                            Var("registers",
                                                                                F16),
                                                                            Mop(Cast
                                                                                  nTy,
                                                                                Var("n",
                                                                                    F4))),
                                                                        MB(MW(Close
                                                                                (Var("s",
                                                                                     PTy(F32,
                                                                                         qTy)),
                                                                                 TP[Mop(Fst,
                                                                                        Var("s",
                                                                                            PTy(F32,
                                                                                                qTy))),
                                                                                    Rupd
                                                                                      ("transfer_unknown",
                                                                                       TP[Mop(Snd,
                                                                                              Var("s",
                                                                                                  PTy(F32,
                                                                                                      qTy))),
                                                                                          LT])])),
                                                                           Close
                                                                             (AVar
                                                                                uTy,
                                                                              MD(Call
                                                                                   ("write'R",
                                                                                    ATy(qTy,
                                                                                        PTy(uTy,
                                                                                            qTy)),
                                                                                    TP[LX F32,
                                                                                       Var("n",
                                                                                           F4)]),
                                                                                 F32))),
                                                                        MD(Call
                                                                             ("write'R",
                                                                              ATy(qTy,
                                                                                  PTy(uTy,
                                                                                      qTy)),
                                                                              TP[ITE(bVar"increment",
                                                                                     Bop(Add,
                                                                                         Var("Rn",
                                                                                             F32),
                                                                                         Var("length",
                                                                                             F32)),
                                                                                     Bop(Sub,
                                                                                         Var("Rn",
                                                                                             F32),
                                                                                         Var("length",
                                                                                             F32))),
                                                                                 Var("n",
                                                                                     F4)]),
                                                                           F32)),
                                                                    MU(LU,
                                                                       PTy(F32,
                                                                           qTy)))))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadMultipleExceptionReturn_def = Def
  ("dfn'LoadMultipleExceptionReturn",
   TP[bVar"increment",bVar"wordhigher",bVar"wback",Var("n",F4),
      Var("registers",FTy 15)],
   MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",
                Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU),
                MU(LU,qTy)),
            Close
              (AVar uTy,
               MB(Call
                    ("CurrentModeIsUserOrSystem",ATy(qTy,PTy(bTy,qTy)),LU),
                  Close
                    (bVar"v",
                     MB(ITE(bVar"v",
                            Call
                              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                               Call
                                 ("UNPREDICTABLE",CTy"exception",
                                  LS"LoadMultipleExceptionReturn")),
                            MU(LU,qTy)),
                        Close
                          (AVar uTy,
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                              Close
                                (Var("Rn",F32),
                                 MB(Call
                                      ("BitCount",ATy(qTy,PTy(nTy,qTy)),
                                       Var("registers",FTy 15)),
                                    Close
                                      (nVar"v",
                                       MB(MB(MB(MU(Mop(Cast F32,nVar"v"),
                                                   qTy),
                                                Close
                                                  (Var("v",F32),
                                                   MU(Bop(Mul,LW(4,32),
                                                          Var("v",F32)),
                                                      qTy))),
                                             Close
                                               (Var("v",F32),
                                                MU(Bop(Add,Var("v",F32),
                                                       LW(4,32)),qTy))),
                                          Close
                                            (Var("length",F32),
                                             MN(ITE(bVar"increment",
                                                    Var("Rn",F32),
                                                    Bop(Sub,Var("Rn",F32),
                                                        Var("length",F32))),
                                                MB(ITE(bVar"wordhigher",
                                                       MB(MR(Close
                                                               (Var("s",
                                                                    PTy(F32,
                                                                        qTy)),
                                                                Mop(Fst,
                                                                    Var("s",
                                                                        PTy(F32,
                                                                            qTy))))),
                                                          Close
                                                            (Var("v",F32),
                                                             MB(MU(Bop(Add,
                                                                       Var("v",
                                                                           F32),
                                                                       LW(4,
                                                                          32)),
                                                                   PTy(F32,
                                                                       qTy)),
                                                                Close
                                                                  (Var("v",
                                                                       F32),
                                                                   MW(Close
                                                                        (Var("s",
                                                                             PTy(F32,
                                                                                 qTy)),
                                                                         TP[Var("v",
                                                                                F32),
                                                                            Mop(Snd,
                                                                                Var("s",
                                                                                    PTy(F32,
                                                                                        qTy)))])))))),
                                                       MU(LU,PTy(F32,qTy))),
                                                   Close
                                                     (AVar uTy,
                                                      MB(MR(Close
                                                              (Var("s",
                                                                   PTy(F32,
                                                                       qTy)),
                                                               Dest
                                                                 ("REG",
                                                                  ATy(CTy"RName",
                                                                      F32),
                                                                  Mop(Snd,
                                                                      Var("s",
                                                                          PTy(F32,
                                                                              qTy)))))),
                                                         Close
                                                           (Var("oreg",
                                                                ATy(CTy"RName",
                                                                    F32)),
                                                            MB(For(TP[LN 0,
                                                                      LN
                                                                       14,
                                                                      Close
                                                                        (nVar"i",
                                                                         ITE(Bop(Bit,
                                                                                 Var("registers",
                                                                                     FTy 15),
                                                                                 nVar"i"),
                                                                             MB(MB(MR(Close
                                                                                        (Var("s",
                                                                                             PTy(F32,
                                                                                                 qTy)),
                                                                                         Mop(Fst,
                                                                                             Var("s",
                                                                                                 PTy(F32,
                                                                                                     qTy))))),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          F32),
                                                                                      MB(MB(MB(MU(TP[Var("v",
                                                                                                         F32),
                                                                                                     LN
                                                                                                      4],
                                                                                                  PTy(F32,
                                                                                                      qTy)),
                                                                                               Close
                                                                                                 (Var("v",
                                                                                                      PTy(F32,
                                                                                                          nTy)),
                                                                                                  MD(Call
                                                                                                       ("MemA",
                                                                                                        ATy(qTy,
                                                                                                            PTy(F32,
                                                                                                                qTy)),
                                                                                                        Var("v",
                                                                                                            PTy(F32,
                                                                                                                nTy))),
                                                                                                     F32))),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   F32),
                                                                                               MU(TP[Var("v",
                                                                                                         F32),
                                                                                                     Mop(Cast
                                                                                                           F4,
                                                                                                         nVar"i")],
                                                                                                  PTy(F32,
                                                                                                      qTy)))),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                PTy(F32,
                                                                                                    F4)),
                                                                                            MD(Call
                                                                                                 ("write'R",
                                                                                                  ATy(qTy,
                                                                                                      PTy(uTy,
                                                                                                          qTy)),
                                                                                                  Var("v",
                                                                                                      PTy(F32,
                                                                                                          F4))),
                                                                                               F32))))),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MB(MR(Close
                                                                                           (Var("s",
                                                                                                PTy(F32,
                                                                                                    qTy)),
                                                                                            Mop(Fst,
                                                                                                Var("s",
                                                                                                    PTy(F32,
                                                                                                        qTy))))),
                                                                                      Close
                                                                                        (Var("v",
                                                                                             F32),
                                                                                         MB(MU(Bop(Add,
                                                                                                   Var("v",
                                                                                                       F32),
                                                                                                   LW(4,
                                                                                                      32)),
                                                                                               PTy(F32,
                                                                                                   qTy)),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   F32),
                                                                                               MW(Close
                                                                                                    (Var("s",
                                                                                                         PTy(F32,
                                                                                                             qTy)),
                                                                                                     TP[Var("v",
                                                                                                            F32),
                                                                                                        Mop(Snd,
                                                                                                            Var("s",
                                                                                                                PTy(F32,
                                                                                                                    qTy)))])))))))),
                                                                             MU(LU,
                                                                                PTy(F32,
                                                                                    qTy))))]),
                                                               Close
                                                                 (AVar uTy,
                                                                  MB(MR(Close
                                                                          (Var("s",
                                                                               PTy(F32,
                                                                                   qTy)),
                                                                           Mop(Fst,
                                                                               Var("s",
                                                                                   PTy(F32,
                                                                                       qTy))))),
                                                                     Close
                                                                       (Var("v",
                                                                            F32),
                                                                        MB(MB(MU(TP[Var("v",
                                                                                        F32),
                                                                                    LN
                                                                                     4],
                                                                                 PTy(F32,
                                                                                     qTy)),
                                                                              Close
                                                                                (Var("v",
                                                                                     PTy(F32,
                                                                                         nTy)),
                                                                                 MD(Call
                                                                                      ("MemA",
                                                                                       ATy(qTy,
                                                                                           PTy(F32,
                                                                                               qTy)),
                                                                                       Var("v",
                                                                                           PTy(F32,
                                                                                               nTy))),
                                                                                    F32))),
                                                                           Close
                                                                             (Var("new_pc_value",
                                                                                  F32),
                                                                              MB(MR(Close
                                                                                      (Var("s",
                                                                                           PTy(F32,
                                                                                               qTy)),
                                                                                       Dest
                                                                                         ("data_abort",
                                                                                          bTy,
                                                                                          Mop(Snd,
                                                                                              Var("s",
                                                                                                  PTy(F32,
                                                                                                      qTy)))))),
                                                                                 Close
                                                                                   (bVar"b",
                                                                                    ITE(bVar"b",
                                                                                        MB(MW(Close
                                                                                                (Var("s",
                                                                                                     PTy(F32,
                                                                                                         qTy)),
                                                                                                 TP[Mop(Fst,
                                                                                                        Var("s",
                                                                                                            PTy(F32,
                                                                                                                qTy))),
                                                                                                    Rupd
                                                                                                      ("REG",
                                                                                                       TP[Mop(Snd,
                                                                                                              Var("s",
                                                                                                                  PTy(F32,
                                                                                                                      qTy))),
                                                                                                          Var("oreg",
                                                                                                              ATy(CTy"RName",
                                                                                                                  F32))])])),
                                                                                           Close
                                                                                             (AVar
                                                                                                uTy,
                                                                                              MD(Call
                                                                                                   ("TakeDataAbortException",
                                                                                                    ATy(qTy,
                                                                                                        PTy(uTy,
                                                                                                            qTy)),
                                                                                                    LU),
                                                                                                 F32))),
                                                                                        MB(ITE(bVar"wback",
                                                                                               ITE(Bop(Bit,
                                                                                                       Var("registers",
                                                                                                           FTy 15),
                                                                                                       Mop(Cast
                                                                                                             nTy,
                                                                                                           Var("n",
                                                                                                               F4))),
                                                                                                   MB(MW(Close
                                                                                                           (Var("s",
                                                                                                                PTy(F32,
                                                                                                                    qTy)),
                                                                                                            TP[Mop(Fst,
                                                                                                                   Var("s",
                                                                                                                       PTy(F32,
                                                                                                                           qTy))),
                                                                                                               Rupd
                                                                                                                 ("transfer_unknown",
                                                                                                                  TP[Mop(Snd,
                                                                                                                         Var("s",
                                                                                                                             PTy(F32,
                                                                                                                                 qTy))),
                                                                                                                     LT])])),
                                                                                                      Close
                                                                                                        (AVar
                                                                                                           uTy,
                                                                                                         MD(Call
                                                                                                              ("write'R",
                                                                                                               ATy(qTy,
                                                                                                                   PTy(uTy,
                                                                                                                       qTy)),
                                                                                                               TP[LX F32,
                                                                                                                  Var("n",
                                                                                                                      F4)]),
                                                                                                            F32))),
                                                                                                   MD(Call
                                                                                                        ("write'R",
                                                                                                         ATy(qTy,
                                                                                                             PTy(uTy,
                                                                                                                 qTy)),
                                                                                                         TP[ITE(bVar"increment",
                                                                                                                Bop(Add,
                                                                                                                    Var("Rn",
                                                                                                                        F32),
                                                                                                                    Var("length",
                                                                                                                        F32)),
                                                                                                                Bop(Sub,
                                                                                                                    Var("Rn",
                                                                                                                        F32),
                                                                                                                    Var("length",
                                                                                                                        F32))),
                                                                                                            Var("n",
                                                                                                                F4)]),
                                                                                                      F32)),
                                                                                               MU(LU,
                                                                                                  PTy(F32,
                                                                                                      qTy))),
                                                                                           Close
                                                                                             (AVar
                                                                                                uTy,
                                                                                              MB(MD(Const
                                                                                                      ("SPSR",
                                                                                                       ATy(qTy,
                                                                                                           PTy(CTy"PSR",
                                                                                                               qTy))),
                                                                                                    F32),
                                                                                                 Close
                                                                                                   (Var("v",
                                                                                                        CTy"PSR"),
                                                                                                    MB(MB(MB(MU(Call
                                                                                                                  ("reg'PSR",
                                                                                                                   F32,
                                                                                                                   Var("v",
                                                                                                                       CTy"PSR")),
                                                                                                                PTy(F32,
                                                                                                                    qTy)),
                                                                                                             Close
                                                                                                               (Var("v",
                                                                                                                    F32),
                                                                                                                MU(TP[Var("v",
                                                                                                                          F32),
                                                                                                                      LW(15,
                                                                                                                         4),
                                                                                                                      LT],
                                                                                                                   PTy(F32,
                                                                                                                       qTy)))),
                                                                                                          Close
                                                                                                            (Var("v",
                                                                                                                 PTy(F32,
                                                                                                                     PTy(F4,
                                                                                                                         bTy))),
                                                                                                             MD(Call
                                                                                                                  ("CPSRWriteByInstr",
                                                                                                                   ATy(qTy,
                                                                                                                       PTy(uTy,
                                                                                                                           qTy)),
                                                                                                                   Var("v",
                                                                                                                       PTy(F32,
                                                                                                                           PTy(F4,
                                                                                                                               bTy)))),
                                                                                                                F32))),
                                                                                                       Close
                                                                                                         (AVar
                                                                                                            uTy,
                                                                                                          MD(Call
                                                                                                               ("BranchWritePC",
                                                                                                                ATy(qTy,
                                                                                                                    PTy(uTy,
                                                                                                                        qTy)),
                                                                                                                Var("new_pc_value",
                                                                                                                    F32)),
                                                                                                             F32))))))))))))))))))))))))))))))))))))
;
val dfn'LoadMultipleUserRegisters_def = Def
  ("dfn'LoadMultipleUserRegisters",
   TP[bVar"increment",bVar"wordhigher",Var("n",F4),Var("registers",FTy 15)],
   MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",
                Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU),
                MU(LU,qTy)),
            Close
              (AVar uTy,
               MB(Call
                    ("CurrentModeIsUserOrSystem",ATy(qTy,PTy(bTy,qTy)),LU),
                  Close
                    (bVar"v",
                     MB(ITE(bVar"v",
                            Call
                              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                               Call
                                 ("UNPREDICTABLE",CTy"exception",
                                  LS"LoadMultipleUserRegisters")),
                            MU(LU,qTy)),
                        Close
                          (AVar uTy,
                           MB(Call
                                ("BitCount",ATy(qTy,PTy(nTy,qTy)),
                                 Var("registers",FTy 15)),
                              Close
                                (nVar"v",
                                 MB(MB(MU(Mop(Cast F32,nVar"v"),qTy),
                                       Close
                                         (Var("v",F32),
                                          MU(Bop(Mul,LW(4,32),Var("v",F32)),
                                             qTy))),
                                    Close
                                      (Var("length",F32),
                                       MB(ITE(bVar"increment",
                                              Call
                                                ("R",
                                                 ATy(qTy,PTy(F32,qTy)),
                                                 Var("n",F4)),
                                              MB(Call
                                                   ("R",
                                                    ATy(qTy,PTy(F32,qTy)),
                                                    Var("n",F4)),
                                                 Close
                                                   (Var("v",F32),
                                                    MU(Bop(Sub,
                                                           Var("v",F32),
                                                           Var("length",
                                                               F32)),qTy)))),
                                          Close
                                            (Var("v",F32),
                                             MN(Var("v",F32),
                                                MB(ITE(bVar"wordhigher",
                                                       MB(MR(Close
                                                               (Var("s",
                                                                    PTy(F32,
                                                                        qTy)),
                                                                Mop(Fst,
                                                                    Var("s",
                                                                        PTy(F32,
                                                                            qTy))))),
                                                          Close
                                                            (Var("v",F32),
                                                             MB(MU(Bop(Add,
                                                                       Var("v",
                                                                           F32),
                                                                       LW(4,
                                                                          32)),
                                                                   PTy(F32,
                                                                       qTy)),
                                                                Close
                                                                  (Var("v",
                                                                       F32),
                                                                   MW(Close
                                                                        (Var("s",
                                                                             PTy(F32,
                                                                                 qTy)),
                                                                         TP[Var("v",
                                                                                F32),
                                                                            Mop(Snd,
                                                                                Var("s",
                                                                                    PTy(F32,
                                                                                        qTy)))])))))),
                                                       MU(LU,PTy(F32,qTy))),
                                                   Close
                                                     (AVar uTy,
                                                      MB(MR(Close
                                                              (Var("s",
                                                                   PTy(F32,
                                                                       qTy)),
                                                               Dest
                                                                 ("REG",
                                                                  ATy(CTy"RName",
                                                                      F32),
                                                                  Mop(Snd,
                                                                      Var("s",
                                                                          PTy(F32,
                                                                              qTy)))))),
                                                         Close
                                                           (Var("oreg",
                                                                ATy(CTy"RName",
                                                                    F32)),
                                                            MB(For(TP[LN 0,
                                                                      LN
                                                                       14,
                                                                      Close
                                                                        (nVar"i",
                                                                         ITE(Bop(Bit,
                                                                                 Var("registers",
                                                                                     FTy 15),
                                                                                 nVar"i"),
                                                                             MB(MB(MR(Close
                                                                                        (Var("s",
                                                                                             PTy(F32,
                                                                                                 qTy)),
                                                                                         Mop(Fst,
                                                                                             Var("s",
                                                                                                 PTy(F32,
                                                                                                     qTy))))),
                                                                                   Close
                                                                                     (Var("v",
                                                                                          F32),
                                                                                      MB(MB(MB(MU(TP[Var("v",
                                                                                                         F32),
                                                                                                     LN
                                                                                                      4],
                                                                                                  PTy(F32,
                                                                                                      qTy)),
                                                                                               Close
                                                                                                 (Var("v",
                                                                                                      PTy(F32,
                                                                                                          nTy)),
                                                                                                  MD(Call
                                                                                                       ("MemA",
                                                                                                        ATy(qTy,
                                                                                                            PTy(F32,
                                                                                                                qTy)),
                                                                                                        Var("v",
                                                                                                            PTy(F32,
                                                                                                                nTy))),
                                                                                                     F32))),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   F32),
                                                                                               MU(TP[Var("v",
                                                                                                         F32),
                                                                                                     Mop(Cast
                                                                                                           F4,
                                                                                                         nVar"i"),
                                                                                                     LW(16,
                                                                                                        5)],
                                                                                                  PTy(F32,
                                                                                                      qTy)))),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                PTy(F32,
                                                                                                    PTy(F4,
                                                                                                        FTy 5))),
                                                                                            MD(Call
                                                                                                 ("write'Rmode",
                                                                                                  ATy(qTy,
                                                                                                      PTy(uTy,
                                                                                                          qTy)),
                                                                                                  Var("v",
                                                                                                      PTy(F32,
                                                                                                          PTy(F4,
                                                                                                              FTy 5)))),
                                                                                               F32))))),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MB(MR(Close
                                                                                           (Var("s",
                                                                                                PTy(F32,
                                                                                                    qTy)),
                                                                                            Mop(Fst,
                                                                                                Var("s",
                                                                                                    PTy(F32,
                                                                                                        qTy))))),
                                                                                      Close
                                                                                        (Var("v",
                                                                                             F32),
                                                                                         MB(MU(Bop(Add,
                                                                                                   Var("v",
                                                                                                       F32),
                                                                                                   LW(4,
                                                                                                      32)),
                                                                                               PTy(F32,
                                                                                                   qTy)),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   F32),
                                                                                               MW(Close
                                                                                                    (Var("s",
                                                                                                         PTy(F32,
                                                                                                             qTy)),
                                                                                                     TP[Var("v",
                                                                                                            F32),
                                                                                                        Mop(Snd,
                                                                                                            Var("s",
                                                                                                                PTy(F32,
                                                                                                                    qTy)))])))))))),
                                                                             MU(LU,
                                                                                PTy(F32,
                                                                                    qTy))))]),
                                                               Close
                                                                 (AVar uTy,
                                                                  MB(MR(Close
                                                                          (Var("s",
                                                                               PTy(F32,
                                                                                   qTy)),
                                                                           Dest
                                                                             ("data_abort",
                                                                              bTy,
                                                                              Mop(Snd,
                                                                                  Var("s",
                                                                                      PTy(F32,
                                                                                          qTy)))))),
                                                                     Close
                                                                       (bVar"b",
                                                                        ITE(bVar"b",
                                                                            MB(MW(Close
                                                                                    (Var("s",
                                                                                         PTy(F32,
                                                                                             qTy)),
                                                                                     TP[Mop(Fst,
                                                                                            Var("s",
                                                                                                PTy(F32,
                                                                                                    qTy))),
                                                                                        Rupd
                                                                                          ("REG",
                                                                                           TP[Mop(Snd,
                                                                                                  Var("s",
                                                                                                      PTy(F32,
                                                                                                          qTy))),
                                                                                              Var("oreg",
                                                                                                  ATy(CTy"RName",
                                                                                                      F32))])])),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MD(Call
                                                                                       ("TakeDataAbortException",
                                                                                        ATy(qTy,
                                                                                            PTy(uTy,
                                                                                                qTy)),
                                                                                        LU),
                                                                                     F32))),
                                                                            MD(Call
                                                                                 ("IncPC",
                                                                                  ATy(qTy,
                                                                                      PTy(uTy,
                                                                                          qTy)),
                                                                                  LU),
                                                                               F32))))))))))))))))))))))))))
;
val dfn'LoadDual_def = Def
  ("dfn'LoadDual",
   TP[bVar"add",bVar"index",bVar"wback",Var("t",F4),Var("t2",F4),
      Var("n",F4),Var("m",CTy"offset2")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset2"),
                         [(Call("register_form2",CTy"offset2",Var("m",F4)),
                           Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4))),
                          (Call
                             ("immediate_form2",CTy"offset2",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"index",Var("offset_addr",F32),
                                     Var("Rn",F32)),
                                 MB(Call
                                      ("MemA",ATy(qTy,PTy(F32,qTy)),
                                       TP[Var("address",F32),LN 4]),
                                    Close
                                      (Var("data1",F32),
                                       MB(Call
                                            ("MemA",ATy(qTy,PTy(F32,qTy)),
                                             TP[Bop(Add,
                                                    Var("address",F32),
                                                    LW(4,32)),LN 4]),
                                          Close
                                            (Var("data2",F32),
                                             MB(MR(Close
                                                     (qVar"s",
                                                      Dest
                                                        ("data_abort",bTy,
                                                         qVar"s"))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       Call
                                                         ("TakeDataAbortException",
                                                          ATy(qTy,
                                                              PTy(uTy,qTy)),
                                                          LU),
                                                       MB(Call
                                                            ("write'R",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("data1",
                                                                    F32),
                                                                Var("t",F4)]),
                                                          Close
                                                            (AVar uTy,
                                                             MB(Call
                                                                  ("write'R",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("data2",
                                                                          F32),
                                                                      Var("t2",
                                                                          F4)]),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MB(ITE(bVar"wback",
                                                                          Call
                                                                            ("write'R",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("offset_addr",
                                                                                    F32),
                                                                                Var("n",
                                                                                    F4)]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         Call
                                                                           ("IncPC",
                                                                            ATy(qTy,
                                                                                PTy(uTy,
                                                                                    qTy)),
                                                                            LU)))))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadDualLiteral_def = Def
  ("dfn'LoadDualLiteral",
   TP[bVar"add",Var("t",F4),Var("t2",F4),Var("imm32",F32)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),LW(15,4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(ITE(bVar"add",
                    MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                       Close
                         (Var("v",F32),
                          MB(MB(MU(TP[Var("v",F32),LN 4],qTy),
                                Close
                                  (Var("v",PTy(F32,nTy)),
                                   MU(Call
                                        ("Align",F32,Var("v",PTy(F32,nTy))),
                                      qTy))),
                             Close
                               (Var("v",F32),
                                MU(Bop(Add,Var("v",F32),Var("imm32",F32)),
                                   qTy))))),
                    MB(Const("PC",ATy(qTy,PTy(F32,qTy))),
                       Close
                         (Var("v",F32),
                          MB(MB(MU(TP[Var("v",F32),LN 4],qTy),
                                Close
                                  (Var("v",PTy(F32,nTy)),
                                   MU(Call
                                        ("Align",F32,Var("v",PTy(F32,nTy))),
                                      qTy))),
                             Close
                               (Var("v",F32),
                                MU(Bop(Sub,Var("v",F32),Var("imm32",F32)),
                                   qTy)))))),
                Close
                  (Var("address",F32),
                   MB(Call
                        ("MemA",ATy(qTy,PTy(F32,qTy)),
                         TP[Var("address",F32),LN 4]),
                      Close
                        (Var("data1",F32),
                         MB(Call
                              ("MemA",ATy(qTy,PTy(F32,qTy)),
                               TP[Bop(Add,Var("address",F32),LW(4,32)),
                                  LN 4]),
                            Close
                              (Var("data2",F32),
                               MB(MR(Close
                                       (qVar"s",
                                        Dest("data_abort",bTy,qVar"s"))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         Call
                                           ("TakeDataAbortException",
                                            ATy(qTy,PTy(uTy,qTy)),LU),
                                         MB(Call
                                              ("write'R",
                                               ATy(qTy,PTy(uTy,qTy)),
                                               TP[Var("data1",F32),
                                                  Var("t",F4)]),
                                            Close
                                              (AVar uTy,
                                               MB(Call
                                                    ("write'R",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Var("data2",F32),
                                                        Var("t2",F4)]),
                                                  Close
                                                    (AVar uTy,
                                                     Call
                                                       ("IncPC",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        LU)))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadExclusive_def = Def
  ("dfn'LoadExclusive",TP[Var("t",F4),Var("n",F4),Var("imm32",F32)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("v",F32),
                   MB(MU(Bop(Add,Var("v",F32),Var("imm32",F32)),qTy),
                      Close
                        (Var("address",F32),
                         MB(MR(Close
                                 (qVar"s",
                                  Dest
                                    ("SetExclusiveMonitors",
                                     ATy(PTy(F32,
                                             PTy(nTy,
                                                 PTy(LTy(STy F32),
                                                     STy(PTy(F32,nTy))))),
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy)))),qVar"s"))),
                            Close
                              (Var("v",
                                   ATy(PTy(F32,
                                           PTy(nTy,
                                               PTy(LTy(STy F32),
                                                   STy(PTy(F32,nTy))))),
                                       PTy(LTy(STy F32),STy(PTy(F32,nTy))))),
                               MB(MB(MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("exclusive_state",
                                                 PTy(LTy(STy F32),
                                                     STy(PTy(F32,nTy))),
                                                 qVar"s"))),
                                        Close
                                          (Var("v0",
                                               PTy(LTy(STy F32),
                                                   STy(PTy(F32,nTy)))),
                                           MB(MB(MU(TP[LN 4,
                                                       Var("v0",
                                                           PTy(LTy(STy F32),
                                                               STy(PTy(F32,
                                                                       nTy))))],
                                                    qTy),
                                                 Close
                                                   (Var("v",
                                                        PTy(nTy,
                                                            PTy(LTy(STy F32),
                                                                STy(PTy(F32,
                                                                        nTy))))),
                                                    MU(TP[Var("address",
                                                              F32),
                                                          Var("v",
                                                              PTy(nTy,
                                                                  PTy(LTy(STy F32),
                                                                      STy(PTy(F32,
                                                                              nTy)))))],
                                                       qTy))),
                                              Close
                                                (Var("v0",
                                                     PTy(F32,
                                                         PTy(nTy,
                                                             PTy(LTy(STy F32),
                                                                 STy(PTy(F32,
                                                                         nTy)))))),
                                                 MU(Apply
                                                      (Var("v",
                                                           ATy(PTy(F32,
                                                                   PTy(nTy,
                                                                       PTy(LTy(STy F32),
                                                                           STy(PTy(F32,
                                                                                   nTy))))),
                                                               PTy(LTy(STy F32),
                                                                   STy(PTy(F32,
                                                                           nTy))))),
                                                       Var("v0",
                                                           PTy(F32,
                                                               PTy(nTy,
                                                                   PTy(LTy(STy F32),
                                                                       STy(PTy(F32,
                                                                               nTy))))))),
                                                    qTy))))),
                                     Close
                                       (Var("v",
                                            PTy(LTy(STy F32),
                                                STy(PTy(F32,nTy)))),
                                        MW(Close
                                             (qVar"s",
                                              Rupd
                                                ("exclusive_state",
                                                 TP[qVar"s",
                                                    Var("v",
                                                        PTy(LTy(STy F32),
                                                            STy(PTy(F32,
                                                                    nTy))))]))))),
                                  Close
                                    (AVar uTy,
                                     MB(Call
                                          ("MemA",ATy(qTy,PTy(F32,qTy)),
                                           TP[Var("address",F32),LN 4]),
                                        Close
                                          (Var("data",F32),
                                           MB(MR(Close
                                                   (qVar"s",
                                                    Dest
                                                      ("data_abort",bTy,
                                                       qVar"s"))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     Call
                                                       ("TakeDataAbortException",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        LU),
                                                     MB(Call
                                                          ("write'R",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("data",
                                                                  F32),
                                                              Var("t",F4)]),
                                                        Close
                                                          (AVar uTy,
                                                           Call
                                                             ("IncPC",
                                                              ATy(qTy,
                                                                  PTy(uTy,
                                                                      qTy)),
                                                              LU)))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadExclusiveByte_def = Def
  ("dfn'LoadExclusiveByte",TP[Var("t",F4),Var("n",F4)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("address",F32),
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("SetExclusiveMonitors",
                               ATy(PTy(F32,
                                       PTy(nTy,
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))))),
                                   PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                               qVar"s"))),
                      Close
                        (Var("v",
                             ATy(PTy(F32,
                                     PTy(nTy,
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy))))),
                                 PTy(LTy(STy F32),STy(PTy(F32,nTy))))),
                         MB(MB(MB(MR(Close
                                       (qVar"s",
                                        Dest
                                          ("exclusive_state",
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))),qVar"s"))),
                                  Close
                                    (Var("v0",
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy)))),
                                     MB(MB(MU(TP[LN 1,
                                                 Var("v0",
                                                     PTy(LTy(STy F32),
                                                         STy(PTy(F32,nTy))))],
                                              qTy),
                                           Close
                                             (Var("v",
                                                  PTy(nTy,
                                                      PTy(LTy(STy F32),
                                                          STy(PTy(F32,nTy))))),
                                              MU(TP[Var("address",F32),
                                                    Var("v",
                                                        PTy(nTy,
                                                            PTy(LTy(STy F32),
                                                                STy(PTy(F32,
                                                                        nTy)))))],
                                                 qTy))),
                                        Close
                                          (Var("v0",
                                               PTy(F32,
                                                   PTy(nTy,
                                                       PTy(LTy(STy F32),
                                                           STy(PTy(F32,nTy)))))),
                                           MU(Apply
                                                (Var("v",
                                                     ATy(PTy(F32,
                                                             PTy(nTy,
                                                                 PTy(LTy(STy F32),
                                                                     STy(PTy(F32,
                                                                             nTy))))),
                                                         PTy(LTy(STy F32),
                                                             STy(PTy(F32,
                                                                     nTy))))),
                                                 Var("v0",
                                                     PTy(F32,
                                                         PTy(nTy,
                                                             PTy(LTy(STy F32),
                                                                 STy(PTy(F32,
                                                                         nTy))))))),
                                              qTy))))),
                               Close
                                 (Var("v",
                                      PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                                  MW(Close
                                       (qVar"s",
                                        Rupd
                                          ("exclusive_state",
                                           TP[qVar"s",
                                              Var("v",
                                                  PTy(LTy(STy F32),
                                                      STy(PTy(F32,nTy))))]))))),
                            Close
                              (AVar uTy,
                               MB(Call
                                    ("MemA",ATy(qTy,PTy(F8,qTy)),
                                     TP[Var("address",F32),LN 1]),
                                  Close
                                    (Var("data",F8),
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("data_abort",bTy,qVar"s"))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               Call
                                                 ("TakeDataAbortException",
                                                  ATy(qTy,PTy(uTy,qTy)),LU),
                                               MB(Call
                                                    ("write'R",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Mop(Cast F32,
                                                            Var("data",F8)),
                                                        Var("t",F4)]),
                                                  Close
                                                    (AVar uTy,
                                                     Call
                                                       ("IncPC",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        LU)))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadExclusiveHalf_def = Def
  ("dfn'LoadExclusiveHalf",TP[Var("t",F4),Var("n",F4)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("address",F32),
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("SetExclusiveMonitors",
                               ATy(PTy(F32,
                                       PTy(nTy,
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))))),
                                   PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                               qVar"s"))),
                      Close
                        (Var("v",
                             ATy(PTy(F32,
                                     PTy(nTy,
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy))))),
                                 PTy(LTy(STy F32),STy(PTy(F32,nTy))))),
                         MB(MB(MB(MR(Close
                                       (qVar"s",
                                        Dest
                                          ("exclusive_state",
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))),qVar"s"))),
                                  Close
                                    (Var("v0",
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy)))),
                                     MB(MB(MU(TP[LN 2,
                                                 Var("v0",
                                                     PTy(LTy(STy F32),
                                                         STy(PTy(F32,nTy))))],
                                              qTy),
                                           Close
                                             (Var("v",
                                                  PTy(nTy,
                                                      PTy(LTy(STy F32),
                                                          STy(PTy(F32,nTy))))),
                                              MU(TP[Var("address",F32),
                                                    Var("v",
                                                        PTy(nTy,
                                                            PTy(LTy(STy F32),
                                                                STy(PTy(F32,
                                                                        nTy)))))],
                                                 qTy))),
                                        Close
                                          (Var("v0",
                                               PTy(F32,
                                                   PTy(nTy,
                                                       PTy(LTy(STy F32),
                                                           STy(PTy(F32,nTy)))))),
                                           MU(Apply
                                                (Var("v",
                                                     ATy(PTy(F32,
                                                             PTy(nTy,
                                                                 PTy(LTy(STy F32),
                                                                     STy(PTy(F32,
                                                                             nTy))))),
                                                         PTy(LTy(STy F32),
                                                             STy(PTy(F32,
                                                                     nTy))))),
                                                 Var("v0",
                                                     PTy(F32,
                                                         PTy(nTy,
                                                             PTy(LTy(STy F32),
                                                                 STy(PTy(F32,
                                                                         nTy))))))),
                                              qTy))))),
                               Close
                                 (Var("v",
                                      PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                                  MW(Close
                                       (qVar"s",
                                        Rupd
                                          ("exclusive_state",
                                           TP[qVar"s",
                                              Var("v",
                                                  PTy(LTy(STy F32),
                                                      STy(PTy(F32,nTy))))]))))),
                            Close
                              (AVar uTy,
                               MB(Call
                                    ("MemA",ATy(qTy,PTy(F16,qTy)),
                                     TP[Var("address",F32),LN 2]),
                                  Close
                                    (Var("data",F16),
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("data_abort",bTy,qVar"s"))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               Call
                                                 ("TakeDataAbortException",
                                                  ATy(qTy,PTy(uTy,qTy)),LU),
                                               MB(Call
                                                    ("write'R",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Mop(Cast F32,
                                                            Var("data",F16)),
                                                        Var("t",F4)]),
                                                  Close
                                                    (AVar uTy,
                                                     Call
                                                       ("IncPC",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        LU)))))))))))))),
             MU(LU,qTy)))))
;
val dfn'LoadExclusiveDoubleword_def = Def
  ("dfn'LoadExclusiveDoubleword",TP[Var("t",F4),Var("t2",F4),Var("n",F4)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("address",F32),
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("SetExclusiveMonitors",
                               ATy(PTy(F32,
                                       PTy(nTy,
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))))),
                                   PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                               qVar"s"))),
                      Close
                        (Var("v",
                             ATy(PTy(F32,
                                     PTy(nTy,
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy))))),
                                 PTy(LTy(STy F32),STy(PTy(F32,nTy))))),
                         MB(MB(MB(MR(Close
                                       (qVar"s",
                                        Dest
                                          ("exclusive_state",
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))),qVar"s"))),
                                  Close
                                    (Var("v0",
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy)))),
                                     MB(MB(MU(TP[LN 8,
                                                 Var("v0",
                                                     PTy(LTy(STy F32),
                                                         STy(PTy(F32,nTy))))],
                                              qTy),
                                           Close
                                             (Var("v",
                                                  PTy(nTy,
                                                      PTy(LTy(STy F32),
                                                          STy(PTy(F32,nTy))))),
                                              MU(TP[Var("address",F32),
                                                    Var("v",
                                                        PTy(nTy,
                                                            PTy(LTy(STy F32),
                                                                STy(PTy(F32,
                                                                        nTy)))))],
                                                 qTy))),
                                        Close
                                          (Var("v0",
                                               PTy(F32,
                                                   PTy(nTy,
                                                       PTy(LTy(STy F32),
                                                           STy(PTy(F32,nTy)))))),
                                           MU(Apply
                                                (Var("v",
                                                     ATy(PTy(F32,
                                                             PTy(nTy,
                                                                 PTy(LTy(STy F32),
                                                                     STy(PTy(F32,
                                                                             nTy))))),
                                                         PTy(LTy(STy F32),
                                                             STy(PTy(F32,
                                                                     nTy))))),
                                                 Var("v0",
                                                     PTy(F32,
                                                         PTy(nTy,
                                                             PTy(LTy(STy F32),
                                                                 STy(PTy(F32,
                                                                         nTy))))))),
                                              qTy))))),
                               Close
                                 (Var("v",
                                      PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                                  MW(Close
                                       (qVar"s",
                                        Rupd
                                          ("exclusive_state",
                                           TP[qVar"s",
                                              Var("v",
                                                  PTy(LTy(STy F32),
                                                      STy(PTy(F32,nTy))))]))))),
                            Close
                              (AVar uTy,
                               MB(Call
                                    ("MemA",ATy(qTy,PTy(F64,qTy)),
                                     TP[Var("address",F32),LN 8]),
                                  Close
                                    (Var("value",F64),
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("data_abort",bTy,qVar"s"))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               Call
                                                 ("TakeDataAbortException",
                                                  ATy(qTy,PTy(uTy,qTy)),LU),
                                               MB(Call
                                                    ("BigEndian",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v",
                                                     MB(MB(MB(MU(ITE(bVar"v",
                                                                     EX(Var("value",
                                                                            F64),
                                                                        LN
                                                                         63,
                                                                        LN
                                                                         32,
                                                                        F32),
                                                                     EX(Var("value",
                                                                            F64),
                                                                        LN
                                                                         31,
                                                                        LN
                                                                         0,
                                                                        F32)),
                                                                 qTy),
                                                              Close
                                                                (Var("v",
                                                                     F32),
                                                                 MU(TP[Var("v",
                                                                           F32),
                                                                       Var("t",
                                                                           F4)],
                                                                    qTy))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F32,
                                                                      F4)),
                                                              Call
                                                                ("write'R",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F32,
                                                                         F4))))),
                                                        Close
                                                          (AVar uTy,
                                                           MB(Call
                                                                ("BigEndian",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v",
                                                                 MB(MB(MB(MU(ITE(bVar"v",
                                                                                 EX(Var("value",
                                                                                        F64),
                                                                                    LN
                                                                                     31,
                                                                                    LN
                                                                                     0,
                                                                                    F32),
                                                                                 EX(Var("value",
                                                                                        F64),
                                                                                    LN
                                                                                     63,
                                                                                    LN
                                                                                     32,
                                                                                    F32)),
                                                                             qTy),
                                                                          Close
                                                                            (Var("v",
                                                                                 F32),
                                                                             MU(TP[Var("v",
                                                                                       F32),
                                                                                   Var("t2",
                                                                                       F4)],
                                                                                qTy))),
                                                                       Close
                                                                         (Var("v",
                                                                              PTy(F32,
                                                                                  F4)),
                                                                          Call
                                                                            ("write'R",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             Var("v",
                                                                                 PTy(F32,
                                                                                     F4))))),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       Call
                                                                         ("IncPC",
                                                                          ATy(qTy,
                                                                              PTy(uTy,
                                                                                  qTy)),
                                                                          LU)))))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreWord_def = Def
  ("dfn'StoreWord",
   TP[bVar"add",bVar"index",bVar"wback",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"index",Var("offset_addr",F32),
                                     Var("Rn",F32)),
                                 MB(ITE(EQ(Var("t",F4),LW(15,4)),
                                        Call
                                          ("PCStoreValue",
                                           ATy(qTy,PTy(F32,qTy)),LU),
                                        Call
                                          ("R",ATy(qTy,PTy(F32,qTy)),
                                           Var("t",F4))),
                                    Close
                                      (Var("data",F32),
                                       MB(Call
                                            ("UnalignedSupport",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v",
                                             MB(MB(MB(MU(Bop(Or,bVar"v",
                                                             Call
                                                               ("Aligned",
                                                                bTy,
                                                                TP[Var("address",
                                                                       F32),
                                                                   LN 4])),
                                                         qTy),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MU(LT,qTy),
                                                             MB(Call
                                                                  ("CurrentInstrSet",
                                                                   ATy(qTy,
                                                                       PTy(CTy"InstrSet",
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (Var("v",
                                                                       CTy"InstrSet"),
                                                                   MU(EQ(Var("v",
                                                                             CTy"InstrSet"),
                                                                         LC("InstrSet_ARM",
                                                                            CTy"InstrSet")),
                                                                      qTy)))))),
                                                   Close
                                                     (bVar"b",
                                                      ITE(bVar"b",
                                                          Call
                                                            ("write'MemU",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("data",
                                                                    F32),
                                                                Var("address",
                                                                    F32),
                                                                LN 4]),
                                                          MB(Call
                                                               ("write'MemU",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                TP[LX F32,
                                                                   Var("address",
                                                                       F32),
                                                                   LN 4]),
                                                             Close
                                                               (AVar uTy,
                                                                MB(MR(Close
                                                                        (qVar"s",
                                                                         Dest
                                                                           ("data_abort",
                                                                            bTy,
                                                                            qVar"s"))),
                                                                   Close
                                                                     (bVar"v",
                                                                      MB(MU(Mop(Not,
                                                                                bVar"v"),
                                                                            qTy),
                                                                         Close
                                                                           (bVar"b",
                                                                            ITE(bVar"b",
                                                                                MW(Close
                                                                                     (qVar"s",
                                                                                      Rupd
                                                                                        ("transfer_unknown",
                                                                                         TP[qVar"s",
                                                                                            LT]))),
                                                                                MU(LU,
                                                                                   qTy))))))))))),
                                                Close
                                                  (AVar uTy,
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("data_abort",
                                                               bTy,qVar"s"))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             Call
                                                               ("TakeDataAbortException",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                LU),
                                                             MB(ITE(bVar"wback",
                                                                    Call
                                                                      ("write'R",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("offset_addr",
                                                                              F32),
                                                                          Var("n",
                                                                              F4)]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("IncPC",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      LU)))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreUnprivileged_def = Def
  ("dfn'StoreUnprivileged",
   TP[bVar"add",bVar"postindex",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"postindex",Var("Rn",F32),
                                     Var("offset_addr",F32)),
                                 MB(ITE(EQ(Var("t",F4),LW(15,4)),
                                        Call
                                          ("PCStoreValue",
                                           ATy(qTy,PTy(F32,qTy)),LU),
                                        Call
                                          ("R",ATy(qTy,PTy(F32,qTy)),
                                           Var("t",F4))),
                                    Close
                                      (Var("data",F32),
                                       MB(Call
                                            ("UnalignedSupport",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v",
                                             MB(MB(MB(MU(Bop(Or,bVar"v",
                                                             Call
                                                               ("Aligned",
                                                                bTy,
                                                                TP[Var("address",
                                                                       F32),
                                                                   LN 4])),
                                                         qTy),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MU(LT,qTy),
                                                             MB(Call
                                                                  ("CurrentInstrSet",
                                                                   ATy(qTy,
                                                                       PTy(CTy"InstrSet",
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (Var("v",
                                                                       CTy"InstrSet"),
                                                                   MU(EQ(Var("v",
                                                                             CTy"InstrSet"),
                                                                         LC("InstrSet_ARM",
                                                                            CTy"InstrSet")),
                                                                      qTy)))))),
                                                   Close
                                                     (bVar"b",
                                                      ITE(bVar"b",
                                                          Call
                                                            ("write'MemU_unpriv",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("data",
                                                                    F32),
                                                                Var("address",
                                                                    F32),
                                                                LN 4]),
                                                          MB(Call
                                                               ("write'MemU_unpriv",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                TP[LX F32,
                                                                   Var("address",
                                                                       F32),
                                                                   LN 4]),
                                                             Close
                                                               (AVar uTy,
                                                                MB(MR(Close
                                                                        (qVar"s",
                                                                         Dest
                                                                           ("data_abort",
                                                                            bTy,
                                                                            qVar"s"))),
                                                                   Close
                                                                     (bVar"v",
                                                                      MB(MU(Mop(Not,
                                                                                bVar"v"),
                                                                            qTy),
                                                                         Close
                                                                           (bVar"b",
                                                                            ITE(bVar"b",
                                                                                MW(Close
                                                                                     (qVar"s",
                                                                                      Rupd
                                                                                        ("transfer_unknown",
                                                                                         TP[qVar"s",
                                                                                            LT]))),
                                                                                MU(LU,
                                                                                   qTy))))))))))),
                                                Close
                                                  (AVar uTy,
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("data_abort",
                                                               bTy,qVar"s"))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             Call
                                                               ("TakeDataAbortException",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                LU),
                                                             MB(ITE(bVar"postindex",
                                                                    Call
                                                                      ("write'R",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("offset_addr",
                                                                              F32),
                                                                          Var("n",
                                                                              F4)]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("IncPC",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      LU)))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreByte_def = Def
  ("dfn'StoreByte",
   TP[bVar"add",bVar"index",bVar"wback",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             MB(MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("t",F4)),
                                   Close
                                     (Var("v",F32),
                                      MB(MB(MU(EX(Var("v",F32),LN 7,LN 0,
                                                  F8),qTy),
                                            Close
                                              (Var("v",F8),
                                               MU(TP[Var("v",F8),
                                                     ITE(bVar"index",
                                                         Var("offset_addr",
                                                             F32),
                                                         Var("Rn",F32)),
                                                     LN 1],qTy))),
                                         Close
                                           (Var("v",PTy(F8,PTy(F32,nTy))),
                                            Call
                                              ("write'MemU",
                                               ATy(qTy,PTy(uTy,qTy)),
                                               Var("v",
                                                   PTy(F8,PTy(F32,nTy)))))))),
                                Close
                                  (AVar uTy,
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("data_abort",bTy,qVar"s"))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Call
                                               ("TakeDataAbortException",
                                                ATy(qTy,PTy(uTy,qTy)),LU),
                                             MB(ITE(bVar"wback",
                                                    Call
                                                      ("write'R",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("offset_addr",
                                                              F32),
                                                          Var("n",F4)]),
                                                    MU(LU,qTy)),
                                                Close
                                                  (AVar uTy,
                                                   Call
                                                     ("IncPC",
                                                      ATy(qTy,PTy(uTy,qTy)),
                                                      LU))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreByteUnprivileged_def = Def
  ("dfn'StoreByteUnprivileged",
   TP[bVar"add",bVar"postindex",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             MB(MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("t",F4)),
                                   Close
                                     (Var("v",F32),
                                      MB(MB(MU(EX(Var("v",F32),LN 7,LN 0,
                                                  F8),qTy),
                                            Close
                                              (Var("v",F8),
                                               MU(TP[Var("v",F8),
                                                     ITE(bVar"postindex",
                                                         Var("Rn",F32),
                                                         Var("offset_addr",
                                                             F32)),LN 1],
                                                  qTy))),
                                         Close
                                           (Var("v",PTy(F8,PTy(F32,nTy))),
                                            Call
                                              ("write'MemU_unpriv",
                                               ATy(qTy,PTy(uTy,qTy)),
                                               Var("v",
                                                   PTy(F8,PTy(F32,nTy)))))))),
                                Close
                                  (AVar uTy,
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("data_abort",bTy,qVar"s"))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Call
                                               ("TakeDataAbortException",
                                                ATy(qTy,PTy(uTy,qTy)),LU),
                                             MB(ITE(bVar"postindex",
                                                    Call
                                                      ("write'R",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("offset_addr",
                                                              F32),
                                                          Var("n",F4)]),
                                                    MU(LU,qTy)),
                                                Close
                                                  (AVar uTy,
                                                   Call
                                                     ("IncPC",
                                                      ATy(qTy,PTy(uTy,qTy)),
                                                      LU))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreHalf_def = Def
  ("dfn'StoreHalf",
   TP[bVar"add",bVar"index",bVar"wback",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset1")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset1"),
                         [(Call
                             ("register_form1",CTy"offset1",
                              TP[Var("m",F4),Var("shift_t",CTy"SRType"),
                                 nVar"shift_n"]),
                           MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4)),
                              Close
                                (Var("v",F32),
                                 MB(MB(MR(Close
                                            (qVar"s",
                                             Dest("CPSR",CTy"PSR",qVar"s"))),
                                       Close
                                         (Var("v0",CTy"PSR"),
                                          MB(MB(MB(MU(Dest
                                                        ("C",bTy,
                                                         Var("v0",CTy"PSR")),
                                                      qTy),
                                                   Close
                                                     (bVar"v",
                                                      MU(TP[nVar"shift_n",
                                                            bVar"v"],qTy))),
                                                Close
                                                  (Var("v",PTy(nTy,bTy)),
                                                   MU(TP[Var("shift_t",
                                                             CTy"SRType"),
                                                         Var("v",
                                                             PTy(nTy,bTy))],
                                                      qTy))),
                                             Close
                                               (Var("v0",
                                                    PTy(CTy"SRType",
                                                        PTy(nTy,bTy))),
                                                MU(TP[Var("v",F32),
                                                      Var("v0",
                                                          PTy(CTy"SRType",
                                                              PTy(nTy,bTy)))],
                                                   qTy))))),
                                    Close
                                      (Var("v",
                                           PTy(F32,
                                               PTy(CTy"SRType",
                                                   PTy(nTy,bTy)))),
                                       Call
                                         ("Shift",ATy(qTy,PTy(F32,qTy)),
                                          Var("v",
                                              PTy(F32,
                                                  PTy(CTy"SRType",
                                                      PTy(nTy,bTy)))))))))),
                          (Call
                             ("immediate_form1",CTy"offset1",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"index",Var("offset_addr",F32),
                                     Var("Rn",F32)),
                                 MB(Call
                                      ("UnalignedSupport",
                                       ATy(qTy,PTy(bTy,qTy)),LU),
                                    Close
                                      (bVar"v",
                                       MB(MB(MU(Bop(Or,bVar"v",
                                                    Call
                                                      ("Aligned",bTy,
                                                       TP[Var("address",
                                                              F32),LN 2])),
                                                qTy),
                                             Close
                                               (bVar"b",
                                                ITE(bVar"b",
                                                    MB(Call
                                                         ("R",
                                                          ATy(qTy,
                                                              PTy(F32,qTy)),
                                                          Var("t",F4)),
                                                       Close
                                                         (Var("v",F32),
                                                          MB(MB(MU(EX(Var("v",
                                                                          F32),
                                                                      LN
                                                                       15,
                                                                      LN 0,
                                                                      F16),
                                                                   qTy),
                                                                Close
                                                                  (Var("v",
                                                                       F16),
                                                                   MU(TP[Var("v",
                                                                             F16),
                                                                         Var("address",
                                                                             F32),
                                                                         LN
                                                                          2],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F16,
                                                                        PTy(F32,
                                                                            nTy))),
                                                                Call
                                                                  ("write'MemU",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F16,
                                                                           PTy(F32,
                                                                               nTy)))))))),
                                                    MB(Call
                                                         ("write'MemU",
                                                          ATy(qTy,
                                                              PTy(uTy,qTy)),
                                                          TP[LX F16,
                                                             Var("address",
                                                                 F32),LN 2]),
                                                       Close
                                                         (AVar uTy,
                                                          MB(MR(Close
                                                                  (qVar"s",
                                                                   Dest
                                                                     ("data_abort",
                                                                      bTy,
                                                                      qVar"s"))),
                                                             Close
                                                               (bVar"v",
                                                                MB(MU(Mop(Not,
                                                                          bVar"v"),
                                                                      qTy),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MW(Close
                                                                               (qVar"s",
                                                                                Rupd
                                                                                  ("transfer_unknown",
                                                                                   TP[qVar"s",
                                                                                      LT]))),
                                                                          MU(LU,
                                                                             qTy))))))))))),
                                          Close
                                            (AVar uTy,
                                             MB(MR(Close
                                                     (qVar"s",
                                                      Dest
                                                        ("data_abort",bTy,
                                                         qVar"s"))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       Call
                                                         ("TakeDataAbortException",
                                                          ATy(qTy,
                                                              PTy(uTy,qTy)),
                                                          LU),
                                                       MB(ITE(bVar"wback",
                                                              Call
                                                                ("write'R",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 TP[Var("offset_addr",
                                                                        F32),
                                                                    Var("n",
                                                                        F4)]),
                                                              MU(LU,qTy)),
                                                          Close
                                                            (AVar uTy,
                                                             Call
                                                               ("IncPC",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                LU)))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreHalfUnprivileged_def = Def
  ("dfn'StoreHalfUnprivileged",
   TP[bVar"add",bVar"postindex",Var("t",F4),Var("n",F4),
      Var("m",CTy"offset2")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset2"),
                         [(Call("register_form2",CTy"offset2",Var("m",F4)),
                           Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4))),
                          (Call
                             ("immediate_form2",CTy"offset2",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"postindex",Var("Rn",F32),
                                     Var("offset_addr",F32)),
                                 MB(Call
                                      ("UnalignedSupport",
                                       ATy(qTy,PTy(bTy,qTy)),LU),
                                    Close
                                      (bVar"v",
                                       MB(MB(MU(Bop(Or,bVar"v",
                                                    Call
                                                      ("Aligned",bTy,
                                                       TP[Var("address",
                                                              F32),LN 2])),
                                                qTy),
                                             Close
                                               (bVar"b",
                                                ITE(bVar"b",
                                                    MB(Call
                                                         ("R",
                                                          ATy(qTy,
                                                              PTy(F32,qTy)),
                                                          Var("t",F4)),
                                                       Close
                                                         (Var("v",F32),
                                                          MB(MB(MU(EX(Var("v",
                                                                          F32),
                                                                      LN
                                                                       15,
                                                                      LN 0,
                                                                      F16),
                                                                   qTy),
                                                                Close
                                                                  (Var("v",
                                                                       F16),
                                                                   MU(TP[Var("v",
                                                                             F16),
                                                                         Var("address",
                                                                             F32),
                                                                         LN
                                                                          2],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F16,
                                                                        PTy(F32,
                                                                            nTy))),
                                                                Call
                                                                  ("write'MemU_unpriv",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F16,
                                                                           PTy(F32,
                                                                               nTy)))))))),
                                                    MB(Call
                                                         ("write'MemU_unpriv",
                                                          ATy(qTy,
                                                              PTy(uTy,qTy)),
                                                          TP[LX F16,
                                                             Var("address",
                                                                 F32),LN 2]),
                                                       Close
                                                         (AVar uTy,
                                                          MB(MR(Close
                                                                  (qVar"s",
                                                                   Dest
                                                                     ("data_abort",
                                                                      bTy,
                                                                      qVar"s"))),
                                                             Close
                                                               (bVar"v",
                                                                MB(MU(Mop(Not,
                                                                          bVar"v"),
                                                                      qTy),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MW(Close
                                                                               (qVar"s",
                                                                                Rupd
                                                                                  ("transfer_unknown",
                                                                                   TP[qVar"s",
                                                                                      LT]))),
                                                                          MU(LU,
                                                                             qTy))))))))))),
                                          Close
                                            (AVar uTy,
                                             MB(MR(Close
                                                     (qVar"s",
                                                      Dest
                                                        ("data_abort",bTy,
                                                         qVar"s"))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       Call
                                                         ("TakeDataAbortException",
                                                          ATy(qTy,
                                                              PTy(uTy,qTy)),
                                                          LU),
                                                       MB(ITE(bVar"postindex",
                                                              Call
                                                                ("write'R",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 TP[Var("offset_addr",
                                                                        F32),
                                                                    Var("n",
                                                                        F4)]),
                                                              MU(LU,qTy)),
                                                          Close
                                                            (AVar uTy,
                                                             Call
                                                               ("IncPC",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                LU)))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreMultiple_def = Def
  ("dfn'StoreMultiple",
   TP[bVar"increment",bVar"index",bVar"wback",Var("n",F4),
      Var("registers",F16)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(Call
                        ("BitCount",ATy(qTy,PTy(nTy,qTy)),
                         Var("registers",F16)),
                      Close
                        (nVar"v",
                         MB(MB(MU(Mop(Cast F32,nVar"v"),qTy),
                               Close
                                 (Var("v",F32),
                                  MU(Bop(Mul,LW(4,32),Var("v",F32)),qTy))),
                            Close
                              (Var("length",F32),
                               MN(ITE(bVar"increment",Var("Rn",F32),
                                      Bop(Sub,Var("Rn",F32),
                                          Var("length",F32))),
                                  MB(ITE(EQ(bVar"index",bVar"increment"),
                                         MB(MR(Close
                                                 (Var("s",PTy(F32,qTy)),
                                                  Mop(Fst,
                                                      Var("s",PTy(F32,qTy))))),
                                            Close
                                              (Var("v",F32),
                                               MB(MU(Bop(Add,Var("v",F32),
                                                         LW(4,32)),
                                                     PTy(F32,qTy)),
                                                  Close
                                                    (Var("v",F32),
                                                     MW(Close
                                                          (Var("s",
                                                               PTy(F32,qTy)),
                                                           TP[Var("v",F32),
                                                              Mop(Snd,
                                                                  Var("s",
                                                                      PTy(F32,
                                                                          qTy)))])))))),
                                         MU(LU,PTy(F32,qTy))),
                                     Close
                                       (AVar uTy,
                                        MB(MR(Close
                                                (Var("s",PTy(F32,qTy)),
                                                 Dest
                                                   ("MEM",ATy(F32,F8),
                                                    Mop(Snd,
                                                        Var("s",
                                                            PTy(F32,qTy)))))),
                                           Close
                                             (Var("omem",ATy(F32,F8)),
                                              MB(For(TP[LN 0,LN 14,
                                                        Close
                                                          (nVar"i",
                                                           ITE(Bop(Bit,
                                                                   Var("registers",
                                                                       F16),
                                                                   Mop(Cast
                                                                         nTy,
                                                                       nVar"i")),
                                                               MB(ITE(Bop(And,
                                                                          Bop(And,
                                                                              EQ(Mop(Cast
                                                                                       F4,
                                                                                     nVar"i"),
                                                                                 Var("n",
                                                                                     F4)),
                                                                              bVar"wback"),
                                                                          Mop(Not,
                                                                              EQ(nVar"i",
                                                                                 Call
                                                                                   ("LowestSetBit",
                                                                                    nTy,
                                                                                    Var("registers",
                                                                                        F16))))),
                                                                      MB(MR(Close
                                                                              (Var("s",
                                                                                   PTy(F32,
                                                                                       qTy)),
                                                                               Mop(Fst,
                                                                                   Var("s",
                                                                                       PTy(F32,
                                                                                           qTy))))),
                                                                         Close
                                                                           (Var("v",
                                                                                F32),
                                                                            MB(MB(MU(TP[Var("v",
                                                                                            F32),
                                                                                        LN
                                                                                         4],
                                                                                     PTy(F32,
                                                                                         qTy)),
                                                                                  Close
                                                                                    (Var("x",
                                                                                         PTy(F32,
                                                                                             nTy)),
                                                                                     MD(Call
                                                                                          ("write'MemA",
                                                                                           ATy(qTy,
                                                                                               PTy(uTy,
                                                                                                   qTy)),
                                                                                           TP[LX F32,
                                                                                              Var("x",
                                                                                                  PTy(F32,
                                                                                                      nTy))]),
                                                                                        F32))),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MB(MR(Close
                                                                                          (Var("s",
                                                                                               PTy(F32,
                                                                                                   qTy)),
                                                                                           Dest
                                                                                             ("data_abort",
                                                                                              bTy,
                                                                                              Mop(Snd,
                                                                                                  Var("s",
                                                                                                      PTy(F32,
                                                                                                          qTy)))))),
                                                                                     Close
                                                                                       (bVar"v",
                                                                                        MB(MU(Mop(Not,
                                                                                                  bVar"v"),
                                                                                              PTy(F32,
                                                                                                  qTy)),
                                                                                           Close
                                                                                             (bVar"b",
                                                                                              ITE(bVar"b",
                                                                                                  MW(Close
                                                                                                       (Var("s",
                                                                                                            PTy(F32,
                                                                                                                qTy)),
                                                                                                        TP[Mop(Fst,
                                                                                                               Var("s",
                                                                                                                   PTy(F32,
                                                                                                                       qTy))),
                                                                                                           Rupd
                                                                                                             ("transfer_unknown",
                                                                                                              TP[Mop(Snd,
                                                                                                                     Var("s",
                                                                                                                         PTy(F32,
                                                                                                                             qTy))),
                                                                                                                 LT])])),
                                                                                                  MU(LU,
                                                                                                     PTy(F32,
                                                                                                         qTy))))))))))),
                                                                      MB(MR(Close
                                                                              (Var("s",
                                                                                   PTy(F32,
                                                                                       qTy)),
                                                                               Mop(Fst,
                                                                                   Var("s",
                                                                                       PTy(F32,
                                                                                           qTy))))),
                                                                         Close
                                                                           (Var("v",
                                                                                F32),
                                                                            MB(MU(TP[Var("v",
                                                                                         F32),
                                                                                     LN
                                                                                      4],
                                                                                  PTy(F32,
                                                                                      qTy)),
                                                                               Close
                                                                                 (Var("x",
                                                                                      PTy(F32,
                                                                                          nTy)),
                                                                                  MB(MD(Call
                                                                                          ("R",
                                                                                           ATy(qTy,
                                                                                               PTy(F32,
                                                                                                   qTy)),
                                                                                           Mop(Cast
                                                                                                 F4,
                                                                                               nVar"i")),
                                                                                        F32),
                                                                                     Close
                                                                                       (Var("v",
                                                                                            F32),
                                                                                        MB(MU(TP[Var("v",
                                                                                                     F32),
                                                                                                 Var("x",
                                                                                                     PTy(F32,
                                                                                                         nTy))],
                                                                                              PTy(F32,
                                                                                                  qTy)),
                                                                                           Close
                                                                                             (Var("v",
                                                                                                  PTy(F32,
                                                                                                      PTy(F32,
                                                                                                          nTy))),
                                                                                              MD(Call
                                                                                                   ("write'MemA",
                                                                                                    ATy(qTy,
                                                                                                        PTy(uTy,
                                                                                                            qTy)),
                                                                                                    Var("v",
                                                                                                        PTy(F32,
                                                                                                            PTy(F32,
                                                                                                                nTy)))),
                                                                                                 F32)))))))))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MB(MR(Close
                                                                             (Var("s",
                                                                                  PTy(F32,
                                                                                      qTy)),
                                                                              Mop(Fst,
                                                                                  Var("s",
                                                                                      PTy(F32,
                                                                                          qTy))))),
                                                                        Close
                                                                          (Var("v",
                                                                               F32),
                                                                           MB(MU(Bop(Add,
                                                                                     Var("v",
                                                                                         F32),
                                                                                     LW(4,
                                                                                        32)),
                                                                                 PTy(F32,
                                                                                     qTy)),
                                                                              Close
                                                                                (Var("v",
                                                                                     F32),
                                                                                 MW(Close
                                                                                      (Var("s",
                                                                                           PTy(F32,
                                                                                               qTy)),
                                                                                       TP[Var("v",
                                                                                              F32),
                                                                                          Mop(Snd,
                                                                                              Var("s",
                                                                                                  PTy(F32,
                                                                                                      qTy)))])))))))),
                                                               MU(LU,
                                                                  PTy(F32,
                                                                      qTy))))]),
                                                 Close
                                                   (AVar uTy,
                                                    MB(ITE(Bop(Bit,
                                                               Var("registers",
                                                                   F16),
                                                               LN 15),
                                                           MB(MR(Close
                                                                   (Var("s",
                                                                        PTy(F32,
                                                                            qTy)),
                                                                    Mop(Fst,
                                                                        Var("s",
                                                                            PTy(F32,
                                                                                qTy))))),
                                                              Close
                                                                (Var("v",
                                                                     F32),
                                                                 MB(MU(TP[Var("v",
                                                                              F32),
                                                                          LN
                                                                           4],
                                                                       PTy(F32,
                                                                           qTy)),
                                                                    Close
                                                                      (Var("x",
                                                                           PTy(F32,
                                                                               nTy)),
                                                                       MB(MD(Call
                                                                               ("PCStoreValue",
                                                                                ATy(qTy,
                                                                                    PTy(F32,
                                                                                        qTy)),
                                                                                LU),
                                                                             F32),
                                                                          Close
                                                                            (Var("v",
                                                                                 F32),
                                                                             MB(MU(TP[Var("v",
                                                                                          F32),
                                                                                      Var("x",
                                                                                          PTy(F32,
                                                                                              nTy))],
                                                                                   PTy(F32,
                                                                                       qTy)),
                                                                                Close
                                                                                  (Var("v",
                                                                                       PTy(F32,
                                                                                           PTy(F32,
                                                                                               nTy))),
                                                                                   MD(Call
                                                                                        ("write'MemA",
                                                                                         ATy(qTy,
                                                                                             PTy(uTy,
                                                                                                 qTy)),
                                                                                         Var("v",
                                                                                             PTy(F32,
                                                                                                 PTy(F32,
                                                                                                     nTy)))),
                                                                                      F32))))))))),
                                                           MU(LU,
                                                              PTy(F32,qTy))),
                                                       Close
                                                         (AVar uTy,
                                                          MB(MR(Close
                                                                  (Var("s",
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Dest
                                                                     ("data_abort",
                                                                      bTy,
                                                                      Mop(Snd,
                                                                          Var("s",
                                                                              PTy(F32,
                                                                                  qTy)))))),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    MB(MW(Close
                                                                            (Var("s",
                                                                                 PTy(F32,
                                                                                     qTy)),
                                                                             TP[Mop(Fst,
                                                                                    Var("s",
                                                                                        PTy(F32,
                                                                                            qTy))),
                                                                                Rupd
                                                                                  ("MEM",
                                                                                   TP[Mop(Snd,
                                                                                          Var("s",
                                                                                              PTy(F32,
                                                                                                  qTy))),
                                                                                      Var("omem",
                                                                                          ATy(F32,
                                                                                              F8))])])),
                                                                       Close
                                                                         (AVar
                                                                            uTy,
                                                                          MD(Call
                                                                               ("TakeDataAbortException",
                                                                                ATy(qTy,
                                                                                    PTy(uTy,
                                                                                        qTy)),
                                                                                LU),
                                                                             F32))),
                                                                    MB(ITE(bVar"wback",
                                                                           MD(Call
                                                                                ("write'R",
                                                                                 ATy(qTy,
                                                                                     PTy(uTy,
                                                                                         qTy)),
                                                                                 TP[ITE(bVar"increment",
                                                                                        Bop(Add,
                                                                                            Var("Rn",
                                                                                                F32),
                                                                                            Var("length",
                                                                                                F32)),
                                                                                        Bop(Sub,
                                                                                            Var("Rn",
                                                                                                F32),
                                                                                            Var("length",
                                                                                                F32))),
                                                                                    Var("n",
                                                                                        F4)]),
                                                                              F32),
                                                                           MU(LU,
                                                                              PTy(F32,
                                                                                  qTy))),
                                                                       Close
                                                                         (AVar
                                                                            uTy,
                                                                          MD(Call
                                                                               ("IncPC",
                                                                                ATy(qTy,
                                                                                    PTy(uTy,
                                                                                        qTy)),
                                                                                LU),
                                                                             F32))))))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreMultipleUserRegisters_def = Def
  ("dfn'StoreMultipleUserRegisters",
   TP[bVar"increment",bVar"wordhigher",Var("n",F4),Var("registers",F16)],
   MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",
                Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU),
                MU(LU,qTy)),
            Close
              (AVar uTy,
               MB(Call
                    ("CurrentModeIsUserOrSystem",ATy(qTy,PTy(bTy,qTy)),LU),
                  Close
                    (bVar"v",
                     MB(ITE(bVar"v",
                            Call
                              ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                               Call
                                 ("UNPREDICTABLE",CTy"exception",
                                  LS"StoreMultipleUserRegisters")),
                            MU(LU,qTy)),
                        Close
                          (AVar uTy,
                           MB(Call
                                ("BitCount",ATy(qTy,PTy(nTy,qTy)),
                                 Var("registers",F16)),
                              Close
                                (nVar"v",
                                 MB(MB(MU(Mop(Cast F32,nVar"v"),qTy),
                                       Close
                                         (Var("v",F32),
                                          MU(Bop(Mul,LW(4,32),Var("v",F32)),
                                             qTy))),
                                    Close
                                      (Var("length",F32),
                                       MB(ITE(bVar"increment",
                                              Call
                                                ("R",
                                                 ATy(qTy,PTy(F32,qTy)),
                                                 Var("n",F4)),
                                              MB(Call
                                                   ("R",
                                                    ATy(qTy,PTy(F32,qTy)),
                                                    Var("n",F4)),
                                                 Close
                                                   (Var("v",F32),
                                                    MU(Bop(Sub,
                                                           Var("v",F32),
                                                           Var("length",
                                                               F32)),qTy)))),
                                          Close
                                            (Var("v",F32),
                                             MN(Var("v",F32),
                                                MB(ITE(bVar"wordhigher",
                                                       MB(MR(Close
                                                               (Var("s",
                                                                    PTy(F32,
                                                                        qTy)),
                                                                Mop(Fst,
                                                                    Var("s",
                                                                        PTy(F32,
                                                                            qTy))))),
                                                          Close
                                                            (Var("v",F32),
                                                             MB(MU(Bop(Add,
                                                                       Var("v",
                                                                           F32),
                                                                       LW(4,
                                                                          32)),
                                                                   PTy(F32,
                                                                       qTy)),
                                                                Close
                                                                  (Var("v",
                                                                       F32),
                                                                   MW(Close
                                                                        (Var("s",
                                                                             PTy(F32,
                                                                                 qTy)),
                                                                         TP[Var("v",
                                                                                F32),
                                                                            Mop(Snd,
                                                                                Var("s",
                                                                                    PTy(F32,
                                                                                        qTy)))])))))),
                                                       MU(LU,PTy(F32,qTy))),
                                                   Close
                                                     (AVar uTy,
                                                      MB(MR(Close
                                                              (Var("s",
                                                                   PTy(F32,
                                                                       qTy)),
                                                               Dest
                                                                 ("MEM",
                                                                  ATy(F32,
                                                                      F8),
                                                                  Mop(Snd,
                                                                      Var("s",
                                                                          PTy(F32,
                                                                              qTy)))))),
                                                         Close
                                                           (Var("omem",
                                                                ATy(F32,F8)),
                                                            MB(For(TP[LN 0,
                                                                      LN
                                                                       14,
                                                                      Close
                                                                        (nVar"i",
                                                                         ITE(Bop(Bit,
                                                                                 Var("registers",
                                                                                     F16),
                                                                                 Mop(Cast
                                                                                       nTy,
                                                                                     nVar"i")),
                                                                             MB(MR(Close
                                                                                     (Var("s",
                                                                                          PTy(F32,
                                                                                              qTy)),
                                                                                      Mop(Fst,
                                                                                          Var("s",
                                                                                              PTy(F32,
                                                                                                  qTy))))),
                                                                                Close
                                                                                  (Var("v",
                                                                                       F32),
                                                                                   MB(MB(MU(TP[Var("v",
                                                                                                   F32),
                                                                                               LN
                                                                                                4],
                                                                                            PTy(F32,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (Var("x",
                                                                                                PTy(F32,
                                                                                                    nTy)),
                                                                                            MB(MD(Call
                                                                                                    ("Rmode",
                                                                                                     ATy(qTy,
                                                                                                         PTy(F32,
                                                                                                             qTy)),
                                                                                                     TP[Mop(Cast
                                                                                                              F4,
                                                                                                            nVar"i"),
                                                                                                        LW(16,
                                                                                                           5)]),
                                                                                                  F32),
                                                                                               Close
                                                                                                 (Var("v",
                                                                                                      F32),
                                                                                                  MB(MU(TP[Var("v",
                                                                                                               F32),
                                                                                                           Var("x",
                                                                                                               PTy(F32,
                                                                                                                   nTy))],
                                                                                                        PTy(F32,
                                                                                                            qTy)),
                                                                                                     Close
                                                                                                       (Var("v",
                                                                                                            PTy(F32,
                                                                                                                PTy(F32,
                                                                                                                    nTy))),
                                                                                                        MD(Call
                                                                                                             ("write'MemA",
                                                                                                              ATy(qTy,
                                                                                                                  PTy(uTy,
                                                                                                                      qTy)),
                                                                                                              Var("v",
                                                                                                                  PTy(F32,
                                                                                                                      PTy(F32,
                                                                                                                          nTy)))),
                                                                                                           F32))))))),
                                                                                      Close
                                                                                        (AVar
                                                                                           uTy,
                                                                                         MB(MR(Close
                                                                                                 (Var("s",
                                                                                                      PTy(F32,
                                                                                                          qTy)),
                                                                                                  Mop(Fst,
                                                                                                      Var("s",
                                                                                                          PTy(F32,
                                                                                                              qTy))))),
                                                                                            Close
                                                                                              (Var("v",
                                                                                                   F32),
                                                                                               MB(MU(Bop(Add,
                                                                                                         Var("v",
                                                                                                             F32),
                                                                                                         LW(4,
                                                                                                            32)),
                                                                                                     PTy(F32,
                                                                                                         qTy)),
                                                                                                  Close
                                                                                                    (Var("v",
                                                                                                         F32),
                                                                                                     MW(Close
                                                                                                          (Var("s",
                                                                                                               PTy(F32,
                                                                                                                   qTy)),
                                                                                                           TP[Var("v",
                                                                                                                  F32),
                                                                                                              Mop(Snd,
                                                                                                                  Var("s",
                                                                                                                      PTy(F32,
                                                                                                                          qTy)))])))))))))),
                                                                             MU(LU,
                                                                                PTy(F32,
                                                                                    qTy))))]),
                                                               Close
                                                                 (AVar uTy,
                                                                  MB(ITE(Bop(Bit,
                                                                             Var("registers",
                                                                                 F16),
                                                                             LN
                                                                              15),
                                                                         MB(MR(Close
                                                                                 (Var("s",
                                                                                      PTy(F32,
                                                                                          qTy)),
                                                                                  Mop(Fst,
                                                                                      Var("s",
                                                                                          PTy(F32,
                                                                                              qTy))))),
                                                                            Close
                                                                              (Var("v",
                                                                                   F32),
                                                                               MB(MU(TP[Var("v",
                                                                                            F32),
                                                                                        LN
                                                                                         4],
                                                                                     PTy(F32,
                                                                                         qTy)),
                                                                                  Close
                                                                                    (Var("x",
                                                                                         PTy(F32,
                                                                                             nTy)),
                                                                                     MB(MD(Call
                                                                                             ("PCStoreValue",
                                                                                              ATy(qTy,
                                                                                                  PTy(F32,
                                                                                                      qTy)),
                                                                                              LU),
                                                                                           F32),
                                                                                        Close
                                                                                          (Var("v",
                                                                                               F32),
                                                                                           MB(MU(TP[Var("v",
                                                                                                        F32),
                                                                                                    Var("x",
                                                                                                        PTy(F32,
                                                                                                            nTy))],
                                                                                                 PTy(F32,
                                                                                                     qTy)),
                                                                                              Close
                                                                                                (Var("v",
                                                                                                     PTy(F32,
                                                                                                         PTy(F32,
                                                                                                             nTy))),
                                                                                                 MD(Call
                                                                                                      ("write'MemA",
                                                                                                       ATy(qTy,
                                                                                                           PTy(uTy,
                                                                                                               qTy)),
                                                                                                       Var("v",
                                                                                                           PTy(F32,
                                                                                                               PTy(F32,
                                                                                                                   nTy)))),
                                                                                                    F32))))))))),
                                                                         MU(LU,
                                                                            PTy(F32,
                                                                                qTy))),
                                                                     Close
                                                                       (AVar
                                                                          uTy,
                                                                        MB(MR(Close
                                                                                (Var("s",
                                                                                     PTy(F32,
                                                                                         qTy)),
                                                                                 Dest
                                                                                   ("data_abort",
                                                                                    bTy,
                                                                                    Mop(Snd,
                                                                                        Var("s",
                                                                                            PTy(F32,
                                                                                                qTy)))))),
                                                                           Close
                                                                             (bVar"b",
                                                                              ITE(bVar"b",
                                                                                  MB(MW(Close
                                                                                          (Var("s",
                                                                                               PTy(F32,
                                                                                                   qTy)),
                                                                                           TP[Mop(Fst,
                                                                                                  Var("s",
                                                                                                      PTy(F32,
                                                                                                          qTy))),
                                                                                              Rupd
                                                                                                ("MEM",
                                                                                                 TP[Mop(Snd,
                                                                                                        Var("s",
                                                                                                            PTy(F32,
                                                                                                                qTy))),
                                                                                                    Var("omem",
                                                                                                        ATy(F32,
                                                                                                            F8))])])),
                                                                                     Close
                                                                                       (AVar
                                                                                          uTy,
                                                                                        MD(Call
                                                                                             ("TakeDataAbortException",
                                                                                              ATy(qTy,
                                                                                                  PTy(uTy,
                                                                                                      qTy)),
                                                                                              LU),
                                                                                           F32))),
                                                                                  MD(Call
                                                                                       ("IncPC",
                                                                                        ATy(qTy,
                                                                                            PTy(uTy,
                                                                                                qTy)),
                                                                                        LU),
                                                                                     F32))))))))))))))))))))))))))))
;
val dfn'StoreDual_def = Def
  ("dfn'StoreDual",
   TP[bVar"add",bVar"index",bVar"wback",Var("t",F4),Var("t2",F4),
      Var("n",F4),Var("m",CTy"offset2")],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("Rn",F32),
                   MB(CS(Var("m",CTy"offset2"),
                         [(Call("register_form2",CTy"offset2",Var("m",F4)),
                           Call("R",ATy(qTy,PTy(F32,qTy)),Var("m",F4))),
                          (Call
                             ("immediate_form2",CTy"offset2",
                              Var("imm32",F32)),MU(Var("imm32",F32),qTy))]),
                      Close
                        (Var("offset",F32),
                         Let(Var("offset_addr",F32),
                             ITE(bVar"add",
                                 Bop(Add,Var("Rn",F32),Var("offset",F32)),
                                 Bop(Sub,Var("Rn",F32),Var("offset",F32))),
                             Let(Var("address",F32),
                                 ITE(bVar"index",Var("offset_addr",F32),
                                     Var("Rn",F32)),
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest("MEM",ATy(F32,F8),qVar"s"))),
                                    Close
                                      (Var("omem",ATy(F32,F8)),
                                       MB(MB(Call
                                               ("R",ATy(qTy,PTy(F32,qTy)),
                                                Var("t",F4)),
                                             Close
                                               (Var("v",F32),
                                                MB(MU(TP[Var("v",F32),
                                                         Var("address",F32),
                                                         LN 4],qTy),
                                                   Close
                                                     (Var("v",
                                                          PTy(F32,
                                                              PTy(F32,nTy))),
                                                      Call
                                                        ("write'MemA",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         Var("v",
                                                             PTy(F32,
                                                                 PTy(F32,
                                                                     nTy)))))))),
                                          Close
                                            (AVar uTy,
                                             MB(MB(Call
                                                     ("R",
                                                      ATy(qTy,PTy(F32,qTy)),
                                                      Var("t2",F4)),
                                                   Close
                                                     (Var("v",F32),
                                                      MB(MU(TP[Var("v",F32),
                                                               Bop(Add,
                                                                   Var("address",
                                                                       F32),
                                                                   LW(4,32)),
                                                               LN 4],qTy),
                                                         Close
                                                           (Var("v",
                                                                PTy(F32,
                                                                    PTy(F32,
                                                                        nTy))),
                                                            Call
                                                              ("write'MemA",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F32,
                                                                       PTy(F32,
                                                                           nTy)))))))),
                                                Close
                                                  (AVar uTy,
                                                   MB(MR(Close
                                                           (qVar"s",
                                                            Dest
                                                              ("data_abort",
                                                               bTy,qVar"s"))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(MW(Close
                                                                     (qVar"s",
                                                                      Rupd
                                                                        ("MEM",
                                                                         TP[qVar"s",
                                                                            Var("omem",
                                                                                ATy(F32,
                                                                                    F8))]))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("TakeDataAbortException",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      LU))),
                                                             MB(ITE(bVar"wback",
                                                                    Call
                                                                      ("write'R",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("offset_addr",
                                                                              F32),
                                                                          Var("n",
                                                                              F4)]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   Call
                                                                     ("IncPC",
                                                                      ATy(qTy,
                                                                          PTy(uTy,
                                                                              qTy)),
                                                                      LU)))))))))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreExclusive_def = Def
  ("dfn'StoreExclusive",
   TP[Var("d",F4),Var("t",F4),Var("n",F4),Var("imm32",F32)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("v",F32),
                   MB(MU(Bop(Add,Var("v",F32),Var("imm32",F32)),qTy),
                      Close
                        (Var("address",F32),
                         MB(MR(Close
                                 (qVar"s",
                                  Dest
                                    ("ExclusiveMonitorsPass",
                                     ATy(PTy(F32,
                                             PTy(nTy,
                                                 PTy(LTy(STy F32),
                                                     STy(PTy(F32,nTy))))),
                                         bTy),qVar"s"))),
                            Close
                              (Var("v",
                                   ATy(PTy(F32,
                                           PTy(nTy,
                                               PTy(LTy(STy F32),
                                                   STy(PTy(F32,nTy))))),
                                       bTy)),
                               MB(MB(MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("exclusive_state",
                                                 PTy(LTy(STy F32),
                                                     STy(PTy(F32,nTy))),
                                                 qVar"s"))),
                                        Close
                                          (Var("v0",
                                               PTy(LTy(STy F32),
                                                   STy(PTy(F32,nTy)))),
                                           MB(MB(MU(TP[LN 4,
                                                       Var("v0",
                                                           PTy(LTy(STy F32),
                                                               STy(PTy(F32,
                                                                       nTy))))],
                                                    qTy),
                                                 Close
                                                   (Var("v",
                                                        PTy(nTy,
                                                            PTy(LTy(STy F32),
                                                                STy(PTy(F32,
                                                                        nTy))))),
                                                    MU(TP[Var("address",
                                                              F32),
                                                          Var("v",
                                                              PTy(nTy,
                                                                  PTy(LTy(STy F32),
                                                                      STy(PTy(F32,
                                                                              nTy)))))],
                                                       qTy))),
                                              Close
                                                (Var("v0",
                                                     PTy(F32,
                                                         PTy(nTy,
                                                             PTy(LTy(STy F32),
                                                                 STy(PTy(F32,
                                                                         nTy)))))),
                                                 MU(Apply
                                                      (Var("v",
                                                           ATy(PTy(F32,
                                                                   PTy(nTy,
                                                                       PTy(LTy(STy F32),
                                                                           STy(PTy(F32,
                                                                                   nTy))))),
                                                               bTy)),
                                                       Var("v0",
                                                           PTy(F32,
                                                               PTy(nTy,
                                                                   PTy(LTy(STy F32),
                                                                       STy(PTy(F32,
                                                                               nTy))))))),
                                                    qTy))))),
                                     Close
                                       (bVar"b",
                                        ITE(bVar"b",
                                            MB(MB(Call
                                                    ("R",
                                                     ATy(qTy,PTy(F32,qTy)),
                                                     Var("t",F4)),
                                                  Close
                                                    (Var("v",F32),
                                                     MB(MU(TP[Var("v",F32),
                                                              Var("address",
                                                                  F32),
                                                              LN 4],qTy),
                                                        Close
                                                          (Var("v",
                                                               PTy(F32,
                                                                   PTy(F32,
                                                                       nTy))),
                                                           Call
                                                             ("write'MemA",
                                                              ATy(qTy,
                                                                  PTy(uTy,
                                                                      qTy)),
                                                              Var("v",
                                                                  PTy(F32,
                                                                      PTy(F32,
                                                                          nTy)))))))),
                                               Close
                                                 (AVar uTy,
                                                  MB(MR(Close
                                                          (qVar"s",
                                                           Dest
                                                             ("data_abort",
                                                              bTy,qVar"s"))),
                                                     Close
                                                       (bVar"v",
                                                        MB(MU(Mop(Not,
                                                                  bVar"v"),
                                                              qTy),
                                                           Close
                                                             (bVar"b",
                                                              ITE(bVar"b",
                                                                  Call
                                                                    ("write'R",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[LW(0,
                                                                           32),
                                                                        Var("d",
                                                                            F4)]),
                                                                  MU(LU,
                                                                     qTy)))))))),
                                            Call
                                              ("write'R",
                                               ATy(qTy,PTy(uTy,qTy)),
                                               TP[LW(1,32),Var("d",F4)])))),
                                  Close
                                    (AVar uTy,
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("data_abort",bTy,qVar"s"))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               Call
                                                 ("TakeDataAbortException",
                                                  ATy(qTy,PTy(uTy,qTy)),LU),
                                               Call
                                                 ("IncPC",
                                                  ATy(qTy,PTy(uTy,qTy)),LU)))))))))))),
             MU(LU,qTy)))))
;
val dfn'StoreExclusiveByte_def = Def
  ("dfn'StoreExclusiveByte",TP[Var("d",F4),Var("t",F4),Var("n",F4)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("address",F32),
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("ExclusiveMonitorsPass",
                               ATy(PTy(F32,
                                       PTy(nTy,
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))))),bTy),
                               qVar"s"))),
                      Close
                        (Var("v",
                             ATy(PTy(F32,
                                     PTy(nTy,
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy))))),bTy)),
                         MB(MB(MB(MR(Close
                                       (qVar"s",
                                        Dest
                                          ("exclusive_state",
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))),qVar"s"))),
                                  Close
                                    (Var("v0",
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy)))),
                                     MB(MB(MU(TP[LN 1,
                                                 Var("v0",
                                                     PTy(LTy(STy F32),
                                                         STy(PTy(F32,nTy))))],
                                              qTy),
                                           Close
                                             (Var("v",
                                                  PTy(nTy,
                                                      PTy(LTy(STy F32),
                                                          STy(PTy(F32,nTy))))),
                                              MU(TP[Var("address",F32),
                                                    Var("v",
                                                        PTy(nTy,
                                                            PTy(LTy(STy F32),
                                                                STy(PTy(F32,
                                                                        nTy)))))],
                                                 qTy))),
                                        Close
                                          (Var("v0",
                                               PTy(F32,
                                                   PTy(nTy,
                                                       PTy(LTy(STy F32),
                                                           STy(PTy(F32,nTy)))))),
                                           MU(Apply
                                                (Var("v",
                                                     ATy(PTy(F32,
                                                             PTy(nTy,
                                                                 PTy(LTy(STy F32),
                                                                     STy(PTy(F32,
                                                                             nTy))))),
                                                         bTy)),
                                                 Var("v0",
                                                     PTy(F32,
                                                         PTy(nTy,
                                                             PTy(LTy(STy F32),
                                                                 STy(PTy(F32,
                                                                         nTy))))))),
                                              qTy))))),
                               Close
                                 (bVar"b",
                                  ITE(bVar"b",
                                      MB(MB(Call
                                              ("R",ATy(qTy,PTy(F32,qTy)),
                                               Var("t",F4)),
                                            Close
                                              (Var("v",F32),
                                               MB(MB(MU(EX(Var("v",F32),
                                                           LN 7,LN 0,F8),
                                                        qTy),
                                                     Close
                                                       (Var("v",F8),
                                                        MU(TP[Var("v",F8),
                                                              Var("address",
                                                                  F32),
                                                              LN 1],qTy))),
                                                  Close
                                                    (Var("v",
                                                         PTy(F8,
                                                             PTy(F32,nTy))),
                                                     Call
                                                       ("write'MemA",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        Var("v",
                                                            PTy(F8,
                                                                PTy(F32,
                                                                    nTy)))))))),
                                         Close
                                           (AVar uTy,
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("data_abort",bTy,
                                                        qVar"s"))),
                                               Close
                                                 (bVar"v",
                                                  MB(MU(Mop(Not,bVar"v"),
                                                        qTy),
                                                     Close
                                                       (bVar"b",
                                                        ITE(bVar"b",
                                                            Call
                                                              ("write'R",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[LW(0,32),
                                                                  Var("d",
                                                                      F4)]),
                                                            MU(LU,qTy)))))))),
                                      Call
                                        ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                         TP[LW(1,32),Var("d",F4)])))),
                            Close
                              (AVar uTy,
                               MB(MR(Close
                                       (qVar"s",
                                        Dest("data_abort",bTy,qVar"s"))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         Call
                                           ("TakeDataAbortException",
                                            ATy(qTy,PTy(uTy,qTy)),LU),
                                         Call
                                           ("IncPC",ATy(qTy,PTy(uTy,qTy)),
                                            LU)))))))))),MU(LU,qTy)))))
;
val dfn'StoreExclusiveHalf_def = Def
  ("dfn'StoreExclusiveHalf",TP[Var("d",F4),Var("t",F4),Var("n",F4)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("address",F32),
                   MB(MR(Close
                           (qVar"s",
                            Dest
                              ("ExclusiveMonitorsPass",
                               ATy(PTy(F32,
                                       PTy(nTy,
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))))),bTy),
                               qVar"s"))),
                      Close
                        (Var("v",
                             ATy(PTy(F32,
                                     PTy(nTy,
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy))))),bTy)),
                         MB(MB(MB(MR(Close
                                       (qVar"s",
                                        Dest
                                          ("exclusive_state",
                                           PTy(LTy(STy F32),
                                               STy(PTy(F32,nTy))),qVar"s"))),
                                  Close
                                    (Var("v0",
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy)))),
                                     MB(MB(MU(TP[LN 2,
                                                 Var("v0",
                                                     PTy(LTy(STy F32),
                                                         STy(PTy(F32,nTy))))],
                                              qTy),
                                           Close
                                             (Var("v",
                                                  PTy(nTy,
                                                      PTy(LTy(STy F32),
                                                          STy(PTy(F32,nTy))))),
                                              MU(TP[Var("address",F32),
                                                    Var("v",
                                                        PTy(nTy,
                                                            PTy(LTy(STy F32),
                                                                STy(PTy(F32,
                                                                        nTy)))))],
                                                 qTy))),
                                        Close
                                          (Var("v0",
                                               PTy(F32,
                                                   PTy(nTy,
                                                       PTy(LTy(STy F32),
                                                           STy(PTy(F32,nTy)))))),
                                           MU(Apply
                                                (Var("v",
                                                     ATy(PTy(F32,
                                                             PTy(nTy,
                                                                 PTy(LTy(STy F32),
                                                                     STy(PTy(F32,
                                                                             nTy))))),
                                                         bTy)),
                                                 Var("v0",
                                                     PTy(F32,
                                                         PTy(nTy,
                                                             PTy(LTy(STy F32),
                                                                 STy(PTy(F32,
                                                                         nTy))))))),
                                              qTy))))),
                               Close
                                 (bVar"b",
                                  ITE(bVar"b",
                                      MB(MB(Call
                                              ("R",ATy(qTy,PTy(F32,qTy)),
                                               Var("t",F4)),
                                            Close
                                              (Var("v",F32),
                                               MB(MB(MU(EX(Var("v",F32),
                                                           LN 15,LN 0,F16),
                                                        qTy),
                                                     Close
                                                       (Var("v",F16),
                                                        MU(TP[Var("v",F16),
                                                              Var("address",
                                                                  F32),
                                                              LN 2],qTy))),
                                                  Close
                                                    (Var("v",
                                                         PTy(F16,
                                                             PTy(F32,nTy))),
                                                     Call
                                                       ("write'MemA",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        Var("v",
                                                            PTy(F16,
                                                                PTy(F32,
                                                                    nTy)))))))),
                                         Close
                                           (AVar uTy,
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("data_abort",bTy,
                                                        qVar"s"))),
                                               Close
                                                 (bVar"v",
                                                  MB(MU(Mop(Not,bVar"v"),
                                                        qTy),
                                                     Close
                                                       (bVar"b",
                                                        ITE(bVar"b",
                                                            Call
                                                              ("write'R",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[LW(0,32),
                                                                  Var("d",
                                                                      F4)]),
                                                            MU(LU,qTy)))))))),
                                      Call
                                        ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                         TP[LW(1,32),Var("d",F4)])))),
                            Close
                              (AVar uTy,
                               MB(MR(Close
                                       (qVar"s",
                                        Dest("data_abort",bTy,qVar"s"))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         Call
                                           ("TakeDataAbortException",
                                            ATy(qTy,PTy(uTy,qTy)),LU),
                                         Call
                                           ("IncPC",ATy(qTy,PTy(uTy,qTy)),
                                            LU)))))))))),MU(LU,qTy)))))
;
val dfn'StoreExclusiveDoubleword_def = Def
  ("dfn'StoreExclusiveDoubleword",
   TP[Var("d",F4),Var("t",F4),Var("t2",F4),Var("n",F4)],
   MB(Call("NullCheckIfThumbEE",ATy(qTy,PTy(bTy,qTy)),Var("n",F4)),
      Close
        (bVar"b",
         ITE(bVar"b",
             MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                Close
                  (Var("address",F32),
                   MB(Call("BigEndian",ATy(qTy,PTy(bTy,qTy)),LU),
                      Close
                        (bVar"v",
                         MB(ITE(bVar"v",
                                MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("t",F4)),
                                   Close
                                     (Var("v",F32),
                                      MB(Call
                                           ("R",ATy(qTy,PTy(F32,qTy)),
                                            Var("t2",F4)),
                                         Close
                                           (Var("v0",F32),
                                            MU(CC[Var("v",F32),
                                                  Var("v0",F32)],qTy))))),
                                MB(Call
                                     ("R",ATy(qTy,PTy(F32,qTy)),
                                      Var("t2",F4)),
                                   Close
                                     (Var("v",F32),
                                      MB(Call
                                           ("R",ATy(qTy,PTy(F32,qTy)),
                                            Var("t",F4)),
                                         Close
                                           (Var("v0",F32),
                                            MU(CC[Var("v",F32),
                                                  Var("v0",F32)],qTy)))))),
                            Close
                              (Var("value",F64),
                               MB(MR(Close
                                       (qVar"s",
                                        Dest
                                          ("ExclusiveMonitorsPass",
                                           ATy(PTy(F32,
                                                   PTy(nTy,
                                                       PTy(LTy(STy F32),
                                                           STy(PTy(F32,nTy))))),
                                               bTy),qVar"s"))),
                                  Close
                                    (Var("v",
                                         ATy(PTy(F32,
                                                 PTy(nTy,
                                                     PTy(LTy(STy F32),
                                                         STy(PTy(F32,nTy))))),
                                             bTy)),
                                     MB(MB(MB(MR(Close
                                                   (qVar"s",
                                                    Dest
                                                      ("exclusive_state",
                                                       PTy(LTy(STy F32),
                                                           STy(PTy(F32,nTy))),
                                                       qVar"s"))),
                                              Close
                                                (Var("v0",
                                                     PTy(LTy(STy F32),
                                                         STy(PTy(F32,nTy)))),
                                                 MB(MB(MU(TP[LN 8,
                                                             Var("v0",
                                                                 PTy(LTy(STy F32),
                                                                     STy(PTy(F32,
                                                                             nTy))))],
                                                          qTy),
                                                       Close
                                                         (Var("v",
                                                              PTy(nTy,
                                                                  PTy(LTy(STy F32),
                                                                      STy(PTy(F32,
                                                                              nTy))))),
                                                          MU(TP[Var("address",
                                                                    F32),
                                                                Var("v",
                                                                    PTy(nTy,
                                                                        PTy(LTy(STy F32),
                                                                            STy(PTy(F32,
                                                                                    nTy)))))],
                                                             qTy))),
                                                    Close
                                                      (Var("v0",
                                                           PTy(F32,
                                                               PTy(nTy,
                                                                   PTy(LTy(STy F32),
                                                                       STy(PTy(F32,
                                                                               nTy)))))),
                                                       MU(Apply
                                                            (Var("v",
                                                                 ATy(PTy(F32,
                                                                         PTy(nTy,
                                                                             PTy(LTy(STy F32),
                                                                                 STy(PTy(F32,
                                                                                         nTy))))),
                                                                     bTy)),
                                                             Var("v0",
                                                                 PTy(F32,
                                                                     PTy(nTy,
                                                                         PTy(LTy(STy F32),
                                                                             STy(PTy(F32,
                                                                                     nTy))))))),
                                                          qTy))))),
                                           Close
                                             (bVar"b",
                                              ITE(bVar"b",
                                                  MB(Call
                                                       ("write'MemA",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        TP[Var("value",F64),
                                                           Var("address",
                                                               F32),LN 8]),
                                                     Close
                                                       (AVar uTy,
                                                        MB(MR(Close
                                                                (qVar"s",
                                                                 Dest
                                                                   ("data_abort",
                                                                    bTy,
                                                                    qVar"s"))),
                                                           Close
                                                             (bVar"v",
                                                              MB(MU(Mop(Not,
                                                                        bVar"v"),
                                                                    qTy),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        Call
                                                                          ("write'R",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[LW(0,
                                                                                 32),
                                                                              Var("d",
                                                                                  F4)]),
                                                                        MU(LU,
                                                                           qTy)))))))),
                                                  Call
                                                    ("write'R",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[LW(1,32),
                                                        Var("d",F4)])))),
                                        Close
                                          (AVar uTy,
                                           MB(MR(Close
                                                   (qVar"s",
                                                    Dest
                                                      ("data_abort",bTy,
                                                       qVar"s"))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     Call
                                                       ("TakeDataAbortException",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        LU),
                                                     Call
                                                       ("IncPC",
                                                        ATy(qTy,
                                                            PTy(uTy,qTy)),
                                                        LU)))))))))))))),
             MU(LU,qTy)))))
;
val dfn'ClearExclusive_def = Def0
  ("dfn'ClearExclusive",
   MB(MR(Close
           (qVar"s",
            Dest
              ("ClearExclusiveLocal",
               ATy(PTy(iTy,PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                   PTy(LTy(STy F32),STy(PTy(F32,nTy)))),qVar"s"))),
      Close
        (Var("v",
             ATy(PTy(iTy,PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                 PTy(LTy(STy F32),STy(PTy(F32,nTy))))),
         MB(MB(MB(MR(Close
                       (qVar"s",
                        Dest
                          ("exclusive_state",
                           PTy(LTy(STy F32),STy(PTy(F32,nTy))),qVar"s"))),
                  Close
                    (Var("v0",PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                     MB(MU(TP[Call("ProcessorID",iTy,LU),
                              Var("v0",PTy(LTy(STy F32),STy(PTy(F32,nTy))))],
                           qTy),
                        Close
                          (Var("v0",
                               PTy(iTy,PTy(LTy(STy F32),STy(PTy(F32,nTy))))),
                           MU(Apply
                                (Var("v",
                                     ATy(PTy(iTy,
                                             PTy(LTy(STy F32),
                                                 STy(PTy(F32,nTy)))),
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy))))),
                                 Var("v0",
                                     PTy(iTy,
                                         PTy(LTy(STy F32),
                                             STy(PTy(F32,nTy)))))),qTy))))),
               Close
                 (Var("v",PTy(LTy(STy F32),STy(PTy(F32,nTy)))),
                  MW(Close
                       (qVar"s",
                        Rupd
                          ("exclusive_state",
                           TP[qVar"s",
                              Var("v",PTy(LTy(STy F32),STy(PTy(F32,nTy))))]))))),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'Swap_def = Def
  ("dfn'Swap",TP[bVar"b",Var("t",F4),Var("t2",F4),Var("n",F4)],
   MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
      Close
        (Var("Rn",F32),
         MB(ITE(bVar"b",
                MB(Call
                     ("MemA",ATy(qTy,PTy(F8,qTy)),TP[Var("Rn",F32),LN 1]),
                   Close
                     (Var("data",F8),
                      MB(MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("t2",F4)),
                            Close
                              (Var("v",F32),
                               MB(MB(MU(EX(Var("v",F32),LN 7,LN 0,F8),qTy),
                                     Close
                                       (Var("v",F8),
                                        MU(TP[Var("v",F8),Var("Rn",F32),
                                              LN 1],qTy))),
                                  Close
                                    (Var("v",PTy(F8,PTy(F32,nTy))),
                                     Call
                                       ("write'MemA",
                                        ATy(qTy,PTy(uTy,qTy)),
                                        Var("v",PTy(F8,PTy(F32,nTy)))))))),
                         Close
                           (AVar uTy,
                            Call
                              ("write'R",ATy(qTy,PTy(uTy,qTy)),
                               TP[Mop(Cast F32,Var("data",F8)),Var("t",F4)]))))),
                MB(Call
                     ("MemA",ATy(qTy,PTy(F32,qTy)),TP[Var("Rn",F32),LN 4]),
                   Close
                     (Var("data",F32),
                      MB(MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("t2",F4)),
                            Close
                              (Var("v",F32),
                               MB(MU(TP[Var("v",F32),Var("Rn",F32),LN 4],
                                     qTy),
                                  Close
                                    (Var("v",PTy(F32,PTy(F32,nTy))),
                                     Call
                                       ("write'MemA",
                                        ATy(qTy,PTy(uTy,qTy)),
                                        Var("v",PTy(F32,PTy(F32,nTy)))))))),
                         Close
                           (AVar uTy,
                            MB(Call
                                 ("ROR",ATy(qTy,PTy(F32,qTy)),
                                  TP[Var("data",F32),
                                     Bop(Mul,LN 8,
                                         Mop(Cast nTy,
                                             EX(Var("Rn",F32),LN 1,LN 0,
                                                FTy 2)))]),
                               Close
                                 (Var("v",F32),
                                  MB(MU(TP[Var("v",F32),Var("t",F4)],qTy),
                                     Close
                                       (Var("v",PTy(F32,F4)),
                                        Call
                                          ("write'R",
                                           ATy(qTy,PTy(uTy,qTy)),
                                           Var("v",PTy(F32,F4)))))))))))),
            Close
              (AVar uTy,
               MB(MR(Close(qVar"s",Dest("data_abort",bTy,qVar"s"))),
                  Close
                    (bVar"b",
                     ITE(bVar"b",
                         Call
                           ("TakeDataAbortException",
                            ATy(qTy,PTy(uTy,qTy)),LU),
                         Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))))
;
val doChangeProcessorState_def = Def
  ("doChangeProcessorState",
   TP[bVar"enable",bVar"disable",bVar"affectA",bVar"affectI",
      bVar"affectF",bVar"changemode",Var("mode",FTy 5)],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",
                MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                   Close
                     (Var("v",CTy"PSR"),
                      MN(Var("v",CTy"PSR"),
                         MB(ITE(bVar"enable",
                                MB(ITE(bVar"affectA",
                                       MB(MR(Close
                                               (Var("s",PTy(CTy"PSR",qTy)),
                                                Mop(Fst,
                                                    Var("s",
                                                        PTy(CTy"PSR",qTy))))),
                                          Close
                                            (Var("v",CTy"PSR"),
                                             MB(MB(MU(TP[Var("v",CTy"PSR"),
                                                         LF],
                                                      PTy(CTy"PSR",qTy)),
                                                   Close
                                                     (Var("v",
                                                          PTy(CTy"PSR",bTy)),
                                                      MU(Rupd
                                                           ("A",
                                                            Var("v",
                                                                PTy(CTy"PSR",
                                                                    bTy))),
                                                         PTy(CTy"PSR",qTy)))),
                                                Close
                                                  (Var("v",CTy"PSR"),
                                                   MW(Close
                                                        (Var("s",
                                                             PTy(CTy"PSR",
                                                                 qTy)),
                                                         TP[Var("v",
                                                                CTy"PSR"),
                                                            Mop(Snd,
                                                                Var("s",
                                                                    PTy(CTy"PSR",
                                                                        qTy)))])))))),
                                       MU(LU,PTy(CTy"PSR",qTy))),
                                   Close
                                     (AVar uTy,
                                      MB(ITE(bVar"affectI",
                                             MB(MR(Close
                                                     (Var("s",
                                                          PTy(CTy"PSR",qTy)),
                                                      Mop(Fst,
                                                          Var("s",
                                                              PTy(CTy"PSR",
                                                                  qTy))))),
                                                Close
                                                  (Var("v",CTy"PSR"),
                                                   MB(MB(MU(TP[Var("v",
                                                                   CTy"PSR"),
                                                               LF],
                                                            PTy(CTy"PSR",
                                                                qTy)),
                                                         Close
                                                           (Var("v",
                                                                PTy(CTy"PSR",
                                                                    bTy)),
                                                            MU(Rupd
                                                                 ("I",
                                                                  Var("v",
                                                                      PTy(CTy"PSR",
                                                                          bTy))),
                                                               PTy(CTy"PSR",
                                                                   qTy)))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MW(Close
                                                              (Var("s",
                                                                   PTy(CTy"PSR",
                                                                       qTy)),
                                                               TP[Var("v",
                                                                      CTy"PSR"),
                                                                  Mop(Snd,
                                                                      Var("s",
                                                                          PTy(CTy"PSR",
                                                                              qTy)))])))))),
                                             MU(LU,PTy(CTy"PSR",qTy))),
                                         Close
                                           (AVar uTy,
                                            ITE(bVar"affectF",
                                                MB(MR(Close
                                                        (Var("s",
                                                             PTy(CTy"PSR",
                                                                 qTy)),
                                                         Mop(Fst,
                                                             Var("s",
                                                                 PTy(CTy"PSR",
                                                                     qTy))))),
                                                   Close
                                                     (Var("v",CTy"PSR"),
                                                      MB(MB(MU(TP[Var("v",
                                                                      CTy"PSR"),
                                                                  LF],
                                                               PTy(CTy"PSR",
                                                                   qTy)),
                                                            Close
                                                              (Var("v",
                                                                   PTy(CTy"PSR",
                                                                       bTy)),
                                                               MU(Rupd
                                                                    ("F",
                                                                     Var("v",
                                                                         PTy(CTy"PSR",
                                                                             bTy))),
                                                                  PTy(CTy"PSR",
                                                                      qTy)))),
                                                         Close
                                                           (Var("v",
                                                                CTy"PSR"),
                                                            MW(Close
                                                                 (Var("s",
                                                                      PTy(CTy"PSR",
                                                                          qTy)),
                                                                  TP[Var("v",
                                                                         CTy"PSR"),
                                                                     Mop(Snd,
                                                                         Var("s",
                                                                             PTy(CTy"PSR",
                                                                                 qTy)))])))))),
                                                MU(LU,PTy(CTy"PSR",qTy))))))),
                                MU(LU,PTy(CTy"PSR",qTy))),
                            Close
                              (AVar uTy,
                               MB(ITE(bVar"disable",
                                      MB(ITE(bVar"affectA",
                                             MB(MR(Close
                                                     (Var("s",
                                                          PTy(CTy"PSR",qTy)),
                                                      Mop(Fst,
                                                          Var("s",
                                                              PTy(CTy"PSR",
                                                                  qTy))))),
                                                Close
                                                  (Var("v",CTy"PSR"),
                                                   MB(MB(MU(TP[Var("v",
                                                                   CTy"PSR"),
                                                               LT],
                                                            PTy(CTy"PSR",
                                                                qTy)),
                                                         Close
                                                           (Var("v",
                                                                PTy(CTy"PSR",
                                                                    bTy)),
                                                            MU(Rupd
                                                                 ("A",
                                                                  Var("v",
                                                                      PTy(CTy"PSR",
                                                                          bTy))),
                                                               PTy(CTy"PSR",
                                                                   qTy)))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MW(Close
                                                              (Var("s",
                                                                   PTy(CTy"PSR",
                                                                       qTy)),
                                                               TP[Var("v",
                                                                      CTy"PSR"),
                                                                  Mop(Snd,
                                                                      Var("s",
                                                                          PTy(CTy"PSR",
                                                                              qTy)))])))))),
                                             MU(LU,PTy(CTy"PSR",qTy))),
                                         Close
                                           (AVar uTy,
                                            MB(ITE(bVar"affectI",
                                                   MB(MR(Close
                                                           (Var("s",
                                                                PTy(CTy"PSR",
                                                                    qTy)),
                                                            Mop(Fst,
                                                                Var("s",
                                                                    PTy(CTy"PSR",
                                                                        qTy))))),
                                                      Close
                                                        (Var("v",CTy"PSR"),
                                                         MB(MB(MU(TP[Var("v",
                                                                         CTy"PSR"),
                                                                     LT],
                                                                  PTy(CTy"PSR",
                                                                      qTy)),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(CTy"PSR",
                                                                          bTy)),
                                                                  MU(Rupd
                                                                       ("I",
                                                                        Var("v",
                                                                            PTy(CTy"PSR",
                                                                                bTy))),
                                                                     PTy(CTy"PSR",
                                                                         qTy)))),
                                                            Close
                                                              (Var("v",
                                                                   CTy"PSR"),
                                                               MW(Close
                                                                    (Var("s",
                                                                         PTy(CTy"PSR",
                                                                             qTy)),
                                                                     TP[Var("v",
                                                                            CTy"PSR"),
                                                                        Mop(Snd,
                                                                            Var("s",
                                                                                PTy(CTy"PSR",
                                                                                    qTy)))])))))),
                                                   MU(LU,PTy(CTy"PSR",qTy))),
                                               Close
                                                 (AVar uTy,
                                                  ITE(bVar"affectF",
                                                      MB(MR(Close
                                                              (Var("s",
                                                                   PTy(CTy"PSR",
                                                                       qTy)),
                                                               Mop(Fst,
                                                                   Var("s",
                                                                       PTy(CTy"PSR",
                                                                           qTy))))),
                                                         Close
                                                           (Var("v",
                                                                CTy"PSR"),
                                                            MB(MB(MU(TP[Var("v",
                                                                            CTy"PSR"),
                                                                        LT],
                                                                     PTy(CTy"PSR",
                                                                         qTy)),
                                                                  Close
                                                                    (Var("v",
                                                                         PTy(CTy"PSR",
                                                                             bTy)),
                                                                     MU(Rupd
                                                                          ("F",
                                                                           Var("v",
                                                                               PTy(CTy"PSR",
                                                                                   bTy))),
                                                                        PTy(CTy"PSR",
                                                                            qTy)))),
                                                               Close
                                                                 (Var("v",
                                                                      CTy"PSR"),
                                                                  MW(Close
                                                                       (Var("s",
                                                                            PTy(CTy"PSR",
                                                                                qTy)),
                                                                        TP[Var("v",
                                                                               CTy"PSR"),
                                                                           Mop(Snd,
                                                                               Var("s",
                                                                                   PTy(CTy"PSR",
                                                                                       qTy)))])))))),
                                                      MU(LU,
                                                         PTy(CTy"PSR",qTy))))))),
                                      MU(LU,PTy(CTy"PSR",qTy))),
                                  Close
                                    (AVar uTy,
                                     MB(ITE(bVar"changemode",
                                            MB(MR(Close
                                                    (Var("s",
                                                         PTy(CTy"PSR",qTy)),
                                                     Mop(Fst,
                                                         Var("s",
                                                             PTy(CTy"PSR",
                                                                 qTy))))),
                                               Close
                                                 (Var("v",CTy"PSR"),
                                                  MB(MB(MU(TP[Var("v",
                                                                  CTy"PSR"),
                                                              Var("mode",
                                                                  FTy 5)],
                                                           PTy(CTy"PSR",
                                                               qTy)),
                                                        Close
                                                          (Var("v",
                                                               PTy(CTy"PSR",
                                                                   FTy 5)),
                                                           MU(Rupd
                                                                ("M",
                                                                 Var("v",
                                                                     PTy(CTy"PSR",
                                                                         FTy 5))),
                                                              PTy(CTy"PSR",
                                                                  qTy)))),
                                                     Close
                                                       (Var("v",CTy"PSR"),
                                                        MW(Close
                                                             (Var("s",
                                                                  PTy(CTy"PSR",
                                                                      qTy)),
                                                              TP[Var("v",
                                                                     CTy"PSR"),
                                                                 Mop(Snd,
                                                                     Var("s",
                                                                         PTy(CTy"PSR",
                                                                             qTy)))])))))),
                                            MU(LU,PTy(CTy"PSR",qTy))),
                                        Close
                                          (AVar uTy,
                                           MB(MR(Close
                                                   (Var("s",
                                                        PTy(CTy"PSR",qTy)),
                                                    Mop(Fst,
                                                        Var("s",
                                                            PTy(CTy"PSR",
                                                                qTy))))),
                                              Close
                                                (Var("v",CTy"PSR"),
                                                 MB(MB(MB(MU(Call
                                                               ("reg'PSR",
                                                                F32,
                                                                Var("v",
                                                                    CTy"PSR")),
                                                             PTy(CTy"PSR",
                                                                 qTy)),
                                                          Close
                                                            (Var("v",F32),
                                                             MU(TP[Var("v",
                                                                       F32),
                                                                   LW(15,4),
                                                                   LF],
                                                                PTy(CTy"PSR",
                                                                    qTy)))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F32,
                                                                  PTy(F4,
                                                                      bTy))),
                                                          MD(Call
                                                               ("CPSRWriteByInstr",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        PTy(F4,
                                                                            bTy)))),
                                                             CTy"PSR"))),
                                                    Close
                                                      (AVar uTy,
                                                       MB(MR(Close
                                                               (Var("s",
                                                                    PTy(CTy"PSR",
                                                                        qTy)),
                                                                Dest
                                                                  ("CPSR",
                                                                   CTy"PSR",
                                                                   Mop(Snd,
                                                                       Var("s",
                                                                           PTy(CTy"PSR",
                                                                               qTy)))))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MB(MB(MB(MU(Dest
                                                                           ("M",
                                                                            FTy 5,
                                                                            Var("v",
                                                                                CTy"PSR")),
                                                                         PTy(CTy"PSR",
                                                                             qTy)),
                                                                      Close
                                                                        (Var("v",
                                                                             FTy 5),
                                                                         MU(EQ(Var("v",
                                                                                   FTy 5),
                                                                               LW(26,
                                                                                  5)),
                                                                            PTy(CTy"PSR",
                                                                                qTy)))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MB(MD(Call
                                                                                  ("CurrentInstrSet",
                                                                                   ATy(qTy,
                                                                                       PTy(CTy"InstrSet",
                                                                                           qTy)),
                                                                                   LU),
                                                                                CTy"PSR"),
                                                                             Close
                                                                               (Var("v",
                                                                                    CTy"InstrSet"),
                                                                                MU(EQ(Var("v",
                                                                                          CTy"InstrSet"),
                                                                                      LC("InstrSet_ThumbEE",
                                                                                         CTy"InstrSet")),
                                                                                   PTy(CTy"PSR",
                                                                                       qTy)))),
                                                                          MU(LF,
                                                                             PTy(CTy"PSR",
                                                                                 qTy))))),
                                                                Close
                                                                  (bVar"b",
                                                                   ITE(bVar"b",
                                                                       MD(Call
                                                                            ("raise'exception",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             Call
                                                                               ("UNPREDICTABLE",
                                                                                CTy"exception",
                                                                                LS
                                                                                 "ChangeProcessorState")),
                                                                          CTy"PSR"),
                                                                       MU(LU,
                                                                          PTy(CTy"PSR",
                                                                              qTy)))))))))))))))))))),
                MU(LU,qTy)),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'ChangeProcessorState_def = Def
  ("dfn'ChangeProcessorState",
   TP[bVar"enable",bVar"disable",bVar"affectA",bVar"affectI",
      bVar"affectF",bVar"changemode",Var("mode",FTy 5)],
   Call
     ("doChangeProcessorState",ATy(qTy,PTy(uTy,qTy)),
      TP[bVar"enable",bVar"disable",bVar"affectA",bVar"affectI",
         bVar"affectF",bVar"changemode",Var("mode",FTy 5)]))
;
val dfn'ChangeProcessorStateT1_def = Def
  ("dfn'ChangeProcessorStateT1",
   TP[bVar"enable",bVar"affectA",bVar"affectI",bVar"affectF"],
   Call
     ("doChangeProcessorState",ATy(qTy,PTy(uTy,qTy)),
      TP[bVar"enable",Mop(Not,bVar"enable"),bVar"affectA",bVar"affectI",
         bVar"affectF",LF,LX(FTy 5)]))
;
val dfn'ExceptionReturn_def = Def0
  ("dfn'ExceptionReturn",
   MB(Call("CurrentModeIsUserOrSystem",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",MU(LT,qTy),
                MB(Call
                     ("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
                   Close
                     (Var("v",CTy"InstrSet"),
                      MU(EQ(Var("v",CTy"InstrSet"),
                            LC("InstrSet_ThumbEE",CTy"InstrSet")),qTy)))),
            Close
              (bVar"b",
               ITE(bVar"b",
                   Call
                     ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",
                         LS"ExceptionReturn")),
                   MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
                      Close
                        (bVar"v",
                         MB(ITE(bVar"v",
                                MR(Close
                                     (qVar"s",Dest("ELR_hyp",F32,qVar"s"))),
                                Call("R",ATy(qTy,PTy(F32,qTy)),LW(14,4))),
                            Close
                              (Var("new_pc_value",F32),
                               MB(Const("SPSR",ATy(qTy,PTy(CTy"PSR",qTy))),
                                  Close
                                    (Var("v",CTy"PSR"),
                                     MB(MB(MB(MU(Call
                                                   ("reg'PSR",F32,
                                                    Var("v",CTy"PSR")),qTy),
                                              Close
                                                (Var("v",F32),
                                                 MU(TP[Var("v",F32),
                                                       LW(15,4),LT],qTy))),
                                           Close
                                             (Var("v",PTy(F32,PTy(F4,bTy))),
                                              Call
                                                ("CPSRWriteByInstr",
                                                 ATy(qTy,PTy(uTy,qTy)),
                                                 Var("v",
                                                     PTy(F32,PTy(F4,bTy)))))),
                                        Close
                                          (AVar uTy,
                                           MB(MR(Close
                                                   (qVar"s",
                                                    Dest
                                                      ("CPSR",CTy"PSR",
                                                       qVar"s"))),
                                              Close
                                                (Var("v",CTy"PSR"),
                                                 MB(MB(MB(MU(Dest
                                                               ("M",FTy 5,
                                                                Var("v",
                                                                    CTy"PSR")),
                                                             qTy),
                                                          Close
                                                            (Var("v",FTy 5),
                                                             MU(EQ(Var("v",
                                                                       FTy 5),
                                                                   LW(26,5)),
                                                                qTy))),
                                                       Close
                                                         (bVar"b",
                                                          ITE(bVar"b",
                                                              MB(Call
                                                                   ("CurrentInstrSet",
                                                                    ATy(qTy,
                                                                        PTy(CTy"InstrSet",
                                                                            qTy)),
                                                                    LU),
                                                                 Close
                                                                   (Var("v",
                                                                        CTy"InstrSet"),
                                                                    MU(EQ(Var("v",
                                                                              CTy"InstrSet"),
                                                                          LC("InstrSet_ThumbEE",
                                                                             CTy"InstrSet")),
                                                                       qTy))),
                                                              MU(LF,qTy)))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           Call
                                                             ("raise'exception",
                                                              ATy(qTy,
                                                                  PTy(uTy,
                                                                      qTy)),
                                                              Call
                                                                ("UNPREDICTABLE",
                                                                 CTy"exception",
                                                                 LS
                                                                  "ExceptionReturn")),
                                                           Call
                                                             ("BranchWritePC",
                                                              ATy(qTy,
                                                                  PTy(uTy,
                                                                      qTy)),
                                                              Var("new_pc_value",
                                                                  F32)))))))))))))))))))))
;
val dfn'HypervisorCall_def = Def
  ("dfn'HypervisorCall",Var("imm16",F16),
   MB(Call("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(MB(MU(Mop(Not,bVar"v"),qTy),
                  Close
                    (bVar"b",
                     ITE(bVar"b",MU(LT,qTy),
                         Call("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU)))),
               Close
                 (bVar"b",
                  ITE(bVar"b",MU(LT,qTy),
                      MB(Call
                           ("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),
                            LU),Close(bVar"v",MU(Mop(Not,bVar"v"),qTy)))))),
            Close
              (bVar"b",
               ITE(bVar"b",
                   Call
                     ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",LS"HypervisorCall")),
                   MB(MR(Close(qVar"s",Dest("CP15",CTy"CP15",qVar"s"))),
                      Close
                        (Var("v",CTy"CP15"),
                         MB(MB(MB(MU(Dest
                                       ("SCR",CTy"SCR",Var("v",CTy"CP15")),
                                     qTy),
                                  Close
                                    (Var("v",CTy"SCR"),
                                     MU(Dest("HCE",bTy,Var("v",CTy"SCR")),
                                        qTy))),
                               Close(bVar"v",MU(Mop(Not,bVar"v"),qTy))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   MB(Call
                                        ("CurrentModeIsHyp",
                                         ATy(qTy,PTy(bTy,qTy)),LU),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Call
                                               ("raise'exception",
                                                ATy(qTy,PTy(uTy,qTy)),
                                                Call
                                                  ("UNPREDICTABLE",
                                                   CTy"exception",
                                                   LS"HypervisorCall")),
                                             Call
                                               ("TakeUndefInstrException",
                                                ATy(qTy,PTy(uTy,qTy)),LU)))),
                                   Call
                                     ("CallHypervisor",
                                      ATy(qTy,PTy(uTy,qTy)),
                                      Var("imm16",F16)))))))))))))
;
val dfn'MoveToRegisterFromSpecial_def = Def
  ("dfn'MoveToRegisterFromSpecial",TP[bVar"read_spsr",Var("d",F4)],
   MB(ITE(bVar"read_spsr",
          MB(Call("CurrentModeIsUserOrSystem",ATy(qTy,PTy(bTy,qTy)),LU),
             Close
               (bVar"b",
                ITE(bVar"b",
                    Call
                      ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                       Call
                         ("UNPREDICTABLE",CTy"exception",
                          LS"MoveToRegisterFromSpecial")),
                    MB(Const("SPSR",ATy(qTy,PTy(CTy"PSR",qTy))),
                       Close
                         (Var("v",CTy"PSR"),
                          MB(MB(MU(Call("reg'PSR",F32,Var("v",CTy"PSR")),
                                   qTy),
                                Close
                                  (Var("v",F32),
                                   MU(TP[Var("v",F32),Var("d",F4)],qTy))),
                             Close
                               (Var("v",PTy(F32,F4)),
                                Call
                                  ("write'R",ATy(qTy,PTy(uTy,qTy)),
                                   Var("v",PTy(F32,F4)))))))))),
          MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
             Close
               (Var("v",CTy"PSR"),
                MB(MB(MB(MU(Call("reg'PSR",F32,Var("v",CTy"PSR")),qTy),
                         Close
                           (Var("v",F32),
                            MU(Bop(BAnd,Var("v",F32),LW(4177462239,32)),
                               qTy))),
                      Close
                        (Var("v",F32),MU(TP[Var("v",F32),Var("d",F4)],qTy))),
                   Close
                     (Var("v",PTy(F32,F4)),
                      Call
                        ("write'R",ATy(qTy,PTy(uTy,qTy)),
                         Var("v",PTy(F32,F4)))))))),
      Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))
;
val dfn'MoveToRegisterFromBankedOrSpecial_def = Def
  ("dfn'MoveToRegisterFromBankedOrSpecial",
   TP[bVar"read_spsr",Var("SYSm",FTy 5),Var("d",F4)],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MB(MU(Mop(Not,bVar"v"),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",
                      Call
                        ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                         Call
                           ("UNPREDICTABLE",CTy"exception",
                            LS"MoveToRegisterFromBankedOrSpecial")),
                      MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                         Close
                           (Var("v",CTy"PSR"),
                            MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                               Close
                                 (Var("mode",FTy 5),
                                  ITE(bVar"read_spsr",
                                      MB(Call
                                           ("SPSRAccessValid",
                                            ATy(qTy,PTy(uTy,qTy)),
                                            TP[Var("SYSm",FTy 5),
                                               Var("mode",FTy 5)]),
                                         Close
                                           (uVar"_0",
                                            CS(Var("SYSm",FTy 5),
                                               [(LW(14,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_fiq",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Call
                                                                  ("reg'PSR",
                                                                   F32,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MU(TP[Var("v",
                                                                          F32),
                                                                      Var("d",
                                                                          F4)],
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 PTy(F32,
                                                                     F4)),
                                                             Call
                                                               ("write'R",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        F4)))))))),
                                                (LW(16,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_irq",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Call
                                                                  ("reg'PSR",
                                                                   F32,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MU(TP[Var("v",
                                                                          F32),
                                                                      Var("d",
                                                                          F4)],
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 PTy(F32,
                                                                     F4)),
                                                             Call
                                                               ("write'R",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        F4)))))))),
                                                (LW(18,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_svc",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Call
                                                                  ("reg'PSR",
                                                                   F32,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MU(TP[Var("v",
                                                                          F32),
                                                                      Var("d",
                                                                          F4)],
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 PTy(F32,
                                                                     F4)),
                                                             Call
                                                               ("write'R",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        F4)))))))),
                                                (LW(20,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_abt",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Call
                                                                  ("reg'PSR",
                                                                   F32,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MU(TP[Var("v",
                                                                          F32),
                                                                      Var("d",
                                                                          F4)],
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 PTy(F32,
                                                                     F4)),
                                                             Call
                                                               ("write'R",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        F4)))))))),
                                                (LW(22,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_und",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Call
                                                                  ("reg'PSR",
                                                                   F32,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MU(TP[Var("v",
                                                                          F32),
                                                                      Var("d",
                                                                          F4)],
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 PTy(F32,
                                                                     F4)),
                                                             Call
                                                               ("write'R",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        F4)))))))),
                                                (LW(28,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_mon",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Call
                                                                  ("reg'PSR",
                                                                   F32,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MU(TP[Var("v",
                                                                          F32),
                                                                      Var("d",
                                                                          F4)],
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 PTy(F32,
                                                                     F4)),
                                                             Call
                                                               ("write'R",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        F4)))))))),
                                                (LW(30,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_hyp",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MU(Call
                                                                  ("reg'PSR",
                                                                   F32,
                                                                   Var("v",
                                                                       CTy"PSR")),
                                                                qTy),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MU(TP[Var("v",
                                                                          F32),
                                                                      Var("d",
                                                                          F4)],
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 PTy(F32,
                                                                     F4)),
                                                             Call
                                                               ("write'R",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Var("v",
                                                                    PTy(F32,
                                                                        F4)))))))),
                                                (AVar(FTy 5),MU(LU,qTy))]))),
                                      MB(Call
                                           ("BankedRegisterAccessValid",
                                            ATy(qTy,PTy(uTy,qTy)),
                                            TP[Var("SYSm",FTy 5),
                                               Var("mode",FTy 5)]),
                                         Close
                                           (AVar uTy,
                                            ITB([(EQ(EX(Var("SYSm",FTy 5),
                                                        LN 4,LN 3,FTy 2),
                                                     LW(0,2)),
                                                  MB(Call
                                                       ("Rmode",
                                                        ATy(qTy,
                                                            PTy(F32,qTy)),
                                                        TP[Bop(Add,
                                                               Mop(Cast F4,
                                                                   EX(Var("SYSm",
                                                                          FTy 5),
                                                                      LN 2,
                                                                      LN 0,
                                                                      FTy 3)),
                                                               LW(8,4)),
                                                           LW(16,5)]),
                                                     Close
                                                       (Var("v",F32),
                                                        MB(MU(TP[Var("v",
                                                                     F32),
                                                                 Var("d",
                                                                     F4)],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F32,
                                                                      F4)),
                                                              Call
                                                                ("write'R",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F32,
                                                                         F4)))))))),
                                                 (EQ(EX(Var("SYSm",FTy 5),
                                                        LN 4,LN 3,FTy 2),
                                                     LW(1,2)),
                                                  MB(Call
                                                       ("Rmode",
                                                        ATy(qTy,
                                                            PTy(F32,qTy)),
                                                        TP[Bop(Add,
                                                               Mop(Cast F4,
                                                                   EX(Var("SYSm",
                                                                          FTy 5),
                                                                      LN 2,
                                                                      LN 0,
                                                                      FTy 3)),
                                                               LW(8,4)),
                                                           LW(17,5)]),
                                                     Close
                                                       (Var("v",F32),
                                                        MB(MU(TP[Var("v",
                                                                     F32),
                                                                 Var("d",
                                                                     F4)],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F32,
                                                                      F4)),
                                                              Call
                                                                ("write'R",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F32,
                                                                         F4)))))))),
                                                 (EQ(EX(Var("SYSm",FTy 5),
                                                        LN 4,LN 3,FTy 2),
                                                     LW(3,2)),
                                                  ITB([(Mop(Not,
                                                            Bop(Bit,
                                                                Var("SYSm",
                                                                    FTy 5),
                                                                LN 1)),
                                                        MB(Call
                                                             ("Rmode",
                                                              ATy(qTy,
                                                                  PTy(F32,
                                                                      qTy)),
                                                              TP[Bop(Add,
                                                                     Mop(Cast
                                                                           F4,
                                                                         Bop(Bit,
                                                                             Var("SYSm",
                                                                                 FTy 5),
                                                                             LN
                                                                              0)),
                                                                     LW(13,
                                                                        4)),
                                                                 LW(22,5)]),
                                                           Close
                                                             (Var("v",F32),
                                                              MB(MU(TP[Var("v",
                                                                           F32),
                                                                       Var("d",
                                                                           F4)],
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F32,
                                                                            F4)),
                                                                    Call
                                                                      ("write'R",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F32,
                                                                               F4)))))))),
                                                       (Mop(Not,
                                                            Bop(Bit,
                                                                Var("SYSm",
                                                                    FTy 5),
                                                                LN 0)),
                                                        MB(Call
                                                             ("Rmode",
                                                              ATy(qTy,
                                                                  PTy(F32,
                                                                      qTy)),
                                                              TP[LW(13,4),
                                                                 LW(26,5)]),
                                                           Close
                                                             (Var("v",F32),
                                                              MB(MU(TP[Var("v",
                                                                           F32),
                                                                       Var("d",
                                                                           F4)],
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F32,
                                                                            F4)),
                                                                    Call
                                                                      ("write'R",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F32,
                                                                               F4))))))))],
                                                      MB(MR(Close
                                                              (qVar"s",
                                                               Dest
                                                                 ("ELR_hyp",
                                                                  F32,
                                                                  qVar"s"))),
                                                         Close
                                                           (Var("v",F32),
                                                            MB(MU(TP[Var("v",
                                                                         F32),
                                                                     Var("d",
                                                                         F4)],
                                                                  qTy),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F32,
                                                                          F4)),
                                                                  Call
                                                                    ("write'R",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F32,
                                                                             F4)))))))))],
                                                MN(LX(FTy 5),
                                                   MB(MR(Close
                                                           (Var("s",
                                                                PTy(FTy 5,
                                                                    qTy)),
                                                            Mop(Fst,
                                                                Var("s",
                                                                    PTy(FTy 5,
                                                                        qTy))))),
                                                      Close
                                                        (Var("v",FTy 5),
                                                         MB(MB(MU(BFI(LN 0,
                                                                      LN 0,
                                                                      Mop(Cast
                                                                            F1,
                                                                          Bop(Or,
                                                                              Bop(Bit,
                                                                                  Var("SYSm",
                                                                                      FTy 5),
                                                                                  LN
                                                                                   2),
                                                                              Bop(Bit,
                                                                                  Var("SYSm",
                                                                                      FTy 5),
                                                                                  LN
                                                                                   1))),
                                                                      Var("v",
                                                                          FTy 5)),
                                                                  PTy(FTy 5,
                                                                      qTy)),
                                                               Close
                                                                 (Var("v",
                                                                      FTy 5),
                                                                  MW(Close
                                                                       (Var("s",
                                                                            PTy(FTy 5,
                                                                                qTy)),
                                                                        TP[Var("v",
                                                                               FTy 5),
                                                                           Mop(Snd,
                                                                               Var("s",
                                                                                   PTy(FTy 5,
                                                                                       qTy)))])))),
                                                            Close
                                                              (AVar uTy,
                                                               MB(MR(Close
                                                                       (Var("s",
                                                                            PTy(FTy 5,
                                                                                qTy)),
                                                                        Mop(Fst,
                                                                            Var("s",
                                                                                PTy(FTy 5,
                                                                                    qTy))))),
                                                                  Close
                                                                    (Var("v",
                                                                         FTy 5),
                                                                     MB(MB(MU(BFI(LN
                                                                                   1,
                                                                                  LN
                                                                                   1,
                                                                                  Mop(Cast
                                                                                        F1,
                                                                                      LT),
                                                                                  Var("v",
                                                                                      FTy 5)),
                                                                              PTy(FTy 5,
                                                                                  qTy)),
                                                                           Close
                                                                             (Var("v",
                                                                                  FTy 5),
                                                                              MW(Close
                                                                                   (Var("s",
                                                                                        PTy(FTy 5,
                                                                                            qTy)),
                                                                                    TP[Var("v",
                                                                                           FTy 5),
                                                                                       Mop(Snd,
                                                                                           Var("s",
                                                                                               PTy(FTy 5,
                                                                                                   qTy)))])))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MB(MR(Close
                                                                                   (Var("s",
                                                                                        PTy(FTy 5,
                                                                                            qTy)),
                                                                                    Mop(Fst,
                                                                                        Var("s",
                                                                                            PTy(FTy 5,
                                                                                                qTy))))),
                                                                              Close
                                                                                (Var("v",
                                                                                     FTy 5),
                                                                                 MB(MB(MU(BFI(LN
                                                                                               2,
                                                                                              LN
                                                                                               2,
                                                                                              Mop(Cast
                                                                                                    F1,
                                                                                                  Bop(And,
                                                                                                      Bop(Bit,
                                                                                                          Var("SYSm",
                                                                                                              FTy 5),
                                                                                                          LN
                                                                                                           2),
                                                                                                      Mop(Not,
                                                                                                          Bop(Bit,
                                                                                                              Var("SYSm",
                                                                                                                  FTy 5),
                                                                                                              LN
                                                                                                               1)))),
                                                                                              Var("v",
                                                                                                  FTy 5)),
                                                                                          PTy(FTy 5,
                                                                                              qTy)),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              FTy 5),
                                                                                          MW(Close
                                                                                               (Var("s",
                                                                                                    PTy(FTy 5,
                                                                                                        qTy)),
                                                                                                TP[Var("v",
                                                                                                       FTy 5),
                                                                                                   Mop(Snd,
                                                                                                       Var("s",
                                                                                                           PTy(FTy 5,
                                                                                                               qTy)))])))),
                                                                                    Close
                                                                                      (AVar
                                                                                         uTy,
                                                                                       MB(MR(Close
                                                                                               (Var("s",
                                                                                                    PTy(FTy 5,
                                                                                                        qTy)),
                                                                                                Mop(Fst,
                                                                                                    Var("s",
                                                                                                        PTy(FTy 5,
                                                                                                            qTy))))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 FTy 5),
                                                                                             MB(MB(MU(BFI(LN
                                                                                                           3,
                                                                                                          LN
                                                                                                           3,
                                                                                                          Mop(Cast
                                                                                                                F1,
                                                                                                              Bop(And,
                                                                                                                  Bop(Bit,
                                                                                                                      Var("SYSm",
                                                                                                                          FTy 5),
                                                                                                                      LN
                                                                                                                       2),
                                                                                                                  Bop(Bit,
                                                                                                                      Var("SYSm",
                                                                                                                          FTy 5),
                                                                                                                      LN
                                                                                                                       1))),
                                                                                                          Var("v",
                                                                                                              FTy 5)),
                                                                                                      PTy(FTy 5,
                                                                                                          qTy)),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          FTy 5),
                                                                                                      MW(Close
                                                                                                           (Var("s",
                                                                                                                PTy(FTy 5,
                                                                                                                    qTy)),
                                                                                                            TP[Var("v",
                                                                                                                   FTy 5),
                                                                                                               Mop(Snd,
                                                                                                                   Var("s",
                                                                                                                       PTy(FTy 5,
                                                                                                                           qTy)))])))),
                                                                                                Close
                                                                                                  (AVar
                                                                                                     uTy,
                                                                                                   MB(MR(Close
                                                                                                           (Var("s",
                                                                                                                PTy(FTy 5,
                                                                                                                    qTy)),
                                                                                                            Mop(Fst,
                                                                                                                Var("s",
                                                                                                                    PTy(FTy 5,
                                                                                                                        qTy))))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             FTy 5),
                                                                                                         MB(MB(MU(BFI(LN
                                                                                                                       4,
                                                                                                                      LN
                                                                                                                       4,
                                                                                                                      Mop(Cast
                                                                                                                            F1,
                                                                                                                          LT),
                                                                                                                      Var("v",
                                                                                                                          FTy 5)),
                                                                                                                  PTy(FTy 5,
                                                                                                                      qTy)),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      FTy 5),
                                                                                                                  MW(Close
                                                                                                                       (Var("s",
                                                                                                                            PTy(FTy 5,
                                                                                                                                qTy)),
                                                                                                                        TP[Var("v",
                                                                                                                               FTy 5),
                                                                                                                           Mop(Snd,
                                                                                                                               Var("s",
                                                                                                                                   PTy(FTy 5,
                                                                                                                                       qTy)))])))),
                                                                                                            Close
                                                                                                              (AVar
                                                                                                                 uTy,
                                                                                                               MB(MR(Close
                                                                                                                       (Var("s",
                                                                                                                            PTy(FTy 5,
                                                                                                                                qTy)),
                                                                                                                        Mop(Fst,
                                                                                                                            Var("s",
                                                                                                                                PTy(FTy 5,
                                                                                                                                    qTy))))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         FTy 5),
                                                                                                                     MB(MU(EQ(Var("mode",
                                                                                                                                  FTy 5),
                                                                                                                              Var("v",
                                                                                                                                  FTy 5)),
                                                                                                                           PTy(FTy 5,
                                                                                                                               qTy)),
                                                                                                                        Close
                                                                                                                          (bVar"b",
                                                                                                                           ITE(bVar"b",
                                                                                                                               MD(Call
                                                                                                                                    ("raise'exception",
                                                                                                                                     ATy(qTy,
                                                                                                                                         PTy(uTy,
                                                                                                                                             qTy)),
                                                                                                                                     Call
                                                                                                                                       ("UNPREDICTABLE",
                                                                                                                                        CTy"exception",
                                                                                                                                        LS
                                                                                                                                         "MoveToRegisterFromBankedOrSpecial")),
                                                                                                                                  FTy 5),
                                                                                                                               MB(MR(Close
                                                                                                                                       (Var("s",
                                                                                                                                            PTy(FTy 5,
                                                                                                                                                qTy)),
                                                                                                                                        Mop(Fst,
                                                                                                                                            Var("s",
                                                                                                                                                PTy(FTy 5,
                                                                                                                                                    qTy))))),
                                                                                                                                  Close
                                                                                                                                    (Var("v",
                                                                                                                                         FTy 5),
                                                                                                                                     MB(MB(MB(MU(TP[Bop(Add,
                                                                                                                                                        Mop(Cast
                                                                                                                                                              F4,
                                                                                                                                                            Bop(Bit,
                                                                                                                                                                Var("SYSm",
                                                                                                                                                                    FTy 5),
                                                                                                                                                                LN
                                                                                                                                                                 0)),
                                                                                                                                                        LW(13,
                                                                                                                                                           4)),
                                                                                                                                                    Var("v",
                                                                                                                                                        FTy 5)],
                                                                                                                                                 PTy(FTy 5,
                                                                                                                                                     qTy)),
                                                                                                                                              Close
                                                                                                                                                (Var("v",
                                                                                                                                                     PTy(F4,
                                                                                                                                                         FTy 5)),
                                                                                                                                                 MD(Call
                                                                                                                                                      ("Rmode",
                                                                                                                                                       ATy(qTy,
                                                                                                                                                           PTy(F32,
                                                                                                                                                               qTy)),
                                                                                                                                                       Var("v",
                                                                                                                                                           PTy(F4,
                                                                                                                                                               FTy 5))),
                                                                                                                                                    FTy 5))),
                                                                                                                                           Close
                                                                                                                                             (Var("v",
                                                                                                                                                  F32),
                                                                                                                                              MU(TP[Var("v",
                                                                                                                                                        F32),
                                                                                                                                                    Var("d",
                                                                                                                                                        F4)],
                                                                                                                                                 PTy(FTy 5,
                                                                                                                                                     qTy)))),
                                                                                                                                        Close
                                                                                                                                          (Var("v",
                                                                                                                                               PTy(F32,
                                                                                                                                                   F4)),
                                                                                                                                           MD(Call
                                                                                                                                                ("write'R",
                                                                                                                                                 ATy(qTy,
                                                                                                                                                     PTy(uTy,
                                                                                                                                                         qTy)),
                                                                                                                                                 Var("v",
                                                                                                                                                     PTy(F32,
                                                                                                                                                         F4))),
                                                                                                                                              FTy 5)))))))))))))))))))))))))))))))))))))))))),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'MoveToSpecialFromImmediate_def = Def
  ("dfn'MoveToSpecialFromImmediate",
   TP[bVar"write_spsr",Var("imm32",F32),Var("mask",F4)],
   MB(ITE(bVar"write_spsr",
          Call
            ("SPSRWriteByInstr",ATy(qTy,PTy(uTy,qTy)),
             TP[Var("imm32",F32),Var("mask",F4)]),
          MB(Call
               ("CPSRWriteByInstr",ATy(qTy,PTy(uTy,qTy)),
                TP[Var("imm32",F32),Var("mask",F4),LF]),
             Close
               (AVar uTy,
                MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                   Close
                     (Var("v",CTy"PSR"),
                      MB(MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                               Close
                                 (Var("v",FTy 5),
                                  MU(EQ(Var("v",FTy 5),LW(26,5)),qTy))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   MB(Call
                                        ("CurrentInstrSet",
                                         ATy(qTy,PTy(CTy"InstrSet",qTy)),
                                         LU),
                                      Close
                                        (Var("v",CTy"InstrSet"),
                                         MU(EQ(Var("v",CTy"InstrSet"),
                                               LC("InstrSet_ThumbEE",
                                                  CTy"InstrSet")),qTy))),
                                   MU(LF,qTy)))),
                         Close
                           (bVar"b",
                            ITE(bVar"b",
                                Call
                                  ("raise'exception",
                                   ATy(qTy,PTy(uTy,qTy)),
                                   Call
                                     ("UNPREDICTABLE",CTy"exception",
                                      LS"MoveToSpecialFromImmediate")),
                                MU(LU,qTy))))))))),
      Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))
;
val dfn'MoveToSpecialFromRegister_def = Def
  ("dfn'MoveToSpecialFromRegister",
   TP[bVar"write_spsr",Var("n",F4),Var("mask",F4)],
   MB(ITE(bVar"write_spsr",
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close
               (Var("v",F32),
                MB(MU(TP[Var("v",F32),Var("mask",F4)],qTy),
                   Close
                     (Var("v",PTy(F32,F4)),
                      Call
                        ("SPSRWriteByInstr",ATy(qTy,PTy(uTy,qTy)),
                         Var("v",PTy(F32,F4))))))),
          MB(Call("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
             Close
               (Var("v",F32),
                MB(MB(MU(TP[Var("v",F32),Var("mask",F4),LF],qTy),
                      Close
                        (Var("v",PTy(F32,PTy(F4,bTy))),
                         Call
                           ("CPSRWriteByInstr",ATy(qTy,PTy(uTy,qTy)),
                            Var("v",PTy(F32,PTy(F4,bTy)))))),
                   Close
                     (AVar uTy,
                      MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                         Close
                           (Var("v",CTy"PSR"),
                            MB(MB(MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),
                                        qTy),
                                     Close
                                       (Var("v",FTy 5),
                                        MU(EQ(Var("v",FTy 5),LW(26,5)),qTy))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MB(Call
                                              ("CurrentInstrSet",
                                               ATy(qTy,
                                                   PTy(CTy"InstrSet",qTy)),
                                               LU),
                                            Close
                                              (Var("v",CTy"InstrSet"),
                                               MU(EQ(Var("v",CTy"InstrSet"),
                                                     LC("InstrSet_ThumbEE",
                                                        CTy"InstrSet")),
                                                  qTy))),MU(LF,qTy)))),
                               Close
                                 (bVar"b",
                                  ITE(bVar"b",
                                      Call
                                        ("raise'exception",
                                         ATy(qTy,PTy(uTy,qTy)),
                                         Call
                                           ("UNPREDICTABLE",
                                            CTy"exception",
                                            LS"MoveToSpecialFromRegister")),
                                      MU(LU,qTy))))))))))),
      Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))
;
val dfn'MoveToBankedOrSpecialRegister_def = Def
  ("dfn'MoveToBankedOrSpecialRegister",
   TP[bVar"write_spsr",Var("SYSm",FTy 5),Var("n",F4)],
   MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(MU(Mop(Not,bVar"v"),qTy),
            Close
              (bVar"b",
               ITE(bVar"b",
                   Call
                     ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                      Call
                        ("UNPREDICTABLE",CTy"exception",
                         LS"MoveToBankedOrSpecialRegister")),
                   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
                      Close
                        (Var("v",CTy"PSR"),
                         MB(MU(Dest("M",FTy 5,Var("v",CTy"PSR")),qTy),
                            Close
                              (Var("mode",FTy 5),
                               MB(ITE(bVar"write_spsr",
                                      MB(Call
                                           ("SPSRAccessValid",
                                            ATy(qTy,PTy(uTy,qTy)),
                                            TP[Var("SYSm",FTy 5),
                                               Var("mode",FTy 5)]),
                                         Close
                                           (uVar"_0",
                                            CS(Var("SYSm",FTy 5),
                                               [(LW(14,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_fiq",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(Call
                                                                  ("R",
                                                                   ATy(qTy,
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Var("n",
                                                                       F4)),
                                                                Close
                                                                  (Var("v0",
                                                                       F32),
                                                                   MU(TP[Var("v",
                                                                             CTy"PSR"),
                                                                         Var("v0",
                                                                             F32)],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32)),
                                                                MU(Call
                                                                     ("write'reg'PSR",
                                                                      CTy"PSR",
                                                                      Var("v",
                                                                          PTy(CTy"PSR",
                                                                              F32))),
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MW(Close
                                                                  (qVar"s",
                                                                   Rupd
                                                                     ("SPSR_fiq",
                                                                      TP[qVar"s",
                                                                         Var("v",
                                                                             CTy"PSR")])))))))),
                                                (LW(16,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_irq",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(Call
                                                                  ("R",
                                                                   ATy(qTy,
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Var("n",
                                                                       F4)),
                                                                Close
                                                                  (Var("v0",
                                                                       F32),
                                                                   MU(TP[Var("v",
                                                                             CTy"PSR"),
                                                                         Var("v0",
                                                                             F32)],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32)),
                                                                MU(Call
                                                                     ("write'reg'PSR",
                                                                      CTy"PSR",
                                                                      Var("v",
                                                                          PTy(CTy"PSR",
                                                                              F32))),
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MW(Close
                                                                  (qVar"s",
                                                                   Rupd
                                                                     ("SPSR_irq",
                                                                      TP[qVar"s",
                                                                         Var("v",
                                                                             CTy"PSR")])))))))),
                                                (LW(18,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_svc",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(Call
                                                                  ("R",
                                                                   ATy(qTy,
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Var("n",
                                                                       F4)),
                                                                Close
                                                                  (Var("v0",
                                                                       F32),
                                                                   MU(TP[Var("v",
                                                                             CTy"PSR"),
                                                                         Var("v0",
                                                                             F32)],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32)),
                                                                MU(Call
                                                                     ("write'reg'PSR",
                                                                      CTy"PSR",
                                                                      Var("v",
                                                                          PTy(CTy"PSR",
                                                                              F32))),
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MW(Close
                                                                  (qVar"s",
                                                                   Rupd
                                                                     ("SPSR_svc",
                                                                      TP[qVar"s",
                                                                         Var("v",
                                                                             CTy"PSR")])))))))),
                                                (LW(20,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_abt",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(Call
                                                                  ("R",
                                                                   ATy(qTy,
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Var("n",
                                                                       F4)),
                                                                Close
                                                                  (Var("v0",
                                                                       F32),
                                                                   MU(TP[Var("v",
                                                                             CTy"PSR"),
                                                                         Var("v0",
                                                                             F32)],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32)),
                                                                MU(Call
                                                                     ("write'reg'PSR",
                                                                      CTy"PSR",
                                                                      Var("v",
                                                                          PTy(CTy"PSR",
                                                                              F32))),
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MW(Close
                                                                  (qVar"s",
                                                                   Rupd
                                                                     ("SPSR_abt",
                                                                      TP[qVar"s",
                                                                         Var("v",
                                                                             CTy"PSR")])))))))),
                                                (LW(22,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_und",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(Call
                                                                  ("R",
                                                                   ATy(qTy,
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Var("n",
                                                                       F4)),
                                                                Close
                                                                  (Var("v0",
                                                                       F32),
                                                                   MU(TP[Var("v",
                                                                             CTy"PSR"),
                                                                         Var("v0",
                                                                             F32)],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32)),
                                                                MU(Call
                                                                     ("write'reg'PSR",
                                                                      CTy"PSR",
                                                                      Var("v",
                                                                          PTy(CTy"PSR",
                                                                              F32))),
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MW(Close
                                                                  (qVar"s",
                                                                   Rupd
                                                                     ("SPSR_und",
                                                                      TP[qVar"s",
                                                                         Var("v",
                                                                             CTy"PSR")])))))))),
                                                (LW(28,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_mon",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(Call
                                                                  ("R",
                                                                   ATy(qTy,
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Var("n",
                                                                       F4)),
                                                                Close
                                                                  (Var("v0",
                                                                       F32),
                                                                   MU(TP[Var("v",
                                                                             CTy"PSR"),
                                                                         Var("v0",
                                                                             F32)],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32)),
                                                                MU(Call
                                                                     ("write'reg'PSR",
                                                                      CTy"PSR",
                                                                      Var("v",
                                                                          PTy(CTy"PSR",
                                                                              F32))),
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MW(Close
                                                                  (qVar"s",
                                                                   Rupd
                                                                     ("SPSR_mon",
                                                                      TP[qVar"s",
                                                                         Var("v",
                                                                             CTy"PSR")])))))))),
                                                (LW(30,5),
                                                 MB(MR(Close
                                                         (qVar"s",
                                                          Dest
                                                            ("SPSR_hyp",
                                                             CTy"PSR",
                                                             qVar"s"))),
                                                    Close
                                                      (Var("v",CTy"PSR"),
                                                       MB(MB(MB(Call
                                                                  ("R",
                                                                   ATy(qTy,
                                                                       PTy(F32,
                                                                           qTy)),
                                                                   Var("n",
                                                                       F4)),
                                                                Close
                                                                  (Var("v0",
                                                                       F32),
                                                                   MU(TP[Var("v",
                                                                             CTy"PSR"),
                                                                         Var("v0",
                                                                             F32)],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(CTy"PSR",
                                                                        F32)),
                                                                MU(Call
                                                                     ("write'reg'PSR",
                                                                      CTy"PSR",
                                                                      Var("v",
                                                                          PTy(CTy"PSR",
                                                                              F32))),
                                                                   qTy))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MW(Close
                                                                  (qVar"s",
                                                                   Rupd
                                                                     ("SPSR_hyp",
                                                                      TP[qVar"s",
                                                                         Var("v",
                                                                             CTy"PSR")])))))))),
                                                (AVar(FTy 5),MU(LU,qTy))]))),
                                      MB(Call
                                           ("BankedRegisterAccessValid",
                                            ATy(qTy,PTy(uTy,qTy)),
                                            TP[Var("SYSm",FTy 5),
                                               Var("mode",FTy 5)]),
                                         Close
                                           (AVar uTy,
                                            ITB([(EQ(EX(Var("SYSm",FTy 5),
                                                        LN 4,LN 3,FTy 2),
                                                     LW(0,2)),
                                                  MB(Call
                                                       ("R",
                                                        ATy(qTy,
                                                            PTy(F32,qTy)),
                                                        Var("n",F4)),
                                                     Close
                                                       (Var("v",F32),
                                                        MB(MU(TP[Var("v",
                                                                     F32),
                                                                 Bop(Add,
                                                                     Mop(Cast
                                                                           F4,
                                                                         EX(Var("SYSm",
                                                                                FTy 5),
                                                                            LN
                                                                             2,
                                                                            LN
                                                                             0,
                                                                            FTy 3)),
                                                                     LW(8,
                                                                        4)),
                                                                 LW(16,5)],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F32,
                                                                      PTy(F4,
                                                                          FTy 5))),
                                                              Call
                                                                ("write'Rmode",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F32,
                                                                         PTy(F4,
                                                                             FTy 5))))))))),
                                                 (EQ(EX(Var("SYSm",FTy 5),
                                                        LN 4,LN 3,FTy 2),
                                                     LW(1,2)),
                                                  MB(Call
                                                       ("R",
                                                        ATy(qTy,
                                                            PTy(F32,qTy)),
                                                        Var("n",F4)),
                                                     Close
                                                       (Var("v",F32),
                                                        MB(MU(TP[Var("v",
                                                                     F32),
                                                                 Bop(Add,
                                                                     Mop(Cast
                                                                           F4,
                                                                         EX(Var("SYSm",
                                                                                FTy 5),
                                                                            LN
                                                                             2,
                                                                            LN
                                                                             0,
                                                                            FTy 3)),
                                                                     LW(8,
                                                                        4)),
                                                                 LW(17,5)],
                                                              qTy),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F32,
                                                                      PTy(F4,
                                                                          FTy 5))),
                                                              Call
                                                                ("write'Rmode",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F32,
                                                                         PTy(F4,
                                                                             FTy 5))))))))),
                                                 (EQ(EX(Var("SYSm",FTy 5),
                                                        LN 4,LN 3,FTy 2),
                                                     LW(3,2)),
                                                  ITB([(Mop(Not,
                                                            Bop(Bit,
                                                                Var("SYSm",
                                                                    FTy 5),
                                                                LN 1)),
                                                        MB(Call
                                                             ("R",
                                                              ATy(qTy,
                                                                  PTy(F32,
                                                                      qTy)),
                                                              Var("n",F4)),
                                                           Close
                                                             (Var("v",F32),
                                                              MB(MU(TP[Var("v",
                                                                           F32),
                                                                       Bop(Add,
                                                                           Mop(Cast
                                                                                 F4,
                                                                               Bop(Bit,
                                                                                   Var("SYSm",
                                                                                       FTy 5),
                                                                                   LN
                                                                                    0)),
                                                                           LW(13,
                                                                              4)),
                                                                       LW(22,
                                                                          5)],
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F32,
                                                                            PTy(F4,
                                                                                FTy 5))),
                                                                    Call
                                                                      ("write'Rmode",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F32,
                                                                               PTy(F4,
                                                                                   FTy 5))))))))),
                                                       (Mop(Not,
                                                            Bop(Bit,
                                                                Var("SYSm",
                                                                    FTy 5),
                                                                LN 0)),
                                                        MB(Call
                                                             ("R",
                                                              ATy(qTy,
                                                                  PTy(F32,
                                                                      qTy)),
                                                              Var("n",F4)),
                                                           Close
                                                             (Var("v",F32),
                                                              MB(MU(TP[Var("v",
                                                                           F32),
                                                                       LW(13,
                                                                          4),
                                                                       LW(26,
                                                                          5)],
                                                                    qTy),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F32,
                                                                            PTy(F4,
                                                                                FTy 5))),
                                                                    Call
                                                                      ("write'Rmode",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F32,
                                                                               PTy(F4,
                                                                                   FTy 5)))))))))],
                                                      MB(Call
                                                           ("R",
                                                            ATy(qTy,
                                                                PTy(F32,
                                                                    qTy)),
                                                            Var("n",F4)),
                                                         Close
                                                           (Var("v",F32),
                                                            MW(Close
                                                                 (qVar"s",
                                                                  Rupd
                                                                    ("ELR_hyp",
                                                                     TP[qVar"s",
                                                                        Var("v",
                                                                            F32)])))))))],
                                                MN(LX(FTy 5),
                                                   MB(MR(Close
                                                           (Var("s",
                                                                PTy(FTy 5,
                                                                    qTy)),
                                                            Mop(Fst,
                                                                Var("s",
                                                                    PTy(FTy 5,
                                                                        qTy))))),
                                                      Close
                                                        (Var("v",FTy 5),
                                                         MB(MB(MU(BFI(LN 0,
                                                                      LN 0,
                                                                      Mop(Cast
                                                                            F1,
                                                                          Bop(Or,
                                                                              Bop(Bit,
                                                                                  Var("SYSm",
                                                                                      FTy 5),
                                                                                  LN
                                                                                   2),
                                                                              Bop(Bit,
                                                                                  Var("SYSm",
                                                                                      FTy 5),
                                                                                  LN
                                                                                   1))),
                                                                      Var("v",
                                                                          FTy 5)),
                                                                  PTy(FTy 5,
                                                                      qTy)),
                                                               Close
                                                                 (Var("v",
                                                                      FTy 5),
                                                                  MW(Close
                                                                       (Var("s",
                                                                            PTy(FTy 5,
                                                                                qTy)),
                                                                        TP[Var("v",
                                                                               FTy 5),
                                                                           Mop(Snd,
                                                                               Var("s",
                                                                                   PTy(FTy 5,
                                                                                       qTy)))])))),
                                                            Close
                                                              (AVar uTy,
                                                               MB(MR(Close
                                                                       (Var("s",
                                                                            PTy(FTy 5,
                                                                                qTy)),
                                                                        Mop(Fst,
                                                                            Var("s",
                                                                                PTy(FTy 5,
                                                                                    qTy))))),
                                                                  Close
                                                                    (Var("v",
                                                                         FTy 5),
                                                                     MB(MB(MU(BFI(LN
                                                                                   1,
                                                                                  LN
                                                                                   1,
                                                                                  Mop(Cast
                                                                                        F1,
                                                                                      LT),
                                                                                  Var("v",
                                                                                      FTy 5)),
                                                                              PTy(FTy 5,
                                                                                  qTy)),
                                                                           Close
                                                                             (Var("v",
                                                                                  FTy 5),
                                                                              MW(Close
                                                                                   (Var("s",
                                                                                        PTy(FTy 5,
                                                                                            qTy)),
                                                                                    TP[Var("v",
                                                                                           FTy 5),
                                                                                       Mop(Snd,
                                                                                           Var("s",
                                                                                               PTy(FTy 5,
                                                                                                   qTy)))])))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MB(MR(Close
                                                                                   (Var("s",
                                                                                        PTy(FTy 5,
                                                                                            qTy)),
                                                                                    Mop(Fst,
                                                                                        Var("s",
                                                                                            PTy(FTy 5,
                                                                                                qTy))))),
                                                                              Close
                                                                                (Var("v",
                                                                                     FTy 5),
                                                                                 MB(MB(MU(BFI(LN
                                                                                               2,
                                                                                              LN
                                                                                               2,
                                                                                              Mop(Cast
                                                                                                    F1,
                                                                                                  Bop(And,
                                                                                                      Bop(Bit,
                                                                                                          Var("SYSm",
                                                                                                              FTy 5),
                                                                                                          LN
                                                                                                           2),
                                                                                                      Mop(Not,
                                                                                                          Bop(Bit,
                                                                                                              Var("SYSm",
                                                                                                                  FTy 5),
                                                                                                              LN
                                                                                                               1)))),
                                                                                              Var("v",
                                                                                                  FTy 5)),
                                                                                          PTy(FTy 5,
                                                                                              qTy)),
                                                                                       Close
                                                                                         (Var("v",
                                                                                              FTy 5),
                                                                                          MW(Close
                                                                                               (Var("s",
                                                                                                    PTy(FTy 5,
                                                                                                        qTy)),
                                                                                                TP[Var("v",
                                                                                                       FTy 5),
                                                                                                   Mop(Snd,
                                                                                                       Var("s",
                                                                                                           PTy(FTy 5,
                                                                                                               qTy)))])))),
                                                                                    Close
                                                                                      (AVar
                                                                                         uTy,
                                                                                       MB(MR(Close
                                                                                               (Var("s",
                                                                                                    PTy(FTy 5,
                                                                                                        qTy)),
                                                                                                Mop(Fst,
                                                                                                    Var("s",
                                                                                                        PTy(FTy 5,
                                                                                                            qTy))))),
                                                                                          Close
                                                                                            (Var("v",
                                                                                                 FTy 5),
                                                                                             MB(MB(MU(BFI(LN
                                                                                                           3,
                                                                                                          LN
                                                                                                           3,
                                                                                                          Mop(Cast
                                                                                                                F1,
                                                                                                              Bop(And,
                                                                                                                  Bop(Bit,
                                                                                                                      Var("SYSm",
                                                                                                                          FTy 5),
                                                                                                                      LN
                                                                                                                       2),
                                                                                                                  Bop(Bit,
                                                                                                                      Var("SYSm",
                                                                                                                          FTy 5),
                                                                                                                      LN
                                                                                                                       1))),
                                                                                                          Var("v",
                                                                                                              FTy 5)),
                                                                                                      PTy(FTy 5,
                                                                                                          qTy)),
                                                                                                   Close
                                                                                                     (Var("v",
                                                                                                          FTy 5),
                                                                                                      MW(Close
                                                                                                           (Var("s",
                                                                                                                PTy(FTy 5,
                                                                                                                    qTy)),
                                                                                                            TP[Var("v",
                                                                                                                   FTy 5),
                                                                                                               Mop(Snd,
                                                                                                                   Var("s",
                                                                                                                       PTy(FTy 5,
                                                                                                                           qTy)))])))),
                                                                                                Close
                                                                                                  (AVar
                                                                                                     uTy,
                                                                                                   MB(MR(Close
                                                                                                           (Var("s",
                                                                                                                PTy(FTy 5,
                                                                                                                    qTy)),
                                                                                                            Mop(Fst,
                                                                                                                Var("s",
                                                                                                                    PTy(FTy 5,
                                                                                                                        qTy))))),
                                                                                                      Close
                                                                                                        (Var("v",
                                                                                                             FTy 5),
                                                                                                         MB(MB(MU(BFI(LN
                                                                                                                       4,
                                                                                                                      LN
                                                                                                                       4,
                                                                                                                      Mop(Cast
                                                                                                                            F1,
                                                                                                                          LT),
                                                                                                                      Var("v",
                                                                                                                          FTy 5)),
                                                                                                                  PTy(FTy 5,
                                                                                                                      qTy)),
                                                                                                               Close
                                                                                                                 (Var("v",
                                                                                                                      FTy 5),
                                                                                                                  MW(Close
                                                                                                                       (Var("s",
                                                                                                                            PTy(FTy 5,
                                                                                                                                qTy)),
                                                                                                                        TP[Var("v",
                                                                                                                               FTy 5),
                                                                                                                           Mop(Snd,
                                                                                                                               Var("s",
                                                                                                                                   PTy(FTy 5,
                                                                                                                                       qTy)))])))),
                                                                                                            Close
                                                                                                              (AVar
                                                                                                                 uTy,
                                                                                                               MB(MR(Close
                                                                                                                       (Var("s",
                                                                                                                            PTy(FTy 5,
                                                                                                                                qTy)),
                                                                                                                        Mop(Fst,
                                                                                                                            Var("s",
                                                                                                                                PTy(FTy 5,
                                                                                                                                    qTy))))),
                                                                                                                  Close
                                                                                                                    (Var("v",
                                                                                                                         FTy 5),
                                                                                                                     MB(MU(EQ(Var("mode",
                                                                                                                                  FTy 5),
                                                                                                                              Var("v",
                                                                                                                                  FTy 5)),
                                                                                                                           PTy(FTy 5,
                                                                                                                               qTy)),
                                                                                                                        Close
                                                                                                                          (bVar"b",
                                                                                                                           ITE(bVar"b",
                                                                                                                               MD(Call
                                                                                                                                    ("raise'exception",
                                                                                                                                     ATy(qTy,
                                                                                                                                         PTy(uTy,
                                                                                                                                             qTy)),
                                                                                                                                     Call
                                                                                                                                       ("UNPREDICTABLE",
                                                                                                                                        CTy"exception",
                                                                                                                                        LS
                                                                                                                                         "MoveToBankedOrSpecialRegister")),
                                                                                                                                  FTy 5),
                                                                                                                               MB(MR(Close
                                                                                                                                       (Var("s",
                                                                                                                                            PTy(FTy 5,
                                                                                                                                                qTy)),
                                                                                                                                        Mop(Fst,
                                                                                                                                            Var("s",
                                                                                                                                                PTy(FTy 5,
                                                                                                                                                    qTy))))),
                                                                                                                                  Close
                                                                                                                                    (Var("v",
                                                                                                                                         FTy 5),
                                                                                                                                     MB(MU(TP[Bop(Add,
                                                                                                                                                  Mop(Cast
                                                                                                                                                        F4,
                                                                                                                                                      Bop(Bit,
                                                                                                                                                          Var("SYSm",
                                                                                                                                                              FTy 5),
                                                                                                                                                          LN
                                                                                                                                                           0)),
                                                                                                                                                  LW(13,
                                                                                                                                                     4)),
                                                                                                                                              Var("v",
                                                                                                                                                  FTy 5)],
                                                                                                                                           PTy(FTy 5,
                                                                                                                                               qTy)),
                                                                                                                                        Close
                                                                                                                                          (Var("x",
                                                                                                                                               PTy(F4,
                                                                                                                                                   FTy 5)),
                                                                                                                                           MB(MD(Call
                                                                                                                                                   ("R",
                                                                                                                                                    ATy(qTy,
                                                                                                                                                        PTy(F32,
                                                                                                                                                            qTy)),
                                                                                                                                                    Var("n",
                                                                                                                                                        F4)),
                                                                                                                                                 FTy 5),
                                                                                                                                              Close
                                                                                                                                                (Var("v",
                                                                                                                                                     F32),
                                                                                                                                                 MB(MU(TP[Var("v",
                                                                                                                                                              F32),
                                                                                                                                                          Var("x",
                                                                                                                                                              PTy(F4,
                                                                                                                                                                  FTy 5))],
                                                                                                                                                       PTy(FTy 5,
                                                                                                                                                           qTy)),
                                                                                                                                                    Close
                                                                                                                                                      (Var("v",
                                                                                                                                                           PTy(F32,
                                                                                                                                                               PTy(F4,
                                                                                                                                                                   FTy 5))),
                                                                                                                                                       MD(Call
                                                                                                                                                            ("write'Rmode",
                                                                                                                                                             ATy(qTy,
                                                                                                                                                                 PTy(uTy,
                                                                                                                                                                     qTy)),
                                                                                                                                                             Var("v",
                                                                                                                                                                 PTy(F32,
                                                                                                                                                                     PTy(F4,
                                                                                                                                                                         FTy 5)))),
                                                                                                                                                          FTy 5))))))))))))))))))))))))))))))))))))))),
                                  Close
                                    (AVar uTy,
                                     Call
                                       ("IncPC",ATy(qTy,PTy(uTy,qTy)),LU)))))))))))))
;
val dfn'ReturnFromException_def = Def
  ("dfn'ReturnFromException",
   TP[bVar"increment",bVar"wordhigher",bVar"wback",Var("n",F4)],
   MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"b",
         ITE(bVar"b",
             Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU),
             MB(Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
                Close
                  (bVar"v",
                   MB(MB(MU(Mop(Not,bVar"v"),qTy),
                         Close
                           (bVar"b",
                            ITE(bVar"b",MU(LT,qTy),
                                MB(Call
                                     ("CurrentInstrSet",
                                      ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
                                   Close
                                     (Var("v",CTy"InstrSet"),
                                      MU(EQ(Var("v",CTy"InstrSet"),
                                            LC("InstrSet_ThumbEE",
                                               CTy"InstrSet")),qTy)))))),
                      Close
                        (bVar"b",
                         ITE(bVar"b",
                             Call
                               ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                                Call
                                  ("UNPREDICTABLE",CTy"exception",
                                   LS"ReturnFromException")),
                             MB(Call
                                  ("R",ATy(qTy,PTy(F32,qTy)),Var("n",F4)),
                                Close
                                  (Var("Rn",F32),
                                   Let(Var("address",F32),
                                       ITE(bVar"increment",Var("Rn",F32),
                                           Bop(Sub,Var("Rn",F32),LW(8,32))),
                                       Let(Var("address",F32),
                                           ITE(bVar"wordhigher",
                                               Bop(Add,Var("address",F32),
                                                   LW(4,32)),
                                               Var("address",F32)),
                                           MB(Call
                                                ("MemA",
                                                 ATy(qTy,PTy(F32,qTy)),
                                                 TP[Var("address",F32),
                                                    LN 4]),
                                              Close
                                                (Var("new_pc_value",F32),
                                                 MB(Call
                                                      ("MemA",
                                                       ATy(qTy,
                                                           PTy(F32,qTy)),
                                                       TP[Bop(Add,
                                                              Var("address",
                                                                  F32),
                                                              LW(4,32)),
                                                          LN 4]),
                                                    Close
                                                      (Var("data",F32),
                                                       MB(MR(Close
                                                               (qVar"s",
                                                                Dest
                                                                  ("data_abort",
                                                                   bTy,
                                                                   qVar"s"))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 Call
                                                                   ("TakeDataAbortException",
                                                                    ATy(qTy,
                                                                        PTy(uTy,
                                                                            qTy)),
                                                                    LU),
                                                                 MB(Call
                                                                      ("CPSRWriteByInstr",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("data",
                                                                              F32),
                                                                          LW(15,
                                                                             4),
                                                                          LT]),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MB(MR(Close
                                                                               (qVar"s",
                                                                                Dest
                                                                                  ("CPSR",
                                                                                   CTy"PSR",
                                                                                   qVar"s"))),
                                                                          Close
                                                                            (Var("v",
                                                                                 CTy"PSR"),
                                                                             MB(MB(MB(MB(MU(Dest
                                                                                              ("M",
                                                                                               FTy 5,
                                                                                               Var("v",
                                                                                                   CTy"PSR")),
                                                                                            qTy),
                                                                                         Close
                                                                                           (Var("v",
                                                                                                FTy 5),
                                                                                            MU(EQ(Var("v",
                                                                                                      FTy 5),
                                                                                                  LW(26,
                                                                                                     5)),
                                                                                               qTy))),
                                                                                      Close
                                                                                        (bVar"b",
                                                                                         ITE(bVar"b",
                                                                                             MB(MR(Close
                                                                                                     (qVar"s",
                                                                                                      Dest
                                                                                                        ("CPSR",
                                                                                                         CTy"PSR",
                                                                                                         qVar"s"))),
                                                                                                Close
                                                                                                  (Var("v",
                                                                                                       CTy"PSR"),
                                                                                                   MU(Dest
                                                                                                        ("J",
                                                                                                         bTy,
                                                                                                         Var("v",
                                                                                                             CTy"PSR")),
                                                                                                      qTy))),
                                                                                             MU(LF,
                                                                                                qTy)))),
                                                                                   Close
                                                                                     (bVar"b",
                                                                                      ITE(bVar"b",
                                                                                          MB(MR(Close
                                                                                                  (qVar"s",
                                                                                                   Dest
                                                                                                     ("CPSR",
                                                                                                      CTy"PSR",
                                                                                                      qVar"s"))),
                                                                                             Close
                                                                                               (Var("v",
                                                                                                    CTy"PSR"),
                                                                                                MU(Dest
                                                                                                     ("T",
                                                                                                      bTy,
                                                                                                      Var("v",
                                                                                                          CTy"PSR")),
                                                                                                   qTy))),
                                                                                          MU(LF,
                                                                                             qTy)))),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   ITE(bVar"b",
                                                                                       Call
                                                                                         ("raise'exception",
                                                                                          ATy(qTy,
                                                                                              PTy(uTy,
                                                                                                  qTy)),
                                                                                          Call
                                                                                            ("UNPREDICTABLE",
                                                                                             CTy"exception",
                                                                                             LS
                                                                                              "ReturnFromException")),
                                                                                       Call
                                                                                         ("BranchWritePC",
                                                                                          ATy(qTy,
                                                                                              PTy(uTy,
                                                                                                  qTy)),
                                                                                          Var("new_pc_value",
                                                                                              F32)))))))))))))))))))))))))))))
;
val dfn'SecureMonitorCall_def = Def
  ("dfn'SecureMonitorCall",Var("imm4",F4),
   MB(Call("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"v",
         MB(ITE(bVar"v",
                Call("CurrentModeIsNotUser",ATy(qTy,PTy(bTy,qTy)),LU),
                MU(LF,qTy)),
            Close
              (bVar"b",
               ITE(bVar"b",
                   MB(Call("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
                      Close
                        (bVar"v",
                         MB(MB(MB(ITE(bVar"v",
                                      MB(Call
                                           ("IsSecure",
                                            ATy(qTy,PTy(bTy,qTy)),LU),
                                         Close
                                           (bVar"v",
                                            MU(Mop(Not,bVar"v"),qTy))),
                                      MU(LF,qTy)),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MB(Call
                                              ("CurrentModeIsHyp",
                                               ATy(qTy,PTy(bTy,qTy)),LU),
                                            Close
                                              (bVar"v",
                                               MU(Mop(Not,bVar"v"),qTy))),
                                         MU(LF,qTy)))),
                               Close
                                 (bVar"b",
                                  ITE(bVar"b",
                                      MB(MR(Close
                                              (qVar"s",
                                               Dest
                                                 ("CP15",CTy"CP15",qVar"s"))),
                                         Close
                                           (Var("v",CTy"CP15"),
                                            MB(MU(Dest
                                                    ("HCR",CTy"HCR",
                                                     Var("v",CTy"CP15")),
                                                  qTy),
                                               Close
                                                 (Var("v",CTy"HCR"),
                                                  MU(Dest
                                                       ("TSC",bTy,
                                                        Var("v",CTy"HCR")),
                                                     qTy))))),MU(LF,qTy)))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   MB(Call
                                        ("WriteHSR",ATy(qTy,PTy(uTy,qTy)),
                                         TP[LW(19,6),LW(0,25)]),
                                      Close
                                        (AVar uTy,
                                         Call
                                           ("TakeHypTrapException",
                                            ATy(qTy,PTy(uTy,qTy)),LU))),
                                   MB(MR(Close
                                           (qVar"s",
                                            Dest("CP15",CTy"CP15",qVar"s"))),
                                      Close
                                        (Var("v",CTy"CP15"),
                                         MB(MB(MU(Dest
                                                    ("SCR",CTy"SCR",
                                                     Var("v",CTy"CP15")),
                                                  qTy),
                                               Close
                                                 (Var("v",CTy"SCR"),
                                                  MU(Dest
                                                       ("SCD",bTy,
                                                        Var("v",CTy"SCR")),
                                                     qTy))),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MB(Call
                                                        ("IsSecure",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         LU),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             Call
                                                               ("raise'exception",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                Call
                                                                  ("UNPREDICTABLE",
                                                                   CTy"exception",
                                                                   LS
                                                                    "SecureMonitorCall")),
                                                             Call
                                                               ("TakeUndefInstrException",
                                                                ATy(qTy,
                                                                    PTy(uTy,
                                                                        qTy)),
                                                                LU)))),
                                                   Call
                                                     ("TakeSMCException",
                                                      ATy(qTy,PTy(uTy,qTy)),
                                                      LU))))))))))),
                   Call
                     ("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU)))))))
;
val dfn'SupervisorCall_def = Def
  ("dfn'SupervisorCall",Var("imm32",F32),
   Call
     ("CallSupervisor",ATy(qTy,PTy(uTy,qTy)),
      EX(Var("imm32",F32),LN 15,LN 0,F16)))
;
val dfn'StoreReturnState_def = Def
  ("dfn'StoreReturnState",
   TP[bVar"increment",bVar"wordhigher",bVar"wback",Var("mode",FTy 5)],
   MB(Call("CurrentModeIsHyp",ATy(qTy,PTy(bTy,qTy)),LU),
      Close
        (bVar"b",
         ITE(bVar"b",
             Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU),
             MB(Call("CurrentModeIsUserOrSystem",ATy(qTy,PTy(bTy,qTy)),LU),
                Close
                  (bVar"v",
                   MB(ITE(bVar"v",MU(LT,qTy),
                          MB(Call
                               ("CurrentInstrSet",
                                ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
                             Close
                               (Var("v",CTy"InstrSet"),
                                MU(EQ(Var("v",CTy"InstrSet"),
                                      LC("InstrSet_ThumbEE",CTy"InstrSet")),
                                   qTy)))),
                      Close
                        (bVar"b",
                         ITB([(bVar"b",
                               Call
                                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                                  Call
                                    ("UNPREDICTABLE",CTy"exception",
                                     LS"StoreReturnState"))),
                              (EQ(Var("mode",FTy 5),LW(26,5)),
                               Call
                                 ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
                                  Call
                                    ("UNPREDICTABLE",CTy"exception",
                                     LS"StoreReturnState")))],
                             MB(Call("IsSecure",ATy(qTy,PTy(bTy,qTy)),LU),
                                Close
                                  (bVar"v",
                                   MB(MB(MU(Mop(Not,bVar"v"),qTy),
                                         Close
                                           (bVar"b",
                                            ITE(bVar"b",
                                                MB(MR(Close
                                                        (qVar"s",
                                                         Dest
                                                           ("CP15",
                                                            CTy"CP15",
                                                            qVar"s"))),
                                                   Close
                                                     (Var("v",CTy"CP15"),
                                                      MB(MB(MB(MB(MU(Dest
                                                                       ("NSACR",
                                                                        CTy"NSACR",
                                                                        Var("v",
                                                                            CTy"CP15")),
                                                                     qTy),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"NSACR"),
                                                                     MU(Dest
                                                                          ("RFR",
                                                                           bTy,
                                                                           Var("v",
                                                                               CTy"NSACR")),
                                                                        qTy))),
                                                               Close
                                                                 (bVar"v",
                                                                  MU(Bop(And,
                                                                         EQ(Var("mode",
                                                                                FTy 5),
                                                                            LW(17,
                                                                               5)),
                                                                         bVar"v"),
                                                                     qTy))),
                                                            Close
                                                              (bVar"v",
                                                               MU(Bop(Or,
                                                                      EQ(Var("mode",
                                                                             FTy 5),
                                                                         LW(22,
                                                                            5)),
                                                                      bVar"v"),
                                                                  qTy))),
                                                         Close
                                                           (bVar"b",
                                                            ITE(bVar"b",
                                                                Call
                                                                  ("raise'exception",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   Call
                                                                     ("UNPREDICTABLE",
                                                                      CTy"exception",
                                                                      LS
                                                                       "StoreReturnState")),
                                                                MU(LU,qTy)))))),
                                                MU(LU,qTy)))),
                                      Close
                                        (AVar uTy,
                                         MB(Call
                                              ("Rmode",
                                               ATy(qTy,PTy(F32,qTy)),
                                               TP[LW(13,4),
                                                  Var("mode",FTy 5)]),
                                            Close
                                              (Var("base",F32),
                                               Let(Var("address",F32),
                                                   ITE(bVar"increment",
                                                       Var("base",F32),
                                                       Bop(Sub,
                                                           Var("base",F32),
                                                           LW(8,32))),
                                                   Let(Var("address",F32),
                                                       ITE(bVar"wordhigher",
                                                           Bop(Add,
                                                               Var("address",
                                                                   F32),
                                                               LW(4,32)),
                                                           Var("address",
                                                               F32)),
                                                       MB(MB(Const
                                                               ("LR",
                                                                ATy(qTy,
                                                                    PTy(F32,
                                                                        qTy))),
                                                             Close
                                                               (Var("v",
                                                                    F32),
                                                                MB(MU(TP[Var("v",
                                                                             F32),
                                                                         Var("address",
                                                                             F32),
                                                                         LN
                                                                          4],
                                                                      qTy),
                                                                   Close
                                                                     (Var("v",
                                                                          PTy(F32,
                                                                              PTy(F32,
                                                                                  nTy))),
                                                                      Call
                                                                        ("write'MemA",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         Var("v",
                                                                             PTy(F32,
                                                                                 PTy(F32,
                                                                                     nTy)))))))),
                                                          Close
                                                            (AVar uTy,
                                                             MB(MB(Const
                                                                     ("SPSR",
                                                                      ATy(qTy,
                                                                          PTy(CTy"PSR",
                                                                              qTy))),
                                                                   Close
                                                                     (Var("v",
                                                                          CTy"PSR"),
                                                                      MB(MB(MU(Call
                                                                                 ("reg'PSR",
                                                                                  F32,
                                                                                  Var("v",
                                                                                      CTy"PSR")),
                                                                               qTy),
                                                                            Close
                                                                              (Var("v",
                                                                                   F32),
                                                                               MU(TP[Var("v",
                                                                                         F32),
                                                                                     Bop(Add,
                                                                                         Var("address",
                                                                                             F32),
                                                                                         LW(4,
                                                                                            32)),
                                                                                     LN
                                                                                      4],
                                                                                  qTy))),
                                                                         Close
                                                                           (Var("v",
                                                                                PTy(F32,
                                                                                    PTy(F32,
                                                                                        nTy))),
                                                                            Call
                                                                              ("write'MemA",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               Var("v",
                                                                                   PTy(F32,
                                                                                       PTy(F32,
                                                                                           nTy)))))))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MB(MR(Close
                                                                           (qVar"s",
                                                                            Dest
                                                                              ("data_abort",
                                                                               bTy,
                                                                               qVar"s"))),
                                                                      Close
                                                                        (bVar"b",
                                                                         ITE(bVar"b",
                                                                             Call
                                                                               ("TakeDataAbortException",
                                                                                ATy(qTy,
                                                                                    PTy(uTy,
                                                                                        qTy)),
                                                                                LU),
                                                                             MB(ITE(bVar"wback",
                                                                                    Call
                                                                                      ("write'Rmode",
                                                                                       ATy(qTy,
                                                                                           PTy(uTy,
                                                                                               qTy)),
                                                                                       TP[ITE(bVar"increment",
                                                                                              Bop(Add,
                                                                                                  Var("base",
                                                                                                      F32),
                                                                                                  LW(8,
                                                                                                     32)),
                                                                                              Bop(Sub,
                                                                                                  Var("base",
                                                                                                      F32),
                                                                                                  LW(8,
                                                                                                     32))),
                                                                                          LW(13,
                                                                                             4),
                                                                                          Var("mode",
                                                                                              FTy 5)]),
                                                                                    MU(LU,
                                                                                       qTy)),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   Call
                                                                                     ("IncPC",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      LU)))))))))))))))))))))))))))
;
val dfn'Setend_def = Def
  ("dfn'Setend",bVar"set_bigend",
   MB(MR(Close(qVar"s",Dest("CPSR",CTy"PSR",qVar"s"))),
      Close
        (Var("v",CTy"PSR"),
         MB(MB(MB(MU(TP[Var("v",CTy"PSR"),bVar"set_bigend"],qTy),
                  Close
                    (Var("v",PTy(CTy"PSR",bTy)),
                     MU(Rupd("E",Var("v",PTy(CTy"PSR",bTy))),qTy))),
               Close
                 (Var("v",CTy"PSR"),
                  MW(Close
                       (qVar"s",Rupd("CPSR",TP[qVar"s",Var("v",CTy"PSR")]))))),
            Close(AVar uTy,Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))))))
;
val dfn'Undefined_def = Def
  ("dfn'Undefined",Var("imm32",F32),
   Call("TakeUndefInstrException",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'NoOperation_def = Def0
  ("dfn'NoOperation",Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'Breakpoint_def = Def
  ("dfn'Breakpoint",Var("imm32",F32),
   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'Debug_def = Def
  ("dfn'Debug",Var("option",F4),Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'DataMemoryBarrier_def = Def
  ("dfn'DataMemoryBarrier",Var("option",F4),
   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'DataSynchronizationBarrier_def = Def
  ("dfn'DataSynchronizationBarrier",Var("option",F4),
   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'InstructionSynchronizationBarrier_def = Def
  ("dfn'InstructionSynchronizationBarrier",Var("option",F4),
   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'PreloadData_def = Def
  ("dfn'PreloadData",
   TP[bVar"add",bVar"is_pldw",Var("n",F4),Var("m",CTy"offset1")],
   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'PreloadDataLiteral_def = Def
  ("dfn'PreloadDataLiteral",TP[bVar"add",Var("imm32",F32)],
   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'PreloadInstruction_def = Def
  ("dfn'PreloadInstruction",
   TP[bVar"add",Var("n",F4),Var("m",CTy"offset1")],
   Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'SendEvent_def = Def0
  ("dfn'SendEvent",Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'WaitForEvent_def = Def0
  ("dfn'WaitForEvent",Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'WaitForInterrupt_def = Def0
  ("dfn'WaitForInterrupt",Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val dfn'Yield_def = Def0
  ("dfn'Yield",Call("IncPC",ATy(qTy,PTy(uTy,qTy)),LU))
;
val Run_def = Def
  ("Run",Var("v0",CTy"instruction"),
   CS(Var("v0",CTy"instruction"),
      [(Const("ClearExclusive",CTy"instruction"),
        Const("dfn'ClearExclusive",ATy(qTy,PTy(uTy,qTy)))),
       (Const("NoOperation",CTy"instruction"),
        Const("dfn'NoOperation",ATy(qTy,PTy(uTy,qTy)))),
       (Call
          ("Divide",CTy"instruction",
           Var("v126",PTy(bTy,PTy(F4,PTy(F4,F4))))),
        Call
          ("dfn'Divide",ATy(qTy,PTy(uTy,qTy)),
           Var("v126",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
       (Call("IfThen",CTy"instruction",Var("v127",PTy(F4,F4))),
        Call("dfn'IfThen",ATy(qTy,PTy(uTy,qTy)),Var("v127",PTy(F4,F4)))),
       (Call
          ("Swap",CTy"instruction",Var("v128",PTy(bTy,PTy(F4,PTy(F4,F4))))),
        Call
          ("dfn'Swap",ATy(qTy,PTy(uTy,qTy)),
           Var("v128",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
       (Call("Undefined",CTy"instruction",Var("v129",F32)),
        Call("dfn'Undefined",ATy(qTy,PTy(uTy,qTy)),Var("v129",F32))),
       (Call("Branch",CTy"instruction",Var("v1",CTy"Branch")),
        CS(Var("v1",CTy"Branch"),
           [(Call("BranchExchange",CTy"Branch",Var("v2",F4)),
             Call("dfn'BranchExchange",ATy(qTy,PTy(uTy,qTy)),Var("v2",F4))),
            (Call
               ("BranchLinkExchangeImmediate",CTy"Branch",
                Var("v3",PTy(CTy"InstrSet",F32))),
             Call
               ("dfn'BranchLinkExchangeImmediate",ATy(qTy,PTy(uTy,qTy)),
                Var("v3",PTy(CTy"InstrSet",F32)))),
            (Call("BranchLinkExchangeRegister",CTy"Branch",Var("v4",F4)),
             Call
               ("dfn'BranchLinkExchangeRegister",ATy(qTy,PTy(uTy,qTy)),
                Var("v4",F4))),
            (Call("BranchTarget",CTy"Branch",Var("v5",F32)),
             Call("dfn'BranchTarget",ATy(qTy,PTy(uTy,qTy)),Var("v5",F32))),
            (Call("CheckArray",CTy"Branch",Var("v6",PTy(F4,F4))),
             Call
               ("dfn'CheckArray",ATy(qTy,PTy(uTy,qTy)),
                Var("v6",PTy(F4,F4)))),
            (Call
               ("CompareBranch",CTy"Branch",Var("v7",PTy(bTy,PTy(F4,F32)))),
             Call
               ("dfn'CompareBranch",ATy(qTy,PTy(uTy,qTy)),
                Var("v7",PTy(bTy,PTy(F4,F32))))),
            (Call("HandlerBranchLink",CTy"Branch",Var("v8",PTy(bTy,F32))),
             Call
               ("dfn'HandlerBranchLink",ATy(qTy,PTy(uTy,qTy)),
                Var("v8",PTy(bTy,F32)))),
            (Call
               ("HandlerBranchLinkParameter",CTy"Branch",
                Var("v9",PTy(F32,F32))),
             Call
               ("dfn'HandlerBranchLinkParameter",ATy(qTy,PTy(uTy,qTy)),
                Var("v9",PTy(F32,F32)))),
            (Call
               ("HandlerBranchParameter",CTy"Branch",
                Var("v10",PTy(F32,F32))),
             Call
               ("dfn'HandlerBranchParameter",ATy(qTy,PTy(uTy,qTy)),
                Var("v10",PTy(F32,F32)))),
            (Call
               ("TableBranchByte",CTy"Branch",
                Var("v11",PTy(bTy,PTy(F4,F4)))),
             Call
               ("dfn'TableBranchByte",ATy(qTy,PTy(uTy,qTy)),
                Var("v11",PTy(bTy,PTy(F4,F4)))))])),
       (Call("Data",CTy"instruction",Var("v12",CTy"Data")),
        CS(Var("v12",CTy"Data"),
           [(Call
               ("AddSub",CTy"Data",
                Var("v13",PTy(bTy,PTy(F4,PTy(F4,FTy 12))))),
             Call
               ("dfn'AddSub",ATy(qTy,PTy(uTy,qTy)),
                Var("v13",PTy(bTy,PTy(F4,PTy(F4,FTy 12)))))),
            (Call
               ("ArithLogicImmediate",CTy"Data",
                Var("v14",PTy(F4,PTy(bTy,PTy(F4,PTy(F4,FTy 12)))))),
             Call
               ("dfn'ArithLogicImmediate",ATy(qTy,PTy(uTy,qTy)),
                Var("v14",PTy(F4,PTy(bTy,PTy(F4,PTy(F4,FTy 12))))))),
            (Call("CountLeadingZeroes",CTy"Data",Var("v15",PTy(F4,F4))),
             Call
               ("dfn'CountLeadingZeroes",ATy(qTy,PTy(uTy,qTy)),
                Var("v15",PTy(F4,F4)))),
            (Call
               ("Move",CTy"Data",
                Var("v16",PTy(bTy,PTy(bTy,PTy(F4,FTy 12))))),
             Call
               ("dfn'Move",ATy(qTy,PTy(uTy,qTy)),
                Var("v16",PTy(bTy,PTy(bTy,PTy(F4,FTy 12)))))),
            (Call
               ("MoveHalfword",CTy"Data",Var("v17",PTy(bTy,PTy(F4,F16)))),
             Call
               ("dfn'MoveHalfword",ATy(qTy,PTy(uTy,qTy)),
                Var("v17",PTy(bTy,PTy(F4,F16))))),
            (Call
               ("Register",CTy"Data",
                Var("v18",
                    PTy(F4,
                        PTy(bTy,
                            PTy(F4,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy)))))))),
             Call
               ("dfn'Register",ATy(qTy,PTy(uTy,qTy)),
                Var("v18",
                    PTy(F4,
                        PTy(bTy,
                            PTy(F4,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy))))))))),
            (Call
               ("RegisterShiftedRegister",CTy"Data",
                Var("v19",
                    PTy(F4,
                        PTy(bTy,
                            PTy(F4,PTy(F4,PTy(F4,PTy(CTy"SRType",F4)))))))),
             Call
               ("dfn'RegisterShiftedRegister",ATy(qTy,PTy(uTy,qTy)),
                Var("v19",
                    PTy(F4,
                        PTy(bTy,
                            PTy(F4,PTy(F4,PTy(F4,PTy(CTy"SRType",F4))))))))),
            (Call
               ("ShiftImmediate",CTy"Data",
                Var("v20",
                    PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy))))))),
             Call
               ("dfn'ShiftImmediate",ATy(qTy,PTy(uTy,qTy)),
                Var("v20",
                    PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy)))))))),
            (Call
               ("ShiftRegister",CTy"Data",
                Var("v21",
                    PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(CTy"SRType",F4))))))),
             Call
               ("dfn'ShiftRegister",ATy(qTy,PTy(uTy,qTy)),
                Var("v21",
                    PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(CTy"SRType",F4)))))))),
            (Call
               ("TestCompareImmediate",CTy"Data",
                Var("v22",PTy(FTy 2,PTy(F4,FTy 12)))),
             Call
               ("dfn'TestCompareImmediate",ATy(qTy,PTy(uTy,qTy)),
                Var("v22",PTy(FTy 2,PTy(F4,FTy 12))))),
            (Call
               ("TestCompareRegister",CTy"Data",
                Var("v23",PTy(FTy 2,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy)))))),
             Call
               ("dfn'TestCompareRegister",ATy(qTy,PTy(uTy,qTy)),
                Var("v23",PTy(FTy 2,PTy(F4,PTy(F4,PTy(CTy"SRType",nTy)))))))])),
       (Call("Hint",CTy"instruction",Var("v24",CTy"Hint")),
        CS(Var("v24",CTy"Hint"),
           [(Const("SendEvent",CTy"Hint"),
             Const("dfn'SendEvent",ATy(qTy,PTy(uTy,qTy)))),
            (Const("WaitForEvent",CTy"Hint"),
             Const("dfn'WaitForEvent",ATy(qTy,PTy(uTy,qTy)))),
            (Const("WaitForInterrupt",CTy"Hint"),
             Const("dfn'WaitForInterrupt",ATy(qTy,PTy(uTy,qTy)))),
            (Const("Yield",CTy"Hint"),
             Const("dfn'Yield",ATy(qTy,PTy(uTy,qTy)))),
            (Call("Breakpoint",CTy"Hint",Var("v25",F32)),
             Call("dfn'Breakpoint",ATy(qTy,PTy(uTy,qTy)),Var("v25",F32))),
            (Call("DataMemoryBarrier",CTy"Hint",Var("v26",F4)),
             Call
               ("dfn'DataMemoryBarrier",ATy(qTy,PTy(uTy,qTy)),
                Var("v26",F4))),
            (Call("DataSynchronizationBarrier",CTy"Hint",Var("v27",F4)),
             Call
               ("dfn'DataSynchronizationBarrier",ATy(qTy,PTy(uTy,qTy)),
                Var("v27",F4))),
            (Call("Debug",CTy"Hint",Var("v28",F4)),
             Call("dfn'Debug",ATy(qTy,PTy(uTy,qTy)),Var("v28",F4))),
            (Call
               ("InstructionSynchronizationBarrier",CTy"Hint",
                Var("v29",F4)),
             Call
               ("dfn'InstructionSynchronizationBarrier",
                ATy(qTy,PTy(uTy,qTy)),Var("v29",F4))),
            (Call
               ("PreloadData",CTy"Hint",
                Var("v30",PTy(bTy,PTy(bTy,PTy(F4,CTy"offset1"))))),
             Call
               ("dfn'PreloadData",ATy(qTy,PTy(uTy,qTy)),
                Var("v30",PTy(bTy,PTy(bTy,PTy(F4,CTy"offset1")))))),
            (Call("PreloadDataLiteral",CTy"Hint",Var("v31",PTy(bTy,F32))),
             Call
               ("dfn'PreloadDataLiteral",ATy(qTy,PTy(uTy,qTy)),
                Var("v31",PTy(bTy,F32)))),
            (Call
               ("PreloadInstruction",CTy"Hint",
                Var("v32",PTy(bTy,PTy(F4,CTy"offset1")))),
             Call
               ("dfn'PreloadInstruction",ATy(qTy,PTy(uTy,qTy)),
                Var("v32",PTy(bTy,PTy(F4,CTy"offset1")))))])),
       (Call("Load",CTy"instruction",Var("v33",CTy"Load")),
        CS(Var("v33",CTy"Load"),
           [(Call
               ("LoadByte",CTy"Load",
                Var("v34",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))))),
             Call
               ("dfn'LoadByte",ATy(qTy,PTy(uTy,qTy)),
                Var("v34",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))))),
            (Call
               ("LoadByteLiteral",CTy"Load",
                Var("v35",PTy(bTy,PTy(bTy,PTy(F4,F32))))),
             Call
               ("dfn'LoadByteLiteral",ATy(qTy,PTy(uTy,qTy)),
                Var("v35",PTy(bTy,PTy(bTy,PTy(F4,F32)))))),
            (Call
               ("LoadByteUnprivileged",CTy"Load",
                Var("v36",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))),
             Call
               ("dfn'LoadByteUnprivileged",ATy(qTy,PTy(uTy,qTy)),
                Var("v36",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
            (Call
               ("LoadDual",CTy"Load",
                Var("v37",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(F4,PTy(F4,PTy(F4,CTy"offset2")))))))),
             Call
               ("dfn'LoadDual",ATy(qTy,PTy(uTy,qTy)),
                Var("v37",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(F4,PTy(F4,PTy(F4,CTy"offset2"))))))))),
            (Call
               ("LoadDualLiteral",CTy"Load",
                Var("v38",PTy(bTy,PTy(F4,PTy(F4,F32))))),
             Call
               ("dfn'LoadDualLiteral",ATy(qTy,PTy(uTy,qTy)),
                Var("v38",PTy(bTy,PTy(F4,PTy(F4,F32)))))),
            (Call
               ("LoadExclusive",CTy"Load",Var("v39",PTy(F4,PTy(F4,F32)))),
             Call
               ("dfn'LoadExclusive",ATy(qTy,PTy(uTy,qTy)),
                Var("v39",PTy(F4,PTy(F4,F32))))),
            (Call("LoadExclusiveByte",CTy"Load",Var("v40",PTy(F4,F4))),
             Call
               ("dfn'LoadExclusiveByte",ATy(qTy,PTy(uTy,qTy)),
                Var("v40",PTy(F4,F4)))),
            (Call
               ("LoadExclusiveDoubleword",CTy"Load",
                Var("v41",PTy(F4,PTy(F4,F4)))),
             Call
               ("dfn'LoadExclusiveDoubleword",ATy(qTy,PTy(uTy,qTy)),
                Var("v41",PTy(F4,PTy(F4,F4))))),
            (Call("LoadExclusiveHalf",CTy"Load",Var("v42",PTy(F4,F4))),
             Call
               ("dfn'LoadExclusiveHalf",ATy(qTy,PTy(uTy,qTy)),
                Var("v42",PTy(F4,F4)))),
            (Call
               ("LoadHalf",CTy"Load",
                Var("v43",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))))),
             Call
               ("dfn'LoadHalf",ATy(qTy,PTy(uTy,qTy)),
                Var("v43",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))))),
            (Call
               ("LoadHalfLiteral",CTy"Load",
                Var("v44",PTy(bTy,PTy(bTy,PTy(F4,F32))))),
             Call
               ("dfn'LoadHalfLiteral",ATy(qTy,PTy(uTy,qTy)),
                Var("v44",PTy(bTy,PTy(bTy,PTy(F4,F32)))))),
            (Call
               ("LoadHalfUnprivileged",CTy"Load",
                Var("v45",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2"))))))),
             Call
               ("dfn'LoadHalfUnprivileged",ATy(qTy,PTy(uTy,qTy)),
                Var("v45",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2")))))))),
            (Call("LoadLiteral",CTy"Load",Var("v46",PTy(bTy,PTy(F4,F32)))),
             Call
               ("dfn'LoadLiteral",ATy(qTy,PTy(uTy,qTy)),
                Var("v46",PTy(bTy,PTy(F4,F32))))),
            (Call
               ("LoadMultiple",CTy"Load",
                Var("v47",PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,F16)))))),
             Call
               ("dfn'LoadMultiple",ATy(qTy,PTy(uTy,qTy)),
                Var("v47",PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,F16))))))),
            (Call
               ("LoadMultipleExceptionReturn",CTy"Load",
                Var("v48",PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,FTy 15)))))),
             Call
               ("dfn'LoadMultipleExceptionReturn",ATy(qTy,PTy(uTy,qTy)),
                Var("v48",PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,FTy 15))))))),
            (Call
               ("LoadMultipleUserRegisters",CTy"Load",
                Var("v49",PTy(bTy,PTy(bTy,PTy(F4,FTy 15))))),
             Call
               ("dfn'LoadMultipleUserRegisters",ATy(qTy,PTy(uTy,qTy)),
                Var("v49",PTy(bTy,PTy(bTy,PTy(F4,FTy 15)))))),
            (Call
               ("LoadSignedByteUnprivileged",CTy"Load",
                Var("v50",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2")))))),
             Call
               ("dfn'LoadSignedByteUnprivileged",ATy(qTy,PTy(uTy,qTy)),
                Var("v50",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2"))))))),
            (Call
               ("LoadUnprivileged",CTy"Load",
                Var("v51",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))),
             Call
               ("dfn'LoadUnprivileged",ATy(qTy,PTy(uTy,qTy)),
                Var("v51",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
            (Call
               ("LoadWord",CTy"Load",
                Var("v52",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
             Call
               ("dfn'LoadWord",ATy(qTy,PTy(uTy,qTy)),
                Var("v52",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))))])),
       (Call("Media",CTy"instruction",Var("v53",CTy"Media")),
        CS(Var("v53",CTy"Media"),
           [(Call
               ("BitFieldClearOrInsert",CTy"Media",
                Var("v54",PTy(F4,PTy(F4,PTy(nTy,nTy))))),
             Call
               ("dfn'BitFieldClearOrInsert",ATy(qTy,PTy(uTy,qTy)),
                Var("v54",PTy(F4,PTy(F4,PTy(nTy,nTy)))))),
            (Call
               ("BitFieldExtract",CTy"Media",
                Var("v55",PTy(bTy,PTy(F4,PTy(F4,PTy(nTy,nTy)))))),
             Call
               ("dfn'BitFieldExtract",ATy(qTy,PTy(uTy,qTy)),
                Var("v55",PTy(bTy,PTy(F4,PTy(F4,PTy(nTy,nTy))))))),
            (Call("ByteReverse",CTy"Media",Var("v56",PTy(F4,F4))),
             Call
               ("dfn'ByteReverse",ATy(qTy,PTy(uTy,qTy)),
                Var("v56",PTy(F4,F4)))),
            (Call
               ("ByteReversePackedHalfword",CTy"Media",
                Var("v57",PTy(F4,F4))),
             Call
               ("dfn'ByteReversePackedHalfword",ATy(qTy,PTy(uTy,qTy)),
                Var("v57",PTy(F4,F4)))),
            (Call
               ("ByteReverseSignedHalfword",CTy"Media",
                Var("v58",PTy(F4,F4))),
             Call
               ("dfn'ByteReverseSignedHalfword",ATy(qTy,PTy(uTy,qTy)),
                Var("v58",PTy(F4,F4)))),
            (Call
               ("ExtendByte",CTy"Media",
                Var("v59",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy)))))),
             Call
               ("dfn'ExtendByte",ATy(qTy,PTy(uTy,qTy)),
                Var("v59",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy))))))),
            (Call
               ("ExtendByte16",CTy"Media",
                Var("v60",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy)))))),
             Call
               ("dfn'ExtendByte16",ATy(qTy,PTy(uTy,qTy)),
                Var("v60",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy))))))),
            (Call
               ("ExtendHalfword",CTy"Media",
                Var("v61",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy)))))),
             Call
               ("dfn'ExtendHalfword",ATy(qTy,PTy(uTy,qTy)),
                Var("v61",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,nTy))))))),
            (Call
               ("PackHalfword",CTy"Media",
                Var("v62",
                    PTy(CTy"SRType",PTy(nTy,PTy(bTy,PTy(F4,PTy(F4,F4))))))),
             Call
               ("dfn'PackHalfword",ATy(qTy,PTy(uTy,qTy)),
                Var("v62",
                    PTy(CTy"SRType",PTy(nTy,PTy(bTy,PTy(F4,PTy(F4,F4)))))))),
            (Call("ReverseBits",CTy"Media",Var("v63",PTy(F4,F4))),
             Call
               ("dfn'ReverseBits",ATy(qTy,PTy(uTy,qTy)),
                Var("v63",PTy(F4,F4)))),
            (Call
               ("Saturate",CTy"Media",
                Var("v64",
                    PTy(CTy"SRType",PTy(nTy,PTy(nTy,PTy(bTy,PTy(F4,F4))))))),
             Call
               ("dfn'Saturate",ATy(qTy,PTy(uTy,qTy)),
                Var("v64",
                    PTy(CTy"SRType",PTy(nTy,PTy(nTy,PTy(bTy,PTy(F4,F4)))))))),
            (Call
               ("Saturate16",CTy"Media",
                Var("v65",PTy(nTy,PTy(bTy,PTy(F4,F4))))),
             Call
               ("dfn'Saturate16",ATy(qTy,PTy(uTy,qTy)),
                Var("v65",PTy(nTy,PTy(bTy,PTy(F4,F4)))))),
            (Call
               ("SaturatingAddSubtract",CTy"Media",
                Var("v66",PTy(FTy 2,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'SaturatingAddSubtract",ATy(qTy,PTy(uTy,qTy)),
                Var("v66",PTy(FTy 2,PTy(F4,PTy(F4,F4)))))),
            (Call("SelectBytes",CTy"Media",Var("v67",PTy(F4,PTy(F4,F4)))),
             Call
               ("dfn'SelectBytes",ATy(qTy,PTy(uTy,qTy)),
                Var("v67",PTy(F4,PTy(F4,F4)))))])),
       (Call("Multiply",CTy"instruction",Var("v68",CTy"Multiply")),
        CS(Var("v68",CTy"Multiply"),
           [(Call
               ("Multiply32",CTy"Multiply",
                Var("v69",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'Multiply32",ATy(qTy,PTy(uTy,qTy)),
                Var("v69",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("MultiplyAccumulate",CTy"Multiply",
                Var("v70",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))),
             Call
               ("dfn'MultiplyAccumulate",ATy(qTy,PTy(uTy,qTy)),
                Var("v70",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
            (Call
               ("MultiplyAccumulateAccumulate",CTy"Multiply",
                Var("v71",PTy(F4,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'MultiplyAccumulateAccumulate",ATy(qTy,PTy(uTy,qTy)),
                Var("v71",PTy(F4,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("MultiplyLong",CTy"Multiply",
                Var("v72",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))))),
             Call
               ("dfn'MultiplyLong",ATy(qTy,PTy(uTy,qTy)),
                Var("v72",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))))),
            (Call
               ("MultiplySubtract",CTy"Multiply",
                Var("v73",PTy(F4,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'MultiplySubtract",ATy(qTy,PTy(uTy,qTy)),
                Var("v73",PTy(F4,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("Signed16Multiply32Accumulate",CTy"Multiply",
                Var("v74",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
             Call
               ("dfn'Signed16Multiply32Accumulate",ATy(qTy,PTy(uTy,qTy)),
                Var("v74",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))))),
            (Call
               ("Signed16Multiply32Result",CTy"Multiply",
                Var("v75",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,F4)))))),
             Call
               ("dfn'Signed16Multiply32Result",ATy(qTy,PTy(uTy,qTy)),
                Var("v75",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,F4))))))),
            (Call
               ("Signed16Multiply64Accumulate",CTy"Multiply",
                Var("v76",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
             Call
               ("dfn'Signed16Multiply64Accumulate",ATy(qTy,PTy(uTy,qTy)),
                Var("v76",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))))),
            (Call
               ("Signed16x32Multiply32Accumulate",CTy"Multiply",
                Var("v77",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))),
             Call
               ("dfn'Signed16x32Multiply32Accumulate",
                ATy(qTy,PTy(uTy,qTy)),
                Var("v77",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
            (Call
               ("Signed16x32Multiply32Result",CTy"Multiply",
                Var("v78",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'Signed16x32Multiply32Result",ATy(qTy,PTy(uTy,qTy)),
                Var("v78",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("SignedMostSignificantMultiply",CTy"Multiply",
                Var("v79",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))),
             Call
               ("dfn'SignedMostSignificantMultiply",ATy(qTy,PTy(uTy,qTy)),
                Var("v79",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
            (Call
               ("SignedMostSignificantMultiplySubtract",CTy"Multiply",
                Var("v80",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))),
             Call
               ("dfn'SignedMostSignificantMultiplySubtract",
                ATy(qTy,PTy(uTy,qTy)),
                Var("v80",PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
            (Call
               ("SignedMultiplyDual",CTy"Multiply",
                Var("v81",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
             Call
               ("dfn'SignedMultiplyDual",ATy(qTy,PTy(uTy,qTy)),
                Var("v81",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4)))))))),
            (Call
               ("SignedMultiplyLongDual",CTy"Multiply",
                Var("v82",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))),
             Call
               ("dfn'SignedMultiplyLongDual",ATy(qTy,PTy(uTy,qTy)),
                Var("v82",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,PTy(F4,F4))))))))])),
       (Call("SIMD",CTy"instruction",Var("v83",CTy"SIMD")),
        CS(Var("v83",CTy"SIMD"),
           [(Call
               ("SignedAddSub16",CTy"SIMD",
                Var("v84",PTy(FTy 2,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'SignedAddSub16",ATy(qTy,PTy(uTy,qTy)),
                Var("v84",PTy(FTy 2,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("SignedAddSub8",CTy"SIMD",
                Var("v85",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'SignedAddSub8",ATy(qTy,PTy(uTy,qTy)),
                Var("v85",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("SignedHalvingAddSub16",CTy"SIMD",
                Var("v86",PTy(FTy 2,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'SignedHalvingAddSub16",ATy(qTy,PTy(uTy,qTy)),
                Var("v86",PTy(FTy 2,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("SignedHalvingAddSub8",CTy"SIMD",
                Var("v87",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'SignedHalvingAddSub8",ATy(qTy,PTy(uTy,qTy)),
                Var("v87",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("SignedSaturatingAddSub16",CTy"SIMD",
                Var("v88",PTy(FTy 2,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'SignedSaturatingAddSub16",ATy(qTy,PTy(uTy,qTy)),
                Var("v88",PTy(FTy 2,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("SignedSaturatingAddSub8",CTy"SIMD",
                Var("v89",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'SignedSaturatingAddSub8",ATy(qTy,PTy(uTy,qTy)),
                Var("v89",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("UnsignedAddSub16",CTy"SIMD",
                Var("v90",PTy(FTy 2,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'UnsignedAddSub16",ATy(qTy,PTy(uTy,qTy)),
                Var("v90",PTy(FTy 2,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("UnsignedAddSub8",CTy"SIMD",
                Var("v91",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'UnsignedAddSub8",ATy(qTy,PTy(uTy,qTy)),
                Var("v91",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("UnsignedHalvingAddSub16",CTy"SIMD",
                Var("v92",PTy(FTy 2,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'UnsignedHalvingAddSub16",ATy(qTy,PTy(uTy,qTy)),
                Var("v92",PTy(FTy 2,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("UnsignedHalvingAddSub8",CTy"SIMD",
                Var("v93",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'UnsignedHalvingAddSub8",ATy(qTy,PTy(uTy,qTy)),
                Var("v93",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("UnsignedSaturatingAddSub16",CTy"SIMD",
                Var("v94",PTy(FTy 2,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'UnsignedSaturatingAddSub16",ATy(qTy,PTy(uTy,qTy)),
                Var("v94",PTy(FTy 2,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("UnsignedSaturatingAddSub8",CTy"SIMD",
                Var("v95",PTy(bTy,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'UnsignedSaturatingAddSub8",ATy(qTy,PTy(uTy,qTy)),
                Var("v95",PTy(bTy,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("UnsignedSumAbsoluteDifferences",CTy"SIMD",
                Var("v96",PTy(F4,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'UnsignedSumAbsoluteDifferences",
                ATy(qTy,PTy(uTy,qTy)),
                Var("v96",PTy(F4,PTy(F4,PTy(F4,F4))))))])),
       (Call("Store",CTy"instruction",Var("v97",CTy"Store")),
        CS(Var("v97",CTy"Store"),
           [(Call
               ("StoreByte",CTy"Store",
                Var("v98",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
             Call
               ("dfn'StoreByte",ATy(qTy,PTy(uTy,qTy)),
                Var("v98",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))))),
            (Call
               ("StoreByteUnprivileged",CTy"Store",
                Var("v99",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))),
             Call
               ("dfn'StoreByteUnprivileged",ATy(qTy,PTy(uTy,qTy)),
                Var("v99",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
            (Call
               ("StoreDual",CTy"Store",
                Var("v100",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(F4,PTy(F4,PTy(F4,CTy"offset2")))))))),
             Call
               ("dfn'StoreDual",ATy(qTy,PTy(uTy,qTy)),
                Var("v100",
                    PTy(bTy,
                        PTy(bTy,
                            PTy(bTy,PTy(F4,PTy(F4,PTy(F4,CTy"offset2"))))))))),
            (Call
               ("StoreExclusive",CTy"Store",
                Var("v101",PTy(F4,PTy(F4,PTy(F4,F32))))),
             Call
               ("dfn'StoreExclusive",ATy(qTy,PTy(uTy,qTy)),
                Var("v101",PTy(F4,PTy(F4,PTy(F4,F32)))))),
            (Call
               ("StoreExclusiveByte",CTy"Store",
                Var("v102",PTy(F4,PTy(F4,F4)))),
             Call
               ("dfn'StoreExclusiveByte",ATy(qTy,PTy(uTy,qTy)),
                Var("v102",PTy(F4,PTy(F4,F4))))),
            (Call
               ("StoreExclusiveDoubleword",CTy"Store",
                Var("v103",PTy(F4,PTy(F4,PTy(F4,F4))))),
             Call
               ("dfn'StoreExclusiveDoubleword",ATy(qTy,PTy(uTy,qTy)),
                Var("v103",PTy(F4,PTy(F4,PTy(F4,F4)))))),
            (Call
               ("StoreExclusiveHalf",CTy"Store",
                Var("v104",PTy(F4,PTy(F4,F4)))),
             Call
               ("dfn'StoreExclusiveHalf",ATy(qTy,PTy(uTy,qTy)),
                Var("v104",PTy(F4,PTy(F4,F4))))),
            (Call
               ("StoreHalf",CTy"Store",
                Var("v105",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
             Call
               ("dfn'StoreHalf",ATy(qTy,PTy(uTy,qTy)),
                Var("v105",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))))),
            (Call
               ("StoreHalfUnprivileged",CTy"Store",
                Var("v106",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2")))))),
             Call
               ("dfn'StoreHalfUnprivileged",ATy(qTy,PTy(uTy,qTy)),
                Var("v106",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset2"))))))),
            (Call
               ("StoreMultiple",CTy"Store",
                Var("v107",PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,F16)))))),
             Call
               ("dfn'StoreMultiple",ATy(qTy,PTy(uTy,qTy)),
                Var("v107",PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,F16))))))),
            (Call
               ("StoreMultipleUserRegisters",CTy"Store",
                Var("v108",PTy(bTy,PTy(bTy,PTy(F4,F16))))),
             Call
               ("dfn'StoreMultipleUserRegisters",ATy(qTy,PTy(uTy,qTy)),
                Var("v108",PTy(bTy,PTy(bTy,PTy(F4,F16)))))),
            (Call
               ("StoreUnprivileged",CTy"Store",
                Var("v109",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1")))))),
             Call
               ("dfn'StoreUnprivileged",ATy(qTy,PTy(uTy,qTy)),
                Var("v109",PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
            (Call
               ("StoreWord",CTy"Store",
                Var("v110",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))),
             Call
               ("dfn'StoreWord",ATy(qTy,PTy(uTy,qTy)),
                Var("v110",
                    PTy(bTy,PTy(bTy,PTy(bTy,PTy(F4,PTy(F4,CTy"offset1"))))))))])),
       (Call("System",CTy"instruction",Var("v111",CTy"System")),
        CS(Var("v111",CTy"System"),
           [(Const("ExceptionReturn",CTy"System"),
             Const("dfn'ExceptionReturn",ATy(qTy,PTy(uTy,qTy)))),
            (Call
               ("ChangeProcessorState",CTy"System",
                Var("v112",
                    PTy(bTy,
                        PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,FTy 5)))))))),
             Call
               ("dfn'ChangeProcessorState",ATy(qTy,PTy(uTy,qTy)),
                Var("v112",
                    PTy(bTy,
                        PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,PTy(bTy,FTy 5))))))))),
            (Call
               ("ChangeProcessorStateT1",CTy"System",
                Var("v113",PTy(bTy,PTy(bTy,PTy(bTy,bTy))))),
             Call
               ("dfn'ChangeProcessorStateT1",ATy(qTy,PTy(uTy,qTy)),
                Var("v113",PTy(bTy,PTy(bTy,PTy(bTy,bTy)))))),
            (Call("EnterxLeavex",CTy"System",bVar"v114"),
             Call("dfn'EnterxLeavex",ATy(qTy,PTy(uTy,qTy)),bVar"v114")),
            (Call("HypervisorCall",CTy"System",Var("v115",F16)),
             Call
               ("dfn'HypervisorCall",ATy(qTy,PTy(uTy,qTy)),Var("v115",F16))),
            (Call
               ("MoveToBankedOrSpecialRegister",CTy"System",
                Var("v116",PTy(bTy,PTy(FTy 5,F4)))),
             Call
               ("dfn'MoveToBankedOrSpecialRegister",ATy(qTy,PTy(uTy,qTy)),
                Var("v116",PTy(bTy,PTy(FTy 5,F4))))),
            (Call
               ("MoveToRegisterFromBankedOrSpecial",CTy"System",
                Var("v117",PTy(bTy,PTy(FTy 5,F4)))),
             Call
               ("dfn'MoveToRegisterFromBankedOrSpecial",
                ATy(qTy,PTy(uTy,qTy)),Var("v117",PTy(bTy,PTy(FTy 5,F4))))),
            (Call
               ("MoveToRegisterFromSpecial",CTy"System",
                Var("v118",PTy(bTy,F4))),
             Call
               ("dfn'MoveToRegisterFromSpecial",ATy(qTy,PTy(uTy,qTy)),
                Var("v118",PTy(bTy,F4)))),
            (Call
               ("MoveToSpecialFromImmediate",CTy"System",
                Var("v119",PTy(bTy,PTy(F32,F4)))),
             Call
               ("dfn'MoveToSpecialFromImmediate",ATy(qTy,PTy(uTy,qTy)),
                Var("v119",PTy(bTy,PTy(F32,F4))))),
            (Call
               ("MoveToSpecialFromRegister",CTy"System",
                Var("v120",PTy(bTy,PTy(F4,F4)))),
             Call
               ("dfn'MoveToSpecialFromRegister",ATy(qTy,PTy(uTy,qTy)),
                Var("v120",PTy(bTy,PTy(F4,F4))))),
            (Call
               ("ReturnFromException",CTy"System",
                Var("v121",PTy(bTy,PTy(bTy,PTy(bTy,F4))))),
             Call
               ("dfn'ReturnFromException",ATy(qTy,PTy(uTy,qTy)),
                Var("v121",PTy(bTy,PTy(bTy,PTy(bTy,F4)))))),
            (Call("SecureMonitorCall",CTy"System",Var("v122",F4)),
             Call
               ("dfn'SecureMonitorCall",ATy(qTy,PTy(uTy,qTy)),
                Var("v122",F4))),
            (Call("Setend",CTy"System",bVar"v123"),
             Call("dfn'Setend",ATy(qTy,PTy(uTy,qTy)),bVar"v123")),
            (Call
               ("StoreReturnState",CTy"System",
                Var("v124",PTy(bTy,PTy(bTy,PTy(bTy,FTy 5))))),
             Call
               ("dfn'StoreReturnState",ATy(qTy,PTy(uTy,qTy)),
                Var("v124",PTy(bTy,PTy(bTy,PTy(bTy,FTy 5)))))),
            (Call("SupervisorCall",CTy"System",Var("v125",F32)),
             Call
               ("dfn'SupervisorCall",ATy(qTy,PTy(uTy,qTy)),Var("v125",F32)))]))]))
;
val Fetch_def = Def0
  ("Fetch",
   MB(Call("CurrentInstrSet",ATy(qTy,PTy(CTy"InstrSet",qTy)),LU),
      Close
        (Var("iset",CTy"InstrSet"),
         MB(MR(Close
                 (qVar"s",Dest("Architecture",CTy"Architecture",qVar"s"))),
            Close
              (Var("v",CTy"Architecture"),
               MB(MB(MU(EQ(Var("v",CTy"Architecture"),
                           LC("ARMv4",CTy"Architecture")),qTy),
                     Close
                       (bVar"v",
                        MU(Bop(Or,
                               EQ(Var("iset",CTy"InstrSet"),
                                  LC("InstrSet_ARM",CTy"InstrSet")),
                               bVar"v"),qTy))),
                  Close
                    (bVar"b",
                     ITB([(bVar"b",
                           MB(MW(Close
                                   (qVar"s",
                                    Rupd
                                      ("Encoding",
                                       TP[qVar"s",
                                          LC("Encoding_ARM",CTy"Encoding")]))),
                              Close
                                (AVar uTy,
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest
                                            ("REG",ATy(CTy"RName",F32),
                                             qVar"s"))),
                                    Close
                                      (Var("v",ATy(CTy"RName",F32)),
                                       MB(MB(MB(MU(Apply
                                                     (Var("v",
                                                          ATy(CTy"RName",
                                                              F32)),
                                                      LC("RName_PC",
                                                         CTy"RName")),qTy),
                                                Close
                                                  (Var("v",F32),
                                                   MU(TP[Var("v",F32),LN 4],
                                                      qTy))),
                                             Close
                                               (Var("v",PTy(F32,nTy)),
                                                Call
                                                  ("MemA",
                                                   ATy(qTy,PTy(F32,qTy)),
                                                   Var("v",PTy(F32,nTy))))),
                                          Close
                                            (Var("v",F32),
                                             MU(Call
                                                  ("ARM",CTy"MachineCode",
                                                   Var("v",F32)),qTy)))))))),
                          (EQ(Var("iset",CTy"InstrSet"),
                              LC("InstrSet_Jazelle",CTy"InstrSet")),
                           Call
                             ("raise'exception",
                              ATy(qTy,PTy(CTy"MachineCode",qTy)),
                              Call
                                ("UNPREDICTABLE",CTy"exception",LS"Fetch")))],
                         MB(MR(Close
                                 (qVar"s",
                                  Dest("REG",ATy(CTy"RName",F32),qVar"s"))),
                            Close
                              (Var("v",ATy(CTy"RName",F32)),
                               MB(MU(Apply
                                       (Var("v",ATy(CTy"RName",F32)),
                                        LC("RName_PC",CTy"RName")),qTy),
                                  Close
                                    (Var("fpc",F32),
                                     MB(Call
                                          ("MemA",ATy(qTy,PTy(F16,qTy)),
                                           TP[Var("fpc",F32),LN 2]),
                                        Close
                                          (Var("ireg",F16),
                                           MB(MR(Close
                                                   (qVar"s",
                                                    Dest
                                                      ("data_abort",bTy,
                                                       qVar"s"))),
                                              Close
                                                (bVar"b",
                                                 ITB([(bVar"b",
                                                       MU(LX(CTy"MachineCode"),
                                                          qTy)),
                                                      (Bop(And,
                                                           EQ(EX(Var("ireg",
                                                                     F16),
                                                                 LN 15,
                                                                 LN 13,
                                                                 FTy 3),
                                                              LW(7,3)),
                                                           Mop(Not,
                                                               EQ(EX(Var("ireg",
                                                                         F16),
                                                                     LN 12,
                                                                     LN 11,
                                                                     FTy 2),
                                                                  LW(0,2)))),
                                                       MB(MW(Close
                                                               (qVar"s",
                                                                Rupd
                                                                  ("Encoding",
                                                                   TP[qVar"s",
                                                                      LC("Encoding_Thumb2",
                                                                         CTy"Encoding")]))),
                                                          Close
                                                            (AVar uTy,
                                                             MB(Call
                                                                  ("MemA",
                                                                   ATy(qTy,
                                                                       PTy(F16,
                                                                           qTy)),
                                                                   TP[Bop(Add,
                                                                          Var("fpc",
                                                                              F32),
                                                                          LW(2,
                                                                             32)),
                                                                      LN 2]),
                                                                Close
                                                                  (Var("v",
                                                                       F16),
                                                                   MB(MU(TP[Var("ireg",
                                                                                F16),
                                                                            Var("v",
                                                                                F16)],
                                                                         qTy),
                                                                      Close
                                                                        (Var("v",
                                                                             PTy(F16,
                                                                                 F16)),
                                                                         MU(Call
                                                                              ("Thumb2",
                                                                               CTy"MachineCode",
                                                                               Var("v",
                                                                                   PTy(F16,
                                                                                       F16))),
                                                                            qTy))))))))],
                                                     MB(MW(Close
                                                             (qVar"s",
                                                              Rupd
                                                                ("Encoding",
                                                                 TP[qVar"s",
                                                                    LC("Encoding_Thumb",
                                                                       CTy"Encoding")]))),
                                                        Close
                                                          (AVar uTy,
                                                           MB(Call
                                                                ("HaveThumbEE",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v",
                                                                 MB(MB(MU(Mop(Not,
                                                                              bVar"v"),
                                                                          qTy),
                                                                       Close
                                                                         (bVar"v",
                                                                          MU(Bop(Or,
                                                                                 EQ(Var("iset",
                                                                                        CTy"InstrSet"),
                                                                                    LC("InstrSet_Thumb",
                                                                                       CTy"InstrSet")),
                                                                                 bVar"v"),
                                                                             qTy))),
                                                                    Close
                                                                      (bVar"b",
                                                                       MU(ITE(bVar"b",
                                                                              Call
                                                                                ("Thumb",
                                                                                 CTy"MachineCode",
                                                                                 Var("ireg",
                                                                                     F16)),
                                                                              Call
                                                                                ("ThumbEE",
                                                                                 CTy"MachineCode",
                                                                                 Var("ireg",
                                                                                     F16))),
                                                                          qTy))))))))))))))))))))))))
;
val Take_def = Def
  ("Take",TP[Var("cond",F4),bVar"defined"],
   MB(MW(Close
           (qVar"s",Rupd("CurrentCondition",TP[qVar"s",Var("cond",F4)]))),
      Close
        (AVar uTy,
         MB(Call("ConditionPassed",ATy(qTy,PTy(bTy,qTy)),LU),
            Close
              (bVar"pass",
               MB(MW(Close
                       (qVar"s",
                        Rupd
                          ("undefined",
                           TP[qVar"s",
                              Bop(And,bVar"pass",Mop(Not,bVar"defined"))]))),
                  Close
                    (AVar uTy,MU(Bop(And,bVar"pass",bVar"defined"),qTy))))))))
;
val Skip_def = Def
  ("Skip",AVar uTy,
   MB(MR(Close(qVar"s",Dest("undefined",bTy,qVar"s"))),
      Close
        (bVar"b",
         MU(ITE(bVar"b",Call("Undefined",CTy"instruction",LW(0,32)),
                Const("NoOperation",CTy"instruction")),qTy))))
;
val UndefinedARM_def = Def
  ("UndefinedARM",Var("cond",F4),
   MB(MW(Close
           (qVar"s",Rupd("CurrentCondition",TP[qVar"s",Var("cond",F4)]))),
      Close
        (AVar uTy,
         MB(Call("ConditionPassed",ATy(qTy,PTy(bTy,qTy)),LU),
            Close
              (bVar"b",
               MU(ITE(bVar"b",Call("Undefined",CTy"instruction",LW(0,32)),
                      Const("NoOperation",CTy"instruction")),qTy))))))
;
val UndefinedThumb_def = Def
  ("UndefinedThumb",AVar uTy,
   MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
      Close
        (Var("v",F4),
         Call
           ("UndefinedARM",ATy(qTy,PTy(CTy"instruction",qTy)),Var("v",F4)))))
;
val DECODE_UNPREDICTABLE_def = Def
  ("DECODE_UNPREDICTABLE",TP[Var("mc",CTy"MachineCode"),sVar"s"],
   Call
     ("raise'exception",ATy(qTy,PTy(uTy,qTy)),
      Call
        ("UNPREDICTABLE",CTy"exception",
         CC[LS"Decode ",
            CS(Var("mc",CTy"MachineCode"),
               [(Call("ARM",CTy"MachineCode",Var("opc",F32)),
                 CC[Mop(Cast sTy,Mop(Cast vTy,Var("opc",F32))),LS"; ARM; "]),
                (Call("Thumb",CTy"MachineCode",Var("opc",F16)),
                 CC[Mop(Cast sTy,Mop(Cast vTy,Var("opc",F16))),
                    LS"; Thumb; "]),
                (Call("ThumbEE",CTy"MachineCode",Var("opc",F16)),
                 CC[Mop(Cast sTy,Mop(Cast vTy,Var("opc",F16))),
                    LS"; ThumbEE; "]),
                (Call
                   ("Thumb2",CTy"MachineCode",
                    TP[Var("opc1",F16),Var("opc2",F16)]),
                 CC[Mop(Cast sTy,Mop(Cast vTy,Var("opc1",F16))),LS", ",
                    Mop(Cast sTy,Mop(Cast vTy,Var("opc2",F16))),
                    LS"; Thumb2; "])]),sVar"s"])))
;
val DecodeHint_def = Def
  ("DecodeHint",TP[Var("cond",F4),Var("op",F8)],
   MB(MR(Close(qVar"s",Dest("Architecture",CTy"Architecture",qVar"s"))),
      Close
        (Var("v",CTy"Architecture"),
         MB(MB(MU(EQ(Var("v",CTy"Architecture"),
                     LC("ARMv6T2",CTy"Architecture")),qTy),
               Close
                 (bVar"b",
                  ITE(bVar"b",MU(LT,qTy),
                      MB(MR(Close
                              (qVar"s",
                               Dest("Encoding",CTy"Encoding",qVar"s"))),
                         Close
                           (Var("v",CTy"Encoding"),
                            MB(MB(MU(EQ(Var("v",CTy"Encoding"),
                                        LC("Encoding_ARM",CTy"Encoding")),
                                     qTy),
                                  Close
                                    (bVar"v",
                                     MU(Bop(And,
                                            EQ(EX(Var("op",F8),LN 7,LN 4,
                                                  F4),LW(15,4)),bVar"v"),
                                        qTy))),
                               Close
                                 (bVar"b",
                                  ITE(bVar"b",
                                      MB(MR(Close
                                              (qVar"s",
                                               Dest
                                                 ("Architecture",
                                                  CTy"Architecture",
                                                  qVar"s"))),
                                         Close
                                           (Var("v",CTy"Architecture"),
                                            MU(EQ(Var("v",
                                                      CTy"Architecture"),
                                                  LC("ARMv6K",
                                                     CTy"Architecture")),
                                               qTy))),MU(LF,qTy))))))))),
            Close
              (bVar"b",
               ITE(bVar"b",MU(Const("NoOperation",CTy"instruction"),qTy),
                   MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                      Close
                        (nVar"v",
                         MB(MB(MB(MB(MU(Bop(Ge,nVar"v",LN 7),qTy),
                                     Close
                                       (bVar"b",
                                        ITE(bVar"b",MU(LT,qTy),
                                            MB(MR(Close
                                                    (qVar"s",
                                                     Dest
                                                       ("Encoding",
                                                        CTy"Encoding",
                                                        qVar"s"))),
                                               Close
                                                 (Var("v",CTy"Encoding"),
                                                  MB(MU(EQ(Var("v",
                                                               CTy"Encoding"),
                                                           LC("Encoding_ARM",
                                                              CTy"Encoding")),
                                                        qTy),
                                                     Close
                                                       (bVar"b",
                                                        ITE(bVar"b",
                                                            MB(MR(Close
                                                                    (qVar"s",
                                                                     Dest
                                                                       ("Architecture",
                                                                        CTy"Architecture",
                                                                        qVar"s"))),
                                                               Close
                                                                 (Var("v",
                                                                      CTy"Architecture"),
                                                                  MU(EQ(Var("v",
                                                                            CTy"Architecture"),
                                                                        LC("ARMv6K",
                                                                           CTy"Architecture")),
                                                                     qTy))),
                                                            MU(LF,qTy))))))))),
                                  Close
                                    (bVar"v",
                                     MU(TP[Var("cond",F4),bVar"v"],qTy))),
                               Close
                                 (Var("v",PTy(F4,bTy)),
                                  Call
                                    ("Take",ATy(qTy,PTy(bTy,qTy)),
                                     Var("v",PTy(F4,bTy))))),
                            Close
                              (bVar"b",
                               ITE(bVar"b",
                                   MU(Let(TP[bVar"b'7",bVar"b'6",
                                             bVar"b'5",bVar"b'4",
                                             bVar"b'3",bVar"b'2",
                                             bVar"b'1",bVar"b'0"],
                                          BL(8,Var("op",F8)),
                                          ITB([(Bop(And,
                                                    Mop(Not,bVar"b'7"),
                                                    Bop(And,
                                                        Mop(Not,bVar"b'6"),
                                                        Bop(And,
                                                            Mop(Not,
                                                                bVar"b'5"),
                                                            Bop(And,
                                                                Mop(Not,
                                                                    bVar"b'4"),
                                                                Bop(And,
                                                                    Mop(Not,
                                                                        bVar"b'3"),
                                                                    Bop(And,
                                                                        Mop(Not,
                                                                            bVar"b'2"),
                                                                        Bop(And,
                                                                            Mop(Not,
                                                                                bVar"b'1"),
                                                                            bVar"b'0"))))))),
                                                Call
                                                  ("Hint",
                                                   CTy"instruction",
                                                   Const
                                                     ("Yield",CTy"Hint"))),
                                               (Bop(And,
                                                    Mop(Not,bVar"b'7"),
                                                    Bop(And,
                                                        Mop(Not,bVar"b'6"),
                                                        Bop(And,
                                                            Mop(Not,
                                                                bVar"b'5"),
                                                            Bop(And,
                                                                Mop(Not,
                                                                    bVar"b'4"),
                                                                Bop(And,
                                                                    Mop(Not,
                                                                        bVar"b'3"),
                                                                    Bop(And,
                                                                        Mop(Not,
                                                                            bVar"b'2"),
                                                                        Bop(And,
                                                                            bVar"b'1",
                                                                            Mop(Not,
                                                                                bVar"b'0")))))))),
                                                Call
                                                  ("Hint",
                                                   CTy"instruction",
                                                   Const
                                                     ("WaitForEvent",
                                                      CTy"Hint"))),
                                               (Bop(And,
                                                    Mop(Not,bVar"b'7"),
                                                    Bop(And,
                                                        Mop(Not,bVar"b'6"),
                                                        Bop(And,
                                                            Mop(Not,
                                                                bVar"b'5"),
                                                            Bop(And,
                                                                Mop(Not,
                                                                    bVar"b'4"),
                                                                Bop(And,
                                                                    Mop(Not,
                                                                        bVar"b'3"),
                                                                    Bop(And,
                                                                        Mop(Not,
                                                                            bVar"b'2"),
                                                                        Bop(And,
                                                                            bVar"b'1",
                                                                            bVar"b'0"))))))),
                                                Call
                                                  ("Hint",
                                                   CTy"instruction",
                                                   Const
                                                     ("WaitForInterrupt",
                                                      CTy"Hint"))),
                                               (Bop(And,
                                                    Mop(Not,bVar"b'7"),
                                                    Bop(And,
                                                        Mop(Not,bVar"b'6"),
                                                        Bop(And,
                                                            Mop(Not,
                                                                bVar"b'5"),
                                                            Bop(And,
                                                                Mop(Not,
                                                                    bVar"b'4"),
                                                                Bop(And,
                                                                    Mop(Not,
                                                                        bVar"b'3"),
                                                                    Bop(And,
                                                                        bVar"b'2",
                                                                        Bop(And,
                                                                            Mop(Not,
                                                                                bVar"b'1"),
                                                                            Mop(Not,
                                                                                bVar"b'0")))))))),
                                                Call
                                                  ("Hint",
                                                   CTy"instruction",
                                                   Const
                                                     ("SendEvent",
                                                      CTy"Hint"))),
                                               (Bop(And,bVar"b'7",
                                                    Bop(And,bVar"b'6",
                                                        Bop(And,bVar"b'5",
                                                            bVar"b'4"))),
                                                Call
                                                  ("Hint",
                                                   CTy"instruction",
                                                   Call
                                                     ("Debug",CTy"Hint",
                                                      Mop(Cast F4,
                                                          LL[bVar"b'3",
                                                             bVar"b'2",
                                                             bVar"b'1",
                                                             bVar"b'0"]))))],
                                              Const
                                                ("NoOperation",
                                                 CTy"instruction"))),qTy),
                                   Call
                                     ("Skip",
                                      ATy(qTy,PTy(CTy"instruction",qTy)),
                                      LU))))))))))))
;
val DecodeParallelAdditionSubtraction_def = Def
  ("DecodeParallelAdditionSubtraction",
   TP[Var("op1",FTy 2),Var("op2",FTy 3),Var("U",F1),Var("Rd",F4),
      Var("Rn",F4),Var("Rm",F4)],
   ITE(EQ(Var("U",F1),LW(1,1)),
       CS(TP[Var("op1",FTy 2),BL(3,Var("op2",FTy 3))],
          [(TP[LW(1,2),LF,bVar"x'1",bVar"x'0"],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedAddSub16",CTy"SIMD",
                  TP[Mop(Cast(FTy 2),LL[bVar"x'1",bVar"x'0"]),
                     Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(1,2),LT,LF,LF],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedAddSub8",CTy"SIMD",
                  TP[LF,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(1,2),LT,LT,LT],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedAddSub8",CTy"SIMD",
                  TP[LT,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(2,2),LF,bVar"x'1",bVar"x'0"],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedSaturatingAddSub16",CTy"SIMD",
                  TP[Mop(Cast(FTy 2),LL[bVar"x'1",bVar"x'0"]),
                     Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(2,2),LT,LF,LF],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedSaturatingAddSub8",CTy"SIMD",
                  TP[LF,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(2,2),LT,LT,LT],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedSaturatingAddSub8",CTy"SIMD",
                  TP[LT,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(3,2),LF,bVar"x'1",bVar"x'0"],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedHalvingAddSub16",CTy"SIMD",
                  TP[Mop(Cast(FTy 2),LL[bVar"x'1",bVar"x'0"]),
                     Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(3,2),LT,LF,LF],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedHalvingAddSub8",CTy"SIMD",
                  TP[LF,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(3,2),LT,LT,LT],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("UnsignedHalvingAddSub8",CTy"SIMD",
                  TP[LT,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[AVar(FTy 2),AVar bTy,AVar bTy,AVar bTy],
            Call("Undefined",CTy"instruction",LW(0,32)))]),
       CS(TP[Var("op1",FTy 2),BL(3,Var("op2",FTy 3))],
          [(TP[LW(1,2),LF,bVar"x'1",bVar"x'0"],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedAddSub16",CTy"SIMD",
                  TP[Mop(Cast(FTy 2),LL[bVar"x'1",bVar"x'0"]),
                     Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(1,2),LT,LF,LF],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedAddSub8",CTy"SIMD",
                  TP[LF,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(1,2),LT,LT,LT],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedAddSub8",CTy"SIMD",
                  TP[LT,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(2,2),LF,bVar"x'1",bVar"x'0"],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedSaturatingAddSub16",CTy"SIMD",
                  TP[Mop(Cast(FTy 2),LL[bVar"x'1",bVar"x'0"]),
                     Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(2,2),LT,LF,LF],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedSaturatingAddSub8",CTy"SIMD",
                  TP[LF,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(2,2),LT,LT,LT],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedSaturatingAddSub8",CTy"SIMD",
                  TP[LT,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(3,2),LF,bVar"x'1",bVar"x'0"],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedHalvingAddSub16",CTy"SIMD",
                  TP[Mop(Cast(FTy 2),LL[bVar"x'1",bVar"x'0"]),
                     Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(3,2),LT,LF,LF],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedHalvingAddSub8",CTy"SIMD",
                  TP[LF,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[LW(3,2),LT,LT,LT],
            Call
              ("SIMD",CTy"instruction",
               Call
                 ("SignedHalvingAddSub8",CTy"SIMD",
                  TP[LT,Var("Rd",F4),Var("Rn",F4),Var("Rm",F4)]))),
           (TP[AVar(FTy 2),AVar bTy,AVar bTy,AVar bTy],
            Call("Undefined",CTy"instruction",LW(0,32)))])))
;
val DecodeARM_def = Def
  ("DecodeARM",Var("w",F32),
   Let(Var("mc",CTy"MachineCode"),
       Call("ARM",CTy"MachineCode",Var("w",F32)),
       Let(Var("cond",F4),EX(Var("w",F32),LN 31,LN 28,F4),
           ITE(EQ(Var("cond",F4),LW(15,4)),
               Let(TP[bVar"b'27",bVar"b'26",bVar"b'25",bVar"b'24",
                      bVar"b'23",bVar"b'22",bVar"b'21",bVar"b'20",
                      bVar"b'19",bVar"b'18",bVar"b'17",bVar"b'16",
                      bVar"b'15",bVar"b'14",bVar"b'13",bVar"b'12",
                      bVar"b'11",bVar"b'10",bVar"b'9",bVar"b'8",bVar"b'7",
                      bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3",bVar"b'2",
                      bVar"b'1",bVar"b'0"],
                   BL(28,EX(Var("w",F32),LN 27,LN 0,FTy 28)),
                   ITB([(bVar"b'26",
                         ITB([(bVar"b'21",
                               ITE(Bop(And,Mop(Not,bVar"b'27"),
                                       Bop(And,Mop(Not,bVar"b'25"),
                                           Bop(And,bVar"b'24",
                                               Bop(And,
                                                   Mop(Not,bVar"b'23"),
                                                   Bop(And,bVar"b'22",
                                                       Bop(And,bVar"b'20",
                                                           Mop(Not,
                                                               bVar"b'7"))))))),
                                   ITB([(Bop(And,Mop(Not,bVar"b'6"),
                                             Bop(And,Mop(Not,bVar"b'5"),
                                                 bVar"b'4")),
                                         MB(MR(Close
                                                 (qVar"s",
                                                  Dest
                                                    ("Architecture",
                                                     CTy"Architecture",
                                                     qVar"s"))),
                                            Close
                                              (Var("v",CTy"Architecture"),
                                               MB(MB(MB(MU(Bop(In,
                                                               Var("v",
                                                                   CTy"Architecture"),
                                                               SL[LC("ARMv6K",
                                                                     CTy"Architecture"),
                                                                  LC("ARMv7_A",
                                                                     CTy"Architecture"),
                                                                  LC("ARMv7_R",
                                                                     CTy"Architecture")]),
                                                           qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[LW(14,4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MU(Const
                                                              ("ClearExclusive",
                                                               CTy"instruction"),
                                                            qTy),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))),
                                        (Bop(And,bVar"b'19",
                                             Bop(And,bVar"b'18",
                                                 Bop(And,bVar"b'17",
                                                     Bop(And,bVar"b'16",
                                                         Bop(And,
                                                             bVar"b'15",
                                                             Bop(And,
                                                                 bVar"b'14",
                                                                 Bop(And,
                                                                     bVar"b'13",
                                                                     Bop(And,
                                                                         bVar"b'12",
                                                                         Bop(And,
                                                                             Mop(Not,
                                                                                 bVar"b'11"),
                                                                             Bop(And,
                                                                                 Mop(Not,
                                                                                     bVar"b'10"),
                                                                                 Bop(And,
                                                                                     Mop(Not,
                                                                                         bVar"b'9"),
                                                                                     Bop(And,
                                                                                         Mop(Not,
                                                                                             bVar"b'8"),
                                                                                         Bop(And,
                                                                                             bVar"b'6",
                                                                                             Bop(And,
                                                                                                 Mop(Not,
                                                                                                     bVar"b'5"),
                                                                                                 Mop(Not,
                                                                                                     bVar"b'4"))))))))))))))),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MU(Bop(Ge,nVar"v",
                                                               LN 7),qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[LW(14,4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MU(Call
                                                              ("Hint",
                                                               CTy"instruction",
                                                               Call
                                                                 ("DataSynchronizationBarrier",
                                                                  CTy"Hint",
                                                                  Mop(Cast
                                                                        F4,
                                                                      LL[bVar"b'3",
                                                                         bVar"b'2",
                                                                         bVar"b'1",
                                                                         bVar"b'0"]))),
                                                            qTy),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))),
                                        (Bop(And,bVar"b'6",
                                             Bop(And,Mop(Not,bVar"b'5"),
                                                 bVar"b'4")),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MU(Bop(Ge,nVar"v",
                                                               LN 7),qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[LW(14,4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MU(Call
                                                              ("Hint",
                                                               CTy"instruction",
                                                               Call
                                                                 ("DataMemoryBarrier",
                                                                  CTy"Hint",
                                                                  Mop(Cast
                                                                        F4,
                                                                      LL[bVar"b'3",
                                                                         bVar"b'2",
                                                                         bVar"b'1",
                                                                         bVar"b'0"]))),
                                                            qTy),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))),
                                        (Bop(And,bVar"b'6",
                                             Bop(And,bVar"b'5",
                                                 Mop(Not,bVar"b'4"))),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MU(Bop(Ge,nVar"v",
                                                               LN 7),qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[LW(14,4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MU(Call
                                                              ("Hint",
                                                               CTy"instruction",
                                                               Call
                                                                 ("InstructionSynchronizationBarrier",
                                                                  CTy"Hint",
                                                                  Mop(Cast
                                                                        F4,
                                                                      LL[bVar"b'3",
                                                                         bVar"b'2",
                                                                         bVar"b'1",
                                                                         bVar"b'0"]))),
                                                            qTy),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))],
                                       MB(Call
                                            ("ArchVersion",
                                             ATy(qTy,PTy(nTy,qTy)),LU),
                                          Close
                                            (nVar"v",
                                             MB(MU(Bop(Ge,nVar"v",LN 5),
                                                   qTy),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MU(Call
                                                            ("Undefined",
                                                             CTy"instruction",
                                                             LW(0,32)),qTy),
                                                       MB(Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS""]),
                                                          Close
                                                            (AVar uTy,
                                                             MU(LX(CTy"instruction"),
                                                                qTy))))))))),
                                   MB(Call
                                        ("ArchVersion",
                                         ATy(qTy,PTy(nTy,qTy)),LU),
                                      Close
                                        (nVar"v",
                                         MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MU(Call
                                                        ("Undefined",
                                                         CTy"instruction",
                                                         LW(0,32)),qTy),
                                                   MB(Call
                                                        ("DECODE_UNPREDICTABLE",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         TP[Var("mc",
                                                                CTy"MachineCode"),
                                                            LS""]),
                                                      Close
                                                        (AVar uTy,
                                                         MU(LX(CTy"instruction"),
                                                            qTy)))))))))),
                              (Bop(And,Mop(Not,bVar"b'27"),bVar"b'20"),
                               ITB([(Bop(And,Mop(Not,bVar"b'25"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             bVar"b'22")),
                                     MB(Call
                                          ("ArchVersion",
                                           ATy(qTy,PTy(nTy,qTy)),LU),
                                        Close
                                          (nVar"v",
                                           MB(MB(MB(MU(Bop(Ge,nVar"v",LN 7),
                                                       qTy),
                                                    Close
                                                      (bVar"v",
                                                       MU(TP[LW(14,4),
                                                             bVar"v"],qTy))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MU(Call
                                                          ("Hint",
                                                           CTy"instruction",
                                                           Call
                                                             ("PreloadInstruction",
                                                              CTy"Hint",
                                                              TP[EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'23"]),
                                                                    LW(1,1)),
                                                                 Mop(Cast
                                                                       F4,
                                                                     LL[bVar"b'19",
                                                                        bVar"b'18",
                                                                        bVar"b'17",
                                                                        bVar"b'16"]),
                                                                 Call
                                                                   ("immediate_form1",
                                                                    CTy"offset1",
                                                                    Mop(Cast
                                                                          F32,
                                                                        Mop(Cast
                                                                              (FTy 12),
                                                                            LL[bVar"b'11",
                                                                               bVar"b'10",
                                                                               bVar"b'9",
                                                                               bVar"b'8",
                                                                               bVar"b'7",
                                                                               bVar"b'6",
                                                                               bVar"b'5",
                                                                               bVar"b'4",
                                                                               bVar"b'3",
                                                                               bVar"b'2",
                                                                               bVar"b'1",
                                                                               bVar"b'0"])))])),
                                                        qTy),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))),
                                    (Bop(And,bVar"b'25",
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'22",
                                                 Mop(Not,bVar"b'4")))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MU(Bop(Ge,nVar"v",
                                                               LN 7),qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[LW(14,4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(EQ(Var("Rm",
                                                                       F4),
                                                                   LW(15,4)),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "PreloadInstruction (register)"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Let(TP[Var("shift_t",
                                                                             CTy"SRType"),
                                                                         nVar"shift_n"],
                                                                      Call
                                                                        ("DecodeImmShift",
                                                                         PTy(CTy"SRType",
                                                                             nTy),
                                                                         TP[Mop(Cast
                                                                                  (FTy 2),
                                                                                LL[bVar"b'6",
                                                                                   bVar"b'5"]),
                                                                            Mop(Cast
                                                                                  (FTy 5),
                                                                                LL[bVar"b'11",
                                                                                   bVar"b'10",
                                                                                   bVar"b'9",
                                                                                   bVar"b'8",
                                                                                   bVar"b'7"])]),
                                                                      Call
                                                                        ("Hint",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("PreloadInstruction",
                                                                            CTy"Hint",
                                                                            TP[EQ(Mop(Cast
                                                                                        F1,
                                                                                      LL[bVar"b'23"]),
                                                                                  LW(1,
                                                                                     1)),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   LL[bVar"b'19",
                                                                                      bVar"b'18",
                                                                                      bVar"b'17",
                                                                                      bVar"b'16"]),
                                                                               Call
                                                                                 ("register_form1",
                                                                                  CTy"offset1",
                                                                                  TP[Var("Rm",
                                                                                         F4),
                                                                                     Var("shift_t",
                                                                                         CTy"SRType"),
                                                                                     nVar"shift_n"])]))),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))),
                                    (Bop(And,Mop(Not,bVar"b'25"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,bVar"b'19",
                                                 Bop(And,bVar"b'18",
                                                     Bop(And,bVar"b'17",
                                                         bVar"b'16"))))),
                                     MB(Call
                                          ("HaveDSPSupport",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MU(TP[LW(14,4),bVar"v"],
                                                    qTy),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MU(Call
                                                          ("Hint",
                                                           CTy"instruction",
                                                           Call
                                                             ("PreloadDataLiteral",
                                                              CTy"Hint",
                                                              TP[EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'23"]),
                                                                    LW(1,1)),
                                                                 Mop(Cast
                                                                       F32,
                                                                     Mop(Cast
                                                                           (FTy 12),
                                                                         LL[bVar"b'11",
                                                                            bVar"b'10",
                                                                            bVar"b'9",
                                                                            bVar"b'8",
                                                                            bVar"b'7",
                                                                            bVar"b'6",
                                                                            bVar"b'5",
                                                                            bVar"b'4",
                                                                            bVar"b'3",
                                                                            bVar"b'2",
                                                                            bVar"b'1",
                                                                            bVar"b'0"]))])),
                                                        qTy),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))),
                                    (Bop(And,Mop(Not,bVar"b'25"),
                                         bVar"b'24"),
                                     Let(Var("R",F1),
                                         Mop(Cast F1,LL[bVar"b'22"]),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MB(MB(MB(MU(Bop(Ge,
                                                                        nVar"v",
                                                                        LN
                                                                         7),
                                                                    qTy),
                                                                 Close
                                                                   (bVar"v",
                                                                    MU(Bop(And,
                                                                           EQ(Var("R",
                                                                                  F1),
                                                                              LW(1,
                                                                                 1)),
                                                                           bVar"v"),
                                                                       qTy))),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(MR(Close
                                                                             (qVar"s",
                                                                              Dest
                                                                                ("Extensions",
                                                                                 STy(CTy"Extensions"),
                                                                                 qVar"s"))),
                                                                        Close
                                                                          (Var("v",
                                                                               STy(CTy"Extensions")),
                                                                           MU(Bop(In,
                                                                                  LC("Extension_Multiprocessing",
                                                                                     CTy"Extensions"),
                                                                                  Var("v",
                                                                                      STy(CTy"Extensions"))),
                                                                              qTy))),
                                                                     MU(LF,
                                                                        qTy)))),
                                                           Close
                                                             (bVar"b",
                                                              ITE(bVar"b",
                                                                  MU(LT,
                                                                     qTy),
                                                                  MB(Call
                                                                       ("HaveDSPSupport",
                                                                        ATy(qTy,
                                                                            PTy(bTy,
                                                                                qTy)),
                                                                        LU),
                                                                     Close
                                                                       (bVar"v",
                                                                        MU(Bop(And,
                                                                               EQ(Var("R",
                                                                                      F1),
                                                                                  LW(0,
                                                                                     1)),
                                                                               bVar"v"),
                                                                           qTy)))))),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[LW(14,4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MU(Call
                                                              ("Hint",
                                                               CTy"instruction",
                                                               Call
                                                                 ("PreloadData",
                                                                  CTy"Hint",
                                                                  TP[EQ(Mop(Cast
                                                                              F1,
                                                                            LL[bVar"b'23"]),
                                                                        LW(1,
                                                                           1)),
                                                                     EQ(Var("R",
                                                                            F1),
                                                                        LW(0,
                                                                           1)),
                                                                     Mop(Cast
                                                                           F4,
                                                                         LL[bVar"b'19",
                                                                            bVar"b'18",
                                                                            bVar"b'17",
                                                                            bVar"b'16"]),
                                                                     Call
                                                                       ("immediate_form1",
                                                                        CTy"offset1",
                                                                        Mop(Cast
                                                                              F32,
                                                                            Mop(Cast
                                                                                  (FTy 12),
                                                                                LL[bVar"b'11",
                                                                                   bVar"b'10",
                                                                                   bVar"b'9",
                                                                                   bVar"b'8",
                                                                                   bVar"b'7",
                                                                                   bVar"b'6",
                                                                                   bVar"b'5",
                                                                                   bVar"b'4",
                                                                                   bVar"b'3",
                                                                                   bVar"b'2",
                                                                                   bVar"b'1",
                                                                                   bVar"b'0"])))])),
                                                            qTy),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))),
                                    (Bop(And,bVar"b'25",
                                         Bop(And,bVar"b'24",
                                             Mop(Not,bVar"b'4"))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rn",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'19",bVar"b'18",
                                                    bVar"b'17",bVar"b'16"]),
                                             Let(Var("R",F1),
                                                 Mop(Cast F1,
                                                     LL[bVar"b'22"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MB(MB(MB(MU(Bop(Ge,
                                                                                nVar"v",
                                                                                LN
                                                                                 7),
                                                                            qTy),
                                                                         Close
                                                                           (bVar"v",
                                                                            MU(Bop(And,
                                                                                   EQ(Var("R",
                                                                                          F1),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   bVar"v"),
                                                                               qTy))),
                                                                      Close
                                                                        (bVar"b",
                                                                         ITE(bVar"b",
                                                                             MB(MR(Close
                                                                                     (qVar"s",
                                                                                      Dest
                                                                                        ("Extensions",
                                                                                         STy(CTy"Extensions"),
                                                                                         qVar"s"))),
                                                                                Close
                                                                                  (Var("v",
                                                                                       STy(CTy"Extensions")),
                                                                                   MU(Bop(In,
                                                                                          LC("Extension_Multiprocessing",
                                                                                             CTy"Extensions"),
                                                                                          Var("v",
                                                                                              STy(CTy"Extensions"))),
                                                                                      qTy))),
                                                                             MU(LF,
                                                                                qTy)))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          MU(LT,
                                                                             qTy),
                                                                          MB(Call
                                                                               ("HaveDSPSupport",
                                                                                ATy(qTy,
                                                                                    PTy(bTy,
                                                                                        qTy)),
                                                                                LU),
                                                                             Close
                                                                               (bVar"v",
                                                                                MU(Bop(And,
                                                                                       EQ(Var("R",
                                                                                              F1),
                                                                                          LW(0,
                                                                                             1)),
                                                                                       bVar"v"),
                                                                                   qTy)))))),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[LW(14,
                                                                            4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 Let(bVar"is_pldw",
                                                                     EQ(Var("R",
                                                                            F1),
                                                                        LW(0,
                                                                           1)),
                                                                     MB(ITE(Bop(Or,
                                                                                EQ(Var("Rm",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                Bop(And,
                                                                                    EQ(Var("Rn",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4)),
                                                                                    bVar"is_pldw")),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "PreloadData (register)"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Let(TP[Var("shift_t",
                                                                                         CTy"SRType"),
                                                                                     nVar"shift_n"],
                                                                                  Call
                                                                                    ("DecodeImmShift",
                                                                                     PTy(CTy"SRType",
                                                                                         nTy),
                                                                                     TP[Mop(Cast
                                                                                              (FTy 2),
                                                                                            LL[bVar"b'6",
                                                                                               bVar"b'5"]),
                                                                                        Mop(Cast
                                                                                              (FTy 5),
                                                                                            LL[bVar"b'11",
                                                                                               bVar"b'10",
                                                                                               bVar"b'9",
                                                                                               bVar"b'8",
                                                                                               bVar"b'7"])]),
                                                                                  Call
                                                                                    ("Hint",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("PreloadData",
                                                                                        CTy"Hint",
                                                                                        TP[EQ(Mop(Cast
                                                                                                    F1,
                                                                                                  LL[bVar"b'23"]),
                                                                                              LW(1,
                                                                                                 1)),
                                                                                           bVar"is_pldw",
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           Call
                                                                                             ("register_form1",
                                                                                              CTy"offset1",
                                                                                              TP[Var("Rm",
                                                                                                     F4),
                                                                                                 Var("shift_t",
                                                                                                     CTy"SRType"),
                                                                                                 nVar"shift_n"])]))),
                                                                              qTy)))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU))))))))))],
                                   MB(Call
                                        ("ArchVersion",
                                         ATy(qTy,PTy(nTy,qTy)),LU),
                                      Close
                                        (nVar"v",
                                         MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MU(Call
                                                        ("Undefined",
                                                         CTy"instruction",
                                                         LW(0,32)),qTy),
                                                   MB(Call
                                                        ("DECODE_UNPREDICTABLE",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         TP[Var("mc",
                                                                CTy"MachineCode"),
                                                            LS""]),
                                                      Close
                                                        (AVar uTy,
                                                         MU(LX(CTy"instruction"),
                                                            qTy))))))))))],
                             MB(Call
                                  ("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                                Close
                                  (nVar"v",
                                   MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MU(Call
                                                  ("Undefined",
                                                   CTy"instruction",
                                                   LW(0,32)),qTy),
                                             MB(Call
                                                  ("DECODE_UNPREDICTABLE",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[Var("mc",
                                                          CTy"MachineCode"),
                                                      LS""]),
                                                Close
                                                  (AVar uTy,
                                                   MU(LX(CTy"instruction"),
                                                      qTy)))))))))),
                        (Bop(And,Mop(Not,bVar"b'27"),
                             Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'24",
                                     Bop(And,Mop(Not,bVar"b'23"),
                                         Bop(And,Mop(Not,bVar"b'22"),
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'20"),
                                                     Bop(And,bVar"b'16",
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'7"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'6"),
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'5"),
                                                                     Mop(Not,
                                                                         bVar"b'4")))))))))))),
                         MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                            Close
                              (nVar"v",
                               MB(MB(MB(MU(Bop(Ge,nVar"v",LN 6),qTy),
                                        Close
                                          (bVar"v",
                                           MU(TP[LW(14,4),bVar"v"],qTy))),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Call
                                              ("System",CTy"instruction",
                                               Call
                                                 ("Setend",CTy"System",
                                                  EQ(Mop(Cast F1,
                                                         LL[bVar"b'9"]),
                                                     LW(1,1)))),qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))),
                        (Bop(And,Mop(Not,bVar"b'27"),
                             Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'24",
                                     Bop(And,Mop(Not,bVar"b'23"),
                                         Bop(And,Mop(Not,bVar"b'22"),
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'20"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'16"),
                                                         Mop(Not,bVar"b'5"))))))))),
                         Let(Var("mode",FTy 5),
                             Mop(Cast(FTy 5),
                                 LL[bVar"b'4",bVar"b'3",bVar"b'2",
                                    bVar"b'1",bVar"b'0"]),
                             Let(Var("F",F1),Mop(Cast F1,LL[bVar"b'6"]),
                                 Let(Var("I",F1),
                                     Mop(Cast F1,LL[bVar"b'7"]),
                                     Let(Var("A",F1),
                                         Mop(Cast F1,LL[bVar"b'8"]),
                                         Let(Var("M",F1),
                                             Mop(Cast F1,LL[bVar"b'17"]),
                                             Let(Var("imod",FTy 2),
                                                 Mop(Cast(FTy 2),
                                                     LL[bVar"b'19",
                                                        bVar"b'18"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[LW(14,
                                                                            4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(And,
                                                                                        Mop(Not,
                                                                                            EQ(Var("mode",
                                                                                                   FTy 5),
                                                                                               LW(0,
                                                                                                  5))),
                                                                                        EQ(Var("M",
                                                                                               F1),
                                                                                           LW(0,
                                                                                              1))),
                                                                                    EQ(Bop(Bit,
                                                                                           Var("imod",
                                                                                               FTy 2),
                                                                                           LN
                                                                                            1),
                                                                                       EQ(CC[Var("A",
                                                                                                 F1),
                                                                                             Var("I",
                                                                                                 F1),
                                                                                             Var("F",
                                                                                                 F1)],
                                                                                          LW(0,
                                                                                             3)))),
                                                                                Bop(And,
                                                                                    EQ(Var("imod",
                                                                                           FTy 2),
                                                                                       LW(0,
                                                                                          2)),
                                                                                    EQ(Var("M",
                                                                                           F1),
                                                                                       LW(0,
                                                                                          1)))),
                                                                            EQ(Var("imod",
                                                                                   FTy 2),
                                                                               LW(1,
                                                                                  2))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "ChangeProcessorState"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("System",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("ChangeProcessorState",
                                                                                CTy"System",
                                                                                TP[EQ(Var("imod",
                                                                                          FTy 2),
                                                                                      LW(2,
                                                                                         2)),
                                                                                   EQ(Var("imod",
                                                                                          FTy 2),
                                                                                      LW(3,
                                                                                         2)),
                                                                                   EQ(Var("A",
                                                                                          F1),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   EQ(Var("I",
                                                                                          F1),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   EQ(Var("F",
                                                                                          F1),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   EQ(Var("M",
                                                                                          F1),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   Var("mode",
                                                                                       FTy 5)])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU))))))))))))),
                        (Bop(And,bVar"b'27",
                             Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'22",Mop(Not,bVar"b'20")))),
                         Let(Var("U",F1),Mop(Cast F1,LL[bVar"b'23"]),
                             MB(Call
                                  ("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                                Close
                                  (nVar"v",
                                   MB(MB(MB(MU(Bop(Ge,nVar"v",LN 6),qTy),
                                            Close
                                              (bVar"v",
                                               MU(TP[LW(14,4),bVar"v"],qTy))),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MU(Call
                                                  ("System",
                                                   CTy"instruction",
                                                   Call
                                                     ("StoreReturnState",
                                                      CTy"System",
                                                      TP[EQ(Var("U",F1),
                                                            LW(1,1)),
                                                         EQ(Mop(Cast F1,
                                                                LL[bVar"b'24"]),
                                                            Var("U",F1)),
                                                         EQ(Mop(Cast F1,
                                                                LL[bVar"b'21"]),
                                                            LW(1,1)),
                                                         Mop(Cast(FTy 5),
                                                             LL[bVar"b'4",
                                                                bVar"b'3",
                                                                bVar"b'2",
                                                                bVar"b'1",
                                                                bVar"b'0"])])),
                                                qTy),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))))),
                        (Bop(And,bVar"b'27",
                             Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'22"),bVar"b'20"))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                    bVar"b'16"]),
                             Let(Var("U",F1),Mop(Cast F1,LL[bVar"b'23"]),
                                 MB(Call
                                      ("ArchVersion",
                                       ATy(qTy,PTy(nTy,qTy)),LU),
                                    Close
                                      (nVar"v",
                                       MB(MB(MB(MU(Bop(Ge,nVar"v",LN 6),
                                                   qTy),
                                                Close
                                                  (bVar"v",
                                                   MU(TP[LW(14,4),bVar"v"],
                                                      qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(EQ(Var("Rn",F4),
                                                           LW(15,4)),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "ReturnFromException"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("System",
                                                             CTy"instruction",
                                                             Call
                                                               ("ReturnFromException",
                                                                CTy"System",
                                                                TP[EQ(Var("U",
                                                                          F1),
                                                                      LW(1,
                                                                         1)),
                                                                   EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'24"]),
                                                                      Var("U",
                                                                          F1)),
                                                                   EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'21"]),
                                                                      LW(1,
                                                                         1)),
                                                                   Var("Rn",
                                                                       F4)])),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))))),
                        (Bop(And,bVar"b'27",bVar"b'25"),
                         MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                            Close
                              (nVar"v",
                               MB(MB(MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                        Close
                                          (bVar"v",
                                           MU(TP[LW(14,4),bVar"v"],qTy))),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Call
                                              ("Branch",CTy"instruction",
                                               Call
                                                 ("BranchLinkExchangeImmediate",
                                                  CTy"Branch",
                                                  TP[LC("InstrSet_Thumb",
                                                        CTy"InstrSet"),
                                                     Mop(SE F32,
                                                         CC[Mop(Cast
                                                                  (FTy 24),
                                                                LL[bVar"b'23",
                                                                   bVar"b'22",
                                                                   bVar"b'21",
                                                                   bVar"b'20",
                                                                   bVar"b'19",
                                                                   bVar"b'18",
                                                                   bVar"b'17",
                                                                   bVar"b'16",
                                                                   bVar"b'15",
                                                                   bVar"b'14",
                                                                   bVar"b'13",
                                                                   bVar"b'12",
                                                                   bVar"b'11",
                                                                   bVar"b'10",
                                                                   bVar"b'9",
                                                                   bVar"b'8",
                                                                   bVar"b'7",
                                                                   bVar"b'6",
                                                                   bVar"b'5",
                                                                   bVar"b'4",
                                                                   bVar"b'3",
                                                                   bVar"b'2",
                                                                   bVar"b'1",
                                                                   bVar"b'0"]),
                                                            Mop(Cast F1,
                                                                LL[bVar"b'24"]),
                                                            LW(0,1)])])),
                                            qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU)))))))],
                       MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                          Close
                            (nVar"v",
                             MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       MU(Call
                                            ("Undefined",CTy"instruction",
                                             LW(0,32)),qTy),
                                       MB(Call
                                            ("DECODE_UNPREDICTABLE",
                                             ATy(qTy,PTy(uTy,qTy)),
                                             TP[Var("mc",CTy"MachineCode"),
                                                LS""]),
                                          Close
                                            (AVar uTy,
                                             MU(LX(CTy"instruction"),qTy)))))))))),
               Let(TP[bVar"b'27",bVar"b'26",bVar"b'25",bVar"b'24",
                      bVar"b'23",bVar"b'22",bVar"b'21",bVar"b'20",
                      bVar"b'19",bVar"b'18",bVar"b'17",bVar"b'16",
                      bVar"b'15",bVar"b'14",bVar"b'13",bVar"b'12",
                      bVar"b'11",bVar"b'10",bVar"b'9",bVar"b'8",bVar"b'7",
                      bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3",bVar"b'2",
                      bVar"b'1",bVar"b'0"],
                   BL(28,EX(Var("w",F32),LN 27,LN 0,FTy 28)),
                   ITB([(bVar"b'25",
                         ITB([(bVar"b'26",
                               ITB([(Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'22",
                                                     Bop(And,bVar"b'21",
                                                         Bop(And,
                                                             bVar"b'20",
                                                             Bop(And,
                                                                 bVar"b'7",
                                                                 Bop(And,
                                                                     bVar"b'6",
                                                                     Bop(And,
                                                                         bVar"b'5",
                                                                         bVar"b'4"))))))))),
                                     MB(MW(Close
                                             (qVar"s",
                                              Rupd
                                                ("CurrentCondition",
                                                 TP[qVar"s",Var("cond",F4)]))),
                                        Close
                                          (AVar uTy,
                                           MB(Call
                                                ("ConditionPassed",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"b",
                                                 MU(ITE(bVar"b",
                                                        Call
                                                          ("Undefined",
                                                           CTy"instruction",
                                                           Mop(Cast F32,
                                                               CC[Mop(Cast
                                                                        (FTy 12),
                                                                      LL[bVar"b'19",
                                                                         bVar"b'18",
                                                                         bVar"b'17",
                                                                         bVar"b'16",
                                                                         bVar"b'15",
                                                                         bVar"b'14",
                                                                         bVar"b'13",
                                                                         bVar"b'12",
                                                                         bVar"b'11",
                                                                         bVar"b'10",
                                                                         bVar"b'9",
                                                                         bVar"b'8"]),
                                                                  Mop(Cast
                                                                        F4,
                                                                      LL[bVar"b'3",
                                                                         bVar"b'2",
                                                                         bVar"b'1",
                                                                         bVar"b'0"])])),
                                                        Const
                                                          ("NoOperation",
                                                           CTy"instruction")),
                                                    qTy)))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'21",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'20"),
                                                     Mop(Not,bVar"b'4"))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rt",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("Rn",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 Let(Var("B",F1),
                                                     Mop(Cast F1,
                                                         LL[bVar"b'22"]),
                                                     MB(Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           TP[Var("cond",
                                                                  F4),LT]),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(Call
                                                                    ("ArchVersion",
                                                                     ATy(qTy,
                                                                         PTy(nTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (nVar"v",
                                                                     MB(MB(MB(MB(MU(Bop(Lt,
                                                                                        nVar"v",
                                                                                        LN
                                                                                         6),
                                                                                    qTy),
                                                                                 Close
                                                                                   (bVar"b",
                                                                                    MU(Bop(And,
                                                                                           bVar"b",
                                                                                           EQ(Var("Rm",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4))),
                                                                                       qTy))),
                                                                              Close
                                                                                (bVar"v",
                                                                                 MU(Bop(Or,
                                                                                        Bop(Or,
                                                                                            Bop(Or,
                                                                                                Bop(Or,
                                                                                                    Bop(And,
                                                                                                        EQ(Var("B",
                                                                                                               F1),
                                                                                                           LW(1,
                                                                                                              1)),
                                                                                                        EQ(Var("Rt",
                                                                                                               F4),
                                                                                                           LW(15,
                                                                                                              4))),
                                                                                                    EQ(Var("Rn",
                                                                                                           F4),
                                                                                                       LW(15,
                                                                                                          4))),
                                                                                                EQ(Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rt",
                                                                                                       F4))),
                                                                                            EQ(Var("Rm",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4))),
                                                                                        bVar"v"),
                                                                                    qTy))),
                                                                           Close
                                                                             (bVar"b",
                                                                              ITE(bVar"b",
                                                                                  Call
                                                                                    ("DECODE_UNPREDICTABLE",
                                                                                     ATy(qTy,
                                                                                         PTy(uTy,
                                                                                             qTy)),
                                                                                     TP[Var("mc",
                                                                                            CTy"MachineCode"),
                                                                                        LS
                                                                                         "StoreUnprivileged (regiser)"]),
                                                                                  MU(LU,
                                                                                     qTy)))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Let(bVar"add",
                                                                                  EQ(Mop(Cast
                                                                                           F1,
                                                                                         LL[bVar"b'23"]),
                                                                                     LW(1,
                                                                                        1)),
                                                                                  Let(bVar"postindex",
                                                                                      LT,
                                                                                      Let(TP[Var("shift_t",
                                                                                                 CTy"SRType"),
                                                                                             nVar"shift_n"],
                                                                                          Call
                                                                                            ("DecodeImmShift",
                                                                                             PTy(CTy"SRType",
                                                                                                 nTy),
                                                                                             TP[Mop(Cast
                                                                                                      (FTy 2),
                                                                                                    LL[bVar"b'6",
                                                                                                       bVar"b'5"]),
                                                                                                Mop(Cast
                                                                                                      (FTy 5),
                                                                                                    LL[bVar"b'11",
                                                                                                       bVar"b'10",
                                                                                                       bVar"b'9",
                                                                                                       bVar"b'8",
                                                                                                       bVar"b'7"])]),
                                                                                          Let(Var("m",
                                                                                                  CTy"offset1"),
                                                                                              Call
                                                                                                ("register_form1",
                                                                                                 CTy"offset1",
                                                                                                 TP[Var("Rm",
                                                                                                        F4),
                                                                                                    Var("shift_t",
                                                                                                        CTy"SRType"),
                                                                                                    nVar"shift_n"]),
                                                                                              ITE(EQ(Var("B",
                                                                                                         F1),
                                                                                                     LW(1,
                                                                                                        1)),
                                                                                                  Call
                                                                                                    ("Store",
                                                                                                     CTy"instruction",
                                                                                                     Call
                                                                                                       ("StoreByteUnprivileged",
                                                                                                        CTy"Store",
                                                                                                        TP[bVar"add",
                                                                                                           bVar"postindex",
                                                                                                           Var("Rt",
                                                                                                               F4),
                                                                                                           Var("Rn",
                                                                                                               F4),
                                                                                                           Var("m",
                                                                                                               CTy"offset1")])),
                                                                                                  Call
                                                                                                    ("Store",
                                                                                                     CTy"instruction",
                                                                                                     Call
                                                                                                       ("StoreUnprivileged",
                                                                                                        CTy"Store",
                                                                                                        TP[bVar"add",
                                                                                                           bVar"postindex",
                                                                                                           Var("Rt",
                                                                                                               F4),
                                                                                                           Var("Rn",
                                                                                                               F4),
                                                                                                           Var("m",
                                                                                                               CTy"offset1")]))))))),
                                                                              qTy))))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Mop(Not,bVar"b'4"))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rt",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("Rn",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 Let(Var("B",F1),
                                                     Mop(Cast F1,
                                                         LL[bVar"b'22"]),
                                                     Let(Var("P",F1),
                                                         Mop(Cast F1,
                                                             LL[bVar"b'24"]),
                                                         MB(Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               TP[Var("cond",
                                                                      F4),
                                                                  LT]),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   Let(bVar"wback",
                                                                       Bop(Or,
                                                                           EQ(Var("P",
                                                                                  F1),
                                                                              LW(0,
                                                                                 1)),
                                                                           EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'21"]),
                                                                              LW(1,
                                                                                 1))),
                                                                       MB(Call
                                                                            ("ArchVersion",
                                                                             ATy(qTy,
                                                                                 PTy(nTy,
                                                                                     qTy)),
                                                                             LU),
                                                                          Close
                                                                            (nVar"v",
                                                                             MB(MB(MB(MB(MB(MU(Bop(Lt,
                                                                                                   nVar"v",
                                                                                                   LN
                                                                                                    6),
                                                                                               qTy),
                                                                                            Close
                                                                                              (bVar"b",
                                                                                               MU(Bop(And,
                                                                                                      bVar"b",
                                                                                                      bVar"wback"),
                                                                                                  qTy))),
                                                                                         Close
                                                                                           (bVar"b",
                                                                                            MU(Bop(And,
                                                                                                   bVar"b",
                                                                                                   EQ(Var("Rm",
                                                                                                          F4),
                                                                                                      Var("Rn",
                                                                                                          F4))),
                                                                                               qTy))),
                                                                                      Close
                                                                                        (bVar"v",
                                                                                         MU(Bop(Or,
                                                                                                Bop(Or,
                                                                                                    Bop(Or,
                                                                                                        Bop(And,
                                                                                                            EQ(Var("B",
                                                                                                                   F1),
                                                                                                               LW(1,
                                                                                                                  1)),
                                                                                                            EQ(Var("Rt",
                                                                                                                   F4),
                                                                                                               LW(15,
                                                                                                                  4))),
                                                                                                        EQ(Var("Rm",
                                                                                                               F4),
                                                                                                           LW(15,
                                                                                                              4))),
                                                                                                    Bop(And,
                                                                                                        bVar"wback",
                                                                                                        Bop(Or,
                                                                                                            EQ(Var("Rn",
                                                                                                                   F4),
                                                                                                               LW(15,
                                                                                                                  4)),
                                                                                                            EQ(Var("Rn",
                                                                                                                   F4),
                                                                                                               Var("Rt",
                                                                                                                   F4))))),
                                                                                                bVar"v"),
                                                                                            qTy))),
                                                                                   Close
                                                                                     (bVar"b",
                                                                                      ITE(bVar"b",
                                                                                          Call
                                                                                            ("DECODE_UNPREDICTABLE",
                                                                                             ATy(qTy,
                                                                                                 PTy(uTy,
                                                                                                     qTy)),
                                                                                             TP[Var("mc",
                                                                                                    CTy"MachineCode"),
                                                                                                LS
                                                                                                 "Store (regiser)"]),
                                                                                          MU(LU,
                                                                                             qTy)))),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MU(Let(bVar"add",
                                                                                          EQ(Mop(Cast
                                                                                                   F1,
                                                                                                 LL[bVar"b'23"]),
                                                                                             LW(1,
                                                                                                1)),
                                                                                          Let(bVar"index",
                                                                                              EQ(Var("P",
                                                                                                     F1),
                                                                                                 LW(1,
                                                                                                    1)),
                                                                                              Let(TP[Var("shift_t",
                                                                                                         CTy"SRType"),
                                                                                                     nVar"shift_n"],
                                                                                                  Call
                                                                                                    ("DecodeImmShift",
                                                                                                     PTy(CTy"SRType",
                                                                                                         nTy),
                                                                                                     TP[Mop(Cast
                                                                                                              (FTy 2),
                                                                                                            LL[bVar"b'6",
                                                                                                               bVar"b'5"]),
                                                                                                        Mop(Cast
                                                                                                              (FTy 5),
                                                                                                            LL[bVar"b'11",
                                                                                                               bVar"b'10",
                                                                                                               bVar"b'9",
                                                                                                               bVar"b'8",
                                                                                                               bVar"b'7"])]),
                                                                                                  Let(Var("m",
                                                                                                          CTy"offset1"),
                                                                                                      Call
                                                                                                        ("register_form1",
                                                                                                         CTy"offset1",
                                                                                                         TP[Var("Rm",
                                                                                                                F4),
                                                                                                            Var("shift_t",
                                                                                                                CTy"SRType"),
                                                                                                            nVar"shift_n"]),
                                                                                                      ITE(EQ(Var("B",
                                                                                                                 F1),
                                                                                                             LW(1,
                                                                                                                1)),
                                                                                                          Call
                                                                                                            ("Store",
                                                                                                             CTy"instruction",
                                                                                                             Call
                                                                                                               ("StoreByte",
                                                                                                                CTy"Store",
                                                                                                                TP[bVar"add",
                                                                                                                   bVar"index",
                                                                                                                   bVar"wback",
                                                                                                                   Var("Rt",
                                                                                                                       F4),
                                                                                                                   Var("Rn",
                                                                                                                       F4),
                                                                                                                   Var("m",
                                                                                                                       CTy"offset1")])),
                                                                                                          Call
                                                                                                            ("Store",
                                                                                                             CTy"instruction",
                                                                                                             Call
                                                                                                               ("StoreWord",
                                                                                                                CTy"Store",
                                                                                                                TP[bVar"add",
                                                                                                                   bVar"index",
                                                                                                                   bVar"wback",
                                                                                                                   Var("Rt",
                                                                                                                       F4),
                                                                                                                   Var("Rn",
                                                                                                                       F4),
                                                                                                                   Var("m",
                                                                                                                       CTy"offset1")]))))))),
                                                                                      qTy)))))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'21",
                                                 Bop(And,bVar"b'20",
                                                     Mop(Not,bVar"b'4"))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rt",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("Rn",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       TP[Var("cond",F4),
                                                          LT]),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(Call
                                                                ("ArchVersion",
                                                                 ATy(qTy,
                                                                     PTy(nTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (nVar"v",
                                                                 MB(MB(MB(MB(MU(Bop(Lt,
                                                                                    nVar"v",
                                                                                    LN
                                                                                     6),
                                                                                qTy),
                                                                             Close
                                                                               (bVar"b",
                                                                                MU(Bop(And,
                                                                                       bVar"b",
                                                                                       EQ(Var("Rm",
                                                                                              F4),
                                                                                          Var("Rn",
                                                                                              F4))),
                                                                                   qTy))),
                                                                          Close
                                                                            (bVar"v",
                                                                             MU(Bop(Or,
                                                                                    Bop(Or,
                                                                                        Bop(Or,
                                                                                            Bop(Or,
                                                                                                EQ(Var("Rt",
                                                                                                       F4),
                                                                                                   LW(15,
                                                                                                      4)),
                                                                                                EQ(Var("Rn",
                                                                                                       F4),
                                                                                                   LW(15,
                                                                                                      4))),
                                                                                            EQ(Var("Rn",
                                                                                                   F4),
                                                                                               Var("Rt",
                                                                                                   F4))),
                                                                                        EQ(Var("Rm",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4))),
                                                                                    bVar"v"),
                                                                                qTy))),
                                                                       Close
                                                                         (bVar"b",
                                                                          ITE(bVar"b",
                                                                              Call
                                                                                ("DECODE_UNPREDICTABLE",
                                                                                 ATy(qTy,
                                                                                     PTy(uTy,
                                                                                         qTy)),
                                                                                 TP[Var("mc",
                                                                                        CTy"MachineCode"),
                                                                                    LS
                                                                                     "LoadUnprivileged (regiser)"]),
                                                                              MU(LU,
                                                                                 qTy)))),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Let(bVar"add",
                                                                              EQ(Mop(Cast
                                                                                       F1,
                                                                                     LL[bVar"b'23"]),
                                                                                 LW(1,
                                                                                    1)),
                                                                              Let(bVar"postindex",
                                                                                  LT,
                                                                                  Let(TP[Var("shift_t",
                                                                                             CTy"SRType"),
                                                                                         nVar"shift_n"],
                                                                                      Call
                                                                                        ("DecodeImmShift",
                                                                                         PTy(CTy"SRType",
                                                                                             nTy),
                                                                                         TP[Mop(Cast
                                                                                                  (FTy 2),
                                                                                                LL[bVar"b'6",
                                                                                                   bVar"b'5"]),
                                                                                            Mop(Cast
                                                                                                  (FTy 5),
                                                                                                LL[bVar"b'11",
                                                                                                   bVar"b'10",
                                                                                                   bVar"b'9",
                                                                                                   bVar"b'8",
                                                                                                   bVar"b'7"])]),
                                                                                      Let(Var("m",
                                                                                              CTy"offset1"),
                                                                                          Call
                                                                                            ("register_form1",
                                                                                             CTy"offset1",
                                                                                             TP[Var("Rm",
                                                                                                    F4),
                                                                                                Var("shift_t",
                                                                                                    CTy"SRType"),
                                                                                                nVar"shift_n"]),
                                                                                          ITE(EQ(Mop(Cast
                                                                                                       F1,
                                                                                                     LL[bVar"b'22"]),
                                                                                                 LW(1,
                                                                                                    1)),
                                                                                              Call
                                                                                                ("Load",
                                                                                                 CTy"instruction",
                                                                                                 Call
                                                                                                   ("LoadByteUnprivileged",
                                                                                                    CTy"Load",
                                                                                                    TP[bVar"add",
                                                                                                       bVar"postindex",
                                                                                                       Var("Rt",
                                                                                                           F4),
                                                                                                       Var("Rn",
                                                                                                           F4),
                                                                                                       Var("m",
                                                                                                           CTy"offset1")])),
                                                                                              Call
                                                                                                ("Load",
                                                                                                 CTy"instruction",
                                                                                                 Call
                                                                                                   ("LoadUnprivileged",
                                                                                                    CTy"Load",
                                                                                                    TP[bVar"add",
                                                                                                       bVar"postindex",
                                                                                                       Var("Rt",
                                                                                                           F4),
                                                                                                       Var("Rn",
                                                                                                           F4),
                                                                                                       Var("m",
                                                                                                           CTy"offset1")]))))))),
                                                                          qTy))))),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU)))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'20",
                                             Mop(Not,bVar"b'4"))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rt",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("Rn",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 Let(Var("B",F1),
                                                     Mop(Cast F1,
                                                         LL[bVar"b'22"]),
                                                     Let(Var("P",F1),
                                                         Mop(Cast F1,
                                                             LL[bVar"b'24"]),
                                                         MB(Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               TP[Var("cond",
                                                                      F4),
                                                                  LT]),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   Let(bVar"wback",
                                                                       Bop(Or,
                                                                           EQ(Var("P",
                                                                                  F1),
                                                                              LW(0,
                                                                                 1)),
                                                                           EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'21"]),
                                                                              LW(1,
                                                                                 1))),
                                                                       MB(Call
                                                                            ("ArchVersion",
                                                                             ATy(qTy,
                                                                                 PTy(nTy,
                                                                                     qTy)),
                                                                             LU),
                                                                          Close
                                                                            (nVar"v",
                                                                             MB(MB(MB(MB(MB(MU(Bop(Lt,
                                                                                                   nVar"v",
                                                                                                   LN
                                                                                                    6),
                                                                                               qTy),
                                                                                            Close
                                                                                              (bVar"b",
                                                                                               MU(Bop(And,
                                                                                                      bVar"b",
                                                                                                      bVar"wback"),
                                                                                                  qTy))),
                                                                                         Close
                                                                                           (bVar"b",
                                                                                            MU(Bop(And,
                                                                                                   bVar"b",
                                                                                                   EQ(Var("Rm",
                                                                                                          F4),
                                                                                                      Var("Rn",
                                                                                                          F4))),
                                                                                               qTy))),
                                                                                      Close
                                                                                        (bVar"v",
                                                                                         MU(Bop(Or,
                                                                                                Bop(Or,
                                                                                                    Bop(Or,
                                                                                                        Bop(And,
                                                                                                            EQ(Var("B",
                                                                                                                   F1),
                                                                                                               LW(1,
                                                                                                                  1)),
                                                                                                            EQ(Var("Rt",
                                                                                                                   F4),
                                                                                                               LW(15,
                                                                                                                  4))),
                                                                                                        EQ(Var("Rm",
                                                                                                               F4),
                                                                                                           LW(15,
                                                                                                              4))),
                                                                                                    Bop(And,
                                                                                                        bVar"wback",
                                                                                                        Bop(Or,
                                                                                                            EQ(Var("Rn",
                                                                                                                   F4),
                                                                                                               LW(15,
                                                                                                                  4)),
                                                                                                            EQ(Var("Rn",
                                                                                                                   F4),
                                                                                                               Var("Rt",
                                                                                                                   F4))))),
                                                                                                bVar"v"),
                                                                                            qTy))),
                                                                                   Close
                                                                                     (bVar"b",
                                                                                      ITE(bVar"b",
                                                                                          Call
                                                                                            ("DECODE_UNPREDICTABLE",
                                                                                             ATy(qTy,
                                                                                                 PTy(uTy,
                                                                                                     qTy)),
                                                                                             TP[Var("mc",
                                                                                                    CTy"MachineCode"),
                                                                                                LS
                                                                                                 "LoadWord/Byte (regiser)"]),
                                                                                          MU(LU,
                                                                                             qTy)))),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MU(Let(bVar"add",
                                                                                          EQ(Mop(Cast
                                                                                                   F1,
                                                                                                 LL[bVar"b'23"]),
                                                                                             LW(1,
                                                                                                1)),
                                                                                          Let(bVar"index",
                                                                                              EQ(Var("P",
                                                                                                     F1),
                                                                                                 LW(1,
                                                                                                    1)),
                                                                                              Let(TP[Var("shift_t",
                                                                                                         CTy"SRType"),
                                                                                                     nVar"shift_n"],
                                                                                                  Call
                                                                                                    ("DecodeImmShift",
                                                                                                     PTy(CTy"SRType",
                                                                                                         nTy),
                                                                                                     TP[Mop(Cast
                                                                                                              (FTy 2),
                                                                                                            LL[bVar"b'6",
                                                                                                               bVar"b'5"]),
                                                                                                        Mop(Cast
                                                                                                              (FTy 5),
                                                                                                            LL[bVar"b'11",
                                                                                                               bVar"b'10",
                                                                                                               bVar"b'9",
                                                                                                               bVar"b'8",
                                                                                                               bVar"b'7"])]),
                                                                                                  Let(Var("m",
                                                                                                          CTy"offset1"),
                                                                                                      Call
                                                                                                        ("register_form1",
                                                                                                         CTy"offset1",
                                                                                                         TP[Var("Rm",
                                                                                                                F4),
                                                                                                            Var("shift_t",
                                                                                                                CTy"SRType"),
                                                                                                            nVar"shift_n"]),
                                                                                                      ITE(EQ(Var("B",
                                                                                                                 F1),
                                                                                                             LW(1,
                                                                                                                1)),
                                                                                                          Call
                                                                                                            ("Load",
                                                                                                             CTy"instruction",
                                                                                                             Call
                                                                                                               ("LoadByte",
                                                                                                                CTy"Load",
                                                                                                                TP[LT,
                                                                                                                   bVar"add",
                                                                                                                   bVar"index",
                                                                                                                   bVar"wback",
                                                                                                                   Var("Rt",
                                                                                                                       F4),
                                                                                                                   Var("Rn",
                                                                                                                       F4),
                                                                                                                   Var("m",
                                                                                                                       CTy"offset1")])),
                                                                                                          Call
                                                                                                            ("Load",
                                                                                                             CTy"instruction",
                                                                                                             Call
                                                                                                               ("LoadWord",
                                                                                                                CTy"Load",
                                                                                                                TP[bVar"add",
                                                                                                                   bVar"index",
                                                                                                                   bVar"wback",
                                                                                                                   Var("Rt",
                                                                                                                       F4),
                                                                                                                   Var("Rn",
                                                                                                                       F4),
                                                                                                                   Var("m",
                                                                                                                       CTy"offset1")]))))))),
                                                                                      qTy)))))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,Mop(Not,bVar"b'23"),
                                                 bVar"b'4"))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("Rn",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[Var("cond",
                                                                             F4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            Bop(Or,
                                                                                EQ(Var("Rd",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rm",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "Parallel addition and subtraction"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("DecodeParallelAdditionSubtraction",
                                                                             CTy"instruction",
                                                                             TP[Mop(Cast
                                                                                      (FTy 2),
                                                                                    LL[bVar"b'21",
                                                                                       bVar"b'20"]),
                                                                                Mop(Cast
                                                                                      (FTy 3),
                                                                                    LL[bVar"b'7",
                                                                                       bVar"b'6",
                                                                                       bVar"b'5"]),
                                                                                Mop(Cast
                                                                                      F1,
                                                                                    LL[bVar"b'22"]),
                                                                                Var("Rd",
                                                                                    F4),
                                                                                Var("Rn",
                                                                                    F4),
                                                                                Var("Rm",
                                                                                    F4)]),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'22"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'20"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'5"),
                                                                 bVar"b'4"))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("tb",F1),
                                             Mop(Cast F1,LL[bVar"b'6"]),
                                             Let(Var("Rd",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 Let(Var("Rn",F4),
                                                     Mop(Cast F4,
                                                         LL[bVar"b'19",
                                                            bVar"b'18",
                                                            bVar"b'17",
                                                            bVar"b'16"]),
                                                     MB(Call
                                                          ("ArchVersion",
                                                           ATy(qTy,
                                                               PTy(nTy,qTy)),
                                                           LU),
                                                        Close
                                                          (nVar"v",
                                                           MB(MB(MB(MU(Bop(Ge,
                                                                           nVar"v",
                                                                           LN
                                                                            6),
                                                                       qTy),
                                                                    Close
                                                                      (bVar"v",
                                                                       MU(TP[Var("cond",
                                                                                 F4),
                                                                             bVar"v"],
                                                                          qTy))),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F4,
                                                                            bTy)),
                                                                    Call
                                                                      ("Take",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F4,
                                                                               bTy))))),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(ITE(Bop(Or,
                                                                                Bop(Or,
                                                                                    EQ(Var("Rd",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4)),
                                                                                    EQ(Var("Rn",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4))),
                                                                                EQ(Var("Rm",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "PackHalfword"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Let(TP[Var("shift_t",
                                                                                         CTy"SRType"),
                                                                                     nVar"shift_n"],
                                                                                  Call
                                                                                    ("DecodeImmShift",
                                                                                     PTy(CTy"SRType",
                                                                                         nTy),
                                                                                     TP[CC[Var("tb",
                                                                                               F1),
                                                                                           LW(0,
                                                                                              1)],
                                                                                        Mop(Cast
                                                                                              (FTy 5),
                                                                                            LL[bVar"b'11",
                                                                                               bVar"b'10",
                                                                                               bVar"b'9",
                                                                                               bVar"b'8",
                                                                                               bVar"b'7"])]),
                                                                                  Call
                                                                                    ("Media",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("PackHalfword",
                                                                                        CTy"Media",
                                                                                        TP[Var("shift_t",
                                                                                               CTy"SRType"),
                                                                                           nVar"shift_n",
                                                                                           EQ(Var("tb",
                                                                                                  F1),
                                                                                              LW(1,
                                                                                                 1)),
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           Var("Rm",
                                                                                               F4)]))),
                                                                              qTy))),
                                                                     Call
                                                                       ("Skip",
                                                                        ATy(qTy,
                                                                            PTy(CTy"instruction",
                                                                                qTy)),
                                                                        LU))))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'22"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'20"),
                                                             Bop(And,
                                                                 bVar"b'7",
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'6"),
                                                                     Bop(And,
                                                                         bVar"b'5",
                                                                         bVar"b'4"))))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("Rn",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[Var("cond",
                                                                             F4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            Bop(Or,
                                                                                EQ(Var("Rd",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rm",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "SelectBytes"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("Media",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("SelectBytes",
                                                                                CTy"Media",
                                                                                TP[Var("Rd",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Var("Rm",
                                                                                       F4)])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'21",
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4"))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("sat_imm",FTy 5),
                                                 Mop(Cast(FTy 5),
                                                     LL[bVar"b'20",
                                                        bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[Var("cond",
                                                                             F4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "Saturate"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Let(bVar"unsigned",
                                                                              EQ(Mop(Cast
                                                                                       F1,
                                                                                     LL[bVar"b'22"]),
                                                                                 LW(1,
                                                                                    1)),
                                                                              Let(TP[Var("shift_t",
                                                                                         CTy"SRType"),
                                                                                     nVar"shift_n"],
                                                                                  Call
                                                                                    ("DecodeImmShift",
                                                                                     PTy(CTy"SRType",
                                                                                         nTy),
                                                                                     TP[CC[Mop(Cast
                                                                                                 F1,
                                                                                               LL[bVar"b'6"]),
                                                                                           LW(0,
                                                                                              1)],
                                                                                        Mop(Cast
                                                                                              (FTy 5),
                                                                                            LL[bVar"b'11",
                                                                                               bVar"b'10",
                                                                                               bVar"b'9",
                                                                                               bVar"b'8",
                                                                                               bVar"b'7"])]),
                                                                                  Call
                                                                                    ("Media",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("Saturate",
                                                                                        CTy"Media",
                                                                                        TP[Var("shift_t",
                                                                                               CTy"SRType"),
                                                                                           nVar"shift_n",
                                                                                           ITE(bVar"unsigned",
                                                                                               Mop(Cast
                                                                                                     nTy,
                                                                                                   Var("sat_imm",
                                                                                                       FTy 5)),
                                                                                               Bop(Add,
                                                                                                   Mop(Cast
                                                                                                         nTy,
                                                                                                       Var("sat_imm",
                                                                                                           FTy 5)),
                                                                                                   LN
                                                                                                    1)),
                                                                                           bVar"unsigned",
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           Var("Rn",
                                                                                               F4)])))),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'21",
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'20"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'7"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'6"),
                                                                 Bop(And,
                                                                     bVar"b'5",
                                                                     bVar"b'4")))))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             Let(Var("sat_imm",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[Var("cond",
                                                                             F4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "Saturate16"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Let(bVar"unsigned",
                                                                              EQ(Mop(Cast
                                                                                       F1,
                                                                                     LL[bVar"b'22"]),
                                                                                 LW(1,
                                                                                    1)),
                                                                              Call
                                                                                ("Media",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("Saturate16",
                                                                                    CTy"Media",
                                                                                    TP[ITE(bVar"unsigned",
                                                                                           Mop(Cast
                                                                                                 nTy,
                                                                                               Var("sat_imm",
                                                                                                   F4)),
                                                                                           Bop(Add,
                                                                                               Mop(Cast
                                                                                                     nTy,
                                                                                                   Var("sat_imm",
                                                                                                       F4)),
                                                                                               LN
                                                                                                1)),
                                                                                       bVar"unsigned",
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4)]))),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'21"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'20"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'7"),
                                                             Bop(And,
                                                                 bVar"b'6",
                                                                 Bop(And,
                                                                     bVar"b'5",
                                                                     bVar"b'4")))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "ExtendByte16"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Media",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("ExtendByte16",
                                                                            CTy"Media",
                                                                            TP[EQ(Mop(Cast
                                                                                        F1,
                                                                                      LL[bVar"b'22"]),
                                                                                  LW(1,
                                                                                     1)),
                                                                               Var("Rd",
                                                                                   F4),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   LL[bVar"b'19",
                                                                                      bVar"b'18",
                                                                                      bVar"b'17",
                                                                                      bVar"b'16"]),
                                                                               Var("Rm",
                                                                                   F4),
                                                                               Mop(Cast
                                                                                     nTy,
                                                                                   CC[Mop(Cast
                                                                                            (FTy 2),
                                                                                          LL[bVar"b'11",
                                                                                             bVar"b'10"]),
                                                                                      LW(0,
                                                                                         3)])])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'21",
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'20"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'7"),
                                                             Bop(And,
                                                                 bVar"b'6",
                                                                 Bop(And,
                                                                     bVar"b'5",
                                                                     bVar"b'4")))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "ExtendByte"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Media",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("ExtendByte",
                                                                            CTy"Media",
                                                                            TP[EQ(Mop(Cast
                                                                                        F1,
                                                                                      LL[bVar"b'22"]),
                                                                                  LW(1,
                                                                                     1)),
                                                                               Var("Rd",
                                                                                   F4),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   LL[bVar"b'19",
                                                                                      bVar"b'18",
                                                                                      bVar"b'17",
                                                                                      bVar"b'16"]),
                                                                               Var("Rm",
                                                                                   F4),
                                                                               Mop(Cast
                                                                                     nTy,
                                                                                   CC[Mop(Cast
                                                                                            (FTy 2),
                                                                                          LL[bVar"b'11",
                                                                                             bVar"b'10"]),
                                                                                      LW(0,
                                                                                         3)])])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'21",
                                                     Bop(And,bVar"b'20",
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'7"),
                                                             Bop(And,
                                                                 bVar"b'6",
                                                                 Bop(And,
                                                                     bVar"b'5",
                                                                     bVar"b'4")))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "ExtendHalfword"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Media",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("ExtendHalfword",
                                                                            CTy"Media",
                                                                            TP[EQ(Mop(Cast
                                                                                        F1,
                                                                                      LL[bVar"b'22"]),
                                                                                  LW(1,
                                                                                     1)),
                                                                               Var("Rd",
                                                                                   F4),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   LL[bVar"b'19",
                                                                                      bVar"b'18",
                                                                                      bVar"b'17",
                                                                                      bVar"b'16"]),
                                                                               Var("Rm",
                                                                                   F4),
                                                                               Mop(Cast
                                                                                     nTy,
                                                                                   CC[Mop(Cast
                                                                                            (FTy 2),
                                                                                          LL[bVar"b'11",
                                                                                             bVar"b'10"]),
                                                                                      LW(0,
                                                                                         3)])])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'22"),
                                                     Bop(And,bVar"b'21",
                                                         Bop(And,
                                                             bVar"b'20",
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'7"),
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'6"),
                                                                     Bop(And,
                                                                         bVar"b'5",
                                                                         bVar"b'4"))))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "ByteReverse"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Media",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("ByteReverse",
                                                                            CTy"Media",
                                                                            TP[Var("Rd",
                                                                                   F4),
                                                                               Var("Rm",
                                                                                   F4)])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'22"),
                                                     Bop(And,bVar"b'21",
                                                         Bop(And,
                                                             bVar"b'20",
                                                             Bop(And,
                                                                 bVar"b'7",
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'6"),
                                                                     Bop(And,
                                                                         bVar"b'5",
                                                                         bVar"b'4"))))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "ByteReversePackedHalfword"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Media",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("ByteReversePackedHalfword",
                                                                            CTy"Media",
                                                                            TP[Var("Rd",
                                                                                   F4),
                                                                               Var("Rm",
                                                                                   F4)])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'22",
                                                     Bop(And,bVar"b'21",
                                                         Bop(And,
                                                             bVar"b'20",
                                                             Bop(And,
                                                                 bVar"b'7",
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'6"),
                                                                     Bop(And,
                                                                         bVar"b'5",
                                                                         bVar"b'4"))))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "ByteReverseSignedHalfword"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Media",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("ByteReverseSignedHalfword",
                                                                            CTy"Media",
                                                                            TP[Var("Rd",
                                                                                   F4),
                                                                               Var("Rm",
                                                                                   F4)])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,Mop(Not,bVar"b'24"),
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'22",
                                                     Bop(And,bVar"b'21",
                                                         Bop(And,
                                                             bVar"b'20",
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'7"),
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'6"),
                                                                     Bop(And,
                                                                         bVar"b'5",
                                                                         bVar"b'4"))))))))),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "ReverseBits"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Media",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("ReverseBits",
                                                                            CTy"Media",
                                                                            TP[Var("Rd",
                                                                                   F4),
                                                                               Var("Rm",
                                                                                   F4)])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,Mop(Not,bVar"b'23"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'22"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'20"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'7"),
                                                                 bVar"b'4"))))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rm",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'11",bVar"b'10",
                                                    bVar"b'9",bVar"b'8"]),
                                             Let(Var("Rd",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[Var("cond",
                                                                             F4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            Bop(Or,
                                                                                EQ(Var("Rd",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rm",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "SignedMultiplyDual"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("Multiply",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("SignedMultiplyDual",
                                                                                CTy"Multiply",
                                                                                TP[EQ(Mop(Cast
                                                                                            F1,
                                                                                          LL[bVar"b'6"]),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   EQ(Mop(Cast
                                                                                            F1,
                                                                                          LL[bVar"b'5"]),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   Var("Rd",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Var("Rm",
                                                                                       F4),
                                                                                   Mop(Cast
                                                                                         F4,
                                                                                       LL[bVar"b'15",
                                                                                          bVar"b'14",
                                                                                          bVar"b'13",
                                                                                          bVar"b'12"])])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,Mop(Not,bVar"b'23"),
                                                 Bop(And,bVar"b'22",
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'20"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'7"),
                                                                 bVar"b'4"))))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rm",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'11",bVar"b'10",
                                                    bVar"b'9",bVar"b'8"]),
                                             Let(Var("RdLo",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 Let(Var("RdHi",F4),
                                                     Mop(Cast F4,
                                                         LL[bVar"b'19",
                                                            bVar"b'18",
                                                            bVar"b'17",
                                                            bVar"b'16"]),
                                                     MB(Call
                                                          ("ArchVersion",
                                                           ATy(qTy,
                                                               PTy(nTy,qTy)),
                                                           LU),
                                                        Close
                                                          (nVar"v",
                                                           MB(MB(MB(MU(Bop(Ge,
                                                                           nVar"v",
                                                                           LN
                                                                            6),
                                                                       qTy),
                                                                    Close
                                                                      (bVar"v",
                                                                       MU(TP[Var("cond",
                                                                                 F4),
                                                                             bVar"v"],
                                                                          qTy))),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F4,
                                                                            bTy)),
                                                                    Call
                                                                      ("Take",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F4,
                                                                               bTy))))),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(ITE(Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        EQ(Var("RdLo",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4)),
                                                                                        EQ(Var("RdHi",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4))),
                                                                                    EQ(Var("Rn",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4))),
                                                                                EQ(Var("Rm",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "SignedMultiplyLongDual"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Call
                                                                                ("Multiply",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("SignedMultiplyLongDual",
                                                                                    CTy"Multiply",
                                                                                    TP[EQ(Mop(Cast
                                                                                                F1,
                                                                                              LL[bVar"b'6"]),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       EQ(Mop(Cast
                                                                                                F1,
                                                                                              LL[bVar"b'5"]),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       Var("RdHi",
                                                                                           F4),
                                                                                       Var("RdLo",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("Rm",
                                                                                           F4)])),
                                                                              qTy))),
                                                                     Call
                                                                       ("Skip",
                                                                        ATy(qTy,
                                                                            PTy(CTy"instruction",
                                                                                qTy)),
                                                                        LU))))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,Mop(Not,bVar"b'23"),
                                                 Bop(And,bVar"b'22",
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             bVar"b'20",
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'7"),
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'6"),
                                                                     bVar"b'4")))))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rm",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'11",bVar"b'10",
                                                    bVar"b'9",bVar"b'8"]),
                                             Let(Var("Rd",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[Var("cond",
                                                                             F4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            Bop(Or,
                                                                                EQ(Var("Rd",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rm",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "SignedMostSignificantMultiply"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("Multiply",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("SignedMostSignificantMultiply",
                                                                                CTy"Multiply",
                                                                                TP[EQ(Mop(Cast
                                                                                            F1,
                                                                                          LL[bVar"b'5"]),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   Var("Rd",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Var("Rm",
                                                                                       F4),
                                                                                   Mop(Cast
                                                                                         F4,
                                                                                       LL[bVar"b'15",
                                                                                          bVar"b'14",
                                                                                          bVar"b'13",
                                                                                          bVar"b'12"])])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,Mop(Not,bVar"b'23"),
                                                 Bop(And,bVar"b'22",
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             bVar"b'20",
                                                             Bop(And,
                                                                 bVar"b'7",
                                                                 Bop(And,
                                                                     bVar"b'6",
                                                                     bVar"b'4")))))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rm",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'11",bVar"b'10",
                                                    bVar"b'9",bVar"b'8"]),
                                             Let(Var("Ra",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 Let(Var("Rd",F4),
                                                     Mop(Cast F4,
                                                         LL[bVar"b'19",
                                                            bVar"b'18",
                                                            bVar"b'17",
                                                            bVar"b'16"]),
                                                     MB(Call
                                                          ("ArchVersion",
                                                           ATy(qTy,
                                                               PTy(nTy,qTy)),
                                                           LU),
                                                        Close
                                                          (nVar"v",
                                                           MB(MB(MB(MU(Bop(Ge,
                                                                           nVar"v",
                                                                           LN
                                                                            6),
                                                                       qTy),
                                                                    Close
                                                                      (bVar"v",
                                                                       MU(TP[Var("cond",
                                                                                 F4),
                                                                             bVar"v"],
                                                                          qTy))),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F4,
                                                                            bTy)),
                                                                    Call
                                                                      ("Take",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F4,
                                                                               bTy))))),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(ITE(Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        EQ(Var("Rd",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4)),
                                                                                        EQ(Var("Rn",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4))),
                                                                                    EQ(Var("Rm",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4))),
                                                                                EQ(Var("Ra",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "SignedMostSignificantMultiplySubtract"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Call
                                                                                ("Multiply",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("SignedMostSignificantMultiplySubtract",
                                                                                    CTy"Multiply",
                                                                                    TP[EQ(Mop(Cast
                                                                                                F1,
                                                                                              LL[bVar"b'5"]),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("Rm",
                                                                                           F4),
                                                                                       Var("Ra",
                                                                                           F4)])),
                                                                              qTy))),
                                                                     Call
                                                                       ("Skip",
                                                                        ATy(qTy,
                                                                            PTy(CTy"instruction",
                                                                                qTy)),
                                                                        LU))))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,bVar"b'23",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'22"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'20"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'7"),
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'6"),
                                                                     Bop(And,
                                                                         Mop(Not,
                                                                             bVar"b'5"),
                                                                         bVar"b'4"))))))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rm",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'11",bVar"b'10",
                                                    bVar"b'9",bVar"b'8"]),
                                             Let(Var("Rd",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Ge,
                                                                       nVar"v",
                                                                       LN
                                                                        6),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(TP[Var("cond",
                                                                             F4),
                                                                         bVar"v"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(Or,
                                                                            Bop(Or,
                                                                                EQ(Var("Rd",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rm",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "UnsignedSumAbsoluteDifferences"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("SIMD",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("UnsignedSumAbsoluteDifferences",
                                                                                CTy"SIMD",
                                                                                TP[Var("Rd",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Var("Rm",
                                                                                       F4),
                                                                                   Mop(Cast
                                                                                         F4,
                                                                                       LL[bVar"b'15",
                                                                                          bVar"b'14",
                                                                                          bVar"b'13",
                                                                                          bVar"b'12"])])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'21",
                                                     Bop(And,bVar"b'6",
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'5"),
                                                             bVar"b'4")))))),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("Rd",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ArchVersion",
                                                   ATy(qTy,PTy(nTy,qTy)),
                                                   LU),
                                                Close
                                                  (nVar"v",
                                                   MB(MB(MB(MU(Bop(Ge,
                                                                   nVar"v",
                                                                   LN 6),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             Let(nVar"lsbit",
                                                                 Mop(Cast
                                                                       nTy,
                                                                     Mop(Cast
                                                                           (FTy 5),
                                                                         LL[bVar"b'11",
                                                                            bVar"b'10",
                                                                            bVar"b'9",
                                                                            bVar"b'8",
                                                                            bVar"b'7"])),
                                                                 Let(nVar"widthminus1",
                                                                     Mop(Cast
                                                                           nTy,
                                                                         Mop(Cast
                                                                               (FTy 5),
                                                                             LL[bVar"b'20",
                                                                                bVar"b'19",
                                                                                bVar"b'18",
                                                                                bVar"b'17",
                                                                                bVar"b'16"])),
                                                                     MB(ITE(Bop(Or,
                                                                                Bop(Or,
                                                                                    EQ(Var("Rd",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4)),
                                                                                    EQ(Var("Rn",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4))),
                                                                                Bop(Lt,
                                                                                    LN
                                                                                     31,
                                                                                    Bop(Add,
                                                                                        nVar"lsbit",
                                                                                        nVar"widthminus1"))),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "BitFieldExtract"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Call
                                                                                ("Media",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("BitFieldExtract",
                                                                                    CTy"Media",
                                                                                    TP[EQ(Mop(Cast
                                                                                                F1,
                                                                                              LL[bVar"b'22"]),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       nVar"lsbit",
                                                                                       nVar"widthminus1"])),
                                                                              qTy))))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))),
                                    (Bop(And,Mop(Not,bVar"b'27"),
                                         Bop(And,bVar"b'24",
                                             Bop(And,bVar"b'23",
                                                 Bop(And,bVar"b'22",
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'21"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'6"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'5"),
                                                                 bVar"b'4"))))))),
                                     Let(Var("Rd",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'15",bVar"b'14",
                                                bVar"b'13",bVar"b'12"]),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MU(Bop(Ge,nVar"v",
                                                               LN 6),qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[Var("cond",
                                                                     F4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         Let(nVar"lsbit",
                                                             Mop(Cast nTy,
                                                                 Mop(Cast
                                                                       (FTy 5),
                                                                     LL[bVar"b'11",
                                                                        bVar"b'10",
                                                                        bVar"b'9",
                                                                        bVar"b'8",
                                                                        bVar"b'7"])),
                                                             Let(nVar"msbit",
                                                                 Mop(Cast
                                                                       nTy,
                                                                     Mop(Cast
                                                                           (FTy 5),
                                                                         LL[bVar"b'20",
                                                                            bVar"b'19",
                                                                            bVar"b'18",
                                                                            bVar"b'17",
                                                                            bVar"b'16"])),
                                                                 MB(ITE(Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            Bop(Lt,
                                                                                nVar"msbit",
                                                                                nVar"lsbit")),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "BitFieldClearOrInsert"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("Media",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("BitFieldClearOrInsert",
                                                                                CTy"Media",
                                                                                TP[Var("Rd",
                                                                                       F4),
                                                                                   Mop(Cast
                                                                                         F4,
                                                                                       LL[bVar"b'3",
                                                                                          bVar"b'2",
                                                                                          bVar"b'1",
                                                                                          bVar"b'0"]),
                                                                                   nVar"lsbit",
                                                                                   nVar"msbit"])),
                                                                          qTy))))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))),
                                    (Bop(And,bVar"b'27",bVar"b'24"),
                                     MB(Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           TP[Var("cond",F4),LT]),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MU(Call
                                                    ("System",
                                                     CTy"instruction",
                                                     Call
                                                       ("SupervisorCall",
                                                        CTy"System",
                                                        Mop(SE F32,
                                                            Mop(Cast
                                                                  (FTy 24),
                                                                LL[bVar"b'23",
                                                                   bVar"b'22",
                                                                   bVar"b'21",
                                                                   bVar"b'20",
                                                                   bVar"b'19",
                                                                   bVar"b'18",
                                                                   bVar"b'17",
                                                                   bVar"b'16",
                                                                   bVar"b'15",
                                                                   bVar"b'14",
                                                                   bVar"b'13",
                                                                   bVar"b'12",
                                                                   bVar"b'11",
                                                                   bVar"b'10",
                                                                   bVar"b'9",
                                                                   bVar"b'8",
                                                                   bVar"b'7",
                                                                   bVar"b'6",
                                                                   bVar"b'5",
                                                                   bVar"b'4",
                                                                   bVar"b'3",
                                                                   bVar"b'2",
                                                                   bVar"b'1",
                                                                   bVar"b'0"])))),
                                                  qTy),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))],
                                   Call
                                     ("UndefinedARM",
                                      ATy(qTy,PTy(CTy"instruction",qTy)),
                                      Var("cond",F4)))),
                              (Bop(And,Mop(Not,bVar"b'27"),
                                   Bop(And,bVar"b'24",
                                       Bop(And,Mop(Not,bVar"b'23"),
                                           Bop(And,Mop(Not,bVar"b'21"),
                                               Mop(Not,bVar"b'20"))))),
                               Let(Var("Rd",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'15",bVar"b'14",
                                          bVar"b'13",bVar"b'12"]),
                                   MB(Call
                                        ("HaveThumb2",
                                         ATy(qTy,PTy(bTy,qTy)),LU),
                                      Close
                                        (bVar"v",
                                         MB(MB(MU(TP[Var("cond",F4),
                                                     bVar"v"],qTy),
                                               Close
                                                 (Var("v",PTy(F4,bTy)),
                                                  Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     Var("v",PTy(F4,bTy))))),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MB(ITE(EQ(Var("Rd",F4),
                                                             LW(15,4)),
                                                          Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS
                                                                 "MoveTopHalfword"]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("Data",
                                                               CTy"instruction",
                                                               Call
                                                                 ("MoveHalfword",
                                                                  CTy"Data",
                                                                  TP[EQ(Mop(Cast
                                                                              F1,
                                                                            LL[bVar"b'22"]),
                                                                        LW(1,
                                                                           1)),
                                                                     Var("Rd",
                                                                         F4),
                                                                     CC[Mop(Cast
                                                                              F4,
                                                                            LL[bVar"b'19",
                                                                               bVar"b'18",
                                                                               bVar"b'17",
                                                                               bVar"b'16"]),
                                                                        Mop(Cast
                                                                              (FTy 12),
                                                                            LL[bVar"b'11",
                                                                               bVar"b'10",
                                                                               bVar"b'9",
                                                                               bVar"b'8",
                                                                               bVar"b'7",
                                                                               bVar"b'6",
                                                                               bVar"b'5",
                                                                               bVar"b'4",
                                                                               bVar"b'3",
                                                                               bVar"b'2",
                                                                               bVar"b'1",
                                                                               bVar"b'0"])]])),
                                                            qTy))),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU)))))))),
                              (Bop(And,Mop(Not,bVar"b'27"),
                                   Bop(And,bVar"b'24",
                                       Bop(And,Mop(Not,bVar"b'23"),
                                           Bop(And,Mop(Not,bVar"b'22"),
                                               Bop(And,bVar"b'21",
                                                   Bop(And,
                                                       Mop(Not,bVar"b'20"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'19"),
                                                           Bop(And,
                                                               Mop(Not,
                                                                   bVar"b'18"),
                                                               Bop(And,
                                                                   Mop(Not,
                                                                       bVar"b'17"),
                                                                   Mop(Not,
                                                                       bVar"b'16")))))))))),
                               Call
                                 ("DecodeHint",
                                  ATy(qTy,PTy(CTy"instruction",qTy)),
                                  TP[Var("cond",F4),
                                     Mop(Cast F8,
                                         LL[bVar"b'7",bVar"b'6",bVar"b'5",
                                            bVar"b'4",bVar"b'3",bVar"b'2",
                                            bVar"b'1",bVar"b'0"])])),
                              (Bop(And,Mop(Not,bVar"b'27"),
                                   Bop(And,bVar"b'24",
                                       Bop(And,Mop(Not,bVar"b'23"),
                                           Bop(And,bVar"b'21",
                                               Mop(Not,bVar"b'20"))))),
                               Let(Var("mask",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'19",bVar"b'18",
                                          bVar"b'17",bVar"b'16"]),
                                   MB(Call
                                        ("Take",ATy(qTy,PTy(bTy,qTy)),
                                         TP[Var("cond",F4),LT]),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(ITE(EQ(Var("mask",F4),
                                                       LW(0,4)),
                                                    Call
                                                      ("DECODE_UNPREDICTABLE",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("mc",
                                                              CTy"MachineCode"),
                                                          LS
                                                           "MoveToSpecialFromImmediate"]),
                                                    MU(LU,qTy)),
                                                Close
                                                  (AVar uTy,
                                                   MB(Call
                                                        ("ARMExpandImm",
                                                         ATy(qTy,
                                                             PTy(F32,qTy)),
                                                         Mop(Cast(FTy 12),
                                                             LL[bVar"b'11",
                                                                bVar"b'10",
                                                                bVar"b'9",
                                                                bVar"b'8",
                                                                bVar"b'7",
                                                                bVar"b'6",
                                                                bVar"b'5",
                                                                bVar"b'4",
                                                                bVar"b'3",
                                                                bVar"b'2",
                                                                bVar"b'1",
                                                                bVar"b'0"])),
                                                      Close
                                                        (Var("imm32",F32),
                                                         MU(Call
                                                              ("System",
                                                               CTy"instruction",
                                                               Call
                                                                 ("MoveToSpecialFromImmediate",
                                                                  CTy"System",
                                                                  TP[EQ(Mop(Cast
                                                                              F1,
                                                                            LL[bVar"b'22"]),
                                                                        LW(1,
                                                                           1)),
                                                                     Var("imm32",
                                                                         F32),
                                                                     Var("mask",
                                                                         F4)])),
                                                            qTy))))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))),
                              (Mop(Not,bVar"b'27"),
                               Let(Var("imm12",FTy 12),
                                   Mop(Cast(FTy 12),
                                       LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                          bVar"b'8",bVar"b'7",bVar"b'6",
                                          bVar"b'5",bVar"b'4",bVar"b'3",
                                          bVar"b'2",bVar"b'1",bVar"b'0"]),
                                   Let(Var("Rd",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'15",bVar"b'14",
                                              bVar"b'13",bVar"b'12"]),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("opc",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'24",
                                                      bVar"b'23",
                                                      bVar"b'22",
                                                      bVar"b'21"]),
                                               MB(Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     TP[Var("cond",F4),LT]),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MU(Let(bVar"setflags",
                                                                EQ(Mop(Cast
                                                                         F1,
                                                                       LL[bVar"b'20"]),
                                                                   LW(1,1)),
                                                                Let(TP[bVar"b'3",
                                                                       bVar"b'2",
                                                                       bVar"b'1",
                                                                       bVar"b'0"],
                                                                    BL(4,
                                                                       Var("opc",
                                                                           F4)),
                                                                    ITE(bVar"b'3",
                                                                        ITB([(Bop(And,
                                                                                  bVar"b'2",
                                                                                  bVar"b'0"),
                                                                              Call
                                                                                ("Data",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("Move",
                                                                                    CTy"Data",
                                                                                    TP[bVar"setflags",
                                                                                       Mop(Cast
                                                                                             bTy,
                                                                                           Mop(Cast
                                                                                                 F1,
                                                                                               LL[bVar"b'1"])),
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       Var("imm12",
                                                                                           FTy 12)]))),
                                                                             (Mop(Not,
                                                                                  bVar"b'2"),
                                                                              Call
                                                                                ("Data",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("TestCompareImmediate",
                                                                                    CTy"Data",
                                                                                    TP[Mop(Cast
                                                                                             (FTy 2),
                                                                                           LL[bVar"b'1",
                                                                                              bVar"b'0"]),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("imm12",
                                                                                           FTy 12)])))],
                                                                            Call
                                                                              ("Data",
                                                                               CTy"instruction",
                                                                               Call
                                                                                 ("ArithLogicImmediate",
                                                                                  CTy"Data",
                                                                                  TP[Var("opc",
                                                                                         F4),
                                                                                     bVar"setflags",
                                                                                     Var("Rd",
                                                                                         F4),
                                                                                     Var("Rn",
                                                                                         F4),
                                                                                     Var("imm12",
                                                                                         FTy 12)]))),
                                                                        Call
                                                                          ("Data",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("ArithLogicImmediate",
                                                                              CTy"Data",
                                                                              TP[Var("opc",
                                                                                     F4),
                                                                                 bVar"setflags",
                                                                                 Var("Rd",
                                                                                     F4),
                                                                                 Var("Rn",
                                                                                     F4),
                                                                                 Var("imm12",
                                                                                     FTy 12)]))))),
                                                            qTy),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))),
                              (Bop(And,bVar"b'27",Mop(Not,bVar"b'24")),
                               MB(Call
                                    ("Take",ATy(qTy,PTy(bTy,qTy)),
                                     TP[Var("cond",F4),LT]),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Call
                                              ("Branch",CTy"instruction",
                                               Call
                                                 ("BranchTarget",
                                                  CTy"Branch",
                                                  Mop(SE F32,
                                                      CC[Mop(Cast(FTy 24),
                                                             LL[bVar"b'23",
                                                                bVar"b'22",
                                                                bVar"b'21",
                                                                bVar"b'20",
                                                                bVar"b'19",
                                                                bVar"b'18",
                                                                bVar"b'17",
                                                                bVar"b'16",
                                                                bVar"b'15",
                                                                bVar"b'14",
                                                                bVar"b'13",
                                                                bVar"b'12",
                                                                bVar"b'11",
                                                                bVar"b'10",
                                                                bVar"b'9",
                                                                bVar"b'8",
                                                                bVar"b'7",
                                                                bVar"b'6",
                                                                bVar"b'5",
                                                                bVar"b'4",
                                                                bVar"b'3",
                                                                bVar"b'2",
                                                                bVar"b'1",
                                                                bVar"b'0"]),
                                                         LW(0,2)]))),qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))),
                              (Bop(And,bVar"b'27",bVar"b'24"),
                               MB(Call
                                    ("Take",ATy(qTy,PTy(bTy,qTy)),
                                     TP[Var("cond",F4),LT]),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Call
                                              ("Branch",CTy"instruction",
                                               Call
                                                 ("BranchLinkExchangeImmediate",
                                                  CTy"Branch",
                                                  TP[LC("InstrSet_ARM",
                                                        CTy"InstrSet"),
                                                     Mop(SE F32,
                                                         CC[Mop(Cast
                                                                  (FTy 24),
                                                                LL[bVar"b'23",
                                                                   bVar"b'22",
                                                                   bVar"b'21",
                                                                   bVar"b'20",
                                                                   bVar"b'19",
                                                                   bVar"b'18",
                                                                   bVar"b'17",
                                                                   bVar"b'16",
                                                                   bVar"b'15",
                                                                   bVar"b'14",
                                                                   bVar"b'13",
                                                                   bVar"b'12",
                                                                   bVar"b'11",
                                                                   bVar"b'10",
                                                                   bVar"b'9",
                                                                   bVar"b'8",
                                                                   bVar"b'7",
                                                                   bVar"b'6",
                                                                   bVar"b'5",
                                                                   bVar"b'4",
                                                                   bVar"b'3",
                                                                   bVar"b'2",
                                                                   bVar"b'1",
                                                                   bVar"b'0"]),
                                                            LW(0,2)])])),
                                            qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU)))))],
                             Call
                               ("UndefinedARM",
                                ATy(qTy,PTy(CTy"instruction",qTy)),
                                Var("cond",F4)))),
                        (bVar"b'27",
                         ITE(Mop(Not,bVar"b'26"),
                             ITB([(Bop(And,bVar"b'22",Mop(Not,bVar"b'20")),
                                   Let(Var("registers",F16),
                                       Mop(Cast F16,
                                           LL[bVar"b'15",bVar"b'14",
                                              bVar"b'13",bVar"b'12",
                                              bVar"b'11",bVar"b'10",
                                              bVar"b'9",bVar"b'8",
                                              bVar"b'7",bVar"b'6",
                                              bVar"b'5",bVar"b'4",
                                              bVar"b'3",bVar"b'2",
                                              bVar"b'1",bVar"b'0"]),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("U",F1),
                                               Mop(Cast F1,LL[bVar"b'23"]),
                                               MB(Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     TP[Var("cond",F4),LT]),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(Call
                                                              ("BitCount",
                                                               ATy(qTy,
                                                                   PTy(nTy,
                                                                       qTy)),
                                                               Var("registers",
                                                                   F16)),
                                                            Close
                                                              (nVar"v",
                                                               MB(MB(MB(MU(Bop(Lt,
                                                                               nVar"v",
                                                                               LN
                                                                                1),
                                                                           qTy),
                                                                        Close
                                                                          (bVar"v",
                                                                           MU(Bop(Or,
                                                                                  EQ(Var("Rn",
                                                                                         F4),
                                                                                     LW(15,
                                                                                        4)),
                                                                                  bVar"v"),
                                                                              qTy))),
                                                                     Close
                                                                       (bVar"b",
                                                                        ITE(bVar"b",
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "StoreMultipleUserRegisters"]),
                                                                            MU(LU,
                                                                               qTy)))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("Store",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("StoreMultipleUserRegisters",
                                                                              CTy"Store",
                                                                              TP[EQ(Var("U",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 EQ(Mop(Cast
                                                                                          F1,
                                                                                        LL[bVar"b'24"]),
                                                                                    Var("U",
                                                                                        F1)),
                                                                                 Var("Rn",
                                                                                     F4),
                                                                                 Var("registers",
                                                                                     F16)])),
                                                                        qTy))))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))),
                                  (Bop(And,Mop(Not,bVar"b'22"),
                                       Mop(Not,bVar"b'20")),
                                   Let(Var("registers",F16),
                                       Mop(Cast F16,
                                           LL[bVar"b'15",bVar"b'14",
                                              bVar"b'13",bVar"b'12",
                                              bVar"b'11",bVar"b'10",
                                              bVar"b'9",bVar"b'8",
                                              bVar"b'7",bVar"b'6",
                                              bVar"b'5",bVar"b'4",
                                              bVar"b'3",bVar"b'2",
                                              bVar"b'1",bVar"b'0"]),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           MB(Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 TP[Var("cond",F4),LT]),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(Call
                                                          ("BitCount",
                                                           ATy(qTy,
                                                               PTy(nTy,qTy)),
                                                           Var("registers",
                                                               F16)),
                                                        Close
                                                          (nVar"v",
                                                           MB(MB(MB(MU(Bop(Lt,
                                                                           nVar"v",
                                                                           LN
                                                                            1),
                                                                       qTy),
                                                                    Close
                                                                      (bVar"v",
                                                                       MU(Bop(Or,
                                                                              EQ(Var("Rn",
                                                                                     F4),
                                                                                 LW(15,
                                                                                    4)),
                                                                              bVar"v"),
                                                                          qTy))),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "StoreMultiple"]),
                                                                        MU(LU,
                                                                           qTy)))),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Call
                                                                      ("Store",
                                                                       CTy"instruction",
                                                                       Call
                                                                         ("StoreMultiple",
                                                                          CTy"Store",
                                                                          TP[EQ(Mop(Cast
                                                                                      F1,
                                                                                    LL[bVar"b'23"]),
                                                                                LW(1,
                                                                                   1)),
                                                                             EQ(Mop(Cast
                                                                                      F1,
                                                                                    LL[bVar"b'24"]),
                                                                                LW(1,
                                                                                   1)),
                                                                             EQ(Mop(Cast
                                                                                      F1,
                                                                                    LL[bVar"b'21"]),
                                                                                LW(1,
                                                                                   1)),
                                                                             Var("Rn",
                                                                                 F4),
                                                                             Var("registers",
                                                                                 F16)])),
                                                                    qTy))))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))),
                                  (Bop(And,bVar"b'22",
                                       Bop(And,bVar"b'20",
                                           Mop(Not,bVar"b'15"))),
                                   Let(Var("registers",FTy 15),
                                       Mop(Cast(FTy 15),
                                           LL[bVar"b'14",bVar"b'13",
                                              bVar"b'12",bVar"b'11",
                                              bVar"b'10",bVar"b'9",
                                              bVar"b'8",bVar"b'7",
                                              bVar"b'6",bVar"b'5",
                                              bVar"b'4",bVar"b'3",
                                              bVar"b'2",bVar"b'1",
                                              bVar"b'0"]),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("U",F1),
                                               Mop(Cast F1,LL[bVar"b'23"]),
                                               MB(Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     TP[Var("cond",F4),LT]),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(Call
                                                              ("BitCount",
                                                               ATy(qTy,
                                                                   PTy(nTy,
                                                                       qTy)),
                                                               Var("registers",
                                                                   FTy 15)),
                                                            Close
                                                              (nVar"v",
                                                               MB(MB(MB(MU(Bop(Lt,
                                                                               nVar"v",
                                                                               LN
                                                                                1),
                                                                           qTy),
                                                                        Close
                                                                          (bVar"v",
                                                                           MU(Bop(Or,
                                                                                  EQ(Var("Rn",
                                                                                         F4),
                                                                                     LW(15,
                                                                                        4)),
                                                                                  bVar"v"),
                                                                              qTy))),
                                                                     Close
                                                                       (bVar"b",
                                                                        ITE(bVar"b",
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "LoadMultipleUserRegisters"]),
                                                                            MU(LU,
                                                                               qTy)))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("Load",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("LoadMultipleUserRegisters",
                                                                              CTy"Load",
                                                                              TP[EQ(Var("U",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 EQ(Mop(Cast
                                                                                          F1,
                                                                                        LL[bVar"b'24"]),
                                                                                    Var("U",
                                                                                        F1)),
                                                                                 Var("Rn",
                                                                                     F4),
                                                                                 Var("registers",
                                                                                     FTy 15)])),
                                                                        qTy))))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))),
                                  (Bop(And,bVar"b'22",
                                       Bop(And,bVar"b'20",bVar"b'15")),
                                   Let(Var("registers",FTy 15),
                                       Mop(Cast(FTy 15),
                                           LL[bVar"b'14",bVar"b'13",
                                              bVar"b'12",bVar"b'11",
                                              bVar"b'10",bVar"b'9",
                                              bVar"b'8",bVar"b'7",
                                              bVar"b'6",bVar"b'5",
                                              bVar"b'4",bVar"b'3",
                                              bVar"b'2",bVar"b'1",
                                              bVar"b'0"]),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("U",F1),
                                               Mop(Cast F1,LL[bVar"b'23"]),
                                               MB(Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     TP[Var("cond",F4),LT]),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         Let(bVar"wback",
                                                             EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'21"]),
                                                                LW(1,1)),
                                                             MB(Call
                                                                  ("ArchVersion",
                                                                   ATy(qTy,
                                                                       PTy(nTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (nVar"v",
                                                                   MB(MB(MB(MB(MU(Bop(Ge,
                                                                                      nVar"v",
                                                                                      LN
                                                                                       7),
                                                                                  qTy),
                                                                               Close
                                                                                 (bVar"v",
                                                                                  MU(Bop(And,
                                                                                         Bop(And,
                                                                                             bVar"wback",
                                                                                             Bop(Bit,
                                                                                                 Var("registers",
                                                                                                     FTy 15),
                                                                                                 Mop(Cast
                                                                                                       nTy,
                                                                                                     Var("Rn",
                                                                                                         F4)))),
                                                                                         bVar"v"),
                                                                                     qTy))),
                                                                            Close
                                                                              (bVar"v",
                                                                               MU(Bop(Or,
                                                                                      EQ(Var("Rn",
                                                                                             F4),
                                                                                         LW(15,
                                                                                            4)),
                                                                                      bVar"v"),
                                                                                  qTy))),
                                                                         Close
                                                                           (bVar"b",
                                                                            ITE(bVar"b",
                                                                                Call
                                                                                  ("DECODE_UNPREDICTABLE",
                                                                                   ATy(qTy,
                                                                                       PTy(uTy,
                                                                                           qTy)),
                                                                                   TP[Var("mc",
                                                                                          CTy"MachineCode"),
                                                                                      LS
                                                                                       "LoadMultipleExceptionReturn"]),
                                                                                MU(LU,
                                                                                   qTy)))),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Call
                                                                              ("Load",
                                                                               CTy"instruction",
                                                                               Call
                                                                                 ("LoadMultipleExceptionReturn",
                                                                                  CTy"Load",
                                                                                  TP[EQ(Var("U",
                                                                                            F1),
                                                                                        LW(1,
                                                                                           1)),
                                                                                     EQ(Mop(Cast
                                                                                              F1,
                                                                                            LL[bVar"b'24"]),
                                                                                        Var("U",
                                                                                            F1)),
                                                                                     bVar"wback",
                                                                                     Var("Rn",
                                                                                         F4),
                                                                                     Var("registers",
                                                                                         FTy 15)])),
                                                                            qTy)))))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))),
                                  (Bop(And,Mop(Not,bVar"b'22"),bVar"b'20"),
                                   Let(Var("registers",F16),
                                       Mop(Cast F16,
                                           LL[bVar"b'15",bVar"b'14",
                                              bVar"b'13",bVar"b'12",
                                              bVar"b'11",bVar"b'10",
                                              bVar"b'9",bVar"b'8",
                                              bVar"b'7",bVar"b'6",
                                              bVar"b'5",bVar"b'4",
                                              bVar"b'3",bVar"b'2",
                                              bVar"b'1",bVar"b'0"]),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           MB(Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 TP[Var("cond",F4),LT]),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     Let(bVar"wback",
                                                         EQ(Mop(Cast F1,
                                                                LL[bVar"b'21"]),
                                                            LW(1,1)),
                                                         MB(Call
                                                              ("BitCount",
                                                               ATy(qTy,
                                                                   PTy(nTy,
                                                                       qTy)),
                                                               Var("registers",
                                                                   F16)),
                                                            Close
                                                              (nVar"v",
                                                               MB(MB(MB(MB(MU(Bop(Lt,
                                                                                  nVar"v",
                                                                                  LN
                                                                                   1),
                                                                              qTy),
                                                                           Close
                                                                             (bVar"v",
                                                                              MU(Bop(Or,
                                                                                     EQ(Var("Rn",
                                                                                            F4),
                                                                                        LW(15,
                                                                                           4)),
                                                                                     bVar"v"),
                                                                                 qTy))),
                                                                        Close
                                                                          (bVar"b",
                                                                           ITE(bVar"b",
                                                                               MU(LT,
                                                                                  qTy),
                                                                               MB(Call
                                                                                    ("ArchVersion",
                                                                                     ATy(qTy,
                                                                                         PTy(nTy,
                                                                                             qTy)),
                                                                                     LU),
                                                                                  Close
                                                                                    (nVar"v",
                                                                                     MB(MU(Bop(Ge,
                                                                                               nVar"v",
                                                                                               LN
                                                                                                7),
                                                                                           qTy),
                                                                                        Close
                                                                                          (bVar"v",
                                                                                           MU(Bop(And,
                                                                                                  Bop(And,
                                                                                                      bVar"wback",
                                                                                                      Bop(Bit,
                                                                                                          Var("registers",
                                                                                                              F16),
                                                                                                          Mop(Cast
                                                                                                                nTy,
                                                                                                              Var("Rn",
                                                                                                                  F4)))),
                                                                                                  bVar"v"),
                                                                                              qTy)))))))),
                                                                     Close
                                                                       (bVar"b",
                                                                        ITE(bVar"b",
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "LoadMultiple"]),
                                                                            MU(LU,
                                                                               qTy)))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("Load",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("LoadMultiple",
                                                                              CTy"Load",
                                                                              TP[EQ(Mop(Cast
                                                                                          F1,
                                                                                        LL[bVar"b'23"]),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 EQ(Mop(Cast
                                                                                          F1,
                                                                                        LL[bVar"b'24"]),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 bVar"wback",
                                                                                 Var("Rn",
                                                                                     F4),
                                                                                 Var("registers",
                                                                                     F16)])),
                                                                        qTy)))))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))],
                                 Call
                                   ("UndefinedARM",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),
                                    Var("cond",F4))),
                             Call
                               ("UndefinedARM",
                                ATy(qTy,PTy(CTy"instruction",qTy)),
                                Var("cond",F4)))),
                        (bVar"b'26",
                         ITB([(Bop(And,Mop(Not,bVar"b'24"),
                                   Bop(And,bVar"b'21",Mop(Not,bVar"b'20"))),
                               Let(Var("Rt",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'15",bVar"b'14",
                                          bVar"b'13",bVar"b'12"]),
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       Let(Var("B",F1),
                                           Mop(Cast F1,LL[bVar"b'22"]),
                                           MB(Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 TP[Var("cond",F4),LT]),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    Bop(And,
                                                                        EQ(Var("B",
                                                                               F1),
                                                                           LW(1,
                                                                              1)),
                                                                        EQ(Var("Rt",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Rn",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                EQ(Var("Rn",
                                                                       F4),
                                                                   Var("Rt",
                                                                       F4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "StoreUnprivileged (immediate)"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Let(bVar"add",
                                                                  EQ(Mop(Cast
                                                                           F1,
                                                                         LL[bVar"b'23"]),
                                                                     LW(1,
                                                                        1)),
                                                                  Let(bVar"postindex",
                                                                      LT,
                                                                      Let(Var("m",
                                                                              CTy"offset1"),
                                                                          Call
                                                                            ("immediate_form1",
                                                                             CTy"offset1",
                                                                             Mop(Cast
                                                                                   F32,
                                                                                 Mop(Cast
                                                                                       (FTy 12),
                                                                                     LL[bVar"b'11",
                                                                                        bVar"b'10",
                                                                                        bVar"b'9",
                                                                                        bVar"b'8",
                                                                                        bVar"b'7",
                                                                                        bVar"b'6",
                                                                                        bVar"b'5",
                                                                                        bVar"b'4",
                                                                                        bVar"b'3",
                                                                                        bVar"b'2",
                                                                                        bVar"b'1",
                                                                                        bVar"b'0"]))),
                                                                          ITE(EQ(Var("B",
                                                                                     F1),
                                                                                 LW(1,
                                                                                    1)),
                                                                              Call
                                                                                ("Store",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("StoreByteUnprivileged",
                                                                                    CTy"Store",
                                                                                    TP[bVar"add",
                                                                                       bVar"postindex",
                                                                                       Var("Rt",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("m",
                                                                                           CTy"offset1")])),
                                                                              Call
                                                                                ("Store",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("StoreUnprivileged",
                                                                                    CTy"Store",
                                                                                    TP[bVar"add",
                                                                                       bVar"postindex",
                                                                                       Var("Rt",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("m",
                                                                                           CTy"offset1")])))))),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))),
                              (Mop(Not,bVar"b'20"),
                               Let(Var("Rt",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'15",bVar"b'14",
                                          bVar"b'13",bVar"b'12"]),
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       Let(Var("B",F1),
                                           Mop(Cast F1,LL[bVar"b'22"]),
                                           Let(Var("P",F1),
                                               Mop(Cast F1,LL[bVar"b'24"]),
                                               MB(Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     TP[Var("cond",F4),LT]),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         Let(bVar"wback",
                                                             Bop(Or,
                                                                 EQ(Var("P",
                                                                        F1),
                                                                    LW(0,1)),
                                                                 EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'21"]),
                                                                    LW(1,1))),
                                                             MB(ITE(Bop(Or,
                                                                        Bop(And,
                                                                            EQ(Var("B",
                                                                                   F1),
                                                                               LW(1,
                                                                                  1)),
                                                                            EQ(Var("Rt",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Bop(And,
                                                                            bVar"wback",
                                                                            Bop(Or,
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   Var("Rt",
                                                                                       F4))))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "Store (immediate)"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Let(bVar"add",
                                                                          EQ(Mop(Cast
                                                                                   F1,
                                                                                 LL[bVar"b'23"]),
                                                                             LW(1,
                                                                                1)),
                                                                          Let(bVar"index",
                                                                              EQ(Var("P",
                                                                                     F1),
                                                                                 LW(1,
                                                                                    1)),
                                                                              Let(Var("m",
                                                                                      CTy"offset1"),
                                                                                  Call
                                                                                    ("immediate_form1",
                                                                                     CTy"offset1",
                                                                                     Mop(Cast
                                                                                           F32,
                                                                                         Mop(Cast
                                                                                               (FTy 12),
                                                                                             LL[bVar"b'11",
                                                                                                bVar"b'10",
                                                                                                bVar"b'9",
                                                                                                bVar"b'8",
                                                                                                bVar"b'7",
                                                                                                bVar"b'6",
                                                                                                bVar"b'5",
                                                                                                bVar"b'4",
                                                                                                bVar"b'3",
                                                                                                bVar"b'2",
                                                                                                bVar"b'1",
                                                                                                bVar"b'0"]))),
                                                                                  ITE(EQ(Var("B",
                                                                                             F1),
                                                                                         LW(1,
                                                                                            1)),
                                                                                      Call
                                                                                        ("Store",
                                                                                         CTy"instruction",
                                                                                         Call
                                                                                           ("StoreByte",
                                                                                            CTy"Store",
                                                                                            TP[bVar"add",
                                                                                               bVar"index",
                                                                                               bVar"wback",
                                                                                               Var("Rt",
                                                                                                   F4),
                                                                                               Var("Rn",
                                                                                                   F4),
                                                                                               Var("m",
                                                                                                   CTy"offset1")])),
                                                                                      Call
                                                                                        ("Store",
                                                                                         CTy"instruction",
                                                                                         Call
                                                                                           ("StoreWord",
                                                                                            CTy"Store",
                                                                                            TP[bVar"add",
                                                                                               bVar"index",
                                                                                               bVar"wback",
                                                                                               Var("Rt",
                                                                                                   F4),
                                                                                               Var("Rn",
                                                                                                   F4),
                                                                                               Var("m",
                                                                                                   CTy"offset1")])))))),
                                                                      qTy)))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))),
                              (Bop(And,Mop(Not,bVar"b'24"),
                                   Bop(And,bVar"b'21",bVar"b'20")),
                               Let(Var("Rt",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'15",bVar"b'14",
                                          bVar"b'13",bVar"b'12"]),
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       MB(Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             TP[Var("cond",F4),LT]),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(Or,
                                                            Bop(Or,
                                                                EQ(Var("Rt",
                                                                       F4),
                                                                   LW(15,4)),
                                                                EQ(Var("Rn",
                                                                       F4),
                                                                   LW(15,4))),
                                                            EQ(Var("Rn",F4),
                                                               Var("Rt",F4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "LoadUnprivileged (immediate)"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Let(bVar"add",
                                                              EQ(Mop(Cast
                                                                       F1,
                                                                     LL[bVar"b'23"]),
                                                                 LW(1,1)),
                                                              Let(bVar"postindex",
                                                                  LT,
                                                                  Let(Var("m",
                                                                          CTy"offset1"),
                                                                      Call
                                                                        ("immediate_form1",
                                                                         CTy"offset1",
                                                                         Mop(Cast
                                                                               F32,
                                                                             Mop(Cast
                                                                                   (FTy 12),
                                                                                 LL[bVar"b'11",
                                                                                    bVar"b'10",
                                                                                    bVar"b'9",
                                                                                    bVar"b'8",
                                                                                    bVar"b'7",
                                                                                    bVar"b'6",
                                                                                    bVar"b'5",
                                                                                    bVar"b'4",
                                                                                    bVar"b'3",
                                                                                    bVar"b'2",
                                                                                    bVar"b'1",
                                                                                    bVar"b'0"]))),
                                                                      ITE(EQ(Mop(Cast
                                                                                   F1,
                                                                                 LL[bVar"b'22"]),
                                                                             LW(1,
                                                                                1)),
                                                                          Call
                                                                            ("Load",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("LoadByteUnprivileged",
                                                                                CTy"Load",
                                                                                TP[bVar"add",
                                                                                   bVar"postindex",
                                                                                   Var("Rt",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Var("m",
                                                                                       CTy"offset1")])),
                                                                          Call
                                                                            ("Load",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("LoadUnprivileged",
                                                                                CTy"Load",
                                                                                TP[bVar"add",
                                                                                   bVar"postindex",
                                                                                   Var("Rt",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Var("m",
                                                                                       CTy"offset1")])))))),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))),
                              (Bop(And,bVar"b'20",
                                   Bop(And,bVar"b'19",
                                       Bop(And,bVar"b'18",
                                           Bop(And,bVar"b'17",bVar"b'16")))),
                               Let(Var("Rt",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'15",bVar"b'14",
                                          bVar"b'13",bVar"b'12"]),
                                   Let(Var("B",F1),
                                       Mop(Cast F1,LL[bVar"b'22"]),
                                       MB(Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             TP[Var("cond",F4),LT]),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(And,
                                                            EQ(Var("B",F1),
                                                               LW(1,1)),
                                                            EQ(Var("Rt",F4),
                                                               LW(15,4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "LoadByte (literal)"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Let(bVar"add",
                                                              EQ(Mop(Cast
                                                                       F1,
                                                                     LL[bVar"b'23"]),
                                                                 LW(1,1)),
                                                              Let(Var("imm32",
                                                                      F32),
                                                                  Mop(Cast
                                                                        F32,
                                                                      Mop(Cast
                                                                            (FTy 12),
                                                                          LL[bVar"b'11",
                                                                             bVar"b'10",
                                                                             bVar"b'9",
                                                                             bVar"b'8",
                                                                             bVar"b'7",
                                                                             bVar"b'6",
                                                                             bVar"b'5",
                                                                             bVar"b'4",
                                                                             bVar"b'3",
                                                                             bVar"b'2",
                                                                             bVar"b'1",
                                                                             bVar"b'0"])),
                                                                  ITE(EQ(Var("B",
                                                                             F1),
                                                                         LW(1,
                                                                            1)),
                                                                      Call
                                                                        ("Load",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("LoadByteLiteral",
                                                                            CTy"Load",
                                                                            TP[LT,
                                                                               bVar"add",
                                                                               Var("Rt",
                                                                                   F4),
                                                                               Var("imm32",
                                                                                   F32)])),
                                                                      Call
                                                                        ("Load",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("LoadLiteral",
                                                                            CTy"Load",
                                                                            TP[bVar"add",
                                                                               Var("Rt",
                                                                                   F4),
                                                                               Var("imm32",
                                                                                   F32)]))))),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))),
                              (bVar"b'20",
                               Let(Var("Rt",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'15",bVar"b'14",
                                          bVar"b'13",bVar"b'12"]),
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       Let(Var("B",F1),
                                           Mop(Cast F1,LL[bVar"b'22"]),
                                           Let(Var("P",F1),
                                               Mop(Cast F1,LL[bVar"b'24"]),
                                               MB(Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     TP[Var("cond",F4),LT]),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         Let(bVar"wback",
                                                             Bop(Or,
                                                                 EQ(Var("P",
                                                                        F1),
                                                                    LW(0,1)),
                                                                 EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'21"]),
                                                                    LW(1,1))),
                                                             MB(ITE(Bop(Or,
                                                                        Bop(And,
                                                                            EQ(Var("B",
                                                                                   F1),
                                                                               LW(1,
                                                                                  1)),
                                                                            EQ(Var("Rt",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        Bop(And,
                                                                            bVar"wback",
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               Var("Rt",
                                                                                   F4)))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "LoadWord/Byte (immediate)"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Let(bVar"add",
                                                                          EQ(Mop(Cast
                                                                                   F1,
                                                                                 LL[bVar"b'23"]),
                                                                             LW(1,
                                                                                1)),
                                                                          Let(bVar"index",
                                                                              EQ(Var("P",
                                                                                     F1),
                                                                                 LW(1,
                                                                                    1)),
                                                                              Let(Var("m",
                                                                                      CTy"offset1"),
                                                                                  Call
                                                                                    ("immediate_form1",
                                                                                     CTy"offset1",
                                                                                     Mop(Cast
                                                                                           F32,
                                                                                         Mop(Cast
                                                                                               (FTy 12),
                                                                                             LL[bVar"b'11",
                                                                                                bVar"b'10",
                                                                                                bVar"b'9",
                                                                                                bVar"b'8",
                                                                                                bVar"b'7",
                                                                                                bVar"b'6",
                                                                                                bVar"b'5",
                                                                                                bVar"b'4",
                                                                                                bVar"b'3",
                                                                                                bVar"b'2",
                                                                                                bVar"b'1",
                                                                                                bVar"b'0"]))),
                                                                                  ITE(EQ(Var("B",
                                                                                             F1),
                                                                                         LW(1,
                                                                                            1)),
                                                                                      Call
                                                                                        ("Load",
                                                                                         CTy"instruction",
                                                                                         Call
                                                                                           ("LoadByte",
                                                                                            CTy"Load",
                                                                                            TP[LT,
                                                                                               bVar"add",
                                                                                               bVar"index",
                                                                                               bVar"wback",
                                                                                               Var("Rt",
                                                                                                   F4),
                                                                                               Var("Rn",
                                                                                                   F4),
                                                                                               Var("m",
                                                                                                   CTy"offset1")])),
                                                                                      Call
                                                                                        ("Load",
                                                                                         CTy"instruction",
                                                                                         Call
                                                                                           ("LoadWord",
                                                                                            CTy"Load",
                                                                                            TP[bVar"add",
                                                                                               bVar"index",
                                                                                               bVar"wback",
                                                                                               Var("Rt",
                                                                                                   F4),
                                                                                               Var("Rn",
                                                                                                   F4),
                                                                                               Var("m",
                                                                                                   CTy"offset1")])))))),
                                                                      qTy)))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))],
                             Call
                               ("UndefinedARM",
                                ATy(qTy,PTy(CTy"instruction",qTy)),
                                Var("cond",F4)))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'21"),
                                     Bop(And,Mop(Not,bVar"b'20"),
                                         Bop(And,bVar"b'9",
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         Mop(Not,bVar"b'4"))))))))),
                         Let(Var("Rd",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             MB(Call
                                  ("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
                                Close
                                  (bVar"v",
                                   MB(MB(MU(TP[Var("cond",F4),bVar"v"],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(ITE(EQ(Var("Rd",F4),
                                                       LW(15,4)),
                                                    Call
                                                      ("DECODE_UNPREDICTABLE",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("mc",
                                                              CTy"MachineCode"),
                                                          LS
                                                           "MoveToRegisterFromBankedOrSpecial"]),
                                                    MU(LU,qTy)),
                                                Close
                                                  (AVar uTy,
                                                   MU(Call
                                                        ("System",
                                                         CTy"instruction",
                                                         Call
                                                           ("MoveToRegisterFromBankedOrSpecial",
                                                            CTy"System",
                                                            TP[EQ(Mop(Cast
                                                                        F1,
                                                                      LL[bVar"b'22"]),
                                                                  LW(1,1)),
                                                               CC[Mop(Cast
                                                                        F1,
                                                                      LL[bVar"b'8"]),
                                                                  Mop(Cast
                                                                        F4,
                                                                      LL[bVar"b'19",
                                                                         bVar"b'18",
                                                                         bVar"b'17",
                                                                         bVar"b'16"])],
                                                               Var("Rd",F4)])),
                                                      qTy))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'21"),
                                     Bop(And,Mop(Not,bVar"b'20"),
                                         Bop(And,Mop(Not,bVar"b'9"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         Mop(Not,bVar"b'4"))))))))),
                         Let(Var("Rd",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             MB(Call
                                  ("Take",ATy(qTy,PTy(bTy,qTy)),
                                   TP[Var("cond",F4),LT]),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       MB(ITE(EQ(Var("Rd",F4),LW(15,4)),
                                              Call
                                                ("DECODE_UNPREDICTABLE",
                                                 ATy(qTy,PTy(uTy,qTy)),
                                                 TP[Var("mc",
                                                        CTy"MachineCode"),
                                                    LS
                                                     "MoveToRegisterFromSpecial"]),
                                              MU(LU,qTy)),
                                          Close
                                            (AVar uTy,
                                             MU(Call
                                                  ("System",
                                                   CTy"instruction",
                                                   Call
                                                     ("MoveToRegisterFromSpecial",
                                                      CTy"System",
                                                      TP[EQ(Mop(Cast F1,
                                                                LL[bVar"b'22"]),
                                                            LW(1,1)),
                                                         Var("Rd",F4)])),
                                                qTy))),
                                       Call
                                         ("Skip",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU)))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'21",
                                     Bop(And,Mop(Not,bVar"b'20"),
                                         Bop(And,bVar"b'9",
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         Mop(Not,bVar"b'4"))))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             MB(Call
                                  ("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
                                Close
                                  (bVar"v",
                                   MB(MB(MU(TP[Var("cond",F4),bVar"v"],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(ITE(Bop(In,Var("Rn",F4),
                                                        SL[LW(13,4),
                                                           LW(15,4)]),
                                                    Call
                                                      ("DECODE_UNPREDICTABLE",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("mc",
                                                              CTy"MachineCode"),
                                                          LS
                                                           "MoveToBankedOrSpecialRegister"]),
                                                    MU(LU,qTy)),
                                                Close
                                                  (AVar uTy,
                                                   MU(Call
                                                        ("System",
                                                         CTy"instruction",
                                                         Call
                                                           ("MoveToBankedOrSpecialRegister",
                                                            CTy"System",
                                                            TP[EQ(Mop(Cast
                                                                        F1,
                                                                      LL[bVar"b'22"]),
                                                                  LW(1,1)),
                                                               CC[Mop(Cast
                                                                        F1,
                                                                      LL[bVar"b'8"]),
                                                                  Mop(Cast
                                                                        F4,
                                                                      LL[bVar"b'19",
                                                                         bVar"b'18",
                                                                         bVar"b'17",
                                                                         bVar"b'16"])],
                                                               Var("Rn",F4)])),
                                                      qTy))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'21",
                                     Bop(And,Mop(Not,bVar"b'20"),
                                         Bop(And,Mop(Not,bVar"b'9"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         Mop(Not,bVar"b'4"))))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("mask",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       TP[Var("cond",F4),LT]),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MB(ITE(Bop(Or,
                                                      EQ(Var("Rn",F4),
                                                         LW(15,4)),
                                                      EQ(Var("mask",F4),
                                                         LW(0,4))),
                                                  Call
                                                    ("DECODE_UNPREDICTABLE",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Var("mc",
                                                            CTy"MachineCode"),
                                                        LS
                                                         "MoveToSpecialFromRegister"]),
                                                  MU(LU,qTy)),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("System",
                                                       CTy"instruction",
                                                       Call
                                                         ("MoveToSpecialFromRegister",
                                                          CTy"System",
                                                          TP[EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'22"]),
                                                                LW(1,1)),
                                                             Var("Rn",F4),
                                                             Var("mask",F4)])),
                                                    qTy))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         MB(MR(Close
                                 (qVar"s",
                                  Dest
                                    ("Architecture",CTy"Architecture",
                                     qVar"s"))),
                            Close
                              (Var("v",CTy"Architecture"),
                               MB(MB(MB(MB(MU(EQ(Var("v",CTy"Architecture"),
                                                 LC("ARMv4",
                                                    CTy"Architecture")),
                                              qTy),
                                           Close
                                             (bVar"v",
                                              MU(Mop(Not,bVar"v"),qTy))),
                                        Close
                                          (bVar"v",
                                           MU(TP[Var("cond",F4),bVar"v"],
                                              qTy))),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Call
                                              ("Branch",CTy"instruction",
                                               Call
                                                 ("BranchExchange",
                                                  CTy"Branch",
                                                  Mop(Cast F4,
                                                      LL[bVar"b'3",
                                                         bVar"b'2",
                                                         bVar"b'1",
                                                         bVar"b'0"]))),qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rd",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 MB(Call
                                      ("ArchVersion",
                                       ATy(qTy,PTy(nTy,qTy)),LU),
                                    Close
                                      (nVar"v",
                                       MB(MB(MB(MU(Bop(Ge,nVar"v",LN 5),
                                                   qTy),
                                                Close
                                                  (bVar"v",
                                                   MU(TP[Var("cond",F4),
                                                         bVar"v"],qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(Or,
                                                            EQ(Var("Rd",F4),
                                                               LW(15,4)),
                                                            EQ(Var("Rm",F4),
                                                               LW(15,4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "CountLeadingZeroes"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Data",
                                                             CTy"instruction",
                                                             Call
                                                               ("CountLeadingZeroes",
                                                                CTy"Data",
                                                                TP[Var("Rd",
                                                                       F4),
                                                                   Var("Rm",
                                                                       F4)])),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,bVar"b'5",
                                                         bVar"b'4")))))))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             MB(Call
                                  ("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                                Close
                                  (nVar"v",
                                   MB(MB(MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                            Close
                                              (bVar"v",
                                               MU(TP[Var("cond",F4),
                                                     bVar"v"],qTy))),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(ITE(EQ(Var("Rm",F4),
                                                       LW(15,4)),
                                                    Call
                                                      ("DECODE_UNPREDICTABLE",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("mc",
                                                              CTy"MachineCode"),
                                                          LS
                                                           "BranchLinkExchangeRegister"]),
                                                    MU(LU,qTy)),
                                                Close
                                                  (AVar uTy,
                                                   MU(Call
                                                        ("Branch",
                                                         CTy"instruction",
                                                         Call
                                                           ("BranchLinkExchangeRegister",
                                                            CTy"Branch",
                                                            Var("Rm",F4))),
                                                      qTy))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'20"),
                                     Bop(And,Mop(Not,bVar"b'7"),
                                         Bop(And,bVar"b'6",
                                             Bop(And,Mop(Not,bVar"b'5"),
                                                 bVar"b'4")))))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rd",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(Call
                                          ("HaveDSPSupport",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MU(TP[Var("cond",F4),
                                                       bVar"v"],qTy),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       LW(15,
                                                                          4)),
                                                                    EQ(Var("Rn",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                EQ(Var("Rm",
                                                                       F4),
                                                                   LW(15,4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "SaturatingAddSubtract"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Media",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("SaturatingAddSubtract",
                                                                    CTy"Media",
                                                                    TP[Mop(Cast
                                                                             (FTy 2),
                                                                           LL[bVar"b'22",
                                                                              bVar"b'21"]),
                                                                       Var("Rd",
                                                                           F4),
                                                                       Var("Rm",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4)])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,bVar"b'6",
                                                     Bop(And,bVar"b'5",
                                                         bVar"b'4")))))))),
                         MB(Call("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                            Close
                              (nVar"v",
                               MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MB(ITE(Mop(Not,
                                                    EQ(Var("cond",F4),
                                                       LW(14,4))),
                                                Call
                                                  ("DECODE_UNPREDICTABLE",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[Var("mc",
                                                          CTy"MachineCode"),
                                                      LS"Breakpoint"]),
                                                MU(LU,qTy)),
                                            Close
                                              (AVar uTy,
                                               MB(MW(Close
                                                       (qVar"s",
                                                        Rupd
                                                          ("CurrentCondition",
                                                           TP[qVar"s",
                                                              Var("cond",
                                                                  F4)]))),
                                                  Close
                                                    (AVar uTy,
                                                     MU(Call
                                                          ("Hint",
                                                           CTy"instruction",
                                                           Call
                                                             ("Breakpoint",
                                                              CTy"Hint",
                                                              Mop(Cast F32,
                                                                  CC[Mop(Cast
                                                                           (FTy 12),
                                                                         LL[bVar"b'19",
                                                                            bVar"b'18",
                                                                            bVar"b'17",
                                                                            bVar"b'16",
                                                                            bVar"b'15",
                                                                            bVar"b'14",
                                                                            bVar"b'13",
                                                                            bVar"b'12",
                                                                            bVar"b'11",
                                                                            bVar"b'10",
                                                                            bVar"b'9",
                                                                            bVar"b'8"]),
                                                                     Mop(Cast
                                                                           F4,
                                                                         LL[bVar"b'3",
                                                                            bVar"b'2",
                                                                            bVar"b'1",
                                                                            bVar"b'0"])]))),
                                                        qTy))))),
                                         MB(Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               TP[Var("cond",F4),LF]),
                                            Close
                                              (bVar"b",
                                               MU(ITE(bVar"b",
                                                      Call
                                                        ("Undefined",
                                                         CTy"instruction",
                                                         LW(0,32)),
                                                      Const
                                                        ("NoOperation",
                                                         CTy"instruction")),
                                                  qTy))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,bVar"b'6",
                                                     Bop(And,bVar"b'5",
                                                         bVar"b'4")))))))),
                         MB(Call("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
                            Close
                              (bVar"v",
                               MB(MB(MU(TP[Var("cond",F4),bVar"v"],qTy),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MB(ITE(Mop(Not,
                                                    EQ(Var("cond",F4),
                                                       LW(14,4))),
                                                Call
                                                  ("DECODE_UNPREDICTABLE",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[Var("mc",
                                                          CTy"MachineCode"),
                                                      LS"HypervisorCall"]),
                                                MU(LU,qTy)),
                                            Close
                                              (AVar uTy,
                                               MU(Call
                                                    ("System",
                                                     CTy"instruction",
                                                     Call
                                                       ("HypervisorCall",
                                                        CTy"System",
                                                        CC[Mop(Cast
                                                                 (FTy 12),
                                                               LL[bVar"b'19",
                                                                  bVar"b'18",
                                                                  bVar"b'17",
                                                                  bVar"b'16",
                                                                  bVar"b'15",
                                                                  bVar"b'14",
                                                                  bVar"b'13",
                                                                  bVar"b'12",
                                                                  bVar"b'11",
                                                                  bVar"b'10",
                                                                  bVar"b'9",
                                                                  bVar"b'8"]),
                                                           Mop(Cast F4,
                                                               LL[bVar"b'3",
                                                                  bVar"b'2",
                                                                  bVar"b'1",
                                                                  bVar"b'0"])])),
                                                  qTy))),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,Mop(Not,bVar"b'7"),
                                                 Bop(And,bVar"b'6",
                                                     Bop(And,bVar"b'5",
                                                         bVar"b'4")))))))),
                         MB(Call
                              ("HaveSecurityExt",ATy(qTy,PTy(bTy,qTy)),LU),
                            Close
                              (bVar"v",
                               MB(MB(MU(TP[Var("cond",F4),bVar"v"],qTy),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Call
                                              ("System",CTy"instruction",
                                               Call
                                                 ("SecureMonitorCall",
                                                  CTy"System",
                                                  Mop(Cast F4,
                                                      LL[bVar"b'3",
                                                         bVar"b'2",
                                                         bVar"b'1",
                                                         bVar"b'0"]))),qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Mop(Not,bVar"b'4"))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("Ra",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("Rd",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         MB(Call
                                              ("HaveDSPSupport",
                                               ATy(qTy,PTy(bTy,qTy)),LU),
                                            Close
                                              (bVar"v",
                                               MB(MB(MU(TP[Var("cond",F4),
                                                           bVar"v"],qTy),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Ra",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "Signed16Multiply32Accumulate"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Multiply",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("Signed16Multiply32Accumulate",
                                                                        CTy"Multiply",
                                                                        TP[EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'6"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'5"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           Var("Rd",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Var("Rm",
                                                                               F4),
                                                                           Var("Ra",
                                                                               F4)])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'5"),
                                                     Mop(Not,bVar"b'4")))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("Ra",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("Rd",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         MB(Call
                                              ("HaveDSPSupport",
                                               ATy(qTy,PTy(bTy,qTy)),LU),
                                            Close
                                              (bVar"v",
                                               MB(MB(MU(TP[Var("cond",F4),
                                                           bVar"v"],qTy),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Ra",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "Signed16x32Multiply32Accumulate"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Multiply",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("Signed16x32Multiply32Accumulate",
                                                                        CTy"Multiply",
                                                                        TP[EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'6"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           Var("Rd",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Var("Rm",
                                                                               F4),
                                                                           Var("Ra",
                                                                               F4)])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,bVar"b'5",
                                                     Mop(Not,bVar"b'4")))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("Rd",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(Call
                                          ("HaveDSPSupport",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MU(TP[Var("cond",F4),
                                                       bVar"v"],qTy),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       LW(15,
                                                                          4)),
                                                                    EQ(Var("Rn",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                EQ(Var("Rm",
                                                                       F4),
                                                                   LW(15,4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "Signed16x32Multiply32Result"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Multiply",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("Signed16x32Multiply32Result",
                                                                    CTy"Multiply",
                                                                    TP[EQ(Mop(Cast
                                                                                F1,
                                                                              LL[bVar"b'6"]),
                                                                          LW(1,
                                                                             1)),
                                                                       Var("Rd",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4),
                                                                       Var("Rm",
                                                                           F4)])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Mop(Not,bVar"b'4"))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("RdLo",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("RdHi",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         MB(Call
                                              ("HaveDSPSupport",
                                               ATy(qTy,PTy(bTy,qTy)),LU),
                                            Close
                                              (bVar"v",
                                               MB(MB(MU(TP[Var("cond",F4),
                                                           bVar"v"],qTy),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            EQ(Var("RdLo",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("RdHi",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rn",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Rm",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "Signed16Multiply64Accumulate"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Multiply",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("Signed16Multiply64Accumulate",
                                                                        CTy"Multiply",
                                                                        TP[EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'6"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'5"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           Var("RdHi",
                                                                               F4),
                                                                           Var("RdLo",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Var("Rm",
                                                                               F4)])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Mop(Not,bVar"b'4"))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("Rd",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(Call
                                          ("HaveDSPSupport",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MU(TP[Var("cond",F4),
                                                       bVar"v"],qTy),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       LW(15,
                                                                          4)),
                                                                    EQ(Var("Rn",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                EQ(Var("Rm",
                                                                       F4),
                                                                   LW(15,4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "Signed16Multiply32Result"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Multiply",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("Signed16Multiply32Result",
                                                                    CTy"Multiply",
                                                                    TP[EQ(Mop(Cast
                                                                                F1,
                                                                              LL[bVar"b'6"]),
                                                                          LW(1,
                                                                             1)),
                                                                       EQ(Mop(Cast
                                                                                F1,
                                                                              LL[bVar"b'5"]),
                                                                          LW(1,
                                                                             1)),
                                                                       Var("Rd",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4),
                                                                       Var("Rm",
                                                                           F4)])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,Mop(Not,bVar"b'19"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'18"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'17"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'16"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'15"),
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'14"),
                                                                     Bop(And,
                                                                         Mop(Not,
                                                                             bVar"b'13"),
                                                                         Bop(And,
                                                                             Mop(Not,
                                                                                 bVar"b'12"),
                                                                             Bop(And,
                                                                                 Mop(Not,
                                                                                     bVar"b'11"),
                                                                                 Bop(And,
                                                                                     Mop(Not,
                                                                                         bVar"b'10"),
                                                                                     Bop(And,
                                                                                         Mop(Not,
                                                                                             bVar"b'9"),
                                                                                         Bop(And,
                                                                                             Mop(Not,
                                                                                                 bVar"b'8"),
                                                                                             Bop(And,
                                                                                                 Mop(Not,
                                                                                                     bVar"b'7"),
                                                                                                 Bop(And,
                                                                                                     bVar"b'6",
                                                                                                     Bop(And,
                                                                                                         bVar"b'5",
                                                                                                         Bop(And,
                                                                                                             Mop(Not,
                                                                                                                 bVar"b'4"),
                                                                                                             Bop(And,
                                                                                                                 bVar"b'3",
                                                                                                                 Bop(And,
                                                                                                                     bVar"b'2",
                                                                                                                     Bop(And,
                                                                                                                         bVar"b'1",
                                                                                                                         Mop(Not,
                                                                                                                             bVar"b'0"))))))))))))))))))))))))),
                         MB(Call("HaveVirtExt",ATy(qTy,PTy(bTy,qTy)),LU),
                            Close
                              (bVar"v",
                               MB(MB(MU(TP[Var("cond",F4),bVar"v"],qTy),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Call
                                              ("System",CTy"instruction",
                                               Const
                                                 ("ExceptionReturn",
                                                  CTy"System")),qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'20"),
                                     Mop(Not,bVar"b'7")))),
                         MU(Call("Undefined",CTy"instruction",LW(0,32)),
                            qTy)),
                        (Mop(Not,bVar"b'4"),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rd",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     Let(Var("opc",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'24",bVar"b'23",
                                                bVar"b'22",bVar"b'21"]),
                                         MB(Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               TP[Var("cond",F4),LT]),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MU(Let(bVar"setflags",
                                                          EQ(Mop(Cast F1,
                                                                 LL[bVar"b'20"]),
                                                             LW(1,1)),
                                                          Let(TP[Var("shift_t",
                                                                     CTy"SRType"),
                                                                 nVar"shift_n"],
                                                              Call
                                                                ("DecodeImmShift",
                                                                 PTy(CTy"SRType",
                                                                     nTy),
                                                                 TP[Mop(Cast
                                                                          (FTy 2),
                                                                        LL[bVar"b'6",
                                                                           bVar"b'5"]),
                                                                    Mop(Cast
                                                                          (FTy 5),
                                                                        LL[bVar"b'11",
                                                                           bVar"b'10",
                                                                           bVar"b'9",
                                                                           bVar"b'8",
                                                                           bVar"b'7"])]),
                                                              ITB([(EQ(EX(Var("opc",
                                                                              F4),
                                                                          LN
                                                                           3,
                                                                          LN
                                                                           2,
                                                                          FTy 2),
                                                                       LW(2,
                                                                          2)),
                                                                    Call
                                                                      ("Data",
                                                                       CTy"instruction",
                                                                       Call
                                                                         ("TestCompareRegister",
                                                                          CTy"Data",
                                                                          TP[EX(Var("opc",
                                                                                    F4),
                                                                                LN
                                                                                 1,
                                                                                LN
                                                                                 0,
                                                                                FTy 2),
                                                                             Var("Rn",
                                                                                 F4),
                                                                             Var("Rm",
                                                                                 F4),
                                                                             Var("shift_t",
                                                                                 CTy"SRType"),
                                                                             nVar"shift_n"]))),
                                                                   (Bop(In,
                                                                        Var("opc",
                                                                            F4),
                                                                        SL[LW(13,
                                                                              4),
                                                                           LW(15,
                                                                              4)]),
                                                                    Call
                                                                      ("Data",
                                                                       CTy"instruction",
                                                                       Call
                                                                         ("ShiftImmediate",
                                                                          CTy"Data",
                                                                          TP[Bop(Bit,
                                                                                 Var("opc",
                                                                                     F4),
                                                                                 LN
                                                                                  1),
                                                                             bVar"setflags",
                                                                             Var("Rd",
                                                                                 F4),
                                                                             Var("Rm",
                                                                                 F4),
                                                                             Var("shift_t",
                                                                                 CTy"SRType"),
                                                                             nVar"shift_n"])))],
                                                                  Call
                                                                    ("Data",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("Register",
                                                                        CTy"Data",
                                                                        TP[Var("opc",
                                                                               F4),
                                                                           bVar"setflags",
                                                                           Var("Rd",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Var("Rm",
                                                                               F4),
                                                                           Var("shift_t",
                                                                               CTy"SRType"),
                                                                           nVar"shift_n"]))))),
                                                      qTy),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU))))))))),
                        (Bop(And,Mop(Not,bVar"b'7"),bVar"b'4"),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rs",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("Rd",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         Let(Var("opc",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'24",bVar"b'23",
                                                    bVar"b'22",bVar"b'21"]),
                                             MB(Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   TP[Var("cond",F4),LT]),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MB(ITE(Bop(Or,
                                                                  Bop(Or,
                                                                      Bop(Or,
                                                                          Bop(And,
                                                                              EQ(Var("Rd",
                                                                                     F4),
                                                                                 LW(15,
                                                                                    4)),
                                                                              Mop(Not,
                                                                                  EQ(EX(Var("opc",
                                                                                            F4),
                                                                                        LN
                                                                                         3,
                                                                                        LN
                                                                                         2,
                                                                                        FTy 2),
                                                                                     LW(2,
                                                                                        2)))),
                                                                          EQ(Var("Rn",
                                                                                 F4),
                                                                             LW(15,
                                                                                4))),
                                                                      EQ(Var("Rm",
                                                                             F4),
                                                                         LW(15,
                                                                            4))),
                                                                  EQ(Var("Rs",
                                                                         F4),
                                                                     LW(15,
                                                                        4))),
                                                              Call
                                                                ("DECODE_UNPREDICTABLE",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 TP[Var("mc",
                                                                        CTy"MachineCode"),
                                                                    LS
                                                                     "RegisterShiftedRegister"]),
                                                              MU(LU,qTy)),
                                                          Close
                                                            (AVar uTy,
                                                             MU(Let(bVar"setflags",
                                                                    EQ(Mop(Cast
                                                                             F1,
                                                                           LL[bVar"b'20"]),
                                                                       LW(1,
                                                                          1)),
                                                                    Let(Var("shift_t",
                                                                            CTy"SRType"),
                                                                        Call
                                                                          ("DecodeRegShift",
                                                                           CTy"SRType",
                                                                           Mop(Cast
                                                                                 (FTy 2),
                                                                               LL[bVar"b'6",
                                                                                  bVar"b'5"])),
                                                                        ITE(Bop(Or,
                                                                                EQ(Var("opc",
                                                                                       F4),
                                                                                   LW(13,
                                                                                      4)),
                                                                                EQ(Var("opc",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            Call
                                                                              ("Data",
                                                                               CTy"instruction",
                                                                               Call
                                                                                 ("ShiftRegister",
                                                                                  CTy"Data",
                                                                                  TP[Bop(Bit,
                                                                                         Var("opc",
                                                                                             F4),
                                                                                         LN
                                                                                          1),
                                                                                     bVar"setflags",
                                                                                     Var("Rd",
                                                                                         F4),
                                                                                     Var("Rm",
                                                                                         F4),
                                                                                     Var("shift_t",
                                                                                         CTy"SRType"),
                                                                                     Var("Rs",
                                                                                         F4)])),
                                                                            Call
                                                                              ("Data",
                                                                               CTy"instruction",
                                                                               Call
                                                                                 ("RegisterShiftedRegister",
                                                                                  CTy"Data",
                                                                                  TP[Var("opc",
                                                                                         F4),
                                                                                     bVar"setflags",
                                                                                     Var("Rd",
                                                                                         F4),
                                                                                     Var("Rn",
                                                                                         F4),
                                                                                     Var("Rm",
                                                                                         F4),
                                                                                     Var("shift_t",
                                                                                         CTy"SRType"),
                                                                                     Var("Rs",
                                                                                         F4)]))))),
                                                                qTy))),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU)))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'7",
                                         Bop(And,Mop(Not,bVar"b'6"),
                                             Bop(And,Mop(Not,bVar"b'5"),
                                                 bVar"b'4")))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("Ra",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("Rd",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         Let(Var("A",F1),
                                             Mop(Cast F1,LL[bVar"b'21"]),
                                             MB(Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   TP[Var("cond",F4),LT]),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MB(Call
                                                            ("ArchVersion",
                                                             ATy(qTy,
                                                                 PTy(nTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (nVar"v",
                                                             MB(MB(MB(MB(MU(Bop(Lt,
                                                                                nVar"v",
                                                                                LN
                                                                                 6),
                                                                            qTy),
                                                                         Close
                                                                           (bVar"b",
                                                                            MU(Bop(And,
                                                                                   bVar"b",
                                                                                   EQ(Var("Rd",
                                                                                          F4),
                                                                                      Var("Rn",
                                                                                          F4))),
                                                                               qTy))),
                                                                      Close
                                                                        (bVar"v",
                                                                         MU(Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        Bop(Or,
                                                                                            EQ(Var("Rd",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4)),
                                                                                            EQ(Var("Rn",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4))),
                                                                                        EQ(Var("Rm",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4))),
                                                                                    Bop(And,
                                                                                        EQ(Var("A",
                                                                                               F1),
                                                                                           LW(1,
                                                                                              1)),
                                                                                        EQ(Var("Ra",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4)))),
                                                                                bVar"v"),
                                                                            qTy))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "Multiply"]),
                                                                          MU(LU,
                                                                             qTy)))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Let(bVar"setflags",
                                                                          EQ(Mop(Cast
                                                                                   F1,
                                                                                 LL[bVar"b'20"]),
                                                                             LW(1,
                                                                                1)),
                                                                          ITE(EQ(Var("A",
                                                                                     F1),
                                                                                 LW(1,
                                                                                    1)),
                                                                              Call
                                                                                ("Multiply",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("MultiplyAccumulate",
                                                                                    CTy"Multiply",
                                                                                    TP[bVar"setflags",
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("Rm",
                                                                                           F4),
                                                                                       Var("Ra",
                                                                                           F4)])),
                                                                              Call
                                                                                ("Multiply",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("Multiply32",
                                                                                    CTy"Multiply",
                                                                                    TP[bVar"setflags",
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("Rm",
                                                                                           F4)])))),
                                                                      qTy))))),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU)))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("RdLo",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("RdHi",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MU(Bop(Ge,nVar"v",
                                                               LN 6),qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[Var("cond",
                                                                     F4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(Or,
                                                                                EQ(Var("RdHi",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("RdLo",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("RdHi",
                                                                           F4),
                                                                       Var("RdLo",
                                                                           F4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "MultiplyAccumulateAccumulate"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Multiply",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("MultiplyAccumulateAccumulate",
                                                                        CTy"Multiply",
                                                                        TP[Var("RdHi",
                                                                               F4),
                                                                           Var("RdLo",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Var("Rm",
                                                                               F4)])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("Ra",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("Rd",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         MB(Call
                                              ("HaveThumb2",
                                               ATy(qTy,PTy(bTy,qTy)),LU),
                                            Close
                                              (bVar"v",
                                               MB(MB(MU(TP[Var("cond",F4),
                                                           bVar"v"],qTy),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Ra",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "MultiplySubtract"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Multiply",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("MultiplySubtract",
                                                                        CTy"Multiply",
                                                                        TP[Var("Rd",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Var("Rm",
                                                                               F4),
                                                                           Var("Ra",
                                                                               F4)])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,bVar"b'23",
                                 Bop(And,bVar"b'7",
                                     Bop(And,Mop(Not,bVar"b'6"),
                                         Bop(And,Mop(Not,bVar"b'5"),
                                             bVar"b'4"))))),
                         Let(Var("Rn",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rm",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                        bVar"b'8"]),
                                 Let(Var("RdLo",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("RdHi",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         MB(Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               TP[Var("cond",F4),LT]),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MB(Call
                                                        ("ArchVersion",
                                                         ATy(qTy,
                                                             PTy(nTy,qTy)),
                                                         LU),
                                                      Close
                                                        (nVar"v",
                                                         MB(MB(MB(MB(MU(Bop(Lt,
                                                                            nVar"v",
                                                                            LN
                                                                             6),
                                                                        qTy),
                                                                     Close
                                                                       (bVar"b",
                                                                        MU(Bop(And,
                                                                               bVar"b",
                                                                               Bop(Or,
                                                                                   EQ(Var("RdHi",
                                                                                          F4),
                                                                                      Var("Rn",
                                                                                          F4)),
                                                                                   EQ(Var("RdLo",
                                                                                          F4),
                                                                                      Var("Rn",
                                                                                          F4)))),
                                                                           qTy))),
                                                                  Close
                                                                    (bVar"v",
                                                                     MU(Bop(Or,
                                                                            Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        Bop(Or,
                                                                                            EQ(Var("RdLo",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4)),
                                                                                            EQ(Var("RdHi",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4))),
                                                                                        EQ(Var("Rn",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4))),
                                                                                    EQ(Var("Rm",
                                                                                           F4),
                                                                                       LW(15,
                                                                                          4))),
                                                                                EQ(Var("RdHi",
                                                                                       F4),
                                                                                   Var("RdLo",
                                                                                       F4))),
                                                                            bVar"v"),
                                                                        qTy))),
                                                               Close
                                                                 (bVar"b",
                                                                  ITE(bVar"b",
                                                                      Call
                                                                        ("DECODE_UNPREDICTABLE",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[Var("mc",
                                                                                CTy"MachineCode"),
                                                                            LS
                                                                             "MultiplyLong"]),
                                                                      MU(LU,
                                                                         qTy)))),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Multiply",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("MultiplyLong",
                                                                        CTy"Multiply",
                                                                        TP[EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'21"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'22"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'20"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           Var("RdHi",
                                                                               F4),
                                                                           Var("RdLo",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Var("Rm",
                                                                               F4)])),
                                                                  qTy))))),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,Mop(Not,bVar"b'23"),
                                 Bop(And,Mop(Not,bVar"b'21"),
                                     Bop(And,Mop(Not,bVar"b'20"),
                                         Bop(And,bVar"b'7",
                                             Bop(And,Mop(Not,bVar"b'6"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'5"),
                                                     bVar"b'4"))))))),
                         Let(Var("Rt2",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rt",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           TP[Var("cond",F4),LT]),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(ITE(Bop(Or,
                                                          Bop(Or,
                                                              Bop(Or,
                                                                  Bop(Or,
                                                                      EQ(Var("Rt",
                                                                             F4),
                                                                         LW(15,
                                                                            4)),
                                                                      EQ(Var("Rt2",
                                                                             F4),
                                                                         LW(15,
                                                                            4))),
                                                                  EQ(Var("Rn",
                                                                         F4),
                                                                     LW(15,
                                                                        4))),
                                                              EQ(Var("Rn",
                                                                     F4),
                                                                 Var("Rt",
                                                                     F4))),
                                                          EQ(Var("Rn",F4),
                                                             Var("Rt2",F4))),
                                                      Call
                                                        ("DECODE_UNPREDICTABLE",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         TP[Var("mc",
                                                                CTy"MachineCode"),
                                                            LS"Swap"]),
                                                      MU(LU,qTy)),
                                                  Close
                                                    (AVar uTy,
                                                     MU(Call
                                                          ("Swap",
                                                           CTy"instruction",
                                                           TP[EQ(Mop(Cast
                                                                       F1,
                                                                     LL[bVar"b'22"]),
                                                                 LW(1,1)),
                                                              Var("Rt",F4),
                                                              Var("Rt2",F4),
                                                              Var("Rn",F4)]),
                                                        qTy))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rd",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(Call
                                          ("ArchVersion",
                                           ATy(qTy,PTy(nTy,qTy)),LU),
                                        Close
                                          (nVar"v",
                                           MB(MB(MB(MU(Bop(Ge,nVar"v",LN 6),
                                                       qTy),
                                                    Close
                                                      (bVar"v",
                                                       MU(TP[Var("cond",F4),
                                                             bVar"v"],qTy))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rt",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rn",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4))),
                                                                EQ(Var("Rd",
                                                                       F4),
                                                                   Var("Rt",
                                                                       F4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "StoreExclusive"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Store",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("StoreExclusive",
                                                                    CTy"Store",
                                                                    TP[Var("Rd",
                                                                           F4),
                                                                       Var("Rt",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4),
                                                                       LW(0,
                                                                          32)])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,bVar"b'20",
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(Call
                                      ("ArchVersion",
                                       ATy(qTy,PTy(nTy,qTy)),LU),
                                    Close
                                      (nVar"v",
                                       MB(MB(MB(MU(Bop(Ge,nVar"v",LN 6),
                                                   qTy),
                                                Close
                                                  (bVar"v",
                                                   MU(TP[Var("cond",F4),
                                                         bVar"v"],qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(Or,
                                                            EQ(Var("Rt",F4),
                                                               LW(15,4)),
                                                            EQ(Var("Rn",F4),
                                                               LW(15,4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "LoadExclusive"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Load",
                                                             CTy"instruction",
                                                             Call
                                                               ("LoadExclusive",
                                                                CTy"Load",
                                                                TP[Var("Rt",
                                                                       F4),
                                                                   Var("Rn",
                                                                       F4),
                                                                   LW(0,32)])),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rd",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("Architecture",
                                                 CTy"Architecture",qVar"s"))),
                                        Close
                                          (Var("v",CTy"Architecture"),
                                           MB(MB(MB(MU(Bop(In,
                                                           Var("v",
                                                               CTy"Architecture"),
                                                           SL[LC("ARMv6K",
                                                                 CTy"Architecture"),
                                                              LC("ARMv7_A",
                                                                 CTy"Architecture"),
                                                              LC("ARMv7_R",
                                                                 CTy"Architecture")]),
                                                       qTy),
                                                    Close
                                                      (bVar"v",
                                                       MU(TP[Var("cond",F4),
                                                             bVar"v"],qTy))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     Let(Var("Rt2",F4),
                                                         Bop(Add,
                                                             Var("Rt",F4),
                                                             LW(1,4)),
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        EQ(Var("Rd",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4)),
                                                                                        Bop(Bit,
                                                                                            Var("Rt",
                                                                                                F4),
                                                                                            LN
                                                                                             0)),
                                                                                    EQ(Var("Rt",
                                                                                           F4),
                                                                                       LW(14,
                                                                                          4))),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               Var("Rn",
                                                                                   F4))),
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           Var("Rt",
                                                                               F4))),
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       Var("Rt2",
                                                                           F4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "StoreExclusiveDoubleword"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Store",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("StoreExclusiveDoubleword",
                                                                        CTy"Store",
                                                                        TP[Var("Rd",
                                                                               F4),
                                                                           Var("Rt",
                                                                               F4),
                                                                           Var("Rt2",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4)])),
                                                                  qTy)))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Bop(And,bVar"b'21",
                                         Bop(And,bVar"b'20",
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest
                                            ("Architecture",
                                             CTy"Architecture",qVar"s"))),
                                    Close
                                      (Var("v",CTy"Architecture"),
                                       MB(MB(MB(MU(Bop(In,
                                                       Var("v",
                                                           CTy"Architecture"),
                                                       SL[LC("ARMv6K",
                                                             CTy"Architecture"),
                                                          LC("ARMv7_A",
                                                             CTy"Architecture"),
                                                          LC("ARMv7_R",
                                                             CTy"Architecture")]),
                                                   qTy),
                                                Close
                                                  (bVar"v",
                                                   MU(TP[Var("cond",F4),
                                                         bVar"v"],qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(Or,
                                                            Bop(Or,
                                                                Bop(Bit,
                                                                    Var("Rt",
                                                                        F4),
                                                                    LN 0),
                                                                EQ(Var("Rt",
                                                                       F4),
                                                                   LW(14,4))),
                                                            EQ(Var("Rn",F4),
                                                               LW(15,4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "LoadExclusiveDoubleword"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Load",
                                                             CTy"instruction",
                                                             Call
                                                               ("LoadExclusiveDoubleword",
                                                                CTy"Load",
                                                                TP[Var("Rt",
                                                                       F4),
                                                                   Bop(Add,
                                                                       Var("Rt",
                                                                           F4),
                                                                       LW(1,
                                                                          4)),
                                                                   Var("Rn",
                                                                       F4)])),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,bVar"b'22",
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rd",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("Architecture",
                                                 CTy"Architecture",qVar"s"))),
                                        Close
                                          (Var("v",CTy"Architecture"),
                                           MB(MB(MB(MU(Bop(In,
                                                           Var("v",
                                                               CTy"Architecture"),
                                                           SL[LC("ARMv6K",
                                                                 CTy"Architecture"),
                                                              LC("ARMv7_A",
                                                                 CTy"Architecture"),
                                                              LC("ARMv7_R",
                                                                 CTy"Architecture")]),
                                                       qTy),
                                                    Close
                                                      (bVar"v",
                                                       MU(TP[Var("cond",F4),
                                                             bVar"v"],qTy))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rt",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rn",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4))),
                                                                EQ(Var("Rd",
                                                                       F4),
                                                                   Var("Rt",
                                                                       F4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "StoreExclusiveByte"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Store",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("StoreExclusiveByte",
                                                                    CTy"Store",
                                                                    TP[Var("Rd",
                                                                           F4),
                                                                       Var("Rt",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4)])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,bVar"b'22",
                                     Bop(And,Mop(Not,bVar"b'21"),
                                         Bop(And,bVar"b'20",
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest
                                            ("Architecture",
                                             CTy"Architecture",qVar"s"))),
                                    Close
                                      (Var("v",CTy"Architecture"),
                                       MB(MB(MB(MU(Bop(In,
                                                       Var("v",
                                                           CTy"Architecture"),
                                                       SL[LC("ARMv6K",
                                                             CTy"Architecture"),
                                                          LC("ARMv7_A",
                                                             CTy"Architecture"),
                                                          LC("ARMv7_R",
                                                             CTy"Architecture")]),
                                                   qTy),
                                                Close
                                                  (bVar"v",
                                                   MU(TP[Var("cond",F4),
                                                         bVar"v"],qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(Or,
                                                            EQ(Var("Rt",F4),
                                                               LW(15,4)),
                                                            EQ(Var("Rn",F4),
                                                               LW(15,4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "LoadExclusiveByte"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Load",
                                                             CTy"instruction",
                                                             Call
                                                               ("LoadExclusiveByte",
                                                                CTy"Load",
                                                                TP[Var("Rt",
                                                                       F4),
                                                                   Var("Rn",
                                                                       F4)])),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'21",
                                         Bop(And,Mop(Not,bVar"b'20"),
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rd",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(MR(Close
                                             (qVar"s",
                                              Dest
                                                ("Architecture",
                                                 CTy"Architecture",qVar"s"))),
                                        Close
                                          (Var("v",CTy"Architecture"),
                                           MB(MB(MB(MU(Bop(In,
                                                           Var("v",
                                                               CTy"Architecture"),
                                                           SL[LC("ARMv6K",
                                                                 CTy"Architecture"),
                                                              LC("ARMv7_A",
                                                                 CTy"Architecture"),
                                                              LC("ARMv7_R",
                                                                 CTy"Architecture")]),
                                                       qTy),
                                                    Close
                                                      (bVar"v",
                                                       MU(TP[Var("cond",F4),
                                                             bVar"v"],qTy))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4)),
                                                                            EQ(Var("Rt",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rn",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4))),
                                                                EQ(Var("Rd",
                                                                       F4),
                                                                   Var("Rt",
                                                                       F4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "StoreExclusiveHalf"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Store",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("StoreExclusiveHalf",
                                                                    CTy"Store",
                                                                    TP[Var("Rd",
                                                                           F4),
                                                                       Var("Rt",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4)])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,bVar"b'24",
                             Bop(And,bVar"b'23",
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'21",
                                         Bop(And,bVar"b'20",
                                             Bop(And,bVar"b'7",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'6"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'5"),
                                                         bVar"b'4")))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest
                                            ("Architecture",
                                             CTy"Architecture",qVar"s"))),
                                    Close
                                      (Var("v",CTy"Architecture"),
                                       MB(MB(MB(MU(Bop(In,
                                                       Var("v",
                                                           CTy"Architecture"),
                                                       SL[LC("ARMv6K",
                                                             CTy"Architecture"),
                                                          LC("ARMv7_A",
                                                             CTy"Architecture"),
                                                          LC("ARMv7_R",
                                                             CTy"Architecture")]),
                                                   qTy),
                                                Close
                                                  (bVar"v",
                                                   MU(TP[Var("cond",F4),
                                                         bVar"v"],qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(Or,
                                                            EQ(Var("Rt",F4),
                                                               LW(15,4)),
                                                            EQ(Var("Rn",F4),
                                                               LW(15,4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "LoadExclusiveHalf"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Load",
                                                             CTy"instruction",
                                                             Call
                                                               ("LoadExclusiveHalf",
                                                                CTy"Load",
                                                                TP[Var("Rt",
                                                                       F4),
                                                                   Var("Rn",
                                                                       F4)])),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,Mop(Not,bVar"b'22"),
                                 Bop(And,bVar"b'21",
                                     Bop(And,Mop(Not,bVar"b'20"),
                                         Bop(And,bVar"b'7",
                                             Bop(And,Mop(Not,bVar"b'6"),
                                                 Bop(And,bVar"b'5",
                                                     bVar"b'4"))))))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rt",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     MB(Call
                                          ("HaveThumb2",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MU(TP[Var("cond",F4),
                                                       bVar"v"],qTy),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(Or,
                                                                    Bop(Or,
                                                                        EQ(Var("Rt",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rn",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Rn",
                                                                           F4),
                                                                       Var("Rt",
                                                                           F4))),
                                                                EQ(Var("Rm",
                                                                       F4),
                                                                   LW(15,4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "StoreHalfUnprivileged"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Store",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("StoreHalfUnprivileged",
                                                                    CTy"Store",
                                                                    TP[EQ(Mop(Cast
                                                                                F1,
                                                                              LL[bVar"b'23"]),
                                                                          LW(1,
                                                                             1)),
                                                                       LT,
                                                                       Var("Rt",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4),
                                                                       Call
                                                                         ("register_form2",
                                                                          CTy"offset2",
                                                                          Var("Rm",
                                                                              F4))])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU)))))))))),
                        (Bop(And,Mop(Not,bVar"b'22"),
                             Bop(And,Mop(Not,bVar"b'20"),
                                 Bop(And,bVar"b'7",
                                     Bop(And,Mop(Not,bVar"b'6"),
                                         Bop(And,bVar"b'5",bVar"b'4"))))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rt",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     Let(Var("P",F1),
                                         Mop(Cast F1,LL[bVar"b'24"]),
                                         MB(Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               TP[Var("cond",F4),LT]),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   Let(bVar"wback",
                                                       Bop(Or,
                                                           EQ(Var("P",F1),
                                                              LW(0,1)),
                                                           EQ(Mop(Cast F1,
                                                                  LL[bVar"b'21"]),
                                                              LW(1,1))),
                                                       MB(Call
                                                            ("ArchVersion",
                                                             ATy(qTy,
                                                                 PTy(nTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (nVar"v",
                                                             MB(MB(MB(MB(MB(MU(Bop(Lt,
                                                                                   nVar"v",
                                                                                   LN
                                                                                    6),
                                                                               qTy),
                                                                            Close
                                                                              (bVar"b",
                                                                               MU(Bop(And,
                                                                                      bVar"b",
                                                                                      bVar"wback"),
                                                                                  qTy))),
                                                                         Close
                                                                           (bVar"b",
                                                                            MU(Bop(And,
                                                                                   bVar"b",
                                                                                   EQ(Var("Rm",
                                                                                          F4),
                                                                                      Var("Rn",
                                                                                          F4))),
                                                                               qTy))),
                                                                      Close
                                                                        (bVar"v",
                                                                         MU(Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        EQ(Var("Rt",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4)),
                                                                                        EQ(Var("Rm",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4))),
                                                                                    Bop(And,
                                                                                        bVar"wback",
                                                                                        Bop(Or,
                                                                                            EQ(Var("Rn",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4)),
                                                                                            EQ(Var("Rn",
                                                                                                   F4),
                                                                                               Var("Rt",
                                                                                                   F4))))),
                                                                                bVar"v"),
                                                                            qTy))),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "StoreHalf"]),
                                                                          MU(LU,
                                                                             qTy)))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Store",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("StoreHalf",
                                                                            CTy"Store",
                                                                            TP[EQ(Mop(Cast
                                                                                        F1,
                                                                                      LL[bVar"b'23"]),
                                                                                  LW(1,
                                                                                     1)),
                                                                               EQ(Var("P",
                                                                                      F1),
                                                                                  LW(1,
                                                                                     1)),
                                                                               bVar"wback",
                                                                               Var("Rt",
                                                                                   F4),
                                                                               Var("Rn",
                                                                                   F4),
                                                                               Call
                                                                                 ("register_form1",
                                                                                  CTy"offset1",
                                                                                  TP[Var("Rm",
                                                                                         F4),
                                                                                     LC("SRType_LSL",
                                                                                        CTy"SRType"),
                                                                                     LN
                                                                                      0])])),
                                                                      qTy)))))),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,Mop(Not,bVar"b'22"),
                                 Bop(And,bVar"b'21",
                                     Bop(And,bVar"b'20",
                                         Bop(And,bVar"b'7",bVar"b'4"))))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("H",F1),Mop(Cast F1,LL[bVar"b'5"]),
                                 Let(Var("S",F1),
                                     Mop(Cast F1,LL[bVar"b'6"]),
                                     Let(Var("Rt",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'15",bVar"b'14",
                                                bVar"b'13",bVar"b'12"]),
                                         Let(Var("Rn",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'19",bVar"b'18",
                                                    bVar"b'17",bVar"b'16"]),
                                             MB(Call
                                                  ("HaveThumb2",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(MB(MU(Bop(And,
                                                                   Bop(Or,
                                                                       Mop(Not,
                                                                           EQ(Var("H",
                                                                                  F1),
                                                                              LW(0,
                                                                                 1))),
                                                                       EQ(Var("S",
                                                                              F1),
                                                                          LW(1,
                                                                             1))),
                                                                   bVar"v"),
                                                               qTy),
                                                            Close
                                                              (bVar"v",
                                                               MU(TP[Var("cond",
                                                                         F4),
                                                                     bVar"v"],
                                                                  qTy))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(Or,
                                                                                EQ(Var("Rt",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               Var("Rt",
                                                                                   F4))),
                                                                        EQ(Var("Rm",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "LoadHalf/Byte (unprivileged)"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Let(bVar"add",
                                                                          EQ(Mop(Cast
                                                                                   F1,
                                                                                 LL[bVar"b'23"]),
                                                                             LW(1,
                                                                                1)),
                                                                          Let(bVar"postindex",
                                                                              LT,
                                                                              Let(Var("m",
                                                                                      CTy"offset2"),
                                                                                  Call
                                                                                    ("register_form2",
                                                                                     CTy"offset2",
                                                                                     Var("Rm",
                                                                                         F4)),
                                                                                  ITE(EQ(Var("H",
                                                                                             F1),
                                                                                         LW(1,
                                                                                            1)),
                                                                                      Call
                                                                                        ("Load",
                                                                                         CTy"instruction",
                                                                                         Call
                                                                                           ("LoadHalfUnprivileged",
                                                                                            CTy"Load",
                                                                                            TP[EQ(Var("S",
                                                                                                      F1),
                                                                                                  LW(0,
                                                                                                     1)),
                                                                                               bVar"add",
                                                                                               bVar"postindex",
                                                                                               Var("Rt",
                                                                                                   F4),
                                                                                               Var("Rn",
                                                                                                   F4),
                                                                                               Var("m",
                                                                                                   CTy"offset2")])),
                                                                                      Call
                                                                                        ("Load",
                                                                                         CTy"instruction",
                                                                                         Call
                                                                                           ("LoadSignedByteUnprivileged",
                                                                                            CTy"Load",
                                                                                            TP[bVar"add",
                                                                                               bVar"postindex",
                                                                                               Var("Rt",
                                                                                                   F4),
                                                                                               Var("Rn",
                                                                                                   F4),
                                                                                               Var("m",
                                                                                                   CTy"offset2")])))))),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU)))))))))))),
                        (Bop(And,Mop(Not,bVar"b'22"),
                             Bop(And,bVar"b'20",
                                 Bop(And,bVar"b'7",bVar"b'4"))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("H",F1),Mop(Cast F1,LL[bVar"b'5"]),
                                 Let(Var("S",F1),
                                     Mop(Cast F1,LL[bVar"b'6"]),
                                     Let(Var("Rt",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'15",bVar"b'14",
                                                bVar"b'13",bVar"b'12"]),
                                         Let(Var("Rn",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'19",bVar"b'18",
                                                    bVar"b'17",bVar"b'16"]),
                                             Let(Var("P",F1),
                                                 Mop(Cast F1,
                                                     LL[bVar"b'24"]),
                                                 MB(Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       TP[Var("cond",F4),
                                                          Bop(Or,
                                                              Mop(Not,
                                                                  EQ(Var("H",
                                                                         F1),
                                                                     LW(0,
                                                                        1))),
                                                              EQ(Var("S",
                                                                     F1),
                                                                 LW(1,1)))]),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           Let(bVar"wback",
                                                               Bop(Or,
                                                                   EQ(Var("P",
                                                                          F1),
                                                                      LW(0,
                                                                         1)),
                                                                   EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'21"]),
                                                                      LW(1,
                                                                         1))),
                                                               MB(Call
                                                                    ("ArchVersion",
                                                                     ATy(qTy,
                                                                         PTy(nTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (nVar"v",
                                                                     MB(MB(MB(MB(MB(MU(Bop(Lt,
                                                                                           nVar"v",
                                                                                           LN
                                                                                            6),
                                                                                       qTy),
                                                                                    Close
                                                                                      (bVar"b",
                                                                                       MU(Bop(And,
                                                                                              bVar"b",
                                                                                              bVar"wback"),
                                                                                          qTy))),
                                                                                 Close
                                                                                   (bVar"b",
                                                                                    MU(Bop(And,
                                                                                           bVar"b",
                                                                                           EQ(Var("Rm",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4))),
                                                                                       qTy))),
                                                                              Close
                                                                                (bVar"v",
                                                                                 MU(Bop(Or,
                                                                                        Bop(Or,
                                                                                            EQ(Var("Rt",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4)),
                                                                                            EQ(Var("Rm",
                                                                                                   F4),
                                                                                               LW(15,
                                                                                                  4))),
                                                                                        bVar"v"),
                                                                                    qTy))),
                                                                           Close
                                                                             (bVar"b",
                                                                              ITE(bVar"b",
                                                                                  Call
                                                                                    ("DECODE_UNPREDICTABLE",
                                                                                     ATy(qTy,
                                                                                         PTy(uTy,
                                                                                             qTy)),
                                                                                     TP[Var("mc",
                                                                                            CTy"MachineCode"),
                                                                                        LS
                                                                                         "LoadHalf/Byte"]),
                                                                                  MU(LU,
                                                                                     qTy)))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Let(bVar"index",
                                                                                  EQ(Var("P",
                                                                                         F1),
                                                                                     LW(1,
                                                                                        1)),
                                                                                  Let(bVar"add",
                                                                                      EQ(Mop(Cast
                                                                                               F1,
                                                                                             LL[bVar"b'23"]),
                                                                                         LW(1,
                                                                                            1)),
                                                                                      Let(bVar"unsigned",
                                                                                          EQ(Var("S",
                                                                                                 F1),
                                                                                             LW(0,
                                                                                                1)),
                                                                                          Let(Var("m",
                                                                                                  CTy"offset1"),
                                                                                              Call
                                                                                                ("register_form1",
                                                                                                 CTy"offset1",
                                                                                                 TP[Var("Rm",
                                                                                                        F4),
                                                                                                    LC("SRType_LSL",
                                                                                                       CTy"SRType"),
                                                                                                    LN
                                                                                                     0]),
                                                                                              ITE(EQ(Var("H",
                                                                                                         F1),
                                                                                                     LW(1,
                                                                                                        1)),
                                                                                                  Call
                                                                                                    ("Load",
                                                                                                     CTy"instruction",
                                                                                                     Call
                                                                                                       ("LoadHalf",
                                                                                                        CTy"Load",
                                                                                                        TP[bVar"unsigned",
                                                                                                           bVar"add",
                                                                                                           bVar"index",
                                                                                                           bVar"wback",
                                                                                                           Var("Rt",
                                                                                                               F4),
                                                                                                           Var("Rn",
                                                                                                               F4),
                                                                                                           Var("m",
                                                                                                               CTy"offset1")])),
                                                                                                  Call
                                                                                                    ("Load",
                                                                                                     CTy"instruction",
                                                                                                     Call
                                                                                                       ("LoadByte",
                                                                                                        CTy"Load",
                                                                                                        TP[bVar"unsigned",
                                                                                                           bVar"add",
                                                                                                           bVar"index",
                                                                                                           bVar"wback",
                                                                                                           Var("Rt",
                                                                                                               F4),
                                                                                                           Var("Rn",
                                                                                                               F4),
                                                                                                           Var("m",
                                                                                                               CTy"offset1")]))))))),
                                                                              qTy)))))),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU))))))))))),
                        (Bop(And,Mop(Not,bVar"b'22"),
                             Bop(And,Mop(Not,bVar"b'20"),
                                 Bop(And,bVar"b'7",
                                     Bop(And,bVar"b'6",bVar"b'4")))),
                         Let(Var("Rm",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                    bVar"b'0"]),
                             Let(Var("Rt",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     Let(Var("W",F1),
                                         Mop(Cast F1,LL[bVar"b'21"]),
                                         Let(Var("P",F1),
                                             Mop(Cast F1,LL[bVar"b'24"]),
                                             MB(Call
                                                  ("HaveDSPSupport",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(MU(TP[Var("cond",
                                                                   F4),
                                                               bVar"v"],
                                                            qTy),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             Let(Var("Rt2",
                                                                     F4),
                                                                 Bop(Add,
                                                                     Var("Rt",
                                                                         F4),
                                                                     LW(1,
                                                                        4)),
                                                                 Let(bVar"wback",
                                                                     Bop(Or,
                                                                         EQ(Var("P",
                                                                                F1),
                                                                            LW(0,
                                                                               1)),
                                                                         EQ(Var("W",
                                                                                F1),
                                                                            LW(1,
                                                                               1))),
                                                                     MB(Call
                                                                          ("ArchVersion",
                                                                           ATy(qTy,
                                                                               PTy(nTy,
                                                                                   qTy)),
                                                                           LU),
                                                                        Close
                                                                          (nVar"v",
                                                                           MB(MB(MB(MB(MB(MU(Bop(Lt,
                                                                                                 nVar"v",
                                                                                                 LN
                                                                                                  6),
                                                                                             qTy),
                                                                                          Close
                                                                                            (bVar"b",
                                                                                             MU(Bop(And,
                                                                                                    bVar"b",
                                                                                                    bVar"wback"),
                                                                                                qTy))),
                                                                                       Close
                                                                                         (bVar"b",
                                                                                          MU(Bop(And,
                                                                                                 bVar"b",
                                                                                                 EQ(Var("Rm",
                                                                                                        F4),
                                                                                                    Var("Rn",
                                                                                                        F4))),
                                                                                             qTy))),
                                                                                    Close
                                                                                      (bVar"v",
                                                                                       MU(Bop(Or,
                                                                                              Bop(Or,
                                                                                                  Bop(Or,
                                                                                                      Bop(Or,
                                                                                                          Bop(Or,
                                                                                                              Bop(Or,
                                                                                                                  Bop(Or,
                                                                                                                      Bop(Bit,
                                                                                                                          Var("Rt",
                                                                                                                              F4),
                                                                                                                          LN
                                                                                                                           0),
                                                                                                                      Bop(And,
                                                                                                                          EQ(Var("P",
                                                                                                                                 F1),
                                                                                                                             LW(0,
                                                                                                                                1)),
                                                                                                                          EQ(Var("W",
                                                                                                                                 F1),
                                                                                                                             LW(1,
                                                                                                                                1)))),
                                                                                                                  EQ(Var("Rt2",
                                                                                                                         F4),
                                                                                                                     LW(15,
                                                                                                                        4))),
                                                                                                              EQ(Var("Rm",
                                                                                                                     F4),
                                                                                                                 LW(15,
                                                                                                                    4))),
                                                                                                          EQ(Var("Rm",
                                                                                                                 F4),
                                                                                                             Var("Rt",
                                                                                                                 F4))),
                                                                                                      EQ(Var("Rm",
                                                                                                             F4),
                                                                                                         Var("Rt2",
                                                                                                             F4))),
                                                                                                  Bop(And,
                                                                                                      bVar"wback",
                                                                                                      Bop(Or,
                                                                                                          Bop(Or,
                                                                                                              EQ(Var("Rn",
                                                                                                                     F4),
                                                                                                                 LW(15,
                                                                                                                    4)),
                                                                                                              EQ(Var("Rn",
                                                                                                                     F4),
                                                                                                                 Var("Rt",
                                                                                                                     F4))),
                                                                                                          EQ(Var("Rn",
                                                                                                                 F4),
                                                                                                             Var("Rt2",
                                                                                                                 F4))))),
                                                                                              bVar"v"),
                                                                                          qTy))),
                                                                                 Close
                                                                                   (bVar"b",
                                                                                    ITE(bVar"b",
                                                                                        Call
                                                                                          ("DECODE_UNPREDICTABLE",
                                                                                           ATy(qTy,
                                                                                               PTy(uTy,
                                                                                                   qTy)),
                                                                                           TP[Var("mc",
                                                                                                  CTy"MachineCode"),
                                                                                              LS
                                                                                               "Load/StoreDual (register)"]),
                                                                                        MU(LU,
                                                                                           qTy)))),
                                                                              Close
                                                                                (AVar
                                                                                   uTy,
                                                                                 MU(Let(bVar"index",
                                                                                        EQ(Var("P",
                                                                                               F1),
                                                                                           LW(1,
                                                                                              1)),
                                                                                        Let(bVar"add",
                                                                                            EQ(Mop(Cast
                                                                                                     F1,
                                                                                                   LL[bVar"b'23"]),
                                                                                               LW(1,
                                                                                                  1)),
                                                                                            Let(Var("m",
                                                                                                    CTy"offset2"),
                                                                                                Call
                                                                                                  ("register_form2",
                                                                                                   CTy"offset2",
                                                                                                   Var("Rm",
                                                                                                       F4)),
                                                                                                ITE(EQ(Mop(Cast
                                                                                                             F1,
                                                                                                           LL[bVar"b'5"]),
                                                                                                       LW(1,
                                                                                                          1)),
                                                                                                    Call
                                                                                                      ("Store",
                                                                                                       CTy"instruction",
                                                                                                       Call
                                                                                                         ("StoreDual",
                                                                                                          CTy"Store",
                                                                                                          TP[bVar"add",
                                                                                                             bVar"index",
                                                                                                             bVar"wback",
                                                                                                             Var("Rt",
                                                                                                                 F4),
                                                                                                             Var("Rt2",
                                                                                                                 F4),
                                                                                                             Var("Rn",
                                                                                                                 F4),
                                                                                                             Var("m",
                                                                                                                 CTy"offset2")])),
                                                                                                    Call
                                                                                                      ("Load",
                                                                                                       CTy"instruction",
                                                                                                       Call
                                                                                                         ("LoadDual",
                                                                                                          CTy"Load",
                                                                                                          TP[bVar"add",
                                                                                                             bVar"index",
                                                                                                             bVar"wback",
                                                                                                             Var("Rt",
                                                                                                                 F4),
                                                                                                             Var("Rt2",
                                                                                                                 F4),
                                                                                                             Var("Rn",
                                                                                                                 F4),
                                                                                                             Var("m",
                                                                                                                 CTy"offset2")])))))),
                                                                                    qTy))))))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU)))))))))))),
                        (Bop(And,bVar"b'22",
                             Bop(And,Mop(Not,bVar"b'20"),
                                 Bop(And,bVar"b'19",
                                     Bop(And,bVar"b'18",
                                         Bop(And,bVar"b'17",
                                             Bop(And,bVar"b'16",
                                                 Bop(And,bVar"b'7",
                                                     Bop(And,bVar"b'6",
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'5"),
                                                             bVar"b'4"))))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             MB(Call
                                  ("HaveDSPSupport",ATy(qTy,PTy(bTy,qTy)),
                                   LU),
                                Close
                                  (bVar"v",
                                   MB(MB(MU(TP[Var("cond",F4),bVar"v"],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Let(Var("Rt2",F4),
                                                 Bop(Add,Var("Rt",F4),
                                                     LW(1,4)),
                                                 MB(ITE(Bop(Or,
                                                            Bop(Bit,
                                                                Var("Rt",
                                                                    F4),
                                                                LN 0),
                                                            EQ(Var("Rt2",
                                                                   F4),
                                                               LW(15,4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "LoadDual (literal)"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Load",
                                                             CTy"instruction",
                                                             Call
                                                               ("LoadDualLiteral",
                                                                CTy"Load",
                                                                TP[EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'23"]),
                                                                      LW(1,
                                                                         1)),
                                                                   Var("Rt",
                                                                       F4),
                                                                   Var("Rt2",
                                                                       F4),
                                                                   Mop(Cast
                                                                         F32,
                                                                       CC[Mop(Cast
                                                                                F4,
                                                                              LL[bVar"b'11",
                                                                                 bVar"b'10",
                                                                                 bVar"b'9",
                                                                                 bVar"b'8"]),
                                                                          Mop(Cast
                                                                                F4,
                                                                              LL[bVar"b'3",
                                                                                 bVar"b'2",
                                                                                 bVar"b'1",
                                                                                 bVar"b'0"])])])),
                                                          qTy)))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))))),
                        (Bop(And,bVar"b'22",
                             Bop(And,Mop(Not,bVar"b'20"),
                                 Bop(And,bVar"b'7",
                                     Bop(And,bVar"b'6",bVar"b'4")))),
                         Let(Var("S",F1),Mop(Cast F1,LL[bVar"b'5"]),
                             Let(Var("Rt",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                        bVar"b'12"]),
                                 Let(Var("Rn",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'19",bVar"b'18",
                                            bVar"b'17",bVar"b'16"]),
                                     Let(Var("W",F1),
                                         Mop(Cast F1,LL[bVar"b'21"]),
                                         Let(Var("P",F1),
                                             Mop(Cast F1,LL[bVar"b'24"]),
                                             MB(Call
                                                  ("HaveDSPSupport",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(MU(TP[Var("cond",
                                                                   F4),
                                                               bVar"v"],
                                                            qTy),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             Let(Var("Rt2",
                                                                     F4),
                                                                 Bop(Add,
                                                                     Var("Rt",
                                                                         F4),
                                                                     LW(1,
                                                                        4)),
                                                                 Let(bVar"wback",
                                                                     Bop(Or,
                                                                         EQ(Var("P",
                                                                                F1),
                                                                            LW(0,
                                                                               1)),
                                                                         EQ(Var("W",
                                                                                F1),
                                                                            LW(1,
                                                                               1))),
                                                                     MB(ITE(Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        Bop(Bit,
                                                                                            Var("Rt",
                                                                                                F4),
                                                                                            LN
                                                                                             0),
                                                                                        Bop(And,
                                                                                            EQ(Var("P",
                                                                                                   F1),
                                                                                               LW(0,
                                                                                                  1)),
                                                                                            EQ(Var("W",
                                                                                                   F1),
                                                                                               LW(1,
                                                                                                  1)))),
                                                                                    Bop(And,
                                                                                        bVar"wback",
                                                                                        Bop(Or,
                                                                                            Bop(Or,
                                                                                                Bop(And,
                                                                                                    EQ(Var("S",
                                                                                                           F1),
                                                                                                       LW(1,
                                                                                                          1)),
                                                                                                    EQ(Var("Rn",
                                                                                                           F4),
                                                                                                       LW(15,
                                                                                                          4))),
                                                                                                EQ(Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rt",
                                                                                                       F4))),
                                                                                            EQ(Var("Rn",
                                                                                                   F4),
                                                                                               Var("Rt2",
                                                                                                   F4))))),
                                                                                EQ(Var("Rt2",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "Load/StoreDual (immediate)"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Let(bVar"index",
                                                                                  EQ(Var("P",
                                                                                         F1),
                                                                                     LW(1,
                                                                                        1)),
                                                                                  Let(bVar"add",
                                                                                      EQ(Mop(Cast
                                                                                               F1,
                                                                                             LL[bVar"b'23"]),
                                                                                         LW(1,
                                                                                            1)),
                                                                                      Let(Var("m",
                                                                                              CTy"offset2"),
                                                                                          Call
                                                                                            ("immediate_form2",
                                                                                             CTy"offset2",
                                                                                             Mop(Cast
                                                                                                   F32,
                                                                                                 CC[Mop(Cast
                                                                                                          F4,
                                                                                                        LL[bVar"b'11",
                                                                                                           bVar"b'10",
                                                                                                           bVar"b'9",
                                                                                                           bVar"b'8"]),
                                                                                                    Mop(Cast
                                                                                                          F4,
                                                                                                        LL[bVar"b'3",
                                                                                                           bVar"b'2",
                                                                                                           bVar"b'1",
                                                                                                           bVar"b'0"])])),
                                                                                          ITE(EQ(Var("S",
                                                                                                     F1),
                                                                                                 LW(1,
                                                                                                    1)),
                                                                                              Call
                                                                                                ("Store",
                                                                                                 CTy"instruction",
                                                                                                 Call
                                                                                                   ("StoreDual",
                                                                                                    CTy"Store",
                                                                                                    TP[bVar"add",
                                                                                                       bVar"index",
                                                                                                       bVar"wback",
                                                                                                       Var("Rt",
                                                                                                           F4),
                                                                                                       Var("Rt2",
                                                                                                           F4),
                                                                                                       Var("Rn",
                                                                                                           F4),
                                                                                                       Var("m",
                                                                                                           CTy"offset2")])),
                                                                                              Call
                                                                                                ("Load",
                                                                                                 CTy"instruction",
                                                                                                 Call
                                                                                                   ("LoadDual",
                                                                                                    CTy"Load",
                                                                                                    TP[bVar"add",
                                                                                                       bVar"index",
                                                                                                       bVar"wback",
                                                                                                       Var("Rt",
                                                                                                           F4),
                                                                                                       Var("Rt2",
                                                                                                           F4),
                                                                                                       Var("Rn",
                                                                                                           F4),
                                                                                                       Var("m",
                                                                                                           CTy"offset2")])))))),
                                                                              qTy))))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU)))))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,bVar"b'22",
                                 Bop(And,bVar"b'21",
                                     Bop(And,bVar"b'20",
                                         Bop(And,bVar"b'7",bVar"b'4"))))),
                         Let(Var("H",F1),Mop(Cast F1,LL[bVar"b'5"]),
                             Let(Var("S",F1),Mop(Cast F1,LL[bVar"b'6"]),
                                 Let(Var("Rt",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         MB(Call
                                              ("HaveThumb2",
                                               ATy(qTy,PTy(bTy,qTy)),LU),
                                            Close
                                              (bVar"v",
                                               MB(MB(MB(MU(Bop(And,
                                                               Bop(Or,
                                                                   Mop(Not,
                                                                       EQ(Var("H",
                                                                              F1),
                                                                          LW(0,
                                                                             1))),
                                                                   EQ(Var("S",
                                                                          F1),
                                                                      LW(1,
                                                                         1))),
                                                               bVar"v"),
                                                           qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[Var("cond",
                                                                     F4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        EQ(Var("Rt",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        EQ(Var("Rn",
                                                                               F4),
                                                                           LW(15,
                                                                              4))),
                                                                    EQ(Var("Rn",
                                                                           F4),
                                                                       Var("Rt",
                                                                           F4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "LoadHalf/Byte (unprivileged)"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Let(bVar"postindex",
                                                                      LT,
                                                                      Let(bVar"add",
                                                                          EQ(Mop(Cast
                                                                                   F1,
                                                                                 LL[bVar"b'23"]),
                                                                             LW(1,
                                                                                1)),
                                                                          Let(Var("m",
                                                                                  CTy"offset2"),
                                                                              Call
                                                                                ("immediate_form2",
                                                                                 CTy"offset2",
                                                                                 Mop(Cast
                                                                                       F32,
                                                                                     CC[Mop(Cast
                                                                                              F4,
                                                                                            LL[bVar"b'11",
                                                                                               bVar"b'10",
                                                                                               bVar"b'9",
                                                                                               bVar"b'8"]),
                                                                                        Mop(Cast
                                                                                              F4,
                                                                                            LL[bVar"b'3",
                                                                                               bVar"b'2",
                                                                                               bVar"b'1",
                                                                                               bVar"b'0"])])),
                                                                              ITE(EQ(Var("H",
                                                                                         F1),
                                                                                     LW(1,
                                                                                        1)),
                                                                                  Call
                                                                                    ("Load",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("LoadHalfUnprivileged",
                                                                                        CTy"Load",
                                                                                        TP[EQ(Var("S",
                                                                                                  F1),
                                                                                              LW(0,
                                                                                                 1)),
                                                                                           bVar"add",
                                                                                           bVar"postindex",
                                                                                           Var("Rt",
                                                                                               F4),
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           Var("m",
                                                                                               CTy"offset2")])),
                                                                                  Call
                                                                                    ("Load",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("LoadSignedByteUnprivileged",
                                                                                        CTy"Load",
                                                                                        TP[bVar"add",
                                                                                           bVar"postindex",
                                                                                           Var("Rt",
                                                                                               F4),
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           Var("m",
                                                                                               CTy"offset2")])))))),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU))))))))))),
                        (Bop(And,bVar"b'22",
                             Bop(And,bVar"b'20",
                                 Bop(And,bVar"b'19",
                                     Bop(And,bVar"b'18",
                                         Bop(And,bVar"b'17",
                                             Bop(And,bVar"b'16",
                                                 Bop(And,bVar"b'7",
                                                     bVar"b'4"))))))),
                         Let(Var("H",F1),Mop(Cast F1,LL[bVar"b'5"]),
                             Let(Var("S",F1),Mop(Cast F1,LL[bVar"b'6"]),
                                 Let(Var("Rt",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     MB(Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           TP[Var("cond",F4),
                                              Bop(Or,
                                                  Mop(Not,
                                                      EQ(Var("H",F1),
                                                         LW(0,1))),
                                                  EQ(Var("S",F1),LW(1,1)))]),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(ITE(EQ(Var("Rt",F4),
                                                         LW(15,4)),
                                                      Call
                                                        ("DECODE_UNPREDICTABLE",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         TP[Var("mc",
                                                                CTy"MachineCode"),
                                                            LS
                                                             "LoadHalf/Byte (literal)"]),
                                                      MU(LU,qTy)),
                                                  Close
                                                    (AVar uTy,
                                                     MU(Let(bVar"add",
                                                            EQ(Mop(Cast F1,
                                                                   LL[bVar"b'23"]),
                                                               LW(1,1)),
                                                            Let(bVar"unsigned",
                                                                EQ(Var("S",
                                                                       F1),
                                                                   LW(0,1)),
                                                                Let(Var("imm32",
                                                                        F32),
                                                                    Mop(Cast
                                                                          F32,
                                                                        CC[Mop(Cast
                                                                                 F4,
                                                                               LL[bVar"b'11",
                                                                                  bVar"b'10",
                                                                                  bVar"b'9",
                                                                                  bVar"b'8"]),
                                                                           Mop(Cast
                                                                                 F4,
                                                                               LL[bVar"b'3",
                                                                                  bVar"b'2",
                                                                                  bVar"b'1",
                                                                                  bVar"b'0"])]),
                                                                    ITE(EQ(Var("H",
                                                                               F1),
                                                                           LW(1,
                                                                              1)),
                                                                        Call
                                                                          ("Load",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("LoadHalfLiteral",
                                                                              CTy"Load",
                                                                              TP[bVar"unsigned",
                                                                                 bVar"add",
                                                                                 Var("Rt",
                                                                                     F4),
                                                                                 Var("imm32",
                                                                                     F32)])),
                                                                        Call
                                                                          ("Load",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("LoadByteLiteral",
                                                                              CTy"Load",
                                                                              TP[bVar"unsigned",
                                                                                 bVar"add",
                                                                                 Var("Rt",
                                                                                     F4),
                                                                                 Var("imm32",
                                                                                     F32)])))))),
                                                        qTy))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                        (Bop(And,bVar"b'22",
                             Bop(And,bVar"b'20",
                                 Bop(And,bVar"b'7",bVar"b'4"))),
                         Let(Var("H",F1),Mop(Cast F1,LL[bVar"b'5"]),
                             Let(Var("S",F1),Mop(Cast F1,LL[bVar"b'6"]),
                                 Let(Var("Rt",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     Let(Var("Rn",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'19",bVar"b'18",
                                                bVar"b'17",bVar"b'16"]),
                                         Let(Var("P",F1),
                                             Mop(Cast F1,LL[bVar"b'24"]),
                                             MB(Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   TP[Var("cond",F4),
                                                      Bop(Or,
                                                          Mop(Not,
                                                              EQ(Var("H",
                                                                     F1),
                                                                 LW(0,1))),
                                                          EQ(Var("S",F1),
                                                             LW(1,1)))]),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       Let(bVar"wback",
                                                           Bop(Or,
                                                               EQ(Var("P",
                                                                      F1),
                                                                  LW(0,1)),
                                                               EQ(Mop(Cast
                                                                        F1,
                                                                      LL[bVar"b'21"]),
                                                                  LW(1,1))),
                                                           MB(ITE(Bop(Or,
                                                                      EQ(Var("Rt",
                                                                             F4),
                                                                         LW(15,
                                                                            4)),
                                                                      Bop(And,
                                                                          bVar"wback",
                                                                          EQ(Var("Rn",
                                                                                 F4),
                                                                             Var("Rt",
                                                                                 F4)))),
                                                                  Call
                                                                    ("DECODE_UNPREDICTABLE",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[Var("mc",
                                                                            CTy"MachineCode"),
                                                                        LS
                                                                         "LoadHalf/Byte (immediate)"]),
                                                                  MU(LU,
                                                                     qTy)),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Let(bVar"index",
                                                                        EQ(Var("P",
                                                                               F1),
                                                                           LW(1,
                                                                              1)),
                                                                        Let(bVar"add",
                                                                            EQ(Mop(Cast
                                                                                     F1,
                                                                                   LL[bVar"b'23"]),
                                                                               LW(1,
                                                                                  1)),
                                                                            Let(bVar"unsigned",
                                                                                EQ(Var("S",
                                                                                       F1),
                                                                                   LW(0,
                                                                                      1)),
                                                                                Let(Var("m",
                                                                                        CTy"offset1"),
                                                                                    Call
                                                                                      ("immediate_form1",
                                                                                       CTy"offset1",
                                                                                       Mop(Cast
                                                                                             F32,
                                                                                           CC[Mop(Cast
                                                                                                    F4,
                                                                                                  LL[bVar"b'11",
                                                                                                     bVar"b'10",
                                                                                                     bVar"b'9",
                                                                                                     bVar"b'8"]),
                                                                                              Mop(Cast
                                                                                                    F4,
                                                                                                  LL[bVar"b'3",
                                                                                                     bVar"b'2",
                                                                                                     bVar"b'1",
                                                                                                     bVar"b'0"])])),
                                                                                    ITE(EQ(Var("H",
                                                                                               F1),
                                                                                           LW(1,
                                                                                              1)),
                                                                                        Call
                                                                                          ("Load",
                                                                                           CTy"instruction",
                                                                                           Call
                                                                                             ("LoadHalf",
                                                                                              CTy"Load",
                                                                                              TP[bVar"unsigned",
                                                                                                 bVar"add",
                                                                                                 bVar"index",
                                                                                                 bVar"wback",
                                                                                                 Var("Rt",
                                                                                                     F4),
                                                                                                 Var("Rn",
                                                                                                     F4),
                                                                                                 Var("m",
                                                                                                     CTy"offset1")])),
                                                                                        Call
                                                                                          ("Load",
                                                                                           CTy"instruction",
                                                                                           Call
                                                                                             ("LoadByte",
                                                                                              CTy"Load",
                                                                                              TP[bVar"unsigned",
                                                                                                 bVar"add",
                                                                                                 bVar"index",
                                                                                                 bVar"wback",
                                                                                                 Var("Rt",
                                                                                                     F4),
                                                                                                 Var("Rn",
                                                                                                     F4),
                                                                                                 Var("m",
                                                                                                     CTy"offset1")]))))))),
                                                                    qTy)))),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU)))))))))),
                        (Bop(And,Mop(Not,bVar"b'24"),
                             Bop(And,bVar"b'22",
                                 Bop(And,bVar"b'21",
                                     Bop(And,Mop(Not,bVar"b'20"),
                                         Bop(And,bVar"b'7",
                                             Bop(And,Mop(Not,bVar"b'6"),
                                                 Bop(And,bVar"b'5",
                                                     bVar"b'4"))))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(Call
                                      ("HaveThumb2",ATy(qTy,PTy(bTy,qTy)),
                                       LU),
                                    Close
                                      (bVar"v",
                                       MB(MB(MU(TP[Var("cond",F4),bVar"v"],
                                                qTy),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(ITE(Bop(Or,
                                                            Bop(Or,
                                                                EQ(Var("Rt",
                                                                       F4),
                                                                   LW(15,4)),
                                                                EQ(Var("Rn",
                                                                       F4),
                                                                   LW(15,4))),
                                                            EQ(Var("Rn",F4),
                                                               Var("Rt",F4))),
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "StoreHalf (immediate)"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Store",
                                                             CTy"instruction",
                                                             Call
                                                               ("StoreHalfUnprivileged",
                                                                CTy"Store",
                                                                TP[EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'23"]),
                                                                      LW(1,
                                                                         1)),
                                                                   LT,
                                                                   Var("Rt",
                                                                       F4),
                                                                   Var("Rn",
                                                                       F4),
                                                                   Call
                                                                     ("immediate_form2",
                                                                      CTy"offset2",
                                                                      Mop(Cast
                                                                            F32,
                                                                          CC[Mop(Cast
                                                                                   F4,
                                                                                 LL[bVar"b'11",
                                                                                    bVar"b'10",
                                                                                    bVar"b'9",
                                                                                    bVar"b'8"]),
                                                                             Mop(Cast
                                                                                   F4,
                                                                                 LL[bVar"b'3",
                                                                                    bVar"b'2",
                                                                                    bVar"b'1",
                                                                                    bVar"b'0"])]))])),
                                                          qTy))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU))))))))),
                        (Bop(And,bVar"b'22",
                             Bop(And,Mop(Not,bVar"b'20"),
                                 Bop(And,bVar"b'7",
                                     Bop(And,Mop(Not,bVar"b'6"),
                                         Bop(And,bVar"b'5",bVar"b'4"))))),
                         Let(Var("Rt",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'15",bVar"b'14",bVar"b'13",
                                    bVar"b'12"]),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("P",F1),
                                     Mop(Cast F1,LL[bVar"b'24"]),
                                     MB(Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           TP[Var("cond",F4),LT]),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               Let(bVar"wback",
                                                   Bop(Or,
                                                       EQ(Var("P",F1),
                                                          LW(0,1)),
                                                       EQ(Mop(Cast F1,
                                                              LL[bVar"b'21"]),
                                                          LW(1,1))),
                                                   MB(ITE(Bop(Or,
                                                              EQ(Var("Rt",
                                                                     F4),
                                                                 LW(15,4)),
                                                              Bop(And,
                                                                  bVar"wback",
                                                                  Bop(Or,
                                                                      EQ(Var("Rn",
                                                                             F4),
                                                                         LW(15,
                                                                            4)),
                                                                      EQ(Var("Rn",
                                                                             F4),
                                                                         Var("Rt",
                                                                             F4))))),
                                                          Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS
                                                                 "StoreHalf (immediate)"]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("Store",
                                                               CTy"instruction",
                                                               Call
                                                                 ("StoreHalf",
                                                                  CTy"Store",
                                                                  TP[EQ(Mop(Cast
                                                                              F1,
                                                                            LL[bVar"b'23"]),
                                                                        LW(1,
                                                                           1)),
                                                                     EQ(Var("P",
                                                                            F1),
                                                                        LW(1,
                                                                           1)),
                                                                     bVar"wback",
                                                                     Var("Rt",
                                                                         F4),
                                                                     Var("Rn",
                                                                         F4),
                                                                     Call
                                                                       ("immediate_form1",
                                                                        CTy"offset1",
                                                                        Mop(Cast
                                                                              F32,
                                                                            CC[Mop(Cast
                                                                                     F4,
                                                                                   LL[bVar"b'11",
                                                                                      bVar"b'10",
                                                                                      bVar"b'9",
                                                                                      bVar"b'8"]),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   LL[bVar"b'3",
                                                                                      bVar"b'2",
                                                                                      bVar"b'1",
                                                                                      bVar"b'0"])]))])),
                                                            qTy)))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU))))))))],
                       Call
                         ("UndefinedARM",
                          ATy(qTy,PTy(CTy"instruction",qTy)),
                          Var("cond",F4))))))))
;
val DecodeThumb_def = Def
  ("DecodeThumb",Var("h",F16),
   Let(Var("mc",CTy"MachineCode"),
       Call("Thumb",CTy"MachineCode",Var("h",F16)),
       Let(TP[bVar"b'15",bVar"b'14",bVar"b'13",bVar"b'12",bVar"b'11",
              bVar"b'10",bVar"b'9",bVar"b'8",bVar"b'7",bVar"b'6",
              bVar"b'5",bVar"b'4",bVar"b'3",bVar"b'2",bVar"b'1",bVar"b'0"],
           BL(16,Var("h",F16)),
           ITB([(bVar"b'13",
                 ITB([(bVar"b'15",
                       ITB([(Bop(And,Mop(Not,bVar"b'14"),
                                 Mop(Not,bVar"b'12")),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MU(Call
                                                  ("Data",
                                                   CTy"instruction",
                                                   Call
                                                     ("ArithLogicImmediate",
                                                      CTy"Data",
                                                      TP[LW(4,4),LF,
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'10",
                                                                    bVar"b'9",
                                                                    bVar"b'8"])),
                                                         ITE(EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'11"]),
                                                                LW(1,1)),
                                                             LW(13,4),
                                                             LW(15,4)),
                                                         CC[LW(15,4),
                                                            Mop(Cast F8,
                                                                LL[bVar"b'7",
                                                                   bVar"b'6",
                                                                   bVar"b'5",
                                                                   bVar"b'4",
                                                                   bVar"b'3",
                                                                   bVar"b'2",
                                                                   bVar"b'1",
                                                                   bVar"b'0"])]])),
                                                qTy),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,Mop(Not,bVar"b'11"),
                                         Bop(And,Mop(Not,bVar"b'10"),
                                             Bop(And,Mop(Not,bVar"b'9"),
                                                 Mop(Not,bVar"b'8")))))),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MU(Call
                                                  ("Data",
                                                   CTy"instruction",
                                                   Call
                                                     ("ArithLogicImmediate",
                                                      CTy"Data",
                                                      TP[ITE(EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'7"]),
                                                                LW(1,1)),
                                                             LW(2,4),
                                                             LW(4,4)),LF,
                                                         LW(13,4),
                                                         LW(13,4),
                                                         CC[LW(30,5),
                                                            Mop(Cast
                                                                  (FTy 7),
                                                                LL[bVar"b'6",
                                                                   bVar"b'5",
                                                                   bVar"b'4",
                                                                   bVar"b'3",
                                                                   bVar"b'2",
                                                                   bVar"b'1",
                                                                   bVar"b'0"])]])),
                                                qTy),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,Mop(Not,bVar"b'10"),bVar"b'8"))),
                             MB(Call
                                  ("HaveThumb2",ATy(qTy,PTy(bTy,qTy)),LU),
                                Close
                                  (bVar"v",
                                   MB(MB(MU(TP[LW(14,4),bVar"v"],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(Call
                                                  ("InITBlock",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(ITE(bVar"v",
                                                          Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS
                                                                 "CompareBranch"]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("Branch",
                                                               CTy"instruction",
                                                               Call
                                                                 ("CompareBranch",
                                                                  CTy"Branch",
                                                                  TP[EQ(Mop(Cast
                                                                              F1,
                                                                            LL[bVar"b'11"]),
                                                                        LW(1,
                                                                           1)),
                                                                     Mop(Cast
                                                                           F4,
                                                                         Mop(Cast
                                                                               (FTy 3),
                                                                             LL[bVar"b'2",
                                                                                bVar"b'1",
                                                                                bVar"b'0"])),
                                                                     Mop(Cast
                                                                           F32,
                                                                         CC[Mop(Cast
                                                                                  F1,
                                                                                LL[bVar"b'9"]),
                                                                            Mop(Cast
                                                                                  (FTy 5),
                                                                                LL[bVar"b'7",
                                                                                   bVar"b'6",
                                                                                   bVar"b'5",
                                                                                   bVar"b'4",
                                                                                   bVar"b'3"]),
                                                                            LW(0,
                                                                               1)])])),
                                                            qTy))))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,Mop(Not,bVar"b'11"),
                                         Bop(And,Mop(Not,bVar"b'10"),
                                             Bop(And,bVar"b'9",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'8"),
                                                     Mop(Not,bVar"b'6"))))))),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v0",
                                               MB(MU(Bop(Ge,nVar"v0",LN 6),
                                                     qTy),
                                                  Close
                                                    (bVar"v0",
                                                     MU(TP[Var("v",F4),
                                                           bVar"v0"],qTy))))),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MU(Call
                                                  ("Media",
                                                   CTy"instruction",
                                                   Call
                                                     ("ExtendHalfword",
                                                      CTy"Media",
                                                      TP[EQ(Mop(Cast F1,
                                                                LL[bVar"b'7"]),
                                                            LW(1,1)),
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'2",
                                                                    bVar"b'1",
                                                                    bVar"b'0"])),
                                                         LW(15,4),
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'5",
                                                                    bVar"b'4",
                                                                    bVar"b'3"])),
                                                         LN 0])),qTy),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,Mop(Not,bVar"b'11"),
                                         Bop(And,Mop(Not,bVar"b'10"),
                                             Bop(And,bVar"b'9",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'8"),
                                                     bVar"b'6")))))),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v0",
                                               MB(MU(Bop(Ge,nVar"v0",LN 6),
                                                     qTy),
                                                  Close
                                                    (bVar"v0",
                                                     MU(TP[Var("v",F4),
                                                           bVar"v0"],qTy))))),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MU(Call
                                                  ("Media",
                                                   CTy"instruction",
                                                   Call
                                                     ("ExtendByte",
                                                      CTy"Media",
                                                      TP[EQ(Mop(Cast F1,
                                                                LL[bVar"b'7"]),
                                                            LW(1,1)),
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'2",
                                                                    bVar"b'1",
                                                                    bVar"b'0"])),
                                                         LW(15,4),
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'5",
                                                                    bVar"b'4",
                                                                    bVar"b'3"])),
                                                         LN 0])),qTy),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,Mop(Not,bVar"b'11"),
                                         Bop(And,bVar"b'10",
                                             Mop(Not,bVar"b'9"))))),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Let(Var("registers",F16),
                                                 CC[LW(0,1),
                                                    Mop(Cast F1,
                                                        LL[bVar"b'8"]),
                                                    LW(0,6),
                                                    Mop(Cast F8,
                                                        LL[bVar"b'7",
                                                           bVar"b'6",
                                                           bVar"b'5",
                                                           bVar"b'4",
                                                           bVar"b'3",
                                                           bVar"b'2",
                                                           bVar"b'1",
                                                           bVar"b'0"])],
                                                 MB(Call
                                                      ("BitCount",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       Var("registers",F16)),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MU(Bop(Lt,
                                                                    nVar"v",
                                                                    LN 1),
                                                                qTy),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "StoreMultiple"]),
                                                                    MU(LU,
                                                                       qTy)))),
                                                          Close
                                                            (AVar uTy,
                                                             MU(Call
                                                                  ("Store",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("StoreMultiple",
                                                                      CTy"Store",
                                                                      TP[LF,
                                                                         LT,
                                                                         LT,
                                                                         LW(13,
                                                                            4),
                                                                         Var("registers",
                                                                             F16)])),
                                                                qTy)))))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,Mop(Not,bVar"b'11"),
                                         Bop(And,bVar"b'10",
                                             Bop(And,bVar"b'9",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'8"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'7"),
                                                         Bop(And,
                                                             bVar"b'6",
                                                             Mop(Not,
                                                                 bVar"b'5"))))))))),
                             MB(Call
                                  ("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                                Close
                                  (nVar"v",
                                   MB(MB(MB(MU(Bop(Ge,nVar"v",LN 6),qTy),
                                            Close
                                              (bVar"v",
                                               MU(TP[LW(14,4),bVar"v"],qTy))),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(Call
                                                  ("InITBlock",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(ITE(bVar"v",
                                                          Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS"Setend"]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("System",
                                                               CTy"instruction",
                                                               Call
                                                                 ("Setend",
                                                                  CTy"System",
                                                                  EQ(Mop(Cast
                                                                           F1,
                                                                         LL[bVar"b'3"]),
                                                                     LW(1,
                                                                        1)))),
                                                            qTy))))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,Mop(Not,bVar"b'11"),
                                         Bop(And,bVar"b'10",
                                             Bop(And,bVar"b'9",
                                                 Bop(And,
                                                     Mop(Not,bVar"b'8"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'7"),
                                                         Bop(And,
                                                             bVar"b'6",
                                                             bVar"b'5")))))))),
                             Let(Var("F",F1),Mop(Cast F1,LL[bVar"b'0"]),
                                 Let(Var("I",F1),
                                     Mop(Cast F1,LL[bVar"b'1"]),
                                     Let(Var("A",F1),
                                         Mop(Cast F1,LL[bVar"b'2"]),
                                         MB(Call
                                              ("ArchVersion",
                                               ATy(qTy,PTy(nTy,qTy)),LU),
                                            Close
                                              (nVar"v",
                                               MB(MB(MB(MU(Bop(Ge,nVar"v",
                                                               LN 6),qTy),
                                                        Close
                                                          (bVar"v",
                                                           MU(TP[LW(14,4),
                                                                 bVar"v"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(Call
                                                              ("InITBlock",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               LU),
                                                            Close
                                                              (bVar"v",
                                                               MB(MB(MU(Bop(Or,
                                                                            EQ(CC[Var("A",
                                                                                      F1),
                                                                                  Var("I",
                                                                                      F1),
                                                                                  Var("F",
                                                                                      F1)],
                                                                               LW(0,
                                                                                  3)),
                                                                            bVar"v"),
                                                                        qTy),
                                                                     Close
                                                                       (bVar"b",
                                                                        ITE(bVar"b",
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "ChangeProcessorStateT1"]),
                                                                            MU(LU,
                                                                               qTy)))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("System",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("ChangeProcessorStateT1",
                                                                              CTy"System",
                                                                              TP[EQ(Mop(Cast
                                                                                          F1,
                                                                                        LL[bVar"b'4"]),
                                                                                    LW(0,
                                                                                       1)),
                                                                                 EQ(Var("A",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 EQ(Var("I",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 EQ(Var("F",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1))])),
                                                                        qTy))))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,bVar"b'11",
                                         Bop(And,Mop(Not,bVar"b'10"),
                                             Bop(And,bVar"b'9",
                                                 Mop(Not,bVar"b'8")))))),
                             Let(Var("Rd",FTy 3),
                                 Mop(Cast(FTy 3),
                                     LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                                 Let(Var("Rm",FTy 3),
                                     Mop(Cast(FTy 3),
                                         LL[bVar"b'5",bVar"b'4",bVar"b'3"]),
                                     MB(Call
                                          ("ThumbCondition",
                                           ATy(qTy,PTy(F4,qTy)),LU),
                                        Close
                                          (Var("v",F4),
                                           MB(MB(MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v0",
                                                       MB(MU(Bop(Ge,
                                                                 nVar"v0",
                                                                 LN 6),qTy),
                                                          Close
                                                            (bVar"v0",
                                                             MU(TP[Var("v",
                                                                       F4),
                                                                   bVar"v0"],
                                                                qTy))))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MU(CS(Mop(Cast(FTy 2),
                                                               LL[bVar"b'7",
                                                                  bVar"b'6"]),
                                                           [(LW(0,2),
                                                             Call
                                                               ("Media",
                                                                CTy"instruction",
                                                                Call
                                                                  ("ByteReverse",
                                                                   CTy"Media",
                                                                   TP[Mop(Cast
                                                                            F4,
                                                                          Var("Rd",
                                                                              FTy 3)),
                                                                      Mop(Cast
                                                                            F4,
                                                                          Var("Rm",
                                                                              FTy 3))]))),
                                                            (LW(1,2),
                                                             Call
                                                               ("Media",
                                                                CTy"instruction",
                                                                Call
                                                                  ("ByteReversePackedHalfword",
                                                                   CTy"Media",
                                                                   TP[Mop(Cast
                                                                            F4,
                                                                          Var("Rd",
                                                                              FTy 3)),
                                                                      Mop(Cast
                                                                            F4,
                                                                          Var("Rm",
                                                                              FTy 3))]))),
                                                            (LW(3,2),
                                                             Call
                                                               ("Media",
                                                                CTy"instruction",
                                                                Call
                                                                  ("ByteReverseSignedHalfword",
                                                                   CTy"Media",
                                                                   TP[Mop(Cast
                                                                            F4,
                                                                          Var("Rd",
                                                                              FTy 3)),
                                                                      Mop(Cast
                                                                            F4,
                                                                          Var("Rm",
                                                                              FTy 3))]))),
                                                            (AVar(FTy 2),
                                                             Call
                                                               ("Undefined",
                                                                CTy"instruction",
                                                                LW(0,32)))]),
                                                        qTy),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,bVar"b'11",
                                         Bop(And,bVar"b'10",
                                             Mop(Not,bVar"b'9"))))),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Let(Var("registers",F16),
                                                 CC[Mop(Cast F1,
                                                        LL[bVar"b'8"]),
                                                    LW(0,7),
                                                    Mop(Cast F8,
                                                        LL[bVar"b'7",
                                                           bVar"b'6",
                                                           bVar"b'5",
                                                           bVar"b'4",
                                                           bVar"b'3",
                                                           bVar"b'2",
                                                           bVar"b'1",
                                                           bVar"b'0"])],
                                                 MB(Call
                                                      ("BitCount",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       Var("registers",F16)),
                                                    Close
                                                      (nVar"v",
                                                       MB(MB(MB(MU(Bop(Lt,
                                                                       nVar"v",
                                                                       LN
                                                                        1),
                                                                   qTy),
                                                                Close
                                                                  (bVar"b",
                                                                   ITE(bVar"b",
                                                                       MU(LT,
                                                                          qTy),
                                                                       MB(Call
                                                                            ("InITBlock",
                                                                             ATy(qTy,
                                                                                 PTy(bTy,
                                                                                     qTy)),
                                                                             LU),
                                                                          Close
                                                                            (bVar"v",
                                                                             MB(MU(Bop(And,
                                                                                       Bop(Bit,
                                                                                           Var("registers",
                                                                                               F16),
                                                                                           LN
                                                                                            15),
                                                                                       bVar"v"),
                                                                                   qTy),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   ITE(bVar"b",
                                                                                       MB(Call
                                                                                            ("LastInITBlock",
                                                                                             ATy(qTy,
                                                                                                 PTy(bTy,
                                                                                                     qTy)),
                                                                                             LU),
                                                                                          Close
                                                                                            (bVar"v",
                                                                                             MU(Mop(Not,
                                                                                                    bVar"v"),
                                                                                                qTy))),
                                                                                       MU(LF,
                                                                                          qTy))))))))),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "LoadMultiple"]),
                                                                    MU(LU,
                                                                       qTy)))),
                                                          Close
                                                            (AVar uTy,
                                                             MU(Call
                                                                  ("Load",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("LoadMultiple",
                                                                      CTy"Load",
                                                                      TP[LT,
                                                                         LF,
                                                                         LT,
                                                                         LW(13,
                                                                            4),
                                                                         Var("registers",
                                                                             F16)])),
                                                                qTy)))))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,bVar"b'11",
                                         Bop(And,bVar"b'10",
                                             Bop(And,bVar"b'9",
                                                 Mop(Not,bVar"b'8")))))),
                             MB(Call
                                  ("ArchVersion",ATy(qTy,PTy(nTy,qTy)),LU),
                                Close
                                  (nVar"v",
                                   MB(MB(MB(MU(Bop(Ge,nVar"v",LN 5),qTy),
                                            Close
                                              (bVar"v",
                                               MU(TP[LW(14,4),bVar"v"],qTy))),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MU(Call
                                                  ("Hint",
                                                   CTy"instruction",
                                                   Call
                                                     ("Breakpoint",
                                                      CTy"Hint",
                                                      Mop(Cast F32,
                                                          Mop(Cast F8,
                                                              LL[bVar"b'7",
                                                                 bVar"b'6",
                                                                 bVar"b'5",
                                                                 bVar"b'4",
                                                                 bVar"b'3",
                                                                 bVar"b'2",
                                                                 bVar"b'1",
                                                                 bVar"b'0"])))),
                                                qTy),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,bVar"b'11",
                                         Bop(And,bVar"b'10",
                                             Bop(And,bVar"b'9",
                                                 Bop(And,bVar"b'8",
                                                     Bop(And,
                                                         Mop(Not,bVar"b'3"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'2"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'1"),
                                                                 Mop(Not,
                                                                     bVar"b'0")))))))))),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MU(TP[Var("v",F4),
                                            Mop(Cast F8,
                                                Mop(Cast F4,
                                                    LL[bVar"b'7",
                                                       bVar"b'6",
                                                       bVar"b'5",bVar"b'4"]))],
                                         qTy),
                                      Close
                                        (Var("v",PTy(F4,F8)),
                                         Call
                                           ("DecodeHint",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            Var("v",PTy(F4,F8)))))))),
                            (Bop(And,Mop(Not,bVar"b'14"),
                                 Bop(And,bVar"b'12",
                                     Bop(And,bVar"b'11",
                                         Bop(And,bVar"b'10",
                                             Bop(And,bVar"b'9",bVar"b'8"))))),
                             Let(Var("mask",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                        bVar"b'0"]),
                                 Let(Var("firstcond",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'7",bVar"b'6",bVar"b'5",
                                            bVar"b'4"]),
                                     MB(Call
                                          ("HaveThumb2",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MU(TP[LW(14,4),bVar"v"],
                                                    qTy),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(Call
                                                          ("BitCount",
                                                           ATy(qTy,
                                                               PTy(nTy,qTy)),
                                                           Var("mask",F4)),
                                                        Close
                                                          (nVar"v",
                                                           MB(MB(MB(MB(MB(MB(MU(EQ(nVar"v",
                                                                                   LN
                                                                                    1),
                                                                                qTy),
                                                                             Close
                                                                               (bVar"v",
                                                                                MU(Mop(Not,
                                                                                       bVar"v"),
                                                                                   qTy))),
                                                                          Close
                                                                            (bVar"v",
                                                                             MU(Bop(And,
                                                                                    EQ(Var("firstcond",
                                                                                           F4),
                                                                                       LW(14,
                                                                                          4)),
                                                                                    bVar"v"),
                                                                                qTy))),
                                                                       Close
                                                                         (bVar"v",
                                                                          MU(Bop(Or,
                                                                                 EQ(Var("firstcond",
                                                                                        F4),
                                                                                    LW(15,
                                                                                       4)),
                                                                                 bVar"v"),
                                                                             qTy))),
                                                                    Close
                                                                      (bVar"b",
                                                                       ITE(bVar"b",
                                                                           MU(LT,
                                                                              qTy),
                                                                           Call
                                                                             ("InITBlock",
                                                                              ATy(qTy,
                                                                                  PTy(bTy,
                                                                                      qTy)),
                                                                              LU)))),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "IfThen"]),
                                                                        MU(LU,
                                                                           qTy)))),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Call
                                                                      ("IfThen",
                                                                       CTy"instruction",
                                                                       TP[Var("firstcond",
                                                                              F4),
                                                                          Var("mask",
                                                                              F4)]),
                                                                    qTy))))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))))),
                            (Bop(And,bVar"b'14",
                                 Bop(And,Mop(Not,bVar"b'12"),
                                     Mop(Not,bVar"b'11"))),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             MB(Call
                                                  ("InITBlock",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(ITE(bVar"v",
                                                             MB(Call
                                                                  ("LastInITBlock",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v",
                                                                   MU(Mop(Not,
                                                                          bVar"v"),
                                                                      qTy))),
                                                             MU(LF,qTy)),
                                                         Close
                                                           (bVar"b",
                                                            ITE(bVar"b",
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "BranchTarget"]),
                                                                MU(LU,qTy)))),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("Branch",
                                                               CTy"instruction",
                                                               Call
                                                                 ("BranchTarget",
                                                                  CTy"Branch",
                                                                  Mop(SE F32,
                                                                      CC[Mop(Cast
                                                                               (FTy 11),
                                                                             LL[bVar"b'10",
                                                                                bVar"b'9",
                                                                                bVar"b'8",
                                                                                bVar"b'7",
                                                                                bVar"b'6",
                                                                                bVar"b'5",
                                                                                bVar"b'4",
                                                                                bVar"b'3",
                                                                                bVar"b'2",
                                                                                bVar"b'1",
                                                                                bVar"b'0"]),
                                                                         LW(0,
                                                                            1)]))),
                                                            qTy))))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))))],
                           Call
                             ("UndefinedThumb",
                              ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                      (Bop(And,Mop(Not,bVar"b'14"),
                           Bop(And,Mop(Not,bVar"b'12"),Mop(Not,bVar"b'11"))),
                       MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                          Close
                            (Var("v",F4),
                             MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                   Close
                                     (Var("v",PTy(F4,bTy)),
                                      Call
                                        ("Take",ATy(qTy,PTy(bTy,qTy)),
                                         Var("v",PTy(F4,bTy))))),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       MB(Call
                                            ("InITBlock",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v",
                                             MB(MU(Mop(Not,bVar"v"),qTy),
                                                Close
                                                  (bVar"setflags",
                                                   MU(Call
                                                        ("Data",
                                                         CTy"instruction",
                                                         Call
                                                           ("Move",
                                                            CTy"Data",
                                                            TP[bVar"setflags",
                                                               LF,
                                                               Mop(Cast F4,
                                                                   Mop(Cast
                                                                         (FTy 3),
                                                                       LL[bVar"b'10",
                                                                          bVar"b'9",
                                                                          bVar"b'8"])),
                                                               Mop(Cast
                                                                     (FTy 12),
                                                                   Mop(Cast
                                                                         F8,
                                                                       LL[bVar"b'7",
                                                                          bVar"b'6",
                                                                          bVar"b'5",
                                                                          bVar"b'4",
                                                                          bVar"b'3",
                                                                          bVar"b'2",
                                                                          bVar"b'1",
                                                                          bVar"b'0"]))])),
                                                      qTy))))),
                                       Call
                                         ("Skip",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU))))))),
                      (Bop(And,Mop(Not,bVar"b'14"),
                           Bop(And,Mop(Not,bVar"b'12"),bVar"b'11")),
                       MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                          Close
                            (Var("v",F4),
                             MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                   Close
                                     (Var("v",PTy(F4,bTy)),
                                      Call
                                        ("Take",ATy(qTy,PTy(bTy,qTy)),
                                         Var("v",PTy(F4,bTy))))),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       MU(Call
                                            ("Data",CTy"instruction",
                                             Call
                                               ("TestCompareImmediate",
                                                CTy"Data",
                                                TP[LW(2,2),
                                                   Mop(Cast F4,
                                                       Mop(Cast(FTy 3),
                                                           LL[bVar"b'10",
                                                              bVar"b'9",
                                                              bVar"b'8"])),
                                                   Mop(Cast(FTy 12),
                                                       Mop(Cast F8,
                                                           LL[bVar"b'7",
                                                              bVar"b'6",
                                                              bVar"b'5",
                                                              bVar"b'4",
                                                              bVar"b'3",
                                                              bVar"b'2",
                                                              bVar"b'1",
                                                              bVar"b'0"]))])),
                                          qTy),
                                       Call
                                         ("Skip",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU))))))),
                      (Bop(And,Mop(Not,bVar"b'14"),bVar"b'12"),
                       MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                          Close
                            (Var("v",F4),
                             MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                   Close
                                     (Var("v",PTy(F4,bTy)),
                                      Call
                                        ("Take",ATy(qTy,PTy(bTy,qTy)),
                                         Var("v",PTy(F4,bTy))))),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       Let(Var("d",F4),
                                           Mop(Cast F4,
                                               Mop(Cast(FTy 3),
                                                   LL[bVar"b'10",
                                                      bVar"b'9",bVar"b'8"])),
                                           MB(Call
                                                ("InITBlock",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v",
                                                 MB(MU(Mop(Not,bVar"v"),
                                                       qTy),
                                                    Close
                                                      (bVar"setflags",
                                                       MU(Call
                                                            ("Data",
                                                             CTy"instruction",
                                                             Call
                                                               ("ArithLogicImmediate",
                                                                CTy"Data",
                                                                TP[ITE(EQ(Mop(Cast
                                                                                F1,
                                                                              LL[bVar"b'11"]),
                                                                          LW(1,
                                                                             1)),
                                                                       LW(2,
                                                                          4),
                                                                       LW(4,
                                                                          4)),
                                                                   bVar"setflags",
                                                                   Var("d",
                                                                       F4),
                                                                   Var("d",
                                                                       F4),
                                                                   Mop(Cast
                                                                         (FTy 12),
                                                                       Mop(Cast
                                                                             F8,
                                                                           LL[bVar"b'7",
                                                                              bVar"b'6",
                                                                              bVar"b'5",
                                                                              bVar"b'4",
                                                                              bVar"b'3",
                                                                              bVar"b'2",
                                                                              bVar"b'1",
                                                                              bVar"b'0"]))])),
                                                          qTy)))))),
                                       Call
                                         ("Skip",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU))))))),
                      (Bop(And,bVar"b'14",Mop(Not,bVar"b'12")),
                       Let(Var("Rt",FTy 3),
                           Mop(Cast(FTy 3),
                               LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                           Let(Var("Rn",FTy 3),
                               Mop(Cast(FTy 3),
                                   LL[bVar"b'5",bVar"b'4",bVar"b'3"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MU(Let(bVar"index",LT,
                                                      Let(bVar"add",LT,
                                                          Let(bVar"wback",
                                                              LF,
                                                              Let(Var("m",
                                                                      CTy"offset1"),
                                                                  Call
                                                                    ("immediate_form1",
                                                                     CTy"offset1",
                                                                     Mop(Cast
                                                                           F32,
                                                                         CC[Mop(Cast
                                                                                  (FTy 5),
                                                                                LL[bVar"b'10",
                                                                                   bVar"b'9",
                                                                                   bVar"b'8",
                                                                                   bVar"b'7",
                                                                                   bVar"b'6"]),
                                                                            LW(0,
                                                                               2)])),
                                                                  ITE(EQ(Mop(Cast
                                                                               F1,
                                                                             LL[bVar"b'11"]),
                                                                         LW(1,
                                                                            1)),
                                                                      Call
                                                                        ("Load",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("LoadWord",
                                                                            CTy"Load",
                                                                            TP[bVar"add",
                                                                               bVar"index",
                                                                               bVar"wback",
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rt",
                                                                                       FTy 3)),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rn",
                                                                                       FTy 3)),
                                                                               Var("m",
                                                                                   CTy"offset1")])),
                                                                      Call
                                                                        ("Store",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("StoreWord",
                                                                            CTy"Store",
                                                                            TP[bVar"add",
                                                                               bVar"index",
                                                                               bVar"wback",
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rt",
                                                                                       FTy 3)),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rn",
                                                                                       FTy 3)),
                                                                               Var("m",
                                                                                   CTy"offset1")]))))))),
                                                  qTy),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU))))))))),
                      (Bop(And,bVar"b'14",bVar"b'12"),
                       Let(Var("Rt",FTy 3),
                           Mop(Cast(FTy 3),
                               LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                           Let(Var("Rn",FTy 3),
                               Mop(Cast(FTy 3),
                                   LL[bVar"b'5",bVar"b'4",bVar"b'3"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MU(Let(bVar"index",LT,
                                                      Let(bVar"add",LT,
                                                          Let(bVar"wback",
                                                              LF,
                                                              Let(Var("m",
                                                                      CTy"offset1"),
                                                                  Call
                                                                    ("immediate_form1",
                                                                     CTy"offset1",
                                                                     Mop(Cast
                                                                           F32,
                                                                         Mop(Cast
                                                                               (FTy 5),
                                                                             LL[bVar"b'10",
                                                                                bVar"b'9",
                                                                                bVar"b'8",
                                                                                bVar"b'7",
                                                                                bVar"b'6"]))),
                                                                  ITE(EQ(Mop(Cast
                                                                               F1,
                                                                             LL[bVar"b'11"]),
                                                                         LW(1,
                                                                            1)),
                                                                      Call
                                                                        ("Load",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("LoadByte",
                                                                            CTy"Load",
                                                                            TP[LT,
                                                                               bVar"add",
                                                                               bVar"index",
                                                                               bVar"wback",
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rt",
                                                                                       FTy 3)),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rn",
                                                                                       FTy 3)),
                                                                               Var("m",
                                                                                   CTy"offset1")])),
                                                                      Call
                                                                        ("Store",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("StoreByte",
                                                                            CTy"Store",
                                                                            TP[bVar"add",
                                                                               bVar"index",
                                                                               bVar"wback",
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rt",
                                                                                       FTy 3)),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rn",
                                                                                       FTy 3)),
                                                                               Var("m",
                                                                                   CTy"offset1")]))))))),
                                                  qTy),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))))],
                     Call
                       ("UndefinedThumb",
                        ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                (bVar"b'15",
                 ITB([(Bop(And,Mop(Not,bVar"b'14"),Mop(Not,bVar"b'12")),
                       Let(Var("Rt",FTy 3),
                           Mop(Cast(FTy 3),
                               LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                           Let(Var("Rn",FTy 3),
                               Mop(Cast(FTy 3),
                                   LL[bVar"b'5",bVar"b'4",bVar"b'3"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MU(Let(bVar"index",LT,
                                                      Let(bVar"add",LT,
                                                          Let(bVar"wback",
                                                              LF,
                                                              Let(Var("m",
                                                                      CTy"offset1"),
                                                                  Call
                                                                    ("immediate_form1",
                                                                     CTy"offset1",
                                                                     Mop(Cast
                                                                           F32,
                                                                         CC[Mop(Cast
                                                                                  (FTy 5),
                                                                                LL[bVar"b'10",
                                                                                   bVar"b'9",
                                                                                   bVar"b'8",
                                                                                   bVar"b'7",
                                                                                   bVar"b'6"]),
                                                                            LW(0,
                                                                               1)])),
                                                                  ITE(EQ(Mop(Cast
                                                                               F1,
                                                                             LL[bVar"b'11"]),
                                                                         LW(1,
                                                                            1)),
                                                                      Call
                                                                        ("Load",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("LoadHalf",
                                                                            CTy"Load",
                                                                            TP[LT,
                                                                               bVar"add",
                                                                               bVar"index",
                                                                               bVar"wback",
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rt",
                                                                                       FTy 3)),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rn",
                                                                                       FTy 3)),
                                                                               Var("m",
                                                                                   CTy"offset1")])),
                                                                      Call
                                                                        ("Store",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("StoreHalf",
                                                                            CTy"Store",
                                                                            TP[bVar"add",
                                                                               bVar"index",
                                                                               bVar"wback",
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rt",
                                                                                       FTy 3)),
                                                                               Mop(Cast
                                                                                     F4,
                                                                                   Var("Rn",
                                                                                       FTy 3)),
                                                                               Var("m",
                                                                                   CTy"offset1")]))))))),
                                                  qTy),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU))))))))),
                      (Bop(And,Mop(Not,bVar"b'14"),bVar"b'12"),
                       Let(Var("Rt",FTy 3),
                           Mop(Cast(FTy 3),
                               LL[bVar"b'10",bVar"b'9",bVar"b'8"]),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MU(Let(bVar"index",LT,
                                                  Let(bVar"add",LT,
                                                      Let(bVar"wback",LF,
                                                          Let(Var("m",
                                                                  CTy"offset1"),
                                                              Call
                                                                ("immediate_form1",
                                                                 CTy"offset1",
                                                                 Mop(Cast
                                                                       F32,
                                                                     CC[Mop(Cast
                                                                              F8,
                                                                            LL[bVar"b'7",
                                                                               bVar"b'6",
                                                                               bVar"b'5",
                                                                               bVar"b'4",
                                                                               bVar"b'3",
                                                                               bVar"b'2",
                                                                               bVar"b'1",
                                                                               bVar"b'0"]),
                                                                        LW(0,
                                                                           2)])),
                                                              ITE(EQ(Mop(Cast
                                                                           F1,
                                                                         LL[bVar"b'11"]),
                                                                     LW(1,
                                                                        1)),
                                                                  Call
                                                                    ("Load",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("LoadWord",
                                                                        CTy"Load",
                                                                        TP[bVar"add",
                                                                           bVar"index",
                                                                           bVar"wback",
                                                                           Mop(Cast
                                                                                 F4,
                                                                               Var("Rt",
                                                                                   FTy 3)),
                                                                           LW(13,
                                                                              4),
                                                                           Var("m",
                                                                               CTy"offset1")])),
                                                                  Call
                                                                    ("Store",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("StoreWord",
                                                                        CTy"Store",
                                                                        TP[bVar"add",
                                                                           bVar"index",
                                                                           bVar"wback",
                                                                           Mop(Cast
                                                                                 F4,
                                                                               Var("Rt",
                                                                                   FTy 3)),
                                                                           LW(13,
                                                                              4),
                                                                           Var("m",
                                                                               CTy"offset1")]))))))),
                                              qTy),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU)))))))),
                      (Bop(And,bVar"b'14",
                           Bop(And,Mop(Not,bVar"b'12"),Mop(Not,bVar"b'11"))),
                       MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                          Close
                            (Var("v",F4),
                             MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                   Close
                                     (Var("v",PTy(F4,bTy)),
                                      Call
                                        ("Take",ATy(qTy,PTy(bTy,qTy)),
                                         Var("v",PTy(F4,bTy))))),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       Let(Var("registers",F16),
                                           Mop(Cast F16,
                                               Mop(Cast F8,
                                                   LL[bVar"b'7",bVar"b'6",
                                                      bVar"b'5",bVar"b'4",
                                                      bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"])),
                                           MB(Call
                                                ("BitCount",
                                                 ATy(qTy,PTy(nTy,qTy)),
                                                 Var("registers",F16)),
                                              Close
                                                (nVar"v",
                                                 MB(MB(MU(Bop(Lt,nVar"v",
                                                              LN 1),qTy),
                                                       Close
                                                         (bVar"b",
                                                          ITE(bVar"b",
                                                              Call
                                                                ("DECODE_UNPREDICTABLE",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 TP[Var("mc",
                                                                        CTy"MachineCode"),
                                                                    LS
                                                                     "StoreMultiple"]),
                                                              MU(LU,qTy)))),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Store",
                                                             CTy"instruction",
                                                             Call
                                                               ("StoreMultiple",
                                                                CTy"Store",
                                                                TP[LT,LF,
                                                                   LT,
                                                                   Mop(Cast
                                                                         F4,
                                                                       Mop(Cast
                                                                             (FTy 3),
                                                                           LL[bVar"b'10",
                                                                              bVar"b'9",
                                                                              bVar"b'8"])),
                                                                   Var("registers",
                                                                       F16)])),
                                                          qTy)))))),
                                       Call
                                         ("Skip",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU))))))),
                      (Bop(And,bVar"b'14",
                           Bop(And,Mop(Not,bVar"b'12"),bVar"b'11")),
                       Let(Var("Rn",FTy 3),
                           Mop(Cast(FTy 3),
                               LL[bVar"b'10",bVar"b'9",bVar"b'8"]),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           Let(Var("registers",F16),
                                               Mop(Cast F16,
                                                   Mop(Cast F8,
                                                       LL[bVar"b'7",
                                                          bVar"b'6",
                                                          bVar"b'5",
                                                          bVar"b'4",
                                                          bVar"b'3",
                                                          bVar"b'2",
                                                          bVar"b'1",
                                                          bVar"b'0"])),
                                               MB(Call
                                                    ("BitCount",
                                                     ATy(qTy,PTy(nTy,qTy)),
                                                     Var("registers",F16)),
                                                  Close
                                                    (nVar"v",
                                                     MB(MB(MU(Bop(Lt,
                                                                  nVar"v",
                                                                  LN 1),
                                                              qTy),
                                                           Close
                                                             (bVar"b",
                                                              ITE(bVar"b",
                                                                  Call
                                                                    ("DECODE_UNPREDICTABLE",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[Var("mc",
                                                                            CTy"MachineCode"),
                                                                        LS
                                                                         "LoadMultiple"]),
                                                                  MU(LU,
                                                                     qTy)))),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Load",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("LoadMultiple",
                                                                    CTy"Load",
                                                                    TP[LT,
                                                                       LF,
                                                                       Mop(Not,
                                                                           Bop(Bit,
                                                                               Var("registers",
                                                                                   F16),
                                                                               Mop(Cast
                                                                                     nTy,
                                                                                   Var("Rn",
                                                                                       FTy 3)))),
                                                                       Mop(Cast
                                                                             F4,
                                                                           Var("Rn",
                                                                               FTy 3)),
                                                                       Var("registers",
                                                                           F16)])),
                                                              qTy)))))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU)))))))),
                      (Bop(And,bVar"b'14",
                           Bop(And,bVar"b'12",
                               Bop(And,bVar"b'11",
                                   Bop(And,bVar"b'10",
                                       Bop(And,bVar"b'9",
                                           Mop(Not,bVar"b'8")))))),
                       MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                          Close
                            (Var("v",F4),
                             MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                   Close
                                     (Var("v",PTy(F4,bTy)),
                                      Call
                                        ("Take",ATy(qTy,PTy(bTy,qTy)),
                                         Var("v",PTy(F4,bTy))))),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       MU(Call
                                            ("Undefined",CTy"instruction",
                                             Mop(Cast F32,
                                                 Mop(Cast F8,
                                                     LL[bVar"b'7",
                                                        bVar"b'6",
                                                        bVar"b'5",
                                                        bVar"b'4",
                                                        bVar"b'3",
                                                        bVar"b'2",
                                                        bVar"b'1",
                                                        bVar"b'0"]))),qTy),
                                       Call
                                         ("Skip",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU))))))),
                      (Bop(And,bVar"b'14",
                           Bop(And,bVar"b'12",
                               Bop(And,bVar"b'11",
                                   Bop(And,bVar"b'10",
                                       Bop(And,bVar"b'9",bVar"b'8"))))),
                       MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                          Close
                            (Var("v",F4),
                             MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                   Close
                                     (Var("v",PTy(F4,bTy)),
                                      Call
                                        ("Take",ATy(qTy,PTy(bTy,qTy)),
                                         Var("v",PTy(F4,bTy))))),
                                Close
                                  (bVar"b",
                                   ITE(bVar"b",
                                       MU(Call
                                            ("System",CTy"instruction",
                                             Call
                                               ("SupervisorCall",
                                                CTy"System",
                                                Mop(Cast F32,
                                                    Mop(Cast F8,
                                                        LL[bVar"b'7",
                                                           bVar"b'6",
                                                           bVar"b'5",
                                                           bVar"b'4",
                                                           bVar"b'3",
                                                           bVar"b'2",
                                                           bVar"b'1",
                                                           bVar"b'0"])))),
                                          qTy),
                                       Call
                                         ("Skip",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU))))))),
                      (Bop(And,bVar"b'14",bVar"b'12"),
                       MB(Call
                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                             TP[Mop(Cast F4,
                                    LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                       bVar"b'8"]),LT]),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MB(Call
                                      ("InITBlock",ATy(qTy,PTy(bTy,qTy)),
                                       LU),
                                    Close
                                      (bVar"v",
                                       MB(ITE(bVar"v",
                                              Call
                                                ("DECODE_UNPREDICTABLE",
                                                 ATy(qTy,PTy(uTy,qTy)),
                                                 TP[Var("mc",
                                                        CTy"MachineCode"),
                                                    LS"BranchTarget"]),
                                              MU(LU,qTy)),
                                          Close
                                            (AVar uTy,
                                             MU(Call
                                                  ("Branch",
                                                   CTy"instruction",
                                                   Call
                                                     ("BranchTarget",
                                                      CTy"Branch",
                                                      Mop(SE F32,
                                                          CC[Mop(Cast F8,
                                                                 LL[bVar"b'7",
                                                                    bVar"b'6",
                                                                    bVar"b'5",
                                                                    bVar"b'4",
                                                                    bVar"b'3",
                                                                    bVar"b'2",
                                                                    bVar"b'1",
                                                                    bVar"b'0"]),
                                                             LW(0,1)]))),
                                                qTy))))),
                                 Call
                                   ("Skip",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU)))))],
                     Call
                       ("UndefinedThumb",
                        ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                (Bop(And,Mop(Not,bVar"b'14"),
                     Bop(And,bVar"b'12",
                         Bop(And,bVar"b'11",Mop(Not,bVar"b'10")))),
                 MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                    Close
                      (Var("v",F4),
                       MB(MB(MU(TP[Var("v",F4),LT],qTy),
                             Close
                               (Var("v",PTy(F4,bTy)),
                                Call
                                  ("Take",ATy(qTy,PTy(bTy,qTy)),
                                   Var("v",PTy(F4,bTy))))),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MB(Call
                                      ("InITBlock",ATy(qTy,PTy(bTy,qTy)),
                                       LU),
                                    Close
                                      (bVar"v",
                                       MB(MU(Mop(Not,bVar"v"),qTy),
                                          Close
                                            (bVar"setflags",
                                             MU(Call
                                                  ("Data",
                                                   CTy"instruction",
                                                   Call
                                                     ("Register",
                                                      CTy"Data",
                                                      TP[ITE(EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'9"]),
                                                                LW(1,1)),
                                                             LW(2,4),
                                                             LW(4,4)),
                                                         bVar"setflags",
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'2",
                                                                    bVar"b'1",
                                                                    bVar"b'0"])),
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'5",
                                                                    bVar"b'4",
                                                                    bVar"b'3"])),
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'8",
                                                                    bVar"b'7",
                                                                    bVar"b'6"])),
                                                         LC("SRType_LSL",
                                                            CTy"SRType"),
                                                         LN 0])),qTy))))),
                                 Call
                                   ("Skip",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))))))),
                (Bop(And,Mop(Not,bVar"b'14"),
                     Bop(And,bVar"b'12",Bop(And,bVar"b'11",bVar"b'10"))),
                 MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                    Close
                      (Var("v",F4),
                       MB(MB(MU(TP[Var("v",F4),LT],qTy),
                             Close
                               (Var("v",PTy(F4,bTy)),
                                Call
                                  ("Take",ATy(qTy,PTy(bTy,qTy)),
                                   Var("v",PTy(F4,bTy))))),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MB(Call
                                      ("InITBlock",ATy(qTy,PTy(bTy,qTy)),
                                       LU),
                                    Close
                                      (bVar"v",
                                       MB(MU(Mop(Not,bVar"v"),qTy),
                                          Close
                                            (bVar"setflags",
                                             MU(Call
                                                  ("Data",
                                                   CTy"instruction",
                                                   Call
                                                     ("ArithLogicImmediate",
                                                      CTy"Data",
                                                      TP[ITE(EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'9"]),
                                                                LW(1,1)),
                                                             LW(2,4),
                                                             LW(4,4)),
                                                         bVar"setflags",
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'2",
                                                                    bVar"b'1",
                                                                    bVar"b'0"])),
                                                         Mop(Cast F4,
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'5",
                                                                    bVar"b'4",
                                                                    bVar"b'3"])),
                                                         Mop(Cast(FTy 12),
                                                             Mop(Cast
                                                                   (FTy 3),
                                                                 LL[bVar"b'8",
                                                                    bVar"b'7",
                                                                    bVar"b'6"]))])),
                                                qTy))))),
                                 Call
                                   ("Skip",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))))))),
                (Mop(Not,bVar"b'14"),
                 MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                    Close
                      (Var("v",F4),
                       MB(MB(MU(TP[Var("v",F4),LT],qTy),
                             Close
                               (Var("v",PTy(F4,bTy)),
                                Call
                                  ("Take",ATy(qTy,PTy(bTy,qTy)),
                                   Var("v",PTy(F4,bTy))))),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MB(Call
                                      ("InITBlock",ATy(qTy,PTy(bTy,qTy)),
                                       LU),
                                    Close
                                      (bVar"v",
                                       MB(MU(Mop(Not,bVar"v"),qTy),
                                          Close
                                            (bVar"setflags",
                                             MU(Let(TP[Var("shift_t",
                                                           CTy"SRType"),
                                                       nVar"shift_n"],
                                                    Call
                                                      ("DecodeImmShift",
                                                       PTy(CTy"SRType",nTy),
                                                       TP[Mop(Cast(FTy 2),
                                                              LL[bVar"b'12",
                                                                 bVar"b'11"]),
                                                          Mop(Cast(FTy 5),
                                                              LL[bVar"b'10",
                                                                 bVar"b'9",
                                                                 bVar"b'8",
                                                                 bVar"b'7",
                                                                 bVar"b'6"])]),
                                                    Call
                                                      ("Data",
                                                       CTy"instruction",
                                                       Call
                                                         ("ShiftImmediate",
                                                          CTy"Data",
                                                          TP[LF,
                                                             bVar"setflags",
                                                             Mop(Cast F4,
                                                                 Mop(Cast
                                                                       (FTy 3),
                                                                     LL[bVar"b'2",
                                                                        bVar"b'1",
                                                                        bVar"b'0"])),
                                                             Mop(Cast F4,
                                                                 Mop(Cast
                                                                       (FTy 3),
                                                                     LL[bVar"b'5",
                                                                        bVar"b'4",
                                                                        bVar"b'3"])),
                                                             Var("shift_t",
                                                                 CTy"SRType"),
                                                             nVar"shift_n"]))),
                                                qTy))))),
                                 Call
                                   ("Skip",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))))))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),
                         Bop(And,Mop(Not,bVar"b'11"),Mop(Not,bVar"b'10")))),
                 Let(Var("Ry",FTy 3),
                     Mop(Cast(FTy 3),LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                     Let(Var("Rx",FTy 3),
                         Mop(Cast(FTy 3),LL[bVar"b'5",bVar"b'4",bVar"b'3"]),
                         Let(Var("opc",F4),
                             Mop(Cast F4,
                                 LL[bVar"b'9",bVar"b'8",bVar"b'7",
                                    bVar"b'6"]),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             CS(Var("opc",F4),
                                                [(LW(0,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("Register",
                                                                           CTy"Data",
                                                                           TP[Var("opc",
                                                                                  F4),
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3)),
                                                                              LC("SRType_LSL",
                                                                                 CTy"SRType"),
                                                                              LN
                                                                               0])),
                                                                     qTy))))))),
                                                 (LW(1,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("Register",
                                                                           CTy"Data",
                                                                           TP[Var("opc",
                                                                                  F4),
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3)),
                                                                              LC("SRType_LSL",
                                                                                 CTy"SRType"),
                                                                              LN
                                                                               0])),
                                                                     qTy))))))),
                                                 (LW(5,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("Register",
                                                                           CTy"Data",
                                                                           TP[Var("opc",
                                                                                  F4),
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3)),
                                                                              LC("SRType_LSL",
                                                                                 CTy"SRType"),
                                                                              LN
                                                                               0])),
                                                                     qTy))))))),
                                                 (LW(6,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("Register",
                                                                           CTy"Data",
                                                                           TP[Var("opc",
                                                                                  F4),
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3)),
                                                                              LC("SRType_LSL",
                                                                                 CTy"SRType"),
                                                                              LN
                                                                               0])),
                                                                     qTy))))))),
                                                 (LW(12,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("Register",
                                                                           CTy"Data",
                                                                           TP[Var("opc",
                                                                                  F4),
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3)),
                                                                              LC("SRType_LSL",
                                                                                 CTy"SRType"),
                                                                              LN
                                                                               0])),
                                                                     qTy))))))),
                                                 (LW(14,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("Register",
                                                                           CTy"Data",
                                                                           TP[Var("opc",
                                                                                  F4),
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3)),
                                                                              LC("SRType_LSL",
                                                                                 CTy"SRType"),
                                                                              LN
                                                                               0])),
                                                                     qTy))))))),
                                                 (LW(2,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("ShiftRegister",
                                                                           CTy"Data",
                                                                           TP[LF,
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Call
                                                                                ("DecodeRegShift",
                                                                                 CTy"SRType",
                                                                                 Mop(Cast
                                                                                       (FTy 2),
                                                                                     Bop(Sub,
                                                                                         Var("opc",
                                                                                             F4),
                                                                                         LW(2,
                                                                                            4)))),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3))])),
                                                                     qTy))))))),
                                                 (LW(3,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("ShiftRegister",
                                                                           CTy"Data",
                                                                           TP[LF,
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Call
                                                                                ("DecodeRegShift",
                                                                                 CTy"SRType",
                                                                                 Mop(Cast
                                                                                       (FTy 2),
                                                                                     Bop(Sub,
                                                                                         Var("opc",
                                                                                             F4),
                                                                                         LW(2,
                                                                                            4)))),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3))])),
                                                                     qTy))))))),
                                                 (LW(4,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("ShiftRegister",
                                                                           CTy"Data",
                                                                           TP[LF,
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              Call
                                                                                ("DecodeRegShift",
                                                                                 CTy"SRType",
                                                                                 Mop(Cast
                                                                                       (FTy 2),
                                                                                     Bop(Sub,
                                                                                         Var("opc",
                                                                                             F4),
                                                                                         LW(2,
                                                                                            4)))),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3))])),
                                                                     qTy))))))),
                                                 (LW(7,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      MB(Call
                                                           ("InITBlock",
                                                            ATy(qTy,
                                                                PTy(bTy,
                                                                    qTy)),
                                                            LU),
                                                         Close
                                                           (bVar"v",
                                                            MB(MU(Mop(Not,
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"setflags",
                                                                  MU(Call
                                                                       ("Data",
                                                                        CTy"instruction",
                                                                        Call
                                                                          ("ShiftRegister",
                                                                           CTy"Data",
                                                                           TP[LF,
                                                                              bVar"setflags",
                                                                              Var("d",
                                                                                  F4),
                                                                              Var("d",
                                                                                  F4),
                                                                              LC("SRType_ROR",
                                                                                 CTy"SRType"),
                                                                              Mop(Cast
                                                                                    F4,
                                                                                  Var("Rx",
                                                                                      FTy 3))])),
                                                                     qTy))))))),
                                                 (LW(8,4),
                                                  MU(Call
                                                       ("Data",
                                                        CTy"instruction",
                                                        Call
                                                          ("TestCompareRegister",
                                                           CTy"Data",
                                                           TP[EX(Var("opc",
                                                                     F4),
                                                                 LN 1,
                                                                 LN 0,
                                                                 FTy 2),
                                                              Mop(Cast F4,
                                                                  Var("Ry",
                                                                      FTy 3)),
                                                              Mop(Cast F4,
                                                                  Var("Rx",
                                                                      FTy 3)),
                                                              LC("SRType_LSL",
                                                                 CTy"SRType"),
                                                              LN 0])),qTy)),
                                                 (LW(10,4),
                                                  MU(Call
                                                       ("Data",
                                                        CTy"instruction",
                                                        Call
                                                          ("TestCompareRegister",
                                                           CTy"Data",
                                                           TP[EX(Var("opc",
                                                                     F4),
                                                                 LN 1,
                                                                 LN 0,
                                                                 FTy 2),
                                                              Mop(Cast F4,
                                                                  Var("Ry",
                                                                      FTy 3)),
                                                              Mop(Cast F4,
                                                                  Var("Rx",
                                                                      FTy 3)),
                                                              LC("SRType_LSL",
                                                                 CTy"SRType"),
                                                              LN 0])),qTy)),
                                                 (LW(11,4),
                                                  MU(Call
                                                       ("Data",
                                                        CTy"instruction",
                                                        Call
                                                          ("TestCompareRegister",
                                                           CTy"Data",
                                                           TP[EX(Var("opc",
                                                                     F4),
                                                                 LN 1,
                                                                 LN 0,
                                                                 FTy 2),
                                                              Mop(Cast F4,
                                                                  Var("Ry",
                                                                      FTy 3)),
                                                              Mop(Cast F4,
                                                                  Var("Rx",
                                                                      FTy 3)),
                                                              LC("SRType_LSL",
                                                                 CTy"SRType"),
                                                              LN 0])),qTy)),
                                                 (LW(9,4),
                                                  MB(Call
                                                       ("InITBlock",
                                                        ATy(qTy,
                                                            PTy(bTy,qTy)),
                                                        LU),
                                                     Close
                                                       (bVar"v",
                                                        MB(MU(Mop(Not,
                                                                  bVar"v"),
                                                              qTy),
                                                           Close
                                                             (bVar"setflags",
                                                              MU(Call
                                                                   ("Data",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("ArithLogicImmediate",
                                                                       CTy"Data",
                                                                       TP[LW(3,
                                                                             4),
                                                                          bVar"setflags",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Ry",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rx",
                                                                                  FTy 3)),
                                                                          LW(0,
                                                                             12)])),
                                                                 qTy)))))),
                                                 (LW(13,4),
                                                  Let(Var("d",F4),
                                                      Mop(Cast F4,
                                                          Var("Ry",FTy 3)),
                                                      Let(Var("n",F4),
                                                          Mop(Cast F4,
                                                              Var("Rx",
                                                                  FTy 3)),
                                                          MB(Call
                                                               ("ArchVersion",
                                                                ATy(qTy,
                                                                    PTy(nTy,
                                                                        qTy)),
                                                                LU),
                                                             Close
                                                               (nVar"v",
                                                                MB(MB(MB(MU(Bop(Lt,
                                                                                nVar"v",
                                                                                LN
                                                                                 6),
                                                                            qTy),
                                                                         Close
                                                                           (bVar"b",
                                                                            MU(Bop(And,
                                                                                   bVar"b",
                                                                                   EQ(Var("d",
                                                                                          F4),
                                                                                      Var("n",
                                                                                          F4))),
                                                                               qTy))),
                                                                      Close
                                                                        (bVar"b",
                                                                         ITE(bVar"b",
                                                                             Call
                                                                               ("DECODE_UNPREDICTABLE",
                                                                                ATy(qTy,
                                                                                    PTy(uTy,
                                                                                        qTy)),
                                                                                TP[Var("mc",
                                                                                       CTy"MachineCode"),
                                                                                   LS
                                                                                    "Multiply"]),
                                                                             MU(LU,
                                                                                qTy)))),
                                                                   Close
                                                                     (AVar
                                                                        uTy,
                                                                      MB(Call
                                                                           ("InITBlock",
                                                                            ATy(qTy,
                                                                                PTy(bTy,
                                                                                    qTy)),
                                                                            LU),
                                                                         Close
                                                                           (bVar"v",
                                                                            MB(MU(Mop(Not,
                                                                                      bVar"v"),
                                                                                  qTy),
                                                                               Close
                                                                                 (bVar"setflags",
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Multiply32",
                                                                                           CTy"Multiply",
                                                                                           TP[bVar"setflags",
                                                                                              Var("d",
                                                                                                  F4),
                                                                                              Var("n",
                                                                                                  F4),
                                                                                              Var("d",
                                                                                                  F4)])),
                                                                                     qTy)))))))))))),
                                                 (LW(15,4),
                                                  MB(Call
                                                       ("InITBlock",
                                                        ATy(qTy,
                                                            PTy(bTy,qTy)),
                                                        LU),
                                                     Close
                                                       (bVar"v",
                                                        MB(MU(Mop(Not,
                                                                  bVar"v"),
                                                              qTy),
                                                           Close
                                                             (bVar"setflags",
                                                              MU(Call
                                                                   ("Data",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("ShiftImmediate",
                                                                       CTy"Data",
                                                                       TP[LT,
                                                                          bVar"setflags",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Ry",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rx",
                                                                                  FTy 3)),
                                                                          LC("SRType_LSL",
                                                                             CTy"SRType"),
                                                                          LN
                                                                           0])),
                                                                 qTy))))))]),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU)))))))))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),
                         Bop(And,Mop(Not,bVar"b'11"),
                             Bop(And,bVar"b'10",
                                 Bop(And,Mop(Not,bVar"b'9"),
                                     Mop(Not,bVar"b'8")))))),
                 Let(Var("Rm",F4),
                     Mop(Cast F4,
                         LL[bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3"]),
                     Let(Var("DN",F1),Mop(Cast F1,LL[bVar"b'7"]),
                         MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                            Close
                              (Var("v",F4),
                               MB(MB(MB(Call
                                          ("HaveThumb2",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v0",
                                           MB(MU(Bop(Or,
                                                     Bop(Or,
                                                         Mop(Msb,
                                                             Var("Rm",F4)),
                                                         EQ(Var("DN",F1),
                                                            LW(1,1))),
                                                     bVar"v0"),qTy),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))))),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         Let(Var("d",F4),
                                             CC[Var("DN",F1),
                                                Mop(Cast(FTy 3),
                                                    LL[bVar"b'2",
                                                       bVar"b'1",bVar"b'0"])],
                                             MB(Call
                                                  ("InITBlock",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(MB(MB(MU(Bop(And,
                                                                      EQ(Var("d",
                                                                             F4),
                                                                         LW(15,
                                                                            4)),
                                                                      bVar"v"),
                                                                  qTy),
                                                               Close
                                                                 (bVar"b",
                                                                  ITE(bVar"b",
                                                                      MB(Call
                                                                           ("LastInITBlock",
                                                                            ATy(qTy,
                                                                                PTy(bTy,
                                                                                    qTy)),
                                                                            LU),
                                                                         Close
                                                                           (bVar"v",
                                                                            MU(Mop(Not,
                                                                                   bVar"v"),
                                                                               qTy))),
                                                                      MU(LF,
                                                                         qTy)))),
                                                            Close
                                                              (bVar"v",
                                                               MU(Bop(Or,
                                                                      Bop(And,
                                                                          EQ(Var("d",
                                                                                 F4),
                                                                             LW(15,
                                                                                4)),
                                                                          EQ(Var("Rm",
                                                                                 F4),
                                                                             LW(15,
                                                                                4))),
                                                                      bVar"v"),
                                                                  qTy))),
                                                         Close
                                                           (bVar"b",
                                                            ITE(bVar"b",
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "ADD"]),
                                                                MU(LU,qTy)))),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("Data",
                                                               CTy"instruction",
                                                               Call
                                                                 ("Register",
                                                                  CTy"Data",
                                                                  TP[LW(4,
                                                                        4),
                                                                     LF,
                                                                     Var("d",
                                                                         F4),
                                                                     Var("d",
                                                                         F4),
                                                                     Var("Rm",
                                                                         F4),
                                                                     LC("SRType_LSL",
                                                                        CTy"SRType"),
                                                                     LN 0])),
                                                            qTy)))))),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),
                         Bop(And,Mop(Not,bVar"b'11"),
                             Bop(And,bVar"b'10",
                                 Bop(And,Mop(Not,bVar"b'9"),
                                     Bop(And,bVar"b'8",
                                         Bop(And,Mop(Not,bVar"b'7"),
                                             Mop(Not,bVar"b'6")))))))),
                 Call
                   ("raise'exception",ATy(qTy,PTy(CTy"instruction",qTy)),
                    Call
                      ("UNPREDICTABLE",CTy"exception",
                       LS"Thumb: 010001 0100 _"))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),
                         Bop(And,Mop(Not,bVar"b'11"),
                             Bop(And,bVar"b'10",
                                 Bop(And,Mop(Not,bVar"b'9"),bVar"b'8"))))),
                 Let(Var("Rm",F4),
                     Mop(Cast F4,
                         LL[bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3"]),
                     MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                        Close
                          (Var("v",F4),
                           MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                 Close
                                   (Var("v",PTy(F4,bTy)),
                                    Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       Var("v",PTy(F4,bTy))))),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     Let(Var("n",F4),
                                         CC[Mop(Cast F1,LL[bVar"b'7"]),
                                            Mop(Cast(FTy 3),
                                                LL[bVar"b'2",bVar"b'1",
                                                   bVar"b'0"])],
                                         MB(ITE(Bop(Or,
                                                    Bop(Or,
                                                        Bop(And,
                                                            Bop(Ult,
                                                                Var("n",F4),
                                                                LW(8,4)),
                                                            Bop(Ult,
                                                                Var("Rm",
                                                                    F4),
                                                                LW(8,4))),
                                                        EQ(Var("n",F4),
                                                           LW(15,4))),
                                                    EQ(Var("Rm",F4),
                                                       LW(15,4))),
                                                Call
                                                  ("DECODE_UNPREDICTABLE",
                                                   ATy(qTy,PTy(uTy,qTy)),
                                                   TP[Var("mc",
                                                          CTy"MachineCode"),
                                                      LS"CMP"]),MU(LU,qTy)),
                                            Close
                                              (AVar uTy,
                                               MU(Call
                                                    ("Data",
                                                     CTy"instruction",
                                                     Call
                                                       ("TestCompareRegister",
                                                        CTy"Data",
                                                        TP[LW(2,2),
                                                           Var("n",F4),
                                                           Var("Rm",F4),
                                                           LC("SRType_LSL",
                                                              CTy"SRType"),
                                                           LN 0])),qTy)))),
                                     Call
                                       ("Skip",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU)))))))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),
                         Bop(And,Mop(Not,bVar"b'11"),
                             Bop(And,bVar"b'10",
                                 Bop(And,bVar"b'9",Mop(Not,bVar"b'8")))))),
                 Let(Var("Rm",F4),
                     Mop(Cast F4,
                         LL[bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3"]),
                     Let(Var("D",F1),Mop(Cast F1,LL[bVar"b'7"]),
                         MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                            Close
                              (Var("v",F4),
                               MB(MB(MB(Call
                                          ("ArchVersion",
                                           ATy(qTy,PTy(nTy,qTy)),LU),
                                        Close
                                          (nVar"v0",
                                           MB(MB(MU(Bop(Ge,nVar"v0",LN 6),
                                                    qTy),
                                                 Close
                                                   (bVar"v",
                                                    MU(Bop(Or,
                                                           Bop(Or,
                                                               Mop(Msb,
                                                                   Var("Rm",
                                                                       F4)),
                                                               EQ(Var("D",
                                                                      F1),
                                                                  LW(1,1))),
                                                           bVar"v"),qTy))),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))))),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         Let(Var("d",F4),
                                             CC[Var("D",F1),
                                                Mop(Cast(FTy 3),
                                                    LL[bVar"b'2",
                                                       bVar"b'1",bVar"b'0"])],
                                             MB(Call
                                                  ("InITBlock",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v",
                                                   MB(MB(MB(MU(Bop(And,
                                                                   EQ(Var("d",
                                                                          F4),
                                                                      LW(15,
                                                                         4)),
                                                                   bVar"v"),
                                                               qTy),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(Call
                                                                        ("LastInITBlock",
                                                                         ATy(qTy,
                                                                             PTy(bTy,
                                                                                 qTy)),
                                                                         LU),
                                                                      Close
                                                                        (bVar"v",
                                                                         MU(Mop(Not,
                                                                                bVar"v"),
                                                                            qTy))),
                                                                   MU(LF,
                                                                      qTy)))),
                                                         Close
                                                           (bVar"b",
                                                            ITE(bVar"b",
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "MOV"]),
                                                                MU(LU,qTy)))),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("Data",
                                                               CTy"instruction",
                                                               Call
                                                                 ("ShiftImmediate",
                                                                  CTy"Data",
                                                                  TP[LF,
                                                                     LF,
                                                                     Var("d",
                                                                         F4),
                                                                     Var("Rm",
                                                                         F4),
                                                                     LC("SRType_LSL",
                                                                        CTy"SRType"),
                                                                     LN 0])),
                                                            qTy)))))),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),
                         Bop(And,Mop(Not,bVar"b'11"),
                             Bop(And,bVar"b'10",
                                 Bop(And,bVar"b'9",
                                     Bop(And,bVar"b'8",Mop(Not,bVar"b'7"))))))),
                 MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                    Close
                      (Var("v",F4),
                       MB(MB(MU(TP[Var("v",F4),LT],qTy),
                             Close
                               (Var("v",PTy(F4,bTy)),
                                Call
                                  ("Take",ATy(qTy,PTy(bTy,qTy)),
                                   Var("v",PTy(F4,bTy))))),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MB(Call
                                      ("InITBlock",ATy(qTy,PTy(bTy,qTy)),
                                       LU),
                                    Close
                                      (bVar"v",
                                       MB(MB(ITE(bVar"v",
                                                 MB(Call
                                                      ("LastInITBlock",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       LU),
                                                    Close
                                                      (bVar"v",
                                                       MU(Mop(Not,bVar"v"),
                                                          qTy))),
                                                 MU(LF,qTy)),
                                             Close
                                               (bVar"b",
                                                ITE(bVar"b",
                                                    Call
                                                      ("DECODE_UNPREDICTABLE",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("mc",
                                                              CTy"MachineCode"),
                                                          LS
                                                           "BranchExchange"]),
                                                    MU(LU,qTy)))),
                                          Close
                                            (AVar uTy,
                                             MU(Call
                                                  ("Branch",
                                                   CTy"instruction",
                                                   Call
                                                     ("BranchExchange",
                                                      CTy"Branch",
                                                      Mop(Cast F4,
                                                          LL[bVar"b'6",
                                                             bVar"b'5",
                                                             bVar"b'4",
                                                             bVar"b'3"]))),
                                                qTy))))),
                                 Call
                                   ("Skip",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))))))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),
                         Bop(And,Mop(Not,bVar"b'11"),
                             Bop(And,bVar"b'10",
                                 Bop(And,bVar"b'9",
                                     Bop(And,bVar"b'8",bVar"b'7")))))),
                 Let(Var("Rm",F4),
                     Mop(Cast F4,
                         LL[bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3"]),
                     MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                        Close
                          (Var("v",F4),
                           MB(MB(MB(Call
                                      ("ArchVersion",
                                       ATy(qTy,PTy(nTy,qTy)),LU),
                                    Close
                                      (nVar"v0",
                                       MB(MU(Bop(Ge,nVar"v0",LN 5),qTy),
                                          Close
                                            (bVar"v0",
                                             MU(TP[Var("v",F4),bVar"v0"],
                                                qTy))))),
                                 Close
                                   (Var("v",PTy(F4,bTy)),
                                    Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       Var("v",PTy(F4,bTy))))),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     MB(Call
                                          ("InITBlock",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(MB(ITE(bVar"v",
                                                        MB(Call
                                                             ("LastInITBlock",
                                                              ATy(qTy,
                                                                  PTy(bTy,
                                                                      qTy)),
                                                              LU),
                                                           Close
                                                             (bVar"v",
                                                              MU(Mop(Not,
                                                                     bVar"v"),
                                                                 qTy))),
                                                        MU(LF,qTy)),
                                                    Close
                                                      (bVar"v",
                                                       MU(Bop(Or,
                                                              EQ(Var("Rm",
                                                                     F4),
                                                                 LW(15,4)),
                                                              bVar"v"),qTy))),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "BranchLinkExchangeRegister"]),
                                                        MU(LU,qTy)))),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("Branch",
                                                       CTy"instruction",
                                                       Call
                                                         ("BranchLinkExchangeRegister",
                                                          CTy"Branch",
                                                          Var("Rm",F4))),
                                                    qTy))))),
                                     Call
                                       ("Skip",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU)))))))),
                (Bop(And,bVar"b'14",
                     Bop(And,Mop(Not,bVar"b'12"),bVar"b'11")),
                 MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                    Close
                      (Var("v",F4),
                       MB(MB(MU(TP[Var("v",F4),LT],qTy),
                             Close
                               (Var("v",PTy(F4,bTy)),
                                Call
                                  ("Take",ATy(qTy,PTy(bTy,qTy)),
                                   Var("v",PTy(F4,bTy))))),
                          Close
                            (bVar"b",
                             ITE(bVar"b",
                                 MU(Call
                                      ("Load",CTy"instruction",
                                       Call
                                         ("LoadLiteral",CTy"Load",
                                          TP[LT,
                                             Mop(Cast F4,
                                                 Mop(Cast(FTy 3),
                                                     LL[bVar"b'10",
                                                        bVar"b'9",
                                                        bVar"b'8"])),
                                             Mop(Cast F32,
                                                 CC[Mop(Cast F8,
                                                        LL[bVar"b'7",
                                                           bVar"b'6",
                                                           bVar"b'5",
                                                           bVar"b'4",
                                                           bVar"b'3",
                                                           bVar"b'2",
                                                           bVar"b'1",
                                                           bVar"b'0"]),
                                                    LW(0,2)])])),qTy),
                                 Call
                                   ("Skip",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))))))),
                (Bop(And,bVar"b'14",bVar"b'12"),
                 Let(Var("Rt",FTy 3),
                     Mop(Cast(FTy 3),LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                     Let(Var("Rn",FTy 3),
                         Mop(Cast(FTy 3),LL[bVar"b'5",bVar"b'4",bVar"b'3"]),
                         MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                            Close
                              (Var("v",F4),
                               MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Let(bVar"index",LT,
                                                Let(bVar"add",LT,
                                                    Let(bVar"wback",LF,
                                                        Let(Var("m",
                                                                CTy"offset1"),
                                                            Call
                                                              ("register_form1",
                                                               CTy"offset1",
                                                               TP[Mop(Cast
                                                                        F4,
                                                                      Mop(Cast
                                                                            (FTy 3),
                                                                          LL[bVar"b'8",
                                                                             bVar"b'7",
                                                                             bVar"b'6"])),
                                                                  LC("SRType_LSL",
                                                                     CTy"SRType"),
                                                                  LN 0]),
                                                            CS(Mop(Cast
                                                                     (FTy 3),
                                                                   LL[bVar"b'11",
                                                                      bVar"b'10",
                                                                      bVar"b'9"]),
                                                               [(LW(0,3),
                                                                 Call
                                                                   ("Store",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("StoreWord",
                                                                       CTy"Store",
                                                                       TP[bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")]))),
                                                                (LW(1,3),
                                                                 Call
                                                                   ("Store",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("StoreHalf",
                                                                       CTy"Store",
                                                                       TP[bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")]))),
                                                                (LW(2,3),
                                                                 Call
                                                                   ("Store",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("StoreByte",
                                                                       CTy"Store",
                                                                       TP[bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")]))),
                                                                (LW(3,3),
                                                                 Call
                                                                   ("Load",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("LoadByte",
                                                                       CTy"Load",
                                                                       TP[LF,
                                                                          bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")]))),
                                                                (LW(4,3),
                                                                 Call
                                                                   ("Load",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("LoadWord",
                                                                       CTy"Load",
                                                                       TP[bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")]))),
                                                                (LW(5,3),
                                                                 Call
                                                                   ("Load",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("LoadHalf",
                                                                       CTy"Load",
                                                                       TP[LT,
                                                                          bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")]))),
                                                                (LW(6,3),
                                                                 Call
                                                                   ("Load",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("LoadByte",
                                                                       CTy"Load",
                                                                       TP[LT,
                                                                          bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")]))),
                                                                (LW(7,3),
                                                                 Call
                                                                   ("Load",
                                                                    CTy"instruction",
                                                                    Call
                                                                      ("LoadHalf",
                                                                       CTy"Load",
                                                                       TP[LF,
                                                                          bVar"add",
                                                                          bVar"index",
                                                                          bVar"wback",
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rt",
                                                                                  FTy 3)),
                                                                          Mop(Cast
                                                                                F4,
                                                                              Var("Rn",
                                                                                  FTy 3)),
                                                                          Var("m",
                                                                              CTy"offset1")])))]))))),
                                            qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU)))))))))],
               Call
                 ("UndefinedThumb",ATy(qTy,PTy(CTy"instruction",qTy)),LU)))))
;
val DecodeThumbEE_def = Def
  ("DecodeThumbEE",Var("h",F16),
   Let(Var("mc",CTy"MachineCode"),
       Call("Thumb",CTy"MachineCode",Var("h",F16)),
       Let(TP[bVar"b'15",bVar"b'14",bVar"b'13",bVar"b'12",bVar"b'11",
              bVar"b'10",bVar"b'9",bVar"b'8",bVar"b'7",bVar"b'6",
              bVar"b'5",bVar"b'4",bVar"b'3",bVar"b'2",bVar"b'1",bVar"b'0"],
           BL(16,Var("h",F16)),
           ITE(Bop(And,bVar"b'14",Mop(Not,bVar"b'13")),
               ITB([(Bop(And,Mop(Not,bVar"b'15"),bVar"b'12"),
                     Let(Var("Rt",FTy 3),
                         Mop(Cast(FTy 3),LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                         Let(Var("Rn",FTy 3),
                             Mop(Cast(FTy 3),
                                 LL[bVar"b'5",bVar"b'4",bVar"b'3"]),
                             MB(Call
                                  ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),
                                   LU),
                                Close
                                  (Var("v",F4),
                                   MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                         Close
                                           (Var("v",PTy(F4,bTy)),
                                            Call
                                              ("Take",
                                               ATy(qTy,PTy(bTy,qTy)),
                                               Var("v",PTy(F4,bTy))))),
                                      Close
                                        (bVar"b",
                                         ITE(bVar"b",
                                             Let(bVar"index",LT,
                                                 Let(bVar"add",LT,
                                                     Let(bVar"wback",LF,
                                                         Let(Var("m",F4),
                                                             Mop(Cast F4,
                                                                 Mop(Cast
                                                                       (FTy 3),
                                                                     LL[bVar"b'8",
                                                                        bVar"b'7",
                                                                        bVar"b'6"])),
                                                             Let(Var("m1",
                                                                     CTy"offset1"),
                                                                 Call
                                                                   ("register_form1",
                                                                    CTy"offset1",
                                                                    TP[Var("m",
                                                                           F4),
                                                                       LC("SRType_LSL",
                                                                          CTy"SRType"),
                                                                       LN
                                                                        1]),
                                                                 Let(Var("m2",
                                                                         CTy"offset1"),
                                                                     Call
                                                                       ("register_form1",
                                                                        CTy"offset1",
                                                                        TP[Var("m",
                                                                               F4),
                                                                           LC("SRType_LSL",
                                                                              CTy"SRType"),
                                                                           LN
                                                                            2]),
                                                                     CS(Mop(Cast
                                                                              (FTy 3),
                                                                            LL[bVar"b'11",
                                                                               bVar"b'10",
                                                                               bVar"b'9"]),
                                                                        [(LW(0,
                                                                             3),
                                                                          MU(Call
                                                                               ("Store",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("StoreWord",
                                                                                   CTy"Store",
                                                                                   TP[bVar"add",
                                                                                      bVar"index",
                                                                                      bVar"wback",
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rt",
                                                                                              FTy 3)),
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rn",
                                                                                              FTy 3)),
                                                                                      Var("m2",
                                                                                          CTy"offset1")])),
                                                                             qTy)),
                                                                         (LW(1,
                                                                             3),
                                                                          MU(Call
                                                                               ("Store",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("StoreHalf",
                                                                                   CTy"Store",
                                                                                   TP[bVar"add",
                                                                                      bVar"index",
                                                                                      bVar"wback",
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rt",
                                                                                              FTy 3)),
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rn",
                                                                                              FTy 3)),
                                                                                      Var("m1",
                                                                                          CTy"offset1")])),
                                                                             qTy)),
                                                                         (LW(4,
                                                                             3),
                                                                          MU(Call
                                                                               ("Load",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("LoadWord",
                                                                                   CTy"Load",
                                                                                   TP[bVar"add",
                                                                                      bVar"index",
                                                                                      bVar"wback",
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rt",
                                                                                              FTy 3)),
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rn",
                                                                                              FTy 3)),
                                                                                      Var("m2",
                                                                                          CTy"offset1")])),
                                                                             qTy)),
                                                                         (LW(5,
                                                                             3),
                                                                          MU(Call
                                                                               ("Load",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("LoadHalf",
                                                                                   CTy"Load",
                                                                                   TP[LT,
                                                                                      bVar"add",
                                                                                      bVar"index",
                                                                                      bVar"wback",
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rt",
                                                                                              FTy 3)),
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rn",
                                                                                              FTy 3)),
                                                                                      Var("m1",
                                                                                          CTy"offset1")])),
                                                                             qTy)),
                                                                         (LW(7,
                                                                             3),
                                                                          MU(Call
                                                                               ("Load",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("LoadHalf",
                                                                                   CTy"Load",
                                                                                   TP[LF,
                                                                                      bVar"add",
                                                                                      bVar"index",
                                                                                      bVar"wback",
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rt",
                                                                                              FTy 3)),
                                                                                      Mop(Cast
                                                                                            F4,
                                                                                          Var("Rn",
                                                                                              FTy 3)),
                                                                                      Var("m1",
                                                                                          CTy"offset1")])),
                                                                             qTy)),
                                                                         (AVar
                                                                            (FTy 3),
                                                                          Call
                                                                            ("DecodeThumb",
                                                                             ATy(qTy,
                                                                                 PTy(CTy"instruction",
                                                                                     qTy)),
                                                                             Var("h",
                                                                                 F16)))]))))))),
                                             Call
                                               ("Skip",
                                                ATy(qTy,
                                                    PTy(CTy"instruction",
                                                        qTy)),LU))))))))),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,Mop(Not,bVar"b'11"),
                                 Bop(And,Mop(Not,bVar"b'10"),
                                     Bop(And,Mop(Not,bVar"b'9"),
                                         Mop(Not,bVar"b'8")))))),
                     MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                        Close
                          (Var("v",F4),
                           MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                 Close
                                   (Var("v",PTy(F4,bTy)),
                                    Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       Var("v",PTy(F4,bTy))))),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     MB(Call
                                          ("InITBlock",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(ITE(bVar"v",
                                                     MB(Call
                                                          ("LastInITBlock",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v",
                                                           MU(Mop(Not,
                                                                  bVar"v"),
                                                              qTy))),
                                                     MU(LF,qTy)),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "HandlerBranchParameter"]),
                                                        MU(LU,qTy)))),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("Branch",
                                                       CTy"instruction",
                                                       Call
                                                         ("HandlerBranchParameter",
                                                          CTy"Branch",
                                                          TP[Mop(Cast F32,
                                                                 Mop(Cast
                                                                       (FTy 3),
                                                                     LL[bVar"b'7",
                                                                        bVar"b'6",
                                                                        bVar"b'5"])),
                                                             Mop(Cast F32,
                                                                 CC[Mop(Cast
                                                                          (FTy 5),
                                                                        LL[bVar"b'4",
                                                                           bVar"b'3",
                                                                           bVar"b'2",
                                                                           bVar"b'1",
                                                                           bVar"b'0"]),
                                                                    LW(0,5)])])),
                                                    qTy))))),
                                     Call
                                       ("Skip",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU))))))),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,Mop(Not,bVar"b'11"),
                                 Bop(And,Mop(Not,bVar"b'10"),
                                     Bop(And,Mop(Not,bVar"b'9"),bVar"b'8"))))),
                     MU(Call("Undefined",CTy"instruction",LW(0,32)),qTy)),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,Mop(Not,bVar"b'11"),
                                 Bop(And,Mop(Not,bVar"b'10"),bVar"b'9")))),
                     MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                        Close
                          (Var("v",F4),
                           MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                 Close
                                   (Var("v",PTy(F4,bTy)),
                                    Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       Var("v",PTy(F4,bTy))))),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     MB(Call
                                          ("InITBlock",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(ITE(bVar"v",
                                                     MB(Call
                                                          ("LastInITBlock",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v",
                                                           MU(Mop(Not,
                                                                  bVar"v"),
                                                              qTy))),
                                                     MU(LF,qTy)),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "HandlerBranchLink"]),
                                                        MU(LU,qTy)))),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("Branch",
                                                       CTy"instruction",
                                                       Call
                                                         ("HandlerBranchLink",
                                                          CTy"Branch",
                                                          TP[EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'8"]),
                                                                LW(1,1)),
                                                             Mop(Cast F32,
                                                                 CC[Mop(Cast
                                                                          F8,
                                                                        LL[bVar"b'7",
                                                                           bVar"b'6",
                                                                           bVar"b'5",
                                                                           bVar"b'4",
                                                                           bVar"b'3",
                                                                           bVar"b'2",
                                                                           bVar"b'1",
                                                                           bVar"b'0"]),
                                                                    LW(0,5)])])),
                                                    qTy))))),
                                     Call
                                       ("Skip",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU))))))),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,Mop(Not,bVar"b'11"),bVar"b'10"))),
                     MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                        Close
                          (Var("v",F4),
                           MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                 Close
                                   (Var("v",PTy(F4,bTy)),
                                    Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       Var("v",PTy(F4,bTy))))),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     MB(Call
                                          ("InITBlock",
                                           ATy(qTy,PTy(bTy,qTy)),LU),
                                        Close
                                          (bVar"v",
                                           MB(MB(ITE(bVar"v",
                                                     MB(Call
                                                          ("LastInITBlock",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v",
                                                           MU(Mop(Not,
                                                                  bVar"v"),
                                                              qTy))),
                                                     MU(LF,qTy)),
                                                 Close
                                                   (bVar"b",
                                                    ITE(bVar"b",
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "HandlerBranchLinkParameter"]),
                                                        MU(LU,qTy)))),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("Branch",
                                                       CTy"instruction",
                                                       Call
                                                         ("HandlerBranchLinkParameter",
                                                          CTy"Branch",
                                                          TP[Mop(Cast F32,
                                                                 Mop(Cast
                                                                       (FTy 5),
                                                                     LL[bVar"b'9",
                                                                        bVar"b'8",
                                                                        bVar"b'7",
                                                                        bVar"b'6",
                                                                        bVar"b'5"])),
                                                             Mop(Cast F32,
                                                                 CC[Mop(Cast
                                                                          (FTy 5),
                                                                        LL[bVar"b'4",
                                                                           bVar"b'3",
                                                                           bVar"b'2",
                                                                           bVar"b'1",
                                                                           bVar"b'0"]),
                                                                    LW(0,5)])])),
                                                    qTy))))),
                                     Call
                                       ("Skip",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU))))))),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,bVar"b'11",
                                 Bop(And,Mop(Not,bVar"b'10"),
                                     Mop(Not,bVar"b'9"))))),
                     MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                        Close
                          (Var("v",F4),
                           MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                 Close
                                   (Var("v",PTy(F4,bTy)),
                                    Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       Var("v",PTy(F4,bTy))))),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     MU(Call
                                          ("Load",CTy"instruction",
                                           Call
                                             ("LoadWord",CTy"Load",
                                              TP[LF,LT,LF,
                                                 Mop(Cast F4,
                                                     Mop(Cast(FTy 3),
                                                         LL[bVar"b'2",
                                                            bVar"b'1",
                                                            bVar"b'0"])),
                                                 Mop(Cast F4,
                                                     Mop(Cast(FTy 3),
                                                         LL[bVar"b'5",
                                                            bVar"b'4",
                                                            bVar"b'3"])),
                                                 Call
                                                   ("immediate_form1",
                                                    CTy"offset1",
                                                    Mop(Cast F32,
                                                        CC[Mop(Cast(FTy 3),
                                                               LL[bVar"b'8",
                                                                  bVar"b'7",
                                                                  bVar"b'6"]),
                                                           LW(0,2)]))])),
                                        qTy),
                                     Call
                                       ("Skip",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU))))))),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,bVar"b'11",
                                 Bop(And,Mop(Not,bVar"b'10"),
                                     Bop(And,bVar"b'9",Mop(Not,bVar"b'8")))))),
                     Let(Var("Rm",F4),
                         Mop(Cast F4,
                             LL[bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3"]),
                         MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                            Close
                              (Var("v",F4),
                               MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         Let(Var("n",F4),
                                             CC[Mop(Cast F1,LL[bVar"b'7"]),
                                                Mop(Cast(FTy 3),
                                                    LL[bVar"b'2",
                                                       bVar"b'1",bVar"b'0"])],
                                             MB(ITE(Bop(Or,
                                                        EQ(Var("n",F4),
                                                           LW(15,4)),
                                                        Bop(In,
                                                            Var("Rm",F4),
                                                            SL[LW(13,4),
                                                               LW(15,4)])),
                                                    Call
                                                      ("DECODE_UNPREDICTABLE",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       TP[Var("mc",
                                                              CTy"MachineCode"),
                                                          LS"CheckArray"]),
                                                    MU(LU,qTy)),
                                                Close
                                                  (AVar uTy,
                                                   MU(Call
                                                        ("Branch",
                                                         CTy"instruction",
                                                         Call
                                                           ("CheckArray",
                                                            CTy"Branch",
                                                            TP[Var("Rm",F4),
                                                               Var("n",F4)])),
                                                      qTy)))),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU)))))))),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,bVar"b'11",
                                 Bop(And,Mop(Not,bVar"b'10"),
                                     Bop(And,bVar"b'9",bVar"b'8"))))),
                     MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                        Close
                          (Var("v",F4),
                           MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                 Close
                                   (Var("v",PTy(F4,bTy)),
                                    Call
                                      ("Take",ATy(qTy,PTy(bTy,qTy)),
                                       Var("v",PTy(F4,bTy))))),
                              Close
                                (bVar"b",
                                 ITE(bVar"b",
                                     MU(Call
                                          ("Load",CTy"instruction",
                                           Call
                                             ("LoadWord",CTy"Load",
                                              TP[LT,LT,LF,
                                                 Mop(Cast F4,
                                                     Mop(Cast(FTy 3),
                                                         LL[bVar"b'2",
                                                            bVar"b'1",
                                                            bVar"b'0"])),
                                                 LW(10,4),
                                                 Call
                                                   ("immediate_form1",
                                                    CTy"offset1",
                                                    Mop(Cast F32,
                                                        CC[Mop(Cast(FTy 5),
                                                               LL[bVar"b'7",
                                                                  bVar"b'6",
                                                                  bVar"b'5",
                                                                  bVar"b'4",
                                                                  bVar"b'3"]),
                                                           LW(0,2)]))])),
                                        qTy),
                                     Call
                                       ("Skip",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU))))))),
                    (Bop(And,bVar"b'15",
                         Bop(And,Mop(Not,bVar"b'12"),
                             Bop(And,bVar"b'11",bVar"b'10"))),
                     Let(Var("Rt",FTy 3),
                         Mop(Cast(FTy 3),LL[bVar"b'2",bVar"b'1",bVar"b'0"]),
                         MB(Call("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                            Close
                              (Var("v",F4),
                               MB(MB(MU(TP[Var("v",F4),LT],qTy),
                                     Close
                                       (Var("v",PTy(F4,bTy)),
                                        Call
                                          ("Take",ATy(qTy,PTy(bTy,qTy)),
                                           Var("v",PTy(F4,bTy))))),
                                  Close
                                    (bVar"b",
                                     ITE(bVar"b",
                                         MU(Let(bVar"index",LT,
                                                Let(bVar"add",LT,
                                                    Let(bVar"wback",LF,
                                                        Let(Var("m",
                                                                CTy"offset1"),
                                                            Call
                                                              ("immediate_form1",
                                                               CTy"offset1",
                                                               Mop(Cast
                                                                     F32,
                                                                   CC[Mop(Cast
                                                                            (FTy 6),
                                                                          LL[bVar"b'8",
                                                                             bVar"b'7",
                                                                             bVar"b'6",
                                                                             bVar"b'5",
                                                                             bVar"b'4",
                                                                             bVar"b'3"]),
                                                                      LW(0,
                                                                         2)])),
                                                            ITE(EQ(Mop(Cast
                                                                         F1,
                                                                       LL[bVar"b'9"]),
                                                                   LW(1,1)),
                                                                Call
                                                                  ("Store",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("StoreWord",
                                                                      CTy"Store",
                                                                      TP[bVar"add",
                                                                         bVar"index",
                                                                         bVar"wback",
                                                                         Mop(Cast
                                                                               F4,
                                                                             Var("Rt",
                                                                                 FTy 3)),
                                                                         LW(9,
                                                                            4),
                                                                         Var("m",
                                                                             CTy"offset1")])),
                                                                Call
                                                                  ("Load",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("LoadWord",
                                                                      CTy"Load",
                                                                      TP[bVar"add",
                                                                         bVar"index",
                                                                         bVar"wback",
                                                                         Mop(Cast
                                                                               F4,
                                                                             Var("Rt",
                                                                                 FTy 3)),
                                                                         LW(9,
                                                                            4),
                                                                         Var("m",
                                                                             CTy"offset1")]))))))),
                                            qTy),
                                         Call
                                           ("Skip",
                                            ATy(qTy,
                                                PTy(CTy"instruction",qTy)),
                                            LU))))))))],
                   Call
                     ("DecodeThumb",ATy(qTy,PTy(CTy"instruction",qTy)),
                      Mop(Cast F16,
                          LL[bVar"b'15",bVar"b'14",bVar"b'13",bVar"b'12",
                             bVar"b'11",bVar"b'10",bVar"b'9",bVar"b'8",
                             bVar"b'7",bVar"b'6",bVar"b'5",bVar"b'4",
                             bVar"b'3",bVar"b'2",bVar"b'1",bVar"b'0"]))),
               Call
                 ("DecodeThumb",ATy(qTy,PTy(CTy"instruction",qTy)),
                  Mop(Cast F16,
                      LL[bVar"b'15",bVar"b'14",bVar"b'13",bVar"b'12",
                         bVar"b'11",bVar"b'10",bVar"b'9",bVar"b'8",
                         bVar"b'7",bVar"b'6",bVar"b'5",bVar"b'4",
                         bVar"b'3",bVar"b'2",bVar"b'1",bVar"b'0"]))))))
;
val DecodeThumb2_def = Def
  ("DecodeThumb2",Var("h",PTy(F16,F16)),
   Let(Var("mc",CTy"MachineCode"),
       Call("Thumb2",CTy"MachineCode",Var("h",PTy(F16,F16))),
       Let(TP[TP[bVar"b'31",bVar"b'30",bVar"b'29",bVar"b'28",bVar"b'27",
                 bVar"b'26",bVar"b'25",bVar"b'24",bVar"b'23",bVar"b'22",
                 bVar"b'21",bVar"b'20",bVar"b'19",bVar"b'18",bVar"b'17",
                 bVar"b'16"],bVar"b'15",bVar"b'14",bVar"b'13",bVar"b'12",
              bVar"b'11",bVar"b'10",bVar"b'9",bVar"b'8",bVar"b'7",
              bVar"b'6",bVar"b'5",bVar"b'4",bVar"b'3",bVar"b'2",bVar"b'1",
              bVar"b'0"],
           TP[BL(16,Mop(Fst,Var("h",PTy(F16,F16)))),
              BL(16,Mop(Snd,Var("h",PTy(F16,F16))))],
           ITB([(bVar"b'27",
                 ITB([(bVar"b'28",
                       ITB([(bVar"b'25",
                             ITE(Bop(And,bVar"b'31",
                                     Bop(And,bVar"b'30",
                                         Bop(And,bVar"b'29",
                                             Mop(Not,bVar"b'26")))),
                                 ITB([(Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,bVar"b'15",
                                                   Bop(And,bVar"b'14",
                                                       Bop(And,bVar"b'13",
                                                           Bop(And,
                                                               bVar"b'12",
                                                               Bop(And,
                                                                   Mop(Not,
                                                                       bVar"b'7"),
                                                                   Bop(And,
                                                                       Mop(Not,
                                                                           bVar"b'6"),
                                                                       Bop(And,
                                                                           Mop(Not,
                                                                               bVar"b'5"),
                                                                           Mop(Not,
                                                                               bVar"b'4")))))))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rd",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(ITE(Bop(Or,
                                                                              Bop(Or,
                                                                                  Bop(In,
                                                                                      Var("Rd",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)]),
                                                                                  Bop(In,
                                                                                      Var("Rn",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)])),
                                                                              Bop(In,
                                                                                  Var("Rm",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "Shift (register)"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Call
                                                                              ("Data",
                                                                               CTy"instruction",
                                                                               Call
                                                                                 ("ShiftRegister",
                                                                                  CTy"Data",
                                                                                  TP[LF,
                                                                                     EQ(Mop(Cast
                                                                                              F1,
                                                                                            LL[bVar"b'20"]),
                                                                                        LW(1,
                                                                                           1)),
                                                                                     Var("Rd",
                                                                                         F4),
                                                                                     Var("Rn",
                                                                                         F4),
                                                                                     Call
                                                                                       ("DecodeRegShift",
                                                                                        CTy"SRType",
                                                                                        Mop(Cast
                                                                                              (FTy 2),
                                                                                            LL[bVar"b'22",
                                                                                               bVar"b'21"])),
                                                                                     Var("Rm",
                                                                                         F4)])),
                                                                            qTy))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,bVar"b'15",
                                                   Bop(And,bVar"b'14",
                                                       Bop(And,bVar"b'13",
                                                           Bop(And,
                                                               bVar"b'12",
                                                               bVar"b'7")))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rd",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(ITE(Bop(Or,
                                                                              Bop(Or,
                                                                                  Bop(In,
                                                                                      Var("Rd",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)]),
                                                                                  EQ(Var("Rn",
                                                                                         F4),
                                                                                     LW(13,
                                                                                        4))),
                                                                              Bop(In,
                                                                                  Var("Rm",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "Extend (register)"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Let(Var("args",
                                                                                    PTy(bTy,
                                                                                        PTy(F4,
                                                                                            PTy(F4,
                                                                                                PTy(F4,
                                                                                                    nTy))))),
                                                                                TP[EQ(Mop(Cast
                                                                                            F1,
                                                                                          LL[bVar"b'20"]),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   Var("Rd",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Var("Rm",
                                                                                       F4),
                                                                                   Mop(Cast
                                                                                         nTy,
                                                                                       CC[Mop(Cast
                                                                                                (FTy 2),
                                                                                              LL[bVar"b'5",
                                                                                                 bVar"b'4"]),
                                                                                          LW(0,
                                                                                             3)])],
                                                                                CS(Mop(Cast
                                                                                         (FTy 2),
                                                                                       LL[bVar"b'22",
                                                                                          bVar"b'21"]),
                                                                                   [(LW(0,
                                                                                        2),
                                                                                     Call
                                                                                       ("Media",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ExtendHalfword",
                                                                                           CTy"Media",
                                                                                           Var("args",
                                                                                               PTy(bTy,
                                                                                                   PTy(F4,
                                                                                                       PTy(F4,
                                                                                                           PTy(F4,
                                                                                                               nTy)))))))),
                                                                                    (LW(1,
                                                                                        2),
                                                                                     Call
                                                                                       ("Media",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ExtendByte16",
                                                                                           CTy"Media",
                                                                                           Var("args",
                                                                                               PTy(bTy,
                                                                                                   PTy(F4,
                                                                                                       PTy(F4,
                                                                                                           PTy(F4,
                                                                                                               nTy)))))))),
                                                                                    (LW(2,
                                                                                        2),
                                                                                     Call
                                                                                       ("Media",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ExtendByte",
                                                                                           CTy"Media",
                                                                                           Var("args",
                                                                                               PTy(bTy,
                                                                                                   PTy(F4,
                                                                                                       PTy(F4,
                                                                                                           PTy(F4,
                                                                                                               nTy)))))))),
                                                                                    (LW(3,
                                                                                        2),
                                                                                     Call
                                                                                       ("Undefined",
                                                                                        CTy"instruction",
                                                                                        LW(0,
                                                                                           32)))])),
                                                                            qTy))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'23",
                                               Bop(And,bVar"b'15",
                                                   Bop(And,bVar"b'14",
                                                       Bop(And,bVar"b'13",
                                                           Bop(And,
                                                               bVar"b'12",
                                                               Mop(Not,
                                                                   bVar"b'7"))))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rd",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(ITE(Bop(Or,
                                                                              Bop(Or,
                                                                                  Bop(In,
                                                                                      Var("Rd",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)]),
                                                                                  Bop(In,
                                                                                      Var("Rn",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)])),
                                                                              Bop(In,
                                                                                  Var("Rm",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "Parallel addition and subtraction"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (uVar"_0",
                                                                         MU(Call
                                                                              ("DecodeParallelAdditionSubtraction",
                                                                               CTy"instruction",
                                                                               TP[Bop(Add,
                                                                                      Mop(Cast
                                                                                            (FTy 2),
                                                                                          LL[bVar"b'5",
                                                                                             bVar"b'4"]),
                                                                                      LW(1,
                                                                                         2)),
                                                                                  CS(Mop(Cast
                                                                                           (FTy 3),
                                                                                         LL[bVar"b'22",
                                                                                            bVar"b'21",
                                                                                            bVar"b'20"]),
                                                                                     [(LW(1,
                                                                                          3),
                                                                                       LW(0,
                                                                                          3)),
                                                                                      (LW(2,
                                                                                          3),
                                                                                       LW(1,
                                                                                          3)),
                                                                                      (LW(6,
                                                                                          3),
                                                                                       LW(2,
                                                                                          3)),
                                                                                      (LW(5,
                                                                                          3),
                                                                                       LW(3,
                                                                                          3)),
                                                                                      (LW(0,
                                                                                          3),
                                                                                       LW(4,
                                                                                          3)),
                                                                                      (LW(4,
                                                                                          3),
                                                                                       LW(7,
                                                                                          3)),
                                                                                      (AVar
                                                                                         (FTy 3),
                                                                                       LW(5,
                                                                                          3))]),
                                                                                  Mop(Cast
                                                                                        F1,
                                                                                      LL[bVar"b'6"]),
                                                                                  Var("Rd",
                                                                                      F4),
                                                                                  Var("Rn",
                                                                                      F4),
                                                                                  Var("Rm",
                                                                                      F4)]),
                                                                            qTy))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'23",
                                               Bop(And,
                                                   Mop(Not,bVar"b'22"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'21"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'20"),
                                                           Bop(And,
                                                               bVar"b'15",
                                                               Bop(And,
                                                                   bVar"b'14",
                                                                   Bop(And,
                                                                       bVar"b'13",
                                                                       Bop(And,
                                                                           bVar"b'12",
                                                                           Bop(And,
                                                                               bVar"b'7",
                                                                               Mop(Not,
                                                                                   bVar"b'6"))))))))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rd",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(ITE(Bop(Or,
                                                                              Bop(Or,
                                                                                  Bop(In,
                                                                                      Var("Rd",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)]),
                                                                                  Bop(In,
                                                                                      Var("Rn",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)])),
                                                                              Bop(In,
                                                                                  Var("Rm",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "SaturatingAddSubtract"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Call
                                                                              ("Media",
                                                                               CTy"instruction",
                                                                               Call
                                                                                 ("SaturatingAddSubtract",
                                                                                  CTy"Media",
                                                                                  TP[Mop(Rev,
                                                                                         Mop(Cast
                                                                                               (FTy 2),
                                                                                             LL[bVar"b'5",
                                                                                                bVar"b'4"])),
                                                                                     Var("Rd",
                                                                                         F4),
                                                                                     Var("Rm",
                                                                                         F4),
                                                                                     Var("Rn",
                                                                                         F4)])),
                                                                            qTy))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'23",
                                               Bop(And,
                                                   Mop(Not,bVar"b'22"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'21"),
                                                       Bop(And,bVar"b'20",
                                                           Bop(And,
                                                               bVar"b'15",
                                                               Bop(And,
                                                                   bVar"b'14",
                                                                   Bop(And,
                                                                       bVar"b'13",
                                                                       Bop(And,
                                                                           bVar"b'12",
                                                                           Bop(And,
                                                                               bVar"b'7",
                                                                               Mop(Not,
                                                                                   bVar"b'6"))))))))))),
                                       Let(Var("Rm",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'3",bVar"b'2",
                                                  bVar"b'1",bVar"b'0"]),
                                           Let(Var("Rd",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'11",
                                                      bVar"b'10",
                                                      bVar"b'9",bVar"b'8"]),
                                               MB(Call
                                                    ("ThumbCondition",
                                                     ATy(qTy,PTy(F4,qTy)),
                                                     LU),
                                                  Close
                                                    (Var("v",F4),
                                                     MB(MB(MB(Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F4,
                                                                      bTy)),
                                                              Call
                                                                ("Take",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F4,
                                                                         bTy))))),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(ITE(Bop(Or,
                                                                          Bop(Or,
                                                                              Mop(Not,
                                                                                  EQ(Mop(Cast
                                                                                           F4,
                                                                                         LL[bVar"b'19",
                                                                                            bVar"b'18",
                                                                                            bVar"b'17",
                                                                                            bVar"b'16"]),
                                                                                     Var("Rm",
                                                                                         F4))),
                                                                              Bop(In,
                                                                                  Var("Rd",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Bop(In,
                                                                              Var("Rm",
                                                                                  F4),
                                                                              SL[LW(13,
                                                                                    4),
                                                                                 LW(15,
                                                                                    4)])),
                                                                      Call
                                                                        ("DECODE_UNPREDICTABLE",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[Var("mc",
                                                                                CTy"MachineCode"),
                                                                            LS
                                                                             "Reverses"]),
                                                                      MU(LU,
                                                                         qTy)),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(CS(Mop(Cast
                                                                                 (FTy 2),
                                                                               LL[bVar"b'5",
                                                                                  bVar"b'4"]),
                                                                           [(LW(0,
                                                                                2),
                                                                             Call
                                                                               ("Media",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("ByteReverse",
                                                                                   CTy"Media",
                                                                                   TP[Var("Rd",
                                                                                          F4),
                                                                                      Var("Rm",
                                                                                          F4)]))),
                                                                            (LW(1,
                                                                                2),
                                                                             Call
                                                                               ("Media",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("ByteReversePackedHalfword",
                                                                                   CTy"Media",
                                                                                   TP[Var("Rd",
                                                                                          F4),
                                                                                      Var("Rm",
                                                                                          F4)]))),
                                                                            (LW(2,
                                                                                2),
                                                                             Call
                                                                               ("Media",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("ReverseBits",
                                                                                   CTy"Media",
                                                                                   TP[Var("Rd",
                                                                                          F4),
                                                                                      Var("Rm",
                                                                                          F4)]))),
                                                                            (LW(3,
                                                                                2),
                                                                             Call
                                                                               ("Media",
                                                                                CTy"instruction",
                                                                                Call
                                                                                  ("ByteReverseSignedHalfword",
                                                                                   CTy"Media",
                                                                                   TP[Var("Rd",
                                                                                          F4),
                                                                                      Var("Rm",
                                                                                          F4)])))]),
                                                                        qTy))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'23",
                                               Bop(And,
                                                   Mop(Not,bVar"b'22"),
                                                   Bop(And,bVar"b'21",
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'20"),
                                                           Bop(And,
                                                               bVar"b'15",
                                                               Bop(And,
                                                                   bVar"b'14",
                                                                   Bop(And,
                                                                       bVar"b'13",
                                                                       Bop(And,
                                                                           bVar"b'12",
                                                                           Bop(And,
                                                                               bVar"b'7",
                                                                               Bop(And,
                                                                                   Mop(Not,
                                                                                       bVar"b'6"),
                                                                                   Bop(And,
                                                                                       Mop(Not,
                                                                                           bVar"b'5"),
                                                                                       Mop(Not,
                                                                                           bVar"b'4"))))))))))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rd",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(ITE(Bop(Or,
                                                                              Bop(Or,
                                                                                  Bop(In,
                                                                                      Var("Rd",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)]),
                                                                                  Bop(In,
                                                                                      Var("Rn",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)])),
                                                                              Bop(In,
                                                                                  Var("Rm",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "SelectBytes"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Call
                                                                              ("Media",
                                                                               CTy"instruction",
                                                                               Call
                                                                                 ("SelectBytes",
                                                                                  CTy"Media",
                                                                                  TP[Var("Rd",
                                                                                         F4),
                                                                                     Var("Rn",
                                                                                         F4),
                                                                                     Var("Rm",
                                                                                         F4)])),
                                                                            qTy))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'23",
                                               Bop(And,
                                                   Mop(Not,bVar"b'22"),
                                                   Bop(And,bVar"b'21",
                                                       Bop(And,bVar"b'20",
                                                           Bop(And,
                                                               bVar"b'15",
                                                               Bop(And,
                                                                   bVar"b'14",
                                                                   Bop(And,
                                                                       bVar"b'13",
                                                                       Bop(And,
                                                                           bVar"b'12",
                                                                           Bop(And,
                                                                               bVar"b'7",
                                                                               Bop(And,
                                                                                   Mop(Not,
                                                                                       bVar"b'6"),
                                                                                   Bop(And,
                                                                                       Mop(Not,
                                                                                           bVar"b'5"),
                                                                                       Mop(Not,
                                                                                           bVar"b'4"))))))))))))),
                                       Let(Var("Rm",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'3",bVar"b'2",
                                                  bVar"b'1",bVar"b'0"]),
                                           Let(Var("Rd",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'11",
                                                      bVar"b'10",
                                                      bVar"b'9",bVar"b'8"]),
                                               MB(Call
                                                    ("ThumbCondition",
                                                     ATy(qTy,PTy(F4,qTy)),
                                                     LU),
                                                  Close
                                                    (Var("v",F4),
                                                     MB(MB(MB(Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F4,
                                                                      bTy)),
                                                              Call
                                                                ("Take",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F4,
                                                                         bTy))))),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(ITE(Bop(Or,
                                                                          Bop(Or,
                                                                              Mop(Not,
                                                                                  EQ(Mop(Cast
                                                                                           F4,
                                                                                         LL[bVar"b'19",
                                                                                            bVar"b'18",
                                                                                            bVar"b'17",
                                                                                            bVar"b'16"]),
                                                                                     Var("Rm",
                                                                                         F4))),
                                                                              Bop(In,
                                                                                  Var("Rd",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Bop(In,
                                                                              Var("Rm",
                                                                                  F4),
                                                                              SL[LW(13,
                                                                                    4),
                                                                                 LW(15,
                                                                                    4)])),
                                                                      Call
                                                                        ("DECODE_UNPREDICTABLE",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[Var("mc",
                                                                                CTy"MachineCode"),
                                                                            LS
                                                                             "CountLeadingZeroes"]),
                                                                      MU(LU,
                                                                         qTy)),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("Data",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("CountLeadingZeroes",
                                                                              CTy"Data",
                                                                              TP[Var("Rd",
                                                                                     F4),
                                                                                 Var("Rm",
                                                                                     F4)])),
                                                                        qTy))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU))))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,Mop(Not,bVar"b'7"),
                                                   Mop(Not,bVar"b'6")))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rd",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   Let(Var("Ra",F4),
                                                       Mop(Cast F4,
                                                           LL[bVar"b'15",
                                                              bVar"b'14",
                                                              bVar"b'13",
                                                              bVar"b'12"]),
                                                       MB(Call
                                                            ("ThumbCondition",
                                                             ATy(qTy,
                                                                 PTy(F4,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (Var("v",F4),
                                                             MB(MB(MB(Call
                                                                        ("HaveThumb2",
                                                                         ATy(qTy,
                                                                             PTy(bTy,
                                                                                 qTy)),
                                                                         LU),
                                                                      Close
                                                                        (bVar"v0",
                                                                         MU(TP[Var("v",
                                                                                   F4),
                                                                               bVar"v0"],
                                                                            qTy))),
                                                                   Close
                                                                     (Var("v",
                                                                          PTy(F4,
                                                                              bTy)),
                                                                      Call
                                                                        ("Take",
                                                                         ATy(qTy,
                                                                             PTy(bTy,
                                                                                 qTy)),
                                                                         Var("v",
                                                                             PTy(F4,
                                                                                 bTy))))),
                                                                Close
                                                                  (bVar"b",
                                                                   ITE(bVar"b",
                                                                       MB(ITE(Bop(Or,
                                                                                  Bop(Or,
                                                                                      Bop(Or,
                                                                                          Bop(In,
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              SL[LW(13,
                                                                                                    4),
                                                                                                 LW(15,
                                                                                                    4)]),
                                                                                          Bop(In,
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              SL[LW(13,
                                                                                                    4),
                                                                                                 LW(15,
                                                                                                    4)])),
                                                                                      Bop(In,
                                                                                          Var("Rm",
                                                                                              F4),
                                                                                          SL[LW(13,
                                                                                                4),
                                                                                             LW(15,
                                                                                                4)])),
                                                                                  EQ(Var("Ra",
                                                                                         F4),
                                                                                     LW(13,
                                                                                        4))),
                                                                              Call
                                                                                ("DECODE_UNPREDICTABLE",
                                                                                 ATy(qTy,
                                                                                     PTy(uTy,
                                                                                         qTy)),
                                                                                 TP[Var("mc",
                                                                                        CTy"MachineCode"),
                                                                                    LS
                                                                                     "Multiplies and absolute difference"]),
                                                                              MU(LU,
                                                                                 qTy)),
                                                                          Close
                                                                            (uVar"_0",
                                                                             CS(TP[Mop(Cast
                                                                                         (FTy 3),
                                                                                       LL[bVar"b'22",
                                                                                          bVar"b'21",
                                                                                          bVar"b'20"]),
                                                                                   Var("Ra",
                                                                                       F4),
                                                                                   EQ(Mop(Cast
                                                                                            F1,
                                                                                          LL[bVar"b'5"]),
                                                                                      LW(1,
                                                                                         1)),
                                                                                   EQ(Mop(Cast
                                                                                            F1,
                                                                                          LL[bVar"b'4"]),
                                                                                      LW(1,
                                                                                         1))],
                                                                                [(TP[LW(0,
                                                                                        3),
                                                                                     LW(15,
                                                                                        4),
                                                                                     LF,
                                                                                     LF],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Multiply32",
                                                                                           CTy"Multiply",
                                                                                           TP[LF,
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(0,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     LF],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("MultiplyAccumulate",
                                                                                           CTy"Multiply",
                                                                                           TP[LF,
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(0,
                                                                                        3),
                                                                                     LW(15,
                                                                                        4),
                                                                                     LF,
                                                                                     LT],
                                                                                  MB(Call
                                                                                       ("DECODE_UNPREDICTABLE",
                                                                                        ATy(qTy,
                                                                                            PTy(uTy,
                                                                                                qTy)),
                                                                                        TP[Var("mc",
                                                                                               CTy"MachineCode"),
                                                                                           LS
                                                                                            "MultiplySubtract"]),
                                                                                     Close
                                                                                       (AVar
                                                                                          uTy,
                                                                                        MU(LX(CTy"instruction"),
                                                                                           qTy)))),
                                                                                 (TP[LW(0,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     LT],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("MultiplySubtract",
                                                                                           CTy"Multiply",
                                                                                           TP[Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(1,
                                                                                        3),
                                                                                     LW(15,
                                                                                        4),
                                                                                     bVar"n_high",
                                                                                     bVar"m_high"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Signed16Multiply32Result",
                                                                                           CTy"Multiply",
                                                                                           TP[bVar"m_high",
                                                                                              bVar"n_high",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(1,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     bVar"n_high",
                                                                                     bVar"m_high"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Signed16Multiply32Accumulate",
                                                                                           CTy"Multiply",
                                                                                           TP[bVar"m_high",
                                                                                              bVar"n_high",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(2,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     bVar"m_swap"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("SignedMultiplyDual",
                                                                                           CTy"Multiply",
                                                                                           TP[LF,
                                                                                              bVar"m_swap",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(3,
                                                                                        3),
                                                                                     LW(15,
                                                                                        4),
                                                                                     LF,
                                                                                     bVar"m_high"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Signed16x32Multiply32Result",
                                                                                           CTy"Multiply",
                                                                                           TP[bVar"m_high",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(3,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     bVar"m_high"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Signed16x32Multiply32Accumulate",
                                                                                           CTy"Multiply",
                                                                                           TP[bVar"m_high",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(4,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     bVar"m_swap"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("SignedMultiplyDual",
                                                                                           CTy"Multiply",
                                                                                           TP[LT,
                                                                                              bVar"m_swap",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(5,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     bVar"round"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("SignedMostSignificantMultiply",
                                                                                           CTy"Multiply",
                                                                                           TP[bVar"round",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(6,
                                                                                        3),
                                                                                     LW(15,
                                                                                        4),
                                                                                     LF,
                                                                                     AVar
                                                                                       bTy],
                                                                                  MB(Call
                                                                                       ("DECODE_UNPREDICTABLE",
                                                                                        ATy(qTy,
                                                                                            PTy(uTy,
                                                                                                qTy)),
                                                                                        TP[Var("mc",
                                                                                               CTy"MachineCode"),
                                                                                           LS
                                                                                            "SignedMostSignificantMultiplySubtract"]),
                                                                                     Close
                                                                                       (AVar
                                                                                          uTy,
                                                                                        MU(LX(CTy"instruction"),
                                                                                           qTy)))),
                                                                                 (TP[LW(6,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     bVar"round"],
                                                                                  MU(Call
                                                                                       ("Multiply",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("SignedMostSignificantMultiplySubtract",
                                                                                           CTy"Multiply",
                                                                                           TP[bVar"round",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (TP[LW(7,
                                                                                        3),
                                                                                     AVar
                                                                                       F4,
                                                                                     LF,
                                                                                     LF],
                                                                                  MU(Call
                                                                                       ("SIMD",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("UnsignedSumAbsoluteDifferences",
                                                                                           CTy"SIMD",
                                                                                           TP[Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("Rm",
                                                                                                  F4),
                                                                                              Var("Ra",
                                                                                                  F4)])),
                                                                                     qTy)),
                                                                                 (AVar
                                                                                    (PTy(FTy 3,
                                                                                         PTy(F4,
                                                                                             PTy(bTy,
                                                                                                 bTy)))),
                                                                                  MU(Call
                                                                                       ("Undefined",
                                                                                        CTy"instruction",
                                                                                        LW(0,
                                                                                           32)),
                                                                                     qTy))]))),
                                                                       Call
                                                                         ("Skip",
                                                                          ATy(qTy,
                                                                              PTy(CTy"instruction",
                                                                                  qTy)),
                                                                          LU))))))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,bVar"b'23",
                                               Bop(And,
                                                   Mop(Not,bVar"b'22"),
                                                   Bop(And,bVar"b'20",
                                                       Bop(And,bVar"b'7",
                                                           Bop(And,
                                                               bVar"b'6",
                                                               Bop(And,
                                                                   bVar"b'5",
                                                                   bVar"b'4"))))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rd",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveVirtExt",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MB(ITE(bVar"v0",
                                                                            MU(LT,
                                                                               qTy),
                                                                            MB(MR(Close
                                                                                    (qVar"s",
                                                                                     Dest
                                                                                       ("Architecture",
                                                                                        CTy"Architecture",
                                                                                        qVar"s"))),
                                                                               Close
                                                                                 (Var("v",
                                                                                      CTy"Architecture"),
                                                                                  MU(EQ(Var("v",
                                                                                            CTy"Architecture"),
                                                                                        LC("ARMv7_R",
                                                                                           CTy"Architecture")),
                                                                                     qTy)))),
                                                                        Close
                                                                          (bVar"v0",
                                                                           MU(TP[Var("v",
                                                                                     F4),
                                                                                 bVar"v0"],
                                                                              qTy))))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(ITE(Bop(Or,
                                                                              Bop(Or,
                                                                                  Bop(In,
                                                                                      Var("Rd",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)]),
                                                                                  Bop(In,
                                                                                      Var("Rn",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)])),
                                                                              Bop(In,
                                                                                  Var("Rm",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "Divide"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Call
                                                                              ("Divide",
                                                                               CTy"instruction",
                                                                               TP[EQ(Mop(Cast
                                                                                           F1,
                                                                                         LL[bVar"b'21"]),
                                                                                     LW(1,
                                                                                        1)),
                                                                                  Var("Rd",
                                                                                      F4),
                                                                                  Var("Rn",
                                                                                      F4),
                                                                                  Var("Rm",
                                                                                      F4)]),
                                                                            qTy))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU)))))))))),
                                      (Bop(And,bVar"b'24",bVar"b'23"),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("RdHi",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'11",
                                                          bVar"b'10",
                                                          bVar"b'9",
                                                          bVar"b'8"]),
                                                   Let(Var("RdLo",F4),
                                                       Mop(Cast F4,
                                                           LL[bVar"b'15",
                                                              bVar"b'14",
                                                              bVar"b'13",
                                                              bVar"b'12"]),
                                                       MB(Call
                                                            ("ThumbCondition",
                                                             ATy(qTy,
                                                                 PTy(F4,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (Var("v",F4),
                                                             MB(MB(MB(Call
                                                                        ("HaveThumb2",
                                                                         ATy(qTy,
                                                                             PTy(bTy,
                                                                                 qTy)),
                                                                         LU),
                                                                      Close
                                                                        (bVar"v0",
                                                                         MU(TP[Var("v",
                                                                                   F4),
                                                                               bVar"v0"],
                                                                            qTy))),
                                                                   Close
                                                                     (Var("v",
                                                                          PTy(F4,
                                                                              bTy)),
                                                                      Call
                                                                        ("Take",
                                                                         ATy(qTy,
                                                                             PTy(bTy,
                                                                                 qTy)),
                                                                         Var("v",
                                                                             PTy(F4,
                                                                                 bTy))))),
                                                                Close
                                                                  (bVar"b",
                                                                   ITE(bVar"b",
                                                                       MB(ITE(Bop(Or,
                                                                                  Bop(Or,
                                                                                      Bop(Or,
                                                                                          Bop(Or,
                                                                                              Bop(In,
                                                                                                  Var("RdLo",
                                                                                                      F4),
                                                                                                  SL[LW(13,
                                                                                                        4),
                                                                                                     LW(15,
                                                                                                        4)]),
                                                                                              Bop(In,
                                                                                                  Var("RdHi",
                                                                                                      F4),
                                                                                                  SL[LW(13,
                                                                                                        4),
                                                                                                     LW(15,
                                                                                                        4)])),
                                                                                          Bop(In,
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              SL[LW(13,
                                                                                                    4),
                                                                                                 LW(15,
                                                                                                    4)])),
                                                                                      Bop(In,
                                                                                          Var("Rm",
                                                                                              F4),
                                                                                          SL[LW(13,
                                                                                                4),
                                                                                             LW(15,
                                                                                                4)])),
                                                                                  EQ(Var("RdHi",
                                                                                         F4),
                                                                                     Var("RdLo",
                                                                                         F4))),
                                                                              Call
                                                                                ("DECODE_UNPREDICTABLE",
                                                                                 ATy(qTy,
                                                                                     PTy(uTy,
                                                                                         qTy)),
                                                                                 TP[Var("mc",
                                                                                        CTy"MachineCode"),
                                                                                    LS
                                                                                     "Long multiply, long multiply accumulate"]),
                                                                              MU(LU,
                                                                                 qTy)),
                                                                          Close
                                                                            (uVar"_0",
                                                                             MU(Let(TP[TP[bVar"b'6",
                                                                                          bVar"b'5",
                                                                                          bVar"b'4"],
                                                                                       bVar"b'3",
                                                                                       bVar"b'2",
                                                                                       bVar"b'1",
                                                                                       bVar"b'0"],
                                                                                    TP[BL(3,
                                                                                          Mop(Cast
                                                                                                (FTy 3),
                                                                                              LL[bVar"b'22",
                                                                                                 bVar"b'21",
                                                                                                 bVar"b'20"])),
                                                                                       BL(4,
                                                                                          Mop(Cast
                                                                                                F4,
                                                                                              LL[bVar"b'7",
                                                                                                 bVar"b'6",
                                                                                                 bVar"b'5",
                                                                                                 bVar"b'4"]))],
                                                                                    ITB([(Bop(And,
                                                                                              Mop(Not,
                                                                                                  bVar"b'4"),
                                                                                              Bop(And,
                                                                                                  Mop(Not,
                                                                                                      bVar"b'3"),
                                                                                                  Bop(And,
                                                                                                      Mop(Not,
                                                                                                          bVar"b'2"),
                                                                                                      Bop(And,
                                                                                                          Mop(Not,
                                                                                                              bVar"b'1"),
                                                                                                          Mop(Not,
                                                                                                              bVar"b'0"))))),
                                                                                          Call
                                                                                            ("Multiply",
                                                                                             CTy"instruction",
                                                                                             Call
                                                                                               ("MultiplyLong",
                                                                                                CTy"Multiply",
                                                                                                TP[EQ(Mop(Cast
                                                                                                            F1,
                                                                                                          LL[bVar"b'6"]),
                                                                                                      LW(1,
                                                                                                         1)),
                                                                                                   EQ(Mop(Cast
                                                                                                            F1,
                                                                                                          LL[bVar"b'5"]),
                                                                                                      LW(0,
                                                                                                         1)),
                                                                                                   LF,
                                                                                                   Var("RdHi",
                                                                                                       F4),
                                                                                                   Var("RdLo",
                                                                                                       F4),
                                                                                                   Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rm",
                                                                                                       F4)]))),
                                                                                         (Bop(And,
                                                                                              bVar"b'6",
                                                                                              Bop(And,
                                                                                                  Mop(Not,
                                                                                                      bVar"b'5"),
                                                                                                  Bop(And,
                                                                                                      Mop(Not,
                                                                                                          bVar"b'4"),
                                                                                                      Bop(And,
                                                                                                          bVar"b'3",
                                                                                                          Mop(Not,
                                                                                                              bVar"b'2"))))),
                                                                                          Call
                                                                                            ("Multiply",
                                                                                             CTy"instruction",
                                                                                             Call
                                                                                               ("Signed16Multiply64Accumulate",
                                                                                                CTy"Multiply",
                                                                                                TP[EQ(Mop(Cast
                                                                                                            F1,
                                                                                                          LL[bVar"b'0"]),
                                                                                                      LW(1,
                                                                                                         1)),
                                                                                                   EQ(Mop(Cast
                                                                                                            F1,
                                                                                                          LL[bVar"b'1"]),
                                                                                                      LW(1,
                                                                                                         1)),
                                                                                                   Var("RdHi",
                                                                                                       F4),
                                                                                                   Var("RdLo",
                                                                                                       F4),
                                                                                                   Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rm",
                                                                                                       F4)]))),
                                                                                         (Bop(And,
                                                                                              bVar"b'6",
                                                                                              Bop(And,
                                                                                                  Mop(Not,
                                                                                                      bVar"b'5"),
                                                                                                  Bop(And,
                                                                                                      bVar"b'3",
                                                                                                      Bop(And,
                                                                                                          bVar"b'2",
                                                                                                          Mop(Not,
                                                                                                              bVar"b'1"))))),
                                                                                          Call
                                                                                            ("Multiply",
                                                                                             CTy"instruction",
                                                                                             Call
                                                                                               ("SignedMultiplyLongDual",
                                                                                                CTy"Multiply",
                                                                                                TP[EQ(Mop(Cast
                                                                                                            F1,
                                                                                                          LL[bVar"b'4"]),
                                                                                                      LW(1,
                                                                                                         1)),
                                                                                                   EQ(Mop(Cast
                                                                                                            F1,
                                                                                                          LL[bVar"b'0"]),
                                                                                                      LW(1,
                                                                                                         1)),
                                                                                                   Var("RdHi",
                                                                                                       F4),
                                                                                                   Var("RdLo",
                                                                                                       F4),
                                                                                                   Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rm",
                                                                                                       F4)]))),
                                                                                         (Bop(And,
                                                                                              bVar"b'6",
                                                                                              Bop(And,
                                                                                                  bVar"b'5",
                                                                                                  Bop(And,
                                                                                                      Mop(Not,
                                                                                                          bVar"b'4"),
                                                                                                      Bop(And,
                                                                                                          Mop(Not,
                                                                                                              bVar"b'3"),
                                                                                                          Bop(And,
                                                                                                              bVar"b'2",
                                                                                                              Bop(And,
                                                                                                                  bVar"b'1",
                                                                                                                  Mop(Not,
                                                                                                                      bVar"b'0"))))))),
                                                                                          Call
                                                                                            ("Multiply",
                                                                                             CTy"instruction",
                                                                                             Call
                                                                                               ("MultiplyAccumulateAccumulate",
                                                                                                CTy"Multiply",
                                                                                                TP[Var("RdHi",
                                                                                                       F4),
                                                                                                   Var("RdLo",
                                                                                                       F4),
                                                                                                   Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rm",
                                                                                                       F4)])))],
                                                                                        Call
                                                                                          ("Undefined",
                                                                                           CTy"instruction",
                                                                                           LW(0,
                                                                                              32)))),
                                                                                qTy))),
                                                                       Call
                                                                         ("Skip",
                                                                          ATy(qTy,
                                                                              PTy(CTy"instruction",
                                                                                  qTy)),
                                                                          LU)))))))))))],
                                     Call
                                       ("UndefinedThumb",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU)),
                                 Call
                                   ("UndefinedThumb",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                            (bVar"b'22",
                             ITB([(bVar"b'20",
                                   ITE(Bop(And,bVar"b'31",
                                           Bop(And,bVar"b'30",
                                               Bop(And,bVar"b'29",
                                                   Bop(And,
                                                       Mop(Not,bVar"b'26"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'24"),
                                                           Mop(Not,
                                                               bVar"b'21")))))),
                                       ITB([(Bop(And,bVar"b'19",
                                                 Bop(And,bVar"b'18",
                                                     Bop(And,bVar"b'17",
                                                         bVar"b'16"))),
                                             Let(Var("Rt",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 MB(Call
                                                      ("ThumbCondition",
                                                       ATy(qTy,PTy(F4,qTy)),
                                                       LU),
                                                    Close
                                                      (Var("v",F4),
                                                       MB(MB(MB(Call
                                                                  ("HaveThumb2",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v0",
                                                                   MU(TP[Var("v",
                                                                             F4),
                                                                         bVar"v0"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(Call
                                                                      ("InITBlock",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       LU),
                                                                    Close
                                                                      (bVar"v",
                                                                       MB(MB(MB(MU(Bop(And,
                                                                                       EQ(Var("Rt",
                                                                                              F4),
                                                                                          LW(15,
                                                                                             4)),
                                                                                       bVar"v"),
                                                                                   qTy),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   ITE(bVar"b",
                                                                                       MB(Call
                                                                                            ("LastInITBlock",
                                                                                             ATy(qTy,
                                                                                                 PTy(bTy,
                                                                                                     qTy)),
                                                                                             LU),
                                                                                          Close
                                                                                            (bVar"v",
                                                                                             MU(Mop(Not,
                                                                                                    bVar"v"),
                                                                                                qTy))),
                                                                                       MU(LF,
                                                                                          qTy)))),
                                                                             Close
                                                                               (bVar"b",
                                                                                ITE(bVar"b",
                                                                                    Call
                                                                                      ("DECODE_UNPREDICTABLE",
                                                                                       ATy(qTy,
                                                                                           PTy(uTy,
                                                                                               qTy)),
                                                                                       TP[Var("mc",
                                                                                              CTy"MachineCode"),
                                                                                          LS
                                                                                           "LoadLiteral"]),
                                                                                    MU(LU,
                                                                                       qTy)))),
                                                                          Close
                                                                            (AVar
                                                                               uTy,
                                                                             MU(Call
                                                                                  ("Load",
                                                                                   CTy"instruction",
                                                                                   Call
                                                                                     ("LoadLiteral",
                                                                                      CTy"Load",
                                                                                      TP[EQ(Mop(Cast
                                                                                                  F1,
                                                                                                LL[bVar"b'23"]),
                                                                                            LW(1,
                                                                                               1)),
                                                                                         Var("Rt",
                                                                                             F4),
                                                                                         Mop(Cast
                                                                                               F32,
                                                                                             Mop(Cast
                                                                                                   (FTy 12),
                                                                                                 LL[bVar"b'11",
                                                                                                    bVar"b'10",
                                                                                                    bVar"b'9",
                                                                                                    bVar"b'8",
                                                                                                    bVar"b'7",
                                                                                                    bVar"b'6",
                                                                                                    bVar"b'5",
                                                                                                    bVar"b'4",
                                                                                                    bVar"b'3",
                                                                                                    bVar"b'2",
                                                                                                    bVar"b'1",
                                                                                                    bVar"b'0"]))])),
                                                                                qTy))))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))),
                                            (bVar"b'23",
                                             Let(Var("Rt",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 MB(Call
                                                      ("ThumbCondition",
                                                       ATy(qTy,PTy(F4,qTy)),
                                                       LU),
                                                    Close
                                                      (Var("v",F4),
                                                       MB(MB(MB(Call
                                                                  ("HaveThumb2",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v0",
                                                                   MU(TP[Var("v",
                                                                             F4),
                                                                         bVar"v0"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(Call
                                                                      ("InITBlock",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       LU),
                                                                    Close
                                                                      (bVar"v",
                                                                       MB(MB(MB(MU(Bop(And,
                                                                                       EQ(Var("Rt",
                                                                                              F4),
                                                                                          LW(15,
                                                                                             4)),
                                                                                       bVar"v"),
                                                                                   qTy),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   ITE(bVar"b",
                                                                                       MB(Call
                                                                                            ("LastInITBlock",
                                                                                             ATy(qTy,
                                                                                                 PTy(bTy,
                                                                                                     qTy)),
                                                                                             LU),
                                                                                          Close
                                                                                            (bVar"v",
                                                                                             MU(Mop(Not,
                                                                                                    bVar"v"),
                                                                                                qTy))),
                                                                                       MU(LF,
                                                                                          qTy)))),
                                                                             Close
                                                                               (bVar"b",
                                                                                ITE(bVar"b",
                                                                                    Call
                                                                                      ("DECODE_UNPREDICTABLE",
                                                                                       ATy(qTy,
                                                                                           PTy(uTy,
                                                                                               qTy)),
                                                                                       TP[Var("mc",
                                                                                              CTy"MachineCode"),
                                                                                          LS
                                                                                           "LoadWord"]),
                                                                                    MU(LU,
                                                                                       qTy)))),
                                                                          Close
                                                                            (AVar
                                                                               uTy,
                                                                             MU(Call
                                                                                  ("Load",
                                                                                   CTy"instruction",
                                                                                   Call
                                                                                     ("LoadWord",
                                                                                      CTy"Load",
                                                                                      TP[LT,
                                                                                         LT,
                                                                                         LF,
                                                                                         Var("Rt",
                                                                                             F4),
                                                                                         Mop(Cast
                                                                                               F4,
                                                                                             LL[bVar"b'19",
                                                                                                bVar"b'18",
                                                                                                bVar"b'17",
                                                                                                bVar"b'16"]),
                                                                                         Call
                                                                                           ("immediate_form1",
                                                                                            CTy"offset1",
                                                                                            Mop(Cast
                                                                                                  F32,
                                                                                                Mop(Cast
                                                                                                      (FTy 12),
                                                                                                    LL[bVar"b'11",
                                                                                                       bVar"b'10",
                                                                                                       bVar"b'9",
                                                                                                       bVar"b'8",
                                                                                                       bVar"b'7",
                                                                                                       bVar"b'6",
                                                                                                       bVar"b'5",
                                                                                                       bVar"b'4",
                                                                                                       bVar"b'3",
                                                                                                       bVar"b'2",
                                                                                                       bVar"b'1",
                                                                                                       bVar"b'0"])))])),
                                                                                qTy))))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))),
                                            (Bop(And,Mop(Not,bVar"b'23"),
                                                 Bop(And,bVar"b'11",
                                                     Bop(And,bVar"b'10",
                                                         Bop(And,
                                                             bVar"b'9",
                                                             Mop(Not,
                                                                 bVar"b'8"))))),
                                             Let(Var("Rt",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 MB(Call
                                                      ("ThumbCondition",
                                                       ATy(qTy,PTy(F4,qTy)),
                                                       LU),
                                                    Close
                                                      (Var("v",F4),
                                                       MB(MB(MB(Call
                                                                  ("HaveThumb2",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v0",
                                                                   MU(TP[Var("v",
                                                                             F4),
                                                                         bVar"v0"],
                                                                      qTy))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(In,
                                                                            Var("Rt",
                                                                                F4),
                                                                            SL[LW(13,
                                                                                  4),
                                                                               LW(15,
                                                                                  4)]),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "LoadUnprivileged"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("Load",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("LoadUnprivileged",
                                                                                CTy"Load",
                                                                                TP[LT,
                                                                                   LF,
                                                                                   Var("Rt",
                                                                                       F4),
                                                                                   Mop(Cast
                                                                                         F4,
                                                                                       LL[bVar"b'19",
                                                                                          bVar"b'18",
                                                                                          bVar"b'17",
                                                                                          bVar"b'16"]),
                                                                                   Call
                                                                                     ("immediate_form1",
                                                                                      CTy"offset1",
                                                                                      Mop(Cast
                                                                                            F32,
                                                                                          Mop(Cast
                                                                                                F8,
                                                                                              LL[bVar"b'7",
                                                                                                 bVar"b'6",
                                                                                                 bVar"b'5",
                                                                                                 bVar"b'4",
                                                                                                 bVar"b'3",
                                                                                                 bVar"b'2",
                                                                                                 bVar"b'1",
                                                                                                 bVar"b'0"])))])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))),
                                            (Bop(And,Mop(Not,bVar"b'23"),
                                                 bVar"b'11"),
                                             Let(Var("Rn",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'19",
                                                        bVar"b'18",
                                                        bVar"b'17",
                                                        bVar"b'16"]),
                                                 Let(Var("W",F1),
                                                     Mop(Cast F1,
                                                         LL[bVar"b'8"]),
                                                     Let(Var("P",F1),
                                                         Mop(Cast F1,
                                                             LL[bVar"b'10"]),
                                                         Let(Var("Rt",F4),
                                                             Mop(Cast F4,
                                                                 LL[bVar"b'15",
                                                                    bVar"b'14",
                                                                    bVar"b'13",
                                                                    bVar"b'12"]),
                                                             MB(Call
                                                                  ("ThumbCondition",
                                                                   ATy(qTy,
                                                                       PTy(F4,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (Var("v",
                                                                       F4),
                                                                   MB(MB(MB(Call
                                                                              ("HaveThumb2",
                                                                               ATy(qTy,
                                                                                   PTy(bTy,
                                                                                       qTy)),
                                                                               LU),
                                                                            Close
                                                                              (bVar"v0",
                                                                               MB(MU(Bop(And,
                                                                                         Bop(Or,
                                                                                             EQ(Var("P",
                                                                                                    F1),
                                                                                                LW(1,
                                                                                                   1)),
                                                                                             EQ(Var("W",
                                                                                                    F1),
                                                                                                LW(1,
                                                                                                   1))),
                                                                                         bVar"v0"),
                                                                                     qTy),
                                                                                  Close
                                                                                    (bVar"v0",
                                                                                     MU(TP[Var("v",
                                                                                               F4),
                                                                                           bVar"v0"],
                                                                                        qTy))))),
                                                                         Close
                                                                           (Var("v",
                                                                                PTy(F4,
                                                                                    bTy)),
                                                                            Call
                                                                              ("Take",
                                                                               ATy(qTy,
                                                                                   PTy(bTy,
                                                                                       qTy)),
                                                                               Var("v",
                                                                                   PTy(F4,
                                                                                       bTy))))),
                                                                      Close
                                                                        (bVar"b",
                                                                         ITE(bVar"b",
                                                                             Let(bVar"wback",
                                                                                 EQ(Var("W",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 MB(Call
                                                                                      ("InITBlock",
                                                                                       ATy(qTy,
                                                                                           PTy(bTy,
                                                                                               qTy)),
                                                                                       LU),
                                                                                    Close
                                                                                      (bVar"v",
                                                                                       MB(MB(MB(MB(MU(Bop(And,
                                                                                                          EQ(Var("Rt",
                                                                                                                 F4),
                                                                                                             LW(15,
                                                                                                                4)),
                                                                                                          bVar"v"),
                                                                                                      qTy),
                                                                                                   Close
                                                                                                     (bVar"b",
                                                                                                      ITE(bVar"b",
                                                                                                          MB(Call
                                                                                                               ("LastInITBlock",
                                                                                                                ATy(qTy,
                                                                                                                    PTy(bTy,
                                                                                                                        qTy)),
                                                                                                                LU),
                                                                                                             Close
                                                                                                               (bVar"v",
                                                                                                                MU(Mop(Not,
                                                                                                                       bVar"v"),
                                                                                                                   qTy))),
                                                                                                          MU(LF,
                                                                                                             qTy)))),
                                                                                                Close
                                                                                                  (bVar"v",
                                                                                                   MU(Bop(Or,
                                                                                                          Bop(And,
                                                                                                              bVar"wback",
                                                                                                              EQ(Var("Rn",
                                                                                                                     F4),
                                                                                                                 Var("Rt",
                                                                                                                     F4))),
                                                                                                          bVar"v"),
                                                                                                      qTy))),
                                                                                             Close
                                                                                               (bVar"b",
                                                                                                ITE(bVar"b",
                                                                                                    Call
                                                                                                      ("DECODE_UNPREDICTABLE",
                                                                                                       ATy(qTy,
                                                                                                           PTy(uTy,
                                                                                                               qTy)),
                                                                                                       TP[Var("mc",
                                                                                                              CTy"MachineCode"),
                                                                                                          LS
                                                                                                           "LoadWord"]),
                                                                                                    MU(LU,
                                                                                                       qTy)))),
                                                                                          Close
                                                                                            (AVar
                                                                                               uTy,
                                                                                             MU(Call
                                                                                                  ("Load",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("LoadWord",
                                                                                                      CTy"Load",
                                                                                                      TP[EQ(Mop(Cast
                                                                                                                  F1,
                                                                                                                LL[bVar"b'9"]),
                                                                                                            LW(1,
                                                                                                               1)),
                                                                                                         EQ(Var("P",
                                                                                                                F1),
                                                                                                            LW(1,
                                                                                                               1)),
                                                                                                         bVar"wback",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Call
                                                                                                           ("immediate_form1",
                                                                                                            CTy"offset1",
                                                                                                            Mop(Cast
                                                                                                                  F32,
                                                                                                                Mop(Cast
                                                                                                                      F8,
                                                                                                                    LL[bVar"b'7",
                                                                                                                       bVar"b'6",
                                                                                                                       bVar"b'5",
                                                                                                                       bVar"b'4",
                                                                                                                       bVar"b'3",
                                                                                                                       bVar"b'2",
                                                                                                                       bVar"b'1",
                                                                                                                       bVar"b'0"])))])),
                                                                                                qTy)))))),
                                                                             Call
                                                                               ("Skip",
                                                                                ATy(qTy,
                                                                                    PTy(CTy"instruction",
                                                                                        qTy)),
                                                                                LU))))))))))),
                                            (Bop(And,Mop(Not,bVar"b'23"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'11"),
                                                     Bop(And,
                                                         Mop(Not,
                                                             bVar"b'10"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'9"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'8"),
                                                                 Bop(And,
                                                                     Mop(Not,
                                                                         bVar"b'7"),
                                                                     Mop(Not,
                                                                         bVar"b'6"))))))),
                                             Let(Var("Rm",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'3",
                                                        bVar"b'2",
                                                        bVar"b'1",
                                                        bVar"b'0"]),
                                                 Let(Var("Rt",F4),
                                                     Mop(Cast F4,
                                                         LL[bVar"b'15",
                                                            bVar"b'14",
                                                            bVar"b'13",
                                                            bVar"b'12"]),
                                                     MB(Call
                                                          ("ThumbCondition",
                                                           ATy(qTy,
                                                               PTy(F4,qTy)),
                                                           LU),
                                                        Close
                                                          (Var("v",F4),
                                                           MB(MB(MB(Call
                                                                      ("HaveThumb2",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       LU),
                                                                    Close
                                                                      (bVar"v0",
                                                                       MU(TP[Var("v",
                                                                                 F4),
                                                                             bVar"v0"],
                                                                          qTy))),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F4,
                                                                            bTy)),
                                                                    Call
                                                                      ("Take",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F4,
                                                                               bTy))))),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(Call
                                                                          ("InITBlock",
                                                                           ATy(qTy,
                                                                               PTy(bTy,
                                                                                   qTy)),
                                                                           LU),
                                                                        Close
                                                                          (bVar"v",
                                                                           MB(MB(MB(MB(MU(Bop(And,
                                                                                              EQ(Var("Rt",
                                                                                                     F4),
                                                                                                 LW(15,
                                                                                                    4)),
                                                                                              bVar"v"),
                                                                                          qTy),
                                                                                       Close
                                                                                         (bVar"b",
                                                                                          ITE(bVar"b",
                                                                                              MB(Call
                                                                                                   ("LastInITBlock",
                                                                                                    ATy(qTy,
                                                                                                        PTy(bTy,
                                                                                                            qTy)),
                                                                                                    LU),
                                                                                                 Close
                                                                                                   (bVar"v",
                                                                                                    MU(Mop(Not,
                                                                                                           bVar"v"),
                                                                                                       qTy))),
                                                                                              MU(LF,
                                                                                                 qTy)))),
                                                                                    Close
                                                                                      (bVar"b",
                                                                                       MU(Bop(Or,
                                                                                              bVar"b",
                                                                                              Bop(In,
                                                                                                  Var("Rm",
                                                                                                      F4),
                                                                                                  SL[LW(13,
                                                                                                        4),
                                                                                                     LW(15,
                                                                                                        4)])),
                                                                                          qTy))),
                                                                                 Close
                                                                                   (bVar"b",
                                                                                    ITE(bVar"b",
                                                                                        Call
                                                                                          ("DECODE_UNPREDICTABLE",
                                                                                           ATy(qTy,
                                                                                               PTy(uTy,
                                                                                                   qTy)),
                                                                                           TP[Var("mc",
                                                                                                  CTy"MachineCode"),
                                                                                              LS
                                                                                               "LoadWord"]),
                                                                                        MU(LU,
                                                                                           qTy)))),
                                                                              Close
                                                                                (AVar
                                                                                   uTy,
                                                                                 MU(Call
                                                                                      ("Load",
                                                                                       CTy"instruction",
                                                                                       Call
                                                                                         ("LoadWord",
                                                                                          CTy"Load",
                                                                                          TP[LT,
                                                                                             LT,
                                                                                             LF,
                                                                                             Var("Rt",
                                                                                                 F4),
                                                                                             Mop(Cast
                                                                                                   F4,
                                                                                                 LL[bVar"b'19",
                                                                                                    bVar"b'18",
                                                                                                    bVar"b'17",
                                                                                                    bVar"b'16"]),
                                                                                             Call
                                                                                               ("register_form1",
                                                                                                CTy"offset1",
                                                                                                TP[Var("Rm",
                                                                                                       F4),
                                                                                                   LC("SRType_LSL",
                                                                                                      CTy"SRType"),
                                                                                                   Mop(Cast
                                                                                                         nTy,
                                                                                                       Mop(Cast
                                                                                                             (FTy 2),
                                                                                                           LL[bVar"b'5",
                                                                                                              bVar"b'4"]))])])),
                                                                                    qTy))))),
                                                                     Call
                                                                       ("Skip",
                                                                        ATy(qTy,
                                                                            PTy(CTy"instruction",
                                                                                qTy)),
                                                                        LU)))))))))],
                                           Call
                                             ("UndefinedThumb",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU)),
                                       Call
                                         ("UndefinedThumb",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU))),
                                  (Bop(And,bVar"b'31",
                                       Bop(And,bVar"b'30",
                                           Bop(And,bVar"b'29",
                                               Bop(And,
                                                   Mop(Not,bVar"b'26"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'24"),
                                                       Mop(Not,bVar"b'21")))))),
                                   ITB([(Bop(And,Mop(Not,bVar"b'23"),
                                             Bop(And,Mop(Not,bVar"b'11"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'10"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'9"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'8"),
                                                             Bop(And,
                                                                 Mop(Not,
                                                                     bVar"b'7"),
                                                                 Mop(Not,
                                                                     bVar"b'6"))))))),
                                         Let(Var("Rn",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'19",bVar"b'18",
                                                    bVar"b'17",bVar"b'16"]),
                                             Let(Var("Rm",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'3",
                                                        bVar"b'2",
                                                        bVar"b'1",
                                                        bVar"b'0"]),
                                                 Let(Var("Rt",F4),
                                                     Mop(Cast F4,
                                                         LL[bVar"b'15",
                                                            bVar"b'14",
                                                            bVar"b'13",
                                                            bVar"b'12"]),
                                                     MB(Call
                                                          ("ThumbCondition",
                                                           ATy(qTy,
                                                               PTy(F4,qTy)),
                                                           LU),
                                                        Close
                                                          (Var("v",F4),
                                                           MB(MB(MB(Call
                                                                      ("HaveThumb2",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       LU),
                                                                    Close
                                                                      (bVar"v0",
                                                                       MB(MU(Bop(And,
                                                                                 Mop(Not,
                                                                                     EQ(Var("Rn",
                                                                                            F4),
                                                                                        LW(15,
                                                                                           4))),
                                                                                 bVar"v0"),
                                                                             qTy),
                                                                          Close
                                                                            (bVar"v0",
                                                                             MU(TP[Var("v",
                                                                                       F4),
                                                                                   bVar"v0"],
                                                                                qTy))))),
                                                                 Close
                                                                   (Var("v",
                                                                        PTy(F4,
                                                                            bTy)),
                                                                    Call
                                                                      ("Take",
                                                                       ATy(qTy,
                                                                           PTy(bTy,
                                                                               qTy)),
                                                                       Var("v",
                                                                           PTy(F4,
                                                                               bTy))))),
                                                              Close
                                                                (bVar"b",
                                                                 ITE(bVar"b",
                                                                     MB(ITE(Bop(Or,
                                                                                EQ(Var("Rt",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4)),
                                                                                Bop(In,
                                                                                    Var("Rm",
                                                                                        F4),
                                                                                    SL[LW(13,
                                                                                          4),
                                                                                       LW(15,
                                                                                          4)])),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "Store (register)"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Call
                                                                                ("Store",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("StoreWord",
                                                                                    CTy"Store",
                                                                                    TP[LT,
                                                                                       LT,
                                                                                       LF,
                                                                                       Var("Rt",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Call
                                                                                         ("register_form1",
                                                                                          CTy"offset1",
                                                                                          TP[Var("Rm",
                                                                                                 F4),
                                                                                             LC("SRType_LSL",
                                                                                                CTy"SRType"),
                                                                                             Mop(Cast
                                                                                                   nTy,
                                                                                                 Mop(Cast
                                                                                                       (FTy 2),
                                                                                                     LL[bVar"b'5",
                                                                                                        bVar"b'4"]))])])),
                                                                              qTy))),
                                                                     Call
                                                                       ("Skip",
                                                                        ATy(qTy,
                                                                            PTy(CTy"instruction",
                                                                                qTy)),
                                                                        LU)))))))))),
                                        (Bop(And,Mop(Not,bVar"b'23"),
                                             Bop(And,bVar"b'11",
                                                 Bop(And,bVar"b'10",
                                                     Bop(And,bVar"b'9",
                                                         Mop(Not,bVar"b'8"))))),
                                         Let(Var("Rn",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'19",bVar"b'18",
                                                    bVar"b'17",bVar"b'16"]),
                                             Let(Var("Rt",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 MB(Call
                                                      ("ThumbCondition",
                                                       ATy(qTy,PTy(F4,qTy)),
                                                       LU),
                                                    Close
                                                      (Var("v",F4),
                                                       MB(MB(MB(Call
                                                                  ("HaveThumb2",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v0",
                                                                   MB(MU(Bop(And,
                                                                             Mop(Not,
                                                                                 EQ(Var("Rn",
                                                                                        F4),
                                                                                    LW(15,
                                                                                       4))),
                                                                             bVar"v0"),
                                                                         qTy),
                                                                      Close
                                                                        (bVar"v0",
                                                                         MU(TP[Var("v",
                                                                                   F4),
                                                                               bVar"v0"],
                                                                            qTy))))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(Bop(In,
                                                                            Var("Rt",
                                                                                F4),
                                                                            SL[LW(13,
                                                                                  4),
                                                                               LW(15,
                                                                                  4)]),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "StoreUnprivileged"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("Store",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("StoreUnprivileged",
                                                                                CTy"Store",
                                                                                TP[LT,
                                                                                   LF,
                                                                                   Var("Rt",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Call
                                                                                     ("immediate_form1",
                                                                                      CTy"offset1",
                                                                                      Mop(Cast
                                                                                            F32,
                                                                                          Mop(Cast
                                                                                                F8,
                                                                                              LL[bVar"b'7",
                                                                                                 bVar"b'6",
                                                                                                 bVar"b'5",
                                                                                                 bVar"b'4",
                                                                                                 bVar"b'3",
                                                                                                 bVar"b'2",
                                                                                                 bVar"b'1",
                                                                                                 bVar"b'0"])))])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU))))))))),
                                        (Bop(And,Mop(Not,bVar"b'23"),
                                             bVar"b'11"),
                                         Let(Var("Rn",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'19",bVar"b'18",
                                                    bVar"b'17",bVar"b'16"]),
                                             Let(Var("W",F1),
                                                 Mop(Cast F1,LL[bVar"b'8"]),
                                                 Let(Var("P",F1),
                                                     Mop(Cast F1,
                                                         LL[bVar"b'10"]),
                                                     Let(Var("Rt",F4),
                                                         Mop(Cast F4,
                                                             LL[bVar"b'15",
                                                                bVar"b'14",
                                                                bVar"b'13",
                                                                bVar"b'12"]),
                                                         MB(Call
                                                              ("ThumbCondition",
                                                               ATy(qTy,
                                                                   PTy(F4,
                                                                       qTy)),
                                                               LU),
                                                            Close
                                                              (Var("v",F4),
                                                               MB(MB(MB(Call
                                                                          ("HaveThumb2",
                                                                           ATy(qTy,
                                                                               PTy(bTy,
                                                                                   qTy)),
                                                                           LU),
                                                                        Close
                                                                          (bVar"v0",
                                                                           MB(MU(Bop(And,
                                                                                     Bop(And,
                                                                                         Mop(Not,
                                                                                             EQ(Var("Rn",
                                                                                                    F4),
                                                                                                LW(15,
                                                                                                   4))),
                                                                                         Bop(Or,
                                                                                             EQ(Var("P",
                                                                                                    F1),
                                                                                                LW(1,
                                                                                                   1)),
                                                                                             EQ(Var("W",
                                                                                                    F1),
                                                                                                LW(1,
                                                                                                   1)))),
                                                                                     bVar"v0"),
                                                                                 qTy),
                                                                              Close
                                                                                (bVar"v0",
                                                                                 MU(TP[Var("v",
                                                                                           F4),
                                                                                       bVar"v0"],
                                                                                    qTy))))),
                                                                     Close
                                                                       (Var("v",
                                                                            PTy(F4,
                                                                                bTy)),
                                                                        Call
                                                                          ("Take",
                                                                           ATy(qTy,
                                                                               PTy(bTy,
                                                                                   qTy)),
                                                                           Var("v",
                                                                               PTy(F4,
                                                                                   bTy))))),
                                                                  Close
                                                                    (bVar"b",
                                                                     ITE(bVar"b",
                                                                         Let(bVar"wback",
                                                                             EQ(Var("W",
                                                                                    F1),
                                                                                LW(1,
                                                                                   1)),
                                                                             MB(ITE(Bop(Or,
                                                                                        EQ(Var("Rt",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4)),
                                                                                        Bop(And,
                                                                                            bVar"wback",
                                                                                            EQ(Var("Rn",
                                                                                                   F4),
                                                                                               Var("Rt",
                                                                                                   F4)))),
                                                                                    Call
                                                                                      ("DECODE_UNPREDICTABLE",
                                                                                       ATy(qTy,
                                                                                           PTy(uTy,
                                                                                               qTy)),
                                                                                       TP[Var("mc",
                                                                                              CTy"MachineCode"),
                                                                                          LS
                                                                                           "Store (immediate)"]),
                                                                                    MU(LU,
                                                                                       qTy)),
                                                                                Close
                                                                                  (AVar
                                                                                     uTy,
                                                                                   MU(Call
                                                                                        ("Store",
                                                                                         CTy"instruction",
                                                                                         Call
                                                                                           ("StoreWord",
                                                                                            CTy"Store",
                                                                                            TP[EQ(Mop(Cast
                                                                                                        F1,
                                                                                                      LL[bVar"b'9"]),
                                                                                                  LW(1,
                                                                                                     1)),
                                                                                               EQ(Var("P",
                                                                                                      F1),
                                                                                                  LW(1,
                                                                                                     1)),
                                                                                               bVar"wback",
                                                                                               Var("Rt",
                                                                                                   F4),
                                                                                               Var("Rn",
                                                                                                   F4),
                                                                                               Call
                                                                                                 ("immediate_form1",
                                                                                                  CTy"offset1",
                                                                                                  Mop(Cast
                                                                                                        F32,
                                                                                                      Mop(Cast
                                                                                                            F8,
                                                                                                          LL[bVar"b'7",
                                                                                                             bVar"b'6",
                                                                                                             bVar"b'5",
                                                                                                             bVar"b'4",
                                                                                                             bVar"b'3",
                                                                                                             bVar"b'2",
                                                                                                             bVar"b'1",
                                                                                                             bVar"b'0"])))])),
                                                                                      qTy)))),
                                                                         Call
                                                                           ("Skip",
                                                                            ATy(qTy,
                                                                                PTy(CTy"instruction",
                                                                                    qTy)),
                                                                            LU))))))))))),
                                        (bVar"b'23",
                                         Let(Var("Rn",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'19",bVar"b'18",
                                                    bVar"b'17",bVar"b'16"]),
                                             Let(Var("Rt",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 MB(Call
                                                      ("ThumbCondition",
                                                       ATy(qTy,PTy(F4,qTy)),
                                                       LU),
                                                    Close
                                                      (Var("v",F4),
                                                       MB(MB(MB(Call
                                                                  ("HaveThumb2",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v0",
                                                                   MB(MU(Bop(And,
                                                                             Mop(Not,
                                                                                 EQ(Var("Rn",
                                                                                        F4),
                                                                                    LW(15,
                                                                                       4))),
                                                                             bVar"v0"),
                                                                         qTy),
                                                                      Close
                                                                        (bVar"v0",
                                                                         MU(TP[Var("v",
                                                                                   F4),
                                                                               bVar"v0"],
                                                                            qTy))))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 MB(ITE(EQ(Var("Rt",
                                                                               F4),
                                                                           LW(15,
                                                                              4)),
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "Store (immediate)"]),
                                                                        MU(LU,
                                                                           qTy)),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Call
                                                                            ("Store",
                                                                             CTy"instruction",
                                                                             Call
                                                                               ("StoreWord",
                                                                                CTy"Store",
                                                                                TP[LT,
                                                                                   LT,
                                                                                   LF,
                                                                                   Var("Rt",
                                                                                       F4),
                                                                                   Var("Rn",
                                                                                       F4),
                                                                                   Call
                                                                                     ("immediate_form1",
                                                                                      CTy"offset1",
                                                                                      Mop(Cast
                                                                                            F32,
                                                                                          Mop(Cast
                                                                                                (FTy 12),
                                                                                              LL[bVar"b'11",
                                                                                                 bVar"b'10",
                                                                                                 bVar"b'9",
                                                                                                 bVar"b'8",
                                                                                                 bVar"b'7",
                                                                                                 bVar"b'6",
                                                                                                 bVar"b'5",
                                                                                                 bVar"b'4",
                                                                                                 bVar"b'3",
                                                                                                 bVar"b'2",
                                                                                                 bVar"b'1",
                                                                                                 bVar"b'0"])))])),
                                                                          qTy))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))],
                                       Call
                                         ("UndefinedThumb",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          LU)))],
                                 Call
                                   ("UndefinedThumb",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                            (bVar"b'20",
                             ITE(Bop(And,bVar"b'31",
                                     Bop(And,bVar"b'30",
                                         Bop(And,bVar"b'29",
                                             Mop(Not,bVar"b'26")))),
                                 ITB([(Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'21",
                                               Bop(And,bVar"b'19",
                                                   Bop(And,bVar"b'18",
                                                       Bop(And,bVar"b'17",
                                                           Bop(And,
                                                               bVar"b'16",
                                                               Bop(And,
                                                                   bVar"b'15",
                                                                   Bop(And,
                                                                       bVar"b'14",
                                                                       Bop(And,
                                                                           bVar"b'13",
                                                                           bVar"b'12"))))))))),
                                       MB(Call
                                            ("DECODE_UNPREDICTABLE",
                                             ATy(qTy,PTy(uTy,qTy)),
                                             TP[Var("mc",CTy"MachineCode"),
                                                LS"PreloadDataLiteral"]),
                                          Close
                                            (AVar uTy,
                                             MU(LX(CTy"instruction"),qTy)))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'19",
                                               Bop(And,bVar"b'18",
                                                   Bop(And,bVar"b'17",
                                                       Bop(And,bVar"b'16",
                                                           Bop(And,
                                                               bVar"b'15",
                                                               Bop(And,
                                                                   bVar"b'14",
                                                                   Bop(And,
                                                                       bVar"b'13",
                                                                       bVar"b'12")))))))),
                                       MB(Call
                                            ("ThumbCondition",
                                             ATy(qTy,PTy(F4,qTy)),LU),
                                          Close
                                            (Var("v",F4),
                                             MB(MB(MB(Call
                                                        ("HaveThumb2",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         LU),
                                                      Close
                                                        (bVar"v0",
                                                         MU(TP[Var("v",F4),
                                                               bVar"v0"],
                                                            qTy))),
                                                   Close
                                                     (Var("v",PTy(F4,bTy)),
                                                      Call
                                                        ("Take",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         Var("v",
                                                             PTy(F4,bTy))))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MU(Call
                                                            ("Hint",
                                                             CTy"instruction",
                                                             Call
                                                               ("PreloadDataLiteral",
                                                                CTy"Hint",
                                                                TP[EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'23"]),
                                                                      LW(1,
                                                                         1)),
                                                                   Mop(Cast
                                                                         F32,
                                                                       Mop(Cast
                                                                             (FTy 12),
                                                                           LL[bVar"b'11",
                                                                              bVar"b'10",
                                                                              bVar"b'9",
                                                                              bVar"b'8",
                                                                              bVar"b'7",
                                                                              bVar"b'6",
                                                                              bVar"b'5",
                                                                              bVar"b'4",
                                                                              bVar"b'3",
                                                                              bVar"b'2",
                                                                              bVar"b'1",
                                                                              bVar"b'0"]))])),
                                                          qTy),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,Mop(Not,bVar"b'21"),
                                               Bop(And,bVar"b'19",
                                                   Bop(And,bVar"b'18",
                                                       Bop(And,bVar"b'17",
                                                           Bop(And,
                                                               bVar"b'16",
                                                               Bop(And,
                                                                   bVar"b'15",
                                                                   Bop(And,
                                                                       bVar"b'14",
                                                                       Bop(And,
                                                                           bVar"b'13",
                                                                           bVar"b'12"))))))))),
                                       MB(Call
                                            ("ThumbCondition",
                                             ATy(qTy,PTy(F4,qTy)),LU),
                                          Close
                                            (Var("v",F4),
                                             MB(MB(MB(Call
                                                        ("ArchVersion",
                                                         ATy(qTy,
                                                             PTy(nTy,qTy)),
                                                         LU),
                                                      Close
                                                        (nVar"v0",
                                                         MB(MU(Bop(Ge,
                                                                   nVar"v0",
                                                                   LN 7),
                                                               qTy),
                                                            Close
                                                              (bVar"v0",
                                                               MU(TP[Var("v",
                                                                         F4),
                                                                     bVar"v0"],
                                                                  qTy))))),
                                                   Close
                                                     (Var("v",PTy(F4,bTy)),
                                                      Call
                                                        ("Take",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         Var("v",
                                                             PTy(F4,bTy))))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MU(Call
                                                            ("Hint",
                                                             CTy"instruction",
                                                             Call
                                                               ("PreloadInstruction",
                                                                CTy"Hint",
                                                                TP[EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'23"]),
                                                                      LW(1,
                                                                         1)),
                                                                   LW(15,4),
                                                                   Call
                                                                     ("immediate_form1",
                                                                      CTy"offset1",
                                                                      Mop(Cast
                                                                            F32,
                                                                          Mop(Cast
                                                                                (FTy 12),
                                                                              LL[bVar"b'11",
                                                                                 bVar"b'10",
                                                                                 bVar"b'9",
                                                                                 bVar"b'8",
                                                                                 bVar"b'7",
                                                                                 bVar"b'6",
                                                                                 bVar"b'5",
                                                                                 bVar"b'4",
                                                                                 bVar"b'3",
                                                                                 bVar"b'2",
                                                                                 bVar"b'1",
                                                                                 bVar"b'0"])))])),
                                                          qTy),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,bVar"b'23",
                                               Bop(And,
                                                   Mop(Not,bVar"b'21"),
                                                   Bop(And,bVar"b'15",
                                                       Bop(And,bVar"b'14",
                                                           Bop(And,
                                                               bVar"b'13",
                                                               bVar"b'12")))))),
                                       MB(Call
                                            ("ThumbCondition",
                                             ATy(qTy,PTy(F4,qTy)),LU),
                                          Close
                                            (Var("v",F4),
                                             MB(MB(MB(Call
                                                        ("ArchVersion",
                                                         ATy(qTy,
                                                             PTy(nTy,qTy)),
                                                         LU),
                                                      Close
                                                        (nVar"v0",
                                                         MB(MU(Bop(Ge,
                                                                   nVar"v0",
                                                                   LN 7),
                                                               qTy),
                                                            Close
                                                              (bVar"v0",
                                                               MU(TP[Var("v",
                                                                         F4),
                                                                     bVar"v0"],
                                                                  qTy))))),
                                                   Close
                                                     (Var("v",PTy(F4,bTy)),
                                                      Call
                                                        ("Take",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         Var("v",
                                                             PTy(F4,bTy))))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MU(Call
                                                            ("Hint",
                                                             CTy"instruction",
                                                             Call
                                                               ("PreloadInstruction",
                                                                CTy"Hint",
                                                                TP[LT,
                                                                   Mop(Cast
                                                                         F4,
                                                                       LL[bVar"b'19",
                                                                          bVar"b'18",
                                                                          bVar"b'17",
                                                                          bVar"b'16"]),
                                                                   Call
                                                                     ("immediate_form1",
                                                                      CTy"offset1",
                                                                      Mop(Cast
                                                                            F32,
                                                                          Mop(Cast
                                                                                (FTy 12),
                                                                              LL[bVar"b'11",
                                                                                 bVar"b'10",
                                                                                 bVar"b'9",
                                                                                 bVar"b'8",
                                                                                 bVar"b'7",
                                                                                 bVar"b'6",
                                                                                 bVar"b'5",
                                                                                 bVar"b'4",
                                                                                 bVar"b'3",
                                                                                 bVar"b'2",
                                                                                 bVar"b'1",
                                                                                 bVar"b'0"])))])),
                                                          qTy),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,bVar"b'23",
                                               Bop(And,bVar"b'15",
                                                   Bop(And,bVar"b'14",
                                                       Bop(And,bVar"b'13",
                                                           bVar"b'12"))))),
                                       Let(Var("W",F1),
                                           Mop(Cast F1,LL[bVar"b'21"]),
                                           MB(Call
                                                ("ThumbCondition",
                                                 ATy(qTy,PTy(F4,qTy)),LU),
                                              Close
                                                (Var("v",F4),
                                                 MB(MB(MB(ITE(EQ(Var("W",
                                                                     F1),
                                                                 LW(1,1)),
                                                              Call
                                                                ("HaveMPExt",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU)),
                                                          Close
                                                            (bVar"v0",
                                                             MU(TP[Var("v",
                                                                       F4),
                                                                   bVar"v0"],
                                                                qTy))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F4,bTy)),
                                                          Call
                                                            ("Take",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             Var("v",
                                                                 PTy(F4,
                                                                     bTy))))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MU(Call
                                                                ("Hint",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("PreloadData",
                                                                    CTy"Hint",
                                                                    TP[LT,
                                                                       EQ(Var("W",
                                                                              F1),
                                                                          LW(1,
                                                                             1)),
                                                                       Mop(Cast
                                                                             F4,
                                                                           LL[bVar"b'19",
                                                                              bVar"b'18",
                                                                              bVar"b'17",
                                                                              bVar"b'16"]),
                                                                       Call
                                                                         ("immediate_form1",
                                                                          CTy"offset1",
                                                                          Mop(Cast
                                                                                F32,
                                                                              Mop(Cast
                                                                                    (FTy 12),
                                                                                  LL[bVar"b'11",
                                                                                     bVar"b'10",
                                                                                     bVar"b'9",
                                                                                     bVar"b'8",
                                                                                     bVar"b'7",
                                                                                     bVar"b'6",
                                                                                     bVar"b'5",
                                                                                     bVar"b'4",
                                                                                     bVar"b'3",
                                                                                     bVar"b'2",
                                                                                     bVar"b'1",
                                                                                     bVar"b'0"])))])),
                                                              qTy),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU)))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,bVar"b'21",
                                               Bop(And,bVar"b'19",
                                                   Bop(And,bVar"b'18",
                                                       Bop(And,bVar"b'17",
                                                           Bop(And,
                                                               bVar"b'16",
                                                               Bop(And,
                                                                   bVar"b'15",
                                                                   Bop(And,
                                                                       bVar"b'14",
                                                                       Bop(And,
                                                                           bVar"b'13",
                                                                           bVar"b'12"))))))))),
                                       MU(Const
                                            ("NoOperation",
                                             CTy"instruction"),qTy)),
                                      (Bop(And,bVar"b'19",
                                           Bop(And,bVar"b'18",
                                               Bop(And,bVar"b'17",
                                                   bVar"b'16"))),
                                       Let(Var("Rt",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'15",bVar"b'14",
                                                  bVar"b'13",bVar"b'12"]),
                                           MB(Call
                                                ("ThumbCondition",
                                                 ATy(qTy,PTy(F4,qTy)),LU),
                                              Close
                                                (Var("v",F4),
                                                 MB(MB(MB(Call
                                                            ("HaveThumb2",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v0",
                                                             MU(TP[Var("v",
                                                                       F4),
                                                                   bVar"v0"],
                                                                qTy))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F4,bTy)),
                                                          Call
                                                            ("Take",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             Var("v",
                                                                 PTy(F4,
                                                                     bTy))))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(ITE(EQ(Var("Rt",
                                                                         F4),
                                                                     LW(13,
                                                                        4)),
                                                                  Call
                                                                    ("DECODE_UNPREDICTABLE",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[Var("mc",
                                                                            CTy"MachineCode"),
                                                                        LS
                                                                         "LoadByteLiteral/LoadHalfLiteral"]),
                                                                  MU(LU,
                                                                     qTy)),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Let(Var("imm32",
                                                                            F32),
                                                                        Mop(Cast
                                                                              F32,
                                                                            Mop(Cast
                                                                                  (FTy 12),
                                                                                LL[bVar"b'11",
                                                                                   bVar"b'10",
                                                                                   bVar"b'9",
                                                                                   bVar"b'8",
                                                                                   bVar"b'7",
                                                                                   bVar"b'6",
                                                                                   bVar"b'5",
                                                                                   bVar"b'4",
                                                                                   bVar"b'3",
                                                                                   bVar"b'2",
                                                                                   bVar"b'1",
                                                                                   bVar"b'0"])),
                                                                        Let(bVar"add",
                                                                            EQ(Mop(Cast
                                                                                     F1,
                                                                                   LL[bVar"b'23"]),
                                                                               LW(1,
                                                                                  1)),
                                                                            Let(bVar"unsigned",
                                                                                EQ(Mop(Cast
                                                                                         F1,
                                                                                       LL[bVar"b'24"]),
                                                                                   LW(0,
                                                                                      1)),
                                                                                ITE(EQ(Mop(Cast
                                                                                             F1,
                                                                                           LL[bVar"b'21"]),
                                                                                       LW(1,
                                                                                          1)),
                                                                                    Call
                                                                                      ("Load",
                                                                                       CTy"instruction",
                                                                                       Call
                                                                                         ("LoadHalfLiteral",
                                                                                          CTy"Load",
                                                                                          TP[bVar"unsigned",
                                                                                             bVar"add",
                                                                                             Var("Rt",
                                                                                                 F4),
                                                                                             Var("imm32",
                                                                                                 F32)])),
                                                                                    Call
                                                                                      ("Load",
                                                                                       CTy"instruction",
                                                                                       Call
                                                                                         ("LoadByteLiteral",
                                                                                          CTy"Load",
                                                                                          TP[bVar"unsigned",
                                                                                             bVar"add",
                                                                                             Var("Rt",
                                                                                                 F4),
                                                                                             Var("imm32",
                                                                                                 F32)])))))),
                                                                    qTy))),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU)))))))),
                                      (bVar"b'23",
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rt",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'15",
                                                      bVar"b'14",
                                                      bVar"b'13",
                                                      bVar"b'12"]),
                                               MB(Call
                                                    ("ThumbCondition",
                                                     ATy(qTy,PTy(F4,qTy)),
                                                     LU),
                                                  Close
                                                    (Var("v",F4),
                                                     MB(MB(MB(Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F4,
                                                                      bTy)),
                                                              Call
                                                                ("Take",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F4,
                                                                         bTy))))),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(ITE(EQ(Var("Rt",
                                                                             F4),
                                                                         LW(13,
                                                                            4)),
                                                                      Call
                                                                        ("DECODE_UNPREDICTABLE",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[Var("mc",
                                                                                CTy"MachineCode"),
                                                                            LS
                                                                             "LoadByte/LoadHalf (immediate)"]),
                                                                      MU(LU,
                                                                         qTy)),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Let(bVar"add",
                                                                            LT,
                                                                            Let(bVar"index",
                                                                                LT,
                                                                                Let(bVar"wback",
                                                                                    LF,
                                                                                    Let(Var("m",
                                                                                            CTy"offset1"),
                                                                                        Call
                                                                                          ("immediate_form1",
                                                                                           CTy"offset1",
                                                                                           Mop(Cast
                                                                                                 F32,
                                                                                               Mop(Cast
                                                                                                     (FTy 12),
                                                                                                   LL[bVar"b'11",
                                                                                                      bVar"b'10",
                                                                                                      bVar"b'9",
                                                                                                      bVar"b'8",
                                                                                                      bVar"b'7",
                                                                                                      bVar"b'6",
                                                                                                      bVar"b'5",
                                                                                                      bVar"b'4",
                                                                                                      bVar"b'3",
                                                                                                      bVar"b'2",
                                                                                                      bVar"b'1",
                                                                                                      bVar"b'0"]))),
                                                                                        Let(bVar"unsigned",
                                                                                            EQ(Mop(Cast
                                                                                                     F1,
                                                                                                   LL[bVar"b'24"]),
                                                                                               LW(0,
                                                                                                  1)),
                                                                                            ITE(EQ(Mop(Cast
                                                                                                         F1,
                                                                                                       LL[bVar"b'21"]),
                                                                                                   LW(1,
                                                                                                      1)),
                                                                                                Call
                                                                                                  ("Load",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("LoadHalf",
                                                                                                      CTy"Load",
                                                                                                      TP[bVar"unsigned",
                                                                                                         bVar"add",
                                                                                                         bVar"index",
                                                                                                         bVar"wback",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Var("m",
                                                                                                             CTy"offset1")])),
                                                                                                Call
                                                                                                  ("Load",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("LoadByte",
                                                                                                      CTy"Load",
                                                                                                      TP[bVar"unsigned",
                                                                                                         bVar"add",
                                                                                                         bVar"index",
                                                                                                         bVar"wback",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Var("m",
                                                                                                             CTy"offset1")])))))))),
                                                                        qTy))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,bVar"b'15",
                                                   Bop(And,bVar"b'14",
                                                       Bop(And,bVar"b'13",
                                                           Bop(And,
                                                               bVar"b'12",
                                                               Bop(And,
                                                                   bVar"b'11",
                                                                   Bop(And,
                                                                       bVar"b'10",
                                                                       Bop(And,
                                                                           Mop(Not,
                                                                               bVar"b'9"),
                                                                           Mop(Not,
                                                                               bVar"b'8")))))))))),
                                       Let(Var("W",F1),
                                           Mop(Cast F1,LL[bVar"b'21"]),
                                           MB(Call
                                                ("ThumbCondition",
                                                 ATy(qTy,PTy(F4,qTy)),LU),
                                              Close
                                                (Var("v",F4),
                                                 MB(MB(MB(ITE(EQ(Var("W",
                                                                     F1),
                                                                 LW(1,1)),
                                                              Call
                                                                ("HaveMPExt",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU)),
                                                          Close
                                                            (bVar"v0",
                                                             MU(TP[Var("v",
                                                                       F4),
                                                                   bVar"v0"],
                                                                qTy))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F4,bTy)),
                                                          Call
                                                            ("Take",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             Var("v",
                                                                 PTy(F4,
                                                                     bTy))))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MU(Call
                                                                ("Hint",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("PreloadData",
                                                                    CTy"Hint",
                                                                    TP[LF,
                                                                       EQ(Var("W",
                                                                              F1),
                                                                          LW(1,
                                                                             1)),
                                                                       Mop(Cast
                                                                             F4,
                                                                           LL[bVar"b'19",
                                                                              bVar"b'18",
                                                                              bVar"b'17",
                                                                              bVar"b'16"]),
                                                                       Call
                                                                         ("immediate_form1",
                                                                          CTy"offset1",
                                                                          Mop(Cast
                                                                                F32,
                                                                              Mop(Cast
                                                                                    F8,
                                                                                  LL[bVar"b'7",
                                                                                     bVar"b'6",
                                                                                     bVar"b'5",
                                                                                     bVar"b'4",
                                                                                     bVar"b'3",
                                                                                     bVar"b'2",
                                                                                     bVar"b'1",
                                                                                     bVar"b'0"])))])),
                                                              qTy),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU)))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,
                                                   Mop(Not,bVar"b'21"),
                                                   Bop(And,bVar"b'15",
                                                       Bop(And,bVar"b'14",
                                                           Bop(And,
                                                               bVar"b'13",
                                                               Bop(And,
                                                                   bVar"b'12",
                                                                   Bop(And,
                                                                       bVar"b'11",
                                                                       Bop(And,
                                                                           bVar"b'10",
                                                                           Bop(And,
                                                                               Mop(Not,
                                                                                   bVar"b'9"),
                                                                               Mop(Not,
                                                                                   bVar"b'8"))))))))))),
                                       MB(Call
                                            ("ThumbCondition",
                                             ATy(qTy,PTy(F4,qTy)),LU),
                                          Close
                                            (Var("v",F4),
                                             MB(MB(MB(Call
                                                        ("ArchVersion",
                                                         ATy(qTy,
                                                             PTy(nTy,qTy)),
                                                         LU),
                                                      Close
                                                        (nVar"v0",
                                                         MB(MU(Bop(Ge,
                                                                   nVar"v0",
                                                                   LN 7),
                                                               qTy),
                                                            Close
                                                              (bVar"v0",
                                                               MU(TP[Var("v",
                                                                         F4),
                                                                     bVar"v0"],
                                                                  qTy))))),
                                                   Close
                                                     (Var("v",PTy(F4,bTy)),
                                                      Call
                                                        ("Take",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         Var("v",
                                                             PTy(F4,bTy))))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MU(Call
                                                            ("Hint",
                                                             CTy"instruction",
                                                             Call
                                                               ("PreloadInstruction",
                                                                CTy"Hint",
                                                                TP[LF,
                                                                   Mop(Cast
                                                                         F4,
                                                                       LL[bVar"b'19",
                                                                          bVar"b'18",
                                                                          bVar"b'17",
                                                                          bVar"b'16"]),
                                                                   Call
                                                                     ("immediate_form1",
                                                                      CTy"offset1",
                                                                      Mop(Cast
                                                                            F32,
                                                                          Mop(Cast
                                                                                F8,
                                                                              LL[bVar"b'7",
                                                                                 bVar"b'6",
                                                                                 bVar"b'5",
                                                                                 bVar"b'4",
                                                                                 bVar"b'3",
                                                                                 bVar"b'2",
                                                                                 bVar"b'1",
                                                                                 bVar"b'0"])))])),
                                                          qTy),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU))))))),
                                      (Bop(And,Mop(Not,bVar"b'23"),
                                           Bop(And,bVar"b'11",
                                               Bop(And,
                                                   Mop(Not,bVar"b'10"),
                                                   Mop(Not,bVar"b'8")))),
                                       MU(Call
                                            ("Undefined",CTy"instruction",
                                             LW(0,32)),qTy)),
                                      (Bop(And,Mop(Not,bVar"b'23"),
                                           Bop(And,bVar"b'11",
                                               Bop(And,bVar"b'10",
                                                   Bop(And,bVar"b'9",
                                                       Mop(Not,bVar"b'8"))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rt",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'15",
                                                      bVar"b'14",
                                                      bVar"b'13",
                                                      bVar"b'12"]),
                                               MB(Call
                                                    ("ThumbCondition",
                                                     ATy(qTy,PTy(F4,qTy)),
                                                     LU),
                                                  Close
                                                    (Var("v",F4),
                                                     MB(MB(MB(Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F4,
                                                                      bTy)),
                                                              Call
                                                                ("Take",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F4,
                                                                         bTy))))),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(ITE(Bop(In,
                                                                          Var("Rt",
                                                                              F4),
                                                                          SL[LW(13,
                                                                                4),
                                                                             LW(15,
                                                                                4)]),
                                                                      Call
                                                                        ("DECODE_UNPREDICTABLE",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[Var("mc",
                                                                                CTy"MachineCode"),
                                                                            LS
                                                                             "LoadUnprivileged"]),
                                                                      MU(LU,
                                                                         qTy)),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Let(bVar"add",
                                                                            LT,
                                                                            Let(bVar"postindex",
                                                                                LF,
                                                                                Let(bVar"unsigned",
                                                                                    EQ(Mop(Cast
                                                                                             F1,
                                                                                           LL[bVar"b'24"]),
                                                                                       LW(0,
                                                                                          1)),
                                                                                    Let(Var("imm32",
                                                                                            F32),
                                                                                        Mop(Cast
                                                                                              F32,
                                                                                            Mop(Cast
                                                                                                  F8,
                                                                                                LL[bVar"b'7",
                                                                                                   bVar"b'6",
                                                                                                   bVar"b'5",
                                                                                                   bVar"b'4",
                                                                                                   bVar"b'3",
                                                                                                   bVar"b'2",
                                                                                                   bVar"b'1",
                                                                                                   bVar"b'0"])),
                                                                                        Let(Var("m",
                                                                                                CTy"offset2"),
                                                                                            Call
                                                                                              ("immediate_form2",
                                                                                               CTy"offset2",
                                                                                               Var("imm32",
                                                                                                   F32)),
                                                                                            ITB([(EQ(Mop(Cast
                                                                                                           F1,
                                                                                                         LL[bVar"b'21"]),
                                                                                                     LW(1,
                                                                                                        1)),
                                                                                                  Call
                                                                                                    ("Load",
                                                                                                     CTy"instruction",
                                                                                                     Call
                                                                                                       ("LoadHalfUnprivileged",
                                                                                                        CTy"Load",
                                                                                                        TP[bVar"unsigned",
                                                                                                           bVar"add",
                                                                                                           bVar"postindex",
                                                                                                           Var("Rt",
                                                                                                               F4),
                                                                                                           Var("Rn",
                                                                                                               F4),
                                                                                                           Var("m",
                                                                                                               CTy"offset2")]))),
                                                                                                 (bVar"unsigned",
                                                                                                  Call
                                                                                                    ("Load",
                                                                                                     CTy"instruction",
                                                                                                     Call
                                                                                                       ("LoadByteUnprivileged",
                                                                                                        CTy"Load",
                                                                                                        TP[bVar"add",
                                                                                                           bVar"postindex",
                                                                                                           Var("Rt",
                                                                                                               F4),
                                                                                                           Var("Rn",
                                                                                                               F4),
                                                                                                           Call
                                                                                                             ("immediate_form1",
                                                                                                              CTy"offset1",
                                                                                                              Var("imm32",
                                                                                                                  F32))])))],
                                                                                                Call
                                                                                                  ("Load",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("LoadSignedByteUnprivileged",
                                                                                                      CTy"Load",
                                                                                                      TP[bVar"add",
                                                                                                         bVar"postindex",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Var("m",
                                                                                                             CTy"offset2")])))))))),
                                                                        qTy))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU))))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,bVar"b'21",
                                                   Bop(And,bVar"b'15",
                                                       Bop(And,bVar"b'14",
                                                           Bop(And,
                                                               bVar"b'13",
                                                               Bop(And,
                                                                   bVar"b'12",
                                                                   Bop(And,
                                                                       bVar"b'11",
                                                                       Bop(And,
                                                                           bVar"b'10",
                                                                           Bop(And,
                                                                               Mop(Not,
                                                                                   bVar"b'9"),
                                                                               Mop(Not,
                                                                                   bVar"b'8"))))))))))),
                                       MU(Const
                                            ("NoOperation",
                                             CTy"instruction"),qTy)),
                                      (Bop(And,Mop(Not,bVar"b'23"),
                                           bVar"b'11"),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rt",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'15",
                                                      bVar"b'14",
                                                      bVar"b'13",
                                                      bVar"b'12"]),
                                               MB(Call
                                                    ("ThumbCondition",
                                                     ATy(qTy,PTy(F4,qTy)),
                                                     LU),
                                                  Close
                                                    (Var("v",F4),
                                                     MB(MB(MB(Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F4,
                                                                      bTy)),
                                                              Call
                                                                ("Take",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F4,
                                                                         bTy))))),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               Let(bVar"wback",
                                                                   EQ(Mop(Cast
                                                                            F1,
                                                                          LL[bVar"b'8"]),
                                                                      LW(1,
                                                                         1)),
                                                                   MB(ITE(Bop(Or,
                                                                              Bop(Or,
                                                                                  EQ(Var("Rt",
                                                                                         F4),
                                                                                     LW(13,
                                                                                        4)),
                                                                                  Bop(And,
                                                                                      EQ(Var("Rt",
                                                                                             F4),
                                                                                         LW(15,
                                                                                            4)),
                                                                                      bVar"wback")),
                                                                              Bop(And,
                                                                                  bVar"wback",
                                                                                  EQ(Var("Rn",
                                                                                         F4),
                                                                                     Var("Rt",
                                                                                         F4)))),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "Load (immediate)"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Let(bVar"add",
                                                                                EQ(Mop(Cast
                                                                                         F1,
                                                                                       LL[bVar"b'9"]),
                                                                                   LW(1,
                                                                                      1)),
                                                                                Let(bVar"index",
                                                                                    EQ(Mop(Cast
                                                                                             F1,
                                                                                           LL[bVar"b'10"]),
                                                                                       LW(1,
                                                                                          1)),
                                                                                    Let(bVar"unsigned",
                                                                                        EQ(Mop(Cast
                                                                                                 F1,
                                                                                               LL[bVar"b'24"]),
                                                                                           LW(0,
                                                                                              1)),
                                                                                        Let(Var("m",
                                                                                                CTy"offset1"),
                                                                                            Call
                                                                                              ("immediate_form1",
                                                                                               CTy"offset1",
                                                                                               Mop(Cast
                                                                                                     F32,
                                                                                                   Mop(Cast
                                                                                                         F8,
                                                                                                       LL[bVar"b'7",
                                                                                                          bVar"b'6",
                                                                                                          bVar"b'5",
                                                                                                          bVar"b'4",
                                                                                                          bVar"b'3",
                                                                                                          bVar"b'2",
                                                                                                          bVar"b'1",
                                                                                                          bVar"b'0"]))),
                                                                                            ITE(EQ(Mop(Cast
                                                                                                         F1,
                                                                                                       LL[bVar"b'21"]),
                                                                                                   LW(1,
                                                                                                      1)),
                                                                                                Call
                                                                                                  ("Load",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("LoadHalf",
                                                                                                      CTy"Load",
                                                                                                      TP[bVar"unsigned",
                                                                                                         bVar"add",
                                                                                                         bVar"index",
                                                                                                         bVar"wback",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Var("m",
                                                                                                             CTy"offset1")])),
                                                                                                Call
                                                                                                  ("Load",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("LoadByte",
                                                                                                      CTy"Load",
                                                                                                      TP[bVar"unsigned",
                                                                                                         bVar"add",
                                                                                                         bVar"index",
                                                                                                         bVar"wback",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Var("m",
                                                                                                             CTy"offset1")]))))))),
                                                                            qTy)))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU))))))))),
                                      (Bop(And,Mop(Not,bVar"b'24"),
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,bVar"b'15",
                                                   Bop(And,bVar"b'14",
                                                       Bop(And,bVar"b'13",
                                                           Bop(And,
                                                               bVar"b'12",
                                                               Bop(And,
                                                                   Mop(Not,
                                                                       bVar"b'11"),
                                                                   Bop(And,
                                                                       Mop(Not,
                                                                           bVar"b'10"),
                                                                       Bop(And,
                                                                           Mop(Not,
                                                                               bVar"b'9"),
                                                                           Bop(And,
                                                                               Mop(Not,
                                                                                   bVar"b'8"),
                                                                               Bop(And,
                                                                                   Mop(Not,
                                                                                       bVar"b'7"),
                                                                                   Mop(Not,
                                                                                       bVar"b'6")))))))))))),
                                       Let(Var("W",F1),
                                           Mop(Cast F1,LL[bVar"b'21"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               MB(Call
                                                    ("ThumbCondition",
                                                     ATy(qTy,PTy(F4,qTy)),
                                                     LU),
                                                  Close
                                                    (Var("v",F4),
                                                     MB(MB(MB(ITE(EQ(Var("W",
                                                                         F1),
                                                                     LW(1,
                                                                        1)),
                                                                  Call
                                                                    ("HaveMPExt",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU)),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F4,
                                                                      bTy)),
                                                              Call
                                                                ("Take",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F4,
                                                                         bTy))))),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(ITE(Bop(In,
                                                                          Var("Rm",
                                                                              F4),
                                                                          SL[LW(13,
                                                                                4),
                                                                             LW(15,
                                                                                4)]),
                                                                      Call
                                                                        ("DECODE_UNPREDICTABLE",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[Var("mc",
                                                                                CTy"MachineCode"),
                                                                            LS
                                                                             "PreloadData"]),
                                                                      MU(LU,
                                                                         qTy)),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("Hint",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("PreloadData",
                                                                              CTy"Hint",
                                                                              TP[LT,
                                                                                 EQ(Var("W",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 Mop(Cast
                                                                                       F4,
                                                                                     LL[bVar"b'19",
                                                                                        bVar"b'18",
                                                                                        bVar"b'17",
                                                                                        bVar"b'16"]),
                                                                                 Call
                                                                                   ("register_form1",
                                                                                    CTy"offset1",
                                                                                    TP[Var("Rm",
                                                                                           F4),
                                                                                       LC("SRType_LSL",
                                                                                          CTy"SRType"),
                                                                                       Mop(Cast
                                                                                             nTy,
                                                                                           Mop(Cast
                                                                                                 (FTy 2),
                                                                                               LL[bVar"b'5",
                                                                                                  bVar"b'4"]))])])),
                                                                        qTy))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU))))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,
                                                   Mop(Not,bVar"b'21"),
                                                   Bop(And,bVar"b'15",
                                                       Bop(And,bVar"b'14",
                                                           Bop(And,
                                                               bVar"b'13",
                                                               Bop(And,
                                                                   bVar"b'12",
                                                                   Bop(And,
                                                                       Mop(Not,
                                                                           bVar"b'11"),
                                                                       Bop(And,
                                                                           Mop(Not,
                                                                               bVar"b'10"),
                                                                           Bop(And,
                                                                               Mop(Not,
                                                                                   bVar"b'9"),
                                                                               Bop(And,
                                                                                   Mop(Not,
                                                                                       bVar"b'8"),
                                                                                   Bop(And,
                                                                                       Mop(Not,
                                                                                           bVar"b'7"),
                                                                                       Mop(Not,
                                                                                           bVar"b'6"))))))))))))),
                                       Let(Var("Rm",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'3",bVar"b'2",
                                                  bVar"b'1",bVar"b'0"]),
                                           MB(Call
                                                ("ThumbCondition",
                                                 ATy(qTy,PTy(F4,qTy)),LU),
                                              Close
                                                (Var("v",F4),
                                                 MB(MB(MB(Call
                                                            ("ArchVersion",
                                                             ATy(qTy,
                                                                 PTy(nTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (nVar"v0",
                                                             MB(MU(Bop(Ge,
                                                                       nVar"v0",
                                                                       LN
                                                                        7),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v0",
                                                                   MU(TP[Var("v",
                                                                             F4),
                                                                         bVar"v0"],
                                                                      qTy))))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F4,bTy)),
                                                          Call
                                                            ("Take",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             Var("v",
                                                                 PTy(F4,
                                                                     bTy))))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(ITE(Bop(In,
                                                                      Var("Rm",
                                                                          F4),
                                                                      SL[LW(13,
                                                                            4),
                                                                         LW(15,
                                                                            4)]),
                                                                  Call
                                                                    ("DECODE_UNPREDICTABLE",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[Var("mc",
                                                                            CTy"MachineCode"),
                                                                        LS
                                                                         "PreloadInstruction"]),
                                                                  MU(LU,
                                                                     qTy)),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Call
                                                                      ("Hint",
                                                                       CTy"instruction",
                                                                       Call
                                                                         ("PreloadInstruction",
                                                                          CTy"Hint",
                                                                          TP[LT,
                                                                             Mop(Cast
                                                                                   F4,
                                                                                 LL[bVar"b'19",
                                                                                    bVar"b'18",
                                                                                    bVar"b'17",
                                                                                    bVar"b'16"]),
                                                                             Call
                                                                               ("register_form1",
                                                                                CTy"offset1",
                                                                                TP[Var("Rm",
                                                                                       F4),
                                                                                   LC("SRType_LSL",
                                                                                      CTy"SRType"),
                                                                                   Mop(Cast
                                                                                         nTy,
                                                                                       Mop(Cast
                                                                                             (FTy 2),
                                                                                           LL[bVar"b'5",
                                                                                              bVar"b'4"]))])])),
                                                                    qTy))),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU)))))))),
                                      (Bop(And,bVar"b'24",
                                           Bop(And,Mop(Not,bVar"b'23"),
                                               Bop(And,bVar"b'21",
                                                   Bop(And,bVar"b'15",
                                                       Bop(And,bVar"b'14",
                                                           Bop(And,
                                                               bVar"b'13",
                                                               Bop(And,
                                                                   bVar"b'12",
                                                                   Bop(And,
                                                                       Mop(Not,
                                                                           bVar"b'11"),
                                                                       Bop(And,
                                                                           Mop(Not,
                                                                               bVar"b'10"),
                                                                           Bop(And,
                                                                               Mop(Not,
                                                                                   bVar"b'9"),
                                                                               Bop(And,
                                                                                   Mop(Not,
                                                                                       bVar"b'8"),
                                                                                   Bop(And,
                                                                                       Mop(Not,
                                                                                           bVar"b'7"),
                                                                                       Mop(Not,
                                                                                           bVar"b'6"))))))))))))),
                                       MU(Const
                                            ("NoOperation",
                                             CTy"instruction"),qTy)),
                                      (Bop(And,Mop(Not,bVar"b'23"),
                                           Bop(And,Mop(Not,bVar"b'11"),
                                               Bop(And,
                                                   Mop(Not,bVar"b'10"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'9"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'8"),
                                                           Bop(And,
                                                               Mop(Not,
                                                                   bVar"b'7"),
                                                               Mop(Not,
                                                                   bVar"b'6"))))))),
                                       Let(Var("Rn",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'19",bVar"b'18",
                                                  bVar"b'17",bVar"b'16"]),
                                           Let(Var("Rm",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'3",bVar"b'2",
                                                      bVar"b'1",bVar"b'0"]),
                                               Let(Var("Rt",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'15",
                                                          bVar"b'14",
                                                          bVar"b'13",
                                                          bVar"b'12"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(ITE(Bop(Or,
                                                                              EQ(Var("Rt",
                                                                                     F4),
                                                                                 LW(13,
                                                                                    4)),
                                                                              Bop(In,
                                                                                  Var("Rm",
                                                                                      F4),
                                                                                  SL[LW(13,
                                                                                        4),
                                                                                     LW(15,
                                                                                        4)])),
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "Load (register)"]),
                                                                          MU(LU,
                                                                             qTy)),
                                                                      Close
                                                                        (AVar
                                                                           uTy,
                                                                         MU(Let(bVar"add",
                                                                                LT,
                                                                                Let(bVar"index",
                                                                                    LT,
                                                                                    Let(bVar"wback",
                                                                                        LF,
                                                                                        Let(bVar"unsigned",
                                                                                            EQ(Mop(Cast
                                                                                                     F1,
                                                                                                   LL[bVar"b'24"]),
                                                                                               LW(0,
                                                                                                  1)),
                                                                                            Let(Var("m",
                                                                                                    CTy"offset1"),
                                                                                                Call
                                                                                                  ("register_form1",
                                                                                                   CTy"offset1",
                                                                                                   TP[Var("Rm",
                                                                                                          F4),
                                                                                                      LC("SRType_LSL",
                                                                                                         CTy"SRType"),
                                                                                                      Mop(Cast
                                                                                                            nTy,
                                                                                                          Mop(Cast
                                                                                                                (FTy 2),
                                                                                                              LL[bVar"b'5",
                                                                                                                 bVar"b'4"]))]),
                                                                                                ITE(EQ(Mop(Cast
                                                                                                             F1,
                                                                                                           LL[bVar"b'21"]),
                                                                                                       LW(1,
                                                                                                          1)),
                                                                                                    Call
                                                                                                      ("Load",
                                                                                                       CTy"instruction",
                                                                                                       Call
                                                                                                         ("LoadHalf",
                                                                                                          CTy"Load",
                                                                                                          TP[bVar"unsigned",
                                                                                                             bVar"add",
                                                                                                             bVar"index",
                                                                                                             bVar"wback",
                                                                                                             Var("Rt",
                                                                                                                 F4),
                                                                                                             Var("Rn",
                                                                                                                 F4),
                                                                                                             Var("m",
                                                                                                                 CTy"offset1")])),
                                                                                                    Call
                                                                                                      ("Load",
                                                                                                       CTy"instruction",
                                                                                                       Call
                                                                                                         ("LoadByte",
                                                                                                          CTy"Load",
                                                                                                          TP[bVar"unsigned",
                                                                                                             bVar"add",
                                                                                                             bVar"index",
                                                                                                             bVar"wback",
                                                                                                             Var("Rt",
                                                                                                                 F4),
                                                                                                             Var("Rn",
                                                                                                                 F4),
                                                                                                             Var("m",
                                                                                                                 CTy"offset1")])))))))),
                                                                            qTy))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU))))))))))],
                                     Call
                                       ("UndefinedThumb",
                                        ATy(qTy,PTy(CTy"instruction",qTy)),
                                        LU)),
                                 Call
                                   ("UndefinedThumb",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                            (Bop(And,bVar"b'31",
                                 Bop(And,bVar"b'30",
                                     Bop(And,bVar"b'29",
                                         Bop(And,Mop(Not,bVar"b'26"),
                                             Mop(Not,bVar"b'24"))))),
                             ITB([(Bop(And,Mop(Not,bVar"b'23"),
                                       Bop(And,Mop(Not,bVar"b'11"),
                                           Bop(And,Mop(Not,bVar"b'10"),
                                               Bop(And,Mop(Not,bVar"b'9"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'8"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'7"),
                                                           Mop(Not,
                                                               bVar"b'6"))))))),
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       Let(Var("Rm",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'3",bVar"b'2",
                                                  bVar"b'1",bVar"b'0"]),
                                           Let(Var("Rt",F4),
                                               Mop(Cast F4,
                                                   LL[bVar"b'15",
                                                      bVar"b'14",
                                                      bVar"b'13",
                                                      bVar"b'12"]),
                                               MB(Call
                                                    ("ThumbCondition",
                                                     ATy(qTy,PTy(F4,qTy)),
                                                     LU),
                                                  Close
                                                    (Var("v",F4),
                                                     MB(MB(MB(Call
                                                                ("HaveThumb2",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v0",
                                                                 MB(MU(Bop(And,
                                                                           Mop(Not,
                                                                               EQ(Var("Rn",
                                                                                      F4),
                                                                                  LW(15,
                                                                                     4))),
                                                                           bVar"v0"),
                                                                       qTy),
                                                                    Close
                                                                      (bVar"v0",
                                                                       MU(TP[Var("v",
                                                                                 F4),
                                                                             bVar"v0"],
                                                                          qTy))))),
                                                           Close
                                                             (Var("v",
                                                                  PTy(F4,
                                                                      bTy)),
                                                              Call
                                                                ("Take",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 Var("v",
                                                                     PTy(F4,
                                                                         bTy))))),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MB(ITE(Bop(Or,
                                                                          Bop(In,
                                                                              Var("Rt",
                                                                                  F4),
                                                                              SL[LW(13,
                                                                                    4),
                                                                                 LW(15,
                                                                                    4)]),
                                                                          Bop(In,
                                                                              Var("Rm",
                                                                                  F4),
                                                                              SL[LW(13,
                                                                                    4),
                                                                                 LW(15,
                                                                                    4)])),
                                                                      Call
                                                                        ("DECODE_UNPREDICTABLE",
                                                                         ATy(qTy,
                                                                             PTy(uTy,
                                                                                 qTy)),
                                                                         TP[Var("mc",
                                                                                CTy"MachineCode"),
                                                                            LS
                                                                             "StoreByte/Half (register)"]),
                                                                      MU(LU,
                                                                         qTy)),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Let(bVar"add",
                                                                            LT,
                                                                            Let(bVar"index",
                                                                                LT,
                                                                                Let(bVar"wback",
                                                                                    LF,
                                                                                    Let(Var("m",
                                                                                            CTy"offset1"),
                                                                                        Call
                                                                                          ("register_form1",
                                                                                           CTy"offset1",
                                                                                           TP[Var("Rm",
                                                                                                  F4),
                                                                                              LC("SRType_LSL",
                                                                                                 CTy"SRType"),
                                                                                              Mop(Cast
                                                                                                    nTy,
                                                                                                  Mop(Cast
                                                                                                        (FTy 2),
                                                                                                      LL[bVar"b'5",
                                                                                                         bVar"b'4"]))]),
                                                                                        ITE(EQ(Mop(Cast
                                                                                                     F1,
                                                                                                   LL[bVar"b'21"]),
                                                                                               LW(1,
                                                                                                  1)),
                                                                                            Call
                                                                                              ("Store",
                                                                                               CTy"instruction",
                                                                                               Call
                                                                                                 ("StoreHalf",
                                                                                                  CTy"Store",
                                                                                                  TP[bVar"add",
                                                                                                     bVar"index",
                                                                                                     bVar"wback",
                                                                                                     Var("Rt",
                                                                                                         F4),
                                                                                                     Var("Rn",
                                                                                                         F4),
                                                                                                     Var("m",
                                                                                                         CTy"offset1")])),
                                                                                            Call
                                                                                              ("Store",
                                                                                               CTy"instruction",
                                                                                               Call
                                                                                                 ("StoreByte",
                                                                                                  CTy"Store",
                                                                                                  TP[bVar"add",
                                                                                                     bVar"index",
                                                                                                     bVar"wback",
                                                                                                     Var("Rt",
                                                                                                         F4),
                                                                                                     Var("Rn",
                                                                                                         F4),
                                                                                                     Var("m",
                                                                                                         CTy"offset1")]))))))),
                                                                        qTy))),
                                                               Call
                                                                 ("Skip",
                                                                  ATy(qTy,
                                                                      PTy(CTy"instruction",
                                                                          qTy)),
                                                                  LU)))))))))),
                                  (Bop(And,Mop(Not,bVar"b'23"),
                                       Bop(And,bVar"b'11",
                                           Bop(And,bVar"b'10",
                                               Bop(And,bVar"b'9",
                                                   Mop(Not,bVar"b'8"))))),
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       Let(Var("Rt",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'15",bVar"b'14",
                                                  bVar"b'13",bVar"b'12"]),
                                           MB(Call
                                                ("ThumbCondition",
                                                 ATy(qTy,PTy(F4,qTy)),LU),
                                              Close
                                                (Var("v",F4),
                                                 MB(MB(MB(Call
                                                            ("HaveThumb2",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v0",
                                                             MB(MU(Bop(And,
                                                                       Mop(Not,
                                                                           EQ(Var("Rn",
                                                                                  F4),
                                                                              LW(15,
                                                                                 4))),
                                                                       bVar"v0"),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v0",
                                                                   MU(TP[Var("v",
                                                                             F4),
                                                                         bVar"v0"],
                                                                      qTy))))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F4,bTy)),
                                                          Call
                                                            ("Take",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             Var("v",
                                                                 PTy(F4,
                                                                     bTy))))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(ITE(Bop(In,
                                                                      Var("Rt",
                                                                          F4),
                                                                      SL[LW(13,
                                                                            4),
                                                                         LW(15,
                                                                            4)]),
                                                                  Call
                                                                    ("DECODE_UNPREDICTABLE",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[Var("mc",
                                                                            CTy"MachineCode"),
                                                                        LS
                                                                         "StoreByte/HalfUnprivileged"]),
                                                                  MU(LU,
                                                                     qTy)),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Let(bVar"add",
                                                                        LT,
                                                                        Let(bVar"postindex",
                                                                            LF,
                                                                            Let(Var("imm32",
                                                                                    F32),
                                                                                Mop(Cast
                                                                                      F32,
                                                                                    Mop(Cast
                                                                                          F8,
                                                                                        LL[bVar"b'7",
                                                                                           bVar"b'6",
                                                                                           bVar"b'5",
                                                                                           bVar"b'4",
                                                                                           bVar"b'3",
                                                                                           bVar"b'2",
                                                                                           bVar"b'1",
                                                                                           bVar"b'0"])),
                                                                                ITE(EQ(Mop(Cast
                                                                                             F1,
                                                                                           LL[bVar"b'21"]),
                                                                                       LW(1,
                                                                                          1)),
                                                                                    Call
                                                                                      ("Store",
                                                                                       CTy"instruction",
                                                                                       Call
                                                                                         ("StoreHalfUnprivileged",
                                                                                          CTy"Store",
                                                                                          TP[bVar"add",
                                                                                             bVar"postindex",
                                                                                             Var("Rt",
                                                                                                 F4),
                                                                                             Var("Rn",
                                                                                                 F4),
                                                                                             Call
                                                                                               ("immediate_form2",
                                                                                                CTy"offset2",
                                                                                                Var("imm32",
                                                                                                    F32))])),
                                                                                    Call
                                                                                      ("Store",
                                                                                       CTy"instruction",
                                                                                       Call
                                                                                         ("StoreByteUnprivileged",
                                                                                          CTy"Store",
                                                                                          TP[bVar"add",
                                                                                             bVar"postindex",
                                                                                             Var("Rt",
                                                                                                 F4),
                                                                                             Var("Rn",
                                                                                                 F4),
                                                                                             Call
                                                                                               ("immediate_form1",
                                                                                                CTy"offset1",
                                                                                                Var("imm32",
                                                                                                    F32))])))))),
                                                                    qTy))),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU))))))))),
                                  (Bop(And,Mop(Not,bVar"b'23"),bVar"b'11"),
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       Let(Var("W",F1),
                                           Mop(Cast F1,LL[bVar"b'8"]),
                                           Let(Var("P",F1),
                                               Mop(Cast F1,LL[bVar"b'10"]),
                                               Let(Var("Rt",F4),
                                                   Mop(Cast F4,
                                                       LL[bVar"b'15",
                                                          bVar"b'14",
                                                          bVar"b'13",
                                                          bVar"b'12"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MB(MU(Bop(And,
                                                                               Bop(And,
                                                                                   Mop(Not,
                                                                                       EQ(Var("Rn",
                                                                                              F4),
                                                                                          LW(15,
                                                                                             4))),
                                                                                   Bop(Or,
                                                                                       EQ(Var("P",
                                                                                              F1),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       EQ(Var("W",
                                                                                              F1),
                                                                                          LW(1,
                                                                                             1)))),
                                                                               bVar"v0"),
                                                                           qTy),
                                                                        Close
                                                                          (bVar"v0",
                                                                           MU(TP[Var("v",
                                                                                     F4),
                                                                                 bVar"v0"],
                                                                              qTy))))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   Let(bVar"wback",
                                                                       EQ(Var("W",
                                                                              F1),
                                                                          LW(1,
                                                                             1)),
                                                                       MB(ITE(Bop(Or,
                                                                                  Bop(In,
                                                                                      Var("Rt",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)]),
                                                                                  Bop(And,
                                                                                      bVar"wback",
                                                                                      EQ(Var("Rn",
                                                                                             F4),
                                                                                         Var("Rt",
                                                                                             F4)))),
                                                                              Call
                                                                                ("DECODE_UNPREDICTABLE",
                                                                                 ATy(qTy,
                                                                                     PTy(uTy,
                                                                                         qTy)),
                                                                                 TP[Var("mc",
                                                                                        CTy"MachineCode"),
                                                                                    LS
                                                                                     "StoreByte/Half (immediate)"]),
                                                                              MU(LU,
                                                                                 qTy)),
                                                                          Close
                                                                            (AVar
                                                                               uTy,
                                                                             MU(Let(bVar"add",
                                                                                    EQ(Mop(Cast
                                                                                             F1,
                                                                                           LL[bVar"b'9"]),
                                                                                       LW(1,
                                                                                          1)),
                                                                                    Let(bVar"index",
                                                                                        EQ(Var("P",
                                                                                               F1),
                                                                                           LW(1,
                                                                                              1)),
                                                                                        Let(Var("m",
                                                                                                CTy"offset1"),
                                                                                            Call
                                                                                              ("immediate_form1",
                                                                                               CTy"offset1",
                                                                                               Mop(Cast
                                                                                                     F32,
                                                                                                   Mop(Cast
                                                                                                         F8,
                                                                                                       LL[bVar"b'7",
                                                                                                          bVar"b'6",
                                                                                                          bVar"b'5",
                                                                                                          bVar"b'4",
                                                                                                          bVar"b'3",
                                                                                                          bVar"b'2",
                                                                                                          bVar"b'1",
                                                                                                          bVar"b'0"]))),
                                                                                            ITE(EQ(Mop(Cast
                                                                                                         F1,
                                                                                                       LL[bVar"b'21"]),
                                                                                                   LW(1,
                                                                                                      1)),
                                                                                                Call
                                                                                                  ("Store",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("StoreHalf",
                                                                                                      CTy"Store",
                                                                                                      TP[bVar"add",
                                                                                                         bVar"index",
                                                                                                         bVar"wback",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Var("m",
                                                                                                             CTy"offset1")])),
                                                                                                Call
                                                                                                  ("Store",
                                                                                                   CTy"instruction",
                                                                                                   Call
                                                                                                     ("StoreByte",
                                                                                                      CTy"Store",
                                                                                                      TP[bVar"add",
                                                                                                         bVar"index",
                                                                                                         bVar"wback",
                                                                                                         Var("Rt",
                                                                                                             F4),
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         Var("m",
                                                                                                             CTy"offset1")])))))),
                                                                                qTy)))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU))))))))))),
                                  (bVar"b'23",
                                   Let(Var("Rn",F4),
                                       Mop(Cast F4,
                                           LL[bVar"b'19",bVar"b'18",
                                              bVar"b'17",bVar"b'16"]),
                                       Let(Var("Rt",F4),
                                           Mop(Cast F4,
                                               LL[bVar"b'15",bVar"b'14",
                                                  bVar"b'13",bVar"b'12"]),
                                           MB(Call
                                                ("ThumbCondition",
                                                 ATy(qTy,PTy(F4,qTy)),LU),
                                              Close
                                                (Var("v",F4),
                                                 MB(MB(MB(Call
                                                            ("HaveThumb2",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v0",
                                                             MB(MU(Bop(And,
                                                                       Mop(Not,
                                                                           EQ(Var("Rn",
                                                                                  F4),
                                                                              LW(15,
                                                                                 4))),
                                                                       bVar"v0"),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v0",
                                                                   MU(TP[Var("v",
                                                                             F4),
                                                                         bVar"v0"],
                                                                      qTy))))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F4,bTy)),
                                                          Call
                                                            ("Take",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             Var("v",
                                                                 PTy(F4,
                                                                     bTy))))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(ITE(Bop(In,
                                                                      Var("Rt",
                                                                          F4),
                                                                      SL[LW(13,
                                                                            4),
                                                                         LW(15,
                                                                            4)]),
                                                                  Call
                                                                    ("DECODE_UNPREDICTABLE",
                                                                     ATy(qTy,
                                                                         PTy(uTy,
                                                                             qTy)),
                                                                     TP[Var("mc",
                                                                            CTy"MachineCode"),
                                                                        LS
                                                                         "StoreByte/Half (immediate)"]),
                                                                  MU(LU,
                                                                     qTy)),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Let(bVar"add",
                                                                        LT,
                                                                        Let(bVar"index",
                                                                            LT,
                                                                            Let(bVar"wback",
                                                                                LF,
                                                                                Let(Var("m",
                                                                                        CTy"offset1"),
                                                                                    Call
                                                                                      ("immediate_form1",
                                                                                       CTy"offset1",
                                                                                       Mop(Cast
                                                                                             F32,
                                                                                           Mop(Cast
                                                                                                 (FTy 12),
                                                                                               LL[bVar"b'11",
                                                                                                  bVar"b'10",
                                                                                                  bVar"b'9",
                                                                                                  bVar"b'8",
                                                                                                  bVar"b'7",
                                                                                                  bVar"b'6",
                                                                                                  bVar"b'5",
                                                                                                  bVar"b'4",
                                                                                                  bVar"b'3",
                                                                                                  bVar"b'2",
                                                                                                  bVar"b'1",
                                                                                                  bVar"b'0"]))),
                                                                                    ITE(EQ(Mop(Cast
                                                                                                 F1,
                                                                                               LL[bVar"b'21"]),
                                                                                           LW(1,
                                                                                              1)),
                                                                                        Call
                                                                                          ("Store",
                                                                                           CTy"instruction",
                                                                                           Call
                                                                                             ("StoreHalf",
                                                                                              CTy"Store",
                                                                                              TP[bVar"add",
                                                                                                 bVar"index",
                                                                                                 bVar"wback",
                                                                                                 Var("Rt",
                                                                                                     F4),
                                                                                                 Var("Rn",
                                                                                                     F4),
                                                                                                 Var("m",
                                                                                                     CTy"offset1")])),
                                                                                        Call
                                                                                          ("Store",
                                                                                           CTy"instruction",
                                                                                           Call
                                                                                             ("StoreByte",
                                                                                              CTy"Store",
                                                                                              TP[bVar"add",
                                                                                                 bVar"index",
                                                                                                 bVar"wback",
                                                                                                 Var("Rt",
                                                                                                     F4),
                                                                                                 Var("Rn",
                                                                                                     F4),
                                                                                                 Var("m",
                                                                                                     CTy"offset1")]))))))),
                                                                    qTy))),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU)))))))))],
                                 Call
                                   ("UndefinedThumb",
                                    ATy(qTy,PTy(CTy"instruction",qTy)),LU)))],
                           Call
                             ("UndefinedThumb",
                              ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                      (Bop(And,bVar"b'31",
                           Bop(And,bVar"b'30",
                               Bop(And,bVar"b'29",Mop(Not,bVar"b'26")))),
                       ITB([(Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,bVar"b'23",
                                         Bop(And,Mop(Not,bVar"b'22"),
                                             Mop(Not,bVar"b'20"))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(Call
                                      ("ThumbCondition",
                                       ATy(qTy,PTy(F4,qTy)),LU),
                                    Close
                                      (Var("v",F4),
                                       MB(MB(MB(Call
                                                  ("HaveThumb2",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v0",
                                                   MU(TP[Var("v",F4),
                                                         bVar"v0"],qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 Let(Var("registers",F16),
                                                     CC[LW(0,1),
                                                        Mop(Cast F1,
                                                            LL[bVar"b'14"]),
                                                        LW(0,1),
                                                        Mop(Cast(FTy 13),
                                                            LL[bVar"b'12",
                                                               bVar"b'11",
                                                               bVar"b'10",
                                                               bVar"b'9",
                                                               bVar"b'8",
                                                               bVar"b'7",
                                                               bVar"b'6",
                                                               bVar"b'5",
                                                               bVar"b'4",
                                                               bVar"b'3",
                                                               bVar"b'2",
                                                               bVar"b'1",
                                                               bVar"b'0"])],
                                                     Let(bVar"wback",
                                                         EQ(Mop(Cast F1,
                                                                LL[bVar"b'21"]),
                                                            LW(1,1)),
                                                         MB(Call
                                                              ("BitCount",
                                                               ATy(qTy,
                                                                   PTy(nTy,
                                                                       qTy)),
                                                               Var("registers",
                                                                   F16)),
                                                            Close
                                                              (nVar"v",
                                                               MB(MB(MB(MB(MU(Bop(Lt,
                                                                                  nVar"v",
                                                                                  LN
                                                                                   2),
                                                                              qTy),
                                                                           Close
                                                                             (bVar"v",
                                                                              MU(Bop(Or,
                                                                                     EQ(Var("Rn",
                                                                                            F4),
                                                                                        LW(15,
                                                                                           4)),
                                                                                     bVar"v"),
                                                                                 qTy))),
                                                                        Close
                                                                          (bVar"b",
                                                                           MU(Bop(Or,
                                                                                  bVar"b",
                                                                                  Bop(And,
                                                                                      bVar"wback",
                                                                                      Bop(Bit,
                                                                                          Var("registers",
                                                                                              F16),
                                                                                          Mop(Cast
                                                                                                nTy,
                                                                                              Var("Rn",
                                                                                                  F4))))),
                                                                              qTy))),
                                                                     Close
                                                                       (bVar"b",
                                                                        ITE(bVar"b",
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "StoreMultiple"]),
                                                                            MU(LU,
                                                                               qTy)))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("Store",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("StoreMultiple",
                                                                              CTy"Store",
                                                                              TP[LT,
                                                                                 LF,
                                                                                 bVar"wback",
                                                                                 Var("Rn",
                                                                                     F4),
                                                                                 Var("registers",
                                                                                     F16)])),
                                                                        qTy))))))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU)))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'24",
                                     Bop(And,Mop(Not,bVar"b'23"),
                                         Bop(And,Mop(Not,bVar"b'22"),
                                             Mop(Not,bVar"b'20"))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 MB(Call
                                      ("ThumbCondition",
                                       ATy(qTy,PTy(F4,qTy)),LU),
                                    Close
                                      (Var("v",F4),
                                       MB(MB(MB(Call
                                                  ("HaveThumb2",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v0",
                                                   MU(TP[Var("v",F4),
                                                         bVar"v0"],qTy))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 Let(Var("registers",F16),
                                                     CC[LW(0,1),
                                                        Mop(Cast F1,
                                                            LL[bVar"b'14"]),
                                                        LW(0,1),
                                                        Mop(Cast(FTy 13),
                                                            LL[bVar"b'12",
                                                               bVar"b'11",
                                                               bVar"b'10",
                                                               bVar"b'9",
                                                               bVar"b'8",
                                                               bVar"b'7",
                                                               bVar"b'6",
                                                               bVar"b'5",
                                                               bVar"b'4",
                                                               bVar"b'3",
                                                               bVar"b'2",
                                                               bVar"b'1",
                                                               bVar"b'0"])],
                                                     Let(bVar"wback",
                                                         EQ(Mop(Cast F1,
                                                                LL[bVar"b'21"]),
                                                            LW(1,1)),
                                                         MB(Call
                                                              ("BitCount",
                                                               ATy(qTy,
                                                                   PTy(nTy,
                                                                       qTy)),
                                                               Var("registers",
                                                                   F16)),
                                                            Close
                                                              (nVar"v",
                                                               MB(MB(MB(MB(MU(Bop(Lt,
                                                                                  nVar"v",
                                                                                  LN
                                                                                   2),
                                                                              qTy),
                                                                           Close
                                                                             (bVar"v",
                                                                              MU(Bop(Or,
                                                                                     EQ(Var("Rn",
                                                                                            F4),
                                                                                        LW(15,
                                                                                           4)),
                                                                                     bVar"v"),
                                                                                 qTy))),
                                                                        Close
                                                                          (bVar"b",
                                                                           MU(Bop(Or,
                                                                                  bVar"b",
                                                                                  Bop(And,
                                                                                      bVar"wback",
                                                                                      Bop(Bit,
                                                                                          Var("registers",
                                                                                              F16),
                                                                                          Mop(Cast
                                                                                                nTy,
                                                                                              Var("Rn",
                                                                                                  F4))))),
                                                                              qTy))),
                                                                     Close
                                                                       (bVar"b",
                                                                        ITE(bVar"b",
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "StoreMultiple"]),
                                                                            MU(LU,
                                                                               qTy)))),
                                                                  Close
                                                                    (AVar
                                                                       uTy,
                                                                     MU(Call
                                                                          ("Store",
                                                                           CTy"instruction",
                                                                           Call
                                                                             ("StoreMultiple",
                                                                              CTy"Store",
                                                                              TP[LF,
                                                                                 LT,
                                                                                 bVar"wback",
                                                                                 Var("Rn",
                                                                                     F4),
                                                                                 Var("registers",
                                                                                     F16)])),
                                                                        qTy))))))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU)))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,bVar"b'23",
                                         Bop(And,Mop(Not,bVar"b'22"),
                                             bVar"b'20")))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("M",F1),
                                     Mop(Cast F1,LL[bVar"b'14"]),
                                     Let(Var("P",F1),
                                         Mop(Cast F1,LL[bVar"b'15"]),
                                         MB(Call
                                              ("ThumbCondition",
                                               ATy(qTy,PTy(F4,qTy)),LU),
                                            Close
                                              (Var("v",F4),
                                               MB(MB(MB(Call
                                                          ("HaveThumb2",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v0",
                                                           MU(TP[Var("v",
                                                                     F4),
                                                                 bVar"v0"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         Let(Var("registers",
                                                                 F16),
                                                             CC[Var("P",F1),
                                                                Var("M",F1),
                                                                LW(0,1),
                                                                Mop(Cast
                                                                      (FTy 13),
                                                                    LL[bVar"b'12",
                                                                       bVar"b'11",
                                                                       bVar"b'10",
                                                                       bVar"b'9",
                                                                       bVar"b'8",
                                                                       bVar"b'7",
                                                                       bVar"b'6",
                                                                       bVar"b'5",
                                                                       bVar"b'4",
                                                                       bVar"b'3",
                                                                       bVar"b'2",
                                                                       bVar"b'1",
                                                                       bVar"b'0"])],
                                                             Let(bVar"wback",
                                                                 EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'21"]),
                                                                    LW(1,1)),
                                                                 MB(Call
                                                                      ("BitCount",
                                                                       ATy(qTy,
                                                                           PTy(nTy,
                                                                               qTy)),
                                                                       Var("registers",
                                                                           F16)),
                                                                    Close
                                                                      (nVar"v",
                                                                       MB(MB(MB(MB(MB(MB(MU(Bop(Lt,
                                                                                                nVar"v",
                                                                                                LN
                                                                                                 2),
                                                                                            qTy),
                                                                                         Close
                                                                                           (bVar"v",
                                                                                            MU(Bop(Or,
                                                                                                   EQ(Var("Rn",
                                                                                                          F4),
                                                                                                      LW(15,
                                                                                                         4)),
                                                                                                   bVar"v"),
                                                                                               qTy))),
                                                                                      Close
                                                                                        (bVar"b",
                                                                                         MU(Bop(Or,
                                                                                                bVar"b",
                                                                                                Bop(And,
                                                                                                    EQ(Var("P",
                                                                                                           F1),
                                                                                                       LW(1,
                                                                                                          1)),
                                                                                                    EQ(Var("M",
                                                                                                           F1),
                                                                                                       LW(1,
                                                                                                          1)))),
                                                                                            qTy))),
                                                                                   Close
                                                                                     (bVar"b",
                                                                                      ITE(bVar"b",
                                                                                          MU(LT,
                                                                                             qTy),
                                                                                          MB(Call
                                                                                               ("InITBlock",
                                                                                                ATy(qTy,
                                                                                                    PTy(bTy,
                                                                                                        qTy)),
                                                                                                LU),
                                                                                             Close
                                                                                               (bVar"v",
                                                                                                MB(MU(Bop(And,
                                                                                                          Bop(Bit,
                                                                                                              Var("registers",
                                                                                                                  F16),
                                                                                                              LN
                                                                                                               15),
                                                                                                          bVar"v"),
                                                                                                      qTy),
                                                                                                   Close
                                                                                                     (bVar"b",
                                                                                                      ITE(bVar"b",
                                                                                                          MB(Call
                                                                                                               ("LastInITBlock",
                                                                                                                ATy(qTy,
                                                                                                                    PTy(bTy,
                                                                                                                        qTy)),
                                                                                                                LU),
                                                                                                             Close
                                                                                                               (bVar"v",
                                                                                                                MU(Mop(Not,
                                                                                                                       bVar"v"),
                                                                                                                   qTy))),
                                                                                                          MU(LF,
                                                                                                             qTy))))))))),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   MU(Bop(Or,
                                                                                          bVar"b",
                                                                                          Bop(And,
                                                                                              bVar"wback",
                                                                                              Bop(Bit,
                                                                                                  Var("registers",
                                                                                                      F16),
                                                                                                  Mop(Cast
                                                                                                        nTy,
                                                                                                      Var("Rn",
                                                                                                          F4))))),
                                                                                      qTy))),
                                                                             Close
                                                                               (bVar"b",
                                                                                ITE(bVar"b",
                                                                                    Call
                                                                                      ("DECODE_UNPREDICTABLE",
                                                                                       ATy(qTy,
                                                                                           PTy(uTy,
                                                                                               qTy)),
                                                                                       TP[Var("mc",
                                                                                              CTy"MachineCode"),
                                                                                          LS
                                                                                           "LoadMultiple"]),
                                                                                    MU(LU,
                                                                                       qTy)))),
                                                                          Close
                                                                            (AVar
                                                                               uTy,
                                                                             MU(Call
                                                                                  ("Load",
                                                                                   CTy"instruction",
                                                                                   Call
                                                                                     ("LoadMultiple",
                                                                                      CTy"Load",
                                                                                      TP[LT,
                                                                                         LF,
                                                                                         bVar"wback",
                                                                                         Var("Rn",
                                                                                             F4),
                                                                                         Var("registers",
                                                                                             F16)])),
                                                                                qTy))))))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'24",
                                     Bop(And,Mop(Not,bVar"b'23"),
                                         Bop(And,Mop(Not,bVar"b'22"),
                                             bVar"b'20")))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("M",F1),
                                     Mop(Cast F1,LL[bVar"b'14"]),
                                     Let(Var("P",F1),
                                         Mop(Cast F1,LL[bVar"b'15"]),
                                         MB(Call
                                              ("ThumbCondition",
                                               ATy(qTy,PTy(F4,qTy)),LU),
                                            Close
                                              (Var("v",F4),
                                               MB(MB(MB(Call
                                                          ("HaveThumb2",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v0",
                                                           MU(TP[Var("v",
                                                                     F4),
                                                                 bVar"v0"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         Let(Var("registers",
                                                                 F16),
                                                             CC[Var("P",F1),
                                                                Var("M",F1),
                                                                LW(0,1),
                                                                Mop(Cast
                                                                      (FTy 13),
                                                                    LL[bVar"b'12",
                                                                       bVar"b'11",
                                                                       bVar"b'10",
                                                                       bVar"b'9",
                                                                       bVar"b'8",
                                                                       bVar"b'7",
                                                                       bVar"b'6",
                                                                       bVar"b'5",
                                                                       bVar"b'4",
                                                                       bVar"b'3",
                                                                       bVar"b'2",
                                                                       bVar"b'1",
                                                                       bVar"b'0"])],
                                                             Let(bVar"wback",
                                                                 EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'21"]),
                                                                    LW(1,1)),
                                                                 MB(Call
                                                                      ("BitCount",
                                                                       ATy(qTy,
                                                                           PTy(nTy,
                                                                               qTy)),
                                                                       Var("registers",
                                                                           F16)),
                                                                    Close
                                                                      (nVar"v",
                                                                       MB(MB(MB(MB(MB(MB(MU(Bop(Lt,
                                                                                                nVar"v",
                                                                                                LN
                                                                                                 2),
                                                                                            qTy),
                                                                                         Close
                                                                                           (bVar"v",
                                                                                            MU(Bop(Or,
                                                                                                   EQ(Var("Rn",
                                                                                                          F4),
                                                                                                      LW(15,
                                                                                                         4)),
                                                                                                   bVar"v"),
                                                                                               qTy))),
                                                                                      Close
                                                                                        (bVar"b",
                                                                                         MU(Bop(Or,
                                                                                                bVar"b",
                                                                                                Bop(And,
                                                                                                    EQ(Var("P",
                                                                                                           F1),
                                                                                                       LW(1,
                                                                                                          1)),
                                                                                                    EQ(Var("M",
                                                                                                           F1),
                                                                                                       LW(1,
                                                                                                          1)))),
                                                                                            qTy))),
                                                                                   Close
                                                                                     (bVar"b",
                                                                                      ITE(bVar"b",
                                                                                          MU(LT,
                                                                                             qTy),
                                                                                          MB(Call
                                                                                               ("InITBlock",
                                                                                                ATy(qTy,
                                                                                                    PTy(bTy,
                                                                                                        qTy)),
                                                                                                LU),
                                                                                             Close
                                                                                               (bVar"v",
                                                                                                MB(MU(Bop(And,
                                                                                                          Bop(Bit,
                                                                                                              Var("registers",
                                                                                                                  F16),
                                                                                                              LN
                                                                                                               15),
                                                                                                          bVar"v"),
                                                                                                      qTy),
                                                                                                   Close
                                                                                                     (bVar"b",
                                                                                                      ITE(bVar"b",
                                                                                                          MB(Call
                                                                                                               ("LastInITBlock",
                                                                                                                ATy(qTy,
                                                                                                                    PTy(bTy,
                                                                                                                        qTy)),
                                                                                                                LU),
                                                                                                             Close
                                                                                                               (bVar"v",
                                                                                                                MU(Mop(Not,
                                                                                                                       bVar"v"),
                                                                                                                   qTy))),
                                                                                                          MU(LF,
                                                                                                             qTy))))))))),
                                                                                Close
                                                                                  (bVar"b",
                                                                                   MU(Bop(Or,
                                                                                          bVar"b",
                                                                                          Bop(And,
                                                                                              bVar"wback",
                                                                                              Bop(Bit,
                                                                                                  Var("registers",
                                                                                                      F16),
                                                                                                  Mop(Cast
                                                                                                        nTy,
                                                                                                      Var("Rn",
                                                                                                          F4))))),
                                                                                      qTy))),
                                                                             Close
                                                                               (bVar"b",
                                                                                ITE(bVar"b",
                                                                                    Call
                                                                                      ("DECODE_UNPREDICTABLE",
                                                                                       ATy(qTy,
                                                                                           PTy(uTy,
                                                                                               qTy)),
                                                                                       TP[Var("mc",
                                                                                              CTy"MachineCode"),
                                                                                          LS
                                                                                           "LoadMultiple"]),
                                                                                    MU(LU,
                                                                                       qTy)))),
                                                                          Close
                                                                            (AVar
                                                                               uTy,
                                                                             MU(Call
                                                                                  ("Load",
                                                                                   CTy"instruction",
                                                                                   Call
                                                                                     ("LoadMultiple",
                                                                                      CTy"Load",
                                                                                      TP[LF,
                                                                                         LT,
                                                                                         bVar"wback",
                                                                                         Var("Rn",
                                                                                             F4),
                                                                                         Var("registers",
                                                                                             F16)])),
                                                                                qTy))))))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'22"),
                                     Mop(Not,bVar"b'20"))),
                             Let(Var("op",FTy 2),
                                 Mop(Cast(FTy 2),LL[bVar"b'24",bVar"b'23"]),
                                 MB(Call
                                      ("ThumbCondition",
                                       ATy(qTy,PTy(F4,qTy)),LU),
                                    Close
                                      (Var("v",F4),
                                       MB(MB(MB(Call
                                                  ("HaveThumb2",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   LU),
                                                Close
                                                  (bVar"v0",
                                                   MB(MU(Bop(And,
                                                             Bop(In,
                                                                 Var("op",
                                                                     FTy 2),
                                                                 SL[LW(0,2),
                                                                    LW(3,2)]),
                                                             bVar"v0"),qTy),
                                                      Close
                                                        (bVar"v0",
                                                         MU(TP[Var("v",F4),
                                                               bVar"v0"],
                                                            qTy))))),
                                             Close
                                               (Var("v",PTy(F4,bTy)),
                                                Call
                                                  ("Take",
                                                   ATy(qTy,PTy(bTy,qTy)),
                                                   Var("v",PTy(F4,bTy))))),
                                          Close
                                            (bVar"b",
                                             ITE(bVar"b",
                                                 MB(Call
                                                      ("CurrentInstrSet",
                                                       ATy(qTy,
                                                           PTy(CTy"InstrSet",
                                                               qTy)),LU),
                                                    Close
                                                      (Var("v",
                                                           CTy"InstrSet"),
                                                       MB(MB(MU(EQ(Var("v",
                                                                       CTy"InstrSet"),
                                                                   LC("InstrSet_ThumbEE",
                                                                      CTy"InstrSet")),
                                                                qTy),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "StoreReturnState"]),
                                                                    MU(LU,
                                                                       qTy)))),
                                                          Close
                                                            (AVar uTy,
                                                             MU(Call
                                                                  ("System",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("StoreReturnState",
                                                                      CTy"System",
                                                                      TP[EQ(Var("op",
                                                                                FTy 2),
                                                                            LW(3,
                                                                               2)),
                                                                         LF,
                                                                         EQ(Mop(Cast
                                                                                  F1,
                                                                                LL[bVar"b'21"]),
                                                                            LW(1,
                                                                               1)),
                                                                         Mop(Cast
                                                                               (FTy 5),
                                                                             LL[bVar"b'4",
                                                                                bVar"b'3",
                                                                                bVar"b'2",
                                                                                bVar"b'1",
                                                                                bVar"b'0"])])),
                                                                qTy))))),
                                                 Call
                                                   ("Skip",
                                                    ATy(qTy,
                                                        PTy(CTy"instruction",
                                                            qTy)),LU)))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'22"),bVar"b'20")),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("op",FTy 2),
                                     Mop(Cast(FTy 2),
                                         LL[bVar"b'24",bVar"b'23"]),
                                     MB(Call
                                          ("ThumbCondition",
                                           ATy(qTy,PTy(F4,qTy)),LU),
                                        Close
                                          (Var("v",F4),
                                           MB(MB(MB(Call
                                                      ("HaveThumb2",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       LU),
                                                    Close
                                                      (bVar"v0",
                                                       MB(MU(Bop(And,
                                                                 Bop(In,
                                                                     Var("op",
                                                                         FTy 2),
                                                                     SL[LW(0,
                                                                           2),
                                                                        LW(3,
                                                                           2)]),
                                                                 bVar"v0"),
                                                             qTy),
                                                          Close
                                                            (bVar"v0",
                                                             MU(TP[Var("v",
                                                                       F4),
                                                                   bVar"v0"],
                                                                qTy))))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(Call
                                                          ("CurrentInstrSet",
                                                           ATy(qTy,
                                                               PTy(CTy"InstrSet",
                                                                   qTy)),
                                                           LU),
                                                        Close
                                                          (Var("v",
                                                               CTy"InstrSet"),
                                                           MB(MB(MB(MB(MU(EQ(Var("v",
                                                                                 CTy"InstrSet"),
                                                                             LC("InstrSet_ThumbEE",
                                                                                CTy"InstrSet")),
                                                                          qTy),
                                                                       Close
                                                                         (bVar"b",
                                                                          MU(Bop(Or,
                                                                                 bVar"b",
                                                                                 EQ(Var("Rn",
                                                                                        F4),
                                                                                    LW(15,
                                                                                       4))),
                                                                             qTy))),
                                                                    Close
                                                                      (bVar"b",
                                                                       ITE(bVar"b",
                                                                           MU(LT,
                                                                              qTy),
                                                                           MB(Call
                                                                                ("InITBlock",
                                                                                 ATy(qTy,
                                                                                     PTy(bTy,
                                                                                         qTy)),
                                                                                 LU),
                                                                              Close
                                                                                (bVar"b",
                                                                                 ITE(bVar"b",
                                                                                     MB(Call
                                                                                          ("LastInITBlock",
                                                                                           ATy(qTy,
                                                                                               PTy(bTy,
                                                                                                   qTy)),
                                                                                           LU),
                                                                                        Close
                                                                                          (bVar"v",
                                                                                           MU(Mop(Not,
                                                                                                  bVar"v"),
                                                                                              qTy))),
                                                                                     MU(LF,
                                                                                        qTy))))))),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "ReturnFromException"]),
                                                                        MU(LU,
                                                                           qTy)))),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Call
                                                                      ("System",
                                                                       CTy"instruction",
                                                                       Call
                                                                         ("ReturnFromException",
                                                                          CTy"System",
                                                                          TP[EQ(Var("op",
                                                                                    FTy 2),
                                                                                LW(3,
                                                                                   2)),
                                                                             LF,
                                                                             EQ(Mop(Cast
                                                                                      F1,
                                                                                    LL[bVar"b'21"]),
                                                                                LW(1,
                                                                                   1)),
                                                                             Var("Rn",
                                                                                 F4)])),
                                                                    qTy))))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,Mop(Not,bVar"b'23"),
                                         Bop(And,bVar"b'22",
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Mop(Not,bVar"b'20")))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("Rd",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'11",bVar"b'10",
                                            bVar"b'9",bVar"b'8"]),
                                     Let(Var("Rt",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'15",bVar"b'14",
                                                bVar"b'13",bVar"b'12"]),
                                         MB(Call
                                              ("ThumbCondition",
                                               ATy(qTy,PTy(F4,qTy)),LU),
                                            Close
                                              (Var("v",F4),
                                               MB(MB(MB(Call
                                                          ("HaveThumb2",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v0",
                                                           MU(TP[Var("v",
                                                                     F4),
                                                                 bVar"v0"],
                                                              qTy))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(Or,
                                                                                Bop(In,
                                                                                    Var("Rd",
                                                                                        F4),
                                                                                    SL[LW(13,
                                                                                          4),
                                                                                       LW(15,
                                                                                          4)]),
                                                                                Bop(In,
                                                                                    Var("Rt",
                                                                                        F4),
                                                                                    SL[LW(13,
                                                                                          4),
                                                                                       LW(15,
                                                                                          4)])),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4))),
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       Var("Rt",
                                                                           F4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "StoreExclusive"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Store",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("StoreExclusive",
                                                                        CTy"Store",
                                                                        TP[Var("Rd",
                                                                               F4),
                                                                           Var("Rt",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4),
                                                                           Mop(Cast
                                                                                 F32,
                                                                               CC[Mop(Cast
                                                                                        F8,
                                                                                      LL[bVar"b'7",
                                                                                         bVar"b'6",
                                                                                         bVar"b'5",
                                                                                         bVar"b'4",
                                                                                         bVar"b'3",
                                                                                         bVar"b'2",
                                                                                         bVar"b'1",
                                                                                         bVar"b'0"]),
                                                                                  LW(0,
                                                                                     2)])])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,Mop(Not,bVar"b'23"),
                                         Bop(And,bVar"b'22",
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 bVar"b'20"))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("Rt",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     MB(Call
                                          ("ThumbCondition",
                                           ATy(qTy,PTy(F4,qTy)),LU),
                                        Close
                                          (Var("v",F4),
                                           MB(MB(MB(Call
                                                      ("HaveThumb2",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       LU),
                                                    Close
                                                      (bVar"v0",
                                                       MU(TP[Var("v",F4),
                                                             bVar"v0"],qTy))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(In,
                                                                    Var("Rt",
                                                                        F4),
                                                                    SL[LW(13,
                                                                          4),
                                                                       LW(15,
                                                                          4)]),
                                                                EQ(Var("Rn",
                                                                       F4),
                                                                   LW(15,4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "StoreExclusive"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("Load",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("LoadExclusive",
                                                                    CTy"Load",
                                                                    TP[Var("Rt",
                                                                           F4),
                                                                       Var("Rn",
                                                                           F4),
                                                                       Mop(Cast
                                                                             F32,
                                                                           CC[Mop(Cast
                                                                                    F8,
                                                                                  LL[bVar"b'7",
                                                                                     bVar"b'6",
                                                                                     bVar"b'5",
                                                                                     bVar"b'4",
                                                                                     bVar"b'3",
                                                                                     bVar"b'2",
                                                                                     bVar"b'1",
                                                                                     bVar"b'0"]),
                                                                              LW(0,
                                                                                 2)])])),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,bVar"b'23",
                                         Bop(And,bVar"b'22",
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'20"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'7"),
                                                         Bop(And,
                                                             bVar"b'6",
                                                             Mop(Not,
                                                                 bVar"b'5"))))))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("Rd",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                            bVar"b'0"]),
                                     Let(Var("Rt",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'15",bVar"b'14",
                                                bVar"b'13",bVar"b'12"]),
                                         MB(Call
                                              ("ThumbCondition",
                                               ATy(qTy,PTy(F4,qTy)),LU),
                                            Close
                                              (Var("v",F4),
                                               MB(MB(MB(Call
                                                          ("ArchVersion",
                                                           ATy(qTy,
                                                               PTy(nTy,qTy)),
                                                           LU),
                                                        Close
                                                          (nVar"v0",
                                                           MB(MU(Bop(Ge,
                                                                     nVar"v0",
                                                                     LN 7),
                                                                 qTy),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(Or,
                                                                                Bop(In,
                                                                                    Var("Rd",
                                                                                        F4),
                                                                                    SL[LW(13,
                                                                                          4),
                                                                                       LW(15,
                                                                                          4)]),
                                                                                Bop(In,
                                                                                    Var("Rt",
                                                                                        F4),
                                                                                    SL[LW(13,
                                                                                          4),
                                                                                       LW(15,
                                                                                          4)])),
                                                                            EQ(Var("Rn",
                                                                                   F4),
                                                                               LW(15,
                                                                                  4))),
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4))),
                                                                    EQ(Var("Rd",
                                                                           F4),
                                                                       Var("Rt",
                                                                           F4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "StoreExclusive: Byte or Halfword"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(ITE(EQ(Mop(Cast
                                                                               F1,
                                                                             LL[bVar"b'4"]),
                                                                         LW(1,
                                                                            1)),
                                                                      Call
                                                                        ("Store",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("StoreExclusiveHalf",
                                                                            CTy"Store",
                                                                            TP[Var("Rd",
                                                                                   F4),
                                                                               Var("Rt",
                                                                                   F4),
                                                                               Var("Rn",
                                                                                   F4)])),
                                                                      Call
                                                                        ("Store",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("StoreExclusiveByte",
                                                                            CTy"Store",
                                                                            TP[Var("Rd",
                                                                                   F4),
                                                                               Var("Rt",
                                                                                   F4),
                                                                               Var("Rn",
                                                                                   F4)]))),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,bVar"b'23",
                                         Bop(And,bVar"b'22",
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Bop(And,
                                                     Mop(Not,bVar"b'20"),
                                                     Bop(And,
                                                         Mop(Not,bVar"b'7"),
                                                         Bop(And,
                                                             bVar"b'6",
                                                             Bop(And,
                                                                 bVar"b'5",
                                                                 bVar"b'4"))))))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("Rd",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                            bVar"b'0"]),
                                     Let(Var("Rt2",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'11",bVar"b'10",
                                                bVar"b'9",bVar"b'8"]),
                                         Let(Var("Rt",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'15",bVar"b'14",
                                                    bVar"b'13",bVar"b'12"]),
                                             MB(Call
                                                  ("ThumbCondition",
                                                   ATy(qTy,PTy(F4,qTy)),LU),
                                                Close
                                                  (Var("v",F4),
                                                   MB(MB(MB(Call
                                                              ("ArchVersion",
                                                               ATy(qTy,
                                                                   PTy(nTy,
                                                                       qTy)),
                                                               LU),
                                                            Close
                                                              (nVar"v0",
                                                               MB(MU(Bop(Ge,
                                                                         nVar"v0",
                                                                         LN
                                                                          7),
                                                                     qTy),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))))),
                                                         Close
                                                           (Var("v",
                                                                PTy(F4,bTy)),
                                                            Call
                                                              ("Take",
                                                               ATy(qTy,
                                                                   PTy(bTy,
                                                                       qTy)),
                                                               Var("v",
                                                                   PTy(F4,
                                                                       bTy))))),
                                                      Close
                                                        (bVar"b",
                                                         ITE(bVar"b",
                                                             MB(ITE(Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        Bop(In,
                                                                                            Var("Rd",
                                                                                                F4),
                                                                                            SL[LW(13,
                                                                                                  4),
                                                                                               LW(15,
                                                                                                  4)]),
                                                                                        Bop(In,
                                                                                            Var("Rt",
                                                                                                F4),
                                                                                            SL[LW(13,
                                                                                                  4),
                                                                                               LW(15,
                                                                                                  4)])),
                                                                                    Bop(In,
                                                                                        Var("Rt2",
                                                                                            F4),
                                                                                        SL[LW(13,
                                                                                              4),
                                                                                           LW(15,
                                                                                              4)])),
                                                                                EQ(Var("Rn",
                                                                                       F4),
                                                                                   LW(15,
                                                                                      4))),
                                                                            EQ(Var("Rd",
                                                                                   F4),
                                                                               Var("Rn",
                                                                                   F4))),
                                                                        EQ(Var("Rd",
                                                                               F4),
                                                                           Var("Rt",
                                                                               F4))),
                                                                    Call
                                                                      ("DECODE_UNPREDICTABLE",
                                                                       ATy(qTy,
                                                                           PTy(uTy,
                                                                               qTy)),
                                                                       TP[Var("mc",
                                                                              CTy"MachineCode"),
                                                                          LS
                                                                           "StoreExclusivDoubleword"]),
                                                                    MU(LU,
                                                                       qTy)),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Store",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("StoreExclusiveDoubleword",
                                                                            CTy"Store",
                                                                            TP[Var("Rd",
                                                                                   F4),
                                                                               Var("Rt",
                                                                                   F4),
                                                                               Var("Rt2",
                                                                                   F4),
                                                                               Var("Rn",
                                                                                   F4)])),
                                                                      qTy))),
                                                             Call
                                                               ("Skip",
                                                                ATy(qTy,
                                                                    PTy(CTy"instruction",
                                                                        qTy)),
                                                                LU))))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,bVar"b'23",
                                         Bop(And,bVar"b'22",
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Bop(And,bVar"b'20",
                                                     Bop(And,
                                                         Mop(Not,bVar"b'7"),
                                                         Bop(And,
                                                             Mop(Not,
                                                                 bVar"b'6"),
                                                             Mop(Not,
                                                                 bVar"b'5"))))))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("Rm",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                            bVar"b'0"]),
                                     MB(Call
                                          ("ThumbCondition",
                                           ATy(qTy,PTy(F4,qTy)),LU),
                                        Close
                                          (Var("v",F4),
                                           MB(MB(MB(Call
                                                      ("HaveThumb2",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       LU),
                                                    Close
                                                      (bVar"v0",
                                                       MU(TP[Var("v",F4),
                                                             bVar"v0"],qTy))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(Call
                                                          ("InITBlock",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v",
                                                           MB(MB(MB(ITE(bVar"v",
                                                                        MB(Call
                                                                             ("LastInITBlock",
                                                                              ATy(qTy,
                                                                                  PTy(bTy,
                                                                                      qTy)),
                                                                              LU),
                                                                           Close
                                                                             (bVar"v",
                                                                              MU(Mop(Not,
                                                                                     bVar"v"),
                                                                                 qTy))),
                                                                        MU(LF,
                                                                           qTy)),
                                                                    Close
                                                                      (bVar"v",
                                                                       MU(Bop(Or,
                                                                              Bop(Or,
                                                                                  EQ(Var("Rn",
                                                                                         F4),
                                                                                     LW(13,
                                                                                        4)),
                                                                                  Bop(In,
                                                                                      Var("Rm",
                                                                                          F4),
                                                                                      SL[LW(13,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4)])),
                                                                              bVar"v"),
                                                                          qTy))),
                                                                 Close
                                                                   (bVar"b",
                                                                    ITE(bVar"b",
                                                                        Call
                                                                          ("DECODE_UNPREDICTABLE",
                                                                           ATy(qTy,
                                                                               PTy(uTy,
                                                                                   qTy)),
                                                                           TP[Var("mc",
                                                                                  CTy"MachineCode"),
                                                                              LS
                                                                               "TableBranchByte"]),
                                                                        MU(LU,
                                                                           qTy)))),
                                                              Close
                                                                (AVar uTy,
                                                                 MU(Call
                                                                      ("Branch",
                                                                       CTy"instruction",
                                                                       Call
                                                                         ("TableBranchByte",
                                                                          CTy"Branch",
                                                                          TP[EQ(Mop(Cast
                                                                                      F1,
                                                                                    LL[bVar"b'4"]),
                                                                                LW(1,
                                                                                   1)),
                                                                             Var("Rm",
                                                                                 F4),
                                                                             Var("Rn",
                                                                                 F4)])),
                                                                    qTy))))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,bVar"b'23",
                                         Bop(And,bVar"b'22",
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Bop(And,bVar"b'20",
                                                     Bop(And,
                                                         Mop(Not,bVar"b'7"),
                                                         Bop(And,
                                                             bVar"b'6",
                                                             Mop(Not,
                                                                 bVar"b'5"))))))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("Rt",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'15",bVar"b'14",
                                            bVar"b'13",bVar"b'12"]),
                                     MB(Call
                                          ("ThumbCondition",
                                           ATy(qTy,PTy(F4,qTy)),LU),
                                        Close
                                          (Var("v",F4),
                                           MB(MB(MB(Call
                                                      ("ArchVersion",
                                                       ATy(qTy,
                                                           PTy(nTy,qTy)),
                                                       LU),
                                                    Close
                                                      (nVar"v0",
                                                       MB(MU(Bop(Ge,
                                                                 nVar"v0",
                                                                 LN 7),qTy),
                                                          Close
                                                            (bVar"v0",
                                                             MU(TP[Var("v",
                                                                       F4),
                                                                   bVar"v0"],
                                                                qTy))))),
                                                 Close
                                                   (Var("v",PTy(F4,bTy)),
                                                    Call
                                                      ("Take",
                                                       ATy(qTy,
                                                           PTy(bTy,qTy)),
                                                       Var("v",PTy(F4,bTy))))),
                                              Close
                                                (bVar"b",
                                                 ITE(bVar"b",
                                                     MB(ITE(Bop(Or,
                                                                Bop(In,
                                                                    Var("Rt",
                                                                        F4),
                                                                    SL[LW(13,
                                                                          4),
                                                                       LW(15,
                                                                          4)]),
                                                                EQ(Var("Rn",
                                                                       F4),
                                                                   LW(15,4))),
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "LoadExclusive: Byte or Halfword"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(ITE(EQ(Mop(Cast
                                                                           F1,
                                                                         LL[bVar"b'4"]),
                                                                     LW(1,
                                                                        1)),
                                                                  Call
                                                                    ("Load",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("LoadExclusiveHalf",
                                                                        CTy"Load",
                                                                        TP[Var("Rt",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4)])),
                                                                  Call
                                                                    ("Load",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("LoadExclusiveByte",
                                                                        CTy"Load",
                                                                        TP[Var("Rt",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4)]))),
                                                              qTy))),
                                                     Call
                                                       ("Skip",
                                                        ATy(qTy,
                                                            PTy(CTy"instruction",
                                                                qTy)),LU))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,Mop(Not,bVar"b'24"),
                                     Bop(And,bVar"b'23",
                                         Bop(And,bVar"b'22",
                                             Bop(And,Mop(Not,bVar"b'21"),
                                                 Bop(And,bVar"b'20",
                                                     Bop(And,
                                                         Mop(Not,bVar"b'7"),
                                                         Bop(And,
                                                             bVar"b'6",
                                                             Bop(And,
                                                                 bVar"b'5",
                                                                 bVar"b'4"))))))))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("Rt2",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'11",bVar"b'10",
                                            bVar"b'9",bVar"b'8"]),
                                     Let(Var("Rt",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'15",bVar"b'14",
                                                bVar"b'13",bVar"b'12"]),
                                         MB(Call
                                              ("ThumbCondition",
                                               ATy(qTy,PTy(F4,qTy)),LU),
                                            Close
                                              (Var("v",F4),
                                               MB(MB(MB(Call
                                                          ("ArchVersion",
                                                           ATy(qTy,
                                                               PTy(nTy,qTy)),
                                                           LU),
                                                        Close
                                                          (nVar"v0",
                                                           MB(MU(Bop(Ge,
                                                                     nVar"v0",
                                                                     LN 7),
                                                                 qTy),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(In,
                                                                                Var("Rt",
                                                                                    F4),
                                                                                SL[LW(13,
                                                                                      4),
                                                                                   LW(15,
                                                                                      4)]),
                                                                            Bop(In,
                                                                                Var("Rt2",
                                                                                    F4),
                                                                                SL[LW(13,
                                                                                      4),
                                                                                   LW(15,
                                                                                      4)])),
                                                                        EQ(Var("Rt",
                                                                               F4),
                                                                           Var("Rt2",
                                                                               F4))),
                                                                    EQ(Var("Rn",
                                                                           F4),
                                                                       LW(15,
                                                                          4))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "LoadExclusiveDoubleword"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Load",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("LoadExclusiveDoubleword",
                                                                        CTy"Load",
                                                                        TP[Var("Rt",
                                                                               F4),
                                                                           Var("Rt2",
                                                                               F4),
                                                                           Var("Rn",
                                                                               F4)])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'22",Mop(Not,bVar"b'20"))),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("W",F1),
                                     Mop(Cast F1,LL[bVar"b'21"]),
                                     Let(Var("P",F1),
                                         Mop(Cast F1,LL[bVar"b'24"]),
                                         Let(Var("Rt2",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'11",bVar"b'10",
                                                    bVar"b'9",bVar"b'8"]),
                                             Let(Var("Rt",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 MB(Call
                                                      ("ThumbCondition",
                                                       ATy(qTy,PTy(F4,qTy)),
                                                       LU),
                                                    Close
                                                      (Var("v",F4),
                                                       MB(MB(MB(Call
                                                                  ("HaveThumb2",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v0",
                                                                   MB(MU(Bop(And,
                                                                             Bop(Or,
                                                                                 EQ(Var("P",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 EQ(Var("W",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1))),
                                                                             bVar"v0"),
                                                                         qTy),
                                                                      Close
                                                                        (bVar"v0",
                                                                         MU(TP[Var("v",
                                                                                   F4),
                                                                               bVar"v0"],
                                                                            qTy))))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 Let(bVar"wback",
                                                                     EQ(Var("W",
                                                                            F1),
                                                                        LW(1,
                                                                           1)),
                                                                     MB(ITE(Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        Bop(And,
                                                                                            bVar"wback",
                                                                                            Bop(Or,
                                                                                                EQ(Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rt",
                                                                                                       F4)),
                                                                                                EQ(Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rt2",
                                                                                                       F4)))),
                                                                                        EQ(Var("Rn",
                                                                                               F4),
                                                                                           LW(15,
                                                                                              4))),
                                                                                    Bop(In,
                                                                                        Var("Rt",
                                                                                            F4),
                                                                                        SL[LW(13,
                                                                                              4),
                                                                                           LW(15,
                                                                                              4)])),
                                                                                Bop(In,
                                                                                    Var("Rt2",
                                                                                        F4),
                                                                                    SL[LW(13,
                                                                                          4),
                                                                                       LW(15,
                                                                                          4)])),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "StoreDual"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Call
                                                                                ("Store",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("StoreDual",
                                                                                    CTy"Store",
                                                                                    TP[EQ(Mop(Cast
                                                                                                F1,
                                                                                              LL[bVar"b'23"]),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       EQ(Var("P",
                                                                                              F1),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       bVar"wback",
                                                                                       Var("Rt",
                                                                                           F4),
                                                                                       Var("Rt2",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Call
                                                                                         ("immediate_form2",
                                                                                          CTy"offset2",
                                                                                          Mop(Cast
                                                                                                F32,
                                                                                              CC[Mop(Cast
                                                                                                       F8,
                                                                                                     LL[bVar"b'7",
                                                                                                        bVar"b'6",
                                                                                                        bVar"b'5",
                                                                                                        bVar"b'4",
                                                                                                        bVar"b'3",
                                                                                                        bVar"b'2",
                                                                                                        bVar"b'1",
                                                                                                        bVar"b'0"]),
                                                                                                 LW(0,
                                                                                                    2)]))])),
                                                                              qTy)))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'22",
                                     Bop(And,bVar"b'20",
                                         Bop(And,bVar"b'19",
                                             Bop(And,bVar"b'18",
                                                 Bop(And,bVar"b'17",
                                                     bVar"b'16")))))),
                             Let(Var("W",F1),Mop(Cast F1,LL[bVar"b'21"]),
                                 Let(Var("Rt2",F4),
                                     Mop(Cast F4,
                                         LL[bVar"b'11",bVar"b'10",
                                            bVar"b'9",bVar"b'8"]),
                                     Let(Var("Rt",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'15",bVar"b'14",
                                                bVar"b'13",bVar"b'12"]),
                                         MB(Call
                                              ("ThumbCondition",
                                               ATy(qTy,PTy(F4,qTy)),LU),
                                            Close
                                              (Var("v",F4),
                                               MB(MB(MB(Call
                                                          ("HaveThumb2",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           LU),
                                                        Close
                                                          (bVar"v0",
                                                           MB(MU(Bop(And,
                                                                     Bop(Or,
                                                                         EQ(Mop(Cast
                                                                                  F1,
                                                                                LL[bVar"b'24"]),
                                                                            LW(1,
                                                                               1)),
                                                                         EQ(Var("W",
                                                                                F1),
                                                                            LW(1,
                                                                               1))),
                                                                     bVar"v0"),
                                                                 qTy),
                                                              Close
                                                                (bVar"v0",
                                                                 MU(TP[Var("v",
                                                                           F4),
                                                                       bVar"v0"],
                                                                    qTy))))),
                                                     Close
                                                       (Var("v",
                                                            PTy(F4,bTy)),
                                                        Call
                                                          ("Take",
                                                           ATy(qTy,
                                                               PTy(bTy,qTy)),
                                                           Var("v",
                                                               PTy(F4,bTy))))),
                                                  Close
                                                    (bVar"b",
                                                     ITE(bVar"b",
                                                         MB(ITE(Bop(Or,
                                                                    Bop(Or,
                                                                        Bop(Or,
                                                                            Bop(In,
                                                                                Var("Rt",
                                                                                    F4),
                                                                                SL[LW(13,
                                                                                      4),
                                                                                   LW(15,
                                                                                      4)]),
                                                                            Bop(In,
                                                                                Var("Rt2",
                                                                                    F4),
                                                                                SL[LW(13,
                                                                                      4),
                                                                                   LW(15,
                                                                                      4)])),
                                                                        EQ(Var("Rt",
                                                                               F4),
                                                                           Var("Rt2",
                                                                               F4))),
                                                                    EQ(Var("W",
                                                                           F1),
                                                                       LW(1,
                                                                          1))),
                                                                Call
                                                                  ("DECODE_UNPREDICTABLE",
                                                                   ATy(qTy,
                                                                       PTy(uTy,
                                                                           qTy)),
                                                                   TP[Var("mc",
                                                                          CTy"MachineCode"),
                                                                      LS
                                                                       "LoadDual: literal"]),
                                                                MU(LU,qTy)),
                                                            Close
                                                              (AVar uTy,
                                                               MU(Call
                                                                    ("Load",
                                                                     CTy"instruction",
                                                                     Call
                                                                       ("LoadDualLiteral",
                                                                        CTy"Load",
                                                                        TP[EQ(Mop(Cast
                                                                                    F1,
                                                                                  LL[bVar"b'23"]),
                                                                              LW(1,
                                                                                 1)),
                                                                           Var("Rt",
                                                                               F4),
                                                                           Var("Rt2",
                                                                               F4),
                                                                           Mop(Cast
                                                                                 F32,
                                                                               CC[Mop(Cast
                                                                                        F8,
                                                                                      LL[bVar"b'7",
                                                                                         bVar"b'6",
                                                                                         bVar"b'5",
                                                                                         bVar"b'4",
                                                                                         bVar"b'3",
                                                                                         bVar"b'2",
                                                                                         bVar"b'1",
                                                                                         bVar"b'0"]),
                                                                                  LW(0,
                                                                                     2)])])),
                                                                  qTy))),
                                                         Call
                                                           ("Skip",
                                                            ATy(qTy,
                                                                PTy(CTy"instruction",
                                                                    qTy)),
                                                            LU)))))))))),
                            (Bop(And,Mop(Not,bVar"b'25"),
                                 Bop(And,bVar"b'22",bVar"b'20")),
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("W",F1),
                                     Mop(Cast F1,LL[bVar"b'21"]),
                                     Let(Var("P",F1),
                                         Mop(Cast F1,LL[bVar"b'24"]),
                                         Let(Var("Rt2",F4),
                                             Mop(Cast F4,
                                                 LL[bVar"b'11",bVar"b'10",
                                                    bVar"b'9",bVar"b'8"]),
                                             Let(Var("Rt",F4),
                                                 Mop(Cast F4,
                                                     LL[bVar"b'15",
                                                        bVar"b'14",
                                                        bVar"b'13",
                                                        bVar"b'12"]),
                                                 MB(Call
                                                      ("ThumbCondition",
                                                       ATy(qTy,PTy(F4,qTy)),
                                                       LU),
                                                    Close
                                                      (Var("v",F4),
                                                       MB(MB(MB(Call
                                                                  ("HaveThumb2",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   LU),
                                                                Close
                                                                  (bVar"v0",
                                                                   MB(MU(Bop(And,
                                                                             Bop(Or,
                                                                                 EQ(Var("P",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 EQ(Var("W",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1))),
                                                                             bVar"v0"),
                                                                         qTy),
                                                                      Close
                                                                        (bVar"v0",
                                                                         MU(TP[Var("v",
                                                                                   F4),
                                                                               bVar"v0"],
                                                                            qTy))))),
                                                             Close
                                                               (Var("v",
                                                                    PTy(F4,
                                                                        bTy)),
                                                                Call
                                                                  ("Take",
                                                                   ATy(qTy,
                                                                       PTy(bTy,
                                                                           qTy)),
                                                                   Var("v",
                                                                       PTy(F4,
                                                                           bTy))))),
                                                          Close
                                                            (bVar"b",
                                                             ITE(bVar"b",
                                                                 Let(bVar"wback",
                                                                     EQ(Var("W",
                                                                            F1),
                                                                        LW(1,
                                                                           1)),
                                                                     MB(ITE(Bop(Or,
                                                                                Bop(Or,
                                                                                    Bop(Or,
                                                                                        Bop(And,
                                                                                            bVar"wback",
                                                                                            Bop(Or,
                                                                                                EQ(Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rt",
                                                                                                       F4)),
                                                                                                EQ(Var("Rn",
                                                                                                       F4),
                                                                                                   Var("Rt2",
                                                                                                       F4)))),
                                                                                        Bop(In,
                                                                                            Var("Rt",
                                                                                                F4),
                                                                                            SL[LW(13,
                                                                                                  4),
                                                                                               LW(15,
                                                                                                  4)])),
                                                                                    Bop(In,
                                                                                        Var("Rt2",
                                                                                            F4),
                                                                                        SL[LW(13,
                                                                                              4),
                                                                                           LW(15,
                                                                                              4)])),
                                                                                EQ(Var("Rt",
                                                                                       F4),
                                                                                   Var("Rt2",
                                                                                       F4))),
                                                                            Call
                                                                              ("DECODE_UNPREDICTABLE",
                                                                               ATy(qTy,
                                                                                   PTy(uTy,
                                                                                       qTy)),
                                                                               TP[Var("mc",
                                                                                      CTy"MachineCode"),
                                                                                  LS
                                                                                   "LoadDual"]),
                                                                            MU(LU,
                                                                               qTy)),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MU(Call
                                                                                ("Load",
                                                                                 CTy"instruction",
                                                                                 Call
                                                                                   ("LoadDual",
                                                                                    CTy"Load",
                                                                                    TP[EQ(Mop(Cast
                                                                                                F1,
                                                                                              LL[bVar"b'23"]),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       EQ(Var("P",
                                                                                              F1),
                                                                                          LW(1,
                                                                                             1)),
                                                                                       bVar"wback",
                                                                                       Var("Rt",
                                                                                           F4),
                                                                                       Var("Rt2",
                                                                                           F4),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Call
                                                                                         ("immediate_form2",
                                                                                          CTy"offset2",
                                                                                          Mop(Cast
                                                                                                F32,
                                                                                              CC[Mop(Cast
                                                                                                       F8,
                                                                                                     LL[bVar"b'7",
                                                                                                        bVar"b'6",
                                                                                                        bVar"b'5",
                                                                                                        bVar"b'4",
                                                                                                        bVar"b'3",
                                                                                                        bVar"b'2",
                                                                                                        bVar"b'1",
                                                                                                        bVar"b'0"]),
                                                                                                 LW(0,
                                                                                                    2)]))])),
                                                                              qTy)))),
                                                                 Call
                                                                   ("Skip",
                                                                    ATy(qTy,
                                                                        PTy(CTy"instruction",
                                                                            qTy)),
                                                                    LU)))))))))))),
                            (bVar"b'25",
                             Let(Var("Rn",F4),
                                 Mop(Cast F4,
                                     LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                        bVar"b'16"]),
                                 Let(Var("S",F1),
                                     Mop(Cast F1,LL[bVar"b'20"]),
                                     Let(Var("Rm",F4),
                                         Mop(Cast F4,
                                             LL[bVar"b'3",bVar"b'2",
                                                bVar"b'1",bVar"b'0"]),
                                         Let(Var("typ",FTy 2),
                                             Mop(Cast(FTy 2),
                                                 LL[bVar"b'5",bVar"b'4"]),
                                             Let(Var("imm2",FTy 2),
                                                 Mop(Cast(FTy 2),
                                                     LL[bVar"b'7",
                                                        bVar"b'6"]),
                                                 Let(Var("Rd",F4),
                                                     Mop(Cast F4,
                                                         LL[bVar"b'11",
                                                            bVar"b'10",
                                                            bVar"b'9",
                                                            bVar"b'8"]),
                                                     Let(Var("imm3",FTy 3),
                                                         Mop(Cast(FTy 3),
                                                             LL[bVar"b'14",
                                                                bVar"b'13",
                                                                bVar"b'12"]),
                                                         MB(Call
                                                              ("ThumbCondition",
                                                               ATy(qTy,
                                                                   PTy(F4,
                                                                       qTy)),
                                                               LU),
                                                            Close
                                                              (Var("v",F4),
                                                               MB(MB(MB(Call
                                                                          ("HaveThumb2",
                                                                           ATy(qTy,
                                                                               PTy(bTy,
                                                                                   qTy)),
                                                                           LU),
                                                                        Close
                                                                          (bVar"v0",
                                                                           MU(TP[Var("v",
                                                                                     F4),
                                                                                 bVar"v0"],
                                                                              qTy))),
                                                                     Close
                                                                       (Var("v",
                                                                            PTy(F4,
                                                                                bTy)),
                                                                        Call
                                                                          ("Take",
                                                                           ATy(qTy,
                                                                               PTy(bTy,
                                                                                   qTy)),
                                                                           Var("v",
                                                                               PTy(F4,
                                                                                   bTy))))),
                                                                  Close
                                                                    (bVar"b",
                                                                     ITE(bVar"b",
                                                                         Let(TP[Var("shift_t",
                                                                                    CTy"SRType"),
                                                                                nVar"shift_n"],
                                                                             Call
                                                                               ("DecodeImmShift",
                                                                                PTy(CTy"SRType",
                                                                                    nTy),
                                                                                TP[Var("typ",
                                                                                       FTy 2),
                                                                                   CC[Var("imm3",
                                                                                          FTy 3),
                                                                                      Var("imm2",
                                                                                          FTy 2)]]),
                                                                             Let(bVar"setflags",
                                                                                 EQ(Var("S",
                                                                                        F1),
                                                                                    LW(1,
                                                                                       1)),
                                                                                 CS(TP[Mop(Cast
                                                                                             F4,
                                                                                           LL[bVar"b'24",
                                                                                              bVar"b'23",
                                                                                              bVar"b'22",
                                                                                              bVar"b'21"]),
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       Var("S",
                                                                                           F1)],
                                                                                    [(TP[LW(0,
                                                                                            4),
                                                                                         AVar
                                                                                           F4,
                                                                                         LW(15,
                                                                                            4),
                                                                                         LW(1,
                                                                                            1)],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(In,
                                                                                                     Var("Rn",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)]),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "TST (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("TestCompareRegister",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(0,
                                                                                                           2),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(0,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(Or,
                                                                                                         EQ(Var("Rd",
                                                                                                                F4),
                                                                                                            LW(13,
                                                                                                               4)),
                                                                                                         Bop(And,
                                                                                                             EQ(Var("Rd",
                                                                                                                    F4),
                                                                                                                LW(15,
                                                                                                                   4)),
                                                                                                             Mop(Not,
                                                                                                                 bVar"setflags"))),
                                                                                                     Bop(In,
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)])),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "AND (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(0,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(1,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(In,
                                                                                                         Var("Rd",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)]),
                                                                                                     Bop(In,
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)])),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "BIC (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(14,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(2,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                F1))],
                                                                                      MB(ITB([(Bop(And,
                                                                                                   Bop(And,
                                                                                                       EQ(Var("typ",
                                                                                                              FTy 2),
                                                                                                          LW(0,
                                                                                                             2)),
                                                                                                       EQ(Var("imm3",
                                                                                                              FTy 3),
                                                                                                          LW(0,
                                                                                                             3))),
                                                                                                   EQ(Var("imm2",
                                                                                                          FTy 2),
                                                                                                      LW(0,
                                                                                                         2))),
                                                                                               ITE(Bop(Or,
                                                                                                       Bop(And,
                                                                                                           bVar"setflags",
                                                                                                           Bop(Or,
                                                                                                               Bop(In,
                                                                                                                   Var("Rd",
                                                                                                                       F4),
                                                                                                                   SL[LW(13,
                                                                                                                         4),
                                                                                                                      LW(15,
                                                                                                                         4)]),
                                                                                                               Bop(In,
                                                                                                                   Var("Rm",
                                                                                                                       F4),
                                                                                                                   SL[LW(13,
                                                                                                                         4),
                                                                                                                      LW(15,
                                                                                                                         4)]))),
                                                                                                       Bop(And,
                                                                                                           Mop(Not,
                                                                                                               bVar"setflags"),
                                                                                                           Bop(Or,
                                                                                                               Bop(Or,
                                                                                                                   EQ(Var("Rd",
                                                                                                                          F4),
                                                                                                                      LW(15,
                                                                                                                         4)),
                                                                                                                   EQ(Var("Rm",
                                                                                                                          F4),
                                                                                                                      LW(15,
                                                                                                                         4))),
                                                                                                               Bop(And,
                                                                                                                   EQ(Var("Rd",
                                                                                                                          F4),
                                                                                                                      LW(13,
                                                                                                                         4)),
                                                                                                                   EQ(Var("Rm",
                                                                                                                          F4),
                                                                                                                      LW(13,
                                                                                                                         4)))))),
                                                                                                   Call
                                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                                      ATy(qTy,
                                                                                                          PTy(uTy,
                                                                                                              qTy)),
                                                                                                      TP[Var("mc",
                                                                                                             CTy"MachineCode"),
                                                                                                         LS
                                                                                                          "MOV (register)"]),
                                                                                                   MU(LU,
                                                                                                      qTy))),
                                                                                              (Bop(Or,
                                                                                                   Bop(In,
                                                                                                       Var("Rd",
                                                                                                           F4),
                                                                                                       SL[LW(13,
                                                                                                             4),
                                                                                                          LW(15,
                                                                                                             4)]),
                                                                                                   Bop(In,
                                                                                                       Var("Rm",
                                                                                                           F4),
                                                                                                       SL[LW(13,
                                                                                                             4),
                                                                                                          LW(15,
                                                                                                             4)])),
                                                                                               Call
                                                                                                 ("DECODE_UNPREDICTABLE",
                                                                                                  ATy(qTy,
                                                                                                      PTy(uTy,
                                                                                                          qTy)),
                                                                                                  TP[Var("mc",
                                                                                                         CTy"MachineCode"),
                                                                                                     LS
                                                                                                      "SHIFT (register)"]))],
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("ShiftImmediate",
                                                                                                     CTy"Data",
                                                                                                     TP[LF,
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(2,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(In,
                                                                                                         Var("Rd",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)]),
                                                                                                     EQ(Var("Rn",
                                                                                                            F4),
                                                                                                        LW(13,
                                                                                                           4))),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "ORR (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(12,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(3,
                                                                                            4),
                                                                                         LW(15,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                F1))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(In,
                                                                                                     Var("Rd",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)]),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "MVN (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("ShiftImmediate",
                                                                                                     CTy"Data",
                                                                                                     TP[LT,
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(3,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(In,
                                                                                                         Var("Rd",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)]),
                                                                                                     EQ(Var("Rn",
                                                                                                            F4),
                                                                                                        LW(13,
                                                                                                           4))),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "ORN (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(15,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(4,
                                                                                            4),
                                                                                         AVar
                                                                                           F4,
                                                                                         LW(15,
                                                                                            4),
                                                                                         LW(1,
                                                                                            1)],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(In,
                                                                                                     Var("Rn",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)]),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "TEQ (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("TestCompareRegister",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(1,
                                                                                                           2),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(4,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(Or,
                                                                                                         EQ(Var("Rd",
                                                                                                                F4),
                                                                                                            LW(13,
                                                                                                               4)),
                                                                                                         Bop(And,
                                                                                                             EQ(Var("Rd",
                                                                                                                    F4),
                                                                                                                LW(15,
                                                                                                                   4)),
                                                                                                             Mop(Not,
                                                                                                                 bVar"setflags"))),
                                                                                                     Bop(In,
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)])),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "EOR (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(1,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(6,
                                                                                            4),
                                                                                         AVar
                                                                                           F4,
                                                                                         AVar
                                                                                           F4,
                                                                                         LW(0,
                                                                                            1)],
                                                                                      ITE(Bop(Bit,
                                                                                              Var("typ",
                                                                                                  FTy 2),
                                                                                              LN
                                                                                               0),
                                                                                          MU(Call
                                                                                               ("Undefined",
                                                                                                CTy"instruction",
                                                                                                LW(0,
                                                                                                   32)),
                                                                                             qTy),
                                                                                          MB(ITE(Bop(Or,
                                                                                                     Bop(Or,
                                                                                                         Bop(In,
                                                                                                             Var("Rd",
                                                                                                                 F4),
                                                                                                             SL[LW(13,
                                                                                                                   4),
                                                                                                                LW(15,
                                                                                                                   4)]),
                                                                                                         Bop(In,
                                                                                                             Var("Rn",
                                                                                                                 F4),
                                                                                                             SL[LW(13,
                                                                                                                   4),
                                                                                                                LW(15,
                                                                                                                   4)])),
                                                                                                     Bop(In,
                                                                                                         Var("Rm",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)])),
                                                                                                 Call
                                                                                                   ("DECODE_UNPREDICTABLE",
                                                                                                    ATy(qTy,
                                                                                                        PTy(uTy,
                                                                                                            qTy)),
                                                                                                    TP[Var("mc",
                                                                                                           CTy"MachineCode"),
                                                                                                       LS
                                                                                                        "PackHalfword"]),
                                                                                                 MU(LU,
                                                                                                    qTy)),
                                                                                             Close
                                                                                               (AVar
                                                                                                  uTy,
                                                                                                MU(Call
                                                                                                     ("Media",
                                                                                                      CTy"instruction",
                                                                                                      Call
                                                                                                        ("PackHalfword",
                                                                                                         CTy"Media",
                                                                                                         TP[Var("shift_t",
                                                                                                                CTy"SRType"),
                                                                                                            nVar"shift_n",
                                                                                                            Bop(Bit,
                                                                                                                Var("typ",
                                                                                                                    FTy 2),
                                                                                                                LN
                                                                                                                 1),
                                                                                                            Var("Rd",
                                                                                                                F4),
                                                                                                            Var("Rn",
                                                                                                                F4),
                                                                                                            Var("Rm",
                                                                                                                F4)])),
                                                                                                   qTy))))),
                                                                                     (TP[LW(8,
                                                                                            4),
                                                                                         AVar
                                                                                           F4,
                                                                                         LW(15,
                                                                                            4),
                                                                                         LW(1,
                                                                                            1)],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 EQ(Var("Rn",
                                                                                                        F4),
                                                                                                    LW(15,
                                                                                                       4)),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "CMN (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("TestCompareRegister",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(3,
                                                                                                           2),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(8,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(Or,
                                                                                                         EQ(Var("Rd",
                                                                                                                F4),
                                                                                                            LW(13,
                                                                                                               4)),
                                                                                                         Bop(And,
                                                                                                             EQ(Var("Rd",
                                                                                                                    F4),
                                                                                                                LW(15,
                                                                                                                   4)),
                                                                                                             Mop(Not,
                                                                                                                 bVar"setflags"))),
                                                                                                     EQ(Var("Rn",
                                                                                                            F4),
                                                                                                        LW(15,
                                                                                                           4))),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "ADD (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Let(TP[Var("shift_t",
                                                                                                          CTy"SRType"),
                                                                                                      nVar"shift_n"],
                                                                                                   Call
                                                                                                     ("DecodeImmShift",
                                                                                                      PTy(CTy"SRType",
                                                                                                          nTy),
                                                                                                      TP[Var("typ",
                                                                                                             FTy 2),
                                                                                                         CC[Var("imm3",
                                                                                                                FTy 3),
                                                                                                            Var("imm2",
                                                                                                                FTy 2)]]),
                                                                                                   Call
                                                                                                     ("Data",
                                                                                                      CTy"instruction",
                                                                                                      Call
                                                                                                        ("Register",
                                                                                                         CTy"Data",
                                                                                                         TP[LW(4,
                                                                                                               4),
                                                                                                            bVar"setflags",
                                                                                                            Var("Rd",
                                                                                                                F4),
                                                                                                            Var("Rn",
                                                                                                                F4),
                                                                                                            Var("Rm",
                                                                                                                F4),
                                                                                                            Var("shift_t",
                                                                                                                CTy"SRType"),
                                                                                                            nVar"shift_n"]))),
                                                                                               qTy)))),
                                                                                     (TP[LW(10,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(In,
                                                                                                         Var("Rd",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)]),
                                                                                                     Bop(In,
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)])),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "ADC (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(5,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(11,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(In,
                                                                                                         Var("Rd",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)]),
                                                                                                     Bop(In,
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)])),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "SBC (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(6,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(13,
                                                                                            4),
                                                                                         AVar
                                                                                           F4,
                                                                                         LW(15,
                                                                                            4),
                                                                                         LW(1,
                                                                                            1)],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 EQ(Var("Rn",
                                                                                                        F4),
                                                                                                    LW(15,
                                                                                                       4)),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "CMP (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("TestCompareRegister",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(2,
                                                                                                           2),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(13,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(Or,
                                                                                                         EQ(Var("Rd",
                                                                                                                F4),
                                                                                                            LW(13,
                                                                                                               4)),
                                                                                                         Bop(And,
                                                                                                             EQ(Var("Rd",
                                                                                                                    F4),
                                                                                                                LW(15,
                                                                                                                   4)),
                                                                                                             Mop(Not,
                                                                                                                 bVar"setflags"))),
                                                                                                     EQ(Var("Rn",
                                                                                                            F4),
                                                                                                        LW(15,
                                                                                                           4))),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "SUB (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(2,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (TP[LW(14,
                                                                                            4),
                                                                                         AVar
                                                                                           (PTy(F4,
                                                                                                PTy(F4,
                                                                                                    F1)))],
                                                                                      MB(ITE(Bop(Or,
                                                                                                 Bop(Or,
                                                                                                     Bop(In,
                                                                                                         Var("Rd",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)]),
                                                                                                     Bop(In,
                                                                                                         Var("Rn",
                                                                                                             F4),
                                                                                                         SL[LW(13,
                                                                                                               4),
                                                                                                            LW(15,
                                                                                                               4)])),
                                                                                                 Bop(In,
                                                                                                     Var("Rm",
                                                                                                         F4),
                                                                                                     SL[LW(13,
                                                                                                           4),
                                                                                                        LW(15,
                                                                                                           4)])),
                                                                                             Call
                                                                                               ("DECODE_UNPREDICTABLE",
                                                                                                ATy(qTy,
                                                                                                    PTy(uTy,
                                                                                                        qTy)),
                                                                                                TP[Var("mc",
                                                                                                       CTy"MachineCode"),
                                                                                                   LS
                                                                                                    "RSB (register)"]),
                                                                                             MU(LU,
                                                                                                qTy)),
                                                                                         Close
                                                                                           (AVar
                                                                                              uTy,
                                                                                            MU(Call
                                                                                                 ("Data",
                                                                                                  CTy"instruction",
                                                                                                  Call
                                                                                                    ("Register",
                                                                                                     CTy"Data",
                                                                                                     TP[LW(3,
                                                                                                           4),
                                                                                                        bVar"setflags",
                                                                                                        Var("Rd",
                                                                                                            F4),
                                                                                                        Var("Rn",
                                                                                                            F4),
                                                                                                        Var("Rm",
                                                                                                            F4),
                                                                                                        Var("shift_t",
                                                                                                            CTy"SRType"),
                                                                                                        nVar"shift_n"])),
                                                                                               qTy)))),
                                                                                     (AVar
                                                                                        (PTy(F4,
                                                                                             PTy(F4,
                                                                                                 PTy(F4,
                                                                                                     F1)))),
                                                                                      MU(Call
                                                                                           ("Undefined",
                                                                                            CTy"instruction",
                                                                                            LW(0,
                                                                                               32)),
                                                                                         qTy))]))),
                                                                         Call
                                                                           ("Skip",
                                                                            ATy(qTy,
                                                                                PTy(CTy"instruction",
                                                                                    qTy)),
                                                                            LU))))))))))))))],
                           Call
                             ("UndefinedThumb",
                              ATy(qTy,PTy(CTy"instruction",qTy)),LU)))],
                     Call
                       ("UndefinedThumb",
                        ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                (bVar"b'15",
                 ITE(Bop(And,bVar"b'31",
                         Bop(And,bVar"b'30",Bop(And,bVar"b'29",bVar"b'28"))),
                     ITB([(Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,Mop(Not,bVar"b'22"),
                                               Bop(And,
                                                   Mop(Not,bVar"b'21"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'14"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'12"),
                                                           bVar"b'5")))))))),
                           Let(Var("Rn",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                      bVar"b'16"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(Call
                                                ("HaveVirtExt",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(ITE(Bop(In,Var("Rn",F4),
                                                          SL[LW(13,4),
                                                             LW(15,4)]),
                                                      Call
                                                        ("DECODE_UNPREDICTABLE",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         TP[Var("mc",
                                                                CTy"MachineCode"),
                                                            LS
                                                             "MoveToBankedOrSpecialRegister"]),
                                                      MU(LU,qTy)),
                                                  Close
                                                    (AVar uTy,
                                                     MU(Call
                                                          ("System",
                                                           CTy"instruction",
                                                           Call
                                                             ("MoveToBankedOrSpecialRegister",
                                                              CTy"System",
                                                              TP[EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'20"]),
                                                                    LW(1,1)),
                                                                 CC[Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'4"]),
                                                                    Mop(Cast
                                                                          F4,
                                                                        LL[bVar"b'11",
                                                                           bVar"b'10",
                                                                           bVar"b'9",
                                                                           bVar"b'8"])],
                                                                 Var("Rn",
                                                                     F4)])),
                                                        qTy))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,Mop(Not,bVar"b'22"),
                                               Bop(And,
                                                   Mop(Not,bVar"b'21"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'14"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'12"),
                                                           Mop(Not,
                                                               bVar"b'5"))))))))),
                           Let(Var("Rn",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                      bVar"b'16"]),
                               Let(Var("mask",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                          bVar"b'8"]),
                                   MB(Call
                                        ("ThumbCondition",
                                         ATy(qTy,PTy(F4,qTy)),LU),
                                      Close
                                        (Var("v",F4),
                                         MB(MB(MB(Call
                                                    ("HaveThumb2",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v0",
                                                     MU(TP[Var("v",F4),
                                                           bVar"v0"],qTy))),
                                               Close
                                                 (Var("v",PTy(F4,bTy)),
                                                  Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     Var("v",PTy(F4,bTy))))),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MB(ITE(Bop(Or,
                                                              EQ(Var("mask",
                                                                     F4),
                                                                 LW(0,4)),
                                                              Bop(In,
                                                                  Var("Rn",
                                                                      F4),
                                                                  SL[LW(13,
                                                                        4),
                                                                     LW(15,
                                                                        4)])),
                                                          Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS
                                                                 "MoveToSpecialFromRegister"]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Call
                                                              ("System",
                                                               CTy"instruction",
                                                               Call
                                                                 ("MoveToSpecialFromRegister",
                                                                  CTy"System",
                                                                  TP[EQ(Mop(Cast
                                                                              F1,
                                                                            LL[bVar"b'20"]),
                                                                        LW(1,
                                                                           1)),
                                                                     Var("Rn",
                                                                         F4),
                                                                     Var("mask",
                                                                         F4)])),
                                                            qTy))),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU))))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,Mop(Not,bVar"b'22"),
                                               Bop(And,bVar"b'21",
                                                   Bop(And,
                                                       Mop(Not,bVar"b'20"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Bop(And,
                                                               Mop(Not,
                                                                   bVar"b'12"),
                                                               Bop(And,
                                                                   Mop(Not,
                                                                       bVar"b'10"),
                                                                   Bop(And,
                                                                       Mop(Not,
                                                                           bVar"b'9"),
                                                                       Mop(Not,
                                                                           bVar"b'8")))))))))))),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MU(TP[Var("v",F4),
                                          Mop(Cast F8,
                                              LL[bVar"b'7",bVar"b'6",
                                                 bVar"b'5",bVar"b'4",
                                                 bVar"b'3",bVar"b'2",
                                                 bVar"b'1",bVar"b'0"])],
                                       qTy),
                                    Close
                                      (Var("v",PTy(F4,F8)),
                                       Call
                                         ("DecodeHint",
                                          ATy(qTy,
                                              PTy(CTy"instruction",qTy)),
                                          Var("v",PTy(F4,F8)))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,Mop(Not,bVar"b'22"),
                                               Bop(And,bVar"b'21",
                                                   Bop(And,
                                                       Mop(Not,bVar"b'20"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Mop(Not,
                                                               bVar"b'12"))))))))),
                           Let(Var("mode",FTy 5),
                               Mop(Cast(FTy 5),
                                   LL[bVar"b'4",bVar"b'3",bVar"b'2",
                                      bVar"b'1",bVar"b'0"]),
                               Let(Var("F",F1),Mop(Cast F1,LL[bVar"b'5"]),
                                   Let(Var("I",F1),
                                       Mop(Cast F1,LL[bVar"b'6"]),
                                       Let(Var("A",F1),
                                           Mop(Cast F1,LL[bVar"b'7"]),
                                           Let(Var("M",F1),
                                               Mop(Cast F1,LL[bVar"b'8"]),
                                               Let(Var("imod",FTy 2),
                                                   Mop(Cast(FTy 2),
                                                       LL[bVar"b'10",
                                                          bVar"b'9"]),
                                                   MB(Call
                                                        ("ThumbCondition",
                                                         ATy(qTy,
                                                             PTy(F4,qTy)),
                                                         LU),
                                                      Close
                                                        (Var("v",F4),
                                                         MB(MB(MB(Call
                                                                    ("HaveThumb2",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (bVar"v0",
                                                                     MU(TP[Var("v",
                                                                               F4),
                                                                           bVar"v0"],
                                                                        qTy))),
                                                               Close
                                                                 (Var("v",
                                                                      PTy(F4,
                                                                          bTy)),
                                                                  Call
                                                                    ("Take",
                                                                     ATy(qTy,
                                                                         PTy(bTy,
                                                                             qTy)),
                                                                     Var("v",
                                                                         PTy(F4,
                                                                             bTy))))),
                                                            Close
                                                              (bVar"b",
                                                               ITE(bVar"b",
                                                                   MB(Call
                                                                        ("InITBlock",
                                                                         ATy(qTy,
                                                                             PTy(bTy,
                                                                                 qTy)),
                                                                         LU),
                                                                      Close
                                                                        (bVar"v",
                                                                         MB(MB(MU(Bop(Or,
                                                                                      Bop(Or,
                                                                                          Bop(Or,
                                                                                              Bop(And,
                                                                                                  Mop(Not,
                                                                                                      EQ(Var("mode",
                                                                                                             FTy 5),
                                                                                                         LW(0,
                                                                                                            5))),
                                                                                                  EQ(Var("M",
                                                                                                         F1),
                                                                                                     LW(0,
                                                                                                        1))),
                                                                                              EQ(Bop(Bit,
                                                                                                     Var("imod",
                                                                                                         FTy 2),
                                                                                                     LN
                                                                                                      1),
                                                                                                 EQ(CC[Var("A",
                                                                                                           F1),
                                                                                                       Var("I",
                                                                                                           F1),
                                                                                                       Var("F",
                                                                                                           F1)],
                                                                                                    LW(0,
                                                                                                       3)))),
                                                                                          EQ(Var("imod",
                                                                                                 FTy 2),
                                                                                             LW(1,
                                                                                                2))),
                                                                                      bVar"v"),
                                                                                  qTy),
                                                                               Close
                                                                                 (bVar"b",
                                                                                  ITE(bVar"b",
                                                                                      Call
                                                                                        ("DECODE_UNPREDICTABLE",
                                                                                         ATy(qTy,
                                                                                             PTy(uTy,
                                                                                                 qTy)),
                                                                                         TP[Var("mc",
                                                                                                CTy"MachineCode"),
                                                                                            LS
                                                                                             "ChangeProcessorState"]),
                                                                                      MU(LU,
                                                                                         qTy)))),
                                                                            Close
                                                                              (AVar
                                                                                 uTy,
                                                                               MU(Call
                                                                                    ("System",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("ChangeProcessorState",
                                                                                        CTy"System",
                                                                                        TP[EQ(Var("imod",
                                                                                                  FTy 2),
                                                                                              LW(2,
                                                                                                 2)),
                                                                                           EQ(Var("imod",
                                                                                                  FTy 2),
                                                                                              LW(3,
                                                                                                 2)),
                                                                                           EQ(Var("A",
                                                                                                  F1),
                                                                                              LW(1,
                                                                                                 1)),
                                                                                           EQ(Var("I",
                                                                                                  F1),
                                                                                              LW(1,
                                                                                                 1)),
                                                                                           EQ(Var("F",
                                                                                                  F1),
                                                                                              LW(1,
                                                                                                 1)),
                                                                                           EQ(Var("M",
                                                                                                  F1),
                                                                                              LW(1,
                                                                                                 1)),
                                                                                           Var("mode",
                                                                                               FTy 5)])),
                                                                                  qTy))))),
                                                                   Call
                                                                     ("Skip",
                                                                      ATy(qTy,
                                                                          PTy(CTy"instruction",
                                                                              qTy)),
                                                                      LU))))))))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,Mop(Not,bVar"b'22"),
                                               Bop(And,bVar"b'21",
                                                   Bop(And,bVar"b'20",
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Bop(And,
                                                               Mop(Not,
                                                                   bVar"b'12"),
                                                               Bop(And,
                                                                   Mop(Not,
                                                                       bVar"b'7"),
                                                                   Bop(And,
                                                                       Mop(Not,
                                                                           bVar"b'6"),
                                                                       Mop(Not,
                                                                           bVar"b'5")))))))))))),
                           Let(Var("J",F1),Mop(Cast F1,LL[bVar"b'4"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(MB(Call
                                                   ("HaveThumbEE",
                                                    ATy(qTy,PTy(bTy,qTy)),
                                                    LU),
                                                 Close
                                                   (bVar"v0",
                                                    MU(TP[Var("v",F4),
                                                          bVar"v0"],qTy))),
                                              Close
                                                (Var("v",PTy(F4,bTy)),
                                                 Call
                                                   ("Take",
                                                    ATy(qTy,PTy(bTy,qTy)),
                                                    Var("v",PTy(F4,bTy))))),
                                           Close
                                             (bVar"b",
                                              ITE(bVar"b",
                                                  MB(Call
                                                       ("CurrentInstrSet",
                                                        ATy(qTy,
                                                            PTy(CTy"InstrSet",
                                                                qTy)),LU),
                                                     Close
                                                       (Var("v",
                                                            CTy"InstrSet"),
                                                        MB(MB(MU(EQ(Var("v",
                                                                        CTy"InstrSet"),
                                                                    LC("InstrSet_Thumb",
                                                                       CTy"InstrSet")),
                                                                 qTy),
                                                              Close
                                                                (bVar"b",
                                                                 MU(Bop(And,
                                                                        bVar"b",
                                                                        EQ(Var("J",
                                                                               F1),
                                                                           LW(0,
                                                                              1))),
                                                                    qTy))),
                                                           Close
                                                             (bVar"v",
                                                              MU(Mop(Not,
                                                                     bVar"v"),
                                                                 qTy))))),
                                                  MU(LF,qTy)))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(Call
                                                    ("InITBlock",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v",
                                                     MB(ITE(bVar"v",
                                                            Call
                                                              ("DECODE_UNPREDICTABLE",
                                                               ATy(qTy,
                                                                   PTy(uTy,
                                                                       qTy)),
                                                               TP[Var("mc",
                                                                      CTy"MachineCode"),
                                                                  LS
                                                                   "EnterxLeavex"]),
                                                            MU(LU,qTy)),
                                                        Close
                                                          (AVar uTy,
                                                           MU(Call
                                                                ("System",
                                                                 CTy"instruction",
                                                                 Call
                                                                   ("EnterxLeavex",
                                                                    CTy"System",
                                                                    EQ(Var("J",
                                                                           F1),
                                                                       LW(1,
                                                                          1)))),
                                                              qTy))))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,Mop(Not,bVar"b'22"),
                                               Bop(And,bVar"b'21",
                                                   Bop(And,bVar"b'20",
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Mop(Not,
                                                               bVar"b'12"))))))))),
                           Let(Var("option",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                      bVar"b'0"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(Call
                                                ("HaveThumb2",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               CS(Mop(Cast F4,
                                                      LL[bVar"b'7",
                                                         bVar"b'6",
                                                         bVar"b'5",
                                                         bVar"b'4"]),
                                                  [(LW(2,4),
                                                    MU(Const
                                                         ("ClearExclusive",
                                                          CTy"instruction"),
                                                       qTy)),
                                                   (LW(4,4),
                                                    MU(Call
                                                         ("Hint",
                                                          CTy"instruction",
                                                          Call
                                                            ("DataSynchronizationBarrier",
                                                             CTy"Hint",
                                                             Var("option",
                                                                 F4))),qTy)),
                                                   (LW(5,4),
                                                    MU(Call
                                                         ("Hint",
                                                          CTy"instruction",
                                                          Call
                                                            ("DataMemoryBarrier",
                                                             CTy"Hint",
                                                             Var("option",
                                                                 F4))),qTy)),
                                                   (LW(6,4),
                                                    MU(Call
                                                         ("Hint",
                                                          CTy"instruction",
                                                          Call
                                                            ("InstructionSynchronizationBarrier",
                                                             CTy"Hint",
                                                             Var("option",
                                                                 F4))),qTy)),
                                                   (AVar F4,
                                                    MB(Call
                                                         ("ArchVersion",
                                                          ATy(qTy,
                                                              PTy(nTy,qTy)),
                                                          LU),
                                                       Close
                                                         (nVar"v",
                                                          MB(MU(Bop(Ge,
                                                                    nVar"v",
                                                                    LN 7),
                                                                qTy),
                                                             Close
                                                               (bVar"b",
                                                                ITE(bVar"b",
                                                                    MU(Call
                                                                         ("Undefined",
                                                                          CTy"instruction",
                                                                          LW(0,
                                                                             32)),
                                                                       qTy),
                                                                    MB(Call
                                                                         ("DECODE_UNPREDICTABLE",
                                                                          ATy(qTy,
                                                                              PTy(uTy,
                                                                                  qTy)),
                                                                          TP[Var("mc",
                                                                                 CTy"MachineCode"),
                                                                             LS
                                                                              "Miscellaneous control"]),
                                                                       Close
                                                                         (AVar
                                                                            uTy,
                                                                          MU(LX(CTy"instruction"),
                                                                             qTy)))))))))]),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,bVar"b'22",
                                               Bop(And,
                                                   Mop(Not,bVar"b'21"),
                                                   Bop(And,bVar"b'20",
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Mop(Not,
                                                               bVar"b'12"))))))))),
                           Let(Var("imm8",F8),
                               Mop(Cast F8,
                                   LL[bVar"b'7",bVar"b'6",bVar"b'5",
                                      bVar"b'4",bVar"b'3",bVar"b'2",
                                      bVar"b'1",bVar"b'0"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(Call
                                                ("HaveThumb2",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(Call
                                                    ("HaveVirtExt",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v",
                                                     MB(MU(Bop(And,
                                                               bVar"v",
                                                               EQ(Var("imm8",
                                                                      F8),
                                                                  LW(0,8))),
                                                           qTy),
                                                        Close
                                                          (bVar"b",
                                                           ITE(bVar"b",
                                                               MU(Call
                                                                    ("System",
                                                                     CTy"instruction",
                                                                     Const
                                                                       ("ExceptionReturn",
                                                                        CTy"System")),
                                                                  qTy),
                                                               MB(Call
                                                                    ("CurrentInstrSet",
                                                                     ATy(qTy,
                                                                         PTy(CTy"InstrSet",
                                                                             qTy)),
                                                                     LU),
                                                                  Close
                                                                    (Var("v",
                                                                         CTy"InstrSet"),
                                                                     MB(MB(MB(MU(EQ(Var("v",
                                                                                        CTy"InstrSet"),
                                                                                    LC("InstrSet_ThumbEE",
                                                                                       CTy"InstrSet")),
                                                                                 qTy),
                                                                              Close
                                                                                (bVar"b",
                                                                                 ITE(bVar"b",
                                                                                     MU(LT,
                                                                                        qTy),
                                                                                     MB(Call
                                                                                          ("InITBlock",
                                                                                           ATy(qTy,
                                                                                               PTy(bTy,
                                                                                                   qTy)),
                                                                                           LU),
                                                                                        Close
                                                                                          (bVar"b",
                                                                                           ITE(bVar"b",
                                                                                               MB(Call
                                                                                                    ("LastInITBlock",
                                                                                                     ATy(qTy,
                                                                                                         PTy(bTy,
                                                                                                             qTy)),
                                                                                                     LU),
                                                                                                  Close
                                                                                                    (bVar"v",
                                                                                                     MU(Mop(Not,
                                                                                                            bVar"v"),
                                                                                                        qTy))),
                                                                                               MU(LF,
                                                                                                  qTy))))))),
                                                                           Close
                                                                             (bVar"b",
                                                                              ITE(bVar"b",
                                                                                  Call
                                                                                    ("DECODE_UNPREDICTABLE",
                                                                                     ATy(qTy,
                                                                                         PTy(uTy,
                                                                                             qTy)),
                                                                                     TP[Var("mc",
                                                                                            CTy"MachineCode"),
                                                                                        LS
                                                                                         "SUBS<c> PC, LR, #0"]),
                                                                                  MU(LU,
                                                                                     qTy)))),
                                                                        Close
                                                                          (AVar
                                                                             uTy,
                                                                           MB(Call
                                                                                ("CurrentModeIsHyp",
                                                                                 ATy(qTy,
                                                                                     PTy(bTy,
                                                                                         qTy)),
                                                                                 LU),
                                                                              Close
                                                                                (bVar"b",
                                                                                 MU(ITE(bVar"b",
                                                                                        Call
                                                                                          ("Undefined",
                                                                                           CTy"instruction",
                                                                                           LW(0,
                                                                                              32)),
                                                                                        Call
                                                                                          ("Data",
                                                                                           CTy"instruction",
                                                                                           Call
                                                                                             ("ArithLogicImmediate",
                                                                                              CTy"Data",
                                                                                              TP[LW(2,
                                                                                                    4),
                                                                                                 LT,
                                                                                                 LW(15,
                                                                                                    4),
                                                                                                 LW(14,
                                                                                                    4),
                                                                                                 Mop(Cast
                                                                                                       (FTy 12),
                                                                                                     Var("imm8",
                                                                                                         F8))]))),
                                                                                    qTy)))))))))))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,bVar"b'22",
                                               Bop(And,bVar"b'21",
                                                   Bop(And,
                                                       Mop(Not,bVar"b'14"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'12"),
                                                           bVar"b'5")))))))),
                           Let(Var("Rd",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                      bVar"b'8"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(Call
                                                ("HaveVirtExt",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(ITE(Bop(In,Var("Rd",F4),
                                                          SL[LW(13,4),
                                                             LW(15,4)]),
                                                      Call
                                                        ("DECODE_UNPREDICTABLE",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         TP[Var("mc",
                                                                CTy"MachineCode"),
                                                            LS
                                                             "MoveToRegisterFromBankedOrSpecial"]),
                                                      MU(LU,qTy)),
                                                  Close
                                                    (AVar uTy,
                                                     MU(Call
                                                          ("System",
                                                           CTy"instruction",
                                                           Call
                                                             ("MoveToRegisterFromBankedOrSpecial",
                                                              CTy"System",
                                                              TP[EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'20"]),
                                                                    LW(1,1)),
                                                                 CC[Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'4"]),
                                                                    Mop(Cast
                                                                          F4,
                                                                        LL[bVar"b'19",
                                                                           bVar"b'18",
                                                                           bVar"b'17",
                                                                           bVar"b'16"])],
                                                                 Var("Rd",
                                                                     F4)])),
                                                        qTy))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                          (Bop(And,Mop(Not,bVar"b'26"),
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,bVar"b'22",
                                               Bop(And,bVar"b'21",
                                                   Bop(And,
                                                       Mop(Not,bVar"b'14"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'12"),
                                                           Mop(Not,
                                                               bVar"b'5"))))))))),
                           Let(Var("Rd",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                      bVar"b'8"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(Call
                                                ("HaveThumb2",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               MB(ITE(Bop(In,Var("Rd",F4),
                                                          SL[LW(13,4),
                                                             LW(15,4)]),
                                                      Call
                                                        ("DECODE_UNPREDICTABLE",
                                                         ATy(qTy,
                                                             PTy(uTy,qTy)),
                                                         TP[Var("mc",
                                                                CTy"MachineCode"),
                                                            LS
                                                             "MoveToRegisterFromSpecial"]),
                                                      MU(LU,qTy)),
                                                  Close
                                                    (AVar uTy,
                                                     MU(Call
                                                          ("System",
                                                           CTy"instruction",
                                                           Call
                                                             ("MoveToRegisterFromSpecial",
                                                              CTy"System",
                                                              TP[EQ(Mop(Cast
                                                                          F1,
                                                                        LL[bVar"b'20"]),
                                                                    LW(1,1)),
                                                                 Var("Rd",
                                                                     F4)])),
                                                        qTy))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))),
                          (Bop(And,bVar"b'26",
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,bVar"b'22",
                                               Bop(And,bVar"b'21",
                                                   Bop(And,
                                                       Mop(Not,bVar"b'20"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Bop(And,
                                                               Mop(Not,
                                                                   bVar"b'13"),
                                                               Mop(Not,
                                                                   bVar"b'12")))))))))),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MB(Call
                                            ("HaveVirtExt",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v0",
                                             MU(TP[Var("v",F4),bVar"v0"],
                                                qTy))),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MB(Call
                                                ("InITBlock",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v",
                                                 MB(ITE(bVar"v",
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "HypervisorCall"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("System",
                                                             CTy"instruction",
                                                             Call
                                                               ("HypervisorCall",
                                                                CTy"System",
                                                                CC[Mop(Cast
                                                                         F4,
                                                                       LL[bVar"b'19",
                                                                          bVar"b'18",
                                                                          bVar"b'17",
                                                                          bVar"b'16"]),
                                                                   Mop(Cast
                                                                         (FTy 12),
                                                                       LL[bVar"b'11",
                                                                          bVar"b'10",
                                                                          bVar"b'9",
                                                                          bVar"b'8",
                                                                          bVar"b'7",
                                                                          bVar"b'6",
                                                                          bVar"b'5",
                                                                          bVar"b'4",
                                                                          bVar"b'3",
                                                                          bVar"b'2",
                                                                          bVar"b'1",
                                                                          bVar"b'0"])])),
                                                          qTy))))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU))))))),
                          (Bop(And,bVar"b'26",
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,bVar"b'22",
                                               Bop(And,bVar"b'21",
                                                   Bop(And,bVar"b'20",
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Bop(And,
                                                               Mop(Not,
                                                                   bVar"b'13"),
                                                               Mop(Not,
                                                                   bVar"b'12")))))))))),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MB(Call
                                            ("HaveSecurityExt",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v0",
                                             MB(ITE(bVar"v0",
                                                    MB(MR(Close
                                                            (qVar"s",
                                                             Dest
                                                               ("Architecture",
                                                                CTy"Architecture",
                                                                qVar"s"))),
                                                       Close
                                                         (Var("v",
                                                              CTy"Architecture"),
                                                          MB(MU(EQ(Var("v",
                                                                       CTy"Architecture"),
                                                                   LC("ARMv6K",
                                                                      CTy"Architecture")),
                                                                qTy),
                                                             Close
                                                               (bVar"v",
                                                                MU(Mop(Not,
                                                                       bVar"v"),
                                                                   qTy))))),
                                                    MU(LF,qTy)),
                                                Close
                                                  (bVar"v0",
                                                   MU(TP[Var("v",F4),
                                                         bVar"v0"],qTy))))),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MB(Call
                                                ("InITBlock",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v",
                                                 MB(MB(ITE(bVar"v",
                                                           MB(Call
                                                                ("LastInITBlock",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v",
                                                                 MU(Mop(Not,
                                                                        bVar"v"),
                                                                    qTy))),
                                                           MU(LF,qTy)),
                                                       Close
                                                         (bVar"b",
                                                          ITE(bVar"b",
                                                              Call
                                                                ("DECODE_UNPREDICTABLE",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 TP[Var("mc",
                                                                        CTy"MachineCode"),
                                                                    LS
                                                                     "SecureMonitorCall"]),
                                                              MU(LU,qTy)))),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("System",
                                                             CTy"instruction",
                                                             Call
                                                               ("SecureMonitorCall",
                                                                CTy"System",
                                                                Mop(Cast
                                                                      F4,
                                                                    LL[bVar"b'19",
                                                                       bVar"b'18",
                                                                       bVar"b'17",
                                                                       bVar"b'16"]))),
                                                          qTy))))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU))))))),
                          (Bop(And,bVar"b'26",
                               Bop(And,bVar"b'25",
                                   Bop(And,bVar"b'24",
                                       Bop(And,bVar"b'23",
                                           Bop(And,bVar"b'22",
                                               Bop(And,bVar"b'21",
                                                   Bop(And,bVar"b'20",
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'14"),
                                                           Bop(And,
                                                               bVar"b'13",
                                                               Mop(Not,
                                                                   bVar"b'12")))))))))),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MB(Call
                                            ("HaveThumb2",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v0",
                                             MU(TP[Var("v",F4),bVar"v0"],
                                                qTy))),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MU(Call
                                                ("Undefined",
                                                 CTy"instruction",
                                                 Mop(Cast F32,
                                                     CC[Mop(Cast F4,
                                                            LL[bVar"b'19",
                                                               bVar"b'18",
                                                               bVar"b'17",
                                                               bVar"b'16"]),
                                                        Mop(Cast(FTy 12),
                                                            LL[bVar"b'11",
                                                               bVar"b'10",
                                                               bVar"b'9",
                                                               bVar"b'8",
                                                               bVar"b'7",
                                                               bVar"b'6",
                                                               bVar"b'5",
                                                               bVar"b'4",
                                                               bVar"b'3",
                                                               bVar"b'2",
                                                               bVar"b'1",
                                                               bVar"b'0"])])),
                                              qTy),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU))))))),
                          (Bop(And,Mop(Not,bVar"b'14"),Mop(Not,bVar"b'12")),
                           MB(Call("HaveThumb2",ATy(qTy,PTy(bTy,qTy)),LU),
                              Close
                                (bVar"v",
                                 MB(MB(MU(TP[Mop(Cast F4,
                                                 LL[bVar"b'25",bVar"b'24",
                                                    bVar"b'23",bVar"b'22"]),
                                             bVar"v"],qTy),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MB(Call
                                                ("InITBlock",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v",
                                                 MB(ITE(bVar"v",
                                                        Call
                                                          ("DECODE_UNPREDICTABLE",
                                                           ATy(qTy,
                                                               PTy(uTy,qTy)),
                                                           TP[Var("mc",
                                                                  CTy"MachineCode"),
                                                              LS
                                                               "BranchTarget"]),
                                                        MU(LU,qTy)),
                                                    Close
                                                      (AVar uTy,
                                                       MU(Call
                                                            ("Branch",
                                                             CTy"instruction",
                                                             Call
                                                               ("BranchTarget",
                                                                CTy"Branch",
                                                                Mop(SE F32,
                                                                    CC[Mop(Cast
                                                                             F1,
                                                                           LL[bVar"b'26"]),
                                                                       Mop(Cast
                                                                             F1,
                                                                           LL[bVar"b'11"]),
                                                                       Mop(Cast
                                                                             F1,
                                                                           LL[bVar"b'13"]),
                                                                       Mop(Cast
                                                                             (FTy 6),
                                                                           LL[bVar"b'21",
                                                                              bVar"b'20",
                                                                              bVar"b'19",
                                                                              bVar"b'18",
                                                                              bVar"b'17",
                                                                              bVar"b'16"]),
                                                                       Mop(Cast
                                                                             (FTy 11),
                                                                           LL[bVar"b'10",
                                                                              bVar"b'9",
                                                                              bVar"b'8",
                                                                              bVar"b'7",
                                                                              bVar"b'6",
                                                                              bVar"b'5",
                                                                              bVar"b'4",
                                                                              bVar"b'3",
                                                                              bVar"b'2",
                                                                              bVar"b'1",
                                                                              bVar"b'0"]),
                                                                       LW(0,
                                                                          1)]))),
                                                          qTy))))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU))))))),
                          (bVar"b'12",
                           Let(Var("S",F1),Mop(Cast F1,LL[bVar"b'26"]),
                               Let(Var("J2",F1),
                                   Mop(Cast F1,LL[bVar"b'11"]),
                                   Let(Var("J1",F1),
                                       Mop(Cast F1,LL[bVar"b'13"]),
                                       Let(Var("L",F1),
                                           Mop(Cast F1,LL[bVar"b'14"]),
                                           MB(Call
                                                ("ThumbCondition",
                                                 ATy(qTy,PTy(F4,qTy)),LU),
                                              Close
                                                (Var("v",F4),
                                                 MB(MB(MB(Call
                                                            ("HaveThumb2",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v0",
                                                             MB(MU(Bop(Or,
                                                                       Bop(And,
                                                                           Bop(And,
                                                                               EQ(Var("L",
                                                                                      F1),
                                                                                  LW(1,
                                                                                     1)),
                                                                               EQ(Var("J1",
                                                                                      F1),
                                                                                  LW(1,
                                                                                     1))),
                                                                           EQ(Var("J1",
                                                                                  F1),
                                                                              Var("J2",
                                                                                  F1))),
                                                                       bVar"v0"),
                                                                   qTy),
                                                                Close
                                                                  (bVar"v0",
                                                                   MU(TP[Var("v",
                                                                             F4),
                                                                         bVar"v0"],
                                                                      qTy))))),
                                                       Close
                                                         (Var("v",
                                                              PTy(F4,bTy)),
                                                          Call
                                                            ("Take",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             Var("v",
                                                                 PTy(F4,
                                                                     bTy))))),
                                                    Close
                                                      (bVar"b",
                                                       ITE(bVar"b",
                                                           MB(Call
                                                                ("InITBlock",
                                                                 ATy(qTy,
                                                                     PTy(bTy,
                                                                         qTy)),
                                                                 LU),
                                                              Close
                                                                (bVar"v",
                                                                 MB(MB(ITE(bVar"v",
                                                                           MB(Call
                                                                                ("LastInITBlock",
                                                                                 ATy(qTy,
                                                                                     PTy(bTy,
                                                                                         qTy)),
                                                                                 LU),
                                                                              Close
                                                                                (bVar"v",
                                                                                 MU(Mop(Not,
                                                                                        bVar"v"),
                                                                                    qTy))),
                                                                           MU(LF,
                                                                              qTy)),
                                                                       Close
                                                                         (bVar"b",
                                                                          ITE(bVar"b",
                                                                              Call
                                                                                ("DECODE_UNPREDICTABLE",
                                                                                 ATy(qTy,
                                                                                     PTy(uTy,
                                                                                         qTy)),
                                                                                 TP[Var("mc",
                                                                                        CTy"MachineCode"),
                                                                                    LS
                                                                                     "BranchTarget or BranchLinkExchangeImmediate"]),
                                                                              MU(LU,
                                                                                 qTy)))),
                                                                    Close
                                                                      (AVar
                                                                         uTy,
                                                                       MU(Let(Var("imm32",
                                                                                  F32),
                                                                              Mop(SE F32,
                                                                                  CC[Var("S",
                                                                                         F1),
                                                                                     Mop(BNot,
                                                                                         Bop(BXor,
                                                                                             Var("J1",
                                                                                                 F1),
                                                                                             Var("S",
                                                                                                 F1))),
                                                                                     Mop(BNot,
                                                                                         Bop(BXor,
                                                                                             Var("J2",
                                                                                                 F1),
                                                                                             Var("S",
                                                                                                 F1))),
                                                                                     Mop(Cast
                                                                                           (FTy 10),
                                                                                         LL[bVar"b'25",
                                                                                            bVar"b'24",
                                                                                            bVar"b'23",
                                                                                            bVar"b'22",
                                                                                            bVar"b'21",
                                                                                            bVar"b'20",
                                                                                            bVar"b'19",
                                                                                            bVar"b'18",
                                                                                            bVar"b'17",
                                                                                            bVar"b'16"]),
                                                                                     Mop(Cast
                                                                                           (FTy 11),
                                                                                         LL[bVar"b'10",
                                                                                            bVar"b'9",
                                                                                            bVar"b'8",
                                                                                            bVar"b'7",
                                                                                            bVar"b'6",
                                                                                            bVar"b'5",
                                                                                            bVar"b'4",
                                                                                            bVar"b'3",
                                                                                            bVar"b'2",
                                                                                            bVar"b'1",
                                                                                            bVar"b'0"]),
                                                                                     LW(0,
                                                                                        1)]),
                                                                              ITE(EQ(Var("L",
                                                                                         F1),
                                                                                     LW(1,
                                                                                        1)),
                                                                                  Call
                                                                                    ("Branch",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("BranchLinkExchangeImmediate",
                                                                                        CTy"Branch",
                                                                                        TP[LC("InstrSet_Thumb",
                                                                                              CTy"InstrSet"),
                                                                                           Var("imm32",
                                                                                               F32)])),
                                                                                  Call
                                                                                    ("Branch",
                                                                                     CTy"instruction",
                                                                                     Call
                                                                                       ("BranchTarget",
                                                                                        CTy"Branch",
                                                                                        Var("imm32",
                                                                                            F32))))),
                                                                          qTy))))),
                                                           Call
                                                             ("Skip",
                                                              ATy(qTy,
                                                                  PTy(CTy"instruction",
                                                                      qTy)),
                                                              LU))))))))))),
                          (Bop(And,bVar"b'14",Mop(Not,bVar"b'12")),
                           Let(Var("S",F1),Mop(Cast F1,LL[bVar"b'26"]),
                               Let(Var("J2",F1),
                                   Mop(Cast F1,LL[bVar"b'11"]),
                                   Let(Var("J1",F1),
                                       Mop(Cast F1,LL[bVar"b'13"]),
                                       MB(Call
                                            ("ThumbCondition",
                                             ATy(qTy,PTy(F4,qTy)),LU),
                                          Close
                                            (Var("v",F4),
                                             MB(MB(MB(Call
                                                        ("CurrentInstrSet",
                                                         ATy(qTy,
                                                             PTy(CTy"InstrSet",
                                                                 qTy)),LU),
                                                      Close
                                                        (Var("v0",
                                                             CTy"InstrSet"),
                                                         MB(MB(MB(MB(MU(EQ(Var("v0",
                                                                               CTy"InstrSet"),
                                                                           LC("InstrSet_ThumbEE",
                                                                              CTy"InstrSet")),
                                                                        qTy),
                                                                     Close
                                                                       (bVar"b",
                                                                        MU(Bop(Or,
                                                                               bVar"b",
                                                                               EQ(Mop(Cast
                                                                                        F1,
                                                                                      LL[bVar"b'0"]),
                                                                                  LW(1,
                                                                                     1))),
                                                                           qTy))),
                                                                  Close
                                                                    (bVar"v",
                                                                     MU(Mop(Not,
                                                                            bVar"v"),
                                                                        qTy))),
                                                               Close
                                                                 (bVar"b",
                                                                  ITE(bVar"b",
                                                                      ITE(Bop(And,
                                                                              EQ(Var("J1",
                                                                                     F1),
                                                                                 LW(1,
                                                                                    1)),
                                                                              EQ(Var("J1",
                                                                                     F1),
                                                                                 Var("J2",
                                                                                     F1))),
                                                                          MB(Call
                                                                               ("ArchVersion",
                                                                                ATy(qTy,
                                                                                    PTy(nTy,
                                                                                        qTy)),
                                                                                LU),
                                                                             Close
                                                                               (nVar"v",
                                                                                MU(Bop(Ge,
                                                                                       nVar"v",
                                                                                       LN
                                                                                        5),
                                                                                   qTy))),
                                                                          Call
                                                                            ("HaveThumb2",
                                                                             ATy(qTy,
                                                                                 PTy(bTy,
                                                                                     qTy)),
                                                                             LU)),
                                                                      MU(LF,
                                                                         qTy)))),
                                                            Close
                                                              (bVar"v0",
                                                               MU(TP[Var("v",
                                                                         F4),
                                                                     bVar"v0"],
                                                                  qTy))))),
                                                   Close
                                                     (Var("v",PTy(F4,bTy)),
                                                      Call
                                                        ("Take",
                                                         ATy(qTy,
                                                             PTy(bTy,qTy)),
                                                         Var("v",
                                                             PTy(F4,bTy))))),
                                                Close
                                                  (bVar"b",
                                                   ITE(bVar"b",
                                                       MB(Call
                                                            ("InITBlock",
                                                             ATy(qTy,
                                                                 PTy(bTy,
                                                                     qTy)),
                                                             LU),
                                                          Close
                                                            (bVar"v",
                                                             MB(MB(ITE(bVar"v",
                                                                       MB(Call
                                                                            ("LastInITBlock",
                                                                             ATy(qTy,
                                                                                 PTy(bTy,
                                                                                     qTy)),
                                                                             LU),
                                                                          Close
                                                                            (bVar"v",
                                                                             MU(Mop(Not,
                                                                                    bVar"v"),
                                                                                qTy))),
                                                                       MU(LF,
                                                                          qTy)),
                                                                   Close
                                                                     (bVar"b",
                                                                      ITE(bVar"b",
                                                                          Call
                                                                            ("DECODE_UNPREDICTABLE",
                                                                             ATy(qTy,
                                                                                 PTy(uTy,
                                                                                     qTy)),
                                                                             TP[Var("mc",
                                                                                    CTy"MachineCode"),
                                                                                LS
                                                                                 "BranchLinkExchangeImmediate"]),
                                                                          MU(LU,
                                                                             qTy)))),
                                                                Close
                                                                  (AVar
                                                                     uTy,
                                                                   MU(Call
                                                                        ("Branch",
                                                                         CTy"instruction",
                                                                         Call
                                                                           ("BranchLinkExchangeImmediate",
                                                                            CTy"Branch",
                                                                            TP[LC("InstrSet_ARM",
                                                                                  CTy"InstrSet"),
                                                                               Mop(SE F32,
                                                                                   CC[Var("S",
                                                                                          F1),
                                                                                      Mop(BNot,
                                                                                          Bop(BXor,
                                                                                              Var("J1",
                                                                                                  F1),
                                                                                              Var("S",
                                                                                                  F1))),
                                                                                      Mop(BNot,
                                                                                          Bop(BXor,
                                                                                              Var("J2",
                                                                                                  F1),
                                                                                              Var("S",
                                                                                                  F1))),
                                                                                      Mop(Cast
                                                                                            (FTy 10),
                                                                                          LL[bVar"b'25",
                                                                                             bVar"b'24",
                                                                                             bVar"b'23",
                                                                                             bVar"b'22",
                                                                                             bVar"b'21",
                                                                                             bVar"b'20",
                                                                                             bVar"b'19",
                                                                                             bVar"b'18",
                                                                                             bVar"b'17",
                                                                                             bVar"b'16"]),
                                                                                      Mop(Cast
                                                                                            (FTy 10),
                                                                                          LL[bVar"b'10",
                                                                                             bVar"b'9",
                                                                                             bVar"b'8",
                                                                                             bVar"b'7",
                                                                                             bVar"b'6",
                                                                                             bVar"b'5",
                                                                                             bVar"b'4",
                                                                                             bVar"b'3",
                                                                                             bVar"b'2",
                                                                                             bVar"b'1"]),
                                                                                      LW(0,
                                                                                         2)])])),
                                                                      qTy))))),
                                                       Call
                                                         ("Skip",
                                                          ATy(qTy,
                                                              PTy(CTy"instruction",
                                                                  qTy)),LU))))))))))],
                         Call
                           ("UndefinedThumb",
                            ATy(qTy,PTy(CTy"instruction",qTy)),LU)),
                     Call
                       ("UndefinedThumb",
                        ATy(qTy,PTy(CTy"instruction",qTy)),LU))),
                (Bop(And,bVar"b'31",
                     Bop(And,bVar"b'30",Bop(And,bVar"b'29",bVar"b'28"))),
                 ITB([(Mop(Not,bVar"b'25"),
                       Let(Var("Rn",F4),
                           Mop(Cast F4,
                               LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                  bVar"b'16"]),
                           Let(Var("S",F1),Mop(Cast F1,LL[bVar"b'20"]),
                               Let(Var("Rd",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                          bVar"b'8"]),
                                   MB(Call
                                        ("ThumbCondition",
                                         ATy(qTy,PTy(F4,qTy)),LU),
                                      Close
                                        (Var("v",F4),
                                         MB(MB(MB(Call
                                                    ("HaveThumb2",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v0",
                                                     MU(TP[Var("v",F4),
                                                           bVar"v0"],qTy))),
                                               Close
                                                 (Var("v",PTy(F4,bTy)),
                                                  Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     Var("v",PTy(F4,bTy))))),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   Let(Var("imm12",FTy 12),
                                                       CC[Mop(Cast F1,
                                                              LL[bVar"b'26"]),
                                                          Mop(Cast(FTy 3),
                                                              LL[bVar"b'14",
                                                                 bVar"b'13",
                                                                 bVar"b'12"]),
                                                          Mop(Cast F8,
                                                              LL[bVar"b'7",
                                                                 bVar"b'6",
                                                                 bVar"b'5",
                                                                 bVar"b'4",
                                                                 bVar"b'3",
                                                                 bVar"b'2",
                                                                 bVar"b'1",
                                                                 bVar"b'0"])],
                                                       MB(MR(Close
                                                               (qVar"s",
                                                                Dest
                                                                  ("CPSR",
                                                                   CTy"PSR",
                                                                   qVar"s"))),
                                                          Close
                                                            (Var("v",
                                                                 CTy"PSR"),
                                                             MB(MB(MB(MU(Dest
                                                                           ("C",
                                                                            bTy,
                                                                            Var("v",
                                                                                CTy"PSR")),
                                                                         qTy),
                                                                      Close
                                                                        (bVar"v",
                                                                         MU(TP[Var("imm12",
                                                                                   FTy 12),
                                                                               bVar"v"],
                                                                            qTy))),
                                                                   Close
                                                                     (Var("v",
                                                                          PTy(FTy 12,
                                                                              bTy)),
                                                                      Call
                                                                        ("ThumbExpandImm_C",
                                                                         ATy(qTy,
                                                                             PTy(PTy(F32,
                                                                                     bTy),
                                                                                 qTy)),
                                                                         Var("v",
                                                                             PTy(FTy 12,
                                                                                 bTy))))),
                                                                Close
                                                                  (Var("x",
                                                                       PTy(F32,
                                                                           bTy)),
                                                                   Let(bVar"setflags",
                                                                       EQ(Var("S",
                                                                              F1),
                                                                          LW(1,
                                                                             1)),
                                                                       CS(TP[Mop(Cast
                                                                                   F4,
                                                                                 LL[bVar"b'24",
                                                                                    bVar"b'23",
                                                                                    bVar"b'22",
                                                                                    bVar"b'21"]),
                                                                             Var("Rn",
                                                                                 F4),
                                                                             Var("Rd",
                                                                                 F4),
                                                                             Var("S",
                                                                                 F1)],
                                                                          [(TP[LW(0,
                                                                                  4),
                                                                               AVar
                                                                                 F4,
                                                                               LW(15,
                                                                                  4),
                                                                               LW(1,
                                                                                  1)],
                                                                            MB(ITE(Bop(In,
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       SL[LW(13,
                                                                                             4),
                                                                                          LW(15,
                                                                                             4)]),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "TST (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("TestCompareImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(0,
                                                                                                 2),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(0,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(Or,
                                                                                           EQ(Var("Rd",
                                                                                                  F4),
                                                                                              LW(13,
                                                                                                 4)),
                                                                                           Bop(And,
                                                                                               EQ(Var("Rd",
                                                                                                      F4),
                                                                                                  LW(15,
                                                                                                     4)),
                                                                                               Mop(Not,
                                                                                                   bVar"setflags"))),
                                                                                       Bop(In,
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)])),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "AND (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(0,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(1,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(In,
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)]),
                                                                                       Bop(In,
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)])),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "BIC (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(14,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(2,
                                                                                  4),
                                                                               LW(15,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      F1))],
                                                                            MB(ITE(Bop(In,
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       SL[LW(13,
                                                                                             4),
                                                                                          LW(15,
                                                                                             4)]),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "MOV (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Move",
                                                                                           CTy"Data",
                                                                                           TP[bVar"setflags",
                                                                                              LF,
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(2,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(In,
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)]),
                                                                                       EQ(Var("Rn",
                                                                                              F4),
                                                                                          LW(13,
                                                                                             4))),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "ORR (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(12,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(3,
                                                                                  4),
                                                                               LW(15,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      F1))],
                                                                            MB(ITE(Bop(In,
                                                                                       Var("Rd",
                                                                                           F4),
                                                                                       SL[LW(13,
                                                                                             4),
                                                                                          LW(15,
                                                                                             4)]),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "MVN (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("Move",
                                                                                           CTy"Data",
                                                                                           TP[bVar"setflags",
                                                                                              LT,
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(3,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(In,
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)]),
                                                                                       EQ(Var("Rn",
                                                                                              F4),
                                                                                          LW(13,
                                                                                             4))),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "ORN (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(15,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(4,
                                                                                  4),
                                                                               AVar
                                                                                 F4,
                                                                               LW(15,
                                                                                  4),
                                                                               LW(1,
                                                                                  1)],
                                                                            MB(ITE(Bop(In,
                                                                                       Var("Rn",
                                                                                           F4),
                                                                                       SL[LW(13,
                                                                                             4),
                                                                                          LW(15,
                                                                                             4)]),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "TEQ (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("TestCompareImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(1,
                                                                                                 2),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(4,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(Or,
                                                                                           EQ(Var("Rd",
                                                                                                  F4),
                                                                                              LW(13,
                                                                                                 4)),
                                                                                           Bop(And,
                                                                                               EQ(Var("Rd",
                                                                                                      F4),
                                                                                                  LW(15,
                                                                                                     4)),
                                                                                               Mop(Not,
                                                                                                   bVar"setflags"))),
                                                                                       Bop(In,
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)])),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "EOR (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(1,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(8,
                                                                                  4),
                                                                               AVar
                                                                                 F4,
                                                                               LW(15,
                                                                                  4),
                                                                               LW(1,
                                                                                  1)],
                                                                            MB(ITE(EQ(Var("Rn",
                                                                                          F4),
                                                                                      LW(15,
                                                                                         4)),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "CMN (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("TestCompareImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(3,
                                                                                                 2),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(8,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(Or,
                                                                                           EQ(Var("Rd",
                                                                                                  F4),
                                                                                              LW(13,
                                                                                                 4)),
                                                                                           Bop(And,
                                                                                               EQ(Var("Rd",
                                                                                                      F4),
                                                                                                  LW(15,
                                                                                                     4)),
                                                                                               Mop(Not,
                                                                                                   bVar"setflags"))),
                                                                                       EQ(Var("Rn",
                                                                                              F4),
                                                                                          LW(15,
                                                                                             4))),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "ADD (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(4,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(10,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(In,
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)]),
                                                                                       Bop(In,
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)])),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "ADC (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(5,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(11,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(In,
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)]),
                                                                                       Bop(In,
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)])),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "SBC (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(6,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(13,
                                                                                  4),
                                                                               AVar
                                                                                 F4,
                                                                               LW(15,
                                                                                  4),
                                                                               LW(1,
                                                                                  1)],
                                                                            MB(ITE(EQ(Var("Rn",
                                                                                          F4),
                                                                                      LW(15,
                                                                                         4)),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "CMP (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("TestCompareImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(2,
                                                                                                 2),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(13,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(Or,
                                                                                           EQ(Var("Rd",
                                                                                                  F4),
                                                                                              LW(13,
                                                                                                 4)),
                                                                                           Bop(And,
                                                                                               EQ(Var("Rd",
                                                                                                      F4),
                                                                                                  LW(15,
                                                                                                     4)),
                                                                                               Mop(Not,
                                                                                                   bVar"setflags"))),
                                                                                       EQ(Var("Rn",
                                                                                              F4),
                                                                                          LW(15,
                                                                                             4))),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "SUB (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(2,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (TP[LW(14,
                                                                                  4),
                                                                               AVar
                                                                                 (PTy(F4,
                                                                                      PTy(F4,
                                                                                          F1)))],
                                                                            MB(ITE(Bop(Or,
                                                                                       Bop(In,
                                                                                           Var("Rd",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)]),
                                                                                       Bop(In,
                                                                                           Var("Rn",
                                                                                               F4),
                                                                                           SL[LW(13,
                                                                                                 4),
                                                                                              LW(15,
                                                                                                 4)])),
                                                                                   Call
                                                                                     ("DECODE_UNPREDICTABLE",
                                                                                      ATy(qTy,
                                                                                          PTy(uTy,
                                                                                              qTy)),
                                                                                      TP[Var("mc",
                                                                                             CTy"MachineCode"),
                                                                                         LS
                                                                                          "RSB (immediate)"]),
                                                                                   MU(LU,
                                                                                      qTy)),
                                                                               Close
                                                                                 (AVar
                                                                                    uTy,
                                                                                  MU(Call
                                                                                       ("Data",
                                                                                        CTy"instruction",
                                                                                        Call
                                                                                          ("ArithLogicImmediate",
                                                                                           CTy"Data",
                                                                                           TP[LW(3,
                                                                                                 4),
                                                                                              bVar"setflags",
                                                                                              Var("Rd",
                                                                                                  F4),
                                                                                              Var("Rn",
                                                                                                  F4),
                                                                                              Var("imm12",
                                                                                                  FTy 12)])),
                                                                                     qTy)))),
                                                                           (AVar
                                                                              (PTy(F4,
                                                                                   PTy(F4,
                                                                                       PTy(F4,
                                                                                           F1)))),
                                                                            MU(Call
                                                                                 ("Undefined",
                                                                                  CTy"instruction",
                                                                                  LW(0,
                                                                                     32)),
                                                                               qTy))]))))))),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU)))))))))),
                      (Bop(And,bVar"b'25",
                           Bop(And,Mop(Not,bVar"b'24"),
                               Bop(And,Mop(Not,bVar"b'23"),
                                   Bop(And,Mop(Not,bVar"b'22"),
                                       Bop(And,Mop(Not,bVar"b'21"),
                                           Mop(Not,bVar"b'20")))))),
                       Let(Var("Rd",F4),
                           Mop(Cast F4,
                               LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                  bVar"b'8"]),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MB(Call
                                            ("HaveThumb2",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v0",
                                             MU(TP[Var("v",F4),bVar"v0"],
                                                qTy))),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MB(ITE(Bop(In,Var("Rd",F4),
                                                      SL[LW(13,4),LW(15,4)]),
                                                  Call
                                                    ("DECODE_UNPREDICTABLE",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Var("mc",
                                                            CTy"MachineCode"),
                                                        LS
                                                         "ADDW (immediate)"]),
                                                  MU(LU,qTy)),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("Data",
                                                       CTy"instruction",
                                                       Call
                                                         ("AddSub",
                                                          CTy"Data",
                                                          TP[LF,
                                                             Var("Rd",F4),
                                                             Mop(Cast F4,
                                                                 LL[bVar"b'19",
                                                                    bVar"b'18",
                                                                    bVar"b'17",
                                                                    bVar"b'16"]),
                                                             CC[Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'26"]),
                                                                Mop(Cast
                                                                      (FTy 3),
                                                                    LL[bVar"b'14",
                                                                       bVar"b'13",
                                                                       bVar"b'12"]),
                                                                Mop(Cast
                                                                      F8,
                                                                    LL[bVar"b'7",
                                                                       bVar"b'6",
                                                                       bVar"b'5",
                                                                       bVar"b'4",
                                                                       bVar"b'3",
                                                                       bVar"b'2",
                                                                       bVar"b'1",
                                                                       bVar"b'0"])]])),
                                                    qTy))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU)))))))),
                      (Bop(And,bVar"b'25",
                           Bop(And,Mop(Not,bVar"b'24"),
                               Bop(And,bVar"b'23",
                                   Bop(And,Mop(Not,bVar"b'22"),
                                       Bop(And,bVar"b'21",
                                           Mop(Not,bVar"b'20")))))),
                       Let(Var("Rd",F4),
                           Mop(Cast F4,
                               LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                  bVar"b'8"]),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MB(Call
                                            ("HaveThumb2",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v0",
                                             MU(TP[Var("v",F4),bVar"v0"],
                                                qTy))),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MB(ITE(Bop(In,Var("Rd",F4),
                                                      SL[LW(13,4),LW(15,4)]),
                                                  Call
                                                    ("DECODE_UNPREDICTABLE",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Var("mc",
                                                            CTy"MachineCode"),
                                                        LS
                                                         "SUBW (immediate)"]),
                                                  MU(LU,qTy)),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("Data",
                                                       CTy"instruction",
                                                       Call
                                                         ("AddSub",
                                                          CTy"Data",
                                                          TP[LT,
                                                             Var("Rd",F4),
                                                             Mop(Cast F4,
                                                                 LL[bVar"b'19",
                                                                    bVar"b'18",
                                                                    bVar"b'17",
                                                                    bVar"b'16"]),
                                                             CC[Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'26"]),
                                                                Mop(Cast
                                                                      (FTy 3),
                                                                    LL[bVar"b'14",
                                                                       bVar"b'13",
                                                                       bVar"b'12"]),
                                                                Mop(Cast
                                                                      F8,
                                                                    LL[bVar"b'7",
                                                                       bVar"b'6",
                                                                       bVar"b'5",
                                                                       bVar"b'4",
                                                                       bVar"b'3",
                                                                       bVar"b'2",
                                                                       bVar"b'1",
                                                                       bVar"b'0"])]])),
                                                    qTy))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU)))))))),
                      (Bop(And,bVar"b'25",
                           Bop(And,Mop(Not,bVar"b'24"),
                               Bop(And,bVar"b'22",
                                   Bop(And,Mop(Not,bVar"b'21"),
                                       Mop(Not,bVar"b'20"))))),
                       Let(Var("Rd",F4),
                           Mop(Cast F4,
                               LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                  bVar"b'8"]),
                           MB(Call
                                ("ThumbCondition",ATy(qTy,PTy(F4,qTy)),LU),
                              Close
                                (Var("v",F4),
                                 MB(MB(MB(Call
                                            ("HaveThumb2",
                                             ATy(qTy,PTy(bTy,qTy)),LU),
                                          Close
                                            (bVar"v0",
                                             MU(TP[Var("v",F4),bVar"v0"],
                                                qTy))),
                                       Close
                                         (Var("v",PTy(F4,bTy)),
                                          Call
                                            ("Take",ATy(qTy,PTy(bTy,qTy)),
                                             Var("v",PTy(F4,bTy))))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           MB(ITE(Bop(In,Var("Rd",F4),
                                                      SL[LW(13,4),LW(15,4)]),
                                                  Call
                                                    ("DECODE_UNPREDICTABLE",
                                                     ATy(qTy,PTy(uTy,qTy)),
                                                     TP[Var("mc",
                                                            CTy"MachineCode"),
                                                        LS
                                                         "MOVT or MOVW (immediate)"]),
                                                  MU(LU,qTy)),
                                              Close
                                                (AVar uTy,
                                                 MU(Call
                                                      ("Data",
                                                       CTy"instruction",
                                                       Call
                                                         ("MoveHalfword",
                                                          CTy"Data",
                                                          TP[EQ(Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'23"]),
                                                                LW(1,1)),
                                                             Var("Rd",F4),
                                                             CC[Mop(Cast
                                                                      F4,
                                                                    LL[bVar"b'19",
                                                                       bVar"b'18",
                                                                       bVar"b'17",
                                                                       bVar"b'16"]),
                                                                Mop(Cast
                                                                      F1,
                                                                    LL[bVar"b'26"]),
                                                                Mop(Cast
                                                                      (FTy 3),
                                                                    LL[bVar"b'14",
                                                                       bVar"b'13",
                                                                       bVar"b'12"]),
                                                                Mop(Cast
                                                                      F8,
                                                                    LL[bVar"b'7",
                                                                       bVar"b'6",
                                                                       bVar"b'5",
                                                                       bVar"b'4",
                                                                       bVar"b'3",
                                                                       bVar"b'2",
                                                                       bVar"b'1",
                                                                       bVar"b'0"])]])),
                                                    qTy))),
                                           Call
                                             ("Skip",
                                              ATy(qTy,
                                                  PTy(CTy"instruction",qTy)),
                                              LU)))))))),
                      (Bop(And,bVar"b'25",
                           Bop(And,bVar"b'24",
                               Bop(And,Mop(Not,bVar"b'22"),
                                   Bop(And,bVar"b'21",
                                       Bop(And,Mop(Not,bVar"b'20"),
                                           Bop(And,Mop(Not,bVar"b'14"),
                                               Bop(And,
                                                   Mop(Not,bVar"b'13"),
                                                   Bop(And,
                                                       Mop(Not,bVar"b'12"),
                                                       Bop(And,
                                                           Mop(Not,
                                                               bVar"b'7"),
                                                           Mop(Not,
                                                               bVar"b'6")))))))))),
                       Let(Var("Rn",F4),
                           Mop(Cast F4,
                               LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                  bVar"b'16"]),
                           Let(Var("sat_imm",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'3",bVar"b'2",bVar"b'1",
                                      bVar"b'0"]),
                               Let(Var("Rd",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                          bVar"b'8"]),
                                   MB(Call
                                        ("ThumbCondition",
                                         ATy(qTy,PTy(F4,qTy)),LU),
                                      Close
                                        (Var("v",F4),
                                         MB(MB(MB(Call
                                                    ("HaveThumb2",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v0",
                                                     MU(TP[Var("v",F4),
                                                           bVar"v0"],qTy))),
                                               Close
                                                 (Var("v",PTy(F4,bTy)),
                                                  Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     Var("v",PTy(F4,bTy))))),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MB(ITE(Bop(Or,
                                                              Bop(In,
                                                                  Var("Rd",
                                                                      F4),
                                                                  SL[LW(13,
                                                                        4),
                                                                     LW(15,
                                                                        4)]),
                                                              Bop(In,
                                                                  Var("Rn",
                                                                      F4),
                                                                  SL[LW(13,
                                                                        4),
                                                                     LW(15,
                                                                        4)])),
                                                          Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS
                                                                 "Saturate16"]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Let(bVar"unsigned",
                                                                EQ(Mop(Cast
                                                                         F1,
                                                                       LL[bVar"b'23"]),
                                                                   LW(1,1)),
                                                                Call
                                                                  ("Media",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("Saturate16",
                                                                      CTy"Media",
                                                                      TP[ITE(bVar"unsigned",
                                                                             Mop(Cast
                                                                                   nTy,
                                                                                 Var("sat_imm",
                                                                                     F4)),
                                                                             Bop(Add,
                                                                                 Mop(Cast
                                                                                       nTy,
                                                                                     Var("sat_imm",
                                                                                         F4)),
                                                                                 LN
                                                                                  1)),
                                                                         bVar"unsigned",
                                                                         Var("Rd",
                                                                             F4),
                                                                         Var("Rn",
                                                                             F4)]))),
                                                            qTy))),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU)))))))))),
                      (Bop(And,bVar"b'25",
                           Bop(And,bVar"b'24",
                               Bop(And,Mop(Not,bVar"b'22"),
                                   Mop(Not,bVar"b'20")))),
                       Let(Var("Rn",F4),
                           Mop(Cast F4,
                               LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                  bVar"b'16"]),
                           Let(Var("sat_imm",FTy 5),
                               Mop(Cast(FTy 5),
                                   LL[bVar"b'4",bVar"b'3",bVar"b'2",
                                      bVar"b'1",bVar"b'0"]),
                               Let(Var("Rd",F4),
                                   Mop(Cast F4,
                                       LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                          bVar"b'8"]),
                                   MB(Call
                                        ("ThumbCondition",
                                         ATy(qTy,PTy(F4,qTy)),LU),
                                      Close
                                        (Var("v",F4),
                                         MB(MB(MB(Call
                                                    ("HaveThumb2",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     LU),
                                                  Close
                                                    (bVar"v0",
                                                     MU(TP[Var("v",F4),
                                                           bVar"v0"],qTy))),
                                               Close
                                                 (Var("v",PTy(F4,bTy)),
                                                  Call
                                                    ("Take",
                                                     ATy(qTy,PTy(bTy,qTy)),
                                                     Var("v",PTy(F4,bTy))))),
                                            Close
                                              (bVar"b",
                                               ITE(bVar"b",
                                                   MB(ITE(Bop(Or,
                                                              Bop(In,
                                                                  Var("Rd",
                                                                      F4),
                                                                  SL[LW(13,
                                                                        4),
                                                                     LW(15,
                                                                        4)]),
                                                              Bop(In,
                                                                  Var("Rn",
                                                                      F4),
                                                                  SL[LW(13,
                                                                        4),
                                                                     LW(15,
                                                                        4)])),
                                                          Call
                                                            ("DECODE_UNPREDICTABLE",
                                                             ATy(qTy,
                                                                 PTy(uTy,
                                                                     qTy)),
                                                             TP[Var("mc",
                                                                    CTy"MachineCode"),
                                                                LS
                                                                 "Saturate"]),
                                                          MU(LU,qTy)),
                                                      Close
                                                        (AVar uTy,
                                                         MU(Let(bVar"unsigned",
                                                                EQ(Mop(Cast
                                                                         F1,
                                                                       LL[bVar"b'23"]),
                                                                   LW(1,1)),
                                                                Let(TP[Var("shift_t",
                                                                           CTy"SRType"),
                                                                       nVar"shift_n"],
                                                                    Call
                                                                      ("DecodeImmShift",
                                                                       PTy(CTy"SRType",
                                                                           nTy),
                                                                       TP[CC[Mop(Cast
                                                                                   F1,
                                                                                 LL[bVar"b'21"]),
                                                                             LW(0,
                                                                                1)],
                                                                          CC[Mop(Cast
                                                                                   (FTy 3),
                                                                                 LL[bVar"b'14",
                                                                                    bVar"b'13",
                                                                                    bVar"b'12"]),
                                                                             Mop(Cast
                                                                                   (FTy 2),
                                                                                 LL[bVar"b'7",
                                                                                    bVar"b'6"])]]),
                                                                    Call
                                                                      ("Media",
                                                                       CTy"instruction",
                                                                       Call
                                                                         ("Saturate",
                                                                          CTy"Media",
                                                                          TP[Var("shift_t",
                                                                                 CTy"SRType"),
                                                                             nVar"shift_n",
                                                                             ITE(bVar"unsigned",
                                                                                 Mop(Cast
                                                                                       nTy,
                                                                                     Var("sat_imm",
                                                                                         FTy 5)),
                                                                                 Bop(Add,
                                                                                     Mop(Cast
                                                                                           nTy,
                                                                                         Var("sat_imm",
                                                                                             FTy 5)),
                                                                                     LN
                                                                                      1)),
                                                                             bVar"unsigned",
                                                                             Var("Rd",
                                                                                 F4),
                                                                             Var("Rn",
                                                                                 F4)])))),
                                                            qTy))),
                                                   Call
                                                     ("Skip",
                                                      ATy(qTy,
                                                          PTy(CTy"instruction",
                                                              qTy)),LU)))))))))),
                      (Bop(And,bVar"b'25",
                           Bop(And,bVar"b'24",
                               Bop(And,bVar"b'22",
                                   Bop(And,Mop(Not,bVar"b'21"),
                                       Mop(Not,bVar"b'20"))))),
                       Let(Var("Rn",F4),
                           Mop(Cast F4,
                               LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                  bVar"b'16"]),
                           Let(Var("Rd",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                      bVar"b'8"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(Call
                                                ("HaveThumb2",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               Let(nVar"widthminus1",
                                                   Mop(Cast nTy,
                                                       Mop(Cast(FTy 5),
                                                           LL[bVar"b'4",
                                                              bVar"b'3",
                                                              bVar"b'2",
                                                              bVar"b'1",
                                                              bVar"b'0"])),
                                                   Let(nVar"lsbit",
                                                       Mop(Cast nTy,
                                                           CC[Mop(Cast
                                                                    (FTy 3),
                                                                  LL[bVar"b'14",
                                                                     bVar"b'13",
                                                                     bVar"b'12"]),
                                                              Mop(Cast
                                                                    (FTy 2),
                                                                  LL[bVar"b'7",
                                                                     bVar"b'6"])]),
                                                       MB(ITE(Bop(Or,
                                                                  Bop(Or,
                                                                      Bop(In,
                                                                          Var("Rd",
                                                                              F4),
                                                                          SL[LW(13,
                                                                                4),
                                                                             LW(15,
                                                                                4)]),
                                                                      Bop(In,
                                                                          Var("Rn",
                                                                              F4),
                                                                          SL[LW(13,
                                                                                4),
                                                                             LW(15,
                                                                                4)])),
                                                                  Bop(Lt,
                                                                      LN
                                                                       31,
                                                                      Bop(Add,
                                                                          nVar"lsbit",
                                                                          nVar"widthminus1"))),
                                                              Call
                                                                ("DECODE_UNPREDICTABLE",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 TP[Var("mc",
                                                                        CTy"MachineCode"),
                                                                    LS
                                                                     "BitFieldExtract"]),
                                                              MU(LU,qTy)),
                                                          Close
                                                            (AVar uTy,
                                                             MU(Call
                                                                  ("Media",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("BitFieldExtract",
                                                                      CTy"Media",
                                                                      TP[EQ(Mop(Cast
                                                                                  F1,
                                                                                LL[bVar"b'23"]),
                                                                            LW(1,
                                                                               1)),
                                                                         Var("Rd",
                                                                             F4),
                                                                         Var("Rn",
                                                                             F4),
                                                                         nVar"lsbit",
                                                                         nVar"widthminus1"])),
                                                                qTy))))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU))))))))),
                      (Bop(And,bVar"b'25",
                           Bop(And,bVar"b'24",
                               Bop(And,Mop(Not,bVar"b'23"),
                                   Bop(And,bVar"b'22",
                                       Bop(And,bVar"b'21",
                                           Mop(Not,bVar"b'20")))))),
                       Let(Var("Rn",F4),
                           Mop(Cast F4,
                               LL[bVar"b'19",bVar"b'18",bVar"b'17",
                                  bVar"b'16"]),
                           Let(Var("Rd",F4),
                               Mop(Cast F4,
                                   LL[bVar"b'11",bVar"b'10",bVar"b'9",
                                      bVar"b'8"]),
                               MB(Call
                                    ("ThumbCondition",
                                     ATy(qTy,PTy(F4,qTy)),LU),
                                  Close
                                    (Var("v",F4),
                                     MB(MB(MB(Call
                                                ("HaveThumb2",
                                                 ATy(qTy,PTy(bTy,qTy)),LU),
                                              Close
                                                (bVar"v0",
                                                 MU(TP[Var("v",F4),
                                                       bVar"v0"],qTy))),
                                           Close
                                             (Var("v",PTy(F4,bTy)),
                                              Call
                                                ("Take",
                                                 ATy(qTy,PTy(bTy,qTy)),
                                                 Var("v",PTy(F4,bTy))))),
                                        Close
                                          (bVar"b",
                                           ITE(bVar"b",
                                               Let(nVar"msbit",
                                                   Mop(Cast nTy,
                                                       Mop(Cast(FTy 5),
                                                           LL[bVar"b'4",
                                                              bVar"b'3",
                                                              bVar"b'2",
                                                              bVar"b'1",
                                                              bVar"b'0"])),
                                                   Let(nVar"lsbit",
                                                       Mop(Cast nTy,
                                                           CC[Mop(Cast
                                                                    (FTy 3),
                                                                  LL[bVar"b'14",
                                                                     bVar"b'13",
                                                                     bVar"b'12"]),
                                                              Mop(Cast
                                                                    (FTy 2),
                                                                  LL[bVar"b'7",
                                                                     bVar"b'6"])]),
                                                       MB(ITE(Bop(Or,
                                                                  Bop(Or,
                                                                      Bop(In,
                                                                          Var("Rd",
                                                                              F4),
                                                                          SL[LW(13,
                                                                                4),
                                                                             LW(15,
                                                                                4)]),
                                                                      EQ(Var("Rn",
                                                                             F4),
                                                                         LW(13,
                                                                            4))),
                                                                  Bop(Lt,
                                                                      nVar"msbit",
                                                                      nVar"lsbit")),
                                                              Call
                                                                ("DECODE_UNPREDICTABLE",
                                                                 ATy(qTy,
                                                                     PTy(uTy,
                                                                         qTy)),
                                                                 TP[Var("mc",
                                                                        CTy"MachineCode"),
                                                                    LS
                                                                     "BitFieldClearOrInsert"]),
                                                              MU(LU,qTy)),
                                                          Close
                                                            (AVar uTy,
                                                             MU(Call
                                                                  ("Media",
                                                                   CTy"instruction",
                                                                   Call
                                                                     ("BitFieldClearOrInsert",
                                                                      CTy"Media",
                                                                      TP[Var("Rd",
                                                                             F4),
                                                                         Var("Rn",
                                                                             F4),
                                                                         nVar"lsbit",
                                                                         nVar"msbit"])),
                                                                qTy))))),
                                               Call
                                                 ("Skip",
                                                  ATy(qTy,
                                                      PTy(CTy"instruction",
                                                          qTy)),LU)))))))))],
                     Call
                       ("UndefinedThumb",
                        ATy(qTy,PTy(CTy"instruction",qTy)),LU)))],
               Call
                 ("UndefinedThumb",ATy(qTy,PTy(CTy"instruction",qTy)),LU)))))
;
val Decode_def = Def
  ("Decode",Var("mc",CTy"MachineCode"),
   CS(Var("mc",CTy"MachineCode"),
      [(Call("ARM",CTy"MachineCode",Var("w",F32)),
        Call("DecodeARM",ATy(qTy,PTy(CTy"instruction",qTy)),Var("w",F32))),
       (Call("Thumb",CTy"MachineCode",Var("h",F16)),
        Call
          ("DecodeThumb",ATy(qTy,PTy(CTy"instruction",qTy)),Var("h",F16))),
       (Call("ThumbEE",CTy"MachineCode",Var("h",F16)),
        Call
          ("DecodeThumbEE",ATy(qTy,PTy(CTy"instruction",qTy)),Var("h",F16))),
       (Call("Thumb2",CTy"MachineCode",Var("hs",PTy(F16,F16))),
        Call
          ("DecodeThumb2",ATy(qTy,PTy(CTy"instruction",qTy)),
           Var("hs",PTy(F16,F16))))]))
;
val Next_def = Def0
  ("Next",
   MB(MW(Close(qVar"s",Rupd("isfetch",TP[qVar"s",LT]))),
      Close
        (AVar uTy,
         MB(MW(Close(qVar"s",Rupd("data_abort",TP[qVar"s",LF]))),
            Close
              (AVar uTy,
               MB(MW(Close
                       (qVar"s",Rupd("transfer_unknown",TP[qVar"s",LF]))),
                  Close
                    (AVar uTy,
                     MB(Const("Fetch",ATy(qTy,PTy(CTy"MachineCode",qTy))),
                        Close
                          (Var("i",CTy"MachineCode"),
                           MB(MW(Close
                                   (qVar"s",Rupd("isfetch",TP[qVar"s",LF]))),
                              Close
                                (AVar uTy,
                                 MB(MR(Close
                                         (qVar"s",
                                          Dest("data_abort",bTy,qVar"s"))),
                                    Close
                                      (bVar"b",
                                       ITE(bVar"b",
                                           Call
                                             ("TakePrefetchAbortException",
                                              ATy(qTy,PTy(uTy,qTy)),LU),
                                           MB(Call
                                                ("Decode",
                                                 ATy(qTy,
                                                     PTy(CTy"instruction",
                                                         qTy)),
                                                 Var("i",CTy"MachineCode")),
                                              Close
                                                (Var("v",CTy"instruction"),
                                                 MB(Call
                                                      ("Run",
                                                       ATy(qTy,
                                                           PTy(uTy,qTy)),
                                                       Var("v",
                                                           CTy"instruction")),
                                                    Close
                                                      (AVar uTy,
                                                       Call
                                                         ("ITAdvance",
                                                          ATy(qTy,
                                                              PTy(uTy,qTy)),
                                                          LU)))))))))))))))))))

val () = Import.finish 0