signature real_topologyTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val CLOSED_interval : thm
    val OPEN_interval : thm
    val at : thm
    val at_infinity : thm
    val at_neginfinity : thm
    val at_posinfinity : thm
    val ball : thm
    val between : thm
    val bilinear : thm
    val bounded_def : thm
    val cauchy : thm
    val cball : thm
    val closed_def : thm
    val closed_segment : thm
    val closest_point : thm
    val closure : thm
    val collinear : thm
    val compact : thm
    val complete : thm
    val components : thm
    val condensation_point_of : thm
    val connected : thm
    val connected_component : thm
    val continuous : thm
    val continuous_on : thm
    val dependent : thm
    val diameter : thm
    val dim : thm
    val dist : thm
    val euclidean : thm
    val eventually : thm
    val frontier : thm
    val fsigma : thm
    val gdelta : thm
    val hausdist : thm
    val homeomorphic : thm
    val homeomorphism : thm
    val in_direction : thm
    val independent : thm
    val infsum : thm
    val interior : thm
    val is_interval : thm
    val isnet : thm
    val lim_def : thm
    val limit_point_of : thm
    val linear : thm
    val locally : thm
    val midpoint : thm
    val net_TY_DEF : thm
    val netlimit : thm
    val open_def : thm
    val open_segment : thm
    val pairwise : thm
    val permutes : thm
    val sequentially : thm
    val setdist : thm
    val span : thm
    val sphere : thm
    val subspace : thm
    val subtopology : thm
    val summable : thm
    val sums : thm
    val tendsto : thm
    val trivial_limit : thm
    val uniformly_continuous_on : thm
    val within : thm
  
  (*  Theorems  *)
    val ABS_CAUCHY_SCHWARZ_ABS_EQ : thm
    val ABS_CAUCHY_SCHWARZ_EQ : thm
    val ABS_CAUCHY_SCHWARZ_EQUAL : thm
    val ABS_LE_0 : thm
    val ABS_SUM_TRIVIAL_LEMMA : thm
    val ABS_TRIANGLE_EQ : thm
    val ABS_TRIANGLE_LE : thm
    val ADD_SUB2 : thm
    val ADD_SUBR : thm
    val ADD_SUBR2 : thm
    val AFFINITY_INVERSES : thm
    val ALWAYS_EVENTUALLY : thm
    val APPROACHABLE_LT_LE : thm
    val AT : thm
    val AT_INFINITY : thm
    val AT_NEGINFINITY : thm
    val AT_POSINFINITY : thm
    val BAIRE : thm
    val BAIRE_ALT : thm
    val BALL : thm
    val BALL_EMPTY : thm
    val BALL_EQ_EMPTY : thm
    val BALL_INTERVAL : thm
    val BALL_INTERVAL_0 : thm
    val BALL_LINEAR_IMAGE : thm
    val BALL_MAX_UNION : thm
    val BALL_MIN_INTER : thm
    val BALL_SCALING : thm
    val BALL_SUBSET_CBALL : thm
    val BALL_TRANSLATION : thm
    val BALL_TRIVIAL : thm
    val BALL_UNION_SPHERE : thm
    val BANACH_FIX : thm
    val BASIS_CARD_EQ_DIM : thm
    val BASIS_EXISTS : thm
    val BASIS_HAS_SIZE_DIM : thm
    val BETWEEN_ABS : thm
    val BETWEEN_ANTISYM : thm
    val BETWEEN_IMP_COLLINEAR : thm
    val BETWEEN_IN_SEGMENT : thm
    val BETWEEN_MIDPOINT : thm
    val BETWEEN_REFL : thm
    val BETWEEN_REFL_EQ : thm
    val BETWEEN_SYM : thm
    val BETWEEN_TRANS : thm
    val BETWEEN_TRANS_2 : thm
    val BIGINTER_BIGUNION : thm
    val BIGINTER_GSPEC : thm
    val BIGINTER_IMAGE : thm
    val BIGUNION_BIGINTER : thm
    val BIGUNION_COMPONENTS : thm
    val BIGUNION_CONNECTED_COMPONENT : thm
    val BIGUNION_DIFF : thm
    val BIGUNION_GSPEC : thm
    val BIGUNION_IMAGE : thm
    val BIGUNION_MONO : thm
    val BIGUNION_MONO_IMAGE : thm
    val BILINEAR_BOUNDED : thm
    val BILINEAR_BOUNDED_POS : thm
    val BILINEAR_CONTINUOUS_COMPOSE : thm
    val BILINEAR_CONTINUOUS_ON_COMPOSE : thm
    val BILINEAR_DOT : thm
    val BILINEAR_LADD : thm
    val BILINEAR_LMUL : thm
    val BILINEAR_LNEG : thm
    val BILINEAR_LSUB : thm
    val BILINEAR_LZERO : thm
    val BILINEAR_RADD : thm
    val BILINEAR_RMUL : thm
    val BILINEAR_RNEG : thm
    val BILINEAR_RSUB : thm
    val BILINEAR_RZERO : thm
    val BILINEAR_SUM : thm
    val BILINEAR_SUM_PARTIAL_PRE : thm
    val BILINEAR_SUM_PARTIAL_SUC : thm
    val BILINEAR_SWAP : thm
    val BILINEAR_UNIFORMLY_CONTINUOUS_ON_COMPOSE : thm
    val BOLZANO_WEIERSTRASS : thm
    val BOLZANO_WEIERSTRASS_CONTRAPOS : thm
    val BOLZANO_WEIERSTRASS_IMP_BOUNDED : thm
    val BOLZANO_WEIERSTRASS_IMP_CLOSED : thm
    val BOUNDED_BALL : thm
    val BOUNDED_BIGINTER : thm
    val BOUNDED_BIGUNION : thm
    val BOUNDED_CBALL : thm
    val BOUNDED_CLOSED_CHAIN : thm
    val BOUNDED_CLOSED_IMP_COMPACT : thm
    val BOUNDED_CLOSED_INTERVAL : thm
    val BOUNDED_CLOSED_NEST : thm
    val BOUNDED_CLOSURE : thm
    val BOUNDED_CLOSURE_EQ : thm
    val BOUNDED_COMPONENTWISE : thm
    val BOUNDED_DECREASING_CONVERGENT : thm
    val BOUNDED_DIFF : thm
    val BOUNDED_DIFFS : thm
    val BOUNDED_EMPTY : thm
    val BOUNDED_EQ_BOLZANO_WEIERSTRASS : thm
    val BOUNDED_FRONTIER : thm
    val BOUNDED_HAS_INF : thm
    val BOUNDED_HAS_SUP : thm
    val BOUNDED_INCREASING_CONVERGENT : thm
    val BOUNDED_INSERT : thm
    val BOUNDED_INTER : thm
    val BOUNDED_INTERIOR : thm
    val BOUNDED_INTERVAL : thm
    val BOUNDED_LINEAR_IMAGE : thm
    val BOUNDED_NEGATIONS : thm
    val BOUNDED_PARTIAL_SUMS : thm
    val BOUNDED_POS : thm
    val BOUNDED_POS_LT : thm
    val BOUNDED_SCALING : thm
    val BOUNDED_SING : thm
    val BOUNDED_SPHERE : thm
    val BOUNDED_SUBSET : thm
    val BOUNDED_SUBSET_BALL : thm
    val BOUNDED_SUBSET_CBALL : thm
    val BOUNDED_SUBSET_CLOSED_INTERVAL : thm
    val BOUNDED_SUBSET_CLOSED_INTERVAL_SYMMETRIC : thm
    val BOUNDED_SUBSET_OPEN_INTERVAL : thm
    val BOUNDED_SUBSET_OPEN_INTERVAL_SYMMETRIC : thm
    val BOUNDED_SUMS : thm
    val BOUNDED_SUMS_IMAGE : thm
    val BOUNDED_SUMS_IMAGES : thm
    val BOUNDED_TRANSLATION : thm
    val BOUNDED_TRANSLATION_EQ : thm
    val BOUNDED_UNIFORMLY_CONTINUOUS_IMAGE : thm
    val BOUNDED_UNION : thm
    val BOUNDS_LINEAR : thm
    val BOUNDS_LINEAR_0 : thm
    val CARD_EQ_BALL : thm
    val CARD_EQ_CBALL : thm
    val CARD_EQ_EUCLIDEAN : thm
    val CARD_EQ_INTERVAL : thm
    val CARD_EQ_OPEN : thm
    val CARD_EQ_REAL : thm
    val CARD_EQ_REAL_IMP_UNCOUNTABLE : thm
    val CARD_FRONTIER_INTERVAL : thm
    val CARD_GE_DIM_INDEPENDENT : thm
    val CARD_STDBASIS : thm
    val CAUCHY : thm
    val CAUCHY_CONTINUOUS_EXTENDS_TO_CLOSURE : thm
    val CAUCHY_CONTINUOUS_IMP_CONTINUOUS : thm
    val CAUCHY_CONTINUOUS_UNIQUENESS_LEMMA : thm
    val CAUCHY_IMP_BOUNDED : thm
    val CAUCHY_ISOMETRIC : thm
    val CBALL_DIFF_BALL : thm
    val CBALL_DIFF_SPHERE : thm
    val CBALL_EMPTY : thm
    val CBALL_EQ_EMPTY : thm
    val CBALL_EQ_SING : thm
    val CBALL_INTERVAL : thm
    val CBALL_INTERVAL_0 : thm
    val CBALL_LINEAR_IMAGE : thm
    val CBALL_MAX_UNION : thm
    val CBALL_MIN_INTER : thm
    val CBALL_SCALING : thm
    val CBALL_SING : thm
    val CBALL_TRANSLATION : thm
    val CBALL_TRIVIAL : thm
    val CENTRE_IN_BALL : thm
    val CENTRE_IN_CBALL : thm
    val CLOPEN : thm
    val CLOPEN_BIGUNION_COMPONENTS : thm
    val CLOPEN_IN_COMPONENTS : thm
    val CLOSED : thm
    val CLOSED_APPROACHABLE : thm
    val CLOSED_AS_GDELTA : thm
    val CLOSED_BIGINTER : thm
    val CLOSED_BIGINTER_COMPACT : thm
    val CLOSED_BIGUNION : thm
    val CLOSED_CBALL : thm
    val CLOSED_CLOSURE : thm
    val CLOSED_COMPACT_DIFFERENCES : thm
    val CLOSED_COMPACT_SUMS : thm
    val CLOSED_COMPONENTS : thm
    val CLOSED_CONNECTED_COMPONENT : thm
    val CLOSED_CONTAINS_SEQUENTIAL_LIMIT : thm
    val CLOSED_DIFF : thm
    val CLOSED_DIFF_OPEN_INTERVAL : thm
    val CLOSED_EMPTY : thm
    val CLOSED_FIP : thm
    val CLOSED_FORALL : thm
    val CLOSED_FORALL_IN : thm
    val CLOSED_HALFSPACE_COMPONENT_GE : thm
    val CLOSED_HALFSPACE_COMPONENT_LE : thm
    val CLOSED_HALFSPACE_GE : thm
    val CLOSED_HALFSPACE_LE : thm
    val CLOSED_HYPERPLANE : thm
    val CLOSED_IMP_FIP : thm
    val CLOSED_IMP_FIP_COMPACT : thm
    val CLOSED_IMP_LOCALLY_COMPACT : thm
    val CLOSED_IN : thm
    val CLOSED_INJECTIVE_IMAGE_SUBSPACE : thm
    val CLOSED_INJECTIVE_LINEAR_IMAGE : thm
    val CLOSED_INJECTIVE_LINEAR_IMAGE_EQ : thm
    val CLOSED_INSERT : thm
    val CLOSED_INTER : thm
    val CLOSED_INTERVAL : thm
    val CLOSED_INTERVAL_EQ : thm
    val CLOSED_INTERVAL_IMAGE_UNIT_INTERVAL : thm
    val CLOSED_INTERVAL_LEFT : thm
    val CLOSED_INTERVAL_RIGHT : thm
    val CLOSED_INTER_COMPACT : thm
    val CLOSED_IN_CLOSED : thm
    val CLOSED_IN_CLOSED_EQ : thm
    val CLOSED_IN_CLOSED_INTER : thm
    val CLOSED_IN_CLOSED_TRANS : thm
    val CLOSED_IN_COMPACT : thm
    val CLOSED_IN_COMPACT_EQ : thm
    val CLOSED_IN_COMPONENT : thm
    val CLOSED_IN_CONNECTED_COMPONENT : thm
    val CLOSED_IN_IMP_SUBSET : thm
    val CLOSED_IN_INTER_CLOSED : thm
    val CLOSED_IN_INTER_CLOSURE : thm
    val CLOSED_IN_LIMPT : thm
    val CLOSED_IN_REFL : thm
    val CLOSED_IN_SING : thm
    val CLOSED_IN_SUBSET_TRANS : thm
    val CLOSED_IN_SUBTOPOLOGY : thm
    val CLOSED_IN_SUBTOPOLOGY_EMPTY : thm
    val CLOSED_IN_SUBTOPOLOGY_REFL : thm
    val CLOSED_IN_SUBTOPOLOGY_UNION : thm
    val CLOSED_IN_TRANS : thm
    val CLOSED_IN_TRANS_EQ : thm
    val CLOSED_LIMPT : thm
    val CLOSED_LIMPTS : thm
    val CLOSED_MAP_CLOSURES : thm
    val CLOSED_MAP_FROM_COMPOSITION_INJECTIVE : thm
    val CLOSED_MAP_FROM_COMPOSITION_SURJECTIVE : thm
    val CLOSED_MAP_IFF_UPPER_HEMICONTINUOUS_PREIMAGE : thm
    val CLOSED_MAP_IMP_OPEN_MAP : thm
    val CLOSED_MAP_IMP_QUOTIENT_MAP : thm
    val CLOSED_MAP_OPEN_SUPERSET_PREIMAGE : thm
    val CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_EQ : thm
    val CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_POINT : thm
    val CLOSED_MAP_RESTRICT : thm
    val CLOSED_NEGATIONS : thm
    val CLOSED_OPEN_INTERVAL : thm
    val CLOSED_POSITIVE_ORTHANT : thm
    val CLOSED_SCALING : thm
    val CLOSED_SEGMENT_LINEAR_IMAGE : thm
    val CLOSED_SEQUENTIAL_LIMITS : thm
    val CLOSED_SING : thm
    val CLOSED_SPHERE : thm
    val CLOSED_STANDARD_HYPERPLANE : thm
    val CLOSED_SUBSET : thm
    val CLOSED_SUBSET_EQ : thm
    val CLOSED_SUBSTANDARD : thm
    val CLOSED_UNION : thm
    val CLOSED_UNION_COMPACT_SUBSETS : thm
    val CLOSED_UNIV : thm
    val CLOSEST_POINT_EXISTS : thm
    val CLOSEST_POINT_IN_FRONTIER : thm
    val CLOSEST_POINT_IN_INTERIOR : thm
    val CLOSEST_POINT_IN_SET : thm
    val CLOSEST_POINT_LE : thm
    val CLOSEST_POINT_REFL : thm
    val CLOSEST_POINT_SELF : thm
    val CLOSURE_APPROACHABLE : thm
    val CLOSURE_BALL : thm
    val CLOSURE_BIGINTER_SUBSET : thm
    val CLOSURE_BIGUNION : thm
    val CLOSURE_BOUNDED_LINEAR_IMAGE : thm
    val CLOSURE_CLOSED : thm
    val CLOSURE_CLOSURE : thm
    val CLOSURE_COMPLEMENT : thm
    val CLOSURE_EMPTY : thm
    val CLOSURE_EQ : thm
    val CLOSURE_EQ_EMPTY : thm
    val CLOSURE_HALFSPACE_COMPONENT_GT : thm
    val CLOSURE_HALFSPACE_COMPONENT_LT : thm
    val CLOSURE_HALFSPACE_GT : thm
    val CLOSURE_HALFSPACE_LT : thm
    val CLOSURE_HULL : thm
    val CLOSURE_HYPERPLANE : thm
    val CLOSURE_IMAGE_BOUNDED : thm
    val CLOSURE_IMAGE_CLOSURE : thm
    val CLOSURE_INJECTIVE_LINEAR_IMAGE : thm
    val CLOSURE_INTERIOR : thm
    val CLOSURE_INTERIOR_IDEMP : thm
    val CLOSURE_INTERIOR_UNION_CLOSED : thm
    val CLOSURE_INTERVAL : thm
    val CLOSURE_INTER_SUBSET : thm
    val CLOSURE_LINEAR_IMAGE_SUBSET : thm
    val CLOSURE_MINIMAL : thm
    val CLOSURE_MINIMAL_EQ : thm
    val CLOSURE_NEGATIONS : thm
    val CLOSURE_NONEMPTY_OPEN_INTER : thm
    val CLOSURE_OPEN_INTERVAL : thm
    val CLOSURE_OPEN_INTER_CLOSURE : thm
    val CLOSURE_OPEN_INTER_SUPERSET : thm
    val CLOSURE_OPEN_IN_INTER_CLOSURE : thm
    val CLOSURE_SEQUENTIAL : thm
    val CLOSURE_SING : thm
    val CLOSURE_SUBSET : thm
    val CLOSURE_SUBSET_EQ : thm
    val CLOSURE_SUMS : thm
    val CLOSURE_UNION : thm
    val CLOSURE_UNION_FRONTIER : thm
    val CLOSURE_UNIQUE : thm
    val CLOSURE_UNIV : thm
    val COBOUNDED_IMP_UNBOUNDED : thm
    val COBOUNDED_INTER_UNBOUNDED : thm
    val COLLINEAR_1 : thm
    val COLLINEAR_2 : thm
    val COLLINEAR_3 : thm
    val COLLINEAR_3_EXPAND : thm
    val COLLINEAR_3_TRANS : thm
    val COLLINEAR_4_3 : thm
    val COLLINEAR_BETWEEN_CASES : thm
    val COLLINEAR_DIST_BETWEEN : thm
    val COLLINEAR_DIST_IN_CLOSED_SEGMENT : thm
    val COLLINEAR_DIST_IN_OPEN_SEGMENT : thm
    val COLLINEAR_EMPTY : thm
    val COLLINEAR_LEMMA : thm
    val COLLINEAR_LEMMA_ALT : thm
    val COLLINEAR_MIDPOINT : thm
    val COLLINEAR_SING : thm
    val COLLINEAR_SMALL : thm
    val COLLINEAR_SUBSET : thm
    val COLLINEAR_TRIPLES : thm
    val COMPACT_AFFINITY : thm
    val COMPACT_ATTAINS_INF : thm
    val COMPACT_ATTAINS_SUP : thm
    val COMPACT_BIGINTER : thm
    val COMPACT_BIGUNION : thm
    val COMPACT_CBALL : thm
    val COMPACT_CHAIN : thm
    val COMPACT_CLOSED_DIFFERENCES : thm
    val COMPACT_CLOSED_SUMS : thm
    val COMPACT_CLOSURE : thm
    val COMPACT_COMPONENTS : thm
    val COMPACT_CONTINUOUS_IMAGE : thm
    val COMPACT_CONTINUOUS_IMAGE_EQ : thm
    val COMPACT_DIFF : thm
    val COMPACT_EMPTY : thm
    val COMPACT_EQ_BOLZANO_WEIERSTRASS : thm
    val COMPACT_EQ_BOUNDED_CLOSED : thm
    val COMPACT_EQ_HEINE_BOREL : thm
    val COMPACT_EQ_HEINE_BOREL_SUBTOPOLOGY : thm
    val COMPACT_FIP : thm
    val COMPACT_FRONTIER : thm
    val COMPACT_FRONTIER_BOUNDED : thm
    val COMPACT_IMP_BOUNDED : thm
    val COMPACT_IMP_CLOSED : thm
    val COMPACT_IMP_COMPLETE : thm
    val COMPACT_IMP_FIP : thm
    val COMPACT_IMP_HEINE_BOREL : thm
    val COMPACT_IMP_TOTALLY_BOUNDED : thm
    val COMPACT_INSERT : thm
    val COMPACT_INTER : thm
    val COMPACT_INTERVAL : thm
    val COMPACT_INTERVAL_EQ : thm
    val COMPACT_INTER_CLOSED : thm
    val COMPACT_LEMMA : thm
    val COMPACT_LINEAR_IMAGE : thm
    val COMPACT_NEGATIONS : thm
    val COMPACT_NEST : thm
    val COMPACT_REAL_LEMMA : thm
    val COMPACT_SCALING : thm
    val COMPACT_SEQUENCE_WITH_LIMIT : thm
    val COMPACT_SING : thm
    val COMPACT_SPHERE : thm
    val COMPACT_TRANSLATION : thm
    val COMPACT_TRANSLATION_EQ : thm
    val COMPACT_UNIFORMLY_CONTINUOUS : thm
    val COMPACT_UNIFORMLY_EQUICONTINUOUS : thm
    val COMPACT_UNION : thm
    val COMPLEMENT_CONNECTED_COMPONENT_BIGUNION : thm
    val COMPLETE_EQ_CLOSED : thm
    val COMPLETE_INJECTIVE_LINEAR_IMAGE : thm
    val COMPLETE_INJECTIVE_LINEAR_IMAGE_EQ : thm
    val COMPLETE_ISOMETRIC_IMAGE : thm
    val COMPLETE_UNIV : thm
    val COMPONENTS_EMPTY : thm
    val COMPONENTS_EQ : thm
    val COMPONENTS_EQ_EMPTY : thm
    val COMPONENTS_EQ_SING : thm
    val COMPONENTS_EQ_SING_EXISTS : thm
    val COMPONENTS_EQ_SING_N_EXISTS : thm
    val COMPONENTS_INTERMEDIATE_SUBSET : thm
    val COMPONENTS_MAXIMAL : thm
    val COMPONENTS_NONOVERLAP : thm
    val COMPONENTS_UNIQUE : thm
    val COMPONENTS_UNIQUE_EQ : thm
    val COMPONENTS_UNIV : thm
    val CONDENSATION_POINT_IMP_LIMPT : thm
    val CONDENSATION_POINT_INFINITE_BALL : thm
    val CONDENSATION_POINT_INFINITE_BALL_CBALL : thm
    val CONDENSATION_POINT_INFINITE_CBALL : thm
    val CONDENSATION_POINT_OF_SUBSET : thm
    val CONNECTED_BIGUNION : thm
    val CONNECTED_CHAIN : thm
    val CONNECTED_CHAIN_GEN : thm
    val CONNECTED_CLOPEN : thm
    val CONNECTED_CLOSED : thm
    val CONNECTED_CLOSED_IN : thm
    val CONNECTED_CLOSED_IN_EQ : thm
    val CONNECTED_CLOSED_MONOTONE_PREIMAGE : thm
    val CONNECTED_CLOSED_SET : thm
    val CONNECTED_CLOSURE : thm
    val CONNECTED_COMPONENT_BIGUNION : thm
    val CONNECTED_COMPONENT_DISJOINT : thm
    val CONNECTED_COMPONENT_EMPTY : thm
    val CONNECTED_COMPONENT_EQ : thm
    val CONNECTED_COMPONENT_EQUIVALENCE_RELATION : thm
    val CONNECTED_COMPONENT_EQ_EMPTY : thm
    val CONNECTED_COMPONENT_EQ_EQ : thm
    val CONNECTED_COMPONENT_EQ_SELF : thm
    val CONNECTED_COMPONENT_EQ_UNIV : thm
    val CONNECTED_COMPONENT_IDEMP : thm
    val CONNECTED_COMPONENT_IN : thm
    val CONNECTED_COMPONENT_INTERMEDIATE_SUBSET : thm
    val CONNECTED_COMPONENT_MAXIMAL : thm
    val CONNECTED_COMPONENT_MONO : thm
    val CONNECTED_COMPONENT_NONOVERLAP : thm
    val CONNECTED_COMPONENT_OF_SUBSET : thm
    val CONNECTED_COMPONENT_OVERLAP : thm
    val CONNECTED_COMPONENT_REFL : thm
    val CONNECTED_COMPONENT_REFL_EQ : thm
    val CONNECTED_COMPONENT_SET : thm
    val CONNECTED_COMPONENT_SUBSET : thm
    val CONNECTED_COMPONENT_SYM : thm
    val CONNECTED_COMPONENT_SYM_EQ : thm
    val CONNECTED_COMPONENT_TRANS : thm
    val CONNECTED_COMPONENT_UNIQUE : thm
    val CONNECTED_COMPONENT_UNIV : thm
    val CONNECTED_CONNECTED_COMPONENT : thm
    val CONNECTED_CONNECTED_COMPONENT_SET : thm
    val CONNECTED_CONTINUOUS_IMAGE : thm
    val CONNECTED_DIFF_OPEN_FROM_CLOSED : thm
    val CONNECTED_DISJOINT_BIGUNION_OPEN_UNIQUE : thm
    val CONNECTED_EMPTY : thm
    val CONNECTED_EQUIVALENCE_RELATION : thm
    val CONNECTED_EQUIVALENCE_RELATION_GEN : thm
    val CONNECTED_EQ_COMPONENTS_SUBSET_SING : thm
    val CONNECTED_EQ_COMPONENTS_SUBSET_SING_EXISTS : thm
    val CONNECTED_EQ_CONNECTED_COMPONENTS_EQ : thm
    val CONNECTED_EQ_CONNECTED_COMPONENT_EQ : thm
    val CONNECTED_FROM_CLOSED_UNION_AND_INTER : thm
    val CONNECTED_FROM_OPEN_UNION_AND_INTER : thm
    val CONNECTED_IFF_CONNECTABLE_POINTS : thm
    val CONNECTED_IFF_CONNECTED_COMPONENT : thm
    val CONNECTED_IMP_PERFECT : thm
    val CONNECTED_IMP_PERFECT_CLOSED : thm
    val CONNECTED_INDUCTION : thm
    val CONNECTED_INDUCTION_SIMPLE : thm
    val CONNECTED_INTERMEDIATE_CLOSURE : thm
    val CONNECTED_INTER_FRONTIER : thm
    val CONNECTED_IVT_COMPONENT : thm
    val CONNECTED_IVT_HYPERPLANE : thm
    val CONNECTED_LINEAR_IMAGE : thm
    val CONNECTED_MONOTONE_QUOTIENT_PREIMAGE : thm
    val CONNECTED_MONOTONE_QUOTIENT_PREIMAGE_GEN : thm
    val CONNECTED_NEGATIONS : thm
    val CONNECTED_NEST : thm
    val CONNECTED_NEST_GEN : thm
    val CONNECTED_OPEN_IN : thm
    val CONNECTED_OPEN_IN_EQ : thm
    val CONNECTED_OPEN_MONOTONE_PREIMAGE : thm
    val CONNECTED_OPEN_SET : thm
    val CONNECTED_REAL_LEMMA : thm
    val CONNECTED_SCALING : thm
    val CONNECTED_SEGMENT : thm
    val CONNECTED_SING : thm
    val CONNECTED_SUBSET_CLOPEN : thm
    val CONNECTED_TRANSLATION : thm
    val CONNECTED_TRANSLATION_EQ : thm
    val CONNECTED_UNION : thm
    val CONNECTED_UNION_STRONG : thm
    val CONNECTED_UNIV : thm
    val CONTINUOUS_ABS : thm
    val CONTINUOUS_ABS_COMPOSE : thm
    val CONTINUOUS_ADD : thm
    val CONTINUOUS_AGREE_ON_CLOSURE : thm
    val CONTINUOUS_AT : thm
    val CONTINUOUS_ATTAINS_INF : thm
    val CONTINUOUS_ATTAINS_SUP : thm
    val CONTINUOUS_AT_ABS : thm
    val CONTINUOUS_AT_AVOID : thm
    val CONTINUOUS_AT_BALL : thm
    val CONTINUOUS_AT_COMPOSE : thm
    val CONTINUOUS_AT_COMPOSE_EQ : thm
    val CONTINUOUS_AT_DIST : thm
    val CONTINUOUS_AT_DIST_CLOSEST_POINT : thm
    val CONTINUOUS_AT_ID : thm
    val CONTINUOUS_AT_IMP_CONTINUOUS_ON : thm
    val CONTINUOUS_AT_INV : thm
    val CONTINUOUS_AT_LIFT_DOT : thm
    val CONTINUOUS_AT_OPEN : thm
    val CONTINUOUS_AT_RANGE : thm
    val CONTINUOUS_AT_SEQUENTIALLY : thm
    val CONTINUOUS_AT_SETDIST : thm
    val CONTINUOUS_AT_TRANSLATION : thm
    val CONTINUOUS_AT_WITHIN : thm
    val CONTINUOUS_AT_WITHIN_INV : thm
    val CONTINUOUS_CLOSED_IMP_CAUCHY_CONTINUOUS : thm
    val CONTINUOUS_CLOSED_IN_PREIMAGE : thm
    val CONTINUOUS_CLOSED_IN_PREIMAGE_CONSTANT : thm
    val CONTINUOUS_CLOSED_IN_PREIMAGE_EQ : thm
    val CONTINUOUS_CLOSED_IN_PREIMAGE_GEN : thm
    val CONTINUOUS_CLOSED_PREIMAGE : thm
    val CONTINUOUS_CLOSED_PREIMAGE_CONSTANT : thm
    val CONTINUOUS_CLOSED_PREIMAGE_UNIV : thm
    val CONTINUOUS_CMUL : thm
    val CONTINUOUS_COMPONENT_COMPOSE : thm
    val CONTINUOUS_CONST : thm
    val CONTINUOUS_CONSTANT_ON_CLOSURE : thm
    val CONTINUOUS_DIAMETER : thm
    val CONTINUOUS_DISCONNECTED_DISCRETE_FINITE_RANGE_CONSTANT_EQ : thm
    val CONTINUOUS_DISCONNECTED_RANGE_CONSTANT : thm
    val CONTINUOUS_DISCONNECTED_RANGE_CONSTANT_EQ : thm
    val CONTINUOUS_DISCRETE_RANGE_CONSTANT : thm
    val CONTINUOUS_DISCRETE_RANGE_CONSTANT_EQ : thm
    val CONTINUOUS_DOT2 : thm
    val CONTINUOUS_FINITE_RANGE_CONSTANT : thm
    val CONTINUOUS_FINITE_RANGE_CONSTANT_EQ : thm
    val CONTINUOUS_GE_ON_CLOSURE : thm
    val CONTINUOUS_IMP_CLOSED_MAP : thm
    val CONTINUOUS_IMP_QUOTIENT_MAP : thm
    val CONTINUOUS_INV : thm
    val CONTINUOUS_LEFT_INVERSE_IMP_QUOTIENT_MAP : thm
    val CONTINUOUS_LEVELSET_OPEN : thm
    val CONTINUOUS_LEVELSET_OPEN_IN : thm
    val CONTINUOUS_LEVELSET_OPEN_IN_CASES : thm
    val CONTINUOUS_LE_ON_CLOSURE : thm
    val CONTINUOUS_MAP_CLOSURES : thm
    val CONTINUOUS_MAX : thm
    val CONTINUOUS_MIN : thm
    val CONTINUOUS_MUL : thm
    val CONTINUOUS_NEG : thm
    val CONTINUOUS_ON : thm
    val CONTINUOUS_ON_ABS : thm
    val CONTINUOUS_ON_ABS_COMPOSE : thm
    val CONTINUOUS_ON_ADD : thm
    val CONTINUOUS_ON_AVOID : thm
    val CONTINUOUS_ON_CASES : thm
    val CONTINUOUS_ON_CASES_1 : thm
    val CONTINUOUS_ON_CASES_LE : thm
    val CONTINUOUS_ON_CASES_LOCAL : thm
    val CONTINUOUS_ON_CASES_LOCAL_OPEN : thm
    val CONTINUOUS_ON_CASES_OPEN : thm
    val CONTINUOUS_ON_CLOSED : thm
    val CONTINUOUS_ON_CLOSED_GEN : thm
    val CONTINUOUS_ON_CLOSURE : thm
    val CONTINUOUS_ON_CLOSURE_ABS_LE : thm
    val CONTINUOUS_ON_CLOSURE_COMPONENT_GE : thm
    val CONTINUOUS_ON_CLOSURE_COMPONENT_LE : thm
    val CONTINUOUS_ON_CLOSURE_SEQUENTIALLY : thm
    val CONTINUOUS_ON_CMUL : thm
    val CONTINUOUS_ON_COMPONENTS_FINITE : thm
    val CONTINUOUS_ON_COMPONENTS_GEN : thm
    val CONTINUOUS_ON_COMPONENT_COMPOSE : thm
    val CONTINUOUS_ON_COMPOSE : thm
    val CONTINUOUS_ON_COMPOSE_QUOTIENT : thm
    val CONTINUOUS_ON_CONST : thm
    val CONTINUOUS_ON_DIST : thm
    val CONTINUOUS_ON_DIST_CLOSEST_POINT : thm
    val CONTINUOUS_ON_DOT2 : thm
    val CONTINUOUS_ON_EMPTY : thm
    val CONTINUOUS_ON_EQ : thm
    val CONTINUOUS_ON_EQ_CONTINUOUS_AT : thm
    val CONTINUOUS_ON_EQ_CONTINUOUS_WITHIN : thm
    val CONTINUOUS_ON_FINITE : thm
    val CONTINUOUS_ON_ID : thm
    val CONTINUOUS_ON_IMP_CLOSED_IN : thm
    val CONTINUOUS_ON_IMP_OPEN_IN : thm
    val CONTINUOUS_ON_INTERIOR : thm
    val CONTINUOUS_ON_INV : thm
    val CONTINUOUS_ON_INVERSE : thm
    val CONTINUOUS_ON_INVERSE_CLOSED_MAP : thm
    val CONTINUOUS_ON_INVERSE_OPEN_MAP : thm
    val CONTINUOUS_ON_LIFT_DOT : thm
    val CONTINUOUS_ON_MAX : thm
    val CONTINUOUS_ON_MIN : thm
    val CONTINUOUS_ON_MUL : thm
    val CONTINUOUS_ON_NEG : thm
    val CONTINUOUS_ON_NO_LIMPT : thm
    val CONTINUOUS_ON_OPEN : thm
    val CONTINUOUS_ON_OPEN_AVOID : thm
    val CONTINUOUS_ON_OPEN_GEN : thm
    val CONTINUOUS_ON_POW : thm
    val CONTINUOUS_ON_PRODUCT : thm
    val CONTINUOUS_ON_RANGE : thm
    val CONTINUOUS_ON_SEQUENTIALLY : thm
    val CONTINUOUS_ON_SETDIST : thm
    val CONTINUOUS_ON_SING : thm
    val CONTINUOUS_ON_SUB : thm
    val CONTINUOUS_ON_SUBSET : thm
    val CONTINUOUS_ON_SUM : thm
    val CONTINUOUS_ON_UNION : thm
    val CONTINUOUS_ON_UNION_LOCAL : thm
    val CONTINUOUS_ON_UNION_LOCAL_OPEN : thm
    val CONTINUOUS_ON_UNION_OPEN : thm
    val CONTINUOUS_ON_VMUL : thm
    val CONTINUOUS_OPEN_IN_PREIMAGE : thm
    val CONTINUOUS_OPEN_IN_PREIMAGE_EQ : thm
    val CONTINUOUS_OPEN_IN_PREIMAGE_GEN : thm
    val CONTINUOUS_OPEN_PREIMAGE : thm
    val CONTINUOUS_OPEN_PREIMAGE_UNIV : thm
    val CONTINUOUS_POW : thm
    val CONTINUOUS_PRODUCT : thm
    val CONTINUOUS_RIGHT_INVERSE_IMP_QUOTIENT_MAP : thm
    val CONTINUOUS_SUB : thm
    val CONTINUOUS_SUM : thm
    val CONTINUOUS_TRANSFORM_AT : thm
    val CONTINUOUS_TRANSFORM_WITHIN : thm
    val CONTINUOUS_TRANSFORM_WITHIN_OPEN : thm
    val CONTINUOUS_TRANSFORM_WITHIN_OPEN_IN : thm
    val CONTINUOUS_TRANSFORM_WITHIN_SET_IMP : thm
    val CONTINUOUS_TRIVIAL_LIMIT : thm
    val CONTINUOUS_UNIFORM_LIMIT : thm
    val CONTINUOUS_VMUL : thm
    val CONTINUOUS_WITHIN : thm
    val CONTINUOUS_WITHIN_AVOID : thm
    val CONTINUOUS_WITHIN_BALL : thm
    val CONTINUOUS_WITHIN_CLOSED_NONTRIVIAL : thm
    val CONTINUOUS_WITHIN_COMPARISON : thm
    val CONTINUOUS_WITHIN_COMPOSE : thm
    val CONTINUOUS_WITHIN_ID : thm
    val CONTINUOUS_WITHIN_OPEN : thm
    val CONTINUOUS_WITHIN_SEQUENTIALLY : thm
    val CONTINUOUS_WITHIN_SUBSET : thm
    val CONTRACTION_IMP_CONTINUOUS_ON : thm
    val CONVERGENT_BOUNDED_INCREASING : thm
    val CONVERGENT_BOUNDED_MONOTONE : thm
    val CONVERGENT_EQ_CAUCHY : thm
    val CONVERGENT_IMP_BOUNDED : thm
    val CONVERGENT_IMP_CAUCHY : thm
    val COUNTABLE_OPEN_INTERVAL : thm
    val DECREASING_CLOSED_NEST : thm
    val DECREASING_CLOSED_NEST_SING : thm
    val DENSE_IMP_PERFECT : thm
    val DENSE_LIMIT_POINTS : thm
    val DENSE_OPEN_INTER : thm
    val DEPENDENT_CHOICE : thm
    val DEPENDENT_CHOICE_FIXED : thm
    val DEPENDENT_EXPLICIT : thm
    val DEPENDENT_MONO : thm
    val DIAMETER_BALL : thm
    val DIAMETER_BOUNDED : thm
    val DIAMETER_BOUNDED_BOUND : thm
    val DIAMETER_CBALL : thm
    val DIAMETER_CLOSURE : thm
    val DIAMETER_EMPTY : thm
    val DIAMETER_EQ_0 : thm
    val DIAMETER_INTERVAL : thm
    val DIAMETER_LE : thm
    val DIAMETER_LINEAR_IMAGE : thm
    val DIAMETER_POS_LE : thm
    val DIAMETER_SING : thm
    val DIAMETER_SUBSET : thm
    val DIAMETER_SUBSET_CBALL : thm
    val DIAMETER_SUBSET_CBALL_NONEMPTY : thm
    val DIAMETER_SUMS : thm
    val DIFF_BIGINTER : thm
    val DIFF_CLOSURE_SUBSET : thm
    val DIM_LE_CARD : thm
    val DIM_SUBSET : thm
    val DIM_SUBSET_UNIV : thm
    val DIM_SUBSTANDARD : thm
    val DIM_UNIQUE : thm
    val DIM_UNIV : thm
    val DINI : thm
    val DISCRETE_BOUNDED_IMP_FINITE : thm
    val DISCRETE_IMP_CLOSED : thm
    val DISJOINT_INTERVAL : thm
    val DISTANCE_ATTAINS_INF : thm
    val DISTANCE_ATTAINS_SUP : thm
    val DIST_0 : thm
    val DIST_CLOSEST_POINT_LIPSCHITZ : thm
    val DIST_EQ : thm
    val DIST_EQ_0 : thm
    val DIST_IN_CLOSED_SEGMENT : thm
    val DIST_IN_OPEN_CLOSED_SEGMENT : thm
    val DIST_IN_OPEN_SEGMENT : thm
    val DIST_LE_0 : thm
    val DIST_MIDPOINT : thm
    val DIST_MUL : thm
    val DIST_NZ : thm
    val DIST_POS_LE : thm
    val DIST_POS_LT : thm
    val DIST_REFL : thm
    val DIST_SYM : thm
    val DIST_TRIANGLE : thm
    val DIST_TRIANGLE_ADD : thm
    val DIST_TRIANGLE_ADD_HALF : thm
    val DIST_TRIANGLE_ALT : thm
    val DIST_TRIANGLE_EQ : thm
    val DIST_TRIANGLE_HALF_L : thm
    val DIST_TRIANGLE_HALF_R : thm
    val DIST_TRIANGLE_LE : thm
    val DIST_TRIANGLE_LT : thm
    val EMPTY_AS_INTERVAL : thm
    val EMPTY_BIGUNION : thm
    val EMPTY_INTERIOR_FINITE : thm
    val ENDS_IN_INTERVAL : thm
    val ENDS_IN_SEGMENT : thm
    val ENDS_IN_UNIT_INTERVAL : thm
    val ENDS_NOT_IN_SEGMENT : thm
    val EQ_BALLS : thm
    val EQ_INTERVAL : thm
    val EVENTUALLY_AND : thm
    val EVENTUALLY_AT : thm
    val EVENTUALLY_AT_INFINITY : thm
    val EVENTUALLY_AT_INFINITY_POS : thm
    val EVENTUALLY_AT_NEGINFINITY : thm
    val EVENTUALLY_AT_POSINFINITY : thm
    val EVENTUALLY_FALSE : thm
    val EVENTUALLY_FORALL : thm
    val EVENTUALLY_HAPPENS : thm
    val EVENTUALLY_MONO : thm
    val EVENTUALLY_MP : thm
    val EVENTUALLY_SEQUENTIALLY : thm
    val EVENTUALLY_TRUE : thm
    val EVENTUALLY_WITHIN : thm
    val EVENTUALLY_WITHIN_INTERIOR : thm
    val EVENTUALLY_WITHIN_LE : thm
    val EXCHANGE_LEMMA : thm
    val EXISTS_COMPONENT_SUPERSET : thm
    val EXISTS_DIFF : thm
    val EXISTS_FINITE_SUBSET_IMAGE : thm
    val EXISTS_IN_GSPEC : thm
    val EXISTS_IN_INSERT : thm
    val EXTENSION_FROM_CLOPEN : thm
    val FINITE_BALL : thm
    val FINITE_CBALL : thm
    val FINITE_IMP_BOUNDED : thm
    val FINITE_IMP_CLOSED : thm
    val FINITE_IMP_CLOSED_IN : thm
    val FINITE_IMP_COMPACT : thm
    val FINITE_IMP_NOT_OPEN : thm
    val FINITE_INTERVAL : thm
    val FINITE_INTER_NUMSEG : thm
    val FINITE_POWERSET : thm
    val FINITE_SET_AVOID : thm
    val FINITE_SPHERE : thm
    val FINITE_SUBSET_IMAGE : thm
    val FORALL_EVENTUALLY : thm
    val FORALL_FINITE_SUBSET_IMAGE : thm
    val FORALL_IN_CLOSURE : thm
    val FORALL_IN_CLOSURE_EQ : thm
    val FORALL_IN_GSPEC : thm
    val FORALL_POS_MONO : thm
    val FORALL_POS_MONO_1 : thm
    val FORALL_SUC : thm
    val FROM_INTER_NUMSEG : thm
    val FROM_INTER_NUMSEG_GEN : thm
    val FROM_INTER_NUMSEG_MAX : thm
    val FRONTIER_BALL : thm
    val FRONTIER_CBALL : thm
    val FRONTIER_CLOSED : thm
    val FRONTIER_CLOSED_INTERVAL : thm
    val FRONTIER_CLOSURES : thm
    val FRONTIER_CLOSURE_SUBSET : thm
    val FRONTIER_COMPLEMENT : thm
    val FRONTIER_DISJOINT_EQ : thm
    val FRONTIER_EMPTY : thm
    val FRONTIER_FRONTIER : thm
    val FRONTIER_FRONTIER_FRONTIER : thm
    val FRONTIER_FRONTIER_SUBSET : thm
    val FRONTIER_HALFSPACE_GE : thm
    val FRONTIER_HALFSPACE_GT : thm
    val FRONTIER_HALFSPACE_LE : thm
    val FRONTIER_HALFSPACE_LT : thm
    val FRONTIER_INTERIORS : thm
    val FRONTIER_INTERIOR_SUBSET : thm
    val FRONTIER_INTER_SUBSET : thm
    val FRONTIER_INTER_SUBSET_INTER : thm
    val FRONTIER_OPEN_INTERVAL : thm
    val FRONTIER_SING : thm
    val FRONTIER_STRADDLE : thm
    val FRONTIER_SUBSET_CLOSED : thm
    val FRONTIER_SUBSET_COMPACT : thm
    val FRONTIER_SUBSET_EQ : thm
    val FRONTIER_UNION : thm
    val FRONTIER_UNION_SUBSET : thm
    val FRONTIER_UNIV : thm
    val FSIGMA_COMPLEMENT : thm
    val FUNCTION_FACTORS_LEFT_GEN : thm
    val FUN_IN_IMAGE : thm
    val GDELTA_COMPLEMENT : thm
    val GREATER_EQ_REFL : thm
    val HAS_SIZE_STDBASIS : thm
    val HAUSDIST_ALT : thm
    val HAUSDIST_CLOSURE : thm
    val HAUSDIST_COMPACT_EXISTS : thm
    val HAUSDIST_COMPACT_NONTRIVIAL : thm
    val HAUSDIST_COMPACT_SUMS : thm
    val HAUSDIST_EMPTY : thm
    val HAUSDIST_EQ : thm
    val HAUSDIST_EQ_0 : thm
    val HAUSDIST_INSERT_LE : thm
    val HAUSDIST_LINEAR_IMAGE : thm
    val HAUSDIST_NONTRIVIAL : thm
    val HAUSDIST_NONTRIVIAL_ALT : thm
    val HAUSDIST_POS_LE : thm
    val HAUSDIST_REFL : thm
    val HAUSDIST_SETDIST_TRIANGLE : thm
    val HAUSDIST_SINGS : thm
    val HAUSDIST_SYM : thm
    val HAUSDIST_TRANS : thm
    val HAUSDIST_TRANSLATION : thm
    val HAUSDIST_TRIANGLE : thm
    val HAUSDIST_UNION_LE : thm
    val HEINE_BOREL_IMP_BOLZANO_WEIERSTRASS : thm
    val HEINE_BOREL_LEMMA : thm
    val HOMEOMORPHIC_AFFINITY : thm
    val HOMEOMORPHIC_BALLS : thm
    val HOMEOMORPHIC_BALLS_CBALL_SPHERE : thm
    val HOMEOMORPHIC_CBALL : thm
    val HOMEOMORPHIC_COMPACT : thm
    val HOMEOMORPHIC_COMPACTNESS : thm
    val HOMEOMORPHIC_CONNECTEDNESS : thm
    val HOMEOMORPHIC_EMPTY : thm
    val HOMEOMORPHIC_FINITE : thm
    val HOMEOMORPHIC_FINITENESS : thm
    val HOMEOMORPHIC_FINITE_STRONG : thm
    val HOMEOMORPHIC_HYPERPLANES : thm
    val HOMEOMORPHIC_HYPERPLANE_STANDARD_HYPERPLANE : thm
    val HOMEOMORPHIC_IMP_CARD_EQ : thm
    val HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_LEFT_EQ : thm
    val HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_RIGHT_EQ : thm
    val HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_SELF : thm
    val HOMEOMORPHIC_LOCALLY : thm
    val HOMEOMORPHIC_LOCAL_COMPACTNESS : thm
    val HOMEOMORPHIC_MINIMAL : thm
    val HOMEOMORPHIC_ONE_POINT_COMPACTIFICATIONS : thm
    val HOMEOMORPHIC_OPEN_INTERVALS : thm
    val HOMEOMORPHIC_OPEN_INTERVAL_UNIV : thm
    val HOMEOMORPHIC_REFL : thm
    val HOMEOMORPHIC_SCALING : thm
    val HOMEOMORPHIC_SCALING_LEFT : thm
    val HOMEOMORPHIC_SCALING_RIGHT : thm
    val HOMEOMORPHIC_SING : thm
    val HOMEOMORPHIC_SPHERE : thm
    val HOMEOMORPHIC_STANDARD_HYPERPLANE_HYPERPLANE : thm
    val HOMEOMORPHIC_SYM : thm
    val HOMEOMORPHIC_TRANS : thm
    val HOMEOMORPHIC_TRANSLATION : thm
    val HOMEOMORPHIC_TRANSLATION_LEFT_EQ : thm
    val HOMEOMORPHIC_TRANSLATION_RIGHT_EQ : thm
    val HOMEOMORPHIC_TRANSLATION_SELF : thm
    val HOMEOMORPHISM : thm
    val HOMEOMORPHISM_COMPACT : thm
    val HOMEOMORPHISM_COMPOSE : thm
    val HOMEOMORPHISM_FROM_COMPOSITION_INJECTIVE : thm
    val HOMEOMORPHISM_FROM_COMPOSITION_SURJECTIVE : thm
    val HOMEOMORPHISM_ID : thm
    val HOMEOMORPHISM_IMP_CLOSED_MAP : thm
    val HOMEOMORPHISM_IMP_OPEN_MAP : thm
    val HOMEOMORPHISM_IMP_QUOTIENT_MAP : thm
    val HOMEOMORPHISM_INJECTIVE_CLOSED_MAP : thm
    val HOMEOMORPHISM_INJECTIVE_CLOSED_MAP_EQ : thm
    val HOMEOMORPHISM_INJECTIVE_OPEN_MAP : thm
    val HOMEOMORPHISM_INJECTIVE_OPEN_MAP_EQ : thm
    val HOMEOMORPHISM_LOCALLY : thm
    val HOMEOMORPHISM_OF_SUBSETS : thm
    val HOMEOMORPHISM_SYM : thm
    val IMAGE_AFFINITY_INTERVAL : thm
    val IMAGE_CLOSURE_SUBSET : thm
    val IMAGE_SING : thm
    val IMAGE_STRETCH_INTERVAL : thm
    val IMAGE_TWIZZLE_INTERVAL : thm
    val INDEPENDENT_BOUND : thm
    val INDEPENDENT_CARD_LE_DIM : thm
    val INDEPENDENT_EMPTY : thm
    val INDEPENDENT_INJECTIVE_IMAGE : thm
    val INDEPENDENT_INJECTIVE_IMAGE_GEN : thm
    val INDEPENDENT_INSERT : thm
    val INDEPENDENT_MONO : thm
    val INDEPENDENT_NONZERO : thm
    val INDEPENDENT_SING : thm
    val INDEPENDENT_SPAN_BOUND : thm
    val INDEPENDENT_STDBASIS : thm
    val INFINITE_FROM : thm
    val INFINITE_OPEN_IN : thm
    val INFINITE_SUPERSET : thm
    val INFSUM_0 : thm
    val INFSUM_ADD : thm
    val INFSUM_CMUL : thm
    val INFSUM_EQ : thm
    val INFSUM_LINEAR : thm
    val INFSUM_NEG : thm
    val INFSUM_RESTRICT : thm
    val INFSUM_SUB : thm
    val INFSUM_UNIQUE : thm
    val INF_FINITE : thm
    val INF_FINITE_LEMMA : thm
    val INF_INSERT : thm
    val INJECTIVE_IMP_ISOMETRIC : thm
    val INJECTIVE_MAP_OPEN_IFF_CLOSED : thm
    val INTERIOR_BALL : thm
    val INTERIOR_BIGINTER_SUBSET : thm
    val INTERIOR_BIJECTIVE_LINEAR_IMAGE : thm
    val INTERIOR_CBALL : thm
    val INTERIOR_CLOSED_EQ_EMPTY_AS_FRONTIER : thm
    val INTERIOR_CLOSED_INTERVAL : thm
    val INTERIOR_CLOSED_UNION_EMPTY_INTERIOR : thm
    val INTERIOR_CLOSURE : thm
    val INTERIOR_CLOSURE_IDEMP : thm
    val INTERIOR_CLOSURE_INTER_OPEN : thm
    val INTERIOR_COMPLEMENT : thm
    val INTERIOR_DIFF : thm
    val INTERIOR_EMPTY : thm
    val INTERIOR_EQ : thm
    val INTERIOR_EQ_EMPTY : thm
    val INTERIOR_EQ_EMPTY_ALT : thm
    val INTERIOR_FINITE_BIGINTER : thm
    val INTERIOR_FRONTIER : thm
    val INTERIOR_FRONTIER_EMPTY : thm
    val INTERIOR_HALFSPACE_COMPONENT_GE : thm
    val INTERIOR_HALFSPACE_COMPONENT_LE : thm
    val INTERIOR_HALFSPACE_GE : thm
    val INTERIOR_HALFSPACE_LE : thm
    val INTERIOR_HYPERPLANE : thm
    val INTERIOR_IMAGE_SUBSET : thm
    val INTERIOR_INJECTIVE_LINEAR_IMAGE : thm
    val INTERIOR_INTER : thm
    val INTERIOR_INTERIOR : thm
    val INTERIOR_INTERVAL : thm
    val INTERIOR_LIMIT_POINT : thm
    val INTERIOR_MAXIMAL : thm
    val INTERIOR_MAXIMAL_EQ : thm
    val INTERIOR_NEGATIONS : thm
    val INTERIOR_OPEN : thm
    val INTERIOR_SING : thm
    val INTERIOR_STANDARD_HYPERPLANE : thm
    val INTERIOR_SUBSET : thm
    val INTERIOR_TRANSLATION : thm
    val INTERIOR_UNIONS_OPEN_SUBSETS : thm
    val INTERIOR_UNION_EQ_EMPTY : thm
    val INTERIOR_UNIQUE : thm
    val INTERIOR_UNIV : thm
    val INTERVAL : thm
    val INTERVAL_CASES : thm
    val INTERVAL_CONTAINS_COMPACT_NEIGHBOURHOOD : thm
    val INTERVAL_EQ_EMPTY : thm
    val INTERVAL_IMAGE_STRETCH_INTERVAL : thm
    val INTERVAL_NE_EMPTY : thm
    val INTERVAL_OPEN_SUBSET_CLOSED : thm
    val INTERVAL_SING : thm
    val INTERVAL_SUBSET_IS_INTERVAL : thm
    val INTERVAL_TRANSLATION : thm
    val INTER_BALLS_EQ_EMPTY : thm
    val INTER_BIGUNION : thm
    val INTER_INTERVAL : thm
    val INTER_INTERVAL_MIXED_EQ_EMPTY : thm
    val IN_BALL : thm
    val IN_BALL_0 : thm
    val IN_CBALL : thm
    val IN_CBALL_0 : thm
    val IN_CLOSURE_DELETE : thm
    val IN_COMPONENTS : thm
    val IN_COMPONENTS_BIGUNION_COMPLEMENT : thm
    val IN_COMPONENTS_CONNECTED : thm
    val IN_COMPONENTS_MAXIMAL : thm
    val IN_COMPONENTS_NONEMPTY : thm
    val IN_COMPONENTS_SELF : thm
    val IN_COMPONENTS_SUBSET : thm
    val IN_DIRECTION : thm
    val IN_INTERIOR : thm
    val IN_INTERIOR_CBALL : thm
    val IN_INTERIOR_LINEAR_IMAGE : thm
    val IN_INTERVAL : thm
    val IN_INTERVAL_REFLECT : thm
    val IN_OPEN_SEGMENT : thm
    val IN_OPEN_SEGMENT_ALT : thm
    val IN_SEGMENT : thm
    val IN_SEGMENT_COMPONENT : thm
    val IN_SPAN_DELETE : thm
    val IN_SPAN_INSERT : thm
    val IN_SPHERE : thm
    val IN_SPHERE_0 : thm
    val ISOMETRY_IMP_EMBEDDING : thm
    val ISOMETRY_IMP_HOMEOMORPHISM_COMPACT : thm
    val ISOMETRY_IMP_OPEN_MAP : thm
    val ISOMETRY_ON_IMP_CONTINUOUS_ON : thm
    val ISTOPLOGY_SUBTOPOLOGY : thm
    val IS_INTERVAL : thm
    val IS_INTERVAL_CASES : thm
    val IS_INTERVAL_COMPACT : thm
    val IS_INTERVAL_EMPTY : thm
    val IS_INTERVAL_IMP_LOCALLY_COMPACT : thm
    val IS_INTERVAL_INTER : thm
    val IS_INTERVAL_INTERVAL : thm
    val IS_INTERVAL_POINTWISE : thm
    val IS_INTERVAL_SCALING : thm
    val IS_INTERVAL_SCALING_EQ : thm
    val IS_INTERVAL_SING : thm
    val IS_INTERVAL_UNIV : thm
    val JOINABLE_COMPONENTS_EQ : thm
    val JOINABLE_CONNECTED_COMPONENT_EQ : thm
    val LAMBDA_PAIR : thm
    val LEBESGUE_COVERING_LEMMA : thm
    val LE_1 : thm
    val LE_ADD : thm
    val LE_ADDR : thm
    val LE_EXISTS : thm
    val LIFT_TO_QUOTIENT_SPACE : thm
    val LIFT_TO_QUOTIENT_SPACE_UNIQUE : thm
    val LIM : thm
    val LIMIT_POINT_FINITE : thm
    val LIMIT_POINT_UNION : thm
    val LIMPT_APPROACHABLE : thm
    val LIMPT_APPROACHABLE_LE : thm
    val LIMPT_BALL : thm
    val LIMPT_EMPTY : thm
    val LIMPT_INFINITE_BALL : thm
    val LIMPT_INFINITE_CBALL : thm
    val LIMPT_INFINITE_OPEN : thm
    val LIMPT_INFINITE_OPEN_BALL_CBALL : thm
    val LIMPT_INJECTIVE_LINEAR_IMAGE_EQ : thm
    val LIMPT_INSERT : thm
    val LIMPT_OF_CLOSURE : thm
    val LIMPT_OF_LIMPTS : thm
    val LIMPT_OF_OPEN : thm
    val LIMPT_OF_OPEN_IN : thm
    val LIMPT_OF_SEQUENCE_SUBSEQUENCE : thm
    val LIMPT_OF_UNIV : thm
    val LIMPT_SEQUENTIAL : thm
    val LIMPT_SEQUENTIAL_INJ : thm
    val LIMPT_SING : thm
    val LIMPT_SUBSET : thm
    val LIMPT_UNIV : thm
    val LIM_ABS : thm
    val LIM_ABS_LBOUND : thm
    val LIM_ABS_UBOUND : thm
    val LIM_ADD : thm
    val LIM_AT : thm
    val LIM_AT_ID : thm
    val LIM_AT_INFINITY : thm
    val LIM_AT_INFINITY_POS : thm
    val LIM_AT_LE : thm
    val LIM_AT_NEGINFINITY : thm
    val LIM_AT_POSINFINITY : thm
    val LIM_AT_WITHIN : thm
    val LIM_AT_ZERO : thm
    val LIM_BILINEAR : thm
    val LIM_CASES_COFINITE_SEQUENTIALLY : thm
    val LIM_CASES_FINITE_SEQUENTIALLY : thm
    val LIM_CASES_SEQUENTIALLY : thm
    val LIM_CMUL : thm
    val LIM_CMUL_EQ : thm
    val LIM_COMPONENT : thm
    val LIM_COMPONENT_EQ : thm
    val LIM_COMPONENT_LBOUND : thm
    val LIM_COMPONENT_LE : thm
    val LIM_COMPONENT_UBOUND : thm
    val LIM_COMPOSE_AT : thm
    val LIM_COMPOSE_WITHIN : thm
    val LIM_CONG_AT : thm
    val LIM_CONG_WITHIN : thm
    val LIM_CONST : thm
    val LIM_CONST_EQ : thm
    val LIM_CONTINUOUS_FUNCTION : thm
    val LIM_DROP_LBOUND : thm
    val LIM_DROP_LE : thm
    val LIM_DROP_UBOUND : thm
    val LIM_EVENTUALLY : thm
    val LIM_INFINITY_POSINFINITY : thm
    val LIM_INV : thm
    val LIM_IN_CLOSED_SET : thm
    val LIM_LIFT_DOT : thm
    val LIM_LINEAR : thm
    val LIM_MAX : thm
    val LIM_MIN : thm
    val LIM_MUL : thm
    val LIM_NEG : thm
    val LIM_NEG_EQ : thm
    val LIM_NULL : thm
    val LIM_NULL_ABS : thm
    val LIM_NULL_ADD : thm
    val LIM_NULL_CMUL : thm
    val LIM_NULL_CMUL_BOUNDED : thm
    val LIM_NULL_CMUL_EQ : thm
    val LIM_NULL_COMPARISON : thm
    val LIM_NULL_SUB : thm
    val LIM_NULL_SUM : thm
    val LIM_POSINFINITY_SEQUENTIALLY : thm
    val LIM_SEQUENTIALLY : thm
    val LIM_SUB : thm
    val LIM_SUBSEQUENCE : thm
    val LIM_SUM : thm
    val LIM_TRANSFORM : thm
    val LIM_TRANSFORM_AT : thm
    val LIM_TRANSFORM_AWAY_AT : thm
    val LIM_TRANSFORM_AWAY_WITHIN : thm
    val LIM_TRANSFORM_BOUND : thm
    val LIM_TRANSFORM_EQ : thm
    val LIM_TRANSFORM_EVENTUALLY : thm
    val LIM_TRANSFORM_WITHIN : thm
    val LIM_TRANSFORM_WITHIN_OPEN : thm
    val LIM_TRANSFORM_WITHIN_OPEN_IN : thm
    val LIM_TRANSFORM_WITHIN_SET : thm
    val LIM_TRANSFORM_WITHIN_SET_IMP : thm
    val LIM_UNION : thm
    val LIM_UNION_UNIV : thm
    val LIM_UNIQUE : thm
    val LIM_VMUL : thm
    val LIM_WITHIN : thm
    val LIM_WITHIN_CLOSED_TRIVIAL : thm
    val LIM_WITHIN_EMPTY : thm
    val LIM_WITHIN_ID : thm
    val LIM_WITHIN_INTERIOR : thm
    val LIM_WITHIN_LE : thm
    val LIM_WITHIN_OPEN : thm
    val LIM_WITHIN_SUBSET : thm
    val LIM_WITHIN_UNION : thm
    val LINEAR_0 : thm
    val LINEAR_ADD : thm
    val LINEAR_BOUNDED : thm
    val LINEAR_BOUNDED_POS : thm
    val LINEAR_CMUL : thm
    val LINEAR_COMPOSE : thm
    val LINEAR_COMPOSE_ADD : thm
    val LINEAR_COMPOSE_CMUL : thm
    val LINEAR_COMPOSE_NEG : thm
    val LINEAR_COMPOSE_SUB : thm
    val LINEAR_COMPOSE_SUM : thm
    val LINEAR_CONTINUOUS_AT : thm
    val LINEAR_CONTINUOUS_COMPOSE : thm
    val LINEAR_CONTINUOUS_ON : thm
    val LINEAR_CONTINUOUS_ON_COMPOSE : thm
    val LINEAR_CONTINUOUS_WITHIN : thm
    val LINEAR_EQ : thm
    val LINEAR_EQ_0 : thm
    val LINEAR_EQ_0_SPAN : thm
    val LINEAR_EQ_STDBASIS : thm
    val LINEAR_ID : thm
    val LINEAR_IMAGE_SUBSET_INTERIOR : thm
    val LINEAR_INDEPENDENT_EXTEND : thm
    val LINEAR_INDEPENDENT_EXTEND_LEMMA : thm
    val LINEAR_INJECTIVE_0_SUBSPACE : thm
    val LINEAR_INJECTIVE_BOUNDED_BELOW_POS : thm
    val LINEAR_INJECTIVE_IMP_SURJECTIVE : thm
    val LINEAR_INJECTIVE_LEFT_INVERSE : thm
    val LINEAR_INTERIOR_IMAGE_SUBSET : thm
    val LINEAR_INVERTIBLE_BOUNDED_BELOW : thm
    val LINEAR_INVERTIBLE_BOUNDED_BELOW_POS : thm
    val LINEAR_LIM_0 : thm
    val LINEAR_MUL_COMPONENT : thm
    val LINEAR_NEG : thm
    val LINEAR_NEGATION : thm
    val LINEAR_OPEN_MAPPING : thm
    val LINEAR_SCALING : thm
    val LINEAR_SUB : thm
    val LINEAR_SUM : thm
    val LINEAR_SUM_MUL : thm
    val LINEAR_UNIFORMLY_CONTINUOUS_ON : thm
    val LINEAR_ZERO : thm
    val LOCALLY_CLOSED : thm
    val LOCALLY_COMPACT : thm
    val LOCALLY_COMPACT_ALT : thm
    val LOCALLY_COMPACT_CLOSED_IN : thm
    val LOCALLY_COMPACT_CLOSED_INTER_OPEN : thm
    val LOCALLY_COMPACT_CLOSED_IN_OPEN : thm
    val LOCALLY_COMPACT_CLOSED_UNION : thm
    val LOCALLY_COMPACT_COMPACT : thm
    val LOCALLY_COMPACT_COMPACT_ALT : thm
    val LOCALLY_COMPACT_COMPACT_SUBOPEN : thm
    val LOCALLY_COMPACT_DELETE : thm
    val LOCALLY_COMPACT_INTER : thm
    val LOCALLY_COMPACT_INTER_CBALL : thm
    val LOCALLY_COMPACT_INTER_CBALLS : thm
    val LOCALLY_COMPACT_OPEN_IN : thm
    val LOCALLY_COMPACT_OPEN_INTER_CLOSURE : thm
    val LOCALLY_COMPACT_OPEN_UNION : thm
    val LOCALLY_COMPACT_PROPER_IMAGE : thm
    val LOCALLY_COMPACT_PROPER_IMAGE_EQ : thm
    val LOCALLY_COMPACT_TRANSLATION_EQ : thm
    val LOCALLY_COMPACT_UNIV : thm
    val LOCALLY_DIFF_CLOSED : thm
    val LOCALLY_EMPTY : thm
    val LOCALLY_INJECTIVE_LINEAR_IMAGE : thm
    val LOCALLY_INTER : thm
    val LOCALLY_MONO : thm
    val LOCALLY_OPEN_MAP_IMAGE : thm
    val LOCALLY_OPEN_SUBSET : thm
    val LOCALLY_SING : thm
    val LOCALLY_TRANSLATION : thm
    val LOWER_HEMICONTINUOUS : thm
    val LT_EXISTS : thm
    val LT_NZ : thm
    val MAPPING_CONNECTED_ONTO_SEGMENT : thm
    val MAXIMAL_INDEPENDENT_SUBSET : thm
    val MAXIMAL_INDEPENDENT_SUBSET_EXTEND : thm
    val MIDPOINT_COLLINEAR : thm
    val MIDPOINT_EQ_ENDPOINT : thm
    val MIDPOINT_IN_SEGMENT : thm
    val MIDPOINT_LINEAR_IMAGE : thm
    val MIDPOINT_REFL : thm
    val MIDPOINT_SYM : thm
    val MONOTONE_BIGGER : thm
    val MONOTONE_SUBSEQUENCE : thm
    val MUL_CAUCHY_SCHWARZ_EQUAL : thm
    val MUMFORD_LEMMA : thm
    val NEGATIONS_BALL : thm
    val NEGATIONS_CBALL : thm
    val NEGATIONS_SPHERE : thm
    val NET : thm
    val NETLIMIT_AT : thm
    val NETLIMIT_WITHIN : thm
    val NETLIMIT_WITHIN_INTERIOR : thm
    val NET_DILEMMA : thm
    val NONTRIVIAL_LIMIT_WITHIN : thm
    val NOT_BOUNDED_UNIV : thm
    val NOT_EQ : thm
    val NOT_EVENTUALLY : thm
    val NOT_INTERVAL_UNIV : thm
    val NOWHERE_DENSE : thm
    val NOWHERE_DENSE_COUNTABLE_BIGUNION : thm
    val NOWHERE_DENSE_COUNTABLE_BIGUNION_CLOSED : thm
    val NOWHERE_DENSE_UNION : thm
    val NO_LIMIT_POINT_IMP_CLOSED : thm
    val OLDNET : thm
    val OPEN : thm
    val OPEN_AFFINITY : thm
    val OPEN_BALL : thm
    val OPEN_BIGINTER : thm
    val OPEN_BIGUNION : thm
    val OPEN_BIJECTIVE_LINEAR_IMAGE_EQ : thm
    val OPEN_CLOSED : thm
    val OPEN_CLOSED_INTERVAL : thm
    val OPEN_CLOSED_INTERVAL_CONVEX : thm
    val OPEN_CONTAINS_BALL : thm
    val OPEN_CONTAINS_BALL_EQ : thm
    val OPEN_CONTAINS_CBALL : thm
    val OPEN_CONTAINS_CBALL_EQ : thm
    val OPEN_CONTAINS_INTERVAL : thm
    val OPEN_CONTAINS_INTERVAL_OPEN_INTERVAL : thm
    val OPEN_CONTAINS_OPEN_INTERVAL : thm
    val OPEN_DELETE : thm
    val OPEN_DIFF : thm
    val OPEN_EMPTY : thm
    val OPEN_EXISTS : thm
    val OPEN_EXISTS_IN : thm
    val OPEN_HALFSPACE_COMPONENT_GT : thm
    val OPEN_HALFSPACE_COMPONENT_LT : thm
    val OPEN_HALFSPACE_GT : thm
    val OPEN_HALFSPACE_LT : thm
    val OPEN_IMP_INFINITE : thm
    val OPEN_IMP_LOCALLY_COMPACT : thm
    val OPEN_IN : thm
    val OPEN_INTER : thm
    val OPEN_INTERIOR : thm
    val OPEN_INTERVAL : thm
    val OPEN_INTERVAL_EQ : thm
    val OPEN_INTERVAL_LEFT : thm
    val OPEN_INTERVAL_LEMMA : thm
    val OPEN_INTERVAL_MIDPOINT : thm
    val OPEN_INTERVAL_RIGHT : thm
    val OPEN_INTER_CLOSURE_EQ_EMPTY : thm
    val OPEN_INTER_CLOSURE_SUBSET : thm
    val OPEN_IN_CONNECTED_COMPONENT : thm
    val OPEN_IN_CONTAINS_BALL : thm
    val OPEN_IN_CONTAINS_CBALL : thm
    val OPEN_IN_DELETE : thm
    val OPEN_IN_IMP_SUBSET : thm
    val OPEN_IN_INTER_OPEN : thm
    val OPEN_IN_LOCALLY_COMPACT : thm
    val OPEN_IN_OPEN : thm
    val OPEN_IN_OPEN_EQ : thm
    val OPEN_IN_OPEN_INTER : thm
    val OPEN_IN_OPEN_TRANS : thm
    val OPEN_IN_REFL : thm
    val OPEN_IN_SING : thm
    val OPEN_IN_SUBSET_TRANS : thm
    val OPEN_IN_SUBTOPOLOGY : thm
    val OPEN_IN_SUBTOPOLOGY_EMPTY : thm
    val OPEN_IN_SUBTOPOLOGY_INTER_SUBSET : thm
    val OPEN_IN_SUBTOPOLOGY_REFL : thm
    val OPEN_IN_SUBTOPOLOGY_UNION : thm
    val OPEN_IN_TRANS : thm
    val OPEN_IN_TRANS_EQ : thm
    val OPEN_MAP_CLOSED_SUPERSET_PREIMAGE : thm
    val OPEN_MAP_CLOSED_SUPERSET_PREIMAGE_EQ : thm
    val OPEN_MAP_FROM_COMPOSITION_INJECTIVE : thm
    val OPEN_MAP_FROM_COMPOSITION_SURJECTIVE : thm
    val OPEN_MAP_IFF_LOWER_HEMICONTINUOUS_PREIMAGE : thm
    val OPEN_MAP_IMP_CLOSED_MAP : thm
    val OPEN_MAP_IMP_QUOTIENT_MAP : thm
    val OPEN_MAP_INTERIORS : thm
    val OPEN_MAP_RESTRICT : thm
    val OPEN_NEGATIONS : thm
    val OPEN_OPEN_IN_TRANS : thm
    val OPEN_POSITIVE_MULTIPLES : thm
    val OPEN_POSITIVE_ORTHANT : thm
    val OPEN_SCALING : thm
    val OPEN_SEGMENT : thm
    val OPEN_SEGMENT_ALT : thm
    val OPEN_SEGMENT_LINEAR_IMAGE : thm
    val OPEN_SUBSET : thm
    val OPEN_SUBSET_INTERIOR : thm
    val OPEN_SUB_OPEN : thm
    val OPEN_SUMS : thm
    val OPEN_SURJECTIVE_LINEAR_IMAGE : thm
    val OPEN_TRANSLATION : thm
    val OPEN_TRANSLATION_EQ : thm
    val OPEN_UNION : thm
    val OPEN_UNION_COMPACT_SUBSETS : thm
    val OPEN_UNIV : thm
    val PAIRWISE_DISJOINT_COMPONENTS : thm
    val PAIRWISE_EMPTY : thm
    val PAIRWISE_IMAGE : thm
    val PAIRWISE_INSERT : thm
    val PAIRWISE_MONO : thm
    val PAIRWISE_SING : thm
    val PARTIAL_SUMS_COMPONENT_LE_INFSUM : thm
    val PARTIAL_SUMS_DROP_LE_INFSUM : thm
    val PASTING_LEMMA : thm
    val PASTING_LEMMA_CLOSED : thm
    val PASTING_LEMMA_EXISTS : thm
    val PASTING_LEMMA_EXISTS_CLOSED : thm
    val PERMUTES_IMAGE : thm
    val PERMUTES_INJECTIVE : thm
    val POWERSET_CLAUSES : thm
    val PROPER_MAP : thm
    val PROPER_MAP_COMPOSE : thm
    val PROPER_MAP_FROM_COMPACT : thm
    val PROPER_MAP_FROM_COMPOSITION_LEFT : thm
    val PROPER_MAP_FROM_COMPOSITION_RIGHT : thm
    val QUASICOMPACT_OPEN_CLOSED : thm
    val QUOTIENT_MAP_CLOSED_MAP_EQ : thm
    val QUOTIENT_MAP_COMPOSE : thm
    val QUOTIENT_MAP_FROM_COMPOSITION : thm
    val QUOTIENT_MAP_FROM_SUBSET : thm
    val QUOTIENT_MAP_IMP_CONTINUOUS_CLOSED : thm
    val QUOTIENT_MAP_IMP_CONTINUOUS_OPEN : thm
    val QUOTIENT_MAP_OPEN_CLOSED : thm
    val QUOTIENT_MAP_OPEN_MAP_EQ : thm
    val QUOTIENT_MAP_RESTRICT : thm
    val REAL_AFFINITY_EQ : thm
    val REAL_AFFINITY_LE : thm
    val REAL_AFFINITY_LT : thm
    val REAL_ARCH_INV : thm
    val REAL_ARCH_POW : thm
    val REAL_ARCH_POW2 : thm
    val REAL_ARCH_POW_INV : thm
    val REAL_ARCH_RDIV_EQ_0 : thm
    val REAL_BOUNDS_LT : thm
    val REAL_CHOOSE_DIST : thm
    val REAL_CHOOSE_SIZE : thm
    val REAL_CONVEX_BOUND_LE : thm
    val REAL_EQ_AFFINITY : thm
    val REAL_EQ_LINV : thm
    val REAL_EQ_RINV : thm
    val REAL_EQ_SQUARE_ABS : thm
    val REAL_HALF : thm
    val REAL_HAUSDIST_LE : thm
    val REAL_HAUSDIST_LE_EQ : thm
    val REAL_HAUSDIST_LE_SUMS : thm
    val REAL_INF_LE_FINITE : thm
    val REAL_INF_LT_FINITE : thm
    val REAL_INV_1_LE : thm
    val REAL_INV_LE_1 : thm
    val REAL_LE_AFFINITY : thm
    val REAL_LE_BETWEEN : thm
    val REAL_LE_HAUSDIST : thm
    val REAL_LE_INF_FINITE : thm
    val REAL_LE_INV2 : thm
    val REAL_LE_LMUL1 : thm
    val REAL_LE_SETDIST : thm
    val REAL_LE_SETDIST_EQ : thm
    val REAL_LE_SQUARE_ABS : thm
    val REAL_LT_AFFINITY : thm
    val REAL_LT_HAUSDIST_POINT_EXISTS : thm
    val REAL_LT_INF_FINITE : thm
    val REAL_LT_INV2 : thm
    val REAL_LT_LCANCEL_IMP : thm
    val REAL_LT_MIN : thm
    val REAL_LT_POW2 : thm
    val REAL_OF_NUM_GE : thm
    val REAL_POW_1_LE : thm
    val REAL_POW_LBOUND : thm
    val REAL_POW_LE_1 : thm
    val REAL_SETDIST_LT_EXISTS : thm
    val REAL_WLOG_LE : thm
    val REAL_WLOG_LT : thm
    val REFLECT_INTERVAL : thm
    val REGULAR_CLOSED_BIGUNION : thm
    val REGULAR_CLOSED_UNION : thm
    val REGULAR_OPEN_INTER : thm
    val SEGMENT : thm
    val SEGMENT_CLOSED_OPEN : thm
    val SEGMENT_OPEN_SUBSET_CLOSED : thm
    val SEGMENT_REFL : thm
    val SEGMENT_SCALAR_MULTIPLE : thm
    val SEGMENT_SYM : thm
    val SEGMENT_TO_CLOSEST_POINT : thm
    val SEGMENT_TO_POINT_EXISTS : thm
    val SEGMENT_TRANSLATION : thm
    val SEPARATE_CLOSED_COMPACT : thm
    val SEPARATE_COMPACT_CLOSED : thm
    val SEPARATE_POINT_CLOSED : thm
    val SEPARATION_CLOSURES : thm
    val SEPARATION_HAUSDORFF : thm
    val SEPARATION_NORMAL : thm
    val SEPARATION_NORMAL_COMPACT : thm
    val SEPARATION_NORMAL_LOCAL : thm
    val SEPARATION_T0 : thm
    val SEPARATION_T1 : thm
    val SEPARATION_T2 : thm
    val SEQUENCE_CAUCHY_WLOG : thm
    val SEQUENCE_INFINITE_LEMMA : thm
    val SEQUENCE_UNIQUE_LIMPT : thm
    val SEQUENTIALLY : thm
    val SEQ_HARMONIC : thm
    val SEQ_HARMONIC_OFFSET : thm
    val SEQ_OFFSET : thm
    val SEQ_OFFSET_NEG : thm
    val SEQ_OFFSET_REV : thm
    val SERIES_0 : thm
    val SERIES_ABSCONV_IMP_CONV : thm
    val SERIES_ADD : thm
    val SERIES_BOUND : thm
    val SERIES_CAUCHY : thm
    val SERIES_CAUCHY_UNIFORM : thm
    val SERIES_CMUL : thm
    val SERIES_COMPARISON : thm
    val SERIES_COMPARISON_BOUND : thm
    val SERIES_COMPARISON_UNIFORM : thm
    val SERIES_COMPONENT : thm
    val SERIES_DIFFS : thm
    val SERIES_DIRICHLET : thm
    val SERIES_DIRICHLET_BILINEAR : thm
    val SERIES_DROP_LE : thm
    val SERIES_DROP_POS : thm
    val SERIES_FINITE : thm
    val SERIES_FINITE_SUPPORT : thm
    val SERIES_FROM : thm
    val SERIES_GOESTOZERO : thm
    val SERIES_INJECTIVE_IMAGE : thm
    val SERIES_INJECTIVE_IMAGE_STRONG : thm
    val SERIES_LINEAR : thm
    val SERIES_NEG : thm
    val SERIES_RATIO : thm
    val SERIES_REARRANGE : thm
    val SERIES_REARRANGE_EQ : thm
    val SERIES_RESTRICT : thm
    val SERIES_SUB : thm
    val SERIES_SUBSET : thm
    val SERIES_SUM : thm
    val SERIES_TERMS_TOZERO : thm
    val SERIES_TRIVIAL : thm
    val SERIES_UNIQUE : thm
    val SETDIST_BALLS : thm
    val SETDIST_CLOSED_COMPACT : thm
    val SETDIST_CLOSEST_POINT : thm
    val SETDIST_CLOSURE : thm
    val SETDIST_COMPACT_CLOSED : thm
    val SETDIST_DIFFERENCES : thm
    val SETDIST_EMPTY : thm
    val SETDIST_EQ_0_BOUNDED : thm
    val SETDIST_EQ_0_CLOSED : thm
    val SETDIST_EQ_0_CLOSED_COMPACT : thm
    val SETDIST_EQ_0_CLOSED_IN : thm
    val SETDIST_EQ_0_COMPACT_CLOSED : thm
    val SETDIST_EQ_0_SING : thm
    val SETDIST_FRONTIER : thm
    val SETDIST_FRONTIERS : thm
    val SETDIST_HAUSDIST_TRIANGLE : thm
    val SETDIST_LE_DIST : thm
    val SETDIST_LE_HAUSDIST : thm
    val SETDIST_LE_SING : thm
    val SETDIST_LINEAR_IMAGE : thm
    val SETDIST_LIPSCHITZ : thm
    val SETDIST_POS_LE : thm
    val SETDIST_REFL : thm
    val SETDIST_SINGS : thm
    val SETDIST_SING_FRONTIER : thm
    val SETDIST_SING_FRONTIER_CASES : thm
    val SETDIST_SING_IN_SET : thm
    val SETDIST_SING_LE_HAUSDIST : thm
    val SETDIST_SING_TRIANGLE : thm
    val SETDIST_SUBSETS_EQ : thm
    val SETDIST_SUBSET_LEFT : thm
    val SETDIST_SUBSET_RIGHT : thm
    val SETDIST_SYM : thm
    val SETDIST_TRANSLATION : thm
    val SETDIST_TRIANGLE : thm
    val SETDIST_UNIQUE : thm
    val SETDIST_UNIV : thm
    val SETDIST_ZERO : thm
    val SETDIST_ZERO_STRONG : thm
    val SET_DIFF_FRONTIER : thm
    val SIMPLE_IMAGE_GEN : thm
    val SPANNING_SUBSET_INDEPENDENT : thm
    val SPAN_0 : thm
    val SPAN_ADD : thm
    val SPAN_ADD_EQ : thm
    val SPAN_BREAKDOWN : thm
    val SPAN_BREAKDOWN_EQ : thm
    val SPAN_CARD_GE_DIM : thm
    val SPAN_CLAUSES : thm
    val SPAN_EMPTY : thm
    val SPAN_EQ_SELF : thm
    val SPAN_EXPLICIT : thm
    val SPAN_INC : thm
    val SPAN_INDUCT : thm
    val SPAN_INDUCT_ALT : thm
    val SPAN_LINEAR_IMAGE : thm
    val SPAN_MONO : thm
    val SPAN_MUL : thm
    val SPAN_MUL_EQ : thm
    val SPAN_NEG : thm
    val SPAN_NEG_EQ : thm
    val SPAN_SPAN : thm
    val SPAN_STDBASIS : thm
    val SPAN_SUB : thm
    val SPAN_SUBSET_SUBSPACE : thm
    val SPAN_SUBSPACE : thm
    val SPAN_SUM : thm
    val SPAN_SUPERSET : thm
    val SPAN_TRANS : thm
    val SPAN_UNION : thm
    val SPAN_UNION_SUBSET : thm
    val SPAN_UNIV : thm
    val SPHERE : thm
    val SPHERE_EMPTY : thm
    val SPHERE_EQ_EMPTY : thm
    val SPHERE_EQ_SING : thm
    val SPHERE_LINEAR_IMAGE : thm
    val SPHERE_SING : thm
    val SPHERE_SUBSET_CBALL : thm
    val SPHERE_TRANSLATION : thm
    val SPHERE_UNION_BALL : thm
    val SUBORDINATE_PARTITION_OF_UNITY : thm
    val SUBSET_ANTISYM_EQ : thm
    val SUBSET_BALL : thm
    val SUBSET_BALLS : thm
    val SUBSET_BIGUNION : thm
    val SUBSET_CBALL : thm
    val SUBSET_CLOSURE : thm
    val SUBSET_IMAGE : thm
    val SUBSET_INTERIOR : thm
    val SUBSET_INTERIOR_EQ : thm
    val SUBSET_INTERVAL : thm
    val SUBSET_INTERVAL_IMP : thm
    val SUBSPACE_0 : thm
    val SUBSPACE_ADD : thm
    val SUBSPACE_BIGINTER : thm
    val SUBSPACE_BOUNDED_EQ_TRIVIAL : thm
    val SUBSPACE_IMP_NONEMPTY : thm
    val SUBSPACE_INTER : thm
    val SUBSPACE_KERNEL : thm
    val SUBSPACE_LINEAR_IMAGE : thm
    val SUBSPACE_LINEAR_PREIMAGE : thm
    val SUBSPACE_MUL : thm
    val SUBSPACE_NEG : thm
    val SUBSPACE_SPAN : thm
    val SUBSPACE_SUB : thm
    val SUBSPACE_SUBSTANDARD : thm
    val SUBSPACE_SUM : thm
    val SUBSPACE_SUMS : thm
    val SUBSPACE_TRANSLATION_SELF : thm
    val SUBSPACE_TRANSLATION_SELF_EQ : thm
    val SUBSPACE_TRIVIAL : thm
    val SUBSPACE_UNION_CHAIN : thm
    val SUBSPACE_UNIV : thm
    val SUBTOPOLOGY_SUPERSET : thm
    val SUBTOPOLOGY_TOPSPACE : thm
    val SUBTOPOLOGY_UNIV : thm
    val SUMMABLE_0 : thm
    val SUMMABLE_ADD : thm
    val SUMMABLE_BILINEAR_PARTIAL_PRE : thm
    val SUMMABLE_CAUCHY : thm
    val SUMMABLE_CMUL : thm
    val SUMMABLE_COMPARISON : thm
    val SUMMABLE_COMPONENT : thm
    val SUMMABLE_EQ : thm
    val SUMMABLE_EQ_COFINITE : thm
    val SUMMABLE_EQ_EVENTUALLY : thm
    val SUMMABLE_FROM_ELSEWHERE : thm
    val SUMMABLE_IFF : thm
    val SUMMABLE_IFF_COFINITE : thm
    val SUMMABLE_IFF_EVENTUALLY : thm
    val SUMMABLE_IMP_BOUNDED : thm
    val SUMMABLE_IMP_SUMS_BOUNDED : thm
    val SUMMABLE_IMP_TOZERO : thm
    val SUMMABLE_LINEAR : thm
    val SUMMABLE_NEG : thm
    val SUMMABLE_REARRANGE : thm
    val SUMMABLE_REINDEX : thm
    val SUMMABLE_RESTRICT : thm
    val SUMMABLE_SUB : thm
    val SUMMABLE_SUBSET : thm
    val SUMMABLE_SUBSET_ABSCONV : thm
    val SUMMABLE_TRIVIAL : thm
    val SUMS_0 : thm
    val SUMS_EQ : thm
    val SUMS_FINITE_DIFF : thm
    val SUMS_FINITE_UNION : thm
    val SUMS_IFF : thm
    val SUMS_INFSUM : thm
    val SUMS_INTERVALS : thm
    val SUMS_LIM : thm
    val SUMS_OFFSET : thm
    val SUMS_OFFSET_REV : thm
    val SUMS_REINDEX : thm
    val SUMS_REINDEX_GEN : thm
    val SUMS_SUMMABLE : thm
    val SUMS_SYM : thm
    val SUM_ABS_TRIANGLE : thm
    val SUM_DIFF_LEMMA : thm
    val SUM_GP : thm
    val SUM_GP_BASIC : thm
    val SUM_GP_MULTIPLIED : thm
    val SUP_INSERT : thm
    val SURJECTIVE_IMAGE_EQ : thm
    val SYMMETRIC_CLOSURE : thm
    val SYMMETRIC_INTERIOR : thm
    val SYMMETRIC_LINEAR_IMAGE : thm
    val TENDSTO_LIM : thm
    val TOPSPACE_EUCLIDEAN : thm
    val TOPSPACE_EUCLIDEAN_SUBTOPOLOGY : thm
    val TOPSPACE_SUBTOPOLOGY : thm
    val TRANSITIVE_STEPWISE_LE : thm
    val TRANSITIVE_STEPWISE_LE_EQ : thm
    val TRANSITIVE_STEPWISE_LT : thm
    val TRANSITIVE_STEPWISE_LT_EQ : thm
    val TRANSLATION_DIFF : thm
    val TRIVIAL_LIMIT_AT : thm
    val TRIVIAL_LIMIT_AT_INFINITY : thm
    val TRIVIAL_LIMIT_AT_NEGINFINITY : thm
    val TRIVIAL_LIMIT_AT_POSINFINITY : thm
    val TRIVIAL_LIMIT_SEQUENTIALLY : thm
    val TRIVIAL_LIMIT_WITHIN : thm
    val UNBOUNDED_HALFSPACE_COMPONENT_GE : thm
    val UNBOUNDED_HALFSPACE_COMPONENT_GT : thm
    val UNBOUNDED_HALFSPACE_COMPONENT_LE : thm
    val UNBOUNDED_HALFSPACE_COMPONENT_LT : thm
    val UNBOUNDED_INTER_COBOUNDED : thm
    val UNCOUNTABLE_EUCLIDEAN : thm
    val UNCOUNTABLE_INTERVAL : thm
    val UNCOUNTABLE_OPEN : thm
    val UNCOUNTABLE_REAL : thm
    val UNIFORMLY_CAUCHY_IMP_UNIFORMLY_CONVERGENT : thm
    val UNIFORMLY_CONTINUOUS_EXTENDS_TO_CLOSURE : thm
    val UNIFORMLY_CONTINUOUS_IMP_CAUCHY_CONTINUOUS : thm
    val UNIFORMLY_CONTINUOUS_IMP_CONTINUOUS : thm
    val UNIFORMLY_CONTINUOUS_ON_ADD : thm
    val UNIFORMLY_CONTINUOUS_ON_CLOSURE : thm
    val UNIFORMLY_CONTINUOUS_ON_CMUL : thm
    val UNIFORMLY_CONTINUOUS_ON_COMPOSE : thm
    val UNIFORMLY_CONTINUOUS_ON_CONST : thm
    val UNIFORMLY_CONTINUOUS_ON_DIST_CLOSEST_POINT : thm
    val UNIFORMLY_CONTINUOUS_ON_EQ : thm
    val UNIFORMLY_CONTINUOUS_ON_ID : thm
    val UNIFORMLY_CONTINUOUS_ON_MUL : thm
    val UNIFORMLY_CONTINUOUS_ON_NEG : thm
    val UNIFORMLY_CONTINUOUS_ON_SEQUENTIALLY : thm
    val UNIFORMLY_CONTINUOUS_ON_SETDIST : thm
    val UNIFORMLY_CONTINUOUS_ON_SUB : thm
    val UNIFORMLY_CONTINUOUS_ON_SUBSET : thm
    val UNIFORMLY_CONTINUOUS_ON_SUM : thm
    val UNIFORMLY_CONTINUOUS_ON_VMUL : thm
    val UNIFORMLY_CONVERGENT_EQ_CAUCHY : thm
    val UNIFORMLY_CONVERGENT_EQ_CAUCHY_ALT : thm
    val UNIFORM_LIM_ADD : thm
    val UNIFORM_LIM_BILINEAR : thm
    val UNIFORM_LIM_SUB : thm
    val UNION_FRONTIER : thm
    val UNION_INTERIOR_SUBSET : thm
    val UNIT_INTERVAL_NONEMPTY : thm
    val UPPER_BOUND_FINITE_SET : thm
    val UPPER_BOUND_FINITE_SET_REAL : thm
    val UPPER_HEMICONTINUOUS : thm
    val UPPER_LOWER_HEMICONTINUOUS : thm
    val UPPER_LOWER_HEMICONTINUOUS_EXPLICIT : thm
    val URYSOHN : thm
    val URYSOHN_LOCAL : thm
    val URYSOHN_LOCAL_STRONG : thm
    val URYSOHN_STRONG : thm
    val WITHIN : thm
    val WITHIN_UNIV : thm
    val WITHIN_WITHIN : thm
    val WLOG_LE : thm
    val WLOG_LT : thm
    val continuous_at : thm
    val continuous_within : thm
    val interval : thm
    val net_tybij : thm
    val open_in : thm
    val segment : thm
  
  val real_topology_grammars : type_grammar.grammar * term_grammar.grammar
(*
   [product] Parent theory of "real_topology"
   
   [CLOSED_interval]  Definition
      
      ⊢ ∀l. interval l = {x | FST (HD l) ≤ x ∧ x ≤ SND (HD l)}
   
   [OPEN_interval]  Definition
      
      ⊢ ∀a b. interval (a,b) = {x | a < x ∧ x < b}
   
   [at]  Definition
      
      ⊢ ∀a. at a = mk_net (λx y. 0 < dist (x,a) ∧ dist (x,a) ≤ dist (y,a))
   
   [at_infinity]  Definition
      
      ⊢ at_infinity = mk_net (λx y. abs x ≥ abs y)
   
   [at_neginfinity]  Definition
      
      ⊢ at_neginfinity = mk_net (λx y. x ≤ y)
   
   [at_posinfinity]  Definition
      
      ⊢ at_posinfinity = mk_net (λx y. x ≥ y)
   
   [ball]  Definition
      
      ⊢ ∀x e. ball (x,e) = {y | dist (x,y) < e}
   
   [between]  Definition
      
      ⊢ ∀x a b. between x (a,b) ⇔ (dist (a,b) = dist (a,x) + dist (x,b))
   
   [bilinear]  Definition
      
      ⊢ ∀f. bilinear f ⇔ (∀x. linear (λy. f x y)) ∧ ∀y. linear (λx. f x y)
   
   [bounded_def]  Definition
      
      ⊢ ∀s. bounded s ⇔ ∃a. ∀x. x ∈ s ⇒ abs x ≤ a
   
   [cauchy]  Definition
      
      ⊢ ∀s.
            cauchy s ⇔
            ∀e. 0 < e ⇒ ∃N. ∀m n. m ≥ N ∧ n ≥ N ⇒ dist (s m,s n) < e
   
   [cball]  Definition
      
      ⊢ ∀x e. cball (x,e) = {y | dist (x,y) ≤ e}
   
   [closed_def]  Definition
      
      ⊢ ∀s. closed s ⇔ open (𝕌(:real) DIFF s)
   
   [closed_segment]  Definition
      
      ⊢ ∀l.
            segment l =
            {(1 − u) * FST (HD l) + u * SND (HD l) | 0 ≤ u ∧ u ≤ 1}
   
   [closest_point]  Definition
      
      ⊢ ∀s a.
            closest_point s a =
            @x. x ∈ s ∧ ∀y. y ∈ s ⇒ dist (a,x) ≤ dist (a,y)
   
   [closure]  Definition
      
      ⊢ ∀s. closure s = s ∪ {x | x limit_point_of s}
   
   [collinear]  Definition
      
      ⊢ ∀s. collinear s ⇔ ∃u. ∀x y. x ∈ s ∧ y ∈ s ⇒ ∃c. x − y = c * u
   
   [compact]  Definition
      
      ⊢ ∀s.
            compact s ⇔
            ∀f.
                (∀n. f n ∈ s) ⇒
                ∃l r.
                    l ∈ s ∧ (∀m n. m < n ⇒ r m < r n) ∧
                    (f ∘ r --> l) sequentially
   
   [complete]  Definition
      
      ⊢ ∀s.
            complete s ⇔
            ∀f.
                (∀n. f n ∈ s) ∧ cauchy f ⇒
                ∃l. l ∈ s ∧ (f --> l) sequentially
   
   [components]  Definition
      
      ⊢ ∀s. components s = {connected_component s x | x | x ∈ s}
   
   [condensation_point_of]  Definition
      
      ⊢ ∀x s.
            x condensation_point_of s ⇔
            ∀t. x ∈ t ∧ open t ⇒ ¬COUNTABLE (s ∩ t)
   
   [connected]  Definition
      
      ⊢ ∀s.
            connected s ⇔
            ¬∃e1 e2.
                open e1 ∧ open e2 ∧ s ⊆ e1 ∪ e2 ∧ (e1 ∩ e2 ∩ s = ∅) ∧
                e1 ∩ s ≠ ∅ ∧ e2 ∩ s ≠ ∅
   
   [connected_component]  Definition
      
      ⊢ ∀s x y.
            connected_component s x y ⇔
            ∃t. connected t ∧ t ⊆ s ∧ x ∈ t ∧ y ∈ t
   
   [continuous]  Definition
      
      ⊢ ∀f net. f continuous net ⇔ (f --> f (netlimit net)) net
   
   [continuous_on]  Definition
      
      ⊢ ∀f s.
            f continuous_on s ⇔
            ∀x.
                x ∈ s ⇒
                ∀e.
                    0 < e ⇒
                    ∃d.
                        0 < d ∧
                        ∀x'. x' ∈ s ∧ dist (x',x) < d ⇒ dist (f x',f x) < e
   
   [dependent]  Definition
      
      ⊢ ∀s. dependent s ⇔ ∃a. a ∈ s ∧ a ∈ span (s DELETE a)
   
   [diameter]  Definition
      
      ⊢ ∀s.
            diameter s =
            if s = ∅ then 0 else sup {abs (x − y) | x ∈ s ∧ y ∈ s}
   
   [dim]  Definition
      
      ⊢ ∀v.
            dim v =
            @n. ∃b. b ⊆ v ∧ independent b ∧ v ⊆ span b ∧ b HAS_SIZE n
   
   [dist]  Definition
      
      ⊢ ∀x y. dist (x,y) = abs (x − y)
   
   [euclidean]  Definition
      
      ⊢ euclidean = topology open
   
   [eventually]  Definition
      
      ⊢ ∀p net.
            eventually p net ⇔
            trivial_limit net ∨
            ∃y. (∃x. netord net x y) ∧ ∀x. netord net x y ⇒ p x
   
   [frontier]  Definition
      
      ⊢ ∀s. frontier s = closure s DIFF interior s
   
   [fsigma]  Definition
      
      ⊢ ∀s.
            fsigma s ⇔
            ∃g. COUNTABLE g ∧ (∀c. c ∈ g ⇒ closed c) ∧ (BIGUNION g = s)
   
   [gdelta]  Definition
      
      ⊢ ∀s.
            gdelta s ⇔
            ∃g. COUNTABLE g ∧ (∀u. u ∈ g ⇒ open u) ∧ (BIGINTER g = s)
   
   [hausdist]  Definition
      
      ⊢ ∀s t.
            hausdist (s,t) =
            if
              {setdist ({x},t) | x ∈ s} ∪ {setdist ({y},s) | y ∈ t} ≠ ∅ ∧
              ∃b.
                  ∀d.
                      d ∈
                      {setdist ({x},t) | x ∈ s} ∪ {setdist ({y},s) | y ∈ t} ⇒
                      d ≤ b
            then
              sup ({setdist ({x},t) | x ∈ s} ∪ {setdist ({y},s) | y ∈ t})
            else 0
   
   [homeomorphic]  Definition
      
      ⊢ ∀s t. s homeomorphic t ⇔ ∃f g. homeomorphism (s,t) (f,g)
   
   [homeomorphism]  Definition
      
      ⊢ ∀s t f g.
            homeomorphism (s,t) (f,g) ⇔
            (∀x. x ∈ s ⇒ (g (f x) = x)) ∧ (IMAGE f s = t) ∧
            f continuous_on s ∧ (∀y. y ∈ t ⇒ (f (g y) = y)) ∧
            (IMAGE g t = s) ∧ g continuous_on t
   
   [in_direction]  Definition
      
      ⊢ ∀a v.
            a in_direction v =
            at a within {b | ∃c. 0 ≤ c ∧ (b − a = c * v)}
   
   [independent]  Definition
      
      ⊢ ∀s. independent s ⇔ ¬dependent s
   
   [infsum]  Definition
      
      ⊢ ∀s f. infsum s f = @l. (f sums l) s
   
   [interior]  Definition
      
      ⊢ ∀s. interior s = {x | ∃t. open t ∧ x ∈ t ∧ t ⊆ s}
   
   [is_interval]  Definition
      
      ⊢ ∀s.
            is_interval s ⇔
            ∀a b x. a ∈ s ∧ b ∈ s ⇒ a ≤ x ∧ x ≤ b ∨ b ≤ x ∧ x ≤ a ⇒ x ∈ s
   
   [isnet]  Definition
      
      ⊢ ∀g. isnet g ⇔ ∀x y. (∀z. g z x ⇒ g z y) ∨ ∀z. g z y ⇒ g z x
   
   [lim_def]  Definition
      
      ⊢ ∀net f. lim net f = @l. (f --> l) net
   
   [limit_point_of]  Definition
      
      ⊢ ∀x s.
            x limit_point_of s ⇔
            ∀t. x ∈ t ∧ open t ⇒ ∃y. y ≠ x ∧ y ∈ s ∧ y ∈ t
   
   [linear]  Definition
      
      ⊢ ∀f.
            linear f ⇔
            (∀x y. f (x + y) = f x + f y) ∧ ∀c x. f (c * x) = c * f x
   
   [locally]  Definition
      
      ⊢ ∀P s.
            locally P s ⇔
            ∀w x.
                open_in (subtopology euclidean s) w ∧ x ∈ w ⇒
                ∃u v.
                    open_in (subtopology euclidean s) u ∧ P v ∧ x ∈ u ∧
                    u ⊆ v ∧ v ⊆ w
   
   [midpoint]  Definition
      
      ⊢ ∀a b. midpoint (a,b) = 2⁻¹ * (a + b)
   
   [net_TY_DEF]  Definition
      
      ⊢ ∃rep. TYPE_DEFINITION isnet rep
   
   [netlimit]  Definition
      
      ⊢ ∀net. netlimit net = @a. ∀x. ¬netord net x a
   
   [open_def]  Definition
      
      ⊢ ∀s. open s ⇔ ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ ∀x'. dist (x',x) < e ⇒ x' ∈ s
   
   [open_segment]  Definition
      
      ⊢ ∀a b. segment (a,b) = segment [(a,b)] DIFF {a; b}
   
   [pairwise]  Definition
      
      ⊢ ∀r s. pairwise r s ⇔ ∀x y. x ∈ s ∧ y ∈ s ∧ x ≠ y ⇒ r x y
   
   [permutes]  Definition
      
      ⊢ ∀p s. p permutes s ⇔ (∀x. x ∉ s ⇒ (p x = x)) ∧ ∀y. ∃!x. p x = y
   
   [sequentially]  Definition
      
      ⊢ sequentially = mk_net (λm n. m ≥ n)
   
   [setdist]  Definition
      
      ⊢ ∀s t.
            setdist (s,t) =
            if (s = ∅) ∨ (t = ∅) then 0
            else inf {dist (x,y) | x ∈ s ∧ y ∈ t}
   
   [span]  Definition
      
      ⊢ ∀s. span s = subspace hull s
   
   [sphere]  Definition
      
      ⊢ ∀x e. sphere (x,e) = {y | dist (x,y) = e}
   
   [subspace]  Definition
      
      ⊢ ∀s.
            subspace s ⇔
            0 ∈ s ∧ (∀x y. x ∈ s ∧ y ∈ s ⇒ x + y ∈ s) ∧
            ∀c x. x ∈ s ⇒ c * x ∈ s
   
   [subtopology]  Definition
      
      ⊢ ∀top u. subtopology top u = topology {s ∩ u | open_in top s}
   
   [summable]  Definition
      
      ⊢ ∀s f. summable s f ⇔ ∃l. (f sums l) s
   
   [sums]  Definition
      
      ⊢ ∀f l s.
            (f sums l) s ⇔ ((λn. sum (s ∩ (0 .. n)) f) --> l) sequentially
   
   [tendsto]  Definition
      
      ⊢ ∀f l net.
            (f --> l) net ⇔
            ∀e. 0 < e ⇒ eventually (λx. dist (f x,l) < e) net
   
   [trivial_limit]  Definition
      
      ⊢ ∀net.
            trivial_limit net ⇔
            (∀a b. a = b) ∨
            ∃a b. a ≠ b ∧ ∀x. ¬netord net x a ∧ ¬netord net x b
   
   [uniformly_continuous_on]  Definition
      
      ⊢ ∀f s.
            f uniformly_continuous_on s ⇔
            ∀e.
                0 < e ⇒
                ∃d.
                    0 < d ∧
                    ∀x x'.
                        x ∈ s ∧ x' ∈ s ∧ dist (x',x) < d ⇒
                        dist (f x',f x) < e
   
   [within]  Definition
      
      ⊢ ∀net s. net within s = mk_net (λx y. netord net x y ∧ x ∈ s)
   
   [ABS_CAUCHY_SCHWARZ_ABS_EQ]  Theorem
      
      ⊢ ∀x y.
            (abs (x * y) = abs x * abs y) ⇔
            (abs x * y = abs y * x) ∨ (abs x * y = -abs y * x)
   
   [ABS_CAUCHY_SCHWARZ_EQ]  Theorem
      
      ⊢ ∀x y. (x * y = abs x * abs y) ⇔ (abs x * y = abs y * x)
   
   [ABS_CAUCHY_SCHWARZ_EQUAL]  Theorem
      
      ⊢ ∀x y. (abs (x * y) = abs x * abs y) ⇔ collinear {0; x; y}
   
   [ABS_LE_0]  Theorem
      
      ⊢ ∀x. abs x ≤ 0 ⇔ (x = 0)
   
   [ABS_SUM_TRIVIAL_LEMMA]  Theorem
      
      ⊢ ∀e.
            0 < e ⇒
            (P ⇒ abs (sum (s ∩ (m .. n)) f) < e ⇔
             P ⇒ n < m ∨ abs (sum (s ∩ (m .. n)) f) < e)
   
   [ABS_TRIANGLE_EQ]  Theorem
      
      ⊢ ∀x y. (abs (x + y) = abs x + abs y) ⇔ (abs x * y = abs y * x)
   
   [ABS_TRIANGLE_LE]  Theorem
      
      ⊢ ∀x y. abs x + abs y ≤ e ⇒ abs (x + y) ≤ e
   
   [ADD_SUB2]  Theorem
      
      ⊢ ∀m n. m + n − m = n
   
   [ADD_SUBR]  Theorem
      
      ⊢ ∀m n. n − (m + n) = 0
   
   [ADD_SUBR2]  Theorem
      
      ⊢ ∀m n. m − (m + n) = 0
   
   [AFFINITY_INVERSES]  Theorem
      
      ⊢ ∀m c.
            m ≠ 0 ⇒
            ((λx. m * x + c) ∘ (λx. m⁻¹ * x + -(m⁻¹ * c)) = (λx. x)) ∧
            ((λx. m⁻¹ * x + -(m⁻¹ * c)) ∘ (λx. m * x + c) = (λx. x))
   
   [ALWAYS_EVENTUALLY]  Theorem
      
      ⊢ (∀x. p x) ⇒ eventually p net
   
   [APPROACHABLE_LT_LE]  Theorem
      
      ⊢ ∀P f.
            (∃d. 0 < d ∧ ∀x. f x < d ⇒ P x) ⇔ ∃d. 0 < d ∧ ∀x. f x ≤ d ⇒ P x
   
   [AT]  Theorem
      
      ⊢ ∀a x y.
            netord (at a) x y ⇔ 0 < dist (x,a) ∧ dist (x,a) ≤ dist (y,a)
   
   [AT_INFINITY]  Theorem
      
      ⊢ ∀x y. netord at_infinity x y ⇔ abs x ≥ abs y
   
   [AT_NEGINFINITY]  Theorem
      
      ⊢ ∀x y. netord at_neginfinity x y ⇔ x ≤ y
   
   [AT_POSINFINITY]  Theorem
      
      ⊢ ∀x y. netord at_posinfinity x y ⇔ x ≥ y
   
   [BAIRE]  Theorem
      
      ⊢ ∀g s.
            locally compact s ∧ COUNTABLE g ∧
            (∀t.
                 t ∈ g ⇒
                 open_in (subtopology euclidean s) t ∧ s ⊆ closure t) ⇒
            s ⊆ closure (BIGINTER g)
   
   [BAIRE_ALT]  Theorem
      
      ⊢ ∀g s.
            locally compact s ∧ s ≠ ∅ ∧ COUNTABLE g ∧ (BIGUNION g = s) ⇒
            ∃t u.
                t ∈ g ∧ open_in (subtopology euclidean s) u ∧ u ⊆ closure t
   
   [BALL]  Theorem
      
      ⊢ ∀x r.
            (cball (x,r) = interval [(x − r,x + r)]) ∧
            (ball (x,r) = interval (x − r,x + r))
   
   [BALL_EMPTY]  Theorem
      
      ⊢ ∀x e. e ≤ 0 ⇒ (ball (x,e) = ∅)
   
   [BALL_EQ_EMPTY]  Theorem
      
      ⊢ ∀x e. (ball (x,e) = ∅) ⇔ e ≤ 0
   
   [BALL_INTERVAL]  Theorem
      
      ⊢ ∀x e. ball (x,e) = interval (x − e,x + e)
   
   [BALL_INTERVAL_0]  Theorem
      
      ⊢ ∀e. ball (0,e) = interval (-e,e)
   
   [BALL_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f x r.
            linear f ∧ (∀y. ∃x. f x = y) ∧ (∀x. abs (f x) = abs x) ⇒
            (ball (f x,r) = IMAGE f (ball (x,r)))
   
   [BALL_MAX_UNION]  Theorem
      
      ⊢ ∀a r s. ball (a,max r s) = ball (a,r) ∪ ball (a,s)
   
   [BALL_MIN_INTER]  Theorem
      
      ⊢ ∀a r s. ball (a,min r s) = ball (a,r) ∩ ball (a,s)
   
   [BALL_SCALING]  Theorem
      
      ⊢ ∀c.
            0 < c ⇒
            ∀x r. ball (c * x,c * r) = IMAGE (λx. c * x) (ball (x,r))
   
   [BALL_SUBSET_CBALL]  Theorem
      
      ⊢ ∀x e. ball (x,e) ⊆ cball (x,e)
   
   [BALL_TRANSLATION]  Theorem
      
      ⊢ ∀a x r. ball (a + x,r) = IMAGE (λy. a + y) (ball (x,r))
   
   [BALL_TRIVIAL]  Theorem
      
      ⊢ ∀x. ball (x,0) = ∅
   
   [BALL_UNION_SPHERE]  Theorem
      
      ⊢ ∀a r. ball (a,r) ∪ sphere (a,r) = cball (a,r)
   
   [BANACH_FIX]  Theorem
      
      ⊢ ∀f s c.
            complete s ∧ s ≠ ∅ ∧ 0 ≤ c ∧ c < 1 ∧ IMAGE f s ⊆ s ∧
            (∀x y. x ∈ s ∧ y ∈ s ⇒ dist (f x,f y) ≤ c * dist (x,y)) ⇒
            ∃!x. x ∈ s ∧ (f x = x)
   
   [BASIS_CARD_EQ_DIM]  Theorem
      
      ⊢ ∀v b.
            b ⊆ v ∧ v ⊆ span b ∧ independent b ⇒
            FINITE b ∧ (CARD b = dim v)
   
   [BASIS_EXISTS]  Theorem
      
      ⊢ ∀v. ∃b. b ⊆ v ∧ independent b ∧ v ⊆ span b ∧ b HAS_SIZE dim v
   
   [BASIS_HAS_SIZE_DIM]  Theorem
      
      ⊢ ∀v b. independent b ∧ (span b = v) ⇒ b HAS_SIZE dim v
   
   [BETWEEN_ABS]  Theorem
      
      ⊢ ∀a b x.
            between x (a,b) ⇔
            (abs (x − a) * (b − x) = abs (b − x) * (x − a))
   
   [BETWEEN_ANTISYM]  Theorem
      
      ⊢ ∀a b c. between a (b,c) ∧ between b (a,c) ⇒ (a = b)
   
   [BETWEEN_IMP_COLLINEAR]  Theorem
      
      ⊢ ∀a b x. between x (a,b) ⇒ collinear {a; x; b}
   
   [BETWEEN_IN_SEGMENT]  Theorem
      
      ⊢ ∀x a b. between x (a,b) ⇔ x ∈ segment [(a,b)]
   
   [BETWEEN_MIDPOINT]  Theorem
      
      ⊢ ∀a b.
            between (midpoint (a,b)) (a,b) ∧ between (midpoint (a,b)) (b,a)
   
   [BETWEEN_REFL]  Theorem
      
      ⊢ ∀a b. between a (a,b) ∧ between b (a,b) ∧ between a (a,a)
   
   [BETWEEN_REFL_EQ]  Theorem
      
      ⊢ ∀a x. between x (a,a) ⇔ (x = a)
   
   [BETWEEN_SYM]  Theorem
      
      ⊢ ∀a b x. between x (a,b) ⇔ between x (b,a)
   
   [BETWEEN_TRANS]  Theorem
      
      ⊢ ∀a b c d. between a (b,c) ∧ between d (a,c) ⇒ between d (b,c)
   
   [BETWEEN_TRANS_2]  Theorem
      
      ⊢ ∀a b c d. between a (b,c) ∧ between d (a,b) ⇒ between a (c,d)
   
   [BIGINTER_BIGUNION]  Theorem
      
      ⊢ ∀s. BIGINTER s = 𝕌(:α) DIFF BIGUNION {𝕌(:α) DIFF t | t ∈ s}
   
   [BIGINTER_GSPEC]  Theorem
      
      ⊢ (∀P f. BIGINTER {f x | P x} = {a | ∀x. P x ⇒ a ∈ f x}) ∧
        (∀P f. BIGINTER {f x y | P x y} = {a | ∀x y. P x y ⇒ a ∈ f x y}) ∧
        ∀P f.
            BIGINTER {f x y z | P x y z} =
            {a | ∀x y z. P x y z ⇒ a ∈ f x y z}
   
   [BIGINTER_IMAGE]  Theorem
      
      ⊢ ∀f s. BIGINTER (IMAGE f s) = {y | ∀x. x ∈ s ⇒ y ∈ f x}
   
   [BIGUNION_BIGINTER]  Theorem
      
      ⊢ ∀s. BIGUNION s = 𝕌(:α) DIFF BIGINTER {𝕌(:α) DIFF t | t ∈ s}
   
   [BIGUNION_COMPONENTS]  Theorem
      
      ⊢ ∀u. u = BIGUNION (components u)
   
   [BIGUNION_CONNECTED_COMPONENT]  Theorem
      
      ⊢ ∀s. BIGUNION {connected_component s x | x | x ∈ s} = s
   
   [BIGUNION_DIFF]  Theorem
      
      ⊢ ∀s t. BIGUNION s DIFF t = BIGUNION {x DIFF t | x ∈ s}
   
   [BIGUNION_GSPEC]  Theorem
      
      ⊢ (∀P f. BIGUNION {f x | P x} = {a | ∃x. P x ∧ a ∈ f x}) ∧
        (∀P f. BIGUNION {f x y | P x y} = {a | ∃x y. P x y ∧ a ∈ f x y}) ∧
        ∀P f.
            BIGUNION {f x y z | P x y z} =
            {a | ∃x y z. P x y z ∧ a ∈ f x y z}
   
   [BIGUNION_IMAGE]  Theorem
      
      ⊢ ∀f s. BIGUNION (IMAGE f s) = {y | ∃x. x ∈ s ∧ y ∈ f x}
   
   [BIGUNION_MONO]  Theorem
      
      ⊢ (∀x. x ∈ s ⇒ ∃y. y ∈ t ∧ x ⊆ y) ⇒ BIGUNION s ⊆ BIGUNION t
   
   [BIGUNION_MONO_IMAGE]  Theorem
      
      ⊢ (∀x. x ∈ s ⇒ f x ⊆ g x) ⇒
        BIGUNION (IMAGE f s) ⊆ BIGUNION (IMAGE g s)
   
   [BILINEAR_BOUNDED]  Theorem
      
      ⊢ ∀h. bilinear h ⇒ ∃B. ∀x y. abs (h x y) ≤ B * abs x * abs y
   
   [BILINEAR_BOUNDED_POS]  Theorem
      
      ⊢ ∀h. bilinear h ⇒ ∃B. 0 < B ∧ ∀x y. abs (h x y) ≤ B * abs x * abs y
   
   [BILINEAR_CONTINUOUS_COMPOSE]  Theorem
      
      ⊢ ∀net f g h.
            f continuous net ∧ g continuous net ∧ bilinear h ⇒
            (λx. h (f x) (g x)) continuous net
   
   [BILINEAR_CONTINUOUS_ON_COMPOSE]  Theorem
      
      ⊢ ∀f g h s.
            f continuous_on s ∧ g continuous_on s ∧ bilinear h ⇒
            (λx. h (f x) (g x)) continuous_on s
   
   [BILINEAR_DOT]  Theorem
      
      ⊢ bilinear (λx y. x * y)
   
   [BILINEAR_LADD]  Theorem
      
      ⊢ ∀h x y z. bilinear h ⇒ (h (x + y) z = h x z + h y z)
   
   [BILINEAR_LMUL]  Theorem
      
      ⊢ ∀h c x y. bilinear h ⇒ (h (c * x) y = c * h x y)
   
   [BILINEAR_LNEG]  Theorem
      
      ⊢ ∀h x y. bilinear h ⇒ (h (-x) y = -h x y)
   
   [BILINEAR_LSUB]  Theorem
      
      ⊢ ∀h x y z. bilinear h ⇒ (h (x − y) z = h x z − h y z)
   
   [BILINEAR_LZERO]  Theorem
      
      ⊢ ∀h x. bilinear h ⇒ (h 0 x = 0)
   
   [BILINEAR_RADD]  Theorem
      
      ⊢ ∀h x y z. bilinear h ⇒ (h x (y + z) = h x y + h x z)
   
   [BILINEAR_RMUL]  Theorem
      
      ⊢ ∀h c x y. bilinear h ⇒ (h x (c * y) = c * h x y)
   
   [BILINEAR_RNEG]  Theorem
      
      ⊢ ∀h x y. bilinear h ⇒ (h x (-y) = -h x y)
   
   [BILINEAR_RSUB]  Theorem
      
      ⊢ ∀h x y z. bilinear h ⇒ (h x (y − z) = h x y − h x z)
   
   [BILINEAR_RZERO]  Theorem
      
      ⊢ ∀h x. bilinear h ⇒ (h x 0 = 0)
   
   [BILINEAR_SUM]  Theorem
      
      ⊢ ∀h.
            bilinear h ∧ FINITE s ∧ FINITE t ⇒
            (h (sum s f) (sum t g) = sum (s × t) (λ(i,j). h (f i) (g j)))
   
   [BILINEAR_SUM_PARTIAL_PRE]  Theorem
      
      ⊢ ∀f g h m n.
            bilinear h ⇒
            (sum (m .. n) (λk. h (f k) (g k − g (k − 1))) =
             if m ≤ n then
               h (f (n + 1)) (g n) − h (f m) (g (m − 1)) −
               sum (m .. n) (λk. h (f (k + 1) − f k) (g k))
             else 0)
   
   [BILINEAR_SUM_PARTIAL_SUC]  Theorem
      
      ⊢ ∀f g h m n.
            bilinear h ⇒
            (sum (m .. n) (λk. h (f k) (g (k + 1) − g k)) =
             if m ≤ n then
               h (f (n + 1)) (g (n + 1)) − h (f m) (g m) −
               sum (m .. n) (λk. h (f (k + 1) − f k) (g (k + 1)))
             else 0)
   
   [BILINEAR_SWAP]  Theorem
      
      ⊢ ∀op. bilinear (λx y. op y x) ⇔ bilinear op
   
   [BILINEAR_UNIFORMLY_CONTINUOUS_ON_COMPOSE]  Theorem
      
      ⊢ ∀f g h s.
            f uniformly_continuous_on s ∧ g uniformly_continuous_on s ∧
            bilinear h ∧ bounded (IMAGE f s) ∧ bounded (IMAGE g s) ⇒
            (λx. h (f x) (g x)) uniformly_continuous_on s
   
   [BOLZANO_WEIERSTRASS]  Theorem
      
      ⊢ ∀s. bounded s ∧ INFINITE s ⇒ ∃x. x limit_point_of s
   
   [BOLZANO_WEIERSTRASS_CONTRAPOS]  Theorem
      
      ⊢ ∀s t.
            compact s ∧ t ⊆ s ∧ (∀x. x ∈ s ⇒ ¬(x limit_point_of t)) ⇒
            FINITE t
   
   [BOLZANO_WEIERSTRASS_IMP_BOUNDED]  Theorem
      
      ⊢ ∀s. (∀t. INFINITE t ∧ t ⊆ s ⇒ ∃x. x limit_point_of t) ⇒ bounded s
   
   [BOLZANO_WEIERSTRASS_IMP_CLOSED]  Theorem
      
      ⊢ ∀s.
            (∀t. INFINITE t ∧ t ⊆ s ⇒ ∃x. x ∈ s ∧ x limit_point_of t) ⇒
            closed s
   
   [BOUNDED_BALL]  Theorem
      
      ⊢ ∀x e. bounded (ball (x,e))
   
   [BOUNDED_BIGINTER]  Theorem
      
      ⊢ ∀f. (∃s. s ∈ f ∧ bounded s) ⇒ bounded (BIGINTER f)
   
   [BOUNDED_BIGUNION]  Theorem
      
      ⊢ ∀f. FINITE f ∧ (∀s. s ∈ f ⇒ bounded s) ⇒ bounded (BIGUNION f)
   
   [BOUNDED_CBALL]  Theorem
      
      ⊢ ∀x e. bounded (cball (x,e))
   
   [BOUNDED_CLOSED_CHAIN]  Theorem
      
      ⊢ ∀f b.
            (∀s. s ∈ f ⇒ closed s ∧ s ≠ ∅) ∧
            (∀s t. s ∈ f ∧ t ∈ f ⇒ s ⊆ t ∨ t ⊆ s) ∧ b ∈ f ∧ bounded b ⇒
            BIGINTER f ≠ ∅
   
   [BOUNDED_CLOSED_IMP_COMPACT]  Theorem
      
      ⊢ ∀s. bounded s ∧ closed s ⇒ compact s
   
   [BOUNDED_CLOSED_INTERVAL]  Theorem
      
      ⊢ ∀a b. bounded (interval [(a,b)])
   
   [BOUNDED_CLOSED_NEST]  Theorem
      
      ⊢ ∀s.
            (∀n. closed (s n)) ∧ (∀n. s n ≠ ∅) ∧
            (∀m n. m ≤ n ⇒ s n ⊆ s m) ∧ bounded (s 0) ⇒
            ∃a. ∀n. a ∈ s n
   
   [BOUNDED_CLOSURE]  Theorem
      
      ⊢ ∀s. bounded s ⇒ bounded (closure s)
   
   [BOUNDED_CLOSURE_EQ]  Theorem
      
      ⊢ ∀s. bounded (closure s) ⇔ bounded s
   
   [BOUNDED_COMPONENTWISE]  Theorem
      
      ⊢ ∀s. bounded s ⇔ bounded (IMAGE (λx. x) s)
   
   [BOUNDED_DECREASING_CONVERGENT]  Theorem
      
      ⊢ ∀s.
            bounded {s n | n ∈ 𝕌(:num)} ∧ (∀n. s (SUC n) ≤ s n) ⇒
            ∃l. (s --> l) sequentially
   
   [BOUNDED_DIFF]  Theorem
      
      ⊢ ∀s t. bounded s ⇒ bounded (s DIFF t)
   
   [BOUNDED_DIFFS]  Theorem
      
      ⊢ ∀s t. bounded s ∧ bounded t ⇒ bounded {x − y | x ∈ s ∧ y ∈ t}
   
   [BOUNDED_EMPTY]  Theorem
      
      ⊢ bounded ∅
   
   [BOUNDED_EQ_BOLZANO_WEIERSTRASS]  Theorem
      
      ⊢ ∀s. bounded s ⇔ ∀t. t ⊆ s ∧ INFINITE t ⇒ ∃x. x limit_point_of t
   
   [BOUNDED_FRONTIER]  Theorem
      
      ⊢ ∀s. bounded s ⇒ bounded (frontier s)
   
   [BOUNDED_HAS_INF]  Theorem
      
      ⊢ ∀s.
            bounded s ∧ s ≠ ∅ ⇒
            (∀x. x ∈ s ⇒ inf s ≤ x) ∧ ∀b. (∀x. x ∈ s ⇒ b ≤ x) ⇒ b ≤ inf s
   
   [BOUNDED_HAS_SUP]  Theorem
      
      ⊢ ∀s.
            bounded s ∧ s ≠ ∅ ⇒
            (∀x. x ∈ s ⇒ x ≤ sup s) ∧ ∀b. (∀x. x ∈ s ⇒ x ≤ b) ⇒ sup s ≤ b
   
   [BOUNDED_INCREASING_CONVERGENT]  Theorem
      
      ⊢ ∀s.
            bounded {s n | n ∈ 𝕌(:num)} ∧ (∀n. s n ≤ s (SUC n)) ⇒
            ∃l. (s --> l) sequentially
   
   [BOUNDED_INSERT]  Theorem
      
      ⊢ ∀x s. bounded (x INSERT s) ⇔ bounded s
   
   [BOUNDED_INTER]  Theorem
      
      ⊢ ∀s t. bounded s ∨ bounded t ⇒ bounded (s ∩ t)
   
   [BOUNDED_INTERIOR]  Theorem
      
      ⊢ ∀s. bounded s ⇒ bounded (interior s)
   
   [BOUNDED_INTERVAL]  Theorem
      
      ⊢ (∀a b. bounded (interval [(a,b)])) ∧ ∀a b. bounded (interval (a,b))
   
   [BOUNDED_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s. bounded s ∧ linear f ⇒ bounded (IMAGE f s)
   
   [BOUNDED_NEGATIONS]  Theorem
      
      ⊢ ∀s. bounded s ⇒ bounded (IMAGE (λx. -x) s)
   
   [BOUNDED_PARTIAL_SUMS]  Theorem
      
      ⊢ ∀f k.
            bounded {sum (k .. n) f | n ∈ 𝕌(:num)} ⇒
            bounded {sum (m .. n) f | m ∈ 𝕌(:num) ∧ n ∈ 𝕌(:num)}
   
   [BOUNDED_POS]  Theorem
      
      ⊢ ∀s. bounded s ⇔ ∃b. 0 < b ∧ ∀x. x ∈ s ⇒ abs x ≤ b
   
   [BOUNDED_POS_LT]  Theorem
      
      ⊢ ∀s. bounded s ⇔ ∃b. 0 < b ∧ ∀x. x ∈ s ⇒ abs x < b
   
   [BOUNDED_SCALING]  Theorem
      
      ⊢ ∀c s. bounded s ⇒ bounded (IMAGE (λx. c * x) s)
   
   [BOUNDED_SING]  Theorem
      
      ⊢ ∀a. bounded {a}
   
   [BOUNDED_SPHERE]  Theorem
      
      ⊢ ∀a r. bounded (sphere (a,r))
   
   [BOUNDED_SUBSET]  Theorem
      
      ⊢ ∀s t. bounded t ∧ s ⊆ t ⇒ bounded s
   
   [BOUNDED_SUBSET_BALL]  Theorem
      
      ⊢ ∀s x. bounded s ⇒ ∃r. 0 < r ∧ s ⊆ ball (x,r)
   
   [BOUNDED_SUBSET_CBALL]  Theorem
      
      ⊢ ∀s x. bounded s ⇒ ∃r. 0 < r ∧ s ⊆ cball (x,r)
   
   [BOUNDED_SUBSET_CLOSED_INTERVAL]  Theorem
      
      ⊢ ∀s. bounded s ⇒ ∃a b. s ⊆ interval [(a,b)]
   
   [BOUNDED_SUBSET_CLOSED_INTERVAL_SYMMETRIC]  Theorem
      
      ⊢ ∀s. bounded s ⇒ ∃a. s ⊆ interval [(-a,a)]
   
   [BOUNDED_SUBSET_OPEN_INTERVAL]  Theorem
      
      ⊢ ∀s. bounded s ⇒ ∃a b. s ⊆ interval (a,b)
   
   [BOUNDED_SUBSET_OPEN_INTERVAL_SYMMETRIC]  Theorem
      
      ⊢ ∀s. bounded s ⇒ ∃a. s ⊆ interval (-a,a)
   
   [BOUNDED_SUMS]  Theorem
      
      ⊢ ∀s t. bounded s ∧ bounded t ⇒ bounded {x + y | x ∈ s ∧ y ∈ t}
   
   [BOUNDED_SUMS_IMAGE]  Theorem
      
      ⊢ ∀f g t.
            bounded {f x | x ∈ t} ∧ bounded {g x | x ∈ t} ⇒
            bounded {f x + g x | x ∈ t}
   
   [BOUNDED_SUMS_IMAGES]  Theorem
      
      ⊢ ∀f t s.
            FINITE s ∧ (∀a. a ∈ s ⇒ bounded {f x a | x ∈ t}) ⇒
            bounded {sum s (f x) | x ∈ t}
   
   [BOUNDED_TRANSLATION]  Theorem
      
      ⊢ ∀a s. bounded s ⇒ bounded (IMAGE (λx. a + x) s)
   
   [BOUNDED_TRANSLATION_EQ]  Theorem
      
      ⊢ ∀a s. bounded (IMAGE (λx. a + x) s) ⇔ bounded s
   
   [BOUNDED_UNIFORMLY_CONTINUOUS_IMAGE]  Theorem
      
      ⊢ ∀f s. f uniformly_continuous_on s ∧ bounded s ⇒ bounded (IMAGE f s)
   
   [BOUNDED_UNION]  Theorem
      
      ⊢ ∀s t. bounded (s ∪ t) ⇔ bounded s ∧ bounded t
   
   [BOUNDS_LINEAR]  Theorem
      
      ⊢ ∀A B C. (∀n. A * n ≤ B * n + C) ⇔ A ≤ B
   
   [BOUNDS_LINEAR_0]  Theorem
      
      ⊢ ∀A B. (∀n. A * n ≤ B) ⇔ (A = 0)
   
   [CARD_EQ_BALL]  Theorem
      
      ⊢ ∀a r. 0 < r ⇒ ball (a,r) ≈ 𝕌(:real)
   
   [CARD_EQ_CBALL]  Theorem
      
      ⊢ ∀a r. 0 < r ⇒ cball (a,r) ≈ 𝕌(:real)
   
   [CARD_EQ_EUCLIDEAN]  Theorem
      
      ⊢ 𝕌(:real) ≈ 𝕌(:real)
   
   [CARD_EQ_INTERVAL]  Theorem
      
      ⊢ (∀a b. interval (a,b) ≠ ∅ ⇒ interval [(a,b)] ≈ 𝕌(:real)) ∧
        ∀a b. interval (a,b) ≠ ∅ ⇒ interval (a,b) ≈ 𝕌(:real)
   
   [CARD_EQ_OPEN]  Theorem
      
      ⊢ ∀s. open s ∧ s ≠ ∅ ⇒ s ≈ 𝕌(:real)
   
   [CARD_EQ_REAL]  Theorem
      
      ⊢ 𝕌(:real) ≈ 𝕌(:num -> bool)
   
   [CARD_EQ_REAL_IMP_UNCOUNTABLE]  Theorem
      
      ⊢ ∀s. s ≈ 𝕌(:real) ⇒ ¬COUNTABLE s
   
   [CARD_FRONTIER_INTERVAL]  Theorem
      
      ⊢ ∀s. is_interval s ⇒ FINITE (frontier s) ∧ CARD (frontier s) ≤ 2
   
   [CARD_GE_DIM_INDEPENDENT]  Theorem
      
      ⊢ ∀v b. b ⊆ v ∧ independent b ∧ dim v ≤ CARD b ⇒ v ⊆ span b
   
   [CARD_STDBASIS]  Theorem
      
      ⊢ CARD {1} = 1
   
   [CAUCHY]  Theorem
      
      ⊢ ∀s. cauchy s ⇔ ∀e. 0 < e ⇒ ∃N. ∀n. n ≥ N ⇒ dist (s n,s N) < e
   
   [CAUCHY_CONTINUOUS_EXTENDS_TO_CLOSURE]  Theorem
      
      ⊢ ∀f s.
            (∀x. cauchy x ∧ (∀n. x n ∈ s) ⇒ cauchy (f ∘ x)) ⇒
            ∃g. g continuous_on closure s ∧ ∀x. x ∈ s ⇒ (g x = f x)
   
   [CAUCHY_CONTINUOUS_IMP_CONTINUOUS]  Theorem
      
      ⊢ ∀f s.
            (∀x. cauchy x ∧ (∀n. x n ∈ s) ⇒ cauchy (f ∘ x)) ⇒
            f continuous_on s
   
   [CAUCHY_CONTINUOUS_UNIQUENESS_LEMMA]  Theorem
      
      ⊢ ∀f s.
            (∀x. cauchy x ∧ (∀n. x n ∈ s) ⇒ cauchy (f ∘ x)) ⇒
            ∀a x.
                (∀n. x n ∈ s) ∧ (x --> a) sequentially ⇒
                ∃l.
                    (f ∘ x --> l) sequentially ∧
                    ∀y.
                        (∀n. y n ∈ s) ∧ (y --> a) sequentially ⇒
                        (f ∘ y --> l) sequentially
   
   [CAUCHY_IMP_BOUNDED]  Theorem
      
      ⊢ ∀s. cauchy s ⇒ bounded {y | (∃n. y = s n)}
   
   [CAUCHY_ISOMETRIC]  Theorem
      
      ⊢ ∀f s e x.
            0 < e ∧ subspace s ∧ linear f ∧
            (∀x. x ∈ s ⇒ abs (f x) ≥ e * abs x) ∧ (∀n. x n ∈ s) ∧
            cauchy (f ∘ x) ⇒
            cauchy x
   
   [CBALL_DIFF_BALL]  Theorem
      
      ⊢ ∀a r. cball (a,r) DIFF ball (a,r) = sphere (a,r)
   
   [CBALL_DIFF_SPHERE]  Theorem
      
      ⊢ ∀a r. cball (a,r) DIFF sphere (a,r) = ball (a,r)
   
   [CBALL_EMPTY]  Theorem
      
      ⊢ ∀x e. e < 0 ⇒ (cball (x,e) = ∅)
   
   [CBALL_EQ_EMPTY]  Theorem
      
      ⊢ ∀x e. (cball (x,e) = ∅) ⇔ e < 0
   
   [CBALL_EQ_SING]  Theorem
      
      ⊢ ∀x e. (cball (x,e) = {x}) ⇔ (e = 0)
   
   [CBALL_INTERVAL]  Theorem
      
      ⊢ ∀x e. cball (x,e) = interval [(x − e,x + e)]
   
   [CBALL_INTERVAL_0]  Theorem
      
      ⊢ ∀e. cball (0,e) = interval [(-e,e)]
   
   [CBALL_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f x r.
            linear f ∧ (∀y. ∃x. f x = y) ∧ (∀x. abs (f x) = abs x) ⇒
            (cball (f x,r) = IMAGE f (cball (x,r)))
   
   [CBALL_MAX_UNION]  Theorem
      
      ⊢ ∀a r s. cball (a,max r s) = cball (a,r) ∪ cball (a,s)
   
   [CBALL_MIN_INTER]  Theorem
      
      ⊢ ∀x d e. cball (x,min d e) = cball (x,d) ∩ cball (x,e)
   
   [CBALL_SCALING]  Theorem
      
      ⊢ ∀c.
            0 < c ⇒
            ∀x r. cball (c * x,c * r) = IMAGE (λx. c * x) (cball (x,r))
   
   [CBALL_SING]  Theorem
      
      ⊢ ∀x e. (e = 0) ⇒ (cball (x,e) = {x})
   
   [CBALL_TRANSLATION]  Theorem
      
      ⊢ ∀a x r. cball (a + x,r) = IMAGE (λy. a + y) (cball (x,r))
   
   [CBALL_TRIVIAL]  Theorem
      
      ⊢ ∀x. cball (x,0) = {x}
   
   [CENTRE_IN_BALL]  Theorem
      
      ⊢ ∀x e. x ∈ ball (x,e) ⇔ 0 < e
   
   [CENTRE_IN_CBALL]  Theorem
      
      ⊢ ∀x e. x ∈ cball (x,e) ⇔ 0 ≤ e
   
   [CLOPEN]  Theorem
      
      ⊢ ∀s. closed s ∧ open s ⇔ (s = ∅) ∨ (s = 𝕌(:real))
   
   [CLOPEN_BIGUNION_COMPONENTS]  Theorem
      
      ⊢ ∀u s.
            closed_in (subtopology euclidean u) s ∧
            open_in (subtopology euclidean u) s ⇒
            ∃k. k ⊆ components u ∧ (s = BIGUNION k)
   
   [CLOPEN_IN_COMPONENTS]  Theorem
      
      ⊢ ∀u s.
            closed_in (subtopology euclidean u) s ∧
            open_in (subtopology euclidean u) s ∧ connected s ∧ s ≠ ∅ ⇒
            s ∈ components u
   
   [CLOSED]  Theorem
      
      ⊢ ∀s.
            closed s ⇔
            ∀x.
                (∀e. 0 < e ⇒ ∃x'. x' ∈ s ∧ x' ≠ x ∧ abs (x' − x) < e) ⇒
                x ∈ s
   
   [CLOSED_APPROACHABLE]  Theorem
      
      ⊢ ∀x s. closed s ⇒ ((∀e. 0 < e ⇒ ∃y. y ∈ s ∧ dist (y,x) < e) ⇔ x ∈ s)
   
   [CLOSED_AS_GDELTA]  Theorem
      
      ⊢ ∀s. closed s ⇒ gdelta s
   
   [CLOSED_BIGINTER]  Theorem
      
      ⊢ ∀f. (∀s. s ∈ f ⇒ closed s) ⇒ closed (BIGINTER f)
   
   [CLOSED_BIGINTER_COMPACT]  Theorem
      
      ⊢ ∀s. closed s ⇔ ∀e. compact (cball (0,e) ∩ s)
   
   [CLOSED_BIGUNION]  Theorem
      
      ⊢ ∀s. FINITE s ∧ (∀t. t ∈ s ⇒ closed t) ⇒ closed (BIGUNION s)
   
   [CLOSED_CBALL]  Theorem
      
      ⊢ ∀x e. closed (cball (x,e))
   
   [CLOSED_CLOSURE]  Theorem
      
      ⊢ ∀s. closed (closure s)
   
   [CLOSED_COMPACT_DIFFERENCES]  Theorem
      
      ⊢ ∀s t. closed s ∧ compact t ⇒ closed {x − y | x ∈ s ∧ y ∈ t}
   
   [CLOSED_COMPACT_SUMS]  Theorem
      
      ⊢ ∀s t. closed s ∧ compact t ⇒ closed {x + y | x ∈ s ∧ y ∈ t}
   
   [CLOSED_COMPONENTS]  Theorem
      
      ⊢ ∀s c. closed s ∧ c ∈ components s ⇒ closed c
   
   [CLOSED_CONNECTED_COMPONENT]  Theorem
      
      ⊢ ∀s x. closed s ⇒ closed (connected_component s x)
   
   [CLOSED_CONTAINS_SEQUENTIAL_LIMIT]  Theorem
      
      ⊢ ∀s x l. closed s ∧ (∀n. x n ∈ s) ∧ (x --> l) sequentially ⇒ l ∈ s
   
   [CLOSED_DIFF]  Theorem
      
      ⊢ ∀s t. closed s ∧ open t ⇒ closed (s DIFF t)
   
   [CLOSED_DIFF_OPEN_INTERVAL]  Theorem
      
      ⊢ ∀a b.
            interval [(a,b)] DIFF interval (a,b) =
            if interval [(a,b)] = ∅ then ∅ else {a; b}
   
   [CLOSED_EMPTY]  Theorem
      
      ⊢ closed ∅
   
   [CLOSED_FIP]  Theorem
      
      ⊢ ∀f.
            (∀t. t ∈ f ⇒ closed t) ∧ (∃t. t ∈ f ∧ bounded t) ∧
            (∀f'. FINITE f' ∧ f' ⊆ f ⇒ BIGINTER f' ≠ ∅) ⇒
            BIGINTER f ≠ ∅
   
   [CLOSED_FORALL]  Theorem
      
      ⊢ ∀Q. (∀a. closed {x | Q a x}) ⇒ closed {x | (∀a. Q a x)}
   
   [CLOSED_FORALL_IN]  Theorem
      
      ⊢ ∀P Q.
            (∀a. P a ⇒ closed {x | Q a x}) ⇒ closed {x | (∀a. P a ⇒ Q a x)}
   
   [CLOSED_HALFSPACE_COMPONENT_GE]  Theorem
      
      ⊢ ∀a. closed {x | x ≥ a}
   
   [CLOSED_HALFSPACE_COMPONENT_LE]  Theorem
      
      ⊢ ∀a. closed {x | x ≤ a}
   
   [CLOSED_HALFSPACE_GE]  Theorem
      
      ⊢ ∀a b. closed {x | a * x ≥ b}
   
   [CLOSED_HALFSPACE_LE]  Theorem
      
      ⊢ ∀a b. closed {x | a * x ≤ b}
   
   [CLOSED_HYPERPLANE]  Theorem
      
      ⊢ ∀a b. closed {x | a * x = b}
   
   [CLOSED_IMP_FIP]  Theorem
      
      ⊢ ∀s f.
            closed s ∧ (∀t. t ∈ f ⇒ closed t) ∧ (∃t. t ∈ f ∧ bounded t) ∧
            (∀f'. FINITE f' ∧ f' ⊆ f ⇒ s ∩ BIGINTER f' ≠ ∅) ⇒
            s ∩ BIGINTER f ≠ ∅
   
   [CLOSED_IMP_FIP_COMPACT]  Theorem
      
      ⊢ ∀s f.
            closed s ∧ (∀t. t ∈ f ⇒ compact t) ∧
            (∀f'. FINITE f' ∧ f' ⊆ f ⇒ s ∩ BIGINTER f' ≠ ∅) ⇒
            s ∩ BIGINTER f ≠ ∅
   
   [CLOSED_IMP_LOCALLY_COMPACT]  Theorem
      
      ⊢ ∀s. closed s ⇒ locally compact s
   
   [CLOSED_IN]  Theorem
      
      ⊢ ∀s. closed s ⇔ closed_in euclidean s
   
   [CLOSED_INJECTIVE_IMAGE_SUBSPACE]  Theorem
      
      ⊢ ∀f s.
            subspace s ∧ linear f ∧ (∀x. x ∈ s ∧ (f x = 0) ⇒ (x = 0)) ∧
            closed s ⇒
            closed (IMAGE f s)
   
   [CLOSED_INJECTIVE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            ∀s. closed s ⇒ closed (IMAGE f s)
   
   [CLOSED_INJECTIVE_LINEAR_IMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (closed (IMAGE f s) ⇔ closed s)
   
   [CLOSED_INSERT]  Theorem
      
      ⊢ ∀a s. closed s ⇒ closed (a INSERT s)
   
   [CLOSED_INTER]  Theorem
      
      ⊢ ∀s t. closed s ∧ closed t ⇒ closed (s ∩ t)
   
   [CLOSED_INTERVAL]  Theorem
      
      ⊢ ∀a b. closed (interval [(a,b)])
   
   [CLOSED_INTERVAL_EQ]  Theorem
      
      ⊢ (∀a b. closed (interval [(a,b)])) ∧
        ∀a b. closed (interval (a,b)) ⇔ (interval (a,b) = ∅)
   
   [CLOSED_INTERVAL_IMAGE_UNIT_INTERVAL]  Theorem
      
      ⊢ ∀a b.
            interval [(a,b)] ≠ ∅ ⇒
            (interval [(a,b)] =
             IMAGE (λx. a + x)
               (IMAGE (λx. @f. f = (b − a) * x) (interval [(0,1)])))
   
   [CLOSED_INTERVAL_LEFT]  Theorem
      
      ⊢ ∀b. closed {x | x ≤ b}
   
   [CLOSED_INTERVAL_RIGHT]  Theorem
      
      ⊢ ∀a. closed {x | a ≤ x}
   
   [CLOSED_INTER_COMPACT]  Theorem
      
      ⊢ ∀s t. closed s ∧ compact t ⇒ compact (s ∩ t)
   
   [CLOSED_IN_CLOSED]  Theorem
      
      ⊢ ∀s u.
            closed_in (subtopology euclidean u) s ⇔
            ∃t. closed t ∧ (s = u ∩ t)
   
   [CLOSED_IN_CLOSED_EQ]  Theorem
      
      ⊢ ∀s t.
            closed s ⇒
            (closed_in (subtopology euclidean s) t ⇔ closed t ∧ t ⊆ s)
   
   [CLOSED_IN_CLOSED_INTER]  Theorem
      
      ⊢ ∀u s. closed s ⇒ closed_in (subtopology euclidean u) (u ∩ s)
   
   [CLOSED_IN_CLOSED_TRANS]  Theorem
      
      ⊢ ∀s t. closed_in (subtopology euclidean t) s ∧ closed t ⇒ closed s
   
   [CLOSED_IN_COMPACT]  Theorem
      
      ⊢ ∀s t. compact s ∧ closed_in (subtopology euclidean s) t ⇒ compact t
   
   [CLOSED_IN_COMPACT_EQ]  Theorem
      
      ⊢ ∀s t.
            compact s ⇒
            (closed_in (subtopology euclidean s) t ⇔ compact t ∧ t ⊆ s)
   
   [CLOSED_IN_COMPONENT]  Theorem
      
      ⊢ ∀s c. c ∈ components s ⇒ closed_in (subtopology euclidean s) c
   
   [CLOSED_IN_CONNECTED_COMPONENT]  Theorem
      
      ⊢ ∀s x. closed_in (subtopology euclidean s) (connected_component s x)
   
   [CLOSED_IN_IMP_SUBSET]  Theorem
      
      ⊢ ∀top s t. closed_in (subtopology top s) t ⇒ t ⊆ s
   
   [CLOSED_IN_INTER_CLOSED]  Theorem
      
      ⊢ ∀s t u.
            closed_in (subtopology euclidean u) s ∧ closed t ⇒
            closed_in (subtopology euclidean u) (s ∩ t)
   
   [CLOSED_IN_INTER_CLOSURE]  Theorem
      
      ⊢ ∀s t. closed_in (subtopology euclidean s) t ⇔ (s ∩ closure t = t)
   
   [CLOSED_IN_LIMPT]  Theorem
      
      ⊢ ∀s t.
            closed_in (subtopology euclidean t) s ⇔
            s ⊆ t ∧ ∀x. x limit_point_of s ∧ x ∈ t ⇒ x ∈ s
   
   [CLOSED_IN_REFL]  Theorem
      
      ⊢ ∀s. closed_in (subtopology euclidean s) s
   
   [CLOSED_IN_SING]  Theorem
      
      ⊢ ∀u x. closed_in (subtopology euclidean u) {x} ⇔ x ∈ u
   
   [CLOSED_IN_SUBSET_TRANS]  Theorem
      
      ⊢ ∀s t u.
            closed_in (subtopology euclidean u) s ∧ s ⊆ t ∧ t ⊆ u ⇒
            closed_in (subtopology euclidean t) s
   
   [CLOSED_IN_SUBTOPOLOGY]  Theorem
      
      ⊢ ∀top u s.
            closed_in (subtopology top u) s ⇔
            ∃t. closed_in top t ∧ (s = t ∩ u)
   
   [CLOSED_IN_SUBTOPOLOGY_EMPTY]  Theorem
      
      ⊢ ∀top s. closed_in (subtopology top ∅) s ⇔ (s = ∅)
   
   [CLOSED_IN_SUBTOPOLOGY_REFL]  Theorem
      
      ⊢ ∀top u. closed_in (subtopology top u) u ⇔ u ⊆ topspace top
   
   [CLOSED_IN_SUBTOPOLOGY_UNION]  Theorem
      
      ⊢ ∀top s t u.
            closed_in (subtopology top t) s ∧
            closed_in (subtopology top u) s ⇒
            closed_in (subtopology top (t ∪ u)) s
   
   [CLOSED_IN_TRANS]  Theorem
      
      ⊢ ∀s t u.
            closed_in (subtopology euclidean t) s ∧
            closed_in (subtopology euclidean u) t ⇒
            closed_in (subtopology euclidean u) s
   
   [CLOSED_IN_TRANS_EQ]  Theorem
      
      ⊢ ∀s t.
            (∀u.
                 closed_in (subtopology euclidean t) u ⇒
                 closed_in (subtopology euclidean s) t) ⇔
            closed_in (subtopology euclidean s) t
   
   [CLOSED_LIMPT]  Theorem
      
      ⊢ ∀s. closed s ⇔ ∀x. x limit_point_of s ⇒ x ∈ s
   
   [CLOSED_LIMPTS]  Theorem
      
      ⊢ ∀s. closed {x | x limit_point_of s}
   
   [CLOSED_MAP_CLOSURES]  Theorem
      
      ⊢ ∀f.
            (∀s. closed s ⇒ closed (IMAGE f s)) ⇔
            ∀s. closure (IMAGE f s) ⊆ IMAGE f (closure s)
   
   [CLOSED_MAP_FROM_COMPOSITION_INJECTIVE]  Theorem
      
      ⊢ ∀f g s t u.
            IMAGE f s ⊆ t ∧ IMAGE g t ⊆ u ∧ g continuous_on t ∧
            (∀x y. x ∈ t ∧ y ∈ t ∧ (g x = g y) ⇒ (x = y)) ∧
            (∀k.
                 closed_in (subtopology euclidean s) k ⇒
                 closed_in (subtopology euclidean u) (IMAGE (g ∘ f) k)) ⇒
            ∀k.
                closed_in (subtopology euclidean s) k ⇒
                closed_in (subtopology euclidean t) (IMAGE f k)
   
   [CLOSED_MAP_FROM_COMPOSITION_SURJECTIVE]  Theorem
      
      ⊢ ∀f g s t u.
            f continuous_on s ∧ (IMAGE f s = t) ∧ IMAGE g t ⊆ u ∧
            (∀k.
                 closed_in (subtopology euclidean s) k ⇒
                 closed_in (subtopology euclidean u) (IMAGE (g ∘ f) k)) ⇒
            ∀k.
                closed_in (subtopology euclidean t) k ⇒
                closed_in (subtopology euclidean u) (IMAGE g k)
   
   [CLOSED_MAP_IFF_UPPER_HEMICONTINUOUS_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀u.
                  closed_in (subtopology euclidean s) u ⇒
                  closed_in (subtopology euclidean t) (IMAGE f u)) ⇔
             ∀u.
                 open_in (subtopology euclidean s) u ⇒
                 open_in (subtopology euclidean t)
                   {y | y ∈ t ∧ {x | x ∈ s ∧ (f x = y)} ⊆ u})
   
   [CLOSED_MAP_IMP_OPEN_MAP]  Theorem
      
      ⊢ ∀f s t.
            (IMAGE f s = t) ∧
            (∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean t) (IMAGE f u)) ∧
            (∀u.
                 open_in (subtopology euclidean s) u ⇒
                 open_in (subtopology euclidean s)
                   {x | x ∈ s ∧ f x ∈ IMAGE f u}) ⇒
            ∀u.
                open_in (subtopology euclidean s) u ⇒
                open_in (subtopology euclidean t) (IMAGE f u)
   
   [CLOSED_MAP_IMP_QUOTIENT_MAP]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ∧
            (∀t.
                 closed_in (subtopology euclidean s) t ⇒
                 closed_in (subtopology euclidean (IMAGE f s)) (IMAGE f t)) ⇒
            ∀t.
                t ⊆ IMAGE f s ⇒
                (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t} ⇔
                 open_in (subtopology euclidean (IMAGE f s)) t)
   
   [CLOSED_MAP_OPEN_SUPERSET_PREIMAGE]  Theorem
      
      ⊢ ∀f s t u w.
            (∀k.
                 closed_in (subtopology euclidean s) k ⇒
                 closed_in (subtopology euclidean t) (IMAGE f k)) ∧
            open_in (subtopology euclidean s) u ∧ w ⊆ t ∧
            {x | x ∈ s ∧ f x ∈ w} ⊆ u ⇒
            ∃v.
                open_in (subtopology euclidean t) v ∧ w ⊆ v ∧
                {x | x ∈ s ∧ f x ∈ v} ⊆ u
   
   [CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_EQ]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀k.
                  closed_in (subtopology euclidean s) k ⇒
                  closed_in (subtopology euclidean t) (IMAGE f k)) ⇔
             ∀u w.
                 open_in (subtopology euclidean s) u ∧ w ⊆ t ∧
                 {x | x ∈ s ∧ f x ∈ w} ⊆ u ⇒
                 ∃v.
                     open_in (subtopology euclidean t) v ∧ w ⊆ v ∧
                     {x | x ∈ s ∧ f x ∈ v} ⊆ u)
   
   [CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_POINT]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀k.
                  closed_in (subtopology euclidean s) k ⇒
                  closed_in (subtopology euclidean t) (IMAGE f k)) ⇔
             ∀u y.
                 open_in (subtopology euclidean s) u ∧ y ∈ t ∧
                 {x | x ∈ s ∧ (f x = y)} ⊆ u ⇒
                 ∃v.
                     open_in (subtopology euclidean t) v ∧ y ∈ v ∧
                     {x | x ∈ s ∧ f x ∈ v} ⊆ u)
   
   [CLOSED_MAP_RESTRICT]  Theorem
      
      ⊢ ∀f s t t'.
            (∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean t) (IMAGE f u)) ∧ t' ⊆ t ⇒
            ∀u.
                closed_in (subtopology euclidean {x | x ∈ s ∧ f x ∈ t'}) u ⇒
                closed_in (subtopology euclidean t') (IMAGE f u)
   
   [CLOSED_NEGATIONS]  Theorem
      
      ⊢ ∀s. closed s ⇒ closed (IMAGE (λx. -x) s)
   
   [CLOSED_OPEN_INTERVAL]  Theorem
      
      ⊢ ∀a b. a ≤ b ⇒ (interval [(a,b)] = interval (a,b) ∪ {a; b})
   
   [CLOSED_POSITIVE_ORTHANT]  Theorem
      
      ⊢ closed {x | 0 ≤ x}
   
   [CLOSED_SCALING]  Theorem
      
      ⊢ ∀s c. closed s ⇒ closed (IMAGE (λx. c * x) s)
   
   [CLOSED_SEGMENT_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f a b.
            linear f ⇒ (segment [(f a,f b)] = IMAGE f (segment [(a,b)]))
   
   [CLOSED_SEQUENTIAL_LIMITS]  Theorem
      
      ⊢ ∀s. closed s ⇔ ∀x l. (∀n. x n ∈ s) ∧ (x --> l) sequentially ⇒ l ∈ s
   
   [CLOSED_SING]  Theorem
      
      ⊢ ∀a. closed {a}
   
   [CLOSED_SPHERE]  Theorem
      
      ⊢ ∀a r. closed (sphere (a,r))
   
   [CLOSED_STANDARD_HYPERPLANE]  Theorem
      
      ⊢ ∀a. closed {x | x = a}
   
   [CLOSED_SUBSET]  Theorem
      
      ⊢ ∀s t. s ⊆ t ∧ closed s ⇒ closed_in (subtopology euclidean t) s
   
   [CLOSED_SUBSET_EQ]  Theorem
      
      ⊢ ∀u s. closed s ⇒ (closed_in (subtopology euclidean u) s ⇔ s ⊆ u)
   
   [CLOSED_SUBSTANDARD]  Theorem
      
      ⊢ closed {x | x = 0}
   
   [CLOSED_UNION]  Theorem
      
      ⊢ ∀s t. closed s ∧ closed t ⇒ closed (s ∪ t)
   
   [CLOSED_UNION_COMPACT_SUBSETS]  Theorem
      
      ⊢ ∀s.
            closed s ⇒
            ∃f.
                (∀n. compact (f n)) ∧ (∀n. f n ⊆ s) ∧
                (∀n. f n ⊆ f (n + 1)) ∧
                (BIGUNION {f n | n ∈ 𝕌(:num)} = s) ∧
                ∀k. compact k ∧ k ⊆ s ⇒ ∃N. ∀n. n ≥ N ⇒ k ⊆ f n
   
   [CLOSED_UNIV]  Theorem
      
      ⊢ closed 𝕌(:real)
   
   [CLOSEST_POINT_EXISTS]  Theorem
      
      ⊢ ∀s a.
            closed s ∧ s ≠ ∅ ⇒
            closest_point s a ∈ s ∧
            ∀y. y ∈ s ⇒ dist (a,closest_point s a) ≤ dist (a,y)
   
   [CLOSEST_POINT_IN_FRONTIER]  Theorem
      
      ⊢ ∀s x.
            closed s ∧ s ≠ ∅ ∧ x ∉ interior s ⇒
            closest_point s x ∈ frontier s
   
   [CLOSEST_POINT_IN_INTERIOR]  Theorem
      
      ⊢ ∀s x.
            closed s ∧ s ≠ ∅ ⇒
            (closest_point s x ∈ interior s ⇔ x ∈ interior s)
   
   [CLOSEST_POINT_IN_SET]  Theorem
      
      ⊢ ∀s a. closed s ∧ s ≠ ∅ ⇒ closest_point s a ∈ s
   
   [CLOSEST_POINT_LE]  Theorem
      
      ⊢ ∀s a x. closed s ∧ x ∈ s ⇒ dist (a,closest_point s a) ≤ dist (a,x)
   
   [CLOSEST_POINT_REFL]  Theorem
      
      ⊢ ∀s x. closed s ∧ s ≠ ∅ ⇒ ((closest_point s x = x) ⇔ x ∈ s)
   
   [CLOSEST_POINT_SELF]  Theorem
      
      ⊢ ∀s x. x ∈ s ⇒ (closest_point s x = x)
   
   [CLOSURE_APPROACHABLE]  Theorem
      
      ⊢ ∀x s. x ∈ closure s ⇔ ∀e. 0 < e ⇒ ∃y. y ∈ s ∧ dist (y,x) < e
   
   [CLOSURE_BALL]  Theorem
      
      ⊢ ∀x e. 0 < e ⇒ (closure (ball (x,e)) = cball (x,e))
   
   [CLOSURE_BIGINTER_SUBSET]  Theorem
      
      ⊢ ∀f. closure (BIGINTER f) ⊆ BIGINTER (IMAGE closure f)
   
   [CLOSURE_BIGUNION]  Theorem
      
      ⊢ ∀f.
            FINITE f ⇒
            (closure (BIGUNION f) = BIGUNION {closure s | s ∈ f})
   
   [CLOSURE_BOUNDED_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ bounded s ⇒
            (closure (IMAGE f s) = IMAGE f (closure s))
   
   [CLOSURE_CLOSED]  Theorem
      
      ⊢ ∀s. closed s ⇒ (closure s = s)
   
   [CLOSURE_CLOSURE]  Theorem
      
      ⊢ ∀s. closure (closure s) = closure s
   
   [CLOSURE_COMPLEMENT]  Theorem
      
      ⊢ ∀s. closure (𝕌(:real) DIFF s) = 𝕌(:real) DIFF interior s
   
   [CLOSURE_EMPTY]  Theorem
      
      ⊢ closure ∅ = ∅
   
   [CLOSURE_EQ]  Theorem
      
      ⊢ ∀s. (closure s = s) ⇔ closed s
   
   [CLOSURE_EQ_EMPTY]  Theorem
      
      ⊢ ∀s. (closure s = ∅) ⇔ (s = ∅)
   
   [CLOSURE_HALFSPACE_COMPONENT_GT]  Theorem
      
      ⊢ ∀a. closure {x | x > a} = {x | x ≥ a}
   
   [CLOSURE_HALFSPACE_COMPONENT_LT]  Theorem
      
      ⊢ ∀a. closure {x | x < a} = {x | x ≤ a}
   
   [CLOSURE_HALFSPACE_GT]  Theorem
      
      ⊢ ∀a b. a ≠ 0 ⇒ (closure {x | a * x > b} = {x | a * x ≥ b})
   
   [CLOSURE_HALFSPACE_LT]  Theorem
      
      ⊢ ∀a b. a ≠ 0 ⇒ (closure {x | a * x < b} = {x | a * x ≤ b})
   
   [CLOSURE_HULL]  Theorem
      
      ⊢ ∀s. closure s = closed hull s
   
   [CLOSURE_HYPERPLANE]  Theorem
      
      ⊢ ∀a b. closure {x | a * x = b} = {x | a * x = b}
   
   [CLOSURE_IMAGE_BOUNDED]  Theorem
      
      ⊢ ∀f s.
            f continuous_on closure s ∧ bounded s ⇒
            (closure (IMAGE f s) = IMAGE f (closure s))
   
   [CLOSURE_IMAGE_CLOSURE]  Theorem
      
      ⊢ ∀f s.
            f continuous_on closure s ⇒
            (closure (IMAGE f (closure s)) = closure (IMAGE f s))
   
   [CLOSURE_INJECTIVE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (closure (IMAGE f s) = IMAGE f (closure s))
   
   [CLOSURE_INTERIOR]  Theorem
      
      ⊢ ∀s. closure s = 𝕌(:real) DIFF interior (𝕌(:real) DIFF s)
   
   [CLOSURE_INTERIOR_IDEMP]  Theorem
      
      ⊢ ∀s.
            closure (interior (closure (interior s))) =
            closure (interior s)
   
   [CLOSURE_INTERIOR_UNION_CLOSED]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ closed t ⇒
            (closure (interior (s ∪ t)) =
             closure (interior s) ∪ closure (interior t))
   
   [CLOSURE_INTERVAL]  Theorem
      
      ⊢ (∀a b. closure (interval [(a,b)]) = interval [(a,b)]) ∧
        ∀a b.
            closure (interval (a,b)) =
            if interval (a,b) = ∅ then ∅ else interval [(a,b)]
   
   [CLOSURE_INTER_SUBSET]  Theorem
      
      ⊢ ∀s t. closure (s ∩ t) ⊆ closure s ∩ closure t
   
   [CLOSURE_LINEAR_IMAGE_SUBSET]  Theorem
      
      ⊢ ∀f s. linear f ⇒ IMAGE f (closure s) ⊆ closure (IMAGE f s)
   
   [CLOSURE_MINIMAL]  Theorem
      
      ⊢ ∀s t. s ⊆ t ∧ closed t ⇒ closure s ⊆ t
   
   [CLOSURE_MINIMAL_EQ]  Theorem
      
      ⊢ ∀s t. closed t ⇒ (closure s ⊆ t ⇔ s ⊆ t)
   
   [CLOSURE_NEGATIONS]  Theorem
      
      ⊢ ∀s. closure (IMAGE (λx. -x) s) = IMAGE (λx. -x) (closure s)
   
   [CLOSURE_NONEMPTY_OPEN_INTER]  Theorem
      
      ⊢ ∀s x. x ∈ closure s ⇔ ∀t. x ∈ t ∧ open t ⇒ s ∩ t ≠ ∅
   
   [CLOSURE_OPEN_INTERVAL]  Theorem
      
      ⊢ ∀a b.
            interval (a,b) ≠ ∅ ⇒
            (closure (interval (a,b)) = interval [(a,b)])
   
   [CLOSURE_OPEN_INTER_CLOSURE]  Theorem
      
      ⊢ ∀s t. open s ⇒ (closure (s ∩ closure t) = closure (s ∩ t))
   
   [CLOSURE_OPEN_INTER_SUPERSET]  Theorem
      
      ⊢ ∀s t. open s ∧ s ⊆ closure t ⇒ (closure (s ∩ t) = closure s)
   
   [CLOSURE_OPEN_IN_INTER_CLOSURE]  Theorem
      
      ⊢ ∀s t u.
            open_in (subtopology euclidean u) s ∧ t ⊆ u ⇒
            (closure (s ∩ closure t) = closure (s ∩ t))
   
   [CLOSURE_SEQUENTIAL]  Theorem
      
      ⊢ ∀s l. l ∈ closure s ⇔ ∃x. (∀n. x n ∈ s) ∧ (x --> l) sequentially
   
   [CLOSURE_SING]  Theorem
      
      ⊢ ∀x. closure {x} = {x}
   
   [CLOSURE_SUBSET]  Theorem
      
      ⊢ ∀s. s ⊆ closure s
   
   [CLOSURE_SUBSET_EQ]  Theorem
      
      ⊢ ∀s. closure s ⊆ s ⇔ closed s
   
   [CLOSURE_SUMS]  Theorem
      
      ⊢ ∀s t.
            bounded s ∨ bounded t ⇒
            (closure {x + y | x ∈ s ∧ y ∈ t} =
             {x + y | x ∈ closure s ∧ y ∈ closure t})
   
   [CLOSURE_UNION]  Theorem
      
      ⊢ ∀s t. closure (s ∪ t) = closure s ∪ closure t
   
   [CLOSURE_UNION_FRONTIER]  Theorem
      
      ⊢ ∀s. closure s = s ∪ frontier s
   
   [CLOSURE_UNIQUE]  Theorem
      
      ⊢ ∀s t.
            s ⊆ t ∧ closed t ∧ (∀t'. s ⊆ t' ∧ closed t' ⇒ t ⊆ t') ⇒
            (closure s = t)
   
   [CLOSURE_UNIV]  Theorem
      
      ⊢ closure 𝕌(:real) = 𝕌(:real)
   
   [COBOUNDED_IMP_UNBOUNDED]  Theorem
      
      ⊢ ∀s. bounded (𝕌(:real) DIFF s) ⇒ ¬bounded s
   
   [COBOUNDED_INTER_UNBOUNDED]  Theorem
      
      ⊢ ∀s t. bounded (𝕌(:real) DIFF s) ∧ ¬bounded t ⇒ s ∩ t ≠ ∅
   
   [COLLINEAR_1]  Theorem
      
      ⊢ ∀s. collinear s
   
   [COLLINEAR_2]  Theorem
      
      ⊢ ∀x y. collinear {x; y}
   
   [COLLINEAR_3]  Theorem
      
      ⊢ ∀x y z. collinear {x; y; z} ⇔ collinear {0; x − y; z − y}
   
   [COLLINEAR_3_EXPAND]  Theorem
      
      ⊢ ∀a b c. collinear {a; b; c} ⇔ (a = c) ∨ ∃u. b = u * a + (1 − u) * c
   
   [COLLINEAR_3_TRANS]  Theorem
      
      ⊢ ∀a b c d.
            collinear {a; b; c} ∧ collinear {b; c; d} ∧ b ≠ c ⇒
            collinear {a; b; d}
   
   [COLLINEAR_4_3]  Theorem
      
      ⊢ ∀a b c d.
            a ≠ b ⇒
            (collinear {a; b; c; d} ⇔
             collinear {a; b; c} ∧ collinear {a; b; d})
   
   [COLLINEAR_BETWEEN_CASES]  Theorem
      
      ⊢ ∀a b c.
            collinear {a; b; c} ⇔
            between a (b,c) ∨ between b (c,a) ∨ between c (a,b)
   
   [COLLINEAR_DIST_BETWEEN]  Theorem
      
      ⊢ ∀a b x.
            collinear {x; a; b} ∧ dist (x,a) ≤ dist (a,b) ∧
            dist (x,b) ≤ dist (a,b) ⇒
            between x (a,b)
   
   [COLLINEAR_DIST_IN_CLOSED_SEGMENT]  Theorem
      
      ⊢ ∀a b x.
            collinear {x; a; b} ∧ dist (x,a) ≤ dist (a,b) ∧
            dist (x,b) ≤ dist (a,b) ⇒
            x ∈ segment [(a,b)]
   
   [COLLINEAR_DIST_IN_OPEN_SEGMENT]  Theorem
      
      ⊢ ∀a b x.
            collinear {x; a; b} ∧ dist (x,a) < dist (a,b) ∧
            dist (x,b) < dist (a,b) ⇒
            x ∈ segment (a,b)
   
   [COLLINEAR_EMPTY]  Theorem
      
      ⊢ collinear ∅
   
   [COLLINEAR_LEMMA]  Theorem
      
      ⊢ ∀x y. collinear {0; x; y} ⇔ (x = 0) ∨ (y = 0) ∨ ∃c. y = c * x
   
   [COLLINEAR_LEMMA_ALT]  Theorem
      
      ⊢ ∀x y. collinear {0; x; y} ⇔ (x = 0) ∨ ∃c. y = c * x
   
   [COLLINEAR_MIDPOINT]  Theorem
      
      ⊢ ∀a b. collinear {a; midpoint (a,b); b}
   
   [COLLINEAR_SING]  Theorem
      
      ⊢ ∀x. collinear {x}
   
   [COLLINEAR_SMALL]  Theorem
      
      ⊢ ∀s. FINITE s ∧ CARD s ≤ 2 ⇒ collinear s
   
   [COLLINEAR_SUBSET]  Theorem
      
      ⊢ ∀s t. collinear t ∧ s ⊆ t ⇒ collinear s
   
   [COLLINEAR_TRIPLES]  Theorem
      
      ⊢ ∀s a b.
            a ≠ b ⇒
            (collinear (a INSERT b INSERT s) ⇔
             ∀x. x ∈ s ⇒ collinear {a; b; x})
   
   [COMPACT_AFFINITY]  Theorem
      
      ⊢ ∀s a c. compact s ⇒ compact (IMAGE (λx. a + c * x) s)
   
   [COMPACT_ATTAINS_INF]  Theorem
      
      ⊢ ∀s. compact s ∧ s ≠ ∅ ⇒ ∃x. x ∈ s ∧ ∀y. y ∈ s ⇒ x ≤ y
   
   [COMPACT_ATTAINS_SUP]  Theorem
      
      ⊢ ∀s. compact s ∧ s ≠ ∅ ⇒ ∃x. x ∈ s ∧ ∀y. y ∈ s ⇒ y ≤ x
   
   [COMPACT_BIGINTER]  Theorem
      
      ⊢ ∀f. (∀s. s ∈ f ⇒ compact s) ∧ f ≠ ∅ ⇒ compact (BIGINTER f)
   
   [COMPACT_BIGUNION]  Theorem
      
      ⊢ ∀s. FINITE s ∧ (∀t. t ∈ s ⇒ compact t) ⇒ compact (BIGUNION s)
   
   [COMPACT_CBALL]  Theorem
      
      ⊢ ∀x e. compact (cball (x,e))
   
   [COMPACT_CHAIN]  Theorem
      
      ⊢ ∀f.
            (∀s. s ∈ f ⇒ compact s ∧ s ≠ ∅) ∧
            (∀s t. s ∈ f ∧ t ∈ f ⇒ s ⊆ t ∨ t ⊆ s) ⇒
            BIGINTER f ≠ ∅
   
   [COMPACT_CLOSED_DIFFERENCES]  Theorem
      
      ⊢ ∀s t. compact s ∧ closed t ⇒ closed {x − y | x ∈ s ∧ y ∈ t}
   
   [COMPACT_CLOSED_SUMS]  Theorem
      
      ⊢ ∀s t. compact s ∧ closed t ⇒ closed {x + y | x ∈ s ∧ y ∈ t}
   
   [COMPACT_CLOSURE]  Theorem
      
      ⊢ ∀s. compact (closure s) ⇔ bounded s
   
   [COMPACT_COMPONENTS]  Theorem
      
      ⊢ ∀s c. compact s ∧ c ∈ components s ⇒ compact c
   
   [COMPACT_CONTINUOUS_IMAGE]  Theorem
      
      ⊢ ∀f s. f continuous_on s ∧ compact s ⇒ compact (IMAGE f s)
   
   [COMPACT_CONTINUOUS_IMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ⇒
            (f continuous_on s ⇔
             ∀t. compact t ∧ t ⊆ s ⇒ compact (IMAGE f t))
   
   [COMPACT_DIFF]  Theorem
      
      ⊢ ∀s t. compact s ∧ open t ⇒ compact (s DIFF t)
   
   [COMPACT_EMPTY]  Theorem
      
      ⊢ compact ∅
   
   [COMPACT_EQ_BOLZANO_WEIERSTRASS]  Theorem
      
      ⊢ ∀s.
            compact s ⇔
            ∀t. INFINITE t ∧ t ⊆ s ⇒ ∃x. x ∈ s ∧ x limit_point_of t
   
   [COMPACT_EQ_BOUNDED_CLOSED]  Theorem
      
      ⊢ ∀s. compact s ⇔ bounded s ∧ closed s
   
   [COMPACT_EQ_HEINE_BOREL]  Theorem
      
      ⊢ ∀s.
            compact s ⇔
            ∀f.
                (∀t. t ∈ f ⇒ open t) ∧ s ⊆ BIGUNION f ⇒
                ∃f'. f' ⊆ f ∧ FINITE f' ∧ s ⊆ BIGUNION f'
   
   [COMPACT_EQ_HEINE_BOREL_SUBTOPOLOGY]  Theorem
      
      ⊢ ∀s.
            compact s ⇔
            ∀f.
                (∀t. t ∈ f ⇒ open_in (subtopology euclidean s) t) ∧
                s ⊆ BIGUNION f ⇒
                ∃f'. f' ⊆ f ∧ FINITE f' ∧ s ⊆ BIGUNION f'
   
   [COMPACT_FIP]  Theorem
      
      ⊢ ∀f.
            (∀t. t ∈ f ⇒ compact t) ∧
            (∀f'. FINITE f' ∧ f' ⊆ f ⇒ BIGINTER f' ≠ ∅) ⇒
            BIGINTER f ≠ ∅
   
   [COMPACT_FRONTIER]  Theorem
      
      ⊢ ∀s. compact s ⇒ compact (frontier s)
   
   [COMPACT_FRONTIER_BOUNDED]  Theorem
      
      ⊢ ∀s. bounded s ⇒ compact (frontier s)
   
   [COMPACT_IMP_BOUNDED]  Theorem
      
      ⊢ ∀s. compact s ⇒ bounded s
   
   [COMPACT_IMP_CLOSED]  Theorem
      
      ⊢ ∀s. compact s ⇒ closed s
   
   [COMPACT_IMP_COMPLETE]  Theorem
      
      ⊢ ∀s. compact s ⇒ complete s
   
   [COMPACT_IMP_FIP]  Theorem
      
      ⊢ ∀s f.
            compact s ∧ (∀t. t ∈ f ⇒ closed t) ∧
            (∀f'. FINITE f' ∧ f' ⊆ f ⇒ s ∩ BIGINTER f' ≠ ∅) ⇒
            s ∩ BIGINTER f ≠ ∅
   
   [COMPACT_IMP_HEINE_BOREL]  Theorem
      
      ⊢ ∀s.
            compact s ⇒
            ∀f.
                (∀t. t ∈ f ⇒ open t) ∧ s ⊆ BIGUNION f ⇒
                ∃f'. f' ⊆ f ∧ FINITE f' ∧ s ⊆ BIGUNION f'
   
   [COMPACT_IMP_TOTALLY_BOUNDED]  Theorem
      
      ⊢ ∀s.
            compact s ⇒
            ∀e.
                0 < e ⇒
                ∃k.
                    FINITE k ∧ k ⊆ s ∧
                    s ⊆ BIGUNION (IMAGE (λx. ball (x,e)) k)
   
   [COMPACT_INSERT]  Theorem
      
      ⊢ ∀a s. compact s ⇒ compact (a INSERT s)
   
   [COMPACT_INTER]  Theorem
      
      ⊢ ∀s t. compact s ∧ compact t ⇒ compact (s ∩ t)
   
   [COMPACT_INTERVAL]  Theorem
      
      ⊢ ∀a b. compact (interval [(a,b)])
   
   [COMPACT_INTERVAL_EQ]  Theorem
      
      ⊢ (∀a b. compact (interval [(a,b)])) ∧
        ∀a b. compact (interval (a,b)) ⇔ (interval (a,b) = ∅)
   
   [COMPACT_INTER_CLOSED]  Theorem
      
      ⊢ ∀s t. compact s ∧ closed t ⇒ compact (s ∩ t)
   
   [COMPACT_LEMMA]  Theorem
      
      ⊢ ∀s.
            bounded s ∧ (∀n. x n ∈ s) ⇒
            ∃l r.
                (∀m n. m < n ⇒ r m < r n) ∧
                ∀e. 0 < e ⇒ ∃N. ∀n i. N ≤ n ⇒ abs (x (r n) − l) < e
   
   [COMPACT_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s. compact s ∧ linear f ⇒ compact (IMAGE f s)
   
   [COMPACT_NEGATIONS]  Theorem
      
      ⊢ ∀s. compact s ⇒ compact (IMAGE (λx. -x) s)
   
   [COMPACT_NEST]  Theorem
      
      ⊢ ∀s.
            (∀n. compact (s n) ∧ s n ≠ ∅) ∧ (∀m n. m ≤ n ⇒ s n ⊆ s m) ⇒
            BIGINTER {s n | n ∈ 𝕌(:num)} ≠ ∅
   
   [COMPACT_REAL_LEMMA]  Theorem
      
      ⊢ ∀s b.
            (∀n. abs (s n) ≤ b) ⇒
            ∃l r.
                (∀m n. m < n ⇒ r m < r n) ∧
                ∀e. 0 < e ⇒ ∃N. ∀n. N ≤ n ⇒ abs (s (r n) − l) < e
   
   [COMPACT_SCALING]  Theorem
      
      ⊢ ∀s c. compact s ⇒ compact (IMAGE (λx. c * x) s)
   
   [COMPACT_SEQUENCE_WITH_LIMIT]  Theorem
      
      ⊢ ∀f l. (f --> l) sequentially ⇒ compact (l INSERT IMAGE f 𝕌(:num))
   
   [COMPACT_SING]  Theorem
      
      ⊢ ∀a. compact {a}
   
   [COMPACT_SPHERE]  Theorem
      
      ⊢ ∀a r. compact (sphere (a,r))
   
   [COMPACT_TRANSLATION]  Theorem
      
      ⊢ ∀s a. compact s ⇒ compact (IMAGE (λx. a + x) s)
   
   [COMPACT_TRANSLATION_EQ]  Theorem
      
      ⊢ ∀a s. compact (IMAGE (λx. a + x) s) ⇔ compact s
   
   [COMPACT_UNIFORMLY_CONTINUOUS]  Theorem
      
      ⊢ ∀f s. f continuous_on s ∧ compact s ⇒ f uniformly_continuous_on s
   
   [COMPACT_UNIFORMLY_EQUICONTINUOUS]  Theorem
      
      ⊢ ∀fs s.
            (∀x e.
                 x ∈ s ∧ 0 < e ⇒
                 ∃d.
                     0 < d ∧
                     ∀f x'.
                         f ∈ fs ∧ x' ∈ s ∧ dist (x',x) < d ⇒
                         dist (f x',f x) < e) ∧ compact s ⇒
            ∀e.
                0 < e ⇒
                ∃d.
                    0 < d ∧
                    ∀f x x'.
                        f ∈ fs ∧ x ∈ s ∧ x' ∈ s ∧ dist (x',x) < d ⇒
                        dist (f x',f x) < e
   
   [COMPACT_UNION]  Theorem
      
      ⊢ ∀s t. compact s ∧ compact t ⇒ compact (s ∪ t)
   
   [COMPLEMENT_CONNECTED_COMPONENT_BIGUNION]  Theorem
      
      ⊢ ∀s x.
            s DIFF connected_component s x =
            BIGUNION
              ({connected_component s y | y | y ∈ s} DELETE
               connected_component s x)
   
   [COMPLETE_EQ_CLOSED]  Theorem
      
      ⊢ ∀s. complete s ⇔ closed s
   
   [COMPLETE_INJECTIVE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            ∀s. complete s ⇒ complete (IMAGE f s)
   
   [COMPLETE_INJECTIVE_LINEAR_IMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (complete (IMAGE f s) ⇔ complete s)
   
   [COMPLETE_ISOMETRIC_IMAGE]  Theorem
      
      ⊢ ∀f s e.
            0 < e ∧ subspace s ∧ linear f ∧
            (∀x. x ∈ s ⇒ abs (f x) ≥ e * abs x) ∧ complete s ⇒
            complete (IMAGE f s)
   
   [COMPLETE_UNIV]  Theorem
      
      ⊢ complete 𝕌(:real)
   
   [COMPONENTS_EMPTY]  Theorem
      
      ⊢ components ∅ = ∅
   
   [COMPONENTS_EQ]  Theorem
      
      ⊢ ∀s c c'.
            c ∈ components s ∧ c' ∈ components s ⇒ ((c = c') ⇔ c ∩ c' ≠ ∅)
   
   [COMPONENTS_EQ_EMPTY]  Theorem
      
      ⊢ ∀s. (components s = ∅) ⇔ (s = ∅)
   
   [COMPONENTS_EQ_SING]  Theorem
      
      ⊢ ∀s. (components s = {s}) ⇔ connected s ∧ s ≠ ∅
   
   [COMPONENTS_EQ_SING_EXISTS]  Theorem
      
      ⊢ ∀s. (∃a. components s = {a}) ⇔ connected s ∧ s ≠ ∅
   
   [COMPONENTS_EQ_SING_N_EXISTS]  Theorem
      
      ⊢ (∀s. (components s = {s}) ⇔ connected s ∧ s ≠ ∅) ∧
        ∀s. (∃a. components s = {a}) ⇔ connected s ∧ s ≠ ∅
   
   [COMPONENTS_INTERMEDIATE_SUBSET]  Theorem
      
      ⊢ ∀s t u. s ∈ components u ∧ s ⊆ t ∧ t ⊆ u ⇒ s ∈ components t
   
   [COMPONENTS_MAXIMAL]  Theorem
      
      ⊢ ∀s t c. c ∈ components s ∧ connected t ∧ t ⊆ s ∧ c ∩ t ≠ ∅ ⇒ t ⊆ c
   
   [COMPONENTS_NONOVERLAP]  Theorem
      
      ⊢ ∀s c c'.
            c ∈ components s ∧ c' ∈ components s ⇒ ((c ∩ c' = ∅) ⇔ c ≠ c')
   
   [COMPONENTS_UNIQUE]  Theorem
      
      ⊢ ∀s k.
            (BIGUNION k = s) ∧
            (∀c.
                 c ∈ k ⇒
                 connected c ∧ c ≠ ∅ ∧
                 ∀c'. connected c' ∧ c ⊆ c' ∧ c' ⊆ s ⇒ (c' = c)) ⇒
            (components s = k)
   
   [COMPONENTS_UNIQUE_EQ]  Theorem
      
      ⊢ ∀s k.
            (components s = k) ⇔
            (BIGUNION k = s) ∧
            ∀c.
                c ∈ k ⇒
                connected c ∧ c ≠ ∅ ∧
                ∀c'. connected c' ∧ c ⊆ c' ∧ c' ⊆ s ⇒ (c' = c)
   
   [COMPONENTS_UNIV]  Theorem
      
      ⊢ components 𝕌(:real) = {𝕌(:real)}
   
   [CONDENSATION_POINT_IMP_LIMPT]  Theorem
      
      ⊢ ∀x s. x condensation_point_of s ⇒ x limit_point_of s
   
   [CONDENSATION_POINT_INFINITE_BALL]  Theorem
      
      ⊢ ∀s x.
            x condensation_point_of s ⇔
            ∀e. 0 < e ⇒ ¬COUNTABLE (s ∩ ball (x,e))
   
   [CONDENSATION_POINT_INFINITE_BALL_CBALL]  Theorem
      
      ⊢ (∀s x.
             x condensation_point_of s ⇔
             ∀e. 0 < e ⇒ ¬COUNTABLE (s ∩ ball (x,e))) ∧
        ∀s x.
            x condensation_point_of s ⇔
            ∀e. 0 < e ⇒ ¬COUNTABLE (s ∩ cball (x,e))
   
   [CONDENSATION_POINT_INFINITE_CBALL]  Theorem
      
      ⊢ ∀s x.
            x condensation_point_of s ⇔
            ∀e. 0 < e ⇒ ¬COUNTABLE (s ∩ cball (x,e))
   
   [CONDENSATION_POINT_OF_SUBSET]  Theorem
      
      ⊢ ∀x s t.
            x condensation_point_of s ∧ s ⊆ t ⇒ x condensation_point_of t
   
   [CONNECTED_BIGUNION]  Theorem
      
      ⊢ ∀P.
            (∀s. s ∈ P ⇒ connected s) ∧ BIGINTER P ≠ ∅ ⇒
            connected (BIGUNION P)
   
   [CONNECTED_CHAIN]  Theorem
      
      ⊢ ∀f.
            (∀s. s ∈ f ⇒ compact s ∧ connected s) ∧
            (∀s t. s ∈ f ∧ t ∈ f ⇒ s ⊆ t ∨ t ⊆ s) ⇒
            connected (BIGINTER f)
   
   [CONNECTED_CHAIN_GEN]  Theorem
      
      ⊢ ∀f.
            (∀s. s ∈ f ⇒ closed s ∧ connected s) ∧
            (∃s. s ∈ f ∧ compact s) ∧ (∀s t. s ∈ f ∧ t ∈ f ⇒ s ⊆ t ∨ t ⊆ s) ⇒
            connected (BIGINTER f)
   
   [CONNECTED_CLOPEN]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ∀t.
                open_in (subtopology euclidean s) t ∧
                closed_in (subtopology euclidean s) t ⇒
                (t = ∅) ∨ (t = s)
   
   [CONNECTED_CLOSED]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ¬∃e1 e2.
                closed e1 ∧ closed e2 ∧ s ⊆ e1 ∪ e2 ∧ (e1 ∩ e2 ∩ s = ∅) ∧
                e1 ∩ s ≠ ∅ ∧ e2 ∩ s ≠ ∅
   
   [CONNECTED_CLOSED_IN]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ¬∃e1 e2.
                closed_in (subtopology euclidean s) e1 ∧
                closed_in (subtopology euclidean s) e2 ∧ s ⊆ e1 ∪ e2 ∧
                (e1 ∩ e2 = ∅) ∧ e1 ≠ ∅ ∧ e2 ≠ ∅
   
   [CONNECTED_CLOSED_IN_EQ]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ¬∃e1 e2.
                closed_in (subtopology euclidean s) e1 ∧
                closed_in (subtopology euclidean s) e2 ∧ (e1 ∪ e2 = s) ∧
                (e1 ∩ e2 = ∅) ∧ e1 ≠ ∅ ∧ e2 ≠ ∅
   
   [CONNECTED_CLOSED_MONOTONE_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀c.
                 closed_in (subtopology euclidean s) c ⇒
                 closed_in (subtopology euclidean t) (IMAGE f c)) ∧
            (∀y. y ∈ t ⇒ connected {x | x ∈ s ∧ (f x = y)}) ⇒
            ∀c. connected c ∧ c ⊆ t ⇒ connected {x | x ∈ s ∧ f x ∈ c}
   
   [CONNECTED_CLOSED_SET]  Theorem
      
      ⊢ ∀s.
            closed s ⇒
            (connected s ⇔
             ¬∃e1 e2.
                 closed e1 ∧ closed e2 ∧ e1 ≠ ∅ ∧ e2 ≠ ∅ ∧ (e1 ∪ e2 = s) ∧
                 (e1 ∩ e2 = ∅))
   
   [CONNECTED_CLOSURE]  Theorem
      
      ⊢ ∀s. connected s ⇒ connected (closure s)
   
   [CONNECTED_COMPONENT_BIGUNION]  Theorem
      
      ⊢ ∀s x.
            connected_component s x =
            BIGUNION {t | connected t ∧ x ∈ t ∧ t ⊆ s}
   
   [CONNECTED_COMPONENT_DISJOINT]  Theorem
      
      ⊢ ∀s a b.
            DISJOINT (connected_component s a) (connected_component s b) ⇔
            a ∉ connected_component s b
   
   [CONNECTED_COMPONENT_EMPTY]  Theorem
      
      ⊢ ∀x. connected_component ∅ x = ∅
   
   [CONNECTED_COMPONENT_EQ]  Theorem
      
      ⊢ ∀s x y.
            y ∈ connected_component s x ⇒
            (connected_component s y = connected_component s x)
   
   [CONNECTED_COMPONENT_EQUIVALENCE_RELATION]  Theorem
      
      ⊢ ∀R s.
            (∀x y. R x y ⇒ R y x) ∧ (∀x y z. R x y ∧ R y z ⇒ R x z) ∧
            (∀a.
                 a ∈ s ⇒
                 ∃t.
                     open_in (subtopology euclidean s) t ∧ a ∈ t ∧
                     ∀x. x ∈ t ⇒ R a x) ⇒
            ∀a b. connected_component s a b ⇒ R a b
   
   [CONNECTED_COMPONENT_EQ_EMPTY]  Theorem
      
      ⊢ ∀s x. (connected_component s x = ∅) ⇔ x ∉ s
   
   [CONNECTED_COMPONENT_EQ_EQ]  Theorem
      
      ⊢ ∀s x y.
            (connected_component s x = connected_component s y) ⇔
            x ∉ s ∧ y ∉ s ∨ x ∈ s ∧ y ∈ s ∧ connected_component s x y
   
   [CONNECTED_COMPONENT_EQ_SELF]  Theorem
      
      ⊢ ∀s x. connected s ∧ x ∈ s ⇒ (connected_component s x = s)
   
   [CONNECTED_COMPONENT_EQ_UNIV]  Theorem
      
      ⊢ ∀s x. (connected_component s x = 𝕌(:real)) ⇔ (s = 𝕌(:real))
   
   [CONNECTED_COMPONENT_IDEMP]  Theorem
      
      ⊢ ∀s x.
            connected_component (connected_component s x) x =
            connected_component s x
   
   [CONNECTED_COMPONENT_IN]  Theorem
      
      ⊢ ∀s x y. connected_component s x y ⇒ x ∈ s ∧ y ∈ s
   
   [CONNECTED_COMPONENT_INTERMEDIATE_SUBSET]  Theorem
      
      ⊢ ∀t u a.
            connected_component u a ⊆ t ∧ t ⊆ u ⇒
            (connected_component t a = connected_component u a)
   
   [CONNECTED_COMPONENT_MAXIMAL]  Theorem
      
      ⊢ ∀s t x. x ∈ t ∧ connected t ∧ t ⊆ s ⇒ t ⊆ connected_component s x
   
   [CONNECTED_COMPONENT_MONO]  Theorem
      
      ⊢ ∀s t x. s ⊆ t ⇒ connected_component s x ⊆ connected_component t x
   
   [CONNECTED_COMPONENT_NONOVERLAP]  Theorem
      
      ⊢ ∀s a b.
            (connected_component s a ∩ connected_component s b = ∅) ⇔
            a ∉ s ∨ b ∉ s ∨
            connected_component s a ≠ connected_component s b
   
   [CONNECTED_COMPONENT_OF_SUBSET]  Theorem
      
      ⊢ ∀s t x.
            s ⊆ t ∧ connected_component s x y ⇒ connected_component t x y
   
   [CONNECTED_COMPONENT_OVERLAP]  Theorem
      
      ⊢ ∀s a b.
            connected_component s a ∩ connected_component s b ≠ ∅ ⇔
            a ∈ s ∧ b ∈ s ∧
            (connected_component s a = connected_component s b)
   
   [CONNECTED_COMPONENT_REFL]  Theorem
      
      ⊢ ∀s x. x ∈ s ⇒ connected_component s x x
   
   [CONNECTED_COMPONENT_REFL_EQ]  Theorem
      
      ⊢ ∀s x. connected_component s x x ⇔ x ∈ s
   
   [CONNECTED_COMPONENT_SET]  Theorem
      
      ⊢ ∀s x.
            connected_component s x =
            {y | ∃t. connected t ∧ t ⊆ s ∧ x ∈ t ∧ y ∈ t}
   
   [CONNECTED_COMPONENT_SUBSET]  Theorem
      
      ⊢ ∀s x. connected_component s x ⊆ s
   
   [CONNECTED_COMPONENT_SYM]  Theorem
      
      ⊢ ∀s x y. connected_component s x y ⇒ connected_component s y x
   
   [CONNECTED_COMPONENT_SYM_EQ]  Theorem
      
      ⊢ ∀s x y. connected_component s x y ⇔ connected_component s y x
   
   [CONNECTED_COMPONENT_TRANS]  Theorem
      
      ⊢ ∀s x y.
            connected_component s x y ∧ connected_component s y z ⇒
            connected_component s x z
   
   [CONNECTED_COMPONENT_UNIQUE]  Theorem
      
      ⊢ ∀s c x.
            x ∈ c ∧ c ⊆ s ∧ connected c ∧
            (∀c'. x ∈ c' ∧ c' ⊆ s ∧ connected c' ⇒ c' ⊆ c) ⇒
            (connected_component s x = c)
   
   [CONNECTED_COMPONENT_UNIV]  Theorem
      
      ⊢ ∀x. connected_component 𝕌(:real) x = 𝕌(:real)
   
   [CONNECTED_CONNECTED_COMPONENT]  Theorem
      
      ⊢ ∀s x. connected (connected_component s x)
   
   [CONNECTED_CONNECTED_COMPONENT_SET]  Theorem
      
      ⊢ ∀s. connected s ⇔ ∀x. x ∈ s ⇒ (connected_component s x = s)
   
   [CONNECTED_CONTINUOUS_IMAGE]  Theorem
      
      ⊢ ∀f s. f continuous_on s ∧ connected s ⇒ connected (IMAGE f s)
   
   [CONNECTED_DIFF_OPEN_FROM_CLOSED]  Theorem
      
      ⊢ ∀s t u.
            s ⊆ t ∧ t ⊆ u ∧ open s ∧ closed t ∧ connected u ∧
            connected (t DIFF s) ⇒
            connected (u DIFF s)
   
   [CONNECTED_DISJOINT_BIGUNION_OPEN_UNIQUE]  Theorem
      
      ⊢ ∀f f'.
            pairwise DISJOINT f ∧ pairwise DISJOINT f' ∧
            (∀s. s ∈ f ⇒ open s ∧ connected s ∧ s ≠ ∅) ∧
            (∀s. s ∈ f' ⇒ open s ∧ connected s ∧ s ≠ ∅) ∧
            (BIGUNION f = BIGUNION f') ⇒
            (f = f')
   
   [CONNECTED_EMPTY]  Theorem
      
      ⊢ connected ∅
   
   [CONNECTED_EQUIVALENCE_RELATION]  Theorem
      
      ⊢ ∀R s.
            connected s ∧ (∀x y. R x y ⇒ R y x) ∧
            (∀x y z. R x y ∧ R y z ⇒ R x z) ∧
            (∀a.
                 a ∈ s ⇒
                 ∃t.
                     open_in (subtopology euclidean s) t ∧ a ∈ t ∧
                     ∀x. x ∈ t ⇒ R a x) ⇒
            ∀a b. a ∈ s ∧ b ∈ s ⇒ R a b
   
   [CONNECTED_EQUIVALENCE_RELATION_GEN]  Theorem
      
      ⊢ ∀P R s.
            connected s ∧ (∀x y. R x y ⇒ R y x) ∧
            (∀x y z. R x y ∧ R y z ⇒ R x z) ∧
            (∀t a.
                 open_in (subtopology euclidean s) t ∧ a ∈ t ⇒
                 ∃z. z ∈ t ∧ P z) ∧
            (∀a.
                 a ∈ s ⇒
                 ∃t.
                     open_in (subtopology euclidean s) t ∧ a ∈ t ∧
                     ∀x y. x ∈ t ∧ y ∈ t ∧ P x ∧ P y ⇒ R x y) ⇒
            ∀a b. a ∈ s ∧ b ∈ s ∧ P a ∧ P b ⇒ R a b
   
   [CONNECTED_EQ_COMPONENTS_SUBSET_SING]  Theorem
      
      ⊢ ∀s. connected s ⇔ components s ⊆ {s}
   
   [CONNECTED_EQ_COMPONENTS_SUBSET_SING_EXISTS]  Theorem
      
      ⊢ ∀s. connected s ⇔ ∃a. components s ⊆ {a}
   
   [CONNECTED_EQ_CONNECTED_COMPONENTS_EQ]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ∀c c'. c ∈ components s ∧ c' ∈ components s ⇒ (c = c')
   
   [CONNECTED_EQ_CONNECTED_COMPONENT_EQ]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ∀x y.
                x ∈ s ∧ y ∈ s ⇒
                (connected_component s x = connected_component s y)
   
   [CONNECTED_FROM_CLOSED_UNION_AND_INTER]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ closed t ∧ connected (s ∪ t) ∧ connected (s ∩ t) ⇒
            connected s ∧ connected t
   
   [CONNECTED_FROM_OPEN_UNION_AND_INTER]  Theorem
      
      ⊢ ∀s t.
            open s ∧ open t ∧ connected (s ∪ t) ∧ connected (s ∩ t) ⇒
            connected s ∧ connected t
   
   [CONNECTED_IFF_CONNECTABLE_POINTS]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ∀a b. a ∈ s ∧ b ∈ s ⇒ ∃t. connected t ∧ t ⊆ s ∧ a ∈ t ∧ b ∈ t
   
   [CONNECTED_IFF_CONNECTED_COMPONENT]  Theorem
      
      ⊢ ∀s. connected s ⇔ ∀x y. x ∈ s ∧ y ∈ s ⇒ connected_component s x y
   
   [CONNECTED_IMP_PERFECT]  Theorem
      
      ⊢ ∀s x. connected s ∧ ¬(∃a. s = {a}) ∧ x ∈ s ⇒ x limit_point_of s
   
   [CONNECTED_IMP_PERFECT_CLOSED]  Theorem
      
      ⊢ ∀s x.
            connected s ∧ closed s ∧ ¬(∃a. s = {a}) ⇒
            (x limit_point_of s ⇔ x ∈ s)
   
   [CONNECTED_INDUCTION]  Theorem
      
      ⊢ ∀P Q s.
            connected s ∧
            (∀t a.
                 open_in (subtopology euclidean s) t ∧ a ∈ t ⇒
                 ∃z. z ∈ t ∧ P z) ∧
            (∀a.
                 a ∈ s ⇒
                 ∃t.
                     open_in (subtopology euclidean s) t ∧ a ∈ t ∧
                     ∀x y. x ∈ t ∧ y ∈ t ∧ P x ∧ P y ∧ Q x ⇒ Q y) ⇒
            ∀a b. a ∈ s ∧ b ∈ s ∧ P a ∧ P b ∧ Q a ⇒ Q b
   
   [CONNECTED_INDUCTION_SIMPLE]  Theorem
      
      ⊢ ∀P s.
            connected s ∧
            (∀a.
                 a ∈ s ⇒
                 ∃t.
                     open_in (subtopology euclidean s) t ∧ a ∈ t ∧
                     ∀x y. x ∈ t ∧ y ∈ t ∧ P x ⇒ P y) ⇒
            ∀a b. a ∈ s ∧ b ∈ s ∧ P a ⇒ P b
   
   [CONNECTED_INTERMEDIATE_CLOSURE]  Theorem
      
      ⊢ ∀s t. connected s ∧ s ⊆ t ∧ t ⊆ closure s ⇒ connected t
   
   [CONNECTED_INTER_FRONTIER]  Theorem
      
      ⊢ ∀s t. connected s ∧ s ∩ t ≠ ∅ ∧ s DIFF t ≠ ∅ ⇒ s ∩ frontier t ≠ ∅
   
   [CONNECTED_IVT_COMPONENT]  Theorem
      
      ⊢ ∀s x y a.
            connected s ∧ x ∈ s ∧ y ∈ s ∧ x ≤ a ∧ a ≤ y ⇒
            ∃z. z ∈ s ∧ (z = a)
   
   [CONNECTED_IVT_HYPERPLANE]  Theorem
      
      ⊢ ∀s x y a b.
            connected s ∧ x ∈ s ∧ y ∈ s ∧ a * x ≤ b ∧ b ≤ a * y ⇒
            ∃z. z ∈ s ∧ (a * z = b)
   
   [CONNECTED_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s. connected s ∧ linear f ⇒ connected (IMAGE f s)
   
   [CONNECTED_MONOTONE_QUOTIENT_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀u.
                 u ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  open_in (subtopology euclidean t) u)) ∧
            (∀y. y ∈ t ⇒ connected {x | x ∈ s ∧ (f x = y)}) ∧ connected t ⇒
            connected s
   
   [CONNECTED_MONOTONE_QUOTIENT_PREIMAGE_GEN]  Theorem
      
      ⊢ ∀f s t c.
            (IMAGE f s = t) ∧
            (∀u.
                 u ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  open_in (subtopology euclidean t) u)) ∧
            (∀y. y ∈ t ⇒ connected {x | x ∈ s ∧ (f x = y)}) ∧
            (open_in (subtopology euclidean t) c ∨
             closed_in (subtopology euclidean t) c) ∧ connected c ⇒
            connected {x | x ∈ s ∧ f x ∈ c}
   
   [CONNECTED_NEGATIONS]  Theorem
      
      ⊢ ∀s. connected s ⇒ connected (IMAGE (λx. -x) s)
   
   [CONNECTED_NEST]  Theorem
      
      ⊢ ∀s.
            (∀n. compact (s n) ∧ connected (s n)) ∧
            (∀m n. m ≤ n ⇒ s n ⊆ s m) ⇒
            connected (BIGINTER {s n | n ∈ 𝕌(:num)})
   
   [CONNECTED_NEST_GEN]  Theorem
      
      ⊢ ∀s.
            (∀n. closed (s n) ∧ connected (s n)) ∧ (∃n. compact (s n)) ∧
            (∀m n. m ≤ n ⇒ s n ⊆ s m) ⇒
            connected (BIGINTER {s n | n ∈ 𝕌(:num)})
   
   [CONNECTED_OPEN_IN]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ¬∃e1 e2.
                open_in (subtopology euclidean s) e1 ∧
                open_in (subtopology euclidean s) e2 ∧ s ⊆ e1 ∪ e2 ∧
                (e1 ∩ e2 = ∅) ∧ e1 ≠ ∅ ∧ e2 ≠ ∅
   
   [CONNECTED_OPEN_IN_EQ]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ¬∃e1 e2.
                open_in (subtopology euclidean s) e1 ∧
                open_in (subtopology euclidean s) e2 ∧ (e1 ∪ e2 = s) ∧
                (e1 ∩ e2 = ∅) ∧ e1 ≠ ∅ ∧ e2 ≠ ∅
   
   [CONNECTED_OPEN_MONOTONE_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀c.
                 open_in (subtopology euclidean s) c ⇒
                 open_in (subtopology euclidean t) (IMAGE f c)) ∧
            (∀y. y ∈ t ⇒ connected {x | x ∈ s ∧ (f x = y)}) ⇒
            ∀c. connected c ∧ c ⊆ t ⇒ connected {x | x ∈ s ∧ f x ∈ c}
   
   [CONNECTED_OPEN_SET]  Theorem
      
      ⊢ ∀s.
            open s ⇒
            (connected s ⇔
             ¬∃e1 e2.
                 open e1 ∧ open e2 ∧ e1 ≠ ∅ ∧ e2 ≠ ∅ ∧ (e1 ∪ e2 = s) ∧
                 (e1 ∩ e2 = ∅))
   
   [CONNECTED_REAL_LEMMA]  Theorem
      
      ⊢ ∀f a b e1 e2.
            a ≤ b ∧ f a ∈ e1 ∧ f b ∈ e2 ∧
            (∀e x.
                 a ≤ x ∧ x ≤ b ∧ 0 < e ⇒
                 ∃d. 0 < d ∧ ∀y. abs (y − x) < d ⇒ dist (f y,f x) < e) ∧
            (∀y. y ∈ e1 ⇒ ∃e. 0 < e ∧ ∀y'. dist (y',y) < e ⇒ y' ∈ e1) ∧
            (∀y. y ∈ e2 ⇒ ∃e. 0 < e ∧ ∀y'. dist (y',y) < e ⇒ y' ∈ e2) ∧
            ¬(∃x. a ≤ x ∧ x ≤ b ∧ f x ∈ e1 ∧ f x ∈ e2) ⇒
            ∃x. a ≤ x ∧ x ≤ b ∧ f x ∉ e1 ∧ f x ∉ e2
   
   [CONNECTED_SCALING]  Theorem
      
      ⊢ ∀s c. connected s ⇒ connected (IMAGE (λx. c * x) s)
   
   [CONNECTED_SEGMENT]  Theorem
      
      ⊢ (∀a b. connected (segment [(a,b)])) ∧
        ∀a b. connected (segment (a,b))
   
   [CONNECTED_SING]  Theorem
      
      ⊢ ∀a. connected {a}
   
   [CONNECTED_SUBSET_CLOPEN]  Theorem
      
      ⊢ ∀u s c.
            closed_in (subtopology euclidean u) s ∧
            open_in (subtopology euclidean u) s ∧ connected c ∧ c ⊆ u ∧
            c ∩ s ≠ ∅ ⇒
            c ⊆ s
   
   [CONNECTED_TRANSLATION]  Theorem
      
      ⊢ ∀a s. connected s ⇒ connected (IMAGE (λx. a + x) s)
   
   [CONNECTED_TRANSLATION_EQ]  Theorem
      
      ⊢ ∀a s. connected (IMAGE (λx. a + x) s) ⇔ connected s
   
   [CONNECTED_UNION]  Theorem
      
      ⊢ ∀s t. connected s ∧ connected t ∧ s ∩ t ≠ ∅ ⇒ connected (s ∪ t)
   
   [CONNECTED_UNION_STRONG]  Theorem
      
      ⊢ ∀s t.
            connected s ∧ connected t ∧ closure s ∩ t ≠ ∅ ⇒
            connected (s ∪ t)
   
   [CONNECTED_UNIV]  Theorem
      
      ⊢ connected 𝕌(:real)
   
   [CONTINUOUS_ABS]  Theorem
      
      ⊢ ∀f net. f continuous net ⇒ (λx. abs (f x)) continuous net
   
   [CONTINUOUS_ABS_COMPOSE]  Theorem
      
      ⊢ ∀net f. f continuous net ⇒ (λx. abs (f x)) continuous net
   
   [CONTINUOUS_ADD]  Theorem
      
      ⊢ ∀f g net.
            f continuous net ∧ g continuous net ⇒
            (λx. f x + g x) continuous net
   
   [CONTINUOUS_AGREE_ON_CLOSURE]  Theorem
      
      ⊢ ∀g h.
            g continuous_on closure s ∧ h continuous_on closure s ∧
            (∀x. x ∈ s ⇒ (g x = h x)) ⇒
            ∀x. x ∈ closure s ⇒ (g x = h x)
   
   [CONTINUOUS_AT]  Theorem
      
      ⊢ ∀f x. f continuous at x ⇔ (f --> f x) (at x)
   
   [CONTINUOUS_ATTAINS_INF]  Theorem
      
      ⊢ ∀f s.
            compact s ∧ s ≠ ∅ ∧ f continuous_on s ⇒
            ∃x. x ∈ s ∧ ∀y. y ∈ s ⇒ f x ≤ f y
   
   [CONTINUOUS_ATTAINS_SUP]  Theorem
      
      ⊢ ∀f s.
            compact s ∧ s ≠ ∅ ∧ f continuous_on s ⇒
            ∃x. x ∈ s ∧ ∀y. y ∈ s ⇒ f y ≤ f x
   
   [CONTINUOUS_AT_ABS]  Theorem
      
      ⊢ ∀x. abs continuous at x
   
   [CONTINUOUS_AT_AVOID]  Theorem
      
      ⊢ ∀f x a.
            f continuous at x ∧ f x ≠ a ⇒
            ∃e. 0 < e ∧ ∀y. dist (x,y) < e ⇒ f y ≠ a
   
   [CONTINUOUS_AT_BALL]  Theorem
      
      ⊢ ∀f x.
            f continuous at x ⇔
            ∀e. 0 < e ⇒ ∃d. 0 < d ∧ IMAGE f (ball (x,d)) ⊆ ball (f x,e)
   
   [CONTINUOUS_AT_COMPOSE]  Theorem
      
      ⊢ ∀f g x.
            f continuous at x ∧ g continuous at (f x) ⇒
            g ∘ f continuous at x
   
   [CONTINUOUS_AT_COMPOSE_EQ]  Theorem
      
      ⊢ ∀f g h.
            g continuous at x ∧ h continuous at (g x) ∧ (∀y. g (h y) = y) ∧
            (h (g x) = x) ⇒
            (f continuous at (g x) ⇔ (λx. f (g x)) continuous at x)
   
   [CONTINUOUS_AT_DIST]  Theorem
      
      ⊢ ∀a x. (λx. dist (a,x)) continuous at x
   
   [CONTINUOUS_AT_DIST_CLOSEST_POINT]  Theorem
      
      ⊢ ∀s x.
            closed s ∧ s ≠ ∅ ⇒
            (λx. dist (x,closest_point s x)) continuous at x
   
   [CONTINUOUS_AT_ID]  Theorem
      
      ⊢ ∀a. (λx. x) continuous at a
   
   [CONTINUOUS_AT_IMP_CONTINUOUS_ON]  Theorem
      
      ⊢ ∀f s. (∀x. x ∈ s ⇒ f continuous at x) ⇒ f continuous_on s
   
   [CONTINUOUS_AT_INV]  Theorem
      
      ⊢ ∀f a. f continuous at a ∧ f a ≠ 0 ⇒ realinv ∘ f continuous at a
   
   [CONTINUOUS_AT_LIFT_DOT]  Theorem
      
      ⊢ ∀a x. (λy. a * y) continuous at x
   
   [CONTINUOUS_AT_OPEN]  Theorem
      
      ⊢ ∀f x.
            f continuous at x ⇔
            ∀t.
                open t ∧ f x ∈ t ⇒
                ∃s. open s ∧ x ∈ s ∧ ∀x'. x' ∈ s ⇒ f x' ∈ t
   
   [CONTINUOUS_AT_RANGE]  Theorem
      
      ⊢ ∀f x.
            f continuous at x ⇔
            ∀e.
                0 < e ⇒
                ∃d. 0 < d ∧ ∀x'. abs (x' − x) < d ⇒ abs (f x' − f x) < e
   
   [CONTINUOUS_AT_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f a.
            f continuous at a ⇔
            ∀x. (x --> a) sequentially ⇒ (f ∘ x --> f a) sequentially
   
   [CONTINUOUS_AT_SETDIST]  Theorem
      
      ⊢ ∀s x. (λy. setdist ({y},s)) continuous at x
   
   [CONTINUOUS_AT_TRANSLATION]  Theorem
      
      ⊢ ∀a z f. f continuous at (a + z) ⇔ (λx. f (a + x)) continuous at z
   
   [CONTINUOUS_AT_WITHIN]  Theorem
      
      ⊢ ∀f x s. f continuous at x ⇒ f continuous (at x within s)
   
   [CONTINUOUS_AT_WITHIN_INV]  Theorem
      
      ⊢ ∀f s a.
            f continuous (at a within s) ∧ f a ≠ 0 ⇒
            realinv ∘ f continuous (at a within s)
   
   [CONTINUOUS_CLOSED_IMP_CAUCHY_CONTINUOUS]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ∧ closed s ⇒
            ∀x. cauchy x ∧ (∀n. x n ∈ s) ⇒ cauchy (f ∘ x)
   
   [CONTINUOUS_CLOSED_IN_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ closed t ⇒
            closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_CLOSED_IN_PREIMAGE_CONSTANT]  Theorem
      
      ⊢ ∀f s a.
            f continuous_on s ⇒
            closed_in (subtopology euclidean s) {x | x ∈ s ∧ (f x = a)}
   
   [CONTINUOUS_CLOSED_IN_PREIMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ⇔
            ∀t.
                closed t ⇒
                closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_CLOSED_IN_PREIMAGE_GEN]  Theorem
      
      ⊢ ∀f s t u.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧
            closed_in (subtopology euclidean t) u ⇒
            closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u}
   
   [CONTINUOUS_CLOSED_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ closed s ∧ closed t ⇒
            closed {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_CLOSED_PREIMAGE_CONSTANT]  Theorem
      
      ⊢ ∀f s. f continuous_on s ∧ closed s ⇒ closed {x | x ∈ s ∧ (f x = a)}
   
   [CONTINUOUS_CLOSED_PREIMAGE_UNIV]  Theorem
      
      ⊢ ∀f s. (∀x. f continuous at x) ∧ closed s ⇒ closed {x | f x ∈ s}
   
   [CONTINUOUS_CMUL]  Theorem
      
      ⊢ ∀f c net. f continuous net ⇒ (λx. c * f x) continuous net
   
   [CONTINUOUS_COMPONENT_COMPOSE]  Theorem
      
      ⊢ ∀net f i. f continuous net ⇒ (λx. f x) continuous net
   
   [CONTINUOUS_CONST]  Theorem
      
      ⊢ ∀net c. (λx. c) continuous net
   
   [CONTINUOUS_CONSTANT_ON_CLOSURE]  Theorem
      
      ⊢ ∀f s a.
            f continuous_on closure s ∧ (∀x. x ∈ s ⇒ (f x = a)) ⇒
            ∀x. x ∈ closure s ⇒ (f x = a)
   
   [CONTINUOUS_DIAMETER]  Theorem
      
      ⊢ ∀s e.
            bounded s ∧ s ≠ ∅ ∧ 0 < e ⇒
            ∃d.
                0 < d ∧
                ∀t.
                    bounded t ∧ t ≠ ∅ ∧ hausdist (s,t) < d ⇒
                    abs (diameter s − diameter t) < e
   
   [CONTINUOUS_DISCONNECTED_DISCRETE_FINITE_RANGE_CONSTANT_EQ]  Theorem
      
      ⊢ (∀s.
             connected s ⇔
             ∀f t.
                 f continuous_on s ∧ IMAGE f s ⊆ t ∧
                 (∀y. y ∈ t ⇒ (connected_component t y = {y})) ⇒
                 ∃a. ∀x. x ∈ s ⇒ (f x = a)) ∧
        (∀s.
             connected s ⇔
             ∀f.
                 f continuous_on s ∧
                 (∀x.
                      x ∈ s ⇒
                      ∃e.
                          0 < e ∧
                          ∀y. y ∈ s ∧ f y ≠ f x ⇒ e ≤ abs (f y − f x)) ⇒
                 ∃a. ∀x. x ∈ s ⇒ (f x = a)) ∧
        ∀s.
            connected s ⇔
            ∀f.
                f continuous_on s ∧ FINITE (IMAGE f s) ⇒
                ∃a. ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_DISCONNECTED_RANGE_CONSTANT]  Theorem
      
      ⊢ ∀f s.
            connected s ∧ f continuous_on s ∧ IMAGE f s ⊆ t ∧
            (∀y. y ∈ t ⇒ (connected_component t y = {y})) ⇒
            ∃a. ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_DISCONNECTED_RANGE_CONSTANT_EQ]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ∀f t.
                f continuous_on s ∧ IMAGE f s ⊆ t ∧
                (∀y. y ∈ t ⇒ (connected_component t y = {y})) ⇒
                ∃a. ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_DISCRETE_RANGE_CONSTANT]  Theorem
      
      ⊢ ∀f s.
            connected s ∧ f continuous_on s ∧
            (∀x.
                 x ∈ s ⇒
                 ∃e. 0 < e ∧ ∀y. y ∈ s ∧ f y ≠ f x ⇒ e ≤ abs (f y − f x)) ⇒
            ∃a. ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_DISCRETE_RANGE_CONSTANT_EQ]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ∀f.
                f continuous_on s ∧
                (∀x.
                     x ∈ s ⇒
                     ∃e.
                         0 < e ∧
                         ∀y. y ∈ s ∧ f y ≠ f x ⇒ e ≤ abs (f y − f x)) ⇒
                ∃a. ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_DOT2]  Theorem
      
      ⊢ ∀net f g.
            f continuous net ∧ g continuous net ⇒
            (λx. f x * g x) continuous net
   
   [CONTINUOUS_FINITE_RANGE_CONSTANT]  Theorem
      
      ⊢ ∀f s.
            connected s ∧ f continuous_on s ∧ FINITE (IMAGE f s) ⇒
            ∃a. ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_FINITE_RANGE_CONSTANT_EQ]  Theorem
      
      ⊢ ∀s.
            connected s ⇔
            ∀f.
                f continuous_on s ∧ FINITE (IMAGE f s) ⇒
                ∃a. ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_GE_ON_CLOSURE]  Theorem
      
      ⊢ ∀f s a.
            f continuous_on closure s ∧ (∀x. x ∈ s ⇒ a ≤ f x) ⇒
            ∀x. x ∈ closure s ⇒ a ≤ f x
   
   [CONTINUOUS_IMP_CLOSED_MAP]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧ compact s ⇒
            ∀u.
                closed_in (subtopology euclidean s) u ⇒
                closed_in (subtopology euclidean t) (IMAGE f u)
   
   [CONTINUOUS_IMP_QUOTIENT_MAP]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧ compact s ⇒
            ∀u.
                u ⊆ t ⇒
                (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                 open_in (subtopology euclidean t) u)
   
   [CONTINUOUS_INV]  Theorem
      
      ⊢ ∀net f.
            f continuous net ∧ f (netlimit net) ≠ 0 ⇒
            realinv ∘ f continuous net
   
   [CONTINUOUS_LEFT_INVERSE_IMP_QUOTIENT_MAP]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ g continuous_on IMAGE f s ∧
            (∀x. x ∈ s ⇒ (g (f x) = x)) ⇒
            ∀u.
                u ⊆ IMAGE f s ⇒
                (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                 open_in (subtopology euclidean (IMAGE f s)) u)
   
   [CONTINUOUS_LEVELSET_OPEN]  Theorem
      
      ⊢ ∀f s a.
            connected s ∧ f continuous_on s ∧
            open {x | x ∈ s ∧ (f x = a)} ∧ (∃x. x ∈ s ∧ (f x = a)) ⇒
            ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_LEVELSET_OPEN_IN]  Theorem
      
      ⊢ ∀f s a.
            connected s ∧ f continuous_on s ∧
            open_in (subtopology euclidean s) {x | x ∈ s ∧ (f x = a)} ∧
            (∃x. x ∈ s ∧ (f x = a)) ⇒
            ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_LEVELSET_OPEN_IN_CASES]  Theorem
      
      ⊢ ∀f s a.
            connected s ∧ f continuous_on s ∧
            open_in (subtopology euclidean s) {x | x ∈ s ∧ (f x = a)} ⇒
            (∀x. x ∈ s ⇒ f x ≠ a) ∨ ∀x. x ∈ s ⇒ (f x = a)
   
   [CONTINUOUS_LE_ON_CLOSURE]  Theorem
      
      ⊢ ∀f s a.
            f continuous_on closure s ∧ (∀x. x ∈ s ⇒ f x ≤ a) ⇒
            ∀x. x ∈ closure s ⇒ f x ≤ a
   
   [CONTINUOUS_MAP_CLOSURES]  Theorem
      
      ⊢ ∀f.
            f continuous_on 𝕌(:real) ⇔
            ∀s. IMAGE f (closure s) ⊆ closure (IMAGE f s)
   
   [CONTINUOUS_MAX]  Theorem
      
      ⊢ ∀f g net.
            f continuous net ∧ g continuous net ⇒
            (λx. max (f x) (g x)) continuous net
   
   [CONTINUOUS_MIN]  Theorem
      
      ⊢ ∀f g net.
            f continuous net ∧ g continuous net ⇒
            (λx. min (f x) (g x)) continuous net
   
   [CONTINUOUS_MUL]  Theorem
      
      ⊢ ∀net f c.
            c continuous net ∧ f continuous net ⇒
            (λx. c x * f x) continuous net
   
   [CONTINUOUS_NEG]  Theorem
      
      ⊢ ∀f net. f continuous net ⇒ (λx. -f x) continuous net
   
   [CONTINUOUS_ON]  Theorem
      
      ⊢ ∀f s. f continuous_on s ⇔ ∀x. x ∈ s ⇒ (f --> f x) (at x within s)
   
   [CONTINUOUS_ON_ABS]  Theorem
      
      ⊢ ∀f s. f continuous_on s ⇒ (λx. abs (f x)) continuous_on s
   
   [CONTINUOUS_ON_ABS_COMPOSE]  Theorem
      
      ⊢ ∀f s. f continuous_on s ⇒ (λx. abs (f x)) continuous_on s
   
   [CONTINUOUS_ON_ADD]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ g continuous_on s ⇒
            (λx. f x + g x) continuous_on s
   
   [CONTINUOUS_ON_AVOID]  Theorem
      
      ⊢ ∀f x s a.
            f continuous_on s ∧ x ∈ s ∧ f x ≠ a ⇒
            ∃e. 0 < e ∧ ∀y. y ∈ s ∧ dist (x,y) < e ⇒ f y ≠ a
   
   [CONTINUOUS_ON_CASES]  Theorem
      
      ⊢ ∀P f g s t.
            closed s ∧ closed t ∧ f continuous_on s ∧ g continuous_on t ∧
            (∀x. x ∈ s ∧ ¬P x ∨ x ∈ t ∧ P x ⇒ (f x = g x)) ⇒
            (λx. if P x then f x else g x) continuous_on s ∪ t
   
   [CONTINUOUS_ON_CASES_1]  Theorem
      
      ⊢ ∀f g s a.
            f continuous_on {t | t ∈ s ∧ t ≤ a} ∧
            g continuous_on {t | t ∈ s ∧ a ≤ t} ∧ (a ∈ s ⇒ (f a = g a)) ⇒
            (λt. if t ≤ a then f t else g t) continuous_on s
   
   [CONTINUOUS_ON_CASES_LE]  Theorem
      
      ⊢ ∀f g h s a.
            f continuous_on {t | t ∈ s ∧ h t ≤ a} ∧
            g continuous_on {t | t ∈ s ∧ a ≤ h t} ∧ h continuous_on s ∧
            (∀t. t ∈ s ∧ (h t = a) ⇒ (f t = g t)) ⇒
            (λt. if h t ≤ a then f t else g t) continuous_on s
   
   [CONTINUOUS_ON_CASES_LOCAL]  Theorem
      
      ⊢ ∀P f g s t.
            closed_in (subtopology euclidean (s ∪ t)) s ∧
            closed_in (subtopology euclidean (s ∪ t)) t ∧
            f continuous_on s ∧ g continuous_on t ∧
            (∀x. x ∈ s ∧ ¬P x ∨ x ∈ t ∧ P x ⇒ (f x = g x)) ⇒
            (λx. if P x then f x else g x) continuous_on s ∪ t
   
   [CONTINUOUS_ON_CASES_LOCAL_OPEN]  Theorem
      
      ⊢ ∀P f g s t.
            open_in (subtopology euclidean (s ∪ t)) s ∧
            open_in (subtopology euclidean (s ∪ t)) t ∧ f continuous_on s ∧
            g continuous_on t ∧
            (∀x. x ∈ s ∧ ¬P x ∨ x ∈ t ∧ P x ⇒ (f x = g x)) ⇒
            (λx. if P x then f x else g x) continuous_on s ∪ t
   
   [CONTINUOUS_ON_CASES_OPEN]  Theorem
      
      ⊢ ∀P f g s t.
            open s ∧ open t ∧ f continuous_on s ∧ g continuous_on t ∧
            (∀x. x ∈ s ∧ ¬P x ∨ x ∈ t ∧ P x ⇒ (f x = g x)) ⇒
            (λx. if P x then f x else g x) continuous_on s ∪ t
   
   [CONTINUOUS_ON_CLOSED]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ⇔
            ∀t.
                closed_in (subtopology euclidean (IMAGE f s)) t ⇒
                closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_ON_CLOSED_GEN]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            (f continuous_on s ⇔
             ∀u.
                 closed_in (subtopology euclidean t) u ⇒
                 closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u})
   
   [CONTINUOUS_ON_CLOSURE]  Theorem
      
      ⊢ ∀f s.
            f continuous_on closure s ⇔
            ∀x e.
                x ∈ closure s ∧ 0 < e ⇒
                ∃d. 0 < d ∧ ∀y. y ∈ s ∧ dist (y,x) < d ⇒ dist (f y,f x) < e
   
   [CONTINUOUS_ON_CLOSURE_ABS_LE]  Theorem
      
      ⊢ ∀f s x b.
            f continuous_on closure s ∧ (∀y. y ∈ s ⇒ abs (f y) ≤ b) ∧
            x ∈ closure s ⇒
            abs (f x) ≤ b
   
   [CONTINUOUS_ON_CLOSURE_COMPONENT_GE]  Theorem
      
      ⊢ ∀f s x b.
            f continuous_on closure s ∧ (∀y. y ∈ s ⇒ b ≤ f y) ∧
            x ∈ closure s ⇒
            b ≤ f x
   
   [CONTINUOUS_ON_CLOSURE_COMPONENT_LE]  Theorem
      
      ⊢ ∀f s x b.
            f continuous_on closure s ∧ (∀y. y ∈ s ⇒ f y ≤ b) ∧
            x ∈ closure s ⇒
            f x ≤ b
   
   [CONTINUOUS_ON_CLOSURE_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f s.
            f continuous_on closure s ⇔
            ∀x a.
                a ∈ closure s ∧ (∀n. x n ∈ s) ∧ (x --> a) sequentially ⇒
                (f ∘ x --> f a) sequentially
   
   [CONTINUOUS_ON_CMUL]  Theorem
      
      ⊢ ∀f c s. f continuous_on s ⇒ (λx. c * f x) continuous_on s
   
   [CONTINUOUS_ON_COMPONENTS_FINITE]  Theorem
      
      ⊢ ∀f s.
            FINITE (components s) ∧
            (∀c. c ∈ components s ⇒ f continuous_on c) ⇒
            f continuous_on s
   
   [CONTINUOUS_ON_COMPONENTS_GEN]  Theorem
      
      ⊢ ∀f s.
            (∀c.
                 c ∈ components s ⇒
                 open_in (subtopology euclidean s) c ∧ f continuous_on c) ⇒
            f continuous_on s
   
   [CONTINUOUS_ON_COMPONENT_COMPOSE]  Theorem
      
      ⊢ ∀f s. f continuous_on s ⇒ (λx. f x) continuous_on s
   
   [CONTINUOUS_ON_COMPOSE]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ g continuous_on IMAGE f s ⇒
            g ∘ f continuous_on s
   
   [CONTINUOUS_ON_COMPOSE_QUOTIENT]  Theorem
      
      ⊢ ∀f g s t u.
            IMAGE f s ⊆ t ∧ IMAGE g t ⊆ u ∧
            (∀v.
                 v ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ v} ⇔
                  open_in (subtopology euclidean t) v)) ∧
            g ∘ f continuous_on s ⇒
            g continuous_on t
   
   [CONTINUOUS_ON_CONST]  Theorem
      
      ⊢ ∀s c. (λx. c) continuous_on s
   
   [CONTINUOUS_ON_DIST]  Theorem
      
      ⊢ ∀a s. (λx. dist (a,x)) continuous_on s
   
   [CONTINUOUS_ON_DIST_CLOSEST_POINT]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ s ≠ ∅ ⇒
            (λx. dist (x,closest_point s x)) continuous_on t
   
   [CONTINUOUS_ON_DOT2]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ g continuous_on s ⇒
            (λx. f x * g x) continuous_on s
   
   [CONTINUOUS_ON_EMPTY]  Theorem
      
      ⊢ ∀f. f continuous_on ∅
   
   [CONTINUOUS_ON_EQ]  Theorem
      
      ⊢ ∀f g s.
            (∀x. x ∈ s ⇒ (f x = g x)) ∧ f continuous_on s ⇒
            g continuous_on s
   
   [CONTINUOUS_ON_EQ_CONTINUOUS_AT]  Theorem
      
      ⊢ ∀f s. open s ⇒ (f continuous_on s ⇔ ∀x. x ∈ s ⇒ f continuous at x)
   
   [CONTINUOUS_ON_EQ_CONTINUOUS_WITHIN]  Theorem
      
      ⊢ ∀f s. f continuous_on s ⇔ ∀x. x ∈ s ⇒ f continuous (at x within s)
   
   [CONTINUOUS_ON_FINITE]  Theorem
      
      ⊢ ∀f s. FINITE s ⇒ f continuous_on s
   
   [CONTINUOUS_ON_ID]  Theorem
      
      ⊢ ∀s. (λx. x) continuous_on s
   
   [CONTINUOUS_ON_IMP_CLOSED_IN]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧
            closed_in (subtopology euclidean (IMAGE f s)) t ⇒
            closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_ON_IMP_OPEN_IN]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧
            open_in (subtopology euclidean (IMAGE f s)) t ⇒
            open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_ON_INTERIOR]  Theorem
      
      ⊢ ∀f s x. f continuous_on s ∧ x ∈ interior s ⇒ f continuous at x
   
   [CONTINUOUS_ON_INV]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ∧ (∀x. x ∈ s ⇒ f x ≠ 0) ⇒
            realinv ∘ f continuous_on s
   
   [CONTINUOUS_ON_INVERSE]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ compact s ∧ (∀x. x ∈ s ⇒ (g (f x) = x)) ⇒
            g continuous_on IMAGE f s
   
   [CONTINUOUS_ON_INVERSE_CLOSED_MAP]  Theorem
      
      ⊢ ∀f g s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x. x ∈ s ⇒ (g (f x) = x)) ∧
            (∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean t) (IMAGE f u)) ⇒
            g continuous_on t
   
   [CONTINUOUS_ON_INVERSE_OPEN_MAP]  Theorem
      
      ⊢ ∀f g s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x. x ∈ s ⇒ (g (f x) = x)) ∧
            (∀u.
                 open_in (subtopology euclidean s) u ⇒
                 open_in (subtopology euclidean t) (IMAGE f u)) ⇒
            g continuous_on t
   
   [CONTINUOUS_ON_LIFT_DOT]  Theorem
      
      ⊢ ∀s. (λy. a * y) continuous_on s
   
   [CONTINUOUS_ON_MAX]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ g continuous_on s ⇒
            (λx. max (f x) (g x)) continuous_on s
   
   [CONTINUOUS_ON_MIN]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ g continuous_on s ⇒
            (λx. min (f x) (g x)) continuous_on s
   
   [CONTINUOUS_ON_MUL]  Theorem
      
      ⊢ ∀s c f.
            c continuous_on s ∧ f continuous_on s ⇒
            (λx. c x * f x) continuous_on s
   
   [CONTINUOUS_ON_NEG]  Theorem
      
      ⊢ ∀f s. f continuous_on s ⇒ (λx. -f x) continuous_on s
   
   [CONTINUOUS_ON_NO_LIMPT]  Theorem
      
      ⊢ ∀f s. ¬(∃x. x limit_point_of s) ⇒ f continuous_on s
   
   [CONTINUOUS_ON_OPEN]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ⇔
            ∀t.
                open_in (subtopology euclidean (IMAGE f s)) t ⇒
                open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_ON_OPEN_AVOID]  Theorem
      
      ⊢ ∀f x s a.
            f continuous_on s ∧ open s ∧ x ∈ s ∧ f x ≠ a ⇒
            ∃e. 0 < e ∧ ∀y. dist (x,y) < e ⇒ f y ≠ a
   
   [CONTINUOUS_ON_OPEN_GEN]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            (f continuous_on s ⇔
             ∀u.
                 open_in (subtopology euclidean t) u ⇒
                 open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u})
   
   [CONTINUOUS_ON_POW]  Theorem
      
      ⊢ ∀f s n. (λx. f x) continuous_on s ⇒ (λx. f x pow n) continuous_on s
   
   [CONTINUOUS_ON_PRODUCT]  Theorem
      
      ⊢ ∀f s t.
            FINITE t ∧ (∀i. i ∈ t ⇒ (λx. f x i) continuous_on s) ⇒
            (λx. product t (f x)) continuous_on s
   
   [CONTINUOUS_ON_RANGE]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ⇔
            ∀x.
                x ∈ s ⇒
                ∀e.
                    0 < e ⇒
                    ∃d.
                        0 < d ∧
                        ∀x'.
                            x' ∈ s ∧ abs (x' − x) < d ⇒
                            abs (f x' − f x) < e
   
   [CONTINUOUS_ON_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ⇔
            ∀x a.
                a ∈ s ∧ (∀n. x n ∈ s) ∧ (x --> a) sequentially ⇒
                (f ∘ x --> f a) sequentially
   
   [CONTINUOUS_ON_SETDIST]  Theorem
      
      ⊢ ∀s t. (λy. setdist ({y},s)) continuous_on t
   
   [CONTINUOUS_ON_SING]  Theorem
      
      ⊢ ∀f a. f continuous_on {a}
   
   [CONTINUOUS_ON_SUB]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ g continuous_on s ⇒
            (λx. f x − g x) continuous_on s
   
   [CONTINUOUS_ON_SUBSET]  Theorem
      
      ⊢ ∀f s t. f continuous_on s ∧ t ⊆ s ⇒ f continuous_on t
   
   [CONTINUOUS_ON_SUM]  Theorem
      
      ⊢ ∀t f s.
            FINITE s ∧ (∀a. a ∈ s ⇒ f a continuous_on t) ⇒
            (λx. sum s (λa. f a x)) continuous_on t
   
   [CONTINUOUS_ON_UNION]  Theorem
      
      ⊢ ∀f s t.
            closed s ∧ closed t ∧ f continuous_on s ∧ f continuous_on t ⇒
            f continuous_on s ∪ t
   
   [CONTINUOUS_ON_UNION_LOCAL]  Theorem
      
      ⊢ ∀f s.
            closed_in (subtopology euclidean (s ∪ t)) s ∧
            closed_in (subtopology euclidean (s ∪ t)) t ∧
            f continuous_on s ∧ f continuous_on t ⇒
            f continuous_on s ∪ t
   
   [CONTINUOUS_ON_UNION_LOCAL_OPEN]  Theorem
      
      ⊢ ∀f s.
            open_in (subtopology euclidean (s ∪ t)) s ∧
            open_in (subtopology euclidean (s ∪ t)) t ∧ f continuous_on s ∧
            f continuous_on t ⇒
            f continuous_on s ∪ t
   
   [CONTINUOUS_ON_UNION_OPEN]  Theorem
      
      ⊢ ∀f s t.
            open s ∧ open t ∧ f continuous_on s ∧ f continuous_on t ⇒
            f continuous_on s ∪ t
   
   [CONTINUOUS_ON_VMUL]  Theorem
      
      ⊢ ∀s c v. c continuous_on s ⇒ (λx. c x * v) continuous_on s
   
   [CONTINUOUS_OPEN_IN_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ open t ⇒
            open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_OPEN_IN_PREIMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ⇔
            ∀t.
                open t ⇒
                open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_OPEN_IN_PREIMAGE_GEN]  Theorem
      
      ⊢ ∀f s t u.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧
            open_in (subtopology euclidean t) u ⇒
            open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u}
   
   [CONTINUOUS_OPEN_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ open s ∧ open t ⇒
            open {x | x ∈ s ∧ f x ∈ t}
   
   [CONTINUOUS_OPEN_PREIMAGE_UNIV]  Theorem
      
      ⊢ ∀f s. (∀x. f continuous at x) ∧ open s ⇒ open {x | f x ∈ s}
   
   [CONTINUOUS_POW]  Theorem
      
      ⊢ ∀net f n. (λx. f x) continuous net ⇒ (λx. f x pow n) continuous net
   
   [CONTINUOUS_PRODUCT]  Theorem
      
      ⊢ ∀net f t.
            FINITE t ∧ (∀i. i ∈ t ⇒ (λx. f x i) continuous net) ⇒
            (λx. product t (f x)) continuous net
   
   [CONTINUOUS_RIGHT_INVERSE_IMP_QUOTIENT_MAP]  Theorem
      
      ⊢ ∀f g s t.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧ g continuous_on t ∧
            IMAGE g t ⊆ s ∧ (∀y. y ∈ t ⇒ (f (g y) = y)) ⇒
            ∀u.
                u ⊆ t ⇒
                (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                 open_in (subtopology euclidean t) u)
   
   [CONTINUOUS_SUB]  Theorem
      
      ⊢ ∀f g net.
            f continuous net ∧ g continuous net ⇒
            (λx. f x − g x) continuous net
   
   [CONTINUOUS_SUM]  Theorem
      
      ⊢ ∀net f s.
            FINITE s ∧ (∀a. a ∈ s ⇒ f a continuous net) ⇒
            (λx. sum s (λa. f a x)) continuous net
   
   [CONTINUOUS_TRANSFORM_AT]  Theorem
      
      ⊢ ∀f g x d.
            0 < d ∧ (∀x'. dist (x',x) < d ⇒ (f x' = g x')) ∧
            f continuous at x ⇒
            g continuous at x
   
   [CONTINUOUS_TRANSFORM_WITHIN]  Theorem
      
      ⊢ ∀f g s x d.
            0 < d ∧ x ∈ s ∧
            (∀x'. x' ∈ s ∧ dist (x',x) < d ⇒ (f x' = g x')) ∧
            f continuous (at x within s) ⇒
            g continuous (at x within s)
   
   [CONTINUOUS_TRANSFORM_WITHIN_OPEN]  Theorem
      
      ⊢ ∀f g s a.
            open s ∧ a ∈ s ∧ (∀x. x ∈ s ⇒ (f x = g x)) ∧ f continuous at a ⇒
            g continuous at a
   
   [CONTINUOUS_TRANSFORM_WITHIN_OPEN_IN]  Theorem
      
      ⊢ ∀f g s t a.
            open_in (subtopology euclidean t) s ∧ a ∈ s ∧
            (∀x. x ∈ s ⇒ (f x = g x)) ∧ f continuous (at a within t) ⇒
            g continuous (at a within t)
   
   [CONTINUOUS_TRANSFORM_WITHIN_SET_IMP]  Theorem
      
      ⊢ ∀f a s t.
            eventually (λx. x ∈ t ⇒ x ∈ s) (at a) ∧
            f continuous (at a within s) ⇒
            f continuous (at a within t)
   
   [CONTINUOUS_TRIVIAL_LIMIT]  Theorem
      
      ⊢ ∀f net. trivial_limit net ⇒ f continuous net
   
   [CONTINUOUS_UNIFORM_LIMIT]  Theorem
      
      ⊢ ∀net f g s.
            ¬trivial_limit net ∧ eventually (λn. f n continuous_on s) net ∧
            (∀e.
                 0 < e ⇒
                 eventually (λn. ∀x. x ∈ s ⇒ abs (f n x − g x) < e) net) ⇒
            g continuous_on s
   
   [CONTINUOUS_VMUL]  Theorem
      
      ⊢ ∀net c v. c continuous net ⇒ (λx. c x * v) continuous net
   
   [CONTINUOUS_WITHIN]  Theorem
      
      ⊢ ∀f x. f continuous (at x within s) ⇔ (f --> f x) (at x within s)
   
   [CONTINUOUS_WITHIN_AVOID]  Theorem
      
      ⊢ ∀f x s a.
            f continuous (at x within s) ∧ x ∈ s ∧ f x ≠ a ⇒
            ∃e. 0 < e ∧ ∀y. y ∈ s ∧ dist (x,y) < e ⇒ f y ≠ a
   
   [CONTINUOUS_WITHIN_BALL]  Theorem
      
      ⊢ ∀f s x.
            f continuous (at x within s) ⇔
            ∀e. 0 < e ⇒ ∃d. 0 < d ∧ IMAGE f (ball (x,d) ∩ s) ⊆ ball (f x,e)
   
   [CONTINUOUS_WITHIN_CLOSED_NONTRIVIAL]  Theorem
      
      ⊢ ∀a s. closed s ∧ a ∉ s ⇒ f continuous (at a within s)
   
   [CONTINUOUS_WITHIN_COMPARISON]  Theorem
      
      ⊢ ∀f g s a.
            g continuous (at a within s) ∧
            (∀x. x ∈ s ⇒ dist (f a,f x) ≤ dist (g a,g x)) ⇒
            f continuous (at a within s)
   
   [CONTINUOUS_WITHIN_COMPOSE]  Theorem
      
      ⊢ ∀f g x s.
            f continuous (at x within s) ∧
            g continuous (at (f x) within IMAGE f s) ⇒
            g ∘ f continuous (at x within s)
   
   [CONTINUOUS_WITHIN_ID]  Theorem
      
      ⊢ ∀a s. (λx. x) continuous (at a within s)
   
   [CONTINUOUS_WITHIN_OPEN]  Theorem
      
      ⊢ ∀f x u.
            f continuous (at x within u) ⇔
            ∀t.
                open t ∧ f x ∈ t ⇒
                ∃s. open s ∧ x ∈ s ∧ ∀x'. x' ∈ s ∧ x' ∈ u ⇒ f x' ∈ t
   
   [CONTINUOUS_WITHIN_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f s a.
            f continuous (at a within s) ⇔
            ∀x.
                (∀n. x n ∈ s) ∧ (x --> a) sequentially ⇒
                (f ∘ x --> f a) sequentially
   
   [CONTINUOUS_WITHIN_SUBSET]  Theorem
      
      ⊢ ∀f s t x.
            f continuous (at x within s) ∧ t ⊆ s ⇒
            f continuous (at x within t)
   
   [CONTRACTION_IMP_CONTINUOUS_ON]  Theorem
      
      ⊢ ∀f.
            (∀x y. x ∈ s ∧ y ∈ s ⇒ dist (f x,f y) ≤ dist (x,y)) ⇒
            f continuous_on s
   
   [CONVERGENT_BOUNDED_INCREASING]  Theorem
      
      ⊢ ∀s b.
            (∀m n. m ≤ n ⇒ s m ≤ s n) ∧ (∀n. abs (s n) ≤ b) ⇒
            ∃l. ∀e. 0 < e ⇒ ∃N. ∀n. N ≤ n ⇒ abs (s n − l) < e
   
   [CONVERGENT_BOUNDED_MONOTONE]  Theorem
      
      ⊢ ∀s b.
            (∀n. abs (s n) ≤ b) ∧
            ((∀m n. m ≤ n ⇒ s m ≤ s n) ∨ ∀m n. m ≤ n ⇒ s n ≤ s m) ⇒
            ∃l. ∀e. 0 < e ⇒ ∃N. ∀n. N ≤ n ⇒ abs (s n − l) < e
   
   [CONVERGENT_EQ_CAUCHY]  Theorem
      
      ⊢ ∀s. (∃l. (s --> l) sequentially) ⇔ cauchy s
   
   [CONVERGENT_IMP_BOUNDED]  Theorem
      
      ⊢ ∀s l. (s --> l) sequentially ⇒ bounded (IMAGE s 𝕌(:num))
   
   [CONVERGENT_IMP_CAUCHY]  Theorem
      
      ⊢ ∀s l. (s --> l) sequentially ⇒ cauchy s
   
   [COUNTABLE_OPEN_INTERVAL]  Theorem
      
      ⊢ ∀a b. COUNTABLE (interval (a,b)) ⇔ (interval (a,b) = ∅)
   
   [DECREASING_CLOSED_NEST]  Theorem
      
      ⊢ ∀s.
            (∀n. closed (s n)) ∧ (∀n. s n ≠ ∅) ∧
            (∀m n. m ≤ n ⇒ s n ⊆ s m) ∧
            (∀e. 0 < e ⇒ ∃n. ∀x y. x ∈ s n ∧ y ∈ s n ⇒ dist (x,y) < e) ⇒
            ∃a. ∀n. a ∈ s n
   
   [DECREASING_CLOSED_NEST_SING]  Theorem
      
      ⊢ ∀s.
            (∀n. closed (s n)) ∧ (∀n. s n ≠ ∅) ∧
            (∀m n. m ≤ n ⇒ s n ⊆ s m) ∧
            (∀e. 0 < e ⇒ ∃n. ∀x y. x ∈ s n ∧ y ∈ s n ⇒ dist (x,y) < e) ⇒
            ∃a. BIGINTER {t | (∃n. t = s n)} = {a}
   
   [DENSE_IMP_PERFECT]  Theorem
      
      ⊢ ∀s. (closure s = 𝕌(:real)) ⇒ ∀x. x ∈ s ⇒ x limit_point_of s
   
   [DENSE_LIMIT_POINTS]  Theorem
      
      ⊢ ∀x. ({x | x limit_point_of s} = 𝕌(:real)) ⇔ (closure s = 𝕌(:real))
   
   [DENSE_OPEN_INTER]  Theorem
      
      ⊢ ∀s t u.
            open_in (subtopology euclidean u) s ∧ t ⊆ u ∨
            open_in (subtopology euclidean u) t ∧ s ⊆ u ⇒
            (u ⊆ closure (s ∩ t) ⇔ u ⊆ closure s ∧ u ⊆ closure t)
   
   [DEPENDENT_CHOICE]  Theorem
      
      ⊢ ∀P R.
            (∃a. P 0 a) ∧ (∀n x. P n x ⇒ ∃y. P (SUC n) y ∧ R n x y) ⇒
            ∃f. (∀n. P n (f n)) ∧ ∀n. R n (f n) (f (SUC n))
   
   [DEPENDENT_CHOICE_FIXED]  Theorem
      
      ⊢ ∀P R a.
            P 0 a ∧ (∀n x. P n x ⇒ ∃y. P (SUC n) y ∧ R n x y) ⇒
            ∃f. (f 0 = a) ∧ (∀n. P n (f n)) ∧ ∀n. R n (f n) (f (SUC n))
   
   [DEPENDENT_EXPLICIT]  Theorem
      
      ⊢ ∀p.
            dependent p ⇔
            ∃s u.
                FINITE s ∧ s ⊆ p ∧ (∃v. v ∈ s ∧ u v ≠ 0) ∧
                (sum s (λv. u v * v) = 0)
   
   [DEPENDENT_MONO]  Theorem
      
      ⊢ ∀s t. dependent s ∧ s ⊆ t ⇒ dependent t
   
   [DIAMETER_BALL]  Theorem
      
      ⊢ ∀a r. diameter (ball (a,r)) = if r < 0 then 0 else 2 * r
   
   [DIAMETER_BOUNDED]  Theorem
      
      ⊢ ∀s.
            bounded s ⇒
            (∀x y. x ∈ s ∧ y ∈ s ⇒ abs (x − y) ≤ diameter s) ∧
            ∀d.
                0 ≤ d ∧ d < diameter s ⇒
                ∃x y. x ∈ s ∧ y ∈ s ∧ abs (x − y) > d
   
   [DIAMETER_BOUNDED_BOUND]  Theorem
      
      ⊢ ∀s x y. bounded s ∧ x ∈ s ∧ y ∈ s ⇒ abs (x − y) ≤ diameter s
   
   [DIAMETER_CBALL]  Theorem
      
      ⊢ ∀a r. diameter (cball (a,r)) = if r < 0 then 0 else 2 * r
   
   [DIAMETER_CLOSURE]  Theorem
      
      ⊢ ∀s. bounded s ⇒ (diameter (closure s) = diameter s)
   
   [DIAMETER_EMPTY]  Theorem
      
      ⊢ diameter ∅ = 0
   
   [DIAMETER_EQ_0]  Theorem
      
      ⊢ ∀s. bounded s ⇒ ((diameter s = 0) ⇔ (s = ∅) ∨ ∃a. s = {a})
   
   [DIAMETER_INTERVAL]  Theorem
      
      ⊢ (∀a b.
             diameter (interval [(a,b)]) =
             if interval [(a,b)] = ∅ then 0 else abs (b − a)) ∧
        ∀a b.
            diameter (interval (a,b)) =
            if interval (a,b) = ∅ then 0 else abs (b − a)
   
   [DIAMETER_LE]  Theorem
      
      ⊢ ∀s d.
            (s ≠ ∅ ∨ 0 ≤ d) ∧ (∀x y. x ∈ s ∧ y ∈ s ⇒ abs (x − y) ≤ d) ⇒
            diameter s ≤ d
   
   [DIAMETER_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x. abs (f x) = abs x) ⇒
            (diameter (IMAGE f s) = diameter s)
   
   [DIAMETER_POS_LE]  Theorem
      
      ⊢ ∀s. bounded s ⇒ 0 ≤ diameter s
   
   [DIAMETER_SING]  Theorem
      
      ⊢ ∀a. diameter {a} = 0
   
   [DIAMETER_SUBSET]  Theorem
      
      ⊢ ∀s t. s ⊆ t ∧ bounded t ⇒ diameter s ≤ diameter t
   
   [DIAMETER_SUBSET_CBALL]  Theorem
      
      ⊢ ∀s. bounded s ⇒ ∃z. s ⊆ cball (z,diameter s)
   
   [DIAMETER_SUBSET_CBALL_NONEMPTY]  Theorem
      
      ⊢ ∀s. bounded s ∧ s ≠ ∅ ⇒ ∃z. z ∈ s ∧ s ⊆ cball (z,diameter s)
   
   [DIAMETER_SUMS]  Theorem
      
      ⊢ ∀s t.
            bounded s ∧ bounded t ⇒
            diameter {x + y | x ∈ s ∧ y ∈ t} ≤ diameter s + diameter t
   
   [DIFF_BIGINTER]  Theorem
      
      ⊢ ∀u s. u DIFF BIGINTER s = BIGUNION {u DIFF t | t ∈ s}
   
   [DIFF_CLOSURE_SUBSET]  Theorem
      
      ⊢ ∀s t. closure s DIFF closure t ⊆ closure (s DIFF t)
   
   [DIM_LE_CARD]  Theorem
      
      ⊢ ∀s. FINITE s ⇒ dim s ≤ CARD s
   
   [DIM_SUBSET]  Theorem
      
      ⊢ ∀s t. s ⊆ t ⇒ dim s ≤ dim t
   
   [DIM_SUBSET_UNIV]  Theorem
      
      ⊢ ∀s. dim s ≤ 1
   
   [DIM_SUBSTANDARD]  Theorem
      
      ⊢ dim {x | x = 0} = 0
   
   [DIM_UNIQUE]  Theorem
      
      ⊢ ∀v b.
            b ⊆ v ∧ v ⊆ span b ∧ independent b ∧ b HAS_SIZE n ⇒ (dim v = n)
   
   [DIM_UNIV]  Theorem
      
      ⊢ dim 𝕌(:real) = 1
   
   [DINI]  Theorem
      
      ⊢ ∀f g s.
            compact s ∧ (∀n. f n continuous_on s) ∧ g continuous_on s ∧
            (∀x. x ∈ s ⇒ ((λn. f n x) --> g x) sequentially) ∧
            (∀n x. x ∈ s ⇒ f n x ≤ f (n + 1) x) ⇒
            ∀e.
                0 < e ⇒
                eventually (λn. ∀x. x ∈ s ⇒ abs (f n x − g x) < e)
                  sequentially
   
   [DISCRETE_BOUNDED_IMP_FINITE]  Theorem
      
      ⊢ ∀s e.
            0 < e ∧ (∀x y. x ∈ s ∧ y ∈ s ∧ abs (y − x) < e ⇒ (y = x)) ∧
            bounded s ⇒
            FINITE s
   
   [DISCRETE_IMP_CLOSED]  Theorem
      
      ⊢ ∀s e.
            0 < e ∧ (∀x y. x ∈ s ∧ y ∈ s ∧ abs (y − x) < e ⇒ (y = x)) ⇒
            closed s
   
   [DISJOINT_INTERVAL]  Theorem
      
      ⊢ ∀a b c d.
            ((interval [(a,b)] ∩ interval [(c,d)] = ∅) ⇔
             b < a ∨ d < c ∨ b < c ∨ d < a) ∧
            ((interval [(a,b)] ∩ interval (c,d) = ∅) ⇔
             b < a ∨ d ≤ c ∨ b ≤ c ∨ d ≤ a) ∧
            ((interval (a,b) ∩ interval [(c,d)] = ∅) ⇔
             b ≤ a ∨ d < c ∨ b ≤ c ∨ d ≤ a) ∧
            ((interval (a,b) ∩ interval (c,d) = ∅) ⇔
             b ≤ a ∨ d ≤ c ∨ b ≤ c ∨ d ≤ a)
   
   [DISTANCE_ATTAINS_INF]  Theorem
      
      ⊢ ∀s a.
            closed s ∧ s ≠ ∅ ⇒
            ∃x. x ∈ s ∧ ∀y. y ∈ s ⇒ dist (a,x) ≤ dist (a,y)
   
   [DISTANCE_ATTAINS_SUP]  Theorem
      
      ⊢ ∀s a.
            compact s ∧ s ≠ ∅ ⇒
            ∃x. x ∈ s ∧ ∀y. y ∈ s ⇒ dist (a,y) ≤ dist (a,x)
   
   [DIST_0]  Theorem
      
      ⊢ ∀x. (dist (x,0) = abs x) ∧ (dist (0,x) = abs x)
   
   [DIST_CLOSEST_POINT_LIPSCHITZ]  Theorem
      
      ⊢ ∀s x y.
            closed s ∧ s ≠ ∅ ⇒
            abs (dist (x,closest_point s x) − dist (y,closest_point s y)) ≤
            dist (x,y)
   
   [DIST_EQ]  Theorem
      
      ⊢ ∀w x y z.
            (dist (w,x) = dist (y,z)) ⇔
            (dist (w,x) pow 2 = dist (y,z) pow 2)
   
   [DIST_EQ_0]  Theorem
      
      ⊢ ∀x y. (dist (x,y) = 0) ⇔ (x = y)
   
   [DIST_IN_CLOSED_SEGMENT]  Theorem
      
      ⊢ ∀a b x.
            x ∈ segment [(a,b)] ⇒
            dist (x,a) ≤ dist (a,b) ∧ dist (x,b) ≤ dist (a,b)
   
   [DIST_IN_OPEN_CLOSED_SEGMENT]  Theorem
      
      ⊢ (∀a b x.
             x ∈ segment [(a,b)] ⇒
             dist (x,a) ≤ dist (a,b) ∧ dist (x,b) ≤ dist (a,b)) ∧
        ∀a b x.
            x ∈ segment (a,b) ⇒
            dist (x,a) < dist (a,b) ∧ dist (x,b) < dist (a,b)
   
   [DIST_IN_OPEN_SEGMENT]  Theorem
      
      ⊢ ∀a b x.
            x ∈ segment (a,b) ⇒
            dist (x,a) < dist (a,b) ∧ dist (x,b) < dist (a,b)
   
   [DIST_LE_0]  Theorem
      
      ⊢ ∀x y. dist (x,y) ≤ 0 ⇔ (x = y)
   
   [DIST_MIDPOINT]  Theorem
      
      ⊢ ∀a b.
            (dist (a,midpoint (a,b)) = dist (a,b) / 2) ∧
            (dist (b,midpoint (a,b)) = dist (a,b) / 2) ∧
            (dist (midpoint (a,b),a) = dist (a,b) / 2) ∧
            (dist (midpoint (a,b),b) = dist (a,b) / 2)
   
   [DIST_MUL]  Theorem
      
      ⊢ ∀x y c. dist (c * x,c * y) = abs c * dist (x,y)
   
   [DIST_NZ]  Theorem
      
      ⊢ ∀x y. x ≠ y ⇔ 0 < dist (x,y)
   
   [DIST_POS_LE]  Theorem
      
      ⊢ ∀x y. 0 ≤ dist (x,y)
   
   [DIST_POS_LT]  Theorem
      
      ⊢ ∀x y. x ≠ y ⇒ 0 < dist (x,y)
   
   [DIST_REFL]  Theorem
      
      ⊢ ∀x. dist (x,x) = 0
   
   [DIST_SYM]  Theorem
      
      ⊢ ∀x y. dist (x,y) = dist (y,x)
   
   [DIST_TRIANGLE]  Theorem
      
      ⊢ ∀x y z. dist (x,z) ≤ dist (x,y) + dist (y,z)
   
   [DIST_TRIANGLE_ADD]  Theorem
      
      ⊢ ∀x x' y y'. dist (x + y,x' + y') ≤ dist (x,x') + dist (y,y')
   
   [DIST_TRIANGLE_ADD_HALF]  Theorem
      
      ⊢ ∀x x' y y'.
            dist (x,x') < e / 2 ∧ dist (y,y') < e / 2 ⇒
            dist (x + y,x' + y') < e
   
   [DIST_TRIANGLE_ALT]  Theorem
      
      ⊢ ∀x y z. dist (y,z) ≤ dist (x,y) + dist (x,z)
   
   [DIST_TRIANGLE_EQ]  Theorem
      
      ⊢ ∀x y z.
            (dist (x,z) = dist (x,y) + dist (y,z)) ⇔
            (abs (x − y) * (y − z) = abs (y − z) * (x − y))
   
   [DIST_TRIANGLE_HALF_L]  Theorem
      
      ⊢ ∀x1 x2 y.
            dist (x1,y) < e / 2 ∧ dist (x2,y) < e / 2 ⇒ dist (x1,x2) < e
   
   [DIST_TRIANGLE_HALF_R]  Theorem
      
      ⊢ ∀x1 x2 y.
            dist (y,x1) < e / 2 ∧ dist (y,x2) < e / 2 ⇒ dist (x1,x2) < e
   
   [DIST_TRIANGLE_LE]  Theorem
      
      ⊢ ∀x y z e. dist (x,z) + dist (y,z) ≤ e ⇒ dist (x,y) ≤ e
   
   [DIST_TRIANGLE_LT]  Theorem
      
      ⊢ ∀x y z e. dist (x,z) + dist (y,z) < e ⇒ dist (x,y) < e
   
   [EMPTY_AS_INTERVAL]  Theorem
      
      ⊢ ∅ = interval [(1,0)]
   
   [EMPTY_BIGUNION]  Theorem
      
      ⊢ ∀s. (BIGUNION s = ∅) ⇔ ∀t. t ∈ s ⇒ (t = ∅)
   
   [EMPTY_INTERIOR_FINITE]  Theorem
      
      ⊢ ∀s. FINITE s ⇒ (interior s = ∅)
   
   [ENDS_IN_INTERVAL]  Theorem
      
      ⊢ (∀a b. a ∈ interval [(a,b)] ⇔ interval [(a,b)] ≠ ∅) ∧
        (∀a b. b ∈ interval [(a,b)] ⇔ interval [(a,b)] ≠ ∅) ∧
        (∀a b. a ∉ interval (a,b)) ∧ ∀a b. b ∉ interval (a,b)
   
   [ENDS_IN_SEGMENT]  Theorem
      
      ⊢ ∀a b. a ∈ segment [(a,b)] ∧ b ∈ segment [(a,b)]
   
   [ENDS_IN_UNIT_INTERVAL]  Theorem
      
      ⊢ 0 ∈ interval [(0,1)] ∧ 1 ∈ interval [(0,1)] ∧ 0 ∉ interval (0,1) ∧
        1 ∉ interval (0,1)
   
   [ENDS_NOT_IN_SEGMENT]  Theorem
      
      ⊢ ∀a b. a ∉ segment (a,b) ∧ b ∉ segment (a,b)
   
   [EQ_BALLS]  Theorem
      
      ⊢ (∀a a' r r'.
             (ball (a,r) = ball (a',r')) ⇔
             (a = a') ∧ (r = r') ∨ r ≤ 0 ∧ r' ≤ 0) ∧
        (∀a a' r r'. (ball (a,r) = cball (a',r')) ⇔ r ≤ 0 ∧ r' < 0) ∧
        (∀a a' r r'. (cball (a,r) = ball (a',r')) ⇔ r < 0 ∧ r' ≤ 0) ∧
        ∀a a' r r'.
            (cball (a,r) = cball (a',r')) ⇔
            (a = a') ∧ (r = r') ∨ r < 0 ∧ r' < 0
   
   [EQ_INTERVAL]  Theorem
      
      ⊢ (∀a b c d.
             (interval [(a,b)] = interval [(c,d)]) ⇔
             (interval [(a,b)] = ∅) ∧ (interval [(c,d)] = ∅) ∨
             (a = c) ∧ (b = d)) ∧
        (∀a b c d.
             (interval [(a,b)] = interval (c,d)) ⇔
             (interval [(a,b)] = ∅) ∧ (interval (c,d) = ∅)) ∧
        (∀a b c d.
             (interval (a,b) = interval [(c,d)]) ⇔
             (interval (a,b) = ∅) ∧ (interval [(c,d)] = ∅)) ∧
        ∀a b c d.
            (interval (a,b) = interval (c,d)) ⇔
            (interval (a,b) = ∅) ∧ (interval (c,d) = ∅) ∨ (a = c) ∧ (b = d)
   
   [EVENTUALLY_AND]  Theorem
      
      ⊢ ∀net p q.
            eventually (λx. p x ∧ q x) net ⇔
            eventually p net ∧ eventually q net
   
   [EVENTUALLY_AT]  Theorem
      
      ⊢ ∀a p.
            eventually p (at a) ⇔
            ∃d. 0 < d ∧ ∀x. 0 < dist (x,a) ∧ dist (x,a) < d ⇒ p x
   
   [EVENTUALLY_AT_INFINITY]  Theorem
      
      ⊢ ∀p. eventually p at_infinity ⇔ ∃b. ∀x. abs x ≥ b ⇒ p x
   
   [EVENTUALLY_AT_INFINITY_POS]  Theorem
      
      ⊢ ∀p. eventually p at_infinity ⇔ ∃b. 0 < b ∧ ∀x. abs x ≥ b ⇒ p x
   
   [EVENTUALLY_AT_NEGINFINITY]  Theorem
      
      ⊢ ∀p. eventually p at_neginfinity ⇔ ∃b. ∀x. x ≤ b ⇒ p x
   
   [EVENTUALLY_AT_POSINFINITY]  Theorem
      
      ⊢ ∀p. eventually p at_posinfinity ⇔ ∃b. ∀x. x ≥ b ⇒ p x
   
   [EVENTUALLY_FALSE]  Theorem
      
      ⊢ ∀net. eventually (λx. F) net ⇔ trivial_limit net
   
   [EVENTUALLY_FORALL]  Theorem
      
      ⊢ ∀net p s.
            FINITE s ∧ s ≠ ∅ ⇒
            (eventually (λx. ∀a. a ∈ s ⇒ p a x) net ⇔
             ∀a. a ∈ s ⇒ eventually (p a) net)
   
   [EVENTUALLY_HAPPENS]  Theorem
      
      ⊢ ∀net p. eventually p net ⇒ trivial_limit net ∨ ∃x. p x
   
   [EVENTUALLY_MONO]  Theorem
      
      ⊢ ∀net p q. (∀x. p x ⇒ q x) ∧ eventually p net ⇒ eventually q net
   
   [EVENTUALLY_MP]  Theorem
      
      ⊢ ∀net p q.
            eventually (λx. p x ⇒ q x) net ∧ eventually p net ⇒
            eventually q net
   
   [EVENTUALLY_SEQUENTIALLY]  Theorem
      
      ⊢ ∀p. eventually p sequentially ⇔ ∃N. ∀n. N ≤ n ⇒ p n
   
   [EVENTUALLY_TRUE]  Theorem
      
      ⊢ ∀net. eventually (λx. T) net ⇔ T
   
   [EVENTUALLY_WITHIN]  Theorem
      
      ⊢ ∀s a p.
            eventually p (at a within s) ⇔
            ∃d. 0 < d ∧ ∀x. x ∈ s ∧ 0 < dist (x,a) ∧ dist (x,a) < d ⇒ p x
   
   [EVENTUALLY_WITHIN_INTERIOR]  Theorem
      
      ⊢ ∀p s x.
            x ∈ interior s ⇒
            (eventually p (at x within s) ⇔ eventually p (at x))
   
   [EVENTUALLY_WITHIN_LE]  Theorem
      
      ⊢ ∀s a p.
            eventually p (at a within s) ⇔
            ∃d. 0 < d ∧ ∀x. x ∈ s ∧ 0 < dist (x,a) ∧ dist (x,a) ≤ d ⇒ p x
   
   [EXCHANGE_LEMMA]  Theorem
      
      ⊢ ∀s t.
            FINITE t ∧ independent s ∧ s ⊆ span t ⇒
            ∃t'. t' HAS_SIZE CARD t ∧ s ⊆ t' ∧ t' ⊆ s ∪ t ∧ s ⊆ span t'
   
   [EXISTS_COMPONENT_SUPERSET]  Theorem
      
      ⊢ ∀s t. t ⊆ s ∧ s ≠ ∅ ∧ connected t ⇒ ∃c. c ∈ components s ∧ t ⊆ c
   
   [EXISTS_DIFF]  Theorem
      
      ⊢ (∃s. P (𝕌(:α) DIFF s)) ⇔ ∃s. P s
   
   [EXISTS_FINITE_SUBSET_IMAGE]  Theorem
      
      ⊢ ∀P f s.
            (∃t. FINITE t ∧ t ⊆ IMAGE f s ∧ P t) ⇔
            ∃t. FINITE t ∧ t ⊆ s ∧ P (IMAGE f t)
   
   [EXISTS_IN_GSPEC]  Theorem
      
      ⊢ (∀P f. (∃z. z ∈ {f x | P x} ∧ Q z) ⇔ ∃x. P x ∧ Q (f x)) ∧
        (∀P f. (∃z. z ∈ {f x y | P x y} ∧ Q z) ⇔ ∃x y. P x y ∧ Q (f x y)) ∧
        ∀P f.
            (∃z. z ∈ {f w x y | P w x y} ∧ Q z) ⇔
            ∃w x y. P w x y ∧ Q (f w x y)
   
   [EXISTS_IN_INSERT]  Theorem
      
      ⊢ ∀P a s. (∃x. x ∈ a INSERT s ∧ P x) ⇔ P a ∨ ∃x. x ∈ s ∧ P x
   
   [EXTENSION_FROM_CLOPEN]  Theorem
      
      ⊢ ∀f s t u.
            open_in (subtopology euclidean s) t ∧
            closed_in (subtopology euclidean s) t ∧ f continuous_on t ∧
            IMAGE f t ⊆ u ∧ ((u = ∅) ⇒ (s = ∅)) ⇒
            ∃g. g continuous_on s ∧ IMAGE g s ⊆ u ∧ ∀x. x ∈ t ⇒ (g x = f x)
   
   [FINITE_BALL]  Theorem
      
      ⊢ ∀a r. FINITE (ball (a,r)) ⇔ r ≤ 0
   
   [FINITE_CBALL]  Theorem
      
      ⊢ ∀a r. FINITE (cball (a,r)) ⇔ r ≤ 0
   
   [FINITE_IMP_BOUNDED]  Theorem
      
      ⊢ ∀s. FINITE s ⇒ bounded s
   
   [FINITE_IMP_CLOSED]  Theorem
      
      ⊢ ∀s. FINITE s ⇒ closed s
   
   [FINITE_IMP_CLOSED_IN]  Theorem
      
      ⊢ ∀s t. FINITE s ∧ s ⊆ t ⇒ closed_in (subtopology euclidean t) s
   
   [FINITE_IMP_COMPACT]  Theorem
      
      ⊢ ∀s. FINITE s ⇒ compact s
   
   [FINITE_IMP_NOT_OPEN]  Theorem
      
      ⊢ ∀s. FINITE s ∧ s ≠ ∅ ⇒ ¬open s
   
   [FINITE_INTERVAL]  Theorem
      
      ⊢ (∀a b. FINITE (interval [(a,b)]) ⇔ b ≤ a) ∧
        ∀a b. FINITE (interval (a,b)) ⇔ b ≤ a
   
   [FINITE_INTER_NUMSEG]  Theorem
      
      ⊢ ∀s m n. FINITE (s ∩ (m .. n))
   
   [FINITE_POWERSET]  Theorem
      
      ⊢ ∀s. FINITE s ⇒ FINITE {t | t ⊆ s}
   
   [FINITE_SET_AVOID]  Theorem
      
      ⊢ ∀a s. FINITE s ⇒ ∃d. 0 < d ∧ ∀x. x ∈ s ∧ x ≠ a ⇒ d ≤ dist (a,x)
   
   [FINITE_SPHERE]  Theorem
      
      ⊢ ∀a r. FINITE (sphere (a,r))
   
   [FINITE_SUBSET_IMAGE]  Theorem
      
      ⊢ ∀f s t.
            FINITE t ∧ t ⊆ IMAGE f s ⇔
            ∃s'. FINITE s' ∧ s' ⊆ s ∧ (t = IMAGE f s')
   
   [FORALL_EVENTUALLY]  Theorem
      
      ⊢ ∀net p s.
            FINITE s ∧ s ≠ ∅ ⇒
            ((∀a. a ∈ s ⇒ eventually (p a) net) ⇔
             eventually (λx. ∀a. a ∈ s ⇒ p a x) net)
   
   [FORALL_FINITE_SUBSET_IMAGE]  Theorem
      
      ⊢ ∀P f s.
            (∀t. FINITE t ∧ t ⊆ IMAGE f s ⇒ P t) ⇔
            ∀t. FINITE t ∧ t ⊆ s ⇒ P (IMAGE f t)
   
   [FORALL_IN_CLOSURE]  Theorem
      
      ⊢ ∀f s t.
            closed t ∧ f continuous_on closure s ∧ (∀x. x ∈ s ⇒ f x ∈ t) ⇒
            ∀x. x ∈ closure s ⇒ f x ∈ t
   
   [FORALL_IN_CLOSURE_EQ]  Theorem
      
      ⊢ ∀f s t.
            closed t ∧ f continuous_on closure s ⇒
            ((∀x. x ∈ closure s ⇒ f x ∈ t) ⇔ ∀x. x ∈ s ⇒ f x ∈ t)
   
   [FORALL_IN_GSPEC]  Theorem
      
      ⊢ (∀P f. (∀z. z ∈ {f x | P x} ⇒ Q z) ⇔ ∀x. P x ⇒ Q (f x)) ∧
        (∀P f. (∀z. z ∈ {f x y | P x y} ⇒ Q z) ⇔ ∀x y. P x y ⇒ Q (f x y)) ∧
        ∀P f.
            (∀z. z ∈ {f w x y | P w x y} ⇒ Q z) ⇔
            ∀w x y. P w x y ⇒ Q (f w x y)
   
   [FORALL_POS_MONO]  Theorem
      
      ⊢ ∀P.
            (∀d e. d < e ∧ P d ⇒ P e) ∧ (∀n. n ≠ 0 ⇒ P (&n)⁻¹) ⇒
            ∀e. 0 < e ⇒ P e
   
   [FORALL_POS_MONO_1]  Theorem
      
      ⊢ ∀P.
            (∀d e. d < e ∧ P d ⇒ P e) ∧ (∀n. P (&n + 1)⁻¹) ⇒
            ∀e. 0 < e ⇒ P e
   
   [FORALL_SUC]  Theorem
      
      ⊢ (∀n. n ≠ 0 ⇒ P n) ⇔ ∀n. P (SUC n)
   
   [FROM_INTER_NUMSEG]  Theorem
      
      ⊢ ∀k n. from k ∩ (0 .. n) = k .. n
   
   [FROM_INTER_NUMSEG_GEN]  Theorem
      
      ⊢ ∀k m n. from k ∩ (m .. n) = if m < k then k .. n else m .. n
   
   [FROM_INTER_NUMSEG_MAX]  Theorem
      
      ⊢ ∀m n p. from p ∩ (m .. n) = MAX p m .. n
   
   [FRONTIER_BALL]  Theorem
      
      ⊢ ∀a e. 0 < e ⇒ (frontier (ball (a,e)) = sphere (a,e))
   
   [FRONTIER_CBALL]  Theorem
      
      ⊢ ∀a e. frontier (cball (a,e)) = sphere (a,e)
   
   [FRONTIER_CLOSED]  Theorem
      
      ⊢ ∀s. closed (frontier s)
   
   [FRONTIER_CLOSED_INTERVAL]  Theorem
      
      ⊢ ∀a b.
            frontier (interval [(a,b)]) =
            interval [(a,b)] DIFF interval (a,b)
   
   [FRONTIER_CLOSURES]  Theorem
      
      ⊢ ∀s. frontier s = closure s ∩ closure (𝕌(:real) DIFF s)
   
   [FRONTIER_CLOSURE_SUBSET]  Theorem
      
      ⊢ ∀s. frontier (closure s) ⊆ frontier s
   
   [FRONTIER_COMPLEMENT]  Theorem
      
      ⊢ ∀s. frontier (𝕌(:real) DIFF s) = frontier s
   
   [FRONTIER_DISJOINT_EQ]  Theorem
      
      ⊢ ∀s. (frontier s ∩ s = ∅) ⇔ open s
   
   [FRONTIER_EMPTY]  Theorem
      
      ⊢ frontier ∅ = ∅
   
   [FRONTIER_FRONTIER]  Theorem
      
      ⊢ ∀s. open s ∨ closed s ⇒ (frontier (frontier s) = frontier s)
   
   [FRONTIER_FRONTIER_FRONTIER]  Theorem
      
      ⊢ ∀s. frontier (frontier (frontier s)) = frontier (frontier s)
   
   [FRONTIER_FRONTIER_SUBSET]  Theorem
      
      ⊢ ∀s. frontier (frontier s) ⊆ frontier s
   
   [FRONTIER_HALFSPACE_GE]  Theorem
      
      ⊢ ∀a b.
            ¬((a = 0) ∧ (b = 0)) ⇒
            (frontier {x | a * x ≥ b} = {x | a * x = b})
   
   [FRONTIER_HALFSPACE_GT]  Theorem
      
      ⊢ ∀a b.
            ¬((a = 0) ∧ (b = 0)) ⇒
            (frontier {x | a * x > b} = {x | a * x = b})
   
   [FRONTIER_HALFSPACE_LE]  Theorem
      
      ⊢ ∀a b.
            ¬((a = 0) ∧ (b = 0)) ⇒
            (frontier {x | a * x ≤ b} = {x | a * x = b})
   
   [FRONTIER_HALFSPACE_LT]  Theorem
      
      ⊢ ∀a b.
            ¬((a = 0) ∧ (b = 0)) ⇒
            (frontier {x | a * x < b} = {x | a * x = b})
   
   [FRONTIER_INTERIORS]  Theorem
      
      ⊢ ∀s.
            frontier s =
            𝕌(:real) DIFF interior s DIFF interior (𝕌(:real) DIFF s)
   
   [FRONTIER_INTERIOR_SUBSET]  Theorem
      
      ⊢ ∀s. frontier (interior s) ⊆ frontier s
   
   [FRONTIER_INTER_SUBSET]  Theorem
      
      ⊢ ∀s t. frontier (s ∩ t) ⊆ frontier s ∪ frontier t
   
   [FRONTIER_INTER_SUBSET_INTER]  Theorem
      
      ⊢ ∀s t.
            frontier (s ∩ t) ⊆
            closure s ∩ frontier t ∪ frontier s ∩ closure t
   
   [FRONTIER_OPEN_INTERVAL]  Theorem
      
      ⊢ ∀a b.
            frontier (interval (a,b)) =
            if interval (a,b) = ∅ then ∅
            else interval [(a,b)] DIFF interval (a,b)
   
   [FRONTIER_SING]  Theorem
      
      ⊢ ∀a. frontier {a} = {a}
   
   [FRONTIER_STRADDLE]  Theorem
      
      ⊢ ∀a s.
            a ∈ frontier s ⇔
            ∀e.
                0 < e ⇒
                (∃x. x ∈ s ∧ dist (a,x) < e) ∧ ∃x. x ∉ s ∧ dist (a,x) < e
   
   [FRONTIER_SUBSET_CLOSED]  Theorem
      
      ⊢ ∀s. closed s ⇒ frontier s ⊆ s
   
   [FRONTIER_SUBSET_COMPACT]  Theorem
      
      ⊢ ∀s. compact s ⇒ frontier s ⊆ s
   
   [FRONTIER_SUBSET_EQ]  Theorem
      
      ⊢ ∀s. frontier s ⊆ s ⇔ closed s
   
   [FRONTIER_UNION]  Theorem
      
      ⊢ ∀s t.
            (closure s ∩ closure t = ∅) ⇒
            (frontier (s ∪ t) = frontier s ∪ frontier t)
   
   [FRONTIER_UNION_SUBSET]  Theorem
      
      ⊢ ∀s t. frontier (s ∪ t) ⊆ frontier s ∪ frontier t
   
   [FRONTIER_UNIV]  Theorem
      
      ⊢ frontier 𝕌(:real) = ∅
   
   [FSIGMA_COMPLEMENT]  Theorem
      
      ⊢ ∀s. fsigma (𝕌(:real) DIFF s) ⇔ gdelta s
   
   [FUNCTION_FACTORS_LEFT_GEN]  Theorem
      
      ⊢ ∀P f g.
            (∀x y. P x ∧ P y ∧ (g x = g y) ⇒ (f x = f y)) ⇔
            ∃h. ∀x. P x ⇒ (f x = h (g x))
   
   [FUN_IN_IMAGE]  Theorem
      
      ⊢ ∀f s x. x ∈ s ⇒ f x ∈ IMAGE f s
   
   [GDELTA_COMPLEMENT]  Theorem
      
      ⊢ ∀s. gdelta (𝕌(:real) DIFF s) ⇔ fsigma s
   
   [GREATER_EQ_REFL]  Theorem
      
      ⊢ ∀m. m ≥ m
   
   [HAS_SIZE_STDBASIS]  Theorem
      
      ⊢ {i | 1 ≤ i ∧ i ≤ 1} HAS_SIZE 1
   
   [HAUSDIST_ALT]  Theorem
      
      ⊢ ∀s t.
            bounded s ∧ bounded t ∧ s ≠ ∅ ∧ t ≠ ∅ ⇒
            (hausdist (s,t) =
             sup {abs (setdist ({x},s) − setdist ({x},t)) | x ∈ 𝕌(:real)})
   
   [HAUSDIST_CLOSURE]  Theorem
      
      ⊢ (∀s t. hausdist (closure s,t) = hausdist (s,t)) ∧
        ∀s t. hausdist (s,closure t) = hausdist (s,t)
   
   [HAUSDIST_COMPACT_EXISTS]  Theorem
      
      ⊢ ∀s t.
            bounded s ∧ compact t ∧ t ≠ ∅ ⇒
            ∀x. x ∈ s ⇒ ∃y. y ∈ t ∧ dist (x,y) ≤ hausdist (s,t)
   
   [HAUSDIST_COMPACT_NONTRIVIAL]  Theorem
      
      ⊢ ∀s t.
            compact s ∧ compact t ∧ s ≠ ∅ ∧ t ≠ ∅ ⇒
            (hausdist (s,t) =
             inf
               {e |
                0 ≤ e ∧ s ⊆ {x + y | x ∈ t ∧ abs y ≤ e} ∧
                t ⊆ {x + y | x ∈ s ∧ abs y ≤ e}})
   
   [HAUSDIST_COMPACT_SUMS]  Theorem
      
      ⊢ ∀s t.
            bounded s ∧ compact t ∧ t ≠ ∅ ⇒
            s ⊆ {y + z | y ∈ t ∧ z ∈ cball (0,hausdist (s,t))}
   
   [HAUSDIST_EMPTY]  Theorem
      
      ⊢ (∀t. hausdist (∅,t) = 0) ∧ ∀s. hausdist (s,∅) = 0
   
   [HAUSDIST_EQ]  Theorem
      
      ⊢ ∀s t s' t'.
            (∀b.
                 (∀x. x ∈ s ⇒ setdist ({x},t) ≤ b) ∧
                 (∀y. y ∈ t ⇒ setdist ({y},s) ≤ b) ⇔
                 (∀x. x ∈ s' ⇒ setdist ({x},t') ≤ b) ∧
                 ∀y. y ∈ t' ⇒ setdist ({y},s') ≤ b) ⇒
            (hausdist (s,t) = hausdist (s',t'))
   
   [HAUSDIST_EQ_0]  Theorem
      
      ⊢ ∀s t.
            bounded s ∧ bounded t ⇒
            ((hausdist (s,t) = 0) ⇔
             (s = ∅) ∨ (t = ∅) ∨ (closure s = closure t))
   
   [HAUSDIST_INSERT_LE]  Theorem
      
      ⊢ ∀s t a.
            bounded s ∧ bounded t ∧ s ≠ ∅ ∧ t ≠ ∅ ⇒
            hausdist (a INSERT s,a INSERT t) ≤ hausdist (s,t)
   
   [HAUSDIST_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s t.
            linear f ∧ (∀x. abs (f x) = abs x) ⇒
            (hausdist (IMAGE f s,IMAGE f t) = hausdist (s,t))
   
   [HAUSDIST_NONTRIVIAL]  Theorem
      
      ⊢ ∀s t.
            bounded s ∧ bounded t ∧ s ≠ ∅ ∧ t ≠ ∅ ⇒
            (hausdist (s,t) =
             sup ({setdist ({x},t) | x ∈ s} ∪ {setdist ({y},s) | y ∈ t}))
   
   [HAUSDIST_NONTRIVIAL_ALT]  Theorem
      
      ⊢ ∀s t.
            bounded s ∧ bounded t ∧ s ≠ ∅ ∧ t ≠ ∅ ⇒
            (hausdist (s,t) =
             max (sup {setdist ({x},t) | x ∈ s})
               (sup {setdist ({y},s) | y ∈ t}))
   
   [HAUSDIST_POS_LE]  Theorem
      
      ⊢ ∀s t. 0 ≤ hausdist (s,t)
   
   [HAUSDIST_REFL]  Theorem
      
      ⊢ ∀s. hausdist (s,s) = 0
   
   [HAUSDIST_SETDIST_TRIANGLE]  Theorem
      
      ⊢ ∀s t u.
            t ≠ ∅ ∧ bounded s ∧ bounded t ⇒
            setdist (s,u) ≤ hausdist (s,t) + setdist (t,u)
   
   [HAUSDIST_SINGS]  Theorem
      
      ⊢ ∀x y. hausdist ({x},{y}) = dist (x,y)
   
   [HAUSDIST_SYM]  Theorem
      
      ⊢ ∀s t. hausdist (s,t) = hausdist (t,s)
   
   [HAUSDIST_TRANS]  Theorem
      
      ⊢ ∀s t u.
            bounded s ∧ bounded t ∧ bounded u ∧ t ≠ ∅ ⇒
            hausdist (s,u) ≤ hausdist (s,t) + hausdist (t,u)
   
   [HAUSDIST_TRANSLATION]  Theorem
      
      ⊢ ∀a s t.
            hausdist (IMAGE (λx. a + x) s,IMAGE (λx. a + x) t) =
            hausdist (s,t)
   
   [HAUSDIST_TRIANGLE]  Theorem
      
      ⊢ ∀s t u.
            bounded s ∧ bounded t ∧ bounded u ∧ t ≠ ∅ ⇒
            hausdist (s,u) ≤ hausdist (s,t) + hausdist (t,u)
   
   [HAUSDIST_UNION_LE]  Theorem
      
      ⊢ ∀s t u.
            bounded s ∧ bounded t ∧ bounded u ∧ t ≠ ∅ ∧ u ≠ ∅ ⇒
            hausdist (s ∪ t,s ∪ u) ≤ hausdist (t,u)
   
   [HEINE_BOREL_IMP_BOLZANO_WEIERSTRASS]  Theorem
      
      ⊢ ∀s.
            (∀f.
                 (∀t. t ∈ f ⇒ open t) ∧ s ⊆ BIGUNION f ⇒
                 ∃f'. f' ⊆ f ∧ FINITE f' ∧ s ⊆ BIGUNION f') ⇒
            ∀t. INFINITE t ∧ t ⊆ s ⇒ ∃x. x ∈ s ∧ x limit_point_of t
   
   [HEINE_BOREL_LEMMA]  Theorem
      
      ⊢ ∀s.
            compact s ⇒
            ∀t.
                s ⊆ BIGUNION t ∧ (∀b. b ∈ t ⇒ open b) ⇒
                ∃e. 0 < e ∧ ∀x. x ∈ s ⇒ ∃b. b ∈ t ∧ ball (x,e) ⊆ b
   
   [HOMEOMORPHIC_AFFINITY]  Theorem
      
      ⊢ ∀s a c. c ≠ 0 ⇒ s homeomorphic IMAGE (λx. a + c * x) s
   
   [HOMEOMORPHIC_BALLS]  Theorem
      
      ⊢ ∀a b d e. 0 < d ∧ 0 < e ⇒ ball (a,d) homeomorphic ball (b,e)
   
   [HOMEOMORPHIC_BALLS_CBALL_SPHERE]  Theorem
      
      ⊢ (∀a b d e. 0 < d ∧ 0 < e ⇒ ball (a,d) homeomorphic ball (b,e)) ∧
        (∀a b d e. 0 < d ∧ 0 < e ⇒ cball (a,d) homeomorphic cball (b,e)) ∧
        ∀a b d e. 0 < d ∧ 0 < e ⇒ sphere (a,d) homeomorphic sphere (b,e)
   
   [HOMEOMORPHIC_CBALL]  Theorem
      
      ⊢ ∀a b d e. 0 < d ∧ 0 < e ⇒ cball (a,d) homeomorphic cball (b,e)
   
   [HOMEOMORPHIC_COMPACT]  Theorem
      
      ⊢ ∀s f t.
            compact s ∧ f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ⇒
            s homeomorphic t
   
   [HOMEOMORPHIC_COMPACTNESS]  Theorem
      
      ⊢ ∀s t. s homeomorphic t ⇒ (compact s ⇔ compact t)
   
   [HOMEOMORPHIC_CONNECTEDNESS]  Theorem
      
      ⊢ ∀s t. s homeomorphic t ⇒ (connected s ⇔ connected t)
   
   [HOMEOMORPHIC_EMPTY]  Theorem
      
      ⊢ (∀s. s homeomorphic ∅ ⇔ (s = ∅)) ∧ ∀s. ∅ homeomorphic s ⇔ (s = ∅)
   
   [HOMEOMORPHIC_FINITE]  Theorem
      
      ⊢ ∀s t. FINITE s ∧ FINITE t ⇒ (s homeomorphic t ⇔ (CARD s = CARD t))
   
   [HOMEOMORPHIC_FINITENESS]  Theorem
      
      ⊢ ∀s t. s homeomorphic t ⇒ (FINITE s ⇔ FINITE t)
   
   [HOMEOMORPHIC_FINITE_STRONG]  Theorem
      
      ⊢ ∀s t.
            FINITE s ∨ FINITE t ⇒
            (s homeomorphic t ⇔ FINITE s ∧ FINITE t ∧ (CARD s = CARD t))
   
   [HOMEOMORPHIC_HYPERPLANES]  Theorem
      
      ⊢ ∀a b c d.
            a ≠ 0 ∧ c ≠ 0 ⇒ {x | a * x = b} homeomorphic {x | c * x = d}
   
   [HOMEOMORPHIC_HYPERPLANE_STANDARD_HYPERPLANE]  Theorem
      
      ⊢ ∀a b c. a ≠ 0 ⇒ {x | a * x = b} homeomorphic {x | x = c}
   
   [HOMEOMORPHIC_IMP_CARD_EQ]  Theorem
      
      ⊢ ∀s t. s homeomorphic t ⇒ s ≈ t
   
   [HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_LEFT_EQ]  Theorem
      
      ⊢ ∀f s t.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (IMAGE f s homeomorphic t ⇔ s homeomorphic t)
   
   [HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_RIGHT_EQ]  Theorem
      
      ⊢ ∀f s t.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (s homeomorphic IMAGE f t ⇔ s homeomorphic t)
   
   [HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_SELF]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            IMAGE f s homeomorphic s
   
   [HOMEOMORPHIC_LOCALLY]  Theorem
      
      ⊢ ∀P Q.
            (∀s t. s homeomorphic t ⇒ (P s ⇔ Q t)) ⇒
            ∀s t. s homeomorphic t ⇒ (locally P s ⇔ locally Q t)
   
   [HOMEOMORPHIC_LOCAL_COMPACTNESS]  Theorem
      
      ⊢ ∀s t. s homeomorphic t ⇒ (locally compact s ⇔ locally compact t)
   
   [HOMEOMORPHIC_MINIMAL]  Theorem
      
      ⊢ ∀s t.
            s homeomorphic t ⇔
            ∃f g.
                (∀x. x ∈ s ⇒ f x ∈ t ∧ (g (f x) = x)) ∧
                (∀y. y ∈ t ⇒ g y ∈ s ∧ (f (g y) = y)) ∧ f continuous_on s ∧
                g continuous_on t
   
   [HOMEOMORPHIC_ONE_POINT_COMPACTIFICATIONS]  Theorem
      
      ⊢ ∀s t a b.
            compact s ∧ compact t ∧ a ∈ s ∧ b ∈ t ∧
            s DELETE a homeomorphic t DELETE b ⇒
            s homeomorphic t
   
   [HOMEOMORPHIC_OPEN_INTERVALS]  Theorem
      
      ⊢ ∀a b c d.
            a < b ∧ c < d ⇒ interval (a,b) homeomorphic interval (c,d)
   
   [HOMEOMORPHIC_OPEN_INTERVAL_UNIV]  Theorem
      
      ⊢ ∀a b. a < b ⇒ interval (a,b) homeomorphic 𝕌(:real)
   
   [HOMEOMORPHIC_REFL]  Theorem
      
      ⊢ ∀s. s homeomorphic s
   
   [HOMEOMORPHIC_SCALING]  Theorem
      
      ⊢ ∀s c. c ≠ 0 ⇒ s homeomorphic IMAGE (λx. c * x) s
   
   [HOMEOMORPHIC_SCALING_LEFT]  Theorem
      
      ⊢ ∀c.
            0 < c ⇒
            ∀s t. IMAGE (λx. c * x) s homeomorphic t ⇔ s homeomorphic t
   
   [HOMEOMORPHIC_SCALING_RIGHT]  Theorem
      
      ⊢ ∀c.
            0 < c ⇒
            ∀s t. s homeomorphic IMAGE (λx. c * x) t ⇔ s homeomorphic t
   
   [HOMEOMORPHIC_SING]  Theorem
      
      ⊢ ∀a b. {a} homeomorphic {b}
   
   [HOMEOMORPHIC_SPHERE]  Theorem
      
      ⊢ ∀a b d e. 0 < d ∧ 0 < e ⇒ sphere (a,d) homeomorphic sphere (b,e)
   
   [HOMEOMORPHIC_STANDARD_HYPERPLANE_HYPERPLANE]  Theorem
      
      ⊢ ∀a b c. a ≠ 0 ⇒ {x | x = c} homeomorphic {x | a * x = b}
   
   [HOMEOMORPHIC_SYM]  Theorem
      
      ⊢ ∀s t. s homeomorphic t ⇔ t homeomorphic s
   
   [HOMEOMORPHIC_TRANS]  Theorem
      
      ⊢ ∀s t u. s homeomorphic t ∧ t homeomorphic u ⇒ s homeomorphic u
   
   [HOMEOMORPHIC_TRANSLATION]  Theorem
      
      ⊢ ∀s a. s homeomorphic IMAGE (λx. a + x) s
   
   [HOMEOMORPHIC_TRANSLATION_LEFT_EQ]  Theorem
      
      ⊢ ∀a s t. IMAGE (λx. a + x) s homeomorphic t ⇔ s homeomorphic t
   
   [HOMEOMORPHIC_TRANSLATION_RIGHT_EQ]  Theorem
      
      ⊢ ∀a s t. s homeomorphic IMAGE (λx. a + x) t ⇔ s homeomorphic t
   
   [HOMEOMORPHIC_TRANSLATION_SELF]  Theorem
      
      ⊢ ∀a s. IMAGE (λx. a + x) s homeomorphic s
   
   [HOMEOMORPHISM]  Theorem
      
      ⊢ ∀s t f g.
            homeomorphism (s,t) (f,g) ⇔
            f continuous_on s ∧ IMAGE f s ⊆ t ∧ g continuous_on t ∧
            IMAGE g t ⊆ s ∧ (∀x. x ∈ s ⇒ (g (f x) = x)) ∧
            ∀y. y ∈ t ⇒ (f (g y) = y)
   
   [HOMEOMORPHISM_COMPACT]  Theorem
      
      ⊢ ∀s f t.
            compact s ∧ f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ⇒
            ∃g. homeomorphism (s,t) (f,g)
   
   [HOMEOMORPHISM_COMPOSE]  Theorem
      
      ⊢ ∀f g h k s t u.
            homeomorphism (s,t) (f,g) ∧ homeomorphism (t,u) (h,k) ⇒
            homeomorphism (s,u) (h ∘ f,g ∘ k)
   
   [HOMEOMORPHISM_FROM_COMPOSITION_INJECTIVE]  Theorem
      
      ⊢ ∀f g s t u.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧ g continuous_on t ∧
            IMAGE g t ⊆ u ∧ (∀x y. x ∈ t ∧ y ∈ t ∧ (g x = g y) ⇒ (x = y)) ∧
            (∃h. homeomorphism (s,u) (g ∘ f,h)) ⇒
            (∃f'. homeomorphism (s,t) (f,f')) ∧
            ∃g'. homeomorphism (t,u) (g,g')
   
   [HOMEOMORPHISM_FROM_COMPOSITION_SURJECTIVE]  Theorem
      
      ⊢ ∀f g s t u.
            f continuous_on s ∧ (IMAGE f s = t) ∧ g continuous_on t ∧
            IMAGE g t ⊆ u ∧ (∃h. homeomorphism (s,u) (g ∘ f,h)) ⇒
            (∃f'. homeomorphism (s,t) (f,f')) ∧
            ∃g'. homeomorphism (t,u) (g,g')
   
   [HOMEOMORPHISM_ID]  Theorem
      
      ⊢ ∀s. homeomorphism (s,s) ((λx. x),(λx. x))
   
   [HOMEOMORPHISM_IMP_CLOSED_MAP]  Theorem
      
      ⊢ ∀f g s t u.
            homeomorphism (s,t) (f,g) ∧
            closed_in (subtopology euclidean s) u ⇒
            closed_in (subtopology euclidean t) (IMAGE f u)
   
   [HOMEOMORPHISM_IMP_OPEN_MAP]  Theorem
      
      ⊢ ∀f g s t u.
            homeomorphism (s,t) (f,g) ∧ open_in (subtopology euclidean s) u ⇒
            open_in (subtopology euclidean t) (IMAGE f u)
   
   [HOMEOMORPHISM_IMP_QUOTIENT_MAP]  Theorem
      
      ⊢ ∀f g s t.
            homeomorphism (s,t) (f,g) ⇒
            ∀u.
                u ⊆ t ⇒
                (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                 open_in (subtopology euclidean t) u)
   
   [HOMEOMORPHISM_INJECTIVE_CLOSED_MAP]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ∧
            (∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean t) (IMAGE f u)) ⇒
            ∃g. homeomorphism (s,t) (f,g)
   
   [HOMEOMORPHISM_INJECTIVE_CLOSED_MAP_EQ]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ⇒
            ((∃g. homeomorphism (s,t) (f,g)) ⇔
             ∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean t) (IMAGE f u))
   
   [HOMEOMORPHISM_INJECTIVE_OPEN_MAP]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ∧
            (∀u.
                 open_in (subtopology euclidean s) u ⇒
                 open_in (subtopology euclidean t) (IMAGE f u)) ⇒
            ∃g. homeomorphism (s,t) (f,g)
   
   [HOMEOMORPHISM_INJECTIVE_OPEN_MAP_EQ]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ⇒
            ((∃g. homeomorphism (s,t) (f,g)) ⇔
             ∀u.
                 open_in (subtopology euclidean s) u ⇒
                 open_in (subtopology euclidean t) (IMAGE f u))
   
   [HOMEOMORPHISM_LOCALLY]  Theorem
      
      ⊢ ∀P Q f g.
            (∀s t. homeomorphism (s,t) (f,g) ⇒ (P s ⇔ Q t)) ⇒
            ∀s t. homeomorphism (s,t) (f,g) ⇒ (locally P s ⇔ locally Q t)
   
   [HOMEOMORPHISM_OF_SUBSETS]  Theorem
      
      ⊢ ∀f g s t s' t'.
            homeomorphism (s,t) (f,g) ∧ s' ⊆ s ∧ t' ⊆ t ∧ (IMAGE f s' = t') ⇒
            homeomorphism (s',t') (f,g)
   
   [HOMEOMORPHISM_SYM]  Theorem
      
      ⊢ ∀f g s t. homeomorphism (s,t) (f,g) ⇔ homeomorphism (t,s) (g,f)
   
   [IMAGE_AFFINITY_INTERVAL]  Theorem
      
      ⊢ ∀a b m c.
            IMAGE (λx. m * x + c) (interval [(a,b)]) =
            if interval [(a,b)] = ∅ then ∅
            else if 0 ≤ m then interval [(m * a + c,m * b + c)]
            else interval [(m * b + c,m * a + c)]
   
   [IMAGE_CLOSURE_SUBSET]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on closure s ∧ closed t ∧ IMAGE f s ⊆ t ⇒
            IMAGE f (closure s) ⊆ t
   
   [IMAGE_SING]  Theorem
      
      ⊢ ∀f a. IMAGE f {a} = {f a}
   
   [IMAGE_STRETCH_INTERVAL]  Theorem
      
      ⊢ ∀a b m.
            IMAGE (λx. @f. f = m 1 * x) (interval [(a,b)]) =
            if interval [(a,b)] = ∅ then ∅
            else
              interval
                [((@f. f = min (m 1 * a) (m 1 * b)),
                  @f. f = max (m 1 * a) (m 1 * b))]
   
   [IMAGE_TWIZZLE_INTERVAL]  Theorem
      
      ⊢ ∀p a b. IMAGE (λx. x) (interval [(a,b)]) = interval [(a,b)]
   
   [INDEPENDENT_BOUND]  Theorem
      
      ⊢ ∀s. independent s ⇒ FINITE s ∧ CARD s ≤ 1
   
   [INDEPENDENT_CARD_LE_DIM]  Theorem
      
      ⊢ ∀v b. b ⊆ v ∧ independent b ⇒ FINITE b ∧ CARD b ≤ dim v
   
   [INDEPENDENT_EMPTY]  Theorem
      
      ⊢ independent ∅
   
   [INDEPENDENT_INJECTIVE_IMAGE]  Theorem
      
      ⊢ ∀f s.
            independent s ∧ linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            independent (IMAGE f s)
   
   [INDEPENDENT_INJECTIVE_IMAGE_GEN]  Theorem
      
      ⊢ ∀f s.
            independent s ∧ linear f ∧
            (∀x y. x ∈ span s ∧ y ∈ span s ∧ (f x = f y) ⇒ (x = y)) ⇒
            independent (IMAGE f s)
   
   [INDEPENDENT_INSERT]  Theorem
      
      ⊢ ∀a s.
            independent (a INSERT s) ⇔
            if a ∈ s then independent s else independent s ∧ a ∉ span s
   
   [INDEPENDENT_MONO]  Theorem
      
      ⊢ ∀s t. independent t ∧ s ⊆ t ⇒ independent s
   
   [INDEPENDENT_NONZERO]  Theorem
      
      ⊢ ∀s. independent s ⇒ 0 ∉ s
   
   [INDEPENDENT_SING]  Theorem
      
      ⊢ ∀x. independent {x} ⇔ x ≠ 0
   
   [INDEPENDENT_SPAN_BOUND]  Theorem
      
      ⊢ ∀s t.
            FINITE t ∧ independent s ∧ s ⊆ span t ⇒
            FINITE s ∧ CARD s ≤ CARD t
   
   [INDEPENDENT_STDBASIS]  Theorem
      
      ⊢ independent {i | 1 ≤ i ∧ i ≤ 1}
   
   [INFINITE_FROM]  Theorem
      
      ⊢ ∀n. INFINITE (from n)
   
   [INFINITE_OPEN_IN]  Theorem
      
      ⊢ ∀u s.
            open_in (subtopology euclidean u) s ∧
            (∃x. x ∈ s ∧ x limit_point_of u) ⇒
            INFINITE s
   
   [INFINITE_SUPERSET]  Theorem
      
      ⊢ ∀s t. INFINITE s ∧ s ⊆ t ⇒ INFINITE t
   
   [INFSUM_0]  Theorem
      
      ⊢ infsum s (λi. 0) = 0
   
   [INFSUM_ADD]  Theorem
      
      ⊢ ∀x y s.
            summable s x ∧ summable s y ⇒
            (infsum s (λi. x i + y i) = infsum s x + infsum s y)
   
   [INFSUM_CMUL]  Theorem
      
      ⊢ ∀s x c. summable s x ⇒ (infsum s (λn. c * x n) = c * infsum s x)
   
   [INFSUM_EQ]  Theorem
      
      ⊢ ∀f g k.
            summable k f ∧ summable k g ∧ (∀x. x ∈ k ⇒ (f x = g x)) ⇒
            (infsum k f = infsum k g)
   
   [INFSUM_LINEAR]  Theorem
      
      ⊢ ∀f h s.
            summable s f ∧ linear h ⇒
            (infsum s (λn. h (f n)) = h (infsum s f))
   
   [INFSUM_NEG]  Theorem
      
      ⊢ ∀s x. summable s x ⇒ (infsum s (λn. -x n) = -infsum s x)
   
   [INFSUM_RESTRICT]  Theorem
      
      ⊢ ∀k a. infsum 𝕌(:num) (λn. if n ∈ k then a n else 0) = infsum k a
   
   [INFSUM_SUB]  Theorem
      
      ⊢ ∀x y s.
            summable s x ∧ summable s y ⇒
            (infsum s (λi. x i − y i) = infsum s x − infsum s y)
   
   [INFSUM_UNIQUE]  Theorem
      
      ⊢ ∀f l s. (f sums l) s ⇒ (infsum s f = l)
   
   [INF_FINITE]  Theorem
      
      ⊢ ∀s. FINITE s ∧ s ≠ ∅ ⇒ inf s ∈ s ∧ ∀x. x ∈ s ⇒ inf s ≤ x
   
   [INF_FINITE_LEMMA]  Theorem
      
      ⊢ ∀s. FINITE s ∧ s ≠ ∅ ⇒ ∃b. b ∈ s ∧ ∀x. x ∈ s ⇒ b ≤ x
   
   [INF_INSERT]  Theorem
      
      ⊢ ∀x s.
            bounded s ⇒
            (inf (x INSERT s) = if s = ∅ then x else min x (inf s))
   
   [INJECTIVE_IMP_ISOMETRIC]  Theorem
      
      ⊢ ∀f s.
            closed s ∧ subspace s ∧ linear f ∧
            (∀x. x ∈ s ∧ (f x = 0) ⇒ (x = 0)) ⇒
            ∃e. 0 < e ∧ ∀x. x ∈ s ⇒ abs (f x) ≥ e * abs x
   
   [INJECTIVE_MAP_OPEN_IFF_CLOSED]  Theorem
      
      ⊢ ∀f s t.
            f continuous_on s ∧ (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ⇒
            ((∀u.
                  open_in (subtopology euclidean s) u ⇒
                  open_in (subtopology euclidean t) (IMAGE f u)) ⇔
             ∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean t) (IMAGE f u))
   
   [INTERIOR_BALL]  Theorem
      
      ⊢ ∀a r. interior (ball (a,r)) = ball (a,r)
   
   [INTERIOR_BIGINTER_SUBSET]  Theorem
      
      ⊢ ∀f. interior (BIGINTER f) ⊆ BIGINTER (IMAGE interior f)
   
   [INTERIOR_BIJECTIVE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ∧ (∀y. ∃x. f x = y) ⇒
            (interior (IMAGE f s) = IMAGE f (interior s))
   
   [INTERIOR_CBALL]  Theorem
      
      ⊢ ∀x e. interior (cball (x,e)) = ball (x,e)
   
   [INTERIOR_CLOSED_EQ_EMPTY_AS_FRONTIER]  Theorem
      
      ⊢ ∀s. closed s ∧ (interior s = ∅) ⇔ ∃t. open t ∧ (s = frontier t)
   
   [INTERIOR_CLOSED_INTERVAL]  Theorem
      
      ⊢ ∀a b. interior (interval [(a,b)]) = interval (a,b)
   
   [INTERIOR_CLOSED_UNION_EMPTY_INTERIOR]  Theorem
      
      ⊢ ∀s t. closed s ∧ (interior t = ∅) ⇒ (interior (s ∪ t) = interior s)
   
   [INTERIOR_CLOSURE]  Theorem
      
      ⊢ ∀s. interior s = 𝕌(:real) DIFF closure (𝕌(:real) DIFF s)
   
   [INTERIOR_CLOSURE_IDEMP]  Theorem
      
      ⊢ ∀s.
            interior (closure (interior (closure s))) =
            interior (closure s)
   
   [INTERIOR_CLOSURE_INTER_OPEN]  Theorem
      
      ⊢ ∀s t.
            open s ∧ open t ⇒
            (interior (closure (s ∩ t)) =
             interior (closure s) ∩ interior (closure t))
   
   [INTERIOR_COMPLEMENT]  Theorem
      
      ⊢ ∀s. interior (𝕌(:real) DIFF s) = 𝕌(:real) DIFF closure s
   
   [INTERIOR_DIFF]  Theorem
      
      ⊢ ∀s t. interior (s DIFF t) = interior s DIFF closure t
   
   [INTERIOR_EMPTY]  Theorem
      
      ⊢ interior ∅ = ∅
   
   [INTERIOR_EQ]  Theorem
      
      ⊢ ∀s. (interior s = s) ⇔ open s
   
   [INTERIOR_EQ_EMPTY]  Theorem
      
      ⊢ ∀s. (interior s = ∅) ⇔ ∀t. open t ∧ t ⊆ s ⇒ (t = ∅)
   
   [INTERIOR_EQ_EMPTY_ALT]  Theorem
      
      ⊢ ∀s. (interior s = ∅) ⇔ ∀t. open t ∧ t ≠ ∅ ⇒ t DIFF s ≠ ∅
   
   [INTERIOR_FINITE_BIGINTER]  Theorem
      
      ⊢ ∀s.
            FINITE s ⇒
            (interior (BIGINTER s) = BIGINTER (IMAGE interior s))
   
   [INTERIOR_FRONTIER]  Theorem
      
      ⊢ ∀s.
            interior (frontier s) =
            interior (closure s) DIFF closure (interior s)
   
   [INTERIOR_FRONTIER_EMPTY]  Theorem
      
      ⊢ ∀s. open s ∨ closed s ⇒ (interior (frontier s) = ∅)
   
   [INTERIOR_HALFSPACE_COMPONENT_GE]  Theorem
      
      ⊢ ∀a. interior {x | x ≥ a} = {x | x > a}
   
   [INTERIOR_HALFSPACE_COMPONENT_LE]  Theorem
      
      ⊢ ∀a. interior {x | x ≤ a} = {x | x < a}
   
   [INTERIOR_HALFSPACE_GE]  Theorem
      
      ⊢ ∀a b. a ≠ 0 ⇒ (interior {x | a * x ≥ b} = {x | a * x > b})
   
   [INTERIOR_HALFSPACE_LE]  Theorem
      
      ⊢ ∀a b. a ≠ 0 ⇒ (interior {x | a * x ≤ b} = {x | a * x < b})
   
   [INTERIOR_HYPERPLANE]  Theorem
      
      ⊢ ∀a b. a ≠ 0 ⇒ (interior {x | a * x = b} = ∅)
   
   [INTERIOR_IMAGE_SUBSET]  Theorem
      
      ⊢ ∀f s.
            (∀x. f continuous at x) ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            interior (IMAGE f s) ⊆ IMAGE f (interior s)
   
   [INTERIOR_INJECTIVE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (interior (IMAGE f s) = IMAGE f (interior s))
   
   [INTERIOR_INTER]  Theorem
      
      ⊢ ∀s t. interior (s ∩ t) = interior s ∩ interior t
   
   [INTERIOR_INTERIOR]  Theorem
      
      ⊢ ∀s. interior (interior s) = interior s
   
   [INTERIOR_INTERVAL]  Theorem
      
      ⊢ (∀a b. interior (interval [(a,b)]) = interval (a,b)) ∧
        ∀a b. interior (interval (a,b)) = interval (a,b)
   
   [INTERIOR_LIMIT_POINT]  Theorem
      
      ⊢ ∀s x. x ∈ interior s ⇒ x limit_point_of s
   
   [INTERIOR_MAXIMAL]  Theorem
      
      ⊢ ∀s t. t ⊆ s ∧ open t ⇒ t ⊆ interior s
   
   [INTERIOR_MAXIMAL_EQ]  Theorem
      
      ⊢ ∀s t. open s ⇒ (s ⊆ interior t ⇔ s ⊆ t)
   
   [INTERIOR_NEGATIONS]  Theorem
      
      ⊢ ∀s. interior (IMAGE (λx. -x) s) = IMAGE (λx. -x) (interior s)
   
   [INTERIOR_OPEN]  Theorem
      
      ⊢ ∀s. open s ⇒ (interior s = s)
   
   [INTERIOR_SING]  Theorem
      
      ⊢ ∀a. interior {a} = ∅
   
   [INTERIOR_STANDARD_HYPERPLANE]  Theorem
      
      ⊢ ∀a. interior {x | x = a} = ∅
   
   [INTERIOR_SUBSET]  Theorem
      
      ⊢ ∀s. interior s ⊆ s
   
   [INTERIOR_TRANSLATION]  Theorem
      
      ⊢ ∀a s.
            interior (IMAGE (λx. a + x) s) = IMAGE (λx. a + x) (interior s)
   
   [INTERIOR_UNIONS_OPEN_SUBSETS]  Theorem
      
      ⊢ ∀s. BIGUNION {t | open t ∧ t ⊆ s} = interior s
   
   [INTERIOR_UNION_EQ_EMPTY]  Theorem
      
      ⊢ ∀s t.
            closed s ∨ closed t ⇒
            ((interior (s ∪ t) = ∅) ⇔ (interior s = ∅) ∧ (interior t = ∅))
   
   [INTERIOR_UNIQUE]  Theorem
      
      ⊢ ∀s t.
            t ⊆ s ∧ open t ∧ (∀t'. t' ⊆ s ∧ open t' ⇒ t' ⊆ t) ⇒
            (interior s = t)
   
   [INTERIOR_UNIV]  Theorem
      
      ⊢ interior 𝕌(:real) = 𝕌(:real)
   
   [INTERVAL]  Theorem
      
      ⊢ (∀a b.
             interval [(a,b)] =
             if a ≤ b then cball (midpoint (a,b),dist (a,b) / 2) else ∅) ∧
        ∀a b.
            interval (a,b) =
            if a < b then ball (midpoint (a,b),dist (a,b) / 2) else ∅
   
   [INTERVAL_CASES]  Theorem
      
      ⊢ ∀x. x ∈ interval [(a,b)] ⇒ x ∈ interval (a,b) ∨ (x = a) ∨ (x = b)
   
   [INTERVAL_CONTAINS_COMPACT_NEIGHBOURHOOD]  Theorem
      
      ⊢ ∀s x.
            is_interval s ∧ x ∈ s ⇒
            ∃a b d.
                0 < d ∧ x ∈ interval [(a,b)] ∧ interval [(a,b)] ⊆ s ∧
                ball (x,d) ∩ s ⊆ interval [(a,b)]
   
   [INTERVAL_EQ_EMPTY]  Theorem
      
      ⊢ ∀a b.
            (b < a ⇔ (interval [(a,b)] = ∅)) ∧
            (b ≤ a ⇔ (interval (a,b) = ∅))
   
   [INTERVAL_IMAGE_STRETCH_INTERVAL]  Theorem
      
      ⊢ ∀a b m.
            ∃u v.
                IMAGE (λx. @f. f = m 1 * x) (interval [(a,b)]) =
                interval [(u,v)]
   
   [INTERVAL_NE_EMPTY]  Theorem
      
      ⊢ (interval [(a,b)] ≠ ∅ ⇔ a ≤ b) ∧ (interval (a,b) ≠ ∅ ⇔ a < b)
   
   [INTERVAL_OPEN_SUBSET_CLOSED]  Theorem
      
      ⊢ ∀a b. interval (a,b) ⊆ interval [(a,b)]
   
   [INTERVAL_SING]  Theorem
      
      ⊢ (interval [(a,a)] = {a}) ∧ (interval (a,a) = ∅)
   
   [INTERVAL_SUBSET_IS_INTERVAL]  Theorem
      
      ⊢ ∀s a b.
            is_interval s ⇒
            (interval [(a,b)] ⊆ s ⇔ (interval [(a,b)] = ∅) ∨ a ∈ s ∧ b ∈ s)
   
   [INTERVAL_TRANSLATION]  Theorem
      
      ⊢ (∀c a b.
             interval [(c + a,c + b)] =
             IMAGE (λx. c + x) (interval [(a,b)])) ∧
        ∀c a b. interval (c + a,c + b) = IMAGE (λx. c + x) (interval (a,b))
   
   [INTER_BALLS_EQ_EMPTY]  Theorem
      
      ⊢ (∀a b r s.
             (ball (a,r) ∩ ball (b,s) = ∅) ⇔
             r ≤ 0 ∨ s ≤ 0 ∨ r + s ≤ dist (a,b)) ∧
        (∀a b r s.
             (ball (a,r) ∩ cball (b,s) = ∅) ⇔
             r ≤ 0 ∨ s < 0 ∨ r + s ≤ dist (a,b)) ∧
        (∀a b r s.
             (cball (a,r) ∩ ball (b,s) = ∅) ⇔
             r < 0 ∨ s ≤ 0 ∨ r + s ≤ dist (a,b)) ∧
        ∀a b r s.
            (cball (a,r) ∩ cball (b,s) = ∅) ⇔
            r < 0 ∨ s < 0 ∨ r + s < dist (a,b)
   
   [INTER_BIGUNION]  Theorem
      
      ⊢ (∀s t. BIGUNION s ∩ t = BIGUNION {x ∩ t | x ∈ s}) ∧
        ∀s t. t ∩ BIGUNION s = BIGUNION {t ∩ x | x ∈ s}
   
   [INTER_INTERVAL]  Theorem
      
      ⊢ interval [(a,b)] ∩ interval [(c,d)] = interval [(max a c,min b d)]
   
   [INTER_INTERVAL_MIXED_EQ_EMPTY]  Theorem
      
      ⊢ ∀a b c d.
            interval (c,d) ≠ ∅ ⇒
            ((interval (a,b) ∩ interval [(c,d)] = ∅) ⇔
             (interval (a,b) ∩ interval (c,d) = ∅))
   
   [IN_BALL]  Theorem
      
      ⊢ ∀x y e. y ∈ ball (x,e) ⇔ dist (x,y) < e
   
   [IN_BALL_0]  Theorem
      
      ⊢ ∀x e. x ∈ ball (0,e) ⇔ abs x < e
   
   [IN_CBALL]  Theorem
      
      ⊢ ∀x y e. y ∈ cball (x,e) ⇔ dist (x,y) ≤ e
   
   [IN_CBALL_0]  Theorem
      
      ⊢ ∀x e. x ∈ cball (0,e) ⇔ abs x ≤ e
   
   [IN_CLOSURE_DELETE]  Theorem
      
      ⊢ ∀s x. x ∈ closure (s DELETE x) ⇔ x limit_point_of s
   
   [IN_COMPONENTS]  Theorem
      
      ⊢ ∀u s. s ∈ components u ⇔ ∃x. x ∈ u ∧ (s = connected_component u x)
   
   [IN_COMPONENTS_BIGUNION_COMPLEMENT]  Theorem
      
      ⊢ ∀s c.
            c ∈ components s ⇒
            (s DIFF c = BIGUNION (components s DELETE c))
   
   [IN_COMPONENTS_CONNECTED]  Theorem
      
      ⊢ ∀s c. c ∈ components s ⇒ connected c
   
   [IN_COMPONENTS_MAXIMAL]  Theorem
      
      ⊢ ∀s c.
            c ∈ components s ⇔
            c ≠ ∅ ∧ c ⊆ s ∧ connected c ∧
            ∀c'. c' ≠ ∅ ∧ c ⊆ c' ∧ c' ⊆ s ∧ connected c' ⇒ (c' = c)
   
   [IN_COMPONENTS_NONEMPTY]  Theorem
      
      ⊢ ∀s c. c ∈ components s ⇒ c ≠ ∅
   
   [IN_COMPONENTS_SELF]  Theorem
      
      ⊢ ∀s. s ∈ components s ⇔ connected s ∧ s ≠ ∅
   
   [IN_COMPONENTS_SUBSET]  Theorem
      
      ⊢ ∀s c. c ∈ components s ⇒ c ⊆ s
   
   [IN_DIRECTION]  Theorem
      
      ⊢ ∀a v x y.
            netord (a in_direction v) x y ⇔
            0 < dist (x,a) ∧ dist (x,a) ≤ dist (y,a) ∧
            ∃c. 0 ≤ c ∧ (x − a = c * v)
   
   [IN_INTERIOR]  Theorem
      
      ⊢ ∀x s. x ∈ interior s ⇔ ∃e. 0 < e ∧ ball (x,e) ⊆ s
   
   [IN_INTERIOR_CBALL]  Theorem
      
      ⊢ ∀x s. x ∈ interior s ⇔ ∃e. 0 < e ∧ cball (x,e) ⊆ s
   
   [IN_INTERIOR_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f g s x.
            linear f ∧ linear g ∧ (f ∘ g = I) ∧ x ∈ interior s ⇒
            f x ∈ interior (IMAGE f s)
   
   [IN_INTERVAL]  Theorem
      
      ⊢ (x ∈ interval (a,b) ⇔ a < x ∧ x < b) ∧
        (x ∈ interval [(a,b)] ⇔ a ≤ x ∧ x ≤ b)
   
   [IN_INTERVAL_REFLECT]  Theorem
      
      ⊢ (∀a b x. -x ∈ interval [(-b,-a)] ⇔ x ∈ interval [(a,b)]) ∧
        ∀a b x. -x ∈ interval (-b,-a) ⇔ x ∈ interval (a,b)
   
   [IN_OPEN_SEGMENT]  Theorem
      
      ⊢ ∀a b x. x ∈ segment (a,b) ⇔ x ∈ segment [(a,b)] ∧ x ≠ a ∧ x ≠ b
   
   [IN_OPEN_SEGMENT_ALT]  Theorem
      
      ⊢ ∀a b x.
            x ∈ segment (a,b) ⇔ x ∈ segment [(a,b)] ∧ x ≠ a ∧ x ≠ b ∧ a ≠ b
   
   [IN_SEGMENT]  Theorem
      
      ⊢ ∀a b x.
            (x ∈ segment [(a,b)] ⇔
             ∃u. 0 ≤ u ∧ u ≤ 1 ∧ (x = (1 − u) * a + u * b)) ∧
            (x ∈ segment (a,b) ⇔
             a ≠ b ∧ ∃u. 0 < u ∧ u < 1 ∧ (x = (1 − u) * a + u * b))
   
   [IN_SEGMENT_COMPONENT]  Theorem
      
      ⊢ ∀a b x i. x ∈ segment [(a,b)] ⇒ min a b ≤ x ∧ x ≤ max a b
   
   [IN_SPAN_DELETE]  Theorem
      
      ⊢ ∀a b s.
            a ∈ span s ∧ a ∉ span (s DELETE b) ⇒
            b ∈ span (a INSERT s DELETE b)
   
   [IN_SPAN_INSERT]  Theorem
      
      ⊢ ∀a b s. a ∈ span (b INSERT s) ∧ a ∉ span s ⇒ b ∈ span (a INSERT s)
   
   [IN_SPHERE]  Theorem
      
      ⊢ ∀x y e. y ∈ sphere (x,e) ⇔ (dist (x,y) = e)
   
   [IN_SPHERE_0]  Theorem
      
      ⊢ ∀x e. x ∈ sphere (0,e) ⇔ (abs x = e)
   
   [ISOMETRY_IMP_EMBEDDING]  Theorem
      
      ⊢ ∀f s t.
            (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ⇒ (dist (f x,f y) = dist (x,y))) ⇒
            ∃g. homeomorphism (s,t) (f,g)
   
   [ISOMETRY_IMP_HOMEOMORPHISM_COMPACT]  Theorem
      
      ⊢ ∀f s.
            compact s ∧ IMAGE f s ⊆ s ∧
            (∀x y. x ∈ s ∧ y ∈ s ⇒ (dist (f x,f y) = dist (x,y))) ⇒
            ∃g. homeomorphism (s,s) (f,g)
   
   [ISOMETRY_IMP_OPEN_MAP]  Theorem
      
      ⊢ ∀f s t u.
            (IMAGE f s = t) ∧
            (∀x y. x ∈ s ∧ y ∈ s ⇒ (dist (f x,f y) = dist (x,y))) ∧
            open_in (subtopology euclidean s) u ⇒
            open_in (subtopology euclidean t) (IMAGE f u)
   
   [ISOMETRY_ON_IMP_CONTINUOUS_ON]  Theorem
      
      ⊢ ∀f.
            (∀x y. x ∈ s ∧ y ∈ s ⇒ (dist (f x,f y) = dist (x,y))) ⇒
            f continuous_on s
   
   [ISTOPLOGY_SUBTOPOLOGY]  Theorem
      
      ⊢ ∀top u. istopology {s ∩ u | open_in top s}
   
   [IS_INTERVAL]  Theorem
      
      ⊢ ∀s. is_interval s ⇔ ∀a b x. a ∈ s ∧ b ∈ s ∧ a ≤ x ∧ x ≤ b ⇒ x ∈ s
   
   [IS_INTERVAL_CASES]  Theorem
      
      ⊢ ∀s.
            is_interval s ⇔
            (s = ∅) ∨ (s = 𝕌(:real)) ∨ (∃a. s = {x | a < x}) ∨
            (∃a. s = {x | a ≤ x}) ∨ (∃b. s = {x | x ≤ b}) ∨
            (∃b. s = {x | x < b}) ∨ (∃a b. s = {x | a < x ∧ x < b}) ∨
            (∃a b. s = {x | a < x ∧ x ≤ b}) ∨
            (∃a b. s = {x | a ≤ x ∧ x < b}) ∨ ∃a b. s = {x | a ≤ x ∧ x ≤ b}
   
   [IS_INTERVAL_COMPACT]  Theorem
      
      ⊢ ∀s. is_interval s ∧ compact s ⇔ ∃a b. s = interval [(a,b)]
   
   [IS_INTERVAL_EMPTY]  Theorem
      
      ⊢ is_interval ∅
   
   [IS_INTERVAL_IMP_LOCALLY_COMPACT]  Theorem
      
      ⊢ ∀s. is_interval s ⇒ locally compact s
   
   [IS_INTERVAL_INTER]  Theorem
      
      ⊢ ∀s t. is_interval s ∧ is_interval t ⇒ is_interval (s ∩ t)
   
   [IS_INTERVAL_INTERVAL]  Theorem
      
      ⊢ ∀a b. is_interval (interval (a,b)) ∧ is_interval (interval [(a,b)])
   
   [IS_INTERVAL_POINTWISE]  Theorem
      
      ⊢ ∀s x. is_interval s ⇒ (∃a. a ∈ s ∧ (a = x)) ⇒ x ∈ s
   
   [IS_INTERVAL_SCALING]  Theorem
      
      ⊢ ∀s c. is_interval s ⇒ is_interval (IMAGE (λx. c * x) s)
   
   [IS_INTERVAL_SCALING_EQ]  Theorem
      
      ⊢ ∀s c. is_interval (IMAGE (λx. c * x) s) ⇔ (c = 0) ∨ is_interval s
   
   [IS_INTERVAL_SING]  Theorem
      
      ⊢ ∀a. is_interval {a}
   
   [IS_INTERVAL_UNIV]  Theorem
      
      ⊢ is_interval 𝕌(:real)
   
   [JOINABLE_COMPONENTS_EQ]  Theorem
      
      ⊢ ∀s t c1 c2.
            connected t ∧ t ⊆ s ∧ c1 ∈ components s ∧ c2 ∈ components s ∧
            c1 ∩ t ≠ ∅ ∧ c2 ∩ t ≠ ∅ ⇒
            (c1 = c2)
   
   [JOINABLE_CONNECTED_COMPONENT_EQ]  Theorem
      
      ⊢ ∀s t x y.
            connected t ∧ t ⊆ s ∧ connected_component s x ∩ t ≠ ∅ ∧
            connected_component s y ∩ t ≠ ∅ ⇒
            (connected_component s x = connected_component s y)
   
   [LAMBDA_PAIR]  Theorem
      
      ⊢ (λ(x,y). P x y) = (λp. P (FST p) (SND p))
   
   [LEBESGUE_COVERING_LEMMA]  Theorem
      
      ⊢ ∀s c.
            compact s ∧ c ≠ ∅ ∧ s ⊆ BIGUNION c ∧ (∀b. b ∈ c ⇒ open b) ⇒
            ∃d. 0 < d ∧ ∀t. t ⊆ s ∧ diameter t ≤ d ⇒ ∃b. b ∈ c ∧ t ⊆ b
   
   [LE_1]  Theorem
      
      ⊢ (∀n. n ≠ 0 ⇒ 0 < n) ∧ (∀n. n ≠ 0 ⇒ 1 ≤ n) ∧ (∀n. 0 < n ⇒ n ≠ 0) ∧
        (∀n. 0 < n ⇒ 1 ≤ n) ∧ (∀n. 1 ≤ n ⇒ 0 < n) ∧ ∀n. 1 ≤ n ⇒ n ≠ 0
   
   [LE_ADD]  Theorem
      
      ⊢ ∀m n. m ≤ m + n
   
   [LE_ADDR]  Theorem
      
      ⊢ ∀m n. n ≤ m + n
   
   [LE_EXISTS]  Theorem
      
      ⊢ ∀m n. m ≤ n ⇔ ∃d. n = m + d
   
   [LIFT_TO_QUOTIENT_SPACE]  Theorem
      
      ⊢ ∀f h s t u.
            (IMAGE f s = t) ∧
            (∀v.
                 v ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ v} ⇔
                  open_in (subtopology euclidean t) v)) ∧
            h continuous_on s ∧ (IMAGE h s = u) ∧
            (∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (h x = h y)) ⇒
            ∃g.
                g continuous_on t ∧ (IMAGE g t = u) ∧
                ∀x. x ∈ s ⇒ (h x = g (f x))
   
   [LIFT_TO_QUOTIENT_SPACE_UNIQUE]  Theorem
      
      ⊢ ∀f g s t u.
            (IMAGE f s = t) ∧ (IMAGE g s = u) ∧
            (∀v.
                 v ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ v} ⇔
                  open_in (subtopology euclidean t) v)) ∧
            (∀v.
                 v ⊆ u ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ g x ∈ v} ⇔
                  open_in (subtopology euclidean u) v)) ∧
            (∀x y. x ∈ s ∧ y ∈ s ⇒ ((f x = f y) ⇔ (g x = g y))) ⇒
            t homeomorphic u
   
   [LIM]  Theorem
      
      ⊢ (f --> l) net ⇔
        trivial_limit net ∨
        ∀e.
            0 < e ⇒
            ∃y.
                (∃x. netord net x y) ∧
                ∀x. netord net x y ⇒ dist (f x,l) < e
   
   [LIMIT_POINT_FINITE]  Theorem
      
      ⊢ ∀s a. FINITE s ⇒ ¬(a limit_point_of s)
   
   [LIMIT_POINT_UNION]  Theorem
      
      ⊢ ∀s t x.
            x limit_point_of s ∪ t ⇔
            x limit_point_of s ∨ x limit_point_of t
   
   [LIMPT_APPROACHABLE]  Theorem
      
      ⊢ ∀x s.
            x limit_point_of s ⇔
            ∀e. 0 < e ⇒ ∃x'. x' ∈ s ∧ x' ≠ x ∧ dist (x',x) < e
   
   [LIMPT_APPROACHABLE_LE]  Theorem
      
      ⊢ ∀x s.
            x limit_point_of s ⇔
            ∀e. 0 < e ⇒ ∃x'. x' ∈ s ∧ x' ≠ x ∧ dist (x',x) ≤ e
   
   [LIMPT_BALL]  Theorem
      
      ⊢ ∀x y e. y limit_point_of ball (x,e) ⇔ 0 < e ∧ y ∈ cball (x,e)
   
   [LIMPT_EMPTY]  Theorem
      
      ⊢ ∀x. ¬(x limit_point_of ∅)
   
   [LIMPT_INFINITE_BALL]  Theorem
      
      ⊢ ∀s x. x limit_point_of s ⇔ ∀e. 0 < e ⇒ INFINITE (s ∩ ball (x,e))
   
   [LIMPT_INFINITE_CBALL]  Theorem
      
      ⊢ ∀s x. x limit_point_of s ⇔ ∀e. 0 < e ⇒ INFINITE (s ∩ cball (x,e))
   
   [LIMPT_INFINITE_OPEN]  Theorem
      
      ⊢ ∀s x. x limit_point_of s ⇔ ∀t. x ∈ t ∧ open t ⇒ INFINITE (s ∩ t)
   
   [LIMPT_INFINITE_OPEN_BALL_CBALL]  Theorem
      
      ⊢ (∀s x. x limit_point_of s ⇔ ∀t. x ∈ t ∧ open t ⇒ INFINITE (s ∩ t)) ∧
        (∀s x. x limit_point_of s ⇔ ∀e. 0 < e ⇒ INFINITE (s ∩ ball (x,e))) ∧
        ∀s x. x limit_point_of s ⇔ ∀e. 0 < e ⇒ INFINITE (s ∩ cball (x,e))
   
   [LIMPT_INJECTIVE_LINEAR_IMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (f x limit_point_of IMAGE f s ⇔ x limit_point_of s)
   
   [LIMPT_INSERT]  Theorem
      
      ⊢ ∀s x y. x limit_point_of y INSERT s ⇔ x limit_point_of s
   
   [LIMPT_OF_CLOSURE]  Theorem
      
      ⊢ ∀x s. x limit_point_of closure s ⇔ x limit_point_of s
   
   [LIMPT_OF_LIMPTS]  Theorem
      
      ⊢ ∀x s.
            x limit_point_of {y | y limit_point_of s} ⇒ x limit_point_of s
   
   [LIMPT_OF_OPEN]  Theorem
      
      ⊢ ∀s x. open s ∧ x ∈ s ⇒ x limit_point_of s
   
   [LIMPT_OF_OPEN_IN]  Theorem
      
      ⊢ ∀s t x.
            open_in (subtopology euclidean s) t ∧ x limit_point_of s ∧
            x ∈ t ⇒
            x limit_point_of t
   
   [LIMPT_OF_SEQUENCE_SUBSEQUENCE]  Theorem
      
      ⊢ ∀f l.
            l limit_point_of IMAGE f 𝕌(:num) ⇒
            ∃r. (∀m n. m < n ⇒ r m < r n) ∧ (f ∘ r --> l) sequentially
   
   [LIMPT_OF_UNIV]  Theorem
      
      ⊢ ∀x. x limit_point_of 𝕌(:real)
   
   [LIMPT_SEQUENTIAL]  Theorem
      
      ⊢ ∀x s.
            x limit_point_of s ⇔
            ∃f. (∀n. f n ∈ s DELETE x) ∧ (f --> x) sequentially
   
   [LIMPT_SEQUENTIAL_INJ]  Theorem
      
      ⊢ ∀x s.
            x limit_point_of s ⇔
            ∃f.
                (∀n. f n ∈ s DELETE x) ∧ (∀m n. (f m = f n) ⇔ (m = n)) ∧
                (f --> x) sequentially
   
   [LIMPT_SING]  Theorem
      
      ⊢ ∀x y. ¬(x limit_point_of {y})
   
   [LIMPT_SUBSET]  Theorem
      
      ⊢ ∀x s t. x limit_point_of s ∧ s ⊆ t ⇒ x limit_point_of t
   
   [LIMPT_UNIV]  Theorem
      
      ⊢ ∀x. x limit_point_of 𝕌(:real)
   
   [LIM_ABS]  Theorem
      
      ⊢ ∀net f l. (f --> l) net ⇒ ((λx. abs (f x)) --> abs l) net
   
   [LIM_ABS_LBOUND]  Theorem
      
      ⊢ ∀net f l b.
            ¬trivial_limit net ∧ (f --> l) net ∧
            eventually (λx. b ≤ abs (f x)) net ⇒
            b ≤ abs l
   
   [LIM_ABS_UBOUND]  Theorem
      
      ⊢ ∀net f l b.
            ¬trivial_limit net ∧ (f --> l) net ∧
            eventually (λx. abs (f x) ≤ b) net ⇒
            abs l ≤ b
   
   [LIM_ADD]  Theorem
      
      ⊢ ∀net f g l m.
            (f --> l) net ∧ (g --> m) net ⇒
            ((λx. f x + g x) --> (l + m)) net
   
   [LIM_AT]  Theorem
      
      ⊢ ∀f l a.
            (f --> l) (at a) ⇔
            ∀e.
                0 < e ⇒
                ∃d.
                    0 < d ∧
                    ∀x. 0 < dist (x,a) ∧ dist (x,a) < d ⇒ dist (f x,l) < e
   
   [LIM_AT_ID]  Theorem
      
      ⊢ ∀a. ((λx. x) --> a) (at a)
   
   [LIM_AT_INFINITY]  Theorem
      
      ⊢ ∀f l.
            (f --> l) at_infinity ⇔
            ∀e. 0 < e ⇒ ∃b. ∀x. abs x ≥ b ⇒ dist (f x,l) < e
   
   [LIM_AT_INFINITY_POS]  Theorem
      
      ⊢ ∀f l.
            (f --> l) at_infinity ⇔
            ∀e. 0 < e ⇒ ∃b. 0 < b ∧ ∀x. abs x ≥ b ⇒ dist (f x,l) < e
   
   [LIM_AT_LE]  Theorem
      
      ⊢ ∀f l a.
            (f --> l) (at a) ⇔
            ∀e.
                0 < e ⇒
                ∃d.
                    0 < d ∧
                    ∀x. 0 < dist (x,a) ∧ dist (x,a) ≤ d ⇒ dist (f x,l) < e
   
   [LIM_AT_NEGINFINITY]  Theorem
      
      ⊢ ∀f l.
            (f --> l) at_neginfinity ⇔
            ∀e. 0 < e ⇒ ∃b. ∀x. x ≤ b ⇒ dist (f x,l) < e
   
   [LIM_AT_POSINFINITY]  Theorem
      
      ⊢ ∀f l.
            (f --> l) at_posinfinity ⇔
            ∀e. 0 < e ⇒ ∃b. ∀x. x ≥ b ⇒ dist (f x,l) < e
   
   [LIM_AT_WITHIN]  Theorem
      
      ⊢ ∀f l a s. (f --> l) (at a) ⇒ (f --> l) (at a within s)
   
   [LIM_AT_ZERO]  Theorem
      
      ⊢ ∀f l a. (f --> l) (at a) ⇔ ((λx. f (a + x)) --> l) (at 0)
   
   [LIM_BILINEAR]  Theorem
      
      ⊢ ∀net h f g l m.
            (f --> l) net ∧ (g --> m) net ∧ bilinear h ⇒
            ((λx. h (f x) (g x)) --> h l m) net
   
   [LIM_CASES_COFINITE_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f g l.
            FINITE {n | (¬P n)} ⇒
            (((λn. if P n then f n else g n) --> l) sequentially ⇔
             (f --> l) sequentially)
   
   [LIM_CASES_FINITE_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f g l.
            FINITE {n | P n} ⇒
            (((λn. if P n then f n else g n) --> l) sequentially ⇔
             (g --> l) sequentially)
   
   [LIM_CASES_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f g l m.
            (((λn. if m ≤ n then f n else g n) --> l) sequentially ⇔
             (f --> l) sequentially) ∧
            (((λn. if m < n then f n else g n) --> l) sequentially ⇔
             (f --> l) sequentially) ∧
            (((λn. if n ≤ m then f n else g n) --> l) sequentially ⇔
             (g --> l) sequentially) ∧
            (((λn. if n < m then f n else g n) --> l) sequentially ⇔
             (g --> l) sequentially)
   
   [LIM_CMUL]  Theorem
      
      ⊢ ∀f l c. (f --> l) net ⇒ ((λx. c * f x) --> (c * l)) net
   
   [LIM_CMUL_EQ]  Theorem
      
      ⊢ ∀net f l c.
            c ≠ 0 ⇒ (((λx. c * f x) --> (c * l)) net ⇔ (f --> l) net)
   
   [LIM_COMPONENT]  Theorem
      
      ⊢ ∀net f i l. (f --> l) net ⇒ ((λa. f a) --> l) net
   
   [LIM_COMPONENT_EQ]  Theorem
      
      ⊢ ∀net f i l b.
            (f --> l) net ∧ ¬trivial_limit net ∧
            eventually (λx. f x = b) net ⇒
            (l = b)
   
   [LIM_COMPONENT_LBOUND]  Theorem
      
      ⊢ ∀net f l b.
            ¬trivial_limit net ∧ (f --> l) net ∧
            eventually (λx. b ≤ f x) net ⇒
            b ≤ l
   
   [LIM_COMPONENT_LE]  Theorem
      
      ⊢ ∀net f g l m.
            ¬trivial_limit net ∧ (f --> l) net ∧ (g --> m) net ∧
            eventually (λx. f x ≤ g x) net ⇒
            l ≤ m
   
   [LIM_COMPONENT_UBOUND]  Theorem
      
      ⊢ ∀net f l b k.
            ¬trivial_limit net ∧ (f --> l) net ∧
            eventually (λx. f x ≤ b) net ⇒
            l ≤ b
   
   [LIM_COMPOSE_AT]  Theorem
      
      ⊢ ∀net f g y z.
            (f --> y) net ∧ eventually (λw. (f w = y) ⇒ (g y = z)) net ∧
            (g --> z) (at y) ⇒
            (g ∘ f --> z) net
   
   [LIM_COMPOSE_WITHIN]  Theorem
      
      ⊢ ∀net f g s y z.
            (f --> y) net ∧
            eventually (λw. f w ∈ s ∧ ((f w = y) ⇒ (g y = z))) net ∧
            (g --> z) (at y within s) ⇒
            (g ∘ f --> z) net
   
   [LIM_CONG_AT]  Theorem
      
      ⊢ (∀x. x ≠ a ⇒ (f x = g x)) ⇒
        (((λx. f x) --> l) (at a) ⇔ (g --> l) (at a))
   
   [LIM_CONG_WITHIN]  Theorem
      
      ⊢ (∀x. x ≠ a ⇒ (f x = g x)) ⇒
        (((λx. f x) --> l) (at a within s) ⇔ (g --> l) (at a within s))
   
   [LIM_CONST]  Theorem
      
      ⊢ ∀net a. ((λx. a) --> a) net
   
   [LIM_CONST_EQ]  Theorem
      
      ⊢ ∀net c d. ((λx. c) --> d) net ⇔ trivial_limit net ∨ (c = d)
   
   [LIM_CONTINUOUS_FUNCTION]  Theorem
      
      ⊢ ∀f net g l.
            f continuous at l ∧ (g --> l) net ⇒ ((λx. f (g x)) --> f l) net
   
   [LIM_DROP_LBOUND]  Theorem
      
      ⊢ ∀net f l b.
            (f --> l) net ∧ ¬trivial_limit net ∧
            eventually (λx. b ≤ f x) net ⇒
            b ≤ l
   
   [LIM_DROP_LE]  Theorem
      
      ⊢ ∀net f g l m.
            ¬trivial_limit net ∧ (f --> l) net ∧ (g --> m) net ∧
            eventually (λx. f x ≤ g x) net ⇒
            l ≤ m
   
   [LIM_DROP_UBOUND]  Theorem
      
      ⊢ ∀net f l b.
            (f --> l) net ∧ ¬trivial_limit net ∧
            eventually (λx. f x ≤ b) net ⇒
            l ≤ b
   
   [LIM_EVENTUALLY]  Theorem
      
      ⊢ ∀net f l. eventually (λx. f x = l) net ⇒ (f --> l) net
   
   [LIM_INFINITY_POSINFINITY]  Theorem
      
      ⊢ ∀f l. (f --> l) at_infinity ⇒ (f --> l) at_posinfinity
   
   [LIM_INV]  Theorem
      
      ⊢ ∀net f l. (f --> l) net ∧ l ≠ 0 ⇒ (realinv ∘ f --> l⁻¹) net
   
   [LIM_IN_CLOSED_SET]  Theorem
      
      ⊢ ∀net f s l.
            closed s ∧ eventually (λx. f x ∈ s) net ∧ ¬trivial_limit net ∧
            (f --> l) net ⇒
            l ∈ s
   
   [LIM_LIFT_DOT]  Theorem
      
      ⊢ ∀f a. (f --> l) net ⇒ ((λy. a * f y) --> (a * l)) net
   
   [LIM_LINEAR]  Theorem
      
      ⊢ ∀net h f l. (f --> l) net ∧ linear h ⇒ ((λx. h (f x)) --> h l) net
   
   [LIM_MAX]  Theorem
      
      ⊢ ∀net f g l m.
            (f --> l) net ∧ (g --> m) net ⇒
            ((λx. max (f x) (g x)) --> max l m) net
   
   [LIM_MIN]  Theorem
      
      ⊢ ∀net f g l m.
            (f --> l) net ∧ (g --> m) net ⇒
            ((λx. min (f x) (g x)) --> min l m) net
   
   [LIM_MUL]  Theorem
      
      ⊢ ∀net f l c d.
            (c --> d) net ∧ (f --> l) net ⇒
            ((λx. c x * f x) --> (d * l)) net
   
   [LIM_NEG]  Theorem
      
      ⊢ ∀net f l. (f --> l) net ⇒ ((λx. -f x) --> -l) net
   
   [LIM_NEG_EQ]  Theorem
      
      ⊢ ∀net f l. ((λx. -f x) --> -l) net ⇔ (f --> l) net
   
   [LIM_NULL]  Theorem
      
      ⊢ ∀net f l. (f --> l) net ⇔ ((λx. f x − l) --> 0) net
   
   [LIM_NULL_ABS]  Theorem
      
      ⊢ ∀net f. (f --> 0) net ⇔ ((λx. abs (f x)) --> 0) net
   
   [LIM_NULL_ADD]  Theorem
      
      ⊢ ∀net f g.
            (f --> 0) net ∧ (g --> 0) net ⇒ ((λx. f x + g x) --> 0) net
   
   [LIM_NULL_CMUL]  Theorem
      
      ⊢ ∀net f c. (f --> 0) net ⇒ ((λx. c * f x) --> 0) net
   
   [LIM_NULL_CMUL_BOUNDED]  Theorem
      
      ⊢ ∀f g B.
            eventually (λa. (g a = 0) ∨ abs (f a) ≤ B) net ∧ (g --> 0) net ⇒
            ((λn. f n * g n) --> 0) net
   
   [LIM_NULL_CMUL_EQ]  Theorem
      
      ⊢ ∀net f c. c ≠ 0 ⇒ (((λx. c * f x) --> 0) net ⇔ (f --> 0) net)
   
   [LIM_NULL_COMPARISON]  Theorem
      
      ⊢ ∀net f g.
            eventually (λx. abs (f x) ≤ g x) net ∧ ((λx. g x) --> 0) net ⇒
            (f --> 0) net
   
   [LIM_NULL_SUB]  Theorem
      
      ⊢ ∀net f g.
            (f --> 0) net ∧ (g --> 0) net ⇒ ((λx. f x − g x) --> 0) net
   
   [LIM_NULL_SUM]  Theorem
      
      ⊢ ∀net f s.
            FINITE s ∧ (∀a. a ∈ s ⇒ ((λx. f x a) --> 0) net) ⇒
            ((λx. sum s (f x)) --> 0) net
   
   [LIM_POSINFINITY_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f l. (f --> l) at_posinfinity ⇒ ((λn. f (&n)) --> l) sequentially
   
   [LIM_SEQUENTIALLY]  Theorem
      
      ⊢ ∀s l.
            (s --> l) sequentially ⇔
            ∀e. 0 < e ⇒ ∃N. ∀n. N ≤ n ⇒ dist (s n,l) < e
   
   [LIM_SUB]  Theorem
      
      ⊢ ∀net f g l m.
            (f --> l) net ∧ (g --> m) net ⇒
            ((λx. f x − g x) --> (l − m)) net
   
   [LIM_SUBSEQUENCE]  Theorem
      
      ⊢ ∀s r l.
            (∀m n. m < n ⇒ r m < r n) ∧ (s --> l) sequentially ⇒
            (s ∘ r --> l) sequentially
   
   [LIM_SUM]  Theorem
      
      ⊢ ∀net f l s.
            FINITE s ∧ (∀i. i ∈ s ⇒ (f i --> l i) net) ⇒
            ((λx. sum s (λi. f i x)) --> sum s l) net
   
   [LIM_TRANSFORM]  Theorem
      
      ⊢ ∀net f g l.
            ((λx. f x − g x) --> 0) net ∧ (f --> l) net ⇒ (g --> l) net
   
   [LIM_TRANSFORM_AT]  Theorem
      
      ⊢ ∀f g x d.
            0 < d ∧
            (∀x'. 0 < dist (x',x) ∧ dist (x',x) < d ⇒ (f x' = g x')) ∧
            (f --> l) (at x) ⇒
            (g --> l) (at x)
   
   [LIM_TRANSFORM_AWAY_AT]  Theorem
      
      ⊢ ∀f g a b.
            a ≠ b ∧ (∀x. x ≠ a ∧ x ≠ b ⇒ (f x = g x)) ∧ (f --> l) (at a) ⇒
            (g --> l) (at a)
   
   [LIM_TRANSFORM_AWAY_WITHIN]  Theorem
      
      ⊢ ∀f g a b s.
            a ≠ b ∧ (∀x. x ∈ s ∧ x ≠ a ∧ x ≠ b ⇒ (f x = g x)) ∧
            (f --> l) (at a within s) ⇒
            (g --> l) (at a within s)
   
   [LIM_TRANSFORM_BOUND]  Theorem
      
      ⊢ ∀f g.
            eventually (λn. abs (f n) ≤ abs (g n)) net ∧ (g --> 0) net ⇒
            (f --> 0) net
   
   [LIM_TRANSFORM_EQ]  Theorem
      
      ⊢ ∀net f g l.
            ((λx. f x − g x) --> 0) net ⇒ ((f --> l) net ⇔ (g --> l) net)
   
   [LIM_TRANSFORM_EVENTUALLY]  Theorem
      
      ⊢ ∀net f g l.
            eventually (λx. f x = g x) net ∧ (f --> l) net ⇒ (g --> l) net
   
   [LIM_TRANSFORM_WITHIN]  Theorem
      
      ⊢ ∀f g x s d.
            0 < d ∧
            (∀x'.
                 x' ∈ s ∧ 0 < dist (x',x) ∧ dist (x',x) < d ⇒ (f x' = g x')) ∧
            (f --> l) (at x within s) ⇒
            (g --> l) (at x within s)
   
   [LIM_TRANSFORM_WITHIN_OPEN]  Theorem
      
      ⊢ ∀f g s a l.
            open s ∧ a ∈ s ∧ (∀x. x ∈ s ∧ x ≠ a ⇒ (f x = g x)) ∧
            (f --> l) (at a) ⇒
            (g --> l) (at a)
   
   [LIM_TRANSFORM_WITHIN_OPEN_IN]  Theorem
      
      ⊢ ∀f g s t a l.
            open_in (subtopology euclidean t) s ∧ a ∈ s ∧
            (∀x. x ∈ s ∧ x ≠ a ⇒ (f x = g x)) ∧ (f --> l) (at a within t) ⇒
            (g --> l) (at a within t)
   
   [LIM_TRANSFORM_WITHIN_SET]  Theorem
      
      ⊢ ∀f a s t.
            eventually (λx. x ∈ s ⇔ x ∈ t) (at a) ⇒
            ((f --> l) (at a within s) ⇔ (f --> l) (at a within t))
   
   [LIM_TRANSFORM_WITHIN_SET_IMP]  Theorem
      
      ⊢ ∀f l a s t.
            eventually (λx. x ∈ t ⇒ x ∈ s) (at a) ∧
            (f --> l) (at a within s) ⇒
            (f --> l) (at a within t)
   
   [LIM_UNION]  Theorem
      
      ⊢ ∀f x l s t.
            (f --> l) (at x within s) ∧ (f --> l) (at x within t) ⇒
            (f --> l) (at x within s ∪ t)
   
   [LIM_UNION_UNIV]  Theorem
      
      ⊢ ∀f x l s t.
            (f --> l) (at x within s) ∧ (f --> l) (at x within t) ∧
            (s ∪ t = 𝕌(:real)) ⇒
            (f --> l) (at x)
   
   [LIM_UNIQUE]  Theorem
      
      ⊢ ∀net f l l'.
            ¬trivial_limit net ∧ (f --> l) net ∧ (f --> l') net ⇒ (l = l')
   
   [LIM_VMUL]  Theorem
      
      ⊢ ∀net c d v. (c --> d) net ⇒ ((λx. c x * v) --> (d * v)) net
   
   [LIM_WITHIN]  Theorem
      
      ⊢ ∀f l a s.
            (f --> l) (at a within s) ⇔
            ∀e.
                0 < e ⇒
                ∃d.
                    0 < d ∧
                    ∀x.
                        x ∈ s ∧ 0 < dist (x,a) ∧ dist (x,a) < d ⇒
                        dist (f x,l) < e
   
   [LIM_WITHIN_CLOSED_TRIVIAL]  Theorem
      
      ⊢ ∀a s. closed s ∧ a ∉ s ⇒ trivial_limit (at a within s)
   
   [LIM_WITHIN_EMPTY]  Theorem
      
      ⊢ ∀f l x. (f --> l) (at x within ∅)
   
   [LIM_WITHIN_ID]  Theorem
      
      ⊢ ∀a s. ((λx. x) --> a) (at a within s)
   
   [LIM_WITHIN_INTERIOR]  Theorem
      
      ⊢ ∀f l s x.
            x ∈ interior s ⇒ ((f --> l) (at x within s) ⇔ (f --> l) (at x))
   
   [LIM_WITHIN_LE]  Theorem
      
      ⊢ ∀f l a s.
            (f --> l) (at a within s) ⇔
            ∀e.
                0 < e ⇒
                ∃d.
                    0 < d ∧
                    ∀x.
                        x ∈ s ∧ 0 < dist (x,a) ∧ dist (x,a) ≤ d ⇒
                        dist (f x,l) < e
   
   [LIM_WITHIN_OPEN]  Theorem
      
      ⊢ ∀f l a s.
            a ∈ s ∧ open s ⇒ ((f --> l) (at a within s) ⇔ (f --> l) (at a))
   
   [LIM_WITHIN_SUBSET]  Theorem
      
      ⊢ ∀f l a s.
            (f --> l) (at a within s) ∧ t ⊆ s ⇒ (f --> l) (at a within t)
   
   [LIM_WITHIN_UNION]  Theorem
      
      ⊢ (f --> l) (at x within s ∪ t) ⇔
        (f --> l) (at x within s) ∧ (f --> l) (at x within t)
   
   [LINEAR_0]  Theorem
      
      ⊢ ∀f. linear f ⇒ (f 0 = 0)
   
   [LINEAR_ADD]  Theorem
      
      ⊢ ∀f x y. linear f ⇒ (f (x + y) = f x + f y)
   
   [LINEAR_BOUNDED]  Theorem
      
      ⊢ ∀f. linear f ⇒ ∃B. ∀x. abs (f x) ≤ B * abs x
   
   [LINEAR_BOUNDED_POS]  Theorem
      
      ⊢ ∀f. linear f ⇒ ∃B. 0 < B ∧ ∀x. abs (f x) ≤ B * abs x
   
   [LINEAR_CMUL]  Theorem
      
      ⊢ ∀f c x. linear f ⇒ (f (c * x) = c * f x)
   
   [LINEAR_COMPOSE]  Theorem
      
      ⊢ ∀f g. linear f ∧ linear g ⇒ linear (g ∘ f)
   
   [LINEAR_COMPOSE_ADD]  Theorem
      
      ⊢ ∀f g. linear f ∧ linear g ⇒ linear (λx. f x + g x)
   
   [LINEAR_COMPOSE_CMUL]  Theorem
      
      ⊢ ∀f c. linear f ⇒ linear (λx. c * f x)
   
   [LINEAR_COMPOSE_NEG]  Theorem
      
      ⊢ ∀f. linear f ⇒ linear (λx. -f x)
   
   [LINEAR_COMPOSE_SUB]  Theorem
      
      ⊢ ∀f g. linear f ∧ linear g ⇒ linear (λx. f x − g x)
   
   [LINEAR_COMPOSE_SUM]  Theorem
      
      ⊢ ∀f s.
            FINITE s ∧ (∀a. a ∈ s ⇒ linear (f a)) ⇒
            linear (λx. sum s (λa. f a x))
   
   [LINEAR_CONTINUOUS_AT]  Theorem
      
      ⊢ ∀f a. linear f ⇒ f continuous at a
   
   [LINEAR_CONTINUOUS_COMPOSE]  Theorem
      
      ⊢ ∀net f g.
            f continuous net ∧ linear g ⇒ (λx. g (f x)) continuous net
   
   [LINEAR_CONTINUOUS_ON]  Theorem
      
      ⊢ ∀f s. linear f ⇒ f continuous_on s
   
   [LINEAR_CONTINUOUS_ON_COMPOSE]  Theorem
      
      ⊢ ∀f g s.
            f continuous_on s ∧ linear g ⇒ (λx. g (f x)) continuous_on s
   
   [LINEAR_CONTINUOUS_WITHIN]  Theorem
      
      ⊢ ∀f s x. linear f ⇒ f continuous (at x within s)
   
   [LINEAR_EQ]  Theorem
      
      ⊢ ∀f g b s.
            linear f ∧ linear g ∧ s ⊆ span b ∧ (∀x. x ∈ b ⇒ (f x = g x)) ⇒
            ∀x. x ∈ s ⇒ (f x = g x)
   
   [LINEAR_EQ_0]  Theorem
      
      ⊢ ∀f b s.
            linear f ∧ s ⊆ span b ∧ (∀x. x ∈ b ⇒ (f x = 0)) ⇒
            ∀x. x ∈ s ⇒ (f x = 0)
   
   [LINEAR_EQ_0_SPAN]  Theorem
      
      ⊢ ∀f b.
            linear f ∧ (∀x. x ∈ b ⇒ (f x = 0)) ⇒ ∀x. x ∈ span b ⇒ (f x = 0)
   
   [LINEAR_EQ_STDBASIS]  Theorem
      
      ⊢ ∀f g.
            linear f ∧ linear g ∧ (∀i. 1 ≤ i ∧ i ≤ 1 ⇒ (f i = g i)) ⇒
            (f = g)
   
   [LINEAR_ID]  Theorem
      
      ⊢ linear (λx. x)
   
   [LINEAR_IMAGE_SUBSET_INTERIOR]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀y. ∃x. f x = y) ⇒
            IMAGE f (interior s) ⊆ interior (IMAGE f s)
   
   [LINEAR_INDEPENDENT_EXTEND]  Theorem
      
      ⊢ ∀f b. independent b ⇒ ∃g. linear g ∧ ∀x. x ∈ b ⇒ (g x = f x)
   
   [LINEAR_INDEPENDENT_EXTEND_LEMMA]  Theorem
      
      ⊢ ∀f b.
            FINITE b ⇒
            independent b ⇒
            ∃g.
                (∀x y. x ∈ span b ∧ y ∈ span b ⇒ (g (x + y) = g x + g y)) ∧
                (∀x c. x ∈ span b ⇒ (g (c * x) = c * g x)) ∧
                ∀x. x ∈ b ⇒ (g x = f x)
   
   [LINEAR_INJECTIVE_0_SUBSPACE]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ subspace s ⇒
            ((∀x y. x ∈ s ∧ y ∈ s ∧ (f x = f y) ⇒ (x = y)) ⇔
             ∀x. x ∈ s ∧ (f x = 0) ⇒ (x = 0))
   
   [LINEAR_INJECTIVE_BOUNDED_BELOW_POS]  Theorem
      
      ⊢ ∀f.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            ∃B. 0 < B ∧ ∀x. abs x * B ≤ abs (f x)
   
   [LINEAR_INJECTIVE_IMP_SURJECTIVE]  Theorem
      
      ⊢ ∀f. linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒ ∀y. ∃x. f x = y
   
   [LINEAR_INJECTIVE_LEFT_INVERSE]  Theorem
      
      ⊢ ∀f.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            ∃g. linear g ∧ (g ∘ f = (λx. x))
   
   [LINEAR_INTERIOR_IMAGE_SUBSET]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            interior (IMAGE f s) ⊆ IMAGE f (interior s)
   
   [LINEAR_INVERTIBLE_BOUNDED_BELOW]  Theorem
      
      ⊢ ∀f g.
            linear f ∧ linear g ∧ (g ∘ f = I) ⇒
            ∃B. ∀x. B * abs x ≤ abs (f x)
   
   [LINEAR_INVERTIBLE_BOUNDED_BELOW_POS]  Theorem
      
      ⊢ ∀f g.
            linear f ∧ linear g ∧ (g ∘ f = I) ⇒
            ∃B. 0 < B ∧ ∀x. B * abs x ≤ abs (f x)
   
   [LINEAR_LIM_0]  Theorem
      
      ⊢ ∀f. linear f ⇒ (f --> 0) (at 0)
   
   [LINEAR_MUL_COMPONENT]  Theorem
      
      ⊢ ∀f v. linear f ⇒ linear (λx. f x * v)
   
   [LINEAR_NEG]  Theorem
      
      ⊢ ∀f x. linear f ⇒ (f (-x) = -f x)
   
   [LINEAR_NEGATION]  Theorem
      
      ⊢ linear (λx. -x)
   
   [LINEAR_OPEN_MAPPING]  Theorem
      
      ⊢ ∀f g.
            linear f ∧ linear g ∧ (f ∘ g = I) ⇒
            ∀s. open s ⇒ open (IMAGE f s)
   
   [LINEAR_SCALING]  Theorem
      
      ⊢ ∀c. linear (λx. c * x)
   
   [LINEAR_SUB]  Theorem
      
      ⊢ ∀f x y. linear f ⇒ (f (x − y) = f x − f y)
   
   [LINEAR_SUM]  Theorem
      
      ⊢ ∀f g s. linear f ∧ FINITE s ⇒ (f (sum s g) = sum s (f ∘ g))
   
   [LINEAR_SUM_MUL]  Theorem
      
      ⊢ ∀f s c v.
            linear f ∧ FINITE s ⇒
            (f (sum s (λi. c i * v i)) = sum s (λi. c i * f (v i)))
   
   [LINEAR_UNIFORMLY_CONTINUOUS_ON]  Theorem
      
      ⊢ ∀f s. linear f ⇒ f uniformly_continuous_on s
   
   [LINEAR_ZERO]  Theorem
      
      ⊢ linear (λx. 0)
   
   [LOCALLY_CLOSED]  Theorem
      
      ⊢ ∀s. locally closed s ⇔ locally compact s
   
   [LOCALLY_COMPACT]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇔
            ∀x.
                x ∈ s ⇒
                ∃u v.
                    x ∈ u ∧ u ⊆ v ∧ v ⊆ s ∧
                    open_in (subtopology euclidean s) u ∧ compact v
   
   [LOCALLY_COMPACT_ALT]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇔
            ∀x.
                x ∈ s ⇒
                ∃u.
                    x ∈ u ∧ open_in (subtopology euclidean s) u ∧
                    compact (closure u) ∧ closure u ⊆ s
   
   [LOCALLY_COMPACT_CLOSED_IN]  Theorem
      
      ⊢ ∀s t.
            closed_in (subtopology euclidean s) t ∧ locally compact s ⇒
            locally compact t
   
   [LOCALLY_COMPACT_CLOSED_INTER_OPEN]  Theorem
      
      ⊢ ∀s. locally compact s ⇔ ∃t u. closed t ∧ open u ∧ (s = t ∩ u)
   
   [LOCALLY_COMPACT_CLOSED_IN_OPEN]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇒
            ∃t. open t ∧ closed_in (subtopology euclidean t) s
   
   [LOCALLY_COMPACT_CLOSED_UNION]  Theorem
      
      ⊢ ∀s t.
            locally compact s ∧ locally compact t ∧
            closed_in (subtopology euclidean (s ∪ t)) s ∧
            closed_in (subtopology euclidean (s ∪ t)) t ⇒
            locally compact (s ∪ t)
   
   [LOCALLY_COMPACT_COMPACT]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇔
            ∀k.
                k ⊆ s ∧ compact k ⇒
                ∃u v.
                    k ⊆ u ∧ u ⊆ v ∧ v ⊆ s ∧
                    open_in (subtopology euclidean s) u ∧ compact v
   
   [LOCALLY_COMPACT_COMPACT_ALT]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇔
            ∀k.
                k ⊆ s ∧ compact k ⇒
                ∃u.
                    k ⊆ u ∧ open_in (subtopology euclidean s) u ∧
                    compact (closure u) ∧ closure u ⊆ s
   
   [LOCALLY_COMPACT_COMPACT_SUBOPEN]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇔
            ∀k t.
                k ⊆ s ∧ compact k ∧ open t ∧ k ⊆ t ⇒
                ∃u v.
                    k ⊆ u ∧ u ⊆ v ∧ u ⊆ t ∧ v ⊆ s ∧
                    open_in (subtopology euclidean s) u ∧ compact v
   
   [LOCALLY_COMPACT_DELETE]  Theorem
      
      ⊢ ∀s a. locally compact s ⇒ locally compact (s DELETE a)
   
   [LOCALLY_COMPACT_INTER]  Theorem
      
      ⊢ ∀s t.
            locally compact s ∧ locally compact t ⇒ locally compact (s ∩ t)
   
   [LOCALLY_COMPACT_INTER_CBALL]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇔
            ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ closed (cball (x,e) ∩ s)
   
   [LOCALLY_COMPACT_INTER_CBALLS]  Theorem
      
      ⊢ ∀s.
            locally compact s ⇔
            ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ ∀d. d ≤ e ⇒ closed (cball (x,d) ∩ s)
   
   [LOCALLY_COMPACT_OPEN_IN]  Theorem
      
      ⊢ ∀s t.
            open_in (subtopology euclidean s) t ∧ locally compact s ⇒
            locally compact t
   
   [LOCALLY_COMPACT_OPEN_INTER_CLOSURE]  Theorem
      
      ⊢ ∀s. locally compact s ⇒ ∃t. open t ∧ (s = t ∩ closure s)
   
   [LOCALLY_COMPACT_OPEN_UNION]  Theorem
      
      ⊢ ∀s t.
            locally compact s ∧ locally compact t ∧
            open_in (subtopology euclidean (s ∪ t)) s ∧
            open_in (subtopology euclidean (s ∪ t)) t ⇒
            locally compact (s ∪ t)
   
   [LOCALLY_COMPACT_PROPER_IMAGE]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ∧
            (∀k. k ⊆ IMAGE f s ∧ compact k ⇒ compact {x | x ∈ s ∧ f x ∈ k}) ∧
            locally compact s ⇒
            locally compact (IMAGE f s)
   
   [LOCALLY_COMPACT_PROPER_IMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ∧
            (∀k. k ⊆ IMAGE f s ∧ compact k ⇒ compact {x | x ∈ s ∧ f x ∈ k}) ⇒
            (locally compact s ⇔ locally compact (IMAGE f s))
   
   [LOCALLY_COMPACT_TRANSLATION_EQ]  Theorem
      
      ⊢ ∀a s. locally compact (IMAGE (λx. a + x) s) ⇔ locally compact s
   
   [LOCALLY_COMPACT_UNIV]  Theorem
      
      ⊢ locally compact 𝕌(:real)
   
   [LOCALLY_DIFF_CLOSED]  Theorem
      
      ⊢ ∀P s t.
            locally P s ∧ closed_in (subtopology euclidean s) t ⇒
            locally P (s DIFF t)
   
   [LOCALLY_EMPTY]  Theorem
      
      ⊢ ∀P. locally P ∅
   
   [LOCALLY_INJECTIVE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀P Q.
            (∀f s.
                 linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
                 (P (IMAGE f s) ⇔ Q s)) ⇒
            ∀f s.
                linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
                (locally P (IMAGE f s) ⇔ locally Q s)
   
   [LOCALLY_INTER]  Theorem
      
      ⊢ ∀P.
            (∀s t. P s ∧ P t ⇒ P (s ∩ t)) ⇒
            ∀s t. locally P s ∧ locally P t ⇒ locally P (s ∩ t)
   
   [LOCALLY_MONO]  Theorem
      
      ⊢ ∀P Q s. (∀t. P t ⇒ Q t) ∧ locally P s ⇒ locally Q s
   
   [LOCALLY_OPEN_MAP_IMAGE]  Theorem
      
      ⊢ ∀P Q f s.
            f continuous_on s ∧
            (∀t.
                 open_in (subtopology euclidean s) t ⇒
                 open_in (subtopology euclidean (IMAGE f s)) (IMAGE f t)) ∧
            (∀t. t ⊆ s ∧ P t ⇒ Q (IMAGE f t)) ∧ locally P s ⇒
            locally Q (IMAGE f s)
   
   [LOCALLY_OPEN_SUBSET]  Theorem
      
      ⊢ ∀P s t.
            locally P s ∧ open_in (subtopology euclidean s) t ⇒ locally P t
   
   [LOCALLY_SING]  Theorem
      
      ⊢ ∀P a. locally P {a} ⇔ P {a}
   
   [LOCALLY_TRANSLATION]  Theorem
      
      ⊢ ∀P.
            (∀a s. P (IMAGE (λx. a + x) s) ⇔ P s) ⇒
            ∀a s. locally P (IMAGE (λx. a + x) s) ⇔ locally P s
   
   [LOWER_HEMICONTINUOUS]  Theorem
      
      ⊢ ∀f t s.
            (∀x. x ∈ s ⇒ f x ⊆ t) ⇒
            ((∀u.
                  closed_in (subtopology euclidean t) u ⇒
                  closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ⊆ u}) ⇔
             ∀u.
                 open_in (subtopology euclidean t) u ⇒
                 open_in (subtopology euclidean s)
                   {x | x ∈ s ∧ f x ∩ u ≠ ∅})
   
   [LT_EXISTS]  Theorem
      
      ⊢ ∀m n. m < n ⇔ ∃d. n = m + SUC d
   
   [LT_NZ]  Theorem
      
      ⊢ ∀n. 0 < n ⇔ n ≠ 0
   
   [MAPPING_CONNECTED_ONTO_SEGMENT]  Theorem
      
      ⊢ ∀s a b.
            connected s ∧ ¬(∃a. s ⊆ {a}) ⇒
            ∃f. f continuous_on s ∧ (IMAGE f s = segment [(a,b)])
   
   [MAXIMAL_INDEPENDENT_SUBSET]  Theorem
      
      ⊢ ∀v. ∃b. b ⊆ v ∧ independent b ∧ v ⊆ span b
   
   [MAXIMAL_INDEPENDENT_SUBSET_EXTEND]  Theorem
      
      ⊢ ∀s v.
            s ⊆ v ∧ independent s ⇒
            ∃b. s ⊆ b ∧ b ⊆ v ∧ independent b ∧ v ⊆ span b
   
   [MIDPOINT_COLLINEAR]  Theorem
      
      ⊢ ∀a b c.
            a ≠ c ⇒
            ((b = midpoint (a,c)) ⇔
             collinear {a; b; c} ∧ (dist (a,b) = dist (b,c)))
   
   [MIDPOINT_EQ_ENDPOINT]  Theorem
      
      ⊢ ∀a b.
            ((midpoint (a,b) = a) ⇔ (a = b)) ∧
            ((midpoint (a,b) = b) ⇔ (a = b)) ∧
            ((a = midpoint (a,b)) ⇔ (a = b)) ∧
            ((b = midpoint (a,b)) ⇔ (a = b))
   
   [MIDPOINT_IN_SEGMENT]  Theorem
      
      ⊢ (∀a b. midpoint (a,b) ∈ segment [(a,b)]) ∧
        ∀a b. midpoint (a,b) ∈ segment (a,b) ⇔ a ≠ b
   
   [MIDPOINT_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f a b. linear f ⇒ (midpoint (f a,f b) = f (midpoint (a,b)))
   
   [MIDPOINT_REFL]  Theorem
      
      ⊢ ∀x. midpoint (x,x) = x
   
   [MIDPOINT_SYM]  Theorem
      
      ⊢ ∀a b. midpoint (a,b) = midpoint (b,a)
   
   [MONOTONE_BIGGER]  Theorem
      
      ⊢ ∀r. (∀m n. m < n ⇒ r m < r n) ⇒ ∀n. n ≤ r n
   
   [MONOTONE_SUBSEQUENCE]  Theorem
      
      ⊢ ∀s.
            ∃r.
                (∀m n. m < n ⇒ r m < r n) ∧
                ((∀m n. m ≤ n ⇒ s (r m) ≤ s (r n)) ∨
                 ∀m n. m ≤ n ⇒ s (r n) ≤ s (r m))
   
   [MUL_CAUCHY_SCHWARZ_EQUAL]  Theorem
      
      ⊢ ∀x y. ((x * y) pow 2 = x * x * (y * y)) ⇔ collinear {0; x; y}
   
   [MUMFORD_LEMMA]  Theorem
      
      ⊢ ∀f s t y.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧ locally compact s ∧ y ∈ t ∧
            compact {x | x ∈ s ∧ (f x = y)} ⇒
            ∃u v.
                open_in (subtopology euclidean s) u ∧
                open_in (subtopology euclidean t) v ∧
                {x | x ∈ s ∧ (f x = y)} ⊆ u ∧ y ∈ v ∧ IMAGE f u ⊆ v ∧
                ∀k. k ⊆ v ∧ compact k ⇒ compact {x | x ∈ u ∧ f x ∈ k}
   
   [NEGATIONS_BALL]  Theorem
      
      ⊢ ∀r. IMAGE (λx. -x) (ball (0,r)) = ball (0,r)
   
   [NEGATIONS_CBALL]  Theorem
      
      ⊢ ∀r. IMAGE (λx. -x) (cball (0,r)) = cball (0,r)
   
   [NEGATIONS_SPHERE]  Theorem
      
      ⊢ ∀r. IMAGE (λx. -x) (sphere (0,r)) = sphere (0,r)
   
   [NET]  Theorem
      
      ⊢ ∀n x y.
            (∀z. netord n z x ⇒ netord n z y) ∨
            ∀z. netord n z y ⇒ netord n z x
   
   [NETLIMIT_AT]  Theorem
      
      ⊢ ∀a. netlimit (at a) = a
   
   [NETLIMIT_WITHIN]  Theorem
      
      ⊢ ∀a s.
            ¬trivial_limit (at a within s) ⇒ (netlimit (at a within s) = a)
   
   [NETLIMIT_WITHIN_INTERIOR]  Theorem
      
      ⊢ ∀s x. x ∈ interior s ⇒ (netlimit (at x within s) = x)
   
   [NET_DILEMMA]  Theorem
      
      ⊢ ∀net.
            (∃a. (∃x. netord net x a) ∧ ∀x. netord net x a ⇒ P x) ∧
            (∃b. (∃x. netord net x b) ∧ ∀x. netord net x b ⇒ Q x) ⇒
            ∃c. (∃x. netord net x c) ∧ ∀x. netord net x c ⇒ P x ∧ Q x
   
   [NONTRIVIAL_LIMIT_WITHIN]  Theorem
      
      ⊢ ∀net s. trivial_limit net ⇒ trivial_limit (net within s)
   
   [NOT_BOUNDED_UNIV]  Theorem
      
      ⊢ ¬bounded 𝕌(:real)
   
   [NOT_EQ]  Theorem
      
      ⊢ ∀a b. a ≠ b ⇔ a ≠ b
   
   [NOT_EVENTUALLY]  Theorem
      
      ⊢ ∀net p. (∀x. ¬p x) ∧ ¬trivial_limit net ⇒ ¬eventually p net
   
   [NOT_INTERVAL_UNIV]  Theorem
      
      ⊢ (∀a b. interval [(a,b)] ≠ 𝕌(:real)) ∧
        ∀a b. interval (a,b) ≠ 𝕌(:real)
   
   [NOWHERE_DENSE]  Theorem
      
      ⊢ ∀s.
            (interior (closure s) = ∅) ⇔
            ∀t. open t ∧ t ≠ ∅ ⇒ ∃u. open u ∧ u ≠ ∅ ∧ u ⊆ t ∧ (u ∩ s = ∅)
   
   [NOWHERE_DENSE_COUNTABLE_BIGUNION]  Theorem
      
      ⊢ ∀g.
            COUNTABLE g ∧ (∀s. s ∈ g ⇒ (interior (closure s) = ∅)) ⇒
            (interior (BIGUNION g) = ∅)
   
   [NOWHERE_DENSE_COUNTABLE_BIGUNION_CLOSED]  Theorem
      
      ⊢ ∀g.
            COUNTABLE g ∧ (∀s. s ∈ g ⇒ closed s ∧ (interior s = ∅)) ⇒
            (interior (BIGUNION g) = ∅)
   
   [NOWHERE_DENSE_UNION]  Theorem
      
      ⊢ ∀s t.
            (interior (closure (s ∪ t)) = ∅) ⇔
            (interior (closure s) = ∅) ∧ (interior (closure t) = ∅)
   
   [NO_LIMIT_POINT_IMP_CLOSED]  Theorem
      
      ⊢ ∀s. ¬(∃x. x limit_point_of s) ⇒ closed s
   
   [OLDNET]  Theorem
      
      ⊢ ∀n x y.
            netord n x x ∧ netord n y y ⇒
            ∃z.
                netord n z z ∧
                ∀w. netord n w z ⇒ netord n w x ∧ netord n w y
   
   [OPEN]  Theorem
      
      ⊢ ∀s. open s ⇔ ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ ∀x'. abs (x' − x) < e ⇒ x' ∈ s
   
   [OPEN_AFFINITY]  Theorem
      
      ⊢ ∀s a c. open s ∧ c ≠ 0 ⇒ open (IMAGE (λx. a + c * x) s)
   
   [OPEN_BALL]  Theorem
      
      ⊢ ∀x e. open (ball (x,e))
   
   [OPEN_BIGINTER]  Theorem
      
      ⊢ ∀s. FINITE s ∧ (∀t. t ∈ s ⇒ open t) ⇒ open (BIGINTER s)
   
   [OPEN_BIGUNION]  Theorem
      
      ⊢ (∀s. s ∈ f ⇒ open s) ⇒ open (BIGUNION f)
   
   [OPEN_BIJECTIVE_LINEAR_IMAGE_EQ]  Theorem
      
      ⊢ ∀f s.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ∧ (∀y. ∃x. f x = y) ⇒
            (open (IMAGE f s) ⇔ open s)
   
   [OPEN_CLOSED]  Theorem
      
      ⊢ ∀s. open s ⇔ closed (𝕌(:real) DIFF s)
   
   [OPEN_CLOSED_INTERVAL]  Theorem
      
      ⊢ ∀a b. interval (a,b) = interval [(a,b)] DIFF {a; b}
   
   [OPEN_CLOSED_INTERVAL_CONVEX]  Theorem
      
      ⊢ ∀a b x y e.
            x ∈ interval (a,b) ∧ y ∈ interval [(a,b)] ∧ 0 < e ∧ e ≤ 1 ⇒
            e * x + (1 − e) * y ∈ interval (a,b)
   
   [OPEN_CONTAINS_BALL]  Theorem
      
      ⊢ ∀s. open s ⇔ ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ ball (x,e) ⊆ s
   
   [OPEN_CONTAINS_BALL_EQ]  Theorem
      
      ⊢ ∀s. open s ⇒ ∀x. x ∈ s ⇔ ∃e. 0 < e ∧ ball (x,e) ⊆ s
   
   [OPEN_CONTAINS_CBALL]  Theorem
      
      ⊢ ∀s. open s ⇔ ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ cball (x,e) ⊆ s
   
   [OPEN_CONTAINS_CBALL_EQ]  Theorem
      
      ⊢ ∀s. open s ⇒ ∀x. x ∈ s ⇔ ∃e. 0 < e ∧ cball (x,e) ⊆ s
   
   [OPEN_CONTAINS_INTERVAL]  Theorem
      
      ⊢ ∀s.
            open s ⇔
            ∀x. x ∈ s ⇒ ∃a b. x ∈ interval (a,b) ∧ interval [(a,b)] ⊆ s
   
   [OPEN_CONTAINS_INTERVAL_OPEN_INTERVAL]  Theorem
      
      ⊢ (∀s.
             open s ⇔
             ∀x. x ∈ s ⇒ ∃a b. x ∈ interval (a,b) ∧ interval [(a,b)] ⊆ s) ∧
        ∀s.
            open s ⇔
            ∀x. x ∈ s ⇒ ∃a b. x ∈ interval (a,b) ∧ interval (a,b) ⊆ s
   
   [OPEN_CONTAINS_OPEN_INTERVAL]  Theorem
      
      ⊢ ∀s.
            open s ⇔
            ∀x. x ∈ s ⇒ ∃a b. x ∈ interval (a,b) ∧ interval (a,b) ⊆ s
   
   [OPEN_DELETE]  Theorem
      
      ⊢ ∀s x. open s ⇒ open (s DELETE x)
   
   [OPEN_DIFF]  Theorem
      
      ⊢ ∀s t. open s ∧ closed t ⇒ open (s DIFF t)
   
   [OPEN_EMPTY]  Theorem
      
      ⊢ open ∅
   
   [OPEN_EXISTS]  Theorem
      
      ⊢ ∀Q. (∀a. open {x | Q a x}) ⇒ open {x | (∃a. Q a x)}
   
   [OPEN_EXISTS_IN]  Theorem
      
      ⊢ ∀P Q. (∀a. P a ⇒ open {x | Q a x}) ⇒ open {x | (∃a. P a ∧ Q a x)}
   
   [OPEN_HALFSPACE_COMPONENT_GT]  Theorem
      
      ⊢ ∀a. open {x | x > a}
   
   [OPEN_HALFSPACE_COMPONENT_LT]  Theorem
      
      ⊢ ∀a. open {x | x < a}
   
   [OPEN_HALFSPACE_GT]  Theorem
      
      ⊢ ∀a b. open {x | a * x > b}
   
   [OPEN_HALFSPACE_LT]  Theorem
      
      ⊢ ∀a b. open {x | a * x < b}
   
   [OPEN_IMP_INFINITE]  Theorem
      
      ⊢ ∀s. open s ⇒ (s = ∅) ∨ INFINITE s
   
   [OPEN_IMP_LOCALLY_COMPACT]  Theorem
      
      ⊢ ∀s. open s ⇒ locally compact s
   
   [OPEN_IN]  Theorem
      
      ⊢ ∀s. open s ⇔ open_in euclidean s
   
   [OPEN_INTER]  Theorem
      
      ⊢ ∀s t. open s ∧ open t ⇒ open (s ∩ t)
   
   [OPEN_INTERIOR]  Theorem
      
      ⊢ ∀s. open (interior s)
   
   [OPEN_INTERVAL]  Theorem
      
      ⊢ ∀a b. open (interval (a,b))
   
   [OPEN_INTERVAL_EQ]  Theorem
      
      ⊢ (∀a b. open (interval [(a,b)]) ⇔ (interval [(a,b)] = ∅)) ∧
        ∀a b. open (interval (a,b))
   
   [OPEN_INTERVAL_LEFT]  Theorem
      
      ⊢ ∀b. open {x | x < b}
   
   [OPEN_INTERVAL_LEMMA]  Theorem
      
      ⊢ ∀a b x.
            a < x ∧ x < b ⇒
            ∃d. 0 < d ∧ ∀x'. abs (x' − x) < d ⇒ a < x' ∧ x' < b
   
   [OPEN_INTERVAL_MIDPOINT]  Theorem
      
      ⊢ ∀a b. interval (a,b) ≠ ∅ ⇒ 2⁻¹ * (a + b) ∈ interval (a,b)
   
   [OPEN_INTERVAL_RIGHT]  Theorem
      
      ⊢ ∀a. open {x | a < x}
   
   [OPEN_INTER_CLOSURE_EQ_EMPTY]  Theorem
      
      ⊢ ∀s t. open s ⇒ ((s ∩ closure t = ∅) ⇔ (s ∩ t = ∅))
   
   [OPEN_INTER_CLOSURE_SUBSET]  Theorem
      
      ⊢ ∀s t. open s ⇒ s ∩ closure t ⊆ closure (s ∩ t)
   
   [OPEN_IN_CONNECTED_COMPONENT]  Theorem
      
      ⊢ ∀s x.
            FINITE {connected_component s x | x | x ∈ s} ⇒
            open_in (subtopology euclidean s) (connected_component s x)
   
   [OPEN_IN_CONTAINS_BALL]  Theorem
      
      ⊢ ∀s t.
            open_in (subtopology euclidean t) s ⇔
            s ⊆ t ∧ ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ ball (x,e) ∩ t ⊆ s
   
   [OPEN_IN_CONTAINS_CBALL]  Theorem
      
      ⊢ ∀s t.
            open_in (subtopology euclidean t) s ⇔
            s ⊆ t ∧ ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ cball (x,e) ∩ t ⊆ s
   
   [OPEN_IN_DELETE]  Theorem
      
      ⊢ ∀u s a.
            open_in (subtopology euclidean u) s ⇒
            open_in (subtopology euclidean u) (s DELETE a)
   
   [OPEN_IN_IMP_SUBSET]  Theorem
      
      ⊢ ∀top s t. open_in (subtopology top s) t ⇒ t ⊆ s
   
   [OPEN_IN_INTER_OPEN]  Theorem
      
      ⊢ ∀s t u.
            open_in (subtopology euclidean u) s ∧ open t ⇒
            open_in (subtopology euclidean u) (s ∩ t)
   
   [OPEN_IN_LOCALLY_COMPACT]  Theorem
      
      ⊢ ∀s t.
            locally compact s ⇒
            (open_in (subtopology euclidean s) t ⇔
             t ⊆ s ∧
             ∀k.
                 compact k ∧ k ⊆ s ⇒
                 open_in (subtopology euclidean k) (k ∩ t))
   
   [OPEN_IN_OPEN]  Theorem
      
      ⊢ ∀s u.
            open_in (subtopology euclidean u) s ⇔ ∃t. open t ∧ (s = u ∩ t)
   
   [OPEN_IN_OPEN_EQ]  Theorem
      
      ⊢ ∀s t.
            open s ⇒ (open_in (subtopology euclidean s) t ⇔ open t ∧ t ⊆ s)
   
   [OPEN_IN_OPEN_INTER]  Theorem
      
      ⊢ ∀u s. open s ⇒ open_in (subtopology euclidean u) (u ∩ s)
   
   [OPEN_IN_OPEN_TRANS]  Theorem
      
      ⊢ ∀s t. open_in (subtopology euclidean t) s ∧ open t ⇒ open s
   
   [OPEN_IN_REFL]  Theorem
      
      ⊢ ∀s. open_in (subtopology euclidean s) s
   
   [OPEN_IN_SING]  Theorem
      
      ⊢ ∀s a.
            open_in (subtopology euclidean s) {a} ⇔
            a ∈ s ∧ ¬(a limit_point_of s)
   
   [OPEN_IN_SUBSET_TRANS]  Theorem
      
      ⊢ ∀s t u.
            open_in (subtopology euclidean u) s ∧ s ⊆ t ∧ t ⊆ u ⇒
            open_in (subtopology euclidean t) s
   
   [OPEN_IN_SUBTOPOLOGY]  Theorem
      
      ⊢ ∀top u s.
            open_in (subtopology top u) s ⇔ ∃t. open_in top t ∧ (s = t ∩ u)
   
   [OPEN_IN_SUBTOPOLOGY_EMPTY]  Theorem
      
      ⊢ ∀top s. open_in (subtopology top ∅) s ⇔ (s = ∅)
   
   [OPEN_IN_SUBTOPOLOGY_INTER_SUBSET]  Theorem
      
      ⊢ ∀s u v.
            open_in (subtopology euclidean u) (u ∩ s) ∧ v ⊆ u ⇒
            open_in (subtopology euclidean v) (v ∩ s)
   
   [OPEN_IN_SUBTOPOLOGY_REFL]  Theorem
      
      ⊢ ∀top u. open_in (subtopology top u) u ⇔ u ⊆ topspace top
   
   [OPEN_IN_SUBTOPOLOGY_UNION]  Theorem
      
      ⊢ ∀top s t u.
            open_in (subtopology top t) s ∧ open_in (subtopology top u) s ⇒
            open_in (subtopology top (t ∪ u)) s
   
   [OPEN_IN_TRANS]  Theorem
      
      ⊢ ∀s t u.
            open_in (subtopology euclidean t) s ∧
            open_in (subtopology euclidean u) t ⇒
            open_in (subtopology euclidean u) s
   
   [OPEN_IN_TRANS_EQ]  Theorem
      
      ⊢ ∀s t.
            (∀u.
                 open_in (subtopology euclidean t) u ⇒
                 open_in (subtopology euclidean s) t) ⇔
            open_in (subtopology euclidean s) t
   
   [OPEN_MAP_CLOSED_SUPERSET_PREIMAGE]  Theorem
      
      ⊢ ∀f s t u w.
            (∀k.
                 open_in (subtopology euclidean s) k ⇒
                 open_in (subtopology euclidean t) (IMAGE f k)) ∧
            closed_in (subtopology euclidean s) u ∧ w ⊆ t ∧
            {x | x ∈ s ∧ f x ∈ w} ⊆ u ⇒
            ∃v.
                closed_in (subtopology euclidean t) v ∧ w ⊆ v ∧
                {x | x ∈ s ∧ f x ∈ v} ⊆ u
   
   [OPEN_MAP_CLOSED_SUPERSET_PREIMAGE_EQ]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀k.
                  open_in (subtopology euclidean s) k ⇒
                  open_in (subtopology euclidean t) (IMAGE f k)) ⇔
             ∀u w.
                 closed_in (subtopology euclidean s) u ∧ w ⊆ t ∧
                 {x | x ∈ s ∧ f x ∈ w} ⊆ u ⇒
                 ∃v.
                     closed_in (subtopology euclidean t) v ∧ w ⊆ v ∧
                     {x | x ∈ s ∧ f x ∈ v} ⊆ u)
   
   [OPEN_MAP_FROM_COMPOSITION_INJECTIVE]  Theorem
      
      ⊢ ∀f g s t u.
            IMAGE f s ⊆ t ∧ IMAGE g t ⊆ u ∧ g continuous_on t ∧
            (∀x y. x ∈ t ∧ y ∈ t ∧ (g x = g y) ⇒ (x = y)) ∧
            (∀k.
                 open_in (subtopology euclidean s) k ⇒
                 open_in (subtopology euclidean u) (IMAGE (g ∘ f) k)) ⇒
            ∀k.
                open_in (subtopology euclidean s) k ⇒
                open_in (subtopology euclidean t) (IMAGE f k)
   
   [OPEN_MAP_FROM_COMPOSITION_SURJECTIVE]  Theorem
      
      ⊢ ∀f g s t u.
            f continuous_on s ∧ (IMAGE f s = t) ∧ IMAGE g t ⊆ u ∧
            (∀k.
                 open_in (subtopology euclidean s) k ⇒
                 open_in (subtopology euclidean u) (IMAGE (g ∘ f) k)) ⇒
            ∀k.
                open_in (subtopology euclidean t) k ⇒
                open_in (subtopology euclidean u) (IMAGE g k)
   
   [OPEN_MAP_IFF_LOWER_HEMICONTINUOUS_PREIMAGE]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀u.
                  open_in (subtopology euclidean s) u ⇒
                  open_in (subtopology euclidean t) (IMAGE f u)) ⇔
             ∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean t)
                   {y | y ∈ t ∧ {x | x ∈ s ∧ (f x = y)} ⊆ u})
   
   [OPEN_MAP_IMP_CLOSED_MAP]  Theorem
      
      ⊢ ∀f s t.
            (IMAGE f s = t) ∧
            (∀u.
                 open_in (subtopology euclidean s) u ⇒
                 open_in (subtopology euclidean t) (IMAGE f u)) ∧
            (∀u.
                 closed_in (subtopology euclidean s) u ⇒
                 closed_in (subtopology euclidean s)
                   {x | x ∈ s ∧ f x ∈ IMAGE f u}) ⇒
            ∀u.
                closed_in (subtopology euclidean s) u ⇒
                closed_in (subtopology euclidean t) (IMAGE f u)
   
   [OPEN_MAP_IMP_QUOTIENT_MAP]  Theorem
      
      ⊢ ∀f s.
            f continuous_on s ∧
            (∀t.
                 open_in (subtopology euclidean s) t ⇒
                 open_in (subtopology euclidean (IMAGE f s)) (IMAGE f t)) ⇒
            ∀t.
                t ⊆ IMAGE f s ⇒
                (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ t} ⇔
                 open_in (subtopology euclidean (IMAGE f s)) t)
   
   [OPEN_MAP_INTERIORS]  Theorem
      
      ⊢ ∀f.
            (∀s. open s ⇒ open (IMAGE f s)) ⇔
            ∀s. IMAGE f (interior s) ⊆ interior (IMAGE f s)
   
   [OPEN_MAP_RESTRICT]  Theorem
      
      ⊢ ∀f s t t'.
            (∀u.
                 open_in (subtopology euclidean s) u ⇒
                 open_in (subtopology euclidean t) (IMAGE f u)) ∧ t' ⊆ t ⇒
            ∀u.
                open_in (subtopology euclidean {x | x ∈ s ∧ f x ∈ t'}) u ⇒
                open_in (subtopology euclidean t') (IMAGE f u)
   
   [OPEN_NEGATIONS]  Theorem
      
      ⊢ ∀s. open s ⇒ open (IMAGE (λx. -x) s)
   
   [OPEN_OPEN_IN_TRANS]  Theorem
      
      ⊢ ∀s t. open s ∧ open t ∧ t ⊆ s ⇒ open_in (subtopology euclidean s) t
   
   [OPEN_POSITIVE_MULTIPLES]  Theorem
      
      ⊢ ∀s. open s ⇒ open {c * x | 0 < c ∧ x ∈ s}
   
   [OPEN_POSITIVE_ORTHANT]  Theorem
      
      ⊢ open {x | 0 < x}
   
   [OPEN_SCALING]  Theorem
      
      ⊢ ∀s c. c ≠ 0 ∧ open s ⇒ open (IMAGE (λx. c * x) s)
   
   [OPEN_SEGMENT]  Theorem
      
      ⊢ ∀a b. open (segment (a,b))
   
   [OPEN_SEGMENT_ALT]  Theorem
      
      ⊢ ∀a b.
            a ≠ b ⇒ (segment (a,b) = {(1 − u) * a + u * b | 0 < u ∧ u < 1})
   
   [OPEN_SEGMENT_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f a b.
            linear f ∧ (∀x y. (f x = f y) ⇒ (x = y)) ⇒
            (segment (f a,f b) = IMAGE f (segment (a,b)))
   
   [OPEN_SUBSET]  Theorem
      
      ⊢ ∀s t. s ⊆ t ∧ open s ⇒ open_in (subtopology euclidean t) s
   
   [OPEN_SUBSET_INTERIOR]  Theorem
      
      ⊢ ∀s t. open s ⇒ (s ⊆ interior t ⇔ s ⊆ t)
   
   [OPEN_SUB_OPEN]  Theorem
      
      ⊢ ∀s. open s ⇔ ∀x. x ∈ s ⇒ ∃t. open t ∧ x ∈ t ∧ t ⊆ s
   
   [OPEN_SUMS]  Theorem
      
      ⊢ ∀s t. open s ∨ open t ⇒ open {x + y | x ∈ s ∧ y ∈ t}
   
   [OPEN_SURJECTIVE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f. linear f ∧ (∀y. ∃x. f x = y) ⇒ ∀s. open s ⇒ open (IMAGE f s)
   
   [OPEN_TRANSLATION]  Theorem
      
      ⊢ ∀s a. open s ⇒ open (IMAGE (λx. a + x) s)
   
   [OPEN_TRANSLATION_EQ]  Theorem
      
      ⊢ ∀a s. open (IMAGE (λx. a + x) s) ⇔ open s
   
   [OPEN_UNION]  Theorem
      
      ⊢ ∀s t. open s ∧ open t ⇒ open (s ∪ t)
   
   [OPEN_UNION_COMPACT_SUBSETS]  Theorem
      
      ⊢ ∀s.
            open s ⇒
            ∃f.
                (∀n. compact (f n)) ∧ (∀n. f n ⊆ s) ∧
                (∀n. f n ⊆ interior (f (n + 1))) ∧
                (BIGUNION {f n | n ∈ 𝕌(:num)} = s) ∧
                ∀k. compact k ∧ k ⊆ s ⇒ ∃N. ∀n. n ≥ N ⇒ k ⊆ f n
   
   [OPEN_UNIV]  Theorem
      
      ⊢ open 𝕌(:real)
   
   [PAIRWISE_DISJOINT_COMPONENTS]  Theorem
      
      ⊢ ∀u. pairwise DISJOINT (components u)
   
   [PAIRWISE_EMPTY]  Theorem
      
      ⊢ ∀r. pairwise r ∅ ⇔ T
   
   [PAIRWISE_IMAGE]  Theorem
      
      ⊢ ∀r f.
            pairwise r (IMAGE f s) ⇔
            pairwise (λx y. f x ≠ f y ⇒ r (f x) (f y)) s
   
   [PAIRWISE_INSERT]  Theorem
      
      ⊢ ∀r x s.
            pairwise r (x INSERT s) ⇔
            (∀y. y ∈ s ∧ y ≠ x ⇒ r x y ∧ r y x) ∧ pairwise r s
   
   [PAIRWISE_MONO]  Theorem
      
      ⊢ ∀r s t. pairwise r s ∧ t ⊆ s ⇒ pairwise r t
   
   [PAIRWISE_SING]  Theorem
      
      ⊢ ∀r x. pairwise r {x} ⇔ T
   
   [PARTIAL_SUMS_COMPONENT_LE_INFSUM]  Theorem
      
      ⊢ ∀f s n.
            (∀i. i ∈ s ⇒ 0 ≤ f i) ∧ summable s f ⇒
            sum (s ∩ (0 .. n)) f ≤ infsum s f
   
   [PARTIAL_SUMS_DROP_LE_INFSUM]  Theorem
      
      ⊢ ∀f s n.
            (∀i. i ∈ s ⇒ 0 ≤ f i) ∧ summable s f ⇒
            sum (s ∩ (0 .. n)) f ≤ infsum s f
   
   [PASTING_LEMMA]  Theorem
      
      ⊢ ∀f g t s k.
            (∀i.
                 i ∈ k ⇒
                 open_in (subtopology euclidean s) (t i) ∧
                 f i continuous_on t i) ∧
            (∀i j x. i ∈ k ∧ j ∈ k ∧ x ∈ s ∩ t i ∩ t j ⇒ (f i x = f j x)) ∧
            (∀x. x ∈ s ⇒ ∃j. j ∈ k ∧ x ∈ t j ∧ (g x = f j x)) ⇒
            g continuous_on s
   
   [PASTING_LEMMA_CLOSED]  Theorem
      
      ⊢ ∀f g t s k.
            FINITE k ∧
            (∀i.
                 i ∈ k ⇒
                 closed_in (subtopology euclidean s) (t i) ∧
                 f i continuous_on t i) ∧
            (∀i j x. i ∈ k ∧ j ∈ k ∧ x ∈ s ∩ t i ∩ t j ⇒ (f i x = f j x)) ∧
            (∀x. x ∈ s ⇒ ∃j. j ∈ k ∧ x ∈ t j ∧ (g x = f j x)) ⇒
            g continuous_on s
   
   [PASTING_LEMMA_EXISTS]  Theorem
      
      ⊢ ∀f t s k.
            s ⊆ BIGUNION {t i | i ∈ k} ∧
            (∀i.
                 i ∈ k ⇒
                 open_in (subtopology euclidean s) (t i) ∧
                 f i continuous_on t i) ∧
            (∀i j x. i ∈ k ∧ j ∈ k ∧ x ∈ s ∩ t i ∩ t j ⇒ (f i x = f j x)) ⇒
            ∃g.
                g continuous_on s ∧
                ∀x i. i ∈ k ∧ x ∈ s ∩ t i ⇒ (g x = f i x)
   
   [PASTING_LEMMA_EXISTS_CLOSED]  Theorem
      
      ⊢ ∀f t s k.
            FINITE k ∧ s ⊆ BIGUNION {t i | i ∈ k} ∧
            (∀i.
                 i ∈ k ⇒
                 closed_in (subtopology euclidean s) (t i) ∧
                 f i continuous_on t i) ∧
            (∀i j x. i ∈ k ∧ j ∈ k ∧ x ∈ s ∩ t i ∩ t j ⇒ (f i x = f j x)) ⇒
            ∃g.
                g continuous_on s ∧
                ∀x i. i ∈ k ∧ x ∈ s ∩ t i ⇒ (g x = f i x)
   
   [PERMUTES_IMAGE]  Theorem
      
      ⊢ ∀p s. p permutes s ⇒ (IMAGE p s = s)
   
   [PERMUTES_INJECTIVE]  Theorem
      
      ⊢ ∀p s. p permutes s ⇒ ∀x y. (p x = p y) ⇔ (x = y)
   
   [POWERSET_CLAUSES]  Theorem
      
      ⊢ ({s | s ⊆ ∅} = {∅}) ∧
        ∀a t.
            {s | s ⊆ a INSERT t} =
            {s | s ⊆ t} ∪ IMAGE (λs. a INSERT s) {s | s ⊆ t}
   
   [PROPER_MAP]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀k. k ⊆ t ∧ compact k ⇒ compact {x | x ∈ s ∧ f x ∈ k}) ⇔
             (∀k.
                  closed_in (subtopology euclidean s) k ⇒
                  closed_in (subtopology euclidean t) (IMAGE f k)) ∧
             ∀a. a ∈ t ⇒ compact {x | x ∈ s ∧ (f x = a)})
   
   [PROPER_MAP_COMPOSE]  Theorem
      
      ⊢ ∀f g s t u.
            IMAGE f s ⊆ t ∧
            (∀k. k ⊆ t ∧ compact k ⇒ compact {x | x ∈ s ∧ f x ∈ k}) ∧
            (∀k. k ⊆ u ∧ compact k ⇒ compact {x | x ∈ t ∧ g x ∈ k}) ⇒
            ∀k. k ⊆ u ∧ compact k ⇒ compact {x | x ∈ s ∧ (g ∘ f) x ∈ k}
   
   [PROPER_MAP_FROM_COMPACT]  Theorem
      
      ⊢ ∀f s k.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧ compact s ∧
            closed_in (subtopology euclidean t) k ⇒
            compact {x | x ∈ s ∧ f x ∈ k}
   
   [PROPER_MAP_FROM_COMPOSITION_LEFT]  Theorem
      
      ⊢ ∀f g s t u.
            f continuous_on s ∧ (IMAGE f s = t) ∧ g continuous_on t ∧
            IMAGE g t ⊆ u ∧
            (∀k. k ⊆ u ∧ compact k ⇒ compact {x | x ∈ s ∧ (g ∘ f) x ∈ k}) ⇒
            ∀k. k ⊆ u ∧ compact k ⇒ compact {x | x ∈ t ∧ g x ∈ k}
   
   [PROPER_MAP_FROM_COMPOSITION_RIGHT]  Theorem
      
      ⊢ ∀f g s t u.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧ g continuous_on t ∧
            IMAGE g t ⊆ u ∧
            (∀k. k ⊆ u ∧ compact k ⇒ compact {x | x ∈ s ∧ (g ∘ f) x ∈ k}) ⇒
            ∀k. k ⊆ t ∧ compact k ⇒ compact {x | x ∈ s ∧ f x ∈ k}
   
   [QUASICOMPACT_OPEN_CLOSED]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀u.
                  u ⊆ t ⇒
                  open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇒
                  open_in (subtopology euclidean t) u) ⇔
             ∀u.
                 u ⊆ t ⇒
                 closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇒
                 closed_in (subtopology euclidean t) u)
   
   [QUOTIENT_MAP_CLOSED_MAP_EQ]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ∧
            (∀u.
                 u ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  open_in (subtopology euclidean t) u)) ⇒
            ((∀k.
                  closed_in (subtopology euclidean s) k ⇒
                  closed_in (subtopology euclidean t) (IMAGE f k)) ⇔
             ∀k.
                 closed_in (subtopology euclidean s) k ⇒
                 closed_in (subtopology euclidean s)
                   {x | x ∈ s ∧ f x ∈ IMAGE f k})
   
   [QUOTIENT_MAP_COMPOSE]  Theorem
      
      ⊢ ∀f g s t u.
            IMAGE f s ⊆ t ∧
            (∀v.
                 v ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ v} ⇔
                  open_in (subtopology euclidean t) v)) ∧
            (∀v.
                 v ⊆ u ⇒
                 (open_in (subtopology euclidean t) {x | x ∈ t ∧ g x ∈ v} ⇔
                  open_in (subtopology euclidean u) v)) ⇒
            ∀v.
                v ⊆ u ⇒
                (open_in (subtopology euclidean s)
                   {x | x ∈ s ∧ (g ∘ f) x ∈ v} ⇔
                 open_in (subtopology euclidean u) v)
   
   [QUOTIENT_MAP_FROM_COMPOSITION]  Theorem
      
      ⊢ ∀f g s t u.
            f continuous_on s ∧ IMAGE f s ⊆ t ∧ g continuous_on t ∧
            IMAGE g t ⊆ u ∧
            (∀v.
                 v ⊆ u ⇒
                 (open_in (subtopology euclidean s)
                    {x | x ∈ s ∧ (g ∘ f) x ∈ v} ⇔
                  open_in (subtopology euclidean u) v)) ⇒
            ∀v.
                v ⊆ u ⇒
                (open_in (subtopology euclidean t) {x | x ∈ t ∧ g x ∈ v} ⇔
                 open_in (subtopology euclidean u) v)
   
   [QUOTIENT_MAP_FROM_SUBSET]  Theorem
      
      ⊢ ∀f s t u.
            f continuous_on t ∧ IMAGE f t ⊆ u ∧ s ⊆ t ∧ (IMAGE f s = u) ∧
            (∀v.
                 v ⊆ u ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ v} ⇔
                  open_in (subtopology euclidean u) v)) ⇒
            ∀v.
                v ⊆ u ⇒
                (open_in (subtopology euclidean t) {x | x ∈ t ∧ f x ∈ v} ⇔
                 open_in (subtopology euclidean u) v)
   
   [QUOTIENT_MAP_IMP_CONTINUOUS_CLOSED]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ∧
            (∀u.
                 u ⊆ t ⇒
                 (closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  closed_in (subtopology euclidean t) u)) ⇒
            f continuous_on s
   
   [QUOTIENT_MAP_IMP_CONTINUOUS_OPEN]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ∧
            (∀u.
                 u ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  open_in (subtopology euclidean t) u)) ⇒
            f continuous_on s
   
   [QUOTIENT_MAP_OPEN_CLOSED]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ⇒
            ((∀u.
                  u ⊆ t ⇒
                  (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                   open_in (subtopology euclidean t) u)) ⇔
             ∀u.
                 u ⊆ t ⇒
                 (closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  closed_in (subtopology euclidean t) u))
   
   [QUOTIENT_MAP_OPEN_MAP_EQ]  Theorem
      
      ⊢ ∀f s t.
            IMAGE f s ⊆ t ∧
            (∀u.
                 u ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  open_in (subtopology euclidean t) u)) ⇒
            ((∀k.
                  open_in (subtopology euclidean s) k ⇒
                  open_in (subtopology euclidean t) (IMAGE f k)) ⇔
             ∀k.
                 open_in (subtopology euclidean s) k ⇒
                 open_in (subtopology euclidean s)
                   {x | x ∈ s ∧ f x ∈ IMAGE f k})
   
   [QUOTIENT_MAP_RESTRICT]  Theorem
      
      ⊢ ∀f s t c.
            IMAGE f s ⊆ t ∧
            (∀u.
                 u ⊆ t ⇒
                 (open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ∈ u} ⇔
                  open_in (subtopology euclidean t) u)) ∧
            (open_in (subtopology euclidean t) c ∨
             closed_in (subtopology euclidean t) c) ⇒
            ∀u.
                u ⊆ c ⇒
                (open_in (subtopology euclidean {x | x ∈ s ∧ f x ∈ c})
                   {x | x ∈ {x | x ∈ s ∧ f x ∈ c} ∧ f x ∈ u} ⇔
                 open_in (subtopology euclidean c) u)
   
   [REAL_AFFINITY_EQ]  Theorem
      
      ⊢ ∀m c x y. m ≠ 0 ⇒ ((m * x + c = y) ⇔ (x = m⁻¹ * y + -(c / m)))
   
   [REAL_AFFINITY_LE]  Theorem
      
      ⊢ ∀m c x y. 0 < m ⇒ (m * x + c ≤ y ⇔ x ≤ m⁻¹ * y + -(c / m))
   
   [REAL_AFFINITY_LT]  Theorem
      
      ⊢ ∀m c x y. 0 < m ⇒ (m * x + c < y ⇔ x < m⁻¹ * y + -(c / m))
   
   [REAL_ARCH_INV]  Theorem
      
      ⊢ ∀e. 0 < e ⇔ ∃n. n ≠ 0 ∧ 0 < (&n)⁻¹ ∧ (&n)⁻¹ < e
   
   [REAL_ARCH_POW]  Theorem
      
      ⊢ ∀x y. 1 < x ⇒ ∃n. y < x pow n
   
   [REAL_ARCH_POW2]  Theorem
      
      ⊢ ∀x. ∃n. x < 2 pow n
   
   [REAL_ARCH_POW_INV]  Theorem
      
      ⊢ ∀x y. 0 < y ∧ x < 1 ⇒ ∃n. x pow n < y
   
   [REAL_ARCH_RDIV_EQ_0]  Theorem
      
      ⊢ ∀x c. 0 ≤ x ∧ 0 ≤ c ∧ (∀m. 0 < m ⇒ &m * x ≤ c) ⇒ (x = 0)
   
   [REAL_BOUNDS_LT]  Theorem
      
      ⊢ ∀x k. -k < x ∧ x < k ⇔ abs x < k
   
   [REAL_CHOOSE_DIST]  Theorem
      
      ⊢ ∀x e. 0 ≤ e ⇒ ∃y. dist (x,y) = e
   
   [REAL_CHOOSE_SIZE]  Theorem
      
      ⊢ ∀c. 0 ≤ c ⇒ ∃x. abs x = c
   
   [REAL_CONVEX_BOUND_LE]  Theorem
      
      ⊢ ∀x y a u v.
            x ≤ a ∧ y ≤ a ∧ 0 ≤ u ∧ 0 ≤ v ∧ (u + v = 1) ⇒ u * x + v * y ≤ a
   
   [REAL_EQ_AFFINITY]  Theorem
      
      ⊢ ∀m c x y. m ≠ 0 ⇒ ((y = m * x + c) ⇔ (m⁻¹ * y + -(c / m) = x))
   
   [REAL_EQ_LINV]  Theorem
      
      ⊢ ∀x. (-x = x) ⇔ (x = 0)
   
   [REAL_EQ_RINV]  Theorem
      
      ⊢ ∀x. (x = -x) ⇔ (x = 0)
   
   [REAL_EQ_SQUARE_ABS]  Theorem
      
      ⊢ ∀x y. (abs x = abs y) ⇔ (x pow 2 = y pow 2)
   
   [REAL_HALF]  Theorem
      
      ⊢ (∀e. 0 < e / 2 ⇔ 0 < e) ∧ (∀e. e / 2 + e / 2 = e) ∧
        ∀e. 2 * (e / 2) = e
   
   [REAL_HAUSDIST_LE]  Theorem
      
      ⊢ ∀s t b.
            s ≠ ∅ ∧ t ≠ ∅ ∧ (∀x. x ∈ s ⇒ setdist ({x},t) ≤ b) ∧
            (∀y. y ∈ t ⇒ setdist ({y},s) ≤ b) ⇒
            hausdist (s,t) ≤ b
   
   [REAL_HAUSDIST_LE_EQ]  Theorem
      
      ⊢ ∀s t b.
            s ≠ ∅ ∧ t ≠ ∅ ∧ bounded s ∧ bounded t ⇒
            (hausdist (s,t) ≤ b ⇔
             (∀x. x ∈ s ⇒ setdist ({x},t) ≤ b) ∧
             ∀y. y ∈ t ⇒ setdist ({y},s) ≤ b)
   
   [REAL_HAUSDIST_LE_SUMS]  Theorem
      
      ⊢ ∀s t b.
            s ≠ ∅ ∧ t ≠ ∅ ∧ s ⊆ {y + z | y ∈ t ∧ z ∈ cball (0,b)} ∧
            t ⊆ {y + z | y ∈ s ∧ z ∈ cball (0,b)} ⇒
            hausdist (s,t) ≤ b
   
   [REAL_INF_LE_FINITE]  Theorem
      
      ⊢ ∀s a. FINITE s ∧ s ≠ ∅ ⇒ (inf s ≤ a ⇔ ∃x. x ∈ s ∧ x ≤ a)
   
   [REAL_INF_LT_FINITE]  Theorem
      
      ⊢ ∀s a. FINITE s ∧ s ≠ ∅ ⇒ (inf s < a ⇔ ∃x. x ∈ s ∧ x < a)
   
   [REAL_INV_1_LE]  Theorem
      
      ⊢ ∀x. 0 < x ∧ x ≤ 1 ⇒ 1 ≤ x⁻¹
   
   [REAL_INV_LE_1]  Theorem
      
      ⊢ ∀x. 1 ≤ x ⇒ x⁻¹ ≤ 1
   
   [REAL_LE_AFFINITY]  Theorem
      
      ⊢ ∀m c x y. 0 < m ⇒ (y ≤ m * x + c ⇔ m⁻¹ * y + -(c / m) ≤ x)
   
   [REAL_LE_BETWEEN]  Theorem
      
      ⊢ ∀a b. a ≤ b ⇔ ∃x. a ≤ x ∧ x ≤ b
   
   [REAL_LE_HAUSDIST]  Theorem
      
      ⊢ ∀s t a b c z.
            s ≠ ∅ ∧ t ≠ ∅ ∧ (∀x. x ∈ s ⇒ setdist ({x},t) ≤ b) ∧
            (∀y. y ∈ t ⇒ setdist ({y},s) ≤ c) ∧
            (z ∈ s ∧ a ≤ setdist ({z},t) ∨ z ∈ t ∧ a ≤ setdist ({z},s)) ⇒
            a ≤ hausdist (s,t)
   
   [REAL_LE_INF_FINITE]  Theorem
      
      ⊢ ∀s a. FINITE s ∧ s ≠ ∅ ⇒ (a ≤ inf s ⇔ ∀x. x ∈ s ⇒ a ≤ x)
   
   [REAL_LE_INV2]  Theorem
      
      ⊢ ∀x y. 0 < x ∧ x ≤ y ⇒ y⁻¹ ≤ x⁻¹
   
   [REAL_LE_LMUL1]  Theorem
      
      ⊢ ∀x y z. 0 ≤ x ∧ y ≤ z ⇒ x * y ≤ x * z
   
   [REAL_LE_SETDIST]  Theorem
      
      ⊢ ∀s t d.
            s ≠ ∅ ∧ t ≠ ∅ ∧ (∀x y. x ∈ s ∧ y ∈ t ⇒ d ≤ dist (x,y)) ⇒
            d ≤ setdist (s,t)
   
   [REAL_LE_SETDIST_EQ]  Theorem
      
      ⊢ ∀d s t.
            d ≤ setdist (s,t) ⇔
            (∀x y. x ∈ s ∧ y ∈ t ⇒ d ≤ dist (x,y)) ∧
            ((s = ∅) ∨ (t = ∅) ⇒ d ≤ 0)
   
   [REAL_LE_SQUARE_ABS]  Theorem
      
      ⊢ ∀x y. abs x ≤ abs y ⇔ x pow 2 ≤ y pow 2
   
   [REAL_LT_AFFINITY]  Theorem
      
      ⊢ ∀m c x y. 0 < m ⇒ (y < m * x + c ⇔ m⁻¹ * y + -(c / m) < x)
   
   [REAL_LT_HAUSDIST_POINT_EXISTS]  Theorem
      
      ⊢ ∀s t x d.
            bounded s ∧ bounded t ∧ t ≠ ∅ ∧ hausdist (s,t) < d ∧ x ∈ s ⇒
            ∃y. y ∈ t ∧ dist (x,y) < d
   
   [REAL_LT_INF_FINITE]  Theorem
      
      ⊢ ∀s a. FINITE s ∧ s ≠ ∅ ⇒ (a < inf s ⇔ ∀x. x ∈ s ⇒ a < x)
   
   [REAL_LT_INV2]  Theorem
      
      ⊢ ∀x y. 0 < x ∧ x < y ⇒ y⁻¹ < x⁻¹
   
   [REAL_LT_LCANCEL_IMP]  Theorem
      
      ⊢ ∀x y z. 0 < x ∧ x * y < x * z ⇒ y < z
   
   [REAL_LT_MIN]  Theorem
      
      ⊢ ∀x y z. z < min x y ⇔ z < x ∧ z < y
   
   [REAL_LT_POW2]  Theorem
      
      ⊢ ∀n. 0 < 2 pow n
   
   [REAL_OF_NUM_GE]  Theorem
      
      ⊢ ∀m n. &m ≥ &n ⇔ m ≥ n
   
   [REAL_POW_1_LE]  Theorem
      
      ⊢ ∀n x. 0 ≤ x ∧ x ≤ 1 ⇒ x pow n ≤ 1
   
   [REAL_POW_LBOUND]  Theorem
      
      ⊢ ∀x n. 0 ≤ x ⇒ 1 + &n * x ≤ (1 + x) pow n
   
   [REAL_POW_LE_1]  Theorem
      
      ⊢ ∀n x. 1 ≤ x ⇒ 1 ≤ x pow n
   
   [REAL_SETDIST_LT_EXISTS]  Theorem
      
      ⊢ ∀s t b.
            s ≠ ∅ ∧ t ≠ ∅ ∧ setdist (s,t) < b ⇒
            ∃x y. x ∈ s ∧ y ∈ t ∧ dist (x,y) < b
   
   [REAL_WLOG_LE]  Theorem
      
      ⊢ (∀x y. P x y ⇔ P y x) ∧ (∀x y. x ≤ y ⇒ P x y) ⇒ ∀x y. P x y
   
   [REAL_WLOG_LT]  Theorem
      
      ⊢ (∀x. P x x) ∧ (∀x y. P x y ⇔ P y x) ∧ (∀x y. x < y ⇒ P x y) ⇒
        ∀x y. P x y
   
   [REFLECT_INTERVAL]  Theorem
      
      ⊢ (∀a b. IMAGE (λx. -x) (interval [(a,b)]) = interval [(-b,-a)]) ∧
        ∀a b. IMAGE (λx. -x) (interval (a,b)) = interval (-b,-a)
   
   [REGULAR_CLOSED_BIGUNION]  Theorem
      
      ⊢ ∀f.
            FINITE f ∧ (∀t. t ∈ f ⇒ (closure (interior t) = t)) ⇒
            (closure (interior (BIGUNION f)) = BIGUNION f)
   
   [REGULAR_CLOSED_UNION]  Theorem
      
      ⊢ ∀s t.
            (closure (interior s) = s) ∧ (closure (interior t) = t) ⇒
            (closure (interior (s ∪ t)) = s ∪ t)
   
   [REGULAR_OPEN_INTER]  Theorem
      
      ⊢ ∀s t.
            (interior (closure s) = s) ∧ (interior (closure t) = t) ⇒
            (interior (closure (s ∩ t)) = s ∩ t)
   
   [SEGMENT]  Theorem
      
      ⊢ (∀a b.
             segment [(a,b)] =
             if a ≤ b then interval [(a,b)] else interval [(b,a)]) ∧
        ∀a b.
            segment (a,b) =
            if a ≤ b then interval (a,b) else interval (b,a)
   
   [SEGMENT_CLOSED_OPEN]  Theorem
      
      ⊢ ∀a b. segment [(a,b)] = segment (a,b) ∪ {a; b}
   
   [SEGMENT_OPEN_SUBSET_CLOSED]  Theorem
      
      ⊢ ∀a b. segment (a,b) ⊆ segment [(a,b)]
   
   [SEGMENT_REFL]  Theorem
      
      ⊢ (∀a. segment [(a,a)] = {a}) ∧ ∀a. segment (a,a) = ∅
   
   [SEGMENT_SCALAR_MULTIPLE]  Theorem
      
      ⊢ (∀a b v.
             segment [(a * v,b * v)] =
             {x * v | a ≤ x ∧ x ≤ b ∨ b ≤ x ∧ x ≤ a}) ∧
        ∀a b v.
            v ≠ 0 ⇒
            (segment (a * v,b * v) =
             {x * v | a < x ∧ x < b ∨ b < x ∧ x < a})
   
   [SEGMENT_SYM]  Theorem
      
      ⊢ (∀a b. segment [(a,b)] = segment [(b,a)]) ∧
        ∀a b. segment (a,b) = segment (b,a)
   
   [SEGMENT_TO_CLOSEST_POINT]  Theorem
      
      ⊢ ∀s a. closed s ∧ s ≠ ∅ ⇒ (segment (a,closest_point s a) ∩ s = ∅)
   
   [SEGMENT_TO_POINT_EXISTS]  Theorem
      
      ⊢ ∀s a. closed s ∧ s ≠ ∅ ⇒ ∃b. b ∈ s ∧ (segment (a,b) ∩ s = ∅)
   
   [SEGMENT_TRANSLATION]  Theorem
      
      ⊢ (∀c a b.
             segment [(c + a,c + b)] = IMAGE (λx. c + x) (segment [(a,b)])) ∧
        ∀c a b. segment (c + a,c + b) = IMAGE (λx. c + x) (segment (a,b))
   
   [SEPARATE_CLOSED_COMPACT]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ compact t ∧ (s ∩ t = ∅) ⇒
            ∃d. 0 < d ∧ ∀x y. x ∈ s ∧ y ∈ t ⇒ d ≤ dist (x,y)
   
   [SEPARATE_COMPACT_CLOSED]  Theorem
      
      ⊢ ∀s t.
            compact s ∧ closed t ∧ (s ∩ t = ∅) ⇒
            ∃d. 0 < d ∧ ∀x y. x ∈ s ∧ y ∈ t ⇒ d ≤ dist (x,y)
   
   [SEPARATE_POINT_CLOSED]  Theorem
      
      ⊢ ∀s a. closed s ∧ a ∉ s ⇒ ∃d. 0 < d ∧ ∀x. x ∈ s ⇒ d ≤ dist (a,x)
   
   [SEPARATION_CLOSURES]  Theorem
      
      ⊢ ∀s t.
            (s ∩ closure t = ∅) ∧ (t ∩ closure s = ∅) ⇒
            ∃u v. DISJOINT u v ∧ open u ∧ open v ∧ s ⊆ u ∧ t ⊆ v
   
   [SEPARATION_HAUSDORFF]  Theorem
      
      ⊢ ∀x y. x ≠ y ⇒ ∃u v. open u ∧ open v ∧ x ∈ u ∧ y ∈ v ∧ (u ∩ v = ∅)
   
   [SEPARATION_NORMAL]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ closed t ∧ (s ∩ t = ∅) ⇒
            ∃u v. open u ∧ open v ∧ s ⊆ u ∧ t ⊆ v ∧ (u ∩ v = ∅)
   
   [SEPARATION_NORMAL_COMPACT]  Theorem
      
      ⊢ ∀s t.
            compact s ∧ closed t ∧ (s ∩ t = ∅) ⇒
            ∃u v.
                open u ∧ compact (closure u) ∧ open v ∧ s ⊆ u ∧ t ⊆ v ∧
                (u ∩ v = ∅)
   
   [SEPARATION_NORMAL_LOCAL]  Theorem
      
      ⊢ ∀s t u.
            closed_in (subtopology euclidean u) s ∧
            closed_in (subtopology euclidean u) t ∧ (s ∩ t = ∅) ⇒
            ∃s' t'.
                open_in (subtopology euclidean u) s' ∧
                open_in (subtopology euclidean u) t' ∧ s ⊆ s' ∧ t ⊆ t' ∧
                (s' ∩ t' = ∅)
   
   [SEPARATION_T0]  Theorem
      
      ⊢ ∀x y. x ≠ y ⇔ ∃u. open u ∧ (x ∈ u ⇎ y ∈ u)
   
   [SEPARATION_T1]  Theorem
      
      ⊢ ∀x y. x ≠ y ⇔ ∃u v. open u ∧ open v ∧ x ∈ u ∧ y ∉ u ∧ x ∉ v ∧ y ∈ v
   
   [SEPARATION_T2]  Theorem
      
      ⊢ ∀x y. x ≠ y ⇔ ∃u v. open u ∧ open v ∧ x ∈ u ∧ y ∈ v ∧ (u ∩ v = ∅)
   
   [SEQUENCE_CAUCHY_WLOG]  Theorem
      
      ⊢ ∀P s.
            (∀m n. P m ∧ P n ⇒ dist (s m,s n) < e) ⇔
            ∀m n. P m ∧ P n ∧ m ≤ n ⇒ dist (s m,s n) < e
   
   [SEQUENCE_INFINITE_LEMMA]  Theorem
      
      ⊢ ∀f l.
            (∀n. f n ≠ l) ∧ (f --> l) sequentially ⇒
            INFINITE {y | (∃n. y = f n)}
   
   [SEQUENCE_UNIQUE_LIMPT]  Theorem
      
      ⊢ ∀f l l'.
            (f --> l) sequentially ∧ l' limit_point_of {y | ∃n. y = f n} ⇒
            (l' = l)
   
   [SEQUENTIALLY]  Theorem
      
      ⊢ ∀m n. netord sequentially m n ⇔ m ≥ n
   
   [SEQ_HARMONIC]  Theorem
      
      ⊢ ((λn. (&n)⁻¹) --> 0) sequentially
   
   [SEQ_HARMONIC_OFFSET]  Theorem
      
      ⊢ ∀a. ((λn. (&n + a)⁻¹) --> 0) sequentially
   
   [SEQ_OFFSET]  Theorem
      
      ⊢ ∀f l k.
            (f --> l) sequentially ⇒ ((λi. f (i + k)) --> l) sequentially
   
   [SEQ_OFFSET_NEG]  Theorem
      
      ⊢ ∀f l k.
            (f --> l) sequentially ⇒ ((λi. f (i − k)) --> l) sequentially
   
   [SEQ_OFFSET_REV]  Theorem
      
      ⊢ ∀f l k.
            ((λi. f (i + k)) --> l) sequentially ⇒ (f --> l) sequentially
   
   [SERIES_0]  Theorem
      
      ⊢ ∀s. ((λn. 0) sums 0) s
   
   [SERIES_ABSCONV_IMP_CONV]  Theorem
      
      ⊢ ∀x k. summable k (λn. abs (x n)) ⇒ summable k x
   
   [SERIES_ADD]  Theorem
      
      ⊢ ∀x x0 y y0 s.
            (x sums x0) s ∧ (y sums y0) s ⇒
            ((λn. x n + y n) sums x0 + y0) s
   
   [SERIES_BOUND]  Theorem
      
      ⊢ ∀f g s a b.
            (f sums a) s ∧ (g sums b) s ∧ (∀i. i ∈ s ⇒ abs (f i) ≤ g i) ⇒
            abs a ≤ b
   
   [SERIES_CAUCHY]  Theorem
      
      ⊢ ∀f s.
            (∃l. (f sums l) s) ⇔
            ∀e. 0 < e ⇒ ∃N. ∀m n. m ≥ N ⇒ abs (sum (s ∩ (m .. n)) f) < e
   
   [SERIES_CAUCHY_UNIFORM]  Theorem
      
      ⊢ ∀P f k.
            (∃l.
                 ∀e.
                     0 < e ⇒
                     ∃N.
                         ∀n x.
                             N ≤ n ∧ P x ⇒
                             dist (sum (k ∩ (0 .. n)) (f x),l x) < e) ⇔
            ∀e.
                0 < e ⇒
                ∃N.
                    ∀m n x.
                        N ≤ m ∧ P x ⇒ abs (sum (k ∩ (m .. n)) (f x)) < e
   
   [SERIES_CMUL]  Theorem
      
      ⊢ ∀x x0 c s. (x sums x0) s ⇒ ((λn. c * x n) sums c * x0) s
   
   [SERIES_COMPARISON]  Theorem
      
      ⊢ ∀f g s.
            (∃l. (g sums l) s) ∧ (∃N. ∀n. n ≥ N ∧ n ∈ s ⇒ abs (f n) ≤ g n) ⇒
            ∃l. (f sums l) s
   
   [SERIES_COMPARISON_BOUND]  Theorem
      
      ⊢ ∀f g s a.
            (g sums a) s ∧ (∀i. i ∈ s ⇒ abs (f i) ≤ g i) ⇒
            ∃l. (f sums l) s ∧ abs l ≤ a
   
   [SERIES_COMPARISON_UNIFORM]  Theorem
      
      ⊢ ∀f g P s.
            (∃l. (g sums l) s) ∧
            (∃N. ∀n x. N ≤ n ∧ n ∈ s ∧ P x ⇒ abs (f x n) ≤ g n) ⇒
            ∃l.
                ∀e.
                    0 < e ⇒
                    ∃N.
                        ∀n x.
                            N ≤ n ∧ P x ⇒
                            dist (sum (s ∩ (0 .. n)) (f x),l x) < e
   
   [SERIES_COMPONENT]  Theorem
      
      ⊢ ∀f s l. (f sums l) s ⇒ ((λi. f i) sums l) s
   
   [SERIES_DIFFS]  Theorem
      
      ⊢ ∀f k.
            (f --> 0) sequentially ⇒
            ((λn. f n − f (n + 1)) sums f k) (from k)
   
   [SERIES_DIRICHLET]  Theorem
      
      ⊢ ∀f g N k m.
            bounded {sum (m .. n) f | n ∈ 𝕌(:num)} ∧
            (∀n. N ≤ n ⇒ g (n + 1) ≤ g n) ∧ (g --> 0) sequentially ⇒
            summable (from k) (λn. g n * f n)
   
   [SERIES_DIRICHLET_BILINEAR]  Theorem
      
      ⊢ ∀f g h k m p l.
            bilinear h ∧ bounded {sum (m .. n) f | n ∈ 𝕌(:num)} ∧
            summable (from p) (λn. abs (g (n + 1) − g n)) ∧
            ((λn. h (g (n + 1)) (sum (1 .. n) f)) --> l) sequentially ⇒
            summable (from k) (λn. h (g n) (f n))
   
   [SERIES_DROP_LE]  Theorem
      
      ⊢ ∀f g s a b.
            (f sums a) s ∧ (g sums b) s ∧ (∀x. x ∈ s ⇒ f x ≤ g x) ⇒ a ≤ b
   
   [SERIES_DROP_POS]  Theorem
      
      ⊢ ∀f s a. (f sums a) s ∧ (∀x. x ∈ s ⇒ 0 ≤ f x) ⇒ 0 ≤ a
   
   [SERIES_FINITE]  Theorem
      
      ⊢ ∀f s. FINITE s ⇒ (f sums sum s f) s
   
   [SERIES_FINITE_SUPPORT]  Theorem
      
      ⊢ ∀f s k.
            FINITE (s ∩ k) ∧ (∀x. x ∈ k ∧ x ∉ s ⇒ (f x = 0)) ⇒
            (f sums sum (s ∩ k) f) k
   
   [SERIES_FROM]  Theorem
      
      ⊢ ∀f l k.
            (f sums l) (from k) ⇔ ((λn. sum (k .. n) f) --> l) sequentially
   
   [SERIES_GOESTOZERO]  Theorem
      
      ⊢ ∀s x.
            summable s x ⇒
            ∀e. 0 < e ⇒ eventually (λn. n ∈ s ⇒ abs (x n) < e) sequentially
   
   [SERIES_INJECTIVE_IMAGE]  Theorem
      
      ⊢ ∀x s f l.
            summable (IMAGE f s) (λn. abs (x n)) ∧
            (∀m n. m ∈ s ∧ n ∈ s ∧ (f m = f n) ⇒ (m = n)) ⇒
            ((x ∘ f sums l) s ⇔ (x sums l) (IMAGE f s))
   
   [SERIES_INJECTIVE_IMAGE_STRONG]  Theorem
      
      ⊢ ∀x s f.
            summable (IMAGE f s) (λn. abs (x n)) ∧
            (∀m n. m ∈ s ∧ n ∈ s ∧ (f m = f n) ⇒ (m = n)) ⇒
            ((λn. sum (IMAGE f s ∩ (0 .. n)) x − sum (s ∩ (0 .. n)) (x ∘ f)) -->
             0) sequentially
   
   [SERIES_LINEAR]  Theorem
      
      ⊢ ∀f h l s. (f sums l) s ∧ linear h ⇒ ((λn. h (f n)) sums h l) s
   
   [SERIES_NEG]  Theorem
      
      ⊢ ∀x x0 s. (x sums x0) s ⇒ ((λn. -x n) sums -x0) s
   
   [SERIES_RATIO]  Theorem
      
      ⊢ ∀c a s N.
            c < 1 ∧ (∀n. n ≥ N ⇒ abs (a (SUC n)) ≤ c * abs (a n)) ⇒
            ∃l. (a sums l) s
   
   [SERIES_REARRANGE]  Theorem
      
      ⊢ ∀x s p l.
            summable s (λn. abs (x n)) ∧ p permutes s ∧ (x sums l) s ⇒
            (x ∘ p sums l) s
   
   [SERIES_REARRANGE_EQ]  Theorem
      
      ⊢ ∀x s p l.
            summable s (λn. abs (x n)) ∧ p permutes s ⇒
            ((x ∘ p sums l) s ⇔ (x sums l) s)
   
   [SERIES_RESTRICT]  Theorem
      
      ⊢ ∀f k l.
            ((λn. if n ∈ k then f n else 0) sums l) 𝕌(:num) ⇔ (f sums l) k
   
   [SERIES_SUB]  Theorem
      
      ⊢ ∀x x0 y y0 s.
            (x sums x0) s ∧ (y sums y0) s ⇒
            ((λn. x n − y n) sums x0 − y0) s
   
   [SERIES_SUBSET]  Theorem
      
      ⊢ ∀x s t l.
            s ⊆ t ∧ ((λi. if i ∈ s then x i else 0) sums l) t ⇒
            (x sums l) s
   
   [SERIES_SUM]  Theorem
      
      ⊢ ∀f l k s.
            FINITE s ∧ s ⊆ k ∧ (∀x. x ∉ s ⇒ (f x = 0)) ∧ (sum s f = l) ⇒
            (f sums l) k
   
   [SERIES_TERMS_TOZERO]  Theorem
      
      ⊢ ∀f l n. (f sums l) (from n) ⇒ (f --> 0) sequentially
   
   [SERIES_TRIVIAL]  Theorem
      
      ⊢ ∀f. (f sums 0) ∅
   
   [SERIES_UNIQUE]  Theorem
      
      ⊢ ∀f l l' s. (f sums l) s ∧ (f sums l') s ⇒ (l = l')
   
   [SETDIST_BALLS]  Theorem
      
      ⊢ (∀a b r s.
             setdist (ball (a,r),ball (b,s)) =
             if r ≤ 0 ∨ s ≤ 0 then 0 else max 0 (dist (a,b) − (r + s))) ∧
        (∀a b r s.
             setdist (ball (a,r),cball (b,s)) =
             if r ≤ 0 ∨ s < 0 then 0 else max 0 (dist (a,b) − (r + s))) ∧
        (∀a b r s.
             setdist (cball (a,r),ball (b,s)) =
             if r < 0 ∨ s ≤ 0 then 0 else max 0 (dist (a,b) − (r + s))) ∧
        ∀a b r s.
            setdist (cball (a,r),cball (b,s)) =
            if r < 0 ∨ s < 0 then 0 else max 0 (dist (a,b) − (r + s))
   
   [SETDIST_CLOSED_COMPACT]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ compact t ∧ s ≠ ∅ ∧ t ≠ ∅ ⇒
            ∃x y. x ∈ s ∧ y ∈ t ∧ (dist (x,y) = setdist (s,t))
   
   [SETDIST_CLOSEST_POINT]  Theorem
      
      ⊢ ∀a s.
            closed s ∧ s ≠ ∅ ⇒
            (setdist ({a},s) = dist (a,closest_point s a))
   
   [SETDIST_CLOSURE]  Theorem
      
      ⊢ (∀s t. setdist (closure s,t) = setdist (s,t)) ∧
        ∀s t. setdist (s,closure t) = setdist (s,t)
   
   [SETDIST_COMPACT_CLOSED]  Theorem
      
      ⊢ ∀s t.
            compact s ∧ closed t ∧ s ≠ ∅ ∧ t ≠ ∅ ⇒
            ∃x y. x ∈ s ∧ y ∈ t ∧ (dist (x,y) = setdist (s,t))
   
   [SETDIST_DIFFERENCES]  Theorem
      
      ⊢ ∀s t. setdist (s,t) = setdist ({0},{x − y | x ∈ s ∧ y ∈ t})
   
   [SETDIST_EMPTY]  Theorem
      
      ⊢ (∀t. setdist (∅,t) = 0) ∧ ∀s. setdist (s,∅) = 0
   
   [SETDIST_EQ_0_BOUNDED]  Theorem
      
      ⊢ ∀s t.
            bounded s ∨ bounded t ⇒
            ((setdist (s,t) = 0) ⇔
             (s = ∅) ∨ (t = ∅) ∨ closure s ∩ closure t ≠ ∅)
   
   [SETDIST_EQ_0_CLOSED]  Theorem
      
      ⊢ ∀s x. closed s ⇒ ((setdist ({x},s) = 0) ⇔ (s = ∅) ∨ x ∈ s)
   
   [SETDIST_EQ_0_CLOSED_COMPACT]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ compact t ⇒
            ((setdist (s,t) = 0) ⇔ (s = ∅) ∨ (t = ∅) ∨ s ∩ t ≠ ∅)
   
   [SETDIST_EQ_0_CLOSED_IN]  Theorem
      
      ⊢ ∀u s x.
            closed_in (subtopology euclidean u) s ∧ x ∈ u ⇒
            ((setdist ({x},s) = 0) ⇔ (s = ∅) ∨ x ∈ s)
   
   [SETDIST_EQ_0_COMPACT_CLOSED]  Theorem
      
      ⊢ ∀s t.
            compact s ∧ closed t ⇒
            ((setdist (s,t) = 0) ⇔ (s = ∅) ∨ (t = ∅) ∨ s ∩ t ≠ ∅)
   
   [SETDIST_EQ_0_SING]  Theorem
      
      ⊢ (∀s x. (setdist ({x},s) = 0) ⇔ (s = ∅) ∨ x ∈ closure s) ∧
        ∀s x. (setdist (s,{x}) = 0) ⇔ (s = ∅) ∨ x ∈ closure s
   
   [SETDIST_FRONTIER]  Theorem
      
      ⊢ (∀s t. DISJOINT s t ⇒ (setdist (frontier s,t) = setdist (s,t))) ∧
        ∀s t. DISJOINT s t ⇒ (setdist (s,frontier t) = setdist (s,t))
   
   [SETDIST_FRONTIERS]  Theorem
      
      ⊢ ∀s t.
            setdist (s,t) =
            if DISJOINT s t then setdist (frontier s,frontier t) else 0
   
   [SETDIST_HAUSDIST_TRIANGLE]  Theorem
      
      ⊢ ∀s t u.
            t ≠ ∅ ∧ bounded t ∧ bounded u ⇒
            setdist (s,u) ≤ setdist (s,t) + hausdist (t,u)
   
   [SETDIST_LE_DIST]  Theorem
      
      ⊢ ∀s t x y. x ∈ s ∧ y ∈ t ⇒ setdist (s,t) ≤ dist (x,y)
   
   [SETDIST_LE_HAUSDIST]  Theorem
      
      ⊢ ∀s t. bounded s ∧ bounded t ⇒ setdist (s,t) ≤ hausdist (s,t)
   
   [SETDIST_LE_SING]  Theorem
      
      ⊢ ∀s t x. x ∈ s ⇒ setdist (s,t) ≤ setdist ({x},t)
   
   [SETDIST_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s t.
            linear f ∧ (∀x. abs (f x) = abs x) ⇒
            (setdist (IMAGE f s,IMAGE f t) = setdist (s,t))
   
   [SETDIST_LIPSCHITZ]  Theorem
      
      ⊢ ∀s t x y. abs (setdist ({x},s) − setdist ({y},s)) ≤ dist (x,y)
   
   [SETDIST_POS_LE]  Theorem
      
      ⊢ ∀s t. 0 ≤ setdist (s,t)
   
   [SETDIST_REFL]  Theorem
      
      ⊢ ∀s. setdist (s,s) = 0
   
   [SETDIST_SINGS]  Theorem
      
      ⊢ ∀x y. setdist ({x},{y}) = dist (x,y)
   
   [SETDIST_SING_FRONTIER]  Theorem
      
      ⊢ ∀s x. x ∉ s ⇒ (setdist ({x},frontier s) = setdist ({x},s))
   
   [SETDIST_SING_FRONTIER_CASES]  Theorem
      
      ⊢ ∀s x.
            setdist ({x},s) = if x ∈ s then 0 else setdist ({x},frontier s)
   
   [SETDIST_SING_IN_SET]  Theorem
      
      ⊢ ∀x s. x ∈ s ⇒ (setdist ({x},s) = 0)
   
   [SETDIST_SING_LE_HAUSDIST]  Theorem
      
      ⊢ ∀s t x.
            bounded s ∧ bounded t ∧ x ∈ s ⇒
            setdist ({x},t) ≤ hausdist (s,t)
   
   [SETDIST_SING_TRIANGLE]  Theorem
      
      ⊢ ∀s x y. abs (setdist ({x},s) − setdist ({y},s)) ≤ dist (x,y)
   
   [SETDIST_SUBSETS_EQ]  Theorem
      
      ⊢ ∀s t s' t'.
            s' ⊆ s ∧ t' ⊆ t ∧
            (∀x y.
                 x ∈ s ∧ y ∈ t ⇒
                 ∃x' y'. x' ∈ s' ∧ y' ∈ t' ∧ dist (x',y') ≤ dist (x,y)) ⇒
            (setdist (s',t') = setdist (s,t))
   
   [SETDIST_SUBSET_LEFT]  Theorem
      
      ⊢ ∀s t u. s ≠ ∅ ∧ s ⊆ t ⇒ setdist (t,u) ≤ setdist (s,u)
   
   [SETDIST_SUBSET_RIGHT]  Theorem
      
      ⊢ ∀s t u. t ≠ ∅ ∧ t ⊆ u ⇒ setdist (s,u) ≤ setdist (s,t)
   
   [SETDIST_SYM]  Theorem
      
      ⊢ ∀s t. setdist (s,t) = setdist (t,s)
   
   [SETDIST_TRANSLATION]  Theorem
      
      ⊢ ∀a s t.
            setdist (IMAGE (λx. a + x) s,IMAGE (λx. a + x) t) =
            setdist (s,t)
   
   [SETDIST_TRIANGLE]  Theorem
      
      ⊢ ∀s a t. setdist (s,t) ≤ setdist (s,{a}) + setdist ({a},t)
   
   [SETDIST_UNIQUE]  Theorem
      
      ⊢ ∀s t a b d.
            a ∈ s ∧ b ∈ t ∧ (dist (a,b) = d) ∧
            (∀x y. x ∈ s ∧ y ∈ t ⇒ dist (a,b) ≤ dist (x,y)) ⇒
            (setdist (s,t) = d)
   
   [SETDIST_UNIV]  Theorem
      
      ⊢ (∀s. setdist (s,𝕌(:real)) = 0) ∧ ∀t. setdist (𝕌(:real),t) = 0
   
   [SETDIST_ZERO]  Theorem
      
      ⊢ ∀s t. ¬DISJOINT s t ⇒ (setdist (s,t) = 0)
   
   [SETDIST_ZERO_STRONG]  Theorem
      
      ⊢ ∀s t. ¬DISJOINT (closure s) (closure t) ⇒ (setdist (s,t) = 0)
   
   [SET_DIFF_FRONTIER]  Theorem
      
      ⊢ ∀s. s DIFF frontier s = interior s
   
   [SIMPLE_IMAGE_GEN]  Theorem
      
      ⊢ ∀f P. {f x | P x} = IMAGE f {x | P x}
   
   [SPANNING_SUBSET_INDEPENDENT]  Theorem
      
      ⊢ ∀s t. t ⊆ s ∧ independent s ∧ s ⊆ span t ⇒ (s = t)
   
   [SPAN_0]  Theorem
      
      ⊢ 0 ∈ span s
   
   [SPAN_ADD]  Theorem
      
      ⊢ ∀x y s. x ∈ span s ∧ y ∈ span s ⇒ x + y ∈ span s
   
   [SPAN_ADD_EQ]  Theorem
      
      ⊢ ∀s x y. x ∈ span s ⇒ (x + y ∈ span s ⇔ y ∈ span s)
   
   [SPAN_BREAKDOWN]  Theorem
      
      ⊢ ∀b s a. b ∈ s ∧ a ∈ span s ⇒ ∃k. a − k * b ∈ span (s DELETE b)
   
   [SPAN_BREAKDOWN_EQ]  Theorem
      
      ⊢ ∀a s. x ∈ span (a INSERT s) ⇔ ∃k. x − k * a ∈ span s
   
   [SPAN_CARD_GE_DIM]  Theorem
      
      ⊢ ∀v b. v ⊆ span b ∧ FINITE b ⇒ dim v ≤ CARD b
   
   [SPAN_CLAUSES]  Theorem
      
      ⊢ (∀a s. a ∈ s ⇒ a ∈ span s) ∧ 0 ∈ span s ∧
        (∀x y s. x ∈ span s ∧ y ∈ span s ⇒ x + y ∈ span s) ∧
        ∀x c s. x ∈ span s ⇒ c * x ∈ span s
   
   [SPAN_EMPTY]  Theorem
      
      ⊢ span ∅ = {0}
   
   [SPAN_EQ_SELF]  Theorem
      
      ⊢ ∀s. (span s = s) ⇔ subspace s
   
   [SPAN_EXPLICIT]  Theorem
      
      ⊢ ∀p.
            span p =
            {y | ∃s u. FINITE s ∧ s ⊆ p ∧ (sum s (λv. u v * v) = y)}
   
   [SPAN_INC]  Theorem
      
      ⊢ ∀s. s ⊆ span s
   
   [SPAN_INDUCT]  Theorem
      
      ⊢ ∀s h. (∀x. x ∈ s ⇒ x ∈ h) ∧ subspace h ⇒ ∀x. x ∈ span s ⇒ h x
   
   [SPAN_INDUCT_ALT]  Theorem
      
      ⊢ ∀s h.
            h 0 ∧ (∀c x y. x ∈ s ∧ h y ⇒ h (c * x + y)) ⇒
            ∀x. x ∈ span s ⇒ h x
   
   [SPAN_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s. linear f ⇒ (span (IMAGE f s) = IMAGE f (span s))
   
   [SPAN_MONO]  Theorem
      
      ⊢ ∀s t. s ⊆ t ⇒ span s ⊆ span t
   
   [SPAN_MUL]  Theorem
      
      ⊢ ∀x c s. x ∈ span s ⇒ c * x ∈ span s
   
   [SPAN_MUL_EQ]  Theorem
      
      ⊢ ∀x c s. c ≠ 0 ⇒ (c * x ∈ span s ⇔ x ∈ span s)
   
   [SPAN_NEG]  Theorem
      
      ⊢ ∀x s. x ∈ span s ⇒ -x ∈ span s
   
   [SPAN_NEG_EQ]  Theorem
      
      ⊢ ∀x s. -x ∈ span s ⇔ x ∈ span s
   
   [SPAN_SPAN]  Theorem
      
      ⊢ ∀s. span (span s) = span s
   
   [SPAN_STDBASIS]  Theorem
      
      ⊢ span {i | 1 ≤ i ∧ i ≤ 1} = 𝕌(:real)
   
   [SPAN_SUB]  Theorem
      
      ⊢ ∀x y s. x ∈ span s ∧ y ∈ span s ⇒ x − y ∈ span s
   
   [SPAN_SUBSET_SUBSPACE]  Theorem
      
      ⊢ ∀s t. s ⊆ t ∧ subspace t ⇒ span s ⊆ t
   
   [SPAN_SUBSPACE]  Theorem
      
      ⊢ ∀b s. b ⊆ s ∧ s ⊆ span b ∧ subspace s ⇒ (span b = s)
   
   [SPAN_SUM]  Theorem
      
      ⊢ ∀s f t. FINITE t ∧ (∀x. x ∈ t ⇒ f x ∈ span s) ⇒ sum t f ∈ span s
   
   [SPAN_SUPERSET]  Theorem
      
      ⊢ ∀x. x ∈ s ⇒ x ∈ span s
   
   [SPAN_TRANS]  Theorem
      
      ⊢ ∀x y s. x ∈ span s ∧ y ∈ span (x INSERT s) ⇒ y ∈ span s
   
   [SPAN_UNION]  Theorem
      
      ⊢ ∀s t. span (s ∪ t) = {x + y | x ∈ span s ∧ y ∈ span t}
   
   [SPAN_UNION_SUBSET]  Theorem
      
      ⊢ ∀s t. span s ∪ span t ⊆ span (s ∪ t)
   
   [SPAN_UNIV]  Theorem
      
      ⊢ span 𝕌(:real) = 𝕌(:real)
   
   [SPHERE]  Theorem
      
      ⊢ ∀a r. sphere (a,r) = if r < 0 then ∅ else {a − r; a + r}
   
   [SPHERE_EMPTY]  Theorem
      
      ⊢ ∀a r. r < 0 ⇒ (sphere (a,r) = ∅)
   
   [SPHERE_EQ_EMPTY]  Theorem
      
      ⊢ ∀a r. (sphere (a,r) = ∅) ⇔ r < 0
   
   [SPHERE_EQ_SING]  Theorem
      
      ⊢ ∀a r x. (sphere (a,r) = {x}) ⇔ (x = a) ∧ (r = 0)
   
   [SPHERE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f x r.
            linear f ∧ (∀y. ∃x. f x = y) ∧ (∀x. abs (f x) = abs x) ⇒
            (sphere (f x,r) = IMAGE f (sphere (x,r)))
   
   [SPHERE_SING]  Theorem
      
      ⊢ ∀x e. (e = 0) ⇒ (sphere (x,e) = {x})
   
   [SPHERE_SUBSET_CBALL]  Theorem
      
      ⊢ ∀x e. sphere (x,e) ⊆ cball (x,e)
   
   [SPHERE_TRANSLATION]  Theorem
      
      ⊢ ∀a x r. sphere (a + x,r) = IMAGE (λy. a + y) (sphere (x,r))
   
   [SPHERE_UNION_BALL]  Theorem
      
      ⊢ ∀a r. sphere (a,r) ∪ ball (a,r) = cball (a,r)
   
   [SUBORDINATE_PARTITION_OF_UNITY]  Theorem
      
      ⊢ ∀c s.
            s ⊆ BIGUNION c ∧ (∀u. u ∈ c ⇒ open u) ∧
            (∀x.
                 x ∈ s ⇒
                 ∃v. open v ∧ x ∈ v ∧ FINITE {u | u ∈ c ∧ u ∩ v ≠ ∅}) ⇒
            ∃f.
                (∀u. u ∈ c ⇒ f u continuous_on s ∧ ∀x. x ∈ s ⇒ 0 ≤ f u x) ∧
                (∀x u. u ∈ c ∧ x ∈ s ∧ x ∉ u ⇒ (f u x = 0)) ∧
                (∀x. x ∈ s ⇒ (sum c (λu. f u x) = 1)) ∧
                ∀x.
                    x ∈ s ⇒
                    ∃n.
                        open n ∧ x ∈ n ∧
                        FINITE {u | u ∈ c ∧ ¬∀x. x ∈ n ⇒ (f u x = 0)}
   
   [SUBSET_ANTISYM_EQ]  Theorem
      
      ⊢ ∀s t. s ⊆ t ∧ t ⊆ s ⇔ (s = t)
   
   [SUBSET_BALL]  Theorem
      
      ⊢ ∀x d e. d ≤ e ⇒ ball (x,d) ⊆ ball (x,e)
   
   [SUBSET_BALLS]  Theorem
      
      ⊢ (∀a a' r r'.
             ball (a,r) ⊆ ball (a',r') ⇔ dist (a,a') + r ≤ r' ∨ r ≤ 0) ∧
        (∀a a' r r'.
             ball (a,r) ⊆ cball (a',r') ⇔ dist (a,a') + r ≤ r' ∨ r ≤ 0) ∧
        (∀a a' r r'.
             cball (a,r) ⊆ ball (a',r') ⇔ dist (a,a') + r < r' ∨ r < 0) ∧
        ∀a a' r r'.
            cball (a,r) ⊆ cball (a',r') ⇔ dist (a,a') + r ≤ r' ∨ r < 0
   
   [SUBSET_BIGUNION]  Theorem
      
      ⊢ ∀f g. f ⊆ g ⇒ BIGUNION f ⊆ BIGUNION g
   
   [SUBSET_CBALL]  Theorem
      
      ⊢ ∀x d e. d ≤ e ⇒ cball (x,d) ⊆ cball (x,e)
   
   [SUBSET_CLOSURE]  Theorem
      
      ⊢ ∀s t. s ⊆ t ⇒ closure s ⊆ closure t
   
   [SUBSET_IMAGE]  Theorem
      
      ⊢ ∀f s t. s ⊆ IMAGE f t ⇔ ∃u. u ⊆ t ∧ (s = IMAGE f u)
   
   [SUBSET_INTERIOR]  Theorem
      
      ⊢ ∀s t. s ⊆ t ⇒ interior s ⊆ interior t
   
   [SUBSET_INTERIOR_EQ]  Theorem
      
      ⊢ ∀s. s ⊆ interior s ⇔ open s
   
   [SUBSET_INTERVAL]  Theorem
      
      ⊢ (interval [(c,d)] ⊆ interval [(a,b)] ⇔ c ≤ d ⇒ a ≤ c ∧ d ≤ b) ∧
        (interval [(c,d)] ⊆ interval (a,b) ⇔ c ≤ d ⇒ a < c ∧ d < b) ∧
        (interval (c,d) ⊆ interval [(a,b)] ⇔ c < d ⇒ a ≤ c ∧ d ≤ b) ∧
        (interval (c,d) ⊆ interval (a,b) ⇔ c < d ⇒ a ≤ c ∧ d ≤ b)
   
   [SUBSET_INTERVAL_IMP]  Theorem
      
      ⊢ (a ≤ c ∧ d ≤ b ⇒ interval [(c,d)] ⊆ interval [(a,b)]) ∧
        (a < c ∧ d < b ⇒ interval [(c,d)] ⊆ interval (a,b)) ∧
        (a ≤ c ∧ d ≤ b ⇒ interval (c,d) ⊆ interval [(a,b)]) ∧
        (a ≤ c ∧ d ≤ b ⇒ interval (c,d) ⊆ interval (a,b))
   
   [SUBSPACE_0]  Theorem
      
      ⊢ subspace s ⇒ 0 ∈ s
   
   [SUBSPACE_ADD]  Theorem
      
      ⊢ ∀x y s. subspace s ∧ x ∈ s ∧ y ∈ s ⇒ x + y ∈ s
   
   [SUBSPACE_BIGINTER]  Theorem
      
      ⊢ ∀f. (∀s. s ∈ f ⇒ subspace s) ⇒ subspace (BIGINTER f)
   
   [SUBSPACE_BOUNDED_EQ_TRIVIAL]  Theorem
      
      ⊢ ∀s. subspace s ⇒ (bounded s ⇔ (s = {0}))
   
   [SUBSPACE_IMP_NONEMPTY]  Theorem
      
      ⊢ ∀s. subspace s ⇒ s ≠ ∅
   
   [SUBSPACE_INTER]  Theorem
      
      ⊢ ∀s t. subspace s ∧ subspace t ⇒ subspace (s ∩ t)
   
   [SUBSPACE_KERNEL]  Theorem
      
      ⊢ ∀f. linear f ⇒ subspace {x | f x = 0}
   
   [SUBSPACE_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s. linear f ∧ subspace s ⇒ subspace (IMAGE f s)
   
   [SUBSPACE_LINEAR_PREIMAGE]  Theorem
      
      ⊢ ∀f s. linear f ∧ subspace s ⇒ subspace {x | f x ∈ s}
   
   [SUBSPACE_MUL]  Theorem
      
      ⊢ ∀x c s. subspace s ∧ x ∈ s ⇒ c * x ∈ s
   
   [SUBSPACE_NEG]  Theorem
      
      ⊢ ∀x s. subspace s ∧ x ∈ s ⇒ -x ∈ s
   
   [SUBSPACE_SPAN]  Theorem
      
      ⊢ ∀s. subspace (span s)
   
   [SUBSPACE_SUB]  Theorem
      
      ⊢ ∀x y s. subspace s ∧ x ∈ s ∧ y ∈ s ⇒ x − y ∈ s
   
   [SUBSPACE_SUBSTANDARD]  Theorem
      
      ⊢ subspace {x | x = 0}
   
   [SUBSPACE_SUM]  Theorem
      
      ⊢ ∀s f t. subspace s ∧ FINITE t ∧ (∀x. x ∈ t ⇒ f x ∈ s) ⇒ sum t f ∈ s
   
   [SUBSPACE_SUMS]  Theorem
      
      ⊢ ∀s t. subspace s ∧ subspace t ⇒ subspace {x + y | x ∈ s ∧ y ∈ t}
   
   [SUBSPACE_TRANSLATION_SELF]  Theorem
      
      ⊢ ∀s a. subspace s ∧ a ∈ s ⇒ (IMAGE (λx. a + x) s = s)
   
   [SUBSPACE_TRANSLATION_SELF_EQ]  Theorem
      
      ⊢ ∀s a. subspace s ⇒ ((IMAGE (λx. a + x) s = s) ⇔ a ∈ s)
   
   [SUBSPACE_TRIVIAL]  Theorem
      
      ⊢ subspace {0}
   
   [SUBSPACE_UNION_CHAIN]  Theorem
      
      ⊢ ∀s t. subspace s ∧ subspace t ∧ subspace (s ∪ t) ⇒ s ⊆ t ∨ t ⊆ s
   
   [SUBSPACE_UNIV]  Theorem
      
      ⊢ subspace 𝕌(:real)
   
   [SUBTOPOLOGY_SUPERSET]  Theorem
      
      ⊢ ∀top s. topspace top ⊆ s ⇒ (subtopology top s = top)
   
   [SUBTOPOLOGY_TOPSPACE]  Theorem
      
      ⊢ ∀top. subtopology top (topspace top) = top
   
   [SUBTOPOLOGY_UNIV]  Theorem
      
      ⊢ ∀top. subtopology top 𝕌(:α) = top
   
   [SUMMABLE_0]  Theorem
      
      ⊢ ∀s. summable s (λn. 0)
   
   [SUMMABLE_ADD]  Theorem
      
      ⊢ ∀x y s. summable s x ∧ summable s y ⇒ summable s (λn. x n + y n)
   
   [SUMMABLE_BILINEAR_PARTIAL_PRE]  Theorem
      
      ⊢ ∀f g h l k.
            bilinear h ∧ ((λn. h (f (n + 1)) (g n)) --> l) sequentially ∧
            summable (from k) (λn. h (f (n + 1) − f n) (g n)) ⇒
            summable (from k) (λn. h (f n) (g n − g (n − 1)))
   
   [SUMMABLE_CAUCHY]  Theorem
      
      ⊢ ∀f s.
            summable s f ⇔
            ∀e. 0 < e ⇒ ∃N. ∀m n. m ≥ N ⇒ abs (sum (s ∩ (m .. n)) f) < e
   
   [SUMMABLE_CMUL]  Theorem
      
      ⊢ ∀s x c. summable s x ⇒ summable s (λn. c * x n)
   
   [SUMMABLE_COMPARISON]  Theorem
      
      ⊢ ∀f g s.
            summable s g ∧ (∃N. ∀n. n ≥ N ∧ n ∈ s ⇒ abs (f n) ≤ g n) ⇒
            summable s f
   
   [SUMMABLE_COMPONENT]  Theorem
      
      ⊢ ∀f s. summable s f ⇒ summable s (λi. f i)
   
   [SUMMABLE_EQ]  Theorem
      
      ⊢ ∀f g k. (∀x. x ∈ k ⇒ (f x = g x)) ∧ summable k f ⇒ summable k g
   
   [SUMMABLE_EQ_COFINITE]  Theorem
      
      ⊢ ∀f s t.
            FINITE (s DIFF t ∪ (t DIFF s)) ∧ summable s f ⇒ summable t f
   
   [SUMMABLE_EQ_EVENTUALLY]  Theorem
      
      ⊢ ∀f g k.
            (∃N. ∀n. N ≤ n ∧ n ∈ k ⇒ (f n = g n)) ∧ summable k f ⇒
            summable k g
   
   [SUMMABLE_FROM_ELSEWHERE]  Theorem
      
      ⊢ ∀f m n. summable (from m) f ⇒ summable (from n) f
   
   [SUMMABLE_IFF]  Theorem
      
      ⊢ ∀f g k. (∀x. x ∈ k ⇒ (f x = g x)) ⇒ (summable k f ⇔ summable k g)
   
   [SUMMABLE_IFF_COFINITE]  Theorem
      
      ⊢ ∀f s t.
            FINITE (s DIFF t ∪ (t DIFF s)) ⇒ (summable s f ⇔ summable t f)
   
   [SUMMABLE_IFF_EVENTUALLY]  Theorem
      
      ⊢ ∀f g k.
            (∃N. ∀n. N ≤ n ∧ n ∈ k ⇒ (f n = g n)) ⇒
            (summable k f ⇔ summable k g)
   
   [SUMMABLE_IMP_BOUNDED]  Theorem
      
      ⊢ ∀f k. summable k f ⇒ bounded (IMAGE f k)
   
   [SUMMABLE_IMP_SUMS_BOUNDED]  Theorem
      
      ⊢ ∀f k. summable (from k) f ⇒ bounded {sum (k .. n) f | n ∈ 𝕌(:num)}
   
   [SUMMABLE_IMP_TOZERO]  Theorem
      
      ⊢ ∀f k.
            summable k f ⇒
            ((λn. if n ∈ k then f n else 0) --> 0) sequentially
   
   [SUMMABLE_LINEAR]  Theorem
      
      ⊢ ∀f h s. summable s f ∧ linear h ⇒ summable s (λn. h (f n))
   
   [SUMMABLE_NEG]  Theorem
      
      ⊢ ∀x s. summable s x ⇒ summable s (λn. -x n)
   
   [SUMMABLE_REARRANGE]  Theorem
      
      ⊢ ∀x s p.
            summable s (λn. abs (x n)) ∧ p permutes s ⇒ summable s (x ∘ p)
   
   [SUMMABLE_REINDEX]  Theorem
      
      ⊢ ∀k a n.
            summable (from n) (λx. a (x + k)) ⇔ summable (from (n + k)) a
   
   [SUMMABLE_RESTRICT]  Theorem
      
      ⊢ ∀f k.
            summable 𝕌(:num) (λn. if n ∈ k then f n else 0) ⇔ summable k f
   
   [SUMMABLE_SUB]  Theorem
      
      ⊢ ∀x y s. summable s x ∧ summable s y ⇒ summable s (λn. x n − y n)
   
   [SUMMABLE_SUBSET]  Theorem
      
      ⊢ ∀x s t.
            s ⊆ t ∧ summable t (λi. if i ∈ s then x i else 0) ⇒
            summable s x
   
   [SUMMABLE_SUBSET_ABSCONV]  Theorem
      
      ⊢ ∀x s t.
            summable s (λn. abs (x n)) ∧ t ⊆ s ⇒ summable t (λn. abs (x n))
   
   [SUMMABLE_TRIVIAL]  Theorem
      
      ⊢ ∀f. summable ∅ f
   
   [SUMS_0]  Theorem
      
      ⊢ ∀f s. (∀n. n ∈ s ⇒ (f n = 0)) ⇒ (f sums 0) s
   
   [SUMS_EQ]  Theorem
      
      ⊢ ∀f g k. (∀x. x ∈ k ⇒ (f x = g x)) ∧ (f sums l) k ⇒ (g sums l) k
   
   [SUMS_FINITE_DIFF]  Theorem
      
      ⊢ ∀f t s l.
            t ⊆ s ∧ FINITE t ∧ (f sums l) s ⇒
            (f sums l − sum t f) (s DIFF t)
   
   [SUMS_FINITE_UNION]  Theorem
      
      ⊢ ∀f s t l.
            FINITE t ∧ (f sums l) s ⇒ (f sums l + sum (t DIFF s) f) (s ∪ t)
   
   [SUMS_IFF]  Theorem
      
      ⊢ ∀f g k. (∀x. x ∈ k ⇒ (f x = g x)) ⇒ ((f sums l) k ⇔ (g sums l) k)
   
   [SUMS_INFSUM]  Theorem
      
      ⊢ ∀f s. (f sums infsum s f) s ⇔ summable s f
   
   [SUMS_INTERVALS]  Theorem
      
      ⊢ (∀a b c d.
             interval [(a,b)] ≠ ∅ ∧ interval [(c,d)] ≠ ∅ ⇒
             ({x + y | x ∈ interval [(a,b)] ∧ y ∈ interval [(c,d)]} =
              interval [(a + c,b + d)])) ∧
        ∀a b c d.
            interval (a,b) ≠ ∅ ∧ interval (c,d) ≠ ∅ ⇒
            ({x + y | x ∈ interval (a,b) ∧ y ∈ interval (c,d)} =
             interval (a + c,b + d))
   
   [SUMS_LIM]  Theorem
      
      ⊢ ∀f s.
            (f sums lim sequentially (λn. sum (s ∩ (0 .. n)) f)) s ⇔
            summable s f
   
   [SUMS_OFFSET]  Theorem
      
      ⊢ ∀f l m n.
            (f sums l) (from m) ∧ 0 < n ∧ m ≤ n ⇒
            (f sums l − sum (m .. n − 1) f) (from n)
   
   [SUMS_OFFSET_REV]  Theorem
      
      ⊢ ∀f l m n.
            (f sums l) (from m) ∧ 0 < m ∧ n ≤ m ⇒
            (f sums l + sum (n .. m − 1) f) (from n)
   
   [SUMS_REINDEX]  Theorem
      
      ⊢ ∀k a l n.
            ((λx. a (x + k)) sums l) (from n) ⇔ (a sums l) (from (n + k))
   
   [SUMS_REINDEX_GEN]  Theorem
      
      ⊢ ∀k a l s.
            ((λx. a (x + k)) sums l) s ⇔ (a sums l) (IMAGE (λi. i + k) s)
   
   [SUMS_SUMMABLE]  Theorem
      
      ⊢ ∀f l s. (f sums l) s ⇒ summable s f
   
   [SUMS_SYM]  Theorem
      
      ⊢ ∀s t. {x + y | x ∈ s ∧ y ∈ t} = {y + x | y ∈ t ∧ x ∈ s}
   
   [SUM_ABS_TRIANGLE]  Theorem
      
      ⊢ ∀s f b. FINITE s ∧ sum s (λa. abs (f a)) ≤ b ⇒ abs (sum s f) ≤ b
   
   [SUM_DIFF_LEMMA]  Theorem
      
      ⊢ ∀f k m n.
            m ≤ n ⇒
            (sum (k ∩ (0 .. n)) f − sum (k ∩ (0 .. m)) f =
             sum (k ∩ (m + 1 .. n)) f)
   
   [SUM_GP]  Theorem
      
      ⊢ ∀x m n.
            sum (m .. n) (λi. x pow i) =
            if n < m then 0
            else if x = 1 then &(n + 1 − m)
            else (x pow m − x pow SUC n) / (1 − x)
   
   [SUM_GP_BASIC]  Theorem
      
      ⊢ ∀x n. (1 − x) * sum (0 .. n) (λi. x pow i) = 1 − x pow SUC n
   
   [SUM_GP_MULTIPLIED]  Theorem
      
      ⊢ ∀x m n.
            m ≤ n ⇒
            ((1 − x) * sum (m .. n) (λi. x pow i) = x pow m − x pow SUC n)
   
   [SUP_INSERT]  Theorem
      
      ⊢ ∀x s.
            bounded s ⇒
            (sup (x INSERT s) = if s = ∅ then x else max x (sup s))
   
   [SURJECTIVE_IMAGE_EQ]  Theorem
      
      ⊢ ∀s t.
            (∀y. y ∈ t ⇒ ∃x. f x = y) ∧ (∀x. f x ∈ t ⇔ x ∈ s) ⇒
            (IMAGE f s = t)
   
   [SYMMETRIC_CLOSURE]  Theorem
      
      ⊢ ∀s. (∀x. x ∈ s ⇒ -x ∈ s) ⇒ ∀x. x ∈ closure s ⇒ -x ∈ closure s
   
   [SYMMETRIC_INTERIOR]  Theorem
      
      ⊢ ∀s. (∀x. x ∈ s ⇒ -x ∈ s) ⇒ ∀x. x ∈ interior s ⇒ -x ∈ interior s
   
   [SYMMETRIC_LINEAR_IMAGE]  Theorem
      
      ⊢ ∀f s.
            (∀x. x ∈ s ⇒ -x ∈ s) ∧ linear f ⇒
            ∀x. x ∈ IMAGE f s ⇒ -x ∈ IMAGE f s
   
   [TENDSTO_LIM]  Theorem
      
      ⊢ ∀net f l. ¬trivial_limit net ∧ (f --> l) net ⇒ (lim net f = l)
   
   [TOPSPACE_EUCLIDEAN]  Theorem
      
      ⊢ topspace euclidean = 𝕌(:real)
   
   [TOPSPACE_EUCLIDEAN_SUBTOPOLOGY]  Theorem
      
      ⊢ ∀s. topspace (subtopology euclidean s) = s
   
   [TOPSPACE_SUBTOPOLOGY]  Theorem
      
      ⊢ ∀top u. topspace (subtopology top u) = topspace top ∩ u
   
   [TRANSITIVE_STEPWISE_LE]  Theorem
      
      ⊢ ∀R.
            (∀x. R x x) ∧ (∀x y z. R x y ∧ R y z ⇒ R x z) ∧
            (∀n. R n (SUC n)) ⇒
            ∀m n. m ≤ n ⇒ R m n
   
   [TRANSITIVE_STEPWISE_LE_EQ]  Theorem
      
      ⊢ ∀R.
            (∀x. R x x) ∧ (∀x y z. R x y ∧ R y z ⇒ R x z) ⇒
            ((∀m n. m ≤ n ⇒ R m n) ⇔ ∀n. R n (SUC n))
   
   [TRANSITIVE_STEPWISE_LT]  Theorem
      
      ⊢ ∀R.
            (∀x y z. R x y ∧ R y z ⇒ R x z) ∧ (∀n. R n (SUC n)) ⇒
            ∀m n. m < n ⇒ R m n
   
   [TRANSITIVE_STEPWISE_LT_EQ]  Theorem
      
      ⊢ ∀R.
            (∀x y z. R x y ∧ R y z ⇒ R x z) ⇒
            ((∀m n. m < n ⇒ R m n) ⇔ ∀n. R n (SUC n))
   
   [TRANSLATION_DIFF]  Theorem
      
      ⊢ ∀s t.
            IMAGE (λx. a + x) (s DIFF t) =
            IMAGE (λx. a + x) s DIFF IMAGE (λx. a + x) t
   
   [TRIVIAL_LIMIT_AT]  Theorem
      
      ⊢ ∀a. ¬trivial_limit (at a)
   
   [TRIVIAL_LIMIT_AT_INFINITY]  Theorem
      
      ⊢ ¬trivial_limit at_infinity
   
   [TRIVIAL_LIMIT_AT_NEGINFINITY]  Theorem
      
      ⊢ ¬trivial_limit at_neginfinity
   
   [TRIVIAL_LIMIT_AT_POSINFINITY]  Theorem
      
      ⊢ ¬trivial_limit at_posinfinity
   
   [TRIVIAL_LIMIT_SEQUENTIALLY]  Theorem
      
      ⊢ ¬trivial_limit sequentially
   
   [TRIVIAL_LIMIT_WITHIN]  Theorem
      
      ⊢ ∀a. trivial_limit (at a within s) ⇔ ¬(a limit_point_of s)
   
   [UNBOUNDED_HALFSPACE_COMPONENT_GE]  Theorem
      
      ⊢ ∀a. ¬bounded {x | x ≥ a}
   
   [UNBOUNDED_HALFSPACE_COMPONENT_GT]  Theorem
      
      ⊢ ∀a. ¬bounded {x | x > a}
   
   [UNBOUNDED_HALFSPACE_COMPONENT_LE]  Theorem
      
      ⊢ ∀a. ¬bounded {x | x ≤ a}
   
   [UNBOUNDED_HALFSPACE_COMPONENT_LT]  Theorem
      
      ⊢ ∀a. ¬bounded {x | x < a}
   
   [UNBOUNDED_INTER_COBOUNDED]  Theorem
      
      ⊢ ∀s t. ¬bounded s ∧ bounded (𝕌(:real) DIFF t) ⇒ s ∩ t ≠ ∅
   
   [UNCOUNTABLE_EUCLIDEAN]  Theorem
      
      ⊢ ¬COUNTABLE 𝕌(:real)
   
   [UNCOUNTABLE_INTERVAL]  Theorem
      
      ⊢ (∀a b. interval (a,b) ≠ ∅ ⇒ ¬COUNTABLE (interval [(a,b)])) ∧
        ∀a b. interval (a,b) ≠ ∅ ⇒ ¬COUNTABLE (interval (a,b))
   
   [UNCOUNTABLE_OPEN]  Theorem
      
      ⊢ ∀s. open s ∧ s ≠ ∅ ⇒ ¬COUNTABLE s
   
   [UNCOUNTABLE_REAL]  Theorem
      
      ⊢ ¬COUNTABLE 𝕌(:real)
   
   [UNIFORMLY_CAUCHY_IMP_UNIFORMLY_CONVERGENT]  Theorem
      
      ⊢ ∀P s l.
            (∀e.
                 0 < e ⇒
                 ∃N. ∀m n x. N ≤ m ∧ N ≤ n ∧ P x ⇒ dist (s m x,s n x) < e) ∧
            (∀x. P x ⇒ ∀e. 0 < e ⇒ ∃N. ∀n. N ≤ n ⇒ dist (s n x,l x) < e) ⇒
            ∀e. 0 < e ⇒ ∃N. ∀n x. N ≤ n ∧ P x ⇒ dist (s n x,l x) < e
   
   [UNIFORMLY_CONTINUOUS_EXTENDS_TO_CLOSURE]  Theorem
      
      ⊢ ∀f s.
            f uniformly_continuous_on s ⇒
            ∃g.
                g uniformly_continuous_on closure s ∧
                (∀x. x ∈ s ⇒ (g x = f x)) ∧
                ∀h.
                    h continuous_on closure s ∧ (∀x. x ∈ s ⇒ (h x = f x)) ⇒
                    ∀x. x ∈ closure s ⇒ (h x = g x)
   
   [UNIFORMLY_CONTINUOUS_IMP_CAUCHY_CONTINUOUS]  Theorem
      
      ⊢ ∀f s.
            f uniformly_continuous_on s ⇒
            ∀x. cauchy x ∧ (∀n. x n ∈ s) ⇒ cauchy (f ∘ x)
   
   [UNIFORMLY_CONTINUOUS_IMP_CONTINUOUS]  Theorem
      
      ⊢ ∀f s. f uniformly_continuous_on s ⇒ f continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_ADD]  Theorem
      
      ⊢ ∀f g s.
            f uniformly_continuous_on s ∧ g uniformly_continuous_on s ⇒
            (λx. f x + g x) uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_CLOSURE]  Theorem
      
      ⊢ ∀f s.
            f uniformly_continuous_on s ∧ f continuous_on closure s ⇒
            f uniformly_continuous_on closure s
   
   [UNIFORMLY_CONTINUOUS_ON_CMUL]  Theorem
      
      ⊢ ∀f c s.
            f uniformly_continuous_on s ⇒
            (λx. c * f x) uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_COMPOSE]  Theorem
      
      ⊢ ∀f g s.
            f uniformly_continuous_on s ∧
            g uniformly_continuous_on IMAGE f s ⇒
            g ∘ f uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_CONST]  Theorem
      
      ⊢ ∀s c. (λx. c) uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_DIST_CLOSEST_POINT]  Theorem
      
      ⊢ ∀s t.
            closed s ∧ s ≠ ∅ ⇒
            (λx. dist (x,closest_point s x)) uniformly_continuous_on t
   
   [UNIFORMLY_CONTINUOUS_ON_EQ]  Theorem
      
      ⊢ ∀f g s.
            (∀x. x ∈ s ⇒ (f x = g x)) ∧ f uniformly_continuous_on s ⇒
            g uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_ID]  Theorem
      
      ⊢ ∀s. (λx. x) uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_MUL]  Theorem
      
      ⊢ ∀f g s.
            f uniformly_continuous_on s ∧ g uniformly_continuous_on s ∧
            bounded (IMAGE f s) ∧ bounded (IMAGE g s) ⇒
            (λx. f x * g x) uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_NEG]  Theorem
      
      ⊢ ∀f s.
            f uniformly_continuous_on s ⇒
            (λx. -f x) uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_SEQUENTIALLY]  Theorem
      
      ⊢ ∀f s.
            f uniformly_continuous_on s ⇔
            ∀x y.
                (∀n. x n ∈ s) ∧ (∀n. y n ∈ s) ∧
                ((λn. x n − y n) --> 0) sequentially ⇒
                ((λn. f (x n) − f (y n)) --> 0) sequentially
   
   [UNIFORMLY_CONTINUOUS_ON_SETDIST]  Theorem
      
      ⊢ ∀s t. (λy. setdist ({y},s)) uniformly_continuous_on t
   
   [UNIFORMLY_CONTINUOUS_ON_SUB]  Theorem
      
      ⊢ ∀f g s.
            f uniformly_continuous_on s ∧ g uniformly_continuous_on s ⇒
            (λx. f x − g x) uniformly_continuous_on s
   
   [UNIFORMLY_CONTINUOUS_ON_SUBSET]  Theorem
      
      ⊢ ∀f s t.
            f uniformly_continuous_on s ∧ t ⊆ s ⇒
            f uniformly_continuous_on t
   
   [UNIFORMLY_CONTINUOUS_ON_SUM]  Theorem
      
      ⊢ ∀t f s.
            FINITE s ∧ (∀a. a ∈ s ⇒ f a uniformly_continuous_on t) ⇒
            (λx. sum s (λa. f a x)) uniformly_continuous_on t
   
   [UNIFORMLY_CONTINUOUS_ON_VMUL]  Theorem
      
      ⊢ ∀s c v.
            c uniformly_continuous_on s ⇒
            (λx. c x * v) uniformly_continuous_on s
   
   [UNIFORMLY_CONVERGENT_EQ_CAUCHY]  Theorem
      
      ⊢ ∀P s.
            (∃l. ∀e. 0 < e ⇒ ∃N. ∀n x. N ≤ n ∧ P x ⇒ dist (s n x,l x) < e) ⇔
            ∀e.
                0 < e ⇒
                ∃N. ∀m n x. N ≤ m ∧ N ≤ n ∧ P x ⇒ dist (s m x,s n x) < e
   
   [UNIFORMLY_CONVERGENT_EQ_CAUCHY_ALT]  Theorem
      
      ⊢ ∀P s.
            (∃l. ∀e. 0 < e ⇒ ∃N. ∀n x. N ≤ n ∧ P x ⇒ dist (s n x,l x) < e) ⇔
            ∀e.
                0 < e ⇒
                ∃N.
                    ∀m n x.
                        N ≤ m ∧ N ≤ n ∧ m < n ∧ P x ⇒
                        dist (s m x,s n x) < e
   
   [UNIFORM_LIM_ADD]  Theorem
      
      ⊢ ∀net P f g l m.
            (∀e.
                 0 < e ⇒
                 eventually (λx. ∀n. P n ⇒ abs (f n x − l n) < e) net) ∧
            (∀e.
                 0 < e ⇒
                 eventually (λx. ∀n. P n ⇒ abs (g n x − m n) < e) net) ⇒
            ∀e.
                0 < e ⇒
                eventually
                  (λx. ∀n. P n ⇒ abs (f n x + g n x − (l n + m n)) < e) net
   
   [UNIFORM_LIM_BILINEAR]  Theorem
      
      ⊢ ∀net P h f g l m b1 b2.
            bilinear h ∧ eventually (λx. ∀n. P n ⇒ abs (l n) ≤ b1) net ∧
            eventually (λx. ∀n. P n ⇒ abs (m n) ≤ b2) net ∧
            (∀e.
                 0 < e ⇒
                 eventually (λx. ∀n. P n ⇒ abs (f n x − l n) < e) net) ∧
            (∀e.
                 0 < e ⇒
                 eventually (λx. ∀n. P n ⇒ abs (g n x − m n) < e) net) ⇒
            ∀e.
                0 < e ⇒
                eventually
                  (λx.
                       ∀n.
                           P n ⇒
                           abs (h (f n x) (g n x) − h (l n) (m n)) < e) net
   
   [UNIFORM_LIM_SUB]  Theorem
      
      ⊢ ∀net P f g l m.
            (∀e.
                 0 < e ⇒
                 eventually (λx. ∀n. P n ⇒ abs (f n x − l n) < e) net) ∧
            (∀e.
                 0 < e ⇒
                 eventually (λx. ∀n. P n ⇒ abs (g n x − m n) < e) net) ⇒
            ∀e.
                0 < e ⇒
                eventually
                  (λx. ∀n. P n ⇒ abs (f n x − g n x − (l n − m n)) < e) net
   
   [UNION_FRONTIER]  Theorem
      
      ⊢ ∀s t.
            frontier s ∪ frontier t =
            frontier (s ∪ t) ∪ frontier (s ∩ t) ∪ frontier s ∩ frontier t
   
   [UNION_INTERIOR_SUBSET]  Theorem
      
      ⊢ ∀s t. interior s ∪ interior t ⊆ interior (s ∪ t)
   
   [UNIT_INTERVAL_NONEMPTY]  Theorem
      
      ⊢ interval [(0,1)] ≠ ∅ ∧ interval (0,1) ≠ ∅
   
   [UPPER_BOUND_FINITE_SET]  Theorem
      
      ⊢ ∀f s. FINITE s ⇒ ∃a. ∀x. x ∈ s ⇒ f x ≤ a
   
   [UPPER_BOUND_FINITE_SET_REAL]  Theorem
      
      ⊢ ∀f s. FINITE s ⇒ ∃a. ∀x. x ∈ s ⇒ f x ≤ a
   
   [UPPER_HEMICONTINUOUS]  Theorem
      
      ⊢ ∀f t s.
            (∀x. x ∈ s ⇒ f x ⊆ t) ⇒
            ((∀u.
                  open_in (subtopology euclidean t) u ⇒
                  open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ⊆ u}) ⇔
             ∀u.
                 closed_in (subtopology euclidean t) u ⇒
                 closed_in (subtopology euclidean s)
                   {x | x ∈ s ∧ f x ∩ u ≠ ∅})
   
   [UPPER_LOWER_HEMICONTINUOUS]  Theorem
      
      ⊢ ∀f t s.
            (∀x. x ∈ s ⇒ f x ⊆ t) ∧
            (∀u.
                 open_in (subtopology euclidean t) u ⇒
                 open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ⊆ u}) ∧
            (∀u.
                 closed_in (subtopology euclidean t) u ⇒
                 closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ⊆ u}) ⇒
            ∀x e.
                x ∈ s ∧ 0 < e ∧ bounded (f x) ⇒
                ∃d.
                    0 < d ∧
                    ∀x'. x' ∈ s ∧ dist (x,x') < d ⇒ hausdist (f x,f x') < e
   
   [UPPER_LOWER_HEMICONTINUOUS_EXPLICIT]  Theorem
      
      ⊢ ∀f t s.
            (∀x. x ∈ s ⇒ f x ⊆ t) ∧
            (∀u.
                 open_in (subtopology euclidean t) u ⇒
                 open_in (subtopology euclidean s) {x | x ∈ s ∧ f x ⊆ u}) ∧
            (∀u.
                 closed_in (subtopology euclidean t) u ⇒
                 closed_in (subtopology euclidean s) {x | x ∈ s ∧ f x ⊆ u}) ⇒
            ∀x e.
                x ∈ s ∧ 0 < e ∧ bounded (f x) ∧ f x ≠ ∅ ⇒
                ∃d.
                    0 < d ∧
                    ∀x'.
                        x' ∈ s ∧ dist (x,x') < d ⇒
                        (∀y. y ∈ f x ⇒ ∃y'. y' ∈ f x' ∧ dist (y,y') < e) ∧
                        ∀y'. y' ∈ f x' ⇒ ∃y. y ∈ f x ∧ dist (y',y) < e
   
   [URYSOHN]  Theorem
      
      ⊢ ∀s t a b.
            closed s ∧ closed t ∧ (s ∩ t = ∅) ⇒
            ∃f.
                f continuous_on 𝕌(:real) ∧ (∀x. f x ∈ segment [(a,b)]) ∧
                (∀x. x ∈ s ⇒ (f x = a)) ∧ ∀x. x ∈ t ⇒ (f x = b)
   
   [URYSOHN_LOCAL]  Theorem
      
      ⊢ ∀s t u a b.
            closed_in (subtopology euclidean u) s ∧
            closed_in (subtopology euclidean u) t ∧ (s ∩ t = ∅) ⇒
            ∃f.
                f continuous_on u ∧ (∀x. x ∈ u ⇒ f x ∈ segment [(a,b)]) ∧
                (∀x. x ∈ s ⇒ (f x = a)) ∧ ∀x. x ∈ t ⇒ (f x = b)
   
   [URYSOHN_LOCAL_STRONG]  Theorem
      
      ⊢ ∀s t u a b.
            closed_in (subtopology euclidean u) s ∧
            closed_in (subtopology euclidean u) t ∧ (s ∩ t = ∅) ∧ a ≠ b ⇒
            ∃f.
                f continuous_on u ∧ (∀x. x ∈ u ⇒ f x ∈ segment [(a,b)]) ∧
                (∀x. x ∈ u ⇒ ((f x = a) ⇔ x ∈ s)) ∧
                ∀x. x ∈ u ⇒ ((f x = b) ⇔ x ∈ t)
   
   [URYSOHN_STRONG]  Theorem
      
      ⊢ ∀s t a b.
            closed s ∧ closed t ∧ (s ∩ t = ∅) ∧ a ≠ b ⇒
            ∃f.
                f continuous_on 𝕌(:real) ∧ (∀x. f x ∈ segment [(a,b)]) ∧
                (∀x. (f x = a) ⇔ x ∈ s) ∧ ∀x. (f x = b) ⇔ x ∈ t
   
   [WITHIN]  Theorem
      
      ⊢ ∀n s x y. netord (n within s) x y ⇔ netord n x y ∧ x ∈ s
   
   [WITHIN_UNIV]  Theorem
      
      ⊢ ∀x. at x within 𝕌(:real) = at x
   
   [WITHIN_WITHIN]  Theorem
      
      ⊢ ∀net s t. (net within s) within t = net within s ∩ t
   
   [WLOG_LE]  Theorem
      
      ⊢ (∀m n. P m n ⇔ P n m) ∧ (∀m n. m ≤ n ⇒ P m n) ⇒ ∀m n. P m n
   
   [WLOG_LT]  Theorem
      
      ⊢ (∀m. P m m) ∧ (∀m n. P m n ⇔ P n m) ∧ (∀m n. m < n ⇒ P m n) ⇒
        ∀m y. P m y
   
   [continuous_at]  Theorem
      
      ⊢ f continuous at x ⇔
        ∀e. 0 < e ⇒ ∃d. 0 < d ∧ ∀x'. dist (x',x) < d ⇒ dist (f x',f x) < e
   
   [continuous_within]  Theorem
      
      ⊢ f continuous (at x within s) ⇔
        ∀e.
            0 < e ⇒
            ∃d. 0 < d ∧ ∀x'. x' ∈ s ∧ dist (x',x) < d ⇒ dist (f x',f x) < e
   
   [interval]  Theorem
      
      ⊢ (interval (a,b) = {x | a < x ∧ x < b}) ∧
        (interval [(a,b)] = {x | a ≤ x ∧ x ≤ b})
   
   [net_tybij]  Theorem
      
      ⊢ (∀a. mk_net (netord a) = a) ∧
        ∀r.
            (∀x y. (∀z. r z x ⇒ r z y) ∨ ∀z. r z y ⇒ r z x) ⇔
            (netord (mk_net r) = r)
   
   [open_in]  Theorem
      
      ⊢ ∀u s.
            open_in (subtopology euclidean u) s ⇔
            s ⊆ u ∧
            ∀x. x ∈ s ⇒ ∃e. 0 < e ∧ ∀x'. x' ∈ u ∧ dist (x',x) < e ⇒ x' ∈ s
   
   [segment]  Theorem
      
      ⊢ (segment [(a,b)] = {(1 − u) * a + u * b | 0 ≤ u ∧ u ≤ 1}) ∧
        (segment (a,b) = segment [(a,b)] DIFF {a; b})
   
   
*)
end
