structure real_topologyTheory :> real_topologyTheory =
struct
  
  val _ = if !Globals.print_thy_loads
    then TextIO.print "Loading real_topologyTheory ... "
    else ()
  
  open Type Term Thm
  local open productTheory in end;
  
  structure TDB = struct
    val thydata = 
      TheoryReader.load_thydata "real_topology"
        (holpathdb.subst_pathvars "$(HOLDIR)/src/probability/real_topologyTheory.dat")
    fun find s = Redblackmap.find (thydata,s)
  end
  
  fun op fsigma _ = () val op fsigma = TDB.find "fsigma"
  fun op gdelta _ = () val op gdelta = TDB.find "gdelta"
  fun op locally _ = () val op locally = TDB.find "locally"
  fun op hausdist _ = () val op hausdist = TDB.find "hausdist"
  fun op setdist _ = () val op setdist = TDB.find "setdist"
  fun op closest_point _ = ()
  val op closest_point = TDB.find "closest_point"
  fun op summable _ = () val op summable = TDB.find "summable"
  fun op infsum _ = () val op infsum = TDB.find "infsum"
  fun op sums _ = () val op sums = TDB.find "sums"
  fun op homeomorphic _ = () val op homeomorphic = TDB.find "homeomorphic"
  fun op homeomorphism _ = ()
  val op homeomorphism = TDB.find "homeomorphism"
  fun op is_interval _ = () val op is_interval = TDB.find "is_interval"
  fun op midpoint _ = () val op midpoint = TDB.find "midpoint"
  fun op between _ = () val op between = TDB.find "between"
  fun op collinear _ = () val op collinear = TDB.find "collinear"
  fun op condensation_point_of _ = ()
  val op condensation_point_of = TDB.find "condensation_point_of"
  fun op netlimit _ = () val op netlimit = TDB.find "netlimit"
  fun op bounded_def _ = () val op bounded_def = TDB.find "bounded_def"
  fun op CLOSED_interval _ = ()
  val op CLOSED_interval = TDB.find "CLOSED_interval"
  fun op OPEN_interval _ = ()
  val op OPEN_interval = TDB.find "OPEN_interval"
  fun op diameter _ = () val op diameter = TDB.find "diameter"
  fun op components _ = () val op components = TDB.find "components"
  fun op connected_component _ = ()
  val op connected_component = TDB.find "connected_component"
  fun op ball _ = () val op ball = TDB.find "ball"
  fun op cball _ = () val op cball = TDB.find "cball"
  fun op sphere _ = () val op sphere = TDB.find "sphere"
  fun op closed_segment _ = ()
  val op closed_segment = TDB.find "closed_segment"
  fun op open_segment _ = () val op open_segment = TDB.find "open_segment"
  fun op connected _ = () val op connected = TDB.find "connected"
  fun op limit_point_of _ = ()
  val op limit_point_of = TDB.find "limit_point_of"
  fun op interior _ = () val op interior = TDB.find "interior"
  fun op closure _ = () val op closure = TDB.find "closure"
  fun op frontier _ = () val op frontier = TDB.find "frontier"
  fun op isnet _ = () val op isnet = TDB.find "isnet"
  fun op net_TY_DEF _ = () val op net_TY_DEF = TDB.find "net_TY_DEF"
  fun op at _ = () val op at = TDB.find "at"
  fun op at_infinity _ = () val op at_infinity = TDB.find "at_infinity"
  fun op at_posinfinity _ = ()
  val op at_posinfinity = TDB.find "at_posinfinity"
  fun op at_neginfinity _ = ()
  val op at_neginfinity = TDB.find "at_neginfinity"
  fun op sequentially _ = () val op sequentially = TDB.find "sequentially"
  fun op within _ = () val op within = TDB.find "within"
  fun op in_direction _ = () val op in_direction = TDB.find "in_direction"
  fun op trivial_limit _ = ()
  val op trivial_limit = TDB.find "trivial_limit"
  fun op eventually _ = () val op eventually = TDB.find "eventually"
  fun op tendsto _ = () val op tendsto = TDB.find "tendsto"
  fun op lim_def _ = () val op lim_def = TDB.find "lim_def"
  fun op euclidean _ = () val op euclidean = TDB.find "euclidean"
  fun op closed_def _ = () val op closed_def = TDB.find "closed_def"
  fun op open_def _ = () val op open_def = TDB.find "open_def"
  fun op subtopology _ = () val op subtopology = TDB.find "subtopology"
  fun op dim _ = () val op dim = TDB.find "dim"
  fun op independent _ = () val op independent = TDB.find "independent"
  fun op dependent _ = () val op dependent = TDB.find "dependent"
  fun op span _ = () val op span = TDB.find "span"
  fun op subspace _ = () val op subspace = TDB.find "subspace"
  fun op bilinear _ = () val op bilinear = TDB.find "bilinear"
  fun op linear _ = () val op linear = TDB.find "linear"
  fun op dist _ = () val op dist = TDB.find "dist"
  fun op permutes _ = () val op permutes = TDB.find "permutes"
  fun op pairwise _ = () val op pairwise = TDB.find "pairwise"
  fun op uniformly_continuous_on _ = ()
  val op uniformly_continuous_on = TDB.find "uniformly_continuous_on"
  fun op continuous_on _ = ()
  val op continuous_on = TDB.find "continuous_on"
  fun op continuous _ = () val op continuous = TDB.find "continuous"
  fun op complete _ = () val op complete = TDB.find "complete"
  fun op cauchy _ = () val op cauchy = TDB.find "cauchy"
  fun op compact _ = () val op compact = TDB.find "compact"
  fun op FSIGMA_COMPLEMENT _ = ()
  val op FSIGMA_COMPLEMENT = TDB.find "FSIGMA_COMPLEMENT"
  fun op GDELTA_COMPLEMENT _ = ()
  val op GDELTA_COMPLEMENT = TDB.find "GDELTA_COMPLEMENT"
  fun op LOCALLY_OPEN_MAP_IMAGE _ = ()
  val op LOCALLY_OPEN_MAP_IMAGE = TDB.find "LOCALLY_OPEN_MAP_IMAGE"
  fun op LOCALLY_INJECTIVE_LINEAR_IMAGE _ = ()
  val op LOCALLY_INJECTIVE_LINEAR_IMAGE = TDB.find
    "LOCALLY_INJECTIVE_LINEAR_IMAGE"
  fun op LOCALLY_TRANSLATION _ = ()
  val op LOCALLY_TRANSLATION = TDB.find "LOCALLY_TRANSLATION"
  fun op HOMEOMORPHIC_LOCALLY _ = ()
  val op HOMEOMORPHIC_LOCALLY = TDB.find "HOMEOMORPHIC_LOCALLY"
  fun op HOMEOMORPHISM_LOCALLY _ = ()
  val op HOMEOMORPHISM_LOCALLY = TDB.find "HOMEOMORPHISM_LOCALLY"
  fun op LOCALLY_INTER _ = ()
  val op LOCALLY_INTER = TDB.find "LOCALLY_INTER"
  fun op LOCALLY_SING _ = () val op LOCALLY_SING = TDB.find "LOCALLY_SING"
  fun op LOCALLY_EMPTY _ = ()
  val op LOCALLY_EMPTY = TDB.find "LOCALLY_EMPTY"
  fun op LOCALLY_DIFF_CLOSED _ = ()
  val op LOCALLY_DIFF_CLOSED = TDB.find "LOCALLY_DIFF_CLOSED"
  fun op LOCALLY_OPEN_SUBSET _ = ()
  val op LOCALLY_OPEN_SUBSET = TDB.find "LOCALLY_OPEN_SUBSET"
  fun op LOCALLY_MONO _ = () val op LOCALLY_MONO = TDB.find "LOCALLY_MONO"
  fun op URYSOHN _ = () val op URYSOHN = TDB.find "URYSOHN"
  fun op URYSOHN_STRONG _ = ()
  val op URYSOHN_STRONG = TDB.find "URYSOHN_STRONG"
  fun op URYSOHN_LOCAL _ = ()
  val op URYSOHN_LOCAL = TDB.find "URYSOHN_LOCAL"
  fun op URYSOHN_LOCAL_STRONG _ = ()
  val op URYSOHN_LOCAL_STRONG = TDB.find "URYSOHN_LOCAL_STRONG"
  fun op ISOMETRY_IMP_HOMEOMORPHISM_COMPACT _ = ()
  val op ISOMETRY_IMP_HOMEOMORPHISM_COMPACT = TDB.find
    "ISOMETRY_IMP_HOMEOMORPHISM_COMPACT"
  fun op ISOMETRY_IMP_EMBEDDING _ = ()
  val op ISOMETRY_IMP_EMBEDDING = TDB.find "ISOMETRY_IMP_EMBEDDING"
  fun op ISOMETRY_IMP_OPEN_MAP _ = ()
  val op ISOMETRY_IMP_OPEN_MAP = TDB.find "ISOMETRY_IMP_OPEN_MAP"
  fun op CONTINUOUS_DIAMETER _ = ()
  val op CONTINUOUS_DIAMETER = TDB.find "CONTINUOUS_DIAMETER"
  fun op HAUSDIST_ALT _ = () val op HAUSDIST_ALT = TDB.find "HAUSDIST_ALT"
  fun op HAUSDIST_COMPACT_NONTRIVIAL _ = ()
  val op HAUSDIST_COMPACT_NONTRIVIAL = TDB.find
    "HAUSDIST_COMPACT_NONTRIVIAL"
  fun op HAUSDIST_EQ_0 _ = ()
  val op HAUSDIST_EQ_0 = TDB.find "HAUSDIST_EQ_0"
  fun op HAUSDIST_TRANS _ = ()
  val op HAUSDIST_TRANS = TDB.find "HAUSDIST_TRANS"
  fun op HAUSDIST_COMPACT_SUMS _ = ()
  val op HAUSDIST_COMPACT_SUMS = TDB.find "HAUSDIST_COMPACT_SUMS"
  fun op HAUSDIST_TRIANGLE _ = ()
  val op HAUSDIST_TRIANGLE = TDB.find "HAUSDIST_TRIANGLE"
  fun op HAUSDIST_COMPACT_EXISTS _ = ()
  val op HAUSDIST_COMPACT_EXISTS = TDB.find "HAUSDIST_COMPACT_EXISTS"
  fun op HAUSDIST_INSERT_LE _ = ()
  val op HAUSDIST_INSERT_LE = TDB.find "HAUSDIST_INSERT_LE"
  fun op HAUSDIST_UNION_LE _ = ()
  val op HAUSDIST_UNION_LE = TDB.find "HAUSDIST_UNION_LE"
  fun op REAL_HAUSDIST_LE_EQ _ = ()
  val op REAL_HAUSDIST_LE_EQ = TDB.find "REAL_HAUSDIST_LE_EQ"
  fun op HAUSDIST_NONTRIVIAL_ALT _ = ()
  val op HAUSDIST_NONTRIVIAL_ALT = TDB.find "HAUSDIST_NONTRIVIAL_ALT"
  fun op HAUSDIST_NONTRIVIAL _ = ()
  val op HAUSDIST_NONTRIVIAL = TDB.find "HAUSDIST_NONTRIVIAL"
  fun op UPPER_LOWER_HEMICONTINUOUS _ = ()
  val op UPPER_LOWER_HEMICONTINUOUS = TDB.find "UPPER_LOWER_HEMICONTINUOUS"
  fun op REAL_LT_HAUSDIST_POINT_EXISTS _ = ()
  val op REAL_LT_HAUSDIST_POINT_EXISTS = TDB.find
    "REAL_LT_HAUSDIST_POINT_EXISTS"
  fun op HAUSDIST_SETDIST_TRIANGLE _ = ()
  val op HAUSDIST_SETDIST_TRIANGLE = TDB.find "HAUSDIST_SETDIST_TRIANGLE"
  fun op SETDIST_HAUSDIST_TRIANGLE _ = ()
  val op SETDIST_HAUSDIST_TRIANGLE = TDB.find "SETDIST_HAUSDIST_TRIANGLE"
  fun op SETDIST_SING_LE_HAUSDIST _ = ()
  val op SETDIST_SING_LE_HAUSDIST = TDB.find "SETDIST_SING_LE_HAUSDIST"
  fun op SETDIST_LE_HAUSDIST _ = ()
  val op SETDIST_LE_HAUSDIST = TDB.find "SETDIST_LE_HAUSDIST"
  fun op REAL_LE_HAUSDIST _ = ()
  val op REAL_LE_HAUSDIST = TDB.find "REAL_LE_HAUSDIST"
  fun op REAL_HAUSDIST_LE_SUMS _ = ()
  val op REAL_HAUSDIST_LE_SUMS = TDB.find "REAL_HAUSDIST_LE_SUMS"
  fun op REAL_HAUSDIST_LE _ = ()
  val op REAL_HAUSDIST_LE = TDB.find "REAL_HAUSDIST_LE"
  fun op HAUSDIST_CLOSURE _ = ()
  val op HAUSDIST_CLOSURE = TDB.find "HAUSDIST_CLOSURE"
  fun op HAUSDIST_LINEAR_IMAGE _ = ()
  val op HAUSDIST_LINEAR_IMAGE = TDB.find "HAUSDIST_LINEAR_IMAGE"
  fun op HAUSDIST_TRANSLATION _ = ()
  val op HAUSDIST_TRANSLATION = TDB.find "HAUSDIST_TRANSLATION"
  fun op HAUSDIST_EQ _ = () val op HAUSDIST_EQ = TDB.find "HAUSDIST_EQ"
  fun op HAUSDIST_SINGS _ = ()
  val op HAUSDIST_SINGS = TDB.find "HAUSDIST_SINGS"
  fun op HAUSDIST_EMPTY _ = ()
  val op HAUSDIST_EMPTY = TDB.find "HAUSDIST_EMPTY"
  fun op HAUSDIST_SYM _ = () val op HAUSDIST_SYM = TDB.find "HAUSDIST_SYM"
  fun op HAUSDIST_REFL _ = ()
  val op HAUSDIST_REFL = TDB.find "HAUSDIST_REFL"
  fun op HAUSDIST_POS_LE _ = ()
  val op HAUSDIST_POS_LE = TDB.find "HAUSDIST_POS_LE"
  fun op CONNECTED_NEST_GEN _ = ()
  val op CONNECTED_NEST_GEN = TDB.find "CONNECTED_NEST_GEN"
  fun op CONNECTED_NEST _ = ()
  val op CONNECTED_NEST = TDB.find "CONNECTED_NEST"
  fun op CONNECTED_CHAIN_GEN _ = ()
  val op CONNECTED_CHAIN_GEN = TDB.find "CONNECTED_CHAIN_GEN"
  fun op CONNECTED_CHAIN _ = ()
  val op CONNECTED_CHAIN = TDB.find "CONNECTED_CHAIN"
  fun op SEPARATION_T0 _ = ()
  val op SEPARATION_T0 = TDB.find "SEPARATION_T0"
  fun op SEPARATION_T1 _ = ()
  val op SEPARATION_T1 = TDB.find "SEPARATION_T1"
  fun op SEPARATION_T2 _ = ()
  val op SEPARATION_T2 = TDB.find "SEPARATION_T2"
  fun op SEPARATION_HAUSDORFF _ = ()
  val op SEPARATION_HAUSDORFF = TDB.find "SEPARATION_HAUSDORFF"
  fun op SEPARATION_NORMAL_COMPACT _ = ()
  val op SEPARATION_NORMAL_COMPACT = TDB.find "SEPARATION_NORMAL_COMPACT"
  fun op SEPARATION_NORMAL_LOCAL _ = ()
  val op SEPARATION_NORMAL_LOCAL = TDB.find "SEPARATION_NORMAL_LOCAL"
  fun op SEPARATION_NORMAL _ = ()
  val op SEPARATION_NORMAL = TDB.find "SEPARATION_NORMAL"
  fun op SEPARATION_CLOSURES _ = ()
  val op SEPARATION_CLOSURES = TDB.find "SEPARATION_CLOSURES"
  fun op SETDIST_BALLS _ = ()
  val op SETDIST_BALLS = TDB.find "SETDIST_BALLS"
  fun op SETDIST_LE_SING _ = ()
  val op SETDIST_LE_SING = TDB.find "SETDIST_LE_SING"
  fun op SETDIST_SING_TRIANGLE _ = ()
  val op SETDIST_SING_TRIANGLE = TDB.find "SETDIST_SING_TRIANGLE"
  fun op SETDIST_SING_FRONTIER_CASES _ = ()
  val op SETDIST_SING_FRONTIER_CASES = TDB.find
    "SETDIST_SING_FRONTIER_CASES"
  fun op SETDIST_SING_IN_SET _ = ()
  val op SETDIST_SING_IN_SET = TDB.find "SETDIST_SING_IN_SET"
  fun op SETDIST_EQ_0_CLOSED_IN _ = ()
  val op SETDIST_EQ_0_CLOSED_IN = TDB.find "SETDIST_EQ_0_CLOSED_IN"
  fun op SETDIST_EQ_0_CLOSED _ = ()
  val op SETDIST_EQ_0_CLOSED = TDB.find "SETDIST_EQ_0_CLOSED"
  fun op SETDIST_EQ_0_SING _ = ()
  val op SETDIST_EQ_0_SING = TDB.find "SETDIST_EQ_0_SING"
  fun op SETDIST_CLOSEST_POINT _ = ()
  val op SETDIST_CLOSEST_POINT = TDB.find "SETDIST_CLOSEST_POINT"
  fun op SETDIST_SING_FRONTIER _ = ()
  val op SETDIST_SING_FRONTIER = TDB.find "SETDIST_SING_FRONTIER"
  fun op SETDIST_FRONTIERS _ = ()
  val op SETDIST_FRONTIERS = TDB.find "SETDIST_FRONTIERS"
  fun op SETDIST_ZERO_STRONG _ = ()
  val op SETDIST_ZERO_STRONG = TDB.find "SETDIST_ZERO_STRONG"
  fun op SETDIST_ZERO _ = () val op SETDIST_ZERO = TDB.find "SETDIST_ZERO"
  fun op SETDIST_UNIV _ = () val op SETDIST_UNIV = TDB.find "SETDIST_UNIV"
  fun op SETDIST_UNIQUE _ = ()
  val op SETDIST_UNIQUE = TDB.find "SETDIST_UNIQUE"
  fun op SETDIST_LINEAR_IMAGE _ = ()
  val op SETDIST_LINEAR_IMAGE = TDB.find "SETDIST_LINEAR_IMAGE"
  fun op SETDIST_TRANSLATION _ = ()
  val op SETDIST_TRANSLATION = TDB.find "SETDIST_TRANSLATION"
  fun op SETDIST_EQ_0_BOUNDED _ = ()
  val op SETDIST_EQ_0_BOUNDED = TDB.find "SETDIST_EQ_0_BOUNDED"
  fun op SETDIST_EQ_0_CLOSED_COMPACT _ = ()
  val op SETDIST_EQ_0_CLOSED_COMPACT = TDB.find
    "SETDIST_EQ_0_CLOSED_COMPACT"
  fun op SETDIST_EQ_0_COMPACT_CLOSED _ = ()
  val op SETDIST_EQ_0_COMPACT_CLOSED = TDB.find
    "SETDIST_EQ_0_COMPACT_CLOSED"
  fun op SETDIST_CLOSED_COMPACT _ = ()
  val op SETDIST_CLOSED_COMPACT = TDB.find "SETDIST_CLOSED_COMPACT"
  fun op SETDIST_COMPACT_CLOSED _ = ()
  val op SETDIST_COMPACT_CLOSED = TDB.find "SETDIST_COMPACT_CLOSED"
  fun op SETDIST_FRONTIER _ = ()
  val op SETDIST_FRONTIER = TDB.find "SETDIST_FRONTIER"
  fun op SETDIST_CLOSURE _ = ()
  val op SETDIST_CLOSURE = TDB.find "SETDIST_CLOSURE"
  fun op SETDIST_SUBSET_LEFT _ = ()
  val op SETDIST_SUBSET_LEFT = TDB.find "SETDIST_SUBSET_LEFT"
  fun op SETDIST_SUBSET_RIGHT _ = ()
  val op SETDIST_SUBSET_RIGHT = TDB.find "SETDIST_SUBSET_RIGHT"
  fun op SETDIST_DIFFERENCES _ = ()
  val op SETDIST_DIFFERENCES = TDB.find "SETDIST_DIFFERENCES"
  fun op UNIFORMLY_CONTINUOUS_ON_SETDIST _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_SETDIST = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_SETDIST"
  fun op CONTINUOUS_ON_SETDIST _ = ()
  val op CONTINUOUS_ON_SETDIST = TDB.find "CONTINUOUS_ON_SETDIST"
  fun op CONTINUOUS_AT_SETDIST _ = ()
  val op CONTINUOUS_AT_SETDIST = TDB.find "CONTINUOUS_AT_SETDIST"
  fun op SETDIST_LIPSCHITZ _ = ()
  val op SETDIST_LIPSCHITZ = TDB.find "SETDIST_LIPSCHITZ"
  fun op SETDIST_SINGS _ = ()
  val op SETDIST_SINGS = TDB.find "SETDIST_SINGS"
  fun op SETDIST_TRIANGLE _ = ()
  val op SETDIST_TRIANGLE = TDB.find "SETDIST_TRIANGLE"
  fun op SETDIST_SYM _ = () val op SETDIST_SYM = TDB.find "SETDIST_SYM"
  fun op SETDIST_REFL _ = () val op SETDIST_REFL = TDB.find "SETDIST_REFL"
  fun op REAL_SETDIST_LT_EXISTS _ = ()
  val op REAL_SETDIST_LT_EXISTS = TDB.find "REAL_SETDIST_LT_EXISTS"
  fun op REAL_LE_SETDIST_EQ _ = ()
  val op REAL_LE_SETDIST_EQ = TDB.find "REAL_LE_SETDIST_EQ"
  fun op SETDIST_LE_DIST _ = ()
  val op SETDIST_LE_DIST = TDB.find "SETDIST_LE_DIST"
  fun op REAL_LE_SETDIST _ = ()
  val op REAL_LE_SETDIST = TDB.find "REAL_LE_SETDIST"
  fun op SETDIST_SUBSETS_EQ _ = ()
  val op SETDIST_SUBSETS_EQ = TDB.find "SETDIST_SUBSETS_EQ"
  fun op SETDIST_POS_LE _ = ()
  val op SETDIST_POS_LE = TDB.find "SETDIST_POS_LE"
  fun op SETDIST_EMPTY _ = ()
  val op SETDIST_EMPTY = TDB.find "SETDIST_EMPTY"
  fun op CLOSEST_POINT_IN_FRONTIER _ = ()
  val op CLOSEST_POINT_IN_FRONTIER = TDB.find "CLOSEST_POINT_IN_FRONTIER"
  fun op CLOSEST_POINT_IN_INTERIOR _ = ()
  val op CLOSEST_POINT_IN_INTERIOR = TDB.find "CLOSEST_POINT_IN_INTERIOR"
  fun op SEGMENT_TO_POINT_EXISTS _ = ()
  val op SEGMENT_TO_POINT_EXISTS = TDB.find "SEGMENT_TO_POINT_EXISTS"
  fun op SEGMENT_TO_CLOSEST_POINT _ = ()
  val op SEGMENT_TO_CLOSEST_POINT = TDB.find "SEGMENT_TO_CLOSEST_POINT"
  fun op UNIFORMLY_CONTINUOUS_ON_DIST_CLOSEST_POINT _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_DIST_CLOSEST_POINT = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_DIST_CLOSEST_POINT"
  fun op CONTINUOUS_ON_DIST_CLOSEST_POINT _ = ()
  val op CONTINUOUS_ON_DIST_CLOSEST_POINT = TDB.find
    "CONTINUOUS_ON_DIST_CLOSEST_POINT"
  fun op CONTINUOUS_AT_DIST_CLOSEST_POINT _ = ()
  val op CONTINUOUS_AT_DIST_CLOSEST_POINT = TDB.find
    "CONTINUOUS_AT_DIST_CLOSEST_POINT"
  fun op DIST_CLOSEST_POINT_LIPSCHITZ _ = ()
  val op DIST_CLOSEST_POINT_LIPSCHITZ = TDB.find
    "DIST_CLOSEST_POINT_LIPSCHITZ"
  fun op CLOSEST_POINT_REFL _ = ()
  val op CLOSEST_POINT_REFL = TDB.find "CLOSEST_POINT_REFL"
  fun op CLOSEST_POINT_SELF _ = ()
  val op CLOSEST_POINT_SELF = TDB.find "CLOSEST_POINT_SELF"
  fun op CLOSEST_POINT_LE _ = ()
  val op CLOSEST_POINT_LE = TDB.find "CLOSEST_POINT_LE"
  fun op CLOSEST_POINT_IN_SET _ = ()
  val op CLOSEST_POINT_IN_SET = TDB.find "CLOSEST_POINT_IN_SET"
  fun op CLOSEST_POINT_EXISTS _ = ()
  val op CLOSEST_POINT_EXISTS = TDB.find "CLOSEST_POINT_EXISTS"
  fun op DINI _ = () val op DINI = TDB.find "DINI"
  fun op BANACH_FIX _ = () val op BANACH_FIX = TDB.find "BANACH_FIX"
  fun op SUMMABLE_REARRANGE _ = ()
  val op SUMMABLE_REARRANGE = TDB.find "SUMMABLE_REARRANGE"
  fun op SERIES_REARRANGE _ = ()
  val op SERIES_REARRANGE = TDB.find "SERIES_REARRANGE"
  fun op SERIES_REARRANGE_EQ _ = ()
  val op SERIES_REARRANGE_EQ = TDB.find "SERIES_REARRANGE_EQ"
  fun op SERIES_INJECTIVE_IMAGE _ = ()
  val op SERIES_INJECTIVE_IMAGE = TDB.find "SERIES_INJECTIVE_IMAGE"
  fun op SERIES_INJECTIVE_IMAGE_STRONG _ = ()
  val op SERIES_INJECTIVE_IMAGE_STRONG = TDB.find
    "SERIES_INJECTIVE_IMAGE_STRONG"
  fun op SERIES_DIRICHLET _ = ()
  val op SERIES_DIRICHLET = TDB.find "SERIES_DIRICHLET"
  fun op SERIES_DIRICHLET_BILINEAR _ = ()
  val op SERIES_DIRICHLET_BILINEAR = TDB.find "SERIES_DIRICHLET_BILINEAR"
  fun op SUMMABLE_BILINEAR_PARTIAL_PRE _ = ()
  val op SUMMABLE_BILINEAR_PARTIAL_PRE = TDB.find
    "SUMMABLE_BILINEAR_PARTIAL_PRE"
  fun op BOUNDED_PARTIAL_SUMS _ = ()
  val op BOUNDED_PARTIAL_SUMS = TDB.find "BOUNDED_PARTIAL_SUMS"
  fun op SERIES_RATIO _ = () val op SERIES_RATIO = TDB.find "SERIES_RATIO"
  fun op SERIES_COMPARISON_UNIFORM _ = ()
  val op SERIES_COMPARISON_UNIFORM = TDB.find "SERIES_COMPARISON_UNIFORM"
  fun op SERIES_COMPARISON_BOUND _ = ()
  val op SERIES_COMPARISON_BOUND = TDB.find "SERIES_COMPARISON_BOUND"
  fun op SUMMABLE_SUBSET_ABSCONV _ = ()
  val op SUMMABLE_SUBSET_ABSCONV = TDB.find "SUMMABLE_SUBSET_ABSCONV"
  fun op SERIES_ABSCONV_IMP_CONV _ = ()
  val op SERIES_ABSCONV_IMP_CONV = TDB.find "SERIES_ABSCONV_IMP_CONV"
  fun op SUMMABLE_COMPARISON _ = ()
  val op SUMMABLE_COMPARISON = TDB.find "SUMMABLE_COMPARISON"
  fun op SERIES_COMPARISON _ = ()
  val op SERIES_COMPARISON = TDB.find "SERIES_COMPARISON"
  fun op SUMMABLE_IMP_SUMS_BOUNDED _ = ()
  val op SUMMABLE_IMP_SUMS_BOUNDED = TDB.find "SUMMABLE_IMP_SUMS_BOUNDED"
  fun op SUMMABLE_IMP_BOUNDED _ = ()
  val op SUMMABLE_IMP_BOUNDED = TDB.find "SUMMABLE_IMP_BOUNDED"
  fun op SUMMABLE_IMP_TOZERO _ = ()
  val op SUMMABLE_IMP_TOZERO = TDB.find "SUMMABLE_IMP_TOZERO"
  fun op SERIES_GOESTOZERO _ = ()
  val op SERIES_GOESTOZERO = TDB.find "SERIES_GOESTOZERO"
  fun op SERIES_CAUCHY_UNIFORM _ = ()
  val op SERIES_CAUCHY_UNIFORM = TDB.find "SERIES_CAUCHY_UNIFORM"
  fun op SUMMABLE_FROM_ELSEWHERE _ = ()
  val op SUMMABLE_FROM_ELSEWHERE = TDB.find "SUMMABLE_FROM_ELSEWHERE"
  fun op SUMMABLE_EQ_COFINITE _ = ()
  val op SUMMABLE_EQ_COFINITE = TDB.find "SUMMABLE_EQ_COFINITE"
  fun op SUMMABLE_IFF_COFINITE _ = ()
  val op SUMMABLE_IFF_COFINITE = TDB.find "SUMMABLE_IFF_COFINITE"
  fun op SUMMABLE_EQ_EVENTUALLY _ = ()
  val op SUMMABLE_EQ_EVENTUALLY = TDB.find "SUMMABLE_EQ_EVENTUALLY"
  fun op SUMMABLE_IFF_EVENTUALLY _ = ()
  val op SUMMABLE_IFF_EVENTUALLY = TDB.find "SUMMABLE_IFF_EVENTUALLY"
  fun op SUMMABLE_CAUCHY _ = ()
  val op SUMMABLE_CAUCHY = TDB.find "SUMMABLE_CAUCHY"
  fun op SERIES_CAUCHY _ = ()
  val op SERIES_CAUCHY = TDB.find "SERIES_CAUCHY"
  fun op ABS_SUM_TRIVIAL_LEMMA _ = ()
  val op ABS_SUM_TRIVIAL_LEMMA = TDB.find "ABS_SUM_TRIVIAL_LEMMA"
  fun op SUM_DIFF_LEMMA _ = ()
  val op SUM_DIFF_LEMMA = TDB.find "SUM_DIFF_LEMMA"
  fun op SEQUENCE_CAUCHY_WLOG _ = ()
  val op SEQUENCE_CAUCHY_WLOG = TDB.find "SEQUENCE_CAUCHY_WLOG"
  fun op PARTIAL_SUMS_DROP_LE_INFSUM _ = ()
  val op PARTIAL_SUMS_DROP_LE_INFSUM = TDB.find
    "PARTIAL_SUMS_DROP_LE_INFSUM"
  fun op PARTIAL_SUMS_COMPONENT_LE_INFSUM _ = ()
  val op PARTIAL_SUMS_COMPONENT_LE_INFSUM = TDB.find
    "PARTIAL_SUMS_COMPONENT_LE_INFSUM"
  fun op INFSUM_RESTRICT _ = ()
  val op INFSUM_RESTRICT = TDB.find "INFSUM_RESTRICT"
  fun op INFSUM_EQ _ = () val op INFSUM_EQ = TDB.find "INFSUM_EQ"
  fun op INFSUM_NEG _ = () val op INFSUM_NEG = TDB.find "INFSUM_NEG"
  fun op INFSUM_CMUL _ = () val op INFSUM_CMUL = TDB.find "INFSUM_CMUL"
  fun op INFSUM_SUB _ = () val op INFSUM_SUB = TDB.find "INFSUM_SUB"
  fun op INFSUM_ADD _ = () val op INFSUM_ADD = TDB.find "INFSUM_ADD"
  fun op INFSUM_0 _ = () val op INFSUM_0 = TDB.find "INFSUM_0"
  fun op INFSUM_LINEAR _ = ()
  val op INFSUM_LINEAR = TDB.find "INFSUM_LINEAR"
  fun op SERIES_BOUND _ = () val op SERIES_BOUND = TDB.find "SERIES_BOUND"
  fun op SERIES_DROP_POS _ = ()
  val op SERIES_DROP_POS = TDB.find "SERIES_DROP_POS"
  fun op SERIES_DROP_LE _ = ()
  val op SERIES_DROP_LE = TDB.find "SERIES_DROP_LE"
  fun op SUMMABLE_REINDEX _ = ()
  val op SUMMABLE_REINDEX = TDB.find "SUMMABLE_REINDEX"
  fun op SUMS_OFFSET_REV _ = ()
  val op SUMS_OFFSET_REV = TDB.find "SUMS_OFFSET_REV"
  fun op SUMS_OFFSET _ = () val op SUMS_OFFSET = TDB.find "SUMS_OFFSET"
  fun op SUMS_FINITE_UNION _ = ()
  val op SUMS_FINITE_UNION = TDB.find "SUMS_FINITE_UNION"
  fun op SUMS_FINITE_DIFF _ = ()
  val op SUMS_FINITE_DIFF = TDB.find "SUMS_FINITE_DIFF"
  fun op SUMMABLE_RESTRICT _ = ()
  val op SUMMABLE_RESTRICT = TDB.find "SUMMABLE_RESTRICT"
  fun op SUMMABLE_TRIVIAL _ = ()
  val op SUMMABLE_TRIVIAL = TDB.find "SUMMABLE_TRIVIAL"
  fun op SUMMABLE_SUBSET _ = ()
  val op SUMMABLE_SUBSET = TDB.find "SUMMABLE_SUBSET"
  fun op SERIES_SUBSET _ = ()
  val op SERIES_SUBSET = TDB.find "SERIES_SUBSET"
  fun op SUMMABLE_COMPONENT _ = ()
  val op SUMMABLE_COMPONENT = TDB.find "SUMMABLE_COMPONENT"
  fun op SUMMABLE_EQ _ = () val op SUMMABLE_EQ = TDB.find "SUMMABLE_EQ"
  fun op SUMMABLE_IFF _ = () val op SUMMABLE_IFF = TDB.find "SUMMABLE_IFF"
  fun op SUMMABLE_NEG _ = () val op SUMMABLE_NEG = TDB.find "SUMMABLE_NEG"
  fun op SUMMABLE_CMUL _ = ()
  val op SUMMABLE_CMUL = TDB.find "SUMMABLE_CMUL"
  fun op SUMMABLE_SUB _ = () val op SUMMABLE_SUB = TDB.find "SUMMABLE_SUB"
  fun op SUMMABLE_ADD _ = () val op SUMMABLE_ADD = TDB.find "SUMMABLE_ADD"
  fun op SUMMABLE_0 _ = () val op SUMMABLE_0 = TDB.find "SUMMABLE_0"
  fun op SUMMABLE_LINEAR _ = ()
  val op SUMMABLE_LINEAR = TDB.find "SUMMABLE_LINEAR"
  fun op SUMS_REINDEX_GEN _ = ()
  val op SUMS_REINDEX_GEN = TDB.find "SUMS_REINDEX_GEN"
  fun op SUMS_REINDEX _ = () val op SUMS_REINDEX = TDB.find "SUMS_REINDEX"
  fun op SERIES_SUM _ = () val op SERIES_SUM = TDB.find "SERIES_SUM"
  fun op SERIES_RESTRICT _ = ()
  val op SERIES_RESTRICT = TDB.find "SERIES_RESTRICT"
  fun op SERIES_TRIVIAL _ = ()
  val op SERIES_TRIVIAL = TDB.find "SERIES_TRIVIAL"
  fun op SERIES_DIFFS _ = () val op SERIES_DIFFS = TDB.find "SERIES_DIFFS"
  fun op SERIES_COMPONENT _ = ()
  val op SERIES_COMPONENT = TDB.find "SERIES_COMPONENT"
  fun op SERIES_FINITE_SUPPORT _ = ()
  val op SERIES_FINITE_SUPPORT = TDB.find "SERIES_FINITE_SUPPORT"
  fun op SUMS_0 _ = () val op SUMS_0 = TDB.find "SUMS_0"
  fun op SUMS_EQ _ = () val op SUMS_EQ = TDB.find "SUMS_EQ"
  fun op SUMS_IFF _ = () val op SUMS_IFF = TDB.find "SUMS_IFF"
  fun op SERIES_NEG _ = () val op SERIES_NEG = TDB.find "SERIES_NEG"
  fun op SERIES_CMUL _ = () val op SERIES_CMUL = TDB.find "SERIES_CMUL"
  fun op SERIES_SUB _ = () val op SERIES_SUB = TDB.find "SERIES_SUB"
  fun op SERIES_ADD _ = () val op SERIES_ADD = TDB.find "SERIES_ADD"
  fun op SERIES_0 _ = () val op SERIES_0 = TDB.find "SERIES_0"
  fun op SERIES_LINEAR _ = ()
  val op SERIES_LINEAR = TDB.find "SERIES_LINEAR"
  fun op SERIES_FINITE _ = ()
  val op SERIES_FINITE = TDB.find "SERIES_FINITE"
  fun op SERIES_TERMS_TOZERO _ = ()
  val op SERIES_TERMS_TOZERO = TDB.find "SERIES_TERMS_TOZERO"
  fun op INFSUM_UNIQUE _ = ()
  val op INFSUM_UNIQUE = TDB.find "INFSUM_UNIQUE"
  fun op SERIES_UNIQUE _ = ()
  val op SERIES_UNIQUE = TDB.find "SERIES_UNIQUE"
  fun op SERIES_FROM _ = () val op SERIES_FROM = TDB.find "SERIES_FROM"
  fun op FINITE_INTER_NUMSEG _ = ()
  val op FINITE_INTER_NUMSEG = TDB.find "FINITE_INTER_NUMSEG"
  fun op SUMS_LIM _ = () val op SUMS_LIM = TDB.find "SUMS_LIM"
  fun op SUMS_INFSUM _ = () val op SUMS_INFSUM = TDB.find "SUMS_INFSUM"
  fun op SUMS_SUMMABLE _ = ()
  val op SUMS_SUMMABLE = TDB.find "SUMS_SUMMABLE"
  fun op IMAGE_AFFINITY_INTERVAL _ = ()
  val op IMAGE_AFFINITY_INTERVAL = TDB.find "IMAGE_AFFINITY_INTERVAL"
  fun op REAL_EQ_AFFINITY _ = ()
  val op REAL_EQ_AFFINITY = TDB.find "REAL_EQ_AFFINITY"
  fun op REAL_AFFINITY_EQ _ = ()
  val op REAL_AFFINITY_EQ = TDB.find "REAL_AFFINITY_EQ"
  fun op REAL_LT_AFFINITY _ = ()
  val op REAL_LT_AFFINITY = TDB.find "REAL_LT_AFFINITY"
  fun op REAL_AFFINITY_LT _ = ()
  val op REAL_AFFINITY_LT = TDB.find "REAL_AFFINITY_LT"
  fun op REAL_LE_AFFINITY _ = ()
  val op REAL_LE_AFFINITY = TDB.find "REAL_LE_AFFINITY"
  fun op REAL_AFFINITY_LE _ = ()
  val op REAL_AFFINITY_LE = TDB.find "REAL_AFFINITY_LE"
  fun op AFFINITY_INVERSES _ = ()
  val op AFFINITY_INVERSES = TDB.find "AFFINITY_INVERSES"
  fun op DIM_SUBSTANDARD _ = ()
  val op DIM_SUBSTANDARD = TDB.find "DIM_SUBSTANDARD"
  fun op CLOSED_SUBSTANDARD _ = ()
  val op CLOSED_SUBSTANDARD = TDB.find "CLOSED_SUBSTANDARD"
  fun op SUBSPACE_SUBSTANDARD _ = ()
  val op SUBSPACE_SUBSTANDARD = TDB.find "SUBSPACE_SUBSTANDARD"
  fun op SYMMETRIC_CLOSURE _ = ()
  val op SYMMETRIC_CLOSURE = TDB.find "SYMMETRIC_CLOSURE"
  fun op CLOSURE_NEGATIONS _ = ()
  val op CLOSURE_NEGATIONS = TDB.find "CLOSURE_NEGATIONS"
  fun op SYMMETRIC_INTERIOR _ = ()
  val op SYMMETRIC_INTERIOR = TDB.find "SYMMETRIC_INTERIOR"
  fun op INTERIOR_NEGATIONS _ = ()
  val op INTERIOR_NEGATIONS = TDB.find "INTERIOR_NEGATIONS"
  fun op LIMPT_INJECTIVE_LINEAR_IMAGE_EQ _ = ()
  val op LIMPT_INJECTIVE_LINEAR_IMAGE_EQ = TDB.find
    "LIMPT_INJECTIVE_LINEAR_IMAGE_EQ"
  fun op COMPLETE_INJECTIVE_LINEAR_IMAGE_EQ _ = ()
  val op COMPLETE_INJECTIVE_LINEAR_IMAGE_EQ = TDB.find
    "COMPLETE_INJECTIVE_LINEAR_IMAGE_EQ"
  fun op COMPLETE_INJECTIVE_LINEAR_IMAGE _ = ()
  val op COMPLETE_INJECTIVE_LINEAR_IMAGE = TDB.find
    "COMPLETE_INJECTIVE_LINEAR_IMAGE"
  fun op INTERIOR_INJECTIVE_LINEAR_IMAGE _ = ()
  val op INTERIOR_INJECTIVE_LINEAR_IMAGE = TDB.find
    "INTERIOR_INJECTIVE_LINEAR_IMAGE"
  fun op LINEAR_OPEN_MAPPING _ = ()
  val op LINEAR_OPEN_MAPPING = TDB.find "LINEAR_OPEN_MAPPING"
  fun op IN_INTERIOR_LINEAR_IMAGE _ = ()
  val op IN_INTERIOR_LINEAR_IMAGE = TDB.find "IN_INTERIOR_LINEAR_IMAGE"
  fun op INTERIOR_BIJECTIVE_LINEAR_IMAGE _ = ()
  val op INTERIOR_BIJECTIVE_LINEAR_IMAGE = TDB.find
    "INTERIOR_BIJECTIVE_LINEAR_IMAGE"
  fun op LINEAR_IMAGE_SUBSET_INTERIOR _ = ()
  val op LINEAR_IMAGE_SUBSET_INTERIOR = TDB.find
    "LINEAR_IMAGE_SUBSET_INTERIOR"
  fun op LINEAR_INTERIOR_IMAGE_SUBSET _ = ()
  val op LINEAR_INTERIOR_IMAGE_SUBSET = TDB.find
    "LINEAR_INTERIOR_IMAGE_SUBSET"
  fun op CLOSURE_BOUNDED_LINEAR_IMAGE _ = ()
  val op CLOSURE_BOUNDED_LINEAR_IMAGE = TDB.find
    "CLOSURE_BOUNDED_LINEAR_IMAGE"
  fun op CLOSURE_INJECTIVE_LINEAR_IMAGE _ = ()
  val op CLOSURE_INJECTIVE_LINEAR_IMAGE = TDB.find
    "CLOSURE_INJECTIVE_LINEAR_IMAGE"
  fun op CLOSURE_LINEAR_IMAGE_SUBSET _ = ()
  val op CLOSURE_LINEAR_IMAGE_SUBSET = TDB.find
    "CLOSURE_LINEAR_IMAGE_SUBSET"
  fun op CLOSED_INJECTIVE_LINEAR_IMAGE_EQ _ = ()
  val op CLOSED_INJECTIVE_LINEAR_IMAGE_EQ = TDB.find
    "CLOSED_INJECTIVE_LINEAR_IMAGE_EQ"
  fun op CLOSED_INJECTIVE_LINEAR_IMAGE _ = ()
  val op CLOSED_INJECTIVE_LINEAR_IMAGE = TDB.find
    "CLOSED_INJECTIVE_LINEAR_IMAGE"
  fun op OPEN_BIJECTIVE_LINEAR_IMAGE_EQ _ = ()
  val op OPEN_BIJECTIVE_LINEAR_IMAGE_EQ = TDB.find
    "OPEN_BIJECTIVE_LINEAR_IMAGE_EQ"
  fun op OPEN_SURJECTIVE_LINEAR_IMAGE _ = ()
  val op OPEN_SURJECTIVE_LINEAR_IMAGE = TDB.find
    "OPEN_SURJECTIVE_LINEAR_IMAGE"
  fun op CLOSED_INJECTIVE_IMAGE_SUBSPACE _ = ()
  val op CLOSED_INJECTIVE_IMAGE_SUBSPACE = TDB.find
    "CLOSED_INJECTIVE_IMAGE_SUBSPACE"
  fun op INJECTIVE_IMP_ISOMETRIC _ = ()
  val op INJECTIVE_IMP_ISOMETRIC = TDB.find "INJECTIVE_IMP_ISOMETRIC"
  fun op COMPLETE_ISOMETRIC_IMAGE _ = ()
  val op COMPLETE_ISOMETRIC_IMAGE = TDB.find "COMPLETE_ISOMETRIC_IMAGE"
  fun op CAUCHY_ISOMETRIC _ = ()
  val op CAUCHY_ISOMETRIC = TDB.find "CAUCHY_ISOMETRIC"
  fun op HOMEOMORPHIC_STANDARD_HYPERPLANE_HYPERPLANE _ = ()
  val op HOMEOMORPHIC_STANDARD_HYPERPLANE_HYPERPLANE = TDB.find
    "HOMEOMORPHIC_STANDARD_HYPERPLANE_HYPERPLANE"
  fun op HOMEOMORPHIC_HYPERPLANE_STANDARD_HYPERPLANE _ = ()
  val op HOMEOMORPHIC_HYPERPLANE_STANDARD_HYPERPLANE = TDB.find
    "HOMEOMORPHIC_HYPERPLANE_STANDARD_HYPERPLANE"
  fun op HOMEOMORPHIC_HYPERPLANES _ = ()
  val op HOMEOMORPHIC_HYPERPLANES = TDB.find "HOMEOMORPHIC_HYPERPLANES"
  fun op CONTINUOUS_FINITE_RANGE_CONSTANT _ = ()
  val op CONTINUOUS_FINITE_RANGE_CONSTANT = TDB.find
    "CONTINUOUS_FINITE_RANGE_CONSTANT"
  fun op CONTINUOUS_DISCRETE_RANGE_CONSTANT _ = ()
  val op CONTINUOUS_DISCRETE_RANGE_CONSTANT = TDB.find
    "CONTINUOUS_DISCRETE_RANGE_CONSTANT"
  fun op CONTINUOUS_DISCONNECTED_RANGE_CONSTANT _ = ()
  val op CONTINUOUS_DISCONNECTED_RANGE_CONSTANT = TDB.find
    "CONTINUOUS_DISCONNECTED_RANGE_CONSTANT"
  fun op CONTINUOUS_FINITE_RANGE_CONSTANT_EQ _ = ()
  val op CONTINUOUS_FINITE_RANGE_CONSTANT_EQ = TDB.find
    "CONTINUOUS_FINITE_RANGE_CONSTANT_EQ"
  fun op CONTINUOUS_DISCRETE_RANGE_CONSTANT_EQ _ = ()
  val op CONTINUOUS_DISCRETE_RANGE_CONSTANT_EQ = TDB.find
    "CONTINUOUS_DISCRETE_RANGE_CONSTANT_EQ"
  fun op CONTINUOUS_DISCONNECTED_RANGE_CONSTANT_EQ _ = ()
  val op CONTINUOUS_DISCONNECTED_RANGE_CONSTANT_EQ = TDB.find
    "CONTINUOUS_DISCONNECTED_RANGE_CONSTANT_EQ"
  fun op CONTINUOUS_DISCONNECTED_DISCRETE_FINITE_RANGE_CONSTANT_EQ _ = ()
  val op CONTINUOUS_DISCONNECTED_DISCRETE_FINITE_RANGE_CONSTANT_EQ =
    TDB.find "CONTINUOUS_DISCONNECTED_DISCRETE_FINITE_RANGE_CONSTANT_EQ"
  fun op FINITE_BALL _ = () val op FINITE_BALL = TDB.find "FINITE_BALL"
  fun op FINITE_CBALL _ = () val op FINITE_CBALL = TDB.find "FINITE_CBALL"
  fun op EMPTY_INTERIOR_FINITE _ = ()
  val op EMPTY_INTERIOR_FINITE = TDB.find "EMPTY_INTERIOR_FINITE"
  fun op OPEN_IMP_INFINITE _ = ()
  val op OPEN_IMP_INFINITE = TDB.find "OPEN_IMP_INFINITE"
  fun op FINITE_IMP_NOT_OPEN _ = ()
  val op FINITE_IMP_NOT_OPEN = TDB.find "FINITE_IMP_NOT_OPEN"
  fun op CARD_EQ_CBALL _ = ()
  val op CARD_EQ_CBALL = TDB.find "CARD_EQ_CBALL"
  fun op CARD_EQ_BALL _ = () val op CARD_EQ_BALL = TDB.find "CARD_EQ_BALL"
  fun op UNCOUNTABLE_OPEN _ = ()
  val op UNCOUNTABLE_OPEN = TDB.find "UNCOUNTABLE_OPEN"
  fun op CARD_EQ_OPEN _ = () val op CARD_EQ_OPEN = TDB.find "CARD_EQ_OPEN"
  fun op COUNTABLE_OPEN_INTERVAL _ = ()
  val op COUNTABLE_OPEN_INTERVAL = TDB.find "COUNTABLE_OPEN_INTERVAL"
  fun op UNCOUNTABLE_INTERVAL _ = ()
  val op UNCOUNTABLE_INTERVAL = TDB.find "UNCOUNTABLE_INTERVAL"
  fun op CARD_EQ_INTERVAL _ = ()
  val op CARD_EQ_INTERVAL = TDB.find "CARD_EQ_INTERVAL"
  fun op UNCOUNTABLE_EUCLIDEAN _ = ()
  val op UNCOUNTABLE_EUCLIDEAN = TDB.find "UNCOUNTABLE_EUCLIDEAN"
  fun op CARD_EQ_EUCLIDEAN _ = ()
  val op CARD_EQ_EUCLIDEAN = TDB.find "CARD_EQ_EUCLIDEAN"
  fun op CARD_EQ_REAL_IMP_UNCOUNTABLE _ = ()
  val op CARD_EQ_REAL_IMP_UNCOUNTABLE = TDB.find
    "CARD_EQ_REAL_IMP_UNCOUNTABLE"
  fun op UNCOUNTABLE_REAL _ = ()
  val op UNCOUNTABLE_REAL = TDB.find "UNCOUNTABLE_REAL"
  fun op CARD_EQ_REAL _ = () val op CARD_EQ_REAL = TDB.find "CARD_EQ_REAL"
  fun op HOMEOMORPHIC_OPEN_INTERVAL_UNIV _ = ()
  val op HOMEOMORPHIC_OPEN_INTERVAL_UNIV = TDB.find
    "HOMEOMORPHIC_OPEN_INTERVAL_UNIV"
  fun op HOMEOMORPHIC_OPEN_INTERVALS _ = ()
  val op HOMEOMORPHIC_OPEN_INTERVALS = TDB.find
    "HOMEOMORPHIC_OPEN_INTERVALS"
  fun op HOMEOMORPHIC_ONE_POINT_COMPACTIFICATIONS _ = ()
  val op HOMEOMORPHIC_ONE_POINT_COMPACTIFICATIONS = TDB.find
    "HOMEOMORPHIC_ONE_POINT_COMPACTIFICATIONS"
  fun op HOMEOMORPHIC_SPHERE _ = ()
  val op HOMEOMORPHIC_SPHERE = TDB.find "HOMEOMORPHIC_SPHERE"
  fun op HOMEOMORPHIC_CBALL _ = ()
  val op HOMEOMORPHIC_CBALL = TDB.find "HOMEOMORPHIC_CBALL"
  fun op HOMEOMORPHIC_BALLS _ = ()
  val op HOMEOMORPHIC_BALLS = TDB.find "HOMEOMORPHIC_BALLS"
  fun op HOMEOMORPHIC_BALLS_CBALL_SPHERE _ = ()
  val op HOMEOMORPHIC_BALLS_CBALL_SPHERE = TDB.find
    "HOMEOMORPHIC_BALLS_CBALL_SPHERE"
  fun op HOMEOMORPHIC_AFFINITY _ = ()
  val op HOMEOMORPHIC_AFFINITY = TDB.find "HOMEOMORPHIC_AFFINITY"
  fun op HOMEOMORPHIC_TRANSLATION _ = ()
  val op HOMEOMORPHIC_TRANSLATION = TDB.find "HOMEOMORPHIC_TRANSLATION"
  fun op HOMEOMORPHIC_SCALING _ = ()
  val op HOMEOMORPHIC_SCALING = TDB.find "HOMEOMORPHIC_SCALING"
  fun op HOMEOMORPHIC_CONNECTEDNESS _ = ()
  val op HOMEOMORPHIC_CONNECTEDNESS = TDB.find "HOMEOMORPHIC_CONNECTEDNESS"
  fun op HOMEOMORPHIC_COMPACTNESS _ = ()
  val op HOMEOMORPHIC_COMPACTNESS = TDB.find "HOMEOMORPHIC_COMPACTNESS"
  fun op HOMEOMORPHISM_FROM_COMPOSITION_INJECTIVE _ = ()
  val op HOMEOMORPHISM_FROM_COMPOSITION_INJECTIVE = TDB.find
    "HOMEOMORPHISM_FROM_COMPOSITION_INJECTIVE"
  fun op HOMEOMORPHISM_FROM_COMPOSITION_SURJECTIVE _ = ()
  val op HOMEOMORPHISM_FROM_COMPOSITION_SURJECTIVE = TDB.find
    "HOMEOMORPHISM_FROM_COMPOSITION_SURJECTIVE"
  fun op HOMEOMORPHIC_COMPACT _ = ()
  val op HOMEOMORPHIC_COMPACT = TDB.find "HOMEOMORPHIC_COMPACT"
  fun op HOMEOMORPHISM_COMPACT _ = ()
  val op HOMEOMORPHISM_COMPACT = TDB.find "HOMEOMORPHISM_COMPACT"
  fun op CONTINUOUS_ON_INVERSE _ = ()
  val op CONTINUOUS_ON_INVERSE = TDB.find "CONTINUOUS_ON_INVERSE"
  fun op CONTINUOUS_IMP_QUOTIENT_MAP _ = ()
  val op CONTINUOUS_IMP_QUOTIENT_MAP = TDB.find
    "CONTINUOUS_IMP_QUOTIENT_MAP"
  fun op CONTINUOUS_IMP_CLOSED_MAP _ = ()
  val op CONTINUOUS_IMP_CLOSED_MAP = TDB.find "CONTINUOUS_IMP_CLOSED_MAP"
  fun op INJECTIVE_MAP_OPEN_IFF_CLOSED _ = ()
  val op INJECTIVE_MAP_OPEN_IFF_CLOSED = TDB.find
    "INJECTIVE_MAP_OPEN_IFF_CLOSED"
  fun op HOMEOMORPHISM_INJECTIVE_CLOSED_MAP_EQ _ = ()
  val op HOMEOMORPHISM_INJECTIVE_CLOSED_MAP_EQ = TDB.find
    "HOMEOMORPHISM_INJECTIVE_CLOSED_MAP_EQ"
  fun op HOMEOMORPHISM_INJECTIVE_OPEN_MAP_EQ _ = ()
  val op HOMEOMORPHISM_INJECTIVE_OPEN_MAP_EQ = TDB.find
    "HOMEOMORPHISM_INJECTIVE_OPEN_MAP_EQ"
  fun op HOMEOMORPHISM_IMP_CLOSED_MAP _ = ()
  val op HOMEOMORPHISM_IMP_CLOSED_MAP = TDB.find
    "HOMEOMORPHISM_IMP_CLOSED_MAP"
  fun op HOMEOMORPHISM_IMP_OPEN_MAP _ = ()
  val op HOMEOMORPHISM_IMP_OPEN_MAP = TDB.find "HOMEOMORPHISM_IMP_OPEN_MAP"
  fun op HOMEOMORPHISM_INJECTIVE_CLOSED_MAP _ = ()
  val op HOMEOMORPHISM_INJECTIVE_CLOSED_MAP = TDB.find
    "HOMEOMORPHISM_INJECTIVE_CLOSED_MAP"
  fun op HOMEOMORPHISM_INJECTIVE_OPEN_MAP _ = ()
  val op HOMEOMORPHISM_INJECTIVE_OPEN_MAP = TDB.find
    "HOMEOMORPHISM_INJECTIVE_OPEN_MAP"
  fun op CONTINUOUS_ON_INVERSE_CLOSED_MAP _ = ()
  val op CONTINUOUS_ON_INVERSE_CLOSED_MAP = TDB.find
    "CONTINUOUS_ON_INVERSE_CLOSED_MAP"
  fun op CONTINUOUS_ON_INVERSE_OPEN_MAP _ = ()
  val op CONTINUOUS_ON_INVERSE_OPEN_MAP = TDB.find
    "CONTINUOUS_ON_INVERSE_OPEN_MAP"
  fun op LIFT_TO_QUOTIENT_SPACE_UNIQUE _ = ()
  val op LIFT_TO_QUOTIENT_SPACE_UNIQUE = TDB.find
    "LIFT_TO_QUOTIENT_SPACE_UNIQUE"
  fun op HOMEOMORPHIC_SING _ = ()
  val op HOMEOMORPHIC_SING = TDB.find "HOMEOMORPHIC_SING"
  fun op HOMEOMORPHIC_FINITE_STRONG _ = ()
  val op HOMEOMORPHIC_FINITE_STRONG = TDB.find "HOMEOMORPHIC_FINITE_STRONG"
  fun op HOMEOMORPHIC_FINITE _ = ()
  val op HOMEOMORPHIC_FINITE = TDB.find "HOMEOMORPHIC_FINITE"
  fun op HOMEOMORPHIC_SCALING_RIGHT _ = ()
  val op HOMEOMORPHIC_SCALING_RIGHT = TDB.find "HOMEOMORPHIC_SCALING_RIGHT"
  fun op HOMEOMORPHIC_SCALING_LEFT _ = ()
  val op HOMEOMORPHIC_SCALING_LEFT = TDB.find "HOMEOMORPHIC_SCALING_LEFT"
  fun op HOMEOMORPHISM_IMP_QUOTIENT_MAP _ = ()
  val op HOMEOMORPHISM_IMP_QUOTIENT_MAP = TDB.find
    "HOMEOMORPHISM_IMP_QUOTIENT_MAP"
  fun op HOMEOMORPHIC_TRANSLATION_RIGHT_EQ _ = ()
  val op HOMEOMORPHIC_TRANSLATION_RIGHT_EQ = TDB.find
    "HOMEOMORPHIC_TRANSLATION_RIGHT_EQ"
  fun op HOMEOMORPHIC_TRANSLATION_LEFT_EQ _ = ()
  val op HOMEOMORPHIC_TRANSLATION_LEFT_EQ = TDB.find
    "HOMEOMORPHIC_TRANSLATION_LEFT_EQ"
  fun op HOMEOMORPHIC_TRANSLATION_SELF _ = ()
  val op HOMEOMORPHIC_TRANSLATION_SELF = TDB.find
    "HOMEOMORPHIC_TRANSLATION_SELF"
  fun op HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_RIGHT_EQ _ = ()
  val op HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_RIGHT_EQ = TDB.find
    "HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_RIGHT_EQ"
  fun op HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_LEFT_EQ _ = ()
  val op HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_LEFT_EQ = TDB.find
    "HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_LEFT_EQ"
  fun op HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_SELF _ = ()
  val op HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_SELF = TDB.find
    "HOMEOMORPHIC_INJECTIVE_LINEAR_IMAGE_SELF"
  fun op HOMEOMORPHIC_MINIMAL _ = ()
  val op HOMEOMORPHIC_MINIMAL = TDB.find "HOMEOMORPHIC_MINIMAL"
  fun op HOMEOMORPHIC_EMPTY _ = ()
  val op HOMEOMORPHIC_EMPTY = TDB.find "HOMEOMORPHIC_EMPTY"
  fun op HOMEOMORPHIC_FINITENESS _ = ()
  val op HOMEOMORPHIC_FINITENESS = TDB.find "HOMEOMORPHIC_FINITENESS"
  fun op HOMEOMORPHIC_IMP_CARD_EQ _ = ()
  val op HOMEOMORPHIC_IMP_CARD_EQ = TDB.find "HOMEOMORPHIC_IMP_CARD_EQ"
  fun op HOMEOMORPHIC_TRANS _ = ()
  val op HOMEOMORPHIC_TRANS = TDB.find "HOMEOMORPHIC_TRANS"
  fun op HOMEOMORPHISM_COMPOSE _ = ()
  val op HOMEOMORPHISM_COMPOSE = TDB.find "HOMEOMORPHISM_COMPOSE"
  fun op HOMEOMORPHIC_SYM _ = ()
  val op HOMEOMORPHIC_SYM = TDB.find "HOMEOMORPHIC_SYM"
  fun op HOMEOMORPHISM_SYM _ = ()
  val op HOMEOMORPHISM_SYM = TDB.find "HOMEOMORPHISM_SYM"
  fun op HOMEOMORPHIC_REFL _ = ()
  val op HOMEOMORPHIC_REFL = TDB.find "HOMEOMORPHIC_REFL"
  fun op HOMEOMORPHISM_ID _ = ()
  val op HOMEOMORPHISM_ID = TDB.find "HOMEOMORPHISM_ID"
  fun op HOMEOMORPHISM_OF_SUBSETS _ = ()
  val op HOMEOMORPHISM_OF_SUBSETS = TDB.find "HOMEOMORPHISM_OF_SUBSETS"
  fun op HOMEOMORPHISM _ = ()
  val op HOMEOMORPHISM = TDB.find "HOMEOMORPHISM"
  fun op BOUNDED_DECREASING_CONVERGENT _ = ()
  val op BOUNDED_DECREASING_CONVERGENT = TDB.find
    "BOUNDED_DECREASING_CONVERGENT"
  fun op BOUNDED_INCREASING_CONVERGENT _ = ()
  val op BOUNDED_INCREASING_CONVERGENT = TDB.find
    "BOUNDED_INCREASING_CONVERGENT"
  fun op MAPPING_CONNECTED_ONTO_SEGMENT _ = ()
  val op MAPPING_CONNECTED_ONTO_SEGMENT = TDB.find
    "MAPPING_CONNECTED_ONTO_SEGMENT"
  fun op CONNECTED_IVT_COMPONENT _ = ()
  val op CONNECTED_IVT_COMPONENT = TDB.find "CONNECTED_IVT_COMPONENT"
  fun op CONNECTED_IVT_HYPERPLANE _ = ()
  val op CONNECTED_IVT_HYPERPLANE = TDB.find "CONNECTED_IVT_HYPERPLANE"
  fun op EXTENSION_FROM_CLOPEN _ = ()
  val op EXTENSION_FROM_CLOPEN = TDB.find "EXTENSION_FROM_CLOPEN"
  fun op CONTINUOUS_ON_CASES_1 _ = ()
  val op CONTINUOUS_ON_CASES_1 = TDB.find "CONTINUOUS_ON_CASES_1"
  fun op CONTINUOUS_ON_CASES_LE _ = ()
  val op CONTINUOUS_ON_CASES_LE = TDB.find "CONTINUOUS_ON_CASES_LE"
  fun op CONTINUOUS_ON_CASES_LOCAL _ = ()
  val op CONTINUOUS_ON_CASES_LOCAL = TDB.find "CONTINUOUS_ON_CASES_LOCAL"
  fun op CONTINUOUS_ON_UNION_LOCAL _ = ()
  val op CONTINUOUS_ON_UNION_LOCAL = TDB.find "CONTINUOUS_ON_UNION_LOCAL"
  fun op CONTINUOUS_ON_CASES _ = ()
  val op CONTINUOUS_ON_CASES = TDB.find "CONTINUOUS_ON_CASES"
  fun op CONTINUOUS_ON_UNION _ = ()
  val op CONTINUOUS_ON_UNION = TDB.find "CONTINUOUS_ON_UNION"
  fun op LIM_WITHIN_UNION _ = ()
  val op LIM_WITHIN_UNION = TDB.find "LIM_WITHIN_UNION"
  fun op CONTINUOUS_MAP_CLOSURES _ = ()
  val op CONTINUOUS_MAP_CLOSURES = TDB.find "CONTINUOUS_MAP_CLOSURES"
  fun op CONTINUOUS_ON_CLOSURE_COMPONENT_GE _ = ()
  val op CONTINUOUS_ON_CLOSURE_COMPONENT_GE = TDB.find
    "CONTINUOUS_ON_CLOSURE_COMPONENT_GE"
  fun op CONTINUOUS_ON_CLOSURE_COMPONENT_LE _ = ()
  val op CONTINUOUS_ON_CLOSURE_COMPONENT_LE = TDB.find
    "CONTINUOUS_ON_CLOSURE_COMPONENT_LE"
  fun op CONTINUOUS_ON_CLOSURE_ABS_LE _ = ()
  val op CONTINUOUS_ON_CLOSURE_ABS_LE = TDB.find
    "CONTINUOUS_ON_CLOSURE_ABS_LE"
  fun op CLOSURE_IMAGE_BOUNDED _ = ()
  val op CLOSURE_IMAGE_BOUNDED = TDB.find "CLOSURE_IMAGE_BOUNDED"
  fun op CLOSURE_IMAGE_CLOSURE _ = ()
  val op CLOSURE_IMAGE_CLOSURE = TDB.find "CLOSURE_IMAGE_CLOSURE"
  fun op IMAGE_CLOSURE_SUBSET _ = ()
  val op IMAGE_CLOSURE_SUBSET = TDB.find "IMAGE_CLOSURE_SUBSET"
  fun op LIM_DROP_LBOUND _ = ()
  val op LIM_DROP_LBOUND = TDB.find "LIM_DROP_LBOUND"
  fun op LIM_DROP_UBOUND _ = ()
  val op LIM_DROP_UBOUND = TDB.find "LIM_DROP_UBOUND"
  fun op LIM_DROP_LE _ = () val op LIM_DROP_LE = TDB.find "LIM_DROP_LE"
  fun op LIM_COMPONENT_LE _ = ()
  val op LIM_COMPONENT_LE = TDB.find "LIM_COMPONENT_LE"
  fun op LIM_COMPONENT_EQ _ = ()
  val op LIM_COMPONENT_EQ = TDB.find "LIM_COMPONENT_EQ"
  fun op LIM_COMPONENT_LBOUND _ = ()
  val op LIM_COMPONENT_LBOUND = TDB.find "LIM_COMPONENT_LBOUND"
  fun op LIM_COMPONENT_UBOUND _ = ()
  val op LIM_COMPONENT_UBOUND = TDB.find "LIM_COMPONENT_UBOUND"
  fun op CARD_FRONTIER_INTERVAL _ = ()
  val op CARD_FRONTIER_INTERVAL = TDB.find "CARD_FRONTIER_INTERVAL"
  fun op IS_INTERVAL_SCALING_EQ _ = ()
  val op IS_INTERVAL_SCALING_EQ = TDB.find "IS_INTERVAL_SCALING_EQ"
  fun op IS_INTERVAL_SCALING _ = ()
  val op IS_INTERVAL_SCALING = TDB.find "IS_INTERVAL_SCALING"
  fun op IS_INTERVAL_SING _ = ()
  val op IS_INTERVAL_SING = TDB.find "IS_INTERVAL_SING"
  fun op INTERVAL_CONTAINS_COMPACT_NEIGHBOURHOOD _ = ()
  val op INTERVAL_CONTAINS_COMPACT_NEIGHBOURHOOD = TDB.find
    "INTERVAL_CONTAINS_COMPACT_NEIGHBOURHOOD"
  fun op INTERVAL_SUBSET_IS_INTERVAL _ = ()
  val op INTERVAL_SUBSET_IS_INTERVAL = TDB.find
    "INTERVAL_SUBSET_IS_INTERVAL"
  fun op IS_INTERVAL_INTER _ = ()
  val op IS_INTERVAL_INTER = TDB.find "IS_INTERVAL_INTER"
  fun op IS_INTERVAL_CASES _ = ()
  val op IS_INTERVAL_CASES = TDB.find "IS_INTERVAL_CASES"
  fun op IS_INTERVAL _ = () val op IS_INTERVAL = TDB.find "IS_INTERVAL"
  fun op IS_INTERVAL_COMPACT _ = ()
  val op IS_INTERVAL_COMPACT = TDB.find "IS_INTERVAL_COMPACT"
  fun op IS_INTERVAL_POINTWISE _ = ()
  val op IS_INTERVAL_POINTWISE = TDB.find "IS_INTERVAL_POINTWISE"
  fun op IS_INTERVAL_UNIV _ = ()
  val op IS_INTERVAL_UNIV = TDB.find "IS_INTERVAL_UNIV"
  fun op IS_INTERVAL_EMPTY _ = ()
  val op IS_INTERVAL_EMPTY = TDB.find "IS_INTERVAL_EMPTY"
  fun op IS_INTERVAL_INTERVAL _ = ()
  val op IS_INTERVAL_INTERVAL = TDB.find "IS_INTERVAL_INTERVAL"
  fun op SEGMENT_SCALAR_MULTIPLE _ = ()
  val op SEGMENT_SCALAR_MULTIPLE = TDB.find "SEGMENT_SCALAR_MULTIPLE"
  fun op OPEN_SEGMENT _ = () val op OPEN_SEGMENT = TDB.find "OPEN_SEGMENT"
  fun op SEGMENT _ = () val op SEGMENT = TDB.find "SEGMENT"
  fun op INTERVAL _ = () val op INTERVAL = TDB.find "INTERVAL"
  fun op CLOSED_DIFF_OPEN_INTERVAL _ = ()
  val op CLOSED_DIFF_OPEN_INTERVAL = TDB.find "CLOSED_DIFF_OPEN_INTERVAL"
  fun op CBALL_INTERVAL_0 _ = ()
  val op CBALL_INTERVAL_0 = TDB.find "CBALL_INTERVAL_0"
  fun op BALL_INTERVAL_0 _ = ()
  val op BALL_INTERVAL_0 = TDB.find "BALL_INTERVAL_0"
  fun op CBALL_INTERVAL _ = ()
  val op CBALL_INTERVAL = TDB.find "CBALL_INTERVAL"
  fun op BALL_INTERVAL _ = ()
  val op BALL_INTERVAL = TDB.find "BALL_INTERVAL"
  fun op FINITE_INTERVAL _ = ()
  val op FINITE_INTERVAL = TDB.find "FINITE_INTERVAL"
  fun op FINITE_SPHERE _ = ()
  val op FINITE_SPHERE = TDB.find "FINITE_SPHERE"
  fun op SPHERE _ = () val op SPHERE = TDB.find "SPHERE"
  fun op BALL _ = () val op BALL = TDB.find "BALL"
  fun op CLOSED_OPEN_INTERVAL _ = ()
  val op CLOSED_OPEN_INTERVAL = TDB.find "CLOSED_OPEN_INTERVAL"
  fun op OPEN_CLOSED_INTERVAL _ = ()
  val op OPEN_CLOSED_INTERVAL = TDB.find "OPEN_CLOSED_INTERVAL"
  fun op INTERVAL_CASES _ = ()
  val op INTERVAL_CASES = TDB.find "INTERVAL_CASES"
  fun op EQ_BALLS _ = () val op EQ_BALLS = TDB.find "EQ_BALLS"
  fun op COMPACT_INTERVAL_EQ _ = ()
  val op COMPACT_INTERVAL_EQ = TDB.find "COMPACT_INTERVAL_EQ"
  fun op OPEN_INTERVAL_EQ _ = ()
  val op OPEN_INTERVAL_EQ = TDB.find "OPEN_INTERVAL_EQ"
  fun op CLOSED_INTERVAL_EQ _ = ()
  val op CLOSED_INTERVAL_EQ = TDB.find "CLOSED_INTERVAL_EQ"
  fun op EQ_INTERVAL _ = () val op EQ_INTERVAL = TDB.find "EQ_INTERVAL"
  fun op IMAGE_TWIZZLE_INTERVAL _ = ()
  val op IMAGE_TWIZZLE_INTERVAL = TDB.find "IMAGE_TWIZZLE_INTERVAL"
  fun op DIAMETER_INTERVAL _ = ()
  val op DIAMETER_INTERVAL = TDB.find "DIAMETER_INTERVAL"
  fun op OPEN_CONTAINS_OPEN_INTERVAL _ = ()
  val op OPEN_CONTAINS_OPEN_INTERVAL = TDB.find
    "OPEN_CONTAINS_OPEN_INTERVAL"
  fun op OPEN_CONTAINS_INTERVAL _ = ()
  val op OPEN_CONTAINS_INTERVAL = TDB.find "OPEN_CONTAINS_INTERVAL"
  fun op OPEN_CONTAINS_INTERVAL_OPEN_INTERVAL _ = ()
  val op OPEN_CONTAINS_INTERVAL_OPEN_INTERVAL = TDB.find
    "OPEN_CONTAINS_INTERVAL_OPEN_INTERVAL"
  fun op SUMS_INTERVALS _ = ()
  val op SUMS_INTERVALS = TDB.find "SUMS_INTERVALS"
  fun op CLOSED_INTERVAL_IMAGE_UNIT_INTERVAL _ = ()
  val op CLOSED_INTERVAL_IMAGE_UNIT_INTERVAL = TDB.find
    "CLOSED_INTERVAL_IMAGE_UNIT_INTERVAL"
  fun op INTERVAL_IMAGE_STRETCH_INTERVAL _ = ()
  val op INTERVAL_IMAGE_STRETCH_INTERVAL = TDB.find
    "INTERVAL_IMAGE_STRETCH_INTERVAL"
  fun op IMAGE_STRETCH_INTERVAL _ = ()
  val op IMAGE_STRETCH_INTERVAL = TDB.find "IMAGE_STRETCH_INTERVAL"
  fun op UNIT_INTERVAL_NONEMPTY _ = ()
  val op UNIT_INTERVAL_NONEMPTY = TDB.find "UNIT_INTERVAL_NONEMPTY"
  fun op EMPTY_AS_INTERVAL _ = ()
  val op EMPTY_AS_INTERVAL = TDB.find "EMPTY_AS_INTERVAL"
  fun op INTERVAL_TRANSLATION _ = ()
  val op INTERVAL_TRANSLATION = TDB.find "INTERVAL_TRANSLATION"
  fun op INTER_INTERVAL_MIXED_EQ_EMPTY _ = ()
  val op INTER_INTERVAL_MIXED_EQ_EMPTY = TDB.find
    "INTER_INTERVAL_MIXED_EQ_EMPTY"
  fun op FRONTIER_OPEN_INTERVAL _ = ()
  val op FRONTIER_OPEN_INTERVAL = TDB.find "FRONTIER_OPEN_INTERVAL"
  fun op FRONTIER_CLOSED_INTERVAL _ = ()
  val op FRONTIER_CLOSED_INTERVAL = TDB.find "FRONTIER_CLOSED_INTERVAL"
  fun op BOUNDED_SUBSET_CLOSED_INTERVAL _ = ()
  val op BOUNDED_SUBSET_CLOSED_INTERVAL = TDB.find
    "BOUNDED_SUBSET_CLOSED_INTERVAL"
  fun op BOUNDED_SUBSET_CLOSED_INTERVAL_SYMMETRIC _ = ()
  val op BOUNDED_SUBSET_CLOSED_INTERVAL_SYMMETRIC = TDB.find
    "BOUNDED_SUBSET_CLOSED_INTERVAL_SYMMETRIC"
  fun op BOUNDED_SUBSET_OPEN_INTERVAL _ = ()
  val op BOUNDED_SUBSET_OPEN_INTERVAL = TDB.find
    "BOUNDED_SUBSET_OPEN_INTERVAL"
  fun op BOUNDED_SUBSET_OPEN_INTERVAL_SYMMETRIC _ = ()
  val op BOUNDED_SUBSET_OPEN_INTERVAL_SYMMETRIC = TDB.find
    "BOUNDED_SUBSET_OPEN_INTERVAL_SYMMETRIC"
  fun op CLOSURE_INTERVAL _ = ()
  val op CLOSURE_INTERVAL = TDB.find "CLOSURE_INTERVAL"
  fun op CLOSURE_OPEN_INTERVAL _ = ()
  val op CLOSURE_OPEN_INTERVAL = TDB.find "CLOSURE_OPEN_INTERVAL"
  fun op REAL_INV_LE_1 _ = ()
  val op REAL_INV_LE_1 = TDB.find "REAL_INV_LE_1"
  fun op REAL_LE_INV2 _ = () val op REAL_LE_INV2 = TDB.find "REAL_LE_INV2"
  fun op REAL_LT_INV2 _ = () val op REAL_LT_INV2 = TDB.find "REAL_LT_INV2"
  fun op REAL_POW_LE_1 _ = ()
  val op REAL_POW_LE_1 = TDB.find "REAL_POW_LE_1"
  fun op REAL_POW_1_LE _ = ()
  val op REAL_POW_1_LE = TDB.find "REAL_POW_1_LE"
  fun op BIGUNION_BIGINTER _ = ()
  val op BIGUNION_BIGINTER = TDB.find "BIGUNION_BIGINTER"
  fun op BIGINTER_BIGUNION _ = ()
  val op BIGINTER_BIGUNION = TDB.find "BIGINTER_BIGUNION"
  fun op DIFF_BIGINTER _ = ()
  val op DIFF_BIGINTER = TDB.find "DIFF_BIGINTER"
  fun op SUBSET_ANTISYM_EQ _ = ()
  val op SUBSET_ANTISYM_EQ = TDB.find "SUBSET_ANTISYM_EQ"
  fun op FUN_IN_IMAGE _ = () val op FUN_IN_IMAGE = TDB.find "FUN_IN_IMAGE"
  fun op REAL_LT_POW2 _ = () val op REAL_LT_POW2 = TDB.find "REAL_LT_POW2"
  fun op SUBSET_BIGUNION _ = ()
  val op SUBSET_BIGUNION = TDB.find "SUBSET_BIGUNION"
  fun op SIMPLE_IMAGE_GEN _ = ()
  val op SIMPLE_IMAGE_GEN = TDB.find "SIMPLE_IMAGE_GEN"
  fun op REAL_LT_LCANCEL_IMP _ = ()
  val op REAL_LT_LCANCEL_IMP = TDB.find "REAL_LT_LCANCEL_IMP"
  fun op POWERSET_CLAUSES _ = ()
  val op POWERSET_CLAUSES = TDB.find "POWERSET_CLAUSES"
  fun op REAL_OF_NUM_GE _ = ()
  val op REAL_OF_NUM_GE = TDB.find "REAL_OF_NUM_GE"
  fun op ABS_LE_0 _ = () val op ABS_LE_0 = TDB.find "ABS_LE_0"
  fun op NOT_EQ _ = () val op NOT_EQ = TDB.find "NOT_EQ"
  fun op LAMBDA_PAIR _ = () val op LAMBDA_PAIR = TDB.find "LAMBDA_PAIR"
  fun op TRANSITIVE_STEPWISE_LE _ = ()
  val op TRANSITIVE_STEPWISE_LE = TDB.find "TRANSITIVE_STEPWISE_LE"
  fun op TRANSITIVE_STEPWISE_LE_EQ _ = ()
  val op TRANSITIVE_STEPWISE_LE_EQ = TDB.find "TRANSITIVE_STEPWISE_LE_EQ"
  fun op ADD_SUBR _ = () val op ADD_SUBR = TDB.find "ADD_SUBR"
  fun op ADD_SUBR2 _ = () val op ADD_SUBR2 = TDB.find "ADD_SUBR2"
  fun op ADD_SUB2 _ = () val op ADD_SUB2 = TDB.find "ADD_SUB2"
  fun op LE_ADDR _ = () val op LE_ADDR = TDB.find "LE_ADDR"
  fun op LE_ADD _ = () val op LE_ADD = TDB.find "LE_ADD"
  fun op FINITE_POWERSET _ = ()
  val op FINITE_POWERSET = TDB.find "FINITE_POWERSET"
  fun op LINEAR_INJECTIVE_BOUNDED_BELOW_POS _ = ()
  val op LINEAR_INJECTIVE_BOUNDED_BELOW_POS = TDB.find
    "LINEAR_INJECTIVE_BOUNDED_BELOW_POS"
  fun op LINEAR_INVERTIBLE_BOUNDED_BELOW _ = ()
  val op LINEAR_INVERTIBLE_BOUNDED_BELOW = TDB.find
    "LINEAR_INVERTIBLE_BOUNDED_BELOW"
  fun op LINEAR_INVERTIBLE_BOUNDED_BELOW_POS _ = ()
  val op LINEAR_INVERTIBLE_BOUNDED_BELOW_POS = TDB.find
    "LINEAR_INVERTIBLE_BOUNDED_BELOW_POS"
  fun op LINEAR_INJECTIVE_IMP_SURJECTIVE _ = ()
  val op LINEAR_INJECTIVE_IMP_SURJECTIVE = TDB.find
    "LINEAR_INJECTIVE_IMP_SURJECTIVE"
  fun op SPAN_LINEAR_IMAGE _ = ()
  val op SPAN_LINEAR_IMAGE = TDB.find "SPAN_LINEAR_IMAGE"
  fun op INDEPENDENT_INJECTIVE_IMAGE _ = ()
  val op INDEPENDENT_INJECTIVE_IMAGE = TDB.find
    "INDEPENDENT_INJECTIVE_IMAGE"
  fun op INDEPENDENT_INJECTIVE_IMAGE_GEN _ = ()
  val op INDEPENDENT_INJECTIVE_IMAGE_GEN = TDB.find
    "INDEPENDENT_INJECTIVE_IMAGE_GEN"
  fun op DEPENDENT_EXPLICIT _ = ()
  val op DEPENDENT_EXPLICIT = TDB.find "DEPENDENT_EXPLICIT"
  fun op SPAN_EXPLICIT _ = ()
  val op SPAN_EXPLICIT = TDB.find "SPAN_EXPLICIT"
  fun op CARD_GE_DIM_INDEPENDENT _ = ()
  val op CARD_GE_DIM_INDEPENDENT = TDB.find "CARD_GE_DIM_INDEPENDENT"
  fun op INDEPENDENT_INSERT _ = ()
  val op INDEPENDENT_INSERT = TDB.find "INDEPENDENT_INSERT"
  fun op IN_SPAN_INSERT _ = ()
  val op IN_SPAN_INSERT = TDB.find "IN_SPAN_INSERT"
  fun op SPAN_BREAKDOWN _ = ()
  val op SPAN_BREAKDOWN = TDB.find "SPAN_BREAKDOWN"
  fun op INDEPENDENT_MONO _ = ()
  val op INDEPENDENT_MONO = TDB.find "INDEPENDENT_MONO"
  fun op INDEPENDENT_NONZERO _ = ()
  val op INDEPENDENT_NONZERO = TDB.find "INDEPENDENT_NONZERO"
  fun op MIDPOINT_COLLINEAR _ = ()
  val op MIDPOINT_COLLINEAR = TDB.find "MIDPOINT_COLLINEAR"
  fun op COLLINEAR_MIDPOINT _ = ()
  val op COLLINEAR_MIDPOINT = TDB.find "COLLINEAR_MIDPOINT"
  fun op MIDPOINT_LINEAR_IMAGE _ = ()
  val op MIDPOINT_LINEAR_IMAGE = TDB.find "MIDPOINT_LINEAR_IMAGE"
  fun op BETWEEN_MIDPOINT _ = ()
  val op BETWEEN_MIDPOINT = TDB.find "BETWEEN_MIDPOINT"
  fun op MIDPOINT_EQ_ENDPOINT _ = ()
  val op MIDPOINT_EQ_ENDPOINT = TDB.find "MIDPOINT_EQ_ENDPOINT"
  fun op DIST_MIDPOINT _ = ()
  val op DIST_MIDPOINT = TDB.find "DIST_MIDPOINT"
  fun op MIDPOINT_SYM _ = () val op MIDPOINT_SYM = TDB.find "MIDPOINT_SYM"
  fun op MIDPOINT_REFL _ = ()
  val op MIDPOINT_REFL = TDB.find "MIDPOINT_REFL"
  fun op COLLINEAR_1 _ = () val op COLLINEAR_1 = TDB.find "COLLINEAR_1"
  fun op COLLINEAR_DIST_BETWEEN _ = ()
  val op COLLINEAR_DIST_BETWEEN = TDB.find "COLLINEAR_DIST_BETWEEN"
  fun op COLLINEAR_BETWEEN_CASES _ = ()
  val op COLLINEAR_BETWEEN_CASES = TDB.find "COLLINEAR_BETWEEN_CASES"
  fun op BETWEEN_IMP_COLLINEAR _ = ()
  val op BETWEEN_IMP_COLLINEAR = TDB.find "BETWEEN_IMP_COLLINEAR"
  fun op BETWEEN_ABS _ = () val op BETWEEN_ABS = TDB.find "BETWEEN_ABS"
  fun op BETWEEN_TRANS_2 _ = ()
  val op BETWEEN_TRANS_2 = TDB.find "BETWEEN_TRANS_2"
  fun op BETWEEN_TRANS _ = ()
  val op BETWEEN_TRANS = TDB.find "BETWEEN_TRANS"
  fun op BETWEEN_ANTISYM _ = ()
  val op BETWEEN_ANTISYM = TDB.find "BETWEEN_ANTISYM"
  fun op BETWEEN_SYM _ = () val op BETWEEN_SYM = TDB.find "BETWEEN_SYM"
  fun op BETWEEN_REFL_EQ _ = ()
  val op BETWEEN_REFL_EQ = TDB.find "BETWEEN_REFL_EQ"
  fun op BETWEEN_REFL _ = () val op BETWEEN_REFL = TDB.find "BETWEEN_REFL"
  fun op COLLINEAR_3_TRANS _ = ()
  val op COLLINEAR_3_TRANS = TDB.find "COLLINEAR_3_TRANS"
  fun op COLLINEAR_4_3 _ = ()
  val op COLLINEAR_4_3 = TDB.find "COLLINEAR_4_3"
  fun op COLLINEAR_TRIPLES _ = ()
  val op COLLINEAR_TRIPLES = TDB.find "COLLINEAR_TRIPLES"
  fun op COLLINEAR_3_EXPAND _ = ()
  val op COLLINEAR_3_EXPAND = TDB.find "COLLINEAR_3_EXPAND"
  fun op MUL_CAUCHY_SCHWARZ_EQUAL _ = ()
  val op MUL_CAUCHY_SCHWARZ_EQUAL = TDB.find "MUL_CAUCHY_SCHWARZ_EQUAL"
  fun op ABS_CAUCHY_SCHWARZ_EQUAL _ = ()
  val op ABS_CAUCHY_SCHWARZ_EQUAL = TDB.find "ABS_CAUCHY_SCHWARZ_EQUAL"
  fun op COLLINEAR_LEMMA_ALT _ = ()
  val op COLLINEAR_LEMMA_ALT = TDB.find "COLLINEAR_LEMMA_ALT"
  fun op COLLINEAR_LEMMA _ = ()
  val op COLLINEAR_LEMMA = TDB.find "COLLINEAR_LEMMA"
  fun op COLLINEAR_3 _ = () val op COLLINEAR_3 = TDB.find "COLLINEAR_3"
  fun op COLLINEAR_SMALL _ = ()
  val op COLLINEAR_SMALL = TDB.find "COLLINEAR_SMALL"
  fun op COLLINEAR_2 _ = () val op COLLINEAR_2 = TDB.find "COLLINEAR_2"
  fun op COLLINEAR_SING _ = ()
  val op COLLINEAR_SING = TDB.find "COLLINEAR_SING"
  fun op COLLINEAR_EMPTY _ = ()
  val op COLLINEAR_EMPTY = TDB.find "COLLINEAR_EMPTY"
  fun op COLLINEAR_SUBSET _ = ()
  val op COLLINEAR_SUBSET = TDB.find "COLLINEAR_SUBSET"
  fun op DIST_TRIANGLE_EQ _ = ()
  val op DIST_TRIANGLE_EQ = TDB.find "DIST_TRIANGLE_EQ"
  fun op ABS_TRIANGLE_EQ _ = ()
  val op ABS_TRIANGLE_EQ = TDB.find "ABS_TRIANGLE_EQ"
  fun op REAL_EQ_RINV _ = () val op REAL_EQ_RINV = TDB.find "REAL_EQ_RINV"
  fun op REAL_EQ_LINV _ = () val op REAL_EQ_LINV = TDB.find "REAL_EQ_LINV"
  fun op ABS_CAUCHY_SCHWARZ_ABS_EQ _ = ()
  val op ABS_CAUCHY_SCHWARZ_ABS_EQ = TDB.find "ABS_CAUCHY_SCHWARZ_ABS_EQ"
  fun op ABS_CAUCHY_SCHWARZ_EQ _ = ()
  val op ABS_CAUCHY_SCHWARZ_EQ = TDB.find "ABS_CAUCHY_SCHWARZ_EQ"
  fun op SPAN_UNION _ = () val op SPAN_UNION = TDB.find "SPAN_UNION"
  fun op SUBSPACE_SUMS _ = ()
  val op SUBSPACE_SUMS = TDB.find "SUBSPACE_SUMS"
  fun op SUBSPACE_TRANSLATION_SELF_EQ _ = ()
  val op SUBSPACE_TRANSLATION_SELF_EQ = TDB.find
    "SUBSPACE_TRANSLATION_SELF_EQ"
  fun op SUBSPACE_TRANSLATION_SELF _ = ()
  val op SUBSPACE_TRANSLATION_SELF = TDB.find "SUBSPACE_TRANSLATION_SELF"
  fun op SURJECTIVE_IMAGE_EQ _ = ()
  val op SURJECTIVE_IMAGE_EQ = TDB.find "SURJECTIVE_IMAGE_EQ"
  fun op SPAN_SUBSET_SUBSPACE _ = ()
  val op SPAN_SUBSET_SUBSPACE = TDB.find "SPAN_SUBSET_SUBSPACE"
  fun op SPAN_EQ_SELF _ = () val op SPAN_EQ_SELF = TDB.find "SPAN_EQ_SELF"
  fun op SPAN_ADD_EQ _ = () val op SPAN_ADD_EQ = TDB.find "SPAN_ADD_EQ"
  fun op SPAN_SUM _ = () val op SPAN_SUM = TDB.find "SPAN_SUM"
  fun op SPAN_SUB _ = () val op SPAN_SUB = TDB.find "SPAN_SUB"
  fun op SPAN_NEG_EQ _ = () val op SPAN_NEG_EQ = TDB.find "SPAN_NEG_EQ"
  fun op SPAN_NEG _ = () val op SPAN_NEG = TDB.find "SPAN_NEG"
  fun op SPAN_MUL_EQ _ = () val op SPAN_MUL_EQ = TDB.find "SPAN_MUL_EQ"
  fun op SPAN_MUL _ = () val op SPAN_MUL = TDB.find "SPAN_MUL"
  fun op SPAN_ADD _ = () val op SPAN_ADD = TDB.find "SPAN_ADD"
  fun op SPAN_0 _ = () val op SPAN_0 = TDB.find "SPAN_0"
  fun op SPAN_UNIV _ = () val op SPAN_UNIV = TDB.find "SPAN_UNIV"
  fun op SPAN_UNION_SUBSET _ = ()
  val op SPAN_UNION_SUBSET = TDB.find "SPAN_UNION_SUBSET"
  fun op SPAN_INC _ = () val op SPAN_INC = TDB.find "SPAN_INC"
  fun op SPAN_SUPERSET _ = ()
  val op SPAN_SUPERSET = TDB.find "SPAN_SUPERSET"
  fun op SPAN_INDUCT_ALT _ = ()
  val op SPAN_INDUCT_ALT = TDB.find "SPAN_INDUCT_ALT"
  fun op SPAN_SUBSPACE _ = ()
  val op SPAN_SUBSPACE = TDB.find "SPAN_SUBSPACE"
  fun op DEPENDENT_MONO _ = ()
  val op DEPENDENT_MONO = TDB.find "DEPENDENT_MONO"
  fun op REAL_LE_SQUARE_ABS _ = ()
  val op REAL_LE_SQUARE_ABS = TDB.find "REAL_LE_SQUARE_ABS"
  fun op REAL_EQ_SQUARE_ABS _ = ()
  val op REAL_EQ_SQUARE_ABS = TDB.find "REAL_EQ_SQUARE_ABS"
  fun op REAL_HALF _ = () val op REAL_HALF = TDB.find "REAL_HALF"
  fun op FINITE_SUBSET_IMAGE _ = ()
  val op FINITE_SUBSET_IMAGE = TDB.find "FINITE_SUBSET_IMAGE"
  fun op EXISTS_FINITE_SUBSET_IMAGE _ = ()
  val op EXISTS_FINITE_SUBSET_IMAGE = TDB.find "EXISTS_FINITE_SUBSET_IMAGE"
  fun op FORALL_FINITE_SUBSET_IMAGE _ = ()
  val op FORALL_FINITE_SUBSET_IMAGE = TDB.find "FORALL_FINITE_SUBSET_IMAGE"
  fun op FORALL_IN_GSPEC _ = ()
  val op FORALL_IN_GSPEC = TDB.find "FORALL_IN_GSPEC"
  fun op EXISTS_IN_GSPEC _ = ()
  val op EXISTS_IN_GSPEC = TDB.find "EXISTS_IN_GSPEC"
  fun op EMPTY_BIGUNION _ = ()
  val op EMPTY_BIGUNION = TDB.find "EMPTY_BIGUNION"
  fun op UPPER_BOUND_FINITE_SET _ = ()
  val op UPPER_BOUND_FINITE_SET = TDB.find "UPPER_BOUND_FINITE_SET"
  fun op REAL_BOUNDS_LT _ = ()
  val op REAL_BOUNDS_LT = TDB.find "REAL_BOUNDS_LT"
  fun op BIGUNION_IMAGE _ = ()
  val op BIGUNION_IMAGE = TDB.find "BIGUNION_IMAGE"
  fun op BIGINTER_IMAGE _ = ()
  val op BIGINTER_IMAGE = TDB.find "BIGINTER_IMAGE"
  fun op REAL_LE_LMUL1 _ = ()
  val op REAL_LE_LMUL1 = TDB.find "REAL_LE_LMUL1"
  fun op LE_EXISTS _ = () val op LE_EXISTS = TDB.find "LE_EXISTS"
  fun op LT_EXISTS _ = () val op LT_EXISTS = TDB.find "LT_EXISTS"
  fun op TRANSITIVE_STEPWISE_LT_EQ _ = ()
  val op TRANSITIVE_STEPWISE_LT_EQ = TDB.find "TRANSITIVE_STEPWISE_LT_EQ"
  fun op TRANSITIVE_STEPWISE_LT _ = ()
  val op TRANSITIVE_STEPWISE_LT = TDB.find "TRANSITIVE_STEPWISE_LT"
  fun op LIMPT_SEQUENTIAL_INJ _ = ()
  val op LIMPT_SEQUENTIAL_INJ = TDB.find "LIMPT_SEQUENTIAL_INJ"
  fun op LIMPT_SEQUENTIAL _ = ()
  val op LIMPT_SEQUENTIAL = TDB.find "LIMPT_SEQUENTIAL"
  fun op INFINITE_SUPERSET _ = ()
  val op INFINITE_SUPERSET = TDB.find "INFINITE_SUPERSET"
  fun op LIMPT_INFINITE_OPEN_BALL_CBALL _ = ()
  val op LIMPT_INFINITE_OPEN_BALL_CBALL = TDB.find
    "LIMPT_INFINITE_OPEN_BALL_CBALL"
  fun op LIMPT_INFINITE_OPEN _ = ()
  val op LIMPT_INFINITE_OPEN = TDB.find "LIMPT_INFINITE_OPEN"
  fun op LIMPT_INFINITE_BALL _ = ()
  val op LIMPT_INFINITE_BALL = TDB.find "LIMPT_INFINITE_BALL"
  fun op LIMPT_INFINITE_CBALL _ = ()
  val op LIMPT_INFINITE_CBALL = TDB.find "LIMPT_INFINITE_CBALL"
  fun op INFINITE_OPEN_IN _ = ()
  val op INFINITE_OPEN_IN = TDB.find "INFINITE_OPEN_IN"
  fun op CONDENSATION_POINT_OF_SUBSET _ = ()
  val op CONDENSATION_POINT_OF_SUBSET = TDB.find
    "CONDENSATION_POINT_OF_SUBSET"
  fun op CONDENSATION_POINT_IMP_LIMPT _ = ()
  val op CONDENSATION_POINT_IMP_LIMPT = TDB.find
    "CONDENSATION_POINT_IMP_LIMPT"
  fun op CONDENSATION_POINT_INFINITE_BALL_CBALL _ = ()
  val op CONDENSATION_POINT_INFINITE_BALL_CBALL = TDB.find
    "CONDENSATION_POINT_INFINITE_BALL_CBALL"
  fun op CONDENSATION_POINT_INFINITE_BALL _ = ()
  val op CONDENSATION_POINT_INFINITE_BALL = TDB.find
    "CONDENSATION_POINT_INFINITE_BALL"
  fun op CONDENSATION_POINT_INFINITE_CBALL _ = ()
  val op CONDENSATION_POINT_INFINITE_CBALL = TDB.find
    "CONDENSATION_POINT_INFINITE_CBALL"
  fun op LIM_LINEAR _ = () val op LIM_LINEAR = TDB.find "LIM_LINEAR"
  fun op LIM_CONST _ = () val op LIM_CONST = TDB.find "LIM_CONST"
  fun op LIM_CMUL _ = () val op LIM_CMUL = TDB.find "LIM_CMUL"
  fun op LIM_CMUL_EQ _ = () val op LIM_CMUL_EQ = TDB.find "LIM_CMUL_EQ"
  fun op LIM_NEG _ = () val op LIM_NEG = TDB.find "LIM_NEG"
  fun op LIM_NEG_EQ _ = () val op LIM_NEG_EQ = TDB.find "LIM_NEG_EQ"
  fun op LIM_ADD _ = () val op LIM_ADD = TDB.find "LIM_ADD"
  fun op LIM_ABS _ = () val op LIM_ABS = TDB.find "LIM_ABS"
  fun op LIM_SUB _ = () val op LIM_SUB = TDB.find "LIM_SUB"
  fun op LIM_MAX _ = () val op LIM_MAX = TDB.find "LIM_MAX"
  fun op LIM_MIN _ = () val op LIM_MIN = TDB.find "LIM_MIN"
  fun op LIM_NULL _ = () val op LIM_NULL = TDB.find "LIM_NULL"
  fun op LIM_NULL_ABS _ = () val op LIM_NULL_ABS = TDB.find "LIM_NULL_ABS"
  fun op LIM_NULL_CMUL_EQ _ = ()
  val op LIM_NULL_CMUL_EQ = TDB.find "LIM_NULL_CMUL_EQ"
  fun op LIM_NULL_CMUL _ = ()
  val op LIM_NULL_CMUL = TDB.find "LIM_NULL_CMUL"
  fun op LIM_NULL_ADD _ = () val op LIM_NULL_ADD = TDB.find "LIM_NULL_ADD"
  fun op LIM_NULL_SUB _ = () val op LIM_NULL_SUB = TDB.find "LIM_NULL_SUB"
  fun op LIM_NULL_COMPARISON _ = ()
  val op LIM_NULL_COMPARISON = TDB.find "LIM_NULL_COMPARISON"
  fun op LIM_COMPONENT _ = ()
  val op LIM_COMPONENT = TDB.find "LIM_COMPONENT"
  fun op LIM_TRANSFORM_BOUND _ = ()
  val op LIM_TRANSFORM_BOUND = TDB.find "LIM_TRANSFORM_BOUND"
  fun op LIM_NULL_CMUL_BOUNDED _ = ()
  val op LIM_NULL_CMUL_BOUNDED = TDB.find "LIM_NULL_CMUL_BOUNDED"
  fun op LIM_SUM _ = () val op LIM_SUM = TDB.find "LIM_SUM"
  fun op LIM_NULL_SUM _ = () val op LIM_NULL_SUM = TDB.find "LIM_NULL_SUM"
  fun op LIM_IN_CLOSED_SET _ = ()
  val op LIM_IN_CLOSED_SET = TDB.find "LIM_IN_CLOSED_SET"
  fun op LIM_ABS_UBOUND _ = ()
  val op LIM_ABS_UBOUND = TDB.find "LIM_ABS_UBOUND"
  fun op LIM_ABS_LBOUND _ = ()
  val op LIM_ABS_LBOUND = TDB.find "LIM_ABS_LBOUND"
  fun op LIM_UNIQUE _ = () val op LIM_UNIQUE = TDB.find "LIM_UNIQUE"
  fun op TENDSTO_LIM _ = () val op TENDSTO_LIM = TDB.find "TENDSTO_LIM"
  fun op LIM_CONST_EQ _ = () val op LIM_CONST_EQ = TDB.find "LIM_CONST_EQ"
  fun op UNIFORM_LIM_ADD _ = ()
  val op UNIFORM_LIM_ADD = TDB.find "UNIFORM_LIM_ADD"
  fun op UNIFORM_LIM_SUB _ = ()
  val op UNIFORM_LIM_SUB = TDB.find "UNIFORM_LIM_SUB"
  fun op UNIFORM_LIM_BILINEAR _ = ()
  val op UNIFORM_LIM_BILINEAR = TDB.find "UNIFORM_LIM_BILINEAR"
  fun op LIM_BILINEAR _ = () val op LIM_BILINEAR = TDB.find "LIM_BILINEAR"
  fun op LIM_WITHIN_ID _ = ()
  val op LIM_WITHIN_ID = TDB.find "LIM_WITHIN_ID"
  fun op LIM_AT_ID _ = () val op LIM_AT_ID = TDB.find "LIM_AT_ID"
  fun op LIM_AT_ZERO _ = () val op LIM_AT_ZERO = TDB.find "LIM_AT_ZERO"
  fun op NETLIMIT_WITHIN _ = ()
  val op NETLIMIT_WITHIN = TDB.find "NETLIMIT_WITHIN"
  fun op NETLIMIT_AT _ = () val op NETLIMIT_AT = TDB.find "NETLIMIT_AT"
  fun op LIM_TRANSFORM _ = ()
  val op LIM_TRANSFORM = TDB.find "LIM_TRANSFORM"
  fun op LIM_TRANSFORM_EVENTUALLY _ = ()
  val op LIM_TRANSFORM_EVENTUALLY = TDB.find "LIM_TRANSFORM_EVENTUALLY"
  fun op LIM_TRANSFORM_WITHIN _ = ()
  val op LIM_TRANSFORM_WITHIN = TDB.find "LIM_TRANSFORM_WITHIN"
  fun op LIM_TRANSFORM_AT _ = ()
  val op LIM_TRANSFORM_AT = TDB.find "LIM_TRANSFORM_AT"
  fun op LIM_TRANSFORM_EQ _ = ()
  val op LIM_TRANSFORM_EQ = TDB.find "LIM_TRANSFORM_EQ"
  fun op LIM_TRANSFORM_WITHIN_SET _ = ()
  val op LIM_TRANSFORM_WITHIN_SET = TDB.find "LIM_TRANSFORM_WITHIN_SET"
  fun op LIM_TRANSFORM_WITHIN_SET_IMP _ = ()
  val op LIM_TRANSFORM_WITHIN_SET_IMP = TDB.find
    "LIM_TRANSFORM_WITHIN_SET_IMP"
  fun op LIM_TRANSFORM_AWAY_WITHIN _ = ()
  val op LIM_TRANSFORM_AWAY_WITHIN = TDB.find "LIM_TRANSFORM_AWAY_WITHIN"
  fun op LIM_TRANSFORM_AWAY_AT _ = ()
  val op LIM_TRANSFORM_AWAY_AT = TDB.find "LIM_TRANSFORM_AWAY_AT"
  fun op LIM_TRANSFORM_WITHIN_OPEN _ = ()
  val op LIM_TRANSFORM_WITHIN_OPEN = TDB.find "LIM_TRANSFORM_WITHIN_OPEN"
  fun op LIM_TRANSFORM_WITHIN_OPEN_IN _ = ()
  val op LIM_TRANSFORM_WITHIN_OPEN_IN = TDB.find
    "LIM_TRANSFORM_WITHIN_OPEN_IN"
  fun op LIM_CASES_FINITE_SEQUENTIALLY _ = ()
  val op LIM_CASES_FINITE_SEQUENTIALLY = TDB.find
    "LIM_CASES_FINITE_SEQUENTIALLY"
  fun op LIM_CASES_COFINITE_SEQUENTIALLY _ = ()
  val op LIM_CASES_COFINITE_SEQUENTIALLY = TDB.find
    "LIM_CASES_COFINITE_SEQUENTIALLY"
  fun op LIM_CASES_SEQUENTIALLY _ = ()
  val op LIM_CASES_SEQUENTIALLY = TDB.find "LIM_CASES_SEQUENTIALLY"
  fun op LIM_CONG_WITHIN _ = ()
  val op LIM_CONG_WITHIN = TDB.find "LIM_CONG_WITHIN"
  fun op LIM_CONG_AT _ = () val op LIM_CONG_AT = TDB.find "LIM_CONG_AT"
  fun op CLOSURE_SEQUENTIAL _ = ()
  val op CLOSURE_SEQUENTIAL = TDB.find "CLOSURE_SEQUENTIAL"
  fun op CLOSED_CONTAINS_SEQUENTIAL_LIMIT _ = ()
  val op CLOSED_CONTAINS_SEQUENTIAL_LIMIT = TDB.find
    "CLOSED_CONTAINS_SEQUENTIAL_LIMIT"
  fun op CLOSED_SEQUENTIAL_LIMITS _ = ()
  val op CLOSED_SEQUENTIAL_LIMITS = TDB.find "CLOSED_SEQUENTIAL_LIMITS"
  fun op CLOSED_APPROACHABLE _ = ()
  val op CLOSED_APPROACHABLE = TDB.find "CLOSED_APPROACHABLE"
  fun op IN_CLOSURE_DELETE _ = ()
  val op IN_CLOSURE_DELETE = TDB.find "IN_CLOSURE_DELETE"
  fun op DENSE_IMP_PERFECT _ = ()
  val op DENSE_IMP_PERFECT = TDB.find "DENSE_IMP_PERFECT"
  fun op DENSE_LIMIT_POINTS _ = ()
  val op DENSE_LIMIT_POINTS = TDB.find "DENSE_LIMIT_POINTS"
  fun op SEQ_OFFSET _ = () val op SEQ_OFFSET = TDB.find "SEQ_OFFSET"
  fun op SEQ_OFFSET_NEG _ = ()
  val op SEQ_OFFSET_NEG = TDB.find "SEQ_OFFSET_NEG"
  fun op SEQ_OFFSET_REV _ = ()
  val op SEQ_OFFSET_REV = TDB.find "SEQ_OFFSET_REV"
  fun op SEQ_HARMONIC_OFFSET _ = ()
  val op SEQ_HARMONIC_OFFSET = TDB.find "SEQ_HARMONIC_OFFSET"
  fun op SEQ_HARMONIC _ = () val op SEQ_HARMONIC = TDB.find "SEQ_HARMONIC"
  fun op CLOSED_CBALL _ = () val op CLOSED_CBALL = TDB.find "CLOSED_CBALL"
  fun op IN_INTERIOR_CBALL _ = ()
  val op IN_INTERIOR_CBALL = TDB.find "IN_INTERIOR_CBALL"
  fun op LIMPT_BALL _ = () val op LIMPT_BALL = TDB.find "LIMPT_BALL"
  fun op CLOSURE_BALL _ = () val op CLOSURE_BALL = TDB.find "CLOSURE_BALL"
  fun op INTERIOR_BALL _ = ()
  val op INTERIOR_BALL = TDB.find "INTERIOR_BALL"
  fun op INTERIOR_CBALL _ = ()
  val op INTERIOR_CBALL = TDB.find "INTERIOR_CBALL"
  fun op FRONTIER_BALL _ = ()
  val op FRONTIER_BALL = TDB.find "FRONTIER_BALL"
  fun op FRONTIER_CBALL _ = ()
  val op FRONTIER_CBALL = TDB.find "FRONTIER_CBALL"
  fun op CBALL_EQ_EMPTY _ = ()
  val op CBALL_EQ_EMPTY = TDB.find "CBALL_EQ_EMPTY"
  fun op CBALL_EMPTY _ = () val op CBALL_EMPTY = TDB.find "CBALL_EMPTY"
  fun op CBALL_EQ_SING _ = ()
  val op CBALL_EQ_SING = TDB.find "CBALL_EQ_SING"
  fun op CBALL_SING _ = () val op CBALL_SING = TDB.find "CBALL_SING"
  fun op SPHERE_SING _ = () val op SPHERE_SING = TDB.find "SPHERE_SING"
  fun op SPHERE_EQ_SING _ = ()
  val op SPHERE_EQ_SING = TDB.find "SPHERE_EQ_SING"
  fun op EVENTUALLY_WITHIN_INTERIOR _ = ()
  val op EVENTUALLY_WITHIN_INTERIOR = TDB.find "EVENTUALLY_WITHIN_INTERIOR"
  fun op LIM_WITHIN_INTERIOR _ = ()
  val op LIM_WITHIN_INTERIOR = TDB.find "LIM_WITHIN_INTERIOR"
  fun op NETLIMIT_WITHIN_INTERIOR _ = ()
  val op NETLIMIT_WITHIN_INTERIOR = TDB.find "NETLIMIT_WITHIN_INTERIOR"
  fun op CONNECTED_IMP_PERFECT _ = ()
  val op CONNECTED_IMP_PERFECT = TDB.find "CONNECTED_IMP_PERFECT"
  fun op CONNECTED_IMP_PERFECT_CLOSED _ = ()
  val op CONNECTED_IMP_PERFECT_CLOSED = TDB.find
    "CONNECTED_IMP_PERFECT_CLOSED"
  fun op BOUNDED_EMPTY _ = ()
  val op BOUNDED_EMPTY = TDB.find "BOUNDED_EMPTY"
  fun op BOUNDED_SUBSET _ = ()
  val op BOUNDED_SUBSET = TDB.find "BOUNDED_SUBSET"
  fun op BOUNDED_INTERIOR _ = ()
  val op BOUNDED_INTERIOR = TDB.find "BOUNDED_INTERIOR"
  fun op BOUNDED_CLOSURE _ = ()
  val op BOUNDED_CLOSURE = TDB.find "BOUNDED_CLOSURE"
  fun op BOUNDED_CLOSURE_EQ _ = ()
  val op BOUNDED_CLOSURE_EQ = TDB.find "BOUNDED_CLOSURE_EQ"
  fun op BOUNDED_CBALL _ = ()
  val op BOUNDED_CBALL = TDB.find "BOUNDED_CBALL"
  fun op BOUNDED_BALL _ = () val op BOUNDED_BALL = TDB.find "BOUNDED_BALL"
  fun op FINITE_IMP_BOUNDED _ = ()
  val op FINITE_IMP_BOUNDED = TDB.find "FINITE_IMP_BOUNDED"
  fun op BOUNDED_UNION _ = ()
  val op BOUNDED_UNION = TDB.find "BOUNDED_UNION"
  fun op BOUNDED_BIGUNION _ = ()
  val op BOUNDED_BIGUNION = TDB.find "BOUNDED_BIGUNION"
  fun op BOUNDED_POS _ = () val op BOUNDED_POS = TDB.find "BOUNDED_POS"
  fun op BOUNDED_POS_LT _ = ()
  val op BOUNDED_POS_LT = TDB.find "BOUNDED_POS_LT"
  fun op BOUNDED_INTER _ = ()
  val op BOUNDED_INTER = TDB.find "BOUNDED_INTER"
  fun op BOUNDED_DIFF _ = () val op BOUNDED_DIFF = TDB.find "BOUNDED_DIFF"
  fun op BOUNDED_INSERT _ = ()
  val op BOUNDED_INSERT = TDB.find "BOUNDED_INSERT"
  fun op BOUNDED_SING _ = () val op BOUNDED_SING = TDB.find "BOUNDED_SING"
  fun op BOUNDED_BIGINTER _ = ()
  val op BOUNDED_BIGINTER = TDB.find "BOUNDED_BIGINTER"
  fun op NOT_BOUNDED_UNIV _ = ()
  val op NOT_BOUNDED_UNIV = TDB.find "NOT_BOUNDED_UNIV"
  fun op COBOUNDED_IMP_UNBOUNDED _ = ()
  val op COBOUNDED_IMP_UNBOUNDED = TDB.find "COBOUNDED_IMP_UNBOUNDED"
  fun op BOUNDED_LINEAR_IMAGE _ = ()
  val op BOUNDED_LINEAR_IMAGE = TDB.find "BOUNDED_LINEAR_IMAGE"
  fun op BOUNDED_SCALING _ = ()
  val op BOUNDED_SCALING = TDB.find "BOUNDED_SCALING"
  fun op BOUNDED_NEGATIONS _ = ()
  val op BOUNDED_NEGATIONS = TDB.find "BOUNDED_NEGATIONS"
  fun op BOUNDED_TRANSLATION _ = ()
  val op BOUNDED_TRANSLATION = TDB.find "BOUNDED_TRANSLATION"
  fun op BOUNDED_TRANSLATION_EQ _ = ()
  val op BOUNDED_TRANSLATION_EQ = TDB.find "BOUNDED_TRANSLATION_EQ"
  fun op BOUNDED_DIFFS _ = ()
  val op BOUNDED_DIFFS = TDB.find "BOUNDED_DIFFS"
  fun op BOUNDED_SUMS _ = () val op BOUNDED_SUMS = TDB.find "BOUNDED_SUMS"
  fun op BOUNDED_SUMS_IMAGE _ = ()
  val op BOUNDED_SUMS_IMAGE = TDB.find "BOUNDED_SUMS_IMAGE"
  fun op BOUNDED_SUMS_IMAGES _ = ()
  val op BOUNDED_SUMS_IMAGES = TDB.find "BOUNDED_SUMS_IMAGES"
  fun op BOUNDED_SUBSET_BALL _ = ()
  val op BOUNDED_SUBSET_BALL = TDB.find "BOUNDED_SUBSET_BALL"
  fun op BOUNDED_SUBSET_CBALL _ = ()
  val op BOUNDED_SUBSET_CBALL = TDB.find "BOUNDED_SUBSET_CBALL"
  fun op UNBOUNDED_INTER_COBOUNDED _ = ()
  val op UNBOUNDED_INTER_COBOUNDED = TDB.find "UNBOUNDED_INTER_COBOUNDED"
  fun op COBOUNDED_INTER_UNBOUNDED _ = ()
  val op COBOUNDED_INTER_UNBOUNDED = TDB.find "COBOUNDED_INTER_UNBOUNDED"
  fun op SUBSPACE_BOUNDED_EQ_TRIVIAL _ = ()
  val op SUBSPACE_BOUNDED_EQ_TRIVIAL = TDB.find
    "SUBSPACE_BOUNDED_EQ_TRIVIAL"
  fun op BOUNDED_COMPONENTWISE _ = ()
  val op BOUNDED_COMPONENTWISE = TDB.find "BOUNDED_COMPONENTWISE"
  fun op BOUNDED_HAS_SUP _ = ()
  val op BOUNDED_HAS_SUP = TDB.find "BOUNDED_HAS_SUP"
  fun op SUP_INSERT _ = () val op SUP_INSERT = TDB.find "SUP_INSERT"
  fun op BOUNDED_HAS_INF _ = ()
  val op BOUNDED_HAS_INF = TDB.find "BOUNDED_HAS_INF"
  fun op INF_INSERT _ = () val op INF_INSERT = TDB.find "INF_INSERT"
  fun op SUBSET_BALLS _ = () val op SUBSET_BALLS = TDB.find "SUBSET_BALLS"
  fun op INTER_BALLS_EQ_EMPTY _ = ()
  val op INTER_BALLS_EQ_EMPTY = TDB.find "INTER_BALLS_EQ_EMPTY"
  fun op OPEN_CLOSED_INTERVAL_CONVEX _ = ()
  val op OPEN_CLOSED_INTERVAL_CONVEX = TDB.find
    "OPEN_CLOSED_INTERVAL_CONVEX"
  fun op OPEN_INTERVAL_MIDPOINT _ = ()
  val op OPEN_INTERVAL_MIDPOINT = TDB.find "OPEN_INTERVAL_MIDPOINT"
  fun op COMPACT_INTERVAL _ = ()
  val op COMPACT_INTERVAL = TDB.find "COMPACT_INTERVAL"
  fun op NOT_INTERVAL_UNIV _ = ()
  val op NOT_INTERVAL_UNIV = TDB.find "NOT_INTERVAL_UNIV"
  fun op BOUNDED_INTERVAL _ = ()
  val op BOUNDED_INTERVAL = TDB.find "BOUNDED_INTERVAL"
  fun op BOUNDED_CLOSED_INTERVAL _ = ()
  val op BOUNDED_CLOSED_INTERVAL = TDB.find "BOUNDED_CLOSED_INTERVAL"
  fun op INTERIOR_INTERVAL _ = ()
  val op INTERIOR_INTERVAL = TDB.find "INTERIOR_INTERVAL"
  fun op INTERIOR_CLOSED_INTERVAL _ = ()
  val op INTERIOR_CLOSED_INTERVAL = TDB.find "INTERIOR_CLOSED_INTERVAL"
  fun op CLOSED_INTERVAL _ = ()
  val op CLOSED_INTERVAL = TDB.find "CLOSED_INTERVAL"
  fun op OPEN_INTERVAL _ = ()
  val op OPEN_INTERVAL = TDB.find "OPEN_INTERVAL"
  fun op OPEN_INTERVAL_LEMMA _ = ()
  val op OPEN_INTERVAL_LEMMA = TDB.find "OPEN_INTERVAL_LEMMA"
  fun op REAL_LT_MIN _ = () val op REAL_LT_MIN = TDB.find "REAL_LT_MIN"
  fun op INTERVAL_OPEN_SUBSET_CLOSED _ = ()
  val op INTERVAL_OPEN_SUBSET_CLOSED = TDB.find
    "INTERVAL_OPEN_SUBSET_CLOSED"
  fun op INTER_INTERVAL _ = ()
  val op INTER_INTERVAL = TDB.find "INTER_INTERVAL"
  fun op ENDS_IN_UNIT_INTERVAL _ = ()
  val op ENDS_IN_UNIT_INTERVAL = TDB.find "ENDS_IN_UNIT_INTERVAL"
  fun op ENDS_IN_INTERVAL _ = ()
  val op ENDS_IN_INTERVAL = TDB.find "ENDS_IN_INTERVAL"
  fun op DISJOINT_INTERVAL _ = ()
  val op DISJOINT_INTERVAL = TDB.find "DISJOINT_INTERVAL"
  fun op SUBSET_INTERVAL _ = ()
  val op SUBSET_INTERVAL = TDB.find "SUBSET_INTERVAL"
  fun op INTERVAL_SING _ = ()
  val op INTERVAL_SING = TDB.find "INTERVAL_SING"
  fun op SUBSET_INTERVAL_IMP _ = ()
  val op SUBSET_INTERVAL_IMP = TDB.find "SUBSET_INTERVAL_IMP"
  fun op INTERVAL_NE_EMPTY _ = ()
  val op INTERVAL_NE_EMPTY = TDB.find "INTERVAL_NE_EMPTY"
  fun op INTERVAL_EQ_EMPTY _ = ()
  val op INTERVAL_EQ_EMPTY = TDB.find "INTERVAL_EQ_EMPTY"
  fun op REFLECT_INTERVAL _ = ()
  val op REFLECT_INTERVAL = TDB.find "REFLECT_INTERVAL"
  fun op IN_INTERVAL_REFLECT _ = ()
  val op IN_INTERVAL_REFLECT = TDB.find "IN_INTERVAL_REFLECT"
  fun op IN_INTERVAL _ = () val op IN_INTERVAL = TDB.find "IN_INTERVAL"
  fun op interval _ = () val op interval = TDB.find "interval"
  fun op OPEN_UNION_COMPACT_SUBSETS _ = ()
  val op OPEN_UNION_COMPACT_SUBSETS = TDB.find "OPEN_UNION_COMPACT_SUBSETS"
  fun op CLOSED_UNION_COMPACT_SUBSETS _ = ()
  val op CLOSED_UNION_COMPACT_SUBSETS = TDB.find
    "CLOSED_UNION_COMPACT_SUBSETS"
  fun op SEPARATE_CLOSED_COMPACT _ = ()
  val op SEPARATE_CLOSED_COMPACT = TDB.find "SEPARATE_CLOSED_COMPACT"
  fun op SEPARATE_COMPACT_CLOSED _ = ()
  val op SEPARATE_COMPACT_CLOSED = TDB.find "SEPARATE_COMPACT_CLOSED"
  fun op SEPARATE_POINT_CLOSED _ = ()
  val op SEPARATE_POINT_CLOSED = TDB.find "SEPARATE_POINT_CLOSED"
  fun op TRANSLATION_DIFF _ = ()
  val op TRANSLATION_DIFF = TDB.find "TRANSLATION_DIFF"
  fun op CLOSED_COMPACT_DIFFERENCES _ = ()
  val op CLOSED_COMPACT_DIFFERENCES = TDB.find "CLOSED_COMPACT_DIFFERENCES"
  fun op COMPACT_CLOSED_DIFFERENCES _ = ()
  val op COMPACT_CLOSED_DIFFERENCES = TDB.find "COMPACT_CLOSED_DIFFERENCES"
  fun op CLOSURE_SUMS _ = () val op CLOSURE_SUMS = TDB.find "CLOSURE_SUMS"
  fun op CLOSED_COMPACT_SUMS _ = ()
  val op CLOSED_COMPACT_SUMS = TDB.find "CLOSED_COMPACT_SUMS"
  fun op COMPACT_CLOSED_SUMS _ = ()
  val op COMPACT_CLOSED_SUMS = TDB.find "COMPACT_CLOSED_SUMS"
  fun op CLOSED_NEGATIONS _ = ()
  val op CLOSED_NEGATIONS = TDB.find "CLOSED_NEGATIONS"
  fun op CLOSED_SCALING _ = ()
  val op CLOSED_SCALING = TDB.find "CLOSED_SCALING"
  fun op LEBESGUE_COVERING_LEMMA _ = ()
  val op LEBESGUE_COVERING_LEMMA = TDB.find "LEBESGUE_COVERING_LEMMA"
  fun op DIAMETER_SUMS _ = ()
  val op DIAMETER_SUMS = TDB.find "DIAMETER_SUMS"
  fun op DIAMETER_BALL _ = ()
  val op DIAMETER_BALL = TDB.find "DIAMETER_BALL"
  fun op DIAMETER_CBALL _ = ()
  val op DIAMETER_CBALL = TDB.find "DIAMETER_CBALL"
  fun op DIAMETER_LE _ = () val op DIAMETER_LE = TDB.find "DIAMETER_LE"
  fun op DIAMETER_EQ_0 _ = ()
  val op DIAMETER_EQ_0 = TDB.find "DIAMETER_EQ_0"
  fun op DIAMETER_SUBSET_CBALL _ = ()
  val op DIAMETER_SUBSET_CBALL = TDB.find "DIAMETER_SUBSET_CBALL"
  fun op DIAMETER_SUBSET_CBALL_NONEMPTY _ = ()
  val op DIAMETER_SUBSET_CBALL_NONEMPTY = TDB.find
    "DIAMETER_SUBSET_CBALL_NONEMPTY"
  fun op DIAMETER_CLOSURE _ = ()
  val op DIAMETER_CLOSURE = TDB.find "DIAMETER_CLOSURE"
  fun op DIAMETER_SUBSET _ = ()
  val op DIAMETER_SUBSET = TDB.find "DIAMETER_SUBSET"
  fun op DIAMETER_POS_LE _ = ()
  val op DIAMETER_POS_LE = TDB.find "DIAMETER_POS_LE"
  fun op DIAMETER_SING _ = ()
  val op DIAMETER_SING = TDB.find "DIAMETER_SING"
  fun op DIAMETER_EMPTY _ = ()
  val op DIAMETER_EMPTY = TDB.find "DIAMETER_EMPTY"
  fun op DIAMETER_LINEAR_IMAGE _ = ()
  val op DIAMETER_LINEAR_IMAGE = TDB.find "DIAMETER_LINEAR_IMAGE"
  fun op DIAMETER_BOUNDED_BOUND _ = ()
  val op DIAMETER_BOUNDED_BOUND = TDB.find "DIAMETER_BOUNDED_BOUND"
  fun op DIAMETER_BOUNDED _ = ()
  val op DIAMETER_BOUNDED = TDB.find "DIAMETER_BOUNDED"
  fun op COMPACT_AFFINITY _ = ()
  val op COMPACT_AFFINITY = TDB.find "COMPACT_AFFINITY"
  fun op COMPACT_NEGATIONS _ = ()
  val op COMPACT_NEGATIONS = TDB.find "COMPACT_NEGATIONS"
  fun op COMPACT_SCALING _ = ()
  val op COMPACT_SCALING = TDB.find "COMPACT_SCALING"
  fun op CONNECTED_NEGATIONS _ = ()
  val op CONNECTED_NEGATIONS = TDB.find "CONNECTED_NEGATIONS"
  fun op CONNECTED_SCALING _ = ()
  val op CONNECTED_SCALING = TDB.find "CONNECTED_SCALING"
  fun op CONTINUOUS_ON_INV _ = ()
  val op CONTINUOUS_ON_INV = TDB.find "CONTINUOUS_ON_INV"
  fun op CONTINUOUS_AT_INV _ = ()
  val op CONTINUOUS_AT_INV = TDB.find "CONTINUOUS_AT_INV"
  fun op CONTINUOUS_AT_WITHIN_INV _ = ()
  val op CONTINUOUS_AT_WITHIN_INV = TDB.find "CONTINUOUS_AT_WITHIN_INV"
  fun op CONTINUOUS_INV _ = ()
  val op CONTINUOUS_INV = TDB.find "CONTINUOUS_INV"
  fun op LIM_INV _ = () val op LIM_INV = TDB.find "LIM_INV"
  fun op CONTINUOUS_ON_PRODUCT _ = ()
  val op CONTINUOUS_ON_PRODUCT = TDB.find "CONTINUOUS_ON_PRODUCT"
  fun op CONTINUOUS_PRODUCT _ = ()
  val op CONTINUOUS_PRODUCT = TDB.find "CONTINUOUS_PRODUCT"
  fun op CONTINUOUS_ON_POW _ = ()
  val op CONTINUOUS_ON_POW = TDB.find "CONTINUOUS_ON_POW"
  fun op CONTINUOUS_POW _ = ()
  val op CONTINUOUS_POW = TDB.find "CONTINUOUS_POW"
  fun op CONTINUOUS_ON_MUL _ = ()
  val op CONTINUOUS_ON_MUL = TDB.find "CONTINUOUS_ON_MUL"
  fun op CONTINUOUS_ON_VMUL _ = ()
  val op CONTINUOUS_ON_VMUL = TDB.find "CONTINUOUS_ON_VMUL"
  fun op CONTINUOUS_MUL _ = ()
  val op CONTINUOUS_MUL = TDB.find "CONTINUOUS_MUL"
  fun op CONTINUOUS_VMUL _ = ()
  val op CONTINUOUS_VMUL = TDB.find "CONTINUOUS_VMUL"
  fun op LIM_VMUL _ = () val op LIM_VMUL = TDB.find "LIM_VMUL"
  fun op LIM_MUL _ = () val op LIM_MUL = TDB.find "LIM_MUL"
  fun op DISTANCE_ATTAINS_INF _ = ()
  val op DISTANCE_ATTAINS_INF = TDB.find "DISTANCE_ATTAINS_INF"
  fun op DISTANCE_ATTAINS_SUP _ = ()
  val op DISTANCE_ATTAINS_SUP = TDB.find "DISTANCE_ATTAINS_SUP"
  fun op CONTINUOUS_ATTAINS_INF _ = ()
  val op CONTINUOUS_ATTAINS_INF = TDB.find "CONTINUOUS_ATTAINS_INF"
  fun op CONTINUOUS_ATTAINS_SUP _ = ()
  val op CONTINUOUS_ATTAINS_SUP = TDB.find "CONTINUOUS_ATTAINS_SUP"
  fun op COMPACT_ATTAINS_INF _ = ()
  val op COMPACT_ATTAINS_INF = TDB.find "COMPACT_ATTAINS_INF"
  fun op COMPACT_ATTAINS_SUP _ = ()
  val op COMPACT_ATTAINS_SUP = TDB.find "COMPACT_ATTAINS_SUP"
  fun op CONTINUOUS_ON_DIST _ = ()
  val op CONTINUOUS_ON_DIST = TDB.find "CONTINUOUS_ON_DIST"
  fun op CONTINUOUS_AT_DIST _ = ()
  val op CONTINUOUS_AT_DIST = TDB.find "CONTINUOUS_AT_DIST"
  fun op CONTINUOUS_AT_ABS _ = ()
  val op CONTINUOUS_AT_ABS = TDB.find "CONTINUOUS_AT_ABS"
  fun op CONTINUOUS_ON_ABS_COMPOSE _ = ()
  val op CONTINUOUS_ON_ABS_COMPOSE = TDB.find "CONTINUOUS_ON_ABS_COMPOSE"
  fun op CONTINUOUS_ABS_COMPOSE _ = ()
  val op CONTINUOUS_ABS_COMPOSE = TDB.find "CONTINUOUS_ABS_COMPOSE"
  fun op CONTINUOUS_ON_RANGE _ = ()
  val op CONTINUOUS_ON_RANGE = TDB.find "CONTINUOUS_ON_RANGE"
  fun op CONTINUOUS_AT_RANGE _ = ()
  val op CONTINUOUS_AT_RANGE = TDB.find "CONTINUOUS_AT_RANGE"
  fun op CLOSED _ = () val op CLOSED = TDB.find "CLOSED"
  fun op OPEN _ = () val op OPEN = TDB.find "OPEN"
  fun op CONTINUOUS_UNIFORM_LIMIT _ = ()
  val op CONTINUOUS_UNIFORM_LIMIT = TDB.find "CONTINUOUS_UNIFORM_LIMIT"
  fun op ABS_TRIANGLE_LE _ = ()
  val op ABS_TRIANGLE_LE = TDB.find "ABS_TRIANGLE_LE"
  fun op COMPACT_UNIFORMLY_CONTINUOUS _ = ()
  val op COMPACT_UNIFORMLY_CONTINUOUS = TDB.find
    "COMPACT_UNIFORMLY_CONTINUOUS"
  fun op COMPACT_UNIFORMLY_EQUICONTINUOUS _ = ()
  val op COMPACT_UNIFORMLY_EQUICONTINUOUS = TDB.find
    "COMPACT_UNIFORMLY_EQUICONTINUOUS"
  fun op CLOPEN_IN_COMPONENTS _ = ()
  val op CLOPEN_IN_COMPONENTS = TDB.find "CLOPEN_IN_COMPONENTS"
  fun op CLOPEN_BIGUNION_COMPONENTS _ = ()
  val op CLOPEN_BIGUNION_COMPONENTS = TDB.find "CLOPEN_BIGUNION_COMPONENTS"
  fun op CONNECTED_SUBSET_CLOPEN _ = ()
  val op CONNECTED_SUBSET_CLOPEN = TDB.find "CONNECTED_SUBSET_CLOPEN"
  fun op IN_COMPONENTS_BIGUNION_COMPLEMENT _ = ()
  val op IN_COMPONENTS_BIGUNION_COMPLEMENT = TDB.find
    "IN_COMPONENTS_BIGUNION_COMPLEMENT"
  fun op COMPONENTS_INTERMEDIATE_SUBSET _ = ()
  val op COMPONENTS_INTERMEDIATE_SUBSET = TDB.find
    "COMPONENTS_INTERMEDIATE_SUBSET"
  fun op EXISTS_COMPONENT_SUPERSET _ = ()
  val op EXISTS_COMPONENT_SUPERSET = TDB.find "EXISTS_COMPONENT_SUPERSET"
  fun op COMPONENTS_UNIQUE_EQ _ = ()
  val op COMPONENTS_UNIQUE_EQ = TDB.find "COMPONENTS_UNIQUE_EQ"
  fun op COMPONENTS_UNIQUE _ = ()
  val op COMPONENTS_UNIQUE = TDB.find "COMPONENTS_UNIQUE"
  fun op COMPONENTS_MAXIMAL _ = ()
  val op COMPONENTS_MAXIMAL = TDB.find "COMPONENTS_MAXIMAL"
  fun op IN_COMPONENTS_SELF _ = ()
  val op IN_COMPONENTS_SELF = TDB.find "IN_COMPONENTS_SELF"
  fun op CONNECTED_EQ_COMPONENTS_SUBSET_SING_EXISTS _ = ()
  val op CONNECTED_EQ_COMPONENTS_SUBSET_SING_EXISTS = TDB.find
    "CONNECTED_EQ_COMPONENTS_SUBSET_SING_EXISTS"
  fun op CONNECTED_EQ_COMPONENTS_SUBSET_SING _ = ()
  val op CONNECTED_EQ_COMPONENTS_SUBSET_SING = TDB.find
    "CONNECTED_EQ_COMPONENTS_SUBSET_SING"
  fun op COMPONENTS_UNIV _ = ()
  val op COMPONENTS_UNIV = TDB.find "COMPONENTS_UNIV"
  fun op COMPONENTS_EQ_SING_EXISTS _ = ()
  val op COMPONENTS_EQ_SING_EXISTS = TDB.find "COMPONENTS_EQ_SING_EXISTS"
  fun op COMPONENTS_EQ_SING _ = ()
  val op COMPONENTS_EQ_SING = TDB.find "COMPONENTS_EQ_SING"
  fun op COMPONENTS_EQ_SING_N_EXISTS _ = ()
  val op COMPONENTS_EQ_SING_N_EXISTS = TDB.find
    "COMPONENTS_EQ_SING_N_EXISTS"
  fun op CONNECTED_EQ_CONNECTED_COMPONENTS_EQ _ = ()
  val op CONNECTED_EQ_CONNECTED_COMPONENTS_EQ = TDB.find
    "CONNECTED_EQ_CONNECTED_COMPONENTS_EQ"
  fun op COMPONENTS_EMPTY _ = ()
  val op COMPONENTS_EMPTY = TDB.find "COMPONENTS_EMPTY"
  fun op COMPONENTS_EQ_EMPTY _ = ()
  val op COMPONENTS_EQ_EMPTY = TDB.find "COMPONENTS_EQ_EMPTY"
  fun op COMPONENTS_EQ _ = ()
  val op COMPONENTS_EQ = TDB.find "COMPONENTS_EQ"
  fun op COMPONENTS_NONOVERLAP _ = ()
  val op COMPONENTS_NONOVERLAP = TDB.find "COMPONENTS_NONOVERLAP"
  fun op CONTINUOUS_ON_COMPONENTS_FINITE _ = ()
  val op CONTINUOUS_ON_COMPONENTS_FINITE = TDB.find
    "CONTINUOUS_ON_COMPONENTS_FINITE"
  fun op CONTINUOUS_ON_COMPONENTS_GEN _ = ()
  val op CONTINUOUS_ON_COMPONENTS_GEN = TDB.find
    "CONTINUOUS_ON_COMPONENTS_GEN"
  fun op COMPACT_COMPONENTS _ = ()
  val op COMPACT_COMPONENTS = TDB.find "COMPACT_COMPONENTS"
  fun op CLOSED_COMPONENTS _ = ()
  val op CLOSED_COMPONENTS = TDB.find "CLOSED_COMPONENTS"
  fun op CLOSED_IN_COMPONENT _ = ()
  val op CLOSED_IN_COMPONENT = TDB.find "CLOSED_IN_COMPONENT"
  fun op JOINABLE_COMPONENTS_EQ _ = ()
  val op JOINABLE_COMPONENTS_EQ = TDB.find "JOINABLE_COMPONENTS_EQ"
  fun op IN_COMPONENTS_MAXIMAL _ = ()
  val op IN_COMPONENTS_MAXIMAL = TDB.find "IN_COMPONENTS_MAXIMAL"
  fun op IN_COMPONENTS_CONNECTED _ = ()
  val op IN_COMPONENTS_CONNECTED = TDB.find "IN_COMPONENTS_CONNECTED"
  fun op IN_COMPONENTS_SUBSET _ = ()
  val op IN_COMPONENTS_SUBSET = TDB.find "IN_COMPONENTS_SUBSET"
  fun op IN_COMPONENTS_NONEMPTY _ = ()
  val op IN_COMPONENTS_NONEMPTY = TDB.find "IN_COMPONENTS_NONEMPTY"
  fun op PAIRWISE_DISJOINT_COMPONENTS _ = ()
  val op PAIRWISE_DISJOINT_COMPONENTS = TDB.find
    "PAIRWISE_DISJOINT_COMPONENTS"
  fun op BIGUNION_COMPONENTS _ = ()
  val op BIGUNION_COMPONENTS = TDB.find "BIGUNION_COMPONENTS"
  fun op IN_COMPONENTS _ = ()
  val op IN_COMPONENTS = TDB.find "IN_COMPONENTS"
  fun op CONNECTED_COMPONENT_INTERMEDIATE_SUBSET _ = ()
  val op CONNECTED_COMPONENT_INTERMEDIATE_SUBSET = TDB.find
    "CONNECTED_COMPONENT_INTERMEDIATE_SUBSET"
  fun op CONNECTED_COMPONENT_EQUIVALENCE_RELATION _ = ()
  val op CONNECTED_COMPONENT_EQUIVALENCE_RELATION = TDB.find
    "CONNECTED_COMPONENT_EQUIVALENCE_RELATION"
  fun op OPEN_IN_CONNECTED_COMPONENT _ = ()
  val op OPEN_IN_CONNECTED_COMPONENT = TDB.find
    "OPEN_IN_CONNECTED_COMPONENT"
  fun op BIGUNION_DIFF _ = ()
  val op BIGUNION_DIFF = TDB.find "BIGUNION_DIFF"
  fun op CLOSED_IN_CONNECTED_COMPONENT _ = ()
  val op CLOSED_IN_CONNECTED_COMPONENT = TDB.find
    "CLOSED_IN_CONNECTED_COMPONENT"
  fun op COMPLEMENT_CONNECTED_COMPONENT_BIGUNION _ = ()
  val op COMPLEMENT_CONNECTED_COMPONENT_BIGUNION = TDB.find
    "COMPLEMENT_CONNECTED_COMPONENT_BIGUNION"
  fun op BIGUNION_CONNECTED_COMPONENT _ = ()
  val op BIGUNION_CONNECTED_COMPONENT = TDB.find
    "BIGUNION_CONNECTED_COMPONENT"
  fun op JOINABLE_CONNECTED_COMPONENT_EQ _ = ()
  val op JOINABLE_CONNECTED_COMPONENT_EQ = TDB.find
    "JOINABLE_CONNECTED_COMPONENT_EQ"
  fun op CONNECTED_COMPONENT_UNIQUE _ = ()
  val op CONNECTED_COMPONENT_UNIQUE = TDB.find "CONNECTED_COMPONENT_UNIQUE"
  fun op CONNECTED_COMPONENT_IDEMP _ = ()
  val op CONNECTED_COMPONENT_IDEMP = TDB.find "CONNECTED_COMPONENT_IDEMP"
  fun op CONNECTED_EQ_CONNECTED_COMPONENT_EQ _ = ()
  val op CONNECTED_EQ_CONNECTED_COMPONENT_EQ = TDB.find
    "CONNECTED_EQ_CONNECTED_COMPONENT_EQ"
  fun op CONNECTED_COMPONENT_EQ_EQ _ = ()
  val op CONNECTED_COMPONENT_EQ_EQ = TDB.find "CONNECTED_COMPONENT_EQ_EQ"
  fun op CONNECTED_COMPONENT_SYM_EQ _ = ()
  val op CONNECTED_COMPONENT_SYM_EQ = TDB.find "CONNECTED_COMPONENT_SYM_EQ"
  fun op CONNECTED_COMPONENT_OVERLAP _ = ()
  val op CONNECTED_COMPONENT_OVERLAP = TDB.find
    "CONNECTED_COMPONENT_OVERLAP"
  fun op CONNECTED_COMPONENT_NONOVERLAP _ = ()
  val op CONNECTED_COMPONENT_NONOVERLAP = TDB.find
    "CONNECTED_COMPONENT_NONOVERLAP"
  fun op CONNECTED_COMPONENT_DISJOINT _ = ()
  val op CONNECTED_COMPONENT_DISJOINT = TDB.find
    "CONNECTED_COMPONENT_DISJOINT"
  fun op CLOSED_CONNECTED_COMPONENT _ = ()
  val op CLOSED_CONNECTED_COMPONENT = TDB.find "CLOSED_CONNECTED_COMPONENT"
  fun op CONNECTED_COMPONENT_EQ _ = ()
  val op CONNECTED_COMPONENT_EQ = TDB.find "CONNECTED_COMPONENT_EQ"
  fun op CONNECTED_COMPONENT_EMPTY _ = ()
  val op CONNECTED_COMPONENT_EMPTY = TDB.find "CONNECTED_COMPONENT_EMPTY"
  fun op CONNECTED_COMPONENT_EQ_EMPTY _ = ()
  val op CONNECTED_COMPONENT_EQ_EMPTY = TDB.find
    "CONNECTED_COMPONENT_EQ_EMPTY"
  fun op CONNECTED_CONNECTED_COMPONENT _ = ()
  val op CONNECTED_CONNECTED_COMPONENT = TDB.find
    "CONNECTED_CONNECTED_COMPONENT"
  fun op CONNECTED_COMPONENT_MONO _ = ()
  val op CONNECTED_COMPONENT_MONO = TDB.find "CONNECTED_COMPONENT_MONO"
  fun op CONNECTED_COMPONENT_MAXIMAL _ = ()
  val op CONNECTED_COMPONENT_MAXIMAL = TDB.find
    "CONNECTED_COMPONENT_MAXIMAL"
  fun op CONNECTED_IFF_CONNECTED_COMPONENT _ = ()
  val op CONNECTED_IFF_CONNECTED_COMPONENT = TDB.find
    "CONNECTED_IFF_CONNECTED_COMPONENT"
  fun op CONNECTED_COMPONENT_EQ_SELF _ = ()
  val op CONNECTED_COMPONENT_EQ_SELF = TDB.find
    "CONNECTED_COMPONENT_EQ_SELF"
  fun op CONNECTED_COMPONENT_EQ_UNIV _ = ()
  val op CONNECTED_COMPONENT_EQ_UNIV = TDB.find
    "CONNECTED_COMPONENT_EQ_UNIV"
  fun op CONNECTED_COMPONENT_UNIV _ = ()
  val op CONNECTED_COMPONENT_UNIV = TDB.find "CONNECTED_COMPONENT_UNIV"
  fun op CONNECTED_CONNECTED_COMPONENT_SET _ = ()
  val op CONNECTED_CONNECTED_COMPONENT_SET = TDB.find
    "CONNECTED_CONNECTED_COMPONENT_SET"
  fun op CONNECTED_COMPONENT_SUBSET _ = ()
  val op CONNECTED_COMPONENT_SUBSET = TDB.find "CONNECTED_COMPONENT_SUBSET"
  fun op CONNECTED_COMPONENT_BIGUNION _ = ()
  val op CONNECTED_COMPONENT_BIGUNION = TDB.find
    "CONNECTED_COMPONENT_BIGUNION"
  fun op CONNECTED_COMPONENT_SET _ = ()
  val op CONNECTED_COMPONENT_SET = TDB.find "CONNECTED_COMPONENT_SET"
  fun op CONNECTED_COMPONENT_OF_SUBSET _ = ()
  val op CONNECTED_COMPONENT_OF_SUBSET = TDB.find
    "CONNECTED_COMPONENT_OF_SUBSET"
  fun op CONNECTED_COMPONENT_TRANS _ = ()
  val op CONNECTED_COMPONENT_TRANS = TDB.find "CONNECTED_COMPONENT_TRANS"
  fun op CONNECTED_COMPONENT_SYM _ = ()
  val op CONNECTED_COMPONENT_SYM = TDB.find "CONNECTED_COMPONENT_SYM"
  fun op CONNECTED_COMPONENT_REFL_EQ _ = ()
  val op CONNECTED_COMPONENT_REFL_EQ = TDB.find
    "CONNECTED_COMPONENT_REFL_EQ"
  fun op CONNECTED_COMPONENT_REFL _ = ()
  val op CONNECTED_COMPONENT_REFL = TDB.find "CONNECTED_COMPONENT_REFL"
  fun op CONNECTED_COMPONENT_IN _ = ()
  val op CONNECTED_COMPONENT_IN = TDB.find "CONNECTED_COMPONENT_IN"
  fun op UPPER_LOWER_HEMICONTINUOUS_EXPLICIT _ = ()
  val op UPPER_LOWER_HEMICONTINUOUS_EXPLICIT = TDB.find
    "UPPER_LOWER_HEMICONTINUOUS_EXPLICIT"
  fun op CLOSED_MAP_IFF_UPPER_HEMICONTINUOUS_PREIMAGE _ = ()
  val op CLOSED_MAP_IFF_UPPER_HEMICONTINUOUS_PREIMAGE = TDB.find
    "CLOSED_MAP_IFF_UPPER_HEMICONTINUOUS_PREIMAGE"
  fun op OPEN_MAP_IFF_LOWER_HEMICONTINUOUS_PREIMAGE _ = ()
  val op OPEN_MAP_IFF_LOWER_HEMICONTINUOUS_PREIMAGE = TDB.find
    "OPEN_MAP_IFF_LOWER_HEMICONTINUOUS_PREIMAGE"
  fun op LOWER_HEMICONTINUOUS _ = ()
  val op LOWER_HEMICONTINUOUS = TDB.find "LOWER_HEMICONTINUOUS"
  fun op UPPER_HEMICONTINUOUS _ = ()
  val op UPPER_HEMICONTINUOUS = TDB.find "UPPER_HEMICONTINUOUS"
  fun op OPEN_SUMS _ = () val op OPEN_SUMS = TDB.find "OPEN_SUMS"
  fun op INTERIOR_TRANSLATION _ = ()
  val op INTERIOR_TRANSLATION = TDB.find "INTERIOR_TRANSLATION"
  fun op OPEN_AFFINITY _ = ()
  val op OPEN_AFFINITY = TDB.find "OPEN_AFFINITY"
  fun op OPEN_TRANSLATION_EQ _ = ()
  val op OPEN_TRANSLATION_EQ = TDB.find "OPEN_TRANSLATION_EQ"
  fun op OPEN_TRANSLATION _ = ()
  val op OPEN_TRANSLATION = TDB.find "OPEN_TRANSLATION"
  fun op OPEN_NEGATIONS _ = ()
  val op OPEN_NEGATIONS = TDB.find "OPEN_NEGATIONS"
  fun op OPEN_SCALING _ = () val op OPEN_SCALING = TDB.find "OPEN_SCALING"
  fun op CONTINUOUS_LEVELSET_OPEN _ = ()
  val op CONTINUOUS_LEVELSET_OPEN = TDB.find "CONTINUOUS_LEVELSET_OPEN"
  fun op CONTINUOUS_LEVELSET_OPEN_IN _ = ()
  val op CONTINUOUS_LEVELSET_OPEN_IN = TDB.find
    "CONTINUOUS_LEVELSET_OPEN_IN"
  fun op CONTINUOUS_LEVELSET_OPEN_IN_CASES _ = ()
  val op CONTINUOUS_LEVELSET_OPEN_IN_CASES = TDB.find
    "CONTINUOUS_LEVELSET_OPEN_IN_CASES"
  fun op CONTINUOUS_ON_OPEN_AVOID _ = ()
  val op CONTINUOUS_ON_OPEN_AVOID = TDB.find "CONTINUOUS_ON_OPEN_AVOID"
  fun op CONTINUOUS_ON_AVOID _ = ()
  val op CONTINUOUS_ON_AVOID = TDB.find "CONTINUOUS_ON_AVOID"
  fun op CONTINUOUS_AT_AVOID _ = ()
  val op CONTINUOUS_AT_AVOID = TDB.find "CONTINUOUS_AT_AVOID"
  fun op CONTINUOUS_WITHIN_AVOID _ = ()
  val op CONTINUOUS_WITHIN_AVOID = TDB.find "CONTINUOUS_WITHIN_AVOID"
  fun op INTERIOR_IMAGE_SUBSET _ = ()
  val op INTERIOR_IMAGE_SUBSET = TDB.find "INTERIOR_IMAGE_SUBSET"
  fun op CONTINUOUS_AT_TRANSLATION _ = ()
  val op CONTINUOUS_AT_TRANSLATION = TDB.find "CONTINUOUS_AT_TRANSLATION"
  fun op CONTINUOUS_AT_COMPOSE_EQ _ = ()
  val op CONTINUOUS_AT_COMPOSE_EQ = TDB.find "CONTINUOUS_AT_COMPOSE_EQ"
  fun op BOUNDED_UNIFORMLY_CONTINUOUS_IMAGE _ = ()
  val op BOUNDED_UNIFORMLY_CONTINUOUS_IMAGE = TDB.find
    "BOUNDED_UNIFORMLY_CONTINUOUS_IMAGE"
  fun op CAUCHY_CONTINUOUS_IMP_CONTINUOUS _ = ()
  val op CAUCHY_CONTINUOUS_IMP_CONTINUOUS = TDB.find
    "CAUCHY_CONTINUOUS_IMP_CONTINUOUS"
  fun op UNIFORMLY_CONTINUOUS_EXTENDS_TO_CLOSURE _ = ()
  val op UNIFORMLY_CONTINUOUS_EXTENDS_TO_CLOSURE = TDB.find
    "UNIFORMLY_CONTINUOUS_EXTENDS_TO_CLOSURE"
  fun op CAUCHY_CONTINUOUS_EXTENDS_TO_CLOSURE _ = ()
  val op CAUCHY_CONTINUOUS_EXTENDS_TO_CLOSURE = TDB.find
    "CAUCHY_CONTINUOUS_EXTENDS_TO_CLOSURE"
  fun op CAUCHY_CONTINUOUS_UNIQUENESS_LEMMA _ = ()
  val op CAUCHY_CONTINUOUS_UNIQUENESS_LEMMA = TDB.find
    "CAUCHY_CONTINUOUS_UNIQUENESS_LEMMA"
  fun op CONTINUOUS_CLOSED_IMP_CAUCHY_CONTINUOUS _ = ()
  val op CONTINUOUS_CLOSED_IMP_CAUCHY_CONTINUOUS = TDB.find
    "CONTINUOUS_CLOSED_IMP_CAUCHY_CONTINUOUS"
  fun op UNIFORMLY_CONTINUOUS_IMP_CAUCHY_CONTINUOUS _ = ()
  val op UNIFORMLY_CONTINUOUS_IMP_CAUCHY_CONTINUOUS = TDB.find
    "UNIFORMLY_CONTINUOUS_IMP_CAUCHY_CONTINUOUS"
  fun op UNIFORMLY_CONTINUOUS_ON_CLOSURE _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_CLOSURE = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_CLOSURE"
  fun op CONTINUOUS_ON_CLOSURE_SEQUENTIALLY _ = ()
  val op CONTINUOUS_ON_CLOSURE_SEQUENTIALLY = TDB.find
    "CONTINUOUS_ON_CLOSURE_SEQUENTIALLY"
  fun op CONTINUOUS_ON_CLOSURE _ = ()
  val op CONTINUOUS_ON_CLOSURE = TDB.find "CONTINUOUS_ON_CLOSURE"
  fun op CONTINUOUS_CLOSED_PREIMAGE_CONSTANT _ = ()
  val op CONTINUOUS_CLOSED_PREIMAGE_CONSTANT = TDB.find
    "CONTINUOUS_CLOSED_PREIMAGE_CONSTANT"
  fun op CONTINUOUS_CLOSED_IN_PREIMAGE_CONSTANT _ = ()
  val op CONTINUOUS_CLOSED_IN_PREIMAGE_CONSTANT = TDB.find
    "CONTINUOUS_CLOSED_IN_PREIMAGE_CONSTANT"
  fun op CONTINUOUS_AGREE_ON_CLOSURE _ = ()
  val op CONTINUOUS_AGREE_ON_CLOSURE = TDB.find
    "CONTINUOUS_AGREE_ON_CLOSURE"
  fun op CONTINUOUS_CONSTANT_ON_CLOSURE _ = ()
  val op CONTINUOUS_CONSTANT_ON_CLOSURE = TDB.find
    "CONTINUOUS_CONSTANT_ON_CLOSURE"
  fun op CONTINUOUS_GE_ON_CLOSURE _ = ()
  val op CONTINUOUS_GE_ON_CLOSURE = TDB.find "CONTINUOUS_GE_ON_CLOSURE"
  fun op CONTINUOUS_LE_ON_CLOSURE _ = ()
  val op CONTINUOUS_LE_ON_CLOSURE = TDB.find "CONTINUOUS_LE_ON_CLOSURE"
  fun op FORALL_IN_CLOSURE_EQ _ = ()
  val op FORALL_IN_CLOSURE_EQ = TDB.find "FORALL_IN_CLOSURE_EQ"
  fun op FORALL_IN_CLOSURE _ = ()
  val op FORALL_IN_CLOSURE = TDB.find "FORALL_IN_CLOSURE"
  fun op UNBOUNDED_HALFSPACE_COMPONENT_GT _ = ()
  val op UNBOUNDED_HALFSPACE_COMPONENT_GT = TDB.find
    "UNBOUNDED_HALFSPACE_COMPONENT_GT"
  fun op UNBOUNDED_HALFSPACE_COMPONENT_LT _ = ()
  val op UNBOUNDED_HALFSPACE_COMPONENT_LT = TDB.find
    "UNBOUNDED_HALFSPACE_COMPONENT_LT"
  fun op UNBOUNDED_HALFSPACE_COMPONENT_GE _ = ()
  val op UNBOUNDED_HALFSPACE_COMPONENT_GE = TDB.find
    "UNBOUNDED_HALFSPACE_COMPONENT_GE"
  fun op UNBOUNDED_HALFSPACE_COMPONENT_LE _ = ()
  val op UNBOUNDED_HALFSPACE_COMPONENT_LE = TDB.find
    "UNBOUNDED_HALFSPACE_COMPONENT_LE"
  fun op INTERIOR_STANDARD_HYPERPLANE _ = ()
  val op INTERIOR_STANDARD_HYPERPLANE = TDB.find
    "INTERIOR_STANDARD_HYPERPLANE"
  fun op FRONTIER_HALFSPACE_GT _ = ()
  val op FRONTIER_HALFSPACE_GT = TDB.find "FRONTIER_HALFSPACE_GT"
  fun op FRONTIER_HALFSPACE_LT _ = ()
  val op FRONTIER_HALFSPACE_LT = TDB.find "FRONTIER_HALFSPACE_LT"
  fun op FRONTIER_HALFSPACE_GE _ = ()
  val op FRONTIER_HALFSPACE_GE = TDB.find "FRONTIER_HALFSPACE_GE"
  fun op FRONTIER_HALFSPACE_LE _ = ()
  val op FRONTIER_HALFSPACE_LE = TDB.find "FRONTIER_HALFSPACE_LE"
  fun op INTERIOR_HYPERPLANE _ = ()
  val op INTERIOR_HYPERPLANE = TDB.find "INTERIOR_HYPERPLANE"
  fun op CLOSURE_HALFSPACE_COMPONENT_GT _ = ()
  val op CLOSURE_HALFSPACE_COMPONENT_GT = TDB.find
    "CLOSURE_HALFSPACE_COMPONENT_GT"
  fun op CLOSURE_HALFSPACE_COMPONENT_LT _ = ()
  val op CLOSURE_HALFSPACE_COMPONENT_LT = TDB.find
    "CLOSURE_HALFSPACE_COMPONENT_LT"
  fun op CLOSURE_HALFSPACE_GT _ = ()
  val op CLOSURE_HALFSPACE_GT = TDB.find "CLOSURE_HALFSPACE_GT"
  fun op CLOSURE_HALFSPACE_LT _ = ()
  val op CLOSURE_HALFSPACE_LT = TDB.find "CLOSURE_HALFSPACE_LT"
  fun op INTERIOR_HALFSPACE_COMPONENT_GE _ = ()
  val op INTERIOR_HALFSPACE_COMPONENT_GE = TDB.find
    "INTERIOR_HALFSPACE_COMPONENT_GE"
  fun op INTERIOR_HALFSPACE_COMPONENT_LE _ = ()
  val op INTERIOR_HALFSPACE_COMPONENT_LE = TDB.find
    "INTERIOR_HALFSPACE_COMPONENT_LE"
  fun op INTERIOR_HALFSPACE_GE _ = ()
  val op INTERIOR_HALFSPACE_GE = TDB.find "INTERIOR_HALFSPACE_GE"
  fun op INTERIOR_HALFSPACE_LE _ = ()
  val op INTERIOR_HALFSPACE_LE = TDB.find "INTERIOR_HALFSPACE_LE"
  fun op OPEN_POSITIVE_ORTHANT _ = ()
  val op OPEN_POSITIVE_ORTHANT = TDB.find "OPEN_POSITIVE_ORTHANT"
  fun op OPEN_INTERVAL_RIGHT _ = ()
  val op OPEN_INTERVAL_RIGHT = TDB.find "OPEN_INTERVAL_RIGHT"
  fun op OPEN_INTERVAL_LEFT _ = ()
  val op OPEN_INTERVAL_LEFT = TDB.find "OPEN_INTERVAL_LEFT"
  fun op OPEN_POSITIVE_MULTIPLES _ = ()
  val op OPEN_POSITIVE_MULTIPLES = TDB.find "OPEN_POSITIVE_MULTIPLES"
  fun op OPEN_HALFSPACE_COMPONENT_GT _ = ()
  val op OPEN_HALFSPACE_COMPONENT_GT = TDB.find
    "OPEN_HALFSPACE_COMPONENT_GT"
  fun op OPEN_HALFSPACE_GT _ = ()
  val op OPEN_HALFSPACE_GT = TDB.find "OPEN_HALFSPACE_GT"
  fun op OPEN_HALFSPACE_COMPONENT_LT _ = ()
  val op OPEN_HALFSPACE_COMPONENT_LT = TDB.find
    "OPEN_HALFSPACE_COMPONENT_LT"
  fun op OPEN_HALFSPACE_LT _ = ()
  val op OPEN_HALFSPACE_LT = TDB.find "OPEN_HALFSPACE_LT"
  fun op CLOSED_HALFSPACE_COMPONENT_GE _ = ()
  val op CLOSED_HALFSPACE_COMPONENT_GE = TDB.find
    "CLOSED_HALFSPACE_COMPONENT_GE"
  fun op CLOSED_HALFSPACE_COMPONENT_LE _ = ()
  val op CLOSED_HALFSPACE_COMPONENT_LE = TDB.find
    "CLOSED_HALFSPACE_COMPONENT_LE"
  fun op CLOSED_STANDARD_HYPERPLANE _ = ()
  val op CLOSED_STANDARD_HYPERPLANE = TDB.find "CLOSED_STANDARD_HYPERPLANE"
  fun op CLOSURE_HYPERPLANE _ = ()
  val op CLOSURE_HYPERPLANE = TDB.find "CLOSURE_HYPERPLANE"
  fun op CLOSED_HYPERPLANE _ = ()
  val op CLOSED_HYPERPLANE = TDB.find "CLOSED_HYPERPLANE"
  fun op CLOSED_HALFSPACE_GE _ = ()
  val op CLOSED_HALFSPACE_GE = TDB.find "CLOSED_HALFSPACE_GE"
  fun op CLOSED_HALFSPACE_LE _ = ()
  val op CLOSED_HALFSPACE_LE = TDB.find "CLOSED_HALFSPACE_LE"
  fun op CLOSED_INTERVAL_RIGHT _ = ()
  val op CLOSED_INTERVAL_RIGHT = TDB.find "CLOSED_INTERVAL_RIGHT"
  fun op CLOSED_INTERVAL_LEFT _ = ()
  val op CLOSED_INTERVAL_LEFT = TDB.find "CLOSED_INTERVAL_LEFT"
  fun op CONTINUOUS_ON_LIFT_DOT _ = ()
  val op CONTINUOUS_ON_LIFT_DOT = TDB.find "CONTINUOUS_ON_LIFT_DOT"
  fun op CONTINUOUS_AT_LIFT_DOT _ = ()
  val op CONTINUOUS_AT_LIFT_DOT = TDB.find "CONTINUOUS_AT_LIFT_DOT"
  fun op LIM_LIFT_DOT _ = () val op LIM_LIFT_DOT = TDB.find "LIM_LIFT_DOT"
  fun op PASTING_LEMMA_EXISTS_CLOSED _ = ()
  val op PASTING_LEMMA_EXISTS_CLOSED = TDB.find
    "PASTING_LEMMA_EXISTS_CLOSED"
  fun op PASTING_LEMMA_CLOSED _ = ()
  val op PASTING_LEMMA_CLOSED = TDB.find "PASTING_LEMMA_CLOSED"
  fun op CONTINUOUS_ON_CASES_OPEN _ = ()
  val op CONTINUOUS_ON_CASES_OPEN = TDB.find "CONTINUOUS_ON_CASES_OPEN"
  fun op CONTINUOUS_ON_CASES_LOCAL_OPEN _ = ()
  val op CONTINUOUS_ON_CASES_LOCAL_OPEN = TDB.find
    "CONTINUOUS_ON_CASES_LOCAL_OPEN"
  fun op CONTINUOUS_ON_UNION_OPEN _ = ()
  val op CONTINUOUS_ON_UNION_OPEN = TDB.find "CONTINUOUS_ON_UNION_OPEN"
  fun op CONTINUOUS_ON_UNION_LOCAL_OPEN _ = ()
  val op CONTINUOUS_ON_UNION_LOCAL_OPEN = TDB.find
    "CONTINUOUS_ON_UNION_LOCAL_OPEN"
  fun op PASTING_LEMMA_EXISTS _ = ()
  val op PASTING_LEMMA_EXISTS = TDB.find "PASTING_LEMMA_EXISTS"
  fun op PASTING_LEMMA _ = ()
  val op PASTING_LEMMA = TDB.find "PASTING_LEMMA"
  fun op PROPER_MAP_FROM_COMPOSITION_RIGHT _ = ()
  val op PROPER_MAP_FROM_COMPOSITION_RIGHT = TDB.find
    "PROPER_MAP_FROM_COMPOSITION_RIGHT"
  fun op PROPER_MAP_FROM_COMPOSITION_LEFT _ = ()
  val op PROPER_MAP_FROM_COMPOSITION_LEFT = TDB.find
    "PROPER_MAP_FROM_COMPOSITION_LEFT"
  fun op PROPER_MAP_COMPOSE _ = ()
  val op PROPER_MAP_COMPOSE = TDB.find "PROPER_MAP_COMPOSE"
  fun op PROPER_MAP_FROM_COMPACT _ = ()
  val op PROPER_MAP_FROM_COMPACT = TDB.find "PROPER_MAP_FROM_COMPACT"
  fun op COMPACT_CONTINUOUS_IMAGE_EQ _ = ()
  val op COMPACT_CONTINUOUS_IMAGE_EQ = TDB.find
    "COMPACT_CONTINUOUS_IMAGE_EQ"
  fun op PROPER_MAP _ = () val op PROPER_MAP = TDB.find "PROPER_MAP"
  fun op CONNECTED_CLOSED_MONOTONE_PREIMAGE _ = ()
  val op CONNECTED_CLOSED_MONOTONE_PREIMAGE = TDB.find
    "CONNECTED_CLOSED_MONOTONE_PREIMAGE"
  fun op CONNECTED_OPEN_MONOTONE_PREIMAGE _ = ()
  val op CONNECTED_OPEN_MONOTONE_PREIMAGE = TDB.find
    "CONNECTED_OPEN_MONOTONE_PREIMAGE"
  fun op CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_POINT _ = ()
  val op CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_POINT = TDB.find
    "CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_POINT"
  fun op BIGUNION_GSPEC _ = ()
  val op BIGUNION_GSPEC = TDB.find "BIGUNION_GSPEC"
  fun op BIGINTER_GSPEC _ = ()
  val op BIGINTER_GSPEC = TDB.find "BIGINTER_GSPEC"
  fun op CLOSED_FORALL_IN _ = ()
  val op CLOSED_FORALL_IN = TDB.find "CLOSED_FORALL_IN"
  fun op CLOSED_FORALL _ = ()
  val op CLOSED_FORALL = TDB.find "CLOSED_FORALL"
  fun op OPEN_CLOSED _ = () val op OPEN_CLOSED = TDB.find "OPEN_CLOSED"
  fun op OPEN_DIFF _ = () val op OPEN_DIFF = TDB.find "OPEN_DIFF"
  fun op CLOSED_DIFF _ = () val op CLOSED_DIFF = TDB.find "CLOSED_DIFF"
  fun op OPEN_BIGINTER _ = ()
  val op OPEN_BIGINTER = TDB.find "OPEN_BIGINTER"
  fun op CLOSED_BIGUNION _ = ()
  val op CLOSED_BIGUNION = TDB.find "CLOSED_BIGUNION"
  fun op IN_BALL _ = () val op IN_BALL = TDB.find "IN_BALL"
  fun op IN_CBALL _ = () val op IN_CBALL = TDB.find "IN_CBALL"
  fun op IN_SPHERE _ = () val op IN_SPHERE = TDB.find "IN_SPHERE"
  fun op IN_BALL_0 _ = () val op IN_BALL_0 = TDB.find "IN_BALL_0"
  fun op IN_CBALL_0 _ = () val op IN_CBALL_0 = TDB.find "IN_CBALL_0"
  fun op IN_SPHERE_0 _ = () val op IN_SPHERE_0 = TDB.find "IN_SPHERE_0"
  fun op BALL_TRIVIAL _ = () val op BALL_TRIVIAL = TDB.find "BALL_TRIVIAL"
  fun op CBALL_TRIVIAL _ = ()
  val op CBALL_TRIVIAL = TDB.find "CBALL_TRIVIAL"
  fun op CENTRE_IN_CBALL _ = ()
  val op CENTRE_IN_CBALL = TDB.find "CENTRE_IN_CBALL"
  fun op BALL_SUBSET_CBALL _ = ()
  val op BALL_SUBSET_CBALL = TDB.find "BALL_SUBSET_CBALL"
  fun op SPHERE_SUBSET_CBALL _ = ()
  val op SPHERE_SUBSET_CBALL = TDB.find "SPHERE_SUBSET_CBALL"
  fun op SUBSET_BALL _ = () val op SUBSET_BALL = TDB.find "SUBSET_BALL"
  fun op SUBSET_CBALL _ = () val op SUBSET_CBALL = TDB.find "SUBSET_CBALL"
  fun op BALL_MAX_UNION _ = ()
  val op BALL_MAX_UNION = TDB.find "BALL_MAX_UNION"
  fun op BALL_MIN_INTER _ = ()
  val op BALL_MIN_INTER = TDB.find "BALL_MIN_INTER"
  fun op CBALL_MAX_UNION _ = ()
  val op CBALL_MAX_UNION = TDB.find "CBALL_MAX_UNION"
  fun op CBALL_MIN_INTER _ = ()
  val op CBALL_MIN_INTER = TDB.find "CBALL_MIN_INTER"
  fun op BALL_TRANSLATION _ = ()
  val op BALL_TRANSLATION = TDB.find "BALL_TRANSLATION"
  fun op CBALL_TRANSLATION _ = ()
  val op CBALL_TRANSLATION = TDB.find "CBALL_TRANSLATION"
  fun op SPHERE_TRANSLATION _ = ()
  val op SPHERE_TRANSLATION = TDB.find "SPHERE_TRANSLATION"
  fun op BALL_LINEAR_IMAGE _ = ()
  val op BALL_LINEAR_IMAGE = TDB.find "BALL_LINEAR_IMAGE"
  fun op CBALL_LINEAR_IMAGE _ = ()
  val op CBALL_LINEAR_IMAGE = TDB.find "CBALL_LINEAR_IMAGE"
  fun op SPHERE_LINEAR_IMAGE _ = ()
  val op SPHERE_LINEAR_IMAGE = TDB.find "SPHERE_LINEAR_IMAGE"
  fun op BALL_SCALING _ = () val op BALL_SCALING = TDB.find "BALL_SCALING"
  fun op CBALL_SCALING _ = ()
  val op CBALL_SCALING = TDB.find "CBALL_SCALING"
  fun op CBALL_DIFF_BALL _ = ()
  val op CBALL_DIFF_BALL = TDB.find "CBALL_DIFF_BALL"
  fun op BALL_UNION_SPHERE _ = ()
  val op BALL_UNION_SPHERE = TDB.find "BALL_UNION_SPHERE"
  fun op SPHERE_UNION_BALL _ = ()
  val op SPHERE_UNION_BALL = TDB.find "SPHERE_UNION_BALL"
  fun op CBALL_DIFF_SPHERE _ = ()
  val op CBALL_DIFF_SPHERE = TDB.find "CBALL_DIFF_SPHERE"
  fun op OPEN_BALL _ = () val op OPEN_BALL = TDB.find "OPEN_BALL"
  fun op CENTRE_IN_BALL _ = ()
  val op CENTRE_IN_BALL = TDB.find "CENTRE_IN_BALL"
  fun op OPEN_CONTAINS_BALL _ = ()
  val op OPEN_CONTAINS_BALL = TDB.find "OPEN_CONTAINS_BALL"
  fun op OPEN_CONTAINS_BALL_EQ _ = ()
  val op OPEN_CONTAINS_BALL_EQ = TDB.find "OPEN_CONTAINS_BALL_EQ"
  fun op BALL_EQ_EMPTY _ = ()
  val op BALL_EQ_EMPTY = TDB.find "BALL_EQ_EMPTY"
  fun op BALL_EMPTY _ = () val op BALL_EMPTY = TDB.find "BALL_EMPTY"
  fun op OPEN_CONTAINS_CBALL _ = ()
  val op OPEN_CONTAINS_CBALL = TDB.find "OPEN_CONTAINS_CBALL"
  fun op OPEN_CONTAINS_CBALL_EQ _ = ()
  val op OPEN_CONTAINS_CBALL_EQ = TDB.find "OPEN_CONTAINS_CBALL_EQ"
  fun op SPHERE_EQ_EMPTY _ = ()
  val op SPHERE_EQ_EMPTY = TDB.find "SPHERE_EQ_EMPTY"
  fun op SPHERE_EMPTY _ = () val op SPHERE_EMPTY = TDB.find "SPHERE_EMPTY"
  fun op NEGATIONS_BALL _ = ()
  val op NEGATIONS_BALL = TDB.find "NEGATIONS_BALL"
  fun op NEGATIONS_CBALL _ = ()
  val op NEGATIONS_CBALL = TDB.find "NEGATIONS_CBALL"
  fun op NEGATIONS_SPHERE _ = ()
  val op NEGATIONS_SPHERE = TDB.find "NEGATIONS_SPHERE"
  fun op OPEN_IN_OPEN _ = () val op OPEN_IN_OPEN = TDB.find "OPEN_IN_OPEN"
  fun op OPEN_IN_INTER_OPEN _ = ()
  val op OPEN_IN_INTER_OPEN = TDB.find "OPEN_IN_INTER_OPEN"
  fun op OPEN_IN_OPEN_INTER _ = ()
  val op OPEN_IN_OPEN_INTER = TDB.find "OPEN_IN_OPEN_INTER"
  fun op OPEN_OPEN_IN_TRANS _ = ()
  val op OPEN_OPEN_IN_TRANS = TDB.find "OPEN_OPEN_IN_TRANS"
  fun op OPEN_SUBSET _ = () val op OPEN_SUBSET = TDB.find "OPEN_SUBSET"
  fun op CLOSED_IN_CLOSED _ = ()
  val op CLOSED_IN_CLOSED = TDB.find "CLOSED_IN_CLOSED"
  fun op CLOSED_SUBSET_EQ _ = ()
  val op CLOSED_SUBSET_EQ = TDB.find "CLOSED_SUBSET_EQ"
  fun op CLOSED_IN_INTER_CLOSED _ = ()
  val op CLOSED_IN_INTER_CLOSED = TDB.find "CLOSED_IN_INTER_CLOSED"
  fun op CLOSED_IN_CLOSED_INTER _ = ()
  val op CLOSED_IN_CLOSED_INTER = TDB.find "CLOSED_IN_CLOSED_INTER"
  fun op CLOSED_SUBSET _ = ()
  val op CLOSED_SUBSET = TDB.find "CLOSED_SUBSET"
  fun op OPEN_IN_SUBSET_TRANS _ = ()
  val op OPEN_IN_SUBSET_TRANS = TDB.find "OPEN_IN_SUBSET_TRANS"
  fun op CLOSED_IN_SUBSET_TRANS _ = ()
  val op CLOSED_IN_SUBSET_TRANS = TDB.find "CLOSED_IN_SUBSET_TRANS"
  fun op open_in _ = () val op open_in = TDB.find "open_in"
  fun op OPEN_IN_CONTAINS_BALL _ = ()
  val op OPEN_IN_CONTAINS_BALL = TDB.find "OPEN_IN_CONTAINS_BALL"
  fun op OPEN_IN_CONTAINS_CBALL _ = ()
  val op OPEN_IN_CONTAINS_CBALL = TDB.find "OPEN_IN_CONTAINS_CBALL"
  fun op OPEN_IN_TRANS _ = ()
  val op OPEN_IN_TRANS = TDB.find "OPEN_IN_TRANS"
  fun op OPEN_IN_TRANS_EQ _ = ()
  val op OPEN_IN_TRANS_EQ = TDB.find "OPEN_IN_TRANS_EQ"
  fun op OPEN_IN_OPEN_TRANS _ = ()
  val op OPEN_IN_OPEN_TRANS = TDB.find "OPEN_IN_OPEN_TRANS"
  fun op CLOSED_IN_TRANS _ = ()
  val op CLOSED_IN_TRANS = TDB.find "CLOSED_IN_TRANS"
  fun op CLOSED_IN_TRANS_EQ _ = ()
  val op CLOSED_IN_TRANS_EQ = TDB.find "CLOSED_IN_TRANS_EQ"
  fun op CLOSED_IN_CLOSED_TRANS _ = ()
  val op CLOSED_IN_CLOSED_TRANS = TDB.find "CLOSED_IN_CLOSED_TRANS"
  fun op OPEN_IN_SUBTOPOLOGY_INTER_SUBSET _ = ()
  val op OPEN_IN_SUBTOPOLOGY_INTER_SUBSET = TDB.find
    "OPEN_IN_SUBTOPOLOGY_INTER_SUBSET"
  fun op OPEN_IN_OPEN_EQ _ = ()
  val op OPEN_IN_OPEN_EQ = TDB.find "OPEN_IN_OPEN_EQ"
  fun op CLOSED_IN_CLOSED_EQ _ = ()
  val op CLOSED_IN_CLOSED_EQ = TDB.find "CLOSED_IN_CLOSED_EQ"
  fun op OPEN_SEGMENT_ALT _ = ()
  val op OPEN_SEGMENT_ALT = TDB.find "OPEN_SEGMENT_ALT"
  fun op segment _ = () val op segment = TDB.find "segment"
  fun op SEGMENT_REFL _ = () val op SEGMENT_REFL = TDB.find "SEGMENT_REFL"
  fun op IN_SEGMENT _ = () val op IN_SEGMENT = TDB.find "IN_SEGMENT"
  fun op SEGMENT_SYM _ = () val op SEGMENT_SYM = TDB.find "SEGMENT_SYM"
  fun op ENDS_IN_SEGMENT _ = ()
  val op ENDS_IN_SEGMENT = TDB.find "ENDS_IN_SEGMENT"
  fun op ENDS_NOT_IN_SEGMENT _ = ()
  val op ENDS_NOT_IN_SEGMENT = TDB.find "ENDS_NOT_IN_SEGMENT"
  fun op SEGMENT_CLOSED_OPEN _ = ()
  val op SEGMENT_CLOSED_OPEN = TDB.find "SEGMENT_CLOSED_OPEN"
  fun op SEGMENT_OPEN_SUBSET_CLOSED _ = ()
  val op SEGMENT_OPEN_SUBSET_CLOSED = TDB.find "SEGMENT_OPEN_SUBSET_CLOSED"
  fun op MIDPOINT_IN_SEGMENT _ = ()
  val op MIDPOINT_IN_SEGMENT = TDB.find "MIDPOINT_IN_SEGMENT"
  fun op BETWEEN_IN_SEGMENT _ = ()
  val op BETWEEN_IN_SEGMENT = TDB.find "BETWEEN_IN_SEGMENT"
  fun op REAL_CONVEX_BOUND_LE _ = ()
  val op REAL_CONVEX_BOUND_LE = TDB.find "REAL_CONVEX_BOUND_LE"
  fun op IN_SEGMENT_COMPONENT _ = ()
  val op IN_SEGMENT_COMPONENT = TDB.find "IN_SEGMENT_COMPONENT"
  fun op SEGMENT_TRANSLATION _ = ()
  val op SEGMENT_TRANSLATION = TDB.find "SEGMENT_TRANSLATION"
  fun op CLOSED_SEGMENT_LINEAR_IMAGE _ = ()
  val op CLOSED_SEGMENT_LINEAR_IMAGE = TDB.find
    "CLOSED_SEGMENT_LINEAR_IMAGE"
  fun op OPEN_SEGMENT_LINEAR_IMAGE _ = ()
  val op OPEN_SEGMENT_LINEAR_IMAGE = TDB.find "OPEN_SEGMENT_LINEAR_IMAGE"
  fun op IN_OPEN_SEGMENT _ = ()
  val op IN_OPEN_SEGMENT = TDB.find "IN_OPEN_SEGMENT"
  fun op IN_OPEN_SEGMENT_ALT _ = ()
  val op IN_OPEN_SEGMENT_ALT = TDB.find "IN_OPEN_SEGMENT_ALT"
  fun op COLLINEAR_DIST_IN_CLOSED_SEGMENT _ = ()
  val op COLLINEAR_DIST_IN_CLOSED_SEGMENT = TDB.find
    "COLLINEAR_DIST_IN_CLOSED_SEGMENT"
  fun op COLLINEAR_DIST_IN_OPEN_SEGMENT _ = ()
  val op COLLINEAR_DIST_IN_OPEN_SEGMENT = TDB.find
    "COLLINEAR_DIST_IN_OPEN_SEGMENT"
  fun op DIST_IN_OPEN_CLOSED_SEGMENT _ = ()
  val op DIST_IN_OPEN_CLOSED_SEGMENT = TDB.find
    "DIST_IN_OPEN_CLOSED_SEGMENT"
  fun op DIST_IN_CLOSED_SEGMENT _ = ()
  val op DIST_IN_CLOSED_SEGMENT = TDB.find "DIST_IN_CLOSED_SEGMENT"
  fun op DIST_IN_OPEN_SEGMENT _ = ()
  val op DIST_IN_OPEN_SEGMENT = TDB.find "DIST_IN_OPEN_SEGMENT"
  fun op CONNECTED_CLOSED _ = ()
  val op CONNECTED_CLOSED = TDB.find "CONNECTED_CLOSED"
  fun op CONNECTED_OPEN_IN _ = ()
  val op CONNECTED_OPEN_IN = TDB.find "CONNECTED_OPEN_IN"
  fun op CONNECTED_OPEN_IN_EQ _ = ()
  val op CONNECTED_OPEN_IN_EQ = TDB.find "CONNECTED_OPEN_IN_EQ"
  fun op CONNECTED_CLOSED_IN _ = ()
  val op CONNECTED_CLOSED_IN = TDB.find "CONNECTED_CLOSED_IN"
  fun op CONNECTED_CLOSED_IN_EQ _ = ()
  val op CONNECTED_CLOSED_IN_EQ = TDB.find "CONNECTED_CLOSED_IN_EQ"
  fun op EXISTS_DIFF _ = () val op EXISTS_DIFF = TDB.find "EXISTS_DIFF"
  fun op CONNECTED_CLOPEN _ = ()
  val op CONNECTED_CLOPEN = TDB.find "CONNECTED_CLOPEN"
  fun op CONNECTED_CLOSED_SET _ = ()
  val op CONNECTED_CLOSED_SET = TDB.find "CONNECTED_CLOSED_SET"
  fun op CONNECTED_OPEN_SET _ = ()
  val op CONNECTED_OPEN_SET = TDB.find "CONNECTED_OPEN_SET"
  fun op CONNECTED_IFF_CONNECTABLE_POINTS _ = ()
  val op CONNECTED_IFF_CONNECTABLE_POINTS = TDB.find
    "CONNECTED_IFF_CONNECTABLE_POINTS"
  fun op CONNECTED_EMPTY _ = ()
  val op CONNECTED_EMPTY = TDB.find "CONNECTED_EMPTY"
  fun op CONNECTED_SING _ = ()
  val op CONNECTED_SING = TDB.find "CONNECTED_SING"
  fun op CONNECTED_REAL_LEMMA _ = ()
  val op CONNECTED_REAL_LEMMA = TDB.find "CONNECTED_REAL_LEMMA"
  fun op CONNECTED_SEGMENT _ = ()
  val op CONNECTED_SEGMENT = TDB.find "CONNECTED_SEGMENT"
  fun op CONNECTED_UNIV _ = ()
  val op CONNECTED_UNIV = TDB.find "CONNECTED_UNIV"
  fun op CLOPEN _ = () val op CLOPEN = TDB.find "CLOPEN"
  fun op CONNECTED_BIGUNION _ = ()
  val op CONNECTED_BIGUNION = TDB.find "CONNECTED_BIGUNION"
  fun op CONNECTED_UNION _ = ()
  val op CONNECTED_UNION = TDB.find "CONNECTED_UNION"
  fun op CONNECTED_DIFF_OPEN_FROM_CLOSED _ = ()
  val op CONNECTED_DIFF_OPEN_FROM_CLOSED = TDB.find
    "CONNECTED_DIFF_OPEN_FROM_CLOSED"
  fun op CONNECTED_DISJOINT_BIGUNION_OPEN_UNIQUE _ = ()
  val op CONNECTED_DISJOINT_BIGUNION_OPEN_UNIQUE = TDB.find
    "CONNECTED_DISJOINT_BIGUNION_OPEN_UNIQUE"
  fun op CONNECTED_FROM_CLOSED_UNION_AND_INTER _ = ()
  val op CONNECTED_FROM_CLOSED_UNION_AND_INTER = TDB.find
    "CONNECTED_FROM_CLOSED_UNION_AND_INTER"
  fun op CONNECTED_FROM_OPEN_UNION_AND_INTER _ = ()
  val op CONNECTED_FROM_OPEN_UNION_AND_INTER = TDB.find
    "CONNECTED_FROM_OPEN_UNION_AND_INTER"
  fun op CONNECTED_INDUCTION _ = ()
  val op CONNECTED_INDUCTION = TDB.find "CONNECTED_INDUCTION"
  fun op CONNECTED_EQUIVALENCE_RELATION_GEN _ = ()
  val op CONNECTED_EQUIVALENCE_RELATION_GEN = TDB.find
    "CONNECTED_EQUIVALENCE_RELATION_GEN"
  fun op CONNECTED_INDUCTION_SIMPLE _ = ()
  val op CONNECTED_INDUCTION_SIMPLE = TDB.find "CONNECTED_INDUCTION_SIMPLE"
  fun op CONNECTED_EQUIVALENCE_RELATION _ = ()
  val op CONNECTED_EQUIVALENCE_RELATION = TDB.find
    "CONNECTED_EQUIVALENCE_RELATION"
  fun op LIMPT_SUBSET _ = () val op LIMPT_SUBSET = TDB.find "LIMPT_SUBSET"
  fun op LIMPT_APPROACHABLE _ = ()
  val op LIMPT_APPROACHABLE = TDB.find "LIMPT_APPROACHABLE"
  fun op APPROACHABLE_LT_LE _ = ()
  val op APPROACHABLE_LT_LE = TDB.find "APPROACHABLE_LT_LE"
  fun op LIMPT_APPROACHABLE_LE _ = ()
  val op LIMPT_APPROACHABLE_LE = TDB.find "LIMPT_APPROACHABLE_LE"
  fun op REAL_CHOOSE_SIZE _ = ()
  val op REAL_CHOOSE_SIZE = TDB.find "REAL_CHOOSE_SIZE"
  fun op LIMPT_UNIV _ = () val op LIMPT_UNIV = TDB.find "LIMPT_UNIV"
  fun op CLOSED_LIMPT _ = () val op CLOSED_LIMPT = TDB.find "CLOSED_LIMPT"
  fun op LIMPT_EMPTY _ = () val op LIMPT_EMPTY = TDB.find "LIMPT_EMPTY"
  fun op NO_LIMIT_POINT_IMP_CLOSED _ = ()
  val op NO_LIMIT_POINT_IMP_CLOSED = TDB.find "NO_LIMIT_POINT_IMP_CLOSED"
  fun op CLOSED_POSITIVE_ORTHANT _ = ()
  val op CLOSED_POSITIVE_ORTHANT = TDB.find "CLOSED_POSITIVE_ORTHANT"
  fun op FINITE_SET_AVOID _ = ()
  val op FINITE_SET_AVOID = TDB.find "FINITE_SET_AVOID"
  fun op LIMIT_POINT_FINITE _ = ()
  val op LIMIT_POINT_FINITE = TDB.find "LIMIT_POINT_FINITE"
  fun op LIMPT_SING _ = () val op LIMPT_SING = TDB.find "LIMPT_SING"
  fun op LIMIT_POINT_UNION _ = ()
  val op LIMIT_POINT_UNION = TDB.find "LIMIT_POINT_UNION"
  fun op LIMPT_INSERT _ = () val op LIMPT_INSERT = TDB.find "LIMPT_INSERT"
  fun op LIMPT_OF_LIMPTS _ = ()
  val op LIMPT_OF_LIMPTS = TDB.find "LIMPT_OF_LIMPTS"
  fun op CLOSED_LIMPTS _ = ()
  val op CLOSED_LIMPTS = TDB.find "CLOSED_LIMPTS"
  fun op DISCRETE_IMP_CLOSED _ = ()
  val op DISCRETE_IMP_CLOSED = TDB.find "DISCRETE_IMP_CLOSED"
  fun op LIMPT_OF_UNIV _ = ()
  val op LIMPT_OF_UNIV = TDB.find "LIMPT_OF_UNIV"
  fun op LIMPT_OF_OPEN_IN _ = ()
  val op LIMPT_OF_OPEN_IN = TDB.find "LIMPT_OF_OPEN_IN"
  fun op LIMPT_OF_OPEN _ = ()
  val op LIMPT_OF_OPEN = TDB.find "LIMPT_OF_OPEN"
  fun op OPEN_IN_SING _ = () val op OPEN_IN_SING = TDB.find "OPEN_IN_SING"
  fun op INTERIOR_EQ _ = () val op INTERIOR_EQ = TDB.find "INTERIOR_EQ"
  fun op INTERIOR_OPEN _ = ()
  val op INTERIOR_OPEN = TDB.find "INTERIOR_OPEN"
  fun op INTERIOR_EMPTY _ = ()
  val op INTERIOR_EMPTY = TDB.find "INTERIOR_EMPTY"
  fun op INTERIOR_UNIV _ = ()
  val op INTERIOR_UNIV = TDB.find "INTERIOR_UNIV"
  fun op OPEN_INTERIOR _ = ()
  val op OPEN_INTERIOR = TDB.find "OPEN_INTERIOR"
  fun op INTERIOR_INTERIOR _ = ()
  val op INTERIOR_INTERIOR = TDB.find "INTERIOR_INTERIOR"
  fun op INTERIOR_SUBSET _ = ()
  val op INTERIOR_SUBSET = TDB.find "INTERIOR_SUBSET"
  fun op SUBSET_INTERIOR_EQ _ = ()
  val op SUBSET_INTERIOR_EQ = TDB.find "SUBSET_INTERIOR_EQ"
  fun op SUBSET_INTERIOR _ = ()
  val op SUBSET_INTERIOR = TDB.find "SUBSET_INTERIOR"
  fun op INTERIOR_MAXIMAL _ = ()
  val op INTERIOR_MAXIMAL = TDB.find "INTERIOR_MAXIMAL"
  fun op INTERIOR_MAXIMAL_EQ _ = ()
  val op INTERIOR_MAXIMAL_EQ = TDB.find "INTERIOR_MAXIMAL_EQ"
  fun op INTERIOR_UNIQUE _ = ()
  val op INTERIOR_UNIQUE = TDB.find "INTERIOR_UNIQUE"
  fun op IN_INTERIOR _ = () val op IN_INTERIOR = TDB.find "IN_INTERIOR"
  fun op OPEN_SUBSET_INTERIOR _ = ()
  val op OPEN_SUBSET_INTERIOR = TDB.find "OPEN_SUBSET_INTERIOR"
  fun op INTERIOR_INTER _ = ()
  val op INTERIOR_INTER = TDB.find "INTERIOR_INTER"
  fun op INTERIOR_FINITE_BIGINTER _ = ()
  val op INTERIOR_FINITE_BIGINTER = TDB.find "INTERIOR_FINITE_BIGINTER"
  fun op INTERIOR_BIGINTER_SUBSET _ = ()
  val op INTERIOR_BIGINTER_SUBSET = TDB.find "INTERIOR_BIGINTER_SUBSET"
  fun op UNION_INTERIOR_SUBSET _ = ()
  val op UNION_INTERIOR_SUBSET = TDB.find "UNION_INTERIOR_SUBSET"
  fun op INTERIOR_EQ_EMPTY _ = ()
  val op INTERIOR_EQ_EMPTY = TDB.find "INTERIOR_EQ_EMPTY"
  fun op INTERIOR_EQ_EMPTY_ALT _ = ()
  val op INTERIOR_EQ_EMPTY_ALT = TDB.find "INTERIOR_EQ_EMPTY_ALT"
  fun op INTERIOR_LIMIT_POINT _ = ()
  val op INTERIOR_LIMIT_POINT = TDB.find "INTERIOR_LIMIT_POINT"
  fun op INTERIOR_SING _ = ()
  val op INTERIOR_SING = TDB.find "INTERIOR_SING"
  fun op INTERIOR_CLOSED_UNION_EMPTY_INTERIOR _ = ()
  val op INTERIOR_CLOSED_UNION_EMPTY_INTERIOR = TDB.find
    "INTERIOR_CLOSED_UNION_EMPTY_INTERIOR"
  fun op INTERIOR_UNION_EQ_EMPTY _ = ()
  val op INTERIOR_UNION_EQ_EMPTY = TDB.find "INTERIOR_UNION_EQ_EMPTY"
  fun op INTERIOR_UNIONS_OPEN_SUBSETS _ = ()
  val op INTERIOR_UNIONS_OPEN_SUBSETS = TDB.find
    "INTERIOR_UNIONS_OPEN_SUBSETS"
  fun op REAL_ARCH_INV _ = ()
  val op REAL_ARCH_INV = TDB.find "REAL_ARCH_INV"
  fun op REAL_POW_LBOUND _ = ()
  val op REAL_POW_LBOUND = TDB.find "REAL_POW_LBOUND"
  fun op REAL_ARCH_POW _ = ()
  val op REAL_ARCH_POW = TDB.find "REAL_ARCH_POW"
  fun op REAL_ARCH_POW2 _ = ()
  val op REAL_ARCH_POW2 = TDB.find "REAL_ARCH_POW2"
  fun op REAL_ARCH_POW_INV _ = ()
  val op REAL_ARCH_POW_INV = TDB.find "REAL_ARCH_POW_INV"
  fun op FORALL_POS_MONO _ = ()
  val op FORALL_POS_MONO = TDB.find "FORALL_POS_MONO"
  fun op FORALL_SUC _ = () val op FORALL_SUC = TDB.find "FORALL_SUC"
  fun op LT_NZ _ = () val op LT_NZ = TDB.find "LT_NZ"
  fun op REAL_ARCH_RDIV_EQ_0 _ = ()
  val op REAL_ARCH_RDIV_EQ_0 = TDB.find "REAL_ARCH_RDIV_EQ_0"
  fun op CLOSURE_APPROACHABLE _ = ()
  val op CLOSURE_APPROACHABLE = TDB.find "CLOSURE_APPROACHABLE"
  fun op CLOSURE_NONEMPTY_OPEN_INTER _ = ()
  val op CLOSURE_NONEMPTY_OPEN_INTER = TDB.find
    "CLOSURE_NONEMPTY_OPEN_INTER"
  fun op CLOSURE_INTERIOR _ = ()
  val op CLOSURE_INTERIOR = TDB.find "CLOSURE_INTERIOR"
  fun op INTERIOR_CLOSURE _ = ()
  val op INTERIOR_CLOSURE = TDB.find "INTERIOR_CLOSURE"
  fun op CLOSED_CLOSURE _ = ()
  val op CLOSED_CLOSURE = TDB.find "CLOSED_CLOSURE"
  fun op CLOSURE_HULL _ = () val op CLOSURE_HULL = TDB.find "CLOSURE_HULL"
  fun op CLOSURE_EQ _ = () val op CLOSURE_EQ = TDB.find "CLOSURE_EQ"
  fun op CLOSURE_CLOSED _ = ()
  val op CLOSURE_CLOSED = TDB.find "CLOSURE_CLOSED"
  fun op CLOSURE_CLOSURE _ = ()
  val op CLOSURE_CLOSURE = TDB.find "CLOSURE_CLOSURE"
  fun op CLOSURE_SUBSET _ = ()
  val op CLOSURE_SUBSET = TDB.find "CLOSURE_SUBSET"
  fun op SUBSET_CLOSURE _ = ()
  val op SUBSET_CLOSURE = TDB.find "SUBSET_CLOSURE"
  fun op CLOSURE_UNION _ = ()
  val op CLOSURE_UNION = TDB.find "CLOSURE_UNION"
  fun op CLOSURE_INTER_SUBSET _ = ()
  val op CLOSURE_INTER_SUBSET = TDB.find "CLOSURE_INTER_SUBSET"
  fun op CLOSURE_BIGINTER_SUBSET _ = ()
  val op CLOSURE_BIGINTER_SUBSET = TDB.find "CLOSURE_BIGINTER_SUBSET"
  fun op CLOSURE_MINIMAL _ = ()
  val op CLOSURE_MINIMAL = TDB.find "CLOSURE_MINIMAL"
  fun op CLOSURE_MINIMAL_EQ _ = ()
  val op CLOSURE_MINIMAL_EQ = TDB.find "CLOSURE_MINIMAL_EQ"
  fun op CLOSURE_UNIQUE _ = ()
  val op CLOSURE_UNIQUE = TDB.find "CLOSURE_UNIQUE"
  fun op CLOSURE_EMPTY _ = ()
  val op CLOSURE_EMPTY = TDB.find "CLOSURE_EMPTY"
  fun op CLOSURE_UNIV _ = () val op CLOSURE_UNIV = TDB.find "CLOSURE_UNIV"
  fun op CLOSURE_BIGUNION _ = ()
  val op CLOSURE_BIGUNION = TDB.find "CLOSURE_BIGUNION"
  fun op CLOSURE_EQ_EMPTY _ = ()
  val op CLOSURE_EQ_EMPTY = TDB.find "CLOSURE_EQ_EMPTY"
  fun op CLOSURE_SUBSET_EQ _ = ()
  val op CLOSURE_SUBSET_EQ = TDB.find "CLOSURE_SUBSET_EQ"
  fun op OPEN_INTER_CLOSURE_EQ_EMPTY _ = ()
  val op OPEN_INTER_CLOSURE_EQ_EMPTY = TDB.find
    "OPEN_INTER_CLOSURE_EQ_EMPTY"
  fun op CLOSURE_OPEN_IN_INTER_CLOSURE _ = ()
  val op CLOSURE_OPEN_IN_INTER_CLOSURE = TDB.find
    "CLOSURE_OPEN_IN_INTER_CLOSURE"
  fun op CLOSURE_OPEN_INTER_CLOSURE _ = ()
  val op CLOSURE_OPEN_INTER_CLOSURE = TDB.find "CLOSURE_OPEN_INTER_CLOSURE"
  fun op OPEN_INTER_CLOSURE_SUBSET _ = ()
  val op OPEN_INTER_CLOSURE_SUBSET = TDB.find "OPEN_INTER_CLOSURE_SUBSET"
  fun op CLOSURE_OPEN_INTER_SUPERSET _ = ()
  val op CLOSURE_OPEN_INTER_SUPERSET = TDB.find
    "CLOSURE_OPEN_INTER_SUPERSET"
  fun op CLOSURE_COMPLEMENT _ = ()
  val op CLOSURE_COMPLEMENT = TDB.find "CLOSURE_COMPLEMENT"
  fun op INTERIOR_COMPLEMENT _ = ()
  val op INTERIOR_COMPLEMENT = TDB.find "INTERIOR_COMPLEMENT"
  fun op CONNECTED_INTERMEDIATE_CLOSURE _ = ()
  val op CONNECTED_INTERMEDIATE_CLOSURE = TDB.find
    "CONNECTED_INTERMEDIATE_CLOSURE"
  fun op CONNECTED_CLOSURE _ = ()
  val op CONNECTED_CLOSURE = TDB.find "CONNECTED_CLOSURE"
  fun op CONNECTED_UNION_STRONG _ = ()
  val op CONNECTED_UNION_STRONG = TDB.find "CONNECTED_UNION_STRONG"
  fun op INTERIOR_DIFF _ = ()
  val op INTERIOR_DIFF = TDB.find "INTERIOR_DIFF"
  fun op LIMPT_OF_CLOSURE _ = ()
  val op LIMPT_OF_CLOSURE = TDB.find "LIMPT_OF_CLOSURE"
  fun op CLOSED_IN_LIMPT _ = ()
  val op CLOSED_IN_LIMPT = TDB.find "CLOSED_IN_LIMPT"
  fun op CLOSED_IN_INTER_CLOSURE _ = ()
  val op CLOSED_IN_INTER_CLOSURE = TDB.find "CLOSED_IN_INTER_CLOSURE"
  fun op INTERIOR_CLOSURE_IDEMP _ = ()
  val op INTERIOR_CLOSURE_IDEMP = TDB.find "INTERIOR_CLOSURE_IDEMP"
  fun op CLOSURE_INTERIOR_IDEMP _ = ()
  val op CLOSURE_INTERIOR_IDEMP = TDB.find "CLOSURE_INTERIOR_IDEMP"
  fun op NOWHERE_DENSE_UNION _ = ()
  val op NOWHERE_DENSE_UNION = TDB.find "NOWHERE_DENSE_UNION"
  fun op NOWHERE_DENSE _ = ()
  val op NOWHERE_DENSE = TDB.find "NOWHERE_DENSE"
  fun op INTERIOR_CLOSURE_INTER_OPEN _ = ()
  val op INTERIOR_CLOSURE_INTER_OPEN = TDB.find
    "INTERIOR_CLOSURE_INTER_OPEN"
  fun op CLOSURE_INTERIOR_UNION_CLOSED _ = ()
  val op CLOSURE_INTERIOR_UNION_CLOSED = TDB.find
    "CLOSURE_INTERIOR_UNION_CLOSED"
  fun op REGULAR_OPEN_INTER _ = ()
  val op REGULAR_OPEN_INTER = TDB.find "REGULAR_OPEN_INTER"
  fun op REGULAR_CLOSED_UNION _ = ()
  val op REGULAR_CLOSED_UNION = TDB.find "REGULAR_CLOSED_UNION"
  fun op REGULAR_CLOSED_BIGUNION _ = ()
  val op REGULAR_CLOSED_BIGUNION = TDB.find "REGULAR_CLOSED_BIGUNION"
  fun op DIFF_CLOSURE_SUBSET _ = ()
  val op DIFF_CLOSURE_SUBSET = TDB.find "DIFF_CLOSURE_SUBSET"
  fun op DENSE_OPEN_INTER _ = ()
  val op DENSE_OPEN_INTER = TDB.find "DENSE_OPEN_INTER"
  fun op FRONTIER_CLOSED _ = ()
  val op FRONTIER_CLOSED = TDB.find "FRONTIER_CLOSED"
  fun op FRONTIER_CLOSURES _ = ()
  val op FRONTIER_CLOSURES = TDB.find "FRONTIER_CLOSURES"
  fun op FRONTIER_STRADDLE _ = ()
  val op FRONTIER_STRADDLE = TDB.find "FRONTIER_STRADDLE"
  fun op FRONTIER_SUBSET_CLOSED _ = ()
  val op FRONTIER_SUBSET_CLOSED = TDB.find "FRONTIER_SUBSET_CLOSED"
  fun op FRONTIER_EMPTY _ = ()
  val op FRONTIER_EMPTY = TDB.find "FRONTIER_EMPTY"
  fun op FRONTIER_UNIV _ = ()
  val op FRONTIER_UNIV = TDB.find "FRONTIER_UNIV"
  fun op FRONTIER_SUBSET_EQ _ = ()
  val op FRONTIER_SUBSET_EQ = TDB.find "FRONTIER_SUBSET_EQ"
  fun op FRONTIER_COMPLEMENT _ = ()
  val op FRONTIER_COMPLEMENT = TDB.find "FRONTIER_COMPLEMENT"
  fun op FRONTIER_DISJOINT_EQ _ = ()
  val op FRONTIER_DISJOINT_EQ = TDB.find "FRONTIER_DISJOINT_EQ"
  fun op FRONTIER_INTER_SUBSET _ = ()
  val op FRONTIER_INTER_SUBSET = TDB.find "FRONTIER_INTER_SUBSET"
  fun op FRONTIER_UNION_SUBSET _ = ()
  val op FRONTIER_UNION_SUBSET = TDB.find "FRONTIER_UNION_SUBSET"
  fun op FRONTIER_INTERIORS _ = ()
  val op FRONTIER_INTERIORS = TDB.find "FRONTIER_INTERIORS"
  fun op FRONTIER_FRONTIER_SUBSET _ = ()
  val op FRONTIER_FRONTIER_SUBSET = TDB.find "FRONTIER_FRONTIER_SUBSET"
  fun op INTERIOR_FRONTIER _ = ()
  val op INTERIOR_FRONTIER = TDB.find "INTERIOR_FRONTIER"
  fun op INTERIOR_FRONTIER_EMPTY _ = ()
  val op INTERIOR_FRONTIER_EMPTY = TDB.find "INTERIOR_FRONTIER_EMPTY"
  fun op FRONTIER_FRONTIER _ = ()
  val op FRONTIER_FRONTIER = TDB.find "FRONTIER_FRONTIER"
  fun op FRONTIER_FRONTIER_FRONTIER _ = ()
  val op FRONTIER_FRONTIER_FRONTIER = TDB.find "FRONTIER_FRONTIER_FRONTIER"
  fun op UNION_FRONTIER _ = ()
  val op UNION_FRONTIER = TDB.find "UNION_FRONTIER"
  fun op CONNECTED_INTER_FRONTIER _ = ()
  val op CONNECTED_INTER_FRONTIER = TDB.find "CONNECTED_INTER_FRONTIER"
  fun op INTERIOR_CLOSED_EQ_EMPTY_AS_FRONTIER _ = ()
  val op INTERIOR_CLOSED_EQ_EMPTY_AS_FRONTIER = TDB.find
    "INTERIOR_CLOSED_EQ_EMPTY_AS_FRONTIER"
  fun op FRONTIER_UNION _ = ()
  val op FRONTIER_UNION = TDB.find "FRONTIER_UNION"
  fun op CLOSURE_UNION_FRONTIER _ = ()
  val op CLOSURE_UNION_FRONTIER = TDB.find "CLOSURE_UNION_FRONTIER"
  fun op FRONTIER_INTERIOR_SUBSET _ = ()
  val op FRONTIER_INTERIOR_SUBSET = TDB.find "FRONTIER_INTERIOR_SUBSET"
  fun op FRONTIER_CLOSURE_SUBSET _ = ()
  val op FRONTIER_CLOSURE_SUBSET = TDB.find "FRONTIER_CLOSURE_SUBSET"
  fun op SET_DIFF_FRONTIER _ = ()
  val op SET_DIFF_FRONTIER = TDB.find "SET_DIFF_FRONTIER"
  fun op FRONTIER_INTER_SUBSET_INTER _ = ()
  val op FRONTIER_INTER_SUBSET_INTER = TDB.find
    "FRONTIER_INTER_SUBSET_INTER"
  fun op net_tybij _ = () val op net_tybij = TDB.find "net_tybij"
  fun op NET _ = () val op NET = TDB.find "NET"
  fun op OLDNET _ = () val op OLDNET = TDB.find "OLDNET"
  fun op NET_DILEMMA _ = () val op NET_DILEMMA = TDB.find "NET_DILEMMA"
  fun op AT _ = () val op AT = TDB.find "AT"
  fun op AT_INFINITY _ = () val op AT_INFINITY = TDB.find "AT_INFINITY"
  fun op AT_POSINFINITY _ = ()
  val op AT_POSINFINITY = TDB.find "AT_POSINFINITY"
  fun op AT_NEGINFINITY _ = ()
  val op AT_NEGINFINITY = TDB.find "AT_NEGINFINITY"
  fun op SEQUENTIALLY _ = () val op SEQUENTIALLY = TDB.find "SEQUENTIALLY"
  fun op WITHIN _ = () val op WITHIN = TDB.find "WITHIN"
  fun op IN_DIRECTION _ = () val op IN_DIRECTION = TDB.find "IN_DIRECTION"
  fun op WITHIN_UNIV _ = () val op WITHIN_UNIV = TDB.find "WITHIN_UNIV"
  fun op WITHIN_WITHIN _ = ()
  val op WITHIN_WITHIN = TDB.find "WITHIN_WITHIN"
  fun op TRIVIAL_LIMIT_WITHIN _ = ()
  val op TRIVIAL_LIMIT_WITHIN = TDB.find "TRIVIAL_LIMIT_WITHIN"
  fun op TRIVIAL_LIMIT_AT _ = ()
  val op TRIVIAL_LIMIT_AT = TDB.find "TRIVIAL_LIMIT_AT"
  fun op TRIVIAL_LIMIT_AT_INFINITY _ = ()
  val op TRIVIAL_LIMIT_AT_INFINITY = TDB.find "TRIVIAL_LIMIT_AT_INFINITY"
  fun op TRIVIAL_LIMIT_AT_POSINFINITY _ = ()
  val op TRIVIAL_LIMIT_AT_POSINFINITY = TDB.find
    "TRIVIAL_LIMIT_AT_POSINFINITY"
  fun op TRIVIAL_LIMIT_AT_NEGINFINITY _ = ()
  val op TRIVIAL_LIMIT_AT_NEGINFINITY = TDB.find
    "TRIVIAL_LIMIT_AT_NEGINFINITY"
  fun op TRIVIAL_LIMIT_SEQUENTIALLY _ = ()
  val op TRIVIAL_LIMIT_SEQUENTIALLY = TDB.find "TRIVIAL_LIMIT_SEQUENTIALLY"
  fun op LIM_WITHIN_CLOSED_TRIVIAL _ = ()
  val op LIM_WITHIN_CLOSED_TRIVIAL = TDB.find "LIM_WITHIN_CLOSED_TRIVIAL"
  fun op NONTRIVIAL_LIMIT_WITHIN _ = ()
  val op NONTRIVIAL_LIMIT_WITHIN = TDB.find "NONTRIVIAL_LIMIT_WITHIN"
  fun op EVENTUALLY_HAPPENS _ = ()
  val op EVENTUALLY_HAPPENS = TDB.find "EVENTUALLY_HAPPENS"
  fun op EVENTUALLY_WITHIN_LE _ = ()
  val op EVENTUALLY_WITHIN_LE = TDB.find "EVENTUALLY_WITHIN_LE"
  fun op EVENTUALLY_WITHIN _ = ()
  val op EVENTUALLY_WITHIN = TDB.find "EVENTUALLY_WITHIN"
  fun op EVENTUALLY_AT _ = ()
  val op EVENTUALLY_AT = TDB.find "EVENTUALLY_AT"
  fun op EVENTUALLY_SEQUENTIALLY _ = ()
  val op EVENTUALLY_SEQUENTIALLY = TDB.find "EVENTUALLY_SEQUENTIALLY"
  fun op EVENTUALLY_AT_INFINITY _ = ()
  val op EVENTUALLY_AT_INFINITY = TDB.find "EVENTUALLY_AT_INFINITY"
  fun op EVENTUALLY_AT_POSINFINITY _ = ()
  val op EVENTUALLY_AT_POSINFINITY = TDB.find "EVENTUALLY_AT_POSINFINITY"
  fun op EVENTUALLY_AT_NEGINFINITY _ = ()
  val op EVENTUALLY_AT_NEGINFINITY = TDB.find "EVENTUALLY_AT_NEGINFINITY"
  fun op EVENTUALLY_AT_INFINITY_POS _ = ()
  val op EVENTUALLY_AT_INFINITY_POS = TDB.find "EVENTUALLY_AT_INFINITY_POS"
  fun op ALWAYS_EVENTUALLY _ = ()
  val op ALWAYS_EVENTUALLY = TDB.find "ALWAYS_EVENTUALLY"
  fun op EVENTUALLY_AND _ = ()
  val op EVENTUALLY_AND = TDB.find "EVENTUALLY_AND"
  fun op EVENTUALLY_MONO _ = ()
  val op EVENTUALLY_MONO = TDB.find "EVENTUALLY_MONO"
  fun op EVENTUALLY_MP _ = ()
  val op EVENTUALLY_MP = TDB.find "EVENTUALLY_MP"
  fun op EVENTUALLY_FALSE _ = ()
  val op EVENTUALLY_FALSE = TDB.find "EVENTUALLY_FALSE"
  fun op EVENTUALLY_TRUE _ = ()
  val op EVENTUALLY_TRUE = TDB.find "EVENTUALLY_TRUE"
  fun op NOT_EVENTUALLY _ = ()
  val op NOT_EVENTUALLY = TDB.find "NOT_EVENTUALLY"
  fun op EVENTUALLY_FORALL _ = ()
  val op EVENTUALLY_FORALL = TDB.find "EVENTUALLY_FORALL"
  fun op FORALL_EVENTUALLY _ = ()
  val op FORALL_EVENTUALLY = TDB.find "FORALL_EVENTUALLY"
  fun op LIM _ = () val op LIM = TDB.find "LIM"
  fun op LIM_WITHIN_LE _ = ()
  val op LIM_WITHIN_LE = TDB.find "LIM_WITHIN_LE"
  fun op LIM_WITHIN _ = () val op LIM_WITHIN = TDB.find "LIM_WITHIN"
  fun op LIM_AT_LE _ = () val op LIM_AT_LE = TDB.find "LIM_AT_LE"
  fun op LIM_AT _ = () val op LIM_AT = TDB.find "LIM_AT"
  fun op LIM_AT_INFINITY _ = ()
  val op LIM_AT_INFINITY = TDB.find "LIM_AT_INFINITY"
  fun op LIM_AT_INFINITY_POS _ = ()
  val op LIM_AT_INFINITY_POS = TDB.find "LIM_AT_INFINITY_POS"
  fun op LIM_AT_POSINFINITY _ = ()
  val op LIM_AT_POSINFINITY = TDB.find "LIM_AT_POSINFINITY"
  fun op LIM_AT_NEGINFINITY _ = ()
  val op LIM_AT_NEGINFINITY = TDB.find "LIM_AT_NEGINFINITY"
  fun op LIM_SEQUENTIALLY _ = ()
  val op LIM_SEQUENTIALLY = TDB.find "LIM_SEQUENTIALLY"
  fun op LIM_EVENTUALLY _ = ()
  val op LIM_EVENTUALLY = TDB.find "LIM_EVENTUALLY"
  fun op LIM_POSINFINITY_SEQUENTIALLY _ = ()
  val op LIM_POSINFINITY_SEQUENTIALLY = TDB.find
    "LIM_POSINFINITY_SEQUENTIALLY"
  fun op LIM_INFINITY_POSINFINITY _ = ()
  val op LIM_INFINITY_POSINFINITY = TDB.find "LIM_INFINITY_POSINFINITY"
  fun op LIM_WITHIN_EMPTY _ = ()
  val op LIM_WITHIN_EMPTY = TDB.find "LIM_WITHIN_EMPTY"
  fun op LIM_WITHIN_SUBSET _ = ()
  val op LIM_WITHIN_SUBSET = TDB.find "LIM_WITHIN_SUBSET"
  fun op LIM_UNION _ = () val op LIM_UNION = TDB.find "LIM_UNION"
  fun op LIM_UNION_UNIV _ = ()
  val op LIM_UNION_UNIV = TDB.find "LIM_UNION_UNIV"
  fun op LIM_COMPOSE_WITHIN _ = ()
  val op LIM_COMPOSE_WITHIN = TDB.find "LIM_COMPOSE_WITHIN"
  fun op LIM_COMPOSE_AT _ = ()
  val op LIM_COMPOSE_AT = TDB.find "LIM_COMPOSE_AT"
  fun op LIM_AT_WITHIN _ = ()
  val op LIM_AT_WITHIN = TDB.find "LIM_AT_WITHIN"
  fun op LIM_WITHIN_OPEN _ = ()
  val op LIM_WITHIN_OPEN = TDB.find "LIM_WITHIN_OPEN"
  fun op FROM_INTER_NUMSEG_GEN _ = ()
  val op FROM_INTER_NUMSEG_GEN = TDB.find "FROM_INTER_NUMSEG_GEN"
  fun op FROM_INTER_NUMSEG_MAX _ = ()
  val op FROM_INTER_NUMSEG_MAX = TDB.find "FROM_INTER_NUMSEG_MAX"
  fun op FROM_INTER_NUMSEG _ = ()
  val op FROM_INTER_NUMSEG = TDB.find "FROM_INTER_NUMSEG"
  fun op INFINITE_FROM _ = ()
  val op INFINITE_FROM = TDB.find "INFINITE_FROM"
  fun op WLOG_LT _ = () val op WLOG_LT = TDB.find "WLOG_LT"
  fun op WLOG_LE _ = () val op WLOG_LE = TDB.find "WLOG_LE"
  fun op REAL_LE_BETWEEN _ = ()
  val op REAL_LE_BETWEEN = TDB.find "REAL_LE_BETWEEN"
  fun op BOUNDS_LINEAR_0 _ = ()
  val op BOUNDS_LINEAR_0 = TDB.find "BOUNDS_LINEAR_0"
  fun op BOUNDS_LINEAR _ = ()
  val op BOUNDS_LINEAR = TDB.find "BOUNDS_LINEAR"
  fun op CLOSED_BIGINTER _ = ()
  val op CLOSED_BIGINTER = TDB.find "CLOSED_BIGINTER"
  fun op CLOSED_INTER _ = () val op CLOSED_INTER = TDB.find "CLOSED_INTER"
  fun op CLOSED_UNION _ = () val op CLOSED_UNION = TDB.find "CLOSED_UNION"
  fun op CLOSED_UNIV _ = () val op CLOSED_UNIV = TDB.find "CLOSED_UNIV"
  fun op CLOSED_EMPTY _ = () val op CLOSED_EMPTY = TDB.find "CLOSED_EMPTY"
  fun op OPEN_SUB_OPEN _ = ()
  val op OPEN_SUB_OPEN = TDB.find "OPEN_SUB_OPEN"
  fun op OPEN_UNION _ = () val op OPEN_UNION = TDB.find "OPEN_UNION"
  fun op CLOSED_IN _ = () val op CLOSED_IN = TDB.find "CLOSED_IN"
  fun op CLOSED_IN_REFL _ = ()
  val op CLOSED_IN_REFL = TDB.find "CLOSED_IN_REFL"
  fun op OPEN_IN_REFL _ = () val op OPEN_IN_REFL = TDB.find "OPEN_IN_REFL"
  fun op TOPSPACE_EUCLIDEAN_SUBTOPOLOGY _ = ()
  val op TOPSPACE_EUCLIDEAN_SUBTOPOLOGY = TDB.find
    "TOPSPACE_EUCLIDEAN_SUBTOPOLOGY"
  fun op TOPSPACE_EUCLIDEAN _ = ()
  val op TOPSPACE_EUCLIDEAN = TDB.find "TOPSPACE_EUCLIDEAN"
  fun op OPEN_IN _ = () val op OPEN_IN = TDB.find "OPEN_IN"
  fun op OPEN_EXISTS _ = () val op OPEN_EXISTS = TDB.find "OPEN_EXISTS"
  fun op OPEN_EXISTS_IN _ = ()
  val op OPEN_EXISTS_IN = TDB.find "OPEN_EXISTS_IN"
  fun op OPEN_BIGUNION _ = ()
  val op OPEN_BIGUNION = TDB.find "OPEN_BIGUNION"
  fun op OPEN_INTER _ = () val op OPEN_INTER = TDB.find "OPEN_INTER"
  fun op OPEN_UNIV _ = () val op OPEN_UNIV = TDB.find "OPEN_UNIV"
  fun op OPEN_EMPTY _ = () val op OPEN_EMPTY = TDB.find "OPEN_EMPTY"
  fun op CLOSED_IN_SUBTOPOLOGY_UNION _ = ()
  val op CLOSED_IN_SUBTOPOLOGY_UNION = TDB.find
    "CLOSED_IN_SUBTOPOLOGY_UNION"
  fun op OPEN_IN_SUBTOPOLOGY_UNION _ = ()
  val op OPEN_IN_SUBTOPOLOGY_UNION = TDB.find "OPEN_IN_SUBTOPOLOGY_UNION"
  fun op CLOSED_IN_IMP_SUBSET _ = ()
  val op CLOSED_IN_IMP_SUBSET = TDB.find "CLOSED_IN_IMP_SUBSET"
  fun op OPEN_IN_IMP_SUBSET _ = ()
  val op OPEN_IN_IMP_SUBSET = TDB.find "OPEN_IN_IMP_SUBSET"
  fun op SUBTOPOLOGY_UNIV _ = ()
  val op SUBTOPOLOGY_UNIV = TDB.find "SUBTOPOLOGY_UNIV"
  fun op SUBTOPOLOGY_TOPSPACE _ = ()
  val op SUBTOPOLOGY_TOPSPACE = TDB.find "SUBTOPOLOGY_TOPSPACE"
  fun op SUBTOPOLOGY_SUPERSET _ = ()
  val op SUBTOPOLOGY_SUPERSET = TDB.find "SUBTOPOLOGY_SUPERSET"
  fun op CLOSED_IN_SUBTOPOLOGY_REFL _ = ()
  val op CLOSED_IN_SUBTOPOLOGY_REFL = TDB.find "CLOSED_IN_SUBTOPOLOGY_REFL"
  fun op OPEN_IN_SUBTOPOLOGY_REFL _ = ()
  val op OPEN_IN_SUBTOPOLOGY_REFL = TDB.find "OPEN_IN_SUBTOPOLOGY_REFL"
  fun op CLOSED_IN_SUBTOPOLOGY_EMPTY _ = ()
  val op CLOSED_IN_SUBTOPOLOGY_EMPTY = TDB.find
    "CLOSED_IN_SUBTOPOLOGY_EMPTY"
  fun op OPEN_IN_SUBTOPOLOGY_EMPTY _ = ()
  val op OPEN_IN_SUBTOPOLOGY_EMPTY = TDB.find "OPEN_IN_SUBTOPOLOGY_EMPTY"
  fun op CLOSED_IN_SUBTOPOLOGY _ = ()
  val op CLOSED_IN_SUBTOPOLOGY = TDB.find "CLOSED_IN_SUBTOPOLOGY"
  fun op TOPSPACE_SUBTOPOLOGY _ = ()
  val op TOPSPACE_SUBTOPOLOGY = TDB.find "TOPSPACE_SUBTOPOLOGY"
  fun op OPEN_IN_SUBTOPOLOGY _ = ()
  val op OPEN_IN_SUBTOPOLOGY = TDB.find "OPEN_IN_SUBTOPOLOGY"
  fun op ISTOPLOGY_SUBTOPOLOGY _ = ()
  val op ISTOPLOGY_SUBTOPOLOGY = TDB.find "ISTOPLOGY_SUBTOPOLOGY"
  fun op INTER_BIGUNION _ = ()
  val op INTER_BIGUNION = TDB.find "INTER_BIGUNION"
  fun op SUBSET_IMAGE _ = () val op SUBSET_IMAGE = TDB.find "SUBSET_IMAGE"
  fun op DIM_SUBSET_UNIV _ = ()
  val op DIM_SUBSET_UNIV = TDB.find "DIM_SUBSET_UNIV"
  fun op DIM_SUBSET _ = () val op DIM_SUBSET = TDB.find "DIM_SUBSET"
  fun op DIM_UNIV _ = () val op DIM_UNIV = TDB.find "DIM_UNIV"
  fun op HAS_SIZE_STDBASIS _ = ()
  val op HAS_SIZE_STDBASIS = TDB.find "HAS_SIZE_STDBASIS"
  fun op SPAN_STDBASIS _ = ()
  val op SPAN_STDBASIS = TDB.find "SPAN_STDBASIS"
  fun op DIM_LE_CARD _ = () val op DIM_LE_CARD = TDB.find "DIM_LE_CARD"
  fun op DIM_UNIQUE _ = () val op DIM_UNIQUE = TDB.find "DIM_UNIQUE"
  fun op BASIS_HAS_SIZE_DIM _ = ()
  val op BASIS_HAS_SIZE_DIM = TDB.find "BASIS_HAS_SIZE_DIM"
  fun op BASIS_CARD_EQ_DIM _ = ()
  val op BASIS_CARD_EQ_DIM = TDB.find "BASIS_CARD_EQ_DIM"
  fun op SPAN_CARD_GE_DIM _ = ()
  val op SPAN_CARD_GE_DIM = TDB.find "SPAN_CARD_GE_DIM"
  fun op INDEPENDENT_CARD_LE_DIM _ = ()
  val op INDEPENDENT_CARD_LE_DIM = TDB.find "INDEPENDENT_CARD_LE_DIM"
  fun op BASIS_EXISTS _ = () val op BASIS_EXISTS = TDB.find "BASIS_EXISTS"
  fun op LINEAR_INJECTIVE_LEFT_INVERSE _ = ()
  val op LINEAR_INJECTIVE_LEFT_INVERSE = TDB.find
    "LINEAR_INJECTIVE_LEFT_INVERSE"
  fun op LINEAR_EQ_STDBASIS _ = ()
  val op LINEAR_EQ_STDBASIS = TDB.find "LINEAR_EQ_STDBASIS"
  fun op LINEAR_EQ _ = () val op LINEAR_EQ = TDB.find "LINEAR_EQ"
  fun op LINEAR_EQ_0 _ = () val op LINEAR_EQ_0 = TDB.find "LINEAR_EQ_0"
  fun op LINEAR_EQ_0_SPAN _ = ()
  val op LINEAR_EQ_0_SPAN = TDB.find "LINEAR_EQ_0_SPAN"
  fun op SUBSPACE_KERNEL _ = ()
  val op SUBSPACE_KERNEL = TDB.find "SUBSPACE_KERNEL"
  fun op LINEAR_INDEPENDENT_EXTEND _ = ()
  val op LINEAR_INDEPENDENT_EXTEND = TDB.find "LINEAR_INDEPENDENT_EXTEND"
  fun op LINEAR_INDEPENDENT_EXTEND_LEMMA _ = ()
  val op LINEAR_INDEPENDENT_EXTEND_LEMMA = TDB.find
    "LINEAR_INDEPENDENT_EXTEND_LEMMA"
  fun op SPAN_BREAKDOWN_EQ _ = ()
  val op SPAN_BREAKDOWN_EQ = TDB.find "SPAN_BREAKDOWN_EQ"
  fun op MAXIMAL_INDEPENDENT_SUBSET _ = ()
  val op MAXIMAL_INDEPENDENT_SUBSET = TDB.find "MAXIMAL_INDEPENDENT_SUBSET"
  fun op MAXIMAL_INDEPENDENT_SUBSET_EXTEND _ = ()
  val op MAXIMAL_INDEPENDENT_SUBSET_EXTEND = TDB.find
    "MAXIMAL_INDEPENDENT_SUBSET_EXTEND"
  fun op INDEPENDENT_BOUND _ = ()
  val op INDEPENDENT_BOUND = TDB.find "INDEPENDENT_BOUND"
  fun op INDEPENDENT_SPAN_BOUND _ = ()
  val op INDEPENDENT_SPAN_BOUND = TDB.find "INDEPENDENT_SPAN_BOUND"
  fun op CARD_STDBASIS _ = ()
  val op CARD_STDBASIS = TDB.find "CARD_STDBASIS"
  fun op EXCHANGE_LEMMA _ = ()
  val op EXCHANGE_LEMMA = TDB.find "EXCHANGE_LEMMA"
  fun op SPAN_TRANS _ = () val op SPAN_TRANS = TDB.find "SPAN_TRANS"
  fun op IN_SPAN_DELETE _ = ()
  val op IN_SPAN_DELETE = TDB.find "IN_SPAN_DELETE"
  fun op SPANNING_SUBSET_INDEPENDENT _ = ()
  val op SPANNING_SUBSET_INDEPENDENT = TDB.find
    "SPANNING_SUBSET_INDEPENDENT"
  fun op INDEPENDENT_STDBASIS _ = ()
  val op INDEPENDENT_STDBASIS = TDB.find "INDEPENDENT_STDBASIS"
  fun op INDEPENDENT_SING _ = ()
  val op INDEPENDENT_SING = TDB.find "INDEPENDENT_SING"
  fun op INDEPENDENT_EMPTY _ = ()
  val op INDEPENDENT_EMPTY = TDB.find "INDEPENDENT_EMPTY"
  fun op SPAN_EMPTY _ = () val op SPAN_EMPTY = TDB.find "SPAN_EMPTY"
  fun op SPAN_INDUCT _ = () val op SPAN_INDUCT = TDB.find "SPAN_INDUCT"
  fun op SPAN_CLAUSES _ = () val op SPAN_CLAUSES = TDB.find "SPAN_CLAUSES"
  fun op SUBSPACE_SPAN _ = ()
  val op SUBSPACE_SPAN = TDB.find "SUBSPACE_SPAN"
  fun op SPAN_MONO _ = () val op SPAN_MONO = TDB.find "SPAN_MONO"
  fun op SPAN_SPAN _ = () val op SPAN_SPAN = TDB.find "SPAN_SPAN"
  fun op SUBSPACE_UNION_CHAIN _ = ()
  val op SUBSPACE_UNION_CHAIN = TDB.find "SUBSPACE_UNION_CHAIN"
  fun op LINEAR_INJECTIVE_0_SUBSPACE _ = ()
  val op LINEAR_INJECTIVE_0_SUBSPACE = TDB.find
    "LINEAR_INJECTIVE_0_SUBSPACE"
  fun op SUBSPACE_BIGINTER _ = ()
  val op SUBSPACE_BIGINTER = TDB.find "SUBSPACE_BIGINTER"
  fun op SUBSPACE_INTER _ = ()
  val op SUBSPACE_INTER = TDB.find "SUBSPACE_INTER"
  fun op SUBSPACE_TRIVIAL _ = ()
  val op SUBSPACE_TRIVIAL = TDB.find "SUBSPACE_TRIVIAL"
  fun op SUBSPACE_LINEAR_PREIMAGE _ = ()
  val op SUBSPACE_LINEAR_PREIMAGE = TDB.find "SUBSPACE_LINEAR_PREIMAGE"
  fun op SUBSPACE_LINEAR_IMAGE _ = ()
  val op SUBSPACE_LINEAR_IMAGE = TDB.find "SUBSPACE_LINEAR_IMAGE"
  fun op SUBSPACE_SUM _ = () val op SUBSPACE_SUM = TDB.find "SUBSPACE_SUM"
  fun op SUBSPACE_SUB _ = () val op SUBSPACE_SUB = TDB.find "SUBSPACE_SUB"
  fun op SUBSPACE_NEG _ = () val op SUBSPACE_NEG = TDB.find "SUBSPACE_NEG"
  fun op SUBSPACE_MUL _ = () val op SUBSPACE_MUL = TDB.find "SUBSPACE_MUL"
  fun op SUBSPACE_ADD _ = () val op SUBSPACE_ADD = TDB.find "SUBSPACE_ADD"
  fun op SUBSPACE_0 _ = () val op SUBSPACE_0 = TDB.find "SUBSPACE_0"
  fun op SUBSPACE_IMP_NONEMPTY _ = ()
  val op SUBSPACE_IMP_NONEMPTY = TDB.find "SUBSPACE_IMP_NONEMPTY"
  fun op SUBSPACE_UNIV _ = ()
  val op SUBSPACE_UNIV = TDB.find "SUBSPACE_UNIV"
  fun op BILINEAR_SUM_PARTIAL_PRE _ = ()
  val op BILINEAR_SUM_PARTIAL_PRE = TDB.find "BILINEAR_SUM_PARTIAL_PRE"
  fun op BILINEAR_SUM_PARTIAL_SUC _ = ()
  val op BILINEAR_SUM_PARTIAL_SUC = TDB.find "BILINEAR_SUM_PARTIAL_SUC"
  fun op BILINEAR_BOUNDED_POS _ = ()
  val op BILINEAR_BOUNDED_POS = TDB.find "BILINEAR_BOUNDED_POS"
  fun op BILINEAR_BOUNDED _ = ()
  val op BILINEAR_BOUNDED = TDB.find "BILINEAR_BOUNDED"
  fun op BILINEAR_SUM _ = () val op BILINEAR_SUM = TDB.find "BILINEAR_SUM"
  fun op BILINEAR_RSUB _ = ()
  val op BILINEAR_RSUB = TDB.find "BILINEAR_RSUB"
  fun op BILINEAR_LSUB _ = ()
  val op BILINEAR_LSUB = TDB.find "BILINEAR_LSUB"
  fun op BILINEAR_RZERO _ = ()
  val op BILINEAR_RZERO = TDB.find "BILINEAR_RZERO"
  fun op BILINEAR_LZERO _ = ()
  val op BILINEAR_LZERO = TDB.find "BILINEAR_LZERO"
  fun op BILINEAR_RNEG _ = ()
  val op BILINEAR_RNEG = TDB.find "BILINEAR_RNEG"
  fun op BILINEAR_LNEG _ = ()
  val op BILINEAR_LNEG = TDB.find "BILINEAR_LNEG"
  fun op BILINEAR_RMUL _ = ()
  val op BILINEAR_RMUL = TDB.find "BILINEAR_RMUL"
  fun op BILINEAR_LMUL _ = ()
  val op BILINEAR_LMUL = TDB.find "BILINEAR_LMUL"
  fun op BILINEAR_RADD _ = ()
  val op BILINEAR_RADD = TDB.find "BILINEAR_RADD"
  fun op BILINEAR_LADD _ = ()
  val op BILINEAR_LADD = TDB.find "BILINEAR_LADD"
  fun op BILINEAR_SWAP _ = ()
  val op BILINEAR_SWAP = TDB.find "BILINEAR_SWAP"
  fun op SYMMETRIC_LINEAR_IMAGE _ = ()
  val op SYMMETRIC_LINEAR_IMAGE = TDB.find "SYMMETRIC_LINEAR_IMAGE"
  fun op LINEAR_BOUNDED_POS _ = ()
  val op LINEAR_BOUNDED_POS = TDB.find "LINEAR_BOUNDED_POS"
  fun op LINEAR_BOUNDED _ = ()
  val op LINEAR_BOUNDED = TDB.find "LINEAR_BOUNDED"
  fun op LINEAR_SUM_MUL _ = ()
  val op LINEAR_SUM_MUL = TDB.find "LINEAR_SUM_MUL"
  fun op LINEAR_SUM _ = () val op LINEAR_SUM = TDB.find "LINEAR_SUM"
  fun op LINEAR_SUB _ = () val op LINEAR_SUB = TDB.find "LINEAR_SUB"
  fun op LINEAR_ADD _ = () val op LINEAR_ADD = TDB.find "LINEAR_ADD"
  fun op LINEAR_NEG _ = () val op LINEAR_NEG = TDB.find "LINEAR_NEG"
  fun op LINEAR_CMUL _ = () val op LINEAR_CMUL = TDB.find "LINEAR_CMUL"
  fun op LINEAR_0 _ = () val op LINEAR_0 = TDB.find "LINEAR_0"
  fun op LINEAR_MUL_COMPONENT _ = ()
  val op LINEAR_MUL_COMPONENT = TDB.find "LINEAR_MUL_COMPONENT"
  fun op LINEAR_COMPOSE_SUM _ = ()
  val op LINEAR_COMPOSE_SUM = TDB.find "LINEAR_COMPOSE_SUM"
  fun op LINEAR_NEGATION _ = ()
  val op LINEAR_NEGATION = TDB.find "LINEAR_NEGATION"
  fun op LINEAR_ZERO _ = () val op LINEAR_ZERO = TDB.find "LINEAR_ZERO"
  fun op LINEAR_ID _ = () val op LINEAR_ID = TDB.find "LINEAR_ID"
  fun op LINEAR_COMPOSE _ = ()
  val op LINEAR_COMPOSE = TDB.find "LINEAR_COMPOSE"
  fun op LINEAR_COMPOSE_SUB _ = ()
  val op LINEAR_COMPOSE_SUB = TDB.find "LINEAR_COMPOSE_SUB"
  fun op LINEAR_COMPOSE_ADD _ = ()
  val op LINEAR_COMPOSE_ADD = TDB.find "LINEAR_COMPOSE_ADD"
  fun op LINEAR_COMPOSE_NEG _ = ()
  val op LINEAR_COMPOSE_NEG = TDB.find "LINEAR_COMPOSE_NEG"
  fun op LINEAR_COMPOSE_CMUL _ = ()
  val op LINEAR_COMPOSE_CMUL = TDB.find "LINEAR_COMPOSE_CMUL"
  fun op LINEAR_SCALING _ = ()
  val op LINEAR_SCALING = TDB.find "LINEAR_SCALING"
  fun op REAL_CHOOSE_DIST _ = ()
  val op REAL_CHOOSE_DIST = TDB.find "REAL_CHOOSE_DIST"
  fun op DIST_0 _ = () val op DIST_0 = TDB.find "DIST_0"
  fun op DIST_EQ _ = () val op DIST_EQ = TDB.find "DIST_EQ"
  fun op DIST_POS_LE _ = () val op DIST_POS_LE = TDB.find "DIST_POS_LE"
  fun op DIST_LE_0 _ = () val op DIST_LE_0 = TDB.find "DIST_LE_0"
  fun op DIST_TRIANGLE_ADD_HALF _ = ()
  val op DIST_TRIANGLE_ADD_HALF = TDB.find "DIST_TRIANGLE_ADD_HALF"
  fun op DIST_MUL _ = () val op DIST_MUL = TDB.find "DIST_MUL"
  fun op DIST_TRIANGLE_ADD _ = ()
  val op DIST_TRIANGLE_ADD = TDB.find "DIST_TRIANGLE_ADD"
  fun op DIST_TRIANGLE_HALF_R _ = ()
  val op DIST_TRIANGLE_HALF_R = TDB.find "DIST_TRIANGLE_HALF_R"
  fun op DIST_TRIANGLE_HALF_L _ = ()
  val op DIST_TRIANGLE_HALF_L = TDB.find "DIST_TRIANGLE_HALF_L"
  fun op DIST_TRIANGLE_LT _ = ()
  val op DIST_TRIANGLE_LT = TDB.find "DIST_TRIANGLE_LT"
  fun op DIST_TRIANGLE_LE _ = ()
  val op DIST_TRIANGLE_LE = TDB.find "DIST_TRIANGLE_LE"
  fun op DIST_NZ _ = () val op DIST_NZ = TDB.find "DIST_NZ"
  fun op DIST_POS_LT _ = () val op DIST_POS_LT = TDB.find "DIST_POS_LT"
  fun op DIST_EQ_0 _ = () val op DIST_EQ_0 = TDB.find "DIST_EQ_0"
  fun op DIST_TRIANGLE_ALT _ = ()
  val op DIST_TRIANGLE_ALT = TDB.find "DIST_TRIANGLE_ALT"
  fun op DIST_TRIANGLE _ = ()
  val op DIST_TRIANGLE = TDB.find "DIST_TRIANGLE"
  fun op DIST_SYM _ = () val op DIST_SYM = TDB.find "DIST_SYM"
  fun op DIST_REFL _ = () val op DIST_REFL = TDB.find "DIST_REFL"
  fun op REAL_WLOG_LT _ = () val op REAL_WLOG_LT = TDB.find "REAL_WLOG_LT"
  fun op BIGUNION_MONO _ = ()
  val op BIGUNION_MONO = TDB.find "BIGUNION_MONO"
  fun op BIGUNION_MONO_IMAGE _ = ()
  val op BIGUNION_MONO_IMAGE = TDB.find "BIGUNION_MONO_IMAGE"
  fun op DEPENDENT_CHOICE _ = ()
  val op DEPENDENT_CHOICE = TDB.find "DEPENDENT_CHOICE"
  fun op DEPENDENT_CHOICE_FIXED _ = ()
  val op DEPENDENT_CHOICE_FIXED = TDB.find "DEPENDENT_CHOICE_FIXED"
  fun op EXISTS_IN_INSERT _ = ()
  val op EXISTS_IN_INSERT = TDB.find "EXISTS_IN_INSERT"
  fun op PERMUTES_INJECTIVE _ = ()
  val op PERMUTES_INJECTIVE = TDB.find "PERMUTES_INJECTIVE"
  fun op PERMUTES_IMAGE _ = ()
  val op PERMUTES_IMAGE = TDB.find "PERMUTES_IMAGE"
  fun op PAIRWISE_IMAGE _ = ()
  val op PAIRWISE_IMAGE = TDB.find "PAIRWISE_IMAGE"
  fun op PAIRWISE_INSERT _ = ()
  val op PAIRWISE_INSERT = TDB.find "PAIRWISE_INSERT"
  fun op PAIRWISE_MONO _ = ()
  val op PAIRWISE_MONO = TDB.find "PAIRWISE_MONO"
  fun op PAIRWISE_SING _ = ()
  val op PAIRWISE_SING = TDB.find "PAIRWISE_SING"
  fun op PAIRWISE_EMPTY _ = ()
  val op PAIRWISE_EMPTY = TDB.find "PAIRWISE_EMPTY"
  fun op REAL_WLOG_LE _ = () val op REAL_WLOG_LE = TDB.find "REAL_WLOG_LE"
  fun op IMAGE_SING _ = () val op IMAGE_SING = TDB.find "IMAGE_SING"
  fun op SUM_ABS_TRIANGLE _ = ()
  val op SUM_ABS_TRIANGLE = TDB.find "SUM_ABS_TRIANGLE"
  fun op SUMS_SYM _ = () val op SUMS_SYM = TDB.find "SUMS_SYM"
  fun op SUM_GP _ = () val op SUM_GP = TDB.find "SUM_GP"
  fun op SUM_GP_MULTIPLIED _ = ()
  val op SUM_GP_MULTIPLIED = TDB.find "SUM_GP_MULTIPLIED"
  fun op SUM_GP_BASIC _ = () val op SUM_GP_BASIC = TDB.find "SUM_GP_BASIC"
  fun op REAL_INV_1_LE _ = ()
  val op REAL_INV_1_LE = TDB.find "REAL_INV_1_LE"
  fun op CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_EQ _ = ()
  val op CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_EQ = TDB.find
    "CLOSED_MAP_OPEN_SUPERSET_PREIMAGE_EQ"
  fun op CLOSED_MAP_OPEN_SUPERSET_PREIMAGE _ = ()
  val op CLOSED_MAP_OPEN_SUPERSET_PREIMAGE = TDB.find
    "CLOSED_MAP_OPEN_SUPERSET_PREIMAGE"
  fun op OPEN_MAP_CLOSED_SUPERSET_PREIMAGE_EQ _ = ()
  val op OPEN_MAP_CLOSED_SUPERSET_PREIMAGE_EQ = TDB.find
    "OPEN_MAP_CLOSED_SUPERSET_PREIMAGE_EQ"
  fun op OPEN_MAP_CLOSED_SUPERSET_PREIMAGE _ = ()
  val op OPEN_MAP_CLOSED_SUPERSET_PREIMAGE = TDB.find
    "OPEN_MAP_CLOSED_SUPERSET_PREIMAGE"
  fun op CLOSED_MAP_FROM_COMPOSITION_INJECTIVE _ = ()
  val op CLOSED_MAP_FROM_COMPOSITION_INJECTIVE = TDB.find
    "CLOSED_MAP_FROM_COMPOSITION_INJECTIVE"
  fun op OPEN_MAP_FROM_COMPOSITION_INJECTIVE _ = ()
  val op OPEN_MAP_FROM_COMPOSITION_INJECTIVE = TDB.find
    "OPEN_MAP_FROM_COMPOSITION_INJECTIVE"
  fun op CLOSED_MAP_FROM_COMPOSITION_SURJECTIVE _ = ()
  val op CLOSED_MAP_FROM_COMPOSITION_SURJECTIVE = TDB.find
    "CLOSED_MAP_FROM_COMPOSITION_SURJECTIVE"
  fun op OPEN_MAP_FROM_COMPOSITION_SURJECTIVE _ = ()
  val op OPEN_MAP_FROM_COMPOSITION_SURJECTIVE = TDB.find
    "OPEN_MAP_FROM_COMPOSITION_SURJECTIVE"
  fun op OPEN_MAP_IMP_CLOSED_MAP _ = ()
  val op OPEN_MAP_IMP_CLOSED_MAP = TDB.find "OPEN_MAP_IMP_CLOSED_MAP"
  fun op CLOSED_MAP_IMP_OPEN_MAP _ = ()
  val op CLOSED_MAP_IMP_OPEN_MAP = TDB.find "CLOSED_MAP_IMP_OPEN_MAP"
  fun op QUOTIENT_MAP_CLOSED_MAP_EQ _ = ()
  val op QUOTIENT_MAP_CLOSED_MAP_EQ = TDB.find "QUOTIENT_MAP_CLOSED_MAP_EQ"
  fun op QUOTIENT_MAP_OPEN_MAP_EQ _ = ()
  val op QUOTIENT_MAP_OPEN_MAP_EQ = TDB.find "QUOTIENT_MAP_OPEN_MAP_EQ"
  fun op CLOSED_MAP_RESTRICT _ = ()
  val op CLOSED_MAP_RESTRICT = TDB.find "CLOSED_MAP_RESTRICT"
  fun op OPEN_MAP_RESTRICT _ = ()
  val op OPEN_MAP_RESTRICT = TDB.find "OPEN_MAP_RESTRICT"
  fun op OPEN_MAP_INTERIORS _ = ()
  val op OPEN_MAP_INTERIORS = TDB.find "OPEN_MAP_INTERIORS"
  fun op CLOSED_MAP_CLOSURES _ = ()
  val op CLOSED_MAP_CLOSURES = TDB.find "CLOSED_MAP_CLOSURES"
  fun op CONNECTED_MONOTONE_QUOTIENT_PREIMAGE_GEN _ = ()
  val op CONNECTED_MONOTONE_QUOTIENT_PREIMAGE_GEN = TDB.find
    "CONNECTED_MONOTONE_QUOTIENT_PREIMAGE_GEN"
  fun op CONNECTED_MONOTONE_QUOTIENT_PREIMAGE _ = ()
  val op CONNECTED_MONOTONE_QUOTIENT_PREIMAGE = TDB.find
    "CONNECTED_MONOTONE_QUOTIENT_PREIMAGE"
  fun op QUOTIENT_MAP_RESTRICT _ = ()
  val op QUOTIENT_MAP_RESTRICT = TDB.find "QUOTIENT_MAP_RESTRICT"
  fun op QUOTIENT_MAP_FROM_SUBSET _ = ()
  val op QUOTIENT_MAP_FROM_SUBSET = TDB.find "QUOTIENT_MAP_FROM_SUBSET"
  fun op QUOTIENT_MAP_FROM_COMPOSITION _ = ()
  val op QUOTIENT_MAP_FROM_COMPOSITION = TDB.find
    "QUOTIENT_MAP_FROM_COMPOSITION"
  fun op QUOTIENT_MAP_COMPOSE _ = ()
  val op QUOTIENT_MAP_COMPOSE = TDB.find "QUOTIENT_MAP_COMPOSE"
  fun op LIFT_TO_QUOTIENT_SPACE _ = ()
  val op LIFT_TO_QUOTIENT_SPACE = TDB.find "LIFT_TO_QUOTIENT_SPACE"
  fun op FUNCTION_FACTORS_LEFT_GEN _ = ()
  val op FUNCTION_FACTORS_LEFT_GEN = TDB.find "FUNCTION_FACTORS_LEFT_GEN"
  fun op CONTINUOUS_ON_COMPOSE_QUOTIENT _ = ()
  val op CONTINUOUS_ON_COMPOSE_QUOTIENT = TDB.find
    "CONTINUOUS_ON_COMPOSE_QUOTIENT"
  fun op QUOTIENT_MAP_OPEN_CLOSED _ = ()
  val op QUOTIENT_MAP_OPEN_CLOSED = TDB.find "QUOTIENT_MAP_OPEN_CLOSED"
  fun op CONTINUOUS_LEFT_INVERSE_IMP_QUOTIENT_MAP _ = ()
  val op CONTINUOUS_LEFT_INVERSE_IMP_QUOTIENT_MAP = TDB.find
    "CONTINUOUS_LEFT_INVERSE_IMP_QUOTIENT_MAP"
  fun op CONTINUOUS_RIGHT_INVERSE_IMP_QUOTIENT_MAP _ = ()
  val op CONTINUOUS_RIGHT_INVERSE_IMP_QUOTIENT_MAP = TDB.find
    "CONTINUOUS_RIGHT_INVERSE_IMP_QUOTIENT_MAP"
  fun op CLOSED_MAP_IMP_QUOTIENT_MAP _ = ()
  val op CLOSED_MAP_IMP_QUOTIENT_MAP = TDB.find
    "CLOSED_MAP_IMP_QUOTIENT_MAP"
  fun op OPEN_MAP_IMP_QUOTIENT_MAP _ = ()
  val op OPEN_MAP_IMP_QUOTIENT_MAP = TDB.find "OPEN_MAP_IMP_QUOTIENT_MAP"
  fun op QUOTIENT_MAP_IMP_CONTINUOUS_CLOSED _ = ()
  val op QUOTIENT_MAP_IMP_CONTINUOUS_CLOSED = TDB.find
    "QUOTIENT_MAP_IMP_CONTINUOUS_CLOSED"
  fun op QUOTIENT_MAP_IMP_CONTINUOUS_OPEN _ = ()
  val op QUOTIENT_MAP_IMP_CONTINUOUS_OPEN = TDB.find
    "QUOTIENT_MAP_IMP_CONTINUOUS_OPEN"
  fun op QUASICOMPACT_OPEN_CLOSED _ = ()
  val op QUASICOMPACT_OPEN_CLOSED = TDB.find "QUASICOMPACT_OPEN_CLOSED"
  fun op CONNECTED_LINEAR_IMAGE _ = ()
  val op CONNECTED_LINEAR_IMAGE = TDB.find "CONNECTED_LINEAR_IMAGE"
  fun op CONNECTED_TRANSLATION_EQ _ = ()
  val op CONNECTED_TRANSLATION_EQ = TDB.find "CONNECTED_TRANSLATION_EQ"
  fun op CONNECTED_TRANSLATION _ = ()
  val op CONNECTED_TRANSLATION = TDB.find "CONNECTED_TRANSLATION"
  fun op CONNECTED_CONTINUOUS_IMAGE _ = ()
  val op CONNECTED_CONTINUOUS_IMAGE = TDB.find "CONNECTED_CONTINUOUS_IMAGE"
  fun op COMPACT_LINEAR_IMAGE _ = ()
  val op COMPACT_LINEAR_IMAGE = TDB.find "COMPACT_LINEAR_IMAGE"
  fun op COMPACT_TRANSLATION_EQ _ = ()
  val op COMPACT_TRANSLATION_EQ = TDB.find "COMPACT_TRANSLATION_EQ"
  fun op COMPACT_TRANSLATION _ = ()
  val op COMPACT_TRANSLATION = TDB.find "COMPACT_TRANSLATION"
  fun op COMPACT_CONTINUOUS_IMAGE _ = ()
  val op COMPACT_CONTINUOUS_IMAGE = TDB.find "COMPACT_CONTINUOUS_IMAGE"
  fun op CONTINUOUS_ON_DOT2 _ = ()
  val op CONTINUOUS_ON_DOT2 = TDB.find "CONTINUOUS_ON_DOT2"
  fun op CONTINUOUS_DOT2 _ = ()
  val op CONTINUOUS_DOT2 = TDB.find "CONTINUOUS_DOT2"
  fun op BILINEAR_DOT _ = () val op BILINEAR_DOT = TDB.find "BILINEAR_DOT"
  fun op BILINEAR_CONTINUOUS_ON_COMPOSE _ = ()
  val op BILINEAR_CONTINUOUS_ON_COMPOSE = TDB.find
    "BILINEAR_CONTINUOUS_ON_COMPOSE"
  fun op BILINEAR_CONTINUOUS_COMPOSE _ = ()
  val op BILINEAR_CONTINUOUS_COMPOSE = TDB.find
    "BILINEAR_CONTINUOUS_COMPOSE"
  fun op CONTINUOUS_ON_COMPONENT_COMPOSE _ = ()
  val op CONTINUOUS_ON_COMPONENT_COMPOSE = TDB.find
    "CONTINUOUS_ON_COMPONENT_COMPOSE"
  fun op CONTINUOUS_COMPONENT_COMPOSE _ = ()
  val op CONTINUOUS_COMPONENT_COMPOSE = TDB.find
    "CONTINUOUS_COMPONENT_COMPOSE"
  fun op LINEAR_CONTINUOUS_ON_COMPOSE _ = ()
  val op LINEAR_CONTINUOUS_ON_COMPOSE = TDB.find
    "LINEAR_CONTINUOUS_ON_COMPOSE"
  fun op LINEAR_CONTINUOUS_COMPOSE _ = ()
  val op LINEAR_CONTINUOUS_COMPOSE = TDB.find "LINEAR_CONTINUOUS_COMPOSE"
  fun op LINEAR_CONTINUOUS_ON _ = ()
  val op LINEAR_CONTINUOUS_ON = TDB.find "LINEAR_CONTINUOUS_ON"
  fun op LINEAR_CONTINUOUS_WITHIN _ = ()
  val op LINEAR_CONTINUOUS_WITHIN = TDB.find "LINEAR_CONTINUOUS_WITHIN"
  fun op LINEAR_CONTINUOUS_AT _ = ()
  val op LINEAR_CONTINUOUS_AT = TDB.find "LINEAR_CONTINUOUS_AT"
  fun op LINEAR_LIM_0 _ = () val op LINEAR_LIM_0 = TDB.find "LINEAR_LIM_0"
  fun op CONTINUOUS_CLOSED_IN_PREIMAGE_EQ _ = ()
  val op CONTINUOUS_CLOSED_IN_PREIMAGE_EQ = TDB.find
    "CONTINUOUS_CLOSED_IN_PREIMAGE_EQ"
  fun op CONTINUOUS_OPEN_IN_PREIMAGE_EQ _ = ()
  val op CONTINUOUS_OPEN_IN_PREIMAGE_EQ = TDB.find
    "CONTINUOUS_OPEN_IN_PREIMAGE_EQ"
  fun op CONTINUOUS_CLOSED_PREIMAGE_UNIV _ = ()
  val op CONTINUOUS_CLOSED_PREIMAGE_UNIV = TDB.find
    "CONTINUOUS_CLOSED_PREIMAGE_UNIV"
  fun op CONTINUOUS_OPEN_PREIMAGE_UNIV _ = ()
  val op CONTINUOUS_OPEN_PREIMAGE_UNIV = TDB.find
    "CONTINUOUS_OPEN_PREIMAGE_UNIV"
  fun op CONTINUOUS_CLOSED_PREIMAGE _ = ()
  val op CONTINUOUS_CLOSED_PREIMAGE = TDB.find "CONTINUOUS_CLOSED_PREIMAGE"
  fun op CONTINUOUS_OPEN_PREIMAGE _ = ()
  val op CONTINUOUS_OPEN_PREIMAGE = TDB.find "CONTINUOUS_OPEN_PREIMAGE"
  fun op CONTINUOUS_CLOSED_IN_PREIMAGE _ = ()
  val op CONTINUOUS_CLOSED_IN_PREIMAGE = TDB.find
    "CONTINUOUS_CLOSED_IN_PREIMAGE"
  fun op CONTINUOUS_OPEN_IN_PREIMAGE _ = ()
  val op CONTINUOUS_OPEN_IN_PREIMAGE = TDB.find
    "CONTINUOUS_OPEN_IN_PREIMAGE"
  fun op CONTINUOUS_ON_IMP_CLOSED_IN _ = ()
  val op CONTINUOUS_ON_IMP_CLOSED_IN = TDB.find
    "CONTINUOUS_ON_IMP_CLOSED_IN"
  fun op CONTINUOUS_CLOSED_IN_PREIMAGE_GEN _ = ()
  val op CONTINUOUS_CLOSED_IN_PREIMAGE_GEN = TDB.find
    "CONTINUOUS_CLOSED_IN_PREIMAGE_GEN"
  fun op CONTINUOUS_ON_CLOSED _ = ()
  val op CONTINUOUS_ON_CLOSED = TDB.find "CONTINUOUS_ON_CLOSED"
  fun op CONTINUOUS_ON_CLOSED_GEN _ = ()
  val op CONTINUOUS_ON_CLOSED_GEN = TDB.find "CONTINUOUS_ON_CLOSED_GEN"
  fun op CONTINUOUS_ON_IMP_OPEN_IN _ = ()
  val op CONTINUOUS_ON_IMP_OPEN_IN = TDB.find "CONTINUOUS_ON_IMP_OPEN_IN"
  fun op CONTINUOUS_OPEN_IN_PREIMAGE_GEN _ = ()
  val op CONTINUOUS_OPEN_IN_PREIMAGE_GEN = TDB.find
    "CONTINUOUS_OPEN_IN_PREIMAGE_GEN"
  fun op CONTINUOUS_ON_OPEN _ = ()
  val op CONTINUOUS_ON_OPEN = TDB.find "CONTINUOUS_ON_OPEN"
  fun op CONTINUOUS_ON_OPEN_GEN _ = ()
  val op CONTINUOUS_ON_OPEN_GEN = TDB.find "CONTINUOUS_ON_OPEN_GEN"
  fun op CONTINUOUS_AT_OPEN _ = ()
  val op CONTINUOUS_AT_OPEN = TDB.find "CONTINUOUS_AT_OPEN"
  fun op CONTINUOUS_WITHIN_OPEN _ = ()
  val op CONTINUOUS_WITHIN_OPEN = TDB.find "CONTINUOUS_WITHIN_OPEN"
  fun op CONTINUOUS_ON_COMPOSE _ = ()
  val op CONTINUOUS_ON_COMPOSE = TDB.find "CONTINUOUS_ON_COMPOSE"
  fun op CONTINUOUS_AT_COMPOSE _ = ()
  val op CONTINUOUS_AT_COMPOSE = TDB.find "CONTINUOUS_AT_COMPOSE"
  fun op CONTINUOUS_WITHIN_COMPOSE _ = ()
  val op CONTINUOUS_WITHIN_COMPOSE = TDB.find "CONTINUOUS_WITHIN_COMPOSE"
  fun op UNIFORMLY_CONTINUOUS_ON_ID _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_ID = TDB.find "UNIFORMLY_CONTINUOUS_ON_ID"
  fun op CONTINUOUS_ON_ID _ = ()
  val op CONTINUOUS_ON_ID = TDB.find "CONTINUOUS_ON_ID"
  fun op CONTINUOUS_AT_ID _ = ()
  val op CONTINUOUS_AT_ID = TDB.find "CONTINUOUS_AT_ID"
  fun op CONTINUOUS_WITHIN_ID _ = ()
  val op CONTINUOUS_WITHIN_ID = TDB.find "CONTINUOUS_WITHIN_ID"
  fun op UNIFORMLY_CONTINUOUS_ON_SUM _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_SUM = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_SUM"
  fun op UNIFORMLY_CONTINUOUS_ON_SUB _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_SUB = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_SUB"
  fun op UNIFORMLY_CONTINUOUS_ON_ADD _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_ADD = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_ADD"
  fun op UNIFORMLY_CONTINUOUS_ON_NEG _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_NEG = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_NEG"
  fun op UNIFORMLY_CONTINUOUS_ON_VMUL _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_VMUL = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_VMUL"
  fun op UNIFORMLY_CONTINUOUS_ON_CMUL _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_CMUL = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_CMUL"
  fun op UNIFORMLY_CONTINUOUS_ON_MUL _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_MUL = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_MUL"
  fun op BILINEAR_UNIFORMLY_CONTINUOUS_ON_COMPOSE _ = ()
  val op BILINEAR_UNIFORMLY_CONTINUOUS_ON_COMPOSE = TDB.find
    "BILINEAR_UNIFORMLY_CONTINUOUS_ON_COMPOSE"
  fun op UNIFORMLY_CONTINUOUS_ON_COMPOSE _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_COMPOSE = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_COMPOSE"
  fun op LINEAR_UNIFORMLY_CONTINUOUS_ON _ = ()
  val op LINEAR_UNIFORMLY_CONTINUOUS_ON = TDB.find
    "LINEAR_UNIFORMLY_CONTINUOUS_ON"
  fun op UNIFORMLY_CONTINUOUS_ON_CONST _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_CONST = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_CONST"
  fun op CONTINUOUS_ON_SUM _ = ()
  val op CONTINUOUS_ON_SUM = TDB.find "CONTINUOUS_ON_SUM"
  fun op CONTINUOUS_ON_MIN _ = ()
  val op CONTINUOUS_ON_MIN = TDB.find "CONTINUOUS_ON_MIN"
  fun op CONTINUOUS_ON_MAX _ = ()
  val op CONTINUOUS_ON_MAX = TDB.find "CONTINUOUS_ON_MAX"
  fun op CONTINUOUS_ON_ABS _ = ()
  val op CONTINUOUS_ON_ABS = TDB.find "CONTINUOUS_ON_ABS"
  fun op CONTINUOUS_ON_SUB _ = ()
  val op CONTINUOUS_ON_SUB = TDB.find "CONTINUOUS_ON_SUB"
  fun op CONTINUOUS_ON_ADD _ = ()
  val op CONTINUOUS_ON_ADD = TDB.find "CONTINUOUS_ON_ADD"
  fun op CONTINUOUS_ON_NEG _ = ()
  val op CONTINUOUS_ON_NEG = TDB.find "CONTINUOUS_ON_NEG"
  fun op CONTINUOUS_ON_CMUL _ = ()
  val op CONTINUOUS_ON_CMUL = TDB.find "CONTINUOUS_ON_CMUL"
  fun op CONTINUOUS_ON_CONST _ = ()
  val op CONTINUOUS_ON_CONST = TDB.find "CONTINUOUS_ON_CONST"
  fun op CONTINUOUS_SUM _ = ()
  val op CONTINUOUS_SUM = TDB.find "CONTINUOUS_SUM"
  fun op CONTINUOUS_MIN _ = ()
  val op CONTINUOUS_MIN = TDB.find "CONTINUOUS_MIN"
  fun op CONTINUOUS_MAX _ = ()
  val op CONTINUOUS_MAX = TDB.find "CONTINUOUS_MAX"
  fun op CONTINUOUS_ABS _ = ()
  val op CONTINUOUS_ABS = TDB.find "CONTINUOUS_ABS"
  fun op CONTINUOUS_SUB _ = ()
  val op CONTINUOUS_SUB = TDB.find "CONTINUOUS_SUB"
  fun op CONTINUOUS_ADD _ = ()
  val op CONTINUOUS_ADD = TDB.find "CONTINUOUS_ADD"
  fun op CONTINUOUS_NEG _ = ()
  val op CONTINUOUS_NEG = TDB.find "CONTINUOUS_NEG"
  fun op CONTINUOUS_CMUL _ = ()
  val op CONTINUOUS_CMUL = TDB.find "CONTINUOUS_CMUL"
  fun op CONTINUOUS_CONST _ = ()
  val op CONTINUOUS_CONST = TDB.find "CONTINUOUS_CONST"
  fun op LIM_CONTINUOUS_FUNCTION _ = ()
  val op LIM_CONTINUOUS_FUNCTION = TDB.find "LIM_CONTINUOUS_FUNCTION"
  fun op UNIFORMLY_CONTINUOUS_ON_SEQUENTIALLY _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_SEQUENTIALLY = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_SEQUENTIALLY"
  fun op CONTINUOUS_ON_SEQUENTIALLY _ = ()
  val op CONTINUOUS_ON_SEQUENTIALLY = TDB.find "CONTINUOUS_ON_SEQUENTIALLY"
  fun op CONTINUOUS_AT_SEQUENTIALLY _ = ()
  val op CONTINUOUS_AT_SEQUENTIALLY = TDB.find "CONTINUOUS_AT_SEQUENTIALLY"
  fun op CONTINUOUS_WITHIN_SEQUENTIALLY _ = ()
  val op CONTINUOUS_WITHIN_SEQUENTIALLY = TDB.find
    "CONTINUOUS_WITHIN_SEQUENTIALLY"
  fun op FORALL_POS_MONO_1 _ = ()
  val op FORALL_POS_MONO_1 = TDB.find "FORALL_POS_MONO_1"
  fun op ISOMETRY_ON_IMP_CONTINUOUS_ON _ = ()
  val op ISOMETRY_ON_IMP_CONTINUOUS_ON = TDB.find
    "ISOMETRY_ON_IMP_CONTINUOUS_ON"
  fun op CONTRACTION_IMP_CONTINUOUS_ON _ = ()
  val op CONTRACTION_IMP_CONTINUOUS_ON = TDB.find
    "CONTRACTION_IMP_CONTINUOUS_ON"
  fun op CONTINUOUS_ON_FINITE _ = ()
  val op CONTINUOUS_ON_FINITE = TDB.find "CONTINUOUS_ON_FINITE"
  fun op CONTINUOUS_ON_NO_LIMPT _ = ()
  val op CONTINUOUS_ON_NO_LIMPT = TDB.find "CONTINUOUS_ON_NO_LIMPT"
  fun op CONTINUOUS_ON_EMPTY _ = ()
  val op CONTINUOUS_ON_EMPTY = TDB.find "CONTINUOUS_ON_EMPTY"
  fun op CONTINUOUS_ON_SING _ = ()
  val op CONTINUOUS_ON_SING = TDB.find "CONTINUOUS_ON_SING"
  fun op UNIFORMLY_CONTINUOUS_ON_EQ _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_EQ = TDB.find "UNIFORMLY_CONTINUOUS_ON_EQ"
  fun op CONTINUOUS_ON_EQ _ = ()
  val op CONTINUOUS_ON_EQ = TDB.find "CONTINUOUS_ON_EQ"
  fun op CONTINUOUS_ON_INTERIOR _ = ()
  val op CONTINUOUS_ON_INTERIOR = TDB.find "CONTINUOUS_ON_INTERIOR"
  fun op UNIFORMLY_CONTINUOUS_ON_SUBSET _ = ()
  val op UNIFORMLY_CONTINUOUS_ON_SUBSET = TDB.find
    "UNIFORMLY_CONTINUOUS_ON_SUBSET"
  fun op CONTINUOUS_ON_SUBSET _ = ()
  val op CONTINUOUS_ON_SUBSET = TDB.find "CONTINUOUS_ON_SUBSET"
  fun op CONTINUOUS_WITHIN_SUBSET _ = ()
  val op CONTINUOUS_WITHIN_SUBSET = TDB.find "CONTINUOUS_WITHIN_SUBSET"
  fun op CONTINUOUS_ON_EQ_CONTINUOUS_AT _ = ()
  val op CONTINUOUS_ON_EQ_CONTINUOUS_AT = TDB.find
    "CONTINUOUS_ON_EQ_CONTINUOUS_AT"
  fun op CONTINUOUS_ON _ = ()
  val op CONTINUOUS_ON = TDB.find "CONTINUOUS_ON"
  fun op CONTINUOUS_ON_EQ_CONTINUOUS_WITHIN _ = ()
  val op CONTINUOUS_ON_EQ_CONTINUOUS_WITHIN = TDB.find
    "CONTINUOUS_ON_EQ_CONTINUOUS_WITHIN"
  fun op CONTINUOUS_AT_IMP_CONTINUOUS_ON _ = ()
  val op CONTINUOUS_AT_IMP_CONTINUOUS_ON = TDB.find
    "CONTINUOUS_AT_IMP_CONTINUOUS_ON"
  fun op UNIFORMLY_CONTINUOUS_IMP_CONTINUOUS _ = ()
  val op UNIFORMLY_CONTINUOUS_IMP_CONTINUOUS = TDB.find
    "UNIFORMLY_CONTINUOUS_IMP_CONTINUOUS"
  fun op CONTINUOUS_WITHIN_COMPARISON _ = ()
  val op CONTINUOUS_WITHIN_COMPARISON = TDB.find
    "CONTINUOUS_WITHIN_COMPARISON"
  fun op CONTINUOUS_AT_BALL _ = ()
  val op CONTINUOUS_AT_BALL = TDB.find "CONTINUOUS_AT_BALL"
  fun op CONTINUOUS_WITHIN_BALL _ = ()
  val op CONTINUOUS_WITHIN_BALL = TDB.find "CONTINUOUS_WITHIN_BALL"
  fun op continuous_at _ = ()
  val op continuous_at = TDB.find "continuous_at"
  fun op continuous_within _ = ()
  val op continuous_within = TDB.find "continuous_within"
  fun op CONTINUOUS_TRANSFORM_WITHIN_SET_IMP _ = ()
  val op CONTINUOUS_TRANSFORM_WITHIN_SET_IMP = TDB.find
    "CONTINUOUS_TRANSFORM_WITHIN_SET_IMP"
  fun op CONTINUOUS_TRANSFORM_WITHIN_OPEN_IN _ = ()
  val op CONTINUOUS_TRANSFORM_WITHIN_OPEN_IN = TDB.find
    "CONTINUOUS_TRANSFORM_WITHIN_OPEN_IN"
  fun op CONTINUOUS_TRANSFORM_WITHIN_OPEN _ = ()
  val op CONTINUOUS_TRANSFORM_WITHIN_OPEN = TDB.find
    "CONTINUOUS_TRANSFORM_WITHIN_OPEN"
  fun op CONTINUOUS_TRANSFORM_AT _ = ()
  val op CONTINUOUS_TRANSFORM_AT = TDB.find "CONTINUOUS_TRANSFORM_AT"
  fun op CONTINUOUS_TRANSFORM_WITHIN _ = ()
  val op CONTINUOUS_TRANSFORM_WITHIN = TDB.find
    "CONTINUOUS_TRANSFORM_WITHIN"
  fun op CONTINUOUS_WITHIN_CLOSED_NONTRIVIAL _ = ()
  val op CONTINUOUS_WITHIN_CLOSED_NONTRIVIAL = TDB.find
    "CONTINUOUS_WITHIN_CLOSED_NONTRIVIAL"
  fun op CONTINUOUS_AT_WITHIN _ = ()
  val op CONTINUOUS_AT_WITHIN = TDB.find "CONTINUOUS_AT_WITHIN"
  fun op CONTINUOUS_AT _ = ()
  val op CONTINUOUS_AT = TDB.find "CONTINUOUS_AT"
  fun op CONTINUOUS_WITHIN _ = ()
  val op CONTINUOUS_WITHIN = TDB.find "CONTINUOUS_WITHIN"
  fun op CONTINUOUS_TRIVIAL_LIMIT _ = ()
  val op CONTINUOUS_TRIVIAL_LIMIT = TDB.find "CONTINUOUS_TRIVIAL_LIMIT"
  fun op UNIFORMLY_CAUCHY_IMP_UNIFORMLY_CONVERGENT _ = ()
  val op UNIFORMLY_CAUCHY_IMP_UNIFORMLY_CONVERGENT = TDB.find
    "UNIFORMLY_CAUCHY_IMP_UNIFORMLY_CONVERGENT"
  fun op UNIFORMLY_CONVERGENT_EQ_CAUCHY_ALT _ = ()
  val op UNIFORMLY_CONVERGENT_EQ_CAUCHY_ALT = TDB.find
    "UNIFORMLY_CONVERGENT_EQ_CAUCHY_ALT"
  fun op UNIFORMLY_CONVERGENT_EQ_CAUCHY _ = ()
  val op UNIFORMLY_CONVERGENT_EQ_CAUCHY = TDB.find
    "UNIFORMLY_CONVERGENT_EQ_CAUCHY"
  fun op COMPACT_NEST _ = () val op COMPACT_NEST = TDB.find "COMPACT_NEST"
  fun op COMPACT_CHAIN _ = ()
  val op COMPACT_CHAIN = TDB.find "COMPACT_CHAIN"
  fun op BOUNDED_CLOSED_CHAIN _ = ()
  val op BOUNDED_CLOSED_CHAIN = TDB.find "BOUNDED_CLOSED_CHAIN"
  fun op DECREASING_CLOSED_NEST_SING _ = ()
  val op DECREASING_CLOSED_NEST_SING = TDB.find
    "DECREASING_CLOSED_NEST_SING"
  fun op DECREASING_CLOSED_NEST _ = ()
  val op DECREASING_CLOSED_NEST = TDB.find "DECREASING_CLOSED_NEST"
  fun op BOUNDED_CLOSED_NEST _ = ()
  val op BOUNDED_CLOSED_NEST = TDB.find "BOUNDED_CLOSED_NEST"
  fun op COMPACT_FIP _ = () val op COMPACT_FIP = TDB.find "COMPACT_FIP"
  fun op CLOSED_FIP _ = () val op CLOSED_FIP = TDB.find "CLOSED_FIP"
  fun op CLOSED_IMP_FIP_COMPACT _ = ()
  val op CLOSED_IMP_FIP_COMPACT = TDB.find "CLOSED_IMP_FIP_COMPACT"
  fun op CLOSED_IMP_FIP _ = ()
  val op CLOSED_IMP_FIP = TDB.find "CLOSED_IMP_FIP"
  fun op COMPACT_IMP_FIP _ = ()
  val op COMPACT_IMP_FIP = TDB.find "COMPACT_IMP_FIP"
  fun op FRONTIER_SING _ = ()
  val op FRONTIER_SING = TDB.find "FRONTIER_SING"
  fun op CLOSED_SPHERE _ = ()
  val op CLOSED_SPHERE = TDB.find "CLOSED_SPHERE"
  fun op BOUNDED_SPHERE _ = ()
  val op BOUNDED_SPHERE = TDB.find "BOUNDED_SPHERE"
  fun op COMPACT_SPHERE _ = ()
  val op COMPACT_SPHERE = TDB.find "COMPACT_SPHERE"
  fun op COMPACT_DIFF _ = () val op COMPACT_DIFF = TDB.find "COMPACT_DIFF"
  fun op COMPACT_BIGUNION _ = ()
  val op COMPACT_BIGUNION = TDB.find "COMPACT_BIGUNION"
  fun op CLOSED_BIGINTER_COMPACT _ = ()
  val op CLOSED_BIGINTER_COMPACT = TDB.find "CLOSED_BIGINTER_COMPACT"
  fun op OPEN_IN_DELETE _ = ()
  val op OPEN_IN_DELETE = TDB.find "OPEN_IN_DELETE"
  fun op OPEN_DELETE _ = () val op OPEN_DELETE = TDB.find "OPEN_DELETE"
  fun op FRONTIER_SUBSET_COMPACT _ = ()
  val op FRONTIER_SUBSET_COMPACT = TDB.find "FRONTIER_SUBSET_COMPACT"
  fun op BOUNDED_FRONTIER _ = ()
  val op BOUNDED_FRONTIER = TDB.find "BOUNDED_FRONTIER"
  fun op COMPACT_FRONTIER _ = ()
  val op COMPACT_FRONTIER = TDB.find "COMPACT_FRONTIER"
  fun op COMPACT_FRONTIER_BOUNDED _ = ()
  val op COMPACT_FRONTIER_BOUNDED = TDB.find "COMPACT_FRONTIER_BOUNDED"
  fun op COMPACT_CBALL _ = ()
  val op COMPACT_CBALL = TDB.find "COMPACT_CBALL"
  fun op CLOSED_INSERT _ = ()
  val op CLOSED_INSERT = TDB.find "CLOSED_INSERT"
  fun op CLOSURE_SING _ = () val op CLOSURE_SING = TDB.find "CLOSURE_SING"
  fun op CLOSED_IN_SING _ = ()
  val op CLOSED_IN_SING = TDB.find "CLOSED_IN_SING"
  fun op CLOSED_SING _ = () val op CLOSED_SING = TDB.find "CLOSED_SING"
  fun op COMPACT_INSERT _ = ()
  val op COMPACT_INSERT = TDB.find "COMPACT_INSERT"
  fun op COMPACT_SING _ = () val op COMPACT_SING = TDB.find "COMPACT_SING"
  fun op FINITE_IMP_COMPACT _ = ()
  val op FINITE_IMP_COMPACT = TDB.find "FINITE_IMP_COMPACT"
  fun op FINITE_IMP_CLOSED_IN _ = ()
  val op FINITE_IMP_CLOSED_IN = TDB.find "FINITE_IMP_CLOSED_IN"
  fun op FINITE_IMP_CLOSED _ = ()
  val op FINITE_IMP_CLOSED = TDB.find "FINITE_IMP_CLOSED"
  fun op COMPACT_BIGINTER _ = ()
  val op COMPACT_BIGINTER = TDB.find "COMPACT_BIGINTER"
  fun op CLOSED_INTER_COMPACT _ = ()
  val op CLOSED_INTER_COMPACT = TDB.find "CLOSED_INTER_COMPACT"
  fun op COMPACT_INTER_CLOSED _ = ()
  val op COMPACT_INTER_CLOSED = TDB.find "COMPACT_INTER_CLOSED"
  fun op COMPACT_INTER _ = ()
  val op COMPACT_INTER = TDB.find "COMPACT_INTER"
  fun op COMPACT_UNION _ = ()
  val op COMPACT_UNION = TDB.find "COMPACT_UNION"
  fun op COMPACT_EMPTY _ = ()
  val op COMPACT_EMPTY = TDB.find "COMPACT_EMPTY"
  fun op BOUNDED_EQ_BOLZANO_WEIERSTRASS _ = ()
  val op BOUNDED_EQ_BOLZANO_WEIERSTRASS = TDB.find
    "BOUNDED_EQ_BOLZANO_WEIERSTRASS"
  fun op BOLZANO_WEIERSTRASS _ = ()
  val op BOLZANO_WEIERSTRASS = TDB.find "BOLZANO_WEIERSTRASS"
  fun op DISCRETE_BOUNDED_IMP_FINITE _ = ()
  val op DISCRETE_BOUNDED_IMP_FINITE = TDB.find
    "DISCRETE_BOUNDED_IMP_FINITE"
  fun op BOLZANO_WEIERSTRASS_CONTRAPOS _ = ()
  val op BOLZANO_WEIERSTRASS_CONTRAPOS = TDB.find
    "BOLZANO_WEIERSTRASS_CONTRAPOS"
  fun op COMPACT_CLOSURE _ = ()
  val op COMPACT_CLOSURE = TDB.find "COMPACT_CLOSURE"
  fun op COMPACT_EQ_HEINE_BOREL_SUBTOPOLOGY _ = ()
  val op COMPACT_EQ_HEINE_BOREL_SUBTOPOLOGY = TDB.find
    "COMPACT_EQ_HEINE_BOREL_SUBTOPOLOGY"
  fun op CLOSED_IN_COMPACT_EQ _ = ()
  val op CLOSED_IN_COMPACT_EQ = TDB.find "CLOSED_IN_COMPACT_EQ"
  fun op CLOSED_IN_COMPACT _ = ()
  val op CLOSED_IN_COMPACT = TDB.find "CLOSED_IN_COMPACT"
  fun op COMPACT_SEQUENCE_WITH_LIMIT _ = ()
  val op COMPACT_SEQUENCE_WITH_LIMIT = TDB.find
    "COMPACT_SEQUENCE_WITH_LIMIT"
  fun op COMPACT_IMP_CLOSED _ = ()
  val op COMPACT_IMP_CLOSED = TDB.find "COMPACT_IMP_CLOSED"
  fun op COMPACT_IMP_BOUNDED _ = ()
  val op COMPACT_IMP_BOUNDED = TDB.find "COMPACT_IMP_BOUNDED"
  fun op COMPACT_EQ_BOUNDED_CLOSED _ = ()
  val op COMPACT_EQ_BOUNDED_CLOSED = TDB.find "COMPACT_EQ_BOUNDED_CLOSED"
  fun op COMPACT_EQ_BOLZANO_WEIERSTRASS _ = ()
  val op COMPACT_EQ_BOLZANO_WEIERSTRASS = TDB.find
    "COMPACT_EQ_BOLZANO_WEIERSTRASS"
  fun op COMPACT_EQ_HEINE_BOREL _ = ()
  val op COMPACT_EQ_HEINE_BOREL = TDB.find "COMPACT_EQ_HEINE_BOREL"
  fun op BOLZANO_WEIERSTRASS_IMP_CLOSED _ = ()
  val op BOLZANO_WEIERSTRASS_IMP_CLOSED = TDB.find
    "BOLZANO_WEIERSTRASS_IMP_CLOSED"
  fun op SEQUENCE_UNIQUE_LIMPT _ = ()
  val op SEQUENCE_UNIQUE_LIMPT = TDB.find "SEQUENCE_UNIQUE_LIMPT"
  fun op LIMPT_OF_SEQUENCE_SUBSEQUENCE _ = ()
  val op LIMPT_OF_SEQUENCE_SUBSEQUENCE = TDB.find
    "LIMPT_OF_SEQUENCE_SUBSEQUENCE"
  fun op LE_1 _ = () val op LE_1 = TDB.find "LE_1"
  fun op SEQUENCE_INFINITE_LEMMA _ = ()
  val op SEQUENCE_INFINITE_LEMMA = TDB.find "SEQUENCE_INFINITE_LEMMA"
  fun op REAL_INF_LT_FINITE _ = ()
  val op REAL_INF_LT_FINITE = TDB.find "REAL_INF_LT_FINITE"
  fun op REAL_LT_INF_FINITE _ = ()
  val op REAL_LT_INF_FINITE = TDB.find "REAL_LT_INF_FINITE"
  fun op REAL_INF_LE_FINITE _ = ()
  val op REAL_INF_LE_FINITE = TDB.find "REAL_INF_LE_FINITE"
  fun op REAL_LE_INF_FINITE _ = ()
  val op REAL_LE_INF_FINITE = TDB.find "REAL_LE_INF_FINITE"
  fun op INF_FINITE _ = () val op INF_FINITE = TDB.find "INF_FINITE"
  fun op INF_FINITE_LEMMA _ = ()
  val op INF_FINITE_LEMMA = TDB.find "INF_FINITE_LEMMA"
  fun op BOLZANO_WEIERSTRASS_IMP_BOUNDED _ = ()
  val op BOLZANO_WEIERSTRASS_IMP_BOUNDED = TDB.find
    "BOLZANO_WEIERSTRASS_IMP_BOUNDED"
  fun op HEINE_BOREL_IMP_BOLZANO_WEIERSTRASS _ = ()
  val op HEINE_BOREL_IMP_BOLZANO_WEIERSTRASS = TDB.find
    "HEINE_BOREL_IMP_BOLZANO_WEIERSTRASS"
  fun op COMPACT_IMP_HEINE_BOREL _ = ()
  val op COMPACT_IMP_HEINE_BOREL = TDB.find "COMPACT_IMP_HEINE_BOREL"
  fun op HEINE_BOREL_LEMMA _ = ()
  val op HEINE_BOREL_LEMMA = TDB.find "HEINE_BOREL_LEMMA"
  fun op COMPACT_IMP_TOTALLY_BOUNDED _ = ()
  val op COMPACT_IMP_TOTALLY_BOUNDED = TDB.find
    "COMPACT_IMP_TOTALLY_BOUNDED"
  fun op CONVERGENT_IMP_BOUNDED _ = ()
  val op CONVERGENT_IMP_BOUNDED = TDB.find "CONVERGENT_IMP_BOUNDED"
  fun op CONVERGENT_EQ_CAUCHY _ = ()
  val op CONVERGENT_EQ_CAUCHY = TDB.find "CONVERGENT_EQ_CAUCHY"
  fun op COMPLETE_EQ_CLOSED _ = ()
  val op COMPLETE_EQ_CLOSED = TDB.find "COMPLETE_EQ_CLOSED"
  fun op COMPLETE_UNIV _ = ()
  val op COMPLETE_UNIV = TDB.find "COMPLETE_UNIV"
  fun op COMPACT_IMP_COMPLETE _ = ()
  val op COMPACT_IMP_COMPLETE = TDB.find "COMPACT_IMP_COMPLETE"
  fun op CAUCHY_IMP_BOUNDED _ = ()
  val op CAUCHY_IMP_BOUNDED = TDB.find "CAUCHY_IMP_BOUNDED"
  fun op UPPER_BOUND_FINITE_SET_REAL _ = ()
  val op UPPER_BOUND_FINITE_SET_REAL = TDB.find
    "UPPER_BOUND_FINITE_SET_REAL"
  fun op GREATER_EQ_REFL _ = ()
  val op GREATER_EQ_REFL = TDB.find "GREATER_EQ_REFL"
  fun op CONVERGENT_IMP_CAUCHY _ = ()
  val op CONVERGENT_IMP_CAUCHY = TDB.find "CONVERGENT_IMP_CAUCHY"
  fun op CAUCHY _ = () val op CAUCHY = TDB.find "CAUCHY"
  fun op BOUNDED_CLOSED_IMP_COMPACT _ = ()
  val op BOUNDED_CLOSED_IMP_COMPACT = TDB.find "BOUNDED_CLOSED_IMP_COMPACT"
  fun op COMPACT_LEMMA _ = ()
  val op COMPACT_LEMMA = TDB.find "COMPACT_LEMMA"
  fun op COMPACT_REAL_LEMMA _ = ()
  val op COMPACT_REAL_LEMMA = TDB.find "COMPACT_REAL_LEMMA"
  fun op CONVERGENT_BOUNDED_MONOTONE _ = ()
  val op CONVERGENT_BOUNDED_MONOTONE = TDB.find
    "CONVERGENT_BOUNDED_MONOTONE"
  fun op CONVERGENT_BOUNDED_INCREASING _ = ()
  val op CONVERGENT_BOUNDED_INCREASING = TDB.find
    "CONVERGENT_BOUNDED_INCREASING"
  fun op MONOTONE_SUBSEQUENCE _ = ()
  val op MONOTONE_SUBSEQUENCE = TDB.find "MONOTONE_SUBSEQUENCE"
  fun op LIM_SUBSEQUENCE _ = ()
  val op LIM_SUBSEQUENCE = TDB.find "LIM_SUBSEQUENCE"
  fun op MONOTONE_BIGGER _ = ()
  val op MONOTONE_BIGGER = TDB.find "MONOTONE_BIGGER"
  fun op CLOSED_AS_GDELTA _ = ()
  val op CLOSED_AS_GDELTA = TDB.find "CLOSED_AS_GDELTA"
  fun op LOCALLY_COMPACT _ = ()
  val op LOCALLY_COMPACT = TDB.find "LOCALLY_COMPACT"
  fun op LOCALLY_COMPACT_ALT _ = ()
  val op LOCALLY_COMPACT_ALT = TDB.find "LOCALLY_COMPACT_ALT"
  fun op LOCALLY_COMPACT_INTER_CBALL _ = ()
  val op LOCALLY_COMPACT_INTER_CBALL = TDB.find
    "LOCALLY_COMPACT_INTER_CBALL"
  fun op LOCALLY_COMPACT_INTER_CBALLS _ = ()
  val op LOCALLY_COMPACT_INTER_CBALLS = TDB.find
    "LOCALLY_COMPACT_INTER_CBALLS"
  fun op LOCALLY_COMPACT_COMPACT _ = ()
  val op LOCALLY_COMPACT_COMPACT = TDB.find "LOCALLY_COMPACT_COMPACT"
  fun op LOCALLY_COMPACT_COMPACT_ALT _ = ()
  val op LOCALLY_COMPACT_COMPACT_ALT = TDB.find
    "LOCALLY_COMPACT_COMPACT_ALT"
  fun op LOCALLY_COMPACT_COMPACT_SUBOPEN _ = ()
  val op LOCALLY_COMPACT_COMPACT_SUBOPEN = TDB.find
    "LOCALLY_COMPACT_COMPACT_SUBOPEN"
  fun op OPEN_IMP_LOCALLY_COMPACT _ = ()
  val op OPEN_IMP_LOCALLY_COMPACT = TDB.find "OPEN_IMP_LOCALLY_COMPACT"
  fun op CLOSED_IMP_LOCALLY_COMPACT _ = ()
  val op CLOSED_IMP_LOCALLY_COMPACT = TDB.find "CLOSED_IMP_LOCALLY_COMPACT"
  fun op IS_INTERVAL_IMP_LOCALLY_COMPACT _ = ()
  val op IS_INTERVAL_IMP_LOCALLY_COMPACT = TDB.find
    "IS_INTERVAL_IMP_LOCALLY_COMPACT"
  fun op LOCALLY_COMPACT_UNIV _ = ()
  val op LOCALLY_COMPACT_UNIV = TDB.find "LOCALLY_COMPACT_UNIV"
  fun op LOCALLY_COMPACT_INTER _ = ()
  val op LOCALLY_COMPACT_INTER = TDB.find "LOCALLY_COMPACT_INTER"
  fun op LOCALLY_COMPACT_OPEN_IN _ = ()
  val op LOCALLY_COMPACT_OPEN_IN = TDB.find "LOCALLY_COMPACT_OPEN_IN"
  fun op LOCALLY_COMPACT_CLOSED_IN _ = ()
  val op LOCALLY_COMPACT_CLOSED_IN = TDB.find "LOCALLY_COMPACT_CLOSED_IN"
  fun op LOCALLY_COMPACT_DELETE _ = ()
  val op LOCALLY_COMPACT_DELETE = TDB.find "LOCALLY_COMPACT_DELETE"
  fun op HOMEOMORPHIC_LOCAL_COMPACTNESS _ = ()
  val op HOMEOMORPHIC_LOCAL_COMPACTNESS = TDB.find
    "HOMEOMORPHIC_LOCAL_COMPACTNESS"
  fun op LOCALLY_COMPACT_TRANSLATION_EQ _ = ()
  val op LOCALLY_COMPACT_TRANSLATION_EQ = TDB.find
    "LOCALLY_COMPACT_TRANSLATION_EQ"
  fun op LOCALLY_CLOSED _ = ()
  val op LOCALLY_CLOSED = TDB.find "LOCALLY_CLOSED"
  fun op LOCALLY_COMPACT_OPEN_UNION _ = ()
  val op LOCALLY_COMPACT_OPEN_UNION = TDB.find "LOCALLY_COMPACT_OPEN_UNION"
  fun op LOCALLY_COMPACT_CLOSED_UNION _ = ()
  val op LOCALLY_COMPACT_CLOSED_UNION = TDB.find
    "LOCALLY_COMPACT_CLOSED_UNION"
  fun op OPEN_IN_LOCALLY_COMPACT _ = ()
  val op OPEN_IN_LOCALLY_COMPACT = TDB.find "OPEN_IN_LOCALLY_COMPACT"
  fun op LOCALLY_COMPACT_PROPER_IMAGE_EQ _ = ()
  val op LOCALLY_COMPACT_PROPER_IMAGE_EQ = TDB.find
    "LOCALLY_COMPACT_PROPER_IMAGE_EQ"
  fun op LOCALLY_COMPACT_PROPER_IMAGE _ = ()
  val op LOCALLY_COMPACT_PROPER_IMAGE = TDB.find
    "LOCALLY_COMPACT_PROPER_IMAGE"
  fun op MUMFORD_LEMMA _ = ()
  val op MUMFORD_LEMMA = TDB.find "MUMFORD_LEMMA"
  fun op LOCALLY_COMPACT_OPEN_INTER_CLOSURE _ = ()
  val op LOCALLY_COMPACT_OPEN_INTER_CLOSURE = TDB.find
    "LOCALLY_COMPACT_OPEN_INTER_CLOSURE"
  fun op LOCALLY_COMPACT_CLOSED_IN_OPEN _ = ()
  val op LOCALLY_COMPACT_CLOSED_IN_OPEN = TDB.find
    "LOCALLY_COMPACT_CLOSED_IN_OPEN"
  fun op LOCALLY_COMPACT_CLOSED_INTER_OPEN _ = ()
  val op LOCALLY_COMPACT_CLOSED_INTER_OPEN = TDB.find
    "LOCALLY_COMPACT_CLOSED_INTER_OPEN"
  fun op BAIRE _ = () val op BAIRE = TDB.find "BAIRE"
  fun op BAIRE_ALT _ = () val op BAIRE_ALT = TDB.find "BAIRE_ALT"
  fun op NOWHERE_DENSE_COUNTABLE_BIGUNION_CLOSED _ = ()
  val op NOWHERE_DENSE_COUNTABLE_BIGUNION_CLOSED = TDB.find
    "NOWHERE_DENSE_COUNTABLE_BIGUNION_CLOSED"
  fun op NOWHERE_DENSE_COUNTABLE_BIGUNION _ = ()
  val op NOWHERE_DENSE_COUNTABLE_BIGUNION = TDB.find
    "NOWHERE_DENSE_COUNTABLE_BIGUNION"
  fun op SUBORDINATE_PARTITION_OF_UNITY _ = ()
  val op SUBORDINATE_PARTITION_OF_UNITY = TDB.find
    "SUBORDINATE_PARTITION_OF_UNITY"
  
  local open GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val real_topology_grammars = merge_grammars ["product"]
  local
  val (tyUDs, tmUDs) = GrammarDeltas.thy_deltas{thyname="real_topology"}
  val addtmUDs = term_grammar.add_deltas tmUDs
  val addtyUDs = type_grammar.apply_deltas tyUDs
  in
  val real_topology_grammars = 
    Portable.## (addtyUDs,addtmUDs) real_topology_grammars
  val _ = Parse.grammarDB_insert("real_topology",real_topology_grammars)
  val _ = Parse.temp_set_grammars (addtyUDs (Parse.type_grammar()), addtmUDs (Parse.term_grammar()))
  end (* addUDs local *)
  end
  
val _ = if !Globals.print_thy_loads then TextIO.print "done\n" else ()
val _ = Theory.load_complete "real_topology"

end
